;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from /tmp/pr2_16412.l on (Linux ubuntu-18 4.15.0-29-generic x86_64) at 2019-12-19 10:43:01 UTC
;;
;; /home/user/.ros $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /home/user/pr2eus_ws/src/euscollada/src/euscollada-robot.l
;;
(defun pr2 () (setq *pr2* (instance pr2-robot :init)))

(defclass pr2-robot
  :super euscollada-robot
  :slots ( ;; link names
          base_bellow_link_lk base_footprint_lk base_laser_link_lk base_link_lk bl_caster_l_wheel_link_lk bl_caster_r_wheel_link_lk bl_caster_rotation_link_lk br_caster_l_wheel_link_lk br_caster_r_wheel_link_lk br_caster_rotation_link_lk double_stereo_link_lk fl_caster_l_wheel_link_lk fl_caster_r_wheel_link_lk fl_caster_rotation_link_lk fr_caster_l_wheel_link_lk fr_caster_r_wheel_link_lk fr_caster_rotation_link_lk head_chain_cb_link_lk head_mount_kinect_ir_link_lk head_mount_kinect_ir_optical_frame_lk head_mount_kinect_rgb_link_lk head_mount_kinect_rgb_optical_frame_lk head_mount_link_lk head_mount_prosilica_link_lk head_mount_prosilica_optical_frame_lk head_pan_link_lk head_plate_frame_lk head_tilt_link_lk high_def_frame_lk high_def_optical_frame_lk imu_link_lk l_elbow_flex_link_lk l_forearm_cam_frame_lk l_forearm_cam_optical_frame_lk l_forearm_link_lk l_forearm_roll_link_lk l_gripper_l_finger_link_lk l_gripper_l_finger_tip_frame_lk l_gripper_l_finger_tip_link_lk l_gripper_led_frame_lk l_gripper_motor_accelerometer_link_lk l_gripper_motor_screw_link_lk l_gripper_motor_slider_link_lk l_gripper_palm_link_lk l_gripper_r_finger_link_lk l_gripper_r_finger_tip_link_lk l_gripper_tool_frame_lk l_shoulder_lift_link_lk l_shoulder_pan_link_lk l_torso_lift_side_plate_link_lk l_upper_arm_link_lk l_upper_arm_roll_link_lk l_wrist_flex_link_lk l_wrist_roll_link_lk laser_tilt_link_lk laser_tilt_mount_link_lk left_arm_chain_cb_link_lk narrow_stereo_l_stereo_camera_frame_lk narrow_stereo_l_stereo_camera_optical_frame_lk narrow_stereo_link_lk narrow_stereo_optical_frame_lk narrow_stereo_r_stereo_camera_frame_lk narrow_stereo_r_stereo_camera_optical_frame_lk projector_wg6802418_child_frame_lk projector_wg6802418_frame_lk r_elbow_flex_link_lk r_forearm_cam_frame_lk r_forearm_cam_optical_frame_lk r_forearm_link_lk r_forearm_roll_link_lk r_gripper_l_finger_link_lk r_gripper_l_finger_tip_frame_lk r_gripper_l_finger_tip_link_lk r_gripper_led_frame_lk r_gripper_motor_accelerometer_link_lk r_gripper_motor_screw_link_lk r_gripper_motor_slider_link_lk r_gripper_palm_link_lk r_gripper_r_finger_link_lk r_gripper_r_finger_tip_link_lk r_gripper_tool_frame_lk r_shoulder_lift_link_lk r_shoulder_pan_link_lk r_torso_lift_side_plate_link_lk r_upper_arm_link_lk r_upper_arm_roll_link_lk r_wrist_flex_link_lk r_wrist_roll_link_lk right_arm_chain_cb_link_lk sensor_mount_link_lk torso_lift_link_lk torso_lift_motor_screw_link_lk wide_stereo_l_stereo_camera_frame_lk wide_stereo_l_stereo_camera_optical_frame_lk wide_stereo_link_lk wide_stereo_optical_frame_lk wide_stereo_r_stereo_camera_frame_lk wide_stereo_r_stereo_camera_optical_frame_lk
         ;; joint names
          base_bellow_joint_fixed_jt base_footprint_joint_fixed_jt base_laser_joint_fixed_jt bl_caster_l_wheel_joint_jt bl_caster_r_wheel_joint_jt bl_caster_rotation_joint_jt br_caster_l_wheel_joint_jt br_caster_r_wheel_joint_jt br_caster_rotation_joint_jt double_stereo_frame_joint_fixed_jt fl_caster_l_wheel_joint_jt fl_caster_r_wheel_joint_jt fl_caster_rotation_joint_jt fr_caster_l_wheel_joint_jt fr_caster_r_wheel_joint_jt fr_caster_rotation_joint_jt head_chain_cb_fixed_jt head_mount_joint_fixed_jt head_mount_kinect_ir_joint_fixed_jt head_mount_kinect_ir_optical_frame_joint_fixed_jt head_mount_kinect_rgb_joint_fixed_jt head_mount_kinect_rgb_optical_frame_joint_fixed_jt head_mount_prosilica_joint_fixed_jt head_mount_prosilica_optical_frame_joint_fixed_jt head_pan_joint_jt head_plate_frame_joint_fixed_jt head_tilt_joint_jt high_def_frame_joint_fixed_jt high_def_optical_frame_joint_fixed_jt imu_joint_fixed_jt l_elbow_flex_joint_jt l_forearm_cam_frame_joint_fixed_jt l_forearm_cam_optical_frame_joint_fixed_jt l_forearm_joint_fixed_jt l_forearm_roll_joint_jt l_gripper_joint_jt l_gripper_l_finger_joint_jt l_gripper_l_finger_tip_joint_jt l_gripper_led_joint_fixed_jt l_gripper_motor_accelerometer_joint_fixed_jt l_gripper_motor_screw_joint_jt l_gripper_motor_slider_joint_jt l_gripper_palm_joint_fixed_jt l_gripper_r_finger_joint_jt l_gripper_r_finger_tip_joint_jt l_gripper_tool_joint_fixed_jt l_shoulder_lift_joint_jt l_shoulder_pan_joint_jt l_torso_lift_side_plate_joint_fixed_jt l_upper_arm_joint_fixed_jt l_upper_arm_roll_joint_jt l_wrist_flex_joint_jt l_wrist_roll_joint_jt laser_tilt_joint_fixed_jt laser_tilt_mount_joint_jt left_arm_chain_cb_fixed_jt narrow_stereo_frame_joint_fixed_jt narrow_stereo_l_stereo_camera_frame_joint_fixed_jt narrow_stereo_l_stereo_camera_optical_frame_joint_fixed_jt narrow_stereo_optical_frame_joint_fixed_jt narrow_stereo_r_stereo_camera_frame_joint_fixed_jt narrow_stereo_r_stereo_camera_optical_frame_joint_fixed_jt projector_wg6802418_child_frame_joint_fixed_jt projector_wg6802418_frame_joint_fixed_jt r_elbow_flex_joint_jt r_forearm_cam_frame_joint_fixed_jt r_forearm_cam_optical_frame_joint_fixed_jt r_forearm_joint_fixed_jt r_forearm_roll_joint_jt r_gripper_joint_jt r_gripper_l_finger_joint_jt r_gripper_l_finger_tip_joint_jt r_gripper_led_joint_fixed_jt r_gripper_motor_accelerometer_joint_fixed_jt r_gripper_motor_screw_joint_jt r_gripper_motor_slider_joint_jt r_gripper_palm_joint_fixed_jt r_gripper_r_finger_joint_jt r_gripper_r_finger_tip_joint_jt r_gripper_tool_joint_fixed_jt r_shoulder_lift_joint_jt r_shoulder_pan_joint_jt r_torso_lift_side_plate_joint_fixed_jt r_upper_arm_joint_fixed_jt r_upper_arm_roll_joint_jt r_wrist_flex_joint_jt r_wrist_roll_joint_jt right_arm_chain_cb_fixed_jt sensor_mount_frame_joint_fixed_jt torso_lift_joint_jt torso_lift_motor_screw_joint_jt wide_stereo_frame_joint_fixed_jt wide_stereo_l_stereo_camera_frame_joint_fixed_jt wide_stereo_l_stereo_camera_optical_frame_joint_fixed_jt wide_stereo_optical_frame_joint_fixed_jt wide_stereo_r_stereo_camera_frame_joint_fixed_jt wide_stereo_r_stereo_camera_optical_frame_joint_fixed_jt
         ;; sensor names
         
         )
  )
(defmethod pr2-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "pr2" args)

     ;; link: base_bellow_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_base_bellow_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq base_bellow_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "base_bellow_link"))
       ;; inertial parameter for base_bellow_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send base_bellow_link_lk :weight 1000.000)
         (setq (base_bellow_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (base_bellow_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for base_bellow_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.9000000000000000e+02 0.0000000000000000e+00 8.5100000000000011e+02))
                        ))
         (send base_bellow_link_lk :transform world-cds))
       )

     ;; link: base_footprint_lk
     (let ((geom-lst (list
                       (send self :_make_instance_base_footprint_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq base_footprint_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "base_footprint"))
       ;; inertial parameter for base_footprint_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send base_footprint_lk :weight 1000.000)
         (setq (base_footprint_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (base_footprint_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for base_footprint_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send base_footprint_lk :transform world-cds))
       )

     ;; link: base_laser_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq base_laser_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "base_laser_link"))
       ;; inertial parameter for base_laser_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send base_laser_link_lk :weight 1.000)
         (setq (base_laser_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+03 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (base_laser_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for base_laser_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.7500000000000000e+02 0.0000000000000000e+00 3.0300000000000000e+02))
                        ))
         (send base_laser_link_lk :transform world-cds))
       )

     ;; link: base_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_base_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq base_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "base_link"))
       ;; inertial parameter for base_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -6.1000000000000000e+01 0.0000000000000000e+00 1.4650000000000003e+02)
                                   :rot (quaternion2matrix (float-vector 6.8719103493307054e-01 -6.8968508724111810e-01 1.6794397935461167e-01 -1.5458907381624593e-01)))
                      ))
         (send base_link_lk :weight 116000.000)
         (setq (base_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 6.2938848215018797e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.0417723116333189e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.6692450764548006e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (base_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for base_link_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.1000000000000000e+01))
                        ))
         (send base_link_lk :transform world-cds))
       )

     ;; link: bl_caster_l_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_bl_caster_l_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq bl_caster_l_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "bl_caster_l_wheel_link"))
       ;; inertial parameter for bl_caster_l_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send bl_caster_l_wheel_link_lk :weight 440.360)
         (setq (bl_caster_l_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (bl_caster_l_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for bl_caster_l_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 2.7360000000000002e+02 7.9199999999999989e+01))
                        ))
         (send bl_caster_l_wheel_link_lk :transform world-cds))
       )

     ;; link: bl_caster_r_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_bl_caster_r_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq bl_caster_r_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "bl_caster_r_wheel_link"))
       ;; inertial parameter for bl_caster_r_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.7755575615628914e-14 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send bl_caster_r_wheel_link_lk :weight 440.360)
         (setq (bl_caster_r_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (bl_caster_r_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for bl_caster_r_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 1.7559999999999997e+02 7.9199999999999989e+01))
                        ))
         (send bl_caster_r_wheel_link_lk :transform world-cds))
       )

     ;; link: bl_caster_rotation_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_bl_caster_rotation_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq bl_caster_rotation_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "bl_caster_rotation_link"))
       ;; inertial parameter for bl_caster_rotation_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.0000000000000000e+01)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send bl_caster_rotation_link_lk :weight 3473.082)
         (setq (bl_caster_rotation_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (bl_caster_rotation_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for bl_caster_rotation_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 2.2459999999999999e+02 7.9199999999999989e+01))
                        ))
         (send bl_caster_rotation_link_lk :transform world-cds))
       )

     ;; link: br_caster_l_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_br_caster_l_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq br_caster_l_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "br_caster_l_wheel_link"))
       ;; inertial parameter for br_caster_l_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.7755575615628914e-14 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send br_caster_l_wheel_link_lk :weight 440.360)
         (setq (br_caster_l_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (br_caster_l_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for br_caster_l_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 -1.7559999999999997e+02 7.9199999999999989e+01))
                        ))
         (send br_caster_l_wheel_link_lk :transform world-cds))
       )

     ;; link: br_caster_r_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_br_caster_r_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq br_caster_r_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "br_caster_r_wheel_link"))
       ;; inertial parameter for br_caster_r_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send br_caster_r_wheel_link_lk :weight 440.360)
         (setq (br_caster_r_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (br_caster_r_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for br_caster_r_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 -2.7360000000000002e+02 7.9199999999999989e+01))
                        ))
         (send br_caster_r_wheel_link_lk :transform world-cds))
       )

     ;; link: br_caster_rotation_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_br_caster_rotation_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq br_caster_rotation_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "br_caster_rotation_link"))
       ;; inertial parameter for br_caster_rotation_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.0000000000000000e+01)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send br_caster_rotation_link_lk :weight 3473.082)
         (setq (br_caster_rotation_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (br_caster_rotation_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for br_caster_rotation_link_lk
       (let ((world-cds (make-coords :pos (float-vector -2.2459999999999999e+02 -2.2459999999999999e+02 7.9199999999999989e+01))
                        ))
         (send br_caster_rotation_link_lk :transform world-cds))
       )

     ;; link: double_stereo_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_double_stereo_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq double_stereo_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "double_stereo_link"))
       ;; inertial parameter for double_stereo_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send double_stereo_link_lk :weight 100.000)
         (setq (double_stereo_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (double_stereo_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for double_stereo_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.4129999999999999e+01 0.0000000000000000e+00 1.2366250000000000e+03))
                        ))
         (send double_stereo_link_lk :transform world-cds))
       )

     ;; link: fl_caster_l_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fl_caster_l_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fl_caster_l_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fl_caster_l_wheel_link"))
       ;; inertial parameter for fl_caster_l_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fl_caster_l_wheel_link_lk :weight 440.360)
         (setq (fl_caster_l_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fl_caster_l_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fl_caster_l_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 2.7360000000000002e+02 7.9199999999999989e+01))
                        ))
         (send fl_caster_l_wheel_link_lk :transform world-cds))
       )

     ;; link: fl_caster_r_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fl_caster_r_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fl_caster_r_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fl_caster_r_wheel_link"))
       ;; inertial parameter for fl_caster_r_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.7755575615628914e-14 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fl_caster_r_wheel_link_lk :weight 440.360)
         (setq (fl_caster_r_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fl_caster_r_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fl_caster_r_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 1.7559999999999997e+02 7.9199999999999989e+01))
                        ))
         (send fl_caster_r_wheel_link_lk :transform world-cds))
       )

     ;; link: fl_caster_rotation_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fl_caster_rotation_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fl_caster_rotation_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fl_caster_rotation_link"))
       ;; inertial parameter for fl_caster_rotation_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.0000000000000000e+01)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fl_caster_rotation_link_lk :weight 3473.082)
         (setq (fl_caster_rotation_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fl_caster_rotation_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fl_caster_rotation_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 2.2459999999999999e+02 7.9199999999999989e+01))
                        ))
         (send fl_caster_rotation_link_lk :transform world-cds))
       )

     ;; link: fr_caster_l_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fr_caster_l_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fr_caster_l_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fr_caster_l_wheel_link"))
       ;; inertial parameter for fr_caster_l_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.7755575615628914e-14 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fr_caster_l_wheel_link_lk :weight 440.360)
         (setq (fr_caster_l_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fr_caster_l_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fr_caster_l_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 -1.7559999999999997e+02 7.9199999999999989e+01))
                        ))
         (send fr_caster_l_wheel_link_lk :transform world-cds))
       )

     ;; link: fr_caster_r_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fr_caster_r_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fr_caster_r_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fr_caster_r_wheel_link"))
       ;; inertial parameter for fr_caster_r_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fr_caster_r_wheel_link_lk :weight 440.360)
         (setq (fr_caster_r_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fr_caster_r_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fr_caster_r_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 -2.7360000000000002e+02 7.9199999999999989e+01))
                        ))
         (send fr_caster_r_wheel_link_lk :transform world-cds))
       )

     ;; link: fr_caster_rotation_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_fr_caster_rotation_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq fr_caster_rotation_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "fr_caster_rotation_link"))
       ;; inertial parameter for fr_caster_rotation_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.0000000000000000e+01)
                                   :rot (quaternion2matrix (float-vector 6.8630934663031751e-01 6.6285921044798191e-01 2.7864936668790563e-01 1.0932373162572707e-01)))
                      ))
         (send fr_caster_rotation_link_lk :weight 3473.082)
         (setq (fr_caster_rotation_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2544593986297460e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1456840427869651e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5392469553832879e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (fr_caster_rotation_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for fr_caster_rotation_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.2459999999999999e+02 -2.2459999999999999e+02 7.9199999999999989e+01))
                        ))
         (send fr_caster_rotation_link_lk :transform world-cds))
       )

     ;; link: head_chain_cb_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_chain_cb_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_chain_cb_link"))
       (progn (send head_chain_cb_link_lk :weight 0.0) (setq (head_chain_cb_link_lk . acentroid) (float-vector 0 0 0)) (send head_chain_cb_link_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_chain_cb_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3000000000000027e-01 0.0000000000000000e+00 1.1721250000000000e+03))
                        ))
         (send head_chain_cb_link_lk :transform world-cds))
       )

     ;; link: head_mount_kinect_ir_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_mount_kinect_ir_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_kinect_ir_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_kinect_ir_link"))
       ;; inertial parameter for head_mount_kinect_ir_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.7755575615628914e-14 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send head_mount_kinect_ir_link_lk :weight 100.000)
         (setq (head_mount_kinect_ir_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_mount_kinect_ir_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_mount_kinect_ir_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.4613700000000003e+02 1.2500000000000000e+01 1.4640780000000000e+03))
                        ))
         (send head_mount_kinect_ir_link_lk :transform world-cds))
       )

     ;; link: head_mount_kinect_ir_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_kinect_ir_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_kinect_ir_optical_frame"))
       (progn (send head_mount_kinect_ir_optical_frame_lk :weight 0.0) (setq (head_mount_kinect_ir_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send head_mount_kinect_ir_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_mount_kinect_ir_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector -1.4613700000000003e+02 2.2500000000000000e+01 1.4640780000000000e+03)
                                   :rot (quaternion2matrix (float-vector 5.0000000000244815e-01 -5.0000000000000011e-01 4.9999999999755174e-01 -5.0000000000000011e-01)))
                        ))
         (send head_mount_kinect_ir_optical_frame_lk :transform world-cds))
       )

     ;; link: head_mount_kinect_rgb_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_mount_kinect_rgb_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_kinect_rgb_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_kinect_rgb_link"))
       ;; inertial parameter for head_mount_kinect_rgb_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send head_mount_kinect_rgb_link_lk :weight 100.000)
         (setq (head_mount_kinect_rgb_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_mount_kinect_rgb_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_mount_kinect_rgb_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.6450399138460000e+02 -8.7223001369000013e+00 1.4421910357032000e+03)
                                   :rot (quaternion2matrix (float-vector 9.9967297120778287e-01 -5.6000060945167749e-03 -2.4366744094289648e-02 -5.3714384096068416e-03)))
                        ))
         (send head_mount_kinect_rgb_link_lk :transform world-cds))
       )

     ;; link: head_mount_kinect_rgb_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_kinect_rgb_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_kinect_rgb_optical_frame"))
       (progn (send head_mount_kinect_rgb_optical_frame_lk :weight 0.0) (setq (head_mount_kinect_rgb_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send head_mount_kinect_rgb_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_mount_kinect_rgb_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector -1.6450399138460000e+02 -8.7223001369000013e+00 1.4421910357032000e+03)
                                   :rot (quaternion2matrix (float-vector 5.0653413540136216e-01 -4.8776739739922853e-01 4.8753882971178447e-01 -5.1750557990309753e-01)))
                        ))
         (send head_mount_kinect_rgb_optical_frame_lk :transform world-cds))
       )

     ;; link: head_mount_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_mount_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_link"))
       ;; inertial parameter for head_mount_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.3877787807814457e-14 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send head_mount_link_lk :weight 100.000)
         (setq (head_mount_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_mount_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_mount_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.1387000000000002e+02 0.0000000000000000e+00 1.3276250000000000e+03))
                        ))
         (send head_mount_link_lk :transform world-cds))
       )

     ;; link: head_mount_prosilica_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_mount_prosilica_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_prosilica_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_prosilica_link"))
       ;; inertial parameter for head_mount_prosilica_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send head_mount_prosilica_link_lk :weight 100.000)
         (setq (head_mount_prosilica_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_mount_prosilica_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_mount_prosilica_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.6032700000000000e+02 1.2500000000000000e+01 1.4165460000000000e+03))
                        ))
         (send head_mount_prosilica_link_lk :transform world-cds))
       )

     ;; link: head_mount_prosilica_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_mount_prosilica_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_mount_prosilica_optical_frame"))
       (progn (send head_mount_prosilica_optical_frame_lk :weight 0.0) (setq (head_mount_prosilica_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send head_mount_prosilica_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_mount_prosilica_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector -1.6032700000000000e+02 1.2500000000000000e+01 1.4165460000000000e+03)
                                   :rot (quaternion2matrix (float-vector 5.0000000000244815e-01 -5.0000000000000011e-01 4.9999999999755174e-01 -5.0000000000000011e-01)))
                        ))
         (send head_mount_prosilica_optical_frame_lk :transform world-cds))
       )

     ;; link: head_pan_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_pan_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_pan_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_pan_link"))
       ;; inertial parameter for head_pan_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.0907000000000007e+01 3.1692999999999998e+01 9.0506999999999891e+01)
                                   :rot (quaternion2matrix (float-vector 9.9332080286057656e-01 -9.7402366566314874e-02 -5.0156631550354866e-02 3.6205992642419915e-02)))
                      ))
         (send head_pan_link_lk :weight 6339.000)
         (setq (head_pan_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.2179798694053225e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 4.6122618877570637e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.8393525428376131e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_pan_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_pan_link_lk
       (let ((world-cds (make-coords :pos (float-vector -6.7070000000000007e+01 0.0000000000000000e+00 1.1721250000000000e+03))
                        ))
         (send head_pan_link_lk :transform world-cds))
       )

     ;; link: head_plate_frame_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_plate_frame_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_plate_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_plate_frame"))
       ;; inertial parameter for head_plate_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send head_plate_frame_lk :weight 10.000)
         (setq (head_plate_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_plate_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_plate_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 2.4129999999999999e+01 0.0000000000000000e+00 1.2366250000000000e+03))
                        ))
         (send head_plate_frame_lk :transform world-cds))
       )

     ;; link: head_tilt_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_tilt_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_tilt_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_tilt_link"))
       ;; inertial parameter for head_tilt_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.7159999999999997e+00 -1.9556000000000001e+01 5.5001999999999995e+01)
                                   :rot (quaternion2matrix (float-vector 9.9447945946553229e-01 1.0440601476237568e-01 7.0609131813543287e-04 1.0463757338150654e-02)))
                      ))
         (send head_tilt_link_lk :weight 4479.000)
         (setq (head_tilt_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.4210046119098920e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.4142523398749784e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 6.7900115482151285e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_tilt_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_tilt_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3000000000000027e-01 0.0000000000000000e+00 1.1721250000000000e+03))
                        ))
         (send head_tilt_link_lk :transform world-cds))
       )

     ;; link: high_def_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq high_def_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "high_def_frame"))
       ;; inertial parameter for high_def_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.2204460492503131e-13))
                      ))
         (send high_def_frame_lk :weight 10.000)
         (setq (high_def_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (high_def_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for high_def_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 4.7640579288500000e+01 -1.0750883907600000e+02 1.2866355484246001e+03)
                                   :rot (quaternion2matrix (float-vector 9.9997012409009334e-01 2.0284391083384063e-03 -7.4480164138416224e-03 4.0424438923839174e-04)))
                        ))
         (send high_def_frame_lk :transform world-cds))
       )

     ;; link: high_def_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq high_def_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "high_def_optical_frame"))
       ;; inertial parameter for high_def_optical_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.2204460492503131e-13 -1.3877787807814457e-14)
                                   :rot (quaternion2matrix (float-vector 1.0000000000000000e+00 -2.7755575615628918e-16 3.8857805861880489e-16 -2.7755575615628918e-16)))
                      ))
         (send high_def_optical_frame_lk :weight 10.000)
         (setq (high_def_optical_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (high_def_optical_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for high_def_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 4.7640579288500000e+01 -1.0750883907600000e+02 1.2866355484246001e+03)
                                   :rot (quaternion2matrix (float-vector 5.0492541200318575e-01 -4.9544895647856996e-01 4.9707315119520945e-01 -5.0249272850318305e-01)))
                        ))
         (send high_def_optical_frame_lk :transform world-cds))
       )

     ;; link: imu_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq imu_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "imu_link"))
       ;; inertial parameter for imu_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send imu_link_lk :weight 1.000)
         (setq (imu_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+03 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (imu_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for imu_link_lk
       (let ((world-cds (make-coords :pos (float-vector -7.9770000000000010e+01 -1.4969999999999999e+02 9.5467500000000007e+02)
                                   :rot (quaternion2matrix (float-vector -1.0286788442024686e-13 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)))
                        ))
         (send imu_link_lk :transform world-cds))
       )

     ;; link: l_elbow_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_elbow_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_elbow_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_elbow_flex_link"))
       ;; inertial parameter for l_elbow_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.0139999999999983e+01 3.1999999999998696e-01 -1.2109999999999953e+01)
                                   :rot (quaternion2matrix (float-vector 6.7023857211269999e-01 -6.5469615865643171e-01 -2.3355256344108982e-01 2.6001230048391416e-01)))
                      ))
         (send l_elbow_flex_link_lk :weight 1903.270)
         (setq (l_elbow_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.0897687844015122e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.9647676565655996e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.4185162390328888e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_elbow_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_elbow_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_elbow_flex_link_lk :transform world-cds))
       )

     ;; link: l_forearm_cam_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_forearm_cam_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_forearm_cam_frame"))
       ;; inertial parameter for l_forearm_cam_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_forearm_cam_frame_lk :weight 10.000)
         (setq (l_forearm_cam_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_forearm_cam_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_forearm_cam_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.8888260177999996e+02 2.0468654474639999e+02 8.3695536614599996e+02)
                                   :rot (quaternion2matrix (float-vector 7.0376576488431553e-01 -6.6021535308457147e-01 -1.7154001878113354e-01 -1.9850304200383823e-01)))
                        ))
         (send l_forearm_cam_frame_lk :transform world-cds))
       )

     ;; link: l_forearm_cam_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_forearm_cam_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_forearm_cam_optical_frame"))
       (progn (send l_forearm_cam_optical_frame_lk :weight 0.0) (setq (l_forearm_cam_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send l_forearm_cam_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for l_forearm_cam_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.8888260177999996e+02 2.0468654474639999e+02 8.3695536614599996e+02)
                                   :rot (quaternion2matrix (float-vector 8.2936942898225313e-03 -4.9696902859405995e-01 3.5256717509081381e-02 -8.6701208937579910e-01)))
                        ))
         (send l_forearm_cam_optical_frame_lk :transform world-cds))
       )

     ;; link: l_forearm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_forearm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_forearm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_forearm_link"))
       ;; inertial parameter for l_forearm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.8790999999999997e+02 -1.7000000000000348e-01 -9.1200000000000170e+00)
                                   :rot (quaternion2matrix (float-vector 7.0455582233769354e-01 -7.0911110961966251e-01 -1.7761550919348956e-02 2.1143668862499916e-02)))
                      ))
         (send l_forearm_link_lk :weight 2579.680)
         (setq (l_forearm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6089171216999060e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.6632586642306658e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5077544915993441e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_forearm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_forearm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_forearm_link_lk :transform world-cds))
       )

     ;; link: l_forearm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_forearm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_forearm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_forearm_roll_link"))
       ;; inertial parameter for l_forearm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_forearm_roll_link_lk :weight 100.000)
         (setq (l_forearm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_forearm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_forearm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_forearm_roll_link_lk :transform world-cds))
       )

     ;; link: l_gripper_l_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_l_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_l_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_l_finger_link"))
       ;; inertial parameter for l_gripper_l_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 3.5979999999999905e+01 1.7299999999999983e+01 -1.6399999999999748e+00)
                                   :rot (quaternion2matrix (float-vector 6.3262934235930901e-01 7.7302450075385043e-01 2.5774405529421746e-02 3.9356275737085514e-02)))
                      ))
         (send l_gripper_l_finger_link_lk :weight 171.260)
         (setq (l_gripper_l_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.6623944609730548e+04 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8133591439139261e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9773963099887679e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_l_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_l_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 8.4791000000000008e+02 1.9800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_l_finger_link_lk :transform world-cds))
       )

     ;; link: l_gripper_l_finger_tip_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_l_finger_tip_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_l_finger_tip_frame"))
       (progn (send l_gripper_l_finger_tip_frame_lk :weight 0.0) (setq (l_gripper_l_finger_tip_frame_lk . acentroid) (float-vector 0 0 0)) (send l_gripper_l_finger_tip_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for l_gripper_l_finger_tip_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 1.7304999999999998e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_l_finger_tip_frame_lk :transform world-cds))
       )

     ;; link: l_gripper_l_finger_tip_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_l_finger_tip_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_l_finger_tip_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_l_finger_tip_link"))
       ;; inertial parameter for l_gripper_l_finger_tip_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 4.2299999999998450e+00 2.8399999999999812e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 9.3563462459842295e-01 0.0000000000000000e+00 0.0000000000000000e+00 3.5297004016285605e-01)))
                      ))
         (send l_gripper_l_finger_tip_link_lk :weight 44.190)
         (setq (l_gripper_l_finger_tip_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.2362449620368520e+03 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.5004895037963150e+04 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5417679999999997e+04))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_l_finger_tip_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_l_finger_tip_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 2.0295000000000002e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_l_finger_tip_link_lk :transform world-cds))
       )

     ;; link: l_gripper_led_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_led_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_led_frame"))
       (progn (send l_gripper_led_frame_lk :weight 0.0) (setq (l_gripper_led_frame_lk . acentroid) (float-vector 0 0 0)) (send l_gripper_led_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for l_gripper_led_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 8.2230000000000007e+02 1.8800000000000000e+02 8.1507500000000005e+02))
                        ))
         (send l_gripper_led_frame_lk :transform world-cds))
       )

     ;; link: l_gripper_motor_accelerometer_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_motor_accelerometer_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_motor_accelerometer_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_motor_accelerometer_link"))
       ;; inertial parameter for l_gripper_motor_accelerometer_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_gripper_motor_accelerometer_link_lk :weight 1.000)
         (setq (l_gripper_motor_accelerometer_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_motor_accelerometer_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_motor_accelerometer_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_motor_accelerometer_link_lk :transform world-cds))
       )

     ;; link: l_gripper_motor_screw_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_motor_screw_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_motor_screw_link"))
       ;; inertial parameter for l_gripper_motor_screw_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_gripper_motor_screw_link_lk :weight 10.000)
         (setq (l_gripper_motor_screw_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_motor_screw_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_motor_screw_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3927999999999997e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_motor_screw_link_lk :transform world-cds))
       )

     ;; link: l_gripper_motor_slider_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_motor_slider_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_motor_slider_link"))
       ;; inertial parameter for l_gripper_motor_slider_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_gripper_motor_slider_link_lk :weight 10.000)
         (setq (l_gripper_motor_slider_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_motor_slider_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_motor_slider_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3927999999999997e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_motor_slider_link_lk :transform world-cds))
       )

     ;; link: l_gripper_palm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_palm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_palm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_palm_link"))
       ;; inertial parameter for l_gripper_palm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 6.6230000000000018e+01 5.3000000000000269e-01 -1.1900000000000244e+00)
                                   :rot (quaternion2matrix (float-vector 1.4899072945442145e-03 9.9970499746458896e-01 2.4226387096224839e-02 8.8339619865787514e-04)))
                      ))
         (send l_gripper_palm_link_lk :weight 580.070)
         (setq (l_gripper_palm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.5147110342667863e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 6.7817787266766967e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.6563651390565163e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_palm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_palm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_palm_link_lk :transform world-cds))
       )

     ;; link: l_gripper_r_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_r_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_r_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_r_finger_link"))
       ;; inertial parameter for l_gripper_r_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 3.5759999999999906e+01 -1.7359999999999985e+01 -9.5000000000000639e-01)
                                   :rot (quaternion2matrix (float-vector 7.5776139467964265e-01 6.5127216354607009e-01 3.5226594320275487e-02 2.0033092017423846e-02)))
                      ))
         (send l_gripper_r_finger_link_lk :weight 173.890)
         (setq (l_gripper_r_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.6684670622283287e+04 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8134000171817749e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9890313765953921e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_r_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_r_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 8.4791000000000008e+02 1.7800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_r_finger_link_lk :transform world-cds))
       )

     ;; link: l_gripper_r_finger_tip_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_r_finger_tip_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_r_finger_tip_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_r_finger_tip_link"))
       ;; inertial parameter for l_gripper_r_finger_tip_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 4.2299999999998450e+00 -2.8399999999999812e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 9.3563462459842295e-01 0.0000000000000000e+00 0.0000000000000000e+00 -3.5297004016285605e-01)))
                      ))
         (send l_gripper_r_finger_tip_link_lk :weight 44.190)
         (setq (l_gripper_r_finger_tip_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.2362449620368520e+03 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.5004895037963150e+04 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5417679999999997e+04))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_r_finger_tip_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_r_finger_tip_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 1.7304999999999998e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_r_finger_tip_link_lk :transform world-cds))
       )

     ;; link: l_gripper_tool_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_tool_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_tool_frame"))
       (progn (send l_gripper_tool_frame_lk :weight 0.0) (setq (l_gripper_tool_frame_lk . acentroid) (float-vector 0 0 0)) (send l_gripper_tool_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for l_gripper_tool_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 9.5100000000000011e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_gripper_tool_frame_lk :transform world-cds))
       )

     ;; link: l_shoulder_lift_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_shoulder_lift_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_shoulder_lift_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_shoulder_lift_link"))
       ;; inertial parameter for l_shoulder_lift_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.1949999999999996e+01 -2.6639999999999997e+01 -3.1270000000000021e+01)
                                   :rot (quaternion2matrix (float-vector 2.9576183828508645e-01 2.3898442472179413e-01 -4.7801368988356990e-01 7.9177919399193220e-01)))
                      ))
         (send l_shoulder_lift_link_lk :weight 2749.880)
         (setq (l_shoulder_lift_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.6187368693981063e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.0730163313329030e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5168089652689919e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_shoulder_lift_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_shoulder_lift_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_shoulder_lift_link_lk :transform world-cds))
       )

     ;; link: l_shoulder_pan_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_shoulder_pan_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_shoulder_pan_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_shoulder_pan_link"))
       ;; inertial parameter for l_shoulder_pan_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.2010000000000007e+00 2.4513000000000005e+01 -9.8230999999999952e+01)
                                   :rot (quaternion2matrix (float-vector 9.2748205313791365e-01 8.7656121686357058e-02 -7.4059439643071295e-02 3.5582108543162694e-01)))
                      ))
         (send l_shoulder_pan_link_lk :weight 25799.322)
         (setq (l_shoulder_pan_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 9.3420134354104972e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.3770052521175265e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.4203263939719772e+08))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_shoulder_pan_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_shoulder_pan_link_lk
       (let ((world-cds (make-coords :pos (float-vector -5.0000000000000000e+01 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_shoulder_pan_link_lk :transform world-cds))
       )

     ;; link: l_torso_lift_side_plate_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_torso_lift_side_plate_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_torso_lift_side_plate_link"))
       ;; inertial parameter for l_torso_lift_side_plate_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -6.2499999999999993e+01 0.0000000000000000e+00 5.0000000000000043e+01))
                      ))
         (send l_torso_lift_side_plate_link_lk :weight 100.000)
         (setq (l_torso_lift_side_plate_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_torso_lift_side_plate_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_torso_lift_side_plate_link_lk
       (let ((world-cds (make-coords :pos (float-vector 3.4999999999999960e+00 2.0928500000000000e+02 9.6730000000000007e+02))
                        ))
         (send l_torso_lift_side_plate_link_lk :transform world-cds))
       )

     ;; link: l_upper_arm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_upper_arm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_upper_arm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_upper_arm_link"))
       ;; inertial parameter for l_upper_arm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.1405000000000001e+02 1.6580000000000013e+01 -5.6999999999995943e-01)
                                   :rot (quaternion2matrix (float-vector 1.0079044589567206e-01 9.9449021067012888e-01 2.7763076482626922e-02 -7.7277733956259828e-03)))
                      ))
         (send l_upper_arm_link_lk :weight 6017.690)
         (setq (l_upper_arm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.5107107160877610e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 7.4882121073444754e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.6069696785677612e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_upper_arm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_upper_arm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_upper_arm_link_lk :transform world-cds))
       )

     ;; link: l_upper_arm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_upper_arm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_upper_arm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_upper_arm_roll_link"))
       ;; inertial parameter for l_upper_arm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_upper_arm_roll_link_lk :weight 100.000)
         (setq (l_upper_arm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_upper_arm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_upper_arm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_upper_arm_roll_link_lk :transform world-cds))
       )

     ;; link: l_wrist_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_wrist_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_wrist_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_wrist_flex_link"))
       ;; inertial parameter for l_wrist_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.5699999999999603e+00 0.0000000000000000e+00 -7.5000000000002842e-01)
                                   :rot (quaternion2matrix (float-vector 6.9597592710835521e-01 -6.9641143568018082e-01 1.2355973330960543e-01 -1.2394197611783576e-01)))
                      ))
         (send l_wrist_flex_link_lk :weight 614.020)
         (setq (l_wrist_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 6.5277143381554517e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 6.4339106681473507e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9824412936971989e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_wrist_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_wrist_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_wrist_flex_link_lk :transform world-cds))
       )

     ;; link: l_wrist_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_wrist_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_wrist_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_wrist_roll_link"))
       ;; inertial parameter for l_wrist_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_wrist_roll_link_lk :weight 100.000)
         (setq (l_wrist_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_wrist_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_wrist_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send l_wrist_roll_link_lk :transform world-cds))
       )

     ;; link: laser_tilt_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq laser_tilt_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "laser_tilt_link"))
       ;; inertial parameter for laser_tilt_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.2204460492503131e-13))
                      ))
         (send laser_tilt_link_lk :weight 1.000)
         (setq (laser_tilt_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+03 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (laser_tilt_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for laser_tilt_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.8930000000000000e+01 0.0000000000000000e+00 1.0468768892415001e+03)
                                   :rot (quaternion2matrix (float-vector 9.9998671474247458e-01 0.0000000000000000e+00 0.0000000000000000e+00 -5.1546424272613288e-03)))
                        ))
         (send laser_tilt_link_lk :transform world-cds))
       )

     ;; link: laser_tilt_mount_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_laser_tilt_mount_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq laser_tilt_mount_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "laser_tilt_mount_link"))
       ;; inertial parameter for laser_tilt_mount_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.1359999999999981e+00 1.6700000000000002e+00 -7.1300000000000807e+00)
                                   :rot (quaternion2matrix (float-vector 9.9128618671773705e-01 -5.0096581162311353e-02 4.8442481946443447e-02 -1.1178262173220145e-01)))
                      ))
         (send laser_tilt_mount_link_lk :weight 591.000)
         (setq (laser_tilt_mount_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2045714172574708e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0817501043531031e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.8792147838942648e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (laser_tilt_mount_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for laser_tilt_mount_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.8930000000000000e+01 0.0000000000000000e+00 1.0176750000000001e+03))
                        ))
         (send laser_tilt_mount_link_lk :transform world-cds))
       )

     ;; link: left_arm_chain_cb_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq left_arm_chain_cb_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "left_arm_chain_cb_link"))
       (progn (send left_arm_chain_cb_link_lk :weight 0.0) (setq (left_arm_chain_cb_link_lk . acentroid) (float-vector 0 0 0)) (send left_arm_chain_cb_link_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for left_arm_chain_cb_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send left_arm_chain_cb_link_lk :transform world-cds))
       )

     ;; link: narrow_stereo_l_stereo_camera_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_l_stereo_camera_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_l_stereo_camera_frame"))
       ;; inertial parameter for narrow_stereo_l_stereo_camera_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send narrow_stereo_l_stereo_camera_frame_lk :weight 10.000)
         (setq (narrow_stereo_l_stereo_camera_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (narrow_stereo_l_stereo_camera_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for narrow_stereo_l_stereo_camera_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.7820754083899999e+01 6.0632256042200005e+01 1.2807375486935000e+03)
                                   :rot (quaternion2matrix (float-vector 9.9995864257776801e-01 -5.0348889792875724e-03 -5.5210231623546158e-03 -5.1847208444301598e-03)))
                        ))
         (send narrow_stereo_l_stereo_camera_frame_lk :transform world-cds))
       )

     ;; link: narrow_stereo_l_stereo_camera_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_l_stereo_camera_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_l_stereo_camera_optical_frame"))
       (progn (send narrow_stereo_l_stereo_camera_optical_frame_lk :weight 0.0) (setq (narrow_stereo_l_stereo_camera_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send narrow_stereo_l_stereo_camera_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for narrow_stereo_l_stereo_camera_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.7820754083899999e+01 6.0632256042200005e+01 1.2807375486935000e+03)
                                   :rot (quaternion2matrix (float-vector 4.9763002796063699e-01 -4.9714389377516049e-01 4.9729372563781626e-01 -5.0784963778192060e-01)))
                        ))
         (send narrow_stereo_l_stereo_camera_optical_frame_lk :transform world-cds))
       )

     ;; link: narrow_stereo_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_link"))
       ;; inertial parameter for narrow_stereo_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send narrow_stereo_link_lk :weight 100.000)
         (setq (narrow_stereo_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (narrow_stereo_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for narrow_stereo_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.7820754083899999e+01 6.0632256042200005e+01 1.2807375486935000e+03)
                                   :rot (quaternion2matrix (float-vector 9.9995864257776801e-01 -5.0348889792875724e-03 -5.5210231623546158e-03 -5.1847208444301598e-03)))
                        ))
         (send narrow_stereo_link_lk :transform world-cds))
       )

     ;; link: narrow_stereo_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_optical_frame"))
       (progn (send narrow_stereo_optical_frame_lk :weight 0.0) (setq (narrow_stereo_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send narrow_stereo_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for narrow_stereo_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.7820754083899999e+01 6.0632256042200005e+01 1.2807375486935000e+03)
                                   :rot (quaternion2matrix (float-vector 4.9763002796063699e-01 -4.9714389377516049e-01 4.9729372563781626e-01 -5.0784963778192060e-01)))
                        ))
         (send narrow_stereo_optical_frame_lk :transform world-cds))
       )

     ;; link: narrow_stereo_r_stereo_camera_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_r_stereo_camera_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_r_stereo_camera_frame"))
       ;; inertial parameter for narrow_stereo_r_stereo_camera_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.3877787807814457e-14 0.0000000000000000e+00 -4.4408920985006262e-13))
                      ))
         (send narrow_stereo_r_stereo_camera_frame_lk :weight 10.000)
         (setq (narrow_stereo_r_stereo_camera_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (narrow_stereo_r_stereo_camera_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for narrow_stereo_r_stereo_camera_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.6882539335745200e+01 -2.9358342299091692e+01 1.2816386387348696e+03)
                                   :rot (quaternion2matrix (float-vector 9.9995864257776801e-01 -5.0348889792875724e-03 -5.5210231623546158e-03 -5.1847208444301598e-03)))
                        ))
         (send narrow_stereo_r_stereo_camera_frame_lk :transform world-cds))
       )

     ;; link: narrow_stereo_r_stereo_camera_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq narrow_stereo_r_stereo_camera_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "narrow_stereo_r_stereo_camera_optical_frame"))
       (progn (send narrow_stereo_r_stereo_camera_optical_frame_lk :weight 0.0) (setq (narrow_stereo_r_stereo_camera_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send narrow_stereo_r_stereo_camera_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for narrow_stereo_r_stereo_camera_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.6882539335745200e+01 -2.9358342299091692e+01 1.2816386387348696e+03)
                                   :rot (quaternion2matrix (float-vector 4.9763002796063699e-01 -4.9714389377516049e-01 4.9729372563781626e-01 -5.0784963778192060e-01)))
                        ))
         (send narrow_stereo_r_stereo_camera_optical_frame_lk :transform world-cds))
       )

     ;; link: projector_wg6802418_child_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq projector_wg6802418_child_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "projector_wg6802418_child_frame"))
       ;; inertial parameter for projector_wg6802418_child_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send projector_wg6802418_child_frame_lk :weight 10.000)
         (setq (projector_wg6802418_child_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (projector_wg6802418_child_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for projector_wg6802418_child_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 2.4129999999999999e+01 1.1000000000000000e+02 1.2912250000000001e+03)
                                   :rot (quaternion2matrix (float-vector 7.0710678118827863e-01 0.0000000000000000e+00 -7.0710678118481640e-01 0.0000000000000000e+00)))
                        ))
         (send projector_wg6802418_child_frame_lk :transform world-cds))
       )

     ;; link: projector_wg6802418_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq projector_wg6802418_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "projector_wg6802418_frame"))
       ;; inertial parameter for projector_wg6802418_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send projector_wg6802418_frame_lk :weight 10.000)
         (setq (projector_wg6802418_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (projector_wg6802418_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for projector_wg6802418_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 2.4129999999999999e+01 1.1000000000000000e+02 1.2912250000000001e+03))
                        ))
         (send projector_wg6802418_frame_lk :transform world-cds))
       )

     ;; link: r_elbow_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_elbow_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_elbow_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_elbow_flex_link"))
       ;; inertial parameter for r_elbow_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.0139999999999983e+01 3.1999999999998696e-01 -1.2109999999999953e+01)
                                   :rot (quaternion2matrix (float-vector 6.7023857211269999e-01 -6.5469615865643171e-01 -2.3355256344108982e-01 2.6001230048391416e-01)))
                      ))
         (send r_elbow_flex_link_lk :weight 1903.270)
         (setq (r_elbow_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.0897687844015122e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.9647676565655996e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.4185162390328888e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_elbow_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_elbow_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_elbow_flex_link_lk :transform world-cds))
       )

     ;; link: r_forearm_cam_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_forearm_cam_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_forearm_cam_frame"))
       ;; inertial parameter for r_forearm_cam_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_forearm_cam_frame_lk :weight 10.000)
         (setq (r_forearm_cam_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_forearm_cam_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_forearm_cam_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9278174482800000e+02 -2.0033502870120000e+02 8.2942074642509999e+02)
                                   :rot (quaternion2matrix (float-vector 6.7977275225487255e-01 6.7856950148554640e-01 -1.9274528806062191e-01 2.0075281038112730e-01)))
                        ))
         (send r_forearm_cam_frame_lk :transform world-cds))
       )

     ;; link: r_forearm_cam_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_forearm_cam_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_forearm_cam_optical_frame"))
       (progn (send r_forearm_cam_optical_frame_lk :weight 0.0) (setq (r_forearm_cam_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send r_forearm_cam_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for r_forearm_cam_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9278174482800000e+02 -2.0033502870120000e+02 8.2942074642509999e+02)
                                   :rot (quaternion2matrix (float-vector 8.7592017609227635e-01 -4.6053865427630736e-03 4.8242207764719869e-01 3.4021357744196679e-03)))
                        ))
         (send r_forearm_cam_optical_frame_lk :transform world-cds))
       )

     ;; link: r_forearm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_forearm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_forearm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_forearm_link"))
       ;; inertial parameter for r_forearm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.8790999999999997e+02 -1.7000000000000348e-01 -9.1200000000000170e+00)
                                   :rot (quaternion2matrix (float-vector 7.0455582233769354e-01 -7.0911110961966251e-01 -1.7761550919348956e-02 2.1143668862499916e-02)))
                      ))
         (send r_forearm_link_lk :weight 2579.680)
         (setq (r_forearm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6089171216999060e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.6632586642306658e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5077544915993441e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_forearm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_forearm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_forearm_link_lk :transform world-cds))
       )

     ;; link: r_forearm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_forearm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_forearm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_forearm_roll_link"))
       ;; inertial parameter for r_forearm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_forearm_roll_link_lk :weight 100.000)
         (setq (r_forearm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_forearm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_forearm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 4.5000000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_forearm_roll_link_lk :transform world-cds))
       )

     ;; link: r_gripper_l_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_l_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_l_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_l_finger_link"))
       ;; inertial parameter for r_gripper_l_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 3.5979999999999905e+01 1.7299999999999983e+01 -1.6399999999999748e+00)
                                   :rot (quaternion2matrix (float-vector 6.3262934235930901e-01 7.7302450075385043e-01 2.5774405529421746e-02 3.9356275737085514e-02)))
                      ))
         (send r_gripper_l_finger_link_lk :weight 171.260)
         (setq (r_gripper_l_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.6623944609730548e+04 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8133591439139261e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9773963099887679e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_l_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_l_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 8.4791000000000008e+02 -1.7800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_l_finger_link_lk :transform world-cds))
       )

     ;; link: r_gripper_l_finger_tip_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_l_finger_tip_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_l_finger_tip_frame"))
       (progn (send r_gripper_l_finger_tip_frame_lk :weight 0.0) (setq (r_gripper_l_finger_tip_frame_lk . acentroid) (float-vector 0 0 0)) (send r_gripper_l_finger_tip_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for r_gripper_l_finger_tip_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 -2.0295000000000002e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_l_finger_tip_frame_lk :transform world-cds))
       )

     ;; link: r_gripper_l_finger_tip_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_l_finger_tip_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_l_finger_tip_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_l_finger_tip_link"))
       ;; inertial parameter for r_gripper_l_finger_tip_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 4.2299999999998450e+00 2.8399999999999812e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 9.3563462459842295e-01 0.0000000000000000e+00 0.0000000000000000e+00 3.5297004016285605e-01)))
                      ))
         (send r_gripper_l_finger_tip_link_lk :weight 44.190)
         (setq (r_gripper_l_finger_tip_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.2362449620368520e+03 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.5004895037963150e+04 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5417679999999997e+04))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_l_finger_tip_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_l_finger_tip_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 -1.7304999999999998e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_l_finger_tip_link_lk :transform world-cds))
       )

     ;; link: r_gripper_led_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_led_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_led_frame"))
       (progn (send r_gripper_led_frame_lk :weight 0.0) (setq (r_gripper_led_frame_lk . acentroid) (float-vector 0 0 0)) (send r_gripper_led_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for r_gripper_led_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 8.2230000000000007e+02 -1.8800000000000000e+02 8.1507500000000005e+02))
                        ))
         (send r_gripper_led_frame_lk :transform world-cds))
       )

     ;; link: r_gripper_motor_accelerometer_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_motor_accelerometer_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_motor_accelerometer_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_motor_accelerometer_link"))
       ;; inertial parameter for r_gripper_motor_accelerometer_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_gripper_motor_accelerometer_link_lk :weight 1.000)
         (setq (r_gripper_motor_accelerometer_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_motor_accelerometer_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_motor_accelerometer_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_motor_accelerometer_link_lk :transform world-cds))
       )

     ;; link: r_gripper_motor_screw_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_motor_screw_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_motor_screw_link"))
       ;; inertial parameter for r_gripper_motor_screw_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_gripper_motor_screw_link_lk :weight 10.000)
         (setq (r_gripper_motor_screw_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_motor_screw_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_motor_screw_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3927999999999997e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_motor_screw_link_lk :transform world-cds))
       )

     ;; link: r_gripper_motor_slider_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_motor_slider_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_motor_slider_link"))
       ;; inertial parameter for r_gripper_motor_slider_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_gripper_motor_slider_link_lk :weight 10.000)
         (setq (r_gripper_motor_slider_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_motor_slider_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_motor_slider_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3927999999999997e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_motor_slider_link_lk :transform world-cds))
       )

     ;; link: r_gripper_palm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_palm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_palm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_palm_link"))
       ;; inertial parameter for r_gripper_palm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 6.6230000000000018e+01 5.3000000000000269e-01 -1.1900000000000244e+00)
                                   :rot (quaternion2matrix (float-vector 1.4899072945442145e-03 9.9970499746458896e-01 2.4226387096224839e-02 8.8339619865787514e-04)))
                      ))
         (send r_gripper_palm_link_lk :weight 580.070)
         (setq (r_gripper_palm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.5147110342667863e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 6.7817787266766967e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.6563651390565163e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_palm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_palm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_palm_link_lk :transform world-cds))
       )

     ;; link: r_gripper_r_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_r_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_r_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_r_finger_link"))
       ;; inertial parameter for r_gripper_r_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 3.5759999999999906e+01 -1.7359999999999985e+01 -9.5000000000000639e-01)
                                   :rot (quaternion2matrix (float-vector 7.5776139467964265e-01 6.5127216354607009e-01 3.5226594320275487e-02 2.0033092017423846e-02)))
                      ))
         (send r_gripper_r_finger_link_lk :weight 173.890)
         (setq (r_gripper_r_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.6684670622283287e+04 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8134000171817749e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9890313765953921e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_r_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_r_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 8.4791000000000008e+02 -1.9800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_r_finger_link_lk :transform world-cds))
       )

     ;; link: r_gripper_r_finger_tip_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_r_finger_tip_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_r_finger_tip_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_r_finger_tip_link"))
       ;; inertial parameter for r_gripper_r_finger_tip_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 4.2299999999998450e+00 -2.8399999999999812e+00 0.0000000000000000e+00)
                                   :rot (quaternion2matrix (float-vector 9.3563462459842295e-01 0.0000000000000000e+00 0.0000000000000000e+00 -3.5297004016285605e-01)))
                      ))
         (send r_gripper_r_finger_tip_link_lk :weight 44.190)
         (setq (r_gripper_r_finger_tip_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.2362449620368520e+03 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.5004895037963150e+04 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5417679999999997e+04))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_r_finger_tip_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_r_finger_tip_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.3928000000000009e+02 -2.0295000000000002e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_r_finger_tip_link_lk :transform world-cds))
       )

     ;; link: r_gripper_tool_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_tool_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_tool_frame"))
       (progn (send r_gripper_tool_frame_lk :weight 0.0) (setq (r_gripper_tool_frame_lk . acentroid) (float-vector 0 0 0)) (send r_gripper_tool_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for r_gripper_tool_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 9.5100000000000011e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_gripper_tool_frame_lk :transform world-cds))
       )

     ;; link: r_shoulder_lift_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_shoulder_lift_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_shoulder_lift_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_shoulder_lift_link"))
       ;; inertial parameter for r_shoulder_lift_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.1949999999999996e+01 -2.6639999999999997e+01 -3.1270000000000021e+01)
                                   :rot (quaternion2matrix (float-vector 2.9576183828508645e-01 2.3898442472179413e-01 -4.7801368988356990e-01 7.9177919399193220e-01)))
                      ))
         (send r_shoulder_lift_link_lk :weight 2749.880)
         (setq (r_shoulder_lift_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.6187368693981063e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.0730163313329030e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.5168089652689919e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_shoulder_lift_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_shoulder_lift_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_shoulder_lift_link_lk :transform world-cds))
       )

     ;; link: r_shoulder_pan_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_shoulder_pan_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_shoulder_pan_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_shoulder_pan_link"))
       ;; inertial parameter for r_shoulder_pan_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.2010000000000007e+00 2.4513000000000005e+01 -9.8230999999999952e+01)
                                   :rot (quaternion2matrix (float-vector 9.2748205313791365e-01 8.7656121686357058e-02 -7.4059439643071295e-02 3.5582108543162694e-01)))
                      ))
         (send r_shoulder_pan_link_lk :weight 25799.322)
         (setq (r_shoulder_pan_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 9.3420134354104972e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.3770052521175265e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.4203263939719772e+08))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_shoulder_pan_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_shoulder_pan_link_lk
       (let ((world-cds (make-coords :pos (float-vector -5.0000000000000000e+01 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_shoulder_pan_link_lk :transform world-cds))
       )

     ;; link: r_torso_lift_side_plate_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_torso_lift_side_plate_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_torso_lift_side_plate_link"))
       ;; inertial parameter for r_torso_lift_side_plate_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -6.2499999999999993e+01 0.0000000000000000e+00 5.0000000000000043e+01))
                      ))
         (send r_torso_lift_side_plate_link_lk :weight 100.000)
         (setq (r_torso_lift_side_plate_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_torso_lift_side_plate_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_torso_lift_side_plate_link_lk
       (let ((world-cds (make-coords :pos (float-vector 3.4999999999999960e+00 -2.0928500000000000e+02 9.6730000000000007e+02))
                        ))
         (send r_torso_lift_side_plate_link_lk :transform world-cds))
       )

     ;; link: r_upper_arm_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_upper_arm_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_upper_arm_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_upper_arm_link"))
       ;; inertial parameter for r_upper_arm_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.1397999999999999e+02 -1.6210000000000001e+01 -1.9999999999997797e-01)
                                   :rot (quaternion2matrix (float-vector 9.9501733410487181e-01 -9.4438775088367580e-02 8.6566840214665347e-03 3.0771487003312628e-02)))
                      ))
         (send r_upper_arm_link_lk :weight 6017.690)
         (setq (r_upper_arm_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.5132686535267271e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 7.4930655272408575e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.6138485232324168e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_upper_arm_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_upper_arm_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_upper_arm_link_lk :transform world-cds))
       )

     ;; link: r_upper_arm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_upper_arm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_upper_arm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_upper_arm_roll_link"))
       ;; inertial parameter for r_upper_arm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_upper_arm_roll_link_lk :weight 100.000)
         (setq (r_upper_arm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_upper_arm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_upper_arm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0000000000000000e+01 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_upper_arm_roll_link_lk :transform world-cds))
       )

     ;; link: r_wrist_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_wrist_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_wrist_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_wrist_flex_link"))
       ;; inertial parameter for r_wrist_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.5699999999999603e+00 0.0000000000000000e+00 -7.5000000000002842e-01)
                                   :rot (quaternion2matrix (float-vector 6.9597592710835521e-01 -6.9641143568018082e-01 1.2355973330960543e-01 -1.2394197611783576e-01)))
                      ))
         (send r_wrist_flex_link_lk :weight 614.020)
         (setq (r_wrist_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 6.5277143381554517e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 6.4339106681473507e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.9824412936971989e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_wrist_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_wrist_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_wrist_flex_link_lk :transform world-cds))
       )

     ;; link: r_wrist_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_wrist_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_wrist_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_wrist_roll_link"))
       ;; inertial parameter for r_wrist_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_wrist_roll_link_lk :weight 100.000)
         (setq (r_wrist_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_wrist_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_wrist_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send r_wrist_roll_link_lk :transform world-cds))
       )

     ;; link: right_arm_chain_cb_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq right_arm_chain_cb_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "right_arm_chain_cb_link"))
       (progn (send right_arm_chain_cb_link_lk :weight 0.0) (setq (right_arm_chain_cb_link_lk . acentroid) (float-vector 0 0 0)) (send right_arm_chain_cb_link_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for right_arm_chain_cb_link_lk
       (let ((world-cds (make-coords :pos (float-vector 7.7100000000000000e+02 -1.8800000000000000e+02 7.9067500000000007e+02))
                        ))
         (send right_arm_chain_cb_link_lk :transform world-cds))
       )

     ;; link: sensor_mount_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_sensor_mount_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq sensor_mount_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "sensor_mount_link"))
       ;; inertial parameter for sensor_mount_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send sensor_mount_link_lk :weight 50.000)
         (setq (sensor_mount_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (sensor_mount_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for sensor_mount_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.4129999999999999e+01 0.0000000000000000e+00 1.2366250000000000e+03))
                        ))
         (send sensor_mount_link_lk :transform world-cds))
       )

     ;; link: torso_lift_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_torso_lift_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq torso_lift_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "torso_lift_link"))
       ;; inertial parameter for torso_lift_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -9.9999999999999986e+01 0.0000000000000000e+00 -8.8500000000000028e+01)
                                   :rot (quaternion2matrix (float-vector 7.1202942589785090e-01 7.0124419064990795e-01 -2.2444350358472802e-02 -2.7693552901690011e-02)))
                      ))
         (send torso_lift_link_lk :weight 36248.046)
         (setq (torso_lift_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.7830748220493431e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.1458072243189907e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.5104500693077579e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (torso_lift_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for torso_lift_link_lk
       (let ((world-cds (make-coords :pos (float-vector -5.0000000000000000e+01 0.0000000000000000e+00 7.9067500000000007e+02))
                        ))
         (send torso_lift_link_lk :transform world-cds))
       )

     ;; link: torso_lift_motor_screw_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq torso_lift_motor_screw_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "torso_lift_motor_screw_link"))
       ;; inertial parameter for torso_lift_motor_screw_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send torso_lift_motor_screw_link_lk :weight 1000.000)
         (setq (torso_lift_motor_screw_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (torso_lift_motor_screw_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for torso_lift_motor_screw_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.5000000000000000e+02 0.0000000000000000e+00 7.5100000000000000e+02))
                        ))
         (send torso_lift_motor_screw_link_lk :transform world-cds))
       )

     ;; link: wide_stereo_l_stereo_camera_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_l_stereo_camera_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_l_stereo_camera_frame"))
       ;; inertial parameter for wide_stereo_l_stereo_camera_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 3.4694469519536142e-15 -2.2204460492503131e-13)
                                   :rot (quaternion2matrix (float-vector 1.0000000000000000e+00 3.3881317890172014e-21 8.6736173798840355e-19 0.0000000000000000e+00)))
                      ))
         (send wide_stereo_l_stereo_camera_frame_lk :weight 10.000)
         (setq (wide_stereo_l_stereo_camera_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (wide_stereo_l_stereo_camera_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for wide_stereo_l_stereo_camera_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9219675205800002e+01 3.0581954459599999e+01 1.2807163111347002e+03)
                                   :rot (quaternion2matrix (float-vector 9.9996564324259862e-01 -3.7075010798754715e-03 -6.2133588949438764e-03 -4.0448660548236034e-03)))
                        ))
         (send wide_stereo_l_stereo_camera_frame_lk :transform world-cds))
       )

     ;; link: wide_stereo_l_stereo_camera_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_l_stereo_camera_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_l_stereo_camera_optical_frame"))
       (progn (send wide_stereo_l_stereo_camera_optical_frame_lk :weight 0.0) (setq (wide_stereo_l_stereo_camera_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send wide_stereo_l_stereo_camera_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for wide_stereo_l_stereo_camera_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9219675205800002e+01 3.0581954459599999e+01 1.2807163111347002e+03)
                                   :rot (quaternion2matrix (float-vector 4.9921331750385456e-01 -4.9670745968637237e-01 4.9704482465883804e-01 -5.0696568463612168e-01)))
                        ))
         (send wide_stereo_l_stereo_camera_optical_frame_lk :transform world-cds))
       )

     ;; link: wide_stereo_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_link"))
       ;; inertial parameter for wide_stereo_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 3.4694469519536142e-15 -2.2204460492503131e-13)
                                   :rot (quaternion2matrix (float-vector 1.0000000000000000e+00 3.3881317890172014e-21 8.6736173798840355e-19 0.0000000000000000e+00)))
                      ))
         (send wide_stereo_link_lk :weight 100.000)
         (setq (wide_stereo_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (wide_stereo_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for wide_stereo_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9219675205800002e+01 3.0581954459599999e+01 1.2807163111347002e+03)
                                   :rot (quaternion2matrix (float-vector 9.9996564324259862e-01 -3.7075010798754715e-03 -6.2133588949438764e-03 -4.0448660548236034e-03)))
                        ))
         (send wide_stereo_link_lk :transform world-cds))
       )

     ;; link: wide_stereo_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_optical_frame"))
       (progn (send wide_stereo_optical_frame_lk :weight 0.0) (setq (wide_stereo_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send wide_stereo_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for wide_stereo_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.9219675205800002e+01 3.0581954459599999e+01 1.2807163111347002e+03)
                                   :rot (quaternion2matrix (float-vector 4.9921331750385456e-01 -4.9670745968637237e-01 4.9704482465883804e-01 -5.0696568463612168e-01)))
                        ))
         (send wide_stereo_optical_frame_lk :transform world-cds))
       )

     ;; link: wide_stereo_r_stereo_camera_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_r_stereo_camera_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_r_stereo_camera_frame"))
       ;; inertial parameter for wide_stereo_r_stereo_camera_frame_lk
       (let ((tmp-cds (make-coords :pos (float-vector -2.7755575615628914e-14 0.0000000000000000e+00 -4.4408920985006262e-13)
                                   :rot (quaternion2matrix (float-vector 1.0000000000000000e+00 3.3881317890172014e-21 8.6736173798840355e-19 0.0000000000000000e+00)))
                      ))
         (send wide_stereo_r_stereo_camera_frame_lk :weight 10.000)
         (setq (wide_stereo_r_stereo_camera_frame_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (wide_stereo_r_stereo_camera_frame_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for wide_stereo_r_stereo_camera_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.8487477843992188e+01 -5.9412626369381421e+01 1.2813791146042824e+03)
                                   :rot (quaternion2matrix (float-vector 9.9996564324259862e-01 -3.7075010798754715e-03 -6.2133588949438764e-03 -4.0448660548236034e-03)))
                        ))
         (send wide_stereo_r_stereo_camera_frame_lk :transform world-cds))
       )

     ;; link: wide_stereo_r_stereo_camera_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wide_stereo_r_stereo_camera_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wide_stereo_r_stereo_camera_optical_frame"))
       (progn (send wide_stereo_r_stereo_camera_optical_frame_lk :weight 0.0) (setq (wide_stereo_r_stereo_camera_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send wide_stereo_r_stereo_camera_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for wide_stereo_r_stereo_camera_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 5.8487477843992188e+01 -5.9412626369381421e+01 1.2813791146042824e+03)
                                   :rot (quaternion2matrix (float-vector 4.9921331750385456e-01 -4.9670745968637237e-01 4.9704482465883804e-01 -5.0696568463612168e-01)))
                        ))
         (send wide_stereo_r_stereo_camera_optical_frame_lk :transform world-cds))
       )

     (send base_link_lk :assoc base_bellow_link_lk)
     (send base_footprint_lk :assoc base_link_lk)
     (send base_link_lk :assoc base_laser_link_lk)
     (send bl_caster_rotation_link_lk :assoc bl_caster_l_wheel_link_lk)
     (send bl_caster_rotation_link_lk :assoc bl_caster_r_wheel_link_lk)
     (send base_link_lk :assoc bl_caster_rotation_link_lk)
     (send br_caster_rotation_link_lk :assoc br_caster_l_wheel_link_lk)
     (send br_caster_rotation_link_lk :assoc br_caster_r_wheel_link_lk)
     (send base_link_lk :assoc br_caster_rotation_link_lk)
     (send sensor_mount_link_lk :assoc double_stereo_link_lk)
     (send fl_caster_rotation_link_lk :assoc fl_caster_l_wheel_link_lk)
     (send fl_caster_rotation_link_lk :assoc fl_caster_r_wheel_link_lk)
     (send base_link_lk :assoc fl_caster_rotation_link_lk)
     (send fr_caster_rotation_link_lk :assoc fr_caster_l_wheel_link_lk)
     (send fr_caster_rotation_link_lk :assoc fr_caster_r_wheel_link_lk)
     (send base_link_lk :assoc fr_caster_rotation_link_lk)
     (send head_tilt_link_lk :assoc head_chain_cb_link_lk)
     (send head_plate_frame_lk :assoc head_mount_link_lk)
     (send head_mount_link_lk :assoc head_mount_kinect_ir_link_lk)
     (send head_mount_kinect_ir_link_lk :assoc head_mount_kinect_ir_optical_frame_lk)
     (send head_mount_kinect_ir_link_lk :assoc head_mount_kinect_rgb_link_lk)
     (send head_mount_kinect_rgb_link_lk :assoc head_mount_kinect_rgb_optical_frame_lk)
     (send head_mount_link_lk :assoc head_mount_prosilica_link_lk)
     (send head_mount_prosilica_link_lk :assoc head_mount_prosilica_optical_frame_lk)
     (send torso_lift_link_lk :assoc head_pan_link_lk)
     (send head_tilt_link_lk :assoc head_plate_frame_lk)
     (send head_pan_link_lk :assoc head_tilt_link_lk)
     (send sensor_mount_link_lk :assoc high_def_frame_lk)
     (send high_def_frame_lk :assoc high_def_optical_frame_lk)
     (send torso_lift_link_lk :assoc imu_link_lk)
     (send l_upper_arm_link_lk :assoc l_elbow_flex_link_lk)
     (send l_forearm_roll_link_lk :assoc l_forearm_cam_frame_lk)
     (send l_forearm_cam_frame_lk :assoc l_forearm_cam_optical_frame_lk)
     (send l_forearm_roll_link_lk :assoc l_forearm_link_lk)
     (send l_elbow_flex_link_lk :assoc l_forearm_roll_link_lk)
     (send l_gripper_r_finger_tip_link_lk :assoc l_gripper_l_finger_tip_frame_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_l_finger_link_lk)
     (send l_gripper_l_finger_link_lk :assoc l_gripper_l_finger_tip_link_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_led_frame_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_motor_accelerometer_link_lk)
     (send l_gripper_motor_slider_link_lk :assoc l_gripper_motor_screw_link_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_motor_slider_link_lk)
     (send l_wrist_roll_link_lk :assoc l_gripper_palm_link_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_r_finger_link_lk)
     (send l_gripper_r_finger_link_lk :assoc l_gripper_r_finger_tip_link_lk)
     (send l_gripper_palm_link_lk :assoc l_gripper_tool_frame_lk)
     (send l_shoulder_pan_link_lk :assoc l_shoulder_lift_link_lk)
     (send torso_lift_link_lk :assoc l_shoulder_pan_link_lk)
     (send torso_lift_link_lk :assoc l_torso_lift_side_plate_link_lk)
     (send l_upper_arm_roll_link_lk :assoc l_upper_arm_link_lk)
     (send l_shoulder_lift_link_lk :assoc l_upper_arm_roll_link_lk)
     (send l_forearm_link_lk :assoc l_wrist_flex_link_lk)
     (send l_wrist_flex_link_lk :assoc l_wrist_roll_link_lk)
     (send laser_tilt_mount_link_lk :assoc laser_tilt_link_lk)
     (send torso_lift_link_lk :assoc laser_tilt_mount_link_lk)
     (send l_wrist_roll_link_lk :assoc left_arm_chain_cb_link_lk)
     (send double_stereo_link_lk :assoc narrow_stereo_link_lk)
     (send narrow_stereo_link_lk :assoc narrow_stereo_l_stereo_camera_frame_lk)
     (send narrow_stereo_l_stereo_camera_frame_lk :assoc narrow_stereo_l_stereo_camera_optical_frame_lk)
     (send narrow_stereo_link_lk :assoc narrow_stereo_optical_frame_lk)
     (send narrow_stereo_l_stereo_camera_frame_lk :assoc narrow_stereo_r_stereo_camera_frame_lk)
     (send narrow_stereo_r_stereo_camera_frame_lk :assoc narrow_stereo_r_stereo_camera_optical_frame_lk)
     (send projector_wg6802418_frame_lk :assoc projector_wg6802418_child_frame_lk)
     (send head_plate_frame_lk :assoc projector_wg6802418_frame_lk)
     (send r_upper_arm_link_lk :assoc r_elbow_flex_link_lk)
     (send r_forearm_roll_link_lk :assoc r_forearm_cam_frame_lk)
     (send r_forearm_cam_frame_lk :assoc r_forearm_cam_optical_frame_lk)
     (send r_forearm_roll_link_lk :assoc r_forearm_link_lk)
     (send r_elbow_flex_link_lk :assoc r_forearm_roll_link_lk)
     (send r_gripper_r_finger_tip_link_lk :assoc r_gripper_l_finger_tip_frame_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_l_finger_link_lk)
     (send r_gripper_l_finger_link_lk :assoc r_gripper_l_finger_tip_link_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_led_frame_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_motor_accelerometer_link_lk)
     (send r_gripper_motor_slider_link_lk :assoc r_gripper_motor_screw_link_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_motor_slider_link_lk)
     (send r_wrist_roll_link_lk :assoc r_gripper_palm_link_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_r_finger_link_lk)
     (send r_gripper_r_finger_link_lk :assoc r_gripper_r_finger_tip_link_lk)
     (send r_gripper_palm_link_lk :assoc r_gripper_tool_frame_lk)
     (send r_shoulder_pan_link_lk :assoc r_shoulder_lift_link_lk)
     (send torso_lift_link_lk :assoc r_shoulder_pan_link_lk)
     (send torso_lift_link_lk :assoc r_torso_lift_side_plate_link_lk)
     (send r_upper_arm_roll_link_lk :assoc r_upper_arm_link_lk)
     (send r_shoulder_lift_link_lk :assoc r_upper_arm_roll_link_lk)
     (send r_forearm_link_lk :assoc r_wrist_flex_link_lk)
     (send r_wrist_flex_link_lk :assoc r_wrist_roll_link_lk)
     (send r_wrist_roll_link_lk :assoc right_arm_chain_cb_link_lk)
     (send head_plate_frame_lk :assoc sensor_mount_link_lk)
     (send base_link_lk :assoc torso_lift_link_lk)
     (send base_link_lk :assoc torso_lift_motor_screw_link_lk)
     (send double_stereo_link_lk :assoc wide_stereo_link_lk)
     (send wide_stereo_link_lk :assoc wide_stereo_l_stereo_camera_frame_lk)
     (send wide_stereo_l_stereo_camera_frame_lk :assoc wide_stereo_l_stereo_camera_optical_frame_lk)
     (send wide_stereo_link_lk :assoc wide_stereo_optical_frame_lk)
     (send wide_stereo_l_stereo_camera_frame_lk :assoc wide_stereo_r_stereo_camera_frame_lk)
     (send wide_stereo_r_stereo_camera_frame_lk :assoc wide_stereo_r_stereo_camera_optical_frame_lk)
     (send self :assoc base_footprint_lk)

     ;; joint models
     ;; joint: base_bellow_joint_fixed_jt
     (setq base_bellow_joint_fixed_jt
           (instance rotational-joint :init
                     :name "base_bellow_joint"
                     :parent-link base_link_lk :child-link base_bellow_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: base_footprint_joint_fixed_jt
     (setq base_footprint_joint_fixed_jt
           (instance rotational-joint :init
                     :name "base_footprint_joint"
                     :parent-link base_footprint_lk :child-link base_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: base_laser_joint_fixed_jt
     (setq base_laser_joint_fixed_jt
           (instance rotational-joint :init
                     :name "base_laser_joint"
                     :parent-link base_link_lk :child-link base_laser_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: bl_caster_l_wheel_joint_jt
     (setq bl_caster_l_wheel_joint_jt
           (instance rotational-joint :init
                     :name "bl_caster_l_wheel_joint"
                     :parent-link bl_caster_rotation_link_lk :child-link bl_caster_l_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: bl_caster_r_wheel_joint_jt
     (setq bl_caster_r_wheel_joint_jt
           (instance rotational-joint :init
                     :name "bl_caster_r_wheel_joint"
                     :parent-link bl_caster_rotation_link_lk :child-link bl_caster_r_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: bl_caster_rotation_joint_jt
     (setq bl_caster_rotation_joint_jt
           (instance rotational-joint :init
                     :name "bl_caster_rotation_joint"
                     :parent-link base_link_lk :child-link bl_caster_rotation_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 10.000000
                     :max-joint-torque 6.500000
                     ))
     ;; joint: br_caster_l_wheel_joint_jt
     (setq br_caster_l_wheel_joint_jt
           (instance rotational-joint :init
                     :name "br_caster_l_wheel_joint"
                     :parent-link br_caster_rotation_link_lk :child-link br_caster_l_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: br_caster_r_wheel_joint_jt
     (setq br_caster_r_wheel_joint_jt
           (instance rotational-joint :init
                     :name "br_caster_r_wheel_joint"
                     :parent-link br_caster_rotation_link_lk :child-link br_caster_r_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: br_caster_rotation_joint_jt
     (setq br_caster_rotation_joint_jt
           (instance rotational-joint :init
                     :name "br_caster_rotation_joint"
                     :parent-link base_link_lk :child-link br_caster_rotation_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 10.000000
                     :max-joint-torque 6.500000
                     ))
     ;; joint: double_stereo_frame_joint_fixed_jt
     (setq double_stereo_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "double_stereo_frame_joint"
                     :parent-link sensor_mount_link_lk :child-link double_stereo_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: fl_caster_l_wheel_joint_jt
     (setq fl_caster_l_wheel_joint_jt
           (instance rotational-joint :init
                     :name "fl_caster_l_wheel_joint"
                     :parent-link fl_caster_rotation_link_lk :child-link fl_caster_l_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: fl_caster_r_wheel_joint_jt
     (setq fl_caster_r_wheel_joint_jt
           (instance rotational-joint :init
                     :name "fl_caster_r_wheel_joint"
                     :parent-link fl_caster_rotation_link_lk :child-link fl_caster_r_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: fl_caster_rotation_joint_jt
     (setq fl_caster_rotation_joint_jt
           (instance rotational-joint :init
                     :name "fl_caster_rotation_joint"
                     :parent-link base_link_lk :child-link fl_caster_rotation_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 10.000000
                     :max-joint-torque 6.500000
                     ))
     ;; joint: fr_caster_l_wheel_joint_jt
     (setq fr_caster_l_wheel_joint_jt
           (instance rotational-joint :init
                     :name "fr_caster_l_wheel_joint"
                     :parent-link fr_caster_rotation_link_lk :child-link fr_caster_l_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: fr_caster_r_wheel_joint_jt
     (setq fr_caster_r_wheel_joint_jt
           (instance rotational-joint :init
                     :name "fr_caster_r_wheel_joint"
                     :parent-link fr_caster_rotation_link_lk :child-link fr_caster_r_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 15.000000
                     :max-joint-torque 7.000000
                     ))
     ;; joint: fr_caster_rotation_joint_jt
     (setq fr_caster_rotation_joint_jt
           (instance rotational-joint :init
                     :name "fr_caster_rotation_joint"
                     :parent-link base_link_lk :child-link fr_caster_rotation_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 10.000000
                     :max-joint-torque 6.500000
                     ))
     ;; joint: head_chain_cb_fixed_jt
     (setq head_chain_cb_fixed_jt
           (instance rotational-joint :init
                     :name "head_chain_cb"
                     :parent-link head_tilt_link_lk :child-link head_chain_cb_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_joint_fixed_jt
     (setq head_mount_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_joint"
                     :parent-link head_plate_frame_lk :child-link head_mount_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_kinect_ir_joint_fixed_jt
     (setq head_mount_kinect_ir_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_kinect_ir_joint"
                     :parent-link head_mount_link_lk :child-link head_mount_kinect_ir_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_kinect_ir_optical_frame_joint_fixed_jt
     (setq head_mount_kinect_ir_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_kinect_ir_optical_frame_joint"
                     :parent-link head_mount_kinect_ir_link_lk :child-link head_mount_kinect_ir_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_kinect_rgb_joint_fixed_jt
     (setq head_mount_kinect_rgb_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_kinect_rgb_joint"
                     :parent-link head_mount_kinect_ir_link_lk :child-link head_mount_kinect_rgb_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_kinect_rgb_optical_frame_joint_fixed_jt
     (setq head_mount_kinect_rgb_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_kinect_rgb_optical_frame_joint"
                     :parent-link head_mount_kinect_rgb_link_lk :child-link head_mount_kinect_rgb_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_prosilica_joint_fixed_jt
     (setq head_mount_prosilica_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_prosilica_joint"
                     :parent-link head_mount_link_lk :child-link head_mount_prosilica_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_mount_prosilica_optical_frame_joint_fixed_jt
     (setq head_mount_prosilica_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_mount_prosilica_optical_frame_joint"
                     :parent-link head_mount_prosilica_link_lk :child-link head_mount_prosilica_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_pan_joint_jt
     (setq head_pan_joint_jt
           (instance rotational-joint :init
                     :name "head_pan_joint"
                     :parent-link torso_lift_link_lk :child-link head_pan_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -163.694049 :max 163.694049
                     :max-joint-velocity 6.000000
                     :max-joint-torque 2.645000
                     ))
     ;; joint: head_plate_frame_joint_fixed_jt
     (setq head_plate_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_plate_frame_joint"
                     :parent-link head_tilt_link_lk :child-link head_plate_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_tilt_joint_jt
     (setq head_tilt_joint_jt
           (instance rotational-joint :init
                     :name "head_tilt_joint"
                     :parent-link head_pan_link_lk :child-link head_tilt_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -21.268193 :max 74.270227
                     :max-joint-velocity 5.000000
                     :max-joint-torque 18.000000
                     ))
     ;; joint: high_def_frame_joint_fixed_jt
     (setq high_def_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "high_def_frame_joint"
                     :parent-link sensor_mount_link_lk :child-link high_def_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: high_def_optical_frame_joint_fixed_jt
     (setq high_def_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "high_def_optical_frame_joint"
                     :parent-link high_def_frame_lk :child-link high_def_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: imu_joint_fixed_jt
     (setq imu_joint_fixed_jt
           (instance rotational-joint :init
                     :name "imu_joint"
                     :parent-link torso_lift_link_lk :child-link imu_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_elbow_flex_joint_jt
     (setq l_elbow_flex_joint_jt
           (instance rotational-joint :init
                     :name "l_elbow_flex_joint"
                     :parent-link l_upper_arm_link_lk :child-link l_elbow_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -121.541536 :max -8.594367
                     :max-joint-velocity 3.300000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: l_forearm_cam_frame_joint_fixed_jt
     (setq l_forearm_cam_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_forearm_cam_frame_joint"
                     :parent-link l_forearm_roll_link_lk :child-link l_forearm_cam_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_forearm_cam_optical_frame_joint_fixed_jt
     (setq l_forearm_cam_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_forearm_cam_optical_frame_joint"
                     :parent-link l_forearm_cam_frame_lk :child-link l_forearm_cam_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_forearm_joint_fixed_jt
     (setq l_forearm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_forearm_joint"
                     :parent-link l_forearm_roll_link_lk :child-link l_forearm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_forearm_roll_joint_jt
     (setq l_forearm_roll_joint_jt
           (instance rotational-joint :init
                     :name "l_forearm_roll_joint"
                     :parent-link l_elbow_flex_link_lk :child-link l_forearm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 3.600000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: l_gripper_joint_jt
     (setq l_gripper_joint_jt
           (instance linear-joint :init
                     :name "l_gripper_joint"
                     :parent-link l_gripper_r_finger_tip_link_lk :child-link l_gripper_l_finger_tip_frame_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -10.000000 :max 88.000000
                     :max-joint-velocity 0.200000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_l_finger_joint_jt
     (setq l_gripper_l_finger_joint_jt
           (instance rotational-joint :init
                     :name "l_gripper_l_finger_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_l_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_l_finger_tip_joint_jt
     (setq l_gripper_l_finger_tip_joint_jt
           (instance rotational-joint :init
                     :name "l_gripper_l_finger_tip_joint"
                     :parent-link l_gripper_l_finger_link_lk :child-link l_gripper_l_finger_tip_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_led_joint_fixed_jt
     (setq l_gripper_led_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_gripper_led_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_led_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_gripper_motor_accelerometer_joint_fixed_jt
     (setq l_gripper_motor_accelerometer_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_gripper_motor_accelerometer_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_motor_accelerometer_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_gripper_motor_screw_joint_jt
     (setq l_gripper_motor_screw_joint_jt
           (instance rotational-joint :init
                     :name "l_gripper_motor_screw_joint"
                     :parent-link l_gripper_motor_slider_link_lk :child-link l_gripper_motor_screw_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_gripper_motor_slider_joint_jt
     (setq l_gripper_motor_slider_joint_jt
           (instance linear-joint :init
                     :name "l_gripper_motor_slider_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_motor_slider_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -100.000000 :max 100.000000
                     :max-joint-velocity 0.200000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_palm_joint_fixed_jt
     (setq l_gripper_palm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_gripper_palm_joint"
                     :parent-link l_wrist_roll_link_lk :child-link l_gripper_palm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_gripper_r_finger_joint_jt
     (setq l_gripper_r_finger_joint_jt
           (instance rotational-joint :init
                     :name "l_gripper_r_finger_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_r_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_r_finger_tip_joint_jt
     (setq l_gripper_r_finger_tip_joint_jt
           (instance rotational-joint :init
                     :name "l_gripper_r_finger_tip_joint"
                     :parent-link l_gripper_r_finger_link_lk :child-link l_gripper_r_finger_tip_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: l_gripper_tool_joint_fixed_jt
     (setq l_gripper_tool_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_gripper_tool_joint"
                     :parent-link l_gripper_palm_link_lk :child-link l_gripper_tool_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_shoulder_lift_joint_jt
     (setq l_shoulder_lift_joint_jt
           (instance rotational-joint :init
                     :name "l_shoulder_lift_joint"
                     :parent-link l_shoulder_pan_link_lk :child-link l_shoulder_lift_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -20.259787 :max 74.272522
                     :max-joint-velocity 2.082000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: l_shoulder_pan_joint_jt
     (setq l_shoulder_pan_joint_jt
           (instance rotational-joint :init
                     :name "l_shoulder_pan_joint"
                     :parent-link torso_lift_link_lk :child-link l_shoulder_pan_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -32.349302 :max 122.349302
                     :max-joint-velocity 2.088000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: l_torso_lift_side_plate_joint_fixed_jt
     (setq l_torso_lift_side_plate_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_torso_lift_side_plate_joint"
                     :parent-link torso_lift_link_lk :child-link l_torso_lift_side_plate_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_upper_arm_joint_fixed_jt
     (setq l_upper_arm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "l_upper_arm_joint"
                     :parent-link l_upper_arm_roll_link_lk :child-link l_upper_arm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: l_upper_arm_roll_joint_jt
     (setq l_upper_arm_roll_joint_jt
           (instance rotational-joint :init
                     :name "l_upper_arm_roll_joint"
                     :parent-link l_shoulder_lift_link_lk :child-link l_upper_arm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -37.242255 :max 214.859173
                     :max-joint-velocity 3.270000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: l_wrist_flex_joint_jt
     (setq l_wrist_flex_joint_jt
           (instance rotational-joint :init
                     :name "l_wrist_flex_joint"
                     :parent-link l_forearm_link_lk :child-link l_wrist_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -114.591559 :max -5.729578
                     :max-joint-velocity 3.078000
                     :max-joint-torque 10.000000
                     ))
     ;; joint: l_wrist_roll_joint_jt
     (setq l_wrist_roll_joint_jt
           (instance rotational-joint :init
                     :name "l_wrist_roll_joint"
                     :parent-link l_wrist_flex_link_lk :child-link l_wrist_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 3.600000
                     :max-joint-torque 10.000000
                     ))
     ;; joint: laser_tilt_joint_fixed_jt
     (setq laser_tilt_joint_fixed_jt
           (instance rotational-joint :init
                     :name "laser_tilt_joint"
                     :parent-link laser_tilt_mount_link_lk :child-link laser_tilt_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: laser_tilt_mount_joint_jt
     (setq laser_tilt_mount_joint_jt
           (instance rotational-joint :init
                     :name "laser_tilt_mount_joint"
                     :parent-link torso_lift_link_lk :child-link laser_tilt_mount_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -42.135317 :max 82.135217
                     :max-joint-velocity 10.000000
                     :max-joint-torque 0.650000
                     ))
     ;; joint: left_arm_chain_cb_fixed_jt
     (setq left_arm_chain_cb_fixed_jt
           (instance rotational-joint :init
                     :name "left_arm_chain_cb"
                     :parent-link l_wrist_roll_link_lk :child-link left_arm_chain_cb_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_frame_joint_fixed_jt
     (setq narrow_stereo_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_frame_joint"
                     :parent-link double_stereo_link_lk :child-link narrow_stereo_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_l_stereo_camera_frame_joint_fixed_jt
     (setq narrow_stereo_l_stereo_camera_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_l_stereo_camera_frame_joint"
                     :parent-link narrow_stereo_link_lk :child-link narrow_stereo_l_stereo_camera_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_l_stereo_camera_optical_frame_joint_fixed_jt
     (setq narrow_stereo_l_stereo_camera_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_l_stereo_camera_optical_frame_joint"
                     :parent-link narrow_stereo_l_stereo_camera_frame_lk :child-link narrow_stereo_l_stereo_camera_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_optical_frame_joint_fixed_jt
     (setq narrow_stereo_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_optical_frame_joint"
                     :parent-link narrow_stereo_link_lk :child-link narrow_stereo_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_r_stereo_camera_frame_joint_fixed_jt
     (setq narrow_stereo_r_stereo_camera_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_r_stereo_camera_frame_joint"
                     :parent-link narrow_stereo_l_stereo_camera_frame_lk :child-link narrow_stereo_r_stereo_camera_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: narrow_stereo_r_stereo_camera_optical_frame_joint_fixed_jt
     (setq narrow_stereo_r_stereo_camera_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "narrow_stereo_r_stereo_camera_optical_frame_joint"
                     :parent-link narrow_stereo_r_stereo_camera_frame_lk :child-link narrow_stereo_r_stereo_camera_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: projector_wg6802418_child_frame_joint_fixed_jt
     (setq projector_wg6802418_child_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "projector_wg6802418_child_frame_joint"
                     :parent-link projector_wg6802418_frame_lk :child-link projector_wg6802418_child_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: projector_wg6802418_frame_joint_fixed_jt
     (setq projector_wg6802418_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "projector_wg6802418_frame_joint"
                     :parent-link head_plate_frame_lk :child-link projector_wg6802418_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_elbow_flex_joint_jt
     (setq r_elbow_flex_joint_jt
           (instance rotational-joint :init
                     :name "r_elbow_flex_joint"
                     :parent-link r_upper_arm_link_lk :child-link r_elbow_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -121.541536 :max -8.594367
                     :max-joint-velocity 3.300000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: r_forearm_cam_frame_joint_fixed_jt
     (setq r_forearm_cam_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_forearm_cam_frame_joint"
                     :parent-link r_forearm_roll_link_lk :child-link r_forearm_cam_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_forearm_cam_optical_frame_joint_fixed_jt
     (setq r_forearm_cam_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_forearm_cam_optical_frame_joint"
                     :parent-link r_forearm_cam_frame_lk :child-link r_forearm_cam_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_forearm_joint_fixed_jt
     (setq r_forearm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_forearm_joint"
                     :parent-link r_forearm_roll_link_lk :child-link r_forearm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_forearm_roll_joint_jt
     (setq r_forearm_roll_joint_jt
           (instance rotational-joint :init
                     :name "r_forearm_roll_joint"
                     :parent-link r_elbow_flex_link_lk :child-link r_forearm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 3.600000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: r_gripper_joint_jt
     (setq r_gripper_joint_jt
           (instance linear-joint :init
                     :name "r_gripper_joint"
                     :parent-link r_gripper_r_finger_tip_link_lk :child-link r_gripper_l_finger_tip_frame_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -10.000000 :max 88.000000
                     :max-joint-velocity 0.200000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_l_finger_joint_jt
     (setq r_gripper_l_finger_joint_jt
           (instance rotational-joint :init
                     :name "r_gripper_l_finger_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_l_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_l_finger_tip_joint_jt
     (setq r_gripper_l_finger_tip_joint_jt
           (instance rotational-joint :init
                     :name "r_gripper_l_finger_tip_joint"
                     :parent-link r_gripper_l_finger_link_lk :child-link r_gripper_l_finger_tip_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_led_joint_fixed_jt
     (setq r_gripper_led_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_gripper_led_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_led_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_gripper_motor_accelerometer_joint_fixed_jt
     (setq r_gripper_motor_accelerometer_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_gripper_motor_accelerometer_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_motor_accelerometer_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_gripper_motor_screw_joint_jt
     (setq r_gripper_motor_screw_joint_jt
           (instance rotational-joint :init
                     :name "r_gripper_motor_screw_joint"
                     :parent-link r_gripper_motor_slider_link_lk :child-link r_gripper_motor_screw_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_gripper_motor_slider_joint_jt
     (setq r_gripper_motor_slider_joint_jt
           (instance linear-joint :init
                     :name "r_gripper_motor_slider_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_motor_slider_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -100.000000 :max 100.000000
                     :max-joint-velocity 0.200000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_palm_joint_fixed_jt
     (setq r_gripper_palm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_gripper_palm_joint"
                     :parent-link r_wrist_roll_link_lk :child-link r_gripper_palm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_gripper_r_finger_joint_jt
     (setq r_gripper_r_finger_joint_jt
           (instance rotational-joint :init
                     :name "r_gripper_r_finger_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_r_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_r_finger_tip_joint_jt
     (setq r_gripper_r_finger_tip_joint_jt
           (instance rotational-joint :init
                     :name "r_gripper_r_finger_tip_joint"
                     :parent-link r_gripper_r_finger_link_lk :child-link r_gripper_r_finger_tip_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 0.000000 :max 31.398086
                     :max-joint-velocity 0.500000
                     :max-joint-torque 1000.000000
                     ))
     ;; joint: r_gripper_tool_joint_fixed_jt
     (setq r_gripper_tool_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_gripper_tool_joint"
                     :parent-link r_gripper_palm_link_lk :child-link r_gripper_tool_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_shoulder_lift_joint_jt
     (setq r_shoulder_lift_joint_jt
           (instance rotational-joint :init
                     :name "r_shoulder_lift_joint"
                     :parent-link r_shoulder_pan_link_lk :child-link r_shoulder_lift_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -20.259787 :max 74.272522
                     :max-joint-velocity 2.082000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: r_shoulder_pan_joint_jt
     (setq r_shoulder_pan_joint_jt
           (instance rotational-joint :init
                     :name "r_shoulder_pan_joint"
                     :parent-link torso_lift_link_lk :child-link r_shoulder_pan_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -122.349302 :max 32.349302
                     :max-joint-velocity 2.088000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: r_torso_lift_side_plate_joint_fixed_jt
     (setq r_torso_lift_side_plate_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_torso_lift_side_plate_joint"
                     :parent-link torso_lift_link_lk :child-link r_torso_lift_side_plate_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_upper_arm_joint_fixed_jt
     (setq r_upper_arm_joint_fixed_jt
           (instance rotational-joint :init
                     :name "r_upper_arm_joint"
                     :parent-link r_upper_arm_roll_link_lk :child-link r_upper_arm_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_upper_arm_roll_joint_jt
     (setq r_upper_arm_roll_joint_jt
           (instance rotational-joint :init
                     :name "r_upper_arm_roll_joint"
                     :parent-link r_shoulder_lift_link_lk :child-link r_upper_arm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -214.859173 :max 37.242255
                     :max-joint-velocity 3.270000
                     :max-joint-torque 30.000000
                     ))
     ;; joint: r_wrist_flex_joint_jt
     (setq r_wrist_flex_joint_jt
           (instance rotational-joint :init
                     :name "r_wrist_flex_joint"
                     :parent-link r_forearm_link_lk :child-link r_wrist_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -114.591559 :max -5.729578
                     :max-joint-velocity 3.078000
                     :max-joint-torque 10.000000
                     ))
     ;; joint: r_wrist_roll_joint_jt
     (setq r_wrist_roll_joint_jt
           (instance rotational-joint :init
                     :name "r_wrist_roll_joint"
                     :parent-link r_wrist_flex_link_lk :child-link r_wrist_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 3.600000
                     :max-joint-torque 10.000000
                     ))
     ;; joint: right_arm_chain_cb_fixed_jt
     (setq right_arm_chain_cb_fixed_jt
           (instance rotational-joint :init
                     :name "right_arm_chain_cb"
                     :parent-link r_wrist_roll_link_lk :child-link right_arm_chain_cb_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: sensor_mount_frame_joint_fixed_jt
     (setq sensor_mount_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "sensor_mount_frame_joint"
                     :parent-link head_plate_frame_lk :child-link sensor_mount_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: torso_lift_joint_jt
     (setq torso_lift_joint_jt
           (instance linear-joint :init
                     :name "torso_lift_joint"
                     :parent-link base_link_lk :child-link torso_lift_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 11.500000 :max 325.000000
                     :max-joint-velocity 0.013000
                     :max-joint-torque 10000.000000
                     ))
     ;; joint: torso_lift_motor_screw_joint_jt
     (setq torso_lift_motor_screw_joint_jt
           (instance rotational-joint :init
                     :name "torso_lift_motor_screw_joint"
                     :parent-link base_link_lk :child-link torso_lift_motor_screw_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_frame_joint_fixed_jt
     (setq wide_stereo_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_frame_joint"
                     :parent-link double_stereo_link_lk :child-link wide_stereo_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_l_stereo_camera_frame_joint_fixed_jt
     (setq wide_stereo_l_stereo_camera_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_l_stereo_camera_frame_joint"
                     :parent-link wide_stereo_link_lk :child-link wide_stereo_l_stereo_camera_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_l_stereo_camera_optical_frame_joint_fixed_jt
     (setq wide_stereo_l_stereo_camera_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_l_stereo_camera_optical_frame_joint"
                     :parent-link wide_stereo_l_stereo_camera_frame_lk :child-link wide_stereo_l_stereo_camera_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_optical_frame_joint_fixed_jt
     (setq wide_stereo_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_optical_frame_joint"
                     :parent-link wide_stereo_link_lk :child-link wide_stereo_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_r_stereo_camera_frame_joint_fixed_jt
     (setq wide_stereo_r_stereo_camera_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_r_stereo_camera_frame_joint"
                     :parent-link wide_stereo_l_stereo_camera_frame_lk :child-link wide_stereo_r_stereo_camera_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: wide_stereo_r_stereo_camera_optical_frame_joint_fixed_jt
     (setq wide_stereo_r_stereo_camera_optical_frame_joint_fixed_jt
           (instance rotational-joint :init
                     :name "wide_stereo_r_stereo_camera_optical_frame_joint"
                     :parent-link wide_stereo_r_stereo_camera_frame_lk :child-link wide_stereo_r_stereo_camera_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; end coords from yaml file
     (setq torso-end-coords (make-cascoords :coords (send torso_lift_link_lk :copy-worldcoords) :name :torso-end-coords))
     (send torso_lift_link_lk :assoc torso-end-coords)
     (setq larm-end-coords (make-cascoords :coords (send l_gripper_tool_frame_lk :copy-worldcoords) :name :larm-end-coords))
     (send larm-end-coords :rotate 0.0000000000000000e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send l_gripper_tool_frame_lk :assoc larm-end-coords)
     (setq rarm-end-coords (make-cascoords :coords (send r_gripper_tool_frame_lk :copy-worldcoords) :name :rarm-end-coords))
     (send rarm-end-coords :rotate 0.0000000000000000e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send r_gripper_tool_frame_lk :assoc rarm-end-coords)
     (setq head-end-coords (make-cascoords :coords (send head_tilt_link_lk :copy-worldcoords) :name :head-end-coords))
     (send head-end-coords :translate (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 1.3000000000000000e+02))
     (send head-end-coords :rotate 1.5707963267948966e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send head_tilt_link_lk :assoc head-end-coords)

     ;; limbs
     (setq torso (list torso_lift_link_lk))

     (setq torso-root-link
           (labels ((find-parent (l) (if (find (send l :parent) torso) (find-parent (send l :parent)) l)))
             (find-parent (car torso))))
     (setq larm (list l_shoulder_pan_link_lk l_shoulder_lift_link_lk l_upper_arm_roll_link_lk l_elbow_flex_link_lk l_forearm_roll_link_lk l_wrist_flex_link_lk l_wrist_roll_link_lk))

     (setq larm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) larm) (find-parent (send l :parent)) l)))
             (find-parent (car larm))))
     (setq rarm (list r_shoulder_pan_link_lk r_shoulder_lift_link_lk r_upper_arm_roll_link_lk r_elbow_flex_link_lk r_forearm_roll_link_lk r_wrist_flex_link_lk r_wrist_roll_link_lk))

     (setq rarm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rarm) (find-parent (send l :parent)) l)))
             (find-parent (car rarm))))
     (setq head (list head_pan_link_lk head_tilt_link_lk))

     (setq head-root-link
           (labels ((find-parent (l) (if (find (send l :parent) head) (find-parent (send l :parent)) l)))
             (find-parent (car head))))

     ;; links
     (setq links (list base_footprint_lk torso_lift_link_lk l_shoulder_pan_link_lk l_shoulder_lift_link_lk l_upper_arm_roll_link_lk l_elbow_flex_link_lk l_forearm_roll_link_lk l_wrist_flex_link_lk l_wrist_roll_link_lk r_shoulder_pan_link_lk r_shoulder_lift_link_lk r_upper_arm_roll_link_lk r_elbow_flex_link_lk r_forearm_roll_link_lk r_wrist_flex_link_lk r_wrist_roll_link_lk head_pan_link_lk head_tilt_link_lk))

     ;; joint-list
     (setq joint-list (list torso_lift_joint_jt l_shoulder_pan_joint_jt l_shoulder_lift_joint_jt l_upper_arm_roll_joint_jt l_elbow_flex_joint_jt l_forearm_roll_joint_jt l_wrist_flex_joint_jt l_wrist_roll_joint_jt r_shoulder_pan_joint_jt r_shoulder_lift_joint_jt r_upper_arm_roll_joint_jt r_elbow_flex_joint_jt r_forearm_roll_joint_jt r_wrist_flex_joint_jt r_wrist_roll_joint_jt head_pan_joint_jt head_tilt_joint_jt))

     ;; sensor-coords

     ;; attach_sensor lists
     (setq force-sensors (list ))
     (setq imu-sensors (list ))
     (setq cameras (list ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list base_bellow_link_lk base_footprint_lk base_laser_link_lk base_link_lk bl_caster_l_wheel_link_lk bl_caster_r_wheel_link_lk bl_caster_rotation_link_lk br_caster_l_wheel_link_lk br_caster_r_wheel_link_lk br_caster_rotation_link_lk double_stereo_link_lk fl_caster_l_wheel_link_lk fl_caster_r_wheel_link_lk fl_caster_rotation_link_lk fr_caster_l_wheel_link_lk fr_caster_r_wheel_link_lk fr_caster_rotation_link_lk head_chain_cb_link_lk head_mount_kinect_ir_link_lk head_mount_kinect_ir_optical_frame_lk head_mount_kinect_rgb_link_lk head_mount_kinect_rgb_optical_frame_lk head_mount_link_lk head_mount_prosilica_link_lk head_mount_prosilica_optical_frame_lk head_pan_link_lk head_plate_frame_lk head_tilt_link_lk high_def_frame_lk high_def_optical_frame_lk imu_link_lk l_elbow_flex_link_lk l_forearm_cam_frame_lk l_forearm_cam_optical_frame_lk l_forearm_link_lk l_forearm_roll_link_lk l_gripper_l_finger_link_lk l_gripper_l_finger_tip_frame_lk l_gripper_l_finger_tip_link_lk l_gripper_led_frame_lk l_gripper_motor_accelerometer_link_lk l_gripper_motor_screw_link_lk l_gripper_motor_slider_link_lk l_gripper_palm_link_lk l_gripper_r_finger_link_lk l_gripper_r_finger_tip_link_lk l_gripper_tool_frame_lk l_shoulder_lift_link_lk l_shoulder_pan_link_lk l_torso_lift_side_plate_link_lk l_upper_arm_link_lk l_upper_arm_roll_link_lk l_wrist_flex_link_lk l_wrist_roll_link_lk laser_tilt_link_lk laser_tilt_mount_link_lk left_arm_chain_cb_link_lk narrow_stereo_l_stereo_camera_frame_lk narrow_stereo_l_stereo_camera_optical_frame_lk narrow_stereo_link_lk narrow_stereo_optical_frame_lk narrow_stereo_r_stereo_camera_frame_lk narrow_stereo_r_stereo_camera_optical_frame_lk projector_wg6802418_child_frame_lk projector_wg6802418_frame_lk r_elbow_flex_link_lk r_forearm_cam_frame_lk r_forearm_cam_optical_frame_lk r_forearm_link_lk r_forearm_roll_link_lk r_gripper_l_finger_link_lk r_gripper_l_finger_tip_frame_lk r_gripper_l_finger_tip_link_lk r_gripper_led_frame_lk r_gripper_motor_accelerometer_link_lk r_gripper_motor_screw_link_lk r_gripper_motor_slider_link_lk r_gripper_palm_link_lk r_gripper_r_finger_link_lk r_gripper_r_finger_tip_link_lk r_gripper_tool_frame_lk r_shoulder_lift_link_lk r_shoulder_pan_link_lk r_torso_lift_side_plate_link_lk r_upper_arm_link_lk r_upper_arm_roll_link_lk r_wrist_flex_link_lk r_wrist_roll_link_lk right_arm_chain_cb_link_lk sensor_mount_link_lk torso_lift_link_lk torso_lift_motor_screw_link_lk wide_stereo_l_stereo_camera_frame_lk wide_stereo_l_stereo_camera_optical_frame_lk wide_stereo_link_lk wide_stereo_optical_frame_lk wide_stereo_r_stereo_camera_frame_lk wide_stereo_r_stereo_camera_optical_frame_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init

  ;; pre-defined pose methods

    (:reset-manip-pose (&optional (limbs '(:torso :larm :rarm :head)))
      "Predefined pose named reset-manip-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:torso (send self limb :angle-vector (float-vector 300.000000)))
          (:larm (send self limb :angle-vector (float-vector 75.000000 50.000000 110.000000 -110.000000 -20.000000 -10.000000 -10.000000)))
          (:rarm (send self limb :angle-vector (float-vector -75.000000 50.000000 -110.000000 -110.000000 20.000000 -10.000000 -10.000000)))
          (:head (send self limb :angle-vector (float-vector 0.000000 50.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
    (:reset-pose (&optional (limbs '(:torso :larm :rarm :head)))
      "Predefined pose named reset-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:torso (send self limb :angle-vector (float-vector 50.000000)))
          (:larm (send self limb :angle-vector (float-vector 60.000000 74.000000 70.000000 -120.000000 20.000000 -30.000000 180.000000)))
          (:rarm (send self limb :angle-vector (float-vector -60.000000 74.000000 -70.000000 -120.000000 -20.000000 -30.000000 180.000000)))
          (:head (send self limb :angle-vector (float-vector 0.000000 0.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
  ;; all joints
  (:base_bellow_joint (&rest args) (forward-message-to base_bellow_joint_fixed_jt args))
  (:base_footprint_joint (&rest args) (forward-message-to base_footprint_joint_fixed_jt args))
  (:base_laser_joint (&rest args) (forward-message-to base_laser_joint_fixed_jt args))
  (:bl_caster_l_wheel_joint (&rest args) (forward-message-to bl_caster_l_wheel_joint_jt args))
  (:bl_caster_r_wheel_joint (&rest args) (forward-message-to bl_caster_r_wheel_joint_jt args))
  (:bl_caster_rotation_joint (&rest args) (forward-message-to bl_caster_rotation_joint_jt args))
  (:br_caster_l_wheel_joint (&rest args) (forward-message-to br_caster_l_wheel_joint_jt args))
  (:br_caster_r_wheel_joint (&rest args) (forward-message-to br_caster_r_wheel_joint_jt args))
  (:br_caster_rotation_joint (&rest args) (forward-message-to br_caster_rotation_joint_jt args))
  (:double_stereo_frame_joint (&rest args) (forward-message-to double_stereo_frame_joint_fixed_jt args))
  (:fl_caster_l_wheel_joint (&rest args) (forward-message-to fl_caster_l_wheel_joint_jt args))
  (:fl_caster_r_wheel_joint (&rest args) (forward-message-to fl_caster_r_wheel_joint_jt args))
  (:fl_caster_rotation_joint (&rest args) (forward-message-to fl_caster_rotation_joint_jt args))
  (:fr_caster_l_wheel_joint (&rest args) (forward-message-to fr_caster_l_wheel_joint_jt args))
  (:fr_caster_r_wheel_joint (&rest args) (forward-message-to fr_caster_r_wheel_joint_jt args))
  (:fr_caster_rotation_joint (&rest args) (forward-message-to fr_caster_rotation_joint_jt args))
  (:head_chain_cb (&rest args) (forward-message-to head_chain_cb_fixed_jt args))
  (:head_mount_joint (&rest args) (forward-message-to head_mount_joint_fixed_jt args))
  (:head_mount_kinect_ir_joint (&rest args) (forward-message-to head_mount_kinect_ir_joint_fixed_jt args))
  (:head_mount_kinect_ir_optical_frame_joint (&rest args) (forward-message-to head_mount_kinect_ir_optical_frame_joint_fixed_jt args))
  (:head_mount_kinect_rgb_joint (&rest args) (forward-message-to head_mount_kinect_rgb_joint_fixed_jt args))
  (:head_mount_kinect_rgb_optical_frame_joint (&rest args) (forward-message-to head_mount_kinect_rgb_optical_frame_joint_fixed_jt args))
  (:head_mount_prosilica_joint (&rest args) (forward-message-to head_mount_prosilica_joint_fixed_jt args))
  (:head_mount_prosilica_optical_frame_joint (&rest args) (forward-message-to head_mount_prosilica_optical_frame_joint_fixed_jt args))
  (:head_pan_joint (&rest args) (forward-message-to head_pan_joint_jt args))
  (:head_plate_frame_joint (&rest args) (forward-message-to head_plate_frame_joint_fixed_jt args))
  (:head_tilt_joint (&rest args) (forward-message-to head_tilt_joint_jt args))
  (:high_def_frame_joint (&rest args) (forward-message-to high_def_frame_joint_fixed_jt args))
  (:high_def_optical_frame_joint (&rest args) (forward-message-to high_def_optical_frame_joint_fixed_jt args))
  (:imu_joint (&rest args) (forward-message-to imu_joint_fixed_jt args))
  (:l_elbow_flex_joint (&rest args) (forward-message-to l_elbow_flex_joint_jt args))
  (:l_forearm_cam_frame_joint (&rest args) (forward-message-to l_forearm_cam_frame_joint_fixed_jt args))
  (:l_forearm_cam_optical_frame_joint (&rest args) (forward-message-to l_forearm_cam_optical_frame_joint_fixed_jt args))
  (:l_forearm_joint (&rest args) (forward-message-to l_forearm_joint_fixed_jt args))
  (:l_forearm_roll_joint (&rest args) (forward-message-to l_forearm_roll_joint_jt args))
  (:l_gripper_joint (&rest args) (forward-message-to l_gripper_joint_jt args))
  (:l_gripper_l_finger_joint (&rest args) (forward-message-to l_gripper_l_finger_joint_jt args))
  (:l_gripper_l_finger_tip_joint (&rest args) (forward-message-to l_gripper_l_finger_tip_joint_jt args))
  (:l_gripper_led_joint (&rest args) (forward-message-to l_gripper_led_joint_fixed_jt args))
  (:l_gripper_motor_accelerometer_joint (&rest args) (forward-message-to l_gripper_motor_accelerometer_joint_fixed_jt args))
  (:l_gripper_motor_screw_joint (&rest args) (forward-message-to l_gripper_motor_screw_joint_jt args))
  (:l_gripper_motor_slider_joint (&rest args) (forward-message-to l_gripper_motor_slider_joint_jt args))
  (:l_gripper_palm_joint (&rest args) (forward-message-to l_gripper_palm_joint_fixed_jt args))
  (:l_gripper_r_finger_joint (&rest args) (forward-message-to l_gripper_r_finger_joint_jt args))
  (:l_gripper_r_finger_tip_joint (&rest args) (forward-message-to l_gripper_r_finger_tip_joint_jt args))
  (:l_gripper_tool_joint (&rest args) (forward-message-to l_gripper_tool_joint_fixed_jt args))
  (:l_shoulder_lift_joint (&rest args) (forward-message-to l_shoulder_lift_joint_jt args))
  (:l_shoulder_pan_joint (&rest args) (forward-message-to l_shoulder_pan_joint_jt args))
  (:l_torso_lift_side_plate_joint (&rest args) (forward-message-to l_torso_lift_side_plate_joint_fixed_jt args))
  (:l_upper_arm_joint (&rest args) (forward-message-to l_upper_arm_joint_fixed_jt args))
  (:l_upper_arm_roll_joint (&rest args) (forward-message-to l_upper_arm_roll_joint_jt args))
  (:l_wrist_flex_joint (&rest args) (forward-message-to l_wrist_flex_joint_jt args))
  (:l_wrist_roll_joint (&rest args) (forward-message-to l_wrist_roll_joint_jt args))
  (:laser_tilt_joint (&rest args) (forward-message-to laser_tilt_joint_fixed_jt args))
  (:laser_tilt_mount_joint (&rest args) (forward-message-to laser_tilt_mount_joint_jt args))
  (:left_arm_chain_cb (&rest args) (forward-message-to left_arm_chain_cb_fixed_jt args))
  (:narrow_stereo_frame_joint (&rest args) (forward-message-to narrow_stereo_frame_joint_fixed_jt args))
  (:narrow_stereo_l_stereo_camera_frame_joint (&rest args) (forward-message-to narrow_stereo_l_stereo_camera_frame_joint_fixed_jt args))
  (:narrow_stereo_l_stereo_camera_optical_frame_joint (&rest args) (forward-message-to narrow_stereo_l_stereo_camera_optical_frame_joint_fixed_jt args))
  (:narrow_stereo_optical_frame_joint (&rest args) (forward-message-to narrow_stereo_optical_frame_joint_fixed_jt args))
  (:narrow_stereo_r_stereo_camera_frame_joint (&rest args) (forward-message-to narrow_stereo_r_stereo_camera_frame_joint_fixed_jt args))
  (:narrow_stereo_r_stereo_camera_optical_frame_joint (&rest args) (forward-message-to narrow_stereo_r_stereo_camera_optical_frame_joint_fixed_jt args))
  (:projector_wg6802418_child_frame_joint (&rest args) (forward-message-to projector_wg6802418_child_frame_joint_fixed_jt args))
  (:projector_wg6802418_frame_joint (&rest args) (forward-message-to projector_wg6802418_frame_joint_fixed_jt args))
  (:r_elbow_flex_joint (&rest args) (forward-message-to r_elbow_flex_joint_jt args))
  (:r_forearm_cam_frame_joint (&rest args) (forward-message-to r_forearm_cam_frame_joint_fixed_jt args))
  (:r_forearm_cam_optical_frame_joint (&rest args) (forward-message-to r_forearm_cam_optical_frame_joint_fixed_jt args))
  (:r_forearm_joint (&rest args) (forward-message-to r_forearm_joint_fixed_jt args))
  (:r_forearm_roll_joint (&rest args) (forward-message-to r_forearm_roll_joint_jt args))
  (:r_gripper_joint (&rest args) (forward-message-to r_gripper_joint_jt args))
  (:r_gripper_l_finger_joint (&rest args) (forward-message-to r_gripper_l_finger_joint_jt args))
  (:r_gripper_l_finger_tip_joint (&rest args) (forward-message-to r_gripper_l_finger_tip_joint_jt args))
  (:r_gripper_led_joint (&rest args) (forward-message-to r_gripper_led_joint_fixed_jt args))
  (:r_gripper_motor_accelerometer_joint (&rest args) (forward-message-to r_gripper_motor_accelerometer_joint_fixed_jt args))
  (:r_gripper_motor_screw_joint (&rest args) (forward-message-to r_gripper_motor_screw_joint_jt args))
  (:r_gripper_motor_slider_joint (&rest args) (forward-message-to r_gripper_motor_slider_joint_jt args))
  (:r_gripper_palm_joint (&rest args) (forward-message-to r_gripper_palm_joint_fixed_jt args))
  (:r_gripper_r_finger_joint (&rest args) (forward-message-to r_gripper_r_finger_joint_jt args))
  (:r_gripper_r_finger_tip_joint (&rest args) (forward-message-to r_gripper_r_finger_tip_joint_jt args))
  (:r_gripper_tool_joint (&rest args) (forward-message-to r_gripper_tool_joint_fixed_jt args))
  (:r_shoulder_lift_joint (&rest args) (forward-message-to r_shoulder_lift_joint_jt args))
  (:r_shoulder_pan_joint (&rest args) (forward-message-to r_shoulder_pan_joint_jt args))
  (:r_torso_lift_side_plate_joint (&rest args) (forward-message-to r_torso_lift_side_plate_joint_fixed_jt args))
  (:r_upper_arm_joint (&rest args) (forward-message-to r_upper_arm_joint_fixed_jt args))
  (:r_upper_arm_roll_joint (&rest args) (forward-message-to r_upper_arm_roll_joint_jt args))
  (:r_wrist_flex_joint (&rest args) (forward-message-to r_wrist_flex_joint_jt args))
  (:r_wrist_roll_joint (&rest args) (forward-message-to r_wrist_roll_joint_jt args))
  (:right_arm_chain_cb (&rest args) (forward-message-to right_arm_chain_cb_fixed_jt args))
  (:sensor_mount_frame_joint (&rest args) (forward-message-to sensor_mount_frame_joint_fixed_jt args))
  (:torso_lift_joint (&rest args) (forward-message-to torso_lift_joint_jt args))
  (:torso_lift_motor_screw_joint (&rest args) (forward-message-to torso_lift_motor_screw_joint_jt args))
  (:wide_stereo_frame_joint (&rest args) (forward-message-to wide_stereo_frame_joint_fixed_jt args))
  (:wide_stereo_l_stereo_camera_frame_joint (&rest args) (forward-message-to wide_stereo_l_stereo_camera_frame_joint_fixed_jt args))
  (:wide_stereo_l_stereo_camera_optical_frame_joint (&rest args) (forward-message-to wide_stereo_l_stereo_camera_optical_frame_joint_fixed_jt args))
  (:wide_stereo_optical_frame_joint (&rest args) (forward-message-to wide_stereo_optical_frame_joint_fixed_jt args))
  (:wide_stereo_r_stereo_camera_frame_joint (&rest args) (forward-message-to wide_stereo_r_stereo_camera_frame_joint_fixed_jt args))
  (:wide_stereo_r_stereo_camera_optical_frame_joint (&rest args) (forward-message-to wide_stereo_r_stereo_camera_optical_frame_joint_fixed_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:base_bellow_link (forward-message-to base_bellow_link_lk nargs))
       (:base_footprint (forward-message-to base_footprint_lk nargs))
       (:base_laser_link (forward-message-to base_laser_link_lk nargs))
       (:base_link (forward-message-to base_link_lk nargs))
       (:bl_caster_l_wheel_link (forward-message-to bl_caster_l_wheel_link_lk nargs))
       (:bl_caster_r_wheel_link (forward-message-to bl_caster_r_wheel_link_lk nargs))
       (:bl_caster_rotation_link (forward-message-to bl_caster_rotation_link_lk nargs))
       (:br_caster_l_wheel_link (forward-message-to br_caster_l_wheel_link_lk nargs))
       (:br_caster_r_wheel_link (forward-message-to br_caster_r_wheel_link_lk nargs))
       (:br_caster_rotation_link (forward-message-to br_caster_rotation_link_lk nargs))
       (:double_stereo_link (forward-message-to double_stereo_link_lk nargs))
       (:fl_caster_l_wheel_link (forward-message-to fl_caster_l_wheel_link_lk nargs))
       (:fl_caster_r_wheel_link (forward-message-to fl_caster_r_wheel_link_lk nargs))
       (:fl_caster_rotation_link (forward-message-to fl_caster_rotation_link_lk nargs))
       (:fr_caster_l_wheel_link (forward-message-to fr_caster_l_wheel_link_lk nargs))
       (:fr_caster_r_wheel_link (forward-message-to fr_caster_r_wheel_link_lk nargs))
       (:fr_caster_rotation_link (forward-message-to fr_caster_rotation_link_lk nargs))
       (:head_chain_cb_link (forward-message-to head_chain_cb_link_lk nargs))
       (:head_mount_kinect_ir_link (forward-message-to head_mount_kinect_ir_link_lk nargs))
       (:head_mount_kinect_ir_optical_frame (forward-message-to head_mount_kinect_ir_optical_frame_lk nargs))
       (:head_mount_kinect_rgb_link (forward-message-to head_mount_kinect_rgb_link_lk nargs))
       (:head_mount_kinect_rgb_optical_frame (forward-message-to head_mount_kinect_rgb_optical_frame_lk nargs))
       (:head_mount_link (forward-message-to head_mount_link_lk nargs))
       (:head_mount_prosilica_link (forward-message-to head_mount_prosilica_link_lk nargs))
       (:head_mount_prosilica_optical_frame (forward-message-to head_mount_prosilica_optical_frame_lk nargs))
       (:head_pan_link (forward-message-to head_pan_link_lk nargs))
       (:head_plate_frame (forward-message-to head_plate_frame_lk nargs))
       (:head_tilt_link (forward-message-to head_tilt_link_lk nargs))
       (:high_def_frame (forward-message-to high_def_frame_lk nargs))
       (:high_def_optical_frame (forward-message-to high_def_optical_frame_lk nargs))
       (:imu_link (forward-message-to imu_link_lk nargs))
       (:l_elbow_flex_link (forward-message-to l_elbow_flex_link_lk nargs))
       (:l_forearm_cam_frame (forward-message-to l_forearm_cam_frame_lk nargs))
       (:l_forearm_cam_optical_frame (forward-message-to l_forearm_cam_optical_frame_lk nargs))
       (:l_forearm_link (forward-message-to l_forearm_link_lk nargs))
       (:l_forearm_roll_link (forward-message-to l_forearm_roll_link_lk nargs))
       (:l_gripper_l_finger_link (forward-message-to l_gripper_l_finger_link_lk nargs))
       (:l_gripper_l_finger_tip_frame (forward-message-to l_gripper_l_finger_tip_frame_lk nargs))
       (:l_gripper_l_finger_tip_link (forward-message-to l_gripper_l_finger_tip_link_lk nargs))
       (:l_gripper_led_frame (forward-message-to l_gripper_led_frame_lk nargs))
       (:l_gripper_motor_accelerometer_link (forward-message-to l_gripper_motor_accelerometer_link_lk nargs))
       (:l_gripper_motor_screw_link (forward-message-to l_gripper_motor_screw_link_lk nargs))
       (:l_gripper_motor_slider_link (forward-message-to l_gripper_motor_slider_link_lk nargs))
       (:l_gripper_palm_link (forward-message-to l_gripper_palm_link_lk nargs))
       (:l_gripper_r_finger_link (forward-message-to l_gripper_r_finger_link_lk nargs))
       (:l_gripper_r_finger_tip_link (forward-message-to l_gripper_r_finger_tip_link_lk nargs))
       (:l_gripper_tool_frame (forward-message-to l_gripper_tool_frame_lk nargs))
       (:l_shoulder_lift_link (forward-message-to l_shoulder_lift_link_lk nargs))
       (:l_shoulder_pan_link (forward-message-to l_shoulder_pan_link_lk nargs))
       (:l_torso_lift_side_plate_link (forward-message-to l_torso_lift_side_plate_link_lk nargs))
       (:l_upper_arm_link (forward-message-to l_upper_arm_link_lk nargs))
       (:l_upper_arm_roll_link (forward-message-to l_upper_arm_roll_link_lk nargs))
       (:l_wrist_flex_link (forward-message-to l_wrist_flex_link_lk nargs))
       (:l_wrist_roll_link (forward-message-to l_wrist_roll_link_lk nargs))
       (:laser_tilt_link (forward-message-to laser_tilt_link_lk nargs))
       (:laser_tilt_mount_link (forward-message-to laser_tilt_mount_link_lk nargs))
       (:left_arm_chain_cb_link (forward-message-to left_arm_chain_cb_link_lk nargs))
       (:narrow_stereo_l_stereo_camera_frame (forward-message-to narrow_stereo_l_stereo_camera_frame_lk nargs))
       (:narrow_stereo_l_stereo_camera_optical_frame (forward-message-to narrow_stereo_l_stereo_camera_optical_frame_lk nargs))
       (:narrow_stereo_link (forward-message-to narrow_stereo_link_lk nargs))
       (:narrow_stereo_optical_frame (forward-message-to narrow_stereo_optical_frame_lk nargs))
       (:narrow_stereo_r_stereo_camera_frame (forward-message-to narrow_stereo_r_stereo_camera_frame_lk nargs))
       (:narrow_stereo_r_stereo_camera_optical_frame (forward-message-to narrow_stereo_r_stereo_camera_optical_frame_lk nargs))
       (:projector_wg6802418_child_frame (forward-message-to projector_wg6802418_child_frame_lk nargs))
       (:projector_wg6802418_frame (forward-message-to projector_wg6802418_frame_lk nargs))
       (:r_elbow_flex_link (forward-message-to r_elbow_flex_link_lk nargs))
       (:r_forearm_cam_frame (forward-message-to r_forearm_cam_frame_lk nargs))
       (:r_forearm_cam_optical_frame (forward-message-to r_forearm_cam_optical_frame_lk nargs))
       (:r_forearm_link (forward-message-to r_forearm_link_lk nargs))
       (:r_forearm_roll_link (forward-message-to r_forearm_roll_link_lk nargs))
       (:r_gripper_l_finger_link (forward-message-to r_gripper_l_finger_link_lk nargs))
       (:r_gripper_l_finger_tip_frame (forward-message-to r_gripper_l_finger_tip_frame_lk nargs))
       (:r_gripper_l_finger_tip_link (forward-message-to r_gripper_l_finger_tip_link_lk nargs))
       (:r_gripper_led_frame (forward-message-to r_gripper_led_frame_lk nargs))
       (:r_gripper_motor_accelerometer_link (forward-message-to r_gripper_motor_accelerometer_link_lk nargs))
       (:r_gripper_motor_screw_link (forward-message-to r_gripper_motor_screw_link_lk nargs))
       (:r_gripper_motor_slider_link (forward-message-to r_gripper_motor_slider_link_lk nargs))
       (:r_gripper_palm_link (forward-message-to r_gripper_palm_link_lk nargs))
       (:r_gripper_r_finger_link (forward-message-to r_gripper_r_finger_link_lk nargs))
       (:r_gripper_r_finger_tip_link (forward-message-to r_gripper_r_finger_tip_link_lk nargs))
       (:r_gripper_tool_frame (forward-message-to r_gripper_tool_frame_lk nargs))
       (:r_shoulder_lift_link (forward-message-to r_shoulder_lift_link_lk nargs))
       (:r_shoulder_pan_link (forward-message-to r_shoulder_pan_link_lk nargs))
       (:r_torso_lift_side_plate_link (forward-message-to r_torso_lift_side_plate_link_lk nargs))
       (:r_upper_arm_link (forward-message-to r_upper_arm_link_lk nargs))
       (:r_upper_arm_roll_link (forward-message-to r_upper_arm_roll_link_lk nargs))
       (:r_wrist_flex_link (forward-message-to r_wrist_flex_link_lk nargs))
       (:r_wrist_roll_link (forward-message-to r_wrist_roll_link_lk nargs))
       (:right_arm_chain_cb_link (forward-message-to right_arm_chain_cb_link_lk nargs))
       (:sensor_mount_link (forward-message-to sensor_mount_link_lk nargs))
       (:torso_lift_link (forward-message-to torso_lift_link_lk nargs))
       (:torso_lift_motor_screw_link (forward-message-to torso_lift_motor_screw_link_lk nargs))
       (:wide_stereo_l_stereo_camera_frame (forward-message-to wide_stereo_l_stereo_camera_frame_lk nargs))
       (:wide_stereo_l_stereo_camera_optical_frame (forward-message-to wide_stereo_l_stereo_camera_optical_frame_lk nargs))
       (:wide_stereo_link (forward-message-to wide_stereo_link_lk nargs))
       (:wide_stereo_optical_frame (forward-message-to wide_stereo_optical_frame_lk nargs))
       (:wide_stereo_r_stereo_camera_frame (forward-message-to wide_stereo_r_stereo_camera_frame_lk nargs))
       (:wide_stereo_r_stereo_camera_optical_frame (forward-message-to wide_stereo_r_stereo_camera_optical_frame_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:base_bellow_link_lk (&rest args) (forward-message-to base_bellow_link_lk args))
  (:base_footprint_lk (&rest args) (forward-message-to base_footprint_lk args))
  (:base_laser_link_lk (&rest args) (forward-message-to base_laser_link_lk args))
  (:base_link_lk (&rest args) (forward-message-to base_link_lk args))
  (:bl_caster_l_wheel_link_lk (&rest args) (forward-message-to bl_caster_l_wheel_link_lk args))
  (:bl_caster_r_wheel_link_lk (&rest args) (forward-message-to bl_caster_r_wheel_link_lk args))
  (:bl_caster_rotation_link_lk (&rest args) (forward-message-to bl_caster_rotation_link_lk args))
  (:br_caster_l_wheel_link_lk (&rest args) (forward-message-to br_caster_l_wheel_link_lk args))
  (:br_caster_r_wheel_link_lk (&rest args) (forward-message-to br_caster_r_wheel_link_lk args))
  (:br_caster_rotation_link_lk (&rest args) (forward-message-to br_caster_rotation_link_lk args))
  (:double_stereo_link_lk (&rest args) (forward-message-to double_stereo_link_lk args))
  (:fl_caster_l_wheel_link_lk (&rest args) (forward-message-to fl_caster_l_wheel_link_lk args))
  (:fl_caster_r_wheel_link_lk (&rest args) (forward-message-to fl_caster_r_wheel_link_lk args))
  (:fl_caster_rotation_link_lk (&rest args) (forward-message-to fl_caster_rotation_link_lk args))
  (:fr_caster_l_wheel_link_lk (&rest args) (forward-message-to fr_caster_l_wheel_link_lk args))
  (:fr_caster_r_wheel_link_lk (&rest args) (forward-message-to fr_caster_r_wheel_link_lk args))
  (:fr_caster_rotation_link_lk (&rest args) (forward-message-to fr_caster_rotation_link_lk args))
  (:head_chain_cb_link_lk (&rest args) (forward-message-to head_chain_cb_link_lk args))
  (:head_mount_kinect_ir_link_lk (&rest args) (forward-message-to head_mount_kinect_ir_link_lk args))
  (:head_mount_kinect_ir_optical_frame_lk (&rest args) (forward-message-to head_mount_kinect_ir_optical_frame_lk args))
  (:head_mount_kinect_rgb_link_lk (&rest args) (forward-message-to head_mount_kinect_rgb_link_lk args))
  (:head_mount_kinect_rgb_optical_frame_lk (&rest args) (forward-message-to head_mount_kinect_rgb_optical_frame_lk args))
  (:head_mount_link_lk (&rest args) (forward-message-to head_mount_link_lk args))
  (:head_mount_prosilica_link_lk (&rest args) (forward-message-to head_mount_prosilica_link_lk args))
  (:head_mount_prosilica_optical_frame_lk (&rest args) (forward-message-to head_mount_prosilica_optical_frame_lk args))
  (:head_pan_link_lk (&rest args) (forward-message-to head_pan_link_lk args))
  (:head_plate_frame_lk (&rest args) (forward-message-to head_plate_frame_lk args))
  (:head_tilt_link_lk (&rest args) (forward-message-to head_tilt_link_lk args))
  (:high_def_frame_lk (&rest args) (forward-message-to high_def_frame_lk args))
  (:high_def_optical_frame_lk (&rest args) (forward-message-to high_def_optical_frame_lk args))
  (:imu_link_lk (&rest args) (forward-message-to imu_link_lk args))
  (:l_elbow_flex_link_lk (&rest args) (forward-message-to l_elbow_flex_link_lk args))
  (:l_forearm_cam_frame_lk (&rest args) (forward-message-to l_forearm_cam_frame_lk args))
  (:l_forearm_cam_optical_frame_lk (&rest args) (forward-message-to l_forearm_cam_optical_frame_lk args))
  (:l_forearm_link_lk (&rest args) (forward-message-to l_forearm_link_lk args))
  (:l_forearm_roll_link_lk (&rest args) (forward-message-to l_forearm_roll_link_lk args))
  (:l_gripper_l_finger_link_lk (&rest args) (forward-message-to l_gripper_l_finger_link_lk args))
  (:l_gripper_l_finger_tip_frame_lk (&rest args) (forward-message-to l_gripper_l_finger_tip_frame_lk args))
  (:l_gripper_l_finger_tip_link_lk (&rest args) (forward-message-to l_gripper_l_finger_tip_link_lk args))
  (:l_gripper_led_frame_lk (&rest args) (forward-message-to l_gripper_led_frame_lk args))
  (:l_gripper_motor_accelerometer_link_lk (&rest args) (forward-message-to l_gripper_motor_accelerometer_link_lk args))
  (:l_gripper_motor_screw_link_lk (&rest args) (forward-message-to l_gripper_motor_screw_link_lk args))
  (:l_gripper_motor_slider_link_lk (&rest args) (forward-message-to l_gripper_motor_slider_link_lk args))
  (:l_gripper_palm_link_lk (&rest args) (forward-message-to l_gripper_palm_link_lk args))
  (:l_gripper_r_finger_link_lk (&rest args) (forward-message-to l_gripper_r_finger_link_lk args))
  (:l_gripper_r_finger_tip_link_lk (&rest args) (forward-message-to l_gripper_r_finger_tip_link_lk args))
  (:l_gripper_tool_frame_lk (&rest args) (forward-message-to l_gripper_tool_frame_lk args))
  (:l_shoulder_lift_link_lk (&rest args) (forward-message-to l_shoulder_lift_link_lk args))
  (:l_shoulder_pan_link_lk (&rest args) (forward-message-to l_shoulder_pan_link_lk args))
  (:l_torso_lift_side_plate_link_lk (&rest args) (forward-message-to l_torso_lift_side_plate_link_lk args))
  (:l_upper_arm_link_lk (&rest args) (forward-message-to l_upper_arm_link_lk args))
  (:l_upper_arm_roll_link_lk (&rest args) (forward-message-to l_upper_arm_roll_link_lk args))
  (:l_wrist_flex_link_lk (&rest args) (forward-message-to l_wrist_flex_link_lk args))
  (:l_wrist_roll_link_lk (&rest args) (forward-message-to l_wrist_roll_link_lk args))
  (:laser_tilt_link_lk (&rest args) (forward-message-to laser_tilt_link_lk args))
  (:laser_tilt_mount_link_lk (&rest args) (forward-message-to laser_tilt_mount_link_lk args))
  (:left_arm_chain_cb_link_lk (&rest args) (forward-message-to left_arm_chain_cb_link_lk args))
  (:narrow_stereo_l_stereo_camera_frame_lk (&rest args) (forward-message-to narrow_stereo_l_stereo_camera_frame_lk args))
  (:narrow_stereo_l_stereo_camera_optical_frame_lk (&rest args) (forward-message-to narrow_stereo_l_stereo_camera_optical_frame_lk args))
  (:narrow_stereo_link_lk (&rest args) (forward-message-to narrow_stereo_link_lk args))
  (:narrow_stereo_optical_frame_lk (&rest args) (forward-message-to narrow_stereo_optical_frame_lk args))
  (:narrow_stereo_r_stereo_camera_frame_lk (&rest args) (forward-message-to narrow_stereo_r_stereo_camera_frame_lk args))
  (:narrow_stereo_r_stereo_camera_optical_frame_lk (&rest args) (forward-message-to narrow_stereo_r_stereo_camera_optical_frame_lk args))
  (:projector_wg6802418_child_frame_lk (&rest args) (forward-message-to projector_wg6802418_child_frame_lk args))
  (:projector_wg6802418_frame_lk (&rest args) (forward-message-to projector_wg6802418_frame_lk args))
  (:r_elbow_flex_link_lk (&rest args) (forward-message-to r_elbow_flex_link_lk args))
  (:r_forearm_cam_frame_lk (&rest args) (forward-message-to r_forearm_cam_frame_lk args))
  (:r_forearm_cam_optical_frame_lk (&rest args) (forward-message-to r_forearm_cam_optical_frame_lk args))
  (:r_forearm_link_lk (&rest args) (forward-message-to r_forearm_link_lk args))
  (:r_forearm_roll_link_lk (&rest args) (forward-message-to r_forearm_roll_link_lk args))
  (:r_gripper_l_finger_link_lk (&rest args) (forward-message-to r_gripper_l_finger_link_lk args))
  (:r_gripper_l_finger_tip_frame_lk (&rest args) (forward-message-to r_gripper_l_finger_tip_frame_lk args))
  (:r_gripper_l_finger_tip_link_lk (&rest args) (forward-message-to r_gripper_l_finger_tip_link_lk args))
  (:r_gripper_led_frame_lk (&rest args) (forward-message-to r_gripper_led_frame_lk args))
  (:r_gripper_motor_accelerometer_link_lk (&rest args) (forward-message-to r_gripper_motor_accelerometer_link_lk args))
  (:r_gripper_motor_screw_link_lk (&rest args) (forward-message-to r_gripper_motor_screw_link_lk args))
  (:r_gripper_motor_slider_link_lk (&rest args) (forward-message-to r_gripper_motor_slider_link_lk args))
  (:r_gripper_palm_link_lk (&rest args) (forward-message-to r_gripper_palm_link_lk args))
  (:r_gripper_r_finger_link_lk (&rest args) (forward-message-to r_gripper_r_finger_link_lk args))
  (:r_gripper_r_finger_tip_link_lk (&rest args) (forward-message-to r_gripper_r_finger_tip_link_lk args))
  (:r_gripper_tool_frame_lk (&rest args) (forward-message-to r_gripper_tool_frame_lk args))
  (:r_shoulder_lift_link_lk (&rest args) (forward-message-to r_shoulder_lift_link_lk args))
  (:r_shoulder_pan_link_lk (&rest args) (forward-message-to r_shoulder_pan_link_lk args))
  (:r_torso_lift_side_plate_link_lk (&rest args) (forward-message-to r_torso_lift_side_plate_link_lk args))
  (:r_upper_arm_link_lk (&rest args) (forward-message-to r_upper_arm_link_lk args))
  (:r_upper_arm_roll_link_lk (&rest args) (forward-message-to r_upper_arm_roll_link_lk args))
  (:r_wrist_flex_link_lk (&rest args) (forward-message-to r_wrist_flex_link_lk args))
  (:r_wrist_roll_link_lk (&rest args) (forward-message-to r_wrist_roll_link_lk args))
  (:right_arm_chain_cb_link_lk (&rest args) (forward-message-to right_arm_chain_cb_link_lk args))
  (:sensor_mount_link_lk (&rest args) (forward-message-to sensor_mount_link_lk args))
  (:torso_lift_link_lk (&rest args) (forward-message-to torso_lift_link_lk args))
  (:torso_lift_motor_screw_link_lk (&rest args) (forward-message-to torso_lift_motor_screw_link_lk args))
  (:wide_stereo_l_stereo_camera_frame_lk (&rest args) (forward-message-to wide_stereo_l_stereo_camera_frame_lk args))
  (:wide_stereo_l_stereo_camera_optical_frame_lk (&rest args) (forward-message-to wide_stereo_l_stereo_camera_optical_frame_lk args))
  (:wide_stereo_link_lk (&rest args) (forward-message-to wide_stereo_link_lk args))
  (:wide_stereo_optical_frame_lk (&rest args) (forward-message-to wide_stereo_optical_frame_lk args))
  (:wide_stereo_r_stereo_camera_frame_lk (&rest args) (forward-message-to wide_stereo_r_stereo_camera_frame_lk args))
  (:wide_stereo_r_stereo_camera_optical_frame_lk (&rest args) (forward-message-to wide_stereo_r_stereo_camera_optical_frame_lk args))

  ;; user-defined joint
  (:torso-waist-z (&rest args) (forward-message-to torso_lift_joint_jt args))
  (:larm-collar-y (&rest args) (forward-message-to l_shoulder_pan_joint_jt args))
  (:larm-shoulder-p (&rest args) (forward-message-to l_shoulder_lift_joint_jt args))
  (:larm-shoulder-r (&rest args) (forward-message-to l_upper_arm_roll_joint_jt args))
  (:larm-elbow-p (&rest args) (forward-message-to l_elbow_flex_joint_jt args))
  (:larm-elbow-r (&rest args) (forward-message-to l_forearm_roll_joint_jt args))
  (:larm-wrist-p (&rest args) (forward-message-to l_wrist_flex_joint_jt args))
  (:larm-wrist-r (&rest args) (forward-message-to l_wrist_roll_joint_jt args))
  (:rarm-collar-y (&rest args) (forward-message-to r_shoulder_pan_joint_jt args))
  (:rarm-shoulder-p (&rest args) (forward-message-to r_shoulder_lift_joint_jt args))
  (:rarm-shoulder-r (&rest args) (forward-message-to r_upper_arm_roll_joint_jt args))
  (:rarm-elbow-p (&rest args) (forward-message-to r_elbow_flex_joint_jt args))
  (:rarm-elbow-r (&rest args) (forward-message-to r_forearm_roll_joint_jt args))
  (:rarm-wrist-p (&rest args) (forward-message-to r_wrist_flex_joint_jt args))
  (:rarm-wrist-r (&rest args) (forward-message-to r_wrist_roll_joint_jt args))
  (:head-neck-y (&rest args) (forward-message-to head_pan_joint_jt args))
  (:head-neck-p (&rest args) (forward-message-to head_tilt_joint_jt args))

  ;; attach_sensor methods

  ;; geometries
  (:_make_instance_base_bellow_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -2.9000000000000000e+02 0.0000000000000000e+00 8.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 1.000000))
                    (list :diffuse (float-vector 0.100000 0.100000 0.100000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(2.6500000000000000e+02 -1.8500000000000000e+02 -9.5000000000000000e+02 3.1500000000000000e+02 -1.8500000000000000e+02 -9.5000000000000000e+02 3.1500000000000000e+02 -1.8500000000000000e+02 -6.5000000000000000e+02 2.6500000000000000e+02 -1.8500000000000000e+02 -6.5000000000000000e+02 2.6500000000000000e+02 1.8500000000000000e+02 -6.5000000000000000e+02 3.1500000000000000e+02 1.8500000000000000e+02 -6.5000000000000000e+02 3.1500000000000000e+02 1.8500000000000000e+02 -9.5000000000000000e+02 2.6500000000000000e+02 1.8500000000000000e+02 -9.5000000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -9.4999998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -9.4999998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -9.4999998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 2.6499998569488525e+02 -1.8500000238418579e+02 -6.4999997615814209e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 2.6499998569488525e+02 1.8500000238418579e+02 -9.4999998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -6.4999997615814209e+02) (float-vector 3.1499999761581421e+02 1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -9.4999998807907104e+02) (float-vector 3.1499999761581421e+02 -1.8500000238418579e+02 -6.4999997615814209e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "base_bellow_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_base_footprint_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "base_footprint_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_base_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.1000000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 1 0 6 329 0 2 0 328 6 329 328 0 9 12 6 1 6 12 9 6 328 327 328 279 280 279 328 280 328 329 327 9 328 321 327 277 327 279 277 327 321 9 279 278 277 279 280 278 280 281 278 282 281 280 282 280 329 283 281 282 278 281 314 314 281 283 283 282 284 329 330 282 330 284 282 284 285 283 330 331 284 331 285 284 3 330 2 329 2 330 330 3 331 335 274 331 274 285 331 3 397 331 331 397 335 285 256 283 285 274 256 254 255 256 256 255 257 274 254 256 283 256 257 312 283 257 312 314 283 312 257 255 314 312 255 255 315 314 314 315 278 255 313 315 313 278 315 277 278 276 313 276 278 255 311 313 276 313 273 273 313 311 276 273 269 269 277 276 321 277 269 318 321 269 318 7 321 9 321 7 7 8 9 318 393 7 393 436 7 436 437 7 437 8 7 13 12 9 13 9 8 13 474 12 8 474 13 12 475 1 474 475 12 471 474 8 471 475 474 438 471 8 438 472 471 485 471 51 471 488 51 471 472 488 475 471 485 438 153 472 153 473 472 473 486 472 472 486 488 488 48 51 48 488 49 486 49 488 487 486 473 486 487 69 69 46 486 49 486 46 48 49 46 46 51 48 45 46 47 50 51 46 46 45 50 69 72 46 46 72 47 47 24 45 25 24 47 47 73 25 72 73 47 71 74 72 72 74 73 71 72 69 69 70 71 74 71 225 70 225 71 61 225 63 225 61 224 225 226 63 225 70 226 74 225 224 61 32 62 32 61 63 223 224 61 62 223 61 63 64 32 63 65 64 63 226 65 226 227 65 226 70 227 65 66 64 65 227 66 66 68 64 29 32 64 29 64 68 66 67 68 66 228 67 227 228 66 227 70 228 229 67 228 228 230 229 230 228 70 67 77 68 87 77 67 67 229 87 235 229 230 235 237 229 87 229 237 87 89 77 87 237 89 238 237 235 89 237 238 89 41 77 41 89 88 236 89 238 236 88 89 236 238 85 235 85 238 234 236 84 84 236 85 234 88 236 62 41 88 234 62 88 223 234 84 234 223 62 32 41 62 29 26 32 26 33 32 32 33 41 34 33 25 26 25 33 42 33 34 33 42 41 25 35 34 34 35 60 34 60 42 25 26 24 35 25 73 35 73 221 35 221 60 42 60 44 217 218 60 60 221 217 218 44 60 221 219 217 221 73 219 74 222 73 73 222 219 217 219 220 219 215 220 222 215 219 220 218 217 231 232 218 220 231 218 232 44 218 215 214 220 220 214 231 214 215 216 222 216 215 222 74 216 233 216 79 214 216 233 84 216 74 216 84 79 214 233 231 231 82 232 231 233 82 44 232 83 232 82 83 81 82 79 83 82 81 233 79 82 78 79 80 79 78 81 79 84 80 80 84 85 74 223 84 80 85 78 78 86 81 93 78 85 86 78 93 81 43 83 81 86 43 44 83 43 42 43 41 40 41 43 42 44 43 40 43 21 86 21 43 93 52 86 21 86 52 20 17 21 21 17 18 18 40 21 21 52 20 20 19 17 19 20 22 52 22 20 17 16 18 17 19 16 16 30 18 30 31 18 31 40 18 14 15 16 16 19 14 16 28 30 28 16 15 14 19 23 22 23 19 26 14 23 15 14 26 15 27 28 15 26 27 28 37 30 37 28 38 28 29 38 28 27 29 26 29 27 23 24 26 23 22 24 22 45 24 22 52 45 52 53 45 45 56 50 57 56 45 53 55 45 55 57 45 56 489 50 56 476 489 56 446 476 56 57 446 485 51 50 485 50 489 485 489 475 475 489 476 10 475 11 1 475 10 11 475 476 1 10 2 2 10 11 2 11 4 11 476 4 2 4 3 3 4 5 5 4 447 447 4 476 3 5 397 335 397 395 5 395 397 274 335 334 335 395 334 334 395 396 395 5 396 274 334 333 334 396 333 333 396 394 394 396 439 5 439 396 332 274 333 333 394 332 394 398 332 398 394 439 332 305 274 341 305 332 332 398 341 274 305 301 305 306 301 305 307 306 341 307 305 345 307 341 341 398 345 306 307 308 309 308 307 345 309 307 336 301 306 336 306 337 337 306 308 274 301 300 336 300 301 336 316 300 337 316 336 337 338 316 308 338 337 316 288 300 288 316 317 338 339 316 317 316 340 316 339 340 300 275 274 300 288 275 271 274 275 271 275 286 288 289 275 275 289 364 286 275 364 286 287 271 290 287 286 378 290 286 286 364 378 287 290 291 377 290 378 377 291 290 364 377 378 291 377 420 377 421 420 377 364 421 420 421 295 420 295 291 422 295 421 422 421 364 291 295 296 297 296 295 297 295 298 422 298 295 298 422 365 364 365 422 299 298 289 298 299 297 298 365 289 365 364 289 288 299 289 302 299 288 302 288 340 288 317 340 302 303 304 304 299 302 303 302 340 340 339 303 308 310 303 310 304 303 303 339 308 342 304 343 310 343 304 299 304 342 308 309 310 310 344 343 344 310 309 338 308 339 344 309 345 343 344 399 345 402 344 402 399 344 343 399 342 399 400 342 399 454 400 399 402 456 456 454 399 345 401 402 401 458 402 402 458 456 345 398 401 398 457 401 401 457 458 458 212 456 213 458 457 213 212 458 456 212 454 209 212 210 212 213 207 207 210 212 212 493 454 501 493 212 209 501 212 207 213 208 213 59 208 457 59 213 206 203 207 208 206 207 207 203 210 208 59 58 206 208 58 206 204 203 204 206 528 58 528 206 203 204 205 205 204 529 528 529 204 201 528 58 200 529 528 200 528 201 199 530 529 199 529 200 529 574 205 530 574 529 205 565 203 574 565 205 530 573 574 565 574 573 202 530 199 202 531 530 573 530 531 573 531 583 565 573 562 562 573 583 564 565 566 203 565 564 565 562 566 561 562 563 561 566 562 562 583 563 566 561 522 522 564 566 522 203 564 203 522 210 522 211 210 511 211 522 561 511 522 561 563 520 520 511 561 510 209 511 211 511 209 511 521 510 519 511 520 519 521 511 209 210 211 494 209 510 494 501 209 455 493 494 494 484 455 484 494 510 493 501 494 454 493 455 400 454 455 342 400 356 356 400 419 455 419 400 299 342 356 355 299 356 356 419 355 355 419 418 455 417 419 419 417 418 299 355 354 355 418 354 354 418 417 354 417 416 455 416 417 353 351 354 299 354 351 354 416 353 353 416 351 416 413 351 416 466 413 466 416 484 455 484 416 299 351 352 351 413 414 351 414 352 466 467 413 413 467 414 352 414 415 414 470 415 467 470 414 349 299 352 352 415 349 349 415 412 470 483 415 415 483 412 470 466 483 467 466 470 483 466 505 505 466 484 412 483 465 465 483 178 169 178 483 169 483 503 483 505 503 503 505 506 505 484 507 507 506 505 503 502 169 503 512 502 503 506 517 503 517 512 506 515 516 516 517 506 506 507 515 518 517 516 517 518 512 514 518 516 515 514 516 513 514 515 515 507 513 514 525 518 525 514 527 513 527 514 524 512 518 525 524 518 524 523 512 524 525 567 171 524 567 524 170 523 170 524 171 523 139 512 523 170 139 139 170 171 140 139 171 171 172 140 567 569 171 172 171 569 139 140 141 504 139 141 512 139 504 512 504 502 502 504 141 142 141 140 169 141 166 141 142 166 141 169 502 137 142 140 165 166 142 165 142 167 137 167 142 166 173 174 166 165 173 166 174 178 169 166 178 173 165 175 165 176 175 167 176 165 168 167 137 176 167 168 177 176 168 463 461 176 461 175 176 463 176 177 460 175 461 460 173 175 461 407 460 405 461 406 406 461 463 407 461 405 463 462 406 463 177 462 177 168 112 462 177 112 404 406 462 404 462 373 462 146 373 112 146 462 405 406 293 404 292 406 406 292 293 287 404 373 404 287 292 372 287 373 146 372 373 144 145 146 145 372 146 112 144 146 374 271 372 372 271 287 145 374 372 291 292 287 291 293 292 291 294 293 291 296 294 407 405 294 407 294 296 405 293 294 403 296 297 296 403 407 460 407 459 403 459 407 403 297 347 347 459 403 297 346 347 297 299 346 408 409 347 346 408 347 347 409 459 460 459 173 409 174 459 459 174 173 469 174 409 469 178 174 468 469 409 468 178 469 465 178 468 409 465 468 465 409 464 465 464 412 464 409 410 410 411 464 412 464 411 350 412 411 349 412 350 411 410 348 350 411 348 410 408 348 408 410 409 299 348 346 348 349 350 348 299 349 348 408 346 374 375 271 147 374 145 375 374 147 376 266 375 266 271 375 150 375 147 150 376 375 266 267 271 267 272 271 274 271 272 263 267 266 362 272 267 267 263 362 258 263 262 262 263 266 363 362 263 263 258 363 362 361 272 361 362 363 363 258 358 363 358 361 272 361 360 357 361 358 357 359 361 361 359 360 258 357 358 357 258 265 359 357 265 268 359 265 270 359 268 360 359 270 272 360 270 269 270 268 270 273 272 270 269 273 264 268 265 269 268 264 265 258 264 258 259 260 260 261 258 262 259 258 261 264 258 368 369 259 368 259 262 369 260 259 370 260 369 260 370 261 370 371 261 261 371 264 425 370 426 369 426 370 370 425 371 368 424 369 424 426 369 426 424 160 426 162 425 162 426 161 426 160 161 425 427 371 427 425 163 425 162 163 162 133 136 162 136 163 161 133 162 160 133 161 132 133 131 131 133 135 132 136 133 135 133 160 155 136 132 155 157 136 136 157 163 131 95 132 94 155 132 132 95 94 95 131 134 134 131 113 135 113 131 113 135 159 159 135 160 158 113 159 423 159 424 424 159 160 159 423 158 120 113 158 149 158 423 120 158 149 368 423 424 149 423 367 367 423 368 148 120 149 366 149 367 149 366 148 366 367 266 262 266 367 367 368 262 366 266 376 148 366 376 150 120 148 148 376 150 150 147 120 145 144 147 144 120 147 144 112 118 144 115 120 115 144 118 116 120 115 116 113 120 115 114 116 115 119 114 118 119 115 113 116 114 97 113 114 134 113 97 122 114 119 97 114 96 114 122 96 117 119 118 122 119 117 122 117 123 122 123 100 96 122 100 95 96 52 96 95 97 52 96 98 96 100 98 97 95 134 94 95 93 93 95 52 98 53 52 54 55 53 53 99 54 53 98 99 58 57 55 55 54 190 55 190 192 55 192 197 55 197 58 59 57 58 58 197 201 198 197 192 201 197 200 200 197 198 190 193 192 192 193 195 192 195 198 198 195 199 199 200 198 196 195 193 195 196 199 191 193 190 191 194 193 194 196 193 202 199 196 194 532 196 196 532 202 532 194 533 533 194 191 191 190 54 184 191 54 184 533 191 532 533 534 534 533 535 184 536 533 536 535 533 54 181 184 184 181 187 187 536 184 181 54 99 99 180 181 98 253 99 251 99 253 180 99 251 180 182 181 251 252 180 180 252 553 182 180 553 250 251 245 245 251 249 250 252 251 251 253 249 98 249 253 245 249 243 249 247 243 249 101 247 249 98 101 243 244 245 245 559 250 244 559 245 244 243 247 246 247 101 247 246 244 101 98 100 100 102 101 246 101 248 248 101 102 248 557 246 246 558 244 557 558 246 558 559 244 558 557 240 242 558 240 559 558 242 248 560 557 240 557 241 557 560 241 102 560 248 241 560 143 560 102 143 240 241 172 164 241 143 172 241 164 172 242 240 164 140 172 569 242 172 140 164 143 137 140 143 102 137 143 108 107 137 108 137 138 137 102 138 107 168 137 102 100 103 138 102 103 100 123 103 124 103 123 125 103 124 125 138 103 117 108 123 108 124 123 126 125 124 127 126 124 108 130 124 130 127 124 129 125 126 129 138 125 127 129 126 128 129 127 130 128 127 108 138 130 130 138 128 128 138 129 107 108 104 104 108 109 108 117 118 108 118 109 104 112 107 168 107 112 112 104 118 118 121 109 104 121 118 104 105 106 109 105 104 121 104 106 109 121 105 111 121 106 110 121 111 105 121 110 105 110 106 110 111 106 598 559 242 569 568 242 598 242 568 559 598 589 589 598 568 559 589 594 559 594 250 592 594 589 594 592 556 597 594 556 250 594 597 250 556 252 556 250 597 556 555 553 252 556 553 592 555 556 553 555 554 555 551 554 555 596 551 593 555 592 593 596 555 553 554 182 554 551 183 182 554 183 181 182 183 183 551 181 551 552 181 593 551 596 593 552 551 185 181 186 181 185 187 552 595 181 181 595 186 593 595 552 595 549 186 549 595 593 186 549 548 549 593 548 548 547 186 548 588 547 588 548 591 548 593 591 547 545 186 585 545 547 547 587 585 547 588 587 590 587 588 588 591 590 591 593 590 590 593 592 590 592 587 585 587 589 587 592 589 585 572 545 585 586 572 585 589 586 186 545 546 545 572 546 546 572 526 526 572 525 572 586 525 525 586 567 586 589 568 586 568 567 526 525 527 527 570 526 527 513 570 563 570 520 526 570 571 520 570 513 570 563 571 507 520 513 509 520 507 509 519 520 484 509 507 508 509 484 508 519 509 510 519 508 510 521 519 484 510 508 544 526 571 571 584 544 571 581 584 581 571 563 526 544 546 546 544 186 189 185 186 186 544 189 185 188 187 185 537 188 537 185 538 185 189 579 538 185 579 188 537 187 187 539 536 187 537 539 536 539 535 537 535 539 537 540 535 535 577 534 535 540 577 580 540 537 599 577 540 540 580 599 577 575 534 599 575 577 575 532 534 575 531 532 575 576 531 599 576 575 578 576 599 580 578 599 580 537 578 578 579 543 537 538 578 579 578 538 578 543 542 542 576 578 583 576 542 576 583 531 532 531 202 582 583 541 581 583 582 583 542 541 563 583 581 541 542 189 542 543 189 189 543 579 550 541 189 544 550 189 550 582 541 581 582 550 550 584 581 550 544 584 567 568 569 59 179 57 482 446 57 481 482 57 179 481 57 441 59 457 441 490 59 179 59 490 457 398 441 398 439 441 440 439 5 441 439 442 440 443 439 439 443 442 440 444 445 440 5 444 440 452 443 445 452 440 5 447 444 444 447 449 447 451 449 447 446 451 447 476 446 448 449 450 449 451 450 444 449 448 451 453 450 446 453 451 444 446 445 453 446 444 446 482 445 444 448 453 450 453 448 445 482 452 482 481 452 480 481 477 480 452 481 179 492 481 481 492 477 443 480 442 442 480 477 443 452 480 442 477 441 477 478 441 478 490 441 477 479 478 478 491 179 479 491 478 179 490 478 491 492 179 479 477 492 479 492 491 91 92 93 93 92 94 85 151 93 151 91 93 154 92 91 154 91 151 92 154 155 94 92 155 152 153 154 156 152 154 155 154 157 154 151 156 154 153 157 85 156 151 500 156 85 235 500 85 152 156 498 498 156 499 156 500 499 499 500 235 230 239 235 239 499 235 499 239 498 495 152 498 498 230 495 498 239 230 495 230 496 497 496 230 70 497 230 152 495 473 495 496 473 496 487 473 496 497 487 497 70 69 487 497 69 152 473 153 435 157 153 435 153 438 163 157 435 163 434 390 429 434 163 435 429 163 427 163 390 391 434 389 389 434 386 390 434 391 429 386 434 325 390 391 326 390 325 427 390 326 326 371 427 325 264 326 326 264 371 325 324 264 388 324 325 391 388 325 388 391 389 324 389 386 388 389 324 323 322 324 269 324 322 269 264 324 324 386 323 323 385 384 323 384 322 386 387 323 323 387 385 385 429 430 385 430 384 387 429 385 384 383 322 384 428 383 384 430 431 384 431 428 435 431 430 429 435 430 386 429 387 435 428 431 435 432 433 435 438 432 428 435 433 428 433 383 322 383 382 383 433 382 382 433 432 382 380 320 322 382 320 382 432 380 322 320 269 269 320 319 320 379 319 380 381 320 320 381 379 432 381 380 381 432 8 381 8 437 381 437 379 318 319 379 379 392 318 436 379 437 379 436 392 318 269 319 318 392 393 392 436 393 432 438 8 273 254 272 254 273 255 311 255 273 254 274 272 38 29 75 75 29 68 36 37 38 38 75 36 36 75 76 75 90 76 75 68 90 77 90 68 76 90 77 36 76 39 76 77 39 37 36 30 30 36 31 39 31 36 39 40 31 39 41 40 39 77 41 223 74 224))
                   (list :vertices (let ((mat (make-matrix 600 3))) (fvector-replace (array-entity mat) #f(3.0023101806640625e+02 -2.9510501098632812e+02 3.8796100616455078e+01 2.9685299682617188e+02 -2.9019702148437500e+02 1.5182299804687500e+02 2.7438500976562500e+02 -3.1605099487304688e+02 4.1262500762939453e+01 2.3932600402832031e+02 -3.2802999877929688e+02 4.4508098602294922e+01 2.3239700317382812e+02 -3.2586700439453125e+02 1.5397399902343750e+02 2.1941400146484375e+02 -3.2824002075195312e+02 9.5353401184082031e+01 3.1445397949218750e+02 -2.7596798706054688e+02 3.7462398529052734e+01 3.2864001464843750e+02 -2.1992300415039062e+02 3.6972400665283203e+01 3.2252899169921875e+02 -2.2448100280761719e+02 1.5353298950195312e+02 3.2601998901367188e+02 -2.4838000488281250e+02 3.6334800720214844e+01 2.7942999267578125e+02 -3.0592999267578125e+02 1.5210699462890625e+02 2.6038500976562500e+02 -3.1690499877929688e+02 1.5375199890136719e+02 3.1106399536132812e+02 -2.6823300170898438e+02 1.5271499633789062e+02 3.1945999145507812e+02 -2.4776400756835938e+02 1.5087300109863281e+02 2.0341000366210938e+02 -3.2873798370361328e+01 2.3513099670410156e+02 2.1236599731445312e+02 -3.3848201751708984e+01 2.3870800781250000e+02 2.0356999206542969e+02 1.1939000129699707e+01 2.3772299194335938e+02 1.8414199829101562e+02 2.4342599868774414e+01 2.1270300292968750e+02 2.0572399902343750e+02 3.4897899627685547e+01 2.3584899902343750e+02 1.8070698547363281e+02 -3.2239201068878174e+00 2.1111399841308594e+02 1.6318899536132812e+02 2.1084100723266602e+01 1.7987899780273438e+02 1.6983799743652344e+02 4.1547500610351562e+01 1.7990699768066406e+02 1.6247000122070312e+02 -1.6208499908447266e+01 1.8021699523925781e+02 1.9430099487304688e+02 -3.7104099273681641e+01 2.2271400451660156e+02 1.6974798583984375e+02 -4.1105098724365234e+01 1.7973199462890625e+02 1.7928401184082031e+02 -4.4960498809814453e+01 1.8107600402832031e+02 2.0852400207519531e+02 -3.9552600860595703e+01 2.3290798950195312e+02 2.4219799804687500e+02 -3.8239097595214844e+01 2.3796499633789062e+02 2.3323500061035156e+02 -3.3860900878906250e+01 2.4195500183105469e+02 2.9444302368164062e+02 -3.8886497497558594e+01 2.3469599914550781e+02 2.3372599792480469e+02 1.3878700256347656e+01 2.4342300415039062e+02 2.4476000976562500e+02 3.6303901672363281e+01 2.4060000610351562e+02 2.1288299560546875e+02 -4.1764999389648438e+01 2.1188600158691406e+02 2.0504798889160156e+02 -4.2515197753906250e+01 2.0309600830078125e+02 1.9998200988769531e+02 -4.3613399505615234e+01 1.8569999694824219e+02 2.0038299560546875e+02 -4.3849502563476562e+01 1.8206199645996094e+02 2.9490798950195312e+02 3.3810501098632812e+01 2.3929699707031250e+02 2.6420797729492188e+02 -1.1748200416564941e+01 2.4302299499511719e+02 2.9603601074218750e+02 -3.2187000274658203e+01 2.3927299499511719e+02 2.9394702148437500e+02 3.9552101135253906e+01 2.3317800903320312e+02 2.0685699462890625e+02 3.9679100036621094e+01 2.3236499023437500e+02 2.1044000244140625e+02 4.1786102294921875e+01 2.1115100097656250e+02 2.0000299072265625e+02 4.3600997924804688e+01 1.8601599121093750e+02 1.7970800781250000e+02 4.4697696685791016e+01 1.8177000427246094e+02 2.0004100036621094e+02 4.3783798217773438e+01 1.8265600585937500e+02 7.8551902770996094e+01 -1.3927799987792969e+02 1.8049000549316406e+02 2.6282998657226562e+02 -5.5588802337646484e+01 1.7665100097656250e+02 1.7663900756835938e+02 -4.7864299774169922e+01 1.7929199218750000e+02 2.9806100463867188e+02 -1.2864799499511719e+02 1.7509300231933594e+02 2.9769598388671875e+02 -6.7902099609375000e+01 1.7585200500488281e+02 2.2196299743652344e+02 -2.5503799438476562e+02 1.7638400268554688e+02 2.6352502441406250e+02 -1.3535400390625000e+02 1.7648098754882812e+02 5.8946800231933594e+01 1.1198600006103516e+02 1.8082701110839844e+02 -9.6140098571777344e+01 -2.4160598754882812e+01 1.8090200805664062e+02 -2.6149899291992188e+02 -1.9596800231933594e+02 1.7660600280761719e+02 -2.0651200866699219e+02 -1.9753601074218750e+02 1.7780000305175781e+02 6.9552398681640625e+01 -3.0918197631835938e+02 1.7782499694824219e+02 -7.2508605957031250e+01 -3.1709701538085938e+02 1.7715699768066406e+02 -1.9201399230957031e+02 -2.8525399780273438e+02 1.7702400207519531e+02 -2.3391099548339844e+02 -3.1606997680664062e+02 1.7403599548339844e+02 2.0022599792480469e+02 -1.2567600250244141e+01 1.8247898864746094e+02 2.4542300415039062e+02 -1.5419400215148926e+01 2.1282899475097656e+02 2.3913800048828125e+02 6.2237095832824707e-01 2.1283599853515625e+02 2.5926199340820312e+02 -2.3050600051879883e+01 2.1283699035644531e+02 2.9569900512695312e+02 -3.9568901062011719e+01 2.1284599304199219e+02 2.7478601074218750e+02 -1.9590200424194336e+01 2.1283300781250000e+02 2.8245898437500000e+02 -1.1313400268554688e+01 2.1283200073242188e+02 2.8575000000000000e+02 1.5033500194549561e+00 2.1283499145507812e+02 3.0166198730468750e+02 -3.2401000976562500e+01 2.1283200073242188e+02 2.6123602294921875e+02 -4.4348999023437500e+01 1.7713299560546875e+02 2.9357202148437500e+02 -4.1024497985839844e+01 1.7981100463867188e+02 2.3130599975585938e+02 -4.3458702087402344e+01 1.7995500183105469e+02 2.0768600463867188e+02 -4.6056503295898438e+01 1.7898100280761719e+02 2.0216200256347656e+02 -4.4616699218750000e+01 1.8039999389648438e+02 2.0461599731445312e+02 -4.4860603332519531e+01 1.8000199890136719e+02 3.0025500488281250e+02 -3.3223201751708984e+01 2.3401800537109375e+02 3.0006301879882812e+02 3.3962299346923828e+01 2.3393598937988281e+02 2.9554400634765625e+02 3.9623497009277344e+01 2.1284100341796875e+02 2.1501699829101562e+02 4.7756099700927734e+01 1.7840100097656250e+02 2.0672200012207031e+02 4.5097297668457031e+01 1.7961399841308594e+02 2.2939799499511719e+02 4.5011600494384766e+01 1.7861700439453125e+02 1.9177999877929688e+02 4.6298900604248047e+01 1.7943699645996094e+02 2.0243099975585938e+02 4.4678600311279297e+01 1.8032899475097656e+02 2.0074499511718750e+02 4.4034400939941406e+01 1.8151399230957031e+02 2.1320899963378906e+02 4.4390499114990234e+01 1.7999800109863281e+02 2.4777301025390625e+02 4.3880802154541016e+01 1.7922000122070312e+02 1.7758999633789062e+02 4.7441699981689453e+01 1.7928500366210938e+02 2.7845999145507812e+02 1.7165800094604492e+01 2.1283100891113281e+02 2.4873899841308594e+02 1.8789300918579102e+01 2.1283499145507812e+02 2.6383798217773438e+02 2.2990900039672852e+01 2.1283100891113281e+02 3.0166000366210938e+02 3.2466999053955078e+01 2.1283499145507812e+02 2.9717599487304688e+02 6.7286796569824219e+01 1.7581999206542969e+02 2.9814700317382812e+02 1.2812899780273438e+02 1.7512500000000000e+02 2.5847900390625000e+02 5.9713699340820312e+01 1.7720599365234375e+02 2.5811599731445312e+02 1.3580699157714844e+02 1.7669200134277344e+02 2.2257299804687500e+02 2.5874099731445312e+02 1.7601100158691406e+02 3.1376998901367188e+01 3.0716699218750000e+02 1.7849800109863281e+02 1.3860099792480469e+02 2.9823699951171875e+02 1.7703599548339844e+02 -2.0646299743652344e+02 1.9765399169921875e+02 1.7781500244140625e+02 -2.6150000000000000e+02 1.9598298645019531e+02 1.7622399902343750e+02 -1.3077700805664062e+02 3.1197000122070312e+02 1.7724398803710938e+02 -1.9161500549316406e+02 2.7025399780273438e+02 1.7707798767089844e+02 -1.9309300231933594e+02 2.8225799560546875e+02 1.7705099487304688e+02 -1.8581800842285156e+02 3.1222201538085938e+02 1.7624301147460938e+02 -1.7911698913574219e+02 3.2547900390625000e+02 1.6679899597167969e+02 -1.7919999694824219e+02 3.2491400146484375e+02 1.6765100097656250e+02 -1.7917900085449219e+02 3.2491497802734375e+02 1.6765100097656250e+02 -2.1599200439453125e+02 3.2079199218750000e+02 1.7174600219726562e+02 -1.8271099853515625e+02 3.2019601440429688e+02 1.7350498962402344e+02 -1.7984800720214844e+02 3.2392401123046875e+02 1.6887500000000000e+02 -1.7917900085449219e+02 3.2491400146484375e+02 1.6765199279785156e+02 -1.7915800476074219e+02 3.2491497802734375e+02 1.6765199279785156e+02 -2.3092700195312500e+02 3.2662899780273438e+02 1.6051599121093750e+02 2.3786599731445312e+02 3.2063299560546875e+02 1.5918299865722656e+02 3.0916999816894531e+01 3.1327301025390625e+02 1.7738099670410156e+02 4.5053401947021484e+01 3.2668798828125000e+02 1.6403500366210938e+02 1.1757099914550781e+02 3.2356799316406250e+02 1.6558200073242188e+02 -1.1809200286865234e+02 3.1984799194335938e+02 1.7472100830078125e+02 -1.5924600219726562e+02 3.2662399291992188e+02 1.6535400390625000e+02 -3.8491699218750000e+01 3.2398999023437500e+02 1.7080700683593750e+02 2.2307400512695312e+02 3.2685198974609375e+02 1.5413099670410156e+02 -1.7919699096679688e+02 3.2483200073242188e+02 1.6759001159667969e+02 -6.1780399322509766e+01 3.1545999145507812e+02 1.7735000610351562e+02 -1.8468299865722656e+02 3.1623599243164062e+02 1.7552400207519531e+02 -1.8542900085449219e+02 3.1414801025390625e+02 1.7602799987792969e+02 -1.8583799743652344e+02 3.1261700439453125e+02 1.7623298645019531e+02 -1.8571299743652344e+02 3.1323199462890625e+02 1.7620399475097656e+02 -1.8554499816894531e+02 3.1391702270507812e+02 1.7613400268554688e+02 -1.8543901062011719e+02 3.1431002807617188e+02 1.7608100891113281e+02 -1.8568800354003906e+02 3.1324499511718750e+02 1.7617399597167969e+02 -1.8513000488281250e+02 3.1524700927734375e+02 1.7587600708007812e+02 2.5339099121093750e+02 2.8096197509765625e+02 1.6768099975585938e+02 2.8237301635742188e+02 2.1796299743652344e+02 1.6980099487304688e+02 3.0177999877929688e+02 2.7633200073242188e+02 1.5799400329589844e+02 2.0117199707031250e+02 3.0224697875976562e+02 1.6986900329589844e+02 2.7186300659179688e+02 3.0599200439453125e+02 1.5794099426269531e+02 3.1493899536132812e+02 2.4052999877929688e+02 1.5967500305175781e+02 -2.3655400085449219e+02 3.1402798461914062e+02 1.7471299743652344e+02 -1.8853700256347656e+02 3.1477297973632812e+02 1.7596200561523438e+02 -3.0256399536132812e+02 1.7047099304199219e+02 1.7408299255371094e+02 -2.6421600341796875e+02 2.6445599365234375e+02 1.7533700561523438e+02 -3.0819500732421875e+02 1.7200100708007812e+02 1.7402101135253906e+02 -3.0009698486328125e+02 2.5403898620605469e+02 1.7367599487304688e+02 -2.4089500427246094e+02 2.8654299926757812e+02 1.7572900390625000e+02 -2.2261700439453125e+02 3.2789599609375000e+02 1.1502899932861328e+02 -7.8173194885253906e+01 3.2863000488281250e+02 7.3000495910644531e+01 -2.2846400451660156e+02 3.2837500000000000e+02 8.6464599609375000e+01 -2.1326700210571289e+01 3.2871899414062500e+02 6.7909706115722656e+01 1.5932301330566406e+02 3.2900100708007812e+02 5.1731998443603516e+01 2.3917298889160156e+02 3.2810900878906250e+02 4.4524402618408203e+01 9.9946502685546875e+01 3.2890899658203125e+02 5.7049400329589844e+01 2.8766998291015625e+02 5.6536903381347656e+01 1.7271800231933594e+02 3.0680798339843750e+02 3.0199098587036133e+01 1.6822500610351562e+02 3.1838400268554688e+02 4.9684402465820312e+01 1.6428999328613281e+02 3.0510501098632812e+02 6.0503700256347656e+01 1.6866999816894531e+02 3.0182498168945312e+02 1.3732699584960938e+02 1.6860499572753906e+02 2.9748400878906250e+02 4.2789798736572266e+01 1.7061300659179688e+02 3.1875000000000000e+02 2.1195100402832031e+02 1.5965199279785156e+02 2.4675000000000000e+02 3.2253100585937500e+02 1.5247200012207031e+02 2.7029998779296875e+02 3.1249301147460938e+02 1.5154998779296875e+02 2.8920199584960938e+02 2.9747702026367188e+02 1.5252900695800781e+02 3.0161602783203125e+02 2.8380599975585938e+02 1.5234201049804688e+02 3.1447100830078125e+02 2.6122601318359375e+02 1.5284500122070312e+02 3.2175500488281250e+02 2.3548799133300781e+02 1.5270300292968750e+02 -2.5834201049804688e+02 2.6732901000976562e+02 1.7773300170898438e+02 -2.9482202148437500e+02 2.6980401611328125e+02 1.7189399719238281e+02 -3.1003100585937500e+02 2.3203698730468750e+02 1.6980799865722656e+02 -2.6874398803710938e+02 2.9855599975585938e+02 1.7247499084472656e+02 -2.4317799377441406e+02 3.1462100219726562e+02 1.7238500976562500e+02 -3.1538000488281250e+02 1.7843099975585938e+02 1.6900399780273438e+02 -2.9707901000976562e+02 1.7267100524902344e+02 1.7908000183105469e+02 -2.7793197631835938e+02 2.1571000671386719e+02 1.7839500427246094e+02 -2.6491400146484375e+02 2.5324800109863281e+02 1.7956100463867188e+02 -3.1386300659179688e+02 2.7184600830078125e+02 1.4402799987792969e+02 -3.2482299804687500e+02 2.4593701171875000e+02 1.3718701171875000e+02 -2.9955700683593750e+02 2.9183099365234375e+02 1.4918998718261719e+02 -2.7596301269531250e+02 3.1145098876953125e+02 1.5510000610351562e+02 -2.4861900329589844e+02 3.2278799438476562e+02 1.5946499633789062e+02 -3.2710702514648438e+02 2.2128399658203125e+02 1.3685099792480469e+02 -1.8126699829101562e+02 -3.2193698120117188e+02 1.7145500183105469e+02 -2.6111502075195312e+02 1.9584100341796875e+02 3.4833700561523438e+02 -2.6144497680664062e+02 1.5934700012207031e+02 5.1925097656250000e+02 -2.6128900146484375e+02 1.9582499694824219e+02 4.0603399658203125e+02 -2.6150000000000000e+02 1.9600000000000000e+02 5.1925000000000000e+02 -2.6132501220703125e+02 -1.9569200134277344e+02 3.6470498657226562e+02 -2.6150000000000000e+02 -1.5934300231933594e+02 5.1925000000000000e+02 -2.6150000000000000e+02 1.5932499694824219e+02 6.0518402099609375e+02 -2.6148599243164062e+02 -1.9573600769042969e+02 4.5809500122070312e+02 -2.6149697875976562e+02 -1.9593299865722656e+02 5.1924902343750000e+02 -2.6150000000000000e+02 -1.5932899475097656e+02 6.0517504882812500e+02 -2.2931001281738281e+02 -1.9607398986816406e+02 2.0614999389648438e+02 -2.5288900756835938e+02 -1.9620401000976562e+02 2.7667300415039062e+02 -2.2611999511718750e+02 -1.9904499816894531e+02 2.0755099487304688e+02 -2.4024400329589844e+02 -1.9952400207519531e+02 2.4231700134277344e+02 -2.4942100524902344e+02 -1.9983999633789062e+02 2.8594900512695312e+02 -2.2738800048828125e+02 -2.3076899719238281e+02 2.2246800231933594e+02 -2.4097000122070312e+02 -2.1888500976562500e+02 2.5647100830078125e+02 -1.9946299743652344e+02 -2.5894702148437500e+02 1.8476899719238281e+02 -2.1461799621582031e+02 -2.4117300415039062e+02 2.0202099609375000e+02 -2.2911700439453125e+02 -2.3447399902343750e+02 2.1992900085449219e+02 -2.1546900939941406e+02 -2.4787800598144531e+02 1.9810299682617188e+02 -2.0363600158691406e+02 -2.6391000366210938e+02 1.8427099609375000e+02 -2.4216799926757812e+02 -2.2350000000000000e+02 2.5558900451660156e+02 -2.6229501342773438e+02 -2.5929299926757812e+02 1.8034300231933594e+02 -2.6451000976562500e+02 -2.5069902038574219e+02 1.9633000183105469e+02 -2.7507000732421875e+02 -2.3969100952148438e+02 2.1160200500488281e+02 -2.5323701477050781e+02 -2.6886901855468750e+02 1.8138099670410156e+02 -2.6401599121093750e+02 -2.6082800292968750e+02 1.7567999267578125e+02 -2.4242900085449219e+02 -2.8712298583984375e+02 1.7536999511718750e+02 -3.0822598266601562e+02 -1.7281100463867188e+02 1.7408999633789062e+02 -2.8341900634765625e+02 -2.0654701232910156e+02 1.7632899475097656e+02 -3.0140798950195312e+02 -1.7303399658203125e+02 1.7486199951171875e+02 -2.9611300659179688e+02 -2.6439999389648438e+02 1.7290599060058594e+02 -2.6557897949218750e+02 -2.9969299316406250e+02 1.7357901000976562e+02 2.0293000793457031e+02 5.0859296321868896e-01 1.8022698974609375e+02 2.0283000183105469e+02 -2.8047001361846924e+00 1.8025199890136719e+02 2.0466999816894531e+02 0.0000000000000000e+00 1.8000000000000000e+02 2.0125601196289062e+02 -1.0167099952697754e+01 1.8105200195312500e+02 2.0125601196289062e+02 8.7646894454956055e+00 1.8105200195312500e+02 2.0188400268554688e+02 -1.8756401062011719e+01 1.8062800598144531e+02 2.0187098693847656e+02 0.0000000000000000e+00 1.8063700866699219e+02 2.0080900573730469e+02 -2.6118799209594727e+01 1.8143800354003906e+02 2.0283000183105469e+02 -2.8397600173950195e+01 1.8025199890136719e+02 2.3685699462890625e+02 -5.2378802299499512e+00 1.8000000000000000e+02 2.4335600280761719e+02 -1.7477701187133789e+01 1.8000100708007812e+02 2.5403898620605469e+02 -2.4762699127197266e+01 1.7999800109863281e+02 2.6624398803710938e+02 -2.5739299774169922e+01 1.8000100708007812e+02 2.7947100830078125e+02 -2.0265100479125977e+01 1.8000698852539062e+02 2.8759899902343750e+02 -7.4400200843811035e+00 1.7999800109863281e+02 2.8732101440429688e+02 9.4460096359252930e+00 1.7999400329589844e+02 3.0267797851562500e+02 -3.3678901672363281e+01 1.7988999938964844e+02 2.0188400268554688e+02 2.1035301208496094e+01 1.8062800598144531e+02 2.0125601196289062e+02 2.9098798751831055e+01 1.8105200195312500e+02 2.0283000183105469e+02 2.8222299575805664e+01 1.8025199890136719e+02 2.3855000305175781e+02 1.0203200340270996e+01 1.8000100708007812e+02 2.9382101440429688e+02 4.1014999389648438e+01 1.8000000000000000e+02 2.4909300231933594e+02 2.2630701065063477e+01 1.8000199890136719e+02 2.7705197143554688e+02 2.1724800109863281e+01 1.8000199890136719e+02 2.6431500244140625e+02 2.6104598999023438e+01 1.8000000000000000e+02 3.0304000854492188e+02 3.2920200347900391e+01 1.8000500488281250e+02 -2.6883102416992188e+02 2.4736300659179688e+02 1.9901899719238281e+02 -2.5888897705078125e+02 2.6074298095703125e+02 1.8611698913574219e+02 -2.7971600341796875e+02 2.3434700012207031e+02 2.2360501098632812e+02 -2.2705400085449219e+02 2.3114100646972656e+02 2.2156399536132812e+02 -2.3005400085449219e+02 2.3336000061035156e+02 2.2234700012207031e+02 -2.3801300048828125e+02 2.2264300537109375e+02 2.4547299194335938e+02 -2.1811799621582031e+02 2.4438899230957031e+02 2.0163198852539062e+02 -2.1348500061035156e+02 2.4323600769042969e+02 2.0051499938964844e+02 -2.0441299438476562e+02 2.6262600708007812e+02 1.8508799743652344e+02 -2.2692201232910156e+02 1.9850500488281250e+02 2.0857398986816406e+02 -2.4676998901367188e+02 2.1743299865722656e+02 2.8203799438476562e+02 -2.4114300537109375e+02 1.9724301147460938e+02 2.4053500366210938e+02 -2.5104200744628906e+02 2.0007699584960938e+02 2.9490200805664062e+02 -2.2318199157714844e+02 1.9609199523925781e+02 1.9523399353027344e+02 1.3856900024414062e+02 -1.6670899963378906e+02 -5.1000000000000000e+01 1.3856900024414062e+02 -1.6670899963378906e+02 1.4900000000000000e+02 1.3856900024414062e+02 -2.9789999389648438e+02 -5.1000000000000000e+01 1.3856900024414062e+02 -2.9789999389648438e+02 1.4900000000000000e+02 2.8499798583984375e+02 2.8055599975585938e+02 -5.1000000000000000e+01 2.8756600952148438e+02 3.1275299072265625e+02 -5.1000400543212891e+01 3.0837301635742188e+02 2.9295700073242188e+02 -5.1000198364257812e+01 3.2558102416992188e+02 2.6504299926757812e+02 -5.1001399993896484e+01 2.6423498535156250e+02 3.2544601440429688e+02 -5.0999599456787109e+01 2.2517800903320312e+02 2.9789999389648438e+02 -5.1000000000000000e+01 3.3315100097656250e+02 2.3254199218750000e+02 -5.1000198364257812e+01 3.0478298950195312e+02 2.2474099731445312e+02 -5.1000000000000000e+01 2.3840800476074219e+02 3.3261001586914062e+02 -5.1001300811767578e+01 1.3856900024414062e+02 2.9789999389648438e+02 -5.1000000000000000e+01 3.0478298950195312e+02 1.3168499755859375e+02 -5.1000000000000000e+01 3.3337399291992188e+02 -1.1711899566650391e+02 -5.1000000000000000e+01 1.7298799133300781e+02 1.3168499755859375e+02 -5.1000000000000000e+01 8.4165702819824219e+01 3.3337500000000000e+02 -5.1000000000000000e+01 1.3856900024414062e+02 1.6670899963378906e+02 -5.1000000000000000e+01 1.7298799133300781e+02 -1.3168499755859375e+02 -5.1000000000000000e+01 -1.0734500122070312e+02 -3.3337500000000000e+02 -5.1000000000000000e+01 -1.3856900024414062e+02 1.6670899963378906e+02 -5.1000000000000000e+01 3.0478298950195312e+02 -1.3168499755859375e+02 -5.1000000000000000e+01 3.3300201416015625e+02 -2.3394499206542969e+02 -5.1002101898193359e+01 3.0478298950195312e+02 -2.2474099731445312e+02 -5.1000000000000000e+01 3.2534201049804688e+02 -2.6543499755859375e+02 -5.0973499298095703e+01 3.0749499511718750e+02 -2.9423800659179688e+02 -5.1000499725341797e+01 2.8499798583984375e+02 -2.8055599975585938e+02 -5.1000000000000000e+01 2.8329000854492188e+02 -3.1575201416015625e+02 -5.0999702453613281e+01 2.2517800903320312e+02 -2.9789999389648438e+02 -5.1000000000000000e+01 2.5389701843261719e+02 -3.2920599365234375e+02 -5.1000499725341797e+01 2.2955999755859375e+02 -3.3329000854492188e+02 -5.1000000000000000e+01 -1.3856900024414062e+02 2.9789999389648438e+02 -5.1000000000000000e+01 -2.3388299560546875e+02 3.3305499267578125e+02 -5.1000198364257812e+01 -1.7298799133300781e+02 -1.3168499755859375e+02 -5.1000000000000000e+01 -1.7298799133300781e+02 1.3168499755859375e+02 -5.1000000000000000e+01 -2.2517800903320312e+02 2.9789999389648438e+02 -5.1000000000000000e+01 -2.8499798583984375e+02 2.8055599975585938e+02 -5.1000000000000000e+01 -2.6282400512695312e+02 3.2623699951171875e+02 -5.1001197814941406e+01 -2.8578698730468750e+02 3.1374499511718750e+02 -5.1000099182128906e+01 -3.0551498413085938e+02 2.9663400268554688e+02 -5.1000499725341797e+01 -3.0478298950195312e+02 2.2474099731445312e+02 -5.1000000000000000e+01 -3.2179598999023438e+02 2.7240399169921875e+02 -5.1000598907470703e+01 -3.3221200561523438e+02 2.4176600646972656e+02 -5.0998199462890625e+01 -3.0478298950195312e+02 1.3168499755859375e+02 -5.1000000000000000e+01 -3.3337597656250000e+02 -1.0389300346374512e+01 -5.1000000000000000e+01 -1.3856900024414062e+02 -1.6670899963378906e+02 -5.1000000000000000e+01 -1.3856900024414062e+02 -2.9789999389648438e+02 -5.1000000000000000e+01 -3.0478298950195312e+02 -1.3168499755859375e+02 -5.1000000000000000e+01 -3.0478298950195312e+02 -2.2474099731445312e+02 -5.1000000000000000e+01 -3.3225100708007812e+02 -2.4223999023437500e+02 -5.0993698120117188e+01 -2.4388999938964844e+02 -3.3201599121093750e+02 -5.1000301361083984e+01 -2.2517800903320312e+02 -2.9789999389648438e+02 -5.1000000000000000e+01 -2.7797897338867188e+02 -3.1890402221679688e+02 -5.1000698089599609e+01 -2.8499798583984375e+02 -2.8055599975585938e+02 -5.1000000000000000e+01 -3.0359701538085938e+02 -2.9891699218750000e+02 -5.0996398925781250e+01 -3.2203500366210938e+02 -2.7198498535156250e+02 -5.1000301361083984e+01 1.7298799133300781e+02 -1.3168499755859375e+02 1.4900000000000000e+02 2.2517800903320312e+02 -2.9789999389648438e+02 1.4900000000000000e+02 3.0478298950195312e+02 -1.3168499755859375e+02 1.4900000000000000e+02 2.8499798583984375e+02 -2.8055599975585938e+02 1.4900000000000000e+02 3.0478298950195312e+02 -2.2474099731445312e+02 1.4900000000000000e+02 -1.3856900024414062e+02 -1.6670899963378906e+02 1.4900000000000000e+02 -1.7298799133300781e+02 -1.3168499755859375e+02 1.4900000000000000e+02 3.3335501098632812e+02 -2.0438900756835938e+02 4.4105297088623047e+01 3.3337500000000000e+02 -1.6071798706054688e+02 1.0454499816894531e+02 3.3335998535156250e+02 -1.4279100036621094e+02 1.1729299926757812e+02 3.3338201904296875e+02 -2.2422599792480469e+02 3.6235198974609375e+01 3.3337500000000000e+02 -3.9860401153564453e+01 1.1850199890136719e+02 3.3337799072265625e+02 1.4074200439453125e+02 1.1764099884033203e+02 3.3337500000000000e+02 1.5934300231933594e+02 1.0647599792480469e+02 3.3333099365234375e+02 2.0433599853515625e+02 4.4074600219726562e+01 3.3373098754882812e+02 2.2492800903320312e+02 3.6267898559570312e+01 3.3044299316406250e+02 -2.4968099975585938e+02 3.6400703430175781e+01 3.1859100341796875e+02 -2.7849002075195312e+02 3.7449699401855469e+01 2.9427099609375000e+02 -3.0797897338867188e+02 3.9645702362060547e+01 2.5936499023437500e+02 -3.2758398437500000e+02 4.2793197631835938e+01 2.3212699890136719e+02 -3.3319000244140625e+02 4.5215099334716797e+01 -2.3000000000000000e+02 -3.3321899414062500e+02 8.6587898254394531e+01 -1.0266600036621094e+02 -3.3337500000000000e+02 7.5194000244140625e+01 -4.4496798515319824e-01 -3.3337500000000000e+02 6.6039894104003906e+01 1.2655499267578125e+02 -3.3337500000000000e+02 5.4666702270507812e+01 -1.3856900024414062e+02 -2.9789999389648438e+02 1.4900000000000000e+02 -2.2517800903320312e+02 -2.9789999389648438e+02 1.4900000000000000e+02 -2.8499798583984375e+02 -2.8055599975585938e+02 1.4900000000000000e+02 -3.0478298950195312e+02 -2.2474099731445312e+02 1.4900000000000000e+02 -3.0478298950195312e+02 -1.3168499755859375e+02 1.4900000000000000e+02 -2.5181401062011719e+02 -3.2976898193359375e+02 8.8549705505371094e+01 -3.3258502197265625e+02 -2.3938200378417969e+02 9.5798004150390625e+01 -3.2442297363281250e+02 -2.6655001831054688e+02 9.5054199218750000e+01 -3.1073098754882812e+02 -2.9012600708007812e+02 9.3821304321289062e+01 -2.8527200317382812e+02 -3.1483798217773438e+02 9.1549095153808594e+01 -3.3337500000000000e+02 1.6147799682617188e+02 9.5922302246093750e+01 -3.3301800537109375e+02 2.3431100463867188e+02 9.5815002441406250e+01 -3.3334799194335938e+02 1.4255799865722656e+02 1.0345500183105469e+02 -3.3337597656250000e+02 1.0433499908447266e+02 1.3582899475097656e+02 -3.3335800170898438e+02 1.2336399841308594e+02 1.2909199523925781e+02 -3.3337500000000000e+02 -3.6560600280761719e+01 1.3586700439453125e+02 -3.3337500000000000e+02 1.2175199508666992e+01 1.3585501098632812e+02 -3.3337500000000000e+02 -1.0636900329589844e+02 1.3565499877929688e+02 -3.3335501098632812e+02 -1.2448699951171875e+02 1.2786999511718750e+02 -3.3337500000000000e+02 -1.4438999938964844e+02 1.0244400024414062e+02 -3.3337500000000000e+02 -1.6136799621582031e+02 9.5947303771972656e+01 3.0478298950195312e+02 2.2474099731445312e+02 1.4900000000000000e+02 2.8499798583984375e+02 2.8055599975585938e+02 1.4900000000000000e+02 3.0478298950195312e+02 1.3168499755859375e+02 1.4900000000000000e+02 1.7298799133300781e+02 1.3168499755859375e+02 1.4900000000000000e+02 1.3856900024414062e+02 1.6670899963378906e+02 1.4900000000000000e+02 1.3856900024414062e+02 2.9789999389648438e+02 1.4900000000000000e+02 2.2517800903320312e+02 2.9789999389648438e+02 1.4900000000000000e+02 -1.3856900024414062e+02 1.6670899963378906e+02 1.4900000000000000e+02 -1.7298799133300781e+02 1.3168499755859375e+02 1.4900000000000000e+02 2.2822000122070312e+02 3.3336099243164062e+02 4.5563999176025391e+01 2.5065199279785156e+02 3.3002099609375000e+02 4.3569000244140625e+01 2.7867599487304688e+02 3.1863900756835938e+02 4.1054401397705078e+01 3.0261401367187500e+02 2.9948498535156250e+02 3.8896099090576172e+01 3.1850299072265625e+02 2.7859301757812500e+02 3.7477298736572266e+01 3.2872702026367188e+02 2.5509300231933594e+02 3.6569599151611328e+01 -1.3309899902343750e+02 3.3337500000000000e+02 7.7919296264648438e+01 -2.2697000122070312e+02 3.3336199951171875e+02 8.6324600219726562e+01 -1.2736499786376953e+01 3.3337500000000000e+02 6.7140602111816406e+01 5.6024497985839844e+01 3.3337500000000000e+02 6.0982902526855469e+01 1.3019000244140625e+02 3.3337500000000000e+02 5.4341201782226562e+01 -2.2517800903320312e+02 2.9789999389648438e+02 1.4900000000000000e+02 -1.3856900024414062e+02 2.9789999389648438e+02 1.4900000000000000e+02 3.2678402709960938e+02 -1.5887300109863281e+02 1.0685800170898438e+02 3.2628198242187500e+02 -1.3295100402832031e+02 1.1849600219726562e+02 3.2519799804687500e+02 -1.4426899719238281e+02 1.1664400482177734e+02 3.2633599853515625e+02 -6.9561195373535156e+01 1.1852099609375000e+02 3.2644097900390625e+02 -1.6672800064086914e+01 1.1850199890136719e+02 3.2645999145507812e+02 5.3080600738525391e+01 1.1849900054931641e+02 3.2642498779296875e+02 1.2969699096679688e+02 1.1849900054931641e+02 3.2684500122070312e+02 1.5598500061035156e+02 1.1039300537109375e+02 3.2605499267578125e+02 1.3662300109863281e+02 1.1807999420166016e+02 3.2896600341796875e+02 1.9909199523925781e+02 5.0066799163818359e+01 3.2782598876953125e+02 1.7954699707031250e+02 7.7868797302246094e+01 3.2861901855468750e+02 2.2239199829101562e+02 3.6643596649169922e+01 3.2831100463867188e+02 2.0663400268554688e+02 4.3131500244140625e+01 3.2897500610351562e+02 -1.9821299743652344e+02 5.1098701477050781e+01 3.2830599975585938e+02 -2.0621900939941406e+02 4.3482200622558594e+01 -1.4276499938964844e+02 -3.2852899169921875e+02 7.8784896850585938e+01 6.1352397918701172e+01 -3.2884799194335938e+02 6.0505599975585938e+01 -5.5821800231933594e+01 -3.2866497802734375e+02 7.0998901367187500e+01 2.0085800170898438e+02 -3.2906600952148438e+02 4.8012496948242188e+01 -2.4555200195312500e+02 -3.2663400268554688e+02 8.8080101013183594e+01 -3.2123898315429688e+02 -2.6225399780273438e+02 9.5177001953125000e+01 -3.2832501220703125e+02 -2.3432501220703125e+02 9.5809494018554688e+01 -2.8053097534179688e+02 -3.1139001464843750e+02 9.1370704650878906e+01 -3.0475598144531250e+02 -2.8972198486328125e+02 9.3654197692871094e+01 -3.2779800415039062e+02 2.5799798583984375e+02 9.5354103088378906e+01 -2.3978100585937500e+02 3.3222399902343750e+02 8.7463806152343750e+01 -2.9361599731445312e+02 3.0790100097656250e+02 9.2287300109863281e+01 -2.6799200439453125e+02 3.2413900756835938e+02 8.9992004394531250e+01 -3.1370602416992188e+02 2.8636700439453125e+02 9.4082496643066406e+01 -3.2881701660156250e+02 1.5968998718261719e+02 9.5975402832031250e+01 -3.2880999755859375e+02 2.2752999877929688e+02 9.5856002807617188e+01 -3.2866601562500000e+02 1.4169599914550781e+02 1.0481200408935547e+02 -3.2936901855468750e+02 1.2512799835205078e+02 1.2753899383544922e+02 -3.2814599609375000e+02 1.0685399627685547e+02 1.3593701171875000e+02 -3.2820098876953125e+02 -5.1091800689697266e+01 1.3607199096679688e+02 -3.2851699829101562e+02 -4.4033002853393555e+00 1.3585501098632812e+02 -3.2851898193359375e+02 6.1788200378417969e+01 1.3585301208496094e+02 -3.2819500732421875e+02 -1.0958300018310547e+02 1.3566699218750000e+02 -3.2872302246093750e+02 -1.2441699981689453e+02 1.2831500244140625e+02 -3.2875000000000000e+02 -1.4176599121093750e+02 1.0445800018310547e+02 -3.2880398559570312e+02 -1.5834901428222656e+02 9.6359199523925781e+01 -2.8499798583984375e+02 2.8055599975585938e+02 1.4900000000000000e+02 -3.0478298950195312e+02 2.2474099731445312e+02 1.4900000000000000e+02 -3.0478298950195312e+02 1.3168499755859375e+02 1.4900000000000000e+02 2.6558300781250000e+02 3.1989300537109375e+02 4.2066200256347656e+01 2.8560299682617188e+02 3.0813198852539062e+02 4.0175998687744141e+01 3.2064599609375000e+02 2.6342199707031250e+02 3.6899898529052734e+01 3.0614599609375000e+02 2.8867901611328125e+02 3.8240501403808594e+01 3.2740499877929688e+02 2.4039599609375000e+02 3.6170799255371094e+01 3.2452999877929688e+02 2.4608699798583984e+01 1.2006100463867188e+02 3.2452099609375000e+02 1.3579598999023438e+02 1.1996099853515625e+02 3.2448699951171875e+02 8.4366500854492188e+01 1.2014199829101562e+02 3.2447799682617188e+02 5.4313999176025391e+01 1.2005599975585938e+02 3.2445098876953125e+02 -1.1847399902343750e+02 1.2039999389648438e+02 3.2445401000976562e+02 -2.7274499893188477e+01 1.2029100036621094e+02 3.2495700073242188e+02 1.5911399841308594e+02 1.1015299987792969e+02 3.2234500122070312e+02 8.5601303100585938e+01 1.5727600097656250e+02 3.2713400268554688e+02 -1.8976199340820312e+02 6.6868995666503906e+01 3.2522000122070312e+02 -1.6357600402832031e+02 1.0434899902343750e+02 3.2199200439453125e+02 -8.0251098632812500e+01 1.5942601013183594e+02 -2.2170999145507812e+02 -3.2744299316406250e+02 1.4100599670410156e+02 -4.2555500030517578e+01 -3.2706698608398438e+02 1.6232598876953125e+02 -2.3522200012207031e+02 -3.2597000122070312e+02 1.6054501342773438e+02 -1.7615998840332031e+02 -3.2709802246093750e+02 1.6071600341796875e+02 -1.1189600372314453e+02 -3.2708401489257812e+02 1.6184799194335938e+02 5.5040699005126953e+01 -3.2728100585937500e+02 1.5029299926757812e+02 -9.1366195678710938e+00 -3.2699099731445312e+02 1.6330200195312500e+02 5.1523700714111328e+01 -3.2613000488281250e+02 1.6540699768066406e+02 1.3582800292968750e+02 -3.2717098999023438e+02 1.5649400329589844e+02 6.8765701293945312e+01 -3.2713897705078125e+02 1.5844100952148438e+02 7.2230804443359375e+01 -3.2713897705078125e+02 1.5844100952148438e+02 7.0861602783203125e+01 -3.2713601684570312e+02 1.5857099914550781e+02 7.2053703308105469e+01 -3.2713699340820312e+02 1.5852000427246094e+02 -6.9020797729492188e+01 -3.2690298461914062e+02 1.6466699218750000e+02 6.7366798400878906e+01 -3.2713400268554688e+02 1.5871598815917969e+02 -3.1965701293945312e+02 -2.6117599487304688e+02 1.4095700073242188e+02 -3.2693200683593750e+02 -2.3180699157714844e+02 1.3650900268554688e+02 -3.0651901245117188e+02 -2.8348999023437500e+02 1.4657199096679688e+02 -2.6593597412109375e+02 -3.1660101318359375e+02 1.5708700561523438e+02 -2.9085699462890625e+02 -3.0013900756835938e+02 1.5192500305175781e+02 -3.2446701049804688e+02 2.5293200683593750e+02 9.5469398498535156e+01 -3.1331698608398438e+02 2.7737399291992188e+02 9.4438301086425781e+01 -2.9489099121093750e+02 3.0032699584960938e+02 9.2717994689941406e+01 -2.4774200439453125e+02 3.2546298217773438e+02 8.8283004760742188e+01 -2.7051602172851562e+02 3.1705700683593750e+02 9.0411994934082031e+01 -3.2756701660156250e+02 1.2531499481201172e+02 1.3281401062011719e+02 -3.2724099731445312e+02 1.5401600646972656e+02 1.3927799987792969e+02 -3.2593899536132812e+02 -3.3571399688720703e+01 1.4755000305175781e+02 -3.2760000610351562e+02 -2.7569299697875977e+01 1.3800700378417969e+02 -3.2741299438476562e+02 1.8479199218750000e+02 1.3618899536132812e+02 -3.2749398803710938e+02 2.2315100097656250e+02 1.3386300659179688e+02 -3.2746499633789062e+02 1.9822200775146484e+01 1.3811000061035156e+02 3.1641400146484375e+02 -2.2644999694824219e+02 1.6091799926757812e+02 3.1488101196289062e+02 -1.0623200225830078e+02 1.6526100158691406e+02 3.0612200927734375e+02 -2.9491800308227539e+01 1.6855398559570312e+02 3.1378100585937500e+02 -2.5191200256347656e+02 1.5838099670410156e+02 2.8745401000976562e+02 -2.9413299560546875e+02 1.5808900451660156e+02 2.2658599853515625e+02 -3.2358801269531250e+02 1.5932899475097656e+02 -1.7785800170898438e+02 -3.2652700805664062e+02 1.6483599853515625e+02 -2.0237500000000000e+02 -3.2555801391601562e+02 1.6567799377441406e+02 -1.7932798767089844e+02 -3.2473098754882812e+02 1.6793099975585938e+02 -1.5150900268554688e+02 -3.2680599975585938e+02 1.6396099853515625e+02 -1.3496800231933594e+02 -3.2525698852539062e+02 1.6834999084472656e+02 -8.8504800796508789e+00 -3.2523001098632812e+02 1.6805000305175781e+02 -3.2386199951171875e+02 1.5032800292968750e+02 1.5052899169921875e+02 -3.2293701171875000e+02 -1.5748699951171875e+02 1.5246400451660156e+02 2.5544100952148438e+02 -2.6166702270507812e+02 1.7052400207519531e+02 3.0282299804687500e+02 -5.8106300354003906e+01 1.6934700012207031e+02 2.9760198974609375e+02 -4.2628799438476562e+01 1.7069000244140625e+02 3.0507901000976562e+02 -1.3638999938964844e+02 1.6768400573730469e+02 2.1387100219726562e+02 -2.9993798828125000e+02 1.6931599426269531e+02 -2.2204600524902344e+02 -3.2106799316406250e+02 1.7079701232910156e+02 -1.8054600524902344e+02 -3.2292102050781250e+02 1.7031799316406250e+02 -1.8002900695800781e+02 -3.2363998413085938e+02 1.6921099853515625e+02 -3.1016497802734375e+02 -2.3015100097656250e+02 1.6975498962402344e+02 -3.1407601928710938e+02 -1.7473899841308594e+02 1.7088200378417969e+02 3.0492098999023438e+02 1.0516300201416016e+01 1.6976000976562500e+02 3.0332800292968750e+02 -3.3155097961425781e+01 1.7165699768066406e+02 2.9415899658203125e+02 -4.1012100219726562e+01 1.7449000549316406e+02 3.0460101318359375e+02 2.9287200927734375e+01 1.7010099792480469e+02 2.9919201660156250e+02 3.8502799987792969e+01 1.7304199218750000e+02 2.8874798583984375e+02 4.1856300354003906e+01 1.7458699035644531e+02 -3.0493301391601562e+02 -2.2846299743652344e+02 1.7358100891113281e+02 -3.1627600097656250e+02 1.6320199584960938e+02 1.6055799865722656e+02 -3.1827801513671875e+02 1.5213999938964844e+02 1.5573899841308594e+02 -3.0509799194335938e+02 1.6375700378417969e+02 1.6438299560546875e+02 -3.2194900512695312e+02 2.4537399291992188e+01 1.5401600646972656e+02 -3.1455697631835938e+02 1.9115900039672852e+01 1.5718199157714844e+02 -3.1270901489257812e+02 -4.9305801391601562e+01 1.5828799438476562e+02 -3.1630700683593750e+02 -1.5177200317382812e+02 1.5641699218750000e+02 -3.1061300659179688e+02 -1.2055300140380859e+02 1.5739599609375000e+02 -3.1427301025390625e+02 -1.6215899658203125e+02 1.6066299438476562e+02 -3.0157299804687500e+02 -1.6569200134277344e+02 1.7182398986816406e+02 -3.0350802612304688e+02 1.5475498962402344e+02 1.5961801147460938e+02 -3.1233901977539062e+02 -2.0917798995971680e+01 1.6161599731445312e+02 -3.1180599975585938e+02 5.4337898254394531e+01 1.6234600830078125e+02 -3.1248001098632812e+02 1.5646899223327637e+01 1.6002499389648438e+02 -3.1203100585937500e+02 5.8979400634765625e+01 1.5925900268554688e+02 -3.1236801147460938e+02 9.6297599792480469e+01 1.5731700134277344e+02 -3.0872100830078125e+02 1.1442900085449219e+02 1.6050498962402344e+02 -3.0471398925781250e+02 -1.5420399475097656e+02 1.5857798767089844e+02 -3.0895001220703125e+02 -1.1543399810791016e+02 1.6111401367187500e+02 -3.0524298095703125e+02 -1.6322499084472656e+02 1.6386000061035156e+02 -2.9724697875976562e+02 -1.7182699584960938e+02 1.7868899536132812e+02 -3.0170199584960938e+02 1.6335299682617188e+02 1.7239401245117188e+02 -3.1284698486328125e+02 1.6672999572753906e+02 2.5202798461914062e+02 -3.2143301391601562e+02 1.7361000061035156e+02 3.3749099731445312e+02 -3.2953100585937500e+02 8.2005996704101562e+01 4.1253701782226562e+02 -3.1772399902343750e+02 3.2468399047851562e+01 2.2300599670410156e+02 -2.0275999450683594e+02 -2.6726800537109375e+02 1.8476699829101562e+02 -2.2279399108886719e+02 -2.4315299987792969e+02 2.0999099731445312e+02 -2.3953099060058594e+02 -2.2955599975585938e+02 2.4698699951171875e+02 -2.5018000793457031e+02 -2.2291499328613281e+02 2.9407998657226562e+02 -2.4970899963378906e+02 -2.1475399780273438e+02 3.0451000976562500e+02 -2.5513198852539062e+02 -1.9814999389648438e+02 3.4915798950195312e+02 -2.5269299316406250e+02 -2.1032199096679688e+02 3.5886898803710938e+02 -2.5446600341796875e+02 -1.9991099548339844e+02 4.0204302978515625e+02 -2.5721401977539062e+02 -1.9676899719238281e+02 4.1741897583007812e+02 -2.5502999877929688e+02 -1.9741400146484375e+02 5.1954797363281250e+02 -2.5500000000000000e+02 -1.5934300231933594e+02 5.1954797363281250e+02 -2.5823199462890625e+02 -1.9618000793457031e+02 4.6032800292968750e+02 -2.5329101562500000e+02 -2.0433799743652344e+02 5.1956701660156250e+02 -3.1909899902343750e+02 -1.9309599304199219e+02 6.0515795898437500e+02 -3.0545602416992188e+02 -2.0641799926757812e+02 6.0515704345703125e+02 -2.5500000000000000e+02 -2.0825700378417969e+02 6.0518096923828125e+02 -3.3568099975585938e+02 -1.2105299949645996e+01 6.0515997314453125e+02 -3.2935000610351562e+02 1.7470599365234375e+02 6.0516796875000000e+02 -3.3431500244140625e+02 8.5528205871582031e+01 6.0516796875000000e+02 -3.1781701660156250e+02 1.9390699768066406e+02 6.0516998291015625e+02 -3.0496298217773438e+02 2.0630900573730469e+02 6.0517199707031250e+02 -2.5500000000000000e+02 2.0825100708007812e+02 6.0518298339843750e+02 -3.2984301757812500e+02 -1.7271200561523438e+02 6.0517297363281250e+02 -2.5495300292968750e+02 1.9707800292968750e+02 5.1956396484375000e+02 -2.5500000000000000e+02 1.5934300231933594e+02 5.1954797363281250e+02 -2.5548699951171875e+02 1.9827301025390625e+02 3.8352700805664062e+02 -2.5636898803710938e+02 1.9681001281738281e+02 4.7587200927734375e+02 -2.5358599853515625e+02 2.0324101257324219e+02 4.6423599243164062e+02 -2.5371000671386719e+02 2.1019900512695312e+02 3.7048797607421875e+02 -2.0922000122070312e+02 2.5864801025390625e+02 1.9109599304199219e+02 -2.2512899780273438e+02 2.4139100646972656e+02 2.1429400634765625e+02 -2.3936801147460938e+02 2.2954100036621094e+02 2.4531399536132812e+02 -1.9598999023437500e+02 2.7671398925781250e+02 1.8085600280761719e+02 -3.0971200561523438e+02 -1.6624600219726562e+02 2.3053300476074219e+02 -3.0113598632812500e+02 -2.1763099670410156e+02 3.0714602661132812e+02 -3.2332299804687500e+02 -1.7587100219726562e+02 3.6520901489257812e+02 -2.7903802490234375e+02 -2.1911099243164062e+02 1.9331900024414062e+02 -2.9199002075195312e+02 -2.2284899902343750e+02 2.4740499877929688e+02 -2.9717498779296875e+02 -2.0201300048828125e+02 2.4540299987792969e+02 -3.0441201782226562e+02 1.9688600158691406e+02 2.7567398071289062e+02 -2.9479101562500000e+02 2.2127400207519531e+02 2.6209197998046875e+02 -2.8853100585937500e+02 2.2532499694824219e+02 2.3627400207519531e+02 -3.2213000488281250e+02 -9.9647598266601562e+01 2.9715402221679688e+02 -3.3085299682617188e+02 -4.5833900451660156e+01 4.3428799438476562e+02 -3.2891400146484375e+02 1.7582798767089844e+02 4.9897998046875000e+02 -2.9340402221679688e+02 -2.2323399353027344e+02 2.7301800537109375e+02 -2.8330001831054688e+02 -2.2965000915527344e+02 2.3834899902343750e+02 -2.5477900695800781e+02 -2.1310099792480469e+02 3.6739700317382812e+02 -2.5486001586914062e+02 -2.1820799255371094e+02 3.7055001831054688e+02 -2.5323098754882812e+02 -2.0838198852539062e+02 4.1945401000976562e+02 -2.5497698974609375e+02 -2.1187500000000000e+02 5.2882702636718750e+02 -2.5500000000000000e+02 -1.5934599304199219e+02 6.0518597412109375e+02 -2.5490098571777344e+02 -2.0725299072265625e+02 5.1955401611328125e+02 -3.2811199951171875e+02 -1.7760301208496094e+02 4.7830297851562500e+02 -3.2433200073242188e+02 -1.8688800048828125e+02 5.4137701416015625e+02 -3.0391601562500000e+02 -2.1531700134277344e+02 3.7580999755859375e+02 -3.3335598754882812e+02 -8.7930503845214844e+01 5.3862298583984375e+02 -3.2280999755859375e+02 1.8986799621582031e+02 5.1736804199218750e+02 -3.2085800170898438e+02 1.8414099121093750e+02 3.7886599731445312e+02 -3.0456701660156250e+02 2.1263900756835938e+02 4.6054199218750000e+02 -3.0566299438476562e+02 2.0894599914550781e+02 5.3762799072265625e+02 -3.0058898925781250e+02 2.1900700378417969e+02 3.0662500000000000e+02 -3.0277899169921875e+02 2.1115800476074219e+02 5.0672198486328125e+02 -3.0196899414062500e+02 2.0997999572753906e+02 5.3383599853515625e+02 -2.5498802185058594e+02 2.1765499877929688e+02 3.8479800415039062e+02 -2.5557899475097656e+02 2.1074398803710938e+02 5.4078100585937500e+02 -2.5244599914550781e+02 2.2113000488281250e+02 3.1606701660156250e+02 -2.5500000000000000e+02 1.5934400939941406e+02 6.0518597412109375e+02 -2.5428599548339844e+02 2.0588600158691406e+02 5.1952203369140625e+02 -2.5233099365234375e+02 2.1589801025390625e+02 3.2177600097656250e+02 -2.8729598999023438e+02 2.2629299926757812e+02 2.5503199768066406e+02 -2.5481001281738281e+02 -2.0962600708007812e+02 4.6008398437500000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3600 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02) (float-vector 2.9603600502014160e+02 -3.2186999917030334e+01 2.3927299678325653e+02) (float-vector 3.1378099322319031e+02 -2.5191199779510498e+02 1.5838100016117096e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02) (float-vector 2.2307400405406952e+02 3.2685199379920959e+02 1.5413099527359009e+02) (float-vector 2.4674999713897705e+02 3.2253101468086243e+02 1.5247200429439545e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2307400405406952e+02 3.2685199379920959e+02 1.5413099527359009e+02) (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02) (float-vector 4.5053400099277496e+01 3.2668799161911011e+02 1.6403500735759735e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490798711776733e+02 3.3810500055551529e+01 2.3929700255393982e+02) (float-vector 2.9603600502014160e+02 -3.2186999917030334e+01 2.3927299678325653e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02) (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6038500666618347e+02 -3.1690499186515808e+02 1.5375199913978577e+02) (float-vector 2.3239700496196747e+02 -3.2586699724197388e+02 1.5397399663925171e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3239700496196747e+02 -3.2586699724197388e+02 1.5397399663925171e+02) (float-vector 5.1523700356483459e+01 -3.2613000273704529e+02 1.6540700197219849e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3522199690341949e+02 -3.2596999406814575e+02 1.6054500639438629e+02) (float-vector 5.1523700356483459e+01 -3.2613000273704529e+02 1.6540700197219849e+02) (float-vector 2.3239700496196747e+02 -3.2586699724197388e+02 1.5397399663925171e+02) (float-vector 2.3212699592113495e+02 -3.3318999409675598e+02 4.5215100049972534e+01) (float-vector -2.3000000417232513e+02 -3.3321899175643921e+02 8.6587898433208466e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0545601248741150e+02 -2.0641799271106720e+02 6.0515701770782471e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02) (float-vector 5.1523700356483459e+01 -3.2613000273704529e+02 1.6540700197219849e+02) (float-vector -2.3522199690341949e+02 -3.2596999406814575e+02 1.6054500639438629e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4861900508403778e+02 3.2278800010681152e+02 1.5946500003337860e+02) (float-vector -2.3092700541019440e+02 3.2662901282310486e+02 1.6051599383354187e+02) (float-vector -3.0496299266815186e+02 2.0630900561809540e+02 6.0517197847366333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02) (float-vector -3.0496299266815186e+02 2.0630900561809540e+02 6.0517197847366333e+02) (float-vector -2.3092700541019440e+02 3.2662901282310486e+02 1.6051599383354187e+02) (float-vector 4.5053400099277496e+01 3.2668799161911011e+02 1.6403500735759735e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1859099864959717e+02 -2.7849000692367554e+02 3.7449698895215988e+01) (float-vector 3.0749499797821045e+02 -2.9423800110816956e+02 -5.1000498235225677e+01) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3338201045989990e+02 -2.2422599792480469e+02 3.6235198378562927e+01) (float-vector 3.3335998654365540e+02 -1.4279100298881531e+02 1.1729300022125244e+02) (float-vector 3.3337798714637756e+02 1.4074200391769409e+02 1.1764100193977356e+02) (float-vector 3.3373099565505981e+02 2.2492800652980804e+02 3.6267898976802826e+01) (float-vector 3.3315101265907288e+02 2.3254199326038361e+02 -5.1000200212001801e+01) (float-vector 3.3300200104713440e+02 -2.3394499719142914e+02 -5.1002100110054016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0749499797821045e+02 -2.9423800110816956e+02 -5.1000498235225677e+01) (float-vector 2.8328999876976013e+02 -3.1575199961662292e+02 -5.0999701023101807e+01) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2442298531532288e+02 -2.6655000448226929e+02 9.5054201781749725e+01) (float-vector -3.3258500695228577e+02 -2.3938199877738953e+02 9.5798000693321228e+01) (float-vector -3.2984301447868347e+02 -1.7271199822425842e+02 6.0517299175262451e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2984301447868347e+02 -1.7271199822425842e+02 6.0517299175262451e+02) (float-vector -3.3258500695228577e+02 -2.3938199877738953e+02 9.5798000693321228e+01) (float-vector -3.3568099141120911e+02 -1.2105300091207027e+01 6.0515999794006348e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3568099141120911e+02 -1.2105300091207027e+01 6.0515999794006348e+02) (float-vector -3.3258500695228577e+02 -2.3938199877738953e+02 9.5798000693321228e+01) (float-vector -3.3225101232528687e+02 -2.4223999679088593e+02 -5.0993699580430984e+01) (float-vector -3.3221200108528137e+02 2.4176600575447083e+02 -5.0998199731111526e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0496299266815186e+02 2.0630900561809540e+02 6.0517197847366333e+02) (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02) (float-vector -3.0545601248741150e+02 -2.0641799271106720e+02 6.0515701770782471e+02) (float-vector -3.1909900903701782e+02 -1.9309599697589874e+02 6.0515797138214111e+02) (float-vector -3.2984301447868347e+02 -1.7271199822425842e+02 6.0517299175262451e+02) (float-vector -3.3568099141120911e+02 -1.2105300091207027e+01 6.0515999794006348e+02) (float-vector -3.2934999465942383e+02 1.7470599710941315e+02 6.0516798496246338e+02) (float-vector -3.1781700253486633e+02 1.9390699267387390e+02 6.0517001152038574e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2984301447868347e+02 -1.7271199822425842e+02 6.0517299175262451e+02) (float-vector -3.1909900903701782e+02 -1.9309599697589874e+02 6.0515797138214111e+02) (float-vector -3.1073099374771118e+02 -2.9012599587440491e+02 9.3821302056312561e+01) (float-vector -3.2442298531532288e+02 -2.6655000448226929e+02 9.5054201781749725e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3258500695228577e+02 -2.3938199877738953e+02 9.5798000693321228e+01) (float-vector -3.2442298531532288e+02 -2.6655000448226929e+02 9.5054201781749725e+01) (float-vector -3.2203501462936401e+02 -2.7198499441146851e+02 -5.1000300794839859e+01) (float-vector -3.3225101232528687e+02 -2.4223999679088593e+02 -5.0993699580430984e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2203501462936401e+02 -2.7198499441146851e+02 -5.1000300794839859e+01) (float-vector -3.2442298531532288e+02 -2.6655000448226929e+02 9.5054201781749725e+01) (float-vector -3.1073099374771118e+02 -2.9012599587440491e+02 9.3821302056312561e+01) (float-vector -3.0359700322151184e+02 -2.9891699552536011e+02 -5.0996400415897369e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2697000205516815e+02 3.3336201310157776e+02 8.6324602365493774e+01) (float-vector -2.3092700541019440e+02 3.2662901282310486e+02 1.6051599383354187e+02) (float-vector -2.4861900508403778e+02 3.2278800010681152e+02 1.5946500003337860e+02) (float-vector -2.6799198985099792e+02 3.2413899898529053e+02 8.9992001652717590e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2822000086307526e+02 3.3336099982261658e+02 4.5563999563455582e+01) (float-vector -2.2697000205516815e+02 3.3336201310157776e+02 8.6324602365493774e+01) (float-vector -2.3388299345970154e+02 3.3305498957633972e+02 -5.1000200212001801e+01) (float-vector 2.3840799927711487e+02 3.3261001110076904e+02 -5.1001299172639847e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5053400099277496e+01 3.2668799161911011e+02 1.6403500735759735e+02) (float-vector -2.3092700541019440e+02 3.2662901282310486e+02 1.6051599383354187e+02) (float-vector -2.2697000205516815e+02 3.3336201310157776e+02 8.6324602365493774e+01) (float-vector 2.2822000086307526e+02 3.3336099982261658e+02 4.5563999563455582e+01) (float-vector 2.2307400405406952e+02 3.2685199379920959e+02 1.5413099527359009e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2175499200820923e+02 2.3548799753189087e+02 1.5270300209522247e+02) (float-vector 3.2872700691223145e+02 2.5509300827980042e+02 3.6569599062204361e+01) (float-vector 3.3373099565505981e+02 2.2492800652980804e+02 3.6267898976802826e+01) (float-vector 3.3337798714637756e+02 1.4074200391769409e+02 1.1764100193977356e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6799198985099792e+02 3.2413899898529053e+02 8.9992001652717590e+01) (float-vector -2.6282399892807007e+02 3.2623699307441711e+02 -5.1001198589801788e+01) (float-vector -2.3388299345970154e+02 3.3305498957633972e+02 -5.1000200212001801e+01) (float-vector -2.2697000205516815e+02 3.3336201310157776e+02 8.6324602365493774e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8578698635101318e+02 3.1374499201774597e+02 -5.1000099629163742e+01) (float-vector -2.6282399892807007e+02 3.2623699307441711e+02 -5.1001198589801788e+01) (float-vector -2.6799198985099792e+02 3.2413899898529053e+02 8.9992001652717590e+01) (float-vector -2.9361599683761597e+02 3.0790099501609802e+02 9.2287302017211914e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2934999465942383e+02 1.7470599710941315e+02 6.0516798496246338e+02) (float-vector -3.2779800891876221e+02 2.5799798965454102e+02 9.5354102551937103e+01) (float-vector -3.1370601058006287e+02 2.8636699914932251e+02 9.4082497060298920e+01) (float-vector -3.1781700253486633e+02 1.9390699267387390e+02 6.0517001152038574e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3221200108528137e+02 2.4176600575447083e+02 -5.0998199731111526e+01) (float-vector -3.2779800891876221e+02 2.5799798965454102e+02 9.5354102551937103e+01) (float-vector -3.2934999465942383e+02 1.7470599710941315e+02 6.0516798496246338e+02) (float-vector -3.3568099141120911e+02 -1.2105300091207027e+01 6.0515999794006348e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2779800891876221e+02 2.5799798965454102e+02 9.5354102551937103e+01) (float-vector -3.2179600000381470e+02 2.7240398526191711e+02 -5.1000598818063736e+01) (float-vector -3.1370601058006287e+02 2.8636699914932251e+02 9.4082497060298920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2179600000381470e+02 2.7240398526191711e+02 -5.1000598818063736e+01) (float-vector -3.2779800891876221e+02 2.5799798965454102e+02 9.5354102551937103e+01) (float-vector -3.3221200108528137e+02 2.4176600575447083e+02 -5.0998199731111526e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3373099565505981e+02 2.2492800652980804e+02 3.6267898976802826e+01) (float-vector 3.2872700691223145e+02 2.5509300827980042e+02 3.6569599062204361e+01) (float-vector 3.2558101415634155e+02 2.6504299044609070e+02 -5.1001399755477905e+01) (float-vector 3.3315101265907288e+02 2.3254199326038361e+02 -5.1000200212001801e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7867600321769714e+02 3.1863901019096375e+02 4.1054401546716690e+01) (float-vector 2.8756600618362427e+02 3.1275299191474915e+02 -5.1000401377677917e+01) (float-vector 3.0837300419807434e+02 2.9295700788497925e+02 -5.1000200212001801e+01) (float-vector 3.0261400341987610e+02 2.9948499798774719e+02 3.8896098732948303e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1859099864959717e+02 -2.7849000692367554e+02 3.7449698895215988e+01) (float-vector 3.2534199953079224e+02 -2.6543501019477844e+02 -5.0973501056432724e+01) (float-vector 3.0749499797821045e+02 -2.9423800110816956e+02 -5.1000498235225677e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1946000456809998e+02 -2.4776400625705719e+02 1.5087300539016724e+02) (float-vector 3.1106400489807129e+02 -2.6823300123214722e+02 1.5271499752998352e+02) (float-vector 3.1378099322319031e+02 -2.5191199779510498e+02 1.5838100016117096e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5936499238014221e+02 -3.2758399844169617e+02 4.2793199419975281e+01) (float-vector 2.6038500666618347e+02 -3.1690499186515808e+02 1.5375199913978577e+02) (float-vector 2.7943000197410583e+02 -3.0592998862266541e+02 1.5210700035095215e+02) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3212699592113495e+02 -3.3318999409675598e+02 4.5215100049972534e+01) (float-vector 2.5936499238014221e+02 -3.2758399844169617e+02 4.2793199419975281e+01) (float-vector 2.5389701128005981e+02 -3.2920598983764648e+02 -5.1000498235225677e+01) (float-vector 2.2956000268459320e+02 -3.3329001069068909e+02 -5.0999999046325684e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8328999876976013e+02 -3.1575199961662292e+02 -5.0999701023101807e+01) (float-vector 2.5389701128005981e+02 -3.2920598983764648e+02 -5.1000498235225677e+01) (float-vector 2.5936499238014221e+02 -3.2758399844169617e+02 4.2793199419975281e+01) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3212699592113495e+02 -3.3318999409675598e+02 4.5215100049972534e+01) (float-vector 2.3239700496196747e+02 -3.2586699724197388e+02 1.5397399663925171e+02) (float-vector 2.6038500666618347e+02 -3.1690499186515808e+02 1.5375199913978577e+02) (float-vector 2.5936499238014221e+02 -3.2758399844169617e+02 4.2793199419975281e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6593598723411560e+02 -3.1660100817680359e+02 1.5708699822425842e+02) (float-vector -3.0545601248741150e+02 -2.0641799271106720e+02 6.0515701770782471e+02) (float-vector -2.3522199690341949e+02 -3.2596999406814575e+02 1.6054500639438629e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5065198540687561e+02 3.3002099394798279e+02 4.3568998575210571e+01) (float-vector 2.4674999713897705e+02 3.2253101468086243e+02 1.5247200429439545e+02) (float-vector 2.2307400405406952e+02 3.2685199379920959e+02 1.5413099527359009e+02) (float-vector 2.2822000086307526e+02 3.3336099982261658e+02 4.5563999563455582e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7867600321769714e+02 3.1863901019096375e+02 4.1054401546716690e+01) (float-vector 2.5065198540687561e+02 3.3002099394798279e+02 4.3568998575210571e+01) (float-vector 2.6423498988151550e+02 3.2544600963592529e+02 -5.0999600440263748e+01) (float-vector 2.8756600618362427e+02 3.1275299191474915e+02 -5.1000401377677917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5065198540687561e+02 3.3002099394798279e+02 4.3568998575210571e+01) (float-vector 2.2822000086307526e+02 3.3336099982261658e+02 4.5563999563455582e+01) (float-vector 2.3840799927711487e+02 3.3261001110076904e+02 -5.1001299172639847e+01) (float-vector 2.6423498988151550e+02 3.2544600963592529e+02 -5.0999600440263748e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7867600321769714e+02 3.1863901019096375e+02 4.1054401546716690e+01) (float-vector 2.7030000090599060e+02 3.1249299645423889e+02 1.5154999494552612e+02) (float-vector 2.4674999713897705e+02 3.2253101468086243e+02 1.5247200429439545e+02) (float-vector 2.5065198540687561e+02 3.3002099394798279e+02 4.3568998575210571e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02) (float-vector 2.4674999713897705e+02 3.2253101468086243e+02 1.5247200429439545e+02) (float-vector 2.7030000090599060e+02 3.1249299645423889e+02 1.5154999494552612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2175499200820923e+02 2.3548799753189087e+02 1.5270300209522247e+02) (float-vector 3.1447100639343262e+02 2.6122599840164185e+02 1.5284499526023865e+02) (float-vector 3.2872700691223145e+02 2.5509300827980042e+02 3.6569599062204361e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9603600502014160e+02 -3.2186999917030334e+01 2.3927299678325653e+02) (float-vector 3.0025500059127808e+02 -3.3223200589418411e+01 2.3401799798011780e+02) (float-vector 3.2252898812294006e+02 -2.2448100149631500e+02 1.5353299677371979e+02) (float-vector 3.1946000456809998e+02 -2.4776400625705719e+02 1.5087300539016724e+02) (float-vector 3.1378099322319031e+02 -2.5191199779510498e+02 1.5838100016117096e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7596300840377808e+02 3.1145098805427551e+02 1.5510000288486481e+02) (float-vector -2.6799198985099792e+02 3.2413899898529053e+02 8.9992001652717590e+01) (float-vector -2.4861900508403778e+02 3.2278800010681152e+02 1.5946500003337860e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7596300840377808e+02 3.1145098805427551e+02 1.5510000288486481e+02) (float-vector -2.4861900508403778e+02 3.2278800010681152e+02 1.5946500003337860e+02) (float-vector -3.0496299266815186e+02 2.0630900561809540e+02 6.0517197847366333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7596300840377808e+02 3.1145098805427551e+02 1.5510000288486481e+02) (float-vector -2.9361599683761597e+02 3.0790099501609802e+02 9.2287302017211914e+01) (float-vector -2.6799198985099792e+02 3.2413899898529053e+02 8.9992001652717590e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1370601058006287e+02 2.8636699914932251e+02 9.4082497060298920e+01) (float-vector -2.9361599683761597e+02 3.0790099501609802e+02 9.2287302017211914e+01) (float-vector -2.7596300840377808e+02 3.1145098805427551e+02 1.5510000288486481e+02) (float-vector -3.0496299266815186e+02 2.0630900561809540e+02 6.0517197847366333e+02) (float-vector -3.1781700253486633e+02 1.9390699267387390e+02 6.0517001152038574e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2179600000381470e+02 2.7240398526191711e+02 -5.1000598818063736e+01) (float-vector -3.0551499128341675e+02 2.9663398861885071e+02 -5.1000498235225677e+01) (float-vector -3.1370601058006287e+02 2.8636699914932251e+02 9.4082497060298920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0551499128341675e+02 2.9663398861885071e+02 -5.1000498235225677e+01) (float-vector -2.8578698635101318e+02 3.1374499201774597e+02 -5.1000099629163742e+01) (float-vector -2.9361599683761597e+02 3.0790099501609802e+02 9.2287302017211914e+01) (float-vector -3.1370601058006287e+02 2.8636699914932251e+02 9.4082497060298920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1850299239158630e+02 2.7859300374984741e+02 3.7477299571037292e+01) (float-vector 3.2558101415634155e+02 2.6504299044609070e+02 -5.1001399755477905e+01) (float-vector 3.2872700691223145e+02 2.5509300827980042e+02 3.6569599062204361e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1850299239158630e+02 2.7859300374984741e+02 3.7477299571037292e+01) (float-vector 3.0261400341987610e+02 2.9948499798774719e+02 3.8896098732948303e+01) (float-vector 3.0837300419807434e+02 2.9295700788497925e+02 -5.1000200212001801e+01) (float-vector 3.2558101415634155e+02 2.6504299044609070e+02 -5.1001399755477905e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3044299483299255e+02 -2.4968099594116211e+02 3.6400701850652695e+01) (float-vector 3.3338201045989990e+02 -2.2422599792480469e+02 3.6235198378562927e+01) (float-vector 3.3300200104713440e+02 -2.3394499719142914e+02 -5.1002100110054016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2534199953079224e+02 -2.6543501019477844e+02 -5.0973501056432724e+01) (float-vector 3.3044299483299255e+02 -2.4968099594116211e+02 3.6400701850652695e+01) (float-vector 3.3300200104713440e+02 -2.3394499719142914e+02 -5.1002100110054016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3044299483299255e+02 -2.4968099594116211e+02 3.6400701850652695e+01) (float-vector 3.2534199953079224e+02 -2.6543501019477844e+02 -5.0973501056432724e+01) (float-vector 3.1859099864959717e+02 -2.7849000692367554e+02 3.7449698895215988e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3044299483299255e+02 -2.4968099594116211e+02 3.6400701850652695e+01) (float-vector 3.1946000456809998e+02 -2.4776400625705719e+02 1.5087300539016724e+02) (float-vector 3.2252898812294006e+02 -2.2448100149631500e+02 1.5353299677371979e+02) (float-vector 3.3335998654365540e+02 -1.4279100298881531e+02 1.1729300022125244e+02) (float-vector 3.3338201045989990e+02 -2.2422599792480469e+02 3.6235198378562927e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1946000456809998e+02 -2.4776400625705719e+02 1.5087300539016724e+02) (float-vector 3.3044299483299255e+02 -2.4968099594116211e+02 3.6400701850652695e+01) (float-vector 3.1859099864959717e+02 -2.7849000692367554e+02 3.7449698895215988e+01) (float-vector 3.1106400489807129e+02 -2.6823300123214722e+02 1.5271499752998352e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7943000197410583e+02 -3.0592998862266541e+02 1.5210700035095215e+02) (float-vector 2.9685300588607788e+02 -2.9019701480865479e+02 1.5182299911975861e+02) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1378099322319031e+02 -2.5191199779510498e+02 1.5838100016117096e+02) (float-vector 3.1106400489807129e+02 -2.6823300123214722e+02 1.5271499752998352e+02) (float-vector 2.9685300588607788e+02 -2.9019701480865479e+02 1.5182299911975861e+02) (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1859099864959717e+02 -2.7849000692367554e+02 3.7449698895215988e+01) (float-vector 2.9427099227905273e+02 -3.0797898769378662e+02 3.9645701646804810e+01) (float-vector 2.9685300588607788e+02 -2.9019701480865479e+02 1.5182299911975861e+02) (float-vector 3.1106400489807129e+02 -2.6823300123214722e+02 1.5271499752998352e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5499999523162842e+02 -2.0825700461864471e+02 6.0518097877502441e+02) (float-vector 2.9685300588607788e+02 -2.9019701480865479e+02 1.5182299911975861e+02) (float-vector 2.7943000197410583e+02 -3.0592998862266541e+02 1.5210700035095215e+02) (float-vector 2.6038500666618347e+02 -3.1690499186515808e+02 1.5375199913978577e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181400775909424e+02 -3.2976898550987244e+02 8.8549703359603882e+01) (float-vector -2.6593598723411560e+02 -3.1660100817680359e+02 1.5708699822425842e+02) (float-vector -2.3522199690341949e+02 -3.2596999406814575e+02 1.6054500639438629e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3000000417232513e+02 -3.3321899175643921e+02 8.6587898433208466e+01) (float-vector -2.5181400775909424e+02 -3.2976898550987244e+02 8.8549703359603882e+01) (float-vector -2.3522199690341949e+02 -3.2596999406814575e+02 1.6054500639438629e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181400775909424e+02 -3.2976898550987244e+02 8.8549703359603882e+01) (float-vector -2.3000000417232513e+02 -3.3321899175643921e+02 8.6587898433208466e+01) (float-vector 2.3212699592113495e+02 -3.3318999409675598e+02 4.5215100049972534e+01) (float-vector 2.2956000268459320e+02 -3.3329001069068909e+02 -5.0999999046325684e+01) (float-vector -2.4389000236988068e+02 -3.3201599121093750e+02 -5.1000300794839859e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2175499200820923e+02 2.3548799753189087e+02 1.5270300209522247e+02) (float-vector 3.0006301403045654e+02 3.3962298184633255e+01 2.3393599689006805e+02) (float-vector 2.9490798711776733e+02 3.3810500055551529e+01 2.3929700255393982e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2252898812294006e+02 -2.2448100149631500e+02 1.5353299677371979e+02) (float-vector 3.0025500059127808e+02 -3.3223200589418411e+01 2.3401799798011780e+02) (float-vector 3.0006301403045654e+02 3.3962298184633255e+01 2.3393599689006805e+02) (float-vector 3.2175499200820923e+02 2.3548799753189087e+02 1.5270300209522247e+02) (float-vector 3.3337798714637756e+02 1.4074200391769409e+02 1.1764100193977356e+02) (float-vector 3.3335998654365540e+02 -1.4279100298881531e+02 1.1729300022125244e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0006301403045654e+02 3.3962298184633255e+01 2.3393599689006805e+02) (float-vector 3.0025500059127808e+02 -3.3223200589418411e+01 2.3401799798011780e+02) (float-vector 2.9603600502014160e+02 -3.2186999917030334e+01 2.3927299678325653e+02) (float-vector 2.9490798711776733e+02 3.3810500055551529e+01 2.3929700255393982e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1850299239158630e+02 2.7859300374984741e+02 3.7477299571037292e+01) (float-vector 3.0161601305007935e+02 2.8380599617958069e+02 1.5234200656414032e+02) (float-vector 3.0261400341987610e+02 2.9948499798774719e+02 3.8896098732948303e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7030000090599060e+02 3.1249299645423889e+02 1.5154999494552612e+02) (float-vector 3.0161601305007935e+02 2.8380599617958069e+02 1.5234200656414032e+02) (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7867600321769714e+02 3.1863901019096375e+02 4.1054401546716690e+01) (float-vector 3.0261400341987610e+02 2.9948499798774719e+02 3.8896098732948303e+01) (float-vector 3.0161601305007935e+02 2.8380599617958069e+02 1.5234200656414032e+02) (float-vector 2.7030000090599060e+02 3.1249299645423889e+02 1.5154999494552612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1447100639343262e+02 2.6122599840164185e+02 1.5284499526023865e+02) (float-vector 3.0161601305007935e+02 2.8380599617958069e+02 1.5234200656414032e+02) (float-vector 3.1850299239158630e+02 2.7859300374984741e+02 3.7477299571037292e+01) (float-vector 3.2872700691223145e+02 2.5509300827980042e+02 3.6569599062204361e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0161601305007935e+02 2.8380599617958069e+02 1.5234200656414032e+02) (float-vector 3.1447100639343262e+02 2.6122599840164185e+02 1.5284499526023865e+02) (float-vector 3.2175499200820923e+02 2.3548799753189087e+02 1.5270300209522247e+02) (float-vector 2.9490798711776733e+02 3.3810500055551529e+01 2.3929700255393982e+02) (float-vector -2.5499999523162842e+02 2.0825099945068359e+02 6.0518300533294678e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8578698635101318e+02 3.1374499201774597e+02 -5.1000099629163742e+01) (float-vector -3.0551499128341675e+02 2.9663398861885071e+02 -5.1000498235225677e+01) (float-vector -3.2179600000381470e+02 2.7240398526191711e+02 -5.1000598818063736e+01) (float-vector -3.3221200108528137e+02 2.4176600575447083e+02 -5.0998199731111526e+01) (float-vector -3.3225101232528687e+02 -2.4223999679088593e+02 -5.0993699580430984e+01) (float-vector -3.2203501462936401e+02 -2.7198499441146851e+02 -5.1000300794839859e+01) (float-vector -3.0359700322151184e+02 -2.9891699552536011e+02 -5.0996400415897369e+01) (float-vector -2.7797898650169373e+02 -3.1890401244163513e+02 -5.1000699400901794e+01) (float-vector -2.4389000236988068e+02 -3.3201599121093750e+02 -5.1000300794839859e+01) (float-vector 2.2956000268459320e+02 -3.3329001069068909e+02 -5.0999999046325684e+01) (float-vector 2.5389701128005981e+02 -3.2920598983764648e+02 -5.1000498235225677e+01) (float-vector 2.8328999876976013e+02 -3.1575199961662292e+02 -5.0999701023101807e+01) (float-vector 3.0749499797821045e+02 -2.9423800110816956e+02 -5.1000498235225677e+01) (float-vector 3.2534199953079224e+02 -2.6543501019477844e+02 -5.0973501056432724e+01) (float-vector 3.3300200104713440e+02 -2.3394499719142914e+02 -5.1002100110054016e+01) (float-vector 3.3315101265907288e+02 2.3254199326038361e+02 -5.1000200212001801e+01) (float-vector 3.2558101415634155e+02 2.6504299044609070e+02 -5.1001399755477905e+01) (float-vector 3.0837300419807434e+02 2.9295700788497925e+02 -5.1000200212001801e+01) (float-vector 2.8756600618362427e+02 3.1275299191474915e+02 -5.1000401377677917e+01) (float-vector 2.6423498988151550e+02 3.2544600963592529e+02 -5.0999600440263748e+01) (float-vector 2.3840799927711487e+02 3.3261001110076904e+02 -5.1001299172639847e+01) (float-vector -2.3388299345970154e+02 3.3305498957633972e+02 -5.1000200212001801e+01) (float-vector -2.6282399892807007e+02 3.2623699307441711e+02 -5.1001198589801788e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181400775909424e+02 -3.2976898550987244e+02 8.8549703359603882e+01) (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -2.6593598723411560e+02 -3.1660100817680359e+02 1.5708699822425842e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -2.7797898650169373e+02 -3.1890401244163513e+02 -5.1000699400901794e+01) (float-vector -3.0359700322151184e+02 -2.9891699552536011e+02 -5.0996400415897369e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -3.0359700322151184e+02 -2.9891699552536011e+02 -5.0996400415897369e+01) (float-vector -3.1073099374771118e+02 -2.9012599587440491e+02 9.3821302056312561e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6593598723411560e+02 -3.1660100817680359e+02 1.5708699822425842e+02) (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -3.0545601248741150e+02 -2.0641799271106720e+02 6.0515701770782471e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0545601248741150e+02 -2.0641799271106720e+02 6.0515701770782471e+02) (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -3.1073099374771118e+02 -2.9012599587440491e+02 9.3821302056312561e+01) (float-vector -3.1909900903701782e+02 -1.9309599697589874e+02 6.0515797138214111e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8527200222015381e+02 -3.1483799219131470e+02 9.1549098491668701e+01) (float-vector -2.5181400775909424e+02 -3.2976898550987244e+02 8.8549703359603882e+01) (float-vector -2.4389000236988068e+02 -3.3201599121093750e+02 -5.1000300794839859e+01) (float-vector -2.7797898650169373e+02 -3.1890401244163513e+02 -5.1000699400901794e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "base_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_bl_caster_l_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 -2.9734701156616211e+01 -9.3289899826049805e+00 2.7445201873779297e+00 -2.9418100357055664e+01 -1.2800700187683105e+01 1.0573199987411499e+00 -2.9640798568725586e+01 -1.0600199699401855e+01 1.0544799804687500e+01 -2.9430900573730469e+01 -8.4442996978759766e+00 8.2298793792724609e+00 -2.9580398559570312e+01 -6.8257398605346680e+00 1.0452800750732422e+01 -2.9676599502563477e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 -2.9607198715209961e+01 8.3633699417114258e+00 -1.0304100036621094e+01 -8.0464500427246094e+01 4.2757096290588379e+00 -9.9000797271728516e+00 -2.9565000534057617e+01 4.3990101814270020e+00 -3.0437600612640381e+00 -2.9632600784301758e+01 1.0238399505615234e+01 -3.0640001296997070e+00 -8.0891304016113281e+01 1.0639900207519531e+01 -1.0523200035095215e+01 -2.9807800292968750e+01 2.0460700988769531e+00 -1.0421499252319336e+01 -2.9872400283813477e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 -2.9559000015258789e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 -8.0892097473144531e+01 8.4554700851440430e+00 -1.0192299842834473e+01 -8.0942695617675781e+01 5.5663700103759766e+00 -1.0925999641418457e+01 -8.0888397216796875e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 -8.0911102294921875e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 -2.9603599548339844e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 -2.9594200134277344e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 -8.0856101989746094e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 -2.9677499771118164e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 -8.0903297424316406e+01 -1.1044600486755371e+01 1.0178999900817871e+00 -2.9632200241088867e+01 1.0607999801635742e+01 1.0090099573135376e+00 -8.0902297973632812e+01 1.1044500350952148e+01 7.1427397727966309e+00 -8.0804000854492188e+01 8.4595899581909180e+00 9.8030099868774414e+00 -8.0907203674316406e+01 5.1623497009277344e+00 7.4257197380065918e+00 -8.1105201721191406e+01 1.1212299346923828e+01 3.3442101478576660e+00 -8.0903900146484375e+01 -1.0557999610900879e+01 6.1998200416564941e+00 -8.1096000671386719e+01 -1.1747900009155273e+01 7.2372202873229980e+00 -8.0794494628906250e+01 -8.3683700561523438e+00 9.8025293350219727e+00 -8.0921005249023438e+01 -5.1738500595092773e+00 4.0853300094604492e+00 -8.0921997070312500e+01 1.0249599456787109e+01 1.0831099510192871e+01 -8.0742095947265625e+01 -2.0039701461791992e+00 1.2268199920654297e+01 -8.1127998352050781e+01 3.9475402832031250e+00 1.1011500358581543e+01 -8.0664100646972656e+01 0.0000000000000000e+00 1.0836700439453125e+01 -8.0821899414062500e+01 2.0019199848175049e+00 -1.1417300224304199e+01 -3.1931400299072266e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 -3.1901300430297852e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 -3.3114299774169922e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 -3.3060798645019531e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 -3.3005496978759766e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 -3.2922698974609375e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 -3.1965400695800781e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 -3.2961498260498047e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 -3.3005199432373047e+01 2.3467597961425781e+00 -4.8763401031494141e+01 -3.2972099304199219e+01 1.6582399368286133e+01 -6.1740497589111328e+01 -3.1979299545288086e+01 1.0151400566101074e+01 -4.5477100372314453e+01 -3.3045398712158203e+01 2.1893899917602539e+01 1.6372301101684570e+01 -3.1941600799560547e+01 5.8962200164794922e+01 2.3468399047851562e+00 -3.3007396697998047e+01 5.1267200469970703e+01 -9.9129495620727539e+00 -3.3083801269531250e+01 4.9431499481201172e+01 -3.6015296936035156e+01 -3.3108100891113281e+01 3.4995300292968750e+01 -4.8726200103759766e+01 -3.1919502258300781e+01 3.8182498931884766e+01 -2.5745399475097656e+01 -3.3058502197265625e+01 4.3290298461914062e+01 -6.4798698425292969e+00 -3.1922300338745117e+01 6.1833000183105469e+01 -3.9104801177978516e+01 -3.3105998992919922e+01 -3.1760398864746094e+01 3.8039699554443359e+01 -3.1931098937988281e+01 4.8811397552490234e+01 2.0110498428344727e+01 -3.2998302459716797e+01 6.3504100799560547e+01 4.7388999938964844e+01 -3.3059799194335938e+01 4.7388999938964844e+01 5.0501701354980469e+01 -3.2199699401855469e+01 3.8274200439453125e+01 6.3447898864746094e+01 -3.3059898376464844e+01 2.0092599868774414e+01 6.0778099060058594e+01 -3.2144401550292969e+01 1.7475801467895508e+01 6.0313198089599609e+01 -3.1965400695800781e+01 7.4321599006652832e+00 6.3284599304199219e+01 -3.2191196441650391e+01 -4.4547400474548340e+00 5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 5.5512199401855469e+01 -3.1871200561523438e+01 -2.7132499694824219e+01 2.8417900085449219e+01 -3.3024398803710938e+01 -6.0260898590087891e+01 4.4547300338745117e+00 -3.2191101074218750e+01 -6.3284301757812500e+01 3.3109401702880859e+01 -3.1901699066162109e+01 -5.2159999847412109e+01 4.6935901641845703e+01 -3.2998600006103516e+01 -4.6935901641845703e+01 4.6696701049804688e+00 -3.3059997558593750e+01 -6.6339698791503906e+01 6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 -3.3019302368164062e+01 6.5981704711914062e+01 -4.4070800781250000e+01 -3.3025100708007812e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 -3.2243999481201172e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 -3.2244602203369141e+01 -3.8144996643066406e+01 1.5174099922180176e+01 -3.2350498199462891e+01 -6.8473693847656250e+01 4.8838300704956055e+00 -3.2246299743652344e+01 -6.9384094238281250e+01 4.1918899536132812e+01 -3.2255702972412109e+01 -5.5662799835205078e+01 5.6185497283935547e+01 -3.2231498718261719e+01 -4.1026100158691406e+01 6.9456398010253906e+01 -3.2233699798583984e+01 -1.5821299552917480e+00 6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 -3.2246299743652344e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 -3.2998302459716797e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 -3.2240303039550781e+01 1.4109100103378296e+00 -6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 -3.8389400482177734e+01 7.4474800109863281e+01 -1.7341400384902954e+00 -3.8391998291015625e+01 7.6071098327636719e+01 5.1130599975585938e+00 -3.4403301239013672e+01 7.2644706726074219e+01 7.1366401672363281e+01 -3.4439002990722656e+01 1.3268600463867188e+01 6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 6.7477394104003906e+01 -3.4428897857666016e+01 2.6760299682617188e+01 7.5355300903320312e+01 -3.7268402099609375e+01 1.7170599699020386e+00 5.9104999542236328e+01 -3.2233699798583984e+01 3.6562202453613281e+01 7.0040397644042969e+01 -3.8387001037597656e+01 2.9782499313354492e+01 7.4474800109863281e+01 -3.8389400482177734e+01 1.5645200729370117e+01 6.2013099670410156e+01 -3.7266197204589844e+01 4.2893001556396484e+01 5.1923801422119141e+01 -3.7266002655029297e+01 5.4677501678466797e+01 4.9207698822021484e+01 -3.2231403350830078e+01 4.9181400299072266e+01 3.9661300659179688e+01 -3.7265899658203125e+01 6.4126296997070312e+01 6.6670997619628906e+01 -4.3020999908447266e+01 4.1205699920654297e+01 7.3550094604492188e+01 -4.3022300720214844e+01 2.7057100296020508e+01 7.7358497619628906e+01 -4.3024600982666016e+01 1.2475700378417969e+01 5.6843299865722656e+01 -4.3021598815917969e+01 5.3966102600097656e+01 2.5049600601196289e+01 -3.4442001342773438e+01 6.8122604370117188e+01 3.6946399688720703e+01 -3.2240901947021484e+01 5.8903797149658203e+01 4.4562896728515625e+01 -4.3020900726318359e+01 6.4476997375488281e+01 1.2114600181579590e+01 -3.8389999389648438e+01 7.5127197265625000e+01 2.6272998809814453e+01 -3.8387500762939453e+01 7.1428794860839844e+01 2.1015600204467773e+01 -3.2246299743652344e+01 6.6359199523925781e+01 3.0671701431274414e+01 -4.3021900177001953e+01 7.2120101928710938e+01 1.6111700057983398e+01 -4.3023998260498047e+01 7.6686698913574219e+01 1.7856500148773193e+00 -4.3026500701904297e+01 7.8329895019531250e+01 7.8330101013183594e+01 -4.3027000427246094e+01 -1.7853500843048096e+00 7.9383201599121094e+01 -4.8954898834228516e+01 -3.4461998939514160e-01 7.8114799499511719e+01 -4.8949199676513672e+01 1.4203499794006348e+01 7.3951698303222656e+01 -4.8940597534179688e+01 2.8930398941040039e+01 6.6686599731445312e+01 -4.8934600830078125e+01 4.3129802703857422e+01 5.6477798461914062e+01 -4.8932300567626953e+01 5.5839900970458984e+01 4.3869800567626953e+01 -4.8934097290039062e+01 6.6202606201171875e+01 2.9704099655151367e+01 -4.8939601898193359e+01 7.3644798278808594e+01 1.4941699981689453e+01 -4.8947898864746094e+01 7.7977600097656250e+01 3.4459200501441956e-01 -4.8954898834228516e+01 7.9383300781250000e+01 -6.4126296997070312e+01 -3.7265899658203125e+01 3.9661300659179688e+01 -5.3850097656250000e+01 -3.6490200042724609e+01 5.2007102966308594e+01 -5.6481498718261719e+01 -3.2248001098632812e+01 4.0724998474121094e+01 -4.8838300704956055e+00 -3.2246299743652344e+01 6.9384094238281250e+01 -1.5174099922180176e+01 -3.2350498199462891e+01 6.8473693847656250e+01 -1.2475700378417969e+01 -4.3024600982666016e+01 7.7358497619628906e+01 -2.9782499313354492e+01 -3.8387001037597656e+01 7.0040397644042969e+01 -4.2893001556396484e+01 -3.7266197204589844e+01 6.2013099670410156e+01 -2.8395601272583008e+01 -3.4441600799560547e+01 6.6799201965332031e+01 -4.3375499725341797e+01 -3.2257099151611328e+01 5.4680000305175781e+01 -2.7057100296020508e+01 -4.3022300720214844e+01 7.3550094604492188e+01 -4.1205699920654297e+01 -4.3020999908447266e+01 6.6670997619628906e+01 -5.3966102600097656e+01 -4.3021598815917969e+01 5.6843299865722656e+01 -6.4476997375488281e+01 -4.3020900726318359e+01 4.4562896728515625e+01 -6.7513504028320312e+01 -3.4440597534179688e+01 2.6707201004028320e+01 -7.5355300903320312e+01 -3.7268402099609375e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 -3.4436901092529297e+01 1.3211199760437012e+01 -6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 -7.5127197265625000e+01 -3.8389999389648438e+01 1.2114600181579590e+01 -7.1428794860839844e+01 -3.8387500762939453e+01 2.6272998809814453e+01 -7.2120101928710938e+01 -4.3021900177001953e+01 3.0671701431274414e+01 -7.6686698913574219e+01 -4.3023998260498047e+01 1.6111700057983398e+01 -1.4203499794006348e+01 -4.8949199676513672e+01 7.8114799499511719e+01 -2.8930398941040039e+01 -4.8940597534179688e+01 7.3951698303222656e+01 -4.3129802703857422e+01 -4.8934600830078125e+01 6.6686599731445312e+01 -5.4402599334716797e+01 -4.9551700592041016e+01 5.7758701324462891e+01 -1.7856500148773193e+00 -5.4973503112792969e+01 7.8329895019531250e+01 -7.8330101013183594e+01 -4.3027000427246094e+01 1.7853500843048096e+00 -6.4116600036621094e+01 -4.8947498321533203e+01 4.6979301452636719e+01 -6.7437301635742188e+01 -4.7811298370361328e+01 4.1716197967529297e+01 -7.3951698303222656e+01 -4.9059398651123047e+01 2.8930398941040039e+01 -7.8114799499511719e+01 -4.9050800323486328e+01 1.4203499794006348e+01 -7.9383201599121094e+01 -4.9045101165771484e+01 -3.4461998939514160e-01 7.8330101013183594e+01 -5.4972999572753906e+01 1.7853500843048096e+00 7.6686698913574219e+01 -5.4976001739501953e+01 1.6111700057983398e+01 7.2120101928710938e+01 -5.4978099822998047e+01 3.0671701431274414e+01 6.4476997375488281e+01 -5.4979099273681641e+01 4.4562896728515625e+01 5.3966102600097656e+01 -5.4978401184082031e+01 5.6843299865722656e+01 7.5127197265625000e+01 -5.9610000610351562e+01 1.2114600181579590e+01 7.5355300903320312e+01 -6.0731601715087891e+01 -1.7170599699020386e+00 7.1428794860839844e+01 -5.9612503051757812e+01 2.6272998809814453e+01 6.4126296997070312e+01 -6.0734100341796875e+01 3.9661300659179688e+01 5.3850097656250000e+01 -6.1509799957275391e+01 5.2007102966308594e+01 4.1205699920654297e+01 -5.4979000091552734e+01 6.6670997619628906e+01 2.7057100296020508e+01 -5.4977699279785156e+01 7.3550094604492188e+01 1.2475700378417969e+01 -5.4975402832031250e+01 7.7358497619628906e+01 -1.2114600181579590e+01 -5.9610000610351562e+01 7.5127197265625000e+01 1.7341400384902954e+00 -5.9608001708984375e+01 7.6071098327636719e+01 4.2893001556396484e+01 -6.0733798980712891e+01 6.2013099670410156e+01 2.9782499313354492e+01 -5.9612998962402344e+01 7.0040397644042969e+01 1.5645200729370117e+01 -5.9610603332519531e+01 7.4474800109863281e+01 5.6481498718261719e+01 -6.5751998901367188e+01 4.0724998474121094e+01 6.7513504028320312e+01 -6.3559398651123047e+01 2.6707201004028320e+01 7.1374496459960938e+01 -6.3563102722167969e+01 1.3211199760437012e+01 6.9488693237304688e+01 -6.5759704589843750e+01 1.4108999967575073e+00 6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 2.8395601272583008e+01 -6.3558399200439453e+01 6.6799201965332031e+01 4.3375499725341797e+01 -6.5742904663085938e+01 5.4680000305175781e+01 -5.1130700111389160e+00 -6.3596702575683594e+01 7.2644706726074219e+01 1.5174099922180176e+01 -6.5649505615234375e+01 6.8473693847656250e+01 -1.6111700057983398e+01 -5.4976001739501953e+01 7.6686698913574219e+01 -3.0671701431274414e+01 -5.4978099822998047e+01 7.2120101928710938e+01 -4.4562896728515625e+01 -5.4979099273681641e+01 6.4476997375488281e+01 -5.6843299865722656e+01 -5.4978401184082031e+01 5.3966102600097656e+01 -2.6272998809814453e+01 -5.9612503051757812e+01 7.1428794860839844e+01 -3.9661300659179688e+01 -6.0734100341796875e+01 6.4126296997070312e+01 -5.1923801422119141e+01 -6.0734001159667969e+01 5.4677501678466797e+01 -7.7358497619628906e+01 -5.4975402832031250e+01 1.2475700378417969e+01 -6.6670997619628906e+01 -5.4979000091552734e+01 4.1205699920654297e+01 -7.3550094604492188e+01 -5.4977699279785156e+01 2.7057100296020508e+01 -7.8330101013183594e+01 -5.4972999572753906e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 -6.0733798980712891e+01 4.2893001556396484e+01 -7.0040397644042969e+01 -5.9612998962402344e+01 2.9782499313354492e+01 -7.5355300903320312e+01 -6.0731601715087891e+01 1.7170599699020386e+00 -7.4474800109863281e+01 -5.9610603332519531e+01 1.5645200729370117e+01 -2.5049600601196289e+01 -6.3557998657226562e+01 6.8122604370117188e+01 -4.9207698822021484e+01 -6.5768600463867188e+01 4.9181400299072266e+01 -3.6946399688720703e+01 -6.5759101867675781e+01 5.8903797149658203e+01 -2.1015600204467773e+01 -6.5753700256347656e+01 6.6359199523925781e+01 -5.9104999542236328e+01 -6.5766296386718750e+01 3.6562202453613281e+01 -6.7477394104003906e+01 -6.3571102142333984e+01 2.6760299682617188e+01 -7.1366401672363281e+01 -6.3561000823974609e+01 1.3268600463867188e+01 -6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 -6.9456398010253906e+01 -6.5766296386718750e+01 -1.5821199417114258e+00 4.8838300704956055e+00 -6.5753700256347656e+01 6.9384094238281250e+01 -6.5954093933105469e+01 -6.5003295898437500e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 -6.5001693725585938e+01 2.0110498428344727e+01 -6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 -6.4940101623535156e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 -6.5744300842285156e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 -6.5649505615234375e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 -6.4940101623535156e+01 4.3333198547363281e+01 -2.5114198684692383e+01 -6.5005798339843750e+01 6.1894699096679688e+01 -4.6691398620605469e+00 -6.4939994812011719e+01 6.6339698791503906e+01 -5.6185497283935547e+01 -6.5768501281738281e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 -6.4974800109863281e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 -6.4940101623535156e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 -6.5753700256347656e+01 -6.9384094238281250e+01 4.6691398620605469e+00 -6.4939994812011719e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 -6.6084396362304688e+01 7.3676099777221680e+00 -3.9422199249267578e+01 -6.6119201660156250e+01 4.7579696655273438e+01 -4.8702198028564453e+01 -6.5940795898437500e+01 3.9441997528076172e+01 -8.7784500122070312e+00 -6.6089698791503906e+01 6.1264701843261719e+01 3.0705200195312500e+01 -6.6117897033691406e+01 5.3397201538085938e+01 1.5252799987792969e+01 -6.5862602233886719e+01 6.1349498748779297e+01 5.0155899047851562e+01 -6.6073204040527344e+01 3.6021900177001953e+01 4.3594100952148438e+01 -6.4963195800781250e+01 5.0356700897216797e+01 6.0698596954345703e+01 -6.6066696166992188e+01 -6.7463498115539551e+00 6.6711799621582031e+01 -6.5003898620605469e+01 1.3542500138282776e-01 5.9121696472167969e+01 -6.6100502014160156e+01 1.8429199218750000e+01 5.9817501068115234e+01 -6.4940101623535156e+01 2.9234298706054688e+01 2.0092599868774414e+01 -6.4940101623535156e+01 6.3447898864746094e+01 -2.4017601013183594e+01 -6.4924705505371094e+01 4.4330997467041016e+01 -1.2296899795532227e+01 -6.4922195434570312e+01 4.8861900329589844e+01 -4.9878101348876953e+01 -6.4923797607421875e+01 6.1260700225830078e+00 -4.7621898651123047e+01 -6.5026702880859375e+01 2.0646100997924805e+01 -5.8962200164794922e+01 -6.6058395385742188e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 -6.4928802490234375e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 -6.4901504516601562e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 -6.4915802001953125e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 -6.6128295898437500e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 -6.4940605163574219e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 -6.4898902893066406e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 -6.5010696411132812e+01 3.6192996978759766e+01 -7.4321599006652832e+00 -6.6034599304199219e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 -6.5038299560546875e+01 -5.1429000854492188e+01 6.1151897907257080e-01 -6.4899902343750000e+01 5.0388702392578125e+01 4.0430500030517578e+01 -6.6047805786132812e+01 -4.7272399902343750e+01 2.1093599319458008e+01 -6.5008094787597656e+01 -4.7210800170898438e+01 5.7853302955627441e+00 -6.4969100952148438e+01 -5.0313201904296875e+01 4.5625198364257812e+01 -6.5076095581054688e+01 -2.5078199386596680e+01 5.2289600372314453e+01 -6.5047103881835938e+01 -4.6615300178527832e+00 4.9076499938964844e+01 -6.5030502319335938e+01 1.6025699615478516e+01 3.6085098266601562e+01 -6.4887702941894531e+01 3.5027797698974609e+01 4.5658901214599609e+01 -6.4956298828125000e+01 2.1977499008178711e+01 1.2848500251770020e+01 -6.4922805786132812e+01 4.8701698303222656e+01 2.4957799911499023e+01 -6.4924301147460938e+01 4.3825702667236328e+01 3.6392799377441406e+01 -6.5013999938964844e+01 -3.6605201721191406e+01 5.6047599792480469e+01 -6.6018997192382812e+01 -2.7524799346923828e+01 4.4547400474548340e+00 -6.5808799743652344e+01 -6.3284599304199219e+01 2.7442001342773438e+01 -6.5952598571777344e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 -6.5855598449707031e+01 -6.0778099060058594e+01 6.3447898864746094e+01 -6.4940101623535156e+01 -2.0092599868774414e+01 5.0577800750732422e+01 -6.4940101623535156e+01 -4.3333198547363281e+01 2.9234298706054688e+01 -6.4940101623535156e+01 -5.9817501068115234e+01 2.1015600204467773e+01 -6.5753700256347656e+01 -6.6359199523925781e+01 5.6820499420166016e+01 -6.5761795043945312e+01 -4.0331298828125000e+01 6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 4.3921298980712891e+01 -6.5758102416992188e+01 -5.3944599151611328e+01 1.5645200729370117e+01 -3.8389400482177734e+01 -7.4474800109863281e+01 1.7341400384902954e+00 -3.8391998291015625e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 -3.4403301239013672e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 -3.4428897857666016e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 -3.4439002990722656e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 -3.8387001037597656e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 -3.8389400482177734e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 -3.7266197204589844e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 -3.7266002655029297e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 -3.3472698211669922e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 -3.7265899658203125e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 -4.3020999908447266e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 -4.3022300720214844e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 -4.3024600982666016e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 -4.3021598815917969e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 -3.4442001342773438e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 -4.3020900726318359e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 -3.8389999389648438e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 -3.8387500762939453e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 -4.3021900177001953e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 -4.3023998260498047e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 -4.3026500701904297e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 -4.9052101135253906e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 -4.9060401916503906e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 -4.9065898895263672e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 -4.9067699432373047e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 -4.9065399169921875e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 -4.9059398651123047e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 -4.9050800323486328e+01 -7.8114799499511719e+01 3.4459200501441956e-01 -4.9045101165771484e+01 -7.9383300781250000e+01 6.4126296997070312e+01 -3.7265899658203125e+01 -3.9661300659179688e+01 5.3850097656250000e+01 -3.6490200042724609e+01 -5.2007102966308594e+01 1.2475700378417969e+01 -4.3024600982666016e+01 -7.7358497619628906e+01 2.9782499313354492e+01 -3.8387001037597656e+01 -7.0040397644042969e+01 4.2893001556396484e+01 -3.7266197204589844e+01 -6.2013099670410156e+01 2.8395601272583008e+01 -3.4441600799560547e+01 -6.6799201965332031e+01 2.7057100296020508e+01 -4.3022300720214844e+01 -7.3550094604492188e+01 4.1205699920654297e+01 -4.3020999908447266e+01 -6.6670997619628906e+01 5.3966102600097656e+01 -4.3021598815917969e+01 -5.6843299865722656e+01 6.7513504028320312e+01 -3.4440597534179688e+01 -2.6707201004028320e+01 6.4476997375488281e+01 -4.3020900726318359e+01 -4.4562896728515625e+01 7.1374496459960938e+01 -3.4436901092529297e+01 -1.3211199760437012e+01 7.5127197265625000e+01 -3.8389999389648438e+01 -1.2114600181579590e+01 7.1428794860839844e+01 -3.8387500762939453e+01 -2.6272998809814453e+01 7.2120101928710938e+01 -4.3021900177001953e+01 -3.0671701431274414e+01 7.6686698913574219e+01 -4.3023998260498047e+01 -1.6111700057983398e+01 1.4941699981689453e+01 -4.9052101135253906e+01 -7.7977600097656250e+01 2.9704099655151367e+01 -4.9060401916503906e+01 -7.3644798278808594e+01 4.1731800079345703e+01 -4.9570999145507812e+01 -6.7475105285644531e+01 4.9999198913574219e+01 -4.8999500274658203e+01 -6.1567001342773438e+01 5.7531902313232422e+01 -4.8420101165771484e+01 -5.4633300781250000e+01 1.7856500148773193e+00 -5.4973503112792969e+01 -7.8329895019531250e+01 6.6202606201171875e+01 -4.8934097290039062e+01 -4.3869800567626953e+01 7.3644798278808594e+01 -4.8939601898193359e+01 -2.9704099655151367e+01 7.7977600097656250e+01 -4.8947898864746094e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 -5.4976001739501953e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 -5.4978099822998047e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 -5.4979099273681641e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 -5.4978401184082031e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 -5.9610000610351562e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 -5.9612503051757812e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 -6.0734100341796875e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 -6.1509799957275391e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 -5.4979000091552734e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 -5.4977699279785156e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 -5.4975402832031250e+01 -7.7358497619628906e+01 1.2114600181579590e+01 -5.9610000610351562e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 -5.9608001708984375e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 -6.0733798980712891e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 -5.9612998962402344e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 -5.9610603332519531e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 -6.3559398651123047e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 -6.3563102722167969e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 -6.3558399200439453e+01 -6.6799201965332031e+01 5.1130599975585938e+00 -6.3596702575683594e+01 -7.2644706726074219e+01 2.5049600601196289e+01 -6.3557998657226562e+01 -6.8122604370117188e+01 1.6111700057983398e+01 -5.4976001739501953e+01 -7.6686698913574219e+01 3.0671701431274414e+01 -5.4978099822998047e+01 -7.2120101928710938e+01 4.2744701385498047e+01 -5.6259502410888672e+01 -6.5250297546386719e+01 5.6843299865722656e+01 -5.4978401184082031e+01 -5.3966102600097656e+01 2.6272998809814453e+01 -5.9612503051757812e+01 -7.1428794860839844e+01 5.1923801422119141e+01 -6.0734001159667969e+01 -5.4677501678466797e+01 3.8678096771240234e+01 -6.2713600158691406e+01 -6.2656597137451172e+01 7.7358497619628906e+01 -5.4975402832031250e+01 -1.2475700378417969e+01 6.6670997619628906e+01 -5.4979000091552734e+01 -4.1205699920654297e+01 7.3550094604492188e+01 -5.4977699279785156e+01 -2.7057100296020508e+01 6.2013099670410156e+01 -6.0733798980712891e+01 -4.2893001556396484e+01 7.0040397644042969e+01 -5.9612998962402344e+01 -2.9782499313354492e+01 7.4474800109863281e+01 -5.9610603332519531e+01 -1.5645200729370117e+01 6.7477394104003906e+01 -6.3571102142333984e+01 -2.6760299682617188e+01 7.1366401672363281e+01 -6.3561000823974609e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 -3.3059700012207031e+01 4.8698802947998047e+01 -6.3504100799560547e+01 -3.2998302459716797e+01 2.0110498428344727e+01 -5.2329101562500000e+01 -3.2130302429199219e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 -3.2137401580810547e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 -3.2020099639892578e+01 4.9141799926757812e+01 2.8352600097656250e+01 -3.2989597320556641e+01 4.3039199829101562e+01 1.5969698905944824e+01 -3.3055599212646484e+01 4.7725498199462891e+01 3.9991699218750000e+01 -3.3097698211669922e+01 3.0614299774169922e+01 4.8633197784423828e+01 -3.3084796905517578e+01 1.3720000267028809e+01 5.0044700622558594e+01 -3.3111999511718750e+01 -5.6227302551269531e+00 3.5953800201416016e+01 -3.3097698211669922e+01 -3.5078903198242188e+01 4.5476398468017578e+01 -3.3045200347900391e+01 -2.1894300460815430e+01 9.9145097732543945e+00 -3.3083801269531250e+01 -4.9431201934814453e+01 2.5745399475097656e+01 -3.3058502197265625e+01 -4.3290298461914062e+01 4.9954399108886719e+01 -6.5034202575683594e+01 5.4540300369262695e+00 4.8967998504638672e+01 -6.7537704467773438e+01 1.3350299835205078e+01 5.0034500122070312e+01 -6.7539604187011719e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 -6.5033500671386719e+01 3.7523998260498047e+01 -4.3557899475097656e+01 -6.7537895202636719e+01 2.6049699783325195e+01 -2.8130199432373047e+01 -6.7539604187011719e+01 4.1621601104736328e+01 -4.9887100219726562e+01 -6.7539398193359375e+01 6.8354101181030273e+00 -4.7150398254394531e+01 -6.5031204223632812e+01 1.8047500610351562e+01 -4.0905799865722656e+01 -6.5034301757812500e+01 2.9103500366210938e+01 -9.2679700851440430e+00 -6.7539001464843750e+01 4.9685398101806641e+01 9.3136892318725586e+00 -6.7538703918457031e+01 4.9535301208496094e+01 2.6869998931884766e+01 -6.7538597106933594e+01 4.2637798309326172e+01 4.0471401214599609e+01 -6.7539604187011719e+01 2.9807500839233398e+01 4.8870899200439453e+01 -6.5032897949218750e+01 -1.3342700004577637e+01 2.4033800125122070e+01 -6.5031997680664062e+01 -4.4287799835205078e+01 3.8291000366210938e+01 -6.5033897399902344e+01 -3.2910102844238281e+01 4.7313400268554688e+01 -6.7535400390625000e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 -6.7537704467773438e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 -6.7539398193359375e+01 -4.9904800415039062e+01 3.7271400451660156e+01 -6.7538406372070312e+01 -3.3985900878906250e+01 2.5166799545288086e+01 -6.7537002563476562e+01 -4.3544601440429688e+01 1.0624900817871094e+01 -6.7538406372070312e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 -6.7537796020507812e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 -6.7539604187011719e+01 -2.9807500839233398e+01 1.2806200027465820e+01 -8.1073295593261719e+01 -3.8097999095916748e+00 1.3205300331115723e+01 -8.0267494201660156e+01 -5.5868902206420898e+00 1.3861199378967285e+01 -8.0269203186035156e+01 4.1422801017761230e+00 6.8685703277587891e+00 -8.0269203186035156e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 -8.0430801391601562e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 -8.1080497741699219e+01 1.2562399864196777e+01 6.8692898750305176e+00 -8.0268096923828125e+01 1.2766799926757812e+01 -2.6745600700378418e+00 -8.0267105102539062e+01 1.4119600296020508e+01 -1.0887900352478027e+01 -8.1082099914550781e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 -8.1073501586914062e+01 3.7914199829101562e+00 -1.3522299766540527e+01 -8.0268005371093750e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 -8.0268394470214844e+01 8.1145401000976562e+00 1.4918000221252441e+01 -8.0275100708007812e+01 -3.5685497283935547e+01 3.7123301029205322e+00 -8.0275100708007812e+01 -3.8456001281738281e+01 5.6025695800781250e+00 -6.7521499633789062e+01 -3.8081703186035156e+01 1.6305999755859375e+01 -6.7521499633789062e+01 -3.5007499694824219e+01 3.6341297149658203e+01 -6.7521499633789062e+01 -1.3186100006103516e+01 3.0869201660156250e+01 -8.0274299621582031e+01 -2.3010200500488281e+01 2.9183500289916992e+01 -6.7522102355957031e+01 -2.5193401336669922e+01 2.3136499404907227e+01 -8.0274299621582031e+01 -3.0677999496459961e+01 3.8549598693847656e+01 -8.0275100708007812e+01 -1.6160999536514282e+00 3.7004398345947266e+01 -8.0275100708007812e+01 -1.1183599472045898e+01 3.8620300292968750e+01 -6.7521499633789062e+01 8.1181198358535767e-01 -4.5067396163940430e+00 -6.7521499633789062e+01 -3.8375400543212891e+01 2.5930200576782227e+01 -8.0275100708007812e+01 2.8557600021362305e+01 3.1677902221679688e+01 -8.0274200439453125e+01 2.1873998641967773e+01 3.1033300399780273e+01 -6.7523498535156250e+01 2.2732900619506836e+01 2.0160699844360352e+01 -6.7523300170898438e+01 3.2750801086425781e+01 6.2813601493835449e+00 -6.7521499633789062e+01 3.8171100616455078e+01 1.6532600402832031e+01 -8.0275100708007812e+01 3.4899303436279297e+01 3.7707702636718750e+01 -8.0275100708007812e+01 8.4654598236083984e+00 3.6223800659179688e+01 -6.7521499633789062e+01 1.2949000358581543e+01 5.2079100608825684e+00 -8.0275100708007812e+01 3.8213302612304688e+01 -3.4080798625946045e+00 -8.0275100708007812e+01 3.8494800567626953e+01 -3.7614700317382812e+01 -8.0275100708007812e+01 9.4110794067382812e+00 -1.6054100036621094e+01 -8.0275100708007812e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 -8.0275100708007812e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 -8.0275100708007812e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 -8.0274406433105469e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 -8.0275001525878906e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 -8.0275001525878906e+01 3.4412902832031250e+01 -3.1601600646972656e+01 -8.0274200439453125e+01 2.1895799636840820e+01 -2.5230501174926758e+01 -8.0274902343750000e+01 2.9101999282836914e+01 -3.3142398834228516e+01 -6.7523193359375000e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 -6.7522598266601562e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 -6.7521499633789062e+01 6.3573803901672363e+00 -3.7880397796630859e+01 -6.7521499633789062e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 -6.7521499633789062e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 -6.7521804809570312e+01 2.5504301071166992e+01 -1.9341501235961914e+01 -6.7523002624511719e+01 3.3339103698730469e+01 -3.4695800781250000e+01 -6.7521499633789062e+01 1.6600400924682617e+01 -7.6062998771667480e+00 -6.7521499633789062e+01 3.7799701690673828e+01 -4.9609901428222656e+01 -3.0460399627685547e+01 8.1507596969604492e+00 -4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 -3.2965702056884766e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 -3.0460399627685547e+01 2.2791400909423828e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 3.5853599548339844e+01 -4.9730598449707031e+01 -3.2965702056884766e+01 6.7970499992370605e+00 2.9969398975372314e+00 -3.2965702056884766e+01 5.0145702362060547e+01 6.9386696815490723e+00 -3.0460399627685547e+01 4.9888397216796875e+01 4.8833702087402344e+01 -3.0460399627685547e+01 1.3304400444030762e+01 4.0471401214599609e+01 -3.0460399627685547e+01 2.9807500839233398e+01 4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 2.5877500534057617e+01 -3.0460399627685547e+01 4.3248897552490234e+01 2.9460500717163086e+01 -3.2965702056884766e+01 4.0491600036621094e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 4.9272800445556641e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 4.3484500885009766e+01 -2.9969398975372314e+00 -3.2965702056884766e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 -3.2965702056884766e+01 -1.7957401275634766e+01 4.3438598632812500e+01 -3.0460399627685547e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 -4.9272800445556641e+01 1.7176401138305664e+01 -3.0460399627685547e+01 -4.7315002441406250e+01 3.1059000015258789e+01 -3.0460399627685547e+01 -3.9376998901367188e+01 2.9829699993133545e+00 -3.0460399627685547e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 -3.0460399627685547e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 -8.1032798767089844e+01 1.1027499437332153e+00 1.0264200210571289e+01 -2.9614400863647461e+01 2.9392998218536377e+00 1.0690099716186523e+01 -4.1044399261474609e+01 0.0000000000000000e+00 8.1825199127197266e+00 -2.9608499526977539e+01 6.8735299110412598e+00 5.0151400566101074e+00 -2.9599399566650391e+01 9.4172601699829102e+00 -6.3304600715637207e+00 -2.9442100524902344e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 -2.9454700469970703e+01 1.2124200820922852e+01 -1.3189299583435059e+01 -2.9452299118041992e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 -2.9457300186157227e+01 6.2997603416442871e+00 6.3305301666259766e+00 -2.9442100524902344e+01 1.2118599891662598e+01 1.3189299583435059e+01 -2.9452299118041992e+01 2.1639201641082764e+00 1.2706499099731445e+01 -3.0459199905395508e+01 -6.5114102363586426e+00 3.8211998939514160e+00 -3.0459899902343750e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 -3.0458499908447266e+01 1.4018300056457520e+01 8.3117198944091797e+00 -3.0458000183105469e+01 1.1874300003051758e+01 1.4127900123596191e+01 -3.0459999084472656e+01 3.0538599491119385e+00 -1.2706499099731445e+01 -3.0459199905395508e+01 6.5114398002624512e+00 -8.3115901947021484e+00 -3.0458000183105469e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 -3.0459199905395508e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "bl_caster_l_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_bl_caster_r_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 6.8265296936035156e+01 -9.3289899826049805e+00 2.7445201873779297e+00 6.8581901550292969e+01 -1.2800700187683105e+01 1.0573199987411499e+00 6.8359207153320312e+01 -1.0600199699401855e+01 1.0544799804687500e+01 6.8569099426269531e+01 -8.4442996978759766e+00 8.2298793792724609e+00 6.8419601440429688e+01 -6.8257398605346680e+00 1.0452800750732422e+01 6.8323402404785156e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 6.8392799377441406e+01 8.3633699417114258e+00 -1.0304100036621094e+01 1.7535499572753906e+01 4.2757096290588379e+00 -9.9000797271728516e+00 6.8434997558593750e+01 4.3990101814270020e+00 -3.0437600612640381e+00 6.8367401123046875e+01 1.0238399505615234e+01 -3.0640001296997070e+00 1.7108699798583984e+01 1.0639900207519531e+01 -1.0523200035095215e+01 6.8192199707031250e+01 2.0460700988769531e+00 -1.0421499252319336e+01 6.8127601623535156e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 6.8441001892089844e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 1.7107900619506836e+01 8.4554700851440430e+00 -1.0192299842834473e+01 1.7057300567626953e+01 5.5663700103759766e+00 -1.0925999641418457e+01 1.7111598968505859e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 1.7088899612426758e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 6.8396400451660156e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 6.8405799865722656e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 1.7143899917602539e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 6.8322502136230469e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 1.7096700668334961e+01 -1.1044600486755371e+01 1.0178999900817871e+00 6.8367797851562500e+01 1.0607999801635742e+01 1.0090099573135376e+00 1.7097700119018555e+01 1.1044500350952148e+01 7.1427397727966309e+00 1.7195999145507812e+01 8.4595899581909180e+00 9.8030099868774414e+00 1.7092800140380859e+01 5.1623497009277344e+00 7.4257197380065918e+00 1.6894800186157227e+01 1.1212299346923828e+01 3.3442101478576660e+00 1.7096099853515625e+01 -1.0557999610900879e+01 6.1998200416564941e+00 1.6903999328613281e+01 -1.1747900009155273e+01 7.2372202873229980e+00 1.7205499649047852e+01 -8.3683700561523438e+00 9.8025293350219727e+00 1.7078998565673828e+01 -5.1738500595092773e+00 4.0853300094604492e+00 1.7077999114990234e+01 1.0249599456787109e+01 1.0831099510192871e+01 1.7257900238037109e+01 -2.0039701461791992e+00 1.2268199920654297e+01 1.6871999740600586e+01 3.9475402832031250e+00 1.1011500358581543e+01 1.7335899353027344e+01 0.0000000000000000e+00 1.0836700439453125e+01 1.7178098678588867e+01 2.0019199848175049e+00 -1.1417300224304199e+01 6.6068595886230469e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 6.6098693847656250e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 6.4885696411132812e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 6.4939201354980469e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 6.4994499206542969e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 6.5077301025390625e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 6.6034599304199219e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 6.5038505554199219e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 6.4994796752929688e+01 2.3467597961425781e+00 -4.8763401031494141e+01 6.5027900695800781e+01 1.6582399368286133e+01 -6.1740497589111328e+01 6.6020698547363281e+01 1.0151400566101074e+01 -4.5477100372314453e+01 6.4954597473144531e+01 2.1893899917602539e+01 1.6372301101684570e+01 6.6058395385742188e+01 5.8962200164794922e+01 2.3468399047851562e+00 6.4992599487304688e+01 5.1267200469970703e+01 -9.9129495620727539e+00 6.4916198730468750e+01 4.9431499481201172e+01 -3.6015296936035156e+01 6.4891899108886719e+01 3.4995300292968750e+01 -4.8726200103759766e+01 6.6080505371093750e+01 3.8182498931884766e+01 -2.5745399475097656e+01 6.4941505432128906e+01 4.3290298461914062e+01 -6.4798698425292969e+00 6.6077705383300781e+01 6.1833000183105469e+01 -3.9104801177978516e+01 6.4893997192382812e+01 -3.1760398864746094e+01 3.8039699554443359e+01 6.6068901062011719e+01 4.8811397552490234e+01 2.0110498428344727e+01 6.5001693725585938e+01 6.3504100799560547e+01 4.7388999938964844e+01 6.4940200805664062e+01 4.7388999938964844e+01 5.0501701354980469e+01 6.5800300598144531e+01 3.8274200439453125e+01 6.3447898864746094e+01 6.4940101623535156e+01 2.0092599868774414e+01 6.0778099060058594e+01 6.5855598449707031e+01 1.7475801467895508e+01 6.0313198089599609e+01 6.6034599304199219e+01 7.4321599006652832e+00 6.3284599304199219e+01 6.5808799743652344e+01 -4.4547400474548340e+00 5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 5.5512199401855469e+01 6.6128799438476562e+01 -2.7132499694824219e+01 2.8417900085449219e+01 6.4975593566894531e+01 -6.0260898590087891e+01 4.4547300338745117e+00 6.5808898925781250e+01 -6.3284301757812500e+01 3.3109401702880859e+01 6.6098304748535156e+01 -5.2159999847412109e+01 4.6935901641845703e+01 6.5001396179199219e+01 -4.6935901641845703e+01 4.6696701049804688e+00 6.4939994812011719e+01 -6.6339698791503906e+01 6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 6.4980697631835938e+01 6.5981704711914062e+01 -4.4070800781250000e+01 6.4974899291992188e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 6.5756004333496094e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 6.5755393981933594e+01 -3.8144996643066406e+01 1.5174099922180176e+01 6.5649505615234375e+01 -6.8473693847656250e+01 4.8838300704956055e+00 6.5753700256347656e+01 -6.9384094238281250e+01 4.1918899536132812e+01 6.5744300842285156e+01 -5.5662799835205078e+01 5.6185497283935547e+01 6.5768501281738281e+01 -4.1026100158691406e+01 6.9456398010253906e+01 6.5766296386718750e+01 -1.5821299552917480e+00 6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 6.5753700256347656e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 6.5001693725585938e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 6.5759704589843750e+01 1.4109100103378296e+00 -6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 5.9610603332519531e+01 7.4474800109863281e+01 -1.7341400384902954e+00 5.9608001708984375e+01 7.6071098327636719e+01 5.1130599975585938e+00 6.3596702575683594e+01 7.2644706726074219e+01 7.1366401672363281e+01 6.3561000823974609e+01 1.3268600463867188e+01 6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 6.7477394104003906e+01 6.3571102142333984e+01 2.6760299682617188e+01 7.5355300903320312e+01 6.0731601715087891e+01 1.7170599699020386e+00 5.9104999542236328e+01 6.5766296386718750e+01 3.6562202453613281e+01 7.0040397644042969e+01 5.9612998962402344e+01 2.9782499313354492e+01 7.4474800109863281e+01 5.9610603332519531e+01 1.5645200729370117e+01 6.2013099670410156e+01 6.0733798980712891e+01 4.2893001556396484e+01 5.1923801422119141e+01 6.0734001159667969e+01 5.4677501678466797e+01 4.9207698822021484e+01 6.5768600463867188e+01 4.9181400299072266e+01 3.9661300659179688e+01 6.0734100341796875e+01 6.4126296997070312e+01 6.6670997619628906e+01 5.4979000091552734e+01 4.1205699920654297e+01 7.3550094604492188e+01 5.4977699279785156e+01 2.7057100296020508e+01 7.7358497619628906e+01 5.4975402832031250e+01 1.2475700378417969e+01 5.6843299865722656e+01 5.4978401184082031e+01 5.3966102600097656e+01 2.5049600601196289e+01 6.3557998657226562e+01 6.8122604370117188e+01 3.6946399688720703e+01 6.5759101867675781e+01 5.8903797149658203e+01 4.4562896728515625e+01 5.4979099273681641e+01 6.4476997375488281e+01 1.2114600181579590e+01 5.9610000610351562e+01 7.5127197265625000e+01 2.6272998809814453e+01 5.9612503051757812e+01 7.1428794860839844e+01 2.1015600204467773e+01 6.5753700256347656e+01 6.6359199523925781e+01 3.0671701431274414e+01 5.4978099822998047e+01 7.2120101928710938e+01 1.6111700057983398e+01 5.4976001739501953e+01 7.6686698913574219e+01 1.7856500148773193e+00 5.4973503112792969e+01 7.8329895019531250e+01 7.8330101013183594e+01 5.4972999572753906e+01 -1.7853500843048096e+00 7.9383201599121094e+01 4.9045101165771484e+01 -3.4461998939514160e-01 7.8114799499511719e+01 4.9050800323486328e+01 1.4203499794006348e+01 7.3951698303222656e+01 4.9059398651123047e+01 2.8930398941040039e+01 6.6686599731445312e+01 4.9065399169921875e+01 4.3129802703857422e+01 5.6477798461914062e+01 4.9067699432373047e+01 5.5839900970458984e+01 4.3869800567626953e+01 4.9065898895263672e+01 6.6202606201171875e+01 2.9704099655151367e+01 4.9060401916503906e+01 7.3644798278808594e+01 1.4941699981689453e+01 4.9052101135253906e+01 7.7977600097656250e+01 3.4459200501441956e-01 4.9045101165771484e+01 7.9383300781250000e+01 -6.4126296997070312e+01 6.0734100341796875e+01 3.9661300659179688e+01 -5.3850097656250000e+01 6.1509799957275391e+01 5.2007102966308594e+01 -5.6481498718261719e+01 6.5751998901367188e+01 4.0724998474121094e+01 -4.8838300704956055e+00 6.5753700256347656e+01 6.9384094238281250e+01 -1.5174099922180176e+01 6.5649505615234375e+01 6.8473693847656250e+01 -1.2475700378417969e+01 5.4975402832031250e+01 7.7358497619628906e+01 -2.9782499313354492e+01 5.9612998962402344e+01 7.0040397644042969e+01 -4.2893001556396484e+01 6.0733798980712891e+01 6.2013099670410156e+01 -2.8395601272583008e+01 6.3558399200439453e+01 6.6799201965332031e+01 -4.3375499725341797e+01 6.5742904663085938e+01 5.4680000305175781e+01 -2.7057100296020508e+01 5.4977699279785156e+01 7.3550094604492188e+01 -4.1205699920654297e+01 5.4979000091552734e+01 6.6670997619628906e+01 -5.3966102600097656e+01 5.4978401184082031e+01 5.6843299865722656e+01 -6.4476997375488281e+01 5.4979099273681641e+01 4.4562896728515625e+01 -6.7513504028320312e+01 6.3559398651123047e+01 2.6707201004028320e+01 -7.5355300903320312e+01 6.0731601715087891e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 6.3563102722167969e+01 1.3211199760437012e+01 -6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 -7.5127197265625000e+01 5.9610000610351562e+01 1.2114600181579590e+01 -7.1428794860839844e+01 5.9612503051757812e+01 2.6272998809814453e+01 -7.2120101928710938e+01 5.4978099822998047e+01 3.0671701431274414e+01 -7.6686698913574219e+01 5.4976001739501953e+01 1.6111700057983398e+01 -1.4203499794006348e+01 4.9050800323486328e+01 7.8114799499511719e+01 -2.8930398941040039e+01 4.9059398651123047e+01 7.3951698303222656e+01 -4.3129802703857422e+01 4.9065399169921875e+01 6.6686599731445312e+01 -5.4402599334716797e+01 4.8448303222656250e+01 5.7758701324462891e+01 -1.7856500148773193e+00 4.3026500701904297e+01 7.8329895019531250e+01 -7.8330101013183594e+01 5.4972999572753906e+01 1.7853500843048096e+00 -6.4116600036621094e+01 4.9052497863769531e+01 4.6979301452636719e+01 -6.7437301635742188e+01 5.0188701629638672e+01 4.1716197967529297e+01 -7.3951698303222656e+01 4.8940597534179688e+01 2.8930398941040039e+01 -7.8114799499511719e+01 4.8949199676513672e+01 1.4203499794006348e+01 -7.9383201599121094e+01 4.8954898834228516e+01 -3.4461998939514160e-01 7.8330101013183594e+01 4.3027000427246094e+01 1.7853500843048096e+00 7.6686698913574219e+01 4.3023998260498047e+01 1.6111700057983398e+01 7.2120101928710938e+01 4.3021900177001953e+01 3.0671701431274414e+01 6.4476997375488281e+01 4.3020900726318359e+01 4.4562896728515625e+01 5.3966102600097656e+01 4.3021598815917969e+01 5.6843299865722656e+01 7.5127197265625000e+01 3.8389999389648438e+01 1.2114600181579590e+01 7.5355300903320312e+01 3.7268402099609375e+01 -1.7170599699020386e+00 7.1428794860839844e+01 3.8387500762939453e+01 2.6272998809814453e+01 6.4126296997070312e+01 3.7265899658203125e+01 3.9661300659179688e+01 5.3850097656250000e+01 3.6490200042724609e+01 5.2007102966308594e+01 4.1205699920654297e+01 4.3020999908447266e+01 6.6670997619628906e+01 2.7057100296020508e+01 4.3022300720214844e+01 7.3550094604492188e+01 1.2475700378417969e+01 4.3024600982666016e+01 7.7358497619628906e+01 -1.2114600181579590e+01 3.8389999389648438e+01 7.5127197265625000e+01 1.7341400384902954e+00 3.8391998291015625e+01 7.6071098327636719e+01 4.2893001556396484e+01 3.7266197204589844e+01 6.2013099670410156e+01 2.9782499313354492e+01 3.8387001037597656e+01 7.0040397644042969e+01 1.5645200729370117e+01 3.8389400482177734e+01 7.4474800109863281e+01 5.6481498718261719e+01 3.2248001098632812e+01 4.0724998474121094e+01 6.7513504028320312e+01 3.4440597534179688e+01 2.6707201004028320e+01 7.1374496459960938e+01 3.4436901092529297e+01 1.3211199760437012e+01 6.9488693237304688e+01 3.2240303039550781e+01 1.4108999967575073e+00 6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 2.8395601272583008e+01 3.4441600799560547e+01 6.6799201965332031e+01 4.3375499725341797e+01 3.2257099151611328e+01 5.4680000305175781e+01 -5.1130700111389160e+00 3.4403301239013672e+01 7.2644706726074219e+01 1.5174099922180176e+01 3.2350498199462891e+01 6.8473693847656250e+01 -1.6111700057983398e+01 4.3023998260498047e+01 7.6686698913574219e+01 -3.0671701431274414e+01 4.3021900177001953e+01 7.2120101928710938e+01 -4.4562896728515625e+01 4.3020900726318359e+01 6.4476997375488281e+01 -5.6843299865722656e+01 4.3021598815917969e+01 5.3966102600097656e+01 -2.6272998809814453e+01 3.8387500762939453e+01 7.1428794860839844e+01 -3.9661300659179688e+01 3.7265899658203125e+01 6.4126296997070312e+01 -5.1923801422119141e+01 3.7266002655029297e+01 5.4677501678466797e+01 -7.7358497619628906e+01 4.3024600982666016e+01 1.2475700378417969e+01 -6.6670997619628906e+01 4.3020999908447266e+01 4.1205699920654297e+01 -7.3550094604492188e+01 4.3022300720214844e+01 2.7057100296020508e+01 -7.8330101013183594e+01 4.3027000427246094e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 3.7266197204589844e+01 4.2893001556396484e+01 -7.0040397644042969e+01 3.8387001037597656e+01 2.9782499313354492e+01 -7.5355300903320312e+01 3.7268402099609375e+01 1.7170599699020386e+00 -7.4474800109863281e+01 3.8389400482177734e+01 1.5645200729370117e+01 -2.5049600601196289e+01 3.4442001342773438e+01 6.8122604370117188e+01 -4.9207698822021484e+01 3.2231403350830078e+01 4.9181400299072266e+01 -3.6946399688720703e+01 3.2240901947021484e+01 5.8903797149658203e+01 -2.1015600204467773e+01 3.2246299743652344e+01 6.6359199523925781e+01 -5.9104999542236328e+01 3.2233699798583984e+01 3.6562202453613281e+01 -6.7477394104003906e+01 3.4428897857666016e+01 2.6760299682617188e+01 -7.1366401672363281e+01 3.4439002990722656e+01 1.3268600463867188e+01 -6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 -6.9456398010253906e+01 3.2233699798583984e+01 -1.5821199417114258e+00 4.8838300704956055e+00 3.2246299743652344e+01 6.9384094238281250e+01 -6.5954093933105469e+01 3.2996700286865234e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 3.2998302459716797e+01 2.0110498428344727e+01 -6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 3.3059898376464844e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 3.2255702972412109e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 3.2350498199462891e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 3.3059898376464844e+01 4.3333198547363281e+01 -2.5114198684692383e+01 3.2994197845458984e+01 6.1894699096679688e+01 -4.6691398620605469e+00 3.3059997558593750e+01 6.6339698791503906e+01 -5.6185497283935547e+01 3.2231498718261719e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 3.3025199890136719e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 3.3059898376464844e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 3.2246299743652344e+01 -6.9384094238281250e+01 4.6691398620605469e+00 3.3059997558593750e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 3.1915601730346680e+01 7.3676099777221680e+00 -3.9422199249267578e+01 3.1880800247192383e+01 4.7579696655273438e+01 -4.8702198028564453e+01 3.2059200286865234e+01 3.9441997528076172e+01 -8.7784500122070312e+00 3.1910301208496094e+01 6.1264701843261719e+01 3.0705200195312500e+01 3.1882099151611328e+01 5.3397201538085938e+01 1.5252799987792969e+01 3.2137401580810547e+01 6.1349498748779297e+01 5.0155899047851562e+01 3.1926799774169922e+01 3.6021900177001953e+01 4.3594100952148438e+01 3.3036796569824219e+01 5.0356700897216797e+01 6.0698596954345703e+01 3.1933300018310547e+01 -6.7463498115539551e+00 6.6711799621582031e+01 3.2996097564697266e+01 1.3542500138282776e-01 5.9121696472167969e+01 3.1899499893188477e+01 1.8429199218750000e+01 5.9817501068115234e+01 3.3059898376464844e+01 2.9234298706054688e+01 2.0092599868774414e+01 3.3059898376464844e+01 6.3447898864746094e+01 -2.4017601013183594e+01 3.3075298309326172e+01 4.4330997467041016e+01 -1.2296899795532227e+01 3.3077796936035156e+01 4.8861900329589844e+01 -4.9878101348876953e+01 3.3076202392578125e+01 6.1260700225830078e+00 -4.7621898651123047e+01 3.2973300933837891e+01 2.0646100997924805e+01 -5.8962200164794922e+01 3.1941600799560547e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 3.3071201324462891e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 3.3098499298095703e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 3.3084197998046875e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 3.1871698379516602e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 3.3059398651123047e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 3.3101100921630859e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 3.2989299774169922e+01 3.6192996978759766e+01 -7.4321599006652832e+00 3.1965400695800781e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 3.2961700439453125e+01 -5.1429000854492188e+01 6.1151897907257080e-01 3.3100097656250000e+01 5.0388702392578125e+01 4.0430500030517578e+01 3.1952198028564453e+01 -4.7272399902343750e+01 2.1093599319458008e+01 3.2991901397705078e+01 -4.7210800170898438e+01 5.7853302955627441e+00 3.3030902862548828e+01 -5.0313201904296875e+01 4.5625198364257812e+01 3.2923900604248047e+01 -2.5078199386596680e+01 5.2289600372314453e+01 3.2952899932861328e+01 -4.6615300178527832e+00 4.9076499938964844e+01 3.2969501495361328e+01 1.6025699615478516e+01 3.6085098266601562e+01 3.3112297058105469e+01 3.5027797698974609e+01 4.5658901214599609e+01 3.3043701171875000e+01 2.1977499008178711e+01 1.2848500251770020e+01 3.3077198028564453e+01 4.8701698303222656e+01 2.4957799911499023e+01 3.3075702667236328e+01 4.3825702667236328e+01 3.6392799377441406e+01 3.2986000061035156e+01 -3.6605201721191406e+01 5.6047599792480469e+01 3.1980998992919922e+01 -2.7524799346923828e+01 4.4547400474548340e+00 3.2191196441650391e+01 -6.3284599304199219e+01 2.7442001342773438e+01 3.2047397613525391e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 3.2144401550292969e+01 -6.0778099060058594e+01 6.3447898864746094e+01 3.3059898376464844e+01 -2.0092599868774414e+01 5.0577800750732422e+01 3.3059898376464844e+01 -4.3333198547363281e+01 2.9234298706054688e+01 3.3059898376464844e+01 -5.9817501068115234e+01 2.1015600204467773e+01 3.2246299743652344e+01 -6.6359199523925781e+01 5.6820499420166016e+01 3.2238201141357422e+01 -4.0331298828125000e+01 6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 4.3921298980712891e+01 3.2241901397705078e+01 -5.3944599151611328e+01 1.5645200729370117e+01 5.9610603332519531e+01 -7.4474800109863281e+01 1.7341400384902954e+00 5.9608001708984375e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 6.3596702575683594e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 6.3571102142333984e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 6.3561000823974609e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 5.9612998962402344e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 5.9610603332519531e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 6.0733798980712891e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 6.0734001159667969e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 6.4527305603027344e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 6.0734100341796875e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 5.4979000091552734e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 5.4977699279785156e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 5.4975402832031250e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 5.4978401184082031e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 6.3557998657226562e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 5.4979099273681641e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 5.9610000610351562e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 5.9612503051757812e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 5.4978099822998047e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 5.4976001739501953e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 5.4973503112792969e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 4.8947898864746094e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 4.8939601898193359e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 4.8934097290039062e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 4.8932300567626953e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 4.8934600830078125e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 4.8940597534179688e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 4.8949199676513672e+01 -7.8114799499511719e+01 3.4459200501441956e-01 4.8954898834228516e+01 -7.9383300781250000e+01 6.4126296997070312e+01 6.0734100341796875e+01 -3.9661300659179688e+01 5.3850097656250000e+01 6.1509799957275391e+01 -5.2007102966308594e+01 1.2475700378417969e+01 5.4975402832031250e+01 -7.7358497619628906e+01 2.9782499313354492e+01 5.9612998962402344e+01 -7.0040397644042969e+01 4.2893001556396484e+01 6.0733798980712891e+01 -6.2013099670410156e+01 2.8395601272583008e+01 6.3558399200439453e+01 -6.6799201965332031e+01 2.7057100296020508e+01 5.4977699279785156e+01 -7.3550094604492188e+01 4.1205699920654297e+01 5.4979000091552734e+01 -6.6670997619628906e+01 5.3966102600097656e+01 5.4978401184082031e+01 -5.6843299865722656e+01 6.7513504028320312e+01 6.3559398651123047e+01 -2.6707201004028320e+01 6.4476997375488281e+01 5.4979099273681641e+01 -4.4562896728515625e+01 7.1374496459960938e+01 6.3563102722167969e+01 -1.3211199760437012e+01 7.5127197265625000e+01 5.9610000610351562e+01 -1.2114600181579590e+01 7.1428794860839844e+01 5.9612503051757812e+01 -2.6272998809814453e+01 7.2120101928710938e+01 5.4978099822998047e+01 -3.0671701431274414e+01 7.6686698913574219e+01 5.4976001739501953e+01 -1.6111700057983398e+01 1.4941699981689453e+01 4.8947898864746094e+01 -7.7977600097656250e+01 2.9704099655151367e+01 4.8939601898193359e+01 -7.3644798278808594e+01 4.1731800079345703e+01 4.8429000854492188e+01 -6.7475105285644531e+01 4.9999198913574219e+01 4.9000503540039062e+01 -6.1567001342773438e+01 5.7531902313232422e+01 4.9579898834228516e+01 -5.4633300781250000e+01 1.7856500148773193e+00 4.3026500701904297e+01 -7.8329895019531250e+01 6.6202606201171875e+01 4.9065898895263672e+01 -4.3869800567626953e+01 7.3644798278808594e+01 4.9060401916503906e+01 -2.9704099655151367e+01 7.7977600097656250e+01 4.9052101135253906e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 4.3023998260498047e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 4.3021900177001953e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 4.3020900726318359e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 4.3021598815917969e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 3.8389999389648438e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 3.8387500762939453e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 3.7265899658203125e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 3.6490200042724609e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 4.3020999908447266e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 4.3022300720214844e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 4.3024600982666016e+01 -7.7358497619628906e+01 1.2114600181579590e+01 3.8389999389648438e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 3.8391998291015625e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 3.7266197204589844e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 3.8387001037597656e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 3.8389400482177734e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 3.4440597534179688e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 3.4436901092529297e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 3.4441600799560547e+01 -6.6799201965332031e+01 5.1130599975585938e+00 3.4403301239013672e+01 -7.2644706726074219e+01 2.5049600601196289e+01 3.4442001342773438e+01 -6.8122604370117188e+01 1.6111700057983398e+01 4.3023998260498047e+01 -7.6686698913574219e+01 3.0671701431274414e+01 4.3021900177001953e+01 -7.2120101928710938e+01 4.2744701385498047e+01 4.1740497589111328e+01 -6.5250297546386719e+01 5.6843299865722656e+01 4.3021598815917969e+01 -5.3966102600097656e+01 2.6272998809814453e+01 3.8387500762939453e+01 -7.1428794860839844e+01 5.1923801422119141e+01 3.7266002655029297e+01 -5.4677501678466797e+01 3.8678096771240234e+01 3.5286399841308594e+01 -6.2656597137451172e+01 7.7358497619628906e+01 4.3024600982666016e+01 -1.2475700378417969e+01 6.6670997619628906e+01 4.3020999908447266e+01 -4.1205699920654297e+01 7.3550094604492188e+01 4.3022300720214844e+01 -2.7057100296020508e+01 6.2013099670410156e+01 3.7266197204589844e+01 -4.2893001556396484e+01 7.0040397644042969e+01 3.8387001037597656e+01 -2.9782499313354492e+01 7.4474800109863281e+01 3.8389400482177734e+01 -1.5645200729370117e+01 6.7477394104003906e+01 3.4428897857666016e+01 -2.6760299682617188e+01 7.1366401672363281e+01 3.4439002990722656e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 6.4940299987792969e+01 4.8698802947998047e+01 -6.3504100799560547e+01 6.5001693725585938e+01 2.0110498428344727e+01 -5.2329101562500000e+01 6.5869697570800781e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 6.5862602233886719e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 6.5979896545410156e+01 4.9141799926757812e+01 2.8352600097656250e+01 6.5010398864746094e+01 4.3039199829101562e+01 1.5969698905944824e+01 6.4944404602050781e+01 4.7725498199462891e+01 3.9991699218750000e+01 6.4902297973632812e+01 3.0614299774169922e+01 4.8633197784423828e+01 6.4915199279785156e+01 1.3720000267028809e+01 5.0044700622558594e+01 6.4888000488281250e+01 -5.6227302551269531e+00 3.5953800201416016e+01 6.4902297973632812e+01 -3.5078903198242188e+01 4.5476398468017578e+01 6.4954803466796875e+01 -2.1894300460815430e+01 9.9145097732543945e+00 6.4916198730468750e+01 -4.9431201934814453e+01 2.5745399475097656e+01 6.4941505432128906e+01 -4.3290298461914062e+01 4.9954399108886719e+01 3.2965801239013672e+01 5.4540300369262695e+00 4.8967998504638672e+01 3.0462301254272461e+01 1.3350299835205078e+01 5.0034500122070312e+01 3.0460399627685547e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 3.2966499328613281e+01 3.7523998260498047e+01 -4.3557899475097656e+01 3.0462099075317383e+01 2.6049699783325195e+01 -2.8130199432373047e+01 3.0460399627685547e+01 4.1621601104736328e+01 -4.9887100219726562e+01 3.0460599899291992e+01 6.8354101181030273e+00 -4.7150398254394531e+01 3.2968799591064453e+01 1.8047500610351562e+01 -4.0905799865722656e+01 3.2965702056884766e+01 2.9103500366210938e+01 -9.2679700851440430e+00 3.0461000442504883e+01 4.9685398101806641e+01 9.3136892318725586e+00 3.0461299896240234e+01 4.9535301208496094e+01 2.6869998931884766e+01 3.0461400985717773e+01 4.2637798309326172e+01 4.0471401214599609e+01 3.0460399627685547e+01 2.9807500839233398e+01 4.8870899200439453e+01 3.2967102050781250e+01 -1.3342700004577637e+01 2.4033800125122070e+01 3.2967998504638672e+01 -4.4287799835205078e+01 3.8291000366210938e+01 3.2966098785400391e+01 -3.2910102844238281e+01 4.7313400268554688e+01 3.0464601516723633e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 3.0462301254272461e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 3.0460599899291992e+01 -4.9904800415039062e+01 3.7271400451660156e+01 3.0461599349975586e+01 -3.3985900878906250e+01 2.5166799545288086e+01 3.0463001251220703e+01 -4.3544601440429688e+01 1.0624900817871094e+01 3.0461599349975586e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 3.0462200164794922e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 3.0460399627685547e+01 -2.9807500839233398e+01 1.2806200027465820e+01 1.6926700592041016e+01 -3.8097999095916748e+00 1.3205300331115723e+01 1.7732500076293945e+01 -5.5868902206420898e+00 1.3861199378967285e+01 1.7730800628662109e+01 4.1422801017761230e+00 6.8685703277587891e+00 1.7730800628662109e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 1.7569198608398438e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 1.6919498443603516e+01 1.2562399864196777e+01 6.8692898750305176e+00 1.7731899261474609e+01 1.2766799926757812e+01 -2.6745600700378418e+00 1.7732898712158203e+01 1.4119600296020508e+01 -1.0887900352478027e+01 1.6917900085449219e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 1.6926498413085938e+01 3.7914199829101562e+00 -1.3522299766540527e+01 1.7732000350952148e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 1.7731599807739258e+01 8.1145401000976562e+00 1.4918000221252441e+01 1.7724899291992188e+01 -3.5685497283935547e+01 3.7123301029205322e+00 1.7724899291992188e+01 -3.8456001281738281e+01 5.6025695800781250e+00 3.0478500366210938e+01 -3.8081703186035156e+01 1.6305999755859375e+01 3.0478500366210938e+01 -3.5007499694824219e+01 3.6341297149658203e+01 3.0478500366210938e+01 -1.3186100006103516e+01 3.0869201660156250e+01 1.7725700378417969e+01 -2.3010200500488281e+01 2.9183500289916992e+01 3.0477899551391602e+01 -2.5193401336669922e+01 2.3136499404907227e+01 1.7725700378417969e+01 -3.0677999496459961e+01 3.8549598693847656e+01 1.7724899291992188e+01 -1.6160999536514282e+00 3.7004398345947266e+01 1.7724899291992188e+01 -1.1183599472045898e+01 3.8620300292968750e+01 3.0478500366210938e+01 8.1181198358535767e-01 -4.5067396163940430e+00 3.0478500366210938e+01 -3.8375400543212891e+01 2.5930200576782227e+01 1.7724899291992188e+01 2.8557600021362305e+01 3.1677902221679688e+01 1.7725799560546875e+01 2.1873998641967773e+01 3.1033300399780273e+01 3.0476499557495117e+01 2.2732900619506836e+01 2.0160699844360352e+01 3.0476699829101562e+01 3.2750801086425781e+01 6.2813601493835449e+00 3.0478500366210938e+01 3.8171100616455078e+01 1.6532600402832031e+01 1.7724899291992188e+01 3.4899303436279297e+01 3.7707702636718750e+01 1.7724899291992188e+01 8.4654598236083984e+00 3.6223800659179688e+01 3.0478500366210938e+01 1.2949000358581543e+01 5.2079100608825684e+00 1.7724899291992188e+01 3.8213302612304688e+01 -3.4080798625946045e+00 1.7724899291992188e+01 3.8494800567626953e+01 -3.7614700317382812e+01 1.7724899291992188e+01 9.4110794067382812e+00 -1.6054100036621094e+01 1.7724899291992188e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 1.7724899291992188e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 1.7724899291992188e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 1.7725599288940430e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 1.7725000381469727e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 1.7725000381469727e+01 3.4412902832031250e+01 -3.1601600646972656e+01 1.7725799560546875e+01 2.1895799636840820e+01 -2.5230501174926758e+01 1.7725101470947266e+01 2.9101999282836914e+01 -3.3142398834228516e+01 3.0476799011230469e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 3.0477401733398438e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 3.0478500366210938e+01 6.3573803901672363e+00 -3.7880397796630859e+01 3.0478500366210938e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 3.0478500366210938e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 3.0478199005126953e+01 2.5504301071166992e+01 -1.9341501235961914e+01 3.0477001190185547e+01 3.3339103698730469e+01 -3.4695800781250000e+01 3.0478500366210938e+01 1.6600400924682617e+01 -7.6062998771667480e+00 3.0478500366210938e+01 3.7799701690673828e+01 -4.9609901428222656e+01 6.7539604187011719e+01 8.1507596969604492e+00 -4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 6.5034301757812500e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 6.7539604187011719e+01 2.2791400909423828e+01 -3.5167198181152344e+01 6.7539604187011719e+01 3.5853599548339844e+01 -4.9730598449707031e+01 6.5034301757812500e+01 6.7970499992370605e+00 2.9969398975372314e+00 6.5034301757812500e+01 5.0145702362060547e+01 6.9386696815490723e+00 6.7539604187011719e+01 4.9888397216796875e+01 4.8833702087402344e+01 6.7539604187011719e+01 1.3304400444030762e+01 4.0471401214599609e+01 6.7539604187011719e+01 2.9807500839233398e+01 4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 2.5877500534057617e+01 6.7539604187011719e+01 4.3248897552490234e+01 2.9460500717163086e+01 6.5034301757812500e+01 4.0491600036621094e+01 -1.0601699829101562e+01 6.7539604187011719e+01 4.9272800445556641e+01 -2.4852701187133789e+01 6.7539604187011719e+01 4.3484500885009766e+01 -2.9969398975372314e+00 6.5034301757812500e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 6.5034301757812500e+01 -1.7957401275634766e+01 4.3438598632812500e+01 6.7539604187011719e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 6.7539604187011719e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 6.7539604187011719e+01 -4.9272800445556641e+01 1.7176401138305664e+01 6.7539604187011719e+01 -4.7315002441406250e+01 3.1059000015258789e+01 6.7539604187011719e+01 -3.9376998901367188e+01 2.9829699993133545e+00 6.7539604187011719e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 6.7539604187011719e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 6.7539604187011719e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 1.6967199325561523e+01 1.1027499437332153e+00 1.0264200210571289e+01 6.8385604858398438e+01 2.9392998218536377e+00 1.0690099716186523e+01 5.6955596923828125e+01 0.0000000000000000e+00 8.1825199127197266e+00 6.8391502380371094e+01 6.8735299110412598e+00 5.0151400566101074e+00 6.8400596618652344e+01 9.4172601699829102e+00 -6.3304600715637207e+00 6.8557899475097656e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 6.8545295715332031e+01 1.2124200820922852e+01 -1.3189299583435059e+01 6.8547706604003906e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 6.8542694091796875e+01 6.2997603416442871e+00 6.3305301666259766e+00 6.8557899475097656e+01 1.2118599891662598e+01 1.3189299583435059e+01 6.8547706604003906e+01 2.1639201641082764e+00 1.2706499099731445e+01 6.7540802001953125e+01 -6.5114102363586426e+00 3.8211998939514160e+00 6.7540100097656250e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 6.7541503906250000e+01 1.4018300056457520e+01 8.3117198944091797e+00 6.7541999816894531e+01 1.1874300003051758e+01 1.4127900123596191e+01 6.7540000915527344e+01 3.0538599491119385e+00 -1.2706499099731445e+01 6.7540802001953125e+01 6.5114398002624512e+00 -8.3115901947021484e+00 6.7541999816894531e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 6.7540802001953125e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "bl_caster_r_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_bl_caster_rotation_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -2.2459999999999999e+02 2.2459999999999999e+02 2.8199999999999999e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 162 0 2 1 0 151 0 162 151 1 151 152 1 152 215 1 284 2 1 215 284 151 223 152 151 162 223 2 299 162 162 299 223 274 299 2 150 299 274 299 150 223 2 273 274 274 351 148 150 274 148 289 351 274 273 289 274 168 148 351 288 351 289 351 166 168 166 351 288 288 289 175 273 175 289 177 167 288 288 175 177 166 288 167 166 167 168 167 311 168 235 234 167 234 380 167 454 167 380 235 167 177 311 167 454 453 311 454 182 311 453 168 311 182 453 454 451 454 380 451 159 182 453 451 159 453 451 160 159 160 451 380 159 160 161 181 182 159 214 181 159 214 159 161 161 160 380 440 214 161 161 380 440 347 158 214 214 440 347 158 181 214 181 339 47 181 47 182 158 339 181 37 158 134 134 158 347 158 37 339 476 47 339 476 339 37 72 476 36 68 476 427 476 68 47 72 427 476 476 37 36 36 37 38 70 72 36 91 36 38 91 70 36 38 37 368 23 38 368 91 38 287 287 38 23 91 86 70 91 195 86 91 287 195 86 87 70 498 87 86 195 498 86 35 195 287 35 318 195 498 195 497 195 318 497 498 497 418 498 418 87 418 331 87 87 331 70 331 90 71 331 426 90 418 426 331 70 331 71 70 71 72 72 71 82 71 412 82 71 90 412 72 82 414 414 427 72 82 329 414 412 329 82 412 413 329 90 89 412 412 89 413 328 329 142 328 191 329 191 414 329 329 413 142 190 414 191 190 427 414 190 68 427 189 190 191 189 69 190 69 68 190 205 191 328 189 191 205 141 328 142 141 205 328 204 189 205 216 218 205 212 216 205 218 204 205 212 205 141 189 204 499 499 69 189 499 204 42 499 42 452 499 452 69 42 43 44 201 42 202 42 44 202 452 42 201 204 43 42 43 330 44 43 327 344 43 344 330 204 327 43 44 330 325 44 325 202 324 202 325 202 324 201 452 201 324 45 452 46 45 69 452 452 324 341 341 46 452 45 46 47 45 68 69 68 45 47 182 47 46 341 182 46 340 148 341 341 365 182 148 365 341 341 324 340 182 365 168 168 365 148 148 149 150 149 148 340 324 149 340 324 333 149 333 81 149 150 149 81 223 150 224 150 81 224 79 80 81 333 75 81 80 224 81 75 79 81 222 223 224 222 224 80 429 80 428 80 79 428 222 80 429 74 97 79 74 79 75 97 428 79 73 74 75 73 75 333 73 420 74 420 496 74 74 496 97 495 494 73 495 73 333 494 420 73 324 495 333 325 494 495 324 325 495 330 420 494 325 330 494 330 416 420 330 344 416 344 415 416 416 415 420 420 415 496 415 423 95 496 415 95 344 423 415 344 217 345 345 423 344 327 217 344 320 95 423 321 320 423 345 321 423 95 96 97 96 95 320 496 95 97 320 321 96 217 321 345 321 17 96 321 217 17 17 16 96 96 16 97 97 16 326 326 428 97 15 16 17 16 15 326 17 131 15 17 217 213 17 213 131 15 131 52 15 52 245 15 245 286 15 286 326 213 52 131 51 35 52 52 35 34 213 51 52 245 52 34 318 51 319 51 88 319 213 88 51 51 318 35 497 318 418 318 319 418 319 417 418 417 319 88 418 417 426 426 417 90 90 417 88 88 89 90 78 413 89 89 88 76 78 89 76 76 77 78 142 413 78 142 78 77 88 77 76 141 142 77 212 141 77 77 88 212 212 88 213 213 216 212 213 217 216 216 217 218 218 217 327 204 218 327 33 34 35 35 66 67 35 203 66 35 287 203 35 364 33 67 411 35 411 364 35 245 34 314 34 33 314 244 245 101 286 245 223 405 245 314 101 245 405 244 223 245 405 314 33 405 409 402 102 101 405 409 405 33 102 405 402 33 111 110 33 110 409 364 315 33 33 315 111 402 409 110 401 402 110 493 102 402 493 402 401 110 111 112 112 401 110 112 462 401 462 493 401 322 493 197 462 197 493 322 102 493 462 112 332 58 60 462 58 462 332 60 197 462 111 332 112 111 58 332 58 59 60 315 58 111 315 59 58 61 59 62 62 59 30 59 364 30 59 315 364 59 61 477 60 59 477 477 61 92 61 62 92 92 62 32 62 30 32 30 31 32 364 31 30 364 411 31 411 178 31 32 31 178 92 32 93 32 178 93 92 93 94 477 92 421 421 92 94 313 94 93 93 178 180 93 180 313 178 179 180 411 67 178 178 67 179 180 179 83 410 180 85 180 83 85 313 180 410 313 410 342 94 313 342 410 99 342 99 410 85 83 84 85 98 99 85 84 432 85 432 98 85 179 66 83 66 84 83 430 431 84 430 84 66 431 432 84 419 432 431 419 98 432 419 200 98 98 343 99 200 343 98 342 99 343 200 129 343 342 343 278 343 129 278 198 199 200 129 200 199 198 200 419 198 419 431 198 431 375 375 431 430 198 129 199 287 198 375 129 198 287 287 375 203 203 375 430 465 355 287 287 130 129 22 465 287 23 22 287 355 130 287 128 129 130 130 355 308 130 308 307 130 307 128 128 479 129 278 129 479 468 126 479 479 126 278 337 468 479 337 479 128 121 278 126 232 342 278 121 280 278 280 232 278 408 342 232 408 94 342 408 422 94 317 408 316 317 422 408 316 408 232 421 94 422 317 421 422 316 60 317 317 60 477 317 477 421 60 196 197 196 60 316 196 323 197 196 298 323 196 348 298 196 316 348 197 323 322 322 323 11 298 11 323 9 11 298 9 298 348 316 9 348 9 10 11 9 316 10 304 11 53 322 11 304 11 54 53 10 54 11 304 102 322 304 53 100 102 304 100 53 54 55 100 53 55 171 140 54 54 139 55 54 140 139 171 54 10 424 55 425 424 100 55 267 425 55 139 267 55 100 101 102 424 101 100 425 244 424 244 101 424 244 425 223 223 425 461 425 267 461 286 223 222 223 461 239 223 239 271 271 458 223 223 458 152 461 267 266 461 266 239 144 238 239 238 271 239 144 239 266 265 266 267 145 266 265 266 145 144 279 265 267 145 265 279 267 369 104 267 104 279 267 139 369 279 104 173 145 279 173 103 172 173 103 173 104 173 172 366 366 145 173 64 103 104 172 103 64 172 64 63 172 357 367 172 63 357 366 172 367 366 367 145 483 143 367 357 475 367 483 367 448 143 145 367 448 367 475 143 144 145 482 395 143 482 143 483 395 144 143 448 125 483 483 125 482 443 482 125 482 443 395 144 395 396 443 396 395 358 238 144 358 144 450 144 396 450 396 480 450 396 481 480 443 481 396 485 450 277 450 480 277 358 450 350 450 485 350 334 238 358 358 350 334 271 238 272 238 334 272 485 458 271 350 485 271 406 271 272 271 406 350 485 379 458 379 485 277 379 152 458 283 215 379 215 152 379 283 379 277 215 283 284 247 283 208 208 283 277 284 283 247 285 284 247 2 284 285 2 285 273 273 285 439 439 285 247 176 273 439 175 273 176 176 439 177 177 439 247 175 176 177 246 398 177 246 177 247 253 235 177 398 253 177 208 246 247 399 398 246 208 399 246 188 398 399 188 253 398 399 436 472 207 436 399 399 472 188 208 207 399 206 207 208 277 206 208 480 481 206 481 207 206 480 206 277 481 256 207 443 256 481 256 257 207 185 186 256 257 256 209 256 186 209 443 185 256 443 124 185 443 125 124 185 124 186 209 186 13 186 124 264 13 186 264 39 209 13 209 484 257 39 484 209 484 39 257 39 40 41 39 41 194 194 257 39 39 13 12 39 187 40 39 270 187 12 270 39 436 194 41 41 40 436 207 194 436 194 207 257 40 472 436 188 472 40 40 187 188 253 188 254 254 188 292 187 292 188 292 187 270 292 270 260 254 292 260 260 253 254 269 253 260 253 233 235 253 269 233 269 260 270 270 133 269 306 233 269 433 269 491 269 133 491 269 433 306 233 234 235 233 380 234 233 306 380 226 157 380 440 380 157 306 226 380 8 225 226 225 157 226 8 226 306 6 7 8 306 6 8 8 7 225 7 155 225 157 225 155 388 7 6 388 155 7 388 6 27 388 27 394 388 464 155 388 394 464 25 26 27 27 6 132 132 25 27 394 27 26 394 389 464 138 394 26 389 394 138 464 487 488 464 488 155 389 487 464 487 349 488 487 478 349 389 478 487 349 155 488 155 156 157 391 156 155 349 392 155 391 155 392 377 378 156 346 377 156 156 378 157 156 391 346 157 378 393 440 157 393 377 374 378 374 393 378 393 347 440 374 347 393 374 134 347 377 134 374 134 135 56 134 377 135 134 56 37 57 135 305 135 377 305 56 135 57 37 56 57 57 368 37 305 108 57 57 108 109 109 368 57 108 305 346 346 305 377 108 21 109 346 391 108 21 108 391 368 109 21 21 23 368 21 22 23 21 391 392 21 392 349 349 22 21 465 22 349 349 249 248 459 349 248 465 349 459 478 249 349 459 105 465 220 355 465 105 220 465 459 474 105 248 474 459 105 106 107 105 255 106 105 107 220 105 474 255 255 474 355 355 474 308 308 474 248 354 255 355 355 220 354 106 255 354 220 221 354 221 106 354 220 165 221 49 106 221 165 164 221 164 49 221 48 49 50 49 437 106 363 437 49 49 48 363 50 49 164 48 192 193 48 193 363 48 50 192 50 164 192 193 192 164 363 193 445 445 193 164 444 363 445 363 444 437 438 445 164 444 445 438 437 444 438 437 438 275 164 275 438 258 275 211 164 211 275 258 437 275 258 211 259 259 437 258 163 210 211 163 211 164 210 259 211 163 164 165 489 210 163 489 163 165 210 489 437 259 210 437 106 437 489 106 489 243 243 489 165 107 165 220 107 243 165 107 106 243 117 248 249 404 449 248 449 252 248 117 404 248 252 308 248 478 400 249 400 117 249 389 400 478 117 400 4 389 4 400 4 389 390 138 390 389 227 390 137 390 138 137 4 390 227 136 137 138 26 136 138 137 133 268 268 227 137 137 136 26 133 137 26 227 228 229 268 228 227 4 227 229 133 228 268 115 312 228 4 229 228 133 115 228 312 4 228 5 4 312 115 5 312 3 4 5 117 4 3 116 3 5 5 115 116 116 117 3 117 116 404 116 403 404 114 116 115 116 114 403 404 386 449 404 403 386 403 236 386 114 263 403 403 263 236 113 114 115 370 114 113 114 370 263 113 12 370 12 113 115 12 115 133 12 13 14 12 469 470 12 14 469 470 370 12 12 133 270 470 263 370 261 470 469 470 261 263 469 231 261 231 469 14 261 262 263 261 231 301 397 261 301 397 262 261 14 230 231 231 300 301 231 230 300 301 300 441 397 301 295 441 295 301 397 295 372 397 372 466 262 397 466 466 372 237 466 237 407 407 262 466 236 407 237 263 407 236 262 407 263 120 236 237 353 386 236 120 119 236 236 119 353 118 119 120 120 219 118 237 219 120 352 353 119 118 352 119 310 353 352 353 310 387 353 387 386 121 123 352 310 352 123 121 352 118 276 118 219 121 118 276 276 219 383 237 383 219 276 184 232 232 280 276 184 276 383 121 276 280 121 122 123 126 122 121 126 127 122 122 127 123 468 467 126 126 467 127 127 467 468 123 127 337 127 468 337 251 337 128 251 376 337 337 376 123 250 251 252 376 251 250 252 251 490 490 251 128 307 490 128 307 252 490 307 308 252 449 386 252 250 252 386 386 387 250 387 309 250 309 376 250 310 309 387 123 309 310 123 376 309 184 383 169 383 384 169 457 383 237 384 383 457 183 184 169 184 183 232 169 10 183 232 183 316 10 316 183 171 10 169 169 170 171 171 170 140 170 169 359 140 170 64 64 170 146 359 147 170 170 147 146 104 139 140 140 64 104 63 64 65 65 64 146 146 147 65 63 65 357 65 147 357 356 357 147 382 475 357 356 382 357 381 382 356 297 356 371 381 356 297 371 356 147 471 475 382 471 382 381 475 471 448 381 296 471 296 448 471 296 381 297 295 296 297 295 297 371 295 371 372 372 371 147 295 441 442 295 442 296 300 230 441 441 230 442 230 373 442 296 442 373 14 373 230 373 29 296 373 14 29 14 28 29 13 240 14 447 446 14 240 447 14 28 14 446 29 28 460 460 296 29 446 460 28 446 447 448 446 448 460 240 242 447 448 447 242 240 241 242 241 240 13 448 242 125 125 242 241 448 296 460 241 13 125 124 125 13 13 264 124 147 455 372 147 359 455 455 359 456 455 457 372 455 456 457 457 237 372 384 457 456 359 384 456 359 169 384 104 369 139 132 133 25 133 281 282 133 434 433 133 282 434 491 133 433 281 133 132 25 133 26 281 302 303 282 281 303 302 281 132 434 282 435 303 435 282 433 434 435 433 435 306 306 435 303 6 303 302 6 306 303 132 6 302 350 335 334 406 335 350 334 335 336 335 338 336 335 406 154 338 335 154 291 334 293 291 272 334 334 336 293 290 154 291 293 290 291 406 272 291 154 406 291 501 290 293 154 290 501 154 501 473 473 501 293 154 473 385 473 293 385 385 153 154 385 293 492 153 385 492 153 18 154 294 153 492 153 294 18 492 293 294 293 19 294 294 19 18 18 19 20 362 18 20 18 362 154 20 19 24 19 174 24 19 293 174 486 362 20 486 20 24 486 24 174 174 463 486 463 362 486 174 293 336 500 174 361 174 336 361 500 463 174 463 360 362 500 360 463 360 500 361 360 361 362 362 361 336 362 336 338 362 338 154 429 286 222 326 286 429 326 429 428 203 430 66 67 66 179))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.5309399414062500e+02 -2.8678799438476562e+02 1.0526599884033203e+02 1.6749499511718750e+02 -2.8678799438476562e+02 1.0526599884033203e+02 1.4962998962402344e+02 -2.8165600585937500e+02 1.0526599884033203e+02 2.5771398925781250e+02 -1.5725999450683594e+02 1.3304998779296875e+02 2.4495401000976562e+02 -1.5231401062011719e+02 1.3304998779296875e+02 2.5889199829101562e+02 -1.5772599792480469e+02 1.3955000305175781e+02 1.7266799926757812e+02 -1.7026600646972656e+02 1.3304998779296875e+02 1.8274299621582031e+02 -1.9238999938964844e+02 1.3304998779296875e+02 1.7675300598144531e+02 -2.0243699645996094e+02 1.3304998779296875e+02 2.9864697265625000e+02 -2.3860499572753906e+02 1.0230000305175781e+02 3.1669802856445312e+02 -2.4011799621582031e+02 1.0230000305175781e+02 2.9776699829101562e+02 -2.4332800292968750e+02 1.0230000305175781e+02 2.8804498291015625e+02 -1.8449600219726562e+02 1.3955000305175781e+02 2.4302198791503906e+02 -2.9742898559570312e+02 1.3955000305175781e+02 2.7962301635742188e+02 -2.7573800659179688e+02 1.3955000305175781e+02 1.4557699584960938e+02 -2.5060800170898438e+02 -1.6409799575805664e+01 1.4248800659179688e+02 -2.5027900695800781e+02 -2.7892499923706055e+01 1.4242399597167969e+02 -2.5025099182128906e+02 -5.9969299316406250e+01 2.3170300292968750e+02 -3.0809997558593750e+02 -5.4909603118896484e+01 2.2893800354003906e+02 -3.1110000610351562e+02 -5.5569801330566406e+01 2.2042399597167969e+02 -3.0809997558593750e+02 -5.5612400054931641e+01 1.8657299804687500e+02 -1.5891499328613281e+02 1.0230000305175781e+02 1.9710000610351562e+02 -1.5458999633789062e+02 1.0230000305175781e+02 1.9573899841308594e+02 -1.6975000000000000e+02 1.0230000305175781e+02 2.1716299438476562e+02 -3.1110000610351562e+02 -5.4838798522949219e+01 1.8395500183105469e+02 -1.6153399658203125e+02 1.3955000305175781e+02 1.9309399414062500e+02 -1.5641400146484375e+02 1.3955000305175781e+02 1.8358898925781250e+02 -1.6171499633789062e+02 1.3304998779296875e+02 2.8716799926757812e+02 -2.6609997558593750e+02 1.3955000305175781e+02 2.9236502075195312e+02 -2.5684197998046875e+02 1.3955000305175781e+02 2.9864697265625000e+02 -2.1059500122070312e+02 -4.3196701049804688e+01 2.9844998168945312e+02 -2.0828900146484375e+02 -5.8984100341796875e+01 2.9835598754882812e+02 -2.0765798950195312e+02 -9.5243206024169922e+00 2.9099398803710938e+02 -2.4985200500488281e+02 -5.9969898223876953e+01 2.8664700317382812e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 2.8664700317382812e+02 -1.9859500122070312e+02 -5.9969802856445312e+01 1.4111100769042969e+02 -1.9941101074218750e+02 1.0230100250244141e+02 1.4256199645996094e+02 -1.7952099609375000e+02 1.0230000305175781e+02 1.4557699584960938e+02 -1.9859500122070312e+02 1.0230000305175781e+02 1.9108801269531250e+02 -2.9180200195312500e+02 1.3955000305175781e+02 1.6508399963378906e+02 -2.7040798950195312e+02 1.3955000305175781e+02 1.7696299743652344e+02 -2.8273098754882812e+02 1.3955000305175781e+02 1.3398300170898438e+02 -2.4170899963378906e+02 5.7514900207519531e+01 1.3398300170898438e+02 -2.4170899963378906e+02 1.3412400245666504e+01 1.3448699951171875e+02 -2.4319400024414062e+02 3.6914199829101562e+01 1.3357701110839844e+02 -2.1059500122070312e+02 1.0230000305175781e+02 1.3136099243164062e+02 -2.1862699890136719e+02 1.0230000305175781e+02 1.3324299621582031e+02 -2.0552900695800781e+02 1.0230000305175781e+02 2.4409001159667969e+02 -1.3809999084472656e+02 -4.7562698364257812e+01 2.5209999084472656e+02 -1.3809999084472656e+02 -2.8200000762939453e+01 2.5044300842285156e+02 -1.3809899902343750e+02 -3.8267398834228516e+01 1.4557699584960938e+02 -1.9859500122070312e+02 -5.9969802856445312e+01 2.0645800781250000e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 2.9491900634765625e+02 -2.4729399108886719e+02 1.0230000305175781e+02 3.1264599609375000e+02 -2.5572999572753906e+02 1.0230000305175781e+02 2.9153399658203125e+02 -2.4962500000000000e+02 1.0230000305175781e+02 1.5309399414062500e+02 -1.6241200256347656e+02 1.0230000305175781e+02 1.7484899902343750e+02 -1.6241200256347656e+02 1.0230000305175781e+02 2.9866799926757812e+02 -2.3860600280761719e+02 -2.7142898559570312e+01 2.9864697265625000e+02 -2.2679800415039062e+02 -1.8764699935913086e+01 2.9864697265625000e+02 -2.3860499572753906e+02 4.0985599517822266e+01 2.9864697265625000e+02 -2.1059500122070312e+02 8.0976800918579102e+00 2.9864697265625000e+02 -2.1059500122070312e+02 -1.5550399780273438e+01 2.8689398193359375e+02 -2.6575698852539062e+02 1.2900000000000000e+02 2.8834399414062500e+02 -2.6370498657226562e+02 1.0526499938964844e+02 2.9076199340820312e+02 -2.5917398071289062e+02 1.2900000000000000e+02 2.9051000976562500e+02 -1.9920599365234375e+02 -3.7053100585937500e+01 2.9255102539062500e+02 -2.0005700683593750e+02 -5.9970798492431641e+01 1.3385299682617188e+02 -2.0815499877929688e+02 1.0230000305175781e+02 1.3357701110839844e+02 -2.1059500122070312e+02 9.6058898925781250e+01 1.4085800170898438e+02 -1.9949099731445312e+02 7.5261901855468750e+01 1.3889401245117188e+02 -2.0059500122070312e+02 3.5743999481201172e+01 1.3716799926757812e+02 -2.0194900512695312e+02 1.0056999969482422e+02 1.3708799743652344e+02 -2.4708999633789062e+02 6.0708602905273438e+01 1.3826901245117188e+02 -2.4812600708007812e+02 3.2135898590087891e+01 1.3826901245117188e+02 -2.4812600708007812e+02 7.9724601745605469e+01 1.3706498718261719e+02 -2.0214300537109375e+02 -5.9969802856445312e+01 1.3508500671386719e+02 -2.0466500854492188e+02 -5.9969898223876953e+01 1.3605200195312500e+02 -2.0329199218750000e+02 -2.9373600006103516e+01 1.3957600402832031e+02 -2.4899899291992188e+02 5.0942001342773438e+01 1.4098399353027344e+02 -2.4969300842285156e+02 7.8505599975585938e+01 1.3957800292968750e+02 -2.4899800109863281e+02 1.0230000305175781e+02 1.3624400329589844e+02 -2.0303300476074219e+02 5.2590198516845703e+01 2.9264199829101562e+02 -2.0019799804687500e+02 -2.3319999694824219e+01 2.9123498535156250e+02 -1.9950500488281250e+02 6.6349101066589355e+00 2.9264199829101562e+02 -2.0019799804687500e+02 3.0526800155639648e+01 1.4401000976562500e+02 -1.9869599914550781e+02 5.8514400482177734e+01 1.4247099304199219e+02 -1.9900199890136719e+02 4.6641597747802734e+01 1.3939698791503906e+02 -2.0022900390625000e+02 -5.9969802856445312e+01 1.3708799743652344e+02 -2.0211000061035156e+02 -1.3356300354003906e+01 1.3895599365234375e+02 -2.0055499267578125e+02 -1.2914799690246582e+01 1.4557699584960938e+02 -1.9859500122070312e+02 7.6262695312500000e+01 2.9844201660156250e+02 -2.0824700927734375e+02 4.4407596588134766e+00 2.9742300415039062e+02 -2.0525500488281250e+02 1.1596100807189941e+01 2.9778701782226562e+02 -2.0599200439453125e+02 6.4847000122070312e+01 1.3826901245117188e+02 -2.4812600708007812e+02 -2.5375299453735352e+01 1.3957600402832031e+02 -2.4899899291992188e+02 -5.3728698730468750e+01 1.3957600402832031e+02 -2.4899899291992188e+02 2.4416298866271973e+00 2.9123498535156250e+02 -1.9950500488281250e+02 4.8518898010253906e+01 2.9264199829101562e+02 -2.0019799804687500e+02 7.6920997619628906e+01 2.9280001831054688e+02 -2.4899398803710938e+02 9.9975700378417969e+01 2.8942901611328125e+02 -2.5033700561523438e+02 4.1235500335693359e+01 2.9379598999023438e+02 -2.4830200195312500e+02 3.2989101409912109e+01 2.8116799926757812e+02 -2.7345401000976562e+02 1.0526599884033203e+02 2.9610601806640625e+02 -2.8678799438476562e+02 1.0526599884033203e+02 1.9710000610351562e+02 -1.3809999084472656e+02 7.0520500183105469e+01 2.5209999084472656e+02 -1.3809999084472656e+02 4.0198602676391602e+00 1.9710000610351562e+02 -1.3809999084472656e+02 -4.4480600357055664e+00 1.8028799438476562e+02 -1.6241200256347656e+02 1.0526599884033203e+02 1.8028799438476562e+02 -1.6241200256347656e+02 1.0230000305175781e+02 2.9537399291992188e+02 -2.4685899353027344e+02 -5.9969699859619141e+01 2.9824502563476562e+02 -2.4205599975585938e+02 -5.9969200134277344e+01 2.9711199951171875e+02 -2.4459999084472656e+02 -5.9332698822021484e+01 2.8169799804687500e+02 -1.7591198730468750e+02 1.3955000305175781e+02 2.7608499145507812e+02 -1.6997300720214844e+02 1.3304998779296875e+02 2.7249099731445312e+02 -1.6669799804687500e+02 1.3955000305175781e+02 2.6763900756835938e+02 -1.6309001159667969e+02 1.3304998779296875e+02 2.3421099853515625e+02 -1.7264300537109375e+02 1.3304998779296875e+02 2.9465298461914062e+02 -1.9881900024414062e+02 1.0526599884033203e+02 2.9307199096679688e+02 -1.9487699890136719e+02 1.2900000000000000e+02 2.9649002075195312e+02 -2.0441099548339844e+02 1.2900000000000000e+02 3.0603997802734375e+02 -1.7843400573730469e+02 1.0526499938964844e+02 2.9958599853515625e+02 -1.6756999206542969e+02 1.0526599884033203e+02 2.9044100952148438e+02 -1.7463000488281250e+02 1.0526599884033203e+02 2.3265499877929688e+02 -2.9920300292968750e+02 1.3304998779296875e+02 2.4584298706054688e+02 -2.9663000488281250e+02 1.3304998779296875e+02 3.0038198852539062e+02 -1.6870899963378906e+02 1.0230000305175781e+02 2.9610601806640625e+02 -1.6241200256347656e+02 1.0526599884033203e+02 2.6147799682617188e+02 -1.5966198730468750e+02 1.0230000305175781e+02 2.8664700317382812e+02 -1.9859500122070312e+02 1.0230000305175781e+02 2.5209999084472656e+02 -1.5523699951171875e+02 1.0230000305175781e+02 1.4557699584960938e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 1.7570999145507812e+02 -1.6766999816894531e+02 1.3955000305175781e+02 1.4987799072265625e+02 -2.1699699401855469e+02 1.3955000305175781e+02 1.4608299255371094e+02 -1.7312001037597656e+02 1.0526599884033203e+02 1.5309399414062500e+02 -1.6241200256347656e+02 1.0526599884033203e+02 2.0329299926757812e+02 -1.5263700866699219e+02 1.3955000305175781e+02 2.1438600158691406e+02 -1.5020799255371094e+02 1.3955000305175781e+02 2.0333399963378906e+02 -1.5257400512695312e+02 1.3304998779296875e+02 3.0329598999023438e+02 -2.7587701416015625e+02 1.0230000305175781e+02 3.0589498901367188e+02 -2.7118899536132812e+02 1.0526499938964844e+02 1.3395599365234375e+02 -2.0738500976562500e+02 -5.7594200134277344e+01 1.3517999267578125e+02 -2.0459899902343750e+02 -1.8744100570678711e+01 2.3902900695800781e+02 -2.7551699829101562e+02 1.2900000000000000e+02 2.5209999084472656e+02 -2.9396298217773438e+02 1.2900000000000000e+02 2.6639300537109375e+02 -2.8657400512695312e+02 1.2900000000000000e+02 2.9268597412109375e+02 -2.5514900207519531e+02 1.0615900421142578e+02 2.9504098510742188e+02 -2.4939500427246094e+02 1.2900000000000000e+02 1.3500599670410156e+02 -2.5077700805664062e+02 1.0526599884033203e+02 1.3477499389648438e+02 -2.4980099487304688e+02 1.0230000305175781e+02 1.3919799804687500e+02 -2.6235101318359375e+02 1.0230000305175781e+02 1.5853300476074219e+02 -2.8678799438476562e+02 1.0230000305175781e+02 1.8028799438476562e+02 -2.8678799438476562e+02 1.0230000305175781e+02 2.4075900268554688e+02 -3.0809997558593750e+02 -5.0521602630615234e+01 2.5209999084472656e+02 -3.0809997558593750e+02 -2.8200000762939453e+01 1.9024099731445312e+02 -1.8453900146484375e+02 1.2900000000000000e+02 1.6681100463867188e+02 -1.7186300659179688e+02 1.2900000000000000e+02 1.6750100708007812e+02 -1.9886000061035156e+02 1.2900000000000000e+02 1.3976199340820312e+02 -1.8562600708007812e+02 1.0526499938964844e+02 1.3922299194335938e+02 -2.1037899780273438e+02 1.0526599884033203e+02 1.3915100097656250e+02 -2.1066899108886719e+02 1.2900000000000000e+02 1.4256300354003906e+02 -2.0203700256347656e+02 1.2900000000000000e+02 1.5309399414062500e+02 -2.8678799438476562e+02 1.0230000305175781e+02 1.9846600341796875e+02 -1.4110099792480469e+02 -3.7242900848388672e+01 2.5142500305175781e+02 -1.4110000610351562e+02 -3.5301700592041016e+01 1.9710000610351562e+02 -1.4110000610351562e+02 -2.8200000762939453e+01 1.3873300170898438e+02 -2.3700300598144531e+02 1.2900000000000000e+02 1.3734400939941406e+02 -2.3003601074218750e+02 1.2900000000000000e+02 1.3826699829101562e+02 -2.3524501037597656e+02 1.0526599884033203e+02 3.1782400512695312e+02 -2.3255400085449219e+02 1.0526599884033203e+02 2.9512100219726562e+02 -2.4906698608398438e+02 1.0526499938964844e+02 3.1402700805664062e+02 -2.5151602172851562e+02 1.0526599884033203e+02 2.8136700439453125e+02 -2.7329699707031250e+02 1.2900000000000000e+02 2.7288601684570312e+02 -2.8176199340820312e+02 1.0526599884033203e+02 2.0844100952148438e+02 -3.1110000610351562e+02 -5.0521602630615234e+01 1.5099899291992188e+02 -2.6083499145507812e+02 1.2900000000000000e+02 1.5566900634765625e+02 -2.6645401000976562e+02 1.2900000000000000e+02 1.7562599182128906e+02 -2.4422299194335938e+02 1.2900000000000000e+02 2.9703701782226562e+02 -2.0445999145507812e+02 -5.6779602050781250e+01 2.9418298339843750e+02 -2.0116600036621094e+02 -5.5256900787353516e+01 2.9490100097656250e+02 -2.0181900024414062e+02 -5.0245699882507324e+00 1.3526399230957031e+02 -1.9760600280761719e+02 1.0526599884033203e+02 1.3131399536132812e+02 -2.1692399597167969e+02 1.0526499938964844e+02 3.1815100097656250e+02 -2.2218499755859375e+02 1.0230000305175781e+02 3.1764001464843750e+02 -2.1607899475097656e+02 1.0526499938964844e+02 2.2460000610351562e+02 -2.9960000610351562e+02 1.3304998779296875e+02 2.2460000610351562e+02 -2.9960000610351562e+02 1.3955000305175781e+02 1.5775000000000000e+02 -2.5875000000000000e+02 1.3955000305175781e+02 1.5778799438476562e+02 -2.5906500244140625e+02 1.3304998779296875e+02 1.3357701110839844e+02 -2.1059500122070312e+02 3.6371799468994141e+01 1.3377999877929688e+02 -2.0825100708007812e+02 6.8863502502441406e+01 1.3396400451660156e+02 -2.0736700439453125e+02 2.6833299636840820e+01 2.4668400573730469e+02 -1.4110000610351562e+02 -4.4711601257324219e+01 2.3904600524902344e+02 -1.4110000610351562e+02 -5.1552700042724609e+01 1.8644200134277344e+02 -2.8926501464843750e+02 1.3304998779296875e+02 1.4557699584960938e+02 -1.9859500122070312e+02 3.4281200408935547e+01 2.9864697265625000e+02 -2.3860499572753906e+02 7.4117301940917969e+01 2.9782199096679688e+02 -2.4319599914550781e+02 3.4616500854492188e+01 2.8664700317382812e+02 -1.9859500122070312e+02 4.6495399475097656e+01 2.8821200561523438e+02 -1.9869599914550781e+02 7.6994102478027344e+01 2.8975000000000000e+02 -1.9900099182128906e+02 7.7262298583984375e+01 1.3398300170898438e+02 -2.4170899963378906e+02 1.0073999786376953e+02 1.3448699951171875e+02 -2.4319400024414062e+02 7.5190002441406250e+01 2.8664700317382812e+02 -1.9859500122070312e+02 -1.6379301071166992e+01 1.3357701110839844e+02 -2.3860499572753906e+02 1.6008800506591797e+01 1.3357199096679688e+02 -2.1059500122070312e+02 -1.9097600936889648e+01 1.9756900024414062e+02 -2.6990899658203125e+02 1.2900000000000000e+02 1.9400100708007812e+02 -2.6754000854492188e+02 1.3304998779296875e+02 1.8794900512695312e+02 -2.6259698486328125e+02 1.2900000000000000e+02 2.1553898620605469e+02 -2.9913101196289062e+02 1.3955000305175781e+02 1.9994099426269531e+02 -1.3809999084472656e+02 -4.0683502197265625e+01 2.0565399169921875e+02 -1.4110099792480469e+02 -4.8183097839355469e+01 1.3357701110839844e+02 -2.1059500122070312e+02 -5.9969802856445312e+01 1.4923500061035156e+02 -2.2532499694824219e+02 -5.9969802856445312e+01 1.4327398681640625e+02 -2.0052400207519531e+02 1.0526499938964844e+02 1.8028799438476562e+02 -2.8678799438476562e+02 1.0526599884033203e+02 1.3357701110839844e+02 -2.3860499572753906e+02 -5.9969802856445312e+01 1.3440899658203125e+02 -2.4332398986816406e+02 -5.9969997406005859e+01 1.3357701110839844e+02 -2.3860499572753906e+02 -3.5175899505615234e+01 2.9744000244140625e+02 -2.0791200256347656e+02 1.0526599884033203e+02 1.9710000610351562e+02 -1.4110000610351562e+02 3.3263198852539062e+01 2.5209999084472656e+02 -1.4110000610351562e+02 -2.8200000762939453e+01 1.4318899536132812e+02 -2.5039300537109375e+02 1.0037599945068359e+02 1.4557699584960938e+02 -2.5060498046875000e+02 1.0230000305175781e+02 1.4098899841308594e+02 -2.4969099426269531e+02 1.0230000305175781e+02 1.8041000366210938e+02 -1.9582598876953125e+02 1.2900000000000000e+02 1.7478799438476562e+02 -2.0738500976562500e+02 1.2900000000000000e+02 2.2460000610351562e+02 -1.4960000610351562e+02 1.3304998779296875e+02 2.3610099792480469e+02 -1.5035900878906250e+02 1.3955000305175781e+02 2.3293499755859375e+02 -1.4997799682617188e+02 1.3304998779296875e+02 2.9869699096679688e+02 -2.3633200073242188e+02 1.3955000305175781e+02 2.9907598876953125e+02 -2.1499099731445312e+02 1.3955000305175781e+02 3.1489700317382812e+02 -2.0074899291992188e+02 1.0230000305175781e+02 1.7183099365234375e+02 -2.2582901000976562e+02 1.3304998779296875e+02 1.7183200073242188e+02 -2.2460000610351562e+02 1.2900000000000000e+02 1.7263999938964844e+02 -2.3378300476074219e+02 1.2900000000000000e+02 2.6605001831054688e+02 -1.9209399414062500e+02 1.2900000000000000e+02 2.9861300659179688e+02 -2.1417799377441406e+02 1.2900000000000000e+02 2.5209999084472656e+02 -3.1110000610351562e+02 1.2900000000000000e+02 2.5209999084472656e+02 -2.9396298217773438e+02 1.0230000305175781e+02 2.7039999389648438e+02 -2.8405801391601562e+02 1.3955000305175781e+02 2.5811099243164062e+02 -2.9184100341796875e+02 1.3955000305175781e+02 2.6037298583984375e+02 -2.9061700439453125e+02 1.3304998779296875e+02 1.9710000610351562e+02 -1.3809999084472656e+02 -2.8200000762939453e+01 2.8664700317382812e+02 -2.5060498046875000e+02 4.8323799133300781e+01 2.8664700317382812e+02 -2.5060600280761719e+02 -1.1485099792480469e+01 1.8070599365234375e+02 -2.5367900085449219e+02 1.2900000000000000e+02 1.7005999755859375e+02 -2.7990402221679688e+02 1.2900000000000000e+02 2.3843600463867188e+02 -1.7356201171875000e+02 1.2900000000000000e+02 2.2460000610351562e+02 -1.7191999816894531e+02 1.2900000000000000e+02 2.7411599731445312e+02 -1.6866700744628906e+02 1.2900000000000000e+02 2.6835098266601562e+02 -1.6405400085449219e+02 1.2900000000000000e+02 2.5306901550292969e+02 -1.7144100952148438e+02 1.2900000000000000e+02 1.7326599121093750e+02 -2.3665100097656250e+02 1.3304998779296875e+02 1.5291200256347656e+02 -2.4683799743652344e+02 1.3304998779296875e+02 2.5209999084472656e+02 -1.3809999084472656e+02 4.8852600097656250e+01 2.1570800781250000e+02 -2.9912799072265625e+02 1.3304998779296875e+02 2.0256500244140625e+02 -2.9646398925781250e+02 1.3304998779296875e+02 2.1015399169921875e+02 -1.3809999084472656e+02 -5.1552700042724609e+01 2.0447200012207031e+02 -1.3809999084472656e+02 -4.6919902801513672e+01 1.5073699951171875e+02 -2.3773098754882812e+02 1.3304998779296875e+02 2.9652899169921875e+02 -2.0289599609375000e+02 1.3304998779296875e+02 2.7405300903320312e+02 -2.0636199951171875e+02 1.3304998779296875e+02 2.6901800537109375e+02 -1.9599699401855469e+02 1.3304998779296875e+02 2.3209600830078125e+02 -2.9928399658203125e+02 1.3955000305175781e+02 2.6312301635742188e+02 -2.8852902221679688e+02 1.0764700317382812e+02 2.5779101562500000e+02 -2.9151300048828125e+02 1.0230000305175781e+02 2.6589901733398438e+02 -2.8678799438476562e+02 1.0230000305175781e+02 2.2460000610351562e+02 -1.4960000610351562e+02 1.3955000305175781e+02 1.4963099670410156e+02 -2.2807499694824219e+02 1.3304998779296875e+02 1.4979701232910156e+02 -2.3099899291992188e+02 1.3955000305175781e+02 2.5209999084472656e+02 -3.0809997558593750e+02 1.0230000305175781e+02 2.5209999084472656e+02 -3.1110000610351562e+02 6.0071498870849609e+01 1.5450799560546875e+02 -2.6530700683593750e+02 1.0526599884033203e+02 1.4160198974609375e+02 -2.6774298095703125e+02 1.0526599884033203e+02 2.1649000549316406e+02 -1.4110000610351562e+02 -5.4577102661132812e+01 3.1553302001953125e+02 -2.0333599853515625e+02 1.0526499938964844e+02 1.8995300292968750e+02 -2.9181201171875000e+02 1.2900000000000000e+02 3.0832897949218750e+02 -1.8309199523925781e+02 1.0230000305175781e+02 2.6589901733398438e+02 -2.8678799438476562e+02 1.0526599884033203e+02 3.1113601684570312e+02 -1.8976399230957031e+02 1.0526599884033203e+02 1.6152200317382812e+02 -1.8396798706054688e+02 1.3955000305175781e+02 1.5676400756835938e+02 -1.9252200317382812e+02 1.3955000305175781e+02 1.7967599487304688e+02 -2.8647698974609375e+02 1.2900000000000000e+02 1.7568099975585938e+02 -2.8393099975585938e+02 1.0526499938964844e+02 1.6472099304199219e+02 -2.7552999877929688e+02 1.0526599884033203e+02 1.4557699584960938e+02 -2.5060498046875000e+02 5.6637203216552734e+01 2.2284899902343750e+02 -1.9859500122070312e+02 1.0230000305175781e+02 1.4279800415039062e+02 -2.4782200622558594e+02 1.2900000000000000e+02 1.4629598999023438e+02 -2.5397598266601562e+02 1.0526499938964844e+02 2.5209999084472656e+02 -3.1110000610351562e+02 -2.8200000762939453e+01 2.5209999084472656e+02 -3.1110000610351562e+02 6.6848897933959961e+00 1.5219700622558594e+02 -2.4467300415039062e+02 1.3955000305175781e+02 2.4951100158691406e+02 -3.1110000610351562e+02 -4.0130100250244141e+01 2.3811499023437500e+02 -3.1110000610351562e+02 -5.2161602020263672e+01 2.7734597778320312e+02 -2.2850100708007812e+02 1.3304998779296875e+02 2.9570599365234375e+02 -2.4869099426269531e+02 1.3304998779296875e+02 2.7431698608398438e+02 -2.4233599853515625e+02 1.3304998779296875e+02 2.9855200195312500e+02 -2.4014900207519531e+02 9.8952499389648438e+01 1.4419700622558594e+02 -2.7258999633789062e+02 1.0230000305175781e+02 2.9960998535156250e+02 -2.2743701171875000e+02 1.3955000305175781e+02 2.9927798461914062e+02 -2.1676499938964844e+02 1.3304998779296875e+02 1.6753900146484375e+02 -1.7586100769042969e+02 1.3955000305175781e+02 1.6169898986816406e+02 -1.8353498840332031e+02 1.3304998779296875e+02 2.9578598022460938e+02 -2.4641899108886719e+02 9.9576896667480469e+01 1.6680000305175781e+02 -1.6241200256347656e+02 1.0526599884033203e+02 1.7321200561523438e+02 -2.1257301330566406e+02 1.3304998779296875e+02 2.5579801940917969e+02 -1.5679800415039062e+02 1.2900000000000000e+02 2.5209999084472656e+02 -1.5523699951171875e+02 1.2900000000000000e+02 2.7987399291992188e+02 -1.7425000000000000e+02 1.0526599884033203e+02 2.8616601562500000e+02 -1.8236100769042969e+02 1.0526599884033203e+02 1.3711399841308594e+02 -2.2774900817871094e+02 1.0526599884033203e+02 2.4758100891113281e+02 -1.5314599609375000e+02 1.3955000305175781e+02 2.9628100585937500e+02 -2.0336000061035156e+02 4.9794101715087891e+01 2.8899197387695312e+02 -2.5040200805664062e+02 -4.6152801513671875e+01 2.9864697265625000e+02 -2.3860499572753906e+02 -5.9969802856445312e+01 2.9864697265625000e+02 -2.1059500122070312e+02 1.0230000305175781e+02 2.9864697265625000e+02 -2.1059500122070312e+02 7.5970199584960938e+01 1.4557699584960938e+02 -1.9859500122070312e+02 -1.6964399337768555e+01 1.4247099304199219e+02 -1.9900199890136719e+02 -5.8409500122070312e+01 1.3827900695800781e+02 -2.4813800048828125e+02 -5.6251296997070312e+01 1.3875498962402344e+02 -2.4852999877929688e+02 -5.9969802856445312e+01 2.9710198974609375e+02 -2.4460501098632812e+02 6.6583404541015625e+01 2.9823898315429688e+02 -2.4171200561523438e+02 7.0289703369140625e+01 1.3495799255371094e+02 -2.4423699951171875e+02 1.0230100250244141e+02 1.3517999267578125e+02 -2.4460099792480469e+02 4.8860198974609375e+01 1.4252699279785156e+02 -2.5026699829101562e+02 9.7371997833251953e+00 1.3398300170898438e+02 -2.4170899963378906e+02 -2.7545099258422852e+01 1.3388600158691406e+02 -2.0759199523925781e+02 -1.4892200469970703e+01 1.3556799316406250e+02 -2.0392599487304688e+02 2.2798498153686523e+01 1.3479800415039062e+02 -2.4394099426269531e+02 1.4838599205017090e+01 1.4098399353027344e+02 -1.9950700378417969e+02 2.7942600250244141e+01 2.9823898315429688e+02 -2.4171200561523438e+02 -3.9637302398681641e+01 1.3732600402832031e+02 -2.4733500671386719e+02 1.0230000305175781e+02 1.9710000610351562e+02 -3.1110000610351562e+02 6.7655197143554688e+01 1.9710000610351562e+02 -3.0809997558593750e+02 3.0641500473022461e+01 1.9710000610351562e+02 -3.1110000610351562e+02 -2.8200000762939453e+01 2.6589901733398438e+02 -1.6241200256347656e+02 1.0526599884033203e+02 1.9710000610351562e+02 -3.0809997558593750e+02 -2.8200000762939453e+01 1.3625300598144531e+02 -1.9457800292968750e+02 1.0230000305175781e+02 1.3335501098632812e+02 -2.4401300048828125e+02 1.0230000305175781e+02 1.3172599792480469e+02 -2.3520700073242188e+02 1.0230000305175781e+02 2.9474600219726562e+02 -2.0163699340820312e+02 1.0230000305175781e+02 2.9122998046875000e+02 -1.9950700378417969e+02 1.0230000305175781e+02 1.3503999328613281e+02 -2.4447399902343750e+02 -2.9775800704956055e+01 1.3569299316406250e+02 -2.4546701049804688e+02 -5.6444297790527344e+01 1.7152301025390625e+02 -1.6816200256347656e+02 1.0526599884033203e+02 1.4907400512695312e+02 -1.9101600646972656e+02 1.0526499938964844e+02 2.9864697265625000e+02 -2.3860499572753906e+02 9.6058898925781250e+01 1.9710000610351562e+02 -1.5458999633789062e+02 1.2900000000000000e+02 1.9710000610351562e+02 -3.0809997558593750e+02 1.0230000305175781e+02 1.4120599365234375e+02 -2.4430799865722656e+02 1.0526599884033203e+02 2.9019900512695312e+02 -1.8892300415039062e+02 1.0526599884033203e+02 2.8852001953125000e+02 -1.8586898803710938e+02 1.2900000000000000e+02 2.5209999084472656e+02 -1.4110000610351562e+02 3.3724399566650391e+01 2.5209999084472656e+02 -1.4110000610351562e+02 1.0230000305175781e+02 2.7383200073242188e+02 -2.4358399963378906e+02 1.2900000000000000e+02 2.7957598876953125e+02 -2.6200399780273438e+02 1.2900000000000000e+02 1.9710000610351562e+02 -3.1110000610351562e+02 1.2900000000000000e+02 2.9720700073242188e+02 -2.4201899719238281e+02 1.0526599884033203e+02 1.9979000854492188e+02 -3.0809997558593750e+02 -4.0305999755859375e+01 1.9807000732421875e+02 -3.1110000610351562e+02 -3.5835197448730469e+01 1.9743099975585938e+02 -3.0809997558593750e+02 -3.2848102569580078e+01 2.3736700439453125e+02 -1.3809999084472656e+02 -5.2639400482177734e+01 2.9864697265625000e+02 -2.1059500122070312e+02 -5.9969802856445312e+01 1.3168099975585938e+02 -2.3469500732421875e+02 1.0526499938964844e+02 2.7409399414062500e+02 -2.8055300903320312e+02 1.2900000000000000e+02 2.5115200805664062e+02 -2.7025000000000000e+02 1.2900000000000000e+02 1.8046000671386719e+02 -1.7152099609375000e+02 1.0230000305175781e+02 2.9610601806640625e+02 -2.8678799438476562e+02 1.0230000305175781e+02 2.8583300781250000e+02 -1.8104901123046875e+02 1.3304998779296875e+02 2.7653698730468750e+02 -2.3392500305175781e+02 1.2900000000000000e+02 2.7736801147460938e+02 -2.2460000610351562e+02 1.2900000000000000e+02 2.9672198486328125e+02 -2.4558999633789062e+02 1.3955000305175781e+02 1.5493998718261719e+02 -1.8357600402832031e+02 1.0526499938964844e+02 2.8664700317382812e+02 -1.9859500122070312e+02 1.8190799713134766e+01 2.7342401123046875e+02 -1.6802999877929688e+02 1.0526599884033203e+02 1.6157099914550781e+02 -1.7661199951171875e+02 1.0526599884033203e+02 1.5872200012207031e+02 -1.7946299743652344e+02 1.2900000000000000e+02 1.8820098876953125e+02 -2.9105300903320312e+02 1.0230000305175781e+02 1.7218800354003906e+02 -2.1809700012207031e+02 1.2900000000000000e+02 2.7005197143554688e+02 -2.5137600708007812e+02 1.3304998779296875e+02 2.6845498657226562e+02 -2.5375300598144531e+02 1.2900000000000000e+02 2.9926998901367188e+02 -2.2078399658203125e+02 1.0526599884033203e+02 2.9904898071289062e+02 -2.3122799682617188e+02 1.0526599884033203e+02 2.4791600036621094e+02 -3.0809997558593750e+02 -4.2833202362060547e+01 2.5867501831054688e+02 -1.8430400085449219e+02 1.2900000000000000e+02 2.8079598999023438e+02 -1.7529701232910156e+02 1.2900000000000000e+02 1.9052700805664062e+02 -1.8435501098632812e+02 1.3304998779296875e+02 2.1260699462890625e+02 -1.7323100280761719e+02 1.3304998779296875e+02 2.1548100280761719e+02 -1.5006799316406250e+02 1.3304998779296875e+02 1.7942399597167969e+02 -1.6287399291992188e+02 1.2900000000000000e+02 1.8971000671386719e+02 -1.5747900390625000e+02 1.2900000000000000e+02 1.5330999755859375e+02 -1.8548699951171875e+02 1.2900000000000000e+02 1.9372000122070312e+02 -1.5622801208496094e+02 1.3304998779296875e+02 2.2460000610351562e+02 -2.7727999877929688e+02 1.2900000000000000e+02 2.1852900695800781e+02 -2.7699398803710938e+02 1.2900000000000000e+02 2.7646899414062500e+02 -2.1490299987792969e+02 1.3304998779296875e+02 1.7781401062011719e+02 -2.4922299194335938e+02 1.3304998779296875e+02 1.8584300231933594e+02 -2.6041900634765625e+02 1.3304998779296875e+02 2.2460000610351562e+02 -1.7191999816894531e+02 1.3304998779296875e+02 2.9613598632812500e+02 -2.4604499816894531e+02 -2.8803701400756836e+01 2.9336801147460938e+02 -2.4857899475097656e+02 -2.5463699340820312e+01 2.5990301513671875e+02 -1.8534199523925781e+02 1.3304998779296875e+02 2.4913699340820312e+02 -1.7780500793457031e+02 1.3304998779296875e+02 2.9085000610351562e+02 -2.4988398742675781e+02 -1.0737000465393066e+01 2.5209999084472656e+02 -3.0809997558593750e+02 5.9928802490234375e+01 2.7216799926757812e+02 -2.0191299438476562e+02 1.2900000000000000e+02 2.9787200927734375e+02 -2.0621800231933594e+02 1.0230200195312500e+02 2.9310797119140625e+02 -2.4874400329589844e+02 -5.2422698974609375e+01 2.9394900512695312e+02 -2.0106999206542969e+02 5.2651199340820312e+01 2.9772799682617188e+02 -2.0572799682617188e+02 -5.9969898223876953e+01 1.3708799743652344e+02 -2.0211000061035156e+02 3.2074897766113281e+01 1.3605200195312500e+02 -2.0329199218750000e+02 3.9531700611114502e+00 1.3481800842285156e+02 -2.0522000122070312e+02 5.3571498870849609e+01 1.3708799743652344e+02 -2.4708999633789062e+02 -1.9134199142456055e+01 1.3605200195312500e+02 -2.4590800476074219e+02 -1.5331000328063965e+01 1.4098399353027344e+02 -1.9950700378417969e+02 -3.0812000274658203e+01 1.4247099304199219e+02 -1.9900199890136719e+02 -6.3017100095748901e-01 2.8975000000000000e+02 -1.9900099182128906e+02 5.3029102325439453e+01 1.3661601257324219e+02 -2.4662500000000000e+02 1.3570899963378906e+01 2.9854598999023438e+02 -2.0902799987792969e+02 5.6193798065185547e+01 2.9823898315429688e+02 -2.0748800659179688e+02 7.7798599243164062e+01 1.3712200927734375e+02 -2.4712799072265625e+02 -5.5226299285888672e+01 2.8899099731445312e+02 -2.5040200805664062e+02 7.4531799316406250e+01 2.8664700317382812e+02 -2.5060498046875000e+02 1.0230000305175781e+02 1.4098399353027344e+02 -1.9950700378417969e+02 2.2100400924682617e+00 1.3469099426269531e+02 -2.0547300720214844e+02 9.9347999572753906e+01 1.4098399353027344e+02 -2.4969300842285156e+02 3.1258199691772461e+01 1.4323001098632812e+02 -2.5040098571777344e+02 5.7319896697998047e+01 2.8975000000000000e+02 -1.9900099182128906e+02 -1.2929599761962891e+01 2.8975000000000000e+02 -1.9900099182128906e+02 2.4188098907470703e+01 2.9123498535156250e+02 -1.9950500488281250e+02 3.9644699096679688e+01 1.5102099609375000e+02 -2.0980999755859375e+02 1.3304998779296875e+02 1.5259001159667969e+02 -2.0331900024414062e+02 1.3955000305175781e+02 1.5463400268554688e+02 -1.9719700622558594e+02 1.3304998779296875e+02 1.7339498901367188e+02 -2.7959201049804688e+02 1.3304998779296875e+02 2.1661199951171875e+02 -1.3809999084472656e+02 -5.4595897674560547e+01 2.2325199890136719e+02 -1.4109899902343750e+02 -5.5724899291992188e+01 1.6186199951171875e+02 -2.7287301635742188e+02 1.2900000000000000e+02 1.4721499633789062e+02 -1.9375500488281250e+02 1.2900000000000000e+02 2.9952899169921875e+02 -2.2879899597167969e+02 1.3304998779296875e+02 2.9821597290039062e+02 -2.3927799987792969e+02 1.3304998779296875e+02 2.2460000610351562e+02 -2.7727999877929688e+02 1.3304998779296875e+02 2.2794699096679688e+02 -1.3809999084472656e+02 -5.5608501434326172e+01 2.3258799743652344e+02 -1.4110000610351562e+02 -5.4595897674560547e+01 2.8195397949218750e+02 -2.7299099731445312e+02 1.3304998779296875e+02 2.7096301269531250e+02 -2.8374099731445312e+02 1.3304998779296875e+02 2.5526600646972656e+02 -2.6752999877929688e+02 1.3304998779296875e+02 2.4900401306152344e+02 -1.7777600097656250e+02 1.2900000000000000e+02 1.9710000610351562e+02 -2.9460998535156250e+02 1.2900000000000000e+02 1.3756098937988281e+02 -2.1766200256347656e+02 1.2899899291992188e+02 1.3357701110839844e+02 -2.3860499572753906e+02 1.0230000305175781e+02 1.3734201049804688e+02 -2.1923300170898438e+02 1.0526599884033203e+02 1.3703900146484375e+02 -2.2442199707031250e+02 1.2900000000000000e+02 2.9777301025390625e+02 -2.3950498962402344e+02 1.2900000000000000e+02 2.9842697143554688e+02 -2.3592900085449219e+02 1.2113300323486328e+02 2.9930300903320312e+02 -2.2786801147460938e+02 1.2900000000000000e+02 1.9333299255371094e+02 -2.8661502075195312e+02 1.0230000305175781e+02 1.9710000610351562e+02 -1.3809999084472656e+02 1.2900000000000000e+02 2.8951901245117188e+02 -2.6239599609375000e+02 1.3304998779296875e+02 2.5841400146484375e+02 -2.8409500122070312e+02 1.0230000305175781e+02 2.9802200317382812e+02 -2.4251100158691406e+02 3.0843800306320190e-01 2.0461300659179688e+02 -3.0809997558593750e+02 -4.7107498168945312e+01 1.9941400146484375e+02 -1.7815600585937500e+02 1.3304998779296875e+02 1.9710000610351562e+02 -1.4110000610351562e+02 1.0230000305175781e+02 2.7598101806640625e+02 -2.1263900756835938e+02 1.2900000000000000e+02 2.9610601806640625e+02 -1.6241200256347656e+02 1.0230000305175781e+02 2.9006500244140625e+02 -1.6241200256347656e+02 1.0230000305175781e+02 2.9501000976562500e+02 -1.9822399902343750e+02 1.3955000305175781e+02 2.9176800537109375e+02 -1.9114700317382812e+02 1.3304998779296875e+02 2.6477301025390625e+02 -2.5882299804687500e+02 1.3304998779296875e+02 1.6498799133300781e+02 -2.7023599243164062e+02 1.3304998779296875e+02 2.5113400268554688e+02 -3.0809997558593750e+02 -3.5868499755859375e+01 2.5209999084472656e+02 -1.3809999084472656e+02 1.2900000000000000e+02 2.6063299560546875e+02 -2.6313998413085938e+02 1.2900000000000000e+02 1.3556100463867188e+02 -2.0359599304199219e+02 1.0230000305175781e+02 2.9864697265625000e+02 -2.1059500122070312e+02 3.7548099517822266e+01 2.1934500122070312e+02 -1.7213598632812500e+02 1.2900000000000000e+02 2.6589901733398438e+02 -1.6241200256347656e+02 1.0230000305175781e+02 2.0792900085449219e+02 -2.7490197753906250e+02 1.2900000000000000e+02 2.0652200317382812e+02 -2.7427499389648438e+02 1.3304998779296875e+02 2.3538699340820312e+02 -2.7634600830078125e+02 1.3304998779296875e+02 2.4668000793457031e+02 -2.7246099853515625e+02 1.3304998779296875e+02 2.0340100097656250e+02 -2.9661599731445312e+02 1.3955000305175781e+02 1.9710000610351562e+02 -2.9460998535156250e+02 1.0230000305175781e+02 2.1063000488281250e+02 -3.0809997558593750e+02 -5.1869602203369141e+01 2.0934899902343750e+02 -1.7401100158691406e+02 1.2900000000000000e+02 1.9981799316406250e+02 -1.7794700622558594e+02 1.2900000000000000e+02 1.9738101196289062e+02 -1.3809999084472656e+02 -3.2403598785400391e+01 2.6235800170898438e+02 -1.6020600891113281e+02 1.2900000000000000e+02 1.4971099853515625e+02 -2.1989700317382812e+02 1.3304998779296875e+02 2.4458700561523438e+02 -3.1110000610351562e+02 -4.7107498168945312e+01 2.9598001098632812e+02 -2.4623699951171875e+02 1.8911499023437500e+01 1.3605200195312500e+02 -2.4590800476074219e+02 3.8815799713134766e+01 1.3605200195312500e+02 -2.4590800476074219e+02 7.5726394653320312e+01 1.3826901245117188e+02 -2.4812600708007812e+02 -2.7268099784851074e+00 1.4401000976562500e+02 -1.9869599914550781e+02 6.1473302841186523e+00 1.4401000976562500e+02 -1.9869599914550781e+02 2.9441900253295898e+01 1.3357701110839844e+02 -2.3860499572753906e+02 4.6775699615478516e+01 2.0128401184082031e+02 -3.1110000610351562e+02 -4.2833202362060547e+01 2.5176901245117188e+02 -3.1110000610351562e+02 -3.2848102569580078e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 55 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1113600730895996e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector 2.9864698648452759e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector 3.1815099716186523e+02 -2.2218500077724457e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1113600730895996e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector 2.9610601067543030e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector 2.9255101084709167e+02 -2.0005699992179871e+02 -5.9970799833536148e+01) (float-vector 2.9864698648452759e+02 -2.1059499680995941e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector 1.3976199924945831e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5309399366378784e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector 1.3976199924945831e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500599563121796e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 1.3500599563121796e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9610601067543030e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector 2.5044301152229309e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector 2.9255101084709167e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5044301152229309e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector 2.3736700415611267e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector 2.9255101084709167e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9738100469112396e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector 1.5309399366378784e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 2.0128400623798370e+02 -3.1110000610351562e+02 -4.2833201587200165e+01) (float-vector 2.0844100415706635e+02 -3.1110000610351562e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector 2.0128400623798370e+02 -3.1110000610351562e+02 -4.2833201587200165e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0340099930763245e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector 2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector 2.9864698648452759e+02 -2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector 2.9864698648452759e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector 2.9255101084709167e+02 -2.0005699992179871e+02 -5.9970799833536148e+01) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9864698648452759e+02 -2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector 3.0589500069618225e+02 -2.7118900418281555e+02 1.0526499897241592e+02) (float-vector 3.1669801473617554e+02 -2.4011799693107605e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1669801473617554e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector 3.1815099716186523e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector 2.9864698648452759e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector 2.9864698648452759e+02 -2.3860499262809753e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector 2.5811100006103516e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1815099716186523e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector 3.1669801473617554e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector 2.9672199487686157e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector 2.9960998892784119e+02 -2.2743700444698334e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8716799616813660e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector 2.9672199487686157e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector 3.1669801473617554e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector 3.0589500069618225e+02 -2.7118900418281555e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9610601067543030e+02 -2.8678798675537109e+02 1.0230000317096710e+02) (float-vector 2.5176900625228882e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector 2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector 2.5176900625228882e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector 2.9610601067543030e+02 -2.8678798675537109e+02 1.0230000317096710e+02) (float-vector 3.0589500069618225e+02 -2.7118900418281555e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.5811100006103516e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector 2.8716799616813660e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector 3.0589500069618225e+02 -2.7118900418281555e+02 1.0526499897241592e+02) (float-vector 2.9610601067543030e+02 -2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3811499774456024e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector 2.5176900625228882e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.5044301152229309e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector 2.9610601067543030e+02 -1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8169798851013184e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.9610601067543030e+02 -1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1015399694442749e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector 1.9738100469112396e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9501000046730042e+02 -1.9822399318218231e+02 1.3955000042915344e+02) (float-vector 3.1113600730895996e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector 3.1815099716186523e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector 2.9960998892784119e+02 -2.2743700444698334e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9501000046730042e+02 -1.9822399318218231e+02 1.3955000042915344e+02) (float-vector 2.8169798851013184e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector 2.9610601067543030e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector 3.1113600730895996e+02 -1.8976399302482605e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 2.2893799841403961e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2893799841403961e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector 1.3440899550914764e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector 2.0844100415706635e+02 -3.1110000610351562e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2893799841403961e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector 2.3811499774456024e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector 2.9537400603294373e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.5176900625228882e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector 2.3811499774456024e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector 2.2893799841403961e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector 2.0844100415706635e+02 -3.1110000610351562e+02 -5.0521600991487503e+01) (float-vector 2.0128400623798370e+02 -3.1110000610351562e+02 -4.2833201587200165e+01) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.5889199972152710e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector 2.3610100150108337e+02 -1.5035900473594666e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5889199972152710e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.8169798851013184e+02 -1.7591199278831482e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2794699668884277e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector 2.1015399694442749e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3736700415611267e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector 2.2794699668884277e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector 1.3508500158786774e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector 2.9255101084709167e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7696300148963928e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector 2.0340099930763245e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7696300148963928e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3734400272369385e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector 1.3500599563121796e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9738100469112396e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 -1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.1438600122928619e+02 -1.5020799636840820e+02 1.3955000042915344e+02) (float-vector 1.9309400022029877e+02 -1.5641400218009949e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.9738100469112396e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector 2.1015399694442749e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector 2.2794699668884277e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector 2.3736700415611267e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector 2.5044301152229309e+02 -1.3809899985790253e+02 -3.8267400115728378e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.3610100150108337e+02 -1.5035900473594666e+02 1.3955000042915344e+02) (float-vector 2.1438600122928619e+02 -1.5020799636840820e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02) (float-vector 1.4279800653457642e+02 -2.4782200157642365e+02 1.2899999320507050e+02) (float-vector 1.5774999558925629e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector 1.7696300148963928e+02 -2.8273099660873413e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500599563121796e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector 1.3734400272369385e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector 1.4279800653457642e+02 -2.4782200157642365e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.6753900051116943e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector 1.5309399366378784e+02 -1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6753900051116943e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.9309400022029877e+02 -1.5641400218009949e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3976199924945831e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector 1.3915100693702698e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3915100693702698e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector 1.3734400272369385e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector 1.3131399452686310e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3976199924945831e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector 1.5309399366378784e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector 1.6753900051116943e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector 1.3915100693702698e+02 -2.1066899597644806e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5259000658988953e+02 -2.0331899821758270e+02 1.3955000042915344e+02) (float-vector 1.3915100693702698e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector 1.6753900051116943e+02 -1.7586100101470947e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9960998892784119e+02 -2.2743700444698334e+02 1.3955000042915344e+02) (float-vector 2.9672199487686157e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector 2.8716799616813660e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector 2.5811100006103516e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector 2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector 2.0340099930763245e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector 1.7696300148963928e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector 1.5774999558925629e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector 1.4979700744152069e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector 1.5259000658988953e+02 -2.0331899821758270e+02 1.3955000042915344e+02) (float-vector 1.6753900051116943e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector 1.9309400022029877e+02 -1.5641400218009949e+02 1.3955000042915344e+02) (float-vector 2.1438600122928619e+02 -1.5020799636840820e+02 1.3955000042915344e+02) (float-vector 2.3610100150108337e+02 -1.5035900473594666e+02 1.3955000042915344e+02) (float-vector 2.5889199972152710e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector 2.8169798851013184e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector 2.9501000046730042e+02 -1.9822399318218231e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4979700744152069e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector 1.3734400272369385e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector 1.3915100693702698e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector 1.5259000658988953e+02 -2.0331899821758270e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3734400272369385e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector 1.4979700744152069e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector 1.5774999558925629e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector 1.4279800653457642e+02 -2.4782200157642365e+02 1.2899999320507050e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "bl_caster_rotation_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_br_caster_l_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 -2.9734701156616211e+01 -9.3289899826049805e+00 2.7445201873779297e+00 -2.9418100357055664e+01 -1.2800700187683105e+01 1.0573199987411499e+00 -2.9640798568725586e+01 -1.0600199699401855e+01 1.0544799804687500e+01 -2.9430900573730469e+01 -8.4442996978759766e+00 8.2298793792724609e+00 -2.9580398559570312e+01 -6.8257398605346680e+00 1.0452800750732422e+01 -2.9676599502563477e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 -2.9607198715209961e+01 8.3633699417114258e+00 -1.0304100036621094e+01 -8.0464500427246094e+01 4.2757096290588379e+00 -9.9000797271728516e+00 -2.9565000534057617e+01 4.3990101814270020e+00 -3.0437600612640381e+00 -2.9632600784301758e+01 1.0238399505615234e+01 -3.0640001296997070e+00 -8.0891304016113281e+01 1.0639900207519531e+01 -1.0523200035095215e+01 -2.9807800292968750e+01 2.0460700988769531e+00 -1.0421499252319336e+01 -2.9872400283813477e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 -2.9559000015258789e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 -8.0892097473144531e+01 8.4554700851440430e+00 -1.0192299842834473e+01 -8.0942695617675781e+01 5.5663700103759766e+00 -1.0925999641418457e+01 -8.0888397216796875e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 -8.0911102294921875e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 -2.9603599548339844e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 -2.9594200134277344e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 -8.0856101989746094e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 -2.9677499771118164e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 -8.0903297424316406e+01 -1.1044600486755371e+01 1.0178999900817871e+00 -2.9632200241088867e+01 1.0607999801635742e+01 1.0090099573135376e+00 -8.0902297973632812e+01 1.1044500350952148e+01 7.1427397727966309e+00 -8.0804000854492188e+01 8.4595899581909180e+00 9.8030099868774414e+00 -8.0907203674316406e+01 5.1623497009277344e+00 7.4257197380065918e+00 -8.1105201721191406e+01 1.1212299346923828e+01 3.3442101478576660e+00 -8.0903900146484375e+01 -1.0557999610900879e+01 6.1998200416564941e+00 -8.1096000671386719e+01 -1.1747900009155273e+01 7.2372202873229980e+00 -8.0794494628906250e+01 -8.3683700561523438e+00 9.8025293350219727e+00 -8.0921005249023438e+01 -5.1738500595092773e+00 4.0853300094604492e+00 -8.0921997070312500e+01 1.0249599456787109e+01 1.0831099510192871e+01 -8.0742095947265625e+01 -2.0039701461791992e+00 1.2268199920654297e+01 -8.1127998352050781e+01 3.9475402832031250e+00 1.1011500358581543e+01 -8.0664100646972656e+01 0.0000000000000000e+00 1.0836700439453125e+01 -8.0821899414062500e+01 2.0019199848175049e+00 -1.1417300224304199e+01 -3.1931400299072266e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 -3.1901300430297852e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 -3.3114299774169922e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 -3.3060798645019531e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 -3.3005496978759766e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 -3.2922698974609375e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 -3.1965400695800781e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 -3.2961498260498047e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 -3.3005199432373047e+01 2.3467597961425781e+00 -4.8763401031494141e+01 -3.2972099304199219e+01 1.6582399368286133e+01 -6.1740497589111328e+01 -3.1979299545288086e+01 1.0151400566101074e+01 -4.5477100372314453e+01 -3.3045398712158203e+01 2.1893899917602539e+01 1.6372301101684570e+01 -3.1941600799560547e+01 5.8962200164794922e+01 2.3468399047851562e+00 -3.3007396697998047e+01 5.1267200469970703e+01 -9.9129495620727539e+00 -3.3083801269531250e+01 4.9431499481201172e+01 -3.6015296936035156e+01 -3.3108100891113281e+01 3.4995300292968750e+01 -4.8726200103759766e+01 -3.1919502258300781e+01 3.8182498931884766e+01 -2.5745399475097656e+01 -3.3058502197265625e+01 4.3290298461914062e+01 -6.4798698425292969e+00 -3.1922300338745117e+01 6.1833000183105469e+01 -3.9104801177978516e+01 -3.3105998992919922e+01 -3.1760398864746094e+01 3.8039699554443359e+01 -3.1931098937988281e+01 4.8811397552490234e+01 2.0110498428344727e+01 -3.2998302459716797e+01 6.3504100799560547e+01 4.7388999938964844e+01 -3.3059799194335938e+01 4.7388999938964844e+01 5.0501701354980469e+01 -3.2199699401855469e+01 3.8274200439453125e+01 6.3447898864746094e+01 -3.3059898376464844e+01 2.0092599868774414e+01 6.0778099060058594e+01 -3.2144401550292969e+01 1.7475801467895508e+01 6.0313198089599609e+01 -3.1965400695800781e+01 7.4321599006652832e+00 6.3284599304199219e+01 -3.2191196441650391e+01 -4.4547400474548340e+00 5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 5.5512199401855469e+01 -3.1871200561523438e+01 -2.7132499694824219e+01 2.8417900085449219e+01 -3.3024398803710938e+01 -6.0260898590087891e+01 4.4547300338745117e+00 -3.2191101074218750e+01 -6.3284301757812500e+01 3.3109401702880859e+01 -3.1901699066162109e+01 -5.2159999847412109e+01 4.6935901641845703e+01 -3.2998600006103516e+01 -4.6935901641845703e+01 4.6696701049804688e+00 -3.3059997558593750e+01 -6.6339698791503906e+01 6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 -3.3019302368164062e+01 6.5981704711914062e+01 -4.4070800781250000e+01 -3.3025100708007812e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 -3.2243999481201172e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 -3.2244602203369141e+01 -3.8144996643066406e+01 1.5174099922180176e+01 -3.2350498199462891e+01 -6.8473693847656250e+01 4.8838300704956055e+00 -3.2246299743652344e+01 -6.9384094238281250e+01 4.1918899536132812e+01 -3.2255702972412109e+01 -5.5662799835205078e+01 5.6185497283935547e+01 -3.2231498718261719e+01 -4.1026100158691406e+01 6.9456398010253906e+01 -3.2233699798583984e+01 -1.5821299552917480e+00 6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 -3.2246299743652344e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 -3.2998302459716797e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 -3.2240303039550781e+01 1.4109100103378296e+00 -6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 -3.8389400482177734e+01 7.4474800109863281e+01 -1.7341400384902954e+00 -3.8391998291015625e+01 7.6071098327636719e+01 5.1130599975585938e+00 -3.4403301239013672e+01 7.2644706726074219e+01 7.1366401672363281e+01 -3.4439002990722656e+01 1.3268600463867188e+01 6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 6.7477394104003906e+01 -3.4428897857666016e+01 2.6760299682617188e+01 7.5355300903320312e+01 -3.7268402099609375e+01 1.7170599699020386e+00 5.9104999542236328e+01 -3.2233699798583984e+01 3.6562202453613281e+01 7.0040397644042969e+01 -3.8387001037597656e+01 2.9782499313354492e+01 7.4474800109863281e+01 -3.8389400482177734e+01 1.5645200729370117e+01 6.2013099670410156e+01 -3.7266197204589844e+01 4.2893001556396484e+01 5.1923801422119141e+01 -3.7266002655029297e+01 5.4677501678466797e+01 4.9207698822021484e+01 -3.2231403350830078e+01 4.9181400299072266e+01 3.9661300659179688e+01 -3.7265899658203125e+01 6.4126296997070312e+01 6.6670997619628906e+01 -4.3020999908447266e+01 4.1205699920654297e+01 7.3550094604492188e+01 -4.3022300720214844e+01 2.7057100296020508e+01 7.7358497619628906e+01 -4.3024600982666016e+01 1.2475700378417969e+01 5.6843299865722656e+01 -4.3021598815917969e+01 5.3966102600097656e+01 2.5049600601196289e+01 -3.4442001342773438e+01 6.8122604370117188e+01 3.6946399688720703e+01 -3.2240901947021484e+01 5.8903797149658203e+01 4.4562896728515625e+01 -4.3020900726318359e+01 6.4476997375488281e+01 1.2114600181579590e+01 -3.8389999389648438e+01 7.5127197265625000e+01 2.6272998809814453e+01 -3.8387500762939453e+01 7.1428794860839844e+01 2.1015600204467773e+01 -3.2246299743652344e+01 6.6359199523925781e+01 3.0671701431274414e+01 -4.3021900177001953e+01 7.2120101928710938e+01 1.6111700057983398e+01 -4.3023998260498047e+01 7.6686698913574219e+01 1.7856500148773193e+00 -4.3026500701904297e+01 7.8329895019531250e+01 7.8330101013183594e+01 -4.3027000427246094e+01 -1.7853500843048096e+00 7.9383201599121094e+01 -4.8954898834228516e+01 -3.4461998939514160e-01 7.8114799499511719e+01 -4.8949199676513672e+01 1.4203499794006348e+01 7.3951698303222656e+01 -4.8940597534179688e+01 2.8930398941040039e+01 6.6686599731445312e+01 -4.8934600830078125e+01 4.3129802703857422e+01 5.6477798461914062e+01 -4.8932300567626953e+01 5.5839900970458984e+01 4.3869800567626953e+01 -4.8934097290039062e+01 6.6202606201171875e+01 2.9704099655151367e+01 -4.8939601898193359e+01 7.3644798278808594e+01 1.4941699981689453e+01 -4.8947898864746094e+01 7.7977600097656250e+01 3.4459200501441956e-01 -4.8954898834228516e+01 7.9383300781250000e+01 -6.4126296997070312e+01 -3.7265899658203125e+01 3.9661300659179688e+01 -5.3850097656250000e+01 -3.6490200042724609e+01 5.2007102966308594e+01 -5.6481498718261719e+01 -3.2248001098632812e+01 4.0724998474121094e+01 -4.8838300704956055e+00 -3.2246299743652344e+01 6.9384094238281250e+01 -1.5174099922180176e+01 -3.2350498199462891e+01 6.8473693847656250e+01 -1.2475700378417969e+01 -4.3024600982666016e+01 7.7358497619628906e+01 -2.9782499313354492e+01 -3.8387001037597656e+01 7.0040397644042969e+01 -4.2893001556396484e+01 -3.7266197204589844e+01 6.2013099670410156e+01 -2.8395601272583008e+01 -3.4441600799560547e+01 6.6799201965332031e+01 -4.3375499725341797e+01 -3.2257099151611328e+01 5.4680000305175781e+01 -2.7057100296020508e+01 -4.3022300720214844e+01 7.3550094604492188e+01 -4.1205699920654297e+01 -4.3020999908447266e+01 6.6670997619628906e+01 -5.3966102600097656e+01 -4.3021598815917969e+01 5.6843299865722656e+01 -6.4476997375488281e+01 -4.3020900726318359e+01 4.4562896728515625e+01 -6.7513504028320312e+01 -3.4440597534179688e+01 2.6707201004028320e+01 -7.5355300903320312e+01 -3.7268402099609375e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 -3.4436901092529297e+01 1.3211199760437012e+01 -6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 -7.5127197265625000e+01 -3.8389999389648438e+01 1.2114600181579590e+01 -7.1428794860839844e+01 -3.8387500762939453e+01 2.6272998809814453e+01 -7.2120101928710938e+01 -4.3021900177001953e+01 3.0671701431274414e+01 -7.6686698913574219e+01 -4.3023998260498047e+01 1.6111700057983398e+01 -1.4203499794006348e+01 -4.8949199676513672e+01 7.8114799499511719e+01 -2.8930398941040039e+01 -4.8940597534179688e+01 7.3951698303222656e+01 -4.3129802703857422e+01 -4.8934600830078125e+01 6.6686599731445312e+01 -5.4402599334716797e+01 -4.9551700592041016e+01 5.7758701324462891e+01 -1.7856500148773193e+00 -5.4973503112792969e+01 7.8329895019531250e+01 -7.8330101013183594e+01 -4.3027000427246094e+01 1.7853500843048096e+00 -6.4116600036621094e+01 -4.8947498321533203e+01 4.6979301452636719e+01 -6.7437301635742188e+01 -4.7811298370361328e+01 4.1716197967529297e+01 -7.3951698303222656e+01 -4.9059398651123047e+01 2.8930398941040039e+01 -7.8114799499511719e+01 -4.9050800323486328e+01 1.4203499794006348e+01 -7.9383201599121094e+01 -4.9045101165771484e+01 -3.4461998939514160e-01 7.8330101013183594e+01 -5.4972999572753906e+01 1.7853500843048096e+00 7.6686698913574219e+01 -5.4976001739501953e+01 1.6111700057983398e+01 7.2120101928710938e+01 -5.4978099822998047e+01 3.0671701431274414e+01 6.4476997375488281e+01 -5.4979099273681641e+01 4.4562896728515625e+01 5.3966102600097656e+01 -5.4978401184082031e+01 5.6843299865722656e+01 7.5127197265625000e+01 -5.9610000610351562e+01 1.2114600181579590e+01 7.5355300903320312e+01 -6.0731601715087891e+01 -1.7170599699020386e+00 7.1428794860839844e+01 -5.9612503051757812e+01 2.6272998809814453e+01 6.4126296997070312e+01 -6.0734100341796875e+01 3.9661300659179688e+01 5.3850097656250000e+01 -6.1509799957275391e+01 5.2007102966308594e+01 4.1205699920654297e+01 -5.4979000091552734e+01 6.6670997619628906e+01 2.7057100296020508e+01 -5.4977699279785156e+01 7.3550094604492188e+01 1.2475700378417969e+01 -5.4975402832031250e+01 7.7358497619628906e+01 -1.2114600181579590e+01 -5.9610000610351562e+01 7.5127197265625000e+01 1.7341400384902954e+00 -5.9608001708984375e+01 7.6071098327636719e+01 4.2893001556396484e+01 -6.0733798980712891e+01 6.2013099670410156e+01 2.9782499313354492e+01 -5.9612998962402344e+01 7.0040397644042969e+01 1.5645200729370117e+01 -5.9610603332519531e+01 7.4474800109863281e+01 5.6481498718261719e+01 -6.5751998901367188e+01 4.0724998474121094e+01 6.7513504028320312e+01 -6.3559398651123047e+01 2.6707201004028320e+01 7.1374496459960938e+01 -6.3563102722167969e+01 1.3211199760437012e+01 6.9488693237304688e+01 -6.5759704589843750e+01 1.4108999967575073e+00 6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 2.8395601272583008e+01 -6.3558399200439453e+01 6.6799201965332031e+01 4.3375499725341797e+01 -6.5742904663085938e+01 5.4680000305175781e+01 -5.1130700111389160e+00 -6.3596702575683594e+01 7.2644706726074219e+01 1.5174099922180176e+01 -6.5649505615234375e+01 6.8473693847656250e+01 -1.6111700057983398e+01 -5.4976001739501953e+01 7.6686698913574219e+01 -3.0671701431274414e+01 -5.4978099822998047e+01 7.2120101928710938e+01 -4.4562896728515625e+01 -5.4979099273681641e+01 6.4476997375488281e+01 -5.6843299865722656e+01 -5.4978401184082031e+01 5.3966102600097656e+01 -2.6272998809814453e+01 -5.9612503051757812e+01 7.1428794860839844e+01 -3.9661300659179688e+01 -6.0734100341796875e+01 6.4126296997070312e+01 -5.1923801422119141e+01 -6.0734001159667969e+01 5.4677501678466797e+01 -7.7358497619628906e+01 -5.4975402832031250e+01 1.2475700378417969e+01 -6.6670997619628906e+01 -5.4979000091552734e+01 4.1205699920654297e+01 -7.3550094604492188e+01 -5.4977699279785156e+01 2.7057100296020508e+01 -7.8330101013183594e+01 -5.4972999572753906e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 -6.0733798980712891e+01 4.2893001556396484e+01 -7.0040397644042969e+01 -5.9612998962402344e+01 2.9782499313354492e+01 -7.5355300903320312e+01 -6.0731601715087891e+01 1.7170599699020386e+00 -7.4474800109863281e+01 -5.9610603332519531e+01 1.5645200729370117e+01 -2.5049600601196289e+01 -6.3557998657226562e+01 6.8122604370117188e+01 -4.9207698822021484e+01 -6.5768600463867188e+01 4.9181400299072266e+01 -3.6946399688720703e+01 -6.5759101867675781e+01 5.8903797149658203e+01 -2.1015600204467773e+01 -6.5753700256347656e+01 6.6359199523925781e+01 -5.9104999542236328e+01 -6.5766296386718750e+01 3.6562202453613281e+01 -6.7477394104003906e+01 -6.3571102142333984e+01 2.6760299682617188e+01 -7.1366401672363281e+01 -6.3561000823974609e+01 1.3268600463867188e+01 -6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 -6.9456398010253906e+01 -6.5766296386718750e+01 -1.5821199417114258e+00 4.8838300704956055e+00 -6.5753700256347656e+01 6.9384094238281250e+01 -6.5954093933105469e+01 -6.5003295898437500e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 -6.5001693725585938e+01 2.0110498428344727e+01 -6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 -6.4940101623535156e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 -6.5744300842285156e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 -6.5649505615234375e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 -6.4940101623535156e+01 4.3333198547363281e+01 -2.5114198684692383e+01 -6.5005798339843750e+01 6.1894699096679688e+01 -4.6691398620605469e+00 -6.4939994812011719e+01 6.6339698791503906e+01 -5.6185497283935547e+01 -6.5768501281738281e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 -6.4974800109863281e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 -6.4940101623535156e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 -6.5753700256347656e+01 -6.9384094238281250e+01 4.6691398620605469e+00 -6.4939994812011719e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 -6.6084396362304688e+01 7.3676099777221680e+00 -3.9422199249267578e+01 -6.6119201660156250e+01 4.7579696655273438e+01 -4.8702198028564453e+01 -6.5940795898437500e+01 3.9441997528076172e+01 -8.7784500122070312e+00 -6.6089698791503906e+01 6.1264701843261719e+01 3.0705200195312500e+01 -6.6117897033691406e+01 5.3397201538085938e+01 1.5252799987792969e+01 -6.5862602233886719e+01 6.1349498748779297e+01 5.0155899047851562e+01 -6.6073204040527344e+01 3.6021900177001953e+01 4.3594100952148438e+01 -6.4963195800781250e+01 5.0356700897216797e+01 6.0698596954345703e+01 -6.6066696166992188e+01 -6.7463498115539551e+00 6.6711799621582031e+01 -6.5003898620605469e+01 1.3542500138282776e-01 5.9121696472167969e+01 -6.6100502014160156e+01 1.8429199218750000e+01 5.9817501068115234e+01 -6.4940101623535156e+01 2.9234298706054688e+01 2.0092599868774414e+01 -6.4940101623535156e+01 6.3447898864746094e+01 -2.4017601013183594e+01 -6.4924705505371094e+01 4.4330997467041016e+01 -1.2296899795532227e+01 -6.4922195434570312e+01 4.8861900329589844e+01 -4.9878101348876953e+01 -6.4923797607421875e+01 6.1260700225830078e+00 -4.7621898651123047e+01 -6.5026702880859375e+01 2.0646100997924805e+01 -5.8962200164794922e+01 -6.6058395385742188e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 -6.4928802490234375e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 -6.4901504516601562e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 -6.4915802001953125e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 -6.6128295898437500e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 -6.4940605163574219e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 -6.4898902893066406e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 -6.5010696411132812e+01 3.6192996978759766e+01 -7.4321599006652832e+00 -6.6034599304199219e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 -6.5038299560546875e+01 -5.1429000854492188e+01 6.1151897907257080e-01 -6.4899902343750000e+01 5.0388702392578125e+01 4.0430500030517578e+01 -6.6047805786132812e+01 -4.7272399902343750e+01 2.1093599319458008e+01 -6.5008094787597656e+01 -4.7210800170898438e+01 5.7853302955627441e+00 -6.4969100952148438e+01 -5.0313201904296875e+01 4.5625198364257812e+01 -6.5076095581054688e+01 -2.5078199386596680e+01 5.2289600372314453e+01 -6.5047103881835938e+01 -4.6615300178527832e+00 4.9076499938964844e+01 -6.5030502319335938e+01 1.6025699615478516e+01 3.6085098266601562e+01 -6.4887702941894531e+01 3.5027797698974609e+01 4.5658901214599609e+01 -6.4956298828125000e+01 2.1977499008178711e+01 1.2848500251770020e+01 -6.4922805786132812e+01 4.8701698303222656e+01 2.4957799911499023e+01 -6.4924301147460938e+01 4.3825702667236328e+01 3.6392799377441406e+01 -6.5013999938964844e+01 -3.6605201721191406e+01 5.6047599792480469e+01 -6.6018997192382812e+01 -2.7524799346923828e+01 4.4547400474548340e+00 -6.5808799743652344e+01 -6.3284599304199219e+01 2.7442001342773438e+01 -6.5952598571777344e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 -6.5855598449707031e+01 -6.0778099060058594e+01 6.3447898864746094e+01 -6.4940101623535156e+01 -2.0092599868774414e+01 5.0577800750732422e+01 -6.4940101623535156e+01 -4.3333198547363281e+01 2.9234298706054688e+01 -6.4940101623535156e+01 -5.9817501068115234e+01 2.1015600204467773e+01 -6.5753700256347656e+01 -6.6359199523925781e+01 5.6820499420166016e+01 -6.5761795043945312e+01 -4.0331298828125000e+01 6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 4.3921298980712891e+01 -6.5758102416992188e+01 -5.3944599151611328e+01 1.5645200729370117e+01 -3.8389400482177734e+01 -7.4474800109863281e+01 1.7341400384902954e+00 -3.8391998291015625e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 -3.4403301239013672e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 -3.4428897857666016e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 -3.4439002990722656e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 -3.8387001037597656e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 -3.8389400482177734e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 -3.7266197204589844e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 -3.7266002655029297e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 -3.3472698211669922e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 -3.7265899658203125e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 -4.3020999908447266e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 -4.3022300720214844e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 -4.3024600982666016e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 -4.3021598815917969e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 -3.4442001342773438e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 -4.3020900726318359e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 -3.8389999389648438e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 -3.8387500762939453e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 -4.3021900177001953e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 -4.3023998260498047e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 -4.3026500701904297e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 -4.9052101135253906e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 -4.9060401916503906e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 -4.9065898895263672e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 -4.9067699432373047e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 -4.9065399169921875e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 -4.9059398651123047e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 -4.9050800323486328e+01 -7.8114799499511719e+01 3.4459200501441956e-01 -4.9045101165771484e+01 -7.9383300781250000e+01 6.4126296997070312e+01 -3.7265899658203125e+01 -3.9661300659179688e+01 5.3850097656250000e+01 -3.6490200042724609e+01 -5.2007102966308594e+01 1.2475700378417969e+01 -4.3024600982666016e+01 -7.7358497619628906e+01 2.9782499313354492e+01 -3.8387001037597656e+01 -7.0040397644042969e+01 4.2893001556396484e+01 -3.7266197204589844e+01 -6.2013099670410156e+01 2.8395601272583008e+01 -3.4441600799560547e+01 -6.6799201965332031e+01 2.7057100296020508e+01 -4.3022300720214844e+01 -7.3550094604492188e+01 4.1205699920654297e+01 -4.3020999908447266e+01 -6.6670997619628906e+01 5.3966102600097656e+01 -4.3021598815917969e+01 -5.6843299865722656e+01 6.7513504028320312e+01 -3.4440597534179688e+01 -2.6707201004028320e+01 6.4476997375488281e+01 -4.3020900726318359e+01 -4.4562896728515625e+01 7.1374496459960938e+01 -3.4436901092529297e+01 -1.3211199760437012e+01 7.5127197265625000e+01 -3.8389999389648438e+01 -1.2114600181579590e+01 7.1428794860839844e+01 -3.8387500762939453e+01 -2.6272998809814453e+01 7.2120101928710938e+01 -4.3021900177001953e+01 -3.0671701431274414e+01 7.6686698913574219e+01 -4.3023998260498047e+01 -1.6111700057983398e+01 1.4941699981689453e+01 -4.9052101135253906e+01 -7.7977600097656250e+01 2.9704099655151367e+01 -4.9060401916503906e+01 -7.3644798278808594e+01 4.1731800079345703e+01 -4.9570999145507812e+01 -6.7475105285644531e+01 4.9999198913574219e+01 -4.8999500274658203e+01 -6.1567001342773438e+01 5.7531902313232422e+01 -4.8420101165771484e+01 -5.4633300781250000e+01 1.7856500148773193e+00 -5.4973503112792969e+01 -7.8329895019531250e+01 6.6202606201171875e+01 -4.8934097290039062e+01 -4.3869800567626953e+01 7.3644798278808594e+01 -4.8939601898193359e+01 -2.9704099655151367e+01 7.7977600097656250e+01 -4.8947898864746094e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 -5.4976001739501953e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 -5.4978099822998047e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 -5.4979099273681641e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 -5.4978401184082031e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 -5.9610000610351562e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 -5.9612503051757812e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 -6.0734100341796875e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 -6.1509799957275391e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 -5.4979000091552734e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 -5.4977699279785156e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 -5.4975402832031250e+01 -7.7358497619628906e+01 1.2114600181579590e+01 -5.9610000610351562e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 -5.9608001708984375e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 -6.0733798980712891e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 -5.9612998962402344e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 -5.9610603332519531e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 -6.3559398651123047e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 -6.3563102722167969e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 -6.3558399200439453e+01 -6.6799201965332031e+01 5.1130599975585938e+00 -6.3596702575683594e+01 -7.2644706726074219e+01 2.5049600601196289e+01 -6.3557998657226562e+01 -6.8122604370117188e+01 1.6111700057983398e+01 -5.4976001739501953e+01 -7.6686698913574219e+01 3.0671701431274414e+01 -5.4978099822998047e+01 -7.2120101928710938e+01 4.2744701385498047e+01 -5.6259502410888672e+01 -6.5250297546386719e+01 5.6843299865722656e+01 -5.4978401184082031e+01 -5.3966102600097656e+01 2.6272998809814453e+01 -5.9612503051757812e+01 -7.1428794860839844e+01 5.1923801422119141e+01 -6.0734001159667969e+01 -5.4677501678466797e+01 3.8678096771240234e+01 -6.2713600158691406e+01 -6.2656597137451172e+01 7.7358497619628906e+01 -5.4975402832031250e+01 -1.2475700378417969e+01 6.6670997619628906e+01 -5.4979000091552734e+01 -4.1205699920654297e+01 7.3550094604492188e+01 -5.4977699279785156e+01 -2.7057100296020508e+01 6.2013099670410156e+01 -6.0733798980712891e+01 -4.2893001556396484e+01 7.0040397644042969e+01 -5.9612998962402344e+01 -2.9782499313354492e+01 7.4474800109863281e+01 -5.9610603332519531e+01 -1.5645200729370117e+01 6.7477394104003906e+01 -6.3571102142333984e+01 -2.6760299682617188e+01 7.1366401672363281e+01 -6.3561000823974609e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 -3.3059700012207031e+01 4.8698802947998047e+01 -6.3504100799560547e+01 -3.2998302459716797e+01 2.0110498428344727e+01 -5.2329101562500000e+01 -3.2130302429199219e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 -3.2137401580810547e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 -3.2020099639892578e+01 4.9141799926757812e+01 2.8352600097656250e+01 -3.2989597320556641e+01 4.3039199829101562e+01 1.5969698905944824e+01 -3.3055599212646484e+01 4.7725498199462891e+01 3.9991699218750000e+01 -3.3097698211669922e+01 3.0614299774169922e+01 4.8633197784423828e+01 -3.3084796905517578e+01 1.3720000267028809e+01 5.0044700622558594e+01 -3.3111999511718750e+01 -5.6227302551269531e+00 3.5953800201416016e+01 -3.3097698211669922e+01 -3.5078903198242188e+01 4.5476398468017578e+01 -3.3045200347900391e+01 -2.1894300460815430e+01 9.9145097732543945e+00 -3.3083801269531250e+01 -4.9431201934814453e+01 2.5745399475097656e+01 -3.3058502197265625e+01 -4.3290298461914062e+01 4.9954399108886719e+01 -6.5034202575683594e+01 5.4540300369262695e+00 4.8967998504638672e+01 -6.7537704467773438e+01 1.3350299835205078e+01 5.0034500122070312e+01 -6.7539604187011719e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 -6.5033500671386719e+01 3.7523998260498047e+01 -4.3557899475097656e+01 -6.7537895202636719e+01 2.6049699783325195e+01 -2.8130199432373047e+01 -6.7539604187011719e+01 4.1621601104736328e+01 -4.9887100219726562e+01 -6.7539398193359375e+01 6.8354101181030273e+00 -4.7150398254394531e+01 -6.5031204223632812e+01 1.8047500610351562e+01 -4.0905799865722656e+01 -6.5034301757812500e+01 2.9103500366210938e+01 -9.2679700851440430e+00 -6.7539001464843750e+01 4.9685398101806641e+01 9.3136892318725586e+00 -6.7538703918457031e+01 4.9535301208496094e+01 2.6869998931884766e+01 -6.7538597106933594e+01 4.2637798309326172e+01 4.0471401214599609e+01 -6.7539604187011719e+01 2.9807500839233398e+01 4.8870899200439453e+01 -6.5032897949218750e+01 -1.3342700004577637e+01 2.4033800125122070e+01 -6.5031997680664062e+01 -4.4287799835205078e+01 3.8291000366210938e+01 -6.5033897399902344e+01 -3.2910102844238281e+01 4.7313400268554688e+01 -6.7535400390625000e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 -6.7537704467773438e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 -6.7539398193359375e+01 -4.9904800415039062e+01 3.7271400451660156e+01 -6.7538406372070312e+01 -3.3985900878906250e+01 2.5166799545288086e+01 -6.7537002563476562e+01 -4.3544601440429688e+01 1.0624900817871094e+01 -6.7538406372070312e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 -6.7537796020507812e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 -6.7539604187011719e+01 -2.9807500839233398e+01 1.2806200027465820e+01 -8.1073295593261719e+01 -3.8097999095916748e+00 1.3205300331115723e+01 -8.0267494201660156e+01 -5.5868902206420898e+00 1.3861199378967285e+01 -8.0269203186035156e+01 4.1422801017761230e+00 6.8685703277587891e+00 -8.0269203186035156e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 -8.0430801391601562e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 -8.1080497741699219e+01 1.2562399864196777e+01 6.8692898750305176e+00 -8.0268096923828125e+01 1.2766799926757812e+01 -2.6745600700378418e+00 -8.0267105102539062e+01 1.4119600296020508e+01 -1.0887900352478027e+01 -8.1082099914550781e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 -8.1073501586914062e+01 3.7914199829101562e+00 -1.3522299766540527e+01 -8.0268005371093750e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 -8.0268394470214844e+01 8.1145401000976562e+00 1.4918000221252441e+01 -8.0275100708007812e+01 -3.5685497283935547e+01 3.7123301029205322e+00 -8.0275100708007812e+01 -3.8456001281738281e+01 5.6025695800781250e+00 -6.7521499633789062e+01 -3.8081703186035156e+01 1.6305999755859375e+01 -6.7521499633789062e+01 -3.5007499694824219e+01 3.6341297149658203e+01 -6.7521499633789062e+01 -1.3186100006103516e+01 3.0869201660156250e+01 -8.0274299621582031e+01 -2.3010200500488281e+01 2.9183500289916992e+01 -6.7522102355957031e+01 -2.5193401336669922e+01 2.3136499404907227e+01 -8.0274299621582031e+01 -3.0677999496459961e+01 3.8549598693847656e+01 -8.0275100708007812e+01 -1.6160999536514282e+00 3.7004398345947266e+01 -8.0275100708007812e+01 -1.1183599472045898e+01 3.8620300292968750e+01 -6.7521499633789062e+01 8.1181198358535767e-01 -4.5067396163940430e+00 -6.7521499633789062e+01 -3.8375400543212891e+01 2.5930200576782227e+01 -8.0275100708007812e+01 2.8557600021362305e+01 3.1677902221679688e+01 -8.0274200439453125e+01 2.1873998641967773e+01 3.1033300399780273e+01 -6.7523498535156250e+01 2.2732900619506836e+01 2.0160699844360352e+01 -6.7523300170898438e+01 3.2750801086425781e+01 6.2813601493835449e+00 -6.7521499633789062e+01 3.8171100616455078e+01 1.6532600402832031e+01 -8.0275100708007812e+01 3.4899303436279297e+01 3.7707702636718750e+01 -8.0275100708007812e+01 8.4654598236083984e+00 3.6223800659179688e+01 -6.7521499633789062e+01 1.2949000358581543e+01 5.2079100608825684e+00 -8.0275100708007812e+01 3.8213302612304688e+01 -3.4080798625946045e+00 -8.0275100708007812e+01 3.8494800567626953e+01 -3.7614700317382812e+01 -8.0275100708007812e+01 9.4110794067382812e+00 -1.6054100036621094e+01 -8.0275100708007812e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 -8.0275100708007812e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 -8.0275100708007812e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 -8.0274406433105469e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 -8.0275001525878906e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 -8.0275001525878906e+01 3.4412902832031250e+01 -3.1601600646972656e+01 -8.0274200439453125e+01 2.1895799636840820e+01 -2.5230501174926758e+01 -8.0274902343750000e+01 2.9101999282836914e+01 -3.3142398834228516e+01 -6.7523193359375000e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 -6.7522598266601562e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 -6.7521499633789062e+01 6.3573803901672363e+00 -3.7880397796630859e+01 -6.7521499633789062e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 -6.7521499633789062e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 -6.7521804809570312e+01 2.5504301071166992e+01 -1.9341501235961914e+01 -6.7523002624511719e+01 3.3339103698730469e+01 -3.4695800781250000e+01 -6.7521499633789062e+01 1.6600400924682617e+01 -7.6062998771667480e+00 -6.7521499633789062e+01 3.7799701690673828e+01 -4.9609901428222656e+01 -3.0460399627685547e+01 8.1507596969604492e+00 -4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 -3.2965702056884766e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 -3.0460399627685547e+01 2.2791400909423828e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 3.5853599548339844e+01 -4.9730598449707031e+01 -3.2965702056884766e+01 6.7970499992370605e+00 2.9969398975372314e+00 -3.2965702056884766e+01 5.0145702362060547e+01 6.9386696815490723e+00 -3.0460399627685547e+01 4.9888397216796875e+01 4.8833702087402344e+01 -3.0460399627685547e+01 1.3304400444030762e+01 4.0471401214599609e+01 -3.0460399627685547e+01 2.9807500839233398e+01 4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 2.5877500534057617e+01 -3.0460399627685547e+01 4.3248897552490234e+01 2.9460500717163086e+01 -3.2965702056884766e+01 4.0491600036621094e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 4.9272800445556641e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 4.3484500885009766e+01 -2.9969398975372314e+00 -3.2965702056884766e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 -3.2965702056884766e+01 -1.7957401275634766e+01 4.3438598632812500e+01 -3.0460399627685547e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 -4.9272800445556641e+01 1.7176401138305664e+01 -3.0460399627685547e+01 -4.7315002441406250e+01 3.1059000015258789e+01 -3.0460399627685547e+01 -3.9376998901367188e+01 2.9829699993133545e+00 -3.0460399627685547e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 -3.0460399627685547e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 -8.1032798767089844e+01 1.1027499437332153e+00 1.0264200210571289e+01 -2.9614400863647461e+01 2.9392998218536377e+00 1.0690099716186523e+01 -4.1044399261474609e+01 0.0000000000000000e+00 8.1825199127197266e+00 -2.9608499526977539e+01 6.8735299110412598e+00 5.0151400566101074e+00 -2.9599399566650391e+01 9.4172601699829102e+00 -6.3304600715637207e+00 -2.9442100524902344e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 -2.9454700469970703e+01 1.2124200820922852e+01 -1.3189299583435059e+01 -2.9452299118041992e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 -2.9457300186157227e+01 6.2997603416442871e+00 6.3305301666259766e+00 -2.9442100524902344e+01 1.2118599891662598e+01 1.3189299583435059e+01 -2.9452299118041992e+01 2.1639201641082764e+00 1.2706499099731445e+01 -3.0459199905395508e+01 -6.5114102363586426e+00 3.8211998939514160e+00 -3.0459899902343750e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 -3.0458499908447266e+01 1.4018300056457520e+01 8.3117198944091797e+00 -3.0458000183105469e+01 1.1874300003051758e+01 1.4127900123596191e+01 -3.0459999084472656e+01 3.0538599491119385e+00 -1.2706499099731445e+01 -3.0459199905395508e+01 6.5114398002624512e+00 -8.3115901947021484e+00 -3.0458000183105469e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 -3.0459199905395508e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "br_caster_l_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_br_caster_r_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 6.8265296936035156e+01 -9.3289899826049805e+00 2.7445201873779297e+00 6.8581901550292969e+01 -1.2800700187683105e+01 1.0573199987411499e+00 6.8359207153320312e+01 -1.0600199699401855e+01 1.0544799804687500e+01 6.8569099426269531e+01 -8.4442996978759766e+00 8.2298793792724609e+00 6.8419601440429688e+01 -6.8257398605346680e+00 1.0452800750732422e+01 6.8323402404785156e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 6.8392799377441406e+01 8.3633699417114258e+00 -1.0304100036621094e+01 1.7535499572753906e+01 4.2757096290588379e+00 -9.9000797271728516e+00 6.8434997558593750e+01 4.3990101814270020e+00 -3.0437600612640381e+00 6.8367401123046875e+01 1.0238399505615234e+01 -3.0640001296997070e+00 1.7108699798583984e+01 1.0639900207519531e+01 -1.0523200035095215e+01 6.8192199707031250e+01 2.0460700988769531e+00 -1.0421499252319336e+01 6.8127601623535156e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 6.8441001892089844e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 1.7107900619506836e+01 8.4554700851440430e+00 -1.0192299842834473e+01 1.7057300567626953e+01 5.5663700103759766e+00 -1.0925999641418457e+01 1.7111598968505859e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 1.7088899612426758e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 6.8396400451660156e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 6.8405799865722656e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 1.7143899917602539e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 6.8322502136230469e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 1.7096700668334961e+01 -1.1044600486755371e+01 1.0178999900817871e+00 6.8367797851562500e+01 1.0607999801635742e+01 1.0090099573135376e+00 1.7097700119018555e+01 1.1044500350952148e+01 7.1427397727966309e+00 1.7195999145507812e+01 8.4595899581909180e+00 9.8030099868774414e+00 1.7092800140380859e+01 5.1623497009277344e+00 7.4257197380065918e+00 1.6894800186157227e+01 1.1212299346923828e+01 3.3442101478576660e+00 1.7096099853515625e+01 -1.0557999610900879e+01 6.1998200416564941e+00 1.6903999328613281e+01 -1.1747900009155273e+01 7.2372202873229980e+00 1.7205499649047852e+01 -8.3683700561523438e+00 9.8025293350219727e+00 1.7078998565673828e+01 -5.1738500595092773e+00 4.0853300094604492e+00 1.7077999114990234e+01 1.0249599456787109e+01 1.0831099510192871e+01 1.7257900238037109e+01 -2.0039701461791992e+00 1.2268199920654297e+01 1.6871999740600586e+01 3.9475402832031250e+00 1.1011500358581543e+01 1.7335899353027344e+01 0.0000000000000000e+00 1.0836700439453125e+01 1.7178098678588867e+01 2.0019199848175049e+00 -1.1417300224304199e+01 6.6068595886230469e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 6.6098693847656250e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 6.4885696411132812e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 6.4939201354980469e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 6.4994499206542969e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 6.5077301025390625e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 6.6034599304199219e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 6.5038505554199219e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 6.4994796752929688e+01 2.3467597961425781e+00 -4.8763401031494141e+01 6.5027900695800781e+01 1.6582399368286133e+01 -6.1740497589111328e+01 6.6020698547363281e+01 1.0151400566101074e+01 -4.5477100372314453e+01 6.4954597473144531e+01 2.1893899917602539e+01 1.6372301101684570e+01 6.6058395385742188e+01 5.8962200164794922e+01 2.3468399047851562e+00 6.4992599487304688e+01 5.1267200469970703e+01 -9.9129495620727539e+00 6.4916198730468750e+01 4.9431499481201172e+01 -3.6015296936035156e+01 6.4891899108886719e+01 3.4995300292968750e+01 -4.8726200103759766e+01 6.6080505371093750e+01 3.8182498931884766e+01 -2.5745399475097656e+01 6.4941505432128906e+01 4.3290298461914062e+01 -6.4798698425292969e+00 6.6077705383300781e+01 6.1833000183105469e+01 -3.9104801177978516e+01 6.4893997192382812e+01 -3.1760398864746094e+01 3.8039699554443359e+01 6.6068901062011719e+01 4.8811397552490234e+01 2.0110498428344727e+01 6.5001693725585938e+01 6.3504100799560547e+01 4.7388999938964844e+01 6.4940200805664062e+01 4.7388999938964844e+01 5.0501701354980469e+01 6.5800300598144531e+01 3.8274200439453125e+01 6.3447898864746094e+01 6.4940101623535156e+01 2.0092599868774414e+01 6.0778099060058594e+01 6.5855598449707031e+01 1.7475801467895508e+01 6.0313198089599609e+01 6.6034599304199219e+01 7.4321599006652832e+00 6.3284599304199219e+01 6.5808799743652344e+01 -4.4547400474548340e+00 5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 5.5512199401855469e+01 6.6128799438476562e+01 -2.7132499694824219e+01 2.8417900085449219e+01 6.4975593566894531e+01 -6.0260898590087891e+01 4.4547300338745117e+00 6.5808898925781250e+01 -6.3284301757812500e+01 3.3109401702880859e+01 6.6098304748535156e+01 -5.2159999847412109e+01 4.6935901641845703e+01 6.5001396179199219e+01 -4.6935901641845703e+01 4.6696701049804688e+00 6.4939994812011719e+01 -6.6339698791503906e+01 6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 6.4980697631835938e+01 6.5981704711914062e+01 -4.4070800781250000e+01 6.4974899291992188e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 6.5756004333496094e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 6.5755393981933594e+01 -3.8144996643066406e+01 1.5174099922180176e+01 6.5649505615234375e+01 -6.8473693847656250e+01 4.8838300704956055e+00 6.5753700256347656e+01 -6.9384094238281250e+01 4.1918899536132812e+01 6.5744300842285156e+01 -5.5662799835205078e+01 5.6185497283935547e+01 6.5768501281738281e+01 -4.1026100158691406e+01 6.9456398010253906e+01 6.5766296386718750e+01 -1.5821299552917480e+00 6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 6.5753700256347656e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 6.5001693725585938e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 6.5759704589843750e+01 1.4109100103378296e+00 -6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 5.9610603332519531e+01 7.4474800109863281e+01 -1.7341400384902954e+00 5.9608001708984375e+01 7.6071098327636719e+01 5.1130599975585938e+00 6.3596702575683594e+01 7.2644706726074219e+01 7.1366401672363281e+01 6.3561000823974609e+01 1.3268600463867188e+01 6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 6.7477394104003906e+01 6.3571102142333984e+01 2.6760299682617188e+01 7.5355300903320312e+01 6.0731601715087891e+01 1.7170599699020386e+00 5.9104999542236328e+01 6.5766296386718750e+01 3.6562202453613281e+01 7.0040397644042969e+01 5.9612998962402344e+01 2.9782499313354492e+01 7.4474800109863281e+01 5.9610603332519531e+01 1.5645200729370117e+01 6.2013099670410156e+01 6.0733798980712891e+01 4.2893001556396484e+01 5.1923801422119141e+01 6.0734001159667969e+01 5.4677501678466797e+01 4.9207698822021484e+01 6.5768600463867188e+01 4.9181400299072266e+01 3.9661300659179688e+01 6.0734100341796875e+01 6.4126296997070312e+01 6.6670997619628906e+01 5.4979000091552734e+01 4.1205699920654297e+01 7.3550094604492188e+01 5.4977699279785156e+01 2.7057100296020508e+01 7.7358497619628906e+01 5.4975402832031250e+01 1.2475700378417969e+01 5.6843299865722656e+01 5.4978401184082031e+01 5.3966102600097656e+01 2.5049600601196289e+01 6.3557998657226562e+01 6.8122604370117188e+01 3.6946399688720703e+01 6.5759101867675781e+01 5.8903797149658203e+01 4.4562896728515625e+01 5.4979099273681641e+01 6.4476997375488281e+01 1.2114600181579590e+01 5.9610000610351562e+01 7.5127197265625000e+01 2.6272998809814453e+01 5.9612503051757812e+01 7.1428794860839844e+01 2.1015600204467773e+01 6.5753700256347656e+01 6.6359199523925781e+01 3.0671701431274414e+01 5.4978099822998047e+01 7.2120101928710938e+01 1.6111700057983398e+01 5.4976001739501953e+01 7.6686698913574219e+01 1.7856500148773193e+00 5.4973503112792969e+01 7.8329895019531250e+01 7.8330101013183594e+01 5.4972999572753906e+01 -1.7853500843048096e+00 7.9383201599121094e+01 4.9045101165771484e+01 -3.4461998939514160e-01 7.8114799499511719e+01 4.9050800323486328e+01 1.4203499794006348e+01 7.3951698303222656e+01 4.9059398651123047e+01 2.8930398941040039e+01 6.6686599731445312e+01 4.9065399169921875e+01 4.3129802703857422e+01 5.6477798461914062e+01 4.9067699432373047e+01 5.5839900970458984e+01 4.3869800567626953e+01 4.9065898895263672e+01 6.6202606201171875e+01 2.9704099655151367e+01 4.9060401916503906e+01 7.3644798278808594e+01 1.4941699981689453e+01 4.9052101135253906e+01 7.7977600097656250e+01 3.4459200501441956e-01 4.9045101165771484e+01 7.9383300781250000e+01 -6.4126296997070312e+01 6.0734100341796875e+01 3.9661300659179688e+01 -5.3850097656250000e+01 6.1509799957275391e+01 5.2007102966308594e+01 -5.6481498718261719e+01 6.5751998901367188e+01 4.0724998474121094e+01 -4.8838300704956055e+00 6.5753700256347656e+01 6.9384094238281250e+01 -1.5174099922180176e+01 6.5649505615234375e+01 6.8473693847656250e+01 -1.2475700378417969e+01 5.4975402832031250e+01 7.7358497619628906e+01 -2.9782499313354492e+01 5.9612998962402344e+01 7.0040397644042969e+01 -4.2893001556396484e+01 6.0733798980712891e+01 6.2013099670410156e+01 -2.8395601272583008e+01 6.3558399200439453e+01 6.6799201965332031e+01 -4.3375499725341797e+01 6.5742904663085938e+01 5.4680000305175781e+01 -2.7057100296020508e+01 5.4977699279785156e+01 7.3550094604492188e+01 -4.1205699920654297e+01 5.4979000091552734e+01 6.6670997619628906e+01 -5.3966102600097656e+01 5.4978401184082031e+01 5.6843299865722656e+01 -6.4476997375488281e+01 5.4979099273681641e+01 4.4562896728515625e+01 -6.7513504028320312e+01 6.3559398651123047e+01 2.6707201004028320e+01 -7.5355300903320312e+01 6.0731601715087891e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 6.3563102722167969e+01 1.3211199760437012e+01 -6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 -7.5127197265625000e+01 5.9610000610351562e+01 1.2114600181579590e+01 -7.1428794860839844e+01 5.9612503051757812e+01 2.6272998809814453e+01 -7.2120101928710938e+01 5.4978099822998047e+01 3.0671701431274414e+01 -7.6686698913574219e+01 5.4976001739501953e+01 1.6111700057983398e+01 -1.4203499794006348e+01 4.9050800323486328e+01 7.8114799499511719e+01 -2.8930398941040039e+01 4.9059398651123047e+01 7.3951698303222656e+01 -4.3129802703857422e+01 4.9065399169921875e+01 6.6686599731445312e+01 -5.4402599334716797e+01 4.8448303222656250e+01 5.7758701324462891e+01 -1.7856500148773193e+00 4.3026500701904297e+01 7.8329895019531250e+01 -7.8330101013183594e+01 5.4972999572753906e+01 1.7853500843048096e+00 -6.4116600036621094e+01 4.9052497863769531e+01 4.6979301452636719e+01 -6.7437301635742188e+01 5.0188701629638672e+01 4.1716197967529297e+01 -7.3951698303222656e+01 4.8940597534179688e+01 2.8930398941040039e+01 -7.8114799499511719e+01 4.8949199676513672e+01 1.4203499794006348e+01 -7.9383201599121094e+01 4.8954898834228516e+01 -3.4461998939514160e-01 7.8330101013183594e+01 4.3027000427246094e+01 1.7853500843048096e+00 7.6686698913574219e+01 4.3023998260498047e+01 1.6111700057983398e+01 7.2120101928710938e+01 4.3021900177001953e+01 3.0671701431274414e+01 6.4476997375488281e+01 4.3020900726318359e+01 4.4562896728515625e+01 5.3966102600097656e+01 4.3021598815917969e+01 5.6843299865722656e+01 7.5127197265625000e+01 3.8389999389648438e+01 1.2114600181579590e+01 7.5355300903320312e+01 3.7268402099609375e+01 -1.7170599699020386e+00 7.1428794860839844e+01 3.8387500762939453e+01 2.6272998809814453e+01 6.4126296997070312e+01 3.7265899658203125e+01 3.9661300659179688e+01 5.3850097656250000e+01 3.6490200042724609e+01 5.2007102966308594e+01 4.1205699920654297e+01 4.3020999908447266e+01 6.6670997619628906e+01 2.7057100296020508e+01 4.3022300720214844e+01 7.3550094604492188e+01 1.2475700378417969e+01 4.3024600982666016e+01 7.7358497619628906e+01 -1.2114600181579590e+01 3.8389999389648438e+01 7.5127197265625000e+01 1.7341400384902954e+00 3.8391998291015625e+01 7.6071098327636719e+01 4.2893001556396484e+01 3.7266197204589844e+01 6.2013099670410156e+01 2.9782499313354492e+01 3.8387001037597656e+01 7.0040397644042969e+01 1.5645200729370117e+01 3.8389400482177734e+01 7.4474800109863281e+01 5.6481498718261719e+01 3.2248001098632812e+01 4.0724998474121094e+01 6.7513504028320312e+01 3.4440597534179688e+01 2.6707201004028320e+01 7.1374496459960938e+01 3.4436901092529297e+01 1.3211199760437012e+01 6.9488693237304688e+01 3.2240303039550781e+01 1.4108999967575073e+00 6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 2.8395601272583008e+01 3.4441600799560547e+01 6.6799201965332031e+01 4.3375499725341797e+01 3.2257099151611328e+01 5.4680000305175781e+01 -5.1130700111389160e+00 3.4403301239013672e+01 7.2644706726074219e+01 1.5174099922180176e+01 3.2350498199462891e+01 6.8473693847656250e+01 -1.6111700057983398e+01 4.3023998260498047e+01 7.6686698913574219e+01 -3.0671701431274414e+01 4.3021900177001953e+01 7.2120101928710938e+01 -4.4562896728515625e+01 4.3020900726318359e+01 6.4476997375488281e+01 -5.6843299865722656e+01 4.3021598815917969e+01 5.3966102600097656e+01 -2.6272998809814453e+01 3.8387500762939453e+01 7.1428794860839844e+01 -3.9661300659179688e+01 3.7265899658203125e+01 6.4126296997070312e+01 -5.1923801422119141e+01 3.7266002655029297e+01 5.4677501678466797e+01 -7.7358497619628906e+01 4.3024600982666016e+01 1.2475700378417969e+01 -6.6670997619628906e+01 4.3020999908447266e+01 4.1205699920654297e+01 -7.3550094604492188e+01 4.3022300720214844e+01 2.7057100296020508e+01 -7.8330101013183594e+01 4.3027000427246094e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 3.7266197204589844e+01 4.2893001556396484e+01 -7.0040397644042969e+01 3.8387001037597656e+01 2.9782499313354492e+01 -7.5355300903320312e+01 3.7268402099609375e+01 1.7170599699020386e+00 -7.4474800109863281e+01 3.8389400482177734e+01 1.5645200729370117e+01 -2.5049600601196289e+01 3.4442001342773438e+01 6.8122604370117188e+01 -4.9207698822021484e+01 3.2231403350830078e+01 4.9181400299072266e+01 -3.6946399688720703e+01 3.2240901947021484e+01 5.8903797149658203e+01 -2.1015600204467773e+01 3.2246299743652344e+01 6.6359199523925781e+01 -5.9104999542236328e+01 3.2233699798583984e+01 3.6562202453613281e+01 -6.7477394104003906e+01 3.4428897857666016e+01 2.6760299682617188e+01 -7.1366401672363281e+01 3.4439002990722656e+01 1.3268600463867188e+01 -6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 -6.9456398010253906e+01 3.2233699798583984e+01 -1.5821199417114258e+00 4.8838300704956055e+00 3.2246299743652344e+01 6.9384094238281250e+01 -6.5954093933105469e+01 3.2996700286865234e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 3.2998302459716797e+01 2.0110498428344727e+01 -6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 3.3059898376464844e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 3.2255702972412109e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 3.2350498199462891e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 3.3059898376464844e+01 4.3333198547363281e+01 -2.5114198684692383e+01 3.2994197845458984e+01 6.1894699096679688e+01 -4.6691398620605469e+00 3.3059997558593750e+01 6.6339698791503906e+01 -5.6185497283935547e+01 3.2231498718261719e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 3.3025199890136719e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 3.3059898376464844e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 3.2246299743652344e+01 -6.9384094238281250e+01 4.6691398620605469e+00 3.3059997558593750e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 3.1915601730346680e+01 7.3676099777221680e+00 -3.9422199249267578e+01 3.1880800247192383e+01 4.7579696655273438e+01 -4.8702198028564453e+01 3.2059200286865234e+01 3.9441997528076172e+01 -8.7784500122070312e+00 3.1910301208496094e+01 6.1264701843261719e+01 3.0705200195312500e+01 3.1882099151611328e+01 5.3397201538085938e+01 1.5252799987792969e+01 3.2137401580810547e+01 6.1349498748779297e+01 5.0155899047851562e+01 3.1926799774169922e+01 3.6021900177001953e+01 4.3594100952148438e+01 3.3036796569824219e+01 5.0356700897216797e+01 6.0698596954345703e+01 3.1933300018310547e+01 -6.7463498115539551e+00 6.6711799621582031e+01 3.2996097564697266e+01 1.3542500138282776e-01 5.9121696472167969e+01 3.1899499893188477e+01 1.8429199218750000e+01 5.9817501068115234e+01 3.3059898376464844e+01 2.9234298706054688e+01 2.0092599868774414e+01 3.3059898376464844e+01 6.3447898864746094e+01 -2.4017601013183594e+01 3.3075298309326172e+01 4.4330997467041016e+01 -1.2296899795532227e+01 3.3077796936035156e+01 4.8861900329589844e+01 -4.9878101348876953e+01 3.3076202392578125e+01 6.1260700225830078e+00 -4.7621898651123047e+01 3.2973300933837891e+01 2.0646100997924805e+01 -5.8962200164794922e+01 3.1941600799560547e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 3.3071201324462891e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 3.3098499298095703e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 3.3084197998046875e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 3.1871698379516602e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 3.3059398651123047e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 3.3101100921630859e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 3.2989299774169922e+01 3.6192996978759766e+01 -7.4321599006652832e+00 3.1965400695800781e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 3.2961700439453125e+01 -5.1429000854492188e+01 6.1151897907257080e-01 3.3100097656250000e+01 5.0388702392578125e+01 4.0430500030517578e+01 3.1952198028564453e+01 -4.7272399902343750e+01 2.1093599319458008e+01 3.2991901397705078e+01 -4.7210800170898438e+01 5.7853302955627441e+00 3.3030902862548828e+01 -5.0313201904296875e+01 4.5625198364257812e+01 3.2923900604248047e+01 -2.5078199386596680e+01 5.2289600372314453e+01 3.2952899932861328e+01 -4.6615300178527832e+00 4.9076499938964844e+01 3.2969501495361328e+01 1.6025699615478516e+01 3.6085098266601562e+01 3.3112297058105469e+01 3.5027797698974609e+01 4.5658901214599609e+01 3.3043701171875000e+01 2.1977499008178711e+01 1.2848500251770020e+01 3.3077198028564453e+01 4.8701698303222656e+01 2.4957799911499023e+01 3.3075702667236328e+01 4.3825702667236328e+01 3.6392799377441406e+01 3.2986000061035156e+01 -3.6605201721191406e+01 5.6047599792480469e+01 3.1980998992919922e+01 -2.7524799346923828e+01 4.4547400474548340e+00 3.2191196441650391e+01 -6.3284599304199219e+01 2.7442001342773438e+01 3.2047397613525391e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 3.2144401550292969e+01 -6.0778099060058594e+01 6.3447898864746094e+01 3.3059898376464844e+01 -2.0092599868774414e+01 5.0577800750732422e+01 3.3059898376464844e+01 -4.3333198547363281e+01 2.9234298706054688e+01 3.3059898376464844e+01 -5.9817501068115234e+01 2.1015600204467773e+01 3.2246299743652344e+01 -6.6359199523925781e+01 5.6820499420166016e+01 3.2238201141357422e+01 -4.0331298828125000e+01 6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 4.3921298980712891e+01 3.2241901397705078e+01 -5.3944599151611328e+01 1.5645200729370117e+01 5.9610603332519531e+01 -7.4474800109863281e+01 1.7341400384902954e+00 5.9608001708984375e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 6.3596702575683594e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 6.3571102142333984e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 6.3561000823974609e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 5.9612998962402344e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 5.9610603332519531e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 6.0733798980712891e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 6.0734001159667969e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 6.4527305603027344e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 6.0734100341796875e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 5.4979000091552734e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 5.4977699279785156e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 5.4975402832031250e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 5.4978401184082031e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 6.3557998657226562e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 5.4979099273681641e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 5.9610000610351562e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 5.9612503051757812e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 5.4978099822998047e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 5.4976001739501953e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 5.4973503112792969e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 4.8947898864746094e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 4.8939601898193359e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 4.8934097290039062e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 4.8932300567626953e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 4.8934600830078125e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 4.8940597534179688e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 4.8949199676513672e+01 -7.8114799499511719e+01 3.4459200501441956e-01 4.8954898834228516e+01 -7.9383300781250000e+01 6.4126296997070312e+01 6.0734100341796875e+01 -3.9661300659179688e+01 5.3850097656250000e+01 6.1509799957275391e+01 -5.2007102966308594e+01 1.2475700378417969e+01 5.4975402832031250e+01 -7.7358497619628906e+01 2.9782499313354492e+01 5.9612998962402344e+01 -7.0040397644042969e+01 4.2893001556396484e+01 6.0733798980712891e+01 -6.2013099670410156e+01 2.8395601272583008e+01 6.3558399200439453e+01 -6.6799201965332031e+01 2.7057100296020508e+01 5.4977699279785156e+01 -7.3550094604492188e+01 4.1205699920654297e+01 5.4979000091552734e+01 -6.6670997619628906e+01 5.3966102600097656e+01 5.4978401184082031e+01 -5.6843299865722656e+01 6.7513504028320312e+01 6.3559398651123047e+01 -2.6707201004028320e+01 6.4476997375488281e+01 5.4979099273681641e+01 -4.4562896728515625e+01 7.1374496459960938e+01 6.3563102722167969e+01 -1.3211199760437012e+01 7.5127197265625000e+01 5.9610000610351562e+01 -1.2114600181579590e+01 7.1428794860839844e+01 5.9612503051757812e+01 -2.6272998809814453e+01 7.2120101928710938e+01 5.4978099822998047e+01 -3.0671701431274414e+01 7.6686698913574219e+01 5.4976001739501953e+01 -1.6111700057983398e+01 1.4941699981689453e+01 4.8947898864746094e+01 -7.7977600097656250e+01 2.9704099655151367e+01 4.8939601898193359e+01 -7.3644798278808594e+01 4.1731800079345703e+01 4.8429000854492188e+01 -6.7475105285644531e+01 4.9999198913574219e+01 4.9000503540039062e+01 -6.1567001342773438e+01 5.7531902313232422e+01 4.9579898834228516e+01 -5.4633300781250000e+01 1.7856500148773193e+00 4.3026500701904297e+01 -7.8329895019531250e+01 6.6202606201171875e+01 4.9065898895263672e+01 -4.3869800567626953e+01 7.3644798278808594e+01 4.9060401916503906e+01 -2.9704099655151367e+01 7.7977600097656250e+01 4.9052101135253906e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 4.3023998260498047e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 4.3021900177001953e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 4.3020900726318359e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 4.3021598815917969e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 3.8389999389648438e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 3.8387500762939453e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 3.7265899658203125e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 3.6490200042724609e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 4.3020999908447266e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 4.3022300720214844e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 4.3024600982666016e+01 -7.7358497619628906e+01 1.2114600181579590e+01 3.8389999389648438e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 3.8391998291015625e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 3.7266197204589844e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 3.8387001037597656e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 3.8389400482177734e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 3.4440597534179688e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 3.4436901092529297e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 3.4441600799560547e+01 -6.6799201965332031e+01 5.1130599975585938e+00 3.4403301239013672e+01 -7.2644706726074219e+01 2.5049600601196289e+01 3.4442001342773438e+01 -6.8122604370117188e+01 1.6111700057983398e+01 4.3023998260498047e+01 -7.6686698913574219e+01 3.0671701431274414e+01 4.3021900177001953e+01 -7.2120101928710938e+01 4.2744701385498047e+01 4.1740497589111328e+01 -6.5250297546386719e+01 5.6843299865722656e+01 4.3021598815917969e+01 -5.3966102600097656e+01 2.6272998809814453e+01 3.8387500762939453e+01 -7.1428794860839844e+01 5.1923801422119141e+01 3.7266002655029297e+01 -5.4677501678466797e+01 3.8678096771240234e+01 3.5286399841308594e+01 -6.2656597137451172e+01 7.7358497619628906e+01 4.3024600982666016e+01 -1.2475700378417969e+01 6.6670997619628906e+01 4.3020999908447266e+01 -4.1205699920654297e+01 7.3550094604492188e+01 4.3022300720214844e+01 -2.7057100296020508e+01 6.2013099670410156e+01 3.7266197204589844e+01 -4.2893001556396484e+01 7.0040397644042969e+01 3.8387001037597656e+01 -2.9782499313354492e+01 7.4474800109863281e+01 3.8389400482177734e+01 -1.5645200729370117e+01 6.7477394104003906e+01 3.4428897857666016e+01 -2.6760299682617188e+01 7.1366401672363281e+01 3.4439002990722656e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 6.4940299987792969e+01 4.8698802947998047e+01 -6.3504100799560547e+01 6.5001693725585938e+01 2.0110498428344727e+01 -5.2329101562500000e+01 6.5869697570800781e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 6.5862602233886719e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 6.5979896545410156e+01 4.9141799926757812e+01 2.8352600097656250e+01 6.5010398864746094e+01 4.3039199829101562e+01 1.5969698905944824e+01 6.4944404602050781e+01 4.7725498199462891e+01 3.9991699218750000e+01 6.4902297973632812e+01 3.0614299774169922e+01 4.8633197784423828e+01 6.4915199279785156e+01 1.3720000267028809e+01 5.0044700622558594e+01 6.4888000488281250e+01 -5.6227302551269531e+00 3.5953800201416016e+01 6.4902297973632812e+01 -3.5078903198242188e+01 4.5476398468017578e+01 6.4954803466796875e+01 -2.1894300460815430e+01 9.9145097732543945e+00 6.4916198730468750e+01 -4.9431201934814453e+01 2.5745399475097656e+01 6.4941505432128906e+01 -4.3290298461914062e+01 4.9954399108886719e+01 3.2965801239013672e+01 5.4540300369262695e+00 4.8967998504638672e+01 3.0462301254272461e+01 1.3350299835205078e+01 5.0034500122070312e+01 3.0460399627685547e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 3.2966499328613281e+01 3.7523998260498047e+01 -4.3557899475097656e+01 3.0462099075317383e+01 2.6049699783325195e+01 -2.8130199432373047e+01 3.0460399627685547e+01 4.1621601104736328e+01 -4.9887100219726562e+01 3.0460599899291992e+01 6.8354101181030273e+00 -4.7150398254394531e+01 3.2968799591064453e+01 1.8047500610351562e+01 -4.0905799865722656e+01 3.2965702056884766e+01 2.9103500366210938e+01 -9.2679700851440430e+00 3.0461000442504883e+01 4.9685398101806641e+01 9.3136892318725586e+00 3.0461299896240234e+01 4.9535301208496094e+01 2.6869998931884766e+01 3.0461400985717773e+01 4.2637798309326172e+01 4.0471401214599609e+01 3.0460399627685547e+01 2.9807500839233398e+01 4.8870899200439453e+01 3.2967102050781250e+01 -1.3342700004577637e+01 2.4033800125122070e+01 3.2967998504638672e+01 -4.4287799835205078e+01 3.8291000366210938e+01 3.2966098785400391e+01 -3.2910102844238281e+01 4.7313400268554688e+01 3.0464601516723633e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 3.0462301254272461e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 3.0460599899291992e+01 -4.9904800415039062e+01 3.7271400451660156e+01 3.0461599349975586e+01 -3.3985900878906250e+01 2.5166799545288086e+01 3.0463001251220703e+01 -4.3544601440429688e+01 1.0624900817871094e+01 3.0461599349975586e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 3.0462200164794922e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 3.0460399627685547e+01 -2.9807500839233398e+01 1.2806200027465820e+01 1.6926700592041016e+01 -3.8097999095916748e+00 1.3205300331115723e+01 1.7732500076293945e+01 -5.5868902206420898e+00 1.3861199378967285e+01 1.7730800628662109e+01 4.1422801017761230e+00 6.8685703277587891e+00 1.7730800628662109e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 1.7569198608398438e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 1.6919498443603516e+01 1.2562399864196777e+01 6.8692898750305176e+00 1.7731899261474609e+01 1.2766799926757812e+01 -2.6745600700378418e+00 1.7732898712158203e+01 1.4119600296020508e+01 -1.0887900352478027e+01 1.6917900085449219e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 1.6926498413085938e+01 3.7914199829101562e+00 -1.3522299766540527e+01 1.7732000350952148e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 1.7731599807739258e+01 8.1145401000976562e+00 1.4918000221252441e+01 1.7724899291992188e+01 -3.5685497283935547e+01 3.7123301029205322e+00 1.7724899291992188e+01 -3.8456001281738281e+01 5.6025695800781250e+00 3.0478500366210938e+01 -3.8081703186035156e+01 1.6305999755859375e+01 3.0478500366210938e+01 -3.5007499694824219e+01 3.6341297149658203e+01 3.0478500366210938e+01 -1.3186100006103516e+01 3.0869201660156250e+01 1.7725700378417969e+01 -2.3010200500488281e+01 2.9183500289916992e+01 3.0477899551391602e+01 -2.5193401336669922e+01 2.3136499404907227e+01 1.7725700378417969e+01 -3.0677999496459961e+01 3.8549598693847656e+01 1.7724899291992188e+01 -1.6160999536514282e+00 3.7004398345947266e+01 1.7724899291992188e+01 -1.1183599472045898e+01 3.8620300292968750e+01 3.0478500366210938e+01 8.1181198358535767e-01 -4.5067396163940430e+00 3.0478500366210938e+01 -3.8375400543212891e+01 2.5930200576782227e+01 1.7724899291992188e+01 2.8557600021362305e+01 3.1677902221679688e+01 1.7725799560546875e+01 2.1873998641967773e+01 3.1033300399780273e+01 3.0476499557495117e+01 2.2732900619506836e+01 2.0160699844360352e+01 3.0476699829101562e+01 3.2750801086425781e+01 6.2813601493835449e+00 3.0478500366210938e+01 3.8171100616455078e+01 1.6532600402832031e+01 1.7724899291992188e+01 3.4899303436279297e+01 3.7707702636718750e+01 1.7724899291992188e+01 8.4654598236083984e+00 3.6223800659179688e+01 3.0478500366210938e+01 1.2949000358581543e+01 5.2079100608825684e+00 1.7724899291992188e+01 3.8213302612304688e+01 -3.4080798625946045e+00 1.7724899291992188e+01 3.8494800567626953e+01 -3.7614700317382812e+01 1.7724899291992188e+01 9.4110794067382812e+00 -1.6054100036621094e+01 1.7724899291992188e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 1.7724899291992188e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 1.7724899291992188e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 1.7725599288940430e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 1.7725000381469727e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 1.7725000381469727e+01 3.4412902832031250e+01 -3.1601600646972656e+01 1.7725799560546875e+01 2.1895799636840820e+01 -2.5230501174926758e+01 1.7725101470947266e+01 2.9101999282836914e+01 -3.3142398834228516e+01 3.0476799011230469e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 3.0477401733398438e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 3.0478500366210938e+01 6.3573803901672363e+00 -3.7880397796630859e+01 3.0478500366210938e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 3.0478500366210938e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 3.0478199005126953e+01 2.5504301071166992e+01 -1.9341501235961914e+01 3.0477001190185547e+01 3.3339103698730469e+01 -3.4695800781250000e+01 3.0478500366210938e+01 1.6600400924682617e+01 -7.6062998771667480e+00 3.0478500366210938e+01 3.7799701690673828e+01 -4.9609901428222656e+01 6.7539604187011719e+01 8.1507596969604492e+00 -4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 6.5034301757812500e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 6.7539604187011719e+01 2.2791400909423828e+01 -3.5167198181152344e+01 6.7539604187011719e+01 3.5853599548339844e+01 -4.9730598449707031e+01 6.5034301757812500e+01 6.7970499992370605e+00 2.9969398975372314e+00 6.5034301757812500e+01 5.0145702362060547e+01 6.9386696815490723e+00 6.7539604187011719e+01 4.9888397216796875e+01 4.8833702087402344e+01 6.7539604187011719e+01 1.3304400444030762e+01 4.0471401214599609e+01 6.7539604187011719e+01 2.9807500839233398e+01 4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 2.5877500534057617e+01 6.7539604187011719e+01 4.3248897552490234e+01 2.9460500717163086e+01 6.5034301757812500e+01 4.0491600036621094e+01 -1.0601699829101562e+01 6.7539604187011719e+01 4.9272800445556641e+01 -2.4852701187133789e+01 6.7539604187011719e+01 4.3484500885009766e+01 -2.9969398975372314e+00 6.5034301757812500e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 6.5034301757812500e+01 -1.7957401275634766e+01 4.3438598632812500e+01 6.7539604187011719e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 6.7539604187011719e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 6.7539604187011719e+01 -4.9272800445556641e+01 1.7176401138305664e+01 6.7539604187011719e+01 -4.7315002441406250e+01 3.1059000015258789e+01 6.7539604187011719e+01 -3.9376998901367188e+01 2.9829699993133545e+00 6.7539604187011719e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 6.7539604187011719e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 6.7539604187011719e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 1.6967199325561523e+01 1.1027499437332153e+00 1.0264200210571289e+01 6.8385604858398438e+01 2.9392998218536377e+00 1.0690099716186523e+01 5.6955596923828125e+01 0.0000000000000000e+00 8.1825199127197266e+00 6.8391502380371094e+01 6.8735299110412598e+00 5.0151400566101074e+00 6.8400596618652344e+01 9.4172601699829102e+00 -6.3304600715637207e+00 6.8557899475097656e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 6.8545295715332031e+01 1.2124200820922852e+01 -1.3189299583435059e+01 6.8547706604003906e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 6.8542694091796875e+01 6.2997603416442871e+00 6.3305301666259766e+00 6.8557899475097656e+01 1.2118599891662598e+01 1.3189299583435059e+01 6.8547706604003906e+01 2.1639201641082764e+00 1.2706499099731445e+01 6.7540802001953125e+01 -6.5114102363586426e+00 3.8211998939514160e+00 6.7540100097656250e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 6.7541503906250000e+01 1.4018300056457520e+01 8.3117198944091797e+00 6.7541999816894531e+01 1.1874300003051758e+01 1.4127900123596191e+01 6.7540000915527344e+01 3.0538599491119385e+00 -1.2706499099731445e+01 6.7540802001953125e+01 6.5114398002624512e+00 -8.3115901947021484e+00 6.7541999816894531e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 6.7540802001953125e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "br_caster_r_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_br_caster_rotation_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -2.2459999999999999e+02 -2.2459999999999999e+02 2.8199999999999999e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 162 0 2 1 0 151 0 162 151 1 151 152 1 152 215 1 284 2 1 215 284 151 223 152 151 162 223 2 299 162 162 299 223 274 299 2 150 299 274 299 150 223 2 273 274 274 351 148 150 274 148 289 351 274 273 289 274 168 148 351 288 351 289 351 166 168 166 351 288 288 289 175 273 175 289 177 167 288 288 175 177 166 288 167 166 167 168 167 311 168 235 234 167 234 380 167 454 167 380 235 167 177 311 167 454 453 311 454 182 311 453 168 311 182 453 454 451 454 380 451 159 182 453 451 159 453 451 160 159 160 451 380 159 160 161 181 182 159 214 181 159 214 159 161 161 160 380 440 214 161 161 380 440 347 158 214 214 440 347 158 181 214 181 339 47 181 47 182 158 339 181 37 158 134 134 158 347 158 37 339 476 47 339 476 339 37 72 476 36 68 476 427 476 68 47 72 427 476 476 37 36 36 37 38 70 72 36 91 36 38 91 70 36 38 37 368 23 38 368 91 38 287 287 38 23 91 86 70 91 195 86 91 287 195 86 87 70 498 87 86 195 498 86 35 195 287 35 318 195 498 195 497 195 318 497 498 497 418 498 418 87 418 331 87 87 331 70 331 90 71 331 426 90 418 426 331 70 331 71 70 71 72 72 71 82 71 412 82 71 90 412 72 82 414 414 427 72 82 329 414 412 329 82 412 413 329 90 89 412 412 89 413 328 329 142 328 191 329 191 414 329 329 413 142 190 414 191 190 427 414 190 68 427 189 190 191 189 69 190 69 68 190 205 191 328 189 191 205 141 328 142 141 205 328 204 189 205 216 218 205 212 216 205 218 204 205 212 205 141 189 204 499 499 69 189 499 204 42 499 42 452 499 452 69 42 43 44 201 42 202 42 44 202 452 42 201 204 43 42 43 330 44 43 327 344 43 344 330 204 327 43 44 330 325 44 325 202 324 202 325 202 324 201 452 201 324 45 452 46 45 69 452 452 324 341 341 46 452 45 46 47 45 68 69 68 45 47 182 47 46 341 182 46 340 148 341 341 365 182 148 365 341 341 324 340 182 365 168 168 365 148 148 149 150 149 148 340 324 149 340 324 333 149 333 81 149 150 149 81 223 150 224 150 81 224 79 80 81 333 75 81 80 224 81 75 79 81 222 223 224 222 224 80 429 80 428 80 79 428 222 80 429 74 97 79 74 79 75 97 428 79 73 74 75 73 75 333 73 420 74 420 496 74 74 496 97 495 494 73 495 73 333 494 420 73 324 495 333 325 494 495 324 325 495 330 420 494 325 330 494 330 416 420 330 344 416 344 415 416 416 415 420 420 415 496 415 423 95 496 415 95 344 423 415 344 217 345 345 423 344 327 217 344 320 95 423 321 320 423 345 321 423 95 96 97 96 95 320 496 95 97 320 321 96 217 321 345 321 17 96 321 217 17 17 16 96 96 16 97 97 16 326 326 428 97 15 16 17 16 15 326 17 131 15 17 217 213 17 213 131 15 131 52 15 52 245 15 245 286 15 286 326 213 52 131 51 35 52 52 35 34 213 51 52 245 52 34 318 51 319 51 88 319 213 88 51 51 318 35 497 318 418 318 319 418 319 417 418 417 319 88 418 417 426 426 417 90 90 417 88 88 89 90 78 413 89 89 88 76 78 89 76 76 77 78 142 413 78 142 78 77 88 77 76 141 142 77 212 141 77 77 88 212 212 88 213 213 216 212 213 217 216 216 217 218 218 217 327 204 218 327 33 34 35 35 66 67 35 203 66 35 287 203 35 364 33 67 411 35 411 364 35 245 34 314 34 33 314 244 245 101 286 245 223 405 245 314 101 245 405 244 223 245 405 314 33 405 409 402 102 101 405 409 405 33 102 405 402 33 111 110 33 110 409 364 315 33 33 315 111 402 409 110 401 402 110 493 102 402 493 402 401 110 111 112 112 401 110 112 462 401 462 493 401 322 493 197 462 197 493 322 102 493 462 112 332 58 60 462 58 462 332 60 197 462 111 332 112 111 58 332 58 59 60 315 58 111 315 59 58 61 59 62 62 59 30 59 364 30 59 315 364 59 61 477 60 59 477 477 61 92 61 62 92 92 62 32 62 30 32 30 31 32 364 31 30 364 411 31 411 178 31 32 31 178 92 32 93 32 178 93 92 93 94 477 92 421 421 92 94 313 94 93 93 178 180 93 180 313 178 179 180 411 67 178 178 67 179 180 179 83 410 180 85 180 83 85 313 180 410 313 410 342 94 313 342 410 99 342 99 410 85 83 84 85 98 99 85 84 432 85 432 98 85 179 66 83 66 84 83 430 431 84 430 84 66 431 432 84 419 432 431 419 98 432 419 200 98 98 343 99 200 343 98 342 99 343 200 129 343 342 343 278 343 129 278 198 199 200 129 200 199 198 200 419 198 419 431 198 431 375 375 431 430 198 129 199 287 198 375 129 198 287 287 375 203 203 375 430 465 355 287 287 130 129 22 465 287 23 22 287 355 130 287 128 129 130 130 355 308 130 308 307 130 307 128 128 479 129 278 129 479 468 126 479 479 126 278 337 468 479 337 479 128 121 278 126 232 342 278 121 280 278 280 232 278 408 342 232 408 94 342 408 422 94 317 408 316 317 422 408 316 408 232 421 94 422 317 421 422 316 60 317 317 60 477 317 477 421 60 196 197 196 60 316 196 323 197 196 298 323 196 348 298 196 316 348 197 323 322 322 323 11 298 11 323 9 11 298 9 298 348 316 9 348 9 10 11 9 316 10 304 11 53 322 11 304 11 54 53 10 54 11 304 102 322 304 53 100 102 304 100 53 54 55 100 53 55 171 140 54 54 139 55 54 140 139 171 54 10 424 55 425 424 100 55 267 425 55 139 267 55 100 101 102 424 101 100 425 244 424 244 101 424 244 425 223 223 425 461 425 267 461 286 223 222 223 461 239 223 239 271 271 458 223 223 458 152 461 267 266 461 266 239 144 238 239 238 271 239 144 239 266 265 266 267 145 266 265 266 145 144 279 265 267 145 265 279 267 369 104 267 104 279 267 139 369 279 104 173 145 279 173 103 172 173 103 173 104 173 172 366 366 145 173 64 103 104 172 103 64 172 64 63 172 357 367 172 63 357 366 172 367 366 367 145 483 143 367 357 475 367 483 367 448 143 145 367 448 367 475 143 144 145 482 395 143 482 143 483 395 144 143 448 125 483 483 125 482 443 482 125 482 443 395 144 395 396 443 396 395 358 238 144 358 144 450 144 396 450 396 480 450 396 481 480 443 481 396 485 450 277 450 480 277 358 450 350 450 485 350 334 238 358 358 350 334 271 238 272 238 334 272 485 458 271 350 485 271 406 271 272 271 406 350 485 379 458 379 485 277 379 152 458 283 215 379 215 152 379 283 379 277 215 283 284 247 283 208 208 283 277 284 283 247 285 284 247 2 284 285 2 285 273 273 285 439 439 285 247 176 273 439 175 273 176 176 439 177 177 439 247 175 176 177 246 398 177 246 177 247 253 235 177 398 253 177 208 246 247 399 398 246 208 399 246 188 398 399 188 253 398 399 436 472 207 436 399 399 472 188 208 207 399 206 207 208 277 206 208 480 481 206 481 207 206 480 206 277 481 256 207 443 256 481 256 257 207 185 186 256 257 256 209 256 186 209 443 185 256 443 124 185 443 125 124 185 124 186 209 186 13 186 124 264 13 186 264 39 209 13 209 484 257 39 484 209 484 39 257 39 40 41 39 41 194 194 257 39 39 13 12 39 187 40 39 270 187 12 270 39 436 194 41 41 40 436 207 194 436 194 207 257 40 472 436 188 472 40 40 187 188 253 188 254 254 188 292 187 292 188 292 187 270 292 270 260 254 292 260 260 253 254 269 253 260 253 233 235 253 269 233 269 260 270 270 133 269 306 233 269 433 269 491 269 133 491 269 433 306 233 234 235 233 380 234 233 306 380 226 157 380 440 380 157 306 226 380 8 225 226 225 157 226 8 226 306 6 7 8 306 6 8 8 7 225 7 155 225 157 225 155 388 7 6 388 155 7 388 6 27 388 27 394 388 464 155 388 394 464 25 26 27 27 6 132 132 25 27 394 27 26 394 389 464 138 394 26 389 394 138 464 487 488 464 488 155 389 487 464 487 349 488 487 478 349 389 478 487 349 155 488 155 156 157 391 156 155 349 392 155 391 155 392 377 378 156 346 377 156 156 378 157 156 391 346 157 378 393 440 157 393 377 374 378 374 393 378 393 347 440 374 347 393 374 134 347 377 134 374 134 135 56 134 377 135 134 56 37 57 135 305 135 377 305 56 135 57 37 56 57 57 368 37 305 108 57 57 108 109 109 368 57 108 305 346 346 305 377 108 21 109 346 391 108 21 108 391 368 109 21 21 23 368 21 22 23 21 391 392 21 392 349 349 22 21 465 22 349 349 249 248 459 349 248 465 349 459 478 249 349 459 105 465 220 355 465 105 220 465 459 474 105 248 474 459 105 106 107 105 255 106 105 107 220 105 474 255 255 474 355 355 474 308 308 474 248 354 255 355 355 220 354 106 255 354 220 221 354 221 106 354 220 165 221 49 106 221 165 164 221 164 49 221 48 49 50 49 437 106 363 437 49 49 48 363 50 49 164 48 192 193 48 193 363 48 50 192 50 164 192 193 192 164 363 193 445 445 193 164 444 363 445 363 444 437 438 445 164 444 445 438 437 444 438 437 438 275 164 275 438 258 275 211 164 211 275 258 437 275 258 211 259 259 437 258 163 210 211 163 211 164 210 259 211 163 164 165 489 210 163 489 163 165 210 489 437 259 210 437 106 437 489 106 489 243 243 489 165 107 165 220 107 243 165 107 106 243 117 248 249 404 449 248 449 252 248 117 404 248 252 308 248 478 400 249 400 117 249 389 400 478 117 400 4 389 4 400 4 389 390 138 390 389 227 390 137 390 138 137 4 390 227 136 137 138 26 136 138 137 133 268 268 227 137 137 136 26 133 137 26 227 228 229 268 228 227 4 227 229 133 228 268 115 312 228 4 229 228 133 115 228 312 4 228 5 4 312 115 5 312 3 4 5 117 4 3 116 3 5 5 115 116 116 117 3 117 116 404 116 403 404 114 116 115 116 114 403 404 386 449 404 403 386 403 236 386 114 263 403 403 263 236 113 114 115 370 114 113 114 370 263 113 12 370 12 113 115 12 115 133 12 13 14 12 469 470 12 14 469 470 370 12 12 133 270 470 263 370 261 470 469 470 261 263 469 231 261 231 469 14 261 262 263 261 231 301 397 261 301 397 262 261 14 230 231 231 300 301 231 230 300 301 300 441 397 301 295 441 295 301 397 295 372 397 372 466 262 397 466 466 372 237 466 237 407 407 262 466 236 407 237 263 407 236 262 407 263 120 236 237 353 386 236 120 119 236 236 119 353 118 119 120 120 219 118 237 219 120 352 353 119 118 352 119 310 353 352 353 310 387 353 387 386 121 123 352 310 352 123 121 352 118 276 118 219 121 118 276 276 219 383 237 383 219 276 184 232 232 280 276 184 276 383 121 276 280 121 122 123 126 122 121 126 127 122 122 127 123 468 467 126 126 467 127 127 467 468 123 127 337 127 468 337 251 337 128 251 376 337 337 376 123 250 251 252 376 251 250 252 251 490 490 251 128 307 490 128 307 252 490 307 308 252 449 386 252 250 252 386 386 387 250 387 309 250 309 376 250 310 309 387 123 309 310 123 376 309 184 383 169 383 384 169 457 383 237 384 383 457 183 184 169 184 183 232 169 10 183 232 183 316 10 316 183 171 10 169 169 170 171 171 170 140 170 169 359 140 170 64 64 170 146 359 147 170 170 147 146 104 139 140 140 64 104 63 64 65 65 64 146 146 147 65 63 65 357 65 147 357 356 357 147 382 475 357 356 382 357 381 382 356 297 356 371 381 356 297 371 356 147 471 475 382 471 382 381 475 471 448 381 296 471 296 448 471 296 381 297 295 296 297 295 297 371 295 371 372 372 371 147 295 441 442 295 442 296 300 230 441 441 230 442 230 373 442 296 442 373 14 373 230 373 29 296 373 14 29 14 28 29 13 240 14 447 446 14 240 447 14 28 14 446 29 28 460 460 296 29 446 460 28 446 447 448 446 448 460 240 242 447 448 447 242 240 241 242 241 240 13 448 242 125 125 242 241 448 296 460 241 13 125 124 125 13 13 264 124 147 455 372 147 359 455 455 359 456 455 457 372 455 456 457 457 237 372 384 457 456 359 384 456 359 169 384 104 369 139 132 133 25 133 281 282 133 434 433 133 282 434 491 133 433 281 133 132 25 133 26 281 302 303 282 281 303 302 281 132 434 282 435 303 435 282 433 434 435 433 435 306 306 435 303 6 303 302 6 306 303 132 6 302 350 335 334 406 335 350 334 335 336 335 338 336 335 406 154 338 335 154 291 334 293 291 272 334 334 336 293 290 154 291 293 290 291 406 272 291 154 406 291 501 290 293 154 290 501 154 501 473 473 501 293 154 473 385 473 293 385 385 153 154 385 293 492 153 385 492 153 18 154 294 153 492 153 294 18 492 293 294 293 19 294 294 19 18 18 19 20 362 18 20 18 362 154 20 19 24 19 174 24 19 293 174 486 362 20 486 20 24 486 24 174 174 463 486 463 362 486 174 293 336 500 174 361 174 336 361 500 463 174 463 360 362 500 360 463 360 500 361 360 361 362 362 361 336 362 336 338 362 338 154 429 286 222 326 286 429 326 429 428 203 430 66 67 66 179))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.5309399414062500e+02 1.6241200256347656e+02 1.0526599884033203e+02 1.6749499511718750e+02 1.6241200256347656e+02 1.0526599884033203e+02 1.4962998962402344e+02 1.6754400634765625e+02 1.0526599884033203e+02 2.5771398925781250e+02 2.9194000244140625e+02 1.3304998779296875e+02 2.4495401000976562e+02 2.9688598632812500e+02 1.3304998779296875e+02 2.5889199829101562e+02 2.9147402954101562e+02 1.3955000305175781e+02 1.7266799926757812e+02 2.7893399047851562e+02 1.3304998779296875e+02 1.8274299621582031e+02 2.5680999755859375e+02 1.3304998779296875e+02 1.7675300598144531e+02 2.4676300048828125e+02 1.3304998779296875e+02 2.9864697265625000e+02 2.1059500122070312e+02 1.0230000305175781e+02 3.1669802856445312e+02 2.0908200073242188e+02 1.0230000305175781e+02 2.9776699829101562e+02 2.0587199401855469e+02 1.0230000305175781e+02 2.8804498291015625e+02 2.6470397949218750e+02 1.3955000305175781e+02 2.4302198791503906e+02 1.5177099609375000e+02 1.3955000305175781e+02 2.7962301635742188e+02 1.7346200561523438e+02 1.3955000305175781e+02 1.4557699584960938e+02 1.9859201049804688e+02 -1.6409799575805664e+01 1.4248800659179688e+02 1.9892098999023438e+02 -2.7892499923706055e+01 1.4242399597167969e+02 1.9894898986816406e+02 -5.9969299316406250e+01 2.3170300292968750e+02 1.4110000610351562e+02 -5.4909603118896484e+01 2.2893800354003906e+02 1.3809999084472656e+02 -5.5569801330566406e+01 2.2042399597167969e+02 1.4110000610351562e+02 -5.5612400054931641e+01 1.8657299804687500e+02 2.9028500366210938e+02 1.0230000305175781e+02 1.9710000610351562e+02 2.9460998535156250e+02 1.0230000305175781e+02 1.9573899841308594e+02 2.7945001220703125e+02 1.0230000305175781e+02 2.1716299438476562e+02 1.3809999084472656e+02 -5.4838798522949219e+01 1.8395500183105469e+02 2.8766598510742188e+02 1.3955000305175781e+02 1.9309399414062500e+02 2.9278601074218750e+02 1.3955000305175781e+02 1.8358898925781250e+02 2.8748501586914062e+02 1.3304998779296875e+02 2.8716799926757812e+02 1.8310000610351562e+02 1.3955000305175781e+02 2.9236502075195312e+02 1.9235800170898438e+02 1.3955000305175781e+02 2.9864697265625000e+02 2.3860499572753906e+02 -4.3196701049804688e+01 2.9844998168945312e+02 2.4091101074218750e+02 -5.8984100341796875e+01 2.9835598754882812e+02 2.4154199218750000e+02 -9.5243206024169922e+00 2.9099398803710938e+02 1.9934800720214844e+02 -5.9969898223876953e+01 2.8664700317382812e+02 1.9859500122070312e+02 -5.9969802856445312e+01 2.8664700317382812e+02 2.5060498046875000e+02 -5.9969802856445312e+01 1.4111100769042969e+02 2.4978900146484375e+02 1.0230100250244141e+02 1.4256199645996094e+02 2.6967901611328125e+02 1.0230000305175781e+02 1.4557699584960938e+02 2.5060498046875000e+02 1.0230000305175781e+02 1.9108801269531250e+02 1.5739799499511719e+02 1.3955000305175781e+02 1.6508399963378906e+02 1.7879199218750000e+02 1.3955000305175781e+02 1.7696299743652344e+02 1.6646899414062500e+02 1.3955000305175781e+02 1.3398300170898438e+02 2.0749099731445312e+02 5.7514900207519531e+01 1.3398300170898438e+02 2.0749099731445312e+02 1.3412400245666504e+01 1.3448699951171875e+02 2.0600601196289062e+02 3.6914199829101562e+01 1.3357701110839844e+02 2.3860499572753906e+02 1.0230000305175781e+02 1.3136099243164062e+02 2.3057299804687500e+02 1.0230000305175781e+02 1.3324299621582031e+02 2.4367100524902344e+02 1.0230000305175781e+02 2.4409001159667969e+02 3.1110000610351562e+02 -4.7562698364257812e+01 2.5209999084472656e+02 3.1110000610351562e+02 -2.8200000762939453e+01 2.5044300842285156e+02 3.1110098266601562e+02 -3.8267398834228516e+01 1.4557699584960938e+02 2.5060498046875000e+02 -5.9969802856445312e+01 2.0645800781250000e+02 1.9859500122070312e+02 -5.9969802856445312e+01 2.9491900634765625e+02 2.0190599060058594e+02 1.0230000305175781e+02 3.1264599609375000e+02 1.9347000122070312e+02 1.0230000305175781e+02 2.9153399658203125e+02 1.9957501220703125e+02 1.0230000305175781e+02 1.5309399414062500e+02 2.8678799438476562e+02 1.0230000305175781e+02 1.7484899902343750e+02 2.8678799438476562e+02 1.0230000305175781e+02 2.9866799926757812e+02 2.1059399414062500e+02 -2.7142898559570312e+01 2.9864697265625000e+02 2.2240200805664062e+02 -1.8764699935913086e+01 2.9864697265625000e+02 2.1059500122070312e+02 4.0985599517822266e+01 2.9864697265625000e+02 2.3860499572753906e+02 8.0976800918579102e+00 2.9864697265625000e+02 2.3860499572753906e+02 -1.5550399780273438e+01 2.8689398193359375e+02 1.8344299316406250e+02 1.2900000000000000e+02 2.8834399414062500e+02 1.8549501037597656e+02 1.0526499938964844e+02 2.9076199340820312e+02 1.9002600097656250e+02 1.2900000000000000e+02 2.9051000976562500e+02 2.4999398803710938e+02 -3.7053100585937500e+01 2.9255102539062500e+02 2.4914300537109375e+02 -5.9970798492431641e+01 1.3385299682617188e+02 2.4104499816894531e+02 1.0230000305175781e+02 1.3357701110839844e+02 2.3860499572753906e+02 9.6058898925781250e+01 1.4085800170898438e+02 2.4970899963378906e+02 7.5261901855468750e+01 1.3889401245117188e+02 2.4860499572753906e+02 3.5743999481201172e+01 1.3716799926757812e+02 2.4725100708007812e+02 1.0056999969482422e+02 1.3708799743652344e+02 2.0211000061035156e+02 6.0708602905273438e+01 1.3826901245117188e+02 2.0107400512695312e+02 3.2135898590087891e+01 1.3826901245117188e+02 2.0107400512695312e+02 7.9724601745605469e+01 1.3706498718261719e+02 2.4705700683593750e+02 -5.9969802856445312e+01 1.3508500671386719e+02 2.4453500366210938e+02 -5.9969898223876953e+01 1.3605200195312500e+02 2.4590800476074219e+02 -2.9373600006103516e+01 1.3957600402832031e+02 2.0020100402832031e+02 5.0942001342773438e+01 1.4098399353027344e+02 1.9950700378417969e+02 7.8505599975585938e+01 1.3957800292968750e+02 2.0020199584960938e+02 1.0230000305175781e+02 1.3624400329589844e+02 2.4616700744628906e+02 5.2590198516845703e+01 2.9264199829101562e+02 2.4900199890136719e+02 -2.3319999694824219e+01 2.9123498535156250e+02 2.4969500732421875e+02 6.6349101066589355e+00 2.9264199829101562e+02 2.4900199890136719e+02 3.0526800155639648e+01 1.4401000976562500e+02 2.5050398254394531e+02 5.8514400482177734e+01 1.4247099304199219e+02 2.5019801330566406e+02 4.6641597747802734e+01 1.3939698791503906e+02 2.4897099304199219e+02 -5.9969802856445312e+01 1.3708799743652344e+02 2.4708999633789062e+02 -1.3356300354003906e+01 1.3895599365234375e+02 2.4864498901367188e+02 -1.2914799690246582e+01 1.4557699584960938e+02 2.5060498046875000e+02 7.6262695312500000e+01 2.9844201660156250e+02 2.4095300292968750e+02 4.4407596588134766e+00 2.9742300415039062e+02 2.4394500732421875e+02 1.1596100807189941e+01 2.9778701782226562e+02 2.4320800781250000e+02 6.4847000122070312e+01 1.3826901245117188e+02 2.0107400512695312e+02 -2.5375299453735352e+01 1.3957600402832031e+02 2.0020100402832031e+02 -5.3728698730468750e+01 1.3957600402832031e+02 2.0020100402832031e+02 2.4416298866271973e+00 2.9123498535156250e+02 2.4969500732421875e+02 4.8518898010253906e+01 2.9264199829101562e+02 2.4900199890136719e+02 7.6920997619628906e+01 2.9280001831054688e+02 2.0020599365234375e+02 9.9975700378417969e+01 2.8942901611328125e+02 1.9886300659179688e+02 4.1235500335693359e+01 2.9379598999023438e+02 2.0089801025390625e+02 3.2989101409912109e+01 2.8116799926757812e+02 1.7574598693847656e+02 1.0526599884033203e+02 2.9610601806640625e+02 1.6241200256347656e+02 1.0526599884033203e+02 1.9710000610351562e+02 3.1110000610351562e+02 7.0520500183105469e+01 2.5209999084472656e+02 3.1110000610351562e+02 4.0198602676391602e+00 1.9710000610351562e+02 3.1110000610351562e+02 -4.4480600357055664e+00 1.8028799438476562e+02 2.8678799438476562e+02 1.0526599884033203e+02 1.8028799438476562e+02 2.8678799438476562e+02 1.0230000305175781e+02 2.9537399291992188e+02 2.0234100341796875e+02 -5.9969699859619141e+01 2.9824502563476562e+02 2.0714401245117188e+02 -5.9969200134277344e+01 2.9711199951171875e+02 2.0460000610351562e+02 -5.9332698822021484e+01 2.8169799804687500e+02 2.7328802490234375e+02 1.3955000305175781e+02 2.7608499145507812e+02 2.7922698974609375e+02 1.3304998779296875e+02 2.7249099731445312e+02 2.8250198364257812e+02 1.3955000305175781e+02 2.6763900756835938e+02 2.8611001586914062e+02 1.3304998779296875e+02 2.3421099853515625e+02 2.7655700683593750e+02 1.3304998779296875e+02 2.9465298461914062e+02 2.5038099670410156e+02 1.0526599884033203e+02 2.9307199096679688e+02 2.5432299804687500e+02 1.2900000000000000e+02 2.9649002075195312e+02 2.4478900146484375e+02 1.2900000000000000e+02 3.0603997802734375e+02 2.7076599121093750e+02 1.0526499938964844e+02 2.9958599853515625e+02 2.8163000488281250e+02 1.0526599884033203e+02 2.9044100952148438e+02 2.7456997680664062e+02 1.0526599884033203e+02 2.3265499877929688e+02 1.4999699401855469e+02 1.3304998779296875e+02 2.4584298706054688e+02 1.5256999206542969e+02 1.3304998779296875e+02 3.0038198852539062e+02 2.8049099731445312e+02 1.0230000305175781e+02 2.9610601806640625e+02 2.8678799438476562e+02 1.0526599884033203e+02 2.6147799682617188e+02 2.8953799438476562e+02 1.0230000305175781e+02 2.8664700317382812e+02 2.5060498046875000e+02 1.0230000305175781e+02 2.5209999084472656e+02 2.9396298217773438e+02 1.0230000305175781e+02 1.4557699584960938e+02 1.9859500122070312e+02 -5.9969802856445312e+01 1.7570999145507812e+02 2.8152999877929688e+02 1.3955000305175781e+02 1.4987799072265625e+02 2.3220300292968750e+02 1.3955000305175781e+02 1.4608299255371094e+02 2.7608001708984375e+02 1.0526599884033203e+02 1.5309399414062500e+02 2.8678799438476562e+02 1.0526599884033203e+02 2.0329299926757812e+02 2.9656298828125000e+02 1.3955000305175781e+02 2.1438600158691406e+02 2.9899200439453125e+02 1.3955000305175781e+02 2.0333399963378906e+02 2.9662600708007812e+02 1.3304998779296875e+02 3.0329598999023438e+02 1.7332299804687500e+02 1.0230000305175781e+02 3.0589498901367188e+02 1.7801100158691406e+02 1.0526499938964844e+02 1.3395599365234375e+02 2.4181500244140625e+02 -5.7594200134277344e+01 1.3517999267578125e+02 2.4460099792480469e+02 -1.8744100570678711e+01 2.3902900695800781e+02 1.7368299865722656e+02 1.2900000000000000e+02 2.5209999084472656e+02 1.5523699951171875e+02 1.2900000000000000e+02 2.6639300537109375e+02 1.6262599182128906e+02 1.2900000000000000e+02 2.9268597412109375e+02 1.9405099487304688e+02 1.0615900421142578e+02 2.9504098510742188e+02 1.9980500793457031e+02 1.2900000000000000e+02 1.3500599670410156e+02 1.9842300415039062e+02 1.0526599884033203e+02 1.3477499389648438e+02 1.9939898681640625e+02 1.0230000305175781e+02 1.3919799804687500e+02 1.8684899902343750e+02 1.0230000305175781e+02 1.5853300476074219e+02 1.6241200256347656e+02 1.0230000305175781e+02 1.8028799438476562e+02 1.6241200256347656e+02 1.0230000305175781e+02 2.4075900268554688e+02 1.4110000610351562e+02 -5.0521602630615234e+01 2.5209999084472656e+02 1.4110000610351562e+02 -2.8200000762939453e+01 1.9024099731445312e+02 2.6466101074218750e+02 1.2900000000000000e+02 1.6681100463867188e+02 2.7733700561523438e+02 1.2900000000000000e+02 1.6750100708007812e+02 2.5034001159667969e+02 1.2900000000000000e+02 1.3976199340820312e+02 2.6357400512695312e+02 1.0526499938964844e+02 1.3922299194335938e+02 2.3882099914550781e+02 1.0526599884033203e+02 1.3915100097656250e+02 2.3853099060058594e+02 1.2900000000000000e+02 1.4256300354003906e+02 2.4716299438476562e+02 1.2900000000000000e+02 1.5309399414062500e+02 1.6241200256347656e+02 1.0230000305175781e+02 1.9846600341796875e+02 3.0809899902343750e+02 -3.7242900848388672e+01 2.5142500305175781e+02 3.0809997558593750e+02 -3.5301700592041016e+01 1.9710000610351562e+02 3.0809997558593750e+02 -2.8200000762939453e+01 1.3873300170898438e+02 2.1219700622558594e+02 1.2900000000000000e+02 1.3734400939941406e+02 2.1916400146484375e+02 1.2900000000000000e+02 1.3826699829101562e+02 2.1395500183105469e+02 1.0526599884033203e+02 3.1782400512695312e+02 2.1664599609375000e+02 1.0526599884033203e+02 2.9512100219726562e+02 2.0013299560546875e+02 1.0526499938964844e+02 3.1402700805664062e+02 1.9768400573730469e+02 1.0526599884033203e+02 2.8136700439453125e+02 1.7590299987792969e+02 1.2900000000000000e+02 2.7288601684570312e+02 1.6743800354003906e+02 1.0526599884033203e+02 2.0844100952148438e+02 1.3809999084472656e+02 -5.0521602630615234e+01 1.5099899291992188e+02 1.8836499023437500e+02 1.2900000000000000e+02 1.5566900634765625e+02 1.8274598693847656e+02 1.2900000000000000e+02 1.7562599182128906e+02 2.0497700500488281e+02 1.2900000000000000e+02 2.9703701782226562e+02 2.4473999023437500e+02 -5.6779602050781250e+01 2.9418298339843750e+02 2.4803399658203125e+02 -5.5256900787353516e+01 2.9490100097656250e+02 2.4738099670410156e+02 -5.0245699882507324e+00 1.3526399230957031e+02 2.5159400939941406e+02 1.0526599884033203e+02 1.3131399536132812e+02 2.3227598571777344e+02 1.0526499938964844e+02 3.1815100097656250e+02 2.2701499938964844e+02 1.0230000305175781e+02 3.1764001464843750e+02 2.3312098693847656e+02 1.0526499938964844e+02 2.2460000610351562e+02 1.4960000610351562e+02 1.3304998779296875e+02 2.2460000610351562e+02 1.4960000610351562e+02 1.3955000305175781e+02 1.5775000000000000e+02 1.9044999694824219e+02 1.3955000305175781e+02 1.5778799438476562e+02 1.9013500976562500e+02 1.3304998779296875e+02 1.3357701110839844e+02 2.3860499572753906e+02 3.6371799468994141e+01 1.3377999877929688e+02 2.4094900512695312e+02 6.8863502502441406e+01 1.3396400451660156e+02 2.4183300781250000e+02 2.6833299636840820e+01 2.4668400573730469e+02 3.0809997558593750e+02 -4.4711601257324219e+01 2.3904600524902344e+02 3.0809997558593750e+02 -5.1552700042724609e+01 1.8644200134277344e+02 1.5993499755859375e+02 1.3304998779296875e+02 1.4557699584960938e+02 2.5060498046875000e+02 3.4281200408935547e+01 2.9864697265625000e+02 2.1059500122070312e+02 7.4117301940917969e+01 2.9782199096679688e+02 2.0600399780273438e+02 3.4616500854492188e+01 2.8664700317382812e+02 2.5060498046875000e+02 4.6495399475097656e+01 2.8821200561523438e+02 2.5050398254394531e+02 7.6994102478027344e+01 2.8975000000000000e+02 2.5019898986816406e+02 7.7262298583984375e+01 1.3398300170898438e+02 2.0749099731445312e+02 1.0073999786376953e+02 1.3448699951171875e+02 2.0600601196289062e+02 7.5190002441406250e+01 2.8664700317382812e+02 2.5060498046875000e+02 -1.6379301071166992e+01 1.3357701110839844e+02 2.1059500122070312e+02 1.6008800506591797e+01 1.3357199096679688e+02 2.3860499572753906e+02 -1.9097600936889648e+01 1.9756900024414062e+02 1.7929100036621094e+02 1.2900000000000000e+02 1.9400100708007812e+02 1.8166000366210938e+02 1.3304998779296875e+02 1.8794900512695312e+02 1.8660299682617188e+02 1.2900000000000000e+02 2.1553898620605469e+02 1.5006900024414062e+02 1.3955000305175781e+02 1.9994099426269531e+02 3.1110000610351562e+02 -4.0683502197265625e+01 2.0565399169921875e+02 3.0809899902343750e+02 -4.8183097839355469e+01 1.3357701110839844e+02 2.3860499572753906e+02 -5.9969802856445312e+01 1.4923500061035156e+02 2.2387500000000000e+02 -5.9969802856445312e+01 1.4327398681640625e+02 2.4867599487304688e+02 1.0526499938964844e+02 1.8028799438476562e+02 1.6241200256347656e+02 1.0526599884033203e+02 1.3357701110839844e+02 2.1059500122070312e+02 -5.9969802856445312e+01 1.3440899658203125e+02 2.0587599182128906e+02 -5.9969997406005859e+01 1.3357701110839844e+02 2.1059500122070312e+02 -3.5175899505615234e+01 2.9744000244140625e+02 2.4128800964355469e+02 1.0526599884033203e+02 1.9710000610351562e+02 3.0809997558593750e+02 3.3263198852539062e+01 2.5209999084472656e+02 3.0809997558593750e+02 -2.8200000762939453e+01 1.4318899536132812e+02 1.9880700683593750e+02 1.0037599945068359e+02 1.4557699584960938e+02 1.9859500122070312e+02 1.0230000305175781e+02 1.4098899841308594e+02 1.9950898742675781e+02 1.0230000305175781e+02 1.8041000366210938e+02 2.5337400817871094e+02 1.2900000000000000e+02 1.7478799438476562e+02 2.4181500244140625e+02 1.2900000000000000e+02 2.2460000610351562e+02 2.9960000610351562e+02 1.3304998779296875e+02 2.3610099792480469e+02 2.9884100341796875e+02 1.3955000305175781e+02 2.3293499755859375e+02 2.9922198486328125e+02 1.3304998779296875e+02 2.9869699096679688e+02 2.1286801147460938e+02 1.3955000305175781e+02 2.9907598876953125e+02 2.3420899963378906e+02 1.3955000305175781e+02 3.1489700317382812e+02 2.4845098876953125e+02 1.0230000305175781e+02 1.7183099365234375e+02 2.2337100219726562e+02 1.3304998779296875e+02 1.7183200073242188e+02 2.2460000610351562e+02 1.2900000000000000e+02 1.7263999938964844e+02 2.1541699218750000e+02 1.2900000000000000e+02 2.6605001831054688e+02 2.5710601806640625e+02 1.2900000000000000e+02 2.9861300659179688e+02 2.3502198791503906e+02 1.2900000000000000e+02 2.5209999084472656e+02 1.3809999084472656e+02 1.2900000000000000e+02 2.5209999084472656e+02 1.5523699951171875e+02 1.0230000305175781e+02 2.7039999389648438e+02 1.6514199829101562e+02 1.3955000305175781e+02 2.5811099243164062e+02 1.5735900878906250e+02 1.3955000305175781e+02 2.6037298583984375e+02 1.5858300781250000e+02 1.3304998779296875e+02 1.9710000610351562e+02 3.1110000610351562e+02 -2.8200000762939453e+01 2.8664700317382812e+02 1.9859500122070312e+02 4.8323799133300781e+01 2.8664700317382812e+02 1.9859400939941406e+02 -1.1485099792480469e+01 1.8070599365234375e+02 1.9552099609375000e+02 1.2900000000000000e+02 1.7005999755859375e+02 1.6929598999023438e+02 1.2900000000000000e+02 2.3843600463867188e+02 2.7563800048828125e+02 1.2900000000000000e+02 2.2460000610351562e+02 2.7727999877929688e+02 1.2900000000000000e+02 2.7411599731445312e+02 2.8053298950195312e+02 1.2900000000000000e+02 2.6835098266601562e+02 2.8514599609375000e+02 1.2900000000000000e+02 2.5306901550292969e+02 2.7775897216796875e+02 1.2900000000000000e+02 1.7326599121093750e+02 2.1254899597167969e+02 1.3304998779296875e+02 1.5291200256347656e+02 2.0236199951171875e+02 1.3304998779296875e+02 2.5209999084472656e+02 3.1110000610351562e+02 4.8852600097656250e+01 2.1570800781250000e+02 1.5007199096679688e+02 1.3304998779296875e+02 2.0256500244140625e+02 1.5273599243164062e+02 1.3304998779296875e+02 2.1015399169921875e+02 3.1110000610351562e+02 -5.1552700042724609e+01 2.0447200012207031e+02 3.1110000610351562e+02 -4.6919902801513672e+01 1.5073699951171875e+02 2.1146899414062500e+02 1.3304998779296875e+02 2.9652899169921875e+02 2.4630400085449219e+02 1.3304998779296875e+02 2.7405300903320312e+02 2.4283799743652344e+02 1.3304998779296875e+02 2.6901800537109375e+02 2.5320300292968750e+02 1.3304998779296875e+02 2.3209600830078125e+02 1.4991600036621094e+02 1.3955000305175781e+02 2.6312301635742188e+02 1.6067098999023438e+02 1.0764700317382812e+02 2.5779101562500000e+02 1.5768699645996094e+02 1.0230000305175781e+02 2.6589901733398438e+02 1.6241200256347656e+02 1.0230000305175781e+02 2.2460000610351562e+02 2.9960000610351562e+02 1.3955000305175781e+02 1.4963099670410156e+02 2.2112500000000000e+02 1.3304998779296875e+02 1.4979701232910156e+02 2.1820100402832031e+02 1.3955000305175781e+02 2.5209999084472656e+02 1.4110000610351562e+02 1.0230000305175781e+02 2.5209999084472656e+02 1.3809999084472656e+02 6.0071498870849609e+01 1.5450799560546875e+02 1.8389299011230469e+02 1.0526599884033203e+02 1.4160198974609375e+02 1.8145700073242188e+02 1.0526599884033203e+02 2.1649000549316406e+02 3.0809997558593750e+02 -5.4577102661132812e+01 3.1553302001953125e+02 2.4586399841308594e+02 1.0526499938964844e+02 1.8995300292968750e+02 1.5738800048828125e+02 1.2900000000000000e+02 3.0832897949218750e+02 2.6610800170898438e+02 1.0230000305175781e+02 2.6589901733398438e+02 1.6241200256347656e+02 1.0526599884033203e+02 3.1113601684570312e+02 2.5943600463867188e+02 1.0526599884033203e+02 1.6152200317382812e+02 2.6523199462890625e+02 1.3955000305175781e+02 1.5676400756835938e+02 2.5667797851562500e+02 1.3955000305175781e+02 1.7967599487304688e+02 1.6272300720214844e+02 1.2900000000000000e+02 1.7568099975585938e+02 1.6526899719238281e+02 1.0526499938964844e+02 1.6472099304199219e+02 1.7366999816894531e+02 1.0526599884033203e+02 1.4557699584960938e+02 1.9859500122070312e+02 5.6637203216552734e+01 2.2284899902343750e+02 2.5060498046875000e+02 1.0230000305175781e+02 1.4279800415039062e+02 2.0137800598144531e+02 1.2900000000000000e+02 1.4629598999023438e+02 1.9522399902343750e+02 1.0526499938964844e+02 2.5209999084472656e+02 1.3809999084472656e+02 -2.8200000762939453e+01 2.5209999084472656e+02 1.3809999084472656e+02 6.6848897933959961e+00 1.5219700622558594e+02 2.0452700805664062e+02 1.3955000305175781e+02 2.4951100158691406e+02 1.3809999084472656e+02 -4.0130100250244141e+01 2.3811499023437500e+02 1.3809999084472656e+02 -5.2161602020263672e+01 2.7734597778320312e+02 2.2069898986816406e+02 1.3304998779296875e+02 2.9570599365234375e+02 2.0050900268554688e+02 1.3304998779296875e+02 2.7431698608398438e+02 2.0686399841308594e+02 1.3304998779296875e+02 2.9855200195312500e+02 2.0905099487304688e+02 9.8952499389648438e+01 1.4419700622558594e+02 1.7660998535156250e+02 1.0230000305175781e+02 2.9960998535156250e+02 2.2176300048828125e+02 1.3955000305175781e+02 2.9927798461914062e+02 2.3243499755859375e+02 1.3304998779296875e+02 1.6753900146484375e+02 2.7333898925781250e+02 1.3955000305175781e+02 1.6169898986816406e+02 2.6566500854492188e+02 1.3304998779296875e+02 2.9578598022460938e+02 2.0278100585937500e+02 9.9576896667480469e+01 1.6680000305175781e+02 2.8678799438476562e+02 1.0526599884033203e+02 1.7321200561523438e+02 2.3662699890136719e+02 1.3304998779296875e+02 2.5579801940917969e+02 2.9240200805664062e+02 1.2900000000000000e+02 2.5209999084472656e+02 2.9396298217773438e+02 1.2900000000000000e+02 2.7987399291992188e+02 2.7495001220703125e+02 1.0526599884033203e+02 2.8616601562500000e+02 2.6683898925781250e+02 1.0526599884033203e+02 1.3711399841308594e+02 2.2145100402832031e+02 1.0526599884033203e+02 2.4758100891113281e+02 2.9605401611328125e+02 1.3955000305175781e+02 2.9628100585937500e+02 2.4583999633789062e+02 4.9794101715087891e+01 2.8899197387695312e+02 1.9879800415039062e+02 -4.6152801513671875e+01 2.9864697265625000e+02 2.1059500122070312e+02 -5.9969802856445312e+01 2.9864697265625000e+02 2.3860499572753906e+02 1.0230000305175781e+02 2.9864697265625000e+02 2.3860499572753906e+02 7.5970199584960938e+01 1.4557699584960938e+02 2.5060498046875000e+02 -1.6964399337768555e+01 1.4247099304199219e+02 2.5019801330566406e+02 -5.8409500122070312e+01 1.3827900695800781e+02 2.0106199645996094e+02 -5.6251296997070312e+01 1.3875498962402344e+02 2.0066999816894531e+02 -5.9969802856445312e+01 2.9710198974609375e+02 2.0459500122070312e+02 6.6583404541015625e+01 2.9823898315429688e+02 2.0748800659179688e+02 7.0289703369140625e+01 1.3495799255371094e+02 2.0496299743652344e+02 1.0230100250244141e+02 1.3517999267578125e+02 2.0459899902343750e+02 4.8860198974609375e+01 1.4252699279785156e+02 1.9893299865722656e+02 9.7371997833251953e+00 1.3398300170898438e+02 2.0749099731445312e+02 -2.7545099258422852e+01 1.3388600158691406e+02 2.4160798645019531e+02 -1.4892200469970703e+01 1.3556799316406250e+02 2.4527400207519531e+02 2.2798498153686523e+01 1.3479800415039062e+02 2.0525900268554688e+02 1.4838599205017090e+01 1.4098399353027344e+02 2.4969300842285156e+02 2.7942600250244141e+01 2.9823898315429688e+02 2.0748800659179688e+02 -3.9637302398681641e+01 1.3732600402832031e+02 2.0186500549316406e+02 1.0230000305175781e+02 1.9710000610351562e+02 1.3809999084472656e+02 6.7655197143554688e+01 1.9710000610351562e+02 1.4110000610351562e+02 3.0641500473022461e+01 1.9710000610351562e+02 1.3809999084472656e+02 -2.8200000762939453e+01 2.6589901733398438e+02 2.8678799438476562e+02 1.0526599884033203e+02 1.9710000610351562e+02 1.4110000610351562e+02 -2.8200000762939453e+01 1.3625300598144531e+02 2.5462200927734375e+02 1.0230000305175781e+02 1.3335501098632812e+02 2.0518699645996094e+02 1.0230000305175781e+02 1.3172599792480469e+02 2.1399299621582031e+02 1.0230000305175781e+02 2.9474600219726562e+02 2.4756300354003906e+02 1.0230000305175781e+02 2.9122998046875000e+02 2.4969300842285156e+02 1.0230000305175781e+02 1.3503999328613281e+02 2.0472599792480469e+02 -2.9775800704956055e+01 1.3569299316406250e+02 2.0373300170898438e+02 -5.6444297790527344e+01 1.7152301025390625e+02 2.8103799438476562e+02 1.0526599884033203e+02 1.4907400512695312e+02 2.5818399047851562e+02 1.0526499938964844e+02 2.9864697265625000e+02 2.1059500122070312e+02 9.6058898925781250e+01 1.9710000610351562e+02 2.9460998535156250e+02 1.2900000000000000e+02 1.9710000610351562e+02 1.4110000610351562e+02 1.0230000305175781e+02 1.4120599365234375e+02 2.0489199829101562e+02 1.0526599884033203e+02 2.9019900512695312e+02 2.6027700805664062e+02 1.0526599884033203e+02 2.8852001953125000e+02 2.6333099365234375e+02 1.2900000000000000e+02 2.5209999084472656e+02 3.0809997558593750e+02 3.3724399566650391e+01 2.5209999084472656e+02 3.0809997558593750e+02 1.0230000305175781e+02 2.7383200073242188e+02 2.0561599731445312e+02 1.2900000000000000e+02 2.7957598876953125e+02 1.8719599914550781e+02 1.2900000000000000e+02 1.9710000610351562e+02 1.3809999084472656e+02 1.2900000000000000e+02 2.9720700073242188e+02 2.0718099975585938e+02 1.0526599884033203e+02 1.9979000854492188e+02 1.4110000610351562e+02 -4.0305999755859375e+01 1.9807000732421875e+02 1.3809999084472656e+02 -3.5835197448730469e+01 1.9743099975585938e+02 1.4110000610351562e+02 -3.2848102569580078e+01 2.3736700439453125e+02 3.1110000610351562e+02 -5.2639400482177734e+01 2.9864697265625000e+02 2.3860499572753906e+02 -5.9969802856445312e+01 1.3168099975585938e+02 2.1450500488281250e+02 1.0526499938964844e+02 2.7409399414062500e+02 1.6864700317382812e+02 1.2900000000000000e+02 2.5115200805664062e+02 1.7894999694824219e+02 1.2900000000000000e+02 1.8046000671386719e+02 2.7767898559570312e+02 1.0230000305175781e+02 2.9610601806640625e+02 1.6241200256347656e+02 1.0230000305175781e+02 2.8583300781250000e+02 2.6815097045898438e+02 1.3304998779296875e+02 2.7653698730468750e+02 2.1527500915527344e+02 1.2900000000000000e+02 2.7736801147460938e+02 2.2460000610351562e+02 1.2900000000000000e+02 2.9672198486328125e+02 2.0361000061035156e+02 1.3955000305175781e+02 1.5493998718261719e+02 2.6562399291992188e+02 1.0526499938964844e+02 2.8664700317382812e+02 2.5060498046875000e+02 1.8190799713134766e+01 2.7342401123046875e+02 2.8117001342773438e+02 1.0526599884033203e+02 1.6157099914550781e+02 2.7258801269531250e+02 1.0526599884033203e+02 1.5872200012207031e+02 2.6973699951171875e+02 1.2900000000000000e+02 1.8820098876953125e+02 1.5814700317382812e+02 1.0230000305175781e+02 1.7218800354003906e+02 2.3110299682617188e+02 1.2900000000000000e+02 2.7005197143554688e+02 1.9782400512695312e+02 1.3304998779296875e+02 2.6845498657226562e+02 1.9544699096679688e+02 1.2900000000000000e+02 2.9926998901367188e+02 2.2841600036621094e+02 1.0526599884033203e+02 2.9904898071289062e+02 2.1797200012207031e+02 1.0526599884033203e+02 2.4791600036621094e+02 1.4110000610351562e+02 -4.2833202362060547e+01 2.5867501831054688e+02 2.6489599609375000e+02 1.2900000000000000e+02 2.8079598999023438e+02 2.7390301513671875e+02 1.2900000000000000e+02 1.9052700805664062e+02 2.6484500122070312e+02 1.3304998779296875e+02 2.1260699462890625e+02 2.7596899414062500e+02 1.3304998779296875e+02 2.1548100280761719e+02 2.9913198852539062e+02 1.3304998779296875e+02 1.7942399597167969e+02 2.8632598876953125e+02 1.2900000000000000e+02 1.8971000671386719e+02 2.9172097778320312e+02 1.2900000000000000e+02 1.5330999755859375e+02 2.6371301269531250e+02 1.2900000000000000e+02 1.9372000122070312e+02 2.9297198486328125e+02 1.3304998779296875e+02 2.2460000610351562e+02 1.7191999816894531e+02 1.2900000000000000e+02 2.1852900695800781e+02 1.7220599365234375e+02 1.2900000000000000e+02 2.7646899414062500e+02 2.3429701232910156e+02 1.3304998779296875e+02 1.7781401062011719e+02 1.9997698974609375e+02 1.3304998779296875e+02 1.8584300231933594e+02 1.8878099060058594e+02 1.3304998779296875e+02 2.2460000610351562e+02 2.7727999877929688e+02 1.3304998779296875e+02 2.9613598632812500e+02 2.0315499877929688e+02 -2.8803701400756836e+01 2.9336801147460938e+02 2.0062098693847656e+02 -2.5463699340820312e+01 2.5990301513671875e+02 2.6385800170898438e+02 1.3304998779296875e+02 2.4913699340820312e+02 2.7139498901367188e+02 1.3304998779296875e+02 2.9085000610351562e+02 1.9931599426269531e+02 -1.0737000465393066e+01 2.5209999084472656e+02 1.4110000610351562e+02 5.9928802490234375e+01 2.7216799926757812e+02 2.4728700256347656e+02 1.2900000000000000e+02 2.9787200927734375e+02 2.4298199462890625e+02 1.0230200195312500e+02 2.9310797119140625e+02 2.0045599365234375e+02 -5.2422698974609375e+01 2.9394900512695312e+02 2.4812998962402344e+02 5.2651199340820312e+01 2.9772799682617188e+02 2.4347200012207031e+02 -5.9969898223876953e+01 1.3708799743652344e+02 2.4708999633789062e+02 3.2074897766113281e+01 1.3605200195312500e+02 2.4590800476074219e+02 3.9531700611114502e+00 1.3481800842285156e+02 2.4398001098632812e+02 5.3571498870849609e+01 1.3708799743652344e+02 2.0211000061035156e+02 -1.9134199142456055e+01 1.3605200195312500e+02 2.0329199218750000e+02 -1.5331000328063965e+01 1.4098399353027344e+02 2.4969300842285156e+02 -3.0812000274658203e+01 1.4247099304199219e+02 2.5019801330566406e+02 -6.3017100095748901e-01 2.8975000000000000e+02 2.5019898986816406e+02 5.3029102325439453e+01 1.3661601257324219e+02 2.0257499694824219e+02 1.3570899963378906e+01 2.9854598999023438e+02 2.4017199707031250e+02 5.6193798065185547e+01 2.9823898315429688e+02 2.4171200561523438e+02 7.7798599243164062e+01 1.3712200927734375e+02 2.0207199096679688e+02 -5.5226299285888672e+01 2.8899099731445312e+02 1.9879800415039062e+02 7.4531799316406250e+01 2.8664700317382812e+02 1.9859500122070312e+02 1.0230000305175781e+02 1.4098399353027344e+02 2.4969300842285156e+02 2.2100400924682617e+00 1.3469099426269531e+02 2.4372700500488281e+02 9.9347999572753906e+01 1.4098399353027344e+02 1.9950700378417969e+02 3.1258199691772461e+01 1.4323001098632812e+02 1.9879899597167969e+02 5.7319896697998047e+01 2.8975000000000000e+02 2.5019898986816406e+02 -1.2929599761962891e+01 2.8975000000000000e+02 2.5019898986816406e+02 2.4188098907470703e+01 2.9123498535156250e+02 2.4969500732421875e+02 3.9644699096679688e+01 1.5102099609375000e+02 2.3938999938964844e+02 1.3304998779296875e+02 1.5259001159667969e+02 2.4588101196289062e+02 1.3955000305175781e+02 1.5463400268554688e+02 2.5200302124023438e+02 1.3304998779296875e+02 1.7339498901367188e+02 1.6960800170898438e+02 1.3304998779296875e+02 2.1661199951171875e+02 3.1110000610351562e+02 -5.4595897674560547e+01 2.2325199890136719e+02 3.0810101318359375e+02 -5.5724899291992188e+01 1.6186199951171875e+02 1.7632701110839844e+02 1.2900000000000000e+02 1.4721499633789062e+02 2.5544500732421875e+02 1.2900000000000000e+02 2.9952899169921875e+02 2.2040100097656250e+02 1.3304998779296875e+02 2.9821597290039062e+02 2.0992199707031250e+02 1.3304998779296875e+02 2.2460000610351562e+02 1.7191999816894531e+02 1.3304998779296875e+02 2.2794699096679688e+02 3.1110000610351562e+02 -5.5608501434326172e+01 2.3258799743652344e+02 3.0809997558593750e+02 -5.4595897674560547e+01 2.8195397949218750e+02 1.7620899963378906e+02 1.3304998779296875e+02 2.7096301269531250e+02 1.6545899963378906e+02 1.3304998779296875e+02 2.5526600646972656e+02 1.8166999816894531e+02 1.3304998779296875e+02 2.4900401306152344e+02 2.7142398071289062e+02 1.2900000000000000e+02 1.9710000610351562e+02 1.5458999633789062e+02 1.2900000000000000e+02 1.3756098937988281e+02 2.3153799438476562e+02 1.2899899291992188e+02 1.3357701110839844e+02 2.1059500122070312e+02 1.0230000305175781e+02 1.3734201049804688e+02 2.2996699523925781e+02 1.0526599884033203e+02 1.3703900146484375e+02 2.2477799987792969e+02 1.2900000000000000e+02 2.9777301025390625e+02 2.0969499206542969e+02 1.2900000000000000e+02 2.9842697143554688e+02 2.1327101135253906e+02 1.2113300323486328e+02 2.9930300903320312e+02 2.2133200073242188e+02 1.2900000000000000e+02 1.9333299255371094e+02 1.6258500671386719e+02 1.0230000305175781e+02 1.9710000610351562e+02 3.1110000610351562e+02 1.2900000000000000e+02 2.8951901245117188e+02 1.8680400085449219e+02 1.3304998779296875e+02 2.5841400146484375e+02 1.6510499572753906e+02 1.0230000305175781e+02 2.9802200317382812e+02 2.0668899536132812e+02 3.0843800306320190e-01 2.0461300659179688e+02 1.4110000610351562e+02 -4.7107498168945312e+01 1.9941400146484375e+02 2.7104397583007812e+02 1.3304998779296875e+02 1.9710000610351562e+02 3.0809997558593750e+02 1.0230000305175781e+02 2.7598101806640625e+02 2.3656100463867188e+02 1.2900000000000000e+02 2.9610601806640625e+02 2.8678799438476562e+02 1.0230000305175781e+02 2.9006500244140625e+02 2.8678799438476562e+02 1.0230000305175781e+02 2.9501000976562500e+02 2.5097599792480469e+02 1.3955000305175781e+02 2.9176800537109375e+02 2.5805300903320312e+02 1.3304998779296875e+02 2.6477301025390625e+02 1.9037699890136719e+02 1.3304998779296875e+02 1.6498799133300781e+02 1.7896400451660156e+02 1.3304998779296875e+02 2.5113400268554688e+02 1.4110000610351562e+02 -3.5868499755859375e+01 2.5209999084472656e+02 3.1110000610351562e+02 1.2900000000000000e+02 2.6063299560546875e+02 1.8605999755859375e+02 1.2900000000000000e+02 1.3556100463867188e+02 2.4560398864746094e+02 1.0230000305175781e+02 2.9864697265625000e+02 2.3860499572753906e+02 3.7548099517822266e+01 2.1934500122070312e+02 2.7706399536132812e+02 1.2900000000000000e+02 2.6589901733398438e+02 2.8678799438476562e+02 1.0230000305175781e+02 2.0792900085449219e+02 1.7429800415039062e+02 1.2900000000000000e+02 2.0652200317382812e+02 1.7492500305175781e+02 1.3304998779296875e+02 2.3538699340820312e+02 1.7285400390625000e+02 1.3304998779296875e+02 2.4668000793457031e+02 1.7673901367187500e+02 1.3304998779296875e+02 2.0340100097656250e+02 1.5258399963378906e+02 1.3955000305175781e+02 1.9710000610351562e+02 1.5458999633789062e+02 1.0230000305175781e+02 2.1063000488281250e+02 1.4110000610351562e+02 -5.1869602203369141e+01 2.0934899902343750e+02 2.7518902587890625e+02 1.2900000000000000e+02 1.9981799316406250e+02 2.7125299072265625e+02 1.2900000000000000e+02 1.9738101196289062e+02 3.1110000610351562e+02 -3.2403598785400391e+01 2.6235800170898438e+02 2.8899401855468750e+02 1.2900000000000000e+02 1.4971099853515625e+02 2.2930300903320312e+02 1.3304998779296875e+02 2.4458700561523438e+02 1.3809999084472656e+02 -4.7107498168945312e+01 2.9598001098632812e+02 2.0296299743652344e+02 1.8911499023437500e+01 1.3605200195312500e+02 2.0329199218750000e+02 3.8815799713134766e+01 1.3605200195312500e+02 2.0329199218750000e+02 7.5726394653320312e+01 1.3826901245117188e+02 2.0107400512695312e+02 -2.7268099784851074e+00 1.4401000976562500e+02 2.5050398254394531e+02 6.1473302841186523e+00 1.4401000976562500e+02 2.5050398254394531e+02 2.9441900253295898e+01 1.3357701110839844e+02 2.1059500122070312e+02 4.6775699615478516e+01 2.0128401184082031e+02 1.3809999084472656e+02 -4.2833202362060547e+01 2.5176901245117188e+02 1.3809999084472656e+02 -3.2848102569580078e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 55 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1113600730895996e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector 2.9864698648452759e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector 3.1815099716186523e+02 2.2701500356197357e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1113600730895996e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector 2.9610601067543030e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector 2.9255101084709167e+02 2.4914300441741943e+02 -5.9970799833536148e+01) (float-vector 2.9864698648452759e+02 2.3860499262809753e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector 1.3976199924945831e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5309399366378784e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector 1.3976199924945831e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500599563121796e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 1.3500599563121796e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9610601067543030e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector 2.5044301152229309e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector 2.9255101084709167e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5044301152229309e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector 2.3736700415611267e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector 2.9255101084709167e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9738100469112396e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector 1.5309399366378784e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 2.0128400623798370e+02 1.3809999823570251e+02 -4.2833201587200165e+01) (float-vector 2.0844100415706635e+02 1.3809999823570251e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector 2.0128400623798370e+02 1.3809999823570251e+02 -4.2833201587200165e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0340099930763245e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector 2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector 2.9864698648452759e+02 2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector 2.9864698648452759e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector 2.9255101084709167e+02 2.4914300441741943e+02 -5.9970799833536148e+01) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9864698648452759e+02 2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector 3.0589500069618225e+02 1.7801100015640259e+02 1.0526499897241592e+02) (float-vector 3.1669801473617554e+02 2.0908200740814209e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1669801473617554e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector 3.1815099716186523e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector 2.9864698648452759e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector 2.9864698648452759e+02 2.1059499680995941e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector 2.5811100006103516e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1815099716186523e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector 3.1669801473617554e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector 2.9672199487686157e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector 2.9960998892784119e+02 2.2176299989223480e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8716799616813660e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector 2.9672199487686157e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector 3.1669801473617554e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector 3.0589500069618225e+02 1.7801100015640259e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9610601067543030e+02 1.6241200268268585e+02 1.0230000317096710e+02) (float-vector 2.5176900625228882e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector 2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector 2.5176900625228882e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector 2.9610601067543030e+02 1.6241200268268585e+02 1.0230000317096710e+02) (float-vector 3.0589500069618225e+02 1.7801100015640259e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.5811100006103516e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector 2.8716799616813660e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector 3.0589500069618225e+02 1.7801100015640259e+02 1.0526499897241592e+02) (float-vector 2.9610601067543030e+02 1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3811499774456024e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector 2.5176900625228882e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.5044301152229309e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector 2.9610601067543030e+02 2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8169798851013184e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.9610601067543030e+02 2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1015399694442749e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector 1.9738100469112396e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9501000046730042e+02 2.5097599625587463e+02 1.3955000042915344e+02) (float-vector 3.1113600730895996e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector 3.1815099716186523e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector 2.9960998892784119e+02 2.2176299989223480e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9501000046730042e+02 2.5097599625587463e+02 1.3955000042915344e+02) (float-vector 2.8169798851013184e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector 2.9610601067543030e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector 3.1113600730895996e+02 2.5943601131439209e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 2.2893799841403961e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2893799841403961e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector 1.3440899550914764e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector 2.0844100415706635e+02 1.3809999823570251e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2893799841403961e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector 2.3811499774456024e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector 2.9537400603294373e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 2.5176900625228882e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector 2.3811499774456024e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector 2.2893799841403961e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector 2.0844100415706635e+02 1.3809999823570251e+02 -5.0521600991487503e+01) (float-vector 2.0128400623798370e+02 1.3809999823570251e+02 -4.2833201587200165e+01) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.5889199972152710e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector 2.3610100150108337e+02 2.9884099960327148e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5889199972152710e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.8169798851013184e+02 2.7328801155090332e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2794699668884277e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector 2.1015399694442749e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3736700415611267e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector 2.2794699668884277e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector 1.3508500158786774e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector 2.9255101084709167e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7696300148963928e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector 2.0340099930763245e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7696300148963928e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3734400272369385e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector 1.3500599563121796e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9738100469112396e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.1438600122928619e+02 2.9899200797080994e+02 1.3955000042915344e+02) (float-vector 1.9309400022029877e+02 2.9278600215911865e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.9738100469112396e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector 2.1015399694442749e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector 2.2794699668884277e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector 2.3736700415611267e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector 2.5044301152229309e+02 3.1110098958015442e+02 -3.8267400115728378e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 2.3610100150108337e+02 2.9884099960327148e+02 1.3955000042915344e+02) (float-vector 2.1438600122928619e+02 2.9899200797080994e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02) (float-vector 1.4279800653457642e+02 2.0137800276279449e+02 1.2899999320507050e+02) (float-vector 1.5774999558925629e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector 1.7696300148963928e+02 1.6646899282932281e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500599563121796e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector 1.3734400272369385e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector 1.4279800653457642e+02 2.0137800276279449e+02 1.2899999320507050e+02) (float-vector 1.5309399366378784e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.6753900051116943e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector 1.5309399366378784e+02 2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6753900051116943e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector 1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector 1.9309400022029877e+02 2.9278600215911865e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3976199924945831e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector 1.3915100693702698e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3915100693702698e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector 1.3734400272369385e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector 1.3131399452686310e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3976199924945831e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector 1.5309399366378784e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector 1.6753900051116943e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector 1.3915100693702698e+02 2.3853099346160889e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5259000658988953e+02 2.4588100612163544e+02 1.3955000042915344e+02) (float-vector 1.3915100693702698e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector 1.6753900051116943e+02 2.7333900332450867e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9960998892784119e+02 2.2176299989223480e+02 1.3955000042915344e+02) (float-vector 2.9672199487686157e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector 2.8716799616813660e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector 2.5811100006103516e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector 2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector 2.0340099930763245e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector 1.7696300148963928e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector 1.5774999558925629e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector 1.4979700744152069e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector 1.5259000658988953e+02 2.4588100612163544e+02 1.3955000042915344e+02) (float-vector 1.6753900051116943e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector 1.9309400022029877e+02 2.9278600215911865e+02 1.3955000042915344e+02) (float-vector 2.1438600122928619e+02 2.9899200797080994e+02 1.3955000042915344e+02) (float-vector 2.3610100150108337e+02 2.9884099960327148e+02 1.3955000042915344e+02) (float-vector 2.5889199972152710e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector 2.8169798851013184e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector 2.9501000046730042e+02 2.5097599625587463e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4979700744152069e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector 1.3734400272369385e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector 1.3915100693702698e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector 1.5259000658988953e+02 2.4588100612163544e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3734400272369385e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector 1.4979700744152069e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector 1.5774999558925629e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector 1.4279800653457642e+02 2.0137800276279449e+02 1.2899999320507050e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "br_caster_rotation_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_double_stereo_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-2.0000000000000000e+01 -6.0000000000000000e+01 -3.7252900142448198e-07 -2.2351699158207339e-07 -6.0000000000000000e+01 -3.7252900142448198e-07 -2.2351699158207339e-07 -6.0000000000000000e+01 5.0000000000000000e+01 -2.0000000000000000e+01 -6.0000000000000000e+01 5.0000000000000000e+01 -2.0000000000000000e+01 6.0000000000000000e+01 5.0000000000000000e+01 -2.2351699158207339e-07 6.0000000000000000e+01 5.0000000000000000e+01 -2.2351699158207339e-07 6.0000000000000000e+01 -3.7252900142448198e-07 -2.0000000000000000e+01 6.0000000000000000e+01 -3.7252900142448198e-07 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 -3.7252900764173091e-07)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 -3.7252900764173091e-07)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 -3.7252900764173091e-07)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -1.9999999552965164e+01 -5.9999998658895493e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -1.9999999552965164e+01 5.9999998658895493e+01 -3.7252900764173091e-07)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 5.0000000745058060e+01) (float-vector -2.2351699657807700e-07 5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 -3.7252900764173091e-07) (float-vector -2.2351699657807700e-07 -5.9999998658895493e+01 5.0000000745058060e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "double_stereo_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fl_caster_l_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 -2.9734701156616211e+01 -9.3289899826049805e+00 2.7445201873779297e+00 -2.9418100357055664e+01 -1.2800700187683105e+01 1.0573199987411499e+00 -2.9640798568725586e+01 -1.0600199699401855e+01 1.0544799804687500e+01 -2.9430900573730469e+01 -8.4442996978759766e+00 8.2298793792724609e+00 -2.9580398559570312e+01 -6.8257398605346680e+00 1.0452800750732422e+01 -2.9676599502563477e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 -2.9607198715209961e+01 8.3633699417114258e+00 -1.0304100036621094e+01 -8.0464500427246094e+01 4.2757096290588379e+00 -9.9000797271728516e+00 -2.9565000534057617e+01 4.3990101814270020e+00 -3.0437600612640381e+00 -2.9632600784301758e+01 1.0238399505615234e+01 -3.0640001296997070e+00 -8.0891304016113281e+01 1.0639900207519531e+01 -1.0523200035095215e+01 -2.9807800292968750e+01 2.0460700988769531e+00 -1.0421499252319336e+01 -2.9872400283813477e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 -2.9559000015258789e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 -8.0892097473144531e+01 8.4554700851440430e+00 -1.0192299842834473e+01 -8.0942695617675781e+01 5.5663700103759766e+00 -1.0925999641418457e+01 -8.0888397216796875e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 -8.0911102294921875e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 -2.9603599548339844e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 -2.9594200134277344e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 -8.0856101989746094e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 -2.9677499771118164e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 -8.0903297424316406e+01 -1.1044600486755371e+01 1.0178999900817871e+00 -2.9632200241088867e+01 1.0607999801635742e+01 1.0090099573135376e+00 -8.0902297973632812e+01 1.1044500350952148e+01 7.1427397727966309e+00 -8.0804000854492188e+01 8.4595899581909180e+00 9.8030099868774414e+00 -8.0907203674316406e+01 5.1623497009277344e+00 7.4257197380065918e+00 -8.1105201721191406e+01 1.1212299346923828e+01 3.3442101478576660e+00 -8.0903900146484375e+01 -1.0557999610900879e+01 6.1998200416564941e+00 -8.1096000671386719e+01 -1.1747900009155273e+01 7.2372202873229980e+00 -8.0794494628906250e+01 -8.3683700561523438e+00 9.8025293350219727e+00 -8.0921005249023438e+01 -5.1738500595092773e+00 4.0853300094604492e+00 -8.0921997070312500e+01 1.0249599456787109e+01 1.0831099510192871e+01 -8.0742095947265625e+01 -2.0039701461791992e+00 1.2268199920654297e+01 -8.1127998352050781e+01 3.9475402832031250e+00 1.1011500358581543e+01 -8.0664100646972656e+01 0.0000000000000000e+00 1.0836700439453125e+01 -8.0821899414062500e+01 2.0019199848175049e+00 -1.1417300224304199e+01 -3.1931400299072266e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 -3.1901300430297852e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 -3.3114299774169922e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 -3.3060798645019531e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 -3.3005496978759766e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 -3.2922698974609375e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 -3.1965400695800781e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 -3.2961498260498047e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 -3.3005199432373047e+01 2.3467597961425781e+00 -4.8763401031494141e+01 -3.2972099304199219e+01 1.6582399368286133e+01 -6.1740497589111328e+01 -3.1979299545288086e+01 1.0151400566101074e+01 -4.5477100372314453e+01 -3.3045398712158203e+01 2.1893899917602539e+01 1.6372301101684570e+01 -3.1941600799560547e+01 5.8962200164794922e+01 2.3468399047851562e+00 -3.3007396697998047e+01 5.1267200469970703e+01 -9.9129495620727539e+00 -3.3083801269531250e+01 4.9431499481201172e+01 -3.6015296936035156e+01 -3.3108100891113281e+01 3.4995300292968750e+01 -4.8726200103759766e+01 -3.1919502258300781e+01 3.8182498931884766e+01 -2.5745399475097656e+01 -3.3058502197265625e+01 4.3290298461914062e+01 -6.4798698425292969e+00 -3.1922300338745117e+01 6.1833000183105469e+01 -3.9104801177978516e+01 -3.3105998992919922e+01 -3.1760398864746094e+01 3.8039699554443359e+01 -3.1931098937988281e+01 4.8811397552490234e+01 2.0110498428344727e+01 -3.2998302459716797e+01 6.3504100799560547e+01 4.7388999938964844e+01 -3.3059799194335938e+01 4.7388999938964844e+01 5.0501701354980469e+01 -3.2199699401855469e+01 3.8274200439453125e+01 6.3447898864746094e+01 -3.3059898376464844e+01 2.0092599868774414e+01 6.0778099060058594e+01 -3.2144401550292969e+01 1.7475801467895508e+01 6.0313198089599609e+01 -3.1965400695800781e+01 7.4321599006652832e+00 6.3284599304199219e+01 -3.2191196441650391e+01 -4.4547400474548340e+00 5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 5.5512199401855469e+01 -3.1871200561523438e+01 -2.7132499694824219e+01 2.8417900085449219e+01 -3.3024398803710938e+01 -6.0260898590087891e+01 4.4547300338745117e+00 -3.2191101074218750e+01 -6.3284301757812500e+01 3.3109401702880859e+01 -3.1901699066162109e+01 -5.2159999847412109e+01 4.6935901641845703e+01 -3.2998600006103516e+01 -4.6935901641845703e+01 4.6696701049804688e+00 -3.3059997558593750e+01 -6.6339698791503906e+01 6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 -3.3019302368164062e+01 6.5981704711914062e+01 -4.4070800781250000e+01 -3.3025100708007812e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 -3.2243999481201172e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 -3.2244602203369141e+01 -3.8144996643066406e+01 1.5174099922180176e+01 -3.2350498199462891e+01 -6.8473693847656250e+01 4.8838300704956055e+00 -3.2246299743652344e+01 -6.9384094238281250e+01 4.1918899536132812e+01 -3.2255702972412109e+01 -5.5662799835205078e+01 5.6185497283935547e+01 -3.2231498718261719e+01 -4.1026100158691406e+01 6.9456398010253906e+01 -3.2233699798583984e+01 -1.5821299552917480e+00 6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 -3.2246299743652344e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 -3.2998302459716797e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 -3.2240303039550781e+01 1.4109100103378296e+00 -6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 -3.8389400482177734e+01 7.4474800109863281e+01 -1.7341400384902954e+00 -3.8391998291015625e+01 7.6071098327636719e+01 5.1130599975585938e+00 -3.4403301239013672e+01 7.2644706726074219e+01 7.1366401672363281e+01 -3.4439002990722656e+01 1.3268600463867188e+01 6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 6.7477394104003906e+01 -3.4428897857666016e+01 2.6760299682617188e+01 7.5355300903320312e+01 -3.7268402099609375e+01 1.7170599699020386e+00 5.9104999542236328e+01 -3.2233699798583984e+01 3.6562202453613281e+01 7.0040397644042969e+01 -3.8387001037597656e+01 2.9782499313354492e+01 7.4474800109863281e+01 -3.8389400482177734e+01 1.5645200729370117e+01 6.2013099670410156e+01 -3.7266197204589844e+01 4.2893001556396484e+01 5.1923801422119141e+01 -3.7266002655029297e+01 5.4677501678466797e+01 4.9207698822021484e+01 -3.2231403350830078e+01 4.9181400299072266e+01 3.9661300659179688e+01 -3.7265899658203125e+01 6.4126296997070312e+01 6.6670997619628906e+01 -4.3020999908447266e+01 4.1205699920654297e+01 7.3550094604492188e+01 -4.3022300720214844e+01 2.7057100296020508e+01 7.7358497619628906e+01 -4.3024600982666016e+01 1.2475700378417969e+01 5.6843299865722656e+01 -4.3021598815917969e+01 5.3966102600097656e+01 2.5049600601196289e+01 -3.4442001342773438e+01 6.8122604370117188e+01 3.6946399688720703e+01 -3.2240901947021484e+01 5.8903797149658203e+01 4.4562896728515625e+01 -4.3020900726318359e+01 6.4476997375488281e+01 1.2114600181579590e+01 -3.8389999389648438e+01 7.5127197265625000e+01 2.6272998809814453e+01 -3.8387500762939453e+01 7.1428794860839844e+01 2.1015600204467773e+01 -3.2246299743652344e+01 6.6359199523925781e+01 3.0671701431274414e+01 -4.3021900177001953e+01 7.2120101928710938e+01 1.6111700057983398e+01 -4.3023998260498047e+01 7.6686698913574219e+01 1.7856500148773193e+00 -4.3026500701904297e+01 7.8329895019531250e+01 7.8330101013183594e+01 -4.3027000427246094e+01 -1.7853500843048096e+00 7.9383201599121094e+01 -4.8954898834228516e+01 -3.4461998939514160e-01 7.8114799499511719e+01 -4.8949199676513672e+01 1.4203499794006348e+01 7.3951698303222656e+01 -4.8940597534179688e+01 2.8930398941040039e+01 6.6686599731445312e+01 -4.8934600830078125e+01 4.3129802703857422e+01 5.6477798461914062e+01 -4.8932300567626953e+01 5.5839900970458984e+01 4.3869800567626953e+01 -4.8934097290039062e+01 6.6202606201171875e+01 2.9704099655151367e+01 -4.8939601898193359e+01 7.3644798278808594e+01 1.4941699981689453e+01 -4.8947898864746094e+01 7.7977600097656250e+01 3.4459200501441956e-01 -4.8954898834228516e+01 7.9383300781250000e+01 -6.4126296997070312e+01 -3.7265899658203125e+01 3.9661300659179688e+01 -5.3850097656250000e+01 -3.6490200042724609e+01 5.2007102966308594e+01 -5.6481498718261719e+01 -3.2248001098632812e+01 4.0724998474121094e+01 -4.8838300704956055e+00 -3.2246299743652344e+01 6.9384094238281250e+01 -1.5174099922180176e+01 -3.2350498199462891e+01 6.8473693847656250e+01 -1.2475700378417969e+01 -4.3024600982666016e+01 7.7358497619628906e+01 -2.9782499313354492e+01 -3.8387001037597656e+01 7.0040397644042969e+01 -4.2893001556396484e+01 -3.7266197204589844e+01 6.2013099670410156e+01 -2.8395601272583008e+01 -3.4441600799560547e+01 6.6799201965332031e+01 -4.3375499725341797e+01 -3.2257099151611328e+01 5.4680000305175781e+01 -2.7057100296020508e+01 -4.3022300720214844e+01 7.3550094604492188e+01 -4.1205699920654297e+01 -4.3020999908447266e+01 6.6670997619628906e+01 -5.3966102600097656e+01 -4.3021598815917969e+01 5.6843299865722656e+01 -6.4476997375488281e+01 -4.3020900726318359e+01 4.4562896728515625e+01 -6.7513504028320312e+01 -3.4440597534179688e+01 2.6707201004028320e+01 -7.5355300903320312e+01 -3.7268402099609375e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 -3.4436901092529297e+01 1.3211199760437012e+01 -6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 -7.5127197265625000e+01 -3.8389999389648438e+01 1.2114600181579590e+01 -7.1428794860839844e+01 -3.8387500762939453e+01 2.6272998809814453e+01 -7.2120101928710938e+01 -4.3021900177001953e+01 3.0671701431274414e+01 -7.6686698913574219e+01 -4.3023998260498047e+01 1.6111700057983398e+01 -1.4203499794006348e+01 -4.8949199676513672e+01 7.8114799499511719e+01 -2.8930398941040039e+01 -4.8940597534179688e+01 7.3951698303222656e+01 -4.3129802703857422e+01 -4.8934600830078125e+01 6.6686599731445312e+01 -5.4402599334716797e+01 -4.9551700592041016e+01 5.7758701324462891e+01 -1.7856500148773193e+00 -5.4973503112792969e+01 7.8329895019531250e+01 -7.8330101013183594e+01 -4.3027000427246094e+01 1.7853500843048096e+00 -6.4116600036621094e+01 -4.8947498321533203e+01 4.6979301452636719e+01 -6.7437301635742188e+01 -4.7811298370361328e+01 4.1716197967529297e+01 -7.3951698303222656e+01 -4.9059398651123047e+01 2.8930398941040039e+01 -7.8114799499511719e+01 -4.9050800323486328e+01 1.4203499794006348e+01 -7.9383201599121094e+01 -4.9045101165771484e+01 -3.4461998939514160e-01 7.8330101013183594e+01 -5.4972999572753906e+01 1.7853500843048096e+00 7.6686698913574219e+01 -5.4976001739501953e+01 1.6111700057983398e+01 7.2120101928710938e+01 -5.4978099822998047e+01 3.0671701431274414e+01 6.4476997375488281e+01 -5.4979099273681641e+01 4.4562896728515625e+01 5.3966102600097656e+01 -5.4978401184082031e+01 5.6843299865722656e+01 7.5127197265625000e+01 -5.9610000610351562e+01 1.2114600181579590e+01 7.5355300903320312e+01 -6.0731601715087891e+01 -1.7170599699020386e+00 7.1428794860839844e+01 -5.9612503051757812e+01 2.6272998809814453e+01 6.4126296997070312e+01 -6.0734100341796875e+01 3.9661300659179688e+01 5.3850097656250000e+01 -6.1509799957275391e+01 5.2007102966308594e+01 4.1205699920654297e+01 -5.4979000091552734e+01 6.6670997619628906e+01 2.7057100296020508e+01 -5.4977699279785156e+01 7.3550094604492188e+01 1.2475700378417969e+01 -5.4975402832031250e+01 7.7358497619628906e+01 -1.2114600181579590e+01 -5.9610000610351562e+01 7.5127197265625000e+01 1.7341400384902954e+00 -5.9608001708984375e+01 7.6071098327636719e+01 4.2893001556396484e+01 -6.0733798980712891e+01 6.2013099670410156e+01 2.9782499313354492e+01 -5.9612998962402344e+01 7.0040397644042969e+01 1.5645200729370117e+01 -5.9610603332519531e+01 7.4474800109863281e+01 5.6481498718261719e+01 -6.5751998901367188e+01 4.0724998474121094e+01 6.7513504028320312e+01 -6.3559398651123047e+01 2.6707201004028320e+01 7.1374496459960938e+01 -6.3563102722167969e+01 1.3211199760437012e+01 6.9488693237304688e+01 -6.5759704589843750e+01 1.4108999967575073e+00 6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 2.8395601272583008e+01 -6.3558399200439453e+01 6.6799201965332031e+01 4.3375499725341797e+01 -6.5742904663085938e+01 5.4680000305175781e+01 -5.1130700111389160e+00 -6.3596702575683594e+01 7.2644706726074219e+01 1.5174099922180176e+01 -6.5649505615234375e+01 6.8473693847656250e+01 -1.6111700057983398e+01 -5.4976001739501953e+01 7.6686698913574219e+01 -3.0671701431274414e+01 -5.4978099822998047e+01 7.2120101928710938e+01 -4.4562896728515625e+01 -5.4979099273681641e+01 6.4476997375488281e+01 -5.6843299865722656e+01 -5.4978401184082031e+01 5.3966102600097656e+01 -2.6272998809814453e+01 -5.9612503051757812e+01 7.1428794860839844e+01 -3.9661300659179688e+01 -6.0734100341796875e+01 6.4126296997070312e+01 -5.1923801422119141e+01 -6.0734001159667969e+01 5.4677501678466797e+01 -7.7358497619628906e+01 -5.4975402832031250e+01 1.2475700378417969e+01 -6.6670997619628906e+01 -5.4979000091552734e+01 4.1205699920654297e+01 -7.3550094604492188e+01 -5.4977699279785156e+01 2.7057100296020508e+01 -7.8330101013183594e+01 -5.4972999572753906e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 -6.0733798980712891e+01 4.2893001556396484e+01 -7.0040397644042969e+01 -5.9612998962402344e+01 2.9782499313354492e+01 -7.5355300903320312e+01 -6.0731601715087891e+01 1.7170599699020386e+00 -7.4474800109863281e+01 -5.9610603332519531e+01 1.5645200729370117e+01 -2.5049600601196289e+01 -6.3557998657226562e+01 6.8122604370117188e+01 -4.9207698822021484e+01 -6.5768600463867188e+01 4.9181400299072266e+01 -3.6946399688720703e+01 -6.5759101867675781e+01 5.8903797149658203e+01 -2.1015600204467773e+01 -6.5753700256347656e+01 6.6359199523925781e+01 -5.9104999542236328e+01 -6.5766296386718750e+01 3.6562202453613281e+01 -6.7477394104003906e+01 -6.3571102142333984e+01 2.6760299682617188e+01 -7.1366401672363281e+01 -6.3561000823974609e+01 1.3268600463867188e+01 -6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 -6.9456398010253906e+01 -6.5766296386718750e+01 -1.5821199417114258e+00 4.8838300704956055e+00 -6.5753700256347656e+01 6.9384094238281250e+01 -6.5954093933105469e+01 -6.5003295898437500e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 -6.5001693725585938e+01 2.0110498428344727e+01 -6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 -6.4940101623535156e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 -6.5744300842285156e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 -6.5649505615234375e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 -6.4940101623535156e+01 4.3333198547363281e+01 -2.5114198684692383e+01 -6.5005798339843750e+01 6.1894699096679688e+01 -4.6691398620605469e+00 -6.4939994812011719e+01 6.6339698791503906e+01 -5.6185497283935547e+01 -6.5768501281738281e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 -6.4974800109863281e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 -6.4940101623535156e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 -6.5753700256347656e+01 -6.9384094238281250e+01 4.6691398620605469e+00 -6.4939994812011719e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 -6.6084396362304688e+01 7.3676099777221680e+00 -3.9422199249267578e+01 -6.6119201660156250e+01 4.7579696655273438e+01 -4.8702198028564453e+01 -6.5940795898437500e+01 3.9441997528076172e+01 -8.7784500122070312e+00 -6.6089698791503906e+01 6.1264701843261719e+01 3.0705200195312500e+01 -6.6117897033691406e+01 5.3397201538085938e+01 1.5252799987792969e+01 -6.5862602233886719e+01 6.1349498748779297e+01 5.0155899047851562e+01 -6.6073204040527344e+01 3.6021900177001953e+01 4.3594100952148438e+01 -6.4963195800781250e+01 5.0356700897216797e+01 6.0698596954345703e+01 -6.6066696166992188e+01 -6.7463498115539551e+00 6.6711799621582031e+01 -6.5003898620605469e+01 1.3542500138282776e-01 5.9121696472167969e+01 -6.6100502014160156e+01 1.8429199218750000e+01 5.9817501068115234e+01 -6.4940101623535156e+01 2.9234298706054688e+01 2.0092599868774414e+01 -6.4940101623535156e+01 6.3447898864746094e+01 -2.4017601013183594e+01 -6.4924705505371094e+01 4.4330997467041016e+01 -1.2296899795532227e+01 -6.4922195434570312e+01 4.8861900329589844e+01 -4.9878101348876953e+01 -6.4923797607421875e+01 6.1260700225830078e+00 -4.7621898651123047e+01 -6.5026702880859375e+01 2.0646100997924805e+01 -5.8962200164794922e+01 -6.6058395385742188e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 -6.4928802490234375e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 -6.4901504516601562e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 -6.4915802001953125e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 -6.6128295898437500e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 -6.4940605163574219e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 -6.4898902893066406e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 -6.5010696411132812e+01 3.6192996978759766e+01 -7.4321599006652832e+00 -6.6034599304199219e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 -6.5038299560546875e+01 -5.1429000854492188e+01 6.1151897907257080e-01 -6.4899902343750000e+01 5.0388702392578125e+01 4.0430500030517578e+01 -6.6047805786132812e+01 -4.7272399902343750e+01 2.1093599319458008e+01 -6.5008094787597656e+01 -4.7210800170898438e+01 5.7853302955627441e+00 -6.4969100952148438e+01 -5.0313201904296875e+01 4.5625198364257812e+01 -6.5076095581054688e+01 -2.5078199386596680e+01 5.2289600372314453e+01 -6.5047103881835938e+01 -4.6615300178527832e+00 4.9076499938964844e+01 -6.5030502319335938e+01 1.6025699615478516e+01 3.6085098266601562e+01 -6.4887702941894531e+01 3.5027797698974609e+01 4.5658901214599609e+01 -6.4956298828125000e+01 2.1977499008178711e+01 1.2848500251770020e+01 -6.4922805786132812e+01 4.8701698303222656e+01 2.4957799911499023e+01 -6.4924301147460938e+01 4.3825702667236328e+01 3.6392799377441406e+01 -6.5013999938964844e+01 -3.6605201721191406e+01 5.6047599792480469e+01 -6.6018997192382812e+01 -2.7524799346923828e+01 4.4547400474548340e+00 -6.5808799743652344e+01 -6.3284599304199219e+01 2.7442001342773438e+01 -6.5952598571777344e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 -6.5855598449707031e+01 -6.0778099060058594e+01 6.3447898864746094e+01 -6.4940101623535156e+01 -2.0092599868774414e+01 5.0577800750732422e+01 -6.4940101623535156e+01 -4.3333198547363281e+01 2.9234298706054688e+01 -6.4940101623535156e+01 -5.9817501068115234e+01 2.1015600204467773e+01 -6.5753700256347656e+01 -6.6359199523925781e+01 5.6820499420166016e+01 -6.5761795043945312e+01 -4.0331298828125000e+01 6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 4.3921298980712891e+01 -6.5758102416992188e+01 -5.3944599151611328e+01 1.5645200729370117e+01 -3.8389400482177734e+01 -7.4474800109863281e+01 1.7341400384902954e+00 -3.8391998291015625e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 -3.4403301239013672e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 -3.4428897857666016e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 -3.4439002990722656e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 -3.8387001037597656e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 -3.8389400482177734e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 -3.7266197204589844e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 -3.7266002655029297e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 -3.3472698211669922e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 -3.7265899658203125e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 -4.3020999908447266e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 -4.3022300720214844e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 -4.3024600982666016e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 -4.3021598815917969e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 -3.4442001342773438e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 -4.3020900726318359e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 -3.8389999389648438e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 -3.8387500762939453e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 -4.3021900177001953e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 -4.3023998260498047e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 -4.3026500701904297e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 -4.9052101135253906e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 -4.9060401916503906e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 -4.9065898895263672e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 -4.9067699432373047e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 -4.9065399169921875e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 -4.9059398651123047e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 -4.9050800323486328e+01 -7.8114799499511719e+01 3.4459200501441956e-01 -4.9045101165771484e+01 -7.9383300781250000e+01 6.4126296997070312e+01 -3.7265899658203125e+01 -3.9661300659179688e+01 5.3850097656250000e+01 -3.6490200042724609e+01 -5.2007102966308594e+01 1.2475700378417969e+01 -4.3024600982666016e+01 -7.7358497619628906e+01 2.9782499313354492e+01 -3.8387001037597656e+01 -7.0040397644042969e+01 4.2893001556396484e+01 -3.7266197204589844e+01 -6.2013099670410156e+01 2.8395601272583008e+01 -3.4441600799560547e+01 -6.6799201965332031e+01 2.7057100296020508e+01 -4.3022300720214844e+01 -7.3550094604492188e+01 4.1205699920654297e+01 -4.3020999908447266e+01 -6.6670997619628906e+01 5.3966102600097656e+01 -4.3021598815917969e+01 -5.6843299865722656e+01 6.7513504028320312e+01 -3.4440597534179688e+01 -2.6707201004028320e+01 6.4476997375488281e+01 -4.3020900726318359e+01 -4.4562896728515625e+01 7.1374496459960938e+01 -3.4436901092529297e+01 -1.3211199760437012e+01 7.5127197265625000e+01 -3.8389999389648438e+01 -1.2114600181579590e+01 7.1428794860839844e+01 -3.8387500762939453e+01 -2.6272998809814453e+01 7.2120101928710938e+01 -4.3021900177001953e+01 -3.0671701431274414e+01 7.6686698913574219e+01 -4.3023998260498047e+01 -1.6111700057983398e+01 1.4941699981689453e+01 -4.9052101135253906e+01 -7.7977600097656250e+01 2.9704099655151367e+01 -4.9060401916503906e+01 -7.3644798278808594e+01 4.1731800079345703e+01 -4.9570999145507812e+01 -6.7475105285644531e+01 4.9999198913574219e+01 -4.8999500274658203e+01 -6.1567001342773438e+01 5.7531902313232422e+01 -4.8420101165771484e+01 -5.4633300781250000e+01 1.7856500148773193e+00 -5.4973503112792969e+01 -7.8329895019531250e+01 6.6202606201171875e+01 -4.8934097290039062e+01 -4.3869800567626953e+01 7.3644798278808594e+01 -4.8939601898193359e+01 -2.9704099655151367e+01 7.7977600097656250e+01 -4.8947898864746094e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 -5.4976001739501953e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 -5.4978099822998047e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 -5.4979099273681641e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 -5.4978401184082031e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 -5.9610000610351562e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 -5.9612503051757812e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 -6.0734100341796875e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 -6.1509799957275391e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 -5.4979000091552734e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 -5.4977699279785156e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 -5.4975402832031250e+01 -7.7358497619628906e+01 1.2114600181579590e+01 -5.9610000610351562e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 -5.9608001708984375e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 -6.0733798980712891e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 -5.9612998962402344e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 -5.9610603332519531e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 -6.3559398651123047e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 -6.3563102722167969e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 -6.3558399200439453e+01 -6.6799201965332031e+01 5.1130599975585938e+00 -6.3596702575683594e+01 -7.2644706726074219e+01 2.5049600601196289e+01 -6.3557998657226562e+01 -6.8122604370117188e+01 1.6111700057983398e+01 -5.4976001739501953e+01 -7.6686698913574219e+01 3.0671701431274414e+01 -5.4978099822998047e+01 -7.2120101928710938e+01 4.2744701385498047e+01 -5.6259502410888672e+01 -6.5250297546386719e+01 5.6843299865722656e+01 -5.4978401184082031e+01 -5.3966102600097656e+01 2.6272998809814453e+01 -5.9612503051757812e+01 -7.1428794860839844e+01 5.1923801422119141e+01 -6.0734001159667969e+01 -5.4677501678466797e+01 3.8678096771240234e+01 -6.2713600158691406e+01 -6.2656597137451172e+01 7.7358497619628906e+01 -5.4975402832031250e+01 -1.2475700378417969e+01 6.6670997619628906e+01 -5.4979000091552734e+01 -4.1205699920654297e+01 7.3550094604492188e+01 -5.4977699279785156e+01 -2.7057100296020508e+01 6.2013099670410156e+01 -6.0733798980712891e+01 -4.2893001556396484e+01 7.0040397644042969e+01 -5.9612998962402344e+01 -2.9782499313354492e+01 7.4474800109863281e+01 -5.9610603332519531e+01 -1.5645200729370117e+01 6.7477394104003906e+01 -6.3571102142333984e+01 -2.6760299682617188e+01 7.1366401672363281e+01 -6.3561000823974609e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 -3.3059700012207031e+01 4.8698802947998047e+01 -6.3504100799560547e+01 -3.2998302459716797e+01 2.0110498428344727e+01 -5.2329101562500000e+01 -3.2130302429199219e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 -3.2137401580810547e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 -3.2020099639892578e+01 4.9141799926757812e+01 2.8352600097656250e+01 -3.2989597320556641e+01 4.3039199829101562e+01 1.5969698905944824e+01 -3.3055599212646484e+01 4.7725498199462891e+01 3.9991699218750000e+01 -3.3097698211669922e+01 3.0614299774169922e+01 4.8633197784423828e+01 -3.3084796905517578e+01 1.3720000267028809e+01 5.0044700622558594e+01 -3.3111999511718750e+01 -5.6227302551269531e+00 3.5953800201416016e+01 -3.3097698211669922e+01 -3.5078903198242188e+01 4.5476398468017578e+01 -3.3045200347900391e+01 -2.1894300460815430e+01 9.9145097732543945e+00 -3.3083801269531250e+01 -4.9431201934814453e+01 2.5745399475097656e+01 -3.3058502197265625e+01 -4.3290298461914062e+01 4.9954399108886719e+01 -6.5034202575683594e+01 5.4540300369262695e+00 4.8967998504638672e+01 -6.7537704467773438e+01 1.3350299835205078e+01 5.0034500122070312e+01 -6.7539604187011719e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 -6.5033500671386719e+01 3.7523998260498047e+01 -4.3557899475097656e+01 -6.7537895202636719e+01 2.6049699783325195e+01 -2.8130199432373047e+01 -6.7539604187011719e+01 4.1621601104736328e+01 -4.9887100219726562e+01 -6.7539398193359375e+01 6.8354101181030273e+00 -4.7150398254394531e+01 -6.5031204223632812e+01 1.8047500610351562e+01 -4.0905799865722656e+01 -6.5034301757812500e+01 2.9103500366210938e+01 -9.2679700851440430e+00 -6.7539001464843750e+01 4.9685398101806641e+01 9.3136892318725586e+00 -6.7538703918457031e+01 4.9535301208496094e+01 2.6869998931884766e+01 -6.7538597106933594e+01 4.2637798309326172e+01 4.0471401214599609e+01 -6.7539604187011719e+01 2.9807500839233398e+01 4.8870899200439453e+01 -6.5032897949218750e+01 -1.3342700004577637e+01 2.4033800125122070e+01 -6.5031997680664062e+01 -4.4287799835205078e+01 3.8291000366210938e+01 -6.5033897399902344e+01 -3.2910102844238281e+01 4.7313400268554688e+01 -6.7535400390625000e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 -6.7537704467773438e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 -6.7539398193359375e+01 -4.9904800415039062e+01 3.7271400451660156e+01 -6.7538406372070312e+01 -3.3985900878906250e+01 2.5166799545288086e+01 -6.7537002563476562e+01 -4.3544601440429688e+01 1.0624900817871094e+01 -6.7538406372070312e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 -6.7537796020507812e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 -6.7539604187011719e+01 -2.9807500839233398e+01 1.2806200027465820e+01 -8.1073295593261719e+01 -3.8097999095916748e+00 1.3205300331115723e+01 -8.0267494201660156e+01 -5.5868902206420898e+00 1.3861199378967285e+01 -8.0269203186035156e+01 4.1422801017761230e+00 6.8685703277587891e+00 -8.0269203186035156e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 -8.0430801391601562e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 -8.1080497741699219e+01 1.2562399864196777e+01 6.8692898750305176e+00 -8.0268096923828125e+01 1.2766799926757812e+01 -2.6745600700378418e+00 -8.0267105102539062e+01 1.4119600296020508e+01 -1.0887900352478027e+01 -8.1082099914550781e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 -8.1073501586914062e+01 3.7914199829101562e+00 -1.3522299766540527e+01 -8.0268005371093750e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 -8.0268394470214844e+01 8.1145401000976562e+00 1.4918000221252441e+01 -8.0275100708007812e+01 -3.5685497283935547e+01 3.7123301029205322e+00 -8.0275100708007812e+01 -3.8456001281738281e+01 5.6025695800781250e+00 -6.7521499633789062e+01 -3.8081703186035156e+01 1.6305999755859375e+01 -6.7521499633789062e+01 -3.5007499694824219e+01 3.6341297149658203e+01 -6.7521499633789062e+01 -1.3186100006103516e+01 3.0869201660156250e+01 -8.0274299621582031e+01 -2.3010200500488281e+01 2.9183500289916992e+01 -6.7522102355957031e+01 -2.5193401336669922e+01 2.3136499404907227e+01 -8.0274299621582031e+01 -3.0677999496459961e+01 3.8549598693847656e+01 -8.0275100708007812e+01 -1.6160999536514282e+00 3.7004398345947266e+01 -8.0275100708007812e+01 -1.1183599472045898e+01 3.8620300292968750e+01 -6.7521499633789062e+01 8.1181198358535767e-01 -4.5067396163940430e+00 -6.7521499633789062e+01 -3.8375400543212891e+01 2.5930200576782227e+01 -8.0275100708007812e+01 2.8557600021362305e+01 3.1677902221679688e+01 -8.0274200439453125e+01 2.1873998641967773e+01 3.1033300399780273e+01 -6.7523498535156250e+01 2.2732900619506836e+01 2.0160699844360352e+01 -6.7523300170898438e+01 3.2750801086425781e+01 6.2813601493835449e+00 -6.7521499633789062e+01 3.8171100616455078e+01 1.6532600402832031e+01 -8.0275100708007812e+01 3.4899303436279297e+01 3.7707702636718750e+01 -8.0275100708007812e+01 8.4654598236083984e+00 3.6223800659179688e+01 -6.7521499633789062e+01 1.2949000358581543e+01 5.2079100608825684e+00 -8.0275100708007812e+01 3.8213302612304688e+01 -3.4080798625946045e+00 -8.0275100708007812e+01 3.8494800567626953e+01 -3.7614700317382812e+01 -8.0275100708007812e+01 9.4110794067382812e+00 -1.6054100036621094e+01 -8.0275100708007812e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 -8.0275100708007812e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 -8.0275100708007812e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 -8.0274406433105469e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 -8.0275001525878906e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 -8.0275001525878906e+01 3.4412902832031250e+01 -3.1601600646972656e+01 -8.0274200439453125e+01 2.1895799636840820e+01 -2.5230501174926758e+01 -8.0274902343750000e+01 2.9101999282836914e+01 -3.3142398834228516e+01 -6.7523193359375000e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 -6.7522598266601562e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 -6.7521499633789062e+01 6.3573803901672363e+00 -3.7880397796630859e+01 -6.7521499633789062e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 -6.7521499633789062e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 -6.7521804809570312e+01 2.5504301071166992e+01 -1.9341501235961914e+01 -6.7523002624511719e+01 3.3339103698730469e+01 -3.4695800781250000e+01 -6.7521499633789062e+01 1.6600400924682617e+01 -7.6062998771667480e+00 -6.7521499633789062e+01 3.7799701690673828e+01 -4.9609901428222656e+01 -3.0460399627685547e+01 8.1507596969604492e+00 -4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 -3.2965702056884766e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 -3.0460399627685547e+01 2.2791400909423828e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 3.5853599548339844e+01 -4.9730598449707031e+01 -3.2965702056884766e+01 6.7970499992370605e+00 2.9969398975372314e+00 -3.2965702056884766e+01 5.0145702362060547e+01 6.9386696815490723e+00 -3.0460399627685547e+01 4.9888397216796875e+01 4.8833702087402344e+01 -3.0460399627685547e+01 1.3304400444030762e+01 4.0471401214599609e+01 -3.0460399627685547e+01 2.9807500839233398e+01 4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 2.5877500534057617e+01 -3.0460399627685547e+01 4.3248897552490234e+01 2.9460500717163086e+01 -3.2965702056884766e+01 4.0491600036621094e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 4.9272800445556641e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 4.3484500885009766e+01 -2.9969398975372314e+00 -3.2965702056884766e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 -3.2965702056884766e+01 -1.7957401275634766e+01 4.3438598632812500e+01 -3.0460399627685547e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 -4.9272800445556641e+01 1.7176401138305664e+01 -3.0460399627685547e+01 -4.7315002441406250e+01 3.1059000015258789e+01 -3.0460399627685547e+01 -3.9376998901367188e+01 2.9829699993133545e+00 -3.0460399627685547e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 -3.0460399627685547e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 -8.1032798767089844e+01 1.1027499437332153e+00 1.0264200210571289e+01 -2.9614400863647461e+01 2.9392998218536377e+00 1.0690099716186523e+01 -4.1044399261474609e+01 0.0000000000000000e+00 8.1825199127197266e+00 -2.9608499526977539e+01 6.8735299110412598e+00 5.0151400566101074e+00 -2.9599399566650391e+01 9.4172601699829102e+00 -6.3304600715637207e+00 -2.9442100524902344e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 -2.9454700469970703e+01 1.2124200820922852e+01 -1.3189299583435059e+01 -2.9452299118041992e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 -2.9457300186157227e+01 6.2997603416442871e+00 6.3305301666259766e+00 -2.9442100524902344e+01 1.2118599891662598e+01 1.3189299583435059e+01 -2.9452299118041992e+01 2.1639201641082764e+00 1.2706499099731445e+01 -3.0459199905395508e+01 -6.5114102363586426e+00 3.8211998939514160e+00 -3.0459899902343750e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 -3.0458499908447266e+01 1.4018300056457520e+01 8.3117198944091797e+00 -3.0458000183105469e+01 1.1874300003051758e+01 1.4127900123596191e+01 -3.0459999084472656e+01 3.0538599491119385e+00 -1.2706499099731445e+01 -3.0459199905395508e+01 6.5114398002624512e+00 -8.3115901947021484e+00 -3.0458000183105469e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 -3.0459199905395508e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fl_caster_l_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fl_caster_r_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 6.8265296936035156e+01 -9.3289899826049805e+00 2.7445201873779297e+00 6.8581901550292969e+01 -1.2800700187683105e+01 1.0573199987411499e+00 6.8359207153320312e+01 -1.0600199699401855e+01 1.0544799804687500e+01 6.8569099426269531e+01 -8.4442996978759766e+00 8.2298793792724609e+00 6.8419601440429688e+01 -6.8257398605346680e+00 1.0452800750732422e+01 6.8323402404785156e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 6.8392799377441406e+01 8.3633699417114258e+00 -1.0304100036621094e+01 1.7535499572753906e+01 4.2757096290588379e+00 -9.9000797271728516e+00 6.8434997558593750e+01 4.3990101814270020e+00 -3.0437600612640381e+00 6.8367401123046875e+01 1.0238399505615234e+01 -3.0640001296997070e+00 1.7108699798583984e+01 1.0639900207519531e+01 -1.0523200035095215e+01 6.8192199707031250e+01 2.0460700988769531e+00 -1.0421499252319336e+01 6.8127601623535156e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 6.8441001892089844e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 1.7107900619506836e+01 8.4554700851440430e+00 -1.0192299842834473e+01 1.7057300567626953e+01 5.5663700103759766e+00 -1.0925999641418457e+01 1.7111598968505859e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 1.7088899612426758e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 6.8396400451660156e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 6.8405799865722656e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 1.7143899917602539e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 6.8322502136230469e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 1.7096700668334961e+01 -1.1044600486755371e+01 1.0178999900817871e+00 6.8367797851562500e+01 1.0607999801635742e+01 1.0090099573135376e+00 1.7097700119018555e+01 1.1044500350952148e+01 7.1427397727966309e+00 1.7195999145507812e+01 8.4595899581909180e+00 9.8030099868774414e+00 1.7092800140380859e+01 5.1623497009277344e+00 7.4257197380065918e+00 1.6894800186157227e+01 1.1212299346923828e+01 3.3442101478576660e+00 1.7096099853515625e+01 -1.0557999610900879e+01 6.1998200416564941e+00 1.6903999328613281e+01 -1.1747900009155273e+01 7.2372202873229980e+00 1.7205499649047852e+01 -8.3683700561523438e+00 9.8025293350219727e+00 1.7078998565673828e+01 -5.1738500595092773e+00 4.0853300094604492e+00 1.7077999114990234e+01 1.0249599456787109e+01 1.0831099510192871e+01 1.7257900238037109e+01 -2.0039701461791992e+00 1.2268199920654297e+01 1.6871999740600586e+01 3.9475402832031250e+00 1.1011500358581543e+01 1.7335899353027344e+01 0.0000000000000000e+00 1.0836700439453125e+01 1.7178098678588867e+01 2.0019199848175049e+00 -1.1417300224304199e+01 6.6068595886230469e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 6.6098693847656250e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 6.4885696411132812e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 6.4939201354980469e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 6.4994499206542969e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 6.5077301025390625e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 6.6034599304199219e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 6.5038505554199219e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 6.4994796752929688e+01 2.3467597961425781e+00 -4.8763401031494141e+01 6.5027900695800781e+01 1.6582399368286133e+01 -6.1740497589111328e+01 6.6020698547363281e+01 1.0151400566101074e+01 -4.5477100372314453e+01 6.4954597473144531e+01 2.1893899917602539e+01 1.6372301101684570e+01 6.6058395385742188e+01 5.8962200164794922e+01 2.3468399047851562e+00 6.4992599487304688e+01 5.1267200469970703e+01 -9.9129495620727539e+00 6.4916198730468750e+01 4.9431499481201172e+01 -3.6015296936035156e+01 6.4891899108886719e+01 3.4995300292968750e+01 -4.8726200103759766e+01 6.6080505371093750e+01 3.8182498931884766e+01 -2.5745399475097656e+01 6.4941505432128906e+01 4.3290298461914062e+01 -6.4798698425292969e+00 6.6077705383300781e+01 6.1833000183105469e+01 -3.9104801177978516e+01 6.4893997192382812e+01 -3.1760398864746094e+01 3.8039699554443359e+01 6.6068901062011719e+01 4.8811397552490234e+01 2.0110498428344727e+01 6.5001693725585938e+01 6.3504100799560547e+01 4.7388999938964844e+01 6.4940200805664062e+01 4.7388999938964844e+01 5.0501701354980469e+01 6.5800300598144531e+01 3.8274200439453125e+01 6.3447898864746094e+01 6.4940101623535156e+01 2.0092599868774414e+01 6.0778099060058594e+01 6.5855598449707031e+01 1.7475801467895508e+01 6.0313198089599609e+01 6.6034599304199219e+01 7.4321599006652832e+00 6.3284599304199219e+01 6.5808799743652344e+01 -4.4547400474548340e+00 5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 5.5512199401855469e+01 6.6128799438476562e+01 -2.7132499694824219e+01 2.8417900085449219e+01 6.4975593566894531e+01 -6.0260898590087891e+01 4.4547300338745117e+00 6.5808898925781250e+01 -6.3284301757812500e+01 3.3109401702880859e+01 6.6098304748535156e+01 -5.2159999847412109e+01 4.6935901641845703e+01 6.5001396179199219e+01 -4.6935901641845703e+01 4.6696701049804688e+00 6.4939994812011719e+01 -6.6339698791503906e+01 6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 6.4980697631835938e+01 6.5981704711914062e+01 -4.4070800781250000e+01 6.4974899291992188e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 6.5756004333496094e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 6.5755393981933594e+01 -3.8144996643066406e+01 1.5174099922180176e+01 6.5649505615234375e+01 -6.8473693847656250e+01 4.8838300704956055e+00 6.5753700256347656e+01 -6.9384094238281250e+01 4.1918899536132812e+01 6.5744300842285156e+01 -5.5662799835205078e+01 5.6185497283935547e+01 6.5768501281738281e+01 -4.1026100158691406e+01 6.9456398010253906e+01 6.5766296386718750e+01 -1.5821299552917480e+00 6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 6.5753700256347656e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 6.5001693725585938e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 6.5759704589843750e+01 1.4109100103378296e+00 -6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 5.9610603332519531e+01 7.4474800109863281e+01 -1.7341400384902954e+00 5.9608001708984375e+01 7.6071098327636719e+01 5.1130599975585938e+00 6.3596702575683594e+01 7.2644706726074219e+01 7.1366401672363281e+01 6.3561000823974609e+01 1.3268600463867188e+01 6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 6.7477394104003906e+01 6.3571102142333984e+01 2.6760299682617188e+01 7.5355300903320312e+01 6.0731601715087891e+01 1.7170599699020386e+00 5.9104999542236328e+01 6.5766296386718750e+01 3.6562202453613281e+01 7.0040397644042969e+01 5.9612998962402344e+01 2.9782499313354492e+01 7.4474800109863281e+01 5.9610603332519531e+01 1.5645200729370117e+01 6.2013099670410156e+01 6.0733798980712891e+01 4.2893001556396484e+01 5.1923801422119141e+01 6.0734001159667969e+01 5.4677501678466797e+01 4.9207698822021484e+01 6.5768600463867188e+01 4.9181400299072266e+01 3.9661300659179688e+01 6.0734100341796875e+01 6.4126296997070312e+01 6.6670997619628906e+01 5.4979000091552734e+01 4.1205699920654297e+01 7.3550094604492188e+01 5.4977699279785156e+01 2.7057100296020508e+01 7.7358497619628906e+01 5.4975402832031250e+01 1.2475700378417969e+01 5.6843299865722656e+01 5.4978401184082031e+01 5.3966102600097656e+01 2.5049600601196289e+01 6.3557998657226562e+01 6.8122604370117188e+01 3.6946399688720703e+01 6.5759101867675781e+01 5.8903797149658203e+01 4.4562896728515625e+01 5.4979099273681641e+01 6.4476997375488281e+01 1.2114600181579590e+01 5.9610000610351562e+01 7.5127197265625000e+01 2.6272998809814453e+01 5.9612503051757812e+01 7.1428794860839844e+01 2.1015600204467773e+01 6.5753700256347656e+01 6.6359199523925781e+01 3.0671701431274414e+01 5.4978099822998047e+01 7.2120101928710938e+01 1.6111700057983398e+01 5.4976001739501953e+01 7.6686698913574219e+01 1.7856500148773193e+00 5.4973503112792969e+01 7.8329895019531250e+01 7.8330101013183594e+01 5.4972999572753906e+01 -1.7853500843048096e+00 7.9383201599121094e+01 4.9045101165771484e+01 -3.4461998939514160e-01 7.8114799499511719e+01 4.9050800323486328e+01 1.4203499794006348e+01 7.3951698303222656e+01 4.9059398651123047e+01 2.8930398941040039e+01 6.6686599731445312e+01 4.9065399169921875e+01 4.3129802703857422e+01 5.6477798461914062e+01 4.9067699432373047e+01 5.5839900970458984e+01 4.3869800567626953e+01 4.9065898895263672e+01 6.6202606201171875e+01 2.9704099655151367e+01 4.9060401916503906e+01 7.3644798278808594e+01 1.4941699981689453e+01 4.9052101135253906e+01 7.7977600097656250e+01 3.4459200501441956e-01 4.9045101165771484e+01 7.9383300781250000e+01 -6.4126296997070312e+01 6.0734100341796875e+01 3.9661300659179688e+01 -5.3850097656250000e+01 6.1509799957275391e+01 5.2007102966308594e+01 -5.6481498718261719e+01 6.5751998901367188e+01 4.0724998474121094e+01 -4.8838300704956055e+00 6.5753700256347656e+01 6.9384094238281250e+01 -1.5174099922180176e+01 6.5649505615234375e+01 6.8473693847656250e+01 -1.2475700378417969e+01 5.4975402832031250e+01 7.7358497619628906e+01 -2.9782499313354492e+01 5.9612998962402344e+01 7.0040397644042969e+01 -4.2893001556396484e+01 6.0733798980712891e+01 6.2013099670410156e+01 -2.8395601272583008e+01 6.3558399200439453e+01 6.6799201965332031e+01 -4.3375499725341797e+01 6.5742904663085938e+01 5.4680000305175781e+01 -2.7057100296020508e+01 5.4977699279785156e+01 7.3550094604492188e+01 -4.1205699920654297e+01 5.4979000091552734e+01 6.6670997619628906e+01 -5.3966102600097656e+01 5.4978401184082031e+01 5.6843299865722656e+01 -6.4476997375488281e+01 5.4979099273681641e+01 4.4562896728515625e+01 -6.7513504028320312e+01 6.3559398651123047e+01 2.6707201004028320e+01 -7.5355300903320312e+01 6.0731601715087891e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 6.3563102722167969e+01 1.3211199760437012e+01 -6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 -7.5127197265625000e+01 5.9610000610351562e+01 1.2114600181579590e+01 -7.1428794860839844e+01 5.9612503051757812e+01 2.6272998809814453e+01 -7.2120101928710938e+01 5.4978099822998047e+01 3.0671701431274414e+01 -7.6686698913574219e+01 5.4976001739501953e+01 1.6111700057983398e+01 -1.4203499794006348e+01 4.9050800323486328e+01 7.8114799499511719e+01 -2.8930398941040039e+01 4.9059398651123047e+01 7.3951698303222656e+01 -4.3129802703857422e+01 4.9065399169921875e+01 6.6686599731445312e+01 -5.4402599334716797e+01 4.8448303222656250e+01 5.7758701324462891e+01 -1.7856500148773193e+00 4.3026500701904297e+01 7.8329895019531250e+01 -7.8330101013183594e+01 5.4972999572753906e+01 1.7853500843048096e+00 -6.4116600036621094e+01 4.9052497863769531e+01 4.6979301452636719e+01 -6.7437301635742188e+01 5.0188701629638672e+01 4.1716197967529297e+01 -7.3951698303222656e+01 4.8940597534179688e+01 2.8930398941040039e+01 -7.8114799499511719e+01 4.8949199676513672e+01 1.4203499794006348e+01 -7.9383201599121094e+01 4.8954898834228516e+01 -3.4461998939514160e-01 7.8330101013183594e+01 4.3027000427246094e+01 1.7853500843048096e+00 7.6686698913574219e+01 4.3023998260498047e+01 1.6111700057983398e+01 7.2120101928710938e+01 4.3021900177001953e+01 3.0671701431274414e+01 6.4476997375488281e+01 4.3020900726318359e+01 4.4562896728515625e+01 5.3966102600097656e+01 4.3021598815917969e+01 5.6843299865722656e+01 7.5127197265625000e+01 3.8389999389648438e+01 1.2114600181579590e+01 7.5355300903320312e+01 3.7268402099609375e+01 -1.7170599699020386e+00 7.1428794860839844e+01 3.8387500762939453e+01 2.6272998809814453e+01 6.4126296997070312e+01 3.7265899658203125e+01 3.9661300659179688e+01 5.3850097656250000e+01 3.6490200042724609e+01 5.2007102966308594e+01 4.1205699920654297e+01 4.3020999908447266e+01 6.6670997619628906e+01 2.7057100296020508e+01 4.3022300720214844e+01 7.3550094604492188e+01 1.2475700378417969e+01 4.3024600982666016e+01 7.7358497619628906e+01 -1.2114600181579590e+01 3.8389999389648438e+01 7.5127197265625000e+01 1.7341400384902954e+00 3.8391998291015625e+01 7.6071098327636719e+01 4.2893001556396484e+01 3.7266197204589844e+01 6.2013099670410156e+01 2.9782499313354492e+01 3.8387001037597656e+01 7.0040397644042969e+01 1.5645200729370117e+01 3.8389400482177734e+01 7.4474800109863281e+01 5.6481498718261719e+01 3.2248001098632812e+01 4.0724998474121094e+01 6.7513504028320312e+01 3.4440597534179688e+01 2.6707201004028320e+01 7.1374496459960938e+01 3.4436901092529297e+01 1.3211199760437012e+01 6.9488693237304688e+01 3.2240303039550781e+01 1.4108999967575073e+00 6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 2.8395601272583008e+01 3.4441600799560547e+01 6.6799201965332031e+01 4.3375499725341797e+01 3.2257099151611328e+01 5.4680000305175781e+01 -5.1130700111389160e+00 3.4403301239013672e+01 7.2644706726074219e+01 1.5174099922180176e+01 3.2350498199462891e+01 6.8473693847656250e+01 -1.6111700057983398e+01 4.3023998260498047e+01 7.6686698913574219e+01 -3.0671701431274414e+01 4.3021900177001953e+01 7.2120101928710938e+01 -4.4562896728515625e+01 4.3020900726318359e+01 6.4476997375488281e+01 -5.6843299865722656e+01 4.3021598815917969e+01 5.3966102600097656e+01 -2.6272998809814453e+01 3.8387500762939453e+01 7.1428794860839844e+01 -3.9661300659179688e+01 3.7265899658203125e+01 6.4126296997070312e+01 -5.1923801422119141e+01 3.7266002655029297e+01 5.4677501678466797e+01 -7.7358497619628906e+01 4.3024600982666016e+01 1.2475700378417969e+01 -6.6670997619628906e+01 4.3020999908447266e+01 4.1205699920654297e+01 -7.3550094604492188e+01 4.3022300720214844e+01 2.7057100296020508e+01 -7.8330101013183594e+01 4.3027000427246094e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 3.7266197204589844e+01 4.2893001556396484e+01 -7.0040397644042969e+01 3.8387001037597656e+01 2.9782499313354492e+01 -7.5355300903320312e+01 3.7268402099609375e+01 1.7170599699020386e+00 -7.4474800109863281e+01 3.8389400482177734e+01 1.5645200729370117e+01 -2.5049600601196289e+01 3.4442001342773438e+01 6.8122604370117188e+01 -4.9207698822021484e+01 3.2231403350830078e+01 4.9181400299072266e+01 -3.6946399688720703e+01 3.2240901947021484e+01 5.8903797149658203e+01 -2.1015600204467773e+01 3.2246299743652344e+01 6.6359199523925781e+01 -5.9104999542236328e+01 3.2233699798583984e+01 3.6562202453613281e+01 -6.7477394104003906e+01 3.4428897857666016e+01 2.6760299682617188e+01 -7.1366401672363281e+01 3.4439002990722656e+01 1.3268600463867188e+01 -6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 -6.9456398010253906e+01 3.2233699798583984e+01 -1.5821199417114258e+00 4.8838300704956055e+00 3.2246299743652344e+01 6.9384094238281250e+01 -6.5954093933105469e+01 3.2996700286865234e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 3.2998302459716797e+01 2.0110498428344727e+01 -6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 3.3059898376464844e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 3.2255702972412109e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 3.2350498199462891e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 3.3059898376464844e+01 4.3333198547363281e+01 -2.5114198684692383e+01 3.2994197845458984e+01 6.1894699096679688e+01 -4.6691398620605469e+00 3.3059997558593750e+01 6.6339698791503906e+01 -5.6185497283935547e+01 3.2231498718261719e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 3.3025199890136719e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 3.3059898376464844e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 3.2246299743652344e+01 -6.9384094238281250e+01 4.6691398620605469e+00 3.3059997558593750e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 3.1915601730346680e+01 7.3676099777221680e+00 -3.9422199249267578e+01 3.1880800247192383e+01 4.7579696655273438e+01 -4.8702198028564453e+01 3.2059200286865234e+01 3.9441997528076172e+01 -8.7784500122070312e+00 3.1910301208496094e+01 6.1264701843261719e+01 3.0705200195312500e+01 3.1882099151611328e+01 5.3397201538085938e+01 1.5252799987792969e+01 3.2137401580810547e+01 6.1349498748779297e+01 5.0155899047851562e+01 3.1926799774169922e+01 3.6021900177001953e+01 4.3594100952148438e+01 3.3036796569824219e+01 5.0356700897216797e+01 6.0698596954345703e+01 3.1933300018310547e+01 -6.7463498115539551e+00 6.6711799621582031e+01 3.2996097564697266e+01 1.3542500138282776e-01 5.9121696472167969e+01 3.1899499893188477e+01 1.8429199218750000e+01 5.9817501068115234e+01 3.3059898376464844e+01 2.9234298706054688e+01 2.0092599868774414e+01 3.3059898376464844e+01 6.3447898864746094e+01 -2.4017601013183594e+01 3.3075298309326172e+01 4.4330997467041016e+01 -1.2296899795532227e+01 3.3077796936035156e+01 4.8861900329589844e+01 -4.9878101348876953e+01 3.3076202392578125e+01 6.1260700225830078e+00 -4.7621898651123047e+01 3.2973300933837891e+01 2.0646100997924805e+01 -5.8962200164794922e+01 3.1941600799560547e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 3.3071201324462891e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 3.3098499298095703e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 3.3084197998046875e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 3.1871698379516602e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 3.3059398651123047e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 3.3101100921630859e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 3.2989299774169922e+01 3.6192996978759766e+01 -7.4321599006652832e+00 3.1965400695800781e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 3.2961700439453125e+01 -5.1429000854492188e+01 6.1151897907257080e-01 3.3100097656250000e+01 5.0388702392578125e+01 4.0430500030517578e+01 3.1952198028564453e+01 -4.7272399902343750e+01 2.1093599319458008e+01 3.2991901397705078e+01 -4.7210800170898438e+01 5.7853302955627441e+00 3.3030902862548828e+01 -5.0313201904296875e+01 4.5625198364257812e+01 3.2923900604248047e+01 -2.5078199386596680e+01 5.2289600372314453e+01 3.2952899932861328e+01 -4.6615300178527832e+00 4.9076499938964844e+01 3.2969501495361328e+01 1.6025699615478516e+01 3.6085098266601562e+01 3.3112297058105469e+01 3.5027797698974609e+01 4.5658901214599609e+01 3.3043701171875000e+01 2.1977499008178711e+01 1.2848500251770020e+01 3.3077198028564453e+01 4.8701698303222656e+01 2.4957799911499023e+01 3.3075702667236328e+01 4.3825702667236328e+01 3.6392799377441406e+01 3.2986000061035156e+01 -3.6605201721191406e+01 5.6047599792480469e+01 3.1980998992919922e+01 -2.7524799346923828e+01 4.4547400474548340e+00 3.2191196441650391e+01 -6.3284599304199219e+01 2.7442001342773438e+01 3.2047397613525391e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 3.2144401550292969e+01 -6.0778099060058594e+01 6.3447898864746094e+01 3.3059898376464844e+01 -2.0092599868774414e+01 5.0577800750732422e+01 3.3059898376464844e+01 -4.3333198547363281e+01 2.9234298706054688e+01 3.3059898376464844e+01 -5.9817501068115234e+01 2.1015600204467773e+01 3.2246299743652344e+01 -6.6359199523925781e+01 5.6820499420166016e+01 3.2238201141357422e+01 -4.0331298828125000e+01 6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 4.3921298980712891e+01 3.2241901397705078e+01 -5.3944599151611328e+01 1.5645200729370117e+01 5.9610603332519531e+01 -7.4474800109863281e+01 1.7341400384902954e+00 5.9608001708984375e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 6.3596702575683594e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 6.3571102142333984e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 6.3561000823974609e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 5.9612998962402344e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 5.9610603332519531e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 6.0733798980712891e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 6.0734001159667969e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 6.4527305603027344e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 6.0734100341796875e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 5.4979000091552734e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 5.4977699279785156e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 5.4975402832031250e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 5.4978401184082031e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 6.3557998657226562e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 5.4979099273681641e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 5.9610000610351562e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 5.9612503051757812e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 5.4978099822998047e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 5.4976001739501953e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 5.4973503112792969e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 4.8947898864746094e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 4.8939601898193359e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 4.8934097290039062e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 4.8932300567626953e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 4.8934600830078125e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 4.8940597534179688e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 4.8949199676513672e+01 -7.8114799499511719e+01 3.4459200501441956e-01 4.8954898834228516e+01 -7.9383300781250000e+01 6.4126296997070312e+01 6.0734100341796875e+01 -3.9661300659179688e+01 5.3850097656250000e+01 6.1509799957275391e+01 -5.2007102966308594e+01 1.2475700378417969e+01 5.4975402832031250e+01 -7.7358497619628906e+01 2.9782499313354492e+01 5.9612998962402344e+01 -7.0040397644042969e+01 4.2893001556396484e+01 6.0733798980712891e+01 -6.2013099670410156e+01 2.8395601272583008e+01 6.3558399200439453e+01 -6.6799201965332031e+01 2.7057100296020508e+01 5.4977699279785156e+01 -7.3550094604492188e+01 4.1205699920654297e+01 5.4979000091552734e+01 -6.6670997619628906e+01 5.3966102600097656e+01 5.4978401184082031e+01 -5.6843299865722656e+01 6.7513504028320312e+01 6.3559398651123047e+01 -2.6707201004028320e+01 6.4476997375488281e+01 5.4979099273681641e+01 -4.4562896728515625e+01 7.1374496459960938e+01 6.3563102722167969e+01 -1.3211199760437012e+01 7.5127197265625000e+01 5.9610000610351562e+01 -1.2114600181579590e+01 7.1428794860839844e+01 5.9612503051757812e+01 -2.6272998809814453e+01 7.2120101928710938e+01 5.4978099822998047e+01 -3.0671701431274414e+01 7.6686698913574219e+01 5.4976001739501953e+01 -1.6111700057983398e+01 1.4941699981689453e+01 4.8947898864746094e+01 -7.7977600097656250e+01 2.9704099655151367e+01 4.8939601898193359e+01 -7.3644798278808594e+01 4.1731800079345703e+01 4.8429000854492188e+01 -6.7475105285644531e+01 4.9999198913574219e+01 4.9000503540039062e+01 -6.1567001342773438e+01 5.7531902313232422e+01 4.9579898834228516e+01 -5.4633300781250000e+01 1.7856500148773193e+00 4.3026500701904297e+01 -7.8329895019531250e+01 6.6202606201171875e+01 4.9065898895263672e+01 -4.3869800567626953e+01 7.3644798278808594e+01 4.9060401916503906e+01 -2.9704099655151367e+01 7.7977600097656250e+01 4.9052101135253906e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 4.3023998260498047e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 4.3021900177001953e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 4.3020900726318359e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 4.3021598815917969e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 3.8389999389648438e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 3.8387500762939453e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 3.7265899658203125e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 3.6490200042724609e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 4.3020999908447266e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 4.3022300720214844e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 4.3024600982666016e+01 -7.7358497619628906e+01 1.2114600181579590e+01 3.8389999389648438e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 3.8391998291015625e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 3.7266197204589844e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 3.8387001037597656e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 3.8389400482177734e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 3.4440597534179688e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 3.4436901092529297e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 3.4441600799560547e+01 -6.6799201965332031e+01 5.1130599975585938e+00 3.4403301239013672e+01 -7.2644706726074219e+01 2.5049600601196289e+01 3.4442001342773438e+01 -6.8122604370117188e+01 1.6111700057983398e+01 4.3023998260498047e+01 -7.6686698913574219e+01 3.0671701431274414e+01 4.3021900177001953e+01 -7.2120101928710938e+01 4.2744701385498047e+01 4.1740497589111328e+01 -6.5250297546386719e+01 5.6843299865722656e+01 4.3021598815917969e+01 -5.3966102600097656e+01 2.6272998809814453e+01 3.8387500762939453e+01 -7.1428794860839844e+01 5.1923801422119141e+01 3.7266002655029297e+01 -5.4677501678466797e+01 3.8678096771240234e+01 3.5286399841308594e+01 -6.2656597137451172e+01 7.7358497619628906e+01 4.3024600982666016e+01 -1.2475700378417969e+01 6.6670997619628906e+01 4.3020999908447266e+01 -4.1205699920654297e+01 7.3550094604492188e+01 4.3022300720214844e+01 -2.7057100296020508e+01 6.2013099670410156e+01 3.7266197204589844e+01 -4.2893001556396484e+01 7.0040397644042969e+01 3.8387001037597656e+01 -2.9782499313354492e+01 7.4474800109863281e+01 3.8389400482177734e+01 -1.5645200729370117e+01 6.7477394104003906e+01 3.4428897857666016e+01 -2.6760299682617188e+01 7.1366401672363281e+01 3.4439002990722656e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 6.4940299987792969e+01 4.8698802947998047e+01 -6.3504100799560547e+01 6.5001693725585938e+01 2.0110498428344727e+01 -5.2329101562500000e+01 6.5869697570800781e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 6.5862602233886719e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 6.5979896545410156e+01 4.9141799926757812e+01 2.8352600097656250e+01 6.5010398864746094e+01 4.3039199829101562e+01 1.5969698905944824e+01 6.4944404602050781e+01 4.7725498199462891e+01 3.9991699218750000e+01 6.4902297973632812e+01 3.0614299774169922e+01 4.8633197784423828e+01 6.4915199279785156e+01 1.3720000267028809e+01 5.0044700622558594e+01 6.4888000488281250e+01 -5.6227302551269531e+00 3.5953800201416016e+01 6.4902297973632812e+01 -3.5078903198242188e+01 4.5476398468017578e+01 6.4954803466796875e+01 -2.1894300460815430e+01 9.9145097732543945e+00 6.4916198730468750e+01 -4.9431201934814453e+01 2.5745399475097656e+01 6.4941505432128906e+01 -4.3290298461914062e+01 4.9954399108886719e+01 3.2965801239013672e+01 5.4540300369262695e+00 4.8967998504638672e+01 3.0462301254272461e+01 1.3350299835205078e+01 5.0034500122070312e+01 3.0460399627685547e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 3.2966499328613281e+01 3.7523998260498047e+01 -4.3557899475097656e+01 3.0462099075317383e+01 2.6049699783325195e+01 -2.8130199432373047e+01 3.0460399627685547e+01 4.1621601104736328e+01 -4.9887100219726562e+01 3.0460599899291992e+01 6.8354101181030273e+00 -4.7150398254394531e+01 3.2968799591064453e+01 1.8047500610351562e+01 -4.0905799865722656e+01 3.2965702056884766e+01 2.9103500366210938e+01 -9.2679700851440430e+00 3.0461000442504883e+01 4.9685398101806641e+01 9.3136892318725586e+00 3.0461299896240234e+01 4.9535301208496094e+01 2.6869998931884766e+01 3.0461400985717773e+01 4.2637798309326172e+01 4.0471401214599609e+01 3.0460399627685547e+01 2.9807500839233398e+01 4.8870899200439453e+01 3.2967102050781250e+01 -1.3342700004577637e+01 2.4033800125122070e+01 3.2967998504638672e+01 -4.4287799835205078e+01 3.8291000366210938e+01 3.2966098785400391e+01 -3.2910102844238281e+01 4.7313400268554688e+01 3.0464601516723633e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 3.0462301254272461e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 3.0460599899291992e+01 -4.9904800415039062e+01 3.7271400451660156e+01 3.0461599349975586e+01 -3.3985900878906250e+01 2.5166799545288086e+01 3.0463001251220703e+01 -4.3544601440429688e+01 1.0624900817871094e+01 3.0461599349975586e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 3.0462200164794922e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 3.0460399627685547e+01 -2.9807500839233398e+01 1.2806200027465820e+01 1.6926700592041016e+01 -3.8097999095916748e+00 1.3205300331115723e+01 1.7732500076293945e+01 -5.5868902206420898e+00 1.3861199378967285e+01 1.7730800628662109e+01 4.1422801017761230e+00 6.8685703277587891e+00 1.7730800628662109e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 1.7569198608398438e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 1.6919498443603516e+01 1.2562399864196777e+01 6.8692898750305176e+00 1.7731899261474609e+01 1.2766799926757812e+01 -2.6745600700378418e+00 1.7732898712158203e+01 1.4119600296020508e+01 -1.0887900352478027e+01 1.6917900085449219e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 1.6926498413085938e+01 3.7914199829101562e+00 -1.3522299766540527e+01 1.7732000350952148e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 1.7731599807739258e+01 8.1145401000976562e+00 1.4918000221252441e+01 1.7724899291992188e+01 -3.5685497283935547e+01 3.7123301029205322e+00 1.7724899291992188e+01 -3.8456001281738281e+01 5.6025695800781250e+00 3.0478500366210938e+01 -3.8081703186035156e+01 1.6305999755859375e+01 3.0478500366210938e+01 -3.5007499694824219e+01 3.6341297149658203e+01 3.0478500366210938e+01 -1.3186100006103516e+01 3.0869201660156250e+01 1.7725700378417969e+01 -2.3010200500488281e+01 2.9183500289916992e+01 3.0477899551391602e+01 -2.5193401336669922e+01 2.3136499404907227e+01 1.7725700378417969e+01 -3.0677999496459961e+01 3.8549598693847656e+01 1.7724899291992188e+01 -1.6160999536514282e+00 3.7004398345947266e+01 1.7724899291992188e+01 -1.1183599472045898e+01 3.8620300292968750e+01 3.0478500366210938e+01 8.1181198358535767e-01 -4.5067396163940430e+00 3.0478500366210938e+01 -3.8375400543212891e+01 2.5930200576782227e+01 1.7724899291992188e+01 2.8557600021362305e+01 3.1677902221679688e+01 1.7725799560546875e+01 2.1873998641967773e+01 3.1033300399780273e+01 3.0476499557495117e+01 2.2732900619506836e+01 2.0160699844360352e+01 3.0476699829101562e+01 3.2750801086425781e+01 6.2813601493835449e+00 3.0478500366210938e+01 3.8171100616455078e+01 1.6532600402832031e+01 1.7724899291992188e+01 3.4899303436279297e+01 3.7707702636718750e+01 1.7724899291992188e+01 8.4654598236083984e+00 3.6223800659179688e+01 3.0478500366210938e+01 1.2949000358581543e+01 5.2079100608825684e+00 1.7724899291992188e+01 3.8213302612304688e+01 -3.4080798625946045e+00 1.7724899291992188e+01 3.8494800567626953e+01 -3.7614700317382812e+01 1.7724899291992188e+01 9.4110794067382812e+00 -1.6054100036621094e+01 1.7724899291992188e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 1.7724899291992188e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 1.7724899291992188e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 1.7725599288940430e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 1.7725000381469727e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 1.7725000381469727e+01 3.4412902832031250e+01 -3.1601600646972656e+01 1.7725799560546875e+01 2.1895799636840820e+01 -2.5230501174926758e+01 1.7725101470947266e+01 2.9101999282836914e+01 -3.3142398834228516e+01 3.0476799011230469e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 3.0477401733398438e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 3.0478500366210938e+01 6.3573803901672363e+00 -3.7880397796630859e+01 3.0478500366210938e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 3.0478500366210938e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 3.0478199005126953e+01 2.5504301071166992e+01 -1.9341501235961914e+01 3.0477001190185547e+01 3.3339103698730469e+01 -3.4695800781250000e+01 3.0478500366210938e+01 1.6600400924682617e+01 -7.6062998771667480e+00 3.0478500366210938e+01 3.7799701690673828e+01 -4.9609901428222656e+01 6.7539604187011719e+01 8.1507596969604492e+00 -4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 6.5034301757812500e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 6.7539604187011719e+01 2.2791400909423828e+01 -3.5167198181152344e+01 6.7539604187011719e+01 3.5853599548339844e+01 -4.9730598449707031e+01 6.5034301757812500e+01 6.7970499992370605e+00 2.9969398975372314e+00 6.5034301757812500e+01 5.0145702362060547e+01 6.9386696815490723e+00 6.7539604187011719e+01 4.9888397216796875e+01 4.8833702087402344e+01 6.7539604187011719e+01 1.3304400444030762e+01 4.0471401214599609e+01 6.7539604187011719e+01 2.9807500839233398e+01 4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 2.5877500534057617e+01 6.7539604187011719e+01 4.3248897552490234e+01 2.9460500717163086e+01 6.5034301757812500e+01 4.0491600036621094e+01 -1.0601699829101562e+01 6.7539604187011719e+01 4.9272800445556641e+01 -2.4852701187133789e+01 6.7539604187011719e+01 4.3484500885009766e+01 -2.9969398975372314e+00 6.5034301757812500e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 6.5034301757812500e+01 -1.7957401275634766e+01 4.3438598632812500e+01 6.7539604187011719e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 6.7539604187011719e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 6.7539604187011719e+01 -4.9272800445556641e+01 1.7176401138305664e+01 6.7539604187011719e+01 -4.7315002441406250e+01 3.1059000015258789e+01 6.7539604187011719e+01 -3.9376998901367188e+01 2.9829699993133545e+00 6.7539604187011719e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 6.7539604187011719e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 6.7539604187011719e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 1.6967199325561523e+01 1.1027499437332153e+00 1.0264200210571289e+01 6.8385604858398438e+01 2.9392998218536377e+00 1.0690099716186523e+01 5.6955596923828125e+01 0.0000000000000000e+00 8.1825199127197266e+00 6.8391502380371094e+01 6.8735299110412598e+00 5.0151400566101074e+00 6.8400596618652344e+01 9.4172601699829102e+00 -6.3304600715637207e+00 6.8557899475097656e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 6.8545295715332031e+01 1.2124200820922852e+01 -1.3189299583435059e+01 6.8547706604003906e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 6.8542694091796875e+01 6.2997603416442871e+00 6.3305301666259766e+00 6.8557899475097656e+01 1.2118599891662598e+01 1.3189299583435059e+01 6.8547706604003906e+01 2.1639201641082764e+00 1.2706499099731445e+01 6.7540802001953125e+01 -6.5114102363586426e+00 3.8211998939514160e+00 6.7540100097656250e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 6.7541503906250000e+01 1.4018300056457520e+01 8.3117198944091797e+00 6.7541999816894531e+01 1.1874300003051758e+01 1.4127900123596191e+01 6.7540000915527344e+01 3.0538599491119385e+00 -1.2706499099731445e+01 6.7540802001953125e+01 6.5114398002624512e+00 -8.3115901947021484e+00 6.7541999816894531e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 6.7540802001953125e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fl_caster_r_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fl_caster_rotation_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 2.2459999999999999e+02 2.2459999999999999e+02 2.8199999999999999e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 162 0 2 1 0 151 0 162 151 1 151 152 1 152 215 1 284 2 1 215 284 151 223 152 151 162 223 2 299 162 162 299 223 274 299 2 150 299 274 299 150 223 2 273 274 274 351 148 150 274 148 289 351 274 273 289 274 168 148 351 288 351 289 351 166 168 166 351 288 288 289 175 273 175 289 177 167 288 288 175 177 166 288 167 166 167 168 167 311 168 235 234 167 234 380 167 454 167 380 235 167 177 311 167 454 453 311 454 182 311 453 168 311 182 453 454 451 454 380 451 159 182 453 451 159 453 451 160 159 160 451 380 159 160 161 181 182 159 214 181 159 214 159 161 161 160 380 440 214 161 161 380 440 347 158 214 214 440 347 158 181 214 181 339 47 181 47 182 158 339 181 37 158 134 134 158 347 158 37 339 476 47 339 476 339 37 72 476 36 68 476 427 476 68 47 72 427 476 476 37 36 36 37 38 70 72 36 91 36 38 91 70 36 38 37 368 23 38 368 91 38 287 287 38 23 91 86 70 91 195 86 91 287 195 86 87 70 498 87 86 195 498 86 35 195 287 35 318 195 498 195 497 195 318 497 498 497 418 498 418 87 418 331 87 87 331 70 331 90 71 331 426 90 418 426 331 70 331 71 70 71 72 72 71 82 71 412 82 71 90 412 72 82 414 414 427 72 82 329 414 412 329 82 412 413 329 90 89 412 412 89 413 328 329 142 328 191 329 191 414 329 329 413 142 190 414 191 190 427 414 190 68 427 189 190 191 189 69 190 69 68 190 205 191 328 189 191 205 141 328 142 141 205 328 204 189 205 216 218 205 212 216 205 218 204 205 212 205 141 189 204 499 499 69 189 499 204 42 499 42 452 499 452 69 42 43 44 201 42 202 42 44 202 452 42 201 204 43 42 43 330 44 43 327 344 43 344 330 204 327 43 44 330 325 44 325 202 324 202 325 202 324 201 452 201 324 45 452 46 45 69 452 452 324 341 341 46 452 45 46 47 45 68 69 68 45 47 182 47 46 341 182 46 340 148 341 341 365 182 148 365 341 341 324 340 182 365 168 168 365 148 148 149 150 149 148 340 324 149 340 324 333 149 333 81 149 150 149 81 223 150 224 150 81 224 79 80 81 333 75 81 80 224 81 75 79 81 222 223 224 222 224 80 429 80 428 80 79 428 222 80 429 74 97 79 74 79 75 97 428 79 73 74 75 73 75 333 73 420 74 420 496 74 74 496 97 495 494 73 495 73 333 494 420 73 324 495 333 325 494 495 324 325 495 330 420 494 325 330 494 330 416 420 330 344 416 344 415 416 416 415 420 420 415 496 415 423 95 496 415 95 344 423 415 344 217 345 345 423 344 327 217 344 320 95 423 321 320 423 345 321 423 95 96 97 96 95 320 496 95 97 320 321 96 217 321 345 321 17 96 321 217 17 17 16 96 96 16 97 97 16 326 326 428 97 15 16 17 16 15 326 17 131 15 17 217 213 17 213 131 15 131 52 15 52 245 15 245 286 15 286 326 213 52 131 51 35 52 52 35 34 213 51 52 245 52 34 318 51 319 51 88 319 213 88 51 51 318 35 497 318 418 318 319 418 319 417 418 417 319 88 418 417 426 426 417 90 90 417 88 88 89 90 78 413 89 89 88 76 78 89 76 76 77 78 142 413 78 142 78 77 88 77 76 141 142 77 212 141 77 77 88 212 212 88 213 213 216 212 213 217 216 216 217 218 218 217 327 204 218 327 33 34 35 35 66 67 35 203 66 35 287 203 35 364 33 67 411 35 411 364 35 245 34 314 34 33 314 244 245 101 286 245 223 405 245 314 101 245 405 244 223 245 405 314 33 405 409 402 102 101 405 409 405 33 102 405 402 33 111 110 33 110 409 364 315 33 33 315 111 402 409 110 401 402 110 493 102 402 493 402 401 110 111 112 112 401 110 112 462 401 462 493 401 322 493 197 462 197 493 322 102 493 462 112 332 58 60 462 58 462 332 60 197 462 111 332 112 111 58 332 58 59 60 315 58 111 315 59 58 61 59 62 62 59 30 59 364 30 59 315 364 59 61 477 60 59 477 477 61 92 61 62 92 92 62 32 62 30 32 30 31 32 364 31 30 364 411 31 411 178 31 32 31 178 92 32 93 32 178 93 92 93 94 477 92 421 421 92 94 313 94 93 93 178 180 93 180 313 178 179 180 411 67 178 178 67 179 180 179 83 410 180 85 180 83 85 313 180 410 313 410 342 94 313 342 410 99 342 99 410 85 83 84 85 98 99 85 84 432 85 432 98 85 179 66 83 66 84 83 430 431 84 430 84 66 431 432 84 419 432 431 419 98 432 419 200 98 98 343 99 200 343 98 342 99 343 200 129 343 342 343 278 343 129 278 198 199 200 129 200 199 198 200 419 198 419 431 198 431 375 375 431 430 198 129 199 287 198 375 129 198 287 287 375 203 203 375 430 465 355 287 287 130 129 22 465 287 23 22 287 355 130 287 128 129 130 130 355 308 130 308 307 130 307 128 128 479 129 278 129 479 468 126 479 479 126 278 337 468 479 337 479 128 121 278 126 232 342 278 121 280 278 280 232 278 408 342 232 408 94 342 408 422 94 317 408 316 317 422 408 316 408 232 421 94 422 317 421 422 316 60 317 317 60 477 317 477 421 60 196 197 196 60 316 196 323 197 196 298 323 196 348 298 196 316 348 197 323 322 322 323 11 298 11 323 9 11 298 9 298 348 316 9 348 9 10 11 9 316 10 304 11 53 322 11 304 11 54 53 10 54 11 304 102 322 304 53 100 102 304 100 53 54 55 100 53 55 171 140 54 54 139 55 54 140 139 171 54 10 424 55 425 424 100 55 267 425 55 139 267 55 100 101 102 424 101 100 425 244 424 244 101 424 244 425 223 223 425 461 425 267 461 286 223 222 223 461 239 223 239 271 271 458 223 223 458 152 461 267 266 461 266 239 144 238 239 238 271 239 144 239 266 265 266 267 145 266 265 266 145 144 279 265 267 145 265 279 267 369 104 267 104 279 267 139 369 279 104 173 145 279 173 103 172 173 103 173 104 173 172 366 366 145 173 64 103 104 172 103 64 172 64 63 172 357 367 172 63 357 366 172 367 366 367 145 483 143 367 357 475 367 483 367 448 143 145 367 448 367 475 143 144 145 482 395 143 482 143 483 395 144 143 448 125 483 483 125 482 443 482 125 482 443 395 144 395 396 443 396 395 358 238 144 358 144 450 144 396 450 396 480 450 396 481 480 443 481 396 485 450 277 450 480 277 358 450 350 450 485 350 334 238 358 358 350 334 271 238 272 238 334 272 485 458 271 350 485 271 406 271 272 271 406 350 485 379 458 379 485 277 379 152 458 283 215 379 215 152 379 283 379 277 215 283 284 247 283 208 208 283 277 284 283 247 285 284 247 2 284 285 2 285 273 273 285 439 439 285 247 176 273 439 175 273 176 176 439 177 177 439 247 175 176 177 246 398 177 246 177 247 253 235 177 398 253 177 208 246 247 399 398 246 208 399 246 188 398 399 188 253 398 399 436 472 207 436 399 399 472 188 208 207 399 206 207 208 277 206 208 480 481 206 481 207 206 480 206 277 481 256 207 443 256 481 256 257 207 185 186 256 257 256 209 256 186 209 443 185 256 443 124 185 443 125 124 185 124 186 209 186 13 186 124 264 13 186 264 39 209 13 209 484 257 39 484 209 484 39 257 39 40 41 39 41 194 194 257 39 39 13 12 39 187 40 39 270 187 12 270 39 436 194 41 41 40 436 207 194 436 194 207 257 40 472 436 188 472 40 40 187 188 253 188 254 254 188 292 187 292 188 292 187 270 292 270 260 254 292 260 260 253 254 269 253 260 253 233 235 253 269 233 269 260 270 270 133 269 306 233 269 433 269 491 269 133 491 269 433 306 233 234 235 233 380 234 233 306 380 226 157 380 440 380 157 306 226 380 8 225 226 225 157 226 8 226 306 6 7 8 306 6 8 8 7 225 7 155 225 157 225 155 388 7 6 388 155 7 388 6 27 388 27 394 388 464 155 388 394 464 25 26 27 27 6 132 132 25 27 394 27 26 394 389 464 138 394 26 389 394 138 464 487 488 464 488 155 389 487 464 487 349 488 487 478 349 389 478 487 349 155 488 155 156 157 391 156 155 349 392 155 391 155 392 377 378 156 346 377 156 156 378 157 156 391 346 157 378 393 440 157 393 377 374 378 374 393 378 393 347 440 374 347 393 374 134 347 377 134 374 134 135 56 134 377 135 134 56 37 57 135 305 135 377 305 56 135 57 37 56 57 57 368 37 305 108 57 57 108 109 109 368 57 108 305 346 346 305 377 108 21 109 346 391 108 21 108 391 368 109 21 21 23 368 21 22 23 21 391 392 21 392 349 349 22 21 465 22 349 349 249 248 459 349 248 465 349 459 478 249 349 459 105 465 220 355 465 105 220 465 459 474 105 248 474 459 105 106 107 105 255 106 105 107 220 105 474 255 255 474 355 355 474 308 308 474 248 354 255 355 355 220 354 106 255 354 220 221 354 221 106 354 220 165 221 49 106 221 165 164 221 164 49 221 48 49 50 49 437 106 363 437 49 49 48 363 50 49 164 48 192 193 48 193 363 48 50 192 50 164 192 193 192 164 363 193 445 445 193 164 444 363 445 363 444 437 438 445 164 444 445 438 437 444 438 437 438 275 164 275 438 258 275 211 164 211 275 258 437 275 258 211 259 259 437 258 163 210 211 163 211 164 210 259 211 163 164 165 489 210 163 489 163 165 210 489 437 259 210 437 106 437 489 106 489 243 243 489 165 107 165 220 107 243 165 107 106 243 117 248 249 404 449 248 449 252 248 117 404 248 252 308 248 478 400 249 400 117 249 389 400 478 117 400 4 389 4 400 4 389 390 138 390 389 227 390 137 390 138 137 4 390 227 136 137 138 26 136 138 137 133 268 268 227 137 137 136 26 133 137 26 227 228 229 268 228 227 4 227 229 133 228 268 115 312 228 4 229 228 133 115 228 312 4 228 5 4 312 115 5 312 3 4 5 117 4 3 116 3 5 5 115 116 116 117 3 117 116 404 116 403 404 114 116 115 116 114 403 404 386 449 404 403 386 403 236 386 114 263 403 403 263 236 113 114 115 370 114 113 114 370 263 113 12 370 12 113 115 12 115 133 12 13 14 12 469 470 12 14 469 470 370 12 12 133 270 470 263 370 261 470 469 470 261 263 469 231 261 231 469 14 261 262 263 261 231 301 397 261 301 397 262 261 14 230 231 231 300 301 231 230 300 301 300 441 397 301 295 441 295 301 397 295 372 397 372 466 262 397 466 466 372 237 466 237 407 407 262 466 236 407 237 263 407 236 262 407 263 120 236 237 353 386 236 120 119 236 236 119 353 118 119 120 120 219 118 237 219 120 352 353 119 118 352 119 310 353 352 353 310 387 353 387 386 121 123 352 310 352 123 121 352 118 276 118 219 121 118 276 276 219 383 237 383 219 276 184 232 232 280 276 184 276 383 121 276 280 121 122 123 126 122 121 126 127 122 122 127 123 468 467 126 126 467 127 127 467 468 123 127 337 127 468 337 251 337 128 251 376 337 337 376 123 250 251 252 376 251 250 252 251 490 490 251 128 307 490 128 307 252 490 307 308 252 449 386 252 250 252 386 386 387 250 387 309 250 309 376 250 310 309 387 123 309 310 123 376 309 184 383 169 383 384 169 457 383 237 384 383 457 183 184 169 184 183 232 169 10 183 232 183 316 10 316 183 171 10 169 169 170 171 171 170 140 170 169 359 140 170 64 64 170 146 359 147 170 170 147 146 104 139 140 140 64 104 63 64 65 65 64 146 146 147 65 63 65 357 65 147 357 356 357 147 382 475 357 356 382 357 381 382 356 297 356 371 381 356 297 371 356 147 471 475 382 471 382 381 475 471 448 381 296 471 296 448 471 296 381 297 295 296 297 295 297 371 295 371 372 372 371 147 295 441 442 295 442 296 300 230 441 441 230 442 230 373 442 296 442 373 14 373 230 373 29 296 373 14 29 14 28 29 13 240 14 447 446 14 240 447 14 28 14 446 29 28 460 460 296 29 446 460 28 446 447 448 446 448 460 240 242 447 448 447 242 240 241 242 241 240 13 448 242 125 125 242 241 448 296 460 241 13 125 124 125 13 13 264 124 147 455 372 147 359 455 455 359 456 455 457 372 455 456 457 457 237 372 384 457 456 359 384 456 359 169 384 104 369 139 132 133 25 133 281 282 133 434 433 133 282 434 491 133 433 281 133 132 25 133 26 281 302 303 282 281 303 302 281 132 434 282 435 303 435 282 433 434 435 433 435 306 306 435 303 6 303 302 6 306 303 132 6 302 350 335 334 406 335 350 334 335 336 335 338 336 335 406 154 338 335 154 291 334 293 291 272 334 334 336 293 290 154 291 293 290 291 406 272 291 154 406 291 501 290 293 154 290 501 154 501 473 473 501 293 154 473 385 473 293 385 385 153 154 385 293 492 153 385 492 153 18 154 294 153 492 153 294 18 492 293 294 293 19 294 294 19 18 18 19 20 362 18 20 18 362 154 20 19 24 19 174 24 19 293 174 486 362 20 486 20 24 486 24 174 174 463 486 463 362 486 174 293 336 500 174 361 174 336 361 500 463 174 463 360 362 500 360 463 360 500 361 360 361 362 362 361 336 362 336 338 362 338 154 429 286 222 326 286 429 326 429 428 203 430 66 67 66 179))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-2.9610601806640625e+02 -2.8678799438476562e+02 1.0526599884033203e+02 -2.8170498657226562e+02 -2.8678799438476562e+02 1.0526599884033203e+02 -2.9957000732421875e+02 -2.8165600585937500e+02 1.0526599884033203e+02 -1.9148600769042969e+02 -1.5725999450683594e+02 1.3304998779296875e+02 -2.0424600219726562e+02 -1.5231401062011719e+02 1.3304998779296875e+02 -1.9030799865722656e+02 -1.5772599792480469e+02 1.3955000305175781e+02 -2.7653198242187500e+02 -1.7026600646972656e+02 1.3304998779296875e+02 -2.6645700073242188e+02 -1.9238999938964844e+02 1.3304998779296875e+02 -2.7244699096679688e+02 -2.0243699645996094e+02 1.3304998779296875e+02 -1.5055300903320312e+02 -2.3860499572753906e+02 1.0230000305175781e+02 -1.3250199890136719e+02 -2.4011799621582031e+02 1.0230000305175781e+02 -1.5143299865722656e+02 -2.4332800292968750e+02 1.0230000305175781e+02 -1.6115499877929688e+02 -1.8449600219726562e+02 1.3955000305175781e+02 -2.0617799377441406e+02 -2.9742898559570312e+02 1.3955000305175781e+02 -1.6957699584960938e+02 -2.7573800659179688e+02 1.3955000305175781e+02 -3.0362298583984375e+02 -2.5060800170898438e+02 -1.6409799575805664e+01 -3.0671200561523438e+02 -2.5027900695800781e+02 -2.7892499923706055e+01 -3.0677600097656250e+02 -2.5025099182128906e+02 -5.9969299316406250e+01 -2.1749700927734375e+02 -3.0809997558593750e+02 -5.4909603118896484e+01 -2.2026200866699219e+02 -3.1110000610351562e+02 -5.5569801330566406e+01 -2.2877598571777344e+02 -3.0809997558593750e+02 -5.5612400054931641e+01 -2.6262701416015625e+02 -1.5891499328613281e+02 1.0230000305175781e+02 -2.5209999084472656e+02 -1.5458999633789062e+02 1.0230000305175781e+02 -2.5346099853515625e+02 -1.6975000000000000e+02 1.0230000305175781e+02 -2.3203698730468750e+02 -3.1110000610351562e+02 -5.4838798522949219e+01 -2.6524499511718750e+02 -1.6153399658203125e+02 1.3955000305175781e+02 -2.5610598754882812e+02 -1.5641400146484375e+02 1.3955000305175781e+02 -2.6561099243164062e+02 -1.6171499633789062e+02 1.3304998779296875e+02 -1.6203199768066406e+02 -2.6609997558593750e+02 1.3955000305175781e+02 -1.5683500671386719e+02 -2.5684197998046875e+02 1.3955000305175781e+02 -1.5055300903320312e+02 -2.1059500122070312e+02 -4.3196701049804688e+01 -1.5075000000000000e+02 -2.0828900146484375e+02 -5.8984100341796875e+01 -1.5084399414062500e+02 -2.0765798950195312e+02 -9.5243206024169922e+00 -1.5820599365234375e+02 -2.4985200500488281e+02 -5.9969898223876953e+01 -1.6255299377441406e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 -1.6255299377441406e+02 -1.9859500122070312e+02 -5.9969802856445312e+01 -3.0808898925781250e+02 -1.9941101074218750e+02 1.0230100250244141e+02 -3.0663800048828125e+02 -1.7952099609375000e+02 1.0230000305175781e+02 -3.0362298583984375e+02 -1.9859500122070312e+02 1.0230000305175781e+02 -2.5811199951171875e+02 -2.9180200195312500e+02 1.3955000305175781e+02 -2.8411599731445312e+02 -2.7040798950195312e+02 1.3955000305175781e+02 -2.7223699951171875e+02 -2.8273098754882812e+02 1.3955000305175781e+02 -3.1521697998046875e+02 -2.4170899963378906e+02 5.7514900207519531e+01 -3.1521697998046875e+02 -2.4170899963378906e+02 1.3412400245666504e+01 -3.1471301269531250e+02 -2.4319400024414062e+02 3.6914199829101562e+01 -3.1562298583984375e+02 -2.1059500122070312e+02 1.0230000305175781e+02 -3.1783898925781250e+02 -2.1862699890136719e+02 1.0230000305175781e+02 -3.1595700073242188e+02 -2.0552900695800781e+02 1.0230000305175781e+02 -2.0511000061035156e+02 -1.3809999084472656e+02 -4.7562698364257812e+01 -1.9710000610351562e+02 -1.3809999084472656e+02 -2.8200000762939453e+01 -1.9875698852539062e+02 -1.3809899902343750e+02 -3.8267398834228516e+01 -3.0362298583984375e+02 -1.9859500122070312e+02 -5.9969802856445312e+01 -2.4274200439453125e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 -1.5428100585937500e+02 -2.4729399108886719e+02 1.0230000305175781e+02 -1.3655400085449219e+02 -2.5572999572753906e+02 1.0230000305175781e+02 -1.5766600036621094e+02 -2.4962500000000000e+02 1.0230000305175781e+02 -2.9610601806640625e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -2.7435101318359375e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -1.5053201293945312e+02 -2.3860600280761719e+02 -2.7142898559570312e+01 -1.5055300903320312e+02 -2.2679800415039062e+02 -1.8764699935913086e+01 -1.5055300903320312e+02 -2.3860499572753906e+02 4.0985599517822266e+01 -1.5055300903320312e+02 -2.1059500122070312e+02 8.0976800918579102e+00 -1.5055300903320312e+02 -2.1059500122070312e+02 -1.5550399780273438e+01 -1.6230599975585938e+02 -2.6575698852539062e+02 1.2900000000000000e+02 -1.6085598754882812e+02 -2.6370498657226562e+02 1.0526499938964844e+02 -1.5843800354003906e+02 -2.5917398071289062e+02 1.2900000000000000e+02 -1.5869000244140625e+02 -1.9920599365234375e+02 -3.7053100585937500e+01 -1.5664898681640625e+02 -2.0005700683593750e+02 -5.9970798492431641e+01 -3.1534698486328125e+02 -2.0815499877929688e+02 1.0230000305175781e+02 -3.1562298583984375e+02 -2.1059500122070312e+02 9.6058898925781250e+01 -3.0834201049804688e+02 -1.9949099731445312e+02 7.5261901855468750e+01 -3.1030599975585938e+02 -2.0059500122070312e+02 3.5743999481201172e+01 -3.1203201293945312e+02 -2.0194900512695312e+02 1.0056999969482422e+02 -3.1211199951171875e+02 -2.4708999633789062e+02 6.0708602905273438e+01 -3.1093099975585938e+02 -2.4812600708007812e+02 3.2135898590087891e+01 -3.1093099975585938e+02 -2.4812600708007812e+02 7.9724601745605469e+01 -3.1213500976562500e+02 -2.0214300537109375e+02 -5.9969802856445312e+01 -3.1411499023437500e+02 -2.0466500854492188e+02 -5.9969898223876953e+01 -3.1314797973632812e+02 -2.0329199218750000e+02 -2.9373600006103516e+01 -3.0962399291992188e+02 -2.4899899291992188e+02 5.0942001342773438e+01 -3.0821600341796875e+02 -2.4969300842285156e+02 7.8505599975585938e+01 -3.0962197875976562e+02 -2.4899800109863281e+02 1.0230000305175781e+02 -3.1295599365234375e+02 -2.0303300476074219e+02 5.2590198516845703e+01 -1.5655801391601562e+02 -2.0019799804687500e+02 -2.3319999694824219e+01 -1.5796501159667969e+02 -1.9950500488281250e+02 6.6349101066589355e+00 -1.5655801391601562e+02 -2.0019799804687500e+02 3.0526800155639648e+01 -3.0519000244140625e+02 -1.9869599914550781e+02 5.8514400482177734e+01 -3.0672900390625000e+02 -1.9900199890136719e+02 4.6641597747802734e+01 -3.0980300903320312e+02 -2.0022900390625000e+02 -5.9969802856445312e+01 -3.1211199951171875e+02 -2.0211000061035156e+02 -1.3356300354003906e+01 -3.1024398803710938e+02 -2.0055499267578125e+02 -1.2914799690246582e+01 -3.0362298583984375e+02 -1.9859500122070312e+02 7.6262695312500000e+01 -1.5075799560546875e+02 -2.0824700927734375e+02 4.4407596588134766e+00 -1.5177699279785156e+02 -2.0525500488281250e+02 1.1596100807189941e+01 -1.5141299438476562e+02 -2.0599200439453125e+02 6.4847000122070312e+01 -3.1093099975585938e+02 -2.4812600708007812e+02 -2.5375299453735352e+01 -3.0962399291992188e+02 -2.4899899291992188e+02 -5.3728698730468750e+01 -3.0962399291992188e+02 -2.4899899291992188e+02 2.4416298866271973e+00 -1.5796501159667969e+02 -1.9950500488281250e+02 4.8518898010253906e+01 -1.5655801391601562e+02 -2.0019799804687500e+02 7.6920997619628906e+01 -1.5639999389648438e+02 -2.4899398803710938e+02 9.9975700378417969e+01 -1.5977099609375000e+02 -2.5033700561523438e+02 4.1235500335693359e+01 -1.5540400695800781e+02 -2.4830200195312500e+02 3.2989101409912109e+01 -1.6803201293945312e+02 -2.7345401000976562e+02 1.0526599884033203e+02 -1.5309399414062500e+02 -2.8678799438476562e+02 1.0526599884033203e+02 -2.5209999084472656e+02 -1.3809999084472656e+02 7.0520500183105469e+01 -1.9710000610351562e+02 -1.3809999084472656e+02 4.0198602676391602e+00 -2.5209999084472656e+02 -1.3809999084472656e+02 -4.4480600357055664e+00 -2.6891198730468750e+02 -1.6241200256347656e+02 1.0526599884033203e+02 -2.6891198730468750e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -1.5382600402832031e+02 -2.4685899353027344e+02 -5.9969699859619141e+01 -1.5095500183105469e+02 -2.4205599975585938e+02 -5.9969200134277344e+01 -1.5208799743652344e+02 -2.4459999084472656e+02 -5.9332698822021484e+01 -1.6750199890136719e+02 -1.7591198730468750e+02 1.3955000305175781e+02 -1.7311500549316406e+02 -1.6997300720214844e+02 1.3304998779296875e+02 -1.7670899963378906e+02 -1.6669799804687500e+02 1.3955000305175781e+02 -1.8156098937988281e+02 -1.6309001159667969e+02 1.3304998779296875e+02 -2.1498901367187500e+02 -1.7264300537109375e+02 1.3304998779296875e+02 -1.5454701232910156e+02 -1.9881900024414062e+02 1.0526599884033203e+02 -1.5612800598144531e+02 -1.9487699890136719e+02 1.2900000000000000e+02 -1.5271000671386719e+02 -2.0441099548339844e+02 1.2900000000000000e+02 -1.4316000366210938e+02 -1.7843400573730469e+02 1.0526499938964844e+02 -1.4961401367187500e+02 -1.6756999206542969e+02 1.0526599884033203e+02 -1.5875900268554688e+02 -1.7463000488281250e+02 1.0526599884033203e+02 -2.1654499816894531e+02 -2.9920300292968750e+02 1.3304998779296875e+02 -2.0335699462890625e+02 -2.9663000488281250e+02 1.3304998779296875e+02 -1.4881800842285156e+02 -1.6870899963378906e+02 1.0230000305175781e+02 -1.5309399414062500e+02 -1.6241200256347656e+02 1.0526599884033203e+02 -1.8772200012207031e+02 -1.5966198730468750e+02 1.0230000305175781e+02 -1.6255299377441406e+02 -1.9859500122070312e+02 1.0230000305175781e+02 -1.9710000610351562e+02 -1.5523699951171875e+02 1.0230000305175781e+02 -3.0362298583984375e+02 -2.5060498046875000e+02 -5.9969802856445312e+01 -2.7349002075195312e+02 -1.6766999816894531e+02 1.3955000305175781e+02 -2.9932202148437500e+02 -2.1699699401855469e+02 1.3955000305175781e+02 -3.0311700439453125e+02 -1.7312001037597656e+02 1.0526599884033203e+02 -2.9610601806640625e+02 -1.6241200256347656e+02 1.0526599884033203e+02 -2.4590699768066406e+02 -1.5263700866699219e+02 1.3955000305175781e+02 -2.3481401062011719e+02 -1.5020799255371094e+02 1.3955000305175781e+02 -2.4586599731445312e+02 -1.5257400512695312e+02 1.3304998779296875e+02 -1.4590400695800781e+02 -2.7587701416015625e+02 1.0230000305175781e+02 -1.4330500793457031e+02 -2.7118899536132812e+02 1.0526499938964844e+02 -3.1524398803710938e+02 -2.0738500976562500e+02 -5.7594200134277344e+01 -3.1402001953125000e+02 -2.0459899902343750e+02 -1.8744100570678711e+01 -2.1017100524902344e+02 -2.7551699829101562e+02 1.2900000000000000e+02 -1.9710000610351562e+02 -2.9396298217773438e+02 1.2900000000000000e+02 -1.8280699157714844e+02 -2.8657400512695312e+02 1.2900000000000000e+02 -1.5651400756835938e+02 -2.5514900207519531e+02 1.0615900421142578e+02 -1.5415899658203125e+02 -2.4939500427246094e+02 1.2900000000000000e+02 -3.1419400024414062e+02 -2.5077700805664062e+02 1.0526599884033203e+02 -3.1442498779296875e+02 -2.4980099487304688e+02 1.0230000305175781e+02 -3.1000201416015625e+02 -2.6235101318359375e+02 1.0230000305175781e+02 -2.9066699218750000e+02 -2.8678799438476562e+02 1.0230000305175781e+02 -2.6891198730468750e+02 -2.8678799438476562e+02 1.0230000305175781e+02 -2.0844100952148438e+02 -3.0809997558593750e+02 -5.0521602630615234e+01 -1.9710000610351562e+02 -3.0809997558593750e+02 -2.8200000762939453e+01 -2.5895898437500000e+02 -1.8453900146484375e+02 1.2900000000000000e+02 -2.8238897705078125e+02 -1.7186300659179688e+02 1.2900000000000000e+02 -2.8169900512695312e+02 -1.9886000061035156e+02 1.2900000000000000e+02 -3.0943798828125000e+02 -1.8562600708007812e+02 1.0526499938964844e+02 -3.0997698974609375e+02 -2.1037899780273438e+02 1.0526599884033203e+02 -3.1004901123046875e+02 -2.1066899108886719e+02 1.2900000000000000e+02 -3.0663699340820312e+02 -2.0203700256347656e+02 1.2900000000000000e+02 -2.9610601806640625e+02 -2.8678799438476562e+02 1.0230000305175781e+02 -2.5073400878906250e+02 -1.4110099792480469e+02 -3.7242900848388672e+01 -1.9777500915527344e+02 -1.4110000610351562e+02 -3.5301700592041016e+01 -2.5209999084472656e+02 -1.4110000610351562e+02 -2.8200000762939453e+01 -3.1046701049804688e+02 -2.3700300598144531e+02 1.2900000000000000e+02 -3.1185598754882812e+02 -2.3003601074218750e+02 1.2900000000000000e+02 -3.1093298339843750e+02 -2.3524501037597656e+02 1.0526599884033203e+02 -1.3137599182128906e+02 -2.3255400085449219e+02 1.0526599884033203e+02 -1.5407901000976562e+02 -2.4906698608398438e+02 1.0526499938964844e+02 -1.3517298889160156e+02 -2.5151602172851562e+02 1.0526599884033203e+02 -1.6783300781250000e+02 -2.7329699707031250e+02 1.2900000000000000e+02 -1.7631399536132812e+02 -2.8176199340820312e+02 1.0526599884033203e+02 -2.4075900268554688e+02 -3.1110000610351562e+02 -5.0521602630615234e+01 -2.9820098876953125e+02 -2.6083499145507812e+02 1.2900000000000000e+02 -2.9353100585937500e+02 -2.6645401000976562e+02 1.2900000000000000e+02 -2.7357400512695312e+02 -2.4422299194335938e+02 1.2900000000000000e+02 -1.5216299438476562e+02 -2.0445999145507812e+02 -5.6779602050781250e+01 -1.5501699829101562e+02 -2.0116600036621094e+02 -5.5256900787353516e+01 -1.5429901123046875e+02 -2.0181900024414062e+02 -5.0245699882507324e+00 -3.1393600463867188e+02 -1.9760600280761719e+02 1.0526599884033203e+02 -3.1788598632812500e+02 -2.1692399597167969e+02 1.0526499938964844e+02 -1.3104901123046875e+02 -2.2218499755859375e+02 1.0230000305175781e+02 -1.3155999755859375e+02 -2.1607899475097656e+02 1.0526499938964844e+02 -2.2460000610351562e+02 -2.9960000610351562e+02 1.3304998779296875e+02 -2.2460000610351562e+02 -2.9960000610351562e+02 1.3955000305175781e+02 -2.9144998168945312e+02 -2.5875000000000000e+02 1.3955000305175781e+02 -2.9141198730468750e+02 -2.5906500244140625e+02 1.3304998779296875e+02 -3.1562298583984375e+02 -2.1059500122070312e+02 3.6371799468994141e+01 -3.1542001342773438e+02 -2.0825100708007812e+02 6.8863502502441406e+01 -3.1523599243164062e+02 -2.0736700439453125e+02 2.6833299636840820e+01 -2.0251600646972656e+02 -1.4110000610351562e+02 -4.4711601257324219e+01 -2.1015399169921875e+02 -1.4110000610351562e+02 -5.1552700042724609e+01 -2.6275799560546875e+02 -2.8926501464843750e+02 1.3304998779296875e+02 -3.0362298583984375e+02 -1.9859500122070312e+02 3.4281200408935547e+01 -1.5055300903320312e+02 -2.3860499572753906e+02 7.4117301940917969e+01 -1.5137800598144531e+02 -2.4319599914550781e+02 3.4616500854492188e+01 -1.6255299377441406e+02 -1.9859500122070312e+02 4.6495399475097656e+01 -1.6098800659179688e+02 -1.9869599914550781e+02 7.6994102478027344e+01 -1.5944999694824219e+02 -1.9900099182128906e+02 7.7262298583984375e+01 -3.1521697998046875e+02 -2.4170899963378906e+02 1.0073999786376953e+02 -3.1471301269531250e+02 -2.4319400024414062e+02 7.5190002441406250e+01 -1.6255299377441406e+02 -1.9859500122070312e+02 -1.6379301071166992e+01 -3.1562298583984375e+02 -2.3860499572753906e+02 1.6008800506591797e+01 -3.1562799072265625e+02 -2.1059500122070312e+02 -1.9097600936889648e+01 -2.5163099670410156e+02 -2.6990899658203125e+02 1.2900000000000000e+02 -2.5519898986816406e+02 -2.6754000854492188e+02 1.3304998779296875e+02 -2.6125100708007812e+02 -2.6259698486328125e+02 1.2900000000000000e+02 -2.3366099548339844e+02 -2.9913101196289062e+02 1.3955000305175781e+02 -2.4925900268554688e+02 -1.3809999084472656e+02 -4.0683502197265625e+01 -2.4354598999023438e+02 -1.4110099792480469e+02 -4.8183097839355469e+01 -3.1562298583984375e+02 -2.1059500122070312e+02 -5.9969802856445312e+01 -2.9996499633789062e+02 -2.2532499694824219e+02 -5.9969802856445312e+01 -3.0592599487304688e+02 -2.0052400207519531e+02 1.0526499938964844e+02 -2.6891198730468750e+02 -2.8678799438476562e+02 1.0526599884033203e+02 -3.1562298583984375e+02 -2.3860499572753906e+02 -5.9969802856445312e+01 -3.1479098510742188e+02 -2.4332398986816406e+02 -5.9969997406005859e+01 -3.1562298583984375e+02 -2.3860499572753906e+02 -3.5175899505615234e+01 -1.5175999450683594e+02 -2.0791200256347656e+02 1.0526599884033203e+02 -2.5209999084472656e+02 -1.4110000610351562e+02 3.3263198852539062e+01 -1.9710000610351562e+02 -1.4110000610351562e+02 -2.8200000762939453e+01 -3.0601098632812500e+02 -2.5039300537109375e+02 1.0037599945068359e+02 -3.0362298583984375e+02 -2.5060498046875000e+02 1.0230000305175781e+02 -3.0821099853515625e+02 -2.4969099426269531e+02 1.0230000305175781e+02 -2.6879000854492188e+02 -1.9582598876953125e+02 1.2900000000000000e+02 -2.7441201782226562e+02 -2.0738500976562500e+02 1.2900000000000000e+02 -2.2460000610351562e+02 -1.4960000610351562e+02 1.3304998779296875e+02 -2.1309899902343750e+02 -1.5035900878906250e+02 1.3955000305175781e+02 -2.1626499938964844e+02 -1.4997799682617188e+02 1.3304998779296875e+02 -1.5050299072265625e+02 -2.3633200073242188e+02 1.3955000305175781e+02 -1.5012399291992188e+02 -2.1499099731445312e+02 1.3955000305175781e+02 -1.3430300903320312e+02 -2.0074899291992188e+02 1.0230000305175781e+02 -2.7736898803710938e+02 -2.2582901000976562e+02 1.3304998779296875e+02 -2.7736801147460938e+02 -2.2460000610351562e+02 1.2900000000000000e+02 -2.7655999755859375e+02 -2.3378300476074219e+02 1.2900000000000000e+02 -1.8314999389648438e+02 -1.9209399414062500e+02 1.2900000000000000e+02 -1.5058700561523438e+02 -2.1417799377441406e+02 1.2900000000000000e+02 -1.9710000610351562e+02 -3.1110000610351562e+02 1.2900000000000000e+02 -1.9710000610351562e+02 -2.9396298217773438e+02 1.0230000305175781e+02 -1.7880000305175781e+02 -2.8405801391601562e+02 1.3955000305175781e+02 -1.9108900451660156e+02 -2.9184100341796875e+02 1.3955000305175781e+02 -1.8882699584960938e+02 -2.9061700439453125e+02 1.3304998779296875e+02 -2.5209999084472656e+02 -1.3809999084472656e+02 -2.8200000762939453e+01 -1.6255299377441406e+02 -2.5060498046875000e+02 4.8323799133300781e+01 -1.6255299377441406e+02 -2.5060600280761719e+02 -1.1485099792480469e+01 -2.6849401855468750e+02 -2.5367900085449219e+02 1.2900000000000000e+02 -2.7913998413085938e+02 -2.7990402221679688e+02 1.2900000000000000e+02 -2.1076400756835938e+02 -1.7356201171875000e+02 1.2900000000000000e+02 -2.2460000610351562e+02 -1.7191999816894531e+02 1.2900000000000000e+02 -1.7508399963378906e+02 -1.6866700744628906e+02 1.2900000000000000e+02 -1.8084899902343750e+02 -1.6405400085449219e+02 1.2900000000000000e+02 -1.9613101196289062e+02 -1.7144100952148438e+02 1.2900000000000000e+02 -2.7593402099609375e+02 -2.3665100097656250e+02 1.3304998779296875e+02 -2.9628802490234375e+02 -2.4683799743652344e+02 1.3304998779296875e+02 -1.9710000610351562e+02 -1.3809999084472656e+02 4.8852600097656250e+01 -2.3349200439453125e+02 -2.9912799072265625e+02 1.3304998779296875e+02 -2.4663500976562500e+02 -2.9646398925781250e+02 1.3304998779296875e+02 -2.3904600524902344e+02 -1.3809999084472656e+02 -5.1552700042724609e+01 -2.4472799682617188e+02 -1.3809999084472656e+02 -4.6919902801513672e+01 -2.9846298217773438e+02 -2.3773098754882812e+02 1.3304998779296875e+02 -1.5267098999023438e+02 -2.0289599609375000e+02 1.3304998779296875e+02 -1.7514700317382812e+02 -2.0636199951171875e+02 1.3304998779296875e+02 -1.8018199157714844e+02 -1.9599699401855469e+02 1.3304998779296875e+02 -2.1710400390625000e+02 -2.9928399658203125e+02 1.3955000305175781e+02 -1.8607699584960938e+02 -2.8852902221679688e+02 1.0764700317382812e+02 -1.9140901184082031e+02 -2.9151300048828125e+02 1.0230000305175781e+02 -1.8330099487304688e+02 -2.8678799438476562e+02 1.0230000305175781e+02 -2.2460000610351562e+02 -1.4960000610351562e+02 1.3955000305175781e+02 -2.9956900024414062e+02 -2.2807499694824219e+02 1.3304998779296875e+02 -2.9940301513671875e+02 -2.3099899291992188e+02 1.3955000305175781e+02 -1.9710000610351562e+02 -3.0809997558593750e+02 1.0230000305175781e+02 -1.9710000610351562e+02 -3.1110000610351562e+02 6.0071498870849609e+01 -2.9469201660156250e+02 -2.6530700683593750e+02 1.0526599884033203e+02 -3.0759799194335938e+02 -2.6774298095703125e+02 1.0526599884033203e+02 -2.3271000671386719e+02 -1.4110000610351562e+02 -5.4577102661132812e+01 -1.3366700744628906e+02 -2.0333599853515625e+02 1.0526499938964844e+02 -2.5924700927734375e+02 -2.9181201171875000e+02 1.2900000000000000e+02 -1.4087100219726562e+02 -1.8309199523925781e+02 1.0230000305175781e+02 -1.8330099487304688e+02 -2.8678799438476562e+02 1.0526599884033203e+02 -1.3806399536132812e+02 -1.8976399230957031e+02 1.0526599884033203e+02 -2.8767800903320312e+02 -1.8396798706054688e+02 1.3955000305175781e+02 -2.9243600463867188e+02 -1.9252200317382812e+02 1.3955000305175781e+02 -2.6952401733398438e+02 -2.8647698974609375e+02 1.2900000000000000e+02 -2.7351901245117188e+02 -2.8393099975585938e+02 1.0526499938964844e+02 -2.8447900390625000e+02 -2.7552999877929688e+02 1.0526599884033203e+02 -3.0362298583984375e+02 -2.5060498046875000e+02 5.6637203216552734e+01 -2.2635099792480469e+02 -1.9859500122070312e+02 1.0230000305175781e+02 -3.0640200805664062e+02 -2.4782200622558594e+02 1.2900000000000000e+02 -3.0290402221679688e+02 -2.5397598266601562e+02 1.0526499938964844e+02 -1.9710000610351562e+02 -3.1110000610351562e+02 -2.8200000762939453e+01 -1.9710000610351562e+02 -3.1110000610351562e+02 6.6848897933959961e+00 -2.9700299072265625e+02 -2.4467300415039062e+02 1.3955000305175781e+02 -1.9968899536132812e+02 -3.1110000610351562e+02 -4.0130100250244141e+01 -2.1108500671386719e+02 -3.1110000610351562e+02 -5.2161602020263672e+01 -1.7185400390625000e+02 -2.2850100708007812e+02 1.3304998779296875e+02 -1.5349400329589844e+02 -2.4869099426269531e+02 1.3304998779296875e+02 -1.7488299560546875e+02 -2.4233599853515625e+02 1.3304998779296875e+02 -1.5064799499511719e+02 -2.4014900207519531e+02 9.8952499389648438e+01 -3.0500299072265625e+02 -2.7258999633789062e+02 1.0230000305175781e+02 -1.4958999633789062e+02 -2.2743701171875000e+02 1.3955000305175781e+02 -1.4992199707031250e+02 -2.1676499938964844e+02 1.3304998779296875e+02 -2.8166101074218750e+02 -1.7586100769042969e+02 1.3955000305175781e+02 -2.8750100708007812e+02 -1.8353498840332031e+02 1.3304998779296875e+02 -1.5341400146484375e+02 -2.4641899108886719e+02 9.9576896667480469e+01 -2.8240002441406250e+02 -1.6241200256347656e+02 1.0526599884033203e+02 -2.7598800659179688e+02 -2.1257301330566406e+02 1.3304998779296875e+02 -1.9340200805664062e+02 -1.5679800415039062e+02 1.2900000000000000e+02 -1.9710000610351562e+02 -1.5523699951171875e+02 1.2900000000000000e+02 -1.6932600402832031e+02 -1.7425000000000000e+02 1.0526599884033203e+02 -1.6303401184082031e+02 -1.8236100769042969e+02 1.0526599884033203e+02 -3.1208599853515625e+02 -2.2774900817871094e+02 1.0526599884033203e+02 -2.0161900329589844e+02 -1.5314599609375000e+02 1.3955000305175781e+02 -1.5291899108886719e+02 -2.0336000061035156e+02 4.9794101715087891e+01 -1.6020800781250000e+02 -2.5040200805664062e+02 -4.6152801513671875e+01 -1.5055300903320312e+02 -2.3860499572753906e+02 -5.9969802856445312e+01 -1.5055300903320312e+02 -2.1059500122070312e+02 1.0230000305175781e+02 -1.5055300903320312e+02 -2.1059500122070312e+02 7.5970199584960938e+01 -3.0362298583984375e+02 -1.9859500122070312e+02 -1.6964399337768555e+01 -3.0672900390625000e+02 -1.9900199890136719e+02 -5.8409500122070312e+01 -3.1092102050781250e+02 -2.4813800048828125e+02 -5.6251296997070312e+01 -3.1044500732421875e+02 -2.4852999877929688e+02 -5.9969802856445312e+01 -1.5209800720214844e+02 -2.4460501098632812e+02 6.6583404541015625e+01 -1.5096099853515625e+02 -2.4171200561523438e+02 7.0289703369140625e+01 -3.1424200439453125e+02 -2.4423699951171875e+02 1.0230100250244141e+02 -3.1402001953125000e+02 -2.4460099792480469e+02 4.8860198974609375e+01 -3.0667300415039062e+02 -2.5026699829101562e+02 9.7371997833251953e+00 -3.1521697998046875e+02 -2.4170899963378906e+02 -2.7545099258422852e+01 -3.1531399536132812e+02 -2.0759199523925781e+02 -1.4892200469970703e+01 -3.1363201904296875e+02 -2.0392599487304688e+02 2.2798498153686523e+01 -3.1440200805664062e+02 -2.4394099426269531e+02 1.4838599205017090e+01 -3.0821600341796875e+02 -1.9950700378417969e+02 2.7942600250244141e+01 -1.5096099853515625e+02 -2.4171200561523438e+02 -3.9637302398681641e+01 -3.1187399291992188e+02 -2.4733500671386719e+02 1.0230000305175781e+02 -2.5209999084472656e+02 -3.1110000610351562e+02 6.7655197143554688e+01 -2.5209999084472656e+02 -3.0809997558593750e+02 3.0641500473022461e+01 -2.5209999084472656e+02 -3.1110000610351562e+02 -2.8200000762939453e+01 -1.8330099487304688e+02 -1.6241200256347656e+02 1.0526599884033203e+02 -2.5209999084472656e+02 -3.0809997558593750e+02 -2.8200000762939453e+01 -3.1294699096679688e+02 -1.9457800292968750e+02 1.0230000305175781e+02 -3.1584500122070312e+02 -2.4401300048828125e+02 1.0230000305175781e+02 -3.1747399902343750e+02 -2.3520700073242188e+02 1.0230000305175781e+02 -1.5445399475097656e+02 -2.0163699340820312e+02 1.0230000305175781e+02 -1.5797000122070312e+02 -1.9950700378417969e+02 1.0230000305175781e+02 -3.1416000366210938e+02 -2.4447399902343750e+02 -2.9775800704956055e+01 -3.1350698852539062e+02 -2.4546701049804688e+02 -5.6444297790527344e+01 -2.7767700195312500e+02 -1.6816200256347656e+02 1.0526599884033203e+02 -3.0012597656250000e+02 -1.9101600646972656e+02 1.0526499938964844e+02 -1.5055300903320312e+02 -2.3860499572753906e+02 9.6058898925781250e+01 -2.5209999084472656e+02 -1.5458999633789062e+02 1.2900000000000000e+02 -2.5209999084472656e+02 -3.0809997558593750e+02 1.0230000305175781e+02 -3.0799401855468750e+02 -2.4430799865722656e+02 1.0526599884033203e+02 -1.5900099182128906e+02 -1.8892300415039062e+02 1.0526599884033203e+02 -1.6067999267578125e+02 -1.8586898803710938e+02 1.2900000000000000e+02 -1.9710000610351562e+02 -1.4110000610351562e+02 3.3724399566650391e+01 -1.9710000610351562e+02 -1.4110000610351562e+02 1.0230000305175781e+02 -1.7536799621582031e+02 -2.4358399963378906e+02 1.2900000000000000e+02 -1.6962400817871094e+02 -2.6200399780273438e+02 1.2900000000000000e+02 -2.5209999084472656e+02 -3.1110000610351562e+02 1.2900000000000000e+02 -1.5199301147460938e+02 -2.4201899719238281e+02 1.0526599884033203e+02 -2.4941000366210938e+02 -3.0809997558593750e+02 -4.0305999755859375e+01 -2.5113002014160156e+02 -3.1110000610351562e+02 -3.5835197448730469e+01 -2.5176901245117188e+02 -3.0809997558593750e+02 -3.2848102569580078e+01 -2.1183300781250000e+02 -1.3809999084472656e+02 -5.2639400482177734e+01 -1.5055300903320312e+02 -2.1059500122070312e+02 -5.9969802856445312e+01 -3.1751901245117188e+02 -2.3469500732421875e+02 1.0526499938964844e+02 -1.7510600280761719e+02 -2.8055300903320312e+02 1.2900000000000000e+02 -1.9804798889160156e+02 -2.7025000000000000e+02 1.2900000000000000e+02 -2.6873999023437500e+02 -1.7152099609375000e+02 1.0230000305175781e+02 -1.5309399414062500e+02 -2.8678799438476562e+02 1.0230000305175781e+02 -1.6336700439453125e+02 -1.8104901123046875e+02 1.3304998779296875e+02 -1.7266300964355469e+02 -2.3392500305175781e+02 1.2900000000000000e+02 -1.7183200073242188e+02 -2.2460000610351562e+02 1.2900000000000000e+02 -1.5247799682617188e+02 -2.4558999633789062e+02 1.3955000305175781e+02 -2.9426000976562500e+02 -1.8357600402832031e+02 1.0526499938964844e+02 -1.6255299377441406e+02 -1.9859500122070312e+02 1.8190799713134766e+01 -1.7577600097656250e+02 -1.6802999877929688e+02 1.0526599884033203e+02 -2.8762899780273438e+02 -1.7661199951171875e+02 1.0526599884033203e+02 -2.9047799682617188e+02 -1.7946299743652344e+02 1.2900000000000000e+02 -2.6099899291992188e+02 -2.9105300903320312e+02 1.0230000305175781e+02 -2.7701199340820312e+02 -2.1809700012207031e+02 1.2900000000000000e+02 -1.7914801025390625e+02 -2.5137600708007812e+02 1.3304998779296875e+02 -1.8074501037597656e+02 -2.5375300598144531e+02 1.2900000000000000e+02 -1.4992999267578125e+02 -2.2078399658203125e+02 1.0526599884033203e+02 -1.5015100097656250e+02 -2.3122799682617188e+02 1.0526599884033203e+02 -2.0128401184082031e+02 -3.0809997558593750e+02 -4.2833202362060547e+01 -1.9052499389648438e+02 -1.8430400085449219e+02 1.2900000000000000e+02 -1.6840399169921875e+02 -1.7529701232910156e+02 1.2900000000000000e+02 -2.5867300415039062e+02 -1.8435501098632812e+02 1.3304998779296875e+02 -2.3659298706054688e+02 -1.7323100280761719e+02 1.3304998779296875e+02 -2.3371900939941406e+02 -1.5006799316406250e+02 1.3304998779296875e+02 -2.6977600097656250e+02 -1.6287399291992188e+02 1.2900000000000000e+02 -2.5949002075195312e+02 -1.5747900390625000e+02 1.2900000000000000e+02 -2.9589001464843750e+02 -1.8548699951171875e+02 1.2900000000000000e+02 -2.5547999572753906e+02 -1.5622801208496094e+02 1.3304998779296875e+02 -2.2460000610351562e+02 -2.7727999877929688e+02 1.2900000000000000e+02 -2.3067100524902344e+02 -2.7699398803710938e+02 1.2900000000000000e+02 -1.7273100280761719e+02 -2.1490299987792969e+02 1.3304998779296875e+02 -2.7138598632812500e+02 -2.4922299194335938e+02 1.3304998779296875e+02 -2.6335702514648438e+02 -2.6041900634765625e+02 1.3304998779296875e+02 -2.2460000610351562e+02 -1.7191999816894531e+02 1.3304998779296875e+02 -1.5306399536132812e+02 -2.4604499816894531e+02 -2.8803701400756836e+01 -1.5583198547363281e+02 -2.4857899475097656e+02 -2.5463699340820312e+01 -1.8929701232910156e+02 -1.8534199523925781e+02 1.3304998779296875e+02 -2.0006300354003906e+02 -1.7780500793457031e+02 1.3304998779296875e+02 -1.5835000610351562e+02 -2.4988398742675781e+02 -1.0737000465393066e+01 -1.9710000610351562e+02 -3.0809997558593750e+02 5.9928802490234375e+01 -1.7703199768066406e+02 -2.0191299438476562e+02 1.2900000000000000e+02 -1.5132800292968750e+02 -2.0621800231933594e+02 1.0230200195312500e+02 -1.5609201049804688e+02 -2.4874400329589844e+02 -5.2422698974609375e+01 -1.5525099182128906e+02 -2.0106999206542969e+02 5.2651199340820312e+01 -1.5147200012207031e+02 -2.0572799682617188e+02 -5.9969898223876953e+01 -3.1211199951171875e+02 -2.0211000061035156e+02 3.2074897766113281e+01 -3.1314797973632812e+02 -2.0329199218750000e+02 3.9531700611114502e+00 -3.1438198852539062e+02 -2.0522000122070312e+02 5.3571498870849609e+01 -3.1211199951171875e+02 -2.4708999633789062e+02 -1.9134199142456055e+01 -3.1314797973632812e+02 -2.4590800476074219e+02 -1.5331000328063965e+01 -3.0821600341796875e+02 -1.9950700378417969e+02 -3.0812000274658203e+01 -3.0672900390625000e+02 -1.9900199890136719e+02 -6.3017100095748901e-01 -1.5944999694824219e+02 -1.9900099182128906e+02 5.3029102325439453e+01 -3.1258401489257812e+02 -2.4662500000000000e+02 1.3570899963378906e+01 -1.5065400695800781e+02 -2.0902799987792969e+02 5.6193798065185547e+01 -1.5096099853515625e+02 -2.0748800659179688e+02 7.7798599243164062e+01 -3.1207800292968750e+02 -2.4712799072265625e+02 -5.5226299285888672e+01 -1.6020899963378906e+02 -2.5040200805664062e+02 7.4531799316406250e+01 -1.6255299377441406e+02 -2.5060498046875000e+02 1.0230000305175781e+02 -3.0821600341796875e+02 -1.9950700378417969e+02 2.2100400924682617e+00 -3.1450900268554688e+02 -2.0547300720214844e+02 9.9347999572753906e+01 -3.0821600341796875e+02 -2.4969300842285156e+02 3.1258199691772461e+01 -3.0597000122070312e+02 -2.5040098571777344e+02 5.7319896697998047e+01 -1.5944999694824219e+02 -1.9900099182128906e+02 -1.2929599761962891e+01 -1.5944999694824219e+02 -1.9900099182128906e+02 2.4188098907470703e+01 -1.5796501159667969e+02 -1.9950500488281250e+02 3.9644699096679688e+01 -2.9817898559570312e+02 -2.0980999755859375e+02 1.3304998779296875e+02 -2.9660998535156250e+02 -2.0331900024414062e+02 1.3955000305175781e+02 -2.9456600952148438e+02 -1.9719700622558594e+02 1.3304998779296875e+02 -2.7580499267578125e+02 -2.7959201049804688e+02 1.3304998779296875e+02 -2.3258799743652344e+02 -1.3809999084472656e+02 -5.4595897674560547e+01 -2.2594801330566406e+02 -1.4109899902343750e+02 -5.5724899291992188e+01 -2.8733798217773438e+02 -2.7287301635742188e+02 1.2900000000000000e+02 -3.0198498535156250e+02 -1.9375500488281250e+02 1.2900000000000000e+02 -1.4967100524902344e+02 -2.2879899597167969e+02 1.3304998779296875e+02 -1.5098400878906250e+02 -2.3927799987792969e+02 1.3304998779296875e+02 -2.2460000610351562e+02 -2.7727999877929688e+02 1.3304998779296875e+02 -2.2125299072265625e+02 -1.3809999084472656e+02 -5.5608501434326172e+01 -2.1661199951171875e+02 -1.4110000610351562e+02 -5.4595897674560547e+01 -1.6724600219726562e+02 -2.7299099731445312e+02 1.3304998779296875e+02 -1.7823699951171875e+02 -2.8374099731445312e+02 1.3304998779296875e+02 -1.9393399047851562e+02 -2.6752999877929688e+02 1.3304998779296875e+02 -2.0019599914550781e+02 -1.7777600097656250e+02 1.2900000000000000e+02 -2.5209999084472656e+02 -2.9460998535156250e+02 1.2900000000000000e+02 -3.1163900756835938e+02 -2.1766200256347656e+02 1.2899899291992188e+02 -3.1562298583984375e+02 -2.3860499572753906e+02 1.0230000305175781e+02 -3.1185800170898438e+02 -2.1923300170898438e+02 1.0526599884033203e+02 -3.1216101074218750e+02 -2.2442199707031250e+02 1.2900000000000000e+02 -1.5142700195312500e+02 -2.3950498962402344e+02 1.2900000000000000e+02 -1.5077301025390625e+02 -2.3592900085449219e+02 1.2113300323486328e+02 -1.4989698791503906e+02 -2.2786801147460938e+02 1.2900000000000000e+02 -2.5586700439453125e+02 -2.8661502075195312e+02 1.0230000305175781e+02 -2.5209999084472656e+02 -1.3809999084472656e+02 1.2900000000000000e+02 -1.5968099975585938e+02 -2.6239599609375000e+02 1.3304998779296875e+02 -1.9078601074218750e+02 -2.8409500122070312e+02 1.0230000305175781e+02 -1.5117800903320312e+02 -2.4251100158691406e+02 3.0843800306320190e-01 -2.4458700561523438e+02 -3.0809997558593750e+02 -4.7107498168945312e+01 -2.4978601074218750e+02 -1.7815600585937500e+02 1.3304998779296875e+02 -2.5209999084472656e+02 -1.4110000610351562e+02 1.0230000305175781e+02 -1.7321899414062500e+02 -2.1263900756835938e+02 1.2900000000000000e+02 -1.5309399414062500e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -1.5913499450683594e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -1.5419000244140625e+02 -1.9822399902343750e+02 1.3955000305175781e+02 -1.5743200683593750e+02 -1.9114700317382812e+02 1.3304998779296875e+02 -1.8442698669433594e+02 -2.5882299804687500e+02 1.3304998779296875e+02 -2.8421200561523438e+02 -2.7023599243164062e+02 1.3304998779296875e+02 -1.9806599426269531e+02 -3.0809997558593750e+02 -3.5868499755859375e+01 -1.9710000610351562e+02 -1.3809999084472656e+02 1.2900000000000000e+02 -1.8856700134277344e+02 -2.6313998413085938e+02 1.2900000000000000e+02 -3.1363897705078125e+02 -2.0359599304199219e+02 1.0230000305175781e+02 -1.5055300903320312e+02 -2.1059500122070312e+02 3.7548099517822266e+01 -2.2985499572753906e+02 -1.7213598632812500e+02 1.2900000000000000e+02 -1.8330099487304688e+02 -1.6241200256347656e+02 1.0230000305175781e+02 -2.4127101135253906e+02 -2.7490197753906250e+02 1.2900000000000000e+02 -2.4267800903320312e+02 -2.7427499389648438e+02 1.3304998779296875e+02 -2.1381300354003906e+02 -2.7634600830078125e+02 1.3304998779296875e+02 -2.0252000427246094e+02 -2.7246099853515625e+02 1.3304998779296875e+02 -2.4579901123046875e+02 -2.9661599731445312e+02 1.3955000305175781e+02 -2.5209999084472656e+02 -2.9460998535156250e+02 1.0230000305175781e+02 -2.3857000732421875e+02 -3.0809997558593750e+02 -5.1869602203369141e+01 -2.3985099792480469e+02 -1.7401100158691406e+02 1.2900000000000000e+02 -2.4938200378417969e+02 -1.7794700622558594e+02 1.2900000000000000e+02 -2.5181901550292969e+02 -1.3809999084472656e+02 -3.2403598785400391e+01 -1.8684199523925781e+02 -1.6020600891113281e+02 1.2900000000000000e+02 -2.9948898315429688e+02 -2.1989700317382812e+02 1.3304998779296875e+02 -2.0461300659179688e+02 -3.1110000610351562e+02 -4.7107498168945312e+01 -1.5322000122070312e+02 -2.4623699951171875e+02 1.8911499023437500e+01 -3.1314797973632812e+02 -2.4590800476074219e+02 3.8815799713134766e+01 -3.1314797973632812e+02 -2.4590800476074219e+02 7.5726394653320312e+01 -3.1093099975585938e+02 -2.4812600708007812e+02 -2.7268099784851074e+00 -3.0519000244140625e+02 -1.9869599914550781e+02 6.1473302841186523e+00 -3.0519000244140625e+02 -1.9869599914550781e+02 2.9441900253295898e+01 -3.1562298583984375e+02 -2.3860499572753906e+02 4.6775699615478516e+01 -2.4791600036621094e+02 -3.1110000610351562e+02 -4.2833202362060547e+01 -1.9743099975585938e+02 -3.1110000610351562e+02 -3.2848102569580078e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 55 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3806399703025818e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector -1.5055300295352936e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector -1.3104900717735291e+02 -2.2218500077724457e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3806399703025818e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector -1.5309399366378784e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector -1.5664899349212646e+02 -2.0005699992179871e+02 -5.9970799833536148e+01) (float-vector -1.5055300295352936e+02 -2.1059499680995941e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector -3.0943799018859863e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9610601067543030e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector -3.0943799018859863e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1419399380683899e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -3.1419399380683899e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5309399366378784e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector -1.9875699281692505e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector -1.5664899349212646e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9875699281692505e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector -2.1183300018310547e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector -1.5664899349212646e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181901454925537e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector -2.9610601067543030e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -2.4791599810123444e+02 -3.1110000610351562e+02 -4.2833201587200165e+01) (float-vector -2.4075900018215179e+02 -3.1110000610351562e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector -2.4791599810123444e+02 -3.1110000610351562e+02 -4.2833201587200165e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4579900503158569e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector -2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector -1.5055300295352936e+02 -2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector -1.5055300295352936e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector -1.5664899349212646e+02 -2.0005699992179871e+02 -5.9970799833536148e+01) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5055300295352936e+02 -2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector -1.4330500364303589e+02 -2.7118900418281555e+02 1.0526499897241592e+02) (float-vector -1.3250200450420380e+02 -2.4011799693107605e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3250200450420380e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector -1.3104900717735291e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector -1.5055300295352936e+02 -2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector -1.5055300295352936e+02 -2.3860499262809753e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector -1.9108900427818298e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3104900717735291e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector -1.3250200450420380e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector -1.5247799456119537e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector -1.4959000051021576e+02 -2.2743700444698334e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6203199326992035e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector -1.5247799456119537e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector -1.3250200450420380e+02 -2.4011799693107605e+02 1.0230000317096710e+02) (float-vector -1.4330500364303589e+02 -2.7118900418281555e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5309399366378784e+02 -2.8678798675537109e+02 1.0230000317096710e+02) (float-vector -1.9743099808692932e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector -1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01) (float-vector -1.9743099808692932e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector -1.5309399366378784e+02 -2.8678798675537109e+02 1.0230000317096710e+02) (float-vector -1.4330500364303589e+02 -2.7118900418281555e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.9108900427818298e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector -1.6203199326992035e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector -1.4330500364303589e+02 -2.7118900418281555e+02 1.0526499897241592e+02) (float-vector -1.5309399366378784e+02 -2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1108500659465790e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector -1.9743099808692932e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.9875699281692505e+02 -1.3809899985790253e+02 -3.8267400115728378e+01) (float-vector -1.5309399366378784e+02 -1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6750200092792511e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.5309399366378784e+02 -1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3904600739479065e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector -2.5181901454925537e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5419000387191772e+02 -1.9822399318218231e+02 1.3955000042915344e+02) (float-vector -1.3806399703025818e+02 -1.8976399302482605e+02 1.0526599735021591e+02) (float-vector -1.3104900717735291e+02 -2.2218500077724457e+02 1.0230000317096710e+02) (float-vector -1.4959000051021576e+02 -2.2743700444698334e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5419000387191772e+02 -1.9822399318218231e+02 1.3955000042915344e+02) (float-vector -1.6750200092792511e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector -1.5309399366378784e+02 -1.6241200268268585e+02 1.0230000317096710e+02) (float-vector -1.3806399703025818e+02 -1.8976399302482605e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -2.2026200592517853e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2026200592517853e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector -3.1479099392890930e+02 -2.4332399666309357e+02 -5.9969998896121979e+01) (float-vector -2.4075900018215179e+02 -3.1110000610351562e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2026200592517853e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector -2.1108500659465790e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector -1.5382599830627441e+02 -2.4685899913311005e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.9743099808692932e+02 -3.1110000610351562e+02 -3.2848101109266281e+01) (float-vector -2.1108500659465790e+02 -3.1110000610351562e+02 -5.2161600440740585e+01) (float-vector -2.2026200592517853e+02 -3.1110000610351562e+02 -5.5569801479578018e+01) (float-vector -2.4075900018215179e+02 -3.1110000610351562e+02 -5.0521600991487503e+01) (float-vector -2.4791599810123444e+02 -3.1110000610351562e+02 -4.2833201587200165e+01) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 -2.8200000524520874e+01) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.9030800461769104e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector -2.1309900283813477e+02 -1.5035900473594666e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9030800461769104e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.6750200092792511e+02 -1.7591199278831482e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2125299274921417e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector -2.3904600739479065e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1183300018310547e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector -2.2125299274921417e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector -3.1411498785018921e+02 -2.0466500520706177e+02 -5.9969898313283920e+01) (float-vector -1.5664899349212646e+02 -2.0005699992179871e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7223700284957886e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector -2.4579900503158569e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7223700284957886e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 -3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1185600161552429e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector -3.1419399380683899e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181901454925537e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 -1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.3481400310993195e+02 -1.5020799636840820e+02 1.3955000042915344e+02) (float-vector -2.5610598921775818e+02 -1.5641400218009949e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.5181901454925537e+02 -1.3809999823570251e+02 -3.2403599470853806e+01) (float-vector -2.3904600739479065e+02 -1.3809999823570251e+02 -5.1552701741456985e+01) (float-vector -2.2125299274921417e+02 -1.3809999823570251e+02 -5.5608499795198441e+01) (float-vector -2.1183300018310547e+02 -1.3809999823570251e+02 -5.2639398723840714e+01) (float-vector -1.9875699281692505e+02 -1.3809899985790253e+02 -3.8267400115728378e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.9709999859333038e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.1309900283813477e+02 -1.5035900473594666e+02 1.3955000042915344e+02) (float-vector -2.3481400310993195e+02 -1.5020799636840820e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02) (float-vector -3.0640199780464172e+02 -2.4782200157642365e+02 1.2899999320507050e+02) (float-vector -2.9144999384880066e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector -2.7223700284957886e+02 -2.8273099660873413e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1419399380683899e+02 -2.5077700614929199e+02 1.0526599735021591e+02) (float-vector -3.1185600161552429e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector -3.0640199780464172e+02 -2.4782200157642365e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 -2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.8166100382804871e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector -2.9610601067543030e+02 -1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8166100382804871e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 -1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.5610598921775818e+02 -1.5641400218009949e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0943799018859863e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector -3.1004899740219116e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1004899740219116e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector -3.1185600161552429e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector -3.1788599491119385e+02 -2.1692399680614471e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0943799018859863e+02 -1.8562600016593933e+02 1.0526499897241592e+02) (float-vector -2.9610601067543030e+02 -1.6241200268268585e+02 1.0526599735021591e+02) (float-vector -2.8166100382804871e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector -3.1004899740219116e+02 -2.1066899597644806e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9660999774932861e+02 -2.0331899821758270e+02 1.3955000042915344e+02) (float-vector -3.1004899740219116e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector -2.8166100382804871e+02 -1.7586100101470947e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4959000051021576e+02 -2.2743700444698334e+02 1.3955000042915344e+02) (float-vector -1.5247799456119537e+02 -2.4559000134468079e+02 1.3955000042915344e+02) (float-vector -1.6203199326992035e+02 -2.6609998941421509e+02 1.3955000042915344e+02) (float-vector -1.9108900427818298e+02 -2.9184100031852722e+02 1.3955000042915344e+02) (float-vector -2.2460000216960907e+02 -2.9960000514984131e+02 1.3955000042915344e+02) (float-vector -2.4579900503158569e+02 -2.9661598801612854e+02 1.3955000042915344e+02) (float-vector -2.7223700284957886e+02 -2.8273099660873413e+02 1.3955000042915344e+02) (float-vector -2.9144999384880066e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector -2.9940301179885864e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector -2.9660999774932861e+02 -2.0331899821758270e+02 1.3955000042915344e+02) (float-vector -2.8166100382804871e+02 -1.7586100101470947e+02 1.3955000042915344e+02) (float-vector -2.5610598921775818e+02 -1.5641400218009949e+02 1.3955000042915344e+02) (float-vector -2.3481400310993195e+02 -1.5020799636840820e+02 1.3955000042915344e+02) (float-vector -2.1309900283813477e+02 -1.5035900473594666e+02 1.3955000042915344e+02) (float-vector -1.9030800461769104e+02 -1.5772600471973419e+02 1.3955000042915344e+02) (float-vector -1.6750200092792511e+02 -1.7591199278831482e+02 1.3955000042915344e+02) (float-vector -1.5419000387191772e+02 -1.9822399318218231e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9940301179885864e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector -3.1185600161552429e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector -3.1004899740219116e+02 -2.1066899597644806e+02 1.2899999320507050e+02) (float-vector -2.9660999774932861e+02 -2.0331899821758270e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1185600161552429e+02 -2.3003600537776947e+02 1.2899999320507050e+02) (float-vector -2.9940301179885864e+02 -2.3099899291992188e+02 1.3955000042915344e+02) (float-vector -2.9144999384880066e+02 -2.5874999165534973e+02 1.3955000042915344e+02) (float-vector -3.0640199780464172e+02 -2.4782200157642365e+02 1.2899999320507050e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fl_caster_rotation_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fr_caster_l_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 -2.9734701156616211e+01 -9.3289899826049805e+00 2.7445201873779297e+00 -2.9418100357055664e+01 -1.2800700187683105e+01 1.0573199987411499e+00 -2.9640798568725586e+01 -1.0600199699401855e+01 1.0544799804687500e+01 -2.9430900573730469e+01 -8.4442996978759766e+00 8.2298793792724609e+00 -2.9580398559570312e+01 -6.8257398605346680e+00 1.0452800750732422e+01 -2.9676599502563477e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 -2.9607198715209961e+01 8.3633699417114258e+00 -1.0304100036621094e+01 -8.0464500427246094e+01 4.2757096290588379e+00 -9.9000797271728516e+00 -2.9565000534057617e+01 4.3990101814270020e+00 -3.0437600612640381e+00 -2.9632600784301758e+01 1.0238399505615234e+01 -3.0640001296997070e+00 -8.0891304016113281e+01 1.0639900207519531e+01 -1.0523200035095215e+01 -2.9807800292968750e+01 2.0460700988769531e+00 -1.0421499252319336e+01 -2.9872400283813477e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 -2.9559000015258789e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 -8.0892097473144531e+01 8.4554700851440430e+00 -1.0192299842834473e+01 -8.0942695617675781e+01 5.5663700103759766e+00 -1.0925999641418457e+01 -8.0888397216796875e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 -8.0911102294921875e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 -2.9603599548339844e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 -2.9594200134277344e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 -8.0856101989746094e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 -2.9677499771118164e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 -8.0903297424316406e+01 -1.1044600486755371e+01 1.0178999900817871e+00 -2.9632200241088867e+01 1.0607999801635742e+01 1.0090099573135376e+00 -8.0902297973632812e+01 1.1044500350952148e+01 7.1427397727966309e+00 -8.0804000854492188e+01 8.4595899581909180e+00 9.8030099868774414e+00 -8.0907203674316406e+01 5.1623497009277344e+00 7.4257197380065918e+00 -8.1105201721191406e+01 1.1212299346923828e+01 3.3442101478576660e+00 -8.0903900146484375e+01 -1.0557999610900879e+01 6.1998200416564941e+00 -8.1096000671386719e+01 -1.1747900009155273e+01 7.2372202873229980e+00 -8.0794494628906250e+01 -8.3683700561523438e+00 9.8025293350219727e+00 -8.0921005249023438e+01 -5.1738500595092773e+00 4.0853300094604492e+00 -8.0921997070312500e+01 1.0249599456787109e+01 1.0831099510192871e+01 -8.0742095947265625e+01 -2.0039701461791992e+00 1.2268199920654297e+01 -8.1127998352050781e+01 3.9475402832031250e+00 1.1011500358581543e+01 -8.0664100646972656e+01 0.0000000000000000e+00 1.0836700439453125e+01 -8.0821899414062500e+01 2.0019199848175049e+00 -1.1417300224304199e+01 -3.1931400299072266e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 -3.1901300430297852e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 -3.3114299774169922e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 -3.3060798645019531e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 -3.3005496978759766e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 -3.2922698974609375e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 -3.1965400695800781e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 -3.2961498260498047e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 -3.3005199432373047e+01 2.3467597961425781e+00 -4.8763401031494141e+01 -3.2972099304199219e+01 1.6582399368286133e+01 -6.1740497589111328e+01 -3.1979299545288086e+01 1.0151400566101074e+01 -4.5477100372314453e+01 -3.3045398712158203e+01 2.1893899917602539e+01 1.6372301101684570e+01 -3.1941600799560547e+01 5.8962200164794922e+01 2.3468399047851562e+00 -3.3007396697998047e+01 5.1267200469970703e+01 -9.9129495620727539e+00 -3.3083801269531250e+01 4.9431499481201172e+01 -3.6015296936035156e+01 -3.3108100891113281e+01 3.4995300292968750e+01 -4.8726200103759766e+01 -3.1919502258300781e+01 3.8182498931884766e+01 -2.5745399475097656e+01 -3.3058502197265625e+01 4.3290298461914062e+01 -6.4798698425292969e+00 -3.1922300338745117e+01 6.1833000183105469e+01 -3.9104801177978516e+01 -3.3105998992919922e+01 -3.1760398864746094e+01 3.8039699554443359e+01 -3.1931098937988281e+01 4.8811397552490234e+01 2.0110498428344727e+01 -3.2998302459716797e+01 6.3504100799560547e+01 4.7388999938964844e+01 -3.3059799194335938e+01 4.7388999938964844e+01 5.0501701354980469e+01 -3.2199699401855469e+01 3.8274200439453125e+01 6.3447898864746094e+01 -3.3059898376464844e+01 2.0092599868774414e+01 6.0778099060058594e+01 -3.2144401550292969e+01 1.7475801467895508e+01 6.0313198089599609e+01 -3.1965400695800781e+01 7.4321599006652832e+00 6.3284599304199219e+01 -3.2191196441650391e+01 -4.4547400474548340e+00 5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 5.5512199401855469e+01 -3.1871200561523438e+01 -2.7132499694824219e+01 2.8417900085449219e+01 -3.3024398803710938e+01 -6.0260898590087891e+01 4.4547300338745117e+00 -3.2191101074218750e+01 -6.3284301757812500e+01 3.3109401702880859e+01 -3.1901699066162109e+01 -5.2159999847412109e+01 4.6935901641845703e+01 -3.2998600006103516e+01 -4.6935901641845703e+01 4.6696701049804688e+00 -3.3059997558593750e+01 -6.6339698791503906e+01 6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 -3.3019302368164062e+01 6.5981704711914062e+01 -4.4070800781250000e+01 -3.3025100708007812e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 -3.2243999481201172e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 -3.2244602203369141e+01 -3.8144996643066406e+01 1.5174099922180176e+01 -3.2350498199462891e+01 -6.8473693847656250e+01 4.8838300704956055e+00 -3.2246299743652344e+01 -6.9384094238281250e+01 4.1918899536132812e+01 -3.2255702972412109e+01 -5.5662799835205078e+01 5.6185497283935547e+01 -3.2231498718261719e+01 -4.1026100158691406e+01 6.9456398010253906e+01 -3.2233699798583984e+01 -1.5821299552917480e+00 6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 -3.2246299743652344e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 -3.2998302459716797e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 -3.2240303039550781e+01 1.4109100103378296e+00 -6.6339698791503906e+01 -3.3059997558593750e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 -3.2246299743652344e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 -3.3059898376464844e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 -3.8389400482177734e+01 7.4474800109863281e+01 -1.7341400384902954e+00 -3.8391998291015625e+01 7.6071098327636719e+01 5.1130599975585938e+00 -3.4403301239013672e+01 7.2644706726074219e+01 7.1366401672363281e+01 -3.4439002990722656e+01 1.3268600463867188e+01 6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 6.7477394104003906e+01 -3.4428897857666016e+01 2.6760299682617188e+01 7.5355300903320312e+01 -3.7268402099609375e+01 1.7170599699020386e+00 5.9104999542236328e+01 -3.2233699798583984e+01 3.6562202453613281e+01 7.0040397644042969e+01 -3.8387001037597656e+01 2.9782499313354492e+01 7.4474800109863281e+01 -3.8389400482177734e+01 1.5645200729370117e+01 6.2013099670410156e+01 -3.7266197204589844e+01 4.2893001556396484e+01 5.1923801422119141e+01 -3.7266002655029297e+01 5.4677501678466797e+01 4.9207698822021484e+01 -3.2231403350830078e+01 4.9181400299072266e+01 3.9661300659179688e+01 -3.7265899658203125e+01 6.4126296997070312e+01 6.6670997619628906e+01 -4.3020999908447266e+01 4.1205699920654297e+01 7.3550094604492188e+01 -4.3022300720214844e+01 2.7057100296020508e+01 7.7358497619628906e+01 -4.3024600982666016e+01 1.2475700378417969e+01 5.6843299865722656e+01 -4.3021598815917969e+01 5.3966102600097656e+01 2.5049600601196289e+01 -3.4442001342773438e+01 6.8122604370117188e+01 3.6946399688720703e+01 -3.2240901947021484e+01 5.8903797149658203e+01 4.4562896728515625e+01 -4.3020900726318359e+01 6.4476997375488281e+01 1.2114600181579590e+01 -3.8389999389648438e+01 7.5127197265625000e+01 2.6272998809814453e+01 -3.8387500762939453e+01 7.1428794860839844e+01 2.1015600204467773e+01 -3.2246299743652344e+01 6.6359199523925781e+01 3.0671701431274414e+01 -4.3021900177001953e+01 7.2120101928710938e+01 1.6111700057983398e+01 -4.3023998260498047e+01 7.6686698913574219e+01 1.7856500148773193e+00 -4.3026500701904297e+01 7.8329895019531250e+01 7.8330101013183594e+01 -4.3027000427246094e+01 -1.7853500843048096e+00 7.9383201599121094e+01 -4.8954898834228516e+01 -3.4461998939514160e-01 7.8114799499511719e+01 -4.8949199676513672e+01 1.4203499794006348e+01 7.3951698303222656e+01 -4.8940597534179688e+01 2.8930398941040039e+01 6.6686599731445312e+01 -4.8934600830078125e+01 4.3129802703857422e+01 5.6477798461914062e+01 -4.8932300567626953e+01 5.5839900970458984e+01 4.3869800567626953e+01 -4.8934097290039062e+01 6.6202606201171875e+01 2.9704099655151367e+01 -4.8939601898193359e+01 7.3644798278808594e+01 1.4941699981689453e+01 -4.8947898864746094e+01 7.7977600097656250e+01 3.4459200501441956e-01 -4.8954898834228516e+01 7.9383300781250000e+01 -6.4126296997070312e+01 -3.7265899658203125e+01 3.9661300659179688e+01 -5.3850097656250000e+01 -3.6490200042724609e+01 5.2007102966308594e+01 -5.6481498718261719e+01 -3.2248001098632812e+01 4.0724998474121094e+01 -4.8838300704956055e+00 -3.2246299743652344e+01 6.9384094238281250e+01 -1.5174099922180176e+01 -3.2350498199462891e+01 6.8473693847656250e+01 -1.2475700378417969e+01 -4.3024600982666016e+01 7.7358497619628906e+01 -2.9782499313354492e+01 -3.8387001037597656e+01 7.0040397644042969e+01 -4.2893001556396484e+01 -3.7266197204589844e+01 6.2013099670410156e+01 -2.8395601272583008e+01 -3.4441600799560547e+01 6.6799201965332031e+01 -4.3375499725341797e+01 -3.2257099151611328e+01 5.4680000305175781e+01 -2.7057100296020508e+01 -4.3022300720214844e+01 7.3550094604492188e+01 -4.1205699920654297e+01 -4.3020999908447266e+01 6.6670997619628906e+01 -5.3966102600097656e+01 -4.3021598815917969e+01 5.6843299865722656e+01 -6.4476997375488281e+01 -4.3020900726318359e+01 4.4562896728515625e+01 -6.7513504028320312e+01 -3.4440597534179688e+01 2.6707201004028320e+01 -7.5355300903320312e+01 -3.7268402099609375e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 -3.4436901092529297e+01 1.3211199760437012e+01 -6.7285202026367188e+01 -3.2246299743652344e+01 1.7788499832153320e+01 -7.5127197265625000e+01 -3.8389999389648438e+01 1.2114600181579590e+01 -7.1428794860839844e+01 -3.8387500762939453e+01 2.6272998809814453e+01 -7.2120101928710938e+01 -4.3021900177001953e+01 3.0671701431274414e+01 -7.6686698913574219e+01 -4.3023998260498047e+01 1.6111700057983398e+01 -1.4203499794006348e+01 -4.8949199676513672e+01 7.8114799499511719e+01 -2.8930398941040039e+01 -4.8940597534179688e+01 7.3951698303222656e+01 -4.3129802703857422e+01 -4.8934600830078125e+01 6.6686599731445312e+01 -5.4402599334716797e+01 -4.9551700592041016e+01 5.7758701324462891e+01 -1.7856500148773193e+00 -5.4973503112792969e+01 7.8329895019531250e+01 -7.8330101013183594e+01 -4.3027000427246094e+01 1.7853500843048096e+00 -6.4116600036621094e+01 -4.8947498321533203e+01 4.6979301452636719e+01 -6.7437301635742188e+01 -4.7811298370361328e+01 4.1716197967529297e+01 -7.3951698303222656e+01 -4.9059398651123047e+01 2.8930398941040039e+01 -7.8114799499511719e+01 -4.9050800323486328e+01 1.4203499794006348e+01 -7.9383201599121094e+01 -4.9045101165771484e+01 -3.4461998939514160e-01 7.8330101013183594e+01 -5.4972999572753906e+01 1.7853500843048096e+00 7.6686698913574219e+01 -5.4976001739501953e+01 1.6111700057983398e+01 7.2120101928710938e+01 -5.4978099822998047e+01 3.0671701431274414e+01 6.4476997375488281e+01 -5.4979099273681641e+01 4.4562896728515625e+01 5.3966102600097656e+01 -5.4978401184082031e+01 5.6843299865722656e+01 7.5127197265625000e+01 -5.9610000610351562e+01 1.2114600181579590e+01 7.5355300903320312e+01 -6.0731601715087891e+01 -1.7170599699020386e+00 7.1428794860839844e+01 -5.9612503051757812e+01 2.6272998809814453e+01 6.4126296997070312e+01 -6.0734100341796875e+01 3.9661300659179688e+01 5.3850097656250000e+01 -6.1509799957275391e+01 5.2007102966308594e+01 4.1205699920654297e+01 -5.4979000091552734e+01 6.6670997619628906e+01 2.7057100296020508e+01 -5.4977699279785156e+01 7.3550094604492188e+01 1.2475700378417969e+01 -5.4975402832031250e+01 7.7358497619628906e+01 -1.2114600181579590e+01 -5.9610000610351562e+01 7.5127197265625000e+01 1.7341400384902954e+00 -5.9608001708984375e+01 7.6071098327636719e+01 4.2893001556396484e+01 -6.0733798980712891e+01 6.2013099670410156e+01 2.9782499313354492e+01 -5.9612998962402344e+01 7.0040397644042969e+01 1.5645200729370117e+01 -5.9610603332519531e+01 7.4474800109863281e+01 5.6481498718261719e+01 -6.5751998901367188e+01 4.0724998474121094e+01 6.7513504028320312e+01 -6.3559398651123047e+01 2.6707201004028320e+01 7.1374496459960938e+01 -6.3563102722167969e+01 1.3211199760437012e+01 6.9488693237304688e+01 -6.5759704589843750e+01 1.4108999967575073e+00 6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 2.8395601272583008e+01 -6.3558399200439453e+01 6.6799201965332031e+01 4.3375499725341797e+01 -6.5742904663085938e+01 5.4680000305175781e+01 -5.1130700111389160e+00 -6.3596702575683594e+01 7.2644706726074219e+01 1.5174099922180176e+01 -6.5649505615234375e+01 6.8473693847656250e+01 -1.6111700057983398e+01 -5.4976001739501953e+01 7.6686698913574219e+01 -3.0671701431274414e+01 -5.4978099822998047e+01 7.2120101928710938e+01 -4.4562896728515625e+01 -5.4979099273681641e+01 6.4476997375488281e+01 -5.6843299865722656e+01 -5.4978401184082031e+01 5.3966102600097656e+01 -2.6272998809814453e+01 -5.9612503051757812e+01 7.1428794860839844e+01 -3.9661300659179688e+01 -6.0734100341796875e+01 6.4126296997070312e+01 -5.1923801422119141e+01 -6.0734001159667969e+01 5.4677501678466797e+01 -7.7358497619628906e+01 -5.4975402832031250e+01 1.2475700378417969e+01 -6.6670997619628906e+01 -5.4979000091552734e+01 4.1205699920654297e+01 -7.3550094604492188e+01 -5.4977699279785156e+01 2.7057100296020508e+01 -7.8330101013183594e+01 -5.4972999572753906e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 -6.0733798980712891e+01 4.2893001556396484e+01 -7.0040397644042969e+01 -5.9612998962402344e+01 2.9782499313354492e+01 -7.5355300903320312e+01 -6.0731601715087891e+01 1.7170599699020386e+00 -7.4474800109863281e+01 -5.9610603332519531e+01 1.5645200729370117e+01 -2.5049600601196289e+01 -6.3557998657226562e+01 6.8122604370117188e+01 -4.9207698822021484e+01 -6.5768600463867188e+01 4.9181400299072266e+01 -3.6946399688720703e+01 -6.5759101867675781e+01 5.8903797149658203e+01 -2.1015600204467773e+01 -6.5753700256347656e+01 6.6359199523925781e+01 -5.9104999542236328e+01 -6.5766296386718750e+01 3.6562202453613281e+01 -6.7477394104003906e+01 -6.3571102142333984e+01 2.6760299682617188e+01 -7.1366401672363281e+01 -6.3561000823974609e+01 1.3268600463867188e+01 -6.7285202026367188e+01 -6.5753700256347656e+01 1.7788499832153320e+01 -6.9456398010253906e+01 -6.5766296386718750e+01 -1.5821199417114258e+00 4.8838300704956055e+00 -6.5753700256347656e+01 6.9384094238281250e+01 -6.5954093933105469e+01 -6.5003295898437500e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 -6.5001693725585938e+01 2.0110498428344727e+01 -6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 -6.4940101623535156e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 -6.5744300842285156e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 -6.5649505615234375e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 -6.4940101623535156e+01 4.3333198547363281e+01 -2.5114198684692383e+01 -6.5005798339843750e+01 6.1894699096679688e+01 -4.6691398620605469e+00 -6.4939994812011719e+01 6.6339698791503906e+01 -5.6185497283935547e+01 -6.5768501281738281e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 -6.4974800109863281e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 -6.4940101623535156e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 -6.5753700256347656e+01 -6.9384094238281250e+01 4.6691398620605469e+00 -6.4939994812011719e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 -6.6084396362304688e+01 7.3676099777221680e+00 -3.9422199249267578e+01 -6.6119201660156250e+01 4.7579696655273438e+01 -4.8702198028564453e+01 -6.5940795898437500e+01 3.9441997528076172e+01 -8.7784500122070312e+00 -6.6089698791503906e+01 6.1264701843261719e+01 3.0705200195312500e+01 -6.6117897033691406e+01 5.3397201538085938e+01 1.5252799987792969e+01 -6.5862602233886719e+01 6.1349498748779297e+01 5.0155899047851562e+01 -6.6073204040527344e+01 3.6021900177001953e+01 4.3594100952148438e+01 -6.4963195800781250e+01 5.0356700897216797e+01 6.0698596954345703e+01 -6.6066696166992188e+01 -6.7463498115539551e+00 6.6711799621582031e+01 -6.5003898620605469e+01 1.3542500138282776e-01 5.9121696472167969e+01 -6.6100502014160156e+01 1.8429199218750000e+01 5.9817501068115234e+01 -6.4940101623535156e+01 2.9234298706054688e+01 2.0092599868774414e+01 -6.4940101623535156e+01 6.3447898864746094e+01 -2.4017601013183594e+01 -6.4924705505371094e+01 4.4330997467041016e+01 -1.2296899795532227e+01 -6.4922195434570312e+01 4.8861900329589844e+01 -4.9878101348876953e+01 -6.4923797607421875e+01 6.1260700225830078e+00 -4.7621898651123047e+01 -6.5026702880859375e+01 2.0646100997924805e+01 -5.8962200164794922e+01 -6.6058395385742188e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 -6.4928802490234375e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 -6.4901504516601562e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 -6.4915802001953125e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 -6.6128295898437500e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 -6.4940605163574219e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 -6.4898902893066406e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 -6.5010696411132812e+01 3.6192996978759766e+01 -7.4321599006652832e+00 -6.6034599304199219e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 -6.5038299560546875e+01 -5.1429000854492188e+01 6.1151897907257080e-01 -6.4899902343750000e+01 5.0388702392578125e+01 4.0430500030517578e+01 -6.6047805786132812e+01 -4.7272399902343750e+01 2.1093599319458008e+01 -6.5008094787597656e+01 -4.7210800170898438e+01 5.7853302955627441e+00 -6.4969100952148438e+01 -5.0313201904296875e+01 4.5625198364257812e+01 -6.5076095581054688e+01 -2.5078199386596680e+01 5.2289600372314453e+01 -6.5047103881835938e+01 -4.6615300178527832e+00 4.9076499938964844e+01 -6.5030502319335938e+01 1.6025699615478516e+01 3.6085098266601562e+01 -6.4887702941894531e+01 3.5027797698974609e+01 4.5658901214599609e+01 -6.4956298828125000e+01 2.1977499008178711e+01 1.2848500251770020e+01 -6.4922805786132812e+01 4.8701698303222656e+01 2.4957799911499023e+01 -6.4924301147460938e+01 4.3825702667236328e+01 3.6392799377441406e+01 -6.5013999938964844e+01 -3.6605201721191406e+01 5.6047599792480469e+01 -6.6018997192382812e+01 -2.7524799346923828e+01 4.4547400474548340e+00 -6.5808799743652344e+01 -6.3284599304199219e+01 2.7442001342773438e+01 -6.5952598571777344e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 -6.5855598449707031e+01 -6.0778099060058594e+01 6.3447898864746094e+01 -6.4940101623535156e+01 -2.0092599868774414e+01 5.0577800750732422e+01 -6.4940101623535156e+01 -4.3333198547363281e+01 2.9234298706054688e+01 -6.4940101623535156e+01 -5.9817501068115234e+01 2.1015600204467773e+01 -6.5753700256347656e+01 -6.6359199523925781e+01 5.6820499420166016e+01 -6.5761795043945312e+01 -4.0331298828125000e+01 6.6359199523925781e+01 -6.5753700256347656e+01 -2.1015600204467773e+01 4.3921298980712891e+01 -6.5758102416992188e+01 -5.3944599151611328e+01 1.5645200729370117e+01 -3.8389400482177734e+01 -7.4474800109863281e+01 1.7341400384902954e+00 -3.8391998291015625e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 -3.4403301239013672e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 -3.4428897857666016e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 -3.4439002990722656e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 -3.8387001037597656e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 -3.8389400482177734e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 -3.7266197204589844e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 -3.7266002655029297e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 -3.3472698211669922e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 -3.7265899658203125e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 -4.3020999908447266e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 -4.3022300720214844e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 -4.3024600982666016e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 -4.3021598815917969e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 -3.4442001342773438e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 -4.3020900726318359e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 -3.8389999389648438e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 -3.8387500762939453e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 -4.3021900177001953e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 -4.3023998260498047e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 -4.3026500701904297e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 -4.9052101135253906e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 -4.9060401916503906e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 -4.9065898895263672e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 -4.9067699432373047e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 -4.9065399169921875e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 -4.9059398651123047e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 -4.9050800323486328e+01 -7.8114799499511719e+01 3.4459200501441956e-01 -4.9045101165771484e+01 -7.9383300781250000e+01 6.4126296997070312e+01 -3.7265899658203125e+01 -3.9661300659179688e+01 5.3850097656250000e+01 -3.6490200042724609e+01 -5.2007102966308594e+01 1.2475700378417969e+01 -4.3024600982666016e+01 -7.7358497619628906e+01 2.9782499313354492e+01 -3.8387001037597656e+01 -7.0040397644042969e+01 4.2893001556396484e+01 -3.7266197204589844e+01 -6.2013099670410156e+01 2.8395601272583008e+01 -3.4441600799560547e+01 -6.6799201965332031e+01 2.7057100296020508e+01 -4.3022300720214844e+01 -7.3550094604492188e+01 4.1205699920654297e+01 -4.3020999908447266e+01 -6.6670997619628906e+01 5.3966102600097656e+01 -4.3021598815917969e+01 -5.6843299865722656e+01 6.7513504028320312e+01 -3.4440597534179688e+01 -2.6707201004028320e+01 6.4476997375488281e+01 -4.3020900726318359e+01 -4.4562896728515625e+01 7.1374496459960938e+01 -3.4436901092529297e+01 -1.3211199760437012e+01 7.5127197265625000e+01 -3.8389999389648438e+01 -1.2114600181579590e+01 7.1428794860839844e+01 -3.8387500762939453e+01 -2.6272998809814453e+01 7.2120101928710938e+01 -4.3021900177001953e+01 -3.0671701431274414e+01 7.6686698913574219e+01 -4.3023998260498047e+01 -1.6111700057983398e+01 1.4941699981689453e+01 -4.9052101135253906e+01 -7.7977600097656250e+01 2.9704099655151367e+01 -4.9060401916503906e+01 -7.3644798278808594e+01 4.1731800079345703e+01 -4.9570999145507812e+01 -6.7475105285644531e+01 4.9999198913574219e+01 -4.8999500274658203e+01 -6.1567001342773438e+01 5.7531902313232422e+01 -4.8420101165771484e+01 -5.4633300781250000e+01 1.7856500148773193e+00 -5.4973503112792969e+01 -7.8329895019531250e+01 6.6202606201171875e+01 -4.8934097290039062e+01 -4.3869800567626953e+01 7.3644798278808594e+01 -4.8939601898193359e+01 -2.9704099655151367e+01 7.7977600097656250e+01 -4.8947898864746094e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 -5.4976001739501953e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 -5.4978099822998047e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 -5.4979099273681641e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 -5.4978401184082031e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 -5.9610000610351562e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 -5.9612503051757812e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 -6.0734100341796875e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 -6.1509799957275391e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 -5.4979000091552734e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 -5.4977699279785156e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 -5.4975402832031250e+01 -7.7358497619628906e+01 1.2114600181579590e+01 -5.9610000610351562e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 -5.9608001708984375e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 -6.0733798980712891e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 -5.9612998962402344e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 -5.9610603332519531e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 -6.3559398651123047e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 -6.3563102722167969e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 -6.3558399200439453e+01 -6.6799201965332031e+01 5.1130599975585938e+00 -6.3596702575683594e+01 -7.2644706726074219e+01 2.5049600601196289e+01 -6.3557998657226562e+01 -6.8122604370117188e+01 1.6111700057983398e+01 -5.4976001739501953e+01 -7.6686698913574219e+01 3.0671701431274414e+01 -5.4978099822998047e+01 -7.2120101928710938e+01 4.2744701385498047e+01 -5.6259502410888672e+01 -6.5250297546386719e+01 5.6843299865722656e+01 -5.4978401184082031e+01 -5.3966102600097656e+01 2.6272998809814453e+01 -5.9612503051757812e+01 -7.1428794860839844e+01 5.1923801422119141e+01 -6.0734001159667969e+01 -5.4677501678466797e+01 3.8678096771240234e+01 -6.2713600158691406e+01 -6.2656597137451172e+01 7.7358497619628906e+01 -5.4975402832031250e+01 -1.2475700378417969e+01 6.6670997619628906e+01 -5.4979000091552734e+01 -4.1205699920654297e+01 7.3550094604492188e+01 -5.4977699279785156e+01 -2.7057100296020508e+01 6.2013099670410156e+01 -6.0733798980712891e+01 -4.2893001556396484e+01 7.0040397644042969e+01 -5.9612998962402344e+01 -2.9782499313354492e+01 7.4474800109863281e+01 -5.9610603332519531e+01 -1.5645200729370117e+01 6.7477394104003906e+01 -6.3571102142333984e+01 -2.6760299682617188e+01 7.1366401672363281e+01 -6.3561000823974609e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 -3.3059700012207031e+01 4.8698802947998047e+01 -6.3504100799560547e+01 -3.2998302459716797e+01 2.0110498428344727e+01 -5.2329101562500000e+01 -3.2130302429199219e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 -3.2137401580810547e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 -3.2020099639892578e+01 4.9141799926757812e+01 2.8352600097656250e+01 -3.2989597320556641e+01 4.3039199829101562e+01 1.5969698905944824e+01 -3.3055599212646484e+01 4.7725498199462891e+01 3.9991699218750000e+01 -3.3097698211669922e+01 3.0614299774169922e+01 4.8633197784423828e+01 -3.3084796905517578e+01 1.3720000267028809e+01 5.0044700622558594e+01 -3.3111999511718750e+01 -5.6227302551269531e+00 3.5953800201416016e+01 -3.3097698211669922e+01 -3.5078903198242188e+01 4.5476398468017578e+01 -3.3045200347900391e+01 -2.1894300460815430e+01 9.9145097732543945e+00 -3.3083801269531250e+01 -4.9431201934814453e+01 2.5745399475097656e+01 -3.3058502197265625e+01 -4.3290298461914062e+01 4.9954399108886719e+01 -6.5034202575683594e+01 5.4540300369262695e+00 4.8967998504638672e+01 -6.7537704467773438e+01 1.3350299835205078e+01 5.0034500122070312e+01 -6.7539604187011719e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 -6.5033500671386719e+01 3.7523998260498047e+01 -4.3557899475097656e+01 -6.7537895202636719e+01 2.6049699783325195e+01 -2.8130199432373047e+01 -6.7539604187011719e+01 4.1621601104736328e+01 -4.9887100219726562e+01 -6.7539398193359375e+01 6.8354101181030273e+00 -4.7150398254394531e+01 -6.5031204223632812e+01 1.8047500610351562e+01 -4.0905799865722656e+01 -6.5034301757812500e+01 2.9103500366210938e+01 -9.2679700851440430e+00 -6.7539001464843750e+01 4.9685398101806641e+01 9.3136892318725586e+00 -6.7538703918457031e+01 4.9535301208496094e+01 2.6869998931884766e+01 -6.7538597106933594e+01 4.2637798309326172e+01 4.0471401214599609e+01 -6.7539604187011719e+01 2.9807500839233398e+01 4.8870899200439453e+01 -6.5032897949218750e+01 -1.3342700004577637e+01 2.4033800125122070e+01 -6.5031997680664062e+01 -4.4287799835205078e+01 3.8291000366210938e+01 -6.5033897399902344e+01 -3.2910102844238281e+01 4.7313400268554688e+01 -6.7535400390625000e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 -6.7537704467773438e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 -6.7539398193359375e+01 -4.9904800415039062e+01 3.7271400451660156e+01 -6.7538406372070312e+01 -3.3985900878906250e+01 2.5166799545288086e+01 -6.7537002563476562e+01 -4.3544601440429688e+01 1.0624900817871094e+01 -6.7538406372070312e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 -6.7537796020507812e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 -6.7539604187011719e+01 -2.9807500839233398e+01 1.2806200027465820e+01 -8.1073295593261719e+01 -3.8097999095916748e+00 1.3205300331115723e+01 -8.0267494201660156e+01 -5.5868902206420898e+00 1.3861199378967285e+01 -8.0269203186035156e+01 4.1422801017761230e+00 6.8685703277587891e+00 -8.0269203186035156e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 -8.0430801391601562e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 -8.1080497741699219e+01 1.2562399864196777e+01 6.8692898750305176e+00 -8.0268096923828125e+01 1.2766799926757812e+01 -2.6745600700378418e+00 -8.0267105102539062e+01 1.4119600296020508e+01 -1.0887900352478027e+01 -8.1082099914550781e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 -8.1073501586914062e+01 3.7914199829101562e+00 -1.3522299766540527e+01 -8.0268005371093750e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 -8.0268394470214844e+01 8.1145401000976562e+00 1.4918000221252441e+01 -8.0275100708007812e+01 -3.5685497283935547e+01 3.7123301029205322e+00 -8.0275100708007812e+01 -3.8456001281738281e+01 5.6025695800781250e+00 -6.7521499633789062e+01 -3.8081703186035156e+01 1.6305999755859375e+01 -6.7521499633789062e+01 -3.5007499694824219e+01 3.6341297149658203e+01 -6.7521499633789062e+01 -1.3186100006103516e+01 3.0869201660156250e+01 -8.0274299621582031e+01 -2.3010200500488281e+01 2.9183500289916992e+01 -6.7522102355957031e+01 -2.5193401336669922e+01 2.3136499404907227e+01 -8.0274299621582031e+01 -3.0677999496459961e+01 3.8549598693847656e+01 -8.0275100708007812e+01 -1.6160999536514282e+00 3.7004398345947266e+01 -8.0275100708007812e+01 -1.1183599472045898e+01 3.8620300292968750e+01 -6.7521499633789062e+01 8.1181198358535767e-01 -4.5067396163940430e+00 -6.7521499633789062e+01 -3.8375400543212891e+01 2.5930200576782227e+01 -8.0275100708007812e+01 2.8557600021362305e+01 3.1677902221679688e+01 -8.0274200439453125e+01 2.1873998641967773e+01 3.1033300399780273e+01 -6.7523498535156250e+01 2.2732900619506836e+01 2.0160699844360352e+01 -6.7523300170898438e+01 3.2750801086425781e+01 6.2813601493835449e+00 -6.7521499633789062e+01 3.8171100616455078e+01 1.6532600402832031e+01 -8.0275100708007812e+01 3.4899303436279297e+01 3.7707702636718750e+01 -8.0275100708007812e+01 8.4654598236083984e+00 3.6223800659179688e+01 -6.7521499633789062e+01 1.2949000358581543e+01 5.2079100608825684e+00 -8.0275100708007812e+01 3.8213302612304688e+01 -3.4080798625946045e+00 -8.0275100708007812e+01 3.8494800567626953e+01 -3.7614700317382812e+01 -8.0275100708007812e+01 9.4110794067382812e+00 -1.6054100036621094e+01 -8.0275100708007812e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 -8.0275100708007812e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 -8.0275100708007812e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 -8.0274406433105469e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 -8.0275001525878906e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 -8.0275001525878906e+01 3.4412902832031250e+01 -3.1601600646972656e+01 -8.0274200439453125e+01 2.1895799636840820e+01 -2.5230501174926758e+01 -8.0274902343750000e+01 2.9101999282836914e+01 -3.3142398834228516e+01 -6.7523193359375000e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 -6.7522598266601562e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 -6.7521499633789062e+01 6.3573803901672363e+00 -3.7880397796630859e+01 -6.7521499633789062e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 -6.7521499633789062e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 -6.7521804809570312e+01 2.5504301071166992e+01 -1.9341501235961914e+01 -6.7523002624511719e+01 3.3339103698730469e+01 -3.4695800781250000e+01 -6.7521499633789062e+01 1.6600400924682617e+01 -7.6062998771667480e+00 -6.7521499633789062e+01 3.7799701690673828e+01 -4.9609901428222656e+01 -3.0460399627685547e+01 8.1507596969604492e+00 -4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 -3.2965702056884766e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 -3.0460399627685547e+01 2.2791400909423828e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 3.5853599548339844e+01 -4.9730598449707031e+01 -3.2965702056884766e+01 6.7970499992370605e+00 2.9969398975372314e+00 -3.2965702056884766e+01 5.0145702362060547e+01 6.9386696815490723e+00 -3.0460399627685547e+01 4.9888397216796875e+01 4.8833702087402344e+01 -3.0460399627685547e+01 1.3304400444030762e+01 4.0471401214599609e+01 -3.0460399627685547e+01 2.9807500839233398e+01 4.9868400573730469e+01 -3.0460399627685547e+01 -6.8321399688720703e+00 2.5877500534057617e+01 -3.0460399627685547e+01 4.3248897552490234e+01 2.9460500717163086e+01 -3.2965702056884766e+01 4.0491600036621094e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 4.9272800445556641e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 4.3484500885009766e+01 -2.9969398975372314e+00 -3.2965702056884766e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 -3.2965702056884766e+01 -1.7957401275634766e+01 4.3438598632812500e+01 -3.0460399627685547e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 -3.0460399627685547e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 -3.0460399627685547e+01 -4.9272800445556641e+01 1.7176401138305664e+01 -3.0460399627685547e+01 -4.7315002441406250e+01 3.1059000015258789e+01 -3.0460399627685547e+01 -3.9376998901367188e+01 2.9829699993133545e+00 -3.0460399627685547e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 -3.0460399627685547e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 -3.0460399627685547e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 -8.1032798767089844e+01 1.1027499437332153e+00 1.0264200210571289e+01 -2.9614400863647461e+01 2.9392998218536377e+00 1.0690099716186523e+01 -4.1044399261474609e+01 0.0000000000000000e+00 8.1825199127197266e+00 -2.9608499526977539e+01 6.8735299110412598e+00 5.0151400566101074e+00 -2.9599399566650391e+01 9.4172601699829102e+00 -6.3304600715637207e+00 -2.9442100524902344e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 -2.9454700469970703e+01 1.2124200820922852e+01 -1.3189299583435059e+01 -2.9452299118041992e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 -2.9457300186157227e+01 6.2997603416442871e+00 6.3305301666259766e+00 -2.9442100524902344e+01 1.2118599891662598e+01 1.3189299583435059e+01 -2.9452299118041992e+01 2.1639201641082764e+00 1.2706499099731445e+01 -3.0459199905395508e+01 -6.5114102363586426e+00 3.8211998939514160e+00 -3.0459899902343750e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 -3.0458499908447266e+01 1.4018300056457520e+01 8.3117198944091797e+00 -3.0458000183105469e+01 1.1874300003051758e+01 1.4127900123596191e+01 -3.0459999084472656e+01 3.0538599491119385e+00 -1.2706499099731445e+01 -3.0459199905395508e+01 6.5114398002624512e+00 -8.3115901947021484e+00 -3.0458000183105469e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 -3.0459199905395508e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -6.0733798891305923e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 -8.0275103449821472e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 -6.0734100639820099e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 -8.0275103449821472e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 -8.0274902284145355e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 -6.5768599510192871e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 -5.9608001261949539e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 -6.5753698348999023e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 -5.9612501412630081e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 -4.3022301048040390e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 -5.4977700114250183e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 -4.8932299017906189e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 -8.0275103449821472e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 -8.0274999141693115e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 -5.4978098720312119e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 -6.3557997345924377e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 -8.0275103449821472e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 -3.8391999900341034e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 -3.2350499182939529e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 -3.2246299088001251e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 -3.2244000583887100e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 -6.5753698348999023e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 -4.8934601247310638e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 -4.3022301048040390e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 -4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 -4.9571000039577484e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 -3.7266198545694351e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 -4.3021600693464279e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 -4.3020900338888168e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 -3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 -3.4439001232385635e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 -3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 -3.8387499749660492e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 -3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 -6.5753698348999023e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 -5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 -4.3021000921726227e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 -3.2244600355625153e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 -6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 -4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 -6.3563100993633270e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 -5.4976001381874084e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 -6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 -5.9613000601530075e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 -6.0733798891305923e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 -4.8934601247310638e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 -4.9551699310541153e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 -6.5759703516960144e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 -5.4978098720312119e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 -5.9610001742839813e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 -6.0734100639820099e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 -6.3559398055076599e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 -8.0274201929569244e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 -6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 -3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 -3.7266198545694351e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 -4.3020900338888168e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 -3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 -3.7265900522470474e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 -5.9610601514577866e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 -4.9045100808143616e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 -6.1509799212217331e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 -6.5744303166866302e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 -5.9613000601530075e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 -4.9059398472309113e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 -4.9065399914979935e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 -4.9067698419094086e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 -3.2248001545667648e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 -3.6490198224782944e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 -4.3020900338888168e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 -3.2240301370620728e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 -3.8387499749660492e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 -4.9059398472309113e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 -4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 -3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 -6.5758101642131805e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 -8.0274298787117004e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 -8.0275103449821472e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 -4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 -4.8934098333120346e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 -5.4978400468826294e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 -6.5761797130107880e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 -6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 -5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 -4.8949200659990311e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 -4.3022301048040390e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 -4.8954900354146957e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 -4.3021898716688156e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 -4.3026499450206757e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 -3.2233700156211853e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 -3.2240901142358780e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 -3.2246299088001251e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 -3.4403301775455475e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 -3.2350499182939529e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 -3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 -2.9418099671602249e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fr_caster_l_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fr_caster_r_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -4.9000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 2 28 0 30 4 0 28 30 0 21 22 2 22 28 2 2 1 21 28 29 30 22 29 28 30 29 31 30 31 4 404 29 407 408 407 29 31 29 404 22 408 29 20 22 21 22 20 408 18 20 21 17 20 18 412 20 17 408 20 412 17 18 19 21 486 18 18 486 19 17 19 16 412 17 16 412 413 414 412 414 408 412 16 413 413 415 414 409 415 413 413 15 409 413 16 481 413 481 15 14 15 7 409 15 14 481 7 15 481 16 7 6 7 8 8 7 11 14 7 6 16 11 7 14 6 10 409 14 10 9 10 6 6 487 9 8 489 6 6 489 487 8 11 13 8 488 489 13 488 8 12 13 11 11 16 12 13 12 19 19 488 13 486 488 19 486 499 488 488 499 497 488 497 489 16 19 12 489 497 494 489 494 487 497 459 494 499 459 497 486 498 499 499 474 459 499 498 474 493 498 486 474 498 475 498 493 475 40 474 475 475 478 471 40 475 471 475 493 478 37 39 40 41 37 40 41 40 471 39 474 40 41 471 378 471 478 378 478 476 378 478 493 476 69 378 379 37 41 378 37 378 69 378 476 379 476 477 379 476 493 477 69 379 376 379 477 376 376 477 473 493 473 477 492 493 3 1 493 486 3 493 1 492 473 493 491 496 492 491 492 3 492 496 473 3 4 5 4 3 1 491 3 5 21 1 486 4 31 5 482 5 483 33 483 5 33 5 31 482 491 5 33 31 34 31 404 34 34 35 33 35 483 33 36 482 483 35 36 483 34 36 35 34 26 36 406 34 404 27 34 406 26 34 27 404 405 406 407 405 404 27 406 410 434 406 405 410 406 434 434 405 423 407 423 405 407 408 423 423 408 417 440 408 414 417 408 440 416 417 418 417 427 418 417 416 423 417 440 427 414 439 440 427 440 439 451 427 439 398 427 402 427 398 418 451 402 427 419 416 418 418 398 419 423 416 419 419 422 423 401 419 398 419 401 400 400 422 419 422 421 423 421 434 423 420 421 422 425 421 420 425 434 421 420 424 425 424 434 425 426 424 420 426 434 424 420 381 426 422 396 420 381 420 382 382 420 396 434 426 435 426 381 435 380 381 382 260 392 381 381 380 260 392 435 381 393 382 396 380 382 393 258 380 257 380 393 257 260 380 258 235 259 260 260 258 235 259 392 260 392 259 391 430 392 391 430 435 392 231 259 235 229 262 259 229 259 231 259 262 391 231 232 229 235 236 231 231 236 232 232 237 229 232 236 177 183 232 177 183 237 232 235 234 236 236 234 181 177 236 181 177 178 167 168 177 167 177 181 178 168 183 177 179 181 180 178 181 179 181 234 180 166 178 164 164 178 179 167 178 166 167 161 162 166 161 167 162 168 167 161 166 160 160 166 164 160 164 159 164 165 159 164 179 165 180 165 179 358 165 363 159 165 358 363 165 365 180 365 165 118 159 117 160 159 118 117 159 358 161 160 119 119 160 118 105 118 117 104 119 118 104 118 105 117 116 105 116 117 329 329 117 358 104 105 98 105 116 95 98 105 95 97 103 104 98 97 104 103 119 104 92 97 98 92 98 95 95 81 92 95 316 81 316 95 317 95 116 317 92 93 94 81 93 92 94 97 92 99 97 94 97 99 103 93 96 94 96 99 94 93 81 72 61 93 72 61 96 93 101 99 96 59 96 61 59 101 96 100 99 101 100 106 99 99 106 103 101 102 100 101 108 102 59 108 101 100 109 106 102 109 100 121 120 106 106 120 103 109 121 106 120 119 103 120 162 161 120 161 119 121 162 120 109 122 121 163 162 121 122 163 121 102 113 109 113 122 109 123 122 113 122 169 163 123 169 122 163 168 162 163 169 174 174 168 163 170 169 123 170 175 169 169 175 174 124 123 114 114 123 113 124 170 123 124 171 170 176 170 171 175 170 176 175 182 174 176 185 175 185 182 175 171 173 176 173 184 176 176 184 185 152 171 125 125 171 124 152 173 171 172 173 152 173 172 184 172 201 184 201 204 184 184 204 210 184 210 185 186 172 152 186 190 172 190 201 172 148 152 125 148 186 152 187 186 149 149 186 148 187 190 186 190 187 191 191 201 190 150 188 187 150 187 149 188 191 187 149 148 136 150 149 137 137 149 136 131 148 125 136 148 131 89 136 131 132 137 136 132 136 89 133 137 132 133 138 137 138 150 137 130 132 89 133 132 134 134 132 130 89 90 91 91 130 89 90 89 131 90 110 91 90 115 110 131 115 90 112 91 107 107 91 110 91 129 130 91 112 129 110 111 107 110 114 111 110 115 114 125 124 115 115 124 114 131 125 115 111 114 113 107 111 102 111 113 102 107 102 108 108 112 107 58 108 59 58 112 108 58 59 57 59 60 57 59 61 60 60 61 62 62 63 60 63 57 60 61 72 62 63 62 64 62 72 64 72 65 64 72 81 82 72 82 65 64 65 66 66 63 64 66 65 70 65 80 70 65 82 80 82 314 80 81 316 82 82 316 314 80 79 70 305 306 80 314 305 80 80 306 79 317 318 314 317 314 316 314 318 305 305 319 315 318 319 305 305 315 306 306 309 79 306 313 309 306 315 313 315 327 325 319 327 315 315 325 313 320 319 318 328 327 319 320 328 319 317 320 318 317 116 320 329 328 320 116 329 320 360 359 328 328 359 327 329 360 328 327 354 325 327 359 354 325 324 313 325 354 324 354 353 324 354 356 353 354 359 361 361 356 354 360 362 359 359 362 361 362 364 361 361 272 356 361 364 272 356 357 353 356 274 357 356 272 274 269 272 268 272 273 268 274 272 269 272 364 273 362 365 364 364 365 273 268 273 234 234 273 180 273 365 180 264 268 234 264 269 268 233 234 235 264 234 233 256 264 233 256 253 264 253 269 264 256 233 257 235 258 233 258 257 233 253 256 263 257 393 256 256 395 263 393 395 256 254 253 263 263 394 254 263 395 394 393 396 395 395 399 400 395 400 394 396 399 395 254 394 255 400 401 394 394 401 255 250 253 254 255 250 254 250 255 251 255 248 251 255 398 248 255 401 398 248 250 251 247 246 248 248 246 250 398 402 248 248 402 247 245 246 247 402 403 247 247 403 245 448 403 402 402 451 448 245 403 397 403 448 397 244 242 245 245 242 246 245 397 244 243 242 244 244 397 243 243 397 386 397 450 386 448 447 397 450 397 447 242 243 240 386 240 243 386 384 387 387 240 386 384 386 449 449 386 450 441 449 450 450 447 441 443 447 448 441 447 442 442 447 443 414 441 442 438 441 414 441 438 449 384 449 454 449 438 454 414 415 438 415 445 438 454 438 445 443 439 414 414 442 443 439 443 448 448 451 439 444 445 415 444 446 445 454 445 452 446 452 445 384 454 452 385 384 452 452 453 385 452 446 453 453 446 444 385 453 389 455 389 453 453 444 455 383 384 385 385 389 238 385 238 383 383 388 384 384 388 387 249 388 383 383 238 249 228 238 239 226 249 238 226 238 228 238 389 239 226 241 249 241 388 249 387 388 241 240 387 241 240 241 225 225 241 226 225 226 227 217 227 226 228 218 226 217 226 218 227 212 225 211 225 212 242 240 225 225 211 242 212 227 217 208 211 212 205 212 217 208 212 205 211 209 213 209 211 208 213 221 211 211 221 242 242 221 246 220 221 213 220 222 221 222 246 221 213 347 346 213 346 220 209 347 213 220 215 222 220 346 336 337 220 336 220 337 215 214 222 215 214 246 222 214 215 216 348 215 343 343 215 337 215 348 216 333 337 332 332 337 336 343 337 333 333 338 343 338 344 343 344 348 343 216 348 344 339 344 338 344 339 345 345 216 344 301 338 333 339 338 302 302 338 301 333 332 300 301 333 300 291 301 300 302 301 294 294 301 291 303 302 295 295 302 294 303 339 302 285 294 291 293 295 294 293 294 285 283 291 289 285 291 283 291 300 289 284 285 283 290 285 75 284 75 285 290 293 285 292 293 290 292 295 293 83 277 290 290 277 292 290 75 83 74 75 76 75 74 83 75 284 76 283 282 284 284 282 76 88 76 87 76 88 74 87 76 278 76 282 278 282 280 278 280 282 286 283 289 282 282 289 286 278 279 87 278 280 279 279 280 281 280 286 287 281 280 287 299 298 286 289 299 286 286 298 287 300 299 289 299 332 331 299 331 298 300 332 299 287 298 297 331 330 298 298 330 297 287 288 281 287 297 288 288 297 158 297 196 158 330 196 297 330 334 196 331 335 330 330 335 334 336 331 332 335 331 336 335 346 334 336 346 335 196 334 199 334 347 199 334 346 347 193 158 196 196 199 193 193 199 200 200 199 207 199 209 207 209 199 347 157 158 193 157 193 195 193 200 195 195 200 198 200 207 198 198 207 206 207 208 206 207 209 208 195 198 194 194 198 197 198 206 197 195 194 156 157 195 156 154 194 189 156 194 154 189 194 197 197 192 189 205 202 197 197 202 192 197 206 205 208 205 206 205 217 202 191 202 203 192 202 191 202 217 203 189 192 188 188 192 191 189 188 151 154 189 151 151 188 150 151 150 138 154 151 138 127 138 133 127 139 138 139 154 138 126 127 128 127 133 135 126 139 127 127 135 128 134 135 133 130 135 134 135 366 128 130 366 135 73 366 130 129 73 130 128 366 367 366 53 367 370 53 366 73 370 366 367 86 143 128 367 143 53 47 367 86 367 47 140 143 142 142 143 85 140 128 143 143 86 85 140 126 128 144 145 140 144 140 142 140 145 126 141 142 85 142 141 144 85 86 87 141 85 279 87 279 85 141 153 144 279 281 141 288 153 141 281 288 141 144 147 145 144 153 147 147 146 145 145 146 126 157 156 147 153 157 147 147 156 146 153 158 157 158 153 288 126 146 139 156 155 146 146 155 139 155 156 154 139 155 154 87 86 88 86 369 88 47 369 86 369 368 88 88 368 74 369 43 368 43 369 47 46 47 48 46 43 47 48 47 52 52 47 53 45 43 46 46 461 45 48 461 46 44 43 45 45 458 44 45 461 458 458 461 456 456 461 48 456 457 458 44 458 472 458 457 472 42 43 44 44 472 42 472 56 42 472 457 480 472 480 56 456 459 457 457 459 480 459 456 48 48 460 459 459 460 470 470 494 459 459 474 480 56 480 479 474 479 480 39 479 474 56 479 39 37 38 39 39 38 56 68 37 69 38 37 84 68 84 37 67 68 69 67 71 68 71 84 68 70 69 66 67 69 70 69 376 66 67 77 71 70 79 67 67 79 77 71 77 78 78 84 71 83 84 78 78 77 277 78 277 83 83 74 84 74 38 84 74 368 38 56 38 42 38 43 42 43 38 368 275 276 277 276 292 277 277 77 275 77 308 275 275 311 307 308 311 275 276 275 307 276 296 292 307 296 276 292 296 295 304 303 296 296 303 295 307 304 296 307 321 304 311 321 307 321 326 304 326 340 304 304 340 303 303 340 339 345 339 340 326 342 340 340 342 345 341 342 326 321 351 326 351 341 326 322 321 311 322 351 321 352 351 322 352 355 351 351 355 341 342 341 349 355 350 341 341 350 349 342 349 345 345 349 216 271 349 350 216 349 223 223 349 271 357 350 355 350 357 271 355 352 353 357 355 353 271 357 274 224 271 270 271 274 270 224 223 271 223 224 214 223 214 216 224 267 214 224 270 265 224 265 267 265 270 266 266 270 269 270 274 269 265 266 253 253 250 265 267 265 250 246 267 250 214 267 246 266 269 253 323 353 352 324 353 323 323 322 312 324 323 312 323 352 322 313 324 312 308 312 311 309 312 308 309 313 312 312 322 311 309 308 310 310 308 77 310 79 309 79 310 77 66 375 63 66 376 377 377 375 66 63 375 374 375 466 464 374 375 464 377 466 375 63 374 373 63 373 57 374 464 465 465 373 374 464 496 465 464 466 496 377 473 466 496 466 473 376 473 377 490 496 491 495 496 490 496 495 465 467 373 465 465 495 467 494 495 490 495 494 467 468 373 467 467 463 372 467 372 468 467 494 470 467 470 463 487 494 490 9 487 23 23 487 490 23 10 9 23 24 10 32 23 485 24 23 32 23 490 485 409 10 24 32 27 24 24 27 409 27 32 25 485 25 32 485 484 25 485 490 484 484 490 491 26 484 482 25 484 26 482 484 491 25 26 27 409 27 410 409 410 411 409 411 415 428 410 434 428 411 410 437 411 436 436 411 428 411 444 415 411 437 444 436 432 437 437 455 444 455 437 432 436 433 432 433 436 428 431 432 433 431 433 428 455 432 389 391 390 432 389 432 390 431 391 432 431 428 430 431 430 391 390 391 261 391 262 261 389 390 252 261 252 390 239 389 252 239 252 228 228 252 261 228 261 229 229 261 262 228 229 230 219 218 228 230 219 228 229 237 230 237 219 230 204 219 210 204 218 219 210 219 237 203 217 218 203 218 204 203 204 201 203 201 191 210 237 185 185 237 183 182 185 183 182 183 174 174 183 168 428 429 430 430 429 435 428 434 429 429 434 435 36 26 482 462 372 463 469 462 463 463 470 469 51 462 469 50 462 51 50 372 462 371 372 49 372 50 49 468 372 371 49 50 51 54 55 51 51 55 49 469 54 51 470 54 469 460 54 470 52 53 54 54 53 55 460 52 54 55 58 49 55 73 58 370 73 55 55 53 370 57 49 58 73 112 58 129 112 73 57 371 49 57 373 371 371 373 468 48 52 460 399 422 400 422 399 396 363 365 362 358 363 360 360 363 362 329 358 360))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(5.1378703117370605e+00 6.8265296936035156e+01 -9.3289899826049805e+00 2.7445201873779297e+00 6.8581901550292969e+01 -1.2800700187683105e+01 1.0573199987411499e+00 6.8359207153320312e+01 -1.0600199699401855e+01 1.0544799804687500e+01 6.8569099426269531e+01 -8.4442996978759766e+00 8.2298793792724609e+00 6.8419601440429688e+01 -6.8257398605346680e+00 1.0452800750732422e+01 6.8323402404785156e+01 -2.3365499973297119e+00 -6.6212201118469238e+00 6.8392799377441406e+01 8.3633699417114258e+00 -1.0304100036621094e+01 1.7535499572753906e+01 4.2757096290588379e+00 -9.9000797271728516e+00 6.8434997558593750e+01 4.3990101814270020e+00 -3.0437600612640381e+00 6.8367401123046875e+01 1.0238399505615234e+01 -3.0640001296997070e+00 1.7108699798583984e+01 1.0639900207519531e+01 -1.0523200035095215e+01 6.8192199707031250e+01 2.0460700988769531e+00 -1.0421499252319336e+01 6.8127601623535156e+01 -1.9288499355316162e+00 -1.1160599708557129e+01 6.8441001892089844e+01 -8.0958700180053711e-01 -7.1614899635314941e+00 1.7107900619506836e+01 8.4554700851440430e+00 -1.0192299842834473e+01 1.7057300567626953e+01 5.5663700103759766e+00 -1.0925999641418457e+01 1.7111598968505859e+01 -2.1682801246643066e+00 -8.4008197784423828e+00 1.7088899612426758e+01 -7.2349200248718262e+00 -6.7002696990966797e+00 6.8396400451660156e+01 -8.3113307952880859e+00 -9.4348793029785156e+00 6.8405799865722656e+01 -4.9726400375366211e+00 -5.3217201232910156e+00 1.7143899917602539e+01 -9.7155799865722656e+00 -2.8588600158691406e+00 6.8322502136230469e+01 -1.0273599624633789e+01 -1.0057700872421265e+00 1.7096700668334961e+01 -1.1044600486755371e+01 1.0178999900817871e+00 6.8367797851562500e+01 1.0607999801635742e+01 1.0090099573135376e+00 1.7097700119018555e+01 1.1044500350952148e+01 7.1427397727966309e+00 1.7195999145507812e+01 8.4595899581909180e+00 9.8030099868774414e+00 1.7092800140380859e+01 5.1623497009277344e+00 7.4257197380065918e+00 1.6894800186157227e+01 1.1212299346923828e+01 3.3442101478576660e+00 1.7096099853515625e+01 -1.0557999610900879e+01 6.1998200416564941e+00 1.6903999328613281e+01 -1.1747900009155273e+01 7.2372202873229980e+00 1.7205499649047852e+01 -8.3683700561523438e+00 9.8025293350219727e+00 1.7078998565673828e+01 -5.1738500595092773e+00 4.0853300094604492e+00 1.7077999114990234e+01 1.0249599456787109e+01 1.0831099510192871e+01 1.7257900238037109e+01 -2.0039701461791992e+00 1.2268199920654297e+01 1.6871999740600586e+01 3.9475402832031250e+00 1.1011500358581543e+01 1.7335899353027344e+01 0.0000000000000000e+00 1.0836700439453125e+01 1.7178098678588867e+01 2.0019199848175049e+00 -1.1417300224304199e+01 6.6068595886230469e+01 -6.0313899993896484e+01 -3.8845100402832031e+01 6.6098693847656250e+01 -4.7875999450683594e+01 -3.0698499679565430e+01 6.4885696411132812e+01 -3.9734401702880859e+01 -1.5955299377441406e+01 6.4939201354980469e+01 -4.7729400634765625e+01 -2.3467898368835449e+00 6.4994499206542969e+01 -5.1267002105712891e+01 -4.5538898468017578e+01 6.5077301025390625e+01 -2.5041301727294922e+01 -6.0313198089599609e+01 6.6034599304199219e+01 -7.4321599006652832e+00 -4.9943901062011719e+01 6.5038505554199219e+01 -1.3358200073242188e+01 -5.1267002105712891e+01 6.4994796752929688e+01 2.3467597961425781e+00 -4.8763401031494141e+01 6.5027900695800781e+01 1.6582399368286133e+01 -6.1740497589111328e+01 6.6020698547363281e+01 1.0151400566101074e+01 -4.5477100372314453e+01 6.4954597473144531e+01 2.1893899917602539e+01 1.6372301101684570e+01 6.6058395385742188e+01 5.8962200164794922e+01 2.3468399047851562e+00 6.4992599487304688e+01 5.1267200469970703e+01 -9.9129495620727539e+00 6.4916198730468750e+01 4.9431499481201172e+01 -3.6015296936035156e+01 6.4891899108886719e+01 3.4995300292968750e+01 -4.8726200103759766e+01 6.6080505371093750e+01 3.8182498931884766e+01 -2.5745399475097656e+01 6.4941505432128906e+01 4.3290298461914062e+01 -6.4798698425292969e+00 6.6077705383300781e+01 6.1833000183105469e+01 -3.9104801177978516e+01 6.4893997192382812e+01 -3.1760398864746094e+01 3.8039699554443359e+01 6.6068901062011719e+01 4.8811397552490234e+01 2.0110498428344727e+01 6.5001693725585938e+01 6.3504100799560547e+01 4.7388999938964844e+01 6.4940200805664062e+01 4.7388999938964844e+01 5.0501701354980469e+01 6.5800300598144531e+01 3.8274200439453125e+01 6.3447898864746094e+01 6.4940101623535156e+01 2.0092599868774414e+01 6.0778099060058594e+01 6.5855598449707031e+01 1.7475801467895508e+01 6.0313198089599609e+01 6.6034599304199219e+01 7.4321599006652832e+00 6.3284599304199219e+01 6.5808799743652344e+01 -4.4547400474548340e+00 5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 5.5512199401855469e+01 6.6128799438476562e+01 -2.7132499694824219e+01 2.8417900085449219e+01 6.4975593566894531e+01 -6.0260898590087891e+01 4.4547300338745117e+00 6.5808898925781250e+01 -6.3284301757812500e+01 3.3109401702880859e+01 6.6098304748535156e+01 -5.2159999847412109e+01 4.6935901641845703e+01 6.5001396179199219e+01 -4.6935901641845703e+01 4.6696701049804688e+00 6.4939994812011719e+01 -6.6339698791503906e+01 6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -1.2190400123596191e+01 6.4980697631835938e+01 6.5981704711914062e+01 -4.4070800781250000e+01 6.4974899291992188e+01 -4.9997600555419922e+01 -3.9661098480224609e+01 6.5756004333496094e+01 -5.7238800048828125e+01 -5.8180297851562500e+01 6.5755393981933594e+01 -3.8144996643066406e+01 1.5174099922180176e+01 6.5649505615234375e+01 -6.8473693847656250e+01 4.8838300704956055e+00 6.5753700256347656e+01 -6.9384094238281250e+01 4.1918899536132812e+01 6.5744300842285156e+01 -5.5662799835205078e+01 5.6185497283935547e+01 6.5768501281738281e+01 -4.1026100158691406e+01 6.9456398010253906e+01 6.5766296386718750e+01 -1.5821299552917480e+00 6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -2.1015600204467773e+01 6.5753700256347656e+01 -6.6359199523925781e+01 -2.0110498428344727e+01 6.5001693725585938e+01 -6.3504100799560547e+01 -6.9488693237304688e+01 6.5759704589843750e+01 1.4109100103378296e+00 -6.6339698791503906e+01 6.4939994812011719e+01 -4.6691398620605469e+00 -6.6359199523925781e+01 6.5753700256347656e+01 -2.1015600204467773e+01 -5.9817501068115234e+01 6.4940101623535156e+01 -2.9234298706054688e+01 -1.5645200729370117e+01 5.9610603332519531e+01 7.4474800109863281e+01 -1.7341400384902954e+00 5.9608001708984375e+01 7.6071098327636719e+01 5.1130599975585938e+00 6.3596702575683594e+01 7.2644706726074219e+01 7.1366401672363281e+01 6.3561000823974609e+01 1.3268600463867188e+01 6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 6.7477394104003906e+01 6.3571102142333984e+01 2.6760299682617188e+01 7.5355300903320312e+01 6.0731601715087891e+01 1.7170599699020386e+00 5.9104999542236328e+01 6.5766296386718750e+01 3.6562202453613281e+01 7.0040397644042969e+01 5.9612998962402344e+01 2.9782499313354492e+01 7.4474800109863281e+01 5.9610603332519531e+01 1.5645200729370117e+01 6.2013099670410156e+01 6.0733798980712891e+01 4.2893001556396484e+01 5.1923801422119141e+01 6.0734001159667969e+01 5.4677501678466797e+01 4.9207698822021484e+01 6.5768600463867188e+01 4.9181400299072266e+01 3.9661300659179688e+01 6.0734100341796875e+01 6.4126296997070312e+01 6.6670997619628906e+01 5.4979000091552734e+01 4.1205699920654297e+01 7.3550094604492188e+01 5.4977699279785156e+01 2.7057100296020508e+01 7.7358497619628906e+01 5.4975402832031250e+01 1.2475700378417969e+01 5.6843299865722656e+01 5.4978401184082031e+01 5.3966102600097656e+01 2.5049600601196289e+01 6.3557998657226562e+01 6.8122604370117188e+01 3.6946399688720703e+01 6.5759101867675781e+01 5.8903797149658203e+01 4.4562896728515625e+01 5.4979099273681641e+01 6.4476997375488281e+01 1.2114600181579590e+01 5.9610000610351562e+01 7.5127197265625000e+01 2.6272998809814453e+01 5.9612503051757812e+01 7.1428794860839844e+01 2.1015600204467773e+01 6.5753700256347656e+01 6.6359199523925781e+01 3.0671701431274414e+01 5.4978099822998047e+01 7.2120101928710938e+01 1.6111700057983398e+01 5.4976001739501953e+01 7.6686698913574219e+01 1.7856500148773193e+00 5.4973503112792969e+01 7.8329895019531250e+01 7.8330101013183594e+01 5.4972999572753906e+01 -1.7853500843048096e+00 7.9383201599121094e+01 4.9045101165771484e+01 -3.4461998939514160e-01 7.8114799499511719e+01 4.9050800323486328e+01 1.4203499794006348e+01 7.3951698303222656e+01 4.9059398651123047e+01 2.8930398941040039e+01 6.6686599731445312e+01 4.9065399169921875e+01 4.3129802703857422e+01 5.6477798461914062e+01 4.9067699432373047e+01 5.5839900970458984e+01 4.3869800567626953e+01 4.9065898895263672e+01 6.6202606201171875e+01 2.9704099655151367e+01 4.9060401916503906e+01 7.3644798278808594e+01 1.4941699981689453e+01 4.9052101135253906e+01 7.7977600097656250e+01 3.4459200501441956e-01 4.9045101165771484e+01 7.9383300781250000e+01 -6.4126296997070312e+01 6.0734100341796875e+01 3.9661300659179688e+01 -5.3850097656250000e+01 6.1509799957275391e+01 5.2007102966308594e+01 -5.6481498718261719e+01 6.5751998901367188e+01 4.0724998474121094e+01 -4.8838300704956055e+00 6.5753700256347656e+01 6.9384094238281250e+01 -1.5174099922180176e+01 6.5649505615234375e+01 6.8473693847656250e+01 -1.2475700378417969e+01 5.4975402832031250e+01 7.7358497619628906e+01 -2.9782499313354492e+01 5.9612998962402344e+01 7.0040397644042969e+01 -4.2893001556396484e+01 6.0733798980712891e+01 6.2013099670410156e+01 -2.8395601272583008e+01 6.3558399200439453e+01 6.6799201965332031e+01 -4.3375499725341797e+01 6.5742904663085938e+01 5.4680000305175781e+01 -2.7057100296020508e+01 5.4977699279785156e+01 7.3550094604492188e+01 -4.1205699920654297e+01 5.4979000091552734e+01 6.6670997619628906e+01 -5.3966102600097656e+01 5.4978401184082031e+01 5.6843299865722656e+01 -6.4476997375488281e+01 5.4979099273681641e+01 4.4562896728515625e+01 -6.7513504028320312e+01 6.3559398651123047e+01 2.6707201004028320e+01 -7.5355300903320312e+01 6.0731601715087891e+01 -1.7170599699020386e+00 -7.1374496459960938e+01 6.3563102722167969e+01 1.3211199760437012e+01 -6.7285202026367188e+01 6.5753700256347656e+01 1.7788499832153320e+01 -7.5127197265625000e+01 5.9610000610351562e+01 1.2114600181579590e+01 -7.1428794860839844e+01 5.9612503051757812e+01 2.6272998809814453e+01 -7.2120101928710938e+01 5.4978099822998047e+01 3.0671701431274414e+01 -7.6686698913574219e+01 5.4976001739501953e+01 1.6111700057983398e+01 -1.4203499794006348e+01 4.9050800323486328e+01 7.8114799499511719e+01 -2.8930398941040039e+01 4.9059398651123047e+01 7.3951698303222656e+01 -4.3129802703857422e+01 4.9065399169921875e+01 6.6686599731445312e+01 -5.4402599334716797e+01 4.8448303222656250e+01 5.7758701324462891e+01 -1.7856500148773193e+00 4.3026500701904297e+01 7.8329895019531250e+01 -7.8330101013183594e+01 5.4972999572753906e+01 1.7853500843048096e+00 -6.4116600036621094e+01 4.9052497863769531e+01 4.6979301452636719e+01 -6.7437301635742188e+01 5.0188701629638672e+01 4.1716197967529297e+01 -7.3951698303222656e+01 4.8940597534179688e+01 2.8930398941040039e+01 -7.8114799499511719e+01 4.8949199676513672e+01 1.4203499794006348e+01 -7.9383201599121094e+01 4.8954898834228516e+01 -3.4461998939514160e-01 7.8330101013183594e+01 4.3027000427246094e+01 1.7853500843048096e+00 7.6686698913574219e+01 4.3023998260498047e+01 1.6111700057983398e+01 7.2120101928710938e+01 4.3021900177001953e+01 3.0671701431274414e+01 6.4476997375488281e+01 4.3020900726318359e+01 4.4562896728515625e+01 5.3966102600097656e+01 4.3021598815917969e+01 5.6843299865722656e+01 7.5127197265625000e+01 3.8389999389648438e+01 1.2114600181579590e+01 7.5355300903320312e+01 3.7268402099609375e+01 -1.7170599699020386e+00 7.1428794860839844e+01 3.8387500762939453e+01 2.6272998809814453e+01 6.4126296997070312e+01 3.7265899658203125e+01 3.9661300659179688e+01 5.3850097656250000e+01 3.6490200042724609e+01 5.2007102966308594e+01 4.1205699920654297e+01 4.3020999908447266e+01 6.6670997619628906e+01 2.7057100296020508e+01 4.3022300720214844e+01 7.3550094604492188e+01 1.2475700378417969e+01 4.3024600982666016e+01 7.7358497619628906e+01 -1.2114600181579590e+01 3.8389999389648438e+01 7.5127197265625000e+01 1.7341400384902954e+00 3.8391998291015625e+01 7.6071098327636719e+01 4.2893001556396484e+01 3.7266197204589844e+01 6.2013099670410156e+01 2.9782499313354492e+01 3.8387001037597656e+01 7.0040397644042969e+01 1.5645200729370117e+01 3.8389400482177734e+01 7.4474800109863281e+01 5.6481498718261719e+01 3.2248001098632812e+01 4.0724998474121094e+01 6.7513504028320312e+01 3.4440597534179688e+01 2.6707201004028320e+01 7.1374496459960938e+01 3.4436901092529297e+01 1.3211199760437012e+01 6.9488693237304688e+01 3.2240303039550781e+01 1.4108999967575073e+00 6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 2.8395601272583008e+01 3.4441600799560547e+01 6.6799201965332031e+01 4.3375499725341797e+01 3.2257099151611328e+01 5.4680000305175781e+01 -5.1130700111389160e+00 3.4403301239013672e+01 7.2644706726074219e+01 1.5174099922180176e+01 3.2350498199462891e+01 6.8473693847656250e+01 -1.6111700057983398e+01 4.3023998260498047e+01 7.6686698913574219e+01 -3.0671701431274414e+01 4.3021900177001953e+01 7.2120101928710938e+01 -4.4562896728515625e+01 4.3020900726318359e+01 6.4476997375488281e+01 -5.6843299865722656e+01 4.3021598815917969e+01 5.3966102600097656e+01 -2.6272998809814453e+01 3.8387500762939453e+01 7.1428794860839844e+01 -3.9661300659179688e+01 3.7265899658203125e+01 6.4126296997070312e+01 -5.1923801422119141e+01 3.7266002655029297e+01 5.4677501678466797e+01 -7.7358497619628906e+01 4.3024600982666016e+01 1.2475700378417969e+01 -6.6670997619628906e+01 4.3020999908447266e+01 4.1205699920654297e+01 -7.3550094604492188e+01 4.3022300720214844e+01 2.7057100296020508e+01 -7.8330101013183594e+01 4.3027000427246094e+01 -1.7853500843048096e+00 -6.2013099670410156e+01 3.7266197204589844e+01 4.2893001556396484e+01 -7.0040397644042969e+01 3.8387001037597656e+01 2.9782499313354492e+01 -7.5355300903320312e+01 3.7268402099609375e+01 1.7170599699020386e+00 -7.4474800109863281e+01 3.8389400482177734e+01 1.5645200729370117e+01 -2.5049600601196289e+01 3.4442001342773438e+01 6.8122604370117188e+01 -4.9207698822021484e+01 3.2231403350830078e+01 4.9181400299072266e+01 -3.6946399688720703e+01 3.2240901947021484e+01 5.8903797149658203e+01 -2.1015600204467773e+01 3.2246299743652344e+01 6.6359199523925781e+01 -5.9104999542236328e+01 3.2233699798583984e+01 3.6562202453613281e+01 -6.7477394104003906e+01 3.4428897857666016e+01 2.6760299682617188e+01 -7.1366401672363281e+01 3.4439002990722656e+01 1.3268600463867188e+01 -6.7285202026367188e+01 3.2246299743652344e+01 1.7788499832153320e+01 -6.9456398010253906e+01 3.2233699798583984e+01 -1.5821199417114258e+00 4.8838300704956055e+00 3.2246299743652344e+01 6.9384094238281250e+01 -6.5954093933105469e+01 3.2996700286865234e+01 -1.1007699966430664e+01 -6.3504100799560547e+01 3.2998302459716797e+01 2.0110498428344727e+01 -6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 -2.0092599868774414e+01 3.3059898376464844e+01 -6.3447898864746094e+01 -4.1918899536132812e+01 3.2255702972412109e+01 -5.5662799835205078e+01 -1.5174099922180176e+01 3.2350498199462891e+01 -6.8473693847656250e+01 -5.0577800750732422e+01 3.3059898376464844e+01 4.3333198547363281e+01 -2.5114198684692383e+01 3.2994197845458984e+01 6.1894699096679688e+01 -4.6691398620605469e+00 3.3059997558593750e+01 6.6339698791503906e+01 -5.6185497283935547e+01 3.2231498718261719e+01 -4.1026100158691406e+01 -5.9442901611328125e+01 3.3025199890136719e+01 -3.0091600418090820e+01 -4.3333198547363281e+01 3.3059898376464844e+01 -5.0577800750732422e+01 -4.8838400840759277e+00 3.2246299743652344e+01 -6.9384094238281250e+01 4.6691398620605469e+00 3.3059997558593750e+01 -6.6339698791503906e+01 -6.1515499114990234e+01 3.1915601730346680e+01 7.3676099777221680e+00 -3.9422199249267578e+01 3.1880800247192383e+01 4.7579696655273438e+01 -4.8702198028564453e+01 3.2059200286865234e+01 3.9441997528076172e+01 -8.7784500122070312e+00 3.1910301208496094e+01 6.1264701843261719e+01 3.0705200195312500e+01 3.1882099151611328e+01 5.3397201538085938e+01 1.5252799987792969e+01 3.2137401580810547e+01 6.1349498748779297e+01 5.0155899047851562e+01 3.1926799774169922e+01 3.6021900177001953e+01 4.3594100952148438e+01 3.3036796569824219e+01 5.0356700897216797e+01 6.0698596954345703e+01 3.1933300018310547e+01 -6.7463498115539551e+00 6.6711799621582031e+01 3.2996097564697266e+01 1.3542500138282776e-01 5.9121696472167969e+01 3.1899499893188477e+01 1.8429199218750000e+01 5.9817501068115234e+01 3.3059898376464844e+01 2.9234298706054688e+01 2.0092599868774414e+01 3.3059898376464844e+01 6.3447898864746094e+01 -2.4017601013183594e+01 3.3075298309326172e+01 4.4330997467041016e+01 -1.2296899795532227e+01 3.3077796936035156e+01 4.8861900329589844e+01 -4.9878101348876953e+01 3.3076202392578125e+01 6.1260700225830078e+00 -4.7621898651123047e+01 3.2973300933837891e+01 2.0646100997924805e+01 -5.8962200164794922e+01 3.1941600799560547e+01 -1.6372301101684570e+01 -4.9968898773193359e+01 3.3071201324462891e+01 -5.5101404190063477e+00 -4.6904499053955078e+01 3.3098499298095703e+01 -1.8820098876953125e+01 -4.1162097930908203e+01 3.3084197998046875e+01 -2.8893501281738281e+01 -4.1316501617431641e+01 3.1871698379516602e+01 -4.6076801300048828e+01 -3.1769998550415039e+01 3.3059398651123047e+01 -3.8861301422119141e+01 -1.5955600738525391e+01 3.3101100921630859e+01 -4.8028099060058594e+01 -3.6749000549316406e+01 3.2989299774169922e+01 3.6192996978759766e+01 -7.4321599006652832e+00 3.1965400695800781e+01 -6.0313198089599609e+01 -4.9870600700378418e+00 3.2961700439453125e+01 -5.1429000854492188e+01 6.1151897907257080e-01 3.3100097656250000e+01 5.0388702392578125e+01 4.0430500030517578e+01 3.1952198028564453e+01 -4.7272399902343750e+01 2.1093599319458008e+01 3.2991901397705078e+01 -4.7210800170898438e+01 5.7853302955627441e+00 3.3030902862548828e+01 -5.0313201904296875e+01 4.5625198364257812e+01 3.2923900604248047e+01 -2.5078199386596680e+01 5.2289600372314453e+01 3.2952899932861328e+01 -4.6615300178527832e+00 4.9076499938964844e+01 3.2969501495361328e+01 1.6025699615478516e+01 3.6085098266601562e+01 3.3112297058105469e+01 3.5027797698974609e+01 4.5658901214599609e+01 3.3043701171875000e+01 2.1977499008178711e+01 1.2848500251770020e+01 3.3077198028564453e+01 4.8701698303222656e+01 2.4957799911499023e+01 3.3075702667236328e+01 4.3825702667236328e+01 3.6392799377441406e+01 3.2986000061035156e+01 -3.6605201721191406e+01 5.6047599792480469e+01 3.1980998992919922e+01 -2.7524799346923828e+01 4.4547400474548340e+00 3.2191196441650391e+01 -6.3284599304199219e+01 2.7442001342773438e+01 3.2047397613525391e+01 -5.6365200042724609e+01 -1.7475801467895508e+01 3.2144401550292969e+01 -6.0778099060058594e+01 6.3447898864746094e+01 3.3059898376464844e+01 -2.0092599868774414e+01 5.0577800750732422e+01 3.3059898376464844e+01 -4.3333198547363281e+01 2.9234298706054688e+01 3.3059898376464844e+01 -5.9817501068115234e+01 2.1015600204467773e+01 3.2246299743652344e+01 -6.6359199523925781e+01 5.6820499420166016e+01 3.2238201141357422e+01 -4.0331298828125000e+01 6.6359199523925781e+01 3.2246299743652344e+01 -2.1015600204467773e+01 4.3921298980712891e+01 3.2241901397705078e+01 -5.3944599151611328e+01 1.5645200729370117e+01 5.9610603332519531e+01 -7.4474800109863281e+01 1.7341400384902954e+00 5.9608001708984375e+01 -7.6071098327636719e+01 -5.1130700111389160e+00 6.3596702575683594e+01 -7.2644706726074219e+01 -6.7477394104003906e+01 6.3571102142333984e+01 -2.6760299682617188e+01 -7.1366401672363281e+01 6.3561000823974609e+01 -1.3268600463867188e+01 -7.0040397644042969e+01 5.9612998962402344e+01 -2.9782499313354492e+01 -7.4474800109863281e+01 5.9610603332519531e+01 -1.5645200729370117e+01 -6.2013099670410156e+01 6.0733798980712891e+01 -4.2893001556396484e+01 -5.1923801422119141e+01 6.0734001159667969e+01 -5.4677501678466797e+01 -5.1424598693847656e+01 6.4527305603027344e+01 -4.9469097137451172e+01 -3.9661300659179688e+01 6.0734100341796875e+01 -6.4126296997070312e+01 -6.6670997619628906e+01 5.4979000091552734e+01 -4.1205699920654297e+01 -7.3550094604492188e+01 5.4977699279785156e+01 -2.7057100296020508e+01 -7.7358497619628906e+01 5.4975402832031250e+01 -1.2475700378417969e+01 -5.6843299865722656e+01 5.4978401184082031e+01 -5.3966102600097656e+01 -2.5049600601196289e+01 6.3557998657226562e+01 -6.8122604370117188e+01 -4.4562896728515625e+01 5.4979099273681641e+01 -6.4476997375488281e+01 -1.2114600181579590e+01 5.9610000610351562e+01 -7.5127197265625000e+01 -2.6272998809814453e+01 5.9612503051757812e+01 -7.1428794860839844e+01 -3.0671701431274414e+01 5.4978099822998047e+01 -7.2120101928710938e+01 -1.6111700057983398e+01 5.4976001739501953e+01 -7.6686698913574219e+01 -1.7856500148773193e+00 5.4973503112792969e+01 -7.8329895019531250e+01 -7.7977600097656250e+01 4.8947898864746094e+01 -1.4941699981689453e+01 -7.3644798278808594e+01 4.8939601898193359e+01 -2.9704099655151367e+01 -6.6202606201171875e+01 4.8934097290039062e+01 -4.3869800567626953e+01 -5.5839900970458984e+01 4.8932300567626953e+01 -5.6477798461914062e+01 -4.3129802703857422e+01 4.8934600830078125e+01 -6.6686599731445312e+01 -2.8930398941040039e+01 4.8940597534179688e+01 -7.3951698303222656e+01 -1.4203499794006348e+01 4.8949199676513672e+01 -7.8114799499511719e+01 3.4459200501441956e-01 4.8954898834228516e+01 -7.9383300781250000e+01 6.4126296997070312e+01 6.0734100341796875e+01 -3.9661300659179688e+01 5.3850097656250000e+01 6.1509799957275391e+01 -5.2007102966308594e+01 1.2475700378417969e+01 5.4975402832031250e+01 -7.7358497619628906e+01 2.9782499313354492e+01 5.9612998962402344e+01 -7.0040397644042969e+01 4.2893001556396484e+01 6.0733798980712891e+01 -6.2013099670410156e+01 2.8395601272583008e+01 6.3558399200439453e+01 -6.6799201965332031e+01 2.7057100296020508e+01 5.4977699279785156e+01 -7.3550094604492188e+01 4.1205699920654297e+01 5.4979000091552734e+01 -6.6670997619628906e+01 5.3966102600097656e+01 5.4978401184082031e+01 -5.6843299865722656e+01 6.7513504028320312e+01 6.3559398651123047e+01 -2.6707201004028320e+01 6.4476997375488281e+01 5.4979099273681641e+01 -4.4562896728515625e+01 7.1374496459960938e+01 6.3563102722167969e+01 -1.3211199760437012e+01 7.5127197265625000e+01 5.9610000610351562e+01 -1.2114600181579590e+01 7.1428794860839844e+01 5.9612503051757812e+01 -2.6272998809814453e+01 7.2120101928710938e+01 5.4978099822998047e+01 -3.0671701431274414e+01 7.6686698913574219e+01 5.4976001739501953e+01 -1.6111700057983398e+01 1.4941699981689453e+01 4.8947898864746094e+01 -7.7977600097656250e+01 2.9704099655151367e+01 4.8939601898193359e+01 -7.3644798278808594e+01 4.1731800079345703e+01 4.8429000854492188e+01 -6.7475105285644531e+01 4.9999198913574219e+01 4.9000503540039062e+01 -6.1567001342773438e+01 5.7531902313232422e+01 4.9579898834228516e+01 -5.4633300781250000e+01 1.7856500148773193e+00 4.3026500701904297e+01 -7.8329895019531250e+01 6.6202606201171875e+01 4.9065898895263672e+01 -4.3869800567626953e+01 7.3644798278808594e+01 4.9060401916503906e+01 -2.9704099655151367e+01 7.7977600097656250e+01 4.9052101135253906e+01 -1.4941699981689453e+01 -7.6686698913574219e+01 4.3023998260498047e+01 -1.6111700057983398e+01 -7.2120101928710938e+01 4.3021900177001953e+01 -3.0671701431274414e+01 -6.4476997375488281e+01 4.3020900726318359e+01 -4.4562896728515625e+01 -5.3966102600097656e+01 4.3021598815917969e+01 -5.6843299865722656e+01 -7.5127197265625000e+01 3.8389999389648438e+01 -1.2114600181579590e+01 -7.1428794860839844e+01 3.8387500762939453e+01 -2.6272998809814453e+01 -6.4126296997070312e+01 3.7265899658203125e+01 -3.9661300659179688e+01 -5.3850097656250000e+01 3.6490200042724609e+01 -5.2007102966308594e+01 -4.1205699920654297e+01 4.3020999908447266e+01 -6.6670997619628906e+01 -2.7057100296020508e+01 4.3022300720214844e+01 -7.3550094604492188e+01 -1.2475700378417969e+01 4.3024600982666016e+01 -7.7358497619628906e+01 1.2114600181579590e+01 3.8389999389648438e+01 -7.5127197265625000e+01 -1.7341400384902954e+00 3.8391998291015625e+01 -7.6071098327636719e+01 -4.2893001556396484e+01 3.7266197204589844e+01 -6.2013099670410156e+01 -2.9782499313354492e+01 3.8387001037597656e+01 -7.0040397644042969e+01 -1.5645200729370117e+01 3.8389400482177734e+01 -7.4474800109863281e+01 -6.7513504028320312e+01 3.4440597534179688e+01 -2.6707201004028320e+01 -7.1374496459960938e+01 3.4436901092529297e+01 -1.3211199760437012e+01 -2.8395601272583008e+01 3.4441600799560547e+01 -6.6799201965332031e+01 5.1130599975585938e+00 3.4403301239013672e+01 -7.2644706726074219e+01 2.5049600601196289e+01 3.4442001342773438e+01 -6.8122604370117188e+01 1.6111700057983398e+01 4.3023998260498047e+01 -7.6686698913574219e+01 3.0671701431274414e+01 4.3021900177001953e+01 -7.2120101928710938e+01 4.2744701385498047e+01 4.1740497589111328e+01 -6.5250297546386719e+01 5.6843299865722656e+01 4.3021598815917969e+01 -5.3966102600097656e+01 2.6272998809814453e+01 3.8387500762939453e+01 -7.1428794860839844e+01 5.1923801422119141e+01 3.7266002655029297e+01 -5.4677501678466797e+01 3.8678096771240234e+01 3.5286399841308594e+01 -6.2656597137451172e+01 7.7358497619628906e+01 4.3024600982666016e+01 -1.2475700378417969e+01 6.6670997619628906e+01 4.3020999908447266e+01 -4.1205699920654297e+01 7.3550094604492188e+01 4.3022300720214844e+01 -2.7057100296020508e+01 6.2013099670410156e+01 3.7266197204589844e+01 -4.2893001556396484e+01 7.0040397644042969e+01 3.8387001037597656e+01 -2.9782499313354492e+01 7.4474800109863281e+01 3.8389400482177734e+01 -1.5645200729370117e+01 6.7477394104003906e+01 3.4428897857666016e+01 -2.6760299682617188e+01 7.1366401672363281e+01 3.4439002990722656e+01 -1.3268600463867188e+01 -4.6283000946044922e+01 6.4940299987792969e+01 4.8698802947998047e+01 -6.3504100799560547e+01 6.5001693725585938e+01 2.0110498428344727e+01 -5.2329101562500000e+01 6.5869697570800781e+01 -3.4909000396728516e+01 -6.1349498748779297e+01 6.5862602233886719e+01 -1.5252799987792969e+01 -3.8747798919677734e+01 6.5979896545410156e+01 4.9141799926757812e+01 2.8352600097656250e+01 6.5010398864746094e+01 4.3039199829101562e+01 1.5969698905944824e+01 6.4944404602050781e+01 4.7725498199462891e+01 3.9991699218750000e+01 6.4902297973632812e+01 3.0614299774169922e+01 4.8633197784423828e+01 6.4915199279785156e+01 1.3720000267028809e+01 5.0044700622558594e+01 6.4888000488281250e+01 -5.6227302551269531e+00 3.5953800201416016e+01 6.4902297973632812e+01 -3.5078903198242188e+01 4.5476398468017578e+01 6.4954803466796875e+01 -2.1894300460815430e+01 9.9145097732543945e+00 6.4916198730468750e+01 -4.9431201934814453e+01 2.5745399475097656e+01 6.4941505432128906e+01 -4.3290298461914062e+01 4.9954399108886719e+01 3.2965801239013672e+01 5.4540300369262695e+00 4.8967998504638672e+01 3.0462301254272461e+01 1.3350299835205078e+01 5.0034500122070312e+01 3.0460399627685547e+01 -4.1453199386596680e+00 -3.3270900726318359e+01 3.2966499328613281e+01 3.7523998260498047e+01 -4.3557899475097656e+01 3.0462099075317383e+01 2.6049699783325195e+01 -2.8130199432373047e+01 3.0460399627685547e+01 4.1621601104736328e+01 -4.9887100219726562e+01 3.0460599899291992e+01 6.8354101181030273e+00 -4.7150398254394531e+01 3.2968799591064453e+01 1.8047500610351562e+01 -4.0905799865722656e+01 3.2965702056884766e+01 2.9103500366210938e+01 -9.2679700851440430e+00 3.0461000442504883e+01 4.9685398101806641e+01 9.3136892318725586e+00 3.0461299896240234e+01 4.9535301208496094e+01 2.6869998931884766e+01 3.0461400985717773e+01 4.2637798309326172e+01 4.0471401214599609e+01 3.0460399627685547e+01 2.9807500839233398e+01 4.8870899200439453e+01 3.2967102050781250e+01 -1.3342700004577637e+01 2.4033800125122070e+01 3.2967998504638672e+01 -4.4287799835205078e+01 3.8291000366210938e+01 3.2966098785400391e+01 -3.2910102844238281e+01 4.7313400268554688e+01 3.0464601516723633e+01 -1.8334699630737305e+01 -4.8967998504638672e+01 3.0462301254272461e+01 -1.3350299835205078e+01 -6.9415998458862305e+00 3.0460599899291992e+01 -4.9904800415039062e+01 3.7271400451660156e+01 3.0461599349975586e+01 -3.3985900878906250e+01 2.5166799545288086e+01 3.0463001251220703e+01 -4.3544601440429688e+01 1.0624900817871094e+01 3.0461599349975586e+01 -4.9357997894287109e+01 -2.6072299957275391e+01 3.0462200164794922e+01 -4.3274299621582031e+01 -4.0471401214599609e+01 3.0460399627685547e+01 -2.9807500839233398e+01 1.2806200027465820e+01 1.6926700592041016e+01 -3.8097999095916748e+00 1.3205300331115723e+01 1.7732500076293945e+01 -5.5868902206420898e+00 1.3861199378967285e+01 1.7730800628662109e+01 4.1422801017761230e+00 6.8685703277587891e+00 1.7730800628662109e+01 -1.2765500068664551e+01 -3.6473600864410400e+00 1.7569198608398438e+01 -1.3761699676513672e+01 -5.0008997917175293e+00 1.6919498443603516e+01 1.2562399864196777e+01 6.8692898750305176e+00 1.7731899261474609e+01 1.2766799926757812e+01 -2.6745600700378418e+00 1.7732898712158203e+01 1.4119600296020508e+01 -1.0887900352478027e+01 1.6917900085449219e+01 -8.1607704162597656e+00 -1.2876600265502930e+01 1.6926498413085938e+01 3.7914199829101562e+00 -1.3522299766540527e+01 1.7732000350952148e+01 -5.6108503341674805e+00 -1.2266799926757812e+01 1.7731599807739258e+01 8.1145401000976562e+00 1.4918000221252441e+01 1.7724899291992188e+01 -3.5685497283935547e+01 3.7123301029205322e+00 1.7724899291992188e+01 -3.8456001281738281e+01 5.6025695800781250e+00 3.0478500366210938e+01 -3.8081703186035156e+01 1.6305999755859375e+01 3.0478500366210938e+01 -3.5007499694824219e+01 3.6341297149658203e+01 3.0478500366210938e+01 -1.3186100006103516e+01 3.0869201660156250e+01 1.7725700378417969e+01 -2.3010200500488281e+01 2.9183500289916992e+01 3.0477899551391602e+01 -2.5193401336669922e+01 2.3136499404907227e+01 1.7725700378417969e+01 -3.0677999496459961e+01 3.8549598693847656e+01 1.7724899291992188e+01 -1.6160999536514282e+00 3.7004398345947266e+01 1.7724899291992188e+01 -1.1183599472045898e+01 3.8620300292968750e+01 3.0478500366210938e+01 8.1181198358535767e-01 -4.5067396163940430e+00 3.0478500366210938e+01 -3.8375400543212891e+01 2.5930200576782227e+01 1.7724899291992188e+01 2.8557600021362305e+01 3.1677902221679688e+01 1.7725799560546875e+01 2.1873998641967773e+01 3.1033300399780273e+01 3.0476499557495117e+01 2.2732900619506836e+01 2.0160699844360352e+01 3.0476699829101562e+01 3.2750801086425781e+01 6.2813601493835449e+00 3.0478500366210938e+01 3.8171100616455078e+01 1.6532600402832031e+01 1.7724899291992188e+01 3.4899303436279297e+01 3.7707702636718750e+01 1.7724899291992188e+01 8.4654598236083984e+00 3.6223800659179688e+01 3.0478500366210938e+01 1.2949000358581543e+01 5.2079100608825684e+00 1.7724899291992188e+01 3.8213302612304688e+01 -3.4080798625946045e+00 1.7724899291992188e+01 3.8494800567626953e+01 -3.7614700317382812e+01 1.7724899291992188e+01 9.4110794067382812e+00 -1.6054100036621094e+01 1.7724899291992188e+01 -3.5240402221679688e+01 -5.2079100608825684e+00 1.7724899291992188e+01 -3.8213302612304688e+01 -3.8329299926757812e+01 1.7724899291992188e+01 -5.8210501670837402e+00 -3.2840499877929688e+01 1.7725599288940430e+01 -1.9909101486206055e+01 -2.6819799423217773e+01 1.7725000381469727e+01 -2.7747999191284180e+01 -1.7555700302124023e+01 1.7725000381469727e+01 3.4412902832031250e+01 -3.1601600646972656e+01 1.7725799560546875e+01 2.1895799636840820e+01 -2.5230501174926758e+01 1.7725101470947266e+01 2.9101999282836914e+01 -3.3142398834228516e+01 3.0476799011230469e+01 -1.9787399291992188e+01 -2.4508100509643555e+01 3.0477401733398438e+01 -2.9667200088500977e+01 -3.8129898071289062e+01 3.0478500366210938e+01 6.3573803901672363e+00 -3.7880397796630859e+01 3.0478500366210938e+01 -7.4131999015808105e+00 -1.6590700149536133e+01 3.0478500366210938e+01 -3.4709499359130859e+01 -2.8872499465942383e+01 3.0478199005126953e+01 2.5504301071166992e+01 -1.9341501235961914e+01 3.0477001190185547e+01 3.3339103698730469e+01 -3.4695800781250000e+01 3.0478500366210938e+01 1.6600400924682617e+01 -7.6062998771667480e+00 3.0478500366210938e+01 3.7799701690673828e+01 -4.9609901428222656e+01 6.7539604187011719e+01 8.1507596969604492e+00 -4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 -4.9947601318359375e+01 6.5034301757812500e+01 -5.4530901908874512e+00 -4.4943298339843750e+01 6.7539604187011719e+01 2.2791400909423828e+01 -3.5167198181152344e+01 6.7539604187011719e+01 3.5853599548339844e+01 -4.9730598449707031e+01 6.5034301757812500e+01 6.7970499992370605e+00 2.9969398975372314e+00 6.5034301757812500e+01 5.0145702362060547e+01 6.9386696815490723e+00 6.7539604187011719e+01 4.9888397216796875e+01 4.8833702087402344e+01 6.7539604187011719e+01 1.3304400444030762e+01 4.0471401214599609e+01 6.7539604187011719e+01 2.9807500839233398e+01 4.9868400573730469e+01 6.7539604187011719e+01 -6.8321399688720703e+00 2.5877500534057617e+01 6.7539604187011719e+01 4.3248897552490234e+01 2.9460500717163086e+01 6.5034301757812500e+01 4.0491600036621094e+01 -1.0601699829101562e+01 6.7539604187011719e+01 4.9272800445556641e+01 -2.4852701187133789e+01 6.7539604187011719e+01 4.3484500885009766e+01 -2.9969398975372314e+00 6.5034301757812500e+01 -5.0145702362060547e+01 -4.6939998626708984e+01 6.5034301757812500e+01 -1.7957401275634766e+01 4.3438598632812500e+01 6.7539604187011719e+01 -2.5998600006103516e+01 -2.4852701187133789e+01 6.7539604187011719e+01 -4.3484500885009766e+01 -1.0601699829101562e+01 6.7539604187011719e+01 -4.9272800445556641e+01 1.7176401138305664e+01 6.7539604187011719e+01 -4.7315002441406250e+01 3.1059000015258789e+01 6.7539604187011719e+01 -3.9376998901367188e+01 2.9829699993133545e+00 6.7539604187011719e+01 -5.0146999359130859e+01 -3.5167198181152344e+01 6.7539604187011719e+01 -3.5853599548339844e+01 -4.4943298339843750e+01 6.7539604187011719e+01 -2.2791400909423828e+01 -1.1755400657653809e+01 1.6967199325561523e+01 1.1027499437332153e+00 1.0264200210571289e+01 6.8385604858398438e+01 2.9392998218536377e+00 1.0690099716186523e+01 5.6955596923828125e+01 0.0000000000000000e+00 8.1825199127197266e+00 6.8391502380371094e+01 6.8735299110412598e+00 5.0151400566101074e+00 6.8400596618652344e+01 9.4172601699829102e+00 -6.3304600715637207e+00 6.8557899475097656e+01 -1.2118599891662598e+01 -5.5505099296569824e+00 6.8545295715332031e+01 1.2124200820922852e+01 -1.3189299583435059e+01 6.8547706604003906e+01 -2.1639201641082764e+00 -1.1655500411987305e+01 6.8542694091796875e+01 6.2997603416442871e+00 6.3305301666259766e+00 6.8557899475097656e+01 1.2118599891662598e+01 1.3189299583435059e+01 6.8547706604003906e+01 2.1639201641082764e+00 1.2706499099731445e+01 6.7540802001953125e+01 -6.5114102363586426e+00 3.8211998939514160e+00 6.7540100097656250e+01 -1.4019599914550781e+01 -3.8208501338958740e+00 6.7541503906250000e+01 1.4018300056457520e+01 8.3117198944091797e+00 6.7541999816894531e+01 1.1874300003051758e+01 1.4127900123596191e+01 6.7540000915527344e+01 3.0538599491119385e+00 -1.2706499099731445e+01 6.7540802001953125e+01 6.5114398002624512e+00 -8.3115901947021484e+00 6.7541999816894531e+01 -1.1874400138854980e+01 -1.4127199172973633e+01 6.7540802001953125e+01 -3.0536701679229736e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 81 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 3.7266198545694351e+01 6.2013100832700729e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 3.2350499182939529e+01 6.8473696708679199e+01) (float-vector 1.6532599925994873e+01 1.7724899575114250e+01 3.4899301826953888e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661299437284470e+01 3.7265900522470474e+01 6.4126297831535339e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -3.4080799669027328e+00 1.7724899575114250e+01 3.8494799286127090e+01) (float-vector -2.5230500847101212e+01 1.7725100740790367e+01 2.9101999476552010e+01) (float-vector -4.9207698553800583e+01 3.2231401652097702e+01 4.9181401729583740e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7341399798169732e+00 3.8391999900341034e+01 7.6071098446846008e+01) (float-vector -2.1015599370002747e+01 3.2246299088001251e+01 6.6359199583530426e+01) (float-vector -2.6272999122738838e+01 3.8387499749660492e+01 7.1428798139095306e+01) (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 2.7057100087404251e+01 5.4977700114250183e+01 -7.3550097644329071e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.7057100087404251e+01 4.3022301048040390e+01 7.3550097644329071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 5.6477800011634827e+01 4.9067698419094086e+01 5.5839899927377701e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -3.7614699453115463e+01 1.7724899575114250e+01 9.4110798090696335e+00) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.6819799095392227e+01 1.7725000157952309e+01 -2.7747999876737595e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 3.0671700835227966e+01 4.3021898716688156e+01 -7.2120100259780884e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.5049600750207901e+01 3.4442000091075897e+01 -6.8122602999210358e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector -5.2079102024435997e+00 1.7724899575114250e+01 -3.8213301450014114e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector 1.7341399798169732e+00 5.9608001261949539e+01 -7.6071098446846008e+01) (float-vector 1.5174100175499916e+01 6.5649501979351044e+01 -6.8473696708679199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1015599370002747e+01 6.5753698348999023e+01 -6.6359199583530426e+01) (float-vector -3.9661098271608353e+01 6.5756000578403473e+01 -5.7238798588514328e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -6.7285202443599701e+01 3.2246299088001251e+01 1.7788499593734741e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 6.6686600446701050e+01 4.9065399914979935e+01 4.3129801750183105e+01) (float-vector 7.3550097644329071e+01 5.4977700114250183e+01 2.7057100087404251e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01) (float-vector 7.9383201897144318e+01 4.9045100808143616e+01 -3.4461999894119799e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 4.1731800884008408e+01 4.8429001122713089e+01 -6.7475102841854095e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 4.2892999947071075e+01 6.0733798891305923e+01 -6.2013100832700729e+01) (float-vector 5.3966101258993149e+01 5.4978400468826294e+01 -5.6843299418687820e+01) (float-vector 6.4476996660232544e+01 5.4979100823402405e+01 -4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01) (float-vector 5.6185498833656311e+01 6.5768502652645111e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.1366399526596069e+01 6.3560999929904938e+01 1.3268600217998028e+01) (float-vector 6.6359199583530426e+01 6.5753698348999023e+01 -2.1015599370002747e+01) (float-vector 7.1428798139095306e+01 5.9612501412630081e+01 -2.6272999122738838e+01) (float-vector 7.5355298817157745e+01 6.0731600970029831e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector -4.8838402144610882e+00 3.2246299088001251e+01 -6.9384098052978516e+01) (float-vector 1.2114600278437138e+01 3.8389999419450760e+01 -7.5127199292182922e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -6.6670998930931091e+01 5.4979000240564346e+01 -4.1205700486898422e+01) (float-vector -5.8180298656225204e+01 6.5755397081375122e+01 -3.8144998252391815e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 4.3020900338888168e+01 -4.4562898576259613e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -5.6185498833656311e+01 3.2231498509645462e+01 -4.1026100516319275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.3644801974296570e+01 4.8939600586891174e+01 -2.9704099521040916e+01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1374498307704926e+01 3.4436900168657303e+01 -1.3211200013756752e+01) (float-vector -7.6686702668666840e+01 4.3023999780416489e+01 -1.6111699864268303e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.5355298817157745e+01 3.7268400192260742e+01 1.7170599894598126e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0040397346019745e+01 3.8387000560760498e+01 2.9782500118017197e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.2013100832700729e+01 3.7266198545694351e+01 4.2892999947071075e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.3129801750183105e+01 4.9065399914979935e+01 6.6686600446701050e+01) (float-vector -5.4402600973844528e+01 4.8448301851749420e+01 5.7758700102567673e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.9488696753978729e+01 3.2240301370620728e+01 1.4109000330790877e+00) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 7.2120100259780884e+01 4.3021898716688156e+01 3.0671700835227966e+01) (float-vector 7.5127199292182922e+01 3.8389999419450760e+01 1.2114600278437138e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.4126297831535339e+01 3.7265900522470474e+01 3.9661299437284470e+01) (float-vector 6.7513503134250641e+01 3.4440599381923676e+01 2.6707200333476067e+01) (float-vector 3.1677901744842529e+01 1.7725799232721329e+01 2.1873999387025833e+01) (float-vector 4.3375499546527863e+01 3.2257098704576492e+01 5.4680000990629196e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -4.2892999947071075e+01 6.0733798891305923e+01 6.2013100832700729e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 6.2013100832700729e+01 6.0733798891305923e+01 4.2892999947071075e+01) (float-vector 4.4562898576259613e+01 5.4979100823402405e+01 6.4476996660232544e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -1.2114600278437138e+01 5.9610001742839813e+01 -7.5127199292182922e+01) (float-vector -3.9661299437284470e+01 6.0734100639820099e+01 -6.4126297831535339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -1.5645200386643410e+01 3.8389399647712708e+01 -7.4474796652793884e+01) (float-vector 3.4459200105629861e-01 4.8954900354146957e+01 -7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3850099444389343e+01 3.6490198224782944e+01 -5.2007101476192474e+01) (float-vector -4.1918899863958359e+01 3.2255701720714569e+01 -5.5662799626588821e+01) (float-vector -2.9782500118017197e+01 3.8387000560760498e+01 -7.0040397346019745e+01) (float-vector -2.8930399566888809e+01 4.8940598964691162e+01 -7.3951698839664459e+01) (float-vector -4.3129801750183105e+01 4.8934601247310638e+01 -6.6686600446701050e+01) (float-vector -5.5839899927377701e+01 4.8932299017906189e+01 -5.6477800011634827e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -5.6481499224901199e+01 6.5751999616622925e+01 4.0725000202655792e+01) (float-vector -5.3850099444389343e+01 6.1509799212217331e+01 5.2007101476192474e+01) (float-vector -6.4476996660232544e+01 5.4979100823402405e+01 4.4562898576259613e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9488696753978729e+01 6.5759703516960144e+01 1.4109100447967649e+00) (float-vector -7.1428798139095306e+01 5.9612501412630081e+01 2.6272999122738838e+01) (float-vector -7.3951698839664459e+01 4.8940598964691162e+01 2.8930399566888809e+01) (float-vector -7.9383201897144318e+01 4.8954900354146957e+01 -3.4461999894119799e-01) (float-vector -7.4474796652793884e+01 5.9610601514577866e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 4.3921299278736115e+01 3.2241899520158768e+01 -5.3944598883390427e+01) (float-vector 2.3136500269174576e+01 1.7725700512528419e+01 -3.0678000301122665e+01) (float-vector 3.7004400044679642e+01 1.7724899575114250e+01 -1.1183599941432476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.3644801974296570e+01 4.9060400575399399e+01 -2.9704099521040916e+01) (float-vector 6.6202603280544281e+01 4.9065899103879929e+01 -4.3869800865650177e+01) (float-vector 5.6843299418687820e+01 4.3021600693464279e+01 -5.3966101258993149e+01) (float-vector 5.6820500642061234e+01 3.2238200306892395e+01 -4.0331300348043442e+01) (float-vector 6.6359199583530426e+01 3.2246299088001251e+01 -2.1015599370002747e+01) (float-vector 7.4474796652793884e+01 3.8389399647712708e+01 -1.5645200386643410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4203500002622604e+01 4.9050800502300262e+01 7.8114800155162811e+01) (float-vector -2.7057100087404251e+01 5.4977700114250183e+01 7.3550097644329071e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01) (float-vector 3.4459200105629861e-01 4.9045100808143616e+01 7.9383298754692078e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 3.0671700835227966e+01 5.4978098720312119e+01 7.2120100259780884e+01) (float-vector 1.7856500344350934e+00 5.4973501712083817e+01 7.8329898416996002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9105001389980316e+01 6.5766297280788422e+01 3.6562200635671616e+01) (float-vector 3.6946401000022888e+01 6.5759100019931793e+01 5.8903798460960388e+01) (float-vector 2.1015599370002747e+01 6.5753698348999023e+01 6.6359199583530426e+01) (float-vector 5.1130601204931736e+00 6.3596703112125397e+01 7.2644703090190887e+01) (float-vector -1.5174100175499916e+01 6.5649501979351044e+01 6.8473696708679199e+01) (float-vector -4.3375499546527863e+01 6.5742902457714081e+01 5.4680000990629196e+01) (float-vector 2.7445200830698013e+00 6.8581901490688324e+01 -1.2800700031220913e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fr_caster_r_wheel_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_fr_caster_rotation_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 2.2459999999999999e+02 -2.2459999999999999e+02 2.8199999999999999e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 162 0 2 1 0 151 0 162 151 1 151 152 1 152 215 1 284 2 1 215 284 151 223 152 151 162 223 2 299 162 162 299 223 274 299 2 150 299 274 299 150 223 2 273 274 274 351 148 150 274 148 289 351 274 273 289 274 168 148 351 288 351 289 351 166 168 166 351 288 288 289 175 273 175 289 177 167 288 288 175 177 166 288 167 166 167 168 167 311 168 235 234 167 234 380 167 454 167 380 235 167 177 311 167 454 453 311 454 182 311 453 168 311 182 453 454 451 454 380 451 159 182 453 451 159 453 451 160 159 160 451 380 159 160 161 181 182 159 214 181 159 214 159 161 161 160 380 440 214 161 161 380 440 347 158 214 214 440 347 158 181 214 181 339 47 181 47 182 158 339 181 37 158 134 134 158 347 158 37 339 476 47 339 476 339 37 72 476 36 68 476 427 476 68 47 72 427 476 476 37 36 36 37 38 70 72 36 91 36 38 91 70 36 38 37 368 23 38 368 91 38 287 287 38 23 91 86 70 91 195 86 91 287 195 86 87 70 498 87 86 195 498 86 35 195 287 35 318 195 498 195 497 195 318 497 498 497 418 498 418 87 418 331 87 87 331 70 331 90 71 331 426 90 418 426 331 70 331 71 70 71 72 72 71 82 71 412 82 71 90 412 72 82 414 414 427 72 82 329 414 412 329 82 412 413 329 90 89 412 412 89 413 328 329 142 328 191 329 191 414 329 329 413 142 190 414 191 190 427 414 190 68 427 189 190 191 189 69 190 69 68 190 205 191 328 189 191 205 141 328 142 141 205 328 204 189 205 216 218 205 212 216 205 218 204 205 212 205 141 189 204 499 499 69 189 499 204 42 499 42 452 499 452 69 42 43 44 201 42 202 42 44 202 452 42 201 204 43 42 43 330 44 43 327 344 43 344 330 204 327 43 44 330 325 44 325 202 324 202 325 202 324 201 452 201 324 45 452 46 45 69 452 452 324 341 341 46 452 45 46 47 45 68 69 68 45 47 182 47 46 341 182 46 340 148 341 341 365 182 148 365 341 341 324 340 182 365 168 168 365 148 148 149 150 149 148 340 324 149 340 324 333 149 333 81 149 150 149 81 223 150 224 150 81 224 79 80 81 333 75 81 80 224 81 75 79 81 222 223 224 222 224 80 429 80 428 80 79 428 222 80 429 74 97 79 74 79 75 97 428 79 73 74 75 73 75 333 73 420 74 420 496 74 74 496 97 495 494 73 495 73 333 494 420 73 324 495 333 325 494 495 324 325 495 330 420 494 325 330 494 330 416 420 330 344 416 344 415 416 416 415 420 420 415 496 415 423 95 496 415 95 344 423 415 344 217 345 345 423 344 327 217 344 320 95 423 321 320 423 345 321 423 95 96 97 96 95 320 496 95 97 320 321 96 217 321 345 321 17 96 321 217 17 17 16 96 96 16 97 97 16 326 326 428 97 15 16 17 16 15 326 17 131 15 17 217 213 17 213 131 15 131 52 15 52 245 15 245 286 15 286 326 213 52 131 51 35 52 52 35 34 213 51 52 245 52 34 318 51 319 51 88 319 213 88 51 51 318 35 497 318 418 318 319 418 319 417 418 417 319 88 418 417 426 426 417 90 90 417 88 88 89 90 78 413 89 89 88 76 78 89 76 76 77 78 142 413 78 142 78 77 88 77 76 141 142 77 212 141 77 77 88 212 212 88 213 213 216 212 213 217 216 216 217 218 218 217 327 204 218 327 33 34 35 35 66 67 35 203 66 35 287 203 35 364 33 67 411 35 411 364 35 245 34 314 34 33 314 244 245 101 286 245 223 405 245 314 101 245 405 244 223 245 405 314 33 405 409 402 102 101 405 409 405 33 102 405 402 33 111 110 33 110 409 364 315 33 33 315 111 402 409 110 401 402 110 493 102 402 493 402 401 110 111 112 112 401 110 112 462 401 462 493 401 322 493 197 462 197 493 322 102 493 462 112 332 58 60 462 58 462 332 60 197 462 111 332 112 111 58 332 58 59 60 315 58 111 315 59 58 61 59 62 62 59 30 59 364 30 59 315 364 59 61 477 60 59 477 477 61 92 61 62 92 92 62 32 62 30 32 30 31 32 364 31 30 364 411 31 411 178 31 32 31 178 92 32 93 32 178 93 92 93 94 477 92 421 421 92 94 313 94 93 93 178 180 93 180 313 178 179 180 411 67 178 178 67 179 180 179 83 410 180 85 180 83 85 313 180 410 313 410 342 94 313 342 410 99 342 99 410 85 83 84 85 98 99 85 84 432 85 432 98 85 179 66 83 66 84 83 430 431 84 430 84 66 431 432 84 419 432 431 419 98 432 419 200 98 98 343 99 200 343 98 342 99 343 200 129 343 342 343 278 343 129 278 198 199 200 129 200 199 198 200 419 198 419 431 198 431 375 375 431 430 198 129 199 287 198 375 129 198 287 287 375 203 203 375 430 465 355 287 287 130 129 22 465 287 23 22 287 355 130 287 128 129 130 130 355 308 130 308 307 130 307 128 128 479 129 278 129 479 468 126 479 479 126 278 337 468 479 337 479 128 121 278 126 232 342 278 121 280 278 280 232 278 408 342 232 408 94 342 408 422 94 317 408 316 317 422 408 316 408 232 421 94 422 317 421 422 316 60 317 317 60 477 317 477 421 60 196 197 196 60 316 196 323 197 196 298 323 196 348 298 196 316 348 197 323 322 322 323 11 298 11 323 9 11 298 9 298 348 316 9 348 9 10 11 9 316 10 304 11 53 322 11 304 11 54 53 10 54 11 304 102 322 304 53 100 102 304 100 53 54 55 100 53 55 171 140 54 54 139 55 54 140 139 171 54 10 424 55 425 424 100 55 267 425 55 139 267 55 100 101 102 424 101 100 425 244 424 244 101 424 244 425 223 223 425 461 425 267 461 286 223 222 223 461 239 223 239 271 271 458 223 223 458 152 461 267 266 461 266 239 144 238 239 238 271 239 144 239 266 265 266 267 145 266 265 266 145 144 279 265 267 145 265 279 267 369 104 267 104 279 267 139 369 279 104 173 145 279 173 103 172 173 103 173 104 173 172 366 366 145 173 64 103 104 172 103 64 172 64 63 172 357 367 172 63 357 366 172 367 366 367 145 483 143 367 357 475 367 483 367 448 143 145 367 448 367 475 143 144 145 482 395 143 482 143 483 395 144 143 448 125 483 483 125 482 443 482 125 482 443 395 144 395 396 443 396 395 358 238 144 358 144 450 144 396 450 396 480 450 396 481 480 443 481 396 485 450 277 450 480 277 358 450 350 450 485 350 334 238 358 358 350 334 271 238 272 238 334 272 485 458 271 350 485 271 406 271 272 271 406 350 485 379 458 379 485 277 379 152 458 283 215 379 215 152 379 283 379 277 215 283 284 247 283 208 208 283 277 284 283 247 285 284 247 2 284 285 2 285 273 273 285 439 439 285 247 176 273 439 175 273 176 176 439 177 177 439 247 175 176 177 246 398 177 246 177 247 253 235 177 398 253 177 208 246 247 399 398 246 208 399 246 188 398 399 188 253 398 399 436 472 207 436 399 399 472 188 208 207 399 206 207 208 277 206 208 480 481 206 481 207 206 480 206 277 481 256 207 443 256 481 256 257 207 185 186 256 257 256 209 256 186 209 443 185 256 443 124 185 443 125 124 185 124 186 209 186 13 186 124 264 13 186 264 39 209 13 209 484 257 39 484 209 484 39 257 39 40 41 39 41 194 194 257 39 39 13 12 39 187 40 39 270 187 12 270 39 436 194 41 41 40 436 207 194 436 194 207 257 40 472 436 188 472 40 40 187 188 253 188 254 254 188 292 187 292 188 292 187 270 292 270 260 254 292 260 260 253 254 269 253 260 253 233 235 253 269 233 269 260 270 270 133 269 306 233 269 433 269 491 269 133 491 269 433 306 233 234 235 233 380 234 233 306 380 226 157 380 440 380 157 306 226 380 8 225 226 225 157 226 8 226 306 6 7 8 306 6 8 8 7 225 7 155 225 157 225 155 388 7 6 388 155 7 388 6 27 388 27 394 388 464 155 388 394 464 25 26 27 27 6 132 132 25 27 394 27 26 394 389 464 138 394 26 389 394 138 464 487 488 464 488 155 389 487 464 487 349 488 487 478 349 389 478 487 349 155 488 155 156 157 391 156 155 349 392 155 391 155 392 377 378 156 346 377 156 156 378 157 156 391 346 157 378 393 440 157 393 377 374 378 374 393 378 393 347 440 374 347 393 374 134 347 377 134 374 134 135 56 134 377 135 134 56 37 57 135 305 135 377 305 56 135 57 37 56 57 57 368 37 305 108 57 57 108 109 109 368 57 108 305 346 346 305 377 108 21 109 346 391 108 21 108 391 368 109 21 21 23 368 21 22 23 21 391 392 21 392 349 349 22 21 465 22 349 349 249 248 459 349 248 465 349 459 478 249 349 459 105 465 220 355 465 105 220 465 459 474 105 248 474 459 105 106 107 105 255 106 105 107 220 105 474 255 255 474 355 355 474 308 308 474 248 354 255 355 355 220 354 106 255 354 220 221 354 221 106 354 220 165 221 49 106 221 165 164 221 164 49 221 48 49 50 49 437 106 363 437 49 49 48 363 50 49 164 48 192 193 48 193 363 48 50 192 50 164 192 193 192 164 363 193 445 445 193 164 444 363 445 363 444 437 438 445 164 444 445 438 437 444 438 437 438 275 164 275 438 258 275 211 164 211 275 258 437 275 258 211 259 259 437 258 163 210 211 163 211 164 210 259 211 163 164 165 489 210 163 489 163 165 210 489 437 259 210 437 106 437 489 106 489 243 243 489 165 107 165 220 107 243 165 107 106 243 117 248 249 404 449 248 449 252 248 117 404 248 252 308 248 478 400 249 400 117 249 389 400 478 117 400 4 389 4 400 4 389 390 138 390 389 227 390 137 390 138 137 4 390 227 136 137 138 26 136 138 137 133 268 268 227 137 137 136 26 133 137 26 227 228 229 268 228 227 4 227 229 133 228 268 115 312 228 4 229 228 133 115 228 312 4 228 5 4 312 115 5 312 3 4 5 117 4 3 116 3 5 5 115 116 116 117 3 117 116 404 116 403 404 114 116 115 116 114 403 404 386 449 404 403 386 403 236 386 114 263 403 403 263 236 113 114 115 370 114 113 114 370 263 113 12 370 12 113 115 12 115 133 12 13 14 12 469 470 12 14 469 470 370 12 12 133 270 470 263 370 261 470 469 470 261 263 469 231 261 231 469 14 261 262 263 261 231 301 397 261 301 397 262 261 14 230 231 231 300 301 231 230 300 301 300 441 397 301 295 441 295 301 397 295 372 397 372 466 262 397 466 466 372 237 466 237 407 407 262 466 236 407 237 263 407 236 262 407 263 120 236 237 353 386 236 120 119 236 236 119 353 118 119 120 120 219 118 237 219 120 352 353 119 118 352 119 310 353 352 353 310 387 353 387 386 121 123 352 310 352 123 121 352 118 276 118 219 121 118 276 276 219 383 237 383 219 276 184 232 232 280 276 184 276 383 121 276 280 121 122 123 126 122 121 126 127 122 122 127 123 468 467 126 126 467 127 127 467 468 123 127 337 127 468 337 251 337 128 251 376 337 337 376 123 250 251 252 376 251 250 252 251 490 490 251 128 307 490 128 307 252 490 307 308 252 449 386 252 250 252 386 386 387 250 387 309 250 309 376 250 310 309 387 123 309 310 123 376 309 184 383 169 383 384 169 457 383 237 384 383 457 183 184 169 184 183 232 169 10 183 232 183 316 10 316 183 171 10 169 169 170 171 171 170 140 170 169 359 140 170 64 64 170 146 359 147 170 170 147 146 104 139 140 140 64 104 63 64 65 65 64 146 146 147 65 63 65 357 65 147 357 356 357 147 382 475 357 356 382 357 381 382 356 297 356 371 381 356 297 371 356 147 471 475 382 471 382 381 475 471 448 381 296 471 296 448 471 296 381 297 295 296 297 295 297 371 295 371 372 372 371 147 295 441 442 295 442 296 300 230 441 441 230 442 230 373 442 296 442 373 14 373 230 373 29 296 373 14 29 14 28 29 13 240 14 447 446 14 240 447 14 28 14 446 29 28 460 460 296 29 446 460 28 446 447 448 446 448 460 240 242 447 448 447 242 240 241 242 241 240 13 448 242 125 125 242 241 448 296 460 241 13 125 124 125 13 13 264 124 147 455 372 147 359 455 455 359 456 455 457 372 455 456 457 457 237 372 384 457 456 359 384 456 359 169 384 104 369 139 132 133 25 133 281 282 133 434 433 133 282 434 491 133 433 281 133 132 25 133 26 281 302 303 282 281 303 302 281 132 434 282 435 303 435 282 433 434 435 433 435 306 306 435 303 6 303 302 6 306 303 132 6 302 350 335 334 406 335 350 334 335 336 335 338 336 335 406 154 338 335 154 291 334 293 291 272 334 334 336 293 290 154 291 293 290 291 406 272 291 154 406 291 501 290 293 154 290 501 154 501 473 473 501 293 154 473 385 473 293 385 385 153 154 385 293 492 153 385 492 153 18 154 294 153 492 153 294 18 492 293 294 293 19 294 294 19 18 18 19 20 362 18 20 18 362 154 20 19 24 19 174 24 19 293 174 486 362 20 486 20 24 486 24 174 174 463 486 463 362 486 174 293 336 500 174 361 174 336 361 500 463 174 463 360 362 500 360 463 360 500 361 360 361 362 362 361 336 362 336 338 362 338 154 429 286 222 326 286 429 326 429 428 203 430 66 67 66 179))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-2.9610601806640625e+02 1.6241200256347656e+02 1.0526599884033203e+02 -2.8170498657226562e+02 1.6241200256347656e+02 1.0526599884033203e+02 -2.9957000732421875e+02 1.6754400634765625e+02 1.0526599884033203e+02 -1.9148600769042969e+02 2.9194000244140625e+02 1.3304998779296875e+02 -2.0424600219726562e+02 2.9688598632812500e+02 1.3304998779296875e+02 -1.9030799865722656e+02 2.9147402954101562e+02 1.3955000305175781e+02 -2.7653198242187500e+02 2.7893399047851562e+02 1.3304998779296875e+02 -2.6645700073242188e+02 2.5680999755859375e+02 1.3304998779296875e+02 -2.7244699096679688e+02 2.4676300048828125e+02 1.3304998779296875e+02 -1.5055300903320312e+02 2.1059500122070312e+02 1.0230000305175781e+02 -1.3250199890136719e+02 2.0908200073242188e+02 1.0230000305175781e+02 -1.5143299865722656e+02 2.0587199401855469e+02 1.0230000305175781e+02 -1.6115499877929688e+02 2.6470397949218750e+02 1.3955000305175781e+02 -2.0617799377441406e+02 1.5177099609375000e+02 1.3955000305175781e+02 -1.6957699584960938e+02 1.7346200561523438e+02 1.3955000305175781e+02 -3.0362298583984375e+02 1.9859201049804688e+02 -1.6409799575805664e+01 -3.0671200561523438e+02 1.9892098999023438e+02 -2.7892499923706055e+01 -3.0677600097656250e+02 1.9894898986816406e+02 -5.9969299316406250e+01 -2.1749700927734375e+02 1.4110000610351562e+02 -5.4909603118896484e+01 -2.2026200866699219e+02 1.3809999084472656e+02 -5.5569801330566406e+01 -2.2877598571777344e+02 1.4110000610351562e+02 -5.5612400054931641e+01 -2.6262701416015625e+02 2.9028500366210938e+02 1.0230000305175781e+02 -2.5209999084472656e+02 2.9460998535156250e+02 1.0230000305175781e+02 -2.5346099853515625e+02 2.7945001220703125e+02 1.0230000305175781e+02 -2.3203698730468750e+02 1.3809999084472656e+02 -5.4838798522949219e+01 -2.6524499511718750e+02 2.8766598510742188e+02 1.3955000305175781e+02 -2.5610598754882812e+02 2.9278601074218750e+02 1.3955000305175781e+02 -2.6561099243164062e+02 2.8748501586914062e+02 1.3304998779296875e+02 -1.6203199768066406e+02 1.8310000610351562e+02 1.3955000305175781e+02 -1.5683500671386719e+02 1.9235800170898438e+02 1.3955000305175781e+02 -1.5055300903320312e+02 2.3860499572753906e+02 -4.3196701049804688e+01 -1.5075000000000000e+02 2.4091101074218750e+02 -5.8984100341796875e+01 -1.5084399414062500e+02 2.4154199218750000e+02 -9.5243206024169922e+00 -1.5820599365234375e+02 1.9934800720214844e+02 -5.9969898223876953e+01 -1.6255299377441406e+02 1.9859500122070312e+02 -5.9969802856445312e+01 -1.6255299377441406e+02 2.5060498046875000e+02 -5.9969802856445312e+01 -3.0808898925781250e+02 2.4978900146484375e+02 1.0230100250244141e+02 -3.0663800048828125e+02 2.6967901611328125e+02 1.0230000305175781e+02 -3.0362298583984375e+02 2.5060498046875000e+02 1.0230000305175781e+02 -2.5811199951171875e+02 1.5739799499511719e+02 1.3955000305175781e+02 -2.8411599731445312e+02 1.7879199218750000e+02 1.3955000305175781e+02 -2.7223699951171875e+02 1.6646899414062500e+02 1.3955000305175781e+02 -3.1521697998046875e+02 2.0749099731445312e+02 5.7514900207519531e+01 -3.1521697998046875e+02 2.0749099731445312e+02 1.3412400245666504e+01 -3.1471301269531250e+02 2.0600601196289062e+02 3.6914199829101562e+01 -3.1562298583984375e+02 2.3860499572753906e+02 1.0230000305175781e+02 -3.1783898925781250e+02 2.3057299804687500e+02 1.0230000305175781e+02 -3.1595700073242188e+02 2.4367100524902344e+02 1.0230000305175781e+02 -2.0511000061035156e+02 3.1110000610351562e+02 -4.7562698364257812e+01 -1.9710000610351562e+02 3.1110000610351562e+02 -2.8200000762939453e+01 -1.9875698852539062e+02 3.1110098266601562e+02 -3.8267398834228516e+01 -3.0362298583984375e+02 2.5060498046875000e+02 -5.9969802856445312e+01 -2.4274200439453125e+02 1.9859500122070312e+02 -5.9969802856445312e+01 -1.5428100585937500e+02 2.0190599060058594e+02 1.0230000305175781e+02 -1.3655400085449219e+02 1.9347000122070312e+02 1.0230000305175781e+02 -1.5766600036621094e+02 1.9957501220703125e+02 1.0230000305175781e+02 -2.9610601806640625e+02 2.8678799438476562e+02 1.0230000305175781e+02 -2.7435101318359375e+02 2.8678799438476562e+02 1.0230000305175781e+02 -1.5053201293945312e+02 2.1059399414062500e+02 -2.7142898559570312e+01 -1.5055300903320312e+02 2.2240200805664062e+02 -1.8764699935913086e+01 -1.5055300903320312e+02 2.1059500122070312e+02 4.0985599517822266e+01 -1.5055300903320312e+02 2.3860499572753906e+02 8.0976800918579102e+00 -1.5055300903320312e+02 2.3860499572753906e+02 -1.5550399780273438e+01 -1.6230599975585938e+02 1.8344299316406250e+02 1.2900000000000000e+02 -1.6085598754882812e+02 1.8549501037597656e+02 1.0526499938964844e+02 -1.5843800354003906e+02 1.9002600097656250e+02 1.2900000000000000e+02 -1.5869000244140625e+02 2.4999398803710938e+02 -3.7053100585937500e+01 -1.5664898681640625e+02 2.4914300537109375e+02 -5.9970798492431641e+01 -3.1534698486328125e+02 2.4104499816894531e+02 1.0230000305175781e+02 -3.1562298583984375e+02 2.3860499572753906e+02 9.6058898925781250e+01 -3.0834201049804688e+02 2.4970899963378906e+02 7.5261901855468750e+01 -3.1030599975585938e+02 2.4860499572753906e+02 3.5743999481201172e+01 -3.1203201293945312e+02 2.4725100708007812e+02 1.0056999969482422e+02 -3.1211199951171875e+02 2.0211000061035156e+02 6.0708602905273438e+01 -3.1093099975585938e+02 2.0107400512695312e+02 3.2135898590087891e+01 -3.1093099975585938e+02 2.0107400512695312e+02 7.9724601745605469e+01 -3.1213500976562500e+02 2.4705700683593750e+02 -5.9969802856445312e+01 -3.1411499023437500e+02 2.4453500366210938e+02 -5.9969898223876953e+01 -3.1314797973632812e+02 2.4590800476074219e+02 -2.9373600006103516e+01 -3.0962399291992188e+02 2.0020100402832031e+02 5.0942001342773438e+01 -3.0821600341796875e+02 1.9950700378417969e+02 7.8505599975585938e+01 -3.0962197875976562e+02 2.0020199584960938e+02 1.0230000305175781e+02 -3.1295599365234375e+02 2.4616700744628906e+02 5.2590198516845703e+01 -1.5655801391601562e+02 2.4900199890136719e+02 -2.3319999694824219e+01 -1.5796501159667969e+02 2.4969500732421875e+02 6.6349101066589355e+00 -1.5655801391601562e+02 2.4900199890136719e+02 3.0526800155639648e+01 -3.0519000244140625e+02 2.5050398254394531e+02 5.8514400482177734e+01 -3.0672900390625000e+02 2.5019801330566406e+02 4.6641597747802734e+01 -3.0980300903320312e+02 2.4897099304199219e+02 -5.9969802856445312e+01 -3.1211199951171875e+02 2.4708999633789062e+02 -1.3356300354003906e+01 -3.1024398803710938e+02 2.4864498901367188e+02 -1.2914799690246582e+01 -3.0362298583984375e+02 2.5060498046875000e+02 7.6262695312500000e+01 -1.5075799560546875e+02 2.4095300292968750e+02 4.4407596588134766e+00 -1.5177699279785156e+02 2.4394500732421875e+02 1.1596100807189941e+01 -1.5141299438476562e+02 2.4320800781250000e+02 6.4847000122070312e+01 -3.1093099975585938e+02 2.0107400512695312e+02 -2.5375299453735352e+01 -3.0962399291992188e+02 2.0020100402832031e+02 -5.3728698730468750e+01 -3.0962399291992188e+02 2.0020100402832031e+02 2.4416298866271973e+00 -1.5796501159667969e+02 2.4969500732421875e+02 4.8518898010253906e+01 -1.5655801391601562e+02 2.4900199890136719e+02 7.6920997619628906e+01 -1.5639999389648438e+02 2.0020599365234375e+02 9.9975700378417969e+01 -1.5977099609375000e+02 1.9886300659179688e+02 4.1235500335693359e+01 -1.5540400695800781e+02 2.0089801025390625e+02 3.2989101409912109e+01 -1.6803201293945312e+02 1.7574598693847656e+02 1.0526599884033203e+02 -1.5309399414062500e+02 1.6241200256347656e+02 1.0526599884033203e+02 -2.5209999084472656e+02 3.1110000610351562e+02 7.0520500183105469e+01 -1.9710000610351562e+02 3.1110000610351562e+02 4.0198602676391602e+00 -2.5209999084472656e+02 3.1110000610351562e+02 -4.4480600357055664e+00 -2.6891198730468750e+02 2.8678799438476562e+02 1.0526599884033203e+02 -2.6891198730468750e+02 2.8678799438476562e+02 1.0230000305175781e+02 -1.5382600402832031e+02 2.0234100341796875e+02 -5.9969699859619141e+01 -1.5095500183105469e+02 2.0714401245117188e+02 -5.9969200134277344e+01 -1.5208799743652344e+02 2.0460000610351562e+02 -5.9332698822021484e+01 -1.6750199890136719e+02 2.7328802490234375e+02 1.3955000305175781e+02 -1.7311500549316406e+02 2.7922698974609375e+02 1.3304998779296875e+02 -1.7670899963378906e+02 2.8250198364257812e+02 1.3955000305175781e+02 -1.8156098937988281e+02 2.8611001586914062e+02 1.3304998779296875e+02 -2.1498901367187500e+02 2.7655700683593750e+02 1.3304998779296875e+02 -1.5454701232910156e+02 2.5038099670410156e+02 1.0526599884033203e+02 -1.5612800598144531e+02 2.5432299804687500e+02 1.2900000000000000e+02 -1.5271000671386719e+02 2.4478900146484375e+02 1.2900000000000000e+02 -1.4316000366210938e+02 2.7076599121093750e+02 1.0526499938964844e+02 -1.4961401367187500e+02 2.8163000488281250e+02 1.0526599884033203e+02 -1.5875900268554688e+02 2.7456997680664062e+02 1.0526599884033203e+02 -2.1654499816894531e+02 1.4999699401855469e+02 1.3304998779296875e+02 -2.0335699462890625e+02 1.5256999206542969e+02 1.3304998779296875e+02 -1.4881800842285156e+02 2.8049099731445312e+02 1.0230000305175781e+02 -1.5309399414062500e+02 2.8678799438476562e+02 1.0526599884033203e+02 -1.8772200012207031e+02 2.8953799438476562e+02 1.0230000305175781e+02 -1.6255299377441406e+02 2.5060498046875000e+02 1.0230000305175781e+02 -1.9710000610351562e+02 2.9396298217773438e+02 1.0230000305175781e+02 -3.0362298583984375e+02 1.9859500122070312e+02 -5.9969802856445312e+01 -2.7349002075195312e+02 2.8152999877929688e+02 1.3955000305175781e+02 -2.9932202148437500e+02 2.3220300292968750e+02 1.3955000305175781e+02 -3.0311700439453125e+02 2.7608001708984375e+02 1.0526599884033203e+02 -2.9610601806640625e+02 2.8678799438476562e+02 1.0526599884033203e+02 -2.4590699768066406e+02 2.9656298828125000e+02 1.3955000305175781e+02 -2.3481401062011719e+02 2.9899200439453125e+02 1.3955000305175781e+02 -2.4586599731445312e+02 2.9662600708007812e+02 1.3304998779296875e+02 -1.4590400695800781e+02 1.7332299804687500e+02 1.0230000305175781e+02 -1.4330500793457031e+02 1.7801100158691406e+02 1.0526499938964844e+02 -3.1524398803710938e+02 2.4181500244140625e+02 -5.7594200134277344e+01 -3.1402001953125000e+02 2.4460099792480469e+02 -1.8744100570678711e+01 -2.1017100524902344e+02 1.7368299865722656e+02 1.2900000000000000e+02 -1.9710000610351562e+02 1.5523699951171875e+02 1.2900000000000000e+02 -1.8280699157714844e+02 1.6262599182128906e+02 1.2900000000000000e+02 -1.5651400756835938e+02 1.9405099487304688e+02 1.0615900421142578e+02 -1.5415899658203125e+02 1.9980500793457031e+02 1.2900000000000000e+02 -3.1419400024414062e+02 1.9842300415039062e+02 1.0526599884033203e+02 -3.1442498779296875e+02 1.9939898681640625e+02 1.0230000305175781e+02 -3.1000201416015625e+02 1.8684899902343750e+02 1.0230000305175781e+02 -2.9066699218750000e+02 1.6241200256347656e+02 1.0230000305175781e+02 -2.6891198730468750e+02 1.6241200256347656e+02 1.0230000305175781e+02 -2.0844100952148438e+02 1.4110000610351562e+02 -5.0521602630615234e+01 -1.9710000610351562e+02 1.4110000610351562e+02 -2.8200000762939453e+01 -2.5895898437500000e+02 2.6466101074218750e+02 1.2900000000000000e+02 -2.8238897705078125e+02 2.7733700561523438e+02 1.2900000000000000e+02 -2.8169900512695312e+02 2.5034001159667969e+02 1.2900000000000000e+02 -3.0943798828125000e+02 2.6357400512695312e+02 1.0526499938964844e+02 -3.0997698974609375e+02 2.3882099914550781e+02 1.0526599884033203e+02 -3.1004901123046875e+02 2.3853099060058594e+02 1.2900000000000000e+02 -3.0663699340820312e+02 2.4716299438476562e+02 1.2900000000000000e+02 -2.9610601806640625e+02 1.6241200256347656e+02 1.0230000305175781e+02 -2.5073400878906250e+02 3.0809899902343750e+02 -3.7242900848388672e+01 -1.9777500915527344e+02 3.0809997558593750e+02 -3.5301700592041016e+01 -2.5209999084472656e+02 3.0809997558593750e+02 -2.8200000762939453e+01 -3.1046701049804688e+02 2.1219700622558594e+02 1.2900000000000000e+02 -3.1185598754882812e+02 2.1916400146484375e+02 1.2900000000000000e+02 -3.1093298339843750e+02 2.1395500183105469e+02 1.0526599884033203e+02 -1.3137599182128906e+02 2.1664599609375000e+02 1.0526599884033203e+02 -1.5407901000976562e+02 2.0013299560546875e+02 1.0526499938964844e+02 -1.3517298889160156e+02 1.9768400573730469e+02 1.0526599884033203e+02 -1.6783300781250000e+02 1.7590299987792969e+02 1.2900000000000000e+02 -1.7631399536132812e+02 1.6743800354003906e+02 1.0526599884033203e+02 -2.4075900268554688e+02 1.3809999084472656e+02 -5.0521602630615234e+01 -2.9820098876953125e+02 1.8836499023437500e+02 1.2900000000000000e+02 -2.9353100585937500e+02 1.8274598693847656e+02 1.2900000000000000e+02 -2.7357400512695312e+02 2.0497700500488281e+02 1.2900000000000000e+02 -1.5216299438476562e+02 2.4473999023437500e+02 -5.6779602050781250e+01 -1.5501699829101562e+02 2.4803399658203125e+02 -5.5256900787353516e+01 -1.5429901123046875e+02 2.4738099670410156e+02 -5.0245699882507324e+00 -3.1393600463867188e+02 2.5159400939941406e+02 1.0526599884033203e+02 -3.1788598632812500e+02 2.3227598571777344e+02 1.0526499938964844e+02 -1.3104901123046875e+02 2.2701499938964844e+02 1.0230000305175781e+02 -1.3155999755859375e+02 2.3312098693847656e+02 1.0526499938964844e+02 -2.2460000610351562e+02 1.4960000610351562e+02 1.3304998779296875e+02 -2.2460000610351562e+02 1.4960000610351562e+02 1.3955000305175781e+02 -2.9144998168945312e+02 1.9044999694824219e+02 1.3955000305175781e+02 -2.9141198730468750e+02 1.9013500976562500e+02 1.3304998779296875e+02 -3.1562298583984375e+02 2.3860499572753906e+02 3.6371799468994141e+01 -3.1542001342773438e+02 2.4094900512695312e+02 6.8863502502441406e+01 -3.1523599243164062e+02 2.4183300781250000e+02 2.6833299636840820e+01 -2.0251600646972656e+02 3.0809997558593750e+02 -4.4711601257324219e+01 -2.1015399169921875e+02 3.0809997558593750e+02 -5.1552700042724609e+01 -2.6275799560546875e+02 1.5993499755859375e+02 1.3304998779296875e+02 -3.0362298583984375e+02 2.5060498046875000e+02 3.4281200408935547e+01 -1.5055300903320312e+02 2.1059500122070312e+02 7.4117301940917969e+01 -1.5137800598144531e+02 2.0600399780273438e+02 3.4616500854492188e+01 -1.6255299377441406e+02 2.5060498046875000e+02 4.6495399475097656e+01 -1.6098800659179688e+02 2.5050398254394531e+02 7.6994102478027344e+01 -1.5944999694824219e+02 2.5019898986816406e+02 7.7262298583984375e+01 -3.1521697998046875e+02 2.0749099731445312e+02 1.0073999786376953e+02 -3.1471301269531250e+02 2.0600601196289062e+02 7.5190002441406250e+01 -1.6255299377441406e+02 2.5060498046875000e+02 -1.6379301071166992e+01 -3.1562298583984375e+02 2.1059500122070312e+02 1.6008800506591797e+01 -3.1562799072265625e+02 2.3860499572753906e+02 -1.9097600936889648e+01 -2.5163099670410156e+02 1.7929100036621094e+02 1.2900000000000000e+02 -2.5519898986816406e+02 1.8166000366210938e+02 1.3304998779296875e+02 -2.6125100708007812e+02 1.8660299682617188e+02 1.2900000000000000e+02 -2.3366099548339844e+02 1.5006900024414062e+02 1.3955000305175781e+02 -2.4925900268554688e+02 3.1110000610351562e+02 -4.0683502197265625e+01 -2.4354598999023438e+02 3.0809899902343750e+02 -4.8183097839355469e+01 -3.1562298583984375e+02 2.3860499572753906e+02 -5.9969802856445312e+01 -2.9996499633789062e+02 2.2387500000000000e+02 -5.9969802856445312e+01 -3.0592599487304688e+02 2.4867599487304688e+02 1.0526499938964844e+02 -2.6891198730468750e+02 1.6241200256347656e+02 1.0526599884033203e+02 -3.1562298583984375e+02 2.1059500122070312e+02 -5.9969802856445312e+01 -3.1479098510742188e+02 2.0587599182128906e+02 -5.9969997406005859e+01 -3.1562298583984375e+02 2.1059500122070312e+02 -3.5175899505615234e+01 -1.5175999450683594e+02 2.4128800964355469e+02 1.0526599884033203e+02 -2.5209999084472656e+02 3.0809997558593750e+02 3.3263198852539062e+01 -1.9710000610351562e+02 3.0809997558593750e+02 -2.8200000762939453e+01 -3.0601098632812500e+02 1.9880700683593750e+02 1.0037599945068359e+02 -3.0362298583984375e+02 1.9859500122070312e+02 1.0230000305175781e+02 -3.0821099853515625e+02 1.9950898742675781e+02 1.0230000305175781e+02 -2.6879000854492188e+02 2.5337400817871094e+02 1.2900000000000000e+02 -2.7441201782226562e+02 2.4181500244140625e+02 1.2900000000000000e+02 -2.2460000610351562e+02 2.9960000610351562e+02 1.3304998779296875e+02 -2.1309899902343750e+02 2.9884100341796875e+02 1.3955000305175781e+02 -2.1626499938964844e+02 2.9922198486328125e+02 1.3304998779296875e+02 -1.5050299072265625e+02 2.1286801147460938e+02 1.3955000305175781e+02 -1.5012399291992188e+02 2.3420899963378906e+02 1.3955000305175781e+02 -1.3430300903320312e+02 2.4845098876953125e+02 1.0230000305175781e+02 -2.7736898803710938e+02 2.2337100219726562e+02 1.3304998779296875e+02 -2.7736801147460938e+02 2.2460000610351562e+02 1.2900000000000000e+02 -2.7655999755859375e+02 2.1541699218750000e+02 1.2900000000000000e+02 -1.8314999389648438e+02 2.5710601806640625e+02 1.2900000000000000e+02 -1.5058700561523438e+02 2.3502198791503906e+02 1.2900000000000000e+02 -1.9710000610351562e+02 1.3809999084472656e+02 1.2900000000000000e+02 -1.9710000610351562e+02 1.5523699951171875e+02 1.0230000305175781e+02 -1.7880000305175781e+02 1.6514199829101562e+02 1.3955000305175781e+02 -1.9108900451660156e+02 1.5735900878906250e+02 1.3955000305175781e+02 -1.8882699584960938e+02 1.5858300781250000e+02 1.3304998779296875e+02 -2.5209999084472656e+02 3.1110000610351562e+02 -2.8200000762939453e+01 -1.6255299377441406e+02 1.9859500122070312e+02 4.8323799133300781e+01 -1.6255299377441406e+02 1.9859400939941406e+02 -1.1485099792480469e+01 -2.6849401855468750e+02 1.9552099609375000e+02 1.2900000000000000e+02 -2.7913998413085938e+02 1.6929598999023438e+02 1.2900000000000000e+02 -2.1076400756835938e+02 2.7563800048828125e+02 1.2900000000000000e+02 -2.2460000610351562e+02 2.7727999877929688e+02 1.2900000000000000e+02 -1.7508399963378906e+02 2.8053298950195312e+02 1.2900000000000000e+02 -1.8084899902343750e+02 2.8514599609375000e+02 1.2900000000000000e+02 -1.9613101196289062e+02 2.7775897216796875e+02 1.2900000000000000e+02 -2.7593402099609375e+02 2.1254899597167969e+02 1.3304998779296875e+02 -2.9628802490234375e+02 2.0236199951171875e+02 1.3304998779296875e+02 -1.9710000610351562e+02 3.1110000610351562e+02 4.8852600097656250e+01 -2.3349200439453125e+02 1.5007199096679688e+02 1.3304998779296875e+02 -2.4663500976562500e+02 1.5273599243164062e+02 1.3304998779296875e+02 -2.3904600524902344e+02 3.1110000610351562e+02 -5.1552700042724609e+01 -2.4472799682617188e+02 3.1110000610351562e+02 -4.6919902801513672e+01 -2.9846298217773438e+02 2.1146899414062500e+02 1.3304998779296875e+02 -1.5267098999023438e+02 2.4630400085449219e+02 1.3304998779296875e+02 -1.7514700317382812e+02 2.4283799743652344e+02 1.3304998779296875e+02 -1.8018199157714844e+02 2.5320300292968750e+02 1.3304998779296875e+02 -2.1710400390625000e+02 1.4991600036621094e+02 1.3955000305175781e+02 -1.8607699584960938e+02 1.6067098999023438e+02 1.0764700317382812e+02 -1.9140901184082031e+02 1.5768699645996094e+02 1.0230000305175781e+02 -1.8330099487304688e+02 1.6241200256347656e+02 1.0230000305175781e+02 -2.2460000610351562e+02 2.9960000610351562e+02 1.3955000305175781e+02 -2.9956900024414062e+02 2.2112500000000000e+02 1.3304998779296875e+02 -2.9940301513671875e+02 2.1820100402832031e+02 1.3955000305175781e+02 -1.9710000610351562e+02 1.4110000610351562e+02 1.0230000305175781e+02 -1.9710000610351562e+02 1.3809999084472656e+02 6.0071498870849609e+01 -2.9469201660156250e+02 1.8389299011230469e+02 1.0526599884033203e+02 -3.0759799194335938e+02 1.8145700073242188e+02 1.0526599884033203e+02 -2.3271000671386719e+02 3.0809997558593750e+02 -5.4577102661132812e+01 -1.3366700744628906e+02 2.4586399841308594e+02 1.0526499938964844e+02 -2.5924700927734375e+02 1.5738800048828125e+02 1.2900000000000000e+02 -1.4087100219726562e+02 2.6610800170898438e+02 1.0230000305175781e+02 -1.8330099487304688e+02 1.6241200256347656e+02 1.0526599884033203e+02 -1.3806399536132812e+02 2.5943600463867188e+02 1.0526599884033203e+02 -2.8767800903320312e+02 2.6523199462890625e+02 1.3955000305175781e+02 -2.9243600463867188e+02 2.5667797851562500e+02 1.3955000305175781e+02 -2.6952401733398438e+02 1.6272300720214844e+02 1.2900000000000000e+02 -2.7351901245117188e+02 1.6526899719238281e+02 1.0526499938964844e+02 -2.8447900390625000e+02 1.7366999816894531e+02 1.0526599884033203e+02 -3.0362298583984375e+02 1.9859500122070312e+02 5.6637203216552734e+01 -2.2635099792480469e+02 2.5060498046875000e+02 1.0230000305175781e+02 -3.0640200805664062e+02 2.0137800598144531e+02 1.2900000000000000e+02 -3.0290402221679688e+02 1.9522399902343750e+02 1.0526499938964844e+02 -1.9710000610351562e+02 1.3809999084472656e+02 -2.8200000762939453e+01 -1.9710000610351562e+02 1.3809999084472656e+02 6.6848897933959961e+00 -2.9700299072265625e+02 2.0452700805664062e+02 1.3955000305175781e+02 -1.9968899536132812e+02 1.3809999084472656e+02 -4.0130100250244141e+01 -2.1108500671386719e+02 1.3809999084472656e+02 -5.2161602020263672e+01 -1.7185400390625000e+02 2.2069898986816406e+02 1.3304998779296875e+02 -1.5349400329589844e+02 2.0050900268554688e+02 1.3304998779296875e+02 -1.7488299560546875e+02 2.0686399841308594e+02 1.3304998779296875e+02 -1.5064799499511719e+02 2.0905099487304688e+02 9.8952499389648438e+01 -3.0500299072265625e+02 1.7660998535156250e+02 1.0230000305175781e+02 -1.4958999633789062e+02 2.2176300048828125e+02 1.3955000305175781e+02 -1.4992199707031250e+02 2.3243499755859375e+02 1.3304998779296875e+02 -2.8166101074218750e+02 2.7333898925781250e+02 1.3955000305175781e+02 -2.8750100708007812e+02 2.6566500854492188e+02 1.3304998779296875e+02 -1.5341400146484375e+02 2.0278100585937500e+02 9.9576896667480469e+01 -2.8240002441406250e+02 2.8678799438476562e+02 1.0526599884033203e+02 -2.7598800659179688e+02 2.3662699890136719e+02 1.3304998779296875e+02 -1.9340200805664062e+02 2.9240200805664062e+02 1.2900000000000000e+02 -1.9710000610351562e+02 2.9396298217773438e+02 1.2900000000000000e+02 -1.6932600402832031e+02 2.7495001220703125e+02 1.0526599884033203e+02 -1.6303401184082031e+02 2.6683898925781250e+02 1.0526599884033203e+02 -3.1208599853515625e+02 2.2145100402832031e+02 1.0526599884033203e+02 -2.0161900329589844e+02 2.9605401611328125e+02 1.3955000305175781e+02 -1.5291899108886719e+02 2.4583999633789062e+02 4.9794101715087891e+01 -1.6020800781250000e+02 1.9879800415039062e+02 -4.6152801513671875e+01 -1.5055300903320312e+02 2.1059500122070312e+02 -5.9969802856445312e+01 -1.5055300903320312e+02 2.3860499572753906e+02 1.0230000305175781e+02 -1.5055300903320312e+02 2.3860499572753906e+02 7.5970199584960938e+01 -3.0362298583984375e+02 2.5060498046875000e+02 -1.6964399337768555e+01 -3.0672900390625000e+02 2.5019801330566406e+02 -5.8409500122070312e+01 -3.1092102050781250e+02 2.0106199645996094e+02 -5.6251296997070312e+01 -3.1044500732421875e+02 2.0066999816894531e+02 -5.9969802856445312e+01 -1.5209800720214844e+02 2.0459500122070312e+02 6.6583404541015625e+01 -1.5096099853515625e+02 2.0748800659179688e+02 7.0289703369140625e+01 -3.1424200439453125e+02 2.0496299743652344e+02 1.0230100250244141e+02 -3.1402001953125000e+02 2.0459899902343750e+02 4.8860198974609375e+01 -3.0667300415039062e+02 1.9893299865722656e+02 9.7371997833251953e+00 -3.1521697998046875e+02 2.0749099731445312e+02 -2.7545099258422852e+01 -3.1531399536132812e+02 2.4160798645019531e+02 -1.4892200469970703e+01 -3.1363201904296875e+02 2.4527400207519531e+02 2.2798498153686523e+01 -3.1440200805664062e+02 2.0525900268554688e+02 1.4838599205017090e+01 -3.0821600341796875e+02 2.4969300842285156e+02 2.7942600250244141e+01 -1.5096099853515625e+02 2.0748800659179688e+02 -3.9637302398681641e+01 -3.1187399291992188e+02 2.0186500549316406e+02 1.0230000305175781e+02 -2.5209999084472656e+02 1.3809999084472656e+02 6.7655197143554688e+01 -2.5209999084472656e+02 1.4110000610351562e+02 3.0641500473022461e+01 -2.5209999084472656e+02 1.3809999084472656e+02 -2.8200000762939453e+01 -1.8330099487304688e+02 2.8678799438476562e+02 1.0526599884033203e+02 -2.5209999084472656e+02 1.4110000610351562e+02 -2.8200000762939453e+01 -3.1294699096679688e+02 2.5462200927734375e+02 1.0230000305175781e+02 -3.1584500122070312e+02 2.0518699645996094e+02 1.0230000305175781e+02 -3.1747399902343750e+02 2.1399299621582031e+02 1.0230000305175781e+02 -1.5445399475097656e+02 2.4756300354003906e+02 1.0230000305175781e+02 -1.5797000122070312e+02 2.4969300842285156e+02 1.0230000305175781e+02 -3.1416000366210938e+02 2.0472599792480469e+02 -2.9775800704956055e+01 -3.1350698852539062e+02 2.0373300170898438e+02 -5.6444297790527344e+01 -2.7767700195312500e+02 2.8103799438476562e+02 1.0526599884033203e+02 -3.0012597656250000e+02 2.5818399047851562e+02 1.0526499938964844e+02 -1.5055300903320312e+02 2.1059500122070312e+02 9.6058898925781250e+01 -2.5209999084472656e+02 2.9460998535156250e+02 1.2900000000000000e+02 -2.5209999084472656e+02 1.4110000610351562e+02 1.0230000305175781e+02 -3.0799401855468750e+02 2.0489199829101562e+02 1.0526599884033203e+02 -1.5900099182128906e+02 2.6027700805664062e+02 1.0526599884033203e+02 -1.6067999267578125e+02 2.6333099365234375e+02 1.2900000000000000e+02 -1.9710000610351562e+02 3.0809997558593750e+02 3.3724399566650391e+01 -1.9710000610351562e+02 3.0809997558593750e+02 1.0230000305175781e+02 -1.7536799621582031e+02 2.0561599731445312e+02 1.2900000000000000e+02 -1.6962400817871094e+02 1.8719599914550781e+02 1.2900000000000000e+02 -2.5209999084472656e+02 1.3809999084472656e+02 1.2900000000000000e+02 -1.5199301147460938e+02 2.0718099975585938e+02 1.0526599884033203e+02 -2.4941000366210938e+02 1.4110000610351562e+02 -4.0305999755859375e+01 -2.5113002014160156e+02 1.3809999084472656e+02 -3.5835197448730469e+01 -2.5176901245117188e+02 1.4110000610351562e+02 -3.2848102569580078e+01 -2.1183300781250000e+02 3.1110000610351562e+02 -5.2639400482177734e+01 -1.5055300903320312e+02 2.3860499572753906e+02 -5.9969802856445312e+01 -3.1751901245117188e+02 2.1450500488281250e+02 1.0526499938964844e+02 -1.7510600280761719e+02 1.6864700317382812e+02 1.2900000000000000e+02 -1.9804798889160156e+02 1.7894999694824219e+02 1.2900000000000000e+02 -2.6873999023437500e+02 2.7767898559570312e+02 1.0230000305175781e+02 -1.5309399414062500e+02 1.6241200256347656e+02 1.0230000305175781e+02 -1.6336700439453125e+02 2.6815097045898438e+02 1.3304998779296875e+02 -1.7266300964355469e+02 2.1527500915527344e+02 1.2900000000000000e+02 -1.7183200073242188e+02 2.2460000610351562e+02 1.2900000000000000e+02 -1.5247799682617188e+02 2.0361000061035156e+02 1.3955000305175781e+02 -2.9426000976562500e+02 2.6562399291992188e+02 1.0526499938964844e+02 -1.6255299377441406e+02 2.5060498046875000e+02 1.8190799713134766e+01 -1.7577600097656250e+02 2.8117001342773438e+02 1.0526599884033203e+02 -2.8762899780273438e+02 2.7258801269531250e+02 1.0526599884033203e+02 -2.9047799682617188e+02 2.6973699951171875e+02 1.2900000000000000e+02 -2.6099899291992188e+02 1.5814700317382812e+02 1.0230000305175781e+02 -2.7701199340820312e+02 2.3110299682617188e+02 1.2900000000000000e+02 -1.7914801025390625e+02 1.9782400512695312e+02 1.3304998779296875e+02 -1.8074501037597656e+02 1.9544699096679688e+02 1.2900000000000000e+02 -1.4992999267578125e+02 2.2841600036621094e+02 1.0526599884033203e+02 -1.5015100097656250e+02 2.1797200012207031e+02 1.0526599884033203e+02 -2.0128401184082031e+02 1.4110000610351562e+02 -4.2833202362060547e+01 -1.9052499389648438e+02 2.6489599609375000e+02 1.2900000000000000e+02 -1.6840399169921875e+02 2.7390301513671875e+02 1.2900000000000000e+02 -2.5867300415039062e+02 2.6484500122070312e+02 1.3304998779296875e+02 -2.3659298706054688e+02 2.7596899414062500e+02 1.3304998779296875e+02 -2.3371900939941406e+02 2.9913198852539062e+02 1.3304998779296875e+02 -2.6977600097656250e+02 2.8632598876953125e+02 1.2900000000000000e+02 -2.5949002075195312e+02 2.9172097778320312e+02 1.2900000000000000e+02 -2.9589001464843750e+02 2.6371301269531250e+02 1.2900000000000000e+02 -2.5547999572753906e+02 2.9297198486328125e+02 1.3304998779296875e+02 -2.2460000610351562e+02 1.7191999816894531e+02 1.2900000000000000e+02 -2.3067100524902344e+02 1.7220599365234375e+02 1.2900000000000000e+02 -1.7273100280761719e+02 2.3429701232910156e+02 1.3304998779296875e+02 -2.7138598632812500e+02 1.9997698974609375e+02 1.3304998779296875e+02 -2.6335702514648438e+02 1.8878099060058594e+02 1.3304998779296875e+02 -2.2460000610351562e+02 2.7727999877929688e+02 1.3304998779296875e+02 -1.5306399536132812e+02 2.0315499877929688e+02 -2.8803701400756836e+01 -1.5583198547363281e+02 2.0062098693847656e+02 -2.5463699340820312e+01 -1.8929701232910156e+02 2.6385800170898438e+02 1.3304998779296875e+02 -2.0006300354003906e+02 2.7139498901367188e+02 1.3304998779296875e+02 -1.5835000610351562e+02 1.9931599426269531e+02 -1.0737000465393066e+01 -1.9710000610351562e+02 1.4110000610351562e+02 5.9928802490234375e+01 -1.7703199768066406e+02 2.4728700256347656e+02 1.2900000000000000e+02 -1.5132800292968750e+02 2.4298199462890625e+02 1.0230200195312500e+02 -1.5609201049804688e+02 2.0045599365234375e+02 -5.2422698974609375e+01 -1.5525099182128906e+02 2.4812998962402344e+02 5.2651199340820312e+01 -1.5147200012207031e+02 2.4347200012207031e+02 -5.9969898223876953e+01 -3.1211199951171875e+02 2.4708999633789062e+02 3.2074897766113281e+01 -3.1314797973632812e+02 2.4590800476074219e+02 3.9531700611114502e+00 -3.1438198852539062e+02 2.4398001098632812e+02 5.3571498870849609e+01 -3.1211199951171875e+02 2.0211000061035156e+02 -1.9134199142456055e+01 -3.1314797973632812e+02 2.0329199218750000e+02 -1.5331000328063965e+01 -3.0821600341796875e+02 2.4969300842285156e+02 -3.0812000274658203e+01 -3.0672900390625000e+02 2.5019801330566406e+02 -6.3017100095748901e-01 -1.5944999694824219e+02 2.5019898986816406e+02 5.3029102325439453e+01 -3.1258401489257812e+02 2.0257499694824219e+02 1.3570899963378906e+01 -1.5065400695800781e+02 2.4017199707031250e+02 5.6193798065185547e+01 -1.5096099853515625e+02 2.4171200561523438e+02 7.7798599243164062e+01 -3.1207800292968750e+02 2.0207199096679688e+02 -5.5226299285888672e+01 -1.6020899963378906e+02 1.9879800415039062e+02 7.4531799316406250e+01 -1.6255299377441406e+02 1.9859500122070312e+02 1.0230000305175781e+02 -3.0821600341796875e+02 2.4969300842285156e+02 2.2100400924682617e+00 -3.1450900268554688e+02 2.4372700500488281e+02 9.9347999572753906e+01 -3.0821600341796875e+02 1.9950700378417969e+02 3.1258199691772461e+01 -3.0597000122070312e+02 1.9879899597167969e+02 5.7319896697998047e+01 -1.5944999694824219e+02 2.5019898986816406e+02 -1.2929599761962891e+01 -1.5944999694824219e+02 2.5019898986816406e+02 2.4188098907470703e+01 -1.5796501159667969e+02 2.4969500732421875e+02 3.9644699096679688e+01 -2.9817898559570312e+02 2.3938999938964844e+02 1.3304998779296875e+02 -2.9660998535156250e+02 2.4588101196289062e+02 1.3955000305175781e+02 -2.9456600952148438e+02 2.5200302124023438e+02 1.3304998779296875e+02 -2.7580499267578125e+02 1.6960800170898438e+02 1.3304998779296875e+02 -2.3258799743652344e+02 3.1110000610351562e+02 -5.4595897674560547e+01 -2.2594801330566406e+02 3.0810101318359375e+02 -5.5724899291992188e+01 -2.8733798217773438e+02 1.7632701110839844e+02 1.2900000000000000e+02 -3.0198498535156250e+02 2.5544500732421875e+02 1.2900000000000000e+02 -1.4967100524902344e+02 2.2040100097656250e+02 1.3304998779296875e+02 -1.5098400878906250e+02 2.0992199707031250e+02 1.3304998779296875e+02 -2.2460000610351562e+02 1.7191999816894531e+02 1.3304998779296875e+02 -2.2125299072265625e+02 3.1110000610351562e+02 -5.5608501434326172e+01 -2.1661199951171875e+02 3.0809997558593750e+02 -5.4595897674560547e+01 -1.6724600219726562e+02 1.7620899963378906e+02 1.3304998779296875e+02 -1.7823699951171875e+02 1.6545899963378906e+02 1.3304998779296875e+02 -1.9393399047851562e+02 1.8166999816894531e+02 1.3304998779296875e+02 -2.0019599914550781e+02 2.7142398071289062e+02 1.2900000000000000e+02 -2.5209999084472656e+02 1.5458999633789062e+02 1.2900000000000000e+02 -3.1163900756835938e+02 2.3153799438476562e+02 1.2899899291992188e+02 -3.1562298583984375e+02 2.1059500122070312e+02 1.0230000305175781e+02 -3.1185800170898438e+02 2.2996699523925781e+02 1.0526599884033203e+02 -3.1216101074218750e+02 2.2477799987792969e+02 1.2900000000000000e+02 -1.5142700195312500e+02 2.0969499206542969e+02 1.2900000000000000e+02 -1.5077301025390625e+02 2.1327101135253906e+02 1.2113300323486328e+02 -1.4989698791503906e+02 2.2133200073242188e+02 1.2900000000000000e+02 -2.5586700439453125e+02 1.6258500671386719e+02 1.0230000305175781e+02 -2.5209999084472656e+02 3.1110000610351562e+02 1.2900000000000000e+02 -1.5968099975585938e+02 1.8680400085449219e+02 1.3304998779296875e+02 -1.9078601074218750e+02 1.6510499572753906e+02 1.0230000305175781e+02 -1.5117800903320312e+02 2.0668899536132812e+02 3.0843800306320190e-01 -2.4458700561523438e+02 1.4110000610351562e+02 -4.7107498168945312e+01 -2.4978601074218750e+02 2.7104397583007812e+02 1.3304998779296875e+02 -2.5209999084472656e+02 3.0809997558593750e+02 1.0230000305175781e+02 -1.7321899414062500e+02 2.3656100463867188e+02 1.2900000000000000e+02 -1.5309399414062500e+02 2.8678799438476562e+02 1.0230000305175781e+02 -1.5913499450683594e+02 2.8678799438476562e+02 1.0230000305175781e+02 -1.5419000244140625e+02 2.5097599792480469e+02 1.3955000305175781e+02 -1.5743200683593750e+02 2.5805300903320312e+02 1.3304998779296875e+02 -1.8442698669433594e+02 1.9037699890136719e+02 1.3304998779296875e+02 -2.8421200561523438e+02 1.7896400451660156e+02 1.3304998779296875e+02 -1.9806599426269531e+02 1.4110000610351562e+02 -3.5868499755859375e+01 -1.9710000610351562e+02 3.1110000610351562e+02 1.2900000000000000e+02 -1.8856700134277344e+02 1.8605999755859375e+02 1.2900000000000000e+02 -3.1363897705078125e+02 2.4560398864746094e+02 1.0230000305175781e+02 -1.5055300903320312e+02 2.3860499572753906e+02 3.7548099517822266e+01 -2.2985499572753906e+02 2.7706399536132812e+02 1.2900000000000000e+02 -1.8330099487304688e+02 2.8678799438476562e+02 1.0230000305175781e+02 -2.4127101135253906e+02 1.7429800415039062e+02 1.2900000000000000e+02 -2.4267800903320312e+02 1.7492500305175781e+02 1.3304998779296875e+02 -2.1381300354003906e+02 1.7285400390625000e+02 1.3304998779296875e+02 -2.0252000427246094e+02 1.7673901367187500e+02 1.3304998779296875e+02 -2.4579901123046875e+02 1.5258399963378906e+02 1.3955000305175781e+02 -2.5209999084472656e+02 1.5458999633789062e+02 1.0230000305175781e+02 -2.3857000732421875e+02 1.4110000610351562e+02 -5.1869602203369141e+01 -2.3985099792480469e+02 2.7518902587890625e+02 1.2900000000000000e+02 -2.4938200378417969e+02 2.7125299072265625e+02 1.2900000000000000e+02 -2.5181901550292969e+02 3.1110000610351562e+02 -3.2403598785400391e+01 -1.8684199523925781e+02 2.8899401855468750e+02 1.2900000000000000e+02 -2.9948898315429688e+02 2.2930300903320312e+02 1.3304998779296875e+02 -2.0461300659179688e+02 1.3809999084472656e+02 -4.7107498168945312e+01 -1.5322000122070312e+02 2.0296299743652344e+02 1.8911499023437500e+01 -3.1314797973632812e+02 2.0329199218750000e+02 3.8815799713134766e+01 -3.1314797973632812e+02 2.0329199218750000e+02 7.5726394653320312e+01 -3.1093099975585938e+02 2.0107400512695312e+02 -2.7268099784851074e+00 -3.0519000244140625e+02 2.5050398254394531e+02 6.1473302841186523e+00 -3.0519000244140625e+02 2.5050398254394531e+02 2.9441900253295898e+01 -3.1562298583984375e+02 2.1059500122070312e+02 4.6775699615478516e+01 -2.4791600036621094e+02 1.3809999084472656e+02 -4.2833202362060547e+01 -1.9743099975585938e+02 1.3809999084472656e+02 -3.2848102569580078e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 55 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3806399703025818e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector -1.5055300295352936e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector -1.3104900717735291e+02 2.2701500356197357e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3806399703025818e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector -1.5309399366378784e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector -1.5664899349212646e+02 2.4914300441741943e+02 -5.9970799833536148e+01) (float-vector -1.5055300295352936e+02 2.3860499262809753e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector -3.0943799018859863e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9610601067543030e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector -3.0943799018859863e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1419399380683899e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -3.1419399380683899e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5309399366378784e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector -1.9875699281692505e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector -1.5664899349212646e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9875699281692505e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector -2.1183300018310547e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector -1.5664899349212646e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181901454925537e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector -2.9610601067543030e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -2.4791599810123444e+02 1.3809999823570251e+02 -4.2833201587200165e+01) (float-vector -2.4075900018215179e+02 1.3809999823570251e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector -2.4791599810123444e+02 1.3809999823570251e+02 -4.2833201587200165e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4579900503158569e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector -2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector -1.5055300295352936e+02 2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector -1.5055300295352936e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector -1.5664899349212646e+02 2.4914300441741943e+02 -5.9970799833536148e+01) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5055300295352936e+02 2.1059499680995941e+02 -5.9969801455736160e+01) (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector -1.4330500364303589e+02 1.7801100015640259e+02 1.0526499897241592e+02) (float-vector -1.3250200450420380e+02 2.0908200740814209e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3250200450420380e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector -1.3104900717735291e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector -1.5055300295352936e+02 2.3860499262809753e+02 -5.9969801455736160e+01) (float-vector -1.5055300295352936e+02 2.1059499680995941e+02 -5.9969801455736160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector -1.9108900427818298e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3104900717735291e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector -1.3250200450420380e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector -1.5247799456119537e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector -1.4959000051021576e+02 2.2176299989223480e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6203199326992035e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector -1.5247799456119537e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector -1.3250200450420380e+02 2.0908200740814209e+02 1.0230000317096710e+02) (float-vector -1.4330500364303589e+02 1.7801100015640259e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5309399366378784e+02 1.6241200268268585e+02 1.0230000317096710e+02) (float-vector -1.9743099808692932e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector -1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01) (float-vector -1.9743099808692932e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector -1.5309399366378784e+02 1.6241200268268585e+02 1.0230000317096710e+02) (float-vector -1.4330500364303589e+02 1.7801100015640259e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.9108900427818298e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector -1.6203199326992035e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector -1.4330500364303589e+02 1.7801100015640259e+02 1.0526499897241592e+02) (float-vector -1.5309399366378784e+02 1.6241200268268585e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1108500659465790e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector -1.9743099808692932e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.9875699281692505e+02 3.1110098958015442e+02 -3.8267400115728378e+01) (float-vector -1.5309399366378784e+02 2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6750200092792511e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.5309399366378784e+02 2.8678798675537109e+02 1.0230000317096710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3904600739479065e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector -2.5181901454925537e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5419000387191772e+02 2.5097599625587463e+02 1.3955000042915344e+02) (float-vector -1.3806399703025818e+02 2.5943601131439209e+02 1.0526599735021591e+02) (float-vector -1.3104900717735291e+02 2.2701500356197357e+02 1.0230000317096710e+02) (float-vector -1.4959000051021576e+02 2.2176299989223480e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5419000387191772e+02 2.5097599625587463e+02 1.3955000042915344e+02) (float-vector -1.6750200092792511e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector -1.5309399366378784e+02 2.8678798675537109e+02 1.0230000317096710e+02) (float-vector -1.3806399703025818e+02 2.5943601131439209e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -2.2026200592517853e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2026200592517853e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector -3.1479099392890930e+02 2.0587599277496338e+02 -5.9969998896121979e+01) (float-vector -2.4075900018215179e+02 1.3809999823570251e+02 -5.0521600991487503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2026200592517853e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector -2.1108500659465790e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector -1.5382599830627441e+02 2.0234100520610809e+02 -5.9969700872898102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -1.9743099808692932e+02 1.3809999823570251e+02 -3.2848101109266281e+01) (float-vector -2.1108500659465790e+02 1.3809999823570251e+02 -5.2161600440740585e+01) (float-vector -2.2026200592517853e+02 1.3809999823570251e+02 -5.5569801479578018e+01) (float-vector -2.4075900018215179e+02 1.3809999823570251e+02 -5.0521600991487503e+01) (float-vector -2.4791599810123444e+02 1.3809999823570251e+02 -4.2833201587200165e+01) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 -2.8200000524520874e+01) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.9030800461769104e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector -2.1309900283813477e+02 2.9884099960327148e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9030800461769104e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.6750200092792511e+02 2.7328801155090332e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2125299274921417e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector -2.3904600739479065e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1183300018310547e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector -2.2125299274921417e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector -3.1411498785018921e+02 2.4453499913215637e+02 -5.9969898313283920e+01) (float-vector -1.5664899349212646e+02 2.4914300441741943e+02 -5.9970799833536148e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7223700284957886e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector -2.4579900503158569e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7223700284957886e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 1.3809999823570251e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1185600161552429e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector -3.1419399380683899e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5181901454925537e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.3481400310993195e+02 2.9899200797080994e+02 1.3955000042915344e+02) (float-vector -2.5610598921775818e+02 2.9278600215911865e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.5181901454925537e+02 3.1110000610351562e+02 -3.2403599470853806e+01) (float-vector -2.3904600739479065e+02 3.1110000610351562e+02 -5.1552701741456985e+01) (float-vector -2.2125299274921417e+02 3.1110000610351562e+02 -5.5608499795198441e+01) (float-vector -2.1183300018310547e+02 3.1110000610351562e+02 -5.2639398723840714e+01) (float-vector -1.9875699281692505e+02 3.1110098958015442e+02 -3.8267400115728378e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -1.9709999859333038e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.1309900283813477e+02 2.9884099960327148e+02 1.3955000042915344e+02) (float-vector -2.3481400310993195e+02 2.9899200797080994e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02) (float-vector -3.0640199780464172e+02 2.0137800276279449e+02 1.2899999320507050e+02) (float-vector -2.9144999384880066e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector -2.7223700284957886e+02 1.6646899282932281e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1419399380683899e+02 1.9842299818992615e+02 1.0526599735021591e+02) (float-vector -3.1185600161552429e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector -3.0640199780464172e+02 2.0137800276279449e+02 1.2899999320507050e+02) (float-vector -2.9610601067543030e+02 1.6241200268268585e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.8166100382804871e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector -2.9610601067543030e+02 2.8678798675537109e+02 1.0526599735021591e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8166100382804871e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector -2.5209999084472656e+02 3.1110000610351562e+02 1.2899999320507050e+02) (float-vector -2.5610598921775818e+02 2.9278600215911865e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0943799018859863e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector -3.1004899740219116e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1004899740219116e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector -3.1185600161552429e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector -3.1788599491119385e+02 2.3227599263191223e+02 1.0526499897241592e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0943799018859863e+02 2.6357400417327881e+02 1.0526499897241592e+02) (float-vector -2.9610601067543030e+02 2.8678798675537109e+02 1.0526599735021591e+02) (float-vector -2.8166100382804871e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector -3.1004899740219116e+02 2.3853099346160889e+02 1.2899999320507050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9660999774932861e+02 2.4588100612163544e+02 1.3955000042915344e+02) (float-vector -3.1004899740219116e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector -2.8166100382804871e+02 2.7333900332450867e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4959000051021576e+02 2.2176299989223480e+02 1.3955000042915344e+02) (float-vector -1.5247799456119537e+02 2.0361000299453735e+02 1.3955000042915344e+02) (float-vector -1.6203199326992035e+02 1.8310000002384186e+02 1.3955000042915344e+02) (float-vector -1.9108900427818298e+02 1.5735900402069092e+02 1.3955000042915344e+02) (float-vector -2.2460000216960907e+02 1.4959999918937683e+02 1.3955000042915344e+02) (float-vector -2.4579900503158569e+02 1.5258400142192841e+02 1.3955000042915344e+02) (float-vector -2.7223700284957886e+02 1.6646899282932281e+02 1.3955000042915344e+02) (float-vector -2.9144999384880066e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector -2.9940301179885864e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector -2.9660999774932861e+02 2.4588100612163544e+02 1.3955000042915344e+02) (float-vector -2.8166100382804871e+02 2.7333900332450867e+02 1.3955000042915344e+02) (float-vector -2.5610598921775818e+02 2.9278600215911865e+02 1.3955000042915344e+02) (float-vector -2.3481400310993195e+02 2.9899200797080994e+02 1.3955000042915344e+02) (float-vector -2.1309900283813477e+02 2.9884099960327148e+02 1.3955000042915344e+02) (float-vector -1.9030800461769104e+02 2.9147401452064514e+02 1.3955000042915344e+02) (float-vector -1.6750200092792511e+02 2.7328801155090332e+02 1.3955000042915344e+02) (float-vector -1.5419000387191772e+02 2.5097599625587463e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9940301179885864e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector -3.1185600161552429e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector -3.1004899740219116e+02 2.3853099346160889e+02 1.2899999320507050e+02) (float-vector -2.9660999774932861e+02 2.4588100612163544e+02 1.3955000042915344e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1185600161552429e+02 2.1916399896144867e+02 1.2899999320507050e+02) (float-vector -2.9940301179885864e+02 2.1820099651813507e+02 1.3955000042915344e+02) (float-vector -2.9144999384880066e+02 1.9044999778270721e+02 1.3955000042915344e+02) (float-vector -3.0640199780464172e+02 2.0137800276279449e+02 1.2899999320507050e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "fr_caster_rotation_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_mount_kinect_ir_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -3.2266999999999996e+01 1.2500000000000000e+01 1.3645300000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 10 11 0 0 11 1 36 0 2 36 10 0 2 1 3 2 3 4 36 2 4 36 4 6 36 6 8 36 8 10 8 9 10 10 9 11 6 7 8 8 7 9 4 5 6 6 5 7 4 3 5 3 13 5 5 13 14 5 14 7 7 14 15 7 15 9 9 15 16 9 16 11 14 20 15 15 20 21 15 21 16 13 19 14 14 19 20 19 25 20 20 25 26 20 26 21 16 21 22 21 26 27 21 27 22 25 31 26 26 31 32 26 32 27 19 24 25 24 30 25 25 30 31 30 37 31 31 37 32 27 32 33 32 37 33 22 27 28 27 33 28 28 33 34 33 37 34 34 37 35 35 37 30 24 35 30 29 34 35 29 35 24 18 24 19 18 29 24 23 28 29 23 29 18 28 34 29 22 28 23 17 22 23 17 23 12 12 23 18 12 18 13 13 18 19 1 12 3 3 12 13 1 17 12 11 16 17 11 17 1 16 22 17))
                   (list :vertices (let ((mat (make-matrix 38 3))) (fvector-replace (array-entity mat) #f(3.2483901977539062e+01 -1.2500000000000000e+01 -1.3600300598144531e+02 3.2657897949218750e+01 -1.2500000000000000e+01 -1.3614100646972656e+02 3.2375499725341797e+01 -1.2312100410461426e+01 -1.3600300598144531e+02 3.2462501525878906e+01 -1.2161499977111816e+01 -1.3614100646972656e+02 3.2158500671386719e+01 -1.2312100410461426e+01 -1.3600300598144531e+02 3.2071502685546875e+01 -1.2161499977111816e+01 -1.3614100646972656e+02 3.2050098419189453e+01 -1.2500000000000000e+01 -1.3600300598144531e+02 3.1876098632812500e+01 -1.2500000000000000e+01 -1.3614100646972656e+02 3.2158500671386719e+01 -1.2687900543212891e+01 -1.3600300598144531e+02 3.2071502685546875e+01 -1.2838500022888184e+01 -1.3614100646972656e+02 3.2375499725341797e+01 -1.2687900543212891e+01 -1.3600300598144531e+02 3.2462501525878906e+01 -1.2838500022888184e+01 -1.3614100646972656e+02 3.2754501342773438e+01 -1.2500000000000000e+01 -1.3634201049804688e+02 3.2510700225830078e+01 -1.2077799797058105e+01 -1.3634201049804688e+02 3.2023300170898438e+01 -1.2077799797058105e+01 -1.3634201049804688e+02 3.1779500961303711e+01 -1.2500000000000000e+01 -1.3634201049804688e+02 3.2023300170898438e+01 -1.2922200202941895e+01 -1.3634201049804688e+02 3.2510700225830078e+01 -1.2922200202941895e+01 -1.3634201049804688e+02 3.2754501342773438e+01 -1.2500000000000000e+01 -1.3656399536132812e+02 3.2510700225830078e+01 -1.2077799797058105e+01 -1.3656399536132812e+02 3.2023300170898438e+01 -1.2077799797058105e+01 -1.3656399536132812e+02 3.1779500961303711e+01 -1.2500000000000000e+01 -1.3656399536132812e+02 3.2023300170898438e+01 -1.2922200202941895e+01 -1.3656399536132812e+02 3.2510700225830078e+01 -1.2922200202941895e+01 -1.3656399536132812e+02 3.2657897949218750e+01 -1.2500000000000000e+01 -1.3676499938964844e+02 3.2462501525878906e+01 -1.2161499977111816e+01 -1.3676499938964844e+02 3.2071502685546875e+01 -1.2161499977111816e+01 -1.3676499938964844e+02 3.1876098632812500e+01 -1.2500000000000000e+01 -1.3676499938964844e+02 3.2071502685546875e+01 -1.2838500022888184e+01 -1.3676499938964844e+02 3.2462501525878906e+01 -1.2838500022888184e+01 -1.3676499938964844e+02 3.2483901977539062e+01 -1.2500000000000000e+01 -1.3690299987792969e+02 3.2375499725341797e+01 -1.2312100410461426e+01 -1.3690299987792969e+02 3.2158500671386719e+01 -1.2312100410461426e+01 -1.3690299987792969e+02 3.2050098419189453e+01 -1.2500000000000000e+01 -1.3690299987792969e+02 3.2158500671386719e+01 -1.2687900543212891e+01 -1.3690299987792969e+02 3.2375499725341797e+01 -1.2687900543212891e+01 -1.3690299987792969e+02 3.2267002105712891e+01 -1.2500000000000000e+01 -1.3595298767089844e+02 3.2267002105712891e+01 -1.2500000000000000e+01 -1.3695300292968750e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 216 -> 4 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2754499465227127e+01 -1.2500000186264515e+01 -1.3656400144100189e+02) (float-vector 3.2510701566934586e+01 -1.2077799998223782e+01 -1.3634200394153595e+02) (float-vector 3.1779501587152481e+01 -1.2500000186264515e+01 -1.3634200394153595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2267000526189804e+01 -1.2500000186264515e+01 -1.3595299422740936e+02) (float-vector 3.2754499465227127e+01 -1.2500000186264515e+01 -1.3656400144100189e+02) (float-vector 3.1779501587152481e+01 -1.2500000186264515e+01 -1.3634200394153595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2510701566934586e+01 -1.2077799998223782e+01 -1.3634200394153595e+02) (float-vector 3.2267000526189804e+01 -1.2500000186264515e+01 -1.3595299422740936e+02) (float-vector 3.1779501587152481e+01 -1.2500000186264515e+01 -1.3634200394153595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2267000526189804e+01 -1.2500000186264515e+01 -1.3595299422740936e+02) (float-vector 3.2510701566934586e+01 -1.2077799998223782e+01 -1.3634200394153595e+02) (float-vector 3.2754499465227127e+01 -1.2500000186264515e+01 -1.3656400144100189e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_mount_kinect_ir_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_mount_kinect_rgb_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -1.8366991384599999e+01 -2.1222300136900000e+01 -2.1886964296799999e+01)
                                    :rot (quaternion2matrix (float-vector 9.9967297120778287e-01 -5.6000060945167749e-03 -2.4366744094289648e-02 -5.3714384096068416e-03)))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 10 11 0 0 11 1 36 0 2 36 10 0 2 1 3 2 3 4 36 2 4 36 4 6 36 6 8 36 8 10 8 9 10 10 9 11 6 7 8 8 7 9 4 5 6 6 5 7 4 3 5 3 13 5 5 13 14 5 14 7 7 14 15 7 15 9 9 15 16 9 16 11 14 20 15 15 20 21 15 21 16 13 19 14 14 19 20 19 25 20 20 25 26 20 26 21 16 21 22 21 26 27 21 27 22 25 31 26 26 31 32 26 32 27 19 24 25 24 30 25 25 30 31 30 37 31 31 37 32 27 32 33 32 37 33 22 27 28 27 33 28 28 33 34 33 37 34 34 37 35 35 37 30 24 35 30 29 34 35 29 35 24 18 24 19 18 29 24 23 28 29 23 29 18 28 34 29 22 28 23 17 22 23 17 23 12 12 23 18 12 18 13 13 18 19 1 12 3 3 12 13 1 17 12 11 16 17 11 17 1 16 22 17))
                   (list :vertices (let ((mat (make-matrix 38 3))) (fvector-replace (array-entity mat) #f(1.9428199768066406e+01 2.1180101394653320e+01 2.1648399353027344e+01 1.9595199584960938e+01 2.1183601379394531e+01 2.1501399993896484e+01 1.9317901611328125e+01 2.1366798400878906e+01 2.1655900955200195e+01 1.9396501541137695e+01 2.1519899368286133e+01 2.1514799118041992e+01 1.9101299285888672e+01 2.1364400863647461e+01 2.1666400909423828e+01 1.9006000518798828e+01 2.1515600204467773e+01 2.1533800125122070e+01 1.8994899749755859e+01 2.1175399780273438e+01 2.1669599533081055e+01 1.8814399719238281e+01 2.1175001144409180e+01 2.1539499282836914e+01 1.9105199813842773e+01 2.0988700866699219e+01 2.1662099838256836e+01 1.9013099670410156e+01 2.0838600158691406e+01 2.1526100158691406e+01 1.9321899414062500e+01 2.0991100311279297e+01 2.1651599884033203e+01 1.9403598785400391e+01 2.0842901229858398e+01 2.1506999969482422e+01 1.9681900024414062e+01 2.1186800003051758e+01 2.1296499252319336e+01 1.9434000015258789e+01 2.1606300354003906e+01 2.1313199996948242e+01 1.8947200775146484e+01 2.1600900650024414e+01 2.1336900711059570e+01 1.8708198547363281e+01 2.1176099777221680e+01 2.1343900680541992e+01 1.8955999374389648e+01 2.0756698608398438e+01 2.1327199935913086e+01 1.9442899703979492e+01 2.0762001037597656e+01 2.1303499221801758e+01 1.9671001434326172e+01 2.1189300537109375e+01 2.1074199676513672e+01 1.9423200607299805e+01 2.1608699798583984e+01 2.1090900421142578e+01 1.8936300277709961e+01 2.1603300094604492e+01 2.1114700317382812e+01 1.8697301864624023e+01 2.1178501129150391e+01 2.1121700286865234e+01 1.8945199966430664e+01 2.0759099960327148e+01 2.1105001449584961e+01 1.9432001113891602e+01 2.0764499664306641e+01 2.1081300735473633e+01 1.9564800262451172e+01 2.1190399169921875e+01 2.0878700256347656e+01 1.9366100311279297e+01 2.1526699066162109e+01 2.0892101287841797e+01 1.8975601196289062e+01 2.1522401809692383e+01 2.0911098480224609e+01 1.8784000396728516e+01 2.1181798934936523e+01 2.0916700363159180e+01 1.8982698440551758e+01 2.0845399856567383e+01 2.0903398513793945e+01 1.9373100280761719e+01 2.0849699020385742e+01 2.0884300231933594e+01 1.9384300231933594e+01 2.1190000534057617e+01 2.0748600006103516e+01 1.9274000167846680e+01 2.1376699447631836e+01 2.0756000518798828e+01 1.9057300567626953e+01 2.1374300003051758e+01 2.0766599655151367e+01 1.8950899124145508e+01 2.1185199737548828e+01 2.0769701004028320e+01 1.9061300277709961e+01 2.0998600006103516e+01 2.0762300491333008e+01 1.9277900695800781e+01 2.1000900268554688e+01 2.0751699447631836e+01 1.9214000701904297e+01 2.1177200317382812e+01 2.1708499908447266e+01 1.9165199279785156e+01 2.1188100814819336e+01 2.0709701538085938e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 216 -> 4 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9681900739669800e+01 2.1186800673604012e+01 2.1296499297022820e+01) (float-vector 1.9423199817538261e+01 2.1608699113130569e+01 2.1090900525450706e+01) (float-vector 1.8697300925850868e+01 2.1178500726819038e+01 2.1121699362993240e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9214000552892685e+01 2.1177200600504875e+01 2.1708499640226364e+01) (float-vector 1.9681900739669800e+01 2.1186800673604012e+01 2.1296499297022820e+01) (float-vector 1.8697300925850868e+01 2.1178500726819038e+01 2.1121699362993240e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9423199817538261e+01 2.1608699113130569e+01 2.1090900525450706e+01) (float-vector 1.9214000552892685e+01 2.1177200600504875e+01 2.1708499640226364e+01) (float-vector 1.8697300925850868e+01 2.1178500726819038e+01 2.1121699362993240e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9214000552892685e+01 2.1177200600504875e+01 2.1708499640226364e+01) (float-vector 1.9423199817538261e+01 2.1608699113130569e+01 2.1090900525450706e+01) (float-vector 1.9681900739669800e+01 2.1186800673604012e+01 2.1296499297022820e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_mount_kinect_rgb_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_mount_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -1.3800000000000000e+02 0.0000000000000000e+00 9.1000000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.250000 0.250000 0.250000 1.000000))
                    (list :diffuse (float-vector 0.500000 0.500000 0.500000 1.000000))))
                   (list :indices #i( 0 1 2 13 14 0 0 14 15 0 15 1 2 123 0 0 123 125 0 125 13 13 12 14 12 126 14 14 126 124 14 124 15 15 124 122 15 122 1 123 122 124 123 124 125 125 124 126 120 122 123 2 120 123 120 121 122 1 122 121 118 119 120 119 121 120 4 118 120 4 120 2 1 121 3 3 121 119 2 1 3 2 3 4 4 3 5 4 5 6 6 118 4 3 119 5 118 117 119 5 119 117 116 117 118 6 116 118 6 5 7 6 7 8 8 116 6 5 117 7 116 115 117 7 117 115 114 115 116 8 114 116 7 57 8 8 57 58 8 58 59 59 114 8 7 115 57 114 113 115 57 115 113 77 113 114 59 77 114 59 58 60 59 60 61 61 77 59 57 113 58 58 113 112 58 112 60 77 112 113 75 76 77 76 112 77 61 75 77 61 60 62 61 62 32 32 75 61 60 112 76 60 76 62 75 74 76 62 76 74 73 74 75 32 73 75 32 33 34 32 62 63 32 63 33 34 73 32 62 74 63 73 72 74 63 74 72 71 72 73 34 71 73 34 33 35 34 35 36 36 71 34 100 101 71 71 101 102 71 102 72 36 100 71 63 72 33 33 72 102 33 102 35 36 35 37 35 102 101 35 101 37 36 37 38 38 100 36 98 99 100 100 99 101 38 98 100 37 101 99 38 37 39 37 99 39 38 39 40 40 98 38 96 97 98 98 97 99 40 96 98 39 99 97 39 50 40 39 97 50 40 50 51 40 51 52 52 96 40 70 95 96 96 95 97 52 70 96 50 97 95 50 95 51 52 51 53 51 95 94 51 94 53 52 53 54 54 70 52 54 53 55 53 69 55 53 94 69 69 94 70 70 94 95 68 69 70 54 68 70 54 55 23 23 68 54 23 55 56 55 69 67 55 67 56 68 67 69 66 67 68 23 66 68 23 24 25 23 56 24 25 66 23 56 67 65 56 65 24 66 65 67 64 65 66 25 64 66 25 24 26 25 26 27 27 64 25 24 65 86 24 86 26 64 86 65 84 85 64 64 85 86 27 84 64 27 26 28 27 28 29 29 84 27 26 86 85 26 85 28 84 83 85 28 85 83 82 83 84 29 82 84 29 28 30 29 30 16 16 82 29 28 83 30 82 81 83 30 83 81 80 81 82 16 80 82 16 17 18 16 30 31 16 31 17 18 80 16 30 81 31 80 79 81 31 81 79 78 79 80 18 78 80 18 17 19 18 19 20 20 78 18 91 92 78 78 92 93 78 93 79 20 91 78 31 79 17 17 79 93 17 93 19 20 19 21 19 93 92 19 92 21 20 21 22 22 91 20 89 90 91 91 90 92 22 89 91 21 92 90 21 41 22 21 90 41 22 41 42 22 42 43 43 89 22 87 88 89 89 88 90 43 87 89 41 90 88 41 88 42 43 42 44 42 88 111 42 111 44 43 44 45 45 87 43 45 44 46 44 111 110 44 110 46 87 110 111 87 111 88 109 110 87 45 109 87 45 46 47 47 109 45 47 46 48 46 110 108 46 108 48 109 108 110 107 108 109 47 107 109 47 48 9 9 107 47 9 48 49 48 108 106 48 106 49 107 106 108 105 106 107 9 105 107 9 10 11 9 49 10 11 105 9 49 106 104 49 104 10 105 104 106 103 104 105 11 103 105 11 10 12 11 12 13 13 103 11 10 104 127 10 127 12 103 127 104 125 126 103 103 126 127 13 125 103 12 127 126 128 129 130 141 142 128 128 142 143 128 143 129 130 251 128 128 251 253 128 253 141 141 140 142 140 254 142 142 254 252 142 252 143 143 252 250 143 250 129 251 250 252 251 252 253 253 252 254 248 250 251 130 248 251 248 249 250 129 250 249 246 247 248 247 249 248 132 246 248 132 248 130 129 249 131 131 249 247 130 129 131 130 131 132 132 131 133 132 133 134 134 246 132 131 247 133 246 245 247 133 247 245 244 245 246 134 244 246 134 133 135 134 135 136 136 244 134 133 245 135 244 243 245 135 245 243 242 243 244 136 242 244 135 185 136 136 185 186 136 186 187 187 242 136 135 243 185 242 241 243 185 243 241 205 241 242 187 205 242 187 186 188 187 188 189 189 205 187 185 241 186 186 241 240 186 240 188 205 240 241 203 204 205 204 240 205 189 203 205 189 188 190 189 190 160 160 203 189 188 240 204 188 204 190 203 202 204 190 204 202 201 202 203 160 201 203 160 161 162 160 190 191 160 191 161 162 201 160 190 202 191 201 200 202 191 202 200 199 200 201 162 199 201 162 161 163 162 163 164 164 199 162 228 229 199 199 229 230 199 230 200 164 228 199 191 200 161 161 200 230 161 230 163 164 163 165 163 230 229 163 229 165 164 165 166 166 228 164 226 227 228 228 227 229 166 226 228 165 229 227 166 165 167 165 227 167 166 167 168 168 226 166 224 225 226 226 225 227 168 224 226 167 227 225 167 178 168 167 225 178 168 178 179 168 179 180 180 224 168 198 223 224 224 223 225 180 198 224 178 225 223 178 223 179 180 179 181 179 223 222 179 222 181 180 181 182 182 198 180 182 181 183 181 197 183 181 222 197 197 222 198 198 222 223 196 197 198 182 196 198 182 183 151 151 196 182 151 183 184 183 197 195 183 195 184 196 195 197 194 195 196 151 194 196 151 152 153 151 184 152 153 194 151 184 195 193 184 193 152 194 193 195 192 193 194 153 192 194 153 152 154 153 154 155 155 192 153 152 193 214 152 214 154 192 214 193 212 213 192 192 213 214 155 212 192 155 154 156 155 156 157 157 212 155 154 214 213 154 213 156 212 211 213 156 213 211 210 211 212 157 210 212 157 156 158 157 158 144 144 210 157 156 211 158 210 209 211 158 211 209 208 209 210 144 208 210 144 145 146 144 158 159 144 159 145 146 208 144 158 209 159 208 207 209 159 209 207 206 207 208 146 206 208 146 145 147 146 147 148 148 206 146 219 220 206 206 220 221 206 221 207 148 219 206 159 207 145 145 207 221 145 221 147 148 147 149 147 221 220 147 220 149 148 149 150 150 219 148 217 218 219 219 218 220 150 217 219 149 220 218 149 169 150 149 218 169 150 169 170 150 170 171 171 217 150 215 216 217 217 216 218 171 215 217 169 218 216 169 216 170 171 170 172 170 216 239 170 239 172 171 172 173 173 215 171 173 172 174 172 239 238 172 238 174 215 238 239 215 239 216 237 238 215 173 237 215 173 174 175 175 237 173 175 174 176 174 238 236 174 236 176 237 236 238 235 236 237 175 235 237 175 176 137 137 235 175 137 176 177 176 236 234 176 234 177 235 234 236 233 234 235 137 233 235 137 138 139 137 177 138 139 233 137 177 234 232 177 232 138 233 232 234 231 232 233 139 231 233 139 138 140 139 140 141 141 231 139 138 232 255 138 255 140 231 255 232 253 254 231 231 254 255 141 253 231 140 255 254 256 257 258 258 291 256 291 394 256 256 394 257 258 290 291 290 395 291 291 395 394 392 393 394 394 395 392 394 393 257 392 395 396 290 396 395 392 396 397 397 396 398 398 396 290 397 398 399 289 392 397 289 397 288 288 397 399 399 398 400 398 401 400 290 287 398 398 287 401 288 399 285 285 399 400 285 287 288 288 287 289 289 287 290 289 290 258 258 392 289 285 286 287 287 286 401 284 283 285 283 286 285 285 400 284 401 286 283 282 281 283 282 283 284 401 283 402 402 283 281 284 400 403 284 403 282 273 281 282 282 403 407 282 407 273 400 402 403 403 402 404 404 407 403 400 401 402 281 404 402 405 406 404 404 406 407 281 405 404 273 407 406 405 411 406 406 411 412 406 412 413 273 406 413 280 411 405 280 405 281 272 412 411 272 411 280 413 412 408 274 408 412 274 412 272 413 408 414 414 275 413 413 275 273 414 408 410 410 278 414 414 278 277 414 277 275 274 273 275 274 275 276 276 275 277 272 273 274 276 408 274 272 280 273 273 280 281 408 409 410 408 415 409 276 415 408 409 271 410 410 271 278 277 278 276 276 278 271 276 271 279 279 415 276 409 415 416 279 416 415 409 416 417 417 270 409 409 270 271 270 269 271 279 271 269 269 416 279 417 416 418 269 418 416 418 427 417 427 268 417 417 268 270 268 269 270 268 267 269 267 418 269 425 426 418 418 426 427 267 425 418 426 260 427 427 260 268 260 267 268 260 266 267 266 425 267 423 424 425 425 424 426 266 423 425 424 262 426 426 262 260 259 260 261 261 260 262 259 266 260 259 423 266 421 422 423 423 422 424 259 421 423 422 262 424 262 263 261 422 263 262 421 420 422 420 263 422 261 263 264 420 264 263 419 420 421 420 419 265 265 264 420 261 264 265 534 261 535 535 261 265 534 539 261 261 539 540 261 540 541 544 261 542 542 261 541 544 421 261 261 421 259 596 539 534 596 534 597 597 534 535 595 596 421 421 596 597 595 539 596 597 601 421 597 623 601 597 535 623 601 623 624 623 535 575 623 575 624 574 575 535 265 582 535 535 582 583 535 583 574 574 573 575 624 575 573 537 563 573 537 573 574 624 573 626 626 573 563 562 561 563 562 563 536 536 563 537 626 563 627 627 563 561 625 624 626 625 626 604 604 626 627 604 627 586 586 627 628 627 561 628 586 628 587 628 561 559 628 559 587 558 559 560 560 559 561 587 559 558 566 565 558 566 558 567 567 558 560 587 558 616 616 558 565 564 565 566 586 564 566 586 566 605 605 566 567 564 541 565 616 565 617 617 565 541 610 587 616 610 616 611 611 616 617 611 617 421 421 617 618 617 541 618 542 541 564 618 541 540 421 618 595 618 540 595 421 601 602 421 602 419 611 421 544 601 624 625 625 574 601 601 574 583 601 583 602 604 537 625 625 537 574 604 586 605 604 605 609 609 538 604 604 538 537 536 537 538 538 576 536 609 576 538 605 622 609 609 622 600 609 600 593 593 576 609 605 567 622 622 568 600 622 567 568 567 560 568 568 560 569 568 569 570 600 568 570 560 561 562 599 569 560 599 560 594 594 560 562 570 569 532 598 532 569 598 569 599 598 599 600 593 600 599 593 599 594 592 593 594 594 562 592 592 562 536 590 591 592 592 591 593 592 536 590 591 577 593 593 577 576 590 631 591 631 579 591 591 579 577 536 576 577 536 577 578 578 577 579 590 536 578 578 579 557 590 578 630 630 578 557 557 579 555 555 579 584 631 584 579 590 621 631 621 584 631 555 584 265 265 584 585 621 585 584 419 620 621 630 419 621 630 621 590 620 585 621 265 585 580 620 580 585 419 619 620 619 580 620 580 581 265 619 581 580 603 619 419 603 581 619 265 581 582 603 582 581 419 602 603 602 582 603 602 583 582 629 419 630 629 265 419 630 632 629 630 557 632 629 632 633 632 556 633 632 557 556 555 556 557 555 554 556 633 556 554 629 633 634 634 633 635 633 554 635 553 552 554 553 554 555 635 554 552 555 265 629 555 629 634 555 634 553 634 635 636 553 634 636 636 635 637 635 552 637 551 550 552 551 552 553 637 552 550 553 636 551 636 637 531 551 636 531 531 637 638 637 550 638 529 533 550 529 550 551 638 550 533 551 531 529 530 529 531 608 530 531 531 638 608 608 638 639 638 533 639 528 532 533 528 533 529 639 533 532 528 529 530 608 615 530 528 530 615 614 613 615 614 615 608 528 615 548 548 615 613 612 613 614 608 549 614 614 549 547 614 547 612 612 611 613 548 613 546 546 613 611 546 547 548 548 547 549 548 549 528 572 528 549 608 572 549 571 528 572 607 571 572 607 572 608 598 607 608 608 639 598 598 606 607 606 571 607 570 532 571 571 532 528 606 570 571 600 606 598 600 570 606 639 532 598 546 545 547 612 547 545 544 543 545 544 545 546 612 545 610 610 545 543 610 611 612 589 587 610 610 543 589 542 543 544 589 543 542 546 611 544 589 542 588 588 542 564 588 587 589 586 587 588 588 564 586 595 540 539 482 483 392 392 483 484 392 484 473 473 475 392 392 475 489 392 489 393 465 480 392 392 480 497 497 507 392 392 507 508 392 508 482 258 465 392 508 365 482 507 365 508 497 506 507 506 359 507 507 359 365 293 364 365 293 365 359 482 365 364 482 364 363 482 363 483 258 363 364 258 364 293 348 363 258 483 363 348 483 348 484 258 347 348 484 348 347 484 347 473 346 347 258 473 347 346 473 474 475 473 346 474 258 351 346 346 351 352 346 352 353 474 346 353 257 350 258 258 350 351 293 465 258 257 349 350 489 351 350 489 350 490 490 350 349 345 349 257 490 349 491 491 349 345 393 489 490 393 490 491 475 351 489 475 474 476 475 476 477 477 504 475 504 352 475 475 352 351 474 353 476 476 353 377 476 377 477 502 503 477 477 503 504 477 377 502 504 378 352 503 379 504 504 379 378 353 352 377 377 352 378 377 378 366 502 377 366 366 378 379 366 379 367 501 367 379 501 379 503 502 501 503 500 501 502 500 517 501 517 367 501 366 367 338 338 367 368 517 368 367 502 366 338 337 338 294 294 338 339 338 368 339 502 338 500 500 338 337 514 339 368 514 368 517 500 514 517 512 513 514 516 512 514 516 514 500 513 339 514 294 339 340 513 340 339 512 511 513 511 340 513 340 356 294 511 356 340 510 511 512 510 356 511 294 356 357 510 357 356 512 525 510 525 357 510 294 357 257 257 357 358 525 358 357 393 524 525 512 393 525 524 344 525 525 344 358 257 358 344 344 345 257 257 393 294 523 345 344 523 344 524 393 523 524 491 523 393 491 345 523 527 467 393 527 393 512 294 393 467 509 467 527 512 361 527 527 361 509 498 467 509 509 362 384 509 384 498 509 361 362 354 337 361 361 337 294 361 294 362 512 354 361 294 384 362 294 383 384 498 384 383 498 499 467 498 383 499 382 383 294 499 383 382 522 467 499 499 382 522 294 391 382 522 382 391 521 467 522 522 391 521 294 390 391 521 391 390 520 492 521 521 492 467 521 390 520 376 389 390 376 390 294 520 390 389 471 519 520 520 519 492 520 389 471 386 388 389 386 389 376 471 389 388 470 471 472 470 518 471 471 518 519 471 388 472 385 388 386 472 388 481 481 388 385 481 470 472 480 470 481 481 385 342 481 342 480 385 386 342 341 336 342 341 342 343 342 386 387 342 387 343 480 342 336 334 336 341 479 334 341 479 341 470 470 341 343 334 335 336 480 336 497 497 336 335 355 335 337 337 335 334 497 335 526 526 335 355 505 506 497 505 497 516 516 497 526 516 526 515 526 355 515 354 355 337 515 355 354 515 512 516 515 354 512 500 337 516 516 337 369 516 369 505 337 334 369 369 334 370 369 370 360 505 369 360 478 370 334 478 334 479 360 370 371 488 371 370 488 370 478 478 479 480 488 478 465 465 478 480 480 479 470 470 343 518 518 343 519 519 343 387 519 387 386 519 386 492 492 386 376 467 492 493 492 376 493 294 375 376 493 376 375 493 494 467 493 375 494 294 374 375 494 375 374 467 494 495 494 374 495 293 374 294 293 381 374 495 374 381 467 495 465 465 495 496 495 381 496 293 380 381 496 381 380 465 496 485 496 380 485 373 380 293 485 380 486 486 380 373 485 486 465 465 486 487 486 373 372 486 372 487 293 372 373 293 371 372 487 372 371 465 487 488 487 371 488 360 371 293 293 359 360 505 360 506 506 360 359 292 293 294 465 293 466 466 293 292 294 298 292 466 292 468 468 292 298 297 296 294 294 296 298 294 467 297 468 298 469 469 298 296 467 466 468 467 468 464 464 468 469 465 466 467 297 467 464 295 296 297 297 299 295 297 464 299 469 296 462 462 296 295 464 469 462 462 463 464 299 464 463 295 299 300 299 463 300 295 300 301 462 295 461 461 295 301 461 460 462 462 460 463 300 463 460 301 300 302 300 303 302 300 460 303 461 301 302 459 460 461 461 302 459 459 458 460 303 460 458 302 303 304 303 458 304 302 304 305 459 302 305 448 458 459 305 448 459 448 457 458 304 458 457 305 304 306 304 457 306 305 306 307 307 449 305 305 449 448 447 448 449 447 457 448 306 457 447 307 306 308 306 309 308 455 309 306 306 447 455 308 453 307 307 453 449 449 453 447 447 453 454 447 454 455 455 454 451 455 451 456 456 309 455 308 309 310 456 310 309 456 451 450 450 312 456 456 312 310 308 310 311 311 310 312 311 312 313 313 312 314 450 314 312 450 451 443 443 314 450 313 314 315 315 314 316 314 317 316 443 317 314 315 452 313 313 452 451 313 451 311 316 444 315 315 444 452 443 451 452 443 452 444 443 444 445 445 317 443 316 317 318 445 318 317 445 444 442 445 442 446 446 318 445 316 442 444 441 440 442 446 442 440 319 441 442 319 442 316 440 320 446 446 320 318 316 318 319 319 318 320 319 320 321 321 441 319 439 440 441 321 439 441 439 438 440 438 322 440 440 322 320 321 320 322 321 322 323 323 439 321 429 438 439 323 429 439 429 437 438 437 322 438 323 322 324 437 324 322 323 324 325 325 429 323 428 429 430 428 437 429 2178 430 429 429 325 2178 428 324 437 325 324 326 428 326 324 326 333 325 333 1329 325 325 1329 1332 2178 325 1332 2177 2178 2151 2177 430 2178 2178 1332 2151 430 431 428 2177 431 430 428 431 432 2183 432 431 2183 431 2177 428 432 433 2192 433 432 2192 432 2183 433 434 428 2194 434 433 2194 433 2192 2183 2161 2192 2161 2193 2192 2192 2193 2194 2161 2123 2193 2123 2130 2193 2193 2130 2132 2193 2132 2194 1659 2129 2130 2130 2129 2131 2130 2131 2132 2123 1659 2130 1659 1663 2129 1663 2096 2129 2129 2096 1626 2129 1626 2131 2095 1632 2096 2096 1632 2083 2096 2083 1626 1663 2095 2096 1645 1630 2095 2095 1630 1632 1868 1645 2095 1868 2095 1663 1630 1631 1632 2083 1632 2084 2084 1632 1631 2084 1722 2083 2083 1722 1621 2083 1621 1626 2084 1631 1805 1805 2097 2084 2084 2097 1722 1651 1722 2097 1651 2097 1853 1853 2097 2098 1805 2098 2097 1853 2098 1844 1844 2098 2099 1800 2099 2098 1800 2098 1805 1844 2099 1847 1847 2099 1730 1648 1730 2099 1648 2099 1800 1799 1648 1800 1805 1806 1800 1800 1806 1807 1800 1807 1799 1805 1817 1806 1806 1199 1807 1817 1199 1806 1807 1199 1197 1807 1197 1799 1198 1197 1199 1199 1203 1198 1817 1203 1199 1805 1816 1817 1816 1203 1817 1198 1203 1204 1816 1204 1203 1815 1816 1805 1815 1204 1816 1198 1204 1205 1815 1205 1204 1805 1814 1815 1814 1205 1815 1205 1206 1200 1205 1200 1198 1814 1206 1205 1631 1813 1814 1805 1631 1814 1813 1206 1814 1200 1206 1207 1813 1207 1206 1631 1812 1813 1812 1207 1813 1200 1207 1201 1812 1201 1207 1808 1812 1631 1808 1201 1812 1200 1201 1202 1808 1202 1201 1808 1631 1809 1809 1208 1808 1808 1208 1202 1202 1208 1209 1202 1209 1200 1209 1208 1210 1809 1210 1208 1809 1631 1810 1809 1810 1811 1811 1210 1809 1209 1210 1144 1210 1211 1144 1804 1211 1210 1804 1210 1811 1810 1804 1811 1735 1803 1804 1810 1735 1804 1803 1211 1804 1144 1211 1212 1803 1212 1211 1735 1802 1803 1802 1212 1803 1144 1212 1142 1142 1212 1213 1802 1213 1212 1648 1801 1802 1648 1802 1735 1801 1213 1802 1213 1214 1142 1801 1214 1213 1798 1801 1648 1798 1214 1801 1142 1214 1215 1798 1215 1214 1798 1648 1799 1799 1215 1798 1142 1215 1196 1196 1215 1216 1799 1216 1215 1799 1197 1216 1196 1216 1197 1196 1197 1198 1145 1142 1196 1145 1196 1475 1475 1196 1198 1198 1200 1454 1198 1454 1460 1475 1198 1476 1476 1198 1460 1481 1145 1475 1481 1475 1246 1246 1475 1476 1476 1460 1477 1246 1476 1236 1236 1476 1477 1460 1454 1455 1460 1455 1461 1477 1460 1461 1477 1461 1126 1236 1477 1442 1442 1477 1126 1461 1455 1456 1461 1456 1414 1126 1461 1414 1454 1063 1455 1455 1063 1062 1455 1062 1456 1456 1062 1401 1456 1401 1457 1414 1456 1457 1457 1401 1335 1457 1335 1458 1414 1457 1383 1383 1457 1458 1458 1335 1328 1458 1328 1459 1383 1458 1363 1363 1458 1459 1459 1328 332 1459 332 331 1363 1459 1331 1331 1459 331 331 332 326 326 332 333 332 1328 333 326 330 331 1331 331 330 326 327 328 328 329 326 326 329 330 327 326 428 1330 1331 330 330 329 1330 328 1039 329 1330 329 1039 327 1040 328 328 1040 1039 327 436 1040 428 436 327 428 434 435 428 435 436 2210 436 2211 2211 436 435 1040 436 2210 1039 1040 1041 1040 2210 1041 1330 1039 1366 1366 1039 1041 1353 1354 1330 1353 1330 1357 1359 1331 1330 1359 1330 1360 1360 1330 1354 1357 1330 1352 1352 1330 1366 1358 1331 1359 1358 1361 1331 1331 1361 1362 1331 1362 1363 2204 1361 1358 2204 1358 2205 2205 1358 1359 2200 1362 1361 2200 1361 2204 1363 1362 1364 2200 2199 1362 1362 2199 1364 2194 2199 2200 2200 2204 2194 2194 2204 2205 2194 2205 2201 2201 2205 2206 2205 1359 2206 2194 2132 2199 2201 434 2194 2132 2198 2199 2198 1364 2199 2197 2198 2132 2131 2163 2132 2132 2163 2196 2132 2196 2197 2197 1365 2198 2198 1365 1364 2196 1350 2197 2197 1350 1365 2195 2196 2163 2195 1351 2196 2196 1351 1350 1350 1351 1352 1365 1350 1363 1363 1350 1352 1363 1364 1365 1382 1383 1363 1363 1352 1382 1421 1383 1422 1422 1383 1382 1421 1424 1383 1383 1424 1425 1383 1425 1414 2133 1424 1421 2133 1421 2134 2134 1421 1422 1422 1382 1423 2134 1422 2140 2140 1422 1423 2133 2134 2131 2134 2140 2137 2134 2137 2131 2133 2131 2136 2136 1424 2133 2136 1425 1424 2131 1625 2136 2136 1625 1425 2131 1626 1625 2131 2137 2163 1624 1625 1626 1624 1426 1625 1425 1625 1426 1624 1626 2135 1626 1621 2143 1626 2143 2135 2135 1415 1624 1624 1415 1426 1414 1425 1426 1414 1426 1415 1414 1415 1416 2135 1416 1415 2143 1416 2135 1621 2142 2143 2142 1417 2143 2143 1417 1416 1128 1414 1416 1128 1416 1417 1126 1414 1128 1125 1126 1127 1127 1126 1128 1442 1126 1113 1113 1126 1125 1113 1125 1111 2323 1111 1125 2323 1125 2322 2322 1125 1127 1127 1128 1129 2322 1127 2321 1127 1129 2321 2321 1724 2322 2322 1724 1723 2322 1723 2323 2323 1723 1721 2323 1721 2324 2324 1111 2323 1721 1723 1722 1722 1723 1724 1722 1724 1621 1621 1724 1725 2321 1725 1724 1650 1721 1722 1650 1722 1651 2324 1721 1650 1649 1650 1651 2324 1650 2325 1650 1649 2325 1649 1651 1711 2325 1649 1711 2325 1711 2326 2326 1120 2325 2325 1120 1114 2325 1114 2324 1651 1717 1711 1711 1717 1718 2326 1711 1718 2326 1718 2327 2327 1121 2326 2326 1121 1120 1114 1120 1115 1115 1120 1121 1113 1112 1114 1113 1114 1115 2324 1114 1112 1111 1112 1113 2324 1112 1111 1115 1447 1113 1113 1447 1448 1113 1448 1449 1449 1450 1113 1113 1450 1451 1113 1451 1442 2233 1449 1448 2233 1448 2234 2234 1448 1447 2232 1450 1449 2232 1449 2233 2231 1451 1450 2231 1450 2232 1442 1451 1452 2230 1452 1451 2230 1451 2231 2103 2230 2231 2103 2231 2104 2104 2231 2232 2104 2232 2105 2105 2232 2233 1651 2103 2104 1651 2104 2105 1853 2102 2103 1853 2103 1651 2102 2230 2103 2102 2229 2230 2229 1452 2230 2101 2102 1853 2101 2229 2102 2101 2228 2229 2228 1440 2229 2229 1440 1452 1853 2100 2101 2100 2228 2101 2100 2227 2228 2227 1441 2228 2228 1441 1440 1440 1441 1442 1442 1452 1440 1253 1442 1441 1253 1441 1443 2227 1443 1441 2108 2226 2227 2108 2227 2100 2226 1443 2227 1853 2108 2100 2106 2107 2108 1853 2106 2108 2107 2226 2108 2107 2225 2226 2225 1444 2226 2226 1444 1443 1443 1444 1253 1253 1444 1445 2225 1445 1444 2112 2224 2225 2112 2225 2107 2224 1445 2225 2106 2112 2107 2106 2111 2112 2111 2224 2112 2111 2235 2224 2235 1446 2224 2224 1446 1445 1253 1445 1115 1445 1446 1115 1115 1446 1447 2235 1447 1446 2110 2234 2235 2110 2235 2111 2234 1447 2235 1717 2110 2111 1717 2111 2106 2109 2110 1717 2109 2234 2110 2109 2233 2234 2105 2109 1651 1651 2109 1717 2105 2233 2109 1714 1716 1717 1717 1716 1718 1115 1714 1717 1115 1717 1253 1253 1717 2106 1714 1715 1716 2327 1718 1716 2327 1716 2328 2328 1716 1715 1713 1715 1714 2328 1715 2329 2329 1715 1713 2329 1124 2328 2328 1124 1123 2328 1123 2327 2327 1123 1121 1122 1121 1123 1122 1123 1124 1116 1122 1124 2329 1116 1124 2329 1713 2330 2330 1116 2329 1712 1713 1714 2330 1713 1712 2330 1712 2331 2331 1117 2330 2330 1117 1116 1116 1117 1118 1118 1122 1116 1118 1117 1119 2331 1119 1117 2331 1712 1720 2331 1720 2320 2320 1119 2331 1622 1720 1712 1712 1714 1622 1622 1719 1720 2320 1720 1719 2320 1725 2321 2320 1719 1725 2321 1130 2320 2320 1130 1119 1119 1130 1118 1129 1128 1130 1118 1130 1128 2321 1129 1130 1417 1418 1128 1128 1418 1419 1128 1419 1420 1118 1128 1382 1382 1128 1420 2142 1418 1417 2145 1419 1418 2145 1418 2142 2144 1420 1419 2144 1419 2145 1382 1420 1412 2144 2139 1420 1420 2139 1412 2139 2144 1621 1621 2144 2145 1621 2145 2142 1621 1622 1623 1621 1719 1622 1621 1725 1719 2139 1621 2137 2137 1621 1623 2137 2138 2139 2138 1412 2139 2137 2140 2141 2137 2141 2138 2162 2163 2137 2137 1623 2162 2141 1413 2138 2138 1413 1412 2140 1423 2141 2141 1423 1413 1412 1413 1382 1423 1382 1413 1382 1352 1367 1382 1367 1118 1351 1355 1352 1352 1355 1356 1352 1356 1357 1352 1366 1367 2195 1355 1351 2209 1356 1355 2209 1355 2195 2208 1357 1356 2208 1356 2209 2208 2207 1357 1357 2207 1353 2207 2208 2163 2163 2208 2209 2163 2209 2195 2162 2211 2163 2163 2211 2201 2163 2201 2207 2207 2201 2203 2203 1353 2207 2203 1354 1353 2201 2202 2203 2202 1354 2203 2201 2206 2202 2211 435 2201 2201 435 434 2162 2210 2211 2168 2210 2162 1041 2210 2168 2166 2167 2168 2168 2167 2146 2162 2175 2168 2168 2175 2176 2168 2176 2166 1041 2168 1388 1388 2168 2146 2162 2174 2175 2174 2221 2175 2175 2221 2222 2175 2222 2176 2176 2222 2223 2176 2223 2166 2221 1384 2222 2222 1384 1393 2222 1393 2223 2174 2220 2221 2220 1385 2221 2221 1385 1384 2165 2174 2162 2165 2220 2174 2165 2219 2220 2219 1389 2220 2220 1389 1385 1384 1385 1366 1385 1389 1366 1366 1389 1390 2219 1390 1389 2164 2218 2219 2164 2219 2165 2218 1390 2219 2162 2164 2165 2162 1623 2170 2162 2170 2164 2170 2218 2164 2170 2217 2218 2217 1391 2218 2218 1391 1390 1366 1390 1367 1367 1390 1391 1366 1041 1384 1392 1393 1041 1384 1041 1393 1388 1395 1041 1041 1395 1396 1041 1396 1392 2223 1393 1392 2223 1392 2212 2212 1392 1396 2212 1396 2213 2213 1396 1395 1388 1394 1395 2213 1395 2214 2214 1395 1394 2167 2212 2213 2167 2213 2171 2171 2213 2214 2166 2212 2167 2166 2223 2212 2167 2171 2146 2146 2171 2172 2171 2214 2172 2172 2214 2215 2214 1394 2215 1387 1394 1388 2215 1394 1387 2172 2215 2173 2173 2215 2216 2215 1387 2216 2146 2172 1623 1623 2172 2173 1623 2173 2169 2173 2216 2169 2169 2216 2217 2216 1387 1386 2216 1386 2217 1386 1387 1367 1367 1387 1388 1367 1388 1122 1388 2146 1122 1367 1391 1386 1118 1367 1122 2217 1386 1391 2169 2217 2170 1623 2169 2170 1622 2146 1623 1622 1714 2146 1122 2146 1714 1115 1121 1122 1122 1714 1115 2206 1360 2202 2202 1360 1354 2206 1359 1360 1852 1835 2106 1852 2106 1853 1253 2106 1241 1241 2106 1835 1844 1852 1853 1842 1843 1844 1847 1849 1844 1844 1849 1850 1844 1850 1842 1843 1851 1844 1844 1851 1852 1842 1238 1843 1843 1238 1851 1850 1244 1842 1842 1244 1238 1849 1245 1850 1850 1245 1244 1238 1244 1236 1236 1244 1245 1236 1237 1238 1238 1237 1851 1851 1237 1852 1836 1835 1852 1852 1237 1254 1852 1254 1836 1237 1236 1254 1236 1245 1246 1254 1236 1442 1246 1245 1247 1849 1247 1245 1248 1246 1247 1848 1248 1247 1848 1247 1849 1847 1848 1849 1846 1848 1847 1846 1248 1848 1248 1249 1239 1239 1246 1248 1846 1249 1248 1840 1845 1846 1840 1846 1847 1845 1249 1846 1239 1249 1250 1845 1250 1249 1841 1845 1840 1841 1250 1845 1239 1250 1240 1841 1240 1250 1840 1839 1841 1839 1240 1841 1239 1240 1241 1241 1240 1242 1839 1242 1240 1835 1838 1839 1835 1839 1840 1838 1242 1839 1241 1242 1243 1838 1243 1242 1837 1838 1835 1837 1243 1838 1835 1836 1837 1241 1835 1239 1239 1835 1840 1836 1252 1837 1252 1251 1837 1837 1251 1243 1243 1251 1241 1241 1251 1252 1241 1252 1253 1253 1252 1254 1836 1254 1252 1254 1442 1253 2073 1840 2074 2074 1840 1847 2073 2076 1840 1840 2076 2077 1840 2077 2078 1239 1840 1038 1038 1840 2078 2073 1479 2076 2076 1479 1478 2076 1478 2077 1239 1478 1479 1479 1480 1239 2073 1480 1479 1038 1037 1239 1239 1037 1478 1239 1480 1246 2077 1478 1037 1036 1037 1038 2077 1037 2079 2079 1037 1036 1038 1488 1036 2079 1036 2080 2080 1036 1488 2078 2077 2079 2079 2080 2078 2078 2080 2081 2080 1488 2081 1038 1487 1488 2081 1488 1487 2078 2081 2082 2081 1487 2082 1483 1487 1038 2082 1487 1483 1483 1038 1481 1481 1038 1509 1038 2078 1509 1481 1482 1483 2082 1483 2069 2069 1483 1482 2071 2078 2082 2071 2082 2069 2069 2070 2071 2069 1482 2070 1481 1486 1482 2070 1482 1486 2071 2070 2072 2070 1486 2072 1481 1485 1486 2072 1486 1485 2071 2072 1847 2075 1847 2072 2072 1485 2075 1246 1484 1485 1246 1485 1481 2075 1485 1484 2074 1847 2075 2075 1484 2074 1847 1730 2071 1647 1729 1730 1729 1731 1730 1730 1731 1732 1730 1732 1726 2071 1730 1726 1647 1730 1648 1729 1146 1731 1731 1146 1151 1731 1151 1732 1726 1732 1733 1733 1732 1150 1150 1732 1151 1726 1733 1727 1148 1727 1733 1148 1733 1150 1726 1727 1728 1147 1728 1727 1147 1727 1148 1147 1148 1149 1149 1148 1150 1149 1049 1147 1049 1749 1147 1749 1728 1147 1728 1749 1750 1728 1750 1726 1750 1749 1751 1049 1751 1749 1048 1049 1050 1149 1050 1049 1048 1751 1049 1750 1751 1752 1752 1751 1753 1751 1048 1753 1752 1753 1739 1757 1750 1752 1757 1752 1779 1779 1752 1739 1739 1753 1754 1753 1048 1505 1753 1505 1754 1739 1754 1740 1754 1505 1154 1754 1154 1740 1739 1740 1741 1741 1740 1742 1740 1154 1153 1740 1153 1742 1742 1746 1741 1742 1132 1746 1742 1153 1133 1742 1133 1132 1152 1153 1154 1152 1133 1153 1131 1132 1133 1152 1131 1133 1131 1138 1132 1746 1132 1138 1741 1746 1747 1746 1138 1747 1741 1747 1744 1744 1747 1748 1138 1137 1747 1747 1137 1748 1744 1748 1745 1136 1745 1748 1136 1748 1137 1743 1744 1745 1134 1743 1745 1134 1745 1136 1134 1136 1135 1135 1136 1137 1052 1134 1135 1052 1738 1134 1738 1743 1134 1738 1737 1743 1743 1737 1744 1736 1737 1738 1052 1736 1738 1051 1052 1053 1052 1135 1053 1051 1736 1052 1734 1735 1736 1736 1735 1737 1736 1051 1734 1646 1648 1734 1734 1648 1735 1734 1051 1139 1734 1139 1646 1818 1735 1810 1818 1819 1735 1735 1819 1820 1735 1820 1737 1631 1825 1810 1810 1825 1826 1810 1826 1818 1631 1824 1825 1825 1218 1826 1824 1218 1825 1826 1218 1217 1826 1217 1818 1200 1217 1218 1218 1223 1200 1824 1223 1218 1823 1824 1631 1823 1223 1824 1200 1223 1224 1823 1224 1223 1631 1834 1823 1834 1224 1823 1200 1224 1225 1834 1225 1224 1631 1833 1834 1833 1225 1834 1225 1226 1219 1225 1219 1200 1833 1226 1225 1630 1832 1833 1630 1833 1631 1832 1226 1833 1219 1226 1227 1832 1227 1226 1831 1832 1630 1831 1227 1832 1219 1227 1220 1831 1220 1227 1630 1830 1831 1830 1220 1831 1219 1220 1221 1830 1221 1220 1630 1829 1830 1829 1228 1830 1830 1228 1221 1219 1221 1222 1221 1228 1222 1222 1228 1229 1829 1229 1228 1634 1828 1829 1634 1829 1630 1828 1229 1829 1222 1229 1053 1053 1229 1230 1827 1230 1229 1827 1229 1828 1827 1828 1634 1822 1827 1737 1737 1827 1634 1822 1230 1827 1053 1230 1231 1822 1231 1230 1737 1821 1822 1821 1231 1822 1737 1820 1821 1737 1634 1744 1820 1232 1821 1821 1232 1231 1231 1232 1053 1053 1232 1144 1232 1233 1144 1820 1233 1232 1819 1233 1820 1144 1233 1234 1819 1234 1233 1142 1143 1144 1053 1144 1139 1139 1144 1143 1144 1234 1209 1209 1234 1235 1818 1235 1234 1818 1234 1819 1200 1209 1217 1209 1235 1217 1818 1217 1235 1200 1219 1453 1200 1453 1454 1222 1257 1219 1219 1257 1273 1219 1273 1453 1454 1453 1063 1453 1273 1075 1453 1075 1063 1062 1063 1064 1063 1075 1077 1063 1077 1064 1064 1065 1062 1065 1064 2244 2244 1064 1077 1075 1076 1077 2244 1077 2243 2243 1077 1076 2243 1662 2244 2244 1662 1661 2244 1661 2245 2245 1065 2244 1062 1065 1066 2245 1066 1065 2245 1661 1660 2245 1660 2246 2246 1066 2245 1659 1660 1661 1661 1662 1663 1661 1663 1659 1662 1664 1663 2243 1664 1662 1663 1664 1666 1663 1666 1868 1664 1665 1666 1665 1664 2243 1666 1665 1667 2242 1667 1665 2242 1665 2243 2243 1076 2242 2241 1667 2242 2242 1076 1074 2242 1074 2241 1666 1667 1668 1667 1669 1668 2241 1669 1667 2240 1669 2241 2241 1074 1073 2241 1073 2240 1073 1074 1075 1075 1074 1076 1075 1079 1073 1073 1079 1078 2240 1073 1078 2239 1670 2240 2240 1670 1669 2240 1078 2239 1668 1669 1670 1668 1670 1671 1670 1672 1671 2239 1672 1670 2238 1672 2239 2239 1078 1080 2239 1080 2238 1078 1079 1080 1080 1079 1072 1080 1072 1081 2238 1080 1081 2237 1673 2238 2238 1673 1672 2238 1081 2237 1671 1672 1673 1671 1673 1674 2237 1674 1673 2236 1674 2237 2237 1081 1071 2237 1071 2236 1081 1072 1071 1070 1071 1072 2236 1071 1070 2247 1656 2236 2236 1656 1655 2236 1655 1674 2236 1070 2247 1657 1671 1674 1657 1674 1655 1655 1656 1657 1656 1658 1659 1656 1659 1657 2247 1658 1656 1659 1658 1660 2246 1660 1658 2246 1658 2247 2247 1068 2246 2246 1068 1066 1066 1068 1067 1067 1068 1069 2247 1069 1068 1062 1066 1067 1067 1398 1062 1062 1398 1403 1062 1403 1404 1404 1406 1062 1062 1406 1407 1062 1407 1401 2113 1404 1403 2113 1403 2114 2114 1403 1398 2128 1406 1404 2128 1404 2113 2127 1407 1406 2127 1406 2128 1401 1407 1408 2127 2126 1407 1407 2126 1408 2126 2127 1659 1659 2127 2128 1659 2128 2113 1659 2113 2114 1657 1659 2114 1657 2114 2115 2114 1398 2115 2126 1659 2123 2123 2125 2126 2125 1408 2126 1401 1408 1399 2125 1399 1408 2123 2124 2125 2124 1399 2125 1399 1400 1401 2124 1400 1399 1401 1400 1402 1333 1335 1401 1333 1401 1379 1379 1401 1402 2122 1402 1400 2122 1400 2124 2122 2124 2123 2121 2122 2123 2121 1402 2122 1379 1402 1405 2121 1405 1402 2120 2121 2118 2118 2121 2123 2120 1405 2121 1405 1409 1379 2120 1409 1405 2118 2119 2120 2119 1409 2120 1379 1409 1410 2119 1410 1409 2118 2117 2119 2119 2117 1410 1379 1410 1067 1067 1410 1411 1410 2117 1411 1657 2116 2117 1657 2117 2118 2116 1411 2117 1067 1411 1397 2116 1397 1411 2115 2116 1657 2115 1397 2116 2118 1671 1657 2118 2148 1671 2148 1374 1671 1671 1374 1072 1671 1072 1668 1070 1072 1067 1067 1072 1374 1668 1072 1079 1067 1069 1070 2247 1070 1069 1067 1374 1379 1067 1397 1398 2115 1398 1397 1377 1378 1379 1379 1378 1380 1379 1380 1333 1379 1374 1376 1379 1376 1377 2347 1378 1377 2347 1377 2348 2348 1377 1376 2346 1380 1378 2346 1378 2347 2156 2346 2347 2156 2347 2147 2147 2347 2348 2147 2348 2149 2149 2348 2349 2348 1376 2349 1374 1375 1376 2349 1376 1375 2149 2349 2150 2150 2349 2350 2349 1375 2350 2147 2149 2148 2148 2149 2150 2147 2148 2118 2118 2156 2147 2148 2150 2151 2151 1334 2148 2148 1334 1374 2151 2150 2152 2150 2350 2152 2151 2152 2153 2152 2350 2351 2152 2351 2153 2153 2157 2151 2153 2351 2352 2153 2352 2157 2350 1373 2351 2351 1373 1372 2351 1372 2352 2157 2352 2353 2352 1372 1368 2352 1368 2353 2157 2158 1620 2151 2157 1620 2157 2353 2158 2158 2353 2354 2353 1368 1369 2353 1369 2354 1368 1334 1369 1368 1372 1334 1334 1372 1373 1332 1333 1334 1369 1334 1333 1334 1373 1374 2151 1332 1334 2151 1620 2177 2177 1620 1619 2177 1619 2181 2181 2186 2177 2177 2186 2187 2177 2187 2183 2181 1348 1347 2181 1347 2186 2181 1619 1348 2186 1347 1342 2186 1342 2187 2183 2187 2188 2187 1342 1343 2187 1343 2188 1342 1329 1343 1342 1347 1329 1329 1347 1348 1329 1348 1333 1333 1348 1349 1348 1619 1349 333 1328 1329 1332 1329 1333 1343 1329 1328 1343 1328 1344 2188 1343 1344 1335 1339 1328 1328 1339 1340 1328 1340 1341 1344 1328 1341 2188 1344 2184 2184 1344 1341 2184 1341 2185 2185 1341 1340 1339 2189 1340 2185 1340 2189 2183 2184 2185 2185 2189 2183 2183 2188 2184 2183 2189 2161 2189 2190 2161 2190 2189 1339 2161 2190 2191 2190 1339 1338 2190 1338 2191 2161 2191 2179 2191 1338 1337 2191 1337 2179 1337 1338 1335 1335 1338 1339 1335 1336 1337 2179 1337 1336 2179 2180 2161 2179 1336 2180 1333 1346 1336 1336 1335 1333 2180 1336 1346 2161 2180 1620 1620 2180 2182 2180 1346 2182 1345 1346 1333 2182 1346 1345 1620 2182 1618 2182 1345 1618 1333 1349 1345 1618 1345 1349 1618 1619 1620 1618 1349 1619 1620 2158 2159 1620 2159 2160 2160 2154 1620 1620 2154 2118 1620 2118 2161 2158 2354 2159 2159 2354 2355 2159 2355 2160 2160 2344 2154 2160 2355 2344 2154 2155 2118 2154 2344 2345 2154 2345 2155 2118 2155 2156 2118 2123 2161 2155 2345 2346 2155 2346 2156 2345 1380 2346 2344 1381 2345 2345 1381 1380 2355 1371 2344 2344 1371 1381 1333 1380 1381 1333 1381 1371 1370 1333 1371 2355 1370 1371 1369 1333 1370 2354 1369 1370 2354 1370 2355 1374 1373 1375 2350 1375 1373 1075 1430 1079 1430 1437 1079 1079 1437 1438 1079 1438 1434 1668 1079 1629 1629 1079 1434 2340 1438 1437 2340 1437 2341 2341 1437 1430 1434 1438 1439 2339 1439 1438 2339 1438 2340 2089 2339 2340 2089 2340 2090 2090 2340 2341 2090 2341 2091 2091 2341 2342 2341 1430 2342 1668 2089 2090 1668 2090 1666 1666 2090 2091 1628 2089 1668 1628 2339 2089 1627 1628 1629 1629 1628 1668 1627 2338 1628 1628 2338 2339 1629 2088 1627 2088 2337 1627 1627 2337 2338 2337 1435 2338 2338 1435 1439 2338 1439 2339 2088 2336 2337 2336 1436 2337 2337 1436 1435 1629 2087 2088 2087 2336 2088 2087 2335 2336 2335 1427 2336 2336 1427 1436 1434 1435 1436 1273 1434 1436 1273 1436 1427 1434 1439 1435 1272 1258 1434 1272 1434 1273 1629 1434 1863 1863 1434 1258 1863 1867 1629 1629 1867 1643 1629 1643 1868 1868 2087 1629 1863 1866 1867 1260 1259 1867 1867 1259 1643 1866 1260 1867 1865 1866 1863 1865 1260 1866 1258 1259 1260 1267 1258 1260 1865 1267 1260 1259 1258 1272 1643 1259 1272 1266 1265 1258 1266 1258 1267 1863 1258 1859 1859 1258 1265 1864 1266 1267 1864 1267 1865 1863 1864 1865 1863 1862 1864 1862 1266 1864 1264 1265 1266 1862 1264 1266 1859 1861 1862 1859 1862 1863 1861 1264 1862 1264 1268 1265 1861 1268 1264 1860 1861 1859 1860 1268 1861 1265 1268 1269 1860 1269 1268 1859 1858 1860 1858 1269 1860 1265 1269 1261 1261 1269 1270 1858 1270 1269 1633 1857 1858 1633 1858 1859 1857 1270 1858 1261 1270 1262 1857 1262 1270 1856 1857 1633 1856 1262 1857 1261 1262 1257 1257 1262 1263 1856 1263 1262 1645 1855 1856 1856 1633 1645 1855 1263 1856 1257 1263 1255 1855 1255 1263 1645 1854 1855 1854 1255 1855 1643 1644 1645 1644 1854 1645 1645 1633 1630 1643 1645 1868 1644 1271 1854 1271 1256 1854 1854 1256 1255 1255 1256 1257 1256 1271 1257 1257 1271 1272 1644 1272 1271 1643 1272 1644 1257 1272 1273 1222 1261 1257 1053 1261 1222 1261 1135 1462 1464 1265 1261 1464 1261 1465 1465 1261 1462 1053 1135 1261 1051 1053 1139 5876 5875 1051 5876 1051 5867 5867 1051 1139 1051 5731 1139 5875 5731 1051 5874 5875 5876 5721 5731 5875 5721 5875 5719 5719 5875 5874 5720 5730 5731 5720 5731 5721 1139 5731 5730 5719 5720 5721 5717 5718 5719 5719 5718 5720 5719 5874 5717 5874 5876 5882 5874 5882 5717 5717 5724 5718 5717 5882 5884 5717 5884 5724 5882 5876 5883 5882 5883 5884 5883 1137 5884 5724 5884 1137 5718 5724 5725 5724 1137 5725 1135 1137 1131 1131 1137 1138 5883 1138 1137 1138 5725 1137 5718 5725 5722 5722 5725 5726 5726 5725 1138 5878 5885 1138 5878 1138 5883 5726 1138 5885 5722 5726 5723 5726 5885 5723 5877 5885 5878 5723 5885 5877 5722 5723 5658 5723 5877 5658 5877 5878 5879 5658 5877 5659 5659 5877 5879 5658 5659 5660 5658 5660 5722 5659 5714 5660 5659 5879 5714 5879 5878 5880 5879 5880 5881 5714 5879 5881 5660 5714 5715 1154 5715 5714 5714 5881 1154 5880 1154 5881 1504 1152 1154 1504 1154 1505 5880 1505 1154 1505 5716 1154 1154 5716 5715 5660 5715 5706 5706 5715 5716 5706 5716 5707 1505 5707 5716 5706 5707 5708 5708 5707 5709 1048 5707 1505 5707 1048 5886 5707 5886 5709 5708 5709 5710 5709 5886 5872 5709 5872 5710 5886 1048 5887 5887 5870 5886 5886 5870 5872 1050 1505 1048 5887 1048 1505 1168 1504 1050 1050 1504 1505 1527 1168 1050 1527 1050 1149 5887 1505 5880 1172 1171 5887 5887 1171 5870 5896 1176 5887 5887 1176 1174 5887 1174 1172 1194 5887 1195 1195 5887 5880 1194 1190 5887 5887 1190 1189 5887 1189 5896 1171 1172 1173 1173 1172 1174 1756 1174 1172 1756 1172 1758 1758 1172 1171 5747 1171 1172 5747 1172 5744 5744 1172 1174 1755 1756 1757 1757 1756 1758 1755 1174 1756 1757 1769 1755 1755 1769 1768 1755 1176 1174 1768 1158 1755 1755 1158 1176 1768 1769 1770 1770 1159 1768 1768 1159 1158 1158 1159 1034 1034 1175 1158 1158 1175 1176 1159 1160 1034 1777 1160 1159 1777 1159 1770 5892 5894 1159 1159 5895 5896 1159 5896 5892 1159 5740 5895 5894 5740 1159 1771 1776 1777 1771 1777 1770 1776 1160 1777 1775 1776 1771 1775 1161 1776 1776 1161 1160 1767 1775 1771 1767 1162 1775 1775 1162 1161 1034 1160 1161 1034 1161 1162 1157 1034 1162 1157 1162 1155 1767 1155 1162 1766 1765 1767 1767 1771 1766 1765 1155 1767 1155 1156 1157 1765 1156 1155 1764 1765 1766 1764 1156 1765 1156 1163 1157 1764 1163 1156 1766 1774 1764 1774 1163 1764 1157 1163 1164 1774 1164 1163 1766 1773 1774 1773 1166 1774 1774 1166 1164 1763 1772 1773 1763 1773 1766 1772 1167 1773 1773 1167 1166 1164 1166 1165 1165 1166 1167 1157 1164 1165 1165 1167 1168 1525 1157 1165 1525 1165 1526 1526 1165 1168 1524 1034 1157 1108 1524 1157 1108 1157 1525 1058 1108 1525 1058 1525 1044 1044 1525 1526 1044 1526 1309 1309 1526 1527 1526 1168 1527 1309 1527 1516 1516 1527 1149 1149 1150 1145 1516 1149 1514 1514 1149 1145 1145 1146 1140 1145 1150 1151 1145 1151 1146 1140 1142 1145 1514 1145 1481 1729 1140 1146 1140 1141 1142 1729 1141 1140 1142 1141 1143 1647 1143 1141 1647 1141 1729 1646 1647 1648 1646 1143 1647 1646 1139 1143 5867 1139 1143 1139 5730 1143 5867 1143 5851 5927 5876 5867 5927 5867 5858 5858 5867 5851 5821 5926 5927 5821 5927 5820 5820 5927 5858 5926 5876 5927 5926 5883 5876 5822 5925 5926 5822 5926 5821 5925 5883 5926 5820 5813 5821 5821 5813 5812 5821 5812 5822 5819 5702 5820 5820 5702 5813 5820 5858 5819 5686 5812 5813 5686 5813 5702 5804 5811 5812 5804 5812 5686 5822 5812 5811 5729 5803 5804 5729 5804 5688 5688 5804 5686 5803 5811 5804 5803 5810 5811 5822 5811 5823 5823 5811 5810 5720 5792 5803 5720 5803 5729 5792 5810 5803 5792 5809 5810 5823 5810 5824 5824 5810 5809 5824 5924 5823 5823 5924 5925 5823 5925 5822 5824 5809 5825 5824 5825 5826 5824 5826 5924 5797 5809 5792 5797 5818 5809 5825 5809 5818 5825 5818 5955 5955 5826 5825 5924 5826 5946 5955 5946 5826 5955 5818 5951 5955 5951 5956 5947 5946 5955 5947 5955 5962 5962 5955 5956 5797 5817 5818 5818 5817 5951 5795 5816 5817 5795 5817 5797 5951 5817 5816 5808 5815 5816 5808 5816 5795 5961 5951 5816 5961 5816 5815 5777 5770 5808 5777 5808 5722 5722 5808 5795 5770 5815 5808 5770 5814 5815 5815 5814 5961 5776 5657 5814 5776 5814 5770 5961 5814 5657 5770 5775 5776 5775 5780 5776 5776 5780 5781 5776 5781 5655 5655 5657 5776 5655 5656 5657 5961 5657 5656 5655 5950 5656 5962 5961 5656 5962 5656 5950 5913 5949 5950 5913 5950 5920 5655 5920 5950 5950 5949 5962 5909 5948 5949 5909 5949 5913 5962 5949 5948 5943 5947 5948 5943 5948 5909 5962 5948 5947 5909 5878 5943 5943 5878 5883 5943 5883 5936 5936 5947 5943 5936 5946 5947 5924 5946 5936 5930 5931 5924 5924 5931 5932 5924 5932 5925 5936 5937 5924 5924 5937 5938 5924 5938 5930 5925 5932 5933 5933 5939 5925 5925 5939 5940 5925 5940 5883 5932 6101 5933 6101 6102 5933 5933 6102 6103 5933 6103 5939 6103 6104 5939 5939 6104 6105 5939 6105 5940 6104 6103 5805 5805 6103 6102 5805 6102 5806 6102 6101 5806 5932 6100 6101 5806 6101 6100 5792 5805 5806 5792 5806 5797 5797 5806 5807 5806 6100 5807 5793 5805 5792 5805 5793 6104 5793 6105 6104 5792 5791 5793 5791 6106 5793 5793 6106 6105 5790 5791 5792 5718 5790 5792 5718 5792 5720 5790 6083 5791 5791 6083 6106 5940 6105 6106 5940 6106 6083 6083 5941 5940 6083 6084 5941 5790 6084 6083 5802 5790 5718 5802 6084 5790 5941 6084 6085 5802 6085 6084 5883 5940 5941 5883 5941 5942 5941 6085 5942 6085 6086 5942 6086 6085 5802 5718 5801 5802 5801 6086 5802 5942 6086 6087 5801 6087 6086 5936 5883 5942 5936 5942 5934 5942 6087 5934 6087 6088 5934 6088 6087 5801 5795 5800 5801 5718 5795 5801 5800 6088 5801 5934 6088 6089 5800 6089 6088 5934 5935 5936 5934 6089 5935 5936 5935 5937 6089 6090 5935 5935 6090 6091 5935 6091 5937 6090 6089 5800 5795 5799 5800 5799 6090 5800 5799 6091 6090 6091 6092 5937 6092 6091 5799 5937 6092 6093 5937 6093 5938 5794 6093 6092 5794 6092 5799 5794 5799 5795 5794 5795 5796 5796 6094 5794 6094 6093 5794 6093 6094 5938 5938 6094 6095 5938 6095 5930 5796 6095 6094 5796 5795 5797 5796 5797 5798 5798 6096 5796 6096 6095 5796 5722 5795 5718 5722 5660 5752 5722 5752 5777 5706 5765 5660 5660 5765 5766 5660 5766 5752 5706 5764 5765 5764 1194 5765 5765 1194 1195 5765 1195 5766 5752 5766 5767 5766 1195 1186 5766 1186 5767 5752 5767 5753 5767 1186 5753 5752 5753 5754 1191 5754 5753 1191 5753 1186 5752 5754 5756 5756 5754 5758 5827 5758 5754 5827 5754 1191 5777 5752 5756 5771 5773 5777 5773 5778 5777 5777 5778 5779 5777 5779 5768 5777 5756 5771 5768 5770 5777 5779 5778 6080 5773 6082 5778 5778 6082 6081 5778 6081 6080 6080 6079 5779 5779 6079 6078 5779 6078 5768 6079 6080 5911 5911 6080 6081 5911 6081 5904 5904 6081 6082 5904 6082 6059 5773 6059 6082 5904 5905 5906 5904 5906 5911 5904 6059 5905 5915 5911 5916 5916 5911 5906 5915 6079 5911 5915 6078 6079 5910 5915 5916 5910 6077 5915 6077 6078 5915 5909 5908 5910 5910 5916 5909 5908 6075 5910 6075 6076 5910 5910 6076 6077 6078 6077 5768 5768 6077 6076 5768 6076 5769 6076 6075 5769 5908 6074 6075 5769 6075 6074 5768 5769 5770 5769 5774 5770 5769 6074 5774 6073 6074 5908 6074 6073 5774 5770 5774 5775 5774 6073 6072 5774 6072 5775 5907 6072 6073 5907 6073 5908 6071 6072 5907 6072 6071 5775 5775 6071 6070 5775 6070 5780 5912 6070 6071 5912 6071 5907 5907 5908 5909 5907 5909 5912 5912 5909 5913 5912 5913 5914 5914 6069 5912 6069 6070 5912 6070 6069 5780 5780 6069 6068 5780 6068 5781 5914 6068 6069 5913 5923 5914 5923 6067 5914 6067 6068 5914 5920 5922 5913 5913 5922 5923 5922 6066 5923 5923 6066 6067 5781 6068 6067 5781 6067 5782 5782 6067 6066 5655 5781 5782 5782 5783 5655 5782 6066 5783 5922 6065 6066 6066 6065 5783 5920 5921 5922 5921 6065 5922 5921 6064 6065 5783 6065 6064 5655 5783 5784 5783 6064 5784 5655 5784 5785 5785 5920 5655 5785 5784 5786 6064 6063 5784 5784 6063 6062 5784 6062 5786 6063 6064 5921 5918 5921 5920 5918 6063 5921 5918 6062 6063 6061 6062 5918 5786 6062 6061 5785 5786 5771 5771 5786 5787 5786 6061 5787 5917 6060 6061 5917 6061 5918 5787 6061 6060 5917 5918 5919 5919 5918 5920 5785 5919 5920 5906 5917 5919 5906 5919 5901 5901 5919 5944 5785 5944 5919 5905 5917 5906 5905 6060 5917 5916 5906 5828 5828 5906 5901 5878 5916 5880 5880 5916 5828 5909 5916 5878 1193 5827 5828 5880 5828 1191 1191 5828 5827 5828 5901 1193 1195 5880 1186 1186 5880 1191 1186 1191 1184 1184 1191 1192 1780 1191 1186 1780 1192 1191 1184 1185 1186 1185 1195 1186 1780 1186 1778 1778 1186 1195 1778 1779 1780 1780 1779 1781 1780 1781 1782 1782 1192 1780 1785 1779 1778 1778 1195 1785 1784 1779 1785 1785 1195 1194 1785 1194 1784 1783 1757 1784 1784 1757 1779 1784 1194 1190 1784 1190 1783 1190 1194 1185 1185 1194 1195 5764 1190 1194 5763 5764 5706 5763 1190 5764 5762 5763 5738 5738 5763 5706 5762 1189 5763 5763 1189 1190 5747 5706 5748 5748 5706 5708 5738 5706 5744 5744 5706 5747 5748 1171 5747 5748 5708 5749 5749 1170 5748 5748 1170 1171 5749 5708 5743 5743 1169 5749 5749 1169 1170 5671 5742 5743 5671 5743 5708 5742 1167 5743 5743 1167 1169 5741 5742 5671 1167 5742 5889 5889 5742 5741 5737 5741 5677 5677 5741 5671 1164 5741 5737 5889 5741 1164 5831 5837 5889 5831 5889 1164 5837 1167 5889 1164 5888 5831 1164 5737 5888 5677 5736 5737 5888 5737 5736 5888 5890 5831 5888 5736 5890 5677 5735 5736 5890 5736 5735 5831 5890 5891 5890 5735 5891 5734 5733 5735 5734 5735 5677 5891 5735 5733 5831 5891 5892 5891 5893 5892 5891 5733 5893 5732 5733 5734 5893 5733 5732 5892 5893 5894 5893 5732 5894 5734 5740 5732 5894 5732 5740 5734 5739 5740 5895 5740 5739 5738 5739 5734 5738 5746 5739 1176 5739 5746 5895 5739 1176 5896 5895 1176 1175 1174 1176 1176 5746 1174 5738 5745 5746 5745 1174 5746 1173 1174 1175 5744 1174 5745 5744 5745 5738 5734 5760 5738 5738 5760 5761 5738 5761 5762 5734 5759 5760 1179 5760 5759 5898 5761 5760 5898 5760 1179 5761 1188 5762 1188 5761 5898 5762 1188 1189 1175 1187 1188 1175 1188 1173 1173 1188 1189 1786 1189 1188 1786 1188 1787 1787 1188 1788 1788 1188 1187 5896 1189 1188 5896 1188 5898 1034 1179 1175 1179 1187 1175 1788 1187 1789 1789 1187 1179 1769 1787 1788 1769 1788 1771 1771 1788 1789 1786 1787 1769 1770 1769 1771 1757 1786 1769 1757 1758 1759 1783 1786 1757 1759 1750 1757 1759 1758 1760 1758 1171 1760 1760 1761 1759 1760 1171 1170 1760 1170 1761 1168 1170 1171 1171 1173 1168 1171 1170 5870 1168 1169 1170 1761 1170 1169 5870 1170 1169 1759 1761 1762 1761 1169 1762 1167 1169 1168 1762 1169 1167 5870 1169 5837 5837 1169 1167 1168 1173 1504 1173 1152 1504 1173 1185 1152 1185 1131 1152 1190 1185 1173 1184 1499 1185 1185 1499 1131 1173 1189 1190 1783 1190 1189 1783 1189 1786 1492 1493 1131 1131 1493 1494 1492 1131 1498 1498 1131 1499 1467 1135 1131 1467 1131 1491 1491 1131 1494 1470 1471 1135 1135 1471 1472 1135 1472 1462 1470 1135 1467 1467 1474 1470 2062 1471 1470 2062 1470 2063 2063 1470 1474 2061 1472 1471 2061 1471 2062 2060 1462 1472 2060 1472 2061 2059 1462 2060 2059 1465 1462 2059 2060 1744 1744 2060 2061 1744 2061 2062 2056 1744 2062 2056 2062 2063 2063 2064 2056 2063 1474 2064 2056 2064 2065 2064 1474 1473 2064 1473 2065 2056 2065 2057 2065 1473 1466 2065 1466 2057 1466 1473 1467 1467 1473 1474 1466 1467 1468 2057 1466 1468 2056 2057 1859 1859 2057 2058 2057 1468 2058 1468 1467 1265 1468 1265 1469 2058 1468 1469 2058 2066 1859 2058 1469 2066 1859 2066 2067 1859 2067 1633 1859 1265 2056 1463 1265 1464 1469 1265 1463 2056 1265 1467 2066 1469 1463 2066 1463 2067 1633 2067 2068 2067 1463 1464 2067 1464 2068 2068 1464 1465 2059 1633 2068 2068 1465 2059 1744 1633 2059 2028 1741 1744 2028 1744 2056 1744 1634 1633 1633 1634 1630 2056 1467 2028 2028 1467 1491 2027 2028 2029 2029 2028 2023 2027 2031 2028 2028 2031 2032 2028 2032 2026 2026 1741 2028 2028 1491 2023 2029 1502 2027 2027 1502 1501 2027 1501 2031 2031 1501 1490 2031 1490 2032 2032 1490 1489 2032 1489 2026 2024 1741 2026 2026 1489 1494 2026 1494 2024 1489 1490 1491 1491 1494 1489 1490 1501 1491 1491 1501 1502 1491 1502 1495 2023 1491 1495 1495 1502 1503 2029 1503 1502 1495 1503 1496 2030 1496 1503 2030 1503 2029 2029 2023 2030 2023 2036 2030 2036 1496 2030 1495 1496 1497 2036 1497 1496 2023 2035 2036 2035 1497 2036 1499 1495 1497 1499 1497 1500 2035 1500 1497 2022 2034 2035 2022 2035 2023 2034 1500 2035 1498 1499 1500 2034 1498 1500 1277 1495 1499 1184 1277 1499 1277 1284 1495 2023 1495 1872 1872 1495 1284 1872 2022 2023 1871 1870 1872 1870 1873 1872 1872 1873 1874 1872 1874 1875 1875 1881 1872 1872 1881 2022 1872 1284 1871 1870 1286 1873 1873 1286 1285 1873 1285 1874 1874 1285 1283 1874 1283 1875 1875 1880 1881 1875 1283 1278 1875 1278 1880 1278 1283 1284 1283 1285 1284 1284 1285 1286 1284 1286 1047 1047 1286 1287 1870 1287 1286 1278 1284 1277 1871 1284 1047 1277 1276 1278 1880 1278 1276 1275 1276 1277 1033 1277 1184 1275 1277 1281 1281 1277 1033 1880 1276 1882 1882 1276 1275 1281 1282 1275 1882 1275 1883 1883 1275 1282 1881 1880 1882 1881 1882 1877 1877 1882 1883 1877 1883 1879 1883 1282 1879 1281 1280 1282 1879 1282 1280 1878 1877 1879 1879 1280 1878 1279 1280 1281 1280 1279 1876 1878 1280 1876 1876 1877 1878 1884 1892 1876 1876 1892 1893 1876 1893 1877 1876 1279 1884 1884 1891 1892 1891 2303 1892 1892 2303 2304 1892 2304 1893 1877 1893 1894 1893 2304 2305 1893 2305 1894 2303 1300 2304 2304 1300 1298 2304 1298 2305 1891 2302 2303 2302 1291 2303 2303 1291 1300 1298 1300 1299 1299 1300 1291 1279 1297 1298 1279 1298 1299 2305 1298 1297 1894 2305 2306 2305 1297 2306 1296 1297 1279 2306 1297 1296 1281 1296 1279 1884 1279 1299 1281 1295 1296 2306 1296 2307 2307 1296 1295 1894 2306 1895 1895 2306 2307 1895 2307 1896 1896 2307 2296 2307 1295 2296 1290 1295 1281 2296 1295 1290 1896 2296 1897 1897 2296 2297 2296 1290 2297 1895 1896 1877 1877 1896 1897 1877 1894 1895 1877 1897 1654 1654 1794 1877 1877 1794 1781 1877 1781 1881 1654 1897 1898 1897 2297 1898 1654 1898 1887 1898 2297 2298 1898 2298 1887 1887 1888 1654 1887 2298 2299 1887 2299 1888 2297 1289 2298 2298 1289 1288 2298 1288 2299 1888 2299 2300 2299 1288 1294 2299 1294 2300 1654 1888 1690 1888 1889 1690 1888 2300 1889 1889 2300 2301 2300 1294 1293 2300 1293 2301 1061 1293 1294 1061 1294 1288 1288 1289 1061 1061 1289 1290 2297 1290 1289 1290 1281 1061 1061 1281 1522 1281 1033 1522 1059 1060 1061 1060 1090 1061 1061 1090 1091 1061 1091 1092 1092 1293 1061 1061 1522 1059 2259 1060 2258 2258 1060 1059 2259 1090 1060 2259 1091 1090 1091 1095 1092 2248 1095 1091 2248 1091 2259 2258 1675 2259 2259 1675 1653 2259 1653 2248 2257 1677 2258 2258 1677 1675 2258 1059 2257 1653 1675 1676 1676 1675 1677 1652 1653 1654 1653 1676 1654 2248 1653 1652 1652 1654 1687 2248 1652 1687 1654 1690 1687 1654 1676 1794 1687 1690 1691 2248 1687 2249 2249 1687 1691 1690 1689 1691 2249 1691 2250 2250 1691 1689 2250 1096 2249 2249 1096 1095 2249 1095 2248 2250 1689 2251 2251 1097 2250 2250 1097 1096 1684 1688 1689 1684 1689 1690 2251 1689 1688 2251 1688 2252 2252 1088 2251 2251 1088 1097 1087 1096 1097 1087 1097 1088 1087 1088 1089 2252 1089 1088 2252 1688 1683 2252 1683 2253 2253 1089 2252 1683 1688 1684 1682 1683 1684 2253 1683 1682 2253 1682 2254 2254 1093 2253 2253 1093 1089 1089 1093 1082 1089 1082 1087 1082 1093 1094 2254 1094 1093 2254 1682 1686 2254 1686 2255 2255 1094 2254 1685 1686 1682 1682 1684 1685 1685 1681 1686 1686 1681 2255 2255 1681 1680 2255 1680 2256 2256 1083 2255 2255 1083 1094 1082 1094 1083 1082 1083 1084 1084 1083 1085 2256 1085 1083 2256 1680 1679 2256 1679 2257 2257 1086 2256 1086 1085 2256 1678 1679 1680 1678 1680 1681 1685 1678 1681 1685 1684 1965 1685 1965 1970 1987 1678 1685 1970 2000 1685 1685 2000 2001 1685 2001 1987 1987 1988 1678 2001 1533 1987 1987 1533 1530 1987 1530 1988 2001 1534 1533 2001 2000 1534 1970 1999 2000 1534 2000 1536 1999 1536 2000 1082 1533 1534 1082 1534 1535 1535 1534 1536 1530 1533 1082 1530 1082 1531 1988 1530 1531 1531 1082 1084 1087 1082 1535 1531 1084 1532 1988 1531 1989 1989 1531 1532 1532 1084 1529 1989 1532 1990 1990 1532 1529 1678 1988 1989 1678 1989 1990 1990 1991 1678 1990 1529 1991 1528 1529 1084 1991 1529 1528 1678 1991 1992 1991 1528 1992 1528 1084 1031 1031 1992 1528 1678 1992 1993 1993 1992 1994 1994 1992 1031 1030 1031 1032 1031 1084 1032 1994 1031 1030 1994 1995 1993 1994 1030 1995 1032 1540 1030 1995 1030 1540 1993 1995 1996 1995 1540 1996 1032 1539 1540 1996 1540 1539 1993 1996 1997 1996 1539 1997 1538 1539 1032 1997 1539 1538 1970 1993 1997 1970 1997 1998 1997 1538 1998 1537 1538 1535 1535 1538 1032 1998 1538 1537 1998 1999 1970 1998 1537 1999 1535 1536 1537 1999 1537 1536 1563 1564 1535 1535 1564 1565 1535 1565 1566 1087 1535 1568 1568 1535 1566 1557 1563 1535 1557 1535 1570 1535 1032 1570 1570 1032 1601 1032 1084 1605 1032 1605 1601 1570 1601 680 680 1601 681 1601 1605 1604 1601 1604 681 1547 1604 1605 1547 1605 1551 1551 1605 1084 1522 1035 1551 1551 1035 1523 1551 1523 1547 1551 1084 1522 1522 1033 1035 1522 1084 1086 1522 1086 1059 1033 1034 1035 1523 1035 1524 1524 1035 1034 1177 1178 1034 1178 1179 1034 1033 1182 1034 1034 1182 1183 1034 1183 1177 1790 1178 1177 1790 1177 1791 1791 1177 1183 1789 1179 1178 1789 1178 1790 1179 5897 5892 5892 5898 1179 1179 5759 5897 5897 5899 5892 5897 5759 5751 5897 5751 5899 5751 5759 5734 5734 5750 5751 5899 5751 5750 5892 5899 5900 5899 5750 5900 5750 5734 5755 5900 5750 5755 5755 5734 5756 5789 5756 5734 5789 5734 5663 5663 5734 5677 5755 5756 5757 5900 5755 5902 5902 5755 5757 5892 5900 5901 5901 5900 5902 5901 5902 5903 5902 5757 5903 5756 5758 5757 5903 5757 5758 1193 5901 5903 5903 5758 1193 5901 5944 5892 5892 5896 5898 5892 5944 5945 5892 5945 5831 5788 5945 5944 5788 5944 5785 5831 5945 5850 5789 5850 5945 5789 5945 5788 5788 5756 5789 5771 5756 5788 5771 5788 5785 5663 5850 5789 5661 5662 5663 5663 5662 5664 5663 5664 5665 5663 5677 5661 5665 5848 5663 5663 5848 5850 5665 5664 5666 5665 5666 5667 5848 5665 5667 5847 5845 5848 5848 5845 5849 5848 5849 5850 5848 5667 5847 5667 5666 5668 5668 5683 5667 5847 5667 5683 5846 5845 5847 5847 5683 5846 5668 5682 5683 5846 5683 5682 5681 5682 5668 5666 6134 5668 5668 6134 6133 5668 6133 5681 5681 5680 5682 5846 5682 5844 5844 5682 5680 5844 5845 5846 5841 5843 5844 5844 5843 5845 5844 5680 5841 5679 5653 5680 5679 5680 5681 5841 5680 5653 5678 5653 5679 5681 6132 5679 5679 6132 6131 5679 6131 5678 5651 5652 5653 5653 5652 5654 5678 5651 5653 5841 5653 5654 5672 5651 5678 5678 6131 6154 5678 6154 5672 5840 6131 5842 5842 6131 6132 5840 6154 6131 5840 6153 6154 5672 6154 6153 5672 5673 5651 5673 5672 6152 5672 6153 6152 5839 6152 6153 5839 6153 5840 5654 5839 5840 5654 5840 5841 5840 5842 5841 5652 5839 5654 5652 5838 5839 5838 6151 5839 6151 6152 5839 6152 6151 5673 5651 5673 5674 5673 6151 6150 5673 6150 5674 5838 6150 6151 5835 5838 5652 5835 6149 5838 6149 6150 5838 6150 6149 5674 5835 6148 6149 5674 6149 6148 5671 5651 5674 5671 5674 5669 5674 6148 5669 6147 6148 5835 6148 6147 5669 5834 5835 5652 5834 6147 5835 5834 6146 6147 5669 6147 6146 5669 5670 5671 5669 6146 5670 5677 5671 5675 5675 5671 5670 5708 5651 5671 6146 6145 5670 5670 6145 6144 5670 6144 5675 6145 6146 5834 5836 6144 6145 5836 6145 5834 6143 6144 5836 6144 6143 5675 5833 5836 5837 5837 5836 5834 5833 6143 5836 5833 6142 6143 5675 6143 6142 5831 5832 5833 5833 5837 5831 5832 6141 5833 6141 6142 5833 5834 5652 5837 5837 5652 5650 5837 5650 5870 5651 5650 5652 5649 5648 5650 5649 5650 5651 5870 5650 5648 5708 5649 5651 5647 5648 5649 5688 5647 5649 5688 5649 5708 5710 5711 5708 5708 5711 5712 5708 5712 5688 5710 5872 5871 5710 5871 5711 5711 5871 1150 5711 1150 5712 5688 5712 5713 1150 1151 5712 5712 1151 5713 5870 1151 1150 5870 1150 5871 5870 5871 5872 5851 1151 5870 5870 5648 5851 5851 5873 1151 5713 1151 5873 5688 5713 5704 5713 5873 5704 5869 5873 5851 5704 5873 5869 5688 5704 5705 5704 5869 5705 5851 5868 5869 5705 5869 5868 5705 5727 5688 5705 5868 5727 5851 1143 5868 5727 5868 1143 5688 5727 5728 5727 1143 5728 1143 5730 5728 5688 5728 5729 5729 5728 5730 5729 5730 5720 5688 5689 5690 5699 5700 5688 5688 5700 5701 5688 5701 5689 5690 5647 5688 5688 5686 5699 5700 6116 5701 6116 6115 5701 5701 6115 6114 5701 6114 5689 6115 6116 5853 5853 6116 6117 5700 6117 6116 5852 6114 6115 5852 6115 5853 6113 6114 5852 6114 6113 5689 5851 5852 5853 5851 5855 5852 5855 6113 5852 5856 5851 5853 5853 6117 5856 6117 6118 5856 6118 6117 5700 5856 5857 5858 5858 5851 5856 5856 6118 6119 5856 6119 5857 5851 5648 5855 5647 5646 5648 5648 5854 5855 5646 5865 5648 5648 5865 5866 5648 5866 5854 5866 6109 5854 6109 6110 5854 5854 6110 6111 5854 6111 5855 6107 5866 5865 6107 6108 5866 5866 6108 6109 6110 6109 5691 5691 6109 6108 5690 6111 6110 5690 6110 5691 6111 6112 5855 6112 6111 5690 5855 6112 6113 5689 6113 6112 5689 6112 5690 5690 5691 5647 5647 5691 5692 5691 6108 5692 5692 6108 6107 5647 5692 5645 5645 5692 5693 5692 6107 5693 5645 5646 5647 5645 5693 5694 5646 5645 5694 5694 5693 5695 5693 6107 6130 5693 6130 5695 5694 5695 5696 5696 5860 5694 5694 5860 5863 5694 5863 5646 5863 5864 5646 5646 5864 5865 5860 5862 5863 5863 5862 5864 5862 6127 5864 6127 6128 5864 5864 6128 6129 5864 6129 5865 5865 6129 6130 5865 6130 6107 5695 6130 6129 5695 6129 6128 5697 5695 6128 6128 6127 5697 5862 6126 6127 5697 6127 6126 5696 5695 5697 5696 5697 5698 5698 5697 5687 5697 6126 5687 6125 6126 5862 6126 6125 5687 5684 5686 5687 5687 5686 5698 5687 6125 6124 5687 6124 5684 5861 6124 6125 5861 6125 5862 6123 6124 5861 6124 6123 5684 5684 5685 5686 5684 6123 6122 5684 6122 5685 5698 5686 5702 5699 5686 5685 6122 6121 5685 5685 6121 6120 5685 6120 5699 6121 6122 5859 5859 6122 6123 5859 6123 5861 5858 5857 5859 5858 5859 5860 5859 5861 5860 5857 6121 5859 5857 6120 6121 6119 6120 5857 6120 6119 5699 5699 6119 6118 5699 6118 5700 5860 5861 5862 5819 5858 5860 5819 5860 5928 5928 5860 5929 5696 5929 5860 5928 5702 5819 5703 5702 5928 5703 5928 5698 5698 5928 5929 5698 5929 5696 5698 5702 5703 5675 6142 5676 5676 6142 6141 5675 5676 5677 5661 5677 5676 5676 6141 5661 5832 6140 6141 5661 6141 6140 5661 6140 5662 6139 6140 5832 6140 6139 5662 5831 5830 5832 5830 6139 5832 5830 6138 6139 5662 6139 6138 5662 6138 5664 5829 6137 6138 5829 6138 5830 6138 6137 5664 5829 5830 5831 5831 5850 5829 5829 5850 5849 5849 6137 5829 5849 6136 6137 5664 6137 6136 5664 6136 5666 6135 6136 5849 6136 6135 5666 5845 6135 5849 5845 6134 6135 5666 6135 6134 5843 6133 5845 6133 6134 5845 5841 5842 5843 5842 6132 5843 5843 6132 6133 5681 6133 6132 5771 5772 5773 5771 5787 5772 5787 6060 5772 5772 6060 6059 5772 6059 5773 5905 6059 6060 1033 1192 1193 1033 1193 1180 1793 1193 1782 1782 1193 1192 1795 1180 1193 1795 1193 1793 1193 5758 5827 1184 1192 1033 1180 1181 1033 1033 1181 1182 1796 1182 1181 1796 1181 1797 1797 1181 1180 1792 1183 1182 1792 1182 1796 1792 1796 1794 1794 1796 1797 1794 1797 1795 1797 1180 1795 1793 1781 1794 1793 1794 1795 1792 1794 1771 1771 1794 1676 1782 1781 1793 1881 1781 1779 1881 1779 2022 1779 1739 2022 2033 2034 2022 2022 1739 1741 2022 1741 2033 2033 1741 2025 2025 1492 2033 2033 1492 1498 2033 1498 2034 2024 2025 1741 2024 1493 2025 2025 1493 1492 2024 1494 1493 1676 1677 1678 1771 1676 2017 2017 1676 1678 1677 1679 1678 2257 1679 1677 2017 1678 2018 2018 1678 1993 1766 1771 2017 1766 2017 2021 2021 2017 2018 2018 1993 2019 2021 2018 2002 2002 2018 2019 1926 1932 1993 1926 1993 1970 2019 1993 1932 2019 1932 2020 2002 2019 1974 1974 2019 2020 2020 1932 851 2020 851 846 1974 2020 1943 1943 2020 846 841 845 846 846 851 841 1943 846 845 841 842 843 843 844 841 841 844 845 841 851 849 841 849 852 677 842 841 677 841 678 678 841 852 842 1958 843 843 1958 1639 843 1639 844 684 1958 842 684 842 677 677 683 684 1575 684 1572 1572 684 683 1575 1958 684 677 682 683 1572 683 1571 1571 683 682 676 677 678 676 679 677 677 679 680 677 680 681 681 682 677 679 1570 680 679 1590 1591 676 1596 679 679 1596 1597 679 1597 1590 1591 1589 679 679 1589 1570 1934 1591 1590 1934 1590 1935 1935 1590 1597 1942 1589 1591 1942 1591 1934 1587 1570 1589 1942 1941 1589 1589 1941 1587 851 1941 1942 851 1942 1934 1934 1935 851 851 1935 1936 1935 1597 1936 1936 1597 1596 851 1936 849 1936 1937 849 1936 1596 1937 1932 1941 851 1932 1940 1941 1940 1587 1941 1587 1588 1570 1940 1588 1587 1933 1940 1932 1933 1588 1940 1930 1931 1932 1932 1931 1933 1930 1932 1926 1931 1592 1933 1933 1592 1588 1588 1592 1570 1570 1592 1593 1570 1593 1557 1931 1593 1592 1930 1593 1931 1926 1929 1930 1929 1594 1930 1930 1594 1593 1557 1593 1594 1557 1594 1595 1929 1595 1594 1928 1929 1926 1928 1595 1929 1595 1598 1557 1928 1598 1595 1926 1939 1928 1928 1939 1598 1557 1598 1599 1598 1939 1599 1926 1938 1939 1938 1599 1939 1557 1599 676 676 1599 1600 1938 1600 1599 849 1937 1938 849 1938 1926 1937 1600 1938 676 1600 1596 1937 1596 1600 685 676 686 686 676 678 1561 1557 676 1561 676 685 847 1561 685 848 847 685 685 686 848 686 678 687 848 686 687 687 678 688 678 852 688 687 688 689 848 687 850 850 687 689 847 848 849 849 848 850 852 849 850 852 850 840 840 850 853 850 689 853 688 852 840 838 839 840 840 853 838 688 840 694 694 840 839 853 689 838 689 688 690 838 689 690 836 837 838 838 837 839 838 690 836 694 839 693 693 839 837 693 690 694 694 690 688 693 692 690 836 690 692 835 834 836 836 834 837 836 692 835 693 837 691 691 837 834 691 692 693 691 700 692 835 692 700 833 834 835 835 700 833 833 832 834 691 834 698 698 834 832 698 699 691 691 699 700 833 700 699 831 832 833 833 699 831 831 830 832 698 832 704 704 832 830 704 699 698 703 702 699 703 699 704 831 699 702 829 830 831 831 702 829 829 828 830 704 830 703 703 830 828 695 702 703 703 828 695 695 701 702 829 702 701 827 828 829 829 697 827 829 701 697 827 826 828 695 828 826 824 826 827 827 697 696 696 824 827 695 696 697 697 701 695 707 706 696 707 696 708 708 696 695 706 822 696 696 822 824 822 823 824 823 825 824 824 825 826 695 826 825 823 708 825 825 708 695 823 707 708 705 706 707 705 707 823 822 814 823 814 705 823 812 814 822 706 812 822 812 813 814 813 820 814 709 705 814 814 820 709 709 710 705 705 710 711 705 711 706 709 712 710 709 820 819 709 819 712 813 819 820 818 819 813 712 819 818 710 712 713 712 818 713 818 813 817 818 817 715 713 818 715 710 713 714 714 713 715 714 715 716 716 815 714 714 815 821 714 821 710 716 715 717 717 816 716 716 816 815 815 816 817 817 821 815 817 813 821 710 821 813 710 813 711 711 813 812 711 812 706 854 855 817 855 873 817 817 873 874 817 874 803 816 882 817 817 882 883 817 883 884 889 890 817 890 891 817 817 891 892 817 892 870 870 894 817 817 894 895 817 895 854 884 904 817 817 904 905 817 905 889 803 715 817 884 903 904 769 905 904 769 904 768 768 904 903 770 889 905 770 905 769 768 729 769 769 729 715 769 715 770 719 767 768 768 767 729 768 903 719 715 729 730 767 897 729 729 897 884 729 884 730 719 766 767 898 767 858 858 767 766 767 898 897 718 766 719 718 858 766 858 859 860 860 898 858 718 859 858 860 897 898 860 859 861 896 897 860 724 896 860 724 860 723 723 860 861 861 859 867 723 861 742 742 861 867 867 859 868 867 868 804 804 886 867 742 867 774 774 867 886 804 868 869 721 869 868 721 868 722 722 868 859 804 869 816 869 879 816 734 879 869 734 869 721 721 722 723 734 721 717 717 721 723 723 722 718 722 859 718 723 718 724 717 723 646 646 723 742 718 719 720 724 718 720 896 724 902 902 724 720 719 902 720 719 903 902 896 902 897 897 902 903 897 903 884 730 884 883 730 746 715 730 883 746 746 883 882 715 746 747 746 882 747 816 888 882 747 882 888 715 747 717 717 747 748 747 888 748 816 887 888 748 888 887 717 748 731 748 887 731 731 732 717 717 732 733 717 733 734 717 646 816 887 732 731 881 887 816 881 732 887 732 881 880 732 880 733 733 880 879 733 879 734 816 879 880 816 880 881 816 646 804 645 644 646 645 646 647 647 646 648 725 726 646 646 726 727 646 727 728 728 736 646 646 736 739 646 739 648 742 751 646 646 751 752 646 752 725 811 804 646 644 811 646 751 878 752 878 725 752 877 725 878 725 877 876 725 876 726 804 876 877 804 877 878 866 876 804 726 876 866 726 866 727 804 865 866 727 866 865 727 865 728 865 804 906 728 865 906 728 735 736 728 906 735 906 804 856 906 856 907 735 906 907 736 735 737 735 907 737 907 856 908 907 908 909 737 907 909 736 737 738 737 909 738 909 908 910 909 910 899 899 755 909 909 755 738 757 910 908 757 908 736 736 908 856 899 910 911 910 757 911 899 900 895 899 911 900 755 899 895 754 900 911 754 911 756 911 757 756 738 756 757 738 757 736 755 754 756 755 756 738 753 754 755 755 895 753 895 900 901 895 901 854 753 895 894 764 762 753 753 762 765 753 765 754 753 894 764 765 900 754 762 901 765 765 901 900 762 854 901 761 855 854 761 854 762 760 761 762 764 760 762 760 759 761 759 855 761 759 873 855 758 759 760 758 873 759 758 874 873 760 773 758 773 874 758 803 874 875 773 875 874 648 772 773 760 648 773 875 773 862 862 773 772 803 875 862 862 863 803 771 863 862 771 862 772 648 771 772 741 771 648 741 863 771 803 863 864 741 864 863 648 740 741 740 864 741 803 864 857 740 857 864 648 739 740 739 857 740 856 804 857 857 804 803 739 856 857 736 856 739 803 804 805 648 715 803 648 803 647 647 803 805 805 804 806 647 805 645 645 805 806 806 804 808 645 806 640 640 806 808 640 644 645 640 641 642 642 643 640 640 643 644 652 641 640 640 808 652 643 811 644 642 810 643 643 810 811 642 641 800 800 809 642 642 809 810 809 808 810 808 811 810 808 804 811 878 885 804 804 885 886 871 870 878 878 870 885 751 871 878 763 886 885 763 885 760 760 885 870 774 886 763 763 760 764 764 774 763 775 648 760 760 870 775 743 715 775 775 715 648 870 743 775 743 744 715 892 743 870 743 892 891 743 891 744 715 744 745 770 715 745 744 891 890 744 890 745 745 890 889 745 889 770 870 871 872 872 893 870 870 893 894 750 872 871 750 871 751 749 893 872 749 872 750 764 894 893 764 893 749 749 750 742 749 742 764 742 750 751 764 742 774 800 807 808 800 808 809 652 808 807 799 798 800 798 807 800 800 641 799 652 807 651 651 807 798 651 641 652 651 650 641 641 650 799 649 650 651 651 798 649 797 798 799 649 798 797 653 654 649 649 654 655 649 655 650 801 653 649 649 797 801 799 650 655 799 655 802 802 655 654 789 797 802 802 797 799 654 789 802 789 801 797 791 801 789 791 653 801 653 659 654 791 659 653 789 790 791 790 660 791 791 660 659 790 789 793 793 789 796 654 796 789 793 656 790 790 656 660 654 659 660 654 660 661 661 660 656 661 796 654 793 796 795 661 795 796 661 656 662 662 795 661 794 793 795 662 794 795 662 656 658 658 794 662 786 793 794 658 786 794 656 657 658 657 786 658 785 784 786 784 792 786 786 792 793 657 785 786 783 784 785 788 783 785 665 788 785 665 785 657 783 666 784 784 666 664 784 664 792 792 664 663 792 663 793 793 663 656 656 663 657 657 663 664 657 664 665 665 664 666 665 666 667 667 788 665 778 783 788 667 778 788 667 666 668 668 778 667 666 669 668 783 669 666 668 669 670 668 670 671 671 782 668 668 782 778 777 670 669 777 669 787 787 669 783 671 670 672 776 672 670 776 670 777 776 777 778 777 787 778 778 787 783 782 776 778 781 776 782 671 781 782 671 672 673 673 781 671 673 672 674 674 672 776 781 780 776 776 780 674 779 780 781 673 779 781 673 674 675 675 779 673 948 951 674 674 951 952 674 952 953 955 675 674 955 674 956 956 674 953 948 674 984 984 674 780 996 953 952 996 952 971 971 952 951 980 956 953 980 953 996 979 955 956 979 956 980 780 979 980 996 780 980 971 780 996 970 971 972 970 985 971 971 985 780 971 951 972 779 977 780 780 977 979 984 780 985 977 955 979 954 675 955 977 954 955 962 675 954 962 954 963 963 954 964 976 964 954 976 954 977 961 675 962 1020 961 962 1020 962 1021 1021 962 963 963 964 965 1021 963 978 978 963 965 977 1020 1021 977 1021 978 779 1019 1020 779 1020 977 1019 961 1020 961 966 675 1019 966 961 1018 1019 779 1018 966 1019 675 966 967 1018 967 966 675 967 968 929 675 927 927 675 968 929 779 675 1023 968 967 1023 967 1018 779 1023 1018 779 1022 1023 1022 968 1023 927 968 937 937 968 969 1022 969 968 983 1017 1022 983 1022 779 1017 969 1022 937 969 938 1017 938 969 1016 1015 1017 1016 1017 982 982 1017 983 1015 938 1017 937 938 939 939 938 940 1015 940 938 1012 1014 1015 1012 1015 1016 1014 940 1015 1013 1014 1012 1013 957 1014 1014 957 940 1012 994 1013 994 958 1013 1013 958 957 957 958 959 959 960 957 957 960 924 957 924 940 965 916 958 958 916 918 958 918 959 994 965 958 1007 960 959 1007 959 1008 1008 959 918 1006 924 960 1006 960 1007 974 1006 1007 974 1007 975 975 1007 1008 975 1008 1009 1009 1008 970 1008 918 970 1009 970 1010 1010 921 1009 1009 921 919 1009 919 975 1010 970 972 970 918 920 970 920 985 972 950 1010 1010 950 921 972 951 950 949 921 950 949 950 948 948 950 951 948 947 949 922 921 949 997 922 949 997 949 998 998 949 947 946 947 948 948 984 999 948 999 946 944 945 946 946 945 947 946 999 1001 946 1001 944 984 998 999 999 998 1000 999 1000 1001 984 997 998 998 947 1000 985 997 984 985 922 997 985 920 922 918 919 920 920 919 921 920 921 922 916 917 918 918 917 919 975 919 917 975 917 995 995 917 916 965 964 916 995 916 993 993 916 964 993 994 995 1011 975 995 1011 995 1012 1012 995 994 973 974 975 973 975 1011 1012 939 1011 1011 939 941 1011 941 973 1016 937 1012 1012 937 939 939 940 941 940 923 941 973 941 923 973 923 974 923 924 925 940 924 923 974 923 925 925 924 926 1005 924 1006 1005 926 924 925 926 914 914 936 925 974 925 992 992 925 936 914 935 936 992 936 991 991 936 935 991 912 992 912 1004 992 992 1004 1005 992 1005 974 1005 1006 974 1004 926 1005 912 1003 1004 1003 942 1004 1004 942 926 1002 1003 912 1002 943 1003 1003 943 942 926 942 914 914 942 943 914 943 944 944 943 945 1002 945 943 1001 1000 1002 1001 1002 912 1000 945 1002 1000 947 945 912 913 914 991 913 912 944 1001 912 944 912 914 914 913 915 990 989 913 990 913 991 989 915 913 991 935 990 988 989 990 990 935 934 990 934 988 988 987 989 987 933 989 989 933 915 986 987 988 988 934 932 988 932 986 933 932 934 933 934 915 915 934 935 915 935 914 931 932 933 987 931 933 986 983 987 983 931 987 981 983 986 986 930 981 986 932 930 931 930 932 929 930 931 983 929 931 981 982 983 983 779 929 981 930 928 981 928 982 929 928 930 927 928 929 982 928 927 982 927 1016 1016 927 937 993 978 994 978 965 994 976 978 993 993 964 976 976 977 978 849 1926 847 847 1926 1927 1927 1561 847 1960 1927 1926 1960 1926 1961 1961 1926 1962 1970 1971 1926 1926 1971 1972 1926 1972 1962 1962 2286 1961 1961 2286 2287 1961 2287 1960 1972 2285 1962 1962 2285 2286 1971 2284 1972 1972 2284 2285 1970 1969 1971 1969 2295 1971 1971 2295 2284 2295 1564 2284 2284 1564 1563 2284 1563 2285 2285 1558 2286 2285 1563 1558 1558 1563 1557 1557 1556 1558 2286 1558 1556 1555 1556 1557 1555 1557 1561 2286 1556 2287 2287 1556 1555 1561 1562 1555 2287 1555 2288 2288 1555 1562 1960 2287 2288 1960 2288 1959 1959 2288 2289 2288 1562 2289 1561 1560 1562 2289 1562 1560 1959 2289 1963 1963 2289 2290 2289 1560 2290 1959 1927 1960 1959 1963 1927 1927 1963 1964 1963 2290 1964 1964 2290 2291 2290 1560 1559 2290 1559 2291 1559 1560 1561 1559 1561 1567 2291 1559 1567 1964 2291 1966 1966 2291 2292 2291 1567 2292 1927 1964 1965 1965 1964 1966 1965 1966 1967 1966 2292 1967 1967 2292 2293 2292 1567 1569 2292 1569 2293 1567 1561 1568 1567 1568 1569 1927 1568 1561 1568 1566 1569 1965 1087 1568 1965 1568 1927 1970 1965 1967 1684 1087 1965 1092 1096 1087 1684 1092 1087 1690 1092 1684 1690 1889 1890 1690 1890 1871 1871 1047 1690 1690 1047 1092 1889 2301 1890 1871 1890 1891 1890 2301 2302 1890 2302 1891 2301 1293 1292 2301 1292 2302 2302 1292 1291 1291 1292 1092 1092 1292 1293 1299 1291 1046 1046 1291 1092 1092 1095 1096 1046 1092 1047 1045 1046 1047 1885 1299 1046 1885 1046 1886 1046 1045 1886 1884 1299 1885 1884 1885 1871 1871 1885 1886 1871 1886 1869 1886 1045 1274 1886 1274 1869 1045 1047 1274 1047 1287 1274 1869 1274 1287 1869 1870 1871 1869 1287 1870 1871 1891 1884 1970 1967 1968 1967 2293 1968 1968 1969 1970 1968 2293 2294 1968 2294 1969 2293 1569 1566 2293 1566 2294 1969 2294 2295 2294 1566 1565 2294 1565 2295 2295 1565 1564 1606 1607 682 681 1616 682 682 1616 1617 682 1617 1606 1571 682 1608 1608 682 1607 681 1615 1616 1947 1617 1616 1947 1616 1950 1950 1616 1615 1946 1606 1617 1946 1617 1947 1946 1947 844 844 1947 845 845 1947 1950 845 1950 1949 1950 1615 1949 1614 1615 681 1949 1615 1614 1948 845 1949 1949 1614 1948 1948 1943 845 1944 1943 1948 1944 1948 1613 1613 1948 1614 681 1613 1614 681 1604 1613 1604 1612 1613 1944 1613 1612 1943 1944 1945 1944 1612 1945 1604 1611 1612 1945 1612 1611 1571 1603 1604 1571 1604 1547 1603 1611 1604 1945 1611 1951 1951 1611 1603 1945 1951 1943 1951 1952 1638 1943 1951 1638 1951 1603 1952 1602 1603 1571 1952 1603 1602 1638 1952 1953 1952 1602 1953 1571 1610 1602 1953 1602 1610 1638 1953 1954 1953 1610 1954 1571 1609 1610 1954 1610 1609 1955 1638 1954 1954 1609 1955 1608 1609 1571 1608 1955 1609 1955 1956 844 844 1638 1955 1956 1955 1608 1956 1608 1607 844 1956 1957 1956 1607 1957 844 1957 1946 844 1639 1638 1957 1607 1606 1957 1606 1946 1638 1639 1635 1943 1638 1973 1973 1638 1635 1973 1974 1943 2011 1974 2012 2012 1974 1973 2011 2014 1974 1974 2014 2015 1974 2015 2002 2012 1552 2011 2011 1552 1546 2011 1546 2014 2012 1973 2013 2013 1553 2012 2012 1553 1552 1552 1553 1029 1546 1552 1547 1547 1552 1029 1545 1546 1547 2014 1546 1545 2014 1545 2015 1547 1550 1545 1550 2015 1545 1547 1523 1550 1547 1029 1571 1523 1549 1550 2016 1550 1549 2016 2015 1550 1523 1548 1549 2016 1549 2003 2003 1549 1548 2002 2015 2016 2002 2016 2003 2002 2003 2004 2003 1548 2004 1544 1548 1523 2004 1548 1544 1705 2002 2004 1705 2004 2007 2004 1544 2007 1708 2021 2002 1708 2002 1705 2039 1766 2021 2039 2021 1708 2038 1766 2039 1905 2038 2039 1905 2039 1899 1899 2039 1708 2038 1763 1766 2037 1763 2038 2052 2037 2038 2052 2038 1905 1759 1762 1763 1762 1772 1763 2037 1759 1763 1726 1759 2037 2045 1726 2037 2045 2037 2052 1726 1750 1759 2071 1726 2045 2045 2078 2071 2045 2042 2078 1509 2078 2042 2043 2044 2045 2052 2054 2045 2045 2054 2055 2045 2055 2043 2044 2042 2045 2055 1513 2043 2043 1513 1512 2043 1512 2044 2044 2050 2042 2044 1512 1511 2044 1511 2050 1512 1513 1514 1514 1511 1512 1514 1513 1515 2055 1515 1513 2054 1515 2055 1514 1515 1516 1516 1515 1517 2054 1517 1515 1481 1509 1514 1514 1509 1511 1509 1510 1511 2050 1511 1510 1508 1520 1509 1509 1520 1521 1509 1521 1510 1509 2042 1508 2050 1510 2051 2051 1510 1521 2051 1521 2040 2040 1521 1520 1508 1519 1520 2040 1520 2041 2041 1520 1519 2040 2041 2042 2042 2051 2040 2042 2041 2046 2042 2050 2051 1508 2042 2046 2041 2047 2046 2041 1519 2047 1507 1519 1508 2047 1519 1507 2046 2047 2048 2047 1507 2048 1506 1507 1508 2048 1507 1506 2046 2048 2049 2048 1506 2049 1508 1518 1506 2049 1506 1518 1305 1516 1508 1508 1516 1518 1508 2046 1305 1516 1517 1518 2049 1518 2053 2053 1518 1517 2049 2052 2046 2049 2053 2052 2052 2053 2054 2053 1517 2054 2046 2052 1905 2046 1905 1910 1305 2046 1910 1899 1904 1905 1905 1904 1906 1905 1906 1907 1910 1905 1907 1899 1903 1904 1903 1311 1904 1904 1311 1310 1904 1310 1906 1906 1310 1308 1906 1308 1907 1910 1907 1908 1907 1308 1307 1907 1307 1908 1307 1308 1309 1309 1308 1310 1309 1310 1044 1044 1310 1311 1044 1311 1304 1903 1304 1311 1042 1044 1304 1901 1042 1304 1901 1304 1903 1042 1043 1044 1043 1042 1901 1899 1900 1901 1901 1903 1899 1900 1043 1901 1325 1317 1043 1043 1317 1326 1043 1326 1044 1900 1325 1043 1302 1301 1325 1325 1301 1317 1923 1302 1325 1923 1325 1900 1301 1302 1303 1303 1302 1641 1641 1302 1923 1900 1922 1923 1923 1922 1924 1924 1641 1923 1640 1641 1642 1924 1642 1641 1640 1303 1641 1303 1312 1301 1902 1312 1303 1902 1303 1640 1640 1642 1902 1642 1912 1902 1912 1312 1902 1301 1312 1313 1912 1313 1312 1642 1911 1912 1911 1313 1912 1301 1313 1305 1305 1313 1314 1911 1314 1313 1910 1909 1911 1910 1911 1642 1909 1314 1911 1305 1314 1306 1909 1306 1314 1908 1909 1910 1908 1306 1909 1305 1910 1301 1301 1910 1642 1925 1698 1642 1925 1642 1924 1301 1642 1100 1100 1642 1698 1919 1698 1925 1924 2260 1925 1925 2260 2261 1925 2261 1919 1922 2271 1924 1924 2271 2260 2271 1317 2260 2260 1317 1316 2260 1316 2261 1919 2261 2262 2261 1315 2262 2261 1316 1315 1301 1315 1316 1301 1316 1317 2271 1326 1317 1922 2270 2271 2270 1326 2271 1044 1326 1327 2270 1327 1326 1921 2269 2270 1921 2270 1922 2269 1327 2270 1044 1327 1318 2269 1318 1327 1318 1319 1044 1044 1319 1320 1044 1320 1058 2268 1319 1318 2268 1318 2269 1920 2268 2269 1920 2269 1921 1917 2267 2268 1917 2268 1920 2267 1319 2268 2267 1320 1319 1058 1320 1321 2266 1321 1320 2266 1320 2267 1916 2266 2267 1916 2267 1917 1899 1916 1917 1917 1920 1899 1899 1920 1921 1692 1916 1899 1899 1921 1900 1899 1708 1692 1692 1915 1916 1915 2266 1916 1915 2265 2266 2265 1321 2266 1914 1915 1692 1914 2265 1915 1914 2264 2265 2264 1322 2265 2265 1322 1321 1692 1913 1914 1913 2264 1914 1913 2263 2264 2263 1323 2264 2264 1323 1322 1321 1322 1058 1058 1322 1323 1058 1323 1100 1100 1323 1324 2263 1324 1323 1918 2262 2263 1918 2263 1913 2262 1324 2263 1913 1692 1918 1918 1692 1698 1918 1698 1919 1919 2262 1918 2262 1315 1324 1100 1324 1315 1100 1315 1301 1025 1099 1100 1099 1101 1100 1100 1101 1102 1100 1102 1058 1100 1698 1025 2317 1102 1101 2317 1101 2316 2316 1101 1099 1058 1102 1103 2318 1103 1102 2318 1102 2317 1056 1057 1058 1058 1103 1056 1057 1108 1058 2319 1056 1103 2319 1103 2318 2317 1699 2318 2318 1699 1694 2318 1694 2319 2319 1694 1693 2319 1693 2308 2308 1056 2319 2308 1057 1056 2308 1709 2309 2308 1693 1710 2308 1710 1709 2309 1057 2308 1692 1693 1694 1692 1710 1693 1692 1694 1698 1694 1699 1698 1692 1708 1710 1708 1709 1710 1708 1707 1709 2309 1709 1707 1705 1707 1708 1705 1706 1707 2309 1707 2310 2310 1707 1706 1704 1706 1705 2310 1706 2311 2311 1706 1704 2311 1054 2310 2310 1054 1109 2310 1109 2309 2311 1704 2312 2312 1055 2311 2311 1055 1054 1703 1704 1705 2312 1704 1703 2312 1703 2313 2313 1105 2312 2312 1105 1104 2312 1104 1055 1054 1055 1024 1055 1104 1024 1024 1104 1105 1024 1105 1025 1025 1105 1106 2313 1106 1105 1024 1025 1026 1026 1578 1024 1024 1578 1110 1024 1110 1054 1054 1110 1109 1108 1107 1109 1108 1109 1110 1109 1107 2309 1057 1107 1108 1110 1524 1108 2309 1107 1057 1110 1523 1524 1544 1523 1110 1110 1543 1544 2007 1544 1543 1110 1542 1543 2007 1543 2008 2008 1543 1542 2007 2008 1705 1705 2008 2009 2008 1542 2009 1541 1542 1110 2009 1542 1541 1705 2009 2010 2009 1541 2010 1697 1703 1705 1697 1705 1973 1973 1705 2010 1973 2010 2005 2005 2010 1028 1028 2010 1541 1028 1541 1110 1028 1110 1029 1029 1110 1578 1027 1028 1029 2005 1028 1027 2005 2006 1973 2005 1027 2006 2013 1973 2006 1973 1635 1697 2006 1027 1554 2006 1554 2013 1029 1554 1027 1029 1553 1554 2013 1554 1553 1571 1029 1572 1029 1578 1572 1572 1579 1580 1580 1584 1572 1572 1584 1585 1572 1585 1575 1572 1578 1583 1572 1583 1579 2277 1584 1580 2277 1580 2278 2278 1580 1579 2276 1585 1584 2276 1584 2277 1978 2276 2277 1978 2277 1977 1977 2277 2278 1977 2278 1976 1976 2278 2279 2278 1579 2279 1976 1639 1977 1977 1639 1978 1639 1986 1978 1986 2276 1978 1986 2275 2276 2275 1585 2276 1639 1985 1986 1985 2275 1986 1976 1635 1639 1958 1985 1639 1958 1984 1985 1984 2274 1985 1985 2274 2275 2274 1586 2275 2275 1586 1585 1575 1585 1586 1575 1586 1576 2274 1576 1586 1984 2273 2274 2273 1576 2274 1981 1984 1958 1981 2273 1984 1981 2272 2273 2272 1574 2273 2273 1574 1576 1574 1575 1576 1574 1026 1575 1026 1636 1575 1575 1636 1958 1573 1026 1574 2272 1573 1574 1982 2272 1981 1982 2283 2272 2283 1573 2272 1981 1958 1982 1982 1958 1636 1982 1636 1983 1983 2283 1982 1983 2282 2283 2282 1577 2283 2283 1577 1573 1573 1577 1026 1026 1577 1578 1577 1581 1578 2282 1581 1577 1980 2281 2282 1980 2282 1983 2281 1581 2282 1983 1636 1980 1635 1979 1980 1635 1980 1636 1979 2281 1980 1979 2280 2281 2280 1582 2281 2281 1582 1581 1578 1581 1582 1578 1582 1583 2280 1583 1582 1975 2279 2280 1975 2280 1979 2279 1583 2280 1975 1979 1635 1975 1635 1976 1976 2279 1975 2279 1579 1583 1635 1636 1637 1697 1635 1637 1026 1637 1636 1025 1637 1026 1098 1099 1025 1025 1106 1098 1025 1698 1637 2315 1099 1098 2315 1098 2314 2314 1098 1106 2316 1099 2315 2314 1702 2315 2315 1702 1701 2315 1701 2316 2313 1695 2314 2314 1695 1702 2314 1106 2313 1637 1701 1702 1695 1637 1702 1637 1700 1701 2316 1701 1700 2316 1700 2317 1698 1699 1700 1698 1700 1637 2317 1700 1699 1697 1637 1695 1695 1696 1697 2313 1696 1695 1703 1696 2313 1696 1703 1697 1900 1921 1922 1305 1306 1307 1307 1309 1305 1305 1309 1516 1908 1307 1306 1762 1167 1772 1789 1790 1771 1771 1790 1791 1771 1791 1792 1791 1183 1792 2257 1059 1086 1084 1085 1086 6095 6096 5930 5930 6096 6097 5798 6097 6096 5930 6097 5931 6097 6098 5931 6098 6097 5798 5797 5807 5798 5807 6098 5798 5931 6098 6099 5807 6099 6098 5931 6099 5932 6099 6100 5932 6100 6099 5807 5960 5961 5962 5962 5956 5960 5959 5958 5960 5960 5958 5961 5960 5956 5953 5960 5953 5959 5958 5951 5961 5951 5952 5953 5956 5951 5953 5958 5952 5951 5957 5541 5958 5957 5958 5959 5958 5541 5477 5477 5952 5958 5959 5953 5954 5959 5954 5957 5953 5952 5954 5954 5952 5457 5477 5457 5952 5954 5457 5639 5954 5639 5549 5957 5954 5549 5552 5541 5957 5957 5549 5552 5550 5551 5552 5552 5551 5584 5549 5624 5552 5552 5624 5625 5552 5625 5550 5584 5518 5552 5552 5518 5541 5624 6014 5625 6014 6013 5625 5625 6013 6012 5625 6012 5550 6013 6014 5545 5545 6014 6015 5624 6015 6014 5544 6012 6013 5544 6013 5545 6011 6012 5544 5550 6012 6011 5540 5544 5541 5541 5544 5545 6011 5544 5540 5541 5545 5477 5477 5545 5546 5545 6015 5546 6015 6016 5546 6016 6015 5624 5477 5546 5534 5546 6016 6017 5546 6017 5534 5623 6017 6016 5623 6016 5624 5549 5623 5624 5612 5623 5549 5612 6018 5623 6018 6017 5623 6017 6018 5534 5534 5535 5477 5534 6018 6019 5534 6019 5535 5612 6019 6018 5549 5611 5612 5611 6020 5612 6020 6019 5612 6019 6020 5535 5477 5535 5536 5535 6020 6021 5535 6021 5536 5611 6021 6020 6021 6022 5536 6022 6021 5611 5477 5536 5479 5479 5536 5537 5536 6022 6023 5536 6023 5537 5616 6023 6022 5616 6022 5611 6023 6024 5537 6024 6023 5616 5479 5537 5538 5537 6024 6025 5537 6025 5538 5618 6025 6024 5618 6024 5616 5611 5615 5616 5616 5615 5617 5616 5617 5618 5618 5617 5619 5618 5619 5620 5620 6026 5618 6026 6025 5618 6025 6026 5538 5538 6026 6027 5620 6027 6026 5620 5619 5621 5620 5621 5610 5610 6028 5620 6028 6027 5620 5538 6027 5539 6027 6028 5539 5539 6028 6029 5610 6029 6028 5538 5539 5479 5479 5539 5518 5543 5518 5539 5539 6029 5543 6029 6030 5543 6030 6029 5610 5542 5518 5543 5543 6030 6031 5543 6031 5542 5609 6031 6030 5609 6030 5610 6031 6032 5542 6032 6031 5609 5540 5541 5542 5542 5541 5518 5542 6032 6033 5542 6033 5540 5609 5608 6032 5608 6033 6032 5584 5608 5609 5584 5609 5599 5599 5609 5610 5551 5608 5584 5551 6034 5608 5608 6034 6033 5540 6033 6034 5540 6034 6011 5551 6011 6034 5550 6011 5551 5582 5583 5584 5584 5583 5585 5584 5585 5586 5584 5599 5582 5586 5531 5584 5584 5531 5518 5586 5585 5587 5583 6036 5585 5585 6036 6035 5585 6035 5587 5586 5587 5588 5531 5586 5588 5518 5531 5516 5516 5531 5532 5531 5588 5532 5588 5587 5589 5588 5589 5590 5532 5588 5590 5587 6035 6058 5587 6058 5589 5516 6057 6058 5516 6058 6035 5589 6058 6057 6035 5517 5516 6035 6036 5517 5516 5517 5518 5521 5518 5517 5517 6036 6037 5517 6037 5521 5479 5518 5521 5521 5522 5479 6037 6038 5521 5521 6038 6039 5521 6039 5522 6038 6037 5583 5583 6037 6036 5582 6039 6038 5582 6038 5583 6039 6040 5522 6040 6039 5582 5582 5599 5600 5582 5600 5601 5601 6040 5582 5522 6040 6041 5601 6041 6040 5601 5600 5602 5601 5602 5603 5603 6042 5601 6042 6041 5601 5522 6041 5523 6041 6042 5523 5523 6042 6043 5603 6043 6042 5479 5522 5523 5479 5523 5524 5523 6043 5524 6043 6044 5524 6044 6043 5603 5519 5479 5524 5524 6044 6045 5524 6045 5519 5605 6045 6044 5605 6044 5603 6045 6046 5519 6046 6045 5605 5484 5519 5520 5484 5479 5519 5519 6046 6047 5519 6047 5520 5597 6047 6046 5597 6046 5605 5603 5604 5605 5605 5604 5606 5605 5606 5597 5603 5602 5604 5602 5515 5604 5604 5515 5514 5604 5514 5606 5597 5606 5607 5606 5514 5513 5606 5513 5607 5484 5513 5514 5484 5514 5515 5515 5499 5484 5602 5499 5515 5600 5499 5602 5499 5500 5479 5484 5499 5479 5600 5500 5499 5599 5501 5600 5501 5500 5600 5479 5500 5501 5479 5480 5477 5479 5501 5480 5599 5480 5501 5610 5622 5599 5622 5480 5599 5477 5480 5481 5621 5481 5480 5621 5480 5622 5610 5621 5622 5619 5481 5621 5477 5481 5475 5619 5475 5481 5617 5475 5619 5475 5476 5477 5617 5476 5475 5615 5476 5617 5477 5476 5478 5615 5478 5476 5611 5614 5615 5614 5478 5615 5483 5477 5478 5614 5483 5478 5549 5613 5614 5549 5614 5611 5613 5483 5614 5482 5477 5483 5613 5482 5483 5482 5457 5477 5465 5457 5482 5465 5482 5548 5548 5482 5613 5548 5613 5549 5547 5548 5549 5548 5547 5465 5547 5549 5628 5465 5547 5628 5628 5549 5627 5628 5627 5629 5465 5628 5467 5467 5628 5629 5629 5627 5630 5467 5629 5469 5469 5629 5630 5466 5465 5467 5466 5467 5468 5468 5467 5469 5468 5469 5470 5470 5469 5471 5469 5630 5471 5630 5627 5631 5630 5631 5632 5471 5630 5632 5470 5471 5472 5472 5471 5473 5471 5632 5473 5632 5631 5633 5632 5633 5634 5473 5632 5634 5472 5473 5455 5455 5473 5474 5473 5634 5474 5634 5633 5635 5634 5635 5569 5474 5634 5569 5455 5474 5456 5474 5569 5456 5562 5568 5569 5568 5578 5569 5562 5569 5560 5560 5569 5635 5456 5569 5578 5568 5577 5578 5456 5578 5505 5505 5578 5577 5576 5575 5577 5576 5577 5568 5505 5577 5507 5507 5577 5575 5498 5456 5505 5498 5505 5506 5506 5505 5507 5506 5507 5508 5508 5507 5509 5507 5575 5509 5574 5573 5575 5574 5575 5576 5509 5575 5573 5508 5509 5510 5510 5509 5511 5509 5573 5511 5572 5571 5573 5572 5573 5574 5511 5573 5571 5576 5988 5574 5574 5988 5987 5574 5987 5572 5570 5571 5572 5572 5987 6010 5572 6010 5570 5987 5508 5510 5987 5988 5508 5510 6010 5987 5508 5988 5989 5576 5989 5988 5568 5990 5576 5990 5989 5576 5508 5989 5506 5989 5990 5506 5506 5990 5991 5568 5991 5990 5562 5992 5568 5992 5991 5568 5506 5991 5498 5991 5992 5498 5498 5992 5993 5562 5993 5992 5560 5561 5562 5561 5994 5562 5994 5993 5562 5498 5993 5497 5993 5994 5497 5497 5461 5498 5461 5456 5498 5496 5461 5497 5497 5994 5995 5497 5995 5496 5561 5995 5994 5995 5996 5496 5996 5995 5561 5560 5563 5561 5563 5996 5561 5496 5996 5997 5563 5997 5996 5494 5495 5496 5496 5495 5461 5496 5997 5494 5997 5998 5494 5998 5997 5563 5560 5557 5563 5557 5998 5563 5494 5998 5999 5557 5999 5998 5491 5493 5494 5494 5493 5495 5494 5999 5491 5495 5558 5461 5558 5495 5493 5491 5492 5493 5558 5493 5559 5559 5493 5492 5557 5558 5559 5558 5557 5560 5461 5558 5560 5567 5557 5559 5559 5492 5567 5490 5492 5491 5567 5492 5490 5566 5557 5567 5567 5490 5566 5489 5488 5490 5489 5490 5491 5566 5490 5488 5556 5565 5566 5566 5565 5557 5566 5488 5556 5487 5484 5488 5487 5488 5489 5556 5488 5553 5553 5488 5484 5553 5555 5556 5555 5564 5556 5556 5564 5565 5553 5554 5555 5554 6006 5555 6006 6005 5555 5555 6005 6004 5555 6004 5564 6004 6003 5564 5564 6003 6002 5564 6002 5565 6003 6004 5487 5487 6004 6005 5487 6005 5485 6005 6006 5485 5485 6006 6007 5554 6007 6006 5484 5485 5486 5485 5484 5487 5485 6007 5486 6007 6008 5486 6008 6007 5554 5486 6008 6009 5554 5570 6008 5570 6009 6008 5554 5553 5570 5570 5553 5571 5570 6010 6009 5486 6009 5510 5510 6009 6010 5510 5511 5486 5486 5511 5512 5511 5571 5512 5553 5581 5571 5512 5571 5581 5486 5512 5502 5512 5581 5502 5553 5580 5581 5502 5581 5580 5486 5502 5484 5484 5502 5503 5502 5580 5503 5579 5580 5553 5503 5580 5579 5484 5503 5504 5598 5504 5503 5503 5579 5598 5553 5598 5579 5553 5597 5598 5597 5607 5598 5607 5504 5598 5504 5513 5484 5607 5513 5504 5520 5525 5484 5484 5525 5526 5484 5526 5527 5553 5484 5593 5593 5484 5527 6047 6048 5520 5520 6048 6049 5520 6049 5525 6048 6047 5597 5596 6049 6048 5596 6048 5597 6049 6050 5525 6050 6049 5596 5553 5595 5596 5596 5597 5553 5595 6050 5596 5525 6050 6051 5595 6051 6050 5553 5594 5595 5594 6052 5595 6052 6051 5595 5593 5594 5553 5593 5592 5594 5592 6054 5594 6054 6053 5594 5594 6053 6052 6051 6052 5526 5526 6052 6053 5525 6051 5526 5527 5526 5528 5526 6053 5528 6053 6054 5528 5528 6054 6055 5592 6055 6054 5527 5528 5529 5529 5528 5530 5528 6055 5530 5529 5593 5527 5530 5533 5529 5533 5591 5529 5529 5591 5593 5530 5532 5533 5532 5590 5533 5533 5590 5591 5590 5589 5591 5591 5589 5592 5591 5592 5593 5592 5589 6056 5589 6057 6056 6056 6055 5592 6055 6056 5530 5530 6056 6057 5530 6057 5516 5516 5532 5530 5489 6003 5487 5491 6001 5489 6001 6002 5489 5489 6002 6003 5999 6000 5491 5491 6000 6001 6002 6001 5565 5565 6001 6000 5565 6000 5557 6000 5999 5557 5560 5635 5636 5636 5637 5560 5560 5637 5638 5560 5638 5639 5461 5560 5457 5457 5560 5639 5460 5461 5462 5462 5461 5457 5460 5454 5461 5461 5454 5456 5462 5975 5460 5975 5976 5460 5460 5976 5977 5460 5977 5454 5462 5974 5975 5976 5975 5638 5638 5975 5974 5637 5977 5976 5637 5976 5638 5977 5978 5454 5978 5977 5637 5636 5978 5637 5454 5978 5979 5636 5979 5978 5635 5980 5636 5980 5979 5636 5454 5979 5455 5979 5980 5455 5455 5980 5981 5635 5981 5980 5633 5982 5635 5982 5981 5635 5455 5981 5472 5981 5982 5472 5454 5455 5456 5472 5982 5983 5472 5983 5470 5633 5983 5982 5633 5631 5984 5984 5983 5633 5983 5984 5470 5470 5984 5985 5470 5985 5468 5631 5985 5984 5627 5986 5631 5631 5986 5985 5468 5985 5986 5963 5466 5468 5468 5986 5963 5627 5963 5986 5626 5627 5549 5626 5963 5627 5963 5964 5466 5626 5964 5963 5464 5465 5466 5466 5964 5965 5466 5965 5464 5644 5965 5964 5644 5964 5626 5549 5644 5626 5639 5643 5549 5549 5643 5644 5643 5966 5644 5966 5965 5644 5965 5966 5464 5464 5966 5967 5643 5967 5966 5464 5458 5465 5464 5967 5458 5465 5458 5457 5457 5458 5459 5967 5968 5458 5458 5968 5969 5458 5969 5459 5968 5967 5643 5639 5642 5643 5642 5968 5643 5642 5969 5968 5969 5970 5459 5970 5969 5642 5463 5457 5459 5459 5970 5971 5459 5971 5463 5462 5457 5463 5971 5972 5463 5463 5972 5973 5463 5973 5462 5972 5971 5641 5641 5971 5970 5641 5970 5642 5641 5642 5639 5639 5640 5641 5640 5972 5641 5640 5973 5972 5973 5974 5462 5974 5973 5640 5639 5638 5640 5638 5974 5640 1273 1427 1428 1428 1431 1273 1273 1431 1432 1273 1432 1075 2335 1428 1427 2334 1431 1428 2334 1428 2335 2333 1431 2334 2333 1432 1431 1075 1432 1433 2332 1433 1432 2332 1432 2333 1429 1430 1075 1075 1433 1429 2343 1429 1433 2343 1433 2332 2093 2332 2094 2094 2332 2333 2093 2343 2332 2094 2333 2085 2085 2333 2334 1666 2093 2094 1868 1666 2094 1868 2094 2085 1666 2092 2093 2092 2343 2093 2092 2342 2343 2342 1429 2343 2342 1430 1429 2091 2342 2092 2091 2092 1666 2085 2086 1868 2085 2334 2086 1868 2086 2087 2086 2334 2335 2086 2335 2087 2074 1484 1480 2074 1480 2073 1480 1484 1246 311 451 454 311 454 308 308 454 453 2356 2357 2358 2356 2358 2359 2643 2641 2356 2356 2641 2357 2359 2643 2356 2641 2640 2357 2357 2640 2358 2359 2358 2363 2640 2622 2358 2358 2622 2363 2639 2623 2640 2640 2623 2622 2641 2639 2640 2638 2639 2641 2643 2638 2641 2567 2568 2639 2568 2478 2639 2639 2478 2623 2638 2567 2639 2564 2569 2638 2569 2567 2638 2642 2564 2638 2642 2638 2643 2563 2567 2569 2563 2569 2564 2562 2563 2564 2565 2567 2563 2562 2687 2563 2563 2687 2686 2563 2686 2565 2564 2571 2562 2687 2562 2571 2685 2686 2687 2689 2685 2687 2689 2687 2688 2688 2687 2571 2693 2565 2686 2693 2686 2694 2694 2686 2685 2692 2565 2693 2694 2700 2693 2693 2700 2701 2693 2701 2692 2694 2685 2695 2695 2700 2694 2695 2699 2700 2704 2701 2700 2704 2700 2705 2705 2700 2699 2695 2685 2691 2691 2699 2695 2691 2396 2699 2699 2396 2395 2705 2699 2394 2394 2699 2395 2707 2704 2705 2707 2705 2393 2393 2705 2394 2392 2393 2394 2392 2394 2386 2386 2394 2395 2386 2395 2385 2385 2395 2396 2385 2384 2386 2386 2384 2676 2386 2676 2696 2696 2710 2386 2386 2710 2392 2710 2707 2392 2392 2707 2393 2709 2706 2710 2710 2706 2707 2696 2709 2710 2696 2676 2681 2696 2681 2697 2697 2709 2696 2708 2702 2709 2709 2702 2706 2697 2708 2709 2702 2703 2706 2706 2703 2704 2706 2704 2707 2587 2585 2702 2585 2583 2702 2702 2583 2703 2708 2587 2702 2586 2585 2587 2586 2587 2588 2588 2587 2589 2589 2587 2708 2584 2583 2585 2584 2585 2586 2603 2584 2586 2603 2586 2604 2604 2586 2588 2588 2589 2590 2604 2588 2590 2590 2589 2415 2415 2589 2698 2698 2589 2708 2590 2415 2435 2607 2604 2590 2607 2590 2435 2435 2606 2607 2608 2607 2609 2609 2607 2606 2608 2604 2607 2609 2606 2610 2435 2619 2606 2606 2619 2620 2606 2620 2610 2612 2608 2609 2612 2609 2613 2613 2609 2610 2613 2610 2605 2610 2620 2621 2610 2621 2605 2619 2635 2620 2620 2635 2636 2620 2636 2621 2605 2621 2362 2621 2636 2637 2621 2637 2362 2605 2360 2365 2605 2365 2613 2605 2362 2360 2359 2360 2361 2361 2360 2362 2359 2363 2360 2360 2363 2364 2360 2364 2365 2365 2364 2366 2365 2366 2367 2613 2365 2367 2611 2366 2364 2611 2364 2614 2364 2363 2614 2614 2363 2622 2614 2615 2611 2622 2615 2614 2611 2608 2612 2612 2366 2611 2611 2615 2602 2611 2602 2608 2612 2367 2366 2613 2367 2612 2608 2602 2604 2602 2603 2604 2617 2603 2602 2617 2602 2618 2618 2602 2615 2622 2618 2615 2623 2618 2622 2623 2617 2618 2616 2603 2617 2616 2617 2623 2582 2584 2603 2616 2582 2603 2507 2582 2616 2507 2616 2506 2506 2616 2623 2623 2478 2476 2506 2623 2475 2475 2623 2476 2475 2482 2506 2506 2482 2484 2506 2484 2507 2507 2484 2582 2482 2483 2484 2484 2483 2485 2485 2492 2484 2484 2492 2493 2484 2493 2488 2582 2484 2488 3018 2492 2485 3018 2485 3019 3019 2485 2483 3017 2493 2492 3017 2492 3018 2488 2493 2494 3016 2494 2493 3016 2493 3017 3007 3016 3017 3007 3017 3008 3008 3017 3018 3008 3018 3009 3009 3018 3019 2994 3007 3008 2994 3008 2995 2995 3008 3009 2996 3006 3007 2996 3007 2994 3006 3016 3007 3006 3015 3016 3015 2494 3016 2992 3005 3006 2992 3006 2996 3005 3015 3006 2996 2994 2987 2992 2996 2987 2987 2994 2995 2995 2999 2987 2995 3009 2999 2999 2997 2987 2999 3009 3010 2999 3010 2997 2987 2997 2998 2997 3010 3011 2997 3011 2998 3009 3019 3010 3010 3019 3020 3010 3020 3011 2998 3011 3000 3011 3020 3021 3011 3021 3000 2998 2990 2987 2998 3000 2990 2990 3000 3001 3000 3021 3022 3000 3022 3001 3021 2490 3022 3020 2491 3021 3021 2491 2490 3019 2483 3020 3020 2483 2491 2482 2490 2491 2482 2491 2483 2481 2489 2490 2481 2490 2482 3022 2490 2489 3001 3022 3023 3022 2489 3023 2480 2489 2481 3023 2489 2480 3001 3023 3002 3002 3023 3012 3023 2480 3012 2479 2480 2481 3012 2480 2479 3002 3012 3003 3003 3012 3013 3012 2479 3013 2988 3001 3002 2988 3002 2989 2989 3002 3003 2989 3003 2993 2993 3003 3004 3003 3013 3004 3004 3013 3014 3013 2479 2487 3013 2487 3014 2993 3004 2991 2991 3004 3005 3004 3014 3005 2993 2991 2987 2989 2993 2987 2987 2988 2989 2990 2988 2987 2987 2991 2992 2991 3005 2992 3005 3014 3015 3014 2487 2486 3014 2486 3015 2486 2487 2488 2488 2487 2479 2488 2494 2486 3015 2486 2494 2479 2481 2488 2488 2481 2497 2488 2497 2516 2582 2488 2516 2516 2521 2582 2582 2521 2583 2582 2583 2584 2460 2591 2583 2460 2583 2528 2528 2583 2521 2583 2591 2703 2464 2591 2460 2591 2464 2703 2703 2464 2701 2703 2701 2704 2474 2692 2701 2474 2701 2457 2457 2701 2464 2472 2473 2474 2459 2472 2474 2459 2474 2457 2473 2692 2474 2473 2566 2692 2692 2566 2565 2566 2473 2472 2542 2557 2472 2542 2472 2459 2472 2557 2566 2565 2566 2567 2566 2557 2556 2566 2556 2567 2545 2556 2557 2545 2557 2542 2500 2555 2556 2500 2556 2545 2567 2556 2555 2567 2555 2568 2477 2554 2555 2477 2555 2500 2568 2555 2554 2568 2554 2478 2478 2554 2477 2477 2476 2478 2475 2476 2477 2477 2481 2475 2475 2481 2482 2477 2505 2481 2505 2508 2481 2481 2508 2509 2481 2509 2497 2504 2505 2477 3052 2508 2505 3052 2505 3053 3053 2505 2504 3051 2509 2508 3051 2508 3052 2497 2509 2510 3050 2510 2509 3050 2509 3051 3044 3050 3051 3044 3051 3045 3045 3051 3052 3045 3052 3046 3046 3052 3053 3031 3044 3045 3031 3045 3032 3032 3045 3046 3033 3043 3044 3033 3044 3031 3043 3050 3044 3043 3049 3050 3049 2510 3050 3029 3042 3043 3029 3043 3033 3042 3049 3043 3033 3031 3024 3029 3033 3024 3024 3031 3032 3032 3036 3024 3032 3046 3036 3036 3034 3024 3036 3046 3047 3036 3047 3034 3024 3034 3035 3034 3047 3048 3034 3048 3035 3046 3053 3047 3047 3053 3054 3047 3054 3048 3035 3048 3037 3048 3054 3055 3048 3055 3037 3035 3027 3024 3035 3037 3027 3027 3037 3038 3037 3055 3056 3037 3056 3038 3055 2502 3056 3054 2503 3055 3055 2503 2502 3053 2504 3054 3054 2504 2503 2477 2502 2503 2477 2503 2504 2500 2501 2502 2500 2502 2477 3056 2502 2501 3038 3056 3057 3056 2501 3057 2499 2501 2500 3057 2501 2499 2498 2499 2500 2545 2497 2500 2500 2497 2496 2500 2496 2498 3057 2499 3058 3058 2499 2498 3038 3057 3039 3039 3057 3058 3039 3058 3040 3040 3058 3059 3058 2498 3059 3059 2498 2496 2495 2496 2497 3059 2496 3060 3060 2496 2495 3040 3059 3041 3041 3059 3060 3026 3039 3040 3026 3040 3030 3030 3040 3041 3025 3038 3039 3025 3039 3026 3027 3038 3025 3024 3025 3026 3027 3025 3024 3026 3030 3024 3030 3028 3024 3030 3041 3028 3028 3041 3042 3041 3060 3042 3024 3028 3029 3028 3042 3029 3042 3060 3049 3060 2495 3049 3049 2495 2510 2497 2510 2495 2513 2518 2497 2497 2518 2519 2497 2519 2520 2516 2497 2520 2545 2513 2497 2981 2520 2519 2981 2519 2982 2982 2519 2518 2516 2520 2514 2980 2514 2520 2980 2520 2981 2973 2980 2981 2973 2981 2974 2974 2981 2982 2974 2982 2963 2963 2982 2983 2982 2518 2983 2960 2973 2974 2960 2974 2961 2961 2974 2963 2961 2963 2953 2953 2963 2964 2963 2983 2964 2964 2983 2984 2983 2518 2517 2983 2517 2984 2513 2517 2518 2512 2517 2513 2984 2517 2512 2964 2984 2965 2965 2984 2985 2984 2512 2985 2953 2964 2951 2951 2964 2965 2951 2965 2952 2952 2965 2966 2965 2985 2966 2966 2985 2986 2985 2512 2511 2985 2511 2986 2511 2512 2513 2521 2522 2511 2511 2513 2521 2986 2511 2522 2966 2986 2967 2967 2986 2975 2986 2522 2975 2952 2966 2956 2956 2966 2967 2956 2967 2954 2954 2967 2968 2967 2975 2968 2968 2975 2976 2975 2522 2525 2975 2525 2976 2521 2525 2522 2521 2524 2525 2976 2525 2524 2968 2976 2969 2969 2976 2977 2976 2524 2977 2954 2968 2955 2955 2968 2969 2950 2954 2955 2956 2954 2950 2952 2956 2950 2950 2951 2952 2953 2951 2950 2961 2953 2950 2950 2960 2961 2962 2960 2950 2962 2973 2960 2958 2962 2950 2958 2972 2962 2962 2972 2973 2972 2980 2973 2958 2971 2972 2971 2979 2972 2972 2979 2980 2950 2957 2958 2957 2971 2958 2957 2970 2971 2970 2978 2971 2971 2978 2979 2978 2515 2979 2979 2515 2514 2979 2514 2980 2970 2977 2978 2977 2523 2978 2978 2523 2515 2959 2969 2970 2959 2970 2957 2969 2977 2970 2959 2957 2950 2955 2959 2950 2955 2969 2959 2977 2524 2523 2515 2523 2516 2516 2523 2524 2514 2515 2516 2516 2524 2521 2521 2513 2532 2521 2532 2533 2533 2534 2521 2521 2534 2535 2521 2535 2528 3164 2534 2533 3164 2533 3165 3165 2533 2532 3163 2535 2534 3163 2534 3164 2528 2535 2536 3162 2536 2535 3162 2535 3163 3155 3162 3163 3155 3163 3156 3156 3163 3164 3156 3164 3157 3157 3164 3165 3142 3155 3156 3142 3156 3143 3143 3156 3157 3144 3154 3155 3144 3155 3142 3154 3162 3155 3154 3161 3162 3161 2536 3162 3140 3153 3154 3140 3154 3144 3153 3161 3154 3144 3142 3135 3140 3144 3135 3135 3142 3143 3143 3147 3135 3143 3157 3147 3147 3145 3135 3147 3157 3158 3147 3158 3145 3135 3145 3146 3145 3158 3159 3145 3159 3146 3157 3165 3158 3158 3165 3166 3158 3166 3159 3146 3159 3148 3159 3166 3167 3159 3167 3148 3146 3138 3135 3146 3148 3138 3138 3148 3149 3148 3167 3168 3148 3168 3149 3167 2538 3168 3166 2539 3167 3167 2539 2538 3165 2532 3166 3166 2532 2539 2513 2538 2539 2513 2539 2532 2531 2537 2538 2531 2538 2513 3168 2538 2537 3149 3168 3169 3168 2537 3169 2530 2537 2531 3169 2537 2530 3149 3169 3150 3150 3169 3170 3169 2530 3170 2529 2530 2531 3170 2530 2529 3150 3170 3151 3151 3170 3171 3170 2529 3171 3136 3149 3150 3136 3150 3137 3137 3150 3151 3137 3151 3141 3141 3151 3152 3151 3171 3152 3152 3171 3160 3171 2529 2527 3171 2527 3160 3141 3152 3139 3139 3152 3153 3152 3160 3153 3141 3139 3135 3137 3141 3135 3135 3136 3137 3138 3136 3135 3135 3139 3140 3139 3153 3140 3153 3160 3161 3160 2527 2526 3160 2526 3161 2526 2527 2528 2527 2529 2528 2528 2536 2526 3161 2526 2536 2528 2458 2460 2528 2529 2531 2528 2531 2458 2457 2456 2458 2457 2458 2459 2456 2466 2458 2458 2466 2467 2458 2467 2468 2460 2458 2468 2458 2531 2550 2550 2551 2458 2458 2551 2552 2458 2552 2459 3132 2466 3133 3133 2466 2456 3132 2467 2466 3131 2468 2467 3131 2467 3132 3122 3131 3132 3122 3132 3111 3111 3132 3133 3111 3133 3112 3112 3133 3134 3133 2456 3134 3109 3111 3101 3101 3111 3112 3109 3122 3111 3101 3112 3099 3099 3112 3113 3112 3134 3113 3113 3134 3123 3134 2456 2455 3134 2455 3123 2455 2456 2457 2455 2457 2463 3123 2455 2463 3113 3123 3114 3114 3123 3124 3123 2463 3124 3099 3113 3100 3100 3113 3114 3100 3114 3104 3104 3114 3115 3114 3124 3115 3115 3124 3125 3124 2463 2465 3124 2465 3125 2463 2457 2464 2463 2464 2465 2464 2471 2465 3125 2465 2471 3115 3125 3116 3116 3125 3126 3125 2471 3126 3104 3115 3102 3102 3115 3116 3102 3116 3103 3103 3116 3117 3116 3126 3117 3117 3126 3127 3126 2471 2470 3126 2470 3127 2464 2470 2471 2460 2470 2464 2460 2469 2470 3127 2470 2469 3117 3127 3118 3118 3127 3128 3127 2469 3128 3103 3117 3107 3107 3117 3118 3107 3118 3105 3105 3118 3119 3118 3128 3119 3119 3128 3129 3128 2469 2462 3128 2462 3129 2462 2469 2460 2460 2461 2462 3129 2462 2461 2460 2468 2461 3129 2461 3130 3130 2461 2468 3119 3129 3120 3120 3129 3130 3105 3119 3106 3106 3119 3120 3106 3120 3110 3110 3120 3121 3120 3130 3121 3121 3130 3131 3130 2468 3131 3110 3121 3108 3108 3121 3122 3121 3131 3122 3110 3108 3098 3106 3110 3098 3098 3105 3106 3107 3105 3098 3103 3107 3098 3098 3102 3103 3104 3102 3098 3100 3104 3098 3098 3099 3100 3101 3099 3098 3109 3101 3098 3098 3108 3109 3108 3122 3109 2546 2542 2459 2546 2459 2547 2459 2552 2553 2459 2553 2547 3094 2546 2547 3094 2547 3095 3095 2547 2553 3095 2553 3096 3096 2553 2552 3096 2552 3097 3097 2552 2551 3077 3095 3096 3077 3096 3078 3078 3096 3097 3076 3094 3095 3076 3095 3077 3063 3076 3077 3063 3077 3067 3067 3077 3078 3067 3078 3065 3065 3078 3079 3078 3097 3079 3067 3065 3061 3063 3067 3061 3061 3062 3063 3062 3076 3063 3062 3075 3076 3075 3094 3076 3064 3062 3061 3064 3075 3062 3064 3074 3075 3074 3093 3075 3075 3093 3094 3093 2546 3094 3074 3092 3093 3092 2540 3093 3093 2540 2546 3072 3074 3064 3072 3085 3074 3085 3092 3074 3072 3064 3061 3061 3071 3072 3071 3085 3072 3071 3084 3085 3084 3091 3085 3085 3091 3092 3091 2541 3092 3092 2541 2540 2540 2541 2542 2540 2542 2546 2542 2541 2543 3091 2543 2541 3084 3090 3091 3090 2543 3091 3073 3083 3084 3073 3084 3071 3083 3090 3084 3073 3071 3061 3069 3073 3061 3069 3083 3073 3069 3082 3083 3082 3089 3083 3083 3089 3090 3089 2544 3090 3090 2544 2543 2542 2543 2544 2544 2531 2542 2544 2548 2531 3089 2548 2544 3082 3088 3089 3088 2548 3089 3068 3081 3082 3068 3082 3069 3081 3088 3082 3061 3068 3069 3070 3068 3061 3070 3081 3068 3070 3080 3081 3080 3087 3081 3081 3087 3088 3087 2549 3088 3088 2549 2548 2531 2548 2549 2531 2549 2550 3087 2550 2549 2542 2531 2513 2542 2513 2545 3086 2551 2550 3086 2550 3087 3080 3086 3087 3079 3086 3080 3079 3097 3086 3097 2551 3086 3065 3079 3066 3066 3079 3080 3061 3065 3066 3066 3070 3061 3066 3080 3070 3138 3149 3136 2990 3001 2988 2645 2643 2359 2359 2361 2648 2359 2648 2645 2645 2642 2643 2644 2642 2645 2645 2648 2649 2645 2649 2644 2653 2649 2648 2653 2648 2373 2373 2648 2361 2644 2649 2376 2652 2376 2649 2652 2649 2653 2378 2570 2644 2644 2570 2642 2644 2376 2378 2570 2564 2642 2570 2378 2379 2570 2379 2564 2376 2377 2378 2378 2377 2379 2564 2379 2571 2379 2377 2664 2379 2664 2671 2379 2671 2688 2688 2571 2379 2376 2574 2377 2377 2574 2664 2664 2574 2662 2664 2662 2665 2671 2664 2665 2671 2665 2672 2690 2688 2671 2690 2671 2672 2689 2688 2690 2399 2689 2690 2399 2690 2397 2397 2690 2672 2672 2665 2383 2672 2383 2385 2397 2672 2385 2665 2662 2663 2665 2663 2383 2662 2656 2663 2663 2656 2661 2663 2661 2380 2383 2663 2380 2656 2657 2661 2661 2657 2659 2661 2659 2381 2380 2661 2381 2380 2381 2382 2380 2382 2383 2381 2659 2382 2657 2658 2659 2659 2658 2660 2659 2660 2382 2383 2382 2387 2382 2660 2387 2666 2387 2660 2666 2660 2667 2667 2660 2668 2668 2660 2658 2383 2387 2384 2384 2387 2388 2388 2387 2666 2682 2388 2666 2666 2667 2682 2682 2667 2673 2668 2673 2667 2668 2658 2669 2669 2673 2668 2673 2674 2675 2682 2673 2679 2679 2673 2675 2669 2674 2673 2682 2679 2683 2683 2390 2682 2682 2390 2388 2679 2678 2680 2683 2679 2680 2679 2675 2678 2683 2680 2684 2684 2391 2683 2683 2391 2390 2389 2388 2390 2389 2390 2391 2684 2389 2391 2684 2680 2681 2684 2681 2676 2676 2389 2684 2680 2678 2677 2680 2677 2681 2697 2681 2677 2417 2677 2678 2697 2677 2698 2698 2677 2417 2698 2708 2697 2698 2417 2415 2416 2415 2417 2416 2417 2418 2447 2448 2417 2417 2448 2449 2417 2449 2418 2442 2447 2417 2442 2417 2424 2424 2417 2592 2678 2592 2417 2849 2418 2449 2849 2449 2850 2850 2449 2448 2845 2848 2849 2845 2849 2844 2844 2849 2850 2848 2418 2849 2844 2850 2843 2843 2850 2851 2850 2448 2851 2842 2724 2843 2843 2724 2719 2843 2719 2844 2843 2851 2842 2842 2851 2852 2851 2448 2447 2851 2447 2852 2842 2852 2841 2841 2852 2853 2852 2447 2453 2852 2453 2853 2454 2453 2447 2454 2447 2442 2452 2451 2453 2452 2453 2454 2853 2453 2451 2841 2853 2840 2840 2853 2854 2853 2451 2854 2412 2450 2451 2412 2451 2452 2854 2451 2450 2883 2412 2452 2883 2452 2884 2884 2452 2454 2879 2882 2883 2879 2883 2878 2878 2883 2884 2882 2412 2883 2878 2884 2877 2877 2884 2885 2884 2454 2885 2877 2759 2878 2759 2758 2878 2878 2758 2754 2878 2754 2879 2876 2764 2877 2877 2764 2759 2877 2885 2876 2755 2758 2759 2755 2759 2760 2764 2760 2759 2754 2758 2755 2754 2755 2756 2754 2756 2879 2756 2755 2752 2755 2760 2752 2763 2762 2760 2763 2760 2764 2752 2760 2762 2876 2763 2764 2761 2762 2763 2761 2763 2876 2761 2765 2762 2875 2765 2761 2875 2761 2876 2762 2765 2766 2766 2765 2875 2874 2766 2875 2876 2886 2875 2875 2886 2887 2875 2887 2874 2762 2766 2767 2766 2768 2767 2874 2768 2766 2873 2768 2874 2874 2887 2888 2874 2888 2873 2886 2441 2887 2887 2441 2426 2887 2426 2888 2873 2888 2889 2888 2426 2425 2888 2425 2889 2425 2426 2427 2426 2441 2427 2424 2441 2442 2427 2441 2424 2886 2442 2441 2885 2454 2442 2885 2442 2886 2876 2885 2886 2422 2423 2424 2435 2436 2424 2424 2436 2437 2424 2437 2422 2427 2424 2446 2446 2424 2423 2424 2592 2593 2435 2424 2619 2424 2593 2619 2940 2422 2437 2940 2437 2941 2941 2437 2436 2923 2939 2940 2923 2940 2924 2924 2940 2941 2939 2422 2940 2924 2941 2925 2925 2941 2942 2941 2436 2942 2906 2923 2924 2906 2924 2905 2905 2924 2925 2905 2925 2904 2904 2925 2926 2925 2942 2926 2926 2942 2943 2942 2436 2434 2942 2434 2943 2435 2434 2436 2433 2434 2435 2943 2434 2433 2926 2943 2927 2927 2943 2944 2943 2433 2944 2904 2926 2903 2903 2926 2927 2903 2927 2902 2902 2927 2928 2927 2944 2928 2928 2944 2945 2944 2433 2445 2944 2445 2945 2435 2445 2433 2435 2432 2445 2945 2445 2432 2415 2432 2435 2430 2431 2432 2415 2430 2432 2945 2432 2946 2946 2432 2431 2928 2945 2929 2929 2945 2946 2929 2946 2930 2930 2946 2947 2946 2431 2947 2430 2429 2431 2947 2431 2429 2930 2947 2931 2931 2947 2948 2947 2429 2948 2899 2929 2930 2899 2930 2900 2900 2930 2931 2901 2928 2929 2901 2929 2899 2899 2900 2828 2828 2826 2899 2899 2826 2825 2899 2825 2901 2901 2825 2823 2901 2823 2902 2902 2928 2901 2823 2825 2824 2824 2825 2826 2824 2826 2827 2826 2828 2827 2827 2828 2829 2900 2829 2828 2827 2829 2793 2807 2827 2793 2824 2827 2819 2819 2827 2807 2819 2823 2824 2819 2822 2823 2823 2822 2902 2902 2822 2818 2902 2818 2903 2818 2822 2819 2818 2819 2820 2820 2819 2817 2819 2807 2817 2818 2820 2903 2903 2820 2821 2903 2821 2904 2820 2817 2821 2812 2816 2817 2821 2817 2816 2817 2807 2812 2904 2821 2816 2904 2816 2905 2812 2815 2816 2816 2815 2905 2811 2812 2813 2813 2812 2810 2811 2815 2812 2807 2810 2812 2905 2815 2811 2905 2811 2906 2811 2813 2906 2813 2810 2814 2906 2813 2814 2807 2809 2810 2814 2810 2809 2906 2814 2907 2814 2809 2907 2907 2923 2906 2907 2809 2808 2907 2808 2908 2908 2922 2907 2907 2922 2923 2807 2808 2809 2806 2808 2807 2908 2808 2806 2908 2806 2909 2909 2921 2908 2908 2921 2922 2921 2938 2922 2922 2938 2939 2922 2939 2923 2909 2920 2921 2920 2937 2921 2921 2937 2938 2937 2446 2938 2938 2446 2423 2938 2423 2939 2939 2423 2422 2937 2427 2446 2920 2936 2937 2936 2427 2937 2425 2427 2438 2438 2427 2439 2936 2439 2427 2919 2935 2936 2919 2936 2920 2935 2439 2936 2438 2439 2404 2404 2439 2440 2935 2440 2439 2889 2425 2438 2889 2438 2890 2890 2438 2404 2404 2405 2406 2404 2440 2405 2890 2404 2891 2891 2404 2406 2934 2405 2440 2934 2440 2935 2406 2405 2407 2933 2405 2934 2933 2407 2405 2406 2407 2408 2891 2406 2892 2892 2406 2408 2871 2890 2891 2871 2891 2870 2870 2891 2892 2870 2892 2869 2869 2892 2893 2892 2408 2893 2408 2407 2409 2893 2408 2409 2869 2893 2868 2868 2893 2894 2893 2409 2894 2407 2428 2409 2409 2428 2429 2409 2429 2430 2894 2409 2430 2868 2894 2867 2867 2894 2895 2894 2430 2895 2421 2444 2430 2421 2430 2415 2895 2430 2444 2867 2895 2865 2865 2895 2896 2895 2444 2896 2403 2443 2444 2403 2444 2421 2896 2444 2443 2865 2896 2866 2866 2896 2897 2896 2443 2897 2402 2443 2403 2897 2443 2402 2866 2897 2881 2881 2897 2898 2897 2402 2898 2400 2401 2402 2400 2402 2403 2898 2402 2401 2881 2898 2880 2880 2898 2882 2898 2401 2882 2880 2751 2881 2881 2751 2790 2881 2790 2866 2879 2757 2880 2880 2757 2751 2880 2882 2879 2882 2401 2412 2401 2411 2412 2412 2411 2413 2413 2450 2412 2401 2410 2411 2856 2413 2411 2856 2411 2857 2857 2411 2410 2855 2450 2413 2855 2413 2856 2854 2450 2855 2839 2854 2855 2839 2855 2838 2838 2855 2856 2838 2856 2837 2837 2856 2857 2837 2857 2836 2836 2857 2858 2857 2410 2858 2836 2736 2837 2736 2735 2837 2837 2735 2731 2837 2731 2838 2835 2741 2836 2836 2741 2736 2836 2858 2835 2835 2858 2859 2858 2410 2400 2858 2400 2859 2835 2859 2834 2834 2859 2860 2859 2400 2403 2859 2403 2860 2400 2410 2401 2834 2860 2833 2833 2860 2861 2860 2403 2421 2860 2421 2861 2831 2745 2833 2833 2745 2743 2833 2743 2834 2833 2861 2831 2831 2861 2862 2861 2421 2420 2861 2420 2862 2415 2420 2421 2415 2419 2420 2862 2420 2419 2831 2862 2832 2832 2862 2863 2862 2419 2863 2414 2419 2415 2863 2419 2414 2414 2415 2416 2863 2414 2864 2864 2414 2416 2832 2863 2847 2847 2863 2864 2847 2864 2846 2846 2864 2848 2864 2416 2848 2848 2416 2418 2846 2848 2845 2845 2717 2846 2846 2717 2711 2846 2711 2847 2847 2711 2750 2847 2750 2832 2711 2712 2713 2717 2712 2711 2713 2750 2711 2716 2712 2717 2845 2716 2717 2844 2714 2845 2714 2716 2845 2714 2715 2716 2716 2715 2712 2715 2713 2712 2714 2718 2715 2715 2718 2719 2715 2719 2720 2720 2722 2715 2715 2722 2713 2844 2718 2714 2719 2718 2844 2724 2720 2719 2723 2722 2720 2723 2720 2724 2842 2723 2724 2721 2722 2723 2721 2723 2842 2841 2721 2842 2721 2725 2722 2841 2725 2721 2840 2726 2841 2726 2725 2841 2722 2725 2726 2722 2726 2727 2726 2728 2727 2840 2728 2726 2839 2728 2840 2840 2854 2839 2727 2728 2729 2839 2729 2728 2838 2734 2839 2734 2729 2839 2727 2729 2730 2734 2730 2729 2733 2730 2734 2838 2733 2734 2731 2733 2838 2731 2732 2733 2733 2732 2730 2730 2732 2727 2731 2735 2732 2732 2735 2736 2732 2736 2737 2737 2739 2732 2732 2739 2744 2727 2732 2744 2741 2737 2736 2740 2739 2737 2740 2737 2741 2835 2740 2741 2738 2739 2740 2738 2740 2835 2834 2738 2835 2738 2742 2739 2834 2742 2738 2743 2742 2834 2739 2742 2743 2739 2743 2744 2743 2745 2744 2744 2745 2746 2831 2746 2745 2744 2746 2747 2746 2748 2747 2748 2746 2831 2831 2832 2748 2747 2748 2749 2832 2749 2748 2747 2749 2713 2722 2744 2747 2722 2747 2713 2713 2749 2750 2832 2750 2749 2727 2744 2722 2879 2756 2757 2756 2752 2757 2757 2752 2751 2751 2752 2753 2752 2762 2753 2753 2790 2751 2753 2789 2790 2866 2790 2789 2787 2788 2789 2787 2789 2753 2866 2789 2788 2865 2866 2788 2786 2788 2787 2788 2786 2865 2784 2786 2787 2784 2787 2753 2784 2785 2786 2865 2786 2785 2865 2785 2867 2783 2785 2784 2867 2785 2783 2779 2783 2784 2779 2784 2777 2777 2784 2753 2779 2782 2783 2867 2783 2868 2783 2782 2868 2778 2779 2780 2780 2779 2777 2778 2782 2779 2868 2782 2778 2868 2778 2869 2778 2780 2869 2780 2777 2781 2869 2780 2781 2869 2781 2870 2781 2777 2776 2870 2781 2776 2870 2776 2871 2772 2775 2776 2772 2776 2777 2776 2775 2871 2871 2775 2771 2871 2771 2872 2872 2890 2871 2771 2775 2772 2771 2772 2773 2771 2773 2872 2872 2773 2774 2872 2774 2873 2873 2889 2872 2872 2889 2890 2773 2772 2770 2773 2770 2774 2774 2770 2769 2774 2769 2873 2873 2769 2768 2767 2768 2769 2767 2769 2770 2762 2767 2770 2753 2762 2770 2772 2753 2770 2777 2753 2772 2948 2429 2428 2931 2948 2932 2932 2948 2949 2948 2428 2949 2949 2428 2407 2932 2949 2916 2916 2949 2933 2949 2407 2933 2915 2931 2932 2915 2932 2914 2914 2932 2916 2900 2931 2915 2914 2791 2915 2915 2791 2830 2915 2830 2900 2913 2797 2914 2914 2797 2791 2914 2916 2913 2791 2792 2793 2797 2792 2791 2793 2830 2791 2793 2829 2830 2900 2830 2829 2792 2807 2793 2796 2795 2792 2796 2792 2797 2795 2807 2792 2913 2796 2797 2794 2795 2796 2794 2796 2913 2794 2798 2795 2795 2798 2799 2795 2799 2800 2800 2802 2795 2795 2802 2807 2802 2806 2807 2801 2802 2803 2803 2802 2800 2801 2805 2802 2802 2805 2806 2803 2800 2804 2804 2800 2799 2801 2803 2910 2910 2803 2804 2909 2805 2801 2909 2801 2910 2806 2805 2909 2910 2920 2909 2910 2804 2911 2911 2919 2910 2910 2919 2920 2911 2804 2799 2911 2799 2912 2912 2918 2911 2911 2918 2919 2918 2935 2919 2912 2917 2918 2917 2934 2918 2918 2934 2935 2913 2916 2917 2913 2917 2912 2916 2933 2917 2917 2933 2934 2912 2794 2913 2912 2798 2794 2799 2798 2912 2619 2593 2635 2593 2592 2594 2593 2594 2595 2593 2595 2635 2635 2595 2624 2635 2624 2636 2595 2594 2596 2595 2596 2597 2595 2597 2624 2675 2596 2594 2675 2594 2592 2678 2675 2592 2674 2596 2675 2597 2596 2598 2674 2598 2596 2597 2598 2599 2597 2599 2624 2599 2598 2600 2600 2598 2674 2670 2600 2674 2670 2674 2669 2599 2600 2601 2601 2600 2559 2559 2600 2670 2599 2601 2625 2624 2599 2625 2601 2559 2558 2625 2601 2558 2558 2559 2560 2560 2559 2561 2670 2561 2559 2558 2630 2625 2558 2560 2630 2579 2560 2561 2630 2560 2647 2560 2579 2647 2581 2579 2561 2581 2561 2657 2657 2561 2658 2670 2658 2561 2578 2579 2581 2578 2581 2657 2656 2578 2657 2577 2576 2578 2576 2580 2578 2578 2580 2579 2577 2578 2656 2573 2577 2656 2662 2573 2656 2573 2576 2577 2573 2575 2576 2576 2575 2651 2580 2576 2650 2650 2576 2651 2579 2580 2650 2650 2651 2655 2647 2579 2650 2647 2650 2646 2646 2650 2655 2655 2651 2654 2655 2654 2374 2646 2655 2372 2372 2655 2374 2372 2626 2646 2626 2628 2646 2646 2628 2632 2646 2632 2647 2630 2647 2631 2631 2647 2632 2629 2631 2632 2629 2632 2628 2626 2627 2628 2628 2627 2629 2625 2631 2629 2633 2625 2629 2633 2629 2634 2634 2629 2627 2625 2630 2631 2624 2625 2633 2636 2624 2633 2636 2633 2637 2637 2633 2634 2634 2627 2369 2637 2634 2368 2368 2634 2369 2362 2637 2368 2368 2369 2370 2368 2370 2362 2369 2627 2370 2362 2370 2371 2371 2370 2626 2626 2370 2627 2362 2371 2361 2361 2371 2372 2371 2626 2372 2361 2372 2373 2373 2372 2374 2373 2374 2375 2375 2653 2373 2374 2654 2375 2654 2653 2375 2654 2652 2653 2651 2652 2654 2572 2376 2652 2651 2572 2652 2575 2572 2651 2572 2573 2376 2572 2575 2573 2376 2573 2574 2574 2573 2662 2669 2658 2670 2384 2388 2389 2676 2384 2389 2383 2384 2385 2385 2396 2397 2397 2396 2398 2396 2691 2398 2397 2398 2399 2398 2689 2399 2398 2691 2685 2398 2685 2689 3172 3173 3174 3185 3186 3172 3172 3186 3187 3172 3187 3173 3174 3295 3172 3172 3295 3297 3172 3297 3185 3185 3184 3186 3184 3298 3186 3186 3298 3296 3186 3296 3187 3187 3296 3294 3187 3294 3173 3295 3294 3296 3295 3296 3297 3297 3296 3298 3292 3294 3295 3174 3292 3295 3292 3293 3294 3173 3294 3293 3290 3291 3292 3291 3293 3292 3176 3290 3292 3176 3292 3174 3173 3293 3175 3175 3293 3291 3174 3173 3175 3174 3175 3176 3176 3175 3177 3176 3177 3178 3178 3290 3176 3175 3291 3177 3290 3289 3291 3177 3291 3289 3288 3289 3290 3178 3288 3290 3178 3177 3179 3178 3179 3180 3180 3288 3178 3177 3289 3179 3288 3287 3289 3179 3289 3287 3286 3287 3288 3180 3286 3288 3179 3229 3180 3180 3229 3230 3180 3230 3231 3231 3286 3180 3179 3287 3229 3286 3285 3287 3229 3287 3285 3249 3285 3286 3231 3249 3286 3231 3230 3232 3231 3232 3233 3233 3249 3231 3229 3285 3230 3230 3285 3284 3230 3284 3232 3249 3284 3285 3247 3248 3249 3248 3284 3249 3233 3247 3249 3233 3232 3234 3233 3234 3204 3204 3247 3233 3232 3284 3248 3232 3248 3234 3247 3246 3248 3234 3248 3246 3245 3246 3247 3204 3245 3247 3204 3205 3206 3204 3234 3235 3204 3235 3205 3206 3245 3204 3234 3246 3235 3245 3244 3246 3235 3246 3244 3243 3244 3245 3206 3243 3245 3206 3205 3207 3206 3207 3208 3208 3243 3206 3272 3273 3243 3243 3273 3274 3243 3274 3244 3208 3272 3243 3235 3244 3205 3205 3244 3274 3205 3274 3207 3208 3207 3209 3207 3274 3273 3207 3273 3209 3208 3209 3210 3210 3272 3208 3270 3271 3272 3272 3271 3273 3210 3270 3272 3209 3273 3271 3210 3209 3211 3209 3271 3211 3210 3211 3212 3212 3270 3210 3268 3269 3270 3270 3269 3271 3212 3268 3270 3211 3271 3269 3211 3222 3212 3211 3269 3222 3212 3222 3223 3212 3223 3224 3224 3268 3212 3242 3267 3268 3268 3267 3269 3224 3242 3268 3222 3269 3267 3222 3267 3223 3224 3223 3225 3223 3267 3266 3223 3266 3225 3224 3225 3226 3226 3242 3224 3226 3225 3227 3225 3241 3227 3225 3266 3241 3241 3266 3242 3242 3266 3267 3240 3241 3242 3226 3240 3242 3226 3227 3195 3195 3240 3226 3195 3227 3228 3227 3241 3239 3227 3239 3228 3240 3239 3241 3238 3239 3240 3195 3238 3240 3195 3196 3197 3195 3228 3196 3197 3238 3195 3228 3239 3237 3228 3237 3196 3238 3237 3239 3236 3237 3238 3197 3236 3238 3197 3196 3198 3197 3198 3199 3199 3236 3197 3196 3237 3258 3196 3258 3198 3236 3258 3237 3256 3257 3236 3236 3257 3258 3199 3256 3236 3199 3198 3200 3199 3200 3201 3201 3256 3199 3198 3258 3257 3198 3257 3200 3256 3255 3257 3200 3257 3255 3254 3255 3256 3201 3254 3256 3201 3200 3202 3201 3202 3188 3188 3254 3201 3200 3255 3202 3254 3253 3255 3202 3255 3253 3252 3253 3254 3188 3252 3254 3188 3189 3190 3188 3202 3203 3188 3203 3189 3190 3252 3188 3202 3253 3203 3252 3251 3253 3203 3253 3251 3250 3251 3252 3190 3250 3252 3190 3189 3191 3190 3191 3192 3192 3250 3190 3263 3264 3250 3250 3264 3265 3250 3265 3251 3192 3263 3250 3203 3251 3189 3189 3251 3265 3189 3265 3191 3192 3191 3193 3191 3265 3264 3191 3264 3193 3192 3193 3194 3194 3263 3192 3261 3262 3263 3263 3262 3264 3194 3261 3263 3193 3264 3262 3193 3213 3194 3193 3262 3213 3194 3213 3214 3194 3214 3215 3215 3261 3194 3259 3260 3261 3261 3260 3262 3215 3259 3261 3213 3262 3260 3213 3260 3214 3215 3214 3216 3214 3260 3283 3214 3283 3216 3215 3216 3217 3217 3259 3215 3217 3216 3218 3216 3283 3282 3216 3282 3218 3259 3282 3283 3259 3283 3260 3281 3282 3259 3217 3281 3259 3217 3218 3219 3219 3281 3217 3219 3218 3220 3218 3282 3280 3218 3280 3220 3281 3280 3282 3279 3280 3281 3219 3279 3281 3219 3220 3181 3181 3279 3219 3181 3220 3221 3220 3280 3278 3220 3278 3221 3279 3278 3280 3277 3278 3279 3181 3277 3279 3181 3182 3183 3181 3221 3182 3183 3277 3181 3221 3278 3276 3221 3276 3182 3277 3276 3278 3275 3276 3277 3183 3275 3277 3183 3182 3184 3183 3184 3185 3185 3275 3183 3182 3276 3299 3182 3299 3184 3275 3299 3276 3297 3298 3275 3275 3298 3299 3185 3297 3275 3184 3299 3298 3300 3301 3302 3313 3314 3300 3300 3314 3315 3300 3315 3301 3302 3423 3300 3300 3423 3425 3300 3425 3313 3313 3312 3314 3312 3426 3314 3314 3426 3424 3314 3424 3315 3315 3424 3422 3315 3422 3301 3423 3422 3424 3423 3424 3425 3425 3424 3426 3420 3422 3423 3302 3420 3423 3420 3421 3422 3301 3422 3421 3418 3419 3420 3419 3421 3420 3304 3418 3420 3304 3420 3302 3301 3421 3303 3303 3421 3419 3302 3301 3303 3302 3303 3304 3304 3303 3305 3304 3305 3306 3306 3418 3304 3303 3419 3305 3418 3417 3419 3305 3419 3417 3416 3417 3418 3306 3416 3418 3306 3305 3307 3306 3307 3308 3308 3416 3306 3305 3417 3307 3416 3415 3417 3307 3417 3415 3414 3415 3416 3308 3414 3416 3307 3357 3308 3308 3357 3358 3308 3358 3359 3359 3414 3308 3307 3415 3357 3414 3413 3415 3357 3415 3413 3377 3413 3414 3359 3377 3414 3359 3358 3360 3359 3360 3361 3361 3377 3359 3357 3413 3358 3358 3413 3412 3358 3412 3360 3377 3412 3413 3375 3376 3377 3376 3412 3377 3361 3375 3377 3361 3360 3362 3361 3362 3332 3332 3375 3361 3360 3412 3376 3360 3376 3362 3375 3374 3376 3362 3376 3374 3373 3374 3375 3332 3373 3375 3332 3333 3334 3332 3362 3363 3332 3363 3333 3334 3373 3332 3362 3374 3363 3373 3372 3374 3363 3374 3372 3371 3372 3373 3334 3371 3373 3334 3333 3335 3334 3335 3336 3336 3371 3334 3400 3401 3371 3371 3401 3402 3371 3402 3372 3336 3400 3371 3363 3372 3333 3333 3372 3402 3333 3402 3335 3336 3335 3337 3335 3402 3401 3335 3401 3337 3336 3337 3338 3338 3400 3336 3398 3399 3400 3400 3399 3401 3338 3398 3400 3337 3401 3399 3338 3337 3339 3337 3399 3339 3338 3339 3340 3340 3398 3338 3396 3397 3398 3398 3397 3399 3340 3396 3398 3339 3399 3397 3339 3350 3340 3339 3397 3350 3340 3350 3351 3340 3351 3352 3352 3396 3340 3370 3395 3396 3396 3395 3397 3352 3370 3396 3350 3397 3395 3350 3395 3351 3352 3351 3353 3351 3395 3394 3351 3394 3353 3352 3353 3354 3354 3370 3352 3354 3353 3355 3353 3369 3355 3353 3394 3369 3369 3394 3370 3370 3394 3395 3368 3369 3370 3354 3368 3370 3354 3355 3323 3323 3368 3354 3323 3355 3356 3355 3369 3367 3355 3367 3356 3368 3367 3369 3366 3367 3368 3323 3366 3368 3323 3324 3325 3323 3356 3324 3325 3366 3323 3356 3367 3365 3356 3365 3324 3366 3365 3367 3364 3365 3366 3325 3364 3366 3325 3324 3326 3325 3326 3327 3327 3364 3325 3324 3365 3386 3324 3386 3326 3364 3386 3365 3384 3385 3364 3364 3385 3386 3327 3384 3364 3327 3326 3328 3327 3328 3329 3329 3384 3327 3326 3386 3385 3326 3385 3328 3384 3383 3385 3328 3385 3383 3382 3383 3384 3329 3382 3384 3329 3328 3330 3329 3330 3316 3316 3382 3329 3328 3383 3330 3382 3381 3383 3330 3383 3381 3380 3381 3382 3316 3380 3382 3316 3317 3318 3316 3330 3331 3316 3331 3317 3318 3380 3316 3330 3381 3331 3380 3379 3381 3331 3381 3379 3378 3379 3380 3318 3378 3380 3318 3317 3319 3318 3319 3320 3320 3378 3318 3391 3392 3378 3378 3392 3393 3378 3393 3379 3320 3391 3378 3331 3379 3317 3317 3379 3393 3317 3393 3319 3320 3319 3321 3319 3393 3392 3319 3392 3321 3320 3321 3322 3322 3391 3320 3389 3390 3391 3391 3390 3392 3322 3389 3391 3321 3392 3390 3321 3341 3322 3321 3390 3341 3322 3341 3342 3322 3342 3343 3343 3389 3322 3387 3388 3389 3389 3388 3390 3343 3387 3389 3341 3390 3388 3341 3388 3342 3343 3342 3344 3342 3388 3411 3342 3411 3344 3343 3344 3345 3345 3387 3343 3345 3344 3346 3344 3411 3410 3344 3410 3346 3387 3410 3411 3387 3411 3388 3409 3410 3387 3345 3409 3387 3345 3346 3347 3347 3409 3345 3347 3346 3348 3346 3410 3408 3346 3408 3348 3409 3408 3410 3407 3408 3409 3347 3407 3409 3347 3348 3309 3309 3407 3347 3309 3348 3349 3348 3408 3406 3348 3406 3349 3407 3406 3408 3405 3406 3407 3309 3405 3407 3309 3310 3311 3309 3349 3310 3311 3405 3309 3349 3406 3404 3349 3404 3310 3405 3404 3406 3403 3404 3405 3311 3403 3405 3311 3310 3312 3311 3312 3313 3313 3403 3311 3310 3404 3427 3310 3427 3312 3403 3427 3404 3425 3426 3403 3403 3426 3427 3313 3425 3403 3312 3427 3426 3428 3429 3430 3441 3442 3428 3428 3442 3443 3428 3443 3429 3430 3551 3428 3428 3551 3553 3428 3553 3441 3441 3440 3442 3440 3554 3442 3442 3554 3552 3442 3552 3443 3443 3552 3550 3443 3550 3429 3551 3550 3552 3551 3552 3553 3553 3552 3554 3548 3550 3551 3430 3548 3551 3548 3549 3550 3429 3550 3549 3546 3547 3548 3547 3549 3548 3432 3546 3548 3432 3548 3430 3429 3549 3431 3431 3549 3547 3430 3429 3431 3430 3431 3432 3432 3431 3433 3432 3433 3434 3434 3546 3432 3431 3547 3433 3546 3545 3547 3433 3547 3545 3544 3545 3546 3434 3544 3546 3434 3433 3435 3434 3435 3436 3436 3544 3434 3433 3545 3435 3544 3543 3545 3435 3545 3543 3542 3543 3544 3436 3542 3544 3435 3485 3436 3436 3485 3486 3436 3486 3487 3487 3542 3436 3435 3543 3485 3542 3541 3543 3485 3543 3541 3505 3541 3542 3487 3505 3542 3487 3486 3488 3487 3488 3489 3489 3505 3487 3485 3541 3486 3486 3541 3540 3486 3540 3488 3505 3540 3541 3503 3504 3505 3504 3540 3505 3489 3503 3505 3489 3488 3490 3489 3490 3460 3460 3503 3489 3488 3540 3504 3488 3504 3490 3503 3502 3504 3490 3504 3502 3501 3502 3503 3460 3501 3503 3460 3461 3462 3460 3490 3491 3460 3491 3461 3462 3501 3460 3490 3502 3491 3501 3500 3502 3491 3502 3500 3499 3500 3501 3462 3499 3501 3462 3461 3463 3462 3463 3464 3464 3499 3462 3528 3529 3499 3499 3529 3530 3499 3530 3500 3464 3528 3499 3491 3500 3461 3461 3500 3530 3461 3530 3463 3464 3463 3465 3463 3530 3529 3463 3529 3465 3464 3465 3466 3466 3528 3464 3526 3527 3528 3528 3527 3529 3466 3526 3528 3465 3529 3527 3466 3465 3467 3465 3527 3467 3466 3467 3468 3468 3526 3466 3524 3525 3526 3526 3525 3527 3468 3524 3526 3467 3527 3525 3467 3478 3468 3467 3525 3478 3468 3478 3479 3468 3479 3480 3480 3524 3468 3498 3523 3524 3524 3523 3525 3480 3498 3524 3478 3525 3523 3478 3523 3479 3480 3479 3481 3479 3523 3522 3479 3522 3481 3480 3481 3482 3482 3498 3480 3482 3481 3483 3481 3497 3483 3481 3522 3497 3497 3522 3498 3498 3522 3523 3496 3497 3498 3482 3496 3498 3482 3483 3451 3451 3496 3482 3451 3483 3484 3483 3497 3495 3483 3495 3484 3496 3495 3497 3494 3495 3496 3451 3494 3496 3451 3452 3453 3451 3484 3452 3453 3494 3451 3484 3495 3493 3484 3493 3452 3494 3493 3495 3492 3493 3494 3453 3492 3494 3453 3452 3454 3453 3454 3455 3455 3492 3453 3452 3493 3514 3452 3514 3454 3492 3514 3493 3512 3513 3492 3492 3513 3514 3455 3512 3492 3455 3454 3456 3455 3456 3457 3457 3512 3455 3454 3514 3513 3454 3513 3456 3512 3511 3513 3456 3513 3511 3510 3511 3512 3457 3510 3512 3457 3456 3458 3457 3458 3444 3444 3510 3457 3456 3511 3458 3510 3509 3511 3458 3511 3509 3508 3509 3510 3444 3508 3510 3444 3445 3446 3444 3458 3459 3444 3459 3445 3446 3508 3444 3458 3509 3459 3508 3507 3509 3459 3509 3507 3506 3507 3508 3446 3506 3508 3446 3445 3447 3446 3447 3448 3448 3506 3446 3519 3520 3506 3506 3520 3521 3506 3521 3507 3448 3519 3506 3459 3507 3445 3445 3507 3521 3445 3521 3447 3448 3447 3449 3447 3521 3520 3447 3520 3449 3448 3449 3450 3450 3519 3448 3517 3518 3519 3519 3518 3520 3450 3517 3519 3449 3520 3518 3449 3469 3450 3449 3518 3469 3450 3469 3470 3450 3470 3471 3471 3517 3450 3515 3516 3517 3517 3516 3518 3471 3515 3517 3469 3518 3516 3469 3516 3470 3471 3470 3472 3470 3516 3539 3470 3539 3472 3471 3472 3473 3473 3515 3471 3473 3472 3474 3472 3539 3538 3472 3538 3474 3515 3538 3539 3515 3539 3516 3537 3538 3515 3473 3537 3515 3473 3474 3475 3475 3537 3473 3475 3474 3476 3474 3538 3536 3474 3536 3476 3537 3536 3538 3535 3536 3537 3475 3535 3537 3475 3476 3437 3437 3535 3475 3437 3476 3477 3476 3536 3534 3476 3534 3477 3535 3534 3536 3533 3534 3535 3437 3533 3535 3437 3438 3439 3437 3477 3438 3439 3533 3437 3477 3534 3532 3477 3532 3438 3533 3532 3534 3531 3532 3533 3439 3531 3533 3439 3438 3440 3439 3440 3441 3441 3531 3439 3438 3532 3555 3438 3555 3440 3531 3555 3532 3553 3554 3531 3531 3554 3555 3441 3553 3531 3440 3555 3554 3556 3557 3558 3569 3570 3556 3556 3570 3571 3556 3571 3557 3558 3679 3556 3556 3679 3681 3556 3681 3569 3569 3568 3570 3568 3682 3570 3570 3682 3680 3570 3680 3571 3571 3680 3678 3571 3678 3557 3679 3678 3680 3679 3680 3681 3681 3680 3682 3676 3678 3679 3558 3676 3679 3676 3677 3678 3557 3678 3677 3674 3675 3676 3675 3677 3676 3560 3674 3676 3560 3676 3558 3557 3677 3559 3559 3677 3675 3558 3557 3559 3558 3559 3560 3560 3559 3561 3560 3561 3562 3562 3674 3560 3559 3675 3561 3674 3673 3675 3561 3675 3673 3672 3673 3674 3562 3672 3674 3562 3561 3563 3562 3563 3564 3564 3672 3562 3561 3673 3563 3672 3671 3673 3563 3673 3671 3670 3671 3672 3564 3670 3672 3563 3613 3564 3564 3613 3614 3564 3614 3615 3615 3670 3564 3563 3671 3613 3670 3669 3671 3613 3671 3669 3633 3669 3670 3615 3633 3670 3615 3614 3616 3615 3616 3617 3617 3633 3615 3613 3669 3614 3614 3669 3668 3614 3668 3616 3633 3668 3669 3631 3632 3633 3632 3668 3633 3617 3631 3633 3617 3616 3618 3617 3618 3588 3588 3631 3617 3616 3668 3632 3616 3632 3618 3631 3630 3632 3618 3632 3630 3629 3630 3631 3588 3629 3631 3588 3589 3590 3588 3618 3619 3588 3619 3589 3590 3629 3588 3618 3630 3619 3629 3628 3630 3619 3630 3628 3627 3628 3629 3590 3627 3629 3590 3589 3591 3590 3591 3592 3592 3627 3590 3656 3657 3627 3627 3657 3658 3627 3658 3628 3592 3656 3627 3619 3628 3589 3589 3628 3658 3589 3658 3591 3592 3591 3593 3591 3658 3657 3591 3657 3593 3592 3593 3594 3594 3656 3592 3654 3655 3656 3656 3655 3657 3594 3654 3656 3593 3657 3655 3594 3593 3595 3593 3655 3595 3594 3595 3596 3596 3654 3594 3652 3653 3654 3654 3653 3655 3596 3652 3654 3595 3655 3653 3595 3606 3596 3595 3653 3606 3596 3606 3607 3596 3607 3608 3608 3652 3596 3626 3651 3652 3652 3651 3653 3608 3626 3652 3606 3653 3651 3606 3651 3607 3608 3607 3609 3607 3651 3650 3607 3650 3609 3608 3609 3610 3610 3626 3608 3610 3609 3611 3609 3625 3611 3609 3650 3625 3625 3650 3626 3626 3650 3651 3624 3625 3626 3610 3624 3626 3610 3611 3579 3579 3624 3610 3579 3611 3612 3611 3625 3623 3611 3623 3612 3624 3623 3625 3622 3623 3624 3579 3622 3624 3579 3580 3581 3579 3612 3580 3581 3622 3579 3612 3623 3621 3612 3621 3580 3622 3621 3623 3620 3621 3622 3581 3620 3622 3581 3580 3582 3581 3582 3583 3583 3620 3581 3580 3621 3642 3580 3642 3582 3620 3642 3621 3640 3641 3620 3620 3641 3642 3583 3640 3620 3583 3582 3584 3583 3584 3585 3585 3640 3583 3582 3642 3641 3582 3641 3584 3640 3639 3641 3584 3641 3639 3638 3639 3640 3585 3638 3640 3585 3584 3586 3585 3586 3572 3572 3638 3585 3584 3639 3586 3638 3637 3639 3586 3639 3637 3636 3637 3638 3572 3636 3638 3572 3573 3574 3572 3586 3587 3572 3587 3573 3574 3636 3572 3586 3637 3587 3636 3635 3637 3587 3637 3635 3634 3635 3636 3574 3634 3636 3574 3573 3575 3574 3575 3576 3576 3634 3574 3647 3648 3634 3634 3648 3649 3634 3649 3635 3576 3647 3634 3587 3635 3573 3573 3635 3649 3573 3649 3575 3576 3575 3577 3575 3649 3648 3575 3648 3577 3576 3577 3578 3578 3647 3576 3645 3646 3647 3647 3646 3648 3578 3645 3647 3577 3648 3646 3577 3597 3578 3577 3646 3597 3578 3597 3598 3578 3598 3599 3599 3645 3578 3643 3644 3645 3645 3644 3646 3599 3643 3645 3597 3646 3644 3597 3644 3598 3599 3598 3600 3598 3644 3667 3598 3667 3600 3599 3600 3601 3601 3643 3599 3601 3600 3602 3600 3667 3666 3600 3666 3602 3643 3666 3667 3643 3667 3644 3665 3666 3643 3601 3665 3643 3601 3602 3603 3603 3665 3601 3603 3602 3604 3602 3666 3664 3602 3664 3604 3665 3664 3666 3663 3664 3665 3603 3663 3665 3603 3604 3565 3565 3663 3603 3565 3604 3605 3604 3664 3662 3604 3662 3605 3663 3662 3664 3661 3662 3663 3565 3661 3663 3565 3566 3567 3565 3605 3566 3567 3661 3565 3605 3662 3660 3605 3660 3566 3661 3660 3662 3659 3660 3661 3567 3659 3661 3567 3566 3568 3567 3568 3569 3569 3659 3567 3566 3660 3683 3566 3683 3568 3659 3683 3660 3681 3682 3659 3659 3682 3683 3569 3681 3659 3568 3683 3682 3684 3685 3686 3690 3685 3684 3686 3739 3684 3739 3740 3684 3684 3740 3741 3684 3741 3690 3689 3685 3690 3690 3741 3742 3690 3742 3689 3961 3867 3741 3961 3741 3740 3867 3742 3741 3739 3793 3740 3962 3961 3740 3962 3740 3793 3960 3959 3961 3960 3961 3962 3959 3867 3961 3977 3960 3962 3977 3962 3975 3975 3962 3793 3739 3792 3793 3975 3793 3792 3975 3792 3791 3863 3977 3975 3863 3975 3862 3862 3975 3791 3738 3791 3792 3738 3792 3739 3686 3738 3739 3736 3737 3738 3736 3738 3686 3737 3790 3738 3790 3791 3738 3862 3791 3790 3737 3789 3790 3790 3789 3862 3735 3737 3736 3735 3789 3737 3731 3735 3736 3731 3736 3978 3736 3686 3978 3686 3685 3978 3689 3688 3685 3685 3688 3978 3687 3688 3689 3742 3743 3689 3689 3743 3744 3689 3744 3687 3687 3691 3688 3687 3744 3745 3687 3745 3691 3745 3744 3866 3866 3744 3743 3866 3743 3867 3867 3743 3742 3866 3867 3868 3869 3745 3866 3869 3866 3870 3870 3866 3868 3745 3746 3691 3746 3745 3869 3853 3746 3869 3853 3869 3963 3963 3869 3870 3870 3868 3871 3963 3870 3964 3964 3870 3871 3964 3874 3963 3963 3874 3876 3963 3876 3853 3964 3871 3965 3965 3872 3964 3964 3872 3874 3956 3871 3957 3957 3871 3868 3965 3871 3956 3965 3956 3825 3825 3824 3965 3965 3824 3872 3824 3823 3872 3872 3823 3873 3872 3873 3874 3810 3823 3824 3810 3824 3825 3825 3828 3810 3825 3956 3828 3810 3811 3806 3816 3823 3810 3810 3828 3829 3810 3829 3811 3806 3816 3810 3816 3822 3823 3823 3822 3873 3815 3822 3816 3873 3822 3880 3822 3815 3880 3814 3815 3813 3813 3815 3816 3815 3814 3884 3880 3815 3884 3873 3880 3875 3875 3880 3881 3880 3884 3881 3884 3814 3885 3884 3885 3886 3881 3884 3886 3814 3813 3817 3814 3817 3885 3886 3885 3887 3885 3817 3892 3885 3892 3887 3886 3887 3888 3881 3886 3882 3882 3886 3888 3875 3881 3877 3877 3881 3882 3877 3882 3879 3879 3882 3883 3882 3888 3883 3888 3887 3889 3888 3889 3890 3883 3888 3890 3879 3883 3752 3752 3883 3753 3883 3890 3753 3890 3889 3891 3891 3755 3890 3890 3755 3754 3890 3754 3753 3699 3752 3753 3699 3753 3697 3697 3753 3754 3697 3754 3701 3701 3754 3755 3755 3756 3701 3891 3756 3755 3697 3701 3698 3698 3701 3702 3701 3756 3757 3701 3757 3702 3697 3698 3699 3699 3698 3696 3698 3702 3703 3698 3703 3978 3696 3698 3978 3702 3704 3703 3702 3757 3758 3702 3758 3704 3891 3895 3757 3757 3895 3758 3757 3756 3891 3704 3758 3759 3759 3758 3852 3852 3758 3895 3703 3704 3705 3704 3759 3705 3705 3759 3760 3760 3759 3852 3852 3895 3966 3966 3900 3852 3852 3900 3902 3852 3902 3760 3891 3894 3895 3966 3895 3894 3889 3894 3891 3889 3893 3894 3966 3894 3967 3967 3894 3893 3967 3898 3966 3966 3898 3900 3967 3893 3968 3968 3896 3967 3967 3896 3898 3887 3892 3893 3887 3893 3889 3968 3893 3892 3968 3892 3818 3818 3839 3968 3968 3839 3896 3839 3840 3896 3896 3840 3897 3896 3897 3898 3839 3818 3840 3817 3812 3818 3840 3818 3812 3818 3892 3817 3840 3812 3841 3840 3841 3897 3898 3897 3899 3897 3841 3904 3897 3904 3899 3841 3812 3833 3841 3833 3842 3841 3842 3904 3812 3813 3802 3817 3813 3812 3802 3833 3812 3802 3813 3803 3813 3816 3803 3802 3803 3804 3804 3833 3802 3804 3803 3805 3803 3816 3805 3805 3816 3806 3806 3807 3805 3805 3807 3800 3805 3800 3804 3804 3800 3801 3804 3801 3797 3797 3833 3804 3798 3799 3800 3800 3799 3801 3800 3827 3798 3807 3827 3800 3806 3811 3807 3811 3827 3807 3826 3827 3811 3826 3836 3827 3827 3836 3837 3827 3837 3808 3798 3827 3808 3808 3809 3798 3798 3809 3799 3809 3845 3799 3799 3845 3801 3808 3821 3809 3821 3843 3809 3809 3843 3844 3809 3844 3845 3808 3820 3821 3821 3820 3944 3843 3821 3974 3974 3821 3944 3974 3940 3843 3843 3940 3844 3849 3845 3844 3849 3844 3933 3933 3844 3940 3933 3940 3935 3935 3940 3941 3974 3941 3940 3973 3941 3974 3974 3944 3973 3935 3941 3937 3937 3941 3942 3973 3942 3941 3934 3933 3935 3934 3935 3936 3936 3935 3937 3932 3849 3933 3932 3933 3934 3929 3932 3934 3929 3934 3930 3930 3934 3936 3936 3937 3938 3930 3936 3931 3931 3936 3938 3925 3929 3930 3925 3930 3927 3927 3930 3931 3923 3928 3929 3923 3929 3925 3928 3932 3929 3924 3923 3925 3924 3925 3926 3926 3925 3927 3922 3921 3923 3922 3923 3924 3921 3928 3923 3921 3847 3928 3847 3848 3928 3928 3848 3932 3920 3846 3921 3920 3921 3922 3846 3847 3921 3846 3835 3847 3847 3835 3794 3847 3794 3848 3848 3794 3845 3848 3845 3849 3848 3849 3932 3794 3795 3796 3834 3795 3794 3834 3794 3835 3796 3845 3794 3801 3845 3796 3796 3795 3797 3797 3801 3796 3795 3833 3797 3831 3832 3795 3795 3832 3833 3831 3795 3834 3971 3916 3834 3834 3916 3831 3834 3835 3971 3832 3831 3909 3909 3831 3916 3842 3833 3832 3842 3832 3908 3908 3832 3909 3908 3909 3910 3910 3909 3911 3909 3916 3911 3911 3916 3917 3971 3917 3916 3910 3911 3912 3912 3911 3913 3911 3917 3913 3905 3908 3910 3905 3910 3906 3906 3910 3912 3904 3842 3908 3904 3908 3905 3899 3904 3905 3899 3905 3901 3901 3905 3906 3901 3906 3903 3903 3906 3907 3906 3912 3907 3900 3899 3901 3900 3901 3902 3902 3901 3903 3898 3899 3900 3903 3907 3764 3764 3763 3903 3903 3763 3762 3903 3762 3902 3902 3762 3761 3902 3761 3760 3761 3762 3708 3708 3762 3763 3708 3763 3710 3710 3763 3764 3706 3707 3708 3706 3708 3709 3709 3708 3710 3707 3761 3708 3707 3760 3761 3705 3760 3707 3705 3707 3706 3703 3705 3706 3706 3709 3978 3703 3706 3978 3709 3710 3711 3709 3711 3978 3711 3710 3712 3710 3764 3712 3711 3712 3713 3764 3765 3712 3712 3765 3766 3712 3766 3713 3764 3907 3765 3907 3914 3765 3914 3766 3765 3713 3766 3767 3914 3767 3766 3713 3714 3711 3713 3767 3714 3767 3768 3714 3915 3768 3767 3915 3767 3914 3912 3913 3914 3914 3913 3915 3907 3912 3914 3913 3918 3915 3915 3918 3919 3915 3919 3769 3769 3768 3915 3714 3768 3769 3711 3714 3715 3714 3769 3715 3715 3769 3770 3769 3919 3770 3851 3770 3919 3851 3919 3969 3969 3919 3918 3715 3770 3717 3717 3770 3771 3771 3770 3851 3711 3715 3716 3715 3717 3716 3711 3716 3978 3716 3717 3718 3716 3718 3719 3716 3719 3978 3717 3771 3718 3771 3772 3718 3772 3771 3851 3719 3718 3720 3718 3772 3773 3718 3773 3720 3719 3720 3721 3719 3721 3978 3721 3720 3722 3720 3773 3774 3720 3774 3722 3926 3774 3773 3926 3773 3772 3851 3926 3772 3851 3924 3926 3927 3774 3926 3774 3775 3722 3927 3775 3774 3927 3931 3776 3776 3775 3927 3722 3775 3776 3722 3776 3723 3723 3776 3777 3776 3931 3777 3931 3938 3777 3723 3777 3724 3724 3777 3778 3938 3778 3777 3721 3722 3723 3723 3724 3721 3721 3724 3725 3724 3778 3725 3725 3778 3779 3938 3779 3778 3938 3937 3939 3939 3779 3938 3725 3779 3727 3779 3780 3727 3939 3780 3779 3721 3725 3726 3725 3727 3726 3721 3726 3978 3726 3727 3728 3726 3728 3729 3726 3729 3978 3727 3780 3781 3727 3781 3728 3781 3780 3939 3728 3781 3782 3939 3943 3781 3781 3943 3782 3729 3728 3730 3728 3782 3730 3729 3730 3731 3731 3978 3729 3693 3696 3978 3688 3693 3978 3688 3692 3693 3692 3694 3693 3693 3694 3695 3693 3695 3696 3699 3696 3700 3700 3696 3695 3694 3749 3695 3749 3750 3695 3695 3750 3751 3695 3751 3700 3692 3748 3694 3694 3748 3749 3878 3750 3749 3878 3749 3748 3879 3751 3750 3879 3750 3878 3700 3751 3752 3752 3751 3879 3700 3752 3699 3878 3877 3879 3876 3877 3878 3853 3876 3878 3853 3878 3748 3692 3747 3748 3748 3747 3853 3747 3746 3853 3691 3746 3747 3691 3747 3692 3688 3691 3692 3874 3875 3876 3876 3875 3877 3874 3873 3875 3731 3730 3732 3731 3732 3733 3733 3734 3731 3731 3734 3735 3730 3782 3783 3730 3783 3732 3783 3784 3732 3732 3784 3785 3732 3785 3733 3733 3785 3786 3733 3786 3734 3950 3786 3785 3950 3785 3784 3784 3783 3850 3850 3950 3784 3783 3782 3850 3850 3782 3943 3850 3943 3972 3972 3948 3850 3850 3948 3950 3948 3949 3950 3950 3949 3951 3951 3786 3950 3786 3787 3734 3951 3787 3786 3949 3954 3951 3951 3954 3955 3951 3955 3788 3788 3787 3951 3734 3787 3788 3734 3788 3735 3735 3788 3789 3788 3955 3789 3862 3789 3955 3862 3955 3859 3859 3955 3954 3862 3859 3863 3859 3856 3860 3863 3859 3860 3859 3954 3856 3863 3860 3864 3864 3977 3863 3860 3856 3855 3860 3855 3861 3864 3860 3861 3854 3855 3856 3856 3954 3953 3856 3953 3854 3836 3855 3837 3837 3855 3854 3861 3855 3836 3861 3836 3826 3864 3861 3865 3865 3861 3826 3811 3830 3826 3865 3826 3830 3830 3858 3865 3865 3858 3976 3865 3976 3864 3811 3829 3830 3830 3829 3858 3829 3857 3858 3858 3857 3958 3858 3958 3976 3864 3976 3977 3976 3958 3960 3976 3960 3977 3857 3957 3958 3958 3957 3959 3958 3959 3960 3829 3828 3857 3828 3956 3857 3857 3956 3957 3957 3868 3959 3959 3868 3867 3837 3854 3838 3854 3953 3952 3854 3952 3838 3808 3837 3838 3808 3838 3819 3838 3952 3819 3945 3819 3952 3945 3952 3947 3947 3952 3953 3947 3953 3949 3949 3953 3954 3946 3945 3947 3946 3947 3948 3948 3947 3949 3944 3820 3945 3944 3945 3946 3820 3819 3945 3819 3820 3808 3973 3944 3946 3973 3946 3972 3972 3946 3948 3972 3942 3973 3972 3943 3942 3937 3942 3939 3939 3942 3943 3969 3922 3924 3969 3924 3851 3969 3918 3970 3970 3922 3969 3970 3920 3922 3970 3918 3917 3970 3917 3971 3971 3920 3970 3913 3917 3918 3835 3846 3920 3971 3835 3920 3979 3980 3981 3985 3980 3979 3981 4034 3979 4034 4035 3979 3979 4035 4036 3979 4036 3985 3984 3980 3985 3985 4036 4037 3985 4037 3984 4256 4162 4036 4256 4036 4035 4162 4037 4036 4034 4088 4035 4257 4256 4035 4257 4035 4088 4255 4254 4256 4255 4256 4257 4254 4162 4256 4272 4255 4257 4272 4257 4270 4270 4257 4088 4034 4087 4088 4270 4088 4087 4270 4087 4086 4158 4272 4270 4158 4270 4157 4157 4270 4086 4033 4086 4087 4033 4087 4034 3981 4033 4034 4031 4032 4033 4031 4033 3981 4032 4085 4033 4085 4086 4033 4157 4086 4085 4032 4084 4085 4085 4084 4157 4030 4032 4031 4030 4084 4032 4026 4030 4031 4026 4031 4273 4031 3981 4273 3981 3980 4273 3984 3983 3980 3980 3983 4273 3982 3983 3984 4037 4038 3984 3984 4038 4039 3984 4039 3982 3982 3986 3983 3982 4039 4040 3982 4040 3986 4040 4039 4161 4161 4039 4038 4161 4038 4162 4162 4038 4037 4161 4162 4163 4164 4040 4161 4164 4161 4165 4165 4161 4163 4040 4041 3986 4041 4040 4164 4148 4041 4164 4148 4164 4258 4258 4164 4165 4165 4163 4166 4258 4165 4259 4259 4165 4166 4259 4169 4258 4258 4169 4171 4258 4171 4148 4259 4166 4260 4260 4167 4259 4259 4167 4169 4251 4166 4252 4252 4166 4163 4260 4166 4251 4260 4251 4120 4120 4119 4260 4260 4119 4167 4119 4118 4167 4167 4118 4168 4167 4168 4169 4105 4118 4119 4105 4119 4120 4120 4123 4105 4120 4251 4123 4105 4106 4101 4111 4118 4105 4105 4123 4124 4105 4124 4106 4101 4111 4105 4111 4117 4118 4118 4117 4168 4110 4117 4111 4168 4117 4175 4117 4110 4175 4109 4110 4108 4108 4110 4111 4110 4109 4179 4175 4110 4179 4168 4175 4170 4170 4175 4176 4175 4179 4176 4179 4109 4180 4179 4180 4181 4176 4179 4181 4109 4108 4112 4109 4112 4180 4181 4180 4182 4180 4112 4187 4180 4187 4182 4181 4182 4183 4176 4181 4177 4177 4181 4183 4170 4176 4172 4172 4176 4177 4172 4177 4174 4174 4177 4178 4177 4183 4178 4183 4182 4184 4183 4184 4185 4178 4183 4185 4174 4178 4047 4047 4178 4048 4178 4185 4048 4185 4184 4186 4186 4050 4185 4185 4050 4049 4185 4049 4048 3994 4047 4048 3994 4048 3992 3992 4048 4049 3992 4049 3996 3996 4049 4050 4050 4051 3996 4186 4051 4050 3992 3996 3993 3993 3996 3997 3996 4051 4052 3996 4052 3997 3992 3993 3994 3994 3993 3991 3993 3997 3998 3993 3998 4273 3991 3993 4273 3997 3999 3998 3997 4052 4053 3997 4053 3999 4186 4190 4052 4052 4190 4053 4052 4051 4186 3999 4053 4054 4054 4053 4147 4147 4053 4190 3998 3999 4000 3999 4054 4000 4000 4054 4055 4055 4054 4147 4147 4190 4261 4261 4195 4147 4147 4195 4197 4147 4197 4055 4186 4189 4190 4261 4190 4189 4184 4189 4186 4184 4188 4189 4261 4189 4262 4262 4189 4188 4262 4193 4261 4261 4193 4195 4262 4188 4263 4263 4191 4262 4262 4191 4193 4182 4187 4188 4182 4188 4184 4263 4188 4187 4263 4187 4113 4113 4134 4263 4263 4134 4191 4134 4135 4191 4191 4135 4192 4191 4192 4193 4134 4113 4135 4112 4107 4113 4135 4113 4107 4113 4187 4112 4135 4107 4136 4135 4136 4192 4193 4192 4194 4192 4136 4199 4192 4199 4194 4136 4107 4128 4136 4128 4137 4136 4137 4199 4107 4108 4097 4112 4108 4107 4097 4128 4107 4097 4108 4098 4108 4111 4098 4097 4098 4099 4099 4128 4097 4099 4098 4100 4098 4111 4100 4100 4111 4101 4101 4102 4100 4100 4102 4095 4100 4095 4099 4099 4095 4096 4099 4096 4092 4092 4128 4099 4093 4094 4095 4095 4094 4096 4095 4122 4093 4102 4122 4095 4101 4106 4102 4106 4122 4102 4121 4122 4106 4121 4131 4122 4122 4131 4132 4122 4132 4103 4093 4122 4103 4103 4104 4093 4093 4104 4094 4104 4140 4094 4094 4140 4096 4103 4116 4104 4116 4138 4104 4104 4138 4139 4104 4139 4140 4103 4115 4116 4116 4115 4239 4138 4116 4269 4269 4116 4239 4269 4235 4138 4138 4235 4139 4144 4140 4139 4144 4139 4228 4228 4139 4235 4228 4235 4230 4230 4235 4236 4269 4236 4235 4268 4236 4269 4269 4239 4268 4230 4236 4232 4232 4236 4237 4268 4237 4236 4229 4228 4230 4229 4230 4231 4231 4230 4232 4227 4144 4228 4227 4228 4229 4224 4227 4229 4224 4229 4225 4225 4229 4231 4231 4232 4233 4225 4231 4226 4226 4231 4233 4220 4224 4225 4220 4225 4222 4222 4225 4226 4218 4223 4224 4218 4224 4220 4223 4227 4224 4219 4218 4220 4219 4220 4221 4221 4220 4222 4217 4216 4218 4217 4218 4219 4216 4223 4218 4216 4142 4223 4142 4143 4223 4223 4143 4227 4215 4141 4216 4215 4216 4217 4141 4142 4216 4141 4130 4142 4142 4130 4089 4142 4089 4143 4143 4089 4140 4143 4140 4144 4143 4144 4227 4089 4090 4091 4129 4090 4089 4129 4089 4130 4091 4140 4089 4096 4140 4091 4091 4090 4092 4092 4096 4091 4090 4128 4092 4126 4127 4090 4090 4127 4128 4126 4090 4129 4266 4211 4129 4129 4211 4126 4129 4130 4266 4127 4126 4204 4204 4126 4211 4137 4128 4127 4137 4127 4203 4203 4127 4204 4203 4204 4205 4205 4204 4206 4204 4211 4206 4206 4211 4212 4266 4212 4211 4205 4206 4207 4207 4206 4208 4206 4212 4208 4200 4203 4205 4200 4205 4201 4201 4205 4207 4199 4137 4203 4199 4203 4200 4194 4199 4200 4194 4200 4196 4196 4200 4201 4196 4201 4198 4198 4201 4202 4201 4207 4202 4195 4194 4196 4195 4196 4197 4197 4196 4198 4193 4194 4195 4198 4202 4059 4059 4058 4198 4198 4058 4057 4198 4057 4197 4197 4057 4056 4197 4056 4055 4056 4057 4003 4003 4057 4058 4003 4058 4005 4005 4058 4059 4001 4002 4003 4001 4003 4004 4004 4003 4005 4002 4056 4003 4002 4055 4056 4000 4055 4002 4000 4002 4001 3998 4000 4001 4001 4004 4273 3998 4001 4273 4004 4005 4006 4004 4006 4273 4006 4005 4007 4005 4059 4007 4006 4007 4008 4059 4060 4007 4007 4060 4061 4007 4061 4008 4059 4202 4060 4202 4209 4060 4209 4061 4060 4008 4061 4062 4209 4062 4061 4008 4009 4006 4008 4062 4009 4062 4063 4009 4210 4063 4062 4210 4062 4209 4207 4208 4209 4209 4208 4210 4202 4207 4209 4208 4213 4210 4210 4213 4214 4210 4214 4064 4064 4063 4210 4009 4063 4064 4006 4009 4010 4009 4064 4010 4010 4064 4065 4064 4214 4065 4146 4065 4214 4146 4214 4264 4264 4214 4213 4010 4065 4012 4012 4065 4066 4066 4065 4146 4006 4010 4011 4010 4012 4011 4006 4011 4273 4011 4012 4013 4011 4013 4014 4011 4014 4273 4012 4066 4013 4066 4067 4013 4067 4066 4146 4014 4013 4015 4013 4067 4068 4013 4068 4015 4014 4015 4016 4014 4016 4273 4016 4015 4017 4015 4068 4069 4015 4069 4017 4221 4069 4068 4221 4068 4067 4146 4221 4067 4146 4219 4221 4222 4069 4221 4069 4070 4017 4222 4070 4069 4222 4226 4071 4071 4070 4222 4017 4070 4071 4017 4071 4018 4018 4071 4072 4071 4226 4072 4226 4233 4072 4018 4072 4019 4019 4072 4073 4233 4073 4072 4016 4017 4018 4018 4019 4016 4016 4019 4020 4019 4073 4020 4020 4073 4074 4233 4074 4073 4233 4232 4234 4234 4074 4233 4020 4074 4022 4074 4075 4022 4234 4075 4074 4016 4020 4021 4020 4022 4021 4016 4021 4273 4021 4022 4023 4021 4023 4024 4021 4024 4273 4022 4075 4076 4022 4076 4023 4076 4075 4234 4023 4076 4077 4234 4238 4076 4076 4238 4077 4024 4023 4025 4023 4077 4025 4024 4025 4026 4026 4273 4024 3988 3991 4273 3983 3988 4273 3983 3987 3988 3987 3989 3988 3988 3989 3990 3988 3990 3991 3994 3991 3995 3995 3991 3990 3989 4044 3990 4044 4045 3990 3990 4045 4046 3990 4046 3995 3987 4043 3989 3989 4043 4044 4173 4045 4044 4173 4044 4043 4174 4046 4045 4174 4045 4173 3995 4046 4047 4047 4046 4174 3995 4047 3994 4173 4172 4174 4171 4172 4173 4148 4171 4173 4148 4173 4043 3987 4042 4043 4043 4042 4148 4042 4041 4148 3986 4041 4042 3986 4042 3987 3983 3986 3987 4169 4170 4171 4171 4170 4172 4169 4168 4170 4026 4025 4027 4026 4027 4028 4028 4029 4026 4026 4029 4030 4025 4077 4078 4025 4078 4027 4078 4079 4027 4027 4079 4080 4027 4080 4028 4028 4080 4081 4028 4081 4029 4245 4081 4080 4245 4080 4079 4079 4078 4145 4145 4245 4079 4078 4077 4145 4145 4077 4238 4145 4238 4267 4267 4243 4145 4145 4243 4245 4243 4244 4245 4245 4244 4246 4246 4081 4245 4081 4082 4029 4246 4082 4081 4244 4249 4246 4246 4249 4250 4246 4250 4083 4083 4082 4246 4029 4082 4083 4029 4083 4030 4030 4083 4084 4083 4250 4084 4157 4084 4250 4157 4250 4154 4154 4250 4249 4157 4154 4158 4154 4151 4155 4158 4154 4155 4154 4249 4151 4158 4155 4159 4159 4272 4158 4155 4151 4150 4155 4150 4156 4159 4155 4156 4149 4150 4151 4151 4249 4248 4151 4248 4149 4131 4150 4132 4132 4150 4149 4156 4150 4131 4156 4131 4121 4159 4156 4160 4160 4156 4121 4106 4125 4121 4160 4121 4125 4125 4153 4160 4160 4153 4271 4160 4271 4159 4106 4124 4125 4125 4124 4153 4124 4152 4153 4153 4152 4253 4153 4253 4271 4159 4271 4272 4271 4253 4255 4271 4255 4272 4152 4252 4253 4253 4252 4254 4253 4254 4255 4124 4123 4152 4123 4251 4152 4152 4251 4252 4252 4163 4254 4254 4163 4162 4132 4149 4133 4149 4248 4247 4149 4247 4133 4103 4132 4133 4103 4133 4114 4133 4247 4114 4240 4114 4247 4240 4247 4242 4242 4247 4248 4242 4248 4244 4244 4248 4249 4241 4240 4242 4241 4242 4243 4243 4242 4244 4239 4115 4240 4239 4240 4241 4115 4114 4240 4114 4115 4103 4268 4239 4241 4268 4241 4267 4267 4241 4243 4267 4237 4268 4267 4238 4237 4232 4237 4234 4234 4237 4238 4264 4217 4219 4264 4219 4146 4264 4213 4265 4265 4217 4264 4265 4215 4217 4265 4213 4212 4265 4212 4266 4266 4215 4265 4208 4212 4213 4130 4141 4215 4266 4130 4215 4274 4275 4276 4280 4275 4274 4276 4329 4274 4329 4330 4274 4274 4330 4331 4274 4331 4280 4279 4275 4280 4280 4331 4332 4280 4332 4279 4551 4457 4331 4551 4331 4330 4457 4332 4331 4329 4383 4330 4552 4551 4330 4552 4330 4383 4550 4549 4551 4550 4551 4552 4549 4457 4551 4567 4550 4552 4567 4552 4565 4565 4552 4383 4329 4382 4383 4565 4383 4382 4565 4382 4381 4453 4567 4565 4453 4565 4452 4452 4565 4381 4328 4381 4382 4328 4382 4329 4276 4328 4329 4326 4327 4328 4326 4328 4276 4327 4380 4328 4380 4381 4328 4452 4381 4380 4327 4379 4380 4380 4379 4452 4325 4327 4326 4325 4379 4327 4321 4325 4326 4321 4326 4568 4326 4276 4568 4276 4275 4568 4279 4278 4275 4275 4278 4568 4277 4278 4279 4332 4333 4279 4279 4333 4334 4279 4334 4277 4277 4281 4278 4277 4334 4335 4277 4335 4281 4335 4334 4456 4456 4334 4333 4456 4333 4457 4457 4333 4332 4456 4457 4458 4459 4335 4456 4459 4456 4460 4460 4456 4458 4335 4336 4281 4336 4335 4459 4443 4336 4459 4443 4459 4553 4553 4459 4460 4460 4458 4461 4553 4460 4554 4554 4460 4461 4554 4464 4553 4553 4464 4466 4553 4466 4443 4554 4461 4555 4555 4462 4554 4554 4462 4464 4546 4461 4547 4547 4461 4458 4555 4461 4546 4555 4546 4415 4415 4414 4555 4555 4414 4462 4414 4413 4462 4462 4413 4463 4462 4463 4464 4400 4413 4414 4400 4414 4415 4415 4418 4400 4415 4546 4418 4400 4401 4396 4406 4413 4400 4400 4418 4419 4400 4419 4401 4396 4406 4400 4406 4412 4413 4413 4412 4463 4405 4412 4406 4463 4412 4470 4412 4405 4470 4404 4405 4403 4403 4405 4406 4405 4404 4474 4470 4405 4474 4463 4470 4465 4465 4470 4471 4470 4474 4471 4474 4404 4475 4474 4475 4476 4471 4474 4476 4404 4403 4407 4404 4407 4475 4476 4475 4477 4475 4407 4482 4475 4482 4477 4476 4477 4478 4471 4476 4472 4472 4476 4478 4465 4471 4467 4467 4471 4472 4467 4472 4469 4469 4472 4473 4472 4478 4473 4478 4477 4479 4478 4479 4480 4473 4478 4480 4469 4473 4342 4342 4473 4343 4473 4480 4343 4480 4479 4481 4481 4345 4480 4480 4345 4344 4480 4344 4343 4289 4342 4343 4289 4343 4287 4287 4343 4344 4287 4344 4291 4291 4344 4345 4345 4346 4291 4481 4346 4345 4287 4291 4288 4288 4291 4292 4291 4346 4347 4291 4347 4292 4287 4288 4289 4289 4288 4286 4288 4292 4293 4288 4293 4568 4286 4288 4568 4292 4294 4293 4292 4347 4348 4292 4348 4294 4481 4485 4347 4347 4485 4348 4347 4346 4481 4294 4348 4349 4349 4348 4442 4442 4348 4485 4293 4294 4295 4294 4349 4295 4295 4349 4350 4350 4349 4442 4442 4485 4556 4556 4490 4442 4442 4490 4492 4442 4492 4350 4481 4484 4485 4556 4485 4484 4479 4484 4481 4479 4483 4484 4556 4484 4557 4557 4484 4483 4557 4488 4556 4556 4488 4490 4557 4483 4558 4558 4486 4557 4557 4486 4488 4477 4482 4483 4477 4483 4479 4558 4483 4482 4558 4482 4408 4408 4429 4558 4558 4429 4486 4429 4430 4486 4486 4430 4487 4486 4487 4488 4429 4408 4430 4407 4402 4408 4430 4408 4402 4408 4482 4407 4430 4402 4431 4430 4431 4487 4488 4487 4489 4487 4431 4494 4487 4494 4489 4431 4402 4423 4431 4423 4432 4431 4432 4494 4402 4403 4392 4407 4403 4402 4392 4423 4402 4392 4403 4393 4403 4406 4393 4392 4393 4394 4394 4423 4392 4394 4393 4395 4393 4406 4395 4395 4406 4396 4396 4397 4395 4395 4397 4390 4395 4390 4394 4394 4390 4391 4394 4391 4387 4387 4423 4394 4388 4389 4390 4390 4389 4391 4390 4417 4388 4397 4417 4390 4396 4401 4397 4401 4417 4397 4416 4417 4401 4416 4426 4417 4417 4426 4427 4417 4427 4398 4388 4417 4398 4398 4399 4388 4388 4399 4389 4399 4435 4389 4389 4435 4391 4398 4411 4399 4411 4433 4399 4399 4433 4434 4399 4434 4435 4398 4410 4411 4411 4410 4534 4433 4411 4564 4564 4411 4534 4564 4530 4433 4433 4530 4434 4439 4435 4434 4439 4434 4523 4523 4434 4530 4523 4530 4525 4525 4530 4531 4564 4531 4530 4563 4531 4564 4564 4534 4563 4525 4531 4527 4527 4531 4532 4563 4532 4531 4524 4523 4525 4524 4525 4526 4526 4525 4527 4522 4439 4523 4522 4523 4524 4519 4522 4524 4519 4524 4520 4520 4524 4526 4526 4527 4528 4520 4526 4521 4521 4526 4528 4515 4519 4520 4515 4520 4517 4517 4520 4521 4513 4518 4519 4513 4519 4515 4518 4522 4519 4514 4513 4515 4514 4515 4516 4516 4515 4517 4512 4511 4513 4512 4513 4514 4511 4518 4513 4511 4437 4518 4437 4438 4518 4518 4438 4522 4510 4436 4511 4510 4511 4512 4436 4437 4511 4436 4425 4437 4437 4425 4384 4437 4384 4438 4438 4384 4435 4438 4435 4439 4438 4439 4522 4384 4385 4386 4424 4385 4384 4424 4384 4425 4386 4435 4384 4391 4435 4386 4386 4385 4387 4387 4391 4386 4385 4423 4387 4421 4422 4385 4385 4422 4423 4421 4385 4424 4561 4506 4424 4424 4506 4421 4424 4425 4561 4422 4421 4499 4499 4421 4506 4432 4423 4422 4432 4422 4498 4498 4422 4499 4498 4499 4500 4500 4499 4501 4499 4506 4501 4501 4506 4507 4561 4507 4506 4500 4501 4502 4502 4501 4503 4501 4507 4503 4495 4498 4500 4495 4500 4496 4496 4500 4502 4494 4432 4498 4494 4498 4495 4489 4494 4495 4489 4495 4491 4491 4495 4496 4491 4496 4493 4493 4496 4497 4496 4502 4497 4490 4489 4491 4490 4491 4492 4492 4491 4493 4488 4489 4490 4493 4497 4354 4354 4353 4493 4493 4353 4352 4493 4352 4492 4492 4352 4351 4492 4351 4350 4351 4352 4298 4298 4352 4353 4298 4353 4300 4300 4353 4354 4296 4297 4298 4296 4298 4299 4299 4298 4300 4297 4351 4298 4297 4350 4351 4295 4350 4297 4295 4297 4296 4293 4295 4296 4296 4299 4568 4293 4296 4568 4299 4300 4301 4299 4301 4568 4301 4300 4302 4300 4354 4302 4301 4302 4303 4354 4355 4302 4302 4355 4356 4302 4356 4303 4354 4497 4355 4497 4504 4355 4504 4356 4355 4303 4356 4357 4504 4357 4356 4303 4304 4301 4303 4357 4304 4357 4358 4304 4505 4358 4357 4505 4357 4504 4502 4503 4504 4504 4503 4505 4497 4502 4504 4503 4508 4505 4505 4508 4509 4505 4509 4359 4359 4358 4505 4304 4358 4359 4301 4304 4305 4304 4359 4305 4305 4359 4360 4359 4509 4360 4441 4360 4509 4441 4509 4559 4559 4509 4508 4305 4360 4307 4307 4360 4361 4361 4360 4441 4301 4305 4306 4305 4307 4306 4301 4306 4568 4306 4307 4308 4306 4308 4309 4306 4309 4568 4307 4361 4308 4361 4362 4308 4362 4361 4441 4309 4308 4310 4308 4362 4363 4308 4363 4310 4309 4310 4311 4309 4311 4568 4311 4310 4312 4310 4363 4364 4310 4364 4312 4516 4364 4363 4516 4363 4362 4441 4516 4362 4441 4514 4516 4517 4364 4516 4364 4365 4312 4517 4365 4364 4517 4521 4366 4366 4365 4517 4312 4365 4366 4312 4366 4313 4313 4366 4367 4366 4521 4367 4521 4528 4367 4313 4367 4314 4314 4367 4368 4528 4368 4367 4311 4312 4313 4313 4314 4311 4311 4314 4315 4314 4368 4315 4315 4368 4369 4528 4369 4368 4528 4527 4529 4529 4369 4528 4315 4369 4317 4369 4370 4317 4529 4370 4369 4311 4315 4316 4315 4317 4316 4311 4316 4568 4316 4317 4318 4316 4318 4319 4316 4319 4568 4317 4370 4371 4317 4371 4318 4371 4370 4529 4318 4371 4372 4529 4533 4371 4371 4533 4372 4319 4318 4320 4318 4372 4320 4319 4320 4321 4321 4568 4319 4283 4286 4568 4278 4283 4568 4278 4282 4283 4282 4284 4283 4283 4284 4285 4283 4285 4286 4289 4286 4290 4290 4286 4285 4284 4339 4285 4339 4340 4285 4285 4340 4341 4285 4341 4290 4282 4338 4284 4284 4338 4339 4468 4340 4339 4468 4339 4338 4469 4341 4340 4469 4340 4468 4290 4341 4342 4342 4341 4469 4290 4342 4289 4468 4467 4469 4466 4467 4468 4443 4466 4468 4443 4468 4338 4282 4337 4338 4338 4337 4443 4337 4336 4443 4281 4336 4337 4281 4337 4282 4278 4281 4282 4464 4465 4466 4466 4465 4467 4464 4463 4465 4321 4320 4322 4321 4322 4323 4323 4324 4321 4321 4324 4325 4320 4372 4373 4320 4373 4322 4373 4374 4322 4322 4374 4375 4322 4375 4323 4323 4375 4376 4323 4376 4324 4540 4376 4375 4540 4375 4374 4374 4373 4440 4440 4540 4374 4373 4372 4440 4440 4372 4533 4440 4533 4562 4562 4538 4440 4440 4538 4540 4538 4539 4540 4540 4539 4541 4541 4376 4540 4376 4377 4324 4541 4377 4376 4539 4544 4541 4541 4544 4545 4541 4545 4378 4378 4377 4541 4324 4377 4378 4324 4378 4325 4325 4378 4379 4378 4545 4379 4452 4379 4545 4452 4545 4449 4449 4545 4544 4452 4449 4453 4449 4446 4450 4453 4449 4450 4449 4544 4446 4453 4450 4454 4454 4567 4453 4450 4446 4445 4450 4445 4451 4454 4450 4451 4444 4445 4446 4446 4544 4543 4446 4543 4444 4426 4445 4427 4427 4445 4444 4451 4445 4426 4451 4426 4416 4454 4451 4455 4455 4451 4416 4401 4420 4416 4455 4416 4420 4420 4448 4455 4455 4448 4566 4455 4566 4454 4401 4419 4420 4420 4419 4448 4419 4447 4448 4448 4447 4548 4448 4548 4566 4454 4566 4567 4566 4548 4550 4566 4550 4567 4447 4547 4548 4548 4547 4549 4548 4549 4550 4419 4418 4447 4418 4546 4447 4447 4546 4547 4547 4458 4549 4549 4458 4457 4427 4444 4428 4444 4543 4542 4444 4542 4428 4398 4427 4428 4398 4428 4409 4428 4542 4409 4535 4409 4542 4535 4542 4537 4537 4542 4543 4537 4543 4539 4539 4543 4544 4536 4535 4537 4536 4537 4538 4538 4537 4539 4534 4410 4535 4534 4535 4536 4410 4409 4535 4409 4410 4398 4563 4534 4536 4563 4536 4562 4562 4536 4538 4562 4532 4563 4562 4533 4532 4527 4532 4529 4529 4532 4533 4559 4512 4514 4559 4514 4441 4559 4508 4560 4560 4512 4559 4560 4510 4512 4560 4508 4507 4560 4507 4561 4561 4510 4560 4503 4507 4508 4425 4436 4510 4561 4425 4510 4569 4570 4571 4575 4570 4569 4571 4624 4569 4624 4625 4569 4569 4625 4626 4569 4626 4575 4574 4570 4575 4575 4626 4627 4575 4627 4574 4846 4752 4626 4846 4626 4625 4752 4627 4626 4624 4678 4625 4847 4846 4625 4847 4625 4678 4845 4844 4846 4845 4846 4847 4844 4752 4846 4862 4845 4847 4862 4847 4860 4860 4847 4678 4624 4677 4678 4860 4678 4677 4860 4677 4676 4748 4862 4860 4748 4860 4747 4747 4860 4676 4623 4676 4677 4623 4677 4624 4571 4623 4624 4621 4622 4623 4621 4623 4571 4622 4675 4623 4675 4676 4623 4747 4676 4675 4622 4674 4675 4675 4674 4747 4620 4622 4621 4620 4674 4622 4616 4620 4621 4616 4621 4863 4621 4571 4863 4571 4570 4863 4574 4573 4570 4570 4573 4863 4572 4573 4574 4627 4628 4574 4574 4628 4629 4574 4629 4572 4572 4576 4573 4572 4629 4630 4572 4630 4576 4630 4629 4751 4751 4629 4628 4751 4628 4752 4752 4628 4627 4751 4752 4753 4754 4630 4751 4754 4751 4755 4755 4751 4753 4630 4631 4576 4631 4630 4754 4738 4631 4754 4738 4754 4848 4848 4754 4755 4755 4753 4756 4848 4755 4849 4849 4755 4756 4849 4759 4848 4848 4759 4761 4848 4761 4738 4849 4756 4850 4850 4757 4849 4849 4757 4759 4841 4756 4842 4842 4756 4753 4850 4756 4841 4850 4841 4710 4710 4709 4850 4850 4709 4757 4709 4708 4757 4757 4708 4758 4757 4758 4759 4695 4708 4709 4695 4709 4710 4710 4713 4695 4710 4841 4713 4695 4696 4691 4701 4708 4695 4695 4713 4714 4695 4714 4696 4691 4701 4695 4701 4707 4708 4708 4707 4758 4700 4707 4701 4758 4707 4765 4707 4700 4765 4699 4700 4698 4698 4700 4701 4700 4699 4769 4765 4700 4769 4758 4765 4760 4760 4765 4766 4765 4769 4766 4769 4699 4770 4769 4770 4771 4766 4769 4771 4699 4698 4702 4699 4702 4770 4771 4770 4772 4770 4702 4777 4770 4777 4772 4771 4772 4773 4766 4771 4767 4767 4771 4773 4760 4766 4762 4762 4766 4767 4762 4767 4764 4764 4767 4768 4767 4773 4768 4773 4772 4774 4773 4774 4775 4768 4773 4775 4764 4768 4637 4637 4768 4638 4768 4775 4638 4775 4774 4776 4776 4640 4775 4775 4640 4639 4775 4639 4638 4584 4637 4638 4584 4638 4582 4582 4638 4639 4582 4639 4586 4586 4639 4640 4640 4641 4586 4776 4641 4640 4582 4586 4583 4583 4586 4587 4586 4641 4642 4586 4642 4587 4582 4583 4584 4584 4583 4581 4583 4587 4588 4583 4588 4863 4581 4583 4863 4587 4589 4588 4587 4642 4643 4587 4643 4589 4776 4780 4642 4642 4780 4643 4642 4641 4776 4589 4643 4644 4644 4643 4737 4737 4643 4780 4588 4589 4590 4589 4644 4590 4590 4644 4645 4645 4644 4737 4737 4780 4851 4851 4785 4737 4737 4785 4787 4737 4787 4645 4776 4779 4780 4851 4780 4779 4774 4779 4776 4774 4778 4779 4851 4779 4852 4852 4779 4778 4852 4783 4851 4851 4783 4785 4852 4778 4853 4853 4781 4852 4852 4781 4783 4772 4777 4778 4772 4778 4774 4853 4778 4777 4853 4777 4703 4703 4724 4853 4853 4724 4781 4724 4725 4781 4781 4725 4782 4781 4782 4783 4724 4703 4725 4702 4697 4703 4725 4703 4697 4703 4777 4702 4725 4697 4726 4725 4726 4782 4783 4782 4784 4782 4726 4789 4782 4789 4784 4726 4697 4718 4726 4718 4727 4726 4727 4789 4697 4698 4687 4702 4698 4697 4687 4718 4697 4687 4698 4688 4698 4701 4688 4687 4688 4689 4689 4718 4687 4689 4688 4690 4688 4701 4690 4690 4701 4691 4691 4692 4690 4690 4692 4685 4690 4685 4689 4689 4685 4686 4689 4686 4682 4682 4718 4689 4683 4684 4685 4685 4684 4686 4685 4712 4683 4692 4712 4685 4691 4696 4692 4696 4712 4692 4711 4712 4696 4711 4721 4712 4712 4721 4722 4712 4722 4693 4683 4712 4693 4693 4694 4683 4683 4694 4684 4694 4730 4684 4684 4730 4686 4693 4706 4694 4706 4728 4694 4694 4728 4729 4694 4729 4730 4693 4705 4706 4706 4705 4829 4728 4706 4859 4859 4706 4829 4859 4825 4728 4728 4825 4729 4734 4730 4729 4734 4729 4818 4818 4729 4825 4818 4825 4820 4820 4825 4826 4859 4826 4825 4858 4826 4859 4859 4829 4858 4820 4826 4822 4822 4826 4827 4858 4827 4826 4819 4818 4820 4819 4820 4821 4821 4820 4822 4817 4734 4818 4817 4818 4819 4814 4817 4819 4814 4819 4815 4815 4819 4821 4821 4822 4823 4815 4821 4816 4816 4821 4823 4810 4814 4815 4810 4815 4812 4812 4815 4816 4808 4813 4814 4808 4814 4810 4813 4817 4814 4809 4808 4810 4809 4810 4811 4811 4810 4812 4807 4806 4808 4807 4808 4809 4806 4813 4808 4806 4732 4813 4732 4733 4813 4813 4733 4817 4805 4731 4806 4805 4806 4807 4731 4732 4806 4731 4720 4732 4732 4720 4679 4732 4679 4733 4733 4679 4730 4733 4730 4734 4733 4734 4817 4679 4680 4681 4719 4680 4679 4719 4679 4720 4681 4730 4679 4686 4730 4681 4681 4680 4682 4682 4686 4681 4680 4718 4682 4716 4717 4680 4680 4717 4718 4716 4680 4719 4856 4801 4719 4719 4801 4716 4719 4720 4856 4717 4716 4794 4794 4716 4801 4727 4718 4717 4727 4717 4793 4793 4717 4794 4793 4794 4795 4795 4794 4796 4794 4801 4796 4796 4801 4802 4856 4802 4801 4795 4796 4797 4797 4796 4798 4796 4802 4798 4790 4793 4795 4790 4795 4791 4791 4795 4797 4789 4727 4793 4789 4793 4790 4784 4789 4790 4784 4790 4786 4786 4790 4791 4786 4791 4788 4788 4791 4792 4791 4797 4792 4785 4784 4786 4785 4786 4787 4787 4786 4788 4783 4784 4785 4788 4792 4649 4649 4648 4788 4788 4648 4647 4788 4647 4787 4787 4647 4646 4787 4646 4645 4646 4647 4593 4593 4647 4648 4593 4648 4595 4595 4648 4649 4591 4592 4593 4591 4593 4594 4594 4593 4595 4592 4646 4593 4592 4645 4646 4590 4645 4592 4590 4592 4591 4588 4590 4591 4591 4594 4863 4588 4591 4863 4594 4595 4596 4594 4596 4863 4596 4595 4597 4595 4649 4597 4596 4597 4598 4649 4650 4597 4597 4650 4651 4597 4651 4598 4649 4792 4650 4792 4799 4650 4799 4651 4650 4598 4651 4652 4799 4652 4651 4598 4599 4596 4598 4652 4599 4652 4653 4599 4800 4653 4652 4800 4652 4799 4797 4798 4799 4799 4798 4800 4792 4797 4799 4798 4803 4800 4800 4803 4804 4800 4804 4654 4654 4653 4800 4599 4653 4654 4596 4599 4600 4599 4654 4600 4600 4654 4655 4654 4804 4655 4736 4655 4804 4736 4804 4854 4854 4804 4803 4600 4655 4602 4602 4655 4656 4656 4655 4736 4596 4600 4601 4600 4602 4601 4596 4601 4863 4601 4602 4603 4601 4603 4604 4601 4604 4863 4602 4656 4603 4656 4657 4603 4657 4656 4736 4604 4603 4605 4603 4657 4658 4603 4658 4605 4604 4605 4606 4604 4606 4863 4606 4605 4607 4605 4658 4659 4605 4659 4607 4811 4659 4658 4811 4658 4657 4736 4811 4657 4736 4809 4811 4812 4659 4811 4659 4660 4607 4812 4660 4659 4812 4816 4661 4661 4660 4812 4607 4660 4661 4607 4661 4608 4608 4661 4662 4661 4816 4662 4816 4823 4662 4608 4662 4609 4609 4662 4663 4823 4663 4662 4606 4607 4608 4608 4609 4606 4606 4609 4610 4609 4663 4610 4610 4663 4664 4823 4664 4663 4823 4822 4824 4824 4664 4823 4610 4664 4612 4664 4665 4612 4824 4665 4664 4606 4610 4611 4610 4612 4611 4606 4611 4863 4611 4612 4613 4611 4613 4614 4611 4614 4863 4612 4665 4666 4612 4666 4613 4666 4665 4824 4613 4666 4667 4824 4828 4666 4666 4828 4667 4614 4613 4615 4613 4667 4615 4614 4615 4616 4616 4863 4614 4578 4581 4863 4573 4578 4863 4573 4577 4578 4577 4579 4578 4578 4579 4580 4578 4580 4581 4584 4581 4585 4585 4581 4580 4579 4634 4580 4634 4635 4580 4580 4635 4636 4580 4636 4585 4577 4633 4579 4579 4633 4634 4763 4635 4634 4763 4634 4633 4764 4636 4635 4764 4635 4763 4585 4636 4637 4637 4636 4764 4585 4637 4584 4763 4762 4764 4761 4762 4763 4738 4761 4763 4738 4763 4633 4577 4632 4633 4633 4632 4738 4632 4631 4738 4576 4631 4632 4576 4632 4577 4573 4576 4577 4759 4760 4761 4761 4760 4762 4759 4758 4760 4616 4615 4617 4616 4617 4618 4618 4619 4616 4616 4619 4620 4615 4667 4668 4615 4668 4617 4668 4669 4617 4617 4669 4670 4617 4670 4618 4618 4670 4671 4618 4671 4619 4835 4671 4670 4835 4670 4669 4669 4668 4735 4735 4835 4669 4668 4667 4735 4735 4667 4828 4735 4828 4857 4857 4833 4735 4735 4833 4835 4833 4834 4835 4835 4834 4836 4836 4671 4835 4671 4672 4619 4836 4672 4671 4834 4839 4836 4836 4839 4840 4836 4840 4673 4673 4672 4836 4619 4672 4673 4619 4673 4620 4620 4673 4674 4673 4840 4674 4747 4674 4840 4747 4840 4744 4744 4840 4839 4747 4744 4748 4744 4741 4745 4748 4744 4745 4744 4839 4741 4748 4745 4749 4749 4862 4748 4745 4741 4740 4745 4740 4746 4749 4745 4746 4739 4740 4741 4741 4839 4838 4741 4838 4739 4721 4740 4722 4722 4740 4739 4746 4740 4721 4746 4721 4711 4749 4746 4750 4750 4746 4711 4696 4715 4711 4750 4711 4715 4715 4743 4750 4750 4743 4861 4750 4861 4749 4696 4714 4715 4715 4714 4743 4714 4742 4743 4743 4742 4843 4743 4843 4861 4749 4861 4862 4861 4843 4845 4861 4845 4862 4742 4842 4843 4843 4842 4844 4843 4844 4845 4714 4713 4742 4713 4841 4742 4742 4841 4842 4842 4753 4844 4844 4753 4752 4722 4739 4723 4739 4838 4837 4739 4837 4723 4693 4722 4723 4693 4723 4704 4723 4837 4704 4830 4704 4837 4830 4837 4832 4832 4837 4838 4832 4838 4834 4834 4838 4839 4831 4830 4832 4831 4832 4833 4833 4832 4834 4829 4705 4830 4829 4830 4831 4705 4704 4830 4704 4705 4693 4858 4829 4831 4858 4831 4857 4857 4831 4833 4857 4827 4858 4857 4828 4827 4822 4827 4824 4824 4827 4828 4854 4807 4809 4854 4809 4736 4854 4803 4855 4855 4807 4854 4855 4805 4807 4855 4803 4802 4855 4802 4856 4856 4805 4855 4798 4802 4803 4720 4731 4805 4856 4720 4805 4864 4865 4866 4870 4865 4864 4866 4919 4864 4919 4920 4864 4864 4920 4921 4864 4921 4870 4869 4865 4870 4870 4921 4922 4870 4922 4869 5141 5047 4921 5141 4921 4920 5047 4922 4921 4919 4973 4920 5142 5141 4920 5142 4920 4973 5140 5139 5141 5140 5141 5142 5139 5047 5141 5157 5140 5142 5157 5142 5155 5155 5142 4973 4919 4972 4973 5155 4973 4972 5155 4972 4971 5043 5157 5155 5043 5155 5042 5042 5155 4971 4918 4971 4972 4918 4972 4919 4866 4918 4919 4916 4917 4918 4916 4918 4866 4917 4970 4918 4970 4971 4918 5042 4971 4970 4917 4969 4970 4970 4969 5042 4915 4917 4916 4915 4969 4917 4911 4915 4916 4911 4916 5158 4916 4866 5158 4866 4865 5158 4869 4868 4865 4865 4868 5158 4867 4868 4869 4922 4923 4869 4869 4923 4924 4869 4924 4867 4867 4871 4868 4867 4924 4925 4867 4925 4871 4925 4924 5046 5046 4924 4923 5046 4923 5047 5047 4923 4922 5046 5047 5048 5049 4925 5046 5049 5046 5050 5050 5046 5048 4925 4926 4871 4926 4925 5049 5033 4926 5049 5033 5049 5143 5143 5049 5050 5050 5048 5051 5143 5050 5144 5144 5050 5051 5144 5054 5143 5143 5054 5056 5143 5056 5033 5144 5051 5145 5145 5052 5144 5144 5052 5054 5136 5051 5137 5137 5051 5048 5145 5051 5136 5145 5136 5005 5005 5004 5145 5145 5004 5052 5004 5003 5052 5052 5003 5053 5052 5053 5054 4990 5003 5004 4990 5004 5005 5005 5008 4990 5005 5136 5008 4990 4991 4986 4996 5003 4990 4990 5008 5009 4990 5009 4991 4986 4996 4990 4996 5002 5003 5003 5002 5053 4995 5002 4996 5053 5002 5060 5002 4995 5060 4994 4995 4993 4993 4995 4996 4995 4994 5064 5060 4995 5064 5053 5060 5055 5055 5060 5061 5060 5064 5061 5064 4994 5065 5064 5065 5066 5061 5064 5066 4994 4993 4997 4994 4997 5065 5066 5065 5067 5065 4997 5072 5065 5072 5067 5066 5067 5068 5061 5066 5062 5062 5066 5068 5055 5061 5057 5057 5061 5062 5057 5062 5059 5059 5062 5063 5062 5068 5063 5068 5067 5069 5068 5069 5070 5063 5068 5070 5059 5063 4932 4932 5063 4933 5063 5070 4933 5070 5069 5071 5071 4935 5070 5070 4935 4934 5070 4934 4933 4879 4932 4933 4879 4933 4877 4877 4933 4934 4877 4934 4881 4881 4934 4935 4935 4936 4881 5071 4936 4935 4877 4881 4878 4878 4881 4882 4881 4936 4937 4881 4937 4882 4877 4878 4879 4879 4878 4876 4878 4882 4883 4878 4883 5158 4876 4878 5158 4882 4884 4883 4882 4937 4938 4882 4938 4884 5071 5075 4937 4937 5075 4938 4937 4936 5071 4884 4938 4939 4939 4938 5032 5032 4938 5075 4883 4884 4885 4884 4939 4885 4885 4939 4940 4940 4939 5032 5032 5075 5146 5146 5080 5032 5032 5080 5082 5032 5082 4940 5071 5074 5075 5146 5075 5074 5069 5074 5071 5069 5073 5074 5146 5074 5147 5147 5074 5073 5147 5078 5146 5146 5078 5080 5147 5073 5148 5148 5076 5147 5147 5076 5078 5067 5072 5073 5067 5073 5069 5148 5073 5072 5148 5072 4998 4998 5019 5148 5148 5019 5076 5019 5020 5076 5076 5020 5077 5076 5077 5078 5019 4998 5020 4997 4992 4998 5020 4998 4992 4998 5072 4997 5020 4992 5021 5020 5021 5077 5078 5077 5079 5077 5021 5084 5077 5084 5079 5021 4992 5013 5021 5013 5022 5021 5022 5084 4992 4993 4982 4997 4993 4992 4982 5013 4992 4982 4993 4983 4993 4996 4983 4982 4983 4984 4984 5013 4982 4984 4983 4985 4983 4996 4985 4985 4996 4986 4986 4987 4985 4985 4987 4980 4985 4980 4984 4984 4980 4981 4984 4981 4977 4977 5013 4984 4978 4979 4980 4980 4979 4981 4980 5007 4978 4987 5007 4980 4986 4991 4987 4991 5007 4987 5006 5007 4991 5006 5016 5007 5007 5016 5017 5007 5017 4988 4978 5007 4988 4988 4989 4978 4978 4989 4979 4989 5025 4979 4979 5025 4981 4988 5001 4989 5001 5023 4989 4989 5023 5024 4989 5024 5025 4988 5000 5001 5001 5000 5124 5023 5001 5154 5154 5001 5124 5154 5120 5023 5023 5120 5024 5029 5025 5024 5029 5024 5113 5113 5024 5120 5113 5120 5115 5115 5120 5121 5154 5121 5120 5153 5121 5154 5154 5124 5153 5115 5121 5117 5117 5121 5122 5153 5122 5121 5114 5113 5115 5114 5115 5116 5116 5115 5117 5112 5029 5113 5112 5113 5114 5109 5112 5114 5109 5114 5110 5110 5114 5116 5116 5117 5118 5110 5116 5111 5111 5116 5118 5105 5109 5110 5105 5110 5107 5107 5110 5111 5103 5108 5109 5103 5109 5105 5108 5112 5109 5104 5103 5105 5104 5105 5106 5106 5105 5107 5102 5101 5103 5102 5103 5104 5101 5108 5103 5101 5027 5108 5027 5028 5108 5108 5028 5112 5100 5026 5101 5100 5101 5102 5026 5027 5101 5026 5015 5027 5027 5015 4974 5027 4974 5028 5028 4974 5025 5028 5025 5029 5028 5029 5112 4974 4975 4976 5014 4975 4974 5014 4974 5015 4976 5025 4974 4981 5025 4976 4976 4975 4977 4977 4981 4976 4975 5013 4977 5011 5012 4975 4975 5012 5013 5011 4975 5014 5151 5096 5014 5014 5096 5011 5014 5015 5151 5012 5011 5089 5089 5011 5096 5022 5013 5012 5022 5012 5088 5088 5012 5089 5088 5089 5090 5090 5089 5091 5089 5096 5091 5091 5096 5097 5151 5097 5096 5090 5091 5092 5092 5091 5093 5091 5097 5093 5085 5088 5090 5085 5090 5086 5086 5090 5092 5084 5022 5088 5084 5088 5085 5079 5084 5085 5079 5085 5081 5081 5085 5086 5081 5086 5083 5083 5086 5087 5086 5092 5087 5080 5079 5081 5080 5081 5082 5082 5081 5083 5078 5079 5080 5083 5087 4944 4944 4943 5083 5083 4943 4942 5083 4942 5082 5082 4942 4941 5082 4941 4940 4941 4942 4888 4888 4942 4943 4888 4943 4890 4890 4943 4944 4886 4887 4888 4886 4888 4889 4889 4888 4890 4887 4941 4888 4887 4940 4941 4885 4940 4887 4885 4887 4886 4883 4885 4886 4886 4889 5158 4883 4886 5158 4889 4890 4891 4889 4891 5158 4891 4890 4892 4890 4944 4892 4891 4892 4893 4944 4945 4892 4892 4945 4946 4892 4946 4893 4944 5087 4945 5087 5094 4945 5094 4946 4945 4893 4946 4947 5094 4947 4946 4893 4894 4891 4893 4947 4894 4947 4948 4894 5095 4948 4947 5095 4947 5094 5092 5093 5094 5094 5093 5095 5087 5092 5094 5093 5098 5095 5095 5098 5099 5095 5099 4949 4949 4948 5095 4894 4948 4949 4891 4894 4895 4894 4949 4895 4895 4949 4950 4949 5099 4950 5031 4950 5099 5031 5099 5149 5149 5099 5098 4895 4950 4897 4897 4950 4951 4951 4950 5031 4891 4895 4896 4895 4897 4896 4891 4896 5158 4896 4897 4898 4896 4898 4899 4896 4899 5158 4897 4951 4898 4951 4952 4898 4952 4951 5031 4899 4898 4900 4898 4952 4953 4898 4953 4900 4899 4900 4901 4899 4901 5158 4901 4900 4902 4900 4953 4954 4900 4954 4902 5106 4954 4953 5106 4953 4952 5031 5106 4952 5031 5104 5106 5107 4954 5106 4954 4955 4902 5107 4955 4954 5107 5111 4956 4956 4955 5107 4902 4955 4956 4902 4956 4903 4903 4956 4957 4956 5111 4957 5111 5118 4957 4903 4957 4904 4904 4957 4958 5118 4958 4957 4901 4902 4903 4903 4904 4901 4901 4904 4905 4904 4958 4905 4905 4958 4959 5118 4959 4958 5118 5117 5119 5119 4959 5118 4905 4959 4907 4959 4960 4907 5119 4960 4959 4901 4905 4906 4905 4907 4906 4901 4906 5158 4906 4907 4908 4906 4908 4909 4906 4909 5158 4907 4960 4961 4907 4961 4908 4961 4960 5119 4908 4961 4962 5119 5123 4961 4961 5123 4962 4909 4908 4910 4908 4962 4910 4909 4910 4911 4911 5158 4909 4873 4876 5158 4868 4873 5158 4868 4872 4873 4872 4874 4873 4873 4874 4875 4873 4875 4876 4879 4876 4880 4880 4876 4875 4874 4929 4875 4929 4930 4875 4875 4930 4931 4875 4931 4880 4872 4928 4874 4874 4928 4929 5058 4930 4929 5058 4929 4928 5059 4931 4930 5059 4930 5058 4880 4931 4932 4932 4931 5059 4880 4932 4879 5058 5057 5059 5056 5057 5058 5033 5056 5058 5033 5058 4928 4872 4927 4928 4928 4927 5033 4927 4926 5033 4871 4926 4927 4871 4927 4872 4868 4871 4872 5054 5055 5056 5056 5055 5057 5054 5053 5055 4911 4910 4912 4911 4912 4913 4913 4914 4911 4911 4914 4915 4910 4962 4963 4910 4963 4912 4963 4964 4912 4912 4964 4965 4912 4965 4913 4913 4965 4966 4913 4966 4914 5130 4966 4965 5130 4965 4964 4964 4963 5030 5030 5130 4964 4963 4962 5030 5030 4962 5123 5030 5123 5152 5152 5128 5030 5030 5128 5130 5128 5129 5130 5130 5129 5131 5131 4966 5130 4966 4967 4914 5131 4967 4966 5129 5134 5131 5131 5134 5135 5131 5135 4968 4968 4967 5131 4914 4967 4968 4914 4968 4915 4915 4968 4969 4968 5135 4969 5042 4969 5135 5042 5135 5039 5039 5135 5134 5042 5039 5043 5039 5036 5040 5043 5039 5040 5039 5134 5036 5043 5040 5044 5044 5157 5043 5040 5036 5035 5040 5035 5041 5044 5040 5041 5034 5035 5036 5036 5134 5133 5036 5133 5034 5016 5035 5017 5017 5035 5034 5041 5035 5016 5041 5016 5006 5044 5041 5045 5045 5041 5006 4991 5010 5006 5045 5006 5010 5010 5038 5045 5045 5038 5156 5045 5156 5044 4991 5009 5010 5010 5009 5038 5009 5037 5038 5038 5037 5138 5038 5138 5156 5044 5156 5157 5156 5138 5140 5156 5140 5157 5037 5137 5138 5138 5137 5139 5138 5139 5140 5009 5008 5037 5008 5136 5037 5037 5136 5137 5137 5048 5139 5139 5048 5047 5017 5034 5018 5034 5133 5132 5034 5132 5018 4988 5017 5018 4988 5018 4999 5018 5132 4999 5125 4999 5132 5125 5132 5127 5127 5132 5133 5127 5133 5129 5129 5133 5134 5126 5125 5127 5126 5127 5128 5128 5127 5129 5124 5000 5125 5124 5125 5126 5000 4999 5125 4999 5000 4988 5153 5124 5126 5153 5126 5152 5152 5126 5128 5152 5122 5153 5152 5123 5122 5117 5122 5119 5119 5122 5123 5149 5102 5104 5149 5104 5031 5149 5098 5150 5150 5102 5149 5150 5100 5102 5150 5098 5097 5150 5097 5151 5151 5100 5150 5093 5097 5098 5015 5026 5100 5151 5015 5100 5159 5160 5161 5165 5160 5159 5161 5214 5159 5214 5215 5159 5159 5215 5216 5159 5216 5165 5164 5160 5165 5165 5216 5217 5165 5217 5164 5436 5342 5216 5436 5216 5215 5342 5217 5216 5214 5268 5215 5437 5436 5215 5437 5215 5268 5435 5434 5436 5435 5436 5437 5434 5342 5436 5452 5435 5437 5452 5437 5450 5450 5437 5268 5214 5267 5268 5450 5268 5267 5450 5267 5266 5338 5452 5450 5338 5450 5337 5337 5450 5266 5213 5266 5267 5213 5267 5214 5161 5213 5214 5211 5212 5213 5211 5213 5161 5212 5265 5213 5265 5266 5213 5337 5266 5265 5212 5264 5265 5265 5264 5337 5210 5212 5211 5210 5264 5212 5206 5210 5211 5206 5211 5453 5211 5161 5453 5161 5160 5453 5164 5163 5160 5160 5163 5453 5162 5163 5164 5217 5218 5164 5164 5218 5219 5164 5219 5162 5162 5166 5163 5162 5219 5220 5162 5220 5166 5220 5219 5341 5341 5219 5218 5341 5218 5342 5342 5218 5217 5341 5342 5343 5344 5220 5341 5344 5341 5345 5345 5341 5343 5220 5221 5166 5221 5220 5344 5328 5221 5344 5328 5344 5438 5438 5344 5345 5345 5343 5346 5438 5345 5439 5439 5345 5346 5439 5349 5438 5438 5349 5351 5438 5351 5328 5439 5346 5440 5440 5347 5439 5439 5347 5349 5431 5346 5432 5432 5346 5343 5440 5346 5431 5440 5431 5300 5300 5299 5440 5440 5299 5347 5299 5298 5347 5347 5298 5348 5347 5348 5349 5285 5298 5299 5285 5299 5300 5300 5303 5285 5300 5431 5303 5285 5286 5281 5291 5298 5285 5285 5303 5304 5285 5304 5286 5281 5291 5285 5291 5297 5298 5298 5297 5348 5290 5297 5291 5348 5297 5355 5297 5290 5355 5289 5290 5288 5288 5290 5291 5290 5289 5359 5355 5290 5359 5348 5355 5350 5350 5355 5356 5355 5359 5356 5359 5289 5360 5359 5360 5361 5356 5359 5361 5289 5288 5292 5289 5292 5360 5361 5360 5362 5360 5292 5367 5360 5367 5362 5361 5362 5363 5356 5361 5357 5357 5361 5363 5350 5356 5352 5352 5356 5357 5352 5357 5354 5354 5357 5358 5357 5363 5358 5363 5362 5364 5363 5364 5365 5358 5363 5365 5354 5358 5227 5227 5358 5228 5358 5365 5228 5365 5364 5366 5366 5230 5365 5365 5230 5229 5365 5229 5228 5174 5227 5228 5174 5228 5172 5172 5228 5229 5172 5229 5176 5176 5229 5230 5230 5231 5176 5366 5231 5230 5172 5176 5173 5173 5176 5177 5176 5231 5232 5176 5232 5177 5172 5173 5174 5174 5173 5171 5173 5177 5178 5173 5178 5453 5171 5173 5453 5177 5179 5178 5177 5232 5233 5177 5233 5179 5366 5370 5232 5232 5370 5233 5232 5231 5366 5179 5233 5234 5234 5233 5327 5327 5233 5370 5178 5179 5180 5179 5234 5180 5180 5234 5235 5235 5234 5327 5327 5370 5441 5441 5375 5327 5327 5375 5377 5327 5377 5235 5366 5369 5370 5441 5370 5369 5364 5369 5366 5364 5368 5369 5441 5369 5442 5442 5369 5368 5442 5373 5441 5441 5373 5375 5442 5368 5443 5443 5371 5442 5442 5371 5373 5362 5367 5368 5362 5368 5364 5443 5368 5367 5443 5367 5293 5293 5314 5443 5443 5314 5371 5314 5315 5371 5371 5315 5372 5371 5372 5373 5314 5293 5315 5292 5287 5293 5315 5293 5287 5293 5367 5292 5315 5287 5316 5315 5316 5372 5373 5372 5374 5372 5316 5379 5372 5379 5374 5316 5287 5308 5316 5308 5317 5316 5317 5379 5287 5288 5277 5292 5288 5287 5277 5308 5287 5277 5288 5278 5288 5291 5278 5277 5278 5279 5279 5308 5277 5279 5278 5280 5278 5291 5280 5280 5291 5281 5281 5282 5280 5280 5282 5275 5280 5275 5279 5279 5275 5276 5279 5276 5272 5272 5308 5279 5273 5274 5275 5275 5274 5276 5275 5302 5273 5282 5302 5275 5281 5286 5282 5286 5302 5282 5301 5302 5286 5301 5311 5302 5302 5311 5312 5302 5312 5283 5273 5302 5283 5283 5284 5273 5273 5284 5274 5284 5320 5274 5274 5320 5276 5283 5296 5284 5296 5318 5284 5284 5318 5319 5284 5319 5320 5283 5295 5296 5296 5295 5419 5318 5296 5449 5449 5296 5419 5449 5415 5318 5318 5415 5319 5324 5320 5319 5324 5319 5408 5408 5319 5415 5408 5415 5410 5410 5415 5416 5449 5416 5415 5448 5416 5449 5449 5419 5448 5410 5416 5412 5412 5416 5417 5448 5417 5416 5409 5408 5410 5409 5410 5411 5411 5410 5412 5407 5324 5408 5407 5408 5409 5404 5407 5409 5404 5409 5405 5405 5409 5411 5411 5412 5413 5405 5411 5406 5406 5411 5413 5400 5404 5405 5400 5405 5402 5402 5405 5406 5398 5403 5404 5398 5404 5400 5403 5407 5404 5399 5398 5400 5399 5400 5401 5401 5400 5402 5397 5396 5398 5397 5398 5399 5396 5403 5398 5396 5322 5403 5322 5323 5403 5403 5323 5407 5395 5321 5396 5395 5396 5397 5321 5322 5396 5321 5310 5322 5322 5310 5269 5322 5269 5323 5323 5269 5320 5323 5320 5324 5323 5324 5407 5269 5270 5271 5309 5270 5269 5309 5269 5310 5271 5320 5269 5276 5320 5271 5271 5270 5272 5272 5276 5271 5270 5308 5272 5306 5307 5270 5270 5307 5308 5306 5270 5309 5446 5391 5309 5309 5391 5306 5309 5310 5446 5307 5306 5384 5384 5306 5391 5317 5308 5307 5317 5307 5383 5383 5307 5384 5383 5384 5385 5385 5384 5386 5384 5391 5386 5386 5391 5392 5446 5392 5391 5385 5386 5387 5387 5386 5388 5386 5392 5388 5380 5383 5385 5380 5385 5381 5381 5385 5387 5379 5317 5383 5379 5383 5380 5374 5379 5380 5374 5380 5376 5376 5380 5381 5376 5381 5378 5378 5381 5382 5381 5387 5382 5375 5374 5376 5375 5376 5377 5377 5376 5378 5373 5374 5375 5378 5382 5239 5239 5238 5378 5378 5238 5237 5378 5237 5377 5377 5237 5236 5377 5236 5235 5236 5237 5183 5183 5237 5238 5183 5238 5185 5185 5238 5239 5181 5182 5183 5181 5183 5184 5184 5183 5185 5182 5236 5183 5182 5235 5236 5180 5235 5182 5180 5182 5181 5178 5180 5181 5181 5184 5453 5178 5181 5453 5184 5185 5186 5184 5186 5453 5186 5185 5187 5185 5239 5187 5186 5187 5188 5239 5240 5187 5187 5240 5241 5187 5241 5188 5239 5382 5240 5382 5389 5240 5389 5241 5240 5188 5241 5242 5389 5242 5241 5188 5189 5186 5188 5242 5189 5242 5243 5189 5390 5243 5242 5390 5242 5389 5387 5388 5389 5389 5388 5390 5382 5387 5389 5388 5393 5390 5390 5393 5394 5390 5394 5244 5244 5243 5390 5189 5243 5244 5186 5189 5190 5189 5244 5190 5190 5244 5245 5244 5394 5245 5326 5245 5394 5326 5394 5444 5444 5394 5393 5190 5245 5192 5192 5245 5246 5246 5245 5326 5186 5190 5191 5190 5192 5191 5186 5191 5453 5191 5192 5193 5191 5193 5194 5191 5194 5453 5192 5246 5193 5246 5247 5193 5247 5246 5326 5194 5193 5195 5193 5247 5248 5193 5248 5195 5194 5195 5196 5194 5196 5453 5196 5195 5197 5195 5248 5249 5195 5249 5197 5401 5249 5248 5401 5248 5247 5326 5401 5247 5326 5399 5401 5402 5249 5401 5249 5250 5197 5402 5250 5249 5402 5406 5251 5251 5250 5402 5197 5250 5251 5197 5251 5198 5198 5251 5252 5251 5406 5252 5406 5413 5252 5198 5252 5199 5199 5252 5253 5413 5253 5252 5196 5197 5198 5198 5199 5196 5196 5199 5200 5199 5253 5200 5200 5253 5254 5413 5254 5253 5413 5412 5414 5414 5254 5413 5200 5254 5202 5254 5255 5202 5414 5255 5254 5196 5200 5201 5200 5202 5201 5196 5201 5453 5201 5202 5203 5201 5203 5204 5201 5204 5453 5202 5255 5256 5202 5256 5203 5256 5255 5414 5203 5256 5257 5414 5418 5256 5256 5418 5257 5204 5203 5205 5203 5257 5205 5204 5205 5206 5206 5453 5204 5168 5171 5453 5163 5168 5453 5163 5167 5168 5167 5169 5168 5168 5169 5170 5168 5170 5171 5174 5171 5175 5175 5171 5170 5169 5224 5170 5224 5225 5170 5170 5225 5226 5170 5226 5175 5167 5223 5169 5169 5223 5224 5353 5225 5224 5353 5224 5223 5354 5226 5225 5354 5225 5353 5175 5226 5227 5227 5226 5354 5175 5227 5174 5353 5352 5354 5351 5352 5353 5328 5351 5353 5328 5353 5223 5167 5222 5223 5223 5222 5328 5222 5221 5328 5166 5221 5222 5166 5222 5167 5163 5166 5167 5349 5350 5351 5351 5350 5352 5349 5348 5350 5206 5205 5207 5206 5207 5208 5208 5209 5206 5206 5209 5210 5205 5257 5258 5205 5258 5207 5258 5259 5207 5207 5259 5260 5207 5260 5208 5208 5260 5261 5208 5261 5209 5425 5261 5260 5425 5260 5259 5259 5258 5325 5325 5425 5259 5258 5257 5325 5325 5257 5418 5325 5418 5447 5447 5423 5325 5325 5423 5425 5423 5424 5425 5425 5424 5426 5426 5261 5425 5261 5262 5209 5426 5262 5261 5424 5429 5426 5426 5429 5430 5426 5430 5263 5263 5262 5426 5209 5262 5263 5209 5263 5210 5210 5263 5264 5263 5430 5264 5337 5264 5430 5337 5430 5334 5334 5430 5429 5337 5334 5338 5334 5331 5335 5338 5334 5335 5334 5429 5331 5338 5335 5339 5339 5452 5338 5335 5331 5330 5335 5330 5336 5339 5335 5336 5329 5330 5331 5331 5429 5428 5331 5428 5329 5311 5330 5312 5312 5330 5329 5336 5330 5311 5336 5311 5301 5339 5336 5340 5340 5336 5301 5286 5305 5301 5340 5301 5305 5305 5333 5340 5340 5333 5451 5340 5451 5339 5286 5304 5305 5305 5304 5333 5304 5332 5333 5333 5332 5433 5333 5433 5451 5339 5451 5452 5451 5433 5435 5451 5435 5452 5332 5432 5433 5433 5432 5434 5433 5434 5435 5304 5303 5332 5303 5431 5332 5332 5431 5432 5432 5343 5434 5434 5343 5342 5312 5329 5313 5329 5428 5427 5329 5427 5313 5283 5312 5313 5283 5313 5294 5313 5427 5294 5420 5294 5427 5420 5427 5422 5422 5427 5428 5422 5428 5424 5424 5428 5429 5421 5420 5422 5421 5422 5423 5423 5422 5424 5419 5295 5420 5419 5420 5421 5295 5294 5420 5294 5295 5283 5448 5419 5421 5448 5421 5447 5447 5421 5423 5447 5417 5448 5447 5418 5417 5412 5417 5414 5414 5417 5418 5444 5397 5399 5444 5399 5326 5444 5393 5445 5445 5397 5444 5445 5395 5397 5445 5393 5392 5445 5392 5446 5446 5395 5445 5388 5392 5393 5310 5321 5395 5446 5310 5395 6155 6156 6157 6157 6159 6155 6155 6159 6160 6155 6160 6161 6183 6156 6155 6183 6155 6161 6157 6156 6158 6206 6158 6156 6206 6156 6183 6157 6182 6159 6158 6182 6157 6159 6182 6180 6159 6180 6160 6179 6178 6180 6179 6180 6181 6181 6180 6182 6160 6180 6178 6177 6178 6179 6181 6175 6179 6179 6175 6177 6177 6176 6178 6160 6178 6162 6162 6178 6176 6175 6176 6177 6175 6174 6176 6162 6176 6164 6164 6176 6174 6161 6160 6162 6161 6162 6163 6163 6162 6164 6163 6164 6165 6165 6164 6166 6164 6174 6166 6173 6172 6174 6173 6174 6175 6166 6174 6172 6165 6166 6167 6167 6166 6168 6166 6172 6168 6183 6163 6165 6183 6165 6167 6161 6163 6183 6181 6182 6183 6183 6182 6184 6183 6184 6185 6185 6206 6183 6167 6181 6183 6167 6175 6181 6169 6173 6175 6169 6175 6167 6167 6168 6169 6169 6168 6170 6169 6170 6171 6171 6173 6169 6171 6170 6172 6168 6172 6170 6171 6172 6173 6205 6158 6206 6185 6205 6206 6203 6204 6205 6205 6204 6158 6187 6203 6205 6187 6205 6185 6204 6182 6158 6203 6202 6204 6202 6200 6204 6204 6200 6182 6184 6182 6186 6186 6182 6200 6185 6184 6186 6185 6186 6187 6187 6186 6188 6186 6200 6188 6187 6188 6189 6189 6203 6187 6189 6188 6190 6188 6200 6190 6189 6190 6191 6191 6201 6189 6189 6201 6203 6191 6190 6192 6192 6190 6194 6194 6190 6200 6191 6192 6193 6193 6199 6191 6191 6199 6201 6199 6200 6201 6201 6200 6202 6201 6202 6203 6197 6198 6199 6199 6198 6200 6193 6197 6199 6193 6192 6194 6193 6194 6195 6195 6197 6193 6195 6194 6196 6194 6200 6196 6196 6200 6198 6197 6196 6198 6195 6196 6197 6207 6208 6209 6270 6271 6207 6207 6271 6272 6207 6272 6208 6380 6270 6207 6380 6207 6381 6381 6207 6209 6270 6269 6271 6329 6272 6271 6329 6271 6330 6330 6271 6269 6328 6208 6272 6328 6272 6329 6362 6328 6329 6362 6329 6363 6363 6329 6330 6330 6269 6331 6363 6330 6364 6364 6330 6331 6439 6362 6363 6439 6363 6440 6440 6363 6364 6361 6328 6362 6434 6361 6362 6434 6362 6439 6416 6434 6439 6416 6439 6440 6440 6441 6416 6440 6364 6441 6364 6331 6365 6441 6364 6365 6416 6441 6442 6441 6365 6442 6365 6331 6332 6365 6332 6366 6442 6365 6366 6416 6442 6443 6442 6366 6443 6366 6332 6333 6366 6333 6367 6443 6366 6367 6331 6267 6332 6332 6267 6265 6332 6265 6333 6333 6265 6263 6333 6263 6334 6367 6333 6334 6367 6334 6368 6443 6367 6447 6447 6367 6368 6447 6416 6443 6446 6416 6447 6447 6368 6446 6368 6334 6335 6368 6335 6369 6446 6368 6369 6334 6263 6261 6334 6261 6335 6335 6261 6259 6335 6259 6336 6369 6335 6336 6369 6336 6370 6446 6369 6444 6444 6369 6370 6444 6445 6446 6446 6445 6416 6444 6370 6445 6370 6336 6337 6370 6337 6338 6445 6370 6338 6336 6259 6257 6336 6257 6337 6337 6257 6255 6337 6255 6283 6337 6283 6338 6338 6283 6292 6338 6292 6339 6445 6338 6416 6416 6338 6339 6283 6291 6292 6292 6291 6293 6292 6293 6289 6339 6292 6289 6339 6289 6340 6416 6339 6418 6418 6339 6340 6340 6289 6307 6340 6307 6341 6418 6340 6420 6420 6340 6341 6417 6416 6418 6417 6418 6419 6419 6418 6420 6419 6420 6421 6421 6420 6422 6420 6341 6422 6341 6307 6308 6341 6308 6342 6422 6341 6342 6421 6422 6423 6423 6422 6424 6422 6342 6424 6423 6351 6421 6421 6351 6352 6421 6352 6419 6423 6424 6425 6425 6350 6423 6423 6350 6351 6425 6424 6426 6424 6342 6343 6424 6343 6426 6425 6426 6427 6427 6349 6425 6425 6349 6350 6349 6316 6350 6350 6316 6317 6350 6317 6351 6348 6315 6349 6349 6315 6316 6427 6348 6349 6427 6426 6428 6427 6428 6429 6429 6348 6427 6347 6314 6348 6348 6314 6315 6429 6347 6348 6314 6233 6315 6315 6233 6231 6315 6231 6316 6313 6235 6314 6314 6235 6233 6347 6313 6314 6346 6313 6347 6431 6346 6347 6431 6347 6429 6312 6237 6313 6313 6237 6235 6346 6312 6313 6234 6233 6235 6234 6235 6236 6236 6235 6237 6236 6237 6238 6238 6237 6239 6312 6239 6237 6311 6239 6312 6345 6311 6312 6345 6312 6346 6238 6239 6240 6240 6239 6241 6311 6241 6239 6395 6236 6238 6395 6238 6396 6396 6238 6240 6240 6241 6242 6396 6240 6397 6397 6240 6242 6242 6241 6243 6310 6243 6241 6310 6241 6311 6242 6243 6244 6397 6242 6398 6398 6242 6244 6398 6392 6397 6397 6392 6393 6397 6393 6396 6398 6244 6399 6399 6391 6398 6398 6391 6392 6244 6243 6245 6244 6245 6246 6399 6244 6246 6399 6246 6400 6400 6390 6399 6399 6390 6391 6390 6227 6391 6391 6227 6229 6391 6229 6392 6389 6225 6390 6390 6225 6227 6400 6389 6390 6400 6246 6248 6400 6248 6401 6401 6389 6400 6388 6223 6389 6389 6223 6225 6401 6388 6389 6223 6224 6225 6225 6224 6226 6225 6226 6227 6221 6222 6223 6223 6222 6224 6388 6221 6223 6387 6221 6388 6402 6387 6388 6402 6388 6401 6219 6220 6221 6221 6220 6222 6387 6219 6221 6320 6224 6222 6320 6222 6321 6321 6222 6220 6219 6218 6220 6321 6220 6322 6322 6220 6218 6217 6218 6219 6386 6217 6219 6386 6219 6387 6217 6216 6218 6322 6218 6323 6323 6218 6216 6355 6321 6322 6355 6322 6356 6356 6322 6323 6323 6216 6324 6356 6323 6357 6357 6323 6324 6215 6214 6216 6215 6216 6217 6324 6216 6214 6324 6214 6325 6357 6324 6358 6358 6324 6325 6437 6356 6357 6437 6357 6436 6436 6357 6358 6358 6325 6359 6436 6358 6435 6435 6358 6359 6325 6214 6212 6325 6212 6326 6359 6325 6326 6359 6326 6360 6435 6359 6432 6432 6359 6360 6416 6435 6432 6436 6435 6437 6437 6435 6416 6432 6433 6434 6432 6434 6416 6432 6360 6433 6360 6326 6327 6360 6327 6361 6433 6360 6361 6326 6212 6210 6326 6210 6327 6327 6210 6208 6327 6208 6328 6361 6327 6328 6433 6361 6434 6209 6208 6210 6209 6210 6211 6211 6210 6212 6381 6209 6382 6382 6209 6211 6211 6212 6213 6382 6211 6383 6383 6211 6213 6213 6212 6214 6213 6214 6215 6383 6213 6384 6384 6213 6215 6371 6382 6383 6385 6371 6383 6385 6383 6384 6384 6215 6385 6385 6215 6217 6385 6217 6386 6385 6386 6387 6387 6371 6385 6402 6372 6387 6387 6372 6371 6401 6250 6402 6402 6250 6372 6371 6372 6252 6252 6372 6250 6248 6249 6250 6250 6249 6251 6250 6251 6252 6401 6248 6250 6252 6251 6253 6252 6253 6254 6252 6254 6371 6254 6253 6255 6254 6255 6256 6371 6254 6256 6371 6256 6373 6373 6382 6371 6256 6255 6257 6256 6257 6258 6373 6256 6258 6373 6258 6374 6374 6382 6373 6258 6257 6259 6258 6259 6260 6374 6258 6260 6374 6260 6375 6375 6382 6374 6260 6259 6261 6260 6261 6262 6375 6260 6262 6375 6262 6376 6376 6377 6375 6375 6377 6382 6262 6261 6263 6262 6263 6264 6376 6262 6264 6376 6264 6377 6377 6264 6266 6377 6266 6378 6378 6382 6377 6264 6263 6265 6264 6265 6266 6266 6265 6267 6266 6267 6268 6378 6266 6268 6378 6268 6379 6379 6382 6378 6379 6381 6382 6379 6268 6270 6379 6270 6380 6380 6381 6379 6268 6267 6269 6268 6269 6270 6331 6269 6267 6253 6274 6255 6274 6275 6255 6255 6275 6276 6255 6276 6277 6277 6278 6255 6255 6278 6279 6255 6279 6280 6283 6255 6280 6276 6275 6404 6404 6275 6274 6276 6404 6277 6277 6404 6403 6277 6403 6278 6403 6279 6278 6403 6280 6279 6283 6280 6281 6412 6281 6280 6412 6280 6403 6403 6404 6405 6412 6403 6413 6413 6403 6405 6404 6274 6405 6273 6274 6253 6405 6274 6273 6253 6306 6273 6405 6273 6411 6411 6273 6306 6251 6305 6253 6253 6305 6306 6411 6306 6305 6251 6304 6305 6305 6304 6411 6303 6304 6251 6411 6304 6303 6251 6302 6303 6411 6303 6302 6410 6408 6411 6411 6408 6405 6411 6302 6410 6251 6301 6302 6410 6302 6301 6409 6406 6410 6410 6406 6408 6410 6300 6409 6410 6301 6300 6300 6301 6251 6251 6299 6300 6409 6300 6299 6409 6299 6406 6251 6298 6299 6406 6299 6298 6297 6298 6251 6297 6251 6289 6289 6251 6249 6406 6298 6297 6289 6296 6297 6296 6406 6297 6289 6295 6296 6295 6407 6296 6296 6407 6406 6288 6295 6289 6295 6288 6407 6406 6407 6408 6294 6408 6407 6407 6288 6287 6407 6287 6294 6287 6288 6289 6289 6294 6287 6289 6293 6294 6294 6293 6408 6289 6249 6307 6307 6249 6247 6307 6247 6308 6246 6245 6247 6246 6247 6248 6248 6247 6249 6308 6247 6245 6308 6245 6309 6342 6308 6309 6309 6245 6243 6309 6243 6310 6342 6309 6343 6343 6309 6310 6343 6310 6344 6344 6310 6311 6426 6343 6344 6344 6311 6345 6426 6344 6428 6428 6344 6345 6428 6345 6430 6430 6345 6346 6429 6428 6430 6429 6430 6431 6430 6346 6431 6414 6405 6408 6408 6293 6291 6408 6291 6414 6413 6405 6414 6414 6286 6413 6414 6291 6290 6414 6290 6286 6283 6290 6291 6286 6290 6283 6283 6285 6286 6413 6286 6285 6282 6412 6413 6282 6413 6284 6413 6285 6284 6283 6284 6285 6281 6282 6283 6282 6284 6283 6281 6412 6282 6415 6416 6417 6437 6416 6438 6438 6416 6415 6417 6354 6415 6415 6354 6355 6415 6355 6438 6419 6353 6417 6417 6353 6354 6353 6320 6354 6354 6320 6321 6354 6321 6355 6438 6355 6356 6438 6356 6437 6319 6224 6320 6353 6319 6320 6352 6319 6353 6419 6352 6353 6318 6226 6319 6319 6226 6224 6352 6318 6319 6351 6318 6352 6317 6228 6318 6318 6228 6226 6351 6317 6318 6227 6226 6228 6227 6228 6229 6228 6230 6229 6317 6230 6228 6316 6230 6317 6229 6230 6231 6316 6231 6230 6229 6231 6232 6392 6229 6232 6232 6231 6233 6232 6233 6234 6392 6232 6393 6393 6232 6234 6393 6234 6394 6394 6234 6236 6396 6393 6394 6394 6236 6395 6396 6394 6395 6448 6449 6450 6462 6454 6448 6462 6448 6463 6463 6448 6450 6465 6449 6448 6465 6448 6466 6466 6448 6451 6751 6448 6752 6752 6448 6454 6753 6451 6448 6753 6448 6751 6751 6752 6760 6760 6761 6751 6751 6761 6762 6751 6762 6753 6744 6451 6753 6744 6753 6757 6753 6762 6772 6757 6753 6772 6762 6761 6772 6772 6761 6760 6760 6752 6772 6752 6454 6749 6763 6752 6749 6752 6763 6772 6749 6454 6750 6750 6764 6749 6749 6764 6765 6749 6765 6763 6763 6765 6772 6772 6765 6764 6764 6750 6772 6750 6454 6480 6750 6480 6747 6747 6768 6750 6750 6768 6772 6747 6480 6748 6747 6748 6766 6766 6767 6747 6747 6767 6768 6768 6767 6772 6767 6766 6772 6772 6766 6748 6748 6480 6457 6748 6457 6745 6745 6771 6748 6748 6771 6772 6745 6457 6746 6745 6746 6769 6769 6770 6745 6745 6770 6771 6771 6770 6772 6772 6770 6769 6769 6746 6772 6746 6457 6471 6746 6471 6742 6742 6756 6746 6746 6756 6772 6742 6471 6743 6742 6743 6754 6754 6755 6742 6742 6755 6756 6756 6755 6772 6755 6754 6772 6772 6754 6743 6743 6471 6451 6743 6451 6744 6744 6759 6743 6743 6759 6772 6772 6758 6757 6759 6758 6772 6744 6758 6759 6757 6758 6744 6451 6452 6453 6466 6451 6467 6467 6451 6453 6469 6452 6451 6469 6451 6470 6470 6451 6471 6497 6467 6453 6497 6453 6498 6498 6453 6452 6496 6466 6467 6496 6467 6497 6495 6465 6466 6495 6466 6496 6533 6495 6496 6533 6496 6534 6534 6496 6535 6535 6496 6497 6532 6495 6533 6532 6533 6711 6711 6533 6534 6711 6534 6712 6534 6535 6712 6535 6497 6536 6712 6535 6536 6712 6536 6713 6607 6711 6712 6607 6712 6611 6611 6712 6612 6612 6712 6713 6536 6497 6537 6536 6537 6713 6537 6497 6498 6537 6498 6538 6713 6537 6538 6498 6452 6499 6538 6498 6539 6539 6498 6499 6713 6538 6714 6714 6538 6539 6539 6499 6540 6714 6539 6540 6499 6452 6468 6499 6468 6500 6540 6499 6541 6541 6499 6500 6468 6452 6469 6500 6468 6469 6500 6469 6501 6541 6500 6542 6542 6500 6543 6543 6500 6501 6540 6541 6715 6715 6541 6542 6540 6715 6714 6715 6542 6716 6714 6715 6614 6716 6619 6715 6715 6619 6618 6715 6618 6614 6543 6716 6542 6543 6501 6544 6544 6716 6543 6544 6717 6716 6717 6621 6716 6716 6621 6619 6615 6618 6619 6615 6619 6620 6619 6621 6620 6614 6618 6615 6614 6615 6616 6714 6614 6616 6616 6615 6613 6620 6697 6615 6615 6697 6698 6615 6698 6613 6616 6613 6617 6617 6714 6616 6617 6713 6714 6617 6613 6612 6612 6713 6617 6608 6612 6613 6613 6698 6699 6613 6699 6608 6698 6697 6699 6608 6699 6700 6699 6697 6695 6699 6695 6700 6608 6700 6606 6606 6700 6701 6700 6695 6702 6700 6702 6701 6606 6701 6603 6603 6701 6702 6603 6605 6606 6609 6608 6606 6609 6606 6610 6610 6606 6605 6598 6602 6603 6602 6604 6603 6603 6604 6605 6603 6702 6598 6604 6710 6605 6605 6710 6610 6610 6710 6711 6610 6711 6609 6607 6608 6609 6609 6711 6607 6710 6532 6711 6531 6495 6532 6710 6531 6532 6530 6494 6531 6531 6494 6495 6530 6531 6710 6494 6465 6495 6493 6464 6494 6494 6464 6465 6529 6493 6494 6529 6494 6530 6709 6529 6530 6709 6530 6710 6528 6493 6529 6528 6529 6709 6708 6528 6709 6602 6708 6709 6602 6709 6604 6604 6709 6710 6527 6493 6528 6708 6527 6528 6526 6492 6527 6527 6492 6493 6526 6527 6708 6525 6492 6526 6708 6706 6526 6526 6706 6525 6491 6450 6492 6492 6450 6449 6492 6449 6493 6525 6491 6492 6524 6491 6525 6525 6706 6524 6490 6463 6491 6491 6463 6450 6490 6491 6524 6524 6591 6490 6524 6706 6707 6524 6707 6591 6489 6462 6490 6490 6462 6463 6490 6591 6592 6490 6592 6489 6591 6707 6592 6592 6707 6740 6706 6600 6707 6707 6600 6594 6707 6594 6740 6489 6592 6593 6592 6740 6593 6593 6740 6741 6740 6594 6679 6740 6679 6741 6594 6595 6596 6600 6595 6594 6596 6679 6594 6599 6595 6600 6706 6599 6600 6599 6598 6595 6598 6703 6595 6595 6703 6704 6595 6704 6596 6597 6598 6599 6597 6599 6706 6597 6601 6598 6598 6601 6602 6598 6702 6703 6704 6703 6702 6596 6704 6705 6705 6704 6680 6680 6704 6702 6596 6705 6676 6676 6705 6680 6676 6680 6673 6673 6680 6681 6680 6702 6681 6673 6675 6676 6675 6677 6676 6676 6677 6678 6676 6678 6596 6673 6674 6675 6674 6739 6675 6739 6677 6675 6739 6741 6677 6741 6678 6677 6596 6678 6679 6741 6679 6678 6593 6741 6587 6587 6741 6739 6489 6593 6587 6523 6489 6587 6587 6588 6523 6739 6588 6587 6523 6461 6489 6489 6461 6462 6522 6460 6523 6523 6460 6461 6523 6588 6589 6523 6589 6522 6739 6589 6588 6522 6589 6590 6738 6590 6589 6738 6589 6739 6674 6738 6739 6737 6583 6738 6583 6590 6738 6672 6737 6738 6672 6738 6674 6522 6590 6583 6521 6522 6583 6583 6584 6521 6737 6584 6583 6520 6456 6521 6521 6456 6455 6521 6455 6522 6521 6584 6585 6521 6585 6520 6585 6584 6737 6520 6585 6586 6736 6586 6585 6736 6585 6737 6520 6586 6579 6579 6586 6736 6669 6670 6736 6736 6670 6735 6736 6735 6579 6669 6736 6667 6667 6736 6737 6519 6520 6579 6579 6580 6519 6579 6735 6580 6519 6488 6520 6520 6488 6456 6487 6454 6488 6488 6454 6456 6519 6487 6488 6454 6455 6456 6461 6455 6454 6461 6454 6462 6487 6480 6454 6486 6480 6487 6518 6486 6487 6518 6487 6519 6485 6478 6486 6486 6478 6480 6517 6485 6486 6517 6486 6518 6516 6478 6485 6516 6485 6517 6478 6479 6480 6515 6479 6478 6515 6478 6516 6515 6516 6571 6517 6577 6516 6516 6577 6578 6516 6578 6571 6514 6479 6515 6571 6572 6515 6515 6572 6573 6515 6573 6514 6480 6479 6481 6514 6481 6479 6482 6457 6480 6482 6480 6483 6483 6480 6481 6483 6481 6484 6513 6484 6481 6513 6481 6514 6511 6482 6483 6511 6483 6512 6512 6483 6484 6512 6484 6513 6513 6514 6567 6567 6568 6513 6513 6568 6569 6513 6569 6512 6511 6512 6563 6512 6569 6570 6512 6570 6563 6728 6570 6569 6728 6569 6729 6569 6568 6729 6729 6568 6567 6729 6567 6730 6653 6728 6729 6653 6729 6652 6652 6729 6650 6650 6729 6730 6652 6649 6653 6653 6649 6648 6648 6728 6653 6650 6651 6652 6652 6651 6649 6650 6654 6651 6650 6730 6654 6651 6654 6655 6651 6655 6656 6656 6686 6651 6651 6686 6687 6651 6687 6649 6654 6730 6655 6660 6656 6655 6655 6730 6731 6655 6731 6660 6659 6656 6660 6660 6731 6732 6660 6732 6659 6730 6573 6731 6573 6572 6731 6731 6572 6571 6731 6571 6732 6567 6574 6730 6730 6574 6573 6514 6573 6574 6514 6574 6567 6732 6571 6578 6732 6578 6577 6577 6733 6732 6732 6733 6657 6732 6657 6659 6517 6576 6577 6577 6576 6733 6517 6518 6575 6575 6576 6517 6733 6576 6575 6518 6582 6575 6733 6575 6734 6582 6734 6575 6519 6581 6518 6518 6581 6582 6581 6734 6582 6581 6735 6734 6735 6664 6734 6734 6664 6662 6734 6662 6733 6519 6580 6581 6580 6735 6581 6670 6665 6735 6735 6665 6664 6662 6664 6663 6663 6664 6665 6658 6661 6662 6658 6662 6663 6733 6662 6661 6733 6661 6657 6657 6661 6658 6657 6658 6659 6659 6658 6656 6663 6684 6658 6658 6684 6685 6658 6685 6656 6656 6685 6686 6702 6686 6685 6685 6684 6702 6663 6683 6684 6702 6684 6683 6666 6682 6683 6666 6683 6663 6702 6683 6682 6668 6681 6682 6668 6682 6666 6681 6702 6682 6673 6681 6668 6668 6672 6673 6672 6674 6673 6668 6671 6672 6671 6737 6672 6667 6671 6668 6667 6737 6671 6667 6668 6669 6669 6668 6666 6669 6666 6670 6670 6666 6665 6663 6665 6666 6688 6687 6702 6702 6687 6686 6688 6702 6689 6689 6702 6691 6693 6691 6702 6693 6702 6694 6694 6702 6695 6649 6687 6688 6646 6648 6649 6649 6688 6646 6641 6645 6646 6645 6647 6646 6646 6647 6648 6646 6688 6689 6646 6689 6641 6647 6728 6648 6645 6727 6647 6647 6727 6728 6641 6644 6645 6644 6726 6645 6645 6726 6727 6726 6565 6727 6565 6564 6727 6727 6564 6563 6727 6563 6728 6563 6570 6728 6563 6564 6511 6511 6564 6565 6511 6565 6510 6510 6565 6566 6726 6566 6565 6510 6482 6511 6509 6458 6510 6510 6458 6482 6509 6510 6559 6510 6566 6559 6559 6566 6726 6559 6560 6509 6725 6560 6559 6725 6559 6726 6509 6560 6561 6561 6560 6725 6509 6561 6508 6508 6561 6562 6724 6562 6561 6724 6561 6725 6508 6562 6558 6558 6562 6724 6723 6558 6724 6638 6723 6724 6638 6724 6643 6643 6724 6725 6557 6508 6558 6723 6557 6558 6722 6556 6723 6556 6557 6723 6637 6722 6723 6637 6723 6638 6636 6637 6638 6636 6638 6639 6643 6639 6638 6642 6639 6643 6643 6725 6642 6642 6641 6639 6641 6690 6639 6639 6690 6691 6639 6691 6636 6640 6641 6642 6642 6725 6640 6640 6725 6726 6640 6644 6641 6640 6726 6644 6641 6689 6690 6689 6691 6690 6636 6691 6692 6692 6691 6693 6636 6692 6633 6633 6692 6693 6633 6693 6630 6630 6693 6694 6630 6632 6633 6632 6634 6633 6633 6634 6635 6633 6635 6636 6635 6637 6636 6634 6722 6635 6635 6722 6637 6632 6721 6634 6634 6721 6722 6630 6631 6632 6631 6721 6632 6720 6552 6721 6552 6553 6721 6721 6553 6554 6721 6554 6722 6631 6720 6721 6554 6555 6722 6722 6555 6556 6553 6506 6554 6554 6506 6555 6552 6505 6553 6553 6505 6506 6551 6505 6552 6720 6551 6552 6504 6474 6505 6505 6474 6475 6505 6475 6506 6551 6504 6505 6506 6475 6476 6506 6476 6507 6555 6506 6507 6555 6507 6556 6556 6507 6557 6507 6476 6477 6507 6477 6508 6557 6507 6508 6475 6457 6476 6476 6457 6459 6476 6459 6477 6474 6471 6475 6475 6471 6457 6457 6458 6459 6458 6457 6482 6508 6477 6459 6508 6459 6509 6509 6459 6458 6470 6471 6472 6474 6472 6471 6501 6469 6470 6501 6470 6502 6502 6470 6472 6473 6472 6474 6502 6472 6503 6503 6472 6473 6504 6473 6474 6503 6473 6504 6547 6502 6503 6547 6503 6548 6548 6503 6549 6549 6503 6504 6549 6504 6550 6550 6504 6551 6548 6549 6719 6719 6549 6550 6718 6547 6548 6718 6548 6719 6546 6502 6547 6546 6547 6718 6626 6627 6718 6718 6627 6717 6718 6717 6546 6626 6718 6624 6624 6718 6719 6545 6502 6546 6546 6717 6545 6545 6717 6544 6627 6622 6717 6717 6622 6621 6626 6623 6627 6627 6623 6622 6620 6621 6622 6620 6622 6623 6626 6625 6623 6625 6695 6623 6623 6695 6696 6623 6696 6620 6620 6696 6697 6697 6696 6695 6625 6694 6695 6630 6694 6625 6625 6629 6630 6629 6631 6630 6625 6628 6629 6628 6719 6629 6629 6719 6720 6629 6720 6631 6624 6628 6625 6624 6719 6628 6719 6550 6720 6550 6551 6720 6624 6625 6626 6544 6501 6545 6545 6501 6502 6460 6455 6461 6522 6455 6460 6601 6708 6602 6601 6597 6708 6708 6597 6706 6493 6449 6464 6464 6449 6465 6607 6611 6608 6608 6611 6612 6773 6774 6775 6787 6779 6773 6787 6773 6788 6788 6773 6775 6790 6774 6773 6790 6773 6791 6791 6773 6776 7076 6773 7077 7077 6773 6779 7078 6776 6773 7078 6773 7076 7076 7077 7085 7085 7086 7076 7076 7086 7087 7076 7087 7078 7069 6776 7078 7069 7078 7082 7078 7087 7097 7082 7078 7097 7087 7086 7097 7097 7086 7085 7085 7077 7097 7077 6779 7074 7088 7077 7074 7077 7088 7097 7074 6779 7075 7075 7089 7074 7074 7089 7090 7074 7090 7088 7088 7090 7097 7097 7090 7089 7089 7075 7097 7075 6779 6805 7075 6805 7072 7072 7093 7075 7075 7093 7097 7072 6805 7073 7072 7073 7091 7091 7092 7072 7072 7092 7093 7093 7092 7097 7092 7091 7097 7097 7091 7073 7073 6805 6782 7073 6782 7070 7070 7096 7073 7073 7096 7097 7070 6782 7071 7070 7071 7094 7094 7095 7070 7070 7095 7096 7096 7095 7097 7097 7095 7094 7094 7071 7097 7071 6782 6796 7071 6796 7067 7067 7081 7071 7071 7081 7097 7067 6796 7068 7067 7068 7079 7079 7080 7067 7067 7080 7081 7081 7080 7097 7080 7079 7097 7097 7079 7068 7068 6796 6776 7068 6776 7069 7069 7084 7068 7068 7084 7097 7097 7083 7082 7084 7083 7097 7069 7083 7084 7082 7083 7069 6776 6777 6778 6791 6776 6792 6792 6776 6778 6794 6777 6776 6794 6776 6795 6795 6776 6796 6822 6792 6778 6822 6778 6823 6823 6778 6777 6821 6791 6792 6821 6792 6822 6820 6790 6791 6820 6791 6821 6858 6820 6821 6858 6821 6859 6859 6821 6860 6860 6821 6822 6857 6820 6858 6857 6858 7036 7036 6858 6859 7036 6859 7037 6859 6860 7037 6860 6822 6861 7037 6860 6861 7037 6861 7038 6932 7036 7037 6932 7037 6936 6936 7037 6937 6937 7037 7038 6861 6822 6862 6861 6862 7038 6862 6822 6823 6862 6823 6863 7038 6862 6863 6823 6777 6824 6863 6823 6864 6864 6823 6824 7038 6863 7039 7039 6863 6864 6864 6824 6865 7039 6864 6865 6824 6777 6793 6824 6793 6825 6865 6824 6866 6866 6824 6825 6793 6777 6794 6825 6793 6794 6825 6794 6826 6866 6825 6867 6867 6825 6868 6868 6825 6826 6865 6866 7040 7040 6866 6867 6865 7040 7039 7040 6867 7041 7039 7040 6939 7041 6944 7040 7040 6944 6943 7040 6943 6939 6868 7041 6867 6868 6826 6869 6869 7041 6868 6869 7042 7041 7042 6946 7041 7041 6946 6944 6940 6943 6944 6940 6944 6945 6944 6946 6945 6939 6943 6940 6939 6940 6941 7039 6939 6941 6941 6940 6938 6945 7022 6940 6940 7022 7023 6940 7023 6938 6941 6938 6942 6942 7039 6941 6942 7038 7039 6942 6938 6937 6937 7038 6942 6933 6937 6938 6938 7023 7024 6938 7024 6933 7023 7022 7024 6933 7024 7025 7024 7022 7020 7024 7020 7025 6933 7025 6931 6931 7025 7026 7025 7020 7027 7025 7027 7026 6931 7026 6928 6928 7026 7027 6928 6930 6931 6934 6933 6931 6934 6931 6935 6935 6931 6930 6923 6927 6928 6927 6929 6928 6928 6929 6930 6928 7027 6923 6929 7035 6930 6930 7035 6935 6935 7035 7036 6935 7036 6934 6932 6933 6934 6934 7036 6932 7035 6857 7036 6856 6820 6857 7035 6856 6857 6855 6819 6856 6856 6819 6820 6855 6856 7035 6819 6790 6820 6818 6789 6819 6819 6789 6790 6854 6818 6819 6854 6819 6855 7034 6854 6855 7034 6855 7035 6853 6818 6854 6853 6854 7034 7033 6853 7034 6927 7033 7034 6927 7034 6929 6929 7034 7035 6852 6818 6853 7033 6852 6853 6851 6817 6852 6852 6817 6818 6851 6852 7033 6850 6817 6851 7033 7031 6851 6851 7031 6850 6816 6775 6817 6817 6775 6774 6817 6774 6818 6850 6816 6817 6849 6816 6850 6850 7031 6849 6815 6788 6816 6816 6788 6775 6815 6816 6849 6849 6916 6815 6849 7031 7032 6849 7032 6916 6814 6787 6815 6815 6787 6788 6815 6916 6917 6815 6917 6814 6916 7032 6917 6917 7032 7065 7031 6925 7032 7032 6925 6919 7032 6919 7065 6814 6917 6918 6917 7065 6918 6918 7065 7066 7065 6919 7004 7065 7004 7066 6919 6920 6921 6925 6920 6919 6921 7004 6919 6924 6920 6925 7031 6924 6925 6924 6923 6920 6923 7028 6920 6920 7028 7029 6920 7029 6921 6922 6923 6924 6922 6924 7031 6922 6926 6923 6923 6926 6927 6923 7027 7028 7029 7028 7027 6921 7029 7030 7030 7029 7005 7005 7029 7027 6921 7030 7001 7001 7030 7005 7001 7005 6998 6998 7005 7006 7005 7027 7006 6998 7000 7001 7000 7002 7001 7001 7002 7003 7001 7003 6921 6998 6999 7000 6999 7064 7000 7064 7002 7000 7064 7066 7002 7066 7003 7002 6921 7003 7004 7066 7004 7003 6918 7066 6912 6912 7066 7064 6814 6918 6912 6848 6814 6912 6912 6913 6848 7064 6913 6912 6848 6786 6814 6814 6786 6787 6847 6785 6848 6848 6785 6786 6848 6913 6914 6848 6914 6847 7064 6914 6913 6847 6914 6915 7063 6915 6914 7063 6914 7064 6999 7063 7064 7062 6908 7063 6908 6915 7063 6997 7062 7063 6997 7063 6999 6847 6915 6908 6846 6847 6908 6908 6909 6846 7062 6909 6908 6845 6781 6846 6846 6781 6780 6846 6780 6847 6846 6909 6910 6846 6910 6845 6910 6909 7062 6845 6910 6911 7061 6911 6910 7061 6910 7062 6845 6911 6904 6904 6911 7061 6994 6995 7061 7061 6995 7060 7061 7060 6904 6994 7061 6992 6992 7061 7062 6844 6845 6904 6904 6905 6844 6904 7060 6905 6844 6813 6845 6845 6813 6781 6812 6779 6813 6813 6779 6781 6844 6812 6813 6779 6780 6781 6786 6780 6779 6786 6779 6787 6812 6805 6779 6811 6805 6812 6843 6811 6812 6843 6812 6844 6810 6803 6811 6811 6803 6805 6842 6810 6811 6842 6811 6843 6841 6803 6810 6841 6810 6842 6803 6804 6805 6840 6804 6803 6840 6803 6841 6840 6841 6896 6842 6902 6841 6841 6902 6903 6841 6903 6896 6839 6804 6840 6896 6897 6840 6840 6897 6898 6840 6898 6839 6805 6804 6806 6839 6806 6804 6807 6782 6805 6807 6805 6808 6808 6805 6806 6808 6806 6809 6838 6809 6806 6838 6806 6839 6836 6807 6808 6836 6808 6837 6837 6808 6809 6837 6809 6838 6838 6839 6892 6892 6893 6838 6838 6893 6894 6838 6894 6837 6836 6837 6888 6837 6894 6895 6837 6895 6888 7053 6895 6894 7053 6894 7054 6894 6893 7054 7054 6893 6892 7054 6892 7055 6978 7053 7054 6978 7054 6977 6977 7054 6975 6975 7054 7055 6977 6974 6978 6978 6974 6973 6973 7053 6978 6975 6976 6977 6977 6976 6974 6975 6979 6976 6975 7055 6979 6976 6979 6980 6976 6980 6981 6981 7011 6976 6976 7011 7012 6976 7012 6974 6979 7055 6980 6985 6981 6980 6980 7055 7056 6980 7056 6985 6984 6981 6985 6985 7056 7057 6985 7057 6984 7055 6898 7056 6898 6897 7056 7056 6897 6896 7056 6896 7057 6892 6899 7055 7055 6899 6898 6839 6898 6899 6839 6899 6892 7057 6896 6903 7057 6903 6902 6902 7058 7057 7057 7058 6982 7057 6982 6984 6842 6901 6902 6902 6901 7058 6842 6843 6900 6900 6901 6842 7058 6901 6900 6843 6907 6900 7058 6900 7059 6907 7059 6900 6844 6906 6843 6843 6906 6907 6906 7059 6907 6906 7060 7059 7060 6989 7059 7059 6989 6987 7059 6987 7058 6844 6905 6906 6905 7060 6906 6995 6990 7060 7060 6990 6989 6987 6989 6988 6988 6989 6990 6983 6986 6987 6983 6987 6988 7058 6987 6986 7058 6986 6982 6982 6986 6983 6982 6983 6984 6984 6983 6981 6988 7009 6983 6983 7009 7010 6983 7010 6981 6981 7010 7011 7027 7011 7010 7010 7009 7027 6988 7008 7009 7027 7009 7008 6991 7007 7008 6991 7008 6988 7027 7008 7007 6993 7006 7007 6993 7007 6991 7006 7027 7007 6998 7006 6993 6993 6997 6998 6997 6999 6998 6993 6996 6997 6996 7062 6997 6992 6996 6993 6992 7062 6996 6992 6993 6994 6994 6993 6991 6994 6991 6995 6995 6991 6990 6988 6990 6991 7013 7012 7027 7027 7012 7011 7013 7027 7014 7014 7027 7016 7018 7016 7027 7018 7027 7019 7019 7027 7020 6974 7012 7013 6971 6973 6974 6974 7013 6971 6966 6970 6971 6970 6972 6971 6971 6972 6973 6971 7013 7014 6971 7014 6966 6972 7053 6973 6970 7052 6972 6972 7052 7053 6966 6969 6970 6969 7051 6970 6970 7051 7052 7051 6890 7052 6890 6889 7052 7052 6889 6888 7052 6888 7053 6888 6895 7053 6888 6889 6836 6836 6889 6890 6836 6890 6835 6835 6890 6891 7051 6891 6890 6835 6807 6836 6834 6783 6835 6835 6783 6807 6834 6835 6884 6835 6891 6884 6884 6891 7051 6884 6885 6834 7050 6885 6884 7050 6884 7051 6834 6885 6886 6886 6885 7050 6834 6886 6833 6833 6886 6887 7049 6887 6886 7049 6886 7050 6833 6887 6883 6883 6887 7049 7048 6883 7049 6963 7048 7049 6963 7049 6968 6968 7049 7050 6882 6833 6883 7048 6882 6883 7047 6881 7048 6881 6882 7048 6962 7047 7048 6962 7048 6963 6961 6962 6963 6961 6963 6964 6968 6964 6963 6967 6964 6968 6968 7050 6967 6967 6966 6964 6966 7015 6964 6964 7015 7016 6964 7016 6961 6965 6966 6967 6967 7050 6965 6965 7050 7051 6965 6969 6966 6965 7051 6969 6966 7014 7015 7014 7016 7015 6961 7016 7017 7017 7016 7018 6961 7017 6958 6958 7017 7018 6958 7018 6955 6955 7018 7019 6955 6957 6958 6957 6959 6958 6958 6959 6960 6958 6960 6961 6960 6962 6961 6959 7047 6960 6960 7047 6962 6957 7046 6959 6959 7046 7047 6955 6956 6957 6956 7046 6957 7045 6877 7046 6877 6878 7046 7046 6878 6879 7046 6879 7047 6956 7045 7046 6879 6880 7047 7047 6880 6881 6878 6831 6879 6879 6831 6880 6877 6830 6878 6878 6830 6831 6876 6830 6877 7045 6876 6877 6829 6799 6830 6830 6799 6800 6830 6800 6831 6876 6829 6830 6831 6800 6801 6831 6801 6832 6880 6831 6832 6880 6832 6881 6881 6832 6882 6832 6801 6802 6832 6802 6833 6882 6832 6833 6800 6782 6801 6801 6782 6784 6801 6784 6802 6799 6796 6800 6800 6796 6782 6782 6783 6784 6783 6782 6807 6833 6802 6784 6833 6784 6834 6834 6784 6783 6795 6796 6797 6799 6797 6796 6826 6794 6795 6826 6795 6827 6827 6795 6797 6798 6797 6799 6827 6797 6828 6828 6797 6798 6829 6798 6799 6828 6798 6829 6872 6827 6828 6872 6828 6873 6873 6828 6874 6874 6828 6829 6874 6829 6875 6875 6829 6876 6873 6874 7044 7044 6874 6875 7043 6872 6873 7043 6873 7044 6871 6827 6872 6871 6872 7043 6951 6952 7043 7043 6952 7042 7043 7042 6871 6951 7043 6949 6949 7043 7044 6870 6827 6871 6871 7042 6870 6870 7042 6869 6952 6947 7042 7042 6947 6946 6951 6948 6952 6952 6948 6947 6945 6946 6947 6945 6947 6948 6951 6950 6948 6950 7020 6948 6948 7020 7021 6948 7021 6945 6945 7021 7022 7022 7021 7020 6950 7019 7020 6955 7019 6950 6950 6954 6955 6954 6956 6955 6950 6953 6954 6953 7044 6954 6954 7044 7045 6954 7045 6956 6949 6953 6950 6949 7044 6953 7044 6875 7045 6875 6876 7045 6949 6950 6951 6869 6826 6870 6870 6826 6827 6785 6780 6786 6847 6780 6785 6926 7033 6927 6926 6922 7033 7033 6922 7031 6818 6774 6789 6789 6774 6790 6932 6936 6933 6933 6936 6937 7098 7099 7100 7112 7104 7098 7112 7098 7113 7113 7098 7100 7115 7099 7098 7115 7098 7116 7116 7098 7101 7401 7098 7402 7402 7098 7104 7403 7101 7098 7403 7098 7401 7401 7402 7410 7410 7411 7401 7401 7411 7412 7401 7412 7403 7394 7101 7403 7394 7403 7407 7403 7412 7422 7407 7403 7422 7412 7411 7422 7422 7411 7410 7410 7402 7422 7402 7104 7399 7413 7402 7399 7402 7413 7422 7399 7104 7400 7400 7414 7399 7399 7414 7415 7399 7415 7413 7413 7415 7422 7422 7415 7414 7414 7400 7422 7400 7104 7130 7400 7130 7397 7397 7418 7400 7400 7418 7422 7397 7130 7398 7397 7398 7416 7416 7417 7397 7397 7417 7418 7418 7417 7422 7417 7416 7422 7422 7416 7398 7398 7130 7107 7398 7107 7395 7395 7421 7398 7398 7421 7422 7395 7107 7396 7395 7396 7419 7419 7420 7395 7395 7420 7421 7421 7420 7422 7422 7420 7419 7419 7396 7422 7396 7107 7121 7396 7121 7392 7392 7406 7396 7396 7406 7422 7392 7121 7393 7392 7393 7404 7404 7405 7392 7392 7405 7406 7406 7405 7422 7405 7404 7422 7422 7404 7393 7393 7121 7101 7393 7101 7394 7394 7409 7393 7393 7409 7422 7422 7408 7407 7409 7408 7422 7394 7408 7409 7407 7408 7394 7101 7102 7103 7116 7101 7117 7117 7101 7103 7119 7102 7101 7119 7101 7120 7120 7101 7121 7147 7117 7103 7147 7103 7148 7148 7103 7102 7146 7116 7117 7146 7117 7147 7145 7115 7116 7145 7116 7146 7183 7145 7146 7183 7146 7184 7184 7146 7185 7185 7146 7147 7182 7145 7183 7182 7183 7361 7361 7183 7184 7361 7184 7362 7184 7185 7362 7185 7147 7186 7362 7185 7186 7362 7186 7363 7257 7361 7362 7257 7362 7261 7261 7362 7262 7262 7362 7363 7186 7147 7187 7186 7187 7363 7187 7147 7148 7187 7148 7188 7363 7187 7188 7148 7102 7149 7188 7148 7189 7189 7148 7149 7363 7188 7364 7364 7188 7189 7189 7149 7190 7364 7189 7190 7149 7102 7118 7149 7118 7150 7190 7149 7191 7191 7149 7150 7118 7102 7119 7150 7118 7119 7150 7119 7151 7191 7150 7192 7192 7150 7193 7193 7150 7151 7190 7191 7365 7365 7191 7192 7190 7365 7364 7365 7192 7366 7364 7365 7264 7366 7269 7365 7365 7269 7268 7365 7268 7264 7193 7366 7192 7193 7151 7194 7194 7366 7193 7194 7367 7366 7367 7271 7366 7366 7271 7269 7265 7268 7269 7265 7269 7270 7269 7271 7270 7264 7268 7265 7264 7265 7266 7364 7264 7266 7266 7265 7263 7270 7347 7265 7265 7347 7348 7265 7348 7263 7266 7263 7267 7267 7364 7266 7267 7363 7364 7267 7263 7262 7262 7363 7267 7258 7262 7263 7263 7348 7349 7263 7349 7258 7348 7347 7349 7258 7349 7350 7349 7347 7345 7349 7345 7350 7258 7350 7256 7256 7350 7351 7350 7345 7352 7350 7352 7351 7256 7351 7253 7253 7351 7352 7253 7255 7256 7259 7258 7256 7259 7256 7260 7260 7256 7255 7248 7252 7253 7252 7254 7253 7253 7254 7255 7253 7352 7248 7254 7360 7255 7255 7360 7260 7260 7360 7361 7260 7361 7259 7257 7258 7259 7259 7361 7257 7360 7182 7361 7181 7145 7182 7360 7181 7182 7180 7144 7181 7181 7144 7145 7180 7181 7360 7144 7115 7145 7143 7114 7144 7144 7114 7115 7179 7143 7144 7179 7144 7180 7359 7179 7180 7359 7180 7360 7178 7143 7179 7178 7179 7359 7358 7178 7359 7252 7358 7359 7252 7359 7254 7254 7359 7360 7177 7143 7178 7358 7177 7178 7176 7142 7177 7177 7142 7143 7176 7177 7358 7175 7142 7176 7358 7356 7176 7176 7356 7175 7141 7100 7142 7142 7100 7099 7142 7099 7143 7175 7141 7142 7174 7141 7175 7175 7356 7174 7140 7113 7141 7141 7113 7100 7140 7141 7174 7174 7241 7140 7174 7356 7357 7174 7357 7241 7139 7112 7140 7140 7112 7113 7140 7241 7242 7140 7242 7139 7241 7357 7242 7242 7357 7390 7356 7250 7357 7357 7250 7244 7357 7244 7390 7139 7242 7243 7242 7390 7243 7243 7390 7391 7390 7244 7329 7390 7329 7391 7244 7245 7246 7250 7245 7244 7246 7329 7244 7249 7245 7250 7356 7249 7250 7249 7248 7245 7248 7353 7245 7245 7353 7354 7245 7354 7246 7247 7248 7249 7247 7249 7356 7247 7251 7248 7248 7251 7252 7248 7352 7353 7354 7353 7352 7246 7354 7355 7355 7354 7330 7330 7354 7352 7246 7355 7326 7326 7355 7330 7326 7330 7323 7323 7330 7331 7330 7352 7331 7323 7325 7326 7325 7327 7326 7326 7327 7328 7326 7328 7246 7323 7324 7325 7324 7389 7325 7389 7327 7325 7389 7391 7327 7391 7328 7327 7246 7328 7329 7391 7329 7328 7243 7391 7237 7237 7391 7389 7139 7243 7237 7173 7139 7237 7237 7238 7173 7389 7238 7237 7173 7111 7139 7139 7111 7112 7172 7110 7173 7173 7110 7111 7173 7238 7239 7173 7239 7172 7389 7239 7238 7172 7239 7240 7388 7240 7239 7388 7239 7389 7324 7388 7389 7387 7233 7388 7233 7240 7388 7322 7387 7388 7322 7388 7324 7172 7240 7233 7171 7172 7233 7233 7234 7171 7387 7234 7233 7170 7106 7171 7171 7106 7105 7171 7105 7172 7171 7234 7235 7171 7235 7170 7235 7234 7387 7170 7235 7236 7386 7236 7235 7386 7235 7387 7170 7236 7229 7229 7236 7386 7319 7320 7386 7386 7320 7385 7386 7385 7229 7319 7386 7317 7317 7386 7387 7169 7170 7229 7229 7230 7169 7229 7385 7230 7169 7138 7170 7170 7138 7106 7137 7104 7138 7138 7104 7106 7169 7137 7138 7104 7105 7106 7111 7105 7104 7111 7104 7112 7137 7130 7104 7136 7130 7137 7168 7136 7137 7168 7137 7169 7135 7128 7136 7136 7128 7130 7167 7135 7136 7167 7136 7168 7166 7128 7135 7166 7135 7167 7128 7129 7130 7165 7129 7128 7165 7128 7166 7165 7166 7221 7167 7227 7166 7166 7227 7228 7166 7228 7221 7164 7129 7165 7221 7222 7165 7165 7222 7223 7165 7223 7164 7130 7129 7131 7164 7131 7129 7132 7107 7130 7132 7130 7133 7133 7130 7131 7133 7131 7134 7163 7134 7131 7163 7131 7164 7161 7132 7133 7161 7133 7162 7162 7133 7134 7162 7134 7163 7163 7164 7217 7217 7218 7163 7163 7218 7219 7163 7219 7162 7161 7162 7213 7162 7219 7220 7162 7220 7213 7378 7220 7219 7378 7219 7379 7219 7218 7379 7379 7218 7217 7379 7217 7380 7303 7378 7379 7303 7379 7302 7302 7379 7300 7300 7379 7380 7302 7299 7303 7303 7299 7298 7298 7378 7303 7300 7301 7302 7302 7301 7299 7300 7304 7301 7300 7380 7304 7301 7304 7305 7301 7305 7306 7306 7336 7301 7301 7336 7337 7301 7337 7299 7304 7380 7305 7310 7306 7305 7305 7380 7381 7305 7381 7310 7309 7306 7310 7310 7381 7382 7310 7382 7309 7380 7223 7381 7223 7222 7381 7381 7222 7221 7381 7221 7382 7217 7224 7380 7380 7224 7223 7164 7223 7224 7164 7224 7217 7382 7221 7228 7382 7228 7227 7227 7383 7382 7382 7383 7307 7382 7307 7309 7167 7226 7227 7227 7226 7383 7167 7168 7225 7225 7226 7167 7383 7226 7225 7168 7232 7225 7383 7225 7384 7232 7384 7225 7169 7231 7168 7168 7231 7232 7231 7384 7232 7231 7385 7384 7385 7314 7384 7384 7314 7312 7384 7312 7383 7169 7230 7231 7230 7385 7231 7320 7315 7385 7385 7315 7314 7312 7314 7313 7313 7314 7315 7308 7311 7312 7308 7312 7313 7383 7312 7311 7383 7311 7307 7307 7311 7308 7307 7308 7309 7309 7308 7306 7313 7334 7308 7308 7334 7335 7308 7335 7306 7306 7335 7336 7352 7336 7335 7335 7334 7352 7313 7333 7334 7352 7334 7333 7316 7332 7333 7316 7333 7313 7352 7333 7332 7318 7331 7332 7318 7332 7316 7331 7352 7332 7323 7331 7318 7318 7322 7323 7322 7324 7323 7318 7321 7322 7321 7387 7322 7317 7321 7318 7317 7387 7321 7317 7318 7319 7319 7318 7316 7319 7316 7320 7320 7316 7315 7313 7315 7316 7338 7337 7352 7352 7337 7336 7338 7352 7339 7339 7352 7341 7343 7341 7352 7343 7352 7344 7344 7352 7345 7299 7337 7338 7296 7298 7299 7299 7338 7296 7291 7295 7296 7295 7297 7296 7296 7297 7298 7296 7338 7339 7296 7339 7291 7297 7378 7298 7295 7377 7297 7297 7377 7378 7291 7294 7295 7294 7376 7295 7295 7376 7377 7376 7215 7377 7215 7214 7377 7377 7214 7213 7377 7213 7378 7213 7220 7378 7213 7214 7161 7161 7214 7215 7161 7215 7160 7160 7215 7216 7376 7216 7215 7160 7132 7161 7159 7108 7160 7160 7108 7132 7159 7160 7209 7160 7216 7209 7209 7216 7376 7209 7210 7159 7375 7210 7209 7375 7209 7376 7159 7210 7211 7211 7210 7375 7159 7211 7158 7158 7211 7212 7374 7212 7211 7374 7211 7375 7158 7212 7208 7208 7212 7374 7373 7208 7374 7288 7373 7374 7288 7374 7293 7293 7374 7375 7207 7158 7208 7373 7207 7208 7372 7206 7373 7206 7207 7373 7287 7372 7373 7287 7373 7288 7286 7287 7288 7286 7288 7289 7293 7289 7288 7292 7289 7293 7293 7375 7292 7292 7291 7289 7291 7340 7289 7289 7340 7341 7289 7341 7286 7290 7291 7292 7292 7375 7290 7290 7375 7376 7290 7294 7291 7290 7376 7294 7291 7339 7340 7339 7341 7340 7286 7341 7342 7342 7341 7343 7286 7342 7283 7283 7342 7343 7283 7343 7280 7280 7343 7344 7280 7282 7283 7282 7284 7283 7283 7284 7285 7283 7285 7286 7285 7287 7286 7284 7372 7285 7285 7372 7287 7282 7371 7284 7284 7371 7372 7280 7281 7282 7281 7371 7282 7370 7202 7371 7202 7203 7371 7371 7203 7204 7371 7204 7372 7281 7370 7371 7204 7205 7372 7372 7205 7206 7203 7156 7204 7204 7156 7205 7202 7155 7203 7203 7155 7156 7201 7155 7202 7370 7201 7202 7154 7124 7155 7155 7124 7125 7155 7125 7156 7201 7154 7155 7156 7125 7126 7156 7126 7157 7205 7156 7157 7205 7157 7206 7206 7157 7207 7157 7126 7127 7157 7127 7158 7207 7157 7158 7125 7107 7126 7126 7107 7109 7126 7109 7127 7124 7121 7125 7125 7121 7107 7107 7108 7109 7108 7107 7132 7158 7127 7109 7158 7109 7159 7159 7109 7108 7120 7121 7122 7124 7122 7121 7151 7119 7120 7151 7120 7152 7152 7120 7122 7123 7122 7124 7152 7122 7153 7153 7122 7123 7154 7123 7124 7153 7123 7154 7197 7152 7153 7197 7153 7198 7198 7153 7199 7199 7153 7154 7199 7154 7200 7200 7154 7201 7198 7199 7369 7369 7199 7200 7368 7197 7198 7368 7198 7369 7196 7152 7197 7196 7197 7368 7276 7277 7368 7368 7277 7367 7368 7367 7196 7276 7368 7274 7274 7368 7369 7195 7152 7196 7196 7367 7195 7195 7367 7194 7277 7272 7367 7367 7272 7271 7276 7273 7277 7277 7273 7272 7270 7271 7272 7270 7272 7273 7276 7275 7273 7275 7345 7273 7273 7345 7346 7273 7346 7270 7270 7346 7347 7347 7346 7345 7275 7344 7345 7280 7344 7275 7275 7279 7280 7279 7281 7280 7275 7278 7279 7278 7369 7279 7279 7369 7370 7279 7370 7281 7274 7278 7275 7274 7369 7278 7369 7200 7370 7200 7201 7370 7274 7275 7276 7194 7151 7195 7195 7151 7152 7110 7105 7111 7172 7105 7110 7251 7358 7252 7251 7247 7358 7358 7247 7356 7143 7099 7114 7114 7099 7115 7257 7261 7258 7258 7261 7262 7423 7424 7425 7437 7429 7423 7437 7423 7438 7438 7423 7425 7440 7424 7423 7440 7423 7441 7441 7423 7426 7726 7423 7727 7727 7423 7429 7728 7426 7423 7728 7423 7726 7726 7727 7735 7735 7736 7726 7726 7736 7737 7726 7737 7728 7719 7426 7728 7719 7728 7732 7728 7737 7747 7732 7728 7747 7737 7736 7747 7747 7736 7735 7735 7727 7747 7727 7429 7724 7738 7727 7724 7727 7738 7747 7724 7429 7725 7725 7739 7724 7724 7739 7740 7724 7740 7738 7738 7740 7747 7747 7740 7739 7739 7725 7747 7725 7429 7455 7725 7455 7722 7722 7743 7725 7725 7743 7747 7722 7455 7723 7722 7723 7741 7741 7742 7722 7722 7742 7743 7743 7742 7747 7742 7741 7747 7747 7741 7723 7723 7455 7432 7723 7432 7720 7720 7746 7723 7723 7746 7747 7720 7432 7721 7720 7721 7744 7744 7745 7720 7720 7745 7746 7746 7745 7747 7747 7745 7744 7744 7721 7747 7721 7432 7446 7721 7446 7717 7717 7731 7721 7721 7731 7747 7717 7446 7718 7717 7718 7729 7729 7730 7717 7717 7730 7731 7731 7730 7747 7730 7729 7747 7747 7729 7718 7718 7446 7426 7718 7426 7719 7719 7734 7718 7718 7734 7747 7747 7733 7732 7734 7733 7747 7719 7733 7734 7732 7733 7719 7426 7427 7428 7441 7426 7442 7442 7426 7428 7444 7427 7426 7444 7426 7445 7445 7426 7446 7472 7442 7428 7472 7428 7473 7473 7428 7427 7471 7441 7442 7471 7442 7472 7470 7440 7441 7470 7441 7471 7508 7470 7471 7508 7471 7509 7509 7471 7510 7510 7471 7472 7507 7470 7508 7507 7508 7686 7686 7508 7509 7686 7509 7687 7509 7510 7687 7510 7472 7511 7687 7510 7511 7687 7511 7688 7582 7686 7687 7582 7687 7586 7586 7687 7587 7587 7687 7688 7511 7472 7512 7511 7512 7688 7512 7472 7473 7512 7473 7513 7688 7512 7513 7473 7427 7474 7513 7473 7514 7514 7473 7474 7688 7513 7689 7689 7513 7514 7514 7474 7515 7689 7514 7515 7474 7427 7443 7474 7443 7475 7515 7474 7516 7516 7474 7475 7443 7427 7444 7475 7443 7444 7475 7444 7476 7516 7475 7517 7517 7475 7518 7518 7475 7476 7515 7516 7690 7690 7516 7517 7515 7690 7689 7690 7517 7691 7689 7690 7589 7691 7594 7690 7690 7594 7593 7690 7593 7589 7518 7691 7517 7518 7476 7519 7519 7691 7518 7519 7692 7691 7692 7596 7691 7691 7596 7594 7590 7593 7594 7590 7594 7595 7594 7596 7595 7589 7593 7590 7589 7590 7591 7689 7589 7591 7591 7590 7588 7595 7672 7590 7590 7672 7673 7590 7673 7588 7591 7588 7592 7592 7689 7591 7592 7688 7689 7592 7588 7587 7587 7688 7592 7583 7587 7588 7588 7673 7674 7588 7674 7583 7673 7672 7674 7583 7674 7675 7674 7672 7670 7674 7670 7675 7583 7675 7581 7581 7675 7676 7675 7670 7677 7675 7677 7676 7581 7676 7578 7578 7676 7677 7578 7580 7581 7584 7583 7581 7584 7581 7585 7585 7581 7580 7573 7577 7578 7577 7579 7578 7578 7579 7580 7578 7677 7573 7579 7685 7580 7580 7685 7585 7585 7685 7686 7585 7686 7584 7582 7583 7584 7584 7686 7582 7685 7507 7686 7506 7470 7507 7685 7506 7507 7505 7469 7506 7506 7469 7470 7505 7506 7685 7469 7440 7470 7468 7439 7469 7469 7439 7440 7504 7468 7469 7504 7469 7505 7684 7504 7505 7684 7505 7685 7503 7468 7504 7503 7504 7684 7683 7503 7684 7577 7683 7684 7577 7684 7579 7579 7684 7685 7502 7468 7503 7683 7502 7503 7501 7467 7502 7502 7467 7468 7501 7502 7683 7500 7467 7501 7683 7681 7501 7501 7681 7500 7466 7425 7467 7467 7425 7424 7467 7424 7468 7500 7466 7467 7499 7466 7500 7500 7681 7499 7465 7438 7466 7466 7438 7425 7465 7466 7499 7499 7566 7465 7499 7681 7682 7499 7682 7566 7464 7437 7465 7465 7437 7438 7465 7566 7567 7465 7567 7464 7566 7682 7567 7567 7682 7715 7681 7575 7682 7682 7575 7569 7682 7569 7715 7464 7567 7568 7567 7715 7568 7568 7715 7716 7715 7569 7654 7715 7654 7716 7569 7570 7571 7575 7570 7569 7571 7654 7569 7574 7570 7575 7681 7574 7575 7574 7573 7570 7573 7678 7570 7570 7678 7679 7570 7679 7571 7572 7573 7574 7572 7574 7681 7572 7576 7573 7573 7576 7577 7573 7677 7678 7679 7678 7677 7571 7679 7680 7680 7679 7655 7655 7679 7677 7571 7680 7651 7651 7680 7655 7651 7655 7648 7648 7655 7656 7655 7677 7656 7648 7650 7651 7650 7652 7651 7651 7652 7653 7651 7653 7571 7648 7649 7650 7649 7714 7650 7714 7652 7650 7714 7716 7652 7716 7653 7652 7571 7653 7654 7716 7654 7653 7568 7716 7562 7562 7716 7714 7464 7568 7562 7498 7464 7562 7562 7563 7498 7714 7563 7562 7498 7436 7464 7464 7436 7437 7497 7435 7498 7498 7435 7436 7498 7563 7564 7498 7564 7497 7714 7564 7563 7497 7564 7565 7713 7565 7564 7713 7564 7714 7649 7713 7714 7712 7558 7713 7558 7565 7713 7647 7712 7713 7647 7713 7649 7497 7565 7558 7496 7497 7558 7558 7559 7496 7712 7559 7558 7495 7431 7496 7496 7431 7430 7496 7430 7497 7496 7559 7560 7496 7560 7495 7560 7559 7712 7495 7560 7561 7711 7561 7560 7711 7560 7712 7495 7561 7554 7554 7561 7711 7644 7645 7711 7711 7645 7710 7711 7710 7554 7644 7711 7642 7642 7711 7712 7494 7495 7554 7554 7555 7494 7554 7710 7555 7494 7463 7495 7495 7463 7431 7462 7429 7463 7463 7429 7431 7494 7462 7463 7429 7430 7431 7436 7430 7429 7436 7429 7437 7462 7455 7429 7461 7455 7462 7493 7461 7462 7493 7462 7494 7460 7453 7461 7461 7453 7455 7492 7460 7461 7492 7461 7493 7491 7453 7460 7491 7460 7492 7453 7454 7455 7490 7454 7453 7490 7453 7491 7490 7491 7546 7492 7552 7491 7491 7552 7553 7491 7553 7546 7489 7454 7490 7546 7547 7490 7490 7547 7548 7490 7548 7489 7455 7454 7456 7489 7456 7454 7457 7432 7455 7457 7455 7458 7458 7455 7456 7458 7456 7459 7488 7459 7456 7488 7456 7489 7486 7457 7458 7486 7458 7487 7487 7458 7459 7487 7459 7488 7488 7489 7542 7542 7543 7488 7488 7543 7544 7488 7544 7487 7486 7487 7538 7487 7544 7545 7487 7545 7538 7703 7545 7544 7703 7544 7704 7544 7543 7704 7704 7543 7542 7704 7542 7705 7628 7703 7704 7628 7704 7627 7627 7704 7625 7625 7704 7705 7627 7624 7628 7628 7624 7623 7623 7703 7628 7625 7626 7627 7627 7626 7624 7625 7629 7626 7625 7705 7629 7626 7629 7630 7626 7630 7631 7631 7661 7626 7626 7661 7662 7626 7662 7624 7629 7705 7630 7635 7631 7630 7630 7705 7706 7630 7706 7635 7634 7631 7635 7635 7706 7707 7635 7707 7634 7705 7548 7706 7548 7547 7706 7706 7547 7546 7706 7546 7707 7542 7549 7705 7705 7549 7548 7489 7548 7549 7489 7549 7542 7707 7546 7553 7707 7553 7552 7552 7708 7707 7707 7708 7632 7707 7632 7634 7492 7551 7552 7552 7551 7708 7492 7493 7550 7550 7551 7492 7708 7551 7550 7493 7557 7550 7708 7550 7709 7557 7709 7550 7494 7556 7493 7493 7556 7557 7556 7709 7557 7556 7710 7709 7710 7639 7709 7709 7639 7637 7709 7637 7708 7494 7555 7556 7555 7710 7556 7645 7640 7710 7710 7640 7639 7637 7639 7638 7638 7639 7640 7633 7636 7637 7633 7637 7638 7708 7637 7636 7708 7636 7632 7632 7636 7633 7632 7633 7634 7634 7633 7631 7638 7659 7633 7633 7659 7660 7633 7660 7631 7631 7660 7661 7677 7661 7660 7660 7659 7677 7638 7658 7659 7677 7659 7658 7641 7657 7658 7641 7658 7638 7677 7658 7657 7643 7656 7657 7643 7657 7641 7656 7677 7657 7648 7656 7643 7643 7647 7648 7647 7649 7648 7643 7646 7647 7646 7712 7647 7642 7646 7643 7642 7712 7646 7642 7643 7644 7644 7643 7641 7644 7641 7645 7645 7641 7640 7638 7640 7641 7663 7662 7677 7677 7662 7661 7663 7677 7664 7664 7677 7666 7668 7666 7677 7668 7677 7669 7669 7677 7670 7624 7662 7663 7621 7623 7624 7624 7663 7621 7616 7620 7621 7620 7622 7621 7621 7622 7623 7621 7663 7664 7621 7664 7616 7622 7703 7623 7620 7702 7622 7622 7702 7703 7616 7619 7620 7619 7701 7620 7620 7701 7702 7701 7540 7702 7540 7539 7702 7702 7539 7538 7702 7538 7703 7538 7545 7703 7538 7539 7486 7486 7539 7540 7486 7540 7485 7485 7540 7541 7701 7541 7540 7485 7457 7486 7484 7433 7485 7485 7433 7457 7484 7485 7534 7485 7541 7534 7534 7541 7701 7534 7535 7484 7700 7535 7534 7700 7534 7701 7484 7535 7536 7536 7535 7700 7484 7536 7483 7483 7536 7537 7699 7537 7536 7699 7536 7700 7483 7537 7533 7533 7537 7699 7698 7533 7699 7613 7698 7699 7613 7699 7618 7618 7699 7700 7532 7483 7533 7698 7532 7533 7697 7531 7698 7531 7532 7698 7612 7697 7698 7612 7698 7613 7611 7612 7613 7611 7613 7614 7618 7614 7613 7617 7614 7618 7618 7700 7617 7617 7616 7614 7616 7665 7614 7614 7665 7666 7614 7666 7611 7615 7616 7617 7617 7700 7615 7615 7700 7701 7615 7619 7616 7615 7701 7619 7616 7664 7665 7664 7666 7665 7611 7666 7667 7667 7666 7668 7611 7667 7608 7608 7667 7668 7608 7668 7605 7605 7668 7669 7605 7607 7608 7607 7609 7608 7608 7609 7610 7608 7610 7611 7610 7612 7611 7609 7697 7610 7610 7697 7612 7607 7696 7609 7609 7696 7697 7605 7606 7607 7606 7696 7607 7695 7527 7696 7527 7528 7696 7696 7528 7529 7696 7529 7697 7606 7695 7696 7529 7530 7697 7697 7530 7531 7528 7481 7529 7529 7481 7530 7527 7480 7528 7528 7480 7481 7526 7480 7527 7695 7526 7527 7479 7449 7480 7480 7449 7450 7480 7450 7481 7526 7479 7480 7481 7450 7451 7481 7451 7482 7530 7481 7482 7530 7482 7531 7531 7482 7532 7482 7451 7452 7482 7452 7483 7532 7482 7483 7450 7432 7451 7451 7432 7434 7451 7434 7452 7449 7446 7450 7450 7446 7432 7432 7433 7434 7433 7432 7457 7483 7452 7434 7483 7434 7484 7484 7434 7433 7445 7446 7447 7449 7447 7446 7476 7444 7445 7476 7445 7477 7477 7445 7447 7448 7447 7449 7477 7447 7478 7478 7447 7448 7479 7448 7449 7478 7448 7479 7522 7477 7478 7522 7478 7523 7523 7478 7524 7524 7478 7479 7524 7479 7525 7525 7479 7526 7523 7524 7694 7694 7524 7525 7693 7522 7523 7693 7523 7694 7521 7477 7522 7521 7522 7693 7601 7602 7693 7693 7602 7692 7693 7692 7521 7601 7693 7599 7599 7693 7694 7520 7477 7521 7521 7692 7520 7520 7692 7519 7602 7597 7692 7692 7597 7596 7601 7598 7602 7602 7598 7597 7595 7596 7597 7595 7597 7598 7601 7600 7598 7600 7670 7598 7598 7670 7671 7598 7671 7595 7595 7671 7672 7672 7671 7670 7600 7669 7670 7605 7669 7600 7600 7604 7605 7604 7606 7605 7600 7603 7604 7603 7694 7604 7604 7694 7695 7604 7695 7606 7599 7603 7600 7599 7694 7603 7694 7525 7695 7525 7526 7695 7599 7600 7601 7519 7476 7520 7520 7476 7477 7435 7430 7436 7497 7430 7435 7576 7683 7577 7576 7572 7683 7683 7572 7681 7468 7424 7439 7439 7424 7440 7582 7586 7583 7583 7586 7587 7748 7749 7750 7762 7754 7748 7762 7748 7763 7763 7748 7750 7765 7749 7748 7765 7748 7766 7766 7748 7751 8051 7748 8052 8052 7748 7754 8053 7751 7748 8053 7748 8051 8051 8052 8060 8060 8061 8051 8051 8061 8062 8051 8062 8053 8044 7751 8053 8044 8053 8057 8053 8062 8072 8057 8053 8072 8062 8061 8072 8072 8061 8060 8060 8052 8072 8052 7754 8049 8063 8052 8049 8052 8063 8072 8049 7754 8050 8050 8064 8049 8049 8064 8065 8049 8065 8063 8063 8065 8072 8072 8065 8064 8064 8050 8072 8050 7754 7780 8050 7780 8047 8047 8068 8050 8050 8068 8072 8047 7780 8048 8047 8048 8066 8066 8067 8047 8047 8067 8068 8068 8067 8072 8067 8066 8072 8072 8066 8048 8048 7780 7757 8048 7757 8045 8045 8071 8048 8048 8071 8072 8045 7757 8046 8045 8046 8069 8069 8070 8045 8045 8070 8071 8071 8070 8072 8072 8070 8069 8069 8046 8072 8046 7757 7771 8046 7771 8042 8042 8056 8046 8046 8056 8072 8042 7771 8043 8042 8043 8054 8054 8055 8042 8042 8055 8056 8056 8055 8072 8055 8054 8072 8072 8054 8043 8043 7771 7751 8043 7751 8044 8044 8059 8043 8043 8059 8072 8072 8058 8057 8059 8058 8072 8044 8058 8059 8057 8058 8044 7751 7752 7753 7766 7751 7767 7767 7751 7753 7769 7752 7751 7769 7751 7770 7770 7751 7771 7797 7767 7753 7797 7753 7798 7798 7753 7752 7796 7766 7767 7796 7767 7797 7795 7765 7766 7795 7766 7796 7833 7795 7796 7833 7796 7834 7834 7796 7835 7835 7796 7797 7832 7795 7833 7832 7833 8011 8011 7833 7834 8011 7834 8012 7834 7835 8012 7835 7797 7836 8012 7835 7836 8012 7836 8013 7907 8011 8012 7907 8012 7911 7911 8012 7912 7912 8012 8013 7836 7797 7837 7836 7837 8013 7837 7797 7798 7837 7798 7838 8013 7837 7838 7798 7752 7799 7838 7798 7839 7839 7798 7799 8013 7838 8014 8014 7838 7839 7839 7799 7840 8014 7839 7840 7799 7752 7768 7799 7768 7800 7840 7799 7841 7841 7799 7800 7768 7752 7769 7800 7768 7769 7800 7769 7801 7841 7800 7842 7842 7800 7843 7843 7800 7801 7840 7841 8015 8015 7841 7842 7840 8015 8014 8015 7842 8016 8014 8015 7914 8016 7919 8015 8015 7919 7918 8015 7918 7914 7843 8016 7842 7843 7801 7844 7844 8016 7843 7844 8017 8016 8017 7921 8016 8016 7921 7919 7915 7918 7919 7915 7919 7920 7919 7921 7920 7914 7918 7915 7914 7915 7916 8014 7914 7916 7916 7915 7913 7920 7997 7915 7915 7997 7998 7915 7998 7913 7916 7913 7917 7917 8014 7916 7917 8013 8014 7917 7913 7912 7912 8013 7917 7908 7912 7913 7913 7998 7999 7913 7999 7908 7998 7997 7999 7908 7999 8000 7999 7997 7995 7999 7995 8000 7908 8000 7906 7906 8000 8001 8000 7995 8002 8000 8002 8001 7906 8001 7903 7903 8001 8002 7903 7905 7906 7909 7908 7906 7909 7906 7910 7910 7906 7905 7898 7902 7903 7902 7904 7903 7903 7904 7905 7903 8002 7898 7904 8010 7905 7905 8010 7910 7910 8010 8011 7910 8011 7909 7907 7908 7909 7909 8011 7907 8010 7832 8011 7831 7795 7832 8010 7831 7832 7830 7794 7831 7831 7794 7795 7830 7831 8010 7794 7765 7795 7793 7764 7794 7794 7764 7765 7829 7793 7794 7829 7794 7830 8009 7829 7830 8009 7830 8010 7828 7793 7829 7828 7829 8009 8008 7828 8009 7902 8008 8009 7902 8009 7904 7904 8009 8010 7827 7793 7828 8008 7827 7828 7826 7792 7827 7827 7792 7793 7826 7827 8008 7825 7792 7826 8008 8006 7826 7826 8006 7825 7791 7750 7792 7792 7750 7749 7792 7749 7793 7825 7791 7792 7824 7791 7825 7825 8006 7824 7790 7763 7791 7791 7763 7750 7790 7791 7824 7824 7891 7790 7824 8006 8007 7824 8007 7891 7789 7762 7790 7790 7762 7763 7790 7891 7892 7790 7892 7789 7891 8007 7892 7892 8007 8040 8006 7900 8007 8007 7900 7894 8007 7894 8040 7789 7892 7893 7892 8040 7893 7893 8040 8041 8040 7894 7979 8040 7979 8041 7894 7895 7896 7900 7895 7894 7896 7979 7894 7899 7895 7900 8006 7899 7900 7899 7898 7895 7898 8003 7895 7895 8003 8004 7895 8004 7896 7897 7898 7899 7897 7899 8006 7897 7901 7898 7898 7901 7902 7898 8002 8003 8004 8003 8002 7896 8004 8005 8005 8004 7980 7980 8004 8002 7896 8005 7976 7976 8005 7980 7976 7980 7973 7973 7980 7981 7980 8002 7981 7973 7975 7976 7975 7977 7976 7976 7977 7978 7976 7978 7896 7973 7974 7975 7974 8039 7975 8039 7977 7975 8039 8041 7977 8041 7978 7977 7896 7978 7979 8041 7979 7978 7893 8041 7887 7887 8041 8039 7789 7893 7887 7823 7789 7887 7887 7888 7823 8039 7888 7887 7823 7761 7789 7789 7761 7762 7822 7760 7823 7823 7760 7761 7823 7888 7889 7823 7889 7822 8039 7889 7888 7822 7889 7890 8038 7890 7889 8038 7889 8039 7974 8038 8039 8037 7883 8038 7883 7890 8038 7972 8037 8038 7972 8038 7974 7822 7890 7883 7821 7822 7883 7883 7884 7821 8037 7884 7883 7820 7756 7821 7821 7756 7755 7821 7755 7822 7821 7884 7885 7821 7885 7820 7885 7884 8037 7820 7885 7886 8036 7886 7885 8036 7885 8037 7820 7886 7879 7879 7886 8036 7969 7970 8036 8036 7970 8035 8036 8035 7879 7969 8036 7967 7967 8036 8037 7819 7820 7879 7879 7880 7819 7879 8035 7880 7819 7788 7820 7820 7788 7756 7787 7754 7788 7788 7754 7756 7819 7787 7788 7754 7755 7756 7761 7755 7754 7761 7754 7762 7787 7780 7754 7786 7780 7787 7818 7786 7787 7818 7787 7819 7785 7778 7786 7786 7778 7780 7817 7785 7786 7817 7786 7818 7816 7778 7785 7816 7785 7817 7778 7779 7780 7815 7779 7778 7815 7778 7816 7815 7816 7871 7817 7877 7816 7816 7877 7878 7816 7878 7871 7814 7779 7815 7871 7872 7815 7815 7872 7873 7815 7873 7814 7780 7779 7781 7814 7781 7779 7782 7757 7780 7782 7780 7783 7783 7780 7781 7783 7781 7784 7813 7784 7781 7813 7781 7814 7811 7782 7783 7811 7783 7812 7812 7783 7784 7812 7784 7813 7813 7814 7867 7867 7868 7813 7813 7868 7869 7813 7869 7812 7811 7812 7863 7812 7869 7870 7812 7870 7863 8028 7870 7869 8028 7869 8029 7869 7868 8029 8029 7868 7867 8029 7867 8030 7953 8028 8029 7953 8029 7952 7952 8029 7950 7950 8029 8030 7952 7949 7953 7953 7949 7948 7948 8028 7953 7950 7951 7952 7952 7951 7949 7950 7954 7951 7950 8030 7954 7951 7954 7955 7951 7955 7956 7956 7986 7951 7951 7986 7987 7951 7987 7949 7954 8030 7955 7960 7956 7955 7955 8030 8031 7955 8031 7960 7959 7956 7960 7960 8031 8032 7960 8032 7959 8030 7873 8031 7873 7872 8031 8031 7872 7871 8031 7871 8032 7867 7874 8030 8030 7874 7873 7814 7873 7874 7814 7874 7867 8032 7871 7878 8032 7878 7877 7877 8033 8032 8032 8033 7957 8032 7957 7959 7817 7876 7877 7877 7876 8033 7817 7818 7875 7875 7876 7817 8033 7876 7875 7818 7882 7875 8033 7875 8034 7882 8034 7875 7819 7881 7818 7818 7881 7882 7881 8034 7882 7881 8035 8034 8035 7964 8034 8034 7964 7962 8034 7962 8033 7819 7880 7881 7880 8035 7881 7970 7965 8035 8035 7965 7964 7962 7964 7963 7963 7964 7965 7958 7961 7962 7958 7962 7963 8033 7962 7961 8033 7961 7957 7957 7961 7958 7957 7958 7959 7959 7958 7956 7963 7984 7958 7958 7984 7985 7958 7985 7956 7956 7985 7986 8002 7986 7985 7985 7984 8002 7963 7983 7984 8002 7984 7983 7966 7982 7983 7966 7983 7963 8002 7983 7982 7968 7981 7982 7968 7982 7966 7981 8002 7982 7973 7981 7968 7968 7972 7973 7972 7974 7973 7968 7971 7972 7971 8037 7972 7967 7971 7968 7967 8037 7971 7967 7968 7969 7969 7968 7966 7969 7966 7970 7970 7966 7965 7963 7965 7966 7988 7987 8002 8002 7987 7986 7988 8002 7989 7989 8002 7991 7993 7991 8002 7993 8002 7994 7994 8002 7995 7949 7987 7988 7946 7948 7949 7949 7988 7946 7941 7945 7946 7945 7947 7946 7946 7947 7948 7946 7988 7989 7946 7989 7941 7947 8028 7948 7945 8027 7947 7947 8027 8028 7941 7944 7945 7944 8026 7945 7945 8026 8027 8026 7865 8027 7865 7864 8027 8027 7864 7863 8027 7863 8028 7863 7870 8028 7863 7864 7811 7811 7864 7865 7811 7865 7810 7810 7865 7866 8026 7866 7865 7810 7782 7811 7809 7758 7810 7810 7758 7782 7809 7810 7859 7810 7866 7859 7859 7866 8026 7859 7860 7809 8025 7860 7859 8025 7859 8026 7809 7860 7861 7861 7860 8025 7809 7861 7808 7808 7861 7862 8024 7862 7861 8024 7861 8025 7808 7862 7858 7858 7862 8024 8023 7858 8024 7938 8023 8024 7938 8024 7943 7943 8024 8025 7857 7808 7858 8023 7857 7858 8022 7856 8023 7856 7857 8023 7937 8022 8023 7937 8023 7938 7936 7937 7938 7936 7938 7939 7943 7939 7938 7942 7939 7943 7943 8025 7942 7942 7941 7939 7941 7990 7939 7939 7990 7991 7939 7991 7936 7940 7941 7942 7942 8025 7940 7940 8025 8026 7940 7944 7941 7940 8026 7944 7941 7989 7990 7989 7991 7990 7936 7991 7992 7992 7991 7993 7936 7992 7933 7933 7992 7993 7933 7993 7930 7930 7993 7994 7930 7932 7933 7932 7934 7933 7933 7934 7935 7933 7935 7936 7935 7937 7936 7934 8022 7935 7935 8022 7937 7932 8021 7934 7934 8021 8022 7930 7931 7932 7931 8021 7932 8020 7852 8021 7852 7853 8021 8021 7853 7854 8021 7854 8022 7931 8020 8021 7854 7855 8022 8022 7855 7856 7853 7806 7854 7854 7806 7855 7852 7805 7853 7853 7805 7806 7851 7805 7852 8020 7851 7852 7804 7774 7805 7805 7774 7775 7805 7775 7806 7851 7804 7805 7806 7775 7776 7806 7776 7807 7855 7806 7807 7855 7807 7856 7856 7807 7857 7807 7776 7777 7807 7777 7808 7857 7807 7808 7775 7757 7776 7776 7757 7759 7776 7759 7777 7774 7771 7775 7775 7771 7757 7757 7758 7759 7758 7757 7782 7808 7777 7759 7808 7759 7809 7809 7759 7758 7770 7771 7772 7774 7772 7771 7801 7769 7770 7801 7770 7802 7802 7770 7772 7773 7772 7774 7802 7772 7803 7803 7772 7773 7804 7773 7774 7803 7773 7804 7847 7802 7803 7847 7803 7848 7848 7803 7849 7849 7803 7804 7849 7804 7850 7850 7804 7851 7848 7849 8019 8019 7849 7850 8018 7847 7848 8018 7848 8019 7846 7802 7847 7846 7847 8018 7926 7927 8018 8018 7927 8017 8018 8017 7846 7926 8018 7924 7924 8018 8019 7845 7802 7846 7846 8017 7845 7845 8017 7844 7927 7922 8017 8017 7922 7921 7926 7923 7927 7927 7923 7922 7920 7921 7922 7920 7922 7923 7926 7925 7923 7925 7995 7923 7923 7995 7996 7923 7996 7920 7920 7996 7997 7997 7996 7995 7925 7994 7995 7930 7994 7925 7925 7929 7930 7929 7931 7930 7925 7928 7929 7928 8019 7929 7929 8019 8020 7929 8020 7931 7924 7928 7925 7924 8019 7928 8019 7850 8020 7850 7851 8020 7924 7925 7926 7844 7801 7845 7845 7801 7802 7760 7755 7761 7822 7755 7760 7901 8008 7902 7901 7897 8008 8008 7897 8006 7793 7749 7764 7764 7749 7765 7907 7911 7908 7908 7911 7912 8073 8074 8075 8087 8079 8073 8087 8073 8088 8088 8073 8075 8090 8074 8073 8090 8073 8091 8091 8073 8076 8376 8073 8377 8377 8073 8079 8378 8076 8073 8378 8073 8376 8376 8377 8385 8385 8386 8376 8376 8386 8387 8376 8387 8378 8369 8076 8378 8369 8378 8382 8378 8387 8397 8382 8378 8397 8387 8386 8397 8397 8386 8385 8385 8377 8397 8377 8079 8374 8388 8377 8374 8377 8388 8397 8374 8079 8375 8375 8389 8374 8374 8389 8390 8374 8390 8388 8388 8390 8397 8397 8390 8389 8389 8375 8397 8375 8079 8105 8375 8105 8372 8372 8393 8375 8375 8393 8397 8372 8105 8373 8372 8373 8391 8391 8392 8372 8372 8392 8393 8393 8392 8397 8392 8391 8397 8397 8391 8373 8373 8105 8082 8373 8082 8370 8370 8396 8373 8373 8396 8397 8370 8082 8371 8370 8371 8394 8394 8395 8370 8370 8395 8396 8396 8395 8397 8397 8395 8394 8394 8371 8397 8371 8082 8096 8371 8096 8367 8367 8381 8371 8371 8381 8397 8367 8096 8368 8367 8368 8379 8379 8380 8367 8367 8380 8381 8381 8380 8397 8380 8379 8397 8397 8379 8368 8368 8096 8076 8368 8076 8369 8369 8384 8368 8368 8384 8397 8397 8383 8382 8384 8383 8397 8369 8383 8384 8382 8383 8369 8076 8077 8078 8091 8076 8092 8092 8076 8078 8094 8077 8076 8094 8076 8095 8095 8076 8096 8122 8092 8078 8122 8078 8123 8123 8078 8077 8121 8091 8092 8121 8092 8122 8120 8090 8091 8120 8091 8121 8158 8120 8121 8158 8121 8159 8159 8121 8160 8160 8121 8122 8157 8120 8158 8157 8158 8336 8336 8158 8159 8336 8159 8337 8159 8160 8337 8160 8122 8161 8337 8160 8161 8337 8161 8338 8232 8336 8337 8232 8337 8236 8236 8337 8237 8237 8337 8338 8161 8122 8162 8161 8162 8338 8162 8122 8123 8162 8123 8163 8338 8162 8163 8123 8077 8124 8163 8123 8164 8164 8123 8124 8338 8163 8339 8339 8163 8164 8164 8124 8165 8339 8164 8165 8124 8077 8093 8124 8093 8125 8165 8124 8166 8166 8124 8125 8093 8077 8094 8125 8093 8094 8125 8094 8126 8166 8125 8167 8167 8125 8168 8168 8125 8126 8165 8166 8340 8340 8166 8167 8165 8340 8339 8340 8167 8341 8339 8340 8239 8341 8244 8340 8340 8244 8243 8340 8243 8239 8168 8341 8167 8168 8126 8169 8169 8341 8168 8169 8342 8341 8342 8246 8341 8341 8246 8244 8240 8243 8244 8240 8244 8245 8244 8246 8245 8239 8243 8240 8239 8240 8241 8339 8239 8241 8241 8240 8238 8245 8322 8240 8240 8322 8323 8240 8323 8238 8241 8238 8242 8242 8339 8241 8242 8338 8339 8242 8238 8237 8237 8338 8242 8233 8237 8238 8238 8323 8324 8238 8324 8233 8323 8322 8324 8233 8324 8325 8324 8322 8320 8324 8320 8325 8233 8325 8231 8231 8325 8326 8325 8320 8327 8325 8327 8326 8231 8326 8228 8228 8326 8327 8228 8230 8231 8234 8233 8231 8234 8231 8235 8235 8231 8230 8223 8227 8228 8227 8229 8228 8228 8229 8230 8228 8327 8223 8229 8335 8230 8230 8335 8235 8235 8335 8336 8235 8336 8234 8232 8233 8234 8234 8336 8232 8335 8157 8336 8156 8120 8157 8335 8156 8157 8155 8119 8156 8156 8119 8120 8155 8156 8335 8119 8090 8120 8118 8089 8119 8119 8089 8090 8154 8118 8119 8154 8119 8155 8334 8154 8155 8334 8155 8335 8153 8118 8154 8153 8154 8334 8333 8153 8334 8227 8333 8334 8227 8334 8229 8229 8334 8335 8152 8118 8153 8333 8152 8153 8151 8117 8152 8152 8117 8118 8151 8152 8333 8150 8117 8151 8333 8331 8151 8151 8331 8150 8116 8075 8117 8117 8075 8074 8117 8074 8118 8150 8116 8117 8149 8116 8150 8150 8331 8149 8115 8088 8116 8116 8088 8075 8115 8116 8149 8149 8216 8115 8149 8331 8332 8149 8332 8216 8114 8087 8115 8115 8087 8088 8115 8216 8217 8115 8217 8114 8216 8332 8217 8217 8332 8365 8331 8225 8332 8332 8225 8219 8332 8219 8365 8114 8217 8218 8217 8365 8218 8218 8365 8366 8365 8219 8304 8365 8304 8366 8219 8220 8221 8225 8220 8219 8221 8304 8219 8224 8220 8225 8331 8224 8225 8224 8223 8220 8223 8328 8220 8220 8328 8329 8220 8329 8221 8222 8223 8224 8222 8224 8331 8222 8226 8223 8223 8226 8227 8223 8327 8328 8329 8328 8327 8221 8329 8330 8330 8329 8305 8305 8329 8327 8221 8330 8301 8301 8330 8305 8301 8305 8298 8298 8305 8306 8305 8327 8306 8298 8300 8301 8300 8302 8301 8301 8302 8303 8301 8303 8221 8298 8299 8300 8299 8364 8300 8364 8302 8300 8364 8366 8302 8366 8303 8302 8221 8303 8304 8366 8304 8303 8218 8366 8212 8212 8366 8364 8114 8218 8212 8148 8114 8212 8212 8213 8148 8364 8213 8212 8148 8086 8114 8114 8086 8087 8147 8085 8148 8148 8085 8086 8148 8213 8214 8148 8214 8147 8364 8214 8213 8147 8214 8215 8363 8215 8214 8363 8214 8364 8299 8363 8364 8362 8208 8363 8208 8215 8363 8297 8362 8363 8297 8363 8299 8147 8215 8208 8146 8147 8208 8208 8209 8146 8362 8209 8208 8145 8081 8146 8146 8081 8080 8146 8080 8147 8146 8209 8210 8146 8210 8145 8210 8209 8362 8145 8210 8211 8361 8211 8210 8361 8210 8362 8145 8211 8204 8204 8211 8361 8294 8295 8361 8361 8295 8360 8361 8360 8204 8294 8361 8292 8292 8361 8362 8144 8145 8204 8204 8205 8144 8204 8360 8205 8144 8113 8145 8145 8113 8081 8112 8079 8113 8113 8079 8081 8144 8112 8113 8079 8080 8081 8086 8080 8079 8086 8079 8087 8112 8105 8079 8111 8105 8112 8143 8111 8112 8143 8112 8144 8110 8103 8111 8111 8103 8105 8142 8110 8111 8142 8111 8143 8141 8103 8110 8141 8110 8142 8103 8104 8105 8140 8104 8103 8140 8103 8141 8140 8141 8196 8142 8202 8141 8141 8202 8203 8141 8203 8196 8139 8104 8140 8196 8197 8140 8140 8197 8198 8140 8198 8139 8105 8104 8106 8139 8106 8104 8107 8082 8105 8107 8105 8108 8108 8105 8106 8108 8106 8109 8138 8109 8106 8138 8106 8139 8136 8107 8108 8136 8108 8137 8137 8108 8109 8137 8109 8138 8138 8139 8192 8192 8193 8138 8138 8193 8194 8138 8194 8137 8136 8137 8188 8137 8194 8195 8137 8195 8188 8353 8195 8194 8353 8194 8354 8194 8193 8354 8354 8193 8192 8354 8192 8355 8278 8353 8354 8278 8354 8277 8277 8354 8275 8275 8354 8355 8277 8274 8278 8278 8274 8273 8273 8353 8278 8275 8276 8277 8277 8276 8274 8275 8279 8276 8275 8355 8279 8276 8279 8280 8276 8280 8281 8281 8311 8276 8276 8311 8312 8276 8312 8274 8279 8355 8280 8285 8281 8280 8280 8355 8356 8280 8356 8285 8284 8281 8285 8285 8356 8357 8285 8357 8284 8355 8198 8356 8198 8197 8356 8356 8197 8196 8356 8196 8357 8192 8199 8355 8355 8199 8198 8139 8198 8199 8139 8199 8192 8357 8196 8203 8357 8203 8202 8202 8358 8357 8357 8358 8282 8357 8282 8284 8142 8201 8202 8202 8201 8358 8142 8143 8200 8200 8201 8142 8358 8201 8200 8143 8207 8200 8358 8200 8359 8207 8359 8200 8144 8206 8143 8143 8206 8207 8206 8359 8207 8206 8360 8359 8360 8289 8359 8359 8289 8287 8359 8287 8358 8144 8205 8206 8205 8360 8206 8295 8290 8360 8360 8290 8289 8287 8289 8288 8288 8289 8290 8283 8286 8287 8283 8287 8288 8358 8287 8286 8358 8286 8282 8282 8286 8283 8282 8283 8284 8284 8283 8281 8288 8309 8283 8283 8309 8310 8283 8310 8281 8281 8310 8311 8327 8311 8310 8310 8309 8327 8288 8308 8309 8327 8309 8308 8291 8307 8308 8291 8308 8288 8327 8308 8307 8293 8306 8307 8293 8307 8291 8306 8327 8307 8298 8306 8293 8293 8297 8298 8297 8299 8298 8293 8296 8297 8296 8362 8297 8292 8296 8293 8292 8362 8296 8292 8293 8294 8294 8293 8291 8294 8291 8295 8295 8291 8290 8288 8290 8291 8313 8312 8327 8327 8312 8311 8313 8327 8314 8314 8327 8316 8318 8316 8327 8318 8327 8319 8319 8327 8320 8274 8312 8313 8271 8273 8274 8274 8313 8271 8266 8270 8271 8270 8272 8271 8271 8272 8273 8271 8313 8314 8271 8314 8266 8272 8353 8273 8270 8352 8272 8272 8352 8353 8266 8269 8270 8269 8351 8270 8270 8351 8352 8351 8190 8352 8190 8189 8352 8352 8189 8188 8352 8188 8353 8188 8195 8353 8188 8189 8136 8136 8189 8190 8136 8190 8135 8135 8190 8191 8351 8191 8190 8135 8107 8136 8134 8083 8135 8135 8083 8107 8134 8135 8184 8135 8191 8184 8184 8191 8351 8184 8185 8134 8350 8185 8184 8350 8184 8351 8134 8185 8186 8186 8185 8350 8134 8186 8133 8133 8186 8187 8349 8187 8186 8349 8186 8350 8133 8187 8183 8183 8187 8349 8348 8183 8349 8263 8348 8349 8263 8349 8268 8268 8349 8350 8182 8133 8183 8348 8182 8183 8347 8181 8348 8181 8182 8348 8262 8347 8348 8262 8348 8263 8261 8262 8263 8261 8263 8264 8268 8264 8263 8267 8264 8268 8268 8350 8267 8267 8266 8264 8266 8315 8264 8264 8315 8316 8264 8316 8261 8265 8266 8267 8267 8350 8265 8265 8350 8351 8265 8269 8266 8265 8351 8269 8266 8314 8315 8314 8316 8315 8261 8316 8317 8317 8316 8318 8261 8317 8258 8258 8317 8318 8258 8318 8255 8255 8318 8319 8255 8257 8258 8257 8259 8258 8258 8259 8260 8258 8260 8261 8260 8262 8261 8259 8347 8260 8260 8347 8262 8257 8346 8259 8259 8346 8347 8255 8256 8257 8256 8346 8257 8345 8177 8346 8177 8178 8346 8346 8178 8179 8346 8179 8347 8256 8345 8346 8179 8180 8347 8347 8180 8181 8178 8131 8179 8179 8131 8180 8177 8130 8178 8178 8130 8131 8176 8130 8177 8345 8176 8177 8129 8099 8130 8130 8099 8100 8130 8100 8131 8176 8129 8130 8131 8100 8101 8131 8101 8132 8180 8131 8132 8180 8132 8181 8181 8132 8182 8132 8101 8102 8132 8102 8133 8182 8132 8133 8100 8082 8101 8101 8082 8084 8101 8084 8102 8099 8096 8100 8100 8096 8082 8082 8083 8084 8083 8082 8107 8133 8102 8084 8133 8084 8134 8134 8084 8083 8095 8096 8097 8099 8097 8096 8126 8094 8095 8126 8095 8127 8127 8095 8097 8098 8097 8099 8127 8097 8128 8128 8097 8098 8129 8098 8099 8128 8098 8129 8172 8127 8128 8172 8128 8173 8173 8128 8174 8174 8128 8129 8174 8129 8175 8175 8129 8176 8173 8174 8344 8344 8174 8175 8343 8172 8173 8343 8173 8344 8171 8127 8172 8171 8172 8343 8251 8252 8343 8343 8252 8342 8343 8342 8171 8251 8343 8249 8249 8343 8344 8170 8127 8171 8171 8342 8170 8170 8342 8169 8252 8247 8342 8342 8247 8246 8251 8248 8252 8252 8248 8247 8245 8246 8247 8245 8247 8248 8251 8250 8248 8250 8320 8248 8248 8320 8321 8248 8321 8245 8245 8321 8322 8322 8321 8320 8250 8319 8320 8255 8319 8250 8250 8254 8255 8254 8256 8255 8250 8253 8254 8253 8344 8254 8254 8344 8345 8254 8345 8256 8249 8253 8250 8249 8344 8253 8344 8175 8345 8175 8176 8345 8249 8250 8251 8169 8126 8170 8170 8126 8127 8085 8080 8086 8147 8080 8085 8226 8333 8227 8226 8222 8333 8333 8222 8331 8118 8074 8089 8089 8074 8090 8232 8236 8233 8233 8236 8237 8398 8399 8400 8412 8404 8398 8412 8398 8413 8413 8398 8400 8415 8399 8398 8415 8398 8416 8416 8398 8401 8701 8398 8702 8702 8398 8404 8703 8401 8398 8703 8398 8701 8701 8702 8710 8710 8711 8701 8701 8711 8712 8701 8712 8703 8694 8401 8703 8694 8703 8707 8703 8712 8722 8707 8703 8722 8712 8711 8722 8722 8711 8710 8710 8702 8722 8702 8404 8699 8713 8702 8699 8702 8713 8722 8699 8404 8700 8700 8714 8699 8699 8714 8715 8699 8715 8713 8713 8715 8722 8722 8715 8714 8714 8700 8722 8700 8404 8430 8700 8430 8697 8697 8718 8700 8700 8718 8722 8697 8430 8698 8697 8698 8716 8716 8717 8697 8697 8717 8718 8718 8717 8722 8717 8716 8722 8722 8716 8698 8698 8430 8407 8698 8407 8695 8695 8721 8698 8698 8721 8722 8695 8407 8696 8695 8696 8719 8719 8720 8695 8695 8720 8721 8721 8720 8722 8722 8720 8719 8719 8696 8722 8696 8407 8421 8696 8421 8692 8692 8706 8696 8696 8706 8722 8692 8421 8693 8692 8693 8704 8704 8705 8692 8692 8705 8706 8706 8705 8722 8705 8704 8722 8722 8704 8693 8693 8421 8401 8693 8401 8694 8694 8709 8693 8693 8709 8722 8722 8708 8707 8709 8708 8722 8694 8708 8709 8707 8708 8694 8401 8402 8403 8416 8401 8417 8417 8401 8403 8419 8402 8401 8419 8401 8420 8420 8401 8421 8447 8417 8403 8447 8403 8448 8448 8403 8402 8446 8416 8417 8446 8417 8447 8445 8415 8416 8445 8416 8446 8483 8445 8446 8483 8446 8484 8484 8446 8485 8485 8446 8447 8482 8445 8483 8482 8483 8661 8661 8483 8484 8661 8484 8662 8484 8485 8662 8485 8447 8486 8662 8485 8486 8662 8486 8663 8557 8661 8662 8557 8662 8561 8561 8662 8562 8562 8662 8663 8486 8447 8487 8486 8487 8663 8487 8447 8448 8487 8448 8488 8663 8487 8488 8448 8402 8449 8488 8448 8489 8489 8448 8449 8663 8488 8664 8664 8488 8489 8489 8449 8490 8664 8489 8490 8449 8402 8418 8449 8418 8450 8490 8449 8491 8491 8449 8450 8418 8402 8419 8450 8418 8419 8450 8419 8451 8491 8450 8492 8492 8450 8493 8493 8450 8451 8490 8491 8665 8665 8491 8492 8490 8665 8664 8665 8492 8666 8664 8665 8564 8666 8569 8665 8665 8569 8568 8665 8568 8564 8493 8666 8492 8493 8451 8494 8494 8666 8493 8494 8667 8666 8667 8571 8666 8666 8571 8569 8565 8568 8569 8565 8569 8570 8569 8571 8570 8564 8568 8565 8564 8565 8566 8664 8564 8566 8566 8565 8563 8570 8647 8565 8565 8647 8648 8565 8648 8563 8566 8563 8567 8567 8664 8566 8567 8663 8664 8567 8563 8562 8562 8663 8567 8558 8562 8563 8563 8648 8649 8563 8649 8558 8648 8647 8649 8558 8649 8650 8649 8647 8645 8649 8645 8650 8558 8650 8556 8556 8650 8651 8650 8645 8652 8650 8652 8651 8556 8651 8553 8553 8651 8652 8553 8555 8556 8559 8558 8556 8559 8556 8560 8560 8556 8555 8548 8552 8553 8552 8554 8553 8553 8554 8555 8553 8652 8548 8554 8660 8555 8555 8660 8560 8560 8660 8661 8560 8661 8559 8557 8558 8559 8559 8661 8557 8660 8482 8661 8481 8445 8482 8660 8481 8482 8480 8444 8481 8481 8444 8445 8480 8481 8660 8444 8415 8445 8443 8414 8444 8444 8414 8415 8479 8443 8444 8479 8444 8480 8659 8479 8480 8659 8480 8660 8478 8443 8479 8478 8479 8659 8658 8478 8659 8552 8658 8659 8552 8659 8554 8554 8659 8660 8477 8443 8478 8658 8477 8478 8476 8442 8477 8477 8442 8443 8476 8477 8658 8475 8442 8476 8658 8656 8476 8476 8656 8475 8441 8400 8442 8442 8400 8399 8442 8399 8443 8475 8441 8442 8474 8441 8475 8475 8656 8474 8440 8413 8441 8441 8413 8400 8440 8441 8474 8474 8541 8440 8474 8656 8657 8474 8657 8541 8439 8412 8440 8440 8412 8413 8440 8541 8542 8440 8542 8439 8541 8657 8542 8542 8657 8690 8656 8550 8657 8657 8550 8544 8657 8544 8690 8439 8542 8543 8542 8690 8543 8543 8690 8691 8690 8544 8629 8690 8629 8691 8544 8545 8546 8550 8545 8544 8546 8629 8544 8549 8545 8550 8656 8549 8550 8549 8548 8545 8548 8653 8545 8545 8653 8654 8545 8654 8546 8547 8548 8549 8547 8549 8656 8547 8551 8548 8548 8551 8552 8548 8652 8653 8654 8653 8652 8546 8654 8655 8655 8654 8630 8630 8654 8652 8546 8655 8626 8626 8655 8630 8626 8630 8623 8623 8630 8631 8630 8652 8631 8623 8625 8626 8625 8627 8626 8626 8627 8628 8626 8628 8546 8623 8624 8625 8624 8689 8625 8689 8627 8625 8689 8691 8627 8691 8628 8627 8546 8628 8629 8691 8629 8628 8543 8691 8537 8537 8691 8689 8439 8543 8537 8473 8439 8537 8537 8538 8473 8689 8538 8537 8473 8411 8439 8439 8411 8412 8472 8410 8473 8473 8410 8411 8473 8538 8539 8473 8539 8472 8689 8539 8538 8472 8539 8540 8688 8540 8539 8688 8539 8689 8624 8688 8689 8687 8533 8688 8533 8540 8688 8622 8687 8688 8622 8688 8624 8472 8540 8533 8471 8472 8533 8533 8534 8471 8687 8534 8533 8470 8406 8471 8471 8406 8405 8471 8405 8472 8471 8534 8535 8471 8535 8470 8535 8534 8687 8470 8535 8536 8686 8536 8535 8686 8535 8687 8470 8536 8529 8529 8536 8686 8619 8620 8686 8686 8620 8685 8686 8685 8529 8619 8686 8617 8617 8686 8687 8469 8470 8529 8529 8530 8469 8529 8685 8530 8469 8438 8470 8470 8438 8406 8437 8404 8438 8438 8404 8406 8469 8437 8438 8404 8405 8406 8411 8405 8404 8411 8404 8412 8437 8430 8404 8436 8430 8437 8468 8436 8437 8468 8437 8469 8435 8428 8436 8436 8428 8430 8467 8435 8436 8467 8436 8468 8466 8428 8435 8466 8435 8467 8428 8429 8430 8465 8429 8428 8465 8428 8466 8465 8466 8521 8467 8527 8466 8466 8527 8528 8466 8528 8521 8464 8429 8465 8521 8522 8465 8465 8522 8523 8465 8523 8464 8430 8429 8431 8464 8431 8429 8432 8407 8430 8432 8430 8433 8433 8430 8431 8433 8431 8434 8463 8434 8431 8463 8431 8464 8461 8432 8433 8461 8433 8462 8462 8433 8434 8462 8434 8463 8463 8464 8517 8517 8518 8463 8463 8518 8519 8463 8519 8462 8461 8462 8513 8462 8519 8520 8462 8520 8513 8678 8520 8519 8678 8519 8679 8519 8518 8679 8679 8518 8517 8679 8517 8680 8603 8678 8679 8603 8679 8602 8602 8679 8600 8600 8679 8680 8602 8599 8603 8603 8599 8598 8598 8678 8603 8600 8601 8602 8602 8601 8599 8600 8604 8601 8600 8680 8604 8601 8604 8605 8601 8605 8606 8606 8636 8601 8601 8636 8637 8601 8637 8599 8604 8680 8605 8610 8606 8605 8605 8680 8681 8605 8681 8610 8609 8606 8610 8610 8681 8682 8610 8682 8609 8680 8523 8681 8523 8522 8681 8681 8522 8521 8681 8521 8682 8517 8524 8680 8680 8524 8523 8464 8523 8524 8464 8524 8517 8682 8521 8528 8682 8528 8527 8527 8683 8682 8682 8683 8607 8682 8607 8609 8467 8526 8527 8527 8526 8683 8467 8468 8525 8525 8526 8467 8683 8526 8525 8468 8532 8525 8683 8525 8684 8532 8684 8525 8469 8531 8468 8468 8531 8532 8531 8684 8532 8531 8685 8684 8685 8614 8684 8684 8614 8612 8684 8612 8683 8469 8530 8531 8530 8685 8531 8620 8615 8685 8685 8615 8614 8612 8614 8613 8613 8614 8615 8608 8611 8612 8608 8612 8613 8683 8612 8611 8683 8611 8607 8607 8611 8608 8607 8608 8609 8609 8608 8606 8613 8634 8608 8608 8634 8635 8608 8635 8606 8606 8635 8636 8652 8636 8635 8635 8634 8652 8613 8633 8634 8652 8634 8633 8616 8632 8633 8616 8633 8613 8652 8633 8632 8618 8631 8632 8618 8632 8616 8631 8652 8632 8623 8631 8618 8618 8622 8623 8622 8624 8623 8618 8621 8622 8621 8687 8622 8617 8621 8618 8617 8687 8621 8617 8618 8619 8619 8618 8616 8619 8616 8620 8620 8616 8615 8613 8615 8616 8638 8637 8652 8652 8637 8636 8638 8652 8639 8639 8652 8641 8643 8641 8652 8643 8652 8644 8644 8652 8645 8599 8637 8638 8596 8598 8599 8599 8638 8596 8591 8595 8596 8595 8597 8596 8596 8597 8598 8596 8638 8639 8596 8639 8591 8597 8678 8598 8595 8677 8597 8597 8677 8678 8591 8594 8595 8594 8676 8595 8595 8676 8677 8676 8515 8677 8515 8514 8677 8677 8514 8513 8677 8513 8678 8513 8520 8678 8513 8514 8461 8461 8514 8515 8461 8515 8460 8460 8515 8516 8676 8516 8515 8460 8432 8461 8459 8408 8460 8460 8408 8432 8459 8460 8509 8460 8516 8509 8509 8516 8676 8509 8510 8459 8675 8510 8509 8675 8509 8676 8459 8510 8511 8511 8510 8675 8459 8511 8458 8458 8511 8512 8674 8512 8511 8674 8511 8675 8458 8512 8508 8508 8512 8674 8673 8508 8674 8588 8673 8674 8588 8674 8593 8593 8674 8675 8507 8458 8508 8673 8507 8508 8672 8506 8673 8506 8507 8673 8587 8672 8673 8587 8673 8588 8586 8587 8588 8586 8588 8589 8593 8589 8588 8592 8589 8593 8593 8675 8592 8592 8591 8589 8591 8640 8589 8589 8640 8641 8589 8641 8586 8590 8591 8592 8592 8675 8590 8590 8675 8676 8590 8594 8591 8590 8676 8594 8591 8639 8640 8639 8641 8640 8586 8641 8642 8642 8641 8643 8586 8642 8583 8583 8642 8643 8583 8643 8580 8580 8643 8644 8580 8582 8583 8582 8584 8583 8583 8584 8585 8583 8585 8586 8585 8587 8586 8584 8672 8585 8585 8672 8587 8582 8671 8584 8584 8671 8672 8580 8581 8582 8581 8671 8582 8670 8502 8671 8502 8503 8671 8671 8503 8504 8671 8504 8672 8581 8670 8671 8504 8505 8672 8672 8505 8506 8503 8456 8504 8504 8456 8505 8502 8455 8503 8503 8455 8456 8501 8455 8502 8670 8501 8502 8454 8424 8455 8455 8424 8425 8455 8425 8456 8501 8454 8455 8456 8425 8426 8456 8426 8457 8505 8456 8457 8505 8457 8506 8506 8457 8507 8457 8426 8427 8457 8427 8458 8507 8457 8458 8425 8407 8426 8426 8407 8409 8426 8409 8427 8424 8421 8425 8425 8421 8407 8407 8408 8409 8408 8407 8432 8458 8427 8409 8458 8409 8459 8459 8409 8408 8420 8421 8422 8424 8422 8421 8451 8419 8420 8451 8420 8452 8452 8420 8422 8423 8422 8424 8452 8422 8453 8453 8422 8423 8454 8423 8424 8453 8423 8454 8497 8452 8453 8497 8453 8498 8498 8453 8499 8499 8453 8454 8499 8454 8500 8500 8454 8501 8498 8499 8669 8669 8499 8500 8668 8497 8498 8668 8498 8669 8496 8452 8497 8496 8497 8668 8576 8577 8668 8668 8577 8667 8668 8667 8496 8576 8668 8574 8574 8668 8669 8495 8452 8496 8496 8667 8495 8495 8667 8494 8577 8572 8667 8667 8572 8571 8576 8573 8577 8577 8573 8572 8570 8571 8572 8570 8572 8573 8576 8575 8573 8575 8645 8573 8573 8645 8646 8573 8646 8570 8570 8646 8647 8647 8646 8645 8575 8644 8645 8580 8644 8575 8575 8579 8580 8579 8581 8580 8575 8578 8579 8578 8669 8579 8579 8669 8670 8579 8670 8581 8574 8578 8575 8574 8669 8578 8669 8500 8670 8500 8501 8670 8574 8575 8576 8494 8451 8495 8495 8451 8452 8410 8405 8411 8472 8405 8410 8551 8658 8552 8551 8547 8658 8658 8547 8656 8443 8399 8414 8414 8399 8415 8557 8561 8558 8558 8561 8562 8723 8724 8725 8737 8729 8723 8737 8723 8738 8738 8723 8725 8740 8724 8723 8740 8723 8741 8741 8723 8726 9026 8723 9027 9027 8723 8729 9028 8726 8723 9028 8723 9026 9026 9027 9035 9035 9036 9026 9026 9036 9037 9026 9037 9028 9019 8726 9028 9019 9028 9032 9028 9037 9047 9032 9028 9047 9037 9036 9047 9047 9036 9035 9035 9027 9047 9027 8729 9024 9038 9027 9024 9027 9038 9047 9024 8729 9025 9025 9039 9024 9024 9039 9040 9024 9040 9038 9038 9040 9047 9047 9040 9039 9039 9025 9047 9025 8729 8755 9025 8755 9022 9022 9043 9025 9025 9043 9047 9022 8755 9023 9022 9023 9041 9041 9042 9022 9022 9042 9043 9043 9042 9047 9042 9041 9047 9047 9041 9023 9023 8755 8732 9023 8732 9020 9020 9046 9023 9023 9046 9047 9020 8732 9021 9020 9021 9044 9044 9045 9020 9020 9045 9046 9046 9045 9047 9047 9045 9044 9044 9021 9047 9021 8732 8746 9021 8746 9017 9017 9031 9021 9021 9031 9047 9017 8746 9018 9017 9018 9029 9029 9030 9017 9017 9030 9031 9031 9030 9047 9030 9029 9047 9047 9029 9018 9018 8746 8726 9018 8726 9019 9019 9034 9018 9018 9034 9047 9047 9033 9032 9034 9033 9047 9019 9033 9034 9032 9033 9019 8726 8727 8728 8741 8726 8742 8742 8726 8728 8744 8727 8726 8744 8726 8745 8745 8726 8746 8772 8742 8728 8772 8728 8773 8773 8728 8727 8771 8741 8742 8771 8742 8772 8770 8740 8741 8770 8741 8771 8808 8770 8771 8808 8771 8809 8809 8771 8810 8810 8771 8772 8807 8770 8808 8807 8808 8986 8986 8808 8809 8986 8809 8987 8809 8810 8987 8810 8772 8811 8987 8810 8811 8987 8811 8988 8882 8986 8987 8882 8987 8886 8886 8987 8887 8887 8987 8988 8811 8772 8812 8811 8812 8988 8812 8772 8773 8812 8773 8813 8988 8812 8813 8773 8727 8774 8813 8773 8814 8814 8773 8774 8988 8813 8989 8989 8813 8814 8814 8774 8815 8989 8814 8815 8774 8727 8743 8774 8743 8775 8815 8774 8816 8816 8774 8775 8743 8727 8744 8775 8743 8744 8775 8744 8776 8816 8775 8817 8817 8775 8818 8818 8775 8776 8815 8816 8990 8990 8816 8817 8815 8990 8989 8990 8817 8991 8989 8990 8889 8991 8894 8990 8990 8894 8893 8990 8893 8889 8818 8991 8817 8818 8776 8819 8819 8991 8818 8819 8992 8991 8992 8896 8991 8991 8896 8894 8890 8893 8894 8890 8894 8895 8894 8896 8895 8889 8893 8890 8889 8890 8891 8989 8889 8891 8891 8890 8888 8895 8972 8890 8890 8972 8973 8890 8973 8888 8891 8888 8892 8892 8989 8891 8892 8988 8989 8892 8888 8887 8887 8988 8892 8883 8887 8888 8888 8973 8974 8888 8974 8883 8973 8972 8974 8883 8974 8975 8974 8972 8970 8974 8970 8975 8883 8975 8881 8881 8975 8976 8975 8970 8977 8975 8977 8976 8881 8976 8878 8878 8976 8977 8878 8880 8881 8884 8883 8881 8884 8881 8885 8885 8881 8880 8873 8877 8878 8877 8879 8878 8878 8879 8880 8878 8977 8873 8879 8985 8880 8880 8985 8885 8885 8985 8986 8885 8986 8884 8882 8883 8884 8884 8986 8882 8985 8807 8986 8806 8770 8807 8985 8806 8807 8805 8769 8806 8806 8769 8770 8805 8806 8985 8769 8740 8770 8768 8739 8769 8769 8739 8740 8804 8768 8769 8804 8769 8805 8984 8804 8805 8984 8805 8985 8803 8768 8804 8803 8804 8984 8983 8803 8984 8877 8983 8984 8877 8984 8879 8879 8984 8985 8802 8768 8803 8983 8802 8803 8801 8767 8802 8802 8767 8768 8801 8802 8983 8800 8767 8801 8983 8981 8801 8801 8981 8800 8766 8725 8767 8767 8725 8724 8767 8724 8768 8800 8766 8767 8799 8766 8800 8800 8981 8799 8765 8738 8766 8766 8738 8725 8765 8766 8799 8799 8866 8765 8799 8981 8982 8799 8982 8866 8764 8737 8765 8765 8737 8738 8765 8866 8867 8765 8867 8764 8866 8982 8867 8867 8982 9015 8981 8875 8982 8982 8875 8869 8982 8869 9015 8764 8867 8868 8867 9015 8868 8868 9015 9016 9015 8869 8954 9015 8954 9016 8869 8870 8871 8875 8870 8869 8871 8954 8869 8874 8870 8875 8981 8874 8875 8874 8873 8870 8873 8978 8870 8870 8978 8979 8870 8979 8871 8872 8873 8874 8872 8874 8981 8872 8876 8873 8873 8876 8877 8873 8977 8978 8979 8978 8977 8871 8979 8980 8980 8979 8955 8955 8979 8977 8871 8980 8951 8951 8980 8955 8951 8955 8948 8948 8955 8956 8955 8977 8956 8948 8950 8951 8950 8952 8951 8951 8952 8953 8951 8953 8871 8948 8949 8950 8949 9014 8950 9014 8952 8950 9014 9016 8952 9016 8953 8952 8871 8953 8954 9016 8954 8953 8868 9016 8862 8862 9016 9014 8764 8868 8862 8798 8764 8862 8862 8863 8798 9014 8863 8862 8798 8736 8764 8764 8736 8737 8797 8735 8798 8798 8735 8736 8798 8863 8864 8798 8864 8797 9014 8864 8863 8797 8864 8865 9013 8865 8864 9013 8864 9014 8949 9013 9014 9012 8858 9013 8858 8865 9013 8947 9012 9013 8947 9013 8949 8797 8865 8858 8796 8797 8858 8858 8859 8796 9012 8859 8858 8795 8731 8796 8796 8731 8730 8796 8730 8797 8796 8859 8860 8796 8860 8795 8860 8859 9012 8795 8860 8861 9011 8861 8860 9011 8860 9012 8795 8861 8854 8854 8861 9011 8944 8945 9011 9011 8945 9010 9011 9010 8854 8944 9011 8942 8942 9011 9012 8794 8795 8854 8854 8855 8794 8854 9010 8855 8794 8763 8795 8795 8763 8731 8762 8729 8763 8763 8729 8731 8794 8762 8763 8729 8730 8731 8736 8730 8729 8736 8729 8737 8762 8755 8729 8761 8755 8762 8793 8761 8762 8793 8762 8794 8760 8753 8761 8761 8753 8755 8792 8760 8761 8792 8761 8793 8791 8753 8760 8791 8760 8792 8753 8754 8755 8790 8754 8753 8790 8753 8791 8790 8791 8846 8792 8852 8791 8791 8852 8853 8791 8853 8846 8789 8754 8790 8846 8847 8790 8790 8847 8848 8790 8848 8789 8755 8754 8756 8789 8756 8754 8757 8732 8755 8757 8755 8758 8758 8755 8756 8758 8756 8759 8788 8759 8756 8788 8756 8789 8786 8757 8758 8786 8758 8787 8787 8758 8759 8787 8759 8788 8788 8789 8842 8842 8843 8788 8788 8843 8844 8788 8844 8787 8786 8787 8838 8787 8844 8845 8787 8845 8838 9003 8845 8844 9003 8844 9004 8844 8843 9004 9004 8843 8842 9004 8842 9005 8928 9003 9004 8928 9004 8927 8927 9004 8925 8925 9004 9005 8927 8924 8928 8928 8924 8923 8923 9003 8928 8925 8926 8927 8927 8926 8924 8925 8929 8926 8925 9005 8929 8926 8929 8930 8926 8930 8931 8931 8961 8926 8926 8961 8962 8926 8962 8924 8929 9005 8930 8935 8931 8930 8930 9005 9006 8930 9006 8935 8934 8931 8935 8935 9006 9007 8935 9007 8934 9005 8848 9006 8848 8847 9006 9006 8847 8846 9006 8846 9007 8842 8849 9005 9005 8849 8848 8789 8848 8849 8789 8849 8842 9007 8846 8853 9007 8853 8852 8852 9008 9007 9007 9008 8932 9007 8932 8934 8792 8851 8852 8852 8851 9008 8792 8793 8850 8850 8851 8792 9008 8851 8850 8793 8857 8850 9008 8850 9009 8857 9009 8850 8794 8856 8793 8793 8856 8857 8856 9009 8857 8856 9010 9009 9010 8939 9009 9009 8939 8937 9009 8937 9008 8794 8855 8856 8855 9010 8856 8945 8940 9010 9010 8940 8939 8937 8939 8938 8938 8939 8940 8933 8936 8937 8933 8937 8938 9008 8937 8936 9008 8936 8932 8932 8936 8933 8932 8933 8934 8934 8933 8931 8938 8959 8933 8933 8959 8960 8933 8960 8931 8931 8960 8961 8977 8961 8960 8960 8959 8977 8938 8958 8959 8977 8959 8958 8941 8957 8958 8941 8958 8938 8977 8958 8957 8943 8956 8957 8943 8957 8941 8956 8977 8957 8948 8956 8943 8943 8947 8948 8947 8949 8948 8943 8946 8947 8946 9012 8947 8942 8946 8943 8942 9012 8946 8942 8943 8944 8944 8943 8941 8944 8941 8945 8945 8941 8940 8938 8940 8941 8963 8962 8977 8977 8962 8961 8963 8977 8964 8964 8977 8966 8968 8966 8977 8968 8977 8969 8969 8977 8970 8924 8962 8963 8921 8923 8924 8924 8963 8921 8916 8920 8921 8920 8922 8921 8921 8922 8923 8921 8963 8964 8921 8964 8916 8922 9003 8923 8920 9002 8922 8922 9002 9003 8916 8919 8920 8919 9001 8920 8920 9001 9002 9001 8840 9002 8840 8839 9002 9002 8839 8838 9002 8838 9003 8838 8845 9003 8838 8839 8786 8786 8839 8840 8786 8840 8785 8785 8840 8841 9001 8841 8840 8785 8757 8786 8784 8733 8785 8785 8733 8757 8784 8785 8834 8785 8841 8834 8834 8841 9001 8834 8835 8784 9000 8835 8834 9000 8834 9001 8784 8835 8836 8836 8835 9000 8784 8836 8783 8783 8836 8837 8999 8837 8836 8999 8836 9000 8783 8837 8833 8833 8837 8999 8998 8833 8999 8913 8998 8999 8913 8999 8918 8918 8999 9000 8832 8783 8833 8998 8832 8833 8997 8831 8998 8831 8832 8998 8912 8997 8998 8912 8998 8913 8911 8912 8913 8911 8913 8914 8918 8914 8913 8917 8914 8918 8918 9000 8917 8917 8916 8914 8916 8965 8914 8914 8965 8966 8914 8966 8911 8915 8916 8917 8917 9000 8915 8915 9000 9001 8915 8919 8916 8915 9001 8919 8916 8964 8965 8964 8966 8965 8911 8966 8967 8967 8966 8968 8911 8967 8908 8908 8967 8968 8908 8968 8905 8905 8968 8969 8905 8907 8908 8907 8909 8908 8908 8909 8910 8908 8910 8911 8910 8912 8911 8909 8997 8910 8910 8997 8912 8907 8996 8909 8909 8996 8997 8905 8906 8907 8906 8996 8907 8995 8827 8996 8827 8828 8996 8996 8828 8829 8996 8829 8997 8906 8995 8996 8829 8830 8997 8997 8830 8831 8828 8781 8829 8829 8781 8830 8827 8780 8828 8828 8780 8781 8826 8780 8827 8995 8826 8827 8779 8749 8780 8780 8749 8750 8780 8750 8781 8826 8779 8780 8781 8750 8751 8781 8751 8782 8830 8781 8782 8830 8782 8831 8831 8782 8832 8782 8751 8752 8782 8752 8783 8832 8782 8783 8750 8732 8751 8751 8732 8734 8751 8734 8752 8749 8746 8750 8750 8746 8732 8732 8733 8734 8733 8732 8757 8783 8752 8734 8783 8734 8784 8784 8734 8733 8745 8746 8747 8749 8747 8746 8776 8744 8745 8776 8745 8777 8777 8745 8747 8748 8747 8749 8777 8747 8778 8778 8747 8748 8779 8748 8749 8778 8748 8779 8822 8777 8778 8822 8778 8823 8823 8778 8824 8824 8778 8779 8824 8779 8825 8825 8779 8826 8823 8824 8994 8994 8824 8825 8993 8822 8823 8993 8823 8994 8821 8777 8822 8821 8822 8993 8901 8902 8993 8993 8902 8992 8993 8992 8821 8901 8993 8899 8899 8993 8994 8820 8777 8821 8821 8992 8820 8820 8992 8819 8902 8897 8992 8992 8897 8896 8901 8898 8902 8902 8898 8897 8895 8896 8897 8895 8897 8898 8901 8900 8898 8900 8970 8898 8898 8970 8971 8898 8971 8895 8895 8971 8972 8972 8971 8970 8900 8969 8970 8905 8969 8900 8900 8904 8905 8904 8906 8905 8900 8903 8904 8903 8994 8904 8904 8994 8995 8904 8995 8906 8899 8903 8900 8899 8994 8903 8994 8825 8995 8825 8826 8995 8899 8900 8901 8819 8776 8820 8820 8776 8777 8735 8730 8736 8797 8730 8735 8876 8983 8877 8876 8872 8983 8983 8872 8981 8768 8724 8739 8739 8724 8740 8882 8886 8883 8883 8886 8887))
                   (list :vertices (let ((mat (make-matrix 9048 3))) (fvector-replace (array-entity mat) #f(8.8364898681640625e+01 -9.6594902038574219e+01 2.4000000000000000e+01 8.9231002807617188e+01 -9.5843902587890625e+01 2.4000000000000000e+01 8.8655899047851562e+01 -9.6822593688964844e+01 2.4000000000000000e+01 8.9579101562500000e+01 -9.6177200317382812e+01 2.4000000000000000e+01 8.8888999938964844e+01 -9.7109306335449219e+01 2.4000000000000000e+01 8.9863998413085938e+01 -9.6565902709960938e+01 2.4000000000000000e+01 8.9052299499511719e+01 -9.7440696716308594e+01 2.4000000000000000e+01 9.0077102661132812e+01 -9.6998199462890625e+01 2.4000000000000000e+01 8.9137893676757812e+01 -9.7800201416015625e+01 2.4000000000000000e+01 8.7300193786621094e+01 -9.6362098693847656e+01 2.4000000000000000e+01 8.7440101623535156e+01 -9.5235603332519531e+01 2.4000000000000000e+01 8.7669601440429688e+01 -9.6358703613281250e+01 2.4000000000000000e+01 8.7920997619628906e+01 -9.5267196655273438e+01 2.4000000000000000e+01 8.8030601501464844e+01 -9.6437606811523438e+01 2.4000000000000000e+01 8.8389099121093750e+01 -9.5381896972656250e+01 2.4000000000000000e+01 8.8830299377441406e+01 -9.5576004028320312e+01 2.4000000000000000e+01 8.5862098693847656e+01 -9.8199798583984375e+01 2.4000000000000000e+01 8.4735603332519531e+01 -9.8059898376464844e+01 2.4000000000000000e+01 8.5858703613281250e+01 -9.7830398559570312e+01 2.4000000000000000e+01 8.4767196655273438e+01 -9.7579002380371094e+01 2.4000000000000000e+01 8.5937599182128906e+01 -9.7469398498535156e+01 2.4000000000000000e+01 8.4881904602050781e+01 -9.7110900878906250e+01 2.4000000000000000e+01 8.6094902038574219e+01 -9.7135093688964844e+01 2.4000000000000000e+01 8.6635101318359375e+01 -9.9405105590820312e+01 2.4000000000000000e+01 8.5768997192382812e+01 -1.0015599822998047e+02 2.4000000000000000e+01 8.6344100952148438e+01 -9.9177398681640625e+01 2.4000000000000000e+01 8.5420898437500000e+01 -9.9822799682617188e+01 2.4000000000000000e+01 8.6111000061035156e+01 -9.8890701293945312e+01 2.4000000000000000e+01 8.5135993957519531e+01 -9.9434097290039062e+01 2.4000000000000000e+01 8.5947700500488281e+01 -9.8559295654296875e+01 2.4000000000000000e+01 8.4922904968261719e+01 -9.9001800537109375e+01 2.4000000000000000e+01 8.4788101196289062e+01 -9.8539001464843750e+01 2.4000000000000000e+01 8.8905105590820312e+01 -9.8864898681640625e+01 2.4000000000000000e+01 8.9656097412109375e+01 -9.9730995178222656e+01 2.4000000000000000e+01 8.8677398681640625e+01 -9.9155899047851562e+01 2.4000000000000000e+01 8.9322799682617188e+01 -1.0007900238037109e+02 2.4000000000000000e+01 8.8390701293945312e+01 -9.9388900756835938e+01 2.4000000000000000e+01 8.8934104919433594e+01 -1.0036399841308594e+02 2.4000000000000000e+01 8.8059295654296875e+01 -9.9552307128906250e+01 2.4000000000000000e+01 8.8501800537109375e+01 -1.0057699584960938e+02 2.4000000000000000e+01 8.7699798583984375e+01 -9.9637901306152344e+01 2.4000000000000000e+01 8.5075996398925781e+01 -9.6669700622558594e+01 2.4000000000000000e+01 8.5343894958496094e+01 -9.6268997192382812e+01 2.4000000000000000e+01 8.6322601318359375e+01 -9.6844100952148438e+01 2.4000000000000000e+01 8.5677200317382812e+01 -9.5920898437500000e+01 2.4000000000000000e+01 8.6609298706054688e+01 -9.6611099243164062e+01 2.4000000000000000e+01 8.6065902709960938e+01 -9.5636001586914062e+01 2.4000000000000000e+01 8.6940696716308594e+01 -9.6447700500488281e+01 2.4000000000000000e+01 8.6498199462890625e+01 -9.5422904968261719e+01 2.4000000000000000e+01 8.6960899353027344e+01 -9.5288101196289062e+01 2.4000000000000000e+01 8.8039100646972656e+01 -1.0071199798583984e+02 2.4000000000000000e+01 8.7559898376464844e+01 -1.0076399993896484e+02 2.4000000000000000e+01 8.7330398559570312e+01 -9.9641304016113281e+01 2.4000000000000000e+01 8.7079002380371094e+01 -1.0073299407958984e+02 2.4000000000000000e+01 8.6969398498535156e+01 -9.9562400817871094e+01 2.4000000000000000e+01 8.6610900878906250e+01 -1.0061799621582031e+02 2.4000000000000000e+01 8.6169700622558594e+01 -1.0042399597167969e+02 2.4000000000000000e+01 9.0211898803710938e+01 -9.7460998535156250e+01 2.4000000000000000e+01 9.0264404296875000e+01 -9.7940101623535156e+01 2.4000000000000000e+01 8.9141304016113281e+01 -9.8169601440429688e+01 2.4000000000000000e+01 9.0232795715332031e+01 -9.8420997619628906e+01 2.4000000000000000e+01 8.9062400817871094e+01 -9.8530601501464844e+01 2.4000000000000000e+01 9.0118103027343750e+01 -9.8889099121093750e+01 2.4000000000000000e+01 8.9924003601074219e+01 -9.9330299377441406e+01 2.4000000000000000e+01 8.6344100952148438e+01 -9.9177398681640625e+01 2.9000000000000000e+01 8.5768997192382812e+01 -1.0015599822998047e+02 2.9000000000000000e+01 8.6635101318359375e+01 -9.9405105590820312e+01 2.9000000000000000e+01 8.6169700622558594e+01 -1.0042399597167969e+02 2.9000000000000000e+01 8.6969398498535156e+01 -9.9562400817871094e+01 2.9000000000000000e+01 8.6610900878906250e+01 -1.0061799621582031e+02 2.9000000000000000e+01 8.7330398559570312e+01 -9.9641304016113281e+01 2.9000000000000000e+01 8.8677398681640625e+01 -9.9155899047851562e+01 2.9000000000000000e+01 8.9656097412109375e+01 -9.9730995178222656e+01 2.9000000000000000e+01 8.8905105590820312e+01 -9.8864898681640625e+01 2.9000000000000000e+01 8.9924003601074219e+01 -9.9330299377441406e+01 2.9000000000000000e+01 8.9062400817871094e+01 -9.8530601501464844e+01 2.9000000000000000e+01 9.0118103027343750e+01 -9.8889099121093750e+01 2.9000000000000000e+01 8.9141304016113281e+01 -9.8169601440429688e+01 2.9000000000000000e+01 8.5858703613281250e+01 -9.7830398559570312e+01 2.9000000000000000e+01 8.4735603332519531e+01 -9.8059898376464844e+01 2.9000000000000000e+01 8.5862098693847656e+01 -9.8199798583984375e+01 2.9000000000000000e+01 8.4788101196289062e+01 -9.8539001464843750e+01 2.9000000000000000e+01 8.5947700500488281e+01 -9.8559295654296875e+01 2.9000000000000000e+01 8.4922904968261719e+01 -9.9001800537109375e+01 2.9000000000000000e+01 8.6111000061035156e+01 -9.8890701293945312e+01 2.9000000000000000e+01 8.5135993957519531e+01 -9.9434097290039062e+01 2.9000000000000000e+01 8.5420898437500000e+01 -9.9822799682617188e+01 2.9000000000000000e+01 8.6322601318359375e+01 -9.6844100952148438e+01 2.9000000000000000e+01 8.5343894958496094e+01 -9.6268997192382812e+01 2.9000000000000000e+01 8.6094902038574219e+01 -9.7135093688964844e+01 2.9000000000000000e+01 8.5075996398925781e+01 -9.6669700622558594e+01 2.9000000000000000e+01 8.5937599182128906e+01 -9.7469398498535156e+01 2.9000000000000000e+01 8.4881904602050781e+01 -9.7110900878906250e+01 2.9000000000000000e+01 8.4767196655273438e+01 -9.7579002380371094e+01 2.9000000000000000e+01 8.7079002380371094e+01 -1.0073299407958984e+02 2.9000000000000000e+01 8.7559898376464844e+01 -1.0076399993896484e+02 2.9000000000000000e+01 8.7699798583984375e+01 -9.9637901306152344e+01 2.9000000000000000e+01 8.8039100646972656e+01 -1.0071199798583984e+02 2.9000000000000000e+01 8.8059295654296875e+01 -9.9552307128906250e+01 2.9000000000000000e+01 8.8501800537109375e+01 -1.0057699584960938e+02 2.9000000000000000e+01 8.8390701293945312e+01 -9.9388900756835938e+01 2.9000000000000000e+01 8.8934104919433594e+01 -1.0036399841308594e+02 2.9000000000000000e+01 8.9322799682617188e+01 -1.0007900238037109e+02 2.9000000000000000e+01 8.7669601440429688e+01 -9.6358703613281250e+01 2.9000000000000000e+01 8.7440101623535156e+01 -9.5235603332519531e+01 2.9000000000000000e+01 8.7300193786621094e+01 -9.6362098693847656e+01 2.9000000000000000e+01 8.6960899353027344e+01 -9.5288101196289062e+01 2.9000000000000000e+01 8.6940696716308594e+01 -9.6447700500488281e+01 2.9000000000000000e+01 8.6498199462890625e+01 -9.5422904968261719e+01 2.9000000000000000e+01 8.6609298706054688e+01 -9.6611099243164062e+01 2.9000000000000000e+01 8.6065902709960938e+01 -9.5636001586914062e+01 2.9000000000000000e+01 8.5677200317382812e+01 -9.5920898437500000e+01 2.9000000000000000e+01 9.0232795715332031e+01 -9.8420997619628906e+01 2.9000000000000000e+01 9.0264404296875000e+01 -9.7940101623535156e+01 2.9000000000000000e+01 8.9137893676757812e+01 -9.7800201416015625e+01 2.9000000000000000e+01 9.0211898803710938e+01 -9.7460998535156250e+01 2.9000000000000000e+01 8.9052299499511719e+01 -9.7440696716308594e+01 2.9000000000000000e+01 9.0077102661132812e+01 -9.6998199462890625e+01 2.9000000000000000e+01 8.8888999938964844e+01 -9.7109306335449219e+01 2.9000000000000000e+01 8.9863998413085938e+01 -9.6565902709960938e+01 2.9000000000000000e+01 8.8655899047851562e+01 -9.6822593688964844e+01 2.9000000000000000e+01 8.9579101562500000e+01 -9.6177200317382812e+01 2.9000000000000000e+01 8.9231002807617188e+01 -9.5843902587890625e+01 2.9000000000000000e+01 8.8364898681640625e+01 -9.6594902038574219e+01 2.9000000000000000e+01 8.8830299377441406e+01 -9.5576004028320312e+01 2.9000000000000000e+01 8.8030601501464844e+01 -9.6437606811523438e+01 2.9000000000000000e+01 8.8389099121093750e+01 -9.5381896972656250e+01 2.9000000000000000e+01 8.7920997619628906e+01 -9.5267196655273438e+01 2.9000000000000000e+01 8.8364898681640625e+01 -4.7094902038574219e+01 2.4000000000000000e+01 8.9231002807617188e+01 -4.6343898773193359e+01 2.4000000000000000e+01 8.8655899047851562e+01 -4.7322601318359375e+01 2.4000000000000000e+01 8.9579101562500000e+01 -4.6677196502685547e+01 2.4000000000000000e+01 8.8888999938964844e+01 -4.7609298706054688e+01 2.4000000000000000e+01 8.9863998413085938e+01 -4.7065898895263672e+01 2.4000000000000000e+01 8.9052299499511719e+01 -4.7940700531005859e+01 2.4000000000000000e+01 9.0077102661132812e+01 -4.7498199462890625e+01 2.4000000000000000e+01 8.9137893676757812e+01 -4.8300197601318359e+01 2.4000000000000000e+01 8.7300193786621094e+01 -4.6862098693847656e+01 2.4000000000000000e+01 8.7440101623535156e+01 -4.5735599517822266e+01 2.4000000000000000e+01 8.7669601440429688e+01 -4.6858703613281250e+01 2.4000000000000000e+01 8.7920997619628906e+01 -4.5767200469970703e+01 2.4000000000000000e+01 8.8030601501464844e+01 -4.6937599182128906e+01 2.4000000000000000e+01 8.8389099121093750e+01 -4.5881900787353516e+01 2.4000000000000000e+01 8.8830299377441406e+01 -4.6076000213623047e+01 2.4000000000000000e+01 8.5862098693847656e+01 -4.8699798583984375e+01 2.4000000000000000e+01 8.4735603332519531e+01 -4.8559902191162109e+01 2.4000000000000000e+01 8.5858703613281250e+01 -4.8330398559570312e+01 2.4000000000000000e+01 8.4767196655273438e+01 -4.8078998565673828e+01 2.4000000000000000e+01 8.5937599182128906e+01 -4.7969402313232422e+01 2.4000000000000000e+01 8.4881904602050781e+01 -4.7610900878906250e+01 2.4000000000000000e+01 8.6094902038574219e+01 -4.7635101318359375e+01 2.4000000000000000e+01 8.6635101318359375e+01 -4.9905097961425781e+01 2.4000000000000000e+01 8.5768997192382812e+01 -5.0656097412109375e+01 2.4000000000000000e+01 8.6344100952148438e+01 -4.9677402496337891e+01 2.4000000000000000e+01 8.5420898437500000e+01 -5.0322799682617188e+01 2.4000000000000000e+01 8.6111000061035156e+01 -4.9390701293945312e+01 2.4000000000000000e+01 8.5135993957519531e+01 -4.9934101104736328e+01 2.4000000000000000e+01 8.5947700500488281e+01 -4.9059303283691406e+01 2.4000000000000000e+01 8.4922904968261719e+01 -4.9501800537109375e+01 2.4000000000000000e+01 8.4788101196289062e+01 -4.9039100646972656e+01 2.4000000000000000e+01 8.8905105590820312e+01 -4.9364898681640625e+01 2.4000000000000000e+01 8.9656097412109375e+01 -5.0230998992919922e+01 2.4000000000000000e+01 8.8677398681640625e+01 -4.9655899047851562e+01 2.4000000000000000e+01 8.9322799682617188e+01 -5.0579101562500000e+01 2.4000000000000000e+01 8.8390701293945312e+01 -4.9888999938964844e+01 2.4000000000000000e+01 8.8934104919433594e+01 -5.0863998413085938e+01 2.4000000000000000e+01 8.8059295654296875e+01 -5.0052299499511719e+01 2.4000000000000000e+01 8.8501800537109375e+01 -5.1077102661132812e+01 2.4000000000000000e+01 8.7699798583984375e+01 -5.0137901306152344e+01 2.4000000000000000e+01 8.5075996398925781e+01 -4.7169700622558594e+01 2.4000000000000000e+01 8.5343894958496094e+01 -4.6769001007080078e+01 2.4000000000000000e+01 8.6322601318359375e+01 -4.7344100952148438e+01 2.4000000000000000e+01 8.5677200317382812e+01 -4.6420898437500000e+01 2.4000000000000000e+01 8.6609298706054688e+01 -4.7111000061035156e+01 2.4000000000000000e+01 8.6065902709960938e+01 -4.6135997772216797e+01 2.4000000000000000e+01 8.6940696716308594e+01 -4.6947700500488281e+01 2.4000000000000000e+01 8.6498199462890625e+01 -4.5922901153564453e+01 2.4000000000000000e+01 8.6960899353027344e+01 -4.5788101196289062e+01 2.4000000000000000e+01 8.8039100646972656e+01 -5.1211902618408203e+01 2.4000000000000000e+01 8.7559898376464844e+01 -5.1264400482177734e+01 2.4000000000000000e+01 8.7330398559570312e+01 -5.0141300201416016e+01 2.4000000000000000e+01 8.7079002380371094e+01 -5.1232799530029297e+01 2.4000000000000000e+01 8.6969398498535156e+01 -5.0062400817871094e+01 2.4000000000000000e+01 8.6610900878906250e+01 -5.1118099212646484e+01 2.4000000000000000e+01 8.6169700622558594e+01 -5.0923999786376953e+01 2.4000000000000000e+01 9.0211898803710938e+01 -4.7960899353027344e+01 2.4000000000000000e+01 9.0264404296875000e+01 -4.8440097808837891e+01 2.4000000000000000e+01 8.9141304016113281e+01 -4.8669597625732422e+01 2.4000000000000000e+01 9.0232795715332031e+01 -4.8921001434326172e+01 2.4000000000000000e+01 8.9062400817871094e+01 -4.9030597686767578e+01 2.4000000000000000e+01 9.0118103027343750e+01 -4.9389102935791016e+01 2.4000000000000000e+01 8.9924003601074219e+01 -4.9830299377441406e+01 2.4000000000000000e+01 8.6344100952148438e+01 -4.9677402496337891e+01 2.9000000000000000e+01 8.5768997192382812e+01 -5.0656097412109375e+01 2.9000000000000000e+01 8.6635101318359375e+01 -4.9905097961425781e+01 2.9000000000000000e+01 8.6169700622558594e+01 -5.0923999786376953e+01 2.9000000000000000e+01 8.6969398498535156e+01 -5.0062400817871094e+01 2.9000000000000000e+01 8.6610900878906250e+01 -5.1118099212646484e+01 2.9000000000000000e+01 8.7330398559570312e+01 -5.0141300201416016e+01 2.9000000000000000e+01 8.8677398681640625e+01 -4.9655899047851562e+01 2.9000000000000000e+01 8.9656097412109375e+01 -5.0230998992919922e+01 2.9000000000000000e+01 8.8905105590820312e+01 -4.9364898681640625e+01 2.9000000000000000e+01 8.9924003601074219e+01 -4.9830299377441406e+01 2.9000000000000000e+01 8.9062400817871094e+01 -4.9030597686767578e+01 2.9000000000000000e+01 9.0118103027343750e+01 -4.9389102935791016e+01 2.9000000000000000e+01 8.9141304016113281e+01 -4.8669597625732422e+01 2.9000000000000000e+01 8.5858703613281250e+01 -4.8330398559570312e+01 2.9000000000000000e+01 8.4735603332519531e+01 -4.8559902191162109e+01 2.9000000000000000e+01 8.5862098693847656e+01 -4.8699798583984375e+01 2.9000000000000000e+01 8.4788101196289062e+01 -4.9039100646972656e+01 2.9000000000000000e+01 8.5947700500488281e+01 -4.9059303283691406e+01 2.9000000000000000e+01 8.4922904968261719e+01 -4.9501800537109375e+01 2.9000000000000000e+01 8.6111000061035156e+01 -4.9390701293945312e+01 2.9000000000000000e+01 8.5135993957519531e+01 -4.9934101104736328e+01 2.9000000000000000e+01 8.5420898437500000e+01 -5.0322799682617188e+01 2.9000000000000000e+01 8.6322601318359375e+01 -4.7344100952148438e+01 2.9000000000000000e+01 8.5343894958496094e+01 -4.6769001007080078e+01 2.9000000000000000e+01 8.6094902038574219e+01 -4.7635101318359375e+01 2.9000000000000000e+01 8.5075996398925781e+01 -4.7169700622558594e+01 2.9000000000000000e+01 8.5937599182128906e+01 -4.7969402313232422e+01 2.9000000000000000e+01 8.4881904602050781e+01 -4.7610900878906250e+01 2.9000000000000000e+01 8.4767196655273438e+01 -4.8078998565673828e+01 2.9000000000000000e+01 8.7079002380371094e+01 -5.1232799530029297e+01 2.9000000000000000e+01 8.7559898376464844e+01 -5.1264400482177734e+01 2.9000000000000000e+01 8.7699798583984375e+01 -5.0137901306152344e+01 2.9000000000000000e+01 8.8039100646972656e+01 -5.1211902618408203e+01 2.9000000000000000e+01 8.8059295654296875e+01 -5.0052299499511719e+01 2.9000000000000000e+01 8.8501800537109375e+01 -5.1077102661132812e+01 2.9000000000000000e+01 8.8390701293945312e+01 -4.9888999938964844e+01 2.9000000000000000e+01 8.8934104919433594e+01 -5.0863998413085938e+01 2.9000000000000000e+01 8.9322799682617188e+01 -5.0579101562500000e+01 2.9000000000000000e+01 8.7669601440429688e+01 -4.6858703613281250e+01 2.9000000000000000e+01 8.7440101623535156e+01 -4.5735599517822266e+01 2.9000000000000000e+01 8.7300193786621094e+01 -4.6862098693847656e+01 2.9000000000000000e+01 8.6960899353027344e+01 -4.5788101196289062e+01 2.9000000000000000e+01 8.6940696716308594e+01 -4.6947700500488281e+01 2.9000000000000000e+01 8.6498199462890625e+01 -4.5922901153564453e+01 2.9000000000000000e+01 8.6609298706054688e+01 -4.7111000061035156e+01 2.9000000000000000e+01 8.6065902709960938e+01 -4.6135997772216797e+01 2.9000000000000000e+01 8.5677200317382812e+01 -4.6420898437500000e+01 2.9000000000000000e+01 9.0232795715332031e+01 -4.8921001434326172e+01 2.9000000000000000e+01 9.0264404296875000e+01 -4.8440097808837891e+01 2.9000000000000000e+01 8.9137893676757812e+01 -4.8300197601318359e+01 2.9000000000000000e+01 9.0211898803710938e+01 -4.7960899353027344e+01 2.9000000000000000e+01 8.9052299499511719e+01 -4.7940700531005859e+01 2.9000000000000000e+01 9.0077102661132812e+01 -4.7498199462890625e+01 2.9000000000000000e+01 8.8888999938964844e+01 -4.7609298706054688e+01 2.9000000000000000e+01 8.9863998413085938e+01 -4.7065898895263672e+01 2.9000000000000000e+01 8.8655899047851562e+01 -4.7322601318359375e+01 2.9000000000000000e+01 8.9579101562500000e+01 -4.6677196502685547e+01 2.9000000000000000e+01 8.9231002807617188e+01 -4.6343898773193359e+01 2.9000000000000000e+01 8.8364898681640625e+01 -4.7094902038574219e+01 2.9000000000000000e+01 8.8830299377441406e+01 -4.6076000213623047e+01 2.9000000000000000e+01 8.8030601501464844e+01 -4.6937599182128906e+01 2.9000000000000000e+01 8.8389099121093750e+01 -4.5881900787353516e+01 2.9000000000000000e+01 8.7920997619628906e+01 -4.5767200469970703e+01 2.9000000000000000e+01 9.0632698059082031e+01 -1.4460800170898438e+02 -6.7859596252441406e+01 8.9160705566406250e+01 -1.4485000610351562e+02 -6.5000000000000000e+01 1.3880799865722656e+02 -1.4485000610351562e+02 -6.5000000000000000e+01 1.0072799682617188e+02 -1.2483100128173828e+02 -8.7472404479980469e+01 1.4929200744628906e+02 -1.2884199523925781e+02 -8.6544097900390625e+01 1.0100000000000000e+02 -1.2184999847412109e+02 -8.8000000000000000e+01 1.4940800476074219e+02 -1.2816099548339844e+02 -8.6782905578613281e+01 1.4985499572753906e+02 -1.2554199981689453e+02 -8.7701797485351562e+01 1.4988000488281250e+02 -1.2489900207519531e+02 -8.7753700256347656e+01 1.5000000000000000e+02 -1.2184999847412109e+02 -8.8000000000000000e+01 1.0041699981689453e+02 -1.2824299621582031e+02 -8.6868400573730469e+01 1.0035400390625000e+02 -1.2893499755859375e+02 -8.6745903015136719e+01 1.4877799987792969e+02 -1.3184800720214844e+02 -8.5489303588867188e+01 1.0028099822998047e+02 -1.2974600219726562e+02 -8.6602302551269531e+01 1.4855599975585938e+02 -1.3314999389648438e+02 -8.5032501220703125e+01 1.4774499511718750e+02 -1.3517098999023438e+02 -8.3365905761718750e+01 9.8209594726562500e+01 -1.3668099975585938e+02 -8.2579200744628906e+01 1.4532699584960938e+02 -1.4024899291992188e+02 -7.8396095275878906e+01 9.8551803588867188e+01 -1.3553500366210938e+02 -8.3243896484375000e+01 1.4605900573730469e+02 -1.3936999511718750e+02 -7.9901100158691406e+01 9.8636199951171875e+01 -1.3525299072265625e+02 -8.3407897949218750e+01 1.4614999389648438e+02 -1.3914300537109375e+02 -8.0088401794433594e+01 1.4764801025390625e+02 -1.3541198730468750e+02 -8.3166702270507812e+01 9.9680702209472656e+01 -1.3175498962402344e+02 -8.5436996459960938e+01 9.6846794128417969e+01 -1.3888800048828125e+02 -7.9931602478027344e+01 9.6020698547363281e+01 -1.4022499084472656e+02 -7.8326797485351562e+01 1.4400399780273438e+02 -1.4183599853515625e+02 -7.5678199768066406e+01 9.5038894653320312e+01 -1.4181500244140625e+02 -7.6419502258300781e+01 1.4267100524902344e+02 -1.4343699645996094e+02 -7.2938400268554688e+01 1.4225399780273438e+02 -1.4358900451660156e+02 -7.2082099914550781e+01 9.4716804504394531e+01 -1.4203900146484375e+02 -7.5793800354003906e+01 9.2760200500488281e+01 -1.4340199279785156e+02 -7.1992706298828125e+01 1.4154200744628906e+02 -1.4385000610351562e+02 -7.0619400024414062e+01 1.4017900085449219e+02 -1.4434799194335938e+02 -6.7817398071289062e+01 9.2040206909179688e+01 -1.4390400695800781e+02 -7.0593994140625000e+01 9.1153800964355469e+01 -1.4452200317382812e+02 -6.8871902465820312e+01 1.0657899475097656e+02 -1.4459300231933594e+02 8.5841399431228638e-01 1.0815200042724609e+02 -1.4485000610351562e+02 -2.0000000000000000e+00 6.0473201751708984e+01 -1.4485000610351562e+02 -2.0000000000000000e+00 1.0430400085449219e+02 -1.4341500854492188e+02 4.9942803382873535e+00 1.0507099914550781e+02 -1.4392900085449219e+02 3.6010899543762207e+00 5.9191101074218750e+01 -1.4434599304199219e+02 8.1552904844284058e-01 1.0589399719238281e+02 -1.4448100280761719e+02 2.1042699813842773e+00 5.7915401458740234e+01 -1.4384399414062500e+02 3.6172301769256592e+00 5.7248996734619141e+01 -1.4358200073242188e+02 5.0806798934936523e+00 1.0221800231933594e+02 -1.4201599121093750e+02 8.7872800827026367e+00 1.0178600311279297e+02 -1.4172599792480469e+02 9.5727500915527344e+00 5.6837398529052734e+01 -1.4341999816894531e+02 5.9844398498535156e+00 5.5612697601318359e+01 -1.4183700561523438e+02 8.6740093231201172e+00 1.0081599426269531e+02 -1.4023800659179688e+02 1.1335399627685547e+01 5.4376098632812500e+01 -1.4024000549316406e+02 1.1389599800109863e+01 9.9936500549316406e+01 -1.3888800048828125e+02 1.2934700012207031e+01 9.8440200805664062e+01 -1.3659100341796875e+02 1.5654999732971191e+01 5.3653900146484375e+01 -1.3930599975585938e+02 1.2975799560546875e+01 5.3597698211669922e+01 -1.3915499877929688e+02 1.3099299430847168e+01 9.8108795166015625e+01 -1.3554299926757812e+02 1.6257400512695312e+01 5.2205802917480469e+01 -1.3540998840332031e+02 1.6155998229980469e+01 9.8019401550292969e+01 -1.3526100158691406e+02 1.6419900894165039e+01 5.2114700317382812e+01 -1.3516398620605469e+02 1.6355899810791016e+01 9.6909599304199219e+01 -1.3175100708007812e+02 1.8437400817871094e+01 9.6257698059082031e+01 -1.2969000244140625e+02 1.9622499465942383e+01 5.1318500518798828e+01 -1.3302198791503906e+02 1.8104400634765625e+01 5.1137001037597656e+01 -1.3185800170898438e+02 1.8503099441528320e+01 9.6184898376464844e+01 -1.2893598937988281e+02 1.9754899978637695e+01 5.0666599273681641e+01 -1.2884199523925781e+02 1.9535999298095703e+01 9.6117897033691406e+01 -1.2824299621582031e+02 1.9876699447631836e+01 5.0560600280761719e+01 -1.2816099548339844e+02 1.9768999099731445e+01 9.5788002014160156e+01 -1.2483000183105469e+02 2.0476400375366211e+01 5.0121799468994141e+01 -1.2534799957275391e+02 2.0732500076293945e+01 9.5500000000000000e+01 -1.2184999847412109e+02 2.1000000000000000e+01 5.0106201171875000e+01 -1.2490000152587891e+02 2.0766698837280273e+01 5.0000000000000000e+01 -1.2184999847412109e+02 2.1000000000000000e+01 6.2857501983642578e+01 -1.2184999847412109e+02 2.1000000000000000e+01 6.4303703308105469e+01 -1.2184999847412109e+02 2.1000000000000000e+01 6.8000000000000000e+01 -1.2184999847412109e+02 2.1000000000000000e+01 7.2750000000000000e+01 -1.2184999847412109e+02 2.1000000000000000e+01 7.7500000000000000e+01 -1.2184999847412109e+02 2.1000000000000000e+01 8.3642494201660156e+01 -1.2184999847412109e+02 2.1000000000000000e+01 7.1547698974609375e+01 -1.4485000610351562e+02 -1.0635700225830078e+01 6.8417900085449219e+01 -1.4485000610351562e+02 -1.2208100318908691e+01 6.8817497253417969e+01 -1.4485000610351562e+02 -1.1878999710083008e+01 9.1804397583007812e+01 -1.4485000610351562e+02 -5.5121002197265625e+01 9.1623001098632812e+01 -1.4485000610351562e+02 -5.5605800628662109e+01 8.8776496887207031e+01 -1.4485000610351562e+02 -5.6380199432373047e+01 8.8371498107910156e+01 -1.4485000610351562e+02 -5.6564598083496094e+01 7.1062896728515625e+01 -1.4485000610351562e+02 -1.0454299926757812e+01 6.8998901367187500e+01 -1.4485000610351562e+02 -1.1394200325012207e+01 7.0733802795410156e+01 -1.4485000610351562e+02 -1.0054800033569336e+01 8.9725601196289062e+01 -1.4485000610351562e+02 -6.1414398193359375e+01 9.0054695129394531e+01 -1.4485000610351562e+02 -6.1813899993896484e+01 9.4179901123046875e+01 -1.4485000610351562e+02 -6.0337699890136719e+01 9.4690399169921875e+01 -1.4485000610351562e+02 -6.0252399444580078e+01 9.5090003967285156e+01 -1.4485000610351562e+02 -5.9923297882080078e+01 9.0539497375488281e+01 -1.4485000610351562e+02 -6.1995399475097656e+01 9.1050102233886719e+01 -1.4485000610351562e+02 -6.1910099029541016e+01 9.1449600219726562e+01 -1.4485000610351562e+02 -6.1581001281738281e+01 9.1631004333496094e+01 -1.4485000610351562e+02 -6.1096199035644531e+01 9.3695098876953125e+01 -1.4485000610351562e+02 -6.0156299591064453e+01 6.7422599792480469e+01 -1.4485000610351562e+02 -1.2111900329589844e+01 6.7907402038574219e+01 -1.4485000610351562e+02 -1.2293399810791016e+01 8.8086601257324219e+01 -1.4485000610351562e+02 -5.6906497955322266e+01 8.7978202819824219e+01 -1.4485000610351562e+02 -5.7338199615478516e+01 8.8067893981933594e+01 -1.4485000610351562e+02 -5.7774101257324219e+01 9.3199295043945312e+01 -1.4485000610351562e+02 -5.4888099670410156e+01 9.2714500427246094e+01 -1.4485000610351562e+02 -5.4706600189208984e+01 6.7093399047851562e+01 -1.4485000610351562e+02 -1.1712400436401367e+01 6.5435798645019531e+01 -1.4485000610351562e+02 -8.0720701217651367e+00 9.5271400451660156e+01 -1.4485000610351562e+02 -5.9438499450683594e+01 9.5186096191406250e+01 -1.4485000610351562e+02 -5.8927902221679688e+01 9.3528503417968750e+01 -1.4485000610351562e+02 -5.5287597656250000e+01 9.1708305358886719e+01 -1.4485000610351562e+02 -5.6116397857666016e+01 8.9618202209472656e+01 -1.4485000610351562e+02 -5.6591400146484375e+01 8.9221405029296875e+01 -1.4485000610351562e+02 -5.6389701843261719e+01 9.2203903198242188e+01 -1.4485000610351562e+02 -5.4791900634765625e+01 7.2058296203613281e+01 -1.4485000610351562e+02 -1.0550399780273438e+01 7.2457794189453125e+01 -1.4485000610351562e+02 -1.0221300125122070e+01 7.2639198303222656e+01 -1.4485000610351562e+02 -9.7364997863769531e+00 7.2554000854492188e+01 -1.4485000610351562e+02 -9.2259407043457031e+00 7.0082405090332031e+01 -1.4485000610351562e+02 -5.0046300888061523e+00 6.9571800231933594e+01 -1.4485000610351562e+02 -5.0899095535278320e+00 6.9172302246093750e+01 -1.4485000610351562e+02 -5.4190402030944824e+00 9.3365898132324219e+01 -1.4485000610351562e+02 -5.9756801605224609e+01 9.1545799255371094e+01 -1.4485000610351562e+02 -6.0585597991943359e+01 8.9888099670410156e+01 -1.4485000610351562e+02 -5.6945201873779297e+01 7.0896301269531250e+01 -1.4485000610351562e+02 -5.5855898857116699e+00 7.0567199707031250e+01 -1.4485000610351562e+02 -5.1860599517822266e+00 6.5739295959472656e+01 -1.4485000610351562e+02 -6.8625998497009277e+00 6.5454399108886719e+01 -1.4485000610351562e+02 -7.2045097351074219e+00 6.5346099853515625e+01 -1.4485000610351562e+02 -7.6361598968505859e+00 6.8913604736328125e+01 -1.4485000610351562e+02 -1.0883600234985352e+01 6.8990798950195312e+01 -1.4485000610351562e+02 -5.9038500785827637e+00 6.9076095581054688e+01 -1.4485000610351562e+02 -6.4144101142883301e+00 6.7255897521972656e+01 -1.4485000610351562e+02 -7.2432498931884766e+00 6.6986000061035156e+01 -1.4485000610351562e+02 -6.8894100189208984e+00 6.6589302062988281e+01 -1.4485000610351562e+02 -6.6877398490905762e+00 6.6144302368164062e+01 -1.4485000610351562e+02 -6.6781797409057617e+00 1.3880799865722656e+02 -1.4785000610351562e+02 -6.5000000000000000e+01 8.9160705566406250e+01 -1.4785000610351562e+02 -6.5000000000000000e+01 9.0626701354980469e+01 -1.4746600341796875e+02 -6.8219497680664062e+01 9.1942695617675781e+01 -1.4712199401855469e+02 -7.1109504699707031e+01 9.2067703247070312e+01 -1.4700500488281250e+02 -7.1383995056152344e+01 1.4018099975585938e+02 -1.4731100463867188e+02 -6.8189300537109375e+01 9.2773994445800781e+01 -1.4634199523925781e+02 -7.2934997558593750e+01 1.4154598999023438e+02 -1.4677500915527344e+02 -7.1360702514648438e+01 1.4225999450683594e+02 -1.4649400329589844e+02 -7.3019699096679688e+01 9.4691902160644531e+01 -1.4454199218750000e+02 -7.7146903991699219e+01 9.5555496215820312e+01 -1.4373100280761719e+02 -7.9043502807617188e+01 1.4248699951171875e+02 -1.4640499877929688e+02 -7.3546600341796875e+01 9.6056793212890625e+01 -1.4273100280761719e+02 -8.0144401550292969e+01 9.6847801208496094e+01 -1.4115400695800781e+02 -8.1881393432617188e+01 1.4535299682617188e+02 -1.4274600219726562e+02 -8.0205596923828125e+01 1.4400898742675781e+02 -1.4446200561523438e+02 -7.7082794189453125e+01 9.8680198669433594e+01 -1.3706199645996094e+02 -8.5905593872070312e+01 1.4779199218750000e+02 -1.3698500061035156e+02 -8.5870399475097656e+01 1.4768501281738281e+02 -1.3726000976562500e+02 -8.5622604370117188e+01 9.8464103698730469e+01 -1.3793000793457031e+02 -8.5430999755859375e+01 9.8596496582031250e+01 -1.3739801025390625e+02 -8.5721702575683594e+01 1.4575700378417969e+02 -1.4223100280761719e+02 -8.1143295288085938e+01 1.4611500549316406e+02 -1.4130899047851562e+02 -8.1974197387695312e+01 9.9675994873046875e+01 -1.3305999755859375e+02 -8.8092399597167969e+01 1.0034799957275391e+02 -1.3035899353027344e+02 -8.9568298339843750e+01 1.4825500488281250e+02 -1.3579200744628906e+02 -8.6945800781250000e+01 1.0038500213623047e+02 -1.2987100219726562e+02 -8.9650306701660156e+01 1.5000000000000000e+02 -1.2184999847412109e+02 -9.1000000000000000e+01 1.4982899475097656e+02 -1.2527799987792969e+02 -9.0602195739746094e+01 1.0100000000000000e+02 -1.2184999847412109e+02 -9.1000000000000000e+01 1.4970300292968750e+02 -1.2780300140380859e+02 -9.0309204101562500e+01 1.0074099731445312e+02 -1.2523199462890625e+02 -9.0430900573730469e+01 1.4947799682617188e+02 -1.2904399108886719e+02 -8.9787002563476562e+01 1.0044499969482422e+02 -1.2909400939941406e+02 -8.9781204223632812e+01 1.4934500122070312e+02 -1.2977899169921875e+02 -8.9477302551269531e+01 1.4874299621582031e+02 -1.3309800720214844e+02 -8.8079994201660156e+01 5.0155700683593750e+01 -1.2528100585937500e+02 2.3613401412963867e+01 9.5500000000000000e+01 -1.2184999847412109e+02 2.4000000000000000e+01 8.4867996215820312e+01 -1.2184999847412109e+02 2.4000000000000000e+01 7.7500000000000000e+01 -1.2184999847412109e+02 2.4000000000000000e+01 7.2750000000000000e+01 -1.2184999847412109e+02 2.4000000000000000e+01 6.8000000000000000e+01 -1.2184999847412109e+02 2.4000000000000000e+01 6.3690998077392578e+01 -1.2184999847412109e+02 2.4000000000000000e+01 6.1631999969482422e+01 -1.2184999847412109e+02 2.4000000000000000e+01 5.0000000000000000e+01 -1.2184999847412109e+02 2.4000000000000000e+01 5.0262599945068359e+01 -1.2763600158691406e+02 2.3347999572753906e+01 5.0496498107910156e+01 -1.2903698730468750e+02 2.2767499923706055e+01 9.5775199890136719e+01 -1.2523199462890625e+02 2.3434400558471680e+01 5.0619503021240234e+01 -1.2977500915527344e+02 2.2462099075317383e+01 9.6089500427246094e+01 -1.2909500122070312e+02 2.2788499832153320e+01 9.6152900695800781e+01 -1.2987298583984375e+02 2.2658300399780273e+01 5.2070899963378906e+01 -1.3697599792480469e+02 1.8859001159667969e+01 9.6188400268554688e+01 -1.3030900573730469e+02 2.2585300445556641e+01 5.1605400085449219e+01 -1.3568299865722656e+02 2.0014600753784180e+01 5.1175098419189453e+01 -1.3310499572753906e+02 2.1082799911499023e+01 5.4350498199462891e+01 -1.4273600769042969e+02 1.3199700355529785e+01 1.0077700042724609e+02 -1.4274600219726562e+02 1.3156399726867676e+01 9.9934303283691406e+01 -1.4115800476074219e+02 1.4887399673461914e+01 5.2170799255371094e+01 -1.3725399780273438e+02 1.8611000061035156e+01 9.7972900390625000e+01 -1.3706900024414062e+02 1.8918100357055664e+01 9.6913894653320312e+01 -1.3305799865722656e+02 2.1094299316406250e+01 9.8178604125976562e+01 -1.3784800720214844e+02 1.8495300292968750e+01 9.8062004089355469e+01 -1.3740600585937500e+02 1.8735000610351562e+01 5.3943397521972656e+01 -1.4217799377441406e+02 1.4210499763488770e+01 5.3633800506591797e+01 -1.4131799316406250e+02 1.4979100227355957e+01 5.5607799530029297e+01 -1.4446099853515625e+02 1.0078499794006348e+01 5.7014202117919922e+01 -1.4639100646972656e+02 6.5871300697326660e+00 1.0125399780273438e+02 -1.4364599609375000e+02 1.2175000190734863e+01 5.7243198394775391e+01 -1.4648799133300781e+02 6.0185599327087402e+00 1.0224299621582031e+02 -1.4453099060058594e+02 1.0143699645996094e+01 1.0428699493408203e+02 -1.4636199951171875e+02 5.9419302940368652e+00 5.7911701202392578e+01 -1.4677000427246094e+02 4.3590102195739746e+00 5.9189098358154297e+01 -1.4730801391601562e+02 1.1877499818801880e+00 1.0815200042724609e+02 -1.4785000610351562e+02 -2.0000000000000000e+00 1.0658599853515625e+02 -1.4745298767089844e+02 1.2179999351501465e+00 6.0473201751708984e+01 -1.4785000610351562e+02 -2.0000000000000000e+00 1.0508000183105469e+02 -1.4707200622558594e+02 4.3121500015258789e+00 1.0504000091552734e+02 -1.4703599548339844e+02 4.3950700759887695e+00 7.1062896728515625e+01 -1.4785000610351562e+02 -1.0454299926757812e+01 6.6986000061035156e+01 -1.4785000610351562e+02 -6.8894100189208984e+00 6.7255897521972656e+01 -1.4785000610351562e+02 -7.2432498931884766e+00 9.4690399169921875e+01 -1.4785000610351562e+02 -6.0252399444580078e+01 9.4179901123046875e+01 -1.4785000610351562e+02 -6.0337699890136719e+01 9.1631004333496094e+01 -1.4785000610351562e+02 -6.1096199035644531e+01 9.3695098876953125e+01 -1.4785000610351562e+02 -6.0156299591064453e+01 9.3365898132324219e+01 -1.4785000610351562e+02 -5.9756801605224609e+01 7.2058296203613281e+01 -1.4785000610351562e+02 -1.0550399780273438e+01 7.1547698974609375e+01 -1.4785000610351562e+02 -1.0635700225830078e+01 6.8998901367187500e+01 -1.4785000610351562e+02 -1.1394200325012207e+01 6.8913604736328125e+01 -1.4785000610351562e+02 -1.0883600234985352e+01 9.5186096191406250e+01 -1.4785000610351562e+02 -5.8927902221679688e+01 9.5271400451660156e+01 -1.4785000610351562e+02 -5.9438499450683594e+01 9.5090003967285156e+01 -1.4785000610351562e+02 -5.9923297882080078e+01 7.0896301269531250e+01 -1.4785000610351562e+02 -5.5855898857116699e+00 7.2554000854492188e+01 -1.4785000610351562e+02 -9.2259407043457031e+00 7.2639198303222656e+01 -1.4785000610351562e+02 -9.7364997863769531e+00 7.2457794189453125e+01 -1.4785000610351562e+02 -1.0221300125122070e+01 9.1449600219726562e+01 -1.4785000610351562e+02 -6.1581001281738281e+01 9.1050102233886719e+01 -1.4785000610351562e+02 -6.1910099029541016e+01 9.0539497375488281e+01 -1.4785000610351562e+02 -6.1995399475097656e+01 6.8990798950195312e+01 -1.4785000610351562e+02 -5.9038500785827637e+00 6.9172302246093750e+01 -1.4785000610351562e+02 -5.4190402030944824e+00 6.9571800231933594e+01 -1.4785000610351562e+02 -5.0899095535278320e+00 7.0082405090332031e+01 -1.4785000610351562e+02 -5.0046300888061523e+00 7.0567199707031250e+01 -1.4785000610351562e+02 -5.1860599517822266e+00 6.8817497253417969e+01 -1.4785000610351562e+02 -1.1878999710083008e+01 6.5346099853515625e+01 -1.4785000610351562e+02 -7.6361598968505859e+00 6.5454399108886719e+01 -1.4785000610351562e+02 -7.2045097351074219e+00 9.1623001098632812e+01 -1.4785000610351562e+02 -5.5605800628662109e+01 8.9618202209472656e+01 -1.4785000610351562e+02 -5.6591400146484375e+01 9.1708305358886719e+01 -1.4785000610351562e+02 -5.6116397857666016e+01 8.9888099670410156e+01 -1.4785000610351562e+02 -5.6945201873779297e+01 9.1545799255371094e+01 -1.4785000610351562e+02 -6.0585597991943359e+01 9.2203903198242188e+01 -1.4785000610351562e+02 -5.4791900634765625e+01 9.2714500427246094e+01 -1.4785000610351562e+02 -5.4706600189208984e+01 9.3199295043945312e+01 -1.4785000610351562e+02 -5.4888099670410156e+01 9.3528503417968750e+01 -1.4785000610351562e+02 -5.5287597656250000e+01 6.5435798645019531e+01 -1.4785000610351562e+02 -8.0720701217651367e+00 8.7978202819824219e+01 -1.4785000610351562e+02 -5.7338199615478516e+01 8.8086601257324219e+01 -1.4785000610351562e+02 -5.6906497955322266e+01 6.7422599792480469e+01 -1.4785000610351562e+02 -1.2111900329589844e+01 8.8371498107910156e+01 -1.4785000610351562e+02 -5.6564598083496094e+01 8.8776496887207031e+01 -1.4785000610351562e+02 -5.6380199432373047e+01 6.7907402038574219e+01 -1.4785000610351562e+02 -1.2293399810791016e+01 9.1804397583007812e+01 -1.4785000610351562e+02 -5.5121002197265625e+01 8.9221405029296875e+01 -1.4785000610351562e+02 -5.6389701843261719e+01 7.0733802795410156e+01 -1.4785000610351562e+02 -1.0054800033569336e+01 6.9076095581054688e+01 -1.4785000610351562e+02 -6.4144101142883301e+00 6.6589302062988281e+01 -1.4785000610351562e+02 -6.6877398490905762e+00 6.6144302368164062e+01 -1.4785000610351562e+02 -6.6781797409057617e+00 6.5739295959472656e+01 -1.4785000610351562e+02 -6.8625998497009277e+00 9.0054695129394531e+01 -1.4785000610351562e+02 -6.1813899993896484e+01 8.9725601196289062e+01 -1.4785000610351562e+02 -6.1414398193359375e+01 8.8067893981933594e+01 -1.4785000610351562e+02 -5.7774101257324219e+01 6.8417900085449219e+01 -1.4785000610351562e+02 -1.2208100318908691e+01 6.7093399047851562e+01 -1.4785000610351562e+02 -1.1712400436401367e+01 1.1100000000000000e+02 -7.8849998474121094e+01 -8.8000000000000000e+01 1.4000000000000000e+02 -7.8849998474121094e+01 -8.8000000000000000e+01 1.1100000000000000e+02 -7.8849998474121094e+01 -9.1000000000000000e+01 1.4000000000000000e+02 -7.8849998474121094e+01 -9.1000000000000000e+01 1.3514199829101562e+02 -8.5849998474121094e+01 -8.8000000000000000e+01 1.3635000610351562e+02 -8.4642097473144531e+01 -8.8000000000000000e+01 1.1300000000000000e+02 -1.1580000305175781e+02 -8.8000000000000000e+01 1.1465000152587891e+02 -1.1535800170898438e+02 -8.8000000000000000e+01 1.3800000000000000e+02 -9.0800003051757812e+01 -8.8000000000000000e+01 1.3469999694824219e+02 -1.1250000000000000e+02 -8.8000000000000000e+01 1.3514199829101562e+02 -1.1084999847412109e+02 -8.8000000000000000e+01 1.1134999847412109e+02 -1.1535800170898438e+02 -8.8000000000000000e+01 1.1014199829101562e+02 -1.1415000152587891e+02 -8.8000000000000000e+01 1.0970000457763672e+02 -1.1250000000000000e+02 -8.8000000000000000e+01 1.1134999847412109e+02 -9.0357902526855469e+01 -8.8000000000000000e+01 1.1014199829101562e+02 -8.9149993896484375e+01 -8.8000000000000000e+01 1.0100000000000000e+02 -8.8849998474121094e+01 -8.8000000000000000e+01 1.0970000457763672e+02 -8.7500000000000000e+01 -8.8000000000000000e+01 1.0233999633789062e+02 -8.3849998474121094e+01 -8.8000000000000000e+01 1.1014199829101562e+02 -8.5849998474121094e+01 -8.8000000000000000e+01 1.0600000000000000e+02 -8.0189804077148438e+01 -8.8000000000000000e+01 1.1134999847412109e+02 -8.4642097473144531e+01 -8.8000000000000000e+01 1.3800000000000000e+02 -8.4200004577636719e+01 -8.8000000000000000e+01 1.4500000000000000e+02 -8.0189804077148438e+01 -8.8000000000000000e+01 1.3965000915527344e+02 -8.4642097473144531e+01 -8.8000000000000000e+01 1.4866000366210938e+02 -8.3849998474121094e+01 -8.8000000000000000e+01 1.4085800170898438e+02 -8.5849998474121094e+01 -8.8000000000000000e+01 1.5000000000000000e+02 -8.8849998474121094e+01 -8.8000000000000000e+01 1.4129998779296875e+02 -8.7500000000000000e+01 -8.8000000000000000e+01 1.4085800170898438e+02 -8.9149993896484375e+01 -8.8000000000000000e+01 1.1134999847412109e+02 -1.0964199829101562e+02 -8.8000000000000000e+01 1.1300000000000000e+02 -1.0919999694824219e+02 -8.8000000000000000e+01 1.3514199829101562e+02 -8.9149993896484375e+01 -8.8000000000000000e+01 1.1465000152587891e+02 -1.0964199829101562e+02 -8.8000000000000000e+01 1.3635000610351562e+02 -9.0357902526855469e+01 -8.8000000000000000e+01 1.1585800170898438e+02 -1.1084999847412109e+02 -8.8000000000000000e+01 1.1300000000000000e+02 -9.0800003051757812e+01 -8.8000000000000000e+01 1.1014199829101562e+02 -1.1084999847412109e+02 -8.8000000000000000e+01 1.1465000152587891e+02 -9.0357902526855469e+01 -8.8000000000000000e+01 1.1585800170898438e+02 -8.9149993896484375e+01 -8.8000000000000000e+01 1.1630000305175781e+02 -8.7500000000000000e+01 -8.8000000000000000e+01 1.3469999694824219e+02 -8.7500000000000000e+01 -8.8000000000000000e+01 1.1585800170898438e+02 -8.5849998474121094e+01 -8.8000000000000000e+01 1.1465000152587891e+02 -8.4642097473144531e+01 -8.8000000000000000e+01 1.1300000000000000e+02 -8.4200004577636719e+01 -8.8000000000000000e+01 1.1630000305175781e+02 -1.1250000000000000e+02 -8.8000000000000000e+01 1.3514199829101562e+02 -1.1415000152587891e+02 -8.8000000000000000e+01 1.1585800170898438e+02 -1.1415000152587891e+02 -8.8000000000000000e+01 1.3635000610351562e+02 -1.0964199829101562e+02 -8.8000000000000000e+01 1.3800000000000000e+02 -1.0919999694824219e+02 -8.8000000000000000e+01 1.3965000915527344e+02 -9.0357902526855469e+01 -8.8000000000000000e+01 1.3965000915527344e+02 -1.0964199829101562e+02 -8.8000000000000000e+01 1.4085800170898438e+02 -1.1415000152587891e+02 -8.8000000000000000e+01 1.3965000915527344e+02 -1.1535800170898438e+02 -8.8000000000000000e+01 1.3800000000000000e+02 -1.1580000305175781e+02 -8.8000000000000000e+01 1.3635000610351562e+02 -1.1535800170898438e+02 -8.8000000000000000e+01 1.4085800170898438e+02 -1.1084999847412109e+02 -8.8000000000000000e+01 1.4129998779296875e+02 -1.1250000000000000e+02 -8.8000000000000000e+01 1.1300000000000000e+02 -9.0800003051757812e+01 -9.1000000000000000e+01 1.1300000000000000e+02 -1.0919999694824219e+02 -9.1000000000000000e+01 1.1134999847412109e+02 -9.0357902526855469e+01 -9.1000000000000000e+01 1.1014199829101562e+02 -8.9149993896484375e+01 -9.1000000000000000e+01 1.3800000000000000e+02 -9.0800003051757812e+01 -9.1000000000000000e+01 1.3965000915527344e+02 -1.0964199829101562e+02 -9.1000000000000000e+01 1.3635000610351562e+02 -9.0357902526855469e+01 -9.1000000000000000e+01 1.3800000000000000e+02 -1.0919999694824219e+02 -9.1000000000000000e+01 1.3514199829101562e+02 -8.9149993896484375e+01 -9.1000000000000000e+01 1.1014199829101562e+02 -1.1415000152587891e+02 -9.1000000000000000e+01 1.1134999847412109e+02 -1.1535800170898438e+02 -9.1000000000000000e+01 1.1300000000000000e+02 -1.1580000305175781e+02 -9.1000000000000000e+01 1.3514199829101562e+02 -8.5849998474121094e+01 -9.1000000000000000e+01 1.3469999694824219e+02 -8.7500000000000000e+01 -9.1000000000000000e+01 1.1630000305175781e+02 -8.7500000000000000e+01 -9.1000000000000000e+01 1.3514199829101562e+02 -1.1415000152587891e+02 -9.1000000000000000e+01 1.3635000610351562e+02 -1.1535800170898438e+02 -9.1000000000000000e+01 1.3800000000000000e+02 -1.1580000305175781e+02 -9.1000000000000000e+01 1.3514199829101562e+02 -1.1084999847412109e+02 -9.1000000000000000e+01 1.1465000152587891e+02 -9.0357902526855469e+01 -9.1000000000000000e+01 1.1585800170898438e+02 -8.5849998474121094e+01 -9.1000000000000000e+01 1.1465000152587891e+02 -8.4642097473144531e+01 -9.1000000000000000e+01 1.1300000000000000e+02 -8.4200004577636719e+01 -9.1000000000000000e+01 1.3635000610351562e+02 -1.0964199829101562e+02 -9.1000000000000000e+01 1.0970000457763672e+02 -8.7500000000000000e+01 -9.1000000000000000e+01 1.0100000000000000e+02 -8.8849998474121094e+01 -9.1000000000000000e+01 1.1014199829101562e+02 -8.5849998474121094e+01 -9.1000000000000000e+01 1.0233999633789062e+02 -8.3849998474121094e+01 -9.1000000000000000e+01 1.1134999847412109e+02 -8.4642097473144531e+01 -9.1000000000000000e+01 1.0600000000000000e+02 -8.0189804077148438e+01 -9.1000000000000000e+01 1.1134999847412109e+02 -1.0964199829101562e+02 -9.1000000000000000e+01 1.1014199829101562e+02 -1.1084999847412109e+02 -9.1000000000000000e+01 1.0970000457763672e+02 -1.1250000000000000e+02 -9.1000000000000000e+01 1.3965000915527344e+02 -1.1535800170898438e+02 -9.1000000000000000e+01 1.4085800170898438e+02 -1.1415000152587891e+02 -9.1000000000000000e+01 1.4129998779296875e+02 -1.1250000000000000e+02 -9.1000000000000000e+01 1.1585800170898438e+02 -8.9149993896484375e+01 -9.1000000000000000e+01 1.1465000152587891e+02 -1.1535800170898438e+02 -9.1000000000000000e+01 1.1585800170898438e+02 -1.1415000152587891e+02 -9.1000000000000000e+01 1.3469999694824219e+02 -1.1250000000000000e+02 -9.1000000000000000e+01 1.1630000305175781e+02 -1.1250000000000000e+02 -9.1000000000000000e+01 1.1585800170898438e+02 -1.1084999847412109e+02 -9.1000000000000000e+01 1.1465000152587891e+02 -1.0964199829101562e+02 -9.1000000000000000e+01 1.5000000000000000e+02 -8.8849998474121094e+01 -9.1000000000000000e+01 1.3965000915527344e+02 -9.0357902526855469e+01 -9.1000000000000000e+01 1.4085800170898438e+02 -1.1084999847412109e+02 -9.1000000000000000e+01 1.4085800170898438e+02 -8.9149993896484375e+01 -9.1000000000000000e+01 1.4129998779296875e+02 -8.7500000000000000e+01 -9.1000000000000000e+01 1.4866000366210938e+02 -8.3849998474121094e+01 -9.1000000000000000e+01 1.4085800170898438e+02 -8.5849998474121094e+01 -9.1000000000000000e+01 1.4500000000000000e+02 -8.0189804077148438e+01 -9.1000000000000000e+01 1.3965000915527344e+02 -8.4642097473144531e+01 -9.1000000000000000e+01 1.3800000000000000e+02 -8.4200004577636719e+01 -9.1000000000000000e+01 1.3635000610351562e+02 -8.4642097473144531e+01 -9.1000000000000000e+01 9.2806900024414062e+01 1.4359599304199219e+02 -7.2083396911621094e+01 1.4221000671386719e+02 1.4339399719238281e+02 -7.1992004394531250e+01 1.4152799987792969e+02 1.4388600158691406e+02 -7.0588905334472656e+01 1.4060499572753906e+02 1.4455200195312500e+02 -6.8691902160644531e+01 1.4019999694824219e+02 1.4461900329589844e+02 -6.7860404968261719e+01 9.2054298400878906e+01 1.4385501098632812e+02 -7.0621299743652344e+01 1.3880799865722656e+02 1.4485000610351562e+02 -6.5000000000000000e+01 9.0611801147460938e+01 1.4435101318359375e+02 -6.7819000244140625e+01 8.9160705566406250e+01 1.4485000610351562e+02 -6.5000000000000000e+01 9.6059394836425781e+01 1.4025799560546875e+02 -7.8402099609375000e+01 1.4406298828125000e+02 1.4205799865722656e+02 -7.5799194335937500e+01 9.4659400939941406e+01 1.4183599853515625e+02 -7.5682197570800781e+01 9.3225006103515625e+01 1.4345201110839844e+02 -7.2895500183105469e+01 9.6795204162597656e+01 1.3942900085449219e+02 -7.9831504821777344e+01 1.4529000854492188e+02 1.4021598815917969e+02 -7.8320693969726562e+01 1.4430700683593750e+02 1.4188200378417969e+02 -7.6300399780273438e+01 9.8619499206542969e+01 1.3517700195312500e+02 -8.3375495910644531e+01 1.4776100158691406e+02 1.3524700927734375e+02 -8.3398796081542969e+01 1.4768099975585938e+02 1.3552999877929688e+02 -8.3233497619628906e+01 9.6922706604003906e+01 1.3913198852539062e+02 -8.0078994750976562e+01 9.8517295837402344e+01 1.3541500854492188e+02 -8.3176902770996094e+01 1.4607299804687500e+02 1.3888800048828125e+02 -7.9929595947265625e+01 1.4733299255371094e+02 1.3675099182128906e+02 -8.2520202636718750e+01 9.9437599182128906e+01 1.3326998901367188e+02 -8.4964797973632812e+01 9.9701599121093750e+01 1.3184001159667969e+02 -8.5477699279785156e+01 1.4875300598144531e+02 1.3175700378417969e+02 -8.5436798095703125e+01 1.0025499725341797e+02 1.2884199523925781e+02 -8.6552703857421875e+01 1.4931201171875000e+02 1.2978799438476562e+02 -8.6586601257324219e+01 1.4938600158691406e+02 1.2893299865722656e+02 -8.6738899230957031e+01 1.0038100433349609e+02 1.2816200256347656e+02 -8.6796798706054688e+01 1.0083100128173828e+02 1.2572200775146484e+02 -8.7671699523925781e+01 1.4944599914550781e+02 1.2824200439453125e+02 -8.6861900329589844e+01 1.0086700439453125e+02 1.2489700317382812e+02 -8.7741699218750000e+01 1.4974200439453125e+02 1.2483100128173828e+02 -8.7469200134277344e+01 1.0100000000000000e+02 1.2184999847412109e+02 -8.8000000000000000e+01 1.5000000000000000e+02 1.2184999847412109e+02 -8.8000000000000000e+01 8.3642494201660156e+01 1.2184999847412109e+02 2.1000000000000000e+01 5.0243198394775391e+01 1.2483199310302734e+02 2.0465898513793945e+01 5.0521400451660156e+01 1.2824099731445312e+02 1.9854999542236328e+01 7.7500000000000000e+01 1.2184999847412109e+02 2.1000000000000000e+01 7.2750000000000000e+01 1.2184999847412109e+02 2.1000000000000000e+01 6.8000000000000000e+01 1.2184999847412109e+02 2.1000000000000000e+01 6.4303703308105469e+01 1.2184999847412109e+02 2.1000000000000000e+01 6.2857501983642578e+01 1.2184999847412109e+02 2.1000000000000000e+01 5.0000000000000000e+01 1.2184999847412109e+02 2.1000000000000000e+01 9.5500000000000000e+01 1.2184999847412109e+02 2.1000000000000000e+01 9.5650703430175781e+01 1.2489499664306641e+02 2.0726099014282227e+01 9.5703102111816406e+01 1.2595400238037109e+02 2.0630798339843750e+01 5.0577701568603516e+01 1.2893200683593750e+02 1.9731300354003906e+01 9.6151199340820312e+01 1.2816299438476562e+02 1.9816200256347656e+01 9.6289199829101562e+01 1.2884399414062500e+02 1.9565200805664062e+01 5.2099498748779297e+01 1.3524000549316406e+02 1.6389200210571289e+01 9.6894699096679688e+01 1.3182798767089844e+02 1.8464601516723633e+01 5.1167201995849609e+01 1.3175999450683594e+02 1.8436800003051758e+01 5.0651302337646484e+01 1.2983399963378906e+02 1.9569599151611328e+01 5.4410301208496094e+01 1.4020599365234375e+02 1.1314599990844727e+01 1.0077500152587891e+02 1.4026998901367188e+02 1.1409899711608887e+01 1.0004299926757812e+02 1.3950500488281250e+02 1.2741100311279297e+01 5.2175498962402344e+01 1.3552400207519531e+02 1.6222400665283203e+01 9.8036697387695312e+01 1.3518499755859375e+02 1.6388399124145508e+01 9.7218200683593750e+01 1.3342300415039062e+02 1.7876399993896484e+01 9.9863204956054688e+01 1.3911799621582031e+02 1.3067999839782715e+01 9.8145599365234375e+01 1.3541999816894531e+02 1.6190500259399414e+01 5.3675800323486328e+01 1.3888899230957031e+02 1.2927700042724609e+01 5.2524299621582031e+01 1.3682598876953125e+02 1.5456399917602539e+01 5.7289398193359375e+01 1.4338600158691406e+02 4.9918298721313477e+00 1.0227300262451172e+02 1.4183599853515625e+02 8.6873598098754883e+00 5.5552898406982422e+01 1.4207998657226562e+02 8.8053398132324219e+00 5.5385997772216797e+01 1.4195401000976562e+02 9.1719493865966797e+00 5.7930599212646484e+01 1.4386799621582031e+02 3.5837700366973877e+00 1.0425399780273438e+02 1.4360499572753906e+02 5.0851402282714844e+00 1.0383900451660156e+02 1.4347299194335938e+02 5.8401198387145996e+00 5.8880401611328125e+01 1.4458200073242188e+02 1.4979300498962402e+00 5.9170299530029297e+01 1.4463099670410156e+02 8.6128199100494385e-01 1.0505799865722656e+02 1.4386199951171875e+02 3.6237299442291260e+00 6.0473201751708984e+01 1.4485000610351562e+02 -2.0000000000000000e+00 1.0659999847412109e+02 1.4435400390625000e+02 8.2109797000885010e-01 1.0815200042724609e+02 1.4485000610351562e+02 -2.0000000000000000e+00 7.1062896728515625e+01 1.4485000610351562e+02 -1.0454299926757812e+01 6.6986000061035156e+01 1.4485000610351562e+02 -6.8894100189208984e+00 6.7255897521972656e+01 1.4485000610351562e+02 -7.2432498931884766e+00 7.2058296203613281e+01 1.4485000610351562e+02 -1.0550399780273438e+01 7.1547698974609375e+01 1.4485000610351562e+02 -1.0635700225830078e+01 6.8998901367187500e+01 1.4485000610351562e+02 -1.1394200325012207e+01 6.8913604736328125e+01 1.4485000610351562e+02 -1.0883600234985352e+01 9.5186096191406250e+01 1.4485000610351562e+02 -5.8927902221679688e+01 9.5271400451660156e+01 1.4485000610351562e+02 -5.9438499450683594e+01 9.5090003967285156e+01 1.4485000610351562e+02 -5.9923297882080078e+01 9.4690399169921875e+01 1.4485000610351562e+02 -6.0252399444580078e+01 6.8990798950195312e+01 1.4485000610351562e+02 -5.9038500785827637e+00 6.9172302246093750e+01 1.4485000610351562e+02 -5.4190402030944824e+00 7.0896301269531250e+01 1.4485000610351562e+02 -5.5855898857116699e+00 7.2554000854492188e+01 1.4485000610351562e+02 -9.2259407043457031e+00 7.2639198303222656e+01 1.4485000610351562e+02 -9.7364997863769531e+00 7.2457794189453125e+01 1.4485000610351562e+02 -1.0221300125122070e+01 9.4179901123046875e+01 1.4485000610351562e+02 -6.0337699890136719e+01 9.1631004333496094e+01 1.4485000610351562e+02 -6.1096199035644531e+01 9.3695098876953125e+01 1.4485000610351562e+02 -6.0156299591064453e+01 9.3365898132324219e+01 1.4485000610351562e+02 -5.9756801605224609e+01 9.1449600219726562e+01 1.4485000610351562e+02 -6.1581001281738281e+01 9.1050102233886719e+01 1.4485000610351562e+02 -6.1910099029541016e+01 9.0539497375488281e+01 1.4485000610351562e+02 -6.1995399475097656e+01 6.8817497253417969e+01 1.4485000610351562e+02 -1.1878999710083008e+01 6.5435798645019531e+01 1.4485000610351562e+02 -8.0720701217651367e+00 6.5346099853515625e+01 1.4485000610351562e+02 -7.6361598968505859e+00 6.5454399108886719e+01 1.4485000610351562e+02 -7.2045097351074219e+00 6.9571800231933594e+01 1.4485000610351562e+02 -5.0899095535278320e+00 7.0082405090332031e+01 1.4485000610351562e+02 -5.0046300888061523e+00 7.0567199707031250e+01 1.4485000610351562e+02 -5.1860599517822266e+00 9.2203903198242188e+01 1.4485000610351562e+02 -5.4791900634765625e+01 9.2714500427246094e+01 1.4485000610351562e+02 -5.4706600189208984e+01 9.3199295043945312e+01 1.4485000610351562e+02 -5.4888099670410156e+01 9.3528503417968750e+01 1.4485000610351562e+02 -5.5287597656250000e+01 9.1623001098632812e+01 1.4485000610351562e+02 -5.5605800628662109e+01 8.9618202209472656e+01 1.4485000610351562e+02 -5.6591400146484375e+01 9.1708305358886719e+01 1.4485000610351562e+02 -5.6116397857666016e+01 8.9888099670410156e+01 1.4485000610351562e+02 -5.6945201873779297e+01 9.1545799255371094e+01 1.4485000610351562e+02 -6.0585597991943359e+01 8.7978202819824219e+01 1.4485000610351562e+02 -5.7338199615478516e+01 8.8086601257324219e+01 1.4485000610351562e+02 -5.6906497955322266e+01 6.7422599792480469e+01 1.4485000610351562e+02 -1.2111900329589844e+01 8.8371498107910156e+01 1.4485000610351562e+02 -5.6564598083496094e+01 8.8776496887207031e+01 1.4485000610351562e+02 -5.6380199432373047e+01 6.7907402038574219e+01 1.4485000610351562e+02 -1.2293399810791016e+01 9.1804397583007812e+01 1.4485000610351562e+02 -5.5121002197265625e+01 8.9221405029296875e+01 1.4485000610351562e+02 -5.6389701843261719e+01 7.0733802795410156e+01 1.4485000610351562e+02 -1.0054800033569336e+01 6.9076095581054688e+01 1.4485000610351562e+02 -6.4144101142883301e+00 6.6589302062988281e+01 1.4485000610351562e+02 -6.6877398490905762e+00 6.6144302368164062e+01 1.4485000610351562e+02 -6.6781797409057617e+00 6.5739295959472656e+01 1.4485000610351562e+02 -6.8625998497009277e+00 9.0054695129394531e+01 1.4485000610351562e+02 -6.1813899993896484e+01 8.9725601196289062e+01 1.4485000610351562e+02 -6.1414398193359375e+01 8.8067893981933594e+01 1.4485000610351562e+02 -5.7774101257324219e+01 6.8417900085449219e+01 1.4485000610351562e+02 -1.2208100318908691e+01 6.7093399047851562e+01 1.4485000610351562e+02 -1.1712400436401367e+01 1.0081400299072266e+02 1.2527600097656250e+02 -9.0591804504394531e+01 1.0066799926757812e+02 1.2795999908447266e+02 -9.0272003173828125e+01 1.4941600036621094e+02 1.2986999511718750e+02 -8.9644096374511719e+01 1.5000000000000000e+02 1.2184999847412109e+02 -9.1000000000000000e+01 1.0100000000000000e+02 1.2184999847412109e+02 -9.1000000000000000e+01 1.4975399780273438e+02 1.2523299407958984e+02 -9.0428100585937500e+01 1.4947299194335938e+02 1.2909300231933594e+02 -8.9775505065917969e+01 1.0031300354003906e+02 1.2978399658203125e+02 -8.9492202758789062e+01 9.9669601440429688e+01 1.3309199523925781e+02 -8.8078300476074219e+01 1.4874800109863281e+02 1.3306100463867188e+02 -8.8091094970703125e+01 1.4780299377441406e+02 1.3705599975585938e+02 -8.5896095275878906e+01 1.0045600128173828e+02 1.2905000305175781e+02 -8.9805793762207031e+01 1.4937800598144531e+02 1.3039700317382812e+02 -8.9555198669433594e+01 1.4532299804687500e+02 1.4272000122070312e+02 -8.0135505676269531e+01 9.8556304931640625e+01 1.3726699829101562e+02 -8.5633399963378906e+01 9.6888198852539062e+01 1.4130101013183594e+02 -8.1970100402832031e+01 9.9124404907226562e+01 1.3589399719238281e+02 -8.6880996704101562e+01 9.8669204711914062e+01 1.3699400329589844e+02 -8.5881393432617188e+01 1.4772300720214844e+02 1.3739199829101562e+02 -8.5711395263671875e+01 1.4758099365234375e+02 1.3799299621582031e+02 -8.5381202697753906e+01 1.4607299804687500e+02 1.4115100097656250e+02 -8.1876998901367188e+01 9.6087203979492188e+01 1.4275599670410156e+02 -8.0211196899414062e+01 9.4664497375488281e+01 1.4446299743652344e+02 -7.7086799621582031e+01 1.4403800964355469e+02 1.4455000305175781e+02 -7.7149803161621094e+01 1.4222200012207031e+02 1.4632701110839844e+02 -7.2930099487304688e+01 9.6483001708984375e+01 1.4228099060058594e+02 -8.1080299377441406e+01 1.4481001281738281e+02 1.4379598999023438e+02 -7.8942100524902344e+01 8.9160705566406250e+01 1.4785000610351562e+02 -6.5000000000000000e+01 1.3880799865722656e+02 1.4785000610351562e+02 -6.5000000000000000e+01 9.0613601684570312e+01 1.4731300354003906e+02 -6.8190704345703125e+01 9.2057800292968750e+01 1.4677900695800781e+02 -7.1362304687500000e+01 9.3035202026367188e+01 1.4641799926757812e+02 -7.3508705139160156e+01 9.2813095092773438e+01 1.4650000000000000e+02 -7.3020797729492188e+01 1.4155200195312500e+02 1.4698100280761719e+02 -7.1375602722167969e+01 1.4137100219726562e+02 1.4715899658203125e+02 -7.0953399658203125e+01 1.4019400024414062e+02 1.4747599792480469e+02 -6.8220603942871094e+01 1.0403499603271484e+02 1.4643499755859375e+02 6.4593696594238281e+00 1.0424800109863281e+02 1.4650799560546875e+02 6.0222401618957520e+00 5.7280700683593750e+01 1.4631199645996094e+02 5.9253897666931152e+00 1.0659799957275391e+02 1.4731599426269531e+02 1.1925200223922729e+00 1.0815200042724609e+02 1.4785000610351562e+02 -2.0000000000000000e+00 6.0473201751708984e+01 1.4785000610351562e+02 -2.0000000000000000e+00 5.9175399780273438e+01 1.4748699951171875e+02 1.2217699289321899e+00 5.8142501831054688e+01 1.4719801330566406e+02 3.7860600948333740e+00 5.7908500671386719e+01 1.4695700073242188e+02 4.3669800758361816e+00 1.0505500030517578e+02 1.4678601074218750e+02 4.3642697334289551e+00 1.0226800537109375e+02 1.4446499633789062e+02 1.0092000007629395e+01 5.5577800750732422e+01 1.4456098937988281e+02 1.0153100013732910e+01 1.0074599456787109e+02 1.4276799011230469e+02 1.3218400001525879e+01 5.4901000976562500e+01 1.4386500549316406e+02 1.1833200454711914e+01 5.4380100250244141e+01 1.4270899963378906e+02 1.3126399993896484e+01 1.0036700439453125e+02 1.4234500122070312e+02 1.3998200416564941e+01 5.3676696777343750e+01 1.4114799499511719e+02 1.4872499465942383e+01 9.9896293640136719e+01 1.4129100036621094e+02 1.4965399742126465e+01 5.2284900665283203e+01 1.3806100463867188e+02 1.8327800750732422e+01 9.8104499816894531e+01 1.3727700805664062e+02 1.8647499084472656e+01 5.2134700775146484e+01 1.3738600158691406e+02 1.8700498580932617e+01 9.7983703613281250e+01 1.3700599670410156e+02 1.8895900726318359e+01 5.2059898376464844e+01 1.3705000305175781e+02 1.8886199951171875e+01 9.7545700073242188e+01 1.3602499389648438e+02 1.9796098709106445e+01 9.6922302246093750e+01 1.3308499145507812e+02 2.1077100753784180e+01 5.1172199249267578e+01 1.3306300354003906e+02 2.1089900970458984e+01 9.6223899841308594e+01 1.2979100036621094e+02 2.2512399673461914e+01 5.0587699890136719e+01 1.3043699645996094e+02 2.2541000366210938e+01 5.0548797607421875e+01 1.2986900329589844e+02 2.2637498855590820e+01 5.0231597900390625e+01 1.2523299407958984e+02 2.3425199508666992e+01 5.0000000000000000e+01 1.2184999847412109e+02 2.4000000000000000e+01 6.1631999969482422e+01 1.2184999847412109e+02 2.4000000000000000e+01 6.3690998077392578e+01 1.2184999847412109e+02 2.4000000000000000e+01 6.8000000000000000e+01 1.2184999847412109e+02 2.4000000000000000e+01 7.2750000000000000e+01 1.2184999847412109e+02 2.4000000000000000e+01 9.5500000000000000e+01 1.2184999847412109e+02 2.4000000000000000e+01 9.5705200195312500e+01 1.2527200317382812e+02 2.3578298568725586e+01 8.4867996215820312e+01 1.2184999847412109e+02 2.4000000000000000e+01 9.5878494262695312e+01 1.2816200256347656e+02 2.3222099304199219e+01 7.7500000000000000e+01 1.2184999847412109e+02 2.4000000000000000e+01 5.0495700836181641e+01 1.2909199523925781e+02 2.2769498825073242e+01 9.6069000244140625e+01 1.2905999755859375e+02 2.2830799102783203e+01 8.8776496887207031e+01 1.4785000610351562e+02 -5.6380199432373047e+01 8.8371498107910156e+01 1.4785000610351562e+02 -5.6564598083496094e+01 9.1449600219726562e+01 1.4785000610351562e+02 -6.1581001281738281e+01 9.1050102233886719e+01 1.4785000610351562e+02 -6.1910099029541016e+01 7.0733802795410156e+01 1.4785000610351562e+02 -1.0054800033569336e+01 7.1062896728515625e+01 1.4785000610351562e+02 -1.0454299926757812e+01 6.8998901367187500e+01 1.4785000610351562e+02 -1.1394200325012207e+01 6.8817497253417969e+01 1.4785000610351562e+02 -1.1878999710083008e+01 8.9725601196289062e+01 1.4785000610351562e+02 -6.1414398193359375e+01 9.0054695129394531e+01 1.4785000610351562e+02 -6.1813899993896484e+01 9.0539497375488281e+01 1.4785000610351562e+02 -6.1995399475097656e+01 9.4690399169921875e+01 1.4785000610351562e+02 -6.0252399444580078e+01 9.5090003967285156e+01 1.4785000610351562e+02 -5.9923297882080078e+01 6.8417900085449219e+01 1.4785000610351562e+02 -1.2208100318908691e+01 7.1547698974609375e+01 1.4785000610351562e+02 -1.0635700225830078e+01 7.2058296203613281e+01 1.4785000610351562e+02 -1.0550399780273438e+01 6.7093399047851562e+01 1.4785000610351562e+02 -1.1712400436401367e+01 9.3199295043945312e+01 1.4785000610351562e+02 -5.4888099670410156e+01 9.2714500427246094e+01 1.4785000610351562e+02 -5.4706600189208984e+01 8.8086601257324219e+01 1.4785000610351562e+02 -5.6906497955322266e+01 8.7978202819824219e+01 1.4785000610351562e+02 -5.7338199615478516e+01 8.8067893981933594e+01 1.4785000610351562e+02 -5.7774101257324219e+01 9.5271400451660156e+01 1.4785000610351562e+02 -5.9438499450683594e+01 9.5186096191406250e+01 1.4785000610351562e+02 -5.8927902221679688e+01 9.3528503417968750e+01 1.4785000610351562e+02 -5.5287597656250000e+01 7.2457794189453125e+01 1.4785000610351562e+02 -1.0221300125122070e+01 7.2639198303222656e+01 1.4785000610351562e+02 -9.7364997863769531e+00 7.2554000854492188e+01 1.4785000610351562e+02 -9.2259407043457031e+00 7.0082405090332031e+01 1.4785000610351562e+02 -5.0046300888061523e+00 6.9571800231933594e+01 1.4785000610351562e+02 -5.0899095535278320e+00 6.9172302246093750e+01 1.4785000610351562e+02 -5.4190402030944824e+00 6.7422599792480469e+01 1.4785000610351562e+02 -1.2111900329589844e+01 6.7907402038574219e+01 1.4785000610351562e+02 -1.2293399810791016e+01 7.0896301269531250e+01 1.4785000610351562e+02 -5.5855898857116699e+00 7.0567199707031250e+01 1.4785000610351562e+02 -5.1860599517822266e+00 6.5739295959472656e+01 1.4785000610351562e+02 -6.8625998497009277e+00 6.5454399108886719e+01 1.4785000610351562e+02 -7.2045097351074219e+00 6.5346099853515625e+01 1.4785000610351562e+02 -7.6361598968505859e+00 6.5435798645019531e+01 1.4785000610351562e+02 -8.0720701217651367e+00 9.2203903198242188e+01 1.4785000610351562e+02 -5.4791900634765625e+01 9.1804397583007812e+01 1.4785000610351562e+02 -5.5121002197265625e+01 9.1623001098632812e+01 1.4785000610351562e+02 -5.5605800628662109e+01 6.8913604736328125e+01 1.4785000610351562e+02 -1.0883600234985352e+01 6.8990798950195312e+01 1.4785000610351562e+02 -5.9038500785827637e+00 6.9076095581054688e+01 1.4785000610351562e+02 -6.4144101142883301e+00 9.1708305358886719e+01 1.4785000610351562e+02 -5.6116397857666016e+01 8.9618202209472656e+01 1.4785000610351562e+02 -5.6591400146484375e+01 8.9221405029296875e+01 1.4785000610351562e+02 -5.6389701843261719e+01 6.7255897521972656e+01 1.4785000610351562e+02 -7.2432498931884766e+00 6.6986000061035156e+01 1.4785000610351562e+02 -6.8894100189208984e+00 6.6589302062988281e+01 1.4785000610351562e+02 -6.6877398490905762e+00 6.6144302368164062e+01 1.4785000610351562e+02 -6.6781797409057617e+00 9.4179901123046875e+01 1.4785000610351562e+02 -6.0337699890136719e+01 9.3695098876953125e+01 1.4785000610351562e+02 -6.0156299591064453e+01 9.1631004333496094e+01 1.4785000610351562e+02 -6.1096199035644531e+01 9.3365898132324219e+01 1.4785000610351562e+02 -5.9756801605224609e+01 9.1545799255371094e+01 1.4785000610351562e+02 -6.0585597991943359e+01 8.9888099670410156e+01 1.4785000610351562e+02 -5.6945201873779297e+01 1.1100000000000000e+02 7.8849998474121094e+01 -9.1000000000000000e+01 1.4000000000000000e+02 7.8849998474121094e+01 -9.1000000000000000e+01 1.1100000000000000e+02 7.8849998474121094e+01 -8.8000000000000000e+01 1.4000000000000000e+02 7.8849998474121094e+01 -8.8000000000000000e+01 1.1630000305175781e+02 1.1250000000000000e+02 -8.8000000000000000e+01 1.1585800170898438e+02 1.1084999847412109e+02 -8.8000000000000000e+01 1.1300000000000000e+02 9.0800003051757812e+01 -8.8000000000000000e+01 1.1465000152587891e+02 1.0964199829101562e+02 -8.8000000000000000e+01 1.1134999847412109e+02 9.0357902526855469e+01 -8.8000000000000000e+01 1.1300000000000000e+02 1.0919999694824219e+02 -8.8000000000000000e+01 1.1014199829101562e+02 8.9149993896484375e+01 -8.8000000000000000e+01 1.3469999694824219e+02 8.7500000000000000e+01 -8.8000000000000000e+01 1.1630000305175781e+02 8.7500000000000000e+01 -8.8000000000000000e+01 1.3514199829101562e+02 8.5849998474121094e+01 -8.8000000000000000e+01 1.1585800170898438e+02 8.5849998474121094e+01 -8.8000000000000000e+01 1.3965000915527344e+02 9.0357902526855469e+01 -8.8000000000000000e+01 1.4085800170898438e+02 8.9149993896484375e+01 -8.8000000000000000e+01 1.5000000000000000e+02 8.8849998474121094e+01 -8.8000000000000000e+01 1.4129998779296875e+02 8.7500000000000000e+01 -8.8000000000000000e+01 1.4866000366210938e+02 8.3849998474121094e+01 -8.8000000000000000e+01 1.4085800170898438e+02 8.5849998474121094e+01 -8.8000000000000000e+01 1.4500000000000000e+02 8.0189804077148438e+01 -8.8000000000000000e+01 1.3965000915527344e+02 8.4642097473144531e+01 -8.8000000000000000e+01 1.3800000000000000e+02 8.4200004577636719e+01 -8.8000000000000000e+01 1.3635000610351562e+02 8.4642097473144531e+01 -8.8000000000000000e+01 1.3800000000000000e+02 9.0800003051757812e+01 -8.8000000000000000e+01 1.3965000915527344e+02 1.0964199829101562e+02 -8.8000000000000000e+01 1.3635000610351562e+02 9.0357902526855469e+01 -8.8000000000000000e+01 1.3800000000000000e+02 1.0919999694824219e+02 -8.8000000000000000e+01 1.3514199829101562e+02 8.9149993896484375e+01 -8.8000000000000000e+01 1.1465000152587891e+02 8.4642097473144531e+01 -8.8000000000000000e+01 1.1300000000000000e+02 8.4200004577636719e+01 -8.8000000000000000e+01 1.0600000000000000e+02 8.0189804077148438e+01 -8.8000000000000000e+01 1.1134999847412109e+02 8.4642097473144531e+01 -8.8000000000000000e+01 1.0233999633789062e+02 8.3849998474121094e+01 -8.8000000000000000e+01 1.1014199829101562e+02 8.5849998474121094e+01 -8.8000000000000000e+01 1.0100000000000000e+02 8.8849998474121094e+01 -8.8000000000000000e+01 1.0970000457763672e+02 8.7500000000000000e+01 -8.8000000000000000e+01 1.1134999847412109e+02 1.0964199829101562e+02 -8.8000000000000000e+01 1.1014199829101562e+02 1.1084999847412109e+02 -8.8000000000000000e+01 1.0970000457763672e+02 1.1250000000000000e+02 -8.8000000000000000e+01 1.1014199829101562e+02 1.1415000152587891e+02 -8.8000000000000000e+01 1.1465000152587891e+02 1.1535800170898438e+02 -8.8000000000000000e+01 1.1300000000000000e+02 1.1580000305175781e+02 -8.8000000000000000e+01 1.1134999847412109e+02 1.1535800170898438e+02 -8.8000000000000000e+01 1.3635000610351562e+02 1.0964199829101562e+02 -8.8000000000000000e+01 1.3514199829101562e+02 1.1084999847412109e+02 -8.8000000000000000e+01 1.1465000152587891e+02 9.0357902526855469e+01 -8.8000000000000000e+01 1.1585800170898438e+02 8.9149993896484375e+01 -8.8000000000000000e+01 1.3800000000000000e+02 1.1580000305175781e+02 -8.8000000000000000e+01 1.3635000610351562e+02 1.1535800170898438e+02 -8.8000000000000000e+01 1.3514199829101562e+02 1.1415000152587891e+02 -8.8000000000000000e+01 1.1585800170898438e+02 1.1415000152587891e+02 -8.8000000000000000e+01 1.3469999694824219e+02 1.1250000000000000e+02 -8.8000000000000000e+01 1.3965000915527344e+02 1.1535800170898438e+02 -8.8000000000000000e+01 1.4085800170898438e+02 1.1415000152587891e+02 -8.8000000000000000e+01 1.4129998779296875e+02 1.1250000000000000e+02 -8.8000000000000000e+01 1.4085800170898438e+02 1.1084999847412109e+02 -8.8000000000000000e+01 1.1300000000000000e+02 9.0800003051757812e+01 -9.1000000000000000e+01 1.0970000457763672e+02 1.1250000000000000e+02 -9.1000000000000000e+01 1.1014199829101562e+02 1.1084999847412109e+02 -9.1000000000000000e+01 1.3514199829101562e+02 8.9149993896484375e+01 -9.1000000000000000e+01 1.3469999694824219e+02 8.7500000000000000e+01 -9.1000000000000000e+01 1.1465000152587891e+02 1.0964199829101562e+02 -9.1000000000000000e+01 1.1585800170898438e+02 1.1415000152587891e+02 -9.1000000000000000e+01 1.1465000152587891e+02 1.1535800170898438e+02 -9.1000000000000000e+01 1.3514199829101562e+02 1.1415000152587891e+02 -9.1000000000000000e+01 1.1300000000000000e+02 1.1580000305175781e+02 -9.1000000000000000e+01 1.1134999847412109e+02 1.1535800170898438e+02 -9.1000000000000000e+01 1.4129998779296875e+02 8.7500000000000000e+01 -9.1000000000000000e+01 1.4085800170898438e+02 8.9149993896484375e+01 -9.1000000000000000e+01 1.5000000000000000e+02 8.8849998474121094e+01 -9.1000000000000000e+01 1.0100000000000000e+02 8.8849998474121094e+01 -9.1000000000000000e+01 1.1134999847412109e+02 9.0357902526855469e+01 -9.1000000000000000e+01 1.4085800170898438e+02 8.5849998474121094e+01 -9.1000000000000000e+01 1.4866000366210938e+02 8.3849998474121094e+01 -9.1000000000000000e+01 1.3965000915527344e+02 8.4642097473144531e+01 -9.1000000000000000e+01 1.4500000000000000e+02 8.0189804077148438e+01 -9.1000000000000000e+01 1.3800000000000000e+02 8.4200004577636719e+01 -9.1000000000000000e+01 1.3635000610351562e+02 8.4642097473144531e+01 -9.1000000000000000e+01 1.3514199829101562e+02 8.5849998474121094e+01 -9.1000000000000000e+01 1.1630000305175781e+02 1.1250000000000000e+02 -9.1000000000000000e+01 1.3469999694824219e+02 1.1250000000000000e+02 -9.1000000000000000e+01 1.1585800170898438e+02 1.1084999847412109e+02 -9.1000000000000000e+01 1.1014199829101562e+02 1.1415000152587891e+02 -9.1000000000000000e+01 1.1014199829101562e+02 8.9149993896484375e+01 -9.1000000000000000e+01 1.0970000457763672e+02 8.7500000000000000e+01 -9.1000000000000000e+01 1.0233999633789062e+02 8.3849998474121094e+01 -9.1000000000000000e+01 1.1014199829101562e+02 8.5849998474121094e+01 -9.1000000000000000e+01 1.0600000000000000e+02 8.0189804077148438e+01 -9.1000000000000000e+01 1.1134999847412109e+02 8.4642097473144531e+01 -9.1000000000000000e+01 1.1300000000000000e+02 8.4200004577636719e+01 -9.1000000000000000e+01 1.1465000152587891e+02 8.4642097473144531e+01 -9.1000000000000000e+01 1.1585800170898438e+02 8.5849998474121094e+01 -9.1000000000000000e+01 1.1630000305175781e+02 8.7500000000000000e+01 -9.1000000000000000e+01 1.1585800170898438e+02 8.9149993896484375e+01 -9.1000000000000000e+01 1.1465000152587891e+02 9.0357902526855469e+01 -9.1000000000000000e+01 1.1300000000000000e+02 1.0919999694824219e+02 -9.1000000000000000e+01 1.1134999847412109e+02 1.0964199829101562e+02 -9.1000000000000000e+01 1.3635000610351562e+02 9.0357902526855469e+01 -9.1000000000000000e+01 1.3800000000000000e+02 9.0800003051757812e+01 -9.1000000000000000e+01 1.3514199829101562e+02 1.1084999847412109e+02 -9.1000000000000000e+01 1.3635000610351562e+02 1.0964199829101562e+02 -9.1000000000000000e+01 1.3800000000000000e+02 1.0919999694824219e+02 -9.1000000000000000e+01 1.3965000915527344e+02 9.0357902526855469e+01 -9.1000000000000000e+01 1.3965000915527344e+02 1.0964199829101562e+02 -9.1000000000000000e+01 1.4085800170898438e+02 1.1415000152587891e+02 -9.1000000000000000e+01 1.3965000915527344e+02 1.1535800170898438e+02 -9.1000000000000000e+01 1.3800000000000000e+02 1.1580000305175781e+02 -9.1000000000000000e+01 1.3635000610351562e+02 1.1535800170898438e+02 -9.1000000000000000e+01 1.4085800170898438e+02 1.1084999847412109e+02 -9.1000000000000000e+01 1.4129998779296875e+02 1.1250000000000000e+02 -9.1000000000000000e+01 6.2857501983642578e+01 7.2678703308105469e+01 2.1000000000000000e+01 5.0000000000000000e+01 7.2678703308105469e+01 2.1000000000000000e+01 5.0000000000000000e+01 8.9071304321289062e+01 2.1000000000000000e+01 6.4884002685546875e+01 8.2500000000000000e+01 2.1000000000000000e+01 6.4750000000000000e+01 8.2000000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 8.9071304321289062e+01 2.1000000000000000e+01 7.8883995056152344e+01 8.2500000000000000e+01 2.1000000000000000e+01 7.8750000000000000e+01 8.2000000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 8.9071304321289062e+01 2.1000000000000000e+01 7.7500000000000000e+01 4.2125000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 4.2125000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 5.7000000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 -1.5375000000000000e+01 2.1000000000000000e+01 5.2750000000000000e+01 -1.6000000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 -1.3375000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 -1.1492499542236328e+02 2.1000000000000000e+01 5.0000000000000000e+01 -1.1492499542236328e+02 2.1000000000000000e+01 5.0000000000000000e+01 -1.0142900085449219e+02 2.1000000000000000e+01 5.4625000000000000e+01 4.2082500457763672e+01 2.1000000000000000e+01 5.4466499328613281e+01 4.2125000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 4.2125000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 4.2082500457763672e+01 2.1000000000000000e+01 9.1966499328613281e+01 4.2125000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 4.2125000000000000e+01 2.1000000000000000e+01 6.9750000000000000e+01 1.2000000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 1.1531099319458008e+01 2.1000000000000000e+01 6.8000000000000000e+01 1.3375000000000000e+01 2.1000000000000000e+01 7.5750000000000000e+01 -1.2000000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 -1.1531099319458008e+01 2.1000000000000000e+01 7.7500000000000000e+01 -1.3375000000000000e+01 2.1000000000000000e+01 6.3474700927734375e+01 6.6928703308105469e+01 2.1000000000000000e+01 6.2857501983642578e+01 6.7545898437500000e+01 2.1000000000000000e+01 6.2428703308105469e+01 6.3025302886962891e+01 2.1000000000000000e+01 6.2857501983642578e+01 6.3454097747802734e+01 2.1000000000000000e+01 6.2857501983642578e+01 5.7000000000000000e+01 2.1000000000000000e+01 8.3025299072265625e+01 6.4071296691894531e+01 2.1000000000000000e+01 8.3642494201660156e+01 6.3454097747802734e+01 2.1000000000000000e+01 8.3642494201660156e+01 5.7000000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 -7.2678703308105469e+01 2.1000000000000000e+01 7.7500000000000000e+01 -5.7000000000000000e+01 2.1000000000000000e+01 8.3025299072265625e+01 -6.4071296691894531e+01 2.1000000000000000e+01 8.2642501831054688e+01 -6.5500000000000000e+01 2.1000000000000000e+01 8.3025299072265625e+01 -6.6928703308105469e+01 2.1000000000000000e+01 8.3642494201660156e+01 -7.2678703308105469e+01 2.1000000000000000e+01 8.3642494201660156e+01 -6.7545898437500000e+01 2.1000000000000000e+01 8.4071304321289062e+01 -6.7974700927734375e+01 2.1000000000000000e+01 8.5500000000000000e+01 -6.8357498168945312e+01 2.1000000000000000e+01 8.6928703308105469e+01 -6.7974700927734375e+01 2.1000000000000000e+01 9.5500000000000000e+01 -7.2678703308105469e+01 2.1000000000000000e+01 8.6928703308105469e+01 -6.3025302886962891e+01 2.1000000000000000e+01 8.5500000000000000e+01 -6.2642498016357422e+01 2.1000000000000000e+01 8.3642494201660156e+01 -5.7000000000000000e+01 2.1000000000000000e+01 8.4071304321289062e+01 -6.3025302886962891e+01 2.1000000000000000e+01 8.3642494201660156e+01 -6.3454097747802734e+01 2.1000000000000000e+01 8.7974700927734375e+01 -6.4071296691894531e+01 2.1000000000000000e+01 9.5500000000000000e+01 -5.7000000000000000e+01 2.1000000000000000e+01 8.8357498168945312e+01 -6.5500000000000000e+01 2.1000000000000000e+01 8.7974700927734375e+01 -6.6928703308105469e+01 2.1000000000000000e+01 8.3642494201660156e+01 7.2678703308105469e+01 2.1000000000000000e+01 8.3642494201660156e+01 6.7545898437500000e+01 2.1000000000000000e+01 7.7500000000000000e+01 7.2678703308105469e+01 2.1000000000000000e+01 8.3025299072265625e+01 6.6928703308105469e+01 2.1000000000000000e+01 8.2642501831054688e+01 6.5500000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 7.2678703308105469e+01 2.1000000000000000e+01 8.7974700927734375e+01 6.6928703308105469e+01 2.1000000000000000e+01 8.6928703308105469e+01 6.7974700927734375e+01 2.1000000000000000e+01 8.4071304321289062e+01 6.3025302886962891e+01 2.1000000000000000e+01 8.5500000000000000e+01 6.2642498016357422e+01 2.1000000000000000e+01 9.5500000000000000e+01 5.7000000000000000e+01 2.1000000000000000e+01 8.5500000000000000e+01 6.8357498168945312e+01 2.1000000000000000e+01 8.4071304321289062e+01 6.7974700927734375e+01 2.1000000000000000e+01 8.6928703308105469e+01 6.3025302886962891e+01 2.1000000000000000e+01 8.7974700927734375e+01 6.4071296691894531e+01 2.1000000000000000e+01 8.8357498168945312e+01 6.5500000000000000e+01 2.1000000000000000e+01 5.8525302886962891e+01 6.6928703308105469e+01 2.1000000000000000e+01 5.8142501831054688e+01 6.5500000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 5.7000000000000000e+01 2.1000000000000000e+01 5.8525302886962891e+01 6.4071296691894531e+01 2.1000000000000000e+01 5.9571300506591797e+01 6.3025302886962891e+01 2.1000000000000000e+01 6.1000000000000000e+01 6.2642498016357422e+01 2.1000000000000000e+01 6.2428703308105469e+01 6.7974700927734375e+01 2.1000000000000000e+01 6.1000000000000000e+01 6.8357498168945312e+01 2.1000000000000000e+01 5.9571300506591797e+01 6.7974700927734375e+01 2.1000000000000000e+01 6.3474700927734375e+01 6.4071296691894531e+01 2.1000000000000000e+01 6.4303703308105469e+01 5.7000000000000000e+01 2.1000000000000000e+01 6.3857501983642578e+01 6.5500000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 7.2678703308105469e+01 2.1000000000000000e+01 6.2857501983642578e+01 -6.3454097747802734e+01 2.1000000000000000e+01 6.2428703308105469e+01 -6.3025302886962891e+01 2.1000000000000000e+01 6.2857501983642578e+01 -5.7000000000000000e+01 2.1000000000000000e+01 6.1000000000000000e+01 -6.2642498016357422e+01 2.1000000000000000e+01 5.0000000000000000e+01 -5.7000000000000000e+01 2.1000000000000000e+01 5.9571300506591797e+01 -6.7974700927734375e+01 2.1000000000000000e+01 6.1000000000000000e+01 -6.8357498168945312e+01 2.1000000000000000e+01 6.2857501983642578e+01 -7.2678703308105469e+01 2.1000000000000000e+01 6.2428703308105469e+01 -6.7974700927734375e+01 2.1000000000000000e+01 5.9571300506591797e+01 -6.3025302886962891e+01 2.1000000000000000e+01 5.8525302886962891e+01 -6.4071296691894531e+01 2.1000000000000000e+01 5.0000000000000000e+01 -7.2678703308105469e+01 2.1000000000000000e+01 5.8142501831054688e+01 -6.5500000000000000e+01 2.1000000000000000e+01 5.8525302886962891e+01 -6.6928703308105469e+01 2.1000000000000000e+01 6.3474700927734375e+01 -6.4071296691894531e+01 2.1000000000000000e+01 6.4303703308105469e+01 -5.7000000000000000e+01 2.1000000000000000e+01 6.3857501983642578e+01 -6.5500000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 -7.2678703308105469e+01 2.1000000000000000e+01 6.3474700927734375e+01 -6.6928703308105469e+01 2.1000000000000000e+01 6.2857501983642578e+01 -6.7545898437500000e+01 2.1000000000000000e+01 8.3642494201660156e+01 1.3375000000000000e+01 2.1000000000000000e+01 8.0080101013183594e+01 9.5000000000000000e+00 2.1000000000000000e+01 7.8250000000000000e+01 1.1330100059509277e+01 2.1000000000000000e+01 7.8250000000000000e+01 -1.1330100059509277e+01 2.1000000000000000e+01 8.3642494201660156e+01 -1.3375000000000000e+01 2.1000000000000000e+01 8.0080101013183594e+01 -9.5000000000000000e+00 2.1000000000000000e+01 8.0750000000000000e+01 -7.0000000000000000e+00 2.1000000000000000e+01 8.0750000000000000e+01 7.0000000000000000e+00 2.1000000000000000e+01 7.2750000000000000e+01 -1.2000000000000000e+01 2.1000000000000000e+01 6.7250000000000000e+01 -1.1330100059509277e+01 2.1000000000000000e+01 6.8000000000000000e+01 -1.1531099319458008e+01 2.1000000000000000e+01 6.8000000000000000e+01 -1.3375000000000000e+01 2.1000000000000000e+01 6.9750000000000000e+01 -1.2000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 -1.3375000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 -1.3375000000000000e+01 2.1000000000000000e+01 6.5419898986816406e+01 -9.5000000000000000e+00 2.1000000000000000e+01 6.7250000000000000e+01 1.1330100059509277e+01 2.1000000000000000e+01 6.5419898986816406e+01 9.5000000000000000e+00 2.1000000000000000e+01 6.4303703308105469e+01 1.3375000000000000e+01 2.1000000000000000e+01 6.4750000000000000e+01 7.0000000000000000e+00 2.1000000000000000e+01 6.4750000000000000e+01 -7.0000000000000000e+00 2.1000000000000000e+01 7.7500000000000000e+01 1.3375000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 1.1531099319458008e+01 2.1000000000000000e+01 7.5750000000000000e+01 1.2000000000000000e+01 2.1000000000000000e+01 7.0027503967285156e+01 4.1974899291992188e+01 2.1000000000000000e+01 6.9626502990722656e+01 4.1781803131103516e+01 2.1000000000000000e+01 6.8000000000000000e+01 4.2125000000000000e+01 2.1000000000000000e+01 7.1250000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 7.1250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 7.1151000976562500e+01 4.1433898925781250e+01 2.1000000000000000e+01 7.0873497009277344e+01 4.1781803131103516e+01 2.1000000000000000e+01 7.0472503662109375e+01 4.1974899291992188e+01 2.1000000000000000e+01 6.9348999023437500e+01 4.1433898925781250e+01 2.1000000000000000e+01 6.9250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 3.7000000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 2.6625000000000000e+01 2.1000000000000000e+01 6.9384002685546875e+01 3.6500000000000000e+01 2.1000000000000000e+01 6.9750000000000000e+01 3.6134002685546875e+01 2.1000000000000000e+01 7.0250000000000000e+01 3.6000000000000000e+01 2.1000000000000000e+01 7.0750000000000000e+01 3.6134002685546875e+01 2.1000000000000000e+01 7.2750000000000000e+01 2.6625000000000000e+01 2.1000000000000000e+01 7.1115997314453125e+01 3.6500000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 7.1250000000000000e+01 3.7000000000000000e+01 2.1000000000000000e+01 7.4626495361328125e+01 4.1781803131103516e+01 2.1000000000000000e+01 7.4348999023437500e+01 4.1433898925781250e+01 2.1000000000000000e+01 7.4250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 7.6151000976562500e+01 4.1433898925781250e+01 2.1000000000000000e+01 7.5873504638671875e+01 4.1781803131103516e+01 2.1000000000000000e+01 7.5472496032714844e+01 4.1974899291992188e+01 2.1000000000000000e+01 7.5027503967285156e+01 4.1974899291992188e+01 2.1000000000000000e+01 7.7500000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 2.6625000000000000e+01 2.1000000000000000e+01 7.6116004943847656e+01 3.6500000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 3.7000000000000000e+01 2.1000000000000000e+01 7.4383995056152344e+01 3.6500000000000000e+01 2.1000000000000000e+01 7.4750000000000000e+01 3.6134002685546875e+01 2.1000000000000000e+01 7.6250000000000000e+01 3.7000000000000000e+01 2.1000000000000000e+01 7.6250000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 7.6250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 7.5250000000000000e+01 3.6000000000000000e+01 2.1000000000000000e+01 7.5750000000000000e+01 3.6134002685546875e+01 2.1000000000000000e+01 6.8000000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 -4.2125000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 -4.2125000000000000e+01 2.1000000000000000e+01 7.1151000976562500e+01 -4.1433898925781250e+01 2.1000000000000000e+01 7.1250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 6.9348999023437500e+01 -4.1433898925781250e+01 2.1000000000000000e+01 6.9626502990722656e+01 -4.1781803131103516e+01 2.1000000000000000e+01 7.0027503967285156e+01 -4.1974899291992188e+01 2.1000000000000000e+01 7.0472503662109375e+01 -4.1974899291992188e+01 2.1000000000000000e+01 7.0873497009277344e+01 -4.1781803131103516e+01 2.1000000000000000e+01 7.1250000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 7.1250000000000000e+01 -3.7000000000000000e+01 2.1000000000000000e+01 7.1115997314453125e+01 -3.6500000000000000e+01 2.1000000000000000e+01 7.0750000000000000e+01 -3.6134002685546875e+01 2.1000000000000000e+01 7.0250000000000000e+01 -3.6000000000000000e+01 2.1000000000000000e+01 6.9750000000000000e+01 -3.6134002685546875e+01 2.1000000000000000e+01 6.9384002685546875e+01 -3.6500000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 -3.7000000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 -4.2125000000000000e+01 2.1000000000000000e+01 7.6151000976562500e+01 -4.1433898925781250e+01 2.1000000000000000e+01 7.6250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 7.4348999023437500e+01 -4.1433898925781250e+01 2.1000000000000000e+01 7.4626495361328125e+01 -4.1781803131103516e+01 2.1000000000000000e+01 7.5027503967285156e+01 -4.1974899291992188e+01 2.1000000000000000e+01 7.5472496032714844e+01 -4.1974899291992188e+01 2.1000000000000000e+01 7.5873504638671875e+01 -4.1781803131103516e+01 2.1000000000000000e+01 7.6250000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 7.6250000000000000e+01 -3.7000000000000000e+01 2.1000000000000000e+01 7.6116004943847656e+01 -3.6500000000000000e+01 2.1000000000000000e+01 7.5750000000000000e+01 -3.6134002685546875e+01 2.1000000000000000e+01 7.5250000000000000e+01 -3.6000000000000000e+01 2.1000000000000000e+01 7.4750000000000000e+01 -3.6134002685546875e+01 2.1000000000000000e+01 7.4383995056152344e+01 -3.6500000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 -3.7000000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 -4.2125000000000000e+01 2.1000000000000000e+01 5.4466499328613281e+01 -4.2125000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 -4.2082500457763672e+01 2.1000000000000000e+01 5.0000000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 -4.0375000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 -4.2125000000000000e+01 2.1000000000000000e+01 5.2750000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 -4.1625000000000000e+01 2.1000000000000000e+01 5.5082500457763672e+01 -4.1625000000000000e+01 2.1000000000000000e+01 5.5250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 -3.7875000000000000e+01 2.1000000000000000e+01 5.5082500457763672e+01 -4.0375000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 -3.9917499542236328e+01 2.1000000000000000e+01 5.4000000000000000e+01 -3.9750000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 -3.9917499542236328e+01 2.1000000000000000e+01 5.3375000000000000e+01 -4.2082500457763672e+01 2.1000000000000000e+01 5.3533496856689453e+01 -4.2125000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 -4.3946300506591797e+01 2.1000000000000000e+01 5.4000000000000000e+01 -4.2250000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 -4.1625000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 -4.2082500457763672e+01 2.1000000000000000e+01 8.3642494201660156e+01 -4.2125000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -4.2125000000000000e+01 2.1000000000000000e+01 9.1966499328613281e+01 -4.2125000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 -4.2082500457763672e+01 2.1000000000000000e+01 8.3642494201660156e+01 -3.7875000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 -4.0375000000000000e+01 2.1000000000000000e+01 9.0250000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 9.2582504272460938e+01 -4.0375000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -3.7875000000000000e+01 2.1000000000000000e+01 9.2750000000000000e+01 -4.1000000000000000e+01 2.1000000000000000e+01 9.2582504272460938e+01 -4.1625000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 -3.9917499542236328e+01 2.1000000000000000e+01 9.1500000000000000e+01 -3.9750000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 -3.9917499542236328e+01 2.1000000000000000e+01 9.1033500671386719e+01 -4.2125000000000000e+01 2.1000000000000000e+01 9.1500000000000000e+01 -4.2250000000000000e+01 2.1000000000000000e+01 8.3642494201660156e+01 -4.3946300506591797e+01 2.1000000000000000e+01 9.2582504272460938e+01 4.1625000000000000e+01 2.1000000000000000e+01 9.0250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 4.0375000000000000e+01 2.1000000000000000e+01 8.3642494201660156e+01 3.7875000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 3.9917499542236328e+01 2.1000000000000000e+01 9.1033500671386719e+01 4.2125000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 4.2082500457763672e+01 2.1000000000000000e+01 8.3642494201660156e+01 4.2125000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 4.1625000000000000e+01 2.1000000000000000e+01 9.1500000000000000e+01 3.9750000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 3.9917499542236328e+01 2.1000000000000000e+01 9.2582504272460938e+01 4.0375000000000000e+01 2.1000000000000000e+01 9.2750000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 8.6071197509765625e+01 5.0974700927734375e+01 2.1000000000000000e+01 8.5025306701660156e+01 4.9928699493408203e+01 2.1000000000000000e+01 8.4642501831054688e+01 4.8500000000000000e+01 2.1000000000000000e+01 9.0357498168945312e+01 4.8500000000000000e+01 2.1000000000000000e+01 8.9974700927734375e+01 4.9928699493408203e+01 2.1000000000000000e+01 8.8928695678710938e+01 5.0974700927734375e+01 2.1000000000000000e+01 8.7500000000000000e+01 5.1357501983642578e+01 2.1000000000000000e+01 8.5025306701660156e+01 4.7071201324462891e+01 2.1000000000000000e+01 8.6071197509765625e+01 4.6025299072265625e+01 2.1000000000000000e+01 8.7500000000000000e+01 4.5642498016357422e+01 2.1000000000000000e+01 8.8928695678710938e+01 4.6025299072265625e+01 2.1000000000000000e+01 9.1500000000000000e+01 4.2250000000000000e+01 2.1000000000000000e+01 8.9974700927734375e+01 4.7071201324462891e+01 2.1000000000000000e+01 5.0000000000000000e+01 4.2125000000000000e+01 2.1000000000000000e+01 5.3533496856689453e+01 4.2125000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 4.2082500457763672e+01 2.1000000000000000e+01 5.5082500457763672e+01 4.1625000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 3.7875000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 3.9917499542236328e+01 2.1000000000000000e+01 5.4000000000000000e+01 3.9750000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 3.9917499542236328e+01 2.1000000000000000e+01 6.2857501983642578e+01 3.7875000000000000e+01 2.1000000000000000e+01 5.5082500457763672e+01 4.0375000000000000e+01 2.1000000000000000e+01 5.5250000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 4.1625000000000000e+01 2.1000000000000000e+01 5.2750000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 4.0375000000000000e+01 2.1000000000000000e+01 5.6525302886962891e+01 4.9928699493408203e+01 2.1000000000000000e+01 5.6142501831054688e+01 4.8500000000000000e+01 2.1000000000000000e+01 5.6525302886962891e+01 4.7071201324462891e+01 2.1000000000000000e+01 6.0428699493408203e+01 4.6025299072265625e+01 2.1000000000000000e+01 6.1474700927734375e+01 4.7071201324462891e+01 2.1000000000000000e+01 6.1857498168945312e+01 4.8500000000000000e+01 2.1000000000000000e+01 6.1474700927734375e+01 4.9928699493408203e+01 2.1000000000000000e+01 6.0428699493408203e+01 5.0974700927734375e+01 2.1000000000000000e+01 5.9000000000000000e+01 5.1357501983642578e+01 2.1000000000000000e+01 5.7571300506591797e+01 5.0974700927734375e+01 2.1000000000000000e+01 5.4000000000000000e+01 4.2250000000000000e+01 2.1000000000000000e+01 5.7571300506591797e+01 4.6025299072265625e+01 2.1000000000000000e+01 5.9000000000000000e+01 4.5642498016357422e+01 2.1000000000000000e+01 7.7500000000000000e+01 -1.1492499542236328e+02 2.1000000000000000e+01 8.3642494201660156e+01 -1.1492499542236328e+02 2.1000000000000000e+01 6.4303703308105469e+01 -1.1492499542236328e+02 2.1000000000000000e+01 6.8000000000000000e+01 -1.1492499542236328e+02 2.1000000000000000e+01 9.5500000000000000e+01 -1.1492499542236328e+02 2.1000000000000000e+01 8.3642494201660156e+01 -1.0142900085449219e+02 2.1000000000000000e+01 9.5500000000000000e+01 -1.0142900085449219e+02 2.1000000000000000e+01 7.7500000000000000e+01 -1.0142900085449219e+02 2.1000000000000000e+01 7.9750000000000000e+01 -1.0200000000000000e+02 2.1000000000000000e+01 7.9250000000000000e+01 -1.0213399505615234e+02 2.1000000000000000e+01 7.8883995056152344e+01 -1.0250000000000000e+02 2.1000000000000000e+01 7.8750000000000000e+01 -1.0300000000000000e+02 2.1000000000000000e+01 7.8750000000000000e+01 -1.0700000000000000e+02 2.1000000000000000e+01 7.8883995056152344e+01 -1.0750000000000000e+02 2.1000000000000000e+01 8.0250000000000000e+01 -1.0786599731445312e+02 2.1000000000000000e+01 7.9750000000000000e+01 -1.0800000000000000e+02 2.1000000000000000e+01 7.9250000000000000e+01 -1.0786599731445312e+02 2.1000000000000000e+01 8.0615997314453125e+01 -1.0250000000000000e+02 2.1000000000000000e+01 8.0250000000000000e+01 -1.0213399505615234e+02 2.1000000000000000e+01 8.0615997314453125e+01 -1.0750000000000000e+02 2.1000000000000000e+01 8.0750000000000000e+01 -1.0700000000000000e+02 2.1000000000000000e+01 8.0750000000000000e+01 -1.0300000000000000e+02 2.1000000000000000e+01 6.6250000000000000e+01 -1.0213399505615234e+02 2.1000000000000000e+01 6.5750000000000000e+01 -1.0200000000000000e+02 2.1000000000000000e+01 6.4303703308105469e+01 -1.0142900085449219e+02 2.1000000000000000e+01 6.4750000000000000e+01 -1.0700000000000000e+02 2.1000000000000000e+01 6.4884002685546875e+01 -1.0750000000000000e+02 2.1000000000000000e+01 6.5250000000000000e+01 -1.0213399505615234e+02 2.1000000000000000e+01 6.4884002685546875e+01 -1.0250000000000000e+02 2.1000000000000000e+01 6.4750000000000000e+01 -1.0300000000000000e+02 2.1000000000000000e+01 6.6250000000000000e+01 -1.0786599731445312e+02 2.1000000000000000e+01 6.5750000000000000e+01 -1.0800000000000000e+02 2.1000000000000000e+01 6.5250000000000000e+01 -1.0786599731445312e+02 2.1000000000000000e+01 6.6615997314453125e+01 -1.0750000000000000e+02 2.1000000000000000e+01 6.6750000000000000e+01 -1.0700000000000000e+02 2.1000000000000000e+01 6.8000000000000000e+01 -1.0142900085449219e+02 2.1000000000000000e+01 6.6750000000000000e+01 -1.0300000000000000e+02 2.1000000000000000e+01 6.6615997314453125e+01 -1.0250000000000000e+02 2.1000000000000000e+01 6.2857501983642578e+01 -1.0142900085449219e+02 2.1000000000000000e+01 6.2857501983642578e+01 -8.9071304321289062e+01 2.1000000000000000e+01 8.8928695678710938e+01 -1.0047499847412109e+02 2.1000000000000000e+01 8.7500000000000000e+01 -1.0085800170898438e+02 2.1000000000000000e+01 8.6071197509765625e+01 -1.0047499847412109e+02 2.1000000000000000e+01 8.5025306701660156e+01 -9.9428695678710938e+01 2.1000000000000000e+01 8.9974700927734375e+01 -9.9428695678710938e+01 2.1000000000000000e+01 9.0357498168945312e+01 -9.8000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -8.9071304321289062e+01 2.1000000000000000e+01 8.9974700927734375e+01 -9.6571296691894531e+01 2.1000000000000000e+01 8.8928695678710938e+01 -9.5525299072265625e+01 2.1000000000000000e+01 8.7500000000000000e+01 -9.5142501831054688e+01 2.1000000000000000e+01 8.6071197509765625e+01 -9.5525299072265625e+01 2.1000000000000000e+01 8.3642494201660156e+01 -8.9071304321289062e+01 2.1000000000000000e+01 8.5025306701660156e+01 -9.6571296691894531e+01 2.1000000000000000e+01 8.4642501831054688e+01 -9.8000000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 -8.9071304321289062e+01 2.1000000000000000e+01 6.8000000000000000e+01 -8.9071304321289062e+01 2.1000000000000000e+01 5.9000000000000000e+01 -1.0085800170898438e+02 2.1000000000000000e+01 6.0428699493408203e+01 -1.0047499847412109e+02 2.1000000000000000e+01 6.0428699493408203e+01 -9.5525299072265625e+01 2.1000000000000000e+01 5.9000000000000000e+01 -9.5142501831054688e+01 2.1000000000000000e+01 5.0000000000000000e+01 -8.9071304321289062e+01 2.1000000000000000e+01 6.1474700927734375e+01 -9.9428695678710938e+01 2.1000000000000000e+01 6.1857498168945312e+01 -9.8000000000000000e+01 2.1000000000000000e+01 6.1474700927734375e+01 -9.6571296691894531e+01 2.1000000000000000e+01 5.6525302886962891e+01 -9.9428695678710938e+01 2.1000000000000000e+01 5.7571300506591797e+01 -1.0047499847412109e+02 2.1000000000000000e+01 5.7571300506591797e+01 -9.5525299072265625e+01 2.1000000000000000e+01 5.6525302886962891e+01 -9.6571296691894531e+01 2.1000000000000000e+01 5.6142501831054688e+01 -9.8000000000000000e+01 2.1000000000000000e+01 8.0615997314453125e+01 -7.7500000000000000e+01 2.1000000000000000e+01 8.0250000000000000e+01 -7.7133995056152344e+01 2.1000000000000000e+01 7.8883995056152344e+01 -8.2500000000000000e+01 2.1000000000000000e+01 7.9250000000000000e+01 -8.2865997314453125e+01 2.1000000000000000e+01 7.7500000000000000e+01 -8.9071304321289062e+01 2.1000000000000000e+01 7.9750000000000000e+01 -8.3000000000000000e+01 2.1000000000000000e+01 7.9750000000000000e+01 -7.7000000000000000e+01 2.1000000000000000e+01 7.9250000000000000e+01 -7.7133995056152344e+01 2.1000000000000000e+01 8.0250000000000000e+01 -8.2865997314453125e+01 2.1000000000000000e+01 7.8883995056152344e+01 -7.7500000000000000e+01 2.1000000000000000e+01 7.8750000000000000e+01 -7.8000000000000000e+01 2.1000000000000000e+01 7.8750000000000000e+01 -8.2000000000000000e+01 2.1000000000000000e+01 8.0615997314453125e+01 -8.2500000000000000e+01 2.1000000000000000e+01 8.0750000000000000e+01 -8.2000000000000000e+01 2.1000000000000000e+01 8.0750000000000000e+01 -7.8000000000000000e+01 2.1000000000000000e+01 6.4750000000000000e+01 -8.2000000000000000e+01 2.1000000000000000e+01 6.4884002685546875e+01 -8.2500000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 -7.2678703308105469e+01 2.1000000000000000e+01 6.6615997314453125e+01 -7.7500000000000000e+01 2.1000000000000000e+01 6.6250000000000000e+01 -7.7133995056152344e+01 2.1000000000000000e+01 6.5750000000000000e+01 -7.7000000000000000e+01 2.1000000000000000e+01 6.5250000000000000e+01 -7.7133995056152344e+01 2.1000000000000000e+01 6.4884002685546875e+01 -7.7500000000000000e+01 2.1000000000000000e+01 6.4750000000000000e+01 -7.8000000000000000e+01 2.1000000000000000e+01 6.6250000000000000e+01 -8.2865997314453125e+01 2.1000000000000000e+01 6.5750000000000000e+01 -8.3000000000000000e+01 2.1000000000000000e+01 6.5250000000000000e+01 -8.2865997314453125e+01 2.1000000000000000e+01 6.6615997314453125e+01 -8.2500000000000000e+01 2.1000000000000000e+01 6.6750000000000000e+01 -8.2000000000000000e+01 2.1000000000000000e+01 6.6750000000000000e+01 -7.8000000000000000e+01 2.1000000000000000e+01 8.7500000000000000e+01 -4.5642498016357422e+01 2.1000000000000000e+01 8.6071197509765625e+01 -4.6025299072265625e+01 2.1000000000000000e+01 8.6071197509765625e+01 -5.0974700927734375e+01 2.1000000000000000e+01 8.7500000000000000e+01 -5.1357501983642578e+01 2.1000000000000000e+01 8.5025306701660156e+01 -4.7071201324462891e+01 2.1000000000000000e+01 8.4642501831054688e+01 -4.8500000000000000e+01 2.1000000000000000e+01 8.5025306701660156e+01 -4.9928699493408203e+01 2.1000000000000000e+01 9.5500000000000000e+01 -4.3946300506591797e+01 2.1000000000000000e+01 8.9974700927734375e+01 -4.7071201324462891e+01 2.1000000000000000e+01 8.8928695678710938e+01 -4.6025299072265625e+01 2.1000000000000000e+01 8.8928695678710938e+01 -5.0974700927734375e+01 2.1000000000000000e+01 8.9974700927734375e+01 -4.9928699493408203e+01 2.1000000000000000e+01 9.0357498168945312e+01 -4.8500000000000000e+01 2.1000000000000000e+01 6.0428699493408203e+01 -4.6025299072265625e+01 2.1000000000000000e+01 5.9000000000000000e+01 -4.5642498016357422e+01 2.1000000000000000e+01 6.2857501983642578e+01 -4.3946300506591797e+01 2.1000000000000000e+01 5.7571300506591797e+01 -4.6025299072265625e+01 2.1000000000000000e+01 5.6525302886962891e+01 -4.7071201324462891e+01 2.1000000000000000e+01 5.6142501831054688e+01 -4.8500000000000000e+01 2.1000000000000000e+01 5.6525302886962891e+01 -4.9928699493408203e+01 2.1000000000000000e+01 5.7571300506591797e+01 -5.0974700927734375e+01 2.1000000000000000e+01 5.9000000000000000e+01 -5.1357501983642578e+01 2.1000000000000000e+01 6.0428699493408203e+01 -5.0974700927734375e+01 2.1000000000000000e+01 6.1474700927734375e+01 -4.9928699493408203e+01 2.1000000000000000e+01 6.1857498168945312e+01 -4.8500000000000000e+01 2.1000000000000000e+01 6.1474700927734375e+01 -4.7071201324462891e+01 2.1000000000000000e+01 7.7500000000000000e+01 -4.3946300506591797e+01 2.1000000000000000e+01 7.2750000000000000e+01 -4.3946300506591797e+01 2.1000000000000000e+01 7.2750000000000000e+01 -5.7000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 -7.2678703308105469e+01 2.1000000000000000e+01 7.2750000000000000e+01 -8.9071304321289062e+01 2.1000000000000000e+01 7.2750000000000000e+01 -1.0142900085449219e+02 2.1000000000000000e+01 7.2750000000000000e+01 -1.1492499542236328e+02 2.1000000000000000e+01 6.8000000000000000e+01 -4.3946300506591797e+01 2.1000000000000000e+01 6.8000000000000000e+01 -5.7000000000000000e+01 2.1000000000000000e+01 9.0250000000000000e+01 -1.6000000000000000e+01 2.1000000000000000e+01 9.1500000000000000e+01 -1.7250000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 -1.7082498550415039e+01 2.1000000000000000e+01 9.0417495727539062e+01 -1.6625000000000000e+01 2.1000000000000000e+01 9.2750000000000000e+01 -1.6000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -1.3375000000000000e+01 2.1000000000000000e+01 9.2582504272460938e+01 -1.6625000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 -1.7082498550415039e+01 2.1000000000000000e+01 9.1500000000000000e+01 -1.4750000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 -1.4917500495910645e+01 2.1000000000000000e+01 9.0417495727539062e+01 -1.5375000000000000e+01 2.1000000000000000e+01 9.2582504272460938e+01 -1.5375000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 -1.4917500495910645e+01 2.1000000000000000e+01 6.4303703308105469e+01 -3.7875000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 -4.2125000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 -4.3946300506591797e+01 2.1000000000000000e+01 5.2917499542236328e+01 -1.6625000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 -1.7082498550415039e+01 2.1000000000000000e+01 5.4000000000000000e+01 -1.7250000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 -1.3375000000000000e+01 2.1000000000000000e+01 5.5082500457763672e+01 -1.5375000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 -1.4917500495910645e+01 2.1000000000000000e+01 5.4625000000000000e+01 -1.7082498550415039e+01 2.1000000000000000e+01 5.5082500457763672e+01 -1.6625000000000000e+01 2.1000000000000000e+01 5.5250000000000000e+01 -1.6000000000000000e+01 2.1000000000000000e+01 5.4000000000000000e+01 -1.4750000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 -1.4917500495910645e+01 2.1000000000000000e+01 9.1500000000000000e+01 1.4750000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 1.4917500495910645e+01 2.1000000000000000e+01 9.5500000000000000e+01 1.3375000000000000e+01 2.1000000000000000e+01 9.0250000000000000e+01 1.6000000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 1.5375000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 1.4917500495910645e+01 2.1000000000000000e+01 9.5500000000000000e+01 2.6625000000000000e+01 2.1000000000000000e+01 9.2125000000000000e+01 1.7082498550415039e+01 2.1000000000000000e+01 9.1500000000000000e+01 1.7250000000000000e+01 2.1000000000000000e+01 9.0417495727539062e+01 1.6625000000000000e+01 2.1000000000000000e+01 8.3642494201660156e+01 2.6625000000000000e+01 2.1000000000000000e+01 9.0875000000000000e+01 1.7082498550415039e+01 2.1000000000000000e+01 9.2582504272460938e+01 1.5375000000000000e+01 2.1000000000000000e+01 9.2750000000000000e+01 1.6000000000000000e+01 2.1000000000000000e+01 9.2582504272460938e+01 1.6625000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 1.3375000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 1.2000000000000000e+01 2.1000000000000000e+01 5.4000000000000000e+01 1.7250000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 1.7082498550415039e+01 2.1000000000000000e+01 5.0000000000000000e+01 2.6625000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 1.3375000000000000e+01 2.1000000000000000e+01 5.3375000000000000e+01 1.4917500495910645e+01 2.1000000000000000e+01 5.4000000000000000e+01 1.4750000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 1.4917500495910645e+01 2.1000000000000000e+01 5.5082500457763672e+01 1.5375000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 1.3375000000000000e+01 2.1000000000000000e+01 5.5250000000000000e+01 1.6000000000000000e+01 2.1000000000000000e+01 6.2857501983642578e+01 2.6625000000000000e+01 2.1000000000000000e+01 5.5082500457763672e+01 1.6625000000000000e+01 2.1000000000000000e+01 5.4625000000000000e+01 1.7082498550415039e+01 2.1000000000000000e+01 5.2917499542236328e+01 1.6625000000000000e+01 2.1000000000000000e+01 5.2750000000000000e+01 1.6000000000000000e+01 2.1000000000000000e+01 5.2917499542236328e+01 1.5375000000000000e+01 2.1000000000000000e+01 7.7500000000000000e+01 5.7000000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 7.2678703308105469e+01 2.1000000000000000e+01 6.8000000000000000e+01 5.7000000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 4.2125000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 3.7875000000000000e+01 2.1000000000000000e+01 6.4303703308105469e+01 2.6625000000000000e+01 2.1000000000000000e+01 7.8750000000000000e+01 7.8000000000000000e+01 2.1000000000000000e+01 7.8883995056152344e+01 7.7500000000000000e+01 2.1000000000000000e+01 8.0250000000000000e+01 7.7133995056152344e+01 2.1000000000000000e+01 7.9750000000000000e+01 7.7000000000000000e+01 2.1000000000000000e+01 7.9250000000000000e+01 7.7133995056152344e+01 2.1000000000000000e+01 8.0615997314453125e+01 7.7500000000000000e+01 2.1000000000000000e+01 8.0750000000000000e+01 7.8000000000000000e+01 2.1000000000000000e+01 8.3642494201660156e+01 8.9071304321289062e+01 2.1000000000000000e+01 8.0750000000000000e+01 8.2000000000000000e+01 2.1000000000000000e+01 8.0615997314453125e+01 8.2500000000000000e+01 2.1000000000000000e+01 8.0250000000000000e+01 8.2865997314453125e+01 2.1000000000000000e+01 7.9750000000000000e+01 8.3000000000000000e+01 2.1000000000000000e+01 7.9250000000000000e+01 8.2865997314453125e+01 2.1000000000000000e+01 6.4750000000000000e+01 7.8000000000000000e+01 2.1000000000000000e+01 6.4884002685546875e+01 7.7500000000000000e+01 2.1000000000000000e+01 6.5250000000000000e+01 7.7133995056152344e+01 2.1000000000000000e+01 6.5750000000000000e+01 7.7000000000000000e+01 2.1000000000000000e+01 6.6750000000000000e+01 8.2000000000000000e+01 2.1000000000000000e+01 6.6615997314453125e+01 8.2500000000000000e+01 2.1000000000000000e+01 6.8000000000000000e+01 8.9071304321289062e+01 2.1000000000000000e+01 6.6250000000000000e+01 7.7133995056152344e+01 2.1000000000000000e+01 6.6615997314453125e+01 7.7500000000000000e+01 2.1000000000000000e+01 6.6750000000000000e+01 7.8000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 7.2678703308105469e+01 2.1000000000000000e+01 6.6250000000000000e+01 8.2865997314453125e+01 2.1000000000000000e+01 6.5750000000000000e+01 8.3000000000000000e+01 2.1000000000000000e+01 6.5250000000000000e+01 8.2865997314453125e+01 2.1000000000000000e+01 8.7500000000000000e+01 1.0085800170898438e+02 2.1000000000000000e+01 8.6071197509765625e+01 1.0047499847412109e+02 2.1000000000000000e+01 8.3642494201660156e+01 1.0142900085449219e+02 2.1000000000000000e+01 8.5025306701660156e+01 9.9428695678710938e+01 2.1000000000000000e+01 9.0357498168945312e+01 9.8000000000000000e+01 2.1000000000000000e+01 8.9974700927734375e+01 9.9428695678710938e+01 2.1000000000000000e+01 9.5500000000000000e+01 1.0142900085449219e+02 2.1000000000000000e+01 8.8928695678710938e+01 1.0047499847412109e+02 2.1000000000000000e+01 8.4642501831054688e+01 9.8000000000000000e+01 2.1000000000000000e+01 8.5025306701660156e+01 9.6571296691894531e+01 2.1000000000000000e+01 8.6071197509765625e+01 9.5525299072265625e+01 2.1000000000000000e+01 8.7500000000000000e+01 9.5142501831054688e+01 2.1000000000000000e+01 8.9974700927734375e+01 9.6571296691894531e+01 2.1000000000000000e+01 9.5500000000000000e+01 8.9071304321289062e+01 2.1000000000000000e+01 8.8928695678710938e+01 9.5525299072265625e+01 2.1000000000000000e+01 7.7500000000000000e+01 1.0142900085449219e+02 2.1000000000000000e+01 6.4303703308105469e+01 1.0142900085449219e+02 2.1000000000000000e+01 6.2857501983642578e+01 1.0142900085449219e+02 2.1000000000000000e+01 5.6525302886962891e+01 9.6571296691894531e+01 2.1000000000000000e+01 5.6142501831054688e+01 9.8000000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 1.0142900085449219e+02 2.1000000000000000e+01 5.6525302886962891e+01 9.9428695678710938e+01 2.1000000000000000e+01 5.7571300506591797e+01 9.5525299072265625e+01 2.1000000000000000e+01 6.2857501983642578e+01 8.9071304321289062e+01 2.1000000000000000e+01 6.1857498168945312e+01 9.8000000000000000e+01 2.1000000000000000e+01 6.1474700927734375e+01 9.9428695678710938e+01 2.1000000000000000e+01 5.9000000000000000e+01 9.5142501831054688e+01 2.1000000000000000e+01 6.0428699493408203e+01 9.5525299072265625e+01 2.1000000000000000e+01 6.1474700927734375e+01 9.6571296691894531e+01 2.1000000000000000e+01 6.0428699493408203e+01 1.0047499847412109e+02 2.1000000000000000e+01 5.9000000000000000e+01 1.0085800170898438e+02 2.1000000000000000e+01 5.7571300506591797e+01 1.0047499847412109e+02 2.1000000000000000e+01 7.8750000000000000e+01 1.0300000000000000e+02 2.1000000000000000e+01 7.8883995056152344e+01 1.0250000000000000e+02 2.1000000000000000e+01 7.8750000000000000e+01 1.0700000000000000e+02 2.1000000000000000e+01 7.9250000000000000e+01 1.0786599731445312e+02 2.1000000000000000e+01 7.8883995056152344e+01 1.0750000000000000e+02 2.1000000000000000e+01 7.9250000000000000e+01 1.0213399505615234e+02 2.1000000000000000e+01 7.9750000000000000e+01 1.0200000000000000e+02 2.1000000000000000e+01 8.0250000000000000e+01 1.0213399505615234e+02 2.1000000000000000e+01 8.0615997314453125e+01 1.0250000000000000e+02 2.1000000000000000e+01 8.0250000000000000e+01 1.0786599731445312e+02 2.1000000000000000e+01 7.9750000000000000e+01 1.0800000000000000e+02 2.1000000000000000e+01 8.0750000000000000e+01 1.0300000000000000e+02 2.1000000000000000e+01 8.0750000000000000e+01 1.0700000000000000e+02 2.1000000000000000e+01 8.0615997314453125e+01 1.0750000000000000e+02 2.1000000000000000e+01 7.2750000000000000e+01 1.0142900085449219e+02 2.1000000000000000e+01 6.5250000000000000e+01 1.0213399505615234e+02 2.1000000000000000e+01 6.5750000000000000e+01 1.0200000000000000e+02 2.1000000000000000e+01 6.8000000000000000e+01 1.0142900085449219e+02 2.1000000000000000e+01 7.2750000000000000e+01 8.9071304321289062e+01 2.1000000000000000e+01 6.5250000000000000e+01 1.0786599731445312e+02 2.1000000000000000e+01 6.4884002685546875e+01 1.0750000000000000e+02 2.1000000000000000e+01 6.4750000000000000e+01 1.0700000000000000e+02 2.1000000000000000e+01 6.4750000000000000e+01 1.0300000000000000e+02 2.1000000000000000e+01 6.4884002685546875e+01 1.0250000000000000e+02 2.1000000000000000e+01 6.6250000000000000e+01 1.0213399505615234e+02 2.1000000000000000e+01 6.6615997314453125e+01 1.0250000000000000e+02 2.1000000000000000e+01 6.6750000000000000e+01 1.0300000000000000e+02 2.1000000000000000e+01 6.6750000000000000e+01 1.0700000000000000e+02 2.1000000000000000e+01 6.6615997314453125e+01 1.0750000000000000e+02 2.1000000000000000e+01 6.6250000000000000e+01 1.0786599731445312e+02 2.1000000000000000e+01 6.5750000000000000e+01 1.0800000000000000e+02 2.1000000000000000e+01 8.0615997314453125e+01 -1.0250000000000000e+02 2.4000000000000000e+01 8.0750000000000000e+01 -1.0300000000000000e+02 2.4000000000000000e+01 8.4867996215820312e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.3690998077392578e+01 -7.2066001892089844e+01 2.4000000000000000e+01 6.1631999969482422e+01 -7.2066001892089844e+01 2.4000000000000000e+01 6.1631999969482422e+01 -8.9684005737304688e+01 2.4000000000000000e+01 6.6615997314453125e+01 -7.7500000000000000e+01 2.4000000000000000e+01 6.6750000000000000e+01 -7.8000000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -7.2066001892089844e+01 2.4000000000000000e+01 8.8913299560546875e+01 -4.7683998107910156e+01 2.4000000000000000e+01 8.9132003784179688e+01 -4.8500000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 -4.4558998107910156e+01 2.4000000000000000e+01 7.7500000000000000e+01 -4.2125000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 -4.2125000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 -4.4558998107910156e+01 2.4000000000000000e+01 8.4867996215820312e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 8.9684005737304688e+01 2.4000000000000000e+01 5.0000000000000000e+01 8.9684005737304688e+01 2.4000000000000000e+01 5.0000000000000000e+01 7.2066001892089844e+01 2.4000000000000000e+01 6.3690998077392578e+01 1.0081599426269531e+02 2.4000000000000000e+01 6.1631999969482422e+01 1.0081599426269531e+02 2.4000000000000000e+01 5.3375000000000000e+01 4.2082500457763672e+01 2.4000000000000000e+01 5.3533496856689453e+01 4.2125000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 4.2125000000000000e+01 2.4000000000000000e+01 9.1500000000000000e+01 -4.2250000000000000e+01 2.4000000000000000e+01 9.1033500671386719e+01 -4.2125000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 -4.2125000000000000e+01 2.4000000000000000e+01 6.9750000000000000e+01 -1.2000000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -1.1531099319458008e+01 2.4000000000000000e+01 6.8000000000000000e+01 -1.3375000000000000e+01 2.4000000000000000e+01 6.1000000000000000e+01 -6.3868099212646484e+01 2.4000000000000000e+01 6.1631999969482422e+01 -6.4037399291992188e+01 2.4000000000000000e+01 6.1631999969482422e+01 -5.7000000000000000e+01 2.4000000000000000e+01 8.5500000000000000e+01 6.3868099212646484e+01 2.4000000000000000e+01 8.4867996215820312e+01 6.4037399291992188e+01 2.4000000000000000e+01 8.4867996215820312e+01 5.7000000000000000e+01 2.4000000000000000e+01 8.5500000000000000e+01 -6.7132003784179688e+01 2.4000000000000000e+01 8.4867996215820312e+01 -6.6962600708007812e+01 2.4000000000000000e+01 8.4867996215820312e+01 -7.2066001892089844e+01 2.4000000000000000e+01 8.4683998107910156e+01 -6.6913299560546875e+01 2.4000000000000000e+01 7.7500000000000000e+01 -7.2066001892089844e+01 2.4000000000000000e+01 8.4086700439453125e+01 -6.6316001892089844e+01 2.4000000000000000e+01 8.3867996215820312e+01 -6.5500000000000000e+01 2.4000000000000000e+01 8.4086700439453125e+01 -6.4684005737304688e+01 2.4000000000000000e+01 7.7500000000000000e+01 -5.7000000000000000e+01 2.4000000000000000e+01 8.4683998107910156e+01 -6.4086700439453125e+01 2.4000000000000000e+01 8.4867996215820312e+01 -6.4037399291992188e+01 2.4000000000000000e+01 8.4867996215820312e+01 -5.7000000000000000e+01 2.4000000000000000e+01 8.5500000000000000e+01 -6.3868099212646484e+01 2.4000000000000000e+01 9.5500000000000000e+01 -5.7000000000000000e+01 2.4000000000000000e+01 8.6315994262695312e+01 -6.4086700439453125e+01 2.4000000000000000e+01 8.6913299560546875e+01 -6.4684005737304688e+01 2.4000000000000000e+01 9.5500000000000000e+01 -7.2066001892089844e+01 2.4000000000000000e+01 8.7131996154785156e+01 -6.5500000000000000e+01 2.4000000000000000e+01 8.6913299560546875e+01 -6.6316001892089844e+01 2.4000000000000000e+01 8.6315994262695312e+01 -6.6913299560546875e+01 2.4000000000000000e+01 8.4683998107910156e+01 6.4086700439453125e+01 2.4000000000000000e+01 7.7500000000000000e+01 5.7000000000000000e+01 2.4000000000000000e+01 8.4086700439453125e+01 6.4684005737304688e+01 2.4000000000000000e+01 7.7500000000000000e+01 7.2066001892089844e+01 2.4000000000000000e+01 8.3867996215820312e+01 6.5500000000000000e+01 2.4000000000000000e+01 8.4086700439453125e+01 6.6316001892089844e+01 2.4000000000000000e+01 8.4683998107910156e+01 6.6913299560546875e+01 2.4000000000000000e+01 8.5500000000000000e+01 6.7132003784179688e+01 2.4000000000000000e+01 8.6315994262695312e+01 6.6913299560546875e+01 2.4000000000000000e+01 9.5500000000000000e+01 7.2066001892089844e+01 2.4000000000000000e+01 8.4867996215820312e+01 7.2066001892089844e+01 2.4000000000000000e+01 8.4867996215820312e+01 6.6962600708007812e+01 2.4000000000000000e+01 8.6315994262695312e+01 6.4086700439453125e+01 2.4000000000000000e+01 8.6913299560546875e+01 6.6316001892089844e+01 2.4000000000000000e+01 8.7131996154785156e+01 6.5500000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 5.7000000000000000e+01 2.4000000000000000e+01 8.6913299560546875e+01 6.4684005737304688e+01 2.4000000000000000e+01 6.1631999969482422e+01 5.7000000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 6.4037399291992188e+01 2.4000000000000000e+01 6.1000000000000000e+01 6.3868099212646484e+01 2.4000000000000000e+01 6.0183998107910156e+01 6.6913299560546875e+01 2.4000000000000000e+01 6.1000000000000000e+01 6.7132003784179688e+01 2.4000000000000000e+01 6.1631999969482422e+01 7.2066001892089844e+01 2.4000000000000000e+01 5.0000000000000000e+01 5.7000000000000000e+01 2.4000000000000000e+01 6.0183998107910156e+01 6.4086700439453125e+01 2.4000000000000000e+01 5.9586700439453125e+01 6.4684005737304688e+01 2.4000000000000000e+01 5.9368000030517578e+01 6.5500000000000000e+01 2.4000000000000000e+01 5.9586700439453125e+01 6.6316001892089844e+01 2.4000000000000000e+01 6.1631999969482422e+01 6.6962600708007812e+01 2.4000000000000000e+01 6.1815998077392578e+01 6.6913299560546875e+01 2.4000000000000000e+01 6.3690998077392578e+01 7.2066001892089844e+01 2.4000000000000000e+01 6.2413299560546875e+01 6.6316001892089844e+01 2.4000000000000000e+01 6.2632003784179688e+01 6.5500000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 5.7000000000000000e+01 2.4000000000000000e+01 6.2413299560546875e+01 6.4684005737304688e+01 2.4000000000000000e+01 6.1815998077392578e+01 6.4086700439453125e+01 2.4000000000000000e+01 6.0183998107910156e+01 -6.4086700439453125e+01 2.4000000000000000e+01 6.1000000000000000e+01 -6.7132003784179688e+01 2.4000000000000000e+01 6.0183998107910156e+01 -6.6913299560546875e+01 2.4000000000000000e+01 5.0000000000000000e+01 -7.2066001892089844e+01 2.4000000000000000e+01 5.9586700439453125e+01 -6.6316001892089844e+01 2.4000000000000000e+01 5.9368000030517578e+01 -6.5500000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 -5.7000000000000000e+01 2.4000000000000000e+01 5.9586700439453125e+01 -6.4684005737304688e+01 2.4000000000000000e+01 6.1815998077392578e+01 -6.6913299560546875e+01 2.4000000000000000e+01 6.1631999969482422e+01 -6.6962600708007812e+01 2.4000000000000000e+01 6.1815998077392578e+01 -6.4086700439453125e+01 2.4000000000000000e+01 6.3690998077392578e+01 -5.7000000000000000e+01 2.4000000000000000e+01 6.2413299560546875e+01 -6.4684005737304688e+01 2.4000000000000000e+01 6.2632003784179688e+01 -6.5500000000000000e+01 2.4000000000000000e+01 6.2413299560546875e+01 -6.6316001892089844e+01 2.4000000000000000e+01 6.3690998077392578e+01 1.3375000000000000e+01 2.4000000000000000e+01 6.5419898986816406e+01 9.5000000000000000e+00 2.4000000000000000e+01 6.7250000000000000e+01 1.1330100059509277e+01 2.4000000000000000e+01 6.7250000000000000e+01 -1.1330100059509277e+01 2.4000000000000000e+01 6.3690998077392578e+01 -1.3375000000000000e+01 2.4000000000000000e+01 6.5419898986816406e+01 -9.5000000000000000e+00 2.4000000000000000e+01 6.4750000000000000e+01 -7.0000000000000000e+00 2.4000000000000000e+01 6.4750000000000000e+01 7.0000000000000000e+00 2.4000000000000000e+01 7.2750000000000000e+01 -1.2000000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 -1.3375000000000000e+01 2.4000000000000000e+01 7.5750000000000000e+01 -1.2000000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 -1.3375000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 -1.1531099319458008e+01 2.4000000000000000e+01 7.7500000000000000e+01 1.3375000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 1.1531099319458008e+01 2.4000000000000000e+01 8.4867996215820312e+01 1.3375000000000000e+01 2.4000000000000000e+01 7.8250000000000000e+01 1.1330100059509277e+01 2.4000000000000000e+01 7.8250000000000000e+01 -1.1330100059509277e+01 2.4000000000000000e+01 8.4867996215820312e+01 -1.3375000000000000e+01 2.4000000000000000e+01 8.0080101013183594e+01 -9.5000000000000000e+00 2.4000000000000000e+01 8.0080101013183594e+01 9.5000000000000000e+00 2.4000000000000000e+01 8.0750000000000000e+01 7.0000000000000000e+00 2.4000000000000000e+01 8.0750000000000000e+01 -7.0000000000000000e+00 2.4000000000000000e+01 6.8000000000000000e+01 1.1531099319458008e+01 2.4000000000000000e+01 6.8000000000000000e+01 1.3375000000000000e+01 2.4000000000000000e+01 6.9750000000000000e+01 1.2000000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 1.3375000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 1.2000000000000000e+01 2.4000000000000000e+01 7.5750000000000000e+01 1.2000000000000000e+01 2.4000000000000000e+01 7.1250000000000000e+01 3.7000000000000000e+01 2.4000000000000000e+01 7.1115997314453125e+01 3.6500000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 2.6625000000000000e+01 2.4000000000000000e+01 7.0750000000000000e+01 3.6134002685546875e+01 2.4000000000000000e+01 6.8000000000000000e+01 2.6625000000000000e+01 2.4000000000000000e+01 7.0250000000000000e+01 3.6000000000000000e+01 2.4000000000000000e+01 6.9750000000000000e+01 3.6134002685546875e+01 2.4000000000000000e+01 6.9384002685546875e+01 3.6500000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 6.9348999023437500e+01 4.1433898925781250e+01 2.4000000000000000e+01 6.9626502990722656e+01 4.1781803131103516e+01 2.4000000000000000e+01 6.8000000000000000e+01 4.2125000000000000e+01 2.4000000000000000e+01 7.0027503967285156e+01 4.1974899291992188e+01 2.4000000000000000e+01 7.1250000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 7.1250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 4.2125000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 3.7000000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 7.0472503662109375e+01 4.1974899291992188e+01 2.4000000000000000e+01 7.0873497009277344e+01 4.1781803131103516e+01 2.4000000000000000e+01 7.1151000976562500e+01 4.1433898925781250e+01 2.4000000000000000e+01 7.6116004943847656e+01 3.6500000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 2.6625000000000000e+01 2.4000000000000000e+01 7.6250000000000000e+01 3.7000000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 7.6250000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 7.4750000000000000e+01 3.6134002685546875e+01 2.4000000000000000e+01 7.5250000000000000e+01 3.6000000000000000e+01 2.4000000000000000e+01 7.5750000000000000e+01 3.6134002685546875e+01 2.4000000000000000e+01 7.4383995056152344e+01 3.6500000000000000e+01 2.4000000000000000e+01 7.4250000000000000e+01 3.7000000000000000e+01 2.4000000000000000e+01 7.4250000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 7.4250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 7.4348999023437500e+01 4.1433898925781250e+01 2.4000000000000000e+01 7.4626495361328125e+01 4.1781803131103516e+01 2.4000000000000000e+01 7.5027503967285156e+01 4.1974899291992188e+01 2.4000000000000000e+01 7.6250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 4.2125000000000000e+01 2.4000000000000000e+01 7.6151000976562500e+01 4.1433898925781250e+01 2.4000000000000000e+01 7.5472496032714844e+01 4.1974899291992188e+01 2.4000000000000000e+01 7.5873504638671875e+01 4.1781803131103516e+01 2.4000000000000000e+01 6.9384002685546875e+01 -3.6500000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 -3.7000000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 6.9750000000000000e+01 -3.6134002685546875e+01 2.4000000000000000e+01 7.0250000000000000e+01 -3.6000000000000000e+01 2.4000000000000000e+01 7.0750000000000000e+01 -3.6134002685546875e+01 2.4000000000000000e+01 7.1115997314453125e+01 -3.6500000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -4.2125000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 6.9250000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.1250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 7.1250000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.1250000000000000e+01 -3.7000000000000000e+01 2.4000000000000000e+01 7.1151000976562500e+01 -4.1433898925781250e+01 2.4000000000000000e+01 7.0873497009277344e+01 -4.1781803131103516e+01 2.4000000000000000e+01 7.0472503662109375e+01 -4.1974899291992188e+01 2.4000000000000000e+01 7.0027503967285156e+01 -4.1974899291992188e+01 2.4000000000000000e+01 6.9626502990722656e+01 -4.1781803131103516e+01 2.4000000000000000e+01 6.9348999023437500e+01 -4.1433898925781250e+01 2.4000000000000000e+01 7.4250000000000000e+01 -3.7000000000000000e+01 2.4000000000000000e+01 7.4383995056152344e+01 -3.6500000000000000e+01 2.4000000000000000e+01 7.4750000000000000e+01 -3.6134002685546875e+01 2.4000000000000000e+01 7.5250000000000000e+01 -3.6000000000000000e+01 2.4000000000000000e+01 7.5750000000000000e+01 -3.6134002685546875e+01 2.4000000000000000e+01 7.4626495361328125e+01 -4.1781803131103516e+01 2.4000000000000000e+01 7.4348999023437500e+01 -4.1433898925781250e+01 2.4000000000000000e+01 7.4250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 7.4250000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.6116004943847656e+01 -3.6500000000000000e+01 2.4000000000000000e+01 7.6250000000000000e+01 -3.7000000000000000e+01 2.4000000000000000e+01 7.6250000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 7.6250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 7.6151000976562500e+01 -4.1433898925781250e+01 2.4000000000000000e+01 7.5873504638671875e+01 -4.1781803131103516e+01 2.4000000000000000e+01 7.5472496032714844e+01 -4.1974899291992188e+01 2.4000000000000000e+01 7.5027503967285156e+01 -4.1974899291992188e+01 2.4000000000000000e+01 5.0000000000000000e+01 -4.2125000000000000e+01 2.4000000000000000e+01 5.3533496856689453e+01 -4.2125000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 -4.2082500457763672e+01 2.4000000000000000e+01 5.2917499542236328e+01 -4.1625000000000000e+01 2.4000000000000000e+01 5.2750000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 5.2917499542236328e+01 -4.0375000000000000e+01 2.4000000000000000e+01 5.5082500457763672e+01 -4.1625000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 -4.2082500457763672e+01 2.4000000000000000e+01 6.1631999969482422e+01 -4.2125000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 -3.9917499542236328e+01 2.4000000000000000e+01 5.4000000000000000e+01 -3.9750000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 -3.7875000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 -3.9917499542236328e+01 2.4000000000000000e+01 5.5082500457763672e+01 -4.0375000000000000e+01 2.4000000000000000e+01 5.5250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 5.4466499328613281e+01 -4.2125000000000000e+01 2.4000000000000000e+01 5.4000000000000000e+01 -4.2250000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 -4.4558998107910156e+01 2.4000000000000000e+01 9.0875000000000000e+01 -4.2082500457763672e+01 2.4000000000000000e+01 9.0417495727539062e+01 -4.1625000000000000e+01 2.4000000000000000e+01 9.0250000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 9.0417495727539062e+01 -4.0375000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 -3.9917499542236328e+01 2.4000000000000000e+01 9.5500000000000000e+01 -3.7875000000000000e+01 2.4000000000000000e+01 9.1500000000000000e+01 -3.9750000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 -3.9917499542236328e+01 2.4000000000000000e+01 9.2582504272460938e+01 -4.0375000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 -4.2125000000000000e+01 2.4000000000000000e+01 9.2750000000000000e+01 -4.1000000000000000e+01 2.4000000000000000e+01 9.2582504272460938e+01 -4.1625000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 -4.2082500457763672e+01 2.4000000000000000e+01 9.1966499328613281e+01 -4.2125000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 -4.4558998107910156e+01 2.4000000000000000e+01 9.2582504272460938e+01 4.1625000000000000e+01 2.4000000000000000e+01 9.2750000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 4.2125000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 9.2582504272460938e+01 4.0375000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 3.9917499542236328e+01 2.4000000000000000e+01 9.1500000000000000e+01 3.9750000000000000e+01 2.4000000000000000e+01 9.1033500671386719e+01 4.2125000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 4.2125000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 4.2082500457763672e+01 2.4000000000000000e+01 9.0417495727539062e+01 4.1625000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 3.9917499542236328e+01 2.4000000000000000e+01 8.4867996215820312e+01 3.7875000000000000e+01 2.4000000000000000e+01 9.0417495727539062e+01 4.0375000000000000e+01 2.4000000000000000e+01 9.0250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 9.1500000000000000e+01 4.2250000000000000e+01 2.4000000000000000e+01 9.1966499328613281e+01 4.2125000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 4.2082500457763672e+01 2.4000000000000000e+01 8.6684005737304688e+01 4.9913299560546875e+01 2.4000000000000000e+01 8.7500000000000000e+01 5.0131999969482422e+01 2.4000000000000000e+01 8.8316001892089844e+01 4.9913299560546875e+01 2.4000000000000000e+01 8.8913299560546875e+01 4.9316001892089844e+01 2.4000000000000000e+01 8.9132003784179688e+01 4.8500000000000000e+01 2.4000000000000000e+01 8.8913299560546875e+01 4.7683998107910156e+01 2.4000000000000000e+01 8.8316001892089844e+01 4.7086700439453125e+01 2.4000000000000000e+01 8.7500000000000000e+01 4.6868000030517578e+01 2.4000000000000000e+01 8.6684005737304688e+01 4.7086700439453125e+01 2.4000000000000000e+01 8.6086700439453125e+01 4.7683998107910156e+01 2.4000000000000000e+01 8.5868003845214844e+01 4.8500000000000000e+01 2.4000000000000000e+01 8.6086700439453125e+01 4.9316001892089844e+01 2.4000000000000000e+01 6.1631999969482422e+01 4.2125000000000000e+01 2.4000000000000000e+01 5.4466499328613281e+01 4.2125000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 4.2082500457763672e+01 2.4000000000000000e+01 5.2917499542236328e+01 4.1625000000000000e+01 2.4000000000000000e+01 5.5082500457763672e+01 4.1625000000000000e+01 2.4000000000000000e+01 5.5250000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 3.7875000000000000e+01 2.4000000000000000e+01 5.5082500457763672e+01 4.0375000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 3.9917499542236328e+01 2.4000000000000000e+01 5.4000000000000000e+01 3.9750000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 3.9917499542236328e+01 2.4000000000000000e+01 5.0000000000000000e+01 3.7875000000000000e+01 2.4000000000000000e+01 5.2917499542236328e+01 4.0375000000000000e+01 2.4000000000000000e+01 5.2750000000000000e+01 4.1000000000000000e+01 2.4000000000000000e+01 5.9000000000000000e+01 5.0131999969482422e+01 2.4000000000000000e+01 5.9815998077392578e+01 4.9913299560546875e+01 2.4000000000000000e+01 6.0413299560546875e+01 4.9316001892089844e+01 2.4000000000000000e+01 6.0631999969482422e+01 4.8500000000000000e+01 2.4000000000000000e+01 6.0413299560546875e+01 4.7683998107910156e+01 2.4000000000000000e+01 5.8184001922607422e+01 4.9913299560546875e+01 2.4000000000000000e+01 5.7586700439453125e+01 4.9316001892089844e+01 2.4000000000000000e+01 5.9815998077392578e+01 4.7086700439453125e+01 2.4000000000000000e+01 5.9000000000000000e+01 4.6868000030517578e+01 2.4000000000000000e+01 5.8184001922607422e+01 4.7086700439453125e+01 2.4000000000000000e+01 5.4000000000000000e+01 4.2250000000000000e+01 2.4000000000000000e+01 5.7586700439453125e+01 4.7683998107910156e+01 2.4000000000000000e+01 5.7368000030517578e+01 4.8500000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 1.0081599426269531e+02 2.4000000000000000e+01 9.5500000000000000e+01 1.0081599426269531e+02 2.4000000000000000e+01 8.0750000000000000e+01 1.0300000000000000e+02 2.4000000000000000e+01 8.0615997314453125e+01 1.0250000000000000e+02 2.4000000000000000e+01 8.0250000000000000e+01 1.0213399505615234e+02 2.4000000000000000e+01 7.9750000000000000e+01 1.0200000000000000e+02 2.4000000000000000e+01 7.7500000000000000e+01 1.0081599426269531e+02 2.4000000000000000e+01 7.9250000000000000e+01 1.0213399505615234e+02 2.4000000000000000e+01 7.8883995056152344e+01 1.0750000000000000e+02 2.4000000000000000e+01 7.9250000000000000e+01 1.0786599731445312e+02 2.4000000000000000e+01 7.9750000000000000e+01 1.0800000000000000e+02 2.4000000000000000e+01 8.0250000000000000e+01 1.0786599731445312e+02 2.4000000000000000e+01 8.0615997314453125e+01 1.0750000000000000e+02 2.4000000000000000e+01 8.0750000000000000e+01 1.0700000000000000e+02 2.4000000000000000e+01 7.8883995056152344e+01 1.0250000000000000e+02 2.4000000000000000e+01 7.8750000000000000e+01 1.0300000000000000e+02 2.4000000000000000e+01 7.8750000000000000e+01 1.0700000000000000e+02 2.4000000000000000e+01 6.8000000000000000e+01 1.0081599426269531e+02 2.4000000000000000e+01 6.6750000000000000e+01 1.0300000000000000e+02 2.4000000000000000e+01 6.6615997314453125e+01 1.0250000000000000e+02 2.4000000000000000e+01 6.5250000000000000e+01 1.0786599731445312e+02 2.4000000000000000e+01 6.5750000000000000e+01 1.0800000000000000e+02 2.4000000000000000e+01 6.6750000000000000e+01 1.0700000000000000e+02 2.4000000000000000e+01 6.6615997314453125e+01 1.0750000000000000e+02 2.4000000000000000e+01 6.6250000000000000e+01 1.0786599731445312e+02 2.4000000000000000e+01 6.6250000000000000e+01 1.0213399505615234e+02 2.4000000000000000e+01 6.5750000000000000e+01 1.0200000000000000e+02 2.4000000000000000e+01 6.5250000000000000e+01 1.0213399505615234e+02 2.4000000000000000e+01 6.4884002685546875e+01 1.0250000000000000e+02 2.4000000000000000e+01 6.4750000000000000e+01 1.0300000000000000e+02 2.4000000000000000e+01 6.4750000000000000e+01 1.0700000000000000e+02 2.4000000000000000e+01 6.4884002685546875e+01 1.0750000000000000e+02 2.4000000000000000e+01 5.0000000000000000e+01 1.0081599426269531e+02 2.4000000000000000e+01 8.8316001892089844e+01 9.9413299560546875e+01 2.4000000000000000e+01 8.7500000000000000e+01 9.9632003784179688e+01 2.4000000000000000e+01 8.6684005737304688e+01 9.9413299560546875e+01 2.4000000000000000e+01 8.6086700439453125e+01 9.8816001892089844e+01 2.4000000000000000e+01 8.8913299560546875e+01 9.8816001892089844e+01 2.4000000000000000e+01 8.9132003784179688e+01 9.8000000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 8.9684005737304688e+01 2.4000000000000000e+01 8.8913299560546875e+01 9.7184005737304688e+01 2.4000000000000000e+01 8.8316001892089844e+01 9.6586700439453125e+01 2.4000000000000000e+01 8.7500000000000000e+01 9.6367996215820312e+01 2.4000000000000000e+01 8.6684005737304688e+01 9.6586700439453125e+01 2.4000000000000000e+01 8.4867996215820312e+01 8.9684005737304688e+01 2.4000000000000000e+01 8.6086700439453125e+01 9.7184005737304688e+01 2.4000000000000000e+01 8.5868003845214844e+01 9.8000000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 8.9684005737304688e+01 2.4000000000000000e+01 6.8000000000000000e+01 8.9684005737304688e+01 2.4000000000000000e+01 6.0413299560546875e+01 9.7184005737304688e+01 2.4000000000000000e+01 6.0631999969482422e+01 9.8000000000000000e+01 2.4000000000000000e+01 6.0413299560546875e+01 9.8816001892089844e+01 2.4000000000000000e+01 5.9815998077392578e+01 9.9413299560546875e+01 2.4000000000000000e+01 5.9815998077392578e+01 9.6586700439453125e+01 2.4000000000000000e+01 5.9000000000000000e+01 9.6367996215820312e+01 2.4000000000000000e+01 5.7368000030517578e+01 9.8000000000000000e+01 2.4000000000000000e+01 5.7586700439453125e+01 9.7184005737304688e+01 2.4000000000000000e+01 5.8184001922607422e+01 9.6586700439453125e+01 2.4000000000000000e+01 5.7586700439453125e+01 9.8816001892089844e+01 2.4000000000000000e+01 5.8184001922607422e+01 9.9413299560546875e+01 2.4000000000000000e+01 5.9000000000000000e+01 9.9632003784179688e+01 2.4000000000000000e+01 8.0615997314453125e+01 7.7500000000000000e+01 2.4000000000000000e+01 8.0250000000000000e+01 7.7133995056152344e+01 2.4000000000000000e+01 7.9750000000000000e+01 7.7000000000000000e+01 2.4000000000000000e+01 7.9250000000000000e+01 7.7133995056152344e+01 2.4000000000000000e+01 7.8883995056152344e+01 7.7500000000000000e+01 2.4000000000000000e+01 7.8750000000000000e+01 7.8000000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 8.9684005737304688e+01 2.4000000000000000e+01 7.8750000000000000e+01 8.2000000000000000e+01 2.4000000000000000e+01 7.8883995056152344e+01 8.2500000000000000e+01 2.4000000000000000e+01 7.9250000000000000e+01 8.2865997314453125e+01 2.4000000000000000e+01 7.9750000000000000e+01 8.3000000000000000e+01 2.4000000000000000e+01 8.0250000000000000e+01 8.2865997314453125e+01 2.4000000000000000e+01 8.0615997314453125e+01 8.2500000000000000e+01 2.4000000000000000e+01 8.0750000000000000e+01 8.2000000000000000e+01 2.4000000000000000e+01 8.0750000000000000e+01 7.8000000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 7.2066001892089844e+01 2.4000000000000000e+01 6.6615997314453125e+01 7.7500000000000000e+01 2.4000000000000000e+01 6.6250000000000000e+01 7.7133995056152344e+01 2.4000000000000000e+01 6.4750000000000000e+01 8.2000000000000000e+01 2.4000000000000000e+01 6.4884002685546875e+01 8.2500000000000000e+01 2.4000000000000000e+01 6.5750000000000000e+01 7.7000000000000000e+01 2.4000000000000000e+01 6.5250000000000000e+01 7.7133995056152344e+01 2.4000000000000000e+01 6.4884002685546875e+01 7.7500000000000000e+01 2.4000000000000000e+01 6.4750000000000000e+01 7.8000000000000000e+01 2.4000000000000000e+01 6.6250000000000000e+01 8.2865997314453125e+01 2.4000000000000000e+01 6.5750000000000000e+01 8.3000000000000000e+01 2.4000000000000000e+01 6.5250000000000000e+01 8.2865997314453125e+01 2.4000000000000000e+01 6.6615997314453125e+01 8.2500000000000000e+01 2.4000000000000000e+01 6.6750000000000000e+01 8.2000000000000000e+01 2.4000000000000000e+01 6.6750000000000000e+01 7.8000000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 5.7000000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 7.2066001892089844e+01 2.4000000000000000e+01 7.2750000000000000e+01 8.9684005737304688e+01 2.4000000000000000e+01 7.2750000000000000e+01 1.0081599426269531e+02 2.4000000000000000e+01 6.8000000000000000e+01 5.7000000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 2.6625000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 2.6625000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 1.4917500495910645e+01 2.4000000000000000e+01 9.0417495727539062e+01 1.5375000000000000e+01 2.4000000000000000e+01 9.1500000000000000e+01 1.4750000000000000e+01 2.4000000000000000e+01 9.2750000000000000e+01 1.6000000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 1.3375000000000000e+01 2.4000000000000000e+01 9.2582504272460938e+01 1.6625000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 1.7082498550415039e+01 2.4000000000000000e+01 9.2582504272460938e+01 1.5375000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 1.4917500495910645e+01 2.4000000000000000e+01 9.0250000000000000e+01 1.6000000000000000e+01 2.4000000000000000e+01 9.0417495727539062e+01 1.6625000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 1.7082498550415039e+01 2.4000000000000000e+01 9.1500000000000000e+01 1.7250000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 2.6625000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 3.7875000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 4.2125000000000000e+01 2.4000000000000000e+01 5.2917499542236328e+01 1.5375000000000000e+01 2.4000000000000000e+01 5.2750000000000000e+01 1.6000000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 1.3375000000000000e+01 2.4000000000000000e+01 5.5082500457763672e+01 1.5375000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 1.4917500495910645e+01 2.4000000000000000e+01 6.1631999969482422e+01 1.3375000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 2.6625000000000000e+01 2.4000000000000000e+01 5.2917499542236328e+01 1.6625000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 1.7082498550415039e+01 2.4000000000000000e+01 5.4000000000000000e+01 1.7250000000000000e+01 2.4000000000000000e+01 5.4000000000000000e+01 1.4750000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 1.4917500495910645e+01 2.4000000000000000e+01 6.1631999969482422e+01 2.6625000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 1.7082498550415039e+01 2.4000000000000000e+01 5.5082500457763672e+01 1.6625000000000000e+01 2.4000000000000000e+01 5.5250000000000000e+01 1.6000000000000000e+01 2.4000000000000000e+01 9.5500000000000000e+01 -1.3375000000000000e+01 2.4000000000000000e+01 9.2750000000000000e+01 -1.6000000000000000e+01 2.4000000000000000e+01 9.2582504272460938e+01 -1.6625000000000000e+01 2.4000000000000000e+01 9.0417495727539062e+01 -1.6625000000000000e+01 2.4000000000000000e+01 9.0250000000000000e+01 -1.6000000000000000e+01 2.4000000000000000e+01 9.0417495727539062e+01 -1.5375000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 -1.4917500495910645e+01 2.4000000000000000e+01 9.1500000000000000e+01 -1.4750000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 -1.4917500495910645e+01 2.4000000000000000e+01 9.2582504272460938e+01 -1.5375000000000000e+01 2.4000000000000000e+01 9.2125000000000000e+01 -1.7082498550415039e+01 2.4000000000000000e+01 9.1500000000000000e+01 -1.7250000000000000e+01 2.4000000000000000e+01 9.0875000000000000e+01 -1.7082498550415039e+01 2.4000000000000000e+01 5.4625000000000000e+01 -1.4917500495910645e+01 2.4000000000000000e+01 5.5082500457763672e+01 -1.5375000000000000e+01 2.4000000000000000e+01 6.1631999969482422e+01 -1.3375000000000000e+01 2.4000000000000000e+01 5.5250000000000000e+01 -1.6000000000000000e+01 2.4000000000000000e+01 5.4000000000000000e+01 -1.7250000000000000e+01 2.4000000000000000e+01 5.4625000000000000e+01 -1.7082498550415039e+01 2.4000000000000000e+01 5.5082500457763672e+01 -1.6625000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 -1.7082498550415039e+01 2.4000000000000000e+01 5.2917499542236328e+01 -1.6625000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 -1.3375000000000000e+01 2.4000000000000000e+01 5.2750000000000000e+01 -1.6000000000000000e+01 2.4000000000000000e+01 5.2917499542236328e+01 -1.5375000000000000e+01 2.4000000000000000e+01 5.3375000000000000e+01 -1.4917500495910645e+01 2.4000000000000000e+01 5.4000000000000000e+01 -1.4750000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -5.7000000000000000e+01 2.4000000000000000e+01 6.8000000000000000e+01 -4.4558998107910156e+01 2.4000000000000000e+01 8.6086700439453125e+01 -4.7683998107910156e+01 2.4000000000000000e+01 8.6684005737304688e+01 -4.7086700439453125e+01 2.4000000000000000e+01 8.7500000000000000e+01 -4.6868000030517578e+01 2.4000000000000000e+01 8.8316001892089844e+01 -4.7086700439453125e+01 2.4000000000000000e+01 8.8913299560546875e+01 -4.9316001892089844e+01 2.4000000000000000e+01 8.8316001892089844e+01 -4.9913299560546875e+01 2.4000000000000000e+01 8.7500000000000000e+01 -5.0131999969482422e+01 2.4000000000000000e+01 8.6684005737304688e+01 -4.9913299560546875e+01 2.4000000000000000e+01 8.6086700439453125e+01 -4.9316001892089844e+01 2.4000000000000000e+01 8.5868003845214844e+01 -4.8500000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 -4.4558998107910156e+01 2.4000000000000000e+01 7.2750000000000000e+01 -5.7000000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 -4.4558998107910156e+01 2.4000000000000000e+01 6.3690998077392578e+01 -4.2125000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 -3.7875000000000000e+01 2.4000000000000000e+01 5.9000000000000000e+01 -4.6868000030517578e+01 2.4000000000000000e+01 5.9815998077392578e+01 -4.7086700439453125e+01 2.4000000000000000e+01 6.0413299560546875e+01 -4.7683998107910156e+01 2.4000000000000000e+01 6.0631999969482422e+01 -4.8500000000000000e+01 2.4000000000000000e+01 6.0413299560546875e+01 -4.9316001892089844e+01 2.4000000000000000e+01 5.9815998077392578e+01 -4.9913299560546875e+01 2.4000000000000000e+01 5.0000000000000000e+01 -4.4558998107910156e+01 2.4000000000000000e+01 5.7586700439453125e+01 -4.7683998107910156e+01 2.4000000000000000e+01 5.8184001922607422e+01 -4.7086700439453125e+01 2.4000000000000000e+01 5.9000000000000000e+01 -5.0131999969482422e+01 2.4000000000000000e+01 5.8184001922607422e+01 -4.9913299560546875e+01 2.4000000000000000e+01 5.7586700439453125e+01 -4.9316001892089844e+01 2.4000000000000000e+01 5.7368000030517578e+01 -4.8500000000000000e+01 2.4000000000000000e+01 7.9250000000000000e+01 -7.7133995056152344e+01 2.4000000000000000e+01 7.9750000000000000e+01 -7.7000000000000000e+01 2.4000000000000000e+01 8.0250000000000000e+01 -7.7133995056152344e+01 2.4000000000000000e+01 8.0615997314453125e+01 -7.7500000000000000e+01 2.4000000000000000e+01 8.0750000000000000e+01 -7.8000000000000000e+01 2.4000000000000000e+01 8.4867996215820312e+01 -8.9684005737304688e+01 2.4000000000000000e+01 8.0750000000000000e+01 -8.2000000000000000e+01 2.4000000000000000e+01 8.0615997314453125e+01 -8.2500000000000000e+01 2.4000000000000000e+01 8.0250000000000000e+01 -8.2865997314453125e+01 2.4000000000000000e+01 7.9750000000000000e+01 -8.3000000000000000e+01 2.4000000000000000e+01 7.7500000000000000e+01 -8.9684005737304688e+01 2.4000000000000000e+01 7.9250000000000000e+01 -8.2865997314453125e+01 2.4000000000000000e+01 7.8883995056152344e+01 -8.2500000000000000e+01 2.4000000000000000e+01 7.8750000000000000e+01 -8.2000000000000000e+01 2.4000000000000000e+01 7.8750000000000000e+01 -7.8000000000000000e+01 2.4000000000000000e+01 7.8883995056152344e+01 -7.7500000000000000e+01 2.4000000000000000e+01 7.2750000000000000e+01 -7.2066001892089844e+01 2.4000000000000000e+01 7.2750000000000000e+01 -8.9684005737304688e+01 2.4000000000000000e+01 6.8000000000000000e+01 -8.9684005737304688e+01 2.4000000000000000e+01 6.8000000000000000e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.6615997314453125e+01 -8.2500000000000000e+01 2.4000000000000000e+01 6.6250000000000000e+01 -8.2865997314453125e+01 2.4000000000000000e+01 6.6250000000000000e+01 -7.7133995056152344e+01 2.4000000000000000e+01 6.6750000000000000e+01 -8.2000000000000000e+01 2.4000000000000000e+01 6.3690998077392578e+01 -8.9684005737304688e+01 2.4000000000000000e+01 6.4884002685546875e+01 -8.2500000000000000e+01 2.4000000000000000e+01 6.4750000000000000e+01 -8.2000000000000000e+01 2.4000000000000000e+01 6.5750000000000000e+01 -8.3000000000000000e+01 2.4000000000000000e+01 6.5250000000000000e+01 -8.2865997314453125e+01 2.4000000000000000e+01 6.5250000000000000e+01 -7.7133995056152344e+01 2.4000000000000000e+01 6.5750000000000000e+01 -7.7000000000000000e+01 2.4000000000000000e+01 6.4750000000000000e+01 -7.8000000000000000e+01 2.4000000000000000e+01 6.4884002685546875e+01 -7.7500000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 -8.9684005737304688e+01 2.4000000000000000e+01 8.7500000000000000e+01 -9.6367996215820312e+01 2.4000000000000000e+01 9.5500000000000000e+01 -8.9684005737304688e+01 2.4000000000000000e+01 8.8316001892089844e+01 -9.6586700439453125e+01 2.4000000000000000e+01 8.8913299560546875e+01 -9.7184005737304688e+01 2.4000000000000000e+01 9.5500000000000000e+01 -1.0081599426269531e+02 2.4000000000000000e+01 8.9132003784179688e+01 -9.8000000000000000e+01 2.4000000000000000e+01 8.8913299560546875e+01 -9.8816001892089844e+01 2.4000000000000000e+01 8.5868003845214844e+01 -9.8000000000000000e+01 2.4000000000000000e+01 8.6086700439453125e+01 -9.7184005737304688e+01 2.4000000000000000e+01 8.6684005737304688e+01 -9.6586700439453125e+01 2.4000000000000000e+01 8.8316001892089844e+01 -9.9413299560546875e+01 2.4000000000000000e+01 8.7500000000000000e+01 -9.9632003784179688e+01 2.4000000000000000e+01 8.6684005737304688e+01 -9.9413299560546875e+01 2.4000000000000000e+01 8.6086700439453125e+01 -9.8816001892089844e+01 2.4000000000000000e+01 7.7500000000000000e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.1631999969482422e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.3690998077392578e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.0631999969482422e+01 -9.8000000000000000e+01 2.4000000000000000e+01 6.0413299560546875e+01 -9.8816001892089844e+01 2.4000000000000000e+01 5.7586700439453125e+01 -9.8816001892089844e+01 2.4000000000000000e+01 5.7368000030517578e+01 -9.8000000000000000e+01 2.4000000000000000e+01 5.0000000000000000e+01 -1.0081599426269531e+02 2.4000000000000000e+01 5.9815998077392578e+01 -9.6586700439453125e+01 2.4000000000000000e+01 6.0413299560546875e+01 -9.7184005737304688e+01 2.4000000000000000e+01 5.7586700439453125e+01 -9.7184005737304688e+01 2.4000000000000000e+01 5.8184001922607422e+01 -9.6586700439453125e+01 2.4000000000000000e+01 5.9000000000000000e+01 -9.6367996215820312e+01 2.4000000000000000e+01 5.9815998077392578e+01 -9.9413299560546875e+01 2.4000000000000000e+01 5.9000000000000000e+01 -9.9632003784179688e+01 2.4000000000000000e+01 5.8184001922607422e+01 -9.9413299560546875e+01 2.4000000000000000e+01 8.4867996215820312e+01 -1.1492499542236328e+02 2.4000000000000000e+01 9.5500000000000000e+01 -1.1492499542236328e+02 2.4000000000000000e+01 7.9250000000000000e+01 -1.0213399505615234e+02 2.4000000000000000e+01 7.9750000000000000e+01 -1.0200000000000000e+02 2.4000000000000000e+01 8.0750000000000000e+01 -1.0700000000000000e+02 2.4000000000000000e+01 8.0250000000000000e+01 -1.0213399505615234e+02 2.4000000000000000e+01 7.7500000000000000e+01 -1.1492499542236328e+02 2.4000000000000000e+01 7.9250000000000000e+01 -1.0786599731445312e+02 2.4000000000000000e+01 7.8883995056152344e+01 -1.0750000000000000e+02 2.4000000000000000e+01 8.0615997314453125e+01 -1.0750000000000000e+02 2.4000000000000000e+01 8.0250000000000000e+01 -1.0786599731445312e+02 2.4000000000000000e+01 7.9750000000000000e+01 -1.0800000000000000e+02 2.4000000000000000e+01 7.8750000000000000e+01 -1.0700000000000000e+02 2.4000000000000000e+01 7.8750000000000000e+01 -1.0300000000000000e+02 2.4000000000000000e+01 7.8883995056152344e+01 -1.0250000000000000e+02 2.4000000000000000e+01 7.2750000000000000e+01 -1.1492499542236328e+02 2.4000000000000000e+01 7.2750000000000000e+01 -1.0081599426269531e+02 2.4000000000000000e+01 6.8000000000000000e+01 -1.1492499542236328e+02 2.4000000000000000e+01 6.5250000000000000e+01 -1.0213399505615234e+02 2.4000000000000000e+01 6.5750000000000000e+01 -1.0200000000000000e+02 2.4000000000000000e+01 6.6250000000000000e+01 -1.0213399505615234e+02 2.4000000000000000e+01 6.6615997314453125e+01 -1.0250000000000000e+02 2.4000000000000000e+01 6.6750000000000000e+01 -1.0300000000000000e+02 2.4000000000000000e+01 6.6750000000000000e+01 -1.0700000000000000e+02 2.4000000000000000e+01 6.3690998077392578e+01 -1.1492499542236328e+02 2.4000000000000000e+01 6.5250000000000000e+01 -1.0786599731445312e+02 2.4000000000000000e+01 6.4884002685546875e+01 -1.0750000000000000e+02 2.4000000000000000e+01 6.6615997314453125e+01 -1.0750000000000000e+02 2.4000000000000000e+01 6.6250000000000000e+01 -1.0786599731445312e+02 2.4000000000000000e+01 6.5750000000000000e+01 -1.0800000000000000e+02 2.4000000000000000e+01 6.4750000000000000e+01 -1.0700000000000000e+02 2.4000000000000000e+01 6.4750000000000000e+01 -1.0300000000000000e+02 2.4000000000000000e+01 6.4884002685546875e+01 -1.0250000000000000e+02 2.4000000000000000e+01 5.0000000000000000e+01 -1.1492499542236328e+02 2.4000000000000000e+01 6.1631999969482422e+01 -1.1492499542236328e+02 2.4000000000000000e+01 5.7368000030517578e+01 -9.8000000000000000e+01 2.2409799575805664e+01 5.7586700439453125e+01 -9.7184005737304688e+01 2.2409799575805664e+01 5.8184001922607422e+01 -9.6586700439453125e+01 2.2409799575805664e+01 5.9000000000000000e+01 -9.6367996215820312e+01 2.2409799575805664e+01 5.9815998077392578e+01 -9.6586700439453125e+01 2.2409799575805664e+01 6.0413299560546875e+01 -9.7184005737304688e+01 2.2409799575805664e+01 6.0631999969482422e+01 -9.8000000000000000e+01 2.2409799575805664e+01 6.0413299560546875e+01 -9.8816001892089844e+01 2.2409799575805664e+01 5.9815998077392578e+01 -9.9413299560546875e+01 2.2409799575805664e+01 5.9000000000000000e+01 -9.9632003784179688e+01 2.2409799575805664e+01 5.8184001922607422e+01 -9.9413299560546875e+01 2.2409799575805664e+01 5.7586700439453125e+01 -9.8816001892089844e+01 2.2409799575805664e+01 5.7368000030517578e+01 -4.8500000000000000e+01 2.2409799575805664e+01 5.7586700439453125e+01 -4.7683998107910156e+01 2.2409799575805664e+01 5.8184001922607422e+01 -4.7086700439453125e+01 2.2409799575805664e+01 5.9000000000000000e+01 -4.6868000030517578e+01 2.2409799575805664e+01 5.9815998077392578e+01 -4.7086700439453125e+01 2.2409799575805664e+01 6.0413299560546875e+01 -4.7683998107910156e+01 2.2409799575805664e+01 6.0631999969482422e+01 -4.8500000000000000e+01 2.2409799575805664e+01 6.0413299560546875e+01 -4.9316001892089844e+01 2.2409799575805664e+01 5.9815998077392578e+01 -4.9913299560546875e+01 2.2409799575805664e+01 5.9000000000000000e+01 -5.0131999969482422e+01 2.2409799575805664e+01 5.8184001922607422e+01 -4.9913299560546875e+01 2.2409799575805664e+01 5.7586700439453125e+01 -4.9316001892089844e+01 2.2409799575805664e+01 8.5500000000000000e+01 -6.7132003784179688e+01 2.2409799575805664e+01 8.6315994262695312e+01 -6.6913299560546875e+01 2.2409799575805664e+01 8.6913299560546875e+01 -6.6316001892089844e+01 2.2409799575805664e+01 8.7131996154785156e+01 -6.5500000000000000e+01 2.2409799575805664e+01 8.6913299560546875e+01 -6.4684005737304688e+01 2.2409799575805664e+01 8.6315994262695312e+01 -6.4086700439453125e+01 2.2409799575805664e+01 8.5500000000000000e+01 -6.3868099212646484e+01 2.2409799575805664e+01 8.4683998107910156e+01 -6.4086700439453125e+01 2.2409799575805664e+01 8.4086700439453125e+01 -6.4684005737304688e+01 2.2409799575805664e+01 8.3867996215820312e+01 -6.5500000000000000e+01 2.2409799575805664e+01 8.4086700439453125e+01 -6.6316001892089844e+01 2.2409799575805664e+01 8.4683998107910156e+01 -6.6913299560546875e+01 2.2409799575805664e+01 8.5500000000000000e+01 6.3868099212646484e+01 2.2409799575805664e+01 8.6315994262695312e+01 6.4086700439453125e+01 2.2409799575805664e+01 8.6913299560546875e+01 6.4684005737304688e+01 2.2409799575805664e+01 8.7131996154785156e+01 6.5500000000000000e+01 2.2409799575805664e+01 8.6913299560546875e+01 6.6316001892089844e+01 2.2409799575805664e+01 8.6315994262695312e+01 6.6913299560546875e+01 2.2409799575805664e+01 8.5500000000000000e+01 6.7132003784179688e+01 2.2409799575805664e+01 8.4683998107910156e+01 6.6913299560546875e+01 2.2409799575805664e+01 8.4086700439453125e+01 6.6316001892089844e+01 2.2409799575805664e+01 8.3867996215820312e+01 6.5500000000000000e+01 2.2409799575805664e+01 8.4086700439453125e+01 6.4684005737304688e+01 2.2409799575805664e+01 8.4683998107910156e+01 6.4086700439453125e+01 2.2409799575805664e+01 5.7368000030517578e+01 4.8500000000000000e+01 2.2409799575805664e+01 5.7586700439453125e+01 4.9316001892089844e+01 2.2409799575805664e+01 5.8184001922607422e+01 4.9913299560546875e+01 2.2409799575805664e+01 5.9000000000000000e+01 5.0131999969482422e+01 2.2409799575805664e+01 5.9815998077392578e+01 4.9913299560546875e+01 2.2409799575805664e+01 6.0413299560546875e+01 4.9316001892089844e+01 2.2409799575805664e+01 6.0631999969482422e+01 4.8500000000000000e+01 2.2409799575805664e+01 6.0413299560546875e+01 4.7683998107910156e+01 2.2409799575805664e+01 5.9815998077392578e+01 4.7086700439453125e+01 2.2409799575805664e+01 5.9000000000000000e+01 4.6868000030517578e+01 2.2409799575805664e+01 5.8184001922607422e+01 4.7086700439453125e+01 2.2409799575805664e+01 5.7586700439453125e+01 4.7683998107910156e+01 2.2409799575805664e+01 5.7368000030517578e+01 9.8000000000000000e+01 2.2409799575805664e+01 5.7586700439453125e+01 9.8816001892089844e+01 2.2409799575805664e+01 5.8184001922607422e+01 9.9413299560546875e+01 2.2409799575805664e+01 5.9000000000000000e+01 9.9632003784179688e+01 2.2409799575805664e+01 5.9815998077392578e+01 9.9413299560546875e+01 2.2409799575805664e+01 6.0413299560546875e+01 9.8816001892089844e+01 2.2409799575805664e+01 6.0631999969482422e+01 9.8000000000000000e+01 2.2409799575805664e+01 6.0413299560546875e+01 9.7184005737304688e+01 2.2409799575805664e+01 5.9815998077392578e+01 9.6586700439453125e+01 2.2409799575805664e+01 5.9000000000000000e+01 9.6367996215820312e+01 2.2409799575805664e+01 5.8184001922607422e+01 9.6586700439453125e+01 2.2409799575805664e+01 5.7586700439453125e+01 9.7184005737304688e+01 2.2409799575805664e+01 8.5868003845214844e+01 9.8000000000000000e+01 2.2409799575805664e+01 8.6086700439453125e+01 9.8816001892089844e+01 2.2409799575805664e+01 8.6684005737304688e+01 9.9413299560546875e+01 2.2409799575805664e+01 8.7500000000000000e+01 9.9632003784179688e+01 2.2409799575805664e+01 8.8316001892089844e+01 9.9413299560546875e+01 2.2409799575805664e+01 8.8913299560546875e+01 9.8816001892089844e+01 2.2409799575805664e+01 8.9132003784179688e+01 9.8000000000000000e+01 2.2409799575805664e+01 8.8913299560546875e+01 9.7184005737304688e+01 2.2409799575805664e+01 8.8316001892089844e+01 9.6586700439453125e+01 2.2409799575805664e+01 8.7500000000000000e+01 9.6367996215820312e+01 2.2409799575805664e+01 8.6684005737304688e+01 9.6586700439453125e+01 2.2409799575805664e+01 8.6086700439453125e+01 9.7184005737304688e+01 2.2409799575805664e+01 8.5868003845214844e+01 4.8500000000000000e+01 2.2409799575805664e+01 8.6086700439453125e+01 4.9316001892089844e+01 2.2409799575805664e+01 8.6684005737304688e+01 4.9913299560546875e+01 2.2409799575805664e+01 8.7500000000000000e+01 5.0131999969482422e+01 2.2409799575805664e+01 8.8316001892089844e+01 4.9913299560546875e+01 2.2409799575805664e+01 8.8913299560546875e+01 4.9316001892089844e+01 2.2409799575805664e+01 8.9132003784179688e+01 4.8500000000000000e+01 2.2409799575805664e+01 8.8913299560546875e+01 4.7683998107910156e+01 2.2409799575805664e+01 8.8316001892089844e+01 4.7086700439453125e+01 2.2409799575805664e+01 8.7500000000000000e+01 4.6868000030517578e+01 2.2409799575805664e+01 8.6684005737304688e+01 4.7086700439453125e+01 2.2409799575805664e+01 8.6086700439453125e+01 4.7683998107910156e+01 2.2409799575805664e+01 6.1815998077392578e+01 6.4086700439453125e+01 2.2409799575805664e+01 6.2413299560546875e+01 6.4684005737304688e+01 2.2409799575805664e+01 6.2632003784179688e+01 6.5500000000000000e+01 2.2409799575805664e+01 6.2413299560546875e+01 6.6316001892089844e+01 2.2409799575805664e+01 6.1815998077392578e+01 6.6913299560546875e+01 2.2409799575805664e+01 6.1000000000000000e+01 6.7132003784179688e+01 2.2409799575805664e+01 6.0183998107910156e+01 6.6913299560546875e+01 2.2409799575805664e+01 5.9586700439453125e+01 6.6316001892089844e+01 2.2409799575805664e+01 5.9368000030517578e+01 6.5500000000000000e+01 2.2409799575805664e+01 5.9586700439453125e+01 6.4684005737304688e+01 2.2409799575805664e+01 6.0183998107910156e+01 6.4086700439453125e+01 2.2409799575805664e+01 6.1000000000000000e+01 6.3868099212646484e+01 2.2409799575805664e+01 6.1815998077392578e+01 -6.6913299560546875e+01 2.2409799575805664e+01 6.2413299560546875e+01 -6.6316001892089844e+01 2.2409799575805664e+01 6.2632003784179688e+01 -6.5500000000000000e+01 2.2409799575805664e+01 6.2413299560546875e+01 -6.4684005737304688e+01 2.2409799575805664e+01 6.1815998077392578e+01 -6.4086700439453125e+01 2.2409799575805664e+01 6.1000000000000000e+01 -6.3868099212646484e+01 2.2409799575805664e+01 6.0183998107910156e+01 -6.4086700439453125e+01 2.2409799575805664e+01 5.9586700439453125e+01 -6.4684005737304688e+01 2.2409799575805664e+01 5.9368000030517578e+01 -6.5500000000000000e+01 2.2409799575805664e+01 5.9586700439453125e+01 -6.6316001892089844e+01 2.2409799575805664e+01 6.0183998107910156e+01 -6.6913299560546875e+01 2.2409799575805664e+01 6.1000000000000000e+01 -6.7132003784179688e+01 2.2409799575805664e+01 8.5868003845214844e+01 -4.8500000000000000e+01 2.2409799575805664e+01 8.6086700439453125e+01 -4.7683998107910156e+01 2.2409799575805664e+01 8.6684005737304688e+01 -4.7086700439453125e+01 2.2409799575805664e+01 8.7500000000000000e+01 -4.6868000030517578e+01 2.2409799575805664e+01 8.8316001892089844e+01 -4.7086700439453125e+01 2.2409799575805664e+01 8.8913299560546875e+01 -4.7683998107910156e+01 2.2409799575805664e+01 8.9132003784179688e+01 -4.8500000000000000e+01 2.2409799575805664e+01 8.8913299560546875e+01 -4.9316001892089844e+01 2.2409799575805664e+01 8.8316001892089844e+01 -4.9913299560546875e+01 2.2409799575805664e+01 8.7500000000000000e+01 -5.0131999969482422e+01 2.2409799575805664e+01 8.6684005737304688e+01 -4.9913299560546875e+01 2.2409799575805664e+01 8.6086700439453125e+01 -4.9316001892089844e+01 2.2409799575805664e+01 8.5868003845214844e+01 -9.8000000000000000e+01 2.2409799575805664e+01 8.6086700439453125e+01 -9.7184005737304688e+01 2.2409799575805664e+01 8.6684005737304688e+01 -9.6586700439453125e+01 2.2409799575805664e+01 8.7500000000000000e+01 -9.6367996215820312e+01 2.2409799575805664e+01 8.8316001892089844e+01 -9.6586700439453125e+01 2.2409799575805664e+01 8.8913299560546875e+01 -9.7184005737304688e+01 2.2409799575805664e+01 8.9132003784179688e+01 -9.8000000000000000e+01 2.2409799575805664e+01 8.8913299560546875e+01 -9.8816001892089844e+01 2.2409799575805664e+01 8.8316001892089844e+01 -9.9413299560546875e+01 2.2409799575805664e+01 8.7500000000000000e+01 -9.9632003784179688e+01 2.2409799575805664e+01 8.6684005737304688e+01 -9.9413299560546875e+01 2.2409799575805664e+01 8.6086700439453125e+01 -9.8816001892089844e+01 2.2409799575805664e+01 4.6145000457763672e+01 -1.0863400268554688e+02 3.1881999969482422e+01 4.7864501953125000e+01 -1.0954199981689453e+02 2.9968799591064453e+01 5.0481700897216797e+01 -1.1092499542236328e+02 2.9156599044799805e+01 4.5598297119140625e+01 -1.0834500122070312e+02 3.4155200958251953e+01 1.0109799957275391e+02 -1.3767401123046875e+02 3.4155200958251953e+01 4.5598297119140625e+01 -1.0834500122070312e+02 5.6155200958251953e+01 1.0109799957275391e+02 -1.3767401123046875e+02 5.6155200958251953e+01 5.0598300933837891e+01 -1.1098699951171875e+02 2.9155200958251953e+01 9.6098297119140625e+01 -1.3503199768066406e+02 2.9155200958251953e+01 1.0109799957275391e+02 -1.3767401123046875e+02 3.4136100769042969e+01 9.8812896728515625e+01 -1.3646600341796875e+02 2.9956300735473633e+01 1.0054199981689453e+02 -1.3738000488281250e+02 3.1863998413085938e+01 1.0055200195312500e+02 -1.3738499450683594e+02 5.8428501129150391e+01 9.8832099914550781e+01 -1.3647599792480469e+02 6.0341598510742188e+01 9.6214897155761719e+01 -1.3509300231933594e+02 6.1153800964355469e+01 9.6098297119140625e+01 -1.3503199768066406e+02 6.1155200958251953e+01 5.0598300933837891e+01 -1.1098699951171875e+02 6.1155200958251953e+01 4.5598400115966797e+01 -1.0834500122070312e+02 5.6174301147460938e+01 4.7883701324462891e+01 -1.0955200195312500e+02 6.0354099273681641e+01 4.6154201507568359e+01 -1.0863800048828125e+02 5.8446399688720703e+01 4.4000000000000000e+01 -1.0569200134277344e+02 5.6155200958251953e+01 4.4000000000000000e+01 1.0569200134277344e+02 5.6155200958251953e+01 4.4000000000000000e+01 -1.0569200134277344e+02 3.4155200958251953e+01 4.4000000000000000e+01 1.0569200134277344e+02 3.4155200958251953e+01 4.6145000457763672e+01 1.0863400268554688e+02 5.8428501129150391e+01 4.7864501953125000e+01 1.0954199981689453e+02 6.0341598510742188e+01 5.0481700897216797e+01 1.1092499542236328e+02 6.1153800964355469e+01 4.5598297119140625e+01 1.0834500122070312e+02 5.6155200958251953e+01 1.0109799957275391e+02 1.3767401123046875e+02 5.6155200958251953e+01 4.5598297119140625e+01 1.0834500122070312e+02 3.4155200958251953e+01 1.0109799957275391e+02 1.3767401123046875e+02 3.4155200958251953e+01 5.0598300933837891e+01 1.1098699951171875e+02 6.1155200958251953e+01 9.6098297119140625e+01 1.3503199768066406e+02 6.1155200958251953e+01 1.0109799957275391e+02 1.3767401123046875e+02 5.6174301147460938e+01 9.8812896728515625e+01 1.3646600341796875e+02 6.0354099273681641e+01 1.0054199981689453e+02 1.3738000488281250e+02 5.8446399688720703e+01 1.0055200195312500e+02 1.3738499450683594e+02 3.1881999969482422e+01 9.8832099914550781e+01 1.3647599792480469e+02 2.9968799591064453e+01 9.6214897155761719e+01 1.3509300231933594e+02 2.9156599044799805e+01 9.6098297119140625e+01 1.3503199768066406e+02 2.9155200958251953e+01 5.0598300933837891e+01 1.1098699951171875e+02 2.9155200958251953e+01 4.5598400115966797e+01 1.0834500122070312e+02 3.4136100769042969e+01 4.7883701324462891e+01 1.0955200195312500e+02 2.9956300735473633e+01 4.6154201507568359e+01 1.0863800048828125e+02 3.1863998413085938e+01 1.0550000000000000e+02 6.7749700546264648e+00 3.7574001312255859e+01 1.0550000000000000e+02 -3.0000000000000000e+00 4.5155200958251953e+01 1.0550000000000000e+02 -3.6415100097656250e+00 4.1723400115966797e+01 1.0550000000000000e+02 9.9001998901367188e+00 3.6017898559570312e+01 1.0550000000000000e+02 -2.1838199615478516e+01 4.3409599304199219e+01 1.0550000000000000e+02 -5.3641502380371094e+01 4.8587001800537109e+01 1.0550000000000000e+02 -2.0577098846435547e+01 4.0154098510742188e+01 1.0550000000000000e+02 -5.3000000000000000e+01 4.5155200958251953e+01 1.0550000000000000e+02 -1.8224998474121094e+01 3.7574001312255859e+01 1.0550000000000000e+02 -1.5099800109863281e+01 3.6017898559570312e+01 1.0550000000000000e+02 4.4229397773742676e+00 4.0154098510742188e+01 1.0550000000000000e+02 3.1617600917816162e+00 4.3409599304199219e+01 1.0550000000000000e+02 -3.6415100097656250e+00 4.8587001800537109e+01 1.0550000000000000e+02 3.1617600917816162e+00 4.6900802612304688e+01 1.0550000000000000e+02 2.1358499526977539e+01 4.1723400115966797e+01 1.0550000000000000e+02 1.3502099609375000e+02 3.4155200958251953e+01 1.0550000000000000e+02 2.2000000000000000e+01 4.5155200958251953e+01 1.0550000000000000e+02 1.3502099609375000e+02 5.6155200958251953e+01 1.0550000000000000e+02 2.1358499526977539e+01 4.8587001800537109e+01 1.0550000000000000e+02 1.9520599365234375e+01 3.8755100250244141e+01 1.0550000000000000e+02 1.6734498977661133e+01 3.6651100158691406e+01 1.0550000000000000e+02 1.3376500129699707e+01 3.5695701599121094e+01 1.0550000000000000e+02 -7.0577102661132812e+01 5.0156299591064453e+01 1.0550000000000000e+02 -6.8224998474121094e+01 5.2736400604248047e+01 1.0550000000000000e+02 -1.3502099609375000e+02 5.6155200958251953e+01 1.0550000000000000e+02 -2.0577098846435547e+01 5.0156299591064453e+01 1.0550000000000000e+02 -1.8224998474121094e+01 5.2736400604248047e+01 1.0550000000000000e+02 -6.1623497009277344e+01 5.4614700317382812e+01 1.0550000000000000e+02 -5.3641502380371094e+01 4.1723400115966797e+01 1.0550000000000000e+02 -5.5479400634765625e+01 3.8755100250244141e+01 1.0550000000000000e+02 -1.1623499870300293e+01 3.5695701599121094e+01 1.0550000000000000e+02 -5.8265499114990234e+01 3.6651100158691406e+01 1.0550000000000000e+02 -6.1623497009277344e+01 3.5695701599121094e+01 1.0550000000000000e+02 -6.8224998474121094e+01 3.7574001312255859e+01 1.0550000000000000e+02 -7.0577102661132812e+01 4.0154098510742188e+01 1.0550000000000000e+02 -1.3502099609375000e+02 3.4155200958251953e+01 1.0550000000000000e+02 -7.1838203430175781e+01 4.3409599304199219e+01 1.0550000000000000e+02 -7.1838203430175781e+01 4.6900802612304688e+01 1.0550000000000000e+02 -2.1838199615478516e+01 4.6900802612304688e+01 1.0550000000000000e+02 -5.8265499114990234e+01 5.3659301757812500e+01 1.0550000000000000e+02 -5.5479400634765625e+01 5.1555297851562500e+01 1.0550000000000000e+02 -1.5099800109863281e+01 5.4292499542236328e+01 1.0550000000000000e+02 -1.1623499870300293e+01 5.4614700317382812e+01 1.0550000000000000e+02 -5.4794201850891113e+00 3.8755100250244141e+01 1.0550000000000000e+02 -8.2654895782470703e+00 3.6651100158691406e+01 1.0550000000000000e+02 -6.5099800109863281e+01 3.6017898559570312e+01 1.0550000000000000e+02 -6.5099800109863281e+01 5.4292499542236328e+01 1.0550000000000000e+02 1.3376500129699707e+01 5.4614700317382812e+01 1.0550000000000000e+02 1.6734498977661133e+01 5.3659301757812500e+01 1.0550000000000000e+02 1.9520599365234375e+01 5.1555297851562500e+01 1.0550000000000000e+02 4.4229397773742676e+00 5.0156299591064453e+01 1.0550000000000000e+02 6.7749700546264648e+00 5.2736400604248047e+01 1.0550000000000000e+02 -5.4794201850891113e+00 5.1555297851562500e+01 1.0550000000000000e+02 9.9001998901367188e+00 5.4292499542236328e+01 1.0550000000000000e+02 -8.2654895782470703e+00 5.3659301757812500e+01 8.6110595703125000e+01 1.0040599822998047e+02 2.6155199050903320e+01 8.5093498229980469e+01 9.9389396667480469e+01 2.6155199050903320e+01 7.4250000000000000e+01 1.2009300231933594e+02 2.6155199050903320e+01 7.4250000000000000e+01 8.1750000000000000e+01 2.6155199050903320e+01 5.5110599517822266e+01 8.1750000000000000e+01 2.6155199050903320e+01 9.7500000000000000e+01 8.1750000000000000e+01 2.6155199050903320e+01 8.7500000000000000e+01 9.5221199035644531e+01 2.6155199050903320e+01 8.8889396667480469e+01 9.5593498229980469e+01 2.6155199050903320e+01 8.7500000000000000e+01 1.0077899932861328e+02 2.6155199050903320e+01 9.7500000000000000e+01 1.3237899780273438e+02 2.6155199050903320e+01 8.8889396667480469e+01 1.0040599822998047e+02 2.6155199050903320e+01 8.4721199035644531e+01 9.8000000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 9.6610595703125000e+01 2.6155199050903320e+01 8.6110595703125000e+01 9.5593498229980469e+01 2.6155199050903320e+01 8.9906501770019531e+01 9.6610595703125000e+01 2.6155199050903320e+01 9.0278793334960938e+01 9.8000000000000000e+01 2.6155199050903320e+01 8.9906501770019531e+01 9.9389396667480469e+01 2.6155199050903320e+01 5.2000000000000000e+01 8.1750000000000000e+01 2.6155199050903320e+01 5.2000000000000000e+01 1.0833500671386719e+02 2.6155199050903320e+01 5.5110599517822266e+01 1.0997799682617188e+02 2.6155199050903320e+01 6.7601097106933594e+01 -1.1657900238037109e+02 2.6155199050903320e+01 5.5110599517822266e+01 -1.0997799682617188e+02 2.6155199050903320e+01 5.5110599517822266e+01 -8.1750000000000000e+01 2.6155199050903320e+01 5.2000000000000000e+01 -1.0833500671386719e+02 2.6155199050903320e+01 8.7500000000000000e+01 -9.5221199035644531e+01 2.6155199050903320e+01 8.6110595703125000e+01 -9.5593498229980469e+01 2.6155199050903320e+01 7.4250000000000000e+01 -8.1750000000000000e+01 2.6155199050903320e+01 7.4250000000000000e+01 -1.1657900238037109e+02 2.6155199050903320e+01 8.6110595703125000e+01 -1.0040599822998047e+02 2.6155199050903320e+01 9.7500000000000000e+01 -1.1657900238037109e+02 2.6155199050903320e+01 8.7500000000000000e+01 -1.0077899932861328e+02 2.6155199050903320e+01 8.9906501770019531e+01 -9.6610595703125000e+01 2.6155199050903320e+01 8.8889396667480469e+01 -9.5593498229980469e+01 2.6155199050903320e+01 9.7500000000000000e+01 -8.1750000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 -9.6610595703125000e+01 2.6155199050903320e+01 8.4721199035644531e+01 -9.8000000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 -9.9389396667480469e+01 2.6155199050903320e+01 8.8889396667480469e+01 -1.0040599822998047e+02 2.6155199050903320e+01 8.9906501770019531e+01 -9.9389396667480469e+01 2.6155199050903320e+01 9.0278793334960938e+01 -9.8000000000000000e+01 2.6155199050903320e+01 6.3406497955322266e+01 -6.4110595703125000e+01 2.6155199050903320e+01 6.2389400482177734e+01 -6.3093498229980469e+01 2.6155199050903320e+01 7.4250000000000000e+01 -5.7000000000000000e+01 2.6155199050903320e+01 6.1000000000000000e+01 -6.2721199035644531e+01 2.6155199050903320e+01 5.9610603332519531e+01 -6.3093498229980469e+01 2.6155199050903320e+01 5.5110599517822266e+01 -5.7000000000000000e+01 2.6155199050903320e+01 5.8593502044677734e+01 -6.4110595703125000e+01 2.6155199050903320e+01 5.8221199035644531e+01 -6.5500000000000000e+01 2.6155199050903320e+01 5.8593502044677734e+01 -6.6889396667480469e+01 2.6155199050903320e+01 5.9610603332519531e+01 -6.7906501770019531e+01 2.6155199050903320e+01 6.1000000000000000e+01 -6.8278793334960938e+01 2.6155199050903320e+01 7.4250000000000000e+01 -1.2009300231933594e+02 2.6155199050903320e+01 9.7500000000000000e+01 -1.3237899780273438e+02 2.6155199050903320e+01 6.2389400482177734e+01 -6.7906501770019531e+01 2.6155199050903320e+01 6.3406497955322266e+01 -6.6889396667480469e+01 2.6155199050903320e+01 6.3778800964355469e+01 -6.5500000000000000e+01 2.6155199050903320e+01 8.7500000000000000e+01 -4.5721199035644531e+01 2.6155199050903320e+01 8.6110595703125000e+01 -4.6093502044677734e+01 2.6155199050903320e+01 7.4250000000000000e+01 6.6452199577976372e-15 2.6155199050903320e+01 8.7500000000000000e+01 -5.1278800964355469e+01 2.6155199050903320e+01 8.8889396667480469e+01 -5.0906501770019531e+01 2.6155199050903320e+01 9.7500000000000000e+01 -5.7000000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 -4.7110599517822266e+01 2.6155199050903320e+01 8.4721199035644531e+01 -4.8500000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 -4.9889400482177734e+01 2.6155199050903320e+01 8.6110595703125000e+01 -5.0906501770019531e+01 2.6155199050903320e+01 9.7500000000000000e+01 6.6452199577976372e-15 2.6155199050903320e+01 8.8889396667480469e+01 -4.6093502044677734e+01 2.6155199050903320e+01 8.9906501770019531e+01 -4.9889400482177734e+01 2.6155199050903320e+01 9.0278793334960938e+01 -4.8500000000000000e+01 2.6155199050903320e+01 8.9906501770019531e+01 -4.7110599517822266e+01 2.6155199050903320e+01 8.9906501770019531e+01 4.9889400482177734e+01 2.6155199050903320e+01 8.8889396667480469e+01 5.0906501770019531e+01 2.6155199050903320e+01 9.7500000000000000e+01 5.7000000000000000e+01 2.6155199050903320e+01 8.7500000000000000e+01 5.1278800964355469e+01 2.6155199050903320e+01 8.6110595703125000e+01 5.0906501770019531e+01 2.6155199050903320e+01 7.4250000000000000e+01 5.7000000000000000e+01 2.6155199050903320e+01 8.6110595703125000e+01 4.6093502044677734e+01 2.6155199050903320e+01 8.7500000000000000e+01 4.5721199035644531e+01 2.6155199050903320e+01 8.8889396667480469e+01 4.6093502044677734e+01 2.6155199050903320e+01 8.9906501770019531e+01 4.7110599517822266e+01 2.6155199050903320e+01 9.0278793334960938e+01 4.8500000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 4.9889400482177734e+01 2.6155199050903320e+01 8.4721199035644531e+01 4.8500000000000000e+01 2.6155199050903320e+01 8.5093498229980469e+01 4.7110599517822266e+01 2.6155199050903320e+01 5.8221199035644531e+01 6.5500000000000000e+01 2.6155199050903320e+01 5.8593502044677734e+01 6.4110595703125000e+01 2.6155199050903320e+01 5.5110599517822266e+01 5.7000000000000000e+01 2.6155199050903320e+01 5.9610603332519531e+01 6.3093498229980469e+01 2.6155199050903320e+01 6.1000000000000000e+01 6.2721199035644531e+01 2.6155199050903320e+01 5.5110599517822266e+01 6.6452199577976372e-15 2.6155199050903320e+01 5.8593502044677734e+01 6.6889396667480469e+01 2.6155199050903320e+01 5.9610603332519531e+01 6.7906501770019531e+01 2.6155199050903320e+01 6.2389400482177734e+01 6.3093498229980469e+01 2.6155199050903320e+01 6.3406497955322266e+01 6.4110595703125000e+01 2.6155199050903320e+01 6.3778800964355469e+01 6.5500000000000000e+01 2.6155199050903320e+01 6.3406497955322266e+01 6.6889396667480469e+01 2.6155199050903320e+01 6.2389400482177734e+01 6.7906501770019531e+01 2.6155199050903320e+01 6.1000000000000000e+01 6.8278793334960938e+01 2.6155199050903320e+01 5.2000000000000000e+01 -8.1750000000000000e+01 2.6155199050903320e+01 5.2000000000000000e+01 -5.7000000000000000e+01 2.6155199050903320e+01 5.2000000000000000e+01 6.6452199577976372e-15 2.6155199050903320e+01 5.2000000000000000e+01 5.7000000000000000e+01 2.6155199050903320e+01 9.7500000000000000e+01 -1.3237899780273438e+02 6.4155197143554688e+01 9.7500000000000000e+01 1.3237899780273438e+02 6.4155197143554688e+01 5.2000000000000000e+01 -1.0833500671386719e+02 6.4155197143554688e+01 5.2000000000000000e+01 1.0833500671386719e+02 6.4155197143554688e+01 4.4889400482177734e+01 1.0598600006103516e+02 3.0489200592041016e+01 4.5138099670410156e+01 1.0606800079345703e+02 3.0214900970458984e+01 4.5143299102783203e+01 -1.0606999969482422e+02 3.0219100952148438e+01 4.7656600952148438e+01 1.0690000152587891e+02 2.7437000274658203e+01 4.8030200958251953e+01 1.0702300262451172e+02 2.7326700210571289e+01 4.8032897949218750e+01 -1.0702400207519531e+02 2.7330598831176758e+01 5.1813499450683594e+01 -1.0827300262451172e+02 2.6157400131225586e+01 4.7625900268554688e+01 -1.0688999938964844e+02 2.7456899642944336e+01 4.4874599456787109e+01 -1.0598100280761719e+02 3.0517999649047852e+01 4.4000099182128906e+01 1.0569200134277344e+02 3.4124603271484375e+01 4.4000099182128906e+01 -1.0569200134277344e+02 5.6185802459716797e+01 4.5143299102783203e+01 1.0606999969482422e+02 6.0091300964355469e+01 4.4874599456787109e+01 1.0598100280761719e+02 5.9792400360107422e+01 4.4889400482177734e+01 -1.0598600006103516e+02 5.9821201324462891e+01 4.5138099670410156e+01 -1.0606800079345703e+02 6.0095500946044922e+01 4.7625900268554688e+01 1.0688999938964844e+02 6.2853500366210938e+01 4.8032897949218750e+01 1.0702400207519531e+02 6.2979801177978516e+01 4.8030200958251953e+01 -1.0702300262451172e+02 6.2983699798583984e+01 4.7656600952148438e+01 -1.0690000152587891e+02 6.2873401641845703e+01 5.1813499450683594e+01 1.0827300262451172e+02 6.4152999877929688e+01 1.0147000122070312e+02 -1.3369000244140625e+02 2.7326700210571289e+01 1.0146699523925781e+02 1.3368899536132812e+02 2.7330598831176758e+01 1.0184300231933594e+02 -1.3381401062011719e+02 2.7437000274658203e+01 1.0187400054931641e+02 1.3382400512695312e+02 2.7456899642944336e+01 1.0436200714111328e+02 -1.3464599609375000e+02 3.0214900970458984e+01 1.0435699462890625e+02 1.3464399719238281e+02 3.0219100952148438e+01 1.0461100006103516e+02 -1.3472799682617188e+02 3.0489200592041016e+01 1.0462500000000000e+02 1.3473300170898438e+02 3.0517999649047852e+01 1.0550000000000000e+02 -1.3502099609375000e+02 3.4124603271484375e+01 9.7686500549316406e+01 1.3244099426269531e+02 2.6157400131225586e+01 1.0550000000000000e+02 1.3502099609375000e+02 5.6185802459716797e+01 1.0462500000000000e+02 -1.3473300170898438e+02 5.9792400360107422e+01 1.0461100006103516e+02 1.3472799682617188e+02 5.9821201324462891e+01 1.0435699462890625e+02 -1.3464399719238281e+02 6.0091300964355469e+01 1.0436200714111328e+02 1.3464599609375000e+02 6.0095500946044922e+01 1.0187400054931641e+02 -1.3382400512695312e+02 6.2853500366210938e+01 1.0184300231933594e+02 1.3381401062011719e+02 6.2873401641845703e+01 1.0146699523925781e+02 -1.3368899536132812e+02 6.2979801177978516e+01 1.0147000122070312e+02 1.3369000244140625e+02 6.2983699798583984e+01 9.7686500549316406e+01 -1.3244099426269531e+02 6.4152999877929688e+01 1.0040100097656250e+02 -1.3598500061035156e+02 2.7894201278686523e+01 1.0122600555419922e+02 -1.3502299499511719e+02 2.7403900146484375e+01 1.0412899780273438e+02 -1.3612500000000000e+02 3.0356601715087891e+01 1.0258399963378906e+02 -1.3801998901367188e+02 3.4155200958251953e+01 1.0511199951171875e+02 -1.3649700927734375e+02 3.4155200958251953e+01 1.0511199951171875e+02 -1.3649700927734375e+02 3.4123100280761719e+01 1.0311399841308594e+02 -1.3718000793457031e+02 3.0592700958251953e+01 1.0404799652099609e+02 -1.3759100341796875e+02 3.4125000000000000e+01 1.0404799652099609e+02 -1.3759100341796875e+02 3.4155200958251953e+01 9.9537300109863281e+01 -1.3650099182128906e+02 2.8807399749755859e+01 1.0181199645996094e+02 -1.3763600158691406e+02 3.1139801025390625e+01 1.0258399963378906e+02 -1.3801998901367188e+02 3.4129699707031250e+01 9.6205001831054688e+01 -1.3483000183105469e+02 2.8007099151611328e+01 9.6306007385253906e+01 -1.3463899230957031e+02 2.7683698654174805e+01 9.6963600158691406e+01 -1.3339399719238281e+02 2.6383598327636719e+01 9.6812500000000000e+01 -1.3368000793457031e+02 2.6599699020385742e+01 9.6508895874023438e+01 -1.3425500488281250e+02 2.7033901214599609e+01 1.0511199951171875e+02 -1.3649700927734375e+02 5.6155200958251953e+01 1.0404799652099609e+02 -1.3759100341796875e+02 5.6155200958251953e+01 1.0258399963378906e+02 -1.3801998901367188e+02 5.6155200958251953e+01 5.0786098480224609e+01 -1.1063200378417969e+02 2.7655199050903320e+01 5.1299198150634766e+01 -1.0966099548339844e+02 2.6557098388671875e+01 1.0125699615478516e+02 -1.3503498840332031e+02 6.2888504028320312e+01 9.7141494750976562e+01 -1.3346299743652344e+02 6.3934200286865234e+01 9.6205001831054688e+01 -1.3483000183105469e+02 6.2303302764892578e+01 9.6344100952148438e+01 -1.3490000915527344e+02 6.2309200286865234e+01 9.6306007385253906e+01 -1.3463899230957031e+02 6.2626697540283203e+01 9.6669700622558594e+01 -1.3432699584960938e+02 6.3286201477050781e+01 9.6963600158691406e+01 -1.3339399719238281e+02 6.3926799774169922e+01 9.6812500000000000e+01 -1.3368000793457031e+02 6.3710697174072266e+01 9.6508895874023438e+01 -1.3425500488281250e+02 6.3276500701904297e+01 1.0042900085449219e+02 -1.3599800109863281e+02 6.2400100708007812e+01 9.9561698913574219e+01 -1.3651300048828125e+02 6.1488700866699219e+01 1.0414600372314453e+02 -1.3613099670410156e+02 5.9924697875976562e+01 1.0312899780273438e+02 -1.3718701171875000e+02 5.9690700531005859e+01 1.0182499694824219e+02 -1.3764199829101562e+02 5.9147598266601562e+01 4.7349800109863281e+01 -1.0805200195312500e+02 2.7974599838256836e+01 5.1126598358154297e+01 -1.0959100341796875e+02 2.6569999694824219e+01 5.0639801025390625e+01 -1.1055999755859375e+02 2.7666299819946289e+01 4.7434700012207031e+01 -1.0899499511718750e+02 2.8868000030517578e+01 4.4947399139404297e+01 -1.0706500244140625e+02 3.0847400665283203e+01 4.5392101287841797e+01 -1.0799299621582031e+02 3.1324800491333008e+01 4.4193901062011719e+01 -1.0675299835205078e+02 3.4155200958251953e+01 4.4750701904296875e+01 -1.0767699432373047e+02 3.4155200958251953e+01 5.0786098480224609e+01 -1.1063200378417969e+02 6.2655204772949219e+01 5.1299198150634766e+01 -1.0966099548339844e+02 6.3753299713134766e+01 4.4750701904296875e+01 -1.0767699432373047e+02 5.6155200958251953e+01 4.4193901062011719e+01 -1.0675299835205078e+02 5.6155200958251953e+01 4.7376899719238281e+01 -1.0806299591064453e+02 6.2355201721191406e+01 4.4960201263427734e+01 -1.0706999969482422e+02 5.9489398956298828e+01 4.4194000244140625e+01 -1.0675299835205078e+02 5.6182899475097656e+01 4.4750797271728516e+01 -1.0767699432373047e+02 5.6178901672363281e+01 4.5402900695800781e+01 -1.0799800109863281e+02 5.9008201599121094e+01 4.7457698822021484e+01 -1.0900700378417969e+02 6.1458999633789062e+01 4.7349800109863281e+01 1.0805200195312500e+02 6.2335800170898438e+01 5.1126598358154297e+01 1.0959100341796875e+02 6.3740402221679688e+01 5.1299198150634766e+01 1.0966099548339844e+02 6.3753299713134766e+01 5.0639801025390625e+01 1.1055999755859375e+02 6.2644100189208984e+01 5.0786098480224609e+01 1.1063200378417969e+02 6.2655204772949219e+01 4.7434700012207031e+01 1.0899499511718750e+02 6.1442401885986328e+01 4.4947399139404297e+01 1.0706500244140625e+02 5.9463001251220703e+01 4.5392101287841797e+01 1.0799299621582031e+02 5.8985599517822266e+01 4.4193901062011719e+01 1.0675299835205078e+02 5.6155200958251953e+01 4.4750701904296875e+01 1.0767699432373047e+02 5.6155200958251953e+01 9.6205001831054688e+01 1.3483000183105469e+02 6.2303302764892578e+01 9.6306007385253906e+01 1.3463899230957031e+02 6.2626697540283203e+01 9.6508895874023438e+01 1.3425500488281250e+02 6.3276500701904297e+01 9.6812500000000000e+01 1.3368000793457031e+02 6.3710697174072266e+01 9.6963600158691406e+01 1.3339399719238281e+02 6.3926799774169922e+01 4.4193901062011719e+01 1.0675299835205078e+02 3.4155200958251953e+01 4.4750701904296875e+01 1.0767699432373047e+02 3.4155200958251953e+01 1.0040100097656250e+02 1.3598500061035156e+02 6.2416198730468750e+01 1.0122600555419922e+02 1.3502299499511719e+02 6.2906501770019531e+01 1.0412899780273438e+02 1.3612500000000000e+02 5.9953800201416016e+01 1.0258399963378906e+02 1.3801998901367188e+02 5.6155200958251953e+01 1.0511199951171875e+02 1.3649700927734375e+02 5.6155200958251953e+01 1.0511199951171875e+02 1.3649700927734375e+02 5.6187297821044922e+01 1.0311399841308594e+02 1.3718000793457031e+02 5.9717700958251953e+01 1.0404799652099609e+02 1.3759100341796875e+02 5.6185398101806641e+01 1.0404799652099609e+02 1.3759100341796875e+02 5.6155200958251953e+01 9.9537300109863281e+01 1.3650099182128906e+02 6.1502899169921875e+01 1.0181199645996094e+02 1.3763600158691406e+02 5.9170600891113281e+01 1.0258399963378906e+02 1.3801998901367188e+02 5.6180702209472656e+01 4.7457698822021484e+01 1.0900700378417969e+02 2.8851398468017578e+01 4.7376899719238281e+01 1.0806299591064453e+02 2.7955200195312500e+01 4.4960201263427734e+01 1.0706999969482422e+02 3.0820999145507812e+01 4.4194000244140625e+01 1.0675299835205078e+02 3.4127498626708984e+01 4.5402900695800781e+01 1.0799800109863281e+02 3.1302198410034180e+01 4.4750797271728516e+01 1.0767699432373047e+02 3.4131500244140625e+01 5.0739601135253906e+01 1.1072000122070312e+02 2.8027000427246094e+01 5.1472900390625000e+01 1.0933200073242188e+02 2.6457500457763672e+01 5.1299198150634766e+01 1.0966099548339844e+02 2.6557098388671875e+01 5.1042602539062500e+01 1.1014600372314453e+02 2.7106199264526367e+01 5.0786098480224609e+01 1.1063200378417969e+02 2.7655199050903320e+01 1.0258399963378906e+02 1.3801998901367188e+02 3.4155200958251953e+01 1.0404799652099609e+02 1.3759100341796875e+02 3.4155200958251953e+01 1.0511199951171875e+02 1.3649700927734375e+02 3.4155200958251953e+01 9.6205001831054688e+01 1.3483000183105469e+02 2.8007099151611328e+01 9.6508895874023438e+01 1.3425500488281250e+02 2.7033901214599609e+01 9.6963600158691406e+01 1.3339399719238281e+02 2.6383598327636719e+01 1.0125699615478516e+02 1.3503498840332031e+02 2.7421899795532227e+01 9.7141494750976562e+01 1.3346299743652344e+02 2.6376201629638672e+01 9.6669700622558594e+01 1.3432699584960938e+02 2.7024200439453125e+01 9.6344100952148438e+01 1.3490000915527344e+02 2.8001199722290039e+01 1.0042900085449219e+02 1.3599800109863281e+02 2.7910299301147461e+01 9.9561698913574219e+01 1.3651300048828125e+02 2.8821699142456055e+01 1.0414600372314453e+02 1.3613099670410156e+02 3.0385698318481445e+01 1.0312899780273438e+02 1.3718701171875000e+02 3.0619800567626953e+01 1.0182499694824219e+02 1.3764199829101562e+02 3.1162799835205078e+01 1.0500000000000000e+02 2.0892299652099609e+01 4.8406398773193359e+01 1.0450000000000000e+02 2.0294200897216797e+01 4.9655197143554688e+01 1.0450000000000000e+02 2.1500000000000000e+01 4.5155200958251953e+01 1.0500000000000000e+02 1.6948801040649414e+01 5.2881599426269531e+01 1.0450000000000000e+02 1.7000000000000000e+01 5.2949398040771484e+01 1.0500000000000000e+02 1.9151100158691406e+01 5.1218498229980469e+01 1.0500000000000000e+02 2.0167600631713867e+01 4.9576801300048828e+01 1.0500000000000000e+02 1.6511600494384766e+01 5.3211700439453125e+01 1.0500000000000000e+02 1.3330400466918945e+01 5.4116802215576172e+01 1.0450000000000000e+02 1.2500000000000000e+01 5.4155200958251953e+01 1.0500000000000000e+02 8.0607004165649414e+00 5.2827499389648438e+01 1.0450000000000000e+02 8.0000000000000000e+00 5.2949398040771484e+01 1.0500000000000000e+02 1.0037000656127930e+01 5.3811599731445312e+01 1.0500000000000000e+02 1.2510599136352539e+01 5.4040802001953125e+01 1.0500000000000000e+02 7.0762901306152344e+00 5.2337402343750000e+01 1.0500000000000000e+02 4.8480501174926758e+00 4.9893100738525391e+01 1.0450000000000000e+02 4.7057700157165527e+00 4.9655197143554688e+01 1.0500000000000000e+02 4.7493495941162109e+00 4.9638301849365234e+01 1.0500000000000000e+02 3.6532399654388428e+00 4.6808898925781250e+01 1.0450000000000000e+02 3.5000000000000000e+00 4.5155200958251953e+01 1.0500000000000000e+02 4.7493495941162109e+00 4.0672100067138672e+01 1.0450000000000000e+02 4.7057700157165527e+00 4.0655200958251953e+01 1.0500000000000000e+02 3.6532399654388428e+00 4.3501399993896484e+01 1.0500000000000000e+02 3.6532399654388428e+00 4.5155200958251953e+01 1.0500000000000000e+02 4.8480501174926758e+00 4.0417297363281250e+01 1.0500000000000000e+02 7.0762901306152344e+00 3.7973003387451172e+01 1.0450000000000000e+02 8.0000000000000000e+00 3.7361000061035156e+01 1.0500000000000000e+02 1.2510599136352539e+01 3.6269599914550781e+01 1.0450000000000000e+02 1.2500000000000000e+01 3.6155200958251953e+01 1.0500000000000000e+02 1.0037000656127930e+01 3.6498798370361328e+01 1.0500000000000000e+02 8.0607004165649414e+00 3.7482898712158203e+01 1.0500000000000000e+02 1.3330400466918945e+01 3.6193603515625000e+01 1.0500000000000000e+02 1.6511600494384766e+01 3.7098697662353516e+01 1.0450000000000000e+02 1.7000000000000000e+01 3.7361000061035156e+01 1.0500000000000000e+02 1.6948801040649414e+01 3.7428798675537109e+01 1.0500000000000000e+02 1.9151100158691406e+01 3.9091899871826172e+01 1.0450000000000000e+02 2.0294200897216797e+01 4.0655200958251953e+01 1.0500000000000000e+02 2.0167600631713867e+01 4.0733596801757812e+01 1.0500000000000000e+02 2.0892299652099609e+01 4.1903999328613281e+01 1.0500000000000000e+02 2.1500000000000000e+01 4.5155200958251953e+01 1.0500000000000000e+02 -4.1077499389648438e+00 4.8406398773193359e+01 1.0450000000000000e+02 -4.7057700157165527e+00 4.9655197143554688e+01 1.0450000000000000e+02 -3.5000000000000000e+00 4.5155200958251953e+01 1.0500000000000000e+02 -8.0512399673461914e+00 5.2881599426269531e+01 1.0450000000000000e+02 -8.0000000000000000e+00 5.2949398040771484e+01 1.0500000000000000e+02 -5.8489198684692383e+00 5.1218498229980469e+01 1.0500000000000000e+02 -4.8324298858642578e+00 4.9576801300048828e+01 1.0500000000000000e+02 -8.4883594512939453e+00 5.3211700439453125e+01 1.0500000000000000e+02 -1.1669600486755371e+01 5.4116802215576172e+01 1.0450000000000000e+02 -1.2500000000000000e+01 5.4155200958251953e+01 1.0500000000000000e+02 -1.6939298629760742e+01 5.2827499389648438e+01 1.0450000000000000e+02 -1.7000000000000000e+01 5.2949398040771484e+01 1.0500000000000000e+02 -1.4963000297546387e+01 5.3811599731445312e+01 1.0500000000000000e+02 -1.2489399909973145e+01 5.4040802001953125e+01 1.0500000000000000e+02 -1.7923700332641602e+01 5.2337402343750000e+01 1.0500000000000000e+02 -2.0152000427246094e+01 4.9893100738525391e+01 1.0450000000000000e+02 -2.0294200897216797e+01 4.9655197143554688e+01 1.0500000000000000e+02 -2.0250699996948242e+01 4.9638301849365234e+01 1.0500000000000000e+02 -2.1346799850463867e+01 4.6808898925781250e+01 1.0450000000000000e+02 -2.1500000000000000e+01 4.5155200958251953e+01 1.0500000000000000e+02 -2.0250699996948242e+01 4.0672100067138672e+01 1.0450000000000000e+02 -2.0294200897216797e+01 4.0655200958251953e+01 1.0500000000000000e+02 -2.1346799850463867e+01 4.3501399993896484e+01 1.0500000000000000e+02 -2.1346799850463867e+01 4.5155200958251953e+01 1.0500000000000000e+02 -2.0152000427246094e+01 4.0417297363281250e+01 1.0500000000000000e+02 -1.7923700332641602e+01 3.7973003387451172e+01 1.0450000000000000e+02 -1.7000000000000000e+01 3.7361000061035156e+01 1.0500000000000000e+02 -1.2489399909973145e+01 3.6269599914550781e+01 1.0450000000000000e+02 -1.2500000000000000e+01 3.6155200958251953e+01 1.0500000000000000e+02 -1.4963000297546387e+01 3.6498798370361328e+01 1.0500000000000000e+02 -1.6939298629760742e+01 3.7482898712158203e+01 1.0500000000000000e+02 -1.1669600486755371e+01 3.6193603515625000e+01 1.0500000000000000e+02 -8.4883594512939453e+00 3.7098697662353516e+01 1.0450000000000000e+02 -8.0000000000000000e+00 3.7361000061035156e+01 1.0500000000000000e+02 -8.0512399673461914e+00 3.7428798675537109e+01 1.0500000000000000e+02 -5.8489198684692383e+00 3.9091899871826172e+01 1.0450000000000000e+02 -4.7057700157165527e+00 4.0655200958251953e+01 1.0500000000000000e+02 -4.8324298858642578e+00 4.0733596801757812e+01 1.0500000000000000e+02 -4.1077499389648438e+00 4.1903999328613281e+01 1.0500000000000000e+02 -3.5000000000000000e+00 4.5155200958251953e+01 1.0500000000000000e+02 -5.4107700347900391e+01 4.8406398773193359e+01 1.0450000000000000e+02 -5.4705799102783203e+01 4.9655197143554688e+01 1.0450000000000000e+02 -5.3500000000000000e+01 4.5155200958251953e+01 1.0500000000000000e+02 -5.8051197052001953e+01 5.2881599426269531e+01 1.0450000000000000e+02 -5.8000000000000000e+01 5.2949398040771484e+01 1.0500000000000000e+02 -5.5848899841308594e+01 5.1218498229980469e+01 1.0500000000000000e+02 -5.4832397460937500e+01 4.9576801300048828e+01 1.0500000000000000e+02 -5.8488399505615234e+01 5.3211700439453125e+01 1.0500000000000000e+02 -6.1669597625732422e+01 5.4116802215576172e+01 1.0450000000000000e+02 -6.2500000000000000e+01 5.4155200958251953e+01 1.0500000000000000e+02 -6.6939300537109375e+01 5.2827499389648438e+01 1.0450000000000000e+02 -6.7000000000000000e+01 5.2949398040771484e+01 1.0500000000000000e+02 -6.4962997436523438e+01 5.3811599731445312e+01 1.0500000000000000e+02 -6.2489402770996094e+01 5.4040802001953125e+01 1.0500000000000000e+02 -6.7923706054687500e+01 5.2337402343750000e+01 1.0500000000000000e+02 -7.0152000427246094e+01 4.9893100738525391e+01 1.0450000000000000e+02 -7.0294204711914062e+01 4.9655197143554688e+01 1.0500000000000000e+02 -7.0250694274902344e+01 4.9638301849365234e+01 1.0500000000000000e+02 -7.1346794128417969e+01 4.6808898925781250e+01 1.0450000000000000e+02 -7.1500000000000000e+01 4.5155200958251953e+01 1.0500000000000000e+02 -7.0250694274902344e+01 4.0672100067138672e+01 1.0450000000000000e+02 -7.0294204711914062e+01 4.0655200958251953e+01 1.0500000000000000e+02 -7.1346794128417969e+01 4.3501399993896484e+01 1.0500000000000000e+02 -7.1346794128417969e+01 4.5155200958251953e+01 1.0500000000000000e+02 -7.0152000427246094e+01 4.0417297363281250e+01 1.0500000000000000e+02 -6.7923706054687500e+01 3.7973003387451172e+01 1.0450000000000000e+02 -6.7000000000000000e+01 3.7361000061035156e+01 1.0500000000000000e+02 -6.2489402770996094e+01 3.6269599914550781e+01 1.0450000000000000e+02 -6.2500000000000000e+01 3.6155200958251953e+01 1.0500000000000000e+02 -6.4962997436523438e+01 3.6498798370361328e+01 1.0500000000000000e+02 -6.6939300537109375e+01 3.7482898712158203e+01 1.0500000000000000e+02 -6.1669597625732422e+01 3.6193603515625000e+01 1.0500000000000000e+02 -5.8488399505615234e+01 3.7098697662353516e+01 1.0450000000000000e+02 -5.8000000000000000e+01 3.7361000061035156e+01 1.0500000000000000e+02 -5.8051197052001953e+01 3.7428798675537109e+01 1.0500000000000000e+02 -5.5848899841308594e+01 3.9091899871826172e+01 1.0450000000000000e+02 -5.4705799102783203e+01 4.0655200958251953e+01 1.0500000000000000e+02 -5.4832397460937500e+01 4.0733596801757812e+01 1.0500000000000000e+02 -5.4107700347900391e+01 4.1903999328613281e+01 1.0500000000000000e+02 -5.3500000000000000e+01 4.5155200958251953e+01 1.0525000000000000e+02 1.9200601577758789e+01 3.9046802520751953e+01 1.0525000000000000e+02 2.0954700469970703e+01 4.1879798889160156e+01 1.0525000000000000e+02 1.6541500091552734e+01 3.7038799285888672e+01 1.0525000000000000e+02 1.3336599349975586e+01 3.6126899719238281e+01 1.0525000000000000e+02 1.0018699645996094e+01 3.6434299468994141e+01 1.0525000000000000e+02 7.0359201431274414e+00 3.7919601440429688e+01 1.0525000000000000e+02 4.7910900115966797e+00 4.0381999969482422e+01 1.0525000000000000e+02 3.5873999595642090e+00 4.3489200592041016e+01 1.0525000000000000e+02 3.5873999595642090e+00 4.6821300506591797e+01 1.0525000000000000e+02 4.7910900115966797e+00 4.9928401947021484e+01 1.0525000000000000e+02 7.0359201431274414e+00 5.2390800476074219e+01 1.0525000000000000e+02 1.0018699645996094e+01 5.3876098632812500e+01 1.0525000000000000e+02 1.3336599349975586e+01 5.4183502197265625e+01 1.0525000000000000e+02 1.6541500091552734e+01 5.3271598815917969e+01 1.0525000000000000e+02 1.9200601577758789e+01 5.1263599395751953e+01 1.0525000000000000e+02 2.0954700469970703e+01 4.8430599212646484e+01 1.0525000000000000e+02 2.1566999435424805e+01 4.5155200958251953e+01 1.0543299865722656e+02 2.1125400543212891e+01 4.8496700286865234e+01 1.0543299865722656e+02 1.9335800170898438e+01 5.1386901855468750e+01 1.0543299865722656e+02 1.6623100280761719e+01 5.3435501098632812e+01 1.0543299865722656e+02 1.3353499412536621e+01 5.4365699768066406e+01 1.0543299865722656e+02 9.9686193466186523e+00 5.4052101135253906e+01 1.0543299865722656e+02 6.9256300926208496e+00 5.2536899566650391e+01 1.0543299865722656e+02 4.6354899406433105e+00 5.0024700164794922e+01 1.0543299865722656e+02 3.4075000286102295e+00 4.6854896545410156e+01 1.0543299865722656e+02 3.4075000286102295e+00 4.3455501556396484e+01 1.0543299865722656e+02 4.6354899406433105e+00 4.0285697937011719e+01 1.0543299865722656e+02 6.9256300926208496e+00 3.7773502349853516e+01 1.0543299865722656e+02 9.9686193466186523e+00 3.6258300781250000e+01 1.0543299865722656e+02 1.3353499412536621e+01 3.5944702148437500e+01 1.0543299865722656e+02 1.6623100280761719e+01 3.6874900817871094e+01 1.0543299865722656e+02 1.9335800170898438e+01 3.8923500061035156e+01 1.0543299865722656e+02 2.1125400543212891e+01 4.1813701629638672e+01 1.0543299865722656e+02 2.1750000000000000e+01 4.5155200958251953e+01 1.0525000000000000e+02 -5.7994203567504883e+00 3.9046802520751953e+01 1.0525000000000000e+02 -4.0452899932861328e+00 4.1879798889160156e+01 1.0525000000000000e+02 -8.4584999084472656e+00 3.7038799285888672e+01 1.0525000000000000e+02 -1.1663399696350098e+01 3.6126899719238281e+01 1.0525000000000000e+02 -1.4981299400329590e+01 3.6434299468994141e+01 1.0525000000000000e+02 -1.7964099884033203e+01 3.7919601440429688e+01 1.0525000000000000e+02 -2.0208900451660156e+01 4.0381999969482422e+01 1.0525000000000000e+02 -2.1412599563598633e+01 4.3489200592041016e+01 1.0525000000000000e+02 -2.1412599563598633e+01 4.6821300506591797e+01 1.0525000000000000e+02 -2.0208900451660156e+01 4.9928401947021484e+01 1.0525000000000000e+02 -1.7964099884033203e+01 5.2390800476074219e+01 1.0525000000000000e+02 -1.4981299400329590e+01 5.3876098632812500e+01 1.0525000000000000e+02 -1.1663399696350098e+01 5.4183502197265625e+01 1.0525000000000000e+02 -8.4584999084472656e+00 5.3271598815917969e+01 1.0525000000000000e+02 -5.7994203567504883e+00 5.1263599395751953e+01 1.0525000000000000e+02 -4.0452899932861328e+00 4.8430599212646484e+01 1.0525000000000000e+02 -3.4330101013183594e+00 4.5155200958251953e+01 1.0543299865722656e+02 -3.8746299743652344e+00 4.8496700286865234e+01 1.0543299865722656e+02 -5.6641697883605957e+00 5.1386901855468750e+01 1.0543299865722656e+02 -8.3769197463989258e+00 5.3435501098632812e+01 1.0543299865722656e+02 -1.1646499633789062e+01 5.4365699768066406e+01 1.0543299865722656e+02 -1.5031399726867676e+01 5.4052101135253906e+01 1.0543299865722656e+02 -1.8074399948120117e+01 5.2536899566650391e+01 1.0543299865722656e+02 -2.0364500045776367e+01 5.0024700164794922e+01 1.0543299865722656e+02 -2.1592498779296875e+01 4.6854896545410156e+01 1.0543299865722656e+02 -2.1592498779296875e+01 4.3455501556396484e+01 1.0543299865722656e+02 -2.0364500045776367e+01 4.0285697937011719e+01 1.0543299865722656e+02 -1.8074399948120117e+01 3.7773502349853516e+01 1.0543299865722656e+02 -1.5031399726867676e+01 3.6258300781250000e+01 1.0543299865722656e+02 -1.1646499633789062e+01 3.5944702148437500e+01 1.0543299865722656e+02 -8.3769197463989258e+00 3.6874900817871094e+01 1.0543299865722656e+02 -5.6641697883605957e+00 3.8923500061035156e+01 1.0543299865722656e+02 -3.8746299743652344e+00 4.1813701629638672e+01 1.0543299865722656e+02 -3.2500000000000000e+00 4.5155200958251953e+01 1.0519100189208984e+02 -5.5820800781250000e+01 3.9066299438476562e+01 1.0519100189208984e+02 -5.4072299957275391e+01 4.1890300750732422e+01 1.0519100189208984e+02 -5.8471401214599609e+01 3.7064701080322266e+01 1.0519100189208984e+02 -6.1666099548339844e+01 3.6155700683593750e+01 1.0519100189208984e+02 -6.4973396301269531e+01 3.6462200164794922e+01 1.0519100189208984e+02 -6.7946594238281250e+01 3.7942699432373047e+01 1.0519100189208984e+02 -7.0184295654296875e+01 4.0397300720214844e+01 1.0519100189208984e+02 -7.1384201049804688e+01 4.3494499206542969e+01 1.0519100189208984e+02 -7.1384201049804688e+01 4.6815898895263672e+01 1.0519100189208984e+02 -7.0184295654296875e+01 4.9913101196289062e+01 1.0519100189208984e+02 -6.7946594238281250e+01 5.2367698669433594e+01 1.0519100189208984e+02 -6.4973396301269531e+01 5.3848197937011719e+01 1.0519100189208984e+02 -6.1666099548339844e+01 5.4154701232910156e+01 1.0519100189208984e+02 -5.8471401214599609e+01 5.3245700836181641e+01 1.0519100189208984e+02 -5.5820800781250000e+01 5.1244098663330078e+01 1.0519100189208984e+02 -5.4072299957275391e+01 4.8420101165771484e+01 1.0519100189208984e+02 -5.3461902618408203e+01 4.5155200958251953e+01 1.0535400390625000e+02 -5.3971202850341797e+01 4.8459297180175781e+01 1.0535400390625000e+02 -5.5740699768066406e+01 5.1317100524902344e+01 1.0535400390625000e+02 -5.8423099517822266e+01 5.3342800140380859e+01 1.0535400390625000e+02 -6.1656097412109375e+01 5.4262599945068359e+01 1.0535400390625000e+02 -6.5002998352050781e+01 5.3952499389648438e+01 1.0535400390625000e+02 -6.8012001037597656e+01 5.2454200744628906e+01 1.0535400390625000e+02 -7.0276496887207031e+01 4.9970199584960938e+01 1.0535400390625000e+02 -7.1490699768066406e+01 4.6835899353027344e+01 1.0535400390625000e+02 -7.1490699768066406e+01 4.3474498748779297e+01 1.0535400390625000e+02 -7.0276496887207031e+01 4.0340198516845703e+01 1.0535400390625000e+02 -6.8012001037597656e+01 3.7856197357177734e+01 1.0535400390625000e+02 -6.5002998352050781e+01 3.6357898712158203e+01 1.0535400390625000e+02 -6.1656097412109375e+01 3.6047801971435547e+01 1.0535400390625000e+02 -5.8423099517822266e+01 3.6967601776123047e+01 1.0535400390625000e+02 -5.5740699768066406e+01 3.8993297576904297e+01 1.0535400390625000e+02 -5.3971202850341797e+01 4.1851100921630859e+01 1.0535400390625000e+02 -5.3353500366210938e+01 4.5155200958251953e+01 1.0546199798583984e+02 -5.3819896697998047e+01 4.8517902374267578e+01 1.0546199798583984e+02 -5.5620800018310547e+01 5.1426399230957031e+01 1.0546199798583984e+02 -5.8350799560546875e+01 5.3488002777099609e+01 1.0546199798583984e+02 -6.1641101837158203e+01 5.4424098968505859e+01 1.0546199798583984e+02 -6.5047401428222656e+01 5.4108501434326172e+01 1.0546199798583984e+02 -6.8109695434570312e+01 5.2583698272705078e+01 1.0546199798583984e+02 -7.0414398193359375e+01 5.0055599212646484e+01 1.0546199798583984e+02 -7.1650199890136719e+01 4.6865699768066406e+01 1.0546199798583984e+02 -7.1650199890136719e+01 4.3444702148437500e+01 1.0546199798583984e+02 -7.0414398193359375e+01 4.0254802703857422e+01 1.0546199798583984e+02 -6.8109695434570312e+01 3.7726699829101562e+01 1.0546199798583984e+02 -6.5047401428222656e+01 3.6201900482177734e+01 1.0546199798583984e+02 -6.1641101837158203e+01 3.5886299133300781e+01 1.0546199798583984e+02 -5.8350799560546875e+01 3.6822399139404297e+01 1.0546199798583984e+02 -5.5620800018310547e+01 3.8883998870849609e+01 1.0546199798583984e+02 -5.3819896697998047e+01 4.1792499542236328e+01 1.0546199798583984e+02 -5.3191299438476562e+01 4.5155200958251953e+01 8.7500000000000000e+01 -4.8500000000000000e+01 3.2135799407958984e+01 8.6086700439453125e+01 -4.7683998107910156e+01 3.1155200958251953e+01 8.6684005737304688e+01 -4.7086700439453125e+01 3.1155200958251953e+01 8.5868003845214844e+01 -4.8500000000000000e+01 3.1155200958251953e+01 8.8316001892089844e+01 -4.7086700439453125e+01 3.1155200958251953e+01 8.8913299560546875e+01 -4.7683998107910156e+01 3.1155200958251953e+01 8.7500000000000000e+01 -4.6868000030517578e+01 3.1155200958251953e+01 8.8913299560546875e+01 -4.9316001892089844e+01 3.1155200958251953e+01 8.8316001892089844e+01 -4.9913299560546875e+01 3.1155200958251953e+01 8.9132003784179688e+01 -4.8500000000000000e+01 3.1155200958251953e+01 8.6684005737304688e+01 -4.9913299560546875e+01 3.1155200958251953e+01 8.6086700439453125e+01 -4.9316001892089844e+01 3.1155200958251953e+01 8.7500000000000000e+01 -5.0131999969482422e+01 3.1155200958251953e+01 8.5868003845214844e+01 -4.8500000000000000e+01 2.9000000000000000e+01 8.6086700439453125e+01 -4.7683998107910156e+01 2.9000000000000000e+01 8.6684005737304688e+01 -4.7086700439453125e+01 2.9000000000000000e+01 8.7500000000000000e+01 -4.6868000030517578e+01 2.9000000000000000e+01 8.8316001892089844e+01 -4.7086700439453125e+01 2.9000000000000000e+01 8.8913299560546875e+01 -4.7683998107910156e+01 2.9000000000000000e+01 8.9132003784179688e+01 -4.8500000000000000e+01 2.9000000000000000e+01 8.8913299560546875e+01 -4.9316001892089844e+01 2.9000000000000000e+01 8.8316001892089844e+01 -4.9913299560546875e+01 2.9000000000000000e+01 8.7500000000000000e+01 -5.0131999969482422e+01 2.9000000000000000e+01 8.6684005737304688e+01 -4.9913299560546875e+01 2.9000000000000000e+01 8.6086700439453125e+01 -4.9316001892089844e+01 2.9000000000000000e+01 8.8889396667480469e+01 -4.6093502044677734e+01 2.9000000000000000e+01 8.9906501770019531e+01 -4.7110599517822266e+01 2.9000000000000000e+01 9.0278793334960938e+01 -4.8500000000000000e+01 2.9000000000000000e+01 8.9906501770019531e+01 -4.9889400482177734e+01 2.9000000000000000e+01 8.8889396667480469e+01 -5.0906501770019531e+01 2.9000000000000000e+01 8.7500000000000000e+01 -5.1278800964355469e+01 2.9000000000000000e+01 8.6110595703125000e+01 -5.0906501770019531e+01 2.9000000000000000e+01 8.5093498229980469e+01 -4.9889400482177734e+01 2.9000000000000000e+01 8.4721199035644531e+01 -4.8500000000000000e+01 2.9000000000000000e+01 8.5093498229980469e+01 -4.7110599517822266e+01 2.9000000000000000e+01 8.6110595703125000e+01 -4.6093502044677734e+01 2.9000000000000000e+01 8.7500000000000000e+01 -4.5721199035644531e+01 2.9000000000000000e+01 8.7500000000000000e+01 -9.8000000000000000e+01 3.2135799407958984e+01 8.6086700439453125e+01 -9.7184005737304688e+01 3.1155200958251953e+01 8.6684005737304688e+01 -9.6586700439453125e+01 3.1155200958251953e+01 8.5868003845214844e+01 -9.8000000000000000e+01 3.1155200958251953e+01 8.8316001892089844e+01 -9.6586700439453125e+01 3.1155200958251953e+01 8.8913299560546875e+01 -9.7184005737304688e+01 3.1155200958251953e+01 8.7500000000000000e+01 -9.6367996215820312e+01 3.1155200958251953e+01 8.8913299560546875e+01 -9.8816001892089844e+01 3.1155200958251953e+01 8.8316001892089844e+01 -9.9413299560546875e+01 3.1155200958251953e+01 8.9132003784179688e+01 -9.8000000000000000e+01 3.1155200958251953e+01 8.6684005737304688e+01 -9.9413299560546875e+01 3.1155200958251953e+01 8.6086700439453125e+01 -9.8816001892089844e+01 3.1155200958251953e+01 8.7500000000000000e+01 -9.9632003784179688e+01 3.1155200958251953e+01 8.5868003845214844e+01 -9.8000000000000000e+01 2.9000000000000000e+01 8.6086700439453125e+01 -9.7184005737304688e+01 2.9000000000000000e+01 8.6684005737304688e+01 -9.6586700439453125e+01 2.9000000000000000e+01 8.7500000000000000e+01 -9.6367996215820312e+01 2.9000000000000000e+01 8.8316001892089844e+01 -9.6586700439453125e+01 2.9000000000000000e+01 8.8913299560546875e+01 -9.7184005737304688e+01 2.9000000000000000e+01 8.9132003784179688e+01 -9.8000000000000000e+01 2.9000000000000000e+01 8.8913299560546875e+01 -9.8816001892089844e+01 2.9000000000000000e+01 8.8316001892089844e+01 -9.9413299560546875e+01 2.9000000000000000e+01 8.7500000000000000e+01 -9.9632003784179688e+01 2.9000000000000000e+01 8.6684005737304688e+01 -9.9413299560546875e+01 2.9000000000000000e+01 8.6086700439453125e+01 -9.8816001892089844e+01 2.9000000000000000e+01 8.6110595703125000e+01 -9.5593498229980469e+01 2.9000000000000000e+01 8.7500000000000000e+01 -9.5221199035644531e+01 2.9000000000000000e+01 8.8889396667480469e+01 -9.5593498229980469e+01 2.9000000000000000e+01 8.9906501770019531e+01 -9.6610595703125000e+01 2.9000000000000000e+01 9.0278793334960938e+01 -9.8000000000000000e+01 2.9000000000000000e+01 8.9906501770019531e+01 -9.9389396667480469e+01 2.9000000000000000e+01 8.8889396667480469e+01 -1.0040599822998047e+02 2.9000000000000000e+01 8.7500000000000000e+01 -1.0077899932861328e+02 2.9000000000000000e+01 8.6110595703125000e+01 -1.0040599822998047e+02 2.9000000000000000e+01 8.5093498229980469e+01 -9.9389396667480469e+01 2.9000000000000000e+01 8.4721199035644531e+01 -9.8000000000000000e+01 2.9000000000000000e+01 8.5093498229980469e+01 -9.6610595703125000e+01 2.9000000000000000e+01 6.1000000000000000e+01 -6.5500000000000000e+01 3.2135799407958984e+01 5.9586700439453125e+01 -6.4684005737304688e+01 3.1155200958251953e+01 6.0183998107910156e+01 -6.4086700439453125e+01 3.1155200958251953e+01 5.9368000030517578e+01 -6.5500000000000000e+01 3.1155200958251953e+01 6.1815998077392578e+01 -6.4086700439453125e+01 3.1155200958251953e+01 6.2413299560546875e+01 -6.4684005737304688e+01 3.1155200958251953e+01 6.1000000000000000e+01 -6.3868099212646484e+01 3.1155200958251953e+01 6.2413299560546875e+01 -6.6316001892089844e+01 3.1155200958251953e+01 6.1815998077392578e+01 -6.6913299560546875e+01 3.1155200958251953e+01 6.2632003784179688e+01 -6.5500000000000000e+01 3.1155200958251953e+01 6.0183998107910156e+01 -6.6913299560546875e+01 3.1155200958251953e+01 5.9586700439453125e+01 -6.6316001892089844e+01 3.1155200958251953e+01 6.1000000000000000e+01 -6.7132003784179688e+01 3.1155200958251953e+01 5.9368000030517578e+01 -6.5500000000000000e+01 2.9000000000000000e+01 5.9586700439453125e+01 -6.4684005737304688e+01 2.9000000000000000e+01 6.0183998107910156e+01 -6.4086700439453125e+01 2.9000000000000000e+01 6.1000000000000000e+01 -6.3868099212646484e+01 2.9000000000000000e+01 6.1815998077392578e+01 -6.4086700439453125e+01 2.9000000000000000e+01 6.2413299560546875e+01 -6.4684005737304688e+01 2.9000000000000000e+01 6.2632003784179688e+01 -6.5500000000000000e+01 2.9000000000000000e+01 6.2413299560546875e+01 -6.6316001892089844e+01 2.9000000000000000e+01 6.1815998077392578e+01 -6.6913299560546875e+01 2.9000000000000000e+01 6.1000000000000000e+01 -6.7132003784179688e+01 2.9000000000000000e+01 6.0183998107910156e+01 -6.6913299560546875e+01 2.9000000000000000e+01 5.9586700439453125e+01 -6.6316001892089844e+01 2.9000000000000000e+01 6.3406497955322266e+01 -6.4110595703125000e+01 2.9000000000000000e+01 6.3778800964355469e+01 -6.5500000000000000e+01 2.9000000000000000e+01 6.3406497955322266e+01 -6.6889396667480469e+01 2.9000000000000000e+01 6.2389400482177734e+01 -6.7906501770019531e+01 2.9000000000000000e+01 6.1000000000000000e+01 -6.8278793334960938e+01 2.9000000000000000e+01 5.9610603332519531e+01 -6.7906501770019531e+01 2.9000000000000000e+01 5.8593502044677734e+01 -6.6889396667480469e+01 2.9000000000000000e+01 5.8221199035644531e+01 -6.5500000000000000e+01 2.9000000000000000e+01 5.8593502044677734e+01 -6.4110595703125000e+01 2.9000000000000000e+01 5.9610603332519531e+01 -6.3093498229980469e+01 2.9000000000000000e+01 6.1000000000000000e+01 -6.2721199035644531e+01 2.9000000000000000e+01 6.2389400482177734e+01 -6.3093498229980469e+01 2.9000000000000000e+01 6.1000000000000000e+01 6.5500000000000000e+01 3.2135799407958984e+01 5.9586700439453125e+01 6.6316001892089844e+01 3.1155200958251953e+01 6.0183998107910156e+01 6.6913299560546875e+01 3.1155200958251953e+01 5.9368000030517578e+01 6.5500000000000000e+01 3.1155200958251953e+01 6.1815998077392578e+01 6.6913299560546875e+01 3.1155200958251953e+01 6.2413299560546875e+01 6.6316001892089844e+01 3.1155200958251953e+01 6.1000000000000000e+01 6.7132003784179688e+01 3.1155200958251953e+01 6.2413299560546875e+01 6.4684005737304688e+01 3.1155200958251953e+01 6.1815998077392578e+01 6.4086700439453125e+01 3.1155200958251953e+01 6.2632003784179688e+01 6.5500000000000000e+01 3.1155200958251953e+01 6.0183998107910156e+01 6.4086700439453125e+01 3.1155200958251953e+01 5.9586700439453125e+01 6.4684005737304688e+01 3.1155200958251953e+01 6.1000000000000000e+01 6.3868099212646484e+01 3.1155200958251953e+01 5.9368000030517578e+01 6.5500000000000000e+01 2.9000000000000000e+01 5.9586700439453125e+01 6.6316001892089844e+01 2.9000000000000000e+01 6.0183998107910156e+01 6.6913299560546875e+01 2.9000000000000000e+01 6.1000000000000000e+01 6.7132003784179688e+01 2.9000000000000000e+01 6.1815998077392578e+01 6.6913299560546875e+01 2.9000000000000000e+01 6.2413299560546875e+01 6.6316001892089844e+01 2.9000000000000000e+01 6.2632003784179688e+01 6.5500000000000000e+01 2.9000000000000000e+01 6.2413299560546875e+01 6.4684005737304688e+01 2.9000000000000000e+01 6.1815998077392578e+01 6.4086700439453125e+01 2.9000000000000000e+01 6.1000000000000000e+01 6.3868099212646484e+01 2.9000000000000000e+01 6.0183998107910156e+01 6.4086700439453125e+01 2.9000000000000000e+01 5.9586700439453125e+01 6.4684005737304688e+01 2.9000000000000000e+01 6.3406497955322266e+01 6.6889396667480469e+01 2.9000000000000000e+01 6.3778800964355469e+01 6.5500000000000000e+01 2.9000000000000000e+01 6.3406497955322266e+01 6.4110595703125000e+01 2.9000000000000000e+01 6.2389400482177734e+01 6.3093498229980469e+01 2.9000000000000000e+01 6.1000000000000000e+01 6.2721199035644531e+01 2.9000000000000000e+01 5.9610603332519531e+01 6.3093498229980469e+01 2.9000000000000000e+01 5.8593502044677734e+01 6.4110595703125000e+01 2.9000000000000000e+01 5.8221199035644531e+01 6.5500000000000000e+01 2.9000000000000000e+01 5.8593502044677734e+01 6.6889396667480469e+01 2.9000000000000000e+01 5.9610603332519531e+01 6.7906501770019531e+01 2.9000000000000000e+01 6.1000000000000000e+01 6.8278793334960938e+01 2.9000000000000000e+01 6.2389400482177734e+01 6.7906501770019531e+01 2.9000000000000000e+01 8.7500000000000000e+01 9.8000000000000000e+01 3.2135799407958984e+01 8.6086700439453125e+01 9.8816001892089844e+01 3.1155200958251953e+01 8.6684005737304688e+01 9.9413299560546875e+01 3.1155200958251953e+01 8.5868003845214844e+01 9.8000000000000000e+01 3.1155200958251953e+01 8.8316001892089844e+01 9.9413299560546875e+01 3.1155200958251953e+01 8.8913299560546875e+01 9.8816001892089844e+01 3.1155200958251953e+01 8.7500000000000000e+01 9.9632003784179688e+01 3.1155200958251953e+01 8.8913299560546875e+01 9.7184005737304688e+01 3.1155200958251953e+01 8.8316001892089844e+01 9.6586700439453125e+01 3.1155200958251953e+01 8.9132003784179688e+01 9.8000000000000000e+01 3.1155200958251953e+01 8.6684005737304688e+01 9.6586700439453125e+01 3.1155200958251953e+01 8.6086700439453125e+01 9.7184005737304688e+01 3.1155200958251953e+01 8.7500000000000000e+01 9.6367996215820312e+01 3.1155200958251953e+01 8.5868003845214844e+01 9.8000000000000000e+01 2.9000000000000000e+01 8.6086700439453125e+01 9.8816001892089844e+01 2.9000000000000000e+01 8.6684005737304688e+01 9.9413299560546875e+01 2.9000000000000000e+01 8.7500000000000000e+01 9.9632003784179688e+01 2.9000000000000000e+01 8.8316001892089844e+01 9.9413299560546875e+01 2.9000000000000000e+01 8.8913299560546875e+01 9.8816001892089844e+01 2.9000000000000000e+01 8.9132003784179688e+01 9.8000000000000000e+01 2.9000000000000000e+01 8.8913299560546875e+01 9.7184005737304688e+01 2.9000000000000000e+01 8.8316001892089844e+01 9.6586700439453125e+01 2.9000000000000000e+01 8.7500000000000000e+01 9.6367996215820312e+01 2.9000000000000000e+01 8.6684005737304688e+01 9.6586700439453125e+01 2.9000000000000000e+01 8.6086700439453125e+01 9.7184005737304688e+01 2.9000000000000000e+01 8.6110595703125000e+01 1.0040599822998047e+02 2.9000000000000000e+01 8.7500000000000000e+01 1.0077899932861328e+02 2.9000000000000000e+01 8.8889396667480469e+01 1.0040599822998047e+02 2.9000000000000000e+01 8.9906501770019531e+01 9.9389396667480469e+01 2.9000000000000000e+01 9.0278793334960938e+01 9.8000000000000000e+01 2.9000000000000000e+01 8.9906501770019531e+01 9.6610595703125000e+01 2.9000000000000000e+01 8.8889396667480469e+01 9.5593498229980469e+01 2.9000000000000000e+01 8.7500000000000000e+01 9.5221199035644531e+01 2.9000000000000000e+01 8.6110595703125000e+01 9.5593498229980469e+01 2.9000000000000000e+01 8.5093498229980469e+01 9.6610595703125000e+01 2.9000000000000000e+01 8.4721199035644531e+01 9.8000000000000000e+01 2.9000000000000000e+01 8.5093498229980469e+01 9.9389396667480469e+01 2.9000000000000000e+01 8.7500000000000000e+01 4.8500000000000000e+01 3.2135799407958984e+01 8.6086700439453125e+01 4.9316001892089844e+01 3.1155200958251953e+01 8.6684005737304688e+01 4.9913299560546875e+01 3.1155200958251953e+01 8.5868003845214844e+01 4.8500000000000000e+01 3.1155200958251953e+01 8.8316001892089844e+01 4.9913299560546875e+01 3.1155200958251953e+01 8.8913299560546875e+01 4.9316001892089844e+01 3.1155200958251953e+01 8.7500000000000000e+01 5.0131999969482422e+01 3.1155200958251953e+01 8.8913299560546875e+01 4.7683998107910156e+01 3.1155200958251953e+01 8.8316001892089844e+01 4.7086700439453125e+01 3.1155200958251953e+01 8.9132003784179688e+01 4.8500000000000000e+01 3.1155200958251953e+01 8.6684005737304688e+01 4.7086700439453125e+01 3.1155200958251953e+01 8.6086700439453125e+01 4.7683998107910156e+01 3.1155200958251953e+01 8.7500000000000000e+01 4.6868000030517578e+01 3.1155200958251953e+01 8.5868003845214844e+01 4.8500000000000000e+01 2.9000000000000000e+01 8.6086700439453125e+01 4.9316001892089844e+01 2.9000000000000000e+01 8.6684005737304688e+01 4.9913299560546875e+01 2.9000000000000000e+01 8.7500000000000000e+01 5.0131999969482422e+01 2.9000000000000000e+01 8.8316001892089844e+01 4.9913299560546875e+01 2.9000000000000000e+01 8.8913299560546875e+01 4.9316001892089844e+01 2.9000000000000000e+01 8.9132003784179688e+01 4.8500000000000000e+01 2.9000000000000000e+01 8.8913299560546875e+01 4.7683998107910156e+01 2.9000000000000000e+01 8.8316001892089844e+01 4.7086700439453125e+01 2.9000000000000000e+01 8.7500000000000000e+01 4.6868000030517578e+01 2.9000000000000000e+01 8.6684005737304688e+01 4.7086700439453125e+01 2.9000000000000000e+01 8.6086700439453125e+01 4.7683998107910156e+01 2.9000000000000000e+01 8.8889396667480469e+01 5.0906501770019531e+01 2.9000000000000000e+01 8.9906501770019531e+01 4.9889400482177734e+01 2.9000000000000000e+01 9.0278793334960938e+01 4.8500000000000000e+01 2.9000000000000000e+01 8.9906501770019531e+01 4.7110599517822266e+01 2.9000000000000000e+01 8.8889396667480469e+01 4.6093502044677734e+01 2.9000000000000000e+01 8.7500000000000000e+01 4.5721199035644531e+01 2.9000000000000000e+01 8.6110595703125000e+01 4.6093502044677734e+01 2.9000000000000000e+01 8.5093498229980469e+01 4.7110599517822266e+01 2.9000000000000000e+01 8.4721199035644531e+01 4.8500000000000000e+01 2.9000000000000000e+01 8.5093498229980469e+01 4.9889400482177734e+01 2.9000000000000000e+01 8.6110595703125000e+01 5.0906501770019531e+01 2.9000000000000000e+01 8.7500000000000000e+01 5.1278800964355469e+01 2.9000000000000000e+01 6.1864902496337891e+01 -6.4094902038574219e+01 2.4000000000000000e+01 6.2730998992919922e+01 -6.3343898773193359e+01 2.4000000000000000e+01 6.2155899047851562e+01 -6.4322601318359375e+01 2.4000000000000000e+01 6.3079097747802734e+01 -6.3677200317382812e+01 2.4000000000000000e+01 6.2388900756835938e+01 -6.4609298706054688e+01 2.4000000000000000e+01 6.3363998413085938e+01 -6.4065902709960938e+01 2.4000000000000000e+01 6.2552303314208984e+01 -6.4940696716308594e+01 2.4000000000000000e+01 6.3577098846435547e+01 -6.4498199462890625e+01 2.4000000000000000e+01 6.2637901306152344e+01 -6.5300193786621094e+01 2.4000000000000000e+01 6.0800197601318359e+01 -6.3862098693847656e+01 2.4000000000000000e+01 6.0940101623535156e+01 -6.2735603332519531e+01 2.4000000000000000e+01 6.1169597625732422e+01 -6.3858703613281250e+01 2.4000000000000000e+01 6.1420997619628906e+01 -6.2767200469970703e+01 2.4000000000000000e+01 6.1530601501464844e+01 -6.3937595367431641e+01 2.4000000000000000e+01 6.1889099121093750e+01 -6.2881900787353516e+01 2.4000000000000000e+01 6.2330303192138672e+01 -6.3075996398925781e+01 2.4000000000000000e+01 5.9362098693847656e+01 -6.5699798583984375e+01 2.4000000000000000e+01 5.8235599517822266e+01 -6.5559898376464844e+01 2.4000000000000000e+01 5.9358699798583984e+01 -6.5330398559570312e+01 2.4000000000000000e+01 5.8267196655273438e+01 -6.5079002380371094e+01 2.4000000000000000e+01 5.9437599182128906e+01 -6.4969398498535156e+01 2.4000000000000000e+01 5.8381900787353516e+01 -6.4610900878906250e+01 2.4000000000000000e+01 5.9594898223876953e+01 -6.4635101318359375e+01 2.4000000000000000e+01 6.0135101318359375e+01 -6.6905105590820312e+01 2.4000000000000000e+01 5.9269001007080078e+01 -6.7656097412109375e+01 2.4000000000000000e+01 5.9844097137451172e+01 -6.6677398681640625e+01 2.4000000000000000e+01 5.8920902252197266e+01 -6.7322799682617188e+01 2.4000000000000000e+01 5.9611099243164062e+01 -6.6390701293945312e+01 2.4000000000000000e+01 5.8635997772216797e+01 -6.6934104919433594e+01 2.4000000000000000e+01 5.9447696685791016e+01 -6.6059295654296875e+01 2.4000000000000000e+01 5.8422901153564453e+01 -6.6501800537109375e+01 2.4000000000000000e+01 5.8288101196289062e+01 -6.6039001464843750e+01 2.4000000000000000e+01 6.2405097961425781e+01 -6.6364898681640625e+01 2.4000000000000000e+01 6.3156097412109375e+01 -6.7231002807617188e+01 2.4000000000000000e+01 6.2177402496337891e+01 -6.6655899047851562e+01 2.4000000000000000e+01 6.2822795867919922e+01 -6.7579101562500000e+01 2.4000000000000000e+01 6.1890697479248047e+01 -6.6888900756835938e+01 2.4000000000000000e+01 6.2434101104736328e+01 -6.7863998413085938e+01 2.4000000000000000e+01 6.1559299468994141e+01 -6.7052299499511719e+01 2.4000000000000000e+01 6.2001796722412109e+01 -6.8077102661132812e+01 2.4000000000000000e+01 6.1199798583984375e+01 -6.7137893676757812e+01 2.4000000000000000e+01 5.8576000213623047e+01 -6.4169700622558594e+01 2.4000000000000000e+01 5.8843898773193359e+01 -6.3768997192382812e+01 2.4000000000000000e+01 5.9822601318359375e+01 -6.4344100952148438e+01 2.4000000000000000e+01 5.9177200317382812e+01 -6.3420898437500000e+01 2.4000000000000000e+01 6.0109298706054688e+01 -6.4111099243164062e+01 2.4000000000000000e+01 5.9565902709960938e+01 -6.3135997772216797e+01 2.4000000000000000e+01 6.0440700531005859e+01 -6.3947700500488281e+01 2.4000000000000000e+01 5.9998199462890625e+01 -6.2922901153564453e+01 2.4000000000000000e+01 6.0460998535156250e+01 -6.2788097381591797e+01 2.4000000000000000e+01 6.1539001464843750e+01 -6.8211898803710938e+01 2.4000000000000000e+01 6.1059898376464844e+01 -6.8264404296875000e+01 2.4000000000000000e+01 6.0830398559570312e+01 -6.7141304016113281e+01 2.4000000000000000e+01 6.0578998565673828e+01 -6.8232795715332031e+01 2.4000000000000000e+01 6.0469398498535156e+01 -6.7062400817871094e+01 2.4000000000000000e+01 6.0110900878906250e+01 -6.8118103027343750e+01 2.4000000000000000e+01 5.9669700622558594e+01 -6.7924003601074219e+01 2.4000000000000000e+01 6.3711894989013672e+01 -6.4960998535156250e+01 2.4000000000000000e+01 6.3764400482177734e+01 -6.5440101623535156e+01 2.4000000000000000e+01 6.2641300201416016e+01 -6.5669601440429688e+01 2.4000000000000000e+01 6.3732803344726562e+01 -6.5920997619628906e+01 2.4000000000000000e+01 6.2562397003173828e+01 -6.6030601501464844e+01 2.4000000000000000e+01 6.3618103027343750e+01 -6.6389099121093750e+01 2.4000000000000000e+01 6.3423999786376953e+01 -6.6830299377441406e+01 2.4000000000000000e+01 5.9844097137451172e+01 -6.6677398681640625e+01 2.9000000000000000e+01 5.9269001007080078e+01 -6.7656097412109375e+01 2.9000000000000000e+01 6.0135101318359375e+01 -6.6905105590820312e+01 2.9000000000000000e+01 5.9669700622558594e+01 -6.7924003601074219e+01 2.9000000000000000e+01 6.0469398498535156e+01 -6.7062400817871094e+01 2.9000000000000000e+01 6.0110900878906250e+01 -6.8118103027343750e+01 2.9000000000000000e+01 6.0830398559570312e+01 -6.7141304016113281e+01 2.9000000000000000e+01 6.2177402496337891e+01 -6.6655899047851562e+01 2.9000000000000000e+01 6.3156097412109375e+01 -6.7231002807617188e+01 2.9000000000000000e+01 6.2405097961425781e+01 -6.6364898681640625e+01 2.9000000000000000e+01 6.3423999786376953e+01 -6.6830299377441406e+01 2.9000000000000000e+01 6.2562397003173828e+01 -6.6030601501464844e+01 2.9000000000000000e+01 6.3618103027343750e+01 -6.6389099121093750e+01 2.9000000000000000e+01 6.2641300201416016e+01 -6.5669601440429688e+01 2.9000000000000000e+01 5.9358699798583984e+01 -6.5330398559570312e+01 2.9000000000000000e+01 5.8235599517822266e+01 -6.5559898376464844e+01 2.9000000000000000e+01 5.9362098693847656e+01 -6.5699798583984375e+01 2.9000000000000000e+01 5.8288101196289062e+01 -6.6039001464843750e+01 2.9000000000000000e+01 5.9447696685791016e+01 -6.6059295654296875e+01 2.9000000000000000e+01 5.8422901153564453e+01 -6.6501800537109375e+01 2.9000000000000000e+01 5.9611099243164062e+01 -6.6390701293945312e+01 2.9000000000000000e+01 5.8635997772216797e+01 -6.6934104919433594e+01 2.9000000000000000e+01 5.8920902252197266e+01 -6.7322799682617188e+01 2.9000000000000000e+01 5.9822601318359375e+01 -6.4344100952148438e+01 2.9000000000000000e+01 5.8843898773193359e+01 -6.3768997192382812e+01 2.9000000000000000e+01 5.9594898223876953e+01 -6.4635101318359375e+01 2.9000000000000000e+01 5.8576000213623047e+01 -6.4169700622558594e+01 2.9000000000000000e+01 5.9437599182128906e+01 -6.4969398498535156e+01 2.9000000000000000e+01 5.8381900787353516e+01 -6.4610900878906250e+01 2.9000000000000000e+01 5.8267196655273438e+01 -6.5079002380371094e+01 2.9000000000000000e+01 6.0578998565673828e+01 -6.8232795715332031e+01 2.9000000000000000e+01 6.1059898376464844e+01 -6.8264404296875000e+01 2.9000000000000000e+01 6.1199798583984375e+01 -6.7137893676757812e+01 2.9000000000000000e+01 6.1539001464843750e+01 -6.8211898803710938e+01 2.9000000000000000e+01 6.1559299468994141e+01 -6.7052299499511719e+01 2.9000000000000000e+01 6.2001796722412109e+01 -6.8077102661132812e+01 2.9000000000000000e+01 6.1890697479248047e+01 -6.6888900756835938e+01 2.9000000000000000e+01 6.2434101104736328e+01 -6.7863998413085938e+01 2.9000000000000000e+01 6.2822795867919922e+01 -6.7579101562500000e+01 2.9000000000000000e+01 6.1169597625732422e+01 -6.3858703613281250e+01 2.9000000000000000e+01 6.0940101623535156e+01 -6.2735603332519531e+01 2.9000000000000000e+01 6.0800197601318359e+01 -6.3862098693847656e+01 2.9000000000000000e+01 6.0460998535156250e+01 -6.2788097381591797e+01 2.9000000000000000e+01 6.0440700531005859e+01 -6.3947700500488281e+01 2.9000000000000000e+01 5.9998199462890625e+01 -6.2922901153564453e+01 2.9000000000000000e+01 6.0109298706054688e+01 -6.4111099243164062e+01 2.9000000000000000e+01 5.9565902709960938e+01 -6.3135997772216797e+01 2.9000000000000000e+01 5.9177200317382812e+01 -6.3420898437500000e+01 2.9000000000000000e+01 6.3732803344726562e+01 -6.5920997619628906e+01 2.9000000000000000e+01 6.3764400482177734e+01 -6.5440101623535156e+01 2.9000000000000000e+01 6.2637901306152344e+01 -6.5300193786621094e+01 2.9000000000000000e+01 6.3711894989013672e+01 -6.4960998535156250e+01 2.9000000000000000e+01 6.2552303314208984e+01 -6.4940696716308594e+01 2.9000000000000000e+01 6.3577098846435547e+01 -6.4498199462890625e+01 2.9000000000000000e+01 6.2388900756835938e+01 -6.4609298706054688e+01 2.9000000000000000e+01 6.3363998413085938e+01 -6.4065902709960938e+01 2.9000000000000000e+01 6.2155899047851562e+01 -6.4322601318359375e+01 2.9000000000000000e+01 6.3079097747802734e+01 -6.3677200317382812e+01 2.9000000000000000e+01 6.2730998992919922e+01 -6.3343898773193359e+01 2.9000000000000000e+01 6.1864902496337891e+01 -6.4094902038574219e+01 2.9000000000000000e+01 6.2330303192138672e+01 -6.3075996398925781e+01 2.9000000000000000e+01 6.1530601501464844e+01 -6.3937595367431641e+01 2.9000000000000000e+01 6.1889099121093750e+01 -6.2881900787353516e+01 2.9000000000000000e+01 6.1420997619628906e+01 -6.2767200469970703e+01 2.9000000000000000e+01 8.8364898681640625e+01 4.9905097961425781e+01 2.4000000000000000e+01 8.9231002807617188e+01 5.0656097412109375e+01 2.4000000000000000e+01 8.8655899047851562e+01 4.9677402496337891e+01 2.4000000000000000e+01 8.9579101562500000e+01 5.0322799682617188e+01 2.4000000000000000e+01 8.8888999938964844e+01 4.9390701293945312e+01 2.4000000000000000e+01 8.9863998413085938e+01 4.9934101104736328e+01 2.4000000000000000e+01 8.9052299499511719e+01 4.9059303283691406e+01 2.4000000000000000e+01 9.0077102661132812e+01 4.9501800537109375e+01 2.4000000000000000e+01 8.9137893676757812e+01 4.8699798583984375e+01 2.4000000000000000e+01 8.7300193786621094e+01 5.0137901306152344e+01 2.4000000000000000e+01 8.7440101623535156e+01 5.1264400482177734e+01 2.4000000000000000e+01 8.7669601440429688e+01 5.0141300201416016e+01 2.4000000000000000e+01 8.7920997619628906e+01 5.1232799530029297e+01 2.4000000000000000e+01 8.8030601501464844e+01 5.0062400817871094e+01 2.4000000000000000e+01 8.8389099121093750e+01 5.1118099212646484e+01 2.4000000000000000e+01 8.8830299377441406e+01 5.0923999786376953e+01 2.4000000000000000e+01 8.5862098693847656e+01 4.8300197601318359e+01 2.4000000000000000e+01 8.4735603332519531e+01 4.8440097808837891e+01 2.4000000000000000e+01 8.5858703613281250e+01 4.8669597625732422e+01 2.4000000000000000e+01 8.4767196655273438e+01 4.8921001434326172e+01 2.4000000000000000e+01 8.5937599182128906e+01 4.9030597686767578e+01 2.4000000000000000e+01 8.4881904602050781e+01 4.9389102935791016e+01 2.4000000000000000e+01 8.6094902038574219e+01 4.9364898681640625e+01 2.4000000000000000e+01 8.6635101318359375e+01 4.7094902038574219e+01 2.4000000000000000e+01 8.5768997192382812e+01 4.6343898773193359e+01 2.4000000000000000e+01 8.6344100952148438e+01 4.7322601318359375e+01 2.4000000000000000e+01 8.5420898437500000e+01 4.6677196502685547e+01 2.4000000000000000e+01 8.6111000061035156e+01 4.7609298706054688e+01 2.4000000000000000e+01 8.5135993957519531e+01 4.7065898895263672e+01 2.4000000000000000e+01 8.5947700500488281e+01 4.7940700531005859e+01 2.4000000000000000e+01 8.4922904968261719e+01 4.7498199462890625e+01 2.4000000000000000e+01 8.4788101196289062e+01 4.7960899353027344e+01 2.4000000000000000e+01 8.8905105590820312e+01 4.7635101318359375e+01 2.4000000000000000e+01 8.9656097412109375e+01 4.6769001007080078e+01 2.4000000000000000e+01 8.8677398681640625e+01 4.7344100952148438e+01 2.4000000000000000e+01 8.9322799682617188e+01 4.6420898437500000e+01 2.4000000000000000e+01 8.8390701293945312e+01 4.7111000061035156e+01 2.4000000000000000e+01 8.8934104919433594e+01 4.6135997772216797e+01 2.4000000000000000e+01 8.8059295654296875e+01 4.6947700500488281e+01 2.4000000000000000e+01 8.8501800537109375e+01 4.5922901153564453e+01 2.4000000000000000e+01 8.7699798583984375e+01 4.6862098693847656e+01 2.4000000000000000e+01 8.5075996398925781e+01 4.9830299377441406e+01 2.4000000000000000e+01 8.5343894958496094e+01 5.0230998992919922e+01 2.4000000000000000e+01 8.6322601318359375e+01 4.9655899047851562e+01 2.4000000000000000e+01 8.5677200317382812e+01 5.0579101562500000e+01 2.4000000000000000e+01 8.6609298706054688e+01 4.9888999938964844e+01 2.4000000000000000e+01 8.6065902709960938e+01 5.0863998413085938e+01 2.4000000000000000e+01 8.6940696716308594e+01 5.0052299499511719e+01 2.4000000000000000e+01 8.6498199462890625e+01 5.1077102661132812e+01 2.4000000000000000e+01 8.6960899353027344e+01 5.1211902618408203e+01 2.4000000000000000e+01 8.8039100646972656e+01 4.5788101196289062e+01 2.4000000000000000e+01 8.7559898376464844e+01 4.5735599517822266e+01 2.4000000000000000e+01 8.7330398559570312e+01 4.6858703613281250e+01 2.4000000000000000e+01 8.7079002380371094e+01 4.5767200469970703e+01 2.4000000000000000e+01 8.6969398498535156e+01 4.6937599182128906e+01 2.4000000000000000e+01 8.6610900878906250e+01 4.5881900787353516e+01 2.4000000000000000e+01 8.6169700622558594e+01 4.6076000213623047e+01 2.4000000000000000e+01 9.0211898803710938e+01 4.9039100646972656e+01 2.4000000000000000e+01 9.0264404296875000e+01 4.8559902191162109e+01 2.4000000000000000e+01 8.9141304016113281e+01 4.8330398559570312e+01 2.4000000000000000e+01 9.0232795715332031e+01 4.8078998565673828e+01 2.4000000000000000e+01 8.9062400817871094e+01 4.7969402313232422e+01 2.4000000000000000e+01 9.0118103027343750e+01 4.7610900878906250e+01 2.4000000000000000e+01 8.9924003601074219e+01 4.7169700622558594e+01 2.4000000000000000e+01 8.6344100952148438e+01 4.7322601318359375e+01 2.9000000000000000e+01 8.5768997192382812e+01 4.6343898773193359e+01 2.9000000000000000e+01 8.6635101318359375e+01 4.7094902038574219e+01 2.9000000000000000e+01 8.6169700622558594e+01 4.6076000213623047e+01 2.9000000000000000e+01 8.6969398498535156e+01 4.6937599182128906e+01 2.9000000000000000e+01 8.6610900878906250e+01 4.5881900787353516e+01 2.9000000000000000e+01 8.7330398559570312e+01 4.6858703613281250e+01 2.9000000000000000e+01 8.8677398681640625e+01 4.7344100952148438e+01 2.9000000000000000e+01 8.9656097412109375e+01 4.6769001007080078e+01 2.9000000000000000e+01 8.8905105590820312e+01 4.7635101318359375e+01 2.9000000000000000e+01 8.9924003601074219e+01 4.7169700622558594e+01 2.9000000000000000e+01 8.9062400817871094e+01 4.7969402313232422e+01 2.9000000000000000e+01 9.0118103027343750e+01 4.7610900878906250e+01 2.9000000000000000e+01 8.9141304016113281e+01 4.8330398559570312e+01 2.9000000000000000e+01 8.5858703613281250e+01 4.8669597625732422e+01 2.9000000000000000e+01 8.4735603332519531e+01 4.8440097808837891e+01 2.9000000000000000e+01 8.5862098693847656e+01 4.8300197601318359e+01 2.9000000000000000e+01 8.4788101196289062e+01 4.7960899353027344e+01 2.9000000000000000e+01 8.5947700500488281e+01 4.7940700531005859e+01 2.9000000000000000e+01 8.4922904968261719e+01 4.7498199462890625e+01 2.9000000000000000e+01 8.6111000061035156e+01 4.7609298706054688e+01 2.9000000000000000e+01 8.5135993957519531e+01 4.7065898895263672e+01 2.9000000000000000e+01 8.5420898437500000e+01 4.6677196502685547e+01 2.9000000000000000e+01 8.6322601318359375e+01 4.9655899047851562e+01 2.9000000000000000e+01 8.5343894958496094e+01 5.0230998992919922e+01 2.9000000000000000e+01 8.6094902038574219e+01 4.9364898681640625e+01 2.9000000000000000e+01 8.5075996398925781e+01 4.9830299377441406e+01 2.9000000000000000e+01 8.5937599182128906e+01 4.9030597686767578e+01 2.9000000000000000e+01 8.4881904602050781e+01 4.9389102935791016e+01 2.9000000000000000e+01 8.4767196655273438e+01 4.8921001434326172e+01 2.9000000000000000e+01 8.7079002380371094e+01 4.5767200469970703e+01 2.9000000000000000e+01 8.7559898376464844e+01 4.5735599517822266e+01 2.9000000000000000e+01 8.7699798583984375e+01 4.6862098693847656e+01 2.9000000000000000e+01 8.8039100646972656e+01 4.5788101196289062e+01 2.9000000000000000e+01 8.8059295654296875e+01 4.6947700500488281e+01 2.9000000000000000e+01 8.8501800537109375e+01 4.5922901153564453e+01 2.9000000000000000e+01 8.8390701293945312e+01 4.7111000061035156e+01 2.9000000000000000e+01 8.8934104919433594e+01 4.6135997772216797e+01 2.9000000000000000e+01 8.9322799682617188e+01 4.6420898437500000e+01 2.9000000000000000e+01 8.7669601440429688e+01 5.0141300201416016e+01 2.9000000000000000e+01 8.7440101623535156e+01 5.1264400482177734e+01 2.9000000000000000e+01 8.7300193786621094e+01 5.0137901306152344e+01 2.9000000000000000e+01 8.6960899353027344e+01 5.1211902618408203e+01 2.9000000000000000e+01 8.6940696716308594e+01 5.0052299499511719e+01 2.9000000000000000e+01 8.6498199462890625e+01 5.1077102661132812e+01 2.9000000000000000e+01 8.6609298706054688e+01 4.9888999938964844e+01 2.9000000000000000e+01 8.6065902709960938e+01 5.0863998413085938e+01 2.9000000000000000e+01 8.5677200317382812e+01 5.0579101562500000e+01 2.9000000000000000e+01 9.0232795715332031e+01 4.8078998565673828e+01 2.9000000000000000e+01 9.0264404296875000e+01 4.8559902191162109e+01 2.9000000000000000e+01 8.9137893676757812e+01 4.8699798583984375e+01 2.9000000000000000e+01 9.0211898803710938e+01 4.9039100646972656e+01 2.9000000000000000e+01 8.9052299499511719e+01 4.9059303283691406e+01 2.9000000000000000e+01 9.0077102661132812e+01 4.9501800537109375e+01 2.9000000000000000e+01 8.8888999938964844e+01 4.9390701293945312e+01 2.9000000000000000e+01 8.9863998413085938e+01 4.9934101104736328e+01 2.9000000000000000e+01 8.8655899047851562e+01 4.9677402496337891e+01 2.9000000000000000e+01 8.9579101562500000e+01 5.0322799682617188e+01 2.9000000000000000e+01 8.9231002807617188e+01 5.0656097412109375e+01 2.9000000000000000e+01 8.8364898681640625e+01 4.9905097961425781e+01 2.9000000000000000e+01 8.8830299377441406e+01 5.0923999786376953e+01 2.9000000000000000e+01 8.8030601501464844e+01 5.0062400817871094e+01 2.9000000000000000e+01 8.8389099121093750e+01 5.1118099212646484e+01 2.9000000000000000e+01 8.7920997619628906e+01 5.1232799530029297e+01 2.9000000000000000e+01 6.1864902496337891e+01 6.6905105590820312e+01 2.4000000000000000e+01 6.2730998992919922e+01 6.7656097412109375e+01 2.4000000000000000e+01 6.2155899047851562e+01 6.6677398681640625e+01 2.4000000000000000e+01 6.3079097747802734e+01 6.7322799682617188e+01 2.4000000000000000e+01 6.2388900756835938e+01 6.6390701293945312e+01 2.4000000000000000e+01 6.3363998413085938e+01 6.6934104919433594e+01 2.4000000000000000e+01 6.2552303314208984e+01 6.6059295654296875e+01 2.4000000000000000e+01 6.3577098846435547e+01 6.6501800537109375e+01 2.4000000000000000e+01 6.2637901306152344e+01 6.5699798583984375e+01 2.4000000000000000e+01 6.0800197601318359e+01 6.7137893676757812e+01 2.4000000000000000e+01 6.0940101623535156e+01 6.8264404296875000e+01 2.4000000000000000e+01 6.1169597625732422e+01 6.7141304016113281e+01 2.4000000000000000e+01 6.1420997619628906e+01 6.8232795715332031e+01 2.4000000000000000e+01 6.1530601501464844e+01 6.7062400817871094e+01 2.4000000000000000e+01 6.1889099121093750e+01 6.8118103027343750e+01 2.4000000000000000e+01 6.2330303192138672e+01 6.7924003601074219e+01 2.4000000000000000e+01 5.9362098693847656e+01 6.5300193786621094e+01 2.4000000000000000e+01 5.8235599517822266e+01 6.5440101623535156e+01 2.4000000000000000e+01 5.9358699798583984e+01 6.5669601440429688e+01 2.4000000000000000e+01 5.8267196655273438e+01 6.5920997619628906e+01 2.4000000000000000e+01 5.9437599182128906e+01 6.6030601501464844e+01 2.4000000000000000e+01 5.8381900787353516e+01 6.6389099121093750e+01 2.4000000000000000e+01 5.9594898223876953e+01 6.6364898681640625e+01 2.4000000000000000e+01 6.0135101318359375e+01 6.4094902038574219e+01 2.4000000000000000e+01 5.9269001007080078e+01 6.3343898773193359e+01 2.4000000000000000e+01 5.9844097137451172e+01 6.4322601318359375e+01 2.4000000000000000e+01 5.8920902252197266e+01 6.3677200317382812e+01 2.4000000000000000e+01 5.9611099243164062e+01 6.4609298706054688e+01 2.4000000000000000e+01 5.8635997772216797e+01 6.4065902709960938e+01 2.4000000000000000e+01 5.9447696685791016e+01 6.4940696716308594e+01 2.4000000000000000e+01 5.8422901153564453e+01 6.4498199462890625e+01 2.4000000000000000e+01 5.8288101196289062e+01 6.4960998535156250e+01 2.4000000000000000e+01 6.2405097961425781e+01 6.4635101318359375e+01 2.4000000000000000e+01 6.3156097412109375e+01 6.3768997192382812e+01 2.4000000000000000e+01 6.2177402496337891e+01 6.4344100952148438e+01 2.4000000000000000e+01 6.2822795867919922e+01 6.3420898437500000e+01 2.4000000000000000e+01 6.1890697479248047e+01 6.4111099243164062e+01 2.4000000000000000e+01 6.2434101104736328e+01 6.3135997772216797e+01 2.4000000000000000e+01 6.1559299468994141e+01 6.3947700500488281e+01 2.4000000000000000e+01 6.2001796722412109e+01 6.2922901153564453e+01 2.4000000000000000e+01 6.1199798583984375e+01 6.3862098693847656e+01 2.4000000000000000e+01 5.8576000213623047e+01 6.6830299377441406e+01 2.4000000000000000e+01 5.8843898773193359e+01 6.7231002807617188e+01 2.4000000000000000e+01 5.9822601318359375e+01 6.6655899047851562e+01 2.4000000000000000e+01 5.9177200317382812e+01 6.7579101562500000e+01 2.4000000000000000e+01 6.0109298706054688e+01 6.6888900756835938e+01 2.4000000000000000e+01 5.9565902709960938e+01 6.7863998413085938e+01 2.4000000000000000e+01 6.0440700531005859e+01 6.7052299499511719e+01 2.4000000000000000e+01 5.9998199462890625e+01 6.8077102661132812e+01 2.4000000000000000e+01 6.0460998535156250e+01 6.8211898803710938e+01 2.4000000000000000e+01 6.1539001464843750e+01 6.2788097381591797e+01 2.4000000000000000e+01 6.1059898376464844e+01 6.2735603332519531e+01 2.4000000000000000e+01 6.0830398559570312e+01 6.3858703613281250e+01 2.4000000000000000e+01 6.0578998565673828e+01 6.2767200469970703e+01 2.4000000000000000e+01 6.0469398498535156e+01 6.3937595367431641e+01 2.4000000000000000e+01 6.0110900878906250e+01 6.2881900787353516e+01 2.4000000000000000e+01 5.9669700622558594e+01 6.3075996398925781e+01 2.4000000000000000e+01 6.3711894989013672e+01 6.6039001464843750e+01 2.4000000000000000e+01 6.3764400482177734e+01 6.5559898376464844e+01 2.4000000000000000e+01 6.2641300201416016e+01 6.5330398559570312e+01 2.4000000000000000e+01 6.3732803344726562e+01 6.5079002380371094e+01 2.4000000000000000e+01 6.2562397003173828e+01 6.4969398498535156e+01 2.4000000000000000e+01 6.3618103027343750e+01 6.4610900878906250e+01 2.4000000000000000e+01 6.3423999786376953e+01 6.4169700622558594e+01 2.4000000000000000e+01 5.9844097137451172e+01 6.4322601318359375e+01 2.9000000000000000e+01 5.9269001007080078e+01 6.3343898773193359e+01 2.9000000000000000e+01 6.0135101318359375e+01 6.4094902038574219e+01 2.9000000000000000e+01 5.9669700622558594e+01 6.3075996398925781e+01 2.9000000000000000e+01 6.0469398498535156e+01 6.3937595367431641e+01 2.9000000000000000e+01 6.0110900878906250e+01 6.2881900787353516e+01 2.9000000000000000e+01 6.0830398559570312e+01 6.3858703613281250e+01 2.9000000000000000e+01 6.2177402496337891e+01 6.4344100952148438e+01 2.9000000000000000e+01 6.3156097412109375e+01 6.3768997192382812e+01 2.9000000000000000e+01 6.2405097961425781e+01 6.4635101318359375e+01 2.9000000000000000e+01 6.3423999786376953e+01 6.4169700622558594e+01 2.9000000000000000e+01 6.2562397003173828e+01 6.4969398498535156e+01 2.9000000000000000e+01 6.3618103027343750e+01 6.4610900878906250e+01 2.9000000000000000e+01 6.2641300201416016e+01 6.5330398559570312e+01 2.9000000000000000e+01 5.9358699798583984e+01 6.5669601440429688e+01 2.9000000000000000e+01 5.8235599517822266e+01 6.5440101623535156e+01 2.9000000000000000e+01 5.9362098693847656e+01 6.5300193786621094e+01 2.9000000000000000e+01 5.8288101196289062e+01 6.4960998535156250e+01 2.9000000000000000e+01 5.9447696685791016e+01 6.4940696716308594e+01 2.9000000000000000e+01 5.8422901153564453e+01 6.4498199462890625e+01 2.9000000000000000e+01 5.9611099243164062e+01 6.4609298706054688e+01 2.9000000000000000e+01 5.8635997772216797e+01 6.4065902709960938e+01 2.9000000000000000e+01 5.8920902252197266e+01 6.3677200317382812e+01 2.9000000000000000e+01 5.9822601318359375e+01 6.6655899047851562e+01 2.9000000000000000e+01 5.8843898773193359e+01 6.7231002807617188e+01 2.9000000000000000e+01 5.9594898223876953e+01 6.6364898681640625e+01 2.9000000000000000e+01 5.8576000213623047e+01 6.6830299377441406e+01 2.9000000000000000e+01 5.9437599182128906e+01 6.6030601501464844e+01 2.9000000000000000e+01 5.8381900787353516e+01 6.6389099121093750e+01 2.9000000000000000e+01 5.8267196655273438e+01 6.5920997619628906e+01 2.9000000000000000e+01 6.0578998565673828e+01 6.2767200469970703e+01 2.9000000000000000e+01 6.1059898376464844e+01 6.2735603332519531e+01 2.9000000000000000e+01 6.1199798583984375e+01 6.3862098693847656e+01 2.9000000000000000e+01 6.1539001464843750e+01 6.2788097381591797e+01 2.9000000000000000e+01 6.1559299468994141e+01 6.3947700500488281e+01 2.9000000000000000e+01 6.2001796722412109e+01 6.2922901153564453e+01 2.9000000000000000e+01 6.1890697479248047e+01 6.4111099243164062e+01 2.9000000000000000e+01 6.2434101104736328e+01 6.3135997772216797e+01 2.9000000000000000e+01 6.2822795867919922e+01 6.3420898437500000e+01 2.9000000000000000e+01 6.1169597625732422e+01 6.7141304016113281e+01 2.9000000000000000e+01 6.0940101623535156e+01 6.8264404296875000e+01 2.9000000000000000e+01 6.0800197601318359e+01 6.7137893676757812e+01 2.9000000000000000e+01 6.0460998535156250e+01 6.8211898803710938e+01 2.9000000000000000e+01 6.0440700531005859e+01 6.7052299499511719e+01 2.9000000000000000e+01 5.9998199462890625e+01 6.8077102661132812e+01 2.9000000000000000e+01 6.0109298706054688e+01 6.6888900756835938e+01 2.9000000000000000e+01 5.9565902709960938e+01 6.7863998413085938e+01 2.9000000000000000e+01 5.9177200317382812e+01 6.7579101562500000e+01 2.9000000000000000e+01 6.3732803344726562e+01 6.5079002380371094e+01 2.9000000000000000e+01 6.3764400482177734e+01 6.5559898376464844e+01 2.9000000000000000e+01 6.2637901306152344e+01 6.5699798583984375e+01 2.9000000000000000e+01 6.3711894989013672e+01 6.6039001464843750e+01 2.9000000000000000e+01 6.2552303314208984e+01 6.6059295654296875e+01 2.9000000000000000e+01 6.3577098846435547e+01 6.6501800537109375e+01 2.9000000000000000e+01 6.2388900756835938e+01 6.6390701293945312e+01 2.9000000000000000e+01 6.3363998413085938e+01 6.6934104919433594e+01 2.9000000000000000e+01 6.2155899047851562e+01 6.6677398681640625e+01 2.9000000000000000e+01 6.3079097747802734e+01 6.7322799682617188e+01 2.9000000000000000e+01 6.2730998992919922e+01 6.7656097412109375e+01 2.9000000000000000e+01 6.1864902496337891e+01 6.6905105590820312e+01 2.9000000000000000e+01 6.2330303192138672e+01 6.7924003601074219e+01 2.9000000000000000e+01 6.1530601501464844e+01 6.7062400817871094e+01 2.9000000000000000e+01 6.1889099121093750e+01 6.8118103027343750e+01 2.9000000000000000e+01 6.1420997619628906e+01 6.8232795715332031e+01 2.9000000000000000e+01 8.8364898681640625e+01 9.9405105590820312e+01 2.4000000000000000e+01 8.9231002807617188e+01 1.0015599822998047e+02 2.4000000000000000e+01 8.8655899047851562e+01 9.9177398681640625e+01 2.4000000000000000e+01 8.9579101562500000e+01 9.9822799682617188e+01 2.4000000000000000e+01 8.8888999938964844e+01 9.8890701293945312e+01 2.4000000000000000e+01 8.9863998413085938e+01 9.9434097290039062e+01 2.4000000000000000e+01 8.9052299499511719e+01 9.8559295654296875e+01 2.4000000000000000e+01 9.0077102661132812e+01 9.9001800537109375e+01 2.4000000000000000e+01 8.9137893676757812e+01 9.8199798583984375e+01 2.4000000000000000e+01 8.7300193786621094e+01 9.9637901306152344e+01 2.4000000000000000e+01 8.7440101623535156e+01 1.0076399993896484e+02 2.4000000000000000e+01 8.7669601440429688e+01 9.9641304016113281e+01 2.4000000000000000e+01 8.7920997619628906e+01 1.0073299407958984e+02 2.4000000000000000e+01 8.8030601501464844e+01 9.9562400817871094e+01 2.4000000000000000e+01 8.8389099121093750e+01 1.0061799621582031e+02 2.4000000000000000e+01 8.8830299377441406e+01 1.0042399597167969e+02 2.4000000000000000e+01 8.5862098693847656e+01 9.7800201416015625e+01 2.4000000000000000e+01 8.4735603332519531e+01 9.7940101623535156e+01 2.4000000000000000e+01 8.5858703613281250e+01 9.8169601440429688e+01 2.4000000000000000e+01 8.4767196655273438e+01 9.8420997619628906e+01 2.4000000000000000e+01 8.5937599182128906e+01 9.8530601501464844e+01 2.4000000000000000e+01 8.4881904602050781e+01 9.8889099121093750e+01 2.4000000000000000e+01 8.6094902038574219e+01 9.8864898681640625e+01 2.4000000000000000e+01 8.6635101318359375e+01 9.6594902038574219e+01 2.4000000000000000e+01 8.5768997192382812e+01 9.5843902587890625e+01 2.4000000000000000e+01 8.6344100952148438e+01 9.6822593688964844e+01 2.4000000000000000e+01 8.5420898437500000e+01 9.6177200317382812e+01 2.4000000000000000e+01 8.6111000061035156e+01 9.7109306335449219e+01 2.4000000000000000e+01 8.5135993957519531e+01 9.6565902709960938e+01 2.4000000000000000e+01 8.5947700500488281e+01 9.7440696716308594e+01 2.4000000000000000e+01 8.4922904968261719e+01 9.6998199462890625e+01 2.4000000000000000e+01 8.4788101196289062e+01 9.7460998535156250e+01 2.4000000000000000e+01 8.8905105590820312e+01 9.7135093688964844e+01 2.4000000000000000e+01 8.9656097412109375e+01 9.6268997192382812e+01 2.4000000000000000e+01 8.8677398681640625e+01 9.6844100952148438e+01 2.4000000000000000e+01 8.9322799682617188e+01 9.5920898437500000e+01 2.4000000000000000e+01 8.8390701293945312e+01 9.6611099243164062e+01 2.4000000000000000e+01 8.8934104919433594e+01 9.5636001586914062e+01 2.4000000000000000e+01 8.8059295654296875e+01 9.6447700500488281e+01 2.4000000000000000e+01 8.8501800537109375e+01 9.5422904968261719e+01 2.4000000000000000e+01 8.7699798583984375e+01 9.6362098693847656e+01 2.4000000000000000e+01 8.5075996398925781e+01 9.9330299377441406e+01 2.4000000000000000e+01 8.5343894958496094e+01 9.9730995178222656e+01 2.4000000000000000e+01 8.6322601318359375e+01 9.9155899047851562e+01 2.4000000000000000e+01 8.5677200317382812e+01 1.0007900238037109e+02 2.4000000000000000e+01 8.6609298706054688e+01 9.9388900756835938e+01 2.4000000000000000e+01 8.6065902709960938e+01 1.0036399841308594e+02 2.4000000000000000e+01 8.6940696716308594e+01 9.9552307128906250e+01 2.4000000000000000e+01 8.6498199462890625e+01 1.0057699584960938e+02 2.4000000000000000e+01 8.6960899353027344e+01 1.0071199798583984e+02 2.4000000000000000e+01 8.8039100646972656e+01 9.5288101196289062e+01 2.4000000000000000e+01 8.7559898376464844e+01 9.5235603332519531e+01 2.4000000000000000e+01 8.7330398559570312e+01 9.6358703613281250e+01 2.4000000000000000e+01 8.7079002380371094e+01 9.5267196655273438e+01 2.4000000000000000e+01 8.6969398498535156e+01 9.6437606811523438e+01 2.4000000000000000e+01 8.6610900878906250e+01 9.5381896972656250e+01 2.4000000000000000e+01 8.6169700622558594e+01 9.5576004028320312e+01 2.4000000000000000e+01 9.0211898803710938e+01 9.8539001464843750e+01 2.4000000000000000e+01 9.0264404296875000e+01 9.8059898376464844e+01 2.4000000000000000e+01 8.9141304016113281e+01 9.7830398559570312e+01 2.4000000000000000e+01 9.0232795715332031e+01 9.7579002380371094e+01 2.4000000000000000e+01 8.9062400817871094e+01 9.7469398498535156e+01 2.4000000000000000e+01 9.0118103027343750e+01 9.7110900878906250e+01 2.4000000000000000e+01 8.9924003601074219e+01 9.6669700622558594e+01 2.4000000000000000e+01 8.6344100952148438e+01 9.6822593688964844e+01 2.9000000000000000e+01 8.5768997192382812e+01 9.5843902587890625e+01 2.9000000000000000e+01 8.6635101318359375e+01 9.6594902038574219e+01 2.9000000000000000e+01 8.6169700622558594e+01 9.5576004028320312e+01 2.9000000000000000e+01 8.6969398498535156e+01 9.6437606811523438e+01 2.9000000000000000e+01 8.6610900878906250e+01 9.5381896972656250e+01 2.9000000000000000e+01 8.7330398559570312e+01 9.6358703613281250e+01 2.9000000000000000e+01 8.8677398681640625e+01 9.6844100952148438e+01 2.9000000000000000e+01 8.9656097412109375e+01 9.6268997192382812e+01 2.9000000000000000e+01 8.8905105590820312e+01 9.7135093688964844e+01 2.9000000000000000e+01 8.9924003601074219e+01 9.6669700622558594e+01 2.9000000000000000e+01 8.9062400817871094e+01 9.7469398498535156e+01 2.9000000000000000e+01 9.0118103027343750e+01 9.7110900878906250e+01 2.9000000000000000e+01 8.9141304016113281e+01 9.7830398559570312e+01 2.9000000000000000e+01 8.5858703613281250e+01 9.8169601440429688e+01 2.9000000000000000e+01 8.4735603332519531e+01 9.7940101623535156e+01 2.9000000000000000e+01 8.5862098693847656e+01 9.7800201416015625e+01 2.9000000000000000e+01 8.4788101196289062e+01 9.7460998535156250e+01 2.9000000000000000e+01 8.5947700500488281e+01 9.7440696716308594e+01 2.9000000000000000e+01 8.4922904968261719e+01 9.6998199462890625e+01 2.9000000000000000e+01 8.6111000061035156e+01 9.7109306335449219e+01 2.9000000000000000e+01 8.5135993957519531e+01 9.6565902709960938e+01 2.9000000000000000e+01 8.5420898437500000e+01 9.6177200317382812e+01 2.9000000000000000e+01 8.6322601318359375e+01 9.9155899047851562e+01 2.9000000000000000e+01 8.5343894958496094e+01 9.9730995178222656e+01 2.9000000000000000e+01 8.6094902038574219e+01 9.8864898681640625e+01 2.9000000000000000e+01 8.5075996398925781e+01 9.9330299377441406e+01 2.9000000000000000e+01 8.5937599182128906e+01 9.8530601501464844e+01 2.9000000000000000e+01 8.4881904602050781e+01 9.8889099121093750e+01 2.9000000000000000e+01 8.4767196655273438e+01 9.8420997619628906e+01 2.9000000000000000e+01 8.7079002380371094e+01 9.5267196655273438e+01 2.9000000000000000e+01 8.7559898376464844e+01 9.5235603332519531e+01 2.9000000000000000e+01 8.7699798583984375e+01 9.6362098693847656e+01 2.9000000000000000e+01 8.8039100646972656e+01 9.5288101196289062e+01 2.9000000000000000e+01 8.8059295654296875e+01 9.6447700500488281e+01 2.9000000000000000e+01 8.8501800537109375e+01 9.5422904968261719e+01 2.9000000000000000e+01 8.8390701293945312e+01 9.6611099243164062e+01 2.9000000000000000e+01 8.8934104919433594e+01 9.5636001586914062e+01 2.9000000000000000e+01 8.9322799682617188e+01 9.5920898437500000e+01 2.9000000000000000e+01 8.7669601440429688e+01 9.9641304016113281e+01 2.9000000000000000e+01 8.7440101623535156e+01 1.0076399993896484e+02 2.9000000000000000e+01 8.7300193786621094e+01 9.9637901306152344e+01 2.9000000000000000e+01 8.6960899353027344e+01 1.0071199798583984e+02 2.9000000000000000e+01 8.6940696716308594e+01 9.9552307128906250e+01 2.9000000000000000e+01 8.6498199462890625e+01 1.0057699584960938e+02 2.9000000000000000e+01 8.6609298706054688e+01 9.9388900756835938e+01 2.9000000000000000e+01 8.6065902709960938e+01 1.0036399841308594e+02 2.9000000000000000e+01 8.5677200317382812e+01 1.0007900238037109e+02 2.9000000000000000e+01 9.0232795715332031e+01 9.7579002380371094e+01 2.9000000000000000e+01 9.0264404296875000e+01 9.8059898376464844e+01 2.9000000000000000e+01 8.9137893676757812e+01 9.8199798583984375e+01 2.9000000000000000e+01 9.0211898803710938e+01 9.8539001464843750e+01 2.9000000000000000e+01 8.9052299499511719e+01 9.8559295654296875e+01 2.9000000000000000e+01 9.0077102661132812e+01 9.9001800537109375e+01 2.9000000000000000e+01 8.8888999938964844e+01 9.8890701293945312e+01 2.9000000000000000e+01 8.9863998413085938e+01 9.9434097290039062e+01 2.9000000000000000e+01 8.8655899047851562e+01 9.9177398681640625e+01 2.9000000000000000e+01 8.9579101562500000e+01 9.9822799682617188e+01 2.9000000000000000e+01 8.9231002807617188e+01 1.0015599822998047e+02 2.9000000000000000e+01 8.8364898681640625e+01 9.9405105590820312e+01 2.9000000000000000e+01 8.8830299377441406e+01 1.0042399597167969e+02 2.9000000000000000e+01 8.8030601501464844e+01 9.9562400817871094e+01 2.9000000000000000e+01 8.8389099121093750e+01 1.0061799621582031e+02 2.9000000000000000e+01 8.7920997619628906e+01 1.0073299407958984e+02 2.9000000000000000e+01 8.8869697570800781e+01 -9.7616203308105469e+01 2.2701799392700195e+01 8.8826301574707031e+01 -9.7486198425292969e+01 3.8587200164794922e+01 8.8922393798828125e+01 -9.8000000000000000e+01 3.8587200164794922e+01 8.8542602539062500e+01 -9.7048698425292969e+01 2.2701799392700195e+01 8.8551200866699219e+01 -9.7041694641113281e+01 3.8587200164794922e+01 8.8715301513671875e+01 -9.7260902404785156e+01 2.2701799392700195e+01 8.8815299987792969e+01 -9.7491004943847656e+01 2.2701799392700195e+01 8.8470901489257812e+01 -9.6960502624511719e+01 2.2701799392700195e+01 8.8154396057128906e+01 -9.6737098693847656e+01 2.2701799392700195e+01 8.8133995056152344e+01 -9.6726699829101562e+01 3.8587200164794922e+01 8.8133003234863281e+01 -9.6729499816894531e+01 2.2701799392700195e+01 8.7789398193359375e+01 -9.6607398986816406e+01 2.2701799392700195e+01 8.7631202697753906e+01 -9.6583702087402344e+01 3.8587200164794922e+01 8.7112701416015625e+01 -9.6641197204589844e+01 2.2701799392700195e+01 8.7110694885253906e+01 -9.6631896972656250e+01 3.8587200164794922e+01 8.7402900695800781e+01 -9.6580902099609375e+01 2.2701799392700195e+01 8.7630401611328125e+01 -9.6596504211425781e+01 2.2701799392700195e+01 8.7023696899414062e+01 -9.6659698486328125e+01 2.2701799392700195e+01 8.6679695129394531e+01 -9.6837898254394531e+01 2.2701799392700195e+01 8.6642799377441406e+01 -9.6864898681640625e+01 3.8587200164794922e+01 8.6646598815917969e+01 -9.6868904113769531e+01 2.2701799392700195e+01 8.6396598815917969e+01 -9.7102302551269531e+01 2.2701799392700195e+01 8.6290596008300781e+01 -9.7251197814941406e+01 3.8587200164794922e+01 8.6301902770996094e+01 -9.7258094787597656e+01 2.2701799392700195e+01 8.6195404052734375e+01 -9.7433296203613281e+01 2.2701799392700195e+01 8.6101799011230469e+01 -9.7738601684570312e+01 3.8587200164794922e+01 8.6109199523925781e+01 -9.7740699768066406e+01 2.2701799392700195e+01 8.6101799011230469e+01 -9.8261398315429688e+01 3.8587200164794922e+01 8.6090805053710938e+01 -9.7806297302246094e+01 2.2701799392700195e+01 8.6090805053710938e+01 -9.8193695068359375e+01 2.2701799392700195e+01 8.6109199523925781e+01 -9.8259300231933594e+01 2.2701799392700195e+01 8.6195404052734375e+01 -9.8566703796386719e+01 2.2701799392700195e+01 8.6290596008300781e+01 -9.8748802185058594e+01 3.8587200164794922e+01 8.6301902770996094e+01 -9.8741897583007812e+01 2.2701799392700195e+01 8.6396598815917969e+01 -9.8897705078125000e+01 2.2701799392700195e+01 8.6642799377441406e+01 -9.9135101318359375e+01 3.8587200164794922e+01 8.6646598815917969e+01 -9.9131103515625000e+01 2.2701799392700195e+01 8.7110694885253906e+01 -9.9368103027343750e+01 3.8587200164794922e+01 8.6679695129394531e+01 -9.9162101745605469e+01 2.2701799392700195e+01 8.7023696899414062e+01 -9.9340293884277344e+01 2.2701799392700195e+01 8.7112701416015625e+01 -9.9358795166015625e+01 2.2701799392700195e+01 8.7402900695800781e+01 -9.9419105529785156e+01 2.2701799392700195e+01 8.7631202697753906e+01 -9.9416297912597656e+01 3.8587200164794922e+01 8.7630401611328125e+01 -9.9403503417968750e+01 2.2701799392700195e+01 8.7789398193359375e+01 -9.9392601013183594e+01 2.2701799392700195e+01 8.8133995056152344e+01 -9.9273300170898438e+01 3.8587200164794922e+01 8.8133003234863281e+01 -9.9270500183105469e+01 2.2701799392700195e+01 8.8551200866699219e+01 -9.8958297729492188e+01 3.8587200164794922e+01 8.8154396057128906e+01 -9.9262901306152344e+01 2.2701799392700195e+01 8.8470901489257812e+01 -9.9039505004882812e+01 2.2701799392700195e+01 8.8542602539062500e+01 -9.8951301574707031e+01 2.2701799392700195e+01 8.8715301513671875e+01 -9.8739105224609375e+01 2.2701799392700195e+01 8.8826301574707031e+01 -9.8513793945312500e+01 3.8587200164794922e+01 8.8815299987792969e+01 -9.8508995056152344e+01 2.2701799392700195e+01 8.8869697570800781e+01 -9.8383796691894531e+01 2.2701799392700195e+01 8.8922393798828125e+01 -9.8000000000000000e+01 2.2701799392700195e+01 9.0065498352050781e+01 -9.7489700317382812e+01 2.1279600143432617e+01 9.0007301330566406e+01 -9.7297805786132812e+01 2.1279600143432617e+01 8.9916702270507812e+01 -9.6999000549316406e+01 2.1279600143432617e+01 8.9727401733398438e+01 -9.6644897460937500e+01 2.1279600143432617e+01 8.9675003051757812e+01 -9.6546699523925781e+01 2.1279600143432617e+01 8.9349594116210938e+01 -9.6150398254394531e+01 2.1279600143432617e+01 8.9280799865722656e+01 -9.6093902587890625e+01 2.1279600143432617e+01 8.8953300476074219e+01 -9.5825096130371094e+01 2.1279600143432617e+01 8.8697593688964844e+01 -9.5688400268554688e+01 2.1279600143432617e+01 8.8500999450683594e+01 -9.5583297729492188e+01 2.1279600143432617e+01 8.8031600952148438e+01 -9.5440902709960938e+01 2.1279600143432617e+01 8.8010307312011719e+01 -9.5434501647949219e+01 2.1279600143432617e+01 8.7500000000000000e+01 -9.5384201049804688e+01 2.1279600143432617e+01 8.7322601318359375e+01 -9.5401695251464844e+01 2.1279600143432617e+01 8.6989700317382812e+01 -9.5434501647949219e+01 2.1279600143432617e+01 8.6626800537109375e+01 -9.5544502258300781e+01 2.1279600143432617e+01 8.6499000549316406e+01 -9.5583297729492188e+01 2.1279600143432617e+01 8.6046699523925781e+01 -9.5825096130371094e+01 2.1279600143432617e+01 8.5995101928710938e+01 -9.5867401123046875e+01 2.1279600143432617e+01 8.5650398254394531e+01 -9.6150398254394531e+01 2.1279600143432617e+01 8.5480598449707031e+01 -9.6357192993164062e+01 2.1279600143432617e+01 8.5325004577636719e+01 -9.6546699523925781e+01 2.1279600143432617e+01 8.5104301452636719e+01 -9.6959701538085938e+01 2.1279600143432617e+01 8.5083297729492188e+01 -9.6999000549316406e+01 2.1279600143432617e+01 8.4934501647949219e+01 -9.7489700317382812e+01 2.1279600143432617e+01 8.4919197082519531e+01 -9.7644905090332031e+01 2.1279600143432617e+01 8.4884193420410156e+01 -9.8000000000000000e+01 2.1279600143432617e+01 8.4919197082519531e+01 -9.8355102539062500e+01 2.1279600143432617e+01 8.4934501647949219e+01 -9.8510299682617188e+01 2.1279600143432617e+01 8.5083297729492188e+01 -9.9000999450683594e+01 2.1279600143432617e+01 8.5104301452636719e+01 -9.9040298461914062e+01 2.1279600143432617e+01 8.5325004577636719e+01 -9.9453300476074219e+01 2.1279600143432617e+01 8.5480598449707031e+01 -9.9642799377441406e+01 2.1279600143432617e+01 8.5650398254394531e+01 -9.9849594116210938e+01 2.1279600143432617e+01 8.5995101928710938e+01 -1.0013300323486328e+02 2.1279600143432617e+01 8.6046699523925781e+01 -1.0017500305175781e+02 2.1279600143432617e+01 8.6499000549316406e+01 -1.0041699981689453e+02 2.1279600143432617e+01 8.6626800537109375e+01 -1.0045500183105469e+02 2.1279600143432617e+01 8.6989700317382812e+01 -1.0056600189208984e+02 2.1279600143432617e+01 8.7322601318359375e+01 -1.0059799957275391e+02 2.1279600143432617e+01 8.7500000000000000e+01 -1.0061599731445312e+02 2.1279600143432617e+01 8.8010307312011719e+01 -1.0056600189208984e+02 2.1279600143432617e+01 8.8031600952148438e+01 -1.0055900573730469e+02 2.1279600143432617e+01 8.8500999450683594e+01 -1.0041699981689453e+02 2.1279600143432617e+01 8.8697593688964844e+01 -1.0031200408935547e+02 2.1279600143432617e+01 8.8953300476074219e+01 -1.0017500305175781e+02 2.1279600143432617e+01 8.9280799865722656e+01 -9.9906105041503906e+01 2.1279600143432617e+01 8.9349594116210938e+01 -9.9849594116210938e+01 2.1279600143432617e+01 8.9675003051757812e+01 -9.9453300476074219e+01 2.1279600143432617e+01 8.9727401733398438e+01 -9.9355102539062500e+01 2.1279600143432617e+01 8.9916702270507812e+01 -9.9000999450683594e+01 2.1279600143432617e+01 9.0007301330566406e+01 -9.8702201843261719e+01 2.1279600143432617e+01 9.0065498352050781e+01 -9.8510299682617188e+01 2.1279600143432617e+01 9.0115798950195312e+01 -9.8000000000000000e+01 2.1279600143432617e+01 8.5582298278808594e+01 -9.8406394958496094e+01 2.1000000000000000e+01 8.5582298278808594e+01 -9.7593597412109375e+01 2.1000000000000000e+01 8.6375900268554688e+01 -9.8406394958496094e+01 2.2701799392700195e+01 8.6375900268554688e+01 -9.7593597412109375e+01 2.2701799392700195e+01 8.7906394958496094e+01 -9.9124099731445312e+01 2.2701799392700195e+01 8.7093597412109375e+01 -9.9124099731445312e+01 2.2701799392700195e+01 8.7906394958496094e+01 -9.8406394958496094e+01 2.2701799392700195e+01 8.7093597412109375e+01 -9.8406394958496094e+01 2.2701799392700195e+01 8.7093597412109375e+01 -9.6875900268554688e+01 2.2701799392700195e+01 8.7906394958496094e+01 -9.6875900268554688e+01 2.2701799392700195e+01 8.7093597412109375e+01 -9.7593597412109375e+01 2.2701799392700195e+01 8.7906394958496094e+01 -9.7593597412109375e+01 2.2701799392700195e+01 8.8624099731445312e+01 -9.7593597412109375e+01 2.2701799392700195e+01 8.8624099731445312e+01 -9.8406394958496094e+01 2.2701799392700195e+01 8.7906394958496094e+01 -9.9917701721191406e+01 2.1000000000000000e+01 8.7093597412109375e+01 -9.9917701721191406e+01 2.1000000000000000e+01 8.9417701721191406e+01 -9.7593597412109375e+01 2.1000000000000000e+01 8.9417701721191406e+01 -9.8406394958496094e+01 2.1000000000000000e+01 8.7093597412109375e+01 -9.6082298278808594e+01 2.1000000000000000e+01 8.7906394958496094e+01 -9.6082298278808594e+01 2.1000000000000000e+01 8.8451103210449219e+01 -9.5703804016113281e+01 2.1000000000000000e+01 8.8880798339843750e+01 -9.5933403015136719e+01 2.1000000000000000e+01 8.7906394958496094e+01 -9.7593597412109375e+01 2.1000000000000000e+01 8.7984893798828125e+01 -9.5562301635742188e+01 2.1000000000000000e+01 8.7500000000000000e+01 -9.5514602661132812e+01 2.1000000000000000e+01 8.7984893798828125e+01 -1.0043799591064453e+02 2.1000000000000000e+01 8.7500000000000000e+01 -1.0048500061035156e+02 2.1000000000000000e+01 8.7015098571777344e+01 -1.0043799591064453e+02 2.1000000000000000e+01 8.9257499694824219e+01 -9.6242500305175781e+01 2.1000000000000000e+01 8.9566604614257812e+01 -9.6619201660156250e+01 2.1000000000000000e+01 8.9796203613281250e+01 -9.7048904418945312e+01 2.1000000000000000e+01 8.9937698364257812e+01 -9.7515098571777344e+01 2.1000000000000000e+01 8.9566604614257812e+01 -9.9380798339843750e+01 2.1000000000000000e+01 8.7906394958496094e+01 -9.8406394958496094e+01 2.1000000000000000e+01 8.9985397338867188e+01 -9.8000000000000000e+01 2.1000000000000000e+01 8.9937698364257812e+01 -9.8484901428222656e+01 2.1000000000000000e+01 8.9796203613281250e+01 -9.8951103210449219e+01 2.1000000000000000e+01 8.5203796386718750e+01 -9.7048904418945312e+01 2.1000000000000000e+01 8.5433403015136719e+01 -9.6619201660156250e+01 2.1000000000000000e+01 8.7093597412109375e+01 -9.7593597412109375e+01 2.1000000000000000e+01 8.5062301635742188e+01 -9.7515098571777344e+01 2.1000000000000000e+01 8.5014595031738281e+01 -9.8000000000000000e+01 2.1000000000000000e+01 8.9257499694824219e+01 -9.9757499694824219e+01 2.1000000000000000e+01 8.8880798339843750e+01 -1.0006699371337891e+02 2.1000000000000000e+01 8.8451103210449219e+01 -1.0029599761962891e+02 2.1000000000000000e+01 8.7015098571777344e+01 -9.5562301635742188e+01 2.1000000000000000e+01 8.6548904418945312e+01 -9.5703804016113281e+01 2.1000000000000000e+01 8.6119194030761719e+01 -9.5933403015136719e+01 2.1000000000000000e+01 8.5742500305175781e+01 -9.6242500305175781e+01 2.1000000000000000e+01 8.6548904418945312e+01 -1.0029599761962891e+02 2.1000000000000000e+01 8.6119194030761719e+01 -1.0006699371337891e+02 2.1000000000000000e+01 8.7093597412109375e+01 -9.8406394958496094e+01 2.1000000000000000e+01 8.5062301635742188e+01 -9.8484901428222656e+01 2.1000000000000000e+01 8.5203796386718750e+01 -9.8951103210449219e+01 2.1000000000000000e+01 8.5433403015136719e+01 -9.9380798339843750e+01 2.1000000000000000e+01 8.5742500305175781e+01 -9.9757499694824219e+01 2.1000000000000000e+01 8.8514297485351562e+01 -1.0044900512695312e+02 2.1211299896240234e+01 8.5296104431152344e+01 -9.9472595214843750e+01 2.1211299896240234e+01 8.5625801086425781e+01 -9.6125793457031250e+01 2.1211299896240234e+01 8.8972595214843750e+01 -9.5796104431152344e+01 2.1211299896240234e+01 8.8922302246093750e+01 -1.0012899780273438e+02 2.1017198562622070e+01 8.9310195922851562e+01 -9.9810195922851562e+01 2.1017198562622070e+01 8.9352302551269531e+01 -9.9852302551269531e+01 2.1065401077270508e+01 9.0060005187988281e+01 -9.8000000000000000e+01 2.1017198562622070e+01 9.0010803222656250e+01 -9.8499404907226562e+01 2.1017198562622070e+01 8.9704994201660156e+01 -9.9473297119140625e+01 2.1134799957275391e+01 8.9678100585937500e+01 -9.9455299377441406e+01 2.1065401077270508e+01 8.9628601074218750e+01 -9.9422294616699219e+01 2.1017198562622070e+01 8.9948806762695312e+01 -9.9014297485351562e+01 2.1211299896240234e+01 8.9950004577636719e+01 -9.9014793395996094e+01 2.1134799957275391e+01 8.9920104980468750e+01 -9.9002395629882812e+01 2.1065401077270508e+01 8.9865203857421875e+01 -9.8979698181152344e+01 2.1017198562622070e+01 8.9703903198242188e+01 -9.6527397155761719e+01 2.1211299896240234e+01 8.9948806762695312e+01 -9.6985694885253906e+01 2.1211299896240234e+01 8.9950004577636719e+01 -9.6985198974609375e+01 2.1134799957275391e+01 8.9374198913574219e+01 -9.6125793457031250e+01 2.1211299896240234e+01 8.9704994201660156e+01 -9.6526695251464844e+01 2.1134799957275391e+01 8.9920104980468750e+01 -9.6997596740722656e+01 2.1065401077270508e+01 8.9628601074218750e+01 -9.6577697753906250e+01 2.1017198562622070e+01 8.9310195922851562e+01 -9.6189796447753906e+01 2.1017198562622070e+01 8.9352302551269531e+01 -9.6147697448730469e+01 2.1065401077270508e+01 8.8955299377441406e+01 -9.5821899414062500e+01 2.1065401077270508e+01 8.8973297119140625e+01 -9.5794998168945312e+01 2.1134799957275391e+01 8.8514801025390625e+01 -9.5550003051757812e+01 2.1134799957275391e+01 8.8514297485351562e+01 -9.5551200866699219e+01 2.1211299896240234e+01 8.8017097473144531e+01 -9.5400398254394531e+01 2.1211299896240234e+01 8.8922302246093750e+01 -9.5871398925781250e+01 2.1017198562622070e+01 8.8502494812011719e+01 -9.5579902648925781e+01 2.1065401077270508e+01 8.8017395019531250e+01 -9.5399093627929688e+01 2.1134799957275391e+01 8.7500000000000000e+01 -9.5349403381347656e+01 2.1211299896240234e+01 8.8479698181152344e+01 -9.5634803771972656e+01 2.1017198562622070e+01 8.7999404907226562e+01 -9.5489196777343750e+01 2.1017198562622070e+01 8.8010993957519531e+01 -9.5430801391601562e+01 2.1065401077270508e+01 8.7500000000000000e+01 -9.5380500793457031e+01 2.1065401077270508e+01 8.7500000000000000e+01 -9.5348098754882812e+01 2.1134799957275391e+01 8.6982597351074219e+01 -9.5399093627929688e+01 2.1134799957275391e+01 8.6982894897460938e+01 -9.5400398254394531e+01 2.1211299896240234e+01 8.6485702514648438e+01 -9.5551200866699219e+01 2.1211299896240234e+01 8.7500000000000000e+01 -9.5440002441406250e+01 2.1017198562622070e+01 8.6988998413085938e+01 -9.5430801391601562e+01 2.1065401077270508e+01 8.6485198974609375e+01 -9.5550003051757812e+01 2.1134799957275391e+01 8.6027397155761719e+01 -9.5796104431152344e+01 2.1211299896240234e+01 8.6520301818847656e+01 -9.5634803771972656e+01 2.1017198562622070e+01 8.6077697753906250e+01 -9.5871398925781250e+01 2.1017198562622070e+01 8.6044700622558594e+01 -9.5821899414062500e+01 2.1065401077270508e+01 8.5647705078125000e+01 -9.6147697448730469e+01 2.1065401077270508e+01 8.5624801635742188e+01 -9.6124801635742188e+01 2.1134799957275391e+01 8.5294998168945312e+01 -9.6526695251464844e+01 2.1134799957275391e+01 8.5296104431152344e+01 -9.6527397155761719e+01 2.1211299896240234e+01 8.5051200866699219e+01 -9.6985694885253906e+01 2.1211299896240234e+01 8.5689796447753906e+01 -9.6189796447753906e+01 2.1017198562622070e+01 8.5321899414062500e+01 -9.6544700622558594e+01 2.1065401077270508e+01 8.5050003051757812e+01 -9.6985198974609375e+01 2.1134799957275391e+01 8.4900398254394531e+01 -9.7482894897460938e+01 2.1211299896240234e+01 8.5371398925781250e+01 -9.6577697753906250e+01 2.1017198562622070e+01 8.5134796142578125e+01 -9.7020301818847656e+01 2.1017198562622070e+01 8.5079902648925781e+01 -9.6997596740722656e+01 2.1065401077270508e+01 8.4930801391601562e+01 -9.7488998413085938e+01 2.1065401077270508e+01 8.4899101257324219e+01 -9.7482597351074219e+01 2.1134799957275391e+01 8.4848098754882812e+01 -9.8000000000000000e+01 2.1134799957275391e+01 8.4849403381347656e+01 -9.8000000000000000e+01 2.1211299896240234e+01 8.4900398254394531e+01 -9.8517097473144531e+01 2.1211299896240234e+01 8.4989196777343750e+01 -9.7500602722167969e+01 2.1017198562622070e+01 8.4880500793457031e+01 -9.8000000000000000e+01 2.1065401077270508e+01 8.4899101257324219e+01 -9.8517402648925781e+01 2.1134799957275391e+01 8.5051200866699219e+01 -9.9014297485351562e+01 2.1211299896240234e+01 8.4989196777343750e+01 -9.8499404907226562e+01 2.1017198562622070e+01 8.5134796142578125e+01 -9.8979698181152344e+01 2.1017198562622070e+01 8.5079902648925781e+01 -9.9002395629882812e+01 2.1065401077270508e+01 8.5321899414062500e+01 -9.9455299377441406e+01 2.1065401077270508e+01 8.5294998168945312e+01 -9.9473297119140625e+01 2.1134799957275391e+01 8.5624801635742188e+01 -9.9875198364257812e+01 2.1134799957275391e+01 8.5625801086425781e+01 -9.9874198913574219e+01 2.1211299896240234e+01 8.6027397155761719e+01 -1.0020399475097656e+02 2.1211299896240234e+01 8.5371398925781250e+01 -9.9422294616699219e+01 2.1017198562622070e+01 8.5647705078125000e+01 -9.9852302551269531e+01 2.1065401077270508e+01 8.6026695251464844e+01 -1.0020499420166016e+02 2.1134799957275391e+01 8.6485702514648438e+01 -1.0044900512695312e+02 2.1211299896240234e+01 8.5689796447753906e+01 -9.9810195922851562e+01 2.1017198562622070e+01 8.6077697753906250e+01 -1.0012899780273438e+02 2.1017198562622070e+01 8.6044700622558594e+01 -1.0017800140380859e+02 2.1065401077270508e+01 8.6497497558593750e+01 -1.0041999816894531e+02 2.1065401077270508e+01 8.6485198974609375e+01 -1.0045000457763672e+02 2.1134799957275391e+01 8.6982597351074219e+01 -1.0060100555419922e+02 2.1134799957275391e+01 8.6982894897460938e+01 -1.0059999847412109e+02 2.1211299896240234e+01 8.7500000000000000e+01 -1.0065100097656250e+02 2.1211299896240234e+01 8.6520301818847656e+01 -1.0036499786376953e+02 2.1017198562622070e+01 8.6988998413085938e+01 -1.0056900024414062e+02 2.1065401077270508e+01 8.7500000000000000e+01 -1.0065200042724609e+02 2.1134799957275391e+01 8.8017097473144531e+01 -1.0059999847412109e+02 2.1211299896240234e+01 8.7500000000000000e+01 -1.0056000518798828e+02 2.1017198562622070e+01 8.7999404907226562e+01 -1.0051100158691406e+02 2.1017198562622070e+01 8.8010993957519531e+01 -1.0056900024414062e+02 2.1065401077270508e+01 8.8502494812011719e+01 -1.0041999816894531e+02 2.1065401077270508e+01 8.8514801025390625e+01 -1.0045000457763672e+02 2.1134799957275391e+01 8.8973297119140625e+01 -1.0020499420166016e+02 2.1134799957275391e+01 8.8972595214843750e+01 -1.0020399475097656e+02 2.1211299896240234e+01 8.9374198913574219e+01 -9.9874198913574219e+01 2.1211299896240234e+01 8.8479698181152344e+01 -1.0036499786376953e+02 2.1017198562622070e+01 8.8955299377441406e+01 -1.0017800140380859e+02 2.1065401077270508e+01 8.9375198364257812e+01 -9.9875198364257812e+01 2.1134799957275391e+01 8.9703903198242188e+01 -9.9472595214843750e+01 2.1211299896240234e+01 9.0010803222656250e+01 -9.7500602722167969e+01 2.1017198562622070e+01 9.0069198608398438e+01 -9.7488998413085938e+01 2.1065401077270508e+01 9.0119506835937500e+01 -9.8000000000000000e+01 2.1065401077270508e+01 9.0100898742675781e+01 -9.7482597351074219e+01 2.1134799957275391e+01 9.0151901245117188e+01 -9.8000000000000000e+01 2.1134799957275391e+01 9.0099601745605469e+01 -9.7482894897460938e+01 2.1211299896240234e+01 9.0150604248046875e+01 -9.8000000000000000e+01 2.1211299896240234e+01 8.9375198364257812e+01 -9.6124801635742188e+01 2.1134799957275391e+01 8.9678100585937500e+01 -9.6544700622558594e+01 2.1065401077270508e+01 8.9865203857421875e+01 -9.7020301818847656e+01 2.1017198562622070e+01 8.6026695251464844e+01 -9.5794998168945312e+01 2.1134799957275391e+01 8.6497497558593750e+01 -9.5579902648925781e+01 2.1065401077270508e+01 8.7000602722167969e+01 -9.5489196777343750e+01 2.1017198562622070e+01 8.5050003051757812e+01 -9.9014793395996094e+01 2.1134799957275391e+01 8.4930801391601562e+01 -9.8511001586914062e+01 2.1065401077270508e+01 8.4940002441406250e+01 -9.8000000000000000e+01 2.1017198562622070e+01 8.8017395019531250e+01 -1.0060100555419922e+02 2.1134799957275391e+01 8.7500000000000000e+01 -1.0062000274658203e+02 2.1065401077270508e+01 8.7000602722167969e+01 -1.0051100158691406e+02 2.1017198562622070e+01 9.0099601745605469e+01 -9.8517097473144531e+01 2.1211299896240234e+01 9.0069198608398438e+01 -9.8511001586914062e+01 2.1065401077270508e+01 9.0100898742675781e+01 -9.8517402648925781e+01 2.1134799957275391e+01 8.7500000000000000e+01 -9.8000000000000000e+01 4.1637500762939453e+01 6.2369701385498047e+01 -6.5116195678710938e+01 2.2701799392700195e+01 6.2326301574707031e+01 -6.4986198425292969e+01 3.8587200164794922e+01 6.2422397613525391e+01 -6.5500000000000000e+01 3.8587200164794922e+01 6.2042602539062500e+01 -6.4548698425292969e+01 2.2701799392700195e+01 6.2051200866699219e+01 -6.4541694641113281e+01 3.8587200164794922e+01 6.2215297698974609e+01 -6.4760902404785156e+01 2.2701799392700195e+01 6.2315200805664062e+01 -6.4990997314453125e+01 2.2701799392700195e+01 6.1970901489257812e+01 -6.4460502624511719e+01 2.2701799392700195e+01 6.1654399871826172e+01 -6.4237106323242188e+01 2.2701799392700195e+01 6.1633998870849609e+01 -6.4226699829101562e+01 3.8587200164794922e+01 6.1632999420166016e+01 -6.4229499816894531e+01 2.2701799392700195e+01 6.1289398193359375e+01 -6.4107406616210938e+01 2.2701799392700195e+01 6.1131202697753906e+01 -6.4083702087402344e+01 3.8587200164794922e+01 6.0612701416015625e+01 -6.4141197204589844e+01 2.2701799392700195e+01 6.0610698699951172e+01 -6.4131896972656250e+01 3.8587200164794922e+01 6.0902900695800781e+01 -6.4080902099609375e+01 2.2701799392700195e+01 6.1130401611328125e+01 -6.4096504211425781e+01 2.2701799392700195e+01 6.0523700714111328e+01 -6.4159698486328125e+01 2.2701799392700195e+01 6.0179698944091797e+01 -6.4337898254394531e+01 2.2701799392700195e+01 6.0142799377441406e+01 -6.4364906311035156e+01 3.8587200164794922e+01 6.0146598815917969e+01 -6.4368904113769531e+01 2.2701799392700195e+01 5.9896598815917969e+01 -6.4602302551269531e+01 2.2701799392700195e+01 5.9790599822998047e+01 -6.4751197814941406e+01 3.8587200164794922e+01 5.9801898956298828e+01 -6.4758102416992188e+01 2.2701799392700195e+01 5.9695400238037109e+01 -6.4933303833007812e+01 2.2701799392700195e+01 5.9601799011230469e+01 -6.5238601684570312e+01 3.8587200164794922e+01 5.9609199523925781e+01 -6.5240699768066406e+01 2.2701799392700195e+01 5.9601799011230469e+01 -6.5761405944824219e+01 3.8587200164794922e+01 5.9590896606445312e+01 -6.5306297302246094e+01 2.2701799392700195e+01 5.9590896606445312e+01 -6.5693695068359375e+01 2.2701799392700195e+01 5.9609199523925781e+01 -6.5759300231933594e+01 2.2701799392700195e+01 5.9695400238037109e+01 -6.6066696166992188e+01 2.2701799392700195e+01 5.9790599822998047e+01 -6.6248794555664062e+01 3.8587200164794922e+01 5.9801898956298828e+01 -6.6241897583007812e+01 2.2701799392700195e+01 5.9896598815917969e+01 -6.6397697448730469e+01 2.2701799392700195e+01 6.0142799377441406e+01 -6.6635101318359375e+01 3.8587200164794922e+01 6.0146598815917969e+01 -6.6631103515625000e+01 2.2701799392700195e+01 6.0610698699951172e+01 -6.6868095397949219e+01 3.8587200164794922e+01 6.0179698944091797e+01 -6.6662101745605469e+01 2.2701799392700195e+01 6.0523700714111328e+01 -6.6840301513671875e+01 2.2701799392700195e+01 6.0612701416015625e+01 -6.6858795166015625e+01 2.2701799392700195e+01 6.0902900695800781e+01 -6.6919105529785156e+01 2.2701799392700195e+01 6.1131202697753906e+01 -6.6916305541992188e+01 3.8587200164794922e+01 6.1130401611328125e+01 -6.6903503417968750e+01 2.2701799392700195e+01 6.1289398193359375e+01 -6.6892601013183594e+01 2.2701799392700195e+01 6.1633998870849609e+01 -6.6773300170898438e+01 3.8587200164794922e+01 6.1632999420166016e+01 -6.6770500183105469e+01 2.2701799392700195e+01 6.2051200866699219e+01 -6.6458297729492188e+01 3.8587200164794922e+01 6.1654399871826172e+01 -6.6762901306152344e+01 2.2701799392700195e+01 6.1970901489257812e+01 -6.6539505004882812e+01 2.2701799392700195e+01 6.2042602539062500e+01 -6.6451301574707031e+01 2.2701799392700195e+01 6.2215297698974609e+01 -6.6239105224609375e+01 2.2701799392700195e+01 6.2326301574707031e+01 -6.6013801574707031e+01 3.8587200164794922e+01 6.2315200805664062e+01 -6.6009002685546875e+01 2.2701799392700195e+01 6.2369701385498047e+01 -6.5883796691894531e+01 2.2701799392700195e+01 6.2422397613525391e+01 -6.5500000000000000e+01 2.2701799392700195e+01 6.3565498352050781e+01 -6.4989700317382812e+01 2.1279600143432617e+01 6.3507305145263672e+01 -6.4797798156738281e+01 2.1279600143432617e+01 6.3416698455810547e+01 -6.4499000549316406e+01 2.1279600143432617e+01 6.3227401733398438e+01 -6.4144905090332031e+01 2.1279600143432617e+01 6.3174903869628906e+01 -6.4046699523925781e+01 2.1279600143432617e+01 6.2849601745605469e+01 -6.3650398254394531e+01 2.1279600143432617e+01 6.2780796051025391e+01 -6.3593902587890625e+01 2.1279600143432617e+01 6.2453300476074219e+01 -6.3325004577636719e+01 2.1279600143432617e+01 6.2197601318359375e+01 -6.3188396453857422e+01 2.1279600143432617e+01 6.2000999450683594e+01 -6.3083297729492188e+01 2.1279600143432617e+01 6.1531600952148438e+01 -6.2940902709960938e+01 2.1279600143432617e+01 6.1510299682617188e+01 -6.2934501647949219e+01 2.1279600143432617e+01 6.1000000000000000e+01 -6.2884197235107422e+01 2.1279600143432617e+01 6.0822597503662109e+01 -6.2901699066162109e+01 2.1279600143432617e+01 6.0489700317382812e+01 -6.2934501647949219e+01 2.1279600143432617e+01 6.0126800537109375e+01 -6.3044502258300781e+01 2.1279600143432617e+01 5.9999000549316406e+01 -6.3083297729492188e+01 2.1279600143432617e+01 5.9546703338623047e+01 -6.3325004577636719e+01 2.1279600143432617e+01 5.9495098114013672e+01 -6.3367397308349609e+01 2.1279600143432617e+01 5.9150402069091797e+01 -6.3650398254394531e+01 2.1279600143432617e+01 5.8980598449707031e+01 -6.3857196807861328e+01 2.1279600143432617e+01 5.8825099945068359e+01 -6.4046699523925781e+01 2.1279600143432617e+01 5.8604301452636719e+01 -6.4459693908691406e+01 2.1279600143432617e+01 5.8583301544189453e+01 -6.4499000549316406e+01 2.1279600143432617e+01 5.8434501647949219e+01 -6.4989700317382812e+01 2.1279600143432617e+01 5.8419200897216797e+01 -6.5144897460937500e+01 2.1279600143432617e+01 5.8384197235107422e+01 -6.5500000000000000e+01 2.1279600143432617e+01 5.8419200897216797e+01 -6.5855102539062500e+01 2.1279600143432617e+01 5.8434501647949219e+01 -6.6010299682617188e+01 2.1279600143432617e+01 5.8583301544189453e+01 -6.6500999450683594e+01 2.1279600143432617e+01 5.8604301452636719e+01 -6.6540298461914062e+01 2.1279600143432617e+01 5.8825099945068359e+01 -6.6953300476074219e+01 2.1279600143432617e+01 5.8980598449707031e+01 -6.7142799377441406e+01 2.1279600143432617e+01 5.9150402069091797e+01 -6.7349594116210938e+01 2.1279600143432617e+01 5.9495098114013672e+01 -6.7632598876953125e+01 2.1279600143432617e+01 5.9546703338623047e+01 -6.7674896240234375e+01 2.1279600143432617e+01 5.9999000549316406e+01 -6.7916702270507812e+01 2.1279600143432617e+01 6.0126800537109375e+01 -6.7955497741699219e+01 2.1279600143432617e+01 6.0489700317382812e+01 -6.8065498352050781e+01 2.1279600143432617e+01 6.0822597503662109e+01 -6.8098297119140625e+01 2.1279600143432617e+01 6.1000000000000000e+01 -6.8115798950195312e+01 2.1279600143432617e+01 6.1510299682617188e+01 -6.8065498352050781e+01 2.1279600143432617e+01 6.1531600952148438e+01 -6.8059104919433594e+01 2.1279600143432617e+01 6.2000999450683594e+01 -6.7916702270507812e+01 2.1279600143432617e+01 6.2197601318359375e+01 -6.7811599731445312e+01 2.1279600143432617e+01 6.2453300476074219e+01 -6.7674896240234375e+01 2.1279600143432617e+01 6.2780796051025391e+01 -6.7406105041503906e+01 2.1279600143432617e+01 6.2849601745605469e+01 -6.7349594116210938e+01 2.1279600143432617e+01 6.3174903869628906e+01 -6.6953300476074219e+01 2.1279600143432617e+01 6.3227401733398438e+01 -6.6855102539062500e+01 2.1279600143432617e+01 6.3416698455810547e+01 -6.6500999450683594e+01 2.1279600143432617e+01 6.3507305145263672e+01 -6.6202201843261719e+01 2.1279600143432617e+01 6.3565498352050781e+01 -6.6010299682617188e+01 2.1279600143432617e+01 6.3615798950195312e+01 -6.5500000000000000e+01 2.1279600143432617e+01 5.9082298278808594e+01 -6.5906394958496094e+01 2.1000000000000000e+01 5.9082298278808594e+01 -6.5093597412109375e+01 2.1000000000000000e+01 5.9875900268554688e+01 -6.5906394958496094e+01 2.2701799392700195e+01 5.9875900268554688e+01 -6.5093597412109375e+01 2.2701799392700195e+01 6.1406398773193359e+01 -6.6624099731445312e+01 2.2701799392700195e+01 6.0593601226806641e+01 -6.6624099731445312e+01 2.2701799392700195e+01 6.1406398773193359e+01 -6.5906394958496094e+01 2.2701799392700195e+01 6.0593601226806641e+01 -6.5906394958496094e+01 2.2701799392700195e+01 6.0593601226806641e+01 -6.4375900268554688e+01 2.2701799392700195e+01 6.1406398773193359e+01 -6.4375900268554688e+01 2.2701799392700195e+01 6.0593601226806641e+01 -6.5093597412109375e+01 2.2701799392700195e+01 6.1406398773193359e+01 -6.5093597412109375e+01 2.2701799392700195e+01 6.2124099731445312e+01 -6.5093597412109375e+01 2.2701799392700195e+01 6.2124099731445312e+01 -6.5906394958496094e+01 2.2701799392700195e+01 6.1406398773193359e+01 -6.7417701721191406e+01 2.1000000000000000e+01 6.0593601226806641e+01 -6.7417701721191406e+01 2.1000000000000000e+01 6.2917701721191406e+01 -6.5093597412109375e+01 2.1000000000000000e+01 6.2917701721191406e+01 -6.5906394958496094e+01 2.1000000000000000e+01 6.0593601226806641e+01 -6.3582302093505859e+01 2.1000000000000000e+01 6.1406398773193359e+01 -6.3582302093505859e+01 2.1000000000000000e+01 6.1951099395751953e+01 -6.3203796386718750e+01 2.1000000000000000e+01 6.2380798339843750e+01 -6.3433403015136719e+01 2.1000000000000000e+01 6.1406398773193359e+01 -6.5093597412109375e+01 2.1000000000000000e+01 6.1484897613525391e+01 -6.3062301635742188e+01 2.1000000000000000e+01 6.1000000000000000e+01 -6.3014595031738281e+01 2.1000000000000000e+01 6.1484897613525391e+01 -6.7937698364257812e+01 2.1000000000000000e+01 6.1000000000000000e+01 -6.7985397338867188e+01 2.1000000000000000e+01 6.0515098571777344e+01 -6.7937698364257812e+01 2.1000000000000000e+01 6.2757499694824219e+01 -6.3742504119873047e+01 2.1000000000000000e+01 6.3066600799560547e+01 -6.4119194030761719e+01 2.1000000000000000e+01 6.3296199798583984e+01 -6.4548904418945312e+01 2.1000000000000000e+01 6.3437698364257812e+01 -6.5015098571777344e+01 2.1000000000000000e+01 6.3066600799560547e+01 -6.6880798339843750e+01 2.1000000000000000e+01 6.1406398773193359e+01 -6.5906394958496094e+01 2.1000000000000000e+01 6.3485397338867188e+01 -6.5500000000000000e+01 2.1000000000000000e+01 6.3437698364257812e+01 -6.5984893798828125e+01 2.1000000000000000e+01 6.3296199798583984e+01 -6.6451103210449219e+01 2.1000000000000000e+01 5.8703800201416016e+01 -6.4548904418945312e+01 2.1000000000000000e+01 5.8933399200439453e+01 -6.4119194030761719e+01 2.1000000000000000e+01 6.0593601226806641e+01 -6.5093597412109375e+01 2.1000000000000000e+01 5.8562301635742188e+01 -6.5015098571777344e+01 2.1000000000000000e+01 5.8514598846435547e+01 -6.5500000000000000e+01 2.1000000000000000e+01 6.2757499694824219e+01 -6.7257499694824219e+01 2.1000000000000000e+01 6.2380798339843750e+01 -6.7566604614257812e+01 2.1000000000000000e+01 6.1951099395751953e+01 -6.7796203613281250e+01 2.1000000000000000e+01 6.0515098571777344e+01 -6.3062301635742188e+01 2.1000000000000000e+01 6.0048900604248047e+01 -6.3203796386718750e+01 2.1000000000000000e+01 5.9619197845458984e+01 -6.3433403015136719e+01 2.1000000000000000e+01 5.9242500305175781e+01 -6.3742504119873047e+01 2.1000000000000000e+01 6.0048900604248047e+01 -6.7796203613281250e+01 2.1000000000000000e+01 5.9619197845458984e+01 -6.7566604614257812e+01 2.1000000000000000e+01 6.0593601226806641e+01 -6.5906394958496094e+01 2.1000000000000000e+01 5.8562301635742188e+01 -6.5984893798828125e+01 2.1000000000000000e+01 5.8703800201416016e+01 -6.6451103210449219e+01 2.1000000000000000e+01 5.8933399200439453e+01 -6.6880798339843750e+01 2.1000000000000000e+01 5.9242500305175781e+01 -6.7257499694824219e+01 2.1000000000000000e+01 6.2014301300048828e+01 -6.7948806762695312e+01 2.1211299896240234e+01 5.8796100616455078e+01 -6.6972595214843750e+01 2.1211299896240234e+01 5.9125801086425781e+01 -6.3625797271728516e+01 2.1211299896240234e+01 6.2472599029541016e+01 -6.3296100616455078e+01 2.1211299896240234e+01 6.2422302246093750e+01 -6.7628601074218750e+01 2.1017198562622070e+01 6.2810195922851562e+01 -6.7310195922851562e+01 2.1017198562622070e+01 6.2852302551269531e+01 -6.7352302551269531e+01 2.1065401077270508e+01 6.3560001373291016e+01 -6.5500000000000000e+01 2.1017198562622070e+01 6.3510799407958984e+01 -6.5999404907226562e+01 2.1017198562622070e+01 6.3204998016357422e+01 -6.6973297119140625e+01 2.1134799957275391e+01 6.3178100585937500e+01 -6.6955299377441406e+01 2.1065401077270508e+01 6.3128597259521484e+01 -6.6922302246093750e+01 2.1017198562622070e+01 6.3448802947998047e+01 -6.6514297485351562e+01 2.1211299896240234e+01 6.3450000762939453e+01 -6.6514801025390625e+01 2.1134799957275391e+01 6.3420101165771484e+01 -6.6502403259277344e+01 2.1065401077270508e+01 6.3365200042724609e+01 -6.6479698181152344e+01 2.1017198562622070e+01 6.3203899383544922e+01 -6.4027397155761719e+01 2.1211299896240234e+01 6.3448802947998047e+01 -6.4485702514648438e+01 2.1211299896240234e+01 6.3450000762939453e+01 -6.4485198974609375e+01 2.1134799957275391e+01 6.2874198913574219e+01 -6.3625797271728516e+01 2.1211299896240234e+01 6.3204998016357422e+01 -6.4026695251464844e+01 2.1134799957275391e+01 6.3420101165771484e+01 -6.4497596740722656e+01 2.1065401077270508e+01 6.3128597259521484e+01 -6.4077697753906250e+01 2.1017198562622070e+01 6.2810195922851562e+01 -6.3689796447753906e+01 2.1017198562622070e+01 6.2852302551269531e+01 -6.3647701263427734e+01 2.1065401077270508e+01 6.2455299377441406e+01 -6.3321903228759766e+01 2.1065401077270508e+01 6.2473300933837891e+01 -6.3294998168945312e+01 2.1134799957275391e+01 6.2014801025390625e+01 -6.3050003051757812e+01 2.1134799957275391e+01 6.2014301300048828e+01 -6.3051200866699219e+01 2.1211299896240234e+01 6.1517101287841797e+01 -6.2900402069091797e+01 2.1211299896240234e+01 6.2422302246093750e+01 -6.3371398925781250e+01 2.1017198562622070e+01 6.2002403259277344e+01 -6.3079902648925781e+01 2.1065401077270508e+01 6.1517398834228516e+01 -6.2899097442626953e+01 2.1134799957275391e+01 6.1000000000000000e+01 -6.2849403381347656e+01 2.1211299896240234e+01 6.1979698181152344e+01 -6.3134796142578125e+01 2.1017198562622070e+01 6.1499397277832031e+01 -6.2989196777343750e+01 2.1017198562622070e+01 6.1510997772216797e+01 -6.2930801391601562e+01 2.1065401077270508e+01 6.1000000000000000e+01 -6.2880500793457031e+01 2.1065401077270508e+01 6.1000000000000000e+01 -6.2848098754882812e+01 2.1134799957275391e+01 6.0482597351074219e+01 -6.2899097442626953e+01 2.1134799957275391e+01 6.0482898712158203e+01 -6.2900402069091797e+01 2.1211299896240234e+01 5.9985702514648438e+01 -6.3051200866699219e+01 2.1211299896240234e+01 6.1000000000000000e+01 -6.2940002441406250e+01 2.1017198562622070e+01 6.0488998413085938e+01 -6.2930801391601562e+01 2.1065401077270508e+01 5.9985202789306641e+01 -6.3050003051757812e+01 2.1134799957275391e+01 5.9527400970458984e+01 -6.3296100616455078e+01 2.1211299896240234e+01 6.0020301818847656e+01 -6.3134796142578125e+01 2.1017198562622070e+01 5.9577701568603516e+01 -6.3371398925781250e+01 2.1017198562622070e+01 5.9544700622558594e+01 -6.3321903228759766e+01 2.1065401077270508e+01 5.9147701263427734e+01 -6.3647701263427734e+01 2.1065401077270508e+01 5.9124801635742188e+01 -6.3624797821044922e+01 2.1134799957275391e+01 5.8795001983642578e+01 -6.4026695251464844e+01 2.1134799957275391e+01 5.8796100616455078e+01 -6.4027397155761719e+01 2.1211299896240234e+01 5.8551200866699219e+01 -6.4485702514648438e+01 2.1211299896240234e+01 5.9189800262451172e+01 -6.3689796447753906e+01 2.1017198562622070e+01 5.8821903228759766e+01 -6.4044700622558594e+01 2.1065401077270508e+01 5.8549999237060547e+01 -6.4485198974609375e+01 2.1134799957275391e+01 5.8400398254394531e+01 -6.4982894897460938e+01 2.1211299896240234e+01 5.8871398925781250e+01 -6.4077697753906250e+01 2.1017198562622070e+01 5.8634799957275391e+01 -6.4520301818847656e+01 2.1017198562622070e+01 5.8579898834228516e+01 -6.4497596740722656e+01 2.1065401077270508e+01 5.8430797576904297e+01 -6.4988998413085938e+01 2.1065401077270508e+01 5.8399101257324219e+01 -6.4982597351074219e+01 2.1134799957275391e+01 5.8348098754882812e+01 -6.5500000000000000e+01 2.1134799957275391e+01 5.8349399566650391e+01 -6.5500000000000000e+01 2.1211299896240234e+01 5.8400398254394531e+01 -6.6017097473144531e+01 2.1211299896240234e+01 5.8489200592041016e+01 -6.5000602722167969e+01 2.1017198562622070e+01 5.8380500793457031e+01 -6.5500000000000000e+01 2.1065401077270508e+01 5.8399101257324219e+01 -6.6017395019531250e+01 2.1134799957275391e+01 5.8551200866699219e+01 -6.6514297485351562e+01 2.1211299896240234e+01 5.8489200592041016e+01 -6.5999404907226562e+01 2.1017198562622070e+01 5.8634799957275391e+01 -6.6479698181152344e+01 2.1017198562622070e+01 5.8579898834228516e+01 -6.6502403259277344e+01 2.1065401077270508e+01 5.8821903228759766e+01 -6.6955299377441406e+01 2.1065401077270508e+01 5.8795001983642578e+01 -6.6973297119140625e+01 2.1134799957275391e+01 5.9124801635742188e+01 -6.7375198364257812e+01 2.1134799957275391e+01 5.9125801086425781e+01 -6.7374198913574219e+01 2.1211299896240234e+01 5.9527400970458984e+01 -6.7703903198242188e+01 2.1211299896240234e+01 5.8871398925781250e+01 -6.6922302246093750e+01 2.1017198562622070e+01 5.9147701263427734e+01 -6.7352302551269531e+01 2.1065401077270508e+01 5.9526699066162109e+01 -6.7704994201660156e+01 2.1134799957275391e+01 5.9985702514648438e+01 -6.7948806762695312e+01 2.1211299896240234e+01 5.9189800262451172e+01 -6.7310195922851562e+01 2.1017198562622070e+01 5.9577701568603516e+01 -6.7628601074218750e+01 2.1017198562622070e+01 5.9544700622558594e+01 -6.7678100585937500e+01 2.1065401077270508e+01 5.9997600555419922e+01 -6.7920104980468750e+01 2.1065401077270508e+01 5.9985202789306641e+01 -6.7950004577636719e+01 2.1134799957275391e+01 6.0482597351074219e+01 -6.8100898742675781e+01 2.1134799957275391e+01 6.0482898712158203e+01 -6.8099601745605469e+01 2.1211299896240234e+01 6.1000000000000000e+01 -6.8150604248046875e+01 2.1211299896240234e+01 6.0020301818847656e+01 -6.7865203857421875e+01 2.1017198562622070e+01 6.0488998413085938e+01 -6.8069198608398438e+01 2.1065401077270508e+01 6.1000000000000000e+01 -6.8151901245117188e+01 2.1134799957275391e+01 6.1517101287841797e+01 -6.8099601745605469e+01 2.1211299896240234e+01 6.1000000000000000e+01 -6.8060005187988281e+01 2.1017198562622070e+01 6.1499397277832031e+01 -6.8010803222656250e+01 2.1017198562622070e+01 6.1510997772216797e+01 -6.8069198608398438e+01 2.1065401077270508e+01 6.2002403259277344e+01 -6.7920104980468750e+01 2.1065401077270508e+01 6.2014801025390625e+01 -6.7950004577636719e+01 2.1134799957275391e+01 6.2473300933837891e+01 -6.7704994201660156e+01 2.1134799957275391e+01 6.2472599029541016e+01 -6.7703903198242188e+01 2.1211299896240234e+01 6.2874198913574219e+01 -6.7374198913574219e+01 2.1211299896240234e+01 6.1979698181152344e+01 -6.7865203857421875e+01 2.1017198562622070e+01 6.2455299377441406e+01 -6.7678100585937500e+01 2.1065401077270508e+01 6.2875194549560547e+01 -6.7375198364257812e+01 2.1134799957275391e+01 6.3203899383544922e+01 -6.6972595214843750e+01 2.1211299896240234e+01 6.3510799407958984e+01 -6.5000602722167969e+01 2.1017198562622070e+01 6.3569202423095703e+01 -6.4988998413085938e+01 2.1065401077270508e+01 6.3619503021240234e+01 -6.5500000000000000e+01 2.1065401077270508e+01 6.3600898742675781e+01 -6.4982597351074219e+01 2.1134799957275391e+01 6.3651897430419922e+01 -6.5500000000000000e+01 2.1134799957275391e+01 6.3599601745605469e+01 -6.4982894897460938e+01 2.1211299896240234e+01 6.3650600433349609e+01 -6.5500000000000000e+01 2.1211299896240234e+01 6.2875194549560547e+01 -6.3624797821044922e+01 2.1134799957275391e+01 6.3178100585937500e+01 -6.4044700622558594e+01 2.1065401077270508e+01 6.3365200042724609e+01 -6.4520301818847656e+01 2.1017198562622070e+01 5.9526699066162109e+01 -6.3294998168945312e+01 2.1134799957275391e+01 5.9997600555419922e+01 -6.3079902648925781e+01 2.1065401077270508e+01 6.0500598907470703e+01 -6.2989196777343750e+01 2.1017198562622070e+01 5.8549999237060547e+01 -6.6514801025390625e+01 2.1134799957275391e+01 5.8430797576904297e+01 -6.6010993957519531e+01 2.1065401077270508e+01 5.8439998626708984e+01 -6.5500000000000000e+01 2.1017198562622070e+01 6.1517398834228516e+01 -6.8100898742675781e+01 2.1134799957275391e+01 6.1000000000000000e+01 -6.8119506835937500e+01 2.1065401077270508e+01 6.0500598907470703e+01 -6.8010803222656250e+01 2.1017198562622070e+01 6.3599601745605469e+01 -6.6017097473144531e+01 2.1211299896240234e+01 6.3569202423095703e+01 -6.6010993957519531e+01 2.1065401077270508e+01 6.3600898742675781e+01 -6.6017395019531250e+01 2.1134799957275391e+01 6.1000000000000000e+01 -6.5500000000000000e+01 4.1637500762939453e+01 8.8789596557617188e+01 -4.9100002288818359e+01 2.2701799392700195e+01 8.8841400146484375e+01 -4.8973098754882812e+01 3.8587200164794922e+01 8.8579902648925781e+01 -4.9425697326660156e+01 3.8587200164794922e+01 8.8910697937011719e+01 -4.8456298828125000e+01 2.2701799392700195e+01 8.8921707153320312e+01 -4.8456600189208984e+01 3.8587200164794922e+01 8.8903701782226562e+01 -4.8729801177978516e+01 2.2701799392700195e+01 8.8829895019531250e+01 -4.8969501495361328e+01 2.2701799392700195e+01 8.8913703918457031e+01 -4.8342601776123047e+01 2.2701799392700195e+01 8.8818801879882812e+01 -4.7967002868652344e+01 2.2701799392700195e+01 8.8809997558593750e+01 -4.7945899963378906e+01 3.8587200164794922e+01 8.8807502746582031e+01 -4.7947399139404297e+01 2.2701799392700195e+01 8.8626098632812500e+01 -4.7631000518798828e+01 2.2701799392700195e+01 8.8521400451660156e+01 -4.7510097503662109e+01 3.8587200164794922e+01 8.8090301513671875e+01 -4.7216300964355469e+01 2.2701799392700195e+01 8.8094894409179688e+01 -4.7208000183105469e+01 3.8587200164794922e+01 8.8349899291992188e+01 -4.7359397888183594e+01 2.2701799392700195e+01 8.8512397766113281e+01 -4.7519199371337891e+01 2.2701799392700195e+01 8.8010604858398438e+01 -4.7172401428222656e+01 2.2701799392700195e+01 8.7633499145507812e+01 -4.7083900451660156e+01 2.2701799392700195e+01 8.7587898254394531e+01 -4.7080299377441406e+01 3.8587200164794922e+01 8.7588195800781250e+01 -4.7085800170898438e+01 2.2701799392700195e+01 8.7246498107910156e+01 -4.7100399017333984e+01 2.2701799392700195e+01 8.7069198608398438e+01 -4.7144401550292969e+01 3.8587200164794922e+01 8.7073295593261719e+01 -4.7157001495361328e+01 2.2701799392700195e+01 8.6878295898437500e+01 -4.7220699310302734e+01 2.2701799392700195e+01 8.6608604431152344e+01 -4.7391601562500000e+01 3.8587200164794922e+01 8.6612800598144531e+01 -4.7398002624511719e+01 2.2701799392700195e+01 8.6268402099609375e+01 -4.7788501739501953e+01 3.8587200164794922e+01 8.6556205749511719e+01 -4.7435802459716797e+01 2.2701799392700195e+01 8.6304100036621094e+01 -4.7729896545410156e+01 2.2701799392700195e+01 8.6275299072265625e+01 -4.7791702270507812e+01 2.2701799392700195e+01 8.6140701293945312e+01 -4.8081199645996094e+01 2.2701799392700195e+01 8.6094497680664062e+01 -4.8281402587890625e+01 3.8587200164794922e+01 8.6107498168945312e+01 -4.8283599853515625e+01 2.2701799392700195e+01 8.6078102111816406e+01 -4.8463401794433594e+01 2.2701799392700195e+01 8.6110504150390625e+01 -4.8803897857666016e+01 3.8587200164794922e+01 8.6115898132324219e+01 -4.8803298950195312e+01 2.2701799392700195e+01 8.6314094543457031e+01 -4.9285400390625000e+01 3.8587200164794922e+01 8.6120903015136719e+01 -4.8848400115966797e+01 2.2701799392700195e+01 8.6266098022460938e+01 -4.9207603454589844e+01 2.2701799392700195e+01 8.6321601867675781e+01 -4.9279499053955078e+01 2.2701799392700195e+01 8.6502700805664062e+01 -4.9514202117919922e+01 2.2701799392700195e+01 8.6677902221679688e+01 -4.9660701751708984e+01 3.8587200164794922e+01 8.6685501098632812e+01 -4.9650402069091797e+01 2.2701799392700195e+01 8.6813400268554688e+01 -4.9745700836181641e+01 2.2701799392700195e+01 8.7152694702148438e+01 -4.9879302978515625e+01 3.8587200164794922e+01 8.7153701782226562e+01 -4.9876602172851562e+01 2.2701799392700195e+01 8.7674400329589844e+01 -4.9911701202392578e+01 3.8587200164794922e+01 8.7174896240234375e+01 -4.9884799957275391e+01 2.2701799392700195e+01 8.7560600280761719e+01 -4.9921100616455078e+01 2.2701799392700195e+01 8.7672500610351562e+01 -4.9900798797607422e+01 2.2701799392700195e+01 8.7941696166992188e+01 -4.9852100372314453e+01 2.2701799392700195e+01 8.8172599792480469e+01 -4.9753299713134766e+01 3.8587200164794922e+01 8.8167304992675781e+01 -4.9742401123046875e+01 2.2701799392700195e+01 8.8290100097656250e+01 -4.9682800292968750e+01 2.2701799392700195e+01 8.8579902648925781e+01 -4.9425697326660156e+01 2.2701799392700195e+01 8.9780006408691406e+01 -4.9782299041748047e+01 2.1279600143432617e+01 8.9860702514648438e+01 -4.9598602294921875e+01 2.1279600143432617e+01 8.9986305236816406e+01 -4.9312801361083984e+01 2.1279600143432617e+01 9.0072998046875000e+01 -4.8920799255371094e+01 2.1279600143432617e+01 9.0097099304199219e+01 -4.8812099456787109e+01 2.1279600143432617e+01 9.0108093261718750e+01 -4.8299499511718750e+01 2.1279600143432617e+01 9.0092597961425781e+01 -4.8211803436279297e+01 2.1279600143432617e+01 9.0018898010253906e+01 -4.7794498443603516e+01 2.1279600143432617e+01 8.9913703918457031e+01 -4.7524398803710938e+01 2.1279600143432617e+01 8.9832794189453125e+01 -4.7316699981689453e+01 2.1279600143432617e+01 8.9569099426269531e+01 -4.6902999877929688e+01 2.1279600143432617e+01 8.9557197570800781e+01 -4.6884300231933594e+01 2.1279600143432617e+01 8.9202400207519531e+01 -4.6513999938964844e+01 2.1279600143432617e+01 8.9056404113769531e+01 -4.6411800384521484e+01 2.1279600143432617e+01 8.8782302856445312e+01 -4.6220001220703125e+01 2.1279600143432617e+01 8.8435096740722656e+01 -4.6067497253417969e+01 2.1279600143432617e+01 8.8312797546386719e+01 -4.6013702392578125e+01 2.1279600143432617e+01 8.7812103271484375e+01 -4.5902900695800781e+01 2.1279600143432617e+01 8.7745399475097656e+01 -4.5901500701904297e+01 2.1279600143432617e+01 8.7299507141113281e+01 -4.5891899108886719e+01 2.1279600143432617e+01 8.7035995483398438e+01 -4.5938499450683594e+01 2.1279600143432617e+01 8.6794502258300781e+01 -4.5981101989746094e+01 2.1279600143432617e+01 8.6358100891113281e+01 -4.6151000976562500e+01 2.1279600143432617e+01 8.6316696166992188e+01 -4.6167198181152344e+01 2.1279600143432617e+01 8.5884300231933594e+01 -4.6442798614501953e+01 2.1279600143432617e+01 8.5771705627441406e+01 -4.6550697326660156e+01 2.1279600143432617e+01 8.5513999938964844e+01 -4.6797599792480469e+01 2.1279600143432617e+01 8.5309402465820312e+01 -4.7090000152587891e+01 2.1279600143432617e+01 8.5220001220703125e+01 -4.7217700958251953e+01 2.1279600143432617e+01 8.5013702392578125e+01 -4.7687198638916016e+01 2.1279600143432617e+01 8.5004096984863281e+01 -4.7730598449707031e+01 2.1279600143432617e+01 8.4902900695800781e+01 -4.8187900543212891e+01 2.1279600143432617e+01 8.4897598266601562e+01 -4.8432998657226562e+01 2.1279600143432617e+01 8.4891899108886719e+01 -4.8700500488281250e+01 2.1279600143432617e+01 8.4969497680664062e+01 -4.9139801025390625e+01 2.1279600143432617e+01 8.4981101989746094e+01 -4.9205501556396484e+01 2.1279600143432617e+01 8.5167198181152344e+01 -4.9683300018310547e+01 2.1279600143432617e+01 8.5238998413085938e+01 -4.9796001434326172e+01 2.1279600143432617e+01 8.5442794799804688e+01 -5.0115699768066406e+01 2.1279600143432617e+01 8.5674301147460938e+01 -5.0357299804687500e+01 2.1279600143432617e+01 8.5797599792480469e+01 -5.0486000061035156e+01 2.1279600143432617e+01 8.6217704772949219e+01 -5.0779998779296875e+01 2.1279600143432617e+01 8.6238098144531250e+01 -5.0788902282714844e+01 2.1279600143432617e+01 8.6687202453613281e+01 -5.0986301422119141e+01 2.1279600143432617e+01 8.6904800415039062e+01 -5.1034500122070312e+01 2.1279600143432617e+01 8.7187904357910156e+01 -5.1097099304199219e+01 2.1279600143432617e+01 8.7611495971679688e+01 -5.1106201171875000e+01 2.1279600143432617e+01 8.7700500488281250e+01 -5.1108100891113281e+01 2.1279600143432617e+01 8.8205497741699219e+01 -5.1018901824951172e+01 2.1279600143432617e+01 8.8309196472167969e+01 -5.0978500366210938e+01 2.1279600143432617e+01 8.8683296203613281e+01 -5.0832801818847656e+01 2.1279600143432617e+01 8.8946601867675781e+01 -5.0664997100830078e+01 2.1279600143432617e+01 8.9115699768066406e+01 -5.0557201385498047e+01 2.1279600143432617e+01 8.9486000061035156e+01 -5.0202400207519531e+01 2.1279600143432617e+01 8.5779502868652344e+01 -4.7560501098632812e+01 2.1000000000000000e+01 8.6308502197265625e+01 -4.6943401336669922e+01 2.1000000000000000e+01 8.6382003784179688e+01 -4.8076900482177734e+01 2.2701799392700195e+01 8.6911003112792969e+01 -4.7459800720214844e+01 2.2701799392700195e+01 8.7076904296875000e+01 -4.9618000030517578e+01 2.2701799392700195e+01 8.6459800720214844e+01 -4.9089000701904297e+01 2.2701799392700195e+01 8.7544097900390625e+01 -4.9072998046875000e+01 2.2701799392700195e+01 8.6926994323730469e+01 -4.8544101715087891e+01 2.2701799392700195e+01 8.7923103332519531e+01 -4.7381999969482422e+01 2.2701799392700195e+01 8.8540199279785156e+01 -4.7910999298095703e+01 2.2701799392700195e+01 8.7455902099609375e+01 -4.7926998138427734e+01 2.2701799392700195e+01 8.8072998046875000e+01 -4.8455902099609375e+01 2.2701799392700195e+01 8.8618003845214844e+01 -4.8923099517822266e+01 2.2701799392700195e+01 8.8088996887207031e+01 -4.9540199279785156e+01 2.2701799392700195e+01 8.6560501098632812e+01 -5.0220500946044922e+01 2.1000000000000000e+01 8.5943397521972656e+01 -4.9691497802734375e+01 2.1000000000000000e+01 8.9220504760742188e+01 -4.9439502716064453e+01 2.1000000000000000e+01 8.8691505432128906e+01 -5.0056598663330078e+01 2.1000000000000000e+01 8.8439498901367188e+01 -4.6779499053955078e+01 2.1000000000000000e+01 8.9056602478027344e+01 -4.7308502197265625e+01 2.1000000000000000e+01 8.9716598510742188e+01 -4.7375598907470703e+01 2.1000000000000000e+01 8.9893295288085938e+01 -4.7829700469970703e+01 2.1000000000000000e+01 8.8072998046875000e+01 -4.8455902099609375e+01 2.1000000000000000e+01 8.9454597473144531e+01 -4.6964801788330078e+01 2.1000000000000000e+01 8.9117599487304688e+01 -4.6612998962402344e+01 2.1000000000000000e+01 8.6281700134277344e+01 -5.0666297912597656e+01 2.1000000000000000e+01 8.5882400512695312e+01 -5.0386997222900391e+01 2.1000000000000000e+01 8.5545394897460938e+01 -5.0035202026367188e+01 2.1000000000000000e+01 8.9978096008300781e+01 -4.8309501647949219e+01 2.1000000000000000e+01 8.9967697143554688e+01 -4.8796600341796875e+01 2.1000000000000000e+01 8.9862396240234375e+01 -4.9272300720214844e+01 2.1000000000000000e+01 8.9666297912597656e+01 -4.9718299865722656e+01 2.1000000000000000e+01 8.8170295715332031e+01 -5.0893299102783203e+01 2.1000000000000000e+01 8.7544097900390625e+01 -4.9072998046875000e+01 2.1000000000000000e+01 8.9387001037597656e+01 -5.0117599487304688e+01 2.1000000000000000e+01 8.9035194396972656e+01 -5.0454601287841797e+01 2.1000000000000000e+01 8.8624404907226562e+01 -5.0716602325439453e+01 2.1000000000000000e+01 8.6375602722167969e+01 -4.6283401489257812e+01 2.1000000000000000e+01 8.6829696655273438e+01 -4.6106700897216797e+01 2.1000000000000000e+01 8.7455902099609375e+01 -4.7926998138427734e+01 2.1000000000000000e+01 8.5964797973632812e+01 -4.6545402526855469e+01 2.1000000000000000e+01 8.5612998962402344e+01 -4.6882396697998047e+01 2.1000000000000000e+01 8.7690505981445312e+01 -5.0978103637695312e+01 2.1000000000000000e+01 8.7203399658203125e+01 -5.0967700958251953e+01 2.1000000000000000e+01 8.6727699279785156e+01 -5.0862400054931641e+01 2.1000000000000000e+01 8.8718299865722656e+01 -4.6333702087402344e+01 2.1000000000000000e+01 8.8272300720214844e+01 -4.6137599945068359e+01 2.1000000000000000e+01 8.7796600341796875e+01 -4.6032299041748047e+01 2.1000000000000000e+01 8.7309501647949219e+01 -4.6021900177001953e+01 2.1000000000000000e+01 8.5283401489257812e+01 -4.9624397277832031e+01 2.1000000000000000e+01 8.5106697082519531e+01 -4.9170299530029297e+01 2.1000000000000000e+01 8.6926994323730469e+01 -4.8544101715087891e+01 2.1000000000000000e+01 8.5333694458007812e+01 -4.7281700134277344e+01 2.1000000000000000e+01 8.5137596130371094e+01 -4.7727699279785156e+01 2.1000000000000000e+01 8.5032302856445312e+01 -4.8203399658203125e+01 2.1000000000000000e+01 8.5021896362304688e+01 -4.8690502166748047e+01 2.1000000000000000e+01 8.6676399230957031e+01 -5.1019298553466797e+01 2.1211299896240234e+01 8.4868400573730469e+01 -4.8183696746826172e+01 2.1211299896240234e+01 8.7296798706054688e+01 -4.5857196807861328e+01 2.1211299896240234e+01 9.0052299499511719e+01 -4.7785099029541016e+01 2.1211299896240234e+01 8.7194503784179688e+01 -5.1041698455810547e+01 2.1017198562622070e+01 8.7696205139160156e+01 -5.1052497863769531e+01 2.1017198562622070e+01 8.7700798034667969e+01 -5.1111797332763672e+01 2.1065401077270508e+01 8.9443695068359375e+01 -5.0166099548339844e+01 2.1017198562622070e+01 8.9081298828125000e+01 -5.0513301849365234e+01 2.1017198562622070e+01 8.8215202331542969e+01 -5.1053600311279297e+01 2.1134799957275391e+01 8.8206497192382812e+01 -5.1022499084472656e+01 2.1065401077270508e+01 8.8190399169921875e+01 -5.0965202331542969e+01 2.1017198562622070e+01 8.8699104309082031e+01 -5.0863800048828125e+01 2.1211299896240234e+01 8.8699699401855469e+01 -5.0864997863769531e+01 2.1134799957275391e+01 8.8684997558593750e+01 -5.0836200714111328e+01 2.1065401077270508e+01 8.8658103942871094e+01 -5.0783100128173828e+01 2.1017198562622070e+01 9.0131599426269531e+01 -4.8816299438476562e+01 2.1211299896240234e+01 9.0019302368164062e+01 -4.9323600769042969e+01 2.1211299896240234e+01 9.0020599365234375e+01 -4.9323997497558594e+01 2.1134799957275391e+01 9.0142799377441406e+01 -4.8296802520751953e+01 2.1211299896240234e+01 9.0132896423339844e+01 -4.8816497802734375e+01 2.1134799957275391e+01 8.9989898681640625e+01 -4.9313999176025391e+01 2.1065401077270508e+01 9.0041694641113281e+01 -4.8805500030517578e+01 2.1017198562622070e+01 9.0052497863769531e+01 -4.8303802490234375e+01 2.1017198562622070e+01 9.0111801147460938e+01 -4.8299201965332031e+01 2.1065401077270508e+01 9.0022499084472656e+01 -4.7793498992919922e+01 2.1065401077270508e+01 9.0053604125976562e+01 -4.7784801483154297e+01 2.1134799957275391e+01 8.9864997863769531e+01 -4.7300300598144531e+01 2.1134799957275391e+01 8.9863800048828125e+01 -4.7300899505615234e+01 2.1211299896240234e+01 8.9584503173828125e+01 -4.6862800598144531e+01 2.1211299896240234e+01 8.9965202331542969e+01 -4.7809600830078125e+01 2.1017198562622070e+01 8.9836204528808594e+01 -4.7315002441406250e+01 2.1065401077270508e+01 8.9585494995117188e+01 -4.6861999511718750e+01 2.1134799957275391e+01 8.9224998474121094e+01 -4.6487598419189453e+01 2.1211299896240234e+01 8.9783103942871094e+01 -4.7341903686523438e+01 2.1017198562622070e+01 8.9513305664062500e+01 -4.6918701171875000e+01 2.1017198562622070e+01 8.9560096740722656e+01 -4.6881999969482422e+01 2.1065401077270508e+01 8.9204803466796875e+01 -4.6511199951171875e+01 2.1065401077270508e+01 8.9225906372070312e+01 -4.6486602783203125e+01 2.1134799957275391e+01 8.8799903869628906e+01 -4.6188598632812500e+01 2.1134799957275391e+01 8.8799301147460938e+01 -4.6189701080322266e+01 2.1211299896240234e+01 8.8323600769042969e+01 -4.5980697631835938e+01 2.1211299896240234e+01 8.9166099548339844e+01 -4.6556301116943359e+01 2.1017198562622070e+01 8.8784095764160156e+01 -4.6216800689697266e+01 2.1065401077270508e+01 8.8324005126953125e+01 -4.5979400634765625e+01 2.1134799957275391e+01 8.7816299438476562e+01 -4.5868400573730469e+01 2.1211299896240234e+01 8.8295494079589844e+01 -4.6066699981689453e+01 2.1017198562622070e+01 8.7805503845214844e+01 -4.5958297729492188e+01 2.1017198562622070e+01 8.7812599182128906e+01 -4.5899200439453125e+01 2.1065401077270508e+01 8.7299194335937500e+01 -4.5888198852539062e+01 2.1065401077270508e+01 8.7296699523925781e+01 -4.5855899810791016e+01 2.1134799957275391e+01 8.6784805297851562e+01 -4.5946399688720703e+01 2.1134799957275391e+01 8.6785102844238281e+01 -4.5947700500488281e+01 2.1211299896240234e+01 8.6300903320312500e+01 -4.6136199951171875e+01 2.1211299896240234e+01 8.7303802490234375e+01 -4.5947498321533203e+01 2.1017198562622070e+01 8.6793495178222656e+01 -4.5977500915527344e+01 2.1065401077270508e+01 8.6300300598144531e+01 -4.6135002136230469e+01 2.1134799957275391e+01 8.5862800598144531e+01 -4.6415500640869141e+01 2.1211299896240234e+01 8.6809600830078125e+01 -4.6034801483154297e+01 2.1017198562622070e+01 8.6341903686523438e+01 -4.6216899871826172e+01 2.1017198562622070e+01 8.6314994812011719e+01 -4.6163799285888672e+01 2.1065401077270508e+01 8.5882003784179688e+01 -4.6439899444580078e+01 2.1065401077270508e+01 8.5861999511718750e+01 -4.6414497375488281e+01 2.1134799957275391e+01 8.5486595153808594e+01 -4.6774101257324219e+01 2.1134799957275391e+01 8.5487594604492188e+01 -4.6774997711181641e+01 2.1211299896240234e+01 8.5189697265625000e+01 -4.7200698852539062e+01 2.1211299896240234e+01 8.5918701171875000e+01 -4.6486701965332031e+01 2.1017198562622070e+01 8.5511199951171875e+01 -4.6795200347900391e+01 2.1065401077270508e+01 8.5188598632812500e+01 -4.7200099945068359e+01 2.1134799957275391e+01 8.4980697631835938e+01 -4.7676399230957031e+01 2.1211299896240234e+01 8.5268699645996094e+01 -4.7245101928710938e+01 2.1017198562622070e+01 8.5066696166992188e+01 -4.7704498291015625e+01 2.1017198562622070e+01 8.5010093688964844e+01 -4.7686000823974609e+01 2.1065401077270508e+01 8.4899200439453125e+01 -4.8187400817871094e+01 2.1065401077270508e+01 8.4867095947265625e+01 -4.8183502197265625e+01 2.1134799957275391e+01 8.4855895996093750e+01 -4.8703300476074219e+01 2.1134799957275391e+01 8.4857200622558594e+01 -4.8703201293945312e+01 2.1211299896240234e+01 8.4947700500488281e+01 -4.9214900970458984e+01 2.1211299896240234e+01 8.4958297729492188e+01 -4.8194499969482422e+01 2.1017198562622070e+01 8.4888198852539062e+01 -4.8700798034667969e+01 2.1065401077270508e+01 8.4946403503417969e+01 -4.9215202331542969e+01 2.1134799957275391e+01 8.5136199951171875e+01 -4.9699100494384766e+01 2.1211299896240234e+01 8.4947494506835938e+01 -4.8696201324462891e+01 2.1017198562622070e+01 8.5034805297851562e+01 -4.9190399169921875e+01 2.1017198562622070e+01 8.4977500915527344e+01 -4.9206497192382812e+01 2.1065401077270508e+01 8.5163803100585938e+01 -4.9685001373291016e+01 2.1065401077270508e+01 8.5134994506835938e+01 -4.9699703216552734e+01 2.1134799957275391e+01 8.5414497375488281e+01 -5.0138000488281250e+01 2.1134799957275391e+01 8.5415496826171875e+01 -5.0137199401855469e+01 2.1211299896240234e+01 8.5775001525878906e+01 -5.0512397766113281e+01 2.1211299896240234e+01 8.5216903686523438e+01 -4.9658100128173828e+01 2.1017198562622070e+01 8.5439895629882812e+01 -5.0118000030517578e+01 2.1065401077270508e+01 8.5774101257324219e+01 -5.0513401031494141e+01 2.1134799957275391e+01 8.6200698852539062e+01 -5.0810298919677734e+01 2.1211299896240234e+01 8.5833900451660156e+01 -5.0443702697753906e+01 2.1017198562622070e+01 8.6245094299316406e+01 -5.0731300354003906e+01 2.1017198562622070e+01 8.6215896606445312e+01 -5.0783199310302734e+01 2.1065401077270508e+01 8.6685997009277344e+01 -5.0989898681640625e+01 2.1065401077270508e+01 8.6676002502441406e+01 -5.1020599365234375e+01 2.1134799957275391e+01 8.7183494567871094e+01 -5.1132900238037109e+01 2.1134799957275391e+01 8.7183700561523438e+01 -5.1131599426269531e+01 2.1211299896240234e+01 8.7703201293945312e+01 -5.1142799377441406e+01 2.1211299896240234e+01 8.6704498291015625e+01 -5.0933300018310547e+01 2.1017198562622070e+01 8.7187400817871094e+01 -5.1100803375244141e+01 2.1065401077270508e+01 8.7703300476074219e+01 -5.1144100189208984e+01 2.1134799957275391e+01 8.8214897155761719e+01 -5.1052299499511719e+01 2.1211299896240234e+01 8.9731300354003906e+01 -4.9754898071289062e+01 2.1017198562622070e+01 8.9783195495605469e+01 -4.9784103393554688e+01 2.1065401077270508e+01 8.9488800048828125e+01 -5.0204799652099609e+01 2.1065401077270508e+01 8.9811401367187500e+01 -4.9799900054931641e+01 2.1134799957275391e+01 8.9513397216796875e+01 -5.0225898742675781e+01 2.1134799957275391e+01 8.9810295104980469e+01 -4.9799301147460938e+01 2.1211299896240234e+01 8.9512397766113281e+01 -5.0225002288818359e+01 2.1211299896240234e+01 9.0144096374511719e+01 -4.8296699523925781e+01 2.1134799957275391e+01 9.0100799560546875e+01 -4.8812602996826172e+01 2.1065401077270508e+01 8.9933296203613281e+01 -4.9295501708984375e+01 2.1017198562622070e+01 8.7816497802734375e+01 -4.5867099761962891e+01 2.1134799957275391e+01 8.8313995361328125e+01 -4.6010097503662109e+01 2.1065401077270508e+01 8.8754898071289062e+01 -4.6268699645996094e+01 2.1017198562622070e+01 8.4979400634765625e+01 -4.7676002502441406e+01 2.1134799957275391e+01 8.5216796875000000e+01 -4.7215900421142578e+01 2.1065401077270508e+01 8.5556297302246094e+01 -4.6833900451660156e+01 2.1017198562622070e+01 8.6200103759765625e+01 -5.0811397552490234e+01 2.1134799957275391e+01 8.5795204162597656e+01 -5.0488800048828125e+01 2.1065401077270508e+01 8.5486701965332031e+01 -5.0081302642822266e+01 2.1017198562622070e+01 8.9137199401855469e+01 -5.0584499359130859e+01 2.1211299896240234e+01 8.9117996215820312e+01 -5.0560096740722656e+01 2.1065401077270508e+01 8.9138000488281250e+01 -5.0585502624511719e+01 2.1134799957275391e+01 8.7500000000000000e+01 -4.8500000000000000e+01 4.1637500762939453e+01 8.8862396240234375e+01 4.8908901214599609e+01 2.2701799392700195e+01 8.8816703796386719e+01 4.9038101196289062e+01 3.8587200164794922e+01 8.8922203063964844e+01 4.8526203155517578e+01 3.8587200164794922e+01 8.8524993896484375e+01 4.9470302581787109e+01 2.2701799392700195e+01 8.8533401489257812e+01 4.9477397918701172e+01 3.8587200164794922e+01 8.8701499938964844e+01 4.9261302947998047e+01 2.2701799392700195e+01 8.8805694580078125e+01 4.9033100128173828e+01 2.2701799392700195e+01 8.8451599121093750e+01 4.9557201385498047e+01 2.2701799392700195e+01 8.8131103515625000e+01 4.9774700164794922e+01 2.2701799392700195e+01 8.8110496520996094e+01 4.9784702301025391e+01 3.8587200164794922e+01 8.8109596252441406e+01 4.9781898498535156e+01 2.2701799392700195e+01 8.7763694763183594e+01 4.9897701263427734e+01 2.2701799392700195e+01 8.7605201721191406e+01 4.9918498992919922e+01 3.8587200164794922e+01 8.7087799072265625e+01 4.9851398468017578e+01 2.2701799392700195e+01 8.7085700988769531e+01 4.9860702514648438e+01 3.8587200164794922e+01 8.7376899719238281e+01 4.9917102813720703e+01 2.2701799392700195e+01 8.7604499816894531e+01 4.9905696868896484e+01 2.2701799392700195e+01 8.6999099731445312e+01 4.9831302642822266e+01 2.2701799392700195e+01 8.6658500671386719e+01 4.9646797180175781e+01 2.2701799392700195e+01 8.6622093200683594e+01 4.9619102478027344e+01 3.8587200164794922e+01 8.6625892639160156e+01 4.9615200042724609e+01 2.2701799392700195e+01 8.6380302429199219e+01 4.9377201080322266e+01 2.2701799392700195e+01 8.6277099609375000e+01 4.9226398468017578e+01 3.8587200164794922e+01 8.6288497924804688e+01 4.9219799041748047e+01 2.2701799392700195e+01 8.6185203552246094e+01 4.9042602539062500e+01 2.2701799392700195e+01 8.6097206115722656e+01 4.8735599517822266e+01 3.8587200164794922e+01 8.6104698181152344e+01 4.8733699798583984e+01 2.2701799392700195e+01 8.6106895446777344e+01 4.8213001251220703e+01 3.8587200164794922e+01 8.6087501525878906e+01 4.8667697906494141e+01 2.2701799392700195e+01 8.6094604492187500e+01 4.8280399322509766e+01 2.2701799392700195e+01 8.6114196777343750e+01 4.8215198516845703e+01 2.2701799392700195e+01 8.6205993652343750e+01 4.7909400939941406e+01 2.2701799392700195e+01 8.6304595947265625e+01 4.7729099273681641e+01 3.8587200164794922e+01 8.6315803527832031e+01 4.7736202239990234e+01 2.2701799392700195e+01 8.6413299560546875e+01 4.7582202911376953e+01 2.2701799392700195e+01 8.6663795471191406e+01 4.7349300384521484e+01 3.8587200164794922e+01 8.6667503356933594e+01 4.7353401184082031e+01 2.2701799392700195e+01 8.7136001586914062e+01 4.7125000000000000e+01 3.8587200164794922e+01 8.6701202392578125e+01 4.7323101043701172e+01 2.2701799392700195e+01 8.7048393249511719e+01 4.7151199340820312e+01 2.2701799392700195e+01 8.7137695312500000e+01 4.7134300231933594e+01 2.2701799392700195e+01 8.7429000854492188e+01 4.7079399108886719e+01 2.2701799392700195e+01 8.7657302856445312e+01 4.7086299896240234e+01 3.8587200164794922e+01 8.7656196594238281e+01 4.7099098205566406e+01 2.2701799392700195e+01 8.7815002441406250e+01 4.7112899780273438e+01 2.2701799392700195e+01 8.8157302856445312e+01 4.7238597869873047e+01 3.8587200164794922e+01 8.8156295776367188e+01 4.7241298675537109e+01 2.2701799392700195e+01 8.8568595886230469e+01 4.7561199188232422e+01 3.8587200164794922e+01 8.8177505493164062e+01 4.7249298095703125e+01 2.2701799392700195e+01 8.8489799499511719e+01 4.7478500366210938e+01 2.2701799392700195e+01 8.8559997558593750e+01 4.7568000793457031e+01 2.2701799392700195e+01 8.8728706359863281e+01 4.7783401489257812e+01 2.2701799392700195e+01 8.8835594177246094e+01 4.8010597229003906e+01 3.8587200164794922e+01 8.8824401855468750e+01 4.8015300750732422e+01 2.2701799392700195e+01 8.8876502990722656e+01 4.8141502380371094e+01 2.2701799392700195e+01 8.8922203063964844e+01 4.8526203155517578e+01 2.2701799392700195e+01 9.0055694580078125e+01 4.9057403564453125e+01 2.1279600143432617e+01 8.9993995666503906e+01 4.9248199462890625e+01 2.1279600143432617e+01 8.9897903442382812e+01 4.9545299530029297e+01 2.1279600143432617e+01 8.9702102661132812e+01 4.9895801544189453e+01 2.1279600143432617e+01 8.9647895812988281e+01 4.9993000030517578e+01 2.1279600143432617e+01 8.9315299987792969e+01 5.0383300781250000e+01 2.1279600143432617e+01 8.9245498657226562e+01 5.0438499450683594e+01 2.1279600143432617e+01 8.8913002014160156e+01 5.0701301574707031e+01 2.1279600143432617e+01 8.8654899597167969e+01 5.0833198547363281e+01 2.1279600143432617e+01 8.8456398010253906e+01 5.0934700012207031e+01 2.1279600143432617e+01 8.7984397888183594e+01 5.1068397521972656e+01 2.1279600143432617e+01 8.7963096618652344e+01 5.1074501037597656e+01 2.1279600143432617e+01 8.7451896667480469e+01 5.1115299224853516e+01 2.1279600143432617e+01 8.7274902343750000e+01 5.1094600677490234e+01 2.1279600143432617e+01 8.6942596435546875e+01 5.1055698394775391e+01 2.1279600143432617e+01 8.6581794738769531e+01 5.0939002990722656e+01 2.1279600143432617e+01 8.6454696655273438e+01 5.0897899627685547e+01 2.1279600143432617e+01 8.6006996154785156e+01 5.0647899627685547e+01 2.1279600143432617e+01 8.5956199645996094e+01 5.0604598999023438e+01 2.1279600143432617e+01 8.5616699218750000e+01 5.0315299987792969e+01 2.1279600143432617e+01 8.5450798034667969e+01 5.0105400085449219e+01 2.1279600143432617e+01 8.5298698425292969e+01 4.9913002014160156e+01 2.1279600143432617e+01 8.5085601806640625e+01 4.9495998382568359e+01 2.1279600143432617e+01 8.5065299987792969e+01 4.9456398010253906e+01 2.1279600143432617e+01 8.4925498962402344e+01 4.8963100433349609e+01 2.1279600143432617e+01 8.4913093566894531e+01 4.8807598114013672e+01 2.1279600143432617e+01 8.4884704589843750e+01 4.8451900482177734e+01 2.1279600143432617e+01 8.4926200866699219e+01 4.8097499847412109e+01 2.1279600143432617e+01 8.4944297790527344e+01 4.7942600250244141e+01 2.1279600143432617e+01 8.5102104187011719e+01 4.7454700469970703e+01 2.1279600143432617e+01 8.5123802185058594e+01 4.7415901184082031e+01 2.1279600143432617e+01 8.5352104187011719e+01 4.7006999969482422e+01 2.1279600143432617e+01 8.5511199951171875e+01 4.6820301055908203e+01 2.1279600143432617e+01 8.5684700012207031e+01 4.6616699218750000e+01 2.1279600143432617e+01 8.6034606933593750e+01 4.6340099334716797e+01 2.1279600143432617e+01 8.6087005615234375e+01 4.6298702239990234e+01 2.1279600143432617e+01 8.6543594360351562e+01 4.6065299987792969e+01 2.1279600143432617e+01 8.6672096252441406e+01 4.6028900146484375e+01 2.1279600143432617e+01 8.7036903381347656e+01 4.5925502777099609e+01 2.1279600143432617e+01 8.7370399475097656e+01 4.5898899078369141e+01 2.1279600143432617e+01 8.7548095703125000e+01 4.5884696960449219e+01 2.1279600143432617e+01 8.8057395935058594e+01 4.5944297790527344e+01 2.1279600143432617e+01 8.8078605651855469e+01 4.5951099395751953e+01 2.1279600143432617e+01 8.8545303344726562e+01 4.6102100372314453e+01 2.1279600143432617e+01 8.8739898681640625e+01 4.6210800170898438e+01 2.1279600143432617e+01 8.8992996215820312e+01 4.6352100372314453e+01 2.1279600143432617e+01 8.9315597534179688e+01 4.6626899719238281e+01 2.1279600143432617e+01 8.9383293151855469e+01 4.6684700012207031e+01 2.1279600143432617e+01 8.9701301574707031e+01 4.7086997985839844e+01 2.1279600143432617e+01 8.9752006530761719e+01 4.7186100006103516e+01 2.1279600143432617e+01 8.9934700012207031e+01 4.7543601989746094e+01 2.1279600143432617e+01 9.0019798278808594e+01 4.7844001770019531e+01 2.1279600143432617e+01 9.0074501037597656e+01 4.8036899566650391e+01 2.1279600143432617e+01 9.0115303039550781e+01 4.8548099517822266e+01 2.1279600143432617e+01 8.5590103149414062e+01 4.8058403015136719e+01 2.1000000000000000e+01 8.5575096130371094e+01 4.8871101379394531e+01 2.1000000000000000e+01 8.6383499145507812e+01 4.8073001861572266e+01 2.2701799392700195e+01 8.6368598937988281e+01 4.8885700225830078e+01 2.2701799392700195e+01 8.7927001953125000e+01 4.7383499145507812e+01 2.2701799392700195e+01 8.7114295959472656e+01 4.7368602752685547e+01 2.2701799392700195e+01 8.7913795471191406e+01 4.8101100921630859e+01 2.2701799392700195e+01 8.7101104736328125e+01 4.8086200714111328e+01 2.2701799392700195e+01 8.7072998046875000e+01 4.9616500854492188e+01 2.2701799392700195e+01 8.7885696411132812e+01 4.9631397247314453e+01 2.2701799392700195e+01 8.7086196899414062e+01 4.8898902893066406e+01 2.2701799392700195e+01 8.7898902893066406e+01 4.8913799285888672e+01 2.2701799392700195e+01 8.8616500854492188e+01 4.8927001953125000e+01 2.2701799392700195e+01 8.8631401062011719e+01 4.8114299774169922e+01 2.2701799392700195e+01 8.7941604614257812e+01 4.6590099334716797e+01 2.1000000000000000e+01 8.7128898620605469e+01 4.6575099945068359e+01 2.1000000000000000e+01 8.9409904479980469e+01 4.8941600799560547e+01 2.1000000000000000e+01 8.9424903869628906e+01 4.8128898620605469e+01 2.1000000000000000e+01 8.7058403015136719e+01 5.0409896850585938e+01 2.1000000000000000e+01 8.7871093750000000e+01 5.0424900054931641e+01 2.1000000000000000e+01 8.8408699035644531e+01 5.0813297271728516e+01 2.1000000000000000e+01 8.8842597961425781e+01 5.0591598510742188e+01 2.1000000000000000e+01 8.7898902893066406e+01 4.8913799285888672e+01 2.1000000000000000e+01 8.7940002441406250e+01 5.0946197509765625e+01 2.1000000000000000e+01 8.7454299926757812e+01 5.0985000610351562e+01 2.1000000000000000e+01 8.8029602050781250e+01 4.6071701049804688e+01 2.1000000000000000e+01 8.7545700073242188e+01 4.6015003204345703e+01 2.1000000000000000e+01 8.7059997558593750e+01 4.6053802490234375e+01 2.1000000000000000e+01 8.9224800109863281e+01 5.0289501190185547e+01 2.1000000000000000e+01 8.9540802001953125e+01 4.9918598175048828e+01 2.1000000000000000e+01 8.9778404235839844e+01 4.9493202209472656e+01 2.1000000000000000e+01 8.9928298950195312e+01 4.9029598236083984e+01 2.1000000000000000e+01 8.9591598510742188e+01 4.7157398223876953e+01 2.1000000000000000e+01 8.7913795471191406e+01 4.8101100921630859e+01 2.1000000000000000e+01 8.9985000610351562e+01 4.8545700073242188e+01 2.1000000000000000e+01 8.9946205139160156e+01 4.8060001373291016e+01 2.1000000000000000e+01 8.9813301086425781e+01 4.7591297149658203e+01 2.1000000000000000e+01 8.5186698913574219e+01 4.9408699035644531e+01 2.1000000000000000e+01 8.5408393859863281e+01 4.9842597961425781e+01 2.1000000000000000e+01 8.7086196899414062e+01 4.8898902893066406e+01 2.1000000000000000e+01 8.5053802490234375e+01 4.8939998626708984e+01 2.1000000000000000e+01 8.5014999389648438e+01 4.8454299926757812e+01 2.1000000000000000e+01 8.9289505004882812e+01 4.6775199890136719e+01 2.1000000000000000e+01 8.8918594360351562e+01 4.6459201812744141e+01 2.1000000000000000e+01 8.8493194580078125e+01 4.6221599578857422e+01 2.1000000000000000e+01 8.6970397949218750e+01 5.0928298950195312e+01 2.1000000000000000e+01 8.6506797790527344e+01 5.0778400421142578e+01 2.1000000000000000e+01 8.6081398010253906e+01 5.0540802001953125e+01 2.1000000000000000e+01 8.5710502624511719e+01 5.0224800109863281e+01 2.1000000000000000e+01 8.6591300964355469e+01 4.6186698913574219e+01 2.1000000000000000e+01 8.6157394409179688e+01 4.6408401489257812e+01 2.1000000000000000e+01 8.7101104736328125e+01 4.8086200714111328e+01 2.1000000000000000e+01 8.5071701049804688e+01 4.7970397949218750e+01 2.1000000000000000e+01 8.5221603393554688e+01 4.7506801605224609e+01 2.1000000000000000e+01 8.5459205627441406e+01 4.7081398010253906e+01 2.1000000000000000e+01 8.5775199890136719e+01 4.6710498809814453e+01 2.1000000000000000e+01 8.8559204101562500e+01 4.6070301055908203e+01 2.1211299896240234e+01 8.5323600769042969e+01 4.6987197875976562e+01 2.1211299896240234e+01 8.5591598510742188e+01 5.0339401245117188e+01 2.1211299896240234e+01 8.8931800842285156e+01 5.0730602264404297e+01 2.1211299896240234e+01 8.8961196899414062e+01 4.6397899627685547e+01 2.1017198562622070e+01 8.9343200683593750e+01 4.6723400115966797e+01 2.1017198562622070e+01 8.9386001586914062e+01 4.6682102203369141e+01 2.1065401077270508e+01 9.0059600830078125e+01 4.8547100067138672e+01 2.1017198562622070e+01 9.0019599914550781e+01 4.8046802520751953e+01 2.1017198562622070e+01 8.9731697082519531e+01 4.7067501068115234e+01 2.1134799957275391e+01 8.9704498291015625e+01 4.7084999084472656e+01 2.1065401077270508e+01 8.9654403686523438e+01 4.7117099761962891e+01 2.1017198562622070e+01 8.9966995239257812e+01 4.7530899047851562e+01 2.1211299896240234e+01 8.9968299865722656e+01 4.7530403137207031e+01 2.1134799957275391e+01 8.9938201904296875e+01 4.7542198181152344e+01 2.1065401077270508e+01 8.9882797241210938e+01 4.7563999176025391e+01 2.1017198562622070e+01 8.9676399230957031e+01 5.0012802124023438e+01 2.1211299896240234e+01 8.9929702758789062e+01 4.9559196472167969e+01 2.1211299896240234e+01 8.9930999755859375e+01 4.9559700012207031e+01 2.1134799957275391e+01 8.9339401245117188e+01 5.0408401489257812e+01 2.1211299896240234e+01 8.9677497863769531e+01 5.0013603210449219e+01 2.1134799957275391e+01 8.9901298522949219e+01 4.9546798706054688e+01 2.1065401077270508e+01 8.9602096557617188e+01 4.9961200714111328e+01 2.1017198562622070e+01 8.9276596069335938e+01 5.0343200683593750e+01 2.1017198562622070e+01 8.9317901611328125e+01 5.0386001586914062e+01 2.1065401077270508e+01 8.8915000915527344e+01 5.0704502105712891e+01 2.1065401077270508e+01 8.8932502746582031e+01 5.0731700897216797e+01 2.1134799957275391e+01 8.8469604492187500e+01 5.0968299865722656e+01 2.1134799957275391e+01 8.8469100952148438e+01 5.0966999053955078e+01 2.1211299896240234e+01 8.7969200134277344e+01 5.1108699798583984e+01 2.1211299896240234e+01 8.8882904052734375e+01 5.0654399871826172e+01 2.1017198562622070e+01 8.8457801818847656e+01 5.0938201904296875e+01 2.1065401077270508e+01 8.7969398498535156e+01 5.1110000610351562e+01 2.1134799957275391e+01 8.7451301574707031e+01 5.1150096893310547e+01 2.1211299896240234e+01 8.8435997009277344e+01 5.0882801055908203e+01 2.1017198562622070e+01 8.7953201293945312e+01 5.1019599914550781e+01 2.1017198562622070e+01 8.7963699340820312e+01 5.1078201293945312e+01 2.1065401077270508e+01 8.7451797485351562e+01 5.1119098663330078e+01 2.1065401077270508e+01 8.7451194763183594e+01 5.1151397705078125e+01 2.1134799957275391e+01 8.6934898376464844e+01 5.1090999603271484e+01 2.1134799957275391e+01 8.6935203552246094e+01 5.1089698791503906e+01 2.1211299896240234e+01 8.6440803527832031e+01 5.0929698944091797e+01 2.1211299896240234e+01 8.7452903747558594e+01 5.1059600830078125e+01 2.1017198562622070e+01 8.6941802978515625e+01 5.1059398651123047e+01 2.1065401077270508e+01 8.6440299987792969e+01 5.0930999755859375e+01 2.1134799957275391e+01 8.5987205505371094e+01 5.0676403045654297e+01 2.1211299896240234e+01 8.6476997375488281e+01 5.0846698760986328e+01 2.1017198562622070e+01 8.6038795471191406e+01 5.0602100372314453e+01 2.1017198562622070e+01 8.6004898071289062e+01 5.0650897979736328e+01 2.1065401077270508e+01 8.5614006042480469e+01 5.0317897796630859e+01 2.1065401077270508e+01 8.5590698242187500e+01 5.0340400695800781e+01 2.1134799957275391e+01 8.5268295288085938e+01 4.9932498931884766e+01 2.1134799957275391e+01 8.5269401550292969e+01 4.9931800842285156e+01 2.1211299896240234e+01 8.5032997131347656e+01 4.9469097137451172e+01 2.1211299896240234e+01 8.5656799316406250e+01 5.0276599884033203e+01 2.1017198562622070e+01 8.5295501708984375e+01 4.9915000915527344e+01 2.1065401077270508e+01 8.5031700134277344e+01 4.9469600677490234e+01 2.1134799957275391e+01 8.4891296386718750e+01 4.8969200134277344e+01 2.1211299896240234e+01 8.5345603942871094e+01 4.9882900238037109e+01 2.1017198562622070e+01 8.5117195129394531e+01 4.9436000823974609e+01 2.1017198562622070e+01 8.5061805725097656e+01 4.9457798004150391e+01 2.1065401077270508e+01 8.4921798706054688e+01 4.8963699340820312e+01 2.1065401077270508e+01 8.4889999389648438e+01 4.8969398498535156e+01 2.1134799957275391e+01 8.4848594665527344e+01 4.8451198577880859e+01 2.1134799957275391e+01 8.4849899291992188e+01 4.8451301574707031e+01 2.1211299896240234e+01 8.4910301208496094e+01 4.7935199737548828e+01 2.1211299896240234e+01 8.4980400085449219e+01 4.8953201293945312e+01 2.1017198562622070e+01 8.4880905151367188e+01 4.8451801300048828e+01 2.1065401077270508e+01 8.4908996582031250e+01 4.7934902191162109e+01 2.1134799957275391e+01 8.5070297241210938e+01 4.7440799713134766e+01 2.1211299896240234e+01 8.4998802185058594e+01 4.7954498291015625e+01 2.1017198562622070e+01 8.5153297424316406e+01 4.7477001190185547e+01 2.1017198562622070e+01 8.5098701477050781e+01 4.7453197479248047e+01 2.1065401077270508e+01 8.5349098205566406e+01 4.7004901885986328e+01 2.1065401077270508e+01 8.5322502136230469e+01 4.6986400604248047e+01 2.1134799957275391e+01 8.5659599304199219e+01 4.6590702056884766e+01 2.1134799957275391e+01 8.5660598754882812e+01 4.6591598510742188e+01 2.1211299896240234e+01 8.6068199157714844e+01 4.6269397735595703e+01 2.1211299896240234e+01 8.5397895812988281e+01 4.7038799285888672e+01 2.1017198562622070e+01 8.5682098388671875e+01 4.6613998413085938e+01 2.1065401077270508e+01 8.6067497253417969e+01 4.6268299102783203e+01 2.1134799957275391e+01 8.6530899047851562e+01 4.6032997131347656e+01 2.1211299896240234e+01 8.5723403930664062e+01 4.6656799316406250e+01 2.1017198562622070e+01 8.6117103576660156e+01 4.6345600128173828e+01 2.1017198562622070e+01 8.6084999084472656e+01 4.6295501708984375e+01 2.1065401077270508e+01 8.6542198181152344e+01 4.6061798095703125e+01 2.1065401077270508e+01 8.6530403137207031e+01 4.6031700134277344e+01 2.1134799957275391e+01 8.7030593872070312e+01 4.5889999389648438e+01 2.1134799957275391e+01 8.7030799865722656e+01 4.5891300201416016e+01 2.1211299896240234e+01 8.7548706054687500e+01 4.5849899291992188e+01 2.1211299896240234e+01 8.6563995361328125e+01 4.6117202758789062e+01 2.1017198562622070e+01 8.7036293029785156e+01 4.5921798706054688e+01 2.1065401077270508e+01 8.7548797607421875e+01 4.5848602294921875e+01 2.1134799957275391e+01 8.8064796447753906e+01 4.5910297393798828e+01 2.1211299896240234e+01 8.7547103881835938e+01 4.5940399169921875e+01 2.1017198562622070e+01 8.8045501708984375e+01 4.5998802185058594e+01 2.1017198562622070e+01 8.8058204650878906e+01 4.5940601348876953e+01 2.1065401077270508e+01 8.8546798706054688e+01 4.6098701477050781e+01 2.1065401077270508e+01 8.8559700012207031e+01 4.6069000244140625e+01 2.1134799957275391e+01 8.9013595581054688e+01 4.6322498321533203e+01 2.1134799957275391e+01 8.9012802124023438e+01 4.6323600769042969e+01 2.1211299896240234e+01 8.9408401489257812e+01 4.6660598754882812e+01 2.1211299896240234e+01 8.8523002624511719e+01 4.6153301239013672e+01 2.1017198562622070e+01 8.8995101928710938e+01 4.6349102020263672e+01 2.1065401077270508e+01 8.9409301757812500e+01 4.6659599304199219e+01 2.1134799957275391e+01 8.9730598449707031e+01 4.7068199157714844e+01 2.1211299896240234e+01 9.0001205444335938e+01 4.9045497894287109e+01 2.1017198562622070e+01 9.0059402465820312e+01 4.9058197021484375e+01 2.1065401077270508e+01 9.0119102478027344e+01 4.8548198699951172e+01 2.1065401077270508e+01 9.0090995788574219e+01 4.9065097808837891e+01 2.1134799957275391e+01 9.0151397705078125e+01 4.8548797607421875e+01 2.1134799957275391e+01 9.0089698791503906e+01 4.9064800262451172e+01 2.1211299896240234e+01 9.0150100708007812e+01 4.8548698425292969e+01 2.1211299896240234e+01 8.9340400695800781e+01 5.0409297943115234e+01 2.1134799957275391e+01 8.9650901794433594e+01 4.9995098114013672e+01 2.1065401077270508e+01 8.9846702575683594e+01 4.9522998809814453e+01 2.1017198562622070e+01 8.5986396789550781e+01 5.0677501678466797e+01 2.1134799957275391e+01 8.6453201293945312e+01 5.0901302337646484e+01 2.1065401077270508e+01 8.6954498291015625e+01 5.1001197814941406e+01 2.1017198562622070e+01 8.5069000244140625e+01 4.7440299987792969e+01 2.1134799957275391e+01 8.4940597534179688e+01 4.7941799163818359e+01 2.1065401077270508e+01 8.4940406799316406e+01 4.8452899932861328e+01 2.1017198562622070e+01 8.8065101623535156e+01 4.5909000396728516e+01 2.1134799957275391e+01 8.7548194885253906e+01 4.5880897521972656e+01 2.1065401077270508e+01 8.7046798706054688e+01 4.5980400085449219e+01 2.1017198562622070e+01 9.0108703613281250e+01 4.8030799865722656e+01 2.1211299896240234e+01 9.0078193664550781e+01 4.8036300659179688e+01 2.1065401077270508e+01 9.0109992980957031e+01 4.8030601501464844e+01 2.1134799957275391e+01 8.7500000000000000e+01 4.8500000000000000e+01 4.1637500762939453e+01 6.2371200561523438e+01 6.5878303527832031e+01 2.2701799392700195e+01 6.2328399658203125e+01 6.6008499145507812e+01 3.8587200164794922e+01 6.2422397613525391e+01 6.5494300842285156e+01 3.8587200164794922e+01 6.2046401977539062e+01 6.6447097778320312e+01 2.2701799392700195e+01 6.2055000305175781e+01 6.6454002380371094e+01 3.8587200164794922e+01 6.2218299865722656e+01 6.6234199523925781e+01 2.2701799392700195e+01 6.2317298889160156e+01 6.6003700256347656e+01 2.2701799392700195e+01 6.1974998474121094e+01 6.6535598754882812e+01 2.2701799392700195e+01 6.1659500122070312e+01 6.6760299682617188e+01 2.2701799392700195e+01 6.1639099121093750e+01 6.6770706176757812e+01 3.8587200164794922e+01 6.1638099670410156e+01 6.6767997741699219e+01 2.2701799392700195e+01 6.1294998168945312e+01 6.6891502380371094e+01 2.2701799392700195e+01 6.1136901855468750e+01 6.6915802001953125e+01 3.8587200164794922e+01 6.0618099212646484e+01 6.6860305786132812e+01 2.2701799392700195e+01 6.0616199493408203e+01 6.6869697570800781e+01 3.8587200164794922e+01 6.0908599853515625e+01 6.6919494628906250e+01 2.2701799392700195e+01 6.1136001586914062e+01 6.6902999877929688e+01 2.2701799392700195e+01 6.0529102325439453e+01 6.6842201232910156e+01 2.2701799392700195e+01 6.0184398651123047e+01 6.6665298461914062e+01 2.2701799392700195e+01 6.0147399902343750e+01 6.6638496398925781e+01 3.8587200164794922e+01 6.0151100158691406e+01 6.6634498596191406e+01 2.2701799392700195e+01 5.9900203704833984e+01 6.6402099609375000e+01 2.2701799392700195e+01 5.9793701171875000e+01 6.6253601074218750e+01 3.8587200164794922e+01 5.9804901123046875e+01 6.6246704101562500e+01 2.2701799392700195e+01 5.9697597503662109e+01 6.6071899414062500e+01 2.2701799392700195e+01 5.9602901458740234e+01 6.5766998291015625e+01 3.8587200164794922e+01 5.9610298156738281e+01 6.5764900207519531e+01 2.2701799392700195e+01 5.9600799560546875e+01 6.5244201660156250e+01 3.8587200164794922e+01 5.9591598510742188e+01 6.5699302673339844e+01 2.2701799392700195e+01 5.9590103149414062e+01 6.5311996459960938e+01 2.2701799392700195e+01 5.9608200073242188e+01 6.5246299743652344e+01 2.2701799392700195e+01 5.9693099975585938e+01 6.4938598632812500e+01 2.2701799392700195e+01 5.9787700653076172e+01 6.4756103515625000e+01 3.8587200164794922e+01 5.9798999786376953e+01 6.4762901306152344e+01 2.2701799392700195e+01 5.9893001556396484e+01 6.4606803894042969e+01 2.2701799392700195e+01 6.0138301849365234e+01 6.4368301391601562e+01 3.8587200164794922e+01 6.0141998291015625e+01 6.4372398376464844e+01 2.2701799392700195e+01 6.0605297088623047e+01 6.4133499145507812e+01 3.8587200164794922e+01 6.0175098419189453e+01 6.4341201782226562e+01 2.2701799392700195e+01 6.0518299102783203e+01 6.4161705017089844e+01 2.2701799392700195e+01 6.0607196807861328e+01 6.4142799377441406e+01 2.2701799392700195e+01 6.0897201538085938e+01 6.4081298828125000e+01 2.2701799392700195e+01 6.1125598907470703e+01 6.4083206176757812e+01 3.8587200164794922e+01 6.1124702453613281e+01 6.4095993041992188e+01 2.2701799392700195e+01 6.1283802032470703e+01 6.4106201171875000e+01 2.2701799392700195e+01 6.1628898620605469e+01 6.4224197387695312e+01 3.8587200164794922e+01 6.1627899169921875e+01 6.4226997375488281e+01 2.2701799392700195e+01 6.2047298431396484e+01 6.4537506103515625e+01 3.8587200164794922e+01 6.1649299621582031e+01 6.4234504699707031e+01 2.2701799392700195e+01 6.1966697692871094e+01 6.4456596374511719e+01 2.2701799392700195e+01 6.2038803100585938e+01 6.4544502258300781e+01 2.2701799392700195e+01 6.2212299346923828e+01 6.4756103515625000e+01 2.2701799392700195e+01 6.2324298858642578e+01 6.4980903625488281e+01 3.8587200164794922e+01 6.2313198089599609e+01 6.4985702514648438e+01 2.2701799392700195e+01 6.2368099212646484e+01 6.5110694885253906e+01 2.2701799392700195e+01 6.2422397613525391e+01 6.5494300842285156e+01 2.2701799392700195e+01 6.3567600250244141e+01 6.6000000000000000e+01 2.1279600143432617e+01 6.3510097503662109e+01 6.6192199707031250e+01 2.1279600143432617e+01 6.3420696258544922e+01 6.6491294860839844e+01 2.1279600143432617e+01 6.3232803344726562e+01 6.6846099853515625e+01 2.1279600143432617e+01 6.3180797576904297e+01 6.6944503784179688e+01 2.1279600143432617e+01 6.2857097625732422e+01 6.7342201232910156e+01 2.1279600143432617e+01 6.2788501739501953e+01 6.7399002075195312e+01 2.1279600143432617e+01 6.2461997985839844e+01 6.7669097900390625e+01 2.1279600143432617e+01 6.2206901550292969e+01 6.7806800842285156e+01 2.1279600143432617e+01 6.2010700225830078e+01 6.7912597656250000e+01 2.1279600143432617e+01 6.1541900634765625e+01 6.8056900024414062e+01 2.1279600143432617e+01 6.1520599365234375e+01 6.8063499450683594e+01 2.1279600143432617e+01 6.1010498046875000e+01 6.8115798950195312e+01 2.1279600143432617e+01 6.0833000183105469e+01 6.8098999023437500e+01 2.1279600143432617e+01 6.0500000000000000e+01 6.8067604064941406e+01 2.1279600143432617e+01 6.0136699676513672e+01 6.7958999633789062e+01 2.1279600143432617e+01 6.0008701324462891e+01 6.7920700073242188e+01 2.1279600143432617e+01 5.9555500030517578e+01 6.7680801391601562e+01 2.1279600143432617e+01 5.9503700256347656e+01 6.7638595581054688e+01 2.1279600143432617e+01 5.9157798767089844e+01 6.7357101440429688e+01 2.1279600143432617e+01 5.8987201690673828e+01 6.7150901794433594e+01 2.1279600143432617e+01 5.8830898284912109e+01 6.6962005615234375e+01 2.1279600143432617e+01 5.8608497619628906e+01 6.6549896240234375e+01 2.1279600143432617e+01 5.8587398529052734e+01 6.6510696411132812e+01 2.1279600143432617e+01 5.8436500549316406e+01 6.6020599365234375e+01 2.1279600143432617e+01 5.8420597076416016e+01 6.5865501403808594e+01 2.1279600143432617e+01 5.8384197235107422e+01 6.5510498046875000e+01 2.1279600143432617e+01 5.8417800903320312e+01 6.5155197143554688e+01 2.1279600143432617e+01 5.8432399749755859e+01 6.5000000000000000e+01 2.1279600143432617e+01 5.8579299926757812e+01 6.4508697509765625e+01 2.1279600143432617e+01 5.8600101470947266e+01 6.4469398498535156e+01 2.1279600143432617e+01 5.8819202423095703e+01 6.4055503845214844e+01 2.1279600143432617e+01 5.8974002838134766e+01 6.3865295410156250e+01 2.1279600143432617e+01 5.9142898559570312e+01 6.3657798767089844e+01 2.1279600143432617e+01 5.9486602783203125e+01 6.3373497009277344e+01 2.1279600143432617e+01 5.9537998199462891e+01 6.3330902099609375e+01 2.1279600143432617e+01 5.9989299774169922e+01 6.3087394714355469e+01 2.1279600143432617e+01 6.0117000579833984e+01 6.3048103332519531e+01 2.1279600143432617e+01 6.0479400634765625e+01 6.2936500549316406e+01 2.1279600143432617e+01 6.0812202453613281e+01 6.2902397155761719e+01 2.1279600143432617e+01 6.0989498138427734e+01 6.2884197235107422e+01 2.1279600143432617e+01 6.1500000000000000e+01 6.2932403564453125e+01 2.1279600143432617e+01 6.1521297454833984e+01 6.2938800811767578e+01 2.1279600143432617e+01 6.1991298675537109e+01 6.3079296112060547e+01 2.1279600143432617e+01 6.2188301086425781e+01 6.3183597564697266e+01 2.1279600143432617e+01 6.2444499969482422e+01 6.3319198608398438e+01 2.1279600143432617e+01 6.2773197174072266e+01 6.3586696624755859e+01 2.1279600143432617e+01 6.2842197418212891e+01 6.3642898559570312e+01 2.1279600143432617e+01 6.3169097900390625e+01 6.4038002014160156e+01 2.1279600143432617e+01 6.3222000122070312e+01 6.4136001586914062e+01 2.1279600143432617e+01 6.3412597656250000e+01 6.4489295959472656e+01 2.1279600143432617e+01 6.3504501342773438e+01 6.4787704467773438e+01 2.1279600143432617e+01 6.3563503265380859e+01 6.4979393005371094e+01 2.1279600143432617e+01 6.3615798950195312e+01 6.5489501953125000e+01 2.1279600143432617e+01 5.9080699920654297e+01 6.5101303100585938e+01 2.1000000000000000e+01 5.9083900451660156e+01 6.5914100646972656e+01 2.1000000000000000e+01 5.9874198913574219e+01 6.5098098754882812e+01 2.2701799392700195e+01 5.9877498626708984e+01 6.5910896301269531e+01 2.2701799392700195e+01 6.1401901245117188e+01 6.4374198913574219e+01 2.2701799392700195e+01 6.0589099884033203e+01 6.4377502441406250e+01 2.2701799392700195e+01 6.1404796600341797e+01 6.5091995239257812e+01 2.2701799392700195e+01 6.0591999053955078e+01 6.5095199584960938e+01 2.2701799392700195e+01 6.0598102569580078e+01 6.6625801086425781e+01 2.2701799392700195e+01 6.1410900115966797e+01 6.6622505187988281e+01 2.2701799392700195e+01 6.0595199584960938e+01 6.5907997131347656e+01 2.2701799392700195e+01 6.1407997131347656e+01 6.5904800415039062e+01 2.2701799392700195e+01 6.2125797271728516e+01 6.5901901245117188e+01 2.2701799392700195e+01 6.2122501373291016e+01 6.5089096069335938e+01 2.2701799392700195e+01 6.1398700714111328e+01 6.3580699920654297e+01 2.1000000000000000e+01 6.0585899353027344e+01 6.3583904266357422e+01 2.1000000000000000e+01 6.2919296264648438e+01 6.5898704528808594e+01 2.1000000000000000e+01 6.2916099548339844e+01 6.5085899353027344e+01 2.1000000000000000e+01 6.0601303100585938e+01 6.7419296264648438e+01 2.1000000000000000e+01 6.1414100646972656e+01 6.7416099548339844e+01 2.1000000000000000e+01 6.1960300445556641e+01 6.7792404174804688e+01 2.1000000000000000e+01 6.2389102935791016e+01 6.7560997009277344e+01 2.1000000000000000e+01 6.1407997131347656e+01 6.5904800415039062e+01 2.1000000000000000e+01 6.1494701385498047e+01 6.7935699462890625e+01 2.1000000000000000e+01 6.1009998321533203e+01 6.7985397338867188e+01 2.1000000000000000e+01 6.1475101470947266e+01 6.3060401916503906e+01 2.1000000000000000e+01 6.0989997863769531e+01 6.3014595031738281e+01 2.1000000000000000e+01 6.0505302429199219e+01 6.3064300537109375e+01 2.1000000000000000e+01 6.2764503479003906e+01 6.7250404357910156e+01 2.1000000000000000e+01 6.3072101593017578e+01 6.6872497558593750e+01 2.1000000000000000e+01 6.3299999237060547e+01 6.6441902160644531e+01 2.1000000000000000e+01 6.3439601898193359e+01 6.5975097656250000e+01 2.1000000000000000e+01 6.3060997009277344e+01 6.4110900878906250e+01 2.1000000000000000e+01 6.1404796600341797e+01 6.5091995239257812e+01 2.1000000000000000e+01 6.3485397338867188e+01 6.5489997863769531e+01 2.1000000000000000e+01 6.3435703277587891e+01 6.5005302429199219e+01 2.1000000000000000e+01 6.3292400360107422e+01 6.4539703369140625e+01 2.1000000000000000e+01 5.8707599639892578e+01 6.6460296630859375e+01 2.1000000000000000e+01 5.8938999176025391e+01 6.6889099121093750e+01 2.1000000000000000e+01 6.0595199584960938e+01 6.5907997131347656e+01 2.1000000000000000e+01 5.8564300537109375e+01 6.5994705200195312e+01 2.1000000000000000e+01 5.8514598846435547e+01 6.5509994506835938e+01 2.1000000000000000e+01 6.2750400543212891e+01 6.3735500335693359e+01 2.1000000000000000e+01 6.2372497558593750e+01 6.3427902221679688e+01 2.1000000000000000e+01 6.1941898345947266e+01 6.3199996948242188e+01 2.1000000000000000e+01 6.0524898529052734e+01 6.7939598083496094e+01 2.1000000000000000e+01 6.0058097839355469e+01 6.7800003051757812e+01 2.1000000000000000e+01 5.9627498626708984e+01 6.7572105407714844e+01 2.1000000000000000e+01 5.9249599456787109e+01 6.7264495849609375e+01 2.1000000000000000e+01 6.0039699554443359e+01 6.3207595825195312e+01 2.1000000000000000e+01 5.9610900878906250e+01 6.3438995361328125e+01 2.1000000000000000e+01 6.0591999053955078e+01 6.5095199584960938e+01 2.1000000000000000e+01 5.8560401916503906e+01 6.5024894714355469e+01 2.1000000000000000e+01 5.8700000762939453e+01 6.4558105468750000e+01 2.1000000000000000e+01 5.8927902221679688e+01 6.4127494812011719e+01 2.1000000000000000e+01 5.9235496520996094e+01 6.3749595642089844e+01 2.1000000000000000e+01 6.2004497528076172e+01 6.3047199249267578e+01 2.1211299896240234e+01 5.8790298461914062e+01 6.4036300659179688e+01 2.1211299896240234e+01 5.9133296966552734e+01 6.7381698608398438e+01 2.1211299896240234e+01 6.2481399536132812e+01 6.7697898864746094e+01 2.1211299896240234e+01 6.2413700103759766e+01 6.3365699768066406e+01 2.1017198562622070e+01 6.2802902221679688e+01 6.3682495117187500e+01 2.1017198562622070e+01 6.2844799041748047e+01 6.3640296936035156e+01 2.1065401077270508e+01 6.3560001373291016e+01 6.5489700317382812e+01 2.1017198562622070e+01 6.3508800506591797e+01 6.4990501403808594e+01 2.1017198562622070e+01 6.3198997497558594e+01 6.4017898559570312e+01 2.1134799957275391e+01 6.3172199249267578e+01 6.4035896301269531e+01 2.1065401077270508e+01 6.3122898101806641e+01 6.4069198608398438e+01 2.1017198562622070e+01 6.3444694519042969e+01 6.4475898742675781e+01 2.1211299896240234e+01 6.3445903778076172e+01 6.4475296020507812e+01 2.1134799957275391e+01 6.3416099548339844e+01 6.4487800598144531e+01 2.1065401077270508e+01 6.3361198425292969e+01 6.4510803222656250e+01 2.1017198562622070e+01 6.3209697723388672e+01 6.6963699340820312e+01 2.1211299896240234e+01 6.3452800750732422e+01 6.6504501342773438e+01 2.1211299896240234e+01 6.3454097747802734e+01 6.6504997253417969e+01 2.1134799957275391e+01 6.2881702423095703e+01 6.7366699218750000e+01 2.1211299896240234e+01 6.3210895538330078e+01 6.6964401245117188e+01 2.1134799957275391e+01 6.3424102783203125e+01 6.6492698669433594e+01 2.1065401077270508e+01 6.3134296417236328e+01 6.6913703918457031e+01 2.1017198562622070e+01 6.2817497253417969e+01 6.7302894592285156e+01 2.1017198562622070e+01 6.2859699249267578e+01 6.7344802856445312e+01 2.1065401077270508e+01 6.2464099884033203e+01 6.7672203063964844e+01 2.1065401077270508e+01 6.2482101440429688e+01 6.7698997497558594e+01 2.1134799957275391e+01 6.2024700164794922e+01 6.7945899963378906e+01 2.1134799957275391e+01 6.2024101257324219e+01 6.7944694519042969e+01 2.1211299896240234e+01 6.1527500152587891e+01 6.8097503662109375e+01 2.1211299896240234e+01 6.2430797576904297e+01 6.7622901916503906e+01 2.1017198562622070e+01 6.2012199401855469e+01 6.7916099548339844e+01 2.1065401077270508e+01 6.1527801513671875e+01 6.8098800659179688e+01 2.1134799957275391e+01 6.1010597229003906e+01 6.8150497436523438e+01 2.1211299896240234e+01 6.1989200592041016e+01 6.7861198425292969e+01 2.1017198562622070e+01 6.1509502410888672e+01 6.8008804321289062e+01 2.1017198562622070e+01 6.1521400451660156e+01 6.8067100524902344e+01 2.1065401077270508e+01 6.1010498046875000e+01 6.8119506835937500e+01 2.1065401077270508e+01 6.1010597229003906e+01 6.8151901245117188e+01 2.1134799957275391e+01 6.0493099212646484e+01 6.8102996826171875e+01 2.1134799957275391e+01 6.0493301391601562e+01 6.8101699829101562e+01 2.1211299896240234e+01 5.9995498657226562e+01 6.7952796936035156e+01 2.1211299896240234e+01 6.1010299682617188e+01 6.8060005187988281e+01 2.1017198562622070e+01 6.0499298095703125e+01 6.8071205139160156e+01 2.1065401077270508e+01 5.9994998931884766e+01 6.7954101562500000e+01 2.1134799957275391e+01 5.9536300659179688e+01 6.7709701538085938e+01 2.1211299896240234e+01 6.0029800415039062e+01 6.7869094848632812e+01 2.1017198562622070e+01 5.9586299896240234e+01 6.7634300231933594e+01 2.1017198562622070e+01 5.9553398132324219e+01 6.7683898925781250e+01 2.1065401077270508e+01 5.9155200958251953e+01 6.7359703063964844e+01 2.1065401077270508e+01 5.9132400512695312e+01 6.7382698059082031e+01 2.1134799957275391e+01 5.8800998687744141e+01 6.6982101440429688e+01 2.1134799957275391e+01 5.8802101135253906e+01 6.6981399536132812e+01 2.1211299896240234e+01 5.8555301666259766e+01 6.6524101257324219e+01 2.1211299896240234e+01 5.9197101593017578e+01 6.7317497253417969e+01 2.1017198562622070e+01 5.8827796936035156e+01 6.6964096069335938e+01 2.1065401077270508e+01 5.8554100036621094e+01 6.6524696350097656e+01 2.1134799957275391e+01 5.8402500152587891e+01 6.6027496337890625e+01 2.1211299896240234e+01 5.8877098083496094e+01 6.6930801391601562e+01 2.1017198562622070e+01 5.8638801574707031e+01 6.6489196777343750e+01 2.1017198562622070e+01 5.8583900451660156e+01 6.6512199401855469e+01 2.1065401077270508e+01 5.8432899475097656e+01 6.6021400451660156e+01 2.1065401077270508e+01 5.8401199340820312e+01 6.6027801513671875e+01 2.1134799957275391e+01 5.8348098754882812e+01 6.5510597229003906e+01 2.1134799957275391e+01 5.8349502563476562e+01 6.5510597229003906e+01 2.1211299896240234e+01 5.8398300170898438e+01 6.4993301391601562e+01 2.1211299896240234e+01 5.8491199493408203e+01 6.6009498596191406e+01 2.1017198562622070e+01 5.8380500793457031e+01 6.5510498046875000e+01 2.1065401077270508e+01 5.8396999359130859e+01 6.4993095397949219e+01 2.1134799957275391e+01 5.8547199249267578e+01 6.4495498657226562e+01 2.1211299896240234e+01 5.8487197875976562e+01 6.5010597229003906e+01 2.1017198562622070e+01 5.8630897521972656e+01 6.4529800415039062e+01 2.1017198562622070e+01 5.8575897216796875e+01 6.4507301330566406e+01 2.1065401077270508e+01 5.8816101074218750e+01 6.4053398132324219e+01 2.1065401077270508e+01 5.8789100646972656e+01 6.4035598754882812e+01 2.1134799957275391e+01 5.9117298126220703e+01 6.3632400512695312e+01 2.1134799957275391e+01 5.9118301391601562e+01 6.3633300781250000e+01 2.1211299896240234e+01 5.9518600463867188e+01 6.3302101135253906e+01 2.1211299896240234e+01 5.8865699768066406e+01 6.4086303710937500e+01 2.1017198562622070e+01 5.9140296936035156e+01 6.3655197143554688e+01 2.1065401077270508e+01 5.9517902374267578e+01 6.3300998687744141e+01 2.1134799957275391e+01 5.9975898742675781e+01 6.3055297851562500e+01 2.1211299896240234e+01 5.9182498931884766e+01 6.3697097778320312e+01 2.1017198562622070e+01 5.9569198608398438e+01 6.3377098083496094e+01 2.1017198562622070e+01 5.9535900115966797e+01 6.3327796936035156e+01 2.1065401077270508e+01 5.9987796783447266e+01 6.3083900451660156e+01 2.1065401077270508e+01 5.9975299835205078e+01 6.3054100036621094e+01 2.1134799957275391e+01 6.0472202301025391e+01 6.2901199340820312e+01 2.1134799957275391e+01 6.0472499847412109e+01 6.2902503967285156e+01 2.1211299896240234e+01 6.0989398956298828e+01 6.2849498748779297e+01 2.1211299896240234e+01 6.0010799407958984e+01 6.3138797760009766e+01 2.1017198562622070e+01 6.0478603363037109e+01 6.2932899475097656e+01 2.1065401077270508e+01 6.0989398956298828e+01 6.2848098754882812e+01 2.1134799957275391e+01 6.1506698608398438e+01 6.2898300170898438e+01 2.1211299896240234e+01 6.0989700317382812e+01 6.2940002441406250e+01 2.1017198562622070e+01 6.1489398956298828e+01 6.2987201690673828e+01 2.1017198562622070e+01 6.1500698089599609e+01 6.2928802490234375e+01 2.1065401077270508e+01 6.1992702484130859e+01 6.3075901031494141e+01 2.1065401077270508e+01 6.2004997253417969e+01 6.3045898437500000e+01 2.1134799957275391e+01 6.2464401245117188e+01 6.3289096832275391e+01 2.1134799957275391e+01 6.2463699340820312e+01 6.3290298461914062e+01 2.1211299896240234e+01 6.2866703033447266e+01 6.3618301391601562e+01 2.1211299896240234e+01 6.1970199584960938e+01 6.3130901336669922e+01 2.1017198562622070e+01 6.2446601867675781e+01 6.3316101074218750e+01 2.1065401077270508e+01 6.2867595672607422e+01 6.3617298126220703e+01 2.1134799957275391e+01 6.3197902679443359e+01 6.4018600463867188e+01 2.1211299896240234e+01 6.3512802124023438e+01 6.5989395141601562e+01 2.1017198562622070e+01 6.3571201324462891e+01 6.6000701904296875e+01 2.1065401077270508e+01 6.3619503021240234e+01 6.5489501953125000e+01 2.1065401077270508e+01 6.3603000640869141e+01 6.6006896972656250e+01 2.1134799957275391e+01 6.3651897430419922e+01 6.5489395141601562e+01 2.1134799957275391e+01 6.3601703643798828e+01 6.6006698608398438e+01 2.1211299896240234e+01 6.3650497436523438e+01 6.5489395141601562e+01 2.1211299896240234e+01 6.2882698059082031e+01 6.7367599487304688e+01 2.1134799957275391e+01 6.3183902740478516e+01 6.6946601867675781e+01 2.1065401077270508e+01 6.3369102478027344e+01 6.6470199584960938e+01 2.1017198562622070e+01 5.9535598754882812e+01 6.7710899353027344e+01 2.1134799957275391e+01 6.0007301330566406e+01 6.7924095153808594e+01 2.1065401077270508e+01 6.0510601043701172e+01 6.8012794494628906e+01 2.1017198562622070e+01 5.8545898437500000e+01 6.4494995117187500e+01 2.1134799957275391e+01 5.8428802490234375e+01 6.4999298095703125e+01 2.1065401077270508e+01 5.8439998626708984e+01 6.5510299682617188e+01 2.1017198562622070e+01 6.1506900787353516e+01 6.2896995544433594e+01 2.1134799957275391e+01 6.0989498138427734e+01 6.2880500793457031e+01 2.1065401077270508e+01 6.0490501403808594e+01 6.2991203308105469e+01 2.1017198562622070e+01 6.3597499847412109e+01 6.4972496032714844e+01 2.1211299896240234e+01 6.3567100524902344e+01 6.4978599548339844e+01 2.1065401077270508e+01 6.3598796844482422e+01 6.4972198486328125e+01 2.1134799957275391e+01 6.1000000000000000e+01 6.5500000000000000e+01 4.1637500762939453e+01 8.8871902465820312e+01 9.8375793457031250e+01 2.2701799392700195e+01 8.8829299926757812e+01 9.8506103515625000e+01 3.8587200164794922e+01 8.8922393798828125e+01 9.7991798400878906e+01 3.8587200164794922e+01 8.8548103332519531e+01 9.8945297241210938e+01 2.2701799392700195e+01 8.8556701660156250e+01 9.8952194213867188e+01 3.8587200164794922e+01 8.8719596862792969e+01 9.8732002258300781e+01 2.2701799392700195e+01 8.8818199157714844e+01 9.8501396179199219e+01 2.2701799392700195e+01 8.8476898193359375e+01 9.9033897399902344e+01 2.2701799392700195e+01 8.8161697387695312e+01 9.9259101867675781e+01 2.2701799392700195e+01 8.8141395568847656e+01 9.9269599914550781e+01 3.8587200164794922e+01 8.8140396118164062e+01 9.9266799926757812e+01 2.2701799392700195e+01 8.7797500610351562e+01 9.9390998840332031e+01 2.2701799392700195e+01 8.7639396667480469e+01 9.9415603637695312e+01 3.8587200164794922e+01 8.7120506286621094e+01 9.9361000061035156e+01 2.2701799392700195e+01 8.7118698120117188e+01 9.9370300292968750e+01 3.8587200164794922e+01 8.7411094665527344e+01 9.9419601440429688e+01 2.2701799392700195e+01 8.7638496398925781e+01 9.9402702331542969e+01 2.2701799392700195e+01 8.7031402587890625e+01 9.9343002319335938e+01 2.2701799392700195e+01 8.6686500549316406e+01 9.9166801452636719e+01 2.2701799392700195e+01 8.6649406433105469e+01 9.9140007019042969e+01 3.8587200164794922e+01 8.6653099060058594e+01 9.9136001586914062e+01 2.2701799392700195e+01 8.6401794433593750e+01 9.8903999328613281e+01 2.2701799392700195e+01 8.6294998168945312e+01 9.8755798339843750e+01 3.8587200164794922e+01 8.6306198120117188e+01 9.8748901367187500e+01 2.2701799392700195e+01 8.6198699951171875e+01 9.8574195861816406e+01 2.2701799392700195e+01 8.6103401184082031e+01 9.8269500732421875e+01 3.8587200164794922e+01 8.6110801696777344e+01 9.8267303466796875e+01 2.2701799392700195e+01 8.6100303649902344e+01 9.7746696472167969e+01 3.8587200164794922e+01 8.6092002868652344e+01 9.8201797485351562e+01 2.2701799392700195e+01 8.6089797973632812e+01 9.7814498901367188e+01 2.2701799392700195e+01 8.6107795715332031e+01 9.7748802185058594e+01 2.2701799392700195e+01 8.6192100524902344e+01 9.7440895080566406e+01 2.2701799392700195e+01 8.6286300659179688e+01 9.7258201599121094e+01 3.8587200164794922e+01 8.6297698974609375e+01 9.7264999389648438e+01 2.2701799392700195e+01 8.6391502380371094e+01 9.7108695983886719e+01 2.2701799392700195e+01 8.6636299133300781e+01 9.6869903564453125e+01 3.8587200164794922e+01 8.6639999389648438e+01 9.6873901367187500e+01 2.2701799392700195e+01 8.7102798461914062e+01 9.6634201049804688e+01 3.8587200164794922e+01 8.6672996520996094e+01 9.6842697143554688e+01 2.2701799392700195e+01 8.7015899658203125e+01 9.6662498474121094e+01 2.2701799392700195e+01 8.7104797363281250e+01 9.6643501281738281e+01 2.2701799392700195e+01 8.7394699096679688e+01 9.6581497192382812e+01 2.2701799392700195e+01 8.7623001098632812e+01 9.6582893371582031e+01 3.8587200164794922e+01 8.7622200012207031e+01 9.6595695495605469e+01 2.2701799392700195e+01 8.7781303405761719e+01 9.6605705261230469e+01 2.2701799392700195e+01 8.8126602172851562e+01 9.6723098754882812e+01 3.8587200164794922e+01 8.8125701904296875e+01 9.6725799560546875e+01 2.2701799392700195e+01 8.8545600891113281e+01 9.7035697937011719e+01 3.8587200164794922e+01 8.8147094726562500e+01 9.6733299255371094e+01 2.2701799392700195e+01 8.8464797973632812e+01 9.6954895019531250e+01 2.2701799392700195e+01 8.8537094116210938e+01 9.7042701721191406e+01 2.2701799392700195e+01 8.8710998535156250e+01 9.7253898620605469e+01 2.2701799392700195e+01 8.8823402404785156e+01 9.7478500366210938e+01 3.8587200164794922e+01 8.8812301635742188e+01 9.7483398437500000e+01 2.2701799392700195e+01 8.8867401123046875e+01 9.7608299255371094e+01 2.2701799392700195e+01 8.8922393798828125e+01 9.7991798400878906e+01 2.2701799392700195e+01 9.0068397521972656e+01 9.8495498657226562e+01 2.1279600143432617e+01 9.0011299133300781e+01 9.8687698364257812e+01 2.1279600143432617e+01 8.9922401428222656e+01 9.8986999511718750e+01 2.1279600143432617e+01 8.9735198974609375e+01 9.9342193603515625e+01 2.1279600143432617e+01 8.9683303833007812e+01 9.9440597534179688e+01 2.1279600143432617e+01 8.9360298156738281e+01 9.9838897705078125e+01 2.1279600143432617e+01 8.9291801452636719e+01 9.9895797729492188e+01 2.1279600143432617e+01 8.8965805053710938e+01 1.0016699981689453e+02 2.1279600143432617e+01 8.8710998535156250e+01 1.0030500030517578e+02 2.1279600143432617e+01 8.8514999389648438e+01 1.0041099548339844e+02 2.1279600143432617e+01 8.8046401977539062e+01 1.0055599975585938e+02 2.1279600143432617e+01 8.8025199890136719e+01 1.0056299591064453e+02 2.1279600143432617e+01 8.7515098571777344e+01 1.0061599731445312e+02 2.1279600143432617e+01 8.7337699890136719e+01 1.0059899902343750e+02 2.1279600143432617e+01 8.7004501342773438e+01 1.0056799316406250e+02 2.1279600143432617e+01 8.6641105651855469e+01 1.0045999908447266e+02 2.1279600143432617e+01 8.6513000488281250e+01 1.0042200469970703e+02 2.1279600143432617e+01 8.6059402465820312e+01 1.0018300628662109e+02 2.1279600143432617e+01 8.6007499694824219e+01 1.0014099884033203e+02 2.1279600143432617e+01 8.5661094665527344e+01 9.9860305786132812e+01 2.1279600143432617e+01 8.5490196228027344e+01 9.9654502868652344e+01 2.1279600143432617e+01 8.5333496093750000e+01 9.9465805053710938e+01 2.1279600143432617e+01 8.5110404968261719e+01 9.9054100036621094e+01 2.1279600143432617e+01 8.5089202880859375e+01 9.9014999389648438e+01 2.1279600143432617e+01 8.4937500000000000e+01 9.8525199890136719e+01 2.1279600143432617e+01 8.4921302795410156e+01 9.8370094299316406e+01 2.1279600143432617e+01 8.4884300231933594e+01 9.8015098571777344e+01 2.1279600143432617e+01 8.4917205810546875e+01 9.7659797668457031e+01 2.1279600143432617e+01 8.4931594848632812e+01 9.7504493713378906e+01 2.1279600143432617e+01 8.5077598571777344e+01 9.7013000488281250e+01 2.1279600143432617e+01 8.5098297119140625e+01 9.6973594665527344e+01 2.1279600143432617e+01 8.5316703796386719e+01 9.6559394836425781e+01 2.1279600143432617e+01 8.5471099853515625e+01 9.6368904113769531e+01 2.1279600143432617e+01 8.5639701843261719e+01 9.6161094665527344e+01 2.1279600143432617e+01 8.5982803344726562e+01 9.5876098632812500e+01 2.1279600143432617e+01 8.6034202575683594e+01 9.5833503723144531e+01 2.1279600143432617e+01 8.6485000610351562e+01 9.5589195251464844e+01 2.1279600143432617e+01 8.6612594604492188e+01 9.5549598693847656e+01 2.1279600143432617e+01 8.6974800109863281e+01 9.5437500000000000e+01 2.1279600143432617e+01 8.7307601928710938e+01 9.5402702331542969e+01 2.1279600143432617e+01 8.7484901428222656e+01 9.5384300231933594e+01 2.1279600143432617e+01 8.7995498657226562e+01 9.5431602478027344e+01 2.1279600143432617e+01 8.8016799926757812e+01 9.5437896728515625e+01 2.1279600143432617e+01 8.8486999511718750e+01 9.5577598571777344e+01 2.1279600143432617e+01 8.8684204101562500e+01 9.5681503295898438e+01 2.1279600143432617e+01 8.8940597534179688e+01 9.5816703796386719e+01 2.1279600143432617e+01 8.9269798278808594e+01 9.6083595275878906e+01 2.1279600143432617e+01 8.9338897705078125e+01 9.6139701843261719e+01 2.1279600143432617e+01 8.9666503906250000e+01 9.6534202575683594e+01 2.1279600143432617e+01 8.9719497680664062e+01 9.6631996154785156e+01 2.1279600143432617e+01 8.9910797119140625e+01 9.6985000610351562e+01 2.1279600143432617e+01 9.0003196716308594e+01 9.7283294677734375e+01 2.1279600143432617e+01 9.0062500000000000e+01 9.7474800109863281e+01 2.1279600143432617e+01 9.0115707397460938e+01 9.7984901428222656e+01 2.1279600143432617e+01 8.5580001831054688e+01 9.7604698181152344e+01 2.1000000000000000e+01 8.5584701538085938e+01 9.8417495727539062e+01 2.1000000000000000e+01 8.6373497009277344e+01 9.7600105285644531e+01 2.2701799392700195e+01 8.6378204345703125e+01 9.8412902832031250e+01 2.2701799392700195e+01 8.7899902343750000e+01 9.6873497009277344e+01 2.2701799392700195e+01 8.7087104797363281e+01 9.6878204345703125e+01 2.2701799392700195e+01 8.7903999328613281e+01 9.7591300964355469e+01 2.2701799392700195e+01 8.7091293334960938e+01 9.7596000671386719e+01 2.2701799392700195e+01 8.7100105285644531e+01 9.9126502990722656e+01 2.2701799392700195e+01 8.7912902832031250e+01 9.9121803283691406e+01 2.2701799392700195e+01 8.7096000671386719e+01 9.8408699035644531e+01 2.2701799392700195e+01 8.7908699035644531e+01 9.8403999328613281e+01 2.2701799392700195e+01 8.8626495361328125e+01 9.8399902343750000e+01 2.2701799392700195e+01 8.8621803283691406e+01 9.7587104797363281e+01 2.2701799392700195e+01 8.7895294189453125e+01 9.6079994201660156e+01 2.1000000000000000e+01 8.7082496643066406e+01 9.6084701538085938e+01 2.1000000000000000e+01 8.9419998168945312e+01 9.8395301818847656e+01 2.1000000000000000e+01 8.9415298461914062e+01 9.7582496643066406e+01 2.1000000000000000e+01 8.7104698181152344e+01 9.9919998168945312e+01 2.1000000000000000e+01 8.7917495727539062e+01 9.9915306091308594e+01 2.1000000000000000e+01 8.8464401245117188e+01 1.0029100036621094e+02 2.1000000000000000e+01 8.8892799377441406e+01 1.0005900573730469e+02 2.1000000000000000e+01 8.7908699035644531e+01 9.8403999328613281e+01 2.1000000000000000e+01 8.7999000549316406e+01 1.0043500518798828e+02 2.1000000000000000e+01 8.7514404296875000e+01 1.0048500061035156e+02 2.1000000000000000e+01 8.7970802307128906e+01 9.5559600830078125e+01 2.1000000000000000e+01 8.7485595703125000e+01 9.5514602661132812e+01 2.1000000000000000e+01 8.7001007080078125e+01 9.5565200805664062e+01 2.1000000000000000e+01 8.9267593383789062e+01 9.9747299194335938e+01 2.1000000000000000e+01 8.9574501037597656e+01 9.9368896484375000e+01 2.1000000000000000e+01 8.9801696777343750e+01 9.8937805175781250e+01 2.1000000000000000e+01 8.9940399169921875e+01 9.8470802307128906e+01 2.1000000000000000e+01 8.9558494567871094e+01 9.6607200622558594e+01 2.1000000000000000e+01 8.7903999328613281e+01 9.7591300964355469e+01 2.1000000000000000e+01 8.9985397338867188e+01 9.7985603332519531e+01 2.1000000000000000e+01 8.9934806823730469e+01 9.7500999450683594e+01 2.1000000000000000e+01 8.9790702819824219e+01 9.7035598754882812e+01 2.1000000000000000e+01 8.5209304809570312e+01 9.8964401245117188e+01 2.1000000000000000e+01 8.5441497802734375e+01 9.9392799377441406e+01 2.1000000000000000e+01 8.7096000671386719e+01 9.8408699035644531e+01 2.1000000000000000e+01 8.5065200805664062e+01 9.8499000549316406e+01 2.1000000000000000e+01 8.5014595031738281e+01 9.8014396667480469e+01 2.1000000000000000e+01 8.9247299194335938e+01 9.6232398986816406e+01 2.1000000000000000e+01 8.8868797302246094e+01 9.5925498962402344e+01 2.1000000000000000e+01 8.8437805175781250e+01 9.5698295593261719e+01 2.1000000000000000e+01 8.7029197692871094e+01 1.0044000244140625e+02 2.1000000000000000e+01 8.6562202453613281e+01 1.0030200195312500e+02 2.1000000000000000e+01 8.6131202697753906e+01 1.0007499694824219e+02 2.1000000000000000e+01 8.5752700805664062e+01 9.9767601013183594e+01 2.1000000000000000e+01 8.6535606384277344e+01 9.5709304809570312e+01 2.1000000000000000e+01 8.6107200622558594e+01 9.5941497802734375e+01 2.1000000000000000e+01 8.7091293334960938e+01 9.7596000671386719e+01 2.1000000000000000e+01 8.5059600830078125e+01 9.7529205322265625e+01 2.1000000000000000e+01 8.5198295593261719e+01 9.7062202453613281e+01 2.1000000000000000e+01 8.5425506591796875e+01 9.6631103515625000e+01 2.1000000000000000e+01 8.5732398986816406e+01 9.6252700805664062e+01 2.1000000000000000e+01 8.8500099182128906e+01 9.5545402526855469e+01 2.1211299896240234e+01 8.5287696838378906e+01 9.6540199279785156e+01 2.1211299896240234e+01 8.5636695861816406e+01 9.9885002136230469e+01 2.1211299896240234e+01 8.8985298156738281e+01 1.0019499969482422e+02 2.1211299896240234e+01 8.8909904479980469e+01 9.5863197326660156e+01 2.1017198562622070e+01 8.9299697875976562e+01 9.6179298400878906e+01 2.1017198562622070e+01 8.9341499328613281e+01 9.6137001037597656e+01 2.1065401077270508e+01 9.0060005187988281e+01 9.7985198974609375e+01 2.1017198562622070e+01 9.0007904052734375e+01 9.7486000061035156e+01 2.1017198562622070e+01 8.9696403503417969e+01 9.6513999938964844e+01 2.1134799957275391e+01 8.9669601440429688e+01 9.6532096862792969e+01 2.1065401077270508e+01 8.9620300292968750e+01 9.6565406799316406e+01 2.1017198562622070e+01 8.9942901611328125e+01 9.6971496582031250e+01 2.1211299896240234e+01 8.9944099426269531e+01 9.6971000671386719e+01 2.1134799957275391e+01 8.9914299011230469e+01 9.6983596801757812e+01 2.1065401077270508e+01 8.9859497070312500e+01 9.7006698608398438e+01 2.1017198562622070e+01 8.9712303161621094e+01 9.9459800720214844e+01 2.1211299896240234e+01 8.9954597473144531e+01 9.9000099182128906e+01 2.1211299896240234e+01 8.9955902099609375e+01 9.9000602722167969e+01 2.1134799957275391e+01 8.9385002136230469e+01 9.9863296508789062e+01 2.1211299896240234e+01 8.9713500976562500e+01 9.9460494995117188e+01 2.1134799957275391e+01 8.9925903320312500e+01 9.8988395690917969e+01 2.1065401077270508e+01 8.9636802673339844e+01 9.9409896850585938e+01 2.1017198562622070e+01 8.9320693969726562e+01 9.9799697875976562e+01 2.1017198562622070e+01 8.9362998962402344e+01 9.9841499328613281e+01 2.1065401077270508e+01 8.8967895507812500e+01 1.0016999816894531e+02 2.1065401077270508e+01 8.8986000061035156e+01 1.0019599914550781e+02 2.1134799957275391e+01 8.8528999328613281e+01 1.0044400024414062e+02 2.1134799957275391e+01 8.8528495788574219e+01 1.0044300079345703e+02 2.1211299896240234e+01 8.8032096862792969e+01 1.0059700012207031e+02 2.1211299896240234e+01 8.8934600830078125e+01 1.0012000274658203e+02 2.1017198562622070e+01 8.8516395568847656e+01 1.0041400146484375e+02 2.1065401077270508e+01 8.8032402038574219e+01 1.0059799957275391e+02 2.1134799957275391e+01 8.7515304565429688e+01 1.0065100097656250e+02 2.1211299896240234e+01 8.8493400573730469e+01 1.0035900115966797e+02 2.1017198562622070e+01 8.8013999938964844e+01 1.0050799560546875e+02 2.1017198562622070e+01 8.8025894165039062e+01 1.0056600189208984e+02 2.1065401077270508e+01 8.7515197753906250e+01 1.0061900329589844e+02 2.1065401077270508e+01 8.7515304565429688e+01 1.0065200042724609e+02 2.1134799957275391e+01 8.6997703552246094e+01 1.0060399627685547e+02 2.1134799957275391e+01 8.6998001098632812e+01 1.0060299682617188e+02 2.1211299896240234e+01 8.6499900817871094e+01 1.0045500183105469e+02 2.1211299896240234e+01 8.7514801025390625e+01 1.0056000518798828e+02 2.1017198562622070e+01 8.7003799438476562e+01 1.0057199859619141e+02 2.1065401077270508e+01 8.6499397277832031e+01 1.0045600128173828e+02 2.1134799957275391e+01 8.6040199279785156e+01 1.0021199798583984e+02 2.1211299896240234e+01 8.6534004211425781e+01 1.0037100219726562e+02 2.1017198562622070e+01 8.6090103149414062e+01 1.0013700103759766e+02 2.1017198562622070e+01 8.6057296752929688e+01 1.0018599700927734e+02 2.1065401077270508e+01 8.5658500671386719e+01 9.9862998962402344e+01 2.1065401077270508e+01 8.5635696411132812e+01 9.9886001586914062e+01 2.1134799957275391e+01 8.5303596496582031e+01 9.9486000061035156e+01 2.1134799957275391e+01 8.5304702758789062e+01 9.9485298156738281e+01 2.1211299896240234e+01 8.5057098388671875e+01 9.9028495788574219e+01 2.1211299896240234e+01 8.5700302124023438e+01 9.9820701599121094e+01 2.1017198562622070e+01 8.5330398559570312e+01 9.9467903137207031e+01 2.1065401077270508e+01 8.5055900573730469e+01 9.9028999328613281e+01 2.1134799957275391e+01 8.4903396606445312e+01 9.8532104492187500e+01 2.1211299896240234e+01 8.5379699707031250e+01 9.9434600830078125e+01 2.1017198562622070e+01 8.5140495300292969e+01 9.8993301391601562e+01 2.1017198562622070e+01 8.5085700988769531e+01 9.9016395568847656e+01 2.1065401077270508e+01 8.4933799743652344e+01 9.8525894165039062e+01 2.1065401077270508e+01 8.4902099609375000e+01 9.8532402038574219e+01 2.1134799957275391e+01 8.4848205566406250e+01 9.8015304565429688e+01 2.1134799957275391e+01 8.4849502563476562e+01 9.8015304565429688e+01 2.1211299896240234e+01 8.4897399902343750e+01 9.7498001098632812e+01 2.1211299896240234e+01 8.4992103576660156e+01 9.8513999938964844e+01 2.1017198562622070e+01 8.4880500793457031e+01 9.8015197753906250e+01 2.1065401077270508e+01 8.4896102905273438e+01 9.7497703552246094e+01 2.1134799957275391e+01 8.5045394897460938e+01 9.6999900817871094e+01 2.1211299896240234e+01 8.4986297607421875e+01 9.7515098571777344e+01 2.1017198562622070e+01 8.5129203796386719e+01 9.7033996582031250e+01 2.1017198562622070e+01 8.5074096679687500e+01 9.7011604309082031e+01 2.1065401077270508e+01 8.5313606262207031e+01 9.6557296752929688e+01 2.1065401077270508e+01 8.5286499023437500e+01 9.6539497375488281e+01 2.1134799957275391e+01 8.5614006042480469e+01 9.6135696411132812e+01 2.1134799957275391e+01 8.5614997863769531e+01 9.6136695861816406e+01 2.1211299896240234e+01 8.6014701843261719e+01 9.5804695129394531e+01 2.1211299896240234e+01 8.5363204956054688e+01 9.6590103149414062e+01 2.1017198562622070e+01 8.5637001037597656e+01 9.6158500671386719e+01 2.1065401077270508e+01 8.6013999938964844e+01 9.5803604125976562e+01 2.1134799957275391e+01 8.6471496582031250e+01 9.5557098388671875e+01 2.1211299896240234e+01 8.5679298400878906e+01 9.6200302124023438e+01 2.1017198562622070e+01 8.6065399169921875e+01 9.5879699707031250e+01 2.1017198562622070e+01 8.6032096862792969e+01 9.5830406188964844e+01 2.1065401077270508e+01 8.6483596801757812e+01 9.5585693359375000e+01 2.1065401077270508e+01 8.6471000671386719e+01 9.5555900573730469e+01 2.1134799957275391e+01 8.6967605590820312e+01 9.5402099609375000e+01 2.1134799957275391e+01 8.6967903137207031e+01 9.5403404235839844e+01 2.1211299896240234e+01 8.7484703063964844e+01 9.5349494934082031e+01 2.1211299896240234e+01 8.6506599426269531e+01 9.5640502929687500e+01 2.1017198562622070e+01 8.6974098205566406e+01 9.5433799743652344e+01 2.1065401077270508e+01 8.7484703063964844e+01 9.5348197937011719e+01 2.1134799957275391e+01 8.8001998901367188e+01 9.5397399902343750e+01 2.1211299896240234e+01 8.7485198974609375e+01 9.5440002441406250e+01 2.1017198562622070e+01 8.7984893798828125e+01 9.5486297607421875e+01 2.1017198562622070e+01 8.7996200561523438e+01 9.5427902221679688e+01 2.1065401077270508e+01 8.8488403320312500e+01 9.5574104309082031e+01 2.1065401077270508e+01 8.8500595092773438e+01 9.5544097900390625e+01 2.1134799957275391e+01 8.8960494995117188e+01 9.5786499023437500e+01 2.1134799957275391e+01 8.8959800720214844e+01 9.5787696838378906e+01 2.1211299896240234e+01 8.9363296508789062e+01 9.6114997863769531e+01 2.1211299896240234e+01 8.8466003417968750e+01 9.5629203796386719e+01 2.1017198562622070e+01 8.8942695617675781e+01 9.5813598632812500e+01 2.1065401077270508e+01 8.9364295959472656e+01 9.6113998413085938e+01 2.1134799957275391e+01 8.9695297241210938e+01 9.6514701843261719e+01 2.1211299896240234e+01 9.0013694763183594e+01 9.8484901428222656e+01 2.1017198562622070e+01 9.0072105407714844e+01 9.8496200561523438e+01 2.1065401077270508e+01 9.0119506835937500e+01 9.7984794616699219e+01 2.1065401077270508e+01 9.0103904724121094e+01 9.8502304077148438e+01 2.1134799957275391e+01 9.0151802062988281e+01 9.7984703063964844e+01 2.1134799957275391e+01 9.0102600097656250e+01 9.8501998901367188e+01 2.1211299896240234e+01 9.0150497436523438e+01 9.7984703063964844e+01 2.1211299896240234e+01 8.9386001586914062e+01 9.9864295959472656e+01 2.1134799957275391e+01 8.9686401367187500e+01 9.9442695617675781e+01 2.1065401077270508e+01 8.9870803833007812e+01 9.8966003417968750e+01 2.1017198562622070e+01 8.6039497375488281e+01 1.0021299743652344e+02 2.1134799957275391e+01 8.6511596679687500e+01 1.0042600250244141e+02 2.1065401077270508e+01 8.7015098571777344e+01 1.0051399993896484e+02 2.1017198562622070e+01 8.5044097900390625e+01 9.6999397277832031e+01 2.1134799957275391e+01 8.4927902221679688e+01 9.7503807067871094e+01 2.1065401077270508e+01 8.4940002441406250e+01 9.8014801025390625e+01 2.1017198562622070e+01 8.8002304077148438e+01 9.5396102905273438e+01 2.1134799957275391e+01 8.7484802246093750e+01 9.5380500793457031e+01 2.1065401077270508e+01 8.6986000061035156e+01 9.5492103576660156e+01 2.1017198562622070e+01 9.0096603393554688e+01 9.7467895507812500e+01 2.1211299896240234e+01 9.0066200256347656e+01 9.7474098205566406e+01 2.1065401077270508e+01 9.0097900390625000e+01 9.7467597961425781e+01 2.1134799957275391e+01 8.7500000000000000e+01 9.8000000000000000e+01 4.1637500762939453e+01 9.8500000000000000e+01 -7.3000001907348633e+00 9.1143608093261719e+00 9.8500000000000000e+01 -6.5000000000000000e+00 8.8999996185302734e+00 9.8500000000000000e+01 -4.0000000000000000e+00 -2.5000000000000000e+00 9.8500000000000000e+01 -2.0000000000000000e+01 1.5000000000000000e+01 9.8500000000000000e+01 -6.5000000000000000e+00 1.2100000381469727e+01 9.8500000000000000e+01 -7.3000001907348633e+00 1.1885600090026855e+01 9.8500000000000000e+01 -7.8856396675109863e+00 9.7000007629394531e+00 9.8500000000000000e+01 -2.0000000000000000e+01 -2.5000000000000000e+00 9.8500000000000000e+01 -8.1000003814697266e+00 1.0500000000000000e+01 9.8500000000000000e+01 -7.8856396675109863e+00 1.1300000190734863e+01 9.8500000000000000e+01 -5.7000002861022949e+00 1.1885600090026855e+01 9.8500000000000000e+01 9.6347999572753906e+00 1.3749300003051758e+01 9.8500000000000000e+01 -5.1143598556518555e+00 1.1300000190734863e+01 9.8500000000000000e+01 5.9646801948547363e+00 1.2650599479675293e+01 9.8500000000000000e+01 -4.9000000953674316e+00 1.0500000000000000e+01 9.8500000000000000e+01 2.6468799114227295e+00 1.0734999656677246e+01 9.8500000000000000e+01 -5.1143598556518555e+00 9.7000007629394531e+00 9.8500000000000000e+01 -1.3973300158977509e-01 8.1059999465942383e+00 9.8500000000000000e+01 -5.7000002861022949e+00 9.1143608093261719e+00 9.8500000000000000e+01 -2.2449400424957275e+00 4.9051899909973145e+00 9.8500000000000000e+01 -3.5552401542663574e+00 1.3051600456237793e+00 9.8500000000000000e+01 2.6285499572753906e+01 6.5668902397155762e+00 9.8500000000000000e+01 2.3822999954223633e+01 9.5016603469848633e+00 9.8500000000000000e+01 2.9449998855590820e+01 1.5000000000000000e+01 9.8500000000000000e+01 2.0750000000000000e+01 1.1789400100708008e+01 9.8500000000000000e+01 2.9449998855590820e+01 -2.5000000000000000e+00 9.8500000000000000e+01 2.8888401031494141e+01 -5.8446496725082397e-01 9.8500000000000000e+01 2.8004899978637695e+01 3.1433300971984863e+00 9.8500000000000000e+01 1.3459400177001953e+01 1.3972100257873535e+01 9.8500000000000000e+01 1.7232299804687500e+01 1.3306799888610840e+01 9.8500000000000000e+01 2.9449998855590820e+01 -2.4000000000000000e+01 9.8500000000000000e+01 -5.7000002861022949e+00 -1.6885599136352539e+01 9.8500000000000000e+01 -5.1143598556518555e+00 -1.6300001144409180e+01 9.8500000000000000e+01 -6.5000000000000000e+00 -1.7100000381469727e+01 9.8500000000000000e+01 -1.6000000000000000e+01 -2.4000000000000000e+01 9.8500000000000000e+01 -7.3000001907348633e+00 -1.6885599136352539e+01 9.8500000000000000e+01 -1.7530700683593750e+01 -2.3695501327514648e+01 9.8500000000000000e+01 -7.8856396675109863e+00 -1.6300001144409180e+01 9.8500000000000000e+01 -1.8828399658203125e+01 -2.2828399658203125e+01 9.8500000000000000e+01 -1.9695499420166016e+01 -2.1530700683593750e+01 9.8500000000000000e+01 -8.1000003814697266e+00 -1.5500000000000000e+01 9.8500000000000000e+01 -2.0000000000000000e+01 -2.0000000000000000e+01 9.8500000000000000e+01 -7.8856396675109863e+00 -1.4699999809265137e+01 9.8500000000000000e+01 -7.3000001907348633e+00 -1.4114399909973145e+01 9.8500000000000000e+01 -6.5000000000000000e+00 -1.3899999618530273e+01 9.8500000000000000e+01 2.8004899978637695e+01 -8.1433296203613281e+00 9.8500000000000000e+01 2.8888401031494141e+01 -4.4155297279357910e+00 9.8500000000000000e+01 2.8888401031494141e+01 -2.5000000000000000e+00 9.8500000000000000e+01 9.6347999572753906e+00 -1.8749300003051758e+01 9.8500000000000000e+01 1.3459400177001953e+01 -1.8972101211547852e+01 9.8500000000000000e+01 1.7232299804687500e+01 -1.8306798934936523e+01 9.8500000000000000e+01 -3.5552401542663574e+00 -6.3051600456237793e+00 9.8500000000000000e+01 -5.7000002861022949e+00 -1.4114399909973145e+01 9.8500000000000000e+01 -2.2449400424957275e+00 -9.9051904678344727e+00 9.8500000000000000e+01 -5.1143598556518555e+00 -1.4699999809265137e+01 9.8500000000000000e+01 -1.3973300158977509e-01 -1.3105999946594238e+01 9.8500000000000000e+01 -4.9000000953674316e+00 -1.5500000000000000e+01 9.8500000000000000e+01 2.6468799114227295e+00 -1.5735000610351562e+01 9.8500000000000000e+01 5.9646801948547363e+00 -1.7650600433349609e+01 9.8500000000000000e+01 2.0750000000000000e+01 -1.6789398193359375e+01 9.8500000000000000e+01 2.3822999954223633e+01 -1.4501700401306152e+01 9.8500000000000000e+01 2.6285499572753906e+01 -1.1566899299621582e+01 9.8500000000000000e+01 3.3100002288818359e+01 -1.5500000000000000e+01 9.8500000000000000e+01 3.2885601043701172e+01 -1.4699999809265137e+01 9.8500000000000000e+01 4.5000000000000000e+01 -2.5000000000000000e+00 9.8500000000000000e+01 2.9899999618530273e+01 -1.5500000000000000e+01 9.8500000000000000e+01 3.0114398956298828e+01 -1.6300001144409180e+01 9.8500000000000000e+01 3.2299999237060547e+01 -1.4114399909973145e+01 9.8500000000000000e+01 3.1500000000000000e+01 -1.3899999618530273e+01 9.8500000000000000e+01 3.0700000762939453e+01 -1.4114399909973145e+01 9.8500000000000000e+01 3.0114398956298828e+01 -1.4699999809265137e+01 9.8500000000000000e+01 3.0700000762939453e+01 -1.6885599136352539e+01 9.8500000000000000e+01 3.1500000000000000e+01 -1.7100000381469727e+01 9.8500000000000000e+01 4.1000000000000000e+01 -2.4000000000000000e+01 9.8500000000000000e+01 3.2299999237060547e+01 -1.6885599136352539e+01 9.8500000000000000e+01 4.2530700683593750e+01 -2.3695501327514648e+01 9.8500000000000000e+01 3.2885601043701172e+01 -1.6300001144409180e+01 9.8500000000000000e+01 4.5000000000000000e+01 -2.0000000000000000e+01 9.8500000000000000e+01 4.4695499420166016e+01 -2.1530700683593750e+01 9.8500000000000000e+01 4.3828403472900391e+01 -2.2828399658203125e+01 9.8500000000000000e+01 3.0700000762939453e+01 1.1885600090026855e+01 9.8500000000000000e+01 3.0114398956298828e+01 1.1300000190734863e+01 9.8500000000000000e+01 2.9899999618530273e+01 1.0500000000000000e+01 9.8500000000000000e+01 3.0114398956298828e+01 9.7000007629394531e+00 9.8500000000000000e+01 3.0700000762939453e+01 9.1143608093261719e+00 9.8500000000000000e+01 3.1500000000000000e+01 8.8999996185302734e+00 9.8500000000000000e+01 3.3100002288818359e+01 1.0500000000000000e+01 9.8500000000000000e+01 4.5000000000000000e+01 1.5000000000000000e+01 9.8500000000000000e+01 3.2885601043701172e+01 9.7000007629394531e+00 9.8500000000000000e+01 3.2299999237060547e+01 9.1143608093261719e+00 9.8500000000000000e+01 3.2885601043701172e+01 1.1300000190734863e+01 9.8500000000000000e+01 3.2299999237060547e+01 1.1885600090026855e+01 9.8500000000000000e+01 3.1500000000000000e+01 1.2100000381469727e+01 1.0150000000000000e+02 9.6347999572753906e+00 1.3749300003051758e+01 1.0150000000000000e+02 1.2500000000000000e+01 1.3916199684143066e+01 1.0150000000000000e+02 1.2500000000000000e+01 1.5000000000000000e+01 1.0150000000000000e+02 3.4475097656250000e+01 1.2061499595642090e+01 1.0150000000000000e+02 3.4860000610351562e+01 1.0500000000000000e+01 1.0150000000000000e+02 4.5000000000000000e+01 1.5000000000000000e+01 1.0150000000000000e+02 1.2500000000000000e+01 -2.4000000000000000e+01 1.0150000000000000e+02 -4.5913000106811523e+00 -1.8265201568603516e+01 1.0150000000000000e+02 -6.0950002670288086e+00 -1.8835500717163086e+01 1.0150000000000000e+02 -1.6000000000000000e+01 -2.4000000000000000e+01 1.0150000000000000e+02 -9.7623596191406250e+00 -1.6304100036621094e+01 1.0150000000000000e+02 -2.0000000000000000e+01 -2.0000000000000000e+01 1.0150000000000000e+02 -1.9695499420166016e+01 -2.1530700683593750e+01 1.0150000000000000e+02 -2.0000000000000000e+01 -2.5000000000000000e+00 1.0150000000000000e+02 -9.0150003433227539e+00 -1.3271900177001953e+01 1.0150000000000000e+02 -7.6914701461791992e+00 -1.2358300209045410e+01 1.0150000000000000e+02 -9.7623596191406250e+00 -1.4695899963378906e+01 1.0150000000000000e+02 -7.6914701461791992e+00 -1.8641698837280273e+01 1.0150000000000000e+02 -9.0150003433227539e+00 -1.7728099822998047e+01 1.0150000000000000e+02 -1.7530700683593750e+01 -2.3695501327514648e+01 1.0150000000000000e+02 -1.8828399658203125e+01 -2.2828399658203125e+01 1.0150000000000000e+02 -6.0950002670288086e+00 -1.2164499282836914e+01 1.0150000000000000e+02 -4.0000000000000000e+00 -2.5000000000000000e+00 1.0150000000000000e+02 -3.5248699188232422e+00 -1.7061500549316406e+01 1.0150000000000000e+02 5.9646801948547363e+00 -1.7650600433349609e+01 1.0150000000000000e+02 -3.1399998664855957e+00 -1.5500000000000000e+01 1.0150000000000000e+02 2.6468799114227295e+00 -1.5735000610351562e+01 1.0150000000000000e+02 -3.5248699188232422e+00 -1.3938499450683594e+01 1.0150000000000000e+02 -1.3973300158977509e-01 -1.3105999946594238e+01 1.0150000000000000e+02 -4.5913000106811523e+00 -1.2734799385070801e+01 1.0150000000000000e+02 -2.2449400424957275e+00 -9.9051904678344727e+00 1.0150000000000000e+02 -3.5552401542663574e+00 -6.3051600456237793e+00 1.0150000000000000e+02 1.3459400177001953e+01 -1.8972101211547852e+01 1.0150000000000000e+02 1.2500000000000000e+01 -1.8916200637817383e+01 1.0150000000000000e+02 9.6347999572753906e+00 -1.8749300003051758e+01 1.0150000000000000e+02 3.1904998779296875e+01 -1.2164499282836914e+01 1.0150000000000000e+02 3.3408702850341797e+01 -1.2734799385070801e+01 1.0150000000000000e+02 4.5000000000000000e+01 -2.5000000000000000e+00 1.0150000000000000e+02 3.4475097656250000e+01 -1.3938499450683594e+01 1.0150000000000000e+02 4.5000000000000000e+01 -2.0000000000000000e+01 1.0150000000000000e+02 3.4860000610351562e+01 -1.5500000000000000e+01 1.0150000000000000e+02 4.4695499420166016e+01 -2.1530700683593750e+01 1.0150000000000000e+02 3.4475097656250000e+01 -1.7061500549316406e+01 1.0150000000000000e+02 4.3828403472900391e+01 -2.2828399658203125e+01 1.0150000000000000e+02 4.2530700683593750e+01 -2.3695501327514648e+01 1.0150000000000000e+02 3.3408702850341797e+01 -1.8265201568603516e+01 1.0150000000000000e+02 4.1000000000000000e+01 -2.4000000000000000e+01 1.0150000000000000e+02 3.1904998779296875e+01 -1.8835500717163086e+01 1.0150000000000000e+02 3.0308500289916992e+01 -1.8641698837280273e+01 1.0150000000000000e+02 2.8984998703002930e+01 -1.7728099822998047e+01 1.0150000000000000e+02 2.8237600326538086e+01 -1.6304100036621094e+01 1.0150000000000000e+02 1.7232299804687500e+01 -1.8306798934936523e+01 1.0150000000000000e+02 2.8888401031494141e+01 -2.5000000000000000e+00 1.0150000000000000e+02 2.8888401031494141e+01 -4.4155297279357910e+00 1.0150000000000000e+02 3.0308500289916992e+01 -1.2358300209045410e+01 1.0150000000000000e+02 2.8004899978637695e+01 -8.1433296203613281e+00 1.0150000000000000e+02 2.8984998703002930e+01 -1.3271900177001953e+01 1.0150000000000000e+02 2.6285499572753906e+01 -1.1566899299621582e+01 1.0150000000000000e+02 2.8237600326538086e+01 -1.4695899963378906e+01 1.0150000000000000e+02 2.3822999954223633e+01 -1.4501700401306152e+01 1.0150000000000000e+02 2.0750000000000000e+01 -1.6789398193359375e+01 1.0150000000000000e+02 3.4475097656250000e+01 8.9385309219360352e+00 1.0150000000000000e+02 3.3408702850341797e+01 7.7347698211669922e+00 1.0150000000000000e+02 3.1904998779296875e+01 7.1645002365112305e+00 1.0150000000000000e+02 2.8237600326538086e+01 1.1304100036621094e+01 1.0150000000000000e+02 2.8984998703002930e+01 1.2728099822998047e+01 1.0150000000000000e+02 1.3459400177001953e+01 1.3972100257873535e+01 1.0150000000000000e+02 1.7232299804687500e+01 1.3306799888610840e+01 1.0150000000000000e+02 2.0750000000000000e+01 1.1789400100708008e+01 1.0150000000000000e+02 2.8237600326538086e+01 9.6958999633789062e+00 1.0150000000000000e+02 2.3822999954223633e+01 9.5016603469848633e+00 1.0150000000000000e+02 2.8984998703002930e+01 8.2719106674194336e+00 1.0150000000000000e+02 2.6285499572753906e+01 6.5668902397155762e+00 1.0150000000000000e+02 3.0308500289916992e+01 7.3583498001098633e+00 1.0150000000000000e+02 2.8004899978637695e+01 3.1433300971984863e+00 1.0150000000000000e+02 2.8888401031494141e+01 -5.8446496725082397e-01 1.0150000000000000e+02 3.0308500289916992e+01 1.3641699790954590e+01 1.0150000000000000e+02 3.1904998779296875e+01 1.3835499763488770e+01 1.0150000000000000e+02 3.3408702850341797e+01 1.3265199661254883e+01 1.0150000000000000e+02 -3.5248699188232422e+00 1.2061499595642090e+01 1.0150000000000000e+02 -3.1399998664855957e+00 1.0500000000000000e+01 1.0150000000000000e+02 5.9646801948547363e+00 1.2650599479675293e+01 1.0150000000000000e+02 2.6468799114227295e+00 1.0734999656677246e+01 1.0150000000000000e+02 -1.3973300158977509e-01 8.1059999465942383e+00 1.0150000000000000e+02 -3.5248699188232422e+00 8.9385309219360352e+00 1.0150000000000000e+02 -2.2449400424957275e+00 4.9051899909973145e+00 1.0150000000000000e+02 -4.5913000106811523e+00 7.7347698211669922e+00 1.0150000000000000e+02 -3.5552401542663574e+00 1.3051600456237793e+00 1.0150000000000000e+02 -6.0950002670288086e+00 7.1645002365112305e+00 1.0150000000000000e+02 -7.6914701461791992e+00 7.3583498001098633e+00 1.0150000000000000e+02 -9.0150003433227539e+00 8.2719106674194336e+00 1.0150000000000000e+02 -9.7623596191406250e+00 9.6958999633789062e+00 1.0150000000000000e+02 -2.0000000000000000e+01 1.5000000000000000e+01 1.0150000000000000e+02 -9.7623596191406250e+00 1.1304100036621094e+01 1.0150000000000000e+02 -9.0150003433227539e+00 1.2728099822998047e+01 1.0150000000000000e+02 -7.6914701461791992e+00 1.3641699790954590e+01 1.0150000000000000e+02 -6.0950002670288086e+00 1.3835499763488770e+01 1.0150000000000000e+02 -4.5913000106811523e+00 1.3265199661254883e+01 5.0000000000000000e+01 -1.6000000000000000e+01 1.8000000000000000e+01 5.0000000000000000e+01 -1.6000000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 -1.2319999694824219e+01 1.8000000000000000e+01 5.0000000000000000e+01 -1.3199999809265137e+01 2.1000000000000000e+01 5.0000000000000000e+01 2.4000000000000000e+01 1.8000000000000000e+01 5.0000000000000000e+01 2.4000000000000000e+01 2.1000000000000000e+01 5.0000000000000000e+01 3.6819999694824219e+01 1.8000000000000000e+01 5.0000000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 5.0000000000000000e+01 4.1000000000000000e+01 1.8000000000000000e+01 5.0000000000000000e+01 4.1000000000000000e+01 2.1000000000000000e+01 9.5180000305175781e+01 4.5000000000000000e+01 1.8000000000000000e+01 9.5500000000000000e+01 4.5000000000000000e+01 1.8000000000000000e+01 9.5500000000000000e+01 4.3180000305175781e+01 1.8000000000000000e+01 7.9285499572753906e+01 1.0535499572753906e+01 1.8000000000000000e+01 7.8500000000000000e+01 1.1060400009155273e+01 1.8000000000000000e+01 7.8500000000000000e+01 2.4000000000000000e+01 1.8000000000000000e+01 5.6540199279785156e+01 4.3180000305175781e+01 1.8000000000000000e+01 5.6514999389648438e+01 4.3228099822998047e+01 1.8000000000000000e+01 6.1055000305175781e+01 4.5000000000000000e+01 1.8000000000000000e+01 5.5191497802734375e+01 4.4141696929931641e+01 1.8000000000000000e+01 5.4000000000000000e+01 4.5000000000000000e+01 1.8000000000000000e+01 5.3594997406005859e+01 4.4335498809814453e+01 1.8000000000000000e+01 5.2469299316406250e+01 4.4695499420166016e+01 1.8000000000000000e+01 5.2091300964355469e+01 4.3765197753906250e+01 1.8000000000000000e+01 5.5191497802734375e+01 3.7858299255371094e+01 1.8000000000000000e+01 5.6514999389648438e+01 3.8771900177001953e+01 1.8000000000000000e+01 6.1055000305175781e+01 3.6819999694824219e+01 1.8000000000000000e+01 5.1024898529052734e+01 3.9438499450683594e+01 1.8000000000000000e+01 5.2091300964355469e+01 3.8234798431396484e+01 1.8000000000000000e+01 5.3594997406005859e+01 3.7664497375488281e+01 1.8000000000000000e+01 5.7262397766113281e+01 4.0195899963378906e+01 1.8000000000000000e+01 5.7262397766113281e+01 4.1804100036621094e+01 1.8000000000000000e+01 6.1055000305175781e+01 4.3180000305175781e+01 1.8000000000000000e+01 5.0639999389648438e+01 4.1000000000000000e+01 1.8000000000000000e+01 5.1024898529052734e+01 4.2561500549316406e+01 1.8000000000000000e+01 5.0304496765136719e+01 4.2530700683593750e+01 1.8000000000000000e+01 5.1572799682617188e+01 4.3180000305175781e+01 1.8000000000000000e+01 5.0738300323486328e+01 4.3180000305175781e+01 1.8000000000000000e+01 5.1171600341796875e+01 4.3828403472900391e+01 1.8000000000000000e+01 5.5191497802734375e+01 -1.9141700744628906e+01 1.8000000000000000e+01 5.6514999389648438e+01 -1.8228099822998047e+01 1.8000000000000000e+01 6.1055000305175781e+01 -1.9680000305175781e+01 1.8000000000000000e+01 5.3594997406005859e+01 -1.9335500717163086e+01 1.8000000000000000e+01 6.1055000305175781e+01 -1.2319999694824219e+01 1.8000000000000000e+01 5.5191497802734375e+01 -1.2858299255371094e+01 1.8000000000000000e+01 5.3594997406005859e+01 -1.2664499282836914e+01 1.8000000000000000e+01 5.2091300964355469e+01 -1.3234799385070801e+01 1.8000000000000000e+01 5.1024898529052734e+01 -1.4438499450683594e+01 1.8000000000000000e+01 5.0639999389648438e+01 -1.6000000000000000e+01 1.8000000000000000e+01 5.0304496765136719e+01 -1.7530700683593750e+01 1.8000000000000000e+01 5.1024898529052734e+01 -1.7561500549316406e+01 1.8000000000000000e+01 5.1171600341796875e+01 -1.8828399658203125e+01 1.8000000000000000e+01 5.2091300964355469e+01 -1.8765199661254883e+01 1.8000000000000000e+01 5.2445999145507812e+01 -1.9680000305175781e+01 1.8000000000000000e+01 5.7262397766113281e+01 -1.6804100036621094e+01 1.8000000000000000e+01 5.7262397766113281e+01 -1.5195899963378906e+01 1.8000000000000000e+01 5.6514999389648438e+01 -1.3771900177001953e+01 1.8000000000000000e+01 5.4000000000000000e+01 -2.0000000000000000e+01 1.8000000000000000e+01 5.2469299316406250e+01 -1.9695499420166016e+01 1.8000000000000000e+01 6.5130599975585938e+01 -8.9134197235107422e+00 1.8000000000000000e+01 6.6214500427246094e+01 -1.0535499572753906e+01 1.8000000000000000e+01 7.2750000000000000e+01 2.4000000000000000e+01 1.8000000000000000e+01 6.9750000000000000e+01 1.2000000000000000e+01 1.8000000000000000e+01 6.1055000305175781e+01 2.4000000000000000e+01 1.8000000000000000e+01 6.7836601257324219e+01 1.1619400024414062e+01 1.8000000000000000e+01 6.6214500427246094e+01 1.0535499572753906e+01 1.8000000000000000e+01 6.5130599975585938e+01 8.9134197235107422e+00 1.8000000000000000e+01 6.4750000000000000e+01 7.0000000000000000e+00 1.8000000000000000e+01 6.4750000000000000e+01 -7.0000000000000000e+00 1.8000000000000000e+01 7.7663398742675781e+01 1.1619400024414062e+01 1.8000000000000000e+01 7.5750000000000000e+01 1.2000000000000000e+01 1.8000000000000000e+01 7.2750000000000000e+01 1.2000000000000000e+01 1.8000000000000000e+01 7.9285499572753906e+01 -1.0535499572753906e+01 1.8000000000000000e+01 8.4444999694824219e+01 -1.2319999694824219e+01 1.8000000000000000e+01 7.8500000000000000e+01 -1.1060400009155273e+01 1.8000000000000000e+01 7.8500000000000000e+01 -1.2319999694824219e+01 1.8000000000000000e+01 7.7663398742675781e+01 -1.1619400024414062e+01 1.8000000000000000e+01 8.4444999694824219e+01 2.4000000000000000e+01 1.8000000000000000e+01 8.0369400024414062e+01 8.9134197235107422e+00 1.8000000000000000e+01 8.0369400024414062e+01 -8.9134197235107422e+00 1.8000000000000000e+01 8.0750000000000000e+01 -7.0000000000000000e+00 1.8000000000000000e+01 8.0750000000000000e+01 7.0000000000000000e+00 1.8000000000000000e+01 6.7836601257324219e+01 -1.1619400024414062e+01 1.8000000000000000e+01 6.9750000000000000e+01 -1.2000000000000000e+01 1.8000000000000000e+01 7.2750000000000000e+01 -1.2319999694824219e+01 1.8000000000000000e+01 7.2750000000000000e+01 -1.2000000000000000e+01 1.8000000000000000e+01 7.5750000000000000e+01 -1.2000000000000000e+01 1.8000000000000000e+01 7.1115997314453125e+01 4.1500000000000000e+01 1.8000000000000000e+01 7.0750000000000000e+01 4.1866001129150391e+01 1.8000000000000000e+01 7.2750000000000000e+01 4.3180000305175781e+01 1.8000000000000000e+01 7.0250000000000000e+01 4.2000000000000000e+01 1.8000000000000000e+01 6.9750000000000000e+01 4.1866001129150391e+01 1.8000000000000000e+01 6.9384002685546875e+01 4.1500000000000000e+01 1.8000000000000000e+01 7.2750000000000000e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.1250000000000000e+01 3.7000000000000000e+01 1.8000000000000000e+01 7.1250000000000000e+01 4.1000000000000000e+01 1.8000000000000000e+01 6.9250000000000000e+01 4.1000000000000000e+01 1.8000000000000000e+01 6.9250000000000000e+01 3.7000000000000000e+01 1.8000000000000000e+01 6.9298202514648438e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.0750000000000000e+01 3.6134002685546875e+01 1.8000000000000000e+01 7.1115997314453125e+01 3.6500000000000000e+01 1.8000000000000000e+01 7.1201797485351562e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.0250000000000000e+01 3.6000000000000000e+01 1.8000000000000000e+01 6.9750000000000000e+01 3.6134002685546875e+01 1.8000000000000000e+01 6.9384002685546875e+01 3.6500000000000000e+01 1.8000000000000000e+01 7.5250000000000000e+01 4.2000000000000000e+01 1.8000000000000000e+01 7.4750000000000000e+01 4.1866001129150391e+01 1.8000000000000000e+01 7.8500000000000000e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.6201797485351562e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.6250000000000000e+01 3.7000000000000000e+01 1.8000000000000000e+01 7.5750000000000000e+01 4.1866001129150391e+01 1.8000000000000000e+01 7.8500000000000000e+01 4.3180000305175781e+01 1.8000000000000000e+01 7.6116004943847656e+01 4.1500000000000000e+01 1.8000000000000000e+01 7.6250000000000000e+01 4.1000000000000000e+01 1.8000000000000000e+01 7.4383995056152344e+01 4.1500000000000000e+01 1.8000000000000000e+01 7.4250000000000000e+01 4.1000000000000000e+01 1.8000000000000000e+01 7.4250000000000000e+01 3.7000000000000000e+01 1.8000000000000000e+01 7.4298202514648438e+01 3.6819999694824219e+01 1.8000000000000000e+01 7.4383995056152344e+01 3.6500000000000000e+01 1.8000000000000000e+01 7.4750000000000000e+01 3.6134002685546875e+01 1.8000000000000000e+01 7.5250000000000000e+01 3.6000000000000000e+01 1.8000000000000000e+01 7.5750000000000000e+01 3.6134002685546875e+01 1.8000000000000000e+01 7.6116004943847656e+01 3.6500000000000000e+01 1.8000000000000000e+01 9.1095001220703125e+01 3.7664497375488281e+01 1.8000000000000000e+01 9.2691505432128906e+01 3.7858299255371094e+01 1.8000000000000000e+01 9.5180000305175781e+01 3.6819999694824219e+01 1.8000000000000000e+01 8.4444999694824219e+01 4.3180000305175781e+01 1.8000000000000000e+01 8.8524902343750000e+01 4.2561500549316406e+01 1.8000000000000000e+01 8.8140007019042969e+01 4.1000000000000000e+01 1.8000000000000000e+01 9.4014999389648438e+01 3.8771900177001953e+01 1.8000000000000000e+01 9.4762397766113281e+01 4.0195899963378906e+01 1.8000000000000000e+01 9.5180000305175781e+01 4.3180000305175781e+01 1.8000000000000000e+01 8.4444999694824219e+01 3.6819999694824219e+01 1.8000000000000000e+01 8.8524902343750000e+01 3.9438499450683594e+01 1.8000000000000000e+01 8.9591300964355469e+01 3.8234798431396484e+01 1.8000000000000000e+01 9.4762397766113281e+01 4.1804100036621094e+01 1.8000000000000000e+01 9.4040199279785156e+01 4.3180000305175781e+01 1.8000000000000000e+01 9.4014999389648438e+01 4.3228099822998047e+01 1.8000000000000000e+01 9.2691505432128906e+01 4.4141696929931641e+01 1.8000000000000000e+01 9.1095001220703125e+01 4.4335498809814453e+01 1.8000000000000000e+01 8.4444999694824219e+01 4.5000000000000000e+01 1.8000000000000000e+01 8.9591300964355469e+01 4.3765197753906250e+01 1.8000000000000000e+01 8.9072799682617188e+01 4.3180000305175781e+01 1.8000000000000000e+01 7.8500000000000000e+01 4.5000000000000000e+01 1.8000000000000000e+01 7.2750000000000000e+01 4.5000000000000000e+01 1.8000000000000000e+01 8.8524902343750000e+01 -1.4438499450683594e+01 1.8000000000000000e+01 8.8140007019042969e+01 -1.6000000000000000e+01 1.8000000000000000e+01 8.4444999694824219e+01 -1.9680000305175781e+01 1.8000000000000000e+01 8.8524902343750000e+01 -1.7561500549316406e+01 1.8000000000000000e+01 9.4762397766113281e+01 -1.5195899963378906e+01 1.8000000000000000e+01 9.5180000305175781e+01 -1.2319999694824219e+01 1.8000000000000000e+01 9.4762397766113281e+01 -1.6804100036621094e+01 1.8000000000000000e+01 9.5180000305175781e+01 -1.9680000305175781e+01 1.8000000000000000e+01 9.4014999389648438e+01 -1.8228099822998047e+01 1.8000000000000000e+01 9.4014999389648438e+01 -1.3771900177001953e+01 1.8000000000000000e+01 9.2691505432128906e+01 -1.2858299255371094e+01 1.8000000000000000e+01 9.1095001220703125e+01 -1.2664499282836914e+01 1.8000000000000000e+01 8.9591300964355469e+01 -1.3234799385070801e+01 1.8000000000000000e+01 7.8500000000000000e+01 -1.9680000305175781e+01 1.8000000000000000e+01 7.2750000000000000e+01 -1.9680000305175781e+01 1.8000000000000000e+01 8.9591300964355469e+01 -1.8765199661254883e+01 1.8000000000000000e+01 9.1095001220703125e+01 -1.9335500717163086e+01 1.8000000000000000e+01 9.2691505432128906e+01 -1.9141700744628906e+01 1.8000000000000000e+01 9.5180000305175781e+01 2.4000000000000000e+01 1.8000000000000000e+01 9.5180000305175781e+01 -2.0000000000000000e+01 1.8000000000000000e+01 8.4444999694824219e+01 -2.0000000000000000e+01 1.8000000000000000e+01 7.8500000000000000e+01 -2.0000000000000000e+01 1.8000000000000000e+01 7.2750000000000000e+01 -2.0000000000000000e+01 1.8000000000000000e+01 6.1055000305175781e+01 -2.0000000000000000e+01 1.8000000000000000e+01 9.5500000000000000e+01 3.6819999694824219e+01 1.8000000000000000e+01 9.5500000000000000e+01 2.4000000000000000e+01 1.8000000000000000e+01 9.5500000000000000e+01 -1.2319999694824219e+01 1.8000000000000000e+01 9.5500000000000000e+01 -1.9680000305175781e+01 1.8000000000000000e+01 9.5500000000000000e+01 -2.0000000000000000e+01 1.8000000000000000e+01 5.4000000000000000e+01 -2.0000000000000000e+01 2.1000000000000000e+01 6.0175003051757812e+01 -2.0000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 -2.0000000000000000e+01 2.1000000000000000e+01 7.8500000000000000e+01 -2.0000000000000000e+01 2.1000000000000000e+01 8.5325004577636719e+01 -2.0000000000000000e+01 2.1000000000000000e+01 9.4300003051757812e+01 -2.0000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -2.0000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -1.8799999237060547e+01 2.1000000000000000e+01 7.6250000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 7.8500000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 5.4799999237060547e+01 4.2385601043701172e+01 2.1000000000000000e+01 5.4885601043701172e+01 4.2299999237060547e+01 2.1000000000000000e+01 6.0175003051757812e+01 4.2299999237060547e+01 2.1000000000000000e+01 5.5385601043701172e+01 4.1799999237060547e+01 2.1000000000000000e+01 5.5599998474121094e+01 4.1000000000000000e+01 2.1000000000000000e+01 5.4799999237060547e+01 3.9614402770996094e+01 2.1000000000000000e+01 5.4000000000000000e+01 3.9400001525878906e+01 2.1000000000000000e+01 5.5385601043701172e+01 4.0199996948242188e+01 2.1000000000000000e+01 6.0175003051757812e+01 3.7700000762939453e+01 2.1000000000000000e+01 5.3200000762939453e+01 3.9614402770996094e+01 2.1000000000000000e+01 5.2614398956298828e+01 4.0199996948242188e+01 2.1000000000000000e+01 5.2400001525878906e+01 4.1000000000000000e+01 2.1000000000000000e+01 5.0258598327636719e+01 4.2299999237060547e+01 2.1000000000000000e+01 5.2614398956298828e+01 4.1799999237060547e+01 2.1000000000000000e+01 5.3114398956298828e+01 4.2299999237060547e+01 2.1000000000000000e+01 5.0304496765136719e+01 4.2530700683593750e+01 2.1000000000000000e+01 5.3200000762939453e+01 4.2385601043701172e+01 2.1000000000000000e+01 5.1171600341796875e+01 4.3828403472900391e+01 2.1000000000000000e+01 5.2469299316406250e+01 4.4695499420166016e+01 2.1000000000000000e+01 5.4000000000000000e+01 4.5000000000000000e+01 2.1000000000000000e+01 5.4000000000000000e+01 4.2599998474121094e+01 2.1000000000000000e+01 6.0175003051757812e+01 4.5000000000000000e+01 2.1000000000000000e+01 6.0175003051757812e+01 -1.3199999809265137e+01 2.1000000000000000e+01 5.4799999237060547e+01 -1.4614400863647461e+01 2.1000000000000000e+01 5.5385601043701172e+01 -1.5199999809265137e+01 2.1000000000000000e+01 5.3200000762939453e+01 -1.4614400863647461e+01 2.1000000000000000e+01 5.4000000000000000e+01 -1.4399999618530273e+01 2.1000000000000000e+01 5.5599998474121094e+01 -1.6000000000000000e+01 2.1000000000000000e+01 5.5385601043701172e+01 -1.6799999237060547e+01 2.1000000000000000e+01 6.0175003051757812e+01 -1.8799999237060547e+01 2.1000000000000000e+01 5.4799999237060547e+01 -1.7385601043701172e+01 2.1000000000000000e+01 5.1152603149414062e+01 -1.8799999237060547e+01 2.1000000000000000e+01 5.4000000000000000e+01 -1.7600000381469727e+01 2.1000000000000000e+01 5.3200000762939453e+01 -1.7385601043701172e+01 2.1000000000000000e+01 5.0304496765136719e+01 -1.7530700683593750e+01 2.1000000000000000e+01 5.2614398956298828e+01 -1.6799999237060547e+01 2.1000000000000000e+01 5.2400001525878906e+01 -1.6000000000000000e+01 2.1000000000000000e+01 5.2614398956298828e+01 -1.5199999809265137e+01 2.1000000000000000e+01 7.2750000000000000e+01 -1.3199999809265137e+01 2.1000000000000000e+01 6.7836601257324219e+01 -1.1619400024414062e+01 2.1000000000000000e+01 6.6214500427246094e+01 -1.0535499572753906e+01 2.1000000000000000e+01 6.0175003051757812e+01 2.4000000000000000e+01 2.1000000000000000e+01 6.5130599975585938e+01 8.9134197235107422e+00 2.1000000000000000e+01 6.6214500427246094e+01 1.0535499572753906e+01 2.1000000000000000e+01 6.5130599975585938e+01 -8.9134197235107422e+00 2.1000000000000000e+01 7.8500000000000000e+01 -1.1060400009155273e+01 2.1000000000000000e+01 7.7663398742675781e+01 -1.1619400024414062e+01 2.1000000000000000e+01 7.8500000000000000e+01 -1.3199999809265137e+01 2.1000000000000000e+01 7.9285499572753906e+01 1.0535499572753906e+01 2.1000000000000000e+01 8.5325004577636719e+01 2.4000000000000000e+01 2.1000000000000000e+01 7.8500000000000000e+01 1.1060400009155273e+01 2.1000000000000000e+01 7.8500000000000000e+01 2.4000000000000000e+01 2.1000000000000000e+01 7.7663398742675781e+01 1.1619400024414062e+01 2.1000000000000000e+01 7.9285499572753906e+01 -1.0535499572753906e+01 2.1000000000000000e+01 8.5325004577636719e+01 -1.3199999809265137e+01 2.1000000000000000e+01 8.0369400024414062e+01 -8.9134197235107422e+00 2.1000000000000000e+01 8.0369400024414062e+01 8.9134197235107422e+00 2.1000000000000000e+01 6.7836601257324219e+01 1.1619400024414062e+01 2.1000000000000000e+01 7.2750000000000000e+01 2.4000000000000000e+01 2.1000000000000000e+01 6.9384002685546875e+01 4.1500000000000000e+01 2.1000000000000000e+01 6.9250000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 6.9750000000000000e+01 4.1866001129150391e+01 2.1000000000000000e+01 7.0250000000000000e+01 4.2000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 4.2299999237060547e+01 2.1000000000000000e+01 7.0750000000000000e+01 4.1866001129150391e+01 2.1000000000000000e+01 7.1115997314453125e+01 4.1500000000000000e+01 2.1000000000000000e+01 7.1250000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 7.2750000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 7.4383995056152344e+01 4.1500000000000000e+01 2.1000000000000000e+01 7.4250000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 7.4750000000000000e+01 4.1866001129150391e+01 2.1000000000000000e+01 7.5250000000000000e+01 4.2000000000000000e+01 2.1000000000000000e+01 7.8500000000000000e+01 4.2299999237060547e+01 2.1000000000000000e+01 7.5750000000000000e+01 4.1866001129150391e+01 2.1000000000000000e+01 7.6116004943847656e+01 4.1500000000000000e+01 2.1000000000000000e+01 8.9900001525878906e+01 4.1000000000000000e+01 2.1000000000000000e+01 9.0114402770996094e+01 4.1799999237060547e+01 2.1000000000000000e+01 8.5325004577636719e+01 4.2299999237060547e+01 2.1000000000000000e+01 9.2885597229003906e+01 4.0199996948242188e+01 2.1000000000000000e+01 9.2299995422363281e+01 3.9614402770996094e+01 2.1000000000000000e+01 9.4300003051757812e+01 3.7700000762939453e+01 2.1000000000000000e+01 9.1500000000000000e+01 3.9400001525878906e+01 2.1000000000000000e+01 9.0114402770996094e+01 4.0199996948242188e+01 2.1000000000000000e+01 9.3099998474121094e+01 4.1000000000000000e+01 2.1000000000000000e+01 9.4300003051757812e+01 4.2299999237060547e+01 2.1000000000000000e+01 9.2885597229003906e+01 4.1799999237060547e+01 2.1000000000000000e+01 9.0699996948242188e+01 3.9614402770996094e+01 2.1000000000000000e+01 8.5325004577636719e+01 3.7700000762939453e+01 2.1000000000000000e+01 9.0614402770996094e+01 4.2299999237060547e+01 2.1000000000000000e+01 9.0699996948242188e+01 4.2385601043701172e+01 2.1000000000000000e+01 8.5325004577636719e+01 4.5000000000000000e+01 2.1000000000000000e+01 9.4300003051757812e+01 4.5000000000000000e+01 2.1000000000000000e+01 9.1500000000000000e+01 4.2599998474121094e+01 2.1000000000000000e+01 9.2299995422363281e+01 4.2385601043701172e+01 2.1000000000000000e+01 9.2385597229003906e+01 4.2299999237060547e+01 2.1000000000000000e+01 9.4300003051757812e+01 -1.8799999237060547e+01 2.1000000000000000e+01 8.5325004577636719e+01 -1.8799999237060547e+01 2.1000000000000000e+01 7.8500000000000000e+01 -1.8799999237060547e+01 2.1000000000000000e+01 7.2750000000000000e+01 -1.8799999237060547e+01 2.1000000000000000e+01 5.2469299316406250e+01 -1.9695499420166016e+01 2.1000000000000000e+01 5.1171600341796875e+01 -1.8828399658203125e+01 2.1000000000000000e+01 9.2885597229003906e+01 -1.6799999237060547e+01 2.1000000000000000e+01 9.2299995422363281e+01 -1.7385601043701172e+01 2.1000000000000000e+01 9.1500000000000000e+01 -1.7600000381469727e+01 2.1000000000000000e+01 9.0699996948242188e+01 -1.7385601043701172e+01 2.1000000000000000e+01 9.1500000000000000e+01 -1.4399999618530273e+01 2.1000000000000000e+01 9.2299995422363281e+01 -1.4614400863647461e+01 2.1000000000000000e+01 9.4300003051757812e+01 -1.3199999809265137e+01 2.1000000000000000e+01 9.2885597229003906e+01 -1.5199999809265137e+01 2.1000000000000000e+01 9.3099998474121094e+01 -1.6000000000000000e+01 2.1000000000000000e+01 9.0114402770996094e+01 -1.6799999237060547e+01 2.1000000000000000e+01 8.9900001525878906e+01 -1.6000000000000000e+01 2.1000000000000000e+01 9.0114402770996094e+01 -1.5199999809265137e+01 2.1000000000000000e+01 9.0699996948242188e+01 -1.4614400863647461e+01 2.1000000000000000e+01 9.4300003051757812e+01 2.4000000000000000e+01 2.1000000000000000e+01 7.8500000000000000e+01 4.5000000000000000e+01 2.1000000000000000e+01 7.2750000000000000e+01 4.5000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 -1.3199999809265137e+01 2.1000000000000000e+01 9.5500000000000000e+01 2.4000000000000000e+01 2.1000000000000000e+01 9.5500000000000000e+01 3.7700000762939453e+01 2.1000000000000000e+01 9.5500000000000000e+01 4.2299999237060547e+01 2.1000000000000000e+01 9.5500000000000000e+01 4.5000000000000000e+01 2.1000000000000000e+01 9.7000000000000000e+01 -2.0000000000000000e+01 1.7598100662231445e+01 9.8098098754882812e+01 -2.0000000000000000e+01 1.6500000000000000e+01 1.0035400390625000e+02 -2.0000000000000000e+01 1.8526699066162109e+01 1.0120599365234375e+02 -2.0000000000000000e+01 1.6854099273681641e+01 9.7354095458984375e+01 -2.0000000000000000e+01 2.0706298828125000e+01 9.9026702880859375e+01 -2.0000000000000000e+01 1.9854101181030273e+01 1.0120599365234375e+02 4.5000000000000000e+01 1.6854099273681641e+01 9.8098098754882812e+01 4.5000000000000000e+01 1.6500000000000000e+01 1.0035400390625000e+02 4.5000000000000000e+01 1.8526699066162109e+01 9.9026702880859375e+01 4.5000000000000000e+01 1.9854101181030273e+01 9.7000000000000000e+01 4.5000000000000000e+01 1.7598100662231445e+01 9.7354095458984375e+01 4.5000000000000000e+01 2.0706298828125000e+01 9.9739997863769531e+01 -5.0832700729370117e+00 1.1243600845336914e+01 9.9739997863769531e+01 -5.1249599456787109e+00 1.1290599822998047e+01 9.9739997863769531e+01 -5.5911002159118652e+00 1.1816799163818359e+01 9.9739997863769531e+01 -5.7091403007507324e+00 1.1861500740051270e+01 9.9739997863769531e+01 -6.3071398735046387e+00 1.2088299751281738e+01 9.9739997863769531e+01 -6.4958000183105469e+00 1.2065400123596191e+01 9.9739997863769531e+01 -7.0673704147338867e+00 1.1996000289916992e+01 9.9739997863769531e+01 -7.2765402793884277e+00 1.1851600646972656e+01 9.9739997863769531e+01 -7.6976199150085449e+00 1.1560999870300293e+01 9.9739997863769531e+01 -7.8456196784973145e+00 1.1279000282287598e+01 9.9739997863769531e+01 -8.0535106658935547e+00 1.0882900238037109e+01 9.9739997863769531e+01 -8.0535106658935547e+00 1.0500000000000000e+01 9.9739997863769531e+01 -8.0535106658935547e+00 1.0117099761962891e+01 9.9739997863769531e+01 -7.8456196784973145e+00 9.7209997177124023e+00 9.9739997863769531e+01 -7.6976199150085449e+00 9.4390001296997070e+00 9.9739997863769531e+01 -7.2765402793884277e+00 9.1483497619628906e+00 9.9739997863769531e+01 -7.0673704147338867e+00 9.0039701461791992e+00 9.9739997863769531e+01 -6.4958000183105469e+00 8.9345693588256836e+00 9.9739997863769531e+01 -6.3071398735046387e+00 8.9116697311401367e+00 9.9739997863769531e+01 -5.7091403007507324e+00 9.1384601593017578e+00 9.9739997863769531e+01 -5.5911002159118652e+00 9.1832294464111328e+00 9.9739997863769531e+01 -5.1249599456787109e+00 9.7093896865844727e+00 9.9739997863769531e+01 -5.0832700729370117e+00 9.7564401626586914e+00 9.9739997863769531e+01 -4.9000000953674316e+00 1.0500000000000000e+01 9.9739997863769531e+01 -5.0832700729370117e+00 -1.4756400108337402e+01 9.9739997863769531e+01 -5.1249599456787109e+00 -1.4709400177001953e+01 9.9739997863769531e+01 -5.5911002159118652e+00 -1.4183199882507324e+01 9.9739997863769531e+01 -5.7091403007507324e+00 -1.4138500213623047e+01 9.9739997863769531e+01 -6.3071398735046387e+00 -1.3911700248718262e+01 9.9739997863769531e+01 -6.4958000183105469e+00 -1.3934599876403809e+01 9.9739997863769531e+01 -7.0673704147338867e+00 -1.4004000663757324e+01 9.9739997863769531e+01 -7.2765402793884277e+00 -1.4148400306701660e+01 9.9739997863769531e+01 -7.6976199150085449e+00 -1.4439000129699707e+01 9.9739997863769531e+01 -7.8456196784973145e+00 -1.4720999717712402e+01 9.9739997863769531e+01 -8.0535106658935547e+00 -1.5117100715637207e+01 9.9739997863769531e+01 -8.0535106658935547e+00 -1.5500000000000000e+01 9.9739997863769531e+01 -8.0535106658935547e+00 -1.5882900238037109e+01 9.9739997863769531e+01 -7.8456196784973145e+00 -1.6279001235961914e+01 9.9739997863769531e+01 -7.6976199150085449e+00 -1.6560998916625977e+01 9.9739997863769531e+01 -7.2765402793884277e+00 -1.6851600646972656e+01 9.9739997863769531e+01 -7.0673704147338867e+00 -1.6996000289916992e+01 9.9739997863769531e+01 -6.4958000183105469e+00 -1.7065401077270508e+01 9.9739997863769531e+01 -6.3071398735046387e+00 -1.7088298797607422e+01 9.9739997863769531e+01 -5.7091403007507324e+00 -1.6861499786376953e+01 9.9739997863769531e+01 -5.5911002159118652e+00 -1.6816801071166992e+01 9.9739997863769531e+01 -5.1249599456787109e+00 -1.6290599822998047e+01 9.9739997863769531e+01 -5.0832700729370117e+00 -1.6243598937988281e+01 9.9739997863769531e+01 -4.9000000953674316e+00 -1.5500000000000000e+01 9.9739997863769531e+01 3.2916698455810547e+01 1.1243600845336914e+01 9.9739997863769531e+01 3.2875000000000000e+01 1.1290599822998047e+01 9.9739997863769531e+01 3.2408901214599609e+01 1.1816799163818359e+01 9.9739997863769531e+01 3.2290897369384766e+01 1.1861500740051270e+01 9.9739997863769531e+01 3.1692899703979492e+01 1.2088299751281738e+01 9.9739997863769531e+01 3.1504198074340820e+01 1.2065400123596191e+01 9.9739997863769531e+01 3.0932600021362305e+01 1.1996000289916992e+01 9.9739997863769531e+01 3.0723499298095703e+01 1.1851600646972656e+01 9.9739997863769531e+01 3.0302400588989258e+01 1.1560999870300293e+01 9.9739997863769531e+01 3.0154399871826172e+01 1.1279000282287598e+01 9.9739997863769531e+01 2.9946500778198242e+01 1.0882900238037109e+01 9.9739997863769531e+01 2.9946500778198242e+01 1.0500000000000000e+01 9.9739997863769531e+01 2.9946500778198242e+01 1.0117099761962891e+01 9.9739997863769531e+01 3.0154399871826172e+01 9.7209997177124023e+00 9.9739997863769531e+01 3.0302400588989258e+01 9.4390001296997070e+00 9.9739997863769531e+01 3.0723499298095703e+01 9.1483497619628906e+00 9.9739997863769531e+01 3.0932600021362305e+01 9.0039701461791992e+00 9.9739997863769531e+01 3.1504198074340820e+01 8.9345693588256836e+00 9.9739997863769531e+01 3.1692899703979492e+01 8.9116697311401367e+00 9.9739997863769531e+01 3.2290897369384766e+01 9.1384601593017578e+00 9.9739997863769531e+01 3.2408901214599609e+01 9.1832294464111328e+00 9.9739997863769531e+01 3.2875000000000000e+01 9.7093896865844727e+00 9.9739997863769531e+01 3.2916698455810547e+01 9.7564401626586914e+00 9.9739997863769531e+01 3.3100002288818359e+01 1.0500000000000000e+01 9.9739997863769531e+01 3.2916698455810547e+01 -1.4756400108337402e+01 9.9739997863769531e+01 3.2875000000000000e+01 -1.4709400177001953e+01 9.9739997863769531e+01 3.2408901214599609e+01 -1.4183199882507324e+01 9.9739997863769531e+01 3.2290897369384766e+01 -1.4138500213623047e+01 9.9739997863769531e+01 3.1692899703979492e+01 -1.3911700248718262e+01 9.9739997863769531e+01 3.1504198074340820e+01 -1.3934599876403809e+01 9.9739997863769531e+01 3.0932600021362305e+01 -1.4004000663757324e+01 9.9739997863769531e+01 3.0723499298095703e+01 -1.4148400306701660e+01 9.9739997863769531e+01 3.0302400588989258e+01 -1.4439000129699707e+01 9.9739997863769531e+01 3.0154399871826172e+01 -1.4720999717712402e+01 9.9739997863769531e+01 2.9946500778198242e+01 -1.5117100715637207e+01 9.9739997863769531e+01 2.9946500778198242e+01 -1.5500000000000000e+01 9.9739997863769531e+01 2.9946500778198242e+01 -1.5882900238037109e+01 9.9739997863769531e+01 3.0154399871826172e+01 -1.6279001235961914e+01 9.9739997863769531e+01 3.0302400588989258e+01 -1.6560998916625977e+01 9.9739997863769531e+01 3.0723499298095703e+01 -1.6851600646972656e+01 9.9739997863769531e+01 3.0932600021362305e+01 -1.6996000289916992e+01 9.9739997863769531e+01 3.1504198074340820e+01 -1.7065401077270508e+01 9.9739997863769531e+01 3.1692899703979492e+01 -1.7088298797607422e+01 9.9739997863769531e+01 3.2290897369384766e+01 -1.6861499786376953e+01 9.9739997863769531e+01 3.2408901214599609e+01 -1.6816801071166992e+01 9.9739997863769531e+01 3.2875000000000000e+01 -1.6290599822998047e+01 9.9739997863769531e+01 3.2916698455810547e+01 -1.6243598937988281e+01 9.9739997863769531e+01 3.3100002288818359e+01 -1.5500000000000000e+01 9.0083297729492188e+01 4.1743598937988281e+01 1.9760000228881836e+01 9.0125000000000000e+01 4.1790599822998047e+01 1.9760000228881836e+01 9.0591102600097656e+01 4.2316802978515625e+01 1.9760000228881836e+01 9.0709098815917969e+01 4.2361499786376953e+01 1.9760000228881836e+01 9.1307106018066406e+01 4.2588302612304688e+01 1.9760000228881836e+01 9.1495796203613281e+01 4.2565402984619141e+01 1.9760000228881836e+01 9.2067398071289062e+01 4.2495998382568359e+01 1.9760000228881836e+01 9.2276496887207031e+01 4.2351600646972656e+01 1.9760000228881836e+01 9.2697601318359375e+01 4.2061000823974609e+01 1.9760000228881836e+01 9.2845596313476562e+01 4.1778999328613281e+01 1.9760000228881836e+01 9.3053497314453125e+01 4.1382900238037109e+01 1.9760000228881836e+01 9.3053497314453125e+01 4.1000000000000000e+01 1.9760000228881836e+01 9.3053497314453125e+01 4.0617099761962891e+01 1.9760000228881836e+01 9.2845596313476562e+01 4.0220996856689453e+01 1.9760000228881836e+01 9.2697601318359375e+01 3.9939002990722656e+01 1.9760000228881836e+01 9.2276496887207031e+01 3.9648399353027344e+01 1.9760000228881836e+01 9.2067398071289062e+01 3.9503997802734375e+01 1.9760000228881836e+01 9.1495796203613281e+01 3.9434600830078125e+01 1.9760000228881836e+01 9.1307106018066406e+01 3.9411701202392578e+01 1.9760000228881836e+01 9.0709098815917969e+01 3.9638500213623047e+01 1.9760000228881836e+01 9.0591102600097656e+01 3.9683200836181641e+01 1.9760000228881836e+01 9.0125000000000000e+01 4.0209400177001953e+01 1.9760000228881836e+01 9.0083297729492188e+01 4.0256401062011719e+01 1.9760000228881836e+01 8.9900001525878906e+01 4.1000000000000000e+01 1.9760000228881836e+01 9.0083297729492188e+01 -1.5256400108337402e+01 1.9760000228881836e+01 9.0125000000000000e+01 -1.5209400177001953e+01 1.9760000228881836e+01 9.0591102600097656e+01 -1.4683199882507324e+01 1.9760000228881836e+01 9.0709098815917969e+01 -1.4638500213623047e+01 1.9760000228881836e+01 9.1307106018066406e+01 -1.4411700248718262e+01 1.9760000228881836e+01 9.1495796203613281e+01 -1.4434599876403809e+01 1.9760000228881836e+01 9.2067398071289062e+01 -1.4503999710083008e+01 1.9760000228881836e+01 9.2276496887207031e+01 -1.4648400306701660e+01 1.9760000228881836e+01 9.2697601318359375e+01 -1.4939000129699707e+01 1.9760000228881836e+01 9.2845596313476562e+01 -1.5220999717712402e+01 1.9760000228881836e+01 9.3053497314453125e+01 -1.5617099761962891e+01 1.9760000228881836e+01 9.3053497314453125e+01 -1.6000000000000000e+01 1.9760000228881836e+01 9.3053497314453125e+01 -1.6382898330688477e+01 1.9760000228881836e+01 9.2845596313476562e+01 -1.6778999328613281e+01 1.9760000228881836e+01 9.2697601318359375e+01 -1.7061000823974609e+01 1.9760000228881836e+01 9.2276496887207031e+01 -1.7351598739624023e+01 1.9760000228881836e+01 9.2067398071289062e+01 -1.7495998382568359e+01 1.9760000228881836e+01 9.1495796203613281e+01 -1.7565399169921875e+01 1.9760000228881836e+01 9.1307106018066406e+01 -1.7588300704956055e+01 1.9760000228881836e+01 9.0709098815917969e+01 -1.7361499786376953e+01 1.9760000228881836e+01 9.0591102600097656e+01 -1.7316799163818359e+01 1.9760000228881836e+01 9.0125000000000000e+01 -1.6790599822998047e+01 1.9760000228881836e+01 9.0083297729492188e+01 -1.6743600845336914e+01 1.9760000228881836e+01 8.9900001525878906e+01 -1.6000000000000000e+01 1.9760000228881836e+01 5.2583297729492188e+01 -1.5256400108337402e+01 1.9760000228881836e+01 5.2625000000000000e+01 -1.5209400177001953e+01 1.9760000228881836e+01 5.3091102600097656e+01 -1.4683199882507324e+01 1.9760000228881836e+01 5.3209098815917969e+01 -1.4638500213623047e+01 1.9760000228881836e+01 5.3807098388671875e+01 -1.4411700248718262e+01 1.9760000228881836e+01 5.3995800018310547e+01 -1.4434599876403809e+01 1.9760000228881836e+01 5.4567401885986328e+01 -1.4503999710083008e+01 1.9760000228881836e+01 5.4776500701904297e+01 -1.4648400306701660e+01 1.9760000228881836e+01 5.5197601318359375e+01 -1.4939000129699707e+01 1.9760000228881836e+01 5.5345600128173828e+01 -1.5220999717712402e+01 1.9760000228881836e+01 5.5553501129150391e+01 -1.5617099761962891e+01 1.9760000228881836e+01 5.5553501129150391e+01 -1.6000000000000000e+01 1.9760000228881836e+01 5.5553501129150391e+01 -1.6382898330688477e+01 1.9760000228881836e+01 5.5345600128173828e+01 -1.6778999328613281e+01 1.9760000228881836e+01 5.5197601318359375e+01 -1.7061000823974609e+01 1.9760000228881836e+01 5.4776500701904297e+01 -1.7351598739624023e+01 1.9760000228881836e+01 5.4567401885986328e+01 -1.7495998382568359e+01 1.9760000228881836e+01 5.3995800018310547e+01 -1.7565399169921875e+01 1.9760000228881836e+01 5.3807098388671875e+01 -1.7588300704956055e+01 1.9760000228881836e+01 5.3209098815917969e+01 -1.7361499786376953e+01 1.9760000228881836e+01 5.3091102600097656e+01 -1.7316799163818359e+01 1.9760000228881836e+01 5.2625000000000000e+01 -1.6790599822998047e+01 1.9760000228881836e+01 5.2583297729492188e+01 -1.6743600845336914e+01 1.9760000228881836e+01 5.2400001525878906e+01 -1.6000000000000000e+01 1.9760000228881836e+01 5.2583297729492188e+01 4.1743598937988281e+01 1.9760000228881836e+01 5.2625000000000000e+01 4.1790599822998047e+01 1.9760000228881836e+01 5.3091102600097656e+01 4.2316802978515625e+01 1.9760000228881836e+01 5.3209098815917969e+01 4.2361499786376953e+01 1.9760000228881836e+01 5.3807098388671875e+01 4.2588302612304688e+01 1.9760000228881836e+01 5.3995800018310547e+01 4.2565402984619141e+01 1.9760000228881836e+01 5.4567401885986328e+01 4.2495998382568359e+01 1.9760000228881836e+01 5.4776500701904297e+01 4.2351600646972656e+01 1.9760000228881836e+01 5.5197601318359375e+01 4.2061000823974609e+01 1.9760000228881836e+01 5.5345600128173828e+01 4.1778999328613281e+01 1.9760000228881836e+01 5.5553501129150391e+01 4.1382900238037109e+01 1.9760000228881836e+01 5.5553501129150391e+01 4.1000000000000000e+01 1.9760000228881836e+01 5.5553501129150391e+01 4.0617099761962891e+01 1.9760000228881836e+01 5.5345600128173828e+01 4.0220996856689453e+01 1.9760000228881836e+01 5.5197601318359375e+01 3.9939002990722656e+01 1.9760000228881836e+01 5.4776500701904297e+01 3.9648399353027344e+01 1.9760000228881836e+01 5.4567401885986328e+01 3.9503997802734375e+01 1.9760000228881836e+01 5.3995800018310547e+01 3.9434600830078125e+01 1.9760000228881836e+01 5.3807098388671875e+01 3.9411701202392578e+01 1.9760000228881836e+01 5.3209098815917969e+01 3.9638500213623047e+01 1.9760000228881836e+01 5.3091102600097656e+01 3.9683200836181641e+01 1.9760000228881836e+01 5.2625000000000000e+01 4.0209400177001953e+01 1.9760000228881836e+01 5.2583297729492188e+01 4.0256401062011719e+01 1.9760000228881836e+01 5.2400001525878906e+01 4.1000000000000000e+01 1.9760000228881836e+01 1.0964600563049316e+01 -8.4148006439208984e+00 -1.6226699352264404e+00 1.0964600563049316e+01 -8.4699993133544922e+00 -2.5000000000000000e+00 5.5964599609375000e+01 -8.4699993133544922e+00 -2.5000000000000000e+00 5.5964599609375000e+01 -8.4148006439208984e+00 -3.3773300647735596e+00 5.5964599609375000e+01 -8.4148006439208984e+00 -1.6226699352264404e+00 5.5964599609375000e+01 -7.9784402847290039e+00 7.6873794198036194e-02 1.0964600563049316e+01 -7.9784402847290039e+00 7.6873794198036194e-02 5.5964599609375000e+01 -7.1331200599670410e+00 1.6144899129867554e+00 1.0964600563049316e+01 -7.1331200599670410e+00 1.6144899129867554e+00 5.5964599609375000e+01 -5.9319701194763184e+00 2.8935899734497070e+00 1.0964600563049316e+01 -5.9319701194763184e+00 2.8935899734497070e+00 5.5964599609375000e+01 -4.4504504203796387e+00 3.8337900638580322e+00 1.0964600563049316e+01 -4.4504504203796387e+00 3.8337900638580322e+00 5.5964599609375000e+01 -2.7816700935363770e+00 4.3760099411010742e+00 1.0964600563049316e+01 -2.7816700935363770e+00 4.3760099411010742e+00 5.5964599609375000e+01 -1.0304700136184692e+00 4.4861903190612793e+00 1.0964600563049316e+01 -1.0304700136184692e+00 4.4861903190612793e+00 5.5964599609375000e+01 6.9311898946762085e-01 4.1573901176452637e+00 1.0964600563049316e+01 6.9311898946762085e-01 4.1573901176452637e+00 5.5964599609375000e+01 2.2807898521423340e+00 3.4102900028228760e+00 1.0964600563049316e+01 2.2807898521423340e+00 3.4102900028228760e+00 5.5964599609375000e+01 3.6327798366546631e+00 2.2918300628662109e+00 1.0964600563049316e+01 3.6327798366546631e+00 2.2918300628662109e+00 5.5964599609375000e+01 4.6641502380371094e+00 8.7227600812911987e-01 1.0964600563049316e+01 4.6641502380371094e+00 8.7227600812911987e-01 5.5964599609375000e+01 5.3100800514221191e+00 -7.5917094945907593e-01 1.0964600563049316e+01 5.3100800514221191e+00 -7.5917094945907593e-01 5.5964599609375000e+01 5.5300002098083496e+00 -2.5000000000000000e+00 1.0964600563049316e+01 5.5300002098083496e+00 -2.5000000000000000e+00 5.5964599609375000e+01 5.3100800514221191e+00 -4.2408299446105957e+00 1.0964600563049316e+01 5.3100800514221191e+00 -4.2408299446105957e+00 5.5964599609375000e+01 4.6641502380371094e+00 -5.8722796440124512e+00 1.0964600563049316e+01 4.6641502380371094e+00 -5.8722796440124512e+00 5.5964599609375000e+01 3.6327798366546631e+00 -7.2918300628662109e+00 1.0964600563049316e+01 3.6327798366546631e+00 -7.2918300628662109e+00 5.5964599609375000e+01 2.2807898521423340e+00 -8.4102897644042969e+00 1.0964600563049316e+01 2.2807898521423340e+00 -8.4102897644042969e+00 5.5964599609375000e+01 6.9311898946762085e-01 -9.1573905944824219e+00 1.0964600563049316e+01 6.9311898946762085e-01 -9.1573905944824219e+00 5.5964599609375000e+01 -1.0304700136184692e+00 -9.4861898422241211e+00 1.0964600563049316e+01 -1.0304700136184692e+00 -9.4861898422241211e+00 5.5964599609375000e+01 -2.7816700935363770e+00 -9.3760099411010742e+00 1.0964600563049316e+01 -2.7816700935363770e+00 -9.3760099411010742e+00 5.5964599609375000e+01 -4.4504504203796387e+00 -8.8337898254394531e+00 1.0964600563049316e+01 -4.4504504203796387e+00 -8.8337898254394531e+00 5.5964599609375000e+01 -5.9319701194763184e+00 -7.8935904502868652e+00 1.0964600563049316e+01 -5.9319701194763184e+00 -7.8935904502868652e+00 5.5964599609375000e+01 -7.1331200599670410e+00 -6.6144900321960449e+00 1.0964600563049316e+01 -7.1331200599670410e+00 -6.6144900321960449e+00 5.5964599609375000e+01 -7.9784402847290039e+00 -5.0768699645996094e+00 1.0964600563049316e+01 -7.9784402847290039e+00 -5.0768699645996094e+00 1.0964600563049316e+01 -8.4148006439208984e+00 -3.3773300647735596e+00 1.0853800201416016e+02 9.3805198669433594e+00 9.8109197616577148e+00 1.0853800201416016e+02 1.0394000053405762e+01 1.2351400375366211e+01 1.0853800201416016e+02 1.1922499656677246e+01 1.0186900138854980e+01 1.0853800201416016e+02 1.3158800125122070e+01 1.2485500335693359e+01 1.0853800201416016e+02 1.4488200187683105e+01 1.0043400764465332e+01 1.0853800201416016e+02 1.5901200294494629e+01 1.2109299659729004e+01 1.0853800201416016e+02 1.6972501754760742e+01 9.3864097595214844e+00 1.0853800201416016e+02 1.8527700424194336e+01 1.1235600471496582e+01 1.0853800201416016e+02 1.9273700714111328e+01 8.2427997589111328e+00 1.0853800201416016e+02 2.0949001312255859e+01 9.8941297531127930e+00 1.0853800201416016e+02 2.1297498703002930e+01 6.6593599319458008e+00 1.0853800201416016e+02 2.3082601547241211e+01 8.1305999755859375e+00 1.0853800201416016e+02 2.2961198806762695e+01 4.7009401321411133e+00 1.0853800201416016e+02 2.4855699539184570e+01 6.0050597190856934e+00 1.0853800201416016e+02 2.4196599960327148e+01 2.4477198123931885e+00 1.0853800201416016e+02 2.6208101272583008e+01 3.5898799896240234e+00 1.0853800201416016e+02 2.4953100204467773e+01 -8.0642700195312500e-03 1.0853800201416016e+02 2.7093799591064453e+01 9.6732300519943237e-01 1.0853800201416016e+02 2.5199800491333008e+01 -2.5658600330352783e+00 1.0853800201416016e+02 2.7482398986816406e+01 -1.7733100652694702e+00 1.0853800201416016e+02 2.4926599502563477e+01 -5.1209802627563477e+00 1.0853800201416016e+02 2.7360799789428711e+01 -4.5386900901794434e+00 1.0853800201416016e+02 2.4144599914550781e+01 -7.5687799453735352e+00 1.0853800201416016e+02 2.6733200073242188e+01 -7.2346401214599609e+00 1.0853800201416016e+02 2.5620800018310547e+01 -9.7693595886230469e+00 1.0853800201416016e+02 2.2885900497436523e+01 -9.8090705871582031e+00 1.0853800201416016e+02 2.4061700820922852e+01 -1.2056499481201172e+01 1.0853800201416016e+02 2.1201999664306641e+01 -1.1750100135803223e+01 1.0853800201416016e+02 2.2108800888061523e+01 -1.4018300056457520e+01 1.0853800201416016e+02 1.9161899566650391e+01 -1.3312500000000000e+01 1.0853800201416016e+02 1.9828699111938477e+01 -1.5587800025939941e+01 1.0853800201416016e+02 1.6848899841308594e+01 -1.4432200431823730e+01 1.0853800201416016e+02 1.7299100875854492e+01 -1.6711599349975586e+01 1.0853800201416016e+02 1.4357999801635742e+01 -1.5063400268554688e+01 1.0853800201416016e+02 1.4605999946594238e+01 -1.7351400375366211e+01 1.0853800201416016e+02 1.1791000366210938e+01 -1.5180200576782227e+01 1.0853800201416016e+02 1.1841199874877930e+01 -1.7485500335693359e+01 1.0853800201416016e+02 9.2529897689819336e+00 -1.4777899742126465e+01 1.0853800201416016e+02 9.0988206863403320e+00 -1.7109298706054688e+01 1.0853800201416016e+02 6.8479299545288086e+00 -1.3873000144958496e+01 1.0853800201416016e+02 6.4722795486450195e+00 -1.6235599517822266e+01 1.0853800201416016e+02 4.6742696762084961e+00 -1.2502400398254395e+01 1.0853800201416016e+02 4.0510101318359375e+00 -1.4894100189208984e+01 1.0853800201416016e+02 2.8210000991821289e+00 -1.0722299575805664e+01 1.0853800201416016e+02 1.9174499511718750e+00 -1.3130599975585938e+01 1.0853800201416016e+02 2.0388200283050537e+00 -9.7009401321411133e+00 1.0853800201416016e+02 1.4427100121974945e-01 -1.1005100250244141e+01 1.0853800201416016e+02 1.3639800548553467e+00 -8.6056594848632812e+00 1.0853800201416016e+02 -1.2081499099731445e+00 -8.5898799896240234e+00 1.0853800201416016e+02 3.6287599802017212e-01 -6.2390098571777344e+00 1.0853800201416016e+02 -2.0937500000000000e+00 -5.9673199653625488e+00 1.0853800201416016e+02 -1.4133401215076447e-01 -3.7192900180816650e+00 1.0853800201416016e+02 -2.4823899269104004e+00 -3.2266900539398193e+00 1.0853800201416016e+02 -1.2800699472427368e-01 -1.1496499776840210e+00 1.0853800201416016e+02 -2.3608100414276123e+00 -4.6131098270416260e-01 1.0853800201416016e+02 4.0231299400329590e-01 1.3647100925445557e+00 1.0853800201416016e+02 -1.7331700325012207e+00 2.2346401214599609e+00 1.0853800201416016e+02 1.4279100894927979e+00 3.7208399772644043e+00 1.0853800201416016e+02 -6.2083500623703003e-01 4.7693600654602051e+00 1.0853800201416016e+02 2.9068100452423096e+00 5.8222999572753906e+00 1.0853800201416016e+02 9.3831402063369751e-01 7.0565400123596191e+00 1.0853800201416016e+02 4.7784500122070312e+00 7.5830397605895996e+00 1.0853800201416016e+02 2.8911800384521484e+00 9.0182704925537109e+00 1.0853800201416016e+02 6.9662098884582520e+00 8.9309701919555664e+00 1.0853800201416016e+02 5.1712698936462402e+00 1.0587800025939941e+01 1.0853800201416016e+02 7.7009301185607910e+00 1.1711600303649902e+01 1.1555100250244141e+02 1.4451301097869873e-01 -1.1003999710083008e+01 1.1554399871826172e+02 8.3785995841026306e-02 -1.0916500091552734e+01 1.1563600158691406e+02 -9.4712197780609131e-02 -1.0646999359130859e+01 1.1568099975585938e+02 -1.2884300947189331e-01 -1.0593100547790527e+01 1.1582899475097656e+02 -2.4181799590587616e-01 -1.0414899826049805e+01 1.1604399871826172e+02 -3.2196399569511414e-01 -1.0284000396728516e+01 1.1610200500488281e+02 -3.4364700317382812e-01 -1.0248600006103516e+01 1.1642400360107422e+02 -3.9186298847198486e-01 -1.0168099403381348e+01 1.1653800201416016e+02 -3.8872399926185608e-01 -1.0173399925231934e+01 1.1675900268554688e+02 -3.8263800740242004e-01 -1.0183599472045898e+01 1.4068800354003906e+02 -1.2081499099731445e+00 -8.5898799896240234e+00 1.1703600311279297e+02 -3.2350200414657593e-01 -1.0281800270080566e+01 1.1706900024414062e+02 -3.1644198298454285e-01 -1.0293499946594238e+01 1.1731999969482422e+02 -1.9879099726676941e-01 -1.0483800888061523e+01 1.1740000152587891e+02 4.3384698033332825e-01 -1.1410699844360352e+01 1.1738899993896484e+02 4.4962099194526672e-01 -1.1432399749755859e+01 1.4068800354003906e+02 1.9174499511718750e+00 -1.3130599975585938e+01 1.1739200592041016e+02 -1.2812799215316772e-01 -1.0593799591064453e+01 1.1748200225830078e+02 -4.0173299610614777e-02 -1.0730699539184570e+01 1.4068800354003906e+02 1.4427100121974945e-01 -1.1005100250244141e+01 1.1753799438476562e+02 1.4427100121974945e-01 -1.1005100250244141e+01 1.1751499938964844e+02 2.6665598154067993e-01 -1.1180199623107910e+01 1.1716799926757812e+02 6.0152399539947510e-01 -1.1633800506591797e+01 1.1703099822998047e+02 6.4857399463653564e-01 -1.1694399833679199e+01 1.1687599945068359e+02 7.0241099596023560e-01 -1.1763700485229492e+01 1.1654599761962891e+02 7.3874604701995850e-01 -1.1809800148010254e+01 1.1653900146484375e+02 7.3803097009658813e-01 -1.1808899879455566e+01 1.1621399688720703e+02 7.0525199174880981e-01 -1.1767400741577148e+01 1.1604499816894531e+02 6.4859300851821899e-01 -1.1694399833679199e+01 1.1591899871826172e+02 6.0644602775573730e-01 -1.1640200614929199e+01 1.1569400024414062e+02 4.5627298951148987e-01 -1.1441400527954102e+01 1.1567799377441406e+02 4.3349298834800720e-01 -1.1409999847412109e+01 1.1556500244140625e+02 2.7469101548194885e-01 -1.1191500663757324e+01 1.1555100250244141e+02 1.4493899047374725e-01 -1.1004599571228027e+01 1.4068800354003906e+02 4.0510101318359375e+00 -1.4894100189208984e+01 1.4068800354003906e+02 6.4722795486450195e+00 -1.6235599517822266e+01 1.4068800354003906e+02 9.0988206863403320e+00 -1.7109298706054688e+01 1.4068800354003906e+02 1.1841199874877930e+01 -1.7485500335693359e+01 1.4068800354003906e+02 1.4605999946594238e+01 -1.7351400375366211e+01 1.4068800354003906e+02 1.7299100875854492e+01 -1.6711599349975586e+01 1.4068800354003906e+02 1.9828699111938477e+01 -1.5587800025939941e+01 1.4068800354003906e+02 2.2108800888061523e+01 -1.4018300056457520e+01 1.4068800354003906e+02 2.4061700820922852e+01 -1.2056499481201172e+01 1.4068800354003906e+02 2.5620800018310547e+01 -9.7693595886230469e+00 1.4068800354003906e+02 2.6733200073242188e+01 -7.2346401214599609e+00 1.4068800354003906e+02 2.7360799789428711e+01 -4.5386900901794434e+00 1.4068800354003906e+02 2.7482398986816406e+01 -1.7733100652694702e+00 1.4068800354003906e+02 2.7093799591064453e+01 9.6732300519943237e-01 1.4068800354003906e+02 2.6208101272583008e+01 3.5898799896240234e+00 1.4068800354003906e+02 2.4855699539184570e+01 6.0050597190856934e+00 1.4068800354003906e+02 2.3082601547241211e+01 8.1305999755859375e+00 1.4068800354003906e+02 2.0949001312255859e+01 9.8941297531127930e+00 1.4068800354003906e+02 1.8527700424194336e+01 1.1235600471496582e+01 1.4068800354003906e+02 1.5901200294494629e+01 1.2109299659729004e+01 1.4068800354003906e+02 1.3158800125122070e+01 1.2485500335693359e+01 1.4068800354003906e+02 1.0394000053405762e+01 1.2351400375366211e+01 1.4068800354003906e+02 7.7009301185607910e+00 1.1711600303649902e+01 1.4068800354003906e+02 5.1712698936462402e+00 1.0587800025939941e+01 1.4068800354003906e+02 2.8911800384521484e+00 9.0182704925537109e+00 1.4068800354003906e+02 9.3831402063369751e-01 7.0565400123596191e+00 1.4068800354003906e+02 -6.2083500623703003e-01 4.7693600654602051e+00 1.4068800354003906e+02 -1.7331700325012207e+00 2.2346401214599609e+00 1.4068800354003906e+02 -2.3608100414276123e+00 -4.6131098270416260e-01 1.4068800354003906e+02 -2.4823899269104004e+00 -3.2266900539398193e+00 1.4068800354003906e+02 -2.0937500000000000e+00 -5.9673199653625488e+00 1.4068800354003906e+02 7.6539605855941772e-02 -9.4111194610595703e+00 1.4068800354003906e+02 1.6089900732040405e+00 -1.1637399673461914e+01 1.4068800354003906e+02 3.5350599288940430e+00 -1.3533400535583496e+01 1.4068800354003906e+02 5.7851500511169434e+00 -1.5030600547790527e+01 1.4068800354003906e+02 8.2779397964477539e+00 -1.6075000762939453e+01 1.4068800354003906e+02 1.0923299789428711e+01 -1.6628700256347656e+01 1.4068800354003906e+02 1.3625699996948242e+01 -1.6671798706054688e+01 1.4068800354003906e+02 1.6287399291992188e+01 -1.6202600479125977e+01 1.4068800354003906e+02 1.8812200546264648e+01 -1.5238200187683105e+01 1.4068800354003906e+02 2.1108800888061523e+01 -1.3813500404357910e+01 1.4068800354003906e+02 2.3094299316406250e+01 -1.1979799270629883e+01 1.4068800354003906e+02 2.4696899414062500e+01 -9.8034706115722656e+00 1.4068800354003906e+02 2.5858699798583984e+01 -7.3632001876831055e+00 1.4068800354003906e+02 2.6537698745727539e+01 -4.7471699714660645e+00 1.4068800354003906e+02 2.6709299087524414e+01 -2.0499098300933838e+00 1.4068800354003906e+02 2.6367300033569336e+01 6.3107299804687500e-01 1.4068800354003906e+02 2.5524200439453125e+01 3.1988999843597412e+00 1.4068800354003906e+02 2.4210300445556641e+01 5.5607500076293945e+00 1.4068800354003906e+02 2.2473100662231445e+01 7.6312599182128906e+00 1.4068800354003906e+02 2.0375600814819336e+01 9.3355998992919922e+00 1.4068800354003906e+02 1.7993299484252930e+01 1.0612199783325195e+01 1.4068800354003906e+02 1.5412599563598633e+01 1.1414799690246582e+01 1.4068800354003906e+02 1.2726499557495117e+01 1.1714599609375000e+01 1.4068800354003906e+02 1.0032299995422363e+01 1.1500599861145020e+01 1.4068800354003906e+02 7.4272699356079102e+00 1.0780599594116211e+01 1.4068800354003906e+02 5.0055799484252930e+00 9.5805397033691406e+00 1.4068800354003906e+02 2.8547499179840088e+00 7.9439001083374023e+00 1.4068800354003906e+02 1.0525300502777100e+00 5.9297900199890137e+00 1.4068800354003906e+02 -3.3594399690628052e-01 3.6110100746154785e+00 1.4068800354003906e+02 -1.2605000734329224e+00 1.0713599920272827e+00 1.4068800354003906e+02 -1.6877100467681885e+00 -1.5973700284957886e+00 1.4068800354003906e+02 -1.6021500825881958e+00 -4.2987298965454102e+00 1.4068800354003906e+02 -1.0068899393081665e+00 -6.9350700378417969e+00 1.0553800201416016e+02 1.3639800548553467e+00 -8.6056594848632812e+00 1.0553800201416016e+02 2.0388200283050537e+00 -9.7009401321411133e+00 1.0553800201416016e+02 3.6287599802017212e-01 -6.2390098571777344e+00 1.0553800201416016e+02 -1.4133401215076447e-01 -3.7192900180816650e+00 1.0553800201416016e+02 -1.2800699472427368e-01 -1.1496499776840210e+00 1.0553800201416016e+02 4.0231299400329590e-01 1.3647100925445557e+00 1.0553800201416016e+02 1.4279100894927979e+00 3.7208399772644043e+00 1.0553800201416016e+02 2.9068100452423096e+00 5.8222999572753906e+00 1.0553800201416016e+02 4.7784500122070312e+00 7.5830397605895996e+00 1.0553800201416016e+02 6.9662098884582520e+00 8.9309701919555664e+00 1.0553800201416016e+02 9.3805198669433594e+00 9.8109197616577148e+00 1.0553800201416016e+02 1.1922499656677246e+01 1.0186900138854980e+01 1.0553800201416016e+02 1.4488200187683105e+01 1.0043400764465332e+01 1.0553800201416016e+02 1.6972501754760742e+01 9.3864097595214844e+00 1.0553800201416016e+02 1.9273700714111328e+01 8.2427997589111328e+00 1.0553800201416016e+02 2.1297498703002930e+01 6.6593599319458008e+00 1.0553800201416016e+02 2.2961198806762695e+01 4.7009401321411133e+00 1.0553800201416016e+02 2.4196599960327148e+01 2.4477198123931885e+00 1.0553800201416016e+02 2.4953100204467773e+01 -8.0642700195312500e-03 1.0553800201416016e+02 2.5199800491333008e+01 -2.5658600330352783e+00 1.0553800201416016e+02 2.4926599502563477e+01 -5.1209802627563477e+00 1.0553800201416016e+02 2.4144599914550781e+01 -7.5687799453735352e+00 1.0553800201416016e+02 2.2885900497436523e+01 -9.8090705871582031e+00 1.0553800201416016e+02 2.1201999664306641e+01 -1.1750100135803223e+01 1.0553800201416016e+02 1.9161899566650391e+01 -1.3312500000000000e+01 1.0553800201416016e+02 1.6848899841308594e+01 -1.4432200431823730e+01 1.0553800201416016e+02 1.4357999801635742e+01 -1.5063400268554688e+01 1.0553800201416016e+02 1.1791000366210938e+01 -1.5180200576782227e+01 1.0553800201416016e+02 9.2529897689819336e+00 -1.4777899742126465e+01 1.0553800201416016e+02 6.8479299545288086e+00 -1.3873000144958496e+01 1.0553800201416016e+02 4.6742696762084961e+00 -1.2502400398254395e+01 1.0553800201416016e+02 2.8210000991821289e+00 -1.0722299575805664e+01 1.1603800201416016e+02 3.7718100547790527e+00 -7.4566798210144043e+00 1.1567199707031250e+02 3.9793500900268555e+00 -7.7581801414489746e+00 1.1553800201416016e+02 4.2628502845764160e+00 -8.1700401306152344e+00 1.1703799438476562e+02 4.7538900375366211e+00 -8.8833894729614258e+00 1.1740399932861328e+02 4.5463500022888184e+00 -8.5818901062011719e+00 1.1753799438476562e+02 4.2628502845764160e+00 -8.1700401306152344e+00 1.1653800201416016e+02 4.8298501968383789e+00 -8.9937505722045898e+00 1.1603800201416016e+02 4.7538900375366211e+00 -8.8833894729614258e+00 1.1567199707031250e+02 4.5463500022888184e+00 -8.5818901062011719e+00 1.1653800201416016e+02 3.6958401203155518e+00 -7.3463201522827148e+00 1.1703799438476562e+02 3.7718100547790527e+00 -7.4566798210144043e+00 1.1740399932861328e+02 3.9793500900268555e+00 -7.7581801414489746e+00 1.3863200378417969e+02 2.3668498992919922e+01 5.1878399848937988e+00 1.3863200378417969e+02 2.1128201484680176e+00 -1.1214699745178223e+01 1.3863200378417969e+02 2.4921600341796875e+01 2.9352600574493408e+00 1.3863200378417969e+02 3.9498000144958496e+00 -1.3022999763488770e+01 1.3863200378417969e+02 2.5725801467895508e+01 4.8622900247573853e-01 1.3863200378417969e+02 6.0957899093627930e+00 -1.4450900077819824e+01 1.3863200378417969e+02 2.6051898956298828e+01 -2.0707299709320068e+00 1.3863200378417969e+02 8.4732599258422852e+00 -1.5447000503540039e+01 1.3863200378417969e+02 2.5888299942016602e+01 -4.6432104110717773e+00 1.3863200378417969e+02 1.0996299743652344e+01 -1.5975100517272949e+01 1.3863200378417969e+02 2.5240699768066406e+01 -7.1382203102111816e+00 1.3863200378417969e+02 1.3573599815368652e+01 -1.6016099929809570e+01 1.3863200378417969e+02 2.4132699966430664e+01 -9.4656000137329102e+00 1.3863200378417969e+02 1.6112201690673828e+01 -1.5568699836730957e+01 1.3863200378417969e+02 2.2604198455810547e+01 -1.1541199684143066e+01 1.3863200378417969e+02 1.8520099639892578e+01 -1.4648900032043457e+01 1.3863200378417969e+02 2.0710599899291992e+01 -1.3290100097656250e+01 1.3863200378417969e+02 1.2715999603271484e+01 1.1056999206542969e+01 1.3863200378417969e+02 1.0146499633789062e+01 1.0852900505065918e+01 1.3863200378417969e+02 7.6619400978088379e+00 1.0166199684143066e+01 1.3863200378417969e+02 1.5277800559997559e+01 1.0771100044250488e+01 1.3863200378417969e+02 1.7739198684692383e+01 1.0005599975585938e+01 1.3863200378417969e+02 2.0011199951171875e+01 8.7880697250366211e+00 1.3863200378417969e+02 2.2011798858642578e+01 7.1625699996948242e+00 1.3863200378417969e+02 5.3522801399230957e+00 9.0216798782348633e+00 1.3863200378417969e+02 3.3009598255157471e+00 7.4607501029968262e+00 1.3863200378417969e+02 1.5821199417114258e+00 5.5398201942443848e+00 1.3863200378417969e+02 2.5787100195884705e-01 3.3282999992370605e+00 1.3863200378417969e+02 -6.2391096353530884e-01 9.0614300966262817e-01 1.3863200378417969e+02 -3.8203501701354980e-01 -6.7298998832702637e+00 1.3863200378417969e+02 6.5127301216125488e-01 -9.0913906097412109e+00 1.3863200378417969e+02 -9.4975298643112183e-01 -4.2155199050903320e+00 1.3863200378417969e+02 -1.0313600301742554e+00 -1.6391299962997437e+00 1.0150000000000000e+02 -6.0001401901245117e+00 1.1540900230407715e+01 1.0150000000000000e+02 -5.2636799812316895e+00 1.2978799819946289e+01 1.0150000000000000e+02 -5.7261495590209961e+00 1.3159699440002441e+01 1.0150000000000000e+02 -5.3486199378967285e+00 1.0587599754333496e+01 1.0150000000000000e+02 -3.7313299179077148e+00 1.0585900306701660e+01 1.0150000000000000e+02 -3.7911698818206787e+00 1.1078899383544922e+01 1.0150000000000000e+02 -7.1515197753906250e+00 1.1453299522399902e+01 1.0150000000000000e+02 -8.0969600677490234e+00 1.2763299942016602e+01 1.0150000000000000e+02 -8.4754304885864258e+00 1.2441800117492676e+01 1.0150000000000000e+02 -6.9998602867126465e+00 9.4590997695922852e+00 1.0150000000000000e+02 -7.5091500282287598e+00 7.9203600883483887e+00 1.0150000000000000e+02 -7.0323200225830078e+00 7.7816300392150879e+00 1.0150000000000000e+02 -7.6671700477600098e+00 1.3012100219726562e+01 1.0150000000000000e+02 -7.1998600959777832e+00 1.3180100440979004e+01 1.0150000000000000e+02 -6.7100501060485840e+00 1.3262000083923340e+01 1.0150000000000000e+02 -6.2135000228881836e+00 1.3255099296569824e+01 1.0150000000000000e+02 -4.8409399986267090e+00 1.2718199729919434e+01 1.0150000000000000e+02 -4.4715304374694824e+00 1.2386300086975098e+01 1.0150000000000000e+02 -4.1673097610473633e+00 1.1993800163269043e+01 1.0150000000000000e+02 -3.9380700588226318e+00 1.1553299903869629e+01 1.0150000000000000e+02 -3.7604801654815674e+00 1.0090200424194336e+01 1.0150000000000000e+02 -3.8776900768280029e+00 9.6076002120971680e+00 1.0150000000000000e+02 -4.0791702270507812e+00 9.1537199020385742e+00 1.0150000000000000e+02 -5.8484797477722168e+00 9.5466594696044922e+00 1.0150000000000000e+02 -4.3584604263305664e+00 8.7431001663208008e+00 1.0150000000000000e+02 -4.7065901756286621e+00 8.3889398574829102e+00 1.0150000000000000e+02 -5.1123499870300293e+00 8.1026391983032227e+00 1.0150000000000000e+02 -5.5627198219299316e+00 7.8933901786804199e+00 1.0150000000000000e+02 -6.0432100296020508e+00 7.7679200172424316e+00 1.0150000000000000e+02 -6.5383801460266113e+00 7.7302598953247070e+00 1.0150000000000000e+02 -9.2498207092285156e+00 1.0166199684143066e+01 1.0150000000000000e+02 -9.1460304260253906e+00 9.6806001663208008e+00 1.0150000000000000e+02 -7.6513795852661133e+00 1.0412399291992188e+01 1.0150000000000000e+02 -8.9572000503540039e+00 9.2213096618652344e+00 1.0150000000000000e+02 -7.9535403251647949e+00 8.1420106887817383e+00 1.0150000000000000e+02 -8.3512201309204102e+00 8.4394493103027344e+00 1.0150000000000000e+02 -8.6893892288208008e+00 8.8031005859375000e+00 1.0150000000000000e+02 -9.2652196884155273e+00 1.0662600517272949e+01 1.0150000000000000e+02 -9.1917495727539062e+00 1.1153699874877930e+01 1.0150000000000000e+02 -9.0317592620849609e+00 1.1623900413513184e+01 1.0150000000000000e+02 -8.7903995513916016e+00 1.2057900428771973e+01 1.0091000366210938e+02 -7.1998600959777832e+00 1.3180100440979004e+01 1.0091000366210938e+02 -6.7100501060485840e+00 1.3262000083923340e+01 1.0091000366210938e+02 -6.2135000228881836e+00 1.3255099296569824e+01 1.0091000366210938e+02 -5.7261495590209961e+00 1.3159699440002441e+01 1.0091000366210938e+02 -5.2636799812316895e+00 1.2978799819946289e+01 1.0091000366210938e+02 -4.8409399986267090e+00 1.2718199729919434e+01 1.0091000366210938e+02 -4.4715304374694824e+00 1.2386300086975098e+01 1.0091000366210938e+02 -4.1673097610473633e+00 1.1993800163269043e+01 1.0091000366210938e+02 -3.9380700588226318e+00 1.1553299903869629e+01 1.0091000366210938e+02 -3.7911698818206787e+00 1.1078899383544922e+01 1.0091000366210938e+02 -3.7313299179077148e+00 1.0585900306701660e+01 1.0091000366210938e+02 -3.7604801654815674e+00 1.0090200424194336e+01 1.0091000366210938e+02 -3.8776900768280029e+00 9.6076002120971680e+00 1.0091000366210938e+02 -4.0791702270507812e+00 9.1537199020385742e+00 1.0091000366210938e+02 -4.3584604263305664e+00 8.7431001663208008e+00 1.0091000366210938e+02 -4.7065901756286621e+00 8.3889398574829102e+00 1.0091000366210938e+02 -5.1123499870300293e+00 8.1026391983032227e+00 1.0091000366210938e+02 -5.5627198219299316e+00 7.8933901786804199e+00 1.0091000366210938e+02 -6.0432100296020508e+00 7.7679200172424316e+00 1.0091000366210938e+02 -6.5383801460266113e+00 7.7302598953247070e+00 1.0091000366210938e+02 -7.0323200225830078e+00 7.7816300392150879e+00 1.0091000366210938e+02 -7.5091500282287598e+00 7.9203600883483887e+00 1.0091000366210938e+02 -7.9535403251647949e+00 8.1420106887817383e+00 1.0091000366210938e+02 -8.3512201309204102e+00 8.4394493103027344e+00 1.0091000366210938e+02 -8.6893892288208008e+00 8.8031005859375000e+00 1.0091000366210938e+02 -8.9572000503540039e+00 9.2213096618652344e+00 1.0091000366210938e+02 -9.1460304260253906e+00 9.6806001663208008e+00 1.0091000366210938e+02 -9.2498207092285156e+00 1.0166199684143066e+01 1.0091000366210938e+02 -9.2652196884155273e+00 1.0662600517272949e+01 1.0091000366210938e+02 -9.1917495727539062e+00 1.1153699874877930e+01 1.0091000366210938e+02 -9.0317592620849609e+00 1.1623900413513184e+01 1.0091000366210938e+02 -8.7903995513916016e+00 1.2057900428771973e+01 1.0091000366210938e+02 -8.4754304885864258e+00 1.2441800117492676e+01 1.0091000366210938e+02 -8.0969600677490234e+00 1.2763299942016602e+01 1.0091000366210938e+02 -7.6671700477600098e+00 1.3012100219726562e+01 9.9669296264648438e+01 -6.3419499397277832e+00 1.2020500183105469e+01 9.9669296264648438e+01 -6.0874300003051758e+00 1.1972599983215332e+01 9.9669296264648438e+01 -6.0732097625732422e+00 1.1967200279235840e+01 9.9669296264648438e+01 -5.8379898071289062e+00 1.1878600120544434e+01 9.9669296264648438e+01 -5.8183698654174805e+00 1.1866999626159668e+01 9.9669296264648438e+01 -5.6086602210998535e+00 1.1742699623107910e+01 9.9669296264648438e+01 -5.5855898857116699e+00 1.1722900390625000e+01 9.9669296264648438e+01 -5.4064097404479980e+00 1.1569000244140625e+01 9.9669296264648438e+01 -5.3822999000549316e+00 1.1539599418640137e+01 9.9669296264648438e+01 -5.2373900413513184e+00 1.1362899780273438e+01 9.9669296264648438e+01 -5.2150301933288574e+00 1.1323100090026855e+01 9.9669296264648438e+01 -5.1067399978637695e+00 1.1130499839782715e+01 9.9669296264648438e+01 -5.0890998840332031e+00 1.1080300331115723e+01 9.9669296264648438e+01 -5.0184202194213867e+00 1.0878999710083008e+01 9.9669296264648438e+01 -5.0085296630859375e+00 1.0818899154663086e+01 9.9669296264648438e+01 -4.9751100540161133e+00 1.0616000175476074e+01 9.9669296264648438e+01 -4.9758896827697754e+00 1.0547499656677246e+01 9.9669296264648438e+01 -4.9781398773193359e+00 1.0349400520324707e+01 9.9669296264648438e+01 -4.9922099113464355e+00 1.0274600028991699e+01 9.9669296264648438e+01 -5.0274100303649902e+00 1.0087399482727051e+01 9.9669296264648438e+01 -5.0569400787353516e+00 1.0009099960327148e+01 9.9669296264648438e+01 -5.1214299201965332e+00 9.8379898071289062e+00 9.9669296264648438e+01 -5.1679997444152832e+00 9.7594003677368164e+00 9.9669296264648438e+01 -5.2573299407958984e+00 9.6086597442626953e+00 9.9669296264648438e+01 -5.3217997550964355e+00 9.5335702896118164e+00 9.9669296264648438e+01 -5.4309802055358887e+00 9.4064102172851562e+00 9.9669296264648438e+01 -5.5134196281433105e+00 9.3388299942016602e+00 9.9669296264648438e+01 -5.6371297836303711e+00 9.2374000549316406e+00 9.9669296264648438e+01 -5.7366900444030762e+00 9.1814098358154297e+00 9.9669296264648438e+01 -5.8694796562194824e+00 9.1067399978637695e+00 9.9669296264648438e+01 -5.9844503402709961e+00 9.0663700103759766e+00 9.9669296264648438e+01 -6.1209998130798340e+00 9.0184202194213867e+00 9.9669296264648438e+01 -6.2487497329711914e+00 8.9973802566528320e+00 9.9669296264648438e+01 -6.3840298652648926e+00 8.9751100540161133e+00 9.9669296264648438e+01 -6.5211200714111328e+00 8.9766702651977539e+00 9.9669296264648438e+01 -7.0551300048828125e+00 9.0811500549316406e+00 9.9669296264648438e+01 -6.9125699996948242e+00 9.0274105072021484e+00 9.9669296264648438e+01 -6.7928199768066406e+00 9.0048904418945312e+00 9.9669296264648438e+01 -6.6505899429321289e+00 8.9781398773193359e+00 9.9669296264648438e+01 -7.5185003280639648e+00 9.3665103912353516e+00 9.9669296264648438e+01 -7.3913402557373047e+00 9.2573204040527344e+00 9.9669296264648438e+01 -7.2996401786804199e+00 9.2029800415039062e+00 9.9669296264648438e+01 -7.1620097160339355e+00 9.1214303970336914e+00 9.9669296264648438e+01 -7.8522200584411621e+00 9.7965002059936523e+00 9.9669296264648438e+01 -7.7626099586486816e+00 9.6371202468872070e+00 9.9669296264648438e+01 -7.7046899795532227e+00 9.5664806365966797e+00 9.9669296264648438e+01 -7.5935897827148438e+00 9.4309806823730469e+00 9.9669296264648438e+01 -8.0137596130371094e+00 1.0316500663757324e+01 9.9669296264648438e+01 -7.9815797805786133e+00 1.0121000289916992e+01 9.9669296264648438e+01 -7.9563698768615723e+00 1.0049200057983398e+01 9.9669296264648438e+01 -7.8932595252990723e+00 9.8694791793823242e+00 9.9669296264648438e+01 -7.9824299812316895e+00 1.0860199928283691e+01 9.9669296264648438e+01 -8.0218601226806641e+00 1.0650600433349609e+01 9.9669296264648438e+01 -8.0225496292114258e+00 1.0589699745178223e+01 9.9669296264648438e+01 -8.0248899459838867e+00 1.0383999824523926e+01 9.9669296264648438e+01 -7.7620601654052734e+00 1.1358599662780762e+01 9.9669296264648438e+01 -7.8785700798034668e+00 1.1161999702453613e+01 9.9669296264648438e+01 -7.8946695327758789e+00 1.1119299888610840e+01 9.9669296264648438e+01 -7.9725894927978516e+00 1.0912599563598633e+01 9.9669296264648438e+01 -7.3805103302001953e+00 1.1748099327087402e+01 9.9669296264648438e+01 -7.5690202713012695e+00 1.1593600273132324e+01 9.9669296264648438e+01 -7.5888299942016602e+00 1.1570500373840332e+01 9.9669296264648438e+01 -7.7426700592041016e+00 1.1391300201416016e+01 9.9669296264648438e+01 -6.8861699104309082e+00 1.1979100227355957e+01 9.9669296264648438e+01 -7.1305198669433594e+00 1.1893300056457520e+01 9.9669296264648438e+01 -7.1437697410583496e+00 1.1885800361633301e+01 9.9669296264648438e+01 -7.3628702163696289e+00 1.1762599945068359e+01 9.9669296264648438e+01 -6.3494100570678711e+00 1.2021900177001953e+01 9.9669296264648438e+01 -6.6159696578979492e+00 1.2024899482727051e+01 9.9669296264648438e+01 -6.8790001869201660e+00 1.1981599807739258e+01 9.9598602294921875e+01 -6.3522996902465820e+00 1.1992700576782227e+01 9.5780502319335938e+01 -6.2525000572204590e+00 1.1979400634765625e+01 9.5780502319335938e+01 -6.6137499809265137e+00 1.1995699882507324e+01 9.9598602294921875e+01 -5.9070696830749512e+00 1.1873399734497070e+01 9.5780502319335938e+01 -5.9056396484375000e+00 1.1877199172973633e+01 9.9598602294921875e+01 -6.0953302383422852e+00 1.1944399833679199e+01 9.9598602294921875e+01 -6.2534999847412109e+00 1.1974100112915039e+01 9.9598602294921875e+01 -5.8506698608398438e+00 1.1852200508117676e+01 9.9598602294921875e+01 -5.6257300376892090e+00 1.1718899726867676e+01 9.5780502319335938e+01 -5.5933198928833008e+00 1.1695000648498535e+01 9.9598602294921875e+01 -5.5952596664428711e+00 1.1692700386047363e+01 9.9598602294921875e+01 -5.4273600578308105e+00 1.1548499107360840e+01 9.5780502319335938e+01 -5.3336901664733887e+00 1.1443300247192383e+01 9.9598602294921875e+01 -5.1432600021362305e+00 1.1135900497436523e+01 9.5780502319335938e+01 -5.1418499946594238e+00 1.1136700630187988e+01 9.9598602294921875e+01 -5.2615799903869629e+00 1.1346399307250977e+01 9.9598602294921875e+01 -5.3380804061889648e+00 1.1439700126647949e+01 9.9598602294921875e+01 -5.1334199905395508e+00 1.1118399620056152e+01 9.9598602294921875e+01 -5.0467901229858398e+00 1.0871700286865234e+01 9.5780502319335938e+01 -5.0289301872253418e+00 1.0793199539184570e+01 9.9598602294921875e+01 -5.0063800811767578e+00 1.0432700157165527e+01 9.5780502319335938e+01 -5.0015101432800293e+00 1.0432600021362305e+01 9.9598602294921875e+01 -5.0043196678161621e+00 1.0613699913024902e+01 9.9598602294921875e+01 -5.0337300300598145e+00 1.0792399406433105e+01 9.9598602294921875e+01 -5.0072898864746094e+00 1.0352299690246582e+01 9.9598602294921875e+01 -5.0556197166442871e+00 1.0095299720764160e+01 9.5780502319335938e+01 -5.0611796379089355e+00 1.0076000213623047e+01 9.9598602294921875e+01 -5.0626997947692871e+00 1.0076600074768066e+01 9.9598602294921875e+01 -5.1478300094604492e+00 9.8506698608398438e+00 9.5780502319335938e+01 -5.2044601440429688e+00 9.7439699172973633e+00 9.9598602294921875e+01 -5.4252901077270508e+00 9.4578304290771484e+00 9.5780502319335938e+01 -5.4230399131774902e+00 9.4558906555175781e+00 9.9598602294921875e+01 -5.2811298370361328e+00 9.6257305145263672e+00 9.9598602294921875e+01 -5.2093396186828613e+00 9.7468595504760742e+00 9.9598602294921875e+01 -5.4514598846435547e+00 9.4273605346679688e+00 9.9598602294921875e+01 -5.6536498069763184e+00 9.2615699768066406e+00 9.5780502319335938e+01 -5.7041997909545898e+00 9.2284994125366211e+00 9.9598602294921875e+01 -5.7061901092529297e+00 9.2320299148559570e+00 9.9598602294921875e+01 -5.8815598487854004e+00 9.1334199905395508e+00 9.5780502319335938e+01 -6.0316200256347656e+00 9.0749998092651367e+00 9.9598602294921875e+01 -6.0334100723266602e+00 9.0801000595092773e+00 9.9598602294921875e+01 -6.1282601356506348e+00 9.0467901229858398e+00 9.5780502319335938e+01 -6.3862500190734863e+00 9.0043201446533203e+00 9.9598602294921875e+01 -6.3862500190734863e+00 9.0043201446533203e+00 9.9598602294921875e+01 -6.6476998329162598e+00 9.0072898864746094e+00 9.5780502319335938e+01 -6.7474999427795410e+00 9.0205602645874023e+00 9.9598602294921875e+01 -7.0929298400878906e+00 9.1265697479248047e+00 9.5780502319335938e+01 -7.0943598747253418e+00 9.1227798461914062e+00 9.9598602294921875e+01 -6.9046702384948730e+00 9.0556201934814453e+00 9.9598602294921875e+01 -6.7465000152587891e+00 9.0258703231811523e+00 9.9598602294921875e+01 -7.1493296623229980e+00 9.1478300094604492e+00 9.9598602294921875e+01 -7.3742699623107910e+00 9.2811298370361328e+00 9.5780502319335938e+01 -7.4066801071166992e+00 9.3050403594970703e+00 9.9598602294921875e+01 -7.4047398567199707e+00 9.3072900772094727e+00 9.9598602294921875e+01 -7.5726404190063477e+00 9.4514598846435547e+00 9.5780502319335938e+01 -7.6663098335266113e+00 9.5567502975463867e+00 9.9598602294921875e+01 -7.8567395210266113e+00 9.8640604019165039e+00 9.5780502319335938e+01 -7.8581495285034180e+00 9.8632707595825195e+00 9.9598602294921875e+01 -7.7384200096130371e+00 9.6536502838134766e+00 9.9598602294921875e+01 -7.6619200706481934e+00 9.5603399276733398e+00 9.9598602294921875e+01 -7.8665800094604492e+00 9.8815593719482422e+00 9.9598602294921875e+01 -7.9532098770141602e+00 1.0128299713134766e+01 9.5780502319335938e+01 -7.9710698127746582e+00 1.0206799507141113e+01 9.9598602294921875e+01 -7.9936199188232422e+00 1.0567299842834473e+01 9.5780502319335938e+01 -7.9984898567199707e+00 1.0567399978637695e+01 9.9598602294921875e+01 -7.9956798553466797e+00 1.0386300086975098e+01 9.9598602294921875e+01 -7.9662699699401855e+00 1.0207599639892578e+01 9.9598602294921875e+01 -7.9927101135253906e+00 1.0647700309753418e+01 9.9598602294921875e+01 -7.9443798065185547e+00 1.0904699325561523e+01 9.5780502319335938e+01 -7.9388198852539062e+00 1.0924000740051270e+01 9.9598602294921875e+01 -7.9373002052307129e+00 1.0923399925231934e+01 9.9598602294921875e+01 -7.8521695137023926e+00 1.1149300575256348e+01 9.5780502319335938e+01 -7.7955403327941895e+00 1.1255999565124512e+01 9.9598602294921875e+01 -7.5747098922729492e+00 1.1542200088500977e+01 9.5780502319335938e+01 -7.5769600868225098e+00 1.1544099807739258e+01 9.9598602294921875e+01 -7.7188701629638672e+00 1.1374300003051758e+01 9.9598602294921875e+01 -7.7906599044799805e+00 1.1253099441528320e+01 9.9598602294921875e+01 -7.5485401153564453e+00 1.1572600364685059e+01 9.9598602294921875e+01 -7.3463497161865234e+00 1.1738399505615234e+01 9.5780502319335938e+01 -7.2957997322082520e+00 1.1771499633789062e+01 9.9598602294921875e+01 -7.2938103675842285e+00 1.1768000602722168e+01 9.9598602294921875e+01 -7.1184396743774414e+00 1.1866600036621094e+01 9.5780502319335938e+01 -6.9683799743652344e+00 1.1925000190734863e+01 9.9598602294921875e+01 -6.9665899276733398e+00 1.1919899940490723e+01 9.9598602294921875e+01 -6.8717398643493652e+00 1.1953200340270996e+01 9.9598602294921875e+01 -6.6137499809265137e+00 1.1995699882507324e+01 9.5500000000000000e+01 -6.8807897567749023e+00 1.1658499717712402e+01 9.5500000000000000e+01 -7.1469802856445312e+00 1.1533699989318848e+01 9.5500000000000000e+01 -7.3755698204040527e+00 1.1348900794982910e+01 9.5500000000000000e+01 -7.5532698631286621e+00 1.1114699363708496e+01 9.5500000000000000e+01 -7.6697597503662109e+00 1.0844699859619141e+01 9.5500000000000000e+01 -7.7182703018188477e+00 1.0554800033569336e+01 9.5500000000000000e+01 -7.6959800720214844e+00 1.0261599540710449e+01 9.5500000000000000e+01 -7.6041798591613770e+00 9.9823398590087891e+00 9.5500000000000000e+01 -7.4482097625732422e+00 9.7331304550170898e+00 9.5500000000000000e+01 -7.2371296882629395e+00 9.5284996032714844e+00 9.5500000000000000e+01 -6.9832100868225098e+00 9.3803205490112305e+00 9.5500000000000000e+01 -6.7012200355529785e+00 9.2972202301025391e+00 9.5500000000000000e+01 -6.4075198173522949e+00 9.2840099334716797e+00 9.5500000000000000e+01 -6.1192097663879395e+00 9.3414802551269531e+00 9.5500000000000000e+01 -5.8530201911926270e+00 9.4662704467773438e+00 9.5500000000000000e+01 -5.6244297027587891e+00 9.6511497497558594e+00 9.5500000000000000e+01 -5.4467301368713379e+00 9.8853502273559570e+00 9.5500000000000000e+01 -5.3302397727966309e+00 1.0155300140380859e+01 9.5500000000000000e+01 -5.2817301750183105e+00 1.0445199966430664e+01 9.5500000000000000e+01 -5.3040199279785156e+00 1.0738399505615234e+01 9.5500000000000000e+01 -5.3958196640014648e+00 1.1017700195312500e+01 9.5500000000000000e+01 -5.5517897605895996e+00 1.1266900062561035e+01 9.5500000000000000e+01 -5.7628698348999023e+00 1.1471499443054199e+01 9.5500000000000000e+01 -6.0167899131774902e+00 1.1619700431823730e+01 9.5500000000000000e+01 -6.2987799644470215e+00 1.1702799797058105e+01 9.5500000000000000e+01 -6.5924801826477051e+00 1.1715999603271484e+01 9.9636802673339844e+01 -6.0932798385620117e+00 1.1951700210571289e+01 9.9636802673339844e+01 -6.3515501022338867e+00 1.2000300407409668e+01 9.9636802673339844e+01 -5.8473696708679199e+00 1.1858999252319336e+01 9.9636802673339844e+01 -5.6212897300720215e+00 1.1725099563598633e+01 9.9636802673339844e+01 -5.4219098091125488e+00 1.1553900718688965e+01 9.9636802673339844e+01 -5.2552900314331055e+00 1.1350600242614746e+01 9.9636802673339844e+01 -5.1264896392822266e+00 1.1121600151062012e+01 9.9636802673339844e+01 -5.0394201278686523e+00 1.0873600006103516e+01 9.9636802673339844e+01 -4.9967298507690430e+00 1.0614299774169922e+01 9.9636802673339844e+01 -4.9997096061706543e+00 1.0351499557495117e+01 9.9636802673339844e+01 -5.0482897758483887e+00 1.0093299865722656e+01 9.9636802673339844e+01 -5.1409702301025391e+00 9.8473701477050781e+00 9.9636802673339844e+01 -5.2749400138854980e+00 9.6212892532348633e+00 9.9636802673339844e+01 -5.4461402893066406e+00 9.4219102859497070e+00 9.9636802673339844e+01 -5.6493597030639648e+00 9.2552900314331055e+00 9.9636802673339844e+01 -5.8784198760986328e+00 9.1264896392822266e+00 9.9636802673339844e+01 -6.1263699531555176e+00 9.0394201278686523e+00 9.9636802673339844e+01 -6.3856797218322754e+00 8.9967298507690430e+00 9.9636802673339844e+01 -6.6484503746032715e+00 8.9997205734252930e+00 9.9636802673339844e+01 -6.9067196846008301e+00 9.0482892990112305e+00 9.9636802673339844e+01 -7.1526298522949219e+00 9.1409702301025391e+00 9.9636802673339844e+01 -7.3787097930908203e+00 9.2749395370483398e+00 9.9636802673339844e+01 -7.5780897140502930e+00 9.4461402893066406e+00 9.9636802673339844e+01 -7.7447099685668945e+00 9.6493501663208008e+00 9.9636802673339844e+01 -7.8735098838806152e+00 9.8784198760986328e+00 9.9636802673339844e+01 -7.9605803489685059e+00 1.0126399993896484e+01 9.9636802673339844e+01 -8.0032701492309570e+00 1.0385699272155762e+01 9.9636802673339844e+01 -8.0002899169921875e+00 1.0648500442504883e+01 9.9636802673339844e+01 -7.9517102241516113e+00 1.0906700134277344e+01 9.9636802673339844e+01 -7.8590297698974609e+00 1.1152600288391113e+01 9.9636802673339844e+01 -7.7250599861145020e+00 1.1378700256347656e+01 9.9636802673339844e+01 -7.5538601875305176e+00 1.1578100204467773e+01 9.9636802673339844e+01 -7.3506398200988770e+00 1.1744700431823730e+01 9.9636802673339844e+01 -7.1215801239013672e+00 1.1873500823974609e+01 9.9636802673339844e+01 -6.6143198013305664e+00 1.2003299713134766e+01 9.9636802673339844e+01 -6.8736300468444824e+00 1.1960599899291992e+01 1.0040000152587891e+02 -5.8484797477722168e+00 9.5466594696044922e+00 1.0040000152587891e+02 -5.5985503196716309e+00 1.0067099571228027e+01 1.0040000152587891e+02 -5.3486199378967285e+00 1.0587599754333496e+01 1.0040000152587891e+02 -6.9998602867126465e+00 9.4590997695922852e+00 1.0040000152587891e+02 -6.4241700172424316e+00 9.5028800964355469e+00 1.0040000152587891e+02 -7.6513795852661133e+00 1.0412399291992188e+01 1.0040000152587891e+02 -7.3256196975708008e+00 9.9357700347900391e+00 1.0040000152587891e+02 -7.1515197753906250e+00 1.1453299522399902e+01 1.0040000152587891e+02 -7.4014501571655273e+00 1.0932900428771973e+01 1.0040000152587891e+02 -6.0001401901245117e+00 1.1540900230407715e+01 1.0040000152587891e+02 -6.5758299827575684e+00 1.1497099876403809e+01 1.0040000152587891e+02 -5.6743798255920410e+00 1.1064199447631836e+01 1.0040000152587891e+02 -5.7662000656127930e+00 9.8206405639648438e+00 1.0040000152587891e+02 -5.9990396499633789e+00 9.6345300674438477e+00 1.0040000152587891e+02 -6.2763996124267578e+00 9.5253190994262695e+00 1.0040000152587891e+02 -5.5995097160339355e+00 1.0934899330139160e+01 1.0040000152587891e+02 -5.5113301277160645e+00 1.0650099754333496e+01 1.0040000152587891e+02 -5.5109996795654297e+00 1.0352100372314453e+01 1.0040000152587891e+02 -6.2785601615905762e+00 1.1475199699401855e+01 1.0040000152587891e+02 -6.0009598731994629e+00 1.1366600036621094e+01 1.0040000152587891e+02 -5.7676997184753418e+00 1.1180999755859375e+01 1.0040000152587891e+02 -6.8663697242736816e+00 1.1430500030517578e+01 1.0040000152587891e+02 -7.3268599510192871e+00 1.1062400817871094e+01 1.0040000152587891e+02 -7.1243500709533691e+00 1.1281100273132324e+01 1.0040000152587891e+02 -7.4552497863769531e+00 1.0204199790954590e+01 1.0040000152587891e+02 -7.5000000000000000e+00 1.0498900413513184e+01 1.0040000152587891e+02 -7.4558997154235840e+00 1.0793700218200684e+01 1.0040000152587891e+02 -6.5736298561096191e+00 9.5027198791503906e+00 1.0040000152587891e+02 -6.8643097877502441e+00 9.5687303543090820e+00 1.0040000152587891e+02 -7.1226296424865723e+00 9.7174806594848633e+00 9.9822700500488281e+01 -6.5000000000000000e+00 1.0500000000000000e+01 1.0150000000000000e+02 3.1999900817871094e+01 -1.4459099769592285e+01 1.0150000000000000e+02 3.2736301422119141e+01 -1.3021200180053711e+01 1.0150000000000000e+02 3.2273799896240234e+01 -1.2840299606323242e+01 1.0150000000000000e+02 3.2651397705078125e+01 -1.5412399291992188e+01 1.0150000000000000e+02 3.4268699645996094e+01 -1.5414099693298340e+01 1.0150000000000000e+02 3.4208801269531250e+01 -1.4921099662780762e+01 1.0150000000000000e+02 3.0848499298095703e+01 -1.4546699523925781e+01 1.0150000000000000e+02 2.9902999877929688e+01 -1.3236700057983398e+01 1.0150000000000000e+02 2.9524600982666016e+01 -1.3558199882507324e+01 1.0150000000000000e+02 3.1000099182128906e+01 -1.6540899276733398e+01 1.0150000000000000e+02 3.0490900039672852e+01 -1.8079599380493164e+01 1.0150000000000000e+02 3.0967699050903320e+01 -1.8218399047851562e+01 1.0150000000000000e+02 3.0332799911499023e+01 -1.2987899780273438e+01 1.0150000000000000e+02 3.0800100326538086e+01 -1.2819900512695312e+01 1.0150000000000000e+02 3.1289901733398438e+01 -1.2737999916076660e+01 1.0150000000000000e+02 3.1786500930786133e+01 -1.2744899749755859e+01 1.0150000000000000e+02 3.3159099578857422e+01 -1.3281800270080566e+01 1.0150000000000000e+02 3.3528499603271484e+01 -1.3613699913024902e+01 1.0150000000000000e+02 3.3832698822021484e+01 -1.4006199836730957e+01 1.0150000000000000e+02 3.4061901092529297e+01 -1.4446700096130371e+01 1.0150000000000000e+02 3.4239501953125000e+01 -1.5909800529479980e+01 1.0150000000000000e+02 3.4122299194335938e+01 -1.6392400741577148e+01 1.0150000000000000e+02 3.3920799255371094e+01 -1.6846298217773438e+01 1.0150000000000000e+02 3.2151500701904297e+01 -1.6453300476074219e+01 1.0150000000000000e+02 3.3641498565673828e+01 -1.7256900787353516e+01 1.0150000000000000e+02 3.3293399810791016e+01 -1.7611099243164062e+01 1.0150000000000000e+02 3.2887599945068359e+01 -1.7897399902343750e+01 1.0150000000000000e+02 3.2437297821044922e+01 -1.8106599807739258e+01 1.0150000000000000e+02 3.1956798553466797e+01 -1.8232099533081055e+01 1.0150000000000000e+02 3.1461599349975586e+01 -1.8269701004028320e+01 1.0150000000000000e+02 2.8750200271606445e+01 -1.5833800315856934e+01 1.0150000000000000e+02 2.8854000091552734e+01 -1.6319398880004883e+01 1.0150000000000000e+02 3.0348600387573242e+01 -1.5587599754333496e+01 1.0150000000000000e+02 2.9042800903320312e+01 -1.6778699874877930e+01 1.0150000000000000e+02 3.0046501159667969e+01 -1.7857999801635742e+01 1.0150000000000000e+02 2.9648799896240234e+01 -1.7560600280761719e+01 1.0150000000000000e+02 2.9310600280761719e+01 -1.7196899414062500e+01 1.0150000000000000e+02 2.8734800338745117e+01 -1.5337400436401367e+01 1.0150000000000000e+02 2.8808200836181641e+01 -1.4846300125122070e+01 1.0150000000000000e+02 2.8968200683593750e+01 -1.4376100540161133e+01 1.0150000000000000e+02 2.9209600448608398e+01 -1.3942100524902344e+01 1.0091000366210938e+02 3.0800100326538086e+01 -1.2819900512695312e+01 1.0091000366210938e+02 3.1289901733398438e+01 -1.2737999916076660e+01 1.0091000366210938e+02 3.1786500930786133e+01 -1.2744899749755859e+01 1.0091000366210938e+02 3.2273799896240234e+01 -1.2840299606323242e+01 1.0091000366210938e+02 3.2736301422119141e+01 -1.3021200180053711e+01 1.0091000366210938e+02 3.3159099578857422e+01 -1.3281800270080566e+01 1.0091000366210938e+02 3.3528499603271484e+01 -1.3613699913024902e+01 1.0091000366210938e+02 3.3832698822021484e+01 -1.4006199836730957e+01 1.0091000366210938e+02 3.4061901092529297e+01 -1.4446700096130371e+01 1.0091000366210938e+02 3.4208801269531250e+01 -1.4921099662780762e+01 1.0091000366210938e+02 3.4268699645996094e+01 -1.5414099693298340e+01 1.0091000366210938e+02 3.4239501953125000e+01 -1.5909800529479980e+01 1.0091000366210938e+02 3.4122299194335938e+01 -1.6392400741577148e+01 1.0091000366210938e+02 3.3920799255371094e+01 -1.6846298217773438e+01 1.0091000366210938e+02 3.3641498565673828e+01 -1.7256900787353516e+01 1.0091000366210938e+02 3.3293399810791016e+01 -1.7611099243164062e+01 1.0091000366210938e+02 3.2887599945068359e+01 -1.7897399902343750e+01 1.0091000366210938e+02 3.2437297821044922e+01 -1.8106599807739258e+01 1.0091000366210938e+02 3.1956798553466797e+01 -1.8232099533081055e+01 1.0091000366210938e+02 3.1461599349975586e+01 -1.8269701004028320e+01 1.0091000366210938e+02 3.0967699050903320e+01 -1.8218399047851562e+01 1.0091000366210938e+02 3.0490900039672852e+01 -1.8079599380493164e+01 1.0091000366210938e+02 3.0046501159667969e+01 -1.7857999801635742e+01 1.0091000366210938e+02 2.9648799896240234e+01 -1.7560600280761719e+01 1.0091000366210938e+02 2.9310600280761719e+01 -1.7196899414062500e+01 1.0091000366210938e+02 2.9042800903320312e+01 -1.6778699874877930e+01 1.0091000366210938e+02 2.8854000091552734e+01 -1.6319398880004883e+01 1.0091000366210938e+02 2.8750200271606445e+01 -1.5833800315856934e+01 1.0091000366210938e+02 2.8734800338745117e+01 -1.5337400436401367e+01 1.0091000366210938e+02 2.8808200836181641e+01 -1.4846300125122070e+01 1.0091000366210938e+02 2.8968200683593750e+01 -1.4376100540161133e+01 1.0091000366210938e+02 2.9209600448608398e+01 -1.3942100524902344e+01 1.0091000366210938e+02 2.9524600982666016e+01 -1.3558199882507324e+01 1.0091000366210938e+02 2.9902999877929688e+01 -1.3236700057983398e+01 1.0091000366210938e+02 3.0332799911499023e+01 -1.2987899780273438e+01 9.9669296264648438e+01 3.1658102035522461e+01 -1.3979499816894531e+01 9.9669296264648438e+01 3.1912599563598633e+01 -1.4027400016784668e+01 9.9669296264648438e+01 3.1926799774169922e+01 -1.4032799720764160e+01 9.9669296264648438e+01 3.2161998748779297e+01 -1.4121399879455566e+01 9.9669296264648438e+01 3.2181598663330078e+01 -1.4132999420166016e+01 9.9669296264648438e+01 3.2391300201416016e+01 -1.4257299423217773e+01 9.9669296264648438e+01 3.2414398193359375e+01 -1.4277099609375000e+01 9.9669296264648438e+01 3.2593601226806641e+01 -1.4430999755859375e+01 9.9669296264648438e+01 3.2617698669433594e+01 -1.4460399627685547e+01 9.9669296264648438e+01 3.2762599945068359e+01 -1.4637099266052246e+01 9.9669296264648438e+01 3.2784999847412109e+01 -1.4676899909973145e+01 9.9669296264648438e+01 3.2893299102783203e+01 -1.4869500160217285e+01 9.9669296264648438e+01 3.2910900115966797e+01 -1.4919699668884277e+01 9.9669296264648438e+01 3.2981601715087891e+01 -1.5121000289916992e+01 9.9669296264648438e+01 3.2991497039794922e+01 -1.5181099891662598e+01 9.9669296264648438e+01 3.3024898529052734e+01 -1.5383999824523926e+01 9.9669296264648438e+01 3.3024097442626953e+01 -1.5452500343322754e+01 9.9669296264648438e+01 3.3021900177001953e+01 -1.5650600433349609e+01 9.9669296264648438e+01 3.3007801055908203e+01 -1.5725399971008301e+01 9.9669296264648438e+01 3.2972599029541016e+01 -1.5912599563598633e+01 9.9669296264648438e+01 3.2943099975585938e+01 -1.5990900039672852e+01 9.9669296264648438e+01 3.2878601074218750e+01 -1.6162000656127930e+01 9.9669296264648438e+01 3.2832000732421875e+01 -1.6240600585937500e+01 9.9669296264648438e+01 3.2742702484130859e+01 -1.6391300201416016e+01 9.9669296264648438e+01 3.2678203582763672e+01 -1.6466400146484375e+01 9.9669296264648438e+01 3.2569000244140625e+01 -1.6593599319458008e+01 9.9669296264648438e+01 3.2486598968505859e+01 -1.6661201477050781e+01 9.9669296264648438e+01 3.2362899780273438e+01 -1.6762599945068359e+01 9.9669296264648438e+01 3.2263301849365234e+01 -1.6818599700927734e+01 9.9669296264648438e+01 3.2130496978759766e+01 -1.6893299102783203e+01 9.9669296264648438e+01 3.2015598297119141e+01 -1.6933599472045898e+01 9.9669296264648438e+01 3.1878999710083008e+01 -1.6981599807739258e+01 9.9669296264648438e+01 3.1751199722290039e+01 -1.7002599716186523e+01 9.9669296264648438e+01 3.1615999221801758e+01 -1.7024900436401367e+01 9.9669296264648438e+01 3.1478900909423828e+01 -1.7023300170898438e+01 9.9669296264648438e+01 3.0944900512695312e+01 -1.6918899536132812e+01 9.9669296264648438e+01 3.1087400436401367e+01 -1.6972599029541016e+01 9.9669296264648438e+01 3.1207201004028320e+01 -1.6995100021362305e+01 9.9669296264648438e+01 3.1349397659301758e+01 -1.7021900177001953e+01 9.9669296264648438e+01 3.0481500625610352e+01 -1.6633499145507812e+01 9.9669296264648438e+01 3.0608699798583984e+01 -1.6742700576782227e+01 9.9669296264648438e+01 3.0700401306152344e+01 -1.6797000885009766e+01 9.9669296264648438e+01 3.0837999343872070e+01 -1.6878599166870117e+01 9.9669296264648438e+01 3.0147800445556641e+01 -1.6203500747680664e+01 9.9669296264648438e+01 3.0237400054931641e+01 -1.6362899780273438e+01 9.9669296264648438e+01 3.0295299530029297e+01 -1.6433500289916992e+01 9.9669296264648438e+01 3.0406400680541992e+01 -1.6569000244140625e+01 9.9669296264648438e+01 2.9986200332641602e+01 -1.5683500289916992e+01 9.9669296264648438e+01 3.0018400192260742e+01 -1.5878999710083008e+01 9.9669296264648438e+01 3.0043600082397461e+01 -1.5950800895690918e+01 9.9669296264648438e+01 3.0106698989868164e+01 -1.6130498886108398e+01 9.9669296264648438e+01 3.0017599105834961e+01 -1.5139799118041992e+01 9.9669296264648438e+01 2.9978099822998047e+01 -1.5349400520324707e+01 9.9669296264648438e+01 2.9977500915527344e+01 -1.5410300254821777e+01 9.9669296264648438e+01 2.9975099563598633e+01 -1.5615999221801758e+01 9.9669296264648438e+01 3.0237899780273438e+01 -1.4641400337219238e+01 9.9669296264648438e+01 3.0121398925781250e+01 -1.4838000297546387e+01 9.9669296264648438e+01 3.0105300903320312e+01 -1.4880700111389160e+01 9.9669296264648438e+01 3.0027400970458984e+01 -1.5087399482727051e+01 9.9669296264648438e+01 3.0619501113891602e+01 -1.4251899719238281e+01 9.9669296264648438e+01 3.0430999755859375e+01 -1.4406399726867676e+01 9.9669296264648438e+01 3.0411201477050781e+01 -1.4429500579833984e+01 9.9669296264648438e+01 3.0257299423217773e+01 -1.4608699798583984e+01 9.9669296264648438e+01 3.1113800048828125e+01 -1.4020899772644043e+01 9.9669296264648438e+01 3.0869501113891602e+01 -1.4106699943542480e+01 9.9669296264648438e+01 3.0856199264526367e+01 -1.4114200592041016e+01 9.9669296264648438e+01 3.0637100219726562e+01 -1.4237400054931641e+01 9.9669296264648438e+01 3.1650598526000977e+01 -1.3978100776672363e+01 9.9669296264648438e+01 3.1383998870849609e+01 -1.3975099563598633e+01 9.9669296264648438e+01 3.1121000289916992e+01 -1.4018399238586426e+01 9.9598602294921875e+01 3.1647701263427734e+01 -1.4007300376892090e+01 9.5780502319335938e+01 3.1747501373291016e+01 -1.4020600318908691e+01 9.5780502319335938e+01 3.1386301040649414e+01 -1.4004300117492676e+01 9.9598602294921875e+01 3.2092899322509766e+01 -1.4126599311828613e+01 9.5780502319335938e+01 3.2094398498535156e+01 -1.4122799873352051e+01 9.9598602294921875e+01 3.1904701232910156e+01 -1.4055600166320801e+01 9.9598602294921875e+01 3.1746500015258789e+01 -1.4025899887084961e+01 9.9598602294921875e+01 3.2149299621582031e+01 -1.4147800445556641e+01 9.9598602294921875e+01 3.2374301910400391e+01 -1.4281099319458008e+01 9.5780502319335938e+01 3.2406700134277344e+01 -1.4305000305175781e+01 9.9598602294921875e+01 3.2404697418212891e+01 -1.4307299613952637e+01 9.9598602294921875e+01 3.2572601318359375e+01 -1.4451499938964844e+01 9.5780502319335938e+01 3.2666297912597656e+01 -1.4556700706481934e+01 9.9598602294921875e+01 3.2856700897216797e+01 -1.4864100456237793e+01 9.5780502319335938e+01 3.2858200073242188e+01 -1.4863300323486328e+01 9.9598602294921875e+01 3.2738399505615234e+01 -1.4653599739074707e+01 9.9598602294921875e+01 3.2661899566650391e+01 -1.4560299873352051e+01 9.9598602294921875e+01 3.2866600036621094e+01 -1.4881599426269531e+01 9.9598602294921875e+01 3.2953197479248047e+01 -1.5128299713134766e+01 9.5780502319335938e+01 3.2971099853515625e+01 -1.5206799507141113e+01 9.9598602294921875e+01 3.2993598937988281e+01 -1.5567299842834473e+01 9.5780502319335938e+01 3.2998497009277344e+01 -1.5567399978637695e+01 9.9598602294921875e+01 3.2995700836181641e+01 -1.5386300086975098e+01 9.9598602294921875e+01 3.2966300964355469e+01 -1.5207599639892578e+01 9.9598602294921875e+01 3.2992698669433594e+01 -1.5647700309753418e+01 9.9598602294921875e+01 3.2944400787353516e+01 -1.5904700279235840e+01 9.5780502319335938e+01 3.2938800811767578e+01 -1.5923998832702637e+01 9.9598602294921875e+01 3.2937297821044922e+01 -1.5923399925231934e+01 9.9598602294921875e+01 3.2852199554443359e+01 -1.6149299621582031e+01 9.5780502319335938e+01 3.2795501708984375e+01 -1.6256000518798828e+01 9.9598602294921875e+01 3.2574699401855469e+01 -1.6542200088500977e+01 9.5780502319335938e+01 3.2576999664306641e+01 -1.6544099807739258e+01 9.9598602294921875e+01 3.2718898773193359e+01 -1.6374300003051758e+01 9.9598602294921875e+01 3.2790702819824219e+01 -1.6253101348876953e+01 9.9598602294921875e+01 3.2548500061035156e+01 -1.6572599411010742e+01 9.9598602294921875e+01 3.2346302032470703e+01 -1.6738399505615234e+01 9.5780502319335938e+01 3.2295799255371094e+01 -1.6771501541137695e+01 9.9598602294921875e+01 3.2293800354003906e+01 -1.6767999649047852e+01 9.9598602294921875e+01 3.2118400573730469e+01 -1.6866600036621094e+01 9.5780502319335938e+01 3.1968399047851562e+01 -1.6924999237060547e+01 9.9598602294921875e+01 3.1966600418090820e+01 -1.6919898986816406e+01 9.9598602294921875e+01 3.1871698379516602e+01 -1.6953199386596680e+01 9.5780502319335938e+01 3.1613700866699219e+01 -1.6995700836181641e+01 9.9598602294921875e+01 3.1613700866699219e+01 -1.6995700836181641e+01 9.9598602294921875e+01 3.1352300643920898e+01 -1.6992698669433594e+01 9.5780502319335938e+01 3.1252500534057617e+01 -1.6979400634765625e+01 9.9598602294921875e+01 3.0907100677490234e+01 -1.6873399734497070e+01 9.5780502319335938e+01 3.0905601501464844e+01 -1.6877201080322266e+01 9.9598602294921875e+01 3.1095300674438477e+01 -1.6944398880004883e+01 9.9598602294921875e+01 3.1253501892089844e+01 -1.6974100112915039e+01 9.9598602294921875e+01 3.0850698471069336e+01 -1.6852199554443359e+01 9.9598602294921875e+01 3.0625699996948242e+01 -1.6718900680541992e+01 9.5780502319335938e+01 3.0593299865722656e+01 -1.6694999694824219e+01 9.9598602294921875e+01 3.0595300674438477e+01 -1.6692699432373047e+01 9.9598602294921875e+01 3.0427400588989258e+01 -1.6548500061035156e+01 9.5780502319335938e+01 3.0333700180053711e+01 -1.6443298339843750e+01 9.9598602294921875e+01 3.0143301010131836e+01 -1.6135898590087891e+01 9.5780502319335938e+01 3.0141799926757812e+01 -1.6136699676513672e+01 9.9598602294921875e+01 3.0261600494384766e+01 -1.6346401214599609e+01 9.9598602294921875e+01 3.0338098526000977e+01 -1.6439701080322266e+01 9.9598602294921875e+01 3.0133399963378906e+01 -1.6118400573730469e+01 9.9598602294921875e+01 3.0046800613403320e+01 -1.5871700286865234e+01 9.5780502319335938e+01 3.0028900146484375e+01 -1.5793200492858887e+01 9.9598602294921875e+01 3.0006399154663086e+01 -1.5432699203491211e+01 9.5780502319335938e+01 3.0001501083374023e+01 -1.5432600021362305e+01 9.9598602294921875e+01 3.0004301071166992e+01 -1.5613699913024902e+01 9.9598602294921875e+01 3.0033700942993164e+01 -1.5792399406433105e+01 9.9598602294921875e+01 3.0007301330566406e+01 -1.5352300643920898e+01 9.9598602294921875e+01 3.0055599212646484e+01 -1.5095299720764160e+01 9.5780502319335938e+01 3.0061201095581055e+01 -1.5076000213623047e+01 9.9598602294921875e+01 3.0062700271606445e+01 -1.5076600074768066e+01 9.9598602294921875e+01 3.0147800445556641e+01 -1.4850700378417969e+01 9.5780502319335938e+01 3.0204498291015625e+01 -1.4743999481201172e+01 9.9598602294921875e+01 3.0425300598144531e+01 -1.4457800865173340e+01 9.5780502319335938e+01 3.0423000335693359e+01 -1.4455899238586426e+01 9.9598602294921875e+01 3.0281101226806641e+01 -1.4625699996948242e+01 9.9598602294921875e+01 3.0209299087524414e+01 -1.4746899604797363e+01 9.9598602294921875e+01 3.0451499938964844e+01 -1.4427400588989258e+01 9.9598602294921875e+01 3.0653699874877930e+01 -1.4261599540710449e+01 9.5780502319335938e+01 3.0704200744628906e+01 -1.4228500366210938e+01 9.9598602294921875e+01 3.0706201553344727e+01 -1.4232000350952148e+01 9.9598602294921875e+01 3.0881601333618164e+01 -1.4133399963378906e+01 9.5780502319335938e+01 3.1031599044799805e+01 -1.4074999809265137e+01 9.9598602294921875e+01 3.1033399581909180e+01 -1.4080100059509277e+01 9.9598602294921875e+01 3.1128299713134766e+01 -1.4046800613403320e+01 9.9598602294921875e+01 3.1386301040649414e+01 -1.4004300117492676e+01 9.5500000000000000e+01 3.1119199752807617e+01 -1.4341499328613281e+01 9.5500000000000000e+01 3.0852998733520508e+01 -1.4466300010681152e+01 9.5500000000000000e+01 3.0624401092529297e+01 -1.4651100158691406e+01 9.5500000000000000e+01 3.0446701049804688e+01 -1.4885299682617188e+01 9.5500000000000000e+01 3.0330200195312500e+01 -1.5155299186706543e+01 9.5500000000000000e+01 3.0281700134277344e+01 -1.5445199966430664e+01 9.5500000000000000e+01 3.0303998947143555e+01 -1.5738399505615234e+01 9.5500000000000000e+01 3.0395799636840820e+01 -1.6017700195312500e+01 9.5500000000000000e+01 3.0551799774169922e+01 -1.6266899108886719e+01 9.5500000000000000e+01 3.0762899398803711e+01 -1.6471500396728516e+01 9.5500000000000000e+01 3.1016799926757812e+01 -1.6619699478149414e+01 9.5500000000000000e+01 3.1298801422119141e+01 -1.6702798843383789e+01 9.5500000000000000e+01 3.1592498779296875e+01 -1.6715999603271484e+01 9.5500000000000000e+01 3.1880800247192383e+01 -1.6658500671386719e+01 9.5500000000000000e+01 3.2147003173828125e+01 -1.6533700942993164e+01 9.5500000000000000e+01 3.2375598907470703e+01 -1.6348899841308594e+01 9.5500000000000000e+01 3.2553298950195312e+01 -1.6114700317382812e+01 9.5500000000000000e+01 3.2669799804687500e+01 -1.5844700813293457e+01 9.5500000000000000e+01 3.2718299865722656e+01 -1.5554800033569336e+01 9.5500000000000000e+01 3.2696002960205078e+01 -1.5261599540710449e+01 9.5500000000000000e+01 3.2604198455810547e+01 -1.4982299804687500e+01 9.5500000000000000e+01 3.2448200225830078e+01 -1.4733099937438965e+01 9.5500000000000000e+01 3.2237102508544922e+01 -1.4528499603271484e+01 9.5500000000000000e+01 3.1983200073242188e+01 -1.4380300521850586e+01 9.5500000000000000e+01 3.1701200485229492e+01 -1.4297200202941895e+01 9.5500000000000000e+01 3.1407501220703125e+01 -1.4283999443054199e+01 9.9636802673339844e+01 3.1906702041625977e+01 -1.4048299789428711e+01 9.9636802673339844e+01 3.1648502349853516e+01 -1.3999699592590332e+01 9.9636802673339844e+01 3.2152599334716797e+01 -1.4140999794006348e+01 9.9636802673339844e+01 3.2378700256347656e+01 -1.4274899482727051e+01 9.9636802673339844e+01 3.2578098297119141e+01 -1.4446100234985352e+01 9.9636802673339844e+01 3.2744697570800781e+01 -1.4649399757385254e+01 9.9636802673339844e+01 3.2873500823974609e+01 -1.4878399848937988e+01 9.9636802673339844e+01 3.2960601806640625e+01 -1.5126399993896484e+01 9.9636802673339844e+01 3.3003299713134766e+01 -1.5385700225830078e+01 9.9636802673339844e+01 3.3000301361083984e+01 -1.5648499488830566e+01 9.9636802673339844e+01 3.2951702117919922e+01 -1.5906701087951660e+01 9.9636802673339844e+01 3.2859001159667969e+01 -1.6152599334716797e+01 9.9636802673339844e+01 3.2725097656250000e+01 -1.6378700256347656e+01 9.9636802673339844e+01 3.2553901672363281e+01 -1.6578100204467773e+01 9.9636802673339844e+01 3.2350601196289062e+01 -1.6744699478149414e+01 9.9636802673339844e+01 3.2121597290039062e+01 -1.6873498916625977e+01 9.9636802673339844e+01 3.1873598098754883e+01 -1.6960599899291992e+01 9.9636802673339844e+01 3.1614299774169922e+01 -1.7003299713134766e+01 9.9636802673339844e+01 3.1351499557495117e+01 -1.7000301361083984e+01 9.9636802673339844e+01 3.1093299865722656e+01 -1.6951700210571289e+01 9.9636802673339844e+01 3.0847400665283203e+01 -1.6859001159667969e+01 9.9636802673339844e+01 3.0621299743652344e+01 -1.6725101470947266e+01 9.9636802673339844e+01 3.0421899795532227e+01 -1.6553899765014648e+01 9.9636802673339844e+01 3.0255300521850586e+01 -1.6350601196289062e+01 9.9636802673339844e+01 3.0126501083374023e+01 -1.6121599197387695e+01 9.9636802673339844e+01 3.0039400100708008e+01 -1.5873600006103516e+01 9.9636802673339844e+01 2.9996700286865234e+01 -1.5614299774169922e+01 9.9636802673339844e+01 2.9999698638916016e+01 -1.5351500511169434e+01 9.9636802673339844e+01 3.0048299789428711e+01 -1.5093299865722656e+01 9.9636802673339844e+01 3.0140998840332031e+01 -1.4847399711608887e+01 9.9636802673339844e+01 3.0274900436401367e+01 -1.4621299743652344e+01 9.9636802673339844e+01 3.0446098327636719e+01 -1.4421899795532227e+01 9.9636802673339844e+01 3.0649398803710938e+01 -1.4255300521850586e+01 9.9636802673339844e+01 3.0878400802612305e+01 -1.4126500129699707e+01 9.9636802673339844e+01 3.1385700225830078e+01 -1.3996700286865234e+01 9.9636802673339844e+01 3.1126399993896484e+01 -1.4039400100708008e+01 1.0040000152587891e+02 3.2151500701904297e+01 -1.6453300476074219e+01 1.0040000152587891e+02 3.2401401519775391e+01 -1.5932900428771973e+01 1.0040000152587891e+02 3.2651397705078125e+01 -1.5412399291992188e+01 1.0040000152587891e+02 3.1000099182128906e+01 -1.6540899276733398e+01 1.0040000152587891e+02 3.1575798034667969e+01 -1.6497098922729492e+01 1.0040000152587891e+02 3.0348600387573242e+01 -1.5587599754333496e+01 1.0040000152587891e+02 3.0674400329589844e+01 -1.6064201354980469e+01 1.0040000152587891e+02 3.0848499298095703e+01 -1.4546699523925781e+01 1.0040000152587891e+02 3.0598600387573242e+01 -1.5067099571228027e+01 1.0040000152587891e+02 3.1999900817871094e+01 -1.4459099769592285e+01 1.0040000152587891e+02 3.1424198150634766e+01 -1.4502900123596191e+01 1.0040000152587891e+02 3.2325599670410156e+01 -1.4935799598693848e+01 1.0040000152587891e+02 3.2233798980712891e+01 -1.6179399490356445e+01 1.0040000152587891e+02 3.2000999450683594e+01 -1.6365499496459961e+01 1.0040000152587891e+02 3.1723600387573242e+01 -1.6474699020385742e+01 1.0040000152587891e+02 3.2400501251220703e+01 -1.5065099716186523e+01 1.0040000152587891e+02 3.2488700866699219e+01 -1.5349900245666504e+01 1.0040000152587891e+02 3.2489002227783203e+01 -1.5647899627685547e+01 1.0040000152587891e+02 3.1721397399902344e+01 -1.4524799346923828e+01 1.0040000152587891e+02 3.1998998641967773e+01 -1.4633399963378906e+01 1.0040000152587891e+02 3.2232299804687500e+01 -1.4819000244140625e+01 1.0040000152587891e+02 3.1133600234985352e+01 -1.4569500923156738e+01 1.0040000152587891e+02 3.0673099517822266e+01 -1.4937600135803223e+01 1.0040000152587891e+02 3.0875600814819336e+01 -1.4718900680541992e+01 1.0040000152587891e+02 3.0544799804687500e+01 -1.5795801162719727e+01 1.0040000152587891e+02 3.0500000000000000e+01 -1.5501099586486816e+01 1.0040000152587891e+02 3.0544099807739258e+01 -1.5206299781799316e+01 1.0040000152587891e+02 3.1426399230957031e+01 -1.6497299194335938e+01 1.0040000152587891e+02 3.1135700225830078e+01 -1.6431299209594727e+01 1.0040000152587891e+02 3.0877399444580078e+01 -1.6282501220703125e+01 9.9822700500488281e+01 3.1500000000000000e+01 -1.5500000000000000e+01 1.0150000000000000e+02 -6.0001401901245117e+00 -1.4459099769592285e+01 1.0150000000000000e+02 -5.2636799812316895e+00 -1.3021200180053711e+01 1.0150000000000000e+02 -5.7261495590209961e+00 -1.2840299606323242e+01 1.0150000000000000e+02 -5.3486199378967285e+00 -1.5412399291992188e+01 1.0150000000000000e+02 -3.7313299179077148e+00 -1.5414099693298340e+01 1.0150000000000000e+02 -3.7911698818206787e+00 -1.4921099662780762e+01 1.0150000000000000e+02 -7.1515197753906250e+00 -1.4546699523925781e+01 1.0150000000000000e+02 -8.0969600677490234e+00 -1.3236700057983398e+01 1.0150000000000000e+02 -8.4754304885864258e+00 -1.3558199882507324e+01 1.0150000000000000e+02 -6.9998602867126465e+00 -1.6540899276733398e+01 1.0150000000000000e+02 -7.5091500282287598e+00 -1.8079599380493164e+01 1.0150000000000000e+02 -7.0323200225830078e+00 -1.8218399047851562e+01 1.0150000000000000e+02 -7.6671700477600098e+00 -1.2987899780273438e+01 1.0150000000000000e+02 -7.1998600959777832e+00 -1.2819900512695312e+01 1.0150000000000000e+02 -6.7100501060485840e+00 -1.2737999916076660e+01 1.0150000000000000e+02 -6.2135000228881836e+00 -1.2744899749755859e+01 1.0150000000000000e+02 -4.8409399986267090e+00 -1.3281800270080566e+01 1.0150000000000000e+02 -4.4715304374694824e+00 -1.3613699913024902e+01 1.0150000000000000e+02 -4.1673097610473633e+00 -1.4006199836730957e+01 1.0150000000000000e+02 -3.9380700588226318e+00 -1.4446700096130371e+01 1.0150000000000000e+02 -3.7604801654815674e+00 -1.5909800529479980e+01 1.0150000000000000e+02 -3.8776900768280029e+00 -1.6392400741577148e+01 1.0150000000000000e+02 -4.0791702270507812e+00 -1.6846298217773438e+01 1.0150000000000000e+02 -5.8484797477722168e+00 -1.6453300476074219e+01 1.0150000000000000e+02 -4.3584604263305664e+00 -1.7256900787353516e+01 1.0150000000000000e+02 -4.7065901756286621e+00 -1.7611099243164062e+01 1.0150000000000000e+02 -5.1123499870300293e+00 -1.7897399902343750e+01 1.0150000000000000e+02 -5.5627198219299316e+00 -1.8106599807739258e+01 1.0150000000000000e+02 -6.0432100296020508e+00 -1.8232099533081055e+01 1.0150000000000000e+02 -6.5383801460266113e+00 -1.8269701004028320e+01 1.0150000000000000e+02 -9.2498207092285156e+00 -1.5833800315856934e+01 1.0150000000000000e+02 -9.1460304260253906e+00 -1.6319398880004883e+01 1.0150000000000000e+02 -7.6513795852661133e+00 -1.5587599754333496e+01 1.0150000000000000e+02 -8.9572000503540039e+00 -1.6778699874877930e+01 1.0150000000000000e+02 -7.9535403251647949e+00 -1.7857999801635742e+01 1.0150000000000000e+02 -8.3512201309204102e+00 -1.7560600280761719e+01 1.0150000000000000e+02 -8.6893892288208008e+00 -1.7196899414062500e+01 1.0150000000000000e+02 -9.2652196884155273e+00 -1.5337400436401367e+01 1.0150000000000000e+02 -9.1917495727539062e+00 -1.4846300125122070e+01 1.0150000000000000e+02 -9.0317592620849609e+00 -1.4376100540161133e+01 1.0150000000000000e+02 -8.7903995513916016e+00 -1.3942100524902344e+01 1.0091000366210938e+02 -7.1998600959777832e+00 -1.2819900512695312e+01 1.0091000366210938e+02 -6.7100501060485840e+00 -1.2737999916076660e+01 1.0091000366210938e+02 -6.2135000228881836e+00 -1.2744899749755859e+01 1.0091000366210938e+02 -5.7261495590209961e+00 -1.2840299606323242e+01 1.0091000366210938e+02 -5.2636799812316895e+00 -1.3021200180053711e+01 1.0091000366210938e+02 -4.8409399986267090e+00 -1.3281800270080566e+01 1.0091000366210938e+02 -4.4715304374694824e+00 -1.3613699913024902e+01 1.0091000366210938e+02 -4.1673097610473633e+00 -1.4006199836730957e+01 1.0091000366210938e+02 -3.9380700588226318e+00 -1.4446700096130371e+01 1.0091000366210938e+02 -3.7911698818206787e+00 -1.4921099662780762e+01 1.0091000366210938e+02 -3.7313299179077148e+00 -1.5414099693298340e+01 1.0091000366210938e+02 -3.7604801654815674e+00 -1.5909800529479980e+01 1.0091000366210938e+02 -3.8776900768280029e+00 -1.6392400741577148e+01 1.0091000366210938e+02 -4.0791702270507812e+00 -1.6846298217773438e+01 1.0091000366210938e+02 -4.3584604263305664e+00 -1.7256900787353516e+01 1.0091000366210938e+02 -4.7065901756286621e+00 -1.7611099243164062e+01 1.0091000366210938e+02 -5.1123499870300293e+00 -1.7897399902343750e+01 1.0091000366210938e+02 -5.5627198219299316e+00 -1.8106599807739258e+01 1.0091000366210938e+02 -6.0432100296020508e+00 -1.8232099533081055e+01 1.0091000366210938e+02 -6.5383801460266113e+00 -1.8269701004028320e+01 1.0091000366210938e+02 -7.0323200225830078e+00 -1.8218399047851562e+01 1.0091000366210938e+02 -7.5091500282287598e+00 -1.8079599380493164e+01 1.0091000366210938e+02 -7.9535403251647949e+00 -1.7857999801635742e+01 1.0091000366210938e+02 -8.3512201309204102e+00 -1.7560600280761719e+01 1.0091000366210938e+02 -8.6893892288208008e+00 -1.7196899414062500e+01 1.0091000366210938e+02 -8.9572000503540039e+00 -1.6778699874877930e+01 1.0091000366210938e+02 -9.1460304260253906e+00 -1.6319398880004883e+01 1.0091000366210938e+02 -9.2498207092285156e+00 -1.5833800315856934e+01 1.0091000366210938e+02 -9.2652196884155273e+00 -1.5337400436401367e+01 1.0091000366210938e+02 -9.1917495727539062e+00 -1.4846300125122070e+01 1.0091000366210938e+02 -9.0317592620849609e+00 -1.4376100540161133e+01 1.0091000366210938e+02 -8.7903995513916016e+00 -1.3942100524902344e+01 1.0091000366210938e+02 -8.4754304885864258e+00 -1.3558199882507324e+01 1.0091000366210938e+02 -8.0969600677490234e+00 -1.3236700057983398e+01 1.0091000366210938e+02 -7.6671700477600098e+00 -1.2987899780273438e+01 9.9669296264648438e+01 -6.3419499397277832e+00 -1.3979499816894531e+01 9.9669296264648438e+01 -6.0874300003051758e+00 -1.4027400016784668e+01 9.9669296264648438e+01 -6.0732097625732422e+00 -1.4032799720764160e+01 9.9669296264648438e+01 -5.8379898071289062e+00 -1.4121399879455566e+01 9.9669296264648438e+01 -5.8183698654174805e+00 -1.4132999420166016e+01 9.9669296264648438e+01 -5.6086602210998535e+00 -1.4257299423217773e+01 9.9669296264648438e+01 -5.5855898857116699e+00 -1.4277099609375000e+01 9.9669296264648438e+01 -5.4064097404479980e+00 -1.4430999755859375e+01 9.9669296264648438e+01 -5.3822999000549316e+00 -1.4460399627685547e+01 9.9669296264648438e+01 -5.2373900413513184e+00 -1.4637099266052246e+01 9.9669296264648438e+01 -5.2150301933288574e+00 -1.4676899909973145e+01 9.9669296264648438e+01 -5.1067399978637695e+00 -1.4869500160217285e+01 9.9669296264648438e+01 -5.0890998840332031e+00 -1.4919699668884277e+01 9.9669296264648438e+01 -5.0184202194213867e+00 -1.5121000289916992e+01 9.9669296264648438e+01 -5.0085296630859375e+00 -1.5181099891662598e+01 9.9669296264648438e+01 -4.9751100540161133e+00 -1.5383999824523926e+01 9.9669296264648438e+01 -4.9758896827697754e+00 -1.5452500343322754e+01 9.9669296264648438e+01 -4.9781398773193359e+00 -1.5650600433349609e+01 9.9669296264648438e+01 -4.9922099113464355e+00 -1.5725399971008301e+01 9.9669296264648438e+01 -5.0274100303649902e+00 -1.5912599563598633e+01 9.9669296264648438e+01 -5.0569400787353516e+00 -1.5990900039672852e+01 9.9669296264648438e+01 -5.1214299201965332e+00 -1.6162000656127930e+01 9.9669296264648438e+01 -5.1679997444152832e+00 -1.6240600585937500e+01 9.9669296264648438e+01 -5.2573299407958984e+00 -1.6391300201416016e+01 9.9669296264648438e+01 -5.3217997550964355e+00 -1.6466400146484375e+01 9.9669296264648438e+01 -5.4309802055358887e+00 -1.6593599319458008e+01 9.9669296264648438e+01 -5.5134196281433105e+00 -1.6661201477050781e+01 9.9669296264648438e+01 -5.6371297836303711e+00 -1.6762599945068359e+01 9.9669296264648438e+01 -5.7366900444030762e+00 -1.6818599700927734e+01 9.9669296264648438e+01 -5.8694796562194824e+00 -1.6893299102783203e+01 9.9669296264648438e+01 -5.9844503402709961e+00 -1.6933599472045898e+01 9.9669296264648438e+01 -6.1209998130798340e+00 -1.6981599807739258e+01 9.9669296264648438e+01 -6.2487497329711914e+00 -1.7002599716186523e+01 9.9669296264648438e+01 -6.3840298652648926e+00 -1.7024900436401367e+01 9.9669296264648438e+01 -6.5211200714111328e+00 -1.7023300170898438e+01 9.9669296264648438e+01 -7.0551300048828125e+00 -1.6918899536132812e+01 9.9669296264648438e+01 -6.9125699996948242e+00 -1.6972599029541016e+01 9.9669296264648438e+01 -6.7928199768066406e+00 -1.6995100021362305e+01 9.9669296264648438e+01 -6.6505899429321289e+00 -1.7021900177001953e+01 9.9669296264648438e+01 -7.5185003280639648e+00 -1.6633499145507812e+01 9.9669296264648438e+01 -7.3913402557373047e+00 -1.6742700576782227e+01 9.9669296264648438e+01 -7.2996401786804199e+00 -1.6797000885009766e+01 9.9669296264648438e+01 -7.1620097160339355e+00 -1.6878599166870117e+01 9.9669296264648438e+01 -7.8522200584411621e+00 -1.6203500747680664e+01 9.9669296264648438e+01 -7.7626099586486816e+00 -1.6362899780273438e+01 9.9669296264648438e+01 -7.7046899795532227e+00 -1.6433500289916992e+01 9.9669296264648438e+01 -7.5935897827148438e+00 -1.6569000244140625e+01 9.9669296264648438e+01 -8.0137596130371094e+00 -1.5683500289916992e+01 9.9669296264648438e+01 -7.9815797805786133e+00 -1.5878999710083008e+01 9.9669296264648438e+01 -7.9563698768615723e+00 -1.5950800895690918e+01 9.9669296264648438e+01 -7.8932595252990723e+00 -1.6130498886108398e+01 9.9669296264648438e+01 -7.9824299812316895e+00 -1.5139799118041992e+01 9.9669296264648438e+01 -8.0218601226806641e+00 -1.5349400520324707e+01 9.9669296264648438e+01 -8.0225496292114258e+00 -1.5410300254821777e+01 9.9669296264648438e+01 -8.0248899459838867e+00 -1.5615999221801758e+01 9.9669296264648438e+01 -7.7620601654052734e+00 -1.4641400337219238e+01 9.9669296264648438e+01 -7.8785700798034668e+00 -1.4838000297546387e+01 9.9669296264648438e+01 -7.8946695327758789e+00 -1.4880700111389160e+01 9.9669296264648438e+01 -7.9725894927978516e+00 -1.5087399482727051e+01 9.9669296264648438e+01 -7.3805103302001953e+00 -1.4251899719238281e+01 9.9669296264648438e+01 -7.5690202713012695e+00 -1.4406399726867676e+01 9.9669296264648438e+01 -7.5888299942016602e+00 -1.4429500579833984e+01 9.9669296264648438e+01 -7.7426700592041016e+00 -1.4608699798583984e+01 9.9669296264648438e+01 -6.8861699104309082e+00 -1.4020899772644043e+01 9.9669296264648438e+01 -7.1305198669433594e+00 -1.4106699943542480e+01 9.9669296264648438e+01 -7.1437697410583496e+00 -1.4114200592041016e+01 9.9669296264648438e+01 -7.3628702163696289e+00 -1.4237400054931641e+01 9.9669296264648438e+01 -6.3494100570678711e+00 -1.3978100776672363e+01 9.9669296264648438e+01 -6.6159696578979492e+00 -1.3975099563598633e+01 9.9669296264648438e+01 -6.8790001869201660e+00 -1.4018399238586426e+01 9.9598602294921875e+01 -6.3522996902465820e+00 -1.4007300376892090e+01 9.5780502319335938e+01 -6.2525000572204590e+00 -1.4020600318908691e+01 9.5780502319335938e+01 -6.6137499809265137e+00 -1.4004300117492676e+01 9.9598602294921875e+01 -5.9070696830749512e+00 -1.4126599311828613e+01 9.5780502319335938e+01 -5.9056396484375000e+00 -1.4122799873352051e+01 9.9598602294921875e+01 -6.0953302383422852e+00 -1.4055600166320801e+01 9.9598602294921875e+01 -6.2534999847412109e+00 -1.4025899887084961e+01 9.9598602294921875e+01 -5.8506698608398438e+00 -1.4147800445556641e+01 9.9598602294921875e+01 -5.6257300376892090e+00 -1.4281099319458008e+01 9.5780502319335938e+01 -5.5933198928833008e+00 -1.4305000305175781e+01 9.9598602294921875e+01 -5.5952596664428711e+00 -1.4307299613952637e+01 9.9598602294921875e+01 -5.4273600578308105e+00 -1.4451499938964844e+01 9.5780502319335938e+01 -5.3336901664733887e+00 -1.4556700706481934e+01 9.9598602294921875e+01 -5.1432600021362305e+00 -1.4864100456237793e+01 9.5780502319335938e+01 -5.1418499946594238e+00 -1.4863300323486328e+01 9.9598602294921875e+01 -5.2615799903869629e+00 -1.4653599739074707e+01 9.9598602294921875e+01 -5.3380804061889648e+00 -1.4560299873352051e+01 9.9598602294921875e+01 -5.1334199905395508e+00 -1.4881599426269531e+01 9.9598602294921875e+01 -5.0467901229858398e+00 -1.5128299713134766e+01 9.5780502319335938e+01 -5.0289301872253418e+00 -1.5206799507141113e+01 9.9598602294921875e+01 -5.0063800811767578e+00 -1.5567299842834473e+01 9.5780502319335938e+01 -5.0015101432800293e+00 -1.5567399978637695e+01 9.9598602294921875e+01 -5.0043196678161621e+00 -1.5386300086975098e+01 9.9598602294921875e+01 -5.0337300300598145e+00 -1.5207599639892578e+01 9.9598602294921875e+01 -5.0072898864746094e+00 -1.5647700309753418e+01 9.9598602294921875e+01 -5.0556197166442871e+00 -1.5904700279235840e+01 9.5780502319335938e+01 -5.0611796379089355e+00 -1.5923998832702637e+01 9.9598602294921875e+01 -5.0626997947692871e+00 -1.5923399925231934e+01 9.9598602294921875e+01 -5.1478300094604492e+00 -1.6149299621582031e+01 9.5780502319335938e+01 -5.2044601440429688e+00 -1.6256000518798828e+01 9.9598602294921875e+01 -5.4252901077270508e+00 -1.6542200088500977e+01 9.5780502319335938e+01 -5.4230399131774902e+00 -1.6544099807739258e+01 9.9598602294921875e+01 -5.2811298370361328e+00 -1.6374300003051758e+01 9.9598602294921875e+01 -5.2093396186828613e+00 -1.6253101348876953e+01 9.9598602294921875e+01 -5.4514598846435547e+00 -1.6572599411010742e+01 9.9598602294921875e+01 -5.6536498069763184e+00 -1.6738399505615234e+01 9.5780502319335938e+01 -5.7041997909545898e+00 -1.6771501541137695e+01 9.9598602294921875e+01 -5.7061901092529297e+00 -1.6767999649047852e+01 9.9598602294921875e+01 -5.8815598487854004e+00 -1.6866600036621094e+01 9.5780502319335938e+01 -6.0316200256347656e+00 -1.6924999237060547e+01 9.9598602294921875e+01 -6.0334100723266602e+00 -1.6919898986816406e+01 9.9598602294921875e+01 -6.1282601356506348e+00 -1.6953199386596680e+01 9.5780502319335938e+01 -6.3862500190734863e+00 -1.6995700836181641e+01 9.9598602294921875e+01 -6.3862500190734863e+00 -1.6995700836181641e+01 9.9598602294921875e+01 -6.6476998329162598e+00 -1.6992698669433594e+01 9.5780502319335938e+01 -6.7474999427795410e+00 -1.6979400634765625e+01 9.9598602294921875e+01 -7.0929298400878906e+00 -1.6873399734497070e+01 9.5780502319335938e+01 -7.0943598747253418e+00 -1.6877201080322266e+01 9.9598602294921875e+01 -6.9046702384948730e+00 -1.6944398880004883e+01 9.9598602294921875e+01 -6.7465000152587891e+00 -1.6974100112915039e+01 9.9598602294921875e+01 -7.1493296623229980e+00 -1.6852199554443359e+01 9.9598602294921875e+01 -7.3742699623107910e+00 -1.6718900680541992e+01 9.5780502319335938e+01 -7.4066801071166992e+00 -1.6694999694824219e+01 9.9598602294921875e+01 -7.4047398567199707e+00 -1.6692699432373047e+01 9.9598602294921875e+01 -7.5726404190063477e+00 -1.6548500061035156e+01 9.5780502319335938e+01 -7.6663098335266113e+00 -1.6443298339843750e+01 9.9598602294921875e+01 -7.8567395210266113e+00 -1.6135898590087891e+01 9.5780502319335938e+01 -7.8581495285034180e+00 -1.6136699676513672e+01 9.9598602294921875e+01 -7.7384200096130371e+00 -1.6346401214599609e+01 9.9598602294921875e+01 -7.6619200706481934e+00 -1.6439701080322266e+01 9.9598602294921875e+01 -7.8665800094604492e+00 -1.6118400573730469e+01 9.9598602294921875e+01 -7.9532098770141602e+00 -1.5871700286865234e+01 9.5780502319335938e+01 -7.9710698127746582e+00 -1.5793200492858887e+01 9.9598602294921875e+01 -7.9936199188232422e+00 -1.5432699203491211e+01 9.5780502319335938e+01 -7.9984898567199707e+00 -1.5432600021362305e+01 9.9598602294921875e+01 -7.9956798553466797e+00 -1.5613699913024902e+01 9.9598602294921875e+01 -7.9662699699401855e+00 -1.5792399406433105e+01 9.9598602294921875e+01 -7.9927101135253906e+00 -1.5352300643920898e+01 9.9598602294921875e+01 -7.9443798065185547e+00 -1.5095299720764160e+01 9.5780502319335938e+01 -7.9388198852539062e+00 -1.5076000213623047e+01 9.9598602294921875e+01 -7.9373002052307129e+00 -1.5076600074768066e+01 9.9598602294921875e+01 -7.8521695137023926e+00 -1.4850700378417969e+01 9.5780502319335938e+01 -7.7955403327941895e+00 -1.4743999481201172e+01 9.9598602294921875e+01 -7.5747098922729492e+00 -1.4457800865173340e+01 9.5780502319335938e+01 -7.5769600868225098e+00 -1.4455899238586426e+01 9.9598602294921875e+01 -7.7188701629638672e+00 -1.4625699996948242e+01 9.9598602294921875e+01 -7.7906599044799805e+00 -1.4746899604797363e+01 9.9598602294921875e+01 -7.5485401153564453e+00 -1.4427400588989258e+01 9.9598602294921875e+01 -7.3463497161865234e+00 -1.4261599540710449e+01 9.5780502319335938e+01 -7.2957997322082520e+00 -1.4228500366210938e+01 9.9598602294921875e+01 -7.2938103675842285e+00 -1.4232000350952148e+01 9.9598602294921875e+01 -7.1184396743774414e+00 -1.4133399963378906e+01 9.5780502319335938e+01 -6.9683799743652344e+00 -1.4074999809265137e+01 9.9598602294921875e+01 -6.9665899276733398e+00 -1.4080100059509277e+01 9.9598602294921875e+01 -6.8717398643493652e+00 -1.4046800613403320e+01 9.9598602294921875e+01 -6.6137499809265137e+00 -1.4004300117492676e+01 9.5500000000000000e+01 -6.8807897567749023e+00 -1.4341499328613281e+01 9.5500000000000000e+01 -7.1469802856445312e+00 -1.4466300010681152e+01 9.5500000000000000e+01 -7.3755698204040527e+00 -1.4651100158691406e+01 9.5500000000000000e+01 -7.5532698631286621e+00 -1.4885299682617188e+01 9.5500000000000000e+01 -7.6697597503662109e+00 -1.5155299186706543e+01 9.5500000000000000e+01 -7.7182703018188477e+00 -1.5445199966430664e+01 9.5500000000000000e+01 -7.6959800720214844e+00 -1.5738399505615234e+01 9.5500000000000000e+01 -7.6041798591613770e+00 -1.6017700195312500e+01 9.5500000000000000e+01 -7.4482097625732422e+00 -1.6266899108886719e+01 9.5500000000000000e+01 -7.2371296882629395e+00 -1.6471500396728516e+01 9.5500000000000000e+01 -6.9832100868225098e+00 -1.6619699478149414e+01 9.5500000000000000e+01 -6.7012200355529785e+00 -1.6702798843383789e+01 9.5500000000000000e+01 -6.4075198173522949e+00 -1.6715999603271484e+01 9.5500000000000000e+01 -6.1192097663879395e+00 -1.6658500671386719e+01 9.5500000000000000e+01 -5.8530201911926270e+00 -1.6533700942993164e+01 9.5500000000000000e+01 -5.6244297027587891e+00 -1.6348899841308594e+01 9.5500000000000000e+01 -5.4467301368713379e+00 -1.6114700317382812e+01 9.5500000000000000e+01 -5.3302397727966309e+00 -1.5844700813293457e+01 9.5500000000000000e+01 -5.2817301750183105e+00 -1.5554800033569336e+01 9.5500000000000000e+01 -5.3040199279785156e+00 -1.5261599540710449e+01 9.5500000000000000e+01 -5.3958196640014648e+00 -1.4982299804687500e+01 9.5500000000000000e+01 -5.5517897605895996e+00 -1.4733099937438965e+01 9.5500000000000000e+01 -5.7628698348999023e+00 -1.4528499603271484e+01 9.5500000000000000e+01 -6.0167899131774902e+00 -1.4380300521850586e+01 9.5500000000000000e+01 -6.2987799644470215e+00 -1.4297200202941895e+01 9.5500000000000000e+01 -6.5924801826477051e+00 -1.4283999443054199e+01 9.9636802673339844e+01 -6.0932798385620117e+00 -1.4048299789428711e+01 9.9636802673339844e+01 -6.3515501022338867e+00 -1.3999699592590332e+01 9.9636802673339844e+01 -5.8473696708679199e+00 -1.4140999794006348e+01 9.9636802673339844e+01 -5.6212897300720215e+00 -1.4274899482727051e+01 9.9636802673339844e+01 -5.4219098091125488e+00 -1.4446100234985352e+01 9.9636802673339844e+01 -5.2552900314331055e+00 -1.4649399757385254e+01 9.9636802673339844e+01 -5.1264896392822266e+00 -1.4878399848937988e+01 9.9636802673339844e+01 -5.0394201278686523e+00 -1.5126399993896484e+01 9.9636802673339844e+01 -4.9967298507690430e+00 -1.5385700225830078e+01 9.9636802673339844e+01 -4.9997096061706543e+00 -1.5648499488830566e+01 9.9636802673339844e+01 -5.0482897758483887e+00 -1.5906701087951660e+01 9.9636802673339844e+01 -5.1409702301025391e+00 -1.6152599334716797e+01 9.9636802673339844e+01 -5.2749400138854980e+00 -1.6378700256347656e+01 9.9636802673339844e+01 -5.4461402893066406e+00 -1.6578100204467773e+01 9.9636802673339844e+01 -5.6493597030639648e+00 -1.6744699478149414e+01 9.9636802673339844e+01 -5.8784198760986328e+00 -1.6873498916625977e+01 9.9636802673339844e+01 -6.1263699531555176e+00 -1.6960599899291992e+01 9.9636802673339844e+01 -6.3856797218322754e+00 -1.7003299713134766e+01 9.9636802673339844e+01 -6.6484503746032715e+00 -1.7000301361083984e+01 9.9636802673339844e+01 -6.9067196846008301e+00 -1.6951700210571289e+01 9.9636802673339844e+01 -7.1526298522949219e+00 -1.6859001159667969e+01 9.9636802673339844e+01 -7.3787097930908203e+00 -1.6725101470947266e+01 9.9636802673339844e+01 -7.5780897140502930e+00 -1.6553899765014648e+01 9.9636802673339844e+01 -7.7447099685668945e+00 -1.6350601196289062e+01 9.9636802673339844e+01 -7.8735098838806152e+00 -1.6121599197387695e+01 9.9636802673339844e+01 -7.9605803489685059e+00 -1.5873600006103516e+01 9.9636802673339844e+01 -8.0032701492309570e+00 -1.5614299774169922e+01 9.9636802673339844e+01 -8.0002899169921875e+00 -1.5351500511169434e+01 9.9636802673339844e+01 -7.9517102241516113e+00 -1.5093299865722656e+01 9.9636802673339844e+01 -7.8590297698974609e+00 -1.4847399711608887e+01 9.9636802673339844e+01 -7.7250599861145020e+00 -1.4621299743652344e+01 9.9636802673339844e+01 -7.5538601875305176e+00 -1.4421899795532227e+01 9.9636802673339844e+01 -7.3506398200988770e+00 -1.4255300521850586e+01 9.9636802673339844e+01 -7.1215801239013672e+00 -1.4126500129699707e+01 9.9636802673339844e+01 -6.6143198013305664e+00 -1.3996700286865234e+01 9.9636802673339844e+01 -6.8736300468444824e+00 -1.4039400100708008e+01 1.0040000152587891e+02 -5.8484797477722168e+00 -1.6453300476074219e+01 1.0040000152587891e+02 -5.5985503196716309e+00 -1.5932900428771973e+01 1.0040000152587891e+02 -5.3486199378967285e+00 -1.5412399291992188e+01 1.0040000152587891e+02 -6.9998602867126465e+00 -1.6540899276733398e+01 1.0040000152587891e+02 -6.4241700172424316e+00 -1.6497098922729492e+01 1.0040000152587891e+02 -7.6513795852661133e+00 -1.5587599754333496e+01 1.0040000152587891e+02 -7.3256196975708008e+00 -1.6064201354980469e+01 1.0040000152587891e+02 -7.1515197753906250e+00 -1.4546699523925781e+01 1.0040000152587891e+02 -7.4014501571655273e+00 -1.5067099571228027e+01 1.0040000152587891e+02 -6.0001401901245117e+00 -1.4459099769592285e+01 1.0040000152587891e+02 -6.5758299827575684e+00 -1.4502900123596191e+01 1.0040000152587891e+02 -5.6743798255920410e+00 -1.4935799598693848e+01 1.0040000152587891e+02 -5.7662000656127930e+00 -1.6179399490356445e+01 1.0040000152587891e+02 -5.9990396499633789e+00 -1.6365499496459961e+01 1.0040000152587891e+02 -6.2763996124267578e+00 -1.6474699020385742e+01 1.0040000152587891e+02 -5.5995097160339355e+00 -1.5065099716186523e+01 1.0040000152587891e+02 -5.5113301277160645e+00 -1.5349900245666504e+01 1.0040000152587891e+02 -5.5109996795654297e+00 -1.5647899627685547e+01 1.0040000152587891e+02 -6.2785601615905762e+00 -1.4524799346923828e+01 1.0040000152587891e+02 -6.0009598731994629e+00 -1.4633399963378906e+01 1.0040000152587891e+02 -5.7676997184753418e+00 -1.4819000244140625e+01 1.0040000152587891e+02 -6.8663697242736816e+00 -1.4569500923156738e+01 1.0040000152587891e+02 -7.3268599510192871e+00 -1.4937600135803223e+01 1.0040000152587891e+02 -7.1243500709533691e+00 -1.4718900680541992e+01 1.0040000152587891e+02 -7.4552497863769531e+00 -1.5795801162719727e+01 1.0040000152587891e+02 -7.5000000000000000e+00 -1.5501099586486816e+01 1.0040000152587891e+02 -7.4558997154235840e+00 -1.5206299781799316e+01 1.0040000152587891e+02 -6.5736298561096191e+00 -1.6497299194335938e+01 1.0040000152587891e+02 -6.8643097877502441e+00 -1.6431299209594727e+01 1.0040000152587891e+02 -7.1226296424865723e+00 -1.6282501220703125e+01 9.9822700500488281e+01 -6.5000000000000000e+00 -1.5500000000000000e+01 1.0150000000000000e+02 3.1999900817871094e+01 1.1540900230407715e+01 1.0150000000000000e+02 3.2736301422119141e+01 1.2978799819946289e+01 1.0150000000000000e+02 3.2273799896240234e+01 1.3159699440002441e+01 1.0150000000000000e+02 3.2651397705078125e+01 1.0587599754333496e+01 1.0150000000000000e+02 3.4268699645996094e+01 1.0585900306701660e+01 1.0150000000000000e+02 3.4208801269531250e+01 1.1078899383544922e+01 1.0150000000000000e+02 3.0848499298095703e+01 1.1453299522399902e+01 1.0150000000000000e+02 2.9902999877929688e+01 1.2763299942016602e+01 1.0150000000000000e+02 2.9524600982666016e+01 1.2441800117492676e+01 1.0150000000000000e+02 3.1000099182128906e+01 9.4590997695922852e+00 1.0150000000000000e+02 3.0490900039672852e+01 7.9203600883483887e+00 1.0150000000000000e+02 3.0967699050903320e+01 7.7816300392150879e+00 1.0150000000000000e+02 3.0332799911499023e+01 1.3012100219726562e+01 1.0150000000000000e+02 3.0800100326538086e+01 1.3180100440979004e+01 1.0150000000000000e+02 3.1289901733398438e+01 1.3262000083923340e+01 1.0150000000000000e+02 3.1786500930786133e+01 1.3255099296569824e+01 1.0150000000000000e+02 3.3159099578857422e+01 1.2718199729919434e+01 1.0150000000000000e+02 3.3528499603271484e+01 1.2386300086975098e+01 1.0150000000000000e+02 3.3832698822021484e+01 1.1993800163269043e+01 1.0150000000000000e+02 3.4061901092529297e+01 1.1553299903869629e+01 1.0150000000000000e+02 3.4239501953125000e+01 1.0090200424194336e+01 1.0150000000000000e+02 3.4122299194335938e+01 9.6076002120971680e+00 1.0150000000000000e+02 3.3920799255371094e+01 9.1537199020385742e+00 1.0150000000000000e+02 3.2151500701904297e+01 9.5466594696044922e+00 1.0150000000000000e+02 3.3641498565673828e+01 8.7431001663208008e+00 1.0150000000000000e+02 3.3293399810791016e+01 8.3889398574829102e+00 1.0150000000000000e+02 3.2887599945068359e+01 8.1026391983032227e+00 1.0150000000000000e+02 3.2437297821044922e+01 7.8933901786804199e+00 1.0150000000000000e+02 3.1956798553466797e+01 7.7679200172424316e+00 1.0150000000000000e+02 3.1461599349975586e+01 7.7302598953247070e+00 1.0150000000000000e+02 2.8750200271606445e+01 1.0166199684143066e+01 1.0150000000000000e+02 2.8854000091552734e+01 9.6806001663208008e+00 1.0150000000000000e+02 3.0348600387573242e+01 1.0412399291992188e+01 1.0150000000000000e+02 2.9042800903320312e+01 9.2213096618652344e+00 1.0150000000000000e+02 3.0046501159667969e+01 8.1420106887817383e+00 1.0150000000000000e+02 2.9648799896240234e+01 8.4394493103027344e+00 1.0150000000000000e+02 2.9310600280761719e+01 8.8031005859375000e+00 1.0150000000000000e+02 2.8734800338745117e+01 1.0662600517272949e+01 1.0150000000000000e+02 2.8808200836181641e+01 1.1153699874877930e+01 1.0150000000000000e+02 2.8968200683593750e+01 1.1623900413513184e+01 1.0150000000000000e+02 2.9209600448608398e+01 1.2057900428771973e+01 1.0091000366210938e+02 3.0800100326538086e+01 1.3180100440979004e+01 1.0091000366210938e+02 3.1289901733398438e+01 1.3262000083923340e+01 1.0091000366210938e+02 3.1786500930786133e+01 1.3255099296569824e+01 1.0091000366210938e+02 3.2273799896240234e+01 1.3159699440002441e+01 1.0091000366210938e+02 3.2736301422119141e+01 1.2978799819946289e+01 1.0091000366210938e+02 3.3159099578857422e+01 1.2718199729919434e+01 1.0091000366210938e+02 3.3528499603271484e+01 1.2386300086975098e+01 1.0091000366210938e+02 3.3832698822021484e+01 1.1993800163269043e+01 1.0091000366210938e+02 3.4061901092529297e+01 1.1553299903869629e+01 1.0091000366210938e+02 3.4208801269531250e+01 1.1078899383544922e+01 1.0091000366210938e+02 3.4268699645996094e+01 1.0585900306701660e+01 1.0091000366210938e+02 3.4239501953125000e+01 1.0090200424194336e+01 1.0091000366210938e+02 3.4122299194335938e+01 9.6076002120971680e+00 1.0091000366210938e+02 3.3920799255371094e+01 9.1537199020385742e+00 1.0091000366210938e+02 3.3641498565673828e+01 8.7431001663208008e+00 1.0091000366210938e+02 3.3293399810791016e+01 8.3889398574829102e+00 1.0091000366210938e+02 3.2887599945068359e+01 8.1026391983032227e+00 1.0091000366210938e+02 3.2437297821044922e+01 7.8933901786804199e+00 1.0091000366210938e+02 3.1956798553466797e+01 7.7679200172424316e+00 1.0091000366210938e+02 3.1461599349975586e+01 7.7302598953247070e+00 1.0091000366210938e+02 3.0967699050903320e+01 7.7816300392150879e+00 1.0091000366210938e+02 3.0490900039672852e+01 7.9203600883483887e+00 1.0091000366210938e+02 3.0046501159667969e+01 8.1420106887817383e+00 1.0091000366210938e+02 2.9648799896240234e+01 8.4394493103027344e+00 1.0091000366210938e+02 2.9310600280761719e+01 8.8031005859375000e+00 1.0091000366210938e+02 2.9042800903320312e+01 9.2213096618652344e+00 1.0091000366210938e+02 2.8854000091552734e+01 9.6806001663208008e+00 1.0091000366210938e+02 2.8750200271606445e+01 1.0166199684143066e+01 1.0091000366210938e+02 2.8734800338745117e+01 1.0662600517272949e+01 1.0091000366210938e+02 2.8808200836181641e+01 1.1153699874877930e+01 1.0091000366210938e+02 2.8968200683593750e+01 1.1623900413513184e+01 1.0091000366210938e+02 2.9209600448608398e+01 1.2057900428771973e+01 1.0091000366210938e+02 2.9524600982666016e+01 1.2441800117492676e+01 1.0091000366210938e+02 2.9902999877929688e+01 1.2763299942016602e+01 1.0091000366210938e+02 3.0332799911499023e+01 1.3012100219726562e+01 9.9669296264648438e+01 3.1658102035522461e+01 1.2020500183105469e+01 9.9669296264648438e+01 3.1912599563598633e+01 1.1972599983215332e+01 9.9669296264648438e+01 3.1926799774169922e+01 1.1967200279235840e+01 9.9669296264648438e+01 3.2161998748779297e+01 1.1878600120544434e+01 9.9669296264648438e+01 3.2181598663330078e+01 1.1866999626159668e+01 9.9669296264648438e+01 3.2391300201416016e+01 1.1742699623107910e+01 9.9669296264648438e+01 3.2414398193359375e+01 1.1722900390625000e+01 9.9669296264648438e+01 3.2593601226806641e+01 1.1569000244140625e+01 9.9669296264648438e+01 3.2617698669433594e+01 1.1539599418640137e+01 9.9669296264648438e+01 3.2762599945068359e+01 1.1362899780273438e+01 9.9669296264648438e+01 3.2784999847412109e+01 1.1323100090026855e+01 9.9669296264648438e+01 3.2893299102783203e+01 1.1130499839782715e+01 9.9669296264648438e+01 3.2910900115966797e+01 1.1080300331115723e+01 9.9669296264648438e+01 3.2981601715087891e+01 1.0878999710083008e+01 9.9669296264648438e+01 3.2991497039794922e+01 1.0818899154663086e+01 9.9669296264648438e+01 3.3024898529052734e+01 1.0616000175476074e+01 9.9669296264648438e+01 3.3024097442626953e+01 1.0547499656677246e+01 9.9669296264648438e+01 3.3021900177001953e+01 1.0349400520324707e+01 9.9669296264648438e+01 3.3007801055908203e+01 1.0274600028991699e+01 9.9669296264648438e+01 3.2972599029541016e+01 1.0087399482727051e+01 9.9669296264648438e+01 3.2943099975585938e+01 1.0009099960327148e+01 9.9669296264648438e+01 3.2878601074218750e+01 9.8379898071289062e+00 9.9669296264648438e+01 3.2832000732421875e+01 9.7594003677368164e+00 9.9669296264648438e+01 3.2742702484130859e+01 9.6086597442626953e+00 9.9669296264648438e+01 3.2678203582763672e+01 9.5335702896118164e+00 9.9669296264648438e+01 3.2569000244140625e+01 9.4064102172851562e+00 9.9669296264648438e+01 3.2486598968505859e+01 9.3388299942016602e+00 9.9669296264648438e+01 3.2362899780273438e+01 9.2374000549316406e+00 9.9669296264648438e+01 3.2263301849365234e+01 9.1814098358154297e+00 9.9669296264648438e+01 3.2130496978759766e+01 9.1067399978637695e+00 9.9669296264648438e+01 3.2015598297119141e+01 9.0663700103759766e+00 9.9669296264648438e+01 3.1878999710083008e+01 9.0184202194213867e+00 9.9669296264648438e+01 3.1751199722290039e+01 8.9973802566528320e+00 9.9669296264648438e+01 3.1615999221801758e+01 8.9751100540161133e+00 9.9669296264648438e+01 3.1478900909423828e+01 8.9766702651977539e+00 9.9669296264648438e+01 3.0944900512695312e+01 9.0811500549316406e+00 9.9669296264648438e+01 3.1087400436401367e+01 9.0274105072021484e+00 9.9669296264648438e+01 3.1207201004028320e+01 9.0048904418945312e+00 9.9669296264648438e+01 3.1349397659301758e+01 8.9781398773193359e+00 9.9669296264648438e+01 3.0481500625610352e+01 9.3665103912353516e+00 9.9669296264648438e+01 3.0608699798583984e+01 9.2573204040527344e+00 9.9669296264648438e+01 3.0700401306152344e+01 9.2029800415039062e+00 9.9669296264648438e+01 3.0837999343872070e+01 9.1214303970336914e+00 9.9669296264648438e+01 3.0147800445556641e+01 9.7965002059936523e+00 9.9669296264648438e+01 3.0237400054931641e+01 9.6371202468872070e+00 9.9669296264648438e+01 3.0295299530029297e+01 9.5664806365966797e+00 9.9669296264648438e+01 3.0406400680541992e+01 9.4309806823730469e+00 9.9669296264648438e+01 2.9986200332641602e+01 1.0316500663757324e+01 9.9669296264648438e+01 3.0018400192260742e+01 1.0121000289916992e+01 9.9669296264648438e+01 3.0043600082397461e+01 1.0049200057983398e+01 9.9669296264648438e+01 3.0106698989868164e+01 9.8694791793823242e+00 9.9669296264648438e+01 3.0017599105834961e+01 1.0860199928283691e+01 9.9669296264648438e+01 2.9978099822998047e+01 1.0650600433349609e+01 9.9669296264648438e+01 2.9977500915527344e+01 1.0589699745178223e+01 9.9669296264648438e+01 2.9975099563598633e+01 1.0383999824523926e+01 9.9669296264648438e+01 3.0237899780273438e+01 1.1358599662780762e+01 9.9669296264648438e+01 3.0121398925781250e+01 1.1161999702453613e+01 9.9669296264648438e+01 3.0105300903320312e+01 1.1119299888610840e+01 9.9669296264648438e+01 3.0027400970458984e+01 1.0912599563598633e+01 9.9669296264648438e+01 3.0619501113891602e+01 1.1748099327087402e+01 9.9669296264648438e+01 3.0430999755859375e+01 1.1593600273132324e+01 9.9669296264648438e+01 3.0411201477050781e+01 1.1570500373840332e+01 9.9669296264648438e+01 3.0257299423217773e+01 1.1391300201416016e+01 9.9669296264648438e+01 3.1113800048828125e+01 1.1979100227355957e+01 9.9669296264648438e+01 3.0869501113891602e+01 1.1893300056457520e+01 9.9669296264648438e+01 3.0856199264526367e+01 1.1885800361633301e+01 9.9669296264648438e+01 3.0637100219726562e+01 1.1762599945068359e+01 9.9669296264648438e+01 3.1650598526000977e+01 1.2021900177001953e+01 9.9669296264648438e+01 3.1383998870849609e+01 1.2024899482727051e+01 9.9669296264648438e+01 3.1121000289916992e+01 1.1981599807739258e+01 9.9598602294921875e+01 3.1647701263427734e+01 1.1992700576782227e+01 9.5780502319335938e+01 3.1747501373291016e+01 1.1979400634765625e+01 9.5780502319335938e+01 3.1386301040649414e+01 1.1995699882507324e+01 9.9598602294921875e+01 3.2092899322509766e+01 1.1873399734497070e+01 9.5780502319335938e+01 3.2094398498535156e+01 1.1877199172973633e+01 9.9598602294921875e+01 3.1904701232910156e+01 1.1944399833679199e+01 9.9598602294921875e+01 3.1746500015258789e+01 1.1974100112915039e+01 9.9598602294921875e+01 3.2149299621582031e+01 1.1852200508117676e+01 9.9598602294921875e+01 3.2374301910400391e+01 1.1718899726867676e+01 9.5780502319335938e+01 3.2406700134277344e+01 1.1695000648498535e+01 9.9598602294921875e+01 3.2404697418212891e+01 1.1692700386047363e+01 9.9598602294921875e+01 3.2572601318359375e+01 1.1548499107360840e+01 9.5780502319335938e+01 3.2666297912597656e+01 1.1443300247192383e+01 9.9598602294921875e+01 3.2856700897216797e+01 1.1135900497436523e+01 9.5780502319335938e+01 3.2858200073242188e+01 1.1136700630187988e+01 9.9598602294921875e+01 3.2738399505615234e+01 1.1346399307250977e+01 9.9598602294921875e+01 3.2661899566650391e+01 1.1439700126647949e+01 9.9598602294921875e+01 3.2866600036621094e+01 1.1118399620056152e+01 9.9598602294921875e+01 3.2953197479248047e+01 1.0871700286865234e+01 9.5780502319335938e+01 3.2971099853515625e+01 1.0793199539184570e+01 9.9598602294921875e+01 3.2993598937988281e+01 1.0432700157165527e+01 9.5780502319335938e+01 3.2998497009277344e+01 1.0432600021362305e+01 9.9598602294921875e+01 3.2995700836181641e+01 1.0613699913024902e+01 9.9598602294921875e+01 3.2966300964355469e+01 1.0792399406433105e+01 9.9598602294921875e+01 3.2992698669433594e+01 1.0352299690246582e+01 9.9598602294921875e+01 3.2944400787353516e+01 1.0095299720764160e+01 9.5780502319335938e+01 3.2938800811767578e+01 1.0076000213623047e+01 9.9598602294921875e+01 3.2937297821044922e+01 1.0076600074768066e+01 9.9598602294921875e+01 3.2852199554443359e+01 9.8506698608398438e+00 9.5780502319335938e+01 3.2795501708984375e+01 9.7439699172973633e+00 9.9598602294921875e+01 3.2574699401855469e+01 9.4578304290771484e+00 9.5780502319335938e+01 3.2576999664306641e+01 9.4558906555175781e+00 9.9598602294921875e+01 3.2718898773193359e+01 9.6257305145263672e+00 9.9598602294921875e+01 3.2790702819824219e+01 9.7468595504760742e+00 9.9598602294921875e+01 3.2548500061035156e+01 9.4273605346679688e+00 9.9598602294921875e+01 3.2346302032470703e+01 9.2615699768066406e+00 9.5780502319335938e+01 3.2295799255371094e+01 9.2284994125366211e+00 9.9598602294921875e+01 3.2293800354003906e+01 9.2320299148559570e+00 9.9598602294921875e+01 3.2118400573730469e+01 9.1334199905395508e+00 9.5780502319335938e+01 3.1968399047851562e+01 9.0749998092651367e+00 9.9598602294921875e+01 3.1966600418090820e+01 9.0801000595092773e+00 9.9598602294921875e+01 3.1871698379516602e+01 9.0467901229858398e+00 9.5780502319335938e+01 3.1613700866699219e+01 9.0043201446533203e+00 9.9598602294921875e+01 3.1613700866699219e+01 9.0043201446533203e+00 9.9598602294921875e+01 3.1352300643920898e+01 9.0072898864746094e+00 9.5780502319335938e+01 3.1252500534057617e+01 9.0205602645874023e+00 9.9598602294921875e+01 3.0907100677490234e+01 9.1265697479248047e+00 9.5780502319335938e+01 3.0905601501464844e+01 9.1227798461914062e+00 9.9598602294921875e+01 3.1095300674438477e+01 9.0556201934814453e+00 9.9598602294921875e+01 3.1253501892089844e+01 9.0258703231811523e+00 9.9598602294921875e+01 3.0850698471069336e+01 9.1478300094604492e+00 9.9598602294921875e+01 3.0625699996948242e+01 9.2811298370361328e+00 9.5780502319335938e+01 3.0593299865722656e+01 9.3050403594970703e+00 9.9598602294921875e+01 3.0595300674438477e+01 9.3072900772094727e+00 9.9598602294921875e+01 3.0427400588989258e+01 9.4514598846435547e+00 9.5780502319335938e+01 3.0333700180053711e+01 9.5567502975463867e+00 9.9598602294921875e+01 3.0143301010131836e+01 9.8640604019165039e+00 9.5780502319335938e+01 3.0141799926757812e+01 9.8632707595825195e+00 9.9598602294921875e+01 3.0261600494384766e+01 9.6536502838134766e+00 9.9598602294921875e+01 3.0338098526000977e+01 9.5603399276733398e+00 9.9598602294921875e+01 3.0133399963378906e+01 9.8815593719482422e+00 9.9598602294921875e+01 3.0046800613403320e+01 1.0128299713134766e+01 9.5780502319335938e+01 3.0028900146484375e+01 1.0206799507141113e+01 9.9598602294921875e+01 3.0006399154663086e+01 1.0567299842834473e+01 9.5780502319335938e+01 3.0001501083374023e+01 1.0567399978637695e+01 9.9598602294921875e+01 3.0004301071166992e+01 1.0386300086975098e+01 9.9598602294921875e+01 3.0033700942993164e+01 1.0207599639892578e+01 9.9598602294921875e+01 3.0007301330566406e+01 1.0647700309753418e+01 9.9598602294921875e+01 3.0055599212646484e+01 1.0904699325561523e+01 9.5780502319335938e+01 3.0061201095581055e+01 1.0924000740051270e+01 9.9598602294921875e+01 3.0062700271606445e+01 1.0923399925231934e+01 9.9598602294921875e+01 3.0147800445556641e+01 1.1149300575256348e+01 9.5780502319335938e+01 3.0204498291015625e+01 1.1255999565124512e+01 9.9598602294921875e+01 3.0425300598144531e+01 1.1542200088500977e+01 9.5780502319335938e+01 3.0423000335693359e+01 1.1544099807739258e+01 9.9598602294921875e+01 3.0281101226806641e+01 1.1374300003051758e+01 9.9598602294921875e+01 3.0209299087524414e+01 1.1253099441528320e+01 9.9598602294921875e+01 3.0451499938964844e+01 1.1572600364685059e+01 9.9598602294921875e+01 3.0653699874877930e+01 1.1738399505615234e+01 9.5780502319335938e+01 3.0704200744628906e+01 1.1771499633789062e+01 9.9598602294921875e+01 3.0706201553344727e+01 1.1768000602722168e+01 9.9598602294921875e+01 3.0881601333618164e+01 1.1866600036621094e+01 9.5780502319335938e+01 3.1031599044799805e+01 1.1925000190734863e+01 9.9598602294921875e+01 3.1033399581909180e+01 1.1919899940490723e+01 9.9598602294921875e+01 3.1128299713134766e+01 1.1953200340270996e+01 9.9598602294921875e+01 3.1386301040649414e+01 1.1995699882507324e+01 9.5500000000000000e+01 3.1119199752807617e+01 1.1658499717712402e+01 9.5500000000000000e+01 3.0852998733520508e+01 1.1533699989318848e+01 9.5500000000000000e+01 3.0624401092529297e+01 1.1348900794982910e+01 9.5500000000000000e+01 3.0446701049804688e+01 1.1114699363708496e+01 9.5500000000000000e+01 3.0330200195312500e+01 1.0844699859619141e+01 9.5500000000000000e+01 3.0281700134277344e+01 1.0554800033569336e+01 9.5500000000000000e+01 3.0303998947143555e+01 1.0261599540710449e+01 9.5500000000000000e+01 3.0395799636840820e+01 9.9823398590087891e+00 9.5500000000000000e+01 3.0551799774169922e+01 9.7331304550170898e+00 9.5500000000000000e+01 3.0762899398803711e+01 9.5284996032714844e+00 9.5500000000000000e+01 3.1016799926757812e+01 9.3803205490112305e+00 9.5500000000000000e+01 3.1298801422119141e+01 9.2972202301025391e+00 9.5500000000000000e+01 3.1592498779296875e+01 9.2840099334716797e+00 9.5500000000000000e+01 3.1880800247192383e+01 9.3414802551269531e+00 9.5500000000000000e+01 3.2147003173828125e+01 9.4662704467773438e+00 9.5500000000000000e+01 3.2375598907470703e+01 9.6511497497558594e+00 9.5500000000000000e+01 3.2553298950195312e+01 9.8853502273559570e+00 9.5500000000000000e+01 3.2669799804687500e+01 1.0155300140380859e+01 9.5500000000000000e+01 3.2718299865722656e+01 1.0445199966430664e+01 9.5500000000000000e+01 3.2696002960205078e+01 1.0738399505615234e+01 9.5500000000000000e+01 3.2604198455810547e+01 1.1017700195312500e+01 9.5500000000000000e+01 3.2448200225830078e+01 1.1266900062561035e+01 9.5500000000000000e+01 3.2237102508544922e+01 1.1471499443054199e+01 9.5500000000000000e+01 3.1983200073242188e+01 1.1619700431823730e+01 9.5500000000000000e+01 3.1701200485229492e+01 1.1702799797058105e+01 9.5500000000000000e+01 3.1407501220703125e+01 1.1715999603271484e+01 9.9636802673339844e+01 3.1906702041625977e+01 1.1951700210571289e+01 9.9636802673339844e+01 3.1648502349853516e+01 1.2000300407409668e+01 9.9636802673339844e+01 3.2152599334716797e+01 1.1858999252319336e+01 9.9636802673339844e+01 3.2378700256347656e+01 1.1725099563598633e+01 9.9636802673339844e+01 3.2578098297119141e+01 1.1553900718688965e+01 9.9636802673339844e+01 3.2744697570800781e+01 1.1350600242614746e+01 9.9636802673339844e+01 3.2873500823974609e+01 1.1121600151062012e+01 9.9636802673339844e+01 3.2960601806640625e+01 1.0873600006103516e+01 9.9636802673339844e+01 3.3003299713134766e+01 1.0614299774169922e+01 9.9636802673339844e+01 3.3000301361083984e+01 1.0351499557495117e+01 9.9636802673339844e+01 3.2951702117919922e+01 1.0093299865722656e+01 9.9636802673339844e+01 3.2859001159667969e+01 9.8473701477050781e+00 9.9636802673339844e+01 3.2725097656250000e+01 9.6212892532348633e+00 9.9636802673339844e+01 3.2553901672363281e+01 9.4219102859497070e+00 9.9636802673339844e+01 3.2350601196289062e+01 9.2552900314331055e+00 9.9636802673339844e+01 3.2121597290039062e+01 9.1264896392822266e+00 9.9636802673339844e+01 3.1873598098754883e+01 9.0394201278686523e+00 9.9636802673339844e+01 3.1614299774169922e+01 8.9967298507690430e+00 9.9636802673339844e+01 3.1351499557495117e+01 8.9997205734252930e+00 9.9636802673339844e+01 3.1093299865722656e+01 9.0482892990112305e+00 9.9636802673339844e+01 3.0847400665283203e+01 9.1409702301025391e+00 9.9636802673339844e+01 3.0621299743652344e+01 9.2749395370483398e+00 9.9636802673339844e+01 3.0421899795532227e+01 9.4461402893066406e+00 9.9636802673339844e+01 3.0255300521850586e+01 9.6493501663208008e+00 9.9636802673339844e+01 3.0126501083374023e+01 9.8784198760986328e+00 9.9636802673339844e+01 3.0039400100708008e+01 1.0126399993896484e+01 9.9636802673339844e+01 2.9996700286865234e+01 1.0385699272155762e+01 9.9636802673339844e+01 2.9999698638916016e+01 1.0648500442504883e+01 9.9636802673339844e+01 3.0048299789428711e+01 1.0906700134277344e+01 9.9636802673339844e+01 3.0140998840332031e+01 1.1152600288391113e+01 9.9636802673339844e+01 3.0274900436401367e+01 1.1378700256347656e+01 9.9636802673339844e+01 3.0446098327636719e+01 1.1578100204467773e+01 9.9636802673339844e+01 3.0649398803710938e+01 1.1744700431823730e+01 9.9636802673339844e+01 3.0878400802612305e+01 1.1873500823974609e+01 9.9636802673339844e+01 3.1385700225830078e+01 1.2003299713134766e+01 9.9636802673339844e+01 3.1126399993896484e+01 1.1960599899291992e+01 1.0040000152587891e+02 3.2151500701904297e+01 9.5466594696044922e+00 1.0040000152587891e+02 3.2401401519775391e+01 1.0067099571228027e+01 1.0040000152587891e+02 3.2651397705078125e+01 1.0587599754333496e+01 1.0040000152587891e+02 3.1000099182128906e+01 9.4590997695922852e+00 1.0040000152587891e+02 3.1575798034667969e+01 9.5028800964355469e+00 1.0040000152587891e+02 3.0348600387573242e+01 1.0412399291992188e+01 1.0040000152587891e+02 3.0674400329589844e+01 9.9357700347900391e+00 1.0040000152587891e+02 3.0848499298095703e+01 1.1453299522399902e+01 1.0040000152587891e+02 3.0598600387573242e+01 1.0932900428771973e+01 1.0040000152587891e+02 3.1999900817871094e+01 1.1540900230407715e+01 1.0040000152587891e+02 3.1424198150634766e+01 1.1497099876403809e+01 1.0040000152587891e+02 3.2325599670410156e+01 1.1064199447631836e+01 1.0040000152587891e+02 3.2233798980712891e+01 9.8206405639648438e+00 1.0040000152587891e+02 3.2000999450683594e+01 9.6345300674438477e+00 1.0040000152587891e+02 3.1723600387573242e+01 9.5253190994262695e+00 1.0040000152587891e+02 3.2400501251220703e+01 1.0934899330139160e+01 1.0040000152587891e+02 3.2488700866699219e+01 1.0650099754333496e+01 1.0040000152587891e+02 3.2489002227783203e+01 1.0352100372314453e+01 1.0040000152587891e+02 3.1721397399902344e+01 1.1475199699401855e+01 1.0040000152587891e+02 3.1998998641967773e+01 1.1366600036621094e+01 1.0040000152587891e+02 3.2232299804687500e+01 1.1180999755859375e+01 1.0040000152587891e+02 3.1133600234985352e+01 1.1430500030517578e+01 1.0040000152587891e+02 3.0673099517822266e+01 1.1062400817871094e+01 1.0040000152587891e+02 3.0875600814819336e+01 1.1281100273132324e+01 1.0040000152587891e+02 3.0544799804687500e+01 1.0204199790954590e+01 1.0040000152587891e+02 3.0500000000000000e+01 1.0498900413513184e+01 1.0040000152587891e+02 3.0544099807739258e+01 1.0793700218200684e+01 1.0040000152587891e+02 3.1426399230957031e+01 9.5027198791503906e+00 1.0040000152587891e+02 3.1135700225830078e+01 9.5687303543090820e+00 1.0040000152587891e+02 3.0877399444580078e+01 9.7174806594848633e+00 9.9822700500488281e+01 3.1500000000000000e+01 1.0500000000000000e+01 5.2853302001953125e+01 -1.5864100456237793e+01 1.8000000000000000e+01 5.1244697570800781e+01 -1.5715200424194336e+01 1.8000000000000000e+01 5.1339801788330078e+01 -1.5227800369262695e+01 1.8000000000000000e+01 5.3309001922607422e+01 -1.6925100326538086e+01 1.8000000000000000e+01 5.2443599700927734e+01 -1.8291400909423828e+01 1.8000000000000000e+01 5.2059402465820312e+01 -1.7976600646972656e+01 1.8000000000000000e+01 5.3544300079345703e+01 -1.4939000129699707e+01 1.8000000000000000e+01 5.2945098876953125e+01 -1.3438699722290039e+01 1.8000000000000000e+01 5.3419399261474609e+01 -1.3291499137878418e+01 1.8000000000000000e+01 5.5146701812744141e+01 -1.6135898590087891e+01 1.8000000000000000e+01 5.6718700408935547e+01 -1.6530599594116211e+01 1.8000000000000000e+01 5.6580303192138672e+01 -1.7007499694824219e+01 1.8000000000000000e+01 5.2504699707031250e+01 -1.3668199539184570e+01 1.8000000000000000e+01 5.2112400054931641e+01 -1.3972700119018555e+01 1.8000000000000000e+01 5.1780799865722656e+01 -1.4342299461364746e+01 1.8000000000000000e+01 5.1520401000976562e+01 -1.4765200614929199e+01 1.8000000000000000e+01 5.1238101959228516e+01 -1.6211799621582031e+01 1.8000000000000000e+01 5.1320301055908203e+01 -1.6701499938964844e+01 1.8000000000000000e+01 5.1488601684570312e+01 -1.7168701171875000e+01 1.8000000000000000e+01 5.1737701416015625e+01 -1.7598400115966797e+01 1.8000000000000000e+01 5.2877700805664062e+01 -1.8532499313354492e+01 1.8000000000000000e+01 5.3347900390625000e+01 -1.8692199707031250e+01 1.8000000000000000e+01 5.3839099884033203e+01 -1.8765300750732422e+01 1.8000000000000000e+01 5.4455699920654297e+01 -1.7061000823974609e+01 1.8000000000000000e+01 5.4335502624511719e+01 -1.8749599456787109e+01 1.8000000000000000e+01 5.4820999145507812e+01 -1.8645500183105469e+01 1.8000000000000000e+01 5.5280200958251953e+01 -1.8456399917602539e+01 1.8000000000000000e+01 5.5698303222656250e+01 -1.8188299179077148e+01 1.8000000000000000e+01 5.6061698913574219e+01 -1.7849899291992188e+01 1.8000000000000000e+01 5.6358898162841797e+01 -1.7452100753784180e+01 1.8000000000000000e+01 5.5755599975585938e+01 -1.3857399940490723e+01 1.8000000000000000e+01 5.6109901428222656e+01 -1.4205300331115723e+01 1.8000000000000000e+01 5.4691001892089844e+01 -1.5074900627136230e+01 1.8000000000000000e+01 5.6396499633789062e+01 -1.4610899925231934e+01 1.8000000000000000e+01 5.6769798278808594e+01 -1.6036701202392578e+01 1.8000000000000000e+01 5.6731800079345703e+01 -1.5541500091552734e+01 1.8000000000000000e+01 5.6605998992919922e+01 -1.5061100006103516e+01 1.8000000000000000e+01 5.5344802856445312e+01 -1.3578300476074219e+01 1.8000000000000000e+01 5.4890800476074219e+01 -1.3377099990844727e+01 1.8000000000000000e+01 5.4408100128173828e+01 -1.3260199546813965e+01 1.8000000000000000e+01 5.3912399291992188e+01 -1.3231400489807129e+01 1.8000000000000000e+01 5.2112400054931641e+01 -1.3972700119018555e+01 1.8590000152587891e+01 5.1780799865722656e+01 -1.4342299461364746e+01 1.8590000152587891e+01 5.1520401000976562e+01 -1.4765200614929199e+01 1.8590000152587891e+01 5.1339801788330078e+01 -1.5227800369262695e+01 1.8590000152587891e+01 5.1244697570800781e+01 -1.5715200424194336e+01 1.8590000152587891e+01 5.1238101959228516e+01 -1.6211799621582031e+01 1.8590000152587891e+01 5.1320301055908203e+01 -1.6701499938964844e+01 1.8590000152587891e+01 5.1488601684570312e+01 -1.7168701171875000e+01 1.8590000152587891e+01 5.1737701416015625e+01 -1.7598400115966797e+01 1.8590000152587891e+01 5.2059402465820312e+01 -1.7976600646972656e+01 1.8590000152587891e+01 5.2443599700927734e+01 -1.8291400909423828e+01 1.8590000152587891e+01 5.2877700805664062e+01 -1.8532499313354492e+01 1.8590000152587891e+01 5.3347900390625000e+01 -1.8692199707031250e+01 1.8590000152587891e+01 5.3839099884033203e+01 -1.8765300750732422e+01 1.8590000152587891e+01 5.4335502624511719e+01 -1.8749599456787109e+01 1.8590000152587891e+01 5.4820999145507812e+01 -1.8645500183105469e+01 1.8590000152587891e+01 5.5280200958251953e+01 -1.8456399917602539e+01 1.8590000152587891e+01 5.5698303222656250e+01 -1.8188299179077148e+01 1.8590000152587891e+01 5.6061698913574219e+01 -1.7849899291992188e+01 1.8590000152587891e+01 5.6358898162841797e+01 -1.7452100753784180e+01 1.8590000152587891e+01 5.6580303192138672e+01 -1.7007499694824219e+01 1.8590000152587891e+01 5.6718700408935547e+01 -1.6530599594116211e+01 1.8590000152587891e+01 5.6769798278808594e+01 -1.6036701202392578e+01 1.8590000152587891e+01 5.6731800079345703e+01 -1.5541500091552734e+01 1.8590000152587891e+01 5.6605998992919922e+01 -1.5061100006103516e+01 1.8590000152587891e+01 5.6396499633789062e+01 -1.4610899925231934e+01 1.8590000152587891e+01 5.6109901428222656e+01 -1.4205300331115723e+01 1.8590000152587891e+01 5.5755599975585938e+01 -1.3857399940490723e+01 1.8590000152587891e+01 5.5344802856445312e+01 -1.3578300476074219e+01 1.8590000152587891e+01 5.4890800476074219e+01 -1.3377099990844727e+01 1.8590000152587891e+01 5.4408100128173828e+01 -1.3260199546813965e+01 1.8590000152587891e+01 5.3912399291992188e+01 -1.3231400489807129e+01 1.8590000152587891e+01 5.3419399261474609e+01 -1.3291499137878418e+01 1.8590000152587891e+01 5.2945098876953125e+01 -1.3438699722290039e+01 1.8590000152587891e+01 5.2504699707031250e+01 -1.3668199539184570e+01 1.8590000152587891e+01 5.2631698608398438e+01 -1.5318499565124512e+01 1.9830699920654297e+01 5.2535701751708984e+01 -1.5559099197387695e+01 1.9830699920654297e+01 5.2532596588134766e+01 -1.5573900222778320e+01 1.9830699920654297e+01 5.2481300354003906e+01 -1.5820000648498535e+01 1.9830699920654297e+01 5.2480602264404297e+01 -1.5842799186706543e+01 1.9830699920654297e+01 5.2473197937011719e+01 -1.6086500167846680e+01 1.9830699920654297e+01 5.2477500915527344e+01 -1.6116600036621094e+01 1.9830699920654297e+01 5.2511402130126953e+01 -1.6350299835205078e+01 1.9830699920654297e+01 5.2523300170898438e+01 -1.6386400222778320e+01 1.9830699920654297e+01 5.2594799041748047e+01 -1.6603500366210938e+01 1.9830699920654297e+01 5.2616397857666016e+01 -1.6643699645996094e+01 1.9830699920654297e+01 5.2721000671386719e+01 -1.6838298797607422e+01 1.9830699920654297e+01 5.2753898620605469e+01 -1.6880100250244141e+01 1.9830699920654297e+01 5.2886001586914062e+01 -1.7047698974609375e+01 1.9830699920654297e+01 5.2931396484375000e+01 -1.7088201522827148e+01 1.9830699920654297e+01 5.3084796905517578e+01 -1.7225200653076172e+01 1.9830699920654297e+01 5.3142997741699219e+01 -1.7261301040649414e+01 1.9830699920654297e+01 5.3311500549316406e+01 -1.7365499496459961e+01 1.9830699920654297e+01 5.3382198333740234e+01 -1.7393701553344727e+01 1.9830699920654297e+01 5.3559097290039062e+01 -1.7464300155639648e+01 1.9830699920654297e+01 5.3640998840332031e+01 -1.7481399536132812e+01 1.9830699920654297e+01 5.3819999694824219e+01 -1.7518699645996094e+01 1.9830699920654297e+01 5.3911296844482422e+01 -1.7521499633789062e+01 1.9830699920654297e+01 5.4086498260498047e+01 -1.7526800155639648e+01 1.9830699920654297e+01 5.4184398651123047e+01 -1.7512699127197266e+01 1.9830699920654297e+01 5.4350299835205078e+01 -1.7488599777221680e+01 1.9830699920654297e+01 5.4451499938964844e+01 -1.7455299377441406e+01 1.9830699920654297e+01 5.4603496551513672e+01 -1.7405200958251953e+01 1.9830699920654297e+01 5.4704101562500000e+01 -1.7351100921630859e+01 1.9830699920654297e+01 5.4838298797607422e+01 -1.7278999328613281e+01 1.9830699920654297e+01 5.4933998107910156e+01 -1.7203599929809570e+01 1.9830699920654297e+01 5.5047698974609375e+01 -1.7114000320434570e+01 1.9830699920654297e+01 5.5133899688720703e+01 -1.7017499923706055e+01 1.9830699920654297e+01 5.5225200653076172e+01 -1.6915201187133789e+01 1.9830699920654297e+01 5.5297401428222656e+01 -1.6798601150512695e+01 1.9830699920654297e+01 5.5495399475097656e+01 -1.6291801452636719e+01 1.9830699920654297e+01 5.5464302062988281e+01 -1.6440900802612305e+01 1.9830699920654297e+01 5.5419200897216797e+01 -1.6554100036621094e+01 1.9830699920654297e+01 5.5365497589111328e+01 -1.6688499450683594e+01 1.9830699920654297e+01 5.5502799987792969e+01 -1.5747699737548828e+01 1.9830699920654297e+01 5.5526802062988281e+01 -1.5913499832153320e+01 1.9830699920654297e+01 5.5523601531982422e+01 -1.6020099639892578e+01 1.9830699920654297e+01 5.5518703460693359e+01 -1.6179998397827148e+01 1.9830699920654297e+01 5.5318698883056641e+01 -1.5235400199890137e+01 1.9830699920654297e+01 5.5405200958251953e+01 -1.5396499633789062e+01 1.9830699920654297e+01 5.5433799743652344e+01 -1.5483300209045410e+01 1.9830699920654297e+01 5.5488601684570312e+01 -1.5649700164794922e+01 1.9830699920654297e+01 5.4966300964355469e+01 -1.4820399284362793e+01 1.9830699920654297e+01 5.5114002227783203e+01 -1.4952300071716309e+01 1.9830699920654297e+01 5.5161098480224609e+01 -1.5012100219726562e+01 1.9830699920654297e+01 5.5279003143310547e+01 -1.5161699295043945e+01 1.9830699920654297e+01 5.4490398406982422e+01 -1.4555399894714355e+01 1.9830699920654297e+01 5.4688499450683594e+01 -1.4634500503540039e+01 1.9830699920654297e+01 5.4740299224853516e+01 -1.4666499137878418e+01 1.9830699920654297e+01 5.4915199279785156e+01 -1.4774800300598145e+01 1.9830699920654297e+01 5.3951499938964844e+01 -1.4474299430847168e+01 1.9830699920654297e+01 5.4180000305175781e+01 -1.4481299400329590e+01 1.9830699920654297e+01 5.4224597930908203e+01 -1.4490599632263184e+01 1.9830699920654297e+01 5.4440898895263672e+01 -1.4535699844360352e+01 1.9830699920654297e+01 5.3418201446533203e+01 -1.4587699890136719e+01 1.9830699920654297e+01 5.3649700164794922e+01 -1.4511400222778320e+01 1.9830699920654297e+01 5.3679801940917969e+01 -1.4506999969482422e+01 1.9830699920654297e+01 5.3913501739501953e+01 -1.4473199844360352e+01 1.9830699920654297e+01 5.2958297729492188e+01 -1.4881299972534180e+01 1.9830699920654297e+01 5.3161701202392578e+01 -1.4720999717712402e+01 1.9830699920654297e+01 5.3175098419189453e+01 -1.4713799476623535e+01 1.9830699920654297e+01 5.3396499633789062e+01 -1.4594799995422363e+01 1.9830699920654297e+01 5.2634498596191406e+01 -1.5311499595642090e+01 1.9830699920654297e+01 5.2774803161621094e+01 -1.5084800720214844e+01 1.9830699920654297e+01 5.2952301025390625e+01 -1.4886000633239746e+01 1.9830699920654297e+01 5.2660598754882812e+01 -1.5324699401855469e+01 1.9901399612426758e+01 5.2618297576904297e+01 -1.5416000366210938e+01 2.3719501495361328e+01 5.2798198699951172e+01 -1.5102299690246582e+01 2.3719501495361328e+01 5.2522701263427734e+01 -1.5764498710632324e+01 1.9901399612426758e+01 5.2518699645996094e+01 -1.5763599395751953e+01 2.3719501495361328e+01 5.2563701629638672e+01 -1.5567500114440918e+01 1.9901399612426758e+01 5.2623397827148438e+01 -1.5417999267578125e+01 1.9901399612426758e+01 5.2510398864746094e+01 -1.5823500633239746e+01 1.9901399612426758e+01 5.2502399444580078e+01 -1.6084798812866211e+01 1.9901399612426758e+01 5.2505199432373047e+01 -1.6125000000000000e+01 2.3719501495361328e+01 5.2508201599121094e+01 -1.6124601364135742e+01 1.9901399612426758e+01 5.2539901733398438e+01 -1.6343599319458008e+01 1.9901399612426758e+01 5.2578598022460938e+01 -1.6479099273681641e+01 2.3719501495361328e+01 5.2736000061035156e+01 -1.6804599761962891e+01 1.9901399612426758e+01 5.2734500885009766e+01 -1.6805299758911133e+01 2.3719501495361328e+01 5.2621700286865234e+01 -1.6591899871826172e+01 1.9901399612426758e+01 5.2583999633789062e+01 -1.6477300643920898e+01 1.9901399612426758e+01 5.2745498657226562e+01 -1.6822299957275391e+01 1.9901399612426758e+01 5.2907299041748047e+01 -1.7027599334716797e+01 1.9901399612426758e+01 5.2963996887207031e+01 -1.7084798812866211e+01 2.3719501495361328e+01 5.3256298065185547e+01 -1.7297100067138672e+01 1.9901399612426758e+01 5.3253700256347656e+01 -1.7301200866699219e+01 2.3719501495361328e+01 5.3102298736572266e+01 -1.7201799392700195e+01 1.9901399612426758e+01 5.2967300415039062e+01 -1.7081199645996094e+01 1.9901399612426758e+01 5.3324699401855469e+01 -1.7339399337768555e+01 1.9901399612426758e+01 5.3567497253417969e+01 -1.7436300277709961e+01 1.9901399612426758e+01 5.3586799621582031e+01 -1.7441999435424805e+01 2.3719501495361328e+01 5.3587196350097656e+01 -1.7440399169921875e+01 1.9901399612426758e+01 5.3823501586914062e+01 -1.7489601135253906e+01 1.9901399612426758e+01 5.3943897247314453e+01 -1.7499000549316406e+01 2.3719501495361328e+01 5.4303798675537109e+01 -1.7465900421142578e+01 1.9901399612426758e+01 5.4304302215576172e+01 -1.7468801498413086e+01 2.3719501495361328e+01 5.4084800720214844e+01 -1.7497598648071289e+01 1.9901399612426758e+01 5.3944099426269531e+01 -1.7493299484252930e+01 1.9901399612426758e+01 5.4343601226806641e+01 -1.7460100173950195e+01 1.9901399612426758e+01 5.4591899871826172e+01 -1.7378299713134766e+01 1.9901399612426758e+01 5.4646900177001953e+01 -1.7353300094604492e+01 2.3719501495361328e+01 5.4644996643066406e+01 -1.7349800109863281e+01 1.9901399612426758e+01 5.4822299957275391e+01 -1.7254499435424805e+01 1.9901399612426758e+01 5.4951999664306641e+01 -1.7159198760986328e+01 2.3719501495361328e+01 5.4948699951171875e+01 -1.7154899597167969e+01 1.9901399612426758e+01 5.5027599334716797e+01 -1.7092699050903320e+01 1.9901399612426758e+01 5.5201797485351562e+01 -1.6897701263427734e+01 2.3719501495361328e+01 5.5201797485351562e+01 -1.6897701263427734e+01 1.9901399612426758e+01 5.5339401245117188e+01 -1.6675300598144531e+01 1.9901399612426758e+01 5.5381698608398438e+01 -1.6583999633789062e+01 2.3719501495361328e+01 5.5477298736572266e+01 -1.6235500335693359e+01 1.9901399612426758e+01 5.5481300354003906e+01 -1.6236400604248047e+01 2.3719501495361328e+01 5.5436298370361328e+01 -1.6432498931884766e+01 1.9901399612426758e+01 5.5376602172851562e+01 -1.6581998825073242e+01 1.9901399612426758e+01 5.5489601135253906e+01 -1.6176500320434570e+01 1.9901399612426758e+01 5.5497600555419922e+01 -1.5915200233459473e+01 1.9901399612426758e+01 5.5494800567626953e+01 -1.5875000953674316e+01 2.3719501495361328e+01 5.5491802215576172e+01 -1.5875398635864258e+01 1.9901399612426758e+01 5.5460098266601562e+01 -1.5656400680541992e+01 1.9901399612426758e+01 5.5421401977539062e+01 -1.5520899772644043e+01 2.3719501495361328e+01 5.5263999938964844e+01 -1.5195400238037109e+01 1.9901399612426758e+01 5.5265502929687500e+01 -1.5194700241088867e+01 2.3719501495361328e+01 5.5378299713134766e+01 -1.5408099174499512e+01 1.9901399612426758e+01 5.5416000366210938e+01 -1.5522699356079102e+01 1.9901399612426758e+01 5.5254501342773438e+01 -1.5177700042724609e+01 1.9901399612426758e+01 5.5092700958251953e+01 -1.4972399711608887e+01 1.9901399612426758e+01 5.5035999298095703e+01 -1.4915200233459473e+01 2.3719501495361328e+01 5.4743698120117188e+01 -1.4702899932861328e+01 1.9901399612426758e+01 5.4746299743652344e+01 -1.4698800086975098e+01 2.3719501495361328e+01 5.4897701263427734e+01 -1.4798199653625488e+01 1.9901399612426758e+01 5.5032699584960938e+01 -1.4918800354003906e+01 1.9901399612426758e+01 5.4675300598144531e+01 -1.4660599708557129e+01 1.9901399612426758e+01 5.4432498931884766e+01 -1.4563699722290039e+01 1.9901399612426758e+01 5.4413200378417969e+01 -1.4557999610900879e+01 2.3719501495361328e+01 5.4412799835205078e+01 -1.4559599876403809e+01 1.9901399612426758e+01 5.4176498413085938e+01 -1.4510399818420410e+01 1.9901399612426758e+01 5.4056098937988281e+01 -1.4500999450683594e+01 2.3719501495361328e+01 5.3696201324462891e+01 -1.4534099578857422e+01 1.9901399612426758e+01 5.3695701599121094e+01 -1.4531199455261230e+01 2.3719501495361328e+01 5.3915199279785156e+01 -1.4502399444580078e+01 1.9901399612426758e+01 5.4055900573730469e+01 -1.4506700515747070e+01 1.9901399612426758e+01 5.3656398773193359e+01 -1.4539899826049805e+01 1.9901399612426758e+01 5.3408100128173828e+01 -1.4621700286865234e+01 1.9901399612426758e+01 5.3353099822998047e+01 -1.4646699905395508e+01 2.3719501495361328e+01 5.3354999542236328e+01 -1.4650199890136719e+01 1.9901399612426758e+01 5.3177700042724609e+01 -1.4745499610900879e+01 1.9901399612426758e+01 5.3048000335693359e+01 -1.4840800285339355e+01 2.3719501495361328e+01 5.3051300048828125e+01 -1.4845100402832031e+01 1.9901399612426758e+01 5.2972396850585938e+01 -1.4907299995422363e+01 1.9901399612426758e+01 5.2798198699951172e+01 -1.5102299690246582e+01 1.9901399612426758e+01 5.3226001739501953e+01 -1.5057600021362305e+01 2.4000000000000000e+01 5.3474002838134766e+01 -1.4899799346923828e+01 2.4000000000000000e+01 5.3752601623535156e+01 -1.4805899620056152e+01 2.4000000000000000e+01 5.4045597076416016e+01 -1.4781399726867676e+01 2.4000000000000000e+01 5.4335899353027344e+01 -1.4827700614929199e+01 2.4000000000000000e+01 5.4606697082519531e+01 -1.4942100524902344e+01 2.4000000000000000e+01 5.4842201232910156e+01 -1.5118100166320801e+01 2.4000000000000000e+01 5.5028800964355469e+01 -1.5345299720764160e+01 2.4000000000000000e+01 5.5155601501464844e+01 -1.5610500335693359e+01 2.4000000000000000e+01 5.5215297698974609e+01 -1.5898401260375977e+01 2.4000000000000000e+01 5.5204299926757812e+01 -1.6192199707031250e+01 2.4000000000000000e+01 5.5123298645019531e+01 -1.6474800109863281e+01 2.4000000000000000e+01 5.4977001190185547e+01 -1.6729799270629883e+01 2.4000000000000000e+01 5.4774002075195312e+01 -1.6942399978637695e+01 2.4000000000000000e+01 5.4526000976562500e+01 -1.7100200653076172e+01 2.4000000000000000e+01 5.4247402191162109e+01 -1.7194099426269531e+01 2.4000000000000000e+01 5.3954399108886719e+01 -1.7218599319458008e+01 2.4000000000000000e+01 5.3664100646972656e+01 -1.7172298431396484e+01 2.4000000000000000e+01 5.3393299102783203e+01 -1.7057899475097656e+01 2.4000000000000000e+01 5.3157798767089844e+01 -1.6881900787353516e+01 2.4000000000000000e+01 5.2971199035644531e+01 -1.6654699325561523e+01 2.4000000000000000e+01 5.2844402313232422e+01 -1.6389499664306641e+01 2.4000000000000000e+01 5.2784698486328125e+01 -1.6101600646972656e+01 2.4000000000000000e+01 5.2795700073242188e+01 -1.5807800292968750e+01 2.4000000000000000e+01 5.2876701354980469e+01 -1.5525200843811035e+01 2.4000000000000000e+01 5.3022998809814453e+01 -1.5270199775695801e+01 2.4000000000000000e+01 5.2556400299072266e+01 -1.5565299987792969e+01 1.9863199234008789e+01 5.2653800964355469e+01 -1.5321199417114258e+01 1.9863199234008789e+01 5.2502899169921875e+01 -1.5822600364685059e+01 1.9863199234008789e+01 5.2494800567626953e+01 -1.6085300445556641e+01 1.9863199234008789e+01 5.2532501220703125e+01 -1.6345300674438477e+01 1.9863199234008789e+01 5.2614700317382812e+01 -1.6594900131225586e+01 1.9863199234008789e+01 5.2739097595214844e+01 -1.6826400756835938e+01 1.9863199234008789e+01 5.2901699066162109e+01 -1.7032800674438477e+01 1.9863199234008789e+01 5.3097801208496094e+01 -1.7207799911499023e+01 1.9863199234008789e+01 5.3321201324462891e+01 -1.7346199035644531e+01 1.9863199234008789e+01 5.3565299987792969e+01 -1.7443599700927734e+01 1.9863199234008789e+01 5.3822597503662109e+01 -1.7497100830078125e+01 1.9863199234008789e+01 5.4085300445556641e+01 -1.7505201339721680e+01 1.9863199234008789e+01 5.4345298767089844e+01 -1.7467500686645508e+01 1.9863199234008789e+01 5.4594902038574219e+01 -1.7385299682617188e+01 1.9863199234008789e+01 5.4826400756835938e+01 -1.7260900497436523e+01 1.9863199234008789e+01 5.5032802581787109e+01 -1.7098199844360352e+01 1.9863199234008789e+01 5.5207801818847656e+01 -1.6902200698852539e+01 1.9863199234008789e+01 5.5346199035644531e+01 -1.6678800582885742e+01 1.9863199234008789e+01 5.5443599700927734e+01 -1.6434700012207031e+01 1.9863199234008789e+01 5.5497097015380859e+01 -1.6177398681640625e+01 1.9863199234008789e+01 5.5505199432373047e+01 -1.5914700508117676e+01 1.9863199234008789e+01 5.5467502593994141e+01 -1.5654700279235840e+01 1.9863199234008789e+01 5.5385299682617188e+01 -1.5405099868774414e+01 1.9863199234008789e+01 5.5260898590087891e+01 -1.5173600196838379e+01 1.9863199234008789e+01 5.5098297119140625e+01 -1.4967200279235840e+01 1.9863199234008789e+01 5.4902198791503906e+01 -1.4792099952697754e+01 1.9863199234008789e+01 5.4678802490234375e+01 -1.4653800010681152e+01 1.9863199234008789e+01 5.4434700012207031e+01 -1.4556399345397949e+01 1.9863199234008789e+01 5.4177398681640625e+01 -1.4502900123596191e+01 1.9863199234008789e+01 5.3914699554443359e+01 -1.4494799613952637e+01 1.9863199234008789e+01 5.3654701232910156e+01 -1.4532500267028809e+01 1.9863199234008789e+01 5.3405097961425781e+01 -1.4614700317382812e+01 1.9863199234008789e+01 5.3173603057861328e+01 -1.4739099502563477e+01 1.9863199234008789e+01 5.2792198181152344e+01 -1.5097799301147461e+01 1.9863199234008789e+01 5.2967197418212891e+01 -1.4901800155639648e+01 1.9863199234008789e+01 5.4455699920654297e+01 -1.7061000823974609e+01 1.9099998474121094e+01 5.3882301330566406e+01 -1.6993099212646484e+01 1.9099998474121094e+01 5.3309001922607422e+01 -1.6925100326538086e+01 1.9099998474121094e+01 5.5146701812744141e+01 -1.6135898590087891e+01 1.9099998474121094e+01 5.4801200866699219e+01 -1.6598400115966797e+01 1.9099998474121094e+01 5.4691001892089844e+01 -1.5074900627136230e+01 1.9099998474121094e+01 5.4918800354003906e+01 -1.5605400085449219e+01 1.9099998474121094e+01 5.3544300079345703e+01 -1.4939000129699707e+01 1.9099998474121094e+01 5.4117698669433594e+01 -1.5006899833679199e+01 1.9099998474121094e+01 5.2853302001953125e+01 -1.5864100456237793e+01 1.9099998474121094e+01 5.3198799133300781e+01 -1.5401599884033203e+01 1.9099998474121094e+01 5.3081199645996094e+01 -1.6394599914550781e+01 1.9099998474121094e+01 5.4180301666259766e+01 -1.6983600616455078e+01 1.9099998474121094e+01 5.4462196350097656e+01 -1.6886800765991211e+01 1.9099998474121094e+01 5.4702999114990234e+01 -1.6711198806762695e+01 1.9099998474121094e+01 5.3150199890136719e+01 -1.6527200698852539e+01 1.9099998474121094e+01 5.3343399047851562e+01 -1.6754199981689453e+01 1.9099998474121094e+01 5.3594802856445312e+01 -1.6914199829101562e+01 1.9099998474121094e+01 5.3057998657226562e+01 -1.5664299964904785e+01 1.9099998474121094e+01 5.3000900268554688e+01 -1.5956898689270020e+01 1.9099998474121094e+01 5.3032600402832031e+01 -1.6253299713134766e+01 1.9099998474121094e+01 5.3410797119140625e+01 -1.5192000389099121e+01 1.9099998474121094e+01 5.3968399047851562e+01 -1.5000499725341797e+01 1.9099998474121094e+01 5.3675201416015625e+01 -1.5054200172424316e+01 1.9099998474121094e+01 5.4761699676513672e+01 -1.5352100372314453e+01 1.9099998474121094e+01 5.4536899566650391e+01 -1.5156400680541992e+01 1.9099998474121094e+01 5.4264400482177734e+01 -1.5035600662231445e+01 1.9099998474121094e+01 5.4881401062011719e+01 -1.6472299575805664e+01 1.9099998474121094e+01 5.4981498718261719e+01 -1.6191600799560547e+01 1.9099998474121094e+01 5.4994300842285156e+01 -1.5893799781799316e+01 1.9099998474121094e+01 5.4000000000000000e+01 -1.6000000000000000e+01 1.9677400588989258e+01 9.0350906372070312e+01 -1.5886099815368652e+01 1.8000000000000000e+01 8.8739700317382812e+01 -1.5768099784851074e+01 1.8000000000000000e+01 8.8825500488281250e+01 -1.5278900146484375e+01 1.8000000000000000e+01 9.0826805114746094e+01 -1.6938199996948242e+01 1.8000000000000000e+01 8.9987800598144531e+01 -1.8320800781250000e+01 1.8000000000000000e+01 8.9597702026367188e+01 -1.8013500213623047e+01 1.8000000000000000e+01 9.1024101257324219e+01 -1.4947899818420410e+01 1.8000000000000000e+01 9.0396202087402344e+01 -1.3459400177001953e+01 1.8000000000000000e+01 9.0867599487304688e+01 -1.3303199768066406e+01 1.8000000000000000e+01 9.2649101257324219e+01 -1.6113899230957031e+01 1.8000000000000000e+01 9.4228401184082031e+01 -1.6478401184082031e+01 1.8000000000000000e+01 9.4099098205566406e+01 -1.6957899093627930e+01 1.8000000000000000e+01 8.9960296630859375e+01 -1.3697299957275391e+01 1.8000000000000000e+01 8.9573898315429688e+01 -1.4009299278259277e+01 1.8000000000000000e+01 8.9249404907226562e+01 -1.4385200500488281e+01 1.8000000000000000e+01 8.8997200012207031e+01 -1.4813000679016113e+01 1.8000000000000000e+01 8.8742706298828125e+01 -1.6264699935913086e+01 1.8000000000000000e+01 8.8834197998046875e+01 -1.6752799987792969e+01 1.8000000000000000e+01 8.9011497497558594e+01 -1.7216699600219727e+01 1.8000000000000000e+01 8.9268699645996094e+01 -1.7641401290893555e+01 1.8000000000000000e+01 9.0426498413085938e+01 -1.8553499221801758e+01 1.8000000000000000e+01 9.0899696350097656e+01 -1.8704200744628906e+01 1.8000000000000000e+01 9.1392196655273438e+01 -1.8767900466918945e+01 1.8000000000000000e+01 9.1975898742675781e+01 -1.7052099227905273e+01 1.8000000000000000e+01 9.1888099670410156e+01 -1.8742698669433594e+01 1.8000000000000000e+01 9.2371597290039062e+01 -1.8629299163818359e+01 1.8000000000000000e+01 9.2827095031738281e+01 -1.8431400299072266e+01 1.8000000000000000e+01 9.3239906311035156e+01 -1.8155399322509766e+01 1.8000000000000000e+01 9.3596801757812500e+01 -1.7810100555419922e+01 1.8000000000000000e+01 9.3886299133300781e+01 -1.7406599044799805e+01 1.8000000000000000e+01 9.3214195251464844e+01 -1.3824099540710449e+01 1.8000000000000000e+01 9.3575096130371094e+01 -1.4165200233459473e+01 1.8000000000000000e+01 9.2173194885253906e+01 -1.5061800003051758e+01 1.8000000000000000e+01 9.3869400024414062e+01 -1.4565199851989746e+01 1.8000000000000000e+01 9.4269996643066406e+01 -1.5983600616455078e+01 1.8000000000000000e+01 9.4222503662109375e+01 -1.5489200592041016e+01 1.8000000000000000e+01 9.4087493896484375e+01 -1.5011300086975098e+01 1.8000000000000000e+01 9.2798095703125000e+01 -1.3553000450134277e+01 1.8000000000000000e+01 9.2340301513671875e+01 -1.3360500335693359e+01 1.8000000000000000e+01 9.1855506896972656e+01 -1.3252900123596191e+01 1.8000000000000000e+01 9.1359298706054688e+01 -1.3233600616455078e+01 1.8000000000000000e+01 8.9573898315429688e+01 -1.4009299278259277e+01 1.8590000152587891e+01 8.9249404907226562e+01 -1.4385200500488281e+01 1.8590000152587891e+01 8.8997200012207031e+01 -1.4813000679016113e+01 1.8590000152587891e+01 8.8825500488281250e+01 -1.5278900146484375e+01 1.8590000152587891e+01 8.8739700317382812e+01 -1.5768099784851074e+01 1.8590000152587891e+01 8.8742706298828125e+01 -1.6264699935913086e+01 1.8590000152587891e+01 8.8834197998046875e+01 -1.6752799987792969e+01 1.8590000152587891e+01 8.9011497497558594e+01 -1.7216699600219727e+01 1.8590000152587891e+01 8.9268699645996094e+01 -1.7641401290893555e+01 1.8590000152587891e+01 8.9597702026367188e+01 -1.8013500213623047e+01 1.8590000152587891e+01 8.9987800598144531e+01 -1.8320800781250000e+01 1.8590000152587891e+01 9.0426498413085938e+01 -1.8553499221801758e+01 1.8590000152587891e+01 9.0899696350097656e+01 -1.8704200744628906e+01 1.8590000152587891e+01 9.1392196655273438e+01 -1.8767900466918945e+01 1.8590000152587891e+01 9.1888099670410156e+01 -1.8742698669433594e+01 1.8590000152587891e+01 9.2371597290039062e+01 -1.8629299163818359e+01 1.8590000152587891e+01 9.2827095031738281e+01 -1.8431400299072266e+01 1.8590000152587891e+01 9.3239906311035156e+01 -1.8155399322509766e+01 1.8590000152587891e+01 9.3596801757812500e+01 -1.7810100555419922e+01 1.8590000152587891e+01 9.3886299133300781e+01 -1.7406599044799805e+01 1.8590000152587891e+01 9.4099098205566406e+01 -1.6957899093627930e+01 1.8590000152587891e+01 9.4228401184082031e+01 -1.6478401184082031e+01 1.8590000152587891e+01 9.4269996643066406e+01 -1.5983600616455078e+01 1.8590000152587891e+01 9.4222503662109375e+01 -1.5489200592041016e+01 1.8590000152587891e+01 9.4087493896484375e+01 -1.5011300086975098e+01 1.8590000152587891e+01 9.3869400024414062e+01 -1.4565199851989746e+01 1.8590000152587891e+01 9.3575096130371094e+01 -1.4165200233459473e+01 1.8590000152587891e+01 9.3214195251464844e+01 -1.3824099540710449e+01 1.8590000152587891e+01 9.2798095703125000e+01 -1.3553000450134277e+01 1.8590000152587891e+01 9.2340301513671875e+01 -1.3360500335693359e+01 1.8590000152587891e+01 9.1855506896972656e+01 -1.3252900123596191e+01 1.8590000152587891e+01 9.1359298706054688e+01 -1.3233600616455078e+01 1.8590000152587891e+01 9.0867599487304688e+01 -1.3303199768066406e+01 1.8590000152587891e+01 9.0396202087402344e+01 -1.3459400177001953e+01 1.8590000152587891e+01 8.9960296630859375e+01 -1.3697299957275391e+01 1.8590000152587891e+01 9.0118804931640625e+01 -1.5344900131225586e+01 1.9830699920654297e+01 9.0027503967285156e+01 -1.5587200164794922e+01 1.9830699920654297e+01 9.0024703979492188e+01 -1.5602099418640137e+01 1.9830699920654297e+01 8.9978202819824219e+01 -1.5849199295043945e+01 1.9830699920654297e+01 8.9977897644042969e+01 -1.5871999740600586e+01 1.9830699920654297e+01 8.9975097656250000e+01 -1.6115701675415039e+01 1.9830699920654297e+01 8.9979995727539062e+01 -1.6145700454711914e+01 1.9830699920654297e+01 9.0018402099609375e+01 -1.6378799438476562e+01 1.9830699920654297e+01 9.0030998229980469e+01 -1.6414600372314453e+01 1.9830699920654297e+01 9.0106597900390625e+01 -1.6630298614501953e+01 1.9830699920654297e+01 9.0129005432128906e+01 -1.6670101165771484e+01 1.9830699920654297e+01 9.0237297058105469e+01 -1.6862699508666992e+01 1.9830699920654297e+01 9.0271003723144531e+01 -1.6903900146484375e+01 1.9830699920654297e+01 9.0406204223632812e+01 -1.7068799972534180e+01 1.9830699920654297e+01 9.0452400207519531e+01 -1.7108499526977539e+01 1.9830699920654297e+01 9.0608497619628906e+01 -1.7242500305175781e+01 1.9830699920654297e+01 9.0667396545410156e+01 -1.7277500152587891e+01 1.9830699920654297e+01 9.0837799072265625e+01 -1.7378499984741211e+01 1.9830699920654297e+01 9.0908996582031250e+01 -1.7405300140380859e+01 1.9830699920654297e+01 9.1087196350097656e+01 -1.7472499847412109e+01 1.9830699920654297e+01 9.1169502258300781e+01 -1.7488000869750977e+01 1.9830699920654297e+01 9.1349197387695312e+01 -1.7521800994873047e+01 1.9830699920654297e+01 9.1440498352050781e+01 -1.7522899627685547e+01 1.9830699920654297e+01 9.1615699768066406e+01 -1.7524900436401367e+01 1.9830699920654297e+01 9.1713401794433594e+01 -1.7508798599243164e+01 1.9830699920654297e+01 9.1878799438476562e+01 -1.7481601715087891e+01 1.9830699920654297e+01 9.1979400634765625e+01 -1.7446300506591797e+01 1.9830699920654297e+01 9.2130302429199219e+01 -1.7393400192260742e+01 1.9830699920654297e+01 9.2229904174804688e+01 -1.7337400436401367e+01 1.9830699920654297e+01 9.2362701416015625e+01 -1.7262699127197266e+01 1.9830699920654297e+01 9.2456901550292969e+01 -1.7185499191284180e+01 1.9830699920654297e+01 9.2568801879882812e+01 -1.7093799591064453e+01 1.9830699920654297e+01 9.2653198242187500e+01 -1.6995500564575195e+01 1.9830699920654297e+01 9.2742500305175781e+01 -1.6891500473022461e+01 1.9830699920654297e+01 9.2812393188476562e+01 -1.6773599624633789e+01 1.9830699920654297e+01 9.3000701904296875e+01 -1.6263099670410156e+01 1.9830699920654297e+01 9.2972503662109375e+01 -1.6412799835205078e+01 1.9830699920654297e+01 9.2929496765136719e+01 -1.6526800155639648e+01 1.9830699920654297e+01 9.2878501892089844e+01 -1.6662200927734375e+01 1.9830699920654297e+01 9.2997703552246094e+01 -1.5718899726867676e+01 1.9830699920654297e+01 9.3024902343750000e+01 -1.5884300231933594e+01 1.9830699920654297e+01 9.3023704528808594e+01 -1.5990900039672852e+01 1.9830699920654297e+01 9.3021804809570312e+01 -1.6150800704956055e+01 1.9830699920654297e+01 9.2803794860839844e+01 -1.5210299491882324e+01 1.9830699920654297e+01 9.2893402099609375e+01 -1.5369700431823730e+01 1.9830699920654297e+01 9.2923599243164062e+01 -1.5455900192260742e+01 1.9830699920654297e+01 9.2981597900390625e+01 -1.5621200561523438e+01 1.9830699920654297e+01 9.2443504333496094e+01 -1.4802100181579590e+01 1.9830699920654297e+01 9.2593795776367188e+01 -1.4931200027465820e+01 1.9830699920654297e+01 9.2641998291015625e+01 -1.4989999771118164e+01 1.9830699920654297e+01 9.2762702941894531e+01 -1.5137299537658691e+01 1.9830699920654297e+01 9.1962600708007812e+01 -1.4546299934387207e+01 1.9830699920654297e+01 9.2162200927734375e+01 -1.4621500015258789e+01 1.9830699920654297e+01 9.2214599609375000e+01 -1.4652599334716797e+01 1.9830699920654297e+01 9.2391494750976562e+01 -1.4757499694824219e+01 1.9830699920654297e+01 9.1422294616699219e+01 -1.4475500106811523e+01 1.9830699920654297e+01 9.1650802612304688e+01 -1.4478199958801270e+01 1.9830699920654297e+01 9.1695701599121094e+01 -1.4486599922180176e+01 1.9830699920654297e+01 9.1912796020507812e+01 -1.4527500152587891e+01 1.9830699920654297e+01 9.0891197204589844e+01 -1.4599100112915039e+01 1.9830699920654297e+01 9.1121200561523438e+01 -1.4518400192260742e+01 1.9830699920654297e+01 9.1151199340820312e+01 -1.4513400077819824e+01 1.9830699920654297e+01 9.1384300231933594e+01 -1.4475099563598633e+01 1.9830699920654297e+01 9.0437004089355469e+01 -1.4901399612426758e+01 1.9830699920654297e+01 9.0637298583984375e+01 -1.4737299919128418e+01 1.9830699920654297e+01 9.0650604248046875e+01 -1.4729799270629883e+01 1.9830699920654297e+01 9.0869705200195312e+01 -1.4606599807739258e+01 1.9830699920654297e+01 9.0121498107910156e+01 -1.5337800025939941e+01 1.9830699920654297e+01 9.0257499694824219e+01 -1.5108499526977539e+01 1.9830699920654297e+01 9.0431198120117188e+01 -1.4906199455261230e+01 1.9830699920654297e+01 9.0147895812988281e+01 -1.5350500106811523e+01 1.9901399612426758e+01 9.0107406616210938e+01 -1.5442599296569824e+01 2.3719501495361328e+01 9.0281303405761719e+01 -1.5125499725341797e+01 2.3719501495361328e+01 9.0018501281738281e+01 -1.5792799949645996e+01 1.9901399612426758e+01 9.0014503479003906e+01 -1.5792099952697754e+01 2.3719501495361328e+01 9.0055694580078125e+01 -1.5595099449157715e+01 1.9901399612426758e+01 9.0112503051757812e+01 -1.5444499969482422e+01 1.9901399612426758e+01 9.0007301330566406e+01 -1.5852099418640137e+01 1.9901399612426758e+01 9.0004302978515625e+01 -1.6113498687744141e+01 1.9901399612426758e+01 9.0007904052734375e+01 -1.6153600692749023e+01 2.3719501495361328e+01 9.0010803222656250e+01 -1.6153200149536133e+01 1.9901399612426758e+01 9.0046699523925781e+01 -1.6371500015258789e+01 1.9901399612426758e+01 9.0088005065917969e+01 -1.6506299972534180e+01 2.3719501495361328e+01 9.0251602172851562e+01 -1.6828701019287109e+01 1.9901399612426758e+01 9.0250198364257812e+01 -1.6829500198364258e+01 2.3719501495361328e+01 9.0133300781250000e+01 -1.6618200302124023e+01 1.9901399612426758e+01 9.0093399047851562e+01 -1.6504400253295898e+01 1.9901399612426758e+01 9.0261398315429688e+01 -1.6846200942993164e+01 1.9901399612426758e+01 9.0427200317382812e+01 -1.7048398971557617e+01 1.9901399612426758e+01 9.0485000610351562e+01 -1.7104400634765625e+01 2.3719501495361328e+01 9.0781303405761719e+01 -1.7311100006103516e+01 1.9901399612426758e+01 9.0778800964355469e+01 -1.7315299987792969e+01 2.3719501495361328e+01 9.0625503540039062e+01 -1.7218700408935547e+01 1.9901399612426758e+01 9.0488204956054688e+01 -1.7100799560546875e+01 1.9901399612426758e+01 9.0850502014160156e+01 -1.7352100372314453e+01 1.9901399612426758e+01 9.1095100402832031e+01 -1.7444299697875977e+01 1.9901399612426758e+01 9.1114501953125000e+01 -1.7449600219726562e+01 2.3719501495361328e+01 9.1114799499511719e+01 -1.7447999954223633e+01 1.9901399612426758e+01 9.1352096557617188e+01 -1.7492700576782227e+01 1.9901399612426758e+01 9.1472702026367188e+01 -1.7499801635742188e+01 2.3719501495361328e+01 9.1831901550292969e+01 -1.7459800720214844e+01 1.9901399612426758e+01 9.1832397460937500e+01 -1.7462699890136719e+01 2.3719501495361328e+01 9.1613502502441406e+01 -1.7495698928833008e+01 1.9901399612426758e+01 9.1472702026367188e+01 -1.7494098663330078e+01 1.9901399612426758e+01 9.1871498107910156e+01 -1.7453300476074219e+01 1.9901399612426758e+01 9.2118202209472656e+01 -1.7366699218750000e+01 1.9901399612426758e+01 9.2172798156738281e+01 -1.7340700149536133e+01 2.3719501495361328e+01 9.2170799255371094e+01 -1.7337100982666016e+01 1.9901399612426758e+01 9.2346199035644531e+01 -1.7238599777221680e+01 1.9901399612426758e+01 9.2474105834960938e+01 -1.7140699386596680e+01 2.3719501495361328e+01 9.2470603942871094e+01 -1.7136499404907227e+01 1.9901399612426758e+01 9.2548400878906250e+01 -1.7072799682617188e+01 1.9901399612426758e+01 9.2718696594238281e+01 -1.6874500274658203e+01 2.3719501495361328e+01 9.2718696594238281e+01 -1.6874500274658203e+01 1.9901399612426758e+01 9.2852104187011719e+01 -1.6649499893188477e+01 1.9901399612426758e+01 9.2892601013183594e+01 -1.6557399749755859e+01 2.3719501495361328e+01 9.2981498718261719e+01 -1.6207199096679688e+01 1.9901399612426758e+01 9.2985504150390625e+01 -1.6207899093627930e+01 2.3719501495361328e+01 9.2944305419921875e+01 -1.6404901504516602e+01 1.9901399612426758e+01 9.2887496948242188e+01 -1.6555500030517578e+01 1.9901399612426758e+01 9.2992698669433594e+01 -1.6147899627685547e+01 1.9901399612426758e+01 9.2995704650878906e+01 -1.5886500358581543e+01 1.9901399612426758e+01 9.2992095947265625e+01 -1.5846399307250977e+01 2.3719501495361328e+01 9.2989196777343750e+01 -1.5846900939941406e+01 1.9901399612426758e+01 9.2953300476074219e+01 -1.5628499984741211e+01 1.9901399612426758e+01 9.2912002563476562e+01 -1.5493700027465820e+01 2.3719501495361328e+01 9.2748405456542969e+01 -1.5171299934387207e+01 1.9901399612426758e+01 9.2749794006347656e+01 -1.5170499801635742e+01 2.3719501495361328e+01 9.2866699218750000e+01 -1.5381799697875977e+01 1.9901399612426758e+01 9.2906600952148438e+01 -1.5495599746704102e+01 1.9901399612426758e+01 9.2738601684570312e+01 -1.5153800010681152e+01 1.9901399612426758e+01 9.2572799682617188e+01 -1.4951600074768066e+01 1.9901399612426758e+01 9.2514999389648438e+01 -1.4895600318908691e+01 2.3719501495361328e+01 9.2218696594238281e+01 -1.4688899993896484e+01 1.9901399612426758e+01 9.2221199035644531e+01 -1.4684700012207031e+01 2.3719501495361328e+01 9.2374504089355469e+01 -1.4781299591064453e+01 1.9901399612426758e+01 9.2511802673339844e+01 -1.4899199485778809e+01 1.9901399612426758e+01 9.2149505615234375e+01 -1.4647900581359863e+01 1.9901399612426758e+01 9.1904899597167969e+01 -1.4555700302124023e+01 1.9901399612426758e+01 9.1885498046875000e+01 -1.4550399780273438e+01 2.3719501495361328e+01 9.1885200500488281e+01 -1.4552000045776367e+01 1.9901399612426758e+01 9.1647903442382812e+01 -1.4507300376892090e+01 1.9901399612426758e+01 9.1527297973632812e+01 -1.4500200271606445e+01 2.3719501495361328e+01 9.1168098449707031e+01 -1.4540200233459473e+01 1.9901399612426758e+01 9.1167602539062500e+01 -1.4537300109863281e+01 2.3719501495361328e+01 9.1386497497558594e+01 -1.4504300117492676e+01 1.9901399612426758e+01 9.1527297973632812e+01 -1.4505900382995605e+01 1.9901399612426758e+01 9.1128501892089844e+01 -1.4546699523925781e+01 1.9901399612426758e+01 9.0881805419921875e+01 -1.4633299827575684e+01 1.9901399612426758e+01 9.0827194213867188e+01 -1.4659300804138184e+01 2.3719501495361328e+01 9.0829200744628906e+01 -1.4662899971008301e+01 1.9901399612426758e+01 9.0653800964355469e+01 -1.4761400222778320e+01 1.9901399612426758e+01 9.0525901794433594e+01 -1.4859299659729004e+01 2.3719501495361328e+01 9.0529396057128906e+01 -1.4863500595092773e+01 1.9901399612426758e+01 9.0451599121093750e+01 -1.4927200317382812e+01 1.9901399612426758e+01 9.0281303405761719e+01 -1.5125499725341797e+01 1.9901399612426758e+01 9.0708099365234375e+01 -1.5072600364685059e+01 2.4000000000000000e+01 9.0953002929687500e+01 -1.4910000801086426e+01 2.4000000000000000e+01 9.1229797363281250e+01 -1.4810799598693848e+01 2.4000000000000000e+01 9.1522201538085938e+01 -1.4780700683593750e+01 2.4000000000000000e+01 9.1813400268554688e+01 -1.4821499824523926e+01 2.4000000000000000e+01 9.2086303710937500e+01 -1.4930700302124023e+01 2.4000000000000000e+01 9.2325202941894531e+01 -1.5102099418640137e+01 2.4000000000000000e+01 9.2516105651855469e+01 -1.5325699806213379e+01 2.4000000000000000e+01 9.2647903442382812e+01 -1.5588399887084961e+01 2.4000000000000000e+01 9.2713104248046875e+01 -1.5875099182128906e+01 2.4000000000000000e+01 9.2707702636718750e+01 -1.6169000625610352e+01 2.4000000000000000e+01 9.2632194519042969e+01 -1.6453199386596680e+01 2.4000000000000000e+01 9.2490798950195312e+01 -1.6710899353027344e+01 2.4000000000000000e+01 9.2291900634765625e+01 -1.6927400588989258e+01 2.4000000000000000e+01 9.2046997070312500e+01 -1.7090000152587891e+01 2.4000000000000000e+01 9.1770202636718750e+01 -1.7189199447631836e+01 2.4000000000000000e+01 9.1477798461914062e+01 -1.7219299316406250e+01 2.4000000000000000e+01 9.1186599731445312e+01 -1.7178499221801758e+01 2.4000000000000000e+01 9.0913696289062500e+01 -1.7069299697875977e+01 2.4000000000000000e+01 9.0674804687500000e+01 -1.6897899627685547e+01 2.4000000000000000e+01 9.0483894348144531e+01 -1.6674301147460938e+01 2.4000000000000000e+01 9.0352104187011719e+01 -1.6411600112915039e+01 2.4000000000000000e+01 9.0286903381347656e+01 -1.6124900817871094e+01 2.4000000000000000e+01 9.0292297363281250e+01 -1.5830999374389648e+01 2.4000000000000000e+01 9.0367797851562500e+01 -1.5546799659729004e+01 2.4000000000000000e+01 9.0509201049804688e+01 -1.5289099693298340e+01 2.4000000000000000e+01 9.0048301696777344e+01 -1.5593100547790527e+01 1.9863199234008789e+01 9.0141105651855469e+01 -1.5347200393676758e+01 1.9863199234008789e+01 8.9999694824218750e+01 -1.5851300239562988e+01 1.9863199234008789e+01 8.9996704101562500e+01 -1.6114101409912109e+01 1.9863199234008789e+01 9.0039405822753906e+01 -1.6373399734497070e+01 1.9863199234008789e+01 9.0126403808593750e+01 -1.6621398925781250e+01 1.9863199234008789e+01 9.0255203247070312e+01 -1.6850500106811523e+01 1.9863199234008789e+01 9.0421806335449219e+01 -1.7053699493408203e+01 1.9863199234008789e+01 9.0621101379394531e+01 -1.7224901199340820e+01 1.9863199234008789e+01 9.0847198486328125e+01 -1.7358898162841797e+01 1.9863199234008789e+01 9.1093101501464844e+01 -1.7451700210571289e+01 1.9863199234008789e+01 9.1351303100585938e+01 -1.7500299453735352e+01 1.9863199234008789e+01 9.1614097595214844e+01 -1.7503301620483398e+01 1.9863199234008789e+01 9.1873397827148438e+01 -1.7460599899291992e+01 1.9863199234008789e+01 9.2121398925781250e+01 -1.7373600006103516e+01 1.9863199234008789e+01 9.2350494384765625e+01 -1.7244800567626953e+01 1.9863199234008789e+01 9.2553695678710938e+01 -1.7078201293945312e+01 1.9863199234008789e+01 9.2724899291992188e+01 -1.6878898620605469e+01 1.9863199234008789e+01 9.2858901977539062e+01 -1.6652799606323242e+01 1.9863199234008789e+01 9.2951698303222656e+01 -1.6406898498535156e+01 1.9863199234008789e+01 9.3000297546386719e+01 -1.6148698806762695e+01 1.9863199234008789e+01 9.3003303527832031e+01 -1.5885900497436523e+01 1.9863199234008789e+01 9.2960601806640625e+01 -1.5626600265502930e+01 1.9863199234008789e+01 9.2873603820800781e+01 -1.5378600120544434e+01 1.9863199234008789e+01 9.2744796752929688e+01 -1.5149499893188477e+01 1.9863199234008789e+01 9.2578201293945312e+01 -1.4946299552917480e+01 1.9863199234008789e+01 9.2378898620605469e+01 -1.4775099754333496e+01 1.9863199234008789e+01 9.2152793884277344e+01 -1.4641099929809570e+01 1.9863199234008789e+01 9.1906898498535156e+01 -1.4548299789428711e+01 1.9863199234008789e+01 9.1648696899414062e+01 -1.4499699592590332e+01 1.9863199234008789e+01 9.1385902404785156e+01 -1.4496700286865234e+01 1.9863199234008789e+01 9.1126602172851562e+01 -1.4539400100708008e+01 1.9863199234008789e+01 9.0878601074218750e+01 -1.4626399993896484e+01 1.9863199234008789e+01 9.0649497985839844e+01 -1.4755199432373047e+01 1.9863199234008789e+01 9.0275100708007812e+01 -1.5121099472045898e+01 1.9863199234008789e+01 9.0446304321289062e+01 -1.4921800613403320e+01 1.9863199234008789e+01 9.1975898742675781e+01 -1.7052099227905273e+01 1.9099998474121094e+01 9.1401397705078125e+01 -1.6995100021362305e+01 1.9099998474121094e+01 9.0826805114746094e+01 -1.6938199996948242e+01 1.9099998474121094e+01 9.2649101257324219e+01 -1.6113899230957031e+01 1.9099998474121094e+01 9.2312500000000000e+01 -1.6583000183105469e+01 1.9099998474121094e+01 9.2173194885253906e+01 -1.5061800003051758e+01 1.9099998474121094e+01 9.2411102294921875e+01 -1.5587800025939941e+01 1.9099998474121094e+01 9.1024101257324219e+01 -1.4947899818420410e+01 1.9099998474121094e+01 9.1598602294921875e+01 -1.5004899978637695e+01 1.9099998474121094e+01 9.0350906372070312e+01 -1.5886099815368652e+01 1.9099998474121094e+01 9.0687500000000000e+01 -1.5416999816894531e+01 1.9099998474121094e+01 9.0588897705078125e+01 -1.6412200927734375e+01 1.9099998474121094e+01 9.1699104309082031e+01 -1.6979999542236328e+01 1.9099998474121094e+01 9.1979103088378906e+01 -1.6877799987792969e+01 1.9099998474121094e+01 9.2216499328613281e+01 -1.6697601318359375e+01 1.9099998474121094e+01 9.0660499572753906e+01 -1.6543300628662109e+01 1.9099998474121094e+01 9.0857902526855469e+01 -1.6766700744628906e+01 1.9099998474121094e+01 9.1112396240234375e+01 -1.6921798706054688e+01 1.9099998474121094e+01 9.0551803588867188e+01 -1.5682399749755859e+01 1.9099998474121094e+01 9.0500305175781250e+01 -1.5976000785827637e+01 1.9099998474121094e+01 9.0537597656250000e+01 -1.6271799087524414e+01 1.9099998474121094e+01 9.0895401000976562e+01 -1.5203399658203125e+01 1.9099998474121094e+01 9.1449203491210938e+01 -1.5001299858093262e+01 1.9099998474121094e+01 9.1157104492187500e+01 -1.5060600280761719e+01 1.9099998474121094e+01 9.2249198913574219e+01 -1.5337600708007812e+01 1.9099998474121094e+01 9.2020599365234375e+01 -1.5146199226379395e+01 1.9099998474121094e+01 9.1745803833007812e+01 -1.5030699729919434e+01 1.9099998474121094e+01 9.2390296936035156e+01 -1.6455400466918945e+01 1.9099998474121094e+01 9.2485000610351562e+01 -1.6172698974609375e+01 1.9099998474121094e+01 9.2492103576660156e+01 -1.5874700546264648e+01 1.9099998474121094e+01 9.1500000000000000e+01 -1.6000000000000000e+01 1.9677400588989258e+01 9.0345703125000000e+01 4.1032001495361328e+01 1.8000000000000000e+01 8.8730201721191406e+01 4.1035297393798828e+01 1.8000000000000000e+01 8.8780998229980469e+01 4.1529300689697266e+01 1.8000000000000000e+01 9.0895195007324219e+01 4.0016403198242188e+01 1.8000000000000000e+01 9.0156394958496094e+01 3.8577697753906250e+01 1.8000000000000000e+01 8.9745498657226562e+01 3.8856498718261719e+01 1.8000000000000000e+01 9.0950599670410156e+01 4.2015602111816406e+01 1.8000000000000000e+01 9.0218605041503906e+01 4.3455799102783203e+01 1.8000000000000000e+01 9.0677703857421875e+01 4.3645099639892578e+01 1.8000000000000000e+01 9.2654304504394531e+01 4.0968002319335938e+01 1.8000000000000000e+01 9.4255500793457031e+01 4.0716598510742188e+01 1.8000000000000000e+01 9.4160598754882812e+01 4.0229099273681641e+01 1.8000000000000000e+01 8.9800697326660156e+01 4.3187500000000000e+01 1.8000000000000000e+01 8.9437400817871094e+01 4.2848899841308594e+01 1.8000000000000000e+01 8.9140403747558594e+01 4.2450901031494141e+01 1.8000000000000000e+01 8.8919197082519531e+01 4.2006298065185547e+01 1.8000000000000000e+01 8.8768402099609375e+01 4.0540199279785156e+01 1.8000000000000000e+01 8.8894393920898438e+01 4.0059803009033203e+01 1.8000000000000000e+01 8.9104194641113281e+01 3.9609699249267578e+01 1.8000000000000000e+01 8.9390907287597656e+01 3.9204200744628906e+01 1.8000000000000000e+01 9.0610496520996094e+01 3.8376701354980469e+01 1.8000000000000000e+01 9.1093200683593750e+01 3.8260002136230469e+01 1.8000000000000000e+01 9.1588996887207031e+01 3.8231399536132812e+01 1.8000000000000000e+01 9.2049400329589844e+01 3.9984401702880859e+01 1.8000000000000000e+01 9.2081893920898438e+01 3.8291801452636719e+01 1.8000000000000000e+01 9.2556098937988281e+01 3.8439197540283203e+01 1.8000000000000000e+01 9.2996406555175781e+01 3.8669002532958984e+01 1.8000000000000000e+01 9.3388603210449219e+01 3.8973598480224609e+01 1.8000000000000000e+01 9.3720100402832031e+01 3.9343402862548828e+01 1.8000000000000000e+01 9.3980201721191406e+01 3.9766399383544922e+01 1.8000000000000000e+01 9.3055297851562500e+01 4.3292102813720703e+01 1.8000000000000000e+01 9.3439598083496094e+01 4.2977600097656250e+01 1.8000000000000000e+01 9.2104797363281250e+01 4.1983600616455078e+01 1.8000000000000000e+01 9.3761505126953125e+01 4.2599498748779297e+01 1.8000000000000000e+01 9.4261802673339844e+01 4.1213100433349609e+01 1.8000000000000000e+01 9.4179306030273438e+01 4.1702800750732422e+01 1.8000000000000000e+01 9.4010803222656250e+01 4.2169998168945312e+01 1.8000000000000000e+01 9.2621002197265625e+01 4.3533000946044922e+01 1.8000000000000000e+01 9.2150703430175781e+01 4.3692501068115234e+01 1.8000000000000000e+01 9.1659500122070312e+01 4.3765399932861328e+01 1.8000000000000000e+01 9.1163200378417969e+01 4.3749401092529297e+01 1.8000000000000000e+01 8.9437400817871094e+01 4.2848899841308594e+01 1.8590000152587891e+01 8.9140403747558594e+01 4.2450901031494141e+01 1.8590000152587891e+01 8.8919197082519531e+01 4.2006298065185547e+01 1.8590000152587891e+01 8.8780998229980469e+01 4.1529300689697266e+01 1.8590000152587891e+01 8.8730201721191406e+01 4.1035297393798828e+01 1.8590000152587891e+01 8.8768402099609375e+01 4.0540199279785156e+01 1.8590000152587891e+01 8.8894393920898438e+01 4.0059803009033203e+01 1.8590000152587891e+01 8.9104194641113281e+01 3.9609699249267578e+01 1.8590000152587891e+01 8.9390907287597656e+01 3.9204200744628906e+01 1.8590000152587891e+01 8.9745498657226562e+01 3.8856498718261719e+01 1.8590000152587891e+01 9.0156394958496094e+01 3.8577697753906250e+01 1.8590000152587891e+01 9.0610496520996094e+01 3.8376701354980469e+01 1.8590000152587891e+01 9.1093200683593750e+01 3.8260002136230469e+01 1.8590000152587891e+01 9.1588996887207031e+01 3.8231399536132812e+01 1.8590000152587891e+01 9.2081893920898438e+01 3.8291801452636719e+01 1.8590000152587891e+01 9.2556098937988281e+01 3.8439197540283203e+01 1.8590000152587891e+01 9.2996406555175781e+01 3.8669002532958984e+01 1.8590000152587891e+01 9.3388603210449219e+01 3.8973598480224609e+01 1.8590000152587891e+01 9.3720100402832031e+01 3.9343402862548828e+01 1.8590000152587891e+01 9.3980201721191406e+01 3.9766399383544922e+01 1.8590000152587891e+01 9.4160598754882812e+01 4.0229099273681641e+01 1.8590000152587891e+01 9.4255500793457031e+01 4.0716598510742188e+01 1.8590000152587891e+01 9.4261802673339844e+01 4.1213100433349609e+01 1.8590000152587891e+01 9.4179306030273438e+01 4.1702800750732422e+01 1.8590000152587891e+01 9.4010803222656250e+01 4.2169998168945312e+01 1.8590000152587891e+01 9.3761505126953125e+01 4.2599498748779297e+01 1.8590000152587891e+01 9.3439598083496094e+01 4.2977600097656250e+01 1.8590000152587891e+01 9.3055297851562500e+01 4.3292102813720703e+01 1.8590000152587891e+01 9.2621002197265625e+01 4.3533000946044922e+01 1.8590000152587891e+01 9.2150703430175781e+01 4.3692501068115234e+01 1.8590000152587891e+01 9.1659500122070312e+01 4.3765399932861328e+01 1.8590000152587891e+01 9.1163200378417969e+01 4.3749401092529297e+01 1.8590000152587891e+01 9.0677703857421875e+01 4.3645099639892578e+01 1.8590000152587891e+01 9.0218605041503906e+01 4.3455799102783203e+01 1.8590000152587891e+01 8.9800697326660156e+01 4.3187500000000000e+01 1.8590000152587891e+01 9.0075798034667969e+01 4.1555400848388672e+01 1.9830699920654297e+01 9.0001899719238281e+01 4.1307201385498047e+01 1.9830699920654297e+01 9.0000099182128906e+01 4.1292102813720703e+01 1.9830699920654297e+01 8.9971298217773438e+01 4.1042400360107422e+01 1.9830699920654297e+01 8.9972694396972656e+01 4.1019599914550781e+01 1.9830699920654297e+01 8.9987205505371094e+01 4.0776302337646484e+01 1.9830699920654297e+01 8.9994201660156250e+01 4.0746700286865234e+01 1.9830699920654297e+01 9.0048995971679688e+01 4.0516998291015625e+01 1.9830699920654297e+01 9.0064102172851562e+01 4.0482101440429688e+01 1.9830699920654297e+01 9.0154899597167969e+01 4.0272300720214844e+01 1.9830699920654297e+01 9.0180099487304688e+01 4.0234199523925781e+01 1.9830699920654297e+01 9.0301696777343750e+01 4.0049797058105469e+01 1.9830699920654297e+01 9.0338294982910156e+01 4.0011100769042969e+01 1.9830699920654297e+01 9.0484901428222656e+01 3.9856197357177734e+01 1.9830699920654297e+01 9.0533798217773438e+01 3.9819900512695312e+01 1.9830699920654297e+01 9.0699005126953125e+01 3.9697299957275391e+01 1.9830699920654297e+01 9.0760200500488281e+01 3.9666599273681641e+01 1.9830699920654297e+01 9.0937400817871094e+01 3.9577999114990234e+01 1.9830699920654297e+01 9.1010299682617188e+01 3.9556297302246094e+01 1.9830699920654297e+01 9.1192794799804688e+01 3.9501903533935547e+01 1.9830699920654297e+01 9.1276000976562500e+01 3.9492301940917969e+01 1.9830699920654297e+01 9.1457595825195312e+01 3.9471298217773438e+01 1.9830699920654297e+01 9.1548797607421875e+01 3.9476699829101562e+01 1.9830699920654297e+01 9.1723701477050781e+01 3.9487201690673828e+01 1.9830699920654297e+01 9.1819999694824219e+01 3.9510101318359375e+01 1.9830699920654297e+01 9.1983001708984375e+01 3.9548999786376953e+01 1.9830699920654297e+01 9.2080902099609375e+01 3.9591400146484375e+01 1.9830699920654297e+01 9.2227699279785156e+01 3.9654899597167969e+01 1.9830699920654297e+01 9.2322998046875000e+01 3.9717800140380859e+01 1.9830699920654297e+01 9.2450202941894531e+01 3.9801696777343750e+01 1.9830699920654297e+01 9.2538696289062500e+01 3.9885498046875000e+01 1.9830699920654297e+01 9.2643798828125000e+01 3.9984901428222656e+01 1.9830699920654297e+01 9.2721000671386719e+01 4.0088897705078125e+01 1.9830699920654297e+01 9.2802703857421875e+01 4.0199001312255859e+01 1.9830699920654297e+01 9.2864105224609375e+01 4.0321598052978516e+01 1.9830699920654297e+01 9.3015602111816406e+01 4.0844200134277344e+01 1.9830699920654297e+01 9.2998100280761719e+01 4.0692798614501953e+01 1.9830699920654297e+01 9.2963302612304688e+01 4.0576099395751953e+01 1.9830699920654297e+01 9.2922004699707031e+01 4.0437400817871094e+01 1.9830699920654297e+01 9.2973999023437500e+01 4.1386802673339844e+01 1.9830699920654297e+01 9.3012802124023438e+01 4.1223701477050781e+01 1.9830699920654297e+01 9.3019203186035156e+01 4.1117298126220703e+01 1.9830699920654297e+01 9.3028701782226562e+01 4.0957599639892578e+01 1.9830699920654297e+01 9.2744400024414062e+01 4.1880298614501953e+01 1.9830699920654297e+01 9.2845100402832031e+01 4.1727699279785156e+01 1.9830699920654297e+01 9.2881393432617188e+01 4.1643798828125000e+01 1.9830699920654297e+01 9.2950996398925781e+01 4.1483001708984375e+01 1.9830699920654297e+01 9.2355995178222656e+01 4.2261898040771484e+01 1.9830699920654297e+01 9.2515106201171875e+01 4.2143798828125000e+01 1.9830699920654297e+01 9.2567398071289062e+01 4.2088500976562500e+01 1.9830699920654297e+01 9.2698295593261719e+01 4.1950199127197266e+01 1.9830699920654297e+01 9.1858200073242188e+01 4.2482902526855469e+01 1.9830699920654297e+01 9.2062599182128906e+01 4.2422000885009766e+01 1.9830699920654297e+01 9.2117103576660156e+01 4.2394798278808594e+01 1.9830699920654297e+01 9.2301002502441406e+01 4.2302700042724609e+01 1.9830699920654297e+01 9.1314193725585938e+01 4.2515098571777344e+01 1.9830699920654297e+01 9.1542404174804688e+01 4.2528701782226562e+01 1.9830699920654297e+01 9.1587699890136719e+01 4.2523498535156250e+01 1.9830699920654297e+01 9.1807205200195312e+01 4.2498100280761719e+01 1.9830699920654297e+01 9.0793296813964844e+01 4.2354099273681641e+01 1.9830699920654297e+01 9.1016998291015625e+01 4.2451000213623047e+01 1.9830699920654297e+01 9.1046493530273438e+01 4.2458000183105469e+01 1.9830699920654297e+01 9.1276306152343750e+01 4.2512802124023438e+01 1.9830699920654297e+01 9.0361701965332031e+01 4.2020298004150391e+01 1.9830699920654297e+01 9.0549797058105469e+01 4.2198299407958984e+01 1.9830699920654297e+01 9.0562500000000000e+01 4.2206600189208984e+01 1.9830699920654297e+01 9.0772300720214844e+01 4.2345100402832031e+01 1.9830699920654297e+01 9.0078002929687500e+01 4.1562599182128906e+01 1.9830699920654297e+01 9.0197303771972656e+01 4.1800998687744141e+01 1.9830699920654297e+01 9.0356201171875000e+01 4.2015102386474609e+01 1.9830699920654297e+01 9.0105201721191406e+01 4.1551898956298828e+01 1.9901399612426758e+01 9.0071296691894531e+01 4.1457099914550781e+01 2.3719501495361328e+01 9.0222198486328125e+01 4.1785697937011719e+01 2.3719501495361328e+01 9.0007499694824219e+01 4.1101398468017578e+01 1.9901399612426758e+01 9.0003494262695312e+01 4.1101898193359375e+01 2.3719501495361328e+01 9.0030601501464844e+01 4.1301300048828125e+01 1.9901399612426758e+01 9.0076499938964844e+01 4.1455501556396484e+01 1.9901399612426758e+01 9.0000602722167969e+01 4.1041500091552734e+01 1.9901399612426758e+01 9.0016098022460938e+01 4.0780498504638672e+01 1.9901399612426758e+01 9.0022598266601562e+01 4.0740798950195312e+01 2.3719501495361328e+01 9.0025497436523438e+01 4.0741500854492188e+01 1.9901399612426758e+01 9.0076797485351562e+01 4.0526199340820312e+01 1.9901399612426758e+01 9.0127494812011719e+01 4.0394702911376953e+01 2.3719501495361328e+01 9.0313598632812500e+01 4.0084800720214844e+01 1.9901399612426758e+01 9.0312301635742188e+01 4.0083900451660156e+01 2.3719501495361328e+01 9.0180702209472656e+01 4.0286300659179688e+01 1.9901399612426758e+01 9.0132698059082031e+01 4.0396999359130859e+01 1.9901399612426758e+01 9.0324699401855469e+01 4.0068000793457031e+01 1.9901399612426758e+01 9.0504402160644531e+01 3.9878101348876953e+01 1.9901399612426758e+01 9.0566001892089844e+01 3.9826301574707031e+01 2.3719501495361328e+01 9.0876197814941406e+01 3.9641201019287109e+01 1.9901399612426758e+01 9.0874099731445312e+01 3.9636798858642578e+01 2.3719501495361328e+01 9.0714294433593750e+01 3.9722202301025391e+01 1.9901399612426758e+01 9.0568901062011719e+01 3.9830200195312500e+01 1.9901399612426758e+01 9.0948097229003906e+01 3.9605201721191406e+01 1.9901399612426758e+01 9.1198699951171875e+01 3.9530601501464844e+01 1.9901399612426758e+01 9.1218498229980469e+01 3.9526702880859375e+01 2.3719501495361328e+01 9.1218704223632812e+01 3.9528297424316406e+01 1.9901399612426758e+01 9.1458496093750000e+01 3.9500602722167969e+01 1.9901399612426758e+01 9.1579200744628906e+01 3.9502098083496094e+01 2.3719501495361328e+01 9.1934700012207031e+01 3.9567501068115234e+01 1.9901399612426758e+01 9.1935401916503906e+01 3.9564598083496094e+01 2.3719501495361328e+01 9.1719497680664062e+01 3.9516098022460938e+01 1.9901399612426758e+01 9.1578903198242188e+01 3.9507797241210938e+01 1.9901399612426758e+01 9.1973793029785156e+01 3.9576797485351562e+01 1.9901399612426758e+01 9.2213699340820312e+01 3.9680702209472656e+01 1.9901399612426758e+01 9.2266296386718750e+01 3.9710498809814453e+01 2.3719501495361328e+01 9.2263999938964844e+01 3.9713901519775391e+01 1.9901399612426758e+01 9.2431999206542969e+01 3.9824703216552734e+01 1.9901399612426758e+01 9.2552604675292969e+01 3.9931400299072266e+01 2.3719501495361328e+01 9.2548896789550781e+01 3.9935298919677734e+01 1.9901399612426758e+01 9.2621902465820312e+01 4.0004398345947266e+01 1.9901399612426758e+01 9.2777801513671875e+01 4.0214302062988281e+01 2.3719501495361328e+01 9.2777801513671875e+01 4.0214302062988281e+01 1.9901399612426758e+01 9.2894798278808594e+01 4.0448101043701172e+01 1.9901399612426758e+01 9.2928703308105469e+01 4.0542900085449219e+01 2.3719501495361328e+01 9.2992500305175781e+01 4.0898597717285156e+01 1.9901399612426758e+01 9.2996498107910156e+01 4.0898097991943359e+01 2.3719501495361328e+01 9.2969406127929688e+01 4.0698699951171875e+01 1.9901399612426758e+01 9.2923500061035156e+01 4.0544498443603516e+01 1.9901399612426758e+01 9.2999397277832031e+01 4.0958499908447266e+01 1.9901399612426758e+01 9.2983901977539062e+01 4.1219497680664062e+01 1.9901399612426758e+01 9.2977394104003906e+01 4.1259201049804688e+01 2.3719501495361328e+01 9.2974502563476562e+01 4.1258499145507812e+01 1.9901399612426758e+01 9.2923202514648438e+01 4.1473796844482422e+01 1.9901399612426758e+01 9.2872497558593750e+01 4.1605300903320312e+01 2.3719501495361328e+01 9.2686401367187500e+01 4.1915199279785156e+01 1.9901399612426758e+01 9.2687705993652344e+01 4.1916099548339844e+01 2.3719501495361328e+01 9.2819305419921875e+01 4.1713699340820312e+01 1.9901399612426758e+01 9.2867301940917969e+01 4.1603000640869141e+01 1.9901399612426758e+01 9.2675300598144531e+01 4.1932003021240234e+01 1.9901399612426758e+01 9.2495597839355469e+01 4.2121898651123047e+01 1.9901399612426758e+01 9.2433998107910156e+01 4.2173698425292969e+01 2.3719501495361328e+01 9.2123802185058594e+01 4.2358798980712891e+01 1.9901399612426758e+01 9.2125900268554688e+01 4.2363201141357422e+01 2.3719501495361328e+01 9.2285697937011719e+01 4.2277801513671875e+01 1.9901399612426758e+01 9.2431098937988281e+01 4.2169799804687500e+01 1.9901399612426758e+01 9.2051902770996094e+01 4.2394798278808594e+01 1.9901399612426758e+01 9.1801300048828125e+01 4.2469402313232422e+01 1.9901399612426758e+01 9.1781494140625000e+01 4.2473300933837891e+01 2.3719501495361328e+01 9.1781303405761719e+01 4.2471698760986328e+01 1.9901399612426758e+01 9.1541496276855469e+01 4.2499401092529297e+01 1.9901399612426758e+01 9.1420799255371094e+01 4.2497898101806641e+01 2.3719501495361328e+01 9.1065299987792969e+01 4.2432498931884766e+01 1.9901399612426758e+01 9.1064605712890625e+01 4.2435401916503906e+01 2.3719501495361328e+01 9.1280494689941406e+01 4.2483898162841797e+01 1.9901399612426758e+01 9.1421096801757812e+01 4.2492198944091797e+01 1.9901399612426758e+01 9.1026199340820312e+01 4.2423198699951172e+01 1.9901399612426758e+01 9.0786300659179688e+01 4.2319301605224609e+01 1.9901399612426758e+01 9.0733695983886719e+01 4.2289497375488281e+01 2.3719501495361328e+01 9.0736000061035156e+01 4.2286102294921875e+01 1.9901399612426758e+01 9.0568000793457031e+01 4.2175300598144531e+01 1.9901399612426758e+01 9.0447402954101562e+01 4.2068599700927734e+01 2.3719501495361328e+01 9.0451095581054688e+01 4.2064701080322266e+01 1.9901399612426758e+01 9.0378097534179688e+01 4.1995601654052734e+01 1.9901399612426758e+01 9.0222198486328125e+01 4.1785697937011719e+01 1.9901399612426758e+01 9.0644203186035156e+01 4.1868797302246094e+01 2.4000000000000000e+01 9.0876998901367188e+01 4.2048397064208984e+01 2.4000000000000000e+01 9.1145996093750000e+01 4.2166999816894531e+01 2.4000000000000000e+01 9.1435592651367188e+01 4.2217800140380859e+01 2.4000000000000000e+01 9.1728904724121094e+01 4.2197799682617188e+01 2.4000000000000000e+01 9.2008903503417969e+01 4.2108200073242188e+01 2.4000000000000000e+01 9.2259300231933594e+01 4.1954299926757812e+01 2.4000000000000000e+01 9.2465599060058594e+01 4.1744796752929688e+01 2.4000000000000000e+01 9.2615798950195312e+01 4.1492099761962891e+01 2.4000000000000000e+01 9.2701194763183594e+01 4.1210700988769531e+01 2.4000000000000000e+01 9.2716697692871094e+01 4.0917198181152344e+01 2.4000000000000000e+01 9.2661499023437500e+01 4.0628398895263672e+01 2.4000000000000000e+01 9.2538795471191406e+01 4.0361198425292969e+01 2.4000000000000000e+01 9.2355804443359375e+01 4.0131198883056641e+01 2.4000000000000000e+01 9.2123001098632812e+01 3.9951599121093750e+01 2.4000000000000000e+01 9.1853996276855469e+01 3.9833000183105469e+01 2.4000000000000000e+01 9.1564399719238281e+01 3.9782199859619141e+01 2.4000000000000000e+01 9.1271102905273438e+01 3.9802200317382812e+01 2.4000000000000000e+01 9.0991104125976562e+01 3.9891799926757812e+01 2.4000000000000000e+01 9.0740699768066406e+01 4.0045700073242188e+01 2.4000000000000000e+01 9.0534393310546875e+01 4.0255199432373047e+01 2.4000000000000000e+01 9.0384201049804688e+01 4.0507900238037109e+01 2.4000000000000000e+01 9.0298805236816406e+01 4.0789299011230469e+01 2.4000000000000000e+01 9.0283294677734375e+01 4.1082798004150391e+01 2.4000000000000000e+01 9.0338500976562500e+01 4.1371597290039062e+01 2.4000000000000000e+01 9.0461204528808594e+01 4.1638797760009766e+01 2.4000000000000000e+01 9.0023101806640625e+01 4.1302799224853516e+01 1.9863199234008789e+01 9.0098098754882812e+01 4.1554698944091797e+01 1.9863199234008789e+01 8.9992996215820312e+01 4.1041797637939453e+01 1.9863199234008789e+01 9.0008598327636719e+01 4.0779399871826172e+01 1.9863199234008789e+01 9.0069602966308594e+01 4.0523799896240234e+01 1.9863199234008789e+01 9.0173995971679688e+01 4.0282600402832031e+01 1.9863199234008789e+01 9.0318702697753906e+01 4.0063301086425781e+01 1.9863199234008789e+01 9.0499298095703125e+01 3.9872402191162109e+01 1.9863199234008789e+01 9.0710296630859375e+01 3.9715698242187500e+01 1.9863199234008789e+01 9.0945304870605469e+01 3.9598098754882812e+01 1.9863199234008789e+01 9.1197196960449219e+01 3.9523097991943359e+01 1.9863199234008789e+01 9.1458198547363281e+01 3.9493000030517578e+01 1.9863199234008789e+01 9.1720603942871094e+01 3.9508598327636719e+01 1.9863199234008789e+01 9.1976203918457031e+01 3.9569602966308594e+01 1.9863199234008789e+01 9.2217399597167969e+01 3.9673999786376953e+01 1.9863199234008789e+01 9.2436698913574219e+01 3.9818698883056641e+01 1.9863199234008789e+01 9.2627601623535156e+01 3.9999298095703125e+01 1.9863199234008789e+01 9.2784301757812500e+01 4.0210300445556641e+01 1.9863199234008789e+01 9.2901901245117188e+01 4.0445301055908203e+01 1.9863199234008789e+01 9.2976898193359375e+01 4.0697196960449219e+01 1.9863199234008789e+01 9.3006996154785156e+01 4.0958198547363281e+01 1.9863199234008789e+01 9.2991394042968750e+01 4.1220600128173828e+01 1.9863199234008789e+01 9.2930397033691406e+01 4.1476200103759766e+01 1.9863199234008789e+01 9.2826004028320312e+01 4.1717399597167969e+01 1.9863199234008789e+01 9.2681304931640625e+01 4.1936698913574219e+01 1.9863199234008789e+01 9.2500701904296875e+01 4.2127601623535156e+01 1.9863199234008789e+01 9.2289703369140625e+01 4.2284297943115234e+01 1.9863199234008789e+01 9.2054702758789062e+01 4.2401897430419922e+01 1.9863199234008789e+01 9.1802795410156250e+01 4.2476898193359375e+01 1.9863199234008789e+01 9.1541793823242188e+01 4.2506999969482422e+01 1.9863199234008789e+01 9.1279403686523438e+01 4.2491397857666016e+01 1.9863199234008789e+01 9.1023803710937500e+01 4.2430400848388672e+01 1.9863199234008789e+01 9.0782600402832031e+01 4.2326000213623047e+01 1.9863199234008789e+01 9.0563293457031250e+01 4.2181301116943359e+01 1.9863199234008789e+01 9.0215698242187500e+01 4.1789699554443359e+01 1.9863199234008789e+01 9.0372398376464844e+01 4.2000698089599609e+01 1.9863199234008789e+01 9.2049400329589844e+01 3.9984401702880859e+01 1.9099998474121094e+01 9.1472297668457031e+01 4.0000400543212891e+01 1.9099998474121094e+01 9.0895195007324219e+01 4.0016403198242188e+01 1.9099998474121094e+01 9.2654304504394531e+01 4.0968002319335938e+01 1.9099998474121094e+01 9.2351799011230469e+01 4.0476200103759766e+01 1.9099998474121094e+01 9.2104797363281250e+01 4.1983600616455078e+01 1.9099998474121094e+01 9.2379501342773438e+01 4.1475799560546875e+01 1.9099998474121094e+01 9.0950599670410156e+01 4.2015602111816406e+01 1.9099998474121094e+01 9.1527702331542969e+01 4.1999599456787109e+01 1.9099998474121094e+01 9.0345703125000000e+01 4.1032001495361328e+01 1.9099998474121094e+01 9.0648193359375000e+01 4.1523799896240234e+01 1.9099998474121094e+01 9.0620506286621094e+01 4.0524200439453125e+01 1.9099998474121094e+01 9.1768196105957031e+01 4.0036598205566406e+01 1.9099998474121094e+01 9.2040206909179688e+01 4.0158500671386719e+01 1.9099998474121094e+01 9.2264305114746094e+01 4.0355102539062500e+01 1.9099998474121094e+01 9.0701202392578125e+01 4.0398399353027344e+01 1.9099998474121094e+01 9.0914001464843750e+01 4.0189697265625000e+01 1.9099998474121094e+01 9.1178901672363281e+01 4.0052997589111328e+01 1.9099998474121094e+01 9.0531600952148438e+01 4.1249397277832031e+01 1.9099998474121094e+01 9.0501098632812500e+01 4.0952899932861328e+01 1.9099998474121094e+01 9.0559402465820312e+01 4.0660602569580078e+01 1.9099998474121094e+01 9.0840400695800781e+01 4.1751602172851562e+01 1.9099998474121094e+01 9.1378395080566406e+01 4.1992599487304688e+01 1.9099998474121094e+01 9.1091201782226562e+01 4.1912601470947266e+01 1.9099998474121094e+01 9.2200195312500000e+01 4.1713901519775391e+01 1.9099998474121094e+01 9.1958702087402344e+01 4.1888599395751953e+01 1.9099998474121094e+01 9.1676399230957031e+01 4.1984302520751953e+01 1.9099998474121094e+01 9.2420402526855469e+01 4.0608997344970703e+01 1.9099998474121094e+01 9.2494804382324219e+01 4.0897701263427734e+01 1.9099998474121094e+01 9.2480697631835938e+01 4.1195400238037109e+01 1.9099998474121094e+01 9.1500000000000000e+01 4.1000000000000000e+01 1.9677400588989258e+01 5.2845298767089844e+01 4.1004501342773438e+01 1.8000000000000000e+01 5.1230197906494141e+01 4.0969299316406250e+01 1.8000000000000000e+01 5.1269199371337891e+01 4.1464401245117188e+01 1.8000000000000000e+01 5.3418800354003906e+01 4.0002201080322266e+01 1.8000000000000000e+01 5.2714500427246094e+01 3.8546398162841797e+01 1.8000000000000000e+01 5.2297000885009766e+01 3.8815299987792969e+01 1.8000000000000000e+01 5.3426502227783203e+01 4.2002201080322266e+01 1.8000000000000000e+01 5.2660396575927734e+01 4.3424598693847656e+01 1.8000000000000000e+01 5.3114898681640625e+01 4.3624797821044922e+01 1.8000000000000000e+01 5.5154701232910156e+01 4.0995502471923828e+01 1.8000000000000000e+01 5.6761398315429688e+01 4.0782299041748047e+01 1.8000000000000000e+01 5.6678199768066406e+01 4.0292697906494141e+01 1.8000000000000000e+01 5.2249000549316406e+01 4.3146400451660156e+01 1.8000000000000000e+01 5.1893901824951172e+01 4.2799301147460938e+01 1.8000000000000000e+01 5.1606498718261719e+01 4.2394298553466797e+01 1.8000000000000000e+01 5.1395999908447266e+01 4.1944499969482422e+01 1.8000000000000000e+01 5.1280200958251953e+01 4.0475200653076172e+01 1.8000000000000000e+01 5.1417598724365234e+01 3.9997997283935547e+01 1.8000000000000000e+01 5.1638000488281250e+01 3.9553001403808594e+01 1.8000000000000000e+01 5.1934303283691406e+01 3.9154499053955078e+01 1.8000000000000000e+01 5.3173301696777344e+01 3.8356300354003906e+01 1.8000000000000000e+01 5.3658599853515625e+01 3.8251098632812500e+01 1.8000000000000000e+01 5.4154899597167969e+01 3.8234302520751953e+01 1.8000000000000000e+01 5.4573497772216797e+01 3.9997802734375000e+01 1.8000000000000000e+01 5.4646297454833984e+01 3.8306400299072266e+01 1.8000000000000000e+01 5.5116798400878906e+01 3.8465103149414062e+01 1.8000000000000000e+01 5.5551498413085938e+01 3.8705299377441406e+01 1.8000000000000000e+01 5.5936298370361328e+01 3.9019199371337891e+01 1.8000000000000000e+01 5.6258899688720703e+01 3.9396800994873047e+01 1.8000000000000000e+01 5.6508899688720703e+01 3.9825901031494141e+01 1.8000000000000000e+01 5.5500297546386719e+01 4.3328502655029297e+01 1.8000000000000000e+01 5.5891902923583984e+01 4.3023197174072266e+01 1.8000000000000000e+01 5.4581199645996094e+01 4.1997802734375000e+01 1.8000000000000000e+01 5.6222801208496094e+01 4.2652900695800781e+01 1.8000000000000000e+01 5.6755901336669922e+01 4.1278900146484375e+01 1.8000000000000000e+01 5.6661800384521484e+01 4.1766498565673828e+01 1.8000000000000000e+01 5.6482200622558594e+01 4.2229400634765625e+01 1.8000000000000000e+01 5.5060401916503906e+01 4.3558998107910156e+01 1.8000000000000000e+01 5.4586399078369141e+01 4.3707199096679688e+01 1.8000000000000000e+01 5.4093597412109375e+01 4.3768398284912109e+01 1.8000000000000000e+01 5.3597801208496094e+01 4.3740600585937500e+01 1.8000000000000000e+01 5.1893901824951172e+01 4.2799301147460938e+01 1.8590000152587891e+01 5.1606498718261719e+01 4.2394298553466797e+01 1.8590000152587891e+01 5.1395999908447266e+01 4.1944499969482422e+01 1.8590000152587891e+01 5.1269199371337891e+01 4.1464401245117188e+01 1.8590000152587891e+01 5.1230197906494141e+01 4.0969299316406250e+01 1.8590000152587891e+01 5.1280200958251953e+01 4.0475200653076172e+01 1.8590000152587891e+01 5.1417598724365234e+01 3.9997997283935547e+01 1.8590000152587891e+01 5.1638000488281250e+01 3.9553001403808594e+01 1.8590000152587891e+01 5.1934303283691406e+01 3.9154499053955078e+01 1.8590000152587891e+01 5.2297000885009766e+01 3.8815299987792969e+01 1.8590000152587891e+01 5.2714500427246094e+01 3.8546398162841797e+01 1.8590000152587891e+01 5.3173301696777344e+01 3.8356300354003906e+01 1.8590000152587891e+01 5.3658599853515625e+01 3.8251098632812500e+01 1.8590000152587891e+01 5.4154899597167969e+01 3.8234302520751953e+01 1.8590000152587891e+01 5.4646297454833984e+01 3.8306400299072266e+01 1.8590000152587891e+01 5.5116798400878906e+01 3.8465103149414062e+01 1.8590000152587891e+01 5.5551498413085938e+01 3.8705299377441406e+01 1.8590000152587891e+01 5.5936298370361328e+01 3.9019199371337891e+01 1.8590000152587891e+01 5.6258899688720703e+01 3.9396800994873047e+01 1.8590000152587891e+01 5.6508899688720703e+01 3.9825901031494141e+01 1.8590000152587891e+01 5.6678199768066406e+01 4.0292697906494141e+01 1.8590000152587891e+01 5.6761398315429688e+01 4.0782299041748047e+01 1.8590000152587891e+01 5.6755901336669922e+01 4.1278900146484375e+01 1.8590000152587891e+01 5.6661800384521484e+01 4.1766498565673828e+01 1.8590000152587891e+01 5.6482200622558594e+01 4.2229400634765625e+01 1.8590000152587891e+01 5.6222801208496094e+01 4.2652900695800781e+01 1.8590000152587891e+01 5.5891902923583984e+01 4.3023197174072266e+01 1.8590000152587891e+01 5.5500297546386719e+01 4.3328502655029297e+01 1.8590000152587891e+01 5.5060401916503906e+01 4.3558998107910156e+01 1.8590000152587891e+01 5.4586399078369141e+01 4.3707199096679688e+01 1.8590000152587891e+01 5.4093597412109375e+01 4.3768398284912109e+01 1.8590000152587891e+01 5.3597801208496094e+01 4.3740600585937500e+01 1.8590000152587891e+01 5.3114898681640625e+01 4.3624797821044922e+01 1.8590000152587891e+01 5.2660396575927734e+01 4.3424598693847656e+01 1.8590000152587891e+01 5.2249000549316406e+01 4.3146400451660156e+01 1.8590000152587891e+01 5.2562999725341797e+01 4.1521301269531250e+01 1.9830699920654297e+01 5.2494998931884766e+01 4.1271400451660156e+01 1.9830699920654297e+01 5.2493598937988281e+01 4.1256301879882812e+01 1.9830699920654297e+01 5.2470699310302734e+01 4.1005897521972656e+01 1.9830699920654297e+01 5.2472599029541016e+01 4.0983200073242188e+01 1.9830699920654297e+01 5.2492900848388672e+01 4.0740299224853516e+01 1.9830699920654297e+01 5.2500698089599609e+01 4.0710899353027344e+01 1.9830699920654297e+01 5.2560897827148438e+01 4.0482498168945312e+01 1.9830699920654297e+01 5.2576900482177734e+01 4.0447998046875000e+01 1.9830699920654297e+01 5.2672599792480469e+01 4.0240501403808594e+01 1.9830699920654297e+01 5.2698699951171875e+01 4.0203002929687500e+01 1.9830699920654297e+01 5.2824699401855469e+01 4.0021499633789062e+01 1.9830699920654297e+01 5.2862201690673828e+01 3.9983699798583984e+01 1.9830699920654297e+01 5.3012500762939453e+01 3.9832302093505859e+01 1.9830699920654297e+01 5.3062202453613281e+01 3.9797203063964844e+01 1.9830699920654297e+01 5.3230201721191406e+01 3.9678600311279297e+01 1.9830699920654297e+01 5.3292198181152344e+01 3.9649402618408203e+01 1.9830699920654297e+01 5.3471401214599609e+01 3.9565002441406250e+01 1.9830699920654297e+01 5.3544799804687500e+01 3.9544998168945312e+01 1.9830699920654297e+01 5.3728599548339844e+01 3.9494998931884766e+01 1.9830699920654297e+01 5.3812000274658203e+01 3.9487400054931641e+01 1.9830699920654297e+01 5.3994098663330078e+01 3.9470699310302734e+01 1.9830699920654297e+01 5.4085098266601562e+01 3.9478298187255859e+01 1.9830699920654297e+01 5.4259696960449219e+01 3.9492900848388672e+01 1.9830699920654297e+01 5.4355400085449219e+01 3.9518199920654297e+01 1.9830699920654297e+01 5.4517501831054688e+01 3.9560897827148438e+01 1.9830699920654297e+01 5.4614303588867188e+01 3.9605598449707031e+01 1.9830699920654297e+01 5.4759498596191406e+01 3.9672599792480469e+01 1.9830699920654297e+01 5.4853302001953125e+01 3.9737796783447266e+01 1.9830699920654297e+01 5.4978500366210938e+01 3.9824703216552734e+01 1.9830699920654297e+01 5.5064903259277344e+01 3.9910499572753906e+01 1.9830699920654297e+01 5.5167701721191406e+01 4.0012500762939453e+01 1.9830699920654297e+01 5.5242401123046875e+01 4.0118198394775391e+01 1.9830699920654297e+01 5.5321399688720703e+01 4.0230197906494141e+01 1.9830699920654297e+01 5.5379901885986328e+01 4.0354301452636719e+01 1.9830699920654297e+01 5.5518898010253906e+01 4.0880298614501953e+01 1.9830699920654297e+01 5.5505001068115234e+01 4.0728599548339844e+01 1.9830699920654297e+01 5.5472999572753906e+01 4.0611000061035156e+01 1.9830699920654297e+01 5.5435001373291016e+01 4.0471401214599609e+01 1.9830699920654297e+01 5.5464302062988281e+01 4.1421802520751953e+01 1.9830699920654297e+01 5.5507102966308594e+01 4.1259696960449219e+01 1.9830699920654297e+01 5.5516002655029297e+01 4.1153503417968750e+01 1.9830699920654297e+01 5.5529300689697266e+01 4.0994098663330078e+01 1.9830699920654297e+01 5.5223098754882812e+01 4.1909698486328125e+01 1.9830699920654297e+01 5.5327400207519531e+01 4.1759498596191406e+01 1.9830699920654297e+01 5.5365600585937500e+01 4.1676601409912109e+01 1.9830699920654297e+01 5.5439098358154297e+01 4.1517498016357422e+01 1.9830699920654297e+01 5.4825702667236328e+01 4.2281898498535156e+01 1.9830699920654297e+01 5.4987503051757812e+01 4.2167701721191406e+01 1.9830699920654297e+01 5.5041202545166016e+01 4.2113700866699219e+01 1.9830699920654297e+01 5.5175300598144531e+01 4.1978500366210938e+01 1.9830699920654297e+01 5.4322799682617188e+01 4.2491001129150391e+01 1.9830699920654297e+01 5.4528602600097656e+01 4.2435001373291016e+01 1.9830699920654297e+01 5.4583698272705078e+01 4.2409099578857422e+01 1.9830699920654297e+01 5.4769798278808594e+01 4.2321399688720703e+01 1.9830699920654297e+01 5.3778202056884766e+01 4.2510200500488281e+01 1.9830699920654297e+01 5.4005897521972656e+01 4.2529300689697266e+01 1.9830699920654297e+01 5.4051399230957031e+01 4.2525100708007812e+01 1.9830699920654297e+01 5.4271400451660156e+01 4.2505001068115234e+01 1.9830699920654297e+01 5.3261199951171875e+01 4.2336898803710938e+01 1.9830699920654297e+01 5.3482498168945312e+01 4.2439098358154297e+01 1.9830699920654297e+01 5.3511898040771484e+01 4.2446800231933594e+01 1.9830699920654297e+01 5.3740299224853516e+01 4.2507099151611328e+01 1.9830699920654297e+01 5.2837699890136719e+01 4.1992900848388672e+01 1.9830699920654297e+01 5.3021503448486328e+01 4.2175300598144531e+01 1.9830699920654297e+01 5.3034000396728516e+01 4.2183998107910156e+01 1.9830699920654297e+01 5.3240501403808594e+01 4.2327400207519531e+01 1.9830699920654297e+01 5.2565002441406250e+01 4.1528602600097656e+01 1.9830699920654297e+01 5.2678600311279297e+01 4.1769798278808594e+01 1.9830699920654297e+01 5.2832302093505859e+01 4.1987499237060547e+01 1.9830699920654297e+01 5.2592502593994141e+01 4.1518497467041016e+01 1.9901399612426758e+01 5.2560897827148438e+01 4.1422901153564453e+01 2.3719501495361328e+01 5.2703899383544922e+01 4.1754997253417969e+01 2.3719501495361328e+01 5.2505500793457031e+01 4.1065799713134766e+01 1.9901399612426758e+01 5.2501499176025391e+01 4.1066200256347656e+01 2.3719501495361328e+01 5.2523799896240234e+01 4.1266201019287109e+01 1.9901399612426758e+01 5.2566101074218750e+01 4.1421497344970703e+01 1.9901399612426758e+01 5.2500000000000000e+01 4.1005802154541016e+01 1.9901399612426758e+01 5.2521797180175781e+01 4.0745300292968750e+01 1.9901399612426758e+01 5.2529201507568359e+01 4.0705699920654297e+01 2.3719501495361328e+01 5.2531997680664062e+01 4.0706398010253906e+01 1.9901399612426758e+01 5.2588500976562500e+01 4.0492401123046875e+01 1.9901399612426758e+01 5.2642299652099609e+01 4.0362201690673828e+01 2.3719501495361328e+01 5.2835800170898438e+01 4.0056797027587891e+01 1.9901399612426758e+01 5.2834400177001953e+01 4.0055801391601562e+01 2.3719501495361328e+01 5.2698101043701172e+01 4.0254997253417969e+01 1.9901399612426758e+01 5.2647502899169922e+01 4.0364601135253906e+01 1.9901399612426758e+01 5.2847198486328125e+01 4.0040298461914062e+01 1.9901399612426758e+01 5.3031398773193359e+01 3.9854701995849609e+01 1.9901399612426758e+01 5.3094200134277344e+01 3.9804298400878906e+01 2.3719501495361328e+01 5.3408802032470703e+01 3.9626697540283203e+01 1.9901399612426758e+01 5.3406700134277344e+01 3.9622299194335938e+01 2.3719501495361328e+01 5.3244998931884766e+01 3.9703903198242188e+01 1.9901399612426758e+01 5.3097000122070312e+01 3.9808300018310547e+01 1.9901399612426758e+01 5.3481498718261719e+01 3.9592502593994141e+01 1.9901399612426758e+01 5.3733798980712891e+01 3.9523799896240234e+01 1.9901399612426758e+01 5.3753601074218750e+01 3.9520401000976562e+01 2.3719501495361328e+01 5.3753799438476562e+01 3.9521999359130859e+01 1.9901399612426758e+01 5.3994201660156250e+01 3.9500000000000000e+01 1.9901399612426758e+01 5.4114898681640625e+01 3.9504402160644531e+01 2.3719501495361328e+01 5.4468700408935547e+01 3.9578201293945312e+01 1.9901399612426758e+01 5.4469501495361328e+01 3.9575401306152344e+01 2.3719501495361328e+01 5.4254699707031250e+01 3.9521797180175781e+01 1.9901399612426758e+01 5.4114402770996094e+01 3.9510101318359375e+01 1.9901399612426758e+01 5.4507598876953125e+01 3.9588500976562500e+01 1.9901399612426758e+01 5.4744998931884766e+01 3.9698101043701172e+01 1.9901399612426758e+01 5.4796798706054688e+01 3.9729099273681641e+01 2.3719501495361328e+01 5.4794502258300781e+01 3.9732398986816406e+01 1.9901399612426758e+01 5.4959697723388672e+01 3.9847198486328125e+01 1.9901399612426758e+01 5.5077796936035156e+01 3.9956699371337891e+01 2.3719501495361328e+01 5.5073997497558594e+01 3.9960601806640625e+01 1.9901399612426758e+01 5.5145301818847656e+01 4.0031398773193359e+01 1.9901399612426758e+01 5.5296100616455078e+01 4.0244998931884766e+01 2.3719501495361328e+01 5.5296100616455078e+01 4.0244998931884766e+01 1.9901399612426758e+01 5.5407501220703125e+01 4.0481498718261719e+01 1.9901399612426758e+01 5.5439098358154297e+01 4.0577098846435547e+01 2.3719501495361328e+01 5.5494499206542969e+01 4.0934200286865234e+01 1.9901399612426758e+01 5.5498500823974609e+01 4.0933799743652344e+01 2.3719501495361328e+01 5.5476200103759766e+01 4.0733798980712891e+01 1.9901399612426758e+01 5.5433898925781250e+01 4.0578498840332031e+01 1.9901399612426758e+01 5.5500000000000000e+01 4.0994201660156250e+01 1.9901399612426758e+01 5.5478199005126953e+01 4.1254699707031250e+01 1.9901399612426758e+01 5.5470798492431641e+01 4.1294300079345703e+01 2.3719501495361328e+01 5.5468002319335938e+01 4.1293598175048828e+01 1.9901399612426758e+01 5.5411499023437500e+01 4.1507602691650391e+01 1.9901399612426758e+01 5.5357696533203125e+01 4.1637802124023438e+01 2.3719501495361328e+01 5.5164199829101562e+01 4.1943199157714844e+01 1.9901399612426758e+01 5.5165599822998047e+01 4.1944198608398438e+01 2.3719501495361328e+01 5.5301902770996094e+01 4.1744998931884766e+01 1.9901399612426758e+01 5.5352500915527344e+01 4.1635402679443359e+01 1.9901399612426758e+01 5.5152801513671875e+01 4.1959697723388672e+01 1.9901399612426758e+01 5.4968597412109375e+01 4.2145301818847656e+01 1.9901399612426758e+01 5.4905799865722656e+01 4.2195701599121094e+01 2.3719501495361328e+01 5.4591201782226562e+01 4.2373298645019531e+01 1.9901399612426758e+01 5.4593299865722656e+01 4.2377700805664062e+01 2.3719501495361328e+01 5.4754997253417969e+01 4.2296100616455078e+01 1.9901399612426758e+01 5.4902999877929688e+01 4.2191699981689453e+01 1.9901399612426758e+01 5.4518497467041016e+01 4.2407501220703125e+01 1.9901399612426758e+01 5.4266201019287109e+01 4.2476200103759766e+01 1.9901399612426758e+01 5.4246398925781250e+01 4.2479598999023438e+01 2.3719501495361328e+01 5.4246196746826172e+01 4.2478000640869141e+01 1.9901399612426758e+01 5.4005802154541016e+01 4.2500000000000000e+01 1.9901399612426758e+01 5.3885097503662109e+01 4.2495601654052734e+01 2.3719501495361328e+01 5.3531299591064453e+01 4.2421798706054688e+01 1.9901399612426758e+01 5.3530498504638672e+01 4.2424598693847656e+01 2.3719501495361328e+01 5.3745300292968750e+01 4.2478199005126953e+01 1.9901399612426758e+01 5.3885601043701172e+01 4.2489902496337891e+01 1.9901399612426758e+01 5.3492401123046875e+01 4.2411499023437500e+01 1.9901399612426758e+01 5.3255001068115234e+01 4.2301898956298828e+01 1.9901399612426758e+01 5.3203197479248047e+01 4.2270896911621094e+01 2.3719501495361328e+01 5.3205501556396484e+01 4.2267597198486328e+01 1.9901399612426758e+01 5.3040298461914062e+01 4.2152801513671875e+01 1.9901399612426758e+01 5.2922199249267578e+01 4.2043296813964844e+01 2.3719501495361328e+01 5.2925998687744141e+01 4.2039402008056641e+01 1.9901399612426758e+01 5.2854698181152344e+01 4.1968597412109375e+01 1.9901399612426758e+01 5.2703899383544922e+01 4.1754997253417969e+01 1.9901399612426758e+01 5.3123798370361328e+01 4.1848201751708984e+01 2.4000000000000000e+01 5.3352199554443359e+01 4.2033199310302734e+01 2.4000000000000000e+01 5.3618301391601562e+01 4.2158203125000000e+01 2.4000000000000000e+01 5.3906600952148438e+01 4.2215900421142578e+01 2.4000000000000000e+01 5.4200298309326172e+01 4.2202899932861328e+01 2.4000000000000000e+01 5.4482398986816406e+01 4.2120098114013672e+01 2.4000000000000000e+01 5.4736396789550781e+01 4.1972099304199219e+01 2.4000000000000000e+01 5.4947601318359375e+01 4.1767601013183594e+01 2.4000000000000000e+01 5.5103801727294922e+01 4.1518497467041016e+01 2.4000000000000000e+01 5.5195800781250000e+01 4.1239299774169922e+01 2.4000000000000000e+01 5.5218299865722656e+01 4.0946201324462891e+01 2.4000000000000000e+01 5.5169998168945312e+01 4.0656200408935547e+01 2.4000000000000000e+01 5.5053699493408203e+01 4.0386199951171875e+01 2.4000000000000000e+01 5.4876201629638672e+01 4.0151802062988281e+01 2.4000000000000000e+01 5.4647800445556641e+01 3.9966800689697266e+01 2.4000000000000000e+01 5.4381698608398438e+01 3.9841800689697266e+01 2.4000000000000000e+01 5.4093399047851562e+01 3.9784099578857422e+01 2.4000000000000000e+01 5.3799701690673828e+01 3.9797100067138672e+01 2.4000000000000000e+01 5.3517597198486328e+01 3.9879898071289062e+01 2.4000000000000000e+01 5.3263599395751953e+01 4.0027900695800781e+01 2.4000000000000000e+01 5.3052398681640625e+01 4.0232402801513672e+01 2.4000000000000000e+01 5.2896202087402344e+01 4.0481498718261719e+01 2.4000000000000000e+01 5.2804203033447266e+01 4.0760700225830078e+01 2.4000000000000000e+01 5.2781700134277344e+01 4.1053802490234375e+01 2.4000000000000000e+01 5.2829998016357422e+01 4.1343799591064453e+01 2.4000000000000000e+01 5.2946300506591797e+01 4.1613800048828125e+01 2.4000000000000000e+01 5.2516300201416016e+01 4.1267601013183594e+01 1.9863199234008789e+01 5.2585300445556641e+01 4.1521099090576172e+01 1.9863199234008789e+01 5.2492397308349609e+01 4.1005802154541016e+01 1.9863199234008789e+01 5.2514301300048828e+01 4.0743999481201172e+01 1.9863199234008789e+01 5.2581298828125000e+01 4.0489902496337891e+01 1.9863199234008789e+01 5.2691501617431641e+01 4.0251300811767578e+01 1.9863199234008789e+01 5.2841400146484375e+01 4.0035400390625000e+01 1.9863199234008789e+01 5.3026500701904297e+01 3.9848899841308594e+01 1.9863199234008789e+01 5.3241100311279297e+01 3.9697299957275391e+01 1.9863199234008789e+01 5.3478900909423828e+01 3.9585300445556641e+01 1.9863199234008789e+01 5.3732498168945312e+01 3.9516300201416016e+01 1.9863199234008789e+01 5.3994201660156250e+01 3.9492397308349609e+01 1.9863199234008789e+01 5.4256000518798828e+01 3.9514301300048828e+01 1.9863199234008789e+01 5.4510101318359375e+01 3.9581298828125000e+01 1.9863199234008789e+01 5.4748699188232422e+01 3.9691501617431641e+01 1.9863199234008789e+01 5.4964599609375000e+01 3.9841400146484375e+01 1.9863199234008789e+01 5.5151100158691406e+01 4.0026500701904297e+01 1.9863199234008789e+01 5.5302700042724609e+01 4.0241100311279297e+01 1.9863199234008789e+01 5.5414699554443359e+01 4.0478900909423828e+01 1.9863199234008789e+01 5.5483699798583984e+01 4.0732398986816406e+01 1.9863199234008789e+01 5.5507598876953125e+01 4.0994201660156250e+01 1.9863199234008789e+01 5.5485698699951172e+01 4.1256000518798828e+01 1.9863199234008789e+01 5.5418701171875000e+01 4.1510101318359375e+01 1.9863199234008789e+01 5.5308498382568359e+01 4.1748699188232422e+01 1.9863199234008789e+01 5.5158599853515625e+01 4.1964603424072266e+01 1.9863199234008789e+01 5.4973503112792969e+01 4.2151100158691406e+01 1.9863199234008789e+01 5.4758899688720703e+01 4.2302700042724609e+01 1.9863199234008789e+01 5.4521099090576172e+01 4.2414699554443359e+01 1.9863199234008789e+01 5.4267498016357422e+01 4.2483699798583984e+01 1.9863199234008789e+01 5.4005802154541016e+01 4.2507598876953125e+01 1.9863199234008789e+01 5.3743999481201172e+01 4.2485698699951172e+01 1.9863199234008789e+01 5.3489902496337891e+01 4.2418701171875000e+01 1.9863199234008789e+01 5.3251300811767578e+01 4.2308498382568359e+01 1.9863199234008789e+01 5.3035400390625000e+01 4.2158599853515625e+01 1.9863199234008789e+01 5.2697299957275391e+01 4.1758899688720703e+01 1.9863199234008789e+01 5.2848899841308594e+01 4.1973503112792969e+01 1.9863199234008789e+01 5.4573497772216797e+01 3.9997802734375000e+01 1.9099998474121094e+01 5.3996101379394531e+01 4.0000000000000000e+01 1.9099998474121094e+01 5.3418800354003906e+01 4.0002201080322266e+01 1.9099998474121094e+01 5.5154701232910156e+01 4.0995502471923828e+01 1.9099998474121094e+01 5.4864101409912109e+01 4.0496597290039062e+01 1.9099998474121094e+01 5.4581199645996094e+01 4.1997802734375000e+01 1.9099998474121094e+01 5.4868000030517578e+01 4.1496601104736328e+01 1.9099998474121094e+01 5.3426502227783203e+01 4.2002201080322266e+01 1.9099998474121094e+01 5.4003902435302734e+01 4.2000000000000000e+01 1.9099998474121094e+01 5.2845298767089844e+01 4.1004501342773438e+01 1.9099998474121094e+01 5.3135902404785156e+01 4.1503398895263672e+01 1.9099998474121094e+01 5.3131999969482422e+01 4.0503402709960938e+01 1.9099998474121094e+01 5.4291000366210938e+01 4.0043296813964844e+01 1.9099998474121094e+01 5.4560100555419922e+01 4.0171600341796875e+01 1.9099998474121094e+01 5.4779399871826172e+01 4.0373500823974609e+01 1.9099998474121094e+01 5.3215801239013672e+01 4.0379497528076172e+01 1.9099998474121094e+01 5.3433498382568359e+01 4.0175998687744141e+01 1.9099998474121094e+01 5.3701499938964844e+01 4.0045600891113281e+01 1.9099998474121094e+01 5.3025901794433594e+01 4.1226303100585938e+01 1.9099998474121094e+01 5.3002498626708984e+01 4.0929100036621094e+01 1.9099998474121094e+01 5.3067699432373047e+01 4.0638301849365234e+01 1.9099998474121094e+01 5.3322700500488281e+01 4.1735702514648438e+01 1.9099998474121094e+01 5.3854801177978516e+01 4.1989402770996094e+01 1.9099998474121094e+01 5.3569599151611328e+01 4.1902603149414062e+01 1.9099998474121094e+01 5.4682998657226562e+01 4.1730400085449219e+01 1.9099998474121094e+01 5.4437400817871094e+01 4.1899299621582031e+01 1.9099998474121094e+01 5.4152896881103516e+01 4.1988201141357422e+01 1.9099998474121094e+01 5.4929496765136719e+01 4.0631099700927734e+01 1.9099998474121094e+01 5.4996898651123047e+01 4.0921401977539062e+01 1.9099998474121094e+01 5.4975799560546875e+01 4.1218700408935547e+01 1.9099998474121094e+01 5.4000000000000000e+01 4.1000000000000000e+01 1.9677400588989258e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 54960 -> 29 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00) (float-vector 1.0034800320863724e+02 -1.3035899400711060e+02 -8.9568302035331726e+01) (float-vector 1.0066799819469452e+02 1.2795999646186829e+02 -9.0272001922130585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3035198748111725e+01 1.4641800522804260e+02 -7.3508702218532562e+01) (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00) (float-vector 1.0066799819469452e+02 1.2795999646186829e+02 -9.0272001922130585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3035198748111725e+01 1.4641800522804260e+02 -7.3508702218532562e+01) (float-vector 6.0473199933767319e+01 1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 5.4901000112295151e+01 1.4386500418186188e+02 1.1833200231194496e+01) (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4947400689125061e+01 1.0706499963998795e+02 5.9463001787662506e+01) (float-vector 1.0964600369334221e+01 -2.7816700749099255e+00 4.3760100379586220e+00) (float-vector 1.0964600369334221e+01 -8.4148002788424492e+00 -1.6226699808612466e+00) (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00) (float-vector 5.4901000112295151e+01 1.4386500418186188e+02 1.1833200231194496e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00) (float-vector 9.6847802400588989e+01 -1.4115400612354279e+02 -8.1881396472454071e+01) (float-vector 1.0034800320863724e+02 -1.3035899400711060e+02 -8.9568302035331726e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9537298083305359e+01 1.3650099933147430e+02 6.1502899974584579e+01) (float-vector 9.7499996423721313e+01 1.3237899541854858e+02 6.4155198633670807e+01) (float-vector 5.1813498139381409e+01 1.0827299952507019e+02 6.4153000712394714e+01) (float-vector 4.4947400689125061e+01 1.0706499963998795e+02 5.9463001787662506e+01) (float-vector 5.4901000112295151e+01 1.4386500418186188e+02 1.1833200231194496e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4960200786590576e+01 -1.0706999897956848e+02 5.9489399194717407e+01) (float-vector 1.0964600369334221e+01 -2.7816700749099255e+00 4.3760100379586220e+00) (float-vector 4.4947400689125061e+01 1.0706499963998795e+02 5.9463001787662506e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0125699639320374e+02 -1.3503499329090118e+02 6.2888503074645996e+01) (float-vector 1.0461100190877914e+02 1.3472799956798553e+02 5.9821199625730515e+01) (float-vector 1.4068800210952759e+02 1.3158800080418587e+01 1.2485500425100327e+01) (float-vector 1.0462500154972076e+02 -1.3473300635814667e+02 5.9792399406433105e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9537298083305359e+01 1.3650099933147430e+02 6.1502899974584579e+01) (float-vector 1.0461100190877914e+02 1.3472799956798553e+02 5.9821199625730515e+01) (float-vector 1.0125699639320374e+02 -1.3503499329090118e+02 6.2888503074645996e+01) (float-vector 9.7499996423721313e+01 1.3237899541854858e+02 6.4155198633670807e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0473199933767319e+01 1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 1.0815200209617615e+02 1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 1.0511200129985809e+02 1.3649700582027435e+02 5.6187298148870468e+01) (float-vector 1.0461100190877914e+02 1.3472799956798553e+02 5.9821199625730515e+01) (float-vector 9.9537298083305359e+01 1.3650099933147430e+02 6.1502899974584579e+01) (float-vector 5.4901000112295151e+01 1.4386500418186188e+02 1.1833200231194496e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0964600369334221e+01 -2.7816700749099255e+00 4.3760100379586220e+00) (float-vector 4.4960200786590576e+01 -1.0706999897956848e+02 5.9489399194717407e+01) (float-vector 5.3943399339914322e+01 -1.4217799901962280e+02 1.4210499823093414e+01) (float-vector 1.0964600369334221e+01 -8.4148002788424492e+00 -1.6226699808612466e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2000001072883606e+01 -1.0833500325679779e+02 6.4155198633670807e+01) (float-vector 9.6508897840976715e+01 -1.3425500690937042e+02 6.3276499509811401e+01) (float-vector 5.3943399339914322e+01 -1.4217799901962280e+02 1.4210499823093414e+01) (float-vector 4.4960200786590576e+01 -1.0706999897956848e+02 5.9489399194717407e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2000001072883606e+01 -1.0833500325679779e+02 6.4155198633670807e+01) (float-vector 4.4960200786590576e+01 -1.0706999897956848e+02 5.9489399194717407e+01) (float-vector 4.4947400689125061e+01 1.0706499963998795e+02 5.9463001787662506e+01) (float-vector 5.1813498139381409e+01 1.0827299952507019e+02 6.4153000712394714e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6508897840976715e+01 -1.3425500690937042e+02 6.3276499509811401e+01) (float-vector 5.2000001072883606e+01 -1.0833500325679779e+02 6.4155198633670807e+01) (float-vector 5.1813498139381409e+01 1.0827299952507019e+02 6.4153000712394714e+01) (float-vector 9.7499996423721313e+01 1.3237899541854858e+02 6.4155198633670807e+01) (float-vector 1.0125699639320374e+02 -1.3503499329090118e+02 6.2888503074645996e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4019399881362915e+02 1.4747600257396698e+02 -6.8220600485801697e+01) (float-vector 1.0511200129985809e+02 1.3649700582027435e+02 5.6187298148870468e+01) (float-vector 1.0815200209617615e+02 1.4785000681877136e+02 -2.0000000949949026e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4019399881362915e+02 1.4747600257396698e+02 -6.8220600485801697e+01) (float-vector 1.0815200209617615e+02 1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 6.0473199933767319e+01 1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 9.3035198748111725e+01 1.4641800522804260e+02 -7.3508702218532562e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6847802400588989e+01 -1.4115400612354279e+02 -8.1881396472454071e+01) (float-vector 1.4575700461864471e+02 -1.4223100244998932e+02 -8.1143297255039215e+01) (float-vector 1.4934499561786652e+02 -1.2977899610996246e+02 -8.9477300643920898e+01) (float-vector 1.0034800320863724e+02 -1.3035899400711060e+02 -8.9568302035331726e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.2184999883174896e+02 -9.0999998152256012e+01) (float-vector 1.4934499561786652e+02 -1.2977899610996246e+02 -8.9477300643920898e+01) (float-vector 1.4575700461864471e+02 -1.4223100244998932e+02 -8.1143297255039215e+01) (float-vector 1.3880799710750580e+02 -1.4785000681877136e+02 -6.4999997615814209e+01) (float-vector 1.0462500154972076e+02 -1.3473300635814667e+02 5.9792399406433105e+01) (float-vector 1.4068800210952759e+02 1.3158800080418587e+01 1.2485500425100327e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4068800210952759e+02 1.3158800080418587e+01 1.2485500425100327e+01) (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -8.7999999523162842e+01) (float-vector 1.5000000596046448e+02 -1.2184999883174896e+02 -9.0999998152256012e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0473199933767319e+01 -1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 9.1942697763442993e+01 -1.4712199568748474e+02 -7.1109503507614136e+01) (float-vector 9.6847802400588989e+01 -1.4115400612354279e+02 -8.1881396472454071e+01) (float-vector 1.0964600369334221e+01 2.2807898931205273e+00 -8.4102898836135864e+00) (float-vector 1.0964600369334221e+01 -8.4148002788424492e+00 -1.6226699808612466e+00) (float-vector 5.3943399339914322e+01 -1.4217799901962280e+02 1.4210499823093414e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0815200209617615e+02 -1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 1.3880799710750580e+02 -1.4785000681877136e+02 -6.4999997615814209e+01) (float-vector 9.1942697763442993e+01 -1.4712199568748474e+02 -7.1109503507614136e+01) (float-vector 6.0473199933767319e+01 -1.4785000681877136e+02 -2.0000000949949026e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6847802400588989e+01 -1.4115400612354279e+02 -8.1881396472454071e+01) (float-vector 9.1942697763442993e+01 -1.4712199568748474e+02 -7.1109503507614136e+01) (float-vector 1.3880799710750580e+02 -1.4785000681877136e+02 -6.4999997615814209e+01) (float-vector 1.4575700461864471e+02 -1.4223100244998932e+02 -8.1143297255039215e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0125699639320374e+02 -1.3503499329090118e+02 6.2888503074645996e+01) (float-vector 1.0462500154972076e+02 -1.3473300635814667e+02 5.9792399406433105e+01) (float-vector 1.3880799710750580e+02 -1.4785000681877136e+02 -6.4999997615814209e+01) (float-vector 1.0815200209617615e+02 -1.4785000681877136e+02 -2.0000000949949026e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3943399339914322e+01 -1.4217799901962280e+02 1.4210499823093414e+01) (float-vector 9.6508897840976715e+01 -1.3425500690937042e+02 6.3276499509811401e+01) (float-vector 1.0125699639320374e+02 -1.3503499329090118e+02 6.2888503074645996e+01) (float-vector 1.0815200209617615e+02 -1.4785000681877136e+02 -2.0000000949949026e+00) (float-vector 6.0473199933767319e+01 -1.4785000681877136e+02 -2.0000000949949026e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4758099615573883e+02 1.3799299299716949e+02 -8.5381202399730682e+01) (float-vector 9.3035198748111725e+01 1.4641800522804260e+02 -7.3508702218532562e+01) (float-vector 1.0066799819469452e+02 1.2795999646186829e+02 -9.0272001922130585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4758099615573883e+02 1.3799299299716949e+02 -8.5381202399730682e+01) (float-vector 1.4019399881362915e+02 1.4747600257396698e+02 -6.8220600485801697e+01) (float-vector 9.3035198748111725e+01 1.4641800522804260e+02 -7.3508702218532562e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -9.0999998152256012e+01) (float-vector 1.4758099615573883e+02 1.3799299299716949e+02 -8.5381202399730682e+01) (float-vector 1.0066799819469452e+02 1.2795999646186829e+02 -9.0272001922130585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4934499561786652e+02 -1.2977899610996246e+02 -8.9477300643920898e+01) (float-vector 1.5000000596046448e+02 -1.2184999883174896e+02 -9.0999998152256012e+01) (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -8.7999999523162842e+01) (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -9.0999998152256012e+01) (float-vector 1.0066799819469452e+02 1.2795999646186829e+02 -9.0272001922130585e+01) (float-vector 1.0034800320863724e+02 -1.3035899400711060e+02 -8.9568302035331726e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0511200129985809e+02 1.3649700582027435e+02 5.6187298148870468e+01) (float-vector 1.4019399881362915e+02 1.4747600257396698e+02 -6.8220600485801697e+01) (float-vector 1.4758099615573883e+02 1.3799299299716949e+02 -8.5381202399730682e+01) (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -9.0999998152256012e+01) (float-vector 1.5000000596046448e+02 1.2184999883174896e+02 -8.7999999523162842e+01) (float-vector 1.4068800210952759e+02 1.3158800080418587e+01 1.2485500425100327e+01) (float-vector 1.0461100190877914e+02 1.3472799956798553e+02 5.9821199625730515e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_mount_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_mount_prosilica_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -4.6457000000000001e+01 1.2500000000000000e+01 8.8921000000000006e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 10 11 0 0 11 1 36 0 2 36 10 0 2 1 3 2 3 4 36 2 4 36 4 6 36 6 8 36 8 10 8 9 10 10 9 11 6 7 8 8 7 9 4 5 6 6 5 7 4 3 5 3 13 5 5 13 14 5 14 7 7 14 15 7 15 9 9 15 16 9 16 11 14 20 15 15 20 21 15 21 16 13 19 14 14 19 20 19 25 20 20 25 26 20 26 21 16 21 22 21 26 27 21 27 22 25 31 26 26 31 32 26 32 27 19 24 25 24 30 25 25 30 31 30 37 31 31 37 32 27 32 33 32 37 33 22 27 28 27 33 28 28 33 34 33 37 34 34 37 35 35 37 30 24 35 30 29 34 35 29 35 24 18 24 19 18 29 24 23 28 29 23 29 18 28 34 29 22 28 23 17 22 23 17 23 12 12 23 18 12 18 13 13 18 19 1 12 3 3 12 13 1 17 12 11 16 17 11 17 1 16 22 17))
                   (list :vertices (let ((mat (make-matrix 38 3))) (fvector-replace (array-entity mat) #f(4.6673900604248047e+01 -1.2500000000000000e+01 -8.8470504760742188e+01 4.6847900390625000e+01 -1.2500000000000000e+01 -8.8609298706054688e+01 4.6565498352050781e+01 -1.2312100410461426e+01 -8.8470504760742188e+01 4.6652500152587891e+01 -1.2161499977111816e+01 -8.8609298706054688e+01 4.6348499298095703e+01 -1.2312100410461426e+01 -8.8470504760742188e+01 4.6261501312255859e+01 -1.2161499977111816e+01 -8.8609298706054688e+01 4.6240097045898438e+01 -1.2500000000000000e+01 -8.8470504760742188e+01 4.6066101074218750e+01 -1.2500000000000000e+01 -8.8609298706054688e+01 4.6348499298095703e+01 -1.2687900543212891e+01 -8.8470504760742188e+01 4.6261501312255859e+01 -1.2838500022888184e+01 -8.8609298706054688e+01 4.6565498352050781e+01 -1.2687900543212891e+01 -8.8470504760742188e+01 4.6652500152587891e+01 -1.2838500022888184e+01 -8.8609298706054688e+01 4.6944499969482422e+01 -1.2500000000000000e+01 -8.8809700012207031e+01 4.6700702667236328e+01 -1.2077799797058105e+01 -8.8809700012207031e+01 4.6213298797607422e+01 -1.2077799797058105e+01 -8.8809700012207031e+01 4.5969501495361328e+01 -1.2500000000000000e+01 -8.8809700012207031e+01 4.6213298797607422e+01 -1.2922200202941895e+01 -8.8809700012207031e+01 4.6700702667236328e+01 -1.2922200202941895e+01 -8.8809700012207031e+01 4.6944499969482422e+01 -1.2500000000000000e+01 -8.9032302856445312e+01 4.6700702667236328e+01 -1.2077799797058105e+01 -8.9032302856445312e+01 4.6213298797607422e+01 -1.2077799797058105e+01 -8.9032302856445312e+01 4.5969501495361328e+01 -1.2500000000000000e+01 -8.9032302856445312e+01 4.6213298797607422e+01 -1.2922200202941895e+01 -8.9032302856445312e+01 4.6700702667236328e+01 -1.2922200202941895e+01 -8.9032302856445312e+01 4.6847900390625000e+01 -1.2500000000000000e+01 -8.9232696533203125e+01 4.6652500152587891e+01 -1.2161499977111816e+01 -8.9232696533203125e+01 4.6261501312255859e+01 -1.2161499977111816e+01 -8.9232696533203125e+01 4.6066101074218750e+01 -1.2500000000000000e+01 -8.9232696533203125e+01 4.6261501312255859e+01 -1.2838500022888184e+01 -8.9232696533203125e+01 4.6652500152587891e+01 -1.2838500022888184e+01 -8.9232696533203125e+01 4.6673900604248047e+01 -1.2500000000000000e+01 -8.9371505737304688e+01 4.6565498352050781e+01 -1.2312100410461426e+01 -8.9371505737304688e+01 4.6348499298095703e+01 -1.2312100410461426e+01 -8.9371505737304688e+01 4.6240097045898438e+01 -1.2500000000000000e+01 -8.9371505737304688e+01 4.6348499298095703e+01 -1.2687900543212891e+01 -8.9371505737304688e+01 4.6565498352050781e+01 -1.2687900543212891e+01 -8.9371505737304688e+01 4.6457000732421875e+01 -1.2500000000000000e+01 -8.8421005249023438e+01 4.6457000732421875e+01 -1.2500000000000000e+01 -8.9420997619628906e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 216 -> 4 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6944499015808105e+01 -1.2500000186264515e+01 -8.9032299816608429e+01) (float-vector 4.6700701117515564e+01 -1.2077799998223782e+01 -8.8809698820114136e+01) (float-vector 4.5969501137733459e+01 -1.2500000186264515e+01 -8.8809698820114136e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6457000076770782e+01 -1.2500000186264515e+01 -8.8421002030372620e+01) (float-vector 4.6944499015808105e+01 -1.2500000186264515e+01 -8.9032299816608429e+01) (float-vector 4.5969501137733459e+01 -1.2500000186264515e+01 -8.8809698820114136e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6700701117515564e+01 -1.2077799998223782e+01 -8.8809698820114136e+01) (float-vector 4.6457000076770782e+01 -1.2500000186264515e+01 -8.8421002030372620e+01) (float-vector 4.5969501137733459e+01 -1.2500000186264515e+01 -8.8809698820114136e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6457000076770782e+01 -1.2500000186264515e+01 -8.8421002030372620e+01) (float-vector 4.6700701117515564e+01 -1.2077799998223782e+01 -8.8809698820114136e+01) (float-vector 4.6944499015808105e+01 -1.2500000186264515e+01 -8.9032299816608429e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_mount_prosilica_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_pan_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -1.7069999999999997e+01 0.0000000000000000e+00 3.8144999999999999e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 3 0 2 3 4 0 1 0 209 0 4 209 1 209 208 2 1 208 2 208 3 207 3 208 208 209 84 205 208 84 208 205 207 207 205 206 3 207 121 121 207 206 205 188 192 205 192 206 205 245 188 245 205 84 121 206 124 124 206 190 206 192 190 190 192 188 188 189 190 124 190 125 190 189 125 124 125 121 121 125 122 122 125 127 125 131 127 191 125 189 131 125 191 120 121 122 127 120 122 123 121 120 123 3 121 126 3 123 120 126 123 126 4 3 4 126 120 132 4 120 120 215 132 215 120 127 209 4 132 215 214 132 132 214 209 213 214 215 215 211 213 215 127 211 214 151 209 214 213 151 84 209 151 81 83 84 84 83 85 85 219 84 249 84 151 81 84 249 218 84 219 84 218 217 245 84 217 216 218 85 218 219 85 216 85 83 218 216 217 216 193 217 195 217 193 217 195 248 248 245 217 196 216 83 216 197 193 197 216 196 196 193 197 198 199 196 199 200 196 196 202 193 196 82 198 82 196 83 200 202 196 198 164 199 170 164 198 82 170 198 78 82 83 78 170 82 78 83 81 78 79 80 78 81 79 135 78 44 78 136 158 78 80 44 136 78 135 78 158 170 170 158 164 158 136 38 33 158 38 158 33 164 136 135 39 25 38 136 136 39 25 39 135 44 17 39 40 44 40 39 25 39 17 15 25 17 25 24 32 32 38 25 15 24 25 33 38 32 24 31 32 31 33 32 31 24 34 33 31 161 31 162 163 162 31 34 31 163 161 24 36 34 169 34 36 34 169 162 162 174 163 162 175 174 175 162 169 36 166 169 169 177 175 169 166 177 24 35 36 36 35 37 36 37 166 167 166 37 167 177 166 167 175 177 167 37 48 165 167 48 165 236 167 236 175 167 47 48 37 47 37 49 37 35 49 48 47 165 165 47 168 172 236 165 168 172 165 49 6 47 50 51 47 47 6 50 51 168 47 35 6 49 5 6 7 7 6 8 8 6 35 5 50 6 51 50 52 52 50 5 52 53 51 5 53 52 118 114 53 139 53 5 139 118 53 51 53 119 119 53 114 5 12 139 139 12 138 139 87 118 138 87 139 5 11 12 11 18 12 55 138 12 55 12 18 5 7 11 10 11 7 10 19 11 19 18 11 55 18 19 22 55 19 22 54 55 54 138 55 19 10 20 20 22 19 8 9 10 8 10 7 9 20 10 21 20 9 21 22 20 13 9 8 13 21 9 13 8 15 8 24 15 8 35 24 14 13 15 14 21 13 14 22 21 16 14 15 16 22 14 15 17 16 16 23 22 40 16 17 40 29 16 23 16 29 30 23 29 30 22 23 54 22 30 29 28 30 28 54 30 26 29 40 29 26 28 40 44 26 26 27 28 26 45 27 26 44 45 54 28 27 27 56 54 54 56 138 27 45 42 27 41 46 42 41 27 46 56 27 45 43 42 45 44 133 45 133 43 41 42 43 56 41 138 41 56 46 43 138 41 133 137 43 43 137 138 133 44 134 133 134 156 157 137 133 156 157 133 138 137 81 137 157 81 159 157 156 157 159 81 156 134 159 44 80 134 159 134 79 80 79 134 81 159 160 159 79 160 81 160 79 138 81 249 140 87 138 140 138 249 87 140 89 140 141 89 140 249 141 86 87 88 89 90 87 88 87 90 86 118 87 93 86 88 118 86 93 91 92 88 88 92 93 90 91 88 89 95 90 95 102 90 90 102 91 91 183 92 183 91 102 181 92 182 92 181 93 92 183 184 92 184 182 102 186 183 183 186 184 95 99 102 104 102 99 102 104 186 186 187 184 186 188 187 104 188 186 184 245 182 187 245 184 187 188 245 189 188 104 99 103 104 104 103 189 101 189 103 191 189 101 100 103 99 100 101 103 101 100 62 105 101 75 75 101 62 101 105 191 129 131 191 191 105 129 70 74 105 70 105 75 74 129 105 62 73 75 70 75 73 69 70 71 71 70 72 72 70 73 69 74 70 69 71 152 69 152 155 69 155 74 71 149 152 149 71 72 72 150 149 73 150 72 149 150 151 151 152 149 151 155 152 210 74 155 210 155 212 155 151 212 210 128 74 130 128 210 212 130 210 211 130 212 211 212 213 151 213 212 130 129 128 127 129 130 127 130 211 128 129 74 127 131 129 151 153 154 153 151 150 151 154 144 249 151 144 77 154 153 148 154 77 148 144 154 65 77 76 77 66 148 77 65 66 77 153 76 148 66 68 147 148 68 146 148 147 144 148 146 65 64 66 66 64 67 66 67 68 64 65 61 76 61 65 61 60 64 60 67 64 67 145 146 60 145 67 146 147 67 147 68 67 145 144 146 96 94 145 145 94 144 60 96 145 143 144 94 250 249 144 143 250 144 142 143 89 89 143 94 143 142 250 250 142 249 142 141 249 141 142 89 89 94 95 94 99 95 97 99 94 100 99 97 96 97 94 98 97 96 98 63 97 97 63 62 100 97 62 98 60 63 98 96 60 62 63 58 63 60 58 62 58 57 57 73 62 57 58 59 58 60 59 59 60 61 57 59 76 61 76 59 57 76 73 150 73 153 73 76 153 245 246 111 182 245 111 245 247 246 247 245 248 182 185 181 185 182 111 185 111 181 107 93 181 181 111 113 110 181 113 107 181 110 106 107 108 107 109 108 110 109 107 106 93 107 118 93 106 106 108 114 118 106 114 108 109 114 109 117 114 110 119 109 119 117 109 113 115 110 110 115 119 51 119 172 115 172 119 117 119 114 112 115 113 112 172 115 51 172 168 112 116 172 244 172 116 244 236 172 111 112 113 111 116 112 111 246 116 116 226 244 246 226 116 226 236 244 222 179 236 226 222 236 175 236 179 226 225 222 246 225 226 220 179 222 223 220 222 222 225 223 179 180 175 220 221 179 179 221 180 180 174 175 180 221 229 178 180 230 229 230 180 180 178 174 224 221 220 234 229 221 224 234 221 233 230 229 234 233 229 178 230 231 233 235 230 230 235 231 233 234 235 224 228 234 234 251 235 234 228 251 228 224 220 223 228 220 223 227 228 228 227 251 227 223 225 246 251 227 246 227 225 248 246 247 248 251 246 194 248 195 241 251 248 241 248 194 193 194 195 203 241 194 193 203 194 240 241 203 240 251 241 202 203 193 203 239 240 202 239 203 238 240 239 251 240 238 251 243 235 243 251 238 238 200 204 204 243 238 238 242 200 242 238 239 242 239 202 200 242 202 200 199 204 201 237 204 201 204 199 243 204 237 237 232 243 235 243 232 231 235 232 231 232 201 232 237 201 176 201 199 231 201 178 178 201 176 199 164 176 174 176 173 174 178 176 164 173 176 33 161 164 164 161 171 173 164 163 163 164 171 163 174 173 171 161 163 252 253 254 255 253 252 268 252 270 252 254 270 252 288 289 252 289 255 290 288 252 252 268 290 255 256 253 255 286 256 255 289 286 289 312 286 288 313 289 289 313 312 288 290 313 268 292 290 290 314 313 290 292 314 336 313 314 336 312 313 292 317 314 336 314 317 268 291 292 291 315 292 292 315 317 341 317 315 317 341 336 312 336 333 341 333 336 315 318 341 341 367 363 367 341 318 341 360 333 360 341 363 291 316 315 316 318 315 294 316 291 316 294 319 319 337 316 316 337 318 262 294 291 294 262 295 295 320 294 320 319 294 260 262 263 262 264 263 264 262 291 295 262 260 258 260 259 260 258 295 263 259 260 304 259 263 293 263 264 293 282 263 263 282 304 293 264 291 280 293 291 280 282 293 281 282 279 279 282 280 281 304 282 281 259 304 279 278 281 278 283 281 283 259 281 278 279 273 276 279 280 273 279 276 280 277 276 280 291 277 276 267 269 276 269 273 276 277 267 272 273 271 271 273 269 273 272 278 267 268 269 271 269 270 269 268 270 291 268 267 291 267 277 254 271 270 274 271 254 271 274 272 274 275 272 275 284 272 272 284 278 253 275 274 254 253 274 275 307 284 275 253 307 284 283 278 284 307 283 259 283 307 257 258 259 259 261 257 259 307 261 257 296 297 257 297 258 257 261 299 257 299 296 322 258 297 258 322 295 297 321 322 321 354 322 322 354 295 295 354 320 353 354 321 353 374 354 374 344 354 354 344 320 297 353 321 297 352 353 373 353 352 353 373 374 373 366 374 343 374 366 344 374 343 343 319 344 319 320 344 319 343 338 343 366 367 343 367 338 372 367 366 366 352 372 366 373 352 378 367 372 351 378 372 372 352 351 377 367 378 378 350 377 350 378 351 351 352 323 324 350 351 324 351 323 325 350 301 301 350 324 377 350 325 323 296 324 324 296 301 297 296 323 323 352 297 299 301 296 302 301 299 302 325 301 298 299 261 300 299 298 299 300 303 303 302 299 325 302 326 326 302 303 300 327 303 303 347 345 327 347 303 303 345 326 326 345 346 326 346 325 347 375 345 346 345 376 376 345 375 348 347 327 348 375 347 327 300 328 328 348 327 328 349 348 348 349 355 355 375 348 369 375 355 375 370 376 370 375 369 371 369 355 349 371 355 328 357 349 371 349 357 309 328 300 328 309 357 356 357 309 356 362 357 365 357 362 371 357 365 371 361 369 371 365 361 362 361 365 361 362 363 362 364 363 364 362 356 306 358 356 306 356 309 358 364 356 306 309 300 305 306 300 308 306 305 358 306 308 329 359 358 329 358 308 359 364 358 364 359 360 360 363 364 331 359 329 331 335 359 360 359 335 285 329 308 331 329 285 308 305 285 265 266 285 305 265 285 266 330 285 330 331 285 330 334 331 335 331 334 333 335 334 333 360 335 333 334 332 310 334 330 332 334 310 310 330 266 266 265 256 287 310 266 256 287 266 287 311 310 332 310 311 312 332 311 332 312 333 286 311 287 312 311 286 256 286 287 256 265 253 265 307 253 307 265 305 305 298 307 298 261 307 298 305 300 363 367 369 361 363 369 342 338 367 367 368 369 342 367 318 377 368 367 370 369 368 376 370 368 368 377 376 346 377 325 376 377 346 337 339 318 339 342 318 319 340 337 340 339 337 338 339 340 338 342 339 340 319 338 379 380 381 379 398 401 397 379 381 397 398 379 401 380 379 397 394 398 398 399 400 394 399 398 400 401 398 400 402 401 401 402 380 406 400 399 400 411 402 406 411 400 399 394 403 399 405 406 403 405 399 409 406 405 409 410 406 406 410 411 411 434 402 410 434 411 434 380 402 381 380 382 380 383 382 380 392 383 380 434 392 383 414 382 414 415 382 382 415 381 383 392 393 413 414 383 393 413 383 412 393 392 432 392 434 412 392 432 393 437 413 393 457 437 412 457 393 437 438 413 413 438 414 438 437 459 457 460 437 437 460 459 412 458 457 458 460 457 459 460 461 460 462 461 460 458 462 438 459 439 461 439 459 414 438 439 414 439 415 439 440 415 461 463 439 440 439 463 415 416 381 415 440 416 440 417 416 440 441 417 441 440 463 463 461 468 444 441 463 463 468 444 441 419 417 441 444 419 381 416 417 417 419 395 417 395 381 397 381 395 394 395 396 397 395 394 396 395 418 419 418 395 419 442 418 444 442 419 442 444 468 442 443 418 442 445 443 468 445 442 418 443 421 446 421 443 443 464 446 445 464 443 445 466 464 445 469 466 445 468 493 445 493 469 464 465 446 464 466 465 465 466 467 466 469 467 493 467 469 467 446 465 467 470 446 467 493 470 471 446 470 493 494 470 494 500 470 470 500 471 471 447 446 481 471 500 447 471 481 500 494 501 481 500 480 500 501 480 449 481 480 448 481 449 422 481 448 447 481 422 421 447 422 421 446 447 422 385 387 422 390 421 387 390 422 422 448 385 448 449 423 423 385 448 449 480 423 423 424 386 385 423 386 450 424 423 423 478 450 480 478 423 384 385 386 386 388 384 425 388 386 424 425 386 388 425 426 388 434 384 434 388 426 426 425 427 427 432 426 434 426 432 434 410 384 409 384 410 405 408 409 408 431 409 431 384 409 407 405 403 407 408 405 420 408 407 389 408 420 431 408 389 389 384 431 389 390 387 389 391 390 387 384 389 391 389 420 418 420 407 418 391 420 418 390 391 418 421 390 404 396 418 404 418 407 396 404 403 403 404 407 394 396 403 384 387 385 427 433 432 432 433 435 412 432 435 427 436 433 484 485 433 435 433 485 436 484 433 435 456 412 435 485 456 412 456 458 456 486 458 485 486 456 484 491 485 485 491 486 436 483 484 484 489 491 483 489 484 488 491 489 487 486 491 491 488 487 486 462 458 462 486 487 462 487 461 461 487 468 488 468 487 488 493 468 488 489 490 495 493 488 495 488 490 492 490 489 495 490 498 490 492 498 489 483 492 492 483 498 482 495 498 482 498 476 483 476 498 482 476 475 482 502 495 475 502 482 475 476 455 476 483 455 483 436 455 455 427 454 454 475 455 427 455 436 454 474 475 474 502 475 430 454 427 430 474 454 430 427 425 425 429 430 430 429 453 473 474 430 453 473 430 473 502 474 472 473 453 503 473 472 502 473 503 453 429 452 452 472 453 425 428 429 428 452 429 424 428 425 428 424 451 428 477 452 451 477 428 452 504 472 452 477 504 472 504 503 493 496 504 503 504 496 505 493 504 504 477 505 479 477 451 479 505 477 451 424 450 450 479 451 450 478 479 499 505 479 479 478 499 499 493 505 495 496 493 494 493 499 496 495 497 496 497 503 495 502 497 503 497 502 499 478 494 478 480 501 478 501 494))
                   (list :vertices (let ((mat (make-matrix 506 3))) (fvector-replace (array-entity mat) #f(-6.1686000823974609e+01 -8.0005302429199219e+01 -4.3572198486328125e+02 -5.7268299102783203e+01 -8.8917701721191406e+01 -4.4159701538085938e+02 -5.8562900543212891e+01 -9.6166297912597656e+01 -4.4050601196289062e+02 -6.4116798400878906e+01 -9.6160301208496094e+01 -4.2883599853515625e+02 -6.4026901245117188e+01 -7.2972099304199219e+01 -4.2868798828125000e+02 8.7988098144531250e+01 8.6345298767089844e+01 -3.2078399658203125e+02 1.1314900207519531e+02 8.5319801330566406e+01 -3.2326800537109375e+02 1.0787999725341797e+02 8.5713996887207031e+01 -3.2432199096679688e+02 1.3320001220703125e+02 8.5145896911621094e+01 -3.4262500000000000e+02 1.2792900085449219e+02 8.7013999938964844e+01 -3.4215100097656250e+02 1.1465500640869141e+02 8.7076400756835938e+01 -3.3059201049804688e+02 1.0046599578857422e+02 8.8640602111816406e+01 -3.2552001953125000e+02 8.7932899475097656e+01 8.7771293640136719e+01 -3.2264199829101562e+02 1.3779600524902344e+02 8.6926994323730469e+01 -3.5750601196289062e+02 1.4225199890136719e+02 8.6866500854492188e+01 -3.7362301635742188e+02 1.4523999023437500e+02 8.4946105957031250e+01 -3.7172299194335938e+02 1.4224200439453125e+02 8.6737403869628906e+01 -3.9072299194335938e+02 1.4478799438476562e+02 8.5063499450683594e+01 -3.9054299926757812e+02 8.7951599121093750e+01 9.1464202880859375e+01 -3.2350399780273438e+02 1.0799800109863281e+02 9.1465400695800781e+01 -3.2854699707031250e+02 1.2315600585937500e+02 9.1444595336914062e+01 -3.3854602050781250e+02 1.3547399902343750e+02 9.1464103698730469e+01 -3.5494598388671875e+02 1.4154299926757812e+02 9.1471199035644531e+01 -3.7472097778320312e+02 1.4046000671386719e+02 9.1456001281738281e+01 -3.9485998535156250e+02 1.4615499877929688e+02 8.4545402526855469e+01 -3.6193402099609375e+02 1.4847599792480469e+02 8.4434898376464844e+01 -3.9035998535156250e+02 1.2226599884033203e+02 8.6202400207519531e+01 -4.2700201416015625e+02 9.8695205688476562e+01 9.1447700500488281e+01 -4.3811199951171875e+02 1.1969900512695312e+02 9.1463401794433594e+01 -4.2815399169921875e+02 1.3492999267578125e+02 8.7671195983886719e+01 -4.1066400146484375e+02 1.3282699584960938e+02 9.1472198486328125e+01 -4.1345300292968750e+02 1.4977101135253906e+02 8.0785102844238281e+01 -3.6470199584960938e+02 1.5090000915527344e+02 8.2902999877929688e+01 -3.7978198242187500e+02 1.5187800598144531e+02 8.0916397094726562e+01 -3.8149301147460938e+02 1.4471598815917969e+02 8.1780097961425781e+01 -3.5119699096679688e+02 1.3405899047851562e+02 8.4360000610351562e+01 -3.3866302490234375e+02 1.3966600036621094e+02 8.1803199768066406e+01 -3.4259799194335938e+02 1.3034999084472656e+02 8.1801300048828125e+01 -3.3164999389648438e+02 1.5104100036621094e+02 8.1169204711914062e+01 -3.9089501953125000e+02 1.4150099182128906e+02 8.4197898864746094e+01 -4.0893899536132812e+02 1.3502099609375000e+02 8.5649497985839844e+01 -4.1347500610351562e+02 8.5105102539062500e+01 8.6976898193359375e+01 -4.4128900146484375e+02 9.5329200744628906e+01 8.7339294433593750e+01 -4.3944998168945312e+02 8.5094299316406250e+01 8.4885002136230469e+01 -4.4575799560546875e+02 1.3287001037597656e+02 8.3030204772949219e+01 -4.2295901489257812e+02 1.1238700103759766e+02 8.6026199340820312e+01 -4.3388400268554688e+02 8.5104698181152344e+01 9.1451400756835938e+01 -4.3987597656250000e+02 1.1127900695800781e+02 8.1927703857421875e+01 -3.1880300903320312e+02 1.2270200347900391e+02 8.0129699707031250e+01 -3.2539300537109375e+02 1.2351799774169922e+02 8.3850898742675781e+01 -3.2781100463867188e+02 9.9465499877929688e+01 8.4950996398925781e+01 -3.1718899536132812e+02 9.8000099182128906e+01 8.2123901367187500e+01 -3.1470599365234375e+02 8.8133499145507812e+01 8.4897300720214844e+01 -3.1503900146484375e+02 8.8160598754882812e+01 8.0735305786132812e+01 -3.1341000366210938e+02 8.5791999816894531e+01 9.1472198486328125e+01 -4.1116601562500000e+02 8.6863304138183594e+01 9.1472198486328125e+01 -3.6682400512695312e+02 8.5251693725585938e+01 9.1472198486328125e+01 -4.3353302001953125e+02 -5.5790199279785156e+01 6.3591697692871094e+01 -3.8171197509765625e+02 -5.5112201690673828e+01 9.6616905212402344e+01 -3.8262399291992188e+02 -5.8460300445556641e+01 6.3782604217529297e+01 -3.8732901000976562e+02 -6.1215499877929688e+01 9.6615600585937500e+01 -3.9762100219726562e+02 -6.1290100097656250e+01 6.5565299987792969e+01 -3.9808099365234375e+02 -4.8779598236083984e+01 6.5187500000000000e+01 -3.7315802001953125e+02 -4.6558399200439453e+01 9.6614700317382812e+01 -3.7346301269531250e+02 -6.4033004760742188e+01 9.6615699768066406e+01 -4.2727597045898438e+02 -6.3997097015380859e+01 7.3116897583007812e+01 -4.2824798583984375e+02 -6.1141597747802734e+01 8.0544204711914062e+01 -4.3708200073242188e+02 -6.0182003021240234e+01 9.6616699218750000e+01 -4.3909399414062500e+02 -5.6808200836181641e+01 9.0048400878906250e+01 -4.4194799804687500e+02 -8.4139305114746094e+01 5.5237197875976562e+00 -4.0187298583984375e+02 -7.6928100585937500e+01 3.0334899902343750e+01 -3.9414797973632812e+02 -8.0317901611328125e+01 2.3708200454711914e+01 -3.9804299926757812e+02 -7.5564804077148438e+01 3.7034400939941406e+01 -3.9578198242187500e+02 -6.4668899536132812e+01 5.3006298065185547e+01 -3.8649697875976562e+02 -8.3326805114746094e+01 -5.9685602188110352e+00 -3.9946301269531250e+02 -6.0656902313232422e+01 5.3605400085449219e+01 -3.8165701293945312e+02 -6.2873497009277344e+01 6.2823696136474609e+01 -4.0245101928710938e+02 -6.4920402526855469e+01 7.2791595458984375e+01 -4.3713198852539062e+02 1.4602500915527344e+02 7.2175506591796875e+01 -4.0960897827148438e+02 1.3480099487304688e+02 4.7776798248291016e+01 -4.3210598754882812e+02 1.3923999023437500e+02 6.2649303436279297e+01 -4.2239801025390625e+02 1.2801599121093750e+02 3.3111500740051270e+00 -4.4605700683593750e+02 1.4505499267578125e+02 -7.0639404296875000e+01 -4.1168099975585938e+02 1.3940299987792969e+02 -6.0145500183105469e+01 -4.2303601074218750e+02 1.2798101043701172e+02 -5.1002998352050781e+00 -4.4605801391601562e+02 1.3442599487304688e+02 -4.6413898468017578e+01 -4.3288998413085938e+02 8.5564102172851562e+01 8.0686500549316406e+01 -3.0536300659179688e+02 6.7386001586914062e+01 8.0378501892089844e+01 -3.0737799072265625e+02 7.2294097900390625e+01 4.5515998840332031e+01 -3.0486499023437500e+02 4.8596698760986328e+01 8.0062004089355469e+01 -3.1445199584960938e+02 5.3547698974609375e+01 3.6908599853515625e+01 -3.1038601684570312e+02 5.5645500183105469e+01 3.0338001251220703e+00 -3.0903100585937500e+02 6.8668800354003906e+01 -3.2503700256347656e+01 -3.0519400024414062e+02 8.5615394592285156e+01 2.8354900360107422e+01 -3.0314801025390625e+02 7.6148800849914551e+00 7.9328796386718750e+01 -3.3738699340820312e+02 2.4541999816894531e+01 5.0746997833251953e+01 -3.2621899414062500e+02 7.6141500473022461e+00 9.6615600585937500e+01 -3.3854400634765625e+02 -1.9146099090576172e+01 7.0537704467773438e+01 -3.5261898803710938e+02 -1.6384799957275391e+01 9.6615600585937500e+01 -3.5275302124023438e+02 2.9477601051330566e+00 3.6125000000000000e+01 -3.3805200195312500e+02 -3.0802700042724609e+01 3.6128402709960938e+01 -3.5898797607421875e+02 -4.7462200164794922e+01 2.2165300369262695e+01 -3.7044799804687500e+02 2.8052400588989258e+01 6.9486998021602631e-02 -3.2314599609375000e+02 -1.6613100051879883e+01 8.8467397689819336e+00 -3.4923400878906250e+02 -8.2668000459671021e-01 -2.6724599838256836e+01 -3.3992700195312500e+02 -6.5507400512695312e+01 1.3249699592590332e+01 -3.8431600952148438e+02 8.5418403625488281e+01 4.2375000000000000e+01 -3.1043600463867188e+02 8.5537002563476562e+01 5.6165599822998047e+00 -3.1174600219726562e+02 8.5785095214843750e+01 2.3696300506591797e+01 -3.1209100341796875e+02 8.7035400390625000e+01 4.3651099205017090e+00 -3.1320599365234375e+02 8.5742301940917969e+01 -2.2285598754882812e+01 -3.1231799316406250e+02 8.5530899047851562e+01 -8.0381500244140625e+01 -3.1167797851562500e+02 8.6778999328613281e+01 -7.0581504821777344e+01 -3.1315899658203125e+02 8.5602699279785156e+01 -4.8394798278808594e+01 -3.1224899291992188e+02 8.6382705688476562e+01 4.4818698883056641e+01 -3.1305300903320312e+02 8.8154800415039062e+01 -4.2401802062988281e+01 -3.1349398803710938e+02 8.8116302490234375e+01 -8.0431602478027344e+01 -3.1353500366210938e+02 8.8154701232910156e+01 2.7443399429321289e+01 -3.1349398803710938e+02 8.5699203491210938e+01 8.0692497253417969e+01 -3.1234298706054688e+02 9.0247100830078125e+01 2.0267499923706055e+01 -3.1365798950195312e+02 -6.0423500061035156e+01 -6.2190299987792969e+01 -3.9285498046875000e+02 -5.7090301513671875e+01 -9.6160301208496094e+01 -3.8620098876953125e+02 -5.6302200317382812e+01 -6.3396102905273438e+01 -3.8263897705078125e+02 -6.0833099365234375e+01 -9.6160202026367188e+01 -3.9599902343750000e+02 -5.0273899078369141e+01 -9.6160705566406250e+01 -3.7664099121093750e+02 -4.9689598083496094e+01 -6.4945495605468750e+01 -3.7405300903320312e+02 -6.2673599243164062e+01 -6.8445098876953125e+01 -4.1059802246093750e+02 -6.7229499816894531e+01 -4.9784400939941406e+01 -3.8818402099609375e+02 -8.1841697692871094e+01 -1.8520200729370117e+01 -3.9962301635742188e+02 -7.6996696472167969e+01 -2.7412399291992188e+01 -3.9401800537109375e+02 -7.7633399963378906e+01 -3.2264900207519531e+01 -3.9691098022460938e+02 -6.3187198638916016e+01 -5.0954799652099609e+01 -3.8354598999023438e+02 -6.5700302124023438e+01 -6.9860801696777344e+01 -4.3205700683593750e+02 1.1209700012207031e+02 8.3434700012207031e+01 -4.3797900390625000e+02 1.2642699432373047e+02 8.1528503417968750e+01 -4.2942300415039062e+02 1.4066099548339844e+02 8.1496398925781250e+01 -4.1375000000000000e+02 1.4625599670410156e+02 8.1483497619628906e+01 -4.0341299438476562e+02 9.2583801269531250e+01 8.1616294860839844e+01 -4.4603900146484375e+02 8.4949203491210938e+01 8.0735900878906250e+01 -4.4605801391601562e+02 8.7276397705078125e+01 8.0736396789550781e+01 -3.4981701660156250e+02 6.6352302551269531e+01 8.0402900695800781e+01 -4.4605801391601562e+02 5.4652500152587891e+01 8.0180694580078125e+01 -4.4605801391601562e+02 3.6334400177001953e+01 7.9841102600097656e+01 -4.4605801391601562e+02 2.5012201309204102e+01 7.9635002136230469e+01 -4.4605801391601562e+02 7.6143898963928223e+00 7.9328796386718750e+01 -4.4605801391601562e+02 7.6143898963928223e+00 9.6615600585937500e+01 -4.4605801391601562e+02 -3.8145401000976562e+01 9.6615600585937500e+01 -4.4605801391601562e+02 -5.0369197845458984e+01 9.6614097595214844e+01 -4.4605801391601562e+02 -5.5553298950195312e+01 8.6408699035644531e+01 -4.4605499267578125e+02 -8.4457504272460938e+01 3.1002099990844727e+01 -4.2271200561523438e+02 -7.5179000854492188e+01 4.3518302917480469e+01 -4.0516299438476562e+02 -8.5458801269531250e+01 4.2989997863769531e+01 -4.4605801391601562e+02 -9.2909500122070312e+01 1.5696199417114258e+01 -4.4605700683593750e+02 -7.0938598632812500e+01 5.9499099731445312e+01 -4.2232901000976562e+02 -7.2174598693847656e+01 6.6778694152832031e+01 -4.4605801391601562e+02 -9.3443801879882812e+01 -1.1339699745178223e+01 -4.4605801391601562e+02 1.1812700653076172e+02 6.0358497619628906e+01 -4.4129199218750000e+02 1.1454399871826172e+02 5.3515300750732422e+01 -4.4605999755859375e+02 1.5009500122070312e+02 7.7838798522949219e+01 -3.9748800659179688e+02 1.2352500152587891e+02 3.3198902130126953e+01 -4.4603698730468750e+02 1.2908099365234375e+02 2.8969099044799805e+01 -4.4149499511718750e+02 1.5170500183105469e+02 -7.9422202110290527e+00 -3.7729400634765625e+02 1.4813900756835938e+02 -8.1145301818847656e+01 -3.5940100097656250e+02 1.5060200500488281e+02 -8.0720603942871094e+01 -3.6899600219726562e+02 1.5125801086425781e+02 -8.1313903808593750e+01 -3.9011099243164062e+02 1.1449000549316406e+02 -8.1379898071289062e+01 -3.2050201416015625e+02 1.3473899841308594e+02 -8.0925399780273438e+01 -3.3622500610351562e+02 1.2350499725341797e+02 -8.1838699340820312e+01 -3.2605902099609375e+02 1.0555699920654297e+02 -7.9884002685546875e+01 -3.1668099975585938e+02 1.4261599731445312e+02 -8.1448898315429688e+01 -3.4733300781250000e+02 1.4860400390625000e+02 -7.5608497619628906e+01 -4.0257998657226562e+02 1.5171800231933594e+02 -7.9410598754882812e+01 -3.7955499267578125e+02 9.7235801696777344e+01 -8.1981399536132812e+01 -3.1449401855468750e+02 1.5053099060058594e+02 -8.2911697387695312e+01 -3.7905999755859375e+02 1.4674600219726562e+02 -8.4247100830078125e+01 -3.6471099853515625e+02 1.3425500488281250e+02 -8.4308799743652344e+01 -3.3864700317382812e+02 1.4812199401855469e+02 -8.4215797424316406e+01 -3.8991299438476562e+02 1.3042298889160156e+02 -8.3019706726074219e+01 -3.3302999877929688e+02 1.4527200317382812e+02 -8.4601402282714844e+01 -3.7161300659179688e+02 1.2521199798583984e+02 -8.4940002441406250e+01 -3.3481402587890625e+02 1.3717399597167969e+02 -8.4869400024414062e+01 -3.5118698120117188e+02 8.5609596252441406e+01 -3.6094699859619141e+01 -3.0340600585937500e+02 7.8555999755859375e+01 -8.0259193420410156e+01 -3.0555200195312500e+02 5.1805297851562500e+01 -3.8199699401855469e+01 -3.1125000000000000e+02 5.9568199157714844e+01 -7.9944000244140625e+01 -3.0966299438476562e+02 8.5566795349121094e+01 -8.0379302978515625e+01 -3.0539599609375000e+02 3.0284601211547852e+01 -5.1980300903320312e+01 -3.2290499877929688e+02 3.3323699951171875e+01 -7.9487396240234375e+01 -3.2270397949218750e+02 7.5996999740600586e+00 -7.9033897399902344e+01 -3.3726400756835938e+02 -2.8370800018310547e+01 -5.1604198455810547e+01 -3.5770898437500000e+02 -2.4918298721313477e+01 -9.6160202026367188e+01 -3.5804901123046875e+02 -5.1907302856445312e+01 -3.2991497039794922e+01 -3.7405401611328125e+02 7.6143603324890137e+00 -9.6160301208496094e+01 -3.3860702514648438e+02 1.1322399902343750e+02 -8.3154205322265625e+01 -4.3738601684570312e+02 8.5131599426269531e+01 -8.4390197753906250e+01 -4.4582901000976562e+02 9.1721900939941406e+01 -8.1909698486328125e+01 -4.4599499511718750e+02 1.3260200500488281e+02 -8.2317901611328125e+01 -4.2353399658203125e+02 1.2162500000000000e+02 -8.1740104675292969e+01 -4.3292401123046875e+02 1.4381300354003906e+02 -8.1442100524902344e+01 -4.0854998779296875e+02 1.4140600585937500e+02 -8.3896194458007812e+01 -4.0911199951171875e+02 1.2856599426269531e+02 -8.5541397094726562e+01 -4.2108200073242188e+02 1.4361000061035156e+02 -8.5138099670410156e+01 -3.9123898315429688e+02 1.1768999481201172e+02 -8.5680000305175781e+01 -4.3070700073242188e+02 9.9875701904296875e+01 -8.6723602294921875e+01 -4.3847998046875000e+02 1.3676998901367188e+02 -8.5404701232910156e+01 -4.0942800903320312e+02 7.6143898963928223e+00 -7.9034202575683594e+01 -4.4605801391601562e+02 7.6143898963928223e+00 -9.6160301208496094e+01 -3.7744299316406250e+02 7.6143898963928223e+00 -9.6160301208496094e+01 -4.4605801391601562e+02 -5.0286098480224609e+01 -9.6156097412109375e+01 -4.4606097412109375e+02 -5.7990398406982422e+01 -8.2868301391601562e+01 -4.4603402709960938e+02 -8.6850395202636719e+01 -2.0039400100708008e+01 -4.2163198852539062e+02 -7.6853500366210938e+01 -4.5735298156738281e+01 -4.1545999145507812e+02 -8.8616699218750000e+01 -3.4339199066162109e+01 -4.4605700683593750e+02 -8.0837699890136719e+01 -5.2439601898193359e+01 -4.4605700683593750e+02 -7.2366600036621094e+01 -6.6274002075195312e+01 -4.4605899047851562e+02 -6.8361106872558594e+01 -5.6799900054931641e+01 -4.0721499633789062e+02 1.2531200408935547e+02 -6.2176601409912109e+01 -4.3557299804687500e+02 1.0470999908447266e+02 -6.7282295227050781e+01 -4.4605801391601562e+02 1.1650199890136719e+02 -4.9801403045654297e+01 -4.4606201171875000e+02 1.2596499633789062e+02 -2.4035598754882812e+01 -4.4602798461914062e+02 1.1405899810791016e+02 -8.7058700561523438e+01 -3.3059899902343750e+02 1.3097900390625000e+02 -8.6617095947265625e+01 -3.4594500732421875e+02 1.0294499969482422e+02 -8.5724998474121094e+01 -3.2310400390625000e+02 1.0074300384521484e+02 -8.8167503356933594e+01 -3.2554000854492188e+02 1.2216600036621094e+02 -8.7759193420410156e+01 -3.3717797851562500e+02 8.7932998657226562e+01 -8.8281402587890625e+01 -3.2306997680664062e+02 8.7985595703125000e+01 -8.5811302185058594e+01 -3.2052902221679688e+02 8.7949401855468750e+01 -9.1054603576660156e+01 -3.2350799560546875e+02 1.0768699645996094e+02 -9.1059898376464844e+01 -3.2839300537109375e+02 1.3627700805664062e+02 -8.8049705505371094e+01 -3.5635098266601562e+02 1.4153399658203125e+02 -8.6360404968261719e+01 -3.6951397705078125e+02 1.4280400085449219e+02 -8.6332702636718750e+01 -3.8170901489257812e+02 1.4140299987792969e+02 -8.7825599670410156e+01 -3.8973901367187500e+02 1.3841000366210938e+02 -9.1056999206542969e+01 -3.6199899291992188e+02 1.2692399597167969e+02 -9.1059104919433594e+01 -3.4227499389648438e+02 1.4162998962402344e+02 -9.1060699462890625e+01 -3.7696600341796875e+02 1.0747399902343750e+02 -8.4932098388671875e+01 -3.2025598144531250e+02 1.3967298889160156e+02 -8.6879402160644531e+01 -4.0007901000976562e+02 1.3025599670410156e+02 -9.1063400268554688e+01 -4.1686199951171875e+02 9.9705101013183594e+01 -9.1042198181152344e+01 -4.3776300048828125e+02 8.5100601196289062e+01 -9.1049903869628906e+01 -4.3991400146484375e+02 8.5075996398925781e+01 -8.6576202392578125e+01 -4.4115600585937500e+02 1.1889299774169922e+02 -9.1035697937011719e+01 -4.2864801025390625e+02 1.3886900329589844e+02 -9.1059997558593750e+01 -4.0087301635742188e+02 8.8139801025390625e+01 -8.4328498840332031e+01 -3.1489300537109375e+02 4.7653499603271484e+01 -7.9746498107910156e+01 -4.4605801391601562e+02 8.7193901062011719e+01 -8.0428298950195312e+01 -3.5322601318359375e+02 8.3406700134277344e+01 -8.0384597778320312e+01 -3.9908001708984375e+02 8.4949005126953125e+01 -8.0428199768066406e+01 -4.4605801391601562e+02 4.1841499328613281e+01 5.4387001037597656e+01 -4.4605801391601562e+02 2.2425298690795898e+01 7.0664001464843750e+01 -4.4605801391601562e+02 8.6455398559570312e+01 -9.1064697265625000e+01 -3.8376300048828125e+02 -4.9783401489257812e+01 1.5523100280761719e+02 -4.4513299560546875e+02 -5.3269302368164062e+01 1.5741999816894531e+02 -4.4149499511718750e+02 -4.6481597900390625e+01 1.5684600830078125e+02 -4.4434698486328125e+02 -6.1934600830078125e+01 1.5627999877929688e+02 -4.3492300415039062e+02 -6.3710102081298828e+01 1.5689500427246094e+02 -4.2388400268554688e+02 1.3279199218750000e+02 1.5939299011230469e+02 -4.0391299438476562e+02 1.3101800537109375e+02 1.5757499694824219e+02 -4.3767398071289062e+02 1.0606300354003906e+02 1.5964799499511719e+02 -4.1435302734375000e+02 1.2073600006103516e+02 1.5733900451660156e+02 -4.4391998291015625e+02 9.9334999084472656e+01 1.6060798645019531e+02 -3.7641799926757812e+02 1.1737400054931641e+02 1.5416600036621094e+02 -4.4552697753906250e+02 8.3717002868652344e+01 1.5686500549316406e+02 -4.4456100463867188e+02 8.3249595642089844e+01 1.5477000427246094e+02 -4.4546197509765625e+02 -3.6879302978515625e+01 1.5872900390625000e+02 -4.0036999511718750e+02 -6.0633598327636719e+01 1.5715699768066406e+02 -3.9278500366210938e+02 4.3068499565124512e+00 1.5484500122070312e+02 -4.4548898315429688e+02 -1.9540599822998047e+01 1.4600199890136719e+02 -4.4679800415039062e+02 -3.6523299217224121e+00 1.5569799804687500e+02 -4.4527700805664062e+02 -2.6404699325561523e+01 1.5569500732421875e+02 -4.4529797363281250e+02 -1.6556400299072266e+01 1.5658999633789062e+02 -4.4468798828125000e+02 -3.2583401203155518e+00 1.5721099853515625e+02 -4.4378298950195312e+02 1.7123500823974609e+01 1.5659700012207031e+02 -4.4461798095703125e+02 -2.8412900924682617e+01 1.5719599914550781e+02 -4.4377200317382812e+02 -2.1333999633789062e+01 1.5745700073242188e+02 -4.4279501342773438e+02 2.0716199874877930e+01 1.5570100402832031e+02 -4.4521600341796875e+02 2.6268299102783203e+01 1.5480400085449219e+02 -4.4544299316406250e+02 2.9589399337768555e+01 1.5722300720214844e+02 -4.4371798706054688e+02 3.4506298065185547e+01 1.5659899902343750e+02 -4.4459899902343750e+02 3.9733303070068359e+01 1.5551799011230469e+02 -4.4529501342773438e+02 5.4930500030517578e+01 1.5736299133300781e+02 -4.4341201782226562e+02 5.4802898406982422e+01 1.5661599731445312e+02 -4.4458300781250000e+02 4.2312900543212891e+01 1.5748699951171875e+02 -4.4273901367187500e+02 1.3584399223327637e+01 1.5748300170898438e+02 -4.4276699829101562e+02 -5.2668498992919922e+01 1.5709799194335938e+02 -3.7883898925781250e+02 -6.4561302185058594e+01 1.3887399291992188e+02 -4.3099902343750000e+02 -6.5467796325683594e+01 1.4117799377441406e+02 -4.2280300903320312e+02 -5.2564300537109375e+01 1.3086900329589844e+02 -4.4476101684570312e+02 -5.9387199401855469e+01 1.2952099609375000e+02 -4.4001498413085938e+02 -4.7494800567626953e+01 1.2822599792480469e+02 -4.4668499755859375e+02 2.8751199722290039e+01 1.3772100830078125e+02 -4.4663500976562500e+02 -2.4711599349975586e+01 1.0465099334716797e+02 -4.4644400024414062e+02 7.1133705139160156e+01 1.5547000122070312e+02 -4.4532901000976562e+02 1.1843000030517578e+02 1.2615600585937500e+02 -4.4677297973632812e+02 1.2880699157714844e+02 1.5479399108886719e+02 -4.4169000244140625e+02 1.5783999633789062e+02 1.5738800048828125e+02 -3.8325198364257812e+02 1.5390699768066406e+02 1.5693501281738281e+02 -4.0863299560546875e+02 7.5399505615234375e+01 1.6041099548339844e+02 -3.5229901123046875e+02 1.2326300048828125e+02 1.5952398681640625e+02 -3.4849700927734375e+02 8.9091896057128906e+01 1.5766699218750000e+02 -3.0938299560546875e+02 1.5387699890136719e+02 1.5698699951171875e+02 -3.5510699462890625e+02 1.3980300903320312e+02 1.5753099060058594e+02 -3.3426300048828125e+02 1.1907800292968750e+02 1.5696200561523438e+02 -3.1627801513671875e+02 7.3452003479003906e+01 1.5734199523925781e+02 -4.4346899414062500e+02 1.7650001525878906e+01 1.5942799377441406e+02 -3.5876101684570312e+02 2.6682800292968750e+01 1.5681700134277344e+02 -3.2793899536132812e+02 2.2446599960327148e+01 1.5977600097656250e+02 -4.1260400390625000e+02 -8.4659099578857422e+00 1.5724900817871094e+02 -3.4848498535156250e+02 6.0932598114013672e+01 1.5671699523925781e+02 -3.1152600097656250e+02 -6.2729202270507812e+01 1.3905000305175781e+02 -3.9393801879882812e+02 -6.5567398071289062e+01 1.1427799987792969e+02 -4.2386001586914062e+02 -6.3419105529785156e+01 9.7959899902343750e+01 -4.3183300781250000e+02 -5.5024200439453125e+01 9.9487899780273438e+01 -4.4241397094726562e+02 -4.6965999603271484e+01 9.7739395141601562e+01 -4.4471499633789062e+02 3.9728298187255859e+01 1.0160499572753906e+02 -4.4571600341796875e+02 9.0032196044921875e+01 1.0373600006103516e+02 -4.4595101928710938e+02 -7.5055098533630371e+00 9.7546195983886719e+01 -4.4461898803710938e+02 6.5139099121093750e+01 9.7620498657226562e+01 -4.4479800415039062e+02 1.1920400238037109e+02 9.8995605468750000e+01 -4.4518899536132812e+02 1.3057800292968750e+02 1.1804299926757812e+02 -4.4167300415039062e+02 1.4970100402832031e+02 1.5568600463867188e+02 -4.1819000244140625e+02 1.4131199645996094e+02 1.5564500427246094e+02 -4.3015499877929688e+02 1.5878900146484375e+02 1.5507400512695312e+02 -3.9054501342773438e+02 1.5820599365234375e+02 1.5507299804687500e+02 -3.6952798461914062e+02 1.4813800048828125e+02 1.5509199523925781e+02 -3.4226098632812500e+02 1.3260400390625000e+02 1.5542698669433594e+02 -3.2480200195312500e+02 1.0497900390625000e+02 1.5569200134277344e+02 -3.1002102661132812e+02 7.8890396118164062e+01 1.5600100708007812e+02 -3.0739199829101562e+02 -3.4469501495361328e+01 1.5606599426269531e+02 -3.6462899780273438e+02 -5.7898998260498047e+01 1.3747599792480469e+02 -3.8334399414062500e+02 -5.2212997436523438e+01 1.2690000152587891e+02 -3.7576498413085938e+02 -6.1975299835205078e+01 9.9264701843261719e+01 -3.9491702270507812e+02 -5.7255500793457031e+01 9.7253501892089844e+01 -3.8731301879882812e+02 -5.6867202758789062e+01 9.9171104431152344e+01 -3.8348699951171875e+02 -4.6854999542236328e+01 9.8274002075195312e+01 -3.7361599731445312e+02 -5.8838901519775391e+01 9.7252693176269531e+01 -4.3696902465820312e+02 8.1205596923828125e+01 9.8930900573730469e+01 -4.4519497680664062e+02 1.1540399932861328e+02 9.7301994323730469e+01 -4.4320300292968750e+02 8.1405998229980469e+01 9.7783203125000000e+01 -4.4426501464843750e+02 1.0201399993896484e+02 9.8018402099609375e+01 -4.4451498413085938e+02 2.1232700347900391e+01 9.7262397766113281e+01 -4.4385498046875000e+02 8.1493499755859375e+01 9.7249900817871094e+01 -4.4250100708007812e+02 1.2833799743652344e+02 9.7255699157714844e+01 -4.3950799560546875e+02 1.3405500793457031e+02 9.9857597351074219e+01 -4.3782202148437500e+02 1.2517500305175781e+02 1.2736499023437500e+02 -3.1817098999023438e+02 1.3893400573730469e+02 1.3164399719238281e+02 -3.2958599853515625e+02 1.1113700103759766e+02 1.2727799987792969e+02 -3.1105899047851562e+02 9.7927803039550781e+01 1.3575500488281250e+02 -3.0723800659179688e+02 8.2783996582031250e+01 1.1890900421142578e+02 -3.0596499633789062e+02 1.5622000122070312e+02 1.2716899871826172e+02 -3.5809899902343750e+02 1.6022099304199219e+02 1.3521699523925781e+02 -3.7581198120117188e+02 1.5863198852539062e+02 1.2722100067138672e+02 -4.0002999877929688e+02 1.5106298828125000e+02 1.2725399780273438e+02 -4.1877099609375000e+02 1.4141400146484375e+02 1.2725600433349609e+02 -4.3207998657226562e+02 9.5278999328613281e+01 1.0037899780273438e+02 -3.0765798950195312e+02 3.7539402008056641e+01 1.3917900085449219e+02 -3.2069702148437500e+02 6.1435100555419922e+01 1.3290600585937500e+02 -3.0946697998046875e+02 -1.0488700866699219e+00 1.3974200439453125e+02 -3.4128100585937500e+02 -2.5332401275634766e+01 1.1903300476074219e+02 -3.5635501098632812e+02 -1.5934700012207031e+01 9.7667800903320312e+01 -3.5278399658203125e+02 6.0455299377441406e+01 9.7351097106933594e+01 -3.1260498046875000e+02 4.0524597167968750e+01 9.9890098571777344e+01 -3.2028799438476562e+02 9.1365104913711548e-01 9.7300796508789062e+01 -3.4281600952148438e+02 2.1138900756835938e+01 1.0595999908447266e+02 -3.2957000732421875e+02 6.0001399993896484e+01 9.9163299560546875e+01 -3.1145098876953125e+02 1.5737100219726562e+02 9.7456901550292969e+01 -3.9694400024414062e+02 1.5628599548339844e+02 9.7252799987792969e+01 -3.6766497802734375e+02 1.4311399841308594e+02 9.7311103820800781e+01 -3.3760397338867188e+02 9.4675300598144531e+01 9.7254699707031250e+01 -3.0972799682617188e+02 1.2019699859619141e+02 9.7305999755859375e+01 -3.1822100830078125e+02 7.7175201416015625e+01 9.9306205749511719e+01 -3.0749099731445312e+02 1.5935699462890625e+02 9.9361503601074219e+01 -3.8027798461914062e+02 1.5260900878906250e+02 9.9044303894042969e+01 -4.1266799926757812e+02 1.4436399841308594e+02 9.8271400451660156e+01 -4.2591598510742188e+02 1.1541199493408203e+02 9.9218399047851562e+01 -3.1372201538085938e+02 1.3567001342773438e+02 9.9058303833007812e+01 -3.2759197998046875e+02 1.4886300659179688e+02 9.9349998474121094e+01 -3.4349099731445312e+02 1.5745300292968750e+02 1.0011299896240234e+02 -3.6494400024414062e+02 -4.6481597900390625e+01 -1.5684600830078125e+02 -4.4434698486328125e+02 -5.3269302368164062e+01 -1.5741999816894531e+02 -4.4149499511718750e+02 -4.9783401489257812e+01 -1.5523100280761719e+02 -4.4513299560546875e+02 -6.1934600830078125e+01 -1.5627999877929688e+02 -4.3492300415039062e+02 -6.3710102081298828e+01 -1.5689500427246094e+02 -4.2388400268554688e+02 1.0606300354003906e+02 -1.5964799499511719e+02 -4.1435302734375000e+02 1.3101800537109375e+02 -1.5757499694824219e+02 -4.3767398071289062e+02 1.3279199218750000e+02 -1.5939299011230469e+02 -4.0391299438476562e+02 1.2073600006103516e+02 -1.5733900451660156e+02 -4.4391998291015625e+02 9.9334999084472656e+01 -1.6060798645019531e+02 -3.7641799926757812e+02 8.3717002868652344e+01 -1.5686500549316406e+02 -4.4456100463867188e+02 1.1737400054931641e+02 -1.5416600036621094e+02 -4.4552697753906250e+02 8.3249595642089844e+01 -1.5477000427246094e+02 -4.4546197509765625e+02 -3.6879302978515625e+01 -1.5872900390625000e+02 -4.0036999511718750e+02 -6.0633598327636719e+01 -1.5715699768066406e+02 -3.9278500366210938e+02 -3.6523299217224121e+00 -1.5569799804687500e+02 -4.4527700805664062e+02 -1.9540599822998047e+01 -1.4600199890136719e+02 -4.4679800415039062e+02 4.3068499565124512e+00 -1.5484500122070312e+02 -4.4548898315429688e+02 -2.6404699325561523e+01 -1.5569500732421875e+02 -4.4529797363281250e+02 -1.6556400299072266e+01 -1.5658999633789062e+02 -4.4468798828125000e+02 1.7123500823974609e+01 -1.5659700012207031e+02 -4.4461798095703125e+02 -3.2583401203155518e+00 -1.5721099853515625e+02 -4.4378298950195312e+02 -2.8412900924682617e+01 -1.5719599914550781e+02 -4.4377200317382812e+02 -2.1333999633789062e+01 -1.5745700073242188e+02 -4.4279501342773438e+02 2.0716199874877930e+01 -1.5570100402832031e+02 -4.4521600341796875e+02 2.6268299102783203e+01 -1.5480400085449219e+02 -4.4544299316406250e+02 3.4506298065185547e+01 -1.5659899902343750e+02 -4.4459899902343750e+02 2.9589399337768555e+01 -1.5722300720214844e+02 -4.4371798706054688e+02 3.9733303070068359e+01 -1.5551799011230469e+02 -4.4529501342773438e+02 5.4802898406982422e+01 -1.5661599731445312e+02 -4.4458300781250000e+02 5.4930500030517578e+01 -1.5736299133300781e+02 -4.4341201782226562e+02 4.2312900543212891e+01 -1.5748699951171875e+02 -4.4273901367187500e+02 1.3584399223327637e+01 -1.5748300170898438e+02 -4.4276699829101562e+02 -5.2668498992919922e+01 -1.5709799194335938e+02 -3.7883898925781250e+02 -6.5467796325683594e+01 -1.4117799377441406e+02 -4.2280300903320312e+02 -6.4561302185058594e+01 -1.3887399291992188e+02 -4.3099902343750000e+02 -5.9387199401855469e+01 -1.2952099609375000e+02 -4.4001498413085938e+02 -5.2564300537109375e+01 -1.3086900329589844e+02 -4.4476101684570312e+02 -4.7494800567626953e+01 -1.2822599792480469e+02 -4.4668499755859375e+02 2.8751199722290039e+01 -1.3772100830078125e+02 -4.4663500976562500e+02 -2.4711599349975586e+01 -1.0465099334716797e+02 -4.4644400024414062e+02 7.1133705139160156e+01 -1.5547000122070312e+02 -4.4532901000976562e+02 1.1843000030517578e+02 -1.2615600585937500e+02 -4.4677297973632812e+02 1.2880699157714844e+02 -1.5479399108886719e+02 -4.4169000244140625e+02 1.5390699768066406e+02 -1.5693501281738281e+02 -4.0863299560546875e+02 1.5783999633789062e+02 -1.5738800048828125e+02 -3.8325198364257812e+02 1.2326300048828125e+02 -1.5952398681640625e+02 -3.4849700927734375e+02 7.5399505615234375e+01 -1.6041099548339844e+02 -3.5229901123046875e+02 8.9091896057128906e+01 -1.5766699218750000e+02 -3.0938299560546875e+02 1.5387699890136719e+02 -1.5698699951171875e+02 -3.5510699462890625e+02 1.3980300903320312e+02 -1.5753099060058594e+02 -3.3426300048828125e+02 1.1907800292968750e+02 -1.5696200561523438e+02 -3.1627801513671875e+02 7.3452003479003906e+01 -1.5734199523925781e+02 -4.4346899414062500e+02 1.7650001525878906e+01 -1.5942799377441406e+02 -3.5876101684570312e+02 2.6682800292968750e+01 -1.5681700134277344e+02 -3.2793899536132812e+02 2.2446599960327148e+01 -1.5977600097656250e+02 -4.1260400390625000e+02 -8.4659099578857422e+00 -1.5724900817871094e+02 -3.4848498535156250e+02 6.0932598114013672e+01 -1.5671699523925781e+02 -3.1152600097656250e+02 -6.2729202270507812e+01 -1.3905000305175781e+02 -3.9393801879882812e+02 -6.5567398071289062e+01 -1.1427799987792969e+02 -4.2386001586914062e+02 -6.3419105529785156e+01 -9.7959899902343750e+01 -4.3183300781250000e+02 -5.5024200439453125e+01 -9.9487899780273438e+01 -4.4241397094726562e+02 -4.6965999603271484e+01 -9.7739395141601562e+01 -4.4471499633789062e+02 3.9728298187255859e+01 -1.0160499572753906e+02 -4.4571600341796875e+02 9.0032196044921875e+01 -1.0373600006103516e+02 -4.4595101928710938e+02 -7.5055098533630371e+00 -9.7546195983886719e+01 -4.4461898803710938e+02 6.5139099121093750e+01 -9.7620498657226562e+01 -4.4479800415039062e+02 1.1920400238037109e+02 -9.8995605468750000e+01 -4.4518899536132812e+02 1.3057800292968750e+02 -1.1804299926757812e+02 -4.4167300415039062e+02 1.4131199645996094e+02 -1.5564500427246094e+02 -4.3015499877929688e+02 1.4970100402832031e+02 -1.5568600463867188e+02 -4.1819000244140625e+02 1.5878900146484375e+02 -1.5507400512695312e+02 -3.9054501342773438e+02 1.5820599365234375e+02 -1.5507299804687500e+02 -3.6952798461914062e+02 1.4813800048828125e+02 -1.5509199523925781e+02 -3.4226098632812500e+02 1.3260400390625000e+02 -1.5542698669433594e+02 -3.2480200195312500e+02 1.0497900390625000e+02 -1.5569200134277344e+02 -3.1002102661132812e+02 7.8890396118164062e+01 -1.5600100708007812e+02 -3.0739199829101562e+02 -3.4469501495361328e+01 -1.5606599426269531e+02 -3.6462899780273438e+02 -5.7898998260498047e+01 -1.3747599792480469e+02 -3.8334399414062500e+02 -5.2212997436523438e+01 -1.2690000152587891e+02 -3.7576498413085938e+02 -6.1975299835205078e+01 -9.9264701843261719e+01 -3.9491702270507812e+02 -5.6867202758789062e+01 -9.9171104431152344e+01 -3.8348699951171875e+02 -5.7255500793457031e+01 -9.7253501892089844e+01 -3.8731301879882812e+02 -4.6854999542236328e+01 -9.8274002075195312e+01 -3.7361599731445312e+02 -5.8838901519775391e+01 -9.7252693176269531e+01 -4.3696902465820312e+02 8.1205596923828125e+01 -9.8930900573730469e+01 -4.4519497680664062e+02 1.0201399993896484e+02 -9.8018402099609375e+01 -4.4451498413085938e+02 8.1405998229980469e+01 -9.7783203125000000e+01 -4.4426501464843750e+02 1.1540399932861328e+02 -9.7301994323730469e+01 -4.4320300292968750e+02 2.1232700347900391e+01 -9.7262397766113281e+01 -4.4385498046875000e+02 8.1493499755859375e+01 -9.7249900817871094e+01 -4.4250100708007812e+02 1.2833799743652344e+02 -9.7255699157714844e+01 -4.3950799560546875e+02 1.3405500793457031e+02 -9.9857597351074219e+01 -4.3782202148437500e+02 1.3893400573730469e+02 -1.3164399719238281e+02 -3.2958599853515625e+02 1.2517500305175781e+02 -1.2736499023437500e+02 -3.1817098999023438e+02 1.1113700103759766e+02 -1.2727799987792969e+02 -3.1105899047851562e+02 9.7927803039550781e+01 -1.3575500488281250e+02 -3.0723800659179688e+02 8.2783996582031250e+01 -1.1890900421142578e+02 -3.0596499633789062e+02 1.5622000122070312e+02 -1.2716899871826172e+02 -3.5809899902343750e+02 1.5863198852539062e+02 -1.2722100067138672e+02 -4.0002999877929688e+02 1.6022099304199219e+02 -1.3521699523925781e+02 -3.7581198120117188e+02 1.5106298828125000e+02 -1.2725399780273438e+02 -4.1877099609375000e+02 1.4141400146484375e+02 -1.2725600433349609e+02 -4.3207998657226562e+02 9.5278999328613281e+01 -1.0037899780273438e+02 -3.0765798950195312e+02 6.1435100555419922e+01 -1.3290600585937500e+02 -3.0946697998046875e+02 3.7539402008056641e+01 -1.3917900085449219e+02 -3.2069702148437500e+02 -1.0488700866699219e+00 -1.3974200439453125e+02 -3.4128100585937500e+02 -2.5332401275634766e+01 -1.1903300476074219e+02 -3.5635501098632812e+02 -1.5934700012207031e+01 -9.7667800903320312e+01 -3.5278399658203125e+02 9.1365104913711548e-01 -9.7300796508789062e+01 -3.4281600952148438e+02 4.0524597167968750e+01 -9.9890098571777344e+01 -3.2028799438476562e+02 6.0455299377441406e+01 -9.7351097106933594e+01 -3.1260498046875000e+02 2.1138900756835938e+01 -1.0595999908447266e+02 -3.2957000732421875e+02 6.0001399993896484e+01 -9.9163299560546875e+01 -3.1145098876953125e+02 1.5628599548339844e+02 -9.7252799987792969e+01 -3.6766497802734375e+02 1.5737100219726562e+02 -9.7456901550292969e+01 -3.9694400024414062e+02 9.4675300598144531e+01 -9.7254699707031250e+01 -3.0972799682617188e+02 1.4311399841308594e+02 -9.7311103820800781e+01 -3.3760397338867188e+02 1.2019699859619141e+02 -9.7305999755859375e+01 -3.1822100830078125e+02 7.7175201416015625e+01 -9.9306205749511719e+01 -3.0749099731445312e+02 1.5935699462890625e+02 -9.9361503601074219e+01 -3.8027798461914062e+02 1.4436399841308594e+02 -9.8271400451660156e+01 -4.2591598510742188e+02 1.5260900878906250e+02 -9.9044303894042969e+01 -4.1266799926757812e+02 1.1541199493408203e+02 -9.9218399047851562e+01 -3.1372201538085938e+02 1.3567001342773438e+02 -9.9058303833007812e+01 -3.2759197998046875e+02 1.4886300659179688e+02 -9.9349998474121094e+01 -3.4349099731445312e+02 1.5745300292968750e+02 -1.0011299896240234e+02 -3.6494400024414062e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 47 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02) (float-vector -6.0633599758148193e+01 -1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -9.3443803489208221e+01 -1.1339699849486351e+01 -4.4605800509452820e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.8890398144721985e+01 1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 1.0497900098562241e+02 1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 8.5615396499633789e+01 2.8354899957776070e+01 -3.0314800143241882e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1934601515531540e+01 -1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -4.9783401191234589e+01 -1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector -9.3443803489208221e+01 -1.1339699849486351e+01 -4.4605800509452820e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1934601515531540e+01 -1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -9.3443803489208221e+01 -1.1339699849486351e+01 -4.4605800509452820e+02) (float-vector -6.0633599758148193e+01 -1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -6.3710100948810577e+01 -1.5689499676227570e+02 -4.2388400435447693e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2668500691652298e+01 -1.5709799528121948e+02 -3.7883898615837097e+02) (float-vector -6.0633599758148193e+01 -1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5458800196647644e+01 4.2989999055862427e+01 -4.4605800509452820e+02) (float-vector -6.1934601515531540e+01 1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -6.3710100948810577e+01 1.5689499676227570e+02 -4.2388400435447693e+02) (float-vector -9.2909500002861023e+01 1.5696199610829353e+01 -4.4605699181556702e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5387700498104095e+02 1.5698699653148651e+02 -3.5510700941085815e+02) (float-vector 1.5783999860286713e+02 1.5738800168037415e+02 -3.8325199484825134e+02) (float-vector 1.6022099554538727e+02 1.3521699607372284e+02 -3.7581199407577515e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6682799682021141e+01 1.5681700408458710e+02 -3.2793900370597839e+02) (float-vector -1.0488700354471803e+00 1.3974200189113617e+02 -3.4128099679946899e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0488700354471803e+00 1.3974200189113617e+02 -3.4128099679946899e+02) (float-vector -4.7462198883295059e+01 2.2165300324559212e+01 -3.7044799327850342e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7462198883295059e+01 2.2165300324559212e+01 -3.7044799327850342e+02) (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2668500691652298e+01 -1.5709799528121948e+02 -3.7883898615837097e+02) (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02) (float-vector -4.7462198883295059e+01 2.2165300324559212e+01 -3.7044799327850342e+02) (float-vector -3.4469500184059143e+01 -1.5606600046157837e+02 -3.6462900042533875e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9783401191234589e+01 1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector -6.1934601515531540e+01 1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -8.5458800196647644e+01 4.2989999055862427e+01 -4.4605800509452820e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02) (float-vector -6.0633599758148193e+01 1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0633599758148193e+01 1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -9.2909500002861023e+01 1.5696199610829353e+01 -4.4605699181556702e+02) (float-vector -6.3710100948810577e+01 1.5689499676227570e+02 -4.2388400435447693e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2909500002861023e+01 1.5696199610829353e+01 -4.4605699181556702e+02) (float-vector -6.0633599758148193e+01 1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -8.3326801657676697e+01 -5.9685599990189075e+00 -3.9946299791336060e+02) (float-vector -9.3443803489208221e+01 -1.1339699849486351e+01 -4.4605800509452820e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2073600292205811e+02 -1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector -4.9783401191234589e+01 -1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector -6.1934601515531540e+01 -1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -6.3710100948810577e+01 -1.5689499676227570e+02 -4.2388400435447693e+02) (float-vector 9.9334999918937683e+01 -1.6060799360275269e+02 -3.7641799449920654e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2326300144195557e+02 -1.5952399373054504e+02 -3.4849700331687927e+02) (float-vector 1.5390700101852417e+02 -1.5693500638008118e+02 -4.0863299369812012e+02) (float-vector 1.4131200313568115e+02 -1.5564499795436859e+02 -4.3015500903129578e+02) (float-vector 1.2073600292205811e+02 -1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector 9.9334999918937683e+01 -1.6060799360275269e+02 -3.7641799449920654e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5622000396251678e+02 -1.2716899812221527e+02 -3.5809901356697083e+02) (float-vector 1.5820600092411041e+02 -1.5507300198078156e+02 -3.6952799558639526e+02) (float-vector 1.4813800156116486e+02 -1.5509200096130371e+02 -3.4226098656654358e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6022099554538727e+02 1.3521699607372284e+02 -3.7581199407577515e+02) (float-vector 1.5820600092411041e+02 -1.5507300198078156e+02 -3.6952799558639526e+02) (float-vector 1.5622000396251678e+02 -1.2716899812221527e+02 -3.5809901356697083e+02) (float-vector 1.5387700498104095e+02 1.5698699653148651e+02 -3.5510700941085815e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5390700101852417e+02 -1.5693500638008118e+02 -4.0863299369812012e+02) (float-vector 1.2326300144195557e+02 -1.5952399373054504e+02 -3.4849700331687927e+02) (float-vector 1.1907800287008286e+02 -1.5696200728416443e+02 -3.1627801060676575e+02) (float-vector 1.4813800156116486e+02 -1.5509200096130371e+02 -3.4226098656654358e+02) (float-vector 1.5820600092411041e+02 -1.5507300198078156e+02 -3.6952799558639526e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2517499923706055e+02 1.2736499309539795e+02 -3.1817099452018738e+02) (float-vector 1.0497900098562241e+02 1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 1.3260400295257568e+02 1.5542699396610260e+02 -3.2480201125144958e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2073600292205811e+02 1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector 1.2798100709915161e+02 -5.1003000698983669e+00 -4.4605800509452820e+02) (float-vector 1.2880699336528778e+02 1.5479399263858795e+02 -4.4168999791145325e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0497900098562241e+02 1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 7.8890398144721985e+01 1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 7.5399503111839294e+01 1.6041100025177002e+02 -3.5229900479316711e+02) (float-vector 1.5387700498104095e+02 1.5698699653148651e+02 -3.5510700941085815e+02) (float-vector 1.3260400295257568e+02 1.5542699396610260e+02 -3.2480201125144958e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5399503111839294e+01 1.6041100025177002e+02 -3.5229900479316711e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02) (float-vector -6.0633599758148193e+01 1.5715700387954712e+02 -3.9278501272201538e+02) (float-vector -6.3710100948810577e+01 1.5689499676227570e+02 -4.2388400435447693e+02) (float-vector -6.1934601515531540e+01 1.5627999603748322e+02 -4.3492299318313599e+02) (float-vector -4.9783401191234589e+01 1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector 1.2073600292205811e+02 1.5733900666236877e+02 -4.4391998648643494e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6682799682021141e+01 1.5681700408458710e+02 -3.2793900370597839e+02) (float-vector 6.0932599008083344e+01 1.5671700239181519e+02 -3.1152600049972534e+02) (float-vector 5.5645499378442764e+01 3.0338000506162643e+00 -3.0903100967407227e+02) (float-vector 2.8052400797605515e+01 6.9486995926126838e-02 -3.2314598560333252e+02) (float-vector -1.0488700354471803e+00 1.3974200189113617e+02 -3.4128099679946899e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.8890398144721985e+01 1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 6.0932599008083344e+01 1.5671700239181519e+02 -3.1152600049972534e+02) (float-vector 2.6682799682021141e+01 1.5681700408458710e+02 -3.2793900370597839e+02) (float-vector -5.2668500691652298e+01 1.5709799528121948e+02 -3.7883898615837097e+02) (float-vector 7.5399503111839294e+01 1.6041100025177002e+02 -3.5229900479316711e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8668797612190247e+01 -3.2503701746463776e+01 -3.0519399046897888e+02) (float-vector 5.5645499378442764e+01 3.0338000506162643e+00 -3.0903100967407227e+02) (float-vector 6.0932599008083344e+01 1.5671700239181519e+02 -3.1152600049972534e+02) (float-vector 7.8890398144721985e+01 1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 8.5615396499633789e+01 2.8354899957776070e+01 -3.0314800143241882e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8052400797605515e+01 6.9486995926126838e-02 -3.2314598560333252e+02) (float-vector 3.7539400160312653e+01 -1.3917900621891022e+02 -3.2069700956344604e+02) (float-vector 2.6682799682021141e+01 -1.5681700408458710e+02 -3.2793900370597839e+02) (float-vector -3.4469500184059143e+01 -1.5606600046157837e+02 -3.6462900042533875e+02) (float-vector -4.7462198883295059e+01 2.2165300324559212e+01 -3.7044799327850342e+02) (float-vector -1.0488700354471803e+00 1.3974200189113617e+02 -3.4128099679946899e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5106299519538879e+02 1.2725399434566498e+02 -4.1877099871635437e+02) (float-vector 1.4970099925994873e+02 1.5568600594997406e+02 -4.1819000244140625e+02) (float-vector 1.2880699336528778e+02 1.5479399263858795e+02 -4.4168999791145325e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2073600292205811e+02 1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector 1.2880699336528778e+02 1.5479399263858795e+02 -4.4168999791145325e+02) (float-vector 1.4970099925994873e+02 1.5568600594997406e+02 -4.1819000244140625e+02) (float-vector 1.5783999860286713e+02 1.5738800168037415e+02 -3.8325199484825134e+02) (float-vector 1.5387700498104095e+02 1.5698699653148651e+02 -3.5510700941085815e+02) (float-vector 7.5399503111839294e+01 1.6041100025177002e+02 -3.5229900479316711e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5106299519538879e+02 -1.2725399434566498e+02 -4.1877099871635437e+02) (float-vector 1.4131200313568115e+02 -1.5564499795436859e+02 -4.3015500903129578e+02) (float-vector 1.5390700101852417e+02 -1.5693500638008118e+02 -4.0863299369812012e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2880699336528778e+02 -1.5479399263858795e+02 -4.4168999791145325e+02) (float-vector 1.2073600292205811e+02 -1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector 1.4131200313568115e+02 -1.5564499795436859e+02 -4.3015500903129578e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2880699336528778e+02 -1.5479399263858795e+02 -4.4168999791145325e+02) (float-vector 1.2798100709915161e+02 -5.1003000698983669e+00 -4.4605800509452820e+02) (float-vector 1.2073600292205811e+02 -1.5733900666236877e+02 -4.4391998648643494e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2880699336528778e+02 -1.5479399263858795e+02 -4.4168999791145325e+02) (float-vector 1.4131200313568115e+02 -1.5564499795436859e+02 -4.3015500903129578e+02) (float-vector 1.5106299519538879e+02 -1.2725399434566498e+02 -4.1877099871635437e+02) (float-vector 1.5106299519538879e+02 1.2725399434566498e+02 -4.1877099871635437e+02) (float-vector 1.2880699336528778e+02 1.5479399263858795e+02 -4.4168999791145325e+02) (float-vector 1.2798100709915161e+02 -5.1003000698983669e+00 -4.4605800509452820e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3443803489208221e+01 -1.1339699849486351e+01 -4.4605800509452820e+02) (float-vector -4.9783401191234589e+01 -1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector 1.2073600292205811e+02 -1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector 1.2798100709915161e+02 -5.1003000698983669e+00 -4.4605800509452820e+02) (float-vector 1.2073600292205811e+02 1.5733900666236877e+02 -4.4391998648643494e+02) (float-vector -4.9783401191234589e+01 1.5523099899291992e+02 -4.4513300061225891e+02) (float-vector -8.5458800196647644e+01 4.2989999055862427e+01 -4.4605800509452820e+02) (float-vector -9.2909500002861023e+01 1.5696199610829353e+01 -4.4605699181556702e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1435099691152573e+01 -1.3290600478649139e+02 -3.0946698784828186e+02) (float-vector 6.8668797612190247e+01 -3.2503701746463776e+01 -3.0519399046897888e+02) (float-vector 7.8890398144721985e+01 -1.5600100159645081e+02 -3.0739200115203857e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7539400160312653e+01 -1.3917900621891022e+02 -3.2069700956344604e+02) (float-vector 6.1435099691152573e+01 -1.3290600478649139e+02 -3.0946698784828186e+02) (float-vector 7.8890398144721985e+01 -1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 2.6682799682021141e+01 -1.5681700408458710e+02 -3.2793900370597839e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8668797612190247e+01 -3.2503701746463776e+01 -3.0519399046897888e+02) (float-vector 6.1435099691152573e+01 -1.3290600478649139e+02 -3.0946698784828186e+02) (float-vector 3.7539400160312653e+01 -1.3917900621891022e+02 -3.2069700956344604e+02) (float-vector 2.8052400797605515e+01 6.9486995926126838e-02 -3.2314598560333252e+02) (float-vector 5.5645499378442764e+01 3.0338000506162643e+00 -3.0903100967407227e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6022099554538727e+02 1.3521699607372284e+02 -3.7581199407577515e+02) (float-vector 1.5863199532032013e+02 1.2722100317478180e+02 -4.0002998709678650e+02) (float-vector 1.5390700101852417e+02 -1.5693500638008118e+02 -4.0863299369812012e+02) (float-vector 1.5820600092411041e+02 -1.5507300198078156e+02 -3.6952799558639526e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5863199532032013e+02 1.2722100317478180e+02 -4.0002998709678650e+02) (float-vector 1.6022099554538727e+02 1.3521699607372284e+02 -3.7581199407577515e+02) (float-vector 1.5783999860286713e+02 1.5738800168037415e+02 -3.8325199484825134e+02) (float-vector 1.4970099925994873e+02 1.5568600594997406e+02 -4.1819000244140625e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5390700101852417e+02 -1.5693500638008118e+02 -4.0863299369812012e+02) (float-vector 1.5863199532032013e+02 1.2722100317478180e+02 -4.0002998709678650e+02) (float-vector 1.4970099925994873e+02 1.5568600594997406e+02 -4.1819000244140625e+02) (float-vector 1.5106299519538879e+02 1.2725399434566498e+02 -4.1877099871635437e+02) (float-vector 1.5106299519538879e+02 -1.2725399434566498e+02 -4.1877099871635437e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1907800287008286e+02 -1.5696200728416443e+02 -3.1627801060676575e+02) (float-vector 1.3893400132656097e+02 -1.3164399564266205e+02 -3.2958599925041199e+02) (float-vector 1.4813800156116486e+02 -1.5509200096130371e+02 -3.4226098656654358e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5622000396251678e+02 -1.2716899812221527e+02 -3.5809901356697083e+02) (float-vector 1.4813800156116486e+02 -1.5509200096130371e+02 -3.4226098656654358e+02) (float-vector 1.3893400132656097e+02 -1.3164399564266205e+02 -3.2958599925041199e+02) (float-vector 1.3260400295257568e+02 1.5542699396610260e+02 -3.2480201125144958e+02) (float-vector 1.5387700498104095e+02 1.5698699653148651e+02 -3.5510700941085815e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3260400295257568e+02 1.5542699396610260e+02 -3.2480201125144958e+02) (float-vector 1.3893400132656097e+02 -1.3164399564266205e+02 -3.2958599925041199e+02) (float-vector 1.1907800287008286e+02 -1.5696200728416443e+02 -3.1627801060676575e+02) (float-vector 1.2517499923706055e+02 1.2736499309539795e+02 -3.1817099452018738e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0497900098562241e+02 -1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 8.5615396499633789e+01 2.8354899957776070e+01 -3.0314800143241882e+02) (float-vector 1.0497900098562241e+02 1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 1.2517499923706055e+02 1.2736499309539795e+02 -3.1817099452018738e+02) (float-vector 1.1907800287008286e+02 -1.5696200728416443e+02 -3.1627801060676575e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.8890398144721985e+01 -1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 6.8668797612190247e+01 -3.2503701746463776e+01 -3.0519399046897888e+02) (float-vector 8.5615396499633789e+01 2.8354899957776070e+01 -3.0314800143241882e+02) (float-vector 1.0497900098562241e+02 -1.5569199621677399e+02 -3.1002101302146912e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2668500691652298e+01 -1.5709799528121948e+02 -3.7883898615837097e+02) (float-vector -3.4469500184059143e+01 -1.5606600046157837e+02 -3.6462900042533875e+02) (float-vector 2.6682799682021141e+01 -1.5681700408458710e+02 -3.2793900370597839e+02) (float-vector 7.8890398144721985e+01 -1.5600100159645081e+02 -3.0739200115203857e+02) (float-vector 1.0497900098562241e+02 -1.5569199621677399e+02 -3.1002101302146912e+02) (float-vector 1.1907800287008286e+02 -1.5696200728416443e+02 -3.1627801060676575e+02) (float-vector 1.2326300144195557e+02 -1.5952399373054504e+02 -3.4849700331687927e+02) (float-vector 9.9334999918937683e+01 -1.6060799360275269e+02 -3.7641799449920654e+02) (float-vector -6.3710100948810577e+01 -1.5689499676227570e+02 -4.2388400435447693e+02) (float-vector -6.0633599758148193e+01 -1.5715700387954712e+02 -3.9278501272201538e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_pan_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_plate_frame_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 2.3199999999999999e+01 0.0000000000000000e+00 6.4500000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-2.8200000762939453e+01 -5.0000000000000000e+00 -6.9500000000000000e+01 -1.8200000762939453e+01 -5.0000000000000000e+00 -6.9500000000000000e+01 -1.8200000762939453e+01 -5.0000000000000000e+00 -5.9500000000000000e+01 -2.8200000762939453e+01 -5.0000000000000000e+00 -5.9500000000000000e+01 -2.8200000762939453e+01 5.0000000000000000e+00 -5.9500000000000000e+01 -1.8200000762939453e+01 5.0000000000000000e+00 -5.9500000000000000e+01 -1.8200000762939453e+01 5.0000000000000000e+00 -6.9500000000000000e+01 -2.8200000762939453e+01 5.0000000000000000e+00 -6.9500000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -6.9499999284744263e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -5.9500001370906830e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -5.9500001370906830e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -5.9500001370906830e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -2.8200000524520874e+01 -4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -1.8200000748038292e+01 -4.9999998882412910e+00 -6.9499999284744263e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -6.9499999284744263e+01) (float-vector -1.8200000748038292e+01 4.9999998882412910e+00 -5.9500001370906830e+01) (float-vector -2.8200000524520874e+01 4.9999998882412910e+00 -5.9500001370906830e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_plate_frame_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_tilt_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 6.8000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 10 11 0 0 11 1 10 0 3 2 3 0 2 1 4 4 1 16 1 11 16 2 4 3 3 4 5 16 5 4 9 5 6 5 9 3 18 15 5 18 5 16 5 15 6 9 6 8 9 8 3 6 7 8 6 15 7 18 19 15 7 15 24 19 24 15 7 24 3 3 8 7 3 24 25 24 19 25 18 25 19 25 21 3 25 18 21 3 21 22 21 26 22 17 26 21 17 21 18 3 23 12 12 10 3 22 23 3 20 22 16 26 16 22 22 20 23 16 26 17 16 17 18 16 14 13 16 11 14 13 20 16 23 20 13 23 13 12 12 13 14 12 14 10 14 11 10 27 28 29 27 29 68 68 28 27 29 44 45 28 31 29 29 31 60 44 29 60 29 45 68 28 68 57 68 50 57 68 45 50 44 50 45 49 50 44 50 49 57 57 49 56 28 57 55 56 55 57 32 49 33 44 33 49 56 49 32 32 55 56 34 55 32 28 55 34 32 33 34 35 33 44 33 35 53 34 33 53 35 36 37 35 54 53 35 37 54 36 35 44 34 53 54 37 52 54 52 34 54 52 37 67 37 36 67 67 36 38 38 52 67 39 36 40 36 39 38 40 36 44 38 39 40 38 40 46 46 48 38 38 48 52 44 47 40 40 47 46 46 47 48 48 41 52 48 42 41 47 42 48 47 44 42 41 42 43 43 42 44 41 43 66 66 52 41 51 52 43 66 43 52 51 43 44 44 60 61 61 51 44 62 64 51 52 51 64 51 61 65 51 65 62 52 63 34 64 63 52 62 63 64 62 58 63 65 58 62 65 60 58 65 61 60 28 58 59 34 63 58 58 28 34 58 60 59 28 30 31 59 30 28 59 60 30 60 31 30 69 70 71 69 76 78 71 76 69 78 85 69 69 85 70 70 75 71 74 75 70 70 85 74 71 82 76 75 82 71 76 77 78 76 82 77 78 82 83 77 82 78 83 85 78 83 82 95 95 85 83 95 86 85 95 82 86 85 86 87 86 94 87 86 82 94 87 94 89 89 85 87 90 89 94 82 79 94 94 79 93 90 94 93 88 89 90 88 85 89 92 90 93 90 92 88 92 93 91 91 93 81 93 79 81 92 91 88 88 91 85 85 80 84 72 85 84 74 85 72 85 91 80 80 91 81 80 81 79 84 80 79 84 79 72 72 73 74 79 73 72 74 73 75 73 82 75 73 79 82 96 97 98 96 99 100 102 99 96 96 100 97 96 98 107 96 107 102 102 108 99 108 120 99 99 120 100 100 120 97 118 119 120 121 120 119 118 120 122 117 120 113 122 120 117 109 120 121 113 120 106 97 120 109 106 120 108 119 110 121 109 121 110 101 109 110 97 109 101 98 97 101 101 119 98 110 119 101 107 98 112 98 119 112 118 112 119 118 122 116 116 112 118 116 122 117 115 116 117 115 112 116 117 114 115 117 113 114 114 112 115 112 114 113 112 113 111 111 113 103 103 113 106 111 103 105 105 112 111 103 104 105 104 103 106 104 106 107 107 106 108 104 107 105 107 112 105 108 102 107 123 124 125 123 130 132 125 130 123 132 139 123 123 139 124 124 129 125 128 129 124 124 139 128 125 136 130 129 136 125 130 131 132 130 136 131 132 136 137 131 136 132 137 139 132 137 136 149 149 139 137 149 140 139 149 136 140 139 140 141 140 148 141 140 136 148 141 148 143 143 139 141 144 143 148 136 133 148 148 133 147 144 148 147 142 143 144 142 139 143 146 144 147 144 146 142 146 147 145 145 147 135 147 133 135 146 145 142 142 145 139 139 134 138 126 139 138 128 139 126 139 145 134 134 145 135 134 135 133 138 134 133 138 133 126 126 127 128 133 127 126 128 127 129 127 136 129 127 133 136 150 151 152 150 153 154 156 153 150 150 154 151 150 152 161 150 161 156 156 162 153 162 174 153 153 174 154 154 174 151 172 173 174 175 174 173 172 174 176 171 174 167 176 174 171 163 174 175 167 174 160 151 174 163 160 174 162 173 164 175 163 175 164 155 163 164 151 163 155 152 151 155 155 173 152 164 173 155 161 152 166 152 173 166 172 166 173 172 176 170 170 166 172 170 176 171 169 170 171 169 166 170 171 168 169 171 167 168 168 166 169 166 168 167 166 167 165 165 167 157 157 167 160 165 157 159 159 166 165 157 158 159 158 157 160 158 160 161 161 160 162 158 161 159 161 166 159 162 156 161 177 178 179 181 178 177 182 181 177 179 182 177 178 187 179 193 178 181 193 187 178 179 187 188 182 179 188 188 187 189 189 187 193 188 189 191 182 188 191 189 190 191 190 189 193 191 200 182 191 190 200 193 197 190 190 197 200 182 200 198 200 197 198 193 198 197 198 199 182 198 203 199 198 193 203 182 199 202 199 194 202 199 203 195 194 199 195 195 203 193 194 195 193 180 192 194 193 180 194 192 196 194 196 202 194 202 201 182 202 196 201 192 201 196 184 192 185 185 192 180 201 192 184 182 201 184 180 181 182 182 186 180 182 183 186 184 183 182 183 184 185 185 180 186 183 185 186 181 180 193 204 205 206 204 207 205 206 215 204 215 277 204 204 362 207 277 362 204 207 208 205 208 207 209 207 374 209 207 362 374 362 375 374 362 277 375 209 374 373 374 372 373 375 372 374 363 377 375 375 377 372 375 277 363 372 370 373 377 276 372 372 276 370 373 370 369 214 373 369 209 373 214 368 369 370 370 371 368 276 378 370 370 378 371 212 369 368 214 369 212 212 213 214 213 210 214 209 214 210 379 212 368 379 213 212 366 368 371 379 368 366 379 366 213 364 365 366 366 371 364 365 388 366 388 213 366 388 389 387 213 388 384 388 387 384 365 389 388 389 390 387 365 390 389 384 387 385 390 361 387 387 361 385 384 385 386 213 384 386 386 385 391 391 213 386 210 213 391 391 398 210 391 385 398 209 210 211 398 395 210 395 211 210 398 455 395 385 455 398 395 396 211 395 455 396 455 385 454 455 454 456 456 457 455 397 455 457 396 455 397 211 396 397 211 397 392 392 397 393 457 400 397 393 397 400 456 401 457 457 401 400 393 400 394 400 401 394 392 393 394 394 399 392 392 399 211 394 205 399 401 205 394 456 205 401 208 399 205 206 205 458 458 205 456 211 399 208 211 208 209 477 456 431 456 452 431 454 452 456 458 456 480 480 456 498 498 456 477 453 454 360 453 452 454 360 454 361 361 454 385 446 452 453 451 446 453 453 360 451 443 441 446 441 442 446 443 446 451 442 452 446 347 443 440 347 441 443 445 440 443 443 451 445 347 348 441 441 348 442 430 442 348 430 452 442 431 452 430 429 430 348 429 431 430 348 347 318 318 343 348 429 348 343 429 342 341 342 429 343 341 431 429 340 343 318 342 343 340 317 318 319 340 318 317 319 318 347 336 340 317 339 342 340 339 340 336 339 341 342 335 339 336 335 341 339 336 337 338 335 336 338 317 337 336 333 335 328 328 335 338 333 330 335 330 341 335 338 334 328 338 337 334 327 326 328 326 329 328 328 329 333 328 334 327 329 330 333 329 325 330 325 332 330 332 341 330 332 431 341 332 325 431 325 432 431 477 431 432 331 432 325 473 432 331 432 473 477 473 497 477 477 497 498 426 473 331 426 476 473 473 476 497 324 331 322 322 331 325 426 331 324 322 323 324 314 424 324 323 314 324 426 324 424 322 325 326 323 322 326 326 325 329 326 327 323 314 323 309 309 323 327 313 314 312 312 314 309 314 313 424 306 309 310 312 309 306 310 309 327 302 327 334 302 310 327 306 310 305 305 310 302 304 305 302 305 304 306 304 307 306 311 312 306 307 311 306 302 303 304 303 307 304 303 308 307 307 316 311 307 308 316 312 311 315 419 315 311 316 419 311 419 316 308 301 308 303 420 308 301 420 421 308 308 421 419 300 301 303 300 303 302 297 301 300 297 420 301 298 297 300 298 300 337 302 337 300 302 334 337 317 298 337 297 298 299 299 298 321 317 321 298 319 320 317 320 321 317 320 238 321 238 299 321 240 297 299 238 240 299 238 239 240 239 238 344 238 320 344 319 345 320 345 346 320 346 344 320 345 319 347 346 345 436 345 437 436 347 437 345 344 346 433 346 436 433 439 433 436 437 355 436 439 436 354 436 355 354 433 439 435 435 344 433 439 447 435 447 439 354 354 259 257 259 354 355 354 257 447 355 356 357 355 357 259 355 437 356 256 257 259 259 382 256 357 382 259 357 356 359 357 383 382 359 383 357 358 359 356 437 450 356 450 358 356 360 359 358 359 360 361 359 361 383 444 358 450 444 449 358 360 358 449 437 444 450 347 440 437 440 444 437 440 445 444 444 448 449 445 448 444 448 451 449 451 360 449 451 448 445 383 361 390 365 380 383 383 243 382 243 383 380 390 365 383 364 367 365 367 246 365 380 365 381 365 246 381 381 243 380 381 246 243 242 243 244 244 243 246 242 382 243 382 242 256 255 256 242 237 255 242 242 244 237 245 244 246 235 236 244 235 244 245 237 244 236 237 236 234 262 237 234 255 237 262 234 236 235 225 234 235 225 235 233 245 233 235 262 234 263 263 234 285 225 285 234 279 262 283 263 283 262 255 262 279 284 263 285 263 284 283 284 285 286 285 225 224 286 285 224 288 284 286 418 283 284 418 284 288 286 287 288 224 287 286 292 288 287 292 418 288 418 293 415 283 418 415 291 418 292 293 418 291 291 292 289 289 292 287 224 226 287 226 289 287 289 290 291 289 226 261 289 261 290 293 291 290 293 290 294 261 294 290 260 261 226 264 261 260 261 268 294 268 261 264 294 268 459 459 293 294 264 267 268 268 267 459 460 459 267 461 459 460 459 461 468 459 468 467 467 293 459 460 267 278 278 461 460 468 461 469 278 483 461 469 461 483 275 215 278 278 267 275 215 462 278 462 483 278 481 482 483 482 469 483 481 483 478 483 462 478 462 206 478 206 462 215 277 215 275 273 277 275 273 363 277 273 377 363 273 276 377 252 273 272 273 274 272 274 273 275 273 252 276 276 252 251 251 378 276 250 251 252 271 252 272 252 271 250 271 272 265 265 272 274 265 274 266 275 266 274 267 266 275 265 266 264 264 266 267 227 265 264 227 228 265 271 265 270 265 228 270 250 271 270 270 269 250 269 270 229 232 270 228 229 270 232 216 228 217 217 228 227 232 228 216 217 227 226 226 227 264 226 264 260 217 226 218 230 218 226 224 220 226 226 220 230 216 217 218 216 218 230 230 232 216 230 229 232 220 229 230 219 220 221 220 222 221 220 219 231 231 229 220 224 222 220 224 221 222 225 221 224 223 219 221 225 223 221 219 223 231 231 269 229 223 269 231 233 223 225 269 223 233 269 249 250 249 269 233 245 249 233 248 249 245 248 250 249 248 253 250 250 253 251 245 247 248 254 253 248 254 248 247 246 247 245 367 364 247 247 364 254 247 246 367 251 253 254 254 364 376 254 376 251 376 378 251 371 376 364 371 378 376 478 206 479 206 458 479 501 478 500 478 479 500 501 502 478 502 481 478 479 458 480 500 479 480 474 500 476 474 501 500 476 500 499 500 480 499 474 475 501 475 502 501 428 474 426 474 476 426 474 428 475 497 476 499 497 499 498 499 480 498 427 475 428 423 475 427 423 471 475 475 503 502 505 475 490 505 503 475 475 471 492 490 475 492 423 470 471 492 471 470 490 492 470 422 470 423 422 472 470 470 472 489 490 470 489 422 313 315 313 422 423 419 472 422 315 419 422 312 315 313 313 425 424 423 425 313 423 427 425 424 425 427 428 426 424 427 428 424 421 463 419 463 472 419 464 463 421 484 472 463 464 484 463 486 472 484 486 489 472 484 485 486 464 485 484 421 465 464 465 485 464 487 486 485 465 488 485 488 487 485 487 490 486 486 490 489 488 491 487 491 490 487 466 488 465 466 414 488 414 491 488 466 465 421 414 466 421 420 414 421 296 420 297 409 420 296 420 409 410 420 410 413 413 412 420 412 417 420 417 414 420 295 296 297 297 240 295 241 295 240 402 295 241 402 296 295 239 241 240 352 241 239 352 402 241 405 296 402 353 404 402 404 405 402 353 402 352 239 353 352 350 353 239 353 403 404 350 403 353 403 405 404 403 406 405 350 406 403 281 406 350 281 405 406 279 280 281 279 281 258 281 407 405 407 281 411 280 411 281 258 281 350 280 279 283 279 258 255 255 258 257 258 350 257 256 255 257 351 257 350 438 257 351 447 257 438 350 349 351 349 438 351 239 349 350 434 438 349 239 434 349 434 435 438 435 447 438 434 344 435 239 344 434 282 280 283 282 283 415 282 415 280 280 412 411 280 415 417 417 412 280 414 415 416 417 415 414 415 293 416 468 414 416 414 493 491 468 493 414 467 416 293 467 468 416 468 469 493 493 490 491 469 494 493 493 494 490 469 496 494 469 482 496 494 495 490 496 495 494 495 505 490 496 505 495 482 505 496 504 482 481 504 505 482 504 503 505 502 503 504 502 504 481 412 413 411 411 413 407 407 413 410 407 408 405 407 410 408 410 409 408 408 296 405 408 409 296 506 507 508 523 524 506 506 509 507 540 509 506 540 506 524 547 523 506 547 506 508 508 507 547 536 547 507 536 528 547 528 523 547 523 528 524 524 528 529 536 529 528 534 529 536 535 536 507 536 535 534 512 529 513 529 512 524 513 529 534 534 535 513 513 535 511 511 535 507 511 512 513 524 512 516 533 516 512 533 512 511 514 515 516 533 532 516 532 514 516 524 516 515 532 533 511 532 530 514 532 511 530 546 514 530 546 515 514 517 515 518 519 515 546 519 518 515 524 515 517 546 530 519 517 518 519 527 517 519 519 525 527 530 525 519 517 526 524 527 526 517 525 526 527 530 522 525 522 521 525 525 521 526 521 524 526 524 521 520 539 540 524 524 531 539 524 520 531 520 521 522 545 520 522 522 530 545 520 530 531 530 520 545 531 541 543 541 531 530 544 539 531 543 544 531 540 539 544 538 540 544 543 538 544 541 542 543 542 538 543 530 542 541 511 542 530 538 542 511 537 538 507 511 507 538 537 540 538 510 540 537 507 510 537 509 510 507 510 509 540))
                   (list :vertices (let ((mat (make-matrix 548 3))) (fvector-replace (array-entity mat) #f(-6.9647102355957031e+00 9.9441200256347656e+01 1.0824900054931641e+02 5.3500003814697266e+00 9.5596000671386719e+01 1.1468099975585938e+02 -6.9647102355957031e+00 9.5596000671386719e+01 1.1468099975585938e+02 -6.9647102355957031e+00 9.5248802185058594e+01 1.2261000061035156e+02 5.3500003814697266e+00 9.5248802185058594e+01 1.2261000061035156e+02 5.3500003814697266e+00 9.9554504394531250e+01 1.3006700134277344e+02 5.3500003814697266e+00 1.0595200347900391e+02 1.3362899780273438e+02 -6.9647703170776367e+00 1.1153499603271484e+02 1.3408100891113281e+02 -6.9647102355957031e+00 1.0595200347900391e+02 1.3362899780273438e+02 -6.9647102355957031e+00 9.9554595947265625e+01 1.3006700134277344e+02 -6.9647102355957031e+00 1.0584200286865234e+02 1.0459700012207031e+02 5.3500003814697266e+00 9.9441101074218750e+01 1.0824900054931641e+02 -6.9648103713989258e+00 1.1157300567626953e+02 1.0414600372314453e+02 5.3483700752258301e+00 1.1305899810791016e+02 1.0430700683593750e+02 5.3500003814697266e+00 1.0584200286865234e+02 1.0459700012207031e+02 5.3492598533630371e+00 1.1304000091552734e+02 1.3388400268554688e+02 5.3498001098632812e+00 1.2273000335693359e+02 1.1080899810791016e+02 5.3506197929382324e+00 1.2504499816894531e+02 1.1775000000000000e+02 5.3495202064514160e+00 1.2408000183105469e+02 1.2470400238037109e+02 5.3489904403686523e+00 1.1953700256347656e+02 1.3076100158691406e+02 5.3455700874328613e+00 1.1907800292968750e+02 1.0708100128173828e+02 -6.9659600257873535e+00 1.2519000244140625e+02 1.1933200073242188e+02 -6.9647102355957031e+00 1.2162400054931641e+02 1.0950899505615234e+02 -6.9654202461242676e+00 1.1676800537109375e+02 1.0563999938964844e+02 -6.9646100997924805e+00 1.1683200073242188e+02 1.3251499938964844e+02 -6.9635400772094727e+00 1.2268300628662109e+02 1.2747100067138672e+02 -6.9623599052429199e+00 1.2426200103759766e+02 1.1429000091552734e+02 -1.9799999237060547e+01 9.5200004577636719e+01 8.8122100830078125e+01 -6.6834297180175781e+01 9.5200004577636719e+01 8.8122100830078125e+01 -1.9799999237060547e+01 9.2200004577636719e+01 8.8122100830078125e+01 -1.0500000000000000e+02 9.5200004577636719e+01 8.8122100830078125e+01 -1.0500000000000000e+02 9.2200004577636719e+01 8.8122100830078125e+01 -9.9018802642822266e+00 9.5200004577636719e+01 2.2461500167846680e+01 -8.0223398208618164e+00 9.2200004577636719e+01 1.6561300277709961e+01 -5.5465497970581055e+00 9.5200004577636719e+01 -3.0501301288604736e+00 -1.7162698745727539e+01 9.2200004577636719e+01 -3.6489597320556641e+01 -4.4993900299072266e+01 9.2200004577636719e+01 -5.8784999847412109e+01 -2.3598098754882812e+01 9.5200004577636719e+01 -4.4011299133300781e+01 -6.8000000000000000e+01 9.5200004577636719e+01 -6.2000000000000000e+01 -6.8000000000000000e+01 9.2200004577636719e+01 -6.2000000000000000e+01 -8.2051498413085938e+01 9.2200004577636719e+01 -6.0772300720214844e+01 -1.2957200622558594e+02 9.5200004577636719e+01 -1.3855000495910645e+01 -1.2811500549316406e+02 9.2200004577636719e+01 -1.7942100524902344e+01 -1.2792099761962891e+02 9.2200004577636719e+01 1.9375799179077148e+01 -6.7777702331542969e+01 9.2200004577636719e+01 1.4576000213623047e+01 -1.9799999237060547e+01 9.2200004577636719e+01 7.5500000000000000e+01 -9.0257400512695312e+01 9.5200004577636719e+01 -5.8664402008056641e+01 -1.0974500274658203e+02 9.2200004577636719e+01 -4.7232601165771484e+01 -1.1408300018310547e+02 9.5200004577636719e+01 -4.2353000640869141e+01 -1.8222799301147461e+01 9.2200004577636719e+01 3.6962596893310547e+01 -1.9799999237060547e+01 9.2200004577636719e+01 4.1731998443603516e+01 -1.0785699462890625e+02 9.2200004577636719e+01 4.7491100311279297e+01 -1.1693399810791016e+02 9.5200004577636719e+01 3.8426601409912109e+01 -5.8684296607971191e+00 9.2200004577636719e+01 -8.0525503158569336e+00 -1.1385000228881836e+01 9.5200004577636719e+01 -2.5728401184082031e+01 -2.3205699920654297e+01 9.5200004577636719e+01 3.9583499908447266e+01 -1.8222799301147461e+01 9.5200004577636719e+01 3.6962596893310547e+01 -1.9799999237060547e+01 9.5200004577636719e+01 4.1731998443603516e+01 -1.0500000000000000e+02 9.5200004577636719e+01 5.9659099578857422e+01 -1.0500000000000000e+02 9.5200004577636719e+01 7.5500000000000000e+01 -1.0500000000000000e+02 9.2200004577636719e+01 7.5500000000000000e+01 -9.8247604370117188e+01 9.2200004577636719e+01 5.1344902038574219e+01 -1.0500000000000000e+02 9.5200004577636719e+01 5.3618999481201172e+01 -9.4963699340820312e+01 9.5200004577636719e+01 4.7030399322509766e+01 -1.0785699462890625e+02 9.5200004577636719e+01 4.7491100311279297e+01 -1.0500000000000000e+02 9.2200004577636719e+01 5.3618999481201172e+01 -1.2771500396728516e+02 9.5200004577636719e+01 1.8487998962402344e+01 -4.7663299560546875e+01 9.5200004577636719e+01 -5.9251499176025391e+01 -1.9799999237060547e+01 9.5200004577636719e+01 7.5500000000000000e+01 -1.3615399360656738e+01 -2.5057500839233398e+01 1.1003700256347656e+02 -1.3615399360656738e+01 -2.3042001724243164e+01 1.1397299957275391e+02 5.9440398216247559e-01 -2.3775899887084961e+01 1.1193100738525391e+02 -1.3615399360656738e+01 -2.4639499664306641e+01 1.1966699981689453e+02 5.9440398216247559e-01 -2.4308599472045898e+01 1.1933300018310547e+02 -1.3615399360656738e+01 -2.3383499145507812e+01 1.1737000274658203e+02 5.9440398216247559e-01 -2.2945800781250000e+01 1.1522799682617188e+02 5.9440398216247559e-01 -2.5455900192260742e+01 1.0975099945068359e+02 5.9440398216247559e-01 -2.8086601257324219e+01 1.0829599761962891e+02 -1.3615399360656738e+01 -2.8086500167846680e+01 1.0829599761962891e+02 5.9440398216247559e-01 -2.6951599121093750e+01 1.2149299621582031e+02 -1.3615399360656738e+01 -2.9267198562622070e+01 1.2219999694824219e+02 5.9440398216247559e-01 -2.9660800933837891e+01 1.2223899841308594e+02 5.9440398216247559e-01 -3.1515300750732422e+01 1.0806600189208984e+02 -1.3615399360656738e+01 -3.0825000762939453e+01 1.0801900482177734e+02 -1.3615399360656738e+01 -2.6771699905395508e+01 1.2140700531005859e+02 -1.3615399360656738e+01 -3.5649600982666016e+01 1.1058100128173828e+02 5.9440398216247559e-01 -3.5078498840332031e+01 1.0988199615478516e+02 -1.3615399360656738e+01 -3.6905601501464844e+01 1.1287899780273438e+02 -1.3615399360656738e+01 -3.6427799224853516e+01 1.1849700164794922e+02 -1.3615399360656738e+01 -3.7249401092529297e+01 1.1580500030517578e+02 5.9440398216247559e-01 -3.6091999053955078e+01 1.1913600158691406e+02 -1.3615399360656738e+01 -3.2202602386474609e+01 1.2195199584960938e+02 -1.3615399360656738e+01 -3.4443298339843750e+01 1.2080399322509766e+02 5.9440398216247559e-01 -3.2685802459716797e+01 1.2185099792480469e+02 5.9440398216247559e-01 -3.7382301330566406e+01 1.1443399810791016e+02 -1.3615399360656738e+01 -3.3337501525878906e+01 1.0875599670410156e+02 -1.5222299575805664e+01 3.7745700836181641e+01 1.1151499938964844e+02 1.5412499904632568e+00 3.5042999267578125e+01 1.0823900604248047e+02 -1.5222299575805664e+01 3.5248600006103516e+01 1.0848999786376953e+02 1.5412499904632568e+00 3.8566501617431641e+01 1.1486700439453125e+02 1.5412499904632568e+00 3.7591201782226562e+01 1.1135700225830078e+02 -1.5222299575805664e+01 3.2505901336669922e+01 1.0706900024414062e+02 -1.5222299575805664e+01 3.8459697723388672e+01 1.1592700195312500e+02 1.5412499904632568e+00 3.1700700759887695e+01 1.2348199462890625e+02 -1.5222299575805664e+01 3.5248600006103516e+01 1.2175799560546875e+02 -1.5222299575805664e+01 3.2279701232910156e+01 1.2323600006103516e+02 1.5412499904632568e+00 3.5609302520751953e+01 1.2146299743652344e+02 -1.5222299575805664e+01 3.7490497589111328e+01 1.1910299682617188e+02 1.5412499904632568e+00 3.7490600585937500e+01 1.1910299682617188e+02 1.5412499904632568e+00 3.0880701065063477e+01 1.0674200439453125e+02 -1.5222299575805664e+01 2.9622999191284180e+01 1.0673099517822266e+02 -1.5222299575805664e+01 2.9275299072265625e+01 1.2350600433349609e+02 -1.5222299575805664e+01 2.5315801620483398e+01 1.2218099975585938e+02 1.5412499904632568e+00 2.6586400985717773e+01 1.2285500335693359e+02 1.5412499904632568e+00 2.3443700790405273e+01 1.2029500579833984e+02 -1.5222299575805664e+01 2.2564899444580078e+01 1.1889099884033203e+02 -1.5222299575805664e+01 2.1696399688720703e+01 1.1592700195312500e+02 1.5412499904632568e+00 2.2023099899291992e+01 1.1755199432373047e+02 -1.5222299575805664e+01 2.2101900100708008e+01 1.1247499847412109e+02 -1.5222299575805664e+01 2.4660398483276367e+01 1.0854199981689453e+02 1.5412499904632568e+00 2.2905899047851562e+01 1.1064600372314453e+02 1.5412499904632568e+00 2.6713800430297852e+01 1.0733599853515625e+02 1.5412499904632568e+00 2.1730701446533203e+01 1.1408899688720703e+02 -1.3615399360656738e+01 6.4764595031738281e+01 1.1003700256347656e+02 -1.3615399360656738e+01 6.6779998779296875e+01 1.1397299957275391e+02 5.9440398216247559e-01 6.6046096801757812e+01 1.1193100738525391e+02 -1.3615399360656738e+01 6.5182502746582031e+01 1.1966699981689453e+02 5.9440398216247559e-01 6.5513496398925781e+01 1.1933300018310547e+02 -1.3615399360656738e+01 6.6438507080078125e+01 1.1737000274658203e+02 5.9440398216247559e-01 6.6876296997070312e+01 1.1522799682617188e+02 5.9440398216247559e-01 6.4366104125976562e+01 1.0975099945068359e+02 5.9440398216247559e-01 6.1735397338867188e+01 1.0829599761962891e+02 -1.3615399360656738e+01 6.1735500335693359e+01 1.0829599761962891e+02 5.9440398216247559e-01 6.2870399475097656e+01 1.2149299621582031e+02 -1.3615399360656738e+01 6.0554798126220703e+01 1.2219999694824219e+02 5.9440398216247559e-01 6.0161197662353516e+01 1.2223899841308594e+02 5.9440398216247559e-01 5.8306701660156250e+01 1.0806600189208984e+02 -1.3615399360656738e+01 5.8997001647949219e+01 1.0801900482177734e+02 -1.3615399360656738e+01 6.3050300598144531e+01 1.2140700531005859e+02 -1.3615399360656738e+01 5.4172401428222656e+01 1.1058100128173828e+02 5.9440398216247559e-01 5.4743499755859375e+01 1.0988199615478516e+02 -1.3615399360656738e+01 5.2916400909423828e+01 1.1287899780273438e+02 -1.3615399360656738e+01 5.3394199371337891e+01 1.1849700164794922e+02 -1.3615399360656738e+01 5.2572601318359375e+01 1.1580500030517578e+02 5.9440398216247559e-01 5.3730098724365234e+01 1.1913600158691406e+02 -1.3615399360656738e+01 5.7619400024414062e+01 1.2195199584960938e+02 -1.3615399360656738e+01 5.5378799438476562e+01 1.2080399322509766e+02 5.9440398216247559e-01 5.7136299133300781e+01 1.2185099792480469e+02 5.9440398216247559e-01 5.2439701080322266e+01 1.1443399810791016e+02 -1.3615399360656738e+01 5.6484500885009766e+01 1.0875599670410156e+02 -1.5222299575805664e+01 -5.2076400756835938e+01 1.1151499938964844e+02 1.5412499904632568e+00 -5.4779102325439453e+01 1.0823900604248047e+02 -1.5222299575805664e+01 -5.4573402404785156e+01 1.0848999786376953e+02 1.5412499904632568e+00 -5.1255500793457031e+01 1.1486700439453125e+02 1.5412499904632568e+00 -5.2230800628662109e+01 1.1135700225830078e+02 -1.5222299575805664e+01 -5.7316097259521484e+01 1.0706900024414062e+02 -1.5222299575805664e+01 -5.1362297058105469e+01 1.1592700195312500e+02 1.5412499904632568e+00 -5.8121299743652344e+01 1.2348199462890625e+02 -1.5222299575805664e+01 -5.4573402404785156e+01 1.2175799560546875e+02 -1.5222299575805664e+01 -5.7542301177978516e+01 1.2323600006103516e+02 1.5412499904632568e+00 -5.4212699890136719e+01 1.2146299743652344e+02 -1.5222299575805664e+01 -5.2331501007080078e+01 1.1910299682617188e+02 1.5412499904632568e+00 -5.2331501007080078e+01 1.1910299682617188e+02 1.5412499904632568e+00 -5.8941299438476562e+01 1.0674200439453125e+02 -1.5222299575805664e+01 -6.0199001312255859e+01 1.0673099517822266e+02 -1.5222299575805664e+01 -6.0546798706054688e+01 1.2350600433349609e+02 -1.5222299575805664e+01 -6.4506301879882812e+01 1.2218099975585938e+02 1.5412499904632568e+00 -6.3235603332519531e+01 1.2285500335693359e+02 1.5412499904632568e+00 -6.6378303527832031e+01 1.2029500579833984e+02 -1.5222299575805664e+01 -6.7257202148437500e+01 1.1889099884033203e+02 -1.5222299575805664e+01 -6.8125701904296875e+01 1.1592700195312500e+02 1.5412499904632568e+00 -6.7798896789550781e+01 1.1755199432373047e+02 -1.5222299575805664e+01 -6.7720100402832031e+01 1.1247499847412109e+02 -1.5222299575805664e+01 -6.5161598205566406e+01 1.0854199981689453e+02 1.5412499904632568e+00 -6.6916198730468750e+01 1.1064600372314453e+02 1.5412499904632568e+00 -6.3108303070068359e+01 1.0733599853515625e+02 1.5412499904632568e+00 -6.8091300964355469e+01 1.1408899688720703e+02 -6.9647102355957031e+00 -9.5596000671386719e+01 1.1468099975585938e+02 5.3500003814697266e+00 -9.5596000671386719e+01 1.1468099975585938e+02 -6.9647102355957031e+00 -9.9441200256347656e+01 1.0824900054931641e+02 5.3500003814697266e+00 -9.9554504394531250e+01 1.3006700134277344e+02 5.3500003814697266e+00 -9.5248802185058594e+01 1.2261000061035156e+02 -6.9647102355957031e+00 -9.5248802185058594e+01 1.2261000061035156e+02 -6.9647102355957031e+00 -1.0595200347900391e+02 1.3362899780273438e+02 -6.9647703170776367e+00 -1.1153499603271484e+02 1.3408100891113281e+02 5.3500003814697266e+00 -1.0595200347900391e+02 1.3362899780273438e+02 -6.9647102355957031e+00 -9.9554595947265625e+01 1.3006700134277344e+02 5.3500003814697266e+00 -9.9441101074218750e+01 1.0824900054931641e+02 -6.9647102355957031e+00 -1.0584200286865234e+02 1.0459700012207031e+02 5.3500003814697266e+00 -1.0584200286865234e+02 1.0459700012207031e+02 5.3483700752258301e+00 -1.1305899810791016e+02 1.0430700683593750e+02 -6.9648103713989258e+00 -1.1157300567626953e+02 1.0414600372314453e+02 5.3492598533630371e+00 -1.1304000091552734e+02 1.3388400268554688e+02 5.3498001098632812e+00 -1.2273000335693359e+02 1.1080899810791016e+02 5.3495202064514160e+00 -1.2408000183105469e+02 1.2470400238037109e+02 5.3506197929382324e+00 -1.2504499816894531e+02 1.1775000000000000e+02 5.3489904403686523e+00 -1.1953700256347656e+02 1.3076100158691406e+02 5.3455700874328613e+00 -1.1907800292968750e+02 1.0708100128173828e+02 -6.9647102355957031e+00 -1.2162400054931641e+02 1.0950899505615234e+02 -6.9659600257873535e+00 -1.2519000244140625e+02 1.1933200073242188e+02 -6.9654202461242676e+00 -1.1676800537109375e+02 1.0563999938964844e+02 -6.9646100997924805e+00 -1.1683200073242188e+02 1.3251499938964844e+02 -6.9635400772094727e+00 -1.2268300628662109e+02 1.2747100067138672e+02 -6.9623599052429199e+00 -1.2426200103759766e+02 1.1429000091552734e+02 -5.3888602256774902e+00 -1.2488999938964844e+02 8.8321701049804688e+01 -5.3026299476623535e+00 -1.2327799987792969e+02 1.4792900085449219e+02 -6.5973801612854004e+00 -1.3950199890136719e+02 1.3395201110839844e+02 -3.7659800052642822e+00 -9.8288200378417969e+01 8.8968597412109375e+01 -2.8652899265289307e+00 -8.0523399353027344e+01 1.4847799682617188e+02 -2.4561500549316406e+00 -7.0641006469726562e+01 8.8567001342773438e+01 -1.4382899999618530e+00 -3.1527500152587891e+01 1.4955000305175781e+02 -2.2387599945068359e+00 -6.3673599243164062e+01 1.4933000183105469e+02 -1.0920900106430054e+00 -6.8978300094604492e+00 8.8124702453613281e+01 -9.5823794603347778e-01 -1.0843499749898911e-01 1.4881298828125000e+02 -1.4458099603652954e+00 -3.6032596588134766e+01 8.8242797851562500e+01 -6.4744601249694824e+00 -1.4037998962402344e+02 8.6364295959472656e+01 -1.1805000305175781e+00 -9.2729202270507812e+01 4.5912002563476562e+01 -1.0463600158691406e+00 -9.5525398254394531e+01 4.9345897674560547e+01 -1.4100600242614746e+01 -9.5192901611328125e+01 4.6617797851562500e+01 -2.7339898049831390e-02 9.1713798522949219e+01 4.5972297668457031e+01 -1.4100000381469727e+01 9.2506103515625000e+01 4.5506801605224609e+01 -6.9111996889114380e-01 9.5146400451660156e+01 4.8393997192382812e+01 -1.4099200248718262e+01 9.5801895141601562e+01 4.9511600494384766e+01 1.3100199699401855e+00 9.3567398071289062e+01 4.9421001434326172e+01 -1.4103399276733398e+01 9.6181304931640625e+01 6.5850402832031250e+01 1.3483999967575073e+00 9.6245803833007812e+01 6.6138603210449219e+01 -1.4109199523925781e+01 -9.6098106384277344e+01 6.5867797851562500e+01 1.4059400558471680e+00 -9.5531600952148438e+01 6.4176300048828125e+01 1.1586700677871704e+00 -9.3105895996093750e+01 4.7738601684570312e+01 2.8677401542663574e+00 8.7440299987792969e+00 4.6086200714111328e+01 -1.4100000381469727e+01 -6.6392105102539062e+01 4.5500000000000000e+01 1.9904998540878296e+00 6.1776199340820312e+01 4.6084300994873047e+01 2.3793900012969971e+00 -4.2309398651123047e+01 4.6340702056884766e+01 3.4915599822998047e+00 9.4056800842285156e+01 6.7379600524902344e+01 -6.6314496994018555e+00 1.3839698791503906e+02 6.6355300903320312e+01 5.0828999280929565e-01 1.1648400115966797e+02 6.7804595947265625e+01 -4.1350498199462891e+00 1.3712200927734375e+02 6.8445999145507812e+01 -7.0551300048828125e+00 1.4352099609375000e+02 7.0972503662109375e+01 -2.4307200622558594e+02 1.4585700988769531e+02 1.3155799865722656e+02 -2.2150000000000000e+02 1.4780000305175781e+02 1.2900000000000000e+02 -2.4381999206542969e+02 1.4573100280761719e+02 8.8323104858398438e+01 -2.2169299316406250e+02 1.4777299499511719e+02 8.7467002868652344e+01 -7.5188899040222168e+00 1.4366101074218750e+02 8.4982795715332031e+01 -6.5453600883483887e+00 1.4024899291992188e+02 8.6694503784179688e+01 -2.4362599849700928e+00 1.3221701049804688e+02 8.3888595581054688e+01 4.1079001426696777e+00 1.0089500427246094e+02 8.2518699645996094e+01 -1.8738099336624146e+00 1.2269700622558594e+02 8.5679901123046875e+01 2.5923399925231934e+00 9.8673599243164062e+01 8.5068099975585938e+01 6.2675099372863770e+00 6.1618701934814453e+01 8.4255393981933594e+01 7.5292000770568848e+00 6.3235698699951172e+01 8.1989303588867188e+01 9.3484001159667969e+00 2.0932798385620117e+01 8.1917602539062500e+01 6.2736101150512695e+00 1.0220399856567383e+01 8.4403594970703125e+01 8.4398498535156250e+00 -9.5455894470214844e+00 8.3611099243164062e+01 6.8343596458435059e+00 3.1735401153564453e+01 8.4348899841308594e+01 3.2502400875091553e+00 4.5742900848388672e+01 8.4795799255371094e+01 -1.8502500534057617e+01 1.4515000915527344e+02 7.1633895874023438e+01 -8.6730899810791016e+00 1.4424299621582031e+02 1.1632399749755859e+02 -4.3108798980712891e+01 1.4771499633789062e+02 1.3215798950195312e+02 -5.0645198822021484e+01 1.4749301147460938e+02 8.7385696411132812e+01 -8.9549703598022461e+00 1.4317900085449219e+02 1.2546299743652344e+02 -1.4100000381469727e+01 -9.7241401672363281e+01 6.5562095642089844e+01 -1.7929000854492188e+01 -9.8748199462890625e+01 6.5889900207519531e+01 -2.1805999755859375e+01 1.4268598937988281e+02 6.8769798278808594e+01 -2.1396499633789062e+01 1.3954299926757812e+02 6.6048797607421875e+01 1.7618499994277954e+00 -9.7305603027343750e+01 6.6337501525878906e+01 3.7694499492645264e+00 -9.2992202758789062e+01 6.7024795532226562e+01 2.0093099772930145e-01 -1.1938899993896484e+02 6.8733100891113281e+01 -5.4713902473449707e+00 -1.4066299438476562e+02 6.8006904602050781e+01 -6.8876199722290039e+00 -1.3777700805664062e+02 6.6193298339843750e+01 6.5521202087402344e+00 4.3331100463867188e+01 6.4341094970703125e+01 6.6157498359680176e+00 -2.6648199081420898e+01 6.2840000152587891e+01 8.7147502899169922e+00 -3.9043399810791016e+01 8.0808700561523438e+01 7.5997300148010254e+00 -6.2148601531982422e+01 8.2681198120117188e+01 2.6103701591491699e+00 -9.8794197082519531e+01 8.5148200988769531e+01 5.1075401306152344e+00 -9.2219001770019531e+01 8.2608703613281250e+01 -8.6380195617675781e-01 -1.2692099761962891e+02 8.3721397399902344e+01 1.4110000133514404e+00 -3.3917999267578125e+01 8.4925895690917969e+01 -3.7713999748229980e+00 -1.2654399871826172e+02 8.6194198608398438e+01 -7.5973901748657227e+00 -1.4389599609375000e+02 8.5655303955078125e+01 -4.2109703063964844e+01 1.4585299682617188e+02 8.0996696472167969e+01 -6.1656200408935547e+01 1.4151699829101562e+02 8.0298294067382812e+01 -6.7878700256347656e+01 1.4619099426269531e+02 8.3196495056152344e+01 -5.1406700134277344e+01 1.4012399291992188e+02 7.8831504821777344e+01 -3.6077499389648438e+01 1.3983599853515625e+02 7.4059600830078125e+01 -2.3819898605346680e+01 8.6960395812988281e+01 6.7227401733398438e+01 -2.0786800384521484e+01 1.0908200073242188e+02 6.5944099426269531e+01 -2.1155099868774414e+01 5.3845497131347656e+01 6.6058601379394531e+01 -2.1649299621582031e+01 -2.8654398918151855e+00 6.6225799560546875e+01 -2.3819898605346680e+01 3.5209999084472656e+01 6.7227401733398438e+01 -2.1649299621582031e+01 -5.8771900177001953e+01 6.6225799560546875e+01 -2.1649299621582031e+01 -9.3629699707031250e+01 6.6225799560546875e+01 -2.3819898605346680e+01 -8.5585601806640625e+01 6.7227401733398438e+01 -2.3819898605346680e+01 -2.9880199432373047e+01 6.7227401733398438e+01 -3.2602100372314453e+01 -1.3875000000000000e+02 7.2363395690917969e+01 -2.1066099166870117e+01 -1.3862500000000000e+02 6.5971504211425781e+01 -2.2163699340820312e+02 1.4620199584960938e+02 8.3392799377441406e+01 -2.1991500854492188e+02 1.4302200317382812e+02 8.0738594055175781e+01 -2.4433499145507812e+02 1.4063699340820312e+02 8.2720504760742188e+01 -2.4713400268554688e+02 1.3846099853515625e+02 8.6146194458007812e+01 -2.4574600219726562e+02 1.4427400207519531e+02 8.8177398681640625e+01 -2.5022200012207031e+02 7.9477401733398438e+01 8.5516296386718750e+01 -2.4680900573730469e+02 7.8178596496582031e+01 8.2758598327636719e+01 -2.5188699340820312e+02 2.8160900115966797e+01 8.6891601562500000e+01 -2.4932501220703125e+02 4.7122699737548828e+01 8.3507598876953125e+01 -2.5060400390625000e+02 1.9034198760986328e+01 8.4365303039550781e+01 -2.5172299194335938e+02 2.9184000492095947e+00 8.6003799438476562e+01 -2.5106901550292969e+02 -3.0983301162719727e+01 8.4945098876953125e+01 -2.4918099975585938e+02 -2.9341599941253662e+00 8.3239501953125000e+01 -2.4729100036621094e+02 1.6296298980712891e+01 8.2753501892089844e+01 -2.5098500061035156e+02 -6.5924697875976562e+01 8.7639503479003906e+01 -2.5194299316406250e+02 -1.5874000549316406e+01 8.7743400573730469e+01 -2.4838999938964844e+02 -7.0229202270507812e+01 8.3160697937011719e+01 -2.4988600158691406e+02 -8.4387802124023438e+01 8.5843299865722656e+01 -2.4669100952148438e+02 -1.4158399963378906e+02 8.6085998535156250e+01 -2.4860200500488281e+02 -1.1479399871826172e+02 8.7447395324707031e+01 -2.4440600585937500e+02 -1.3935099792480469e+02 8.2680999755859375e+01 -2.4707800292968750e+02 -3.5501701354980469e+01 8.2735298156738281e+01 -2.4751399230957031e+02 1.2918800354003906e+02 1.5009400939941406e+02 -2.4540400695800781e+02 1.2644700622558594e+02 1.5245098876953125e+02 -2.4364199829101562e+02 1.3444299316406250e+02 1.4961299133300781e+02 -2.4414199829101562e+02 1.4279598999023438e+02 1.4120300292968750e+02 -2.4661099243164062e+02 1.4273899841308594e+02 1.3513299560546875e+02 -2.4936898803710938e+02 -8.5908897399902344e+01 1.5071398925781250e+02 -2.5060800170898438e+02 -7.6624397277832031e+01 1.4789801025390625e+02 -2.4765499877929688e+02 -1.2765899658203125e+02 1.4970700073242188e+02 -2.4843400573730469e+02 -5.3548400878906250e+01 1.5258399963378906e+02 -2.5110700988769531e+02 -4.7955596923828125e+01 1.4955000305175781e+02 -2.5204499816894531e+02 -1.3351400375366211e+01 1.4760699462890625e+02 -2.5180200195312500e+02 6.0264701843261719e+00 1.4948899841308594e+02 -2.5049200439453125e+02 -2.8033500671386719e+01 1.5114498901367188e+02 -2.4918000793457031e+02 -7.4610199928283691e+00 1.5226100158691406e+02 -2.4460501098632812e+02 -1.2658999633789062e+02 1.5278099060058594e+02 -2.4718501281738281e+02 -3.0177700042724609e+01 1.5275500488281250e+02 -2.5070599365234375e+02 -1.6328899860382080e+00 1.5112599182128906e+02 -2.5166799926757812e+02 3.8229202270507812e+01 1.4778900146484375e+02 -2.4985000610351562e+02 3.0785299301147461e+01 1.5182499694824219e+02 -2.4937300109863281e+02 7.1609603881835938e+01 1.5124200439453125e+02 -2.5007000732421875e+02 8.7735496520996094e+01 1.4847099304199219e+02 -2.5067898559570312e+02 6.2867702484130859e+01 1.4958700561523438e+02 -2.4828100585937500e+02 5.8192901611328125e+01 1.5233898925781250e+02 -2.4715499877929688e+02 8.8109100341796875e+01 1.5243800354003906e+02 -2.4709999084472656e+02 2.8384899139404297e+01 1.5277899169921875e+02 -2.4611500549316406e+02 7.0902198791503906e+01 1.5284700012207031e+02 -2.4357199096679688e+02 1.2179999542236328e+02 1.5306900024414062e+02 -2.2228900146484375e+02 1.4718400573730469e+02 1.3513999938964844e+02 -2.2147299194335938e+02 1.4016200256347656e+02 1.4750700378417969e+02 -2.2151499938964844e+02 1.4390798950195312e+02 1.4273999023437500e+02 -2.2257499694824219e+02 1.3142199707031250e+02 1.5336199951171875e+02 -2.2158900451660156e+02 1.2328500366210938e+02 1.5498500061035156e+02 -1.3329798889160156e+02 1.4780000305175781e+02 1.2900000000000000e+02 -1.0142699432373047e+02 1.4780000305175781e+02 8.8472206115722656e+01 -6.6522399902343750e+01 1.4780000305175781e+02 1.2900000000000000e+02 -1.9484298706054688e+02 1.4780000305175781e+02 8.8470199584960938e+01 -1.5749700927734375e+02 1.4780000305175781e+02 8.8471099853515625e+01 -3.9288700103759766e+01 1.4657600402832031e+02 1.3688800048828125e+02 -3.3158599853515625e+01 1.4275500488281250e+02 1.4463600158691406e+02 -2.8765499114990234e+01 1.3763900756835938e+02 1.4970399475097656e+02 -7.8263597488403320e+00 1.3815699768066406e+02 1.3707501220703125e+02 -2.5848699569702148e+01 1.3127400207519531e+02 1.5323999023437500e+02 -7.1046199798583984e+00 1.2771800231933594e+02 1.4689500427246094e+02 -2.3279600143432617e+01 1.2638300323486328e+02 1.5456500244140625e+02 -5.6406102180480957e+00 1.1264599609375000e+02 1.5074699401855469e+02 -4.3277297019958496e+00 -1.1204399871826172e+02 8.7958702087402344e+01 -2.2654399871826172e+00 -1.0971800231933594e+02 8.5929298400878906e+01 -8.9418202638626099e-02 4.0464099884033203e+01 8.5356201171875000e+01 -2.8475298881530762e+00 8.1291000366210938e+01 8.7462097167968750e+01 -1.4218599796295166e+00 3.6940799713134766e+01 8.7491897583007812e+01 -7.6596099138259888e-01 6.4937705993652344e+01 8.5533302307128906e+01 -8.5320699214935303e-01 2.8503501415252686e-01 8.6849601745605469e+01 -9.2991805076599121e-01 -1.6990301132202148e+01 8.6872894287109375e+01 -2.3677600920200348e-01 -2.5038499832153320e+01 8.5717002868652344e+01 -9.6861295402050018e-02 7.3657503128051758e+00 8.5673698425292969e+01 -1.0603799819946289e+00 -5.9936901092529297e+01 8.5972999572753906e+01 -1.3904799222946167e+00 -4.5649402618408203e+01 8.7015502929687500e+01 -2.7319800853729248e+00 -8.2450393676757812e+01 8.7434700012207031e+01 -2.4023799896240234e+00 -9.1627906799316406e+01 8.6391502380371094e+01 9.5837903022766113e-01 2.1048400878906250e+01 8.4924499511718750e+01 -3.9770799875259399e-01 -7.3321502685546875e+01 8.5346298217773438e+01 1.0841699838638306e+00 -7.4947600364685059e+00 8.4885795593261719e+01 -1.1848399639129639e+00 1.8195699691772461e+01 8.8158798217773438e+01 -5.0301098823547363e+00 1.1968199920654297e+02 8.8358200073242188e+01 -3.5911300182342529e+00 1.1116799926757812e+02 8.6755294799804688e+01 -6.7526898384094238e+00 1.4158700561523438e+02 1.2585400390625000e+02 -5.4683799743652344e+00 1.2608300018310547e+02 1.4658000183105469e+02 -1.6443600654602051e+00 2.8561199188232422e+01 1.4983900451660156e+02 -4.9019598960876465e+00 3.0133800506591797e+01 1.5229100036621094e+02 -2.2410600185394287e+00 1.0696800231933594e+01 1.5073800659179688e+02 -2.8351099491119385e+00 6.3309200286865234e+01 1.5042599487304688e+02 -1.8098800182342529e+00 5.1053199768066406e+01 1.4808699035644531e+02 -2.7286999225616455e+00 7.6754402160644531e+01 1.4802799987792969e+02 -3.4091000556945801e+00 9.0980903625488281e+01 1.4858599853515625e+02 -2.1985499858856201e+00 -4.1737399101257324e+00 1.5074501037597656e+02 -4.2631502151489258e+00 -8.4226196289062500e+01 1.5065200805664062e+02 -5.6379103660583496e+00 -9.4878501892089844e+01 1.5116900634765625e+02 -5.7004199028015137e+00 -1.1010099792480469e+02 1.5061999511718750e+02 -3.1540400981903076e+00 -4.5071502685546875e+01 1.5100500488281250e+02 -4.0704302787780762e+00 -5.9981700897216797e+01 1.5122200012207031e+02 -6.0389599800109863e+00 -8.6294395446777344e+01 1.5162699890136719e+02 -3.1570301055908203e+00 -2.2088199615478516e+01 1.5128100585937500e+02 -4.0448803901672363e+00 -9.3369697570800781e+01 1.4986898803710938e+02 -7.1989598274230957e+00 -1.1000800323486328e+02 1.5150801086425781e+02 -7.4514799118041992e+00 -1.1838400268554688e+02 1.5069400024414062e+02 -1.7775799560546875e+02 1.4740798950195312e+02 8.5833496093750000e+01 -1.2921899414062500e+02 1.4764599609375000e+02 8.6905998229980469e+01 -1.5798300170898438e+02 1.4764599609375000e+02 8.6905998229980469e+01 -1.4446299743652344e+02 1.4552000427246094e+02 8.2591697692871094e+01 -1.0585000610351562e+02 1.4745399475097656e+02 8.5974800109863281e+01 -1.2023200225830078e+02 1.4245800781250000e+02 8.0889099121093750e+01 -1.6472401428222656e+02 1.4139199829101562e+02 8.0653900146484375e+01 -1.8944200134277344e+02 1.3982998657226562e+02 8.0500000000000000e+01 -1.4599800109863281e+02 1.3982998657226562e+02 8.0500000000000000e+01 -9.2965797424316406e+01 1.4139199829101562e+02 8.0653900146484375e+01 -6.6420501708984375e+01 1.3984599304199219e+02 8.0499000549316406e+01 -1.2143000030517578e+02 1.3982998657226562e+02 8.0500000000000000e+01 -6.3593605041503906e+01 -1.4284999084472656e+02 8.0496101379394531e+01 -4.8286998748779297e+01 -3.8659099578857422e+01 7.8114196777343750e+01 -4.9682899475097656e+01 -1.4151499938964844e+02 7.8631294250488281e+01 -6.4972297668457031e+01 6.2990703582763672e+01 8.0495201110839844e+01 -3.2453800201416016e+01 -1.2786800384521484e+01 7.2294799804687500e+01 -2.2156700134277344e+02 -1.4085400390625000e+02 8.0506500244140625e+01 -2.2150000000000000e+02 8.6009300231933594e+01 8.0500000000000000e+01 -2.2150000000000000e+02 -6.5413993835449219e+01 8.0500000000000000e+01 -2.4361199951171875e+02 -1.4252200317382812e+02 8.3781600952148438e+01 -2.4406300354003906e+02 -1.4565299987792969e+02 8.8054801940917969e+01 -2.4692100524902344e+02 -1.3815499877929688e+02 1.4327200317382812e+02 -2.4652198791503906e+02 -1.4311799621582031e+02 1.3281799316406250e+02 -2.4377799987792969e+02 -1.3621600341796875e+02 1.4844599914550781e+02 -2.4401199340820312e+02 -1.4566400146484375e+02 1.3305099487304688e+02 -2.4311000061035156e+02 -1.4260299682617188e+02 1.4161900329589844e+02 -2.3588598632812500e+02 3.9249401092529297e+01 1.5374099731445312e+02 -2.2150000000000000e+02 9.5204803466796875e+01 1.5500000000000000e+02 -2.2150000000000000e+02 -1.0551199913024902e+01 1.5500000000000000e+02 -2.2145800781250000e+02 -1.2445499420166016e+02 1.5498701477050781e+02 -1.8122300720214844e+02 1.4548901367187500e+02 1.3991700744628906e+02 -1.7411999511718750e+02 1.4766299438476562e+02 1.3166600036621094e+02 -1.4262699890136719e+02 1.4725199890136719e+02 1.3431199645996094e+02 -1.5459999084472656e+02 1.4405400085449219e+02 1.4272799682617188e+02 -1.1912900543212891e+02 1.3758599853515625e+02 1.4979800415039062e+02 -1.0068499755859375e+02 1.4766299438476562e+02 1.3166600036621094e+02 -1.3155200195312500e+02 1.4657899475097656e+02 1.3687400817871094e+02 -1.7132699584960938e+02 1.3209800720214844e+02 1.5296000671386719e+02 -1.7739500427246094e+02 1.2446600341796875e+02 1.5486300659179688e+02 -1.6076699829101562e+02 1.2179999542236328e+02 1.5500000000000000e+02 -1.4570899963378906e+02 1.2711199951171875e+02 1.5445199584960938e+02 -9.9288299560546875e+01 1.3211700439453125e+02 1.5286499023437500e+02 -1.3039599609375000e+02 1.2967399597167969e+02 1.5377900695800781e+02 -1.0858200073242188e+02 1.2446600341796875e+02 1.5486300659179688e+02 -8.8020195007324219e+01 1.4725199890136719e+02 1.3431199645996094e+02 -1.0015500640869141e+02 1.2967399597167969e+02 1.5377900695800781e+02 -6.0957500457763672e+01 1.2967399597167969e+02 1.5377900695800781e+02 -5.0074600219726562e+01 1.3440998840332031e+02 1.5173699951171875e+02 -8.6094001770019531e+01 1.2711199951171875e+02 1.5445199584960938e+02 -8.9947700500488281e+01 1.2179999542236328e+02 1.5500000000000000e+02 -5.6623600006103516e+01 1.2446600341796875e+02 1.5486300659179688e+02 -2.1470998764038086e+01 1.2044200134277344e+02 1.5498599243164062e+02 -1.1225600242614746e+01 -2.0882699966430664e+01 1.5430499267578125e+02 -2.4126699447631836e+01 -1.2563100433349609e+02 1.5499299621582031e+02 -1.6899499893188477e+01 -1.1077799987792969e+02 1.5443899536132812e+02 -7.8951101303100586e+00 -1.3247999572753906e+02 1.4387400817871094e+02 -2.1038099288940430e+01 -1.4347399902343750e+02 6.8339103698730469e+01 -8.0231399536132812e+00 -1.4402000427246094e+02 7.1815498352050781e+01 -2.0663398742675781e+01 -1.4555599975585938e+02 7.4718299865722656e+01 -7.7943301200866699e+00 -1.4381300354003906e+02 1.2115499877929688e+02 -2.1185800170898438e+02 -1.4076901245117188e+02 8.0517204284667969e+01 -1.6637199401855469e+02 -1.3992900085449219e+02 8.0500000000000000e+01 -1.2712300109863281e+02 -1.3992799377441406e+02 8.0500000000000000e+01 -9.4465705871582031e+01 -1.3992799377441406e+02 8.0500000000000000e+01 -3.3717098236083984e+01 -1.4341700744628906e+02 7.4766304016113281e+01 -5.0793598175048828e+01 -1.4625799560546875e+02 8.2945602416992188e+01 -5.7182300567626953e+01 -1.4769500732421875e+02 8.6644096374511719e+01 -2.2175399780273438e+02 -1.4663499450683594e+02 8.4045700073242188e+01 -2.2162500000000000e+02 -1.4788000488281250e+02 8.7529602050781250e+01 -2.2141200256347656e+02 -1.4358599853515625e+02 8.1311203002929688e+01 -2.2150300598144531e+02 -1.3102899169921875e+02 1.5338000488281250e+02 -2.2218798828125000e+02 -1.4268901062011719e+02 1.4480599975585938e+02 -2.2174400329589844e+02 -1.4787800598144531e+02 1.3287399291992188e+02 -2.2131800842285156e+02 -1.3686700439453125e+02 1.5036499023437500e+02 -1.4446299743652344e+02 -1.2573600006103516e+02 1.5495100402832031e+02 -3.9896598815917969e+01 -1.4677398681640625e+02 1.3676998901367188e+02 -3.3886299133300781e+01 -1.4377200317382812e+02 1.4345001220703125e+02 -2.7702600479125977e+01 -1.3563099670410156e+02 1.5122799682617188e+02 -4.4208099365234375e+01 -1.4786698913574219e+02 1.3079600524902344e+02 -6.4777206420898438e+01 -1.4789601135253906e+02 8.8404602050781250e+01 -3.0331399917602539e+01 -1.4648999023437500e+02 1.2067800140380859e+02 -1.8884300231933594e+02 -1.4149198913574219e+02 8.0653900146484375e+01 -1.5498701477050781e+02 -1.4149198913574219e+02 8.0653900146484375e+01 -1.7686000061035156e+02 -1.4335099792480469e+02 8.1268196105957031e+01 -1.1948300170898438e+02 -1.4380299377441406e+02 8.1464096069335938e+01 -1.0689900207519531e+02 -1.4221200561523438e+02 8.0791503906250000e+01 -1.9063999938964844e+02 -1.4495100402832031e+02 8.2274299621582031e+01 -1.5391000366210938e+02 -1.4771899414062500e+02 8.5268104553222656e+01 -9.1617797851562500e+01 -1.4439100646972656e+02 8.1809700012207031e+01 -1.8927000427246094e+02 -1.4778100585937500e+02 8.6408103942871094e+01 -7.5320899963378906e+01 -1.4680500793457031e+02 8.4332695007324219e+01 -1.1663600158691406e+02 -1.4774600219726562e+02 8.6907203674316406e+01 -1.2509200286865234e+02 -1.4789999389648438e+02 8.8469604492187500e+01 -8.9190902709960938e+01 -1.4789999389648438e+02 8.8469604492187500e+01 -1.7413800048828125e+02 -1.3410000610351562e+02 1.5205099487304688e+02 -8.6768203735351562e+01 -1.3101899719238281e+02 1.5338299560546875e+02 -1.1456500244140625e+02 -1.3641799926757812e+02 1.5061399841308594e+02 -1.1646500396728516e+02 -1.4236999511718750e+02 1.4532600402832031e+02 -1.7106199645996094e+02 -1.4673699951171875e+02 1.3693598937988281e+02 -1.1816500091552734e+02 -1.4776300048828125e+02 1.3166600036621094e+02 -1.6709400939941406e+02 -1.4789999389648438e+02 1.2900000000000000e+02 -8.1237098693847656e+01 -1.4789999389648438e+02 1.2900000000000000e+02 -9.4729103088378906e+01 -1.4789999389648438e+02 1.0771199798583984e+02 -1.9799999237060547e+01 -9.2200004577636719e+01 8.8122100830078125e+01 -6.6834297180175781e+01 -9.5200004577636719e+01 8.8122100830078125e+01 -1.9799999237060547e+01 -9.5200004577636719e+01 8.8122100830078125e+01 -1.0500000000000000e+02 -9.2200004577636719e+01 8.8122100830078125e+01 -1.0500000000000000e+02 -9.5200004577636719e+01 8.8122100830078125e+01 -5.5465497970581055e+00 -9.5200004577636719e+01 -3.0501301288604736e+00 -8.0223398208618164e+00 -9.2200004577636719e+01 1.6561300277709961e+01 -9.9018802642822266e+00 -9.5200004577636719e+01 2.2461500167846680e+01 -2.3598098754882812e+01 -9.5200004577636719e+01 -4.4011299133300781e+01 -4.4993900299072266e+01 -9.2200004577636719e+01 -5.8784999847412109e+01 -1.7162698745727539e+01 -9.2200004577636719e+01 -3.6489597320556641e+01 -8.2051498413085938e+01 -9.2200004577636719e+01 -6.0772300720214844e+01 -6.8000000000000000e+01 -9.2200004577636719e+01 -6.2000000000000000e+01 -6.8000000000000000e+01 -9.5200004577636719e+01 -6.2000000000000000e+01 -1.2792099761962891e+02 -9.2200004577636719e+01 1.9375799179077148e+01 -1.2811500549316406e+02 -9.2200004577636719e+01 -1.7942100524902344e+01 -1.2957200622558594e+02 -9.5200004577636719e+01 -1.3855000495910645e+01 -1.9799999237060547e+01 -9.2200004577636719e+01 7.5500000000000000e+01 -6.7777702331542969e+01 -9.2200004577636719e+01 1.4576000213623047e+01 -1.1408300018310547e+02 -9.5200004577636719e+01 -4.2353000640869141e+01 -1.0974500274658203e+02 -9.2200004577636719e+01 -4.7232601165771484e+01 -9.0257400512695312e+01 -9.5200004577636719e+01 -5.8664402008056641e+01 -1.9799999237060547e+01 -9.2200004577636719e+01 4.1731998443603516e+01 -1.8222799301147461e+01 -9.2200004577636719e+01 3.6962596893310547e+01 -1.1693399810791016e+02 -9.5200004577636719e+01 3.8426601409912109e+01 -1.0785699462890625e+02 -9.2200004577636719e+01 4.7491100311279297e+01 -1.1385000228881836e+01 -9.5200004577636719e+01 -2.5728401184082031e+01 -5.8684296607971191e+00 -9.2200004577636719e+01 -8.0525503158569336e+00 -1.8222799301147461e+01 -9.5200004577636719e+01 3.6962596893310547e+01 -2.3205699920654297e+01 -9.5200004577636719e+01 3.9583499908447266e+01 -1.9799999237060547e+01 -9.5200004577636719e+01 4.1731998443603516e+01 -1.0500000000000000e+02 -9.5200004577636719e+01 7.5500000000000000e+01 -1.0500000000000000e+02 -9.5200004577636719e+01 5.9659099578857422e+01 -9.8247604370117188e+01 -9.2200004577636719e+01 5.1344902038574219e+01 -1.0500000000000000e+02 -9.2200004577636719e+01 7.5500000000000000e+01 -1.0785699462890625e+02 -9.5200004577636719e+01 4.7491100311279297e+01 -9.4963699340820312e+01 -9.5200004577636719e+01 4.7030399322509766e+01 -1.0500000000000000e+02 -9.5200004577636719e+01 5.3618999481201172e+01 -1.0500000000000000e+02 -9.2200004577636719e+01 5.3618999481201172e+01 -1.2771500396728516e+02 -9.5200004577636719e+01 1.8487998962402344e+01 -4.7663299560546875e+01 -9.5200004577636719e+01 -5.9251499176025391e+01 -1.9799999237060547e+01 -9.5200004577636719e+01 7.5500000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3180 -> 64 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4540400505065918e+02 1.2644700706005096e+02 1.5245099365711212e+02) (float-vector -2.4843400716781616e+02 -5.3548399358987808e+01 1.5258400142192841e+02) (float-vector -2.5204500555992126e+02 -1.3351400382816792e+01 1.4760699868202209e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3506200201809406e+00 1.2504500150680542e+02 1.1774999648332596e+02) (float-vector -5.8684297837316990e+00 9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector 9.3483999371528625e+00 2.0932799205183983e+01 8.1917598843574524e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3495201282203197e+00 -1.2408000230789185e+02 1.2470400333404541e+02) (float-vector 5.3492598235607147e+00 -1.1304000020027161e+02 1.3388399779796600e+02) (float-vector 9.3483999371528625e+00 2.0932799205183983e+01 8.1917598843574524e+01) (float-vector 5.1075401715934277e+00 -9.2219002544879913e+01 8.2608699798583984e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.0257398784160614e+01 9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -9.0257398784160614e+01 -9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -6.8000003695487976e+01 -9.5200002193450928e+01 -6.1999998986721039e+01) (float-vector -6.8000003695487976e+01 9.5200002193450928e+01 -6.1999998986721039e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4433499574661255e+02 1.4063699543476105e+02 8.2720503211021423e+01) (float-vector -1.0974500328302383e+02 9.2200003564357758e+01 -4.7232601791620255e+01) (float-vector -9.0257398784160614e+01 9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -2.4381999671459198e+02 1.4573100209236145e+02 8.8323101401329041e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4414199590682983e+02 1.4279599487781525e+02 1.4120300114154816e+02) (float-vector -2.2147299349308014e+02 1.4016200602054596e+02 1.4750699698925018e+02) (float-vector -2.4540400505065918e+02 1.2644700706005096e+02 1.5245099365711212e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3492598235607147e+00 1.1304000020027161e+02 1.3388399779796600e+02) (float-vector 5.3506200201809406e+00 1.2504500150680542e+02 1.1774999648332596e+02) (float-vector 9.3483999371528625e+00 2.0932799205183983e+01 8.1917598843574524e+01) (float-vector 5.3492598235607147e+00 -1.1304000020027161e+02 1.3388399779796600e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4540400505065918e+02 1.2644700706005096e+02 1.5245099365711212e+02) (float-vector -2.2147299349308014e+02 1.4016200602054596e+02 1.4750699698925018e+02) (float-vector -2.8765499591827393e+01 1.3763900101184845e+02 1.4970399439334869e+02) (float-vector -2.1470999345183372e+01 1.2044200301170349e+02 1.5498599410057068e+02) (float-vector -2.2158899903297424e+02 1.2328500300645828e+02 1.5498499572277069e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4669100344181061e+02 -1.4158399403095245e+02 8.6085997521877289e+01) (float-vector -1.0974500328302383e+02 -9.2200003564357758e+01 -4.7232601791620255e+01) (float-vector -2.5106900930404663e+02 -3.0983300879597664e+01 8.4945097565650940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0974500328302383e+02 -9.2200003564357758e+01 -4.7232601791620255e+01) (float-vector -9.0257398784160614e+01 -9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -9.0257398784160614e+01 9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -1.0974500328302383e+02 9.2200003564357758e+01 -4.7232601791620255e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8684297837316990e+00 9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector -5.8684297837316990e+00 -9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector 9.3483999371528625e+00 2.0932799205183983e+01 8.1917598843574524e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8684297837316990e+00 -9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector 5.1075401715934277e+00 -9.2219002544879913e+01 8.2608699798583984e+01) (float-vector 9.3483999371528625e+00 2.0932799205183983e+01 8.1917598843574524e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1075401715934277e+00 -9.2219002544879913e+01 8.2608699798583984e+01) (float-vector -5.8684297837316990e+00 -9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01) (float-vector 5.3495201282203197e+00 -1.2408000230789185e+02 1.2470400333404541e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2145800292491913e+02 -1.2445499747991562e+02 1.5498700737953186e+02) (float-vector -2.2158899903297424e+02 1.2328500300645828e+02 1.5498499572277069e+02) (float-vector -2.1470999345183372e+01 1.2044200301170349e+02 1.5498599410057068e+02) (float-vector -1.1225599795579910e+01 -2.0882699638605118e+01 1.5430499613285065e+02) (float-vector -2.4126699194312096e+01 -1.2563100457191467e+02 1.5499299764633179e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.8000003695487976e+01 9.5200002193450928e+01 -6.1999998986721039e+01) (float-vector -6.8000003695487976e+01 -9.5200002193450928e+01 -6.1999998986721039e+01) (float-vector -4.7663301229476929e+01 -9.5200002193450928e+01 -5.9251498430967331e+01) (float-vector -4.7663301229476929e+01 9.5200002193450928e+01 -5.9251498430967331e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3598099127411842e+01 -9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -2.3598099127411842e+01 9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -4.7663301229476929e+01 9.5200002193450928e+01 -5.9251498430967331e+01) (float-vector -4.7663301229476929e+01 -9.5200002193450928e+01 -5.9251498430967331e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5106900930404663e+02 -3.0983300879597664e+01 8.4945097565650940e+01) (float-vector -2.5022199749946594e+02 7.9477399587631226e+01 8.5516296327114105e+01) (float-vector -2.5204500555992126e+02 -1.3351400382816792e+01 1.4760699868202209e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4433499574661255e+02 1.4063699543476105e+02 8.2720503211021423e+01) (float-vector -2.5022199749946594e+02 7.9477399587631226e+01 8.5516296327114105e+01) (float-vector -2.5106900930404663e+02 -3.0983300879597664e+01 8.4945097565650940e+01) (float-vector -1.0974500328302383e+02 -9.2200003564357758e+01 -4.7232601791620255e+01) (float-vector -1.0974500328302383e+02 9.2200003564357758e+01 -4.7232601791620255e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6406101211905479e+00 1.1264599859714508e+02 1.5074700117111206e+02) (float-vector -2.8351100627332926e+00 6.3309200108051300e+01 1.5042600035667419e+02) (float-vector -1.1225599795579910e+01 -2.0882699638605118e+01 1.5430499613285065e+02) (float-vector -2.1470999345183372e+01 1.2044200301170349e+02 1.5498599410057068e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7004201225936413e+00 -1.1010099947452545e+02 1.5061999857425690e+02) (float-vector -1.1225599795579910e+01 -2.0882699638605118e+01 1.5430499613285065e+02) (float-vector -2.8351100627332926e+00 6.3309200108051300e+01 1.5042600035667419e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7004201225936413e+00 -1.1010099947452545e+02 1.5061999857425690e+02) (float-vector -2.8351100627332926e+00 6.3309200108051300e+01 1.5042600035667419e+02) (float-vector -5.6406101211905479e+00 1.1264599859714508e+02 1.5074700117111206e+02) (float-vector 5.3492598235607147e+00 1.1304000020027161e+02 1.3388399779796600e+02) (float-vector 5.3492598235607147e+00 -1.1304000020027161e+02 1.3388399779796600e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9288699626922607e+01 1.4657600224018097e+02 1.3688799738883972e+02) (float-vector -2.8765499591827393e+01 1.3763900101184845e+02 1.4970399439334869e+02) (float-vector -2.2147299349308014e+02 1.4016200602054596e+02 1.4750699698925018e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0645198673009872e+01 1.4749300479888916e+02 8.7385699152946472e+01) (float-vector -3.9288699626922607e+01 1.4657600224018097e+02 1.3688799738883972e+02) (float-vector -2.4307200312614441e+02 1.4585700631141663e+02 1.3155800104141235e+02) (float-vector -2.4381999671459198e+02 1.4573100209236145e+02 8.8323101401329041e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9288699626922607e+01 1.4657600224018097e+02 1.3688799738883972e+02) (float-vector -2.2147299349308014e+02 1.4016200602054596e+02 1.4750699698925018e+02) (float-vector -2.4414199590682983e+02 1.4279599487781525e+02 1.4120300114154816e+02) (float-vector -2.4307200312614441e+02 1.4585700631141663e+02 1.3155800104141235e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8684297837316990e+00 -9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector -1.1385000310838223e+01 -9.5200002193450928e+01 -2.5728400796651840e+01) (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1385000310838223e+01 -9.5200002193450928e+01 -2.5728400796651840e+01) (float-vector -2.3598099127411842e+01 -9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8684297837316990e+00 -9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector -5.8684297837316990e+00 9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector -1.1385000310838223e+01 9.5200002193450928e+01 -2.5728400796651840e+01) (float-vector -1.1385000310838223e+01 -9.5200002193450928e+01 -2.5728400796651840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3598099127411842e+01 9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -2.3598099127411842e+01 -9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -1.1385000310838223e+01 -9.5200002193450928e+01 -2.5728400796651840e+01) (float-vector -1.1385000310838223e+01 9.5200002193450928e+01 -2.5728400796651840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3886298537254333e+01 -1.4377200603485107e+02 1.4345000684261322e+02) (float-vector -4.4208098202943802e+01 -1.4786699414253235e+02 1.3079600036144257e+02) (float-vector -2.2174400091171265e+02 -1.4787800610065460e+02 1.3287399709224701e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4713400006294250e+02 1.3846099376678467e+02 8.6146198213100433e+01) (float-vector -2.5022199749946594e+02 7.9477399587631226e+01 8.5516296327114105e+01) (float-vector -2.4433499574661255e+02 1.4063699543476105e+02 8.2720503211021423e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5204500555992126e+02 -1.3351400382816792e+01 1.4760699868202209e+02) (float-vector -2.5022199749946594e+02 7.9477399587631226e+01 8.5516296327114105e+01) (float-vector -2.4713400006294250e+02 1.3846099376678467e+02 8.6146198213100433e+01) (float-vector -2.4414199590682983e+02 1.4279599487781525e+02 1.4120300114154816e+02) (float-vector -2.4540400505065918e+02 1.2644700706005096e+02 1.5245099365711212e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4414199590682983e+02 1.4279599487781525e+02 1.4120300114154816e+02) (float-vector -2.4713400006294250e+02 1.3846099376678467e+02 8.6146198213100433e+01) (float-vector -2.4433499574661255e+02 1.4063699543476105e+02 8.2720503211021423e+01) (float-vector -2.4381999671459198e+02 1.4573100209236145e+02 8.8323101401329041e+01) (float-vector -2.4307200312614441e+02 1.4585700631141663e+02 1.3155800104141235e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.6406101211905479e+00 1.1264599859714508e+02 1.5074700117111206e+02) (float-vector -7.1046198718249798e+00 1.2771800160408020e+02 1.4689500629901886e+02) (float-vector 5.3492598235607147e+00 1.1304000020027161e+02 1.3388399779796600e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1046198718249798e+00 1.2771800160408020e+02 1.4689500629901886e+02) (float-vector -5.6406101211905479e+00 1.1264599859714508e+02 1.5074700117111206e+02) (float-vector -2.1470999345183372e+01 1.2044200301170349e+02 1.5498599410057068e+02) (float-vector -2.8765499591827393e+01 1.3763900101184845e+02 1.4970399439334869e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2131800651550293e+02 -1.3686700165271759e+02 1.5036499500274658e+02) (float-vector -2.4460500478744507e+02 -1.2658999860286713e+02 1.5278099477291107e+02) (float-vector -2.2145800292491913e+02 -1.2445499747991562e+02 1.5498700737953186e+02) (float-vector -2.4126699194312096e+01 -1.2563100457191467e+02 1.5499299764633179e+02) (float-vector -2.7702599763870239e+01 -1.3563099503517151e+02 1.5122799575328827e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4401199817657471e+02 -1.4566400647163391e+02 1.3305099308490753e+02) (float-vector -2.4692100286483765e+02 -1.3815499842166901e+02 1.4327199757099152e+02) (float-vector -2.2131800651550293e+02 -1.3686700165271759e+02 1.5036499500274658e+02) (float-vector -2.7702599763870239e+01 -1.3563099503517151e+02 1.5122799575328827e+02) (float-vector -3.3886298537254333e+01 -1.4377200603485107e+02 1.4345000684261322e+02) (float-vector -2.2174400091171265e+02 -1.4787800610065460e+02 1.3287399709224701e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4843400716781616e+02 -5.3548399358987808e+01 1.5258400142192841e+02) (float-vector -2.4765500426292419e+02 -1.2765899300575256e+02 1.4970700442790985e+02) (float-vector -2.4692100286483765e+02 -1.3815499842166901e+02 1.4327199757099152e+02) (float-vector -2.4401199817657471e+02 -1.4566400647163391e+02 1.3305099308490753e+02) (float-vector -2.4669100344181061e+02 -1.4158399403095245e+02 8.6085997521877289e+01) (float-vector -2.5106900930404663e+02 -3.0983300879597664e+01 8.4945097565650940e+01) (float-vector -2.5204500555992126e+02 -1.3351400382816792e+01 1.4760699868202209e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2145800292491913e+02 -1.2445499747991562e+02 1.5498700737953186e+02) (float-vector -2.4460500478744507e+02 -1.2658999860286713e+02 1.5278099477291107e+02) (float-vector -2.4765500426292419e+02 -1.2765899300575256e+02 1.4970700442790985e+02) (float-vector -2.4843400716781616e+02 -5.3548399358987808e+01 1.5258400142192841e+02) (float-vector -2.4540400505065918e+02 1.2644700706005096e+02 1.5245099365711212e+02) (float-vector -2.2158899903297424e+02 1.2328500300645828e+02 1.5498499572277069e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4401199817657471e+02 -1.4566400647163391e+02 1.3305099308490753e+02) (float-vector -2.2174400091171265e+02 -1.4787800610065460e+02 1.3287399709224701e+02) (float-vector -4.4208098202943802e+01 -1.4786699414253235e+02 1.3079600036144257e+02) (float-vector -5.7182300835847855e+01 -1.4769500494003296e+02 8.6644098162651062e+01) (float-vector -2.2175399959087372e+02 -1.4663499593734741e+02 8.4045700728893280e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3886298537254333e+01 -1.4377200603485107e+02 1.4345000684261322e+02) (float-vector -6.5973801538348198e+00 -1.3950200378894806e+02 1.3395200669765472e+02) (float-vector -7.7943298965692520e+00 -1.4381299912929535e+02 1.2115500122308731e+02) (float-vector -4.4208098202943802e+01 -1.4786699414253235e+02 1.3079600036144257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5973900966346264e+00 -1.4389599859714508e+02 8.5655301809310913e+01) (float-vector -7.7943298965692520e+00 -1.4381299912929535e+02 1.2115500122308731e+02) (float-vector -6.5973801538348198e+00 -1.3950200378894806e+02 1.3395200669765472e+02) (float-vector 5.3495201282203197e+00 -1.2408000230789185e+02 1.2470400333404541e+02) (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4401199817657471e+02 -1.4566400647163391e+02 1.3305099308490753e+02) (float-vector -2.4406300485134125e+02 -1.4565299451351166e+02 8.8054798543453217e+01) (float-vector -2.4669100344181061e+02 -1.4158399403095245e+02 8.6085997521877289e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2175399959087372e+02 -1.4663499593734741e+02 8.4045700728893280e+01) (float-vector -2.4406300485134125e+02 -1.4565299451351166e+02 8.8054798543453217e+01) (float-vector -2.4401199817657471e+02 -1.4566400647163391e+02 1.3305099308490753e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4669100344181061e+02 -1.4158399403095245e+02 8.6085997521877289e+01) (float-vector -2.4406300485134125e+02 -1.4565299451351166e+02 8.8054798543453217e+01) (float-vector -9.0257398784160614e+01 -9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -1.0974500328302383e+02 -9.2200003564357758e+01 -4.7232601791620255e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8263599425554276e+00 1.3815699517726898e+02 1.3707500696182251e+02) (float-vector -7.1046198718249798e+00 1.2771800160408020e+02 1.4689500629901886e+02) (float-vector -2.8765499591827393e+01 1.3763900101184845e+02 1.4970399439334869e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8263599425554276e+00 1.3815699517726898e+02 1.3707500696182251e+02) (float-vector -2.8765499591827393e+01 1.3763900101184845e+02 1.4970399439334869e+02) (float-vector -3.9288699626922607e+01 1.4657600224018097e+02 1.3688799738883972e+02) (float-vector -8.9549701660871506e+00 1.4317899942398071e+02 1.2546299397945404e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.1046198718249798e+00 1.2771800160408020e+02 1.4689500629901886e+02) (float-vector -7.8263599425554276e+00 1.3815699517726898e+02 1.3707500696182251e+02) (float-vector 5.3506200201809406e+00 1.2504500150680542e+02 1.1774999648332596e+02) (float-vector 5.3492598235607147e+00 1.1304000020027161e+02 1.3388399779796600e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3026298992335796e+00 -1.2327799946069717e+02 1.4792899787425995e+02) (float-vector -5.7004201225936413e+00 -1.1010099947452545e+02 1.5061999857425690e+02) (float-vector 5.3492598235607147e+00 -1.1304000020027161e+02 1.3388399779796600e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3026298992335796e+00 -1.2327799946069717e+02 1.4792899787425995e+02) (float-vector 5.3492598235607147e+00 -1.1304000020027161e+02 1.3388399779796600e+02) (float-vector 5.3495201282203197e+00 -1.2408000230789185e+02 1.2470400333404541e+02) (float-vector -6.5973801538348198e+00 -1.3950200378894806e+02 1.3395200669765472e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7004201225936413e+00 -1.1010099947452545e+02 1.5061999857425690e+02) (float-vector -5.3026298992335796e+00 -1.2327799946069717e+02 1.4792899787425995e+02) (float-vector -2.4126699194312096e+01 -1.2563100457191467e+02 1.5499299764633179e+02) (float-vector -1.1225599795579910e+01 -2.0882699638605118e+01 1.5430499613285065e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3886298537254333e+01 -1.4377200603485107e+02 1.4345000684261322e+02) (float-vector -2.7702599763870239e+01 -1.3563099503517151e+02 1.5122799575328827e+02) (float-vector -2.4126699194312096e+01 -1.2563100457191467e+02 1.5499299764633179e+02) (float-vector -5.3026298992335796e+00 -1.2327799946069717e+02 1.4792899787425995e+02) (float-vector -6.5973801538348198e+00 -1.3950200378894806e+02 1.3395200669765472e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4692100286483765e+02 -1.3815499842166901e+02 1.4327199757099152e+02) (float-vector -2.4377800524234772e+02 -1.3621599972248077e+02 1.4844599366188049e+02) (float-vector -2.2131800651550293e+02 -1.3686700165271759e+02 1.5036499500274658e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4377800524234772e+02 -1.3621599972248077e+02 1.4844599366188049e+02) (float-vector -2.4460500478744507e+02 -1.2658999860286713e+02 1.5278099477291107e+02) (float-vector -2.2131800651550293e+02 -1.3686700165271759e+02 1.5036499500274658e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4460500478744507e+02 -1.2658999860286713e+02 1.5278099477291107e+02) (float-vector -2.4377800524234772e+02 -1.3621599972248077e+02 1.4844599366188049e+02) (float-vector -2.4692100286483765e+02 -1.3815499842166901e+02 1.4327199757099152e+02) (float-vector -2.4765500426292419e+02 -1.2765899300575256e+02 1.4970700442790985e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01) (float-vector -2.1038100123405457e+01 -1.4347399771213531e+02 6.8339101970195770e+01) (float-vector -7.5973900966346264e+00 -1.4389599859714508e+02 8.5655301809310913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7943298965692520e+00 -1.4381299912929535e+02 1.2115500122308731e+02) (float-vector -7.5973900966346264e+00 -1.4389599859714508e+02 8.5655301809310913e+01) (float-vector -2.1038100123405457e+01 -1.4347399771213531e+02 6.8339101970195770e+01) (float-vector -5.7182300835847855e+01 -1.4769500494003296e+02 8.6644098162651062e+01) (float-vector -4.4208098202943802e+01 -1.4786699414253235e+02 1.3079600036144257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1038100123405457e+01 -1.4347399771213531e+02 6.8339101970195770e+01) (float-vector -5.4713902063667774e+00 -1.4066299796104431e+02 6.8006902933120728e+01) (float-vector -2.3598099127411842e+01 -9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -4.7663301229476929e+01 -9.5200002193450928e+01 -5.9251498430967331e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.0257398784160614e+01 -9.5200002193450928e+01 -5.8664400130510330e+01) (float-vector -2.4406300485134125e+02 -1.4565299451351166e+02 8.8054798543453217e+01) (float-vector -2.2175399959087372e+02 -1.4663499593734741e+02 8.4045700728893280e+01) (float-vector -5.7182300835847855e+01 -1.4769500494003296e+02 8.6644098162651062e+01) (float-vector -2.1038100123405457e+01 -1.4347399771213531e+02 6.8339101970195770e+01) (float-vector -4.7663301229476929e+01 -9.5200002193450928e+01 -5.9251498430967331e+01) (float-vector -6.8000003695487976e+01 -9.5200002193450928e+01 -6.1999998986721039e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01) (float-vector -2.3598099127411842e+01 9.5200002193450928e+01 -4.4011298567056656e+01) (float-vector -1.1385000310838223e+01 9.5200002193450928e+01 -2.5728400796651840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01) (float-vector -4.7663301229476929e+01 9.5200002193450928e+01 -5.9251498430967331e+01) (float-vector -2.3598099127411842e+01 9.5200002193450928e+01 -4.4011298567056656e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01) (float-vector -8.9549701660871506e+00 1.4317899942398071e+02 1.2546299397945404e+02) (float-vector -3.9288699626922607e+01 1.4657600224018097e+02 1.3688799738883972e+02) (float-vector -5.0645198673009872e+01 1.4749300479888916e+02 8.7385699152946472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.8000003695487976e+01 9.5200002193450928e+01 -6.1999998986721039e+01) (float-vector -4.7663301229476929e+01 9.5200002193450928e+01 -5.9251498430967331e+01) (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01) (float-vector -5.0645198673009872e+01 1.4749300479888916e+02 8.7385699152946472e+01) (float-vector -2.4381999671459198e+02 1.4573100209236145e+02 8.8323101401329041e+01) (float-vector -9.0257398784160614e+01 9.5200002193450928e+01 -5.8664400130510330e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01) (float-vector 5.3506200201809406e+00 1.2504500150680542e+02 1.1774999648332596e+02) (float-vector -7.8263599425554276e+00 1.3815699517726898e+02 1.3707500696182251e+02) (float-vector -8.9549701660871506e+00 1.4317899942398071e+02 1.2546299397945404e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1385000310838223e+01 9.5200002193450928e+01 -2.5728400796651840e+01) (float-vector -5.8684297837316990e+00 9.2200003564357758e+01 -8.0525502562522888e+00) (float-vector 5.3506200201809406e+00 1.2504500150680542e+02 1.1774999648332596e+02) (float-vector -7.0551298558712006e+00 1.4352099597454071e+02 7.0972502231597900e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "head_tilt_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_elbow_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 4.0000000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 0 25 24 0 2 25 24 174 0 174 175 0 0 175 1 23 24 25 25 28 23 25 17 28 2 17 25 12 33 24 23 12 24 24 33 174 12 32 33 174 33 32 174 179 175 174 32 179 175 176 1 175 179 176 176 179 177 177 179 178 179 32 178 29 32 12 178 32 29 177 178 115 115 178 29 29 30 31 30 29 12 29 150 116 29 31 150 115 29 116 115 116 104 104 177 115 116 102 104 116 105 102 116 106 105 150 106 116 150 107 106 31 112 150 150 112 107 106 107 108 105 106 108 107 112 162 162 356 107 107 356 108 35 112 31 112 34 162 35 34 112 34 35 30 35 31 30 36 34 37 37 34 30 34 36 162 92 30 12 92 37 30 36 37 39 88 37 92 39 37 88 4 91 92 4 92 12 88 92 93 91 93 92 40 39 88 88 89 40 88 93 89 89 93 94 94 93 91 3 91 4 3 94 91 94 3 100 100 342 94 342 343 94 94 344 89 343 344 94 100 99 86 86 101 100 3 99 100 101 342 100 86 99 97 97 99 3 86 87 83 86 97 87 83 101 86 85 101 83 85 168 101 101 168 342 83 84 85 83 87 84 84 341 85 87 326 84 341 84 326 329 341 327 341 326 327 329 85 341 326 325 327 325 326 95 96 326 87 326 96 95 328 329 327 331 327 325 328 327 331 95 324 325 331 325 324 95 96 60 60 324 95 60 96 61 96 87 61 59 60 61 59 71 60 71 324 60 340 331 324 69 324 71 340 324 69 70 71 59 69 71 70 65 69 68 68 69 70 338 340 69 65 338 69 338 339 340 339 331 340 336 339 338 336 331 339 330 328 331 330 331 336 330 336 332 332 372 330 330 372 375 375 381 330 330 381 328 328 381 377 328 377 329 377 381 380 381 376 380 376 381 375 375 372 376 380 376 382 382 376 383 376 384 383 376 374 384 372 374 376 383 384 337 338 383 337 382 383 338 384 374 385 335 384 385 337 384 335 335 336 337 337 336 338 67 338 65 173 338 67 173 382 338 65 66 67 20 173 67 20 67 66 65 68 66 21 66 68 20 66 21 21 68 22 22 68 70 20 21 13 13 21 11 21 22 11 22 18 11 22 70 18 18 70 5 70 59 5 11 18 12 18 4 12 5 4 18 8 11 6 6 11 12 8 13 11 23 6 12 6 7 8 7 6 23 7 9 8 9 13 8 10 9 7 23 26 7 7 26 10 28 26 23 26 16 27 28 16 26 10 26 19 26 27 19 19 20 10 10 20 9 20 13 9 19 173 20 27 172 19 19 172 173 16 64 27 27 64 172 172 382 173 64 382 172 62 63 64 15 62 64 15 64 16 63 382 64 63 380 382 62 72 63 72 56 63 379 380 63 56 379 63 72 62 15 57 72 73 57 56 72 14 73 72 14 72 15 56 57 58 58 379 56 73 181 57 57 182 58 181 182 57 1 73 14 180 181 73 180 73 1 2 1 14 14 15 2 1 176 170 170 180 1 170 181 180 168 169 170 170 169 181 365 168 170 177 365 170 170 176 177 169 168 171 171 168 85 342 168 365 169 171 183 169 183 181 183 171 184 184 181 183 181 184 182 171 368 184 368 182 184 182 368 371 182 379 58 371 379 182 368 171 370 371 368 370 370 378 371 371 378 379 378 380 379 377 378 370 377 380 378 369 370 171 369 377 370 329 377 369 329 369 85 85 369 171 366 365 177 342 365 366 177 367 366 342 366 343 366 367 343 104 367 177 357 367 104 343 367 344 344 367 345 345 367 357 102 103 104 103 357 104 102 105 103 105 357 103 355 357 105 345 357 354 354 357 355 89 345 90 89 344 345 354 90 345 89 90 40 90 127 40 127 90 161 90 354 161 38 39 40 38 40 42 42 40 127 127 161 126 42 127 126 126 161 123 161 354 123 126 123 125 42 126 125 38 42 43 42 125 43 123 124 125 43 125 159 159 125 124 123 354 124 159 124 160 124 353 160 354 353 124 160 43 159 43 44 38 44 43 167 167 43 160 353 352 160 160 352 167 354 356 353 353 356 352 355 356 354 108 356 355 358 356 162 352 356 358 167 352 166 352 350 166 352 358 350 166 44 167 149 148 166 148 44 166 166 350 149 122 148 149 149 350 122 44 148 49 122 49 148 44 49 38 38 49 47 49 121 120 122 121 49 47 49 120 350 351 122 122 351 121 121 117 120 121 349 117 121 351 349 120 117 119 47 120 119 117 118 119 117 349 348 117 348 118 349 361 348 351 361 349 350 360 351 360 361 351 350 359 360 350 358 359 360 359 114 114 361 360 109 359 110 359 358 110 114 359 109 110 358 162 109 110 111 162 36 110 110 36 111 109 113 114 111 128 109 109 128 113 36 45 111 111 45 128 36 39 45 41 45 39 41 128 45 113 128 129 128 41 129 113 129 114 114 129 130 129 131 130 129 41 131 39 38 41 38 163 41 41 163 131 130 131 132 131 163 132 130 361 114 132 361 130 132 133 134 132 163 133 362 361 132 134 362 132 163 38 133 134 133 135 133 136 135 133 38 136 363 362 134 135 363 134 347 362 363 348 362 347 348 361 362 137 363 135 137 364 363 363 364 347 135 136 137 46 136 38 136 46 137 137 46 138 138 364 137 46 47 48 46 38 47 138 46 139 46 48 139 138 139 140 140 364 138 140 139 141 139 142 141 139 48 142 140 193 192 141 193 140 192 364 140 141 142 143 143 193 141 151 143 142 55 151 142 55 142 48 151 152 143 195 193 143 152 195 143 153 152 151 55 54 151 54 153 151 48 54 55 51 54 48 54 51 153 153 154 152 153 155 154 153 51 155 152 202 195 154 202 152 154 197 202 155 197 154 51 146 155 199 197 155 146 199 155 196 197 198 197 199 198 196 202 197 195 202 196 195 196 194 196 389 194 198 227 196 227 389 196 199 200 198 200 227 198 199 201 200 146 201 199 80 200 79 79 200 201 234 227 200 80 234 200 79 201 75 75 201 203 145 201 146 145 203 201 74 79 75 79 78 80 78 79 74 74 75 76 75 203 76 76 203 147 147 203 145 144 145 146 144 147 145 156 146 51 156 144 146 157 147 144 51 144 156 144 50 157 50 144 51 157 158 147 147 346 76 158 346 147 50 53 157 157 53 158 48 50 51 48 53 50 48 52 53 158 53 164 53 52 164 164 346 158 164 52 165 347 346 164 165 347 164 47 52 48 47 119 52 165 52 118 118 52 119 348 347 165 118 348 165 347 364 346 204 364 192 206 364 204 346 364 206 192 187 191 192 193 187 191 204 192 188 191 187 191 188 190 190 204 191 188 187 186 188 189 190 186 388 188 388 189 188 189 204 190 205 204 189 189 388 205 388 494 205 388 390 494 389 388 186 389 390 388 185 186 187 185 389 186 194 389 185 227 390 389 227 391 390 494 390 495 390 391 495 226 391 227 226 392 391 391 392 495 494 495 493 493 495 492 495 496 492 495 392 496 233 392 226 233 393 392 392 393 496 492 496 491 496 497 491 393 394 496 496 394 497 225 393 233 225 394 393 225 233 217 217 233 226 221 225 217 221 232 225 232 394 225 232 395 394 394 395 497 231 232 221 231 395 232 231 396 395 497 395 396 229 231 221 229 396 231 229 397 396 497 396 498 396 397 498 224 229 214 214 229 221 224 397 229 224 398 397 498 397 398 498 489 490 490 497 498 489 498 499 498 398 499 228 398 224 228 399 398 398 399 499 489 499 486 486 499 487 499 400 487 499 399 400 230 399 228 230 400 399 210 228 212 212 228 224 210 230 228 223 230 210 223 400 230 223 401 400 487 400 442 442 400 401 222 223 210 222 235 223 235 401 223 235 402 401 401 402 442 487 442 402 279 402 235 279 403 402 402 444 487 402 484 444 402 403 484 222 279 235 220 222 210 220 279 222 209 220 210 209 278 220 220 278 277 277 279 220 208 209 210 208 210 212 209 486 278 209 489 486 208 489 209 277 278 276 278 444 276 486 444 278 486 487 444 443 444 445 444 484 445 276 444 443 275 276 274 276 275 277 276 443 274 273 274 272 275 274 273 274 443 272 282 273 283 283 273 284 275 273 282 273 271 284 272 271 273 281 275 282 282 406 281 282 407 406 283 407 282 283 408 407 284 408 283 284 271 313 284 409 408 313 409 284 446 408 450 450 408 451 446 407 408 408 409 451 406 407 446 281 406 405 445 406 446 445 405 406 280 405 404 281 405 280 404 405 445 443 445 446 484 404 445 312 404 403 280 404 312 484 403 404 280 275 281 312 275 280 279 277 312 312 277 275 312 403 279 446 447 443 448 447 446 448 446 450 272 447 448 272 443 447 449 448 450 268 448 449 272 448 268 450 451 449 451 452 449 449 452 269 268 449 269 268 269 270 271 268 270 271 272 268 270 269 285 285 269 286 269 267 286 269 452 267 271 270 313 313 270 314 314 270 285 313 410 409 314 410 313 314 411 410 285 411 314 451 410 411 451 409 410 285 412 411 451 411 453 411 412 453 451 453 452 453 454 452 453 456 454 453 412 456 287 412 285 287 413 412 412 413 456 455 454 456 456 457 455 456 414 457 456 413 414 288 413 287 288 414 413 285 286 287 287 286 288 286 266 288 288 266 315 315 414 288 315 415 414 414 415 457 315 266 289 289 415 315 266 264 265 267 264 266 266 265 289 286 267 266 289 265 290 289 416 415 290 416 289 457 415 416 290 417 416 457 416 460 416 417 460 290 265 291 291 417 290 291 418 417 417 418 460 265 262 291 291 262 316 316 418 291 316 419 418 460 418 419 316 262 317 317 419 316 317 420 419 460 419 462 419 420 462 262 259 317 317 259 318 318 420 317 318 421 420 462 420 464 420 421 464 318 259 319 319 421 318 319 422 421 421 422 464 464 463 462 464 465 463 466 465 464 464 422 466 320 422 319 320 423 422 422 423 466 259 257 319 319 257 320 320 257 321 321 423 320 321 424 423 423 424 466 467 465 466 469 467 466 466 424 469 292 424 321 292 425 424 424 425 469 257 255 321 321 255 292 292 253 293 292 255 253 293 425 292 293 426 425 425 426 469 293 253 294 294 426 293 294 427 426 469 426 472 426 427 472 294 253 295 295 427 294 295 428 427 472 427 428 471 470 472 473 471 472 469 472 470 472 428 473 296 428 295 296 429 428 428 429 473 295 250 296 253 250 295 296 250 297 297 429 296 297 430 429 429 430 473 297 249 298 250 249 297 298 430 297 250 251 248 253 251 250 248 249 250 252 251 253 255 252 253 251 471 248 251 470 471 252 470 251 248 247 249 248 471 247 474 471 473 247 471 474 246 247 245 247 246 249 247 474 245 473 488 474 474 488 476 245 474 476 473 430 488 488 432 476 430 431 488 488 431 432 475 476 477 476 432 477 245 476 242 242 476 475 478 475 477 478 479 475 242 475 241 475 479 241 432 433 477 433 434 477 477 434 478 322 433 432 300 433 322 300 434 433 301 434 300 301 435 434 434 435 478 300 244 301 322 244 300 299 246 322 322 246 244 322 432 299 298 249 299 249 246 299 299 431 298 299 432 431 244 246 245 244 245 242 242 241 243 242 243 244 241 240 239 241 239 243 241 479 240 244 243 302 302 243 239 301 244 302 302 239 303 302 435 301 302 436 435 303 436 302 303 239 304 303 437 436 304 437 303 478 436 480 478 435 436 436 437 480 304 438 437 437 438 480 304 238 305 304 239 238 305 438 304 305 439 438 480 438 439 305 238 306 306 439 305 306 440 439 480 439 482 439 440 482 306 307 308 306 238 307 308 440 306 308 441 440 482 440 441 482 483 481 483 482 485 481 480 482 482 441 485 481 483 236 236 483 237 483 485 237 480 481 479 479 481 236 479 478 480 240 479 236 236 237 238 239 240 236 239 236 238 237 307 238 308 307 309 307 237 309 309 441 308 310 311 309 309 237 310 386 441 309 311 386 309 485 441 387 387 441 386 385 374 386 386 374 387 334 386 311 385 386 334 310 334 311 310 333 334 334 333 335 335 385 334 332 333 323 335 333 336 323 333 310 332 336 333 323 372 332 237 323 310 237 485 323 323 485 373 323 373 372 372 373 374 387 374 373 373 485 387 298 431 430 470 468 469 252 468 470 468 467 469 254 467 468 254 468 252 254 252 255 254 255 256 256 467 254 256 465 467 257 256 255 257 258 256 258 465 256 463 465 258 259 258 257 260 258 259 260 463 258 461 462 463 260 461 463 261 260 262 262 260 259 261 461 260 461 459 462 261 459 461 459 460 462 459 458 460 263 458 459 263 459 261 263 261 262 263 262 265 264 263 265 264 458 263 457 458 455 460 458 457 264 455 458 267 454 264 264 454 455 452 454 267 211 489 208 211 490 489 211 208 212 213 211 214 214 211 212 213 490 211 213 491 490 491 497 490 213 221 216 214 221 213 216 491 213 212 224 214 216 492 491 215 216 217 216 221 217 215 492 216 215 493 492 215 218 219 215 217 218 219 493 215 217 226 218 81 219 218 226 227 218 218 227 81 207 219 81 207 205 219 205 493 219 205 494 493 207 206 205 205 206 204 81 206 207 76 206 74 74 206 77 77 206 81 76 346 206 74 77 78 77 81 78 78 82 80 78 81 82 81 227 82 82 227 234 80 82 234 187 194 185 193 194 187 193 195 194 108 355 105 17 2 15 15 16 17 17 16 28 3 4 5 5 59 3 59 98 3 3 98 97 61 98 59 97 98 61 87 97 61))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(-3.0777401733398438e+02 -1.3134599685668945e+01 -6.5277297973632812e+01 -3.0890899658203125e+02 -1.3436499595642090e+01 -6.6128204345703125e+01 -3.0848898315429688e+02 -1.2156300544738770e+01 -6.7489898681640625e+01 -3.0911199951171875e+02 1.3857300758361816e+01 -6.4911697387695312e+01 -3.0809301757812500e+02 1.2844799995422363e+01 -6.5707603454589844e+01 -3.0908700561523438e+02 1.2757599830627441e+01 -6.6488800048828125e+01 -3.0741598510742188e+02 9.1581697463989258e+00 -6.8030799865722656e+01 -3.0743200683593750e+02 1.1357699632644653e+00 -7.1250404357910156e+01 -3.0755200195312500e+02 6.5072202682495117e+00 -7.0113601684570312e+01 -3.0779098510742188e+02 2.5019598007202148e+00 -7.1824401855468750e+01 -3.0809701538085938e+02 -2.0749799907207489e-01 -7.2356399536132812e+01 -3.0816500854492188e+02 8.5131797790527344e+00 -6.9865798950195312e+01 -3.0747198486328125e+02 1.0998499870300293e+01 -6.6724700927734375e+01 -3.0827297973632812e+02 4.9361696243286133e+00 -7.1659202575683594e+01 -3.0936300659179688e+02 -1.2094099998474121e+01 -6.7727699279785156e+01 -3.0913400268554688e+02 -9.1547393798828125e+00 -7.0200500488281250e+01 -3.0874401855468750e+02 -6.5513200759887695e+00 -7.1458999633789062e+01 -3.0836199951171875e+02 -9.1352300643920898e+00 -6.9879196166992188e+01 -3.0874197387695312e+02 1.1201799392700195e+01 -6.8146102905273438e+01 -3.0879000854492188e+02 -1.4139299392700195e+00 -7.2730598449707031e+01 -3.0904000854492188e+02 2.7335000038146973e+00 -7.2548004150390625e+01 -3.0909698486328125e+02 7.0038099288940430e+00 -7.1157295227050781e+01 -3.0894198608398438e+02 9.6879901885986328e+00 -6.9464401245117188e+01 -3.0740200805664062e+02 -4.7992997169494629e+00 -7.0437599182128906e+01 -3.0740698242187500e+02 -1.1925900459289551e+01 -6.5268203735351562e+01 -3.0754199218750000e+02 -1.0028899192810059e+01 -6.8128196716308594e+01 -3.0764300537109375e+02 -3.2011201381683350e+00 -7.1543296813964844e+01 -3.0873999023437500e+02 -4.5607099533081055e+00 -7.2146598815917969e+01 -3.0766799926757812e+02 -7.0771799087524414e+00 -7.0274803161621094e+01 -3.0742098999023438e+02 -4.0183998107910156e+01 -2.1452301025390625e+01 -3.0740802001953125e+02 1.8708299636840820e+01 -5.4010398864746094e+01 -3.0740499877929688e+02 -4.3257698059082031e+01 -1.3750299453735352e+01 -3.0741500854492188e+02 -2.9230400085449219e+01 -3.8711601257324219e+01 -3.0740600585937500e+02 -2.5514999389648438e+01 -4.4172397613525391e+01 -3.0741400146484375e+02 -4.5253799438476562e+01 -4.6156997680664062e+00 -3.0740600585937500e+02 -4.4674900054931641e+01 -7.8494100570678711e+00 -3.0742199707031250e+02 -4.5557800292968750e+01 3.5076099634170532e-01 -3.0740499877929688e+02 2.5097099304199219e+01 -4.4168498992919922e+01 -3.0741598510742188e+02 -3.3958599090576172e+01 3.0300600051879883e+01 -3.0740499877929688e+02 3.2176597595214844e+01 -3.3281597137451172e+01 -3.0744998168945312e+02 3.9432296752929688e+01 -2.2251699447631836e+01 -3.0741198730468750e+02 -4.1484199523925781e+01 1.8899799346923828e+01 -3.0741198730468750e+02 4.2879398345947266e+01 -1.4098400115966797e+01 -3.0741198730468750e+02 4.5136501312255859e+01 1.5318800210952759e+00 -3.0742098999023438e+02 4.4420001983642578e+01 7.9844098091125488e+00 -3.0742098999023438e+02 -4.5176700592041016e+01 6.0076003074645996e+00 -3.0742898559570312e+02 -2.5960100173950195e+01 3.7390399932861328e+01 -3.0740698242187500e+02 3.8804298400878906e+01 2.2947500228881836e+01 -3.0742300415039062e+02 -2.0350599288940430e+01 4.0660400390625000e+01 -3.0744100952148438e+02 4.1471199035644531e+01 1.8096599578857422e+01 -3.0744201660156250e+02 1.8971099853515625e+01 4.1111499786376953e+01 -3.0743899536132812e+02 6.4790902137756348e+00 4.5011901855468750e+01 -3.0742199707031250e+02 3.0382699966430664e+01 3.3553501129150391e+01 -3.0742098999023438e+02 2.3900499343872070e+01 3.8426399230957031e+01 -3.0740698242187500e+02 -3.2556700706481934e+00 4.5163799285888672e+01 -3.0741500854492188e+02 -1.1377300262451172e+01 4.3868999481201172e+01 -3.5859600830078125e+02 -1.3454799652099609e+01 -6.8481994628906250e+01 -3.5388601684570312e+02 -1.5468100547790527e+01 -6.5511001586914062e+01 -3.5234698486328125e+02 -1.6868200302124023e+01 -6.4264602661132812e+01 -3.5443499755859375e+02 1.3684099197387695e+01 -6.6598602294921875e+01 -3.5399401855468750e+02 1.5269899368286133e+01 -6.5500900268554688e+01 -3.5230401611328125e+02 1.4861100196838379e+01 -6.4912399291992188e+01 -3.6257800292968750e+02 -9.4689502716064453e+00 -7.1070404052734375e+01 -3.6351498413085938e+02 -9.7013902664184570e+00 -7.1218902587890625e+01 -3.6643402099609375e+02 -6.4989299774169922e+00 -7.2667999267578125e+01 -3.6567300415039062e+02 7.3989400863647461e+00 -7.2280494689941406e+01 -3.6675302124023438e+02 5.4714498519897461e+00 -7.2886604309082031e+01 -3.6838299560546875e+02 3.2701199054718018e+00 -7.3509796142578125e+01 -3.6326000976562500e+02 8.5408201217651367e+00 -7.1418800354003906e+01 -3.6149902343750000e+02 1.0832900047302246e+01 -7.0171897888183594e+01 -3.5851800537109375e+02 1.1550499916076660e+01 -6.9113998413085938e+01 -3.5756701660156250e+02 1.3215299606323242e+01 -6.7858894348144531e+01 -3.5856198120117188e+02 -1.2248899459838867e+01 -6.8877502441406250e+01 -3.5362399291992188e+02 -1.4572899818420410e+01 -6.5986602783203125e+01 -3.3215399169921875e+02 1.8854499816894531e+01 4.2447299957275391e+01 -3.3194299316406250e+02 1.8209499359130859e+01 4.2786502838134766e+01 -3.3076599121093750e+02 1.9378999710083008e+01 4.2072097778320312e+01 -3.3310400390625000e+02 1.8581600189208984e+01 4.2796100616455078e+01 -3.3372302246093750e+02 1.7810300827026367e+01 4.3835201263427734e+01 -3.3273699951171875e+02 1.7163200378417969e+01 4.3541099548339844e+01 -3.3337597656250000e+02 1.6962299346923828e+01 4.4191402435302734e+01 -3.3442498779296875e+02 1.8235700607299805e+01 4.3574699401855469e+01 -3.3432598876953125e+02 1.7697399139404297e+01 4.4726799011230469e+01 -3.4774301147460938e+02 1.8175600051879883e+01 -5.9922401428222656e+01 -3.4804998779296875e+02 1.7838901519775391e+01 -6.0701099395751953e+01 -3.4911099243164062e+02 1.8299200057983398e+01 -5.9591598510742188e+01 -3.4516702270507812e+02 1.8209600448608398e+01 -5.9186801910400391e+01 -3.4721401977539062e+02 1.7738599777221680e+01 -6.0491302490234375e+01 -3.0757400512695312e+02 3.2320899963378906e+01 -3.3943897247314453e+01 -3.0815100097656250e+02 3.2863697052001953e+01 -3.3983497619628906e+01 -3.0825399780273438e+02 4.0041801452636719e+01 -2.2384601593017578e+01 -3.0829400634765625e+02 1.9851400375366211e+01 -5.4726398468017578e+01 -3.0767898559570312e+02 1.9353599548339844e+01 -5.4420398712158203e+01 -3.0805700683593750e+02 2.6207599639892578e+01 -4.4415397644042969e+01 -3.0867001342773438e+02 2.6212598800659180e+01 -4.4845600128173828e+01 -3.5283300781250000e+02 1.6793399810791016e+01 -6.4555198669433594e+01 -3.5049798583984375e+02 1.6825199127197266e+01 -6.2927700042724609e+01 -3.4785598754882812e+02 1.6576200485229492e+01 -6.1840900421142578e+01 -3.4867901611328125e+02 1.5935000419616699e+01 -6.2878101348876953e+01 -3.4561801147460938e+02 1.7464500427246094e+01 -6.0293102264404297e+01 -3.4386798095703125e+02 1.8472700119018555e+01 -5.8608699798583984e+01 -3.4826998901367188e+02 1.8573200225830078e+01 -5.8583499908447266e+01 -3.0819299316406250e+02 -4.1763801574707031e+01 -1.9733398437500000e+01 -3.0838299560546875e+02 -4.1694297790527344e+01 -1.9700300216674805e+01 -3.0812500000000000e+02 -4.0101402282714844e+01 -2.2917699813842773e+01 -3.0824700927734375e+02 -4.3250602722167969e+01 -1.6238700866699219e+01 -3.0817602539062500e+02 -4.4506698608398438e+01 -1.2482199668884277e+01 -3.0809500122070312e+02 -4.5701499938964844e+01 -6.9559502601623535e+00 -3.0840701293945312e+02 -4.5228897094726562e+01 -9.5398902893066406e+00 -3.0838998413085938e+02 -4.5056701660156250e+01 1.0309000015258789e+01 -3.0812002563476562e+02 -4.6162200927734375e+01 2.9047498703002930e+00 -3.0805700683593750e+02 -4.5832897186279297e+01 6.0392103195190430e+00 -3.0745501708984375e+02 -4.4646499633789062e+01 -9.3849601745605469e+00 -3.0809301757812500e+02 -4.4233200073242188e+01 1.3391500473022461e+01 -3.0833300781250000e+02 -4.3069602966308594e+01 1.6769901275634766e+01 -3.0762402343750000e+02 -3.9583000183105469e+01 -2.3136699676513672e+01 -3.0769299316406250e+02 -4.2237899780273438e+01 -1.8133899688720703e+01 -3.0824700927734375e+02 3.6868000030517578e+01 2.7290800094604492e+01 -3.0807800292968750e+02 3.3857902526855469e+01 3.0938400268554688e+01 -3.0751300048828125e+02 3.5660400390625000e+01 2.8093601226806641e+01 -3.0778399658203125e+02 3.9360698699951172e+01 2.3194198608398438e+01 -3.0814001464843750e+02 4.0897899627685547e+01 2.0673700332641602e+01 -3.0801000976562500e+02 4.2826099395751953e+01 1.6164800643920898e+01 -3.0814401245117188e+02 4.4010597229003906e+01 -1.2731200218200684e+01 -3.0808599853515625e+02 4.5339302062988281e+01 -6.5539102554321289e+00 -3.0751498413085938e+02 4.4803798675537109e+01 -6.9697399139404297e+00 -3.0771301269531250e+02 4.3850700378417969e+01 -1.2457099914550781e+01 -3.0769299316406250e+02 4.1736000061035156e+01 -1.8333799362182617e+01 -3.0765798950195312e+02 -4.4618400573730469e+01 1.1058099746704102e+01 -3.0787799072265625e+02 -4.2569202423095703e+01 1.7706501007080078e+01 -3.0831097412109375e+02 -4.0279399871826172e+01 2.2628599166870117e+01 -3.0787799072265625e+02 -3.9817699432373047e+01 2.3217798233032227e+01 -3.0807598876953125e+02 -3.7323299407958984e+01 2.7167100906372070e+01 -3.0787799072265625e+02 -3.4371799468994141e+01 3.0672998428344727e+01 -3.0826699829101562e+02 -3.3645999908447266e+01 3.1581300735473633e+01 -3.0822198486328125e+02 -2.9970899581909180e+01 3.5063098907470703e+01 -3.0769400024414062e+02 -2.9891500473022461e+01 3.4892002105712891e+01 -3.0813699340820312e+02 -2.7060499191284180e+01 3.7395099639892578e+01 -3.0808099365234375e+02 -2.3659000396728516e+01 3.9577201843261719e+01 -3.0787799072265625e+02 -1.9612800598144531e+01 4.1610900878906250e+01 -3.0826800537109375e+02 -2.0746101379394531e+01 4.1155498504638672e+01 -3.0830700683593750e+02 -1.5793800354003906e+01 4.3276298522949219e+01 -3.0772299194335938e+02 -1.3930999755859375e+01 4.3724800109863281e+01 -3.0828799438476562e+02 -1.0092300415039062e+01 4.4953102111816406e+01 -3.0769400024414062e+02 1.4874399185180664e+01 4.3229499816894531e+01 -3.0831201171875000e+02 1.5331399917602539e+01 4.3292499542236328e+01 -3.0823999023437500e+02 1.0043100357055664e+01 4.4881198883056641e+01 -3.0818600463867188e+02 1.9736099243164062e+01 4.1463298797607422e+01 -3.0760400390625000e+02 4.3666198730468750e+01 1.2865600585937500e+01 -3.0813198852539062e+02 4.4497402191162109e+01 1.0942899703979492e+01 -3.0767300415039062e+02 -4.4242198944091797e+01 -1.2444700241088867e+01 -3.0767300415039062e+02 -7.8517198562622070e+00 4.5116500854492188e+01 -3.0823800659179688e+02 -4.2098999023437500e+00 4.5862701416015625e+01 -3.0767300415039062e+02 -1.7433099746704102e+00 4.5733699798583984e+01 -3.0819897460937500e+02 -2.0546099543571472e-01 4.5991996765136719e+01 -3.0809301757812500e+02 3.7694799900054932e+00 4.5863201141357422e+01 -3.0767300415039062e+02 1.0446099281311035e+01 4.4502002716064453e+01 -3.0769299316406250e+02 1.9041101455688477e+01 4.1531700134277344e+01 -3.0805798339843750e+02 2.4656499862670898e+01 3.8725799560546875e+01 -3.0763302612304688e+02 4.5456001281738281e+01 -1.8482500314712524e+00 -3.0801202392578125e+02 4.5776401519775391e+01 -5.7509404420852661e-01 -3.0816500854492188e+02 4.1998798370361328e+01 -1.8322900772094727e+01 -3.0797601318359375e+02 -4.6123798370361328e+01 -2.6660602092742920e+00 -3.0752798461914062e+02 -3.7866397857666016e+01 2.5615299224853516e+01 -3.0813598632812500e+02 2.7676300048828125e+01 3.6631301879882812e+01 -3.0810800170898438e+02 3.1050199508666992e+01 3.3764102935791016e+01 -3.0809201049804688e+02 4.5208900451660156e+01 7.3699698448181152e+00 -3.0814901733398438e+02 4.5692298889160156e+01 3.5811200141906738e+00 -3.4827102661132812e+02 -1.8986000061035156e+01 -5.8587100982666016e+01 -3.4696002197265625e+02 -1.8689500808715820e+01 -5.9367500305175781e+01 -3.4395098876953125e+02 -1.8891601562500000e+01 -5.8606597900390625e+01 -3.4903799438476562e+02 -1.8719999313354492e+01 -5.9654899597167969e+01 -3.6821301269531250e+02 -3.9714002609252930e+00 -7.3439903259277344e+01 -3.6927600097656250e+02 -4.5407101511955261e-01 -7.3886093139648438e+01 -3.0763500976562500e+02 -1.9697200775146484e+01 -5.4375999450683594e+01 -3.0820700073242188e+02 -2.0227798461914062e+01 -5.4703498840332031e+01 -3.0895800781250000e+02 -2.0475500106811523e+01 -5.4843601226806641e+01 -3.0807800292968750e+02 -3.3128601074218750e+01 -3.4182899475097656e+01 -3.0754699707031250e+02 -3.2692001342773438e+01 -3.3916397094726562e+01 -3.0792098999023438e+02 -2.6554100036621094e+01 -4.4374099731445312e+01 -3.4772399902343750e+02 -1.6902200698852539e+01 -6.1953300476074219e+01 -3.4597702026367188e+02 -1.8262199401855469e+01 -5.9891998291015625e+01 -3.5014199829101562e+02 -1.7591299057006836e+01 -6.2514202117919922e+01 -3.4767199707031250e+02 -1.8533699035644531e+01 -6.0060501098632812e+01 -3.4787399291992188e+02 -1.8014799118041992e+01 -6.0907100677490234e+01 -3.3323800659179688e+02 -1.6956501007080078e+01 4.4100399017333984e+01 -3.3350698852539062e+02 -1.7769201278686523e+01 4.4073299407958984e+01 -3.3247900390625000e+02 -1.8208200454711914e+01 4.3171600341796875e+01 -3.3391101074218750e+02 -1.8348800659179688e+01 4.3821201324462891e+01 -3.3460400390625000e+02 -1.8654600143432617e+01 4.3688800811767578e+01 -3.3347299194335938e+02 -1.8920099258422852e+01 4.2938499450683594e+01 -3.3249899291992188e+02 -1.9155700683593750e+01 4.2557701110839844e+01 -3.3137197875976562e+02 -1.9332500457763672e+01 4.2344001770019531e+01 -3.3218499755859375e+02 -1.6045900344848633e+01 4.3667800903320312e+01 -3.3416900634765625e+02 -1.2080599784851074e+01 4.5518699645996094e+01 -3.3350198364257812e+02 -1.0269700050354004e+01 4.5406501770019531e+01 -3.3501199340820312e+02 -4.1414098739624023e+00 4.6716602325439453e+01 -3.3429400634765625e+02 1.1957200765609741e+00 4.6490402221679688e+01 -3.3515701293945312e+02 2.5081298351287842e+00 4.6905799865722656e+01 -3.3394400024414062e+02 6.2567696571350098e+00 4.6052898406982422e+01 -3.3425000000000000e+02 1.0697500228881836e+01 4.5649299621582031e+01 -3.3314300537109375e+02 1.2673500061035156e+01 4.4747299194335938e+01 -3.3402499389648438e+02 -4.1446199417114258e+00 4.6321102142333984e+01 -3.3204400634765625e+02 1.5467700004577637e+01 4.3734798431396484e+01 -3.3449398803710938e+02 -1.9191200256347656e+01 4.2539802551269531e+01 -3.3520199584960938e+02 -1.8714500427246094e+01 4.3705501556396484e+01 -3.3456399536132812e+02 1.8653598785400391e+01 4.2649997711181641e+01 -3.3523498535156250e+02 1.8298999786376953e+01 4.3706996917724609e+01 -3.8721401977539062e+02 1.8290000915527344e+01 7.7091094970703125e+01 -3.9599902343750000e+02 1.8284700393676758e+01 7.8107994079589844e+01 -3.8734600830078125e+02 1.8068399429321289e+01 7.8080902099609375e+01 -3.7617001342773438e+02 1.8292701721191406e+01 7.4457603454589844e+01 -3.7788500976562500e+02 1.8144300460815430e+01 7.5767601013183594e+01 -3.6544601440429688e+02 1.8303298950195312e+01 7.0070404052734375e+01 -3.6853298950195312e+02 1.8120000839233398e+01 7.2395896911621094e+01 -3.4531301879882812e+02 1.8287399291992188e+01 5.5944400787353516e+01 -3.5517599487304688e+02 1.8292200088500977e+01 6.4084800720214844e+01 -3.5038198852539062e+02 1.8053300857543945e+01 6.1640399932861328e+01 -3.4179602050781250e+02 1.8168498992919922e+01 5.3178798675537109e+01 -3.4013699340820312e+02 1.8287099838256836e+01 5.0232299804687500e+01 -3.9900399780273438e+02 1.8168498992919922e+01 7.8731002807617188e+01 -3.6017401123046875e+02 1.7912700653076172e+01 6.8588897705078125e+01 -3.9898498535156250e+02 1.7538400650024414e+01 7.9622596740722656e+01 -3.9168499755859375e+02 1.7084300994873047e+01 7.9478599548339844e+01 -3.7383499145507812e+02 1.7084199905395508e+01 7.5507400512695312e+01 -3.5231799316406250e+02 1.7084199905395508e+01 6.4128303527832031e+01 -3.4293197631835938e+02 1.7054698944091797e+01 5.5967098236083984e+01 -3.3875799560546875e+02 1.7049900054931641e+01 5.1370899200439453e+01 -3.7952600097656250e+02 1.6897600173950195e+01 7.7291801452636719e+01 -3.6826000976562500e+02 1.6897600173950195e+01 7.3387603759765625e+01 -3.8570800781250000e+02 1.6744098663330078e+01 7.8688400268554688e+01 -3.6261199951171875e+02 1.6741199493408203e+01 7.0699806213378906e+01 -3.5732098388671875e+02 1.6741300582885742e+01 6.7637298583984375e+01 -3.4757998657226562e+02 1.6744098663330078e+01 6.0400699615478516e+01 -3.3517797851562500e+02 1.6757200241088867e+01 4.6834201812744141e+01 -3.9879501342773438e+02 1.6576099395751953e+01 8.0004699707031250e+01 -4.2094998168945312e+02 1.8291500091552734e+01 -7.5274993896484375e+01 -4.0897799682617188e+02 1.8295400619506836e+01 -7.7713806152343750e+01 -4.2165100097656250e+02 1.8046300888061523e+01 -7.6108406066894531e+01 -4.3368301391601562e+02 1.8066799163818359e+01 -7.1555999755859375e+01 -4.2932702636718750e+02 1.8287300109863281e+01 -7.2365295410156250e+01 -4.3791897583007812e+02 1.8290798187255859e+01 -6.8337295532226562e+01 -4.4704397583007812e+02 1.8278900146484375e+01 -6.2438201904296875e+01 -4.4024899291992188e+02 1.8168300628662109e+01 -6.7702400207519531e+01 -4.4796099853515625e+02 1.8041198730468750e+01 -6.2948001861572266e+01 -4.5348999023437500e+02 1.8277698516845703e+01 -5.7003299713134766e+01 -4.5680697631835938e+02 1.8154699325561523e+01 -5.4654502868652344e+01 -4.6027499389648438e+02 1.8282400131225586e+01 -4.9837200164794922e+01 -4.6683300781250000e+02 1.8287698745727539e+01 -4.0520103454589844e+01 -4.6470700073242188e+02 1.8049100875854492e+01 -4.5531898498535156e+01 -4.7021401977539062e+02 1.8066299438476562e+01 -3.6398101806640625e+01 -4.7110098266601562e+02 1.8283401489257812e+01 -3.2272499084472656e+01 -4.7480700683593750e+02 1.8290100097656250e+01 -2.2567701339721680e+01 -4.7583099365234375e+02 1.8067600250244141e+01 -2.2465700149536133e+01 -4.7704199218750000e+02 1.8281299591064453e+01 -1.3000800132751465e+01 -4.7790301513671875e+02 1.8165199279785156e+01 -1.2031899452209473e+01 -4.7798098754882812e+02 1.8273700714111328e+01 -5.7238497734069824e+00 -4.7882901000976562e+02 1.8164100646972656e+01 -5.2798201795667410e-04 -4.7809402465820312e+02 1.8276599884033203e+01 4.5136198997497559e+00 -4.7790399169921875e+02 1.8164800643920898e+01 1.2033299446105957e+01 -4.7691400146484375e+02 1.8280700683593750e+01 1.3716400146484375e+01 -4.7501300048828125e+02 1.8284099578857422e+01 2.1749601364135742e+01 -4.7514599609375000e+02 1.8169099807739258e+01 2.3780899047851562e+01 -4.7216400146484375e+02 1.8283599853515625e+01 2.9905300140380859e+01 -4.6688000488281250e+02 1.8285699844360352e+01 4.0490501403808594e+01 -4.7151101684570312e+02 1.8066799163818359e+01 3.3777099609375000e+01 -4.6447500610351562e+02 1.8165500640869141e+01 4.5349098205566406e+01 -4.5992498779296875e+02 1.8283401489257812e+01 5.0233699798583984e+01 -4.4300100708007812e+02 1.8284999847412109e+01 6.5297401428222656e+01 -4.5292599487304688e+02 1.8295200347900391e+01 5.7614299774169922e+01 -4.4778601074218750e+02 1.8164899826049805e+01 6.2691398620605469e+01 -4.3764999389648438e+02 1.8164299011230469e+01 6.9231101989746094e+01 -4.3148898315429688e+02 1.8285301208496094e+01 7.1530799865722656e+01 -4.3383300781250000e+02 1.8088600158691406e+01 7.1476699829101562e+01 -4.2098001098632812e+02 1.8293498992919922e+01 7.5242805480957031e+01 -4.2165802001953125e+02 1.8046800613403320e+01 7.6105598449707031e+01 -4.1296197509765625e+02 1.8280200958251953e+01 7.7048698425292969e+01 -4.0994198608398438e+02 1.8170999526977539e+01 7.8157798767089844e+01 -4.0525601196289062e+02 1.8281599044799805e+01 7.7986595153808594e+01 -4.0576300048828125e+02 1.7215499877929688e+01 7.9685501098632812e+01 -4.1821499633789062e+02 1.6923200607299805e+01 7.7839599609375000e+01 -4.2405099487304688e+02 1.6744199752807617e+01 7.6272102355957031e+01 -4.2965899658203125e+02 1.7054698944091797e+01 7.4222198486328125e+01 -4.3548501586914062e+02 1.6741300582885742e+01 7.1671997070312500e+01 -4.4083499145507812e+02 1.7085000991821289e+01 6.8687294006347656e+01 -4.5565600585937500e+02 1.7215299606323242e+01 5.7318199157714844e+01 -4.5922299194335938e+02 1.7825801849365234e+01 5.2779399871826172e+01 -4.5969998168945312e+02 1.6764101028442383e+01 5.3204200744628906e+01 -4.6342300415039062e+02 1.7054698944091797e+01 4.8642601013183594e+01 -4.7020098876953125e+02 1.7085000991821289e+01 3.8174098968505859e+01 -4.7297900390625000e+02 1.6741300582885742e+01 3.2713699340820312e+01 -4.7530401611328125e+02 1.7054698944091797e+01 2.6794898986816406e+01 -4.7842098999023438e+02 1.7054698944091797e+01 -1.5449600219726562e+01 -4.7710897827148438e+02 1.6763999938964844e+01 -2.1189800262451172e+01 -4.7530401611328125e+02 1.7054698944091797e+01 -2.6794898986816406e+01 -4.7303198242187500e+02 1.7054698944091797e+01 -3.2480796813964844e+01 -4.7025997924804688e+02 1.6741300582885742e+01 -3.8204200744628906e+01 -4.6707299804687500e+02 1.7085000991821289e+01 -4.3435901641845703e+01 -4.6365298461914062e+02 1.6744199752807617e+01 -4.8416801452636719e+01 -4.5951397705078125e+02 1.7054698944091797e+01 -5.3354801177978516e+01 -4.5084100341796875e+02 1.7085000991821289e+01 -6.1648799896240234e+01 -4.4601300048828125e+02 1.6740600585937500e+01 -6.5413101196289062e+01 -4.4064199829101562e+02 1.7054698944091797e+01 -6.8824798583984375e+01 -4.3548300170898438e+02 1.6763999938964844e+01 -7.1663696289062500e+01 -4.3009799194335938e+02 1.7054698944091797e+01 -7.4045501708984375e+01 -4.2405099487304688e+02 1.6744199752807617e+01 -7.6272102355957031e+01 -4.1821499633789062e+02 1.6923200607299805e+01 -7.7839599609375000e+01 -4.1209097290039062e+02 1.7950599670410156e+01 -7.8277000427246094e+01 -4.1229000854492188e+02 1.6744098663330078e+01 -7.9024398803710938e+01 -4.0575701904296875e+02 1.7215600967407227e+01 -7.9686004638671875e+01 -3.9849099731445312e+02 1.7926599502563477e+01 -7.9246696472167969e+01 -3.9871600341796875e+02 1.6813098907470703e+01 -7.9975097656250000e+01 -4.1196798706054688e+02 1.7054698944091797e+01 7.9027694702148438e+01 -4.4579101562500000e+02 1.7054698944091797e+01 6.5511802673339844e+01 -4.5103601074218750e+02 1.7054698944091797e+01 6.1513599395751953e+01 -4.6721801757812500e+02 1.7054698944091797e+01 4.3248199462890625e+01 -4.7713400268554688e+02 1.7054698944091797e+01 2.0951799392700195e+01 -4.7844699096679688e+02 1.7085000991821289e+01 1.5213900566101074e+01 -4.7937399291992188e+02 1.7054698944091797e+01 9.4011602401733398e+00 -4.7987899780273438e+02 1.7054698944091797e+01 2.8254101276397705e+00 -4.7985000610351562e+02 1.7085000991821289e+01 -3.0607199668884277e+00 -4.7942797851562500e+02 1.7054698944091797e+01 -8.9317598342895508e+00 -4.5514398193359375e+02 1.7215299606323242e+01 -5.7811000823974609e+01 -3.9442599487304688e+02 1.8301601409912109e+01 -7.8043106079101562e+01 -3.5790698242187500e+02 1.6792699813842773e+01 -6.8023300170898438e+01 -3.5752801513671875e+02 1.7446399688720703e+01 -6.7453102111816406e+01 -3.5088000488281250e+02 1.7737901687622070e+01 -6.2550903320312500e+01 -3.5763299560546875e+02 1.8135799407958984e+01 -6.6536399841308594e+01 -3.6277600097656250e+02 1.8297700881958008e+01 -6.8711898803710938e+01 -3.5451300048828125e+02 1.8288700103759766e+01 -6.3541004180908203e+01 -3.7331100463867188e+02 1.8294300079345703e+01 -7.3417098999023438e+01 -3.6757299804687500e+02 1.8056100845336914e+01 -7.2166702270507812e+01 -3.8293200683593750e+02 1.8290498733520508e+01 -7.6239494323730469e+01 -3.8948800659179688e+02 1.8055500030517578e+01 -7.8417602539062500e+01 -3.9138601684570312e+02 1.6765199661254883e+01 -7.9503402709960938e+01 -3.8602600097656250e+02 1.6900299072265625e+01 -7.8726203918457031e+01 -3.7918402099609375e+02 1.8003599166870117e+01 -7.6385803222656250e+01 -3.8040399169921875e+02 1.6742900848388672e+01 -7.7538902282714844e+01 -3.7243499755859375e+02 1.6814300537109375e+01 -7.5100105285644531e+01 -3.7253399658203125e+02 1.7564399719238281e+01 -7.4712501525878906e+01 -3.6470898437500000e+02 1.6744098663330078e+01 -7.1768600463867188e+01 -3.4902502441406250e+02 1.8247001647949219e+01 -6.0278999328613281e+01 -3.4214898681640625e+02 2.2111900329589844e+01 -5.2632400512695312e+01 -3.3367401123046875e+02 2.8810699462890625e+01 -4.1474597930908203e+01 -3.2832299804687500e+02 3.5164798736572266e+01 -3.0980701446533203e+01 -3.2546899414062500e+02 3.9781002044677734e+01 -2.3407499313354492e+01 -3.3303399658203125e+02 2.3119001388549805e+01 4.0198699951171875e+01 -3.3004400634765625e+02 3.0693899154663086e+01 3.4748497009277344e+01 -3.2680999755859375e+02 3.7340202331542969e+01 2.7238300323486328e+01 -3.2473498535156250e+02 4.1168701171875000e+01 2.0895099639892578e+01 -3.2234698486328125e+02 4.5231597900390625e+01 8.9706306457519531e+00 -3.2343301391601562e+02 4.3421802520751953e+01 1.5444099426269531e+01 -3.2183599853515625e+02 4.6051799774169922e+01 1.7238899469375610e+00 -3.2202801513671875e+02 4.5745700836181641e+01 -5.8653898239135742e+00 -3.2339199829101562e+02 4.3496200561523438e+01 -1.5415699958801270e+01 -3.2300000000000000e+02 -4.4564998626708984e+01 -1.3251200675964355e+01 -3.2201000976562500e+02 -4.6191200256347656e+01 -5.6455097198486328e+00 -3.2467300415039062e+02 -4.1689498901367188e+01 -2.0746400833129883e+01 -3.2184600830078125e+02 -4.6448497772216797e+01 2.2471199035644531e+00 -3.2236001586914062e+02 -4.5622901916503906e+01 8.9496297836303711e+00 -3.2347900390625000e+02 -4.3757202148437500e+01 1.5668200492858887e+01 -3.2478698730468750e+02 -4.1491600036621094e+01 2.1054599761962891e+01 -3.2729299926757812e+02 -3.6815299987792969e+01 2.8473800659179688e+01 -3.2988598632812500e+02 -3.1410701751708984e+01 3.4375297546386719e+01 -3.3240197753906250e+02 -2.5392400741577148e+01 3.9142501831054688e+01 -3.4323599243164062e+02 -2.1857301712036133e+01 -5.3755699157714844e+01 -3.3589898681640625e+02 -2.7210300445556641e+01 -4.4820899963378906e+01 -3.2866098022460938e+02 -3.4986400604248047e+01 -3.1955301284790039e+01 -3.4869000244140625e+02 -1.8358900070190430e+01 -6.0926799774169922e+01 -3.5226101684570312e+02 -1.8713901519775391e+01 -6.1846698760986328e+01 -3.5241299438476562e+02 -1.8509799957275391e+01 -6.2945297241210938e+01 -3.5211700439453125e+02 -1.7899900436401367e+01 -6.3648300170898438e+01 -3.8156597900390625e+02 -1.8708999633789062e+01 -7.5953102111816406e+01 -3.9468899536132812e+02 -1.8728399276733398e+01 -7.8057601928710938e+01 -3.8872097778320312e+02 -1.8487998962402344e+01 -7.8286697387695312e+01 -3.7328698730468750e+02 -1.8710401535034180e+01 -7.3361396789550781e+01 -3.7615600585937500e+02 -1.8470899581909180e+01 -7.5448600769042969e+01 -3.5934201049804688e+02 -1.8747900009155273e+01 -6.6779701232910156e+01 -3.5904397583007812e+02 -1.7999399185180664e+01 -6.8277801513671875e+01 -3.5919299316406250e+02 -1.7031999588012695e+01 -6.8844306945800781e+01 -3.6671899414062500e+02 -1.7667098999023438e+01 -7.2603500366210938e+01 -3.6608599853515625e+02 -1.8735300064086914e+01 -7.0381599426269531e+01 -3.7212698364257812e+02 -1.7319099426269531e+01 -7.4940002441406250e+01 -3.7821398925781250e+02 -1.7167600631713867e+01 -7.6949501037597656e+01 -3.8414401245117188e+02 -1.7506401062011719e+01 -7.8320396423339844e+01 -3.9012899780273438e+02 -1.7166700363159180e+01 -7.9362800598144531e+01 -3.9835501098632812e+02 -1.7237701416015625e+01 -7.9969894409179688e+01 -3.9829098510742188e+02 -1.8202899932861328e+01 -7.9377304077148438e+01 -3.3436599731445312e+02 -1.8178800582885742e+01 4.4697898864746094e+01 -3.3517700195312500e+02 -1.7168001174926758e+01 4.6834899902343750e+01 -3.3898898315429688e+02 -1.7501399993896484e+01 5.1609699249267578e+01 -3.4293099975585938e+02 -1.7471799850463867e+01 5.5965698242187500e+01 -3.4772399902343750e+02 -1.7471799850463867e+01 6.0466598510742188e+01 -3.5231900024414062e+02 -1.7501399993896484e+01 6.4127899169921875e+01 -3.5714797973632812e+02 -1.7471799850463867e+01 6.7473701477050781e+01 -3.6242602539062500e+02 -1.7471799850463867e+01 7.0549301147460938e+01 -3.6847399902343750e+02 -1.7633001327514648e+01 7.3413696289062500e+01 -3.7383499145507812e+02 -1.7501399993896484e+01 7.5507003784179688e+01 -3.7934197998046875e+02 -1.7633001327514648e+01 7.7180000305175781e+01 -3.8577499389648438e+02 -1.7314300537109375e+01 7.8681495666503906e+01 -3.9168899536132812e+02 -1.7666399002075195e+01 7.9435401916503906e+01 -3.9880499267578125e+02 -1.6979700088500977e+01 8.0005302429199219e+01 -4.0575799560546875e+02 -1.7630599975585938e+01 7.9685897827148438e+01 -4.1212698364257812e+02 -1.7159198760986328e+01 7.9049598693847656e+01 -4.1821499633789062e+02 -1.7338199615478516e+01 7.7839599609375000e+01 -4.2405099487304688e+02 -1.7159198760986328e+01 7.6272102355957031e+01 -4.2965899658203125e+02 -1.7469699859619141e+01 7.4222198486328125e+01 -4.3548501586914062e+02 -1.7156299591064453e+01 7.1671997070312500e+01 -4.4083499145507812e+02 -1.7500000000000000e+01 6.8687294006347656e+01 -4.4601300048828125e+02 -1.7155601501464844e+01 6.5413101196289062e+01 -4.5103601074218750e+02 -1.7469699859619141e+01 6.1513599395751953e+01 -4.5565600585937500e+02 -1.7630298614501953e+01 5.7318199157714844e+01 -4.5965600585937500e+02 -1.7500000000000000e+01 5.3165397644042969e+01 -4.6355300903320312e+02 -1.7159198760986328e+01 4.8548099517822266e+01 -4.6721801757812500e+02 -1.7469699859619141e+01 4.3248199462890625e+01 -4.7025201416015625e+02 -1.7178998947143555e+01 3.8201999664306641e+01 -4.7283801269531250e+02 -1.7469699859619141e+01 3.2911800384521484e+01 -4.7530401611328125e+02 -1.7469699859619141e+01 2.6794898986816406e+01 -4.7713699340820312e+02 -1.7159198760986328e+01 2.1112098693847656e+01 -4.7844699096679688e+02 -1.7500000000000000e+01 1.5213900566101074e+01 -4.7937399291992188e+02 -1.7469699859619141e+01 9.4011602401733398e+00 -4.7987899780273438e+02 -1.7469699859619141e+01 2.8254101276397705e+00 -4.7985000610351562e+02 -1.7500000000000000e+01 -3.0607199668884277e+00 -4.7942797851562500e+02 -1.7469699859619141e+01 -8.9317502975463867e+00 -4.7842098999023438e+02 -1.7469699859619141e+01 -1.5449600219726562e+01 -4.7705200195312500e+02 -1.7500000000000000e+01 -2.1174398422241211e+01 -4.7530401611328125e+02 -1.7469699859619141e+01 -2.6794898986816406e+01 -4.7297702026367188e+02 -1.7155698776245117e+01 -3.2717498779296875e+01 -4.7010498046875000e+02 -1.7469699859619141e+01 -3.8390899658203125e+01 -4.6707299804687500e+02 -1.7500000000000000e+01 -4.3435901641845703e+01 -4.6371002197265625e+02 -1.7469699859619141e+01 -4.8266799926757812e+01 -4.5965002441406250e+02 -1.7159198760986328e+01 -5.3270599365234375e+01 -4.5514398193359375e+02 -1.7630298614501953e+01 -5.7811000823974609e+01 -4.5084100341796875e+02 -1.7500000000000000e+01 -6.1648799896240234e+01 -4.4579101562500000e+02 -1.7469699859619141e+01 -6.5511802673339844e+01 -4.4064199829101562e+02 -1.7469699859619141e+01 -6.8824798583984375e+01 -4.3543801879882812e+02 -1.7664300918579102e+01 -7.1572494506835938e+01 -4.3009799194335938e+02 -1.7469699859619141e+01 -7.4045501708984375e+01 -4.2405099487304688e+02 -1.7159198760986328e+01 -7.6272102355957031e+01 -4.1821499633789062e+02 -1.7338199615478516e+01 -7.7839599609375000e+01 -4.1229000854492188e+02 -1.7159198760986328e+01 -7.9024398803710938e+01 -4.0576199340820312e+02 -1.7630298614501953e+01 -7.9685699462890625e+01 -3.9886999511718750e+02 -1.7958600997924805e+01 7.9610900878906250e+01 -4.2094998168945312e+02 -1.8706501007080078e+01 7.5274993896484375e+01 -4.0897799682617188e+02 -1.8710401535034180e+01 7.7713699340820312e+01 -4.2165100097656250e+02 -1.8461299896240234e+01 7.6108299255371094e+01 -4.3368301391601562e+02 -1.8481800079345703e+01 7.1555999755859375e+01 -4.2932702636718750e+02 -1.8702301025390625e+01 7.2365295410156250e+01 -4.3791897583007812e+02 -1.8705801010131836e+01 6.8337295532226562e+01 -4.4704397583007812e+02 -1.8693899154663086e+01 6.2438201904296875e+01 -4.4024899291992188e+02 -1.8583299636840820e+01 6.7702400207519531e+01 -4.4796099853515625e+02 -1.8456199645996094e+01 6.2948001861572266e+01 -4.5348999023437500e+02 -1.8692699432373047e+01 5.7003299713134766e+01 -4.5680697631835938e+02 -1.8569700241088867e+01 5.4654502868652344e+01 -4.6027499389648438e+02 -1.8697399139404297e+01 4.9837200164794922e+01 -4.6683300781250000e+02 -1.8702701568603516e+01 4.0520000457763672e+01 -4.6470700073242188e+02 -1.8464099884033203e+01 4.5531898498535156e+01 -4.7021401977539062e+02 -1.8481298446655273e+01 3.6398101806640625e+01 -4.7110098266601562e+02 -1.8698400497436523e+01 3.2272499084472656e+01 -4.7480700683593750e+02 -1.8705099105834961e+01 2.2567701339721680e+01 -4.7583099365234375e+02 -1.8482599258422852e+01 2.2465700149536133e+01 -4.7704199218750000e+02 -1.8696300506591797e+01 1.3000800132751465e+01 -4.7790301513671875e+02 -1.8580200195312500e+01 1.2031899452209473e+01 -4.7798098754882812e+02 -1.8688699722290039e+01 5.7238402366638184e+00 -4.7882901000976562e+02 -1.8579099655151367e+01 5.1649397937580943e-04 -4.7809402465820312e+02 -1.8691598892211914e+01 -4.5136504173278809e+00 -4.7790399169921875e+02 -1.8579799652099609e+01 -1.2033299446105957e+01 -4.7691400146484375e+02 -1.8695701599121094e+01 -1.3716400146484375e+01 -4.7501300048828125e+02 -1.8699100494384766e+01 -2.1749601364135742e+01 -4.7514599609375000e+02 -1.8584199905395508e+01 -2.3780899047851562e+01 -4.7216400146484375e+02 -1.8698598861694336e+01 -2.9905300140380859e+01 -4.6688000488281250e+02 -1.8700700759887695e+01 -4.0490501403808594e+01 -4.7151101684570312e+02 -1.8481800079345703e+01 -3.3777099609375000e+01 -4.6447500610351562e+02 -1.8580600738525391e+01 -4.5349098205566406e+01 -4.5992498779296875e+02 -1.8698400497436523e+01 -5.0233699798583984e+01 -4.4300100708007812e+02 -1.8700099945068359e+01 -6.5297401428222656e+01 -4.5292599487304688e+02 -1.8710199356079102e+01 -5.7614299774169922e+01 -4.4778601074218750e+02 -1.8579900741577148e+01 -6.2691398620605469e+01 -4.3764999389648438e+02 -1.8579299926757812e+01 -6.9231101989746094e+01 -4.3148898315429688e+02 -1.8700401306152344e+01 -7.1530799865722656e+01 -4.2535400390625000e+02 -1.8483900070190430e+01 -7.4913398742675781e+01 -4.2098001098632812e+02 -1.8708499908447266e+01 -7.5242805480957031e+01 -4.1432897949218750e+02 -1.8464698791503906e+01 -7.7813903808593750e+01 -4.1296197509765625e+02 -1.8695199966430664e+01 -7.7048698425292969e+01 -4.1209097290039062e+02 -1.8365598678588867e+01 7.8277000427246094e+01 -4.0553097534179688e+02 -1.8722299575805664e+01 -7.7983497619628906e+01 -3.9549499511718750e+02 -1.8713500976562500e+01 7.8084098815917969e+01 -3.9929898071289062e+02 -1.8511899948120117e+01 7.8904701232910156e+01 -4.5922299194335938e+02 -1.8240800857543945e+01 -5.2779399871826172e+01 -3.8448901367187500e+02 -1.8707201004028320e+01 7.6625396728515625e+01 -3.7216101074218750e+02 -1.8709199905395508e+01 7.3030502319335938e+01 -3.6097399902343750e+02 -1.8706998825073242e+01 6.7708595275878906e+01 -3.5148901367187500e+02 -1.8700599670410156e+01 6.1335601806640625e+01 -3.4308901977539062e+02 -1.8699800491333008e+01 5.3666000366210938e+01 -3.3985998535156250e+02 -1.8588998794555664e+01 5.0872501373291016e+01 -3.4603399658203125e+02 -1.8586299896240234e+01 5.7465698242187500e+01 -3.5541598510742188e+02 -1.8587099075317383e+01 6.5012901306152344e+01 -3.6584201049804688e+02 -1.8586599349975586e+01 7.1023796081542969e+01 -3.7705697631835938e+02 -1.8586400985717773e+01 7.5398200988769531e+01 -3.8708499145507812e+02 -1.8545400619506836e+01 7.7871704101562500e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 33 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01) (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01) (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01) (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_elbow_flex_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_forearm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 3 1 0 2 4 0 0 756 3 0 702 709 702 0 4 706 756 0 709 706 0 1 3 698 698 3 737 3 756 737 737 756 698 756 759 698 759 756 705 705 756 706 636 634 706 706 709 636 706 634 705 636 10 528 634 636 528 10 636 9 636 709 9 528 527 634 527 635 634 634 635 705 527 528 374 528 529 374 10 529 528 527 374 526 526 635 527 637 635 526 635 637 704 704 705 635 374 373 526 526 373 523 523 637 526 638 637 523 704 637 638 703 704 638 703 705 704 759 705 762 703 762 705 703 641 710 703 638 641 762 703 760 710 760 703 524 638 523 524 641 638 520 640 641 520 641 524 710 641 640 523 521 524 524 521 520 520 518 517 520 521 518 517 640 520 519 640 517 642 640 519 710 640 642 517 518 519 518 386 519 518 521 378 386 518 378 523 373 521 521 373 378 373 377 378 380 386 378 378 377 380 372 373 374 373 372 377 372 379 377 377 379 380 386 380 387 379 389 380 380 389 387 372 384 379 384 385 379 389 379 385 389 390 387 389 489 390 389 345 489 345 389 385 387 388 386 387 390 388 390 391 388 488 391 390 390 489 488 514 388 515 516 388 514 388 391 515 388 516 386 519 386 516 522 519 516 516 514 522 514 639 522 514 643 639 515 643 514 522 639 642 522 642 519 708 639 643 642 639 708 515 644 643 708 643 644 644 707 708 710 642 708 757 710 708 707 757 708 515 691 644 644 691 707 690 691 623 515 623 691 691 690 707 689 690 622 622 690 623 690 689 711 690 711 707 622 623 620 530 623 515 530 620 623 515 391 530 620 530 490 490 530 391 491 620 490 619 620 491 621 620 619 622 620 621 621 689 622 619 499 621 499 500 621 621 631 689 500 631 621 496 619 491 499 619 496 497 499 496 497 500 499 497 498 500 498 630 500 631 500 630 497 492 495 498 497 495 497 496 492 348 349 496 492 496 349 348 496 491 345 344 348 344 349 348 491 489 348 489 345 348 344 350 349 350 492 349 344 345 346 227 350 344 344 347 227 446 447 344 344 453 454 454 347 344 447 453 344 446 344 346 345 396 346 346 396 446 448 447 446 396 531 446 446 531 448 394 396 393 393 396 392 392 396 345 531 396 394 395 531 394 531 534 448 395 534 531 383 382 394 382 395 394 383 394 393 393 392 384 384 383 393 384 392 345 345 385 384 376 384 372 376 383 384 381 382 383 381 383 376 381 525 382 525 7 382 382 7 395 375 381 376 375 529 381 529 525 381 376 372 375 374 375 372 374 529 375 525 529 10 10 8 525 7 525 8 10 9 8 7 8 5 9 5 8 709 5 9 5 6 7 6 5 709 6 709 702 6 646 532 7 6 532 6 701 646 702 701 6 701 702 692 702 4 749 702 749 692 646 701 692 647 532 646 646 692 647 532 533 7 532 647 533 7 533 395 533 534 395 533 647 534 647 648 578 647 578 534 693 648 647 693 647 692 448 534 451 534 578 451 578 579 572 451 578 572 645 579 578 578 648 645 648 693 645 694 693 696 693 694 645 693 750 696 692 750 693 645 694 695 694 696 697 694 697 695 785 696 750 792 696 785 696 792 697 749 750 692 749 743 750 743 785 750 743 780 785 785 791 792 785 780 791 792 794 697 791 794 792 780 815 791 820 794 791 791 835 820 815 835 791 780 814 815 835 815 836 815 814 836 820 835 841 841 835 836 794 820 817 820 841 817 841 842 817 842 841 843 841 836 847 849 841 847 841 849 843 814 837 836 836 837 847 847 848 849 837 838 847 847 838 848 814 813 837 813 838 837 838 813 812 838 812 839 848 838 839 848 850 849 851 850 848 848 839 851 812 834 839 839 834 851 851 831 850 851 840 831 851 834 811 811 840 851 809 811 834 812 816 834 809 834 816 810 811 808 808 811 809 811 831 840 811 810 831 807 831 810 808 807 810 808 809 786 786 807 808 786 787 788 788 795 786 809 787 786 807 786 795 787 789 788 790 789 787 787 809 790 788 789 755 755 795 788 765 795 755 713 795 765 807 795 734 734 795 713 753 754 755 789 753 755 754 765 755 753 789 790 781 790 809 790 781 753 753 781 754 745 754 781 745 764 754 754 764 765 744 745 736 745 781 736 763 764 745 744 763 745 712 764 763 712 765 764 712 763 707 707 763 758 763 744 758 736 741 744 741 758 744 740 757 758 740 758 741 757 707 758 711 712 707 689 712 711 688 689 631 712 689 688 633 688 631 712 688 713 713 688 734 633 734 688 629 631 630 633 631 629 629 687 633 633 687 731 633 731 734 776 734 731 776 807 734 687 733 731 775 776 731 733 775 731 775 807 776 775 803 807 803 831 807 774 775 733 775 802 803 774 802 775 732 733 678 687 678 733 774 733 732 730 774 732 768 774 730 774 804 802 768 804 774 676 730 732 732 678 676 665 730 676 721 730 665 768 730 721 772 768 721 806 804 768 772 806 768 806 824 804 804 824 832 832 802 804 798 806 772 823 824 806 798 823 806 830 824 823 830 850 824 824 850 832 832 833 802 832 846 833 850 846 832 802 831 803 802 833 831 833 846 831 846 850 831 849 850 830 849 830 819 849 819 845 843 849 845 818 819 799 799 819 827 819 818 845 830 827 819 844 843 845 818 844 845 843 844 842 793 844 818 793 842 844 793 818 799 799 800 766 766 793 799 799 827 800 827 828 800 827 830 828 766 800 771 769 800 796 771 800 769 800 828 796 828 829 796 828 830 829 770 796 797 769 796 770 796 830 797 796 829 830 769 770 727 769 727 729 771 769 729 672 727 675 727 726 675 672 729 727 770 726 727 672 671 729 728 729 671 771 729 728 671 672 673 673 672 670 670 672 675 670 675 668 675 726 668 670 668 593 673 670 590 590 670 593 668 669 593 668 726 669 590 593 591 593 24 591 669 24 593 589 590 591 589 594 590 594 673 590 592 591 23 591 24 13 592 589 591 23 591 13 13 24 20 662 20 24 24 669 662 11 12 13 14 11 13 13 20 14 12 23 13 21 23 12 23 21 592 21 12 17 17 12 11 11 14 15 15 17 11 14 660 15 14 666 660 14 662 666 20 662 14 15 16 17 18 16 15 15 660 661 15 661 18 660 663 661 666 667 660 660 667 663 666 722 667 666 723 722 662 723 666 667 718 663 722 718 667 663 664 661 718 719 663 663 719 664 661 664 18 664 665 18 664 720 665 719 720 664 719 772 720 719 718 773 773 772 719 767 773 718 722 767 718 773 798 772 767 805 773 773 805 798 720 772 721 665 720 721 18 665 19 665 676 19 18 19 16 16 19 25 25 19 597 19 681 597 676 681 19 681 676 678 681 678 597 25 597 596 596 597 677 597 680 677 597 678 680 678 679 680 678 687 679 679 677 680 466 677 604 596 677 466 677 679 604 596 595 25 596 466 595 462 466 461 595 466 462 466 599 461 466 604 599 604 603 599 603 604 605 679 605 604 679 687 605 605 606 603 683 606 605 605 687 683 600 599 603 603 601 600 601 603 606 461 599 598 598 599 600 600 469 598 600 601 602 600 602 469 601 682 685 601 685 602 606 682 601 683 682 606 682 683 684 684 685 682 613 685 684 613 617 685 686 685 617 602 685 686 686 618 602 602 618 469 618 686 617 613 616 617 617 616 614 614 618 617 469 618 614 609 610 614 614 616 609 615 614 610 615 469 614 608 616 612 608 609 616 616 613 612 478 609 608 476 609 478 476 610 609 476 611 610 611 615 610 470 615 611 615 470 469 467 469 470 598 469 467 467 470 468 468 470 611 475 611 476 474 611 475 468 611 474 474 475 335 476 335 475 474 335 332 332 471 474 471 468 474 52 335 48 336 48 335 52 332 335 476 336 335 52 38 332 38 333 332 333 471 332 471 472 468 333 472 471 325 333 38 325 473 333 473 472 333 468 472 314 472 473 314 467 468 465 468 318 465 314 318 468 313 195 314 314 195 196 314 196 318 314 473 313 206 302 318 207 206 318 196 207 318 302 465 318 464 465 302 464 467 465 598 467 464 461 464 312 312 464 302 464 461 598 206 194 302 302 193 312 302 194 193 108 193 194 108 194 114 194 206 114 61 107 108 114 61 108 108 191 193 107 191 108 61 191 107 61 192 191 192 309 191 191 309 193 190 192 61 190 309 192 308 309 190 308 193 309 189 190 61 190 189 304 304 308 190 308 305 310 304 305 308 308 310 193 304 189 303 303 305 304 109 189 61 109 188 189 303 189 188 303 188 204 303 306 305 204 307 303 307 306 303 59 188 109 113 188 59 204 188 113 61 59 109 59 61 60 61 114 60 114 115 116 60 114 116 206 207 114 114 207 115 115 195 116 115 196 195 207 196 115 195 197 116 116 197 60 313 197 195 60 197 198 197 313 198 198 313 205 313 473 205 198 110 60 198 205 110 110 205 199 205 315 199 317 315 205 205 473 317 317 473 325 324 315 317 317 325 324 315 316 200 199 315 200 316 315 324 199 200 111 110 199 111 201 111 200 200 202 201 200 254 202 254 200 316 110 111 62 62 111 59 111 112 59 111 201 112 58 110 62 60 110 58 62 59 58 58 59 60 112 113 59 112 201 113 113 201 203 204 113 203 201 202 203 203 202 204 204 202 307 463 306 307 463 307 415 307 202 415 306 311 305 306 463 311 311 312 310 305 311 310 312 311 463 193 310 312 312 463 459 459 461 312 459 460 461 460 459 560 459 463 560 461 460 462 560 561 460 460 587 462 561 587 460 562 563 560 560 563 561 560 463 562 463 415 562 562 416 565 415 416 562 562 565 563 561 563 564 563 566 564 563 565 568 568 566 563 565 416 569 569 570 565 568 565 570 568 573 571 573 568 649 566 568 571 568 570 649 570 569 652 649 570 652 559 569 416 653 652 569 569 559 653 650 649 652 650 652 651 653 651 652 573 649 576 649 650 576 574 650 651 576 650 574 574 651 292 651 550 292 549 651 653 550 651 549 549 653 559 547 544 549 550 549 545 551 547 549 549 544 545 551 549 559 292 550 545 544 536 545 418 545 536 418 417 545 417 292 545 544 547 536 418 536 419 419 536 535 535 536 546 546 536 547 418 259 417 418 419 259 257 293 417 417 259 257 293 292 417 257 259 100 100 259 167 167 259 260 419 260 259 99 257 100 258 257 99 257 258 293 98 99 100 98 100 166 100 167 166 167 260 166 260 261 166 419 422 260 261 260 422 166 103 98 166 261 103 103 261 262 420 421 261 420 261 422 421 262 261 422 419 535 422 535 420 539 420 535 420 539 421 423 262 421 421 538 423 539 538 421 539 535 540 538 539 542 540 542 539 546 540 535 541 542 540 543 541 540 548 543 540 540 546 548 546 547 548 411 548 547 548 407 543 407 548 411 407 406 543 543 406 541 406 407 408 408 407 405 405 407 248 409 248 407 411 409 407 411 412 409 547 412 411 551 412 547 409 412 410 412 413 410 412 414 413 414 412 551 246 248 409 409 410 246 410 247 246 251 247 410 410 413 251 414 250 413 413 250 251 247 251 158 158 251 250 157 246 247 157 247 158 157 248 246 157 158 153 153 155 157 155 248 157 159 160 158 158 160 153 159 158 250 159 250 163 414 163 250 160 159 163 160 154 153 154 160 156 160 163 156 153 154 155 154 152 155 152 248 155 154 156 152 156 150 152 150 156 162 156 163 164 164 165 156 156 165 162 150 151 152 150 161 151 162 243 150 150 243 161 165 243 162 164 253 165 256 165 253 402 243 165 256 402 165 164 252 253 163 252 164 253 254 256 254 253 252 316 256 254 256 316 402 403 243 402 401 403 402 316 401 402 316 324 323 401 316 323 400 401 322 322 401 323 401 400 403 322 323 35 35 323 324 35 324 37 324 325 37 34 33 35 35 47 34 35 37 47 35 33 322 37 53 47 53 34 47 36 37 38 37 36 53 325 38 37 36 34 53 38 42 36 42 34 36 52 42 38 51 42 52 42 40 34 40 42 51 48 51 52 48 40 51 39 40 41 41 40 48 34 40 39 41 48 334 48 336 334 49 39 41 41 334 337 41 337 49 49 50 39 34 39 50 50 122 34 50 49 122 49 212 122 49 331 212 49 337 338 338 331 49 337 358 338 334 477 337 477 358 337 331 338 358 331 330 212 330 331 357 331 358 357 363 364 358 364 357 358 477 479 358 479 363 358 357 362 330 365 362 357 365 357 364 363 237 364 236 365 364 364 237 236 237 363 339 363 479 339 340 339 479 480 340 479 477 480 479 74 339 127 74 237 339 339 340 127 76 236 237 76 237 74 74 75 76 75 236 76 75 74 77 126 74 127 126 128 74 74 128 77 127 217 126 127 340 217 217 128 126 77 128 29 341 128 342 128 341 29 128 217 342 217 340 480 342 217 480 481 342 480 483 341 342 483 342 481 29 341 30 484 30 341 484 341 483 481 482 483 482 484 483 480 607 481 607 482 481 607 480 477 477 608 607 608 612 607 607 612 482 482 485 484 482 612 485 484 485 486 486 30 484 613 486 485 485 612 613 486 487 28 30 486 28 486 502 487 502 486 684 613 684 486 487 26 28 343 487 371 343 26 487 502 371 487 26 27 28 27 30 28 80 26 343 27 26 80 343 241 80 241 343 371 241 371 370 370 371 502 81 241 242 79 241 81 80 241 79 370 242 241 77 80 79 77 27 80 79 78 77 81 78 79 81 238 78 242 238 81 367 242 370 238 242 367 624 370 502 370 624 367 238 367 368 503 368 367 624 503 367 78 238 239 368 239 238 366 239 368 368 369 366 503 501 368 368 501 369 503 507 501 624 627 503 627 507 503 501 507 506 507 511 506 627 632 507 632 512 507 507 512 511 624 628 627 495 632 627 495 627 628 632 495 494 494 512 632 511 512 493 493 512 494 493 494 492 494 495 492 495 628 498 628 624 626 630 628 626 628 630 498 625 626 624 625 629 626 626 629 630 624 502 625 502 684 625 684 683 625 683 629 625 683 687 629 492 350 354 493 492 354 218 350 227 218 219 350 219 351 350 350 351 354 227 224 226 226 218 227 347 224 227 224 222 223 226 224 223 347 222 224 225 226 223 225 218 226 132 223 221 133 223 132 223 222 221 223 133 225 146 221 222 347 234 222 222 234 146 144 69 221 221 146 144 69 131 221 132 221 131 145 144 146 146 234 145 144 145 143 70 144 143 69 144 70 69 70 55 55 131 69 64 131 55 132 131 64 55 63 64 63 132 64 63 133 132 66 63 55 66 134 63 225 133 63 134 225 63 55 65 66 65 135 66 135 134 66 225 134 218 135 228 134 228 218 134 130 135 65 135 130 228 55 71 65 65 129 130 71 129 65 218 130 219 219 130 220 130 218 228 130 129 220 149 129 71 129 149 220 220 149 235 220 235 351 220 351 219 73 149 71 73 138 149 138 235 149 138 230 235 235 230 351 351 352 353 351 353 354 351 230 352 136 229 230 138 136 230 230 229 352 136 138 73 72 73 71 72 136 73 72 137 136 136 137 229 54 72 71 54 137 72 54 71 55 54 55 56 56 68 54 54 68 137 68 147 137 147 229 137 56 67 68 139 68 140 67 140 68 139 147 68 55 57 56 57 67 56 55 70 67 67 57 55 140 67 142 142 67 143 70 143 67 140 141 139 142 141 140 142 181 141 143 234 142 142 234 181 145 234 143 178 234 289 181 234 178 347 289 234 290 178 289 454 453 289 454 289 347 453 457 289 289 457 290 290 444 439 290 439 288 288 178 290 290 457 444 453 458 457 457 458 580 444 457 580 444 443 439 580 443 444 439 440 284 443 440 439 439 284 288 430 440 443 441 430 443 443 580 441 441 580 458 430 441 294 445 441 574 574 441 575 294 441 445 441 458 575 291 445 292 294 445 291 574 292 445 574 575 576 576 575 577 575 456 577 575 458 456 577 573 576 573 577 455 455 577 456 455 456 453 456 458 453 447 455 453 452 455 447 452 573 455 571 573 452 447 449 452 452 449 571 448 449 447 450 449 448 450 571 449 571 450 572 566 571 572 451 450 448 451 572 450 579 567 572 572 567 566 564 566 567 567 659 655 567 655 564 579 659 567 716 659 579 716 579 645 655 659 656 659 716 714 659 714 656 655 656 654 564 655 561 561 655 654 656 658 654 714 715 656 658 656 715 716 747 714 714 747 748 748 715 714 716 645 747 747 751 752 645 751 747 747 793 748 752 794 747 747 794 793 766 715 748 748 793 766 794 817 793 817 842 793 697 794 752 697 752 751 695 697 751 695 751 645 766 717 715 717 766 771 717 657 715 717 728 657 717 771 728 658 715 657 654 657 588 654 658 657 657 674 588 657 728 674 674 728 671 588 674 673 673 674 671 586 588 583 583 588 594 654 588 586 594 588 673 561 654 586 582 586 583 587 561 586 586 582 587 581 582 583 585 581 583 585 583 594 589 585 594 592 585 589 21 585 592 581 585 21 462 581 21 581 462 584 581 584 582 584 587 582 587 584 462 22 462 21 595 462 22 17 22 21 595 22 17 595 17 25 25 17 16 291 292 293 293 184 291 184 294 291 258 184 293 182 184 99 184 258 99 184 182 294 294 183 295 182 183 294 295 430 294 105 182 99 183 182 105 98 105 99 98 183 105 98 186 183 295 183 296 186 296 183 296 430 295 429 430 296 429 433 430 433 440 430 296 186 297 297 429 296 185 186 98 297 186 185 187 298 297 187 297 185 428 429 297 298 428 297 102 185 98 102 187 185 104 187 102 104 264 187 187 301 298 264 301 187 298 299 300 301 299 298 298 300 428 264 424 301 301 424 299 106 263 264 106 264 104 263 424 264 101 104 102 101 106 104 98 101 102 103 101 98 103 106 101 103 262 106 106 262 263 262 424 263 423 424 262 423 299 424 537 423 538 423 537 434 423 434 299 555 538 542 555 537 538 555 542 556 556 554 555 555 554 537 542 541 557 542 557 556 557 552 556 556 552 554 404 552 557 541 408 557 408 404 557 406 408 541 408 405 404 403 404 245 405 245 404 403 553 404 404 553 552 552 553 554 553 398 554 553 403 398 403 244 243 403 245 244 403 400 398 161 243 244 161 244 245 161 245 151 151 245 152 245 249 152 152 249 248 248 249 405 405 249 245 398 321 320 397 398 320 398 399 321 398 400 399 554 398 397 321 33 320 33 321 322 399 322 321 320 33 319 319 397 320 31 32 33 33 34 31 33 32 319 46 319 32 46 269 319 269 276 319 276 397 319 45 46 32 32 31 45 45 31 34 43 44 45 44 46 45 45 34 43 269 46 44 209 44 117 117 44 43 209 269 44 43 34 117 34 118 117 118 209 117 118 208 209 209 270 267 209 208 270 267 269 209 118 34 119 118 210 208 119 210 118 270 208 274 208 210 274 270 271 272 267 270 272 274 271 270 267 268 269 272 268 267 268 273 269 268 437 436 437 268 272 268 436 273 273 276 269 300 273 436 300 276 273 300 436 435 436 437 435 435 437 432 432 437 438 272 438 437 435 432 428 435 428 300 299 434 300 434 276 300 537 276 434 558 276 537 537 554 558 554 397 558 276 558 397 428 425 429 428 432 425 425 426 427 429 425 427 432 431 425 425 431 426 427 433 429 426 442 427 427 442 433 431 285 426 426 285 442 432 438 431 431 282 285 431 279 282 438 279 431 281 285 282 281 286 285 286 442 285 442 440 433 442 286 440 283 286 281 286 283 284 440 286 284 174 283 281 174 175 283 283 175 284 287 288 284 175 287 284 175 177 287 287 177 288 175 174 84 92 175 84 90 177 175 175 92 90 84 174 173 174 281 173 84 173 85 173 176 85 176 173 281 280 176 281 280 281 282 85 176 87 176 172 87 280 172 176 85 82 84 85 87 82 82 83 84 86 82 87 82 86 83 84 83 90 83 91 90 83 86 91 90 92 84 91 97 90 90 97 177 86 95 91 91 95 97 97 95 178 178 288 97 97 288 177 96 95 86 178 95 181 181 95 96 93 96 86 93 168 96 179 181 96 179 96 277 96 168 277 179 180 181 141 181 180 179 277 180 168 278 277 278 275 277 277 275 233 180 277 233 180 232 141 233 232 180 141 231 139 141 232 231 265 232 266 266 232 233 265 231 232 266 233 275 275 274 266 274 211 266 216 266 211 216 265 266 274 275 271 274 210 211 120 211 119 211 210 119 120 216 211 215 216 121 121 216 120 215 265 216 34 120 119 121 120 34 123 121 34 123 215 121 214 215 123 265 215 326 214 326 215 124 123 34 124 214 123 34 125 124 122 125 34 125 213 124 213 214 124 122 212 125 212 213 125 214 213 328 213 329 328 213 212 330 213 330 329 214 328 327 359 327 328 328 360 359 328 329 360 329 361 360 330 362 329 329 362 361 508 360 361 359 360 509 509 360 508 362 505 361 361 505 508 365 501 362 501 504 362 362 504 505 506 505 504 506 511 505 505 511 508 511 509 508 511 513 509 493 513 511 513 354 509 354 513 493 353 509 354 509 353 510 510 353 352 359 509 510 352 359 510 352 229 355 355 359 352 359 355 327 229 356 355 355 356 326 327 355 326 148 229 147 148 356 229 231 356 148 326 356 265 265 356 231 214 327 326 139 231 148 148 147 139 501 506 504 501 365 369 366 369 365 365 236 366 240 239 366 240 366 236 75 240 236 239 240 78 78 240 75 77 78 75 29 27 77 29 30 27 275 272 271 272 275 278 438 272 278 168 169 278 171 279 278 278 169 170 278 170 171 279 438 278 94 168 93 169 168 94 89 169 94 89 170 169 88 170 89 88 171 170 87 88 89 87 89 86 89 93 86 89 94 93 87 171 88 87 172 171 171 172 280 279 171 280 280 282 279 322 399 400 477 478 608 334 478 477 336 478 334 336 476 478 254 252 255 255 202 254 255 252 163 255 163 414 255 415 202 415 255 416 255 414 416 416 414 551 551 559 416 805 826 798 798 826 823 767 801 805 805 822 825 805 825 826 801 822 805 830 826 825 830 823 826 825 822 830 801 821 822 822 821 830 770 797 801 770 801 767 797 821 801 830 821 797 723 767 722 770 767 724 723 724 767 770 724 726 662 724 725 669 724 662 726 724 669 725 724 723 725 723 662 713 765 712 761 757 739 739 757 740 710 757 761 738 761 739 738 760 761 761 760 710 738 739 736 740 736 739 736 740 741 698 735 736 736 1 698 1 736 2 736 742 743 743 2 736 738 736 735 736 781 782 736 779 742 736 782 779 743 4 2 743 742 780 4 743 749 779 780 742 777 778 779 779 778 780 779 783 777 782 783 779 781 784 782 784 783 782 783 812 777 784 812 783 812 813 777 777 813 778 813 814 778 778 814 780 816 812 784 781 816 784 809 816 781 735 698 746 746 760 735 735 760 738 698 699 700 746 698 700 698 759 699 746 762 760 700 762 746 699 759 700 700 759 762 488 489 490 490 489 491 490 391 488))
                   (list :vertices (let ((mat (make-matrix 852 3))) (fvector-replace (array-entity mat) #f(3.1503201293945312e+02 -2.6000200271606445e+01 3.1107799530029297e+01 3.1210299682617188e+02 -2.2538099288940430e+01 3.0156898498535156e+01 3.0351998901367188e+02 -2.2642599105834961e+01 2.6287000656127930e+01 3.2023300170898438e+02 -2.2628198623657227e+01 3.1645801544189453e+01 3.0166598510742188e+02 -2.6000000000000000e+01 2.4887201309204102e+01 3.1413900756835938e+02 -2.7637699127197266e+01 3.5655200958251953e+01 3.0485998535156250e+02 -2.7090000152587891e+01 3.2474300384521484e+01 3.0621401977539062e+02 -4.7460700988769531e+01 3.1538799285888672e+01 3.1489102172851562e+02 -4.6480598449707031e+01 3.4614997863769531e+01 3.2225601196289062e+02 -2.7598400115966797e+01 3.6376499176025391e+01 3.2470501708984375e+02 -4.6435901641845703e+01 3.5191402435302734e+01 3.4354098510742188e+02 5.5921497344970703e+01 -2.9861898422241211e+00 3.3653500366210938e+02 5.8014999389648438e+01 2.0056300163269043e+00 3.4594900512695312e+02 5.4418300628662109e+01 8.5914497375488281e+00 3.5430300903320312e+02 5.0840999603271484e+01 2.4503500461578369e+00 3.4914300537109375e+02 5.3070301055908203e+01 -9.2625198364257812e+00 3.3879400634765625e+02 5.4328502655029297e+01 -1.9524900436401367e+01 3.3256500244140625e+02 5.7484500885009766e+01 -1.3136400222778320e+01 3.4745999145507812e+02 5.0817501068115234e+01 -2.0239900588989258e+01 3.4122000122070312e+02 5.0550502777099609e+01 -2.6544099807739258e+01 3.5305801391601562e+02 5.0655601501464844e+01 9.6949996948242188e+00 3.2543600463867188e+02 5.9633899688720703e+01 2.3389501571655273e+00 3.2558102416992188e+02 5.8834701538085938e+01 -9.5504798889160156e+00 3.3411700439453125e+02 5.7560501098632812e+01 1.1150799751281738e+01 3.4844799804687500e+02 5.1167400360107422e+01 1.7657300949096680e+01 3.2238800048828125e+02 5.5477298736572266e+01 -2.7290700912475586e+01 1.9252600097656250e+02 1.0846799850463867e+01 -4.6685199737548828e+01 1.9210499572753906e+02 1.2420199394226074e+01 -4.2988899230957031e+01 1.9144400024414062e+02 1.3404799461364746e+01 -4.6701999664306641e+01 1.8877600097656250e+02 1.4924700736999512e+01 -4.2712902069091797e+01 1.8871900939941406e+02 1.5120499610900879e+01 -4.6546100616455078e+01 9.4099998474121094e+01 1.9113899230957031e+01 4.1929302215576172e+01 9.6000000000000000e+01 1.7761299133300781e+01 4.2602401733398438e+01 9.6000000000000000e+01 2.9828901290893555e+01 3.5211399078369141e+01 9.4099998474121094e+01 3.0099000930786133e+01 3.4966201782226562e+01 9.6000000000000000e+01 4.0535900115966797e+01 2.2388198852539062e+01 9.4099998474121094e+01 4.5999298095703125e+01 -2.5075099468231201e+00 9.6000000000000000e+01 4.5940299987792969e+01 5.3986601829528809e+00 9.6000000000000000e+01 4.5343101501464844e+01 -8.3319101333618164e+00 9.4099998474121094e+01 1.4253199577331543e+01 -4.3782497406005859e+01 9.4099998474121094e+01 2.4428400039672852e+01 -3.9134101867675781e+01 9.6000000000000000e+01 1.7903499603271484e+01 -4.2521900177001953e+01 9.4099998474121094e+01 4.3421199798583984e+01 -1.5967300415039062e+01 9.4099998474121094e+01 -2.5075199604034424e+00 4.5999298095703125e+01 9.6000000000000000e+01 -4.9403500556945801e+00 4.5868999481201172e+01 9.4099998474121094e+01 8.5027494430541992e+00 4.5290599822998047e+01 9.6000000000000000e+01 6.9224400520324707e+00 4.5515701293945312e+01 9.4099998474121094e+01 4.0428501129150391e+01 2.2525299072265625e+01 9.6000000000000000e+01 2.9708101272583008e+01 -3.5342102050781250e+01 9.6000000000000000e+01 0.0000000000000000e+00 -4.6383499145507812e+01 9.4099998474121094e+01 1.1513199806213379e+00 -4.6282897949218750e+01 9.4099998474121094e+01 3.5193202972412109e+01 -2.9797599792480469e+01 9.5999893188476562e+01 4.0535900115966797e+01 -2.2388198852539062e+01 9.4099998474121094e+01 4.5290599822998047e+01 8.5027494430541992e+00 1.1449799346923828e+02 -5.4985900878906250e+01 1.0246600210666656e-01 1.6139100646972656e+02 -5.4474498748779297e+01 1.5267199516296387e+01 1.1492399597167969e+02 -5.3801902770996094e+01 1.3189599990844727e+01 1.1827100372314453e+02 -5.3557197570800781e+01 1.5704700469970703e+01 1.1456500244140625e+02 5.4046398162841797e+01 1.1930899620056152e+01 1.6205101013183594e+02 5.4473098754882812e+01 1.5230500221252441e+01 1.1449799346923828e+02 5.4952899932861328e+01 -5.0631499290466309e-01 1.9848799133300781e+02 5.4588798522949219e+01 8.7717199325561523e+00 1.1737200164794922e+02 5.3428897857666016e+01 1.5774799346923828e+01 1.9834700012207031e+02 -5.4612098693847656e+01 9.9916105270385742e+00 1.9508399963378906e+02 -5.4600299835205078e+01 1.2764999389648438e+01 1.9543899536132812e+02 -5.4609500885009766e+01 -2.2776599884033203e+01 1.9847300720214844e+02 -5.4600101470947266e+01 -1.8770498275756836e+01 1.1801000213623047e+02 -5.6789100646972656e+01 1.6025999069213867e+01 1.1470700073242188e+02 -5.7083202362060547e+01 1.2998600006103516e+01 1.7906199645996094e+02 -5.8092697143554688e+01 1.4217900276184082e+01 1.5562300109863281e+02 -5.7344100952148438e+01 1.5327599525451660e+01 1.5060299682617188e+02 -5.4384201049804688e+01 -1.8485000610351562e+01 1.1496300506591797e+02 -5.3961399078369141e+01 -1.4977100372314453e+01 1.1815799713134766e+02 -5.3665199279785156e+01 -1.7477600097656250e+01 1.1450300598144531e+02 -4.6117700636386871e-02 -4.8416397094726562e+01 1.1806999969482422e+02 -1.4916299819946289e+01 -4.7087699890136719e+01 1.1481100463867188e+02 -1.2154200553894043e+01 -4.7796699523925781e+01 1.5903900146484375e+02 0.0000000000000000e+00 -4.5461200714111328e+01 1.6580801391601562e+02 -1.4999899864196777e+01 -4.3654399871826172e+01 1.9231800842285156e+02 -1.1470999717712402e+01 -4.3075698852539062e+01 1.9250000000000000e+02 -2.2548599168658257e-02 -4.4213298797607422e+01 1.9006599426269531e+02 -1.4576200485229492e+01 -4.2775798797607422e+01 1.4618598937988281e+02 -4.6352401733398438e+01 3.4799999237060547e+01 1.5291799926757812e+02 -4.7074199676513672e+01 3.1825901031494141e+01 1.5574400329589844e+02 -4.1765701293945312e+01 3.6404899597167969e+01 1.4334599304199219e+02 -4.1123699188232422e+01 4.4964298248291016e+01 1.4058599853515625e+02 -5.1456001281738281e+01 2.6736299514770508e+01 1.3604299926757812e+02 -4.1494602203369141e+01 4.7087501525878906e+01 1.1658799743652344e+02 -4.0450199127197266e+01 4.7407299041748047e+01 1.1505500030517578e+02 -4.1527198791503906e+01 4.5400001525878906e+01 1.6374301147460938e+02 -4.8115398406982422e+01 2.8495100021362305e+01 1.6200000000000000e+02 -5.0874900817871094e+01 2.6188699722290039e+01 1.6343598937988281e+02 -4.5519100189208984e+01 3.0637399673461914e+01 1.1663199615478516e+02 -5.0418296813964844e+01 2.7047800064086914e+01 1.1499900054931641e+02 -4.9221099853515625e+01 2.9731700897216797e+01 1.4397999572753906e+02 -5.6872497558593750e+01 2.6555898666381836e+01 1.1713100433349609e+02 -5.4999401092529297e+01 2.7023500442504883e+01 1.6224099731445312e+02 -5.6271602630615234e+01 2.6360898971557617e+01 1.6478900146484375e+02 -2.6097599029541016e+01 3.7846496582031250e+01 1.7602799987792969e+02 -2.2235900878906250e+01 3.0518098831176758e+01 1.7598100280761719e+02 2.2768199920654297e+01 3.0473800659179688e+01 1.3647599792480469e+02 3.0222597718238831e-01 6.0534999847412109e+01 1.3731401062011719e+02 -2.6060400009155273e+01 5.9662300109863281e+01 1.3678799438476562e+02 2.5955900192260742e+01 6.0024600982666016e+01 1.3419100952148438e+02 -2.2424900054931641e+01 6.1047599792480469e+01 1.7361399841308594e+02 -2.5739299774169922e+01 3.1662300109863281e+01 1.3419400024414062e+02 2.2285598754882812e+01 6.1078800201416016e+01 1.9844099426269531e+02 5.4599998474121094e+01 -1.8855800628662109e+01 1.9537701416015625e+02 5.4601799011230469e+01 -2.2832698822021484e+01 1.9622898864746094e+02 5.4599998474121094e+01 1.2469599723815918e+01 1.1460199737548828e+02 5.7295898437500000e+01 1.2719099998474121e+01 1.1741699981689453e+02 5.7041500091552734e+01 1.5914099693298340e+01 1.5520500183105469e+02 5.7338401794433594e+01 1.5354599952697754e+01 1.7483801269531250e+02 5.8720397949218750e+01 1.4711700439453125e+01 1.5269200134277344e+02 5.4454700469970703e+01 -1.8558200836181641e+01 1.1732300567626953e+02 5.3655899047851562e+01 -1.7380100250244141e+01 1.1462999725341797e+02 5.4087898254394531e+01 -1.3886399269104004e+01 9.4099998474121094e+01 -1.5967300415039062e+01 4.3421199798583984e+01 9.4099998474121094e+01 -2.9797599792480469e+01 3.5193202972412109e+01 9.4099998474121094e+01 -3.9889297485351562e+01 2.3322601318359375e+01 9.4099998474121094e+01 -4.5168601989746094e+01 9.3440008163452148e+00 9.4099998474121094e+01 -4.5733699798583984e+01 -6.4106898307800293e+00 9.4099998474121094e+01 -1.1184000015258789e+01 -4.4662700653076172e+01 9.4099998474121094e+01 -4.0859600067138672e+01 -2.1622798919677734e+01 9.4099998474121094e+01 -3.3650497436523438e+01 -3.1403099060058594e+01 9.4099998474121094e+01 -2.3322601318359375e+01 -3.9889297485351562e+01 1.1816299438476562e+02 1.4855200767517090e+01 -4.7273899078369141e+01 1.1470100402832031e+02 1.1991200447082520e+01 -4.7840801239013672e+01 1.4635099792480469e+02 1.4995599746704102e+01 -4.4941898345947266e+01 1.7382901000976562e+02 -5.7973701477050781e+01 -2.0439800262451172e+01 1.9407499694824219e+02 -5.8817600250244141e+01 -2.3077199935913086e+01 1.9486199951171875e+02 -5.8171699523925781e+01 1.2886500358581543e+01 1.9716000366210938e+02 -5.8459400177001953e+01 1.1561400413513184e+01 1.9854600524902344e+02 -5.8514698028564453e+01 9.3722000122070312e+00 1.9862799072265625e+02 -5.8520202636718750e+01 -1.8454799652099609e+01 1.9731600952148438e+02 -5.8183498382568359e+01 -2.1319400787353516e+01 1.1651899719238281e+02 -5.7500797271728516e+01 -1.6842800140380859e+01 1.1451300048828125e+02 -5.7821300506591797e+01 -1.4249500274658203e+01 1.1868499755859375e+02 -5.7057102203369141e+01 -1.7608499526977539e+01 1.1335899353027344e+02 -5.8828399658203125e+01 1.2669400215148926e+01 1.1621300506591797e+02 -5.7982097625732422e+01 1.6174900054931641e+01 1.1567399597167969e+02 -5.8013198852539062e+01 1.8026498794555664e+01 1.1936399841308594e+02 -5.8166198730468750e+01 1.7376100540161133e+01 1.4368099975585938e+02 -5.8733501434326172e+01 1.6344900131225586e+01 1.7113299560546875e+02 -5.8815399169921875e+01 1.5044799804687500e+01 1.5535899353027344e+02 -5.9240402221679688e+01 1.6519599914550781e+01 1.7652099609375000e+02 -5.9584598541259766e+01 1.6065599441528320e+01 1.1419599914550781e+02 -5.9047100067138672e+01 3.4203498363494873e+00 1.1299700164794922e+02 -6.0056499481201172e+01 3.0513799190521240e-01 1.4397599792480469e+02 -5.7933597564697266e+01 -1.8289299011230469e+01 1.1499800109863281e+02 4.9119201660156250e+01 2.9836200714111328e+01 1.1737900543212891e+02 4.0256103515625000e+01 4.7608100891113281e+01 1.3669100952148438e+02 4.1682003021240234e+01 4.6998500823974609e+01 1.5196800231933594e+02 4.4445598602294922e+01 3.5241500854492188e+01 1.4598300170898438e+02 4.6994800567626953e+01 3.3551200866699219e+01 1.4392500305175781e+02 4.1058399200439453e+01 4.4687698364257812e+01 1.4013198852539062e+02 5.1463203430175781e+01 2.6760999679565430e+01 1.5581500244140625e+02 4.1901699066162109e+01 3.6347999572753906e+01 1.6367100524902344e+02 4.5910499572753906e+01 3.0266199111938477e+01 1.6314999389648438e+02 4.9716899871826172e+01 2.7135099411010742e+01 1.6098300170898438e+02 5.0988903045654297e+01 2.6129699707031250e+01 1.1510100555419922e+02 4.1385597229003906e+01 4.5929698944091797e+01 1.1653900146484375e+02 5.0318599700927734e+01 2.7125000000000000e+01 1.6186499023437500e+02 5.6938999176025391e+01 2.6204700469970703e+01 1.3925099182128906e+02 5.5904399871826172e+01 2.6750699996948242e+01 1.1676499938964844e+02 5.4973300933837891e+01 2.7038900375366211e+01 1.6682400512695312e+02 2.6060499191284180e+01 3.6166198730468750e+01 1.7307099914550781e+02 2.5920801162719727e+01 3.1978599548339844e+01 1.1516399383544922e+02 -5.3939899444580078e+01 2.8469499588012695e+01 1.1497799682617188e+02 -4.5840999603271484e+01 4.5402698516845703e+01 1.1589299774169922e+02 -4.4332099914550781e+01 4.6953800201416016e+01 1.1770200347900391e+02 -4.3677898406982422e+01 4.7819499969482422e+01 1.3104000854492188e+02 -4.4282600402832031e+01 4.7534999847412109e+01 1.4513301086425781e+02 -4.4246799468994141e+01 4.4137500762939453e+01 1.5508399963378906e+02 -4.4877296447753906e+01 3.7028396606445312e+01 1.6315600585937500e+02 -4.9108402252197266e+01 3.1481500625610352e+01 1.4001699829101562e+02 -4.4498802185058594e+01 4.6318401336669922e+01 1.6388699340820312e+02 -5.2401302337646484e+01 2.9196201324462891e+01 1.6203799438476562e+02 -5.8043598175048828e+01 2.5633199691772461e+01 1.1688999938964844e+02 -5.5850101470947266e+01 2.6519300460815430e+01 1.1569000244140625e+02 -5.6270698547363281e+01 2.5694499969482422e+01 1.3211799621582031e+02 -5.7453598022460938e+01 2.5795801162719727e+01 1.7737699890136719e+02 -2.3623001098632812e+01 3.3894699096679688e+01 1.7473100280761719e+02 -2.6218099594116211e+01 3.5281200408935547e+01 1.7830799865722656e+02 -2.1005300521850586e+01 3.3996196746826172e+01 1.3838499450683594e+02 -2.6159000396728516e+01 6.3387401580810547e+01 1.5179100036621094e+02 -2.6269498825073242e+01 5.3216098785400391e+01 1.3513499450683594e+02 -2.3144298553466797e+01 6.4615196228027344e+01 1.9586299133300781e+02 5.8236400604248047e+01 1.2660900115966797e+01 1.9823199462890625e+02 5.8101200103759766e+01 9.8418502807617188e+00 1.9858999633789062e+02 5.8241600036621094e+01 7.8716797828674316e+00 1.9840599060058594e+02 5.7618396759033203e+01 -1.9005399703979492e+01 1.9850000000000000e+02 5.7599998474121094e+01 -6.5246300697326660e+00 1.9881199645996094e+02 5.8980499267578125e+01 -1.9598299026489258e+01 1.9508999633789062e+02 5.8171501159667969e+01 -2.2848899841308594e+01 1.1540699768066406e+02 5.7624599456787109e+01 -1.5771599769592285e+01 1.1814399719238281e+02 5.7377799987792969e+01 -1.7631599426269531e+01 1.1448300170898438e+02 5.7681900024414062e+01 -1.3678299903869629e+01 1.1443399810791016e+02 5.8665599822998047e+01 2.1728900074958801e-01 1.1334999847412109e+02 5.8832798004150391e+01 1.2717800140380859e+01 1.1672499847412109e+02 5.8079101562500000e+01 1.7532100677490234e+01 1.4245700073242188e+02 5.8542198181152344e+01 1.6263698577880859e+01 1.6257199096679688e+02 5.9422599792480469e+01 2.2507499694824219e+01 1.5482699584960938e+02 5.9303100585937500e+01 1.6978799819946289e+01 1.9343400573730469e+02 5.9557697296142578e+01 1.4360199928283691e+01 1.1329600524902344e+02 6.0008102416992188e+01 5.8001601696014404e-01 1.7371000671386719e+02 5.8520500183105469e+01 -2.0492799758911133e+01 1.4781199645996094e+02 5.8035797119140625e+01 -1.8449501037597656e+01 9.6000000000000000e+01 -2.7708499908447266e+01 3.6778301239013672e+01 9.6000000000000000e+01 -1.7761299133300781e+01 4.2602401733398438e+01 9.6000000000000000e+01 -3.6395900726318359e+01 2.8370899200439453e+01 9.6000000000000000e+01 -4.2124099731445312e+01 1.8687900543212891e+01 9.6000000000000000e+01 -1.7903499603271484e+01 -4.2521900177001953e+01 9.6000000000000000e+01 -2.9708101272583008e+01 -3.5342102050781250e+01 9.5999893188476562e+01 -4.0535900115966797e+01 -2.2388198852539062e+01 9.6000000000000000e+01 -4.5343101501464844e+01 -8.3319101333618164e+00 9.6000000000000000e+01 -4.5940299987792969e+01 5.3986601829528809e+00 1.1819200134277344e+02 1.5090000152587891e+01 -5.1031997680664062e+01 1.9961700439453125e+02 -5.9503398895263672e+01 -2.2906101226806641e+01 1.8115800476074219e+02 -5.9575901031494141e+01 -2.2798400878906250e+01 1.6956100463867188e+02 -5.9359100341796875e+01 -2.0833000183105469e+01 1.9509799194335938e+02 -5.9182701110839844e+01 1.3523900032043457e+01 1.9684100341796875e+02 -5.9584899902343750e+01 1.4392700195312500e+01 1.9956300354003906e+02 -5.9429401397705078e+01 1.0121399879455566e+01 2.0047900390625000e+02 -5.9599998474121094e+01 9.2174596786499023e+00 1.9882299804687500e+02 -5.8752399444580078e+01 -5.0170197486877441e+00 1.9970600891113281e+02 -5.9435798645019531e+01 -5.7206001281738281e+00 2.0048399353027344e+02 -5.9599998474121094e+01 -1.8691299438476562e+01 1.9762699890136719e+02 -5.9261798858642578e+01 -2.2142900466918945e+01 1.1376000213623047e+02 -5.8778800964355469e+01 -1.5927000045776367e+01 1.1759600067138672e+02 -5.8381500244140625e+01 -1.8738500595092773e+01 1.0636900329589844e+02 -6.0001899719238281e+01 3.9615197181701660e+00 1.0620299530029297e+02 -5.7914100646972656e+01 1.6882301330566406e+01 1.0608900451660156e+02 -5.2843601226806641e+01 3.3501899719238281e+01 1.6069699096679688e+02 -5.9322799682617188e+01 2.3000598907470703e+01 1.3293299865722656e+02 -5.8864898681640625e+01 -1.9247499465942383e+01 1.1774600219726562e+02 -1.4972800254821777e+01 -5.0734401702880859e+01 1.1454900360107422e+02 -1.1422699928283691e+01 -5.1588298797607422e+01 1.8837500000000000e+02 -1.5151999473571777e+01 -4.6500297546386719e+01 1.5976100158691406e+02 -1.5126800537109375e+01 -4.7644397735595703e+01 1.4265600585937500e+02 -1.5001399993896484e+01 -4.7951499938964844e+01 1.9251799011230469e+02 -1.1506799697875977e+01 -4.7005298614501953e+01 1.9041299438476562e+02 -1.4267300605773926e+01 -4.6525600433349609e+01 1.1488600158691406e+02 5.3745300292968750e+01 2.9165800094604492e+01 1.1509100341796875e+02 4.5321800231933594e+01 4.5990798950195312e+01 1.1722800445556641e+02 4.3668697357177734e+01 4.7778301239013672e+01 1.5705099487304688e+02 4.5566001892089844e+01 3.5603000640869141e+01 1.6281199645996094e+02 4.8271701812744141e+01 3.1496801376342773e+01 1.4562199401855469e+02 4.4266498565673828e+01 4.4049301147460938e+01 1.3574301147460938e+02 4.4599201202392578e+01 4.7192001342773438e+01 1.6380000305175781e+02 5.4823497772216797e+01 2.8059299468994141e+01 1.6360198974609375e+02 5.0160800933837891e+01 3.0754299163818359e+01 1.4435499572753906e+02 5.7135997772216797e+01 2.6440198898315430e+01 1.2700099945068359e+02 5.6121299743652344e+01 2.6727300643920898e+01 1.3181098937988281e+02 5.7516998291015625e+01 2.5521499633789062e+01 1.6344400024414062e+02 5.8080902099609375e+01 2.5643400192260742e+01 1.1701499938964844e+02 5.6186298370361328e+01 2.6178600311279297e+01 1.7818600463867188e+02 2.2477600097656250e+01 3.3969799041748047e+01 1.7781700134277344e+02 -5.0146598815917969e+00 3.3470397949218750e+01 1.7605400085449219e+02 2.5440799713134766e+01 3.4740299224853516e+01 1.7398999023437500e+02 2.6164300918579102e+01 3.4999401092529297e+01 1.3848899841308594e+02 2.6201200485229492e+01 6.3457496643066406e+01 1.3549099731445312e+02 2.3635400772094727e+01 6.4490699768066406e+01 1.3492199707031250e+02 2.1094900131225586e+01 6.3880100250244141e+01 1.3496200561523438e+02 6.7191904783248901e-01 6.4027801513671875e+01 9.5991401672363281e+01 -5.2353099822998047e+01 2.6103901863098145e+00 9.6013099670410156e+01 -4.8817798614501953e+01 1.9642200469970703e+01 9.6004394531250000e+01 -2.6181100845336914e+01 5.0067001342773438e+01 1.0531699371337891e+02 -3.4370502471923828e+01 6.5224296569824219e+01 9.5996299743652344e+01 -1.0822400093078613e+01 5.3937698364257812e+01 9.6001998901367188e+01 -3.1918897628784180e+01 4.6097000122070312e+01 1.0148300170898438e+02 -3.9306800842285156e+01 5.0527000427246094e+01 1.0569400024414062e+02 -3.8895301818847656e+01 6.2172401428222656e+01 1.0544999694824219e+02 -2.2088001251220703e+01 6.6305099487304688e+01 9.6003395080566406e+01 -4.0100997924804688e+01 3.6881900787353516e+01 1.0618700408935547e+02 -4.5324401855468750e+01 5.0910202026367188e+01 1.0552500152587891e+02 1.7329999923706055e+01 6.6509300231933594e+01 1.1374600219726562e+02 -5.5072502136230469e+01 2.8351900100708008e+01 1.1414500427246094e+02 -4.6034801483154297e+01 4.7630001068115234e+01 1.1800300598144531e+02 -4.4662097930908203e+01 4.9751098632812500e+01 1.3459500122070312e+02 -4.5706996917724609e+01 4.8228599548339844e+01 1.4568400573730469e+02 -4.5191501617431641e+01 4.5570602416992188e+01 1.3669900512695312e+02 -4.6077400207519531e+01 4.9466300964355469e+01 1.5675000000000000e+02 -4.6239101409912109e+01 3.7885101318359375e+01 1.6391499328613281e+02 -4.9290798187255859e+01 3.3866100311279297e+01 1.4367799377441406e+02 -4.5182300567626953e+01 4.8243797302246094e+01 1.5700498962402344e+02 -4.5630397796630859e+01 3.9460201263427734e+01 1.6457598876953125e+02 -5.1265796661376953e+01 3.1692899703979492e+01 1.6494099426269531e+02 -5.4776699066162109e+01 2.8969699859619141e+01 2.0015299987792969e+02 -5.8359500885009766e+01 2.1649599075317383e+01 1.8204000854492188e+02 -5.7073101043701172e+01 2.5260999679565430e+01 1.7964900207519531e+02 -2.0388500213623047e+01 3.4191799163818359e+01 1.8368800354003906e+02 1.4527799606323242e+01 3.2624301910400391e+01 1.7919999694824219e+02 -8.4076100587844849e-01 3.4105098724365234e+01 1.7868000793457031e+02 -2.4385999679565430e+01 3.4431098937988281e+01 1.7551599121093750e+02 -2.7489799499511719e+01 3.6154197692871094e+01 1.6743400573730469e+02 -2.7813098907470703e+01 4.1675601959228516e+01 1.3980700683593750e+02 -2.7853099822998047e+01 6.3749595642089844e+01 1.3426300048828125e+02 -2.3186401367187500e+01 6.6021896362304688e+01 1.3418600463867188e+02 5.6766800582408905e-02 6.6304000854492188e+01 1.3093598937988281e+02 -2.8188598632812500e+01 6.6408500671386719e+01 1.3493501281738281e+02 -1.0140299797058105e+01 6.5212799072265625e+01 1.9530799865722656e+02 5.9507900238037109e+01 -2.3955301284790039e+01 1.9821000671386719e+02 5.9297302246093750e+01 1.1879100799560547e+01 1.9904499816894531e+02 5.9013500213623047e+01 9.1163101196289062e+00 1.9970600891113281e+02 5.9435699462890625e+01 7.9474897384643555e+00 2.0043499755859375e+02 5.9599796295166016e+01 9.7910203933715820e+00 1.9586000061035156e+02 5.9646499633789062e+01 1.5539100646972656e+01 1.9908599853515625e+02 5.9014202117919922e+01 -6.5246901512145996e+00 1.9865000915527344e+02 5.8394302368164062e+01 -1.8435598373413086e+01 1.9969500732421875e+02 5.9435699462890625e+01 -1.8581800460815430e+01 2.0050000000000000e+02 5.9599998474121094e+01 -6.5246300697326660e+00 2.0033599853515625e+02 5.9599899291992188e+01 -2.0095300674438477e+01 1.1366799926757812e+02 5.8863597869873047e+01 -1.5145799636840820e+01 1.1680900573730469e+02 5.8361999511718750e+01 -1.9104400634765625e+01 1.0628399658203125e+02 5.9086502075195312e+01 1.1291700363159180e+01 1.0609500122070312e+02 5.6163002014160156e+01 2.3417699813842773e+01 1.0631900024414062e+02 6.0075698852539062e+01 -1.4537400007247925e+00 1.5073500061035156e+02 5.9307098388671875e+01 -1.9643699645996094e+01 9.6003898620605469e+01 1.5412500381469727e+01 5.3257301330566406e+01 9.6004798889160156e+01 2.6230899810791016e+01 5.0048000335693359e+01 9.6002700805664062e+01 3.1935199737548828e+01 4.6087802886962891e+01 9.6003005981445312e+01 4.0110099792480469e+01 3.6866401672363281e+01 9.6015296936035156e+01 4.8818901062011719e+01 1.9644500732421875e+01 9.5997100830078125e+01 5.1885002136230469e+01 6.3617200851440430e+00 9.5993698120117188e+01 5.2160800933837891e+01 -2.6104500293731689e+00 9.6000000000000000e+01 -5.0805099487304688e+01 -1.3062699317932129e+01 9.5999893188476562e+01 -4.6927398681640625e+01 -2.4410200119018555e+01 9.6001197814941406e+01 -3.9989200592041016e+01 -3.5133899688720703e+01 9.6004394531250000e+01 -2.9499401092529297e+01 -4.3494499206542969e+01 9.6005599975585938e+01 -2.1365800857543945e+01 -4.7225597381591797e+01 9.6005798339843750e+01 -1.0439700126647949e+01 -5.0291999816894531e+01 9.5999893188476562e+01 4.6927398681640625e+01 -2.4410200119018555e+01 9.6000099182128906e+01 5.0805099487304688e+01 -1.3062699317932129e+01 9.6005599975585938e+01 2.1365800857543945e+01 -4.7225597381591797e+01 9.6000801086425781e+01 3.9988800048828125e+01 -3.5133598327636719e+01 9.6005500793457031e+01 2.9500499725341797e+01 -4.3494998931884766e+01 9.6004798889160156e+01 1.0438700675964355e+01 -5.0291797637939453e+01 9.5999893188476562e+01 -6.7094003316015005e-04 -5.1141399383544922e+01 1.1450499725341797e+02 1.0991100311279297e+01 -5.1546001434326172e+01 1.1604599761962891e+02 1.3854700088500977e+01 -5.1550197601318359e+01 1.6811000061035156e+02 1.5124500274658203e+01 -4.7219997406005859e+01 1.4425801086425781e+02 1.5128399848937988e+01 -4.8744800567626953e+01 1.9262899780273438e+02 -1.5407700836658478e-01 -4.8087501525878906e+01 2.5329301452636719e+02 -5.9360702514648438e+01 3.7227799892425537e+00 2.9913900756835938e+02 -5.9560802459716797e+01 -1.7453300476074219e+01 2.7202902221679688e+02 -5.9582500457763672e+01 1.4386100769042969e+00 2.1833198547363281e+02 -5.9621898651123047e+01 1.4433300018310547e+01 2.9397698974609375e+02 -5.9558399200439453e+01 -3.5167701721191406e+01 2.7114901733398438e+02 -5.9548698425292969e+01 -3.7561496734619141e+01 2.0986900329589844e+02 -5.9567699432373047e+01 -3.3242599487304688e+01 1.6356500244140625e+02 -5.9376098632812500e+01 -2.7983701705932617e+01 1.2132699584960938e+02 -5.6694103240966797e+01 -2.8142299652099609e+01 1.4651300048828125e+02 -5.7890800476074219e+01 -2.9504899978637695e+01 1.7305000305175781e+02 -5.8148300170898438e+01 -3.1985301971435547e+01 1.0599900054931641e+02 -5.7094497680664062e+01 -2.3374799728393555e+01 1.0629999542236328e+02 -5.9657997131347656e+01 -9.6062297821044922e+00 1.0748100280761719e+02 -2.1787601470947266e+01 -5.2811801910400391e+01 1.0753999328613281e+02 0.0000000000000000e+00 -5.4102397918701172e+01 1.0590699768066406e+02 -5.1664100646972656e+01 -3.5987499237060547e+01 1.0589600372314453e+02 -4.5768398284912109e+01 -4.3152702331542969e+01 1.0639399719238281e+02 -4.0084499359130859e+01 -4.7432502746582031e+01 1.0673200225830078e+02 -3.1287700653076172e+01 -5.0921600341796875e+01 1.1374100494384766e+02 -3.8158097863197327e-01 -5.3426197052001953e+01 1.1373999786376953e+02 -1.1884500503540039e+01 -5.2836299896240234e+01 1.1759200286865234e+02 -1.6310998916625977e+01 -5.2187900543212891e+01 1.4660400390625000e+02 -1.5789000511169434e+01 -4.9292999267578125e+01 1.8940899658203125e+02 -1.6616300582885742e+01 -4.7532001495361328e+01 1.7581201171875000e+02 -1.6619499206542969e+01 -4.8004001617431641e+01 1.4950799560546875e+02 -1.7443799972534180e+01 -4.9311500549316406e+01 1.9384500122070312e+02 -1.2534000396728516e+01 -4.7933799743652344e+01 1.9403800964355469e+02 -1.7250499222427607e-03 -4.9168300628662109e+01 3.3021600341796875e+02 -5.6055797576904297e+01 2.0187198638916016e+01 3.4545901489257812e+02 -5.0816699981689453e+01 2.2870401382446289e+01 3.3549801635742188e+02 -5.0789100646972656e+01 2.9877399444580078e+01 3.2403100585937500e+02 -5.2572601318359375e+01 2.9864000320434570e+01 3.1784500122070312e+02 -5.7084899902343750e+01 1.8167900085449219e+01 3.4129800415039062e+02 -5.6062301635742188e+01 9.2115697860717773e+00 3.5057800292968750e+02 -5.2317699432373047e+01 9.2651100158691406e+00 3.3276901245117188e+02 -5.8215099334716797e+01 8.7259998321533203e+00 3.4325097656250000e+02 -5.6178497314453125e+01 1.1262999475002289e-01 3.1429498291015625e+02 -5.2795299530029297e+01 2.8681699752807617e+01 3.0606799316406250e+02 -5.2102199554443359e+01 2.6739799499511719e+01 3.0453802490234375e+02 -5.6613300323486328e+01 1.3450200080871582e+01 3.2094000244140625e+02 -5.8827301025390625e+01 1.0650600433349609e+01 3.2424099731445312e+02 -5.9578399658203125e+01 3.4495999813079834e+00 3.5264797973632812e+02 -5.1604000091552734e+01 -6.1658797264099121e+00 3.4294900512695312e+02 -5.5334899902343750e+01 -1.0186499595642090e+01 3.4746200561523438e+02 -5.0817401885986328e+01 -2.0237600326538086e+01 3.3017797851562500e+02 -5.9017700195312500e+01 -5.6194200515747070e+00 3.3758898925781250e+02 -5.4773799896240234e+01 -1.9325298309326172e+01 3.4245199584960938e+02 -5.1083801269531250e+01 -2.4650699615478516e+01 2.9087002563476562e+02 -5.9193599700927734e+01 -3.2216899394989014e+00 2.9248602294921875e+02 -5.7564697265625000e+01 7.6732001304626465e+00 2.9598901367187500e+02 -5.4300201416015625e+01 1.7811300277709961e+01 2.9382199096679688e+02 -5.2435001373291016e+01 2.0415199279785156e+01 2.7742098999023438e+02 -5.9148300170898438e+01 5.6215400695800781e+00 1.0530900573730469e+02 3.4321598052978516e+01 6.5242401123046875e+01 1.0569400024414062e+02 3.8895301818847656e+01 6.2172401428222656e+01 1.0148300170898438e+02 3.9306800842285156e+01 5.0527000427246094e+01 1.0617800140380859e+02 4.4436000823974609e+01 5.2621902465820312e+01 1.0614900207519531e+02 5.0014999389648438e+01 4.0773899078369141e+01 1.1361599731445312e+02 5.4901100158691406e+01 2.8888000488281250e+01 1.1414199829101562e+02 4.6037399291992188e+01 4.7626399993896484e+01 1.1798699951171875e+02 4.4691802978515625e+01 4.9682098388671875e+01 1.3803100585937500e+02 4.5747398376464844e+01 4.7655799865722656e+01 1.3999099731445312e+02 4.5829200744628906e+01 4.8849300384521484e+01 1.4675399780273438e+02 4.5329998016357422e+01 4.5792800903320312e+01 1.3424900817871094e+02 4.5920902252197266e+01 4.9633499145507812e+01 1.5674200439453125e+02 4.6255699157714844e+01 3.8023899078369141e+01 1.6293499755859375e+02 4.9106601715087891e+01 3.2713302612304688e+01 1.5772799682617188e+02 4.5693599700927734e+01 3.9082199096679688e+01 1.6438700866699219e+02 4.9323799133300781e+01 3.3832099914550781e+01 1.6457598876953125e+02 5.1265098571777344e+01 3.1693298339843750e+01 1.6572799682617188e+02 5.3874702453613281e+01 2.9780099868774414e+01 1.9815699768066406e+02 5.8837997436523438e+01 2.1240400314331055e+01 1.9343798828125000e+02 5.6698200225830078e+01 2.4391698837280273e+01 1.7957901000976562e+02 2.3111301422119141e+01 3.4188697814941406e+01 1.7661199951171875e+02 2.7193799972534180e+01 3.5522697448730469e+01 1.7350199890136719e+02 2.7229598999023438e+01 3.7267498016357422e+01 1.4899800109863281e+02 2.7814199447631836e+01 5.6784500122070312e+01 1.3937300109863281e+02 2.7741701126098633e+01 6.3865699768066406e+01 1.6256700134277344e+02 2.7309000015258789e+01 4.5492897033691406e+01 1.3362799072265625e+02 2.2824899673461914e+01 6.6271499633789062e+01 1.3495401000976562e+02 2.2463800430297852e+01 6.5064102172851562e+01 1.4000099182128906e+02 -3.7999397277832031e+01 6.0201297760009766e+01 1.4167300415039062e+02 -4.1072902679443359e+01 5.6351402282714844e+01 1.4835600280761719e+02 -3.8722103118896484e+01 5.3804698944091797e+01 1.3761999511718750e+02 -3.2905498504638672e+01 6.3922599792480469e+01 1.4371499633789062e+02 -3.3531402587890625e+01 6.0123001098632812e+01 1.7050500488281250e+02 -3.5418300628662109e+01 3.8127601623535156e+01 1.3574501037597656e+02 -4.1949298858642578e+01 5.7254703521728516e+01 1.3344499206542969e+02 -3.7413997650146484e+01 6.2541000366210938e+01 1.6036199951171875e+02 -3.7501800537109375e+01 4.4486000061035156e+01 1.2822300720214844e+02 2.5380500592291355e-03 6.6940597534179688e+01 1.3307000732421875e+02 -3.4566497802734375e+01 6.4479301452636719e+01 1.1277999877929688e+02 -3.1176601409912109e+01 6.5373397827148438e+01 1.1455500030517578e+02 -3.4925697326660156e+01 6.3660301208496094e+01 1.1466699981689453e+02 -3.8377098083496094e+01 6.0182701110839844e+01 1.7202600097656250e+02 -4.7644599914550781e+01 3.2922801971435547e+01 1.6332400512695312e+02 -4.2409698486328125e+01 3.9155300140380859e+01 1.8566699218750000e+02 -3.5922698974609375e+01 3.1507398605346680e+01 1.5437200927734375e+02 -4.2130802154541016e+01 4.4921398162841797e+01 1.8039299011230469e+02 -4.4782402038574219e+01 3.1724597930908203e+01 1.8650599670410156e+02 -5.1513900756835938e+01 2.7751098632812500e+01 1.8375700378417969e+02 -1.3497900009155273e+01 3.2690799713134766e+01 2.6988101196289062e+02 -5.8853500366210938e+01 4.1775803565979004e+00 2.5401199340820312e+02 -5.6849300384521484e+01 7.2803001403808594e+00 2.6807598876953125e+02 -5.6217498779296875e+01 7.0146603584289551e+00 2.5847198486328125e+02 -5.3321800231933594e+01 8.5031900405883789e+00 2.6445401000976562e+02 -5.2188796997070312e+01 8.2084398269653320e+00 2.6950000000000000e+02 -5.3400299072265625e+01 8.6443300247192383e+00 2.5100201416015625e+02 -5.3311000823974609e+01 1.0358699798583984e+01 2.2819100952148438e+02 -5.6646701812744141e+01 1.7905900955200195e+01 2.3049099731445312e+02 -5.8918201446533203e+01 1.3960800170898438e+01 2.3717098999023438e+02 -5.3330802917480469e+01 1.6238899230957031e+01 2.2476400756835938e+02 -5.2911201477050781e+01 2.0362998962402344e+01 2.0169299316406250e+02 -5.5829101562500000e+01 2.3711700439453125e+01 2.1151300048828125e+02 -5.3709899902343750e+01 2.2954799652099609e+01 2.5361401367187500e+02 5.9597099304199219e+01 1.7641000747680664e+00 2.7073098754882812e+02 5.9595001220703125e+01 1.1347800493240356e+00 2.4433801269531250e+02 5.9590702056884766e+01 -3.6644599914550781e+01 2.9514700317382812e+02 5.9618499755859375e+01 -1.4815299987792969e+01 2.2900999450683594e+02 5.9573402404785156e+01 1.2471499443054199e+01 1.9489300537109375e+02 5.9581298828125000e+01 -3.0429100036621094e+01 1.6975801086425781e+02 5.9464500427246094e+01 -2.8738201141357422e+01 2.9397799682617188e+02 5.9503997802734375e+01 -3.6015701293945312e+01 1.8752799987792969e+02 5.8433799743652344e+01 -3.3148200988769531e+01 1.3923699951171875e+02 5.7992500305175781e+01 -2.8420598983764648e+01 1.8559500122070312e+02 5.5778900146484375e+01 -3.5464500427246094e+01 1.5547401428222656e+02 5.6283702850341797e+01 -3.2385200500488281e+01 1.0595899963378906e+02 5.5626701354980469e+01 -2.7611200332641602e+01 1.0606999969482422e+02 5.8002098083496094e+01 -1.9309000015258789e+01 1.0625699615478516e+02 5.9228500366210938e+01 -1.2706600189208984e+01 1.0581500244140625e+02 5.2338802337646484e+01 -3.4569198608398438e+01 1.0594799804687500e+02 4.8441600799560547e+01 -4.0372299194335938e+01 1.0627699279785156e+02 4.1895698547363281e+01 -4.6385700225830078e+01 1.0749800109863281e+02 2.1781200408935547e+01 -5.2819000244140625e+01 1.0683300018310547e+02 3.2219997406005859e+01 -5.0730602264404297e+01 1.1385800170898438e+02 1.2536900520324707e+01 -5.2801399230957031e+01 1.1831399536132812e+02 1.6657098770141602e+01 -5.2060100555419922e+01 1.4150999450683594e+02 1.6733798980712891e+01 -5.0052600860595703e+01 1.5871099853515625e+02 1.7253200531005859e+01 -4.8840000152587891e+01 1.5283599853515625e+02 1.6447799682617188e+01 -4.9134197235107422e+01 1.7329399108886719e+02 1.6458099365234375e+01 -4.8023998260498047e+01 1.7724299621582031e+02 1.7257999420166016e+01 -4.7909400939941406e+01 1.9079299926757812e+02 1.6327899932861328e+01 -4.7524600982666016e+01 1.9348800659179688e+02 1.1803199768066406e+01 -4.7916000366210938e+01 3.2879299926757812e+02 -5.4604198455810547e+01 -2.5244899749755859e+01 3.1785601806640625e+02 -5.7207500457763672e+01 -2.3674100875854492e+01 3.2115399169921875e+02 -5.4195003509521484e+01 -3.3423999786376953e+01 3.0731201171875000e+02 -5.7213798522949219e+01 -3.6426101684570312e+01 2.4370700073242188e+02 -5.8105400085449219e+01 -4.0483600616455078e+01 1.8605000305175781e+02 -5.5666301727294922e+01 -3.5633197784423828e+01 2.2290701293945312e+02 -5.4581798553466797e+01 -4.0966201782226562e+01 2.5016900634765625e+02 -5.5311500549316406e+01 -4.2954696655273438e+01 2.9298898315429688e+02 -5.8406402587890625e+01 -3.9179798126220703e+01 2.7344998168945312e+02 -5.5917999267578125e+01 -4.2715999603271484e+01 2.6892797851562500e+02 -5.3521598815917969e+01 -4.3816802978515625e+01 2.9295199584960938e+02 -5.5925998687744141e+01 -4.1507198333740234e+01 2.8959701538085938e+02 -5.3229801177978516e+01 -4.2905300140380859e+01 1.6210000610351562e+02 -2.8137701034545898e+01 -4.6781600952148438e+01 2.2045600891113281e+02 -2.0525101572275162e-03 -4.8651199340820312e+01 1.9152799987792969e+02 -2.6897300720214844e+01 -4.5917598724365234e+01 1.4162600708007812e+02 -3.2515800476074219e+01 -4.7097602844238281e+01 1.4261500549316406e+02 -3.9808399200439453e+01 -4.4338600158691406e+01 1.6180300903320312e+02 -3.9506500244140625e+01 -4.3474597930908203e+01 1.9230200195312500e+02 -4.0004398345947266e+01 -4.2837898254394531e+01 1.3307400512695312e+02 -4.4574100494384766e+01 -4.2234397888183594e+01 1.4059600830078125e+02 -5.0834701538085938e+01 -3.7153800964355469e+01 1.2431199645996094e+02 -5.3877700805664062e+01 -3.3177299499511719e+01 1.7020100402832031e+02 -4.6278499603271484e+01 -4.0095199584960938e+01 2.0101000976562500e+02 -4.9776302337646484e+01 -3.9787696838378906e+01 1.6527398681640625e+02 -5.1322799682617188e+01 -3.7043899536132812e+01 3.4758599853515625e+02 -4.6564601898193359e+01 -2.3633201599121094e+01 3.4175802612304688e+02 -4.7322097778320312e+01 -2.8669099807739258e+01 3.5105401611328125e+02 -5.0087699890136719e+01 -1.5676500320434570e+01 3.5647000122070312e+02 -4.6487201690673828e+01 -4.1949100494384766e+00 3.5497497558593750e+02 -4.9988998413085938e+01 1.9928300380706787e+00 3.5551898193359375e+02 -4.7991901397705078e+01 -8.0698108673095703e+00 3.5655297851562500e+02 -4.6585800170898438e+01 2.8831000328063965e+00 3.5317297363281250e+02 -4.9987899780273438e+01 1.1425299644470215e+01 3.5243099975585938e+02 -4.6553897857666016e+01 -1.6864498138427734e+01 3.5240499877929688e+02 -4.6603298187255859e+01 1.6930099487304688e+01 3.5556301879882812e+02 -4.6486900329589844e+01 8.9986906051635742e+00 3.1190802001953125e+02 -4.9952499389648438e+01 3.2275901794433594e+01 3.4660101318359375e+02 -4.6533302307128906e+01 2.4800498962402344e+01 3.3962698364257812e+02 -4.6558799743652344e+01 3.0183099746704102e+01 3.3385101318359375e+02 -4.6603401184082031e+01 3.2969097137451172e+01 3.2513497924804688e+02 -4.9954196929931641e+01 3.3501701354980469e+01 3.3816497802734375e+02 -4.9954002380371094e+01 -2.9056800842285156e+01 2.8545098876953125e+02 -5.5893600463867188e+01 1.2783999443054199e+01 2.9691400146484375e+02 -4.6429599761962891e+01 2.5998100280761719e+01 2.8733102416992188e+02 -4.9988197326660156e+01 1.8403999328613281e+01 2.7717001342773438e+02 -5.3599498748779297e+01 1.1216300010681152e+01 1.4946701049804688e+02 3.4173000335693359e+01 5.5406803131103516e+01 1.6770599365234375e+02 3.4920600891113281e+01 4.0210899353027344e+01 1.2979600524902344e+02 2.8933300018310547e+01 6.6311996459960938e+01 1.3604499816894531e+02 3.2817901611328125e+01 6.4451202392578125e+01 1.4030000305175781e+02 3.3655300140380859e+01 6.2324600219726562e+01 1.4425000000000000e+02 3.8764099121093750e+01 5.7055397033691406e+01 1.3992799377441406e+02 4.1637901306152344e+01 5.6498401641845703e+01 1.3657798767089844e+02 3.7251300811767578e+01 6.2039798736572266e+01 1.4481100463867188e+02 4.0798500061035156e+01 5.4572998046875000e+01 1.6895100402832031e+02 4.1108100891113281e+01 3.7266002655029297e+01 1.7570500183105469e+02 3.4639900207519531e+01 3.5550502777099609e+01 1.6036199951171875e+02 3.7501800537109375e+01 4.4486000061035156e+01 1.6420599365234375e+02 4.3967002868652344e+01 3.7650699615478516e+01 1.5437799072265625e+02 4.2090599060058594e+01 4.4954601287841797e+01 1.7954200744628906e+02 4.3807800292968750e+01 3.2334201812744141e+01 1.8271000671386719e+02 3.4912899017333984e+01 3.2622501373291016e+01 1.7485398864746094e+02 5.1047599792480469e+01 3.0327501296997070e+01 1.1885199737548828e+02 3.8033599853515625e+01 6.0749198913574219e+01 1.1260499572753906e+02 3.8684600830078125e+01 6.0240398406982422e+01 1.1471700286865234e+02 3.4023200988769531e+01 6.4308197021484375e+01 1.3116999816894531e+02 3.4135299682617188e+01 6.4737297058105469e+01 1.3075500488281250e+02 3.7378501892089844e+01 6.2505001068115234e+01 1.3469900512695312e+02 4.1564098358154297e+01 5.7772399902343750e+01 1.1008300018310547e+02 2.8295999526977539e+01 6.5921501159667969e+01 1.8822099304199219e+02 5.2735298156738281e+01 2.6884998321533203e+01 2.5340199279785156e+02 5.8809001922607422e+01 4.8021702766418457e+00 2.7045300292968750e+02 5.8691402435302734e+01 4.6866698265075684e+00 2.2915400695800781e+02 5.7930999755859375e+01 1.6172698974609375e+01 2.5401199340820312e+02 5.6850002288818359e+01 7.2797298431396484e+00 2.6870001220703125e+02 5.6944297790527344e+01 6.5571699142456055e+00 2.2943299865722656e+02 5.5725601196289062e+01 1.8159700393676758e+01 2.5865100097656250e+02 5.3174900054931641e+01 8.5388698577880859e+00 2.6743298339843750e+02 5.3322399139404297e+01 8.1703891754150391e+00 2.5073098754882812e+02 5.3366001129150391e+01 1.0430599212646484e+01 2.0754299926757812e+02 5.3815799713134766e+01 2.3621799468994141e+01 2.2995300292968750e+02 5.3392002105712891e+01 1.8940801620483398e+01 2.5989199829101562e+02 1.9578199833631516e-02 1.0337200164794922e+01 2.6579299926757812e+02 -2.2864998877048492e-01 9.7871303558349609e+00 2.5126200866699219e+02 1.6547399759292603e-01 1.3001600265502930e+01 2.0748699951171875e+02 -3.5740300081670284e-03 2.9029499053955078e+01 2.1601000976562500e+02 -2.6735000610351562e+01 2.5183200836181641e+01 2.2427400207519531e+02 -1.3213099539279938e-01 2.4299200057983398e+01 2.2842800903320312e+02 -3.3193599700927734e+01 2.0551898956298828e+01 2.7235998535156250e+02 -3.6123901367187500e+01 1.0205699920654297e+01 2.7025299072265625e+02 6.1456594616174698e-02 1.0806500434875488e+01 1.9766500854492188e+02 -4.6399600982666016e+01 2.6853300094604492e+01 3.0579901123046875e+02 5.8677299499511719e+01 4.7270102500915527e+00 2.9326998901367188e+02 5.6706199645996094e+01 1.0634400367736816e+01 3.0686798095703125e+02 5.5396697998046875e+01 1.8861700057983398e+01 2.8923999023437500e+02 5.8949199676513672e+01 7.2731298208236694e-01 3.1638101196289062e+02 5.7163398742675781e+01 1.7737598419189453e+01 2.9579800415039062e+02 5.3833000183105469e+01 1.8883600234985352e+01 2.7655801391601562e+02 5.9387901306152344e+01 4.4498901367187500e+00 3.1206301879882812e+02 5.0240200042724609e+01 3.2121402740478516e+01 3.2334100341796875e+02 5.5386600494384766e+01 2.3537099838256836e+01 3.2828399658203125e+02 5.1962497711181641e+01 3.0207698822021484e+01 3.3696499633789062e+02 5.4748100280761719e+01 2.0116201400756836e+01 3.2583697509765625e+02 5.8132297515869141e+01 1.3629400253295898e+01 3.4155599975585938e+02 5.1276798248291016e+01 2.5338800430297852e+01 3.1700598144531250e+02 5.1871601104736328e+01 3.0941799163818359e+01 3.0556399536132812e+02 5.8850696563720703e+01 -2.2756799697875977e+01 3.0676901245117188e+02 5.7761402130126953e+01 -3.4925502777099609e+01 3.1970797729492188e+02 5.4104099273681641e+01 -3.4696899414062500e+01 2.3032299804687500e+02 5.8577701568603516e+01 -3.8440902709960938e+01 2.6688098144531250e+02 5.8656700134277344e+01 -4.0082599639892578e+01 2.3738000488281250e+02 5.7097801208496094e+01 -4.0868801116943359e+01 2.5059199523925781e+02 5.4423801422119141e+01 -4.3293300628662109e+01 2.2987500000000000e+02 5.4408699035644531e+01 -4.1789100646972656e+01 2.7122100830078125e+02 5.6256801605224609e+01 -4.2623199462890625e+01 2.9224200439453125e+02 5.8129398345947266e+01 -3.9615097045898438e+01 2.9490100097656250e+02 5.4677299499511719e+01 -4.2012699127197266e+01 2.7172900390625000e+02 5.3217998504638672e+01 -4.3895801544189453e+01 1.3229200744628906e+02 2.4901100158691406e+01 -4.9607898712158203e+01 1.3106399536132812e+02 3.2620399475097656e+01 -4.7903400421142578e+01 1.3256500244140625e+02 3.9792198181152344e+01 -4.5002300262451172e+01 1.3307400512695312e+02 4.4574100494384766e+01 -4.2234397888183594e+01 1.2406900024414062e+02 4.9163700103759766e+01 -3.8926200866699219e+01 1.6753500366210938e+02 2.8057201385498047e+01 -4.6593799591064453e+01 1.9271699523925781e+02 3.0185100555419922e+01 -4.5341201782226562e+01 1.7020700073242188e+02 4.6277603149414062e+01 -4.0095600128173828e+01 1.5373899841308594e+02 5.0213096618652344e+01 -3.7515300750732422e+01 1.6180300903320312e+02 3.9506500244140625e+01 -4.3474597930908203e+01 1.8816400146484375e+02 4.1039199829101562e+01 -4.2396499633789062e+01 1.9456001281738281e+02 4.8691196441650391e+01 -3.9693698883056641e+01 3.0714898681640625e+02 -5.4431198120117188e+01 -3.9724399566650391e+01 3.2254098510742188e+02 -5.1588798522949219e+01 -3.6031700134277344e+01 3.0816000366210938e+02 -5.1990596771240234e+01 -4.0674400329589844e+01 3.2262399291992188e+02 -4.8886501312255859e+01 -3.7410400390625000e+01 3.3305697631835938e+02 -4.7024803161621094e+01 -3.3586597442626953e+01 2.2141000366210938e+02 -1.9463699340820312e+01 -4.6871101379394531e+01 2.6096401977539062e+02 1.2615600228309631e-01 -4.8555000305175781e+01 2.5980999755859375e+02 -2.1825000762939453e+01 -4.7363399505615234e+01 2.1659300231933594e+02 -3.5800399780273438e+01 -4.4494800567626953e+01 2.4820100402832031e+02 -4.0265003204345703e+01 -4.5528602600097656e+01 2.8806600952148438e+02 -1.8376800417900085e-01 -4.7667297363281250e+01 2.7403799438476562e+02 -3.2568298339843750e+01 -4.6432800292968750e+01 2.9938198852539062e+02 -2.9787300109863281e+01 -4.4220897674560547e+01 2.1799301147460938e+02 -4.6383197784423828e+01 -4.2410102844238281e+01 3.0550198364257812e+02 1.5604100190103054e-03 -4.5325500488281250e+01 3.3713299560546875e+02 -2.7296199798583984e+01 3.2845298767089844e+01 3.4536499023437500e+02 -2.7500299453735352e+01 2.7609300613403320e+01 3.3054501342773438e+02 -2.7301300048828125e+01 3.5275199890136719e+01 3.5222598266601562e+02 -2.7748899459838867e+01 1.9580801010131836e+01 3.5620901489257812e+02 -2.7264900207519531e+01 1.1036899566650391e+01 3.5141998291015625e+02 -2.7590900421142578e+01 -2.0691900253295898e+01 3.5747702026367188e+02 -2.7658300399780273e+01 -6.1160697937011719e+00 3.5773699951171875e+02 -2.7730998992919922e+01 3.6521000862121582e+00 3.5477301025390625e+02 -2.7616800308227539e+01 -1.4722100257873535e+01 3.4653100585937500e+02 -2.7701599121093750e+01 -2.6458301544189453e+01 3.4195397949218750e+02 -2.7236700057983398e+01 -3.0036399841308594e+01 2.7476998901367188e+02 -1.4349600672721863e-01 1.2996800422668457e+01 2.8622500610351562e+02 -2.8034400939941406e+01 1.9559200286865234e+01 2.7812500000000000e+02 -2.7048200607299805e+01 1.3644199371337891e+01 2.7526599121093750e+02 -2.3990999221801758e+01 1.2114700317382812e+01 2.2841101074218750e+02 3.6035701751708984e+01 2.0388200759887695e+01 2.1325999450683594e+02 2.4194000244140625e+01 2.6268999099731445e+01 1.9223899841308594e+02 3.3256603240966797e+01 3.0131299972534180e+01 2.1534500122070312e+02 4.4072700500488281e+01 2.3374000549316406e+01 1.9287901306152344e+02 4.6887699127197266e+01 2.7825201034545898e+01 2.8867199707031250e+02 5.2378597259521484e+01 1.8078699111938477e+01 2.7820700073242188e+02 5.4890499114990234e+01 1.1003299713134766e+01 2.8493499755859375e+02 5.0125202178955078e+01 1.6675199508666992e+01 3.0661300659179688e+02 4.7075801849365234e+01 3.1899499893188477e+01 2.9687802124023438e+02 4.6438899993896484e+01 2.5975198745727539e+01 2.7496002197265625e+02 5.2326297760009766e+01 1.0564499855041504e+01 3.5468600463867188e+02 4.9993198394775391e+01 -4.8203902244567871e+00 3.5105401611328125e+02 5.0087699890136719e+01 -1.5676600456237793e+01 3.5377600097656250e+02 4.7331199645996094e+01 1.4020999908447266e+01 3.5495199584960938e+02 4.7584102630615234e+01 -1.0297300338745117e+01 3.5230401611328125e+02 4.6536899566650391e+01 -1.7081100463867188e+01 3.4601699829101562e+02 4.6798400878906250e+01 -2.5342599868774414e+01 3.5634698486328125e+02 4.6674499511718750e+01 4.8554697036743164e+00 3.5648797607421875e+02 4.6525001525878906e+01 -4.1701798439025879e+00 3.4442999267578125e+02 4.7429901123046875e+01 2.6542301177978516e+01 3.4893899536132812e+02 4.7365596771240234e+01 2.1899101257324219e+01 3.3642898559570312e+02 4.9807601928710938e+01 3.0209800720214844e+01 3.2194201660156250e+02 4.6480300903320312e+01 3.5234600067138672e+01 3.2808898925781250e+02 4.6672798156738281e+01 3.4538501739501953e+01 3.2513497924804688e+02 4.9954196929931641e+01 3.3501701354980469e+01 3.1507299804687500e+02 4.6535499572753906e+01 3.4624599456787109e+01 3.3743399047851562e+02 4.6488399505615234e+01 3.1513799667358398e+01 3.3727700805664062e+02 4.6310298919677734e+01 -3.1631298065185547e+01 3.0766699218750000e+02 5.6297599792480469e+01 -3.7703701019287109e+01 3.2102001953125000e+02 4.8730102539062500e+01 -3.8035900115966797e+01 3.0572500610351562e+02 5.2984699249267578e+01 -4.0842102050781250e+01 3.1386898803710938e+02 5.2998798370361328e+01 -3.8497200012207031e+01 3.2940200805664062e+02 4.9467800140380859e+01 -3.4280502319335938e+01 2.4820700073242188e+02 4.0354900360107422e+01 -4.5516498565673828e+01 2.7123901367187500e+02 2.9942798614501953e+01 -4.6779499053955078e+01 2.2335598754882812e+02 2.1486499786376953e+01 -4.6662597656250000e+01 2.0977899169921875e+02 3.6775100708007812e+01 -4.4052299499511719e+01 2.1080599975585938e+02 4.6506801605224609e+01 -4.1695301055908203e+01 2.9669400024414062e+02 2.9202999114990234e+01 -4.4716899871826172e+01 3.0624801635742188e+02 -2.2213899612426758e+01 -4.3449798583984375e+01 3.0911499023437500e+02 -2.7346899032592773e+01 -4.2625698089599609e+01 3.2430599975585938e+02 -2.7654500961303711e+01 -3.8567199707031250e+01 3.3528701782226562e+02 -2.7687999725341797e+01 -3.3854598999023438e+01 2.8012200927734375e+02 -2.6104598999023438e+01 1.3669399261474609e+01 2.7672000122070312e+02 -2.3183599472045898e+01 1.1913700103759766e+01 2.7633398437500000e+02 -9.2903404235839844e+00 1.2180799484252930e+01 2.7604299926757812e+02 -3.4207201679237187e-04 1.2574600219726562e+01 2.7893899536132812e+02 -2.0653699874877930e+01 8.7239694595336914e+00 2.7657699584960938e+02 5.0345800817012787e-02 1.2027600288391113e+01 3.3445401000976562e+02 -2.2513700485229492e+01 2.8790901184082031e+01 3.4005697631835938e+02 -2.2685300827026367e+01 2.5597900390625000e+01 3.4482897949218750e+02 -2.2565999984741211e+01 2.1283800125122070e+01 2.9766299438476562e+02 -2.6523099899291992e+01 2.7454498291015625e+01 3.0562600708007812e+02 -2.6010398864746094e+01 3.1183000564575195e+01 3.5634899902343750e+02 -2.6059101104736328e+01 5.8243298530578613e+00 3.5154797363281250e+02 -2.6336599349975586e+01 1.9282100677490234e+01 3.4218402099609375e+02 -2.6087699890136719e+01 2.8799999237060547e+01 3.3005801391601562e+02 -2.6043800354003906e+01 3.3971801757812500e+01 3.3773199462890625e+02 -2.6108301162719727e+01 -3.1531200408935547e+01 3.5047000122070312e+02 -2.6140300750732422e+01 -2.0534999847412109e+01 3.1814797973632812e+02 -2.6205898284912109e+01 3.5436100006103516e+01 3.5621801757812500e+02 -2.6078699111938477e+01 -7.2444996833801270e+00 3.2137500000000000e+02 -2.6332401275634766e+01 -3.8557201385498047e+01 3.1005999755859375e+02 -2.5947299957275391e+01 -4.1249397277832031e+01 3.0709201049804688e+02 -2.2699701309204102e+01 -4.1997699737548828e+01 2.7975601196289062e+02 2.7727199554443359e+01 1.4709400177001953e+01 2.9642199707031250e+02 2.7680400848388672e+01 2.7165500640869141e+01 2.7523999023437500e+02 2.3218999862670898e+01 1.2136699676513672e+01 3.0542199707031250e+02 2.7093299865722656e+01 3.2611602783203125e+01 3.5766900634765625e+02 2.7659698486328125e+01 -4.1118702888488770e+00 3.5587500000000000e+02 2.7293498992919922e+01 -1.1997699737548828e+01 3.5250198364257812e+02 2.7535099029541016e+01 -1.9004600524902344e+01 3.4826300048828125e+02 2.7280200958251953e+01 -2.4681600570678711e+01 3.5775698852539062e+02 2.7590799331665039e+01 3.1053099632263184e+00 3.5656198120117188e+02 2.7193000793457031e+01 9.5668497085571289e+00 3.5135598754882812e+02 2.6703300476074219e+01 2.0567199707031250e+01 3.5414498901367188e+02 2.7480300903320312e+01 1.6101799011230469e+01 3.4437500000000000e+02 2.7321100234985352e+01 2.8381200790405273e+01 3.3443200683593750e+02 2.7651300430297852e+01 3.4104999542236328e+01 3.1345401000976562e+02 2.7610599517822266e+01 3.5509700775146484e+01 3.2427499389648438e+02 2.7064800262451172e+01 3.6305099487304688e+01 3.3879101562500000e+02 2.7218500137329102e+01 -3.2092899322509766e+01 3.0641000366210938e+02 2.3153598785400391e+01 -4.3312900543212891e+01 3.2678198242187500e+02 2.7743398666381836e+01 -3.7607498168945312e+01 3.1130200195312500e+02 2.7627698898315430e+01 -4.2145198822021484e+01 3.0729800415039062e+02 -1.3068999350070953e-01 -4.4095500946044922e+01 3.5254699707031250e+02 -2.2570699691772461e+01 5.8562602996826172e+00 2.9912200927734375e+02 -2.2500099182128906e+01 -2.8525199890136719e+01 3.2809201049804688e+02 -2.2587800979614258e+01 3.0876399993896484e+01 3.5303500366210938e+02 -2.2591400146484375e+01 -3.3876399993896484e+00 3.4994500732421875e+02 -2.2623300552368164e+01 -1.3949899673461914e+01 3.4482501220703125e+02 -2.2590000152587891e+01 -2.1335401535034180e+01 3.3741900634765625e+02 -2.2572399139404297e+01 -2.7345800399780273e+01 2.8399597167968750e+02 -2.2465400695800781e+01 7.0138499140739441e-02 2.8402700805664062e+02 -2.2483798980712891e+01 1.1852000236511230e+01 3.2878399658203125e+02 -2.2568099975585938e+01 -3.1702201843261719e+01 3.1482101440429688e+02 -2.2513198852539062e+01 -3.6335502624511719e+01 3.4956399536132812e+02 -2.2603399276733398e+01 1.4776100158691406e+01 2.7682598876953125e+02 2.3387899398803711e+01 1.2001500129699707e+01 2.8011102294921875e+02 2.6141099929809570e+01 1.3711100578308105e+01 2.8342102050781250e+02 -2.6004800796508789e+01 1.1255299568176270e+01 2.7995602416992188e+02 -2.4622001647949219e+01 9.0958299636840820e+00 2.7636599731445312e+02 1.0545199394226074e+01 1.2132500648498535e+01 2.7690301513671875e+02 2.0893600463867188e+01 1.1493800163269043e+01 3.1025100708007812e+02 -2.0070199966430664e+01 -3.7088302612304688e+01 3.1108599853515625e+02 -2.1187500000000000e+01 -3.7158897399902344e+01 3.1001800537109375e+02 -1.9901199340820312e+01 -3.7811500549316406e+01 3.2788101196289062e+02 -2.6000099182128906e+01 3.0941900253295898e+01 3.4796597290039062e+02 -2.6000099182128906e+01 -1.7636600494384766e+01 3.3692602539062500e+02 -2.6000200271606445e+01 -2.7666399002075195e+01 3.3832202148437500e+02 -2.6000000000000000e+01 2.6807100296020508e+01 3.5251000976562500e+02 -2.5998798370361328e+01 6.9172201156616211e+00 3.5261300659179688e+02 -2.6000099182128906e+01 -5.4188599586486816e+00 3.4654699707031250e+02 -2.5999599456787109e+01 1.9377300262451172e+01 3.2077700805664062e+02 -2.6000000000000000e+01 -3.4507400512695312e+01 3.0941900634765625e+02 -2.5780399322509766e+01 -3.7523899078369141e+01 3.0665902709960938e+02 -2.3165500640869141e+01 -3.8298301696777344e+01 3.0206600952148438e+02 2.6097801208496094e+01 2.9890100479125977e+01 3.5634899902343750e+02 2.6059101104736328e+01 5.8244099617004395e+00 3.4173699951171875e+02 2.6119100570678711e+01 -2.8922599792480469e+01 3.3293499755859375e+02 2.6069200515747070e+01 3.3286003112792969e+01 3.4118099975585938e+02 2.6065099716186523e+01 2.9356100082397461e+01 3.1887200927734375e+02 2.6177400588989258e+01 3.5499000549316406e+01 3.5117098999023438e+02 2.6102998733520508e+01 -1.9248298645019531e+01 3.5633001708984375e+02 2.6052700042724609e+01 -5.8796601295471191e+00 3.2291400146484375e+02 2.6110399246215820e+01 -3.7826000213623047e+01 3.0966400146484375e+02 2.5779899597167969e+01 -4.1416099548339844e+01 3.0705700683593750e+02 2.2368700027465820e+01 -4.2082500457763672e+01 2.8673400878906250e+02 -2.0196599960327148e+01 -1.9524398803710938e+01 2.8292001342773438e+02 -2.0130901336669922e+01 -1.0649800300598145e+01 2.8740502929687500e+02 -2.1659000396728516e+01 -1.7899398803710938e+01 2.8085000610351562e+02 -2.0700000762939453e+01 9.6570396423339844e-01 3.0376397705078125e+02 -2.1434400558471680e+01 -3.4334598541259766e+01 2.9701599121093750e+02 -2.1653200149536133e+01 -2.9821500778198242e+01 2.9126998901367188e+02 -2.0262298583984375e+01 -2.6095800399780273e+01 2.9622201538085938e+02 -2.0309598922729492e+01 -3.0737501144409180e+01 2.8183001708984375e+02 -2.0291500091552734e+01 1.0322500228881836e+01 3.1022799682617188e+02 3.0523300170898438e-02 -3.9105197906494141e+01 3.1023999023437500e+02 -6.9103598594665527e-01 -3.8601200103759766e+01 3.1001202392578125e+02 -4.9342002868652344e+00 -3.8894500732421875e+01 3.1023300170898438e+02 -1.2400699615478516e+01 -3.8026199340820312e+01 3.1012899780273438e+02 -6.8877401351928711e+00 -3.7973697662353516e+01 2.8132199096679688e+02 -1.6647100448608398e-01 1.1363299369812012e+01 2.7825399780273438e+02 -9.0659397840499878e-01 9.5199594497680664e+00 2.8212402343750000e+02 2.5955301284790039e+01 1.0360199928283691e+01 2.7893200683593750e+02 2.2772199630737305e+01 8.5578994750976562e+00 3.0666598510742188e+02 -7.5930498540401459e-02 -3.9983997344970703e+01 3.3258200073242188e+02 2.6001399993896484e+01 2.9845399856567383e+01 3.4378701782226562e+02 2.5999799728393555e+01 2.2355598449707031e+01 3.5053198242187500e+02 2.6000200271606445e+01 -1.2615200042724609e+01 3.0544702148437500e+02 2.6000099182128906e+01 2.7420200347900391e+01 3.1806799316406250e+02 2.5999500274658203e+01 3.1459499359130859e+01 3.4996099853515625e+02 2.6000000000000000e+01 1.3619700431823730e+01 3.2077600097656250e+02 2.6000000000000000e+01 -3.4507198333740234e+01 3.1017700195312500e+02 2.5918500900268555e+01 -3.7336799621582031e+01 3.3648800659179688e+02 2.5999198913574219e+01 -2.7846698760986328e+01 3.5312500000000000e+02 2.6000398635864258e+01 2.1355299949645996e+00 3.4473898315429688e+02 2.6000398635864258e+01 -2.1347400665283203e+01 3.0642398071289062e+02 2.3199699401855469e+01 -3.8352096557617188e+01 3.1038699340820312e+02 9.5664100646972656e+00 -3.8100299835205078e+01 3.0491098022460938e+02 -1.1446600547060370e-03 -3.6421699523925781e+01 3.1004901123046875e+02 2.0163801193237305e+01 -3.7772800445556641e+01 3.1037799072265625e+02 2.0527299880981445e+01 -3.7196598052978516e+01 2.9124600219726562e+02 -3.1401601433753967e-01 -2.7701400756835938e+01 2.8512399291992188e+02 -4.2115998268127441e-01 -1.8362098693847656e+01 2.8168899536132812e+02 1.6421999782323837e-02 -8.6530294418334961e+00 2.8004699707031250e+02 -3.6268499493598938e-01 1.8416399955749512e+00 2.9793301391601562e+02 1.0533499717712402e-01 -3.3168098449707031e+01 2.8349200439453125e+02 2.2290100097656250e+01 1.1396100044250488e+01 2.9908999633789062e+02 2.2815700531005859e+01 2.3235698699951172e+01 3.0568600463867188e+02 2.2533899307250977e+01 2.7233999252319336e+01 2.8182101440429688e+02 2.0269199371337891e+01 1.0274700164794922e+01 3.4589498901367188e+02 2.2556598663330078e+01 2.0075799942016602e+01 3.5085202026367188e+02 2.2621700286865234e+01 1.2020199775695801e+01 3.4709899902343750e+02 2.2597900390625000e+01 -1.8744199752807617e+01 3.3921798706054688e+02 2.2599800109863281e+01 -2.6273900985717773e+01 3.5324798583984375e+02 2.2608600616455078e+01 -6.0054697096347809e-02 3.5123101806640625e+02 2.2599800109863281e+01 -1.0864999771118164e+01 3.1195101928710938e+02 2.2623800277709961e+01 3.0223999023437500e+01 3.2231201171875000e+02 2.2578599929809570e+01 3.1666200637817383e+01 3.3136999511718750e+02 2.2594499588012695e+01 3.0013200759887695e+01 3.3935897827148438e+02 2.2509799957275391e+01 2.6158201217651367e+01 3.1352499389648438e+02 2.2338500976562500e+01 -3.6697799682617188e+01 3.2829998779296875e+02 2.2644899368286133e+01 -3.1856998443603516e+01 3.1922998046875000e+02 2.2708799362182617e+01 -3.5121398925781250e+01 2.9673098754882812e+02 2.0280599594116211e+01 -3.1121299743652344e+01 2.8092199707031250e+02 2.0161300659179688e+01 3.4471898078918457e+00 2.8130001831054688e+02 2.0401599884033203e+01 -3.2472999095916748e+00 2.8355899047851562e+02 2.0190500259399414e+01 -1.2346499443054199e+01 2.8687701416015625e+02 2.0207201004028320e+01 -1.9766799926757812e+01 2.9094100952148438e+02 2.0240200042724609e+01 -2.5731901168823242e+01 3.1107299804687500e+02 2.1322200775146484e+01 -3.6683300018310547e+01 2.8336999511718750e+02 2.2372100830078125e+01 8.4650707244873047e+00 2.8845098876953125e+02 2.2632600784301758e+01 1.5141900062561035e+01 2.9204400634765625e+02 2.2500000000000000e+01 1.7394800186157227e+01 2.9310198974609375e+02 2.2624799728393555e+01 1.8662498474121094e+01 2.9767599487304688e+02 2.2536100387573242e+01 2.1906000137329102e+01 3.2286700439453125e+02 2.2496999740600586e+01 -3.3406997680664062e+01 2.8442098999023438e+02 2.1869798660278320e+01 -9.0608596801757812e+00 2.8940600585937500e+02 2.1477800369262695e+01 -2.1441598892211914e+01 2.8895501708984375e+02 2.2499300003051758e+01 -1.4380199432373047e+01 3.0081399536132812e+02 2.2498498916625977e+01 -2.9665199279785156e+01 2.9939599609375000e+02 2.1758598327636719e+01 -3.1656000137329102e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 5100 -> 68 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01) (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01) (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01) (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01) (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00) (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_forearm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_forearm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 171 173 0 1 0 173 0 21 171 2 21 0 2 1 309 1 173 381 309 1 381 171 172 173 172 381 173 381 175 174 308 175 381 381 172 308 381 174 309 13 166 309 174 13 309 2 309 166 124 174 175 174 136 13 233 174 124 233 136 174 136 120 14 136 337 120 13 136 14 136 233 337 233 124 57 337 233 404 404 233 57 337 102 121 337 404 102 102 404 100 404 57 100 100 101 102 120 121 102 101 154 102 154 120 102 274 101 100 274 100 405 57 405 100 274 54 321 101 274 321 405 54 274 54 405 57 53 54 55 89 54 57 53 321 54 55 54 89 91 101 321 91 321 53 90 91 53 101 91 302 91 90 302 90 380 302 53 380 90 380 53 152 152 286 380 380 286 302 151 152 153 286 152 151 152 53 153 361 151 258 258 151 153 361 286 151 53 363 153 209 370 153 363 209 153 370 258 153 258 259 83 361 258 83 370 259 258 370 104 329 370 329 259 370 209 104 209 210 104 294 210 209 363 294 209 123 104 210 123 210 56 294 56 210 294 55 56 363 55 294 56 57 58 89 56 55 56 60 123 60 56 58 56 89 57 53 55 363 58 57 60 124 60 57 60 124 123 122 123 124 124 175 122 245 122 175 245 97 122 122 97 123 308 245 175 245 172 293 308 172 245 245 98 97 98 245 293 97 98 99 123 97 336 97 99 336 104 123 336 336 99 330 330 104 336 225 330 99 99 98 346 99 346 225 98 297 346 297 98 293 296 346 297 346 296 225 163 296 297 297 293 68 163 297 214 68 214 297 165 225 296 165 296 163 163 164 165 165 149 225 164 149 165 332 149 164 164 163 332 148 149 150 149 148 225 150 149 332 331 267 332 267 266 332 331 332 163 266 150 332 267 331 213 213 331 163 253 266 267 253 267 213 266 78 77 77 150 266 78 266 253 79 78 253 155 253 213 155 79 253 213 163 214 214 155 213 155 156 79 155 214 156 77 78 79 156 260 79 141 77 79 79 260 141 77 141 150 314 148 150 150 127 314 150 141 143 150 143 127 148 314 127 148 127 256 256 225 148 127 128 129 256 127 129 143 128 127 141 142 143 128 143 142 128 277 278 128 278 129 128 142 277 215 256 129 335 129 278 334 215 129 334 129 335 334 335 278 278 277 357 313 278 357 354 334 278 354 278 313 341 334 354 341 215 334 313 50 354 50 412 354 412 341 354 176 50 313 313 357 176 357 177 176 277 177 357 51 176 177 176 51 50 50 51 52 177 113 51 51 113 52 252 251 52 50 52 251 252 52 113 251 252 43 170 252 113 44 43 252 44 252 170 251 322 50 251 43 322 43 44 45 43 45 322 169 44 170 44 169 208 45 44 208 341 45 212 322 45 341 45 208 212 50 322 412 412 322 341 212 215 341 195 104 212 104 215 212 208 195 212 208 169 362 208 362 195 195 36 104 195 362 36 362 365 34 169 365 362 34 36 362 34 35 36 35 234 36 104 36 234 46 35 34 365 46 34 365 169 192 192 46 365 194 46 192 46 239 35 194 239 46 239 244 35 35 244 234 239 194 190 239 191 244 191 239 190 244 246 206 244 191 246 206 394 244 234 244 394 190 189 191 246 191 189 194 250 190 189 190 250 188 189 94 246 189 188 189 250 95 94 189 95 216 188 217 217 188 94 216 246 188 94 95 96 96 217 94 250 240 95 96 95 240 96 181 182 181 96 240 182 217 96 42 93 217 182 42 217 217 93 216 181 42 182 385 59 181 59 42 181 241 385 181 241 181 240 385 241 59 59 40 42 284 59 241 284 40 59 240 203 241 284 241 203 202 284 203 40 284 356 284 270 323 356 284 323 284 202 270 40 41 42 41 40 356 41 356 323 307 323 306 41 323 307 306 323 409 323 270 409 92 41 307 41 92 42 92 93 42 306 92 307 93 92 47 92 410 47 410 92 306 306 409 410 409 269 410 270 269 409 410 269 47 268 269 270 269 268 47 268 270 318 268 48 47 48 268 318 202 318 270 4 202 203 202 196 318 202 4 3 3 196 202 3 4 5 343 200 4 200 5 4 196 3 197 3 5 197 199 5 200 193 5 199 5 353 197 193 353 5 199 200 201 343 359 200 200 359 201 203 359 343 201 359 250 359 240 250 203 240 359 199 201 250 199 250 194 193 199 194 192 193 194 169 170 192 192 170 193 113 193 170 112 113 114 319 113 177 113 112 342 193 113 342 319 114 113 193 112 183 183 112 114 112 193 342 183 114 184 114 319 184 319 384 184 399 384 319 319 177 399 177 277 280 177 280 399 384 399 280 384 279 141 184 384 141 384 280 279 142 279 280 277 142 280 142 141 279 260 184 141 260 355 184 355 260 290 260 156 299 290 260 299 290 301 355 25 355 398 355 25 184 355 301 398 398 301 390 390 25 398 390 106 25 390 107 106 301 107 390 106 107 108 107 301 347 108 107 347 106 108 162 292 285 108 162 108 285 292 108 347 282 106 162 285 282 162 281 285 67 282 285 281 68 285 214 68 67 285 285 292 214 281 67 282 8 282 6 282 8 106 282 67 6 62 67 68 80 67 62 6 67 80 6 7 8 74 6 75 6 80 75 74 7 6 106 8 65 7 65 8 106 64 25 64 106 65 64 65 66 25 64 351 349 64 66 351 64 349 66 109 111 65 257 66 66 257 109 66 111 349 349 350 351 349 111 350 350 378 351 351 378 386 386 25 351 350 168 378 350 111 168 109 110 111 167 168 111 111 110 167 109 257 110 110 242 243 257 374 110 110 374 242 110 243 167 257 16 242 257 242 374 16 161 242 161 243 242 161 375 243 375 167 243 16 160 161 160 371 161 371 375 161 371 408 375 375 408 167 160 377 371 371 377 408 160 16 15 160 15 222 160 222 224 160 224 377 376 167 377 377 224 376 377 167 408 262 167 376 262 376 224 222 223 224 224 185 262 224 223 406 224 406 185 187 261 262 333 262 261 262 333 167 185 187 262 185 186 187 186 185 406 187 186 247 187 325 261 325 187 247 333 261 324 391 261 325 283 333 324 283 167 333 247 324 325 324 391 325 283 324 247 186 368 247 368 283 247 69 71 283 368 69 283 167 283 49 283 71 49 48 168 167 49 48 167 276 311 168 378 168 310 48 276 168 310 168 311 276 180 232 180 276 48 232 311 276 310 311 30 311 232 26 30 311 26 400 310 30 378 310 386 400 386 310 25 30 26 25 386 30 30 386 400 24 25 26 231 26 232 26 231 24 232 180 312 231 232 312 340 24 231 312 139 231 340 231 139 340 352 24 25 24 184 184 24 352 340 139 373 340 197 352 340 395 197 395 340 373 137 138 139 137 139 312 138 373 139 180 137 312 138 137 180 138 382 373 138 180 382 48 179 180 180 179 382 373 382 383 382 179 383 316 179 392 401 179 316 317 179 48 401 383 179 47 48 49 317 48 318 316 317 318 316 392 317 318 401 316 196 396 401 196 401 318 396 383 401 196 395 396 197 395 196 395 407 396 407 383 396 395 373 407 373 383 407 197 353 352 183 352 353 183 353 193 352 183 184 72 73 49 72 49 130 326 49 327 47 49 216 71 130 49 326 372 49 372 216 49 73 327 49 326 32 372 364 326 327 326 364 32 85 364 327 85 327 73 364 85 88 364 88 235 32 364 235 31 32 33 32 31 372 32 235 33 372 31 360 372 360 216 360 31 205 31 33 205 33 235 218 33 367 205 33 218 367 235 105 218 235 88 105 104 218 105 218 366 367 366 218 104 367 366 205 204 205 206 204 360 205 205 366 206 216 360 204 246 204 206 204 246 216 206 366 394 366 104 234 394 366 234 103 104 105 328 329 104 338 104 315 104 330 215 104 103 315 339 358 104 339 104 338 358 328 104 225 256 330 215 330 256 81 328 249 328 275 249 328 358 275 329 328 81 248 249 134 249 275 134 131 81 249 248 131 249 358 134 275 28 134 135 358 135 134 248 134 28 132 131 248 28 227 248 227 132 248 131 132 133 131 82 81 131 133 82 125 132 227 132 125 116 132 116 133 140 226 227 28 140 227 226 125 227 28 27 140 140 27 264 140 264 226 264 263 226 226 295 230 226 230 125 263 295 226 263 264 265 265 264 219 27 219 264 263 265 295 265 159 295 411 230 295 159 411 295 265 219 159 159 219 220 27 389 219 369 219 389 219 369 220 157 158 159 157 159 220 158 411 159 304 230 411 158 304 411 158 157 304 157 305 304 305 157 393 157 220 393 186 228 304 305 186 304 304 228 230 397 368 305 186 305 368 305 393 397 393 403 397 393 220 403 397 403 255 255 70 397 70 69 397 397 69 368 254 255 403 403 220 254 220 369 254 254 130 255 254 369 130 130 70 255 69 70 71 71 70 130 9 72 130 9 130 369 9 369 389 29 389 27 389 29 9 27 28 29 10 29 207 29 135 207 29 28 135 29 10 9 9 10 11 19 10 207 11 10 19 339 20 207 339 207 135 20 19 207 358 339 135 20 339 338 18 19 20 20 338 18 18 11 19 22 18 23 22 11 18 338 23 18 338 315 23 22 23 87 87 23 315 144 22 87 22 211 11 72 211 22 144 72 22 85 144 87 86 85 87 315 86 87 84 86 315 103 84 315 84 85 86 85 84 88 73 72 85 72 144 85 211 72 9 9 11 211 88 103 105 88 84 103 228 186 406 228 229 230 228 126 229 228 344 126 229 126 125 125 230 229 117 125 126 126 344 115 115 117 126 344 406 115 320 115 406 223 320 406 115 116 117 320 116 115 116 125 117 133 116 39 39 116 320 222 221 320 320 221 39 320 223 222 37 38 39 39 38 286 221 37 39 286 133 39 286 361 133 82 133 361 286 38 302 303 302 38 38 37 273 38 273 303 302 303 272 147 302 272 146 101 302 146 302 147 272 303 273 271 272 273 37 271 273 147 272 271 271 37 147 145 146 147 147 17 145 17 147 37 154 146 145 146 154 101 17 14 145 154 145 402 120 145 14 15 16 17 16 14 17 15 17 37 37 221 15 15 221 222 12 13 14 21 12 14 118 14 198 118 21 14 198 14 16 65 16 257 198 16 65 7 198 65 7 74 198 76 288 198 288 118 198 198 74 76 74 75 76 76 287 288 76 75 287 288 345 118 287 345 288 63 287 75 287 63 62 287 387 345 287 62 387 80 63 75 61 62 63 63 80 61 68 119 62 62 119 387 61 80 62 387 119 345 119 118 345 118 119 21 21 119 178 119 68 178 178 68 171 293 171 68 21 178 171 12 21 2 12 2 13 2 166 13 172 171 293 402 120 154 82 361 83 81 82 83 329 81 83 259 329 83 93 47 216 238 237 214 214 237 299 238 214 292 156 214 299 298 290 299 299 237 298 290 298 291 237 291 298 236 237 238 291 237 236 289 290 291 236 289 291 300 301 290 300 290 289 289 236 238 289 238 379 379 300 289 347 300 379 301 300 347 379 388 347 379 238 388 348 238 292 292 347 348 347 388 348 413 414 415 413 439 440 413 456 457 461 462 413 456 413 471 461 413 434 435 413 468 413 440 484 413 415 469 413 457 439 413 484 414 462 480 413 413 469 468 435 434 413 502 471 413 480 502 413 469 415 449 415 414 449 467 468 469 467 469 501 501 469 449 449 414 450 452 501 449 452 449 450 450 414 484 453 452 450 453 450 464 464 450 484 451 452 453 501 452 488 451 488 452 488 491 501 491 467 501 419 488 451 419 442 488 442 491 488 419 451 453 453 489 419 489 453 464 489 464 463 419 489 463 463 464 459 419 463 423 463 459 424 423 463 424 439 459 440 464 484 459 424 459 439 459 484 440 424 439 443 439 457 443 457 456 447 447 443 457 447 456 471 446 447 448 446 443 447 471 448 447 448 471 428 471 502 496 428 471 496 496 502 481 481 502 480 480 462 481 496 481 475 475 481 462 475 462 474 474 462 461 482 475 474 496 475 482 455 417 474 417 476 474 482 474 476 474 461 455 455 461 434 454 455 434 417 455 433 455 454 433 434 435 436 454 434 436 470 454 441 470 433 454 454 436 441 436 435 467 436 467 491 441 436 491 435 468 467 442 441 491 441 442 419 419 470 441 470 499 433 470 419 499 419 431 499 499 431 433 419 420 421 419 479 420 419 422 500 419 500 479 421 431 419 423 422 419 421 420 477 431 421 477 477 420 478 477 478 431 420 498 478 478 498 431 498 427 495 498 495 432 498 432 431 420 427 498 495 427 494 494 432 495 431 432 433 494 487 432 432 487 433 427 493 494 487 494 493 493 427 485 493 485 487 485 486 487 485 427 486 486 427 490 487 486 490 490 460 487 490 427 460 427 426 460 497 487 460 460 426 497 425 426 427 427 420 425 472 444 425 472 425 479 425 444 448 425 420 479 448 426 425 422 472 473 472 422 445 473 472 479 445 444 472 443 444 445 444 503 448 444 443 503 503 446 448 448 428 426 503 443 446 424 443 445 424 445 422 422 423 424 422 473 500 500 473 479 437 426 438 426 418 483 426 483 465 426 437 497 426 465 438 426 428 418 466 497 437 466 437 438 438 465 466 483 466 465 483 417 466 418 417 483 416 417 418 428 416 418 416 428 458 416 458 417 428 429 430 428 496 429 492 428 430 428 492 458 458 492 417 492 430 417 429 417 430 429 476 417 466 417 433 429 496 476 496 482 476 487 466 433 497 466 487))
                   (list :vertices (let ((mat (make-matrix 504 3))) (fvector-replace (array-entity mat) #f(1.0600399780273438e+02 -9.3246002197265625e+00 4.0252799987792969e+01 1.0598299407958984e+02 -9.9800395965576172e+00 4.1002197265625000e+01 1.0650300598144531e+02 -9.8726997375488281e+00 4.0323699951171875e+01 1.0650000000000000e+02 3.3295299530029297e+01 3.3229999542236328e+00 1.0650000000000000e+02 3.7112499237060547e+01 -1.7666699886322021e+00 1.0600000000000000e+02 3.6189399719238281e+01 2.9743599891662598e-01 1.0600000000000000e+02 -6.6358900070190430e+00 2.8250999450683594e+01 1.0650000000000000e+02 -7.0874996185302734e+00 2.7699298858642578e+01 1.0650000000000000e+02 -6.5229802131652832e+00 2.7763898849487305e+01 9.3900001525878906e+01 -2.9588500976562500e+01 -2.8441398620605469e+01 9.3413299560546875e+01 -3.0424699783325195e+01 -2.8075599670410156e+01 9.3411102294921875e+01 -2.4949800491333008e+01 -3.3031002044677734e+01 1.0650000000000000e+02 -9.5875005722045898e+00 3.9289199829101562e+01 1.0650000000000000e+02 -1.1491900444030762e+01 4.0733596801757812e+01 1.0650000000000000e+02 -9.5875005722045898e+00 3.0199300765991211e+01 1.0650000000000000e+02 -2.0087499618530273e+01 2.1166700363159180e+01 1.0650000000000000e+02 -1.3721800804138184e+01 2.1760900497436523e+01 1.0650000000000000e+02 -1.9587499618530273e+01 2.2666700363159180e+01 9.2408096313476562e+01 -2.3180099487304688e+01 -3.4330402374267578e+01 9.2397506713867188e+01 -2.8620300292968750e+01 -2.9883300781250000e+01 9.1900001525878906e+01 -2.6001699447631836e+01 -3.1681198120117188e+01 1.0600000000000000e+02 -9.0875005722045898e+00 3.9289199829101562e+01 9.3408103942871094e+01 -1.6778999328613281e+01 -3.7901401519775391e+01 9.2405998229980469e+01 -1.6652399063110352e+01 -3.7882999420166016e+01 1.0650000000000000e+02 1.5394399642944336e+01 2.0419599533081055e+01 1.0650000000000000e+02 6.1935896873474121e+00 2.4935699462890625e+01 1.0599099731445312e+02 1.2504000663757324e+01 2.1621500015258789e+01 9.3900001525878906e+01 -3.7409099578857422e+01 -1.6526000976562500e+01 9.3402702331542969e+01 -3.9415500640869141e+01 -1.2758299827575684e+01 9.3392402648925781e+01 -3.5738700866699219e+01 -2.1080900192260742e+01 1.0599300384521484e+02 9.1015205383300781e+00 2.3263000488281250e+01 9.3406600952148438e+01 2.4851999282836914e+01 -3.2996597290039062e+01 9.3432800292968750e+01 1.6941999435424805e+01 -3.7724899291992188e+01 9.2378898620605469e+01 2.2726900100708008e+01 -3.4521099090576172e+01 9.2381599426269531e+01 4.0499603271484375e+01 8.1415395736694336e+00 9.2389595031738281e+01 4.1256599426269531e+01 -9.2630404233932495e-01 9.1900001525878906e+01 4.0202098846435547e+01 7.5019397735595703e+00 1.0600000000000000e+02 -2.0487501144409180e+01 2.1466699600219727e+01 9.3900001525878906e+01 -2.3876300811767578e+01 1.6948299407958984e+01 9.3900001525878906e+01 -2.8699298858642578e+01 1.0517600059509277e+01 1.0650000000000000e+02 2.8912500381469727e+01 -1.5500000000000000e+01 1.0600000000000000e+02 2.8912500381469727e+01 -1.6000000000000000e+01 1.0600000000000000e+02 3.5912498474121094e+01 -1.6000000000000000e+01 9.3395004272460938e+01 2.5451200485229492e+01 3.2538299560546875e+01 9.3402198791503906e+01 2.9934200286865234e+01 2.8402200698852539e+01 9.2391105651855469e+01 2.6465398788452148e+01 3.1714000701904297e+01 9.3364402770996094e+01 4.0916999816894531e+01 5.9389500617980957e+00 9.3900001525878906e+01 2.5748399734497070e+01 -1.7015600204467773e+01 9.3900001525878906e+01 2.6912498474121094e+01 -2.0355300903320312e+00 9.3900001525878906e+01 3.2329201698303223e+00 -2.1429899215698242e+01 9.3400001525878906e+01 2.0340499877929688e+01 3.6153301239013672e+01 9.3900001525878906e+01 1.9912500381469727e+01 3.5890602111816406e+01 9.3900001525878906e+01 2.0921501159667969e+01 3.4975101470947266e+01 9.3400001525878906e+01 -2.1354000091552734e+01 3.5403800964355469e+01 9.3400001525878906e+01 -2.0012001037597656e+01 3.7159000396728516e+01 9.2403205871582031e+01 -2.0478799819946289e+01 3.6168800354003906e+01 9.1900001525878906e+01 -1.9530899047851562e+01 3.7022998809814453e+01 9.2399902343750000e+01 -1.8969900131225586e+01 3.8409599304199219e+01 9.1900001525878906e+01 -1.9235099792480469e+01 3.7579799652099609e+01 1.0650000000000000e+02 3.5912498474121094e+01 -1.5500000000000000e+01 9.1900001525878906e+01 -1.8749300003051758e+01 3.7960903167724609e+01 9.3900001525878906e+01 -7.0874996185302734e+00 2.8199300765991211e+01 9.3900505065917969e+01 -8.7110004425048828e+00 2.8879299163818359e+01 9.7287002563476562e+01 -7.4840898513793945e+00 2.8202800750732422e+01 1.0650000000000000e+02 -8.7499998509883881e-02 2.5500000000000000e+01 1.0650000000000000e+02 -4.6803097724914551e+00 2.5189298629760742e+01 1.0597900390625000e+02 -3.3031499385833740e+00 2.4831300735473633e+01 9.3900100708007812e+01 -4.4406099319458008e+00 2.8699598312377930e+01 9.3900001525878906e+01 -4.4287500381469727e+00 3.5016902923583984e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -1.4000000000000000e+01 9.3900398254394531e+01 -2.7206899642944336e+01 -1.4783800125122070e+01 9.3900001525878906e+01 -2.5091600418090820e+01 -1.4711099624633789e+01 9.3900001525878906e+01 -8.0413503646850586e+00 -4.0114601135253906e+01 9.3900001525878906e+01 -8.7499998509883881e-02 -4.0800003051757812e+01 1.0600000000000000e+02 -7.0874996185302734e+00 2.8199300765991211e+01 1.0093800354003906e+02 -7.3930997848510742e+00 2.8199300765991211e+01 1.0600200653076172e+02 -8.0970792770385742e+00 2.8461198806762695e+01 1.0650000000000000e+02 1.1316900253295898e+01 4.0733596801757812e+01 1.0650000000000000e+02 9.6878404617309570e+00 4.0155300140380859e+01 1.0650000000000000e+02 9.4125003814697266e+00 3.9289199829101562e+01 9.3900001525878906e+01 -6.6358900070190430e+00 2.8250999450683594e+01 9.2385200500488281e+01 -4.0352100372314453e+01 9.5234107971191406e+00 9.3386802673339844e+01 -3.9813598632812500e+01 1.1657099723815918e+01 9.2398803710937500e+01 -3.7589698791503906e+01 1.7452501296997070e+01 9.2400001525878906e+01 -8.7499998509883881e-02 -4.1299999237060547e+01 9.3400001525878906e+01 -8.7499998509883881e-02 -4.1299999237060547e+01 9.2400001525878906e+01 -2.2346801757812500e+00 -4.1244102478027344e+01 9.2419296264648438e+01 -8.8318500518798828e+00 -4.0474899291992188e+01 9.2400001525878906e+01 4.4464502334594727e+00 -4.1099399566650391e+01 9.2400001525878906e+01 -2.0012001037597656e+01 3.7159000396728516e+01 9.3900001525878906e+01 -2.1096500396728516e+01 3.4975101470947266e+01 9.3900001525878906e+01 -2.0087499618530273e+01 3.5890602111816406e+01 9.3900001525878906e+01 2.8912500381469727e+01 -1.6000000000000000e+01 9.3900001525878906e+01 3.5912498474121094e+01 -1.6000000000000000e+01 9.3900398254394531e+01 3.7752502441406250e+01 -1.4911700248718262e+01 9.3900001525878906e+01 3.7912498474121094e+01 -1.4000000000000000e+01 9.9105003356933594e+01 3.7702899932861328e+01 -1.4991199493408203e+01 9.2392898559570312e+01 -6.9005999565124512e+00 4.2310798645019531e+01 9.3388702392578125e+01 -4.5561299324035645e+00 4.2613597869873047e+01 9.2399902343750000e+01 -8.7499998509883881e-02 4.2800003051757812e+01 9.9789199829101562e+01 -1.9569999694824219e+01 3.7992500305175781e+01 9.9448005676269531e+01 -2.0088499069213867e+01 3.6596298217773438e+01 1.0601799774169922e+02 -1.9599800109863281e+01 3.7949600219726562e+01 9.1900001525878906e+01 -8.7507396936416626e-02 -4.0801101684570312e+01 9.1900001525878906e+01 4.9303202629089355e+00 1.2872800230979919e-01 9.1900001525878906e+01 7.6348896026611328e+00 -4.0122501373291016e+01 1.0650000000000000e+02 -6.6803991794586182e-02 2.8663000106811523e+01 1.0600000000000000e+02 6.4608902931213379e+00 2.8250999450683594e+01 1.0599700164794922e+02 2.4476599693298340e+00 2.8908599853515625e+01 9.9694602966308594e+01 -5.3148398399353027e+00 2.4455200195312500e+01 9.3900299072265625e+01 -9.5627698898315430e+00 2.3286100387573242e+01 9.3900100708007812e+01 -2.5808298587799072e+00 2.4900199890136719e+01 1.0201699829101562e+02 2.0000200271606445e+01 2.2045898437500000e+01 9.3900001525878906e+01 1.9912500381469727e+01 2.2666700363159180e+01 1.0600000000000000e+02 1.9912500381469727e+01 2.2666700363159180e+01 1.0600000000000000e+02 -3.7687500000000000e+01 -1.4666699171066284e+00 9.3900001525878906e+01 -3.7687500000000000e+01 -1.4666699171066284e+00 9.9827201843261719e+01 -3.8002597808837891e+01 -2.0540900230407715e+00 1.0600000000000000e+02 -9.0875005722045898e+00 3.0199300765991211e+01 9.3900001525878906e+01 -9.0875005722045898e+00 3.0199300765991211e+01 1.0650000000000000e+02 -1.9360799789428711e+01 3.7407600402832031e+01 1.0650000000000000e+02 -1.9090600967407227e+01 3.7729499816894531e+01 9.2399902343750000e+01 -1.1674500465393066e+01 4.1201698303222656e+01 9.1900001525878906e+01 -1.2428300857543945e+01 4.0568698883056641e+01 9.2383598327636719e+01 -1.5034199714660645e+01 4.0139198303222656e+01 9.3900001525878906e+01 -3.8087497711181641e+01 -2.6666698455810547e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -2.6666698455810547e+00 9.2402900695800781e+01 1.5613400459289551e+01 3.9825500488281250e+01 9.2399902343750000e+01 1.8794898986816406e+01 3.8409599304199219e+01 9.1900001525878906e+01 1.8574298858642578e+01 3.7960903167724609e+01 9.3900207519531250e+01 -2.8023799896240234e+01 -1.5721600532531738e+01 9.3409004211425781e+01 -4.1222801208496094e+01 4.0004796981811523e+00 9.3900001525878906e+01 -4.1014400482177734e+01 6.6825497150421143e-01 9.3900001525878906e+01 -3.8707698822021484e+01 1.3752300262451172e+01 9.2404098510742188e+01 -4.0284500122070312e+01 -9.7258100509643555e+00 9.2391494750976562e+01 -3.7257999420166016e+01 -1.8208600997924805e+01 1.0650000000000000e+02 -1.5166000366210938e+01 3.9557300567626953e+01 9.3900001525878906e+01 2.0506999969482422e+01 1.4206100463867188e+01 9.3900001525878906e+01 2.2031000137329102e+01 1.1682899475097656e+01 1.0600000000000000e+02 1.9891799926757812e+01 1.5122599601745605e+01 9.3900001525878906e+01 -3.8674297332763672e+01 -1.3276100158691406e+01 1.0650000000000000e+02 1.8574298858642578e+01 3.7960903167724609e+01 1.0600000000000000e+02 1.8794898986816406e+01 3.8409599304199219e+01 1.0600000000000000e+02 1.7009399414062500e+01 3.9236900329589844e+01 9.3409599304199219e+01 -8.9973201751708984e+00 -4.0360099792480469e+01 1.0650000000000000e+02 -1.9587499618530273e+01 3.6614700317382812e+01 1.0600000000000000e+02 -2.0087499618530273e+01 3.4290100097656250e+01 1.0600000000000000e+02 -2.0087499618530273e+01 2.2666700363159180e+01 9.2396102905273438e+01 1.2555500030517578e+01 4.0893497467041016e+01 9.3400001525878906e+01 1.1451700210571289e+01 4.1215099334716797e+01 1.0600000000000000e+02 1.1451700210571289e+01 4.1215099334716797e+01 9.3404396057128906e+01 -3.3095596313476562e+01 2.4880500793457031e+01 9.3406402587890625e+01 -2.8592300415039062e+01 2.9951200485229492e+01 9.2407302856445312e+01 -2.8450201034545898e+01 3.0166799545288086e+01 1.0600000000000000e+02 -2.0087499618530273e+01 3.6614700317382812e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.9289199829101562e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.7021301269531250e+01 1.0650000000000000e+02 -2.9087501525878906e+01 -1.5500000000000000e+01 1.0650000000000000e+02 -3.6087501525878906e+01 -1.5500000000000000e+01 1.0600000000000000e+02 -3.6087501525878906e+01 -1.6000000000000000e+01 1.0650000000000000e+02 -1.9367498397827148e+01 1.6780199050903320e+01 1.0600900268554688e+02 -1.4913300514221191e+01 2.0185100555419922e+01 1.0600000000000000e+02 -8.7499998509883881e-02 2.9000000000000000e+01 9.3900001525878906e+01 1.0014199256896973e+01 4.1076103210449219e+01 9.3470703125000000e+01 1.0912500381469727e+01 4.1289199829101562e+01 9.3401603698730469e+01 9.4109992980957031e+00 4.1740600585937500e+01 1.0650000000000000e+02 -1.1087499618530273e+01 4.0789203643798828e+01 9.3900001525878906e+01 -2.3235599517822266e+01 9.4426298141479492e+00 9.3900001525878906e+01 2.6852600574493408e+00 2.2159900665283203e+01 9.3396995544433594e+01 3.4466503143310547e+01 2.2775400161743164e+01 9.3900001525878906e+01 3.3555400848388672e+01 2.3256198883056641e+01 9.3900207519531250e+01 -9.3199396133422852e+00 4.0288299560546875e+01 9.3900001525878906e+01 -1.0189300537109375e+01 4.1076198577880859e+01 9.9941795349121094e+01 -9.8314399719238281e+00 4.0885002136230469e+01 1.0600000000000000e+02 -1.1626799583435059e+01 4.1215099334716797e+01 9.3400001525878906e+01 -1.1626799583435059e+01 4.1215099334716797e+01 9.3523300170898438e+01 1.9912500381469727e+01 3.6614700317382812e+01 9.9448005676269531e+01 1.9913700103759766e+01 3.6595001220703125e+01 9.3900001525878906e+01 -9.0875005722045898e+00 3.9289199829101562e+01 9.3900001525878906e+01 2.6764400482177734e+01 3.6317798495292664e-01 9.3900001525878906e+01 1.8313100814819336e+01 1.0928699493408203e+01 1.0600499725341797e+02 3.7710399627685547e+01 -1.5080300331115723e+01 1.0130699920654297e+02 3.6695701599121094e+01 -1.5872699737548828e+01 1.0600000000000000e+02 2.0312500000000000e+01 2.1466699600219727e+01 1.0650000000000000e+02 1.9412500381469727e+01 2.2666700363159180e+01 1.0650000000000000e+02 -2.7402299880981445e+01 5.5203098058700562e-01 1.0650000000000000e+02 -2.7587499618530273e+01 -3.9223200082778931e-01 1.0600000000000000e+02 -2.6939399719238281e+01 3.6317798495292664e-01 9.3900001525878906e+01 3.7635597229003906e+01 -1.5554800033569336e+01 9.3900001525878906e+01 3.8502201080322266e+01 -1.3257499694824219e+01 9.3900207519531250e+01 4.0495998382568359e+01 -5.6626601219177246e+00 9.3403602600097656e+01 3.9685398101806641e+01 -1.1262900352478027e+01 9.3900100708007812e+01 3.8247600555419922e+01 1.4279799461364746e+01 9.3900001525878906e+01 2.0312500000000000e+01 2.1466699600219727e+01 9.3900001525878906e+01 4.0478500366210938e+01 5.0050797462463379e+00 9.1900001525878906e+01 3.5986999511718750e+01 1.9333099365234375e+01 1.0650000000000000e+02 2.7227298736572266e+01 5.5203098058700562e-01 1.0650000000000000e+02 2.7447898864746094e+01 1.1119500160217285e+01 1.0650000000000000e+02 -9.0512905120849609e+00 2.8470100402832031e+01 9.3900001525878906e+01 3.7512500762939453e+01 -1.4666699171066284e+00 1.0600000000000000e+02 3.7512500762939453e+01 -1.4666699171066284e+00 9.9817298889160156e+01 3.7823200225830078e+01 -2.0384600162506104e+00 1.0650000000000000e+02 2.7412500381469727e+01 -3.9223200082778931e-01 1.0650000000000000e+02 3.7412498474121094e+01 -2.6666698455810547e+00 9.3403198242187500e+01 3.4390399932861328e+01 -2.2877498626708984e+01 9.2387306213378906e+01 3.0786600112915039e+01 -2.7630100250244141e+01 9.2408302307128906e+01 3.6649398803710938e+01 -1.9086898803710938e+01 9.2399597167968750e+01 -3.2656497955322266e+01 -2.5475799560546875e+01 9.2416000366210938e+01 3.2024799346923828e+01 2.6073099136352539e+01 9.1900001525878906e+01 -2.4570699691772461e+01 3.2691398620605469e+01 9.1900001525878906e+01 -1.8576599121093750e+01 3.1771800994873047e+01 9.3900207519531250e+01 -1.8980400085449219e+01 -3.6389297485351562e+01 9.1900001525878906e+01 2.8560400009155273e+01 2.9231300354003906e+01 9.9875999450683594e+01 9.0505599975585938e+00 4.0098400115966797e+01 9.3900001525878906e+01 8.9125003814697266e+00 3.9289199829101562e+01 9.1900001525878906e+01 1.3297299385070801e+01 3.4903400421142578e+01 9.3900001525878906e+01 3.4007999420166016e+01 -2.2763601303100586e+01 9.3900299072265625e+01 3.6679397583007812e+01 -1.5887800216674805e+01 9.1900001525878906e+01 1.7298400878906250e+01 -3.7057003021240234e+01 9.3900001525878906e+01 -3.6087501525878906e+01 -1.6000000000000000e+01 1.0600000000000000e+02 -2.9087501525878906e+01 -1.6000000000000000e+01 1.0600000000000000e+02 -2.1810600280761719e+01 1.9702600479125977e+01 1.0650000000000000e+02 -2.3501298904418945e+01 1.6614999771118164e+01 1.0650000000000000e+02 -2.6674398422241211e+01 1.2384099960327148e+01 1.0650000000000000e+02 -2.3698600769042969e+01 9.6314802169799805e+00 9.2391700744628906e+01 6.3834495544433594e+00 4.2426898956298828e+01 9.3900001525878906e+01 -3.8087497711181641e+01 -1.4000000000000000e+01 9.3900001525878906e+01 -4.0095703125000000e+01 -8.3186407089233398e+00 1.0650000000000000e+02 -3.7587501525878906e+01 -2.6666698455810547e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -4.9265303611755371e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -1.4000000000000000e+01 1.0594300079345703e+02 1.6699501037597656e+01 1.8565099716186523e+01 9.3900001525878906e+01 1.5863999366760254e+01 1.9328399658203125e+01 1.0597799682617188e+02 -1.6018999099731445e+01 3.9784000396728516e+01 9.1900001525878906e+01 4.0520999908447266e+01 -5.2265801429748535e+00 9.2382598876953125e+01 1.3552900314331055e+01 -3.9082500457763672e+01 9.3900299072265625e+01 8.6850299835205078e+00 2.9167600631713867e+01 9.3900001525878906e+01 8.9125003814697266e+00 3.0199300765991211e+01 9.3900001525878906e+01 7.5170097351074219e+00 2.8283599853515625e+01 9.3403396606445312e+01 4.1101699829101562e+01 -3.9148898124694824e+00 1.0600000000000000e+02 3.7912498474121094e+01 -1.4000000000000000e+01 1.0650000000000000e+02 3.7412498474121094e+01 -1.4000000000000000e+01 1.0599199676513672e+02 -1.1893699645996094e+01 2.2043901443481445e+01 9.3900207519531250e+01 -1.4989999771118164e+01 2.0105001449584961e+01 9.2418403625488281e+01 4.0169498443603516e+01 -9.7180500030517578e+00 9.3401702880859375e+01 -9.5865297317504883e+00 4.1740497589111328e+01 9.3389503479003906e+01 3.7671600341796875e+01 -1.6828001022338867e+01 1.0600000000000000e+02 -2.7087499618530273e+01 -3.9223200082778931e-01 9.3412597656250000e+01 -4.1312900543212891e+01 -4.0082297325134277e+00 9.2414794921875000e+01 -4.1516300201416016e+01 -5.2713996171951294e-01 9.3900001525878906e+01 3.7912498474121094e+01 -2.6666698455810547e+00 9.3400001525878906e+01 2.1179000854492188e+01 3.5403800964355469e+01 9.3900207519531250e+01 2.6472499847412109e+01 3.1160200119018555e+01 1.0598500061035156e+02 9.3084707260131836e+00 4.0737899780273438e+01 9.9499000549316406e+01 -2.8394500732421875e+01 -1.5902200698852539e+01 1.0005900573730469e+02 -2.7663101196289062e+01 -1.5436699867248535e+01 9.1900001525878906e+01 1.1130999565124512e+01 4.0882503509521484e+01 1.0598899841308594e+02 -7.8268003463745117e+00 2.3793001174926758e+01 9.2390098571777344e+01 -3.3803199768066406e+01 2.3915498733520508e+01 9.1899902343750000e+01 -3.5675201416015625e+01 2.0122200012207031e+01 1.0650000000000000e+02 9.4125003814697266e+00 3.0199300765991211e+01 9.3900001525878906e+01 -2.6939399719238281e+01 3.6317798495292664e-01 1.0600000000000000e+02 -2.3235599517822266e+01 9.4426298141479492e+00 1.0016500091552734e+02 -3.7756099700927734e+01 -1.5144499778747559e+01 9.3900505065917969e+01 -3.7711799621582031e+01 -1.5224800109863281e+01 9.9814598083496094e+01 -3.6905601501464844e+01 -1.5854300498962402e+01 1.0600000000000000e+02 1.0912500381469727e+01 4.1289199829101562e+01 1.0341500091552734e+02 9.9233999252319336e+00 4.1065299987792969e+01 9.3900001525878906e+01 2.6912498474121094e+01 -8.0455598831176758e+00 9.3900001525878906e+01 2.6912498474121094e+01 -1.4000000000000000e+01 1.0600000000000000e+02 2.6912498474121094e+01 -1.4000000000000000e+01 1.0354100036621094e+02 -2.0188400268554688e+01 2.1996601104736328e+01 9.3900001525878906e+01 -2.0189100265502930e+01 2.2038200378417969e+01 9.5916702270507812e+01 -2.0487501144409180e+01 2.1466699600219727e+01 9.7154197692871094e+01 -2.0028099060058594e+01 3.7137798309326172e+01 9.1899902343750000e+01 -4.0211902618408203e+01 -7.8426403999328613e+00 9.3900001525878906e+01 1.2059900283813477e+01 1.6713600158691406e+01 9.9697906494140625e+01 1.9392900466918945e+01 3.7993598937988281e+01 9.2386795043945312e+01 1.9438899993896484e+01 3.7936401367187500e+01 1.0650000000000000e+02 1.9207901000976562e+01 3.7462398529052734e+01 1.0601200103759766e+02 1.9745201110839844e+01 3.7513496398925781e+01 1.0035599517822266e+02 -3.4069099426269531e+00 2.8835498809814453e+01 1.0598299407958984e+02 -3.8346300125122070e+00 2.8819200515747070e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -1.0350299835205078e+01 1.0650000000000000e+02 2.7412500381469727e+01 -1.4000000000000000e+01 9.3900001525878906e+01 -8.7499998509883881e-02 2.9000000000000000e+01 9.3900001525878906e+01 -3.2327999114990234e+01 2.5194601058959961e+01 9.9455902099609375e+01 -8.1943197250366211e+00 2.8504699707031250e+01 1.0599599456787109e+02 -8.8718595504760742e+00 2.9192899703979492e+01 9.8024703979492188e+01 8.0216798782348633e+00 2.8510099411010742e+01 1.0598199462890625e+02 8.6136703491210938e+00 2.9092199325561523e+01 9.7616302490234375e+01 8.7357902526855469e+00 2.9290100097656250e+01 9.3900001525878906e+01 3.3122398853302002e+00 2.8839399337768555e+01 9.3900001525878906e+01 -7.3392200469970703e+00 4.1708702087402344e+01 9.1900001525878906e+01 -2.1096599578857422e+01 3.4975299835205078e+01 1.0596800231933594e+02 -3.7815601348876953e+01 -1.5168800354003906e+01 9.3400901794433594e+01 4.9529399871826172e+00 4.2534103393554688e+01 9.3900001525878906e+01 -8.7683498859405518e-02 4.2300102233886719e+01 1.0126999664306641e+02 8.7984600067138672e+00 2.9463800430297852e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.0199300765991211e+01 1.0218899536132812e+02 7.2825798988342285e+00 2.8204401016235352e+01 1.0600000000000000e+02 6.9124999046325684e+00 2.8199300765991211e+01 9.3900001525878906e+01 -2.0087499618530273e+01 2.2666700363159180e+01 9.3900001525878906e+01 -2.0487501144409180e+01 2.1466699600219727e+01 1.0650000000000000e+02 -3.7587501525878906e+01 -1.4000000000000000e+01 1.0650000000000000e+02 -2.7587499618530273e+01 -1.4000000000000000e+01 9.8280403137207031e+01 2.7946001052856445e+01 -1.5811499595642090e+01 1.0268199920654297e+02 2.8152999877929688e+01 -1.5884300231933594e+01 9.3470703125000000e+01 -1.1087499618530273e+01 4.1289199829101562e+01 1.0600000000000000e+02 -1.1087499618530273e+01 4.1289199829101562e+01 9.3900100708007812e+01 7.0825800895690918e+00 2.4032499313354492e+01 9.3900100708007812e+01 1.1174400329589844e+01 2.2354200363159180e+01 9.3900001525878906e+01 1.8604499816894531e+01 1.6615100860595703e+01 9.3400001525878906e+01 1.9836999893188477e+01 3.7159000396728516e+01 9.4666503906250000e+01 1.3333999633789062e+01 4.0641201019287109e+01 9.1900001525878906e+01 -7.3356599807739258e+00 -4.0374698638916016e+01 9.8919898986816406e+01 2.6872598648071289e+01 2.4476198479533195e-02 9.3900001525878906e+01 2.6912498474121094e+01 -3.9223200082778931e-01 1.0600000000000000e+02 2.6912498474121094e+01 -3.9223200082778931e-01 1.0600000000000000e+02 1.9912500381469727e+01 3.0176500320434570e+01 1.0600000000000000e+02 -3.0159299850463867e+01 8.5709695816040039e+00 9.3523300170898438e+01 -2.0087499618530273e+01 3.6614700317382812e+01 9.2400001525878906e+01 2.1179000854492188e+01 3.5403800964355469e+01 1.0600399780273438e+02 2.7398899078369141e+01 -1.5334899902343750e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -3.9223200082778931e-01 9.8919395446777344e+01 -2.7047599792480469e+01 2.4511799216270447e-02 9.3900001525878906e+01 1.5882499694824219e+01 -3.7669597625732422e+01 9.3900001525878906e+01 6.8354401588439941e+00 -4.0268199920654297e+01 9.1900001525878906e+01 -4.0944000244140625e+01 2.4558799266815186e+00 9.1900001525878906e+01 -3.9046298980712891e+01 1.2369800567626953e+01 9.1900001525878906e+01 -8.7499998509883881e-02 4.2300102233886719e+01 9.8157798767089844e+01 9.4639606475830078e+00 4.0718399047851562e+01 9.7581398010253906e+01 1.0627600669860840e+01 4.1296298980712891e+01 9.3900001525878906e+01 -2.6477800369262695e+01 1.4946999549865723e+00 9.1900001525878906e+01 1.9355899810791016e+01 3.7022998809814453e+01 9.1900001525878906e+01 1.9059200286865234e+01 3.7578601837158203e+01 9.1900001525878906e+01 -5.2440600395202637e+00 4.2013500213623047e+01 1.0650000000000000e+02 -1.8749300003051758e+01 3.7960903167724609e+01 9.1899902343750000e+01 -1.7429599761962891e+01 -3.7005599975585938e+01 9.1900001525878906e+01 -3.3679000854492188e+01 -2.3326900482177734e+01 1.0650000000000000e+02 2.0976900100708008e+01 1.4521100044250488e+01 9.1900001525878906e+01 2.0921598434448242e+01 3.4975299835205078e+01 9.3900001525878906e+01 2.0016700744628906e+01 2.2030399322509766e+01 1.0650000000000000e+02 3.7334400177001953e+01 -2.1894900798797607e+00 1.0650000000000000e+02 -3.7511299133300781e+01 -2.1952900886535645e+00 1.0118400573730469e+02 -8.9532308578491211e+00 2.9394100189208984e+01 9.3400001525878906e+01 -8.7683498859405518e-02 4.2800003051757812e+01 9.9951400756835938e+01 6.4147200584411621e+00 2.8265998840332031e+01 9.3900001525878906e+01 6.4608902931213379e+00 2.8250999450683594e+01 1.0600000000000000e+02 -8.7499998509883881e-02 2.5000000000000000e+01 9.3900001525878906e+01 -8.7499998509883881e-02 2.5000000000000000e+01 1.0599700164794922e+02 1.8315600156784058e+00 2.4939199447631836e+01 1.0650000000000000e+02 1.9912500381469727e+01 2.1166700363159180e+01 1.0600000000000000e+02 2.4416099548339844e+01 1.5995201110839844e+01 9.2400001525878906e+01 1.9836999893188477e+01 3.7159000396728516e+01 1.0650000000000000e+02 8.1638097763061523e+00 2.8034999847412109e+01 1.0650099945068359e+02 2.8099599838256836e+01 -1.5283200263977051e+01 9.6401603698730469e+01 1.9813100814819336e+01 3.7308498382568359e+01 9.1900001525878906e+01 -3.7668601989746094e+01 -1.6015399932861328e+01 1.0600000000000000e+02 3.7912498474121094e+01 -2.6666698455810547e+00 9.3402099609375000e+01 2.9712099075317383e+01 -2.8631700515747070e+01 9.3402198791503906e+01 -3.6710697174072266e+01 1.9200698852539062e+01 9.2392494201660156e+01 3.7046501159667969e+01 1.8352899551391602e+01 9.2400001525878906e+01 -2.1354000091552734e+01 3.5403800964355469e+01 9.3408401489257812e+01 8.5287199020385742e+00 -4.0435798645019531e+01 9.3401603698730469e+01 3.8474102020263672e+01 1.4962200164794922e+01 9.1900001525878906e+01 3.3029602050781250e+01 -2.3929498672485352e+01 9.1899902343750000e+01 2.6627099990844727e+01 -3.1037099838256836e+01 1.0600000000000000e+02 -2.7087499618530273e+01 -1.1732000350952148e+01 9.3900001525878906e+01 -2.9087501525878906e+01 -1.6000000000000000e+01 9.1900001525878906e+01 -3.0592100143432617e+01 2.7194398880004883e+01 1.0599500274658203e+02 -1.8377399444580078e+01 1.7063899993896484e+01 9.3900001525878906e+01 2.5806499481201172e+01 -3.1690601348876953e+01 1.0600299835205078e+02 2.2216899871826172e+01 1.1318200111389160e+01 9.9225997924804688e+01 -9.3011999130249023e+00 2.3264499664306641e+01 9.3900001525878906e+01 -1.7346000671386719e+01 1.8108699798583984e+01 1.0600000000000000e+02 -2.2474498748779297e+01 1.1127499580383301e+01 1.0600599670410156e+02 -2.1236499786376953e+01 1.3425899505615234e+01 9.3900100708007812e+01 2.4200401306152344e+00 2.4885499954223633e+01 9.8757499694824219e+01 7.1863203048706055e+00 2.8196201324462891e+01 9.3900001525878906e+01 -2.5269300460815430e+01 3.2169597625732422e+01 9.9915901184082031e+01 -1.1181499481201172e+01 4.1294498443603516e+01 9.3900001525878906e+01 2.3060600280761719e+01 9.4426298141479492e+00 9.9622802734375000e+01 2.3060699462890625e+01 9.4426393508911133e+00 1.0650000000000000e+02 1.9412500381469727e+01 3.6614700317382812e+01 1.0650000000000000e+02 3.7195899963378906e+01 -1.4813000679016113e+01 1.0599400329589844e+02 5.3029298782348633e+00 2.4433099746704102e+01 9.8250595092773438e+01 -8.9470300674438477e+00 2.9379999160766602e+01 9.3900001525878906e+01 6.9124999046325684e+00 2.8199300765991211e+01 9.3900001525878906e+01 -3.5226501464843750e+01 -2.0819000244140625e+01 1.0650000000000000e+02 6.3479800224304199e+00 2.7763898849487305e+01 9.3900001525878906e+01 -2.7050298690795898e+01 -8.2228807732462883e-03 9.3900001525878906e+01 2.6874900817871094e+01 -6.4549399539828300e-03 1.0650300598144531e+02 -2.8052900314331055e+01 -1.5215000152587891e+01 9.1900001525878906e+01 3.7568000793457031e+01 -1.5989100456237793e+01 1.0650000000000000e+02 2.3523601531982422e+01 9.6314802169799805e+00 1.0600000000000000e+02 2.3799200057983398e+01 7.6321897506713867e+00 1.0600000000000000e+02 -2.7087499618530273e+01 -1.4000000000000000e+01 1.0650000000000000e+02 6.9124999046325684e+00 2.7699298858642578e+01 1.0600000000000000e+02 1.9912500381469727e+01 3.6614700317382812e+01 9.9157600402832031e+01 7.5321698188781738e+00 2.3816699981689453e+01 1.0600000000000000e+02 2.6764400482177734e+01 3.6317798495292664e-01 1.0650000000000000e+02 -1.9530401229858398e+01 3.7023101806640625e+01 1.0599599456787109e+02 -2.8217500686645508e+01 -1.5851400375366211e+01 1.0600000000000000e+02 -1.8969900131225586e+01 3.8409599304199219e+01 9.5440902709960938e+01 -1.9573900222778320e+01 3.7986301422119141e+01 1.0650000000000000e+02 -3.7287498474121094e+01 -1.7666699886322021e+00 1.0600000000000000e+02 2.3060600280761719e+01 9.4426298141479492e+00 9.3900001525878906e+01 -2.0074699401855469e+01 1.5094799995422363e+01 9.9317398071289062e+01 2.7066400527954102e+01 -1.4834500312805176e+01 9.3899803161621094e+01 2.7680799484252930e+01 -1.5657700538635254e+01 1.0650499725341797e+02 -3.7295898437500000e+01 -1.5037000656127930e+01 9.2400093078613281e+01 2.0340499877929688e+01 3.6153301239013672e+01 9.1900001525878906e+01 0.0000000000000000e+00 4.4408897162204620e-16 9.1900001525878906e+01 5.3135099411010742e+00 5.3135099411010742e+00 9.1900001525878906e+01 2.8756501674652100e+00 6.9424300193786621e+00 5.1869300842285156e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 6.1474899291992188e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 4.6094802856445312e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -1.1102199806005023e-16 -4.4408897162204620e-16 -2.4500000000000000e+01 -2.8756501674652100e+00 -6.9424300193786621e+00 -2.4500000000000000e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 6.9424300193786621e+00 -2.8756501674652100e+00 1.0332200050354004e+01 6.9424300193786621e+00 -2.8756501674652100e+00 6.7281899452209473e+00 1.5133799752220511e-04 -7.5142202377319336e+00 3.3475898742675781e+01 -2.8849399089813232e+00 -6.9405999183654785e+00 5.7977900505065918e+00 -2.8732600212097168e+00 -6.9429302215576172e+00 6.0673599243164062e+01 -2.8732199668884277e+00 -6.9431900978088379e+00 7.1780097961425781e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 6.6000999450683594e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -4.5272803306579590e+00 -6.9424300193786621e+00 -2.8756501674652100e+00 8.0891599655151367e+00 -7.5144300460815430e+00 -3.1380999132579745e-08 9.1900001525878906e+01 -6.9424300193786621e+00 2.8756501674652100e+00 9.1900001525878906e+01 -5.3135099411010742e+00 5.3135099411010742e+00 5.1116802215576172e+01 -5.3135099411010742e+00 5.3135099411010742e+00 2.7307100296020508e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.1490200042724609e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 6.9424300193786621e+00 -2.8756501674652100e+00 9.1900001525878906e+01 7.5144300460815430e+00 0.0000000000000000e+00 -2.4500000000000000e+01 -5.3135099411010742e+00 5.3135099411010742e+00 -2.4500000000000000e+01 -2.8756501674652100e+00 6.9424300193786621e+00 4.4179397583007812e+01 5.3135099411010742e+00 -5.3135099411010742e+00 1.8716899871826172e+01 2.8756501674652100e+00 -6.9424300193786621e+00 1.0601899147033691e+01 5.3135099411010742e+00 -5.3135099411010742e+00 5.8955596923828125e+01 2.8756501674652100e+00 -6.9424300193786621e+00 7.4340003967285156e+01 2.8756501674652100e+00 -6.9424300193786621e+00 3.8972499847412109e+01 -2.1143201738595963e-03 -7.5146799087524414e+00 6.5296798706054688e+01 2.8756501674652100e+00 6.9424300193786621e+00 3.5107299804687500e+01 5.3135099411010742e+00 5.3135099411010742e+00 -2.4500000000000000e+01 2.8756501674652100e+00 6.9424300193786621e+00 6.8251299858093262e+00 2.8756501674652100e+00 6.9424300193786621e+00 -2.4500000000000000e+01 5.3135099411010742e+00 5.3135099411010742e+00 2.5188499450683594e+01 -6.9424300193786621e+00 2.8756501674652100e+00 6.9428199768066406e+01 -7.5144300460815430e+00 -1.2178499098070006e-08 9.1900001525878906e+01 2.8756501674652100e+00 -6.9424300193786621e+00 9.1900001525878906e+01 5.3135099411010742e+00 -5.3135099411010742e+00 5.7016399383544922e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 4.4472702026367188e+01 7.5144300460815430e+00 2.0245298770760201e-08 2.0877799987792969e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 -7.5144300460815430e+00 9.9920103979999611e-16 9.1900001525878906e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -2.4500000000000000e+01 7.5144300460815430e+00 -1.6653300900147617e-15 1.4758699417114258e+01 6.9424300193786621e+00 2.8756501674652100e+00 3.5491500854492188e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.4586601257324219e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 5.9062400817871094e+01 -2.8756501674652100e+00 6.9424300193786621e+00 9.1900001525878906e+01 -2.8756501674652100e+00 6.9424300193786621e+00 9.1900001525878906e+01 5.5511103585654544e-16 7.5144300460815430e+00 -2.4500000000000000e+01 -6.9424300193786621e+00 2.8756501674652100e+00 9.1900001525878906e+01 -3.3306698679688577e-16 -7.5144300460815430e+00 2.9183700680732727e-01 2.8756501674652100e+00 -6.9424300193786621e+00 -1.4862899780273438e+01 2.8756501674652100e+00 -6.9424300193786621e+00 8.1460403442382812e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 8.3242797851562500e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 7.6513404846191406e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.1208099365234375e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.7816101074218750e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -1.4432900378918219e-15 -7.5144300460815430e+00 9.1900001525878906e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 8.7725997924804688e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 7.9441596984863281e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 4.0302101135253906e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 6.9424300193786621e+00 2.8756501674652100e+00 9.1105003356933594e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3711900711059570e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3540299415588379e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -2.4500000000000000e+01 1.4432900378918219e-15 7.5144300460815430e+00 -2.4500000000000000e+01 6.9424300193786621e+00 2.8756501674652100e+00 1.7158500671386719e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3821800231933594e+01 -2.8756501674652100e+00 6.9424300193786621e+00 6.1954299926757812e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.8361301422119141e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.1056200414896011e-01 -5.3135099411010742e+00 -5.3135099411010742e+00 -4.1209101676940918e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 8.3293998718261719e+01 -2.8750801086425781e+00 -6.9430499076843262e+00 2.3951499938964844e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.1386799812316895e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -7.5144300460815430e+00 7.7715601135849117e-16 -2.4500000000000000e+01 2.8756501674652100e+00 -6.9424300193786621e+00 1.5545199394226074e+01 -2.9718497884800854e-08 7.5144300460815430e+00 9.1900001525878906e+01 -2.8756501674652100e+00 -6.9424300193786621e+00 3.9963302612304688e+01 2.8756501674652100e+00 -6.9424300193786621e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2979 -> 30 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00) (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_forearm_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_l_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.6910000000000011e+01 1.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 856 1 0 953 856 0 477 0 484 0 34 484 2 34 0 953 0 477 2 147 33 34 2 33 2 1 147 33 30 34 34 32 484 34 30 32 477 484 32 30 31 32 476 477 32 476 32 486 486 32 31 485 476 486 718 850 476 485 718 476 476 850 477 902 485 486 902 718 485 902 486 717 31 844 486 486 844 717 902 717 718 717 646 718 717 778 646 717 844 778 778 844 647 31 290 844 844 290 647 778 647 646 646 647 620 4 718 646 620 4 646 620 647 36 290 36 647 290 37 36 31 37 290 35 36 37 620 36 396 36 35 396 4 620 396 395 4 396 35 481 396 396 481 546 546 395 396 35 37 481 37 472 481 37 31 470 472 37 470 546 481 545 481 472 923 481 923 545 545 483 546 597 395 546 546 483 597 545 923 483 923 472 483 469 472 470 483 472 469 478 483 469 483 478 597 597 478 543 543 395 597 468 478 469 478 468 479 543 478 479 468 469 470 468 38 466 468 466 479 468 470 38 479 466 480 479 480 543 466 38 467 466 467 471 466 471 480 543 480 688 689 480 471 688 480 689 471 467 734 689 471 690 690 471 734 38 22 467 467 22 734 406 733 734 21 734 22 406 734 21 733 690 734 688 689 690 733 688 690 543 688 408 733 408 688 406 408 733 406 407 408 407 406 21 21 22 23 21 23 407 38 491 22 22 491 23 23 748 407 23 491 489 748 23 489 408 407 832 832 407 791 748 791 407 748 489 853 748 853 791 488 489 490 488 853 489 489 491 490 853 488 791 791 792 148 148 832 791 791 488 792 792 488 490 490 491 896 740 490 896 740 792 490 148 792 740 149 148 740 684 740 896 684 149 740 465 464 896 465 896 491 684 896 464 683 684 464 684 69 149 70 684 683 69 684 70 463 464 465 464 463 683 470 463 39 31 683 463 463 465 39 470 31 463 470 39 38 38 39 40 465 40 39 40 491 38 491 40 465 30 487 31 487 458 31 31 458 683 487 680 458 19 680 487 19 487 473 473 487 30 458 459 216 216 593 458 680 459 458 458 593 683 64 459 680 64 680 19 459 499 216 64 493 459 493 499 459 216 217 218 216 218 593 216 499 217 593 316 683 593 218 316 259 218 260 316 218 259 218 68 70 260 218 70 218 217 68 316 259 683 259 260 683 260 70 683 68 69 70 68 217 272 68 272 69 272 217 232 777 686 217 217 686 232 497 217 499 217 497 777 231 183 232 232 686 231 183 272 232 682 686 777 682 231 686 456 777 497 682 777 456 681 682 456 682 681 231 231 681 183 456 367 681 849 681 367 183 681 849 456 361 457 456 457 367 456 497 361 361 362 191 497 362 361 457 361 191 367 457 191 365 366 367 367 191 365 818 849 367 745 367 366 818 367 528 367 745 528 528 745 529 366 529 745 528 529 530 528 530 963 963 818 528 530 529 366 963 530 859 859 530 366 859 366 860 366 365 860 859 860 381 963 859 381 818 963 381 381 365 190 818 381 190 860 365 381 190 191 192 192 631 190 631 892 190 190 892 818 365 191 190 362 138 191 192 191 178 178 191 138 192 178 736 736 631 192 892 631 736 178 735 736 735 171 736 171 892 736 169 170 171 171 735 169 170 892 171 297 169 298 169 297 752 170 169 752 169 735 829 169 829 298 170 752 818 170 818 892 181 183 818 818 183 849 818 752 181 181 182 183 181 752 182 267 183 182 272 183 267 182 269 267 182 752 269 269 270 267 270 269 879 269 752 879 271 268 270 268 267 270 271 270 301 270 879 301 301 879 373 373 879 752 752 122 373 752 297 122 120 121 122 300 373 122 120 122 297 122 121 300 297 298 120 120 298 732 972 120 732 120 972 121 300 121 49 121 972 47 121 47 49 919 47 972 732 735 972 972 735 919 732 298 829 829 735 732 178 180 735 735 716 919 180 715 735 715 716 735 178 179 180 138 137 178 137 913 178 913 179 178 179 715 180 715 433 716 284 433 715 179 284 715 179 283 284 283 996 284 996 433 284 179 433 283 283 433 996 538 433 179 538 179 913 913 795 914 913 137 795 538 913 914 537 434 538 538 956 537 433 538 434 914 956 538 914 795 797 956 914 797 795 796 797 795 340 796 795 137 340 796 387 797 956 797 387 537 956 387 387 388 250 537 387 311 387 250 311 410 388 387 410 387 796 340 411 796 411 410 796 388 410 411 388 411 342 340 342 411 340 341 342 342 341 898 388 342 802 802 342 898 898 341 769 994 898 769 898 994 802 388 802 803 803 802 651 802 994 651 994 426 425 994 425 651 426 994 769 768 426 769 769 341 194 194 768 769 424 425 426 424 426 867 426 768 867 651 425 652 652 425 494 425 424 494 424 820 494 424 867 820 495 867 961 867 768 961 820 867 495 494 820 495 494 495 496 495 554 496 495 961 554 961 934 549 934 961 768 961 549 554 496 554 275 554 276 275 549 999 554 554 999 276 494 496 932 932 496 275 275 276 277 932 275 883 275 277 883 277 276 326 935 326 276 935 276 999 999 549 935 326 935 327 935 551 327 549 551 935 326 327 328 572 277 326 326 328 572 650 328 327 551 648 327 648 650 327 549 550 551 551 766 648 550 766 551 648 649 650 767 649 648 648 766 767 765 766 550 765 767 766 550 934 765 934 550 549 765 934 193 765 930 767 930 765 193 930 931 767 936 649 767 931 936 767 1001 931 930 1001 930 193 193 194 195 934 194 193 195 1001 193 768 194 934 194 341 195 341 492 195 492 1000 195 1000 1001 195 1000 776 1001 776 931 1001 775 776 1000 492 775 1000 340 775 492 492 341 340 775 504 776 775 137 504 340 137 775 504 927 776 931 776 927 503 504 358 504 503 927 504 137 358 136 137 138 136 358 137 358 359 360 358 136 742 358 360 503 359 358 742 138 116 136 116 117 136 136 117 742 254 138 413 362 413 138 138 254 116 116 28 117 116 254 29 116 29 28 117 28 720 117 720 955 742 117 955 27 28 29 28 114 720 28 27 114 113 114 115 114 595 115 114 27 595 720 114 113 113 115 414 113 414 724 724 888 113 113 888 720 595 414 115 737 595 364 595 642 414 595 737 642 364 595 27 414 642 643 414 643 724 724 980 888 643 988 724 724 988 980 84 887 980 84 980 377 980 887 888 377 980 988 988 565 377 643 565 988 376 84 377 376 377 565 564 565 566 565 212 566 643 212 565 565 564 376 376 320 322 564 320 376 880 84 376 322 880 376 320 564 321 321 564 817 564 566 817 566 629 817 629 566 212 629 624 817 817 624 321 320 321 322 624 53 321 869 321 53 321 869 322 880 322 357 357 322 869 868 869 870 868 357 869 53 870 869 868 976 355 976 868 870 868 355 357 53 55 870 242 870 55 242 976 870 976 838 355 976 242 838 355 356 357 838 452 355 355 452 356 452 838 154 242 619 838 155 838 619 838 155 154 241 242 55 619 242 241 241 243 619 54 835 241 835 404 241 241 404 243 241 55 54 53 54 55 118 54 119 119 54 53 118 835 54 612 835 118 612 404 835 118 119 997 118 997 986 612 118 986 119 53 624 119 624 630 997 119 630 174 997 959 997 630 959 986 997 174 612 986 173 173 986 174 172 173 174 174 289 247 172 174 247 289 174 959 288 111 289 111 247 289 288 289 959 111 246 247 247 246 172 110 111 112 111 288 112 246 111 110 959 808 288 112 288 846 808 846 288 307 112 569 107 110 112 307 107 112 569 112 846 109 246 110 107 109 110 107 108 109 306 107 307 786 108 107 107 306 786 92 306 307 569 92 307 809 569 846 569 809 92 809 846 808 808 783 809 809 813 824 809 824 92 783 813 809 783 18 813 813 20 824 18 20 813 75 824 20 824 75 92 18 19 20 74 75 20 482 74 20 20 19 473 20 473 482 74 739 75 739 92 75 482 596 74 596 739 74 482 473 475 948 596 482 948 482 475 473 474 475 474 473 30 695 475 474 948 475 695 948 695 596 596 695 336 336 695 219 695 474 220 219 695 220 474 30 922 220 474 922 922 30 544 544 30 33 220 922 146 146 922 544 219 220 146 145 336 219 145 219 146 336 1 596 145 1 336 145 146 147 147 1 145 147 146 544 33 147 544 3 1 4 1 516 764 525 516 1 764 93 1 1 856 4 525 1 841 596 1 93 841 1 3 596 93 739 92 93 94 94 93 764 93 92 739 516 94 764 94 516 291 94 291 92 415 92 291 306 92 415 293 306 415 291 293 415 293 435 306 786 306 435 291 292 293 292 435 293 374 375 292 5 374 292 435 292 375 5 292 291 5 640 374 374 438 375 438 374 640 437 435 375 438 437 375 436 437 438 346 438 508 727 436 438 727 438 346 508 438 640 436 227 226 727 330 436 436 226 437 436 330 227 346 330 727 346 347 60 346 60 330 346 508 347 508 640 641 508 641 347 746 747 641 641 640 746 861 347 641 747 906 641 906 861 641 746 843 747 843 906 747 843 905 906 907 861 906 906 905 907 907 905 908 908 702 907 713 861 907 713 907 714 907 702 714 908 954 702 905 671 908 908 671 954 702 703 704 702 704 714 954 703 702 982 954 671 982 703 954 598 671 672 672 671 905 598 982 671 598 80 599 675 598 599 80 598 672 675 982 598 672 72 80 905 72 672 991 72 905 843 991 905 71 72 73 73 72 964 72 71 80 964 72 991 964 991 843 238 842 843 842 964 843 238 843 746 73 964 82 964 842 82 79 71 73 73 82 81 79 73 81 79 80 71 79 599 80 599 79 738 81 738 79 901 675 599 599 738 901 901 738 400 901 982 675 982 901 400 703 982 399 399 982 400 399 43 703 703 43 704 399 400 210 399 210 441 399 441 43 41 42 43 441 41 43 704 43 14 14 43 42 714 704 14 12 13 14 42 12 14 13 714 14 666 713 714 13 666 714 665 666 13 52 773 13 12 52 13 13 773 665 368 52 12 12 42 368 50 51 52 51 335 52 368 50 52 335 773 52 899 666 773 773 666 665 773 335 899 899 335 91 741 666 899 741 899 90 899 91 90 90 91 46 91 335 527 46 91 527 223 501 90 741 90 501 46 223 90 713 741 501 713 666 741 713 501 861 501 502 15 501 942 502 501 15 861 223 942 501 861 15 347 15 16 17 502 939 15 939 16 15 347 15 17 939 502 942 939 942 513 223 943 942 943 513 942 513 16 939 513 331 16 513 248 331 943 248 513 249 943 223 249 248 943 45 222 223 222 249 223 45 223 46 248 249 224 224 249 222 45 224 222 44 45 46 45 248 224 44 248 45 526 46 527 526 44 46 335 44 526 44 712 248 44 385 712 385 44 335 526 527 335 335 384 385 51 839 335 335 839 384 712 385 710 385 384 987 710 385 987 710 711 712 710 987 744 710 744 711 811 810 987 384 811 987 987 810 744 744 265 711 744 144 265 744 810 821 744 821 144 810 811 812 812 821 810 811 993 812 811 628 993 384 628 811 993 627 812 993 628 627 626 627 628 836 837 628 626 628 837 384 836 628 836 384 839 951 837 836 836 839 951 951 839 583 839 51 353 583 839 353 837 951 583 837 305 304 583 950 837 626 837 304 950 305 837 25 950 583 305 950 25 24 25 26 26 25 583 24 305 25 26 789 24 789 305 24 790 789 26 790 26 582 582 26 583 165 789 790 789 165 430 789 430 305 163 165 790 790 804 163 804 790 582 581 582 583 582 581 721 804 582 721 379 378 581 581 805 721 581 378 805 379 581 583 379 583 616 353 616 583 353 615 616 150 379 616 616 615 150 353 50 354 353 51 50 615 353 354 354 50 368 706 615 354 706 354 368 368 42 369 706 368 826 826 368 369 705 615 706 826 705 706 826 832 705 705 832 148 615 705 148 408 832 826 543 408 395 4 395 408 408 826 806 408 806 4 856 718 4 4 806 3 850 856 953 718 856 850 850 953 477 806 78 3 605 841 3 78 605 3 841 605 523 523 525 841 523 524 525 523 918 971 990 918 523 605 990 523 523 971 524 525 524 516 291 516 517 516 524 517 8 291 9 291 8 6 5 291 6 291 517 9 517 524 693 693 9 517 8 9 10 10 9 693 8 11 6 8 10 11 5 6 7 6 11 7 746 640 5 746 5 239 5 7 239 240 239 7 67 7 11 67 240 7 11 890 67 10 890 11 65 66 67 67 66 970 890 65 67 67 970 240 238 239 240 240 970 238 239 238 746 238 970 842 970 66 83 83 842 970 842 83 82 81 82 83 900 81 83 236 83 66 236 900 83 236 237 81 237 738 81 900 236 81 237 236 66 875 738 237 875 237 66 886 738 884 738 610 884 886 400 738 610 738 875 884 885 886 885 400 886 884 209 885 210 884 610 210 209 884 885 208 400 885 209 208 400 208 210 208 209 210 847 441 210 623 847 210 610 623 210 187 847 188 698 847 623 188 847 698 187 441 847 187 41 441 187 188 189 42 187 369 42 41 187 369 187 189 825 826 189 826 369 189 189 188 825 826 825 806 825 188 806 188 944 806 806 944 78 188 697 944 944 607 992 944 992 78 697 607 944 76 77 78 992 76 78 78 77 605 607 76 992 606 607 608 76 607 606 607 697 608 418 76 606 606 416 418 606 608 416 697 416 608 416 417 418 416 696 417 697 696 416 417 609 418 623 417 696 623 609 417 696 697 698 698 623 696 610 609 623 151 609 610 609 151 418 610 875 962 151 610 962 874 875 655 962 875 874 653 655 875 653 875 66 962 874 655 151 962 655 653 654 655 655 654 151 65 653 66 654 653 398 398 653 65 654 398 918 654 723 152 918 723 654 151 654 152 918 398 971 918 990 723 722 723 670 723 722 152 990 670 723 151 152 153 152 722 153 418 151 153 153 722 670 673 153 670 673 418 153 605 604 670 670 604 673 990 605 670 673 604 76 418 673 76 77 604 605 76 604 77 971 398 524 65 397 398 524 398 693 397 10 398 398 10 693 397 65 890 397 890 10 188 698 697 148 149 150 615 148 150 989 150 149 149 69 989 130 150 989 995 833 150 833 379 150 130 995 150 130 989 69 130 131 132 132 380 130 130 380 995 131 130 69 833 995 380 833 380 379 378 379 380 132 533 380 533 378 380 132 429 533 131 427 132 427 429 132 533 534 535 534 533 429 533 535 805 533 805 378 427 428 429 429 428 534 761 762 427 427 762 428 761 427 131 428 603 534 985 603 428 428 762 985 985 762 622 622 762 761 985 622 973 985 973 603 48 622 49 622 590 317 973 622 317 761 49 622 48 590 622 319 587 973 319 973 317 587 603 973 317 318 319 402 317 591 318 317 402 317 590 591 590 542 591 48 542 590 699 402 591 591 893 699 542 893 591 401 318 402 402 699 845 401 402 845 318 401 319 575 401 573 891 401 845 573 401 891 319 401 575 573 574 575 575 574 586 319 575 586 574 573 876 876 573 891 891 845 161 897 876 891 161 897 891 574 876 877 897 799 876 877 876 894 876 799 894 338 574 877 338 586 574 338 877 339 877 894 339 894 799 895 894 895 371 894 371 678 339 894 678 337 338 339 339 677 337 339 678 677 586 338 601 338 337 601 512 511 337 324 337 677 512 337 324 601 337 511 676 677 678 677 676 325 324 677 325 323 324 325 512 324 594 324 323 594 325 676 323 938 323 676 938 676 678 105 594 323 323 106 105 938 106 323 512 594 105 104 105 106 409 105 104 512 105 409 370 104 106 370 106 938 938 678 370 370 678 371 370 371 372 104 370 351 351 370 372 372 371 957 351 372 957 371 782 585 895 952 371 371 952 782 371 585 957 957 958 657 957 585 958 351 957 657 584 446 585 584 585 782 585 446 958 799 584 782 952 799 782 895 799 952 447 799 800 799 460 462 500 799 897 799 462 800 799 447 584 460 799 500 446 584 447 445 446 447 958 446 445 445 532 531 445 447 915 445 915 532 958 445 531 134 531 532 531 657 958 134 657 531 133 134 135 352 134 133 135 134 865 865 134 532 352 657 134 351 657 352 350 351 352 350 352 133 350 133 983 133 135 983 135 865 780 780 983 135 865 532 866 865 866 781 781 780 865 779 780 781 793 780 794 793 983 780 779 794 780 350 983 793 793 848 350 793 345 848 793 343 345 794 343 793 779 580 794 580 343 794 580 779 685 781 685 779 578 579 580 578 580 600 685 600 580 579 343 580 343 344 345 579 547 343 547 344 343 344 848 345 344 409 104 450 449 344 344 200 199 344 199 848 344 104 200 409 344 294 449 294 344 547 450 344 200 104 201 201 104 351 199 200 201 199 201 848 848 201 350 201 351 350 449 450 451 450 547 548 156 450 917 451 450 156 917 450 548 548 547 579 518 548 56 548 579 56 917 548 518 452 154 917 58 917 518 452 917 58 154 156 917 518 56 519 518 519 58 56 57 58 58 57 731 519 56 58 731 452 58 56 578 57 56 579 578 731 57 830 749 831 57 578 749 57 57 831 830 555 452 731 555 731 830 555 830 831 831 726 815 831 725 726 555 831 815 725 831 749 555 556 452 555 814 556 555 815 814 175 556 658 556 175 452 975 658 556 814 975 556 452 175 356 175 176 177 356 175 177 175 658 176 176 658 656 975 656 658 514 975 814 558 656 975 514 558 975 86 656 123 656 85 176 85 656 86 558 123 656 177 176 880 880 176 85 84 85 86 880 85 84 357 947 880 947 177 880 356 177 357 357 177 947 887 84 86 887 728 888 887 86 728 728 729 720 729 728 431 86 431 728 728 720 888 729 390 955 720 729 955 621 390 729 621 729 431 86 63 431 621 431 63 86 123 63 61 62 63 63 389 621 63 123 61 389 63 62 389 390 621 389 386 390 62 785 389 785 386 389 360 359 386 770 360 386 359 390 386 770 386 785 62 771 785 785 771 770 660 770 771 770 503 360 660 503 770 771 570 709 771 62 570 709 660 771 650 660 709 570 650 709 659 503 660 649 659 660 650 649 660 927 503 659 936 927 659 649 936 659 936 931 927 650 570 328 572 328 570 570 571 572 571 277 572 570 644 571 571 881 277 644 61 571 571 61 969 571 969 881 277 881 883 881 882 883 279 881 969 881 279 929 882 881 929 61 754 969 279 969 754 61 753 754 753 280 754 279 754 280 753 514 419 280 753 540 61 558 753 558 514 753 540 753 419 278 279 280 540 278 280 540 419 925 540 925 576 577 278 540 576 577 540 278 577 279 279 577 974 279 974 929 933 928 974 974 928 929 974 577 933 928 882 929 634 928 632 932 928 634 632 928 933 882 928 932 882 932 883 634 494 932 632 633 634 633 494 634 632 730 633 912 632 933 912 730 632 633 281 652 633 652 494 730 281 633 707 708 730 708 282 730 281 730 282 912 707 730 567 912 933 567 707 912 707 204 708 204 707 567 203 708 204 439 708 203 439 282 708 281 282 251 439 440 282 251 282 440 439 203 635 439 635 440 202 203 204 635 203 636 203 202 636 635 636 637 252 635 637 252 440 635 251 440 252 250 251 252 872 281 251 251 250 872 872 250 862 872 862 281 949 803 250 388 949 250 803 862 250 252 311 250 803 651 862 281 862 652 862 651 652 949 388 803 311 252 312 312 537 311 432 537 312 312 645 432 541 645 312 312 252 541 432 434 537 432 433 434 454 432 645 432 878 433 432 454 878 645 541 455 455 454 645 453 454 455 878 454 852 852 454 453 716 878 852 878 716 433 851 852 453 919 852 851 716 852 919 48 453 455 453 48 851 455 541 542 542 48 455 47 48 49 851 48 47 851 47 919 49 299 300 761 299 49 552 299 816 300 299 552 816 299 761 300 552 553 553 373 300 816 855 552 855 553 552 855 816 274 131 274 816 816 761 131 553 855 274 553 274 373 69 274 131 373 274 69 272 266 69 266 373 69 272 267 273 273 266 272 266 267 268 273 267 266 266 268 373 373 268 271 271 301 373 541 893 542 541 252 864 541 864 893 864 252 893 252 699 893 162 252 637 827 252 162 252 827 845 252 845 699 160 161 162 160 162 637 827 162 161 636 160 637 460 500 160 160 500 161 636 460 160 845 827 161 161 500 897 460 461 462 636 461 460 636 202 461 461 663 662 461 998 462 461 202 663 662 998 461 979 800 462 998 979 462 998 662 979 661 662 663 979 662 871 662 310 871 310 662 661 871 915 979 979 915 447 447 800 979 871 310 98 539 915 871 871 98 539 532 915 539 100 539 98 100 99 539 866 539 442 532 539 866 539 99 442 98 99 100 442 99 443 99 725 443 99 98 725 442 443 444 685 442 444 781 442 685 866 442 781 443 749 444 443 725 749 725 98 726 310 726 98 815 726 383 383 726 310 308 309 310 310 309 383 308 310 661 382 383 309 382 815 383 515 814 815 420 515 815 420 815 382 382 664 420 309 308 382 308 664 382 661 664 308 663 664 661 421 664 694 664 663 694 420 664 421 419 420 421 515 420 419 514 515 419 514 814 515 925 419 421 694 921 421 921 925 421 924 576 925 925 921 924 332 924 921 694 941 921 941 332 921 334 576 924 334 924 332 576 334 577 332 333 334 568 577 334 334 333 568 772 926 332 772 332 941 926 333 332 694 772 941 694 204 772 772 204 926 926 204 333 333 567 568 333 204 567 937 568 567 937 577 568 937 933 577 937 567 933 694 202 204 694 663 202 749 600 444 749 578 600 685 444 600 558 61 123 62 61 644 62 909 570 644 909 62 570 909 644 390 359 742 742 955 390 154 155 156 451 156 155 155 618 451 618 155 619 449 451 294 294 451 828 618 828 451 295 618 619 828 618 295 245 619 243 295 619 245 294 295 296 295 245 296 828 295 294 405 409 294 405 294 296 296 403 405 244 296 245 296 244 403 243 244 245 243 404 403 243 403 244 403 404 405 405 404 409 409 404 612 611 612 613 611 409 612 613 612 173 261 409 611 262 611 613 261 611 262 639 613 173 639 262 613 422 173 423 172 423 173 639 173 422 422 638 639 638 262 639 261 262 263 263 262 638 984 409 261 984 261 263 233 920 263 263 834 233 920 984 263 638 834 263 920 409 984 920 589 409 589 512 409 946 589 920 946 920 233 946 233 235 946 235 589 588 510 589 589 592 588 589 510 512 592 589 235 510 511 512 602 511 510 588 602 510 592 535 588 602 588 534 534 588 535 592 234 535 234 592 235 233 234 235 617 234 233 234 804 535 617 804 234 535 804 805 163 804 617 805 804 721 163 164 165 163 617 759 164 163 759 164 314 165 314 164 315 315 164 674 674 164 759 165 314 430 313 314 315 509 314 313 509 430 314 313 315 784 674 945 315 784 315 945 758 945 674 758 674 759 916 945 758 916 784 945 285 784 916 562 313 784 784 285 562 561 313 562 509 313 561 561 562 563 563 562 285 285 286 287 916 286 285 788 285 287 788 563 285 916 758 286 286 873 823 758 873 286 286 823 287 788 287 394 287 823 394 822 394 823 822 823 873 422 873 758 172 873 423 822 873 172 423 873 422 822 172 246 109 822 246 822 109 394 109 108 801 801 394 109 108 394 801 108 393 394 700 701 108 87 89 108 701 87 108 786 700 108 89 393 108 89 788 393 393 788 394 87 88 89 88 788 89 787 788 129 787 563 788 129 788 88 87 129 88 127 128 129 127 129 87 819 129 128 129 819 787 561 563 787 561 787 819 614 303 819 303 509 819 911 819 128 614 819 911 819 509 561 302 303 304 302 430 303 303 430 509 614 304 303 304 305 302 305 430 302 614 854 304 854 812 304 304 812 626 614 142 854 812 854 142 812 142 821 626 812 627 142 143 144 614 143 142 821 142 144 144 264 265 264 144 967 143 967 144 265 264 141 139 264 967 264 139 141 265 141 711 774 711 141 774 712 711 712 774 965 141 966 774 965 774 966 712 965 248 248 965 557 965 966 557 966 559 557 141 560 966 966 560 559 559 560 140 559 140 391 557 559 391 141 140 560 139 140 141 140 139 96 391 140 95 140 96 95 391 392 205 391 95 392 205 557 391 95 96 97 392 95 960 960 95 97 96 139 968 97 96 968 968 139 967 968 967 143 97 968 798 968 143 978 978 798 968 97 798 412 960 97 412 412 807 960 807 392 960 253 412 128 798 128 412 412 253 807 798 978 128 911 128 978 143 911 978 143 614 911 127 253 128 253 127 87 253 87 807 87 701 807 392 807 349 701 349 807 700 349 701 348 206 349 392 349 206 700 348 349 392 206 205 205 206 207 348 700 206 206 700 207 786 207 700 205 207 940 435 207 786 435 940 207 205 940 557 940 763 557 437 940 435 940 437 763 248 557 448 557 763 448 226 763 437 448 763 719 226 719 763 248 448 331 331 448 329 329 448 719 329 719 226 225 226 227 329 226 225 329 330 331 225 330 329 330 16 331 225 227 330 16 330 60 59 16 60 17 16 59 59 60 347 347 17 59 638 422 760 422 758 760 638 760 757 638 757 834 760 758 757 757 758 759 834 757 617 617 757 759 233 834 617 603 602 534 601 602 603 586 603 587 586 601 603 602 601 511 319 586 587 19 18 64 18 667 669 18 507 667 783 507 18 101 18 669 18 101 64 101 103 64 103 493 64 101 102 103 102 101 669 103 213 221 102 213 103 221 493 103 213 102 215 669 215 102 230 215 669 213 215 230 229 214 230 214 213 230 669 229 230 229 625 228 229 669 625 214 229 228 213 214 197 197 214 198 198 214 228 198 228 166 228 625 166 166 167 168 166 840 167 166 168 198 840 166 625 168 167 157 840 158 167 167 158 157 168 157 863 198 168 981 981 168 863 157 158 159 27 157 159 863 157 27 158 625 159 840 625 158 159 625 364 364 27 159 27 29 863 863 29 692 981 863 692 692 679 981 981 679 198 691 679 692 29 691 692 29 254 691 254 258 691 521 679 691 258 521 691 257 258 256 257 521 258 256 258 254 687 257 256 687 521 257 520 521 522 185 679 521 185 521 520 522 521 687 255 522 687 687 256 255 254 255 256 185 520 255 520 522 255 255 186 185 255 254 186 184 185 186 185 184 679 857 679 184 186 857 184 679 857 198 857 858 198 858 857 536 536 857 186 196 197 198 196 198 858 858 536 196 213 197 196 213 196 536 756 904 536 213 536 221 756 536 186 904 221 536 755 756 743 743 756 186 903 904 756 903 756 755 904 493 221 904 903 977 904 977 493 903 755 977 755 743 910 755 910 977 493 977 910 493 910 497 493 497 499 910 743 497 413 497 498 498 497 743 497 413 362 413 498 254 254 498 889 889 498 743 889 186 254 889 743 186 363 125 364 125 737 364 625 363 364 737 643 642 125 643 737 643 125 212 125 211 212 211 629 212 750 211 751 211 750 629 505 211 125 211 505 751 624 629 630 629 750 630 959 630 750 783 750 751 750 783 808 750 808 959 507 783 751 751 505 507 505 506 507 667 507 506 506 668 667 506 126 668 506 124 126 506 505 124 667 668 669 363 669 668 126 363 668 124 125 126 126 125 363 505 125 124 625 669 363))
                   (list :vertices (let ((mat (make-matrix 1002 3))) (fvector-replace (array-entity mat) #f(-1.2468999862670898e+01 -3.9723799228668213e+00 6.4992804527282715e+00 -1.2259700775146484e+01 -4.8232102394104004e+00 9.5915098190307617e+00 -1.2469099998474121e+01 -3.9723799228668213e+00 7.7372398376464844e+00 -1.1248499870300293e+01 -5.1348104476928711e+00 6.3296699523925781e+00 -1.2259700775146484e+01 -4.8232197761535645e+00 1.8234599828720093e+00 4.5199198722839355e+00 -9.9936399459838867e+00 1.2656300544738770e+01 1.0525900125503540e+00 -8.9252195358276367e+00 1.2656300544738770e+01 1.6549700498580933e+00 -9.1108398437500000e+00 1.2403100013732910e+01 -4.0988898277282715e+00 -7.3378596305847168e+00 1.2656300544738770e+01 -7.1897602081298828e+00 -6.3854498863220215e+00 1.2656300544738770e+01 -6.1697001457214355e+00 -6.6997704505920410e+00 1.2403100013732910e+01 -1.7609100341796875e+00 -8.0582799911499023e+00 1.2403100013732910e+01 -1.0249300003051758e+00 -8.2850599288940430e+00 -1.2656300544738770e+01 4.5199198722839355e+00 -9.9936399459838867e+00 -1.2656300544738770e+01 1.6549700498580933e+00 -9.1108398437500000e+00 -1.2403100013732910e+01 6.4850397109985352e+00 -7.0131702423095703e+00 1.2792600393295288e+00 6.9717001914978027e+00 -6.3005099296569824e+00 6.4077000617980957e+00 6.5039496421813965e+00 -6.9507203102111816e+00 6.4160499572753906e+00 -1.3997900009155273e+01 -3.1436100006103516e+00 1.7327999114990234e+01 -1.4515100479125977e+01 -4.0282702445983887e+00 1.6200000762939453e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.4174999237060547e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -9.0204601287841797e+00 -1.2505499839782715e+01 -3.8669600486755371e+00 -8.9239597320556641e+00 -1.2484200477600098e+01 -3.9098598957061768e+00 -9.6969003677368164e+00 2.4653301239013672e+00 1.7317001342773438e+01 -1.3170300483703613e+01 6.9176201820373535e+00 1.2376099586486816e+01 -1.3162500381469727e+01 -2.2360601425170898e+00 2.0811300277709961e+01 -1.3162500381469727e+01 -2.4159500122070312e+01 -6.2754898071289062e+00 2.2972999572753906e+01 -3.2170398712158203e+01 -8.2487401962280273e+00 2.5059400558471680e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 2.0248399734497070e+01 -1.2662399291992188e+01 -3.7477099895477295e+00 7.8319096565246582e+00 -1.2970499992370605e+01 -3.6573300361633301e+00 2.2901000976562500e+00 -1.2573500633239746e+01 -3.8009400367736816e+00 5.9408802986145020e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 7.8881697654724121e+00 -1.2484200477600098e+01 -3.9098598957061768e+00 7.0624599456787109e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -2.0024199485778809e+00 -1.2484299659729004e+01 -3.9098799228668213e+00 -9.6985197067260742e-01 -1.2524399757385254e+01 -3.8409099578857422e+00 -1.8293800354003906e+00 -1.2605199813842773e+01 -3.7882800102233887e+00 -7.5229701995849609e+00 -1.2807399749755859e+01 -3.7095000743865967e+00 -5.9678897857666016e+00 -1.2767600059509277e+01 -3.7213799953460693e+00 -8.6283597946166992e+00 -3.7348401546478271e+00 -9.6158704757690430e+00 -1.2329899787902832e+01 -3.1280300617218018e+00 -7.6370201110839844e+00 -1.2403100013732910e+01 8.7329399585723877e-01 -1.1364899635314941e+01 -1.2318799972534180e+01 1.0703100204467773e+01 -7.2038497924804688e+00 -1.1134699821472168e+01 7.7888498306274414e+00 -6.2445998191833496e+00 -1.0708199501037598e+01 7.8256697654724121e+00 -6.1219301223754883e+00 -1.1171999931335449e+01 -2.1993900299072266e+01 -4.3255300521850586e+00 -2.4526199340820312e+01 -2.3448400497436523e+01 -3.2784500122070312e+00 -2.5642499923706055e+01 -2.0344799041748047e+01 -2.5829300880432129e+00 -2.3502201080322266e+01 -1.1917799711227417e+00 -3.1527099609375000e+00 -1.2656300544738770e+01 6.2891502380371094e+00 -4.2209100723266602e+00 -1.2782799720764160e+01 6.1553201675415039e+00 -4.6863098144531250e+00 -1.2656300544738770e+01 -2.2139501571655273e+01 2.5863601684570312e+01 2.0501499176025391e+01 -2.1425201416015625e+01 2.7268400192260742e+01 1.9481500625610352e+01 -2.5302400588989258e+01 2.7277299880981445e+01 2.1045299530029297e+01 -6.9466300964355469e+01 3.3302398681640625e+01 2.2395801544189453e+01 -7.2046302795410156e+01 3.1377199172973633e+01 2.3069599151611328e+01 -7.0832496643066406e+01 3.1005399703979492e+01 2.3329299926757812e+01 6.5056400299072266e+00 -6.9451603889465332e+00 7.9941797256469727e+00 6.5039496421813965e+00 -6.9507203102111816e+00 1.0265699386596680e+01 -8.3144500732421875e+01 -5.1153302192687988e+00 2.8096899032592773e+01 -7.5474998474121094e+01 -1.5825899124145508e+01 2.8096899032592773e+01 -6.2479598999023438e+01 -1.2624799728393555e+01 2.8096899032592773e+01 -1.4801699638366699e+01 -4.1313600540161133e+00 1.6200000762939453e+01 -3.7829699516296387e+00 -1.0163400650024414e+01 1.2222599983215332e+01 -2.6531100273132324e-01 -1.2549300193786621e+01 1.1706399917602539e+01 8.7329399585723877e-01 -1.1364899635314941e+01 1.2318799972534180e+01 -1.4801400184631348e+01 -4.1321501731872559e+00 -1.6200000762939453e+01 -1.3764300346374512e+01 -3.1246500015258789e+00 -1.7190198898315430e+01 -1.4514800071716309e+01 -4.0290498733520508e+00 -1.6200000762939453e+01 2.2106499671936035e+00 -1.3960100173950195e+01 -2.0790699124336243e-01 3.4323198795318604e+00 -1.3626199722290039e+01 1.5319299697875977e-01 2.2320101261138916e+00 -1.3986299514770508e+01 4.8962998390197754e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 1.2998600006103516e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 1.3617499351501465e+01 -1.1717700004577637e+01 -9.3561401367187500e+00 -4.2465898394584656e-01 -1.2008800506591797e+01 -8.4160299301147461e+00 3.8966000080108643e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 0.0000000000000000e+00 1.3559999465942383e+00 -1.3735700607299805e+01 0.0000000000000000e+00 2.2826800346374512e+00 -1.3991299629211426e+01 -4.2284898757934570e+00 1.3559999465942383e+00 -1.3735700607299805e+01 8.7694101333618164e+00 2.4698100090026855e+00 -1.3937099456787109e+01 8.7694101333618164e+00 1.8381600379943848e+00 -1.3701499938964844e+01 1.0737399101257324e+01 -3.2054100036621094e+01 6.2682800292968750e+00 2.7916500091552734e+01 -3.5307498931884766e+01 6.9998002052307129e+00 2.8040800094604492e+01 -3.4960601806640625e+01 4.6865496635437012e+00 2.8096899032592773e+01 1.6996000289916992e+01 -3.3174800872802734e+00 1.2577500343322754e+01 9.9698200225830078e+00 1.2566100120544434e+01 1.1364099502563477e+01 8.8271598815917969e+00 1.1986900329589844e+01 1.2798500061035156e+01 6.5754299163818359e+00 -6.7187600135803223e+00 -1.1521000862121582e+01 7.0703201293945312e+00 -5.9839997291564941e+00 -1.1557299613952637e+01 -6.3049201965332031e+00 -2.9044599533081055e+00 1.2972599983215332e+01 -1.2259400367736816e+01 -4.8232898712158203e+00 1.2660400390625000e+01 -9.9744796752929688e+00 -4.5425395965576172e+00 1.2656199455261230e+01 1.6979299545288086e+01 -7.7118597030639648e+00 1.0204299926757812e+01 1.7815399169921875e+01 -6.8035297393798828e+00 6.1348299980163574e+00 1.8233100891113281e+01 -6.0392799377441406e+00 9.8591594696044922e+00 -7.5310699462890625e+01 2.9075099945068359e+01 -2.2331199645996094e+01 -7.4115997314453125e+01 3.0917200088500977e+01 -6.3364000320434570e+00 -7.3991905212402344e+01 3.1087200164794922e+01 -2.0753999710083008e+01 -1.7933801651000977e+01 -4.4097299575805664e+00 1.9811000823974609e+01 -1.8381599426269531e+01 -4.6153502464294434e+00 1.9938400268554688e+01 -1.8535400390625000e+01 -4.7442803382873535e+00 1.9777198791503906e+01 -4.6186599731445312e+01 3.2449398040771484e+01 -1.9171899795532227e+01 -3.9010299682617188e+01 3.1170000076293945e+01 -1.2812999725341797e+01 -4.0568500518798828e+01 3.1447801589965820e+01 -1.9171899795532227e+01 -9.3643701076507568e-01 -1.2331299781799316e+00 1.3162500381469727e+01 7.4979400634765625e+00 1.1315800666809082e+01 1.3162500381469727e+01 -2.2360601425170898e+00 2.0811300277709961e+01 1.3162500381469727e+01 -2.7377400398254395e+00 8.1501903533935547e+00 1.3189200401306152e+01 -5.5910696983337402e+00 9.8823995590209961e+00 1.3536700248718262e+01 -5.0552597045898438e+00 -7.3047602176666260e-01 1.3541700363159180e+01 -3.0652400970458984e+01 -6.3191099166870117e+00 2.7726499557495117e+01 -2.8022499084472656e+01 -7.0541601181030273e+00 2.5820299148559570e+01 -2.5538499832153320e+01 -5.7663202285766602e+00 2.5932901382446289e+01 -3.6865699768066406e+01 -9.4052896499633789e+00 2.5059400558471680e+01 -3.6099399566650391e+01 -9.0500707626342773e+00 2.6140300750732422e+01 -1.6234600067138672e+01 2.6851600646972656e+01 1.6481698989868164e+01 -1.5578900337219238e+01 2.5394300460815430e+01 1.7527900695800781e+01 -2.1363500595092773e+01 -5.5741901397705078e+00 -2.1366701126098633e+01 -2.0411201477050781e+01 -4.7090196609497070e+00 -2.2788400650024414e+01 -2.0372501373291016e+01 -5.0616903305053711e+00 -2.1867599487304688e+01 -7.3012802124023438e+01 1.1470699310302734e+01 2.8096899032592773e+01 -1.9929201126098633e+01 -2.5044901371002197e+00 2.3149600982666016e+01 -2.0344799041748047e+01 -2.5829300880432129e+00 2.3502201080322266e+01 -1.9911499023437500e+01 -2.6179800033569336e+00 2.3137298583984375e+01 1.7851099014282227e+01 -2.8868699073791504e+00 1.1213200569152832e+01 1.7999500274658203e+01 -2.8110098838806152e+00 1.0229700088500977e+01 1.0173600196838379e+01 1.2668499946594238e+01 1.0229700088500977e+01 -1.1707900047302246e+01 -1.0305900573730469e+00 -1.6281200408935547e+01 -1.3814399719238281e+01 -1.2366698980331421e+00 -1.7900100708007812e+01 -1.2813099861145020e+01 8.6443700790405273e+00 -1.6657701492309570e+01 -6.7424400329589844e+01 3.5585800170898438e+01 -1.5192500114440918e+01 -6.9739402770996094e+01 3.4844497680664062e+01 -1.9329198837280273e+01 -6.9890800476074219e+01 3.4740299224853516e+01 -1.3068599700927734e+01 -3.8664299011230469e+01 -9.7858896255493164e+00 2.5666900634765625e+01 -3.8664299011230469e+01 -9.7859201431274414e+00 -6.0895299911499023e+00 -3.6865699768066406e+01 -9.4051599502563477e+00 2.5553998947143555e+00 1.7359399795532227e+01 -7.3857803344726562e+00 5.2850300073623657e-01 1.6201900482177734e+01 -8.2512598037719727e+00 6.4863600730895996e+00 1.5625000000000000e+01 -8.4799699783325195e+00 -3.5178201198577881e+00 1.8429599761962891e+01 -4.6149396896362305e+00 -1.0229800224304199e+01 1.8488298416137695e+01 -4.2356801033020020e+00 -5.2802896499633789e+00 1.8034099578857422e+01 -6.5168299674987793e+00 -9.8976402282714844e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 9.9036703109741211e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 9.4646701812744141e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 8.9752006530761719e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -1.3617499351501465e+01 -1.0752200126647949e+01 -3.0702002048492432e+00 -1.4689800262451172e+01 -8.5498199462890625e+00 -2.0437798500061035e+00 -1.4373999595642090e+01 -8.8484201431274414e+00 -1.0371999740600586e+01 1.0295099258422852e+01 -9.3663597106933594e+00 -1.0286300659179688e+01 1.0186400413513184e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 8.7694101333618164e+00 -4.7212001800537109e+01 3.0567699432373047e+01 2.2045299530029297e+01 -3.7275600433349609e+01 2.9620201110839844e+01 2.1652898788452148e+01 -5.6820701599121094e+01 3.2918598175048828e+01 2.1759700775146484e+01 -2.1543800354003906e+01 -5.6311798095703125e+00 2.1169200897216797e+01 -2.1525400161743164e+01 -5.6266598701477051e+00 2.1153800964355469e+01 -2.1363500595092773e+01 -5.5741901397705078e+00 2.1366701126098633e+01 -5.7192401885986328e+01 1.5727400779724121e+01 -2.7392900466918945e+01 -3.6246501922607422e+01 1.2408599853515625e+01 -2.7300899505615234e+01 -4.7573600769042969e+01 1.0629099845886230e+01 -2.7922698974609375e+01 -1.1501399278640747e+00 2.3098100662231445e+01 -1.1806599617004395e+01 1.0235599279403687e+00 2.2340299606323242e+01 -1.1137999534606934e+01 1.8424400091171265e+00 2.0947498321533203e+01 -1.2331600189208984e+01 -2.0471099853515625e+01 -5.3669600486755371e+00 2.0250000000000000e+01 -2.1715600967407227e+01 -5.6734995841979980e+00 2.0814899444580078e+01 -2.2813199996948242e+01 -5.9438600540161133e+00 2.0250000000000000e+01 -2.1642099380493164e+01 -5.6554098129272461e+00 -2.0250000000000000e+01 -2.3167098999023438e+01 -6.1690402030944824e+00 -1.9695999145507812e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -2.0250000000000000e+01 -6.7396001815795898e+00 2.4108900070190430e+01 1.3244400024414062e+01 -6.8111300468444824e+00 2.5263500213623047e+01 1.1734999656677246e+01 -9.2166500091552734e+00 2.4305500030517578e+01 1.4093100547790527e+01 -5.3998703002929688e+01 1.6689399719238281e+01 2.7050100326538086e+01 -3.5852001190185547e+01 1.0150699615478516e+01 2.7704900741577148e+01 -3.6246501922607422e+01 1.2408599853515625e+01 2.7300899505615234e+01 -3.6865699768066406e+01 -9.4052896499633789e+00 -2.5059400558471680e+01 -3.3109001159667969e+01 -8.3592500686645508e+00 -2.5973201751708984e+01 -3.2170398712158203e+01 -8.2487401962280273e+00 -2.5059400558471680e+01 -2.0274599075317383e+01 -6.1647500991821289e+00 -1.9253698348999023e+01 -1.9463399887084961e+01 -5.4603700637817383e+00 -1.9454500198364258e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 -1.8648300170898438e+01 -2.3977399826049805e+01 -9.3802804946899414e+00 1.9237499237060547e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 1.9237499237060547e+01 -2.2188899993896484e+01 -7.8271403312683105e+00 1.6200000762939453e+01 -8.5282297134399414e+00 -8.4679307937622070e+00 -1.2318799972534180e+01 -1.1204199790954590e+01 -8.3859004974365234e+00 -1.1267899513244629e+01 -9.5885000228881836e+00 -5.6457500457763672e+00 -1.2016500473022461e+01 -3.1619102478027344e+01 -9.1428298950195312e+00 -1.9237499237060547e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -1.6200000762939453e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -1.9173799514770508e+01 -8.0539199829101562e+01 -1.8201200485229492e+01 -1.1521100044250488e+01 -8.1597496032714844e+01 -1.7668201446533203e+01 -2.0089199066162109e+01 -7.9247604370117188e+01 -1.8652799606323242e+01 -1.6982500076293945e+01 -1.9463399887084961e+01 -5.4603700637817383e+00 1.9454500198364258e+01 -1.9552999496459961e+01 -5.2118301391601562e+00 1.9774299621582031e+01 -2.0416799545288086e+01 -5.5875201225280762e+00 1.9607500076293945e+01 -6.3738002777099609e+01 3.5578601837158203e+01 6.5812498331069946e-01 -6.0402301788330078e+01 3.4983898162841797e+01 3.0985200405120850e+00 -6.3738002777099609e+01 3.5578601837158203e+01 -6.5812498331069946e-01 -8.1343498229980469e+01 1.6503000259399414e+01 -2.7062200546264648e+01 -8.1813697814941406e+01 1.3203999519348145e+01 -2.7711000442504883e+01 -8.2870994567871094e+01 1.3630099296569824e+01 -2.6311100006103516e+01 1.4399399757385254e+01 -8.0869398117065430e+00 1.1998900413513184e+01 1.4841400146484375e+01 -6.6712498664855957e+00 1.3026099205017090e+01 1.3564299583435059e+01 -6.5236997604370117e+00 1.2960899353027344e+01 -3.6743099689483643e+00 -1.1660599708557129e+01 -1.0305999755859375e+01 -4.2065200805664062e+00 -1.1490400314331055e+01 -1.0306200027465820e+01 -4.5494699478149414e+00 -1.1222999572753906e+01 -1.1082200050354004e+01 -1.5663599967956543e+01 1.2680299758911133e+01 1.8732999801635742e+01 -2.2333801269531250e+01 1.5039600133895874e+00 2.4641700744628906e+01 -1.8950401306152344e+01 -5.0148200988769531e+00 1.9704099655151367e+01 -1.9560499191284180e+01 -5.1910400390625000e+00 1.9819000244140625e+01 -1.8805200576782227e+01 -4.8084197044372559e+00 2.0003700256347656e+01 -1.4816500663757324e+01 -4.1381201744079590e+00 -5.9119100570678711e+00 -1.5987800598144531e+01 -4.4253101348876953e+00 -1.6200000762939453e+01 -1.4801400184631348e+01 -4.1322402954101562e+00 -1.1137500762939453e+01 -1.2476700782775879e+01 -3.9411499500274658e+00 1.0080999374389648e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 9.9088802337646484e+00 -1.8682600021362305e+01 -4.8834199905395508e+00 1.9414600372314453e+01 7.8056902885437012e+00 -6.3070902824401855e+00 -1.0229800224304199e+01 7.7733201980590820e+00 -6.2963700294494629e+00 -1.0229800224304199e+01 7.8375797271728516e+00 -6.3176698684692383e+00 -1.0229800224304199e+01 7.7733201980590820e+00 -6.2963700294494629e+00 1.0229800224304199e+01 7.8056902885437012e+00 -6.3070902824401855e+00 1.0229800224304199e+01 7.7888598442077637e+00 -6.2445998191833496e+00 1.0708199501037598e+01 -2.0253499984741211e+01 -5.3109297752380371e+00 2.0218898773193359e+01 -1.9684999465942383e+01 -5.1407999992370605e+00 2.0137001037597656e+01 -1.9590099334716797e+01 -5.1089401245117188e+00 2.0123201370239258e+01 -1.8959199905395508e+01 -5.0460901260375977e+00 -1.6953500747680664e+01 -1.8677999496459961e+01 -4.9410200119018555e+00 -1.8645801544189453e+01 -6.8465900421142578e+00 2.5434799194335938e+01 -1.0693900108337402e+01 -6.7984600067138672e+00 2.5216499328613281e+01 -1.1873999595642090e+01 -7.0307302474975586e+00 2.5468399047851562e+01 -1.0730699539184570e+01 5.4230195283889771e-01 -1.3339400291442871e+01 1.0186499595642090e+01 6.6291794180870056e-02 -1.3118900299072266e+01 1.0295099258422852e+01 3.5693798065185547e+00 -1.2067600250244141e+01 1.1115400314331055e+01 3.3281998634338379e+00 -9.6264200210571289e+00 1.1927900314331055e+01 1.9329000711441040e+00 -1.1760899543762207e+01 1.2143399238586426e+01 -2.6596599578857422e+01 2.8676700592041016e+01 2.0053998947143555e+01 -3.0364299774169922e+01 2.8519001007080078e+01 2.1515800476074219e+01 -3.2134498596191406e+01 2.9944099426269531e+01 1.9171699523925781e+01 -3.2243801116943359e+01 2.9963600158691406e+01 1.9171899795532227e+01 -3.2244800567626953e+01 2.9958099365234375e+01 1.9357599258422852e+01 -4.5868897438049316e+00 2.1889400482177734e+01 1.3294899940490723e+01 -6.8786296844482422e+00 2.2554998397827148e+01 1.3689200401306152e+01 1.0780099868774414e+01 -7.3840303421020508e+00 -1.0229299545288086e+01 7.9849400520324707e+00 -6.3666200637817383e+00 -9.7502603530883789e+00 -7.5474998474121094e+01 -1.5825899124145508e+01 -2.8096899032592773e+01 -8.3144500732421875e+01 -5.1153302192687988e+00 -2.8096899032592773e+01 -3.4960601806640625e+01 4.6865601539611816e+00 -2.8096899032592773e+01 1.8121999740600586e+01 -3.7267000675201416e+00 1.1475500106811523e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 1.6200000762939453e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 1.6200000762939453e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 1.6200000762939453e+01 -3.1426000595092773e+01 -1.2474399566650391e+01 1.7586500167846680e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 1.9237499237060547e+01 -1.4514900207519531e+01 -4.0289001464843750e+00 -1.0148599624633789e+01 -1.4514900207519531e+01 -4.0289201736450195e+00 -1.0824300765991211e+01 -7.0307302474975586e+00 2.5468399047851562e+01 1.1930599212646484e+00 -6.2811598777770996e+00 2.5323999404907227e+01 8.8308601379394531e+00 -5.1029601097106934e+00 2.5061498641967773e+01 -9.2014297842979431e-02 1.7082599639892578e+01 -7.6317801475524902e+00 -5.2086601257324219e+00 1.6372600555419922e+01 -8.1343603134155273e+00 -1.0082700729370117e+01 -1.8381599426269531e+01 -4.6153502464294434e+00 -1.9938400268554688e+01 -1.8950401306152344e+01 -5.0148200988769531e+00 -1.9704099655151367e+01 -1.8805200576782227e+01 -4.8084197044372559e+00 -2.0003700256347656e+01 -1.9552999496459961e+01 -5.2118301391601562e+00 -1.9774299621582031e+01 -1.9560499191284180e+01 -5.1910400390625000e+00 -1.9819000244140625e+01 -1.9590099334716797e+01 -5.1089401245117188e+00 -2.0123201370239258e+01 -1.8682600021362305e+01 -4.8834199905395508e+00 -1.9414600372314453e+01 -1.8535400390625000e+01 -4.7442803382873535e+00 -1.9777198791503906e+01 -1.5709898948669434e+01 -2.6496000289916992e+00 -1.9353401184082031e+01 -8.5771003723144531e+01 -1.1238199234008789e+01 8.6786994934082031e+00 -8.5504898071289062e+01 -1.2630400657653809e+01 1.7258298873901367e+01 -8.5808395385742188e+01 -1.0856200218200684e+01 2.5666900634765625e+01 -8.4953704833984375e+01 5.5282402038574219e+00 2.6353700637817383e+01 -8.5409095764160156e+01 2.5775000452995300e-01 2.6810899734497070e+01 -8.3794303894042969e+01 8.1370296478271484e+00 2.7293899536132812e+01 -8.4496902465820312e+01 -5.4552202224731445e+00 -2.7859399795532227e+01 -8.3920501708984375e+01 1.1767899990081787e+00 -2.7920200347900391e+01 -3.2235397338867188e+01 -8.0054492950439453e+00 -2.6211301803588867e+01 -3.2233303070068359e+01 -8.0535802841186523e+00 -2.5843000411987305e+01 5.9477596282958984e+00 1.8598400115966797e+01 1.0229899406433105e+01 1.7649099826812744e+00 2.1988698959350586e+01 1.0890100479125977e+01 4.4711198806762695e+00 1.9349500656127930e+01 1.1871500015258789e+01 -8.2649297714233398e+00 1.0456899642944336e+01 1.4296099662780762e+01 -7.5794796943664551e+00 2.2704200744628906e+01 1.3865099906921387e+01 -1.2534000396728516e+01 -3.8350398540496826e+00 -4.3579798936843872e-01 -5.1284399032592773e+00 -3.3915398120880127e+00 1.2656300544738770e+01 6.1553602218627930e+00 -4.6861801147460938e+00 1.2656300544738770e+01 -1.1917500495910645e+00 -3.1527099609375000e+00 1.2656300544738770e+01 -4.9385200500488281e+01 3.3019901275634766e+01 1.9171899795532227e+01 -3.8531600952148438e+01 3.1011400222778320e+01 1.9901300430297852e+01 -3.5196399688720703e+01 3.0490100860595703e+01 1.9171899795532227e+01 -2.1136699676513672e+01 -5.5309100151062012e+00 -2.0822700500488281e+01 -2.1525400161743164e+01 -5.6266598701477051e+00 -2.1153800964355469e+01 -1.9929201126098633e+01 -2.5044901371002197e+00 -2.3149600982666016e+01 -1.9911499023437500e+01 -2.6179800033569336e+00 -2.3137298583984375e+01 -1.9684999465942383e+01 -5.1407999992370605e+00 -2.0137001037597656e+01 9.3636302947998047e+00 1.2259200096130371e+01 -1.2307199478149414e+01 9.9552602767944336e+00 1.2558500289916992e+01 -1.1385199546813965e+01 1.7250400543212891e+01 -3.1916201114654541e+00 -1.2400099754333496e+01 8.3363199234008789e+00 1.1740099906921387e+01 -1.3043000221252441e+01 -1.1279500722885132e+00 -2.6728100776672363e+00 1.2782799720764160e+01 -3.0875298976898193e+00 -2.3608798980712891e+00 1.2931300163269043e+01 -7.9667396545410156e+01 2.1551099777221680e+01 -7.7849397659301758e+00 -7.9124397277832031e+01 2.2711299896240234e+01 6.7944297790527344e+00 -7.8378700256347656e+01 2.4122501373291016e+01 -2.4199899673461914e+01 -5.1685897827148438e+01 -9.9661397933959961e+00 -2.8096899032592773e+01 -4.1871303558349609e+01 -7.5485901832580566e+00 -2.8096899032592773e+01 5.7027497291564941e+00 1.8850900650024414e+01 -1.0230400085449219e+01 4.9494004249572754e+00 1.9332698822021484e+01 -1.1386799812316895e+01 3.4745199680328369e+00 2.0812099456787109e+01 -1.0230200767517090e+01 -1.4514900207519531e+01 -4.0288801193237305e+00 -9.4729499816894531e+00 -2.5882299423217773e+01 6.5729398727416992e+00 -2.5915699005126953e+01 -2.7801700592041016e+01 8.5838298797607422e+00 -2.6338800430297852e+01 -2.4039199829101562e+01 1.7257900238037109e+01 -2.2966598510742188e+01 -2.7801700592041016e+01 8.5838403701782227e+00 2.6338800430297852e+01 -2.4689399719238281e+01 1.7569900512695312e+01 2.3172599792480469e+01 -2.9835699081420898e+01 1.0471699714660645e+01 2.6646598815917969e+01 -3.2243801116943359e+01 2.9963600158691406e+01 -1.9171899795532227e+01 -3.2134498596191406e+01 2.9944099426269531e+01 -1.9171699523925781e+01 -3.2244800567626953e+01 2.9958099365234375e+01 -1.9357599258422852e+01 -8.5030395507812500e+01 -1.3849199295043945e+01 2.5683200836181641e+01 -8.3256996154785156e+01 -1.6324600219726562e+01 2.5701200485229492e+01 -8.3782005310058594e+01 -1.5325400352478027e+01 2.6581800460815430e+01 7.7733201980590820e+00 -6.2963800430297852e+00 9.5904197692871094e+00 7.0217099189758301e+00 -6.2707200050354004e+00 1.0502500534057617e+01 7.7806801795959473e+00 -6.2986197471618652e+00 6.6971802711486816e+00 -8.3059402465820312e+01 1.3686499595642090e+01 -1.0157999992370605e+01 -8.3825904846191406e+01 1.1212299346923828e+01 -2.5673000335693359e+01 -8.3771400451660156e+01 1.1408599853515625e+01 4.6389899253845215e+00 7.3231196403503418e+00 -4.9986801147460938e+00 -1.2475100517272949e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 1.0522600173950195e+01 -2.7505100250244141e+01 2.8871700286865234e+01 -2.0221300125122070e+01 -2.7945199966430664e+01 2.7703599929809570e+01 -2.1552700042724609e+01 -3.2466899871826172e+01 2.8711000442504883e+01 -2.1660499572753906e+01 -7.4771903991699219e+01 -1.8679899215698242e+01 -2.5666900634765625e+01 -7.8437995910644531e+01 -1.8913499832153320e+01 -2.5915500640869141e+01 -7.7258293151855469e+01 -1.8657999038696289e+01 -2.6711400985717773e+01 -6.6294601440429688e+01 3.5746601104736328e+01 1.9609399795532227e+01 -6.3738002777099609e+01 3.5578601837158203e+01 1.9171899795532227e+01 -6.5297294616699219e+01 3.5755100250244141e+01 1.2447099685668945e+01 6.5754299163818359e+00 -6.7187600135803223e+00 1.1521000862121582e+01 5.9373202323913574e+00 -8.7896099090576172e+00 6.6695103645324707e+00 1.4505400657653809e+01 -5.6119298934936523e+00 1.3162500381469727e+01 1.5431400299072266e+01 -4.6149396896362305e+00 1.3162500381469727e+01 -6.5213394165039062e+01 3.5754699707031250e+01 -5.3641695976257324e+00 -6.3738002777099609e+01 3.5578601837158203e+01 -1.9171899795532227e+01 -6.5423103332519531e+01 3.5773197174072266e+01 -1.8596099853515625e+01 -1.1279500722885132e+00 -2.6728100776672363e+00 -1.2782799720764160e+01 -2.9760499000549316e+00 -3.0944697856903076e+00 -1.2656300544738770e+01 -3.5070602416992188e+01 2.1786800384521484e+01 2.4295400619506836e+01 -3.7007598876953125e+01 1.6523199081420898e+01 2.6201299667358398e+01 -3.3571800231933594e+01 1.3752599716186523e+01 2.6741498947143555e+01 -5.5210800170898438e+01 -1.3861700057983398e+01 2.5675899505615234e+01 -5.8108501434326172e+01 -1.4226099967956543e+01 2.6618700027465820e+01 -6.5610900878906250e+01 -1.6215900421142578e+01 2.6334899902343750e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -1.6200000762939453e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -4.8937501907348633e+00 -2.0114799499511719e+01 -4.5602002143859863e+00 2.2325199127197266e+01 -2.0671400070190430e+01 -5.1170496940612793e+00 2.2351400375366211e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 -1.6200000762939453e+01 -3.0750799179077148e+01 -1.3395999908447266e+01 -1.6200401306152344e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 -1.6200000762939453e+01 -4.3063602447509766e+00 -7.2739300727844238e+00 -1.2656300544738770e+01 -7.9056901931762695e+00 -6.1648397445678711e+00 -1.2403100013732910e+01 -4.5345703125000000e+01 3.2152801513671875e+01 -2.0257198333740234e+01 -5.8073497772216797e+01 3.3361198425292969e+01 -2.1627399444580078e+01 -5.3898498535156250e+01 3.3666698455810547e+01 -2.0286298751831055e+01 -1.8998699188232422e+01 -4.6136698722839355e+00 -2.0957500457763672e+01 6.5172100067138672e+00 -5.2400598526000977e+00 1.2515299797058105e+01 7.2640500068664551e+00 -5.3626699447631836e+00 1.2187999725341797e+01 -2.8788700103759766e+01 8.0465402603149414e+00 2.6805700302124023e+01 -2.9295900344848633e+01 2.6298601627349854e+00 2.7616500854492188e+01 -7.4663600921630859e+00 9.6977396011352539e+00 -1.4044400215148926e+01 -6.7237200736999512e+00 -8.6511200666427612e-01 -1.3970100402832031e+01 -9.9872703552246094e+00 1.0614800453186035e+01 -1.4986700057983398e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 -1.9237499237060547e+01 -7.9663406372070312e+01 2.1549299240112305e+01 2.5176801681518555e+01 -7.8378700256347656e+01 2.4122501373291016e+01 2.4199899673461914e+01 1.3725899696350098e+01 -6.1690597534179688e+00 -1.3083499908447266e+01 1.3075299263000488e+01 -7.6040601730346680e+00 -1.2196599960327148e+01 -6.7755897521972656e+01 -1.5935299873352051e+01 2.7407100677490234e+01 -6.0522998809814453e+01 -1.3709699630737305e+01 -2.7725700378417969e+01 -7.5249801635742188e+01 -1.6741300582885742e+01 -2.7983098983764648e+01 -6.6762901306152344e+01 -1.4503699302673340e+01 2.8012199401855469e+01 -5.4187301635742188e+01 -1.2421299934387207e+01 2.7538700103759766e+01 1.4696800231933594e+01 -8.6779699325561523e+00 1.0343199729919434e+01 1.6443500518798828e+01 -7.5257997512817383e+00 1.2014800071716309e+01 7.5706100463867188e+00 1.3780200004577637e+01 1.2959400177001953e+01 3.1823399066925049e+00 1.8640600204467773e+01 1.3034200668334961e+01 -1.2421900749206543e+01 -4.1541399955749512e+00 -4.5282101631164551e+00 -1.2468999862670898e+01 -3.9723701477050781e+00 -1.8569400310516357e+00 -6.1132202148437500e+00 -8.9653596878051758e+00 1.2327199935913086e+01 -8.5282297134399414e+00 -8.4679307937622070e+00 1.2318799972534180e+01 2.3100900650024414e-01 -1.2773900032043457e+01 -1.1537400245666504e+01 6.6291794180870056e-02 -1.3118900299072266e+01 -1.0295099258422852e+01 -3.1013799667358398e+01 1.1508500099182129e+01 -2.6688199996948242e+01 -2.8788700103759766e+01 8.0465402603149414e+00 -2.6805700302124023e+01 -3.3203502655029297e+01 3.0134700775146484e+01 1.7758001327514648e+01 -2.4825799942016602e+01 2.8641099929809570e+01 1.8163799285888672e+01 -4.1487602233886719e+01 3.1611598968505859e+01 1.4307600021362305e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -8.9752006530761719e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -9.9036703109741211e+00 -1.2259700775146484e+01 -4.8232102394104004e+00 -9.3602504730224609e+00 -3.1784002304077148e+01 2.9881599426269531e+01 1.4811899662017822e+00 -7.1686904907226562e+01 -1.6983200073242188e+01 -2.7335699081420898e+01 -7.4860198974609375e+01 -1.8286399841308594e+01 -2.6814899444580078e+01 1.8429599761962891e+01 -4.6149396896362305e+00 1.0229800224304199e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 5.2312502861022949e+00 -2.5633199691772461e+01 -4.6088900566101074e+00 2.6641799926757812e+01 -2.9760499000549316e+00 -3.0944697856903076e+00 1.2656300544738770e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 -8.7694101333618164e+00 -9.3663597106933594e+00 -1.0286300659179688e+01 -1.0186400413513184e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 0.0000000000000000e+00 -8.1791900634765625e+01 1.5954900741577148e+01 2.6767200469970703e+01 -8.0238800048828125e+01 2.0285900115966797e+01 2.5552999496459961e+01 -8.1184898376464844e+01 1.8335500717163086e+01 2.5733100891113281e+01 -3.6160202026367188e+00 2.4537000656127930e+01 1.1019499778747559e+01 -2.9645600318908691e+00 2.3958898544311523e+01 1.1670299530029297e+01 -8.5344795227050781e+01 -1.3159299850463867e+01 -2.5675498962402344e+01 -8.4780502319335938e+01 -1.3482700347900391e+01 -2.6805799484252930e+01 -8.3488502502441406e+01 -1.6101799011230469e+01 -2.5653900146484375e+01 -1.4594299316406250e+01 1.1992500305175781e+01 -1.7900100708007812e+01 -1.5563899993896484e+01 1.8719600677490234e+01 -1.8207599639892578e+01 -1.3649499893188477e+01 2.0166198730468750e+01 -1.6796400070190430e+01 7.1067600250244141e+00 1.5662099838256836e+01 -1.2590600013732910e+01 -5.2022899627685547e+01 -1.0049200057983398e+01 2.8097499847412109e+01 -3.2659900665283203e+01 -6.2573800086975098e+00 -2.7959701538085938e+01 -3.2310401916503906e+01 -7.7156100273132324e+00 -2.6880100250244141e+01 -3.7114601135253906e+01 -8.2541399002075195e+00 -2.7487701416015625e+01 6.2891502380371094e+00 -4.2209100723266602e+00 1.2782799720764160e+01 7.8256697654724121e+00 -6.1219201087951660e+00 1.1171999931335449e+01 7.8357701301574707e+00 -6.0883202552795410e+00 1.1264100074768066e+01 6.5892200469970703e+00 -6.6740202903747559e+00 1.1643799781799316e+01 -8.2213798522949219e+01 9.0626697540283203e+00 -2.8002300262451172e+01 -8.2400001525878906e+01 4.0667500495910645e+00 -2.8096899032592773e+01 -3.7193300724029541e+00 -1.0557499885559082e+01 -1.2111100196838379e+01 -7.3138801574707031e+01 3.2191802978515625e+01 1.9520699977874756e+00 -7.3991905212402344e+01 3.1087200164794922e+01 2.0753999710083008e+01 -7.3362998962402344e+01 3.1903699874877930e+01 2.0454200744628906e+01 -7.0345703125000000e+01 3.3393600463867188e+01 -2.2247501373291016e+01 -6.5009803771972656e+01 3.4581100463867188e+01 -2.1574399948120117e+01 -7.0832199096679688e+01 3.1005699157714844e+01 -2.3329200744628906e+01 9.4824304580688477e+00 -6.8887901306152344e+00 1.0229599952697754e+01 -5.8311397552490234e+01 3.4510696411132812e+01 2.0043899536132812e+01 -5.9798099517822266e+01 3.4223999023437500e+01 2.1105899810791016e+01 -5.0657699584960938e+01 3.2827701568603516e+01 2.0781299591064453e+01 -5.7458099365234375e+01 2.0169298171997070e+01 2.6201400756835938e+01 -2.6081600189208984e+01 -4.7166800498962402e+00 -2.6796600341796875e+01 -2.9988599777221680e+01 -5.7139000892639160e+00 -2.7801799774169922e+01 -2.9492401123046875e+01 -4.9492101669311523e+00 -2.7866498947143555e+01 -2.0742601394653320e+01 -5.4436001777648926e+00 -1.6200000762939453e+01 -2.4548599243164062e+01 -7.9655795097351074e+00 -1.6200000762939453e+01 -1.4520799636840820e+01 -4.0115003585815430e+00 3.2433801889419556e-01 -1.5133599281311035e+01 -4.2432403564453125e+00 3.3784000873565674e+00 -7.7186103820800781e+01 2.0684000015258789e+01 -2.7094200134277344e+01 -7.8433197021484375e+01 2.0577098846435547e+01 -2.7034099578857422e+01 -7.5841705322265625e+01 2.3446901321411133e+01 -2.6201299667358398e+01 -1.3005199432373047e+01 -3.6734499931335449e+00 -4.7825298309326172e+00 -1.3184000015258789e+01 -3.6677999496459961e+00 -1.0433699607849121e+01 -1.2911699295043945e+01 -3.6889998912811279e+00 -8.6283597946166992e+00 -1.2516999244689941e+01 -3.8552200794219971e+00 -6.6013298034667969e+00 -1.2536999702453613e+01 -3.8368198871612549e+00 -7.7837600708007812e+00 -1.2509699821472168e+01 -3.8612699508666992e+00 -5.5878200531005859e+00 -1.2515500068664551e+01 -3.8569900989532471e+00 -4.7432298660278320e+00 -1.2617600440979004e+01 -3.7806799411773682e+00 -3.9830901622772217e+00 -1.2494400024414062e+01 -3.8837699890136719e+00 -7.4459300041198730e+00 -1.2515299797058105e+01 -3.8555400371551514e+00 -3.1807298660278320e+00 -1.2770099639892578e+01 -3.6780300140380859e+00 1.3781299591064453e+01 -1.2551699638366699e+01 -3.8121600151062012e+00 1.0509500503540039e+01 -1.2494299888610840e+01 -3.8842501640319824e+00 1.1810799598693848e+01 -1.2484299659729004e+01 -3.9098701477050781e+00 4.3427801132202148e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 5.2011504173278809e+00 -1.2487799644470215e+01 -3.8981499671936035e+00 -5.0306601524353027e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -5.9310398101806641e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 -6.6529803276062012e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -2.7161998748779297e+00 -1.2484299659729004e+01 -3.9098799228668213e+00 1.2311100006103516e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -3.8659100532531738e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 6.4431800842285156e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 3.2775499820709229e+00 -1.2553400039672852e+01 -3.8170099258422852e+00 2.6337800025939941e+00 -1.3502200126647949e+01 -3.6915798187255859e+00 5.7843003273010254e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 -1.1838899612426758e+01 -1.2502299308776855e+01 -3.8715100288391113e+00 -1.1204400062561035e+01 -1.2566300392150879e+01 -3.8090999126434326e+00 -1.2344599723815918e+01 -1.2623800277709961e+01 -3.7661299705505371e+00 -1.1394400596618652e+01 -7.6548400878906250e+01 -1.8981800079345703e+01 -2.0772098541259766e+01 -1.5987800598144531e+01 -4.4253101348876953e+00 1.6200000762939453e+01 -8.5808395385742188e+01 -1.0856200218200684e+01 -2.5666900634765625e+01 -8.5545196533203125e+01 -1.2445300102233887e+01 -1.1223400115966797e+01 -8.5798896789550781e+01 -1.0950900077819824e+01 -5.1937799453735352e+00 -1.8212100982666016e+01 -4.8294701576232910e+00 3.5889799594879150e+00 -2.4160200119018555e+01 -6.2756600379943848e+00 1.3753100395202637e+01 -1.5917999267578125e+01 -4.4139900207519531e+00 -2.8708499670028687e-01 -5.4176799774169922e+01 1.8406198501586914e+01 -2.6585201263427734e+01 6.5039496421813965e+00 -6.9507203102111816e+00 -1.0265699386596680e+01 6.6861600875854492e+00 -6.6043400764465332e+00 -5.2144203186035156e+00 -7.4772003173828125e+01 -1.8680000305175781e+01 2.5666900634765625e+01 -7.4772003173828125e+01 -1.8679899215698242e+01 1.1820299148559570e+01 -1.7977699279785156e+01 2.7983801364898682e+00 2.1229398727416992e+01 -1.8674098968505859e+01 -2.1953301429748535e+00 2.2069599151611328e+01 -1.3814399719238281e+01 -1.2366698980331421e+00 1.7900100708007812e+01 6.3108000755310059e+00 -7.5775399208068848e+00 1.1643799781799316e+01 8.6524295806884766e+00 1.5191599845886230e+01 -1.0941699981689453e+01 -1.6323900222778320e+01 2.6955699920654297e+01 -1.6242500305175781e+01 -2.0590400695800781e+01 2.7657899856567383e+01 -1.8403299331665039e+01 -2.3231201171875000e+01 2.8357799530029297e+01 -1.7734498977661133e+01 7.7492098808288574e+00 -6.2869400978088379e+00 -4.6565900556743145e-03 -8.0036903381347656e+01 1.6166000366210938e+01 2.7858100891113281e+01 -7.9609603881835938e+01 1.9263700485229492e+01 2.7067701339721680e+01 -1.0022800445556641e+01 -5.5124697685241699e+00 1.2656300544738770e+01 -7.8006200790405273e+00 -6.1972203254699707e+00 1.2656300544738770e+01 -6.4110900878906250e+01 3.3581001281738281e+01 2.2046899795532227e+01 -6.8545196533203125e+01 3.2818500518798828e+01 2.2579700469970703e+01 -2.8804500579833984e+01 -1.3430199623107910e+01 1.9237600326538086e+01 -3.0280599594116211e+01 -1.3544600486755371e+01 1.9237001419067383e+01 -2.9175899505615234e+01 -1.3620599746704102e+01 1.6201000213623047e+01 -1.1577199935913086e+01 -7.8938903808593750e+00 1.0571000099182129e+01 -9.4056100845336914e+00 -5.7048501968383789e+00 1.2144999504089355e+01 -1.0799900054931641e+01 -5.2730302810668945e+00 1.0634300231933594e+01 9.3039999008178711e+00 -6.4376001358032227e+00 -1.1582799911499023e+01 7.8357701301574707e+00 -6.0883202552795410e+00 -1.1264100074768066e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 -1.9237499237060547e+01 -2.9465299606323242e+01 -1.3595799446105957e+01 -1.9237499237060547e+01 -3.0399499893188477e+01 -1.3425000190734863e+01 -1.9237499237060547e+01 -7.0144195556640625e+01 3.4517097473144531e+01 -2.0652599334716797e+01 -7.2173400878906250e+01 3.3203399658203125e+01 -2.0240598678588867e+01 -1.0893500328063965e+01 2.3506999969482422e+01 -1.5018699645996094e+01 -1.3107599258422852e+01 2.3883600234985352e+01 -1.6286199569702148e+01 -9.3633508682250977e+00 2.4608098983764648e+01 -1.3956800460815430e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 1.8648300170898438e+01 -4.4742698669433594e+01 -9.5224294662475586e+00 -2.7852001190185547e+01 -3.8778800964355469e+01 -9.3354997634887695e+00 -2.6824199676513672e+01 -7.3362998962402344e+01 3.1903699874877930e+01 -2.0454200744628906e+01 -8.2735099792480469e+01 1.3578999519348145e+01 2.6668500900268555e+01 -3.2975799560546875e+01 -3.8400099277496338e+00 -2.8096899032592773e+01 -2.8934200286865234e+01 -3.4957900047302246e+00 -2.7763200759887695e+01 -1.2468999862670898e+01 -3.9723598957061768e+00 -5.8803100585937500e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 9.0204601287841797e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -3.2910499572753906e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -3.0948998928070068e+00 -6.3811504364013672e+01 3.5166500091552734e+01 2.0719499588012695e+01 -6.3929901123046875e+01 3.4440399169921875e+01 2.1585100173950195e+01 -8.4447395324707031e+01 -1.4850500106811523e+01 1.3938599824905396e+00 -8.3164802551269531e+01 -1.6422599792480469e+01 3.3809599876403809e+00 -8.3263206481933594e+01 -1.6331899642944336e+01 1.2152299880981445e+01 -1.8656398773193359e+01 -2.3088200092315674e+00 -2.2057399749755859e+01 -1.8647300720214844e+01 -3.4699399471282959e+00 -2.1727500915527344e+01 -8.5497795104980469e+01 -1.2562899589538574e+01 2.8260599821805954e-02 -7.5841705322265625e+01 2.3446901321411133e+01 2.6201299667358398e+01 -7.6856498718261719e+01 2.1396400451660156e+01 2.6889600753784180e+01 1.2776300430297852e+01 -8.2544794082641602e+00 1.0229800224304199e+01 -8.0267700195312500e+01 1.2764199256896973e+01 2.8096899032592773e+01 1.3941699981689453e+01 -8.6312093734741211e+00 7.5555901527404785e+00 1.4910300254821777e+01 -8.6305704116821289e+00 3.7874600887298584e+00 8.0147495269775391e+00 1.6214498519897461e+01 -1.0230600357055664e+01 6.6464800834655762e+00 1.7869501113891602e+01 1.2357000112533569e+00 7.1461400985717773e+00 1.7260000228881836e+01 1.0229700088500977e+01 -2.5912401199340820e+01 6.5912199020385742e+00 2.5931301116943359e+01 -2.5644001007080078e+01 2.4205899238586426e+00 2.6451900482177734e+01 -2.3801099777221680e+01 3.8622300624847412e+00 2.5255300521850586e+01 -8.5145103454589844e+01 5.5757799148559570e+00 -2.5662200927734375e+01 -8.4460601806640625e+01 8.7752904891967773e+00 -5.3235797882080078e+00 -6.3375101089477539e+00 -1.7565100193023682e+00 1.3721400260925293e+01 -8.2074394226074219e+01 -1.5267700195312500e+01 2.7876098632812500e+01 -8.4486404418945312e+01 -1.0800999641418457e+01 2.7713001251220703e+01 -8.4867797851562500e+01 -1.2569499969482422e+01 2.7100799560546875e+01 -3.1758199691772461e+01 2.0571800231933594e+01 -2.4306600570678711e+01 -2.9592399597167969e+01 2.7388601303100586e+01 -2.1954000473022461e+01 -2.8733600616455078e+01 1.9363800048828125e+01 -2.4038000106811523e+01 -8.3058799743652344e+01 1.3686300277709961e+01 2.5666900634765625e+01 -8.5035003662109375e+01 6.3558301925659180e+00 2.5674098968505859e+01 -7.1587898254394531e+01 3.3174499511718750e+01 2.1690000534057617e+01 -6.8256202697753906e+01 3.4979999542236328e+01 2.1093599319458008e+01 -6.9966796875000000e+01 3.4713600158691406e+01 1.9631198883056641e+01 -5.3734598159790039e+00 9.3850593566894531e+00 -1.3516600608825684e+01 -4.5868897438049316e+00 2.1889400482177734e+01 -1.3294899940490723e+01 -9.3643701076507568e-01 -1.2331299781799316e+00 -1.3162500381469727e+01 -6.4110900878906250e+01 3.3581001281738281e+01 -2.2046899795532227e+01 -6.3890895843505859e+01 3.4450099945068359e+01 -2.1590299606323242e+01 -2.2416999816894531e+01 2.5918298721313477e+01 -2.0565500259399414e+01 -2.1139299392700195e+01 2.0317699432373047e+01 -2.1121301651000977e+01 -1.2585000038146973e+01 2.6100500106811523e+01 -1.4657299995422363e+01 -1.4178999900817871e+01 2.6742898941040039e+01 -1.3717199325561523e+01 -2.5169300079345703e+01 3.6497998237609863e-01 -2.6374399185180664e+01 -2.8175498962402344e+01 1.5697500705718994e+00 -2.7393899917602539e+01 -9.6048898696899414e+00 2.5772399902343750e+01 -1.2623800277709961e+01 -1.4514900207519531e+01 -4.0288496017456055e+00 -8.1216001510620117e+00 -3.2789901733398438e+01 3.0060899734497070e+01 -1.7758699417114258e+01 -2.2868999481201172e+01 -5.2620897293090820e+00 2.4482398986816406e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 1.1451100349426270e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 -4.6423501968383789e+00 2.4698100090026855e+00 -1.3937099456787109e+01 -8.7694101333618164e+00 1.3559999465942383e+00 -1.3735700607299805e+01 -8.7694101333618164e+00 -7.2062995910644531e+01 3.3286300659179688e+01 2.0510700225830078e+01 -2.1232500076293945e+01 2.6503099441528320e+01 -1.9953899383544922e+01 -1.5564300537109375e+01 2.5595899581909180e+01 -1.7409900665283203e+01 -1.6401000976562500e+01 2.4625801086425781e+01 -1.8170499801635742e+01 -1.1733599662780762e+01 -9.2020101547241211e+00 3.9287097454071045e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 8.7694005966186523e+00 -1.1136300086975098e+01 -9.8672695159912109e+00 -3.1021800041198730e+00 -1.1920199394226074e+01 -8.9085302352905273e+00 -8.3831701278686523e+00 -1.1295700073242188e+01 -9.6952896118164062e+00 -8.7694101333618164e+00 -8.8484201431274414e+00 -1.0371999740600586e+01 -1.0295099258422852e+01 -6.5542902946472168e+00 -1.0829599380493164e+01 -1.0302700042724609e+01 -7.0307302474975586e+00 2.5468399047851562e+01 6.5915398597717285e+00 -1.4179100036621094e+01 2.6742898941040039e+01 1.3717199325561523e+01 -7.0307302474975586e+00 2.5468399047851562e+01 1.0730800628662109e+01 1.7999500274658203e+01 -2.8110098838806152e+00 -1.0229700088500977e+01 -5.0236697196960449e+00 -2.6851301193237305e+00 -1.2880999565124512e+01 -5.3248100280761719e+00 -1.9142800569534302e+00 -1.3434800148010254e+01 -3.2349998950958252e+00 2.4259799957275391e+01 -1.1439999580383301e+01 -3.9967998504638672e+01 3.0895101547241211e+01 2.0772499084472656e+01 -3.2330902099609375e+01 2.9474100112915039e+01 2.0962800979614258e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -5.1695203781127930e-01 -5.4393699645996094e+01 -1.1380000114440918e+01 2.8026699066162109e+01 -2.2231201171875000e+01 1.2556499242782593e+00 -2.4675800323486328e+01 -8.9134998321533203e+00 -1.0206200599670410e+01 -1.1205100059509277e+01 -1.6373800277709961e+01 2.4622798919677734e+01 1.8157501220703125e+01 -2.0687799453735352e+01 -5.2614102363586426e+00 2.1774700164794922e+01 1.5323800086975098e+01 -4.1637501716613770e+00 -1.3162500381469727e+01 1.5431400299072266e+01 -4.6149396896362305e+00 -1.3162500381469727e+01 1.4017400741577148e+01 -5.5252099037170410e+00 -1.3162500381469727e+01 -1.7720899581909180e+01 1.3928599357604980e+01 2.0123699188232422e+01 -1.3107599258422852e+01 2.3883600234985352e+01 1.6286199569702148e+01 -3.1628799438476562e+01 -8.4871101379394531e+00 -1.9451400756835938e+01 -8.5964797973632812e+01 -1.1868500709533691e+00 -2.5676300048828125e+01 -8.5881393432617188e+01 -6.9067101478576660e+00 -2.6386400222778320e+01 -8.6083892822265625e+01 -5.1130099296569824e+00 -2.5666900634765625e+01 -8.0267700195312500e+01 1.2764199256896973e+01 -2.8096899032592773e+01 -7.9344696044921875e+01 1.5972599029541016e+01 -2.7999799728393555e+01 -6.8686302185058594e+01 1.3177599906921387e+01 -2.8035299301147461e+01 -3.4678499698638916e+00 2.4546600341796875e+01 1.0226399421691895e+01 -6.8465900421142578e+00 2.5434799194335938e+01 1.0693900108337402e+01 5.3050603866577148e+00 -1.0234899520874023e+01 1.2282799720764160e+01 5.4755702018737793e+00 -1.0288099288940430e+01 1.1643799781799316e+01 -2.3418100357055664e+01 -3.4390799999237061e+00 2.5626100540161133e+01 -2.3448501586914062e+01 -3.2784798145294189e+00 2.5642599105834961e+01 -8.2882400512695312e+01 -1.0574700355529785e+01 2.8096899032592773e+01 -3.2887599945068359e+01 -5.3357300758361816e+00 -2.8096899032592773e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 7.9923099279403687e-01 -1.2487700462341309e+01 -3.8984899520874023e+00 3.2551601529121399e-01 -8.2080101013183594e+01 -1.7292600631713867e+01 2.5666900634765625e+01 -8.0811302185058594e+01 -1.8070999145507812e+01 2.5639598846435547e+01 -8.1527099609375000e+01 -1.7308099746704102e+01 2.6616500854492188e+01 -8.3500305175781250e+01 -1.2953100204467773e+01 -2.7934499740600586e+01 -8.4759696960449219e+01 -1.0734800338745117e+01 -2.7460899353027344e+01 -4.1574902534484863e+00 -1.0894499778747559e+01 1.1716500282287598e+01 -8.5376605987548828e+00 -1.0257399559020996e+01 1.1212699890136719e+01 -5.0540599822998047e+00 -1.1139400482177734e+01 1.0868499755859375e+01 -6.4351997375488281e+01 1.2023900032043457e+01 2.8055299758911133e+01 -6.6457595825195312e+01 3.5751899719238281e+01 -1.9767801284790039e+01 -6.5414596557617188e+01 1.6021900177001953e+01 2.7626399993896484e+01 -7.7686401367187500e+01 -1.8971700668334961e+01 2.5795400619506836e+01 -7.7796401977539062e+01 -1.8792200088500977e+01 2.6459199905395508e+01 -7.9663406372070312e+01 2.1549299240112305e+01 -2.5176801681518555e+01 -7.7815803527832031e+01 2.4162700653076172e+01 -2.5170400619506836e+01 -8.0238800048828125e+01 2.0285900115966797e+01 -2.5552999496459961e+01 -8.0270500183105469e+01 2.0207399368286133e+01 2.2489600181579590e+00 4.8787798881530762e+00 -1.0104199409484863e+01 -1.2581200599670410e+01 5.1955399513244629e+00 -1.0201799392700195e+01 -1.2359499931335449e+01 -1.7269599914550781e+01 -2.7614200115203857e+00 2.0761899948120117e+01 -1.8656398773193359e+01 -2.3088200092315674e+00 2.2057399749755859e+01 -1.8927799224853516e+01 -4.4864702224731445e+00 2.1103000640869141e+01 -1.1295700073242188e+01 -9.6952896118164062e+00 8.7694101333618164e+00 3.4292600154876709e+00 -1.3637700080871582e+01 -8.3823099136352539e+00 3.2828400135040283e+00 -1.3691499710083008e+01 -4.4710597991943359e+00 -1.0954899787902832e+01 -9.9566106796264648e+00 4.3614101409912109e+00 9.4770300388336182e-01 2.2524200439453125e+01 -1.0229899406433105e+01 1.3160300254821777e+00 -1.3715700149536133e+01 -9.1459999084472656e+00 -3.4076000213623047e+01 3.0211999893188477e+01 -1.9965900421142578e+01 -3.2286403656005859e+01 2.9720199584960938e+01 -2.0481201171875000e+01 -3.7879798889160156e+01 3.0309301376342773e+01 -2.1135299682617188e+01 -2.6406499862670898e+01 -7.8242998123168945e+00 1.9237300872802734e+01 -1.4515699386596680e+01 -4.0267701148986816e+00 1.1472999572753906e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 -1.6200000762939453e+01 -1.8723299026489258e+01 -4.9519901275634766e+00 -1.6200000762939453e+01 -1.3659000396728516e+01 -3.7333600521087646e+00 -1.0100999832153320e+01 -1.3369699478149414e+01 -3.6811499595642090e+00 -1.5818199157714844e+01 -7.2312301635742188e+01 3.3093002319335938e+01 1.3019000053405762e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 -1.6200000762939453e+01 -3.0809600830078125e+01 -1.3216799736022949e+01 1.6199798583984375e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -6.8087697029113770e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -7.2823896408081055e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -7.7019901275634766e+00 -3.1619102478027344e+01 -9.1428298950195312e+00 1.9237499237060547e+01 -2.8657798767089844e+01 -7.6556901931762695e+00 1.9496599197387695e+01 -7.9056901931762695e+00 -6.1648502349853516e+00 1.2403100013732910e+01 -8.1184898376464844e+01 1.8335500717163086e+01 -2.5733100891113281e+01 -1.2484200477600098e+01 -3.9098398685455322e+00 1.0575200080871582e+01 -1.0217400550842285e+01 -1.0161899566650391e+01 -9.1455993652343750e+00 -1.1837100028991699e+01 -9.0069694519042969e+00 -9.6961002349853516e+00 -1.0723400115966797e+01 -9.2629899978637695e+00 -1.1413799285888672e+01 -3.0947000503540039e+01 6.8715701103210449e+00 -2.7576299667358398e+01 1.4017400741577148e+01 -5.5252299308776855e+00 1.3162500381469727e+01 1.5323800086975098e+01 -4.1637501716613770e+00 1.3162500381469727e+01 3.5189900398254395e+00 -1.2387099266052246e+01 -1.0975000381469727e+01 2.7276201248168945e+00 -1.2909700393676758e+01 -1.1376399993896484e+01 2.0134000778198242e+00 -1.1841899871826172e+01 -1.2109000205993652e+01 -9.9629602432250977e+00 -3.9463801383972168e+00 -1.2822000503540039e+01 -5.1284399032592773e+00 -3.3915398120880127e+00 -1.2656300544738770e+01 -8.4990898132324219e+01 4.6578397750854492e+00 -2.6591299057006836e+01 -8.3480400085449219e+01 8.3210201263427734e+00 -2.7478899002075195e+01 -7.9436500549316406e+01 -1.7295799255371094e+01 2.7633199691772461e+01 1.4097799301147461e+01 -8.5582199096679688e+00 -1.0974300384521484e+01 1.4471399307250977e+01 -8.6752099990844727e+00 -9.8253202438354492e+00 1.2776300430297852e+01 -8.2544794082641602e+00 -1.0229800224304199e+01 5.4755702018737793e+00 -1.0288099288940430e+01 -1.1643799781799316e+01 3.9121499061584473e+00 -9.8083105087280273e+00 -1.1604000091552734e+01 -3.2194900512695312e+01 -8.1703805923461914e+00 -2.5740800857543945e+01 -2.8270698547363281e+01 -7.1634702682495117e+00 -2.5726100921630859e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.9889199733734131e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 3.0948998928070068e+00 7.8375797271728516e+00 -6.3176698684692383e+00 1.0229800224304199e+01 -3.2373802185058594e+01 -7.4179096221923828e+00 2.7315099716186523e+01 -6.8786296844482422e+00 2.2554998397827148e+01 -1.3689200401306152e+01 -1.0217400550842285e+01 -1.0161899566650391e+01 9.1456098556518555e+00 -1.0972799301147461e+01 -9.8318595886230469e+00 1.0179499626159668e+01 -2.7397800445556641e+01 -4.1198697090148926e+00 2.7423400878906250e+01 -7.5310699462890625e+01 2.9075099945068359e+01 2.2331199645996094e+01 -7.6789695739746094e+01 2.6851900100708008e+01 2.3179199218750000e+01 7.0728302001953125e+00 -6.1602401733398438e+00 1.1267999649047852e+01 -3.8524200439453125e+01 -6.7241401672363281e+00 2.8097499847412109e+01 -4.0985801696777344e+01 -8.4421596527099609e+00 2.7926500320434570e+01 -8.5338500976562500e+01 4.3485999107360840e-01 -2.6955900192260742e+01 -7.4673599243164062e+01 2.5458698272705078e+01 2.5446899414062500e+01 -2.1543800354003906e+01 -5.6311798095703125e+00 -2.1169200897216797e+01 -1.2469099998474121e+01 -3.9723901748657227e+00 -7.7372398376464844e+00 -1.2491400718688965e+01 -3.8886401653289795e+00 -8.3463201522827148e+00 -2.4159500122070312e+01 -6.2754898071289062e+00 -2.2972999572753906e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -2.0250000000000000e+01 -2.1872001647949219e+01 -3.6640801429748535e+00 2.4625801086425781e+01 -1.8115199804306030e+00 -1.2297200202941895e+01 -1.1544100046157837e+00 -1.2392800331115723e+01 -4.2737202644348145e+00 1.2936100006103516e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.4174999237060547e+01 6.1715998649597168e+00 -8.0292997360229492e+00 -1.1643799781799316e+01 -4.6267498016357422e+01 -1.1364599227905273e+01 2.6522500991821289e+01 -2.0308200836181641e+01 -5.3378500938415527e+00 1.6200000762939453e+01 1.6434799194335938e+01 -8.0008001327514648e+00 -1.1106800079345703e+01 -2.9465299606323242e+01 -1.3595799446105957e+01 -1.6200000762939453e+01 4.7463798522949219e+00 -1.0064300537109375e+01 1.0486200332641602e+01 4.9977498054504395e+00 -1.0140899658203125e+01 8.8615293502807617e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.0824300765991211e+01 -7.3093101501464844e+01 3.1947500228881836e+01 2.1611099243164062e+01 -1.3649499893188477e+01 2.0166198730468750e+01 1.6796400070190430e+01 -1.4594299316406250e+01 1.1992500305175781e+01 1.7900100708007812e+01 -2.0471099853515625e+01 -5.3669600486755371e+00 -2.0250000000000000e+01 -8.1364402770996094e+01 1.3131000518798828e+01 2.7924800872802734e+01 -8.4118301391601562e+01 2.4903000891208649e-01 2.7910200119018555e+01 -1.8723299026489258e+01 -4.9519901275634766e+00 1.6200000762939453e+01 -1.9121099472045898e+01 -5.1630897521972656e+00 1.6200000762939453e+01 -2.2204599380493164e+00 2.4079299926757812e+01 -1.0228199958801270e+01 -9.5017600059509277e-01 2.3519701004028320e+01 1.0229700088500977e+01 -9.5017600059509277e-01 2.3519701004028320e+01 -1.0229800224304199e+01 -2.2204599380493164e+00 2.4079299926757812e+01 1.0228199958801270e+01 -1.8619499206542969e+01 1.0543999671936035e+00 -2.1860898971557617e+01 -1.6382200241088867e+01 1.3128899574279785e+01 -1.9254699707031250e+01 7.8754200935363770e+00 -6.1899800300598145e+00 1.0834399223327637e+01 -1.1968599319458008e+01 -4.9128999710083008e+00 1.2656300544738770e+01 -8.1316902160644531e+01 -1.7834100723266602e+01 -5.7058101892471313e-01 -8.1432899475097656e+01 -1.7731700897216797e+01 9.8030796051025391e+00 -7.9688804626464844e+01 -1.8525798797607422e+01 1.2558599472045898e+01 -8.3561798095703125e+01 -1.6003499984741211e+01 -1.7607400894165039e+01 -8.2080101013183594e+01 -1.7292600631713867e+01 -2.5666900634765625e+01 -7.4880401611328125e+01 -1.8242099761962891e+01 2.6841800689697266e+01 -7.7240798950195312e+01 -1.7425498962402344e+01 2.7850198745727539e+01 -8.3054100036621094e+01 1.3700300216674805e+01 -2.5666900634765625e+01 6.5172100067138672e+00 -5.2400598526000977e+00 -1.2515299797058105e+01 1.3856300354003906e+01 -8.6082496643066406e+00 -5.6883196830749512e+00 -7.4771903991699219e+01 -1.8679899215698242e+01 -9.7939796447753906e+00 -7.5627700805664062e+01 -1.8856300354003906e+01 -6.6064101457595825e-01 -1.8680601119995117e+01 -4.9415903091430664e+00 -1.5576899528503418e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.2886400222778320e+00 -7.0791000366210938e+01 3.4229801177978516e+01 1.2186399459838867e+01 -6.9940795898437500e+01 3.4720802307128906e+01 -3.3461299538612366e-01 -7.2171600341796875e+01 3.3224800109863281e+01 1.0406699180603027e+00 -6.4094703674316406e+01 3.3578197479248047e+01 -2.2046899795532227e+01 -1.2100500106811523e+01 -9.9917197227478027e-01 1.6574199676513672e+01 4.2148599624633789e+00 2.0214399337768555e+01 4.3156399726867676e+00 -7.4685699462890625e+01 -1.6565099716186523e+01 2.7998899459838867e+01 7.3976602554321289e+00 -3.0381901264190674e+00 1.3162399291992188e+01 9.2621002197265625e+00 1.4340699195861816e+01 1.0230099678039551e+01 8.2847900390625000e+00 1.5479100227355957e+01 1.1488699913024902e+01 1.9050099849700928e+00 1.9417699813842773e+01 -1.3059399604797363e+01 -1.7540600299835205e+00 2.1827699661254883e+01 -1.2974999427795410e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 -1.1451100349426270e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.2562399864196777e+01 -6.7094001770019531e+01 3.5633499145507812e+01 1.9204199314117432e+00 -6.9141998291015625e+01 3.5073398590087891e+01 1.0676899909973145e+01 -5.8862102508544922e+01 -1.4758200645446777e+01 -2.5771200180053711e+01 -6.6752700805664062e+01 -1.6404199600219727e+01 -2.6540199279785156e+01 -5.7855300903320312e+01 -1.4107700347900391e+01 -2.6716400146484375e+01 1.8461599349975586e+01 -4.4659600257873535e+00 4.0511398315429688e+00 -6.7801803588867188e+01 2.2013500213623047e+01 -2.6201400756835938e+01 -7.4673599243164062e+01 2.5458698272705078e+01 -2.5446899414062500e+01 3.1772801876068115e+00 1.6965400695800781e+01 1.3166399955749512e+01 -7.9464698791503906e+01 -1.6842800140380859e+01 -2.7888599395751953e+01 -8.0379997253417969e+01 -1.4894800186157227e+01 -2.8096899032592773e+01 -6.6855001449584961e+00 2.3976100921630859e+01 -1.3298200607299805e+01 -7.5794796943664551e+00 2.2704200744628906e+01 -1.3865099906921387e+01 -1.1248499870300293e+01 -5.1348104476928711e+00 -8.8615293502807617e+00 1.7053899765014648e+01 -4.5799903869628906e+00 1.2750299453735352e+01 -9.6793699264526367e+00 -7.8165602684020996e-01 1.5179299354553223e+01 -9.2741994857788086e+00 -2.1737599372863770e+00 1.4671999931335449e+01 1.6998899459838867e+01 -6.2526502609252930e+00 -1.2577199935913086e+01 1.5033500671386719e+01 -6.3609900474548340e+00 -1.3092599868774414e+01 1.7478500366210938e+01 -5.1903200149536133e+00 -1.2537400245666504e+01 -1.1825799942016602e+01 -2.5406200885772705e+00 1.5898799896240234e+01 -7.7610099792480469e+01 2.2007999420166016e+01 2.6670200347900391e+01 -7.7864997863769531e+01 2.4162899017333984e+01 2.5080999374389648e+01 -1.8674098968505859e+01 -2.1953301429748535e+00 -2.2069599151611328e+01 -2.0307800292968750e+01 1.5372200012207031e+01 2.1515800476074219e+01 -2.0569900512695312e+01 -6.4211702346801758e+00 -1.9237499237060547e+01 1.0173600196838379e+01 1.2668499946594238e+01 -1.0229700088500977e+01 -8.5624000549316406e+01 -1.2087100028991699e+01 -1.9766099929809570e+01 1.8035499572753906e+01 -6.2667803764343262e+00 -1.1057900428771973e+01 -1.8145300149917603e+00 2.1698999404907227e+01 1.3026299476623535e+01 9.1821396350860596e-01 2.1643299102783203e+01 1.2238900184631348e+01 -1.0127799987792969e+01 -3.3894300460815430e+00 1.3818900108337402e+01 -1.0800699234008789e+01 -5.2727899551391602e+00 -1.0632800102233887e+01 -1.1968599319458008e+01 -4.9128999710083008e+00 -1.2656300544738770e+01 -3.5346199035644531e+01 7.1104402542114258e+00 -2.8034200668334961e+01 -4.5793701171875000e+01 3.2309902191162109e+01 1.9889099121093750e+01 -2.1853099822998047e+01 -5.7073702812194824e+00 -2.0932600021362305e+01 -7.4651397705078125e+01 2.7210699081420898e+01 2.4724800109863281e+01 -7.5132499694824219e+01 2.8274499893188477e+01 2.3792798995971680e+01 -1.2259400367736816e+01 -4.8232898712158203e+00 -1.2660400390625000e+01 -9.0257501602172852e+00 -7.4893897771835327e-01 -1.4873800277709961e+01 -3.4678499698638916e+00 2.4546600341796875e+01 -1.0226300239562988e+01 -2.1972099304199219e+01 2.8044799804687500e+01 1.8302000045776367e+01 1.2765799522399902e+01 -4.9755697250366211e+00 -1.3162500381469727e+01 9.8834295272827148e+00 6.5972900390625000e+00 -1.3162599563598633e+01 -3.2600399017333984e+01 2.7963298797607422e+01 2.2046899795532227e+01 5.3409199714660645e+00 -3.1408400535583496e+00 -1.3085200309753418e+01 -2.1136699676513672e+01 -5.5309100151062012e+00 2.0822700500488281e+01 -1.1248499870300293e+01 -5.1348104476928711e+00 8.8615293502807617e+00 3.5155498981475830e+00 -1.3290500640869141e+01 1.0145500183105469e+01 4.1435799598693848e+00 -1.2604000091552734e+01 8.7694005966186523e+00 -1.2528200149536133e+01 -3.8404700756072998e+00 1.0844699144363403e+00 -3.2696197509765625e+01 9.6085901260375977e+00 -2.7570400238037109e+01 -9.0257501602172852e+00 -7.4893897771835327e-01 1.4873800277709961e+01 -8.8467397689819336e+00 -9.2061595916748047e+00 -1.2156000137329102e+01 -6.4980903625488281e+01 3.5738899230957031e+01 4.7488999366760254e+00 -2.0951200485229492e+01 -6.7523698806762695e+00 -1.7952001571655273e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 4.6423501968383789e+00 -2.3418199539184570e+01 -3.4390799999237061e+00 -2.5625900268554688e+01 -2.5539800643920898e+01 -5.7666797637939453e+00 -2.5933300018310547e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.1211000442504883e+01 1.8064201354980469e+01 -3.8077600002288818e+00 -1.1699000358581543e+01 -1.7263299942016602e+01 -2.5184898376464844e+00 -2.0802299499511719e+01 -1.2420499801635742e+01 -4.1591300964355469e+00 4.3063297271728516e+00 -2.0569900512695312e+01 -6.4211797714233398e+00 1.9237499237060547e+01 -2.0274599075317383e+01 -6.1647500991821289e+00 1.9253698348999023e+01 -3.1579498291015625e+01 -1.1716900825500488e+01 -1.9237499237060547e+01 -3.1538299560546875e+01 -1.2062000274658203e+01 -1.7867500305175781e+01 5.4755702018737793e+00 -1.0288099288940430e+01 -1.4281799793243408e+00 -8.2882400512695312e+01 -1.0574700355529785e+01 -2.8096899032592773e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 2.0250000000000000e+01 -3.3957599639892578e+01 2.2076699733734131e+00 -2.8097000122070312e+01 -7.1406898498535156e+01 3.3811698913574219e+01 -1.0665699958801270e+01 -7.2553596496582031e+01 3.2843196868896484e+01 -1.1039799690246582e+01 -8.4824501037597656e+01 -1.4209400177001953e+01 -1.7676399230957031e+01 -3.1318798065185547e+01 2.0398700714111328e+01 2.4274200439453125e+01 -2.6977600097656250e+01 1.8610399246215820e+01 2.3734500885009766e+01 -2.7629499435424805e+01 2.6979400634765625e+01 2.1713800430297852e+01 -7.5557098388671875e+01 2.8117698669433594e+01 -2.3519599914550781e+01 -8.3045700073242188e+01 -8.4699592590332031e+00 -2.8096899032592773e+01 -1.2279800176620483e+00 2.2933200836181641e+01 1.2090600013732910e+01 -4.3032598495483398e+00 -1.1460499763488770e+01 1.0306200027465820e+01 -4.2065896987915039e+00 -1.1490400314331055e+01 1.0306200027465820e+01 -3.5070602416992188e+01 2.1786800384521484e+01 -2.4295400619506836e+01 -3.2600399017333984e+01 2.7963100433349609e+01 -2.2046899795532227e+01 -3.0197000503540039e+01 -6.8118801116943359e+00 -2.7204399108886719e+01 -2.0253499984741211e+01 -5.3109297752380371e+00 -2.0218898773193359e+01 -3.2878101348876953e+01 9.3289098739624023e+00 2.7645900726318359e+01 -8.5834098815917969e+01 -7.2901301383972168e+00 2.6437700271606445e+01 -8.6083892822265625e+01 -5.1130099296569824e+00 2.5666900634765625e+01 -8.6002799987792969e+01 -8.5538406372070312e+00 2.5668899536132812e+01 -4.3032598495483398e+00 -1.1460499763488770e+01 -1.0306200027465820e+01 -3.7239401340484619e+00 -1.1649600028991699e+01 -1.0305799484252930e+01 -3.6514399051666260e+00 -1.1667500495910645e+01 -1.0304599761962891e+01 -3.2975799560546875e+01 -3.8400099277496338e+00 2.8096899032592773e+01 -3.2887599945068359e+01 -5.3357300758361816e+00 2.8096899032592773e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 1.6200000762939453e+01 -3.7348401546478271e+00 -9.6158704757690430e+00 1.2329899787902832e+01 -3.4674800872802734e+01 1.4640600204467773e+01 -2.6576499938964844e+01 -2.5977300643920898e+01 -7.0095701217651367e+00 -1.9470499038696289e+01 -3.1917098999023438e+01 2.6032500267028809e+00 -2.8021100997924805e+01 -4.0303600311279297e+01 2.9336700439453125e+01 -2.2047401428222656e+01 -5.2587200164794922e+01 3.1526498794555664e+01 -2.2046899795532227e+01 -1.2900600433349609e+01 -3.6866500377655029e+00 -1.4267199516296387e+01 -3.7007598876953125e+01 1.6523199081420898e+01 -2.6201299667358398e+01 -8.0504699707031250e+01 -1.7846899032592773e+01 -2.6673799514770508e+01 6.5892200469970703e+00 -6.6740202903747559e+00 -1.1643799781799316e+01 1.3160300254821777e+00 -1.3715700149536133e+01 9.1459999084472656e+00 5.4230195283889771e-01 -1.3339400291442871e+01 -1.0186499595642090e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 2.6891999244689941e+00 -1.8805799484252930e+01 -4.9762101173400879e+00 1.6808599472045898e+01 -1.8677999496459961e+01 -4.9410200119018555e+00 1.8645801544189453e+01 4.1435799598693848e+00 -1.2604000091552734e+01 0.0000000000000000e+00 4.9977498054504395e+00 -1.0140899658203125e+01 3.7186799049377441e+00 4.9977498054504395e+00 -1.0140899658203125e+01 -8.8615293502807617e+00 4.1435799598693848e+00 -1.2604000091552734e+01 -8.7694005966186523e+00 -8.0861595153808594e+01 -1.4468800544738770e+01 2.8099199295043945e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 1.5576899528503418e+01 1.8025800704956055e+01 -2.8638198375701904e+00 -1.8640899658203125e+00 -8.5711204528808594e+01 1.5585000514984131e+00 -2.5666900634765625e+01 -3.8664299011230469e+01 -9.7858705520629883e+00 -2.5666900634765625e+01 -4.5768001556396484e+01 -1.1208900451660156e+01 -2.6579498291015625e+01 -7.2385307312011719e+01 3.1241298675537109e+01 -2.3072099685668945e+01 2.7172601222991943e+00 2.1455699920654297e+01 9.9170894622802734e+00 -6.4094703674316406e+01 3.3578197479248047e+01 2.2046899795532227e+01 -1.0621700286865234e+01 -9.1452493667602539e+00 1.1563099861145020e+01 -2.3368301391601562e+01 -5.4110898971557617e+00 -2.4809200286865234e+01 -7.0307302474975586e+00 2.5468399047851562e+01 -7.1406497955322266e+00 -8.2216102600097656e+01 1.6069200515747070e+01 5.7170400619506836e+00 -1.2499199867248535e+01 -3.8734200000762939e+00 9.4482898712158203e+00 -1.2490699768066406e+01 -3.8924100399017334e+00 -3.3666701316833496e+00 -8.3060401916503906e+01 1.3686800003051758e+01 1.6274000167846680e+01 -8.3054100036621094e+01 1.3700300216674805e+01 2.5666900634765625e+01 -8.3058799743652344e+01 1.3686300277709961e+01 -2.5666900634765625e+01 -7.6187500000000000e+01 -1.8943000793457031e+01 1.8149898529052734e+01 -8.6044700622558594e+01 -2.5542399883270264e+00 3.6043100357055664e+00 -8.5937301635742188e+01 -8.1713896989822388e-01 2.5695800781250000e+01 -7.8908195495605469e+01 -1.8738399505615234e+01 -2.7807998657226562e-01 -7.7226402282714844e+01 -1.8952301025390625e+01 1.0827600479125977e+01 -8.6039001464843750e+01 -7.8893499374389648e+00 -6.7517399787902832e-01 -8.5695495605468750e+01 1.7946900129318237e+00 -9.9244898557662964e-01 -8.2707893371582031e+01 -1.6874198913574219e+01 -8.4668798446655273e+00 -8.4415199279785156e+01 -1.4895499229431152e+01 1.7561300277709961e+01 -7.8498001098632812e+01 -1.8810798645019531e+01 1.8372900009155273e+01 -8.5170501708984375e+01 5.4223003387451172e+00 1.0836700439453125e+01 -3.9489898681640625e+01 3.1162698745727539e+01 -2.0016599655151367e+01 6.9650502204895020e+00 -6.2961602210998535e+00 1.4111299514770508e+00 1.2963500022888184e+01 -7.8590903282165527e+00 1.1816699981689453e+01 -8.2167495727539062e+01 1.6196201324462891e+01 -1.3814499855041504e+01 7.2005200386047363e+00 -6.2607698440551758e+00 -5.2534098625183105e+00 7.7394099235534668e+00 -6.2859597206115723e+00 -7.0418801307678223e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 -8.7694005966186523e+00 1.6019899845123291e+00 2.2163599014282227e+01 4.3230800628662109e+00 -7.0307302474975586e+00 2.5468399047851562e+01 -1.0015199661254883e+01 -3.4272903442382812e+01 1.2446599960327148e+01 2.7127899169921875e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.1597700119018555e+01 -7.6556900024414062e+01 -1.5989600181579590e+01 -2.8096899032592773e+01 7.4979400634765625e+00 1.1315800666809082e+01 -1.3162500381469727e+01 1.7743200063705444e+00 -1.6654300689697266e+00 -1.3162500381469727e+01 -5.6050800323486328e+01 3.2143898010253906e+01 -2.2046501159667969e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 5.5708198547363281e+00 3.6702899932861328e+00 -1.3299300193786621e+01 -9.6205396652221680e+00 -4.3236499786376953e+01 -9.9578104019165039e+00 2.7337198257446289e+01 -5.2473796844482422e+01 -1.2130700111389160e+01 -2.7420099258422852e+01 -6.3763603210449219e+01 3.5443500518798828e+01 -2.0199199676513672e+01 -6.6889602661132812e+01 3.5169300079345703e+01 -2.1070100784301758e+01 -1.0937100410461426e+01 2.3413600921630859e+01 1.5065499305725098e+01 1.8118101119995117e+01 -6.0945100784301758e+00 1.0972000122070312e+01 -8.4443199157714844e+01 -1.4854499816894531e+01 -9.4425296783447266e+00 -5.7554101943969727e+00 -1.1038000106811523e+01 1.0308400154113770e+01 -2.9934400558471680e+01 -1.1625800132751465e+01 -1.9237499237060547e+01 3.7036798000335693e+00 -1.3349900245666504e+01 8.5235795974731445e+00 1.2869499206542969e+01 -8.2948493957519531e+00 -1.4541900157928467e+00 1.3971300125122070e+01 -8.6322698593139648e+00 9.0816795825958252e-01 1.8016201019287109e+01 -6.4611701965332031e+00 -5.0233302116394043e+00 1.8278699874877930e+01 -5.8155899047851562e+00 3.9653798937797546e-01 -8.5030097961425781e+01 -6.9620103836059570e+00 2.7464399337768555e+01 1.9063199758529663e+00 -1.2481399536132812e+01 1.2013400077819824e+01 -9.8575506210327148e+00 -8.1238298416137695e+00 1.2062000274658203e+01 -2.2471500396728516e+01 -5.6958599090576172e+00 -2.3190601348876953e+01 -2.0458801269531250e+01 1.5454299926757812e+01 -2.1590900421142578e+01 -8.5711204528808594e+01 1.5585000514984131e+00 2.5666900634765625e+01 -7.8688301086425781e+01 1.7159898757934570e+01 2.7824800491333008e+01 -3.0506299972534180e+01 2.7548599243164062e+01 2.1996099472045898e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 1.6200000762939453e+01 1.8381200790405273e+01 -3.7917900085449219e+00 7.5998598337173462e-01 -7.4819496154785156e+01 2.7081100463867188e+01 -2.4762300491333008e+01 -2.9883800506591797e+01 -3.6574599742889404e+00 2.7899700164794922e+01 -2.5053699493408203e+01 -6.9892301559448242e+00 1.9359899520874023e+01 2.0604398250579834e+00 -1.3875300407409668e+01 -1.0187500000000000e+01 -6.8339897155761719e+01 3.5352901458740234e+01 -7.4738702774047852e+00 -7.0307302474975586e+00 2.5468399047851562e+01 -4.2167601585388184e+00 -1.8669198989868164e+01 1.4469600677490234e+01 -2.0667400360107422e+01 -1.3715800285339355e+01 2.6531400680541992e+01 1.4534399986267090e+01 1.4554799079895020e+01 -7.8870701789855957e+00 -1.2254600524902344e+01 -2.5937799453735352e+01 -3.4249598979949951e+00 2.6824901580810547e+01 -1.1792400360107422e+01 -1.8972599506378174e+00 -1.6251201629638672e+01 -1.1929100036621094e+01 -8.4870595932006836e+00 9.6228895187377930e+00 3.8926100730895996e+00 -1.3110199928283691e+01 4.5864601135253906e+00 -1.2007099151611328e+01 -8.2018299102783203e+00 -4.3791403770446777e+00 1.5308300018310547e+01 -5.0949902534484863e+00 -1.3162500381469727e+01 -8.2356803894042969e+01 -1.6340200424194336e+01 -2.7129499435424805e+01 -9.6793699264526367e+00 -7.8165602684020996e-01 -1.5179299354553223e+01 -3.2233699798583984e+01 -8.0123805999755859e+00 -2.6198598861694336e+01 -1.2804200172424316e+01 2.5236200332641602e+01 1.5723800659179688e+01 -7.6621002197265625e+01 2.3808599472045898e+01 -2.6010200500488281e+01 -8.5190994262695312e+01 -1.3430399894714355e+01 9.0667800903320312e+00 -7.6371398925781250e+01 -1.8959999084472656e+01 -1.2674399375915527e+01 -7.7428604125976562e+01 -1.8959300994873047e+01 -3.9070899486541748e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6000 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01) (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01) (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01) (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01) (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01) (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_l_finger_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_l_finger_tip_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 9.1370000000000005e+01 4.9500000000000002e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 5 8 0 2 5 8 26 0 0 28 1 26 28 0 2 3 4 2 1 3 2 4 5 3 1 7 3 19 4 19 3 7 4 19 5 18 19 20 19 21 20 19 7 21 5 19 24 24 19 18 18 30 24 31 30 18 20 31 18 20 36 31 20 37 36 21 37 20 7 22 21 21 61 37 22 61 21 38 37 39 37 38 36 37 60 39 37 61 60 22 62 61 62 268 61 268 271 61 61 271 60 23 22 7 23 62 22 23 268 62 6 23 7 63 23 6 63 267 23 267 268 23 6 7 1 1 28 6 6 28 63 57 28 58 27 58 28 27 28 26 63 28 57 55 57 56 57 58 56 55 63 57 56 58 50 49 50 58 49 58 27 55 56 54 54 56 52 52 56 50 53 55 54 53 63 55 53 54 52 51 52 50 51 53 52 48 50 49 48 51 50 51 264 53 48 264 51 264 63 53 264 267 63 261 264 260 261 265 264 264 268 267 265 268 264 260 264 48 259 260 254 259 261 260 254 260 48 258 259 255 255 259 254 258 261 259 247 251 254 251 255 254 48 247 254 252 255 251 255 252 256 256 258 255 257 258 256 257 261 258 252 59 256 59 257 256 41 257 59 41 90 257 257 262 261 90 262 257 262 265 261 90 263 262 262 266 265 263 266 262 265 269 268 266 269 265 263 86 266 266 86 84 266 270 269 84 270 266 88 263 90 88 86 263 84 86 85 86 87 85 86 88 87 81 84 83 84 85 83 84 81 270 270 271 269 270 272 271 81 272 270 80 39 81 81 83 80 272 81 39 83 290 80 83 293 290 83 85 293 80 82 39 290 286 80 80 286 82 39 82 38 60 272 39 271 272 60 269 271 268 79 36 38 38 82 79 82 286 79 78 36 79 79 286 78 29 36 78 31 36 29 32 78 77 29 78 32 286 287 78 78 287 77 29 30 31 32 30 29 11 30 9 32 9 30 34 30 11 30 34 24 9 10 11 10 12 11 11 12 13 13 34 11 14 10 9 14 9 32 14 15 10 15 16 10 10 16 12 12 16 17 12 25 13 12 17 25 5 13 25 5 34 13 25 8 5 24 34 5 8 27 26 27 8 25 25 65 27 65 66 27 27 232 49 66 232 27 65 67 66 65 273 67 25 273 65 67 68 66 68 232 66 67 69 68 67 273 69 69 70 68 70 232 68 69 73 70 69 273 73 73 74 70 74 232 70 72 74 73 74 284 285 74 285 232 72 284 74 284 72 277 285 284 276 276 284 277 232 285 282 282 285 274 274 285 276 274 276 73 276 277 73 73 277 71 71 277 278 277 72 278 71 72 73 278 279 71 71 279 72 278 72 279 273 274 73 274 273 275 275 282 274 129 273 25 280 281 273 273 281 275 129 280 273 281 427 275 275 427 282 128 427 281 128 281 280 128 280 129 126 128 127 128 129 127 310 432 128 432 427 128 309 310 128 126 297 128 128 297 309 423 432 431 426 432 423 426 427 432 431 432 310 423 424 247 247 426 423 423 431 424 424 431 430 430 431 310 424 425 247 424 430 425 425 430 429 429 430 310 425 421 247 425 429 421 421 429 428 315 429 310 428 429 315 314 315 308 308 315 310 315 314 116 116 428 315 310 309 308 308 307 306 308 309 307 306 314 308 309 299 307 299 309 297 306 307 305 307 94 305 307 299 94 297 298 299 298 94 299 297 296 298 291 296 297 126 291 297 298 301 95 298 296 301 95 94 298 295 296 288 288 296 291 296 295 301 291 292 288 292 291 126 124 126 125 126 127 125 124 292 126 288 292 122 122 292 124 122 124 123 124 125 123 125 127 118 121 125 118 123 125 121 127 129 64 118 127 64 64 16 118 16 119 118 119 120 118 120 121 118 120 122 121 122 123 121 120 288 122 119 288 120 76 119 16 76 288 119 16 64 17 16 35 76 15 35 16 75 76 35 75 288 76 35 15 33 33 75 35 32 33 15 14 32 15 32 77 33 75 33 77 77 287 75 75 287 288 289 287 286 289 288 287 290 289 286 289 290 294 290 293 294 303 294 293 289 294 303 85 302 293 293 302 303 289 303 501 302 501 303 301 302 85 301 295 302 289 501 302 289 302 500 295 500 302 87 300 85 301 85 300 95 301 300 89 300 87 95 300 89 88 89 87 88 90 89 90 91 89 93 89 91 93 95 89 94 95 93 92 93 91 92 94 93 90 41 91 91 41 40 40 92 91 40 311 92 311 94 92 305 94 311 99 311 96 305 311 99 96 311 40 40 41 42 42 96 40 41 59 42 42 97 96 42 59 97 97 98 96 98 99 96 98 100 99 304 99 100 304 305 99 306 305 304 304 100 101 101 103 304 103 312 304 304 312 306 98 101 100 98 102 101 102 103 101 102 104 103 236 102 249 104 102 236 102 250 249 98 250 102 104 105 103 104 106 105 236 237 104 104 237 106 234 235 236 235 237 236 236 249 234 235 106 237 106 107 105 235 243 106 243 244 106 106 244 107 239 235 234 239 243 235 238 239 234 234 249 248 234 248 238 242 239 238 242 245 239 239 245 243 245 246 243 243 246 244 245 417 246 242 417 245 241 242 238 242 418 417 242 419 418 241 419 242 246 417 416 416 417 414 417 418 414 244 246 46 246 416 46 46 416 44 44 416 231 416 414 231 43 46 44 43 109 46 109 244 46 107 244 109 107 109 108 43 110 109 109 110 108 107 108 105 108 319 105 110 319 108 110 321 319 43 321 110 316 319 318 103 319 316 105 319 103 319 321 318 318 321 320 320 321 111 111 321 43 312 318 317 316 318 312 318 320 317 103 316 312 312 313 306 312 317 313 313 317 314 317 115 314 317 320 115 115 320 111 114 115 113 113 115 111 116 115 114 314 115 116 313 314 306 116 114 117 117 428 116 229 114 113 229 117 114 111 112 113 229 113 228 228 113 112 111 43 112 43 45 112 228 112 45 45 231 228 360 229 228 348 360 228 231 348 228 43 44 45 44 231 45 348 231 414 348 414 454 457 454 414 418 477 414 457 414 439 414 477 439 435 457 439 454 457 435 436 435 439 439 481 436 420 481 439 477 420 439 418 419 477 477 419 415 415 420 477 420 421 422 415 421 420 422 433 420 433 481 420 240 415 241 415 419 241 240 421 415 247 421 240 421 428 422 428 433 422 117 433 428 230 433 117 433 229 481 230 229 433 229 230 117 360 483 229 483 487 229 487 481 229 436 481 451 481 480 451 487 480 481 487 488 480 487 495 488 495 487 483 480 479 451 479 480 488 451 445 436 446 445 451 451 479 446 446 479 478 489 479 488 478 479 491 491 479 489 488 493 489 488 495 493 493 495 494 483 494 495 492 493 494 493 496 489 493 497 496 493 492 497 490 491 489 489 496 490 496 497 475 496 475 499 490 496 499 497 476 475 497 498 476 498 497 492 498 492 485 485 492 494 471 476 498 471 498 485 475 476 410 410 476 408 370 476 471 408 476 370 373 471 470 370 471 373 471 484 470 485 484 471 370 371 372 373 371 370 370 409 408 372 409 370 408 409 410 409 404 412 409 412 410 372 404 409 372 371 377 377 404 372 403 404 402 405 402 404 412 404 403 377 405 404 411 412 413 413 412 403 410 412 411 413 403 396 403 402 396 397 402 401 396 402 397 405 401 402 378 405 377 401 405 378 322 401 323 322 397 401 386 401 378 386 323 401 396 397 325 325 397 324 324 397 322 142 322 323 145 322 142 145 324 322 142 323 381 381 323 386 386 378 385 381 386 382 382 386 385 380 381 382 142 381 380 380 382 383 383 382 387 387 382 385 376 385 375 385 378 375 376 387 385 383 387 376 374 376 366 366 376 375 374 379 376 379 383 376 368 375 371 366 375 368 371 375 378 371 378 377 373 368 371 367 368 369 369 368 373 367 366 368 365 366 367 365 374 366 367 460 365 369 460 367 373 458 369 458 460 369 470 458 373 458 459 460 458 466 459 470 484 458 458 484 466 459 466 467 459 467 460 463 467 466 466 482 463 484 482 466 485 482 484 463 482 464 482 469 464 482 483 469 485 486 482 482 486 483 485 494 486 486 494 483 469 483 465 465 483 360 464 469 354 465 354 469 355 464 354 463 464 355 352 353 354 354 353 355 176 178 354 354 178 352 354 465 176 360 361 465 465 361 176 177 360 348 361 360 177 176 361 177 174 176 177 178 176 174 177 173 174 177 348 173 348 339 173 348 454 339 165 168 173 174 173 168 165 173 339 168 178 174 168 165 167 167 178 168 165 166 167 166 183 167 167 183 178 184 183 166 352 183 184 178 183 352 182 184 166 352 184 353 184 362 353 182 362 184 181 182 155 155 182 153 153 182 166 182 181 362 353 362 356 364 357 362 362 357 356 362 181 364 353 356 355 355 356 349 356 357 349 349 357 350 357 358 350 363 357 364 363 358 357 181 180 364 364 180 363 359 358 363 180 179 363 363 388 359 363 195 388 179 195 363 358 359 350 359 388 393 359 393 350 388 193 389 195 193 388 388 389 393 194 193 195 179 194 195 191 193 192 194 192 193 193 390 389 193 191 390 389 392 393 389 390 392 393 392 395 350 393 395 390 394 392 395 392 374 392 394 374 191 391 390 390 391 394 394 379 374 394 391 379 365 395 374 365 468 395 460 468 365 468 462 351 468 351 461 460 462 468 468 461 395 467 462 460 351 462 349 462 463 349 467 463 462 349 350 351 461 351 350 350 395 461 349 463 355 383 379 384 379 391 384 185 383 384 185 380 383 186 384 391 186 185 384 189 391 191 186 391 189 185 186 187 186 188 187 186 189 188 189 190 188 189 191 190 191 192 190 192 208 190 190 208 188 215 187 188 215 188 207 207 188 208 199 208 192 199 207 208 194 199 192 200 199 194 198 199 200 198 197 199 197 207 199 204 207 197 206 207 204 206 215 207 196 197 198 196 201 197 201 203 197 197 203 204 203 206 204 205 206 203 205 209 206 209 215 206 202 203 201 202 227 203 203 227 205 225 227 202 201 335 202 335 336 202 202 336 225 224 227 225 224 205 227 223 224 225 225 336 223 336 337 223 335 342 336 336 342 344 336 344 337 171 335 201 342 335 171 342 171 172 172 343 342 344 342 343 344 343 345 344 345 337 345 343 341 347 343 172 347 341 343 345 453 337 346 345 341 453 345 346 341 175 340 341 340 346 341 347 175 175 347 163 347 172 163 163 170 175 175 170 165 165 340 175 165 339 340 346 340 339 165 170 166 169 166 170 170 163 169 161 160 163 169 163 160 161 163 172 154 169 160 153 169 154 166 169 153 153 154 155 154 157 155 157 154 160 159 155 157 159 181 155 156 157 158 159 157 156 158 157 160 156 179 159 179 180 159 180 181 159 156 200 194 158 200 156 156 194 179 164 158 160 198 200 158 164 198 158 162 164 160 196 198 164 162 196 164 160 161 162 171 162 172 162 161 172 171 196 162 171 201 196 339 454 346 456 346 454 437 454 435 456 454 437 456 453 346 440 456 437 453 456 440 435 436 437 436 438 437 438 440 437 441 440 438 442 440 441 442 452 440 452 453 440 455 337 453 455 453 452 443 452 330 330 452 442 443 455 452 338 337 455 338 455 443 223 337 221 221 337 219 337 338 219 136 338 329 219 338 136 329 338 443 329 443 330 136 329 134 329 330 134 330 331 134 442 331 330 134 135 136 134 137 135 134 149 137 134 331 149 222 219 136 135 222 136 135 130 132 137 130 135 132 222 135 137 138 130 149 138 137 149 150 138 149 331 150 150 151 138 138 133 130 138 143 133 138 151 143 130 131 132 133 131 130 216 222 132 131 216 132 139 131 140 133 140 131 131 217 216 139 217 131 143 140 133 143 144 140 151 144 143 145 140 144 140 145 139 147 144 151 144 325 145 326 325 144 147 327 144 327 326 144 145 142 139 325 324 145 325 326 396 327 399 326 399 396 326 328 327 147 328 398 327 398 399 327 400 399 398 413 396 399 400 413 399 406 400 398 406 398 328 406 407 400 407 413 400 411 413 407 406 473 407 473 474 407 474 475 407 407 475 411 328 472 406 472 473 406 473 499 474 491 473 472 491 499 473 474 499 475 411 475 410 490 499 491 478 491 472 434 472 328 434 478 472 333 478 434 449 478 333 446 478 449 333 434 328 146 328 147 146 333 328 146 147 148 148 333 146 148 334 333 448 333 334 448 449 333 449 448 446 444 445 446 444 446 448 444 448 447 447 448 334 444 447 441 438 444 441 438 445 444 436 445 438 441 447 442 447 334 450 447 450 442 442 450 331 332 450 334 331 450 332 331 332 150 150 332 334 152 151 150 150 334 152 152 334 148 148 151 152 148 147 151 141 139 142 139 212 217 141 212 139 142 185 141 141 185 212 380 185 142 185 187 212 214 187 215 212 187 214 214 210 212 210 214 213 213 214 215 213 215 209 210 213 211 205 213 209 205 211 213 210 211 212 226 218 211 226 211 205 211 218 212 226 205 224 220 226 224 216 226 220 216 218 226 216 217 218 217 212 218 222 216 220 219 220 221 222 220 219 220 223 221 220 224 223 240 241 238 238 247 240 238 248 247 248 251 247 47 247 48 47 426 247 248 252 251 249 252 248 249 253 252 253 59 252 250 253 249 250 98 253 98 97 253 97 59 253 47 283 426 283 427 426 282 283 233 233 283 47 282 427 283 232 282 233 47 232 233 47 48 49 49 232 47 288 289 500 288 500 295 17 64 25 64 129 25))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-1.1255100250244141e+02 2.1148599624633789e+01 7.2288298606872559e+00 -1.0990699768066406e+02 2.2224800109863281e+01 8.4010801315307617e+00 -1.1138800048828125e+02 2.1970798492431641e+01 7.6926403045654297e+00 -1.1022100067138672e+02 2.2377601623535156e+01 8.1409997940063477e+00 -1.1120399475097656e+02 2.2176399230957031e+01 7.6428799629211426e+00 -1.1219800567626953e+02 2.1725299835205078e+01 7.1447100639343262e+00 -1.0823900604248047e+02 2.1607000350952148e+01 9.1103105545043945e+00 -1.0910300445556641e+02 2.2351900100708008e+01 8.6652698516845703e+00 -1.1298500061035156e+02 2.1160499572753906e+01 6.8069300651550293e+00 -1.1063700103759766e+02 2.2329200744628906e+01 -7.9401097297668457e+00 -1.1053100585937500e+02 2.2138799667358398e+01 -8.1301708221435547e+00 -1.1188899993896484e+02 2.1872499465942383e+01 -7.3370399475097656e+00 -1.1254100036621094e+02 2.1298200607299805e+01 -7.2108802795410156e+00 -1.1268900299072266e+02 2.1404798507690430e+01 -6.8442997932434082e+00 -1.0970099639892578e+02 2.2372600555419922e+01 -8.4108705520629883e+00 -1.0892800140380859e+02 2.2148000717163086e+01 -8.8029594421386719e+00 -1.0786999511718750e+02 2.0569400787353516e+01 -9.1142997741699219e+00 -1.1374600219726562e+02 2.0187700271606445e+01 -6.6784701347351074e+00 -1.0917800140380859e+02 2.3354999542236328e+01 7.0110297203063965e+00 -1.0959700012207031e+02 2.2983501434326172e+01 7.7004499435424805e+00 -1.0783599853515625e+02 2.3773399353027344e+01 7.0611500740051270e+00 -1.0779300689697266e+02 2.3464401245117188e+01 7.9070405960083008e+00 -1.0771399688720703e+02 2.2889999389648438e+01 8.5910701751708984e+00 -1.0673400115966797e+02 2.2362699508666992e+01 8.9888896942138672e+00 -1.1084500122070312e+02 2.2612600326538086e+01 6.7972202301025391e+00 -1.1408399963378906e+02 2.0165700912475586e+01 -6.2718000411987305e+00 -1.1384799957275391e+02 2.0181499481201172e+01 6.6102499961853027e+00 -1.1406900024414062e+02 2.0165899276733398e+01 6.2554397583007812e+00 -1.0810800170898438e+02 2.0549499511718750e+01 9.1296901702880859e+00 -1.0787599945068359e+02 2.3624900817871094e+01 -7.5470304489135742e+00 -1.0941000366210938e+02 2.3245100021362305e+01 -7.2567200660705566e+00 -1.0786599731445312e+02 2.3784700393676758e+01 -6.8197798728942871e+00 -1.0798899841308594e+02 2.3176898956298828e+01 -8.2607002258300781e+00 -1.0745400238037109e+02 2.2550701141357422e+01 -8.8517494201660156e+00 -1.1085499572753906e+02 2.2606800079345703e+01 -6.8199100494384766e+00 -1.0834500122070312e+02 2.1908199310302734e+01 -9.0081100463867188e+00 -1.0678499603271484e+02 2.3850200653076172e+01 -7.2325701713562012e+00 -1.0652100372314453e+02 2.3850898742675781e+01 7.2211799621582031e+00 -1.0580200195312500e+02 2.3780399322509766e+01 -6.8899002075195312e+00 -1.0503900146484375e+02 2.3565999984741211e+01 6.8094100952148438e+00 -8.0891105651855469e+01 1.1325000524520874e+00 -6.8449096679687500e+00 -8.1105300903320312e+01 2.2144498825073242e+00 7.0301799774169922e+00 -8.0893203735351562e+01 1.1343699693679810e+00 6.8404102325439453e+00 -6.6427604675292969e+01 -7.8912601470947266e+00 -7.0898699760437012e+00 -6.6379302978515625e+01 -1.0204099655151367e+01 6.8426899909973145e+00 -6.6416801452636719e+01 -1.0317999839782715e+01 -6.9112296104431152e+00 -6.6422096252441406e+01 -7.8617205619812012e+00 6.9276800155639648e+00 -1.0390999603271484e+02 1.1320199966430664e+01 9.1500005722045898e+00 -1.0289599609375000e+02 1.2907699584960938e+01 9.1500005722045898e+00 -1.0390800476074219e+02 1.1322799682617188e+01 6.2500000000000000e+00 -1.0289599609375000e+02 1.2907699584960938e+01 6.2500000000000000e+00 -1.0243199920654297e+02 1.5235600471496582e+01 9.1500005722045898e+00 -1.0243199920654297e+02 1.5235600471496582e+01 6.2500000000000000e+00 -1.0325399780273438e+02 1.7961500167846680e+01 9.1500005722045898e+00 -1.0325399780273438e+02 1.7961500167846680e+01 6.2500000000000000e+00 -1.0492599487304688e+02 1.9646100997924805e+01 9.1500005722045898e+00 -1.0492599487304688e+02 1.9646100997924805e+01 6.2500000000000000e+00 -1.0664500427246094e+02 2.0404399871826172e+01 9.1500005722045898e+00 -1.0715000152587891e+02 2.0549098968505859e+01 6.2500100135803223e+00 -8.1037994384765625e+01 9.0935903787612915e-01 7.6571698188781738e+00 -1.0581700134277344e+02 2.3635700225830078e+01 7.5242900848388672e+00 -1.0625199890136719e+02 2.3281200408935547e+01 8.2787399291992188e+00 -1.0631799316406250e+02 2.2787200927734375e+01 8.7120494842529297e+00 -1.0642399597167969e+02 2.1591701507568359e+01 9.1486701965332031e+00 -1.0758700561523438e+02 2.0558599472045898e+01 -6.2500600814819336e+00 -1.1537699890136719e+02 1.8636501312255859e+01 -6.2500000000000000e+00 -1.1537699890136719e+02 1.8636501312255859e+01 6.2500000000000000e+00 -1.1674299621582031e+02 1.6191101074218750e+01 -6.2500000000000000e+00 -1.1674299621582031e+02 1.6191101074218750e+01 6.2500000000000000e+00 -1.1696799468994141e+02 1.4067199707031250e+01 -6.2500000000000000e+00 -1.1696799468994141e+02 1.4067199707031250e+01 6.2500000000000000e+00 -1.1538999938964844e+02 9.9371299743652344e+00 -6.2500000000000000e+00 -1.1516500091552734e+02 9.6792697906494141e+00 6.2500000000000000e+00 -1.1622299957275391e+02 1.1383399963378906e+01 -6.2500000000000000e+00 -1.1622299957275391e+02 1.1383399963378906e+01 6.2500000000000000e+00 -1.0658500671386719e+02 2.2050399780273438e+01 -9.0689001083374023e+00 -1.0739199829101562e+02 2.1629100799560547e+01 -9.1438894271850586e+00 -1.0634799957275391e+02 2.2640100479125977e+01 -8.8131694793701172e+00 -1.0628200531005859e+02 2.3285800933837891e+01 -8.2749204635620117e+00 -1.0582099914550781e+02 2.3627899169921875e+01 -7.5341701507568359e+00 -1.0305800628662109e+02 2.2583400726318359e+01 -6.9935097694396973e+00 -1.0316800689697266e+02 2.2666999816894531e+01 6.8754200935363770e+00 -1.0470500183105469e+02 2.3403900146484375e+01 -7.1863298416137695e+00 -8.4307502746582031e+01 7.6383199691772461e+00 -7.0561299324035645e+00 -8.4178100585937500e+01 7.4929299354553223e+00 7.2439699172973633e+00 -8.3353996276855469e+01 6.6484398841857910e+00 -7.2930903434753418e+00 -8.3333702087402344e+01 6.6357998847961426e+00 7.2368602752685547e+00 -8.2248100280761719e+01 5.2323098182678223e+00 -6.7470102310180664e+00 -8.2248100280761719e+01 5.2323098182678223e+00 6.7470197677612305e+00 -8.1535301208496094e+01 3.6073899269104004e+00 -7.2368497848510742e+00 -8.1535301208496094e+01 3.6073899269104004e+00 7.2368602752685547e+00 -8.1164703369140625e+01 2.4137799739837646e+00 -7.0925097465515137e+00 -8.1041595458984375e+01 1.2051099538803101e+00 -7.4830198287963867e+00 -8.1404800415039062e+01 2.1610400676727295e+00 -7.8907098770141602e+00 -8.1464607238769531e+01 5.7703697681427002e-01 -8.4296903610229492e+00 -8.1916801452636719e+01 2.8818399906158447e+00 -8.3461799621582031e+00 -8.0582000732421875e+01 3.2899701595306396e-01 -6.8224301338195801e+00 -8.0611602783203125e+01 3.6499801278114319e-01 7.0285301208496094e+00 -7.9885299682617188e+01 -5.9871703386306763e-01 6.9645900726318359e+00 -8.0027702331542969e+01 -4.7092598676681519e-01 -7.2357196807861328e+00 -7.9382598876953125e+01 -9.8377698659896851e-01 -7.2393703460693359e+00 -7.8882797241210938e+01 -1.2371500730514526e+00 -7.0834403038024902e+00 -7.8878799438476562e+01 -1.2544499635696411e+00 7.2472901344299316e+00 -6.8381195068359375e+01 -5.0998897552490234e+00 -7.0914001464843750e+00 -6.8381401062011719e+01 -5.0997200012207031e+00 7.0912103652954102e+00 -6.7523101806640625e+01 -5.7609796524047852e+00 -6.6500000953674316e+00 -6.7562103271484375e+01 -5.7994298934936523e+00 7.3110098838806152e+00 -6.7093399047851562e+01 -6.2765302658081055e+00 6.6500000953674316e+00 -6.7093399047851562e+01 -6.2765302658081055e+00 -6.6500000953674316e+00 -6.6755897521972656e+01 -6.8566699028015137e+00 6.6500000953674316e+00 -6.6765502929687500e+01 -6.8609399795532227e+00 -6.9129900932312012e+00 -6.6726501464843750e+01 -8.2779598236083984e+00 -7.9365501403808594e+00 -6.6528701782226562e+01 -1.0204299926757812e+01 -7.5418601036071777e+00 -6.6966804504394531e+01 -1.0284399986267090e+01 -8.2502498626708984e+00 -6.7592597961425781e+01 -1.0280200004577637e+01 -8.7884492874145508e+00 -6.7469200134277344e+01 -7.9253296852111816e+00 -8.7163000106811523e+00 -6.8424797058105469e+01 -8.1632604598999023e+00 -9.1246194839477539e+00 -6.8441200256347656e+01 -1.0274600028991699e+01 -9.1099405288696289e+00 -1.0575799560546875e+02 2.0101900100708008e+01 -6.2499799728393555e+00 -1.0574500274658203e+02 2.0094999313354492e+01 -9.1500005722045898e+00 -1.0418099975585938e+02 1.9052000045776367e+01 -9.1500005722045898e+00 -1.0418099975585938e+02 1.9052000045776367e+01 -6.2500000000000000e+00 -1.0282299804687500e+02 1.7104900360107422e+01 -9.1500005722045898e+00 -1.0282299804687500e+02 1.7104900360107422e+01 -6.2500000000000000e+00 -1.0247100067138672e+02 1.4757699966430664e+01 -9.1500005722045898e+00 -1.0247100067138672e+02 1.4757699966430664e+01 -6.2500000000000000e+00 -1.0289599609375000e+02 1.2907699584960938e+01 -9.1500005722045898e+00 -1.0289599609375000e+02 1.2907699584960938e+01 -6.2500000000000000e+00 -1.0390999603271484e+02 1.1320199966430664e+01 -9.1500005722045898e+00 -1.0390800476074219e+02 1.1322799682617188e+01 -6.2500000000000000e+00 -9.3890396118164062e+01 -1.9594499588012695e+01 1.0717599868774414e+01 -9.3311698913574219e+01 -2.0343400955200195e+01 1.0186299324035645e+01 -9.3139999389648438e+01 -1.9639101028442383e+01 1.0931699752807617e+01 -9.4444198608398438e+01 -1.9820499420166016e+01 1.0143100738525391e+01 -9.3770805358886719e+01 -1.8042900085449219e+01 1.1324600219726562e+01 -9.3148300170898438e+01 -1.8898900985717773e+01 1.1310199737548828e+01 -9.2880302429199219e+01 -1.8248298645019531e+01 1.1486599922180176e+01 -9.4190101623535156e+01 -1.8621999740600586e+01 1.1047300338745117e+01 -9.4629699707031250e+01 -1.9244899749755859e+01 1.0483499526977539e+01 -9.3179298400878906e+01 -2.0761600494384766e+01 9.3805398941040039e+00 -9.4466201782226562e+01 -2.0374099731445312e+01 9.2567300796508789e+00 -9.2621604919433594e+01 -2.0890800476074219e+01 8.6935596466064453e+00 -9.3537803649902344e+01 -2.0878400802612305e+01 8.3422803878784180e+00 -9.5026596069335938e+01 -1.9846000671386719e+01 9.4315004348754883e+00 -9.5409896850585938e+01 -1.9844099044799805e+01 8.4183597564697266e+00 -9.4459800720214844e+01 -2.0576400756835938e+01 8.5082206726074219e+00 -9.6102294921875000e+01 -1.8082401275634766e+01 8.4063005447387695e+00 -9.5957000732421875e+01 -1.8826099395751953e+01 8.5782003402709961e+00 -9.5930999755859375e+01 -1.8176700592041016e+01 9.1546802520751953e+00 -9.4813400268554688e+01 -1.8193399429321289e+01 1.0736900329589844e+01 -9.5316596984863281e+01 -1.8348098754882812e+01 1.0241700172424316e+01 -9.5368499755859375e+01 -1.9263999938964844e+01 9.6255397796630859e+00 -9.5664001464843750e+01 -1.8175401687622070e+01 9.7290201187133789e+00 -6.1640899658203125e+01 -1.0425000190734863e+01 3.9616897106170654e+00 -6.1256801605224609e+01 -1.1007900238037109e+01 5.0008902549743652e+00 -6.1028400421142578e+01 -1.0940000534057617e+01 3.5944600105285645e+00 -6.0362701416015625e+01 -1.2412300109863281e+01 3.8142299652099609e+00 -6.0830898284912109e+01 -1.1490600585937500e+01 4.6984200477600098e+00 -6.0695499420166016e+01 -1.2366300582885742e+01 5.3090500831604004e+00 -6.0535999298095703e+01 -1.1712599754333496e+01 3.2430801391601562e+00 -6.1415000915527344e+01 -1.1332499504089355e+01 6.1296601295471191e+00 -6.2047298431396484e+01 -1.1340100288391113e+01 7.2632598876953125e+00 -6.1666099548339844e+01 -1.2169400215148926e+01 7.3382396697998047e+00 -6.2599899291992188e+01 -1.0761500358581543e+01 7.2886400222778320e+00 -6.1104301452636719e+01 -1.2365699768066406e+01 6.3779201507568359e+00 -6.3905403137207031e+01 -9.9834995269775391e+00 6.6251201629638672e+00 -6.2361698150634766e+01 -1.0050799369812012e+01 4.0647602081298828e+00 -6.3224800109863281e+01 -9.8956604003906250e+00 4.1209397315979004e+00 -6.4281700134277344e+01 -9.9137601852416992e+00 6.2162299156188965e+00 -6.2290500640869141e+01 -1.0443200111389160e+01 6.0588402748107910e+00 -6.3195800781250000e+01 -1.0118500709533691e+01 6.4187703132629395e+00 -6.2472702026367188e+01 -1.2513899803161621e+01 8.4688806533813477e+00 -6.2741802215576172e+01 -1.1699199676513672e+01 8.3473205566406250e+00 -6.5240798950195312e+01 -1.0212999343872070e+01 7.2388596534729004e+00 -6.4898796081542969e+01 -9.9844198226928711e+00 6.1325101852416992e+00 -6.3833900451660156e+01 -1.0411499977111816e+01 7.6742200851440430e+00 -6.4857902526855469e+01 -9.9734296798706055e+00 -6.2122802734375000e+00 -6.5789199829101562e+01 -1.0287300109863281e+01 6.7968602180480957e+00 -6.3911804199218750e+01 -9.8958206176757812e+00 -5.6185297966003418e+00 -6.0359798431396484e+01 -1.2307199478149414e+01 -3.6064600944519043e+00 -6.0628803253173828e+01 -1.1578699111938477e+01 -3.7531502246856689e+00 -6.1003398895263672e+01 -1.0976799964904785e+01 -3.6707999706268311e+00 -6.1652702331542969e+01 -1.0380000114440918e+01 -3.2844698429107666e+00 -6.2966400146484375e+01 -9.9117994308471680e+00 -3.9426000118255615e+00 -6.2402801513671875e+01 -1.0049499511718750e+01 -4.1836700439453125e+00 -6.2849601745605469e+01 -2.0878900527954102e+01 -4.6983399391174316e+00 -6.1999298095703125e+01 -2.0687000274658203e+01 -3.4147000312805176e+00 -6.2570995330810547e+01 -2.0865400314331055e+01 3.6086099147796631e+00 -6.1783802032470703e+01 -2.0569799423217773e+01 4.0062098503112793e+00 -6.1179801940917969e+01 -2.0188600540161133e+01 -3.4911398887634277e+00 -6.1094200134277344e+01 -2.0112199783325195e+01 3.4762198925018311e+00 -6.0759300231933594e+01 -1.9701499938964844e+01 -4.0063400268554688e+00 -6.0481601715087891e+01 -1.9313299179077148e+01 3.6495699882507324e+00 -6.0331798553466797e+01 -1.8978799819946289e+01 -3.8294301033020020e+00 -6.0145603179931641e+01 -1.8248100280761719e+01 3.5796301364898682e+00 -6.0149700164794922e+01 -1.8183900833129883e+01 -3.7242200374603271e+00 -6.1329101562500000e+01 -1.8172399520874023e+01 7.3941497802734375e+00 -6.1202499389648438e+01 -1.9032899856567383e+01 6.7604098320007324e+00 -6.0576999664306641e+01 -1.8134300231933594e+01 5.7871098518371582e+00 -6.0678703308105469e+01 -1.9317298889160156e+01 4.9355797767639160e+00 -6.0273300170898438e+01 -1.8190299987792969e+01 4.6072797775268555e+00 -6.2056499481201172e+01 -1.8305599212646484e+01 8.4032497406005859e+00 -6.2891201019287109e+01 -1.8202999114990234e+01 9.2903900146484375e+00 -6.2518798828125000e+01 -1.9168001174926758e+01 8.5312500000000000e+00 -6.1819400787353516e+01 -1.9715000152587891e+01 7.0366902351379395e+00 -6.3629402160644531e+01 -1.9681400299072266e+01 9.1858005523681641e+00 -6.2661094665527344e+01 -2.0117799758911133e+01 7.6399598121643066e+00 -6.1705501556396484e+01 -2.0120000839233398e+01 6.0299701690673828e+00 -6.1365299224853516e+01 -2.0182001113891602e+01 4.7702097892761230e+00 -6.3459999084472656e+01 -2.0138601303100586e+01 8.4642896652221680e+00 -6.5282203674316406e+01 -2.0844699859619141e+01 8.1589899063110352e+00 -6.5461898803710938e+01 -2.0472999572753906e+01 9.3470602035522461e+00 -6.7502799987792969e+01 -2.0880699157714844e+01 8.8870401382446289e+00 -6.4250900268554688e+01 -2.0501499176025391e+01 8.5253801345825195e+00 -6.3902801513671875e+01 -2.0890598297119141e+01 6.4770898818969727e+00 -6.2842899322509766e+01 -2.0660999298095703e+01 6.4450001716613770e+00 -6.7447898864746094e+01 -1.9895900726318359e+01 1.0701199531555176e+01 -6.8066703796386719e+01 -2.0559700012207031e+01 9.8929996490478516e+00 -6.6776199340820312e+01 -2.0473899841308594e+01 9.8433294296264648e+00 -6.8019004821777344e+01 -1.8250000000000000e+01 1.1477600097656250e+01 -6.6453102111816406e+01 -1.9029800415039062e+01 1.1013400077819824e+01 -6.6668197631835938e+01 -1.8167299270629883e+01 1.1279200553894043e+01 -6.8108795166015625e+01 -1.9188899993896484e+01 1.1208799362182617e+01 -6.5456893920898438e+01 -1.8165899276733398e+01 1.0892800331115723e+01 -6.4912101745605469e+01 -1.9028398513793945e+01 1.0428299903869629e+01 -6.4241897583007812e+01 -1.8162601470947266e+01 1.0295599937438965e+01 -6.5291099548339844e+01 -1.9738498687744141e+01 1.0151299476623535e+01 -6.3691497802734375e+01 -1.9022300720214844e+01 9.6710500717163086e+00 -6.6639404296875000e+01 -1.0391200065612793e+01 -7.4401497840881348e+00 -6.7378097534179688e+01 -1.0396800041198730e+01 -8.4291000366210938e+00 -6.8558403015136719e+01 -1.0390600204467773e+01 -8.9551897048950195e+00 -6.6518203735351562e+01 -1.0381000518798828e+01 7.0109400749206543e+00 -1.0655000305175781e+02 9.0483503341674805e+00 6.2500000000000000e+00 -1.0659600067138672e+02 8.9703903198242188e+00 9.1500005722045898e+00 -6.8878005981445312e+01 -5.8127598762512207e+00 8.5706300735473633e+00 -6.8101898193359375e+01 -5.8599400520324707e+00 8.1459197998046875e+00 -6.8941696166992188e+01 -5.2135200500488281e+00 7.9463496208190918e+00 -6.8069396972656250e+01 -5.3750901222229004e+00 7.2382197380065918e+00 -6.9012496948242188e+01 -6.5341000556945801e+00 8.9862108230590820e+00 -6.7782798767089844e+01 -6.8296599388122559e+00 8.5839900970458984e+00 -6.9165496826171875e+01 -7.2737402915954590e+00 9.1449699401855469e+00 -6.8384101867675781e+01 -7.9007697105407715e+00 9.0976705551147461e+00 -6.7704200744628906e+01 -7.7998600006103516e+00 8.8410501480102539e+00 -6.7219802856445312e+01 -6.7383103370666504e+00 7.9707598686218262e+00 -6.6955093383789062e+01 -6.5843300819396973e+00 7.2415699958801270e+00 -6.7004997253417969e+01 -7.9977197647094727e+00 8.2913408279418945e+00 -6.6569900512695312e+01 -7.9542694091796875e+00 7.5836801528930664e+00 -8.0766601562500000e+01 -2.6834499835968018e+00 9.1361703872680664e+00 -8.0020896911621094e+01 -2.0557599067687988e+00 8.8182601928710938e+00 -7.9667900085449219e+01 -1.4880100488662720e+00 8.2595100402832031e+00 -7.9713203430175781e+01 -9.0127098560333252e-01 7.5182800292968750e+00 -8.1314804077148438e+01 -1.4700200557708740e+00 9.0114593505859375e+00 -8.1178298950195312e+01 -3.1777799129486084e-01 8.5120792388916016e+00 -8.0600097656250000e+01 -2.5520402193069458e-01 7.9102797508239746e+00 -8.2784805297851562e+01 -4.4402197003364563e-02 9.1334791183471680e+00 -8.1941299438476562e+01 2.4092900753021240e-01 8.8169498443603516e+00 -8.1437797546386719e+01 9.2610096931457520e-01 8.2673997879028320e+00 -8.1758094787597656e+01 3.0187301635742188e+00 8.1118698120117188e+00 -8.2164199829101562e+01 2.6206700801849365e+00 8.6233196258544922e+00 -8.2902999877929688e+01 2.6529698371887207e+00 9.0108594894409180e+00 -8.3766494750976562e+01 3.3219201564788818e+00 9.1485605239868164e+00 -8.3335899353027344e+01 4.5836100578308105e+00 8.8279705047607422e+00 -8.2762893676757812e+01 4.9265799522399902e+00 8.2738695144653320e+00 -8.2385002136230469e+01 5.1509799957275391e+00 7.5249400138854980e+00 -8.5538703918457031e+01 6.0334100723266602e+00 9.1193103790283203e+00 -8.4640304565429688e+01 6.3338699340820312e+00 8.8090000152587891e+00 -8.4188796997070312e+01 6.8161702156066895e+00 8.2442798614501953e+00 -1.0439299774169922e+02 2.1178501129150391e+01 9.0887203216552734e+00 -1.0403299713134766e+02 2.1799600601196289e+01 8.8098001480102539e+00 -1.0300900268554688e+02 2.1867799758911133e+01 8.2513504028320312e+00 -1.0275500488281250e+02 2.2213001251220703e+01 7.4874601364135742e+00 -1.0447800445556641e+02 2.2709800720214844e+01 8.2735300064086914e+00 -1.0429399871826172e+02 2.3108600616455078e+01 7.5249996185302734e+00 -1.0652499389648438e+02 9.0833702087402344e+00 -6.2500000000000000e+00 -1.0879199981689453e+02 9.1968107223510742e+00 -6.2500000000000000e+00 -1.0652100372314453e+02 8.5220699310302734e+00 -6.2500000000000000e+00 -1.1179100036621094e+02 9.5880804061889648e+00 -6.2500000000000000e+00 -1.1489099884033203e+02 9.5263805389404297e+00 -6.2500000000000000e+00 -1.1528500366210938e+02 9.8146600723266602e+00 -6.2500000000000000e+00 -1.1534700012207031e+02 9.8796491622924805e+00 -6.2500000000000000e+00 -1.0652600097656250e+02 9.0829801559448242e+00 -9.1500005722045898e+00 -1.0653000640869141e+02 8.5469398498535156e+00 -9.1500005722045898e+00 -1.0649300384521484e+02 8.5030593872070312e+00 6.2500000000000000e+00 -1.0643299865722656e+02 8.4661493301391602e+00 9.1500005722045898e+00 -1.1463999938964844e+02 9.5075397491455078e+00 6.2500000000000000e+00 -1.1074099731445312e+02 9.5356006622314453e+00 6.2500000000000000e+00 -1.0459899902343750e+02 2.2849300384521484e+01 -8.1906995773315430e+00 -1.0481200408935547e+02 2.1987098693847656e+01 -8.9133701324462891e+00 -1.0357700347900391e+02 2.0572999954223633e+01 -9.1288499832153320e+00 -1.0290700531005859e+02 2.1414701461791992e+01 -8.5791702270507812e+00 -1.0255799865722656e+02 2.1847799301147461e+01 -7.9297304153442383e+00 -8.5285697937011719e+01 5.3565101623535156e+00 -9.1531400680541992e+00 -8.6191101074218750e+01 5.9746003150939941e+00 -9.1500005722045898e+00 -8.4434997558593750e+01 7.4523196220397949e+00 -7.7178397178649902e+00 -9.3737998962402344e+01 1.4706799507141113e+01 -8.4361400604248047e+00 -8.4648101806640625e+01 6.3001999855041504e+00 -8.8215703964233398e+00 -8.4215202331542969e+01 5.1858601570129395e+00 -9.0355100631713867e+00 -8.3408996582031250e+01 1.5781799554824829e+00 -9.1507396697998047e+00 -8.2511795043945312e+01 2.3564100265502930e+00 -8.9124402999877930e+00 -8.2423698425292969e+01 6.5717399120330811e-01 -8.9903802871704102e+00 -8.2372299194335938e+01 5.1327199935913086e+00 -7.5182700157165527e+00 -8.2866104125976562e+01 4.8270797729492188e+00 -8.4458894729614258e+00 -8.4181701660156250e+01 6.7181601524353027e+00 -8.2935199737548828e+00 -8.4635505676269531e+01 7.3326001167297363e+00 -8.0918207168579102e+00 -7.9508697509765625e+01 -1.3220299482345581e+00 -7.9454097747802734e+00 -8.0807800292968750e+01 -4.0625399351119995e-01 -8.2731399536132812e+00 -7.9835494995117188e+01 -1.7615299224853516e+00 -8.5770492553710938e+00 -8.1352302551269531e+01 -7.9768502712249756e-01 -8.8287897109985352e+00 -8.0248199462890625e+01 -2.4152600765228271e+00 -9.0147600173950195e+00 -8.2238693237304688e+01 -1.0475699901580811e+00 -9.1326198577880859e+00 -8.0497398376464844e+01 -3.0117800235748291e+00 -9.1439599990844727e+00 -8.0731506347656250e+01 3.0195799469947815e-01 -7.5233402252197266e+00 -6.8582801818847656e+01 -5.3629498481750488e+00 -7.9397101402282715e+00 -6.8881599426269531e+01 -5.8094701766967773e+00 -8.5697393417358398e+00 -6.8847198486328125e+01 -6.6348700523376465e+00 -8.9898700714111328e+00 -6.9246902465820312e+01 -7.1703696250915527e+00 -9.1396703720092773e+00 -6.8069396972656250e+01 -5.3750901222229004e+00 -7.2382502555847168e+00 -6.7967201232910156e+01 -6.5680298805236816e+00 -8.5666704177856445e+00 -6.7570594787597656e+01 -6.2374300956726074e+00 -7.9708199501037598e+00 -6.7335296630859375e+01 -6.0413298606872559e+00 -7.2416000366210938e+00 -6.7046905517578125e+01 -7.3667497634887695e+00 -8.1459798812866211e+00 -6.6710304260253906e+01 -7.2175598144531250e+00 -7.4390296936035156e+00 -9.3670799255371094e+01 -2.0848899841308594e+01 -8.3173599243164062e+00 -9.3062400817871094e+01 -2.0889600753784180e+01 -8.6832695007324219e+00 -9.4475296020507812e+01 -2.0568099975585938e+01 -8.2652196884155273e+00 -9.5187599182128906e+01 -2.0061500549316406e+01 -8.3796195983886719e+00 -9.5581100463867188e+01 -1.9595699310302734e+01 -8.4368000030517578e+00 -9.5950202941894531e+01 -1.8861299514770508e+01 -8.5076694488525391e+00 -9.6091598510742188e+01 -1.8124500274658203e+01 -8.5547199249267578e+00 -9.2733894348144531e+01 -1.3036300659179688e+01 1.1314899444580078e+01 -9.3509201049804688e+01 -1.2771699905395508e+01 1.1148099899291992e+01 -9.4322799682617188e+01 -1.2947400093078613e+01 1.0788499832153320e+01 -9.5096099853515625e+01 -1.3248800277709961e+01 1.0142100334167480e+01 -9.5897506713867188e+01 -1.2896499633789062e+01 8.4291496276855469e+00 -9.5564300537109375e+01 -1.2914200782775879e+01 9.4243803024291992e+00 -6.3192703247070312e+01 -1.2891500473022461e+01 9.2307596206665039e+00 -6.4513099670410156e+01 -1.3146400451660156e+01 1.0202899932861328e+01 -6.6488899230957031e+01 -1.2884799957275391e+01 1.1013099670410156e+01 -6.8109695434570312e+01 -1.3013999938964844e+01 1.1299399375915527e+01 -6.5641593933105469e+01 -1.0540900230407715e+01 8.5027809143066406e+00 -6.4671798706054688e+01 -1.0553799629211426e+01 8.2588300704956055e+00 -6.5173202514648438e+01 -1.1195799827575684e+01 9.5083999633789062e+00 -6.3850902557373047e+01 -1.2335700035095215e+01 9.5917797088623047e+00 -6.4128501892089844e+01 -1.1689200401306152e+01 9.3995904922485352e+00 -6.5116004943847656e+01 -1.2520500183105469e+01 1.0389900207519531e+01 -6.5758300781250000e+01 -1.1837399482727051e+01 1.0338700294494629e+01 -6.6464500427246094e+01 -1.0906100273132324e+01 9.6689691543579102e+00 -6.3610897064208984e+01 -1.1091800689697266e+01 8.5185594558715820e+00 -6.6167900085449219e+01 -1.0398699760437012e+01 7.9767799377441406e+00 -6.2467800140380859e+01 -1.1268300056457520e+01 -7.7261500358581543e+00 -6.1838798522949219e+01 -1.2272899627685547e+01 -7.6358799934387207e+00 -6.2593101501464844e+01 -1.1978600502014160e+01 -8.3717203140258789e+00 -6.3545398712158203e+01 -1.0006099700927734e+01 -6.3585700988769531e+00 -6.2917201995849609e+01 -1.0279500007629395e+01 -6.5945401191711426e+00 -6.4087898254394531e+01 -1.0062999725341797e+01 -6.9385199546813965e+00 -6.3364795684814453e+01 -1.0512000083923340e+01 -7.5604901313781738e+00 -6.2347198486328125e+01 -1.0855699539184570e+01 -7.0596799850463867e+00 -6.1525798797607422e+01 -1.1299500465393066e+01 -6.3326201438903809e+00 -6.1499397277832031e+01 -1.1783800125122070e+01 -6.7678098678588867e+00 -6.1221202850341797e+01 -1.2550399780273438e+01 -6.6556100845336914e+00 -6.6212104797363281e+01 -1.0403900146484375e+01 -8.0452194213867188e+00 -6.6002197265625000e+01 -1.0354200363159180e+01 -7.3951301574707031e+00 -6.1782299041748047e+01 -1.0559800148010254e+01 -5.2923297882080078e+00 -6.0674999237060547e+01 -1.2354599952697754e+01 -5.2776899337768555e+00 -6.1002899169921875e+01 -1.1452499389648438e+01 -5.1973299980163574e+00 -6.2865303039550781e+01 -1.8152999877929688e+01 -9.2703104019165039e+00 -6.3542903900146484e+01 -1.9026599884033203e+01 -9.5700607299804688e+00 -6.3911899566650391e+01 -1.8160499572753906e+01 -1.0083099365234375e+01 -6.4932998657226562e+01 -1.9028398513793945e+01 -1.0438500404357910e+01 -6.5083602905273438e+01 -1.8163599014282227e+01 -1.0737700462341309e+01 -6.8084594726562500e+01 -1.8238901138305664e+01 -1.1481900215148926e+01 -6.6696098327636719e+01 -1.9317298889160156e+01 -1.0944100379943848e+01 -6.8112800598144531e+01 -1.9189100265502930e+01 -1.1208999633789062e+01 -6.6610595703125000e+01 -1.8187299728393555e+01 -1.1270100593566895e+01 -6.2587501525878906e+01 -1.9317298889160156e+01 -8.5163793563842773e+00 -6.4965301513671875e+01 -1.9671701431274414e+01 -1.0067800521850586e+01 -6.4137504577636719e+01 -2.0114099502563477e+01 -9.0809097290039062e+00 -6.8143798828125000e+01 -1.9980400085449219e+01 -1.0664299964904785e+01 -6.7360702514648438e+01 -2.0325500488281250e+01 -1.0215700149536133e+01 -6.2951496124267578e+01 -2.0212200164794922e+01 -7.8240799903869629e+00 -6.3676296234130859e+01 -2.0879798889160156e+01 -6.3429899215698242e+00 -6.7528594970703125e+01 -2.0886798858642578e+01 -8.7112894058227539e+00 -6.5104995727539062e+01 -2.0866199493408203e+01 -7.9224696159362793e+00 -6.3572601318359375e+01 -2.0637199401855469e+01 -7.5048704147338867e+00 -6.2261699676513672e+01 -2.0642299652099609e+01 -5.2907700538635254e+00 -6.5791603088378906e+01 -2.0477001190185547e+01 -9.4930295944213867e+00 -6.7668601989746094e+01 -2.0770900726318359e+01 -9.3475894927978516e+00 -6.4894996643066406e+01 -2.0623199462890625e+01 -8.6585197448730469e+00 -6.0366298675537109e+01 -1.8139200210571289e+01 -5.0881099700927734e+00 -6.0722499847412109e+01 -1.8731399536132812e+01 -5.8447499275207520e+00 -6.1084197998046875e+01 -1.9590000152587891e+01 -5.7146601676940918e+00 -6.1696899414062500e+01 -2.0292400360107422e+01 -5.4823598861694336e+00 -6.1519702911376953e+01 -1.9022199630737305e+01 -7.2866196632385254e+00 -6.0968997955322266e+01 -1.8159299850463867e+01 -6.7200498580932617e+00 -6.1844501495361328e+01 -1.9715000152587891e+01 -7.0786099433898926e+00 -6.1798400878906250e+01 -1.8179298400878906e+01 -8.0919799804687500e+00 -9.4956199645996094e+01 -1.9852399826049805e+01 -9.5523796081542969e+00 -9.4453796386718750e+01 -2.0476699829101562e+01 -8.9710702896118164e+00 -9.5729797363281250e+01 -1.8588001251220703e+01 -9.4496603012084961e+00 -9.5338096618652344e+01 -1.9318201065063477e+01 -9.6174697875976562e+00 -9.5275199890136719e+01 -1.8673000335693359e+01 -1.0142399787902832e+01 -9.3161399841308594e+01 -2.0778799057006836e+01 -9.3056592941284180e+00 -9.3839492797851562e+01 -2.0395500183105469e+01 -9.8352499008178711e+00 -9.4051506042480469e+01 -1.9846000671386719e+01 -1.0406599998474121e+01 -9.3038200378417969e+01 -1.9844099044799805e+01 -1.0789899826049805e+01 -9.2919799804687500e+01 -2.0447200775146484e+01 -1.0065799713134766e+01 -9.5639495849609375e+01 -1.7997301101684570e+01 -9.8040399551391602e+00 -9.4895103454589844e+01 -1.8177099227905273e+01 -1.0668899536132812e+01 -9.3024902343750000e+01 -1.8078800201416016e+01 -1.1482800483703613e+01 -9.2970001220703125e+01 -1.8775999069213867e+01 -1.1366900444030762e+01 -9.3774696350097656e+01 -1.8176700592041016e+01 -1.1310899734497070e+01 -9.4405502319335938e+01 -1.8309900283813477e+01 -1.1005100250244141e+01 -9.3781997680664062e+01 -1.9160699844360352e+01 -1.1028399467468262e+01 -9.4629699707031250e+01 -1.9244899749755859e+01 -1.0483499526977539e+01 -6.7091796875000000e+01 -1.0387100219726562e+01 8.2227993011474609e+00 -6.8684898376464844e+01 -1.0267600059509277e+01 9.1260995864868164e+00 -6.6537399291992188e+01 -1.0284700393676758e+01 7.5106997489929199e+00 -6.6952499389648438e+01 -1.0204899787902832e+01 8.2621393203735352e+00 -6.7445297241210938e+01 -1.0284399986267090e+01 8.6767597198486328e+00 -6.8003402709960938e+01 -1.0204400062561035e+01 9.0006399154663086e+00 -9.4780799865722656e+01 -1.0342499732971191e+01 9.0948200225830078e+00 -9.5615997314453125e+01 -7.4379100799560547e+00 9.1500005722045898e+00 -9.5754699707031250e+01 -9.3954296112060547e+00 9.1500005722045898e+00 -9.9812004089355469e+01 3.8179500102996826e+00 9.1500005722045898e+00 -9.7460502624511719e+01 3.4211501479148865e-01 9.1500005722045898e+00 -9.6030395507812500e+01 -3.6031599044799805e+00 9.1500005722045898e+00 -1.0294199371337891e+02 6.6133403778076172e+00 9.1500005722045898e+00 -1.0354500579833984e+02 7.0583600997924805e+00 -9.1500005722045898e+00 -9.5741798400878906e+01 -9.4041604995727539e+00 -9.1500005722045898e+00 -9.5690200805664062e+01 -5.6777200698852539e+00 -9.1500005722045898e+00 -9.6326698303222656e+01 -2.5946600437164307e+00 -9.1500005722045898e+00 -9.7460502624511719e+01 3.4211501479148865e-01 -9.1500005722045898e+00 -9.9812004089355469e+01 3.8179500102996826e+00 -9.1500005722045898e+00 -9.4780197143554688e+01 -1.0343600273132324e+01 -9.0943698883056641e+00 -9.5914100646972656e+01 -1.2885900497436523e+01 -8.1875104904174805e+00 -9.2767204284667969e+01 -1.0443500518798828e+01 8.9088096618652344e+00 -9.3540496826171875e+01 -1.0453800201416016e+01 8.3829898834228516e+00 -9.2991600036621094e+01 -1.0611999511718750e+01 9.4347295761108398e+00 -9.3684799194335938e+01 -1.0865900039672852e+01 9.6164999008178711e+00 -9.3108398437500000e+01 -1.0393699645996094e+01 7.8538393974304199e+00 -9.2875503540039062e+01 -1.1119400024414062e+01 1.0302600860595703e+01 -9.3976898193359375e+01 -1.1336700439453125e+01 1.0092399597167969e+01 -9.4118400573730469e+01 -1.1921799659729004e+01 1.0509799957275391e+01 -9.2803398132324219e+01 -1.2278599739074707e+01 1.1129500389099121e+01 -9.4789199829101562e+01 -1.1336400032043457e+01 9.2163696289062500e+00 -9.4345397949218750e+01 -1.0851400375366211e+01 8.8078298568725586e+00 -9.5200096130371094e+01 -1.1399000167846680e+01 8.2679204940795898e+00 -9.5081802368164062e+01 -1.2056799888610840e+01 9.7091798782348633e+00 -9.5445701599121094e+01 -1.1953700065612793e+01 8.8719797134399414e+00 -9.5723701477050781e+01 -1.2212299346923828e+01 8.0698595046997070e+00 -9.4766296386718750e+01 -1.2548900604248047e+01 1.0349299430847168e+01 -9.4426605224609375e+01 -1.0768700599670410e+01 8.1309795379638672e+00 -9.2969200134277344e+01 -1.1712499618530273e+01 1.0805199623107910e+01 -6.7538795471191406e+01 -1.1655799865722656e+01 1.0740300178527832e+01 -6.7675102233886719e+01 -1.0599900245666504e+01 9.4035396575927734e+00 -6.8163200378417969e+01 -1.2221399307250977e+01 1.1092700004577637e+01 -6.8055099487304688e+01 -1.1065199851989746e+01 1.0230899810791016e+01 -6.8276100158691406e+01 -1.0440400123596191e+01 8.9049005508422852e+00 -6.5624801635742188e+01 -1.2907999992370605e+01 -1.0718899726867676e+01 -6.5133201599121094e+01 -1.2643300056457520e+01 -1.0425600051879883e+01 -6.4267204284667969e+01 -1.3000999450683594e+01 -1.0042300224304199e+01 -6.2303199768066406e+01 -1.2680799484252930e+01 -8.3036804199218750e+00 -6.3390201568603516e+01 -1.1651099205017090e+01 -8.8691902160644531e+00 -6.4303298950195312e+01 -1.1275300025939941e+01 -9.1667203903198242e+00 -6.4761100769042969e+01 -1.0851999282836914e+01 -8.8473796844482422e+00 -6.5631797790527344e+01 -1.0486500740051270e+01 -8.3171300888061523e+00 -6.5605400085449219e+01 -1.1897500038146973e+01 -1.0314599990844727e+01 -6.4388298034667969e+01 -1.2194299697875977e+01 -9.8595495223999023e+00 -6.3178600311279297e+01 -1.2712699890136719e+01 -9.2077093124389648e+00 -6.5609100341796875e+01 -1.0742199897766113e+01 -8.9996404647827148e+00 -6.6827606201171875e+01 -1.3214099884033203e+01 -1.1109299659729004e+01 -6.8150299072265625e+01 -1.2829500198364258e+01 -1.1287300109863281e+01 -9.5783393859863281e+01 -1.2894499778747559e+01 -8.8829793930053711e+00 -9.5408401489257812e+01 -1.2947400093078613e+01 -9.7028608322143555e+00 -9.4762306213378906e+01 -1.3247200012207031e+01 -1.0475899696350098e+01 -9.4044403076171875e+01 -1.2914200782775879e+01 -1.0944300651550293e+01 -9.3054199218750000e+01 -1.2910599708557129e+01 -1.1280300140380859e+01 -6.8154998779296875e+01 -1.0390000343322754e+01 8.9144802093505859e+00 -9.5694496154785156e+01 -1.2157899856567383e+01 -8.2170896530151367e+00 -9.5115501403808594e+01 -1.1302899360656738e+01 -8.2818202972412109e+00 -9.4288604736328125e+01 -1.0711600303649902e+01 -8.3680400848388672e+00 -9.3305107116699219e+01 -1.0405999183654785e+01 -8.3051605224609375e+00 -6.6861396789550781e+01 -1.1230699539184570e+01 -1.0218200683593750e+01 -6.7718498229980469e+01 -1.0555000305175781e+01 -9.3031597137451172e+00 -6.6954704284667969e+01 -1.2355299949645996e+01 -1.0972000122070312e+01 -6.8097000122070312e+01 -1.1831899642944336e+01 -1.0898099899291992e+01 -6.8167404174804688e+01 -1.1026800155639648e+01 -1.0180800437927246e+01 -9.3028099060058594e+01 -1.0487699508666992e+01 -9.0319404602050781e+00 -9.4236503601074219e+01 -1.0865900039672852e+01 -9.0648107528686523e+00 -9.4712402343750000e+01 -1.1336700439453125e+01 -9.3568792343139648e+00 -9.4869003295898438e+01 -1.1888800621032715e+01 -9.8110904693603516e+00 -9.5405403137207031e+01 -1.1966600418090820e+01 -8.9950094223022461e+00 -9.2892494201660156e+01 -1.1598400115966797e+01 -1.0732900619506836e+01 -9.3836395263671875e+01 -1.1336400032043457e+01 -1.0169199943542480e+01 -9.2781700134277344e+01 -1.1079999923706055e+01 -1.0256199836730957e+01 -9.3148902893066406e+01 -1.0728499412536621e+01 -9.6660299301147461e+00 -9.4224105834960938e+01 -1.2082500457763672e+01 -1.0541100502014160e+01 -9.3492004394531250e+01 -1.1953700065612793e+01 -1.0825699806213379e+01 -9.2700401306152344e+01 -1.2215199470520020e+01 -1.1101500511169434e+01 -9.4969200134277344e+01 -1.2548900604248047e+01 -1.0146300315856934e+01 -9.4030799865722656e+01 1.4237500190734863e+01 -8.9692401885986328e+00 -9.3823699951171875e+01 1.4584000587463379e+01 -8.7680501937866211e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00) (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00) (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00) (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00) (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_l_finger_tip_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_motor_accelerometer_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 4 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_motor_accelerometer_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_palm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.400000 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.800000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 65 66 0 1 0 205 2 105 0 257 65 0 205 0 66 0 105 257 209 66 65 209 442 66 205 66 442 232 442 209 206 205 442 206 442 232 214 232 233 206 232 214 232 382 233 382 232 209 212 213 214 212 214 242 213 206 214 242 214 233 372 233 230 242 233 372 233 382 230 209 230 382 73 230 209 372 230 373 373 230 413 73 413 230 371 372 373 372 371 385 242 372 385 373 393 371 393 373 413 391 393 413 73 308 413 308 391 413 391 392 393 23 159 393 393 392 23 159 371 393 159 71 371 385 371 71 242 385 396 396 385 71 357 358 242 396 357 242 242 358 212 358 357 395 395 357 396 358 395 473 212 358 473 212 434 435 213 212 435 434 212 473 473 479 434 473 426 427 473 395 426 427 479 473 313 395 396 395 313 426 10 426 11 313 11 426 10 427 426 427 491 277 491 427 10 427 277 479 9 10 11 9 356 10 10 264 491 356 264 10 11 70 9 313 315 11 315 70 11 355 356 9 355 9 72 70 72 9 264 356 474 355 474 356 8 264 265 265 264 474 491 264 8 355 24 474 24 265 474 265 345 363 8 265 363 265 24 345 363 6 8 345 6 363 6 7 8 8 7 277 277 491 8 6 345 346 346 468 6 6 468 7 468 161 7 277 7 479 7 161 479 467 468 346 160 468 467 468 160 161 444 346 345 467 346 444 444 471 467 467 471 490 490 160 467 160 55 161 160 376 55 160 490 376 376 490 471 203 376 97 376 56 55 340 56 376 376 471 97 376 203 340 54 55 56 54 161 55 56 434 54 54 434 479 161 54 479 435 434 56 404 435 56 435 404 213 404 56 339 157 213 404 404 339 157 206 213 157 205 206 207 156 206 157 156 365 206 365 207 206 205 364 1 205 207 364 364 207 365 364 365 366 365 158 408 156 158 365 365 408 366 156 157 158 168 158 169 169 158 157 408 158 168 168 282 408 169 472 168 472 282 168 169 359 472 157 360 169 169 360 359 282 472 301 301 472 359 359 360 361 301 359 361 360 157 164 164 361 360 361 192 191 301 361 220 361 191 220 192 361 164 301 281 282 301 220 281 219 220 191 220 153 136 220 136 281 153 220 219 191 192 193 191 193 219 227 219 193 219 227 430 219 154 153 430 154 219 153 154 152 155 153 152 136 153 155 154 150 152 430 150 154 152 150 149 155 152 149 149 150 151 430 151 150 15 149 151 15 17 149 155 149 489 34 489 149 17 34 149 429 151 430 15 151 429 15 16 17 15 91 16 15 429 91 33 34 17 17 16 184 17 184 33 33 428 34 489 34 428 489 87 155 489 428 87 33 319 428 87 428 319 184 319 33 117 319 184 117 184 16 85 319 117 87 319 85 85 86 87 87 86 155 155 86 135 136 155 135 135 46 136 135 86 46 374 375 86 374 86 119 85 119 86 86 375 46 119 85 117 117 118 119 374 119 134 118 134 119 375 374 134 118 133 134 375 134 133 118 379 380 117 89 118 118 89 379 380 133 118 375 133 459 459 133 380 414 380 379 380 367 459 380 414 367 459 367 375 367 368 369 367 417 368 367 414 417 375 367 466 466 367 369 368 255 369 386 368 417 386 255 368 106 369 255 466 369 106 46 466 106 466 46 375 46 106 44 269 44 106 441 106 255 269 106 441 44 45 46 46 45 136 282 45 44 282 44 269 408 282 269 269 441 408 441 254 408 254 441 255 408 254 366 121 253 254 255 256 254 254 270 121 256 270 254 253 366 254 364 366 253 253 121 120 253 129 364 253 120 129 364 129 1 1 129 2 129 120 2 120 121 122 120 122 231 231 2 120 59 105 2 2 231 59 122 272 231 272 341 231 59 231 433 341 433 231 122 139 272 341 272 494 272 457 494 139 457 272 494 457 341 341 432 433 457 348 341 348 432 341 139 138 457 457 138 348 348 138 337 432 348 433 348 337 433 137 138 139 138 304 337 137 140 138 138 140 304 141 137 370 137 141 140 139 370 137 140 141 142 140 142 305 140 305 304 304 305 81 81 80 304 337 304 80 305 483 81 305 326 483 305 142 326 79 80 81 79 81 483 79 14 80 337 80 14 266 267 79 79 483 266 267 50 79 79 50 14 126 483 326 266 483 126 389 406 266 406 267 266 266 126 389 406 244 267 50 267 244 14 50 18 243 50 244 50 243 18 406 407 244 244 407 377 243 244 377 389 229 406 407 406 229 496 407 228 407 229 228 377 407 496 377 378 243 98 377 22 98 378 377 496 22 377 21 308 378 378 98 21 378 308 307 307 243 378 98 22 21 21 22 23 22 159 23 22 496 201 159 22 201 392 21 23 308 21 392 75 307 308 308 73 75 308 392 391 307 75 243 166 243 75 18 243 12 166 215 243 243 215 12 165 166 167 166 257 167 165 215 166 166 75 257 99 13 215 215 13 12 165 99 215 12 13 14 12 14 18 99 100 13 100 101 13 13 101 14 100 99 284 284 99 495 165 495 99 167 495 165 284 495 167 58 283 284 284 283 36 284 167 58 36 100 284 35 100 36 35 101 100 202 101 35 101 202 14 35 36 37 132 35 37 202 35 132 306 37 36 306 36 283 57 283 58 283 57 306 190 37 306 57 190 306 190 189 37 37 189 132 188 189 190 57 433 190 433 188 190 57 58 59 433 57 59 337 188 433 188 337 132 132 189 188 14 132 337 14 202 132 167 59 58 105 59 257 167 257 59 257 75 65 73 74 75 65 75 74 65 74 209 73 209 74 146 72 201 159 201 71 201 72 71 146 201 496 70 71 72 72 146 355 71 464 396 70 465 71 464 71 465 70 315 465 314 464 465 314 465 315 488 396 464 488 464 314 488 497 396 497 313 396 313 488 314 313 497 488 313 314 315 24 355 53 148 355 146 355 148 53 51 52 53 51 53 148 52 24 53 146 147 148 148 180 51 148 147 180 146 496 147 180 147 228 228 147 496 228 229 180 180 229 389 389 128 180 389 126 128 126 127 128 128 179 180 127 179 128 127 126 326 127 326 327 127 327 179 327 218 179 180 179 218 327 334 335 342 40 327 335 342 327 327 40 39 327 39 218 327 326 334 326 142 334 478 142 141 142 492 334 82 142 478 142 124 492 82 124 142 478 141 370 248 83 478 478 370 248 478 83 82 370 249 248 249 370 139 248 249 247 83 248 247 82 83 84 83 247 246 83 237 84 246 237 83 246 247 121 122 247 249 122 121 247 122 249 139 271 121 270 121 271 463 463 246 121 431 246 463 246 431 237 236 84 237 431 236 237 383 240 431 431 240 236 463 383 431 463 271 383 271 256 383 270 256 271 383 256 454 454 240 383 236 240 241 454 296 240 241 240 296 108 453 454 453 296 454 454 256 108 108 256 317 317 256 255 107 69 108 108 69 453 107 108 317 296 453 69 69 295 296 241 296 295 241 295 236 236 295 217 68 295 69 131 217 295 131 295 68 67 68 69 107 200 69 200 67 69 107 317 200 67 200 297 317 318 200 297 200 318 312 420 67 68 67 420 312 67 297 297 311 312 297 318 311 386 311 318 318 255 386 318 317 255 312 311 174 386 416 311 416 174 311 417 416 386 414 415 416 414 416 417 415 174 416 414 379 415 394 415 379 379 89 394 88 394 89 394 335 415 88 335 394 88 89 90 90 89 16 16 89 117 335 88 342 342 88 90 334 415 335 492 501 334 501 415 334 456 492 123 492 456 501 123 492 124 175 501 456 415 501 175 415 175 174 173 174 175 173 175 456 456 362 173 402 362 456 456 123 402 123 124 125 123 125 402 124 82 125 125 130 131 125 131 402 125 82 130 402 131 362 173 362 216 362 131 216 173 216 298 174 173 298 312 174 298 477 312 298 298 216 477 131 68 216 68 477 216 217 131 130 84 217 130 84 130 82 217 84 236 477 68 312 420 312 68 90 16 91 91 235 90 235 342 90 462 316 91 91 429 462 235 91 316 40 235 316 40 342 235 40 316 38 316 462 31 31 38 316 31 462 429 430 31 429 30 31 32 30 221 31 221 38 31 227 32 31 227 31 430 60 61 30 30 61 279 30 279 221 60 30 32 227 28 32 32 28 27 60 32 27 193 226 227 28 227 226 27 28 29 226 484 28 29 28 484 27 29 60 60 29 104 384 29 484 29 384 102 102 104 29 484 338 384 226 338 484 338 226 192 226 193 192 338 162 384 338 192 163 162 338 163 102 384 162 102 103 104 486 103 102 162 486 102 162 163 164 353 162 164 162 353 486 164 163 192 164 401 353 164 157 401 309 353 354 354 353 401 486 353 251 251 353 309 103 486 251 250 251 252 251 309 310 251 250 103 252 251 310 349 323 309 323 310 309 309 354 349 310 323 194 194 252 310 250 252 278 252 194 278 194 195 196 195 194 323 194 196 278 278 196 250 208 196 195 196 347 250 196 208 347 323 324 195 347 208 195 195 436 347 195 324 436 436 423 347 347 423 103 347 103 250 423 436 114 436 475 114 436 476 475 476 436 324 324 323 498 324 498 476 475 476 447 476 485 447 438 476 498 485 476 438 498 323 437 438 498 437 437 323 349 437 110 438 349 111 437 111 110 437 458 485 438 110 458 438 109 110 111 110 109 48 325 458 110 325 110 48 111 349 94 111 94 109 349 354 94 92 93 94 94 76 109 354 92 94 93 76 94 76 48 109 76 77 78 76 268 77 76 78 451 76 93 268 451 48 76 92 268 93 268 439 77 92 157 268 268 157 439 439 381 77 381 78 77 260 451 78 260 78 452 78 381 452 451 260 450 451 450 48 258 259 260 260 452 258 450 260 259 302 452 381 452 302 258 204 302 381 439 204 381 204 210 302 302 210 299 258 302 299 289 322 258 322 259 258 289 258 299 259 322 321 259 321 450 320 321 322 288 320 322 289 288 322 288 289 290 294 290 289 294 289 299 288 499 320 288 290 352 352 424 288 288 424 499 290 351 352 387 290 294 387 351 290 351 387 388 351 197 399 351 388 197 352 351 399 294 469 387 388 387 198 198 387 469 197 388 198 197 198 199 199 399 197 352 399 333 199 333 399 238 199 239 238 333 199 199 198 239 410 333 238 352 333 410 410 238 411 238 239 411 410 411 448 410 448 352 352 331 424 352 448 331 239 448 411 239 331 448 331 332 303 331 239 332 424 331 303 424 303 425 425 461 424 461 499 424 41 143 303 42 303 332 303 143 425 303 42 41 332 239 42 41 42 43 42 198 43 198 42 239 20 143 41 41 43 20 4 19 20 20 329 4 43 336 20 336 329 20 143 20 19 19 291 183 183 143 19 19 3 291 3 19 4 291 403 397 397 287 291 3 403 291 183 291 287 181 182 183 181 183 287 143 183 182 274 287 275 287 397 398 181 287 274 287 398 275 274 275 25 181 274 25 275 345 26 25 275 26 449 345 275 449 275 398 398 397 449 449 444 345 449 397 444 24 26 345 24 25 26 52 181 25 52 25 24 52 51 181 343 182 181 51 343 181 343 51 344 344 405 343 144 343 405 182 343 144 182 144 143 143 144 145 144 405 145 344 263 405 405 263 145 425 143 145 425 145 461 145 263 461 261 262 263 461 263 262 344 261 263 461 262 499 480 499 262 481 480 262 481 262 261 320 499 480 480 481 390 390 320 480 481 445 390 481 261 445 321 320 390 482 390 445 47 390 482 321 390 47 445 446 447 445 447 485 445 261 446 485 482 445 47 482 325 458 325 482 485 458 482 325 48 47 47 48 49 47 49 321 48 450 49 450 321 49 446 409 344 446 261 409 460 446 51 446 344 51 446 460 447 261 344 409 460 475 447 460 51 115 460 115 475 180 218 51 51 116 115 51 218 116 114 115 116 115 114 475 116 218 112 116 279 280 114 116 280 112 279 116 218 39 113 112 218 113 112 113 38 112 38 221 279 112 221 280 279 61 423 114 280 280 61 104 104 423 280 104 61 60 104 103 423 38 39 40 113 39 38 397 443 444 471 444 443 403 443 397 403 471 443 178 471 403 471 178 95 97 471 95 403 3 178 3 4 5 5 178 3 328 4 329 5 4 171 500 171 4 4 328 500 328 329 330 500 328 400 328 330 400 336 330 329 43 330 336 43 400 330 43 455 400 500 400 455 171 500 455 172 455 43 172 171 455 170 171 172 171 170 5 43 273 172 172 273 170 43 419 273 43 225 419 198 225 43 418 273 419 170 273 418 170 418 5 419 276 418 5 418 276 419 245 276 245 419 225 5 276 178 178 276 245 225 62 245 64 178 245 245 62 64 64 95 178 95 96 97 95 64 96 176 96 177 64 177 96 203 96 176 96 203 97 222 223 177 234 222 177 64 234 177 177 223 176 223 222 286 286 222 198 222 224 198 234 224 222 176 223 211 223 286 211 285 211 286 286 186 350 350 285 286 286 198 186 198 224 225 186 198 187 187 198 469 421 412 225 412 62 225 225 224 421 63 412 421 422 421 487 224 487 421 421 422 63 62 412 63 62 63 64 422 64 63 422 487 64 234 487 224 64 487 234 469 294 470 187 469 470 293 470 294 470 293 187 185 186 187 185 187 293 292 293 294 292 185 293 292 186 185 186 292 493 186 493 350 493 292 294 350 493 300 493 294 300 211 350 300 350 211 285 294 299 300 300 299 211 210 176 211 299 210 211 204 176 210 203 176 204 204 439 440 204 440 203 203 339 340 203 440 339 339 440 439 439 157 339 339 56 340 157 92 401 401 92 354 281 45 282 45 281 136))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.1654100036621094e+02 2.8819299697875977e+01 2.1372100830078125e+01 1.1831100463867188e+02 2.4029899597167969e+01 2.2009498596191406e+01 1.2028100585937500e+02 2.0551099777221680e+01 2.0041101455688477e+01 4.1848899841308594e+01 2.3961900711059570e+01 -1.9932701110839844e+01 4.1461299896240234e+01 2.2120000839233398e+01 -1.9689201354980469e+01 4.1461200714111328e+01 2.1937898635864258e+01 -9.5684700012207031e+00 6.1490200042724609e+01 4.6300003051757812e+01 -1.7233299255371094e+01 6.3590801239013672e+01 4.7331298828125000e+01 1.7376600265502930e+01 6.6594604492187500e+01 4.8580097198486328e+01 -1.7121700286865234e+01 8.2293693542480469e+01 5.0280700683593750e+01 -1.8978599548339844e+01 7.6395301818847656e+01 5.0793701171875000e+01 -1.7271301269531250e+01 8.1030303955078125e+01 5.1014698028564453e+01 -1.7174200057983398e+01 1.1479999542236328e+02 3.2614398956298828e+01 -1.3004799842834473e+01 1.1593800354003906e+02 3.2234901428222656e+01 -1.2902700424194336e+01 1.1604299926757812e+02 3.2229698181152344e+01 -1.9731100082397461e+01 1.1605799865722656e+02 -3.2264602661132812e+01 -1.9712699890136719e+01 1.1850199890136719e+02 -2.7195098876953125e+01 -1.9759698867797852e+01 1.1748900604248047e+02 -3.2998699188232422e+01 -1.9747600555419922e+01 1.1488700103759766e+02 3.2486598968505859e+01 -1.9778100967407227e+01 4.1962600708007812e+01 2.1884300231933594e+01 -2.1592199325561523e+01 4.1770000457763672e+01 3.8540201187133789e+00 -2.1172401428222656e+01 1.0538400268554688e+02 4.2581001281738281e+01 -1.8671098709106445e+01 1.0360399627685547e+02 4.2883300781250000e+01 -2.0329401016235352e+01 1.0147100067138672e+02 4.4997497558593750e+01 -1.8635398864746094e+01 6.7597396850585938e+01 4.6218498229980469e+01 -2.0792798995971680e+01 5.2277099609375000e+01 3.2314098358154297e+01 -2.3881799697875977e+01 6.2007999420166016e+01 4.4043197631835938e+01 -2.0751501083374023e+01 1.0396599578857422e+02 -4.2950897216796875e+01 -1.9891799926757812e+01 1.0424599456787109e+02 -4.3347000122070312e+01 -1.8643299102783203e+01 9.9570800781250000e+01 -4.6006698608398438e+01 -1.8625799179077148e+01 1.0612799835205078e+02 -3.9675601959228516e+01 -2.1942399978637695e+01 1.1184799957275391e+02 -3.5224899291992188e+01 -2.2293399810791016e+01 1.0740299987792969e+02 -4.0114002227783203e+01 -2.0729200363159180e+01 1.1833499908447266e+02 -3.2949001312255859e+01 -1.3177000045776367e+01 1.1732900238037109e+02 -3.2930797576904297e+01 4.0176301002502441e+00 1.1844200134277344e+02 3.2897201538085938e+01 -1.2006199836730957e+01 1.1838299560546875e+02 3.2924800872802734e+01 5.3936901092529297e+00 1.1911799621582031e+02 3.2230701446533203e+01 -1.0289499282836914e+01 1.1467099761962891e+02 -2.7561100006103516e+01 -2.3782100677490234e+01 1.1789900207519531e+02 -1.7338798522949219e+01 -2.3882598876953125e+01 1.1865399932861328e+02 -2.1166099548339844e+01 -2.2712999343872070e+01 4.1932003021240234e+01 6.2127596139907837e-01 -2.1483600616455078e+01 2.9449998855590820e+01 -2.4710199832916260e+00 -2.1323400497436523e+01 2.9449998855590820e+01 2.4340200424194336e+00 -2.1343299865722656e+01 1.1990799713134766e+02 -2.0013799667358398e+01 2.1360099792480469e+01 1.1818999481201172e+02 -2.5736099243164062e+01 2.0935001373291016e+01 1.2003300476074219e+02 -2.1960500717163086e+01 1.9855798721313477e+01 6.0512302398681641e+01 -4.5624301910400391e+01 1.7693199157714844e+01 6.1396099090576172e+01 -4.5489299774169922e+01 1.9152299880981445e+01 5.0121299743652344e+01 -3.4111701965332031e+01 2.0814599990844727e+01 1.1603300476074219e+02 3.0545000076293945e+01 -2.0177000045776367e+01 7.4131401062011719e+01 -3.8402198791503906e+01 -2.4230899810791016e+01 5.3492900848388672e+01 3.1628898620605469e+01 -2.4233798980712891e+01 7.4845100402832031e+01 3.8537700653076172e+01 -2.4218099594116211e+01 6.2318798065185547e+01 4.4542396545410156e+01 2.0572299957275391e+01 5.1299499511718750e+01 3.4146900177001953e+01 2.2306499481201172e+01 5.2058300018310547e+01 3.2318302154541016e+01 2.3839698791503906e+01 1.1861799621582031e+02 3.2773700714111328e+01 1.9747798919677734e+01 1.1768000030517578e+02 3.3028202056884766e+01 1.9747499465942383e+01 1.1923200225830078e+02 2.5752300262451172e+01 1.9770500183105469e+01 1.0177099609375000e+02 -4.3595298767089844e+01 -2.0596899032592773e+01 9.8403602600097656e+01 -4.4433097839355469e+01 -2.1070598602294922e+01 4.1448600769042969e+01 2.0201200485229492e+01 7.2723398208618164e+00 4.1445999145507812e+01 1.8578599929809570e+01 1.0757599830627441e+01 4.1475200653076172e+01 2.1937999725341797e+01 2.0074300765991211e+01 1.1415100097656250e+02 3.3124500274658203e+01 2.0921901702880859e+01 1.1377199554443359e+02 3.1981100082397461e+01 2.2530599594116211e+01 1.2519900512695312e+02 -5.3969597816467285e+00 7.3635001182556152e+00 1.2554598999023438e+02 -4.5443401336669922e+00 -6.0654797554016113e+00 1.2552200317382812e+02 -4.5169496536254883e+00 1.8507799148559570e+01 8.6568397521972656e+01 5.0036502838134766e+01 -1.8663000106811523e+01 9.1381294250488281e+01 4.9043701171875000e+01 -1.8709600448608398e+01 8.7309303283691406e+01 4.9024803161621094e+01 -1.9933599472045898e+01 1.0992900085449219e+02 3.7912998199462891e+01 2.0971199035644531e+01 1.1227400207519531e+02 3.5685699462890625e+01 2.0797201156616211e+01 1.1213999938964844e+02 3.6172302246093750e+01 1.9721399307250977e+01 6.4227500915527344e+01 -4.5120998382568359e+01 2.0710599899291992e+01 5.2985198974609375e+01 -3.1408700942993164e+01 2.4222700119018555e+01 5.2224700927734375e+01 -3.2336997985839844e+01 2.3865999221801758e+01 1.1925299835205078e+02 2.3703201293945312e+01 -2.0150600433349609e+01 1.1949100494384766e+02 2.4370899200439453e+01 -1.9778499603271484e+01 1.2063700103759766e+02 1.8895000457763672e+01 -2.0093000411987305e+01 1.2156199645996094e+02 6.2555799484252930e+00 -1.8006399154663086e+01 1.2156300354003906e+02 6.2498903274536133e+00 4.0827598571777344e+00 1.2415999603271484e+02 6.1299600601196289e+00 -6.5868797302246094e+00 1.2100000000000000e+02 -2.8626800537109375e+01 1.9474700927734375e+01 1.2218099975585938e+02 -2.5639499664306641e+01 1.9726301193237305e+01 1.1886199951171875e+02 -3.2624599456787109e+01 1.9689599990844727e+01 1.2106300354003906e+02 -1.6888198852539062e+01 -2.0078699111938477e+01 1.2159700012207031e+02 -1.7674699783325195e+01 -1.9771600723266602e+01 1.1909600067138672e+02 -2.4157001495361328e+01 -2.0106000900268555e+01 1.1707799530029297e+02 -2.8637100219726562e+01 -2.0141799926757812e+01 7.7539299011230469e+01 -4.7723598480224609e+01 2.1053199768066406e+01 7.0501197814941406e+01 -4.6717300415039062e+01 2.0937400817871094e+01 7.4367904663085938e+01 -4.9118198394775391e+01 1.9948200225830078e+01 4.2023498535156250e+01 2.4483001708984375e+01 1.9945800781250000e+01 4.1979301452636719e+01 2.2280099868774414e+01 2.1524398803710938e+01 4.2973598480224609e+01 2.4989999771118164e+01 2.1863000869750977e+01 1.0706099700927734e+02 4.0556198120117188e+01 -2.0412199020385742e+01 1.1578000640869141e+02 3.2241500854492188e+01 -4.5030097961425781e+00 1.1765200042724609e+02 3.3035400390625000e+01 -5.5160603523254395e+00 1.1738400268554688e+02 3.2976898193359375e+01 -1.6216899871826172e+01 9.5943603515625000e+01 -4.7594799041748047e+01 -1.8566099166870117e+01 8.9679702758789062e+01 -4.9457302093505859e+01 -1.8623399734497070e+01 9.4823501586914062e+01 -4.7184700012207031e+01 -1.9878499984741211e+01 1.1793199920654297e+02 2.6954000473022461e+01 2.0128398895263672e+01 1.2137500000000000e+02 -1.4572600364685059e+01 2.0132999420166016e+01 1.2416300201416016e+02 -5.2244997024536133e+00 1.9358800888061523e+01 1.2404299926757812e+02 -3.7942500114440918e+00 1.9900299072265625e+01 6.7845298767089844e+01 -4.7943000793457031e+01 1.9431900024414062e+01 6.6834899902343750e+01 -4.8663002014160156e+01 1.7187700271606445e+01 7.0600097656250000e+01 -4.9512699127197266e+01 1.8100301742553711e+01 1.0911999511718750e+02 -3.3581100463867188e+01 -2.4208101272583008e+01 1.1496800231933594e+02 -2.2546800613403320e+01 -2.4256000518798828e+01 8.0946800231933594e+01 -4.8766098022460938e+01 -2.0619400024414062e+01 7.7487197875976562e+01 -4.7761100769042969e+01 -2.1010900497436523e+01 8.3322006225585938e+01 -3.8958900451660156e+01 -2.4240798950195312e+01 1.2089300537109375e+02 -2.8814199447631836e+01 -1.9726600646972656e+01 1.2399200439453125e+02 -1.8722000122070312e+01 -1.9750000000000000e+01 1.2271299743652344e+02 -2.4364000320434570e+01 -1.9490900039672852e+01 1.2152200317382812e+02 1.3514899253845215e+01 2.0053100585937500e+01 1.2155999755859375e+02 7.0005502700805664e+00 2.0149900436401367e+01 1.2205699920654297e+02 6.9977798461914062e+00 1.9776201248168945e+01 1.2349600219726562e+02 4.3771300315856934e+00 -1.9899000167846680e+01 1.2156700134277344e+02 5.3662900924682617e+00 -1.9448999404907227e+01 1.2415599822998047e+02 5.4748597145080566e+00 -1.9120100021362305e+01 1.1966200256347656e+02 1.5923200607299805e+01 -2.2844299316406250e+01 1.1958499908447266e+02 1.1167099952697754e+01 -2.3250200271606445e+01 1.1814899444580078e+02 1.3589200019836426e+01 -2.3996099472045898e+01 1.2013899993896484e+02 1.8768501281738281e+01 2.1438699722290039e+01 1.2458799743652344e+02 5.9992799758911133e+00 -1.8001298904418945e+01 1.2553000640869141e+02 4.5559401512145996e+00 -1.8481298446655273e+01 1.1880099487304688e+02 3.2646598815917969e+01 -1.9732198715209961e+01 1.2495400238037109e+02 -1.3428999900817871e+01 -1.9517200469970703e+01 1.2414199829101562e+02 -1.9249799728393555e+01 -1.9527099609375000e+01 1.1949100494384766e+02 -2.4370899200439453e+01 1.9778499603271484e+01 1.1672000122070312e+02 -2.9319400787353516e+01 2.0149900436401367e+01 1.2504999542236328e+02 9.9865093231201172e+00 -1.9697200775146484e+01 1.2489099884033203e+02 1.4242899894714355e+01 -1.9663299560546875e+01 1.2508200073242188e+02 1.0018800735473633e+01 3.3295898437500000e+00 1.2204799652099609e+02 7.0051898956298828e+00 -1.9770799636840820e+01 1.2206300354003906e+02 7.0000000000000000e+00 -1.5552700042724609e+01 1.2155899810791016e+02 6.9997301101684570e+00 -2.0134199142456055e+01 4.3363399505615234e+01 4.8121399879455566e+00 -2.3222700119018555e+01 4.4737300872802734e+01 -8.3035602569580078e+00 -2.3961400985717773e+01 4.4120700836181641e+01 -2.2482900619506836e+01 -2.3703201293945312e+01 8.6881401062011719e+01 4.7569099426269531e+01 -2.0928899765014648e+01 8.8601203918457031e+01 3.7955101013183594e+01 -2.4218900680541992e+01 8.1255195617675781e+01 3.9069000244140625e+01 -2.4229598999023438e+01 1.1626799774169922e+02 -3.2354103088378906e+01 1.0055700540542603e+00 1.1494000244140625e+02 -3.2450901031494141e+01 -2.6776200532913208e-01 1.1505200195312500e+02 -3.2389099121093750e+01 -1.5315599441528320e+01 1.1543299865722656e+02 -3.2317199707031250e+01 8.3978300094604492e+00 1.1493899536132812e+02 -3.2432300567626953e+01 2.0050098419189453e+01 1.1474900054931641e+02 -3.2678298950195312e+01 8.1221494674682617e+00 1.1599300384521484e+02 -3.2266399383544922e+01 1.9703500747680664e+01 1.1725699615478516e+02 1.1965000152587891e+01 2.4244100570678711e+01 8.5003005981445312e+01 -3.8562202453613281e+01 2.4246299743652344e+01 1.1735499572753906e+02 -1.1131900787353516e+01 2.4220500946044922e+01 9.6333900451660156e+01 4.7427501678466797e+01 -1.8758600234985352e+01 5.0082603454589844e+01 3.3874401092529297e+01 2.1198301315307617e+01 6.1590198516845703e+01 4.5308399200439453e+01 1.9556098937988281e+01 9.6421005249023438e+01 -4.7370002746582031e+01 1.8783901214599609e+01 1.0019699859619141e+02 -4.5080200195312500e+01 1.9758300781250000e+01 1.0124299621582031e+02 -4.2915699005126953e+01 2.1440999984741211e+01 1.1527700042724609e+02 3.2353698730468750e+01 8.5873804092407227e+00 1.1488700103759766e+02 3.2554500579833984e+01 1.4077199935913086e+01 1.1590599822998047e+02 3.2271999359130859e+01 1.9759901046752930e+01 1.1812300109863281e+02 -1.5584899902343750e+01 2.3930799484252930e+01 1.1414500427246094e+02 -2.4787300109863281e+01 2.4235601425170898e+01 4.1445602416992188e+01 1.9036300659179688e+01 -9.9389896392822266e+00 4.1449100494384766e+01 1.6890701293945312e+01 -1.3332700729370117e+01 2.9449998855590820e+01 1.9019199371337891e+01 -1.0037799835205078e+01 1.2415499877929688e+02 -5.7316303253173828e+00 -1.8848499298095703e+01 1.2156300354003906e+02 -6.2469797134399414e+00 -1.8017700195312500e+01 1.2156500244140625e+02 -5.4651203155517578e+00 -1.9351699829101562e+01 4.2497501373291016e+01 5.2111001014709473e+00 2.2346799850463867e+01 4.1506500244140625e+01 7.3689904212951660e+00 2.0205799102783203e+01 4.1690200805664062e+01 2.3505701065063477e+01 4.7142801284790039e+00 1.1864499664306641e+02 -6.5876703262329102e+00 -2.3852499008178711e+01 1.1704000091552734e+02 1.5026399612426758e+01 -2.4248300552368164e+01 4.5662300109863281e+01 2.2897298812866211e+01 -2.4236000061035156e+01 4.4576499938964844e+01 1.5580699920654297e+01 -2.3915401458740234e+01 4.3443500518798828e+01 2.2479099273681641e+01 -2.3248498916625977e+01 1.1875700378417969e+02 -3.2695899963378906e+01 -1.9715198516845703e+01 2.9450698852539062e+01 -1.5205499649047852e+01 1.5197799682617188e+01 2.9451499938964844e+01 -1.1640099525451660e+01 1.8076799392700195e+01 2.9454101562500000e+01 -1.8656299591064453e+01 1.0724600791931152e+01 1.2233799743652344e+02 2.5371700286865234e+01 -1.9517099380493164e+01 1.2054399871826172e+02 2.9552598953247070e+01 -1.9501600265502930e+01 1.2125399780273438e+02 2.8054500579833984e+01 1.9512899398803711e+01 1.1140499877929688e+02 -3.6038398742675781e+01 2.1706399917602539e+01 1.0604000091552734e+02 -4.1192798614501953e+01 2.0605699539184570e+01 1.0979799652099609e+02 -3.8754299163818359e+01 1.9404298782348633e+01 8.3412498474121094e+01 -5.0918399810791016e+01 1.6443099975585938e+01 8.2245002746582031e+01 -5.0994197845458984e+01 -1.6992900848388672e+01 8.6562797546386719e+01 -5.0568698883056641e+01 -1.0563799858093262e+01 2.9450099945068359e+01 -2.1184900283813477e+01 -3.6931798458099365e+00 2.9449998855590820e+01 -2.0445899963378906e+01 6.5655498504638672e+00 2.9449998855590820e+01 -1.9360700607299805e+01 -9.3323698043823242e+00 1.2442700195312500e+02 -6.0271401405334473e+00 1.8212699890136719e+01 9.5909698486328125e+01 4.6076499938964844e+01 -2.0557399749755859e+01 1.1787100219726562e+02 3.3044597625732422e+01 -1.9747798919677734e+01 4.3507301330566406e+01 2.2327701568603516e+01 2.3380701065063477e+01 4.4268398284912109e+01 -1.1331999778747559e+01 2.3785600662231445e+01 1.1562400054931641e+02 2.6839601516723633e+01 2.3416000366210938e+01 1.1578600311279297e+02 2.1190399169921875e+01 2.4250699996948242e+01 1.1728700256347656e+02 2.0083398818969727e+01 2.3868900299072266e+01 8.6562202453613281e+01 -5.0484897613525391e+01 -1.7434700012207031e+01 1.1066400146484375e+02 3.5422897338867188e+01 2.2967699050903320e+01 4.2715000152587891e+01 -2.1253200531005859e+01 2.2587200164794922e+01 4.1871902465820312e+01 -3.0555698871612549e+00 2.1301898956298828e+01 7.8002403259277344e+01 4.7927398681640625e+01 2.0995498657226562e+01 8.0304199218750000e+01 3.9039802551269531e+01 2.4248100280761719e+01 8.6040496826171875e+01 3.8676998138427734e+01 2.4187700271606445e+01 1.1477999877929688e+02 3.2641399383544922e+01 1.2448700666427612e+00 1.2554700469970703e+02 -4.8945403099060059e+00 -1.8038099288940430e+01 1.2523099517822266e+02 5.3644199371337891e+00 -3.0804901123046875e+00 1.1725600433349609e+02 -9.4152898788452148e+00 -2.4246200561523438e+01 1.1267500305175781e+02 -3.5539100646972656e+01 1.9991199493408203e+01 1.1403199768066406e+02 -3.2502799987792969e+01 2.1869899749755859e+01 1.1058600616455078e+02 -3.5444000244140625e+01 -2.3014999389648438e+01 2.9451999664306641e+01 7.9106698036193848e+00 2.0037500381469727e+01 4.1908802032470703e+01 2.6628899574279785e+00 2.1350700378417969e+01 2.9449899673461914e+01 1.2911100387573242e+01 1.7200500488281250e+01 2.9450599670410156e+01 2.1122200012207031e+01 4.1480898857116699e+00 1.0661199951171875e+02 -4.1649898529052734e+01 1.8603500366210938e+01 1.0902899932861328e+02 -3.9587596893310547e+01 -1.9060300827026367e+01 1.0874500274658203e+02 3.3654399871826172e+01 -2.4233699798583984e+01 1.1331700134277344e+02 2.6757999420166016e+01 -2.4224399566650391e+01 1.0399299621582031e+02 4.1632598876953125e+01 2.1390899658203125e+01 1.2199500274658203e+02 1.4932700157165527e+01 1.9752599716186523e+01 1.0912699890136719e+02 3.3405899047851562e+01 2.4258600234985352e+01 9.6535598754882812e+01 4.4738597869873047e+01 2.1203899383544922e+01 4.1447799682617188e+01 1.1319199562072754e+01 1.8237798690795898e+01 1.1847099304199219e+02 -2.4286499023437500e+01 -2.1516099929809570e+01 1.2518499755859375e+02 5.3708100318908691e+00 1.7989000320434570e+01 1.2409799957275391e+02 6.1388902664184570e+00 1.7529298782348633e+01 2.9452400207519531e+01 -1.6320199966430664e+01 -1.4042399406433105e+01 2.9449998855590820e+01 -9.0945901870727539e+00 -1.9463998794555664e+01 1.2527500152587891e+02 4.0470399856567383e+00 1.9094501495361328e+01 1.2556399536132812e+02 3.8000998497009277e+00 1.8034000396728516e+01 8.7470504760742188e+01 4.7957099914550781e+01 2.0746700286865234e+01 1.1246299743652344e+02 3.5779899597167969e+01 -2.0218299865722656e+01 1.1365599822998047e+02 3.3056800842285156e+01 -2.1897500991821289e+01 4.1455802917480469e+01 2.1384599685668945e+01 2.2605700492858887e+00 1.2156300354003906e+02 6.2451696395874023e+00 1.8022300720214844e+01 1.2156300354003906e+02 7.0000000000000000e+00 1.0747600555419922e+01 1.2156300354003906e+02 7.0000000000000000e+00 1.7906399965286255e+00 1.2206300354003906e+02 7.0000000000000000e+00 8.3286905288696289e+00 8.6563293457031250e+01 -5.0017402648925781e+01 -1.2963099479675293e+00 8.6581398010253906e+01 -5.0049201965332031e+01 1.8601900100708008e+01 8.6563293457031250e+01 -5.0559402465820312e+01 9.1940202713012695e+00 1.2098600006103516e+02 1.2696400642395020e+01 2.1552900314331055e+01 1.2083100128173828e+02 -7.2210496664047241e-01 2.1907600402832031e+01 1.2155400085449219e+02 -6.9981999397277832e+00 2.0158000946044922e+01 1.2158300018310547e+02 -5.0495600700378418e-01 2.0014400482177734e+01 1.1489199829101562e+02 3.2459999084472656e+01 2.0126701354980469e+01 4.3914299011230469e+01 -2.5972900390625000e+01 2.2440999984741211e+01 4.6688999176025391e+01 -3.0191200256347656e+01 2.1198799133300781e+01 5.0702800750732422e+01 -3.2870800018310547e+01 2.2906299591064453e+01 5.1347099304199219e+01 -3.2749599456787109e+01 -2.3373899459838867e+01 4.5005100250244141e+01 -2.6748800277709961e+01 -2.2832500457763672e+01 4.5809803009033203e+01 -2.5172300338745117e+01 -2.3899999618530273e+01 7.2368896484375000e+01 4.9847099304199219e+01 -1.8287500381469727e+01 6.8518104553222656e+01 4.8139698028564453e+01 -1.9446098327636719e+01 1.1872799682617188e+02 2.2832500457763672e+01 -2.2009401321411133e+01 1.1693399810791016e+02 2.7360700607299805e+01 -2.1905700683593750e+01 7.5895599365234375e+01 -3.8876602172851562e+01 2.4225101470947266e+01 1.2014500427246094e+02 -1.6668500900268555e+01 2.2199598312377930e+01 1.2156300354003906e+02 1.0851199626922607e+00 2.0165199279785156e+01 1.2156300354003906e+02 3.8944101333618164e+00 1.9998800277709961e+01 1.2502400207519531e+02 9.9738397598266602e+00 1.9713399887084961e+01 2.9450201034545898e+01 2.0599599838256836e+01 -6.0919404029846191e+00 4.7122299194335938e+01 2.6560800552368164e+01 -2.3925800323486328e+01 5.1354999542236328e+01 3.3145000457763672e+01 -2.3125200271606445e+01 4.1450401306152344e+01 2.1425399780273438e+01 -1.4014999866485596e+00 6.7718902587890625e+01 4.8960700988769531e+01 1.6951999664306641e+01 8.6562698364257812e+01 -5.0569000244140625e+01 1.6153399944305420e+00 1.0523399353027344e+02 -3.8684600830078125e+01 -2.2714199066162109e+01 8.7970802307128906e+01 -4.7339996337890625e+01 -2.0930999755859375e+01 1.1642400360107422e+02 -2.8069200515747070e+01 2.2089599609375000e+01 1.1822499847412109e+02 -2.2612699508666992e+01 2.2685699462890625e+01 1.1841799926757812e+02 3.2908000946044922e+01 1.2055000305175781e+01 1.1731700134277344e+02 3.2933498382568359e+01 1.0373600006103516e+01 2.9450399398803711e+01 -4.0197496414184570e+00 2.1087100982666016e+01 2.9450298309326172e+01 1.1759699583053589e+00 2.1488599777221680e+01 4.4620399475097656e+01 2.5843999862670898e+01 -2.3104600906372070e+01 4.2160598754882812e+01 -2.4873600006103516e+01 -1.9721300125122070e+01 4.2020000457763672e+01 -2.4550701141357422e+01 1.9998500823974609e+01 4.1572998046875000e+01 -2.2780099868774414e+01 2.5766799449920654e+00 4.2974300384521484e+01 2.4490398406982422e+01 -2.2228799819946289e+01 4.1449100494384766e+01 -1.4331899642944336e+01 1.5987400054931641e+01 4.1449497222900391e+01 -1.6877099990844727e+01 1.3331399917602539e+01 4.1484100341796875e+01 -2.1851800918579102e+01 1.9717401504516602e+01 1.2556501007080078e+02 4.4949302673339844e+00 7.4721398353576660e+00 1.2554800415039062e+02 -2.4081601202487946e-01 1.8444801330566406e+01 1.2417399597167969e+02 -6.1183500289916992e+00 6.0768003463745117e+00 1.2411899566650391e+02 -6.1393198966979980e+00 -1.7518001556396484e+01 4.1921100616455078e+01 -2.2732299804687500e+01 2.1374401092529297e+01 4.1540802001953125e+01 -7.1070599555969238e+00 2.0256099700927734e+01 1.1436600494384766e+02 -3.0236999511718750e+01 2.2997900009155273e+01 4.3808502197265625e+01 -2.2717800140380859e+01 2.3489101409912109e+01 4.1893402099609375e+01 -2.7665500640869141e+00 -2.1349500656127930e+01 1.2153800201416016e+02 1.7149499893188477e+01 -1.9765699386596680e+01 1.2143099975585938e+02 1.2672100067138672e+01 -2.0265100479125977e+01 1.1907199859619141e+02 3.2347499847412109e+01 1.9513999938964844e+01 1.1054000091552734e+02 3.8017299652099609e+01 1.7951200008392334e+00 1.0793899536132812e+02 4.0545898437500000e+01 1.8810300827026367e+01 8.2682403564453125e+01 -5.0309898376464844e+01 1.8905900955200195e+01 8.6556900024414062e+01 -5.0553501129150391e+01 1.7278999328613281e+01 1.2156300354003906e+02 -6.2444200515747070e+00 -6.9675701856613159e-01 1.2427500152587891e+02 -6.1088700294494629e+00 -6.6244401931762695e+00 8.3356597900390625e+01 5.0927299499511719e+01 1.6988599777221680e+01 8.6559799194335938e+01 5.0580799102783203e+01 -2.9593899250030518e+00 8.6560501098632812e+01 5.0589900970458984e+01 -1.7030900955200195e+01 1.1646399688720703e+02 -2.7535799026489258e+01 -2.2384300231933594e+01 1.2156700134277344e+02 -4.8942399024963379e+00 1.9851400375366211e+01 1.2156099700927734e+02 -6.2293601036071777e+00 1.8089401245117188e+01 1.1912299346923828e+02 -3.2290699005126953e+01 -4.7652201652526855e+00 4.3421901702880859e+01 -2.7150299072265625e+01 -1.9364700317382812e+01 4.8006000518798828e+01 -3.2157501220703125e+01 1.9838899612426758e+01 4.3395999908447266e+01 -2.7102100372314453e+01 2.0171800613403320e+01 7.8084495544433594e+01 -5.0971900939941406e+01 1.7122600555419922e+01 7.7095802307128906e+01 -5.0876499176025391e+01 -1.7087100982666016e+01 6.3486202239990234e+01 -4.7273097991943359e+01 1.7081399917602539e+01 1.2087000274658203e+02 1.1438300132751465e+01 -2.1848699569702148e+01 1.1984200286865234e+02 -1.2806900024414062e+01 -2.3092399597167969e+01 4.1445400238037109e+01 1.0852499961853027e+01 -1.8539798736572266e+01 4.1521697998046875e+01 7.4629402160644531e+00 -2.0129699707031250e+01 2.9450799942016602e+01 8.8233795166015625e+00 -1.9572601318359375e+01 4.1494701385498047e+01 -7.6232600212097168e+00 -2.0119899749755859e+01 2.9452400207519531e+01 -6.1314601898193359e+00 -2.0570798873901367e+01 4.1449401855468750e+01 -1.7941299438476562e+01 -1.1848400115966797e+01 1.2104299926757812e+02 -3.4721398353576660e-01 -2.1517700195312500e+01 1.2101799774169922e+02 -1.1870800018310547e+01 -2.1538600921630859e+01 2.9451999664306641e+01 5.6320900917053223e+00 -2.0720699310302734e+01 1.2360499572753906e+02 2.1061800003051758e+01 -1.9662199020385742e+01 1.0237000274658203e+02 -4.4525600433349609e+01 1.8729499816894531e+01 4.6008998870849609e+01 2.3310199737548828e+01 2.4242300033569336e+01 4.5149299621582031e+01 2.5467100143432617e+01 2.3525800704956055e+01 1.2477300262451172e+02 1.4673699378967285e+01 1.9649398803710938e+01 1.2036299896240234e+02 -1.8118400573730469e+01 -2.1322500228881836e+01 4.5955596923828125e+01 1.3097300529479980e+01 -2.4247200012207031e+01 5.3228900909423828e+01 -3.1484498977661133e+01 -2.4235399246215820e+01 6.1658401489257812e+01 4.5324096679687500e+01 -1.9570499420166016e+01 5.9491199493408203e+01 4.4742000579833984e+01 -1.7504899978637695e+01 8.6561096191406250e+01 -5.0012901306152344e+01 -1.8737998962402344e+01 1.2450399780273438e+02 1.7211500167846680e+01 8.8741995394229889e-02 7.6335197448730469e+01 -5.0503200531005859e+01 1.8162900924682617e+01 2.9450399398803711e+01 -6.8196997642517090e+00 2.0367799758911133e+01 4.1458400726318359e+01 -2.1431098937988281e+01 -1.9154599905014038e+00 4.1502502441406250e+01 -2.2397899627685547e+01 -1.9669300079345703e+01 8.9915000915527344e+01 -4.8864700317382812e+01 1.9548398971557617e+01 8.0191101074218750e+01 -4.9564800262451172e+01 1.9968200683593750e+01 7.8857894897460938e+01 4.8629398345947266e+01 -2.0719400405883789e+01 7.7992996215820312e+01 5.0031299591064453e+01 -1.9285200119018555e+01 8.2900199890136719e+01 4.9613597869873047e+01 1.9807298660278320e+01 7.7579299926757812e+01 4.9055099487304688e+01 2.0289400100708008e+01 1.1334799957275391e+02 -2.8897199630737305e+01 2.3953001022338867e+01 1.0887799835205078e+02 -3.3707099914550781e+01 2.4216800689697266e+01 1.1023600006103516e+02 -3.5348800659179688e+01 2.3302799224853516e+01 1.2530400085449219e+02 -4.2098202705383301e+00 -1.8979999542236328e+01 6.5223594665527344e+01 4.7747299194335938e+01 -1.8123901367187500e+01 1.1929499816894531e+02 1.8003900527954102e+01 2.2880399703979492e+01 1.1877799987792969e+02 1.1789199829101562e+01 2.3743000030517578e+01 1.2020999908447266e+02 1.0971300125122070e+01 2.2728099822998047e+01 1.2505699920654297e+02 -9.9936103820800781e+00 1.9732500076293945e+01 1.2206300354003906e+02 -7.0000000000000000e+00 1.1625100135803223e+01 1.2206199645996094e+02 -7.0005102157592773e+00 1.9778499603271484e+01 1.2206300354003906e+02 7.0000000000000000e+00 -2.0538301467895508e+00 9.5069999694824219e+01 4.7896797180175781e+01 1.8612800598144531e+01 9.6663497924804688e+01 4.6234897613525391e+01 2.0146400451660156e+01 1.0149700164794922e+02 4.4369998931884766e+01 1.9860898971557617e+01 1.2362599945068359e+02 -2.1295598983764648e+01 1.9502901077270508e+01 1.2441900634765625e+02 -1.7549499511718750e+01 1.9725799560546875e+01 4.4434700012207031e+01 2.6387098312377930e+01 2.2640300750732422e+01 1.1046299743652344e+02 3.6007099151611328e+01 -2.2724399566650391e+01 1.0930699920654297e+02 3.9254596710205078e+01 -1.9282798767089844e+01 1.2208999633789062e+02 -7.0206799507141113e+00 -1.9766799926757812e+01 1.2501299285888672e+02 -9.9498300552368164e+00 -1.9716699600219727e+01 4.5723300933837891e+01 -2.2883501052856445e+01 2.4228099822998047e+01 1.0694499969482422e+02 3.7792198181152344e+01 2.2852600097656250e+01 1.2399099731445312e+02 4.2607698440551758e+00 1.9886299133300781e+01 9.8593597412109375e+01 -4.6460300445556641e+01 7.7177100181579590e+00 9.0517501831054688e+01 4.9235298156738281e+01 1.8761899948120117e+01 1.2156300354003906e+02 -7.0000000000000000e+00 6.2587699890136719e+00 4.1446998596191406e+01 -2.1255100250244141e+01 3.1492199897766113e+00 2.9451400756835938e+01 -2.1394599914550781e+01 1.8386900424957275e+00 1.1756900024414062e+02 2.0236700057983398e+01 -2.3723600387573242e+01 6.0049701690673828e+01 -4.5218200683593750e+01 -1.7670299530029297e+01 1.0467100524902344e+02 4.3041698455810547e+01 1.8641000747680664e+01 1.0376599884033203e+02 4.3659500122070312e+01 2.6347398757934570e+00 1.0009400177001953e+02 4.5747100830078125e+01 1.8707201004028320e+01 1.2153800201416016e+02 -1.0916000366210938e+01 -2.0160699844360352e+01 8.0076698303222656e+01 5.0326499938964844e+01 1.8977800369262695e+01 8.6578506469726562e+01 5.0037799835205078e+01 1.8725198745727539e+01 4.3631099700927734e+01 2.6957700729370117e+01 -2.0975900650024414e+01 4.6153900146484375e+01 2.8781499862670898e+01 -2.2180900573730469e+01 4.1444698333740234e+01 -2.0168998718261719e+01 -7.4942698478698730e+00 2.9450201034545898e+01 1.2137399673461914e+01 -1.7715801239013672e+01 8.6604103088378906e+01 -4.8097400665283203e+01 2.0748498916625977e+01 1.2470400238037109e+02 3.4212801456451416e+00 -1.9651800155639648e+01 4.2493999481201172e+01 2.5605899810791016e+01 -1.9873600006103516e+01 5.3477100372314453e+01 3.1604801177978516e+01 2.4243799209594727e+01 4.6118499755859375e+01 -2.3080799102783203e+01 -2.4238500595092773e+01 1.1544400024414062e+02 2.7181598663330078e+01 -2.3450599670410156e+01 1.1009400177001953e+02 3.4561500549316406e+01 -2.3769300460815430e+01 1.1964300537109375e+02 -1.2571100234985352e+01 2.3256000518798828e+01 5.3597900390625000e+01 -3.3945301055908203e+01 -2.3461999893188477e+01 4.1449302673339844e+01 -1.5137000083923340e+01 -1.5231100082397461e+01 2.9451400756835938e+01 -1.3029700279235840e+01 -1.7065700531005859e+01 2.9451099395751953e+01 1.9630899429321289e+01 8.6858806610107422e+00 1.0599099731445312e+02 4.1502201080322266e+01 2.0141000747680664e+01 1.2206300354003906e+02 -7.0000000000000000e+00 -1.4847399711608887e+01 1.2156700134277344e+02 -7.0021200180053711e+00 -2.0100299835205078e+01 1.2156300354003906e+02 -7.0000000000000000e+00 -4.9702701568603516e+00 1.2206300354003906e+02 -7.0000000000000000e+00 3.8407897949218750e+00 4.1443099975585938e+01 2.0705501556396484e+01 -5.9115500450134277e+00 2.9449998855590820e+01 2.1461299896240234e+01 -1.3934799432754517e+00 1.2510399627685547e+02 -5.4875302314758301e+00 -2.6204500198364258e+00 2.9451599121093750e+01 1.6979499816894531e+01 1.3179400444030762e+01 4.1449302673339844e+01 1.6233200073242188e+01 1.4062999725341797e+01 8.7422401428222656e+01 -4.9064098358154297e+01 -1.9846899032592773e+01 4.1816600799560547e+01 -2.2916400909423828e+01 -2.1086198806762695e+01 4.2815101623535156e+01 -2.1860500335693359e+01 -2.2703800201416016e+01 7.7563896179199219e+01 5.0843299865722656e+01 1.7545801162719727e+01 7.1856697082519531e+01 5.0089199066162109e+01 1.7277500152587891e+01 1.1843399810791016e+02 -3.2894100189208984e+01 5.2945899963378906e+00 1.1496400451660156e+02 -3.2404602050781250e+01 -2.0033300399780273e+01 1.1252400207519531e+02 -3.5706298828125000e+01 -1.9854400634765625e+01 1.2408000183105469e+02 5.6865200996398926e+00 1.8953201293945312e+01 1.2405799865722656e+02 1.9487199783325195e+01 1.9514999389648438e+01 1.2313099670410156e+02 2.2883298873901367e+01 1.9678098678588867e+01 7.0093299865722656e+01 4.6915401458740234e+01 2.0814599990844727e+01 7.3881401062011719e+01 3.8409301757812500e+01 2.4193799972534180e+01 8.0496200561523438e+01 -5.0318000793457031e+01 -1.9005599975585938e+01 7.2027694702148438e+01 -5.0115501403808594e+01 1.6612600326538086e+01 6.9010398864746094e+01 -4.9358100891113281e+01 -1.6804800033569336e+01 4.6135101318359375e+01 -7.1033396720886230e+00 2.4248798370361328e+01 4.4780899047851562e+01 6.5252199172973633e+00 2.3964500427246094e+01 1.2100000000000000e+02 -1.1211899757385254e+01 2.1605800628662109e+01 1.1233300018310547e+02 3.1228599548339844e+01 2.3798900604248047e+01 4.3482299804687500e+01 2.7216701507568359e+01 -1.2783800125122070e+01 4.8873302459716797e+01 3.2969501495361328e+01 -2.0585100173950195e+01 6.1301498413085938e+01 -4.5305198669433594e+01 -1.9338098526000977e+01 6.2783397674560547e+01 -4.4689498901367188e+01 -2.0667100906372070e+01 6.8034202575683594e+01 -4.8063198089599609e+01 -1.9371601104736328e+01 4.1448001861572266e+01 -1.1764200210571289e+01 -1.7972299575805664e+01 5.0433300018310547e+01 3.3507297515869141e+01 -2.2159399032592773e+01 5.0605499267578125e+01 -3.3803897857666016e+01 2.2021099090576172e+01 6.1553798675537109e+01 -4.4041900634765625e+01 2.0580099105834961e+01 4.5529499053955078e+01 -2.5807001113891602e+01 2.3592998504638672e+01 1.2506100463867188e+02 -2.4962198734283447e+00 1.9315698623657227e+01 1.2427199554443359e+02 1.1613200604915619e-01 1.9849100112915039e+01 2.9450201034545898e+01 1.5377300262451172e+01 -1.5040299415588379e+01 1.2397200012207031e+02 -4.3468198776245117e+00 -1.9870899200439453e+01 1.2496200561523438e+02 1.3045000076293945e+01 -7.3478999137878418e+00 6.4566795349121094e+01 -4.7766201019287109e+01 -1.6582500457763672e+01 1.2499500274658203e+02 -1.2810200691223145e+01 1.9527099609375000e+01 7.0175300598144531e+01 -4.6927200317382812e+01 -2.0823200225830078e+01 4.3556797027587891e+01 -2.3889400482177734e+01 -2.3026800155639648e+01 1.1550000000000000e+02 -3.0891201019287109e+01 -2.1069000244140625e+01 1.2156700134277344e+02 5.3327598571777344e+00 1.9488500595092773e+01 8.6563697814941406e+01 5.0022399902343750e+01 4.7650203704833984e+00 8.6563293457031250e+01 5.0018001556396484e+01 -8.4483699798583984e+00 1.2203700256347656e+02 -1.5033599853515625e+01 1.9751699447631836e+01 4.9822799682617188e+01 3.4136699676513672e+01 1.9837999343872070e+01 6.0570697784423828e+01 4.5697101593017578e+01 1.7498500823974609e+01 4.1449901580810547e+01 -2.0154100418090820e+01 7.4180202484130859e+00 4.1449497222900391e+01 -1.8806699752807617e+01 1.0360699653625488e+01 4.3002300262451172e+01 2.6556699752807617e+01 1.9947500228881836e+01 1.1625699615478516e+02 -2.4141599655151367e+01 2.3707300186157227e+01 7.2535697937011719e+01 4.9100399017333984e+01 1.9602998733520508e+01 7.3173599243164062e+01 4.8740200042724609e+01 -2.0037099838256836e+01 7.5365203857421875e+01 -4.9183101654052734e+01 -2.0009300231933594e+01 7.4140495300292969e+01 -5.0144901275634766e+01 -1.8372200012207031e+01 1.2514400482177734e+02 -5.4489202499389648e+00 -1.1442899703979492e+01 1.2156300354003906e+02 7.0000000000000000e+00 -7.4766798019409180e+00 6.7888198852539062e+01 4.8122001647949219e+01 1.9240598678588867e+01 4.8659599304199219e+01 -3.2538002014160156e+01 -2.0967100143432617e+01 5.0401298522949219e+01 -3.3608200073242188e+01 -2.2029298782348633e+01 6.1970798492431641e+01 -4.6539398193359375e+01 -1.7511001586914062e+01 1.2056600189208984e+02 1.6455299377441406e+01 -2.1572700500488281e+01 1.0175900268554688e+02 -4.4870903015136719e+01 2.3420000076293945e+00 6.7292495727539062e+01 -4.8552299499511719e+01 -1.7979801177978516e+01 9.1211997985839844e+01 -4.9090198516845703e+01 1.8606700897216797e+01 4.1446498870849609e+01 1.3913299560546875e+01 1.6371799468994141e+01 8.6563293457031250e+01 5.0559101104736328e+01 9.3907394409179688e+00 1.1766099548339844e+02 -3.3039699554443359e+01 1.9742099761962891e+01 4.5223400115966797e+01 2.8551799774169922e+01 2.1276000976562500e+01 7.2094406127929688e+01 5.0154399871826172e+01 -1.6445699691772461e+01 1.2158200073242188e+02 4.1109700202941895e+00 -2.0010000228881836e+01 4.1451301574707031e+01 -9.9402704238891602e+00 1.9050399780273438e+01 1.2495099639892578e+02 1.3168999671936035e+01 8.1176996231079102e+00 1.1629699707031250e+02 3.2352203369140625e+01 1.0701100349426270e+01 1.0091000366210938e+02 4.2978599548339844e+01 -2.1418399810791016e+01 8.6562698364257812e+01 5.0544700622558594e+01 1.7201200485229492e+01 7.2773200988769531e+01 -5.0259998321533203e+01 -1.6804000854492188e+01 4.3583099365234375e+01 -2.6588798522949219e+01 -2.1462099075317383e+01 4.1445999145507812e+01 1.3733099937438965e+01 -1.6506999969482422e+01 1.2158499908447266e+02 -4.2660198211669922e+00 -1.9997001647949219e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 39 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00) (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01) (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01) (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01) (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01) (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01) (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01) (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01) (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01) (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01) (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_palm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_r_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.6910000000000011e+01 -1.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 856 1 0 953 856 0 477 0 484 0 34 484 2 34 0 953 0 477 2 147 33 34 2 33 2 1 147 33 30 34 34 32 484 34 30 32 477 484 32 30 31 32 476 477 32 476 32 486 486 32 31 485 476 486 718 850 476 485 718 476 476 850 477 902 485 486 902 718 485 902 486 717 31 844 486 486 844 717 902 717 718 717 646 718 717 778 646 717 844 778 778 844 647 31 290 844 844 290 647 778 647 646 646 647 620 4 718 646 620 4 646 620 647 36 290 36 647 290 37 36 31 37 290 35 36 37 620 36 396 36 35 396 4 620 396 395 4 396 35 481 396 396 481 546 546 395 396 35 37 481 37 472 481 37 31 470 472 37 470 546 481 545 481 472 923 481 923 545 545 483 546 597 395 546 546 483 597 545 923 483 923 472 483 469 472 470 483 472 469 478 483 469 483 478 597 597 478 543 543 395 597 468 478 469 478 468 479 543 478 479 468 469 470 468 38 466 468 466 479 468 470 38 479 466 480 479 480 543 466 38 467 466 467 471 466 471 480 543 480 688 689 480 471 688 480 689 471 467 734 689 471 690 690 471 734 38 22 467 467 22 734 406 733 734 21 734 22 406 734 21 733 690 734 688 689 690 733 688 690 543 688 408 733 408 688 406 408 733 406 407 408 407 406 21 21 22 23 21 23 407 38 491 22 22 491 23 23 748 407 23 491 489 748 23 489 408 407 832 832 407 791 748 791 407 748 489 853 748 853 791 488 489 490 488 853 489 489 491 490 853 488 791 791 792 148 148 832 791 791 488 792 792 488 490 490 491 896 740 490 896 740 792 490 148 792 740 149 148 740 684 740 896 684 149 740 465 464 896 465 896 491 684 896 464 683 684 464 684 69 149 70 684 683 69 684 70 463 464 465 464 463 683 470 463 39 31 683 463 463 465 39 470 31 463 470 39 38 38 39 40 465 40 39 40 491 38 491 40 465 30 487 31 487 458 31 31 458 683 487 680 458 19 680 487 19 487 473 473 487 30 458 459 216 216 593 458 680 459 458 458 593 683 64 459 680 64 680 19 459 499 216 64 493 459 493 499 459 216 217 218 216 218 593 216 499 217 593 316 683 593 218 316 259 218 260 316 218 259 218 68 70 260 218 70 218 217 68 316 259 683 259 260 683 260 70 683 68 69 70 68 217 272 68 272 69 272 217 232 777 686 217 217 686 232 497 217 499 217 497 777 231 183 232 232 686 231 183 272 232 682 686 777 682 231 686 456 777 497 682 777 456 681 682 456 682 681 231 231 681 183 456 367 681 849 681 367 183 681 849 456 361 457 456 457 367 456 497 361 361 362 191 497 362 361 457 361 191 367 457 191 365 366 367 367 191 365 818 849 367 745 367 366 818 367 528 367 745 528 528 745 529 366 529 745 528 529 530 528 530 963 963 818 528 530 529 366 963 530 859 859 530 366 859 366 860 366 365 860 859 860 381 963 859 381 818 963 381 381 365 190 818 381 190 860 365 381 190 191 192 192 631 190 631 892 190 190 892 818 365 191 190 362 138 191 192 191 178 178 191 138 192 178 736 736 631 192 892 631 736 178 735 736 735 171 736 171 892 736 169 170 171 171 735 169 170 892 171 297 169 298 169 297 752 170 169 752 169 735 829 169 829 298 170 752 818 170 818 892 181 183 818 818 183 849 818 752 181 181 182 183 181 752 182 267 183 182 272 183 267 182 269 267 182 752 269 269 270 267 270 269 879 269 752 879 271 268 270 268 267 270 271 270 301 270 879 301 301 879 373 373 879 752 752 122 373 752 297 122 120 121 122 300 373 122 120 122 297 122 121 300 297 298 120 120 298 732 972 120 732 120 972 121 300 121 49 121 972 47 121 47 49 919 47 972 732 735 972 972 735 919 732 298 829 829 735 732 178 180 735 735 716 919 180 715 735 715 716 735 178 179 180 138 137 178 137 913 178 913 179 178 179 715 180 715 433 716 284 433 715 179 284 715 179 283 284 283 996 284 996 433 284 179 433 283 283 433 996 538 433 179 538 179 913 913 795 914 913 137 795 538 913 914 537 434 538 538 956 537 433 538 434 914 956 538 914 795 797 956 914 797 795 796 797 795 340 796 795 137 340 796 387 797 956 797 387 537 956 387 387 388 250 537 387 311 387 250 311 410 388 387 410 387 796 340 411 796 411 410 796 388 410 411 388 411 342 340 342 411 340 341 342 342 341 898 388 342 802 802 342 898 898 341 769 994 898 769 898 994 802 388 802 803 803 802 651 802 994 651 994 426 425 994 425 651 426 994 769 768 426 769 769 341 194 194 768 769 424 425 426 424 426 867 426 768 867 651 425 652 652 425 494 425 424 494 424 820 494 424 867 820 495 867 961 867 768 961 820 867 495 494 820 495 494 495 496 495 554 496 495 961 554 961 934 549 934 961 768 961 549 554 496 554 275 554 276 275 549 999 554 554 999 276 494 496 932 932 496 275 275 276 277 932 275 883 275 277 883 277 276 326 935 326 276 935 276 999 999 549 935 326 935 327 935 551 327 549 551 935 326 327 328 572 277 326 326 328 572 650 328 327 551 648 327 648 650 327 549 550 551 551 766 648 550 766 551 648 649 650 767 649 648 648 766 767 765 766 550 765 767 766 550 934 765 934 550 549 765 934 193 765 930 767 930 765 193 930 931 767 936 649 767 931 936 767 1001 931 930 1001 930 193 193 194 195 934 194 193 195 1001 193 768 194 934 194 341 195 341 492 195 492 1000 195 1000 1001 195 1000 776 1001 776 931 1001 775 776 1000 492 775 1000 340 775 492 492 341 340 775 504 776 775 137 504 340 137 775 504 927 776 931 776 927 503 504 358 504 503 927 504 137 358 136 137 138 136 358 137 358 359 360 358 136 742 358 360 503 359 358 742 138 116 136 116 117 136 136 117 742 254 138 413 362 413 138 138 254 116 116 28 117 116 254 29 116 29 28 117 28 720 117 720 955 742 117 955 27 28 29 28 114 720 28 27 114 113 114 115 114 595 115 114 27 595 720 114 113 113 115 414 113 414 724 724 888 113 113 888 720 595 414 115 737 595 364 595 642 414 595 737 642 364 595 27 414 642 643 414 643 724 724 980 888 643 988 724 724 988 980 84 887 980 84 980 377 980 887 888 377 980 988 988 565 377 643 565 988 376 84 377 376 377 565 564 565 566 565 212 566 643 212 565 565 564 376 376 320 322 564 320 376 880 84 376 322 880 376 320 564 321 321 564 817 564 566 817 566 629 817 629 566 212 629 624 817 817 624 321 320 321 322 624 53 321 869 321 53 321 869 322 880 322 357 357 322 869 868 869 870 868 357 869 53 870 869 868 976 355 976 868 870 868 355 357 53 55 870 242 870 55 242 976 870 976 838 355 976 242 838 355 356 357 838 452 355 355 452 356 452 838 154 242 619 838 155 838 619 838 155 154 241 242 55 619 242 241 241 243 619 54 835 241 835 404 241 241 404 243 241 55 54 53 54 55 118 54 119 119 54 53 118 835 54 612 835 118 612 404 835 118 119 997 118 997 986 612 118 986 119 53 624 119 624 630 997 119 630 174 997 959 997 630 959 986 997 174 612 986 173 173 986 174 172 173 174 174 289 247 172 174 247 289 174 959 288 111 289 111 247 289 288 289 959 111 246 247 247 246 172 110 111 112 111 288 112 246 111 110 959 808 288 112 288 846 808 846 288 307 112 569 107 110 112 307 107 112 569 112 846 109 246 110 107 109 110 107 108 109 306 107 307 786 108 107 107 306 786 92 306 307 569 92 307 809 569 846 569 809 92 809 846 808 808 783 809 809 813 824 809 824 92 783 813 809 783 18 813 813 20 824 18 20 813 75 824 20 824 75 92 18 19 20 74 75 20 482 74 20 20 19 473 20 473 482 74 739 75 739 92 75 482 596 74 596 739 74 482 473 475 948 596 482 948 482 475 473 474 475 474 473 30 695 475 474 948 475 695 948 695 596 596 695 336 336 695 219 695 474 220 219 695 220 474 30 922 220 474 922 922 30 544 544 30 33 220 922 146 146 922 544 219 220 146 145 336 219 145 219 146 336 1 596 145 1 336 145 146 147 147 1 145 147 146 544 33 147 544 3 1 4 1 516 764 525 516 1 764 93 1 1 856 4 525 1 841 596 1 93 841 1 3 596 93 739 92 93 94 94 93 764 93 92 739 516 94 764 94 516 291 94 291 92 415 92 291 306 92 415 293 306 415 291 293 415 293 435 306 786 306 435 291 292 293 292 435 293 374 375 292 5 374 292 435 292 375 5 292 291 5 640 374 374 438 375 438 374 640 437 435 375 438 437 375 436 437 438 346 438 508 727 436 438 727 438 346 508 438 640 436 227 226 727 330 436 436 226 437 436 330 227 346 330 727 346 347 60 346 60 330 346 508 347 508 640 641 508 641 347 746 747 641 641 640 746 861 347 641 747 906 641 906 861 641 746 843 747 843 906 747 843 905 906 907 861 906 906 905 907 907 905 908 908 702 907 713 861 907 713 907 714 907 702 714 908 954 702 905 671 908 908 671 954 702 703 704 702 704 714 954 703 702 982 954 671 982 703 954 598 671 672 672 671 905 598 982 671 598 80 599 675 598 599 80 598 672 675 982 598 672 72 80 905 72 672 991 72 905 843 991 905 71 72 73 73 72 964 72 71 80 964 72 991 964 991 843 238 842 843 842 964 843 238 843 746 73 964 82 964 842 82 79 71 73 73 82 81 79 73 81 79 80 71 79 599 80 599 79 738 81 738 79 901 675 599 599 738 901 901 738 400 901 982 675 982 901 400 703 982 399 399 982 400 399 43 703 703 43 704 399 400 210 399 210 441 399 441 43 41 42 43 441 41 43 704 43 14 14 43 42 714 704 14 12 13 14 42 12 14 13 714 14 666 713 714 13 666 714 665 666 13 52 773 13 12 52 13 13 773 665 368 52 12 12 42 368 50 51 52 51 335 52 368 50 52 335 773 52 899 666 773 773 666 665 773 335 899 899 335 91 741 666 899 741 899 90 899 91 90 90 91 46 91 335 527 46 91 527 223 501 90 741 90 501 46 223 90 713 741 501 713 666 741 713 501 861 501 502 15 501 942 502 501 15 861 223 942 501 861 15 347 15 16 17 502 939 15 939 16 15 347 15 17 939 502 942 939 942 513 223 943 942 943 513 942 513 16 939 513 331 16 513 248 331 943 248 513 249 943 223 249 248 943 45 222 223 222 249 223 45 223 46 248 249 224 224 249 222 45 224 222 44 45 46 45 248 224 44 248 45 526 46 527 526 44 46 335 44 526 44 712 248 44 385 712 385 44 335 526 527 335 335 384 385 51 839 335 335 839 384 712 385 710 385 384 987 710 385 987 710 711 712 710 987 744 710 744 711 811 810 987 384 811 987 987 810 744 744 265 711 744 144 265 744 810 821 744 821 144 810 811 812 812 821 810 811 993 812 811 628 993 384 628 811 993 627 812 993 628 627 626 627 628 836 837 628 626 628 837 384 836 628 836 384 839 951 837 836 836 839 951 951 839 583 839 51 353 583 839 353 837 951 583 837 305 304 583 950 837 626 837 304 950 305 837 25 950 583 305 950 25 24 25 26 26 25 583 24 305 25 26 789 24 789 305 24 790 789 26 790 26 582 582 26 583 165 789 790 789 165 430 789 430 305 163 165 790 790 804 163 804 790 582 581 582 583 582 581 721 804 582 721 379 378 581 581 805 721 581 378 805 379 581 583 379 583 616 353 616 583 353 615 616 150 379 616 616 615 150 353 50 354 353 51 50 615 353 354 354 50 368 706 615 354 706 354 368 368 42 369 706 368 826 826 368 369 705 615 706 826 705 706 826 832 705 705 832 148 615 705 148 408 832 826 543 408 395 4 395 408 408 826 806 408 806 4 856 718 4 4 806 3 850 856 953 718 856 850 850 953 477 806 78 3 605 841 3 78 605 3 841 605 523 523 525 841 523 524 525 523 918 971 990 918 523 605 990 523 523 971 524 525 524 516 291 516 517 516 524 517 8 291 9 291 8 6 5 291 6 291 517 9 517 524 693 693 9 517 8 9 10 10 9 693 8 11 6 8 10 11 5 6 7 6 11 7 746 640 5 746 5 239 5 7 239 240 239 7 67 7 11 67 240 7 11 890 67 10 890 11 65 66 67 67 66 970 890 65 67 67 970 240 238 239 240 240 970 238 239 238 746 238 970 842 970 66 83 83 842 970 842 83 82 81 82 83 900 81 83 236 83 66 236 900 83 236 237 81 237 738 81 900 236 81 237 236 66 875 738 237 875 237 66 886 738 884 738 610 884 886 400 738 610 738 875 884 885 886 885 400 886 884 209 885 210 884 610 210 209 884 885 208 400 885 209 208 400 208 210 208 209 210 847 441 210 623 847 210 610 623 210 187 847 188 698 847 623 188 847 698 187 441 847 187 41 441 187 188 189 42 187 369 42 41 187 369 187 189 825 826 189 826 369 189 189 188 825 826 825 806 825 188 806 188 944 806 806 944 78 188 697 944 944 607 992 944 992 78 697 607 944 76 77 78 992 76 78 78 77 605 607 76 992 606 607 608 76 607 606 607 697 608 418 76 606 606 416 418 606 608 416 697 416 608 416 417 418 416 696 417 697 696 416 417 609 418 623 417 696 623 609 417 696 697 698 698 623 696 610 609 623 151 609 610 609 151 418 610 875 962 151 610 962 874 875 655 962 875 874 653 655 875 653 875 66 962 874 655 151 962 655 653 654 655 655 654 151 65 653 66 654 653 398 398 653 65 654 398 918 654 723 152 918 723 654 151 654 152 918 398 971 918 990 723 722 723 670 723 722 152 990 670 723 151 152 153 152 722 153 418 151 153 153 722 670 673 153 670 673 418 153 605 604 670 670 604 673 990 605 670 673 604 76 418 673 76 77 604 605 76 604 77 971 398 524 65 397 398 524 398 693 397 10 398 398 10 693 397 65 890 397 890 10 188 698 697 148 149 150 615 148 150 989 150 149 149 69 989 130 150 989 995 833 150 833 379 150 130 995 150 130 989 69 130 131 132 132 380 130 130 380 995 131 130 69 833 995 380 833 380 379 378 379 380 132 533 380 533 378 380 132 429 533 131 427 132 427 429 132 533 534 535 534 533 429 533 535 805 533 805 378 427 428 429 429 428 534 761 762 427 427 762 428 761 427 131 428 603 534 985 603 428 428 762 985 985 762 622 622 762 761 985 622 973 985 973 603 48 622 49 622 590 317 973 622 317 761 49 622 48 590 622 319 587 973 319 973 317 587 603 973 317 318 319 402 317 591 318 317 402 317 590 591 590 542 591 48 542 590 699 402 591 591 893 699 542 893 591 401 318 402 402 699 845 401 402 845 318 401 319 575 401 573 891 401 845 573 401 891 319 401 575 573 574 575 575 574 586 319 575 586 574 573 876 876 573 891 891 845 161 897 876 891 161 897 891 574 876 877 897 799 876 877 876 894 876 799 894 338 574 877 338 586 574 338 877 339 877 894 339 894 799 895 894 895 371 894 371 678 339 894 678 337 338 339 339 677 337 339 678 677 586 338 601 338 337 601 512 511 337 324 337 677 512 337 324 601 337 511 676 677 678 677 676 325 324 677 325 323 324 325 512 324 594 324 323 594 325 676 323 938 323 676 938 676 678 105 594 323 323 106 105 938 106 323 512 594 105 104 105 106 409 105 104 512 105 409 370 104 106 370 106 938 938 678 370 370 678 371 370 371 372 104 370 351 351 370 372 372 371 957 351 372 957 371 782 585 895 952 371 371 952 782 371 585 957 957 958 657 957 585 958 351 957 657 584 446 585 584 585 782 585 446 958 799 584 782 952 799 782 895 799 952 447 799 800 799 460 462 500 799 897 799 462 800 799 447 584 460 799 500 446 584 447 445 446 447 958 446 445 445 532 531 445 447 915 445 915 532 958 445 531 134 531 532 531 657 958 134 657 531 133 134 135 352 134 133 135 134 865 865 134 532 352 657 134 351 657 352 350 351 352 350 352 133 350 133 983 133 135 983 135 865 780 780 983 135 865 532 866 865 866 781 781 780 865 779 780 781 793 780 794 793 983 780 779 794 780 350 983 793 793 848 350 793 345 848 793 343 345 794 343 793 779 580 794 580 343 794 580 779 685 781 685 779 578 579 580 578 580 600 685 600 580 579 343 580 343 344 345 579 547 343 547 344 343 344 848 345 344 409 104 450 449 344 344 200 199 344 199 848 344 104 200 409 344 294 449 294 344 547 450 344 200 104 201 201 104 351 199 200 201 199 201 848 848 201 350 201 351 350 449 450 451 450 547 548 156 450 917 451 450 156 917 450 548 548 547 579 518 548 56 548 579 56 917 548 518 452 154 917 58 917 518 452 917 58 154 156 917 518 56 519 518 519 58 56 57 58 58 57 731 519 56 58 731 452 58 56 578 57 56 579 578 731 57 830 749 831 57 578 749 57 57 831 830 555 452 731 555 731 830 555 830 831 831 726 815 831 725 726 555 831 815 725 831 749 555 556 452 555 814 556 555 815 814 175 556 658 556 175 452 975 658 556 814 975 556 452 175 356 175 176 177 356 175 177 175 658 176 176 658 656 975 656 658 514 975 814 558 656 975 514 558 975 86 656 123 656 85 176 85 656 86 558 123 656 177 176 880 880 176 85 84 85 86 880 85 84 357 947 880 947 177 880 356 177 357 357 177 947 887 84 86 887 728 888 887 86 728 728 729 720 729 728 431 86 431 728 728 720 888 729 390 955 720 729 955 621 390 729 621 729 431 86 63 431 621 431 63 86 123 63 61 62 63 63 389 621 63 123 61 389 63 62 389 390 621 389 386 390 62 785 389 785 386 389 360 359 386 770 360 386 359 390 386 770 386 785 62 771 785 785 771 770 660 770 771 770 503 360 660 503 770 771 570 709 771 62 570 709 660 771 650 660 709 570 650 709 659 503 660 649 659 660 650 649 660 927 503 659 936 927 659 649 936 659 936 931 927 650 570 328 572 328 570 570 571 572 571 277 572 570 644 571 571 881 277 644 61 571 571 61 969 571 969 881 277 881 883 881 882 883 279 881 969 881 279 929 882 881 929 61 754 969 279 969 754 61 753 754 753 280 754 279 754 280 753 514 419 280 753 540 61 558 753 558 514 753 540 753 419 278 279 280 540 278 280 540 419 925 540 925 576 577 278 540 576 577 540 278 577 279 279 577 974 279 974 929 933 928 974 974 928 929 974 577 933 928 882 929 634 928 632 932 928 634 632 928 933 882 928 932 882 932 883 634 494 932 632 633 634 633 494 634 632 730 633 912 632 933 912 730 632 633 281 652 633 652 494 730 281 633 707 708 730 708 282 730 281 730 282 912 707 730 567 912 933 567 707 912 707 204 708 204 707 567 203 708 204 439 708 203 439 282 708 281 282 251 439 440 282 251 282 440 439 203 635 439 635 440 202 203 204 635 203 636 203 202 636 635 636 637 252 635 637 252 440 635 251 440 252 250 251 252 872 281 251 251 250 872 872 250 862 872 862 281 949 803 250 388 949 250 803 862 250 252 311 250 803 651 862 281 862 652 862 651 652 949 388 803 311 252 312 312 537 311 432 537 312 312 645 432 541 645 312 312 252 541 432 434 537 432 433 434 454 432 645 432 878 433 432 454 878 645 541 455 455 454 645 453 454 455 878 454 852 852 454 453 716 878 852 878 716 433 851 852 453 919 852 851 716 852 919 48 453 455 453 48 851 455 541 542 542 48 455 47 48 49 851 48 47 851 47 919 49 299 300 761 299 49 552 299 816 300 299 552 816 299 761 300 552 553 553 373 300 816 855 552 855 553 552 855 816 274 131 274 816 816 761 131 553 855 274 553 274 373 69 274 131 373 274 69 272 266 69 266 373 69 272 267 273 273 266 272 266 267 268 273 267 266 266 268 373 373 268 271 271 301 373 541 893 542 541 252 864 541 864 893 864 252 893 252 699 893 162 252 637 827 252 162 252 827 845 252 845 699 160 161 162 160 162 637 827 162 161 636 160 637 460 500 160 160 500 161 636 460 160 845 827 161 161 500 897 460 461 462 636 461 460 636 202 461 461 663 662 461 998 462 461 202 663 662 998 461 979 800 462 998 979 462 998 662 979 661 662 663 979 662 871 662 310 871 310 662 661 871 915 979 979 915 447 447 800 979 871 310 98 539 915 871 871 98 539 532 915 539 100 539 98 100 99 539 866 539 442 532 539 866 539 99 442 98 99 100 442 99 443 99 725 443 99 98 725 442 443 444 685 442 444 781 442 685 866 442 781 443 749 444 443 725 749 725 98 726 310 726 98 815 726 383 383 726 310 308 309 310 310 309 383 308 310 661 382 383 309 382 815 383 515 814 815 420 515 815 420 815 382 382 664 420 309 308 382 308 664 382 661 664 308 663 664 661 421 664 694 664 663 694 420 664 421 419 420 421 515 420 419 514 515 419 514 814 515 925 419 421 694 921 421 921 925 421 924 576 925 925 921 924 332 924 921 694 941 921 941 332 921 334 576 924 334 924 332 576 334 577 332 333 334 568 577 334 334 333 568 772 926 332 772 332 941 926 333 332 694 772 941 694 204 772 772 204 926 926 204 333 333 567 568 333 204 567 937 568 567 937 577 568 937 933 577 937 567 933 694 202 204 694 663 202 749 600 444 749 578 600 685 444 600 558 61 123 62 61 644 62 909 570 644 909 62 570 909 644 390 359 742 742 955 390 154 155 156 451 156 155 155 618 451 618 155 619 449 451 294 294 451 828 618 828 451 295 618 619 828 618 295 245 619 243 295 619 245 294 295 296 295 245 296 828 295 294 405 409 294 405 294 296 296 403 405 244 296 245 296 244 403 243 244 245 243 404 403 243 403 244 403 404 405 405 404 409 409 404 612 611 612 613 611 409 612 613 612 173 261 409 611 262 611 613 261 611 262 639 613 173 639 262 613 422 173 423 172 423 173 639 173 422 422 638 639 638 262 639 261 262 263 263 262 638 984 409 261 984 261 263 233 920 263 263 834 233 920 984 263 638 834 263 920 409 984 920 589 409 589 512 409 946 589 920 946 920 233 946 233 235 946 235 589 588 510 589 589 592 588 589 510 512 592 589 235 510 511 512 602 511 510 588 602 510 592 535 588 602 588 534 534 588 535 592 234 535 234 592 235 233 234 235 617 234 233 234 804 535 617 804 234 535 804 805 163 804 617 805 804 721 163 164 165 163 617 759 164 163 759 164 314 165 314 164 315 315 164 674 674 164 759 165 314 430 313 314 315 509 314 313 509 430 314 313 315 784 674 945 315 784 315 945 758 945 674 758 674 759 916 945 758 916 784 945 285 784 916 562 313 784 784 285 562 561 313 562 509 313 561 561 562 563 563 562 285 285 286 287 916 286 285 788 285 287 788 563 285 916 758 286 286 873 823 758 873 286 286 823 287 788 287 394 287 823 394 822 394 823 822 823 873 422 873 758 172 873 423 822 873 172 423 873 422 822 172 246 109 822 246 822 109 394 109 108 801 801 394 109 108 394 801 108 393 394 700 701 108 87 89 108 701 87 108 786 700 108 89 393 108 89 788 393 393 788 394 87 88 89 88 788 89 787 788 129 787 563 788 129 788 88 87 129 88 127 128 129 127 129 87 819 129 128 129 819 787 561 563 787 561 787 819 614 303 819 303 509 819 911 819 128 614 819 911 819 509 561 302 303 304 302 430 303 303 430 509 614 304 303 304 305 302 305 430 302 614 854 304 854 812 304 304 812 626 614 142 854 812 854 142 812 142 821 626 812 627 142 143 144 614 143 142 821 142 144 144 264 265 264 144 967 143 967 144 265 264 141 139 264 967 264 139 141 265 141 711 774 711 141 774 712 711 712 774 965 141 966 774 965 774 966 712 965 248 248 965 557 965 966 557 966 559 557 141 560 966 966 560 559 559 560 140 559 140 391 557 559 391 141 140 560 139 140 141 140 139 96 391 140 95 140 96 95 391 392 205 391 95 392 205 557 391 95 96 97 392 95 960 960 95 97 96 139 968 97 96 968 968 139 967 968 967 143 97 968 798 968 143 978 978 798 968 97 798 412 960 97 412 412 807 960 807 392 960 253 412 128 798 128 412 412 253 807 798 978 128 911 128 978 143 911 978 143 614 911 127 253 128 253 127 87 253 87 807 87 701 807 392 807 349 701 349 807 700 349 701 348 206 349 392 349 206 700 348 349 392 206 205 205 206 207 348 700 206 206 700 207 786 207 700 205 207 940 435 207 786 435 940 207 205 940 557 940 763 557 437 940 435 940 437 763 248 557 448 557 763 448 226 763 437 448 763 719 226 719 763 248 448 331 331 448 329 329 448 719 329 719 226 225 226 227 329 226 225 329 330 331 225 330 329 330 16 331 225 227 330 16 330 60 59 16 60 17 16 59 59 60 347 347 17 59 638 422 760 422 758 760 638 760 757 638 757 834 760 758 757 757 758 759 834 757 617 617 757 759 233 834 617 603 602 534 601 602 603 586 603 587 586 601 603 602 601 511 319 586 587 19 18 64 18 667 669 18 507 667 783 507 18 101 18 669 18 101 64 101 103 64 103 493 64 101 102 103 102 101 669 103 213 221 102 213 103 221 493 103 213 102 215 669 215 102 230 215 669 213 215 230 229 214 230 214 213 230 669 229 230 229 625 228 229 669 625 214 229 228 213 214 197 197 214 198 198 214 228 198 228 166 228 625 166 166 167 168 166 840 167 166 168 198 840 166 625 168 167 157 840 158 167 167 158 157 168 157 863 198 168 981 981 168 863 157 158 159 27 157 159 863 157 27 158 625 159 840 625 158 159 625 364 364 27 159 27 29 863 863 29 692 981 863 692 692 679 981 981 679 198 691 679 692 29 691 692 29 254 691 254 258 691 521 679 691 258 521 691 257 258 256 257 521 258 256 258 254 687 257 256 687 521 257 520 521 522 185 679 521 185 521 520 522 521 687 255 522 687 687 256 255 254 255 256 185 520 255 520 522 255 255 186 185 255 254 186 184 185 186 185 184 679 857 679 184 186 857 184 679 857 198 857 858 198 858 857 536 536 857 186 196 197 198 196 198 858 858 536 196 213 197 196 213 196 536 756 904 536 213 536 221 756 536 186 904 221 536 755 756 743 743 756 186 903 904 756 903 756 755 904 493 221 904 903 977 904 977 493 903 755 977 755 743 910 755 910 977 493 977 910 493 910 497 493 497 499 910 743 497 413 497 498 498 497 743 497 413 362 413 498 254 254 498 889 889 498 743 889 186 254 889 743 186 363 125 364 125 737 364 625 363 364 737 643 642 125 643 737 643 125 212 125 211 212 211 629 212 750 211 751 211 750 629 505 211 125 211 505 751 624 629 630 629 750 630 959 630 750 783 750 751 750 783 808 750 808 959 507 783 751 751 505 507 505 506 507 667 507 506 506 668 667 506 126 668 506 124 126 506 505 124 667 668 669 363 669 668 126 363 668 124 125 126 126 125 363 505 125 124 625 669 363))
                   (list :vertices (let ((mat (make-matrix 1002 3))) (fvector-replace (array-entity mat) #f(-1.2468999862670898e+01 3.9723799228668213e+00 -6.4992804527282715e+00 -1.2259700775146484e+01 4.8232102394104004e+00 -9.5915098190307617e+00 -1.2469099998474121e+01 3.9723799228668213e+00 -7.7372398376464844e+00 -1.1248499870300293e+01 5.1348104476928711e+00 -6.3296699523925781e+00 -1.2259700775146484e+01 4.8232197761535645e+00 -1.8234599828720093e+00 4.5199198722839355e+00 9.9936399459838867e+00 -1.2656300544738770e+01 1.0525900125503540e+00 8.9252195358276367e+00 -1.2656300544738770e+01 1.6549700498580933e+00 9.1108398437500000e+00 -1.2403100013732910e+01 -4.0988898277282715e+00 7.3378596305847168e+00 -1.2656300544738770e+01 -7.1897602081298828e+00 6.3854498863220215e+00 -1.2656300544738770e+01 -6.1697001457214355e+00 6.6997704505920410e+00 -1.2403100013732910e+01 -1.7609100341796875e+00 8.0582799911499023e+00 -1.2403100013732910e+01 -1.0249300003051758e+00 8.2850599288940430e+00 1.2656300544738770e+01 4.5199198722839355e+00 9.9936399459838867e+00 1.2656300544738770e+01 1.6549700498580933e+00 9.1108398437500000e+00 1.2403100013732910e+01 6.4850397109985352e+00 7.0131702423095703e+00 -1.2792600393295288e+00 6.9717001914978027e+00 6.3005099296569824e+00 -6.4077000617980957e+00 6.5039496421813965e+00 6.9507203102111816e+00 -6.4160499572753906e+00 -1.3997900009155273e+01 3.1436100006103516e+00 -1.7327999114990234e+01 -1.4515100479125977e+01 4.0282702445983887e+00 -1.6200000762939453e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.4174999237060547e+01 -1.2484399795532227e+01 3.9099199771881104e+00 9.0204601287841797e+00 -1.2505499839782715e+01 3.8669600486755371e+00 8.9239597320556641e+00 -1.2484200477600098e+01 3.9098598957061768e+00 9.6969003677368164e+00 2.4653301239013672e+00 -1.7317001342773438e+01 1.3170300483703613e+01 6.9176201820373535e+00 -1.2376099586486816e+01 1.3162500381469727e+01 -2.2360601425170898e+00 -2.0811300277709961e+01 1.3162500381469727e+01 -2.4159500122070312e+01 6.2754898071289062e+00 -2.2972999572753906e+01 -3.2170398712158203e+01 8.2487401962280273e+00 -2.5059400558471680e+01 -3.1634099960327148e+01 8.1166400909423828e+00 -2.0248399734497070e+01 -1.2662399291992188e+01 3.7477099895477295e+00 -7.8319096565246582e+00 -1.2970499992370605e+01 3.6573300361633301e+00 -2.2901000976562500e+00 -1.2573500633239746e+01 3.8009400367736816e+00 -5.9408802986145020e+00 -1.2484200477600098e+01 3.9098501205444336e+00 -7.8881697654724121e+00 -1.2484200477600098e+01 3.9098598957061768e+00 -7.0624599456787109e+00 -1.2484399795532227e+01 3.9099199771881104e+00 2.0024199485778809e+00 -1.2484299659729004e+01 3.9098799228668213e+00 9.6985197067260742e-01 -1.2524399757385254e+01 3.8409099578857422e+00 1.8293800354003906e+00 -1.2605199813842773e+01 3.7882800102233887e+00 7.5229701995849609e+00 -1.2807399749755859e+01 3.7095000743865967e+00 5.9678897857666016e+00 -1.2767600059509277e+01 3.7213799953460693e+00 8.6283597946166992e+00 -3.7348401546478271e+00 9.6158704757690430e+00 1.2329899787902832e+01 -3.1280300617218018e+00 7.6370201110839844e+00 1.2403100013732910e+01 8.7329399585723877e-01 1.1364899635314941e+01 1.2318799972534180e+01 1.0703100204467773e+01 7.2038497924804688e+00 1.1134699821472168e+01 7.7888498306274414e+00 6.2445998191833496e+00 1.0708199501037598e+01 7.8256697654724121e+00 6.1219301223754883e+00 1.1171999931335449e+01 -2.1993900299072266e+01 4.3255300521850586e+00 2.4526199340820312e+01 -2.3448400497436523e+01 3.2784500122070312e+00 2.5642499923706055e+01 -2.0344799041748047e+01 2.5829300880432129e+00 2.3502201080322266e+01 -1.1917799711227417e+00 3.1527099609375000e+00 1.2656300544738770e+01 6.2891502380371094e+00 4.2209100723266602e+00 1.2782799720764160e+01 6.1553201675415039e+00 4.6863098144531250e+00 1.2656300544738770e+01 -2.2139501571655273e+01 -2.5863601684570312e+01 -2.0501499176025391e+01 -2.1425201416015625e+01 -2.7268400192260742e+01 -1.9481500625610352e+01 -2.5302400588989258e+01 -2.7277299880981445e+01 -2.1045299530029297e+01 -6.9466300964355469e+01 -3.3302398681640625e+01 -2.2395801544189453e+01 -7.2046302795410156e+01 -3.1377199172973633e+01 -2.3069599151611328e+01 -7.0832496643066406e+01 -3.1005399703979492e+01 -2.3329299926757812e+01 6.5056400299072266e+00 6.9451603889465332e+00 -7.9941797256469727e+00 6.5039496421813965e+00 6.9507203102111816e+00 -1.0265699386596680e+01 -8.3144500732421875e+01 5.1153302192687988e+00 -2.8096899032592773e+01 -7.5474998474121094e+01 1.5825899124145508e+01 -2.8096899032592773e+01 -6.2479598999023438e+01 1.2624799728393555e+01 -2.8096899032592773e+01 -1.4801699638366699e+01 4.1313600540161133e+00 -1.6200000762939453e+01 -3.7829699516296387e+00 1.0163400650024414e+01 -1.2222599983215332e+01 -2.6531100273132324e-01 1.2549300193786621e+01 -1.1706399917602539e+01 8.7329399585723877e-01 1.1364899635314941e+01 -1.2318799972534180e+01 -1.4801400184631348e+01 4.1321501731872559e+00 1.6200000762939453e+01 -1.3764300346374512e+01 3.1246500015258789e+00 1.7190198898315430e+01 -1.4514800071716309e+01 4.0290498733520508e+00 1.6200000762939453e+01 2.2106499671936035e+00 1.3960100173950195e+01 2.0790699124336243e-01 3.4323198795318604e+00 1.3626199722290039e+01 -1.5319299697875977e-01 2.2320101261138916e+00 1.3986299514770508e+01 -4.8962998390197754e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -1.2998600006103516e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -1.3617499351501465e+01 -1.1717700004577637e+01 9.3561401367187500e+00 4.2465898394584656e-01 -1.2008800506591797e+01 8.4160299301147461e+00 -3.8966000080108643e+00 -1.1928699493408203e+01 7.6515102386474609e+00 -4.8316694612263178e-13 1.3559999465942383e+00 1.3735700607299805e+01 7.6857200074706422e-13 2.2826800346374512e+00 1.3991299629211426e+01 4.2284898757934570e+00 1.3559999465942383e+00 1.3735700607299805e+01 -8.7694101333618164e+00 2.4698100090026855e+00 1.3937099456787109e+01 -8.7694101333618164e+00 1.8381600379943848e+00 1.3701499938964844e+01 -1.0737399101257324e+01 -3.2054100036621094e+01 -6.2682800292968750e+00 -2.7916500091552734e+01 -3.5307498931884766e+01 -6.9998002052307129e+00 -2.8040800094604492e+01 -3.4960601806640625e+01 -4.6865496635437012e+00 -2.8096899032592773e+01 1.6996000289916992e+01 3.3174800872802734e+00 -1.2577500343322754e+01 9.9698200225830078e+00 -1.2566100120544434e+01 -1.1364099502563477e+01 8.8271598815917969e+00 -1.1986900329589844e+01 -1.2798500061035156e+01 6.5754299163818359e+00 6.7187600135803223e+00 1.1521000862121582e+01 7.0703201293945312e+00 5.9839997291564941e+00 1.1557299613952637e+01 -6.3049201965332031e+00 2.9044599533081055e+00 -1.2972599983215332e+01 -1.2259400367736816e+01 4.8232898712158203e+00 -1.2660400390625000e+01 -9.9744796752929688e+00 4.5425395965576172e+00 -1.2656199455261230e+01 1.6979299545288086e+01 7.7118597030639648e+00 -1.0204299926757812e+01 1.7815399169921875e+01 6.8035297393798828e+00 -6.1348299980163574e+00 1.8233100891113281e+01 6.0392799377441406e+00 -9.8591594696044922e+00 -7.5310699462890625e+01 -2.9075099945068359e+01 2.2331199645996094e+01 -7.4115997314453125e+01 -3.0917200088500977e+01 6.3364000320434570e+00 -7.3991905212402344e+01 -3.1087200164794922e+01 2.0753999710083008e+01 -1.7933801651000977e+01 4.4097299575805664e+00 -1.9811000823974609e+01 -1.8381599426269531e+01 4.6153502464294434e+00 -1.9938400268554688e+01 -1.8535400390625000e+01 4.7442803382873535e+00 -1.9777198791503906e+01 -4.6186599731445312e+01 -3.2449398040771484e+01 1.9171899795532227e+01 -3.9010299682617188e+01 -3.1170000076293945e+01 1.2812999725341797e+01 -4.0568500518798828e+01 -3.1447801589965820e+01 1.9171899795532227e+01 -9.3643701076507568e-01 1.2331299781799316e+00 -1.3162500381469727e+01 7.4979400634765625e+00 -1.1315800666809082e+01 -1.3162500381469727e+01 -2.2360601425170898e+00 -2.0811300277709961e+01 -1.3162500381469727e+01 -2.7377400398254395e+00 -8.1501903533935547e+00 -1.3189200401306152e+01 -5.5910696983337402e+00 -9.8823995590209961e+00 -1.3536700248718262e+01 -5.0552597045898438e+00 7.3047602176666260e-01 -1.3541700363159180e+01 -3.0652400970458984e+01 6.3191099166870117e+00 -2.7726499557495117e+01 -2.8022499084472656e+01 7.0541601181030273e+00 -2.5820299148559570e+01 -2.5538499832153320e+01 5.7663202285766602e+00 -2.5932901382446289e+01 -3.6865699768066406e+01 9.4052896499633789e+00 -2.5059400558471680e+01 -3.6099399566650391e+01 9.0500707626342773e+00 -2.6140300750732422e+01 -1.6234600067138672e+01 -2.6851600646972656e+01 -1.6481698989868164e+01 -1.5578900337219238e+01 -2.5394300460815430e+01 -1.7527900695800781e+01 -2.1363500595092773e+01 5.5741901397705078e+00 2.1366701126098633e+01 -2.0411201477050781e+01 4.7090196609497070e+00 2.2788400650024414e+01 -2.0372501373291016e+01 5.0616903305053711e+00 2.1867599487304688e+01 -7.3012802124023438e+01 -1.1470699310302734e+01 -2.8096899032592773e+01 -1.9929201126098633e+01 2.5044901371002197e+00 -2.3149600982666016e+01 -2.0344799041748047e+01 2.5829300880432129e+00 -2.3502201080322266e+01 -1.9911499023437500e+01 2.6179800033569336e+00 -2.3137298583984375e+01 1.7851099014282227e+01 2.8868699073791504e+00 -1.1213200569152832e+01 1.7999500274658203e+01 2.8110098838806152e+00 -1.0229700088500977e+01 1.0173600196838379e+01 -1.2668499946594238e+01 -1.0229700088500977e+01 -1.1707900047302246e+01 1.0305900573730469e+00 1.6281200408935547e+01 -1.3814399719238281e+01 1.2366698980331421e+00 1.7900100708007812e+01 -1.2813099861145020e+01 -8.6443700790405273e+00 1.6657701492309570e+01 -6.7424400329589844e+01 -3.5585800170898438e+01 1.5192500114440918e+01 -6.9739402770996094e+01 -3.4844497680664062e+01 1.9329198837280273e+01 -6.9890800476074219e+01 -3.4740299224853516e+01 1.3068599700927734e+01 -3.8664299011230469e+01 9.7858896255493164e+00 -2.5666900634765625e+01 -3.8664299011230469e+01 9.7859201431274414e+00 6.0895299911499023e+00 -3.6865699768066406e+01 9.4051599502563477e+00 -2.5553998947143555e+00 1.7359399795532227e+01 7.3857803344726562e+00 -5.2850300073623657e-01 1.6201900482177734e+01 8.2512598037719727e+00 -6.4863600730895996e+00 1.5625000000000000e+01 8.4799699783325195e+00 3.5178201198577881e+00 1.8429599761962891e+01 4.6149396896362305e+00 1.0229800224304199e+01 1.8488298416137695e+01 4.2356801033020020e+00 5.2802896499633789e+00 1.8034099578857422e+01 6.5168299674987793e+00 9.8976402282714844e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -9.9036703109741211e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -9.4646701812744141e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -8.9752006530761719e+00 -1.2468999862670898e+01 3.9723799228668213e+00 1.3617499351501465e+01 -1.0752200126647949e+01 3.0702002048492432e+00 1.4689800262451172e+01 -8.5498199462890625e+00 2.0437798500061035e+00 1.4373999595642090e+01 -8.8484201431274414e+00 1.0371999740600586e+01 -1.0295099258422852e+01 -9.3663597106933594e+00 1.0286300659179688e+01 -1.0186400413513184e+01 -1.0261599540710449e+01 1.0155900001525879e+01 -8.7694101333618164e+00 -4.7212001800537109e+01 -3.0567699432373047e+01 -2.2045299530029297e+01 -3.7275600433349609e+01 -2.9620201110839844e+01 -2.1652898788452148e+01 -5.6820701599121094e+01 -3.2918598175048828e+01 -2.1759700775146484e+01 -2.1543800354003906e+01 5.6311798095703125e+00 -2.1169200897216797e+01 -2.1525400161743164e+01 5.6266598701477051e+00 -2.1153800964355469e+01 -2.1363500595092773e+01 5.5741901397705078e+00 -2.1366701126098633e+01 -5.7192401885986328e+01 -1.5727400779724121e+01 2.7392900466918945e+01 -3.6246501922607422e+01 -1.2408599853515625e+01 2.7300899505615234e+01 -4.7573600769042969e+01 -1.0629099845886230e+01 2.7922698974609375e+01 -1.1501399278640747e+00 -2.3098100662231445e+01 1.1806599617004395e+01 1.0235599279403687e+00 -2.2340299606323242e+01 1.1137999534606934e+01 1.8424400091171265e+00 -2.0947498321533203e+01 1.2331600189208984e+01 -2.0471099853515625e+01 5.3669600486755371e+00 -2.0250000000000000e+01 -2.1715600967407227e+01 5.6734995841979980e+00 -2.0814899444580078e+01 -2.2813199996948242e+01 5.9438600540161133e+00 -2.0250000000000000e+01 -2.1642099380493164e+01 5.6554098129272461e+00 2.0250000000000000e+01 -2.3167098999023438e+01 6.1690402030944824e+00 1.9695999145507812e+01 -2.4160200119018555e+01 6.2756600379943848e+00 2.0250000000000000e+01 -6.7396001815795898e+00 -2.4108900070190430e+01 -1.3244400024414062e+01 -6.8111300468444824e+00 -2.5263500213623047e+01 -1.1734999656677246e+01 -9.2166500091552734e+00 -2.4305500030517578e+01 -1.4093100547790527e+01 -5.3998703002929688e+01 -1.6689399719238281e+01 -2.7050100326538086e+01 -3.5852001190185547e+01 -1.0150699615478516e+01 -2.7704900741577148e+01 -3.6246501922607422e+01 -1.2408599853515625e+01 -2.7300899505615234e+01 -3.6865699768066406e+01 9.4052896499633789e+00 2.5059400558471680e+01 -3.3109001159667969e+01 8.3592500686645508e+00 2.5973201751708984e+01 -3.2170398712158203e+01 8.2487401962280273e+00 2.5059400558471680e+01 -2.0274599075317383e+01 6.1647500991821289e+00 1.9253698348999023e+01 -1.9463399887084961e+01 5.4603700637817383e+00 1.9454500198364258e+01 -1.9121200561523438e+01 5.1631298065185547e+00 1.8648300170898438e+01 -2.3977399826049805e+01 9.3802804946899414e+00 -1.9237499237060547e+01 -2.8271600723266602e+01 1.3109300613403320e+01 -1.9237499237060547e+01 -2.2188899993896484e+01 7.8271403312683105e+00 -1.6200000762939453e+01 -8.5282297134399414e+00 8.4679307937622070e+00 1.2318799972534180e+01 -1.1204199790954590e+01 8.3859004974365234e+00 1.1267899513244629e+01 -9.5885000228881836e+00 5.6457500457763672e+00 1.2016500473022461e+01 -3.1619102478027344e+01 9.1428298950195312e+00 1.9237499237060547e+01 -3.1634099960327148e+01 8.1166400909423828e+00 1.6200000762939453e+01 -3.1634099960327148e+01 8.1166400909423828e+00 1.9173799514770508e+01 -8.0539199829101562e+01 1.8201200485229492e+01 1.1521100044250488e+01 -8.1597496032714844e+01 1.7668201446533203e+01 2.0089199066162109e+01 -7.9247604370117188e+01 1.8652799606323242e+01 1.6982500076293945e+01 -1.9463399887084961e+01 5.4603700637817383e+00 -1.9454500198364258e+01 -1.9552999496459961e+01 5.2118301391601562e+00 -1.9774299621582031e+01 -2.0416799545288086e+01 5.5875201225280762e+00 -1.9607500076293945e+01 -6.3738002777099609e+01 -3.5578601837158203e+01 -6.5812498331069946e-01 -6.0402301788330078e+01 -3.4983898162841797e+01 -3.0985200405120850e+00 -6.3738002777099609e+01 -3.5578601837158203e+01 6.5812498331069946e-01 -8.1343498229980469e+01 -1.6503000259399414e+01 2.7062200546264648e+01 -8.1813697814941406e+01 -1.3203999519348145e+01 2.7711000442504883e+01 -8.2870994567871094e+01 -1.3630099296569824e+01 2.6311100006103516e+01 1.4399399757385254e+01 8.0869398117065430e+00 -1.1998900413513184e+01 1.4841400146484375e+01 6.6712498664855957e+00 -1.3026099205017090e+01 1.3564299583435059e+01 6.5236997604370117e+00 -1.2960899353027344e+01 -3.6743099689483643e+00 1.1660599708557129e+01 1.0305999755859375e+01 -4.2065200805664062e+00 1.1490400314331055e+01 1.0306200027465820e+01 -4.5494699478149414e+00 1.1222999572753906e+01 1.1082200050354004e+01 -1.5663599967956543e+01 -1.2680299758911133e+01 -1.8732999801635742e+01 -2.2333801269531250e+01 -1.5039600133895874e+00 -2.4641700744628906e+01 -1.8950401306152344e+01 5.0148200988769531e+00 -1.9704099655151367e+01 -1.9560499191284180e+01 5.1910400390625000e+00 -1.9819000244140625e+01 -1.8805200576782227e+01 4.8084197044372559e+00 -2.0003700256347656e+01 -1.4816500663757324e+01 4.1381201744079590e+00 5.9119100570678711e+00 -1.5987800598144531e+01 4.4253101348876953e+00 1.6200000762939453e+01 -1.4801400184631348e+01 4.1322402954101562e+00 1.1137500762939453e+01 -1.2476700782775879e+01 3.9411499500274658e+00 -1.0080999374389648e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -9.9088802337646484e+00 -1.8682600021362305e+01 4.8834199905395508e+00 -1.9414600372314453e+01 7.8056902885437012e+00 6.3070902824401855e+00 1.0229800224304199e+01 7.7733201980590820e+00 6.2963700294494629e+00 1.0229800224304199e+01 7.8375797271728516e+00 6.3176698684692383e+00 1.0229800224304199e+01 7.7733201980590820e+00 6.2963700294494629e+00 -1.0229800224304199e+01 7.8056902885437012e+00 6.3070902824401855e+00 -1.0229800224304199e+01 7.7888598442077637e+00 6.2445998191833496e+00 -1.0708199501037598e+01 -2.0253499984741211e+01 5.3109297752380371e+00 -2.0218898773193359e+01 -1.9684999465942383e+01 5.1407999992370605e+00 -2.0137001037597656e+01 -1.9590099334716797e+01 5.1089401245117188e+00 -2.0123201370239258e+01 -1.8959199905395508e+01 5.0460901260375977e+00 1.6953500747680664e+01 -1.8677999496459961e+01 4.9410200119018555e+00 1.8645801544189453e+01 -6.8465900421142578e+00 -2.5434799194335938e+01 1.0693900108337402e+01 -6.7984600067138672e+00 -2.5216499328613281e+01 1.1873999595642090e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 1.0730699539184570e+01 5.4230195283889771e-01 1.3339400291442871e+01 -1.0186499595642090e+01 6.6291794180870056e-02 1.3118900299072266e+01 -1.0295099258422852e+01 3.5693798065185547e+00 1.2067600250244141e+01 -1.1115400314331055e+01 3.3281998634338379e+00 9.6264200210571289e+00 -1.1927900314331055e+01 1.9329000711441040e+00 1.1760899543762207e+01 -1.2143399238586426e+01 -2.6596599578857422e+01 -2.8676700592041016e+01 -2.0053998947143555e+01 -3.0364299774169922e+01 -2.8519001007080078e+01 -2.1515800476074219e+01 -3.2134498596191406e+01 -2.9944099426269531e+01 -1.9171699523925781e+01 -3.2243801116943359e+01 -2.9963600158691406e+01 -1.9171899795532227e+01 -3.2244800567626953e+01 -2.9958099365234375e+01 -1.9357599258422852e+01 -4.5868897438049316e+00 -2.1889400482177734e+01 -1.3294899940490723e+01 -6.8786296844482422e+00 -2.2554998397827148e+01 -1.3689200401306152e+01 1.0780099868774414e+01 7.3840303421020508e+00 1.0229299545288086e+01 7.9849400520324707e+00 6.3666200637817383e+00 9.7502603530883789e+00 -7.5474998474121094e+01 1.5825899124145508e+01 2.8096899032592773e+01 -8.3144500732421875e+01 5.1153302192687988e+00 2.8096899032592773e+01 -3.4960601806640625e+01 -4.6865601539611816e+00 2.8096899032592773e+01 1.8121999740600586e+01 3.7267000675201416e+00 -1.1475500106811523e+01 -3.1634099960327148e+01 8.1166400909423828e+00 -1.6200000762939453e+01 -2.8271600723266602e+01 1.3109300613403320e+01 -1.6200000762939453e+01 -3.1582798004150391e+01 1.1628499984741211e+01 -1.6200000762939453e+01 -3.1426000595092773e+01 1.2474399566650391e+01 -1.7586500167846680e+01 -3.1582798004150391e+01 1.1628499984741211e+01 -1.9237499237060547e+01 -1.4514900207519531e+01 4.0289001464843750e+00 1.0148599624633789e+01 -1.4514900207519531e+01 4.0289201736450195e+00 1.0824300765991211e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -1.1930599212646484e+00 -6.2811598777770996e+00 -2.5323999404907227e+01 -8.8308601379394531e+00 -5.1029601097106934e+00 -2.5061498641967773e+01 9.2014297842979431e-02 1.7082599639892578e+01 7.6317801475524902e+00 5.2086601257324219e+00 1.6372600555419922e+01 8.1343603134155273e+00 1.0082700729370117e+01 -1.8381599426269531e+01 4.6153502464294434e+00 1.9938400268554688e+01 -1.8950401306152344e+01 5.0148200988769531e+00 1.9704099655151367e+01 -1.8805200576782227e+01 4.8084197044372559e+00 2.0003700256347656e+01 -1.9552999496459961e+01 5.2118301391601562e+00 1.9774299621582031e+01 -1.9560499191284180e+01 5.1910400390625000e+00 1.9819000244140625e+01 -1.9590099334716797e+01 5.1089401245117188e+00 2.0123201370239258e+01 -1.8682600021362305e+01 4.8834199905395508e+00 1.9414600372314453e+01 -1.8535400390625000e+01 4.7442803382873535e+00 1.9777198791503906e+01 -1.5709898948669434e+01 2.6496000289916992e+00 1.9353401184082031e+01 -8.5771003723144531e+01 1.1238199234008789e+01 -8.6786994934082031e+00 -8.5504898071289062e+01 1.2630400657653809e+01 -1.7258298873901367e+01 -8.5808395385742188e+01 1.0856200218200684e+01 -2.5666900634765625e+01 -8.4953704833984375e+01 -5.5282402038574219e+00 -2.6353700637817383e+01 -8.5409095764160156e+01 -2.5775000452995300e-01 -2.6810899734497070e+01 -8.3794303894042969e+01 -8.1370296478271484e+00 -2.7293899536132812e+01 -8.4496902465820312e+01 5.4552202224731445e+00 2.7859399795532227e+01 -8.3920501708984375e+01 -1.1767899990081787e+00 2.7920200347900391e+01 -3.2235397338867188e+01 8.0054492950439453e+00 2.6211301803588867e+01 -3.2233303070068359e+01 8.0535802841186523e+00 2.5843000411987305e+01 5.9477596282958984e+00 -1.8598400115966797e+01 -1.0229899406433105e+01 1.7649099826812744e+00 -2.1988698959350586e+01 -1.0890100479125977e+01 4.4711198806762695e+00 -1.9349500656127930e+01 -1.1871500015258789e+01 -8.2649297714233398e+00 -1.0456899642944336e+01 -1.4296099662780762e+01 -7.5794796943664551e+00 -2.2704200744628906e+01 -1.3865099906921387e+01 -1.2534000396728516e+01 3.8350398540496826e+00 4.3579798936843872e-01 -5.1284399032592773e+00 3.3915398120880127e+00 -1.2656300544738770e+01 6.1553602218627930e+00 4.6861801147460938e+00 -1.2656300544738770e+01 -1.1917500495910645e+00 3.1527099609375000e+00 -1.2656300544738770e+01 -4.9385200500488281e+01 -3.3019901275634766e+01 -1.9171899795532227e+01 -3.8531600952148438e+01 -3.1011400222778320e+01 -1.9901300430297852e+01 -3.5196399688720703e+01 -3.0490100860595703e+01 -1.9171899795532227e+01 -2.1136699676513672e+01 5.5309100151062012e+00 2.0822700500488281e+01 -2.1525400161743164e+01 5.6266598701477051e+00 2.1153800964355469e+01 -1.9929201126098633e+01 2.5044901371002197e+00 2.3149600982666016e+01 -1.9911499023437500e+01 2.6179800033569336e+00 2.3137298583984375e+01 -1.9684999465942383e+01 5.1407999992370605e+00 2.0137001037597656e+01 9.3636302947998047e+00 -1.2259200096130371e+01 1.2307199478149414e+01 9.9552602767944336e+00 -1.2558500289916992e+01 1.1385199546813965e+01 1.7250400543212891e+01 3.1916201114654541e+00 1.2400099754333496e+01 8.3363199234008789e+00 -1.1740099906921387e+01 1.3043000221252441e+01 -1.1279500722885132e+00 2.6728100776672363e+00 -1.2782799720764160e+01 -3.0875298976898193e+00 2.3608798980712891e+00 -1.2931300163269043e+01 -7.9667396545410156e+01 -2.1551099777221680e+01 7.7849397659301758e+00 -7.9124397277832031e+01 -2.2711299896240234e+01 -6.7944297790527344e+00 -7.8378700256347656e+01 -2.4122501373291016e+01 2.4199899673461914e+01 -5.1685897827148438e+01 9.9661397933959961e+00 2.8096899032592773e+01 -4.1871303558349609e+01 7.5485901832580566e+00 2.8096899032592773e+01 5.7027497291564941e+00 -1.8850900650024414e+01 1.0230400085449219e+01 4.9494004249572754e+00 -1.9332698822021484e+01 1.1386799812316895e+01 3.4745199680328369e+00 -2.0812099456787109e+01 1.0230200767517090e+01 -1.4514900207519531e+01 4.0288801193237305e+00 9.4729499816894531e+00 -2.5882299423217773e+01 -6.5729398727416992e+00 2.5915699005126953e+01 -2.7801700592041016e+01 -8.5838298797607422e+00 2.6338800430297852e+01 -2.4039199829101562e+01 -1.7257900238037109e+01 2.2966598510742188e+01 -2.7801700592041016e+01 -8.5838403701782227e+00 -2.6338800430297852e+01 -2.4689399719238281e+01 -1.7569900512695312e+01 -2.3172599792480469e+01 -2.9835699081420898e+01 -1.0471699714660645e+01 -2.6646598815917969e+01 -3.2243801116943359e+01 -2.9963600158691406e+01 1.9171899795532227e+01 -3.2134498596191406e+01 -2.9944099426269531e+01 1.9171699523925781e+01 -3.2244800567626953e+01 -2.9958099365234375e+01 1.9357599258422852e+01 -8.5030395507812500e+01 1.3849199295043945e+01 -2.5683200836181641e+01 -8.3256996154785156e+01 1.6324600219726562e+01 -2.5701200485229492e+01 -8.3782005310058594e+01 1.5325400352478027e+01 -2.6581800460815430e+01 7.7733201980590820e+00 6.2963800430297852e+00 -9.5904197692871094e+00 7.0217099189758301e+00 6.2707200050354004e+00 -1.0502500534057617e+01 7.7806801795959473e+00 6.2986197471618652e+00 -6.6971802711486816e+00 -8.3059402465820312e+01 -1.3686499595642090e+01 1.0157999992370605e+01 -8.3825904846191406e+01 -1.1212299346923828e+01 2.5673000335693359e+01 -8.3771400451660156e+01 -1.1408599853515625e+01 -4.6389899253845215e+00 7.3231196403503418e+00 4.9986801147460938e+00 1.2475100517272949e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -1.0522600173950195e+01 -2.7505100250244141e+01 -2.8871700286865234e+01 2.0221300125122070e+01 -2.7945199966430664e+01 -2.7703599929809570e+01 2.1552700042724609e+01 -3.2466899871826172e+01 -2.8711000442504883e+01 2.1660499572753906e+01 -7.4771903991699219e+01 1.8679899215698242e+01 2.5666900634765625e+01 -7.8437995910644531e+01 1.8913499832153320e+01 2.5915500640869141e+01 -7.7258293151855469e+01 1.8657999038696289e+01 2.6711400985717773e+01 -6.6294601440429688e+01 -3.5746601104736328e+01 -1.9609399795532227e+01 -6.3738002777099609e+01 -3.5578601837158203e+01 -1.9171899795532227e+01 -6.5297294616699219e+01 -3.5755100250244141e+01 -1.2447099685668945e+01 6.5754299163818359e+00 6.7187600135803223e+00 -1.1521000862121582e+01 5.9373202323913574e+00 8.7896099090576172e+00 -6.6695103645324707e+00 1.4505400657653809e+01 5.6119298934936523e+00 -1.3162500381469727e+01 1.5431400299072266e+01 4.6149396896362305e+00 -1.3162500381469727e+01 -6.5213394165039062e+01 -3.5754699707031250e+01 5.3641695976257324e+00 -6.3738002777099609e+01 -3.5578601837158203e+01 1.9171899795532227e+01 -6.5423103332519531e+01 -3.5773197174072266e+01 1.8596099853515625e+01 -1.1279500722885132e+00 2.6728100776672363e+00 1.2782799720764160e+01 -2.9760499000549316e+00 3.0944697856903076e+00 1.2656300544738770e+01 -3.5070602416992188e+01 -2.1786800384521484e+01 -2.4295400619506836e+01 -3.7007598876953125e+01 -1.6523199081420898e+01 -2.6201299667358398e+01 -3.3571800231933594e+01 -1.3752599716186523e+01 -2.6741498947143555e+01 -5.5210800170898438e+01 1.3861700057983398e+01 -2.5675899505615234e+01 -5.8108501434326172e+01 1.4226099967956543e+01 -2.6618700027465820e+01 -6.5610900878906250e+01 1.6215900421142578e+01 -2.6334899902343750e+01 -2.4160200119018555e+01 6.2756600379943848e+00 1.6200000762939453e+01 -2.4160200119018555e+01 6.2756600379943848e+00 4.8937501907348633e+00 -2.0114799499511719e+01 4.5602002143859863e+00 -2.2325199127197266e+01 -2.0671400070190430e+01 5.1170496940612793e+00 -2.2351400375366211e+01 -3.1582798004150391e+01 1.1628499984741211e+01 1.6200000762939453e+01 -3.0750799179077148e+01 1.3395999908447266e+01 1.6200401306152344e+01 -2.8271600723266602e+01 1.3109300613403320e+01 1.6200000762939453e+01 -4.3063602447509766e+00 7.2739300727844238e+00 1.2656300544738770e+01 -7.9056901931762695e+00 6.1648397445678711e+00 1.2403100013732910e+01 -4.5345703125000000e+01 -3.2152801513671875e+01 2.0257198333740234e+01 -5.8073497772216797e+01 -3.3361198425292969e+01 2.1627399444580078e+01 -5.3898498535156250e+01 -3.3666698455810547e+01 2.0286298751831055e+01 -1.8998699188232422e+01 4.6136698722839355e+00 2.0957500457763672e+01 6.5172100067138672e+00 5.2400598526000977e+00 -1.2515299797058105e+01 7.2640500068664551e+00 5.3626699447631836e+00 -1.2187999725341797e+01 -2.8788700103759766e+01 -8.0465402603149414e+00 -2.6805700302124023e+01 -2.9295900344848633e+01 -2.6298601627349854e+00 -2.7616500854492188e+01 -7.4663600921630859e+00 -9.6977396011352539e+00 1.4044400215148926e+01 -6.7237200736999512e+00 8.6511200666427612e-01 1.3970100402832031e+01 -9.9872703552246094e+00 -1.0614800453186035e+01 1.4986700057983398e+01 -3.1582798004150391e+01 1.1628499984741211e+01 1.9237499237060547e+01 -7.9663406372070312e+01 -2.1549299240112305e+01 -2.5176801681518555e+01 -7.8378700256347656e+01 -2.4122501373291016e+01 -2.4199899673461914e+01 1.3725899696350098e+01 6.1690597534179688e+00 1.3083499908447266e+01 1.3075299263000488e+01 7.6040601730346680e+00 1.2196599960327148e+01 -6.7755897521972656e+01 1.5935299873352051e+01 -2.7407100677490234e+01 -6.0522998809814453e+01 1.3709699630737305e+01 2.7725700378417969e+01 -7.5249801635742188e+01 1.6741300582885742e+01 2.7983098983764648e+01 -6.6762901306152344e+01 1.4503699302673340e+01 -2.8012199401855469e+01 -5.4187301635742188e+01 1.2421299934387207e+01 -2.7538700103759766e+01 1.4696800231933594e+01 8.6779699325561523e+00 -1.0343199729919434e+01 1.6443500518798828e+01 7.5257997512817383e+00 -1.2014800071716309e+01 7.5706100463867188e+00 -1.3780200004577637e+01 -1.2959400177001953e+01 3.1823399066925049e+00 -1.8640600204467773e+01 -1.3034200668334961e+01 -1.2421900749206543e+01 4.1541399955749512e+00 4.5282101631164551e+00 -1.2468999862670898e+01 3.9723701477050781e+00 1.8569400310516357e+00 -6.1132202148437500e+00 8.9653596878051758e+00 -1.2327199935913086e+01 -8.5282297134399414e+00 8.4679307937622070e+00 -1.2318799972534180e+01 2.3100900650024414e-01 1.2773900032043457e+01 1.1537400245666504e+01 6.6291794180870056e-02 1.3118900299072266e+01 1.0295099258422852e+01 -3.1013799667358398e+01 -1.1508500099182129e+01 2.6688199996948242e+01 -2.8788700103759766e+01 -8.0465402603149414e+00 2.6805700302124023e+01 -3.3203502655029297e+01 -3.0134700775146484e+01 -1.7758001327514648e+01 -2.4825799942016602e+01 -2.8641099929809570e+01 -1.8163799285888672e+01 -4.1487602233886719e+01 -3.1611598968505859e+01 -1.4307600021362305e+01 -1.2468999862670898e+01 3.9723799228668213e+00 8.9752006530761719e+00 -1.2468999862670898e+01 3.9723799228668213e+00 9.9036703109741211e+00 -1.2259700775146484e+01 4.8232102394104004e+00 9.3602504730224609e+00 -3.1784002304077148e+01 -2.9881599426269531e+01 -1.4811899662017822e+00 -7.1686904907226562e+01 1.6983200073242188e+01 2.7335699081420898e+01 -7.4860198974609375e+01 1.8286399841308594e+01 2.6814899444580078e+01 1.8429599761962891e+01 4.6149396896362305e+00 -1.0229800224304199e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -5.2312502861022949e+00 -2.5633199691772461e+01 4.6088900566101074e+00 -2.6641799926757812e+01 -2.9760499000549316e+00 3.0944697856903076e+00 -1.2656300544738770e+01 -1.0261599540710449e+01 1.0155900001525879e+01 8.7694101333618164e+00 -9.3663597106933594e+00 1.0286300659179688e+01 1.0186400413513184e+01 -1.0261599540710449e+01 1.0155900001525879e+01 3.2075098057183365e-14 -8.1791900634765625e+01 -1.5954900741577148e+01 -2.6767200469970703e+01 -8.0238800048828125e+01 -2.0285900115966797e+01 -2.5552999496459961e+01 -8.1184898376464844e+01 -1.8335500717163086e+01 -2.5733100891113281e+01 -3.6160202026367188e+00 -2.4537000656127930e+01 -1.1019499778747559e+01 -2.9645600318908691e+00 -2.3958898544311523e+01 -1.1670299530029297e+01 -8.5344795227050781e+01 1.3159299850463867e+01 2.5675498962402344e+01 -8.4780502319335938e+01 1.3482700347900391e+01 2.6805799484252930e+01 -8.3488502502441406e+01 1.6101799011230469e+01 2.5653900146484375e+01 -1.4594299316406250e+01 -1.1992500305175781e+01 1.7900100708007812e+01 -1.5563899993896484e+01 -1.8719600677490234e+01 1.8207599639892578e+01 -1.3649499893188477e+01 -2.0166198730468750e+01 1.6796400070190430e+01 7.1067600250244141e+00 -1.5662099838256836e+01 1.2590600013732910e+01 -5.2022899627685547e+01 1.0049200057983398e+01 -2.8097499847412109e+01 -3.2659900665283203e+01 6.2573800086975098e+00 2.7959701538085938e+01 -3.2310401916503906e+01 7.7156100273132324e+00 2.6880100250244141e+01 -3.7114601135253906e+01 8.2541399002075195e+00 2.7487701416015625e+01 6.2891502380371094e+00 4.2209100723266602e+00 -1.2782799720764160e+01 7.8256697654724121e+00 6.1219201087951660e+00 -1.1171999931335449e+01 7.8357701301574707e+00 6.0883202552795410e+00 -1.1264100074768066e+01 6.5892200469970703e+00 6.6740202903747559e+00 -1.1643799781799316e+01 -8.2213798522949219e+01 -9.0626697540283203e+00 2.8002300262451172e+01 -8.2400001525878906e+01 -4.0667500495910645e+00 2.8096899032592773e+01 -3.7193300724029541e+00 1.0557499885559082e+01 1.2111100196838379e+01 -7.3138801574707031e+01 -3.2191802978515625e+01 -1.9520699977874756e+00 -7.3991905212402344e+01 -3.1087200164794922e+01 -2.0753999710083008e+01 -7.3362998962402344e+01 -3.1903699874877930e+01 -2.0454200744628906e+01 -7.0345703125000000e+01 -3.3393600463867188e+01 2.2247501373291016e+01 -6.5009803771972656e+01 -3.4581100463867188e+01 2.1574399948120117e+01 -7.0832199096679688e+01 -3.1005699157714844e+01 2.3329200744628906e+01 9.4824304580688477e+00 6.8887901306152344e+00 -1.0229599952697754e+01 -5.8311397552490234e+01 -3.4510696411132812e+01 -2.0043899536132812e+01 -5.9798099517822266e+01 -3.4223999023437500e+01 -2.1105899810791016e+01 -5.0657699584960938e+01 -3.2827701568603516e+01 -2.0781299591064453e+01 -5.7458099365234375e+01 -2.0169298171997070e+01 -2.6201400756835938e+01 -2.6081600189208984e+01 4.7166800498962402e+00 2.6796600341796875e+01 -2.9988599777221680e+01 5.7139000892639160e+00 2.7801799774169922e+01 -2.9492401123046875e+01 4.9492101669311523e+00 2.7866498947143555e+01 -2.0742601394653320e+01 5.4436001777648926e+00 1.6200000762939453e+01 -2.4548599243164062e+01 7.9655795097351074e+00 1.6200000762939453e+01 -1.4520799636840820e+01 4.0115003585815430e+00 -3.2433801889419556e-01 -1.5133599281311035e+01 4.2432403564453125e+00 -3.3784000873565674e+00 -7.7186103820800781e+01 -2.0684000015258789e+01 2.7094200134277344e+01 -7.8433197021484375e+01 -2.0577098846435547e+01 2.7034099578857422e+01 -7.5841705322265625e+01 -2.3446901321411133e+01 2.6201299667358398e+01 -1.3005199432373047e+01 3.6734499931335449e+00 4.7825298309326172e+00 -1.3184000015258789e+01 3.6677999496459961e+00 1.0433699607849121e+01 -1.2911699295043945e+01 3.6889998912811279e+00 8.6283597946166992e+00 -1.2516999244689941e+01 3.8552200794219971e+00 6.6013298034667969e+00 -1.2536999702453613e+01 3.8368198871612549e+00 7.7837600708007812e+00 -1.2509699821472168e+01 3.8612699508666992e+00 5.5878200531005859e+00 -1.2515500068664551e+01 3.8569900989532471e+00 4.7432298660278320e+00 -1.2617600440979004e+01 3.7806799411773682e+00 3.9830901622772217e+00 -1.2494400024414062e+01 3.8837699890136719e+00 7.4459300041198730e+00 -1.2515299797058105e+01 3.8555400371551514e+00 3.1807298660278320e+00 -1.2770099639892578e+01 3.6780300140380859e+00 -1.3781299591064453e+01 -1.2551699638366699e+01 3.8121600151062012e+00 -1.0509500503540039e+01 -1.2494299888610840e+01 3.8842501640319824e+00 -1.1810799598693848e+01 -1.2484299659729004e+01 3.9098701477050781e+00 -4.3427801132202148e+00 -1.2484200477600098e+01 3.9098501205444336e+00 -5.2011504173278809e+00 -1.2487799644470215e+01 3.8981499671936035e+00 5.0306601524353027e+00 -1.2484399795532227e+01 3.9099199771881104e+00 5.9310398101806641e+00 -1.2484200477600098e+01 3.9098501205444336e+00 6.6529803276062012e+00 -1.2484399795532227e+01 3.9099199771881104e+00 2.7161998748779297e+00 -1.2484299659729004e+01 3.9098799228668213e+00 -1.2311100006103516e+01 -1.2484399795532227e+01 3.9099199771881104e+00 3.8659100532531738e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -6.4431800842285156e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -3.2775499820709229e+00 -1.2553400039672852e+01 3.8170099258422852e+00 -2.6337800025939941e+00 -1.3502200126647949e+01 3.6915798187255859e+00 -5.7843003273010254e+00 -1.2484200477600098e+01 3.9098501205444336e+00 1.1838899612426758e+01 -1.2502299308776855e+01 3.8715100288391113e+00 1.1204400062561035e+01 -1.2566300392150879e+01 3.8090999126434326e+00 1.2344599723815918e+01 -1.2623800277709961e+01 3.7661299705505371e+00 1.1394400596618652e+01 -7.6548400878906250e+01 1.8981800079345703e+01 2.0772098541259766e+01 -1.5987800598144531e+01 4.4253101348876953e+00 -1.6200000762939453e+01 -8.5808395385742188e+01 1.0856200218200684e+01 2.5666900634765625e+01 -8.5545196533203125e+01 1.2445300102233887e+01 1.1223400115966797e+01 -8.5798896789550781e+01 1.0950900077819824e+01 5.1937799453735352e+00 -1.8212100982666016e+01 4.8294701576232910e+00 -3.5889799594879150e+00 -2.4160200119018555e+01 6.2756600379943848e+00 -1.3753100395202637e+01 -1.5917999267578125e+01 4.4139900207519531e+00 2.8708499670028687e-01 -5.4176799774169922e+01 -1.8406198501586914e+01 2.6585201263427734e+01 6.5039496421813965e+00 6.9507203102111816e+00 1.0265699386596680e+01 6.6861600875854492e+00 6.6043400764465332e+00 5.2144203186035156e+00 -7.4772003173828125e+01 1.8680000305175781e+01 -2.5666900634765625e+01 -7.4772003173828125e+01 1.8679899215698242e+01 -1.1820299148559570e+01 -1.7977699279785156e+01 -2.7983801364898682e+00 -2.1229398727416992e+01 -1.8674098968505859e+01 2.1953301429748535e+00 -2.2069599151611328e+01 -1.3814399719238281e+01 1.2366698980331421e+00 -1.7900100708007812e+01 6.3108000755310059e+00 7.5775399208068848e+00 -1.1643799781799316e+01 8.6524295806884766e+00 -1.5191599845886230e+01 1.0941699981689453e+01 -1.6323900222778320e+01 -2.6955699920654297e+01 1.6242500305175781e+01 -2.0590400695800781e+01 -2.7657899856567383e+01 1.8403299331665039e+01 -2.3231201171875000e+01 -2.8357799530029297e+01 1.7734498977661133e+01 7.7492098808288574e+00 6.2869400978088379e+00 4.6565900556743145e-03 -8.0036903381347656e+01 -1.6166000366210938e+01 -2.7858100891113281e+01 -7.9609603881835938e+01 -1.9263700485229492e+01 -2.7067701339721680e+01 -1.0022800445556641e+01 5.5124697685241699e+00 -1.2656300544738770e+01 -7.8006200790405273e+00 6.1972203254699707e+00 -1.2656300544738770e+01 -6.4110900878906250e+01 -3.3581001281738281e+01 -2.2046899795532227e+01 -6.8545196533203125e+01 -3.2818500518798828e+01 -2.2579700469970703e+01 -2.8804500579833984e+01 1.3430199623107910e+01 -1.9237600326538086e+01 -3.0280599594116211e+01 1.3544600486755371e+01 -1.9237001419067383e+01 -2.9175899505615234e+01 1.3620599746704102e+01 -1.6201000213623047e+01 -1.1577199935913086e+01 7.8938903808593750e+00 -1.0571000099182129e+01 -9.4056100845336914e+00 5.7048501968383789e+00 -1.2144999504089355e+01 -1.0799900054931641e+01 5.2730302810668945e+00 -1.0634300231933594e+01 9.3039999008178711e+00 6.4376001358032227e+00 1.1582799911499023e+01 7.8357701301574707e+00 6.0883202552795410e+00 1.1264100074768066e+01 -2.8271600723266602e+01 1.3109300613403320e+01 1.9237499237060547e+01 -2.9465299606323242e+01 1.3595799446105957e+01 1.9237499237060547e+01 -3.0399499893188477e+01 1.3425000190734863e+01 1.9237499237060547e+01 -7.0144195556640625e+01 -3.4517097473144531e+01 2.0652599334716797e+01 -7.2173400878906250e+01 -3.3203399658203125e+01 2.0240598678588867e+01 -1.0893500328063965e+01 -2.3506999969482422e+01 1.5018699645996094e+01 -1.3107599258422852e+01 -2.3883600234985352e+01 1.6286199569702148e+01 -9.3633508682250977e+00 -2.4608098983764648e+01 1.3956800460815430e+01 -1.9121200561523438e+01 5.1631298065185547e+00 -1.8648300170898438e+01 -4.4742698669433594e+01 9.5224294662475586e+00 2.7852001190185547e+01 -3.8778800964355469e+01 9.3354997634887695e+00 2.6824199676513672e+01 -7.3362998962402344e+01 -3.1903699874877930e+01 2.0454200744628906e+01 -8.2735099792480469e+01 -1.3578999519348145e+01 -2.6668500900268555e+01 -3.2975799560546875e+01 3.8400099277496338e+00 2.8096899032592773e+01 -2.8934200286865234e+01 3.4957900047302246e+00 2.7763200759887695e+01 -1.2468999862670898e+01 3.9723598957061768e+00 5.8803100585937500e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -9.0204601287841797e+00 -1.2484399795532227e+01 3.9099199771881104e+00 3.2910499572753906e+00 -1.2468999862670898e+01 3.9723799228668213e+00 3.0948998928070068e+00 -6.3811504364013672e+01 -3.5166500091552734e+01 -2.0719499588012695e+01 -6.3929901123046875e+01 -3.4440399169921875e+01 -2.1585100173950195e+01 -8.4447395324707031e+01 1.4850500106811523e+01 -1.3938599824905396e+00 -8.3164802551269531e+01 1.6422599792480469e+01 -3.3809599876403809e+00 -8.3263206481933594e+01 1.6331899642944336e+01 -1.2152299880981445e+01 -1.8656398773193359e+01 2.3088200092315674e+00 2.2057399749755859e+01 -1.8647300720214844e+01 3.4699399471282959e+00 2.1727500915527344e+01 -8.5497795104980469e+01 1.2562899589538574e+01 -2.8260599821805954e-02 -7.5841705322265625e+01 -2.3446901321411133e+01 -2.6201299667358398e+01 -7.6856498718261719e+01 -2.1396400451660156e+01 -2.6889600753784180e+01 1.2776300430297852e+01 8.2544794082641602e+00 -1.0229800224304199e+01 -8.0267700195312500e+01 -1.2764199256896973e+01 -2.8096899032592773e+01 1.3941699981689453e+01 8.6312093734741211e+00 -7.5555901527404785e+00 1.4910300254821777e+01 8.6305704116821289e+00 -3.7874600887298584e+00 8.0147495269775391e+00 -1.6214498519897461e+01 1.0230600357055664e+01 6.6464800834655762e+00 -1.7869501113891602e+01 -1.2357000112533569e+00 7.1461400985717773e+00 -1.7260000228881836e+01 -1.0229700088500977e+01 -2.5912401199340820e+01 -6.5912199020385742e+00 -2.5931301116943359e+01 -2.5644001007080078e+01 -2.4205899238586426e+00 -2.6451900482177734e+01 -2.3801099777221680e+01 -3.8622300624847412e+00 -2.5255300521850586e+01 -8.5145103454589844e+01 -5.5757799148559570e+00 2.5662200927734375e+01 -8.4460601806640625e+01 -8.7752904891967773e+00 5.3235797882080078e+00 -6.3375101089477539e+00 1.7565100193023682e+00 -1.3721400260925293e+01 -8.2074394226074219e+01 1.5267700195312500e+01 -2.7876098632812500e+01 -8.4486404418945312e+01 1.0800999641418457e+01 -2.7713001251220703e+01 -8.4867797851562500e+01 1.2569499969482422e+01 -2.7100799560546875e+01 -3.1758199691772461e+01 -2.0571800231933594e+01 2.4306600570678711e+01 -2.9592399597167969e+01 -2.7388601303100586e+01 2.1954000473022461e+01 -2.8733600616455078e+01 -1.9363800048828125e+01 2.4038000106811523e+01 -8.3058799743652344e+01 -1.3686300277709961e+01 -2.5666900634765625e+01 -8.5035003662109375e+01 -6.3558301925659180e+00 -2.5674098968505859e+01 -7.1587898254394531e+01 -3.3174499511718750e+01 -2.1690000534057617e+01 -6.8256202697753906e+01 -3.4979999542236328e+01 -2.1093599319458008e+01 -6.9966796875000000e+01 -3.4713600158691406e+01 -1.9631198883056641e+01 -5.3734598159790039e+00 -9.3850593566894531e+00 1.3516600608825684e+01 -4.5868897438049316e+00 -2.1889400482177734e+01 1.3294899940490723e+01 -9.3643701076507568e-01 1.2331299781799316e+00 1.3162500381469727e+01 -6.4110900878906250e+01 -3.3581001281738281e+01 2.2046899795532227e+01 -6.3890895843505859e+01 -3.4450099945068359e+01 2.1590299606323242e+01 -2.2416999816894531e+01 -2.5918298721313477e+01 2.0565500259399414e+01 -2.1139299392700195e+01 -2.0317699432373047e+01 2.1121301651000977e+01 -1.2585000038146973e+01 -2.6100500106811523e+01 1.4657299995422363e+01 -1.4178999900817871e+01 -2.6742898941040039e+01 1.3717199325561523e+01 -2.5169300079345703e+01 -3.6497998237609863e-01 2.6374399185180664e+01 -2.8175498962402344e+01 -1.5697500705718994e+00 2.7393899917602539e+01 -9.6048898696899414e+00 -2.5772399902343750e+01 1.2623800277709961e+01 -1.4514900207519531e+01 4.0288496017456055e+00 8.1216001510620117e+00 -3.2789901733398438e+01 -3.0060899734497070e+01 1.7758699417114258e+01 -2.2868999481201172e+01 5.2620897293090820e+00 -2.4482398986816406e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -1.1451100349426270e+01 -1.2468999862670898e+01 3.9723701477050781e+00 4.6423501968383789e+00 2.4698100090026855e+00 1.3937099456787109e+01 8.7694101333618164e+00 1.3559999465942383e+00 1.3735700607299805e+01 8.7694101333618164e+00 -7.2062995910644531e+01 -3.3286300659179688e+01 -2.0510700225830078e+01 -2.1232500076293945e+01 -2.6503099441528320e+01 1.9953899383544922e+01 -1.5564300537109375e+01 -2.5595899581909180e+01 1.7409900665283203e+01 -1.6401000976562500e+01 -2.4625801086425781e+01 1.8170499801635742e+01 -1.1733599662780762e+01 9.2020101547241211e+00 -3.9287097454071045e+00 -1.1928699493408203e+01 7.6515102386474609e+00 -8.7694005966186523e+00 -1.1136300086975098e+01 9.8672695159912109e+00 3.1021800041198730e+00 -1.1920199394226074e+01 8.9085302352905273e+00 8.3831701278686523e+00 -1.1295700073242188e+01 9.6952896118164062e+00 8.7694101333618164e+00 -8.8484201431274414e+00 1.0371999740600586e+01 1.0295099258422852e+01 -6.5542902946472168e+00 1.0829599380493164e+01 1.0302700042724609e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -6.5915398597717285e+00 -1.4179100036621094e+01 -2.6742898941040039e+01 -1.3717199325561523e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -1.0730800628662109e+01 1.7999500274658203e+01 2.8110098838806152e+00 1.0229700088500977e+01 -5.0236697196960449e+00 2.6851301193237305e+00 1.2880999565124512e+01 -5.3248100280761719e+00 1.9142800569534302e+00 1.3434800148010254e+01 -3.2349998950958252e+00 -2.4259799957275391e+01 1.1439999580383301e+01 -3.9967998504638672e+01 -3.0895101547241211e+01 -2.0772499084472656e+01 -3.2330902099609375e+01 -2.9474100112915039e+01 -2.0962800979614258e+01 -1.2468999862670898e+01 3.9723799228668213e+00 5.1695203781127930e-01 -5.4393699645996094e+01 1.1380000114440918e+01 -2.8026699066162109e+01 -2.2231201171875000e+01 -1.2556499242782593e+00 2.4675800323486328e+01 -8.9134998321533203e+00 1.0206200599670410e+01 1.1205100059509277e+01 -1.6373800277709961e+01 -2.4622798919677734e+01 -1.8157501220703125e+01 -2.0687799453735352e+01 5.2614102363586426e+00 -2.1774700164794922e+01 1.5323800086975098e+01 4.1637501716613770e+00 1.3162500381469727e+01 1.5431400299072266e+01 4.6149396896362305e+00 1.3162500381469727e+01 1.4017400741577148e+01 5.5252099037170410e+00 1.3162500381469727e+01 -1.7720899581909180e+01 -1.3928599357604980e+01 -2.0123699188232422e+01 -1.3107599258422852e+01 -2.3883600234985352e+01 -1.6286199569702148e+01 -3.1628799438476562e+01 8.4871101379394531e+00 1.9451400756835938e+01 -8.5964797973632812e+01 1.1868500709533691e+00 2.5676300048828125e+01 -8.5881393432617188e+01 6.9067101478576660e+00 2.6386400222778320e+01 -8.6083892822265625e+01 5.1130099296569824e+00 2.5666900634765625e+01 -8.0267700195312500e+01 -1.2764199256896973e+01 2.8096899032592773e+01 -7.9344696044921875e+01 -1.5972599029541016e+01 2.7999799728393555e+01 -6.8686302185058594e+01 -1.3177599906921387e+01 2.8035299301147461e+01 -3.4678499698638916e+00 -2.4546600341796875e+01 -1.0226399421691895e+01 -6.8465900421142578e+00 -2.5434799194335938e+01 -1.0693900108337402e+01 5.3050603866577148e+00 1.0234899520874023e+01 -1.2282799720764160e+01 5.4755702018737793e+00 1.0288099288940430e+01 -1.1643799781799316e+01 -2.3418100357055664e+01 3.4390799999237061e+00 -2.5626100540161133e+01 -2.3448501586914062e+01 3.2784798145294189e+00 -2.5642599105834961e+01 -8.2882400512695312e+01 1.0574700355529785e+01 -2.8096899032592773e+01 -3.2887599945068359e+01 5.3357300758361816e+00 2.8096899032592773e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -7.9923099279403687e-01 -1.2487700462341309e+01 3.8984899520874023e+00 -3.2551601529121399e-01 -8.2080101013183594e+01 1.7292600631713867e+01 -2.5666900634765625e+01 -8.0811302185058594e+01 1.8070999145507812e+01 -2.5639598846435547e+01 -8.1527099609375000e+01 1.7308099746704102e+01 -2.6616500854492188e+01 -8.3500305175781250e+01 1.2953100204467773e+01 2.7934499740600586e+01 -8.4759696960449219e+01 1.0734800338745117e+01 2.7460899353027344e+01 -4.1574902534484863e+00 1.0894499778747559e+01 -1.1716500282287598e+01 -8.5376605987548828e+00 1.0257399559020996e+01 -1.1212699890136719e+01 -5.0540599822998047e+00 1.1139400482177734e+01 -1.0868499755859375e+01 -6.4351997375488281e+01 -1.2023900032043457e+01 -2.8055299758911133e+01 -6.6457595825195312e+01 -3.5751899719238281e+01 1.9767801284790039e+01 -6.5414596557617188e+01 -1.6021900177001953e+01 -2.7626399993896484e+01 -7.7686401367187500e+01 1.8971700668334961e+01 -2.5795400619506836e+01 -7.7796401977539062e+01 1.8792200088500977e+01 -2.6459199905395508e+01 -7.9663406372070312e+01 -2.1549299240112305e+01 2.5176801681518555e+01 -7.7815803527832031e+01 -2.4162700653076172e+01 2.5170400619506836e+01 -8.0238800048828125e+01 -2.0285900115966797e+01 2.5552999496459961e+01 -8.0270500183105469e+01 -2.0207399368286133e+01 -2.2489600181579590e+00 4.8787798881530762e+00 1.0104199409484863e+01 1.2581200599670410e+01 5.1955399513244629e+00 1.0201799392700195e+01 1.2359499931335449e+01 -1.7269599914550781e+01 2.7614200115203857e+00 -2.0761899948120117e+01 -1.8656398773193359e+01 2.3088200092315674e+00 -2.2057399749755859e+01 -1.8927799224853516e+01 4.4864702224731445e+00 -2.1103000640869141e+01 -1.1295700073242188e+01 9.6952896118164062e+00 -8.7694101333618164e+00 3.4292600154876709e+00 1.3637700080871582e+01 8.3823099136352539e+00 3.2828400135040283e+00 1.3691499710083008e+01 4.4710597991943359e+00 -1.0954899787902832e+01 9.9566106796264648e+00 -4.3614101409912109e+00 9.4770300388336182e-01 -2.2524200439453125e+01 1.0229899406433105e+01 1.3160300254821777e+00 1.3715700149536133e+01 9.1459999084472656e+00 -3.4076000213623047e+01 -3.0211999893188477e+01 1.9965900421142578e+01 -3.2286403656005859e+01 -2.9720199584960938e+01 2.0481201171875000e+01 -3.7879798889160156e+01 -3.0309301376342773e+01 2.1135299682617188e+01 -2.6406499862670898e+01 7.8242998123168945e+00 -1.9237300872802734e+01 -1.4515699386596680e+01 4.0267701148986816e+00 -1.1472999572753906e+01 -1.9121200561523438e+01 5.1631298065185547e+00 1.6200000762939453e+01 -1.8723299026489258e+01 4.9519901275634766e+00 1.6200000762939453e+01 -1.3659000396728516e+01 3.7333600521087646e+00 1.0100999832153320e+01 -1.3369699478149414e+01 3.6811499595642090e+00 1.5818199157714844e+01 -7.2312301635742188e+01 -3.3093002319335938e+01 -1.3019000053405762e+01 -1.8680601119995117e+01 4.9415903091430664e+00 1.6200000762939453e+01 -3.0809600830078125e+01 1.3216799736022949e+01 -1.6199798583984375e+01 -1.2468999862670898e+01 3.9723799228668213e+00 6.8087697029113770e+00 -1.2484399795532227e+01 3.9099199771881104e+00 7.2823896408081055e+00 -1.2484399795532227e+01 3.9099199771881104e+00 7.7019901275634766e+00 -3.1619102478027344e+01 9.1428298950195312e+00 -1.9237499237060547e+01 -2.8657798767089844e+01 7.6556901931762695e+00 -1.9496599197387695e+01 -7.9056901931762695e+00 6.1648502349853516e+00 -1.2403100013732910e+01 -8.1184898376464844e+01 -1.8335500717163086e+01 2.5733100891113281e+01 -1.2484200477600098e+01 3.9098398685455322e+00 -1.0575200080871582e+01 -1.0217400550842285e+01 1.0161899566650391e+01 9.1455993652343750e+00 -1.1837100028991699e+01 9.0069694519042969e+00 9.6961002349853516e+00 -1.0723400115966797e+01 9.2629899978637695e+00 1.1413799285888672e+01 -3.0947000503540039e+01 -6.8715701103210449e+00 2.7576299667358398e+01 1.4017400741577148e+01 5.5252299308776855e+00 -1.3162500381469727e+01 1.5323800086975098e+01 4.1637501716613770e+00 -1.3162500381469727e+01 3.5189900398254395e+00 1.2387099266052246e+01 1.0975000381469727e+01 2.7276201248168945e+00 1.2909700393676758e+01 1.1376399993896484e+01 2.0134000778198242e+00 1.1841899871826172e+01 1.2109000205993652e+01 -9.9629602432250977e+00 3.9463801383972168e+00 1.2822000503540039e+01 -5.1284399032592773e+00 3.3915398120880127e+00 1.2656300544738770e+01 -8.4990898132324219e+01 -4.6578397750854492e+00 2.6591299057006836e+01 -8.3480400085449219e+01 -8.3210201263427734e+00 2.7478899002075195e+01 -7.9436500549316406e+01 1.7295799255371094e+01 -2.7633199691772461e+01 1.4097799301147461e+01 8.5582199096679688e+00 1.0974300384521484e+01 1.4471399307250977e+01 8.6752099990844727e+00 9.8253202438354492e+00 1.2776300430297852e+01 8.2544794082641602e+00 1.0229800224304199e+01 5.4755702018737793e+00 1.0288099288940430e+01 1.1643799781799316e+01 3.9121499061584473e+00 9.8083105087280273e+00 1.1604000091552734e+01 -3.2194900512695312e+01 8.1703805923461914e+00 2.5740800857543945e+01 -2.8270698547363281e+01 7.1634702682495117e+00 2.5726100921630859e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.9889199733734131e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -3.0948998928070068e+00 7.8375797271728516e+00 6.3176698684692383e+00 -1.0229800224304199e+01 -3.2373802185058594e+01 7.4179096221923828e+00 -2.7315099716186523e+01 -6.8786296844482422e+00 -2.2554998397827148e+01 1.3689200401306152e+01 -1.0217400550842285e+01 1.0161899566650391e+01 -9.1456098556518555e+00 -1.0972799301147461e+01 9.8318595886230469e+00 -1.0179499626159668e+01 -2.7397800445556641e+01 4.1198697090148926e+00 -2.7423400878906250e+01 -7.5310699462890625e+01 -2.9075099945068359e+01 -2.2331199645996094e+01 -7.6789695739746094e+01 -2.6851900100708008e+01 -2.3179199218750000e+01 7.0728302001953125e+00 6.1602401733398438e+00 -1.1267999649047852e+01 -3.8524200439453125e+01 6.7241401672363281e+00 -2.8097499847412109e+01 -4.0985801696777344e+01 8.4421596527099609e+00 -2.7926500320434570e+01 -8.5338500976562500e+01 -4.3485999107360840e-01 2.6955900192260742e+01 -7.4673599243164062e+01 -2.5458698272705078e+01 -2.5446899414062500e+01 -2.1543800354003906e+01 5.6311798095703125e+00 2.1169200897216797e+01 -1.2469099998474121e+01 3.9723901748657227e+00 7.7372398376464844e+00 -1.2491400718688965e+01 3.8886401653289795e+00 8.3463201522827148e+00 -2.4159500122070312e+01 6.2754898071289062e+00 2.2972999572753906e+01 -3.1634099960327148e+01 8.1166400909423828e+00 2.0250000000000000e+01 -2.1872001647949219e+01 3.6640801429748535e+00 -2.4625801086425781e+01 -1.8115199804306030e+00 1.2297200202941895e+01 1.1544100046157837e+00 -1.2392800331115723e+01 4.2737202644348145e+00 -1.2936100006103516e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.4174999237060547e+01 6.1715998649597168e+00 8.0292997360229492e+00 1.1643799781799316e+01 -4.6267498016357422e+01 1.1364599227905273e+01 -2.6522500991821289e+01 -2.0308200836181641e+01 5.3378500938415527e+00 -1.6200000762939453e+01 1.6434799194335938e+01 8.0008001327514648e+00 1.1106800079345703e+01 -2.9465299606323242e+01 1.3595799446105957e+01 1.6200000762939453e+01 4.7463798522949219e+00 1.0064300537109375e+01 -1.0486200332641602e+01 4.9977498054504395e+00 1.0140899658203125e+01 -8.8615293502807617e+00 -1.2484399795532227e+01 3.9099199771881104e+00 1.0824300765991211e+01 -7.3093101501464844e+01 -3.1947500228881836e+01 -2.1611099243164062e+01 -1.3649499893188477e+01 -2.0166198730468750e+01 -1.6796400070190430e+01 -1.4594299316406250e+01 -1.1992500305175781e+01 -1.7900100708007812e+01 -2.0471099853515625e+01 5.3669600486755371e+00 2.0250000000000000e+01 -8.1364402770996094e+01 -1.3131000518798828e+01 -2.7924800872802734e+01 -8.4118301391601562e+01 -2.4903000891208649e-01 -2.7910200119018555e+01 -1.8723299026489258e+01 4.9519901275634766e+00 -1.6200000762939453e+01 -1.9121099472045898e+01 5.1630897521972656e+00 -1.6200000762939453e+01 -2.2204599380493164e+00 -2.4079299926757812e+01 1.0228199958801270e+01 -9.5017600059509277e-01 -2.3519701004028320e+01 -1.0229700088500977e+01 -9.5017600059509277e-01 -2.3519701004028320e+01 1.0229800224304199e+01 -2.2204599380493164e+00 -2.4079299926757812e+01 -1.0228199958801270e+01 -1.8619499206542969e+01 -1.0543999671936035e+00 2.1860898971557617e+01 -1.6382200241088867e+01 -1.3128899574279785e+01 1.9254699707031250e+01 7.8754200935363770e+00 6.1899800300598145e+00 -1.0834399223327637e+01 -1.1968599319458008e+01 4.9128999710083008e+00 -1.2656300544738770e+01 -8.1316902160644531e+01 1.7834100723266602e+01 5.7058101892471313e-01 -8.1432899475097656e+01 1.7731700897216797e+01 -9.8030796051025391e+00 -7.9688804626464844e+01 1.8525798797607422e+01 -1.2558599472045898e+01 -8.3561798095703125e+01 1.6003499984741211e+01 1.7607400894165039e+01 -8.2080101013183594e+01 1.7292600631713867e+01 2.5666900634765625e+01 -7.4880401611328125e+01 1.8242099761962891e+01 -2.6841800689697266e+01 -7.7240798950195312e+01 1.7425498962402344e+01 -2.7850198745727539e+01 -8.3054100036621094e+01 -1.3700300216674805e+01 2.5666900634765625e+01 6.5172100067138672e+00 5.2400598526000977e+00 1.2515299797058105e+01 1.3856300354003906e+01 8.6082496643066406e+00 5.6883196830749512e+00 -7.4771903991699219e+01 1.8679899215698242e+01 9.7939796447753906e+00 -7.5627700805664062e+01 1.8856300354003906e+01 6.6064101457595825e-01 -1.8680601119995117e+01 4.9415903091430664e+00 1.5576899528503418e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.2886400222778320e+00 -7.0791000366210938e+01 -3.4229801177978516e+01 -1.2186399459838867e+01 -6.9940795898437500e+01 -3.4720802307128906e+01 3.3461299538612366e-01 -7.2171600341796875e+01 -3.3224800109863281e+01 -1.0406699180603027e+00 -6.4094703674316406e+01 -3.3578197479248047e+01 2.2046899795532227e+01 -1.2100500106811523e+01 9.9917197227478027e-01 -1.6574199676513672e+01 4.2148599624633789e+00 -2.0214399337768555e+01 -4.3156399726867676e+00 -7.4685699462890625e+01 1.6565099716186523e+01 -2.7998899459838867e+01 7.3976602554321289e+00 3.0381901264190674e+00 -1.3162399291992188e+01 9.2621002197265625e+00 -1.4340699195861816e+01 -1.0230099678039551e+01 8.2847900390625000e+00 -1.5479100227355957e+01 -1.1488699913024902e+01 1.9050099849700928e+00 -1.9417699813842773e+01 1.3059399604797363e+01 -1.7540600299835205e+00 -2.1827699661254883e+01 1.2974999427795410e+01 -1.2468999862670898e+01 3.9723701477050781e+00 1.1451100349426270e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.2562399864196777e+01 -6.7094001770019531e+01 -3.5633499145507812e+01 -1.9204199314117432e+00 -6.9141998291015625e+01 -3.5073398590087891e+01 -1.0676899909973145e+01 -5.8862102508544922e+01 1.4758200645446777e+01 2.5771200180053711e+01 -6.6752700805664062e+01 1.6404199600219727e+01 2.6540199279785156e+01 -5.7855300903320312e+01 1.4107700347900391e+01 2.6716400146484375e+01 1.8461599349975586e+01 4.4659600257873535e+00 -4.0511398315429688e+00 -6.7801803588867188e+01 -2.2013500213623047e+01 2.6201400756835938e+01 -7.4673599243164062e+01 -2.5458698272705078e+01 2.5446899414062500e+01 3.1772801876068115e+00 -1.6965400695800781e+01 -1.3166399955749512e+01 -7.9464698791503906e+01 1.6842800140380859e+01 2.7888599395751953e+01 -8.0379997253417969e+01 1.4894800186157227e+01 2.8096899032592773e+01 -6.6855001449584961e+00 -2.3976100921630859e+01 1.3298200607299805e+01 -7.5794796943664551e+00 -2.2704200744628906e+01 1.3865099906921387e+01 -1.1248499870300293e+01 5.1348104476928711e+00 8.8615293502807617e+00 1.7053899765014648e+01 4.5799903869628906e+00 -1.2750299453735352e+01 -9.6793699264526367e+00 7.8165602684020996e-01 -1.5179299354553223e+01 -9.2741994857788086e+00 2.1737599372863770e+00 -1.4671999931335449e+01 1.6998899459838867e+01 6.2526502609252930e+00 1.2577199935913086e+01 1.5033500671386719e+01 6.3609900474548340e+00 1.3092599868774414e+01 1.7478500366210938e+01 5.1903200149536133e+00 1.2537400245666504e+01 -1.1825799942016602e+01 2.5406200885772705e+00 -1.5898799896240234e+01 -7.7610099792480469e+01 -2.2007999420166016e+01 -2.6670200347900391e+01 -7.7864997863769531e+01 -2.4162899017333984e+01 -2.5080999374389648e+01 -1.8674098968505859e+01 2.1953301429748535e+00 2.2069599151611328e+01 -2.0307800292968750e+01 -1.5372200012207031e+01 -2.1515800476074219e+01 -2.0569900512695312e+01 6.4211702346801758e+00 1.9237499237060547e+01 1.0173600196838379e+01 -1.2668499946594238e+01 1.0229700088500977e+01 -8.5624000549316406e+01 1.2087100028991699e+01 1.9766099929809570e+01 1.8035499572753906e+01 6.2667803764343262e+00 1.1057900428771973e+01 -1.8145300149917603e+00 -2.1698999404907227e+01 -1.3026299476623535e+01 9.1821396350860596e-01 -2.1643299102783203e+01 -1.2238900184631348e+01 -1.0127799987792969e+01 3.3894300460815430e+00 -1.3818900108337402e+01 -1.0800699234008789e+01 5.2727899551391602e+00 1.0632800102233887e+01 -1.1968599319458008e+01 4.9128999710083008e+00 1.2656300544738770e+01 -3.5346199035644531e+01 -7.1104402542114258e+00 2.8034200668334961e+01 -4.5793701171875000e+01 -3.2309902191162109e+01 -1.9889099121093750e+01 -2.1853099822998047e+01 5.7073702812194824e+00 2.0932600021362305e+01 -7.4651397705078125e+01 -2.7210699081420898e+01 -2.4724800109863281e+01 -7.5132499694824219e+01 -2.8274499893188477e+01 -2.3792798995971680e+01 -1.2259400367736816e+01 4.8232898712158203e+00 1.2660400390625000e+01 -9.0257501602172852e+00 7.4893897771835327e-01 1.4873800277709961e+01 -3.4678499698638916e+00 -2.4546600341796875e+01 1.0226300239562988e+01 -2.1972099304199219e+01 -2.8044799804687500e+01 -1.8302000045776367e+01 1.2765799522399902e+01 4.9755697250366211e+00 1.3162500381469727e+01 9.8834295272827148e+00 -6.5972900390625000e+00 1.3162599563598633e+01 -3.2600399017333984e+01 -2.7963298797607422e+01 -2.2046899795532227e+01 5.3409199714660645e+00 3.1408400535583496e+00 1.3085200309753418e+01 -2.1136699676513672e+01 5.5309100151062012e+00 -2.0822700500488281e+01 -1.1248499870300293e+01 5.1348104476928711e+00 -8.8615293502807617e+00 3.5155498981475830e+00 1.3290500640869141e+01 -1.0145500183105469e+01 4.1435799598693848e+00 1.2604000091552734e+01 -8.7694005966186523e+00 -1.2528200149536133e+01 3.8404700756072998e+00 -1.0844699144363403e+00 -3.2696197509765625e+01 -9.6085901260375977e+00 2.7570400238037109e+01 -9.0257501602172852e+00 7.4893897771835327e-01 -1.4873800277709961e+01 -8.8467397689819336e+00 9.2061595916748047e+00 1.2156000137329102e+01 -6.4980903625488281e+01 -3.5738899230957031e+01 -4.7488999366760254e+00 -2.0951200485229492e+01 6.7523698806762695e+00 1.7952001571655273e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -4.6423501968383789e+00 -2.3418199539184570e+01 3.4390799999237061e+00 2.5625900268554688e+01 -2.5539800643920898e+01 5.7666797637939453e+00 2.5933300018310547e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.1211000442504883e+01 1.8064201354980469e+01 3.8077600002288818e+00 1.1699000358581543e+01 -1.7263299942016602e+01 2.5184898376464844e+00 2.0802299499511719e+01 -1.2420499801635742e+01 4.1591300964355469e+00 -4.3063297271728516e+00 -2.0569900512695312e+01 6.4211797714233398e+00 -1.9237499237060547e+01 -2.0274599075317383e+01 6.1647500991821289e+00 -1.9253698348999023e+01 -3.1579498291015625e+01 1.1716900825500488e+01 1.9237499237060547e+01 -3.1538299560546875e+01 1.2062000274658203e+01 1.7867500305175781e+01 5.4755702018737793e+00 1.0288099288940430e+01 1.4281799793243408e+00 -8.2882400512695312e+01 1.0574700355529785e+01 2.8096899032592773e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -2.0250000000000000e+01 -3.3957599639892578e+01 -2.2076699733734131e+00 2.8097000122070312e+01 -7.1406898498535156e+01 -3.3811698913574219e+01 1.0665699958801270e+01 -7.2553596496582031e+01 -3.2843196868896484e+01 1.1039799690246582e+01 -8.4824501037597656e+01 1.4209400177001953e+01 1.7676399230957031e+01 -3.1318798065185547e+01 -2.0398700714111328e+01 -2.4274200439453125e+01 -2.6977600097656250e+01 -1.8610399246215820e+01 -2.3734500885009766e+01 -2.7629499435424805e+01 -2.6979400634765625e+01 -2.1713800430297852e+01 -7.5557098388671875e+01 -2.8117698669433594e+01 2.3519599914550781e+01 -8.3045700073242188e+01 8.4699592590332031e+00 2.8096899032592773e+01 -1.2279800176620483e+00 -2.2933200836181641e+01 -1.2090600013732910e+01 -4.3032598495483398e+00 1.1460499763488770e+01 -1.0306200027465820e+01 -4.2065896987915039e+00 1.1490400314331055e+01 -1.0306200027465820e+01 -3.5070602416992188e+01 -2.1786800384521484e+01 2.4295400619506836e+01 -3.2600399017333984e+01 -2.7963100433349609e+01 2.2046899795532227e+01 -3.0197000503540039e+01 6.8118801116943359e+00 2.7204399108886719e+01 -2.0253499984741211e+01 5.3109297752380371e+00 2.0218898773193359e+01 -3.2878101348876953e+01 -9.3289098739624023e+00 -2.7645900726318359e+01 -8.5834098815917969e+01 7.2901301383972168e+00 -2.6437700271606445e+01 -8.6083892822265625e+01 5.1130099296569824e+00 -2.5666900634765625e+01 -8.6002799987792969e+01 8.5538406372070312e+00 -2.5668899536132812e+01 -4.3032598495483398e+00 1.1460499763488770e+01 1.0306200027465820e+01 -3.7239401340484619e+00 1.1649600028991699e+01 1.0305799484252930e+01 -3.6514399051666260e+00 1.1667500495910645e+01 1.0304599761962891e+01 -3.2975799560546875e+01 3.8400099277496338e+00 -2.8096899032592773e+01 -3.2887599945068359e+01 5.3357300758361816e+00 -2.8096899032592773e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -1.6200000762939453e+01 -3.7348401546478271e+00 9.6158704757690430e+00 -1.2329899787902832e+01 -3.4674800872802734e+01 -1.4640600204467773e+01 2.6576499938964844e+01 -2.5977300643920898e+01 7.0095701217651367e+00 1.9470499038696289e+01 -3.1917098999023438e+01 -2.6032500267028809e+00 2.8021100997924805e+01 -4.0303600311279297e+01 -2.9336700439453125e+01 2.2047401428222656e+01 -5.2587200164794922e+01 -3.1526498794555664e+01 2.2046899795532227e+01 -1.2900600433349609e+01 3.6866500377655029e+00 1.4267199516296387e+01 -3.7007598876953125e+01 -1.6523199081420898e+01 2.6201299667358398e+01 -8.0504699707031250e+01 1.7846899032592773e+01 2.6673799514770508e+01 6.5892200469970703e+00 6.6740202903747559e+00 1.1643799781799316e+01 1.3160300254821777e+00 1.3715700149536133e+01 -9.1459999084472656e+00 5.4230195283889771e-01 1.3339400291442871e+01 1.0186499595642090e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -2.6891999244689941e+00 -1.8805799484252930e+01 4.9762101173400879e+00 -1.6808599472045898e+01 -1.8677999496459961e+01 4.9410200119018555e+00 -1.8645801544189453e+01 4.1435799598693848e+00 1.2604000091552734e+01 5.3573400056461384e-13 4.9977498054504395e+00 1.0140899658203125e+01 -3.7186799049377441e+00 4.9977498054504395e+00 1.0140899658203125e+01 8.8615293502807617e+00 4.1435799598693848e+00 1.2604000091552734e+01 8.7694005966186523e+00 -8.0861595153808594e+01 1.4468800544738770e+01 -2.8099199295043945e+01 -1.8680601119995117e+01 4.9415903091430664e+00 -1.5576899528503418e+01 1.8025800704956055e+01 2.8638198375701904e+00 1.8640899658203125e+00 -8.5711204528808594e+01 -1.5585000514984131e+00 2.5666900634765625e+01 -3.8664299011230469e+01 9.7858705520629883e+00 2.5666900634765625e+01 -4.5768001556396484e+01 1.1208900451660156e+01 2.6579498291015625e+01 -7.2385307312011719e+01 -3.1241298675537109e+01 2.3072099685668945e+01 2.7172601222991943e+00 -2.1455699920654297e+01 -9.9170894622802734e+00 -6.4094703674316406e+01 -3.3578197479248047e+01 -2.2046899795532227e+01 -1.0621700286865234e+01 9.1452493667602539e+00 -1.1563099861145020e+01 -2.3368301391601562e+01 5.4110898971557617e+00 2.4809200286865234e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 7.1406497955322266e+00 -8.2216102600097656e+01 -1.6069200515747070e+01 -5.7170400619506836e+00 -1.2499199867248535e+01 3.8734200000762939e+00 -9.4482898712158203e+00 -1.2490699768066406e+01 3.8924100399017334e+00 3.3666701316833496e+00 -8.3060401916503906e+01 -1.3686800003051758e+01 -1.6274000167846680e+01 -8.3054100036621094e+01 -1.3700300216674805e+01 -2.5666900634765625e+01 -8.3058799743652344e+01 -1.3686300277709961e+01 2.5666900634765625e+01 -7.6187500000000000e+01 1.8943000793457031e+01 -1.8149898529052734e+01 -8.6044700622558594e+01 2.5542399883270264e+00 -3.6043100357055664e+00 -8.5937301635742188e+01 8.1713896989822388e-01 -2.5695800781250000e+01 -7.8908195495605469e+01 1.8738399505615234e+01 2.7807998657226562e-01 -7.7226402282714844e+01 1.8952301025390625e+01 -1.0827600479125977e+01 -8.6039001464843750e+01 7.8893499374389648e+00 6.7517399787902832e-01 -8.5695495605468750e+01 -1.7946900129318237e+00 9.9244898557662964e-01 -8.2707893371582031e+01 1.6874198913574219e+01 8.4668798446655273e+00 -8.4415199279785156e+01 1.4895499229431152e+01 -1.7561300277709961e+01 -7.8498001098632812e+01 1.8810798645019531e+01 -1.8372900009155273e+01 -8.5170501708984375e+01 -5.4223003387451172e+00 -1.0836700439453125e+01 -3.9489898681640625e+01 -3.1162698745727539e+01 2.0016599655151367e+01 6.9650502204895020e+00 6.2961602210998535e+00 -1.4111299514770508e+00 1.2963500022888184e+01 7.8590903282165527e+00 -1.1816699981689453e+01 -8.2167495727539062e+01 -1.6196201324462891e+01 1.3814499855041504e+01 7.2005200386047363e+00 6.2607698440551758e+00 5.2534098625183105e+00 7.7394099235534668e+00 6.2859597206115723e+00 7.0418801307678223e+00 -1.1928699493408203e+01 7.6515102386474609e+00 8.7694005966186523e+00 1.6019899845123291e+00 -2.2163599014282227e+01 -4.3230800628662109e+00 -7.0307302474975586e+00 -2.5468399047851562e+01 1.0015199661254883e+01 -3.4272903442382812e+01 -1.2446599960327148e+01 -2.7127899169921875e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.1597700119018555e+01 -7.6556900024414062e+01 1.5989600181579590e+01 2.8096899032592773e+01 7.4979400634765625e+00 -1.1315800666809082e+01 1.3162500381469727e+01 1.7743200063705444e+00 1.6654300689697266e+00 1.3162500381469727e+01 -5.6050800323486328e+01 -3.2143898010253906e+01 2.2046501159667969e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -5.5708198547363281e+00 3.6702899932861328e+00 1.3299300193786621e+01 9.6205396652221680e+00 -4.3236499786376953e+01 9.9578104019165039e+00 -2.7337198257446289e+01 -5.2473796844482422e+01 1.2130700111389160e+01 2.7420099258422852e+01 -6.3763603210449219e+01 -3.5443500518798828e+01 2.0199199676513672e+01 -6.6889602661132812e+01 -3.5169300079345703e+01 2.1070100784301758e+01 -1.0937100410461426e+01 -2.3413600921630859e+01 -1.5065499305725098e+01 1.8118101119995117e+01 6.0945100784301758e+00 -1.0972000122070312e+01 -8.4443199157714844e+01 1.4854499816894531e+01 9.4425296783447266e+00 -5.7554101943969727e+00 1.1038000106811523e+01 -1.0308400154113770e+01 -2.9934400558471680e+01 1.1625800132751465e+01 1.9237499237060547e+01 3.7036798000335693e+00 1.3349900245666504e+01 -8.5235795974731445e+00 1.2869499206542969e+01 8.2948493957519531e+00 1.4541900157928467e+00 1.3971300125122070e+01 8.6322698593139648e+00 -9.0816795825958252e-01 1.8016201019287109e+01 6.4611701965332031e+00 5.0233302116394043e+00 1.8278699874877930e+01 5.8155899047851562e+00 -3.9653798937797546e-01 -8.5030097961425781e+01 6.9620103836059570e+00 -2.7464399337768555e+01 1.9063199758529663e+00 1.2481399536132812e+01 -1.2013400077819824e+01 -9.8575506210327148e+00 8.1238298416137695e+00 -1.2062000274658203e+01 -2.2471500396728516e+01 5.6958599090576172e+00 2.3190601348876953e+01 -2.0458801269531250e+01 -1.5454299926757812e+01 2.1590900421142578e+01 -8.5711204528808594e+01 -1.5585000514984131e+00 -2.5666900634765625e+01 -7.8688301086425781e+01 -1.7159898757934570e+01 -2.7824800491333008e+01 -3.0506299972534180e+01 -2.7548599243164062e+01 -2.1996099472045898e+01 -1.8680601119995117e+01 4.9415903091430664e+00 -1.6200000762939453e+01 1.8381200790405273e+01 3.7917900085449219e+00 -7.5998598337173462e-01 -7.4819496154785156e+01 -2.7081100463867188e+01 2.4762300491333008e+01 -2.9883800506591797e+01 3.6574599742889404e+00 -2.7899700164794922e+01 -2.5053699493408203e+01 6.9892301559448242e+00 -1.9359899520874023e+01 2.0604398250579834e+00 1.3875300407409668e+01 1.0187500000000000e+01 -6.8339897155761719e+01 -3.5352901458740234e+01 7.4738702774047852e+00 -7.0307302474975586e+00 -2.5468399047851562e+01 4.2167601585388184e+00 -1.8669198989868164e+01 -1.4469600677490234e+01 2.0667400360107422e+01 -1.3715800285339355e+01 -2.6531400680541992e+01 -1.4534399986267090e+01 1.4554799079895020e+01 7.8870701789855957e+00 1.2254600524902344e+01 -2.5937799453735352e+01 3.4249598979949951e+00 -2.6824901580810547e+01 -1.1792400360107422e+01 1.8972599506378174e+00 1.6251201629638672e+01 -1.1929100036621094e+01 8.4870595932006836e+00 -9.6228895187377930e+00 3.8926100730895996e+00 1.3110199928283691e+01 -4.5864601135253906e+00 -1.2007099151611328e+01 8.2018299102783203e+00 4.3791403770446777e+00 1.5308300018310547e+01 5.0949902534484863e+00 1.3162500381469727e+01 -8.2356803894042969e+01 1.6340200424194336e+01 2.7129499435424805e+01 -9.6793699264526367e+00 7.8165602684020996e-01 1.5179299354553223e+01 -3.2233699798583984e+01 8.0123805999755859e+00 2.6198598861694336e+01 -1.2804200172424316e+01 -2.5236200332641602e+01 -1.5723800659179688e+01 -7.6621002197265625e+01 -2.3808599472045898e+01 2.6010200500488281e+01 -8.5190994262695312e+01 1.3430399894714355e+01 -9.0667800903320312e+00 -7.6371398925781250e+01 1.8959999084472656e+01 1.2674399375915527e+01 -7.7428604125976562e+01 1.8959300994873047e+01 3.9070899486541748e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6000 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01) (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01) (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01) (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01) (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01) (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_r_finger_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_r_finger_tip_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 9.1370000000000005e+01 -4.9500000000000002e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 5 8 0 2 5 8 26 0 0 28 1 26 28 0 2 3 4 2 1 3 2 4 5 3 1 7 3 19 4 19 3 7 4 19 5 18 19 20 19 21 20 19 7 21 5 19 24 24 19 18 18 30 24 31 30 18 20 31 18 20 36 31 20 37 36 21 37 20 7 22 21 21 61 37 22 61 21 38 37 39 37 38 36 37 60 39 37 61 60 22 62 61 62 268 61 268 271 61 61 271 60 23 22 7 23 62 22 23 268 62 6 23 7 63 23 6 63 267 23 267 268 23 6 7 1 1 28 6 6 28 63 57 28 58 27 58 28 27 28 26 63 28 57 55 57 56 57 58 56 55 63 57 56 58 50 49 50 58 49 58 27 55 56 54 54 56 52 52 56 50 53 55 54 53 63 55 53 54 52 51 52 50 51 53 52 48 50 49 48 51 50 51 264 53 48 264 51 264 63 53 264 267 63 261 264 260 261 265 264 264 268 267 265 268 264 260 264 48 259 260 254 259 261 260 254 260 48 258 259 255 255 259 254 258 261 259 247 251 254 251 255 254 48 247 254 252 255 251 255 252 256 256 258 255 257 258 256 257 261 258 252 59 256 59 257 256 41 257 59 41 90 257 257 262 261 90 262 257 262 265 261 90 263 262 262 266 265 263 266 262 265 269 268 266 269 265 263 86 266 266 86 84 266 270 269 84 270 266 88 263 90 88 86 263 84 86 85 86 87 85 86 88 87 81 84 83 84 85 83 84 81 270 270 271 269 270 272 271 81 272 270 80 39 81 81 83 80 272 81 39 83 290 80 83 293 290 83 85 293 80 82 39 290 286 80 80 286 82 39 82 38 60 272 39 271 272 60 269 271 268 79 36 38 38 82 79 82 286 79 78 36 79 79 286 78 29 36 78 31 36 29 32 78 77 29 78 32 286 287 78 78 287 77 29 30 31 32 30 29 11 30 9 32 9 30 34 30 11 30 34 24 9 10 11 10 12 11 11 12 13 13 34 11 14 10 9 14 9 32 14 15 10 15 16 10 10 16 12 12 16 17 12 25 13 12 17 25 5 13 25 5 34 13 25 8 5 24 34 5 8 27 26 27 8 25 25 65 27 65 66 27 27 232 49 66 232 27 65 67 66 65 273 67 25 273 65 67 68 66 68 232 66 67 69 68 67 273 69 69 70 68 70 232 68 69 73 70 69 273 73 73 74 70 74 232 70 72 74 73 74 284 285 74 285 232 72 284 74 284 72 277 285 284 276 276 284 277 232 285 282 282 285 274 274 285 276 274 276 73 276 277 73 73 277 71 71 277 278 277 72 278 71 72 73 278 279 71 71 279 72 278 72 279 273 274 73 274 273 275 275 282 274 129 273 25 280 281 273 273 281 275 129 280 273 281 427 275 275 427 282 128 427 281 128 281 280 128 280 129 126 128 127 128 129 127 310 432 128 432 427 128 309 310 128 126 297 128 128 297 309 423 432 431 426 432 423 426 427 432 431 432 310 423 424 247 247 426 423 423 431 424 424 431 430 430 431 310 424 425 247 424 430 425 425 430 429 429 430 310 425 421 247 425 429 421 421 429 428 315 429 310 428 429 315 314 315 308 308 315 310 315 314 116 116 428 315 310 309 308 308 307 306 308 309 307 306 314 308 309 299 307 299 309 297 306 307 305 307 94 305 307 299 94 297 298 299 298 94 299 297 296 298 291 296 297 126 291 297 298 301 95 298 296 301 95 94 298 295 296 288 288 296 291 296 295 301 291 292 288 292 291 126 124 126 125 126 127 125 124 292 126 288 292 122 122 292 124 122 124 123 124 125 123 125 127 118 121 125 118 123 125 121 127 129 64 118 127 64 64 16 118 16 119 118 119 120 118 120 121 118 120 122 121 122 123 121 120 288 122 119 288 120 76 119 16 76 288 119 16 64 17 16 35 76 15 35 16 75 76 35 75 288 76 35 15 33 33 75 35 32 33 15 14 32 15 32 77 33 75 33 77 77 287 75 75 287 288 289 287 286 289 288 287 290 289 286 289 290 294 290 293 294 303 294 293 289 294 303 85 302 293 293 302 303 289 303 501 302 501 303 301 302 85 301 295 302 289 501 302 289 302 500 295 500 302 87 300 85 301 85 300 95 301 300 89 300 87 95 300 89 88 89 87 88 90 89 90 91 89 93 89 91 93 95 89 94 95 93 92 93 91 92 94 93 90 41 91 91 41 40 40 92 91 40 311 92 311 94 92 305 94 311 99 311 96 305 311 99 96 311 40 40 41 42 42 96 40 41 59 42 42 97 96 42 59 97 97 98 96 98 99 96 98 100 99 304 99 100 304 305 99 306 305 304 304 100 101 101 103 304 103 312 304 304 312 306 98 101 100 98 102 101 102 103 101 102 104 103 236 102 249 104 102 236 102 250 249 98 250 102 104 105 103 104 106 105 236 237 104 104 237 106 234 235 236 235 237 236 236 249 234 235 106 237 106 107 105 235 243 106 243 244 106 106 244 107 239 235 234 239 243 235 238 239 234 234 249 248 234 248 238 242 239 238 242 245 239 239 245 243 245 246 243 243 246 244 245 417 246 242 417 245 241 242 238 242 418 417 242 419 418 241 419 242 246 417 416 416 417 414 417 418 414 244 246 46 246 416 46 46 416 44 44 416 231 416 414 231 43 46 44 43 109 46 109 244 46 107 244 109 107 109 108 43 110 109 109 110 108 107 108 105 108 319 105 110 319 108 110 321 319 43 321 110 316 319 318 103 319 316 105 319 103 319 321 318 318 321 320 320 321 111 111 321 43 312 318 317 316 318 312 318 320 317 103 316 312 312 313 306 312 317 313 313 317 314 317 115 314 317 320 115 115 320 111 114 115 113 113 115 111 116 115 114 314 115 116 313 314 306 116 114 117 117 428 116 229 114 113 229 117 114 111 112 113 229 113 228 228 113 112 111 43 112 43 45 112 228 112 45 45 231 228 360 229 228 348 360 228 231 348 228 43 44 45 44 231 45 348 231 414 348 414 454 457 454 414 418 477 414 457 414 439 414 477 439 435 457 439 454 457 435 436 435 439 439 481 436 420 481 439 477 420 439 418 419 477 477 419 415 415 420 477 420 421 422 415 421 420 422 433 420 433 481 420 240 415 241 415 419 241 240 421 415 247 421 240 421 428 422 428 433 422 117 433 428 230 433 117 433 229 481 230 229 433 229 230 117 360 483 229 483 487 229 487 481 229 436 481 451 481 480 451 487 480 481 487 488 480 487 495 488 495 487 483 480 479 451 479 480 488 451 445 436 446 445 451 451 479 446 446 479 478 489 479 488 478 479 491 491 479 489 488 493 489 488 495 493 493 495 494 483 494 495 492 493 494 493 496 489 493 497 496 493 492 497 490 491 489 489 496 490 496 497 475 496 475 499 490 496 499 497 476 475 497 498 476 498 497 492 498 492 485 485 492 494 471 476 498 471 498 485 475 476 410 410 476 408 370 476 471 408 476 370 373 471 470 370 471 373 471 484 470 485 484 471 370 371 372 373 371 370 370 409 408 372 409 370 408 409 410 409 404 412 409 412 410 372 404 409 372 371 377 377 404 372 403 404 402 405 402 404 412 404 403 377 405 404 411 412 413 413 412 403 410 412 411 413 403 396 403 402 396 397 402 401 396 402 397 405 401 402 378 405 377 401 405 378 322 401 323 322 397 401 386 401 378 386 323 401 396 397 325 325 397 324 324 397 322 142 322 323 145 322 142 145 324 322 142 323 381 381 323 386 386 378 385 381 386 382 382 386 385 380 381 382 142 381 380 380 382 383 383 382 387 387 382 385 376 385 375 385 378 375 376 387 385 383 387 376 374 376 366 366 376 375 374 379 376 379 383 376 368 375 371 366 375 368 371 375 378 371 378 377 373 368 371 367 368 369 369 368 373 367 366 368 365 366 367 365 374 366 367 460 365 369 460 367 373 458 369 458 460 369 470 458 373 458 459 460 458 466 459 470 484 458 458 484 466 459 466 467 459 467 460 463 467 466 466 482 463 484 482 466 485 482 484 463 482 464 482 469 464 482 483 469 485 486 482 482 486 483 485 494 486 486 494 483 469 483 465 465 483 360 464 469 354 465 354 469 355 464 354 463 464 355 352 353 354 354 353 355 176 178 354 354 178 352 354 465 176 360 361 465 465 361 176 177 360 348 361 360 177 176 361 177 174 176 177 178 176 174 177 173 174 177 348 173 348 339 173 348 454 339 165 168 173 174 173 168 165 173 339 168 178 174 168 165 167 167 178 168 165 166 167 166 183 167 167 183 178 184 183 166 352 183 184 178 183 352 182 184 166 352 184 353 184 362 353 182 362 184 181 182 155 155 182 153 153 182 166 182 181 362 353 362 356 364 357 362 362 357 356 362 181 364 353 356 355 355 356 349 356 357 349 349 357 350 357 358 350 363 357 364 363 358 357 181 180 364 364 180 363 359 358 363 180 179 363 363 388 359 363 195 388 179 195 363 358 359 350 359 388 393 359 393 350 388 193 389 195 193 388 388 389 393 194 193 195 179 194 195 191 193 192 194 192 193 193 390 389 193 191 390 389 392 393 389 390 392 393 392 395 350 393 395 390 394 392 395 392 374 392 394 374 191 391 390 390 391 394 394 379 374 394 391 379 365 395 374 365 468 395 460 468 365 468 462 351 468 351 461 460 462 468 468 461 395 467 462 460 351 462 349 462 463 349 467 463 462 349 350 351 461 351 350 350 395 461 349 463 355 383 379 384 379 391 384 185 383 384 185 380 383 186 384 391 186 185 384 189 391 191 186 391 189 185 186 187 186 188 187 186 189 188 189 190 188 189 191 190 191 192 190 192 208 190 190 208 188 215 187 188 215 188 207 207 188 208 199 208 192 199 207 208 194 199 192 200 199 194 198 199 200 198 197 199 197 207 199 204 207 197 206 207 204 206 215 207 196 197 198 196 201 197 201 203 197 197 203 204 203 206 204 205 206 203 205 209 206 209 215 206 202 203 201 202 227 203 203 227 205 225 227 202 201 335 202 335 336 202 202 336 225 224 227 225 224 205 227 223 224 225 225 336 223 336 337 223 335 342 336 336 342 344 336 344 337 171 335 201 342 335 171 342 171 172 172 343 342 344 342 343 344 343 345 344 345 337 345 343 341 347 343 172 347 341 343 345 453 337 346 345 341 453 345 346 341 175 340 341 340 346 341 347 175 175 347 163 347 172 163 163 170 175 175 170 165 165 340 175 165 339 340 346 340 339 165 170 166 169 166 170 170 163 169 161 160 163 169 163 160 161 163 172 154 169 160 153 169 154 166 169 153 153 154 155 154 157 155 157 154 160 159 155 157 159 181 155 156 157 158 159 157 156 158 157 160 156 179 159 179 180 159 180 181 159 156 200 194 158 200 156 156 194 179 164 158 160 198 200 158 164 198 158 162 164 160 196 198 164 162 196 164 160 161 162 171 162 172 162 161 172 171 196 162 171 201 196 339 454 346 456 346 454 437 454 435 456 454 437 456 453 346 440 456 437 453 456 440 435 436 437 436 438 437 438 440 437 441 440 438 442 440 441 442 452 440 452 453 440 455 337 453 455 453 452 443 452 330 330 452 442 443 455 452 338 337 455 338 455 443 223 337 221 221 337 219 337 338 219 136 338 329 219 338 136 329 338 443 329 443 330 136 329 134 329 330 134 330 331 134 442 331 330 134 135 136 134 137 135 134 149 137 134 331 149 222 219 136 135 222 136 135 130 132 137 130 135 132 222 135 137 138 130 149 138 137 149 150 138 149 331 150 150 151 138 138 133 130 138 143 133 138 151 143 130 131 132 133 131 130 216 222 132 131 216 132 139 131 140 133 140 131 131 217 216 139 217 131 143 140 133 143 144 140 151 144 143 145 140 144 140 145 139 147 144 151 144 325 145 326 325 144 147 327 144 327 326 144 145 142 139 325 324 145 325 326 396 327 399 326 399 396 326 328 327 147 328 398 327 398 399 327 400 399 398 413 396 399 400 413 399 406 400 398 406 398 328 406 407 400 407 413 400 411 413 407 406 473 407 473 474 407 474 475 407 407 475 411 328 472 406 472 473 406 473 499 474 491 473 472 491 499 473 474 499 475 411 475 410 490 499 491 478 491 472 434 472 328 434 478 472 333 478 434 449 478 333 446 478 449 333 434 328 146 328 147 146 333 328 146 147 148 148 333 146 148 334 333 448 333 334 448 449 333 449 448 446 444 445 446 444 446 448 444 448 447 447 448 334 444 447 441 438 444 441 438 445 444 436 445 438 441 447 442 447 334 450 447 450 442 442 450 331 332 450 334 331 450 332 331 332 150 150 332 334 152 151 150 150 334 152 152 334 148 148 151 152 148 147 151 141 139 142 139 212 217 141 212 139 142 185 141 141 185 212 380 185 142 185 187 212 214 187 215 212 187 214 214 210 212 210 214 213 213 214 215 213 215 209 210 213 211 205 213 209 205 211 213 210 211 212 226 218 211 226 211 205 211 218 212 226 205 224 220 226 224 216 226 220 216 218 226 216 217 218 217 212 218 222 216 220 219 220 221 222 220 219 220 223 221 220 224 223 240 241 238 238 247 240 238 248 247 248 251 247 47 247 48 47 426 247 248 252 251 249 252 248 249 253 252 253 59 252 250 253 249 250 98 253 98 97 253 97 59 253 47 283 426 283 427 426 282 283 233 233 283 47 282 427 283 232 282 233 47 232 233 47 48 49 49 232 47 288 289 500 288 500 295 17 64 25 64 129 25))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-1.1255100250244141e+02 -2.1148599624633789e+01 -7.2288298606872559e+00 -1.0990699768066406e+02 -2.2224800109863281e+01 -8.4010801315307617e+00 -1.1138800048828125e+02 -2.1970798492431641e+01 -7.6926403045654297e+00 -1.1022100067138672e+02 -2.2377601623535156e+01 -8.1409997940063477e+00 -1.1120399475097656e+02 -2.2176399230957031e+01 -7.6428799629211426e+00 -1.1219800567626953e+02 -2.1725299835205078e+01 -7.1447100639343262e+00 -1.0823900604248047e+02 -2.1607000350952148e+01 -9.1103105545043945e+00 -1.0910300445556641e+02 -2.2351900100708008e+01 -8.6652698516845703e+00 -1.1298500061035156e+02 -2.1160499572753906e+01 -6.8069300651550293e+00 -1.1063700103759766e+02 -2.2329200744628906e+01 7.9401097297668457e+00 -1.1053100585937500e+02 -2.2138799667358398e+01 8.1301708221435547e+00 -1.1188899993896484e+02 -2.1872499465942383e+01 7.3370399475097656e+00 -1.1254100036621094e+02 -2.1298200607299805e+01 7.2108802795410156e+00 -1.1268900299072266e+02 -2.1404798507690430e+01 6.8442997932434082e+00 -1.0970099639892578e+02 -2.2372600555419922e+01 8.4108705520629883e+00 -1.0892800140380859e+02 -2.2148000717163086e+01 8.8029594421386719e+00 -1.0786999511718750e+02 -2.0569400787353516e+01 9.1142997741699219e+00 -1.1374600219726562e+02 -2.0187700271606445e+01 6.6784701347351074e+00 -1.0917800140380859e+02 -2.3354999542236328e+01 -7.0110297203063965e+00 -1.0959700012207031e+02 -2.2983501434326172e+01 -7.7004499435424805e+00 -1.0783599853515625e+02 -2.3773399353027344e+01 -7.0611500740051270e+00 -1.0779300689697266e+02 -2.3464401245117188e+01 -7.9070405960083008e+00 -1.0771399688720703e+02 -2.2889999389648438e+01 -8.5910701751708984e+00 -1.0673400115966797e+02 -2.2362699508666992e+01 -8.9888896942138672e+00 -1.1084500122070312e+02 -2.2612600326538086e+01 -6.7972202301025391e+00 -1.1408399963378906e+02 -2.0165700912475586e+01 6.2718000411987305e+00 -1.1384799957275391e+02 -2.0181499481201172e+01 -6.6102499961853027e+00 -1.1406900024414062e+02 -2.0165899276733398e+01 -6.2554397583007812e+00 -1.0810800170898438e+02 -2.0549499511718750e+01 -9.1296901702880859e+00 -1.0787599945068359e+02 -2.3624900817871094e+01 7.5470304489135742e+00 -1.0941000366210938e+02 -2.3245100021362305e+01 7.2567200660705566e+00 -1.0786599731445312e+02 -2.3784700393676758e+01 6.8197798728942871e+00 -1.0798899841308594e+02 -2.3176898956298828e+01 8.2607002258300781e+00 -1.0745400238037109e+02 -2.2550701141357422e+01 8.8517494201660156e+00 -1.1085499572753906e+02 -2.2606800079345703e+01 6.8199100494384766e+00 -1.0834500122070312e+02 -2.1908199310302734e+01 9.0081100463867188e+00 -1.0678499603271484e+02 -2.3850200653076172e+01 7.2325701713562012e+00 -1.0652100372314453e+02 -2.3850898742675781e+01 -7.2211799621582031e+00 -1.0580200195312500e+02 -2.3780399322509766e+01 6.8899002075195312e+00 -1.0503900146484375e+02 -2.3565999984741211e+01 -6.8094100952148438e+00 -8.0891105651855469e+01 -1.1325000524520874e+00 6.8449096679687500e+00 -8.1105300903320312e+01 -2.2144498825073242e+00 -7.0301799774169922e+00 -8.0893203735351562e+01 -1.1343699693679810e+00 -6.8404102325439453e+00 -6.6427604675292969e+01 7.8912601470947266e+00 7.0898699760437012e+00 -6.6379302978515625e+01 1.0204099655151367e+01 -6.8426899909973145e+00 -6.6416801452636719e+01 1.0317999839782715e+01 6.9112296104431152e+00 -6.6422096252441406e+01 7.8617205619812012e+00 -6.9276800155639648e+00 -1.0390999603271484e+02 -1.1320199966430664e+01 -9.1500005722045898e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 -9.1500005722045898e+00 -1.0390800476074219e+02 -1.1322799682617188e+01 -6.2500000000000000e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 -6.2500000000000000e+00 -1.0243199920654297e+02 -1.5235600471496582e+01 -9.1500005722045898e+00 -1.0243199920654297e+02 -1.5235600471496582e+01 -6.2500000000000000e+00 -1.0325399780273438e+02 -1.7961500167846680e+01 -9.1500005722045898e+00 -1.0325399780273438e+02 -1.7961500167846680e+01 -6.2500000000000000e+00 -1.0492599487304688e+02 -1.9646100997924805e+01 -9.1500005722045898e+00 -1.0492599487304688e+02 -1.9646100997924805e+01 -6.2500000000000000e+00 -1.0664500427246094e+02 -2.0404399871826172e+01 -9.1500005722045898e+00 -1.0715000152587891e+02 -2.0549098968505859e+01 -6.2500100135803223e+00 -8.1037994384765625e+01 -9.0935903787612915e-01 -7.6571698188781738e+00 -1.0581700134277344e+02 -2.3635700225830078e+01 -7.5242900848388672e+00 -1.0625199890136719e+02 -2.3281200408935547e+01 -8.2787399291992188e+00 -1.0631799316406250e+02 -2.2787200927734375e+01 -8.7120494842529297e+00 -1.0642399597167969e+02 -2.1591701507568359e+01 -9.1486701965332031e+00 -1.0758700561523438e+02 -2.0558599472045898e+01 6.2500600814819336e+00 -1.1537699890136719e+02 -1.8636501312255859e+01 6.2500000000000000e+00 -1.1537699890136719e+02 -1.8636501312255859e+01 -6.2500000000000000e+00 -1.1674299621582031e+02 -1.6191101074218750e+01 6.2500000000000000e+00 -1.1674299621582031e+02 -1.6191101074218750e+01 -6.2500000000000000e+00 -1.1696799468994141e+02 -1.4067199707031250e+01 6.2500000000000000e+00 -1.1696799468994141e+02 -1.4067199707031250e+01 -6.2500000000000000e+00 -1.1538999938964844e+02 -9.9371299743652344e+00 6.2500000000000000e+00 -1.1516500091552734e+02 -9.6792697906494141e+00 -6.2500000000000000e+00 -1.1622299957275391e+02 -1.1383399963378906e+01 6.2500000000000000e+00 -1.1622299957275391e+02 -1.1383399963378906e+01 -6.2500000000000000e+00 -1.0658500671386719e+02 -2.2050399780273438e+01 9.0689001083374023e+00 -1.0739199829101562e+02 -2.1629100799560547e+01 9.1438894271850586e+00 -1.0634799957275391e+02 -2.2640100479125977e+01 8.8131694793701172e+00 -1.0628200531005859e+02 -2.3285800933837891e+01 8.2749204635620117e+00 -1.0582099914550781e+02 -2.3627899169921875e+01 7.5341701507568359e+00 -1.0305800628662109e+02 -2.2583400726318359e+01 6.9935097694396973e+00 -1.0316800689697266e+02 -2.2666999816894531e+01 -6.8754200935363770e+00 -1.0470500183105469e+02 -2.3403900146484375e+01 7.1863298416137695e+00 -8.4307502746582031e+01 -7.6383199691772461e+00 7.0561299324035645e+00 -8.4178100585937500e+01 -7.4929299354553223e+00 -7.2439699172973633e+00 -8.3353996276855469e+01 -6.6484398841857910e+00 7.2930903434753418e+00 -8.3333702087402344e+01 -6.6357998847961426e+00 -7.2368602752685547e+00 -8.2248100280761719e+01 -5.2323098182678223e+00 6.7470102310180664e+00 -8.2248100280761719e+01 -5.2323098182678223e+00 -6.7470197677612305e+00 -8.1535301208496094e+01 -3.6073899269104004e+00 7.2368497848510742e+00 -8.1535301208496094e+01 -3.6073899269104004e+00 -7.2368602752685547e+00 -8.1164703369140625e+01 -2.4137799739837646e+00 7.0925097465515137e+00 -8.1041595458984375e+01 -1.2051099538803101e+00 7.4830198287963867e+00 -8.1404800415039062e+01 -2.1610400676727295e+00 7.8907098770141602e+00 -8.1464607238769531e+01 -5.7703697681427002e-01 8.4296903610229492e+00 -8.1916801452636719e+01 -2.8818399906158447e+00 8.3461799621582031e+00 -8.0582000732421875e+01 -3.2899701595306396e-01 6.8224301338195801e+00 -8.0611602783203125e+01 -3.6499801278114319e-01 -7.0285301208496094e+00 -7.9885299682617188e+01 5.9871703386306763e-01 -6.9645900726318359e+00 -8.0027702331542969e+01 4.7092598676681519e-01 7.2357196807861328e+00 -7.9382598876953125e+01 9.8377698659896851e-01 7.2393703460693359e+00 -7.8882797241210938e+01 1.2371500730514526e+00 7.0834403038024902e+00 -7.8878799438476562e+01 1.2544499635696411e+00 -7.2472901344299316e+00 -6.8381195068359375e+01 5.0998897552490234e+00 7.0914001464843750e+00 -6.8381401062011719e+01 5.0997200012207031e+00 -7.0912103652954102e+00 -6.7523101806640625e+01 5.7609796524047852e+00 6.6500000953674316e+00 -6.7562103271484375e+01 5.7994298934936523e+00 -7.3110098838806152e+00 -6.7093399047851562e+01 6.2765302658081055e+00 -6.6500000953674316e+00 -6.7093399047851562e+01 6.2765302658081055e+00 6.6500000953674316e+00 -6.6755897521972656e+01 6.8566699028015137e+00 -6.6500000953674316e+00 -6.6765502929687500e+01 6.8609399795532227e+00 6.9129900932312012e+00 -6.6726501464843750e+01 8.2779598236083984e+00 7.9365501403808594e+00 -6.6528701782226562e+01 1.0204299926757812e+01 7.5418601036071777e+00 -6.6966804504394531e+01 1.0284399986267090e+01 8.2502498626708984e+00 -6.7592597961425781e+01 1.0280200004577637e+01 8.7884492874145508e+00 -6.7469200134277344e+01 7.9253296852111816e+00 8.7163000106811523e+00 -6.8424797058105469e+01 8.1632604598999023e+00 9.1246194839477539e+00 -6.8441200256347656e+01 1.0274600028991699e+01 9.1099405288696289e+00 -1.0575799560546875e+02 -2.0101900100708008e+01 6.2499799728393555e+00 -1.0574500274658203e+02 -2.0094999313354492e+01 9.1500005722045898e+00 -1.0418099975585938e+02 -1.9052000045776367e+01 9.1500005722045898e+00 -1.0418099975585938e+02 -1.9052000045776367e+01 6.2500000000000000e+00 -1.0282299804687500e+02 -1.7104900360107422e+01 9.1500005722045898e+00 -1.0282299804687500e+02 -1.7104900360107422e+01 6.2500000000000000e+00 -1.0247100067138672e+02 -1.4757699966430664e+01 9.1500005722045898e+00 -1.0247100067138672e+02 -1.4757699966430664e+01 6.2500000000000000e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 9.1500005722045898e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 6.2500000000000000e+00 -1.0390999603271484e+02 -1.1320199966430664e+01 9.1500005722045898e+00 -1.0390800476074219e+02 -1.1322799682617188e+01 6.2500000000000000e+00 -9.3890396118164062e+01 1.9594499588012695e+01 -1.0717599868774414e+01 -9.3311698913574219e+01 2.0343400955200195e+01 -1.0186299324035645e+01 -9.3139999389648438e+01 1.9639101028442383e+01 -1.0931699752807617e+01 -9.4444198608398438e+01 1.9820499420166016e+01 -1.0143100738525391e+01 -9.3770805358886719e+01 1.8042900085449219e+01 -1.1324600219726562e+01 -9.3148300170898438e+01 1.8898900985717773e+01 -1.1310199737548828e+01 -9.2880302429199219e+01 1.8248298645019531e+01 -1.1486599922180176e+01 -9.4190101623535156e+01 1.8621999740600586e+01 -1.1047300338745117e+01 -9.4629699707031250e+01 1.9244899749755859e+01 -1.0483499526977539e+01 -9.3179298400878906e+01 2.0761600494384766e+01 -9.3805398941040039e+00 -9.4466201782226562e+01 2.0374099731445312e+01 -9.2567300796508789e+00 -9.2621604919433594e+01 2.0890800476074219e+01 -8.6935596466064453e+00 -9.3537803649902344e+01 2.0878400802612305e+01 -8.3422803878784180e+00 -9.5026596069335938e+01 1.9846000671386719e+01 -9.4315004348754883e+00 -9.5409896850585938e+01 1.9844099044799805e+01 -8.4183597564697266e+00 -9.4459800720214844e+01 2.0576400756835938e+01 -8.5082206726074219e+00 -9.6102294921875000e+01 1.8082401275634766e+01 -8.4063005447387695e+00 -9.5957000732421875e+01 1.8826099395751953e+01 -8.5782003402709961e+00 -9.5930999755859375e+01 1.8176700592041016e+01 -9.1546802520751953e+00 -9.4813400268554688e+01 1.8193399429321289e+01 -1.0736900329589844e+01 -9.5316596984863281e+01 1.8348098754882812e+01 -1.0241700172424316e+01 -9.5368499755859375e+01 1.9263999938964844e+01 -9.6255397796630859e+00 -9.5664001464843750e+01 1.8175401687622070e+01 -9.7290201187133789e+00 -6.1640899658203125e+01 1.0425000190734863e+01 -3.9616897106170654e+00 -6.1256801605224609e+01 1.1007900238037109e+01 -5.0008902549743652e+00 -6.1028400421142578e+01 1.0940000534057617e+01 -3.5944600105285645e+00 -6.0362701416015625e+01 1.2412300109863281e+01 -3.8142299652099609e+00 -6.0830898284912109e+01 1.1490600585937500e+01 -4.6984200477600098e+00 -6.0695499420166016e+01 1.2366300582885742e+01 -5.3090500831604004e+00 -6.0535999298095703e+01 1.1712599754333496e+01 -3.2430801391601562e+00 -6.1415000915527344e+01 1.1332499504089355e+01 -6.1296601295471191e+00 -6.2047298431396484e+01 1.1340100288391113e+01 -7.2632598876953125e+00 -6.1666099548339844e+01 1.2169400215148926e+01 -7.3382396697998047e+00 -6.2599899291992188e+01 1.0761500358581543e+01 -7.2886400222778320e+00 -6.1104301452636719e+01 1.2365699768066406e+01 -6.3779201507568359e+00 -6.3905403137207031e+01 9.9834995269775391e+00 -6.6251201629638672e+00 -6.2361698150634766e+01 1.0050799369812012e+01 -4.0647602081298828e+00 -6.3224800109863281e+01 9.8956604003906250e+00 -4.1209397315979004e+00 -6.4281700134277344e+01 9.9137601852416992e+00 -6.2162299156188965e+00 -6.2290500640869141e+01 1.0443200111389160e+01 -6.0588402748107910e+00 -6.3195800781250000e+01 1.0118500709533691e+01 -6.4187703132629395e+00 -6.2472702026367188e+01 1.2513899803161621e+01 -8.4688806533813477e+00 -6.2741802215576172e+01 1.1699199676513672e+01 -8.3473205566406250e+00 -6.5240798950195312e+01 1.0212999343872070e+01 -7.2388596534729004e+00 -6.4898796081542969e+01 9.9844198226928711e+00 -6.1325101852416992e+00 -6.3833900451660156e+01 1.0411499977111816e+01 -7.6742200851440430e+00 -6.4857902526855469e+01 9.9734296798706055e+00 6.2122802734375000e+00 -6.5789199829101562e+01 1.0287300109863281e+01 -6.7968602180480957e+00 -6.3911804199218750e+01 9.8958206176757812e+00 5.6185297966003418e+00 -6.0359798431396484e+01 1.2307199478149414e+01 3.6064600944519043e+00 -6.0628803253173828e+01 1.1578699111938477e+01 3.7531502246856689e+00 -6.1003398895263672e+01 1.0976799964904785e+01 3.6707999706268311e+00 -6.1652702331542969e+01 1.0380000114440918e+01 3.2844698429107666e+00 -6.2966400146484375e+01 9.9117994308471680e+00 3.9426000118255615e+00 -6.2402801513671875e+01 1.0049499511718750e+01 4.1836700439453125e+00 -6.2849601745605469e+01 2.0878900527954102e+01 4.6983399391174316e+00 -6.1999298095703125e+01 2.0687000274658203e+01 3.4147000312805176e+00 -6.2570995330810547e+01 2.0865400314331055e+01 -3.6086099147796631e+00 -6.1783802032470703e+01 2.0569799423217773e+01 -4.0062098503112793e+00 -6.1179801940917969e+01 2.0188600540161133e+01 3.4911398887634277e+00 -6.1094200134277344e+01 2.0112199783325195e+01 -3.4762198925018311e+00 -6.0759300231933594e+01 1.9701499938964844e+01 4.0063400268554688e+00 -6.0481601715087891e+01 1.9313299179077148e+01 -3.6495699882507324e+00 -6.0331798553466797e+01 1.8978799819946289e+01 3.8294301033020020e+00 -6.0145603179931641e+01 1.8248100280761719e+01 -3.5796301364898682e+00 -6.0149700164794922e+01 1.8183900833129883e+01 3.7242200374603271e+00 -6.1329101562500000e+01 1.8172399520874023e+01 -7.3941497802734375e+00 -6.1202499389648438e+01 1.9032899856567383e+01 -6.7604098320007324e+00 -6.0576999664306641e+01 1.8134300231933594e+01 -5.7871098518371582e+00 -6.0678703308105469e+01 1.9317298889160156e+01 -4.9355797767639160e+00 -6.0273300170898438e+01 1.8190299987792969e+01 -4.6072797775268555e+00 -6.2056499481201172e+01 1.8305599212646484e+01 -8.4032497406005859e+00 -6.2891201019287109e+01 1.8202999114990234e+01 -9.2903900146484375e+00 -6.2518798828125000e+01 1.9168001174926758e+01 -8.5312500000000000e+00 -6.1819400787353516e+01 1.9715000152587891e+01 -7.0366902351379395e+00 -6.3629402160644531e+01 1.9681400299072266e+01 -9.1858005523681641e+00 -6.2661094665527344e+01 2.0117799758911133e+01 -7.6399598121643066e+00 -6.1705501556396484e+01 2.0120000839233398e+01 -6.0299701690673828e+00 -6.1365299224853516e+01 2.0182001113891602e+01 -4.7702097892761230e+00 -6.3459999084472656e+01 2.0138601303100586e+01 -8.4642896652221680e+00 -6.5282203674316406e+01 2.0844699859619141e+01 -8.1589899063110352e+00 -6.5461898803710938e+01 2.0472999572753906e+01 -9.3470602035522461e+00 -6.7502799987792969e+01 2.0880699157714844e+01 -8.8870401382446289e+00 -6.4250900268554688e+01 2.0501499176025391e+01 -8.5253801345825195e+00 -6.3902801513671875e+01 2.0890598297119141e+01 -6.4770898818969727e+00 -6.2842899322509766e+01 2.0660999298095703e+01 -6.4450001716613770e+00 -6.7447898864746094e+01 1.9895900726318359e+01 -1.0701199531555176e+01 -6.8066703796386719e+01 2.0559700012207031e+01 -9.8929996490478516e+00 -6.6776199340820312e+01 2.0473899841308594e+01 -9.8433294296264648e+00 -6.8019004821777344e+01 1.8250000000000000e+01 -1.1477600097656250e+01 -6.6453102111816406e+01 1.9029800415039062e+01 -1.1013400077819824e+01 -6.6668197631835938e+01 1.8167299270629883e+01 -1.1279200553894043e+01 -6.8108795166015625e+01 1.9188899993896484e+01 -1.1208799362182617e+01 -6.5456893920898438e+01 1.8165899276733398e+01 -1.0892800331115723e+01 -6.4912101745605469e+01 1.9028398513793945e+01 -1.0428299903869629e+01 -6.4241897583007812e+01 1.8162601470947266e+01 -1.0295599937438965e+01 -6.5291099548339844e+01 1.9738498687744141e+01 -1.0151299476623535e+01 -6.3691497802734375e+01 1.9022300720214844e+01 -9.6710500717163086e+00 -6.6639404296875000e+01 1.0391200065612793e+01 7.4401497840881348e+00 -6.7378097534179688e+01 1.0396800041198730e+01 8.4291000366210938e+00 -6.8558403015136719e+01 1.0390600204467773e+01 8.9551897048950195e+00 -6.6518203735351562e+01 1.0381000518798828e+01 -7.0109400749206543e+00 -1.0655000305175781e+02 -9.0483503341674805e+00 -6.2500000000000000e+00 -1.0659600067138672e+02 -8.9703903198242188e+00 -9.1500005722045898e+00 -6.8878005981445312e+01 5.8127598762512207e+00 -8.5706300735473633e+00 -6.8101898193359375e+01 5.8599400520324707e+00 -8.1459197998046875e+00 -6.8941696166992188e+01 5.2135200500488281e+00 -7.9463496208190918e+00 -6.8069396972656250e+01 5.3750901222229004e+00 -7.2382197380065918e+00 -6.9012496948242188e+01 6.5341000556945801e+00 -8.9862108230590820e+00 -6.7782798767089844e+01 6.8296599388122559e+00 -8.5839900970458984e+00 -6.9165496826171875e+01 7.2737402915954590e+00 -9.1449699401855469e+00 -6.8384101867675781e+01 7.9007697105407715e+00 -9.0976705551147461e+00 -6.7704200744628906e+01 7.7998600006103516e+00 -8.8410501480102539e+00 -6.7219802856445312e+01 6.7383103370666504e+00 -7.9707598686218262e+00 -6.6955093383789062e+01 6.5843300819396973e+00 -7.2415699958801270e+00 -6.7004997253417969e+01 7.9977197647094727e+00 -8.2913408279418945e+00 -6.6569900512695312e+01 7.9542694091796875e+00 -7.5836801528930664e+00 -8.0766601562500000e+01 2.6834499835968018e+00 -9.1361703872680664e+00 -8.0020896911621094e+01 2.0557599067687988e+00 -8.8182601928710938e+00 -7.9667900085449219e+01 1.4880100488662720e+00 -8.2595100402832031e+00 -7.9713203430175781e+01 9.0127098560333252e-01 -7.5182800292968750e+00 -8.1314804077148438e+01 1.4700200557708740e+00 -9.0114593505859375e+00 -8.1178298950195312e+01 3.1777799129486084e-01 -8.5120792388916016e+00 -8.0600097656250000e+01 2.5520402193069458e-01 -7.9102797508239746e+00 -8.2784805297851562e+01 4.4402197003364563e-02 -9.1334791183471680e+00 -8.1941299438476562e+01 -2.4092900753021240e-01 -8.8169498443603516e+00 -8.1437797546386719e+01 -9.2610096931457520e-01 -8.2673997879028320e+00 -8.1758094787597656e+01 -3.0187301635742188e+00 -8.1118698120117188e+00 -8.2164199829101562e+01 -2.6206700801849365e+00 -8.6233196258544922e+00 -8.2902999877929688e+01 -2.6529698371887207e+00 -9.0108594894409180e+00 -8.3766494750976562e+01 -3.3219201564788818e+00 -9.1485605239868164e+00 -8.3335899353027344e+01 -4.5836100578308105e+00 -8.8279705047607422e+00 -8.2762893676757812e+01 -4.9265799522399902e+00 -8.2738695144653320e+00 -8.2385002136230469e+01 -5.1509799957275391e+00 -7.5249400138854980e+00 -8.5538703918457031e+01 -6.0334100723266602e+00 -9.1193103790283203e+00 -8.4640304565429688e+01 -6.3338699340820312e+00 -8.8090000152587891e+00 -8.4188796997070312e+01 -6.8161702156066895e+00 -8.2442798614501953e+00 -1.0439299774169922e+02 -2.1178501129150391e+01 -9.0887203216552734e+00 -1.0403299713134766e+02 -2.1799600601196289e+01 -8.8098001480102539e+00 -1.0300900268554688e+02 -2.1867799758911133e+01 -8.2513504028320312e+00 -1.0275500488281250e+02 -2.2213001251220703e+01 -7.4874601364135742e+00 -1.0447800445556641e+02 -2.2709800720214844e+01 -8.2735300064086914e+00 -1.0429399871826172e+02 -2.3108600616455078e+01 -7.5249996185302734e+00 -1.0652499389648438e+02 -9.0833702087402344e+00 6.2500000000000000e+00 -1.0879199981689453e+02 -9.1968107223510742e+00 6.2500000000000000e+00 -1.0652100372314453e+02 -8.5220699310302734e+00 6.2500000000000000e+00 -1.1179100036621094e+02 -9.5880804061889648e+00 6.2500000000000000e+00 -1.1489099884033203e+02 -9.5263805389404297e+00 6.2500000000000000e+00 -1.1528500366210938e+02 -9.8146600723266602e+00 6.2500000000000000e+00 -1.1534700012207031e+02 -9.8796491622924805e+00 6.2500000000000000e+00 -1.0652600097656250e+02 -9.0829801559448242e+00 9.1500005722045898e+00 -1.0653000640869141e+02 -8.5469398498535156e+00 9.1500005722045898e+00 -1.0649300384521484e+02 -8.5030593872070312e+00 -6.2500000000000000e+00 -1.0643299865722656e+02 -8.4661493301391602e+00 -9.1500005722045898e+00 -1.1463999938964844e+02 -9.5075397491455078e+00 -6.2500000000000000e+00 -1.1074099731445312e+02 -9.5356006622314453e+00 -6.2500000000000000e+00 -1.0459899902343750e+02 -2.2849300384521484e+01 8.1906995773315430e+00 -1.0481200408935547e+02 -2.1987098693847656e+01 8.9133701324462891e+00 -1.0357700347900391e+02 -2.0572999954223633e+01 9.1288499832153320e+00 -1.0290700531005859e+02 -2.1414701461791992e+01 8.5791702270507812e+00 -1.0255799865722656e+02 -2.1847799301147461e+01 7.9297304153442383e+00 -8.5285697937011719e+01 -5.3565101623535156e+00 9.1531400680541992e+00 -8.6191101074218750e+01 -5.9746003150939941e+00 9.1500005722045898e+00 -8.4434997558593750e+01 -7.4523196220397949e+00 7.7178397178649902e+00 -9.3737998962402344e+01 -1.4706799507141113e+01 8.4361400604248047e+00 -8.4648101806640625e+01 -6.3001999855041504e+00 8.8215703964233398e+00 -8.4215202331542969e+01 -5.1858601570129395e+00 9.0355100631713867e+00 -8.3408996582031250e+01 -1.5781799554824829e+00 9.1507396697998047e+00 -8.2511795043945312e+01 -2.3564100265502930e+00 8.9124402999877930e+00 -8.2423698425292969e+01 -6.5717399120330811e-01 8.9903802871704102e+00 -8.2372299194335938e+01 -5.1327199935913086e+00 7.5182700157165527e+00 -8.2866104125976562e+01 -4.8270797729492188e+00 8.4458894729614258e+00 -8.4181701660156250e+01 -6.7181601524353027e+00 8.2935199737548828e+00 -8.4635505676269531e+01 -7.3326001167297363e+00 8.0918207168579102e+00 -7.9508697509765625e+01 1.3220299482345581e+00 7.9454097747802734e+00 -8.0807800292968750e+01 4.0625399351119995e-01 8.2731399536132812e+00 -7.9835494995117188e+01 1.7615299224853516e+00 8.5770492553710938e+00 -8.1352302551269531e+01 7.9768502712249756e-01 8.8287897109985352e+00 -8.0248199462890625e+01 2.4152600765228271e+00 9.0147600173950195e+00 -8.2238693237304688e+01 1.0475699901580811e+00 9.1326198577880859e+00 -8.0497398376464844e+01 3.0117800235748291e+00 9.1439599990844727e+00 -8.0731506347656250e+01 -3.0195799469947815e-01 7.5233402252197266e+00 -6.8582801818847656e+01 5.3629498481750488e+00 7.9397101402282715e+00 -6.8881599426269531e+01 5.8094701766967773e+00 8.5697393417358398e+00 -6.8847198486328125e+01 6.6348700523376465e+00 8.9898700714111328e+00 -6.9246902465820312e+01 7.1703696250915527e+00 9.1396703720092773e+00 -6.8069396972656250e+01 5.3750901222229004e+00 7.2382502555847168e+00 -6.7967201232910156e+01 6.5680298805236816e+00 8.5666704177856445e+00 -6.7570594787597656e+01 6.2374300956726074e+00 7.9708199501037598e+00 -6.7335296630859375e+01 6.0413298606872559e+00 7.2416000366210938e+00 -6.7046905517578125e+01 7.3667497634887695e+00 8.1459798812866211e+00 -6.6710304260253906e+01 7.2175598144531250e+00 7.4390296936035156e+00 -9.3670799255371094e+01 2.0848899841308594e+01 8.3173599243164062e+00 -9.3062400817871094e+01 2.0889600753784180e+01 8.6832695007324219e+00 -9.4475296020507812e+01 2.0568099975585938e+01 8.2652196884155273e+00 -9.5187599182128906e+01 2.0061500549316406e+01 8.3796195983886719e+00 -9.5581100463867188e+01 1.9595699310302734e+01 8.4368000030517578e+00 -9.5950202941894531e+01 1.8861299514770508e+01 8.5076694488525391e+00 -9.6091598510742188e+01 1.8124500274658203e+01 8.5547199249267578e+00 -9.2733894348144531e+01 1.3036300659179688e+01 -1.1314899444580078e+01 -9.3509201049804688e+01 1.2771699905395508e+01 -1.1148099899291992e+01 -9.4322799682617188e+01 1.2947400093078613e+01 -1.0788499832153320e+01 -9.5096099853515625e+01 1.3248800277709961e+01 -1.0142100334167480e+01 -9.5897506713867188e+01 1.2896499633789062e+01 -8.4291496276855469e+00 -9.5564300537109375e+01 1.2914200782775879e+01 -9.4243803024291992e+00 -6.3192703247070312e+01 1.2891500473022461e+01 -9.2307596206665039e+00 -6.4513099670410156e+01 1.3146400451660156e+01 -1.0202899932861328e+01 -6.6488899230957031e+01 1.2884799957275391e+01 -1.1013099670410156e+01 -6.8109695434570312e+01 1.3013999938964844e+01 -1.1299399375915527e+01 -6.5641593933105469e+01 1.0540900230407715e+01 -8.5027809143066406e+00 -6.4671798706054688e+01 1.0553799629211426e+01 -8.2588300704956055e+00 -6.5173202514648438e+01 1.1195799827575684e+01 -9.5083999633789062e+00 -6.3850902557373047e+01 1.2335700035095215e+01 -9.5917797088623047e+00 -6.4128501892089844e+01 1.1689200401306152e+01 -9.3995904922485352e+00 -6.5116004943847656e+01 1.2520500183105469e+01 -1.0389900207519531e+01 -6.5758300781250000e+01 1.1837399482727051e+01 -1.0338700294494629e+01 -6.6464500427246094e+01 1.0906100273132324e+01 -9.6689691543579102e+00 -6.3610897064208984e+01 1.1091800689697266e+01 -8.5185594558715820e+00 -6.6167900085449219e+01 1.0398699760437012e+01 -7.9767799377441406e+00 -6.2467800140380859e+01 1.1268300056457520e+01 7.7261500358581543e+00 -6.1838798522949219e+01 1.2272899627685547e+01 7.6358799934387207e+00 -6.2593101501464844e+01 1.1978600502014160e+01 8.3717203140258789e+00 -6.3545398712158203e+01 1.0006099700927734e+01 6.3585700988769531e+00 -6.2917201995849609e+01 1.0279500007629395e+01 6.5945401191711426e+00 -6.4087898254394531e+01 1.0062999725341797e+01 6.9385199546813965e+00 -6.3364795684814453e+01 1.0512000083923340e+01 7.5604901313781738e+00 -6.2347198486328125e+01 1.0855699539184570e+01 7.0596799850463867e+00 -6.1525798797607422e+01 1.1299500465393066e+01 6.3326201438903809e+00 -6.1499397277832031e+01 1.1783800125122070e+01 6.7678098678588867e+00 -6.1221202850341797e+01 1.2550399780273438e+01 6.6556100845336914e+00 -6.6212104797363281e+01 1.0403900146484375e+01 8.0452194213867188e+00 -6.6002197265625000e+01 1.0354200363159180e+01 7.3951301574707031e+00 -6.1782299041748047e+01 1.0559800148010254e+01 5.2923297882080078e+00 -6.0674999237060547e+01 1.2354599952697754e+01 5.2776899337768555e+00 -6.1002899169921875e+01 1.1452499389648438e+01 5.1973299980163574e+00 -6.2865303039550781e+01 1.8152999877929688e+01 9.2703104019165039e+00 -6.3542903900146484e+01 1.9026599884033203e+01 9.5700607299804688e+00 -6.3911899566650391e+01 1.8160499572753906e+01 1.0083099365234375e+01 -6.4932998657226562e+01 1.9028398513793945e+01 1.0438500404357910e+01 -6.5083602905273438e+01 1.8163599014282227e+01 1.0737700462341309e+01 -6.8084594726562500e+01 1.8238901138305664e+01 1.1481900215148926e+01 -6.6696098327636719e+01 1.9317298889160156e+01 1.0944100379943848e+01 -6.8112800598144531e+01 1.9189100265502930e+01 1.1208999633789062e+01 -6.6610595703125000e+01 1.8187299728393555e+01 1.1270100593566895e+01 -6.2587501525878906e+01 1.9317298889160156e+01 8.5163793563842773e+00 -6.4965301513671875e+01 1.9671701431274414e+01 1.0067800521850586e+01 -6.4137504577636719e+01 2.0114099502563477e+01 9.0809097290039062e+00 -6.8143798828125000e+01 1.9980400085449219e+01 1.0664299964904785e+01 -6.7360702514648438e+01 2.0325500488281250e+01 1.0215700149536133e+01 -6.2951496124267578e+01 2.0212200164794922e+01 7.8240799903869629e+00 -6.3676296234130859e+01 2.0879798889160156e+01 6.3429899215698242e+00 -6.7528594970703125e+01 2.0886798858642578e+01 8.7112894058227539e+00 -6.5104995727539062e+01 2.0866199493408203e+01 7.9224696159362793e+00 -6.3572601318359375e+01 2.0637199401855469e+01 7.5048704147338867e+00 -6.2261699676513672e+01 2.0642299652099609e+01 5.2907700538635254e+00 -6.5791603088378906e+01 2.0477001190185547e+01 9.4930295944213867e+00 -6.7668601989746094e+01 2.0770900726318359e+01 9.3475894927978516e+00 -6.4894996643066406e+01 2.0623199462890625e+01 8.6585197448730469e+00 -6.0366298675537109e+01 1.8139200210571289e+01 5.0881099700927734e+00 -6.0722499847412109e+01 1.8731399536132812e+01 5.8447499275207520e+00 -6.1084197998046875e+01 1.9590000152587891e+01 5.7146601676940918e+00 -6.1696899414062500e+01 2.0292400360107422e+01 5.4823598861694336e+00 -6.1519702911376953e+01 1.9022199630737305e+01 7.2866196632385254e+00 -6.0968997955322266e+01 1.8159299850463867e+01 6.7200498580932617e+00 -6.1844501495361328e+01 1.9715000152587891e+01 7.0786099433898926e+00 -6.1798400878906250e+01 1.8179298400878906e+01 8.0919799804687500e+00 -9.4956199645996094e+01 1.9852399826049805e+01 9.5523796081542969e+00 -9.4453796386718750e+01 2.0476699829101562e+01 8.9710702896118164e+00 -9.5729797363281250e+01 1.8588001251220703e+01 9.4496603012084961e+00 -9.5338096618652344e+01 1.9318201065063477e+01 9.6174697875976562e+00 -9.5275199890136719e+01 1.8673000335693359e+01 1.0142399787902832e+01 -9.3161399841308594e+01 2.0778799057006836e+01 9.3056592941284180e+00 -9.3839492797851562e+01 2.0395500183105469e+01 9.8352499008178711e+00 -9.4051506042480469e+01 1.9846000671386719e+01 1.0406599998474121e+01 -9.3038200378417969e+01 1.9844099044799805e+01 1.0789899826049805e+01 -9.2919799804687500e+01 2.0447200775146484e+01 1.0065799713134766e+01 -9.5639495849609375e+01 1.7997301101684570e+01 9.8040399551391602e+00 -9.4895103454589844e+01 1.8177099227905273e+01 1.0668899536132812e+01 -9.3024902343750000e+01 1.8078800201416016e+01 1.1482800483703613e+01 -9.2970001220703125e+01 1.8775999069213867e+01 1.1366900444030762e+01 -9.3774696350097656e+01 1.8176700592041016e+01 1.1310899734497070e+01 -9.4405502319335938e+01 1.8309900283813477e+01 1.1005100250244141e+01 -9.3781997680664062e+01 1.9160699844360352e+01 1.1028399467468262e+01 -9.4629699707031250e+01 1.9244899749755859e+01 1.0483499526977539e+01 -6.7091796875000000e+01 1.0387100219726562e+01 -8.2227993011474609e+00 -6.8684898376464844e+01 1.0267600059509277e+01 -9.1260995864868164e+00 -6.6537399291992188e+01 1.0284700393676758e+01 -7.5106997489929199e+00 -6.6952499389648438e+01 1.0204899787902832e+01 -8.2621393203735352e+00 -6.7445297241210938e+01 1.0284399986267090e+01 -8.6767597198486328e+00 -6.8003402709960938e+01 1.0204400062561035e+01 -9.0006399154663086e+00 -9.4780799865722656e+01 1.0342499732971191e+01 -9.0948200225830078e+00 -9.5615997314453125e+01 7.4379100799560547e+00 -9.1500005722045898e+00 -9.5754699707031250e+01 9.3954296112060547e+00 -9.1500005722045898e+00 -9.9812004089355469e+01 -3.8179500102996826e+00 -9.1500005722045898e+00 -9.7460502624511719e+01 -3.4211501479148865e-01 -9.1500005722045898e+00 -9.6030395507812500e+01 3.6031599044799805e+00 -9.1500005722045898e+00 -1.0294199371337891e+02 -6.6133403778076172e+00 -9.1500005722045898e+00 -1.0354500579833984e+02 -7.0583600997924805e+00 9.1500005722045898e+00 -9.5741798400878906e+01 9.4041604995727539e+00 9.1500005722045898e+00 -9.5690200805664062e+01 5.6777200698852539e+00 9.1500005722045898e+00 -9.6326698303222656e+01 2.5946600437164307e+00 9.1500005722045898e+00 -9.7460502624511719e+01 -3.4211501479148865e-01 9.1500005722045898e+00 -9.9812004089355469e+01 -3.8179500102996826e+00 9.1500005722045898e+00 -9.4780197143554688e+01 1.0343600273132324e+01 9.0943698883056641e+00 -9.5914100646972656e+01 1.2885900497436523e+01 8.1875104904174805e+00 -9.2767204284667969e+01 1.0443500518798828e+01 -8.9088096618652344e+00 -9.3540496826171875e+01 1.0453800201416016e+01 -8.3829898834228516e+00 -9.2991600036621094e+01 1.0611999511718750e+01 -9.4347295761108398e+00 -9.3684799194335938e+01 1.0865900039672852e+01 -9.6164999008178711e+00 -9.3108398437500000e+01 1.0393699645996094e+01 -7.8538393974304199e+00 -9.2875503540039062e+01 1.1119400024414062e+01 -1.0302600860595703e+01 -9.3976898193359375e+01 1.1336700439453125e+01 -1.0092399597167969e+01 -9.4118400573730469e+01 1.1921799659729004e+01 -1.0509799957275391e+01 -9.2803398132324219e+01 1.2278599739074707e+01 -1.1129500389099121e+01 -9.4789199829101562e+01 1.1336400032043457e+01 -9.2163696289062500e+00 -9.4345397949218750e+01 1.0851400375366211e+01 -8.8078298568725586e+00 -9.5200096130371094e+01 1.1399000167846680e+01 -8.2679204940795898e+00 -9.5081802368164062e+01 1.2056799888610840e+01 -9.7091798782348633e+00 -9.5445701599121094e+01 1.1953700065612793e+01 -8.8719797134399414e+00 -9.5723701477050781e+01 1.2212299346923828e+01 -8.0698595046997070e+00 -9.4766296386718750e+01 1.2548900604248047e+01 -1.0349299430847168e+01 -9.4426605224609375e+01 1.0768700599670410e+01 -8.1309795379638672e+00 -9.2969200134277344e+01 1.1712499618530273e+01 -1.0805199623107910e+01 -6.7538795471191406e+01 1.1655799865722656e+01 -1.0740300178527832e+01 -6.7675102233886719e+01 1.0599900245666504e+01 -9.4035396575927734e+00 -6.8163200378417969e+01 1.2221399307250977e+01 -1.1092700004577637e+01 -6.8055099487304688e+01 1.1065199851989746e+01 -1.0230899810791016e+01 -6.8276100158691406e+01 1.0440400123596191e+01 -8.9049005508422852e+00 -6.5624801635742188e+01 1.2907999992370605e+01 1.0718899726867676e+01 -6.5133201599121094e+01 1.2643300056457520e+01 1.0425600051879883e+01 -6.4267204284667969e+01 1.3000999450683594e+01 1.0042300224304199e+01 -6.2303199768066406e+01 1.2680799484252930e+01 8.3036804199218750e+00 -6.3390201568603516e+01 1.1651099205017090e+01 8.8691902160644531e+00 -6.4303298950195312e+01 1.1275300025939941e+01 9.1667203903198242e+00 -6.4761100769042969e+01 1.0851999282836914e+01 8.8473796844482422e+00 -6.5631797790527344e+01 1.0486500740051270e+01 8.3171300888061523e+00 -6.5605400085449219e+01 1.1897500038146973e+01 1.0314599990844727e+01 -6.4388298034667969e+01 1.2194299697875977e+01 9.8595495223999023e+00 -6.3178600311279297e+01 1.2712699890136719e+01 9.2077093124389648e+00 -6.5609100341796875e+01 1.0742199897766113e+01 8.9996404647827148e+00 -6.6827606201171875e+01 1.3214099884033203e+01 1.1109299659729004e+01 -6.8150299072265625e+01 1.2829500198364258e+01 1.1287300109863281e+01 -9.5783393859863281e+01 1.2894499778747559e+01 8.8829793930053711e+00 -9.5408401489257812e+01 1.2947400093078613e+01 9.7028608322143555e+00 -9.4762306213378906e+01 1.3247200012207031e+01 1.0475899696350098e+01 -9.4044403076171875e+01 1.2914200782775879e+01 1.0944300651550293e+01 -9.3054199218750000e+01 1.2910599708557129e+01 1.1280300140380859e+01 -6.8154998779296875e+01 1.0390000343322754e+01 -8.9144802093505859e+00 -9.5694496154785156e+01 1.2157899856567383e+01 8.2170896530151367e+00 -9.5115501403808594e+01 1.1302899360656738e+01 8.2818202972412109e+00 -9.4288604736328125e+01 1.0711600303649902e+01 8.3680400848388672e+00 -9.3305107116699219e+01 1.0405999183654785e+01 8.3051605224609375e+00 -6.6861396789550781e+01 1.1230699539184570e+01 1.0218200683593750e+01 -6.7718498229980469e+01 1.0555000305175781e+01 9.3031597137451172e+00 -6.6954704284667969e+01 1.2355299949645996e+01 1.0972000122070312e+01 -6.8097000122070312e+01 1.1831899642944336e+01 1.0898099899291992e+01 -6.8167404174804688e+01 1.1026800155639648e+01 1.0180800437927246e+01 -9.3028099060058594e+01 1.0487699508666992e+01 9.0319404602050781e+00 -9.4236503601074219e+01 1.0865900039672852e+01 9.0648107528686523e+00 -9.4712402343750000e+01 1.1336700439453125e+01 9.3568792343139648e+00 -9.4869003295898438e+01 1.1888800621032715e+01 9.8110904693603516e+00 -9.5405403137207031e+01 1.1966600418090820e+01 8.9950094223022461e+00 -9.2892494201660156e+01 1.1598400115966797e+01 1.0732900619506836e+01 -9.3836395263671875e+01 1.1336400032043457e+01 1.0169199943542480e+01 -9.2781700134277344e+01 1.1079999923706055e+01 1.0256199836730957e+01 -9.3148902893066406e+01 1.0728499412536621e+01 9.6660299301147461e+00 -9.4224105834960938e+01 1.2082500457763672e+01 1.0541100502014160e+01 -9.3492004394531250e+01 1.1953700065612793e+01 1.0825699806213379e+01 -9.2700401306152344e+01 1.2215199470520020e+01 1.1101500511169434e+01 -9.4969200134277344e+01 1.2548900604248047e+01 1.0146300315856934e+01 -9.4030799865722656e+01 -1.4237500190734863e+01 8.9692401885986328e+00 -9.3823699951171875e+01 -1.4584000587463379e+01 8.7680501937866211e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00) (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00) (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00) (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00) (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_gripper_r_finger_tip_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_shoulder_lift_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.0000000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 200 100 0 100 1 0 2 200 0 100 70 1 1 70 369 2 1 361 369 361 1 99 70 100 99 100 117 217 117 100 100 200 217 343 99 117 217 258 117 117 258 343 105 342 343 343 338 340 99 343 340 342 356 343 343 356 338 343 258 408 408 106 343 105 343 106 338 339 340 340 442 99 442 340 339 339 441 442 442 223 225 442 446 223 99 442 225 441 446 442 225 451 99 99 451 70 223 224 225 258 225 224 225 258 424 451 225 424 330 224 223 330 223 446 312 224 330 312 258 224 311 258 312 258 311 408 217 424 258 216 424 217 424 216 191 451 424 191 49 216 217 217 200 85 84 217 85 49 217 84 49 192 216 191 216 192 191 192 193 48 359 192 48 192 49 280 192 359 193 192 280 166 193 280 166 295 193 295 414 193 414 191 193 359 166 280 359 91 360 359 48 91 360 166 359 2 166 167 166 2 295 167 166 360 360 233 289 91 233 360 167 360 289 91 48 50 110 91 50 233 91 110 289 233 290 341 290 233 233 110 341 156 110 50 156 157 110 157 341 110 156 406 157 50 406 156 406 341 157 406 50 407 407 341 406 399 407 390 341 407 399 391 407 98 98 407 50 390 407 391 341 399 400 400 399 418 390 484 399 418 399 484 390 391 175 390 175 484 391 98 97 391 97 175 50 97 98 49 97 50 175 97 372 84 97 49 97 279 372 279 97 84 48 49 50 83 84 85 279 84 405 405 84 83 278 146 279 279 146 372 279 405 278 153 146 278 153 278 405 405 484 175 405 83 418 153 405 175 484 405 418 153 154 155 154 153 175 155 152 153 153 152 146 155 154 331 154 175 331 331 175 332 140 332 175 140 175 372 332 155 331 145 155 332 152 155 145 152 141 146 145 141 152 140 139 145 140 145 332 139 141 145 139 140 141 140 146 141 140 372 146 418 83 419 302 400 418 419 302 418 85 301 83 419 83 303 83 301 303 303 302 419 301 302 303 341 302 290 400 302 341 301 290 302 85 289 301 289 290 301 200 289 85 200 167 289 200 2 167 2 361 295 361 362 363 361 402 362 295 361 363 369 402 361 363 414 295 438 414 363 438 363 362 438 439 414 414 439 191 305 439 438 362 490 438 490 305 438 451 439 305 191 439 451 305 307 451 70 451 307 305 306 307 378 71 307 468 378 307 307 306 468 307 71 70 69 70 71 69 369 70 71 364 69 378 364 71 364 378 379 387 69 364 387 364 379 386 170 387 387 170 287 386 387 379 287 69 387 168 170 386 168 386 379 168 169 170 168 379 4 4 174 168 174 169 168 173 169 174 170 169 173 226 173 174 174 4 226 3 4 5 4 3 7 4 379 5 226 4 7 173 226 7 6 170 173 7 6 173 6 7 8 3 8 7 6 8 3 5 6 3 379 6 5 378 6 379 6 378 170 286 287 170 468 286 170 378 468 170 368 423 286 423 287 286 368 286 468 287 423 416 69 287 416 416 423 472 368 472 423 69 416 417 417 416 434 434 416 472 69 402 369 487 486 69 402 69 486 69 417 487 487 417 434 486 487 488 488 487 434 434 382 469 472 382 434 469 488 434 472 368 382 305 367 368 368 367 382 306 305 368 368 468 306 367 305 383 383 305 490 382 367 383 362 382 383 362 383 490 402 382 362 382 402 403 403 402 486 382 403 469 469 403 486 469 486 488 408 311 445 408 445 443 408 443 106 445 311 312 445 312 330 445 330 444 443 445 444 352 443 444 352 106 443 446 447 444 447 352 444 444 330 446 339 106 352 339 352 447 441 447 446 339 447 441 221 339 338 339 221 106 106 221 104 338 461 221 221 461 104 356 342 338 208 338 342 461 338 208 437 461 321 461 208 321 461 179 104 179 461 437 104 105 106 105 104 179 199 105 179 199 179 206 437 323 179 179 323 206 321 323 437 321 322 323 323 232 206 323 429 232 429 323 322 206 207 208 206 232 207 199 206 208 208 342 199 105 199 342 321 208 207 207 232 242 244 207 242 244 321 207 321 243 401 401 429 321 244 243 321 321 429 322 243 244 245 288 245 244 288 244 425 242 425 244 242 232 425 232 231 425 231 288 425 463 245 288 231 463 288 463 52 245 52 63 245 63 243 245 231 462 463 462 52 463 230 231 232 230 462 231 429 230 232 230 429 401 230 320 291 401 320 230 65 230 63 230 65 462 230 291 63 320 243 291 401 243 320 291 243 63 63 64 65 64 63 46 46 63 47 47 63 52 459 64 46 64 459 108 64 108 65 459 46 241 241 10 459 459 33 108 10 33 459 241 46 11 10 241 11 9 10 11 9 448 10 448 33 10 11 46 45 45 9 11 9 40 39 51 448 9 9 39 51 40 9 45 51 33 448 51 39 52 33 51 52 39 40 41 47 39 41 39 47 52 45 41 40 45 46 47 45 47 41 52 462 33 65 34 462 462 34 33 33 34 35 108 33 35 433 35 34 433 435 35 309 35 435 108 35 309 107 108 109 109 108 309 65 108 485 485 108 107 347 431 309 435 347 309 309 431 109 347 435 433 347 433 346 34 346 433 346 235 347 235 432 347 347 432 431 431 432 75 431 485 107 109 431 107 431 75 485 75 65 485 34 75 76 131 75 432 65 75 34 76 75 131 131 432 497 497 432 235 80 131 81 131 308 81 76 131 80 131 497 308 497 235 265 497 265 308 308 73 72 265 73 308 72 81 308 80 81 82 81 72 82 72 73 74 236 72 375 236 82 72 375 72 74 264 304 73 264 73 265 304 74 73 344 74 304 344 375 74 236 375 234 264 375 344 436 375 264 375 436 234 263 264 265 304 264 344 436 264 263 235 436 263 235 234 436 76 234 235 236 234 237 234 76 237 235 263 265 346 76 235 76 80 237 34 76 346 237 269 240 237 80 269 236 237 240 316 80 129 269 80 316 129 80 82 315 316 317 394 316 315 316 394 269 316 129 317 82 128 129 129 128 317 236 128 82 236 240 239 236 239 128 128 176 317 239 176 128 315 317 176 394 315 176 270 394 247 394 270 269 394 176 178 394 178 247 176 177 178 318 176 239 177 176 318 178 246 247 177 246 178 389 247 246 270 247 470 470 247 389 395 246 177 395 389 246 420 177 318 420 395 177 409 410 395 409 395 420 68 395 410 68 389 395 420 318 421 409 420 491 470 491 420 420 421 470 270 470 421 421 318 270 269 270 271 271 270 318 269 319 238 319 269 271 238 240 269 318 319 271 318 239 319 238 319 239 238 239 240 470 389 336 470 336 491 389 67 336 67 389 68 66 67 68 67 66 133 67 133 336 410 66 68 410 493 66 493 133 66 479 480 410 479 410 409 410 480 493 480 133 493 427 480 428 371 480 427 480 479 428 371 133 480 494 132 479 479 409 494 132 428 479 491 492 409 337 494 409 492 337 409 494 337 132 336 132 337 336 337 492 491 336 492 336 133 132 132 133 134 134 133 371 427 134 371 132 134 92 92 134 328 326 134 427 134 326 328 326 327 328 327 92 328 351 215 326 326 215 327 326 427 351 94 427 428 427 94 351 94 215 351 114 215 94 327 215 313 215 116 313 116 215 114 93 92 327 313 93 327 313 165 93 313 116 165 163 164 165 165 116 59 59 388 165 165 164 93 163 165 257 257 165 388 252 93 164 163 15 164 15 252 164 251 185 252 115 114 252 252 181 354 252 185 115 93 252 114 15 181 252 251 252 354 114 115 116 93 114 94 92 93 94 92 94 329 94 428 329 132 92 329 132 329 428 458 116 404 115 404 116 458 59 116 204 115 205 115 185 205 204 404 115 415 298 204 204 54 404 415 204 205 298 54 204 187 186 205 205 186 415 185 187 205 185 186 187 186 185 251 251 78 186 186 370 392 392 415 186 78 370 186 182 251 354 79 251 182 78 251 79 77 78 79 77 267 78 267 370 78 392 370 393 370 267 393 392 393 38 415 392 38 36 38 393 393 267 36 36 37 38 267 37 36 60 267 77 37 267 62 62 267 60 37 374 210 37 210 38 374 37 62 60 61 62 373 374 62 474 62 61 62 474 373 374 373 411 374 411 456 374 456 210 373 118 111 450 373 474 450 118 373 373 111 411 474 61 365 474 457 450 365 457 474 449 248 450 457 449 450 467 118 450 450 248 467 385 384 457 385 457 366 457 365 366 457 384 449 365 260 366 260 365 61 212 366 262 385 366 212 260 262 366 212 384 385 26 25 212 26 212 476 412 384 212 476 212 498 299 300 212 483 212 300 498 212 262 25 299 212 412 212 483 498 261 476 26 476 284 261 284 476 262 261 498 260 261 262 358 136 261 136 284 261 261 260 358 357 358 260 136 358 460 460 358 357 135 86 136 135 136 102 136 86 284 102 136 460 87 86 135 87 135 102 13 86 87 86 159 284 159 86 13 266 87 102 266 13 87 101 102 103 101 266 102 103 102 460 16 266 180 14 13 266 180 266 101 266 16 14 17 180 181 180 101 181 180 17 16 15 16 17 15 17 181 14 16 53 53 16 32 16 15 32 12 13 14 12 14 53 53 32 31 501 12 53 31 501 53 30 31 32 15 314 32 32 314 30 314 15 163 163 142 314 314 142 30 142 283 30 283 31 30 142 143 144 257 143 142 142 144 283 163 257 142 283 253 31 283 144 253 159 158 253 254 253 277 254 159 253 228 277 253 144 228 253 31 253 158 158 159 13 159 254 284 158 501 31 158 13 501 13 12 501 284 130 26 284 254 29 284 29 130 24 25 26 345 138 26 26 130 345 26 138 24 137 24 138 24 137 25 299 25 43 25 137 43 137 345 43 137 138 345 345 130 198 465 345 198 465 477 345 477 43 345 130 197 198 197 465 198 454 465 353 471 465 454 477 465 471 465 197 353 43 477 44 44 477 464 477 471 464 471 454 464 44 464 95 453 464 454 464 453 95 42 43 44 95 96 44 44 96 42 42 482 43 42 96 482 426 195 43 426 43 482 43 195 299 495 426 482 482 96 201 201 495 482 397 426 495 495 201 397 196 195 426 426 335 196 335 426 397 397 203 398 201 203 397 398 335 397 201 202 203 201 478 202 96 478 201 203 202 285 285 202 478 478 96 190 190 143 478 143 285 478 190 96 95 95 143 190 259 143 95 143 257 285 143 259 144 388 203 285 257 388 285 203 388 58 59 58 388 203 273 398 58 273 203 57 58 59 58 272 273 57 496 58 496 272 58 57 59 458 376 57 377 57 458 452 376 496 57 57 452 377 348 458 404 350 458 348 452 458 350 377 452 220 452 350 220 220 333 377 333 376 377 333 496 376 333 222 162 334 333 162 222 333 220 333 334 499 333 499 496 219 222 220 219 162 222 218 219 220 219 218 276 249 219 276 219 160 162 219 249 160 274 276 218 274 218 220 274 275 276 350 349 274 350 274 220 275 274 349 55 275 56 276 275 455 455 275 55 56 275 349 348 349 350 54 349 404 404 349 348 56 349 54 54 55 56 54 298 209 54 209 500 55 54 500 209 210 211 209 298 210 209 211 500 310 500 21 21 500 211 500 324 55 324 500 310 310 21 255 324 310 325 489 325 310 489 310 255 297 324 325 297 55 324 296 55 297 296 455 55 250 296 297 325 250 297 489 250 325 489 256 250 489 255 256 255 21 256 213 118 256 213 256 21 118 467 256 467 250 256 248 249 250 250 249 296 248 250 467 449 249 248 449 160 249 276 296 249 384 160 449 160 161 162 160 384 413 161 160 413 412 413 384 422 413 412 396 161 413 396 413 422 162 161 396 334 162 396 300 194 396 300 396 483 396 194 334 483 396 422 412 483 422 334 196 335 196 334 194 335 499 334 194 195 196 195 194 300 299 195 300 496 499 273 499 335 273 398 273 335 272 496 273 276 455 296 112 118 119 118 213 214 430 119 118 111 118 112 214 430 118 292 293 119 430 292 119 119 293 112 292 430 214 214 121 292 211 293 292 121 22 292 292 21 211 22 21 292 112 293 113 293 211 113 211 210 113 111 112 113 456 111 113 456 113 210 298 20 210 210 19 38 210 20 19 298 18 20 298 415 281 298 281 18 18 19 20 19 281 38 19 18 281 38 281 415 411 111 456 21 22 23 213 21 23 23 22 123 120 22 121 123 22 120 23 123 122 124 23 122 213 23 124 213 227 214 172 227 213 213 124 172 171 172 124 122 171 124 120 121 122 171 122 121 122 123 120 171 121 214 171 214 227 227 172 171 28 144 282 229 144 28 229 228 144 259 282 144 27 228 229 28 27 229 228 27 254 473 228 254 481 228 473 228 481 277 27 28 29 254 27 29 473 254 277 473 277 481 29 28 89 130 29 89 88 89 90 88 130 89 28 282 89 89 282 90 197 130 353 353 130 88 466 454 353 466 353 88 88 381 466 381 454 466 380 453 454 454 381 380 380 381 88 440 259 380 380 259 453 148 380 88 148 440 380 259 95 453 282 259 440 148 282 440 294 282 150 282 294 90 148 150 282 150 147 151 147 150 148 188 294 150 188 150 151 147 148 149 151 147 189 189 147 149 188 151 189 126 188 189 125 188 126 294 188 125 189 149 148 126 189 148 125 126 127 127 126 148 127 294 125 88 294 127 127 148 88 90 294 88 181 101 354 355 354 101 355 101 103 268 354 355 268 182 354 183 268 355 183 355 103 183 182 268 182 183 184 79 182 103 182 184 103 460 77 103 77 79 103 184 183 103 460 260 60 460 357 260 60 77 460 475 60 260 475 260 61 475 61 60))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(2.3470200598239899e-01 1.0800000280141830e-01 -7.3000000000000000e+01 1.2431000471115112e+00 -1.5290900230407715e+01 -7.1712203979492188e+01 2.1000000000000000e+01 1.0800000280141830e-01 -7.3000000000000000e+01 1.8000000000000000e+01 -7.4599105834960938e+01 -1.7263500213623047e+01 1.8000000000000000e+01 -7.3891998291015625e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -1.7970600128173828e+01 2.1000000000000000e+01 -7.4891998291015625e+01 -1.7970600128173828e+01 2.1000000000000000e+01 -7.3891998291015625e+01 -1.6970598220825195e+01 2.1000000000000000e+01 -7.4599105834960938e+01 -1.7263500213623047e+01 -1.9498999023437500e+02 -7.4120796203613281e+01 -7.9705703735351562e+01 -1.9616200256347656e+02 -7.3917701721191406e+01 -8.0641906738281250e+01 -1.9728800964355469e+02 -7.4120796203613281e+01 -8.1634002685546875e+01 4.6470003128051758e+00 4.0496799468994141e+01 7.8790199279785156e+01 7.9735097885131836e+00 3.4166801452636719e+01 8.6842597961425781e+01 2.8803999423980713e+00 2.8202899932861328e+01 9.4235298156738281e+01 -3.2177501678466797e+01 2.3207599639892578e+01 1.0380799865722656e+02 -2.8348999023437500e+01 1.8307600021362305e+01 1.0466899871826172e+02 -2.9548099517822266e+01 1.7663799285888672e+01 1.0527899932861328e+02 -8.0203896760940552e-01 -4.8946998596191406e+01 7.4402694702148438e+01 7.3230397701263428e-01 -4.9362598419189453e+01 7.2409797668457031e+01 4.4030100107192993e-01 -5.0143600463867188e+01 7.2716896057128906e+01 2.1000000000000000e+01 -7.4891998291015625e+01 2.9799299240112305e+01 2.1000000000000000e+01 -7.4891998291015625e+01 1.7970600128173828e+01 2.1000000000000000e+01 -7.3891998291015625e+01 1.6970598220825195e+01 2.1000000000000000e+01 4.4702800750732422e+01 6.1597599029541016e+01 2.1000200271606445e+01 3.8596000671386719e+01 6.8976600646972656e+01 2.1000000000000000e+01 4.4833297729492188e+01 5.7956199645996094e+01 1.4506999969482422e+01 6.0928501129150391e+01 4.7579696655273438e+01 1.7152000427246094e+01 6.2820201873779297e+01 3.8687198638916016e+01 1.6707500457763672e+01 5.7793098449707031e+01 4.4737300872802734e+01 -4.7689599990844727e+00 4.5441398620605469e+01 7.9416900634765625e+01 2.1049001216888428e+00 4.7077598571777344e+01 7.1995697021484375e+01 -1.5595499992370605e+01 3.1022298812866211e+01 9.2373397827148438e+01 -1.9510099792480469e+02 -7.3742393493652344e+01 -7.9572898864746094e+01 -2.0812100219726562e+02 7.5106399536132812e+01 -6.1163398742675781e+01 -2.0226800537109375e+02 -6.3592903137207031e+01 -7.0246200561523438e+01 7.0341000556945801e+00 -4.5464500427246094e+01 7.1164604187011719e+01 1.3447500228881836e+01 -5.3169197082519531e+01 5.6213901519775391e+01 2.0333998203277588e+00 -4.7228702545166016e+01 7.1934898376464844e+01 -1.9466699218750000e+02 -7.4891998291015625e+01 -8.0087997436523438e+01 -1.9498999023437500e+02 -7.4391998291015625e+01 -7.9705703735351562e+01 -1.9489500427246094e+02 -7.4745605468750000e+01 -7.9817802429199219e+01 1.2373399734497070e+01 5.2909297943115234e+01 6.5194198608398438e+01 1.9679698944091797e+01 4.8820098876953125e+01 6.3869297027587891e+01 1.6655000686645508e+01 5.9379802703857422e+01 5.4137599945068359e+01 -1.9728800964355469e+02 -7.4391998291015625e+01 -8.1634002685546875e+01 -1.9603300476074219e+02 -7.2734497070312500e+01 -8.3106201171875000e+01 -1.9696499633789062e+02 -7.4891998291015625e+01 -8.2016403198242188e+01 1.1818599700927734e+01 4.9144802093505859e+01 -6.0318897247314453e+01 1.7103899002075195e+01 7.5108001708984375e+01 -4.9149497985839844e+01 1.7103899002075195e+01 6.1016498565673828e+01 -4.9149597167968750e+01 -1.9335499572753906e+02 -7.4470993041992188e+01 -8.1614006042480469e+01 -1.8936500549316406e+02 -7.4891998291015625e+01 -8.6000602722167969e+01 -8.0966205596923828e+00 3.3492099761962891e+01 8.8121398925781250e+01 -4.4254798889160156e+00 -7.4892105102539062e+01 8.4284797668457031e+01 9.1557998657226562e+00 -5.6802997589111328e+01 6.5280601501464844e+01 -2.3937900066375732e+00 -4.5289299011230469e+01 8.1252899169921875e+01 -4.5447902679443359e+01 1.0800000280141830e-01 1.1510100555419922e+02 -3.3992397308349609e+01 1.6715000152587891e+01 1.0987500000000000e+02 -4.7113700866699219e+01 1.0757499933242798e-01 1.1546500396728516e+02 1.7299798965454102e+01 -1.2469900131225586e+01 9.7201194763183594e+01 1.8000000000000000e+01 -2.6923999786376953e+01 7.4437698364257812e+01 1.6142898559570312e+01 -3.7781799316406250e+01 7.3245506286621094e+01 -1.8971400451660156e+02 -7.4891700744628906e+01 -9.0005706787109375e+01 -1.9672801208496094e+02 -3.1246900558471680e+01 -8.2407104492187500e+01 -1.9633898925781250e+02 7.5105697631835938e+01 -8.3057899475097656e+01 -1.5879200744628906e+02 -1.0485199689865112e+00 1.1271399688720703e+02 -1.6432400512695312e+02 7.5107299804687500e+01 1.0962100219726562e+02 -1.7501899719238281e+02 -2.3872101306915283e+00 1.0262899780273438e+02 1.4337699890136719e+01 -5.4901996612548828e+01 -4.7988498687744141e+01 2.2154002189636230e+00 -7.4891899108886719e+01 -7.1059600830078125e+01 1.4337699890136719e+01 -7.4891998291015625e+01 -4.7988498687744141e+01 -2.2543499755859375e+02 -7.4891403198242188e+01 -2.1152601242065430e+01 -2.2267300415039062e+02 -7.3891998291015625e+01 -3.2869998931884766e+01 -2.2292800903320312e+02 -7.4891998291015625e+01 -3.1903099060058594e+01 -2.1504299926757812e+02 7.5107002258300781e+01 -5.4824199676513672e+01 -2.2160301208496094e+02 7.5104598999023438e+01 -2.5158201217651367e+01 1.0121800422668457e+01 -1.6533498764038086e+01 1.0342200469970703e+02 2.5580999851226807e+00 -1.8091600418090820e+01 1.0466899871826172e+02 2.5001001358032227e+00 -1.0140899658203125e+01 1.0999600219726562e+02 -2.2709100341796875e+02 7.5107704162597656e+01 1.7232200130820274e-02 -2.2685499572753906e+02 -1.0918499946594238e+01 -8.0426397323608398e+00 -2.2702400207519531e+02 -7.4892105102539062e+01 3.7199800014495850e+00 1.4337699890136719e+01 5.5118000030517578e+01 -4.7988498687744141e+01 1.4337699890136719e+01 7.5108001708984375e+01 -4.7988498687744141e+01 1.0165399551391602e+01 4.5933700561523438e+01 -5.7064899444580078e+01 1.4968899726867676e+01 3.2673599243164062e+01 8.1433898925781250e+01 1.3642299652099609e+01 1.4999800682067871e+01 1.0129499816894531e+02 2.1000000000000000e+01 6.8942596435546875e+01 2.4304300308227539e+01 1.7520200729370117e+01 6.3328899383544922e+01 3.6498199462890625e+01 1.8000000000000000e+01 6.6748794555664062e+01 2.9799299240112305e+01 1.8000000000000000e+01 5.5078300476074219e+01 -5.2481098175048828e+01 -1.0000000000000000e+02 7.5108001708984375e+01 1.2400000000000000e+02 -7.3782798767089844e+01 7.5108100891113281e+01 1.2160099792480469e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 1.2400000000000000e+02 1.3202000617980957e+01 6.0726799011230469e+01 5.7570098876953125e+01 1.0920399665832520e+01 5.4900501251220703e+01 6.3292198181152344e+01 2.1000000000000000e+01 7.5108001708984375e+01 -2.9799200057983398e+01 2.0726699829101562e+01 7.0765998840332031e+01 -3.5019599914550781e+01 -3.1190700531005859e+01 -7.4891799926757812e+01 -1.0344400024414062e+02 -9.7811002731323242e+00 6.6044199466705322e-01 -8.5328399658203125e+01 -1.4491200447082520e-01 8.3208198547363281e+00 1.1119899749755859e+02 1.0916699409484863e+01 8.6330699920654297e+00 1.0936299896240234e+02 7.2210998535156250e+00 -5.1280598640441895e+00 1.1129800415039062e+02 -8.6697898864746094e+01 7.5108200073242188e+01 -1.2636700439453125e+02 -8.1959205627441406e+01 7.5108200073242188e+01 -1.2283200073242188e+02 -6.1289100646972656e+01 7.5108604431152344e+01 -1.2114699554443359e+02 -2.0725000000000000e+02 -4.6728599548339844e+01 -6.8072799682617188e+01 -2.0499099731445312e+02 -6.2948600769042969e+01 -7.1556503295898438e+01 -2.0981500244140625e+02 -5.5135200500488281e+01 -6.3794204711914062e+01 1.8369199752807617e+01 5.6631000518798828e+01 -5.0843002319335938e+01 1.6746400833129883e+01 -5.7669097900390625e+01 4.4618499755859375e+01 1.6850000381469727e+01 -6.0251300811767578e+01 4.1101100921630859e+01 1.4337599754333496e+01 -6.0713500976562500e+01 4.7988601684570312e+01 -7.5069999694824219e+01 -7.4892105102539062e+01 1.2170399475097656e+02 -4.5905799865722656e+01 -7.4889999389648438e+01 1.1191999816894531e+02 -6.1492900848388672e+01 -7.4891098022460938e+01 1.2134500122070312e+02 -2.4414600372314453e+01 7.5108001708984375e+01 -9.8412902832031250e+01 2.1000598907470703e+01 -6.4429000854492188e+01 3.5479099273681641e+01 1.7511899948120117e+01 -6.3079902648925781e+01 3.6555397033691406e+01 1.8000000000000000e+01 -7.4599105834960938e+01 1.7263500213623047e+01 1.8000000000000000e+01 -7.4891998291015625e+01 1.7970600128173828e+01 1.8000000000000000e+01 -7.3891998291015625e+01 1.6970598220825195e+01 2.1000000000000000e+01 -7.4599105834960938e+01 1.7263500213623047e+01 2.1000000000000000e+01 -7.1676795959472656e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.1277793884277344e+01 1.7182800292968750e+01 2.1000000000000000e+01 7.1892799377441406e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.0922698974609375e+01 1.7727699279785156e+01 -2.2467300415039062e+02 -7.4891593933105469e+01 2.4523500442504883e+01 -2.2641600036621094e+02 5.3997101783752441e+00 1.2965999603271484e+01 2.0999799728393555e+01 5.8480899810791016e+01 4.4186698913574219e+01 -2.2515299987792969e+02 7.5107299804687500e+01 -2.2557399749755859e+01 -1.3277099609375000e+02 7.5105400085449219e+01 1.2005899810791016e+02 -1.4044200134277344e+02 7.5107299804687500e+01 1.2067499542236328e+02 -1.0668999481201172e+02 7.5108001708984375e+01 1.2682299041748047e+02 1.4737400054931641e+01 1.4116399765014648e+01 1.0039400482177734e+02 1.6964899063110352e+01 1.1505800247192383e+01 9.7720306396484375e+01 2.0975799560546875e+01 4.5589900970458984e+01 6.1531101226806641e+01 2.1000000000000000e+01 4.5076999664306641e+01 6.1127799987792969e+01 2.1000000000000000e+01 7.4815101623535156e+01 -1.7263500213623047e+01 2.1000000000000000e+01 7.5108001708984375e+01 -1.7970600128173828e+01 1.8000000000000000e+01 7.4815101623535156e+01 -1.7263500213623047e+01 -7.3691701889038086e+00 7.5107406616210938e+01 8.2811302185058594e+01 4.7304000854492188e+00 7.5107597351074219e+01 7.3345901489257812e+01 1.4337699890136719e+01 7.5108001708984375e+01 4.7988498687744141e+01 2.1000000000000000e+01 7.4107994079589844e+01 -1.6970598220825195e+01 1.8000000000000000e+01 7.5108001708984375e+01 -1.7970600128173828e+01 1.8000000000000000e+01 7.4815101623535156e+01 1.7263500213623047e+01 2.1000000000000000e+01 7.5108001708984375e+01 1.7970600128173828e+01 2.1000000000000000e+01 7.4815101623535156e+01 1.7263500213623047e+01 1.8000000000000000e+01 7.5108001708984375e+01 1.7970600128173828e+01 1.8000000000000000e+01 7.4107994079589844e+01 1.6970598220825195e+01 1.8000000000000000e+01 7.4107994079589844e+01 -1.6970598220825195e+01 1.8000000000000000e+01 7.0922698974609375e+01 -1.7727699279785156e+01 1.8000000000000000e+01 7.1277793884277344e+01 -1.7182800292968750e+01 1.8000000000000000e+01 7.1892799377441406e+01 -1.6970598220825195e+01 1.8862400054931641e+01 5.9060100555419922e+01 -4.8271701812744141e+01 1.8935098648071289e+01 5.9023902893066406e+01 -4.8272201538085938e+01 6.5987000465393066e+00 4.5333900451660156e+01 7.1686401367187500e+01 1.3430399894714355e+01 5.3364898681640625e+01 5.6081897735595703e+01 2.0345098495483398e+01 -2.3524801254272461e+01 9.1230300903320312e+01 1.8666301727294922e+01 -1.3005300521850586e+01 1.0204399871826172e+02 1.6864400863647461e+01 -1.4607399940490723e+01 1.0397700500488281e+02 -2.6127298355102539e+01 7.5107795715332031e+01 9.9849594116210938e+01 -4.7543899536132812e+01 7.5107299804687500e+01 1.1253400421142578e+02 -4.9926399230957031e+01 7.5107704162597656e+01 1.1721199798583984e+02 1.8804199218750000e+01 1.6510299682617188e+01 -7.4573600769042969e+01 2.1178600311279297e+01 1.8494001388549805e+01 -7.0857803344726562e+01 1.8000000000000000e+01 -7.0706703186035156e+01 -1.7727699279785156e+01 2.1000000000000000e+01 -7.1061798095703125e+01 -1.7182800292968750e+01 2.1000000000000000e+01 -7.0706703186035156e+01 -1.7727699279785156e+01 1.8000000000000000e+01 -7.1676795959472656e+01 1.6970598220825195e+01 2.1000000000000000e+01 -7.1061996459960938e+01 1.7182701110839844e+01 2.1000000000000000e+01 -7.1676795959472656e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.1061996459960938e+01 -1.7182701110839844e+01 2.1000000000000000e+01 7.0922698974609375e+01 -1.7727699279785156e+01 -2.1741299438476562e+02 -7.4885894775390625e+01 4.9223098754882812e+01 -2.0345599365234375e+02 -7.4891593933105469e+01 7.3888603210449219e+01 -2.0693899536132812e+02 -4.9084997177124023e+00 6.8771400451660156e+01 -1.0000000000000000e+02 7.5108001708984375e+01 -1.2700000762939453e+02 -1.5642400741577148e+01 1.5332799911499023e+01 1.0724499511718750e+02 -4.2853099822998047e+01 9.2921895980834961e+00 1.1059600067138672e+02 2.5006098747253418e+00 -6.5308899879455566e+00 1.1123899841308594e+02 2.5006999969482422e+00 -5.8350400924682617e+00 1.1141300201416016e+02 2.5006999969482422e+00 -6.1961998939514160e+00 1.1132500457763672e+02 -4.0223899841308594e+01 -1.5410000801086426e+01 1.0878500366210938e+02 -2.8348999023437500e+01 -1.8091600418090820e+01 1.0466899871826172e+02 -3.2152000427246094e+01 -2.2937299728393555e+01 1.0379199981689453e+02 1.8000000000000000e+01 7.1892799377441406e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.4107994079589844e+01 1.6970598220825195e+01 5.3158998489379883e+00 5.3001098632812500e+01 7.1256301879882812e+01 8.5990297794342041e-01 1.0802999883890152e-01 -7.7176895141601562e+01 4.2993998527526855e+00 2.6358999252319336e+01 -7.2684402465820312e+01 3.2423999309539795e+00 1.0799900442361832e-01 -7.6000000000000000e+01 1.9115999221801758e+01 1.2767699241638184e+01 1.0111899566650391e+02 2.0015298843383789e+01 2.0527599334716797e+01 9.4154197692871094e+01 1.8644100189208984e+01 1.3296100616455078e+01 1.0179699707031250e+02 2.1000000000000000e+01 6.1279899597167969e+01 4.2324199676513672e+01 2.1000000000000000e+01 5.8731101989746094e+01 4.4977001190185547e+01 -1.0000000000000000e+02 7.5108001708984375e+01 -1.2400000000000000e+02 2.2366998195648193e+00 2.2410699844360352e+01 -7.0335800170898438e+01 1.7035000324249268e+00 4.3026397705078125e+01 8.0824195861816406e+01 -9.2202701568603516e+00 3.6778800964355469e+01 8.9871299743652344e+01 -2.8348999023437500e+01 2.0407499313354492e+01 1.0681199645996094e+02 -2.5226499557495117e+01 -7.4891899108886719e+01 9.8998100280761719e+01 -3.2177501678466797e+01 -2.2991600036621094e+01 1.0380799865722656e+02 -1.1352399444580078e+02 7.5107795715332031e+01 -1.2336699676513672e+02 -1.3004699707031250e+02 -7.4891998291015625e+01 -1.2049199676513672e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 -1.2400000000000000e+02 8.2552003860473633e+00 -7.4891799926757812e+01 6.0788600921630859e+01 7.7395000457763672e+00 -5.6370700836181641e+01 6.1729900360107422e+01 1.4337699890136719e+01 -7.4891998291015625e+01 4.7988498687744141e+01 2.1000101089477539e+01 1.9199899673461914e+01 7.1127304077148438e+01 2.1000000000000000e+01 -7.0706703186035156e+01 1.7727699279785156e+01 1.8000000000000000e+01 -7.0706703186035156e+01 1.7727699279785156e+01 -8.5987205505371094e+01 -7.4891296386718750e+01 1.2629499816894531e+02 1.0817999839782715e+00 7.5106895446777344e+01 -7.7009605407714844e+01 -1.5594899654388428e+00 7.5108001708984375e+01 -7.6054901123046875e+01 1.0055200576782227e+01 -3.9504901885986328e+01 8.5356201171875000e+01 1.4704400062561035e+01 -3.3138099670410156e+01 9.1603195190429688e+01 4.2192001342773438e+00 -2.0191600799560547e+01 1.0681199645996094e+02 -7.8046005249023438e+01 -7.4890701293945312e+01 -1.2514300537109375e+02 1.1272000312805176e+01 -1.8118999481201172e+01 1.0693599700927734e+02 -4.0971000671386719e+01 -5.5583999633789062e+01 -1.1244799804687500e+02 -3.9326400756835938e+01 -2.4054899215698242e+01 -1.1156900024414062e+02 -2.4468601226806641e+01 -7.4892402648925781e+01 -1.0244999694824219e+02 1.8000000000000000e+01 -7.1676795959472656e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.1061798095703125e+01 1.7182800292968750e+01 1.4337599754333496e+01 6.0839599609375000e+01 4.7988601684570312e+01 1.4665599822998047e+01 6.3570499420166016e+01 4.7193298339843750e+01 -1.7139401245117188e+02 7.5105506896972656e+01 -1.0562599945068359e+02 -1.6840699768066406e+02 7.5105804443359375e+01 -1.0365899658203125e+02 -1.4018499755859375e+02 7.5108200073242188e+01 -1.1758100128173828e+02 2.0121299743652344e+01 5.4442802429199219e+01 -5.1874298095703125e+01 -2.2333900451660156e+02 3.3066600561141968e-01 -1.3463000297546387e+01 -2.1951199340820312e+02 -5.4891998291015625e+01 -3.3058403015136719e+01 -2.2434001159667969e+02 -7.4888603210449219e+01 1.2969899177551270e+00 -2.2416099548339844e+02 7.5107902526855469e+01 -1.2013800144195557e+00 -2.2045600891113281e+02 5.4221897125244141e+00 2.9790201187133789e+01 -2.1884100341796875e+02 -7.4891403198242188e+01 3.6125202178955078e+01 -2.2360299682617188e+02 -6.2022700309753418e+00 1.1924800872802734e+01 -1.9730099487304688e+02 -7.3979103088378906e+01 -8.1618301391601562e+01 -1.4337599182128906e+02 7.5013999938964844e+00 -1.1628199768066406e+02 -1.6911299133300781e+02 -7.4891899108886719e+01 -1.0705500030517578e+02 -1.5268200683593750e+02 -7.4890701293945312e+01 -1.1241500091552734e+02 -1.7421899414062500e+02 -7.4891204833984375e+01 -9.9686302185058594e+01 -1.9708601379394531e+02 -2.4027400016784668e+00 8.1963699340820312e+01 -2.0411199951171875e+02 7.5104499816894531e+01 7.3148200988769531e+01 2.1000000000000000e+01 -4.7192699432373047e+01 5.9706699371337891e+01 1.9997301101684570e+01 -5.0283901214599609e+01 6.1828399658203125e+01 2.0247499465942383e+01 -6.0854499816894531e+01 4.7096698760986328e+01 -4.1633598327636719e+01 -8.4118700027465820e+00 1.1066600036621094e+02 -4.8362800598144531e+01 1.0879299789667130e-01 1.1273699951171875e+02 7.1133999824523926e+00 5.5788597106933594e+01 6.2712295532226562e+01 1.5973400115966797e+01 5.6621101379394531e+01 4.7871997833251953e+01 2.0762599945068359e+01 -7.1411804199218750e+01 3.4666000366210938e+01 2.1000000000000000e+01 -7.3284500122070312e+01 2.9799299240112305e+01 -2.2786399841308594e+01 7.5107597351074219e+01 1.0112799835205078e+02 -2.4328300476074219e+01 7.5108299255371094e+01 -1.0229299926757812e+02 1.7103899002075195e+01 7.5108001708984375e+01 4.9149497985839844e+01 1.8000000000000000e+01 1.0800000280141830e-01 9.6601097106933594e+01 1.8002399444580078e+01 1.8926799774169922e+01 8.2105194091796875e+01 1.8000000000000000e+01 6.5922002792358398e+00 7.2711196899414062e+01 -2.1977500915527344e+02 -5.5892002105712891e+01 -3.2093601226806641e+01 -2.1977500915527344e+02 -7.3891998291015625e+01 -3.2093601226806641e+01 -2.2267300415039062e+02 -5.5892002105712891e+01 -3.2869998931884766e+01 2.5000000000000000e+00 1.8307600021362305e+01 1.0466899871826172e+02 9.3776998519897461e+00 -3.4714199066162109e+01 8.5550796508789062e+01 -1.0888500213623047e+00 -3.5304799079895020e+00 1.1184999847412109e+02 -2.1943699645996094e+02 7.5107406616210938e+01 3.6568599700927734e+01 -2.0540399169921875e+02 7.5108001708984375e+01 6.5474197387695312e+01 -2.1020401000976562e+02 1.4833799362182617e+01 5.7062099456787109e+01 2.9303998947143555e+00 1.1191800117492676e+01 1.1289899444580078e+02 3.3034000396728516e+00 1.5760001182556152e+01 1.1056800079345703e+02 -9.5387096405029297e+00 -3.3844600677490234e+01 9.2266296386718750e+01 3.0102000236511230e+00 -4.6909198760986328e+01 7.5950103759765625e+01 1.3488999366760254e+01 -5.3708999633789062e+01 6.3441997528076172e+01 1.3385499954223633e+01 5.7839900970458984e+01 5.1017601013183594e+01 1.8000000000000000e+01 7.0928405761718750e+01 -2.3759199142456055e+01 1.8000000000000000e+01 7.5108001708984375e+01 -2.9799299240112305e+01 5.5107898712158203e+00 2.1042098999023438e+01 -7.3059997558593750e+01 -5.6733798980712891e+00 -4.4396400451660156e+01 8.0489097595214844e+01 1.8000000000000000e+01 7.5108001708984375e+01 2.9799299240112305e+01 -1.5419599413871765e-01 4.9785301208496094e+01 7.3531097412109375e+01 1.7535699844360352e+01 4.9132102966308594e+01 5.4567501068115234e+01 -1.7766000747680664e+01 3.2458499908447266e+01 9.7077301025390625e+01 2.1000000000000000e+01 -6.8290893554687500e+01 -3.5028598785400391e+01 2.1000000000000000e+01 -6.6618896484375000e+01 -2.9605100631713867e+01 -1.6731298828125000e+02 -4.2762002944946289e+00 -1.0428799438476562e+02 2.1034200668334961e+01 3.9254699707031250e+01 -6.2075298309326172e+01 2.0800600051879883e+01 5.3686298370361328e+01 -5.1152099609375000e+01 -1.7693099975585938e+02 1.9977500438690186e+00 -1.0117900085449219e+02 1.8000000000000000e+01 -7.4891998291015625e+01 2.9799299240112305e+01 1.7355199813842773e+01 -6.2855102539062500e+01 3.7557899475097656e+01 1.8000000000000000e+01 7.0922698974609375e+01 1.7727699279785156e+01 1.8000000000000000e+01 1.0800000280141830e-01 -7.6000000000000000e+01 1.6974599838256836e+01 -5.9432800292968750e+01 5.3557796478271484e+01 1.8391799926757812e+01 -6.2457099914550781e+01 4.8568401336669922e+01 -5.3404603004455566e+00 -7.4891502380371094e+01 8.0632904052734375e+01 2.1000000000000000e+01 2.0144699096679688e+01 8.6661003112792969e+01 2.1000000000000000e+01 8.4600601196289062e+00 9.4622200012207031e+01 2.1000000000000000e+01 5.2908397674560547e+01 -5.0409500122070312e+01 2.0983598709106445e+01 5.5569297790527344e+01 -4.8216400146484375e+01 2.1000000000000000e+01 5.3976497650146484e+01 -4.9253200531005859e+01 -2.1985000610351562e+02 -7.4599403381347656e+01 -3.1810298919677734e+01 1.1480299949645996e+01 -4.7841400146484375e+01 -6.1011898040771484e+01 1.7103899002075195e+01 -6.0800498962402344e+01 -4.9149597167968750e+01 1.7103899002075195e+01 -7.4891998291015625e+01 -4.9149497985839844e+01 -2.2459100341796875e+02 -3.5183601379394531e+01 -2.4900398254394531e+01 -2.0748199462890625e+02 -5.5135200500488281e+01 -6.1836299896240234e+01 1.9715101242065430e+01 -6.8232299804687500e+01 4.1411102294921875e+01 -3.9335197448730469e+01 6.9081199645996094e+01 -1.1157499694824219e+02 -3.9326400756835938e+01 1.8272100448608398e+01 -1.1156900024414062e+02 -7.4844505310058594e+01 7.5108001708984375e+01 1.2459199523925781e+02 -2.1668798446655273e+01 3.2112598419189453e+01 9.6281898498535156e+01 -2.1827700805664062e+02 -1.4179999828338623e+00 4.6404201507568359e+01 -2.2446299743652344e+02 7.5106300354003906e+01 2.6909999847412109e+01 -2.2304501342773438e+02 1.7659299850463867e+01 3.1906400680541992e+01 -2.0663101196289062e+02 -7.4886100769042969e+01 6.3669197082519531e+01 -2.1613299560546875e+02 4.8294301033020020e+00 4.3676200866699219e+01 -1.6604100036621094e+02 -1.3293899536132812e+01 -1.0859500122070312e+02 -1.3236500549316406e+02 -7.4889198303222656e+01 -1.2322799682617188e+02 -1.3477600097656250e+02 4.1680402755737305e+00 -1.2219899749755859e+02 -1.2329100036621094e+02 7.5107597351074219e+01 -1.2494400024414062e+02 1.7103899002075195e+01 -6.4845504760742188e+01 4.9149700164794922e+01 1.9013999938964844e+01 -6.4074996948242188e+01 4.6009498596191406e+01 -1.0018800354003906e+02 6.8534398078918457e+00 1.2700299835205078e+02 -9.1548103332519531e+01 7.5108001708984375e+01 1.2671700286865234e+02 -1.0000000000000000e+02 7.5108001708984375e+01 1.2700000762939453e+02 -1.1133200073242188e+02 -8.5999698638916016e+00 1.2359199523925781e+02 -4.0971000671386719e+01 -1.5349600791931152e+01 -1.1244799804687500e+02 2.1000000000000000e+01 7.1277999877929688e+01 -1.7182701110839844e+01 2.1000000000000000e+01 7.1892799377441406e+01 -1.6970598220825195e+01 9.8897008895874023e+00 -5.5709900856018066e+00 1.1372399902343750e+02 1.7712200164794922e+01 4.4143300056457520e+00 1.0767900085449219e+02 1.0344699859619141e+01 1.8827398300170898e+01 1.0696599578857422e+02 -1.6409201049804688e+02 7.5108001708984375e+01 1.0632299804687500e+02 -1.5303399658203125e+02 1.7258600234985352e+01 1.1219699859619141e+02 -8.0452102661132812e+01 -7.4892204284667969e+01 -1.2281300354003906e+02 -6.0083198547363281e+01 -7.4892105102539062e+01 -1.2084500122070312e+02 -5.3797698974609375e+01 -7.4891998291015625e+01 -1.1516699981689453e+02 2.0442899703979492e+01 5.8248401641845703e+01 -4.7478900909423828e+01 -8.2821098327636719e+01 5.3875499725341797e+01 -1.2315200042724609e+02 -5.0509696960449219e+01 7.5108299255371094e+01 -1.1403299713134766e+02 -2.2002999877929688e+02 -7.4891998291015625e+01 -3.1126600265502930e+01 2.0997999191284180e+01 5.0729698181152344e+01 5.4137699127197266e+01 -2.1544801330566406e+02 1.7201700210571289e+01 -4.5611301422119141e+01 -2.0781100463867188e+02 -5.4891998291015625e+01 -6.1259700775146484e+01 -3.0536600112915039e+01 -2.2991600036621094e+01 1.0631999969482422e+02 -1.4031300544738770e+01 -3.4750900268554688e+01 9.3618698120117188e+01 -2.8348999023437500e+01 -2.0191600799560547e+01 1.0681199645996094e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 1.2700000762939453e+02 -4.4298000335693359e+01 3.1567300796508789e+01 -1.1413300323486328e+02 2.1000000000000000e+01 6.3844898223876953e+01 3.9687099456787109e+01 -4.5447902679443359e+01 1.0800000280141830e-01 1.1210100555419922e+02 2.5000000000000000e+00 1.0800000280141830e-01 1.1210100555419922e+02 -6.6079994201660156e+01 4.4925201416015625e+01 -1.1926999664306641e+02 1.8000000000000000e+01 2.5940699577331543e+00 9.6302505493164062e+01 1.8000000000000000e+01 7.4578800201416016e+00 9.3599700927734375e+01 1.0661899566650391e+01 3.8095100402832031e+01 -6.6385299682617188e+01 1.9015298843383789e+01 3.9948600769042969e+01 -6.5030403137207031e+01 2.1175001144409180e+01 -1.8278900146484375e+01 -7.0860099792480469e+01 1.8544599533081055e+01 -4.6590499877929688e+01 -6.0089900970458984e+01 1.8420700073242188e+01 -2.9401899337768555e+01 -7.0327697753906250e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -2.9799299240112305e+01 1.7999900817871094e+01 -1.4813999176025391e+01 7.1764793395996094e+01 1.8000000000000000e+01 1.0800000280141830e-01 7.3000000000000000e+01 1.8336099624633789e+01 -5.6275798797607422e+01 -5.0990802764892578e+01 1.8935199737548828e+01 -5.8807899475097656e+01 -4.8272098541259766e+01 6.6869997978210449e+00 -3.6554298400878906e+01 -6.3411304473876953e+01 3.8247900009155273e+00 -3.1292798995971680e+01 9.0722801208496094e+01 -1.2202799987792969e+02 7.7657198905944824e-01 1.2513500213623047e+02 2.1000000000000000e+01 7.5108001708984375e+01 -2.3884899139404297e+01 1.7280200958251953e+01 -5.1649101257324219e+01 5.1728199005126953e+01 1.5431200027465820e+01 -5.5689498901367188e+01 4.9959102630615234e+01 -2.2155799865722656e+02 -7.4891998291015625e+01 -2.4480899810791016e+01 2.4995999336242676e+00 1.0800000280141830e-01 1.1510100555419922e+02 2.4210000038146973e+00 -8.1501207351684570e+00 1.1407899475097656e+02 2.1000000000000000e+01 -7.4891998291015625e+01 -2.9799200057983398e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -2.5239198684692383e+01 2.1000000000000000e+01 7.3500495910644531e+01 2.9799200057983398e+01 2.1000000000000000e+01 6.9175300598144531e+01 3.3713199615478516e+01 2.0060100555419922e+01 -5.4269802093505859e+01 -5.1915401458740234e+01 1.8000000000000000e+01 -5.4862300872802734e+01 -5.2481098175048828e+01 2.1000000000000000e+01 -2.0907100677490234e+01 8.6932098388671875e+01 2.1000000000000000e+01 1.0800000280141830e-01 7.3000000000000000e+01 1.8000000000000000e+01 -6.8884300231933594e+01 -2.3855001449584961e+01 1.8000000000000000e+01 -6.6532798767089844e+01 -2.9799299240112305e+01 -3.0536600112915039e+01 2.3207599639892578e+01 1.0631999969482422e+02 -1.8569200134277344e+02 7.5104804992675781e+01 9.3923202514648438e+01 2.1000000000000000e+01 6.8513999938964844e+01 -3.5021301269531250e+01 2.1000000000000000e+01 7.3272300720214844e+01 -2.9799200057983398e+01 -1.1753499984741211e+01 -3.0837299346923828e+01 9.1194305419921875e+01 6.1103000640869141e+00 -4.4312000274658203e+01 7.2949897766113281e+01 -2.1466099548339844e+02 7.5108001708984375e+01 5.4784099578857422e+01 -1.9013400268554688e+02 -7.4891296386718750e+01 8.9537704467773438e+01 2.0533998489379883e+01 -7.2795397043228149e-01 1.0195600128173828e+02 7.9645094871520996e+00 3.5167297363281250e+01 9.0931701660156250e+01 3.9316997528076172e+00 2.0407600402832031e+01 1.0681199645996094e+02 2.1004098892211914e+01 6.2256599426269531e+01 -4.1176799774169922e+01 2.1000000000000000e+01 5.7031200408935547e+01 -4.6233798980712891e+01 -1.5327900695800781e+02 -4.6390995979309082e+00 -1.1533100128173828e+02 2.1178699493408203e+01 -4.1126800537109375e+01 -6.0761501312255859e+01 2.0932199478149414e+01 -5.1859699249267578e+01 -5.2187000274658203e+01 -3.4418502807617188e+01 -7.4891403198242188e+01 1.0934200286865234e+02 1.8000000000000000e+01 6.6748794555664062e+01 -2.9799299240112305e+01 1.9166101455688477e+01 6.0066398620605469e+01 -4.7126800537109375e+01 2.0314098358154297e+01 6.5873100280761719e+01 -4.0621299743652344e+01 -4.1148799896240234e+01 7.5108001708984375e+01 -1.1255699920654297e+02 -1.6846800231933594e+02 -7.4890396118164062e+01 1.0418300628662109e+02 -1.6650601196289062e+02 -7.4891204833984375e+01 1.0909700012207031e+02 1.5993300437927246e+01 -5.6457298278808594e+01 4.7894702911376953e+01 2.1000000000000000e+01 5.5608296394348145e-01 9.0649902343750000e+01 2.1000000000000000e+01 -8.4453201293945312e+00 9.4827499389648438e+01 5.6221899986267090e+00 -1.8348899841308594e+01 -7.4209800720214844e+01 -1.3257200241088867e+01 -3.7578899383544922e+01 8.8780799865722656e+01 2.1000000000000000e+01 -5.7266101837158203e+01 -4.5136501312255859e+01 2.1000000000000000e+01 -5.5840499877929688e+01 -4.6890197753906250e+01 2.1000000000000000e+01 5.7483200073242188e+01 -4.5135402679443359e+01 2.1000000000000000e+01 5.6056499481201172e+01 -4.6890197753906250e+01 -1.9163600158691406e+02 -7.4891593933105469e+01 8.3692100524902344e+01 -1.9611099243164062e+02 9.8749694824218750e+00 7.8552902221679688e+01 2.1000000000000000e+01 -3.6007300019264221e-01 9.6598899841308594e+01 2.1004301071166992e+01 -6.2021598815917969e+01 -4.1194801330566406e+01 -8.4987297058105469e+00 7.5108001708984375e+01 -8.8191505432128906e+01 -1.5600900268554688e+02 3.6128101348876953e+00 -1.1068700408935547e+02 1.5161299705505371e+01 3.7162399291992188e+01 8.6777206420898438e+01 -1.1147000122070312e+02 -7.4891403198242188e+01 1.2659700012207031e+02 -1.1642400360107422e+02 -7.4891998291015625e+01 1.2297200012207031e+02 -1.4419500732421875e+02 7.5107299804687500e+01 -1.1916200256347656e+02 1.8000000000000000e+01 -6.6532798767089844e+01 2.9799299240112305e+01 -2.1014698791503906e+02 -5.4891998291015625e+01 -6.3219398498535156e+01 -2.1751199340820312e+02 -5.4891799926757812e+01 -4.8431301116943359e+01 -2.0800100708007812e+02 1.2910199165344238e+00 -6.1064899444580078e+01 2.0981901168823242e+01 -5.5407798767089844e+01 -4.8191699981689453e+01 -2.0590499877929688e+02 -4.1511699676513672e+01 -6.4517601013183594e+01 -2.2121900939941406e+02 -4.6848899841308594e+01 -2.6174999237060547e+01 -1.1017800140380859e+02 6.3913302421569824e+00 -1.2669100189208984e+02 1.2519899368286133e+01 -4.3236698150634766e+01 -6.2628799438476562e+01 3.5546998977661133e+00 -2.1866500854492188e+01 -7.3647796630859375e+01 2.1000000000000000e+01 7.5108001708984375e+01 2.9799200057983398e+01 -4.4298000335693359e+01 -7.3106292724609375e+01 -1.1413300323486328e+02 -4.1794799804687500e+01 -7.4891998291015625e+01 -1.1288099670410156e+02 -4.2628299713134766e+01 6.7965095520019531e+01 -1.1330300140380859e+02 -4.2628299713134766e+01 4.7396998405456543e+00 -1.1330300140380859e+02 -4.0971000671386719e+01 3.5152698516845703e+01 -1.1244799804687500e+02 -4.2628299713134766e+01 -4.1967899322509766e+01 -1.1330300140380859e+02 -4.4298000335693359e+01 -1.3787099838256836e+01 -1.1413300323486328e+02 -1.9500300598144531e+02 -7.3979103088378906e+01 -7.9689895629882812e+01 2.1000000000000000e+01 -4.4068099975585938e+01 6.3845298767089844e+01 2.1000101089477539e+01 -4.3902999877929688e+01 5.8802898406982422e+01 -2.0448801517486572e+00 -7.4892105102539062e+01 -8.1524795532226562e+01 -3.9611701965332031e+01 -1.1682099342346191e+01 1.1259600067138672e+02 1.7103899002075195e+01 6.5061500549316406e+01 4.9149700164794922e+01 1.9856300354003906e+01 6.6521194458007812e+01 4.2222599029541016e+01 1.5833899497985840e+01 -5.9839496612548828e+01 5.4097599029541016e+01 1.5865499496459961e+01 -5.6621799468994141e+01 4.7871601104736328e+01 2.1000000000000000e+01 -1.4489100456237793e+01 7.2099601745605469e+01 -4.0007999420166016e+01 -1.4801500320434570e+01 1.1204000091552734e+02 -1.9739900207519531e+02 -7.3742393493652344e+01 -8.1501296997070312e+01 1.6308401107788086e+01 -4.8506798744201660e+00 1.0468699645996094e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 -1.2700000762939453e+02 -1.9004100036621094e+02 7.5104301452636719e+01 -8.5460197448730469e+01 -1.8223999023437500e+02 1.7392500638961792e+00 -9.2903800964355469e+01 1.8357299804687500e+01 6.2707000732421875e+01 4.8569797515869141e+01 2.0624500274658203e+01 6.0352798461914062e+01 4.6493999481201172e+01 2.1000000000000000e+01 6.7407897949218750e+01 3.5785701751708984e+01 2.1000000000000000e+01 -5.8562999725341797e+01 4.5097900390625000e+01 2.1000000000000000e+01 -7.3056304931640625e+01 -2.9799200057983398e+01 2.0995100021362305e+01 -5.2815799713134766e+01 -5.0527301788330078e+01 -1.8799699401855469e+02 7.5106399536132812e+01 8.7539703369140625e+01 1.9731599807739258e+01 6.1630401611328125e+01 4.7645401000976562e+01 2.1000000000000000e+01 -5.6809398651123047e+01 -4.6239498138427734e+01 1.5814099311828613e+01 5.6829601287841797e+01 4.7844902038574219e+01 1.8000000000000000e+01 -3.8214298248291016e+01 6.2132102966308594e+01 1.8000000000000000e+01 -7.2825498580932617e+00 9.3641197204589844e+01 1.8000000000000000e+01 3.7198902130126953e+01 6.2875003814697266e+01 1.9513198852539062e+01 5.7422000885009766e+01 5.3005401611328125e+01 -2.3469798564910889e+00 4.5547401428222656e+01 8.1196601867675781e+01 -1.3559399414062500e+02 -7.4891998291015625e+01 1.1897899627685547e+02 -1.3439500427246094e+02 -7.4891700744628906e+01 1.2245000457763672e+02 1.4789000511169434e+01 5.8734001159667969e+01 4.7777198791503906e+01 1.2187500000000000e+01 5.2666500091552734e+01 6.5605995178222656e+01 2.1000000000000000e+01 1.2906099855899811e-01 9.6600502014160156e+01 2.1000000000000000e+01 6.6834899902343750e+01 -2.9605100631713867e+01 -2.0749400329589844e+02 1.5842599868774414e+01 -6.7731903076171875e+01 2.1000000000000000e+01 -5.2692398071289062e+01 -5.0409500122070312e+01 2.1000000000000000e+01 -5.3760601043701172e+01 -4.9253200531005859e+01 2.1000000000000000e+01 -5.3699699401855469e+01 -4.9362800598144531e+01 2.0763799667358398e+01 -7.0773902893066406e+01 3.4953300476074219e+01 1.6749300003051758e+01 -5.2333000183105469e+01 -5.5008499145507812e+01 -1.7778900146484375e+02 1.0520999908447266e+01 9.6655693054199219e+01 -1.6788899230957031e+02 -2.8404199600219727e+01 1.0391799926757812e+02 -1.4750300598144531e+02 -4.1497802734375000e+00 1.1786500549316406e+02 -1.3913500976562500e+02 7.0647201538085938e+00 1.1778099822998047e+02 1.1004500389099121e+01 4.7851100921630859e+01 7.3358398437500000e+01 2.6818099021911621e+00 6.7375898361206055e+00 1.1440700531005859e+02 -2.2240998840332031e+02 -5.4891998291015625e+01 -3.3834899902343750e+01 1.8000299453735352e+01 2.3586599349975586e+01 6.9473197937011719e+01 8.2315006256103516e+00 1.0114500045776367e+01 1.1246299743652344e+02 1.7103899002075195e+01 -7.4891998291015625e+01 4.9149497985839844e+01 5.4821000099182129e+00 4.3973300933837891e+01 7.3780700683593750e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 38 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02) (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01) (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02) (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00) (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02) (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01) (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01) (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01) (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01) (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01) (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02) (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02) (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01) (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_shoulder_lift_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_shoulder_pan_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.8800000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 3 1 0 2 14 0 14 168 0 169 0 168 173 174 0 0 169 175 175 173 0 0 174 3 169 168 170 14 170 168 177 170 14 177 202 170 202 169 170 177 203 202 203 177 372 177 379 372 177 422 379 177 14 422 161 179 202 202 203 161 169 202 179 178 169 179 179 161 160 179 205 178 402 179 160 205 179 402 169 176 175 169 178 176 176 173 175 172 174 173 173 176 172 171 3 172 172 3 174 176 171 172 3 171 5 5 171 176 4 1 3 5 4 3 5 6 4 15 4 6 4 469 1 469 4 15 1 467 2 1 469 467 467 417 421 467 468 417 467 469 468 420 467 421 2 467 420 14 2 420 420 421 416 412 420 416 412 419 420 419 422 420 422 14 420 416 421 417 376 412 416 376 416 409 415 409 416 417 415 416 377 411 412 412 376 377 419 412 411 411 379 419 422 419 379 378 411 377 378 379 411 373 375 377 375 378 377 373 377 376 375 371 378 378 371 372 372 379 378 369 371 375 375 373 366 366 369 375 366 373 368 373 376 368 368 367 366 374 367 368 376 374 368 376 409 374 374 409 410 367 374 480 410 452 374 374 452 480 413 410 409 413 409 414 409 415 414 413 453 410 453 452 410 452 453 454 466 452 454 480 452 466 480 466 367 465 466 454 501 466 481 501 367 466 481 466 465 465 454 462 462 479 465 465 479 481 457 462 454 462 457 447 450 479 462 462 447 450 479 450 481 449 450 446 446 450 447 449 481 450 446 447 448 448 447 457 455 456 457 454 455 457 456 448 457 451 446 448 459 448 456 460 448 459 451 448 460 456 455 458 458 459 456 461 460 459 458 463 459 463 461 459 490 460 461 451 460 490 464 461 463 464 490 461 414 418 463 458 414 463 463 418 464 455 413 458 414 458 413 417 418 414 415 417 414 468 418 417 470 418 468 470 471 418 464 418 471 468 469 470 470 469 472 470 472 471 434 471 495 471 472 495 471 434 491 464 471 491 496 495 472 472 469 496 434 495 435 435 495 496 434 435 433 433 491 434 435 436 433 435 437 436 437 435 496 433 436 428 436 431 428 438 436 437 436 438 431 437 440 438 437 441 440 437 496 441 440 431 438 431 393 428 431 439 396 393 431 396 440 439 431 442 439 440 440 441 442 47 442 441 441 405 47 441 496 405 59 439 442 58 59 442 47 58 442 439 59 396 50 59 58 50 61 59 61 129 59 129 23 59 23 156 59 396 59 395 156 395 59 319 156 23 319 321 156 156 321 336 336 395 156 352 395 336 388 395 352 388 396 395 336 321 337 336 351 352 337 351 336 338 337 321 319 338 321 351 337 353 338 355 337 337 355 353 351 354 352 351 333 354 351 334 333 353 334 351 355 334 353 338 356 355 356 331 355 334 355 331 331 333 334 331 332 333 333 332 354 354 332 386 354 386 352 386 332 387 386 387 388 388 352 386 389 388 387 335 389 387 332 335 387 389 393 388 393 396 388 335 392 389 392 393 389 394 393 392 428 393 394 335 391 392 391 397 392 394 392 397 397 426 394 428 394 426 429 428 426 433 428 429 426 433 429 397 427 426 427 430 426 426 430 432 432 433 426 397 391 494 397 494 427 427 483 430 494 483 427 485 430 483 430 485 432 485 488 432 488 491 432 491 433 432 487 488 485 487 491 488 483 484 485 486 485 484 485 489 487 486 489 485 483 492 484 483 494 492 391 492 494 492 493 486 492 486 484 499 493 492 499 492 391 486 446 489 486 449 446 486 493 449 489 446 451 451 487 489 451 490 487 490 491 487 490 464 491 476 449 475 449 476 481 449 493 475 475 443 476 443 445 476 476 445 482 476 482 481 501 481 482 445 477 482 482 500 501 500 482 477 443 444 445 445 444 474 474 477 445 474 478 477 477 478 500 384 500 385 385 500 478 384 501 500 384 367 501 286 384 385 367 384 286 367 286 366 285 286 277 286 285 366 286 385 277 366 285 365 369 366 365 280 285 277 295 285 280 295 365 285 295 294 365 365 294 369 294 370 369 370 371 369 294 295 289 287 370 294 289 287 294 295 296 289 296 295 280 289 288 287 289 293 288 293 289 296 287 270 203 287 288 270 287 203 370 288 292 270 288 293 292 296 284 293 293 284 278 297 293 278 293 297 292 284 296 280 284 280 278 278 276 279 276 278 280 278 279 297 297 298 292 279 298 297 292 291 270 292 298 291 279 276 298 291 298 302 298 313 302 315 313 298 276 315 298 270 291 290 291 302 290 268 203 270 290 268 270 268 290 299 302 299 290 268 299 300 299 301 300 302 301 299 300 271 268 300 303 271 301 308 300 308 303 300 302 314 301 301 314 316 308 301 316 308 309 303 316 317 308 308 317 309 272 316 314 272 317 316 313 314 302 313 275 314 272 314 275 272 273 274 272 275 273 274 317 272 317 274 309 303 309 306 309 274 306 274 273 306 306 307 303 307 306 312 306 273 312 303 307 304 305 304 307 307 310 305 307 312 310 271 303 304 269 271 304 304 305 269 310 311 305 269 305 162 305 311 163 162 305 163 310 318 311 312 282 310 310 282 318 158 163 311 158 311 318 163 164 162 158 165 163 165 164 163 157 158 159 157 165 158 166 159 158 158 318 166 282 281 318 318 281 166 281 282 273 312 273 282 277 281 273 281 283 167 281 277 283 166 281 167 159 166 167 383 167 283 383 159 167 383 283 382 159 383 401 382 401 383 381 382 283 381 401 382 159 401 402 32 401 398 380 401 381 398 401 380 401 32 402 283 380 381 398 380 283 283 28 398 28 32 398 31 32 24 28 25 32 32 25 24 402 32 31 24 29 31 423 31 29 31 423 402 21 24 22 24 25 26 24 26 22 24 21 29 27 26 25 25 28 27 26 363 348 22 26 348 26 329 363 329 26 27 18 21 22 22 348 18 18 20 21 20 29 21 18 19 20 18 344 19 18 348 344 348 347 344 363 362 348 348 362 347 344 343 19 344 347 343 19 23 20 23 19 320 19 343 320 23 30 20 30 29 20 141 23 129 141 30 23 319 23 320 320 341 319 343 341 320 339 340 319 319 340 338 341 342 319 342 339 319 343 346 341 341 350 342 346 350 341 339 342 345 342 350 345 345 340 339 340 357 338 345 357 340 357 356 338 358 357 345 357 328 356 357 358 364 357 364 328 360 358 345 350 360 345 364 358 326 326 358 327 327 358 360 328 364 326 326 327 325 325 328 326 325 327 360 325 360 350 28 325 324 28 328 325 361 325 350 361 324 325 322 28 324 322 324 349 349 324 361 349 361 350 349 350 346 346 359 349 322 349 359 28 322 323 362 322 359 323 322 362 347 359 346 362 359 347 347 346 343 363 323 362 28 323 329 329 323 363 329 27 28 328 28 330 283 277 28 277 330 28 331 328 332 330 332 328 331 356 328 330 335 332 390 391 335 335 400 390 330 400 335 391 390 498 400 498 390 499 391 498 498 497 475 475 499 498 498 400 497 399 400 330 399 497 400 443 497 473 473 497 399 443 475 497 475 493 499 443 473 444 444 473 474 385 473 399 474 473 385 385 399 330 385 330 277 478 474 385 276 277 273 277 276 280 275 276 273 276 313 315 275 313 276 423 29 30 30 141 423 424 423 141 130 423 424 402 423 130 129 140 141 141 140 424 139 424 140 130 424 139 139 140 129 129 61 130 130 139 129 50 60 61 61 60 128 130 61 128 45 60 52 45 56 60 52 60 50 60 56 128 56 131 128 128 131 130 69 131 56 132 131 69 130 131 135 131 132 135 135 144 130 402 130 144 135 132 144 132 142 144 142 145 144 145 425 144 425 402 144 132 134 142 134 137 142 142 137 145 137 143 145 143 153 145 145 153 425 148 402 425 153 152 425 152 148 425 153 143 152 152 143 148 143 105 148 148 105 146 146 151 148 154 402 148 151 154 148 108 146 105 147 146 108 147 149 146 146 149 151 151 149 150 151 150 122 122 154 151 147 123 149 149 123 150 109 147 106 108 106 147 123 147 109 106 108 105 83 106 85 83 86 106 106 105 85 106 86 109 86 107 109 109 107 123 107 114 123 114 150 123 86 84 107 84 114 107 82 84 86 82 86 83 81 84 82 81 100 84 100 110 84 111 84 110 84 111 114 111 122 114 122 150 114 111 110 122 110 100 115 115 120 110 120 121 110 122 110 121 121 127 122 122 127 154 119 121 112 112 121 120 119 125 121 125 127 121 112 120 115 115 100 112 112 102 113 112 100 95 95 102 112 112 113 119 113 116 119 116 125 119 124 125 116 124 127 125 97 103 116 116 102 97 102 116 113 103 118 116 118 124 116 95 101 102 101 97 102 94 97 96 94 98 97 96 97 101 103 97 98 103 117 118 98 99 103 103 99 117 117 126 118 118 126 124 99 227 117 117 227 240 117 240 126 94 99 98 94 93 99 93 224 99 99 224 227 227 224 225 228 227 225 240 227 228 228 241 240 240 241 242 240 242 126 226 228 225 239 228 226 239 241 228 223 225 224 226 225 223 223 224 12 93 12 224 12 221 223 221 226 223 229 226 221 239 226 229 229 234 239 243 241 239 239 234 243 231 229 221 231 234 229 213 221 12 222 221 213 222 231 221 231 233 234 232 231 222 232 233 231 233 244 234 244 243 234 233 232 236 238 233 236 250 233 238 250 244 233 230 232 222 236 232 230 230 222 213 219 230 213 230 219 235 235 236 230 235 238 236 237 238 235 258 238 237 250 238 258 262 244 250 258 264 250 264 262 250 257 258 237 264 258 257 237 235 219 256 257 237 256 237 219 256 259 257 259 264 257 264 265 262 264 259 265 262 265 261 261 244 262 265 263 261 265 260 263 259 260 265 261 245 243 244 261 243 263 245 261 263 266 242 263 242 245 260 266 263 127 260 154 127 266 260 154 260 259 242 266 155 155 266 127 241 245 242 126 242 155 243 245 241 124 155 127 126 155 124 259 256 219 259 219 252 252 267 259 267 154 259 402 154 267 402 267 252 402 164 157 164 402 160 402 252 210 210 209 402 402 209 205 159 402 157 164 160 162 157 164 165 160 161 162 161 269 162 203 268 161 268 269 161 269 268 271 370 203 372 370 372 371 178 205 206 206 205 209 204 178 206 204 206 208 206 200 208 209 200 206 209 210 200 199 200 196 200 201 196 200 199 208 200 210 201 199 197 208 208 207 204 208 197 207 199 194 198 196 194 199 197 199 198 194 196 192 192 196 185 196 201 185 194 192 193 198 194 193 197 198 190 198 193 190 197 190 195 207 197 195 207 195 182 204 207 182 180 195 189 182 195 180 189 195 190 190 187 189 190 191 187 190 193 191 193 192 191 191 192 187 184 187 183 184 189 187 192 183 187 180 189 184 176 184 183 184 176 188 180 184 188 183 5 176 185 5 183 192 185 183 178 188 176 181 180 188 181 188 178 182 178 204 182 181 178 180 181 182 5 185 7 186 7 185 201 186 185 6 5 7 8 6 7 186 8 7 211 8 186 214 186 201 211 186 214 246 214 201 246 201 210 214 217 211 214 246 217 255 217 246 252 246 210 255 246 252 254 255 252 255 254 217 217 247 211 217 249 247 217 253 249 254 253 217 254 251 253 254 252 251 252 219 251 251 219 248 251 248 253 253 248 249 249 220 247 249 248 220 247 215 211 247 220 215 219 218 220 220 218 215 220 248 219 219 213 218 212 218 213 215 218 212 215 212 216 211 215 216 211 11 8 212 11 211 216 212 211 11 212 9 212 213 9 213 10 9 213 12 10 9 10 11 11 6 8 11 15 6 10 15 11 12 13 10 13 15 10 12 17 13 17 12 93 13 16 15 17 16 13 469 15 16 79 16 81 81 16 17 79 403 16 469 16 403 496 469 407 469 403 407 79 404 403 407 403 404 404 406 407 406 408 407 496 407 408 496 408 405 405 408 44 44 408 406 53 406 404 41 406 53 41 44 406 53 54 55 42 53 55 42 41 53 54 53 404 41 42 43 41 43 44 43 42 45 45 42 56 56 42 55 44 43 45 34 44 45 45 46 34 45 52 46 34 46 52 34 52 50 40 50 49 40 34 50 51 49 50 51 50 58 39 34 40 40 49 39 39 49 48 51 48 49 48 51 58 58 47 48 48 47 39 36 34 39 36 39 47 405 35 47 36 47 35 35 34 36 33 34 35 35 37 33 35 405 37 405 44 37 33 37 34 34 37 38 37 44 38 38 44 34 54 57 55 56 55 62 65 62 55 55 57 65 73 54 74 54 73 57 54 404 74 57 73 104 73 74 105 73 105 104 57 104 72 136 72 104 104 105 143 136 104 143 78 105 74 78 85 105 77 78 76 76 78 74 77 85 78 83 85 77 75 77 76 75 80 77 80 83 77 75 76 74 75 79 80 75 74 79 79 81 80 80 81 82 80 82 83 74 404 79 87 88 81 88 90 81 81 90 100 81 92 87 92 81 17 89 90 88 88 87 89 89 95 90 90 95 100 89 87 91 89 91 95 95 91 96 96 101 95 17 91 87 91 17 96 87 92 17 17 93 94 96 17 94 138 143 137 138 136 143 137 136 138 136 137 72 72 137 134 57 72 71 72 133 71 72 134 133 133 134 132 70 133 132 71 133 70 66 57 71 66 71 70 65 57 66 66 67 65 67 66 70 68 70 69 70 68 67 69 70 132 67 63 65 67 68 63 62 65 63 62 63 64 63 68 64 64 68 56 68 69 56 62 64 56 455 453 413 455 454 453))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-2.0386199951171875e+01 -3.1374200439453125e+02 -4.8366799926757812e+02 -2.3539199829101562e+01 -3.0677099609375000e+02 -4.9085400390625000e+02 1.5101799964904785e+00 -3.1135202026367188e+02 -4.8928500366210938e+02 -4.4597099304199219e+01 -3.0689001464843750e+02 -4.8414599609375000e+02 -5.7018898010253906e+01 -2.9444598388671875e+02 -4.9092501831054688e+02 -6.3879600524902344e+01 -2.9806900024414062e+02 -4.8355401611328125e+02 -7.9504402160644531e+01 -2.8077099609375000e+02 -4.9013098144531250e+02 -8.7696296691894531e+01 -2.8020599365234375e+02 -4.8369500732421875e+02 -9.8202201843261719e+01 -2.6863900756835938e+02 -4.8480700683593750e+02 -1.1751300048828125e+02 -2.3654499816894531e+02 -4.8154602050781250e+02 -1.2229100036621094e+02 -2.2218699645996094e+02 -4.8598199462890625e+02 -1.0817900085449219e+02 -2.5467800903320312e+02 -4.8531100463867188e+02 -1.2632499694824219e+02 -2.0250799560546875e+02 -4.8305801391601562e+02 -1.2283100128173828e+02 -2.0779199218750000e+02 -4.8846301269531250e+02 2.8380999565124512e+00 -3.1500100708007812e+02 -4.8454699707031250e+02 -1.0650800323486328e+02 -2.4332200622558594e+02 -4.9088998413085938e+02 -1.2008499908447266e+02 -1.7086500549316406e+02 -4.9096200561523438e+02 -1.2667199707031250e+02 -1.7919799804687500e+02 -4.8404199218750000e+02 1.1191799926757812e+02 -6.4848297119140625e+01 1.1239500427246094e+02 1.4279399108886719e+02 -6.1290599822998047e+01 9.3671005249023438e+01 3.3887100219726562e+01 -6.1976299285888672e+01 1.0249699401855469e+02 4.8612899780273438e+01 -6.6426597595214844e+01 1.1542700195312500e+02 1.0820300292968750e+02 -7.2194801330566406e+01 1.2013199615478516e+02 6.3338198661804199e+00 -6.0985698699951172e+01 8.7461502075195312e+01 5.6660999298095703e+01 -7.6343399047851562e+01 1.2241500091552734e+02 6.1319900512695312e+01 -9.3668296813964844e+01 1.2582799530029297e+02 1.1429700469970703e+02 -8.5984497070312500e+01 1.2432499694824219e+02 1.0525099945068359e+02 -1.0859999847412109e+02 1.2696899414062500e+02 6.2915802001953125e+01 -1.0860800170898438e+02 1.2631200408935547e+02 5.0127498626708984e+01 -6.6561698913574219e+01 1.4194400024414062e+02 2.4879999160766602e+01 -6.1120903015136719e+01 1.4194400024414062e+02 5.8835903167724609e+01 -8.8595100402832031e+01 1.4194400024414062e+02 5.9172801971435547e+01 -9.5810798645019531e+01 1.2853900146484375e+02 -1.0730000495910645e+01 -6.1442901611328125e+01 -4.8100000000000000e+02 -2.2236398696899414e+01 -6.2702796936035156e+01 -3.8613500976562500e+02 9.5290201902389526e-01 -6.0917701721191406e+01 -4.8280001831054688e+02 -1.9158499240875244e+00 -6.0980400085449219e+01 -4.2910598754882812e+02 -1.6738698959350586e+01 -6.2108501434326172e+01 -4.8202401733398438e+02 -2.2900798797607422e+01 -6.3059001922607422e+01 -4.7951800537109375e+02 -4.9496698379516602e+00 -6.1096599578857422e+01 -3.7525601196289062e+02 -7.4571700096130371e+00 -6.1219402313232422e+01 -3.6481298828125000e+02 -5.1831802368164062e+01 -7.2074195861816406e+01 -4.8419100952148438e+02 -5.1448501586914062e+01 -7.1837699890136719e+01 -4.1818197631835938e+02 -4.1733898162841797e+01 -6.8053092956542969e+01 -4.7789700317382812e+02 -3.3772499084472656e+01 -6.5870597839355469e+01 -4.8577499389648438e+02 -4.5538803100585938e+01 -6.9417495727539062e+01 -3.3249499511718750e+02 -3.8335700988769531e+01 -6.6927101135253906e+01 -3.3971801757812500e+02 8.2428798675537109e+00 -6.1171497344970703e+01 -4.8467001342773438e+02 -2.4886200428009033e+00 -6.1024402618408203e+01 -3.2593899536132812e+02 -4.9915499687194824e+00 -6.1098300933837891e+01 -3.2379202270507812e+02 -1.7847801208496094e+01 -6.2045299530029297e+01 -2.3374000549316406e+02 -5.0281000137329102e+00 -6.1099700927734375e+01 -2.7877999877929688e+02 -3.7623199462890625e+01 -6.6652900695800781e+01 -2.6787100219726562e+02 -6.5083602905273438e+01 -7.8729698181152344e+01 -4.8454898071289062e+02 -8.8373199462890625e+01 -9.6403396606445312e+01 -4.8306900024414062e+02 -7.1430694580078125e+01 -8.2839599609375000e+01 -3.1817901611328125e+02 -5.3965900421142578e+01 -7.2992103576660156e+01 -1.9534100341796875e+02 -8.0282005310058594e+01 -8.9474899291992188e+01 -2.3261601257324219e+02 7.0645198822021484e+00 -6.1031799316406250e+01 -2.5213798522949219e+02 9.8963394165039062e+00 -6.0814701080322266e+01 -1.5394900512695312e+02 -4.0323398590087891e+01 -6.7492301940917969e+01 -1.7597700500488281e+02 -1.8255199432373047e+01 -6.1994796752929688e+01 -1.3561299133300781e+02 -6.6130401611328125e+01 -7.9557899475097656e+01 -2.2605200195312500e+02 -7.0306602478027344e+01 -8.2238006591796875e+01 -1.9116101074218750e+02 -6.7984497070312500e+01 -8.0730995178222656e+01 -1.8058801269531250e+02 -7.2347496032714844e+01 -8.3623199462890625e+01 -2.1601000976562500e+02 -7.4448799133300781e+01 -8.5111198425292969e+01 -1.8302699279785156e+02 -7.2442298889160156e+01 -8.3688995361328125e+01 -1.5392500305175781e+02 -7.0382499694824219e+01 -8.2288597106933594e+01 -1.4635198974609375e+02 -7.0481895446777344e+01 -8.2354705810546875e+01 -8.7289993286132812e+01 -7.3517097473144531e+01 -8.4436203002929688e+01 -1.2342700195312500e+02 -7.6505401611328125e+01 -8.6630798339843750e+01 -1.5491700744628906e+02 -8.4778305053710938e+01 -9.3387001037597656e+01 -6.7579795837402344e+01 -9.5364898681640625e+01 -1.0404600524902344e+02 -3.2015600585937500e+02 -1.0613600158691406e+02 -1.1801100158691406e+02 -4.8381100463867188e+02 -1.1370000457763672e+02 -1.3141999816894531e+02 -4.7781900024414062e+02 -1.1168599700927734e+02 -1.2754299926757812e+02 -4.1662200927734375e+02 -1.1353299713134766e+02 -1.3109100341796875e+02 -3.5188000488281250e+02 -1.1157400512695312e+02 -1.2733900451660156e+02 -3.3159802246093750e+02 -1.1730300140380859e+02 -1.3945298767089844e+02 -4.8420199584960938e+02 -1.1539500427246094e+02 -1.3496499633789062e+02 -3.9727398681640625e+02 -1.2269700622558594e+02 -1.5388200378417969e+02 -4.8232098388671875e+02 -1.1702399444580078e+02 -1.3866700744628906e+02 -3.6617898559570312e+02 -1.1526799774169922e+02 -1.3469499206542969e+02 -3.0071099853515625e+02 -1.2293799591064453e+02 -1.5567399597167969e+02 -3.5670001220703125e+02 -1.1342500305175781e+02 -1.3087800598144531e+02 -2.7013299560546875e+02 -1.1687999725341797e+02 -1.3832899475097656e+02 -2.5190200805664062e+02 -1.2599599456787109e+02 -1.7197999572753906e+02 -4.6177200317382812e+02 -1.2579399108886719e+02 -1.7054699707031250e+02 -4.1757901000976562e+02 -1.2613099670410156e+02 -1.7317199707031250e+02 -3.9319198608398438e+02 -1.2596200561523438e+02 -1.7174099731445312e+02 -3.5157800292968750e+02 -1.2642200469970703e+02 -1.7590299987792969e+02 -4.2654800415039062e+02 -1.2580400848388672e+02 -1.7034399414062500e+02 -4.8100201416015625e+02 -1.2700000762939453e+02 -1.8800000000000000e+02 -4.8099899291992188e+02 -1.2690800476074219e+02 -1.8289299011230469e+02 -4.2516000366210938e+02 -1.2640699768066406e+02 -1.7575100708007812e+02 -3.4070797729492188e+02 -1.2664300537109375e+02 -1.7849299621582031e+02 -3.8592800903320312e+02 -1.2681199645996094e+02 -1.8109799194335938e+02 -3.4539199829101562e+02 -1.2695400238037109e+02 -1.8457299804687500e+02 -3.6554800415039062e+02 -1.2700000762939453e+02 -1.8800000000000000e+02 -3.7742199707031250e+02 -1.2562599945068359e+02 -1.6919599914550781e+02 -2.8781802368164062e+02 -1.2663699340820312e+02 -1.7841600036621094e+02 -3.3234097290039062e+02 -1.2663300323486328e+02 -1.7836299133300781e+02 -2.9629702758789062e+02 -1.2695300292968750e+02 -1.8454200744628906e+02 -3.1280200195312500e+02 -9.5416900634765625e+01 -1.0403999328613281e+02 -1.4185800170898438e+02 -1.0484900665283203e+02 -1.1619000244140625e+02 -1.2765499877929688e+02 -1.1427000427246094e+02 -1.3254701232910156e+02 -2.0267599487304688e+02 -1.1907699584960938e+02 -1.4381199645996094e+02 -2.2590699768066406e+02 -1.1133499908447266e+02 -1.2684600067138672e+02 -1.1397200012207031e+02 -1.1675400543212891e+02 -1.3803300476074219e+02 -1.5135798645019531e+02 -1.2474800109863281e+02 -1.6404699707031250e+02 -2.2539601135253906e+02 -1.2339600372314453e+02 -1.5791200256347656e+02 -1.9464099121093750e+02 -1.2625600433349609e+02 -1.7421499633789062e+02 -2.4012300109863281e+02 -1.2662899780273438e+02 -1.7830899047851562e+02 -2.5849700927734375e+02 -1.2086599731445312e+02 -1.4892700195312500e+02 -1.6345800781250000e+02 -1.2554800415039062e+02 -1.6879899597167969e+02 -2.2222100830078125e+02 -1.2680600738525391e+02 -1.8098999023437500e+02 -2.4650900268554688e+02 -1.2700499725341797e+02 -1.8800000000000000e+02 -2.4787298583984375e+02 -1.2695201110839844e+02 -1.8450500488281250e+02 -2.4941700744628906e+02 -1.2651699829101562e+02 -1.7686100769042969e+02 -1.9886599731445312e+02 -1.2572499847412109e+02 -1.7006201171875000e+02 -2.0585299682617188e+02 -1.2600900268554688e+02 -1.7197200012207031e+02 -1.4287799072265625e+02 -1.2486100006103516e+02 -1.6411100769042969e+02 -7.8009597778320312e+01 -1.1823300170898438e+02 -1.4164199829101562e+02 -8.8684295654296875e+01 -1.2695099639892578e+02 -1.8446600341796875e+02 -1.8005900573730469e+02 -1.2672500610351562e+02 -1.7952999877929688e+02 -1.5891799926757812e+02 -1.2700000762939453e+02 -1.8800000000000000e+02 -2.2350500488281250e+02 -1.2685500335693359e+02 -1.8145899963378906e+02 -7.8726501464843750e+01 -5.3327602386474609e+01 -7.2455596923828125e+01 -4.0043701171875000e+01 -2.1231399536132812e+01 -6.2664501190185547e+01 3.2805202484130859e+01 -4.8489299774169922e+01 -7.0055496215820312e+01 1.4194400024414062e+02 -6.7410301208496094e+01 -8.0330604553222656e+01 -2.9937900543212891e+01 -7.3549301147460938e+01 -8.4450294494628906e+01 -1.5339599609375000e+01 -7.6580505371093750e+01 -8.6687400817871094e+01 -9.0714202880859375e+01 -7.8601005554199219e+01 -8.8246505737304688e+01 -4.9109100341796875e+01 -6.7595802307128906e+01 -8.0435905456542969e+01 6.7999198913574219e+01 -8.7625099182128906e+01 -9.6042404174804688e+01 -1.8369300842285156e+01 -8.2434494018554688e+01 -9.1389801025390625e+01 3.8092399597167969e+01 -8.6060798645019531e+01 -9.4605606079101562e+01 2.6018699645996094e+01 -2.7250499725341797e+01 -6.3900096893310547e+01 1.4194400024414062e+02 -1.9763000488281250e+01 -6.2547294616699219e+01 1.4194400024414062e+02 -1.0930399894714355e+01 -6.1416099548339844e+01 1.4194400024414062e+02 -7.8716896057128906e+01 -8.8337600708007812e+01 7.0067298889160156e+01 -9.2582000732421875e+01 -1.0079399871826172e+02 2.9808099746704102e+01 -7.2979400634765625e+01 -8.3932701110839844e+01 1.4194400024414062e+02 -8.3949401855468750e+01 -9.2681999206542969e+01 1.4194400024414062e+02 -1.1253500366210938e+02 -1.2874699401855469e+02 1.7826101303100586e+01 -1.1583100128173828e+02 -1.3588699340820312e+02 -6.1110401153564453e+01 -1.0817500305175781e+02 -1.2098600006103516e+02 1.4194400024414062e+02 -1.1812899780273438e+02 -1.4137500000000000e+02 7.6065498590469360e-01 -1.2105599975585938e+02 -1.4947999572753906e+02 -5.5568298339843750e+01 -1.2200599670410156e+02 -1.5188600158691406e+02 1.4194400024414062e+02 -9.6165199279785156e+01 -1.0490499877929688e+02 1.4194400024414062e+02 -8.8148200988769531e+01 -9.6573005676269531e+01 1.4194400024414062e+02 -1.2711900329589844e+02 -1.8418798828125000e+02 1.4194400024414062e+02 -1.2700000762939453e+02 -1.8800000000000000e+02 -1.1943099975585938e+02 5.1629100799560547e+01 -6.1028999328613281e+01 -1.0152500152587891e+02 5.8887401580810547e+01 -2.7838702392578125e+02 1.4194400024414062e+02 5.6119400024414062e+01 -3.0211801147460938e+02 1.2143900299072266e+02 5.9328498840332031e+01 -2.7456201171875000e+02 1.2837199401855469e+02 2.3114500045776367e+01 -3.1498699951171875e+02 1.4194400024414062e+02 1.1166799545288086e+01 -3.1513000488281250e+02 9.0647300720214844e+01 4.0624698638916016e+01 -3.1278900146484375e+02 1.0823400115966797e+02 5.1440898895263672e+01 -3.0721398925781250e+02 1.1853999328613281e+02 4.4208099365234375e+01 -3.1167599487304688e+02 1.4194400024414062e+02 5.5495601654052734e+01 -3.0183898925781250e+02 1.4194299316406250e+02 6.1112197875976562e+01 -2.8743099975585938e+02 1.2522800445556641e+02 6.2940799713134766e+01 -2.6739199829101562e+02 1.2680700683593750e+02 -1.1595199584960938e+01 -3.1453500366210938e+02 -3.5641101074218750e+02 -2.4380199432373047e+01 -3.1276699829101562e+02 -3.0230398559570312e+02 -1.1757100105285645e+01 -3.1449499511718750e+02 -2.1956600952148438e+02 -4.9355201721191406e+01 -3.0504199218750000e+02 -3.9170101928710938e+02 -4.1970600128173828e+01 -3.0786199951171875e+02 -4.0246701049804688e+02 -3.8290897369384766e+01 -3.0908700561523438e+02 -3.5388897705078125e+02 -3.7898101806640625e+01 -3.0921301269531250e+02 -4.7791998291015625e+02 -3.4576801300048828e+01 -3.1019900512695312e+02 -3.1122601318359375e+02 -4.6176799774169922e+01 -3.0639801025390625e+02 -2.8801000976562500e+02 2.7423400878906250e+00 -3.1506500244140625e+02 -1.5879299926757812e+02 -3.9852897644042969e+01 -3.0868301391601562e+02 -1.0809200286865234e+02 -2.0531499862670898e+01 -3.1357601928710938e+02 1.4194400024414062e+02 -5.8142700195312500e+01 -3.0090600585937500e+02 -1.9857699584960938e+02 -5.5651100158691406e+01 -3.0215399169921875e+02 -1.4608399963378906e+02 -5.8330699920654297e+01 -3.0080899047851562e+02 -1.2444400024414062e+02 -6.6638404846191406e+01 -2.9622900390625000e+02 -3.2167300415039062e+02 -5.7937900543212891e+01 -3.0101098632812500e+02 -2.7876202392578125e+02 -8.2374000549316406e+01 -2.8479199218750000e+02 -3.3335900878906250e+02 -9.4717498779296875e+01 -2.7269799804687500e+02 -2.6646102905273438e+02 -6.3624202728271484e+01 -2.9793399047851562e+02 -2.7506301879882812e+02 -5.5408798217773438e+01 -3.0227200317382812e+02 -2.3635398864746094e+02 -6.0688899993896484e+01 -2.9955801391601562e+02 -2.2391900634765625e+02 -6.3186698913574219e+01 -2.9816299438476562e+02 -1.9436499023437500e+02 -6.5499496459960938e+01 -2.9680401611328125e+02 -2.3661300659179688e+02 -6.9072097778320312e+01 -2.9458099365234375e+02 -2.3104899597167969e+02 -6.5608001708984375e+01 -2.9673800659179688e+02 -1.8407099914550781e+02 -6.7984497070312500e+01 -2.9526901245117188e+02 -1.8058801269531250e+02 -6.0861900329589844e+01 -2.9946398925781250e+02 -1.5147499084472656e+02 -7.1913299560546875e+01 -2.9268899536132812e+02 -1.6620199584960938e+02 -6.3359996795654297e+01 -2.9806301879882812e+02 -1.1645100402832031e+02 -6.5697502136230469e+01 -2.9668399047851562e+02 -1.4053199768066406e+02 -6.6962699890136719e+01 -2.9591900634765625e+02 -1.0181999969482422e+02 -7.2715995788574219e+01 -2.9224600219726562e+02 -8.2801498413085938e+01 -8.6448898315429688e+01 -2.8137399291992188e+02 -9.2565093994140625e+01 -1.0263100624084473e+01 -3.1461700439453125e+02 -7.0137901306152344e+01 6.2046901702880859e+01 -3.1500900268554688e+02 -9.8233200073242188e+01 -5.8526798248291016e+01 -3.0070700073242188e+02 -4.6357597351074219e+01 -4.7585800170898438e+01 -3.0591699218750000e+02 1.4194400024414062e+02 -5.4899799346923828e+01 -3.0267501831054688e+02 9.2592601776123047e+00 -6.1012100219726562e+01 -2.9938198852539062e+02 -8.8112503051757812e+01 -6.2307102203369141e+01 -2.9867102050781250e+02 -5.1939498901367188e+01 -6.9274101257324219e+01 -2.9458401489257812e+02 1.4194400024414062e+02 -8.4998199462890625e+01 -2.8273001098632812e+02 1.4194400024414062e+02 -1.0532999420166016e+02 -2.5908700561523438e+02 -2.4356498718261719e+02 -1.1205500030517578e+02 -2.4785600280761719e+02 -2.7908798217773438e+02 -1.2067300415039062e+02 -2.2898800659179688e+02 -3.0631500244140625e+02 -1.0001100158691406e+02 -2.6635598754882812e+02 -1.3120600891113281e+02 -1.1327199554443359e+02 -2.4542500305175781e+02 -1.5344099426269531e+02 -1.1048399353027344e+02 -2.5065400695800781e+02 -2.2892799377441406e+02 -1.0815100097656250e+02 -2.5472700500488281e+02 -3.6759201049804688e+01 -1.1514399719238281e+02 -2.4157199096679688e+02 -2.0518901062011719e+02 -1.2057500457763672e+02 -2.2810200500488281e+02 -1.2323999786376953e+02 -1.1501900482177734e+02 -2.4184001159667969e+02 -1.0840200042724609e+02 -1.2586399841308594e+02 -2.0514599609375000e+02 -3.3965701293945312e+02 -1.2550599670410156e+02 -2.0747900390625000e+02 -2.8637399291992188e+02 -1.2668299865722656e+02 -1.9715599060058594e+02 -4.0105300903320312e+02 -1.2695400238037109e+02 -1.9139799499511719e+02 -4.1550897216796875e+02 -1.2681299591064453e+02 -1.9489300537109375e+02 -3.5360501098632812e+02 -1.2663500213623047e+02 -1.9761300659179688e+02 -3.1232897949218750e+02 -1.2695300292968750e+02 -1.9145800781250000e+02 -3.1191400146484375e+02 -1.2680899810791016e+02 -1.9496600341796875e+02 -2.8730599975585938e+02 -1.2639699554443359e+02 -2.0034899902343750e+02 -2.8342398071289062e+02 -1.2384899902343750e+02 -2.1629400634765625e+02 -2.2046199035644531e+02 -1.2609900665283203e+02 -2.0309098815917969e+02 -2.6388000488281250e+02 -1.2572999572753906e+02 -2.0589799499511719e+02 -2.2334700012207031e+02 -1.2607899475097656e+02 -2.0325199890136719e+02 -1.8491000366210938e+02 -1.2638899993896484e+02 -2.0043598937988281e+02 -2.3421800231933594e+02 -1.2518100738525391e+02 -2.0940499877929688e+02 -2.0450900268554688e+02 -1.2572499847412109e+02 -2.0593800354003906e+02 -2.0585299682617188e+02 -1.2514799499511719e+02 -2.0959300231933594e+02 -1.3009400939941406e+02 -1.2570400238037109e+02 -2.0608599853515625e+02 -1.4065200805664062e+02 -1.2662699890136719e+02 -1.9771299743652344e+02 -2.4319900512695312e+02 -1.2695201110839844e+02 -1.9149499511718750e+02 -2.4941700744628906e+02 -1.2680399322509766e+02 -1.9504000854492188e+02 -2.1940701293945312e+02 -1.2694999694824219e+02 -1.9154598999023438e+02 -1.6055999755859375e+02 -1.2662099456787109e+02 -1.9780000305175781e+02 -1.8225199890136719e+02 -1.2637500762939453e+02 -2.0056900024414062e+02 -1.5792599487304688e+02 -1.2680100250244141e+02 -1.9510899353027344e+02 -1.5515600585937500e+02 -1.0044000244140625e+02 -2.6606399536132812e+02 1.4194400024414062e+02 -1.1314199829101562e+02 -2.4568299865722656e+02 -5.2696300506591797e+01 -1.1664599609375000e+02 -2.3821899414062500e+02 -6.4641296386718750e+01 -1.1488600158691406e+02 -2.4212699890136719e+02 -3.3939599990844727e+00 -1.2606100463867188e+02 -2.0340600585937500e+02 -1.0817099761962891e+02 -1.1812899780273438e+02 -2.3462500000000000e+02 7.6065498590469360e-01 -1.2146700286865234e+02 -2.2549400329589844e+02 1.4194400024414062e+02 -1.1654900360107422e+02 -2.3844400024414062e+02 1.3889599800109863e+01 -1.1647100067138672e+02 -2.3862699890136719e+02 7.8563896179199219e+01 -1.1480799865722656e+02 -2.4254100036621094e+02 1.4194400024414062e+02 -1.2445999908447266e+02 -2.1326200866699219e+02 -6.0051300048828125e+01 -1.2542100524902344e+02 -2.0802400207519531e+02 -5.9027999877929688e+01 -1.2568999481201172e+02 -2.0618299865722656e+02 -9.7443496704101562e+01 -1.2588199615478516e+02 -2.0557299804687500e+02 2.0804300308227539e+01 -1.2679399871826172e+02 -1.9523599243164062e+02 -3.7121097564697266e+01 -1.2661300659179688e+02 -1.9789500427246094e+02 -1.1558899688720703e+02 -1.2636199951171875e+02 -2.0070700073242188e+02 -7.7984001159667969e+01 -1.2679700469970703e+02 -1.9517800903320312e+02 -9.1553199768066406e+01 -1.2621499633789062e+02 -2.0215199279785156e+02 -4.2187500000000000e+01 -1.2660600280761719e+02 -1.9799299621582031e+02 -4.6739803314208984e+01 -1.2694899749755859e+02 -1.9159799194335938e+02 -6.8973701477050781e+01 -1.2626600646972656e+02 -2.0277099609375000e+02 1.4194400024414062e+02 1.9505799865722656e+02 -3.1499499511718750e+02 -1.7240200042724609e+01 1.1118499755859375e+02 -3.1495300292968750e+02 9.6514999389648438e+01 1.6698199462890625e+02 -3.1492401123046875e+02 -7.7959205627441406e+01 1.7156500244140625e+02 -3.1500698852539062e+02 6.1691299438476562e+01 2.2490299987792969e+02 -2.6739199829101562e+02 2.6359598159790039e+01 1.7702099609375000e+02 -2.6739300537109375e+02 1.0179799652099609e+02 2.0350900268554688e+02 -2.6740802001953125e+02 7.4386405944824219e+01 2.2587600708007812e+02 -2.6739199829101562e+02 -1.7441999435424805e+01 2.1618600463867188e+02 -2.6739199829101562e+02 -5.2203098297119141e+01 6.2462699890136719e+01 -2.6739199829101562e+02 -5.5947799682617188e+01 1.6963299560546875e+02 -2.6739300537109375e+02 -1.0655100250244141e+02 1.9776300048828125e+02 -2.6739599609375000e+02 -8.1758499145507812e+01 1.1587899780273438e+02 -2.6739199829101562e+02 -1.2622700500488281e+02 1.0835600280761719e+02 -2.6739199829101562e+02 1.2680999755859375e+02 1.4104899597167969e+02 -2.6741299438476562e+02 1.2079499816894531e+02 6.2748798370361328e+01 -2.6739199829101562e+02 5.5877300262451172e+01 1.5003298950195312e+02 -2.6740200805664062e+02 -1.1716699981689453e+02 8.7536903381347656e+01 -2.6739498901367188e+02 -1.2757099914550781e+02 6.2513999938964844e+01 -2.6739901733398438e+02 -1.4090199279785156e+02 1.0484600067138672e+02 -3.1273999023437500e+02 -1.1165100097656250e+02 1.4487400817871094e+02 -3.1211199951171875e+02 -1.0471600341796875e+02 1.2478700256347656e+02 -3.0926702880859375e+02 -1.1617199707031250e+02 2.0559400939941406e+02 -3.1240200805664062e+02 -3.7847198486328125e+01 2.0100599670410156e+02 -3.0912899780273438e+02 -6.1296501159667969e+01 1.8040199279785156e+02 -3.0926300048828125e+02 -8.6614494323730469e+01 1.5322299194335938e+02 -3.0329598999023438e+02 -1.1073700714111328e+02 8.2857498168945312e+01 -3.0520700073242188e+02 -1.2201199340820312e+02 1.1074400329589844e+02 -2.9530099487304688e+02 -1.2432800292968750e+02 1.3035899353027344e+02 -2.9492300415039062e+02 -1.2116300201416016e+02 1.8080400085449219e+02 -2.9668899536132812e+02 -9.5126502990722656e+01 2.0724900817871094e+02 -2.9833901977539062e+02 -6.2189098358154297e+01 2.1335899353027344e+02 -3.1186700439453125e+02 -6.0748000144958496e+00 2.0096099853515625e+02 -3.1384201049804688e+02 3.5687397003173828e+01 2.1591200256347656e+02 -3.0791699218750000e+02 2.6680400848388672e+01 2.1923300170898438e+02 -3.0627798461914062e+02 -1.9833499908447266e+01 1.8280999755859375e+02 -3.1150500488281250e+02 7.7822700500488281e+01 1.4647799682617188e+02 -3.1408798217773438e+02 9.2877593994140625e+01 1.2100800323486328e+02 -3.1171099853515625e+02 1.1034899902343750e+02 1.8365701293945312e+02 -2.9859201049804688e+02 9.0514602661132812e+01 1.6213800048828125e+02 -3.0902200317382812e+02 9.8933700561523438e+01 2.0798799133300781e+02 -3.0816598510742188e+02 4.8401100158691406e+01 1.9659300231933594e+02 -3.0168701171875000e+02 7.4555595397949219e+01 1.3999200439453125e+02 -3.0158801269531250e+02 1.1552600097656250e+02 1.0781399536132812e+02 -3.0665798950195312e+02 1.1866900634765625e+02 1.6411300659179688e+02 -2.9812600708007812e+02 1.0537500000000000e+02 2.2299400329589844e+02 -2.9439498901367188e+02 -2.0850200653076172e+01 2.2492698669433594e+02 -2.9130798339843750e+02 1.0091500282287598e+01 2.1649299621582031e+02 -2.8537301635742188e+02 -4.7570602416992188e+01 2.1820700073242188e+02 -2.9173400878906250e+02 4.0720397949218750e+01 2.0847299194335938e+02 -2.9139099121093750e+02 6.2196399688720703e+01 1.1234600067138672e+02 -2.9037298583984375e+02 1.2461299896240234e+02 1.8967900085449219e+02 -6.1024597167968750e+01 -4.9712596893310547e+01 1.8978999328613281e+02 -6.1012500762939453e+01 3.4521800994873047e+01 1.5169900512695312e+02 -6.1478599548339844e+01 -9.1658599853515625e+01 1.8291999816894531e+02 -1.0859300231933594e+02 9.6916694641113281e+01 1.5508300781250000e+02 -1.0860099792480469e+02 1.1465500640869141e+02 2.0269400024414062e+02 -1.0860900115966797e+02 7.5614196777343750e+01 2.2066900634765625e+02 -1.0860499572753906e+02 4.0891098022460938e+01 2.2416400146484375e+02 -1.0860800170898438e+02 -2.9159299850463867e+01 2.2650300598144531e+02 -1.0860600280761719e+02 1.4042599678039551e+01 2.0614999389648438e+02 -1.0860800170898438e+02 -7.0524795532226562e+01 1.3126400756835938e+02 -1.0860099792480469e+02 1.2347300720214844e+02 6.2328598022460938e+01 -1.0860800170898438e+02 -1.1428699493408203e+02 1.7696099853515625e+02 -1.0860800170898438e+02 -1.0131099700927734e+02 8.6748596191406250e+01 -1.0860700225830078e+02 -1.2766300201416016e+02 1.2106999969482422e+02 -1.0860200500488281e+02 -1.2573200225830078e+02 1.4651100158691406e+02 -1.0858499908447266e+02 -1.1856500244140625e+02 6.3028701782226562e+01 -1.0854899597167969e+02 -1.4211199951171875e+02 1.1459300231933594e+02 -6.4040100097656250e+01 -1.1340100097656250e+02 1.5310501098632812e+02 -6.6487297058105469e+01 -1.0582599639892578e+02 1.8040199279785156e+02 -6.6737098693847656e+01 -8.6614494323730469e+01 2.0559400939941406e+02 -6.3598094940185547e+01 -3.7847198486328125e+01 2.0100599670410156e+02 -6.6871398925781250e+01 -6.1296501159667969e+01 2.0883299255371094e+02 -6.4032302856445312e+01 3.2384399414062500e+01 2.1335899353027344e+02 -6.4132896423339844e+01 -6.0748000144958496e+00 1.7669700622558594e+02 -6.2966503143310547e+01 7.6760398864746094e+01 1.4589900207519531e+02 -6.2486598968505859e+01 9.6739997863769531e+01 2.1923300170898438e+02 -6.9722396850585938e+01 -1.9833499908447266e+01 1.9633999633789062e+02 -6.6740600585937500e+01 6.6335098266601562e+01 1.6528601074218750e+02 -6.8328399658203125e+01 9.8848701477050781e+01 1.3801499938964844e+02 -6.9305099487304688e+01 1.1298100280761719e+02 1.9786100769042969e+02 -7.6490097045898438e+01 7.4741500854492188e+01 2.1694299316406250e+02 -7.3412796020507812e+01 3.5626602172851562e+01 1.2864700317382812e+02 -7.2067199707031250e+01 -1.1918599700927734e+02 7.6779800415039062e+01 -6.7272903442382812e+01 -1.1990900421142578e+02 1.5159500122070312e+02 -7.9211799621582031e+01 -1.1318799591064453e+02 1.1080500030517578e+02 -7.9300094604492188e+01 -1.2408900451660156e+02 1.7079899597167969e+02 -8.1520103454589844e+01 -1.0284200286865234e+02 1.9033700561523438e+02 -8.2586799621582031e+01 -8.6301101684570312e+01 2.0724900817871094e+02 -7.7661300659179688e+01 -6.2189098358154297e+01 2.2358399963378906e+02 -8.2799705505371094e+01 -1.9464298248291016e+01 1.8101300048828125e+02 -7.5168296813964844e+01 9.1508003234863281e+01 2.2435900878906250e+02 -8.3476997375488281e+01 1.2755200386047363e+01 2.0858399963378906e+02 -8.4341201782226562e+01 6.1897300720214844e+01 1.6375500488281250e+02 -8.4603599548339844e+01 1.0734999847412109e+02 1.4271398925781250e+02 -8.3362800598144531e+01 1.1685800170898438e+02 2.1571800231933594e+02 -9.1999206542968750e+01 -4.9814800262451172e+01 8.7036697387695312e+01 -2.9379901123046875e+02 -1.2553599548339844e+02 6.8245300292968750e+01 -2.8651602172851562e+02 -1.3351300048828125e+02 6.1130500793457031e+01 -2.6248800659179688e+02 -1.4557200622558594e+02 5.6205699920654297e+01 -2.8227001953125000e+02 -1.5092100524902344e+02 6.2038600921630859e+01 -3.0337100219726562e+02 -1.3188099670410156e+02 6.7993499755859375e+01 -3.1167901611328125e+02 -1.1864200592041016e+02 4.7243198394775391e+01 -3.1145999145507812e+02 -1.3330999755859375e+02 2.8281700134277344e+01 -3.1403900146484375e+02 -1.4085299682617188e+02 4.7516597747802734e+01 -2.9838800048828125e+02 -1.6372099304199219e+02 5.3583999633789062e+01 -2.6605599975585938e+02 -1.7091000366210938e+02 4.8974998474121094e+01 -3.0503100585937500e+02 -1.4592599487304688e+02 5.1542900085449219e+01 -2.8634899902343750e+02 -1.7528800964355469e+02 4.4716899871826172e+01 -3.0302600097656250e+02 -1.6806399536132812e+02 3.4729598999023438e+01 -3.1068997192382812e+02 -1.6184799194335938e+02 2.3630599975585938e+01 -3.1342300415039062e+02 -2.4038699340820312e+02 6.2940902709960938e+01 -1.7016799926757812e+02 1.2680700683593750e+02 6.2940902709960938e+01 -1.9048100280761719e+02 1.2680700683593750e+02 6.2940902709960938e+01 -2.0536700439453125e+02 1.2680700683593750e+02 6.2895500183105469e+01 -2.2862599182128906e+02 1.2661099243164062e+02 6.2278999328613281e+01 -2.5655401611328125e+02 -1.3603599548339844e+02 6.2297599792480469e+01 -2.5661001586914062e+02 -1.2692299652099609e+02 8.5051795959472656e+01 -7.8910697937011719e+01 -1.2524400329589844e+02 7.1835899353027344e+01 -8.5611503601074219e+01 -1.3085398864746094e+02 5.6591102600097656e+01 -6.9802497863769531e+01 -1.3307299804687500e+02 5.5134201049804688e+01 -7.7696502685546875e+01 -1.4283799743652344e+02 6.2201702117919922e+01 -1.1408899688720703e+02 -1.4380200195312500e+02 5.5387401580810547e+01 -1.1356700134277344e+02 -1.5869200134277344e+02 5.5431999206542969e+01 -8.7636199951171875e+01 -1.5060900878906250e+02 4.5932098388671875e+01 -7.4454002380371094e+01 -1.6649099731445312e+02 5.2335098266601562e+01 -9.2347602844238281e+01 -1.6989299011230469e+02 5.3190799713134766e+01 -6.2290901184082031e+01 -1.1772900390625000e+02 3.3222400665283203e+01 -6.4302398681640625e+01 -1.6042700195312500e+02 5.3657798767089844e+01 -1.1000399780273438e+02 -1.7429100036621094e+02 6.2940799713134766e+01 -1.5574699401855469e+02 1.2680700683593750e+02 6.2292499542236328e+01 -1.1939399719238281e+02 -1.2692299652099609e+02 6.2272701263427734e+01 -1.1941199493408203e+02 -1.3617999267578125e+02 5.9509197235107422e+01 -1.9394999694824219e+02 1.2818301391601562e+02 5.8883903503417969e+01 -2.2609100341796875e+02 1.4194400024414062e+02 -1.1384999847412109e+02 -1.4769999694824219e+02 -4.9088497924804688e+02 -9.8200798034667969e+01 -1.1189299774169922e+02 -4.8877398681640625e+02 -5.3559803962707520e-01 -6.3575000762939453e+01 -4.8864099121093750e+02 -6.4981201171875000e+01 -8.2831504821777344e+01 -4.8920700073242188e+02 -7.3221199035644531e+01 -9.1562194824218750e+01 -4.9095999145507812e+02 -1.7018400192260742e+01 -6.9224998474121094e+01 -4.9095700073242188e+02 5.7139602661132812e+01 -2.8626599121093750e+02 -3.1033099365234375e+02 5.6464599609375000e+01 -2.6618798828125000e+02 -2.6258700561523438e+02 3.8864299774169922e+01 -3.0939401245117188e+02 -3.0262899780273438e+02 4.9913398742675781e+01 -3.0154202270507812e+02 -3.2128598022460938e+02 6.3399394989013672e+01 -2.6371801757812500e+02 -3.6246301269531250e+02 6.5713005065917969e+01 -2.7342700195312500e+02 -4.0574301147460938e+02 6.3319801330566406e+01 -2.8564501953125000e+02 -4.1479598999023438e+02 5.5794399261474609e+01 -2.9839102172851562e+02 -3.9160098266601562e+02 6.0450901031494141e+01 -2.9500698852539062e+02 -4.8320498657226562e+02 6.8412399291992188e+01 -2.6682498168945312e+02 -4.8195898437500000e+02 3.6712699890136719e+01 -3.1104800415039062e+02 -3.6817700195312500e+02 4.6029399871826172e+01 -3.0695700073242188e+02 -4.8577099609375000e+02 5.0595001220703125e+01 -3.0403799438476562e+02 -4.8366000366210938e+02 2.1635700225830078e+01 -3.1359899902343750e+02 -4.8338500976562500e+02 -5.3496799468994141e+00 -7.8661201477050781e+01 1.4194400024414062e+02 -2.5222499847412109e+01 -6.9428802490234375e+01 1.4194400024414062e+02 -7.7815505981445312e+01 -9.6963195800781250e+01 1.4194400024414062e+02 5.4910896301269531e+01 -9.8731803894042969e+01 -2.4874000549316406e+02 5.4471897125244141e+01 -1.1087000274658203e+02 -2.2128300476074219e+02 5.4691501617431641e+01 -8.2129905700683594e+01 -3.1838500976562500e+02 5.6865798950195312e+01 -9.1648300170898438e+01 -3.0131500244140625e+02 5.7725601196289062e+01 -1.1230100250244141e+02 -2.8730401611328125e+02 4.8052097320556641e+01 -7.3384002685546875e+01 -2.8891302490234375e+02 6.5324203491210938e+01 -1.1424700164794922e+02 -3.8867199707031250e+02 6.5102302551269531e+01 -9.9474403381347656e+01 -4.0381900024414062e+02 6.8174400329589844e+01 -1.0735099792480469e+02 -4.7958200073242188e+02 6.3778602600097656e+01 -8.8201004028320312e+01 -4.8524600219726562e+02 5.9992801666259766e+01 -8.1926399230957031e+01 -4.2564300537109375e+02 5.1288002014160156e+01 -7.1880897521972656e+01 -4.8342498779296875e+02 4.8997997283935547e+01 -7.1204002380371094e+01 -3.8575198364257812e+02 3.4768501281738281e+01 -6.5274200439453125e+01 -2.6661801147460938e+02 4.0111099243164062e+01 -6.6316703796386719e+01 -3.7790499877929688e+02 3.1249099731445312e+01 -6.4454200744628906e+01 -4.8672802734375000e+02 2.5231599807739258e+01 -6.2455299377441406e+01 -3.7020498657226562e+02 4.0435199737548828e+01 -1.4675999450683594e+02 -1.4050100708007812e+02 3.5379398345947266e+01 -1.7190299987792969e+02 -1.4632701110839844e+02 3.3710800170898438e+01 -1.8929299926757812e+02 -1.5197799682617188e+02 3.8041801452636719e+01 -1.4632800292968750e+02 -2.9307800292968750e+02 3.6891399383544922e+01 -2.3175099182128906e+02 -2.8500100708007812e+02 5.6724601745605469e+01 -2.2361599731445312e+02 -4.1753100585937500e+02 2.0352001190185547e+01 -1.4523300170898438e+02 -1.7375000000000000e+02 2.0800600051879883e+01 -2.3014799499511719e+02 -1.7905500793457031e+02 5.6568397521972656e+01 -1.4927899169921875e+02 -4.1521398925781250e+02 5.3439201354980469e+01 -2.6167199707031250e+02 -2.3931999206542969e+02 5.8864799499511719e+01 -2.6086499023437500e+02 -3.2538900756835938e+02 4.4320899963378906e+01 -2.5292199707031250e+02 -2.6502697753906250e+02 5.7672000885009766e+01 -2.5244700622558594e+02 -3.7765499877929688e+02 5.7236297607421875e+01 -2.3786799621582031e+02 -4.1006500244140625e+02 5.0562500000000000e+01 -2.4623300170898438e+02 -3.5103399658203125e+02 6.7357398986816406e+01 -2.4938299560546875e+02 -4.2535900878906250e+02 6.3268600463867188e+01 -2.2742300415039062e+02 -4.4014700317382812e+02 6.0768299102783203e+01 -1.8800000000000000e+02 -4.3790701293945312e+02 6.5125694274902344e+01 -1.9052600097656250e+02 -4.4929199218750000e+02 3.3770599365234375e+01 -2.3974099731445312e+02 -2.4545800781250000e+02 6.8844306945800781e+01 -2.3044499206542969e+02 -4.4780999755859375e+02 6.9593597412109375e+01 -1.7632899475097656e+02 -4.5589797973632812e+02 3.0507600784301758e+01 -2.4781100463867188e+02 -1.7606399536132812e+02 3.7325199127197266e+01 -2.5330400085449219e+02 -1.6570500183105469e+02 4.3810901641845703e+01 -3.0095098876953125e+02 -4.9094400024414062e+02 6.2465599060058594e+01 -2.8464199829101562e+02 -4.8897601318359375e+02 6.1174697875976562e+01 -2.6993798828125000e+02 -4.9099499511718750e+02 6.7371505737304688e+01 -2.2282800292968750e+02 -4.8778097534179688e+02 7.0070495605468750e+01 -1.6727200317382812e+02 -4.8256497192382812e+02 6.5605300903320312e+01 -1.5878300476074219e+02 -4.8958398437500000e+02 4.2002399444580078e+01 -1.4297000122070312e+02 -1.2692299652099609e+02 3.4187202453613281e+01 -1.9069400024414062e+02 -1.2692299652099609e+02 2.8171400070190430e+01 -1.4148400878906250e+02 -1.5264700317382812e+02 2.4904899597167969e+01 -1.9269400024414062e+02 -1.6169300842285156e+02 4.0530799865722656e+01 -2.2916500854492188e+02 -1.3999900817871094e+02 4.3324298858642578e+01 -2.3544799804687500e+02 -1.2692299652099609e+02 2.3212999343872070e+01 -2.3883099365234375e+02 -1.7658000183105469e+02 5.1200099945068359e+01 -2.6127499389648438e+02 -1.7388899230957031e+02 2.2772100448608398e+01 -2.3481300354003906e+02 -1.6369200134277344e+02 3.0628499984741211e+01 -2.3436000061035156e+02 -1.4972200012207031e+02 5.2199798583984375e+01 -1.1576899719238281e+02 -2.5313899230957031e+02 4.3601799011230469e+01 -1.2417300415039062e+02 -2.6421401977539062e+02 5.5447898864746094e+01 -1.2038300323486328e+02 -3.4373699951171875e+02 3.3618099212646484e+01 -1.3564399719238281e+02 -2.4359400939941406e+02 6.0310501098632812e+01 -1.2876899719238281e+02 -4.0998797607421875e+02 6.3381999969482422e+01 -1.2115499877929688e+02 -3.9515798950195312e+02 5.3292900085449219e+01 -1.3488000488281250e+02 -3.8138397216796875e+02 6.3668495178222656e+01 -1.4815899658203125e+02 -4.4042501831054688e+02 6.7989799499511719e+01 -1.3153399658203125e+02 -4.3456799316406250e+02 3.6272701263427734e+01 -1.2317900085449219e+02 -1.7338800048828125e+02 2.2915300369262695e+01 -1.3762800598144531e+02 -1.7542199707031250e+02 5.1267898559570312e+01 -1.1465200042724609e+02 -1.7844801330566406e+02 6.6065803527832031e+01 -1.0483200073242188e+02 -4.8713601684570312e+02 5.5346401214599609e+01 -8.3324096679687500e+01 -4.9100198364257812e+02 4.9384998321533203e+01 -1.3075900268554688e+02 -1.3719200134277344e+02 4.6587898254394531e+01 -1.2431999969482422e+02 -1.4516999816894531e+02 3.1689800262451172e+01 -1.2922300720214844e+02 -1.6045600891113281e+02 4.9874397277832031e+01 -2.4590901184082031e+02 -1.3708599853515625e+02 4.4320098876953125e+01 -2.5143301391601562e+02 -1.4733399963378906e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 82 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0044000297784805e+02 -2.6606398820877075e+02 1.4194400608539581e+02) (float-vector -8.6448900401592255e+01 -2.8137400746345520e+02 -9.2565096914768219e+01) (float-vector -9.8202198743820190e+01 -2.6863899827003479e+02 -4.8480701446533203e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0044000297784805e+02 -2.6606398820877075e+02 1.4194400608539581e+02) (float-vector -6.9274097681045532e+01 -2.9458400607109070e+02 1.4194400608539581e+02) (float-vector -8.6448900401592255e+01 -2.8137400746345520e+02 -9.2565096914768219e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2711900472640991e+02 -1.8418799340724945e+02 1.4194400608539581e+02) (float-vector -1.2588199973106384e+02 -2.0557299256324768e+02 2.0804300904273987e+01) (float-vector -1.2632499635219574e+02 -2.0250800251960754e+02 -4.8305800557136536e+02) (float-vector -1.2667199969291687e+02 -1.7919799685478210e+02 -4.8404198884963989e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1288001239299774e+01 -7.1880899369716644e+01 -4.8342499136924744e+02) (float-vector 3.1249100342392921e+01 -6.4454197883605957e+01 -4.8672801256179810e+02) (float-vector 5.5346399545669556e+01 -8.3324097096920013e+01 -4.9100199341773987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1288001239299774e+01 -7.1880899369716644e+01 -4.8342499136924744e+02) (float-vector 2.1923300623893738e+02 -6.9722399115562439e+01 -1.9833499565720558e+01) (float-vector 2.1335899829864502e+02 -6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 1.8967899680137634e+02 -6.1024598777294159e+01 -4.9712598323822021e+01) (float-vector 3.1249100342392921e+01 -6.4454197883605957e+01 -4.8672801256179810e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.3879601657390594e+01 -2.9806900024414062e+02 -4.8355400562286377e+02) (float-vector -6.9274097681045532e+01 -2.9458400607109070e+02 1.4194400608539581e+02) (float-vector -2.0531499758362770e+01 -3.1357601284980774e+02 1.4194400608539581e+02) (float-vector -2.0386200398206711e+01 -3.1374201178550720e+02 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2269700318574905e+02 -1.5388199687004089e+02 -4.8232099413871765e+02) (float-vector -1.2200599908828735e+02 -1.5188600122928619e+02 1.4194400608539581e+02) (float-vector -1.2711900472640991e+02 -1.8418799340724945e+02 1.4194400608539581e+02) (float-vector -1.2667199969291687e+02 -1.7919799685478210e+02 -4.8404198884963989e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0613600164651871e+02 -1.1801099777221680e+02 -4.8381099104881287e+02) (float-vector -1.0817500203847885e+02 -1.2098599970340729e+02 1.4194400608539581e+02) (float-vector -1.2200599908828735e+02 -1.5188600122928619e+02 1.4194400608539581e+02) (float-vector -1.2269700318574905e+02 -1.5388199687004089e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2146700173616409e+02 -2.2549399733543396e+02 1.4194400608539581e+02) (float-vector -1.2588199973106384e+02 -2.0557299256324768e+02 2.0804300904273987e+01) (float-vector -1.2711900472640991e+02 -1.8418799340724945e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1249100342392921e+01 -6.4454197883605957e+01 -4.8672801256179810e+02) (float-vector -5.3559802472591400e-01 -6.3574999570846558e+01 -4.8864099383354187e+02) (float-vector -1.7018400132656097e+01 -6.9224998354911804e+01 -4.9095699191093445e+02) (float-vector 5.5346399545669556e+01 -8.3324097096920013e+01 -4.9100199341773987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1831800490617752e+01 -7.2074197232723236e+01 -4.8419100046157837e+02) (float-vector -8.8373199105262756e+01 -9.6403397619724274e+01 -4.8306900262832642e+02) (float-vector -7.3221199214458466e+01 -9.1562196612358093e+01 -4.9096000194549561e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.5346399545669556e+01 -8.3324097096920013e+01 -4.9100199341773987e+02) (float-vector 6.3778601586818695e+01 -8.8201001286506653e+01 -4.8524600267410278e+02) (float-vector 2.1923300623893738e+02 -6.9722399115562439e+01 -1.9833499565720558e+01) (float-vector 5.1288001239299774e+01 -7.1880899369716644e+01 -4.8342499136924744e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.3778601586818695e+01 -8.8201001286506653e+01 -4.8524600267410278e+02) (float-vector 5.5346399545669556e+01 -8.3324097096920013e+01 -4.9100199341773987e+02) (float-vector 6.2465600669384003e+01 -2.8464201092720032e+02 -4.8897600173950195e+02) (float-vector 6.6065803170204163e+01 -1.0483200103044510e+02 -4.8713600635528564e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0930400341749191e+01 -6.1416100710630417e+01 1.4194400608539581e+02) (float-vector -4.8489298671483994e+01 -7.0055499672889709e+01 1.4194400608539581e+02) (float-vector -2.1231399849057198e+01 -6.2664501368999481e+01 3.2805200666189194e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.8489298671483994e+01 -7.0055499672889709e+01 1.4194400608539581e+02) (float-vector -8.3949401974678040e+01 -9.2681996524333954e+01 1.4194400608539581e+02) (float-vector -8.8373199105262756e+01 -9.6403397619724274e+01 -4.8306900262832642e+02) (float-vector -5.1831800490617752e+01 -7.2074197232723236e+01 -4.8419100046157837e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7018898427486420e+01 -2.9444599151611328e+02 -4.9092501401901245e+02) (float-vector -7.9504400491714478e+01 -2.8077098727226257e+02 -4.9013099074363708e+02) (float-vector -6.3879601657390594e+01 -2.9806900024414062e+02 -4.8355400562286377e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9274097681045532e+01 -2.9458400607109070e+02 1.4194400608539581e+02) (float-vector -6.3879601657390594e+01 -2.9806900024414062e+02 -4.8355400562286377e+02) (float-vector -7.9504400491714478e+01 -2.8077098727226257e+02 -4.9013099074363708e+02) (float-vector -9.8202198743820190e+01 -2.6863899827003479e+02 -4.8480701446533203e+02) (float-vector -8.6448900401592255e+01 -2.8137400746345520e+02 -9.2565096914768219e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0817900300025940e+02 -2.5467801094055176e+02 -4.8531100153923035e+02) (float-vector -9.8202198743820190e+01 -2.6863899827003479e+02 -4.8480701446533203e+02) (float-vector -7.9504400491714478e+01 -2.8077098727226257e+02 -4.9013099074363708e+02) (float-vector -1.0650800168514252e+02 -2.4332199990749359e+02 -4.9088999629020691e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.8202198743820190e+01 -2.6863899827003479e+02 -4.8480701446533203e+02) (float-vector -1.0817900300025940e+02 -2.5467801094055176e+02 -4.8531100153923035e+02) (float-vector -1.1751300096511841e+02 -2.3654499650001526e+02 -4.8154601454734802e+02) (float-vector -1.2146700173616409e+02 -2.2549399733543396e+02 1.4194400608539581e+02) (float-vector -1.0044000297784805e+02 -2.6606398820877075e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2283100187778473e+02 -2.0779199898242950e+02 -4.8846301436424255e+02) (float-vector -1.1751300096511841e+02 -2.3654499650001526e+02 -4.8154601454734802e+02) (float-vector -1.0817900300025940e+02 -2.5467801094055176e+02 -4.8531100153923035e+02) (float-vector -1.0650800168514252e+02 -2.4332199990749359e+02 -4.9088999629020691e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2283100187778473e+02 -2.0779199898242950e+02 -4.8846301436424255e+02) (float-vector -1.2632499635219574e+02 -2.0250800251960754e+02 -4.8305800557136536e+02) (float-vector -1.2588199973106384e+02 -2.0557299256324768e+02 2.0804300904273987e+01) (float-vector -1.2146700173616409e+02 -2.2549399733543396e+02 1.4194400608539581e+02) (float-vector -1.1751300096511841e+02 -2.3654499650001526e+02 -4.8154601454734802e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1831800490617752e+01 -7.2074197232723236e+01 -4.8419100046157837e+02) (float-vector -3.3772498369216919e+01 -6.5870597958564758e+01 -4.8577499389648438e+02) (float-vector -2.2900799289345741e+01 -6.3059002161026001e+01 -4.7951799631118774e+02) (float-vector -2.1231399849057198e+01 -6.2664501368999481e+01 3.2805200666189194e+01) (float-vector -4.8489298671483994e+01 -7.0055499672889709e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3559802472591400e-01 -6.3574999570846558e+01 -4.8864099383354187e+02) (float-vector -3.3772498369216919e+01 -6.5870597958564758e+01 -4.8577499389648438e+02) (float-vector -5.1831800490617752e+01 -7.2074197232723236e+01 -4.8419100046157837e+02) (float-vector -7.3221199214458466e+01 -9.1562196612358093e+01 -4.9096000194549561e+02) (float-vector -1.7018400132656097e+01 -6.9224998354911804e+01 -4.9095699191093445e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.8373199105262756e+01 -9.6403397619724274e+01 -4.8306900262832642e+02) (float-vector -9.8200798034667969e+01 -1.1189299821853638e+02 -4.8877400159835815e+02) (float-vector -7.3221199214458466e+01 -9.1562196612358093e+01 -4.9096000194549561e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1384999752044678e+02 -1.4769999682903290e+02 -4.9088498950004578e+02) (float-vector -9.8200798034667969e+01 -1.1189299821853638e+02 -4.8877400159835815e+02) (float-vector -1.0613600164651871e+02 -1.1801099777221680e+02 -4.8381099104881287e+02) (float-vector -1.2269700318574905e+02 -1.5388199687004089e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0613600164651871e+02 -1.1801099777221680e+02 -4.8381099104881287e+02) (float-vector -9.8200798034667969e+01 -1.1189299821853638e+02 -4.8877400159835815e+02) (float-vector -8.8373199105262756e+01 -9.6403397619724274e+01 -4.8306900262832642e+02) (float-vector -8.3949401974678040e+01 -9.2681996524333954e+01 1.4194400608539581e+02) (float-vector -1.0817500203847885e+02 -1.2098599970340729e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6029400080442429e+01 -3.0695700645446777e+02 -4.8577100038528442e+02) (float-vector 6.0450900346040726e+01 -2.9500699043273926e+02 -4.8320499062538147e+02) (float-vector 6.2465600669384003e+01 -2.8464201092720032e+02 -4.8897600173950195e+02) (float-vector 4.3810900300741196e+01 -3.0095100402832031e+02 -4.9094399809837341e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6029400080442429e+01 -3.0695700645446777e+02 -4.8577100038528442e+02) (float-vector 2.0559400320053101e+02 -3.1240200996398926e+02 -3.7847198545932770e+01) (float-vector 2.1923300623893738e+02 -3.0627799034118652e+02 -1.9833499565720558e+01) (float-vector 6.0450900346040726e+01 -2.9500699043273926e+02 -4.8320499062538147e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1635700017213821e+01 -3.1359899044036865e+02 -4.8338499665260315e+02) (float-vector 1.9505800306797028e+02 -3.1499499082565308e+02 -1.7240200191736221e+01) (float-vector 2.0559400320053101e+02 -3.1240200996398926e+02 -3.7847198545932770e+01) (float-vector 4.6029400080442429e+01 -3.0695700645446777e+02 -4.8577100038528442e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1923300623893738e+02 -6.9722399115562439e+01 -1.9833499565720558e+01) (float-vector 6.3778601586818695e+01 -8.8201001286506653e+01 -4.8524600267410278e+02) (float-vector 6.6065803170204163e+01 -1.0483200103044510e+02 -4.8713600635528564e+02) (float-vector 2.2358399629592896e+02 -8.2799702882766724e+01 -1.9464299082756042e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2650299966335297e+02 -1.0860600322484970e+02 1.4042600058019161e+01) (float-vector 2.2435900568962097e+02 -8.3476997911930084e+01 1.2755200266838074e+01) (float-vector 2.2358399629592896e+02 -8.2799702882766724e+01 -1.9464299082756042e+01) (float-vector 2.2587600350379944e+02 -2.6739200949668884e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2358399629592896e+02 -8.2799702882766724e+01 -1.9464299082756042e+01) (float-vector 2.2435900568962097e+02 -8.3476997911930084e+01 1.2755200266838074e+01) (float-vector 2.1694299578666687e+02 -7.3412798345088959e+01 3.5626601427793503e+01) (float-vector 2.1335899829864502e+02 -6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 2.1923300623893738e+02 -6.9722399115562439e+01 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1694299578666687e+02 -7.3412798345088959e+01 3.5626601427793503e+01) (float-vector 2.0883299410343170e+02 -6.4032301306724548e+01 3.2384399324655533e+01) (float-vector 2.1335899829864502e+02 -6.4132899045944214e+01 -6.0748001560568810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 -6.4032301306724548e+01 3.2384399324655533e+01) (float-vector 2.1694299578666687e+02 -7.3412798345088959e+01 3.5626601427793503e+01) (float-vector 1.9633999466896057e+02 -6.6740602254867554e+01 6.6335096955299377e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900799289345741e+01 -6.3059002161026001e+01 -4.7951799631118774e+02) (float-vector -3.3772498369216919e+01 -6.5870597958564758e+01 -4.8577499389648438e+02) (float-vector -5.3559802472591400e-01 -6.3574999570846558e+01 -4.8864099383354187e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8835901319980621e+01 -8.8595099747180939e+01 1.4194400608539581e+02) (float-vector 1.5508300065994263e+02 -1.0860099643468857e+02 1.1465500295162201e+02) (float-vector 1.4104899764060974e+02 -2.6741299033164978e+02 1.2079499661922455e+02) (float-vector 5.5495601147413254e+01 -3.0183899402618408e+02 1.4194299280643463e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2667199969291687e+02 -1.7919799685478210e+02 -4.8404198884963989e+02) (float-vector -1.2008500099182129e+02 -1.7086499929428101e+02 -4.9096199870109558e+02) (float-vector -1.1384999752044678e+02 -1.4769999682903290e+02 -4.9088498950004578e+02) (float-vector -1.2269700318574905e+02 -1.5388199687004089e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2008500099182129e+02 -1.7086499929428101e+02 -4.9096199870109558e+02) (float-vector -1.2667199969291687e+02 -1.7919799685478210e+02 -4.8404198884963989e+02) (float-vector -1.2632499635219574e+02 -2.0250800251960754e+02 -4.8305800557136536e+02) (float-vector -1.2283100187778473e+02 -2.0779199898242950e+02 -4.8846301436424255e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6213800013065338e+02 -3.0902200937271118e+02 9.8933696746826172e+01) (float-vector 1.8280999362468719e+02 -3.1150498986244202e+02 7.7822700142860413e+01) (float-vector 2.0096099376678467e+02 -3.1384199857711792e+02 3.5687398165464401e+01) (float-vector 4.4208098202943802e+01 -3.1167599558830261e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3539200425148010e+01 -3.0677101016044617e+02 -4.9085399508476257e+02) (float-vector -5.7018898427486420e+01 -2.9444599151611328e+02 -4.9092501401901245e+02) (float-vector -6.3879601657390594e+01 -2.9806900024414062e+02 -4.8355400562286377e+02) (float-vector -2.0386200398206711e+01 -3.1374201178550720e+02 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2465600669384003e+01 -2.8464201092720032e+02 -4.8897600173950195e+02) (float-vector 2.1649299561977386e+02 -2.8537300229072571e+02 -4.7570601105690002e+01) (float-vector 2.2587600350379944e+02 -2.6739200949668884e+02 -1.7441999167203903e+01) (float-vector 2.2358399629592896e+02 -8.2799702882766724e+01 -1.9464299082756042e+01) (float-vector 6.6065803170204163e+01 -1.0483200103044510e+02 -4.8713600635528564e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0559400320053101e+02 -3.1240200996398926e+02 -3.7847198545932770e+01) (float-vector 2.1335899829864502e+02 -3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 2.1923300623893738e+02 -3.0627799034118652e+02 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1335899829864502e+02 -3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 2.0559400320053101e+02 -3.1240200996398926e+02 -3.7847198545932770e+01) (float-vector 1.9505800306797028e+02 -3.1499499082565308e+02 -1.7240200191736221e+01) (float-vector 2.0096099376678467e+02 -3.1384199857711792e+02 3.5687398165464401e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 -3.0816599726676941e+02 4.8401098698377609e+01) (float-vector 2.1820700168609619e+02 -2.9173400998115540e+02 4.0720399469137192e+01) (float-vector 2.1591199934482574e+02 -3.0791699886322021e+02 2.6680400595068932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 -3.0816599726676941e+02 4.8401098698377609e+01) (float-vector 2.0096099376678467e+02 -3.1384199857711792e+02 3.5687398165464401e+01) (float-vector 1.8280999362468719e+02 -3.1150498986244202e+02 7.7822700142860413e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 -3.0816599726676941e+02 4.8401098698377609e+01) (float-vector 2.1591199934482574e+02 -3.0791699886322021e+02 2.6680400595068932e+01) (float-vector 2.1335899829864502e+02 -3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 2.0096099376678467e+02 -3.1384199857711792e+02 3.5687398165464401e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2492699325084686e+02 -2.9130798578262329e+02 1.0091500356793404e+01) (float-vector 2.1591199934482574e+02 -3.0791699886322021e+02 2.6680400595068932e+01) (float-vector 2.1820700168609619e+02 -2.9173400998115540e+02 4.0720399469137192e+01) (float-vector 2.2490300238132477e+02 -2.6739200949668884e+02 2.6359599083662033e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 -6.4032301306724548e+01 3.2384399324655533e+01) (float-vector 1.8978999555110931e+02 -6.1012499034404755e+01 3.4521799534559250e+01) (float-vector 1.8967899680137634e+02 -6.1024598777294159e+01 -4.9712598323822021e+01) (float-vector 2.1335899829864502e+02 -6.4132899045944214e+01 -6.0748001560568810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900799289345741e+01 -6.3059002161026001e+01 -4.7951799631118774e+02) (float-vector -5.3559802472591400e-01 -6.3574999570846558e+01 -4.8864099383354187e+02) (float-vector 3.1249100342392921e+01 -6.4454197883605957e+01 -4.8672801256179810e+02) (float-vector 1.8967899680137634e+02 -6.1024598777294159e+01 -4.9712598323822021e+01) (float-vector 1.8978999555110931e+02 -6.1012499034404755e+01 3.4521799534559250e+01) (float-vector 1.4279399812221527e+02 -6.1290599405765533e+01 9.3671001493930817e+01) (float-vector 2.4879999458789825e+01 -6.1120901256799698e+01 1.4194400608539581e+02) (float-vector -1.0930400341749191e+01 -6.1416100710630417e+01 1.4194400608539581e+02) (float-vector -2.1231399849057198e+01 -6.2664501368999481e+01 3.2805200666189194e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9274097681045532e+01 -2.9458400607109070e+02 1.4194400608539581e+02) (float-vector -1.0044000297784805e+02 -2.6606398820877075e+02 1.4194400608539581e+02) (float-vector -1.2146700173616409e+02 -2.2549399733543396e+02 1.4194400608539581e+02) (float-vector -1.2711900472640991e+02 -1.8418799340724945e+02 1.4194400608539581e+02) (float-vector -1.2200599908828735e+02 -1.5188600122928619e+02 1.4194400608539581e+02) (float-vector -1.0817500203847885e+02 -1.2098599970340729e+02 1.4194400608539581e+02) (float-vector -8.3949401974678040e+01 -9.2681996524333954e+01 1.4194400608539581e+02) (float-vector -4.8489298671483994e+01 -7.0055499672889709e+01 1.4194400608539581e+02) (float-vector -1.0930400341749191e+01 -6.1416100710630417e+01 1.4194400608539581e+02) (float-vector 2.4879999458789825e+01 -6.1120901256799698e+01 1.4194400608539581e+02) (float-vector 5.0127498805522919e+01 -6.6561698913574219e+01 1.4194400608539581e+02) (float-vector 5.8835901319980621e+01 -8.8595099747180939e+01 1.4194400608539581e+02) (float-vector 5.5495601147413254e+01 -3.0183899402618408e+02 1.4194299280643463e+02) (float-vector 4.4208098202943802e+01 -3.1167599558830261e+02 1.4194400608539581e+02) (float-vector -2.0531499758362770e+01 -3.1357601284980774e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4271399378776550e+02 -8.3362802863121033e+01 1.1685799807310104e+02) (float-vector 5.0127498805522919e+01 -6.6561698913574219e+01 1.4194400608539581e+02) (float-vector 1.3801500201225281e+02 -6.9305099546909332e+01 1.1298099905252457e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0127498805522919e+01 -6.6561698913574219e+01 1.4194400608539581e+02) (float-vector 1.4271399378776550e+02 -8.3362802863121033e+01 1.1685799807310104e+02) (float-vector 1.5508300065994263e+02 -1.0860099643468857e+02 1.1465500295162201e+02) (float-vector 5.8835901319980621e+01 -8.8595099747180939e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5101799508556724e+00 -3.1135201454162598e+02 -4.8928499221801758e+02) (float-vector -2.3539200425148010e+01 -3.0677101016044617e+02 -4.9085399508476257e+02) (float-vector -2.0386200398206711e+01 -3.1374201178550720e+02 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5101799508556724e+00 -3.1135201454162598e+02 -4.8928499221801758e+02) (float-vector 2.1635700017213821e+01 -3.1359899044036865e+02 -4.8338499665260315e+02) (float-vector 4.6029400080442429e+01 -3.0695700645446777e+02 -4.8577100038528442e+02) (float-vector 4.3810900300741196e+01 -3.0095100402832031e+02 -4.9094399809837341e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1384999752044678e+02 -1.4769999682903290e+02 -4.9088498950004578e+02) (float-vector -1.2008500099182129e+02 -1.7086499929428101e+02 -4.9096199870109558e+02) (float-vector -1.2283100187778473e+02 -2.0779199898242950e+02 -4.8846301436424255e+02) (float-vector -1.0650800168514252e+02 -2.4332199990749359e+02 -4.9088999629020691e+02) (float-vector -7.9504400491714478e+01 -2.8077098727226257e+02 -4.9013099074363708e+02) (float-vector -5.7018898427486420e+01 -2.9444599151611328e+02 -4.9092501401901245e+02) (float-vector -2.3539200425148010e+01 -3.0677101016044617e+02 -4.9085399508476257e+02) (float-vector 1.5101799508556724e+00 -3.1135201454162598e+02 -4.8928499221801758e+02) (float-vector 4.3810900300741196e+01 -3.0095100402832031e+02 -4.9094399809837341e+02) (float-vector 6.2465600669384003e+01 -2.8464201092720032e+02 -4.8897600173950195e+02) (float-vector 5.5346399545669556e+01 -8.3324097096920013e+01 -4.9100199341773987e+02) (float-vector -1.7018400132656097e+01 -6.9224998354911804e+01 -4.9095699191093445e+02) (float-vector -7.3221199214458466e+01 -9.1562196612358093e+01 -4.9096000194549561e+02) (float-vector -9.8200798034667969e+01 -1.1189299821853638e+02 -4.8877400159835815e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4208098202943802e+01 -3.1167599558830261e+02 1.4194400608539581e+02) (float-vector 2.0096099376678467e+02 -3.1384199857711792e+02 3.5687398165464401e+01) (float-vector 1.9505800306797028e+02 -3.1499499082565308e+02 -1.7240200191736221e+01) (float-vector 2.1635700017213821e+01 -3.1359899044036865e+02 -4.8338499665260315e+02) (float-vector 1.5101799508556724e+00 -3.1135201454162598e+02 -4.8928499221801758e+02) (float-vector -2.0386200398206711e+01 -3.1374201178550720e+02 -4.8366799950599670e+02) (float-vector -2.0531499758362770e+01 -3.1357601284980774e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1649299561977386e+02 -2.8537300229072571e+02 -4.7570601105690002e+01) (float-vector 2.2299399971961975e+02 -2.9439499974250793e+02 -2.0850200206041336e+01) (float-vector 2.2587600350379944e+02 -2.6739200949668884e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 -2.9439499974250793e+02 -2.0850200206041336e+01) (float-vector 2.1649299561977386e+02 -2.8537300229072571e+02 -4.7570601105690002e+01) (float-vector 6.2465600669384003e+01 -2.8464201092720032e+02 -4.8897600173950195e+02) (float-vector 6.0450900346040726e+01 -2.9500699043273926e+02 -4.8320499062538147e+02) (float-vector 2.1923300623893738e+02 -3.0627799034118652e+02 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 -2.9439499974250793e+02 -2.0850200206041336e+01) (float-vector 2.2492699325084686e+02 -2.9130798578262329e+02 1.0091500356793404e+01) (float-vector 2.2490300238132477e+02 -2.6739200949668884e+02 2.6359599083662033e+01) (float-vector 2.2650299966335297e+02 -1.0860600322484970e+02 1.4042600058019161e+01) (float-vector 2.2587600350379944e+02 -2.6739200949668884e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 -2.9439499974250793e+02 -2.0850200206041336e+01) (float-vector 2.1923300623893738e+02 -3.0627799034118652e+02 -1.9833499565720558e+01) (float-vector 2.1335899829864502e+02 -3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 2.1591199934482574e+02 -3.0791699886322021e+02 2.6680400595068932e+01) (float-vector 2.2492699325084686e+02 -2.9130798578262329e+02 1.0091500356793404e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9659300148487091e+02 -3.0168700218200684e+02 7.4555598199367523e+01) (float-vector 2.0798799395561218e+02 -3.0816599726676941e+02 4.8401098698377609e+01) (float-vector 1.8280999362468719e+02 -3.1150498986244202e+02 7.7822700142860413e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8365700542926788e+02 -2.9859200119972229e+02 9.0514600276947021e+01) (float-vector 1.6411300003528595e+02 -2.9812601208686829e+02 1.0537499934434891e+02) (float-vector 1.7702099680900574e+02 -2.6739299297332764e+02 1.0179799795150757e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8291999399662018e+02 -1.0859300196170807e+02 9.6916697919368744e+01) (float-vector 1.7702099680900574e+02 -2.6739299297332764e+02 1.0179799795150757e+02) (float-vector 1.6411300003528595e+02 -2.9812601208686829e+02 1.0537499934434891e+02) (float-vector 1.4104899764060974e+02 -2.6741299033164978e+02 1.2079499661922455e+02) (float-vector 1.5508300065994263e+02 -1.0860099643468857e+02 1.1465500295162201e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.5495601147413254e+01 -3.0183899402618408e+02 1.4194299280643463e+02) (float-vector 1.4104899764060974e+02 -2.6741299033164978e+02 1.2079499661922455e+02) (float-vector 1.6411300003528595e+02 -2.9812601208686829e+02 1.0537499934434891e+02) (float-vector 4.4208098202943802e+01 -3.1167599558830261e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6411300003528595e+02 -2.9812601208686829e+02 1.0537499934434891e+02) (float-vector 1.8365700542926788e+02 -2.9859200119972229e+02 9.0514600276947021e+01) (float-vector 1.9659300148487091e+02 -3.0168700218200684e+02 7.4555598199367523e+01) (float-vector 1.8280999362468719e+02 -3.1150498986244202e+02 7.7822700142860413e+01) (float-vector 1.6213800013065338e+02 -3.0902200937271118e+02 9.8933696746826172e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6213800013065338e+02 -3.0902200937271118e+02 9.8933696746826172e+01) (float-vector 4.4208098202943802e+01 -3.1167599558830261e+02 1.4194400608539581e+02) (float-vector 1.6411300003528595e+02 -2.9812601208686829e+02 1.0537499934434891e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2490300238132477e+02 -2.6739200949668884e+02 2.6359599083662033e+01) (float-vector 2.2066900134086609e+02 -1.0860499739646912e+02 4.0891099721193314e+01) (float-vector 2.2650299966335297e+02 -1.0860600322484970e+02 1.4042600058019161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2650299966335297e+02 -1.0860600322484970e+02 1.4042600058019161e+01) (float-vector 2.2066900134086609e+02 -1.0860499739646912e+02 4.0891099721193314e+01) (float-vector 2.0858399569988251e+02 -8.4341198205947876e+01 6.1897300183773041e+01) (float-vector 2.1694299578666687e+02 -7.3412798345088959e+01 3.5626601427793503e+01) (float-vector 2.2435900568962097e+02 -8.3476997911930084e+01 1.2755200266838074e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9786100089550018e+02 -7.6490096747875214e+01 7.4741497635841370e+01) (float-vector 1.9633999466896057e+02 -6.6740602254867554e+01 6.6335096955299377e+01) (float-vector 2.1694299578666687e+02 -7.3412798345088959e+01 3.5626601427793503e+01) (float-vector 2.0858399569988251e+02 -8.4341198205947876e+01 6.1897300183773041e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 -7.5168296694755554e+01 9.1508001089096069e+01) (float-vector 1.9786100089550018e+02 -7.6490096747875214e+01 7.4741497635841370e+01) (float-vector 2.0858399569988251e+02 -8.4341198205947876e+01 6.1897300183773041e+01) (float-vector 2.0269399881362915e+02 -1.0860899835824966e+02 7.5614199042320251e+01) (float-vector 1.8291999399662018e+02 -1.0859300196170807e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4271399378776550e+02 -8.3362802863121033e+01 1.1685799807310104e+02) (float-vector 1.6375499963760376e+02 -8.4603600203990936e+01 1.0734999924898148e+02) (float-vector 1.5508300065994263e+02 -1.0860099643468857e+02 1.1465500295162201e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6375499963760376e+02 -8.4603600203990936e+01 1.0734999924898148e+02) (float-vector 1.8101300299167633e+02 -7.5168296694755554e+01 9.1508001089096069e+01) (float-vector 1.8291999399662018e+02 -1.0859300196170807e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5508300065994263e+02 -1.0860099643468857e+02 1.1465500295162201e+02) (float-vector 1.6375499963760376e+02 -8.4603600203990936e+01 1.0734999924898148e+02) (float-vector 1.8291999399662018e+02 -1.0859300196170807e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4879999458789825e+01 -6.1120901256799698e+01 1.4194400608539581e+02) (float-vector 1.4279399812221527e+02 -6.1290599405765533e+01 9.3671001493930817e+01) (float-vector 1.6528600454330444e+02 -6.8328402936458588e+01 9.8848700523376465e+01) (float-vector 1.3801500201225281e+02 -6.9305099546909332e+01 1.1298099905252457e+02) (float-vector 5.0127498805522919e+01 -6.6561698913574219e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 -7.5168296694755554e+01 9.1508001089096069e+01) (float-vector 1.6528600454330444e+02 -6.8328402936458588e+01 9.8848700523376465e+01) (float-vector 1.9633999466896057e+02 -6.6740602254867554e+01 6.6335096955299377e+01) (float-vector 1.9786100089550018e+02 -7.6490096747875214e+01 7.4741497635841370e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 -6.4032301306724548e+01 3.2384399324655533e+01) (float-vector 1.9633999466896057e+02 -6.6740602254867554e+01 6.6335096955299377e+01) (float-vector 1.6528600454330444e+02 -6.8328402936458588e+01 9.8848700523376465e+01) (float-vector 1.4279399812221527e+02 -6.1290599405765533e+01 9.3671001493930817e+01) (float-vector 1.8978999555110931e+02 -6.1012499034404755e+01 3.4521799534559250e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 -7.5168296694755554e+01 9.1508001089096069e+01) (float-vector 1.6375499963760376e+02 -8.4603600203990936e+01 1.0734999924898148e+02) (float-vector 1.4271399378776550e+02 -8.3362802863121033e+01 1.1685799807310104e+02) (float-vector 1.3801500201225281e+02 -6.9305099546909332e+01 1.1298099905252457e+02) (float-vector 1.6528600454330444e+02 -6.8328402936458588e+01 9.8848700523376465e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0269399881362915e+02 -1.0860899835824966e+02 7.5614199042320251e+01) (float-vector 2.0350900292396545e+02 -2.6740801334381104e+02 7.4386402964591980e+01) (float-vector 1.7702099680900574e+02 -2.6739299297332764e+02 1.0179799795150757e+02) (float-vector 1.8291999399662018e+02 -1.0859300196170807e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0350900292396545e+02 -2.6740801334381104e+02 7.4386402964591980e+01) (float-vector 2.0269399881362915e+02 -1.0860899835824966e+02 7.5614199042320251e+01) (float-vector 2.0858399569988251e+02 -8.4341198205947876e+01 6.1897300183773041e+01) (float-vector 2.2066900134086609e+02 -1.0860499739646912e+02 4.0891099721193314e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0847299695014954e+02 -2.9139098525047302e+02 6.2196400016546249e+01) (float-vector 2.0350900292396545e+02 -2.6740801334381104e+02 7.4386402964591980e+01) (float-vector 2.2066900134086609e+02 -1.0860499739646912e+02 4.0891099721193314e+01) (float-vector 2.2490300238132477e+02 -2.6739200949668884e+02 2.6359599083662033e+01) (float-vector 2.1820700168609619e+02 -2.9173400998115540e+02 4.0720399469137192e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9659300148487091e+02 -3.0168700218200684e+02 7.4555598199367523e+01) (float-vector 2.0847299695014954e+02 -2.9139098525047302e+02 6.2196400016546249e+01) (float-vector 2.1820700168609619e+02 -2.9173400998115540e+02 4.0720399469137192e+01) (float-vector 2.0798799395561218e+02 -3.0816599726676941e+02 4.8401098698377609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0847299695014954e+02 -2.9139098525047302e+02 6.2196400016546249e+01) (float-vector 1.9659300148487091e+02 -3.0168700218200684e+02 7.4555598199367523e+01) (float-vector 1.8365700542926788e+02 -2.9859200119972229e+02 9.0514600276947021e+01) (float-vector 1.7702099680900574e+02 -2.6739299297332764e+02 1.0179799795150757e+02) (float-vector 2.0350900292396545e+02 -2.6740801334381104e+02 7.4386402964591980e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_shoulder_pan_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_upper_arm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 202 203 0 215 0 2 609 0 607 215 698 0 202 0 698 0 609 1 0 203 607 457 458 215 458 698 215 457 215 2 698 458 122 122 434 698 434 202 698 120 458 457 458 120 122 457 658 120 658 457 2 120 658 161 466 658 678 161 658 466 678 658 768 658 2 768 768 2 704 2 1 704 768 704 785 678 768 785 466 678 237 238 678 785 237 678 238 634 785 584 704 347 785 347 584 785 238 785 634 1 537 704 537 347 704 1 609 72 1 72 537 537 71 348 72 71 537 347 537 348 346 347 348 346 584 347 348 71 446 446 346 348 534 346 445 346 446 445 346 534 584 445 26 534 171 584 534 26 694 534 694 171 534 445 446 27 27 26 445 26 27 28 694 26 28 171 694 583 694 28 195 195 594 694 594 583 694 446 28 27 195 28 683 683 28 446 683 446 305 683 305 307 683 447 195 307 447 683 306 305 446 306 446 71 305 306 307 307 645 447 414 307 306 307 414 645 415 306 71 415 414 306 70 71 72 71 410 415 70 410 71 414 415 409 409 415 410 414 628 645 409 628 414 409 410 411 628 409 411 410 38 411 410 642 604 70 642 410 604 38 410 411 38 628 38 39 40 38 604 39 38 40 628 623 604 663 642 403 604 39 604 623 604 403 663 623 40 39 40 623 515 623 663 515 663 403 664 664 515 663 402 664 403 402 81 664 81 515 664 79 80 81 81 713 79 402 713 81 515 81 80 471 79 103 79 193 103 713 193 79 79 471 80 402 529 713 193 713 733 733 713 529 104 103 193 732 193 733 104 193 732 528 747 733 747 732 733 528 733 529 402 528 529 528 402 788 788 374 528 374 747 528 374 376 747 747 554 732 376 554 747 104 732 553 553 732 554 553 554 555 554 330 555 328 554 376 330 554 328 374 375 376 376 375 652 376 652 328 328 329 330 443 329 328 443 328 652 416 330 329 330 416 555 329 309 416 329 443 309 309 308 416 308 102 416 555 416 102 308 309 310 443 310 309 308 339 102 339 308 455 455 308 310 310 475 455 310 443 475 454 455 456 455 475 476 456 455 476 454 629 455 455 629 339 728 475 443 475 728 476 456 476 287 728 121 476 476 121 287 728 443 729 121 728 779 779 728 729 443 652 729 729 652 435 729 435 779 434 122 779 121 779 122 435 434 779 434 435 202 435 375 202 435 652 375 202 375 203 404 375 374 203 375 404 607 203 401 203 404 401 404 402 401 788 404 374 788 402 404 401 402 403 401 403 607 607 403 608 598 609 607 598 607 608 403 599 608 642 599 403 598 608 599 597 598 599 609 598 597 609 597 769 72 609 769 70 597 642 599 642 597 70 769 597 72 769 70 120 121 122 286 287 121 286 121 120 287 286 483 286 120 483 120 654 483 161 113 120 120 113 654 483 112 441 287 483 441 483 654 112 456 287 635 635 287 441 441 183 442 441 442 635 441 112 751 441 751 183 456 635 653 442 653 635 643 454 456 643 456 653 643 653 442 518 643 442 442 183 518 643 630 629 629 454 643 630 643 518 518 629 630 73 174 518 74 518 183 73 518 74 629 518 174 173 629 174 173 339 629 172 173 174 620 172 174 174 73 716 174 716 620 172 444 173 172 622 444 622 172 620 620 621 622 620 716 73 73 780 620 780 621 620 622 621 444 444 782 783 782 444 621 444 783 173 621 780 672 621 672 782 780 73 75 780 723 672 780 75 723 672 373 673 672 723 373 782 672 673 723 428 226 373 723 226 723 75 428 73 74 75 75 182 428 74 182 75 428 227 226 428 182 227 14 226 227 13 277 226 277 373 226 14 13 226 227 207 14 207 227 182 182 74 183 326 207 182 326 182 183 327 183 751 326 183 327 92 326 327 207 326 92 93 92 327 93 327 111 327 751 111 751 112 111 111 112 113 113 112 654 113 161 162 113 162 111 162 161 466 352 353 162 111 162 353 466 4 162 3 162 4 162 3 352 466 265 5 237 265 466 4 466 5 3 4 5 3 361 746 3 626 352 5 361 3 626 3 746 5 264 361 264 5 265 532 531 361 532 361 264 531 746 361 430 746 425 626 746 430 531 425 746 429 625 626 625 352 626 626 430 429 429 430 431 430 425 431 681 429 431 625 429 353 681 353 429 352 625 353 353 681 741 111 353 741 399 681 431 741 681 399 650 399 431 425 424 431 650 431 424 399 400 82 399 650 400 399 82 741 741 82 50 741 50 111 111 50 49 49 93 111 49 50 51 605 50 82 662 50 605 662 51 50 51 269 49 93 49 136 269 136 49 92 93 94 93 136 94 134 135 136 134 136 519 94 136 135 269 519 136 94 422 92 422 94 135 422 207 92 421 422 135 421 207 422 303 135 134 303 421 135 208 207 421 421 303 208 207 208 14 208 303 304 208 12 14 208 735 755 12 208 755 304 735 208 12 13 14 12 755 13 13 755 756 272 755 734 756 755 272 734 755 735 297 734 735 297 735 304 297 296 734 294 272 734 296 294 734 255 296 297 297 800 255 800 297 304 294 296 255 272 294 295 295 294 69 254 69 294 294 255 254 253 254 255 742 253 255 255 800 742 542 254 253 743 69 254 254 542 743 275 274 253 253 274 542 275 253 742 344 275 742 633 344 742 742 800 633 228 274 275 228 275 345 344 345 275 542 274 132 274 133 132 133 274 228 133 228 229 229 228 247 345 247 228 344 247 345 245 246 247 247 344 651 245 247 651 246 229 247 246 245 574 651 575 245 574 245 575 246 574 601 657 229 246 246 601 657 573 574 575 574 573 391 574 687 601 574 391 687 575 651 526 413 573 575 526 413 575 412 573 413 573 412 391 315 412 413 526 527 413 413 196 360 527 196 413 360 315 413 389 412 315 412 389 391 389 390 391 390 389 300 300 389 315 390 233 391 234 390 300 234 233 390 300 301 302 301 300 315 302 234 300 233 234 235 87 235 234 234 302 87 302 301 88 87 302 88 87 88 89 89 235 87 235 638 233 581 235 89 235 581 638 44 89 748 36 89 44 89 88 748 89 36 581 343 88 301 748 88 343 44 748 342 748 343 342 44 45 37 44 342 45 36 44 37 35 36 37 36 35 571 581 36 571 35 37 505 37 45 505 35 289 288 571 35 288 289 35 505 581 571 632 690 632 571 288 775 571 775 690 571 288 289 290 290 775 288 775 499 692 565 775 290 775 565 499 690 775 692 690 731 632 690 692 731 691 692 693 693 692 499 731 692 691 149 439 499 499 565 149 693 499 439 691 693 676 693 439 497 693 497 676 668 691 676 668 731 691 668 639 731 731 639 632 613 668 614 217 614 668 613 639 668 217 668 676 676 497 217 216 217 218 217 10 218 217 216 614 10 217 496 217 497 496 612 613 614 216 686 614 614 686 612 218 701 216 701 686 216 218 10 9 703 218 9 703 701 218 9 10 11 10 496 11 495 496 497 495 11 496 11 393 9 393 11 495 392 9 393 392 703 9 701 703 331 392 331 703 393 479 392 392 479 332 332 331 392 331 332 20 20 229 331 714 701 331 229 714 331 20 21 22 229 20 465 20 332 21 20 22 465 229 440 133 657 714 229 465 440 229 714 657 686 686 701 714 612 657 601 612 686 657 638 613 612 601 638 612 233 601 687 233 638 601 638 639 613 638 632 639 581 632 638 233 687 391 131 133 440 131 440 145 351 145 440 465 351 440 131 132 133 132 131 388 388 387 132 387 542 132 386 387 388 387 67 743 743 542 387 67 387 386 436 61 386 386 163 67 163 386 61 386 388 436 666 436 388 666 617 436 617 61 436 61 62 63 61 63 163 617 616 61 62 61 616 67 163 670 163 726 670 63 726 163 592 726 63 63 62 592 484 62 319 592 62 484 62 616 319 318 592 484 592 318 719 720 592 719 592 720 726 758 670 726 726 720 758 719 472 720 758 720 538 720 539 538 472 539 720 739 670 758 739 758 538 538 539 29 739 538 29 702 29 539 539 472 702 29 30 31 560 29 31 739 29 772 30 29 702 772 29 560 670 739 68 68 739 772 68 67 670 67 68 69 68 772 69 772 560 273 295 69 772 272 772 273 295 772 272 273 560 561 560 31 561 271 272 273 561 271 273 272 271 792 792 756 272 707 271 561 792 271 707 572 707 561 572 561 31 707 572 507 507 792 707 756 792 506 506 792 507 756 506 587 13 756 587 506 507 106 587 506 105 105 506 106 572 106 507 105 106 107 106 572 107 105 251 252 252 278 105 105 107 251 278 587 105 587 277 13 277 587 278 276 277 278 276 278 467 467 278 252 151 383 252 383 467 252 151 252 251 7 467 383 467 7 721 721 276 467 277 276 373 673 276 721 673 373 276 721 7 796 721 796 673 796 782 673 695 789 796 782 796 789 695 796 7 783 782 789 589 783 789 695 589 789 589 695 371 7 371 695 173 589 371 783 589 173 371 7 372 372 173 371 6 7 8 7 6 372 383 8 7 6 8 624 624 372 6 383 646 8 646 624 8 760 646 383 151 760 383 760 151 646 646 150 624 150 646 151 150 151 152 152 151 251 624 150 718 702 150 152 150 702 718 152 591 702 251 591 152 251 107 591 107 572 591 30 702 591 591 572 30 474 702 472 718 702 474 474 473 718 473 624 718 472 473 474 472 719 473 738 624 473 719 738 473 738 372 624 719 372 738 719 318 372 318 173 372 318 319 173 319 318 484 319 616 173 616 617 618 618 568 616 616 568 173 666 618 617 568 618 666 388 569 666 666 569 568 131 569 388 567 568 569 569 131 567 145 567 131 567 145 48 567 48 568 145 146 46 350 145 351 146 145 350 145 46 48 46 47 48 47 102 48 48 102 568 146 753 46 46 753 47 350 753 146 488 350 715 350 351 715 350 488 753 351 465 715 22 715 465 22 488 715 488 22 191 488 270 99 488 191 270 753 488 99 47 753 99 99 100 101 270 100 99 47 99 101 270 191 201 201 100 270 100 130 101 100 201 157 157 130 100 102 101 130 101 102 47 503 130 157 130 503 102 156 157 154 154 157 201 157 156 503 124 102 503 503 156 619 619 709 503 503 709 124 156 154 619 153 154 155 154 153 619 201 155 154 423 619 153 619 423 709 125 709 423 124 709 125 125 423 181 181 423 153 153 155 181 125 181 86 181 155 749 86 181 749 123 124 125 765 125 86 125 765 123 54 85 86 749 54 86 86 85 547 765 86 547 52 749 155 54 749 52 52 53 54 54 706 85 53 706 54 53 52 763 706 53 40 53 763 40 515 85 706 40 515 706 628 40 52 52 40 763 685 628 52 685 667 628 667 645 628 697 685 322 697 667 685 685 52 322 667 160 448 645 667 448 667 697 717 667 717 160 447 645 448 447 448 261 261 448 160 263 447 261 447 263 195 261 262 263 159 262 261 261 160 159 263 262 165 165 195 263 194 195 167 165 167 195 195 194 594 194 593 594 194 759 593 167 759 194 165 166 167 166 596 167 596 759 167 659 759 596 593 759 659 219 593 659 594 593 219 219 583 594 204 206 219 370 417 219 240 583 219 204 219 417 219 659 660 660 370 219 219 241 240 219 206 241 204 205 206 205 241 206 470 205 204 417 470 204 370 468 417 468 470 417 468 469 470 205 470 469 640 205 469 241 205 610 205 640 610 724 469 468 640 469 724 370 369 468 468 369 521 724 468 521 677 640 724 521 677 724 452 640 381 381 640 677 640 452 610 241 610 25 25 610 452 452 453 23 453 452 381 452 23 25 23 24 25 24 239 25 25 239 241 239 240 241 407 408 239 239 408 655 24 407 239 199 239 655 198 239 199 240 239 198 407 24 23 407 513 408 513 407 23 655 408 656 656 408 513 243 530 655 655 656 243 199 655 530 198 199 200 530 200 199 530 242 200 530 243 242 242 243 244 243 656 231 244 243 231 513 489 656 231 656 489 23 489 513 453 477 489 489 700 231 700 489 477 453 489 23 230 231 232 244 231 230 700 232 231 477 148 700 147 232 700 700 148 147 477 478 148 730 478 477 453 730 477 147 148 149 478 149 148 565 147 149 232 147 566 565 566 147 368 232 566 368 230 232 230 368 244 367 244 368 565 368 566 368 290 289 565 290 368 289 367 368 552 504 244 244 367 552 244 504 545 242 244 545 367 289 552 505 552 289 505 504 552 504 505 45 504 546 545 504 45 546 545 546 349 545 200 242 200 545 349 349 546 260 362 260 546 45 362 546 342 362 45 362 342 363 362 259 260 362 363 259 259 198 260 198 349 260 198 200 349 482 481 198 198 508 482 259 508 198 198 481 240 508 259 535 535 259 363 363 342 341 363 341 535 341 342 343 343 727 341 535 341 509 727 509 341 508 535 509 508 509 482 509 562 482 727 562 509 727 314 562 727 301 314 727 343 301 480 482 562 480 562 536 562 314 536 314 315 316 314 316 536 315 314 301 480 536 481 708 536 316 708 481 536 480 481 482 481 708 564 240 481 564 708 324 564 316 324 708 315 360 316 325 324 316 316 360 325 323 324 325 564 324 579 579 324 323 240 564 56 579 56 564 579 57 56 323 57 579 359 57 323 325 359 323 325 360 359 196 359 360 57 359 196 55 56 57 57 196 197 55 57 689 689 57 197 196 527 197 197 385 184 689 197 184 197 527 526 197 526 385 384 184 385 526 651 385 651 384 385 344 633 384 633 185 384 184 384 185 384 651 344 633 800 185 184 185 186 750 185 800 186 185 750 800 570 750 570 800 304 750 437 186 437 750 570 186 437 109 186 108 184 108 186 109 437 570 303 109 437 134 303 134 437 303 570 304 519 109 134 519 520 109 269 520 519 267 268 269 267 269 51 520 269 268 267 541 268 603 541 267 662 267 51 267 662 603 777 520 268 268 540 777 541 540 268 77 540 541 602 541 603 602 77 541 777 540 615 77 90 540 540 90 615 647 520 777 647 777 615 615 90 98 647 615 98 90 76 91 98 90 91 90 77 76 357 98 358 647 98 648 648 98 357 358 98 91 544 520 647 544 647 648 544 543 520 543 109 520 543 544 110 689 544 606 110 544 689 648 606 544 648 357 606 606 212 214 689 606 55 606 357 212 55 606 164 164 606 214 110 689 184 110 184 108 108 109 110 543 110 109 212 213 214 665 516 214 665 214 213 214 516 164 212 357 213 357 405 213 665 213 405 516 665 517 405 406 665 517 665 406 240 516 517 516 240 56 164 516 56 517 406 249 517 249 240 405 250 406 250 249 406 248 249 250 249 248 583 240 249 583 250 512 248 405 512 250 248 511 583 511 248 512 736 583 511 188 169 583 169 171 583 736 188 583 511 512 187 736 511 187 512 405 187 405 78 433 78 405 126 187 405 433 126 405 357 76 77 78 77 168 78 78 126 76 433 78 168 126 91 76 357 358 126 126 358 91 432 433 168 168 77 432 787 432 77 787 77 602 432 563 433 725 631 432 631 563 432 787 725 432 787 795 725 258 787 602 795 787 258 603 745 602 745 258 602 745 603 256 256 603 794 794 603 793 662 793 603 745 256 258 256 257 258 766 722 256 256 722 257 794 766 256 793 84 794 794 790 766 84 790 794 84 793 662 84 662 605 82 83 84 83 790 84 84 605 82 790 791 722 766 790 722 83 791 790 257 722 490 490 722 791 313 490 791 791 83 313 313 83 15 82 400 83 649 15 83 400 649 83 15 16 17 15 17 313 16 15 649 649 400 650 649 650 16 17 16 364 737 16 650 16 737 364 424 737 650 364 737 426 737 424 426 364 365 366 366 17 364 365 364 426 424 425 426 426 533 365 533 426 425 365 533 776 366 365 776 18 366 177 366 776 177 18 17 366 776 129 177 129 776 532 533 532 776 531 532 533 533 425 531 582 129 532 532 705 582 264 705 532 127 128 129 129 582 127 128 177 129 127 582 95 95 582 705 266 705 264 705 266 95 264 265 266 266 265 463 96 266 463 266 96 95 95 96 97 740 95 97 127 95 740 96 463 611 138 97 96 96 611 138 577 578 463 265 577 463 463 578 611 237 577 265 585 577 236 577 585 578 236 577 237 311 578 585 142 578 311 578 142 611 584 285 585 236 634 585 311 585 285 584 585 634 236 237 238 634 236 238 170 584 171 285 584 170 284 285 170 311 285 312 312 285 284 169 170 171 284 170 464 187 464 170 170 169 187 284 464 312 312 464 773 312 773 311 449 464 187 225 464 449 773 464 225 187 169 188 736 187 188 433 449 187 563 449 433 449 563 631 459 631 675 459 449 631 631 795 675 795 631 725 459 222 460 459 675 600 222 459 600 459 460 449 258 675 795 258 600 675 600 220 222 220 600 258 220 221 222 222 221 427 427 460 222 491 220 257 220 258 257 178 220 491 221 220 178 221 178 180 180 209 221 221 209 427 427 209 34 34 33 427 460 427 33 32 33 34 34 280 627 280 34 209 34 627 32 32 450 33 460 33 450 450 449 460 449 450 451 451 450 500 450 627 500 627 450 32 280 279 627 500 627 279 279 280 211 209 211 280 211 501 279 279 501 500 451 500 501 682 762 501 501 211 682 451 501 762 209 210 211 210 682 211 210 550 682 550 762 682 550 549 762 549 451 762 549 550 551 210 559 550 550 559 551 549 551 711 451 549 711 559 688 551 551 710 711 688 710 551 688 559 317 317 559 210 176 175 317 141 176 317 141 317 210 688 317 757 317 175 757 175 176 177 757 175 128 175 177 128 576 688 757 128 576 757 128 127 576 576 137 688 576 740 137 740 576 127 688 754 710 688 137 754 754 684 712 710 754 712 798 684 754 137 798 754 711 710 712 684 679 712 712 799 711 712 679 799 684 66 679 684 798 66 137 64 798 798 64 66 64 65 66 66 65 781 66 781 680 66 680 679 137 138 64 333 64 334 64 138 334 64 333 65 137 740 138 334 138 144 138 740 97 138 611 144 333 334 335 144 335 334 223 65 333 335 223 333 144 498 335 335 498 223 223 224 225 223 498 224 299 223 225 65 223 299 65 299 781 225 298 299 298 781 299 224 773 225 786 225 449 786 298 225 781 298 786 781 786 680 449 680 786 449 679 680 679 449 451 451 799 679 799 451 711 224 590 773 773 590 311 498 143 224 143 590 224 311 590 142 143 142 590 142 143 144 498 144 143 144 611 142 176 18 177 140 18 176 140 176 141 18 19 17 19 18 140 139 140 141 140 139 641 641 19 140 139 141 210 139 661 641 661 139 210 43 641 548 19 641 43 661 548 641 19 43 17 17 42 313 43 42 17 41 42 43 41 43 548 461 548 661 461 41 548 209 461 661 209 661 210 461 209 462 462 41 461 462 586 41 313 41 179 41 586 179 42 41 313 313 179 490 178 179 180 179 178 490 586 180 179 180 586 462 462 209 180 257 490 491 490 178 491 55 164 56 149 438 439 478 438 149 752 674 438 752 438 784 438 478 784 438 674 439 439 674 495 439 495 497 495 674 393 558 393 674 674 752 558 637 558 752 784 637 752 478 730 784 380 637 784 730 380 784 636 558 637 637 382 699 637 380 382 637 699 636 380 381 382 380 453 381 380 730 453 381 699 382 282 699 381 669 699 282 699 669 636 381 677 282 281 282 283 281 669 282 282 522 283 282 677 522 281 636 669 557 636 281 767 281 283 767 58 281 281 58 557 557 60 558 58 60 557 557 558 636 58 59 60 354 58 767 58 354 59 283 354 767 354 355 356 354 283 510 59 354 356 354 510 355 60 59 356 158 332 356 159 356 355 158 356 159 356 332 479 60 356 479 158 159 160 158 21 332 158 160 21 262 159 355 595 262 355 165 262 595 595 355 510 510 165 595 166 165 292 165 510 292 596 166 292 291 292 293 283 292 510 596 292 291 292 283 293 659 596 774 291 774 596 660 659 774 660 774 291 370 660 291 369 370 291 369 291 293 293 283 522 522 369 293 521 369 522 522 677 521 717 192 21 21 160 717 192 22 21 697 192 717 191 22 192 321 191 192 192 697 321 321 697 322 320 321 322 191 321 320 320 201 191 155 320 322 201 320 155 322 52 155 60 479 393 60 393 558 80 514 515 514 85 515 547 85 80 80 85 514 547 80 471 471 764 547 764 765 547 764 471 123 471 103 123 764 123 765 123 103 124 102 103 104 103 102 124 102 339 340 102 104 555 377 568 102 340 696 102 696 377 102 555 104 553 377 378 379 696 378 377 568 377 173 173 377 379 696 397 398 696 398 378 397 696 340 397 173 398 173 397 340 340 339 173 114 398 173 114 173 379 378 644 379 114 379 115 644 115 379 114 115 116 116 398 114 378 398 116 378 116 744 485 116 117 744 116 556 116 485 556 117 116 115 117 115 588 115 644 588 588 644 378 378 744 588 744 556 588 556 485 487 556 487 588 485 486 487 117 486 485 487 580 419 487 419 588 494 487 486 494 493 487 493 580 487 419 418 588 117 588 418 418 419 420 419 580 420 525 671 418 525 418 797 418 190 117 420 797 418 190 418 671 761 420 580 420 761 797 525 797 523 523 797 761 523 524 525 524 671 525 671 394 190 394 671 524 189 118 190 118 117 190 189 190 394 117 118 119 486 117 119 119 118 189 189 394 396 396 801 189 189 801 778 778 119 189 394 395 396 395 394 524 523 395 524 395 770 771 523 770 395 395 771 396 771 801 396 771 770 801 801 770 502 801 502 494 801 494 778 778 494 119 492 493 494 502 492 494 494 486 119 502 770 492 770 523 492 523 761 338 338 337 523 337 492 523 492 336 493 336 492 337 336 580 493 336 337 338 336 338 580 580 338 761 572 31 30 743 67 69))
                   (list :vertices (let ((mat (make-matrix 802 3))) (fvector-replace (array-entity mat) #f(2.6986798095703125e+02 -3.9552700042724609e+01 -8.5208602905273438e+01 2.7694601440429688e+02 -3.3872398376464844e+01 -8.5934898376464844e+01 3.0842401123046875e+02 -4.3315299987792969e+01 -8.3196403503417969e+01 3.9816000366210938e+02 -5.9998798370361328e+01 -6.2860301971435547e+01 4.0136700439453125e+02 -5.9997901916503906e+01 -7.2361297607421875e+01 4.1815399169921875e+02 -5.9998798370361328e+01 -7.0219200134277344e+01 1.5893598937988281e+02 -1.2309099197387695e+01 7.7216903686523438e+01 1.6485099792480469e+02 -3.0282199859619141e+01 7.6222206115722656e+01 1.6143600463867188e+02 -2.4344900131225586e+01 7.5617698669433594e+01 4.1278298950195312e+02 6.3789100646972656e+01 -4.5672698974609375e+01 4.1299600219726562e+02 6.7244499206542969e+01 -2.3317600250244141e+01 4.2784698486328125e+02 6.4496597290039062e+01 -3.4076499938964844e+01 2.4403401184082031e+02 -4.3474498748779297e+01 4.9415397644042969e+01 2.3051998901367188e+02 -4.5847801208496094e+01 6.0693599700927734e+01 2.4332398986816406e+02 -5.1150798797607422e+01 4.7005798339843750e+01 3.9466400146484375e+02 -6.0129798889160156e+01 6.1981597900390625e+01 4.0706597900390625e+02 -6.5834503173828125e+01 3.5854801177978516e+01 4.2979602050781250e+02 -6.0115501403808594e+01 5.5395202636718750e+01 4.6494799804687500e+02 -5.9999099731445312e+01 3.2285102844238281e+01 4.5424801635742188e+02 -5.9998901367187500e+01 4.8128002166748047e+01 3.5395199584960938e+02 5.9978099822998047e+01 -6.9140296936035156e+01 3.4920599365234375e+02 5.5760101318359375e+01 -7.7187599182128906e+01 2.9290499877929688e+02 5.7566402435302734e+01 -7.2705406188964844e+01 4.7654400634765625e+02 4.6998199462890625e+01 1.2270199775695801e+01 4.7660101318359375e+02 2.0735900878906250e+01 1.0939000129699707e+01 4.7699902343750000e+02 1.9828201293945312e+01 -5.1001197099685669e-01 3.7617300415039062e+02 6.3791996240615845e-01 -8.0953796386718750e+01 3.7085198974609375e+02 2.7463099956512451e+00 -8.1232398986816406e+01 3.7310400390625000e+02 8.4643297195434570e+00 -8.0613502502441406e+01 2.1702900695800781e+02 2.8702400207519531e+01 6.8424201965332031e+01 2.1228399658203125e+02 2.8834899902343750e+01 6.6361503601074219e+01 2.2132800292968750e+02 2.8147998809814453e+01 6.2509403228759766e+01 4.1574298095703125e+02 -2.1155399322509766e+01 7.5707298278808594e+01 4.0561700439453125e+02 -2.0677000045776367e+01 7.7149101257324219e+01 4.1629498291015625e+02 -4.6997398376464844e+01 7.5683799743652344e+01 4.1280200195312500e+02 5.4773597717285156e+01 7.7729003906250000e+01 3.8889398193359375e+02 5.4655498504638672e+01 7.8453102111816406e+01 3.9807998657226562e+02 5.0818698883056641e+01 8.2171096801757812e+01 2.3680500793457031e+02 2.4093900680541992e+01 -8.5377502441406250e+01 2.3606599426269531e+02 2.3887100219726562e+01 -8.0423400878906250e+01 2.3054598999023438e+02 2.8480600357055664e+01 -8.4933799743652344e+01 4.2424200439453125e+02 -5.3822799682617188e+01 7.6156600952148438e+01 4.2204602050781250e+02 -5.9998298645019531e+01 6.8907295227050781e+01 4.3811898803710938e+02 -5.9996799468994141e+01 6.1647697448730469e+01 3.7960198974609375e+02 4.9416500091552734e+01 8.0190101623535156e+01 3.9882598876953125e+02 4.7364601135253906e+01 8.2470901489257812e+01 1.5089700317382812e+02 7.2811798095703125e+01 -7.4253101348876953e+00 1.2140000152587891e+02 7.3841697692871094e+01 -1.8654199600219727e+01 1.2138999938964844e+02 7.6263000488281250e+01 2.3532900810241699e+00 3.0664797973632812e+02 -5.7578300476074219e+01 2.7616000175476074e+00 3.1935598754882812e+02 -6.0008102416992188e+01 5.0378699302673340e+00 3.1697500610351562e+02 -5.4764301300048828e+01 1.1626799583435059e+01 2.0703298950195312e+02 4.7485797882080078e+01 -8.2852500915527344e+01 2.0158799743652344e+02 3.0267299652099609e+01 -8.3859504699707031e+01 1.7736099243164062e+02 3.0544700622558594e+01 -8.2059303283691406e+01 3.1340600585937500e+02 1.9811399459838867e+01 9.8132400512695312e+00 3.1770397949218750e+02 1.9901700973510742e+01 6.5741100311279297e+00 3.1196200561523438e+02 2.3891498565673828e+01 1.1806300163269043e+01 4.5297799682617188e+02 5.3168800354003906e+01 -6.0622798919677734e+01 4.4024398803710938e+02 5.4464599609375000e+01 -6.8112594604492188e+01 4.4211898803710938e+02 5.9998901367187500e+01 -5.9171501159667969e+01 1.7923399353027344e+02 5.5238800048828125e+01 6.6634796142578125e+01 1.5311000061035156e+02 4.6697097778320312e+01 6.9339202880859375e+01 1.7761199951171875e+02 4.9026298522949219e+01 7.1591598510742188e+01 4.7360800170898438e+02 -4.6919101715087891e+01 -2.4326000213623047e+01 4.6661499023437500e+02 -3.4613201141357422e+01 -3.9662498474121094e+01 4.7283102416992188e+02 -2.0681900024414062e+01 -2.6530899047851562e+01 2.2145600891113281e+02 5.3074600219726562e+01 6.2365600585937500e+01 2.2105200195312500e+02 4.5480800628662109e+01 6.6385299682617188e+01 2.3066999816894531e+02 4.6444198608398438e+01 6.0312698364257812e+01 2.3813800048828125e+02 -9.9425201416015625e+00 -8.4197097778320312e+01 2.8719100952148438e+02 -9.9715194702148438e+00 -8.4992202758789062e+01 2.6918499755859375e+02 -1.0910200119018555e+01 -8.6877502441406250e+01 1.7088600158691406e+02 -6.7885894775390625e+01 2.9224599838256836e+01 2.0478900146484375e+02 -6.3624000549316406e+01 3.8380500793457031e+01 2.0894700622558594e+02 -6.0195899963378906e+01 5.3730300903320312e+01 3.2603298950195312e+02 -4.1732398986816406e+01 2.2306699752807617e+01 3.2933898925781250e+02 -4.6893299102783203e+01 3.1939498901367188e+01 3.2545599365234375e+02 -2.0907501220703125e+01 2.0522499084472656e+01 1.5300799560546875e+02 -2.8839397430419922e-01 -7.8621902465820312e+01 1.5413198852539062e+02 2.2949001312255859e+01 -7.3717597961425781e+01 1.5305299377441406e+02 -9.1694802045822144e-01 -7.5586799621582031e+01 3.3972201538085938e+02 -6.0005901336669922e+01 1.6729999542236328e+01 3.6316400146484375e+02 -6.0006202697753906e+01 5.1266201019287109e+01 3.3911499023437500e+02 -5.9995700836181641e+01 3.9877002716064453e+01 1.6171299743652344e+02 2.8147998809814453e+01 -7.8484001159667969e+01 1.5855899047851562e+02 2.9345399856567383e+01 -7.8902999877929688e+01 3.4951202392578125e+02 5.3926898956298828e+01 6.1641201019287109e+01 3.4959997558593750e+02 5.0109600067138672e+01 6.5272895812988281e+01 3.6565798950195312e+02 5.3905899047851562e+01 7.2036903381347656e+01 3.2376797485351562e+02 -4.2838600158691406e+01 2.2373498916625977e+01 3.2380599975585938e+02 -4.0734100341796875e+01 1.9065999984741211e+01 2.7185198974609375e+02 -5.8264499664306641e+01 9.5921592712402344e+00 2.9277700805664062e+02 -5.7906002044677734e+01 1.0180799961090088e+00 2.8657598876953125e+02 -5.6599098205566406e+01 4.6875100135803223e+00 4.6709600830078125e+02 -5.3823299407958984e+01 -4.3650299072265625e+01 4.6170397949218750e+02 -4.9313098907470703e+01 -5.5342300415039062e+01 4.7101599121093750e+02 -4.9803001403808594e+01 -4.2164699554443359e+01 3.1809600830078125e+02 -3.5133399963378906e+01 1.5108200073242188e+01 1.4565100097656250e+02 6.8649497985839844e+01 -3.6268699645996094e+01 1.3780499267578125e+02 6.4641105651855469e+01 -4.4423801422119141e+01 1.2140399932861328e+02 6.9412200927734375e+01 -3.2745201110839844e+01 1.2139300537109375e+02 9.9997701644897461e+00 -1.1968299865722656e+01 1.2139300537109375e+02 9.8423099517822266e+00 -7.5771804809570312e+01 1.2139900207519531e+02 -9.9811496734619141e+00 -7.4517898559570312e+01 2.1418299865722656e+02 -2.8903200149536133e+01 6.9828102111816406e+01 2.2198001098632812e+02 -2.8015300750732422e+01 6.2136299133300781e+01 2.1008999633789062e+02 -2.8920499801635742e+01 6.7124397277832031e+01 3.0036898803710938e+02 -8.9209400117397308e-02 1.5115599632263184e+01 3.0177099609375000e+02 -2.9157999038696289e+01 1.2824599266052246e+01 3.0692700195312500e+02 -2.9952199459075928e+00 1.6996101379394531e+01 2.9884201049804688e+02 -6.0129898071289062e+01 -4.8139300346374512e+00 2.9283801269531250e+02 -6.0129001617431641e+01 -5.4920700073242188e+01 3.4953399658203125e+02 -5.9949497222900391e+01 -6.8550697326660156e+01 3.9273399353027344e+01 -1.3449899673461914e+01 5.2689399719238281e+00 2.8058801651000977e+01 -1.3449899673461914e+01 2.3030998706817627e+00 3.1032899856567383e+01 -1.3450200080871582e+01 -1.0102399826049805e+01 1.8257999420166016e+01 -1.3449800491333008e+01 -2.5995299816131592e+00 -3.3837600708007812e+01 -1.3392100334167480e+01 -2.9419200420379639e+00 -3.3802902221679688e+01 -1.3426199913024902e+01 -2.2469400405883789e+01 3.0067599487304688e+02 -5.6111000061035156e+01 -7.5902999877929688e+01 2.1492999267578125e+02 -6.2470802307128906e+01 -7.0899299621582031e+01 2.4110699462890625e+02 -5.6888999938964844e+01 -7.7841697692871094e+01 1.3857699584960938e+02 1.1006800651550293e+01 -7.7741195678710938e+01 1.2139499664306641e+02 1.8486499786376953e+01 -7.4485305786132812e+01 1.4368798828125000e+02 2.6688600540161133e+01 -7.5144699096679688e+01 3.2345599365234375e+02 -3.1529602050781250e+01 1.2233900070190430e+01 4.7807601928710938e+02 -5.3813598632812500e+01 -1.8448099136352539e+01 4.8035400390625000e+02 -5.3332298278808594e+01 4.1944399476051331e-01 4.7164099121093750e+02 -5.9999298095703125e+01 -1.3072199821472168e+01 1.2139599609375000e+02 6.2054000854492188e+01 -4.5387599945068359e+01 2.1473699951171875e+02 6.3270702362060547e+01 3.4553501129150391e+01 2.2899800109863281e+02 5.9934097290039062e+01 4.3128700256347656e+01 2.6944799804687500e+02 6.0635700225830078e+01 -3.2574899196624756e+00 2.9396298217773438e+02 -4.4181598663330078e+01 9.3261995315551758e+00 2.8868298339843750e+02 -4.8889301300048828e+01 9.0583791732788086e+00 3.0042098999023438e+02 -5.3955600738525391e+01 5.0463500022888184e+00 4.7838000488281250e+02 -4.7064800262451172e+01 -2.3568698883056641e+01 4.7109402465820312e+02 -4.7213798522949219e+01 -4.1692001342773438e+01 4.5972601318359375e+02 -5.0037700653076172e+01 5.7041999816894531e+01 4.6915798950195312e+02 -5.4221202850341797e+01 3.9175598144531250e+01 4.7038098144531250e+02 -4.9879798889160156e+01 4.3316799163818359e+01 4.4158700561523438e+02 -4.5438697814941406e+01 -6.7158103942871094e+01 4.4945898437500000e+02 -4.1862598419189453e+01 -6.2420700073242188e+01 4.5697097778320312e+02 -4.7024898529052734e+01 -5.3940097808837891e+01 2.0153999328613281e+02 6.8060195922851562e+01 -1.1492799758911133e+01 1.7148500061035156e+02 7.0551795959472656e+01 -1.8865798950195312e+01 4.6680700683593750e+02 5.4159297943115234e+01 4.3343799591064453e+01 4.7536297607421875e+02 5.3367301940917969e+01 2.8076700210571289e+01 4.6810598754882812e+02 6.0000198364257812e+01 2.5183700561523438e+01 1.6003599548339844e+02 3.9523601531982422e-01 7.2710296630859375e+01 1.7845100402832031e+02 -2.8838699340820312e+01 7.1519203186035156e+01 1.8851399230957031e+02 -1.7382399737834930e-01 7.1839195251464844e+01 1.6020199584960938e+02 4.8382202148437500e+01 -7.3968200683593750e+01 1.6479299926757812e+02 5.3966899871826172e+01 -7.2279495239257812e+01 1.8417898559570312e+02 5.3395099639892578e+01 -7.8712303161621094e+01 1.4016999816894531e+02 5.3923801422119141e+01 -5.9281101226806641e+01 1.3903399658203125e+02 5.8825702667236328e+01 -5.3495998382568359e+01 4.0570599365234375e+02 5.3947601318359375e+01 -7.9568199157714844e+01 4.1013800048828125e+02 5.0291297912597656e+01 -8.1996406555175781e+01 3.7038998413085938e+02 5.1096397399902344e+01 -8.1582099914550781e+01 3.4594100952148438e+02 -5.5474601745605469e+01 -7.7564903259277344e+01 3.7423397827148438e+02 -5.9976997375488281e+01 -7.1428298950195312e+01 2.0081800842285156e+02 5.1504600524902344e+01 6.9726699829101562e+01 3.1583700561523438e+02 1.9498199462890625e+01 6.0402803421020508e+00 4.1638800048828125e+02 3.3946498870849609e+01 -8.2740203857421875e+01 4.2376199340820312e+02 3.7665500640869141e+01 -7.6277000427246094e+01 4.0964401245117188e+02 3.0147800445556641e+01 -7.9614402770996094e+01 3.3024700927734375e+02 -2.1268400192260742e+01 3.3185501098632812e+01 3.6955099487304688e+02 -1.9496799468994141e+01 -7.7861305236816406e+01 3.8992102050781250e+02 -1.9616498947143555e+01 -7.9423706054687500e+01 3.7680102539062500e+02 -1.2180100440979004e+01 -7.8124595642089844e+01 1.2139599609375000e+02 -6.6797897338867188e+01 3.8167598724365234e+01 1.2138600158691406e+02 -1.3449899673461914e+01 5.0183601379394531e+00 1.2138999938964844e+02 -7.3373306274414062e+01 2.2108100891113281e+01 4.7867797851562500e+02 -5.3674499511718750e+01 1.4692000389099121e+01 4.7551599121093750e+02 -5.3135601043701172e+01 2.7813499450683594e+01 4.7154501342773438e+02 -6.0000000000000000e+01 1.2690000534057617e+01 3.9115499877929688e+02 -4.9367801666259766e+01 8.2341598510742188e+01 4.0481698608398438e+02 -5.3760101318359375e+01 7.9872695922851562e+01 4.0211801147460938e+02 -4.8140602111816406e+01 8.2547996520996094e+01 1.6903599548339844e+02 4.3589599609375000e+01 -7.8905403137207031e+01 2.3655499267578125e+02 -5.9016101837158203e+01 4.1195701599121094e+01 2.3055299377441406e+02 -6.2521800994873047e+01 2.4980100631713867e+01 3.0025601196289062e+02 1.7427900314331055e+01 1.3779999732971191e+01 2.8647100830078125e+02 2.8453498840332031e+01 1.3760600090026855e+01 2.9213198852539062e+02 -5.9411001205444336e+00 1.4324099540710449e+01 3.4870800781250000e+02 -1.9499300003051758e+01 -6.9588104248046875e+01 3.5845397949218750e+02 -1.9489898681640625e+01 -7.4871505737304688e+01 -3.6853500366210938e+01 -1.0836500167846680e+01 -9.1771993637084961e+00 -3.5132900238037109e+01 -8.0246801376342773e+00 -2.6096498966217041e+00 2.1107600402832031e+02 6.1521999359130859e+01 -7.3211105346679688e+01 3.0263299560546875e+02 5.4852298736572266e+01 -7.7576599121093750e+01 1.5302899169921875e+02 -1.0001899719238281e+01 -7.7975898742675781e+01 3.9240100097656250e+02 2.0922300338745117e+01 -8.0007392883300781e+01 3.8156701660156250e+02 1.5172899246215820e+01 -8.3363395690917969e+01 3.1338800048828125e+02 4.3959300994873047e+01 9.6440000534057617e+00 3.0935299682617188e+02 3.1767000198364258e+01 1.4847200393676758e+01 4.1321200561523438e+02 1.9500000000000000e+01 7.4684600830078125e+01 4.4500399780273438e+02 1.9546899795532227e+01 6.1493198394775391e+01 4.3336401367187500e+02 2.0601499557495117e+01 6.9930801391601562e+01 1.7918800354003906e+02 5.9264999389648438e+01 -7.2425399780273438e+01 2.0902299499511719e+02 -5.0874099731445312e+01 -8.2039299011230469e+01 2.0939199829101562e+02 -4.2539100646972656e+01 -8.3531600952148438e+01 4.6049899291992188e+02 2.0859399795532227e+01 -4.8491600036621094e+01 4.7099700927734375e+02 2.0322999954223633e+01 -3.1006698608398438e+01 4.5732098388671875e+02 1.9546899795532227e+01 -5.0013301849365234e+01 2.6233499145507812e+02 -5.5384502410888672e+01 2.2946399688720703e+01 2.6440701293945312e+02 -4.7897102355957031e+01 2.6482500076293945e+01 4.2614999389648438e+02 -4.7050201416015625e+01 7.7948097229003906e+01 4.6317398071289062e+02 -4.7130199432373047e+01 5.2111000061035156e+01 4.4767901611328125e+02 -4.6999599456787109e+01 6.0965400695800781e+01 3.1367700195312500e+02 -1.9999500274658203e+01 9.2987298965454102e+00 3.1829699707031250e+02 -1.9518999099731445e+01 6.2488603591918945e+00 3.1570898437500000e+02 -1.9467100143432617e+01 6.0103697776794434e+00 2.7382998657226562e+02 -4.7906997680664062e+01 -8.3371200561523438e+01 3.7380999755859375e+02 6.6768104553222656e+01 -1.5534600257873535e+01 4.0231399536132812e+02 6.8998100280761719e+01 -4.4331297874450684e+00 3.9324899291992188e+02 6.7024795532226562e+01 -2.7822500228881836e+01 4.4623501586914062e+02 1.9570301055908203e+01 -6.2450401306152344e+01 3.7662802124023438e+02 -4.7040100097656250e+01 7.7853797912597656e+01 3.9494699096679688e+02 -4.7025600433349609e+01 8.1092605590820312e+01 3.8329397583007812e+02 -4.6997100830078125e+01 7.5581100463867188e+01 4.6304602050781250e+02 -3.1340900421142578e+01 -4.9396999359130859e+01 4.4703701782226562e+02 -2.0881000518798828e+01 -6.4975502014160156e+01 4.4551101684570312e+02 -1.9466899871826172e+01 -6.3752300262451172e+01 2.2124800109863281e+02 -5.3368698120117188e+01 6.2238800048828125e+01 2.3674499511718750e+02 -5.6224300384521484e+01 4.7721401214599609e+01 2.8605099487304688e+02 5.8087200164794922e+01 2.0315999984741211e+00 2.8768499755859375e+02 6.0119899749755859e+01 -6.3383498191833496e+00 4.5564801025390625e+02 4.8281200408935547e+01 6.1075901031494141e+01 4.6816302490234375e+02 4.7333400726318359e+01 4.6460899353027344e+01 4.6154400634765625e+02 4.9588298797607422e+01 5.5273998260498047e+01 3.3768499755859375e+02 5.9995300292968750e+01 3.7050399780273438e+01 3.3727801513671875e+02 5.3218498229980469e+01 5.0358001708984375e+01 3.5332699584960938e+02 6.0000000000000000e+01 5.5455799102783203e+01 4.2033700561523438e+02 -3.7974300384521484e+01 -8.2487594604492188e+01 4.2375799560546875e+02 -4.8129497528076172e+01 -7.9968200683593750e+01 4.0650000000000000e+02 -4.4263099670410156e+01 -8.4146697998046875e+01 4.6930300903320312e+02 1.9473699569702148e+01 3.3172203063964844e+01 3.2463699340820312e+02 1.9500299453735352e+01 7.4353399276733398e+00 4.7125399780273438e+02 1.9502698898315430e+01 -2.7070699691772461e+01 4.3906799316406250e+02 4.6999397277832031e+01 6.6787101745605469e+01 4.5112899780273438e+02 4.6999698638916016e+01 5.8139202117919922e+01 4.4153402709960938e+02 4.7216899871826172e+01 7.0952301025390625e+01 3.0929199218750000e+02 5.6993598937988281e+01 4.3637099266052246e+00 3.1117401123046875e+02 6.0046901702880859e+01 -3.5963502526283264e-01 2.9760000610351562e+02 5.7296298980712891e+01 1.9913599491119385e+00 3.3396099853515625e+02 1.9496799468994141e+01 -5.5271099090576172e+01 3.2498199462890625e+02 1.9494899749755859e+01 -3.9764198303222656e+01 3.3048901367187500e+02 -1.9485799789428711e+01 -5.0209197998046875e+01 1.9752000427246094e+02 -2.8996999740600586e+01 6.9826400756835938e+01 1.9283300781250000e+02 -2.9338899612426758e+01 7.4710800170898438e+01 2.6233499145507812e+02 5.5384597778320312e+01 2.2946199417114258e+01 2.4693399047851562e+02 4.9439197540283203e+01 4.4376800537109375e+01 2.6343600463867188e+02 4.6680801391601562e+01 2.8110099792480469e+01 3.4889099121093750e+02 -5.0128097534179688e+01 6.4892799377441406e+01 3.6860800170898438e+02 -4.9317401885986328e+01 7.6662300109863281e+01 3.5238598632812500e+02 -4.7202503204345703e+01 6.7087905883789062e+01 3.8578799438476562e+02 2.0408199310302734e+01 7.6132904052734375e+01 4.0146801757812500e+02 2.0530000686645508e+01 7.7252403259277344e+01 4.0245700073242188e+02 4.2681701660156250e+01 -8.4610900878906250e+01 4.1418099975585938e+02 4.4590801239013672e+01 -8.3079399108886719e+01 4.0629299926757812e+02 2.9699600219726562e+01 -8.4733703613281250e+01 4.3701199340820312e+02 -5.9997001647949219e+01 -6.2299800872802734e+01 4.2976300048828125e+02 -5.2976600646972656e+01 -7.5196701049804688e+01 4.4970101928710938e+02 -5.3270896911621094e+01 -6.3543998718261719e+01 3.1956198120117188e+02 -4.9608798980712891e+01 2.1117498397827148e+01 3.1445397949218750e+02 -4.7147800445556641e+01 1.3249499320983887e+01 3.1273001098632812e+02 -4.9305099487304688e+01 1.2802599906921387e+01 1.8479399108886719e+02 6.2976100921630859e+01 -6.6643096923828125e+01 2.3029998779296875e+02 8.4347200393676758e+00 6.1281799316406250e+01 2.3263600158691406e+02 1.4125600814819336e+01 6.2240001678466797e+01 2.3024700927734375e+02 2.0864000320434570e+01 6.2046798706054688e+01 2.5917700195312500e+02 5.8716899871826172e+01 1.8326200485229492e+01 2.7426300048828125e+02 5.6647098541259766e+01 1.1210100173950195e+01 2.0695100402832031e+02 -4.3192401885986328e+01 7.1861602783203125e+01 2.1846200561523438e+02 -4.6244400024414062e+01 6.7268699645996094e+01 2.1029199218750000e+02 -3.1240501403808594e+01 7.2299598693847656e+01 4.3961300659179688e+02 -2.0954700469970703e+01 6.6452499389648438e+01 4.3207299804687500e+02 -4.6992599487304688e+01 7.0418098449707031e+01 4.6399798583984375e+02 4.8775402069091797e+01 -5.2801399230957031e+01 4.6948901367187500e+02 4.7205799102783203e+01 -4.3558399200439453e+01 4.5015399169921875e+02 4.7171199798583984e+01 -6.4952598571777344e+01 4.0357000732421875e+02 -2.0669000625610352e+01 -7.9856201171875000e+01 4.0683801269531250e+02 -2.8655300140380859e+01 -7.9769798278808594e+01 2.5902499389648438e+02 -6.0186401367187500e+01 -7.0155700683593750e+01 2.1616398620605469e+02 -6.4617599487304688e+01 -6.2114997863769531e+01 4.2200000000000000e+02 5.9999801635742188e+01 6.9077003479003906e+01 4.3445199584960938e+02 5.3369400024414062e+01 7.2814002990722656e+01 4.3856399536132812e+02 5.9996898651123047e+01 6.1295597076416016e+01 4.4381399536132812e+02 3.5276599884033203e+01 -6.7163101196289062e+01 4.3527200317382812e+02 4.3373802185058594e+01 -7.1270103454589844e+01 4.4901699829101562e+02 4.6619899749755859e+01 -6.1579498291015625e+01 2.4286100769042969e+02 3.9521400451660156e+01 5.1413299560546875e+01 2.3515998840332031e+02 3.2205600738525391e+01 5.8955299377441406e+01 2.5973300170898438e+02 3.4162399291992188e+01 3.3229400634765625e+01 2.6420401000976562e+02 1.0952799797058105e+01 2.9290800094604492e+01 4.5578500366210938e+02 -2.0386100769042969e+01 -5.3351303100585938e+01 4.5673098754882812e+02 -2.5990900039672852e+01 -5.2924598693847656e+01 3.2822100830078125e+02 4.8122303009033203e+01 4.0762302398681641e+01 3.4029400634765625e+02 4.7230400085449219e+01 5.6344596862792969e+01 3.3739401245117188e+02 4.9815700531005859e+01 5.3847499847412109e+01 2.7990402221679688e+02 -3.4508197784423828e+01 1.6098100662231445e+01 2.7173001098632812e+02 -2.3079999923706055e+01 2.2498600006103516e+01 3.5463101196289062e+02 9.9919700622558594e+00 -8.3778205871582031e+01 3.2274899291992188e+02 9.9649105072021484e+00 -8.4541297912597656e+01 3.5360900878906250e+02 1.0478300094604492e+01 -8.5510597229003906e+01 1.2139499664306641e+02 -6.3039100646972656e+01 -4.4126201629638672e+01 1.3699099731445312e+02 -5.5877101898193359e+01 -5.5938301086425781e+01 1.3608500671386719e+02 -6.2437999725341797e+01 -4.7398002624511719e+01 4.2259899902343750e+02 -3.7057601928710938e+01 -7.6763397216796875e+01 4.1775000000000000e+02 -2.0649799346923828e+01 -7.8183700561523438e+01 4.0339199829101562e+02 -6.0000198364257812e+01 7.2648506164550781e+01 3.3673199462890625e+02 4.7000499725341797e+01 4.4600597381591797e+01 3.2035400390625000e+02 4.7154197692871094e+01 2.0995000839233398e+01 3.2905001831054688e+02 4.7052600860595703e+01 3.0753099441528320e+01 4.7758999633789062e+02 -4.8609100341796875e+01 2.9899200439453125e+01 1.2140000152587891e+02 1.9523799896240234e+01 7.4487297058105469e+01 1.2139499664306641e+02 3.9317897796630859e+01 6.6696304321289062e+01 2.0190800476074219e+02 5.8483600616455078e+01 -7.7087097167968750e+01 2.2209100341796875e+02 5.7571899414062500e+01 -7.8153198242187500e+01 2.1001901245117188e+02 5.5216201782226562e+01 -8.0158599853515625e+01 3.2088198852539062e+02 3.5206298828125000e+01 1.3385799407958984e+01 3.2439700317382812e+02 3.7311798095703125e+01 1.6667499542236328e+01 3.2435501098632812e+02 4.3716197967529297e+01 2.3257200241088867e+01 2.5734100341796875e+02 -5.8833999633789062e+01 1.9736801147460938e+01 2.7373901367187500e+02 -6.0437702178955078e+01 -4.7786302566528320e+00 1.5920799255371094e+02 -4.7932201385498047e+01 -7.3774101257324219e+01 1.3699800109863281e+02 -4.6578701019287109e+01 -6.3617298126220703e+01 1.3964399719238281e+02 -3.7774299621582031e+01 -6.9598396301269531e+01 3.8093399047851562e+02 6.0015296936035156e+01 -6.0300498962402344e+01 4.0476599121093750e+02 6.0003501892089844e+01 -7.2448501586914062e+01 4.7289801025390625e+02 -4.3565998077392578e+01 -3.0951099395751953e+01 4.6832400512695312e+02 -4.6991901397705078e+01 -3.8521598815917969e+01 4.6921099853515625e+02 -4.0864398956298828e+01 -3.9848701477050781e+01 -3.8829799652099609e+01 8.4264297485351562e+00 -1.8046800613403320e+01 -5.2199600219726562e+01 6.6490097045898438e+00 -1.9946599960327148e+01 -5.2207397460937500e+01 9.3103599548339844e+00 -1.5870100021362305e+01 1.2139499664306641e+02 -6.9184402465820312e+01 -3.3060401916503906e+01 1.2139199829101562e+02 -1.3450200080871582e+01 -1.1897100448608398e+01 3.6526599121093750e+02 4.7000099182128906e+01 6.9119102478027344e+01 3.7322500610351562e+02 4.7052600860595703e+01 7.7051498413085938e+01 3.5123101806640625e+02 4.7212699890136719e+01 6.5883598327636719e+01 2.8851800537109375e+02 4.9751800537109375e+01 8.6520395278930664e+00 2.8751098632812500e+02 5.5096500396728516e+01 5.7343597412109375e+00 3.7455099487304688e+02 -9.9911594390869141e+00 -8.3500495910644531e+01 3.7303500366210938e+02 -1.0890100479125977e+01 -8.5416603088378906e+01 3.4465899658203125e+02 -9.9475593566894531e+00 -8.4082099914550781e+01 4.1382199096679688e+02 2.0520500183105469e+01 7.6125801086425781e+01 2.0997700500488281e+02 6.8231796264648438e+01 -3.5426097869873047e+01 2.7858599853515625e+02 6.1413700103759766e+01 -5.0858596801757812e+01 3.6783599853515625e+02 -6.0022102355957031e+01 -5.2814899444580078e+01 3.4871200561523438e+02 -6.0184501647949219e+01 -3.4829399108886719e+01 4.4373800659179688e+02 4.8891300201416016e+01 -7.0732597351074219e+01 4.2629199218750000e+02 4.6583400726318359e+01 -7.9632698059082031e+01 4.2881201171875000e+02 5.3365398406982422e+01 -7.5047004699707031e+01 3.1871499633789062e+02 -2.5577901840209961e+01 7.7959499359130859e+00 3.2085601806640625e+02 -3.4658000946044922e+01 1.2971100807189941e+01 3.1939797973632812e+02 3.7043003082275391e+01 1.6164699554443359e+01 3.1959201049804688e+02 4.7047298431396484e+01 1.3563099861145020e+01 4.2574600219726562e+02 -5.9999397277832031e+01 -5.6593803405761719e+01 3.9389801025390625e+02 4.6999099731445312e+01 7.7121597290039062e+01 3.7800500488281250e+02 4.6999698638916016e+01 7.4091598510742188e+01 4.3556100463867188e+02 -6.3748703002929688e+01 3.2133800506591797e+01 4.4895700073242188e+02 -6.3019500732421875e+01 1.3286800384521484e+01 4.5796099853515625e+02 -6.0000598907470703e+01 2.3436199188232422e+01 4.3767700195312500e+02 5.0037998199462891e+01 7.3454299926757812e+01 4.4826699829101562e+02 5.1183601379394531e+01 6.6398002624511719e+01 4.5757299804687500e+02 4.1167499542236328e+01 -5.5166099548339844e+01 4.5711499023437500e+02 2.6968900680541992e+01 -5.5978801727294922e+01 1.2141799926757812e+02 -1.1030699729919434e+01 7.5932998657226562e+01 1.2137699890136719e+02 1.8111799955368042e+00 7.6768302917480469e+01 2.0642100524902344e+02 -5.0541698455810547e+01 6.9386802673339844e+01 1.6833900451660156e+02 -3.0322700500488281e+01 -8.0908203125000000e+01 1.8574899291992188e+02 -4.7965602874755859e+01 -8.0921394348144531e+01 1.6871299743652344e+02 -4.2440601348876953e+01 -7.9159805297851562e+01 1.2138600158691406e+02 9.9997997283935547e+00 4.9754199981689453e+00 4.0206996917724609e+01 9.9997606277465820e+00 -7.0157999992370605e+00 3.9356601715087891e+01 9.9995203018188477e+00 5.4596600532531738e+00 4.8285897827148438e+02 4.9023597717285156e+01 -2.2885200977325439e+00 4.8016101074218750e+02 4.7198200225830078e+01 -1.9647600173950195e+01 4.8022198486328125e+02 4.8344600677490234e+01 -2.0300500869750977e+01 1.6862901306152344e+02 -2.8404600143432617e+01 7.5372299194335938e+01 2.9437399291992188e+02 3.9367702484130859e+01 1.0528300285339355e+01 3.0028799438476562e+02 3.4368198394775391e+01 1.1748299598693848e+01 2.0505499267578125e+02 5.6041301727294922e+01 6.4948997497558594e+01 2.2232901000976562e+02 5.7294200897216797e+01 5.6930500030517578e+01 2.0981199645996094e+02 5.9544300079345703e+01 5.5890800476074219e+01 3.2305099487304688e+02 4.8730499267578125e+01 2.9741498947143555e+01 3.2657901000976562e+02 5.0801998138427734e+01 3.6722202301025391e+01 3.2317297363281250e+02 5.3442298889160156e+01 2.3058900833129883e+01 4.1613598632812500e+02 6.0000698089599609e+01 -6.0036998748779297e+01 4.3933401489257812e+02 6.0003200531005859e+01 -4.8552902221679688e+01 -3.9101898193359375e+01 -7.7785501480102539e+00 -5.9053301811218262e+00 -5.2207202911376953e+01 -1.0355299949645996e+01 -1.0454099655151367e+01 -4.0447898864746094e+01 -1.0300499916076660e+01 -1.0833999633789062e+01 1.0617300415039062e+02 -1.3450200080871582e+01 -7.1649298667907715e+00 4.1278999328613281e+01 -1.3450200080871582e+01 -7.0143098831176758e+00 3.6346099853515625e+02 -6.5623001098632812e+01 9.0900602340698242e+00 3.5942700195312500e+02 -6.3574501037597656e+01 2.6146200180053711e+01 2.0978799438476562e+02 -2.9403900146484375e+01 -8.3998802185058594e+01 1.7411898803710938e+02 -2.8856199264526367e+01 -7.6761901855468750e+01 2.0923100280761719e+02 -2.8993900299072266e+01 -7.9408493041992188e+01 1.8325599670410156e+02 -2.9675899505615234e+01 -8.2495506286621094e+01 3.2358700561523438e+02 -1.9684499740600586e+01 8.6622705459594727e+00 3.2215802001953125e+02 -1.9497999191284180e+01 -3.2977199554443359e+01 4.7376901245117188e+02 2.1386598587036133e+01 2.3267200469970703e+01 4.6779000854492188e+02 2.0513000488281250e+01 3.7409702301025391e+01 2.6880700683593750e+02 1.0747099876403809e+01 -8.6791000366210938e+01 2.3817601013183594e+02 9.9974393844604492e+00 -8.4372398376464844e+01 2.3947698974609375e+02 1.0498600006103516e+01 -8.5949401855468750e+01 3.1859100341796875e+02 4.9858699798583984e+01 1.9355899810791016e+01 3.1367199707031250e+02 4.7429000854492188e+01 1.4108799934387207e+01 3.1850399780273438e+02 1.0779599189758301e+01 -8.6433502197265625e+01 2.8481298828125000e+02 9.9594202041625977e+00 -8.4976303100585938e+01 1.2139700317382812e+02 -4.4761199951171875e+01 -6.2557197570800781e+01 4.6009799194335938e+02 2.8615100860595703e+01 -4.8899898529052734e+01 -3.8805297851562500e+01 2.1942300796508789e+00 -2.6787099838256836e+00 -3.4253200531005859e+01 9.9260101318359375e+00 -2.9263200759887695e+00 -3.8575702667236328e+01 8.2397899627685547e+00 -6.9093298912048340e+00 2.7972097778320312e+02 -4.8689601898193359e+01 1.3545800209045410e+01 2.7527099609375000e+02 -5.5110301971435547e+01 1.2155799865722656e+01 1.4177799987792969e+02 3.4543399810791016e+01 -7.1905502319335938e+01 4.0603500366210938e+02 -6.8803497314453125e+01 1.4634000062942505e+00 4.2048498535156250e+02 -6.7412506103515625e+01 -1.6210699081420898e+01 4.2928799438476562e+02 -6.6924293518066406e+01 5.2737298011779785e+00 4.0248297119140625e+02 -4.6996101379394531e+01 7.7266098022460938e+01 2.2039199829101562e+02 -5.7974597930908203e+01 5.6403701782226562e+01 3.7732897949218750e+02 -6.6330902099609375e+01 -2.5233098983764648e+01 4.0149700927734375e+02 -6.6905899047851562e+01 -2.9552000045776367e+01 3.8943698120117188e+02 -6.8757202148437500e+01 -3.5911800861358643e+00 3.3835198974609375e+02 -2.0324998855590820e+01 4.6718502044677734e+01 3.2756399536132812e+02 -1.9502300262451172e+01 2.3850599288940430e+01 2.1592498779296875e+02 -5.5361698150634766e+01 -8.0084693908691406e+01 1.9516900634765625e+02 -5.4913799285888672e+01 -7.9384605407714844e+01 1.8761500549316406e+02 5.8249599456787109e+01 6.2449001312255859e+01 2.8975201416015625e+02 -2.5156000137329102e+01 1.3326499938964844e+01 4.7258099365234375e+02 5.9998699188232422e+01 1.4192500114440918e+00 4.6284500122070312e+02 6.0008701324462891e+01 -3.6313802003860474e-01 2.6817199707031250e+02 6.0726200103759766e+01 -2.7909000396728516e+01 2.3774301147460938e+02 -6.5778999328613281e+01 -4.0708198547363281e+01 1.9886698913574219e+02 -6.8236595153808594e+01 -7.3314499855041504e+00 1.6130700683593750e+02 -5.6858901977539062e+01 -6.7954200744628906e+01 1.2141799926757812e+02 -5.5553199768066406e+01 5.3859497070312500e+01 3.7179501342773438e+02 -6.6181998252868652e+00 -8.0730995178222656e+01 3.7031201171875000e+02 -7.3377901315689087e-01 -8.4307601928710938e+01 3.7452600097656250e+02 1.2316200256347656e+01 -8.5427001953125000e+01 3.8273400878906250e+02 4.4961502075195312e+01 -8.4029304504394531e+01 3.7726901245117188e+02 -1.9499799728393555e+01 7.2692901611328125e+01 4.1229699707031250e+02 -1.9455799102783203e+01 7.4946296691894531e+01 4.6330401611328125e+02 -1.9528900146484375e+01 4.3163600921630859e+01 4.7718499755859375e+02 4.7031600952148438e+01 -8.0190200805664062e+00 4.8117797851562500e+02 4.7104103088378906e+01 1.1359499931335449e+01 1.3648399353027344e+02 -7.2275802612304688e+01 -2.1791400909423828e+01 1.3998199462890625e+02 -6.8141899108886719e+01 -3.7146900177001953e+01 1.6234800720214844e+02 -6.9730903625488281e+01 -3.2697902679443359e+01 3.0661300659179688e+02 -5.1591899871826172e+01 -8.0196205139160156e+01 2.7342999267578125e+02 -5.4090297698974609e+01 -7.9887596130371094e+01 3.6923501586914062e+02 -2.0616098403930664e+01 7.0954002380371094e+01 3.8781600952148438e+02 -2.0435501098632812e+01 7.6430000305175781e+01 4.3329598999023438e+02 -4.9894702911376953e+01 7.5655799865722656e+01 4.2008502197265625e+02 -4.8013698577880859e+01 8.0104499816894531e+01 4.4692098999023438e+02 -4.8459602355957031e+01 -6.8739601135253906e+01 4.1259197998046875e+02 -1.9500400543212891e+01 -7.7915992736816406e+01 2.9868200683593750e+02 5.9954502105712891e+01 -5.9096500396728516e+01 4.0756698608398438e+02 -5.3954998016357422e+01 -7.9620101928710938e+01 1.8743200683593750e+02 -3.0600299835205078e+01 7.5947799682617188e+01 4.6523699951171875e+02 3.3452102661132812e+01 -4.6088500976562500e+01 4.7157601928710938e+02 4.1733699798583984e+01 -2.9466199874877930e+01 4.6689297485351562e+02 3.5142101287841797e+01 -3.9242900848388672e+01 1.5311799621582031e+02 1.0007599830627441e+01 -7.8002296447753906e+01 1.6796398925781250e+02 2.8336099624633789e+01 7.5395004272460938e+01 1.6127600097656250e+02 2.3711500167846680e+01 7.5437797546386719e+01 1.6511000061035156e+02 2.7566200256347656e+01 7.1445800781250000e+01 1.5259201049804688e+02 -6.4640899658203125e+01 -5.0179199218750000e+01 1.8425700378417969e+02 -6.5575004577636719e+01 -5.7792900085449219e+01 4.7907901000976562e+02 4.9219799041748047e+01 2.4461700439453125e+01 4.7902798461914062e+02 5.3630901336669922e+01 1.2806399345397949e+01 4.2361099243164062e+02 5.9999702453613281e+01 -6.8437705993652344e+01 3.3600100708007812e+02 1.9685701370239258e+01 4.1637802124023438e+01 3.2825299072265625e+02 1.9507299423217773e+01 2.5761199951171875e+01 3.4998699951171875e+02 1.9506198883056641e+01 5.7094299316406250e+01 2.9614199829101562e+02 -5.8876800537109375e+01 -6.7440895080566406e+01 1.4397099304199219e+02 3.4710399627685547e+01 7.2951499938964844e+01 1.9188299179077148e+01 -1.3449099540710449e+01 -1.9286100387573242e+01 8.8103094100952148e+00 -1.3450000762939453e+01 -2.2580400466918945e+01 9.1594600677490234e+00 9.9991302490234375e+00 -2.2570899963378906e+01 2.0770800781250000e+02 6.4783897399902344e+01 -6.3669601440429688e+01 4.7770101928710938e+02 4.7195800781250000e+01 2.6885499954223633e+01 3.8425799560546875e+02 -5.3581401824951172e+01 7.8558601379394531e+01 3.7770700073242188e+02 -4.8815399169921875e+01 7.9550903320312500e+01 -3.9498798370361328e+01 1.5597300529479980e+00 -2.2691600799560547e+01 -3.4039699554443359e+01 9.9082002639770508e+00 -2.2434900283813477e+01 -3.6558097839355469e+01 -5.7264099121093750e+00 -2.2590900421142578e+01 4.4380700683593750e+02 6.3095195770263672e+01 -2.5015701293945312e+01 4.3029800415039062e+02 6.6494598388671875e+01 -1.1050700187683105e+01 4.4017498779296875e+02 6.5324302673339844e+01 3.3569598197937012e+00 4.5810400390625000e+02 -4.0826000213623047e+01 -5.4695598602294922e+01 4.5092700195312500e+02 6.0000900268554688e+01 3.5562900543212891e+01 4.4334500122070312e+02 -1.9585000991821289e+01 6.2819400787353516e+01 4.5092898559570312e+02 -2.0515899658203125e+01 5.8298099517822266e+01 -4.0346801757812500e+01 -4.0342397689819336e+00 -2.1897998809814453e+01 1.2140099334716797e+02 4.9184898376464844e+01 -5.8824798583984375e+01 4.1492999267578125e+02 4.7227798461914062e+01 8.0652099609375000e+01 4.1453997802734375e+02 5.0165798187255859e+01 8.1171600341796875e+01 2.2669300842285156e+02 -2.6684700012207031e+01 6.3238204956054688e+01 2.2936099243164062e+02 -2.2227499008178711e+01 5.7892700195312500e+01 3.7604699707031250e+02 1.9552198410034180e+01 7.2653701782226562e+01 3.5830798339843750e+02 2.0399900436401367e+01 6.4990997314453125e+01 4.3634799194335938e+02 4.4071701049804688e+01 -7.5414703369140625e+01 3.4434301757812500e+02 1.9485799789428711e+01 -6.6335098266601562e+01 3.3899700927734375e+02 -1.9488298416137695e+01 -6.1291198730468750e+01 4.7089700317382812e+02 4.6998100280761719e+01 3.1079801559448242e+01 1.6093299865722656e+02 2.7697698593139648e+01 -7.4587799072265625e+01 1.8120401000976562e+02 2.9061500549316406e+01 -7.7659301757812500e+01 3.1665600585937500e+02 1.9500200271606445e+01 -7.8561501502990723e+00 3.1971899414062500e+02 1.9496500015258789e+01 -2.4786399841308594e+01 1.2138700103759766e+02 -7.5496597290039062e+01 1.0262300491333008e+01 3.0283901977539062e+02 -4.5932201385498047e+01 9.2503805160522461e+00 3.1062100219726562e+02 -4.3601200103759766e+01 1.3135299682617188e+01 4.6549798583984375e+02 4.2101699829101562e+01 -4.5255798339843750e+01 4.5980999755859375e+02 4.7003799438476562e+01 -5.0753398895263672e+01 -5.2213600158691406e+01 1.2892800569534302e+00 -2.2631900787353516e+01 -5.2211299896240234e+01 -5.4359102249145508e+00 -3.8882999420166016e+00 -5.2213199615478516e+01 1.3888500928878784e+00 -2.5954499244689941e+00 3.0472399902343750e+02 4.3305599212646484e+01 1.0643199920654297e+01 3.1080697631835938e+02 4.4436500549316406e+01 1.2970600128173828e+01 1.5894099426269531e+02 -2.7586198806762695e+01 -7.8158294677734375e+01 1.5885800170898438e+02 -2.7126901626586914e+01 -7.4080604553222656e+01 4.4790399169921875e+02 2.1455801010131836e+01 6.0823398590087891e+01 4.3296899414062500e+02 -6.2763103485107422e+01 -4.0159099578857422e+01 4.5260400390625000e+02 -6.0000301361083984e+01 -3.3559501647949219e+01 4.4520397949218750e+02 -6.3975402832031250e+01 -1.2906099319458008e+01 3.7690798950195312e+02 -1.1944700241088867e+01 -7.9862800598144531e+01 3.6856698608398438e+02 2.1349100112915039e+01 7.0643501281738281e+01 3.3417401123046875e+02 2.1146800994873047e+01 4.0620899200439453e+01 3.2288400268554688e+02 -1.0753899574279785e+01 -8.6279701232910156e+01 2.0102400207519531e+02 2.9871599197387695e+01 7.4030899047851562e+01 1.8846600341796875e+02 2.9156999588012695e+01 7.4716003417968750e+01 3.2325698852539062e+02 -4.6995498657226562e+01 1.8619600296020508e+01 3.2074697875976562e+02 -4.7207698822021484e+01 2.1647300720214844e+01 2.4750900268554688e+02 5.6442199707031250e+01 3.6722599029541016e+01 3.0844799804687500e+02 -2.9747200012207031e+01 1.4979500770568848e+01 3.0972601318359375e+02 -2.8544599533081055e+01 1.4712999343872070e+01 4.2329998779296875e+02 4.6996997833251953e+01 7.3860496520996094e+01 4.0638699340820312e+02 4.6999000549316406e+01 7.7058898925781250e+01 1.5434100341796875e+02 2.3110198974609375e+01 -7.7022499084472656e+01 4.4112100219726562e+02 -5.3270896911621094e+01 6.8994697570800781e+01 4.6729901123046875e+02 -2.0598600387573242e+01 3.8382602691650391e+01 4.6611401367187500e+02 -4.6995800018310547e+01 4.0229000091552734e+01 4.7122500610351562e+02 -4.6993999481201172e+01 3.0214799880981445e+01 4.2645800781250000e+02 4.8638900756835938e+01 7.8525604248046875e+01 1.2144699859619141e+02 -1.1082099914550781e+01 -7.5967903137207031e+01 1.4094400024414062e+02 -2.3374700546264648e+01 -7.5681999206542969e+01 1.2139599609375000e+02 -2.3031799316406250e+01 -7.3275901794433594e+01 2.4208999633789062e+01 9.9948997497558594e+00 -1.6386301040649414e+01 4.6035598754882812e+02 5.4745700836181641e+01 -5.0807498931884766e+01 4.6098397827148438e+02 6.0000198364257812e+01 -3.9570899963378906e+01 4.7446398925781250e+02 -4.7099300384521484e+01 3.3413898468017578e+01 2.2766700744628906e+02 2.6047399520874023e+01 6.2707603454589844e+01 2.2859199523925781e+02 2.3706499099731445e+01 5.8528301239013672e+01 3.4494900512695312e+02 2.0604000091552734e+01 5.4376502990722656e+01 3.4264300537109375e+02 -1.9499799728393555e+01 4.9337902069091797e+01 3.2253900146484375e+02 2.0319999694824219e+01 7.6380100250244141e+00 4.5493099975585938e+02 6.0001399993896484e+01 4.7762699127197266e+01 4.5729299926757812e+02 5.3432701110839844e+01 5.6181900024414062e+01 1.8244999694824219e+02 6.8681800842285156e+01 1.4439599990844727e+01 1.2139499664306641e+02 7.4013999938964844e+01 1.9531600952148438e+01 1.8924299621582031e+02 6.5076095581054688e+01 3.6148399353027344e+01 2.7857199096679688e+02 -3.3273999691009521e+00 1.8129701614379883e+01 3.9531201171875000e+02 5.9999397277832031e+01 7.2362403869628906e+01 2.1791999816894531e+02 -1.9250901043415070e-01 6.5389793395996094e+01 3.1770700073242188e+02 5.3210601806640625e+01 1.4727499961853027e+01 3.2292199707031250e+02 5.9970901489257812e+01 8.9725704193115234e+00 3.1019198608398438e+02 5.1456100463867188e+01 9.8250303268432617e+00 4.8186499023437500e+02 -4.8405200958251953e+01 -1.3818000793457031e+01 4.3462802124023438e+02 -4.4208602905273438e+01 -7.6701301574707031e+01 4.3775698852539062e+02 -4.4371601104736328e+01 -7.3397705078125000e+01 3.1949499511718750e+02 2.8391700744628906e+01 9.0772905349731445e+00 -3.9751296997070312e+01 9.8612995147705078e+00 -1.2903699874877930e+01 3.7295700073242188e+02 6.0000801086425781e+01 6.7334602355957031e+01 4.6382299804687500e+02 -5.9995300292968750e+01 -3.4188697814941406e+01 3.6793399047851562e+02 1.9505699157714844e+01 -7.7577400207519531e+01 3.8226300048828125e+02 -1.6083599090576172e+01 -8.4906799316406250e+01 4.1496301269531250e+02 -3.3101997375488281e+01 -8.3059196472167969e+01 4.1146499633789062e+02 -5.0028800964355469e+01 8.1623298645019531e+01 2.2652099609375000e+02 -2.9473999023437500e+01 6.5283798217773438e+01 1.8784099578857422e+01 9.9991903305053711e+00 -2.5935499668121338e+00 1.2140399932861328e+02 -2.9224199295043945e+01 7.1641403198242188e+01 4.3800000000000000e+02 -3.7197101593017578e+01 -7.0391296386718750e+01 2.0307501220703125e+02 -2.1902999281883240e-01 6.9769699096679688e+01 1.6842700195312500e+02 3.8101799011230469e+01 7.5127197265625000e+01 4.0508999633789062e+02 1.9607198715209961e+01 -7.8820198059082031e+01 3.8956399536132812e+02 1.9482000350952148e+01 -7.8164199829101562e+01 4.2695401000976562e+02 4.0556900024414062e+01 -8.0134506225585938e+01 4.2694299316406250e+02 2.1298099517822266e+01 -7.5493698120117188e+01 2.3706401062011719e+02 -2.1446100234985352e+01 -8.3815597534179688e+01 2.3241099548339844e+02 -2.7318099975585938e+01 -8.3929298400878906e+01 2.3493299865722656e+02 -2.5151500701904297e+01 -8.0320800781250000e+01 3.7039700317382812e+02 -4.6996501922607422e+01 7.1414703369140625e+01 3.4057800292968750e+02 5.9999599456787109e+01 1.7444400787353516e+01 3.3242401123046875e+02 -4.7271499633789062e+01 4.6557800292968750e+01 3.2822497558593750e+02 -5.0210300445556641e+01 4.1165000915527344e+01 2.3817401123046875e+02 7.7359399795532227e+00 -8.1224205017089844e+01 3.2963400268554688e+02 -5.9987701416015625e+01 1.8482599258422852e+01 3.1305599975585938e+02 -1.8249799728393555e+01 1.0080900192260742e+01 2.2427700805664062e+02 -2.8941400527954102e+01 -8.4644401550292969e+01 2.3003500366210938e+02 -2.7789300918579102e+01 -8.0052803039550781e+01 2.3548400878906250e+02 -2.7285499572753906e+01 -8.5217300415039062e+01 4.7631399536132812e+02 2.1028699874877930e+01 -1.3156900405883789e+01 4.5043899536132812e+02 -4.7057201385498047e+01 -6.4637397766113281e+01 3.5404199218750000e+02 6.3482501983642578e+01 1.6369798660278320e+01 3.6813598632812500e+02 6.5215904235839844e+01 2.5302600860595703e+01 3.8165600585937500e+02 6.8086105346679688e+01 5.5572500228881836e+00 3.1773901367187500e+02 -4.1326797485351562e+01 1.3830400466918945e+01 1.2140999603271484e+02 5.3768798828125000e+01 5.6119503021240234e+01 1.4008200073242188e+02 6.0924400329589844e+01 4.8280300140380859e+01 1.2139099884033203e+02 6.7247200012207031e+01 3.7593101501464844e+01 1.3687400817871094e+02 4.5585800170898438e+01 -6.4200202941894531e+01 1.5900099182128906e+02 -6.3000202178955078e+01 4.5924499511718750e+01 1.7153599548339844e+02 -5.6645900726318359e+01 6.3568504333496094e+01 1.4074200439453125e+02 -6.0995300292968750e+01 4.8195899963378906e+01 2.2845700073242188e+02 2.8236801147460938e+01 -8.0183998107910156e+01 1.5924899291992188e+02 6.0796799659729004e+00 7.7349899291992188e+01 3.7064498901367188e+02 -6.3272296905517578e+01 -3.9899200439453125e+01 3.8990301513671875e+02 -6.3551403045654297e+01 -4.7807296752929688e+01 4.2641699218750000e+02 -2.0340200424194336e+01 7.2655601501464844e+01 2.8024600219726562e+02 3.4880599975585938e+01 -8.5823699951171875e+01 1.2140200042724609e+02 -7.4608001708984375e+01 -1.5916200637817383e+01 1.2139900207519531e+02 -7.6086997985839844e+01 -2.0323601365089417e-01 3.5722900390625000e+02 -2.0051099777221680e+01 6.4125701904296875e+01 3.7715597534179688e+02 6.0001998901367188e+01 5.8282699584960938e+01 2.8508300781250000e+02 4.0666000366210938e+01 1.2633799552917480e+01 4.0627801513671875e+02 -3.0101400375366211e+01 -8.4828399658203125e+01 2.0203599548339844e+02 -6.8860000610351562e+01 -3.4175796508789062e+01 4.6938500976562500e+02 5.3855602264404297e+01 -3.9432601928710938e+01 4.7712698364257812e+02 5.3354400634765625e+01 -2.3150001525878906e+01 3.5226602172851562e+02 6.0000499725341797e+01 3.9655101776123047e+01 3.7605801391601562e+02 6.3361099243164062e+01 4.3322898864746094e+01 4.7354901123046875e+02 4.6998298645019531e+01 -2.4059999465942383e+01 4.5430499267578125e+02 -5.5246299743652344e+01 5.6729396820068359e+01 2.3768901062011719e+02 -1.8429899215698242e+01 -8.0736602783203125e+01 1.5465199279785156e+02 -7.2437705993652344e+01 -8.4779701232910156e+00 2.6725999832153320e+01 9.9988803863525391e+00 1.6717799901962280e+00 3.2548901367187500e+02 3.0100200653076172e+01 -8.4728897094726562e+01 1.6115798950195312e+02 -2.3830600738525391e+01 7.1780899047851562e+01 3.1332202148437500e+02 -4.2011398315429688e+01 9.6432504653930664e+00 3.1184802246093750e+02 -2.3497400283813477e+01 1.1880299568176270e+01 3.8273699951171875e+02 -6.5534301757812500e+01 3.5133201599121094e+01 3.8676397705078125e+02 -6.7754295349121094e+01 1.8944700241088867e+01 3.0022399902343750e+02 5.1093299865722656e+01 6.5889496803283691e+00 1.7460000610351562e+02 -5.2863800048828125e+01 -7.6696205139160156e+01 1.7243899536132812e+02 -7.0401496887207031e+01 -2.2019399642944336e+01 3.1446499633789062e+02 -5.8274398803710938e+01 -7.1471000671386719e+01 4.5787899780273438e+02 2.0334600448608398e+01 5.1297500610351562e+01 4.6189099121093750e+02 4.6999599456787109e+01 4.6506000518798828e+01 3.3753500366210938e+02 6.0036499023437500e+01 2.8993301093578339e-02 3.3608697509765625e+02 -5.2141597747802734e+01 -8.0029602050781250e+01 4.2741098022460938e+02 1.9526800155639648e+01 -7.3969001770019531e+01 4.4612399291992188e+02 2.0561899185180664e+01 -6.5466903686523438e+01 4.4899200439453125e+02 -4.8467300415039062e+01 6.6893898010253906e+01 3.2321301269531250e+02 -5.4660900115966797e+01 2.0205400466918945e+01 2.1493400573730469e+02 1.1095900554209948e-03 -8.0631706237792969e+01 1.7903601074218750e+02 -7.2128000259399414e+00 -7.8161399841308594e+01 3.1746899414062500e+02 -1.9495500564575195e+01 -1.3806000709533691e+01 1.7376600646972656e+02 6.4496101379394531e+01 4.1711597442626953e+01 3.1281301879882812e+02 4.6363597869873047e+01 -8.2290802001953125e+01 3.9618701171875000e+02 6.7704399108886719e+01 2.2618999481201172e+01 4.6973999023437500e+02 5.0240596771240234e+01 -4.3916198730468750e+01 2.1057600402832031e+02 4.7207698822021484e+01 6.9880798339843750e+01 -3.9354900360107422e+01 -2.7552599906921387e+00 -2.7192399501800537e+00 1.9242399597167969e+02 -5.4745300292968750e+01 6.7543899536132812e+01 1.9428700256347656e+02 -4.8353000640869141e+01 7.2414398193359375e+01 4.5624899291992188e+02 6.0000900268554688e+01 -2.6427700042724609e+01 3.5940600585937500e+02 -4.6993598937988281e+01 6.5772697448730469e+01 4.1950500488281250e+02 6.7430503845214844e+01 1.5704600334167480e+01 4.7153298950195312e+02 4.6978801727294922e+01 -3.2296298980712891e+01 4.0298699951171875e+02 -4.9353801727294922e+01 -8.2853195190429688e+01 4.7494097900390625e+02 -1.9511699676513672e+01 -1.5548299789428711e+01 4.6614001464843750e+02 -1.9525001525878906e+01 -3.7789699554443359e+01 3.6092999267578125e+02 -6.5256797790527344e+01 -8.4853792190551758e+00 4.5789001464843750e+02 -4.6999000549316406e+01 5.1349899291992188e+01 3.7430200195312500e+02 9.9293403625488281e+00 -8.3930099487304688e+01 4.7673699951171875e+02 -2.0532699584960938e+01 -1.0493399620056152e+01 2.7144799804687500e+02 4.5715896606445312e+01 -8.4106994628906250e+01 3.5525198364257812e+02 6.4174598693847656e+01 -1.1331299781799316e+01 3.2989401245117188e+02 5.9976600646972656e+01 1.9294900894165039e+01 4.8172000122070312e+02 -4.7110698699951172e+01 4.0064196586608887e+00 3.0803701782226562e+02 4.0838098526000977e+00 1.6993099212646484e+01 4.0518798828125000e+02 6.0006099700927734e+01 6.1959197998046875e+01 4.1278298950195312e+02 6.5869697570800781e+01 3.4340301513671875e+01 4.2548901367187500e+02 6.2698200225830078e+01 4.5882198333740234e+01 4.4351800537109375e+02 6.3348598480224609e+01 2.4119499206542969e+01 3.7674298095703125e+02 1.1935899734497070e+01 -7.8256004333496094e+01 1.5147499084472656e+02 -3.4508499145507812e+01 7.4204498291015625e+01 1.0606600189208984e+02 9.9995899200439453e+00 -7.0439600944519043e+00 2.8841000366210938e+02 5.2489097595214844e+01 -8.0498504638671875e+01 2.3831201171875000e+02 -5.0986400604248047e+01 -8.1918800354003906e+01 4.7575302124023438e+02 4.9695499420166016e+01 -3.3041000366210938e+01 4.7260998535156250e+02 5.0078498840332031e+01 3.9270401000976562e+01 3.6967599487304688e+02 6.3682102203369141e+01 -3.7480201721191406e+01 1.9246099853515625e+02 2.9167699813842773e+01 7.0744598388671875e+01 3.9386199951171875e+02 6.3911697387695312e+01 -4.6495002746582031e+01 3.3437899780273438e+02 -2.8980899810791016e+01 -8.4656799316406250e+01 4.5352700805664062e+02 -6.0000499725341797e+01 -4.9077800750732422e+01 1.8212200927734375e+02 2.9206499099731445e+01 -8.1619003295898438e+01 2.3012001037597656e+02 8.1384494900703430e-02 5.8210601806640625e+01 3.2590600585937500e+02 2.0843601226806641e+01 2.2145999908447266e+01 1.2141499328613281e+02 3.0817899703979492e+01 -7.0121902465820312e+01 4.7567700195312500e+02 -4.6996299743652344e+01 1.6270999908447266e+01 4.7411700439453125e+02 -2.0461500167846680e+01 2.2169599533081055e+01 4.7708099365234375e+02 -2.0624200820922852e+01 7.6081399917602539e+00 1.5374000549316406e+02 -1.9587398529052734e+01 -7.4028999328613281e+01 3.4714697265625000e+02 6.0097797393798828e+01 -3.2233303070068359e+01 2.7199798583984375e+02 6.0908397674560547e+01 -6.1903999328613281e+01 1.5916000366210938e+02 -6.7103202819824219e+01 3.5625000000000000e+01 3.3029602050781250e+02 5.2576999664306641e+01 -7.9605400085449219e+01 1.6083000183105469e+02 2.0524600982666016e+01 7.2027496337890625e+01 1.6486099243164062e+02 2.9716699600219727e+01 7.6240898132324219e+01 1.8545500183105469e+02 3.1283699035644531e+01 7.6079299926757812e+01 1.8600399780273438e+02 -4.1304500579833984e+01 7.4833000183105469e+01 3.6487799072265625e+02 -5.3943500518798828e+01 7.1718299865722656e+01 2.0729899597167969e+02 -5.6372798919677734e+01 6.3907802581787109e+01 4.7248199462890625e+02 4.2861801147460938e+01 -3.2742897033691406e+01 3.4727600097656250e+02 -2.1075099945068359e+01 5.6460399627685547e+01 1.9106399536132812e+02 4.4755100250244141e+01 7.3893600463867188e+01 3.4977099609375000e+02 4.7004901885986328e+01 5.9012699127197266e+01 1.8536799621582031e+02 -6.2319400787353516e+01 -6.8996597290039062e+01 1.8572200012207031e+02 -5.9252700805664062e+01 -7.3872299194335938e+01 4.8194302368164062e+02 4.9584300994873047e+01 1.0631100654602051e+01 3.9419601440429688e+02 6.4472305297851562e+01 4.3811199188232422e+01 1.5135900878906250e+02 -1.0893400192260742e+01 -7.9699302673339844e+01 1.5407901000976562e+02 -2.2339599609375000e+01 -7.7376296997070312e+01 2.4361898803710938e+02 7.7641898393630981e-01 5.2963199615478516e+01 2.6086199951171875e+02 -3.3180999755859375e+01 3.2078899383544922e+01 3.5293899536132812e+02 1.9496500015258789e+01 -7.2189102172851562e+01 4.1677297973632812e+02 -6.7151100158691406e+01 2.1611299514770508e+01 1.5938200378417969e+02 2.0673999786376953e+01 7.6856796264648438e+01 2.1184500122070312e+02 3.0791799545288086e+01 7.1641601562500000e+01 4.7677401733398438e+02 -5.0294898986816406e+01 -2.9972101211547852e+01 3.3792999267578125e+02 -6.0076198577880859e+01 -6.2225198745727539e+00 2.7712197875976562e+02 4.7956298828125000e+01 1.5653100013732910e+01 2.3766299438476562e+02 5.3402698516845703e+01 5.0549201965332031e+01 3.0375799179077148e+01 9.9391202926635742e+00 -1.0591000556945801e+01 3.3997299194335938e+02 -4.8548900604248047e+01 5.6806900024414062e+01 4.1624700927734375e+02 -6.4079299926757812e+01 -4.3270599365234375e+01 1.5411199951171875e+02 -2.7009201049804688e+01 -7.8020500183105469e+01 3.6437402343750000e+02 4.9025402069091797e+01 7.4818000793457031e+01 1.8716200256347656e+02 4.6253498077392578e+01 -8.1463699340820312e+01 2.8436099243164062e+02 3.0368900299072266e-01 1.5762899398803711e+01 2.6777200317382812e+02 -6.0659500122070312e+01 -2.6114900588989258e+01 4.6991299438476562e+02 5.9998901367187500e+01 -1.9130100250244141e+01 1.4642800903320312e+02 7.1499694824218750e+01 -2.3242799758911133e+01 4.7739700317382812e+02 -4.6997699737548828e+01 3.3630700111389160e+00 2.4102101135253906e+02 -2.1528799057006836e+01 5.4675800323486328e+01 2.3194700622558594e+02 -2.1836099624633789e+01 6.2076900482177734e+01 4.8216302490234375e+02 -4.9043598175048828e+01 1.0561300277709961e+01 2.0079399108886719e+02 3.9153499603271484e+01 7.3614997863769531e+01 4.1032598876953125e+02 2.0676000595092773e+01 -7.9506500244140625e+01 1.6784199523925781e+02 -2.8001399993896484e+01 7.1406204223632812e+01 -5.2198200225830078e+01 9.3285408020019531e+00 -9.6113891601562500e+00 4.5998901367187500e+02 -2.1096799850463867e+01 4.8851299285888672e+01 2.2198100280761719e+02 3.0446498870849609e+01 -8.4691101074218750e+01 1.5130500793457031e+02 1.0406499862670898e+01 -7.9566703796386719e+01 1.5327499389648438e+02 2.3042499542236328e+01 -7.8294204711914062e+01 3.5034899902343750e+02 -5.4572700500488281e+01 6.1386997222900391e+01 4.5364001464843750e+02 4.9013599395751953e+01 -6.3041599273681641e+01 3.3279699707031250e+02 -4.2505397796630859e+01 -8.3159400939941406e+01 2.3909799194335938e+02 -1.1195799827575684e+01 -8.6013198852539062e+01 -5.2211696624755859e+01 -5.7841696739196777e+00 -2.1085800170898438e+01 -5.2150802612304688e+01 -9.4350700378417969e+00 -1.6849100112915039e+01 2.2823899841308594e+02 2.8106899261474609e+01 6.4293800354003906e+01 4.3345300292968750e+02 -2.0558399200439453e+01 -7.2749801635742188e+01 4.3682797241210938e+02 2.0550899505615234e+01 -7.1027198791503906e+01 4.2785501098632812e+02 6.0000999450683594e+01 5.5945697784423828e+01 4.6189801025390625e+02 -6.0000000000000000e+01 -6.1515498161315918e+00 3.1639797973632812e+02 -4.6750301361083984e+01 1.0335700035095215e+01 -3.6740798950195312e+01 -1.0678500175476074e+01 -1.6623201370239258e+01 2.0746199035644531e+02 -5.9102500915527344e+01 -7.6797302246093750e+01 1.9206100463867188e+02 -5.8412998199462891e+01 6.1629798889160156e+01 4.6382800292968750e+02 -2.0742399215698242e+01 -4.3754299163818359e+01 1.6854199218750000e+02 -5.2668800354003906e+01 6.7774398803710938e+01 1.2142700195312500e+02 -4.5622501373291016e+01 6.2988697052001953e+01 4.8035101318359375e+02 5.3385299682617188e+01 -2.6758899688720703e+00 3.7970199584960938e+02 -3.7449501037597656e+01 -8.4848594665527344e+01 4.5082000732421875e+02 -1.9499898910522461e+01 -5.6452598571777344e+01 3.4095300292968750e+02 -4.6998401641845703e+01 4.9828899383544922e+01 1.7288899230957031e+02 -2.8761299133300781e+01 -7.9521301269531250e+01 1.5466299438476562e+02 -4.4225902557373047e+01 7.0831298828125000e+01 3.5824298095703125e+02 -5.9998600006103516e+01 5.9292999267578125e+01 3.7871398925781250e+02 -5.9998199462890625e+01 6.9279098510742188e+01 2.2982600402832031e+02 -1.6795700073242188e+01 6.0896797180175781e+01 3.3195001220703125e+02 -5.4020198822021484e+01 4.1310600280761719e+01 3.4126699829101562e+02 -5.4441699981689453e+01 5.2895797729492188e+01 3.4962698364257812e+02 -4.6997200012207031e+01 5.8637001037597656e+01 1.7262800598144531e+02 -4.4369602203369141e+01 7.3444801330566406e+01 -5.2204502105712891e+01 6.9395403861999512e+00 -5.5010600090026855e+00 4.7680899047851562e+02 -4.6995800018310547e+01 -9.6744699478149414e+00 4.7443899536132812e+02 -1.9502500534057617e+01 1.3590799331665039e+01 2.7759100341796875e+02 2.6923999786376953e+01 1.8183401107788086e+01 -4.0981300354003906e+01 -8.7790393829345703e+00 -1.8236799240112305e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 4800 -> 87 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01) (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01) (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01) (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01) (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01) (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01) (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_upper_arm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_upper_arm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 156 0 157 306 1 0 306 0 430 430 0 156 0 2 157 1 319 2 319 361 2 157 2 361 1 6 319 319 193 361 193 319 6 157 361 437 361 193 437 223 157 437 223 437 193 223 158 157 223 15 17 15 223 193 158 223 17 156 157 158 156 158 327 158 469 327 158 17 469 430 156 327 306 430 291 291 430 56 56 430 500 500 430 327 306 291 292 372 1 306 372 306 292 292 371 372 371 498 372 498 6 372 6 1 372 371 292 492 371 492 498 7 6 498 498 492 7 6 7 8 193 6 8 8 7 283 492 283 7 492 292 258 492 258 283 282 283 258 253 283 282 283 253 8 282 143 142 282 258 143 253 282 142 141 142 143 258 259 143 141 143 259 141 277 142 142 155 253 277 155 142 277 141 120 277 120 155 120 154 155 398 253 155 398 155 244 244 155 154 26 119 120 120 119 243 141 26 120 120 243 154 243 244 154 243 140 244 138 140 243 138 243 119 110 138 119 26 110 119 138 139 140 323 138 110 323 324 138 324 139 138 110 26 111 111 323 110 323 111 324 324 25 139 25 324 111 25 24 139 55 140 139 55 139 24 24 25 26 26 25 111 24 269 55 269 24 26 313 269 26 313 26 141 269 149 55 313 149 269 141 312 313 285 149 313 285 313 263 313 312 263 312 141 259 391 312 65 65 312 66 312 259 66 263 312 391 259 258 66 65 66 67 293 443 66 258 293 66 66 443 67 391 65 67 408 392 67 392 391 67 408 67 443 293 305 443 305 408 443 258 292 293 292 305 293 291 305 292 305 291 408 408 291 409 264 408 409 264 392 408 264 391 392 246 263 264 192 264 409 57 246 264 264 263 391 57 264 192 409 401 192 291 401 409 57 192 58 192 401 58 56 57 58 245 246 57 245 57 56 291 56 58 401 291 58 245 56 500 245 500 412 326 245 412 245 326 246 500 327 412 327 411 412 411 326 412 326 327 328 328 327 469 326 411 327 124 326 328 421 124 328 474 328 469 421 328 474 474 469 475 469 17 475 474 422 421 422 474 475 422 475 17 15 16 17 17 16 422 16 421 422 432 16 15 421 16 484 16 432 484 112 113 15 193 112 15 113 432 15 112 193 194 194 270 112 203 113 112 270 203 112 266 193 94 193 8 94 266 194 193 204 194 266 204 270 194 203 270 204 202 203 204 202 38 203 203 38 113 265 204 266 204 265 340 202 204 340 94 341 266 265 266 341 340 265 341 339 294 340 294 202 340 341 339 340 294 11 202 11 38 202 11 10 38 38 10 113 9 10 11 11 294 46 11 46 9 234 294 295 46 294 234 295 294 339 45 9 46 234 45 46 10 9 209 45 209 9 10 209 173 10 173 113 113 415 432 113 173 415 172 173 174 173 314 174 415 173 172 173 209 314 414 415 172 432 415 433 433 415 414 172 174 311 414 172 311 314 311 174 314 404 368 209 404 314 314 368 311 404 369 368 404 354 369 209 354 404 368 369 370 368 370 311 370 369 479 354 446 369 446 479 369 209 45 354 45 446 354 236 398 446 446 45 236 446 464 479 446 398 464 479 44 370 464 463 479 479 463 44 462 463 464 462 464 398 244 487 398 398 487 462 236 253 398 463 462 27 462 487 27 463 27 44 27 28 29 29 44 27 487 28 27 244 28 487 244 257 28 244 140 257 28 257 29 257 189 29 191 44 29 189 191 29 140 189 257 140 55 190 140 190 189 189 190 191 190 54 191 191 212 272 272 44 191 191 54 212 55 54 190 53 54 55 211 55 149 53 55 211 54 53 212 53 211 212 212 211 272 271 68 272 211 271 272 44 272 68 211 149 271 271 461 68 149 461 271 68 69 44 396 69 68 396 68 461 149 396 461 149 395 396 396 395 69 69 440 44 395 440 69 395 439 440 149 151 395 151 208 395 395 208 439 439 74 440 74 44 440 439 72 74 72 439 208 207 208 151 400 208 207 72 208 400 149 150 151 151 150 207 42 207 150 207 42 400 400 42 73 73 72 400 72 73 74 73 42 75 74 73 75 42 43 44 70 42 71 42 44 71 150 43 42 149 285 150 150 285 43 285 198 43 43 198 501 501 44 43 44 74 71 44 501 370 74 70 71 370 197 419 495 370 419 495 311 370 501 197 370 198 197 501 196 197 198 285 196 198 196 285 263 196 303 419 196 419 197 263 303 196 303 495 419 468 311 495 343 468 495 343 495 303 263 246 303 246 343 303 61 466 343 466 468 343 246 61 343 466 467 468 311 468 467 466 63 467 466 61 63 61 62 63 326 61 246 61 326 62 63 217 467 63 483 217 62 483 63 467 217 311 216 137 217 311 217 137 483 216 217 62 444 483 444 216 483 326 124 62 62 124 444 124 84 444 84 382 444 216 444 382 216 382 137 137 382 386 84 476 382 382 476 386 137 386 135 386 427 135 476 427 386 84 83 476 476 83 427 135 427 108 427 83 108 82 83 84 107 108 83 82 107 83 135 108 480 224 480 108 107 224 108 224 107 82 82 145 144 145 82 84 82 144 224 224 144 225 224 225 480 144 145 146 144 146 225 146 145 302 84 302 145 84 124 97 97 302 84 95 124 351 456 330 124 97 124 95 456 124 421 330 351 124 95 96 97 351 96 95 351 332 147 96 351 147 330 332 351 330 331 332 484 331 330 484 330 456 456 421 484 432 331 484 331 432 389 374 331 389 332 331 374 488 432 433 389 432 488 374 389 390 389 488 390 352 332 374 352 374 390 352 390 353 390 310 137 488 310 390 353 390 137 433 310 488 433 414 310 310 311 137 310 414 311 135 136 137 136 353 137 276 352 353 276 353 136 276 332 352 136 275 276 332 276 275 135 431 136 380 275 136 431 380 136 147 275 380 147 332 275 380 431 148 147 380 148 497 431 135 148 431 497 18 147 148 278 148 497 18 148 278 383 96 147 18 20 147 147 20 383 18 19 20 19 18 278 278 497 460 19 278 460 460 497 135 459 460 135 493 19 460 493 460 459 20 19 455 455 19 493 459 188 493 455 493 188 459 480 423 423 188 459 480 459 135 186 187 188 186 188 423 187 455 188 187 20 455 3 377 187 248 20 187 376 248 187 187 186 465 337 187 465 3 187 337 376 187 377 186 423 465 338 465 423 465 338 337 336 337 338 336 397 337 3 337 397 410 336 338 338 423 410 410 436 336 304 336 436 397 336 304 3 397 304 4 3 304 4 304 435 435 304 436 434 435 436 210 434 436 436 410 210 434 4 435 98 4 434 434 210 98 98 99 100 100 4 98 289 98 210 99 98 289 78 100 99 167 78 99 167 99 289 77 100 78 77 118 100 118 4 100 76 77 78 166 78 167 261 78 166 261 76 78 166 167 175 175 167 289 289 210 175 116 210 205 115 210 116 210 410 205 210 115 175 114 115 116 205 206 116 206 114 116 346 347 205 347 206 205 346 205 410 410 480 225 346 410 225 423 480 410 346 318 347 225 146 346 146 318 346 317 206 347 318 317 347 316 317 318 146 316 318 316 146 302 316 302 301 316 301 317 317 489 206 489 317 301 489 91 93 489 114 206 301 91 489 489 93 114 91 92 93 91 485 92 91 301 485 93 447 115 92 290 93 114 93 115 447 93 290 115 447 175 447 290 175 290 231 175 231 290 92 166 175 176 175 231 375 176 175 375 261 166 176 201 200 176 200 261 176 201 176 375 300 199 375 199 201 375 300 375 231 199 200 201 281 199 300 280 200 199 199 281 280 299 279 300 233 300 231 279 281 300 299 300 233 279 280 281 59 280 279 200 280 490 59 490 280 299 59 279 273 299 233 273 424 299 59 299 424 231 232 233 232 273 233 60 273 274 273 232 274 273 60 424 60 59 424 14 59 60 59 14 490 12 13 14 457 14 13 457 490 14 12 14 60 366 219 12 12 60 366 219 13 12 13 219 218 182 13 218 182 457 13 218 219 220 220 219 366 182 218 213 218 220 287 218 287 450 218 450 213 181 182 183 183 182 213 457 182 181 450 296 213 428 183 213 213 296 428 287 296 450 286 287 288 286 296 287 287 220 288 428 296 286 105 428 286 183 428 105 181 183 134 134 183 105 104 105 106 417 106 105 105 286 325 104 134 105 105 325 417 286 288 325 288 358 378 348 288 220 288 348 358 378 130 288 130 325 288 130 378 131 131 378 358 226 358 348 226 228 358 131 358 228 130 131 132 36 131 228 35 131 36 131 35 132 214 130 132 130 214 325 359 214 132 359 325 214 359 360 325 240 325 360 417 325 240 359 132 472 284 359 472 359 284 360 360 284 240 240 241 242 251 241 240 417 240 242 284 251 240 90 417 418 417 90 106 242 418 417 242 241 445 445 418 242 251 350 241 350 445 241 445 385 418 445 350 251 251 403 445 445 403 385 251 284 179 403 251 179 21 403 179 385 403 452 403 21 452 179 180 21 179 284 315 179 315 399 399 180 179 364 159 180 180 159 22 180 399 364 21 180 22 35 482 399 486 399 482 364 399 486 315 35 399 284 132 315 35 315 132 284 472 132 35 36 37 482 35 37 37 481 482 486 482 481 486 499 364 499 486 481 481 37 121 121 499 481 237 37 36 237 121 37 227 36 228 36 227 237 226 227 228 170 227 226 237 227 170 226 348 126 226 126 170 170 126 171 170 171 473 473 237 170 125 126 127 171 126 125 126 348 127 220 366 348 127 348 366 127 366 367 367 366 60 127 367 458 478 367 363 458 367 478 367 60 363 60 274 363 274 362 363 478 363 362 478 362 388 478 388 458 458 388 387 127 458 387 387 388 335 388 362 426 335 388 426 362 232 231 362 231 426 274 232 362 231 425 426 92 425 231 425 451 426 122 425 92 122 451 425 485 122 92 121 122 123 122 121 442 122 485 301 122 442 451 122 301 123 442 121 321 121 237 321 121 123 499 442 321 405 442 405 451 229 320 321 405 321 406 321 237 229 321 320 406 405 406 407 405 407 454 451 405 454 406 262 163 407 406 163 406 320 262 407 163 178 454 407 178 454 426 451 454 178 426 163 177 178 334 335 178 349 178 177 178 335 426 178 349 334 101 177 345 345 177 163 349 177 101 333 334 349 344 349 101 344 333 349 101 102 103 344 101 103 102 101 345 496 333 344 41 344 103 381 496 344 381 344 41 384 41 103 103 102 345 103 345 384 384 345 165 429 384 165 429 41 384 163 164 165 402 165 164 165 345 163 402 429 165 39 41 429 429 402 342 429 342 39 255 402 256 342 402 255 402 164 256 256 164 438 163 438 164 254 255 256 438 470 256 254 256 470 342 255 229 51 229 255 255 254 51 50 51 52 229 51 230 50 230 51 52 51 254 50 52 64 168 50 169 169 50 64 50 168 230 64 52 169 52 441 169 52 254 441 168 169 416 441 491 169 416 169 491 355 168 416 230 168 355 229 230 184 355 184 230 184 355 356 356 355 416 297 416 471 471 416 491 356 416 297 441 254 491 491 254 471 254 470 471 470 297 471 470 438 297 438 163 297 297 163 298 80 356 297 80 297 298 184 356 80 79 80 81 80 79 184 80 448 81 80 298 448 87 298 163 87 448 298 262 87 163 87 86 85 86 87 262 85 449 87 449 448 87 48 448 449 81 448 48 79 81 365 365 81 48 47 48 49 222 48 47 222 365 48 79 365 229 221 365 222 229 365 320 320 365 221 221 222 47 320 221 329 221 195 329 195 221 47 320 329 86 320 86 262 195 86 329 86 195 47 86 47 85 47 49 85 79 229 184 342 229 237 342 237 309 39 342 309 237 238 239 309 237 239 238 237 473 239 238 381 238 473 496 238 496 381 307 309 239 307 239 381 494 307 381 494 381 41 307 308 309 308 307 322 307 494 322 494 41 40 494 40 322 39 40 41 309 322 40 309 40 39 308 322 309 333 496 171 473 171 496 171 125 333 333 125 334 125 127 379 125 379 334 334 379 335 387 379 127 379 387 335 364 499 393 499 123 393 364 393 394 364 394 159 393 123 394 394 123 23 123 301 23 394 23 159 159 23 22 21 22 23 109 21 23 301 109 23 301 302 152 301 152 109 152 453 109 453 21 109 452 21 453 452 453 153 153 453 152 385 452 153 152 30 153 385 153 32 153 30 32 477 385 373 385 477 418 373 385 32 30 31 32 31 373 32 30 247 31 268 247 30 152 268 30 31 260 373 31 247 260 373 260 90 477 373 90 418 477 90 88 89 90 90 261 200 260 261 90 89 106 90 200 88 90 260 76 261 247 76 260 268 77 76 268 76 247 267 118 77 268 267 77 152 267 268 267 117 118 152 117 267 117 5 118 5 4 118 5 117 413 162 117 152 117 162 413 162 152 302 160 161 162 162 377 413 162 161 377 160 162 302 413 3 5 377 3 413 3 4 5 161 376 377 357 376 161 357 161 160 160 302 357 185 302 97 302 185 357 357 248 376 357 128 248 185 128 357 97 129 185 128 185 129 383 97 96 129 97 383 128 129 20 129 383 20 128 20 248 420 89 88 490 457 88 420 88 457 490 88 200 420 181 133 133 89 420 457 181 420 215 106 89 133 215 89 133 134 104 133 104 215 181 134 133 215 104 106 252 253 236 252 34 253 34 8 253 234 235 236 45 234 236 235 252 236 235 234 295 235 295 249 252 235 249 249 295 250 295 339 250 249 250 33 252 249 33 33 250 94 339 94 250 339 341 94 8 33 94 33 8 34 33 34 252))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.3837001037597656e+02 2.8102998733520508e+01 -5.3000000000000000e+01 1.4036999511718750e+02 2.7274599075317383e+01 -5.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 -5.5828399658203125e+01 1.1886999511718750e+02 6.0911300659179688e+01 2.3493299484252930e+01 1.1886599731445312e+02 5.5482101440429688e+01 3.3601200103759766e+01 1.1886999511718750e+02 6.4159896850585938e+01 3.3188999176025391e+01 1.4036999511718750e+02 -2.5872699737548828e+01 -6.5000000000000000e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -6.4158203125000000e+01 1.3837001037597656e+02 -2.6258998870849609e+01 -6.7000000000000000e+01 1.1886999511718750e+02 -3.8841802626848221e-02 -7.2086601257324219e+01 1.1886999511718750e+02 9.7871809005737305e+00 -7.1372596740722656e+01 1.2137000274658203e+02 3.0495100021362305e+00 -7.1979003906250000e+01 1.1886999511718750e+02 -7.5180497169494629e+00 7.1620002746582031e+01 1.2137000274658203e+02 -1.5263999700546265e+00 7.2027099609375000e+01 1.1886999511718750e+02 1.7722400426864624e+00 7.2045806884765625e+01 1.1886999511718750e+02 2.9271900177001953e+01 -6.5830902099609375e+01 1.1886999511718750e+02 3.2772102355957031e+01 -6.4178802490234375e+01 1.2225399780273438e+02 3.0408300399780273e+01 -6.5315002441406250e+01 1.1886899566650391e+02 6.2879100799560547e+01 -1.7059499740600586e+01 1.1886999511718750e+02 6.4711402893066406e+01 -7.0697798728942871e+00 1.1886999511718750e+02 7.1740097045898438e+01 -8.0421199798583984e+00 1.2334299468994141e+02 2.0932399749755859e+01 5.2999897003173828e+01 1.2235099792480469e+02 1.1860799789428711e+01 5.2780300140380859e+01 1.2156599426269531e+02 1.2450900077819824e+01 5.1984100341796875e+01 1.2137000274658203e+02 -5.4027698516845703e+01 -4.0807399749755859e+01 1.2137000274658203e+02 -5.6317501068115234e+01 -4.3395599365234375e+01 1.2137000274658203e+02 -4.6876697540283203e+01 -4.7991001129150391e+01 1.1737000274658203e+02 -3.4353099822998047e+01 -5.3386100769042969e+01 1.1847600555419922e+02 -3.5485801696777344e+01 -5.3080101013183594e+01 1.1737200164794922e+02 -3.9874198913574219e+01 -4.9363899230957031e+01 1.2137000274658203e+02 3.2102996826171875e+01 5.4171600341796875e+01 1.2137000274658203e+02 3.2102996826171875e+01 6.4500503540039062e+01 1.2175499725341797e+02 3.0767000198364258e+01 5.8083000183105469e+01 1.2330100250244141e+02 -1.5703101158142090e+01 -6.6997795104980469e+01 1.2337000274658203e+02 -2.6254899978637695e+01 -6.7000000000000000e+01 1.2337000274658203e+02 -2.7886999130249023e+01 5.3000000000000000e+01 1.2175899505615234e+02 -3.0437400817871094e+01 5.4857498168945312e+01 1.2175499725341797e+02 -2.8295799255371094e+01 5.2285400390625000e+01 1.2137000274658203e+02 1.5079000473022461e+01 -7.0493698120117188e+01 1.1886999511718750e+02 -6.0362800598144531e+01 2.3838798522949219e+01 1.1886999511718750e+02 -6.5623100280761719e+01 2.7320598602294922e+01 1.1886999511718750e+02 -5.8172500610351562e+01 2.8881599426269531e+01 1.1761999511718750e+02 -2.7101200103759766e+01 -1.7819499969482422e+01 1.1763499450683594e+02 -2.1460599899291992e+01 -2.4439599990844727e+01 1.1737000274658203e+02 -2.4275100708007812e+01 -2.2130399703979492e+01 1.1886999511718750e+02 -1.1811599731445312e+01 -7.1095497131347656e+01 1.2137000274658203e+02 -7.5685801506042480e+00 -7.1636199951171875e+01 1.1761999511718750e+02 -3.0257101058959961e+01 1.3208700180053711e+01 1.1761999511718750e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.1737000274658203e+02 -3.0257101058959961e+01 1.3458700180053711e+01 1.2137000274658203e+02 -3.8890602111816406e+01 1.2624699592590332e+01 1.2137000274658203e+02 -4.2355197906494141e+01 1.1919799804687500e+01 1.2137000274658203e+02 -4.0975399017333984e+01 1.1504599571228027e+01 1.1761999511718750e+02 -5.1134197235107422e+01 -3.7537002563476562e+01 1.1818900299072266e+02 -4.9283901214599609e+01 -4.0244300842285156e+01 1.1886999511718750e+02 -5.2137298583984375e+01 -3.8670799255371094e+01 1.2222299957275391e+02 1.0924599647521973e+01 -5.2719699859619141e+01 1.2137000274658203e+02 4.8255200386047363e+00 -5.1033500671386719e+01 1.2224900054931641e+02 5.6168699264526367e+00 -5.2746398925781250e+01 1.1886599731445312e+02 2.0431599617004395e+00 6.4957099914550781e+01 1.1886599731445312e+02 -7.1629400253295898e+00 6.4649597167968750e+01 1.2137000274658203e+02 8.2198905944824219e+00 -3.1664598464965820e+01 1.2137000274658203e+02 1.6157999038696289e+01 -2.8363399505615234e+01 1.1761599731445312e+02 1.4625800132751465e+01 -2.9182701110839844e+01 1.2136799621582031e+02 -4.0019298553466797e+01 1.1677000045776367e+01 1.2155699920654297e+02 -2.4789800643920898e+01 -5.1964996337890625e+01 1.2205799865722656e+02 -2.8022800445556641e+01 -5.2669300079345703e+01 1.2157999420166016e+02 -1.8630100250244141e+01 -5.2017902374267578e+01 1.1737000274658203e+02 -4.0101600646972656e+01 -2.5444200515747070e+01 1.1737000274658203e+02 -3.7895401000976562e+01 -2.3592500686645508e+01 1.1737000274658203e+02 -2.7581300735473633e+01 -1.7707799911499023e+01 1.1737000274658203e+02 -2.7310300827026367e+01 -1.7956501007080078e+01 1.1761999511718750e+02 -2.8460399627685547e+01 -1.7514900207519531e+01 1.1761999511718750e+02 -2.7937698364257812e+01 -1.7367401123046875e+01 1.1737000274658203e+02 -2.8329801559448242e+01 -1.7728000640869141e+01 1.1737000274658203e+02 -2.7937698364257812e+01 -1.7617401123046875e+01 1.1886999511718750e+02 3.8424701690673828e+01 6.1056697845458984e+01 1.1886999511718750e+02 4.7440799713134766e+01 5.4317199707031250e+01 1.1886700439453125e+02 3.7178501129150391e+01 5.3142101287841797e+01 1.1761999511718750e+02 -3.5414699554443359e+01 1.5034999847412109e+01 1.1737000274658203e+02 -3.5414699554443359e+01 1.5284999847412109e+01 1.1761999511718750e+02 -3.4026500701904297e+01 1.4747900009155273e+01 1.2137000274658203e+02 3.1945198059082031e+01 -7.2414598464965820e+00 1.1763399505615234e+02 3.1368400573730469e+01 -9.2509603500366211e+00 1.2137000274658203e+02 2.8730501174926758e+01 -1.5605100631713867e+01 1.1737000274658203e+02 -2.9854598999023438e+01 1.3576099395751953e+01 1.1761999511718750e+02 -2.9351299285888672e+01 1.3784900665283203e+01 1.1737000274658203e+02 -2.9577798843383789e+01 1.3890800476074219e+01 1.1886999511718750e+02 1.9947898864746094e+01 6.9319000244140625e+01 1.2275599670410156e+02 2.6223499298095703e+01 6.7096702575683594e+01 1.1886999511718750e+02 2.8016601562500000e+01 6.6379196166992188e+01 1.2137000274658203e+02 1.4018799781799316e+01 2.9597200393676758e+01 1.1764299774169922e+02 5.6489901542663574e+00 3.2238201141357422e+01 1.1759600067138672e+02 1.6880899429321289e+01 2.8038600921630859e+01 1.2317100524902344e+02 -6.0609102249145508e-01 -6.7000297546386719e+01 1.2137000274658203e+02 6.1707298278808594e+01 -3.7386100769042969e+01 1.1886999511718750e+02 6.5867202758789062e+01 -2.9558200836181641e+01 1.2137000274658203e+02 6.7189094543457031e+01 -2.6405298233032227e+01 1.1845099639892578e+02 4.8900100708007812e+01 4.1262802124023438e+01 1.1849299621582031e+02 4.3287399291992188e+01 4.7150798797607422e+01 1.1886599731445312e+02 4.7488800048828125e+01 4.4185199737548828e+01 1.1855900573730469e+02 -4.9810398101806641e+01 4.0064201354980469e+01 1.1814800262451172e+02 -5.1147800445556641e+01 3.7811901092529297e+01 1.1867500305175781e+02 -5.3971000671386719e+01 3.4668098449707031e+01 1.2241799926757812e+02 1.3628199577331543e+01 6.7201698303222656e+01 1.2286000061035156e+02 4.4063701629638672e+00 6.7005096435546875e+01 1.2337000274658203e+02 2.6470899581909180e+01 6.7000000000000000e+01 1.1761999511718750e+02 3.2391300201416016e+01 -3.9578700065612793e+00 1.1737000274658203e+02 3.2497699737548828e+01 -5.1400599479675293e+00 1.2161599731445312e+02 2.2089900970458984e+01 5.2101200103759766e+01 1.2137000274658203e+02 -5.4713001251220703e+01 -4.6703899383544922e+01 1.2137000274658203e+02 -5.6568500518798828e+01 -4.4058200836181641e+01 1.2337000274658203e+02 2.6470899581909180e+01 -6.7000000000000000e+01 1.1886999511718750e+02 2.1601699829101562e+01 -6.8827796936035156e+01 1.1760900115966797e+02 2.2688598632812500e+01 2.3479598999023438e+01 1.1737000274658203e+02 1.9260601043701172e+01 2.6627300262451172e+01 1.1737000274658203e+02 2.5179500579833984e+01 2.1338300704956055e+01 1.2137000274658203e+02 6.4264198303222656e+01 3.2988399505615234e+01 1.1886999511718750e+02 5.6136501312255859e+01 4.5345397949218750e+01 1.2137000274658203e+02 -4.8838600158691406e+01 -5.2884002685546875e+01 1.2137000274658203e+02 -3.8841197967529297e+01 -6.0686500549316406e+01 1.2137000274658203e+02 -1.8172599792480469e+01 5.0735500335693359e+01 1.2137000274658203e+02 -3.7241301536560059e+00 3.2484401702880859e+01 1.2137400054931641e+02 -6.7035800218582153e-01 5.1426300048828125e+01 1.2137000274658203e+02 5.5127597808837891e+01 -4.6537998199462891e+01 1.1886700439453125e+02 -3.5631198883056641e+01 5.3900901794433594e+01 1.1886999511718750e+02 -3.8045997619628906e+01 6.1132801055908203e+01 1.1884999847412109e+02 -2.8608699798583984e+01 5.7999202728271484e+01 1.2137000274658203e+02 7.2016403198242188e+01 -4.6319098472595215e+00 1.2137000274658203e+02 7.0636802673339844e+01 -1.4785599708557129e+01 1.2915499877929688e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.2337000274658203e+02 -2.9887001037597656e+01 5.5000000000000000e+01 1.3837001037597656e+02 -2.9887001037597656e+01 5.5000000000000000e+01 1.2165000152587891e+02 1.9512100219726562e+01 6.7920204162597656e+01 1.2159000396728516e+02 1.0458299636840820e+01 6.7999496459960938e+01 1.1737000274658203e+02 6.0491100311279297e+01 -2.0045900344848633e+01 1.1738099670410156e+02 5.4535400390625000e+01 -3.2764598846435547e+01 1.1737000274658203e+02 2.4598600387573242e+01 -2.1879899978637695e+01 1.1886999511718750e+02 -5.6352699279785156e+01 -4.4678798675537109e+01 1.1886999511718750e+02 -5.6317501068115234e+01 -4.3395599365234375e+01 1.1886999511718750e+02 -4.4921699523925781e+01 -4.7023899078369141e+01 1.2137000274658203e+02 -3.1886999130249023e+01 -5.4171600341796875e+01 1.2171799468994141e+02 -3.0610200881958008e+01 -6.5120101928710938e+01 1.2219099426269531e+02 -3.0203300476074219e+01 -5.9604999542236328e+01 1.2137000274658203e+02 3.2632999420166016e+01 -1.4210900454981155e-14 1.2137000274658203e+02 3.4800498962402344e+01 -5.4644002914428711e+00 1.2137000274658203e+02 3.2294197082519531e+01 4.8958797454833984e+00 1.1886999511718750e+02 5.7366401672363281e+01 -3.1222900390625000e+01 1.1868800354003906e+02 6.0740200042724609e+01 -2.1166299819946289e+01 1.2137000274658203e+02 -4.0288799285888672e+01 -2.5278499603271484e+01 1.2137000274658203e+02 -2.3569700241088867e+01 -2.2407899856567383e+01 1.2137000274658203e+02 -3.8026000976562500e+01 -2.3379400253295898e+01 1.2137000274658203e+02 2.8931400299072266e+01 5.1000000000000000e+01 1.2189800262451172e+02 3.0577301025390625e+01 5.4872501373291016e+01 1.1886999511718750e+02 -3.9752700805664062e+01 -5.9999702453613281e+01 1.1886999511718750e+02 -3.3598697662353516e+01 -6.3636398315429688e+01 1.2337000274658203e+02 2.8102998733520508e+01 -5.3000000000000000e+01 1.3837001037597656e+02 3.0103000640869141e+01 -5.5000000000000000e+01 1.2337000274658203e+02 3.0103000640869141e+01 -5.5000000000000000e+01 1.2232700347900391e+02 6.0257802009582520e+00 5.2771499633789062e+01 1.2137000274658203e+02 6.7176605224609375e+01 8.7329998016357422e+00 1.2137000274658203e+02 7.1865295410156250e+01 6.4717001914978027e+00 1.2137000274658203e+02 6.9949203491210938e+01 1.8015501022338867e+01 1.1737000274658203e+02 -2.4616600036621094e+01 2.1620100021362305e+01 1.1737000274658203e+02 -5.4012897491455078e+01 1.9935699462890625e+01 1.1737000274658203e+02 -5.8990299224853516e+01 2.3230199813842773e+01 1.1854199981689453e+02 2.8987800598144531e+01 5.7150798797607422e+01 1.1841400146484375e+02 3.6011798858642578e+01 5.2829399108886719e+01 1.1761999511718750e+02 -3.8890602111816406e+01 1.2624699592590332e+01 1.1760600280761719e+02 -3.9935100555419922e+01 1.1683500289916992e+01 1.2137000274658203e+02 -4.2364700317382812e+01 5.8364498138427734e+01 1.1886999511718750e+02 -4.7349201202392578e+01 5.4317897796630859e+01 1.1849199676513672e+02 1.9945800781250000e+01 -6.0786899566650391e+01 1.1886999511718750e+02 1.3379899978637695e+01 -6.3592998504638672e+01 1.1843399810791016e+02 1.4714799880981445e+01 -6.2136501312255859e+01 1.1737000274658203e+02 2.8809198379516602e+01 5.6720001220703125e+01 1.1848600006103516e+02 2.3653398513793945e+01 5.9397701263427734e+01 1.1737000274658203e+02 -4.5455501556396484e+01 4.4291801452636719e+01 1.1737000274658203e+02 -3.9683101654052734e+01 4.9556999206542969e+01 1.3837001037597656e+02 2.7618200778961182e+00 5.3000000000000000e+01 1.2330699920654297e+02 5.9888100624084473e+00 5.2999797821044922e+01 1.2137300109863281e+02 1.2602199554443359e+01 6.8827499389648438e+01 1.2137100219726562e+02 1.5094200372695923e+00 6.9024803161621094e+01 1.2158600616455078e+02 3.4607899188995361e+00 6.7970703125000000e+01 1.1761999511718750e+02 -3.7071300506591797e+01 1.4618099212646484e+01 1.2137000274658203e+02 6.6644500732421875e+01 -9.7219600677490234e+00 1.1863300323486328e+02 6.4118804931640625e+01 4.4358601570129395e+00 1.1886999511718750e+02 6.4816398620605469e+01 8.3940601348876953e+00 1.1848400115966797e+02 6.4006004333496094e+01 8.6720287799835205e-02 1.1844400024414062e+02 -4.2903800964355469e+01 -4.7232700347900391e+01 1.1855000305175781e+02 -4.6752799987792969e+01 -4.3500598907470703e+01 1.1737000274658203e+02 -4.6861598968505859e+01 -4.2791900634765625e+01 1.2154599761962891e+02 2.4122200906276703e-01 -5.1890102386474609e+01 1.3837001037597656e+02 2.6475099563598633e+01 -6.7000000000000000e+01 1.2312799835205078e+02 2.0708600997924805e+01 -6.7007202148437500e+01 1.2137000274658203e+02 -2.9902299880981445e+01 1.3273699760437012e+01 1.1764099884033203e+02 -9.2966394424438477e+00 -3.1213098526000977e+01 1.1737000274658203e+02 -1.4536700248718262e+01 -2.9371000289916992e+01 1.1762899780273438e+02 -1.5938500404357910e+01 -2.8328201293945312e+01 1.1854899597167969e+02 1.6234100341796875e+01 6.1868701934814453e+01 1.1886999511718750e+02 2.1466100692749023e+01 6.1433597564697266e+01 1.1850800323486328e+02 2.0161399841308594e+01 6.0728401184082031e+01 1.2137300109863281e+02 1.0267900466918945e+01 -6.8858604431152344e+01 1.2137000274658203e+02 2.0674999237060547e+01 -6.9000000000000000e+01 1.2189800262451172e+02 1.5803700447082520e+01 -6.7499198913574219e+01 1.1737000274658203e+02 2.9397100448608398e+01 1.4782500267028809e+01 1.1761599731445312e+02 2.6375898361206055e+01 1.9258800506591797e+01 1.2137000274658203e+02 -2.7101200103759766e+01 -1.7819499969482422e+01 1.2137000274658203e+02 -2.8460399627685547e+01 -1.7514900207519531e+01 1.1886999511718750e+02 3.3142700195312500e+00 -6.5001304626464844e+01 1.1737000274658203e+02 4.9717998504638672e+01 3.9694396972656250e+01 1.1761999511718750e+02 -4.7914501190185547e+01 -3.3897796630859375e+01 1.1737000274658203e+02 -5.0969100952148438e+01 -3.7727699279785156e+01 1.2159500122070312e+02 -7.1500301361083984e+00 6.7965698242187500e+01 1.3837001037597656e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.2261699676513672e+02 2.2238500595092773e+01 6.7120300292968750e+01 1.1761700439453125e+02 2.1297098159790039e+01 -2.4689701080322266e+01 1.1737000274658203e+02 1.7519599914550781e+01 -2.7862998962402344e+01 1.2137300109863281e+02 -1.0486300468444824e+01 6.8867401123046875e+01 1.2137000274658203e+02 -1.3528600692749023e+01 7.0840003967285156e+01 1.2137000274658203e+02 -2.0458999633789062e+01 6.9000000000000000e+01 1.2137000274658203e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.1949499511718750e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.2337000274658203e+02 3.0103000640869141e+01 -6.5454605102539062e+01 1.1761999511718750e+02 3.2632999420166016e+01 3.2000997391496073e-17 1.1762400054931641e+02 3.2563602447509766e+01 2.3690600395202637e+00 1.2137000274658203e+02 -3.1886999130249023e+01 6.4500503540039062e+01 1.2137000274658203e+02 -3.1886999130249023e+01 5.4171600341796875e+01 1.2175499725341797e+02 -3.0550998687744141e+01 5.8083000183105469e+01 1.2136799621582031e+02 -3.6309997558593750e+01 1.5016699790954590e+01 1.2137000274658203e+02 -3.8333301544189453e+01 1.3466799736022949e+01 1.1737000274658203e+02 1.9529700279235840e+00 3.2814399719238281e+01 1.1737000274658203e+02 -6.9231801033020020e+00 6.3126197814941406e+01 1.1737000274658203e+02 9.4580096006393433e-01 6.3574703216552734e+01 1.2137000274658203e+02 -2.0458999633789062e+01 -6.9000000000000000e+01 1.2151999664306641e+02 -2.3022500991821289e+01 -6.8188102722167969e+01 1.1886999511718750e+02 -2.1853899002075195e+01 -6.8590301513671875e+01 1.2137000274658203e+02 -2.8715400695800781e+01 5.1000000000000000e+01 1.2137000274658203e+02 -5.7734298706054688e+01 4.3032798767089844e+01 1.2137000274658203e+02 -6.2470500946044922e+01 3.5678302764892578e+01 1.4036999511718750e+02 2.6088699340820312e+01 6.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 6.0260799407958984e+01 1.4036999511718750e+02 2.8102998733520508e+01 6.4158203125000000e+01 1.1886999511718750e+02 -4.7454200744628906e+01 -5.4153099060058594e+01 1.1886999511718750e+02 -3.6804298400878906e+01 -5.3527900695800781e+01 1.2137200164794922e+02 1.2510599136352539e+01 -5.1171001434326172e+01 1.2137000274658203e+02 -1.2524300813674927e+00 -3.2546100616455078e+01 1.2137000274658203e+02 3.7243000030517578e+01 6.1743598937988281e+01 1.1886999511718750e+02 7.2108001708984375e+01 1.4210900454981155e-14 1.2223000335693359e+02 -1.5892399787902832e+01 -6.7301902770996094e+01 1.2235599517822266e+02 -7.8413996696472168e+00 -6.7212402343750000e+01 1.4036999511718750e+02 2.7274599075317383e+01 5.5000000000000000e+01 1.2275599670410156e+02 -2.6007499694824219e+01 -6.7096702575683594e+01 1.1886999511718750e+02 -2.7524900436401367e+01 -6.6491500854492188e+01 1.1761999511718750e+02 -4.2355197906494141e+01 1.1919799804687500e+01 1.2137000274658203e+02 -4.5679199218750000e+01 1.4119899749755859e+01 1.1761999511718750e+02 -4.9136199951171875e+01 1.6408100128173828e+01 1.1868199920654297e+02 -3.9552101135253906e+01 -5.0510700225830078e+01 1.2337000274658203e+02 -2.9887001037597656e+01 -5.5000000000000000e+01 1.2172499847412109e+02 -3.0462701797485352e+01 -5.4544502258300781e+01 1.1886999511718750e+02 3.2619800567626953e+01 6.4241500854492188e+01 1.1886999511718750e+02 2.5471799850463867e+01 5.9758201599121094e+01 1.1764600372314453e+02 -2.7308700561523438e+01 1.7566301345825195e+01 1.2137000274658203e+02 -8.3014602661132812e+00 -3.1481000900268555e+01 1.2137100219726562e+02 -4.5079498291015625e+00 -5.1209899902343750e+01 1.2231499481201172e+02 9.1094303131103516e+00 -6.7229896545410156e+01 1.2343199920654297e+02 7.8583498001098633e+00 -6.6999000549316406e+01 1.2137000274658203e+02 5.5055900573730469e+01 4.6770698547363281e+01 1.2137000274658203e+02 4.5815898895263672e+01 5.5719600677490234e+01 1.2137000274658203e+02 -5.2208801269531250e+01 -3.8751598358154297e+01 1.2192600250244141e+02 2.2115200042724609e+01 -6.7486900329589844e+01 1.1761999511718750e+02 -4.2457901000976562e+01 -2.7730199813842773e+01 1.1737000274658203e+02 -4.4869400024414062e+01 -3.0833200454711914e+01 1.1859400177001953e+02 -4.0541796684265137e+00 6.3980804443359375e+01 1.1853100585937500e+02 -1.0671599388122559e+01 6.3023200988769531e+01 1.1853200531005859e+02 5.4580902099609375e+01 -3.3514400482177734e+01 1.1838899993896484e+02 5.1760902404785156e+01 -3.7530197143554688e+01 1.2137000274658203e+02 -3.1886999130249023e+01 -6.4500503540039062e+01 1.1866900634765625e+02 6.2999599456787109e+01 -1.3057600021362305e+01 1.1851100158691406e+02 8.6447401046752930e+00 6.3330703735351562e+01 1.1886800384521484e+02 1.2249699592590332e+01 6.3842998504638672e+01 1.1819300079345703e+02 1.3418299674987793e+01 6.2310699462890625e+01 1.2337000274658203e+02 -2.9887001037597656e+01 -6.5454605102539062e+01 1.3837001037597656e+02 -2.9887001037597656e+01 -6.5454605102539062e+01 1.4036999511718750e+02 -2.7058599472045898e+01 5.5000000000000000e+01 1.2137000274658203e+02 -1.5906701087951660e+01 -2.8460100173950195e+01 1.2349300384521484e+02 -7.9625902175903320e+00 6.6999000549316406e+01 1.2202999877929688e+02 -2.1181900024414062e+01 6.7372596740722656e+01 1.2337000274658203e+02 -2.6254899978637695e+01 6.7000000000000000e+01 1.1737100219726562e+02 4.2544300079345703e+01 4.7411098480224609e+01 1.1737000274658203e+02 9.5523900985717773e+00 3.1442798614501953e+01 1.2391799926757812e+02 -7.3300099372863770e-01 -5.3001399993896484e+01 1.3837001037597656e+02 -2.7886999130249023e+01 -5.3000000000000000e+01 1.2337000274658203e+02 -2.7886999130249023e+01 -5.3000000000000000e+01 1.2137599945068359e+02 -6.8729901313781738e+00 -6.8855499267578125e+01 1.2152499389648438e+02 -1.0067399978637695e+01 -6.8156898498535156e+01 1.2261500549316406e+02 -9.1735095977783203e+00 6.7123397827148438e+01 1.1737000274658203e+02 -3.9200599670410156e+01 1.6385799407958984e+01 1.1737000274658203e+02 -3.1682600021362305e+01 1.7502000808715820e+01 1.1842100524902344e+02 4.1473698616027832e+00 6.3737400054931641e+01 1.1737000274658203e+02 1.2427000045776367e+01 6.2363098144531250e+01 1.2137000274658203e+02 1.8387599945068359e+01 5.0735599517822266e+01 1.2137000274658203e+02 4.8338100433349609e+01 9.3933696746826172e+00 1.1763200378417969e+02 -2.7521200180053711e+00 -3.2435398101806641e+01 1.1853299713134766e+02 5.8128799438476562e+01 2.6877998352050781e+01 1.2333699798583984e+02 -1.5853399276733398e+01 -5.3000000000000000e+01 1.3837001037597656e+02 4.4822196960449219e+00 -5.3000000000000000e+01 1.2137000274658203e+02 -6.5989196777343750e+01 2.8550998687744141e+01 1.2137000274658203e+02 -6.6029701232910156e+01 2.7869300842285156e+01 1.2137000274658203e+02 -6.5623100280761719e+01 2.7320598602294922e+01 1.1736799621582031e+02 2.9482500076293945e+01 -5.6398200988769531e+01 1.1737000274658203e+02 1.4023200035095215e+01 -6.2224800109863281e+01 1.2137000274658203e+02 -2.8715400695800781e+01 -5.1000000000000000e+01 1.2137000274658203e+02 -3.4914600372314453e+01 -4.4607898712158203e+01 1.1849100494384766e+02 9.1693201065063477e+00 -6.3284797668457031e+01 1.3837001037597656e+02 -2.7886999130249023e+01 5.3000000000000000e+01 1.2137000274658203e+02 3.1598602294921875e+01 1.5615800857543945e+01 1.2137000274658203e+02 2.7497900009155273e+01 1.7717100143432617e+01 1.2137000274658203e+02 3.0582300186157227e+01 1.1498799324035645e+01 1.4036999511718750e+02 2.6088699340820312e+01 -6.5000000000000000e+01 1.2137000274658203e+02 -2.7313800811767578e+01 1.7535301208496094e+01 1.2137000274658203e+02 -2.2064701080322266e+01 2.3874898910522461e+01 1.1886999511718750e+02 -6.6029701232910156e+01 2.7869300842285156e+01 1.2137000274658203e+02 -5.6352699279785156e+01 -4.4678798675537109e+01 1.1886999511718750e+02 -5.6568500518798828e+01 -4.4058200836181641e+01 1.3837001037597656e+02 -2.6259099960327148e+01 6.7000000000000000e+01 1.2137000274658203e+02 2.8931400299072266e+01 -5.1000000000000000e+01 1.2205799865722656e+02 2.8239000320434570e+01 -5.2669399261474609e+01 1.2137000274658203e+02 3.2102996826171875e+01 -5.4171600341796875e+01 1.2137000274658203e+02 -2.9351299285888672e+01 1.3784900665283203e+01 1.1886999511718750e+02 5.2377201080322266e+01 -4.9650901794433594e+01 1.1886999511718750e+02 4.0899501800537109e+01 -5.0718898773193359e+01 1.1886599731445312e+02 5.0433300018310547e+01 -4.0747898101806641e+01 1.1886899566650391e+02 -4.2332000732421875e+01 4.9297000885009766e+01 1.1856800079345703e+02 -3.9030300140380859e+01 5.0684898376464844e+01 1.1737000274658203e+02 -3.1198799133300781e+01 5.5306301116943359e+01 1.1737500000000000e+02 5.8853897094726562e+01 2.4166601181030273e+01 1.1855699920654297e+02 6.2409198760986328e+01 1.4375800132751465e+01 1.1737200164794922e+02 6.2433399200439453e+01 1.2367700576782227e+01 1.2158899688720703e+02 -2.1880099773406982e+00 -6.7966300964355469e+01 1.2157299804687500e+02 6.9003601074218750e+00 -6.8011596679687500e+01 1.2227600097656250e+02 2.1726500988006592e+00 -6.7260597229003906e+01 1.2137000274658203e+02 -5.9009201049804688e+01 2.2942901611328125e+01 1.1762200164794922e+02 2.4148600101470947e+00 -3.2453300476074219e+01 1.1886899566650391e+02 -5.1713798522949219e+01 3.9198997497558594e+01 1.1737100219726562e+02 -5.2649200439453125e+01 3.5542800903320312e+01 1.1766699981689453e+02 3.1545200347900391e+01 8.5568103790283203e+00 1.1763200378417969e+02 2.9337100982666016e+01 1.4323200225830078e+01 1.1886999511718750e+02 -2.7984600067138672e+01 6.6349800109863281e+01 1.1863899993896484e+02 -4.5179298400878906e+01 4.5482299804687500e+01 1.4036999511718750e+02 2.8102998733520508e+01 5.5828399658203125e+01 1.1886999511718750e+02 6.0302398681640625e+01 -3.9612503051757812e+01 1.1843399810791016e+02 4.6489299774169922e+01 -4.3946399688720703e+01 1.1737000274658203e+02 4.8203701019287109e+01 -4.1558502197265625e+01 1.1887100219726562e+02 -6.3287601470947266e+00 -6.4690406799316406e+01 1.1761999511718750e+02 -3.8333301544189453e+01 1.3466799736022949e+01 1.1737000274658203e+02 -3.8541801452636719e+01 1.3604800224304199e+01 1.2137000274658203e+02 7.2108001708984375e+01 2.4158499094435737e-13 1.2225499725341797e+02 -3.0191900253295898e+01 6.5315093994140625e+01 1.4036999511718750e+02 -2.7886999130249023e+01 6.4158203125000000e+01 1.4036999511718750e+02 -2.5872699737548828e+01 6.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 -6.4158203125000000e+01 1.1737000274658203e+02 -1.4913800239562988e+01 6.1755699157714844e+01 1.1847499847412109e+02 -1.4920899391174316e+01 6.2122699737548828e+01 1.2231499481201172e+02 -3.2408800125122070e+00 5.2767501831054688e+01 1.2137000274658203e+02 -3.4026500701904297e+01 1.4747900009155273e+01 1.1886999511718750e+02 -1.6125699996948242e+01 7.0211402893066406e+01 1.1886899566650391e+02 -1.9463998794555664e+01 6.1953800201416016e+01 1.1804299926757812e+02 2.3236801624298096e+00 -6.3704200744628906e+01 1.1845600128173828e+02 -7.4153099060058594e+00 -6.3474796295166016e+01 1.1737000274658203e+02 -4.8890900611877441e+00 -6.3496700286865234e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -5.5828399658203125e+01 1.4036999511718750e+02 -2.7058599472045898e+01 -5.5000000000000000e+01 1.2225499725341797e+02 3.0408100128173828e+01 6.5314598083496094e+01 1.1860800170898438e+02 4.2470802307128906e+01 -4.8004096984863281e+01 1.1737000274658203e+02 2.1118700027465820e+01 5.9949199676513672e+01 1.1886999511718750e+02 7.2016502380371094e+01 3.6040399074554443e+00 1.1886999511718750e+02 7.0811698913574219e+01 1.4034000396728516e+01 1.2337000274658203e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.1843500518798828e+02 -3.3093299865722656e+01 5.4558601379394531e+01 1.1866999816894531e+02 5.7572700500488281e+01 -2.8691400527954102e+01 1.1886999511718750e+02 -6.2338901519775391e+01 3.6005199432373047e+01 1.1763700103759766e+02 2.5347801208496094e+01 -2.0675899505615234e+01 1.1886999511718750e+02 6.9648902893066406e+01 -1.8769800186157227e+01 1.1818299865722656e+02 -5.5386199951171875e+01 3.1375698089599609e+01 1.2337000274658203e+02 3.0103000640869141e+01 5.5000000000000000e+01 1.1737000274658203e+02 2.7959701538085938e+01 -1.7380599975585938e+01 1.1820600128173828e+02 -2.8034801483154297e+01 5.7169399261474609e+01 1.1737299346923828e+02 -2.3443000793457031e+01 5.8980701446533203e+01 1.1847999572753906e+02 3.8226398468017578e+01 -5.1287799835205078e+01 1.1737100219726562e+02 3.9669597625732422e+01 -4.9769199371337891e+01 1.2136899566650391e+02 -1.8175001144409180e+01 -5.0726802825927734e+01 1.2147600555419922e+02 -1.1570799827575684e+01 -5.1704898834228516e+01 1.2157499694824219e+02 -2.8302400112152100e+00 5.1970298767089844e+01 1.2164700317382812e+02 3.4586400985717773e+00 5.2106998443603516e+01 1.1761999511718750e+02 -3.8026000976562500e+01 -2.3379400253295898e+01 1.1761999511718750e+02 -3.9227897644042969e+01 -2.4244998931884766e+01 1.1852099609375000e+02 6.0291500091552734e+01 2.1799200057983398e+01 1.1886599731445312e+02 -2.5886600494384766e+01 -5.9272800445556641e+01 1.2330500030517578e+02 -1.2942000389099121e+01 5.3000301361083984e+01 1.2137000274658203e+02 -2.7718999862670898e+01 -1.7391599655151367e+01 1.2238299560546875e+02 3.1219500303268433e-01 -5.2810901641845703e+01 1.1761999511718750e+02 -5.9100502014160156e+01 2.3003299713134766e+01 1.3837001037597656e+02 2.8102998733520508e+01 5.3000000000000000e+01 1.1863400268554688e+02 3.8843297958374023e-01 -6.4193702697753906e+01 1.1761100006103516e+02 -1.6871200561523438e+01 2.7775199890136719e+01 1.1758200073242188e+02 -2.2663301467895508e+01 2.3472900390625000e+01 1.1737000274658203e+02 -2.0256898880004883e+01 2.5712799072265625e+01 1.2222299957275391e+02 -1.0709900856018066e+01 -5.2719699859619141e+01 1.2224900054931641e+02 -5.4021396636962891e+00 -5.2746398925781250e+01 1.1737000274658203e+02 3.2081897735595703e+01 7.5248799324035645e+00 1.2155699920654297e+02 2.5004699707031250e+01 -5.1964900970458984e+01 1.2160799407958984e+02 1.9047800064086914e+01 -5.2066299438476562e+01 1.1886999511718750e+02 6.8511802673339844e+01 2.2576299667358398e+01 1.1849500274658203e+02 2.5292100906372070e+01 -5.8713500976562500e+01 1.1886800384521484e+02 2.6568399429321289e+01 -5.9357097625732422e+01 1.1737000274658203e+02 -3.9099102020263672e+01 1.2762700080871582e+01 1.3837001037597656e+02 2.6474998474121094e+01 6.7000000000000000e+01 1.3837001037597656e+02 3.0103000640869141e+01 6.5454605102539062e+01 1.1737000274658203e+02 -8.1189699172973633e+00 -3.1791400909423828e+01 1.2137000274658203e+02 2.0674999237060547e+01 6.9000000000000000e+01 1.2137000274658203e+02 3.6923099517822266e+01 -6.1917098999023438e+01 1.2137000274658203e+02 3.2102996826171875e+01 -6.4500503540039062e+01 1.1737000274658203e+02 6.3607997894287109e+01 -9.6633801221351900e-13 1.1868599700927734e+02 6.2898403406143188e-01 6.4218696594238281e+01 1.1763300323486328e+02 -2.8975999355316162e+00 3.2396598815917969e+01 1.1737000274658203e+02 -5.8872699737548828e+00 3.2315898895263672e+01 1.1737000274658203e+02 3.1001699447631836e+01 -1.1159599304199219e+01 1.2227600097656250e+02 -1.9566500186920166e+00 6.7260597229003906e+01 1.1843099975585938e+02 -5.9458599090576172e+01 2.3240299224853516e+01 1.2313199615478516e+02 1.8484100341796875e+01 -5.2999702453613281e+01 1.1819600677490234e+02 5.8913101196289062e+01 -2.4616500854492188e+01 1.1886800384521484e+02 3.2603401184082031e+01 -5.6195697784423828e+01 1.1850199890136719e+02 2.8431699752807617e+01 -5.7314102172851562e+01 1.1852500152587891e+02 5.3111602783203125e+01 3.5825801849365234e+01 1.1827999877929688e+02 5.5938899993896484e+01 3.0847801208496094e+01 1.1737000274658203e+02 5.5271598815917969e+01 3.1592802047729492e+01 1.3837001037597656e+02 3.0103000640869141e+01 -6.5454498291015625e+01 1.1737000274658203e+02 -4.9159603118896484e+01 1.6723400115966797e+01 1.1761999511718750e+02 -3.1649000167846680e+01 -1.9469699859619141e+01 1.1737000274658203e+02 -3.3802101135253906e+01 -2.1082998275756836e+01 1.1761999511718750e+02 -4.0975399017333984e+01 1.1504599571228027e+01 1.2137000274658203e+02 -1.4254399299621582e+01 2.9293998718261719e+01 1.2229100036621094e+02 -1.7794401168823242e+01 -5.2748100280761719e+01 1.2137000274658203e+02 2.3336099624633789e+01 -2.2923299789428711e+01 1.3837001037597656e+02 3.0103000640869141e+01 5.5000000000000000e+01 1.1886999511718750e+02 -1.4996999740600586e+01 -6.3287197113037109e+01 1.1737000274658203e+02 1.5259600639343262e+01 2.9098098754882812e+01 1.1737000274658203e+02 -3.3927398681640625e+01 1.4977399826049805e+01 1.1737000274658203e+02 -3.0554599761962891e+01 1.3520199775695801e+01 1.2167900085449219e+02 -1.5458099365234375e+01 6.7850097656250000e+01 1.1762999725341797e+02 -9.6849603652954102e+00 3.1160600662231445e+01 1.2337000274658203e+02 2.8102998733520508e+01 5.3000000000000000e+01 1.2225099945068359e+02 2.8251899719238281e+01 5.2701000213623047e+01 1.1737000274658203e+02 -1.3914899826049805e+01 2.9743301391601562e+01 1.1886999511718750e+02 6.5108001708984375e+01 -8.6686202920710498e-13 1.2137000274658203e+02 4.6335998535156250e+01 -5.5385898590087891e+01 1.2137000274658203e+02 1.0696800231933594e+01 7.1361495971679688e+01 1.1866100311279297e+02 -2.4940299987792969e+01 5.9089702606201172e+01 1.1737000274658203e+02 6.3341899871826172e+01 -6.4508299827575684e+00 1.1813200378417969e+02 6.3290798187255859e+01 -8.3502302169799805e+00 1.1761999511718750e+02 -4.0288799285888672e+01 -2.5278499603271484e+01 1.1846300506591797e+02 -2.7731100082397461e+01 -5.7558399200439453e+01 1.1738699340820312e+02 -2.6513099670410156e+01 -5.7629199981689453e+01 1.1819400024414062e+02 -1.9792400360107422e+01 -6.0569099426269531e+01 1.1848200225830078e+02 6.3147598266601562e+01 1.0512200355529785e+01 1.1763399505615234e+02 8.4969196319580078e+00 -3.1469099044799805e+01 1.1737000274658203e+02 1.0995600700378418e+01 -3.0952800750732422e+01 1.1737000274658203e+02 5.7727699279785156e+00 -3.2296501159667969e+01 1.2228500366210938e+02 3.0357099533081055e+01 -5.4833999633789062e+01 1.1737000274658203e+02 -4.5341701507568359e+01 1.4196399688720703e+01 1.1737000274658203e+02 -4.2217197418212891e+01 1.2128299713134766e+01 1.4036999511718750e+02 -2.7886999130249023e+01 5.5828399658203125e+01 1.2137000274658203e+02 -5.1566600799560547e+01 5.0175998687744141e+01 1.2136899566650391e+02 3.2042800903320312e+01 -5.7899398803710938e+01 1.2163600158691406e+02 3.1005899429321289e+01 -6.1990901947021484e+01 1.1760900115966797e+02 2.9176599502563477e+01 -1.4637299537658691e+01 1.2337000274658203e+02 3.0103000640869141e+01 6.5454605102539062e+01 1.1850099945068359e+02 -1.9194801330566406e+01 6.0964199066162109e+01 1.1737000274658203e+02 -1.8898500442504883e+01 -6.0616298675537109e+01 1.1737000274658203e+02 3.2882999420166016e+01 2.8421701298887714e-13 1.2156199645996094e+02 -1.9396598815917969e+01 5.1963401794433594e+01 1.2250699615478516e+02 -2.2260900497436523e+01 5.2837402343750000e+01 1.1761999511718750e+02 1.8994298934936523e+01 -2.6486999511718750e+01 1.1886999511718750e+02 4.1817401885986328e+01 -5.8911598205566406e+01 1.2137000274658203e+02 4.8735098838806152e+00 3.2218399047851562e+01 1.2230200195312500e+02 -1.2254400253295898e+01 5.2756298065185547e+01 1.1871799468994141e+02 -3.1468997955322266e+01 -5.5970298767089844e+01 1.1822900390625000e+02 3.2869300842285156e+01 -5.4708499908447266e+01 1.2137000274658203e+02 2.2720699310302734e+01 2.3456800460815430e+01 1.1886999511718750e+02 1.1232599258422852e+01 7.1156005859375000e+01 1.1737000274658203e+02 -4.0975399017333984e+01 1.1754600524902344e+01 1.3837001037597656e+02 -2.9887001037597656e+01 -5.5000000000000000e+01 1.1855300140380859e+02 6.3947097778320312e+01 -3.5793299674987793e+00 1.1886999511718750e+02 -6.5989196777343750e+01 2.8550998687744141e+01 1.1737000274658203e+02 -4.3372997641563416e-01 -3.2841197967529297e+01 1.1886999511718750e+02 -5.5902801513671875e+01 4.5347499847412109e+01 1.1818599700927734e+02 6.1611400604248047e+01 -1.6768699645996094e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -6.0179199218750000e+01 1.2147399902343750e+02 -1.0176099777221680e+01 5.1711101531982422e+01 1.2246699523925781e+02 1.7770599365234375e+01 -5.2830497741699219e+01 1.1737000274658203e+02 -1.9266300201416016e+01 -2.6453399658203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2988 -> 23 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01) (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01) (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01) (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_upper_arm_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_wrist_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 3.2100000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 0 50 229 393 50 0 0 2 324 98 0 229 1 0 98 324 393 0 393 51 50 51 393 324 50 51 52 50 52 291 50 291 229 2 308 51 324 2 51 51 431 52 431 51 308 308 430 431 128 209 308 128 308 2 308 440 430 308 209 440 431 430 52 430 39 38 52 430 38 440 39 430 38 39 40 40 39 412 39 440 412 38 40 52 40 327 52 356 327 40 356 40 191 412 191 40 412 440 191 440 209 439 439 387 440 191 440 387 432 387 439 298 439 209 432 439 298 297 303 387 389 191 387 432 297 387 303 389 387 297 432 298 296 297 298 296 303 297 296 302 303 303 302 389 302 489 389 389 489 191 489 302 499 499 191 489 191 499 500 499 302 500 500 302 492 492 191 500 492 302 487 191 492 487 487 302 192 487 192 191 32 191 192 192 346 347 346 192 302 32 192 347 347 346 423 32 347 423 32 423 201 63 423 346 201 423 63 32 201 202 201 63 202 62 63 64 63 262 64 202 63 339 339 63 62 63 346 262 202 339 247 247 32 202 62 338 339 338 247 339 140 62 64 62 140 338 140 64 73 73 64 71 71 64 262 140 141 142 140 73 141 142 338 140 338 142 245 338 245 247 245 246 247 311 246 245 142 311 245 33 246 269 311 267 246 246 267 269 33 247 246 142 310 311 310 267 311 267 268 269 284 268 267 284 267 22 310 22 267 22 310 142 21 22 23 284 22 21 23 22 99 142 99 22 341 284 21 284 341 268 341 368 268 341 438 174 110 368 341 174 110 341 341 21 438 400 332 368 268 368 436 400 368 110 368 332 436 108 109 110 109 400 110 108 110 174 173 108 174 173 174 438 173 183 108 108 305 109 108 498 305 108 183 498 422 109 304 109 422 400 305 304 109 304 305 241 241 305 9 9 305 498 484 498 183 484 9 498 9 10 11 240 241 9 11 265 9 265 240 9 484 10 9 10 253 11 256 253 10 10 484 256 253 265 11 122 253 256 299 265 253 299 253 122 129 122 256 496 129 256 484 496 256 121 122 123 309 299 122 123 122 129 121 309 122 469 299 309 299 469 265 318 309 121 468 309 318 468 469 309 130 217 121 123 130 121 121 217 318 129 130 123 411 130 129 420 203 130 419 420 130 411 419 130 130 203 217 318 217 205 217 203 205 203 204 205 334 485 203 204 203 485 203 420 334 293 318 205 205 204 293 204 433 293 433 204 485 334 314 485 314 433 485 132 131 433 433 294 293 433 261 294 314 132 433 131 261 433 131 132 133 132 189 133 189 132 314 131 190 261 131 133 190 261 328 294 261 416 328 261 190 416 125 293 294 328 125 294 124 125 126 126 125 328 408 125 124 206 293 125 408 206 125 293 206 318 206 468 318 468 206 469 469 229 265 98 469 206 98 229 469 265 229 266 229 291 292 266 229 292 265 266 240 240 266 279 266 292 279 292 291 279 291 52 279 240 279 241 279 52 327 357 241 279 357 279 327 304 241 357 356 304 357 356 357 327 422 304 356 422 356 332 356 191 332 400 422 332 331 332 333 436 332 331 333 332 191 34 191 32 333 191 34 331 333 34 32 33 34 331 34 33 409 331 33 436 331 269 269 331 409 269 268 436 409 33 269 32 247 33 97 1 98 319 24 98 350 319 98 98 208 348 350 98 348 206 208 98 24 97 98 128 2 1 1 97 128 97 127 128 209 128 127 19 127 20 127 19 298 298 209 127 127 97 20 18 19 20 298 19 434 19 18 474 434 19 474 24 20 97 18 20 24 18 24 25 18 25 212 474 18 212 434 474 475 475 474 212 210 211 212 212 211 475 210 212 25 319 263 25 263 210 25 319 25 24 263 236 210 210 236 460 210 460 211 211 460 470 475 211 470 235 231 460 460 236 235 460 231 470 235 236 237 263 264 236 236 264 237 264 263 336 319 336 263 336 337 264 337 391 264 264 391 237 237 448 235 390 448 237 237 391 390 235 448 231 448 322 231 448 390 322 390 391 392 390 83 322 83 390 437 392 497 390 390 497 437 322 180 231 83 181 322 180 322 181 82 83 84 181 83 82 83 437 84 179 180 181 82 179 181 231 180 232 180 373 232 179 373 180 470 231 232 470 232 475 102 232 163 475 232 102 232 373 163 163 373 316 316 373 179 316 179 82 316 82 317 316 197 163 316 317 197 103 163 164 164 163 197 102 163 103 164 197 72 317 78 197 197 78 72 262 164 71 262 103 164 71 164 72 102 103 104 346 103 262 346 104 103 302 296 104 434 104 296 102 104 434 302 104 346 434 296 298 434 475 102 71 72 73 77 72 78 73 72 77 141 73 77 77 78 463 141 77 463 463 78 429 429 78 317 141 463 377 463 429 377 142 141 358 377 358 141 377 85 358 429 85 377 317 86 429 429 86 85 317 82 426 317 426 86 85 86 87 87 86 426 85 115 358 67 85 87 67 115 85 87 426 84 84 53 87 53 323 87 87 323 67 84 426 82 84 437 53 53 54 55 53 55 323 437 54 53 323 55 483 323 65 67 323 483 65 74 483 75 75 483 55 483 74 65 65 66 67 74 66 65 74 75 76 76 66 74 75 55 175 351 75 447 75 175 447 75 351 76 76 351 353 66 76 353 67 66 115 358 66 353 115 66 358 351 352 353 353 272 358 352 270 353 353 270 272 142 358 272 99 142 272 23 99 69 99 146 69 99 274 105 105 107 99 345 99 272 99 154 90 379 466 99 90 146 99 239 379 99 154 99 466 107 239 99 274 99 345 154 88 90 466 275 154 275 88 154 466 467 276 379 467 466 276 275 466 151 275 276 425 88 275 151 425 275 88 89 90 425 89 88 222 425 453 454 425 151 453 425 454 89 425 222 221 89 222 221 90 89 221 222 223 80 223 222 80 222 453 476 453 454 80 453 476 454 150 476 150 454 151 81 80 476 476 150 81 79 80 81 80 79 223 100 101 81 81 150 187 81 187 100 79 81 101 150 151 152 187 150 152 187 188 100 187 152 371 187 371 188 152 151 493 152 493 371 493 151 276 371 493 372 372 493 276 188 371 372 450 188 372 450 375 188 375 100 188 406 372 467 372 276 467 450 372 406 450 406 252 354 375 450 354 450 252 248 406 379 252 406 248 379 406 467 238 91 252 91 354 252 238 252 248 374 375 354 374 354 91 91 92 93 378 374 91 378 91 93 91 238 92 107 238 239 238 248 239 92 238 107 239 248 379 105 106 107 106 92 107 106 93 92 93 106 290 289 378 93 289 93 290 289 374 378 375 374 289 288 289 290 289 288 375 177 176 290 176 288 290 106 177 290 176 177 178 456 177 106 456 490 177 178 177 490 277 176 278 176 178 278 176 277 288 278 178 8 8 178 12 178 490 12 490 13 12 404 13 490 404 490 456 274 404 456 456 106 274 345 403 404 404 254 13 345 404 274 404 403 254 12 13 14 13 254 14 139 44 254 254 403 139 44 14 254 344 403 345 403 457 139 457 403 344 272 344 345 272 376 344 376 457 344 369 457 376 139 457 137 137 457 369 376 272 271 113 369 376 376 271 113 270 271 272 270 113 271 111 112 113 111 113 477 369 113 112 270 477 113 270 352 477 446 111 477 352 446 477 116 111 386 116 112 111 111 446 386 112 116 117 117 369 112 320 116 386 117 116 320 320 321 117 321 138 117 369 117 138 137 369 138 137 138 139 139 167 44 329 139 138 139 329 167 44 45 46 45 44 167 424 14 44 44 46 424 166 95 45 167 166 45 46 45 95 46 95 94 424 46 94 193 424 295 193 14 424 295 424 94 193 12 14 8 12 193 8 193 295 381 295 94 295 6 8 295 381 6 94 95 96 96 381 94 380 234 381 381 234 405 381 405 6 96 380 381 6 7 8 6 405 7 8 7 278 278 7 158 405 158 7 234 233 405 405 233 158 58 233 234 58 234 227 227 234 380 96 227 380 227 96 228 49 227 228 58 227 48 48 227 49 200 255 228 228 255 49 481 228 96 200 228 481 47 48 49 49 255 47 48 47 162 162 58 48 367 59 47 255 367 47 59 162 47 255 200 199 367 255 199 367 60 59 367 199 60 198 199 200 168 199 213 213 199 198 199 168 60 59 60 61 60 169 61 60 168 169 168 28 169 26 28 168 26 168 213 26 27 28 169 28 27 218 300 169 472 61 169 169 300 472 27 218 169 218 27 482 27 26 482 482 26 326 26 213 326 479 219 482 218 482 219 326 479 482 213 325 326 325 479 326 479 243 219 175 479 325 175 55 479 55 243 479 218 219 220 220 219 243 444 220 462 444 218 220 462 220 471 220 243 471 300 444 445 300 218 444 444 462 459 445 444 459 462 242 459 462 471 242 471 243 242 242 243 244 242 391 459 242 244 391 458 445 459 459 391 337 459 337 336 459 336 458 392 391 244 243 340 244 54 244 340 54 392 244 497 392 54 437 497 54 54 340 55 340 243 55 370 445 458 336 370 458 370 336 319 370 319 455 455 445 370 300 445 455 455 319 350 61 472 455 472 300 455 350 61 455 59 61 350 59 225 413 59 350 225 162 59 413 56 162 413 225 56 413 3 5 225 465 3 225 5 56 225 465 225 350 56 57 58 56 5 57 56 58 162 3 4 5 4 488 5 57 5 488 465 4 3 465 382 4 382 465 350 382 43 4 359 488 4 4 43 359 57 488 159 361 159 488 488 359 361 359 360 361 359 43 42 42 360 359 160 159 361 360 288 361 160 361 288 158 159 160 233 57 159 158 233 159 277 158 160 277 160 288 288 100 375 288 442 100 442 288 360 101 100 155 100 136 155 100 442 136 360 42 442 442 41 136 41 442 42 134 135 136 136 135 155 136 41 134 41 42 43 41 43 134 153 147 134 280 135 134 147 280 134 134 43 153 135 301 286 286 155 135 280 301 135 149 301 280 147 149 280 147 148 149 396 147 153 396 148 147 149 461 301 148 461 149 301 287 286 301 461 287 148 452 461 461 452 287 478 148 208 148 396 208 478 452 148 208 396 348 348 396 153 206 207 208 207 452 208 452 478 208 287 452 449 449 452 207 415 449 207 415 207 206 414 415 206 206 408 414 285 449 415 415 282 285 282 415 414 285 287 449 285 286 287 285 282 365 286 285 473 285 494 473 285 365 494 155 286 473 473 435 155 473 494 435 155 156 157 435 156 155 155 157 101 435 494 156 383 118 156 156 118 157 156 494 383 120 101 157 118 120 157 120 143 101 101 143 79 118 119 120 119 143 120 383 119 118 119 383 384 383 494 281 384 383 281 144 119 384 144 143 119 364 384 281 464 144 384 464 384 364 281 282 283 281 283 364 282 281 494 365 282 494 283 282 414 283 414 407 364 283 407 414 408 407 407 408 124 364 407 362 407 366 362 407 124 366 366 124 126 366 363 362 363 366 395 126 395 366 362 363 364 363 395 37 36 363 37 36 464 363 363 464 364 395 126 328 328 37 395 35 36 37 328 35 37 36 417 418 36 35 417 36 418 464 144 464 441 418 441 464 260 441 418 260 418 394 418 417 394 417 35 394 17 260 394 15 17 394 35 451 394 394 451 15 15 16 17 17 259 260 17 388 259 17 16 388 185 16 15 15 451 185 451 401 185 401 451 416 416 451 35 185 186 16 185 401 257 186 185 257 257 258 186 258 161 186 186 161 16 401 402 257 258 257 402 402 250 249 402 249 258 421 402 401 402 421 315 402 315 250 249 250 251 250 315 251 258 249 251 196 195 258 195 68 258 68 161 258 196 258 251 194 195 196 196 251 194 230 195 194 230 273 195 114 68 195 273 114 195 68 69 70 114 69 68 68 70 161 443 69 114 216 114 273 443 114 216 216 273 397 397 273 230 214 215 216 397 214 216 215 443 216 171 443 215 69 443 23 23 443 171 69 146 70 161 70 146 90 29 146 146 388 161 146 29 388 29 90 30 30 90 221 29 30 31 388 29 31 161 388 16 259 388 31 31 307 259 355 307 31 31 30 355 30 221 355 223 342 221 355 221 342 355 306 307 355 342 343 355 343 306 306 260 307 307 260 259 343 145 306 306 441 260 306 145 441 342 223 343 223 143 343 343 143 145 223 79 143 143 144 145 144 441 145 170 171 172 170 23 171 172 171 215 224 21 170 170 21 23 170 172 224 172 226 182 172 182 224 215 226 172 215 214 226 427 428 226 214 427 226 226 428 182 182 183 173 224 182 173 428 183 182 427 496 428 428 496 484 428 484 183 410 427 486 214 486 427 427 410 496 496 410 129 410 411 129 411 410 486 480 411 486 214 480 486 480 419 411 397 480 214 313 419 480 397 313 480 419 313 420 230 312 313 397 230 313 335 495 313 312 335 313 420 313 495 495 334 420 334 495 335 251 334 335 251 335 312 194 312 230 194 251 312 314 251 315 334 251 314 314 421 189 314 315 421 189 421 190 421 401 190 189 190 133 190 401 416 328 416 35 173 438 224 438 21 224 43 349 153 153 349 348 382 349 43 348 349 350 350 349 382 278 158 277 58 57 233 175 325 385 175 385 447 385 325 386 386 325 213 386 447 385 386 446 447 447 446 351 213 321 386 320 386 321 398 213 198 213 398 321 321 398 138 398 198 399 398 399 165 398 165 138 200 399 198 399 200 491 399 491 184 399 184 165 165 166 167 165 184 166 167 330 165 138 165 330 330 329 138 167 329 330 166 481 95 166 184 481 491 481 184 491 200 481 95 481 96 351 446 352 274 106 105))
                   (list :vertices (let ((mat (make-matrix 501 3))) (fvector-replace (array-entity mat) #f(-3.5301699829101562e+02 2.1641901016235352e+01 4.1873102188110352e+00 -3.5611999511718750e+02 2.1715000152587891e+01 0.0000000000000000e+00 -3.5607598876953125e+02 2.1692899703979492e+01 1.2645499706268311e+00 -2.9478799438476562e+02 2.1286500930786133e+01 -2.0755001068115234e+01 -2.9394799804687500e+02 2.0900800704956055e+01 -2.0644199371337891e+01 -2.9454498291015625e+02 2.1118700027465820e+01 -2.5026998519897461e+01 -2.9516101074218750e+02 2.3047499656677246e+00 -3.5144500732421875e+01 -2.9418600463867188e+02 3.6295700073242188e+00 -3.2654502868652344e+01 -2.9509899902343750e+02 -1.8817499160766602e+01 -3.5094299316406250e+01 -3.5238900756835938e+02 1.9902599334716797e+01 2.0142499923706055e+01 -3.4893899536132812e+02 1.9776300430297852e+01 2.4683900833129883e+01 -3.5029000854492188e+02 2.0569499969482422e+01 2.2376399993896484e+01 -2.9583499145507812e+02 -1.9436700820922852e+01 -3.6196300506591797e+01 -2.9672302246093750e+02 -2.0360700607299805e+01 -3.6702301025390625e+01 -2.9791702270507812e+02 -1.9608400344848633e+01 -3.8560199737548828e+01 -3.0912701416015625e+02 -1.9747900009155273e+01 3.5340301513671875e+01 -3.1271801757812500e+02 -2.0705598831176758e+01 3.5513000488281250e+01 -3.0717001342773438e+02 -2.0295598983764648e+01 3.4268901824951172e+01 -3.5556301879882812e+02 2.1432699203491211e+01 -9.7471504211425781e+00 -3.5711898803710938e+02 2.1207601547241211e+01 -5.1841897964477539e+00 -3.5629998779296875e+02 2.1574800491333008e+01 -4.9674201011657715e+00 -3.5129202270507812e+02 -2.1317298889160156e+01 1.8885200500488281e+01 -3.5171697998046875e+02 -2.1437799453735352e+01 1.6795900344848633e+01 -3.4419198608398438e+02 -2.1295299530029297e+01 2.6035999298095703e+01 -3.5373199462890625e+02 2.1518899917602539e+01 -1.2404700279235840e+01 -3.5354299926757812e+02 2.1373300552368164e+01 -1.4902899742126465e+01 -3.1502398681640625e+02 1.8796300888061523e+01 -3.9231098175048828e+01 -3.2345501708984375e+02 1.9679599761962891e+01 -3.7457202911376953e+01 -3.1820999145507812e+02 1.9652000427246094e+01 -3.8476398468017578e+01 -3.0773400878906250e+02 -2.1182800292968750e+01 3.2080097198486328e+01 -2.9687802124023438e+02 -2.1269298553466797e+01 2.5533899307250977e+01 -3.0021701049804688e+02 -2.1105300903320312e+01 2.9298198699951172e+01 -3.5834698486328125e+02 -1.9420801162719727e+01 1.3042000532150269e+00 -3.5800997924804688e+02 -2.0234498977661133e+01 3.9089400768280029e+00 -3.5817797851562500e+02 -1.9378999710083008e+01 3.7875001430511475e+00 -3.0845401000976562e+02 1.8866498947143555e+01 3.5229701995849609e+01 -3.0312500000000000e+02 1.8695199966430664e+01 3.2908203125000000e+01 -3.0759899902343750e+02 1.9508300781250000e+01 3.4821399688720703e+01 -3.5812500000000000e+02 1.9712200164794922e+01 4.0400400161743164e+00 -3.5817797851562500e+02 1.9378999710083008e+01 3.7875001430511475e+00 -3.5815100097656250e+02 1.9377000808715820e+01 4.0399999618530273e+00 -2.9287600708007812e+02 1.9959699630737305e+01 -4.9184298515319824e+00 -2.9301199340820312e+02 1.9805700302124023e+01 -1.2913000106811523e+01 -2.9339099121093750e+02 2.0763799667358398e+01 -8.6935701370239258e+00 -3.0073800659179688e+02 -1.8931900024414062e+01 -4.0221900939941406e+01 -3.0134399414062500e+02 -6.9823198318481445e+00 -4.0403602600097656e+01 -2.9997900390625000e+02 -3.1850500106811523e+00 -3.9919296264648438e+01 -3.0488101196289062e+02 2.1041101455688477e+01 -3.8609600067138672e+01 -2.9809500122070312e+02 2.0997800827026367e+01 -3.6835201263427734e+01 -3.0123001098632812e+02 2.0798700332641602e+01 -3.9214000701904297e+01 -3.5586898803710938e+02 2.1644498825073242e+01 4.0399899482727051e+00 -3.5649200439453125e+02 2.1582498550415039e+01 3.7915399074554443e+00 -3.5765902709960938e+02 2.0909799575805664e+01 3.8497300148010254e+00 -3.4104998779296875e+02 -1.8928001403808594e+01 -3.1607698440551758e+01 -3.3941000366210938e+02 -1.8548299789428711e+01 -3.2494998931884766e+01 -3.3415600585937500e+02 -1.8840799331665039e+01 -3.4997600555419922e+01 -2.9507601928710938e+02 2.1140100479125977e+01 -2.8969400405883789e+01 -2.9423498535156250e+02 2.0540399551391602e+01 -3.0364099502563477e+01 -2.9576199340820312e+02 2.0860399246215820e+01 -3.3895999908447266e+01 -3.0844598388671875e+02 2.1047599792480469e+01 -3.8234199523925781e+01 -3.1204501342773438e+02 2.0852899551391602e+01 -3.8557201385498047e+01 -3.2042599487304688e+02 2.1049798965454102e+01 -3.6366600036621094e+01 -3.5695700073242188e+02 -2.1528100967407227e+01 -1.3672299385070801e+00 -3.5808300781250000e+02 -2.0571901321411133e+01 -1.6275700330734253e+00 -3.5690100097656250e+02 -2.1453899383544922e+01 -4.2780499458312988e+00 -3.3824398803710938e+02 -2.0333400726318359e+01 -3.2655998229980469e+01 -3.3714602661132812e+02 -2.0995498657226562e+01 -3.2264698028564453e+01 -3.4192300415039062e+02 -2.0409999847412109e+01 -3.0380500793457031e+01 -3.2463101196289062e+02 -2.0982398986816406e+01 3.5771102905273438e+01 -3.3658001708984375e+02 -2.1173799514770508e+01 3.1602100372314453e+01 -3.2473800659179688e+02 -2.1105199813842773e+01 3.4942001342773438e+01 -3.5711801147460938e+02 -2.0758501052856445e+01 -7.5738797187805176e+00 -3.5564498901367188e+02 -2.0659599304199219e+01 -1.2771900177001953e+01 -3.5564602661132812e+02 -2.1346900939941406e+01 -1.0336899757385254e+01 -3.3404098510742188e+02 -2.0342800140380859e+01 -3.4504699707031250e+01 -3.3085400390625000e+02 -1.9838399887084961e+01 -3.5884998321533203e+01 -3.3025299072265625e+02 -2.0969900131225586e+01 -3.4810901641845703e+01 -3.5392800903320312e+02 -2.1372699737548828e+01 -1.4258600234985352e+01 -3.5379998779296875e+02 -2.0633001327514648e+01 -1.6859498977661133e+01 -2.9310598754882812e+02 -1.9056501388549805e+01 2.2132900238037109e+01 -2.9319799804687500e+02 -1.9659500122070312e+01 2.2141799926757812e+01 -2.9298202514648438e+02 -1.9177999496459961e+01 1.5009799957275391e+01 -3.5025701904296875e+02 -1.9035499572753906e+01 -2.3315399169921875e+01 -3.4762298583984375e+02 -1.8535400390625000e+01 -2.6109399795532227e+01 -3.4638699340820312e+02 -1.9011798858642578e+01 -2.7484899520874023e+01 -3.4489102172851562e+02 -2.0840400695800781e+01 -2.7574998855590820e+01 -3.4848498535156250e+02 -2.0445098876953125e+01 -2.4654699325561523e+01 -3.4584997558593750e+02 -1.9826700210571289e+01 -2.7800500869750977e+01 -2.9469100952148438e+02 -2.1390199661254883e+01 1.5064200401306152e+01 -2.9455502319335938e+02 -2.1195899963378906e+01 2.2164899826049805e+01 -2.9537799072265625e+02 -2.1328701019287109e+01 2.2132900238037109e+01 -2.9358099365234375e+02 -2.0782501220703125e+01 -1.3934000015258789e+01 -2.9447000122070312e+02 -2.1253999710083008e+01 -1.8271800994873047e+01 -2.9381399536132812e+02 -2.0783700942993164e+01 -2.0777799606323242e+01 -2.9868701171875000e+02 5.3715000152587891e+00 -3.9247501373291016e+01 -3.0086700439453125e+02 1.4495900154113770e+01 -4.0261699676513672e+01 -2.9887500000000000e+02 1.9101100921630859e+01 -3.9388500213623047e+01 -3.5607598876953125e+02 2.1692899703979492e+01 -1.2645399570465088e+00 -3.3094097900390625e+02 2.1715000152587891e+01 0.0000000000000000e+00 -3.2660299682617188e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9272000122070312e+02 -1.2480899810791016e+01 0.0000000000000000e+00 -2.9310101318359375e+02 -9.5282592773437500e+00 2.2133199691772461e+01 -3.5680200195312500e+02 1.9170299530029297e+01 -1.0743799209594727e+01 -3.5700000000000000e+02 -1.9283300399780273e+01 -1.0072000503540039e+01 -3.5783700561523438e+02 1.9338800430297852e+01 -6.2930798530578613e+00 -2.9542700195312500e+02 -2.1280000686645508e+01 -2.4923398971557617e+01 -2.9457199096679688e+02 -2.1129699707031250e+01 -2.5248401641845703e+01 -2.9529101562500000e+02 -2.1393400192260742e+01 -1.8437801361083984e+01 -3.5415100097656250e+02 -1.9159400939941406e+01 1.7321100234985352e+01 -3.5592898559570312e+02 -1.9224500656127930e+01 1.3314700126647949e+01 -3.5515298461914062e+02 -2.0062999725341797e+01 1.4870900154113770e+01 -3.1422900390625000e+02 -1.9933101654052734e+01 -3.9087100982666016e+01 -3.1189199829101562e+02 -1.9628000259399414e+01 -3.9706497192382812e+01 -3.1217102050781250e+02 -2.0584499359130859e+01 -3.8925098419189453e+01 -3.3257699584960938e+02 -2.1000101089477539e+01 3.4073299407958984e+01 -3.4172299194335938e+02 -2.1072500228881836e+01 -2.9408599853515625e+01 -3.1605801391601562e+02 -1.9327600479125977e+01 -3.8978302001953125e+01 -3.0888000488281250e+02 -1.8775501251220703e+01 -4.0425300598144531e+01 -2.9338500976562500e+02 1.6920000076293945e+01 2.3979600906372070e+01 -2.9422598266601562e+02 7.1667399406433105e+00 2.5911100387573242e+01 -2.9338500976562500e+02 -7.1761697530746460e-01 2.3979600906372070e+01 -3.3547100830078125e+02 2.0776899337768555e+01 3.3450698852539062e+01 -3.4247100830078125e+02 2.0694698333740234e+01 2.9690299987792969e+01 -3.3793301391601562e+02 2.0354600906372070e+01 3.2776298522949219e+01 -3.0514599609375000e+02 2.1098001480102539e+01 3.2023899078369141e+01 -3.1241101074218750e+02 2.0910799026489258e+01 3.5174900054931641e+01 -3.0844598388671875e+02 2.0781000137329102e+01 3.4161300659179688e+01 -3.5721002197265625e+02 2.1388801574707031e+01 -1.2988300323486328e+00 -3.5697497558593750e+02 2.1567300796508789e+01 3.3120602369308472e-01 -3.4166799926757812e+02 1.9748600006103516e+01 3.1055801391601562e+01 -3.3513500976562500e+02 1.9611999511718750e+01 3.4518199920654297e+01 -3.2092401123046875e+02 1.8829700469970703e+01 3.7369899749755859e+01 -3.2101800537109375e+02 1.8829700469970703e+01 3.7369998931884766e+01 -3.2044400024414062e+02 1.7454999923706055e+01 3.7367298126220703e+01 -2.9289401245117188e+02 2.0353000640869141e+01 -7.1080195903778076e-01 -2.9283401489257812e+02 1.9329799652099609e+01 6.4341502189636230e+00 -2.9272000122070312e+02 1.9442800521850586e+01 0.0000000000000000e+00 -3.0660900878906250e+02 -1.9584199905395508e+01 -4.0665897369384766e+01 -3.0507299804687500e+02 -1.8768899917602539e+01 -4.0841602325439453e+01 -3.0356402587890625e+02 -1.9593799591064453e+01 -4.0697898864746094e+01 -3.5607598876953125e+02 -2.1692899703979492e+01 -1.2645399570465088e+00 -3.5243698120117188e+02 -2.1438001632690430e+01 -1.6253198623657227e+01 -3.4977999877929688e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9389102172851562e+02 -1.8979900360107422e+01 2.5343799591064453e+01 -2.9530999755859375e+02 -5.3384203910827637e+00 2.7151700973510742e+01 -2.9531600952148438e+02 -1.8997200012207031e+01 2.7145198822021484e+01 -3.2100201416015625e+02 -2.1101699829101562e+01 3.5137298583984375e+01 -2.9328799438476562e+02 2.0910200119018555e+01 2.4294300079345703e+00 -2.9423498535156250e+02 2.1436700820922852e+01 7.9212093353271484e+00 -2.9331600952148438e+02 2.0680099487304688e+01 8.3790197372436523e+00 -2.9299798583984375e+02 -2.0043001174926758e+01 9.4347801208496094e+00 -2.9360397338867188e+02 -2.1064100265502930e+01 6.5731902122497559e+00 -2.9292398071289062e+02 -2.0053699493408203e+01 6.0825400352478027e+00 -2.9389501953125000e+02 2.1500699996948242e+01 -1.8998600542545319e-02 -2.9521200561523438e+02 -2.1496000289916992e+01 1.2589699745178223e+01 -2.9308599853515625e+02 1.2501699447631836e+01 2.2134401321411133e+01 -2.9326998901367188e+02 1.9039999008178711e+01 2.3525598526000977e+01 -2.9326998901367188e+02 7.7019100189208984e+00 2.3525899887084961e+01 -2.9362100219726562e+02 1.8922399520874023e+01 -3.0231399536132812e+01 -2.9341098022460938e+02 1.9731498718261719e+01 -2.8019500732421875e+01 -2.9327801513671875e+02 1.8965499877929688e+01 -2.7515899658203125e+01 -3.1907498168945312e+02 -2.0976200103759766e+01 3.5905399322509766e+01 -2.9638900756835938e+02 2.1148000717163086e+01 -3.2614101409912109e+01 -3.5573199462890625e+02 -1.9215301513671875e+01 -1.3810099601745605e+01 -3.5643301391601562e+02 -1.9833499908447266e+01 -1.1759099960327148e+01 -3.0430902099609375e+02 -1.8555899858474731e+00 -4.0844600677490234e+01 -3.0249200439453125e+02 1.1829500198364258e+01 -4.0658897399902344e+01 -3.0264498901367188e+02 -1.8771400451660156e+01 -4.0680099487304688e+01 -3.1430798339843750e+02 1.9702499389648438e+01 -3.9203201293945312e+01 -3.1984500122070312e+02 2.0591798782348633e+01 -3.7447299957275391e+01 -3.4647000122070312e+02 -2.1216400146484375e+01 2.4975999832153320e+01 -3.4159402465820312e+02 -2.1077899932861328e+01 2.9460500717163086e+01 -3.4637698364257812e+02 -2.0909101486206055e+01 2.6118799209594727e+01 -3.5209399414062500e+02 -2.0018499374389648e+01 2.0471300125122070e+01 -3.5347900390625000e+02 -2.0099201202392578e+01 1.8154300689697266e+01 -3.3030599975585938e+02 -1.8848699569702148e+01 -3.6203102111816406e+01 -2.9343099975585938e+02 -1.9761400222778320e+01 -2.8140600204467773e+01 -2.9422500610351562e+02 -2.0539600372314453e+01 -3.0411399841308594e+01 -2.9426599121093750e+02 -1.9398899078369141e+01 -3.2816200256347656e+01 -3.5261300659179688e+02 -1.8655199050903320e+01 -1.9787799835205078e+01 -3.5268099975585938e+02 1.8645401000976562e+01 -1.9713500976562500e+01 -3.5036099243164062e+02 -1.8625799179077148e+01 -2.3007801055908203e+01 -3.4930398559570312e+02 -2.0009599685668945e+01 2.4183099746704102e+01 -3.5157498168945312e+02 -1.9090700149536133e+01 2.1532600402832031e+01 -3.0346600341796875e+02 1.4679299354553223e+01 -4.0783000946044922e+01 -3.1395199584960938e+02 -1.9701200485229492e+01 3.6567798614501953e+01 -3.1672497558593750e+02 -2.0192699432373047e+01 3.6717002868652344e+01 -2.9281698608398438e+02 -1.9346300125122070e+01 5.5332198143005371e+00 -2.9272000122070312e+02 -1.9442800521850586e+01 0.0000000000000000e+00 -3.2081198120117188e+02 1.0791099548339844e+01 3.7371200561523438e+01 -3.1724398803710938e+02 1.9006500244140625e+01 3.7210098266601562e+01 -3.5834698486328125e+02 -3.4417200088500977e-01 2.1963999271392822e+00 -3.5834698486328125e+02 -9.1127700805664062e+00 -1.2978600263595581e+00 -2.9685900878906250e+02 -1.8872900009155273e+01 -3.7652400970458984e+01 -3.2794897460937500e+02 -1.9750200271606445e+01 3.6587100982666016e+01 -3.2780999755859375e+02 -2.0669000625610352e+01 3.5925102233886719e+01 -3.2391699218750000e+02 -1.9712800979614258e+01 3.7130401611328125e+01 -3.5435000610351562e+02 -1.9748800277709961e+01 -1.6822799682617188e+01 -3.0676901245117188e+02 1.8752901077270508e+01 -4.0763198852539062e+01 -3.0882702636718750e+02 1.9946399688720703e+01 -4.0176700592041016e+01 -3.0496099853515625e+02 1.9614299774169922e+01 -4.0783699035644531e+01 -3.5834698486328125e+02 -1.9443500518798828e+01 -1.3041900396347046e+00 -3.5814398193359375e+02 -2.0477001190185547e+01 0.0000000000000000e+00 -3.2921002197265625e+02 1.9697200775146484e+01 3.6352500915527344e+01 -3.2421200561523438e+02 2.0156599044799805e+01 3.6847499847412109e+01 -3.2686401367187500e+02 2.0697500228881836e+01 3.6008201599121094e+01 -3.2100201416015625e+02 2.1101699829101562e+01 3.5137298583984375e+01 -2.9527600097656250e+02 2.1412799835205078e+01 1.7235700607299805e+01 -2.9540600585937500e+02 2.1568498611450195e+01 8.8543395996093750e+00 -3.5814398193359375e+02 2.0477001190185547e+01 0.0000000000000000e+00 -3.5139700317382812e+02 2.0919799804687500e+01 -2.0299098968505859e+01 -3.5380398559570312e+02 2.0627099990844727e+01 -1.6860799789428711e+01 -3.5473901367187500e+02 2.1041700363159180e+01 -1.3936400413513184e+01 -3.0888000488281250e+02 1.8775501251220703e+01 -4.0425300598144531e+01 -3.4084298706054688e+02 -1.9801599502563477e+01 3.1534000396728516e+01 -3.4271099853515625e+02 -2.0521400451660156e+01 2.9706800460815430e+01 -3.3793801879882812e+02 -2.0354099273681641e+01 3.2774002075195312e+01 -3.3154299926757812e+02 2.0306900024414062e+01 3.5360797882080078e+01 -3.2807400512695312e+02 2.0018199920654297e+01 -3.6406101226806641e+01 -3.3054299926757812e+02 1.8849498748779297e+01 -3.6133800506591797e+01 -3.3050097656250000e+02 1.9640399932861328e+01 -3.6027500152587891e+01 -2.9454800415039062e+02 -2.1165300369262695e+01 2.3529899597167969e+01 -2.9354101562500000e+02 -2.0450700759887695e+01 2.1593698501586914e+01 -2.9352999877929688e+02 -1.9945899963378906e+01 2.4132699966430664e+01 -3.5027398681640625e+02 -2.0774400711059570e+01 2.2095098495483398e+01 -2.9542700195312500e+02 2.1280000686645508e+01 -2.4923398971557617e+01 -3.4608398437500000e+02 -1.9849899291992188e+01 2.7569898605346680e+01 -2.9817001342773438e+02 2.0221099853515625e+01 -3.8348499298095703e+01 -3.0135400390625000e+02 1.9679300308227539e+01 -4.0253299713134766e+01 -3.5280999755859375e+02 2.1489599227905273e+01 1.4429300308227539e+01 -3.3125497436523438e+02 -1.9740200042724609e+01 3.5798099517822266e+01 -3.5258599853515625e+02 1.9049900054931641e+01 -2.0097499847412109e+01 -3.5518099975585938e+02 1.9193099975585938e+01 -1.5135700225830078e+01 -2.9447100830078125e+02 1.9673799514770508e+01 -3.3245998382568359e+01 -2.9600598144531250e+02 1.9808300018310547e+01 -3.6304397583007812e+01 -3.4952700805664062e+02 1.9592401504516602e+01 -2.4081501007080078e+01 -3.4875802612304688e+02 2.0456298828125000e+01 -2.4366399765014648e+01 -3.4627999877929688e+02 1.9539398193359375e+01 -2.7475700378417969e+01 -2.9445999145507812e+02 -2.1392999649047852e+01 -1.2102700233459473e+01 -2.9513601684570312e+02 -2.1514900207519531e+01 -1.1265500068664551e+01 -3.5333898925781250e+02 2.0614799499511719e+01 1.7745698928833008e+01 -3.5506399536132812e+02 2.0054599761962891e+01 1.5079500198364258e+01 -3.3875900268554688e+02 1.9763700485229492e+01 -3.2741302490234375e+01 -3.3436099243164062e+02 1.8835599899291992e+01 -3.4935298919677734e+01 -3.3937298583984375e+02 1.8953699111938477e+01 -3.2561100006103516e+01 -3.5607598876953125e+02 -2.1692899703979492e+01 1.2645499706268311e+00 -3.5703500366210938e+02 -2.1400499343872070e+01 3.8565700054168701e+00 -3.5773199462890625e+02 -2.1037698745727539e+01 1.6897399425506592e+00 -2.9437301635742188e+02 -2.1436899185180664e+01 -9.0840997695922852e+00 -3.2101800537109375e+02 -1.8829700469970703e+01 3.7369998931884766e+01 -3.2140600585937500e+02 -1.7583400726318359e+01 3.7368499755859375e+01 -3.2482299804687500e+02 -1.8929100036621094e+01 3.7224697113037109e+01 -2.9354000854492188e+02 -2.0930999755859375e+01 -8.1252498626708984e+00 -3.4674700927734375e+02 2.0832700729370117e+01 2.5924900054931641e+01 -2.9987200927734375e+02 -2.0180599212646484e+01 -3.9411300659179688e+01 -3.0491702270507812e+02 2.0618099212646484e+01 -3.9998798370361328e+01 -3.4606100463867188e+02 1.9925899505615234e+01 2.7537700653076172e+01 -3.1801300048828125e+02 -1.9320600509643555e+01 3.7224300384521484e+01 -3.2061801147460938e+02 -2.0167699813842773e+01 3.7003498077392578e+01 -3.0369299316406250e+02 -2.0773601531982422e+01 3.2077201843261719e+01 -3.0207397460937500e+02 -1.9697500228881836e+01 3.2151699066162109e+01 -3.1690100097656250e+02 1.9549200057983398e+01 3.7093200683593750e+01 -3.5792898559570312e+02 -2.0122098922729492e+01 -5.3060798645019531e+00 -3.4812399291992188e+02 2.1213899612426758e+01 -2.3536401748657227e+01 -3.4604098510742188e+02 2.0502298355102539e+01 -2.7044799804687500e+01 -3.5003997802734375e+02 2.1177700042724609e+01 2.1476499557495117e+01 -3.5280902099609375e+02 2.1289100646972656e+01 1.6794000625610352e+01 -3.5586898803710938e+02 -2.1644498825073242e+01 4.0399899482727051e+00 -3.5662799072265625e+02 -2.1450700759887695e+01 5.7333002090454102e+00 -3.5763000488281250e+02 -2.0915899276733398e+01 3.9535799026489258e+00 -3.1959799194335938e+02 -2.1012901306152344e+01 -3.6637500762939453e+01 -3.1159500122070312e+02 -2.0971199035644531e+01 -3.8243301391601562e+01 -3.0844598388671875e+02 -2.1047599792480469e+01 -3.8234199523925781e+01 -3.3399002075195312e+02 -2.0463300704956055e+01 3.4382102966308594e+01 -2.9550701904296875e+02 -2.1220600128173828e+01 -2.8668201446533203e+01 -2.9457199096679688e+02 -2.1510900497436523e+01 8.2121295928955078e+00 -2.9417800903320312e+02 -2.1533100128173828e+01 3.1188600063323975e+00 -2.9334899902343750e+02 -1.8914800643920898e+01 -2.8487800598144531e+01 -2.9388699340820312e+02 -1.8902101516723633e+01 -3.1506698608398438e+01 -3.5596401977539062e+02 2.0822801589965820e+01 1.1559199333190918e+01 -2.9289599609375000e+02 1.9868801116943359e+01 6.6371603012084961e+00 -2.9544500732421875e+02 1.9908800125122070e+01 2.7024900436401367e+01 -2.9491497802734375e+02 2.1063600540161133e+01 2.4867498397827148e+01 -2.9605697631835938e+02 2.1032400131225586e+01 2.6281299591064453e+01 -3.5476400756835938e+02 -2.1436000823974609e+01 1.1820499420166016e+01 -2.9351300048828125e+02 2.0482898712158203e+01 2.2125499725341797e+01 -2.9305499267578125e+02 1.9228498458862305e+01 1.8848798751831055e+01 -2.9341900634765625e+02 2.0416299819946289e+01 1.8378601074218750e+01 -2.9315502929687500e+02 -1.9007801055908203e+01 -2.4923398971557617e+01 -2.9310501098632812e+02 -1.9728700637817383e+01 -1.7640798568725586e+01 -2.9364498901367188e+02 -2.0444400787353516e+01 -2.4939100265502930e+01 -3.5650100708007812e+02 2.1465898513793945e+01 5.8667902946472168e+00 -3.5503100585937500e+02 2.1411300659179688e+01 1.1534199714660645e+01 -3.1990600585937500e+02 2.0899099349975586e+01 3.6170799255371094e+01 -3.1497799682617188e+02 2.0311800003051758e+01 3.6380802154541016e+01 -2.9642700195312500e+02 -2.6864600181579590e+00 -3.7169200897216797e+01 -3.5826901245117188e+02 1.9396200180053711e+01 -2.7868998050689697e+00 -3.5834698486328125e+02 1.9420801162719727e+01 -1.3041900396347046e+00 -3.5808102416992188e+02 2.0524499893188477e+01 -1.9851101636886597e+00 -3.4434597778320312e+02 2.1216800689697266e+01 2.6880199432373047e+01 -3.2735400390625000e+02 2.0929399490356445e+01 -3.5480102539062500e+01 -2.9309799194335938e+02 1.9990001678466797e+01 1.4655200004577637e+01 -3.5818298339843750e+02 -1.0875799655914307e+00 -3.8518300056457520e+00 -3.5834698486328125e+02 1.3966799736022949e+01 -1.2978600263595581e+00 -3.5647900390625000e+02 1.9250000000000000e+01 1.1819000244140625e+01 -3.5481399536132812e+02 1.9181400299072266e+01 1.5933800697326660e+01 -2.9740899658203125e+02 -1.9789999008178711e+01 2.8850900650024414e+01 -2.9899902343750000e+02 -2.0753999710083008e+01 2.9213399887084961e+01 -3.5760302734375000e+02 2.1160999298095703e+01 1.4570499658584595e+00 -3.3751800537109375e+02 2.1068399429321289e+01 3.1864599227905273e+01 -3.5440600585937500e+02 -2.1626298904418945e+01 5.0832700729370117e+00 -3.5589700317382812e+02 -2.1648900985717773e+01 3.7875001430511475e+00 -3.2881298828125000e+02 -1.8843299865722656e+01 3.6546699523925781e+01 -3.3228601074218750e+02 -1.8861598968505859e+01 3.5655597686767578e+01 -3.2306600952148438e+02 1.8831100463867188e+01 3.7318099975585938e+01 -3.2146701049804688e+02 -1.6176101684570312e+01 3.7370201110839844e+01 -3.5406500244140625e+02 -1.9178598403930664e+01 -1.7486400604248047e+01 -3.5185198974609375e+02 -1.9945699691772461e+01 -2.0880500793457031e+01 -3.2843899536132812e+02 2.1021301269531250e+01 3.5178100585937500e+01 -3.4762600708007812e+02 2.1344600677490234e+01 -2.2794698715209961e+01 -3.1502398681640625e+02 -1.8796300888061523e+01 -3.9231098175048828e+01 -3.0888000488281250e+02 -1.3805500030517578e+01 -4.0425502777099609e+01 -3.5015197753906250e+02 1.8606500625610352e+01 -2.3265600204467773e+01 -3.3998999023437500e+02 -1.9486799240112305e+01 -3.2167503356933594e+01 -3.5603298950195312e+02 2.1677200317382812e+01 2.1655900478363037e+00 -3.2813098144531250e+02 -2.5604700669646263e-02 -3.6683498382568359e+01 -3.2813098144531250e+02 5.0987601280212402e+00 -3.6683399200439453e+01 -3.5746398925781250e+02 2.0303298950195312e+01 7.3249602317810059e+00 -3.1179101562500000e+02 1.9813699722290039e+01 3.6043498992919922e+01 -3.0476300048828125e+02 -1.8768800735473633e+01 -4.0842296600341797e+01 -3.0375497436523438e+02 -1.4236000061035156e+01 -4.0810100555419922e+01 -3.5815100097656250e+02 -1.9377000808715820e+01 4.0399999618530273e+00 -3.5772000122070312e+02 -1.9327600479125977e+01 7.0548300743103027e+00 -3.5810101318359375e+02 -1.5556599617004395e+01 4.4922103881835938e+00 -3.2705398559570312e+02 1.8839099884033203e+01 3.6892498016357422e+01 -3.2893499755859375e+02 -1.1858800888061523e+01 3.6523597717285156e+01 -3.4358297729492188e+02 2.1170099258422852e+01 -2.7724300384521484e+01 -3.4299499511718750e+02 2.0763900756835938e+01 -2.9156200408935547e+01 -3.5611999511718750e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -3.5778799438476562e+02 -2.0986700057983398e+01 -2.6590199558995664e-04 -3.3586999511718750e+02 4.9580696225166321e-01 -3.4280097961425781e+01 -3.5449002075195312e+02 -2.1093299865722656e+01 1.4353300094604492e+01 -2.9463699340820312e+02 -2.0799200057983398e+01 2.4978399276733398e+01 -2.9544601440429688e+02 -1.9906999588012695e+01 2.7025600433349609e+01 -3.0488101196289062e+02 -2.1041101455688477e+01 -3.8609600067138672e+01 -3.0070498657226562e+02 -2.1078199386596680e+01 -3.7644599914550781e+01 -3.5809100341796875e+02 -1.9329900741577148e+01 -4.8850998878479004e+00 -3.5834698486328125e+02 -1.4840600013732910e+01 -1.2978600263595581e+00 -2.9499200439453125e+02 2.1715000152587891e+01 0.0000000000000000e+00 -2.9414801025390625e+02 2.1496801376342773e+01 -3.3543500900268555e+00 -2.9501699829101562e+02 2.1595598220825195e+01 -6.7908496856689453e+00 -3.2797500610351562e+02 -2.0812900543212891e+01 -3.5661102294921875e+01 -3.2473400878906250e+02 -2.0942600250244141e+01 -3.5960800170898438e+01 -3.2769702148437500e+02 -2.1112899780273438e+01 -3.4492401123046875e+01 -2.9298898315429688e+02 -2.0142499923706055e+01 -7.6051497459411621e+00 -2.9599801635742188e+02 -2.0920900344848633e+01 2.6439599990844727e+01 -3.5754998779296875e+02 1.9198099136352539e+01 7.9628500938415527e+00 -3.5651300048828125e+02 1.9896200180053711e+01 1.1456799507141113e+01 -3.4111599731445312e+02 -2.1202299118041992e+01 -2.8984800338745117e+01 -2.9318899536132812e+02 1.9989601135253906e+01 -1.8623899459838867e+01 -2.9301397705078125e+02 1.9255699157714844e+01 -1.6637100219726562e+01 -2.9315502929687500e+02 1.9007801055908203e+01 -2.4923398971557617e+01 -2.9862402343750000e+02 2.0614500045776367e+01 2.9065099716186523e+01 -3.0196899414062500e+02 1.9748498916625977e+01 3.2083000183105469e+01 -2.9710098266601562e+02 1.9892801284790039e+01 2.8552400588989258e+01 -2.9366101074218750e+02 2.0477399826049805e+01 2.3110700607299805e+01 -3.0232000732421875e+02 2.0738700866699219e+01 3.1372398376464844e+01 -3.0861099243164062e+02 2.0884700775146484e+01 -3.9078899383544922e+01 -3.5606301879882812e+02 -2.0713399887084961e+01 1.1461899757385254e+01 -3.0955801391601562e+02 -1.9846300125122070e+01 -4.0090198516845703e+01 -3.3147698974609375e+02 2.1130699157714844e+01 -3.3505802154541016e+01 -2.9286599731445312e+02 -2.0144500732421875e+01 2.0268700122833252e+00 -2.9316000366210938e+02 -2.0815498352050781e+01 -2.5017300248146057e-01 -3.5429299926757812e+02 -1.8833799362182617e+01 -1.6851200103759766e+01 -2.9301699829101562e+02 -2.0011701583862305e+01 -1.0951999664306641e+01 -2.9293600463867188e+02 -1.9169601440429688e+01 -1.2381299972534180e+01 -3.0861300659179688e+02 -2.0877300262451172e+01 -3.9086498260498047e+01 -3.4602200317382812e+02 -2.1209100723266602e+01 -2.5532299041748047e+01 -2.9335998535156250e+02 -2.0292200088500977e+01 -1.8246900558471680e+01 -2.9511599731445312e+02 -2.1624200820922852e+01 -5.2132701873779297e+00 -2.9801397705078125e+02 1.9363100051879883e+01 -3.8681102752685547e+01 -2.9636300659179688e+02 1.8934900283813477e+01 -3.7104099273681641e+01 -2.9401000976562500e+02 2.1180299758911133e+01 -1.1817700386047363e+01 -2.9377099609375000e+02 1.8889099121093750e+01 2.5117799758911133e+01 -2.9531600952148438e+02 1.8997200012207031e+01 2.7145198822021484e+01 -3.2813098144531250e+02 -1.8840799331665039e+01 -3.6683399200439453e+01 -3.2379800415039062e+02 -1.8826000213623047e+01 -3.7523998260498047e+01 -3.5837200927734375e+02 1.8921699523925781e+01 -2.0907101035118103e-01 -3.1051901245117188e+02 -2.1018600463867188e+01 3.4418601989746094e+01 -3.5834698486328125e+02 9.1127700805664062e+00 -1.2978600263595581e+00 -3.4554800415039062e+02 1.8992599487304688e+01 -2.8222999572753906e+01 -3.4229498291015625e+02 1.9781700134277344e+01 -3.0575700759887695e+01 -3.4187100219726562e+02 1.8969900131225586e+01 -3.0999300003051758e+01 -3.5589700317382812e+02 2.1648900985717773e+01 3.7875001430511475e+00 -3.0598898315429688e+02 -1.8919500350952148e+01 3.4270000457763672e+01 -3.0674298095703125e+02 2.0300998687744141e+01 3.4072601318359375e+01 -2.9420501708984375e+02 2.1496000289916992e+01 4.6709599494934082e+00 -3.3512399291992188e+02 -1.9611301422119141e+01 3.4523300170898438e+01 -3.0652801513671875e+02 3.9767501354217529e+00 -4.0787200927734375e+01 -3.0504797363281250e+02 1.8768699645996094e+01 -4.0841899871826172e+01 -3.5642001342773438e+02 -1.9835100173950195e+01 1.1765600204467773e+01 -3.1605099487304688e+02 -1.9000099182128906e+01 3.7082500457763672e+01 -3.2092401123046875e+02 -1.8829700469970703e+01 3.7369899749755859e+01 -3.0149398803710938e+02 -2.0793701171875000e+01 -3.9310699462890625e+01 -2.9745401000976562e+02 -2.0954299926757812e+01 -3.6376899719238281e+01 -2.9460299682617188e+02 1.8884201049804688e+01 -3.3892700195312500e+01 -2.9364801025390625e+02 -2.1200399398803711e+01 -3.3317599296569824e+00 -3.0004901123046875e+02 2.1085699081420898e+01 2.9257400512695312e+01 -3.0743301391601562e+02 2.1191900253295898e+01 3.2060798645019531e+01 -3.5812500000000000e+02 -1.9712200164794922e+01 4.0400400161743164e+00 -3.4259600830078125e+02 1.8944200515747070e+01 3.0526500701904297e+01 -3.3932098388671875e+02 1.8908899307250977e+01 3.2588001251220703e+01 -3.5827999877929688e+02 1.4844900131225586e+01 2.6031599044799805e+00 -2.9566799926757812e+02 2.1223400115966797e+01 -2.8238401412963867e+01 -2.9687802124023438e+02 2.1269298553466797e+01 2.5534101486206055e+01 -2.9537899780273438e+02 2.1328498840332031e+01 2.2141799926757812e+01 -3.1321200561523438e+02 1.8844200134277344e+01 3.6570499420166016e+01 -3.0418200683593750e+02 2.7969000339508057e+00 3.3395500183105469e+01 -3.0206799316406250e+02 -1.8914899826049805e+01 3.2236999511718750e+01 -3.3626800537109375e+02 1.8883199691772461e+01 3.4117500305175781e+01 -3.3267700195312500e+02 1.8861499786376953e+01 3.5520301818847656e+01 -3.1994699096679688e+02 -5.1878199577331543e+00 3.7359901428222656e+01 -3.5688998413085938e+02 -1.9271200180053711e+01 1.0455399513244629e+01 -3.5834698486328125e+02 -1.9420801162719727e+01 -1.3041900396347046e+00 -2.9864199829101562e+02 -1.8773300170898438e+01 -3.9216201782226562e+01 -2.9410897827148438e+02 -2.1056200027465820e+01 1.8797698974609375e+01 -3.4948599243164062e+02 -1.9572900772094727e+01 -2.4137399673461914e+01 -3.4397198486328125e+02 -1.8960100173950195e+01 2.9512298583984375e+01 -3.4822100830078125e+02 -1.9023900985717773e+01 2.5644699096679688e+01 -3.5030999755859375e+02 -2.0830198287963867e+01 -2.1956499099731445e+01 -3.5796899414062500e+02 2.0331899642944336e+01 3.9482898712158203e+00 -3.5751400756835938e+02 2.0967201232910156e+01 3.7875001430511475e+00 -3.5836999511718750e+02 1.9432199478149414e+01 -6.5209698677062988e-01 -3.2050897216796875e+02 1.9792100906372070e+01 3.7196098327636719e+01 -3.5790100097656250e+02 2.0170999526977539e+01 -5.3803701400756836e+00 -2.9315502929687500e+02 1.9048400878906250e+01 2.2833799362182617e+01 -3.5727999877929688e+02 -2.0736299514770508e+01 6.9037899971008301e+00 -3.4454000854492188e+02 -1.8609199523925781e+01 -2.8952798843383789e+01 -3.5209597778320312e+02 -2.0996799468994141e+01 1.8986598968505859e+01 -3.5839300537109375e+02 1.9443500518798828e+01 0.0000000000000000e+00 -3.5834698486328125e+02 1.9420801162719727e+01 1.3042000532150269e+00 -2.9879199218750000e+02 -1.8950899124145508e+01 3.0093799591064453e+01 -2.9293899536132812e+02 1.9302200317382812e+01 -1.2291600227355957e+01 -3.3834799194335938e+02 -2.1032199859619141e+01 3.1538900375366211e+01 -3.3006600952148438e+02 2.0704399108886719e+01 -3.5360500335693359e+01 -3.3085998535156250e+02 2.1028799057006836e+01 -3.4449699401855469e+01 -3.2315701293945312e+02 -2.0186399459838867e+01 -3.7215400695800781e+01 -3.2810000610351562e+02 -1.9724100112915039e+01 -3.6536201477050781e+01 -3.4930801391601562e+02 1.9034198760986328e+01 -2.4420200347900391e+01 -2.9450000000000000e+02 2.1250600814819336e+01 1.9632299423217773e+01 -2.9291299438476562e+02 -2.0182098388671875e+01 -3.5791299343109131e+00 -3.1092599487304688e+02 -1.8853700637817383e+01 3.6003196716308594e+01 -2.9439099121093750e+02 2.1284301757812500e+01 1.6522699356079102e+01 -2.9342898559570312e+02 -2.0489299774169922e+01 1.7059600830078125e+01 -2.9344201660156250e+02 -2.0672800064086914e+01 1.2770199775695801e+01 -3.2769702148437500e+02 2.1112899780273438e+01 -3.4492401123046875e+01 -2.9540399169921875e+02 -2.1068399429321289e+01 -3.1504400253295898e+01 -3.0506597900390625e+02 -2.0638999938964844e+01 -3.9955097198486328e+01 -3.3741699218750000e+02 2.1109699249267578e+01 -3.1682901382446289e+01 -3.3869998168945312e+02 2.0800600051879883e+01 -3.1858600616455078e+01 -3.5179098510742188e+02 2.0019300460815430e+01 -2.0903600692749023e+01 -2.9362899780273438e+02 2.0801599502563477e+01 1.4327899932861328e+01 -3.3454299926757812e+02 2.0316301345825195e+01 -3.4356002807617188e+01 -3.5110101318359375e+02 -2.1267099380493164e+01 -1.9590099334716797e+01 -2.9847100830078125e+02 1.8778600692749023e+01 2.9873401641845703e+01 -2.9463601684570312e+02 2.1392398834228516e+01 -1.4212500572204590e+01 -2.9499200439453125e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9411700439453125e+02 -2.1560701370239258e+01 -4.4470497965812683e-01 -3.3192501831054688e+02 2.1169300079345703e+01 3.3075298309326172e+01 -3.4372698974609375e+02 2.1261499404907227e+01 2.6730300903320312e+01 -3.5434899902343750e+02 1.9749300003051758e+01 -1.6822698593139648e+01 -3.3484100341796875e+02 1.9469400405883789e+01 -3.4661800384521484e+01 -3.2450000000000000e+02 2.0966499328613281e+01 -3.5923599243164062e+01 -2.9310598754882812e+02 1.9056501388549805e+01 2.2132900238037109e+01 -3.5648999023437500e+02 2.0910301208496094e+01 -9.5198602676391602e+00 -3.5628799438476562e+02 2.0098001480102539e+01 -1.1975999832153320e+01 -2.9304901123046875e+02 -1.9753999710083008e+01 1.5128799438476562e+01 -3.1738702392578125e+02 -2.0613300323486328e+01 -3.7891799926757812e+01 -2.9470898437500000e+02 2.1455999374389648e+01 1.1961799621582031e+01 -3.3017901611328125e+02 5.0834503173828125e+00 -3.6240398406982422e+01 -3.3655700683593750e+02 -1.8886299133300781e+01 3.3996196746826172e+01 -3.0234500122070312e+02 1.8929800033569336e+01 -4.0626998901367188e+01 -3.2813098144531250e+02 1.8840799331665039e+01 -3.6683399200439453e+01 -3.3484201049804688e+02 -1.9465299606323242e+01 -3.4663200378417969e+01 -3.4947399902343750e+02 1.8960500717163086e+01 2.4254400253295898e+01 -3.2469497680664062e+02 1.9346300125122070e+01 3.7166999816894531e+01 -3.4057501220703125e+02 -1.8921199798583984e+01 3.1855899810791016e+01 -3.5834698486328125e+02 -9.0900001525878906e+00 -1.2978600263595581e+00 -2.9367599487304688e+02 2.0488698959350586e+01 -2.5060199737548828e+01 -3.5834698486328125e+02 9.0900001525878906e+00 -1.2978600263595581e+00 -2.9482702636718750e+02 -2.0255800247192383e+01 -3.3309799194335938e+01 -3.0476599121093750e+02 1.8768800735473633e+01 -4.0842296600341797e+01 -3.5834698486328125e+02 -5.1512403488159180e+00 -1.2978600263595581e+00 -2.9324700927734375e+02 -2.0800300598144531e+01 3.6718399524688721e+00 -2.9344400024414062e+02 1.9818399429321289e+01 2.4002199172973633e+01 -3.2935699462890625e+02 1.1955900192260742e+01 3.6433799743652344e+01 -3.4562899780273438e+02 1.8982200622558594e+01 2.8123498916625977e+01 -3.4391098022460938e+02 1.8453798294067383e+01 -2.9462400436401367e+01 -3.5237399291992188e+02 1.9291599273681641e+01 2.0367198944091797e+01 -3.5834698486328125e+02 5.1512403488159180e+00 -1.2978600263595581e+00 -3.5834698486328125e+02 0.0000000000000000e+00 -1.2978600263595581e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2994 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01) (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01) (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01) (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01) (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_wrist_flex_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_wrist_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 3 4 0 4 72 0 72 248 0 0 2 3 1 0 248 1 270 2 270 410 2 2 410 3 4 3 294 410 294 3 294 410 454 410 324 454 270 325 410 324 410 325 269 270 1 270 269 79 79 325 270 324 325 20 325 79 21 20 325 21 21 79 23 79 318 23 79 269 318 318 269 407 318 407 23 407 194 196 407 148 23 269 194 407 194 195 196 194 338 195 269 445 194 329 338 194 445 329 194 445 269 1 72 329 445 248 72 445 248 445 1 329 330 331 72 330 329 329 331 338 72 4 330 444 330 4 331 330 444 331 337 338 494 337 331 331 444 494 494 444 4 494 4 273 337 494 273 338 337 311 273 311 337 96 272 273 273 272 311 96 273 4 310 311 149 149 311 317 311 272 317 310 338 311 338 310 447 338 447 195 310 149 195 310 195 447 147 148 149 195 149 148 317 124 149 147 149 124 148 147 403 147 464 403 124 464 147 473 148 474 474 148 403 23 148 473 474 403 464 467 473 474 467 474 95 95 474 464 467 23 473 21 23 24 24 23 467 95 24 467 462 24 95 21 24 462 141 462 202 462 95 203 203 202 462 462 141 21 201 202 203 396 141 202 201 396 202 197 201 203 197 203 95 396 201 197 396 197 414 141 396 475 396 414 475 197 95 189 414 197 189 476 414 369 369 414 189 475 414 476 142 475 476 141 475 142 142 476 369 80 142 369 402 369 189 402 80 369 80 141 142 381 21 141 441 141 39 141 80 39 381 141 441 380 381 382 380 21 381 381 441 382 38 382 441 39 38 441 38 39 40 39 80 40 38 40 466 466 306 38 382 38 306 306 380 382 380 379 21 380 306 379 21 379 326 379 306 326 326 327 22 326 22 21 326 306 327 20 21 22 22 327 20 70 71 20 327 70 20 71 324 20 70 327 339 71 70 339 71 295 294 71 294 324 71 159 295 339 159 71 294 454 324 294 295 296 294 296 4 296 295 302 158 302 295 159 158 295 296 302 4 96 4 97 97 4 302 97 302 303 303 302 158 158 159 160 158 160 328 328 303 158 303 317 272 272 97 303 328 317 303 96 97 272 328 6 317 125 317 144 317 5 144 317 6 5 317 125 124 6 328 160 5 6 7 73 6 160 6 73 7 73 74 7 74 264 7 7 264 5 73 313 74 74 313 214 264 74 214 214 5 264 214 215 5 408 215 214 214 313 408 73 257 313 313 257 409 313 409 408 408 409 191 408 191 215 409 257 261 409 261 191 261 257 262 261 314 191 261 262 314 262 256 314 257 256 262 314 256 461 314 461 191 255 256 257 256 255 461 255 104 461 191 461 104 274 255 257 255 109 104 274 109 255 274 85 109 452 274 257 452 85 274 109 110 104 85 84 109 110 109 84 83 84 85 497 85 452 85 497 83 84 453 110 84 496 453 84 83 496 497 496 83 489 496 497 99 489 497 452 99 497 496 489 453 489 260 453 260 319 453 453 319 110 489 99 258 260 489 258 99 11 100 99 100 258 99 452 11 258 259 260 100 259 258 260 259 319 259 100 319 100 11 55 54 100 55 100 54 319 54 55 56 55 389 56 55 11 389 319 54 304 54 56 304 56 389 46 56 46 304 44 46 389 389 64 44 11 64 389 44 45 46 46 45 304 63 44 64 44 63 45 11 293 64 293 63 64 478 288 63 288 45 63 478 63 293 293 13 478 11 13 293 288 478 289 478 13 289 11 12 13 78 13 12 13 78 493 13 493 289 288 289 69 289 493 69 493 68 69 493 78 68 68 60 69 60 288 69 78 35 68 35 60 68 35 36 37 60 35 37 78 36 35 36 107 108 108 440 36 36 440 37 211 107 36 211 36 78 440 120 37 60 37 120 440 108 120 108 14 120 107 213 108 108 213 14 211 213 107 211 212 213 463 65 211 211 65 212 211 78 463 213 212 14 198 212 65 14 212 198 65 66 67 463 66 65 65 67 198 198 92 14 198 67 92 32 67 263 67 66 263 67 32 92 463 263 66 263 33 32 263 463 33 32 33 34 32 34 92 33 457 458 34 33 487 487 33 458 463 457 33 34 487 92 487 458 89 487 89 92 458 90 89 458 457 90 89 90 91 91 90 457 250 251 89 91 316 89 250 89 460 460 89 57 251 92 89 316 57 89 250 459 477 251 250 477 250 460 459 251 477 145 92 251 145 145 146 92 15 92 206 92 15 14 92 146 206 146 145 477 146 477 115 115 477 459 459 460 435 459 435 115 400 404 435 57 400 435 435 292 115 435 404 292 460 57 435 57 59 400 404 400 59 59 58 404 58 292 404 57 58 59 376 374 58 58 57 376 58 374 292 372 373 374 374 290 372 373 292 374 374 376 290 290 87 372 373 372 87 373 87 86 292 373 86 86 87 88 266 87 290 88 87 266 266 290 291 376 291 290 265 266 267 265 88 266 266 291 267 88 265 86 265 267 137 265 137 86 284 285 267 267 285 76 434 267 291 76 137 267 434 284 267 392 393 284 434 392 284 285 284 393 76 285 77 492 285 393 492 77 285 42 436 393 393 436 492 392 42 393 42 392 442 434 442 392 291 442 434 442 308 42 308 442 291 41 42 43 42 308 43 436 42 41 43 308 309 309 308 376 291 376 308 309 53 43 376 53 309 53 376 51 438 51 376 438 376 57 51 52 53 43 53 52 51 438 52 315 411 438 315 438 57 438 488 52 438 411 488 316 315 57 315 316 91 411 315 91 411 91 412 411 412 488 412 52 488 412 43 52 91 43 412 457 43 91 41 43 47 47 43 413 43 457 413 413 457 463 413 78 12 413 463 78 102 413 161 413 12 161 47 413 102 101 102 103 47 102 164 161 163 102 102 101 164 163 103 102 161 162 163 450 162 161 161 12 450 419 163 162 163 323 103 419 322 163 323 163 322 450 419 162 12 351 450 352 419 450 450 351 352 246 322 419 352 246 419 322 10 323 246 10 322 103 323 443 10 115 323 323 115 443 103 443 220 443 115 220 220 101 103 101 220 165 165 220 114 115 114 220 164 101 165 164 165 166 423 165 114 166 165 423 114 115 116 423 114 424 424 114 116 166 423 271 271 423 424 164 166 271 47 164 271 177 271 178 271 175 178 175 271 424 271 177 448 448 47 271 175 424 176 424 116 176 174 175 176 178 175 174 177 178 174 484 177 174 448 177 484 395 448 181 41 47 448 448 395 41 181 448 484 433 181 484 433 484 174 432 433 174 174 176 486 486 432 174 179 433 432 179 181 433 179 180 181 395 181 180 336 179 432 180 179 336 486 336 432 486 292 336 292 486 176 335 336 86 335 425 336 425 180 336 292 86 336 425 226 180 395 180 226 425 426 224 426 425 335 224 226 425 429 335 86 429 426 335 429 428 426 428 224 426 224 225 226 49 224 427 427 224 428 49 225 224 395 226 225 225 41 395 41 225 49 98 41 49 41 98 436 169 98 48 48 98 49 169 306 98 98 306 436 386 436 306 386 77 436 492 436 77 386 387 388 75 386 388 386 75 77 387 386 306 75 76 77 437 81 75 75 81 76 388 437 75 387 437 388 306 341 387 377 437 387 387 341 377 81 437 377 81 377 378 341 378 377 340 341 306 341 340 378 340 81 378 340 490 81 306 490 340 82 490 491 490 466 491 490 306 466 490 82 81 80 81 82 82 40 80 82 491 40 40 491 466 199 200 80 80 200 394 80 402 199 394 81 80 312 199 189 189 199 402 200 199 312 200 312 394 470 394 287 312 287 394 470 81 394 312 189 286 287 312 286 286 254 287 287 254 136 495 470 287 495 287 136 135 81 470 135 470 495 136 135 495 135 136 17 17 136 254 17 254 18 286 189 254 18 254 189 17 18 19 25 17 19 135 17 25 398 135 399 398 81 135 25 399 135 399 25 19 19 18 397 397 399 19 397 18 189 397 398 399 130 397 131 130 398 397 131 397 189 130 81 398 81 130 76 129 130 131 76 130 129 137 129 131 137 131 189 129 137 76 137 189 86 344 86 189 429 86 344 344 170 345 173 344 189 173 170 344 345 429 344 345 428 429 170 421 345 345 421 428 170 171 172 173 171 170 170 172 421 171 173 189 223 342 171 171 342 172 223 171 189 342 48 172 172 347 421 50 347 172 48 50 172 421 347 428 50 346 347 346 428 347 48 49 50 49 346 50 167 48 342 169 48 167 223 167 342 167 168 169 188 167 223 188 168 167 306 169 168 168 188 243 306 168 415 168 243 415 188 189 190 188 223 189 243 188 190 243 282 418 415 243 418 282 243 190 307 415 418 307 306 415 307 418 349 349 418 282 280 306 307 221 307 349 280 307 184 184 307 221 282 222 349 222 221 349 182 221 222 182 184 221 182 183 184 183 30 184 30 280 184 30 279 280 279 306 280 306 279 327 279 159 327 327 159 339 73 159 279 159 73 160 257 73 279 257 277 297 279 277 257 452 257 297 451 452 297 452 451 11 320 348 451 281 11 451 320 451 297 350 281 451 350 451 348 11 281 12 253 252 281 253 281 151 252 12 281 350 151 281 12 252 351 252 253 216 479 252 216 351 252 479 153 216 253 151 153 253 216 217 218 153 217 216 216 218 479 479 245 351 479 234 245 218 234 479 351 245 352 245 236 246 234 236 245 245 246 352 234 235 236 334 234 218 234 334 235 235 246 236 246 235 10 333 235 334 235 333 10 334 356 333 334 218 356 354 355 356 356 355 416 417 356 416 356 417 333 218 354 356 218 217 354 354 217 355 153 355 217 355 152 244 355 244 416 152 355 153 244 431 416 431 417 416 152 230 244 230 431 244 151 152 153 152 151 230 151 229 230 229 238 230 238 431 230 238 430 431 431 430 417 237 238 229 237 480 238 480 430 238 350 237 229 151 350 229 350 155 237 155 480 237 155 481 480 480 481 430 430 481 417 154 481 155 481 154 417 154 155 156 155 350 156 156 350 348 154 156 157 348 157 156 348 320 485 157 348 485 320 297 321 485 320 321 485 321 157 119 321 117 119 157 321 297 117 321 297 276 301 297 277 276 297 301 117 117 118 119 117 301 118 119 353 157 353 119 118 118 227 228 227 118 301 118 228 353 301 276 227 360 361 227 360 227 276 227 361 228 353 228 268 228 361 268 247 353 268 247 157 353 154 157 247 154 247 268 123 154 268 332 154 134 154 113 333 113 154 332 417 154 333 134 154 205 205 154 210 123 210 154 205 132 134 209 205 210 209 132 205 208 209 210 208 210 401 401 210 123 319 132 209 208 319 209 132 133 134 132 304 133 304 132 319 122 110 319 208 122 319 122 208 401 122 401 123 122 123 110 105 110 150 471 110 123 150 110 469 105 104 110 471 469 110 471 123 268 268 469 471 268 105 469 150 469 105 104 105 106 105 299 106 299 105 268 104 106 371 191 104 371 106 299 298 106 298 371 298 299 300 300 299 268 93 268 361 268 93 300 232 93 361 232 361 360 231 186 232 232 240 93 186 240 232 231 232 360 275 231 360 275 360 276 187 186 231 187 231 275 185 186 187 185 240 186 482 187 275 482 185 187 275 276 277 275 277 482 482 483 239 239 185 482 357 482 277 482 357 483 239 240 185 420 240 239 483 420 239 483 359 420 357 359 483 357 358 359 357 279 465 358 357 465 357 277 279 358 94 359 94 420 359 94 240 420 93 94 95 240 94 93 383 95 94 358 384 94 383 94 384 384 358 465 383 384 385 384 465 439 385 384 439 27 383 385 27 26 383 383 26 95 29 385 439 27 385 29 439 30 29 439 465 30 29 30 31 29 31 28 27 29 28 26 27 28 26 28 219 219 283 26 283 95 26 31 343 28 343 219 28 31 30 233 343 31 233 343 422 219 233 422 343 283 219 422 282 95 283 242 282 283 242 283 422 189 95 190 282 190 95 95 464 93 282 242 222 241 182 242 242 182 222 422 241 242 233 241 422 241 183 182 233 183 241 233 30 183 465 279 30 300 93 127 93 464 127 140 298 300 138 140 300 367 300 127 138 300 367 138 139 140 370 140 192 140 139 192 140 370 298 370 371 298 192 371 370 191 192 193 191 371 192 192 139 193 139 215 193 215 139 138 215 191 193 215 138 368 5 215 498 368 498 215 367 368 138 368 367 498 127 498 367 498 127 5 127 128 5 144 5 128 446 127 126 128 127 446 464 126 127 143 144 128 143 128 446 143 125 144 143 126 125 446 126 143 124 125 126 124 126 464 304 305 133 304 112 305 45 112 304 305 204 133 332 204 305 112 111 305 305 111 332 133 204 134 204 332 134 111 113 332 111 112 113 112 45 406 112 406 113 113 406 365 365 333 113 45 365 406 365 366 333 365 45 366 288 366 45 366 363 333 366 364 363 288 364 366 333 249 10 363 362 333 333 362 249 362 363 364 362 364 375 456 375 364 364 288 456 288 60 456 455 449 456 456 62 455 456 60 62 449 375 456 375 449 362 362 449 249 249 449 455 62 61 455 455 61 121 121 249 455 60 61 62 120 61 60 120 121 61 120 8 121 121 8 249 120 468 8 120 14 468 8 9 10 8 10 249 468 9 8 468 14 472 9 468 472 14 15 16 14 16 278 14 278 472 9 472 390 472 278 391 390 472 391 9 390 10 390 391 10 391 115 10 16 499 391 278 16 391 499 115 391 405 16 15 405 499 16 405 15 206 207 405 206 499 405 115 405 207 115 116 115 292 207 146 115 206 146 207 176 116 292 346 49 427 346 427 428))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(2.6949899673461914e+01 -1.3321399688720703e+00 -1.4519399642944336e+01 2.7806900024414062e+01 -1.1231600046157837e+00 -1.4235500335693359e+01 2.7934198379516602e+01 -1.4776200056076050e+00 -1.4892799377441406e+01 2.6950000762939453e+01 -1.5249999761581421e+00 -1.5300000190734863e+01 2.6950000762939453e+01 1.5249999761581421e+00 -1.5300000190734863e+01 2.9449998855590820e+01 5.6033401489257812e+00 -1.1994600296020508e+01 2.9449998855590820e+01 4.4691600799560547e+00 -1.8366899490356445e+01 2.9449998855590820e+01 6.4079799652099609e+00 -1.7792999267578125e+01 4.1700000762939453e+01 5.2891001701354980e+00 1.2142200469970703e+01 4.1700000762939453e+01 4.1911201477050781e+00 1.2555100440979004e+01 4.1700000762939453e+01 2.3946001529693604e+00 9.0899496078491211e+00 2.4800001144409180e+01 1.4113900184631348e+01 5.2387599945068359e+00 2.4800001144409180e+01 5.0686402320861816e+00 6.1980595588684082e+00 2.4800001144409180e+01 1.2478300094604492e+01 9.0991601943969727e+00 2.9449998855590820e+01 3.5873501300811768e+00 1.8564199447631836e+01 2.9449998855590820e+01 1.7070800068658132e-12 1.3250000000000000e+01 2.9449998855590820e+01 9.4172596931457520e-01 1.3219099998474121e+01 4.0941303253173828e+01 -1.2944400787353516e+01 -2.7889099121093750e+00 4.1700000762939453e+01 -1.3126599311828613e+01 -1.7778500318527222e+00 4.0596401214599609e+01 -1.3072700500488281e+01 -2.1210699081420898e+00 2.9449998855590820e+01 -3.7143499851226807e+00 -1.8546400070190430e+01 2.9449998855590820e+01 -8.6656904220581055e+00 -1.6823900222778320e+01 2.9449998855590820e+01 -6.4647998809814453e+00 -1.7769500732421875e+01 2.9449998855590820e+01 -1.5027298927307129e+00 -1.3168100357055664e+01 2.9449998855590820e+01 -3.3077600002288818e+00 -1.2824199676513672e+01 3.7543899536132812e+01 -1.3026099205017090e+01 -2.3835899829864502e+00 4.1700000762939453e+01 -1.0812700986862183e+00 -4.8788895606994629e+00 4.1451499938964844e+01 -8.2713496685028076e-01 -4.9284200668334961e+00 3.6605102539062500e+01 -1.0988899469375610e+00 -4.8750300407409668e+00 3.1152399063110352e+01 -8.2713496685028076e-01 -4.9284200668334961e+00 2.4800498962402344e+01 -1.2670500278472900e+00 -4.8517098426818848e+00 2.8791999816894531e+01 -1.2358100414276123e+00 -4.8441500663757324e+00 2.9449998855590820e+01 -1.6344200372695923e+00 1.8844400405883789e+01 2.4800001144409180e+01 -3.0237698554992676e+00 1.8664899826049805e+01 2.9449998855590820e+01 -3.2595500946044922e+00 1.8619998931884766e+01 2.4800001144409180e+01 9.9735498428344727e+00 1.6064901351928711e+01 2.4800001144409180e+01 7.7365999221801758e+00 1.7259799957275391e+01 2.9449899673461914e+01 9.5353603363037109e+00 1.6332099914550781e+01 2.4800001144409180e+01 -1.3306699752807617e+01 -1.3433399200439453e+01 2.9449998855590820e+01 -1.3193599700927734e+01 -1.3537799835205078e+01 2.9449899673461914e+01 -1.4166500091552734e+01 -1.2516999244689941e+01 2.4800001144409180e+01 -7.0188102722167969e+00 3.5983300209045410e+00 2.4800001144409180e+01 -1.5630700111389160e+01 4.6948299407958984e+00 2.4800001144409180e+01 -1.2478799819946289e+01 9.9487600326538086e+00 2.9449998855590820e+01 1.7299499511718750e+01 7.6166000366210938e+00 2.9449998855590820e+01 1.1459199905395508e+01 6.6333303451538086e+00 2.9449998855590820e+01 1.7936100006103516e+01 5.9735398292541504e+00 2.4800001144409180e+01 -2.7413001060485840e+00 6.8829898834228516e+00 2.4800100326538086e+01 -4.7332797050476074e+00 -1.6327600479125977e+00 2.4800001144409180e+01 -4.9987001419067383e+00 1.7108700376411434e-06 2.5172800064086914e+01 -4.9490499496459961e+00 -7.0615899562835693e-01 2.9449998855590820e+01 -1.3733900070190430e+01 1.3003800392150879e+01 2.4800001144409180e+01 -1.3201000213623047e+01 1.3534600257873535e+01 2.4800001144409180e+01 -1.4448500633239746e+01 1.2194899559020996e+01 2.4800001144409180e+01 1.8614400863647461e+01 3.2872800827026367e+00 2.4800001144409180e+01 1.7139900207519531e+01 5.5272798538208008e+00 2.4800001144409180e+01 1.8191400527954102e+01 5.1539697647094727e+00 2.9449998855590820e+01 -7.9176297187805176e+00 1.0620200157165527e+01 2.9449998855590820e+01 -9.1493997573852539e+00 9.5894107818603516e+00 3.5463500976562500e+01 -8.6739902496337891e+00 1.0019599914550781e+01 2.9449998855590820e+01 1.0968299865722656e+01 1.5395999908447266e+01 2.9449998855590820e+01 7.0534601211547852e+00 1.1208900451660156e+01 2.9449998855590820e+01 7.9035301208496094e+00 1.0628799438476562e+01 2.9449998855590820e+01 1.6562898635864258e+01 9.1354904174804688e+00 2.4800001144409180e+01 1.7104598999023438e+01 8.0530996322631836e+00 2.4800001144409180e+01 1.3717299699783325e+00 1.8857799530029297e+01 2.4800001144409180e+01 -1.4854799681995878e-11 1.8899999618530273e+01 2.9449998855590820e+01 -1.5583599966007000e-09 1.8899999618530273e+01 2.4800001144409180e+01 1.1533399581909180e+01 1.4974200248718262e+01 2.9449998855590820e+01 1.2898599624633789e+01 1.3833900451660156e+01 2.4800001144409180e+01 -3.5367000102996826e+00 -1.8570798873901367e+01 2.4800001144409180e+01 -1.7920200824737549e+00 -1.8824199676513672e+01 2.6950000762939453e+01 -6.9327699137033960e-10 -1.3775000572204590e+01 2.4800001144409180e+01 6.1278700828552246e+00 -1.7885200500488281e+01 2.4800001144409180e+01 8.2251195907592773e+00 -1.7023900985717773e+01 2.9449899673461914e+01 -1.8800298690795898e+01 -2.0146400928497314e+00 2.9449998855590820e+01 -1.3177899360656738e+01 1.3828600645065308e+00 2.9449899673461914e+01 -1.8906700134277344e+01 4.3627300858497620e-01 2.4800001144409180e+01 7.6361198425292969e+00 1.2906599998474121e+01 2.9449899673461914e+01 -1.7853900194168091e+00 -1.4315999984741211e+01 2.9449998855590820e+01 -1.0306200027465820e+01 -8.3443403244018555e+00 2.9449998855590820e+01 -1.6965299606323242e+01 -8.3512096405029297e+00 2.9449998855590820e+01 -1.5813600540161133e+01 -1.0373899459838867e+01 2.4800001144409180e+01 1.8169099807739258e+01 -5.2433500289916992e+00 2.9449998855590820e+01 1.8230001449584961e+01 -5.0533900260925293e+00 2.4800100326538086e+01 1.7557699203491211e+01 -7.0197801589965820e+00 4.1700000762939453e+01 -9.0987195968627930e+00 3.0617098808288574e+00 4.1700000762939453e+01 -1.1873300552368164e+01 5.8653898239135742e+00 4.1700000762939453e+01 -1.2331399917602539e+01 4.8047900199890137e+00 2.9449998855590820e+01 -6.9459600448608398e+00 1.7588899612426758e+01 2.4800001144409180e+01 -6.7345299720764160e+00 1.7668100357055664e+01 2.4800001144409180e+01 -8.5615901947021484e+00 1.6858699798583984e+01 2.9449998855590820e+01 -1.5945000648498535e+00 1.3163100242614746e+01 4.1700000762939453e+01 4.2218799591064453e+00 -5.8488397598266602e+00 4.1700000762939453e+01 8.6131399869918823e-01 -4.9489803314208984e+00 4.1700099945068359e+01 -3.6179699897766113e+00 -1.2741100311279297e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.6184600830078125e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.8838399887084961e+01 2.4800001144409180e+01 -6.4720101356506348e+00 -1.8500200510025024e+00 2.4800001144409180e+01 1.5606900215148926e+01 -1.3564898967742920e+00 2.4800001144409180e+01 1.8856498718261719e+01 1.3846999406814575e+00 3.0496999740600586e+01 -6.9884502887725830e-01 4.9502301216125488e+00 2.4800001144409180e+01 1.7109100554080214e-06 4.9987001419067383e+00 3.3118000030517578e+01 3.1702800107336060e-11 4.9973497390747070e+00 2.9449998855590820e+01 1.4403300285339355e+01 -9.0918502807617188e+00 2.9449998855590820e+01 1.2218600273132324e+01 -5.1004796028137207e+00 2.9449998855590820e+01 1.1632599830627441e+01 -6.3270602226257324e+00 2.4800001144409180e+01 6.1484198570251465e+00 1.7874099731445312e+01 2.9449998855590820e+01 5.7962603569030762e+00 1.7995498657226562e+01 2.9449998855590820e+01 1.7369400024414062e+01 -7.4808998107910156e+00 2.9450099945068359e+01 1.2841000556945801e+01 -3.2295300960540771e+00 4.1044700622558594e+01 1.2410599708557129e+01 4.6027798652648926e+00 2.9449998855590820e+01 1.2081000328063965e+01 5.4132800102233887e+00 4.1700099945068359e+01 1.2073200225830078e+01 5.4324998855590820e+00 4.1366802215576172e+01 -1.3704800605773926e+00 4.8117103576660156e+00 4.1700000762939453e+01 -9.7641903162002563e-01 4.9032096862792969e+00 4.1700000762939453e+01 -1.9282399415969849e+00 4.6091599464416504e+00 2.5281700134277344e+01 4.6080799102783203e+00 -1.9345901012420654e+00 3.5064498901367188e+01 4.5723900794982910e+00 -2.0414299964904785e+00 3.2693099975585938e+01 4.7710299491882324e+00 -1.5233099460601807e+00 2.9449998855590820e+01 5.9480400085449219e+00 1.1824600219726562e+01 4.1700000762939453e+01 6.8109397888183594e+00 1.1353399276733398e+01 2.9449998855590820e+01 1.3077699661254883e+01 -2.1189999580383301e+00 4.1700000762939453e+01 1.3024199485778809e+01 -2.4528200626373291e+00 4.1700000762939453e+01 1.8967499732971191e+00 -1.3111899375915527e+01 3.2467102050781250e+01 3.5735399723052979e+00 -1.2753700256347656e+01 4.1700000762939453e+01 3.5595600605010986e+00 -1.2760800361633301e+01 4.1700000762939453e+01 5.7176399230957031e+00 -1.1947800636291504e+01 3.5498397827148438e+01 4.6924200057983398e+00 -1.2375200271606445e+01 2.9909299850463867e+01 -1.3233499526977539e+01 6.7986297607421875e-01 2.9450099945068359e+01 -1.3251099586486816e+01 -4.2760699987411499e-01 4.1700000762939453e+01 -1.3251000404357910e+01 1.1281799525022507e-02 2.9449998855590820e+01 1.3185000419616699e+01 1.3257799148559570e+00 2.9449998855590820e+01 1.3010799407958984e+01 2.4883000850677490e+00 4.1700000762939453e+01 1.3091700553894043e+01 2.0333499908447266e+00 2.9449998855590820e+01 -1.2854799270629883e+01 -3.1774599552154541e+00 3.5451599121093750e+01 -1.2673999786376953e+01 -3.8420100212097168e+00 4.1700000762939453e+01 -1.3146899223327637e+01 1.6732499599456787e+00 4.1700000762939453e+01 8.7537002563476562e+00 -9.9471302032470703e+00 3.5589797973632812e+01 9.0852098464965820e+00 -9.6500902175903320e+00 4.1700000762939453e+01 9.6044502258300781e+00 -9.1407299041748047e+00 2.9449998855590820e+01 -8.4621601104736328e+00 -1.2428799629211426e+01 2.9450099945068359e+01 -9.1007795333862305e+00 -9.6398496627807617e+00 4.0596401214599609e+01 4.4419002532958984e+00 -1.2467600822448730e+01 3.0563600540161133e+01 4.4419002532958984e+00 -1.2467600822448730e+01 3.4262798309326172e+01 -2.5802001953125000e+00 1.2989199638366699e+01 4.1700000762939453e+01 -2.0681099891662598e+00 1.3082499504089355e+01 4.1700000762939453e+01 9.5419400930404663e-01 -1.3217900276184082e+01 2.9449998855590820e+01 -1.5099000608836954e-13 -1.3250000000000000e+01 2.9449998855590820e+01 1.3475999832153320e+00 -1.3186599731445312e+01 3.0563600540161133e+01 1.2555100440979004e+01 -4.1896400451660156e+00 2.4799900054931641e+01 4.5830502510070801e+00 1.9992399215698242e+00 2.8193998336791992e+01 4.4985599517822266e+00 2.1763498783111572e+00 2.5048500061035156e+01 4.3693199157714844e+00 2.4254100322723389e+00 4.1699901580810547e+01 4.9439101219177246e+00 7.6508200168609619e-01 3.3006999969482422e+01 4.9120898246765137e+00 9.2592900991439819e-01 3.1737901687622070e+01 4.9853000640869141e+00 4.0886998176574707e-01 3.5200901031494141e+01 4.9823098182678223e+00 -4.8427399992942810e-01 2.4800001144409180e+01 1.7883800268173218e+00 -1.8824499130249023e+01 2.4800001144409180e+01 5.1598697900772095e-01 -1.4673399925231934e+01 2.4800001144409180e+01 4.3475599288940430e+00 -1.8397600173950195e+01 2.4800001144409180e+01 9.0005397796630859e-01 4.9207901954650879e+00 2.9995800018310547e+01 1.2358300685882568e+00 4.8441500663757324e+00 3.3199298858642578e+01 6.0916501283645630e-01 4.9676499366760254e+00 2.4800001144409180e+01 -8.7354403734207153e-01 4.9205598831176758e+00 3.4352897644042969e+01 -1.1120200157165527e+00 4.8720598220825195e+00 3.0656000137329102e+01 -1.3837099075317383e+00 4.8019599914550781e+00 2.5064998626708984e+01 -4.4503998756408691e+00 -2.2920100688934326e+00 2.5491998672485352e+01 -3.7973399162292480e+00 -3.2582600116729736e+00 2.4799900054931641e+01 -3.9770100116729736e+00 -3.0274100303649902e+00 3.7475002288818359e+01 -4.8703002929687500e+00 -1.1196700334548950e+00 3.3742599487304688e+01 -4.7547302246093750e+00 -1.5442498922348022e+00 3.0139801025390625e+01 -4.8750100135803223e+00 -1.1267799139022827e+00 4.1327201843261719e+01 -4.7908797264099121e+00 -1.4225100278854370e+00 3.5886898040771484e+01 -3.4335300922393799e+00 3.6457099914550781e+00 3.5273200988769531e+01 -2.7790000438690186e+00 4.1557497978210449e+00 4.1700000762939453e+01 -2.9831700325012207e+00 4.0128798484802246e+00 2.5635999679565430e+01 -3.0542199611663818e+00 3.9661097526550293e+00 2.9655099868774414e+01 -2.7790000438690186e+00 4.1557402610778809e+00 3.4228599548339844e+01 -4.2334699630737305e+00 2.6554300785064697e+00 2.5157899856567383e+01 -4.5110802650451660e+00 2.1703798770904541e+00 2.5359100341796875e+01 -3.8741300106048584e+00 3.1621801853179932e+00 3.2100597381591797e+01 -2.1571500301361084e+00 -4.5078001022338867e+00 2.9875398635864258e+01 -1.9007399082183838e+00 -4.6217598915100098e+00 2.5522800445556641e+01 -2.1281199455261230e+00 -4.5269098281860352e+00 3.3747100830078125e+01 2.4185400009155273e+00 -4.3731203079223633e+00 3.6387699127197266e+01 2.6601800918579102e+00 -4.2304801940917969e+00 2.9149299621582031e+01 2.6601800918579102e+00 -4.2304801940917969e+00 4.1377998352050781e+01 -4.2740101814270020e+00 -2.6047999858856201e+00 4.1700000762939453e+01 -4.6142601966857910e+00 -1.9129699468612671e+00 4.1700000762939453e+01 -3.8957700729370117e+00 -3.1462600231170654e+00 2.9449998855590820e+01 1.2822800636291504e+01 -1.3897599220275879e+01 2.9449998855590820e+01 9.9814195632934570e+00 -8.7158994674682617e+00 2.9450099945068359e+01 9.1288604736328125e+00 -9.6070594787597656e+00 2.8950000762939453e+01 -2.6849699352737844e-08 -1.3775000572204590e+01 2.9449998855590820e+01 4.0034601092338562e-01 -1.3321899414062500e+01 2.9449998855590820e+01 -2.5009200266268294e-10 -1.3275000572204590e+01 4.1700000762939453e+01 -6.7596302032470703e+00 -1.1387599945068359e+01 2.9449998855590820e+01 1.4829100370407104e+00 1.8850200653076172e+01 4.1700000762939453e+01 -1.0580799102783203e+01 -7.9779596328735352e+00 2.9937200546264648e+01 -1.1114899635314941e+01 -7.1989998817443848e+00 3.5727001190185547e+01 -6.5068202018737793e+00 -1.1531299591064453e+01 2.9449998855590820e+01 -5.9482998847961426e+00 -1.1826000213623047e+01 4.1699901580810547e+01 -5.4556403160095215e+00 -1.2071100234985352e+01 3.7817501068115234e+01 1.2935999870300293e+01 2.8339099884033203e+00 4.1700000762939453e+01 1.3217700004577637e+01 9.7401398420333862e-01 3.8573200225830078e+01 -1.3627499341964722e+00 1.3181200027465820e+01 4.1700000762939453e+01 -9.4658499956130981e-01 1.3215100288391113e+01 2.9449998855590820e+01 1.3217000007629395e+01 -9.6028500795364380e-01 2.9449998855590820e+01 1.3250000000000000e+01 -2.0045698620378971e-03 4.1700000762939453e+01 1.3250000000000000e+01 -3.5527100789104751e-15 2.4800001144409180e+01 3.7499701976776123e+00 1.6734001159667969e+01 2.4800001144409180e+01 3.0695300102233887e+00 1.8649799346923828e+01 2.4800100326538086e+01 4.3336400985717773e+00 1.8401800155639648e+01 2.9449998855590820e+01 9.5055303573608398e+00 -1.6344100952148438e+01 2.9449998855590820e+01 7.8296594619750977e+00 -1.0713999748229980e+01 2.5048799514770508e+01 3.8801999092102051e+00 3.1612598896026611e+00 2.9724000930786133e+01 4.2262997627258301e+00 2.6668200492858887e+00 3.8146999359130859e+01 3.8809800148010254e+00 3.1654098033905029e+00 4.1451499938964844e+01 -1.5267000198364258e+00 -4.7615299224853516e+00 3.5249900817871094e+01 -8.3708697557449341e-01 4.9267401695251465e+00 3.0807399749755859e+01 -2.4067599773406982e+00 -4.3796200752258301e+00 3.7412899017333984e+01 -2.4067599773406982e+00 -4.3796200752258301e+00 3.6807102203369141e+01 -4.6136202812194824e+00 -1.9204299449920654e+00 2.5048500061035156e+01 -4.9248199462890625e+00 8.4835904836654663e-01 2.4800001144409180e+01 -4.8660397529602051e+00 1.1375000476837158e+00 2.5794099807739258e+01 -4.7648100852966309e+00 1.5131800174713135e+00 3.6961601257324219e+01 4.2035498619079590e+00 -2.7138500213623047e+00 4.1700000762939453e+01 4.4363698959350586e+00 -2.3252601623535156e+00 2.5297100067138672e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.0038499832153320e+01 4.6136202812194824e+00 1.9204299449920654e+00 3.5120800018310547e+01 3.0078499317169189e+00 -3.9932601451873779e+00 4.1700099945068359e+01 3.1686899662017822e+00 -3.8774399757385254e+00 3.1650100708007812e+01 -1.6383399963378906e+00 -4.7211599349975586e+00 3.9070098876953125e+01 3.1667201519012451e+00 3.8768999576568604e+00 4.1700000762939453e+01 3.0313599109649658e+00 3.9810700416564941e+00 4.0736900329589844e+01 2.4746601581573486e+00 4.3486800193786621e+00 3.0236600875854492e+01 4.7997798919677734e+00 1.3912599086761475e+00 3.4741199493408203e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.1912200927734375e+01 2.0574100017547607e+00 -4.5562601089477539e+00 4.1700000762939453e+01 2.0206000804901123e+00 -4.5724501609802246e+00 3.5587699890136719e+01 -1.9007399082183838e+00 -4.6217598915100098e+00 4.0705902099609375e+01 -2.1571500301361084e+00 -4.5078001022338867e+00 3.6748802185058594e+01 -3.6158800125122070e+00 -3.4654498100280762e+00 3.3250000000000000e+01 4.4985599517822266e+00 2.1763498783111572e+00 3.4513099670410156e+01 2.3838200569152832e+00 4.3947401046752930e+00 4.1700000762939453e+01 2.0182600021362305e+00 4.5777096748352051e+00 4.1700000762939453e+01 4.9939398765563965e+00 -2.3858800530433655e-01 2.6950099945068359e+01 -6.2554597854614258e-01 -1.3902099609375000e+01 4.1700000762939453e+01 6.8182497024536133e+00 9.0122699737548828e+00 2.9449998855590820e+01 -5.0816497802734375e+00 1.2220200538635254e+01 2.9449998855590820e+01 -3.7489798069000244e+00 1.2702899932861328e+01 2.4800001144409180e+01 3.3998799324035645e+00 3.6651298999786377e+00 2.4800001144409180e+01 3.9777402877807617e+00 3.0276300907135010e+00 4.1700000762939453e+01 -1.2797200202941895e+01 -3.4067099094390869e+00 2.9449998855590820e+01 1.6111200332641602e+01 -9.8928604125976562e+00 2.9449998855590820e+01 1.5145599365234375e+01 -1.1308600425720215e+01 2.4800001144409180e+01 1.5501599311828613e+01 -1.0832400321960449e+01 2.4800001144409180e+01 1.8899999618530273e+01 1.5631900288082257e-11 2.9449998855590820e+01 1.8887401580810547e+01 9.1989201307296753e-01 2.9449998855590820e+01 1.8866199493408203e+01 -1.2389400005340576e+00 2.4800001144409180e+01 1.3872900009155273e+01 -1.2846400260925293e+01 2.6858299255371094e+01 1.4819600105285645e+01 -1.1737200736999512e+01 2.4800001144409180e+01 -1.0743399858474731e+00 1.8871101379394531e+01 2.9449998855590820e+01 7.8572101593017578e+00 -1.7191499710083008e+01 4.1700000762939453e+01 -1.2775400161743164e+01 3.4847400188446045e+00 2.9449998855590820e+01 -1.2358600616455078e+01 4.7548999786376953e+00 2.9449998855590820e+01 -1.2941699981689453e+01 2.8194899559020996e+00 4.1700000762939453e+01 1.2358300209045410e+01 -4.7434897422790527e+00 2.8943300247192383e+01 -8.4296703338623047e-01 -1.4008899688720703e+01 2.8950000762939453e+01 -1.3283500671386719e+00 -1.4550900459289551e+01 2.4800001144409180e+01 -2.1010298728942871e+00 4.5441198348999023e+00 2.9449998855590820e+01 2.0250000953674316e+00 -1.5300000190734863e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.5300000190734863e+01 2.4800001144409180e+01 1.6667301177978516e+01 -8.9205904006958008e+00 2.4800001144409180e+01 3.0401298999786377e+00 -3.9712200164794922e+00 2.4800001144409180e+01 3.5477199554443359e+00 -3.5183198451995850e+00 2.4800001144409180e+01 2.9181900024414062e+00 -5.5421199798583984e+00 2.9449998855590820e+01 2.2433400154113770e+00 1.3056299209594727e+01 2.4800001144409180e+01 -1.3477499485015869e+00 -8.0606098175048828e+00 2.4800001144409180e+01 -2.4538598060607910e+00 -4.3522100448608398e+00 2.4800001144409180e+01 5.9878001213073730e+00 3.3621299266815186e+00 4.1700099945068359e+01 -2.8946800231933594e+00 -4.0769495964050293e+00 4.1700000762939453e+01 -2.1914999485015869e+00 -4.4933600425720215e+00 2.9449998855590820e+01 -1.8301500320434570e+01 4.7207698822021484e+00 2.9449998855590820e+01 -1.8650999069213867e+01 3.0929598808288574e+00 4.1700000762939453e+01 -1.2297100067138672e+01 -4.9172501564025879e+00 4.0615600585937500e+01 -1.2106699943542480e+01 -5.3535900115966797e+00 2.9449998855590820e+01 1.4747099876403809e+01 1.1842700004577637e+01 2.4800100326538086e+01 1.4372400283813477e+01 1.2304400444030762e+01 2.9449998855590820e+01 -1.1683199882507324e+01 6.2337899208068848e+00 2.9449998855590820e+01 -1.6836900711059570e+01 8.6031103134155273e+00 4.1699901580810547e+01 -9.9462699890136719e+00 8.7587499618530273e+00 2.4800001144409180e+01 1.6276798248291016e+01 9.6195201873779297e+00 2.6950000762939453e+01 -1.5249999761581421e+00 -1.8838399887084961e+01 2.4800001144409180e+01 1.5195799479839067e-11 -1.8899999618530273e+01 2.6950000762939453e+01 -5.2957600327543930e-13 -1.8899999618530273e+01 2.4800001144409180e+01 4.4624700546264648e+00 -2.3056600093841553e+00 4.1700000762939453e+01 1.0825200080871582e+01 -7.6326203346252441e+00 4.1700000762939453e+01 1.1791600227355957e+01 -6.0317301750183105e+00 4.1700000762939453e+01 8.8994798660278320e+00 -6.7522101402282715e+00 2.4992198944091797e+01 4.2495203018188477e+00 -2.6554801464080811e+00 2.6950000762939453e+01 1.5249999761581421e+00 -1.8838399887084961e+01 2.9449998855590820e+01 2.0250000953674316e+00 -1.8791200637817383e+01 2.9449998855590820e+01 1.8390199661254883e+01 4.3643698692321777e+00 2.9449998855590820e+01 1.2689099311828613e+01 3.7930700778961182e+00 2.4800100326538086e+01 -3.2428801059722900e+00 -3.8084399700164795e+00 2.5642499923706055e+01 -2.7681601047515869e+00 -4.1631898880004883e+00 2.4800001144409180e+01 -1.6275199890136719e+01 9.6231803894042969e+00 2.4800001144409180e+01 -1.5456299781799316e+01 1.0881600379943848e+01 2.9449998855590820e+01 1.0138599872589111e+00 -1.3547200202941895e+01 2.9449998855590820e+01 1.8589400053024292e+00 -1.4446499824523926e+01 4.1700000762939453e+01 -1.1405799865722656e+01 -6.7373299598693848e+00 2.4800001144409180e+01 1.0179300308227539e+01 -1.5931799888610840e+01 2.9449998855590820e+01 1.4185699462890625e+01 -1.2493100166320801e+01 2.9449899673461914e+01 -1.0493899345397949e+01 1.5739500045776367e+01 2.9449998855590820e+01 -8.8438701629638672e+00 1.6708898544311523e+01 2.9449998855590820e+01 3.3471400737762451e+00 -1.2829800605773926e+01 2.9449699401855469e+01 -1.0802299976348877e+00 -1.3560500144958496e+01 2.9449998855590820e+01 1.8634500503540039e+01 3.1860501766204834e+00 2.4800001144409180e+01 4.9210400581359863e+00 -9.0871900320053101e-01 2.5179199218750000e+01 4.8703203201293945e+00 -1.1570299863815308e+00 4.1700000762939453e+01 1.1110500097274780e+00 4.8738498687744141e+00 4.1700000762939453e+01 2.2204498608985757e-15 5.0000000000000000e+00 2.9449998855590820e+01 -2.0250000953674316e+00 -1.8791200637817383e+01 2.9449998855590820e+01 -2.0250000953674316e+00 -1.5300000190734863e+01 2.4800001144409180e+01 -7.0885000228881836e+00 -1.7525199890136719e+01 2.4800001144409180e+01 -4.9320502281188965e+00 -1.8249200820922852e+01 2.9449998855590820e+01 2.9568200111389160e+00 -1.8670000076293945e+01 2.8037199020385742e+01 3.7343701720237732e-01 -1.3814900398254395e+01 2.6950099945068359e+01 5.4151099920272827e-01 -1.3856599807739258e+01 2.8017700195312500e+01 1.1112500429153442e+00 -1.4212800025939941e+01 4.1700000762939453e+01 1.2739599227905273e+01 3.6081001758575439e+00 4.1700000762939453e+01 1.0911499977111816e+01 7.5164599418640137e+00 4.1699802398681641e+01 3.7404100894927979e+00 3.3201501369476318e+00 4.1700000762939453e+01 -4.8871197700500488e+00 1.0520899295806885e+00 4.1700000762939453e+01 -4.5000700950622559e+00 2.1826899051666260e+00 2.8952899932861328e+01 1.3881899118423462e+00 -1.4642200469970703e+01 2.8916898727416992e+01 8.2251203060150146e-01 -1.3990099906921387e+01 2.4800001144409180e+01 -1.2620900869369507e+00 -1.7424499511718750e+01 2.4800001144409180e+01 -1.6897899627685547e+01 -8.4848995208740234e+00 2.4800001144409180e+01 -1.7877399444580078e+01 -6.1482095718383789e+00 3.1898599624633789e+01 -4.7141299247741699e+00 -1.6584600210189819e+00 3.2915996551513672e+01 -1.3707801103591919e+00 -4.8056702613830566e+00 4.1700000762939453e+01 -4.8921098709106445e+00 -1.0340999364852905e+00 4.1451499938964844e+01 -4.9257502555847168e+00 -8.4289097785949707e-01 2.5048500061035156e+01 -4.9892797470092773e+00 -2.8384402394294739e-01 2.9522100448608398e+01 -4.9651103019714355e+00 -5.6676900386810303e-01 2.4800001144409180e+01 4.9963698387145996e+00 -1.8702000379562378e-02 3.4834400177001953e+01 -2.6487700939178467e+00 -4.2376298904418945e+00 2.4799900054931641e+01 4.8941898345947266e+00 1.0495899915695190e+00 2.4800001144409180e+01 2.5379199981689453e+00 4.3056302070617676e+00 3.1059799194335938e+01 1.9007399082183838e+00 4.6217598915100098e+00 4.1700000762939453e+01 4.8502702713012695e+00 -1.2260400056838989e+00 3.7350700378417969e+01 4.2262997627258301e+00 2.6668200492858887e+00 3.2255897521972656e+01 4.3693199157714844e+00 2.4254100322723389e+00 4.1700000762939453e+01 4.3661198616027832e+00 2.4433100223541260e+00 2.4800001144409180e+01 1.1244099140167236e+00 -4.8914198875427246e+00 3.7043003082275391e+01 7.6922196149826050e-01 -4.9447102546691895e+00 3.1742300033569336e+01 1.3837099075317383e+00 -4.8019599914550781e+00 3.6150501251220703e+01 3.6216299533843994e+00 -3.4574899673461914e+00 4.1700000762939453e+01 3.8508801460266113e+00 -3.1995701789855957e+00 4.1700000762939453e+01 9.6837406158447266e+00 9.0545501708984375e+00 3.8337200164794922e+01 1.0182400703430176e+01 8.4795398712158203e+00 2.9449998855590820e+01 9.8481197357177734e+00 8.8664398193359375e+00 4.1010200500488281e+01 1.1318900108337402e+01 6.8856997489929199e+00 2.9449998855590820e+01 1.0594799995422363e+01 7.9537796974182129e+00 4.1700000762939453e+01 7.4504399299621582e+00 -1.0962599754333496e+01 3.5348602294921875e+01 7.7396798133850098e+00 -1.0753099441528320e+01 4.1700000762939453e+01 -9.0503005981445312e+00 -9.6821193695068359e+00 3.8730201721191406e+01 1.0206299781799316e+01 -8.4540300369262695e+00 2.9449998855590820e+01 1.0812399864196777e+01 -7.6491103172302246e+00 3.3401500701904297e+01 -1.1174599647521973e+01 7.1107802391052246e+00 4.1700000762939453e+01 -1.0885399818420410e+01 7.5579400062561035e+00 2.9449998855590820e+01 -1.0344099998474121e+01 8.2848396301269531e+00 3.3956699371337891e+01 9.3241205215454102e+00 9.4183301925659180e+00 2.9449998855590820e+01 -1.5550900459289551e+01 1.0775700569152832e+01 2.9449998855590820e+01 -1.7864900588989258e+01 -6.1986598968505859e+00 2.6538801193237305e+01 -1.7346000671386719e+01 -7.5152401924133301e+00 2.4800001144409180e+01 -8.6485795974731445e+00 -1.6812601089477539e+01 2.4800001144409180e+01 -9.9439496994018555e+00 -1.6074298858642578e+01 2.9449998855590820e+01 -1.0854700088500977e+01 -1.5472799301147461e+01 2.4800100326538086e+01 -1.1520800590515137e+01 -1.5003800392150879e+01 4.1700000762939453e+01 3.5527100789104751e-15 -5.0000000000000000e+00 3.4021602630615234e+01 -4.3147701944690198e-05 -5.0023598670959473e+00 3.6430900573730469e+01 -5.5283904075622559e-01 -4.9666800498962402e+00 2.4800001144409180e+01 -1.8822700500488281e+01 -1.9479199647903442e+00 2.4800001144409180e+01 -1.8387399673461914e+01 -4.3816800117492676e+00 2.7193000793457031e+01 -1.8585498809814453e+01 -3.4506700038909912e+00 2.4800001144409180e+01 1.7719398498535156e+01 6.5778098106384277e+00 4.1700000762939453e+01 3.2244198322296143e+00 1.2841400146484375e+01 4.1700000762939453e+01 2.2679700851440430e+00 1.3052400588989258e+01 2.4800001144409180e+01 -1.7905599594116211e+01 6.0784401893615723e+00 2.4800001144409180e+01 -1.8639799118041992e+01 3.2260699272155762e+00 2.9449998855590820e+01 -1.1473399162292480e+01 -6.6046400070190430e+00 2.4800498962402344e+01 -4.5277299880981445e+00 2.1901500225067139e+00 2.9449998855590820e+01 -7.0489597320556641e+00 -1.1210200309753418e+01 4.1700000762939453e+01 -1.3220399856567383e+01 -9.0833395719528198e-01 2.9449998855590820e+01 -1.3094499588012695e+01 -1.9941999912261963e+00 3.3010898590087891e+01 -1.3072700500488281e+01 -2.1210699081420898e+00 4.1079200744628906e+01 -7.6970500946044922e+00 1.0781199455261230e+01 4.0135498046875000e+01 1.3164400100708008e+01 -1.4988400936126709e+00 4.1700000762939453e+01 -9.8609600067138672e+00 -8.8514099121093750e+00 4.1700000762939453e+01 3.5527100789104751e-15 -1.3250000000000000e+01 4.1700000762939453e+01 -8.7294702529907227e+00 9.9829206466674805e+00 4.1700000762939453e+01 3.5527100789104751e-15 1.3250000000000000e+01 3.3017799377441406e+01 1.1722599983215332e+01 6.1502499580383301e+00 2.9449998855590820e+01 -4.0375900268554688e-01 -1.3321100234985352e+01 2.9449998855590820e+01 1.1093700408935547e+01 -1.5308099746704102e+01 2.4800001144409180e+01 1.1934000015258789e+01 -1.4662099838256836e+01 2.8950000762939453e+01 -1.5249999761581421e+00 -1.5300000190734863e+01 2.4800001144409180e+01 -1.0443900108337402e+01 1.5761099815368652e+01 2.4800001144409180e+01 -1.1309200286865234e+01 1.3782600402832031e+01 2.4800001144409180e+01 9.7973696887493134e-02 8.2902097702026367e+00 4.1700000762939453e+01 -7.9593696594238281e+00 -1.0588300704956055e+01 2.5110601425170898e+01 -3.3533899784088135e+00 -3.7071900367736816e+00 3.6480899810791016e+01 4.4985599517822266e+00 2.1763498783111572e+00 4.1700000762939453e+01 4.6284899711608887e+00 1.8853900432586670e+00 2.8218200683593750e+01 -3.0356299877166748e+00 -3.9726901054382324e+00 3.3556800842285156e+01 1.5057100057601929e+00 4.7671899795532227e+00 3.5859600067138672e+01 1.6510500907897949e+00 -4.7167301177978516e+00 3.4290702819824219e+01 -4.9254698753356934e+00 -8.4455001354217529e-01 3.8764202117919922e+01 -1.7710200548171997e+00 -4.6752796173095703e+00 3.5510997772216797e+01 -1.5185400247573853e+00 4.7631196975708008e+00 4.1223197937011719e+01 -2.2106401920318604e+00 4.4923200607299805e+00 3.6527599334716797e+01 -4.7948203086853027e+00 1.4180999994277954e+00 4.1176799774169922e+01 -4.9679498672485352e+00 5.9715402126312256e-01 2.5105699539184570e+01 -4.9928598403930664e+00 2.7264899015426636e-01 3.4426399230957031e+01 -5.0038399696350098e+00 -6.0524802654981613e-02 4.1700000762939453e+01 -5.0000000000000000e+00 -3.5527100789104751e-15 3.8484600067138672e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.4477100372314453e+01 4.6136202812194824e+00 1.9204299449920654e+00 4.1258998870849609e+01 -4.1352801322937012e+00 2.8180201053619385e+00 3.6688598632812500e+01 -3.9966697692871094e+00 3.0033500194549561e+00 2.9449998855590820e+01 -1.7697200775146484e+01 6.6598796844482422e+00 4.1700000762939453e+01 -6.8491501808166504e+00 1.1335199356079102e+01 2.4800001144409180e+01 -1.8899999618530273e+01 -1.5579399992304843e-09 2.9449998855590820e+01 -1.8386600494384766e+01 -4.3971800804138184e+00 2.9449998855590820e+01 -1.2079899787902832e+01 1.4545300483703613e+01 2.9606899261474609e+01 -5.5283904075622559e-01 -4.9666800498962402e+00 2.9449998855590820e+01 7.4122099876403809e+00 1.7391498565673828e+01 2.9449998855590820e+01 -1.2001500129699707e+01 -1.4610500335693359e+01 2.4800001144409180e+01 -1.7215700149536133e+01 7.8101801872253418e+00 4.0674797058105469e+01 -5.5952596664428711e-01 4.9659299850463867e+00 2.6950000762939453e+01 1.2915600538253784e+00 -1.4445000648498535e+01 2.8275600433349609e+01 -4.1702300310134888e-01 -1.3823400497436523e+01 4.1424098968505859e+01 4.6972999572753906e+00 -1.2373300552368164e+01 2.9449998855590820e+01 7.7934700250625610e-01 -1.3431300163269043e+01 2.4800001144409180e+01 -3.3469099998474121e+00 3.7231998443603516e+00 4.1700000762939453e+01 8.6985101699829102e+00 9.9949102401733398e+00 2.4800001144409180e+01 1.7519800662994385e+00 4.6830697059631348e+00 2.4800001144409180e+01 7.7306900024414062e+00 -3.6552900075912476e-01 2.4800001144409180e+01 1.3829299926757812e+01 -6.4051799774169922e+00 2.9449998855590820e+01 1.8633899688720703e+01 -3.1787199974060059e+00 2.8950000762939453e+01 -1.5249999761581421e+00 -1.8838399887084961e+01 4.1700000762939453e+01 7.7042098045349121e+00 1.0777099609375000e+01 2.9449998855590820e+01 8.7703905105590820e+00 9.9334201812744141e+00 2.4800001144409180e+01 -4.9205904006958008e+00 1.6132799148559570e+01 2.4800001144409180e+01 -5.0075902938842773e+00 1.8233800888061523e+01 4.1700000762939453e+01 -5.6207799911499023e+00 1.1992399215698242e+01 2.9449998855590820e+01 -6.5312399864196777e+00 1.1527700424194336e+01 2.9449998855590820e+01 1.4903900146484375e+01 -1.0531800270080566e+01 2.9449998855590820e+01 -4.5353097915649414e+00 -1.2442899703979492e+01 2.4800001144409180e+01 -9.2650198936462402e-01 1.5960400581359863e+01 4.1700000762939453e+01 2.5249499082565308e-01 -1.0592100143432617e+01 2.4800001144409180e+01 1.8136398693968658e-06 -4.9986000061035156e+00 2.4800001144409180e+01 -1.4857399940490723e+01 -1.1700200080871582e+01 3.5677001953125000e+01 -2.5360400676727295e+00 -1.3000300407409668e+01 2.9449998855590820e+01 4.9950399398803711e+00 1.2256999969482422e+01 3.6311599731445312e+01 1.2555100440979004e+01 -4.1896400451660156e+00 2.9449998855590820e+01 -1.2246999740600586e+01 -5.0621500015258789e+00 4.1165401458740234e+01 1.2685899734497070e+01 -3.7877101898193359e+00 2.9450099945068359e+01 3.6273798942565918e+00 1.2736200332641602e+01 3.3152999877929688e+01 -1.2918499708175659e+00 -1.3188100814819336e+01 4.1700000762939453e+01 -1.3868299722671509e+00 -1.3184299468994141e+01 2.9449998855590820e+01 -7.9923000335693359e+00 -1.0569299697875977e+01 4.1182701110839844e+01 -8.4638795852661133e+00 -1.0191899299621582e+01 4.1700000762939453e+01 -3.5744600296020508e+00 1.2749499320983887e+01 2.4800001144409180e+01 1.5480299949645996e+01 1.0846799850463867e+01 2.8154001235961914e+01 3.1742300987243652e+00 3.8707301616668701e+00 3.5253799438476562e+01 4.7997798919677734e+00 1.3912599086761475e+00 4.1451499938964844e+01 4.7997798919677734e+00 1.3912599086761475e+00 2.4800001144409180e+01 2.2216498851776123e+00 -4.4787802696228027e+00 2.5370800018310547e+01 1.8058999776840210e+00 -4.6614503860473633e+00 3.1703498840332031e+01 -3.6103398799896240e+00 3.4666299819946289e+00 2.5545600891113281e+01 4.9625401496887207e+00 -6.2990200519561768e-01 4.1699802398681641e+01 -3.5861799716949463e+00 3.4918401241302490e+00 2.9449998855590820e+01 -4.7791500091552734e+00 1.8292701721191406e+01 2.4800001144409180e+01 -1.2024999618530273e+01 1.4586599349975586e+01 2.4800001144409180e+01 1.8845800399780273e+01 -1.5313301086425781e+00 2.4800001144409180e+01 -1.6155099868774414e+01 -9.8147907257080078e+00 2.7458200454711914e+01 -1.5312899589538574e+01 -1.1099900245666504e+01 2.6681098937988281e+01 -1.8815999984741211e+01 1.8006500005722046e+00 2.4800001144409180e+01 1.2838600158691406e+01 1.3878400802612305e+01 2.7960899353027344e+01 1.4763799905776978e+00 -1.4887000083923340e+01 3.0511400222778320e+01 -1.2600000381469727e+01 -4.0787100791931152e+00 2.4800001144409180e+01 1.8584499359130859e+01 -3.4542100429534912e+00 2.4800001144409180e+01 1.7056200027465820e+01 -4.6083002090454102e+00 3.0997098922729492e+01 6.7090201377868652e+00 -1.1416500091552734e+01 4.1700000762939453e+01 9.4161397218704224e-01 1.3219099998474121e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2994 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00) (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00) (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01) (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01) (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "l_wrist_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_laser_tilt_mount_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 9.8930000000000007e+01 0.0000000000000000e+00 2.2700000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.400000 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.800000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 18 140 0 2 19 0 19 18 0 347 1 140 347 0 18 19 20 18 131 132 20 131 18 140 18 132 140 132 344 347 140 344 347 344 144 347 144 1 144 344 145 344 183 145 344 132 183 132 131 183 20 135 131 135 355 131 131 355 183 181 182 183 145 183 182 183 238 181 183 355 238 144 145 146 146 145 182 255 146 396 144 146 255 396 146 182 1 144 255 255 396 129 129 1 255 182 330 396 330 129 396 280 129 330 280 330 182 279 129 280 282 279 280 280 182 282 279 315 129 175 315 279 282 237 279 175 279 237 181 281 282 281 237 282 282 182 181 236 237 238 236 175 237 238 237 281 238 281 181 355 236 238 202 201 236 355 202 236 201 4 236 4 175 236 135 202 355 201 202 203 202 135 45 378 202 45 202 378 203 203 4 201 203 5 4 378 5 203 310 378 45 378 310 5 3 4 5 5 239 49 310 239 5 3 5 49 45 69 310 69 239 310 239 240 48 69 375 239 239 48 49 239 375 240 68 69 45 68 375 69 240 375 377 68 377 375 32 240 297 48 240 32 297 240 377 48 32 49 31 32 17 17 32 297 31 49 32 109 49 31 31 17 254 254 109 31 371 109 254 109 3 49 109 47 3 47 109 371 320 47 371 320 371 176 176 371 254 3 47 4 320 4 47 176 4 320 4 176 175 174 175 176 175 174 315 137 136 315 174 137 315 315 136 129 54 136 137 137 174 180 137 180 134 54 137 134 37 53 54 134 37 54 136 54 53 133 37 134 134 180 133 133 342 37 180 391 133 133 398 342 133 391 398 342 43 38 398 43 342 37 342 38 398 387 42 391 387 398 42 43 398 180 388 391 391 388 387 42 387 388 180 337 388 388 337 42 180 174 337 42 337 389 337 174 389 174 221 55 365 221 174 176 365 174 55 389 174 55 42 389 55 29 42 29 55 221 28 29 30 30 29 221 7 29 28 7 42 29 30 34 28 30 221 107 107 34 30 35 107 108 34 107 35 221 108 107 33 34 35 35 108 222 33 35 222 33 316 317 33 222 316 34 33 317 222 85 223 108 85 222 222 223 316 316 223 234 234 191 316 317 316 191 84 359 223 223 359 234 84 223 85 84 85 86 86 85 108 231 324 84 86 231 84 324 359 84 235 234 359 235 359 324 191 234 235 217 235 264 264 235 232 217 191 235 233 235 324 233 232 235 231 233 324 231 232 233 264 232 383 382 232 379 379 232 231 382 383 232 217 264 384 384 264 383 329 384 383 329 383 382 186 382 379 382 186 329 186 379 380 231 380 379 108 186 380 108 380 86 86 380 231 186 108 365 108 221 365 365 176 186 185 186 176 210 211 176 176 211 185 210 176 254 211 26 185 26 321 185 185 184 186 184 185 321 249 26 211 210 249 211 210 248 249 248 26 249 259 248 210 248 259 24 248 24 26 257 258 259 257 259 274 381 259 258 274 259 210 259 381 24 24 25 26 381 25 24 25 381 258 25 258 308 319 308 258 257 319 258 308 225 224 225 308 319 25 308 224 225 319 122 122 319 16 16 319 370 370 319 257 15 16 17 10 122 16 10 16 15 16 370 17 17 370 273 273 370 257 273 257 274 273 274 254 17 273 254 297 15 17 297 217 212 217 297 191 94 323 297 212 15 297 297 377 94 190 297 323 191 297 190 212 11 15 212 204 11 217 204 212 9 10 11 9 11 204 11 10 15 193 116 204 204 217 193 116 9 204 9 116 122 9 122 10 225 122 214 214 122 116 224 225 219 225 214 373 373 219 225 213 214 116 373 214 213 213 209 373 373 209 219 219 209 220 219 220 224 220 189 224 224 188 25 224 189 188 209 187 220 220 187 189 209 178 187 213 179 209 179 178 209 50 178 179 215 216 178 50 215 178 178 216 187 50 179 177 177 179 213 59 50 177 374 59 177 116 177 213 177 116 374 374 116 118 390 374 118 270 374 390 59 374 270 116 117 118 116 193 200 117 116 318 318 116 200 117 318 123 117 125 118 123 125 117 123 318 309 309 318 168 318 200 168 200 354 168 200 192 354 192 200 193 192 362 354 354 72 83 354 362 72 168 354 166 354 83 166 102 192 193 70 192 102 362 192 70 72 362 70 70 71 72 83 72 71 82 83 71 82 166 83 361 71 70 105 71 361 105 165 71 71 165 82 70 102 103 361 70 103 105 361 106 361 103 399 106 361 399 104 105 106 165 105 92 92 105 104 164 165 92 165 164 82 90 91 92 230 92 91 90 92 104 164 92 230 90 104 161 104 331 161 104 106 331 106 399 331 331 399 102 331 102 161 399 103 102 161 102 111 112 111 102 112 102 193 90 161 111 91 90 111 228 91 256 91 119 256 119 91 111 230 91 228 227 228 229 227 230 228 228 256 229 119 229 256 229 300 301 301 227 229 229 119 300 164 230 227 100 164 227 301 100 227 300 171 301 302 301 171 302 100 301 300 75 171 300 119 75 170 171 75 170 302 171 101 100 302 385 101 302 385 302 170 99 100 101 99 164 100 82 164 99 166 99 163 163 99 101 166 82 99 385 163 101 163 385 142 142 385 74 385 170 74 74 170 75 73 74 75 141 142 74 141 74 73 142 162 163 162 142 141 162 166 163 168 166 169 169 166 162 299 169 162 299 162 141 141 73 299 73 75 121 299 73 121 298 169 299 167 298 299 167 299 121 167 168 169 298 167 169 168 167 121 121 363 168 309 168 363 119 120 121 363 121 120 121 75 119 309 363 120 309 120 123 119 184 120 124 120 184 123 120 124 111 186 119 119 186 184 110 111 112 195 111 110 186 111 195 186 328 329 194 186 195 328 186 194 194 195 196 195 110 199 195 199 196 199 110 77 77 110 112 77 112 78 78 112 193 76 77 78 334 199 77 334 77 76 199 334 196 76 325 334 196 334 401 334 325 401 78 218 76 218 325 76 193 218 78 193 217 218 325 218 217 325 217 401 217 397 401 196 401 397 397 217 384 397 328 194 196 397 194 397 384 328 384 329 328 184 156 332 184 63 62 124 184 125 62 125 184 332 63 184 400 156 184 13 184 321 400 184 13 62 63 64 62 64 265 125 62 265 123 124 125 125 265 118 150 118 153 118 265 153 390 118 151 152 151 118 152 118 150 153 265 352 150 153 276 153 352 276 265 253 352 96 352 97 97 352 360 352 253 360 276 352 96 275 150 276 357 275 276 357 276 96 96 97 98 96 98 357 296 357 98 275 357 296 150 275 151 151 275 390 275 296 390 157 296 158 270 390 296 158 296 98 270 296 157 157 158 159 269 270 157 269 157 159 98 353 158 353 159 158 353 292 159 159 292 394 159 394 269 242 269 356 269 394 356 242 270 269 242 59 270 241 242 243 60 59 242 356 243 242 242 241 60 394 243 356 243 394 351 292 351 394 241 243 351 60 241 351 59 60 61 61 60 294 351 294 60 351 292 294 292 293 294 353 293 292 293 289 294 293 353 98 293 97 289 98 97 293 289 149 205 289 205 294 97 149 289 97 360 149 147 148 149 149 148 205 360 147 149 294 205 326 205 226 327 326 205 327 148 226 205 148 147 226 147 208 226 327 226 207 207 226 208 294 326 327 207 294 327 61 294 207 59 61 263 268 263 61 207 268 61 350 59 263 350 50 59 263 272 350 263 268 272 266 267 268 268 113 266 267 272 268 268 207 113 271 272 267 350 272 271 50 350 271 290 271 267 271 22 50 271 290 22 290 267 266 290 266 291 266 368 291 368 266 113 291 22 290 21 22 23 23 22 304 291 304 22 50 22 21 305 291 87 291 368 87 305 304 291 303 304 305 23 304 303 21 23 260 260 23 303 50 21 306 306 21 260 260 261 262 261 260 303 306 260 262 262 261 303 303 89 262 305 89 303 89 305 87 87 88 89 87 368 88 89 88 368 262 89 368 306 262 307 313 262 311 307 262 313 262 368 311 307 50 306 51 307 313 307 51 50 311 312 313 312 51 313 50 51 52 52 51 312 215 50 216 52 216 50 52 367 216 187 216 367 367 52 172 367 172 187 187 188 189 187 172 188 172 52 173 188 172 114 172 173 114 188 114 364 247 188 364 188 247 246 188 246 25 114 12 364 247 364 12 25 246 247 372 25 247 376 247 12 376 372 247 372 26 25 26 372 322 376 322 372 14 322 376 14 376 12 12 13 14 113 12 114 12 113 13 14 321 322 13 321 14 322 321 26 206 154 13 13 207 206 113 207 13 154 400 13 113 114 115 368 113 115 244 115 245 115 366 245 115 244 368 114 366 115 368 244 314 368 314 311 244 245 314 314 245 311 245 366 311 311 366 52 114 52 366 311 52 312 173 52 114 400 154 156 154 155 156 154 143 155 143 154 358 206 286 154 286 358 154 155 295 156 156 295 395 332 156 395 155 143 295 143 67 295 67 288 295 295 288 395 332 395 333 395 288 333 63 332 333 63 333 64 333 288 64 288 66 277 67 66 288 288 277 64 65 66 67 143 65 67 251 277 66 285 66 65 251 66 285 277 251 253 265 64 277 265 277 253 251 252 253 251 285 252 285 286 287 285 65 286 252 285 287 392 252 287 253 252 393 393 252 392 360 253 393 360 393 147 393 392 147 392 386 147 392 287 386 206 287 286 386 287 206 286 65 358 358 65 143 206 207 208 208 386 206 147 386 208 150 151 152 190 41 191 41 190 81 278 190 130 79 190 278 81 190 79 130 190 323 339 317 191 346 191 41 339 191 346 338 317 339 341 338 339 341 339 346 127 34 317 128 317 338 127 317 128 128 338 341 345 341 346 126 128 341 126 341 345 41 345 346 7 345 41 7 126 345 126 127 128 250 127 126 250 126 6 6 126 7 250 34 127 34 250 28 27 28 250 27 250 6 6 7 8 27 6 8 41 42 7 28 8 7 42 41 81 42 283 43 81 283 42 44 43 283 44 283 81 79 80 81 81 40 39 39 44 81 80 40 81 38 43 44 36 38 44 36 44 39 39 40 36 40 160 36 340 160 40 80 340 40 343 340 80 79 343 80 79 278 343 343 335 336 343 336 340 343 278 335 340 336 160 58 139 160 160 139 36 336 58 160 335 56 336 56 58 336 56 57 58 58 57 139 57 138 139 36 139 284 139 138 284 136 53 138 138 53 284 57 136 138 36 284 37 284 53 37 36 37 38 129 136 57 1 129 130 57 130 129 130 197 1 1 198 93 1 197 198 2 1 93 130 323 197 278 130 349 57 349 130 197 94 198 94 197 323 198 94 93 93 94 95 68 95 94 94 377 68 46 93 95 45 46 95 45 95 68 45 2 46 46 2 93 45 135 20 19 2 45 20 19 45 57 348 349 335 349 369 349 348 369 278 349 335 348 56 335 57 56 348 348 335 369 28 27 8 274 210 254 402 403 404 457 443 402 404 424 402 402 424 436 402 500 403 457 402 489 500 402 443 489 402 436 485 437 457 443 457 437 489 485 457 436 485 489 437 485 436 436 405 437 443 437 407 437 405 407 405 406 407 406 405 493 487 405 436 493 405 487 483 493 487 493 483 428 493 428 406 423 483 487 436 423 487 428 483 423 406 428 422 422 428 423 422 423 424 436 424 423 438 422 408 486 422 438 406 422 486 408 422 424 408 424 409 409 424 468 424 404 468 404 408 409 442 404 409 409 468 442 442 468 404 408 404 403 446 438 408 408 403 458 407 408 491 407 467 408 458 491 408 408 503 446 467 503 408 458 407 491 458 459 460 458 460 407 458 403 474 474 459 458 462 460 459 474 462 459 407 460 462 407 462 456 456 462 474 403 473 474 473 456 474 451 407 456 451 456 452 473 452 456 469 484 473 452 473 450 473 403 469 484 450 473 450 451 452 451 433 407 451 450 433 484 433 450 469 494 484 433 484 434 494 434 484 433 434 435 433 435 407 494 435 434 469 435 494 435 471 470 471 435 469 495 407 435 495 435 470 469 470 471 495 470 469 492 440 495 495 440 497 496 495 497 492 495 469 407 495 496 441 492 469 440 492 441 403 440 441 440 403 497 477 479 497 497 479 496 477 497 403 477 478 479 478 477 403 482 479 478 479 475 496 479 482 475 478 403 482 445 482 403 445 475 482 445 464 475 475 464 496 445 412 419 445 463 464 445 403 412 488 445 419 463 445 488 496 464 463 496 463 498 498 463 488 419 421 488 421 498 488 419 420 421 419 427 420 412 427 419 498 421 420 407 496 498 490 498 420 490 407 498 420 427 426 426 490 420 425 426 427 425 427 412 411 426 432 432 426 425 426 411 490 412 432 425 410 411 412 410 412 403 412 411 432 411 410 439 490 411 439 403 480 410 480 481 410 481 439 410 490 439 481 480 454 481 490 481 454 455 454 480 466 480 403 466 455 480 453 454 455 454 453 490 455 466 465 453 455 465 465 466 416 466 403 416 416 502 465 453 465 502 418 453 502 453 407 490 418 407 453 502 416 418 416 417 418 444 416 403 444 499 416 416 499 417 407 418 429 418 417 415 418 415 429 417 499 415 444 413 499 415 499 413 472 413 444 472 444 430 444 403 430 500 430 403 403 441 469 501 500 461 443 461 500 500 501 430 431 501 461 501 431 430 461 407 429 429 431 461 461 443 407 429 430 431 415 414 429 476 430 429 414 476 429 413 414 415 472 414 413 414 472 476 476 472 430 407 406 467 486 448 406 448 467 406 503 467 447 447 467 448 447 448 449 449 448 438 486 438 448 446 447 449 447 446 503 446 449 438))
                   (list :vertices (let ((mat (make-matrix 504 3))) (fvector-replace (array-entity mat) #f(-4.4124301910400391e+01 1.7580499649047852e+01 -2.3996398925781250e+02 -4.5074100494384766e+01 4.3559700012207031e+01 -2.4374000549316406e+02 -4.3870098114013672e+01 3.2852897644042969e+01 -2.3886700439453125e+02 -4.7264900207519531e+01 -4.8252098083496094e+01 -2.1758599853515625e+02 -4.3623203277587891e+01 -8.1500000000000000e+01 -2.2099200439453125e+02 -4.3302700042724609e+01 -4.1045299530029297e+01 -2.2188499450683594e+02 -7.9170005798339844e+01 2.4053800106048584e+00 -2.7973800659179688e+02 -7.4355903625488281e+01 9.1225595474243164e+00 -2.7769601440429688e+02 -7.8119300842285156e+01 -3.5373198986053467e-01 -2.7933200073242188e+02 -1.1193000030517578e+02 8.1500000000000000e+01 -2.1389999389648438e+02 -1.1125399780273438e+02 6.2145198822021484e+01 -2.1577699279785156e+02 -1.1132199859619141e+02 8.1493698120117188e+01 -2.1579200744628906e+02 -1.0962799835205078e+02 -5.9769001007080078e+01 -1.8885198974609375e+02 -1.0943000030517578e+02 -8.1500000000000000e+01 -1.8885000610351562e+02 -1.1138200378417969e+02 -6.9378395080566406e+01 -1.8957699584960938e+02 -1.0957099914550781e+02 5.9228900909423828e+01 -2.1639700317382812e+02 -1.1132099914550781e+02 4.9099800109863281e+01 -2.1572900390625000e+02 -1.0953799438476562e+02 3.4649101257324219e+01 -2.1639999389648438e+02 -4.4124301910400391e+01 -7.4283900260925293e+00 -2.3996398925781250e+02 -4.3875999450683594e+01 -8.1358498334884644e-01 -2.3886500549316406e+02 -4.3875999450683594e+01 -2.7184400558471680e+01 -2.3886500549316406e+02 -6.6897300720214844e+01 8.1500000000000000e+01 -1.7188200378417969e+02 -7.6334495544433594e+01 8.1499801635742188e+01 -1.6727699279785156e+02 -6.9130302429199219e+01 3.6068599700927734e+01 -1.7063600158691406e+02 -1.1192599487304688e+02 -2.1662199020385742e+01 -2.1401600646972656e+02 -1.1192599487304688e+02 -1.5236900329589844e+01 -1.9042700195312500e+02 -1.1193000030517578e+02 -5.4704597473144531e+01 -2.1394799804687500e+02 -7.9170005798339844e+01 -1.9561401367187500e+01 -2.7973800659179688e+02 -7.7189994812011719e+01 -3.7689998626708984e+01 -2.7899200439453125e+02 -7.0294097900390625e+01 -8.1500000000000000e+01 -2.7550698852539062e+02 -7.7714401245117188e+01 -8.1500000000000000e+01 -2.7928399658203125e+02 -5.1930000305175781e+01 -6.9129500389099121e+00 -2.1639999389648438e+02 -5.1479801177978516e+01 3.9315902709960938e+01 -2.1640100097656250e+02 -9.4034904479980469e+01 -1.0692399978637695e+01 -2.8315698242187500e+02 -8.6455101013183594e+01 -1.2597700119018555e+01 -2.8201199340820312e+02 -9.8930000305175781e+01 -8.1500000000000000e+01 -2.8331802368164062e+02 -5.8195400238037109e+01 2.3240200042724609e+01 -2.6589398193359375e+02 -5.8981498718261719e+01 -1.0722499847412109e+01 -2.6670101928710938e+02 -5.9382400512695312e+01 9.2324199676513672e+00 -2.6709698486328125e+02 -5.8588401794433594e+01 3.9140499114990234e+01 -2.6629800415039062e+02 -5.7810600280761719e+01 5.0619098663330078e+01 -2.6548300170898438e+02 -7.5262596130371094e+01 8.1499893188476562e+01 -2.7824499511718750e+02 -6.6679496765136719e+01 -3.3685199737548828e+01 -2.7323098754882812e+02 -6.0601100921630859e+01 2.2829000473022461e+01 -2.6826699829101562e+02 -5.9382400512695312e+01 2.8634700775146484e+01 -2.6709698486328125e+02 -4.2741203308105469e+01 9.3736200332641602e+00 -2.3209400939941406e+02 -4.3589900970458984e+01 5.3225700378417969e+01 -2.3748699951171875e+02 -4.9385997772216797e+01 -8.1500205993652344e+01 -2.1669900512695312e+02 -4.6906600952148438e+01 3.0302801132202148e+01 -2.1780000305175781e+02 -4.7826900482177734e+01 -3.6692798614501953e+01 -2.1723500061035156e+02 -6.3518196105957031e+01 8.1500000000000000e+01 -1.8429299926757812e+02 -6.2783897399902344e+01 3.2903701782226562e+01 -1.8282000732421875e+02 -6.5581901550292969e+01 -5.6012997627258301e+00 -1.8685699462890625e+02 -5.7810600280761719e+01 -2.2214399337768555e+01 -2.6548300170898438e+02 -5.8195503234863281e+01 -3.8185398101806641e+01 -2.6589398193359375e+02 -6.5793296813964844e+01 -8.1500000000000000e+01 -2.7255300903320312e+02 -5.5576896667480469e+01 4.4994800567626953e+01 -2.6294799804687500e+02 -5.2102497100830078e+01 2.8515298843383789e+01 -2.5833898925781250e+02 -5.6304500579833984e+01 3.6894298553466797e+01 -2.6380801391601562e+02 -1.0977199554443359e+02 8.1500000000000000e+01 -1.6417599487304688e+02 -1.1457700347900391e+02 3.6181301116943359e+01 -1.6519099426269531e+02 -1.0654000091552734e+02 -3.8164798736572266e+01 -1.6363699340820312e+02 -1.3782400512695312e+02 -2.0845899581909180e+01 -1.7647700500488281e+02 -1.3584500122070312e+02 -3.3427700042724609e+01 -1.7502600097656250e+02 -1.3469601440429688e+02 -1.0992199897766113e+01 -1.7422099304199219e+02 -1.3113400268554688e+02 -5.6084300994873047e+01 -1.7198200988769531e+02 -1.3161799621582031e+02 -2.6255800247192383e+01 -1.7226600646972656e+02 -1.3209700012207031e+02 -4.3367599487304688e+01 -1.7255699157714844e+02 -4.2633499145507812e+01 8.1500000000000000e+01 -2.2544300842285156e+02 -4.2632598876953125e+01 2.7935499191284180e+01 -2.2541999816894531e+02 -1.5962500000000000e+02 4.3845199584960938e+01 -2.1472999572753906e+02 -1.5962500000000000e+02 1.2168399810791016e+01 -2.1472999572753906e+02 -1.5957600402832031e+02 3.1287700653076172e+01 -2.1367100524902344e+02 -1.5893499755859375e+02 -6.8252700805664062e+01 -2.0841300964355469e+02 -1.5911599731445312e+02 -5.4687103271484375e+01 -2.0945799255371094e+02 -1.5900999450683594e+02 -8.1500000000000000e+01 -2.0878799438476562e+02 -1.5602500915527344e+02 2.0788499832153320e+01 -2.4257600402832031e+02 -1.5729499816894531e+02 -1.8070200681686401e+00 -2.3843499755859375e+02 -1.5738000488281250e+02 5.5397296905517578e+01 -2.3800500488281250e+02 -5.8588798522949219e+01 8.1500000000000000e+01 -2.6629702758789062e+02 -5.7810600280761719e+01 7.6972198486328125e+01 -2.6548300170898438e+02 -6.4670799255371094e+01 8.1500000000000000e+01 -2.7183398437500000e+02 -1.5957600402832031e+02 -4.0325498580932617e+00 -2.1367100524902344e+02 -1.5954499816894531e+02 1.4856699705123901e+00 -2.1314199829101562e+02 -1.1216600036621094e+02 4.6876797676086426e+00 -2.8179498291015625e+02 -1.0803399658203125e+02 -3.4509899139404297e+01 -2.8265100097656250e+02 -1.1716699981689453e+02 -5.2658599853515625e+01 -2.8034500122070312e+02 -6.6897399902343750e+01 -8.1500000000000000e+01 -1.7188200378417969e+02 -6.4097099304199219e+01 -8.1500297546386719e+01 -1.7428498840332031e+02 -6.4369995117187500e+01 -5.0874900817871094e+01 -1.7387998962402344e+02 -1.5959100341796875e+02 -3.0226501464843750e+01 -2.1870500183105469e+02 -1.5947200012207031e+02 -8.1500000000000000e+01 -2.2048400878906250e+02 -1.5965299987792969e+02 -3.2317897796630859e+01 -2.1605500793457031e+02 -4.3988800048828125e+01 8.1500000000000000e+01 -2.3939100646972656e+02 -5.0597900390625000e+01 8.1500000000000000e+01 -2.3026399230957031e+02 -4.3065799713134766e+01 8.1500000000000000e+01 -2.3438299560546875e+02 -1.2718400573730469e+02 2.2461999893188477e+01 -1.6985299682617188e+02 -1.2668099975585938e+02 4.6869599819183350e-01 -1.6960400390625000e+02 -1.2566600799560547e+02 3.8494998931884766e+01 -1.6912500000000000e+02 -1.5950100708007812e+02 -2.0375000000000000e+01 -2.1261399841308594e+02 -1.5950100708007812e+02 -4.1315998077392578e+01 -2.1261399841308594e+02 -1.5939900207519531e+02 -2.9448200225830078e+01 -2.1155899047851562e+02 -1.5948500061035156e+02 4.0513999938964844e+01 -2.2057800292968750e+02 -1.5964900207519531e+02 4.0449298858642578e+01 -2.1579000854492188e+02 -1.5963200378417969e+02 -8.8360900878906250e+00 -2.1764500427246094e+02 -1.5964900207519531e+02 2.1732499599456787e+00 -2.1579000854492188e+02 -1.5964700317382812e+02 4.9257302284240723e+00 -2.1684999084472656e+02 -8.9273605346679688e+01 -8.1500000000000000e+01 -2.8258200073242188e+02 -1.0889899444580078e+02 -8.1499893188476562e+01 -2.8253601074218750e+02 -4.9670902252197266e+01 -3.9281200408935547e+01 -2.1664700317382812e+02 -1.5715399169921875e+02 -5.7391700744628906e+01 -2.3902699279785156e+02 -1.5789300537109375e+02 -8.1500000000000000e+01 -2.3477600097656250e+02 -1.5789599609375000e+02 1.2989100456237793e+01 -2.3477700805664062e+02 -7.1469902038574219e+01 -8.1500000000000000e+01 -1.8885000610351562e+02 -7.0920600891113281e+01 -4.1905998229980469e+01 -1.8885000610351562e+02 -6.5944702148437500e+01 -8.1500205993652344e+01 -1.8733799743652344e+02 -1.1193000030517578e+02 8.1500000000000000e+01 -1.9134999084472656e+02 -1.4869200134277344e+02 8.1500000000000000e+01 -1.8707699584960938e+02 -1.3763499450683594e+02 8.1500000000000000e+01 -1.7604899597167969e+02 -1.4643199157714844e+02 -8.1500000000000000e+01 -2.1027099609375000e+02 -1.5328300476074219e+02 -8.1500000000000000e+01 -1.9368598937988281e+02 -1.5759300231933594e+02 -8.1500000000000000e+01 -2.0297999572753906e+02 -1.1193000030517578e+02 5.5892898559570312e+01 -2.1399900817871094e+02 -1.5080499267578125e+02 2.8448901176452637e+00 -1.8988500976562500e+02 -1.4785099792480469e+02 -8.1500205993652344e+01 -1.8604800415039062e+02 -1.4342900085449219e+02 7.8822204589843750e+01 -1.8122399902343750e+02 -8.0228698730468750e+01 8.5072708129882812e+00 -2.8012200927734375e+02 -8.1829696655273438e+01 -9.2501096725463867e+00 -2.8066198730468750e+02 -8.1829803466796875e+01 4.1386699676513672e+00 -2.8066198730468750e+02 -4.8996299743652344e+01 -3.8781501770019531e+01 -2.5322198486328125e+02 -4.9644298553466797e+01 8.1500000000000000e+01 -2.5448001098632812e+02 -4.4124301910400391e+01 -3.4347400665283203e+01 -2.3996398925781250e+02 -4.4394500732421875e+01 -2.3841600418090820e+01 -2.4105801391601562e+02 -6.0192199707031250e+01 -2.0100900650024414e+01 -2.6787899780273438e+02 -5.9382400512695312e+01 -3.1835899353027344e+01 -2.6709698486328125e+02 -4.3875999450683594e+01 -4.9345699310302734e+01 -2.3886500549316406e+02 -5.4808799743652344e+01 -2.6198999404907227e+01 -2.6211499023437500e+02 -5.7995899200439453e+01 -6.3762500762939453e+01 -2.6569500732421875e+02 -5.7049198150634766e+01 -5.7127799987792969e+00 -2.6465298461914062e+02 -5.7049198150634766e+01 1.7898900985717773e+01 -2.6465298461914062e+02 -4.4394500732421875e+01 4.3155403137207031e+00 -2.4105801391601562e+02 -1.5893499755859375e+02 -4.9734802246093750e+01 -2.0841300964355469e+02 -1.5911599731445312e+02 -3.6434501647949219e+01 -2.0945799255371094e+02 -1.3209700012207031e+02 -7.6972198486328125e+01 -1.7255699157714844e+02 -4.5162498474121094e+01 1.1310599327087402e+01 -2.4376599121093750e+02 -4.5000301361083984e+01 -1.6607801437377930e+01 -2.4322700500488281e+02 -4.5335597991943359e+01 -5.5005402565002441e+00 -2.4430200195312500e+02 -1.2718400573730469e+02 -4.5724399566650391e+01 -1.6985299682617188e+02 -1.2617300415039062e+02 -4.4128101348876953e+01 -1.6936399841308594e+02 -1.2617300415039062e+02 -2.4849699020385742e+01 -1.6936399841308594e+02 -1.2917800903320312e+02 4.9593299865722656e+01 -1.7088299560546875e+02 -1.2917800903320312e+02 8.0368103027343750e+01 -1.7088299560546875e+02 -1.3016099548339844e+02 6.2679203033447266e+01 -1.7142399597167969e+02 -1.2917800903320312e+02 2.2143699645996094e+01 -1.7088299560546875e+02 -1.3172499084472656e+02 -8.1500000000000000e+01 -1.7232200622558594e+02 -1.3304998779296875e+02 -7.6972198486328125e+01 -1.7315000915527344e+02 -1.3399299621582031e+02 -7.6972198486328125e+01 -1.7375900268554688e+02 -1.2309300231933594e+02 6.4520797729492188e+01 -1.6800700378417969e+02 -1.2412799835205078e+02 5.2493900299072266e+01 -1.6844099426269531e+02 -1.2309300231933594e+02 3.9211299896240234e+01 -1.6800700378417969e+02 -5.7049198150634766e+01 3.9759597778320312e+01 -2.6465298461914062e+02 -1.5957299804687500e+02 5.5535998344421387e+00 -2.1896900939941406e+02 -1.5893499755859375e+02 -3.5828697204589844e+01 -2.0841300964355469e+02 -1.5924200439453125e+02 -1.5555400848388672e+01 -2.1024299621582031e+02 -1.5960699462890625e+02 -3.1181499481201172e+01 -2.1420100402832031e+02 -1.5962500000000000e+02 -1.8942399978637695e+01 -2.1472999572753906e+02 -1.5919900512695312e+02 4.9168796539306641e+00 -2.0998098754882812e+02 -1.5818099975585938e+02 -3.6883296966552734e+01 -2.0505200195312500e+02 -1.5668200683593750e+02 2.7926300048828125e+01 -2.0039300537109375e+02 -1.5872999572753906e+02 -2.3364000320434570e+01 -2.0737400817871094e+02 -1.5927000427246094e+02 -6.1125000000000000e+01 -2.1050700378417969e+02 -1.5939900207519531e+02 -8.0368103027343750e+01 -2.1155899047851562e+02 -7.0918800354003906e+01 -1.5837900161743164e+01 -1.8884700012207031e+02 -6.9318099975585938e+01 -2.2988998413085938e+01 -1.8863000488281250e+02 -5.8000000000000000e+01 -8.1500000000000000e+01 -2.6569198608398438e+02 -5.2883499145507812e+01 -8.1500000000000000e+01 -2.4274699401855469e+02 -1.0943000030517578e+02 -8.1500000000000000e+01 -2.1639999389648438e+02 -1.1522799682617188e+02 8.1500000000000000e+01 -1.8632200622558594e+02 -7.1469902038574219e+01 8.1500000000000000e+01 -1.8885000610351562e+02 -1.0943000030517578e+02 8.1500000000000000e+01 -1.8885000610351562e+02 -6.0192199707031250e+01 -4.2474399566650391e+01 -2.6787899780273438e+02 -4.5000301361083984e+01 -5.9267902374267578e+01 -2.4322700500488281e+02 -4.5335597991943359e+01 -3.8689502716064453e+01 -2.4430200195312500e+02 -4.4684398651123047e+01 -3.8595901489257812e+01 -2.4215798950195312e+02 -1.4127000427246094e+02 -8.1500000000000000e+01 -1.7932499694824219e+02 -1.1193000030517578e+02 -8.1500000000000000e+01 -2.1389999389648438e+02 -1.3732600402832031e+02 -8.1500000000000000e+01 -2.6843600463867188e+02 -7.0851898193359375e+01 3.1052799224853516e+01 -1.8884899902343750e+02 -1.0980699920654297e+02 -1.7284500122070312e+01 -1.8885099792480469e+02 -1.0955899810791016e+02 1.8030799865722656e+01 -1.8885198974609375e+02 -6.5182800292968750e+01 8.1500000000000000e+01 -2.6041799926757812e+02 -9.0691299438476562e+01 8.1500000000000000e+01 -2.8287399291992188e+02 -1.5964500427246094e+02 8.1500099182128906e+01 -2.1404998779296875e+02 -1.5789300537109375e+02 8.1500000000000000e+01 -2.3477600097656250e+02 -1.4945199584960938e+02 -8.1499801635742188e+01 -2.5488099670410156e+02 -1.5485299682617188e+02 -8.1500000000000000e+01 -2.4548300170898438e+02 -1.5233700561523438e+02 -3.6233699798583984e+01 -2.5027099609375000e+02 -4.5388900756835938e+01 8.1500000000000000e+01 -2.4449299621582031e+02 -4.4539897918701172e+01 8.1500000000000000e+01 -2.4160000610351562e+02 -1.5586599731445312e+02 -4.3205802917480469e+01 -2.4303401184082031e+02 -1.5829499816894531e+02 8.1500000000000000e+01 -2.0517199707031250e+02 -4.2691997528076172e+01 -8.1500000000000000e+01 -2.3023500061035156e+02 -4.2735000610351562e+01 -6.1435699462890625e+01 -2.3245899963378906e+02 -4.2633399963378906e+01 -8.1500000000000000e+01 -2.2544300842285156e+02 -1.1580800628662109e+02 8.1500000000000000e+01 -2.1884100341796875e+02 -1.2515499877929688e+02 -4.5578399658203125e+01 -1.6889399719238281e+02 -1.2814100646972656e+02 -8.1500000000000000e+01 -1.7032699584960938e+02 -1.1837300109863281e+02 -8.1500000000000000e+01 -1.6613600158691406e+02 -1.2719899749755859e+02 -7.7679702758789062e+01 -1.6986000061035156e+02 -1.0947799682617188e+02 5.4704597473144531e+01 -1.8885000610351562e+02 -1.0943099975585938e+02 -4.3047599792480469e+01 -2.1640800476074219e+02 -1.1127900695800781e+02 -7.1679298400878906e+01 -2.1579399108886719e+02 -1.0943000030517578e+02 8.1500000000000000e+01 -2.1639999389648438e+02 -1.1132199859619141e+02 8.1493698120117188e+01 -1.8945799255371094e+02 -1.1192900085449219e+02 6.1604297637939453e+01 -1.9122999572753906e+02 -6.7901596069335938e+01 8.1499397277832031e+01 -1.8827999877929688e+02 -6.7311103820800781e+01 5.8139801025390625e+01 -1.8807899475097656e+02 -1.4869700622558594e+02 8.1500000000000000e+01 -2.5605599975585938e+02 -1.5614299011230469e+02 8.1500000000000000e+01 -2.4241400146484375e+02 -1.1122000122070312e+02 3.9176898956298828e+01 -1.8944599914550781e+02 -1.0955000305175781e+02 2.8174699783325195e+01 -1.8885198974609375e+02 -8.1829299926757812e+01 -8.1500000000000000e+01 -2.6751300048828125e+02 -9.8615196228027344e+01 -3.8322200775146484e+01 -2.8331900024414062e+02 -1.0366000366210938e+02 1.3266599655151367e+01 -2.8316598510742188e+02 -1.1129399871826172e+02 1.8158899307250977e+01 -1.8949800109863281e+02 -1.1193399810791016e+02 4.1963199615478516e+01 -1.9127699279785156e+02 -1.2617300415039062e+02 -6.7881301879882812e+01 -1.6936399841308594e+02 -1.5957600402832031e+02 -5.8188999176025391e+01 -2.1367100524902344e+02 -1.5962500000000000e+02 -6.8907096862792969e+01 -2.1472999572753906e+02 -1.5957499694824219e+02 -8.1500000000000000e+01 -2.1366400146484375e+02 -1.5962500000000000e+02 -4.5613800048828125e+01 -2.1472999572753906e+02 -1.2022899627685547e+02 -1.4175499916076660e+01 -2.7920300292968750e+02 -1.2844699096679688e+02 3.0646900177001953e+01 -2.7503601074218750e+02 -1.2268699645996094e+02 4.0988899230957031e+01 -2.7810498046875000e+02 -1.0639200592041016e+02 8.1499595642089844e+01 -2.8287500000000000e+02 -1.2025699615478516e+02 8.1500000000000000e+01 -2.7926998901367188e+02 -4.3418899536132812e+01 -8.1500000000000000e+01 -2.3688400268554688e+02 -4.5039199829101562e+01 -8.1500000000000000e+01 -2.4337998962402344e+02 -4.4686500549316406e+01 -8.0368103027343750e+01 -2.4214500427246094e+02 -4.4313598632812500e+01 1.4542499542236328e+01 -2.2024198913574219e+02 -4.7166900634765625e+01 6.3532001495361328e+01 -2.1757400512695312e+02 -1.1754900360107422e+02 2.1767801284790039e+01 -1.6602299499511719e+02 -1.1593099975585938e+02 8.1500000000000000e+01 -1.6553799438476562e+02 -1.2047599792480469e+02 2.5327301025390625e+01 -1.6699899291992188e+02 -6.3451999664306641e+01 -7.8934997558593750e+01 -1.8406300354003906e+02 -6.3407695770263672e+01 -5.0291900634765625e+01 -1.8397000122070312e+02 -1.1132099914550781e+02 -1.6196899414062500e+01 -1.8945899963378906e+02 -1.1108999633789062e+02 -2.9502500534057617e+01 -1.8932199096679688e+02 -1.1130899810791016e+02 -3.4919601440429688e+01 -2.1573699951171875e+02 -1.1130999755859375e+02 -5.5752300262451172e+01 -2.1574699401855469e+02 -8.1024993896484375e+01 -1.8464799880981445e+01 -2.8040502929687500e+02 -1.3016099548339844e+02 -2.0231298446655273e+01 -1.7142399597167969e+02 -1.2917800903320312e+02 -3.8256198883056641e+01 -1.7088299560546875e+02 -1.2893099975585938e+02 -8.6200199127197266e+00 -1.7074800109863281e+02 -5.1375499725341797e+01 -3.5496101379394531e+01 -2.1639999389648438e+02 -4.5969200134277344e+01 -5.3678898811340332e+00 -2.4616900634765625e+02 -1.5964299011230469e+02 -8.1500000000000000e+01 -2.1533801269531250e+02 -1.1133200073242188e+02 1.4942900657653809e+01 -2.1570700073242188e+02 -1.1193000030517578e+02 1.2829600334167480e+01 -2.1389999389648438e+02 -1.1131300354003906e+02 -1.6639699935913086e+01 -2.1573098754882812e+02 -6.6412498474121094e+01 4.2981800079345703e+01 -1.7217199707031250e+02 -6.5100601196289062e+01 2.0399299621582031e+01 -1.7318299865722656e+02 -6.3122303009033203e+01 2.0244499206542969e+01 -1.7593200683593750e+02 -1.0457400512695312e+02 2.0855899810791016e+01 -1.6345399475097656e+02 -1.3441600036621094e+02 8.1498695373535156e+01 -2.7103701782226562e+02 -1.3544400024414062e+02 3.2431499481201172e+01 -1.7466999816894531e+02 -8.6795600891113281e+01 -8.1500000000000000e+01 -1.6431799316406250e+02 -9.0691497802734375e+01 1.5448199272155762e+01 -1.6373899841308594e+02 -1.0047399902343750e+02 -8.1500099182128906e+01 -1.6314401245117188e+02 -1.2205100250244141e+02 6.0811100006103516e+01 -1.6759100341796875e+02 -1.2261100006103516e+02 8.1500000000000000e+01 -1.6780400085449219e+02 -8.9665596008300781e+01 8.1499893188476562e+01 -1.6382899475097656e+02 -9.6522102355957031e+01 7.9124900817871094e+01 -1.6321900939941406e+02 -1.0934700012207031e+02 1.3453200340270996e+01 -2.1639999389648438e+02 -1.0931199645996094e+02 -1.0592499732971191e+01 -2.1639900207519531e+02 -1.2818499755859375e+02 6.5528999328613281e+01 -1.7035899353027344e+02 -1.2818499755859375e+02 3.8556900024414062e+01 -1.7035899353027344e+02 -1.3192599487304688e+02 2.9293598607182503e-02 -1.7243400573730469e+02 -5.5631801605224609e+01 8.1500000000000000e+01 -2.6306597900390625e+02 -4.6146697998046875e+01 -8.1500000000000000e+01 -2.4665100097656250e+02 -4.5692298889160156e+01 -5.8118297576904297e+01 -2.4537100219726562e+02 -4.5000301361083984e+01 -8.0368103027343750e+01 -2.4322700500488281e+02 -4.5335597991943359e+01 -8.0368103027343750e+01 -2.4430200195312500e+02 -6.2648399353027344e+01 3.7457500457763672e+01 -2.7011499023437500e+02 -5.7810600280761719e+01 7.5345001220703125e+00 -2.6548300170898438e+02 -1.3016099548339844e+02 -4.6339000701904297e+01 -1.7142399597167969e+02 -1.2980101013183594e+02 -7.8033401489257812e+01 -1.7122100830078125e+02 -1.2917800903320312e+02 -6.1602500915527344e+01 -1.7088299560546875e+02 -1.3352400207519531e+02 -3.3135898590087891e+01 -1.7344999694824219e+02 -1.2515499877929688e+02 -1.5528899192810059e+01 -1.6889399719238281e+02 -8.0426498413085938e+01 -1.3816499710083008e+01 -1.6595399475097656e+02 -7.4774200439453125e+01 -8.1500099182128906e+01 -1.6789199829101562e+02 -1.2309300231933594e+02 1.7226800918579102e+01 -1.6800700378417969e+02 -1.2464299774169922e+02 3.0774700641632080e+00 -1.6866299438476562e+02 -1.1618500518798828e+02 -2.3915599822998047e+01 -1.6556700134277344e+02 -1.3304998779296875e+02 -5.7623100280761719e+01 -1.7315000915527344e+02 -1.2579600524902344e+02 7.2457702636718750e+01 -1.6917700195312500e+02 -5.1930000305175781e+01 8.1500000000000000e+01 -2.1639999389648438e+02 -1.5849800109863281e+02 -3.5850799560546875e+01 -2.0633900451660156e+02 -1.5872999572753906e+02 -5.5788101196289062e+01 -2.0737400817871094e+02 -1.5945098876953125e+02 -8.1500000000000000e+01 -2.1202699279785156e+02 -1.5950100708007812e+02 -7.2656700134277344e+01 -2.1261399841308594e+02 -1.5939900207519531e+02 -5.2352397918701172e+01 -2.1155899047851562e+02 -6.6539199829101562e+01 -5.9720301628112793e+00 -1.7208500671386719e+02 -6.9695198059082031e+01 -2.9547300338745117e+01 -1.7033299255371094e+02 -6.6494895935058594e+01 -4.1639999389648438e+01 -1.7210499572753906e+02 -6.3173004150390625e+01 8.1500000000000000e+01 -1.7575700378417969e+02 -6.2288799285888672e+01 8.1499099731445312e+01 -1.8008700561523438e+02 -1.1193000030517578e+02 2.0609800338745117e+01 -1.9120599365234375e+02 -1.5328399658203125e+02 3.0216800689697266e+01 -1.9368499755859375e+02 -4.2638397216796875e+01 -9.9006395339965820e+00 -2.2504100036621094e+02 -6.2292800903320312e+01 -3.5557697296142578e+01 -1.8121301269531250e+02 -6.2989303588867188e+01 5.3153200149536133e+00 -1.8313699340820312e+02 -6.2298301696777344e+01 6.9066300392150879e+00 -1.7996800231933594e+02 -6.2996200561523438e+01 -5.9798500061035156e+01 -1.8306800842285156e+02 -5.2208198547363281e+01 -8.1500099182128906e+01 -2.5870599365234375e+02 -9.8930000305175781e+01 8.1500000000000000e+01 -2.8331802368164062e+02 -9.0505401611328125e+01 4.2505397796630859e+01 -2.8291799926757812e+02 -1.5328300476074219e+02 8.1500000000000000e+01 -1.9368598937988281e+02 -1.1192700195312500e+02 3.2083999633789062e+01 -2.1443499755859375e+02 -5.1930000305175781e+01 -8.1500000000000000e+01 -2.1639999389648438e+02 -1.1193000030517578e+02 -8.1500000000000000e+01 -1.9134999084472656e+02 -1.1193100738525391e+02 -5.5123703002929688e+01 -1.9124099731445312e+02 -5.6202499389648438e+01 8.1500000000000000e+01 -2.4436099243164062e+02 -1.1610900115966797e+02 5.3495399475097656e+01 -2.8068399047851562e+02 -1.5341400146484375e+02 5.1279300689697266e+01 -2.4831399536132812e+02 -1.2412799835205078e+02 -4.9805599212646484e+01 -1.6844099426269531e+02 -1.2335500335693359e+02 -6.1359401702880859e+01 -1.6810700988769531e+02 -1.4334599304199219e+02 -3.7892700195312500e+01 -2.6226800537109375e+02 -1.3913699340820312e+02 -2.2590400695800781e+01 -2.6655798339843750e+02 -4.5692298889160156e+01 -4.3579898834228516e+01 -2.4537100219726562e+02 -1.5962100219726562e+02 2.2037500381469727e+01 -2.1791000366210938e+02 -1.3492399597167969e+02 -5.5712902069091797e+01 -1.7438400268554688e+02 -1.3492399597167969e+02 -3.4418197631835938e+01 -1.7438400268554688e+02 -1.5381900024414062e+02 -5.8485496044158936e-01 -2.4758300781250000e+02 -5.5549800872802734e+01 7.8139495849609375e+01 -2.6291598510742188e+02 -5.6304500579833984e+01 5.5889801025390625e+01 -2.6380801391601562e+02 -6.1017498016357422e+01 -6.0912799835205078e+01 -2.6864599609375000e+02 -8.2368095397949219e+01 1.9614500045776367e+01 -2.8082800292968750e+02 -8.2368095397949219e+01 4.6480499267578125e+01 -2.8082800292968750e+02 -5.7049198150634766e+01 5.8012199401855469e+01 -2.6465298461914062e+02 -8.1294898986816406e+01 2.6609500885009766e+01 -2.8048599243164062e+02 -6.0192199707031250e+01 7.7113699913024902e+00 -2.6787899780273438e+02 -5.6621902465820312e+01 7.7715095520019531e+01 -2.6417700195312500e+02 -4.4686500549316406e+01 -1.1036499977111816e+01 -2.4214500427246094e+02 -8.0228698730468750e+01 3.7124202728271484e+01 -2.8012200927734375e+02 -8.1294898986816406e+01 5.5712902069091797e+01 -2.8048599243164062e+02 -4.4610103607177734e+01 2.3461301803588867e+01 -2.4187399291992188e+02 -5.4866703033447266e+01 5.6738700866699219e+01 -2.6207400512695312e+02 -5.4173999786376953e+01 7.9236099243164062e+01 -2.6118499755859375e+02 -1.0220899963378906e+02 8.1500099182128906e+01 -1.6327600097656250e+02 -1.1875499725341797e+02 -6.2787604331970215e-01 -1.6639399719238281e+02 -1.2818499755859375e+02 1.2133000373840332e+01 -1.7035899353027344e+02 -1.2412799835205078e+02 2.8811498641967773e+01 -1.6844099426269531e+02 -1.5909199523925781e+02 3.6917499542236328e+01 -2.0915499877929688e+02 -4.4253902435302734e+01 -6.3702800750732422e+01 -2.4051199340820312e+02 -1.2100200653076172e+02 4.6339000701904297e+01 -1.6719299316406250e+02 -1.2718400573730469e+02 4.7736202239990234e+01 -1.6985299682617188e+02 -1.3113400268554688e+02 -7.8104194641113281e+01 -1.7198200988769531e+02 -1.1000299835205078e+02 5.2793598175048828e+01 -2.8224600219726562e+02 -1.2718400573730469e+02 -9.5640497207641602e+00 -1.6985299682617188e+02 -1.5964900207519531e+02 2.5893199920654297e+01 -2.1579000854492188e+02 -1.5955000305175781e+02 5.9229999542236328e+01 -2.1321000671386719e+02 -1.5536999511718750e+02 -3.2170299530029297e+01 -1.9738699340820312e+02 -1.0944000244140625e+02 -4.5227298736572266e+01 -1.8884700012207031e+02 -9.4237602233886719e+01 -8.1500000000000000e+01 -2.3952799987792969e+02 -6.5612998962402344e+01 -5.7504501342773438e+01 -1.8693000793457031e+02 -6.8448097229003906e+01 2.9360401153564453e+01 -1.8842799377441406e+02 -6.2320400238037109e+01 -8.1500000000000000e+01 -1.7900498962402344e+02 -5.4866703033447266e+01 7.8104194641113281e+01 -2.6207400512695312e+02 -1.1117600250244141e+02 3.0571001052856445e+01 -2.1585600280761719e+02 -5.1428798675537109e+01 -5.5763500213623047e+01 -2.1640600585937500e+02 -1.1192900085449219e+02 -3.1927801132202148e+01 -1.9115098571777344e+02 -1.1129499816894531e+02 5.3575901031494141e+01 -1.8947100830078125e+02 -1.2601499176025391e+02 8.1500000000000000e+01 -1.7857701110839844e+02 -4.3200199127197266e+01 4.1322799682617188e+01 -2.2210900878906250e+02 -1.1158999633789062e+02 -4.8158298492431641e+01 -1.8997900390625000e+02 -4.5874698638916016e+01 8.1499504089355469e+01 -2.1849200439453125e+02 -4.2635398864746094e+01 -3.8299198150634766e+01 -2.2535000610351562e+02 -1.2844499206542969e+02 -4.1468097686767578e+01 -2.7502301025390625e+02 -1.2467300415039062e+02 -8.1499893188476562e+01 -2.7726998901367188e+02 -1.1193000030517578e+02 -8.1500005722045898e+00 -2.1389999389648438e+02 -1.3368299865722656e+02 -2.0634601593017578e+01 -2.7138000488281250e+02 -1.3480499267578125e+02 4.4322299957275391e+01 -2.7044799804687500e+02 -1.4144299316406250e+02 4.0752799987792969e+01 -2.6430999755859375e+02 -1.5927000427246094e+02 -3.5178699493408203e+01 -2.1050700378417969e+02 -1.2818499755859375e+02 -6.7032302856445312e+01 -1.7035899353027344e+02 -6.1857997894287109e+01 -2.0339601516723633e+01 -2.6939599609375000e+02 -6.1017498016357422e+01 -4.1033000946044922e+01 -2.6864599609375000e+02 -6.1642097473144531e+01 -8.1500000000000000e+01 -2.6925201416015625e+02 -1.2735099792480469e+02 8.1500000000000000e+01 -1.6992601013183594e+02 -6.1017498016357422e+01 -2.3735500335693359e+01 -2.6864599609375000e+02 -1.2818499755859375e+02 -5.4483699798583984e+01 -1.7035899353027344e+02 -1.2818499755859375e+02 -2.6742198944091797e+01 -1.7035899353027344e+02 -1.2205100250244141e+02 2.4372200012207031e+01 -1.6759100341796875e+02 -1.3399299621582031e+02 -5.0177001953125000e+01 -1.7375900268554688e+02 -4.5876102447509766e+01 -2.5804800033569336e+01 -2.4590299987792969e+02 -1.4687100219726562e+02 -4.7973499298095703e+00 -2.5816000366210938e+02 -6.1017498016357422e+01 -1.4856799840927124e+00 -2.6864599609375000e+02 -1.5964700317382812e+02 3.1942098617553711e+01 -2.1684999084472656e+02 -1.3638200378417969e+02 -8.1500000000000000e+01 -1.7537200927734375e+02 -1.4980400085449219e+02 3.1111299514770508e+01 -2.5422399902343750e+02 -1.0786299896240234e+02 -2.3283599853515625e+01 -2.1639999389648438e+02 -9.3337997436523438e+01 2.4400899887084961e+01 -2.1639999389648438e+02 -8.5923995971679688e+01 -1.3123000144958496e+01 -2.1639999389648438e+02 -9.8075393676757812e+01 -2.2372699737548828e+01 -1.8728900146484375e+02 -8.6830200195312500e+01 -1.8823200225830078e+01 -1.8728900146484375e+02 -7.7954597473144531e+01 -7.7424597740173340e+00 -1.8728900146484375e+02 -7.6394104003906250e+01 -1.0720900535583496e+01 -2.1639999389648438e+02 -8.6009803771972656e+01 -1.4916299819946289e+01 -2.1639999389648438e+02 -1.2123799896240234e+02 1.1255100250244141e+01 -2.1639900207519531e+02 -1.1830599975585938e+02 1.3930899620056152e+01 -2.0442298889160156e+02 -1.1643700408935547e+02 1.7983600616455078e+01 -2.1639999389648438e+02 -1.1975000000000000e+02 -1.1105000495910645e+01 -2.0151699829101562e+02 -1.1716000366210938e+02 -1.2969799995422363e+01 -1.8728900146484375e+02 -1.1962599945068359e+02 -8.6495599746704102e+00 -1.8728900146484375e+02 -1.2336100006103516e+02 -5.2193899154663086e+00 -2.1639999389648438e+02 -1.2126499938964844e+02 -5.8810701370239258e+00 -1.9592698669433594e+02 -1.2115100097656250e+02 -2.7500901222229004e+00 -1.8728900146484375e+02 -1.1071500396728516e+02 2.2009300231933594e+01 -2.1639900207519531e+02 -1.1026499938964844e+02 1.9308000564575195e+01 -1.8728900146484375e+02 -1.0806700134277344e+02 2.2047798156738281e+01 -2.0454899597167969e+02 -8.6567001342773438e+01 -2.1687700271606445e+01 -2.1639999389648438e+02 -8.9995697021484375e+01 -2.3297399520874023e+01 -2.1639999389648438e+02 -8.8336997985839844e+01 -1.8521699905395508e+01 -2.1639999389648438e+02 -1.1462799835205078e+02 1.7867099761962891e+01 -2.0335699462890625e+02 -1.1522100067138672e+02 1.5464200019836426e+01 -1.8728900146484375e+02 -1.1205899810791016e+02 1.9490600585937500e+01 -2.0049501037597656e+02 -9.0612998962402344e+01 -2.0789699554443359e+01 -1.8728900146484375e+02 -1.1484799957275391e+02 -1.5756800651550293e+01 -1.8728900146484375e+02 -1.1583200073242188e+02 -1.8420801162719727e+01 -2.1639999389648438e+02 -1.1398799896240234e+02 -1.8017299652099609e+01 -2.0012800598144531e+02 -1.1629199981689453e+02 1.6131000518798828e+01 -2.0243099975585938e+02 -7.9191902160644531e+01 1.0561600685119629e+01 -1.8728999328613281e+02 -7.9093704223632812e+01 1.3024300575256348e+01 -2.0292399597167969e+02 -8.1721702575683594e+01 1.4316899299621582e+01 -1.8728999328613281e+02 -9.9474197387695312e+01 -2.4982599258422852e+01 -2.1639900207519531e+02 -1.0219100189208984e+02 -2.2163999557495117e+01 -1.8728900146484375e+02 -8.2604103088378906e+01 -1.8929300308227539e+01 -2.1639900207519531e+02 -1.1993200683593750e+02 1.0780799865722656e+01 -2.0168800354003906e+02 -8.9284400939941406e+01 2.1794099807739258e+01 -2.0422300720214844e+02 -8.7711807250976562e+01 2.2295700073242188e+01 -2.1639999389648438e+02 -8.6459396362304688e+01 -1.5310900688171387e+01 -2.1639999389648438e+02 -1.0740499877929688e+02 -2.0697898864746094e+01 -1.8728900146484375e+02 -1.2171600341796875e+02 -1.0193900108337402e+01 -2.1639999389648438e+02 -1.0159700012207031e+02 2.4927400588989258e+01 -2.1639999389648438e+02 -7.8850097656250000e+01 -1.4857999801635742e+01 -2.1639999389648438e+02 -8.1664505004882812e+01 -1.4248999595642090e+01 -1.8728999328613281e+02 -8.4299697875976562e+01 -1.6942199707031250e+01 -1.8728900146484375e+02 -8.0679100036621094e+01 -1.6040601730346680e+01 -2.0909400939941406e+02 -7.6583000183105469e+01 7.7691197395324707e+00 -2.0238499450683594e+02 -7.7401306152343750e+01 6.1099600791931152e+00 -1.8728999328613281e+02 -7.5639900207519531e+01 4.1488304138183594e+00 -2.0217100524902344e+02 -1.2130200195312500e+02 0.0000000000000000e+00 -1.8728900146484375e+02 -1.2065699768066406e+02 5.4261598587036133e+00 -1.8728900146484375e+02 -1.2378100585937500e+02 2.4426200389862061e+00 -2.1639999389648438e+02 -7.6668998718261719e+01 2.3520100116729736e+00 -1.8728900146484375e+02 -1.0480199432373047e+02 -2.2782899856567383e+01 -2.0081298828125000e+02 -7.4741600036621094e+01 -6.1618800163269043e+00 -2.1639999389648438e+02 -7.4095298767089844e+01 -2.6006000041961670e+00 -2.1639999389648438e+02 -7.6770606994628906e+01 -3.4387500286102295e+00 -1.8728900146484375e+02 -1.1111699676513672e+02 -1.8756101608276367e+01 -1.8728900146484375e+02 -7.6557800292968750e+01 0.0000000000000000e+00 -1.8728900146484375e+02 -1.0362899780273438e+02 2.3287799835205078e+01 -2.0315399169921875e+02 -1.0154000091552734e+02 2.3758501052856445e+01 -2.0471000671386719e+02 -1.2389299774169922e+02 0.0000000000000000e+00 -2.1639999389648438e+02 -1.2158799743652344e+02 3.5115301609039307e+00 -2.1639999389648438e+02 -7.9032897949218750e+01 -1.0196300506591797e+01 -1.8728900146484375e+02 -8.6790702819824219e+01 -1.5767699241638184e+01 -2.1639999389648438e+02 -8.2762298583984375e+01 1.9169601440429688e+01 -2.1639999389648438e+02 -8.4647300720214844e+01 1.7226200103759766e+01 -1.8728900146484375e+02 -8.2849693298339844e+01 1.7439498901367188e+01 -2.0263899230957031e+02 -1.1986100006103516e+02 -1.3593600273132324e+01 -2.1639999389648438e+02 -7.4263801574707031e+01 4.3352899551391602e+00 -2.1639999389648438e+02 -7.3966896057128906e+01 0.0000000000000000e+00 -2.1639999389648438e+02 -9.8912094116210938e+01 2.2379699707031250e+01 -1.8728900146484375e+02 -1.1809799957275391e+02 -1.6007099151611328e+01 -2.1639999389648438e+02 -9.3657798767089844e+01 2.3438899993896484e+01 -2.0619699096679688e+02 -9.5956802368164062e+01 2.3254100799560547e+01 -1.9970899963378906e+02 -9.5074897766113281e+01 2.2079500198364258e+01 -1.8728999328613281e+02 -1.2320899963378906e+02 5.8835101127624512e+00 -2.1639999389648438e+02 -1.2137000274658203e+02 7.4678702354431152e+00 -2.0221800231933594e+02 -9.7939094543457031e+01 2.3789100646972656e+01 -2.0356999206542969e+02 -9.2487602233886719e+01 -2.2787399291992188e+01 -2.0247999572753906e+02 -7.6406005859375000e+01 1.0778200149536133e+01 -2.1639999389648438e+02 -1.0206100463867188e+02 -2.3341199874877930e+01 -2.0088999938964844e+02 -8.5360305786132812e+01 -1.9213600158691406e+01 -2.0056100463867188e+02 -9.4368896484375000e+01 -2.4563598632812500e+01 -2.1639999389648438e+02 -1.0667800140380859e+02 2.3711299896240234e+01 -2.1639999389648438e+02 -1.0426200103759766e+02 -2.4407699584960938e+01 -2.1639999389648438e+02 -1.1866699981689453e+02 1.0581100463867188e+01 -1.8728900146484375e+02 -7.5941200256347656e+01 -7.8840198516845703e+00 -2.0933300781250000e+02 -8.6851295471191406e+01 2.0182899475097656e+01 -2.0059800720214844e+02 -9.4530998229980469e+01 -2.1941499710083008e+01 -1.8728900146484375e+02 -7.8869003295898438e+01 1.4852800369262695e+01 -2.1639999389648438e+02 -8.7455299377441406e+01 1.9230199813842773e+01 -1.8728900146484375e+02 -1.0228300476074219e+02 2.2140701293945312e+01 -1.8728900146484375e+02 -9.0718498229980469e+01 2.0797599792480469e+01 -1.8728900146484375e+02 -1.0680300140380859e+02 2.0927799224853516e+01 -1.8728900146484375e+02 -1.2113999938964844e+02 -8.0166492462158203e+00 -2.0173100280761719e+02 -1.1109600067138672e+02 -2.1829099655151367e+01 -2.1639900207519531e+02 -1.1268099975585938e+02 -1.9607799530029297e+01 -2.0532099914550781e+02 -1.2292599487304688e+02 -1.4513500928878784e+00 -2.0603700256347656e+02 -7.8505302429199219e+01 -1.2261099815368652e+01 -2.0392799377441406e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 17 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2467300146818161e+02 -8.1499896943569183e+01 -2.7726998925209045e+02) (float-vector -9.8930001258850098e+01 -8.1500001251697540e+01 -2.8331801295280457e+02) (float-vector -9.0691298246383667e+01 8.1500001251697540e+01 -2.8287398815155029e+02) (float-vector -1.2025699764490128e+02 8.1500001251697540e+01 -2.7926999330520630e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2467300146818161e+02 -8.1499896943569183e+01 -2.7726998925209045e+02) (float-vector -1.2025699764490128e+02 8.1500001251697540e+01 -2.7926999330520630e+02) (float-vector -1.4869700372219086e+02 8.1500001251697540e+01 -2.5605601072311401e+02) (float-vector -1.4945200085639954e+02 -8.1499800086021423e+01 -2.5488099455833435e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2633499950170517e+01 8.1500001251697540e+01 -2.2544300556182861e+02) (float-vector -4.5388899743556976e+01 8.1500001251697540e+01 -2.4449299275875092e+02) (float-vector -4.6146698296070099e+01 -8.1500001251697540e+01 -2.4665099382400513e+02) (float-vector -4.2633399367332458e+01 -8.1500001251697540e+01 -2.2544300556182861e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6146698296070099e+01 -8.1500001251697540e+01 -2.4665099382400513e+02) (float-vector -4.5388899743556976e+01 8.1500001251697540e+01 -2.4449299275875092e+02) (float-vector -5.5631801486015320e+01 8.1500001251697540e+01 -2.6306599378585815e+02) (float-vector -5.7999998331069946e+01 -8.1500001251697540e+01 -2.6569199562072754e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5485300123691559e+02 -8.1500001251697540e+01 -2.4548299610614777e+02) (float-vector -1.4945200085639954e+02 -8.1499800086021423e+01 -2.5488099455833435e+02) (float-vector -1.4869700372219086e+02 8.1500001251697540e+01 -2.5605601072311401e+02) (float-vector -1.5614299476146698e+02 8.1500001251697540e+01 -2.4241399765014648e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5947200357913971e+02 -8.1500001251697540e+01 -2.2048400342464447e+02) (float-vector -1.5485300123691559e+02 -8.1500001251697540e+01 -2.4548299610614777e+02) (float-vector -1.5614299476146698e+02 8.1500001251697540e+01 -2.4241399765014648e+02) (float-vector -1.5964500606060028e+02 8.1500098109245300e+01 -2.1404999494552612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3172499835491180e+02 -8.1500001251697540e+01 -1.7232200503349304e+02) (float-vector -1.1837299913167953e+02 -8.1500001251697540e+01 -1.6613599658012390e+02) (float-vector -1.0047399997711182e+02 -8.1500098109245300e+01 -1.6314400732517242e+02) (float-vector -7.4774198234081268e+01 -8.1500098109245300e+01 -1.6789199411869049e+02) (float-vector -6.4097099006175995e+01 -8.1500299274921417e+01 -1.7428499460220337e+02) (float-vector -4.2633399367332458e+01 -8.1500001251697540e+01 -2.2544300556182861e+02) (float-vector -4.6146698296070099e+01 -8.1500001251697540e+01 -2.4665099382400513e+02) (float-vector -5.7999998331069946e+01 -8.1500001251697540e+01 -2.6569199562072754e+02) (float-vector -7.7714398503303528e+01 -8.1500001251697540e+01 -2.7928400039672852e+02) (float-vector -9.8930001258850098e+01 -8.1500001251697540e+01 -2.8331801295280457e+02) (float-vector -1.2467300146818161e+02 -8.1499896943569183e+01 -2.7726998925209045e+02) (float-vector -1.4945200085639954e+02 -8.1499800086021423e+01 -2.5488099455833435e+02) (float-vector -1.5485300123691559e+02 -8.1500001251697540e+01 -2.4548299610614777e+02) (float-vector -1.5947200357913971e+02 -8.1500001251697540e+01 -2.2048400342464447e+02) (float-vector -1.5328299999237061e+02 -8.1500001251697540e+01 -1.9368599355220795e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5262598693370819e+01 8.1499896943569183e+01 -2.7824500203132629e+02) (float-vector -7.7714398503303528e+01 -8.1500001251697540e+01 -2.7928400039672852e+02) (float-vector -5.7999998331069946e+01 -8.1500001251697540e+01 -2.6569199562072754e+02) (float-vector -5.5631801486015320e+01 8.1500001251697540e+01 -2.6306599378585815e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7714398503303528e+01 -8.1500001251697540e+01 -2.7928400039672852e+02) (float-vector -7.5262598693370819e+01 8.1499896943569183e+01 -2.7824500203132629e+02) (float-vector -9.0691298246383667e+01 8.1500001251697540e+01 -2.8287398815155029e+02) (float-vector -9.8930001258850098e+01 -8.1500001251697540e+01 -2.8331801295280457e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2633399367332458e+01 -8.1500001251697540e+01 -2.2544300556182861e+02) (float-vector -6.4097099006175995e+01 -8.1500299274921417e+01 -1.7428499460220337e+02) (float-vector -6.3173003494739532e+01 8.1500001251697540e+01 -1.7575700581073761e+02) (float-vector -4.2633499950170517e+01 8.1500001251697540e+01 -2.2544300556182861e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5328299999237061e+02 8.1500001251697540e+01 -1.9368599355220795e+02) (float-vector -1.5328299999237061e+02 -8.1500001251697540e+01 -1.9368599355220795e+02) (float-vector -1.5947200357913971e+02 -8.1500001251697540e+01 -2.2048400342464447e+02) (float-vector -1.5964500606060028e+02 8.1500098109245300e+01 -2.1404999494552612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4342899620532990e+02 7.8822202980518341e+01 -1.8122400343418121e+02) (float-vector -1.3172499835491180e+02 -8.1500001251697540e+01 -1.7232200503349304e+02) (float-vector -1.5328299999237061e+02 -8.1500001251697540e+01 -1.9368599355220795e+02) (float-vector -1.5328299999237061e+02 8.1500001251697540e+01 -1.9368599355220795e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1593099683523178e+02 8.1500001251697540e+01 -1.6553799808025360e+02) (float-vector -1.1837299913167953e+02 -8.1500001251697540e+01 -1.6613599658012390e+02) (float-vector -1.3172499835491180e+02 -8.1500001251697540e+01 -1.7232200503349304e+02) (float-vector -1.4342899620532990e+02 7.8822202980518341e+01 -1.8122400343418121e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0047399997711182e+02 -8.1500098109245300e+01 -1.6314400732517242e+02) (float-vector -1.1837299913167953e+02 -8.1500001251697540e+01 -1.6613599658012390e+02) (float-vector -1.1593099683523178e+02 8.1500001251697540e+01 -1.6553799808025360e+02) (float-vector -8.9665599167346954e+01 8.1499896943569183e+01 -1.6382899880409241e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2025699764490128e+02 8.1500001251697540e+01 -2.7926999330520630e+02) (float-vector -9.0691298246383667e+01 8.1500001251697540e+01 -2.8287398815155029e+02) (float-vector -7.5262598693370819e+01 8.1499896943569183e+01 -2.7824500203132629e+02) (float-vector -5.5631801486015320e+01 8.1500001251697540e+01 -2.6306599378585815e+02) (float-vector -4.5388899743556976e+01 8.1500001251697540e+01 -2.4449299275875092e+02) (float-vector -4.2633499950170517e+01 8.1500001251697540e+01 -2.2544300556182861e+02) (float-vector -6.3173003494739532e+01 8.1500001251697540e+01 -1.7575700581073761e+02) (float-vector -7.6334498822689056e+01 8.1499800086021423e+01 -1.6727699339389801e+02) (float-vector -8.9665599167346954e+01 8.1499896943569183e+01 -1.6382899880409241e+02) (float-vector -1.1593099683523178e+02 8.1500001251697540e+01 -1.6553799808025360e+02) (float-vector -1.4342899620532990e+02 7.8822202980518341e+01 -1.8122400343418121e+02) (float-vector -1.5328299999237061e+02 8.1500001251697540e+01 -1.9368599355220795e+02) (float-vector -1.5964500606060028e+02 8.1500098109245300e+01 -2.1404999494552612e+02) (float-vector -1.5614299476146698e+02 8.1500001251697540e+01 -2.4241399765014648e+02) (float-vector -1.4869700372219086e+02 8.1500001251697540e+01 -2.5605601072311401e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.9665599167346954e+01 8.1499896943569183e+01 -1.6382899880409241e+02) (float-vector -7.6334498822689056e+01 8.1499800086021423e+01 -1.6727699339389801e+02) (float-vector -7.4774198234081268e+01 -8.1500098109245300e+01 -1.6789199411869049e+02) (float-vector -1.0047399997711182e+02 -8.1500098109245300e+01 -1.6314400732517242e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4774198234081268e+01 -8.1500098109245300e+01 -1.6789199411869049e+02) (float-vector -7.6334498822689056e+01 8.1499800086021423e+01 -1.6727699339389801e+02) (float-vector -6.3173003494739532e+01 8.1500001251697540e+01 -1.7575700581073761e+02) (float-vector -6.4097099006175995e+01 -8.1500299274921417e+01 -1.7428499460220337e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "laser_tilt_mount_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_elbow_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 4.0000000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 0 25 24 0 2 25 24 174 0 174 175 0 0 175 1 23 24 25 25 28 23 25 17 28 2 17 25 12 33 24 23 12 24 24 33 174 12 32 33 174 33 32 174 179 175 174 32 179 175 176 1 175 179 176 176 179 177 177 179 178 179 32 178 29 32 12 178 32 29 177 178 115 115 178 29 29 30 31 30 29 12 29 150 116 29 31 150 115 29 116 115 116 104 104 177 115 116 102 104 116 105 102 116 106 105 150 106 116 150 107 106 31 112 150 150 112 107 106 107 108 105 106 108 107 112 162 162 356 107 107 356 108 35 112 31 112 34 162 35 34 112 34 35 30 35 31 30 36 34 37 37 34 30 34 36 162 92 30 12 92 37 30 36 37 39 88 37 92 39 37 88 4 91 92 4 92 12 88 92 93 91 93 92 40 39 88 88 89 40 88 93 89 89 93 94 94 93 91 3 91 4 3 94 91 94 3 100 100 342 94 342 343 94 94 344 89 343 344 94 100 99 86 86 101 100 3 99 100 101 342 100 86 99 97 97 99 3 86 87 83 86 97 87 83 101 86 85 101 83 85 168 101 101 168 342 83 84 85 83 87 84 84 341 85 87 326 84 341 84 326 329 341 327 341 326 327 329 85 341 326 325 327 325 326 95 96 326 87 326 96 95 328 329 327 331 327 325 328 327 331 95 324 325 331 325 324 95 96 60 60 324 95 60 96 61 96 87 61 59 60 61 59 71 60 71 324 60 340 331 324 69 324 71 340 324 69 70 71 59 69 71 70 65 69 68 68 69 70 338 340 69 65 338 69 338 339 340 339 331 340 336 339 338 336 331 339 330 328 331 330 331 336 330 336 332 332 372 330 330 372 375 375 381 330 330 381 328 328 381 377 328 377 329 377 381 380 381 376 380 376 381 375 375 372 376 380 376 382 382 376 383 376 384 383 376 374 384 372 374 376 383 384 337 338 383 337 382 383 338 384 374 385 335 384 385 337 384 335 335 336 337 337 336 338 67 338 65 173 338 67 173 382 338 65 66 67 20 173 67 20 67 66 65 68 66 21 66 68 20 66 21 21 68 22 22 68 70 20 21 13 13 21 11 21 22 11 22 18 11 22 70 18 18 70 5 70 59 5 11 18 12 18 4 12 5 4 18 8 11 6 6 11 12 8 13 11 23 6 12 6 7 8 7 6 23 7 9 8 9 13 8 10 9 7 23 26 7 7 26 10 28 26 23 26 16 27 28 16 26 10 26 19 26 27 19 19 20 10 10 20 9 20 13 9 19 173 20 27 172 19 19 172 173 16 64 27 27 64 172 172 382 173 64 382 172 62 63 64 15 62 64 15 64 16 63 382 64 63 380 382 62 72 63 72 56 63 379 380 63 56 379 63 72 62 15 57 72 73 57 56 72 14 73 72 14 72 15 56 57 58 58 379 56 73 181 57 57 182 58 181 182 57 1 73 14 180 181 73 180 73 1 2 1 14 14 15 2 1 176 170 170 180 1 170 181 180 168 169 170 170 169 181 365 168 170 177 365 170 170 176 177 169 168 171 171 168 85 342 168 365 169 171 183 169 183 181 183 171 184 184 181 183 181 184 182 171 368 184 368 182 184 182 368 371 182 379 58 371 379 182 368 171 370 371 368 370 370 378 371 371 378 379 378 380 379 377 378 370 377 380 378 369 370 171 369 377 370 329 377 369 329 369 85 85 369 171 366 365 177 342 365 366 177 367 366 342 366 343 366 367 343 104 367 177 357 367 104 343 367 344 344 367 345 345 367 357 102 103 104 103 357 104 102 105 103 105 357 103 355 357 105 345 357 354 354 357 355 89 345 90 89 344 345 354 90 345 89 90 40 90 127 40 127 90 161 90 354 161 38 39 40 38 40 42 42 40 127 127 161 126 42 127 126 126 161 123 161 354 123 126 123 125 42 126 125 38 42 43 42 125 43 123 124 125 43 125 159 159 125 124 123 354 124 159 124 160 124 353 160 354 353 124 160 43 159 43 44 38 44 43 167 167 43 160 353 352 160 160 352 167 354 356 353 353 356 352 355 356 354 108 356 355 358 356 162 352 356 358 167 352 166 352 350 166 352 358 350 166 44 167 149 148 166 148 44 166 166 350 149 122 148 149 149 350 122 44 148 49 122 49 148 44 49 38 38 49 47 49 121 120 122 121 49 47 49 120 350 351 122 122 351 121 121 117 120 121 349 117 121 351 349 120 117 119 47 120 119 117 118 119 117 349 348 117 348 118 349 361 348 351 361 349 350 360 351 360 361 351 350 359 360 350 358 359 360 359 114 114 361 360 109 359 110 359 358 110 114 359 109 110 358 162 109 110 111 162 36 110 110 36 111 109 113 114 111 128 109 109 128 113 36 45 111 111 45 128 36 39 45 41 45 39 41 128 45 113 128 129 128 41 129 113 129 114 114 129 130 129 131 130 129 41 131 39 38 41 38 163 41 41 163 131 130 131 132 131 163 132 130 361 114 132 361 130 132 133 134 132 163 133 362 361 132 134 362 132 163 38 133 134 133 135 133 136 135 133 38 136 363 362 134 135 363 134 347 362 363 348 362 347 348 361 362 137 363 135 137 364 363 363 364 347 135 136 137 46 136 38 136 46 137 137 46 138 138 364 137 46 47 48 46 38 47 138 46 139 46 48 139 138 139 140 140 364 138 140 139 141 139 142 141 139 48 142 140 193 192 141 193 140 192 364 140 141 142 143 143 193 141 151 143 142 55 151 142 55 142 48 151 152 143 195 193 143 152 195 143 153 152 151 55 54 151 54 153 151 48 54 55 51 54 48 54 51 153 153 154 152 153 155 154 153 51 155 152 202 195 154 202 152 154 197 202 155 197 154 51 146 155 199 197 155 146 199 155 196 197 198 197 199 198 196 202 197 195 202 196 195 196 194 196 389 194 198 227 196 227 389 196 199 200 198 200 227 198 199 201 200 146 201 199 80 200 79 79 200 201 234 227 200 80 234 200 79 201 75 75 201 203 145 201 146 145 203 201 74 79 75 79 78 80 78 79 74 74 75 76 75 203 76 76 203 147 147 203 145 144 145 146 144 147 145 156 146 51 156 144 146 157 147 144 51 144 156 144 50 157 50 144 51 157 158 147 147 346 76 158 346 147 50 53 157 157 53 158 48 50 51 48 53 50 48 52 53 158 53 164 53 52 164 164 346 158 164 52 165 347 346 164 165 347 164 47 52 48 47 119 52 165 52 118 118 52 119 348 347 165 118 348 165 347 364 346 204 364 192 206 364 204 346 364 206 192 187 191 192 193 187 191 204 192 188 191 187 191 188 190 190 204 191 188 187 186 188 189 190 186 388 188 388 189 188 189 204 190 205 204 189 189 388 205 388 494 205 388 390 494 389 388 186 389 390 388 185 186 187 185 389 186 194 389 185 227 390 389 227 391 390 494 390 495 390 391 495 226 391 227 226 392 391 391 392 495 494 495 493 493 495 492 495 496 492 495 392 496 233 392 226 233 393 392 392 393 496 492 496 491 496 497 491 393 394 496 496 394 497 225 393 233 225 394 393 225 233 217 217 233 226 221 225 217 221 232 225 232 394 225 232 395 394 394 395 497 231 232 221 231 395 232 231 396 395 497 395 396 229 231 221 229 396 231 229 397 396 497 396 498 396 397 498 224 229 214 214 229 221 224 397 229 224 398 397 498 397 398 498 489 490 490 497 498 489 498 499 498 398 499 228 398 224 228 399 398 398 399 499 489 499 486 486 499 487 499 400 487 499 399 400 230 399 228 230 400 399 210 228 212 212 228 224 210 230 228 223 230 210 223 400 230 223 401 400 487 400 442 442 400 401 222 223 210 222 235 223 235 401 223 235 402 401 401 402 442 487 442 402 279 402 235 279 403 402 402 444 487 402 484 444 402 403 484 222 279 235 220 222 210 220 279 222 209 220 210 209 278 220 220 278 277 277 279 220 208 209 210 208 210 212 209 486 278 209 489 486 208 489 209 277 278 276 278 444 276 486 444 278 486 487 444 443 444 445 444 484 445 276 444 443 275 276 274 276 275 277 276 443 274 273 274 272 275 274 273 274 443 272 282 273 283 283 273 284 275 273 282 273 271 284 272 271 273 281 275 282 282 406 281 282 407 406 283 407 282 283 408 407 284 408 283 284 271 313 284 409 408 313 409 284 446 408 450 450 408 451 446 407 408 408 409 451 406 407 446 281 406 405 445 406 446 445 405 406 280 405 404 281 405 280 404 405 445 443 445 446 484 404 445 312 404 403 280 404 312 484 403 404 280 275 281 312 275 280 279 277 312 312 277 275 312 403 279 446 447 443 448 447 446 448 446 450 272 447 448 272 443 447 449 448 450 268 448 449 272 448 268 450 451 449 451 452 449 449 452 269 268 449 269 268 269 270 271 268 270 271 272 268 270 269 285 285 269 286 269 267 286 269 452 267 271 270 313 313 270 314 314 270 285 313 410 409 314 410 313 314 411 410 285 411 314 451 410 411 451 409 410 285 412 411 451 411 453 411 412 453 451 453 452 453 454 452 453 456 454 453 412 456 287 412 285 287 413 412 412 413 456 455 454 456 456 457 455 456 414 457 456 413 414 288 413 287 288 414 413 285 286 287 287 286 288 286 266 288 288 266 315 315 414 288 315 415 414 414 415 457 315 266 289 289 415 315 266 264 265 267 264 266 266 265 289 286 267 266 289 265 290 289 416 415 290 416 289 457 415 416 290 417 416 457 416 460 416 417 460 290 265 291 291 417 290 291 418 417 417 418 460 265 262 291 291 262 316 316 418 291 316 419 418 460 418 419 316 262 317 317 419 316 317 420 419 460 419 462 419 420 462 262 259 317 317 259 318 318 420 317 318 421 420 462 420 464 420 421 464 318 259 319 319 421 318 319 422 421 421 422 464 464 463 462 464 465 463 466 465 464 464 422 466 320 422 319 320 423 422 422 423 466 259 257 319 319 257 320 320 257 321 321 423 320 321 424 423 423 424 466 467 465 466 469 467 466 466 424 469 292 424 321 292 425 424 424 425 469 257 255 321 321 255 292 292 253 293 292 255 253 293 425 292 293 426 425 425 426 469 293 253 294 294 426 293 294 427 426 469 426 472 426 427 472 294 253 295 295 427 294 295 428 427 472 427 428 471 470 472 473 471 472 469 472 470 472 428 473 296 428 295 296 429 428 428 429 473 295 250 296 253 250 295 296 250 297 297 429 296 297 430 429 429 430 473 297 249 298 250 249 297 298 430 297 250 251 248 253 251 250 248 249 250 252 251 253 255 252 253 251 471 248 251 470 471 252 470 251 248 247 249 248 471 247 474 471 473 247 471 474 246 247 245 247 246 249 247 474 245 473 488 474 474 488 476 245 474 476 473 430 488 488 432 476 430 431 488 488 431 432 475 476 477 476 432 477 245 476 242 242 476 475 478 475 477 478 479 475 242 475 241 475 479 241 432 433 477 433 434 477 477 434 478 322 433 432 300 433 322 300 434 433 301 434 300 301 435 434 434 435 478 300 244 301 322 244 300 299 246 322 322 246 244 322 432 299 298 249 299 249 246 299 299 431 298 299 432 431 244 246 245 244 245 242 242 241 243 242 243 244 241 240 239 241 239 243 241 479 240 244 243 302 302 243 239 301 244 302 302 239 303 302 435 301 302 436 435 303 436 302 303 239 304 303 437 436 304 437 303 478 436 480 478 435 436 436 437 480 304 438 437 437 438 480 304 238 305 304 239 238 305 438 304 305 439 438 480 438 439 305 238 306 306 439 305 306 440 439 480 439 482 439 440 482 306 307 308 306 238 307 308 440 306 308 441 440 482 440 441 482 483 481 483 482 485 481 480 482 482 441 485 481 483 236 236 483 237 483 485 237 480 481 479 479 481 236 479 478 480 240 479 236 236 237 238 239 240 236 239 236 238 237 307 238 308 307 309 307 237 309 309 441 308 310 311 309 309 237 310 386 441 309 311 386 309 485 441 387 387 441 386 385 374 386 386 374 387 334 386 311 385 386 334 310 334 311 310 333 334 334 333 335 335 385 334 332 333 323 335 333 336 323 333 310 332 336 333 323 372 332 237 323 310 237 485 323 323 485 373 323 373 372 372 373 374 387 374 373 373 485 387 298 431 430 470 468 469 252 468 470 468 467 469 254 467 468 254 468 252 254 252 255 254 255 256 256 467 254 256 465 467 257 256 255 257 258 256 258 465 256 463 465 258 259 258 257 260 258 259 260 463 258 461 462 463 260 461 463 261 260 262 262 260 259 261 461 260 461 459 462 261 459 461 459 460 462 459 458 460 263 458 459 263 459 261 263 261 262 263 262 265 264 263 265 264 458 263 457 458 455 460 458 457 264 455 458 267 454 264 264 454 455 452 454 267 211 489 208 211 490 489 211 208 212 213 211 214 214 211 212 213 490 211 213 491 490 491 497 490 213 221 216 214 221 213 216 491 213 212 224 214 216 492 491 215 216 217 216 221 217 215 492 216 215 493 492 215 218 219 215 217 218 219 493 215 217 226 218 81 219 218 226 227 218 218 227 81 207 219 81 207 205 219 205 493 219 205 494 493 207 206 205 205 206 204 81 206 207 76 206 74 74 206 77 77 206 81 76 346 206 74 77 78 77 81 78 78 82 80 78 81 82 81 227 82 82 227 234 80 82 234 187 194 185 193 194 187 193 195 194 108 355 105 17 2 15 15 16 17 17 16 28 3 4 5 5 59 3 59 98 3 3 98 97 61 98 59 97 98 61 87 97 61))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(-3.0777401733398438e+02 -1.3134599685668945e+01 -6.5277297973632812e+01 -3.0890899658203125e+02 -1.3436499595642090e+01 -6.6128204345703125e+01 -3.0848898315429688e+02 -1.2156300544738770e+01 -6.7489898681640625e+01 -3.0911199951171875e+02 1.3857300758361816e+01 -6.4911697387695312e+01 -3.0809301757812500e+02 1.2844799995422363e+01 -6.5707603454589844e+01 -3.0908700561523438e+02 1.2757599830627441e+01 -6.6488800048828125e+01 -3.0741598510742188e+02 9.1581697463989258e+00 -6.8030799865722656e+01 -3.0743200683593750e+02 1.1357699632644653e+00 -7.1250404357910156e+01 -3.0755200195312500e+02 6.5072202682495117e+00 -7.0113601684570312e+01 -3.0779098510742188e+02 2.5019598007202148e+00 -7.1824401855468750e+01 -3.0809701538085938e+02 -2.0749799907207489e-01 -7.2356399536132812e+01 -3.0816500854492188e+02 8.5131797790527344e+00 -6.9865798950195312e+01 -3.0747198486328125e+02 1.0998499870300293e+01 -6.6724700927734375e+01 -3.0827297973632812e+02 4.9361696243286133e+00 -7.1659202575683594e+01 -3.0936300659179688e+02 -1.2094099998474121e+01 -6.7727699279785156e+01 -3.0913400268554688e+02 -9.1547393798828125e+00 -7.0200500488281250e+01 -3.0874401855468750e+02 -6.5513200759887695e+00 -7.1458999633789062e+01 -3.0836199951171875e+02 -9.1352300643920898e+00 -6.9879196166992188e+01 -3.0874197387695312e+02 1.1201799392700195e+01 -6.8146102905273438e+01 -3.0879000854492188e+02 -1.4139299392700195e+00 -7.2730598449707031e+01 -3.0904000854492188e+02 2.7335000038146973e+00 -7.2548004150390625e+01 -3.0909698486328125e+02 7.0038099288940430e+00 -7.1157295227050781e+01 -3.0894198608398438e+02 9.6879901885986328e+00 -6.9464401245117188e+01 -3.0740200805664062e+02 -4.7992997169494629e+00 -7.0437599182128906e+01 -3.0740698242187500e+02 -1.1925900459289551e+01 -6.5268203735351562e+01 -3.0754199218750000e+02 -1.0028899192810059e+01 -6.8128196716308594e+01 -3.0764300537109375e+02 -3.2011201381683350e+00 -7.1543296813964844e+01 -3.0873999023437500e+02 -4.5607099533081055e+00 -7.2146598815917969e+01 -3.0766799926757812e+02 -7.0771799087524414e+00 -7.0274803161621094e+01 -3.0742098999023438e+02 -4.0183998107910156e+01 -2.1452301025390625e+01 -3.0740802001953125e+02 1.8708299636840820e+01 -5.4010398864746094e+01 -3.0740499877929688e+02 -4.3257698059082031e+01 -1.3750299453735352e+01 -3.0741500854492188e+02 -2.9230400085449219e+01 -3.8711601257324219e+01 -3.0740600585937500e+02 -2.5514999389648438e+01 -4.4172397613525391e+01 -3.0741400146484375e+02 -4.5253799438476562e+01 -4.6156997680664062e+00 -3.0740600585937500e+02 -4.4674900054931641e+01 -7.8494100570678711e+00 -3.0742199707031250e+02 -4.5557800292968750e+01 3.5076099634170532e-01 -3.0740499877929688e+02 2.5097099304199219e+01 -4.4168498992919922e+01 -3.0741598510742188e+02 -3.3958599090576172e+01 3.0300600051879883e+01 -3.0740499877929688e+02 3.2176597595214844e+01 -3.3281597137451172e+01 -3.0744998168945312e+02 3.9432296752929688e+01 -2.2251699447631836e+01 -3.0741198730468750e+02 -4.1484199523925781e+01 1.8899799346923828e+01 -3.0741198730468750e+02 4.2879398345947266e+01 -1.4098400115966797e+01 -3.0741198730468750e+02 4.5136501312255859e+01 1.5318800210952759e+00 -3.0742098999023438e+02 4.4420001983642578e+01 7.9844098091125488e+00 -3.0742098999023438e+02 -4.5176700592041016e+01 6.0076003074645996e+00 -3.0742898559570312e+02 -2.5960100173950195e+01 3.7390399932861328e+01 -3.0740698242187500e+02 3.8804298400878906e+01 2.2947500228881836e+01 -3.0742300415039062e+02 -2.0350599288940430e+01 4.0660400390625000e+01 -3.0744100952148438e+02 4.1471199035644531e+01 1.8096599578857422e+01 -3.0744201660156250e+02 1.8971099853515625e+01 4.1111499786376953e+01 -3.0743899536132812e+02 6.4790902137756348e+00 4.5011901855468750e+01 -3.0742199707031250e+02 3.0382699966430664e+01 3.3553501129150391e+01 -3.0742098999023438e+02 2.3900499343872070e+01 3.8426399230957031e+01 -3.0740698242187500e+02 -3.2556700706481934e+00 4.5163799285888672e+01 -3.0741500854492188e+02 -1.1377300262451172e+01 4.3868999481201172e+01 -3.5859600830078125e+02 -1.3454799652099609e+01 -6.8481994628906250e+01 -3.5388601684570312e+02 -1.5468100547790527e+01 -6.5511001586914062e+01 -3.5234698486328125e+02 -1.6868200302124023e+01 -6.4264602661132812e+01 -3.5443499755859375e+02 1.3684099197387695e+01 -6.6598602294921875e+01 -3.5399401855468750e+02 1.5269899368286133e+01 -6.5500900268554688e+01 -3.5230401611328125e+02 1.4861100196838379e+01 -6.4912399291992188e+01 -3.6257800292968750e+02 -9.4689502716064453e+00 -7.1070404052734375e+01 -3.6351498413085938e+02 -9.7013902664184570e+00 -7.1218902587890625e+01 -3.6643402099609375e+02 -6.4989299774169922e+00 -7.2667999267578125e+01 -3.6567300415039062e+02 7.3989400863647461e+00 -7.2280494689941406e+01 -3.6675302124023438e+02 5.4714498519897461e+00 -7.2886604309082031e+01 -3.6838299560546875e+02 3.2701199054718018e+00 -7.3509796142578125e+01 -3.6326000976562500e+02 8.5408201217651367e+00 -7.1418800354003906e+01 -3.6149902343750000e+02 1.0832900047302246e+01 -7.0171897888183594e+01 -3.5851800537109375e+02 1.1550499916076660e+01 -6.9113998413085938e+01 -3.5756701660156250e+02 1.3215299606323242e+01 -6.7858894348144531e+01 -3.5856198120117188e+02 -1.2248899459838867e+01 -6.8877502441406250e+01 -3.5362399291992188e+02 -1.4572899818420410e+01 -6.5986602783203125e+01 -3.3215399169921875e+02 1.8854499816894531e+01 4.2447299957275391e+01 -3.3194299316406250e+02 1.8209499359130859e+01 4.2786502838134766e+01 -3.3076599121093750e+02 1.9378999710083008e+01 4.2072097778320312e+01 -3.3310400390625000e+02 1.8581600189208984e+01 4.2796100616455078e+01 -3.3372302246093750e+02 1.7810300827026367e+01 4.3835201263427734e+01 -3.3273699951171875e+02 1.7163200378417969e+01 4.3541099548339844e+01 -3.3337597656250000e+02 1.6962299346923828e+01 4.4191402435302734e+01 -3.3442498779296875e+02 1.8235700607299805e+01 4.3574699401855469e+01 -3.3432598876953125e+02 1.7697399139404297e+01 4.4726799011230469e+01 -3.4774301147460938e+02 1.8175600051879883e+01 -5.9922401428222656e+01 -3.4804998779296875e+02 1.7838901519775391e+01 -6.0701099395751953e+01 -3.4911099243164062e+02 1.8299200057983398e+01 -5.9591598510742188e+01 -3.4516702270507812e+02 1.8209600448608398e+01 -5.9186801910400391e+01 -3.4721401977539062e+02 1.7738599777221680e+01 -6.0491302490234375e+01 -3.0757400512695312e+02 3.2320899963378906e+01 -3.3943897247314453e+01 -3.0815100097656250e+02 3.2863697052001953e+01 -3.3983497619628906e+01 -3.0825399780273438e+02 4.0041801452636719e+01 -2.2384601593017578e+01 -3.0829400634765625e+02 1.9851400375366211e+01 -5.4726398468017578e+01 -3.0767898559570312e+02 1.9353599548339844e+01 -5.4420398712158203e+01 -3.0805700683593750e+02 2.6207599639892578e+01 -4.4415397644042969e+01 -3.0867001342773438e+02 2.6212598800659180e+01 -4.4845600128173828e+01 -3.5283300781250000e+02 1.6793399810791016e+01 -6.4555198669433594e+01 -3.5049798583984375e+02 1.6825199127197266e+01 -6.2927700042724609e+01 -3.4785598754882812e+02 1.6576200485229492e+01 -6.1840900421142578e+01 -3.4867901611328125e+02 1.5935000419616699e+01 -6.2878101348876953e+01 -3.4561801147460938e+02 1.7464500427246094e+01 -6.0293102264404297e+01 -3.4386798095703125e+02 1.8472700119018555e+01 -5.8608699798583984e+01 -3.4826998901367188e+02 1.8573200225830078e+01 -5.8583499908447266e+01 -3.0819299316406250e+02 -4.1763801574707031e+01 -1.9733398437500000e+01 -3.0838299560546875e+02 -4.1694297790527344e+01 -1.9700300216674805e+01 -3.0812500000000000e+02 -4.0101402282714844e+01 -2.2917699813842773e+01 -3.0824700927734375e+02 -4.3250602722167969e+01 -1.6238700866699219e+01 -3.0817602539062500e+02 -4.4506698608398438e+01 -1.2482199668884277e+01 -3.0809500122070312e+02 -4.5701499938964844e+01 -6.9559502601623535e+00 -3.0840701293945312e+02 -4.5228897094726562e+01 -9.5398902893066406e+00 -3.0838998413085938e+02 -4.5056701660156250e+01 1.0309000015258789e+01 -3.0812002563476562e+02 -4.6162200927734375e+01 2.9047498703002930e+00 -3.0805700683593750e+02 -4.5832897186279297e+01 6.0392103195190430e+00 -3.0745501708984375e+02 -4.4646499633789062e+01 -9.3849601745605469e+00 -3.0809301757812500e+02 -4.4233200073242188e+01 1.3391500473022461e+01 -3.0833300781250000e+02 -4.3069602966308594e+01 1.6769901275634766e+01 -3.0762402343750000e+02 -3.9583000183105469e+01 -2.3136699676513672e+01 -3.0769299316406250e+02 -4.2237899780273438e+01 -1.8133899688720703e+01 -3.0824700927734375e+02 3.6868000030517578e+01 2.7290800094604492e+01 -3.0807800292968750e+02 3.3857902526855469e+01 3.0938400268554688e+01 -3.0751300048828125e+02 3.5660400390625000e+01 2.8093601226806641e+01 -3.0778399658203125e+02 3.9360698699951172e+01 2.3194198608398438e+01 -3.0814001464843750e+02 4.0897899627685547e+01 2.0673700332641602e+01 -3.0801000976562500e+02 4.2826099395751953e+01 1.6164800643920898e+01 -3.0814401245117188e+02 4.4010597229003906e+01 -1.2731200218200684e+01 -3.0808599853515625e+02 4.5339302062988281e+01 -6.5539102554321289e+00 -3.0751498413085938e+02 4.4803798675537109e+01 -6.9697399139404297e+00 -3.0771301269531250e+02 4.3850700378417969e+01 -1.2457099914550781e+01 -3.0769299316406250e+02 4.1736000061035156e+01 -1.8333799362182617e+01 -3.0765798950195312e+02 -4.4618400573730469e+01 1.1058099746704102e+01 -3.0787799072265625e+02 -4.2569202423095703e+01 1.7706501007080078e+01 -3.0831097412109375e+02 -4.0279399871826172e+01 2.2628599166870117e+01 -3.0787799072265625e+02 -3.9817699432373047e+01 2.3217798233032227e+01 -3.0807598876953125e+02 -3.7323299407958984e+01 2.7167100906372070e+01 -3.0787799072265625e+02 -3.4371799468994141e+01 3.0672998428344727e+01 -3.0826699829101562e+02 -3.3645999908447266e+01 3.1581300735473633e+01 -3.0822198486328125e+02 -2.9970899581909180e+01 3.5063098907470703e+01 -3.0769400024414062e+02 -2.9891500473022461e+01 3.4892002105712891e+01 -3.0813699340820312e+02 -2.7060499191284180e+01 3.7395099639892578e+01 -3.0808099365234375e+02 -2.3659000396728516e+01 3.9577201843261719e+01 -3.0787799072265625e+02 -1.9612800598144531e+01 4.1610900878906250e+01 -3.0826800537109375e+02 -2.0746101379394531e+01 4.1155498504638672e+01 -3.0830700683593750e+02 -1.5793800354003906e+01 4.3276298522949219e+01 -3.0772299194335938e+02 -1.3930999755859375e+01 4.3724800109863281e+01 -3.0828799438476562e+02 -1.0092300415039062e+01 4.4953102111816406e+01 -3.0769400024414062e+02 1.4874399185180664e+01 4.3229499816894531e+01 -3.0831201171875000e+02 1.5331399917602539e+01 4.3292499542236328e+01 -3.0823999023437500e+02 1.0043100357055664e+01 4.4881198883056641e+01 -3.0818600463867188e+02 1.9736099243164062e+01 4.1463298797607422e+01 -3.0760400390625000e+02 4.3666198730468750e+01 1.2865600585937500e+01 -3.0813198852539062e+02 4.4497402191162109e+01 1.0942899703979492e+01 -3.0767300415039062e+02 -4.4242198944091797e+01 -1.2444700241088867e+01 -3.0767300415039062e+02 -7.8517198562622070e+00 4.5116500854492188e+01 -3.0823800659179688e+02 -4.2098999023437500e+00 4.5862701416015625e+01 -3.0767300415039062e+02 -1.7433099746704102e+00 4.5733699798583984e+01 -3.0819897460937500e+02 -2.0546099543571472e-01 4.5991996765136719e+01 -3.0809301757812500e+02 3.7694799900054932e+00 4.5863201141357422e+01 -3.0767300415039062e+02 1.0446099281311035e+01 4.4502002716064453e+01 -3.0769299316406250e+02 1.9041101455688477e+01 4.1531700134277344e+01 -3.0805798339843750e+02 2.4656499862670898e+01 3.8725799560546875e+01 -3.0763302612304688e+02 4.5456001281738281e+01 -1.8482500314712524e+00 -3.0801202392578125e+02 4.5776401519775391e+01 -5.7509404420852661e-01 -3.0816500854492188e+02 4.1998798370361328e+01 -1.8322900772094727e+01 -3.0797601318359375e+02 -4.6123798370361328e+01 -2.6660602092742920e+00 -3.0752798461914062e+02 -3.7866397857666016e+01 2.5615299224853516e+01 -3.0813598632812500e+02 2.7676300048828125e+01 3.6631301879882812e+01 -3.0810800170898438e+02 3.1050199508666992e+01 3.3764102935791016e+01 -3.0809201049804688e+02 4.5208900451660156e+01 7.3699698448181152e+00 -3.0814901733398438e+02 4.5692298889160156e+01 3.5811200141906738e+00 -3.4827102661132812e+02 -1.8986000061035156e+01 -5.8587100982666016e+01 -3.4696002197265625e+02 -1.8689500808715820e+01 -5.9367500305175781e+01 -3.4395098876953125e+02 -1.8891601562500000e+01 -5.8606597900390625e+01 -3.4903799438476562e+02 -1.8719999313354492e+01 -5.9654899597167969e+01 -3.6821301269531250e+02 -3.9714002609252930e+00 -7.3439903259277344e+01 -3.6927600097656250e+02 -4.5407101511955261e-01 -7.3886093139648438e+01 -3.0763500976562500e+02 -1.9697200775146484e+01 -5.4375999450683594e+01 -3.0820700073242188e+02 -2.0227798461914062e+01 -5.4703498840332031e+01 -3.0895800781250000e+02 -2.0475500106811523e+01 -5.4843601226806641e+01 -3.0807800292968750e+02 -3.3128601074218750e+01 -3.4182899475097656e+01 -3.0754699707031250e+02 -3.2692001342773438e+01 -3.3916397094726562e+01 -3.0792098999023438e+02 -2.6554100036621094e+01 -4.4374099731445312e+01 -3.4772399902343750e+02 -1.6902200698852539e+01 -6.1953300476074219e+01 -3.4597702026367188e+02 -1.8262199401855469e+01 -5.9891998291015625e+01 -3.5014199829101562e+02 -1.7591299057006836e+01 -6.2514202117919922e+01 -3.4767199707031250e+02 -1.8533699035644531e+01 -6.0060501098632812e+01 -3.4787399291992188e+02 -1.8014799118041992e+01 -6.0907100677490234e+01 -3.3323800659179688e+02 -1.6956501007080078e+01 4.4100399017333984e+01 -3.3350698852539062e+02 -1.7769201278686523e+01 4.4073299407958984e+01 -3.3247900390625000e+02 -1.8208200454711914e+01 4.3171600341796875e+01 -3.3391101074218750e+02 -1.8348800659179688e+01 4.3821201324462891e+01 -3.3460400390625000e+02 -1.8654600143432617e+01 4.3688800811767578e+01 -3.3347299194335938e+02 -1.8920099258422852e+01 4.2938499450683594e+01 -3.3249899291992188e+02 -1.9155700683593750e+01 4.2557701110839844e+01 -3.3137197875976562e+02 -1.9332500457763672e+01 4.2344001770019531e+01 -3.3218499755859375e+02 -1.6045900344848633e+01 4.3667800903320312e+01 -3.3416900634765625e+02 -1.2080599784851074e+01 4.5518699645996094e+01 -3.3350198364257812e+02 -1.0269700050354004e+01 4.5406501770019531e+01 -3.3501199340820312e+02 -4.1414098739624023e+00 4.6716602325439453e+01 -3.3429400634765625e+02 1.1957200765609741e+00 4.6490402221679688e+01 -3.3515701293945312e+02 2.5081298351287842e+00 4.6905799865722656e+01 -3.3394400024414062e+02 6.2567696571350098e+00 4.6052898406982422e+01 -3.3425000000000000e+02 1.0697500228881836e+01 4.5649299621582031e+01 -3.3314300537109375e+02 1.2673500061035156e+01 4.4747299194335938e+01 -3.3402499389648438e+02 -4.1446199417114258e+00 4.6321102142333984e+01 -3.3204400634765625e+02 1.5467700004577637e+01 4.3734798431396484e+01 -3.3449398803710938e+02 -1.9191200256347656e+01 4.2539802551269531e+01 -3.3520199584960938e+02 -1.8714500427246094e+01 4.3705501556396484e+01 -3.3456399536132812e+02 1.8653598785400391e+01 4.2649997711181641e+01 -3.3523498535156250e+02 1.8298999786376953e+01 4.3706996917724609e+01 -3.8721401977539062e+02 1.8290000915527344e+01 7.7091094970703125e+01 -3.9599902343750000e+02 1.8284700393676758e+01 7.8107994079589844e+01 -3.8734600830078125e+02 1.8068399429321289e+01 7.8080902099609375e+01 -3.7617001342773438e+02 1.8292701721191406e+01 7.4457603454589844e+01 -3.7788500976562500e+02 1.8144300460815430e+01 7.5767601013183594e+01 -3.6544601440429688e+02 1.8303298950195312e+01 7.0070404052734375e+01 -3.6853298950195312e+02 1.8120000839233398e+01 7.2395896911621094e+01 -3.4531301879882812e+02 1.8287399291992188e+01 5.5944400787353516e+01 -3.5517599487304688e+02 1.8292200088500977e+01 6.4084800720214844e+01 -3.5038198852539062e+02 1.8053300857543945e+01 6.1640399932861328e+01 -3.4179602050781250e+02 1.8168498992919922e+01 5.3178798675537109e+01 -3.4013699340820312e+02 1.8287099838256836e+01 5.0232299804687500e+01 -3.9900399780273438e+02 1.8168498992919922e+01 7.8731002807617188e+01 -3.6017401123046875e+02 1.7912700653076172e+01 6.8588897705078125e+01 -3.9898498535156250e+02 1.7538400650024414e+01 7.9622596740722656e+01 -3.9168499755859375e+02 1.7084300994873047e+01 7.9478599548339844e+01 -3.7383499145507812e+02 1.7084199905395508e+01 7.5507400512695312e+01 -3.5231799316406250e+02 1.7084199905395508e+01 6.4128303527832031e+01 -3.4293197631835938e+02 1.7054698944091797e+01 5.5967098236083984e+01 -3.3875799560546875e+02 1.7049900054931641e+01 5.1370899200439453e+01 -3.7952600097656250e+02 1.6897600173950195e+01 7.7291801452636719e+01 -3.6826000976562500e+02 1.6897600173950195e+01 7.3387603759765625e+01 -3.8570800781250000e+02 1.6744098663330078e+01 7.8688400268554688e+01 -3.6261199951171875e+02 1.6741199493408203e+01 7.0699806213378906e+01 -3.5732098388671875e+02 1.6741300582885742e+01 6.7637298583984375e+01 -3.4757998657226562e+02 1.6744098663330078e+01 6.0400699615478516e+01 -3.3517797851562500e+02 1.6757200241088867e+01 4.6834201812744141e+01 -3.9879501342773438e+02 1.6576099395751953e+01 8.0004699707031250e+01 -4.2094998168945312e+02 1.8291500091552734e+01 -7.5274993896484375e+01 -4.0897799682617188e+02 1.8295400619506836e+01 -7.7713806152343750e+01 -4.2165100097656250e+02 1.8046300888061523e+01 -7.6108406066894531e+01 -4.3368301391601562e+02 1.8066799163818359e+01 -7.1555999755859375e+01 -4.2932702636718750e+02 1.8287300109863281e+01 -7.2365295410156250e+01 -4.3791897583007812e+02 1.8290798187255859e+01 -6.8337295532226562e+01 -4.4704397583007812e+02 1.8278900146484375e+01 -6.2438201904296875e+01 -4.4024899291992188e+02 1.8168300628662109e+01 -6.7702400207519531e+01 -4.4796099853515625e+02 1.8041198730468750e+01 -6.2948001861572266e+01 -4.5348999023437500e+02 1.8277698516845703e+01 -5.7003299713134766e+01 -4.5680697631835938e+02 1.8154699325561523e+01 -5.4654502868652344e+01 -4.6027499389648438e+02 1.8282400131225586e+01 -4.9837200164794922e+01 -4.6683300781250000e+02 1.8287698745727539e+01 -4.0520103454589844e+01 -4.6470700073242188e+02 1.8049100875854492e+01 -4.5531898498535156e+01 -4.7021401977539062e+02 1.8066299438476562e+01 -3.6398101806640625e+01 -4.7110098266601562e+02 1.8283401489257812e+01 -3.2272499084472656e+01 -4.7480700683593750e+02 1.8290100097656250e+01 -2.2567701339721680e+01 -4.7583099365234375e+02 1.8067600250244141e+01 -2.2465700149536133e+01 -4.7704199218750000e+02 1.8281299591064453e+01 -1.3000800132751465e+01 -4.7790301513671875e+02 1.8165199279785156e+01 -1.2031899452209473e+01 -4.7798098754882812e+02 1.8273700714111328e+01 -5.7238497734069824e+00 -4.7882901000976562e+02 1.8164100646972656e+01 -5.2798201795667410e-04 -4.7809402465820312e+02 1.8276599884033203e+01 4.5136198997497559e+00 -4.7790399169921875e+02 1.8164800643920898e+01 1.2033299446105957e+01 -4.7691400146484375e+02 1.8280700683593750e+01 1.3716400146484375e+01 -4.7501300048828125e+02 1.8284099578857422e+01 2.1749601364135742e+01 -4.7514599609375000e+02 1.8169099807739258e+01 2.3780899047851562e+01 -4.7216400146484375e+02 1.8283599853515625e+01 2.9905300140380859e+01 -4.6688000488281250e+02 1.8285699844360352e+01 4.0490501403808594e+01 -4.7151101684570312e+02 1.8066799163818359e+01 3.3777099609375000e+01 -4.6447500610351562e+02 1.8165500640869141e+01 4.5349098205566406e+01 -4.5992498779296875e+02 1.8283401489257812e+01 5.0233699798583984e+01 -4.4300100708007812e+02 1.8284999847412109e+01 6.5297401428222656e+01 -4.5292599487304688e+02 1.8295200347900391e+01 5.7614299774169922e+01 -4.4778601074218750e+02 1.8164899826049805e+01 6.2691398620605469e+01 -4.3764999389648438e+02 1.8164299011230469e+01 6.9231101989746094e+01 -4.3148898315429688e+02 1.8285301208496094e+01 7.1530799865722656e+01 -4.3383300781250000e+02 1.8088600158691406e+01 7.1476699829101562e+01 -4.2098001098632812e+02 1.8293498992919922e+01 7.5242805480957031e+01 -4.2165802001953125e+02 1.8046800613403320e+01 7.6105598449707031e+01 -4.1296197509765625e+02 1.8280200958251953e+01 7.7048698425292969e+01 -4.0994198608398438e+02 1.8170999526977539e+01 7.8157798767089844e+01 -4.0525601196289062e+02 1.8281599044799805e+01 7.7986595153808594e+01 -4.0576300048828125e+02 1.7215499877929688e+01 7.9685501098632812e+01 -4.1821499633789062e+02 1.6923200607299805e+01 7.7839599609375000e+01 -4.2405099487304688e+02 1.6744199752807617e+01 7.6272102355957031e+01 -4.2965899658203125e+02 1.7054698944091797e+01 7.4222198486328125e+01 -4.3548501586914062e+02 1.6741300582885742e+01 7.1671997070312500e+01 -4.4083499145507812e+02 1.7085000991821289e+01 6.8687294006347656e+01 -4.5565600585937500e+02 1.7215299606323242e+01 5.7318199157714844e+01 -4.5922299194335938e+02 1.7825801849365234e+01 5.2779399871826172e+01 -4.5969998168945312e+02 1.6764101028442383e+01 5.3204200744628906e+01 -4.6342300415039062e+02 1.7054698944091797e+01 4.8642601013183594e+01 -4.7020098876953125e+02 1.7085000991821289e+01 3.8174098968505859e+01 -4.7297900390625000e+02 1.6741300582885742e+01 3.2713699340820312e+01 -4.7530401611328125e+02 1.7054698944091797e+01 2.6794898986816406e+01 -4.7842098999023438e+02 1.7054698944091797e+01 -1.5449600219726562e+01 -4.7710897827148438e+02 1.6763999938964844e+01 -2.1189800262451172e+01 -4.7530401611328125e+02 1.7054698944091797e+01 -2.6794898986816406e+01 -4.7303198242187500e+02 1.7054698944091797e+01 -3.2480796813964844e+01 -4.7025997924804688e+02 1.6741300582885742e+01 -3.8204200744628906e+01 -4.6707299804687500e+02 1.7085000991821289e+01 -4.3435901641845703e+01 -4.6365298461914062e+02 1.6744199752807617e+01 -4.8416801452636719e+01 -4.5951397705078125e+02 1.7054698944091797e+01 -5.3354801177978516e+01 -4.5084100341796875e+02 1.7085000991821289e+01 -6.1648799896240234e+01 -4.4601300048828125e+02 1.6740600585937500e+01 -6.5413101196289062e+01 -4.4064199829101562e+02 1.7054698944091797e+01 -6.8824798583984375e+01 -4.3548300170898438e+02 1.6763999938964844e+01 -7.1663696289062500e+01 -4.3009799194335938e+02 1.7054698944091797e+01 -7.4045501708984375e+01 -4.2405099487304688e+02 1.6744199752807617e+01 -7.6272102355957031e+01 -4.1821499633789062e+02 1.6923200607299805e+01 -7.7839599609375000e+01 -4.1209097290039062e+02 1.7950599670410156e+01 -7.8277000427246094e+01 -4.1229000854492188e+02 1.6744098663330078e+01 -7.9024398803710938e+01 -4.0575701904296875e+02 1.7215600967407227e+01 -7.9686004638671875e+01 -3.9849099731445312e+02 1.7926599502563477e+01 -7.9246696472167969e+01 -3.9871600341796875e+02 1.6813098907470703e+01 -7.9975097656250000e+01 -4.1196798706054688e+02 1.7054698944091797e+01 7.9027694702148438e+01 -4.4579101562500000e+02 1.7054698944091797e+01 6.5511802673339844e+01 -4.5103601074218750e+02 1.7054698944091797e+01 6.1513599395751953e+01 -4.6721801757812500e+02 1.7054698944091797e+01 4.3248199462890625e+01 -4.7713400268554688e+02 1.7054698944091797e+01 2.0951799392700195e+01 -4.7844699096679688e+02 1.7085000991821289e+01 1.5213900566101074e+01 -4.7937399291992188e+02 1.7054698944091797e+01 9.4011602401733398e+00 -4.7987899780273438e+02 1.7054698944091797e+01 2.8254101276397705e+00 -4.7985000610351562e+02 1.7085000991821289e+01 -3.0607199668884277e+00 -4.7942797851562500e+02 1.7054698944091797e+01 -8.9317598342895508e+00 -4.5514398193359375e+02 1.7215299606323242e+01 -5.7811000823974609e+01 -3.9442599487304688e+02 1.8301601409912109e+01 -7.8043106079101562e+01 -3.5790698242187500e+02 1.6792699813842773e+01 -6.8023300170898438e+01 -3.5752801513671875e+02 1.7446399688720703e+01 -6.7453102111816406e+01 -3.5088000488281250e+02 1.7737901687622070e+01 -6.2550903320312500e+01 -3.5763299560546875e+02 1.8135799407958984e+01 -6.6536399841308594e+01 -3.6277600097656250e+02 1.8297700881958008e+01 -6.8711898803710938e+01 -3.5451300048828125e+02 1.8288700103759766e+01 -6.3541004180908203e+01 -3.7331100463867188e+02 1.8294300079345703e+01 -7.3417098999023438e+01 -3.6757299804687500e+02 1.8056100845336914e+01 -7.2166702270507812e+01 -3.8293200683593750e+02 1.8290498733520508e+01 -7.6239494323730469e+01 -3.8948800659179688e+02 1.8055500030517578e+01 -7.8417602539062500e+01 -3.9138601684570312e+02 1.6765199661254883e+01 -7.9503402709960938e+01 -3.8602600097656250e+02 1.6900299072265625e+01 -7.8726203918457031e+01 -3.7918402099609375e+02 1.8003599166870117e+01 -7.6385803222656250e+01 -3.8040399169921875e+02 1.6742900848388672e+01 -7.7538902282714844e+01 -3.7243499755859375e+02 1.6814300537109375e+01 -7.5100105285644531e+01 -3.7253399658203125e+02 1.7564399719238281e+01 -7.4712501525878906e+01 -3.6470898437500000e+02 1.6744098663330078e+01 -7.1768600463867188e+01 -3.4902502441406250e+02 1.8247001647949219e+01 -6.0278999328613281e+01 -3.4214898681640625e+02 2.2111900329589844e+01 -5.2632400512695312e+01 -3.3367401123046875e+02 2.8810699462890625e+01 -4.1474597930908203e+01 -3.2832299804687500e+02 3.5164798736572266e+01 -3.0980701446533203e+01 -3.2546899414062500e+02 3.9781002044677734e+01 -2.3407499313354492e+01 -3.3303399658203125e+02 2.3119001388549805e+01 4.0198699951171875e+01 -3.3004400634765625e+02 3.0693899154663086e+01 3.4748497009277344e+01 -3.2680999755859375e+02 3.7340202331542969e+01 2.7238300323486328e+01 -3.2473498535156250e+02 4.1168701171875000e+01 2.0895099639892578e+01 -3.2234698486328125e+02 4.5231597900390625e+01 8.9706306457519531e+00 -3.2343301391601562e+02 4.3421802520751953e+01 1.5444099426269531e+01 -3.2183599853515625e+02 4.6051799774169922e+01 1.7238899469375610e+00 -3.2202801513671875e+02 4.5745700836181641e+01 -5.8653898239135742e+00 -3.2339199829101562e+02 4.3496200561523438e+01 -1.5415699958801270e+01 -3.2300000000000000e+02 -4.4564998626708984e+01 -1.3251200675964355e+01 -3.2201000976562500e+02 -4.6191200256347656e+01 -5.6455097198486328e+00 -3.2467300415039062e+02 -4.1689498901367188e+01 -2.0746400833129883e+01 -3.2184600830078125e+02 -4.6448497772216797e+01 2.2471199035644531e+00 -3.2236001586914062e+02 -4.5622901916503906e+01 8.9496297836303711e+00 -3.2347900390625000e+02 -4.3757202148437500e+01 1.5668200492858887e+01 -3.2478698730468750e+02 -4.1491600036621094e+01 2.1054599761962891e+01 -3.2729299926757812e+02 -3.6815299987792969e+01 2.8473800659179688e+01 -3.2988598632812500e+02 -3.1410701751708984e+01 3.4375297546386719e+01 -3.3240197753906250e+02 -2.5392400741577148e+01 3.9142501831054688e+01 -3.4323599243164062e+02 -2.1857301712036133e+01 -5.3755699157714844e+01 -3.3589898681640625e+02 -2.7210300445556641e+01 -4.4820899963378906e+01 -3.2866098022460938e+02 -3.4986400604248047e+01 -3.1955301284790039e+01 -3.4869000244140625e+02 -1.8358900070190430e+01 -6.0926799774169922e+01 -3.5226101684570312e+02 -1.8713901519775391e+01 -6.1846698760986328e+01 -3.5241299438476562e+02 -1.8509799957275391e+01 -6.2945297241210938e+01 -3.5211700439453125e+02 -1.7899900436401367e+01 -6.3648300170898438e+01 -3.8156597900390625e+02 -1.8708999633789062e+01 -7.5953102111816406e+01 -3.9468899536132812e+02 -1.8728399276733398e+01 -7.8057601928710938e+01 -3.8872097778320312e+02 -1.8487998962402344e+01 -7.8286697387695312e+01 -3.7328698730468750e+02 -1.8710401535034180e+01 -7.3361396789550781e+01 -3.7615600585937500e+02 -1.8470899581909180e+01 -7.5448600769042969e+01 -3.5934201049804688e+02 -1.8747900009155273e+01 -6.6779701232910156e+01 -3.5904397583007812e+02 -1.7999399185180664e+01 -6.8277801513671875e+01 -3.5919299316406250e+02 -1.7031999588012695e+01 -6.8844306945800781e+01 -3.6671899414062500e+02 -1.7667098999023438e+01 -7.2603500366210938e+01 -3.6608599853515625e+02 -1.8735300064086914e+01 -7.0381599426269531e+01 -3.7212698364257812e+02 -1.7319099426269531e+01 -7.4940002441406250e+01 -3.7821398925781250e+02 -1.7167600631713867e+01 -7.6949501037597656e+01 -3.8414401245117188e+02 -1.7506401062011719e+01 -7.8320396423339844e+01 -3.9012899780273438e+02 -1.7166700363159180e+01 -7.9362800598144531e+01 -3.9835501098632812e+02 -1.7237701416015625e+01 -7.9969894409179688e+01 -3.9829098510742188e+02 -1.8202899932861328e+01 -7.9377304077148438e+01 -3.3436599731445312e+02 -1.8178800582885742e+01 4.4697898864746094e+01 -3.3517700195312500e+02 -1.7168001174926758e+01 4.6834899902343750e+01 -3.3898898315429688e+02 -1.7501399993896484e+01 5.1609699249267578e+01 -3.4293099975585938e+02 -1.7471799850463867e+01 5.5965698242187500e+01 -3.4772399902343750e+02 -1.7471799850463867e+01 6.0466598510742188e+01 -3.5231900024414062e+02 -1.7501399993896484e+01 6.4127899169921875e+01 -3.5714797973632812e+02 -1.7471799850463867e+01 6.7473701477050781e+01 -3.6242602539062500e+02 -1.7471799850463867e+01 7.0549301147460938e+01 -3.6847399902343750e+02 -1.7633001327514648e+01 7.3413696289062500e+01 -3.7383499145507812e+02 -1.7501399993896484e+01 7.5507003784179688e+01 -3.7934197998046875e+02 -1.7633001327514648e+01 7.7180000305175781e+01 -3.8577499389648438e+02 -1.7314300537109375e+01 7.8681495666503906e+01 -3.9168899536132812e+02 -1.7666399002075195e+01 7.9435401916503906e+01 -3.9880499267578125e+02 -1.6979700088500977e+01 8.0005302429199219e+01 -4.0575799560546875e+02 -1.7630599975585938e+01 7.9685897827148438e+01 -4.1212698364257812e+02 -1.7159198760986328e+01 7.9049598693847656e+01 -4.1821499633789062e+02 -1.7338199615478516e+01 7.7839599609375000e+01 -4.2405099487304688e+02 -1.7159198760986328e+01 7.6272102355957031e+01 -4.2965899658203125e+02 -1.7469699859619141e+01 7.4222198486328125e+01 -4.3548501586914062e+02 -1.7156299591064453e+01 7.1671997070312500e+01 -4.4083499145507812e+02 -1.7500000000000000e+01 6.8687294006347656e+01 -4.4601300048828125e+02 -1.7155601501464844e+01 6.5413101196289062e+01 -4.5103601074218750e+02 -1.7469699859619141e+01 6.1513599395751953e+01 -4.5565600585937500e+02 -1.7630298614501953e+01 5.7318199157714844e+01 -4.5965600585937500e+02 -1.7500000000000000e+01 5.3165397644042969e+01 -4.6355300903320312e+02 -1.7159198760986328e+01 4.8548099517822266e+01 -4.6721801757812500e+02 -1.7469699859619141e+01 4.3248199462890625e+01 -4.7025201416015625e+02 -1.7178998947143555e+01 3.8201999664306641e+01 -4.7283801269531250e+02 -1.7469699859619141e+01 3.2911800384521484e+01 -4.7530401611328125e+02 -1.7469699859619141e+01 2.6794898986816406e+01 -4.7713699340820312e+02 -1.7159198760986328e+01 2.1112098693847656e+01 -4.7844699096679688e+02 -1.7500000000000000e+01 1.5213900566101074e+01 -4.7937399291992188e+02 -1.7469699859619141e+01 9.4011602401733398e+00 -4.7987899780273438e+02 -1.7469699859619141e+01 2.8254101276397705e+00 -4.7985000610351562e+02 -1.7500000000000000e+01 -3.0607199668884277e+00 -4.7942797851562500e+02 -1.7469699859619141e+01 -8.9317502975463867e+00 -4.7842098999023438e+02 -1.7469699859619141e+01 -1.5449600219726562e+01 -4.7705200195312500e+02 -1.7500000000000000e+01 -2.1174398422241211e+01 -4.7530401611328125e+02 -1.7469699859619141e+01 -2.6794898986816406e+01 -4.7297702026367188e+02 -1.7155698776245117e+01 -3.2717498779296875e+01 -4.7010498046875000e+02 -1.7469699859619141e+01 -3.8390899658203125e+01 -4.6707299804687500e+02 -1.7500000000000000e+01 -4.3435901641845703e+01 -4.6371002197265625e+02 -1.7469699859619141e+01 -4.8266799926757812e+01 -4.5965002441406250e+02 -1.7159198760986328e+01 -5.3270599365234375e+01 -4.5514398193359375e+02 -1.7630298614501953e+01 -5.7811000823974609e+01 -4.5084100341796875e+02 -1.7500000000000000e+01 -6.1648799896240234e+01 -4.4579101562500000e+02 -1.7469699859619141e+01 -6.5511802673339844e+01 -4.4064199829101562e+02 -1.7469699859619141e+01 -6.8824798583984375e+01 -4.3543801879882812e+02 -1.7664300918579102e+01 -7.1572494506835938e+01 -4.3009799194335938e+02 -1.7469699859619141e+01 -7.4045501708984375e+01 -4.2405099487304688e+02 -1.7159198760986328e+01 -7.6272102355957031e+01 -4.1821499633789062e+02 -1.7338199615478516e+01 -7.7839599609375000e+01 -4.1229000854492188e+02 -1.7159198760986328e+01 -7.9024398803710938e+01 -4.0576199340820312e+02 -1.7630298614501953e+01 -7.9685699462890625e+01 -3.9886999511718750e+02 -1.7958600997924805e+01 7.9610900878906250e+01 -4.2094998168945312e+02 -1.8706501007080078e+01 7.5274993896484375e+01 -4.0897799682617188e+02 -1.8710401535034180e+01 7.7713699340820312e+01 -4.2165100097656250e+02 -1.8461299896240234e+01 7.6108299255371094e+01 -4.3368301391601562e+02 -1.8481800079345703e+01 7.1555999755859375e+01 -4.2932702636718750e+02 -1.8702301025390625e+01 7.2365295410156250e+01 -4.3791897583007812e+02 -1.8705801010131836e+01 6.8337295532226562e+01 -4.4704397583007812e+02 -1.8693899154663086e+01 6.2438201904296875e+01 -4.4024899291992188e+02 -1.8583299636840820e+01 6.7702400207519531e+01 -4.4796099853515625e+02 -1.8456199645996094e+01 6.2948001861572266e+01 -4.5348999023437500e+02 -1.8692699432373047e+01 5.7003299713134766e+01 -4.5680697631835938e+02 -1.8569700241088867e+01 5.4654502868652344e+01 -4.6027499389648438e+02 -1.8697399139404297e+01 4.9837200164794922e+01 -4.6683300781250000e+02 -1.8702701568603516e+01 4.0520000457763672e+01 -4.6470700073242188e+02 -1.8464099884033203e+01 4.5531898498535156e+01 -4.7021401977539062e+02 -1.8481298446655273e+01 3.6398101806640625e+01 -4.7110098266601562e+02 -1.8698400497436523e+01 3.2272499084472656e+01 -4.7480700683593750e+02 -1.8705099105834961e+01 2.2567701339721680e+01 -4.7583099365234375e+02 -1.8482599258422852e+01 2.2465700149536133e+01 -4.7704199218750000e+02 -1.8696300506591797e+01 1.3000800132751465e+01 -4.7790301513671875e+02 -1.8580200195312500e+01 1.2031899452209473e+01 -4.7798098754882812e+02 -1.8688699722290039e+01 5.7238402366638184e+00 -4.7882901000976562e+02 -1.8579099655151367e+01 5.1649397937580943e-04 -4.7809402465820312e+02 -1.8691598892211914e+01 -4.5136504173278809e+00 -4.7790399169921875e+02 -1.8579799652099609e+01 -1.2033299446105957e+01 -4.7691400146484375e+02 -1.8695701599121094e+01 -1.3716400146484375e+01 -4.7501300048828125e+02 -1.8699100494384766e+01 -2.1749601364135742e+01 -4.7514599609375000e+02 -1.8584199905395508e+01 -2.3780899047851562e+01 -4.7216400146484375e+02 -1.8698598861694336e+01 -2.9905300140380859e+01 -4.6688000488281250e+02 -1.8700700759887695e+01 -4.0490501403808594e+01 -4.7151101684570312e+02 -1.8481800079345703e+01 -3.3777099609375000e+01 -4.6447500610351562e+02 -1.8580600738525391e+01 -4.5349098205566406e+01 -4.5992498779296875e+02 -1.8698400497436523e+01 -5.0233699798583984e+01 -4.4300100708007812e+02 -1.8700099945068359e+01 -6.5297401428222656e+01 -4.5292599487304688e+02 -1.8710199356079102e+01 -5.7614299774169922e+01 -4.4778601074218750e+02 -1.8579900741577148e+01 -6.2691398620605469e+01 -4.3764999389648438e+02 -1.8579299926757812e+01 -6.9231101989746094e+01 -4.3148898315429688e+02 -1.8700401306152344e+01 -7.1530799865722656e+01 -4.2535400390625000e+02 -1.8483900070190430e+01 -7.4913398742675781e+01 -4.2098001098632812e+02 -1.8708499908447266e+01 -7.5242805480957031e+01 -4.1432897949218750e+02 -1.8464698791503906e+01 -7.7813903808593750e+01 -4.1296197509765625e+02 -1.8695199966430664e+01 -7.7048698425292969e+01 -4.1209097290039062e+02 -1.8365598678588867e+01 7.8277000427246094e+01 -4.0553097534179688e+02 -1.8722299575805664e+01 -7.7983497619628906e+01 -3.9549499511718750e+02 -1.8713500976562500e+01 7.8084098815917969e+01 -3.9929898071289062e+02 -1.8511899948120117e+01 7.8904701232910156e+01 -4.5922299194335938e+02 -1.8240800857543945e+01 -5.2779399871826172e+01 -3.8448901367187500e+02 -1.8707201004028320e+01 7.6625396728515625e+01 -3.7216101074218750e+02 -1.8709199905395508e+01 7.3030502319335938e+01 -3.6097399902343750e+02 -1.8706998825073242e+01 6.7708595275878906e+01 -3.5148901367187500e+02 -1.8700599670410156e+01 6.1335601806640625e+01 -3.4308901977539062e+02 -1.8699800491333008e+01 5.3666000366210938e+01 -3.3985998535156250e+02 -1.8588998794555664e+01 5.0872501373291016e+01 -3.4603399658203125e+02 -1.8586299896240234e+01 5.7465698242187500e+01 -3.5541598510742188e+02 -1.8587099075317383e+01 6.5012901306152344e+01 -3.6584201049804688e+02 -1.8586599349975586e+01 7.1023796081542969e+01 -3.7705697631835938e+02 -1.8586400985717773e+01 7.5398200988769531e+01 -3.8708499145507812e+02 -1.8545400619506836e+01 7.7871704101562500e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 33 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01) (float-vector -3.2201001048088074e+02 -4.6191200613975525e+01 -5.6455098092556000e+00) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01) (float-vector -3.0904000997543335e+02 2.7334999758750200e+00 -7.2548002004623413e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.9835500717163086e+02 -1.7237700521945953e+01 -7.9969897866249084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.7615600228309631e+02 -1.8470900133252144e+01 -7.5448602437973022e+01) (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7987899184226990e+02 1.7054699361324310e+01 2.8254101052880287e+00) (float-vector -4.7020098567008972e+02 1.7085000872612000e+01 3.8174100220203400e+01) (float-vector -4.7283801436424255e+02 -1.7469700425863266e+01 3.2911799848079681e+01) (float-vector -4.7987899184226990e+02 -1.7469700425863266e+01 2.8254101052880287e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01) (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5565599203109741e+02 -1.7630299553275108e+01 5.7318199425935745e+01) (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01) (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2405098676681519e+02 -1.7159199342131615e+01 7.6272100210189819e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.2236000895500183e+02 -4.5622900128364563e+01 8.9496299624443054e+00) (float-vector -4.3791899085044861e+02 -1.8705800175666809e+01 6.8337298929691315e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0890899896621704e+02 -1.3436499983072281e+01 -6.6128201782703400e+01) (float-vector -3.0812498927116394e+02 -4.0101401507854462e+01 -2.2917699068784714e+01) (float-vector -3.0797600746154785e+02 -4.6123798936605453e+01 -2.6660601142793894e+00) (float-vector -3.0809301137924194e+02 -4.4233199208974838e+01 1.3391500338912010e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01) (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01) (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.0911201238632202e+02 1.3857300393283367e+01 -6.4911700785160065e+01) (float-vector -3.0740201473236084e+02 -4.7992998734116554e+00 -7.0437602698802948e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5922300219535828e+02 1.7825800925493240e+01 5.2779398858547211e+01) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -4.2405098676681519e+02 1.6744200140237808e+01 7.6272100210189819e+01) (float-vector -4.4579100608825684e+02 1.7054699361324310e+01 6.5511800348758698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.0801001191139221e+02 4.2826101183891296e+01 1.6164800152182579e+01) (float-vector -3.0810800194740295e+02 3.1050199642777443e+01 3.3764101564884186e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01) (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.4579100608825684e+02 -1.7469700425863266e+01 -6.5511800348758698e+01) (float-vector -4.2535400390625000e+02 -1.8483899533748627e+01 -7.4913397431373596e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.5084100961685181e+02 1.7085000872612000e+01 -6.1648800969123840e+01) (float-vector -4.1821500658988953e+02 1.6923200339078903e+01 -7.7839598059654236e+01) (float-vector -3.9871600270271301e+02 1.6813099384307861e+01 -7.9975098371505737e+01) (float-vector -3.0825400352478027e+02 4.0041800588369370e+01 -2.2384600713849068e+01) (float-vector -3.0751499533653259e+02 4.4803798198699951e+01 -6.9697401486337185e+00) (float-vector -3.2183599472045898e+02 4.6051800251007080e+01 1.7238899599760771e+00) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6365299820899963e+02 1.6744200140237808e+01 -4.8416800796985626e+01) (float-vector -4.7842100262641907e+02 1.7054699361324310e+01 -1.5449600294232368e+01) (float-vector -4.7705200314521790e+02 -1.7500000074505806e+01 -2.1174399182200432e+01) (float-vector -4.6707299351692200e+02 -1.7500000074505806e+01 -4.3435901403427124e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.8734599947929382e+02 1.8068399280309677e+01 7.8080900013446808e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0769398808479309e+02 1.4874399639666080e+01 4.3229501694440842e+01) (float-vector -3.0767300724983215e+02 -7.8517198562622070e+00 4.5116499066352844e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.6853298544883728e+02 1.8120000138878822e+01 7.2395898401737213e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8577499985694885e+02 -1.7314299941062927e+01 7.8681498765945435e+01) (float-vector -3.6847400665283203e+02 -1.7633000388741493e+01 7.3413699865341187e+01) (float-vector -3.0808100104331970e+02 -2.3659000173211098e+01 3.9577201008796692e+01) (float-vector -3.0807599425315857e+02 -3.7323299795389175e+01 2.7167100459337234e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_elbow_flex_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_forearm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 3 1 0 2 4 0 0 756 3 0 702 709 702 0 4 706 756 0 709 706 0 1 3 698 698 3 737 3 756 737 737 756 698 756 759 698 759 756 705 705 756 706 636 634 706 706 709 636 706 634 705 636 10 528 634 636 528 10 636 9 636 709 9 528 527 634 527 635 634 634 635 705 527 528 374 528 529 374 10 529 528 527 374 526 526 635 527 637 635 526 635 637 704 704 705 635 374 373 526 526 373 523 523 637 526 638 637 523 704 637 638 703 704 638 703 705 704 759 705 762 703 762 705 703 641 710 703 638 641 762 703 760 710 760 703 524 638 523 524 641 638 520 640 641 520 641 524 710 641 640 523 521 524 524 521 520 520 518 517 520 521 518 517 640 520 519 640 517 642 640 519 710 640 642 517 518 519 518 386 519 518 521 378 386 518 378 523 373 521 521 373 378 373 377 378 380 386 378 378 377 380 372 373 374 373 372 377 372 379 377 377 379 380 386 380 387 379 389 380 380 389 387 372 384 379 384 385 379 389 379 385 389 390 387 389 489 390 389 345 489 345 389 385 387 388 386 387 390 388 390 391 388 488 391 390 390 489 488 514 388 515 516 388 514 388 391 515 388 516 386 519 386 516 522 519 516 516 514 522 514 639 522 514 643 639 515 643 514 522 639 642 522 642 519 708 639 643 642 639 708 515 644 643 708 643 644 644 707 708 710 642 708 757 710 708 707 757 708 515 691 644 644 691 707 690 691 623 515 623 691 691 690 707 689 690 622 622 690 623 690 689 711 690 711 707 622 623 620 530 623 515 530 620 623 515 391 530 620 530 490 490 530 391 491 620 490 619 620 491 621 620 619 622 620 621 621 689 622 619 499 621 499 500 621 621 631 689 500 631 621 496 619 491 499 619 496 497 499 496 497 500 499 497 498 500 498 630 500 631 500 630 497 492 495 498 497 495 497 496 492 348 349 496 492 496 349 348 496 491 345 344 348 344 349 348 491 489 348 489 345 348 344 350 349 350 492 349 344 345 346 227 350 344 344 347 227 446 447 344 344 453 454 454 347 344 447 453 344 446 344 346 345 396 346 346 396 446 448 447 446 396 531 446 446 531 448 394 396 393 393 396 392 392 396 345 531 396 394 395 531 394 531 534 448 395 534 531 383 382 394 382 395 394 383 394 393 393 392 384 384 383 393 384 392 345 345 385 384 376 384 372 376 383 384 381 382 383 381 383 376 381 525 382 525 7 382 382 7 395 375 381 376 375 529 381 529 525 381 376 372 375 374 375 372 374 529 375 525 529 10 10 8 525 7 525 8 10 9 8 7 8 5 9 5 8 709 5 9 5 6 7 6 5 709 6 709 702 6 646 532 7 6 532 6 701 646 702 701 6 701 702 692 702 4 749 702 749 692 646 701 692 647 532 646 646 692 647 532 533 7 532 647 533 7 533 395 533 534 395 533 647 534 647 648 578 647 578 534 693 648 647 693 647 692 448 534 451 534 578 451 578 579 572 451 578 572 645 579 578 578 648 645 648 693 645 694 693 696 693 694 645 693 750 696 692 750 693 645 694 695 694 696 697 694 697 695 785 696 750 792 696 785 696 792 697 749 750 692 749 743 750 743 785 750 743 780 785 785 791 792 785 780 791 792 794 697 791 794 792 780 815 791 820 794 791 791 835 820 815 835 791 780 814 815 835 815 836 815 814 836 820 835 841 841 835 836 794 820 817 820 841 817 841 842 817 842 841 843 841 836 847 849 841 847 841 849 843 814 837 836 836 837 847 847 848 849 837 838 847 847 838 848 814 813 837 813 838 837 838 813 812 838 812 839 848 838 839 848 850 849 851 850 848 848 839 851 812 834 839 839 834 851 851 831 850 851 840 831 851 834 811 811 840 851 809 811 834 812 816 834 809 834 816 810 811 808 808 811 809 811 831 840 811 810 831 807 831 810 808 807 810 808 809 786 786 807 808 786 787 788 788 795 786 809 787 786 807 786 795 787 789 788 790 789 787 787 809 790 788 789 755 755 795 788 765 795 755 713 795 765 807 795 734 734 795 713 753 754 755 789 753 755 754 765 755 753 789 790 781 790 809 790 781 753 753 781 754 745 754 781 745 764 754 754 764 765 744 745 736 745 781 736 763 764 745 744 763 745 712 764 763 712 765 764 712 763 707 707 763 758 763 744 758 736 741 744 741 758 744 740 757 758 740 758 741 757 707 758 711 712 707 689 712 711 688 689 631 712 689 688 633 688 631 712 688 713 713 688 734 633 734 688 629 631 630 633 631 629 629 687 633 633 687 731 633 731 734 776 734 731 776 807 734 687 733 731 775 776 731 733 775 731 775 807 776 775 803 807 803 831 807 774 775 733 775 802 803 774 802 775 732 733 678 687 678 733 774 733 732 730 774 732 768 774 730 774 804 802 768 804 774 676 730 732 732 678 676 665 730 676 721 730 665 768 730 721 772 768 721 806 804 768 772 806 768 806 824 804 804 824 832 832 802 804 798 806 772 823 824 806 798 823 806 830 824 823 830 850 824 824 850 832 832 833 802 832 846 833 850 846 832 802 831 803 802 833 831 833 846 831 846 850 831 849 850 830 849 830 819 849 819 845 843 849 845 818 819 799 799 819 827 819 818 845 830 827 819 844 843 845 818 844 845 843 844 842 793 844 818 793 842 844 793 818 799 799 800 766 766 793 799 799 827 800 827 828 800 827 830 828 766 800 771 769 800 796 771 800 769 800 828 796 828 829 796 828 830 829 770 796 797 769 796 770 796 830 797 796 829 830 769 770 727 769 727 729 771 769 729 672 727 675 727 726 675 672 729 727 770 726 727 672 671 729 728 729 671 771 729 728 671 672 673 673 672 670 670 672 675 670 675 668 675 726 668 670 668 593 673 670 590 590 670 593 668 669 593 668 726 669 590 593 591 593 24 591 669 24 593 589 590 591 589 594 590 594 673 590 592 591 23 591 24 13 592 589 591 23 591 13 13 24 20 662 20 24 24 669 662 11 12 13 14 11 13 13 20 14 12 23 13 21 23 12 23 21 592 21 12 17 17 12 11 11 14 15 15 17 11 14 660 15 14 666 660 14 662 666 20 662 14 15 16 17 18 16 15 15 660 661 15 661 18 660 663 661 666 667 660 660 667 663 666 722 667 666 723 722 662 723 666 667 718 663 722 718 667 663 664 661 718 719 663 663 719 664 661 664 18 664 665 18 664 720 665 719 720 664 719 772 720 719 718 773 773 772 719 767 773 718 722 767 718 773 798 772 767 805 773 773 805 798 720 772 721 665 720 721 18 665 19 665 676 19 18 19 16 16 19 25 25 19 597 19 681 597 676 681 19 681 676 678 681 678 597 25 597 596 596 597 677 597 680 677 597 678 680 678 679 680 678 687 679 679 677 680 466 677 604 596 677 466 677 679 604 596 595 25 596 466 595 462 466 461 595 466 462 466 599 461 466 604 599 604 603 599 603 604 605 679 605 604 679 687 605 605 606 603 683 606 605 605 687 683 600 599 603 603 601 600 601 603 606 461 599 598 598 599 600 600 469 598 600 601 602 600 602 469 601 682 685 601 685 602 606 682 601 683 682 606 682 683 684 684 685 682 613 685 684 613 617 685 686 685 617 602 685 686 686 618 602 602 618 469 618 686 617 613 616 617 617 616 614 614 618 617 469 618 614 609 610 614 614 616 609 615 614 610 615 469 614 608 616 612 608 609 616 616 613 612 478 609 608 476 609 478 476 610 609 476 611 610 611 615 610 470 615 611 615 470 469 467 469 470 598 469 467 467 470 468 468 470 611 475 611 476 474 611 475 468 611 474 474 475 335 476 335 475 474 335 332 332 471 474 471 468 474 52 335 48 336 48 335 52 332 335 476 336 335 52 38 332 38 333 332 333 471 332 471 472 468 333 472 471 325 333 38 325 473 333 473 472 333 468 472 314 472 473 314 467 468 465 468 318 465 314 318 468 313 195 314 314 195 196 314 196 318 314 473 313 206 302 318 207 206 318 196 207 318 302 465 318 464 465 302 464 467 465 598 467 464 461 464 312 312 464 302 464 461 598 206 194 302 302 193 312 302 194 193 108 193 194 108 194 114 194 206 114 61 107 108 114 61 108 108 191 193 107 191 108 61 191 107 61 192 191 192 309 191 191 309 193 190 192 61 190 309 192 308 309 190 308 193 309 189 190 61 190 189 304 304 308 190 308 305 310 304 305 308 308 310 193 304 189 303 303 305 304 109 189 61 109 188 189 303 189 188 303 188 204 303 306 305 204 307 303 307 306 303 59 188 109 113 188 59 204 188 113 61 59 109 59 61 60 61 114 60 114 115 116 60 114 116 206 207 114 114 207 115 115 195 116 115 196 195 207 196 115 195 197 116 116 197 60 313 197 195 60 197 198 197 313 198 198 313 205 313 473 205 198 110 60 198 205 110 110 205 199 205 315 199 317 315 205 205 473 317 317 473 325 324 315 317 317 325 324 315 316 200 199 315 200 316 315 324 199 200 111 110 199 111 201 111 200 200 202 201 200 254 202 254 200 316 110 111 62 62 111 59 111 112 59 111 201 112 58 110 62 60 110 58 62 59 58 58 59 60 112 113 59 112 201 113 113 201 203 204 113 203 201 202 203 203 202 204 204 202 307 463 306 307 463 307 415 307 202 415 306 311 305 306 463 311 311 312 310 305 311 310 312 311 463 193 310 312 312 463 459 459 461 312 459 460 461 460 459 560 459 463 560 461 460 462 560 561 460 460 587 462 561 587 460 562 563 560 560 563 561 560 463 562 463 415 562 562 416 565 415 416 562 562 565 563 561 563 564 563 566 564 563 565 568 568 566 563 565 416 569 569 570 565 568 565 570 568 573 571 573 568 649 566 568 571 568 570 649 570 569 652 649 570 652 559 569 416 653 652 569 569 559 653 650 649 652 650 652 651 653 651 652 573 649 576 649 650 576 574 650 651 576 650 574 574 651 292 651 550 292 549 651 653 550 651 549 549 653 559 547 544 549 550 549 545 551 547 549 549 544 545 551 549 559 292 550 545 544 536 545 418 545 536 418 417 545 417 292 545 544 547 536 418 536 419 419 536 535 535 536 546 546 536 547 418 259 417 418 419 259 257 293 417 417 259 257 293 292 417 257 259 100 100 259 167 167 259 260 419 260 259 99 257 100 258 257 99 257 258 293 98 99 100 98 100 166 100 167 166 167 260 166 260 261 166 419 422 260 261 260 422 166 103 98 166 261 103 103 261 262 420 421 261 420 261 422 421 262 261 422 419 535 422 535 420 539 420 535 420 539 421 423 262 421 421 538 423 539 538 421 539 535 540 538 539 542 540 542 539 546 540 535 541 542 540 543 541 540 548 543 540 540 546 548 546 547 548 411 548 547 548 407 543 407 548 411 407 406 543 543 406 541 406 407 408 408 407 405 405 407 248 409 248 407 411 409 407 411 412 409 547 412 411 551 412 547 409 412 410 412 413 410 412 414 413 414 412 551 246 248 409 409 410 246 410 247 246 251 247 410 410 413 251 414 250 413 413 250 251 247 251 158 158 251 250 157 246 247 157 247 158 157 248 246 157 158 153 153 155 157 155 248 157 159 160 158 158 160 153 159 158 250 159 250 163 414 163 250 160 159 163 160 154 153 154 160 156 160 163 156 153 154 155 154 152 155 152 248 155 154 156 152 156 150 152 150 156 162 156 163 164 164 165 156 156 165 162 150 151 152 150 161 151 162 243 150 150 243 161 165 243 162 164 253 165 256 165 253 402 243 165 256 402 165 164 252 253 163 252 164 253 254 256 254 253 252 316 256 254 256 316 402 403 243 402 401 403 402 316 401 402 316 324 323 401 316 323 400 401 322 322 401 323 401 400 403 322 323 35 35 323 324 35 324 37 324 325 37 34 33 35 35 47 34 35 37 47 35 33 322 37 53 47 53 34 47 36 37 38 37 36 53 325 38 37 36 34 53 38 42 36 42 34 36 52 42 38 51 42 52 42 40 34 40 42 51 48 51 52 48 40 51 39 40 41 41 40 48 34 40 39 41 48 334 48 336 334 49 39 41 41 334 337 41 337 49 49 50 39 34 39 50 50 122 34 50 49 122 49 212 122 49 331 212 49 337 338 338 331 49 337 358 338 334 477 337 477 358 337 331 338 358 331 330 212 330 331 357 331 358 357 363 364 358 364 357 358 477 479 358 479 363 358 357 362 330 365 362 357 365 357 364 363 237 364 236 365 364 364 237 236 237 363 339 363 479 339 340 339 479 480 340 479 477 480 479 74 339 127 74 237 339 339 340 127 76 236 237 76 237 74 74 75 76 75 236 76 75 74 77 126 74 127 126 128 74 74 128 77 127 217 126 127 340 217 217 128 126 77 128 29 341 128 342 128 341 29 128 217 342 217 340 480 342 217 480 481 342 480 483 341 342 483 342 481 29 341 30 484 30 341 484 341 483 481 482 483 482 484 483 480 607 481 607 482 481 607 480 477 477 608 607 608 612 607 607 612 482 482 485 484 482 612 485 484 485 486 486 30 484 613 486 485 485 612 613 486 487 28 30 486 28 486 502 487 502 486 684 613 684 486 487 26 28 343 487 371 343 26 487 502 371 487 26 27 28 27 30 28 80 26 343 27 26 80 343 241 80 241 343 371 241 371 370 370 371 502 81 241 242 79 241 81 80 241 79 370 242 241 77 80 79 77 27 80 79 78 77 81 78 79 81 238 78 242 238 81 367 242 370 238 242 367 624 370 502 370 624 367 238 367 368 503 368 367 624 503 367 78 238 239 368 239 238 366 239 368 368 369 366 503 501 368 368 501 369 503 507 501 624 627 503 627 507 503 501 507 506 507 511 506 627 632 507 632 512 507 507 512 511 624 628 627 495 632 627 495 627 628 632 495 494 494 512 632 511 512 493 493 512 494 493 494 492 494 495 492 495 628 498 628 624 626 630 628 626 628 630 498 625 626 624 625 629 626 626 629 630 624 502 625 502 684 625 684 683 625 683 629 625 683 687 629 492 350 354 493 492 354 218 350 227 218 219 350 219 351 350 350 351 354 227 224 226 226 218 227 347 224 227 224 222 223 226 224 223 347 222 224 225 226 223 225 218 226 132 223 221 133 223 132 223 222 221 223 133 225 146 221 222 347 234 222 222 234 146 144 69 221 221 146 144 69 131 221 132 221 131 145 144 146 146 234 145 144 145 143 70 144 143 69 144 70 69 70 55 55 131 69 64 131 55 132 131 64 55 63 64 63 132 64 63 133 132 66 63 55 66 134 63 225 133 63 134 225 63 55 65 66 65 135 66 135 134 66 225 134 218 135 228 134 228 218 134 130 135 65 135 130 228 55 71 65 65 129 130 71 129 65 218 130 219 219 130 220 130 218 228 130 129 220 149 129 71 129 149 220 220 149 235 220 235 351 220 351 219 73 149 71 73 138 149 138 235 149 138 230 235 235 230 351 351 352 353 351 353 354 351 230 352 136 229 230 138 136 230 230 229 352 136 138 73 72 73 71 72 136 73 72 137 136 136 137 229 54 72 71 54 137 72 54 71 55 54 55 56 56 68 54 54 68 137 68 147 137 147 229 137 56 67 68 139 68 140 67 140 68 139 147 68 55 57 56 57 67 56 55 70 67 67 57 55 140 67 142 142 67 143 70 143 67 140 141 139 142 141 140 142 181 141 143 234 142 142 234 181 145 234 143 178 234 289 181 234 178 347 289 234 290 178 289 454 453 289 454 289 347 453 457 289 289 457 290 290 444 439 290 439 288 288 178 290 290 457 444 453 458 457 457 458 580 444 457 580 444 443 439 580 443 444 439 440 284 443 440 439 439 284 288 430 440 443 441 430 443 443 580 441 441 580 458 430 441 294 445 441 574 574 441 575 294 441 445 441 458 575 291 445 292 294 445 291 574 292 445 574 575 576 576 575 577 575 456 577 575 458 456 577 573 576 573 577 455 455 577 456 455 456 453 456 458 453 447 455 453 452 455 447 452 573 455 571 573 452 447 449 452 452 449 571 448 449 447 450 449 448 450 571 449 571 450 572 566 571 572 451 450 448 451 572 450 579 567 572 572 567 566 564 566 567 567 659 655 567 655 564 579 659 567 716 659 579 716 579 645 655 659 656 659 716 714 659 714 656 655 656 654 564 655 561 561 655 654 656 658 654 714 715 656 658 656 715 716 747 714 714 747 748 748 715 714 716 645 747 747 751 752 645 751 747 747 793 748 752 794 747 747 794 793 766 715 748 748 793 766 794 817 793 817 842 793 697 794 752 697 752 751 695 697 751 695 751 645 766 717 715 717 766 771 717 657 715 717 728 657 717 771 728 658 715 657 654 657 588 654 658 657 657 674 588 657 728 674 674 728 671 588 674 673 673 674 671 586 588 583 583 588 594 654 588 586 594 588 673 561 654 586 582 586 583 587 561 586 586 582 587 581 582 583 585 581 583 585 583 594 589 585 594 592 585 589 21 585 592 581 585 21 462 581 21 581 462 584 581 584 582 584 587 582 587 584 462 22 462 21 595 462 22 17 22 21 595 22 17 595 17 25 25 17 16 291 292 293 293 184 291 184 294 291 258 184 293 182 184 99 184 258 99 184 182 294 294 183 295 182 183 294 295 430 294 105 182 99 183 182 105 98 105 99 98 183 105 98 186 183 295 183 296 186 296 183 296 430 295 429 430 296 429 433 430 433 440 430 296 186 297 297 429 296 185 186 98 297 186 185 187 298 297 187 297 185 428 429 297 298 428 297 102 185 98 102 187 185 104 187 102 104 264 187 187 301 298 264 301 187 298 299 300 301 299 298 298 300 428 264 424 301 301 424 299 106 263 264 106 264 104 263 424 264 101 104 102 101 106 104 98 101 102 103 101 98 103 106 101 103 262 106 106 262 263 262 424 263 423 424 262 423 299 424 537 423 538 423 537 434 423 434 299 555 538 542 555 537 538 555 542 556 556 554 555 555 554 537 542 541 557 542 557 556 557 552 556 556 552 554 404 552 557 541 408 557 408 404 557 406 408 541 408 405 404 403 404 245 405 245 404 403 553 404 404 553 552 552 553 554 553 398 554 553 403 398 403 244 243 403 245 244 403 400 398 161 243 244 161 244 245 161 245 151 151 245 152 245 249 152 152 249 248 248 249 405 405 249 245 398 321 320 397 398 320 398 399 321 398 400 399 554 398 397 321 33 320 33 321 322 399 322 321 320 33 319 319 397 320 31 32 33 33 34 31 33 32 319 46 319 32 46 269 319 269 276 319 276 397 319 45 46 32 32 31 45 45 31 34 43 44 45 44 46 45 45 34 43 269 46 44 209 44 117 117 44 43 209 269 44 43 34 117 34 118 117 118 209 117 118 208 209 209 270 267 209 208 270 267 269 209 118 34 119 118 210 208 119 210 118 270 208 274 208 210 274 270 271 272 267 270 272 274 271 270 267 268 269 272 268 267 268 273 269 268 437 436 437 268 272 268 436 273 273 276 269 300 273 436 300 276 273 300 436 435 436 437 435 435 437 432 432 437 438 272 438 437 435 432 428 435 428 300 299 434 300 434 276 300 537 276 434 558 276 537 537 554 558 554 397 558 276 558 397 428 425 429 428 432 425 425 426 427 429 425 427 432 431 425 425 431 426 427 433 429 426 442 427 427 442 433 431 285 426 426 285 442 432 438 431 431 282 285 431 279 282 438 279 431 281 285 282 281 286 285 286 442 285 442 440 433 442 286 440 283 286 281 286 283 284 440 286 284 174 283 281 174 175 283 283 175 284 287 288 284 175 287 284 175 177 287 287 177 288 175 174 84 92 175 84 90 177 175 175 92 90 84 174 173 174 281 173 84 173 85 173 176 85 176 173 281 280 176 281 280 281 282 85 176 87 176 172 87 280 172 176 85 82 84 85 87 82 82 83 84 86 82 87 82 86 83 84 83 90 83 91 90 83 86 91 90 92 84 91 97 90 90 97 177 86 95 91 91 95 97 97 95 178 178 288 97 97 288 177 96 95 86 178 95 181 181 95 96 93 96 86 93 168 96 179 181 96 179 96 277 96 168 277 179 180 181 141 181 180 179 277 180 168 278 277 278 275 277 277 275 233 180 277 233 180 232 141 233 232 180 141 231 139 141 232 231 265 232 266 266 232 233 265 231 232 266 233 275 275 274 266 274 211 266 216 266 211 216 265 266 274 275 271 274 210 211 120 211 119 211 210 119 120 216 211 215 216 121 121 216 120 215 265 216 34 120 119 121 120 34 123 121 34 123 215 121 214 215 123 265 215 326 214 326 215 124 123 34 124 214 123 34 125 124 122 125 34 125 213 124 213 214 124 122 212 125 212 213 125 214 213 328 213 329 328 213 212 330 213 330 329 214 328 327 359 327 328 328 360 359 328 329 360 329 361 360 330 362 329 329 362 361 508 360 361 359 360 509 509 360 508 362 505 361 361 505 508 365 501 362 501 504 362 362 504 505 506 505 504 506 511 505 505 511 508 511 509 508 511 513 509 493 513 511 513 354 509 354 513 493 353 509 354 509 353 510 510 353 352 359 509 510 352 359 510 352 229 355 355 359 352 359 355 327 229 356 355 355 356 326 327 355 326 148 229 147 148 356 229 231 356 148 326 356 265 265 356 231 214 327 326 139 231 148 148 147 139 501 506 504 501 365 369 366 369 365 365 236 366 240 239 366 240 366 236 75 240 236 239 240 78 78 240 75 77 78 75 29 27 77 29 30 27 275 272 271 272 275 278 438 272 278 168 169 278 171 279 278 278 169 170 278 170 171 279 438 278 94 168 93 169 168 94 89 169 94 89 170 169 88 170 89 88 171 170 87 88 89 87 89 86 89 93 86 89 94 93 87 171 88 87 172 171 171 172 280 279 171 280 280 282 279 322 399 400 477 478 608 334 478 477 336 478 334 336 476 478 254 252 255 255 202 254 255 252 163 255 163 414 255 415 202 415 255 416 255 414 416 416 414 551 551 559 416 805 826 798 798 826 823 767 801 805 805 822 825 805 825 826 801 822 805 830 826 825 830 823 826 825 822 830 801 821 822 822 821 830 770 797 801 770 801 767 797 821 801 830 821 797 723 767 722 770 767 724 723 724 767 770 724 726 662 724 725 669 724 662 726 724 669 725 724 723 725 723 662 713 765 712 761 757 739 739 757 740 710 757 761 738 761 739 738 760 761 761 760 710 738 739 736 740 736 739 736 740 741 698 735 736 736 1 698 1 736 2 736 742 743 743 2 736 738 736 735 736 781 782 736 779 742 736 782 779 743 4 2 743 742 780 4 743 749 779 780 742 777 778 779 779 778 780 779 783 777 782 783 779 781 784 782 784 783 782 783 812 777 784 812 783 812 813 777 777 813 778 813 814 778 778 814 780 816 812 784 781 816 784 809 816 781 735 698 746 746 760 735 735 760 738 698 699 700 746 698 700 698 759 699 746 762 760 700 762 746 699 759 700 700 759 762 488 489 490 490 489 491 490 391 488))
                   (list :vertices (let ((mat (make-matrix 852 3))) (fvector-replace (array-entity mat) #f(3.1503201293945312e+02 -2.6000200271606445e+01 3.1107799530029297e+01 3.1210299682617188e+02 -2.2538099288940430e+01 3.0156898498535156e+01 3.0351998901367188e+02 -2.2642599105834961e+01 2.6287000656127930e+01 3.2023300170898438e+02 -2.2628198623657227e+01 3.1645801544189453e+01 3.0166598510742188e+02 -2.6000000000000000e+01 2.4887201309204102e+01 3.1413900756835938e+02 -2.7637699127197266e+01 3.5655200958251953e+01 3.0485998535156250e+02 -2.7090000152587891e+01 3.2474300384521484e+01 3.0621401977539062e+02 -4.7460700988769531e+01 3.1538799285888672e+01 3.1489102172851562e+02 -4.6480598449707031e+01 3.4614997863769531e+01 3.2225601196289062e+02 -2.7598400115966797e+01 3.6376499176025391e+01 3.2470501708984375e+02 -4.6435901641845703e+01 3.5191402435302734e+01 3.4354098510742188e+02 5.5921497344970703e+01 -2.9861898422241211e+00 3.3653500366210938e+02 5.8014999389648438e+01 2.0056300163269043e+00 3.4594900512695312e+02 5.4418300628662109e+01 8.5914497375488281e+00 3.5430300903320312e+02 5.0840999603271484e+01 2.4503500461578369e+00 3.4914300537109375e+02 5.3070301055908203e+01 -9.2625198364257812e+00 3.3879400634765625e+02 5.4328502655029297e+01 -1.9524900436401367e+01 3.3256500244140625e+02 5.7484500885009766e+01 -1.3136400222778320e+01 3.4745999145507812e+02 5.0817501068115234e+01 -2.0239900588989258e+01 3.4122000122070312e+02 5.0550502777099609e+01 -2.6544099807739258e+01 3.5305801391601562e+02 5.0655601501464844e+01 9.6949996948242188e+00 3.2543600463867188e+02 5.9633899688720703e+01 2.3389501571655273e+00 3.2558102416992188e+02 5.8834701538085938e+01 -9.5504798889160156e+00 3.3411700439453125e+02 5.7560501098632812e+01 1.1150799751281738e+01 3.4844799804687500e+02 5.1167400360107422e+01 1.7657300949096680e+01 3.2238800048828125e+02 5.5477298736572266e+01 -2.7290700912475586e+01 1.9252600097656250e+02 1.0846799850463867e+01 -4.6685199737548828e+01 1.9210499572753906e+02 1.2420199394226074e+01 -4.2988899230957031e+01 1.9144400024414062e+02 1.3404799461364746e+01 -4.6701999664306641e+01 1.8877600097656250e+02 1.4924700736999512e+01 -4.2712902069091797e+01 1.8871900939941406e+02 1.5120499610900879e+01 -4.6546100616455078e+01 9.4099998474121094e+01 1.9113899230957031e+01 4.1929302215576172e+01 9.6000000000000000e+01 1.7761299133300781e+01 4.2602401733398438e+01 9.6000000000000000e+01 2.9828901290893555e+01 3.5211399078369141e+01 9.4099998474121094e+01 3.0099000930786133e+01 3.4966201782226562e+01 9.6000000000000000e+01 4.0535900115966797e+01 2.2388198852539062e+01 9.4099998474121094e+01 4.5999298095703125e+01 -2.5075099468231201e+00 9.6000000000000000e+01 4.5940299987792969e+01 5.3986601829528809e+00 9.6000000000000000e+01 4.5343101501464844e+01 -8.3319101333618164e+00 9.4099998474121094e+01 1.4253199577331543e+01 -4.3782497406005859e+01 9.4099998474121094e+01 2.4428400039672852e+01 -3.9134101867675781e+01 9.6000000000000000e+01 1.7903499603271484e+01 -4.2521900177001953e+01 9.4099998474121094e+01 4.3421199798583984e+01 -1.5967300415039062e+01 9.4099998474121094e+01 -2.5075199604034424e+00 4.5999298095703125e+01 9.6000000000000000e+01 -4.9403500556945801e+00 4.5868999481201172e+01 9.4099998474121094e+01 8.5027494430541992e+00 4.5290599822998047e+01 9.6000000000000000e+01 6.9224400520324707e+00 4.5515701293945312e+01 9.4099998474121094e+01 4.0428501129150391e+01 2.2525299072265625e+01 9.6000000000000000e+01 2.9708101272583008e+01 -3.5342102050781250e+01 9.6000000000000000e+01 0.0000000000000000e+00 -4.6383499145507812e+01 9.4099998474121094e+01 1.1513199806213379e+00 -4.6282897949218750e+01 9.4099998474121094e+01 3.5193202972412109e+01 -2.9797599792480469e+01 9.5999893188476562e+01 4.0535900115966797e+01 -2.2388198852539062e+01 9.4099998474121094e+01 4.5290599822998047e+01 8.5027494430541992e+00 1.1449799346923828e+02 -5.4985900878906250e+01 1.0246600210666656e-01 1.6139100646972656e+02 -5.4474498748779297e+01 1.5267199516296387e+01 1.1492399597167969e+02 -5.3801902770996094e+01 1.3189599990844727e+01 1.1827100372314453e+02 -5.3557197570800781e+01 1.5704700469970703e+01 1.1456500244140625e+02 5.4046398162841797e+01 1.1930899620056152e+01 1.6205101013183594e+02 5.4473098754882812e+01 1.5230500221252441e+01 1.1449799346923828e+02 5.4952899932861328e+01 -5.0631499290466309e-01 1.9848799133300781e+02 5.4588798522949219e+01 8.7717199325561523e+00 1.1737200164794922e+02 5.3428897857666016e+01 1.5774799346923828e+01 1.9834700012207031e+02 -5.4612098693847656e+01 9.9916105270385742e+00 1.9508399963378906e+02 -5.4600299835205078e+01 1.2764999389648438e+01 1.9543899536132812e+02 -5.4609500885009766e+01 -2.2776599884033203e+01 1.9847300720214844e+02 -5.4600101470947266e+01 -1.8770498275756836e+01 1.1801000213623047e+02 -5.6789100646972656e+01 1.6025999069213867e+01 1.1470700073242188e+02 -5.7083202362060547e+01 1.2998600006103516e+01 1.7906199645996094e+02 -5.8092697143554688e+01 1.4217900276184082e+01 1.5562300109863281e+02 -5.7344100952148438e+01 1.5327599525451660e+01 1.5060299682617188e+02 -5.4384201049804688e+01 -1.8485000610351562e+01 1.1496300506591797e+02 -5.3961399078369141e+01 -1.4977100372314453e+01 1.1815799713134766e+02 -5.3665199279785156e+01 -1.7477600097656250e+01 1.1450300598144531e+02 -4.6117700636386871e-02 -4.8416397094726562e+01 1.1806999969482422e+02 -1.4916299819946289e+01 -4.7087699890136719e+01 1.1481100463867188e+02 -1.2154200553894043e+01 -4.7796699523925781e+01 1.5903900146484375e+02 0.0000000000000000e+00 -4.5461200714111328e+01 1.6580801391601562e+02 -1.4999899864196777e+01 -4.3654399871826172e+01 1.9231800842285156e+02 -1.1470999717712402e+01 -4.3075698852539062e+01 1.9250000000000000e+02 -2.2548599168658257e-02 -4.4213298797607422e+01 1.9006599426269531e+02 -1.4576200485229492e+01 -4.2775798797607422e+01 1.4618598937988281e+02 -4.6352401733398438e+01 3.4799999237060547e+01 1.5291799926757812e+02 -4.7074199676513672e+01 3.1825901031494141e+01 1.5574400329589844e+02 -4.1765701293945312e+01 3.6404899597167969e+01 1.4334599304199219e+02 -4.1123699188232422e+01 4.4964298248291016e+01 1.4058599853515625e+02 -5.1456001281738281e+01 2.6736299514770508e+01 1.3604299926757812e+02 -4.1494602203369141e+01 4.7087501525878906e+01 1.1658799743652344e+02 -4.0450199127197266e+01 4.7407299041748047e+01 1.1505500030517578e+02 -4.1527198791503906e+01 4.5400001525878906e+01 1.6374301147460938e+02 -4.8115398406982422e+01 2.8495100021362305e+01 1.6200000000000000e+02 -5.0874900817871094e+01 2.6188699722290039e+01 1.6343598937988281e+02 -4.5519100189208984e+01 3.0637399673461914e+01 1.1663199615478516e+02 -5.0418296813964844e+01 2.7047800064086914e+01 1.1499900054931641e+02 -4.9221099853515625e+01 2.9731700897216797e+01 1.4397999572753906e+02 -5.6872497558593750e+01 2.6555898666381836e+01 1.1713100433349609e+02 -5.4999401092529297e+01 2.7023500442504883e+01 1.6224099731445312e+02 -5.6271602630615234e+01 2.6360898971557617e+01 1.6478900146484375e+02 -2.6097599029541016e+01 3.7846496582031250e+01 1.7602799987792969e+02 -2.2235900878906250e+01 3.0518098831176758e+01 1.7598100280761719e+02 2.2768199920654297e+01 3.0473800659179688e+01 1.3647599792480469e+02 3.0222597718238831e-01 6.0534999847412109e+01 1.3731401062011719e+02 -2.6060400009155273e+01 5.9662300109863281e+01 1.3678799438476562e+02 2.5955900192260742e+01 6.0024600982666016e+01 1.3419100952148438e+02 -2.2424900054931641e+01 6.1047599792480469e+01 1.7361399841308594e+02 -2.5739299774169922e+01 3.1662300109863281e+01 1.3419400024414062e+02 2.2285598754882812e+01 6.1078800201416016e+01 1.9844099426269531e+02 5.4599998474121094e+01 -1.8855800628662109e+01 1.9537701416015625e+02 5.4601799011230469e+01 -2.2832698822021484e+01 1.9622898864746094e+02 5.4599998474121094e+01 1.2469599723815918e+01 1.1460199737548828e+02 5.7295898437500000e+01 1.2719099998474121e+01 1.1741699981689453e+02 5.7041500091552734e+01 1.5914099693298340e+01 1.5520500183105469e+02 5.7338401794433594e+01 1.5354599952697754e+01 1.7483801269531250e+02 5.8720397949218750e+01 1.4711700439453125e+01 1.5269200134277344e+02 5.4454700469970703e+01 -1.8558200836181641e+01 1.1732300567626953e+02 5.3655899047851562e+01 -1.7380100250244141e+01 1.1462999725341797e+02 5.4087898254394531e+01 -1.3886399269104004e+01 9.4099998474121094e+01 -1.5967300415039062e+01 4.3421199798583984e+01 9.4099998474121094e+01 -2.9797599792480469e+01 3.5193202972412109e+01 9.4099998474121094e+01 -3.9889297485351562e+01 2.3322601318359375e+01 9.4099998474121094e+01 -4.5168601989746094e+01 9.3440008163452148e+00 9.4099998474121094e+01 -4.5733699798583984e+01 -6.4106898307800293e+00 9.4099998474121094e+01 -1.1184000015258789e+01 -4.4662700653076172e+01 9.4099998474121094e+01 -4.0859600067138672e+01 -2.1622798919677734e+01 9.4099998474121094e+01 -3.3650497436523438e+01 -3.1403099060058594e+01 9.4099998474121094e+01 -2.3322601318359375e+01 -3.9889297485351562e+01 1.1816299438476562e+02 1.4855200767517090e+01 -4.7273899078369141e+01 1.1470100402832031e+02 1.1991200447082520e+01 -4.7840801239013672e+01 1.4635099792480469e+02 1.4995599746704102e+01 -4.4941898345947266e+01 1.7382901000976562e+02 -5.7973701477050781e+01 -2.0439800262451172e+01 1.9407499694824219e+02 -5.8817600250244141e+01 -2.3077199935913086e+01 1.9486199951171875e+02 -5.8171699523925781e+01 1.2886500358581543e+01 1.9716000366210938e+02 -5.8459400177001953e+01 1.1561400413513184e+01 1.9854600524902344e+02 -5.8514698028564453e+01 9.3722000122070312e+00 1.9862799072265625e+02 -5.8520202636718750e+01 -1.8454799652099609e+01 1.9731600952148438e+02 -5.8183498382568359e+01 -2.1319400787353516e+01 1.1651899719238281e+02 -5.7500797271728516e+01 -1.6842800140380859e+01 1.1451300048828125e+02 -5.7821300506591797e+01 -1.4249500274658203e+01 1.1868499755859375e+02 -5.7057102203369141e+01 -1.7608499526977539e+01 1.1335899353027344e+02 -5.8828399658203125e+01 1.2669400215148926e+01 1.1621300506591797e+02 -5.7982097625732422e+01 1.6174900054931641e+01 1.1567399597167969e+02 -5.8013198852539062e+01 1.8026498794555664e+01 1.1936399841308594e+02 -5.8166198730468750e+01 1.7376100540161133e+01 1.4368099975585938e+02 -5.8733501434326172e+01 1.6344900131225586e+01 1.7113299560546875e+02 -5.8815399169921875e+01 1.5044799804687500e+01 1.5535899353027344e+02 -5.9240402221679688e+01 1.6519599914550781e+01 1.7652099609375000e+02 -5.9584598541259766e+01 1.6065599441528320e+01 1.1419599914550781e+02 -5.9047100067138672e+01 3.4203498363494873e+00 1.1299700164794922e+02 -6.0056499481201172e+01 3.0513799190521240e-01 1.4397599792480469e+02 -5.7933597564697266e+01 -1.8289299011230469e+01 1.1499800109863281e+02 4.9119201660156250e+01 2.9836200714111328e+01 1.1737900543212891e+02 4.0256103515625000e+01 4.7608100891113281e+01 1.3669100952148438e+02 4.1682003021240234e+01 4.6998500823974609e+01 1.5196800231933594e+02 4.4445598602294922e+01 3.5241500854492188e+01 1.4598300170898438e+02 4.6994800567626953e+01 3.3551200866699219e+01 1.4392500305175781e+02 4.1058399200439453e+01 4.4687698364257812e+01 1.4013198852539062e+02 5.1463203430175781e+01 2.6760999679565430e+01 1.5581500244140625e+02 4.1901699066162109e+01 3.6347999572753906e+01 1.6367100524902344e+02 4.5910499572753906e+01 3.0266199111938477e+01 1.6314999389648438e+02 4.9716899871826172e+01 2.7135099411010742e+01 1.6098300170898438e+02 5.0988903045654297e+01 2.6129699707031250e+01 1.1510100555419922e+02 4.1385597229003906e+01 4.5929698944091797e+01 1.1653900146484375e+02 5.0318599700927734e+01 2.7125000000000000e+01 1.6186499023437500e+02 5.6938999176025391e+01 2.6204700469970703e+01 1.3925099182128906e+02 5.5904399871826172e+01 2.6750699996948242e+01 1.1676499938964844e+02 5.4973300933837891e+01 2.7038900375366211e+01 1.6682400512695312e+02 2.6060499191284180e+01 3.6166198730468750e+01 1.7307099914550781e+02 2.5920801162719727e+01 3.1978599548339844e+01 1.1516399383544922e+02 -5.3939899444580078e+01 2.8469499588012695e+01 1.1497799682617188e+02 -4.5840999603271484e+01 4.5402698516845703e+01 1.1589299774169922e+02 -4.4332099914550781e+01 4.6953800201416016e+01 1.1770200347900391e+02 -4.3677898406982422e+01 4.7819499969482422e+01 1.3104000854492188e+02 -4.4282600402832031e+01 4.7534999847412109e+01 1.4513301086425781e+02 -4.4246799468994141e+01 4.4137500762939453e+01 1.5508399963378906e+02 -4.4877296447753906e+01 3.7028396606445312e+01 1.6315600585937500e+02 -4.9108402252197266e+01 3.1481500625610352e+01 1.4001699829101562e+02 -4.4498802185058594e+01 4.6318401336669922e+01 1.6388699340820312e+02 -5.2401302337646484e+01 2.9196201324462891e+01 1.6203799438476562e+02 -5.8043598175048828e+01 2.5633199691772461e+01 1.1688999938964844e+02 -5.5850101470947266e+01 2.6519300460815430e+01 1.1569000244140625e+02 -5.6270698547363281e+01 2.5694499969482422e+01 1.3211799621582031e+02 -5.7453598022460938e+01 2.5795801162719727e+01 1.7737699890136719e+02 -2.3623001098632812e+01 3.3894699096679688e+01 1.7473100280761719e+02 -2.6218099594116211e+01 3.5281200408935547e+01 1.7830799865722656e+02 -2.1005300521850586e+01 3.3996196746826172e+01 1.3838499450683594e+02 -2.6159000396728516e+01 6.3387401580810547e+01 1.5179100036621094e+02 -2.6269498825073242e+01 5.3216098785400391e+01 1.3513499450683594e+02 -2.3144298553466797e+01 6.4615196228027344e+01 1.9586299133300781e+02 5.8236400604248047e+01 1.2660900115966797e+01 1.9823199462890625e+02 5.8101200103759766e+01 9.8418502807617188e+00 1.9858999633789062e+02 5.8241600036621094e+01 7.8716797828674316e+00 1.9840599060058594e+02 5.7618396759033203e+01 -1.9005399703979492e+01 1.9850000000000000e+02 5.7599998474121094e+01 -6.5246300697326660e+00 1.9881199645996094e+02 5.8980499267578125e+01 -1.9598299026489258e+01 1.9508999633789062e+02 5.8171501159667969e+01 -2.2848899841308594e+01 1.1540699768066406e+02 5.7624599456787109e+01 -1.5771599769592285e+01 1.1814399719238281e+02 5.7377799987792969e+01 -1.7631599426269531e+01 1.1448300170898438e+02 5.7681900024414062e+01 -1.3678299903869629e+01 1.1443399810791016e+02 5.8665599822998047e+01 2.1728900074958801e-01 1.1334999847412109e+02 5.8832798004150391e+01 1.2717800140380859e+01 1.1672499847412109e+02 5.8079101562500000e+01 1.7532100677490234e+01 1.4245700073242188e+02 5.8542198181152344e+01 1.6263698577880859e+01 1.6257199096679688e+02 5.9422599792480469e+01 2.2507499694824219e+01 1.5482699584960938e+02 5.9303100585937500e+01 1.6978799819946289e+01 1.9343400573730469e+02 5.9557697296142578e+01 1.4360199928283691e+01 1.1329600524902344e+02 6.0008102416992188e+01 5.8001601696014404e-01 1.7371000671386719e+02 5.8520500183105469e+01 -2.0492799758911133e+01 1.4781199645996094e+02 5.8035797119140625e+01 -1.8449501037597656e+01 9.6000000000000000e+01 -2.7708499908447266e+01 3.6778301239013672e+01 9.6000000000000000e+01 -1.7761299133300781e+01 4.2602401733398438e+01 9.6000000000000000e+01 -3.6395900726318359e+01 2.8370899200439453e+01 9.6000000000000000e+01 -4.2124099731445312e+01 1.8687900543212891e+01 9.6000000000000000e+01 -1.7903499603271484e+01 -4.2521900177001953e+01 9.6000000000000000e+01 -2.9708101272583008e+01 -3.5342102050781250e+01 9.5999893188476562e+01 -4.0535900115966797e+01 -2.2388198852539062e+01 9.6000000000000000e+01 -4.5343101501464844e+01 -8.3319101333618164e+00 9.6000000000000000e+01 -4.5940299987792969e+01 5.3986601829528809e+00 1.1819200134277344e+02 1.5090000152587891e+01 -5.1031997680664062e+01 1.9961700439453125e+02 -5.9503398895263672e+01 -2.2906101226806641e+01 1.8115800476074219e+02 -5.9575901031494141e+01 -2.2798400878906250e+01 1.6956100463867188e+02 -5.9359100341796875e+01 -2.0833000183105469e+01 1.9509799194335938e+02 -5.9182701110839844e+01 1.3523900032043457e+01 1.9684100341796875e+02 -5.9584899902343750e+01 1.4392700195312500e+01 1.9956300354003906e+02 -5.9429401397705078e+01 1.0121399879455566e+01 2.0047900390625000e+02 -5.9599998474121094e+01 9.2174596786499023e+00 1.9882299804687500e+02 -5.8752399444580078e+01 -5.0170197486877441e+00 1.9970600891113281e+02 -5.9435798645019531e+01 -5.7206001281738281e+00 2.0048399353027344e+02 -5.9599998474121094e+01 -1.8691299438476562e+01 1.9762699890136719e+02 -5.9261798858642578e+01 -2.2142900466918945e+01 1.1376000213623047e+02 -5.8778800964355469e+01 -1.5927000045776367e+01 1.1759600067138672e+02 -5.8381500244140625e+01 -1.8738500595092773e+01 1.0636900329589844e+02 -6.0001899719238281e+01 3.9615197181701660e+00 1.0620299530029297e+02 -5.7914100646972656e+01 1.6882301330566406e+01 1.0608900451660156e+02 -5.2843601226806641e+01 3.3501899719238281e+01 1.6069699096679688e+02 -5.9322799682617188e+01 2.3000598907470703e+01 1.3293299865722656e+02 -5.8864898681640625e+01 -1.9247499465942383e+01 1.1774600219726562e+02 -1.4972800254821777e+01 -5.0734401702880859e+01 1.1454900360107422e+02 -1.1422699928283691e+01 -5.1588298797607422e+01 1.8837500000000000e+02 -1.5151999473571777e+01 -4.6500297546386719e+01 1.5976100158691406e+02 -1.5126800537109375e+01 -4.7644397735595703e+01 1.4265600585937500e+02 -1.5001399993896484e+01 -4.7951499938964844e+01 1.9251799011230469e+02 -1.1506799697875977e+01 -4.7005298614501953e+01 1.9041299438476562e+02 -1.4267300605773926e+01 -4.6525600433349609e+01 1.1488600158691406e+02 5.3745300292968750e+01 2.9165800094604492e+01 1.1509100341796875e+02 4.5321800231933594e+01 4.5990798950195312e+01 1.1722800445556641e+02 4.3668697357177734e+01 4.7778301239013672e+01 1.5705099487304688e+02 4.5566001892089844e+01 3.5603000640869141e+01 1.6281199645996094e+02 4.8271701812744141e+01 3.1496801376342773e+01 1.4562199401855469e+02 4.4266498565673828e+01 4.4049301147460938e+01 1.3574301147460938e+02 4.4599201202392578e+01 4.7192001342773438e+01 1.6380000305175781e+02 5.4823497772216797e+01 2.8059299468994141e+01 1.6360198974609375e+02 5.0160800933837891e+01 3.0754299163818359e+01 1.4435499572753906e+02 5.7135997772216797e+01 2.6440198898315430e+01 1.2700099945068359e+02 5.6121299743652344e+01 2.6727300643920898e+01 1.3181098937988281e+02 5.7516998291015625e+01 2.5521499633789062e+01 1.6344400024414062e+02 5.8080902099609375e+01 2.5643400192260742e+01 1.1701499938964844e+02 5.6186298370361328e+01 2.6178600311279297e+01 1.7818600463867188e+02 2.2477600097656250e+01 3.3969799041748047e+01 1.7781700134277344e+02 -5.0146598815917969e+00 3.3470397949218750e+01 1.7605400085449219e+02 2.5440799713134766e+01 3.4740299224853516e+01 1.7398999023437500e+02 2.6164300918579102e+01 3.4999401092529297e+01 1.3848899841308594e+02 2.6201200485229492e+01 6.3457496643066406e+01 1.3549099731445312e+02 2.3635400772094727e+01 6.4490699768066406e+01 1.3492199707031250e+02 2.1094900131225586e+01 6.3880100250244141e+01 1.3496200561523438e+02 6.7191904783248901e-01 6.4027801513671875e+01 9.5991401672363281e+01 -5.2353099822998047e+01 2.6103901863098145e+00 9.6013099670410156e+01 -4.8817798614501953e+01 1.9642200469970703e+01 9.6004394531250000e+01 -2.6181100845336914e+01 5.0067001342773438e+01 1.0531699371337891e+02 -3.4370502471923828e+01 6.5224296569824219e+01 9.5996299743652344e+01 -1.0822400093078613e+01 5.3937698364257812e+01 9.6001998901367188e+01 -3.1918897628784180e+01 4.6097000122070312e+01 1.0148300170898438e+02 -3.9306800842285156e+01 5.0527000427246094e+01 1.0569400024414062e+02 -3.8895301818847656e+01 6.2172401428222656e+01 1.0544999694824219e+02 -2.2088001251220703e+01 6.6305099487304688e+01 9.6003395080566406e+01 -4.0100997924804688e+01 3.6881900787353516e+01 1.0618700408935547e+02 -4.5324401855468750e+01 5.0910202026367188e+01 1.0552500152587891e+02 1.7329999923706055e+01 6.6509300231933594e+01 1.1374600219726562e+02 -5.5072502136230469e+01 2.8351900100708008e+01 1.1414500427246094e+02 -4.6034801483154297e+01 4.7630001068115234e+01 1.1800300598144531e+02 -4.4662097930908203e+01 4.9751098632812500e+01 1.3459500122070312e+02 -4.5706996917724609e+01 4.8228599548339844e+01 1.4568400573730469e+02 -4.5191501617431641e+01 4.5570602416992188e+01 1.3669900512695312e+02 -4.6077400207519531e+01 4.9466300964355469e+01 1.5675000000000000e+02 -4.6239101409912109e+01 3.7885101318359375e+01 1.6391499328613281e+02 -4.9290798187255859e+01 3.3866100311279297e+01 1.4367799377441406e+02 -4.5182300567626953e+01 4.8243797302246094e+01 1.5700498962402344e+02 -4.5630397796630859e+01 3.9460201263427734e+01 1.6457598876953125e+02 -5.1265796661376953e+01 3.1692899703979492e+01 1.6494099426269531e+02 -5.4776699066162109e+01 2.8969699859619141e+01 2.0015299987792969e+02 -5.8359500885009766e+01 2.1649599075317383e+01 1.8204000854492188e+02 -5.7073101043701172e+01 2.5260999679565430e+01 1.7964900207519531e+02 -2.0388500213623047e+01 3.4191799163818359e+01 1.8368800354003906e+02 1.4527799606323242e+01 3.2624301910400391e+01 1.7919999694824219e+02 -8.4076100587844849e-01 3.4105098724365234e+01 1.7868000793457031e+02 -2.4385999679565430e+01 3.4431098937988281e+01 1.7551599121093750e+02 -2.7489799499511719e+01 3.6154197692871094e+01 1.6743400573730469e+02 -2.7813098907470703e+01 4.1675601959228516e+01 1.3980700683593750e+02 -2.7853099822998047e+01 6.3749595642089844e+01 1.3426300048828125e+02 -2.3186401367187500e+01 6.6021896362304688e+01 1.3418600463867188e+02 5.6766800582408905e-02 6.6304000854492188e+01 1.3093598937988281e+02 -2.8188598632812500e+01 6.6408500671386719e+01 1.3493501281738281e+02 -1.0140299797058105e+01 6.5212799072265625e+01 1.9530799865722656e+02 5.9507900238037109e+01 -2.3955301284790039e+01 1.9821000671386719e+02 5.9297302246093750e+01 1.1879100799560547e+01 1.9904499816894531e+02 5.9013500213623047e+01 9.1163101196289062e+00 1.9970600891113281e+02 5.9435699462890625e+01 7.9474897384643555e+00 2.0043499755859375e+02 5.9599796295166016e+01 9.7910203933715820e+00 1.9586000061035156e+02 5.9646499633789062e+01 1.5539100646972656e+01 1.9908599853515625e+02 5.9014202117919922e+01 -6.5246901512145996e+00 1.9865000915527344e+02 5.8394302368164062e+01 -1.8435598373413086e+01 1.9969500732421875e+02 5.9435699462890625e+01 -1.8581800460815430e+01 2.0050000000000000e+02 5.9599998474121094e+01 -6.5246300697326660e+00 2.0033599853515625e+02 5.9599899291992188e+01 -2.0095300674438477e+01 1.1366799926757812e+02 5.8863597869873047e+01 -1.5145799636840820e+01 1.1680900573730469e+02 5.8361999511718750e+01 -1.9104400634765625e+01 1.0628399658203125e+02 5.9086502075195312e+01 1.1291700363159180e+01 1.0609500122070312e+02 5.6163002014160156e+01 2.3417699813842773e+01 1.0631900024414062e+02 6.0075698852539062e+01 -1.4537400007247925e+00 1.5073500061035156e+02 5.9307098388671875e+01 -1.9643699645996094e+01 9.6003898620605469e+01 1.5412500381469727e+01 5.3257301330566406e+01 9.6004798889160156e+01 2.6230899810791016e+01 5.0048000335693359e+01 9.6002700805664062e+01 3.1935199737548828e+01 4.6087802886962891e+01 9.6003005981445312e+01 4.0110099792480469e+01 3.6866401672363281e+01 9.6015296936035156e+01 4.8818901062011719e+01 1.9644500732421875e+01 9.5997100830078125e+01 5.1885002136230469e+01 6.3617200851440430e+00 9.5993698120117188e+01 5.2160800933837891e+01 -2.6104500293731689e+00 9.6000000000000000e+01 -5.0805099487304688e+01 -1.3062699317932129e+01 9.5999893188476562e+01 -4.6927398681640625e+01 -2.4410200119018555e+01 9.6001197814941406e+01 -3.9989200592041016e+01 -3.5133899688720703e+01 9.6004394531250000e+01 -2.9499401092529297e+01 -4.3494499206542969e+01 9.6005599975585938e+01 -2.1365800857543945e+01 -4.7225597381591797e+01 9.6005798339843750e+01 -1.0439700126647949e+01 -5.0291999816894531e+01 9.5999893188476562e+01 4.6927398681640625e+01 -2.4410200119018555e+01 9.6000099182128906e+01 5.0805099487304688e+01 -1.3062699317932129e+01 9.6005599975585938e+01 2.1365800857543945e+01 -4.7225597381591797e+01 9.6000801086425781e+01 3.9988800048828125e+01 -3.5133598327636719e+01 9.6005500793457031e+01 2.9500499725341797e+01 -4.3494998931884766e+01 9.6004798889160156e+01 1.0438700675964355e+01 -5.0291797637939453e+01 9.5999893188476562e+01 -6.7094003316015005e-04 -5.1141399383544922e+01 1.1450499725341797e+02 1.0991100311279297e+01 -5.1546001434326172e+01 1.1604599761962891e+02 1.3854700088500977e+01 -5.1550197601318359e+01 1.6811000061035156e+02 1.5124500274658203e+01 -4.7219997406005859e+01 1.4425801086425781e+02 1.5128399848937988e+01 -4.8744800567626953e+01 1.9262899780273438e+02 -1.5407700836658478e-01 -4.8087501525878906e+01 2.5329301452636719e+02 -5.9360702514648438e+01 3.7227799892425537e+00 2.9913900756835938e+02 -5.9560802459716797e+01 -1.7453300476074219e+01 2.7202902221679688e+02 -5.9582500457763672e+01 1.4386100769042969e+00 2.1833198547363281e+02 -5.9621898651123047e+01 1.4433300018310547e+01 2.9397698974609375e+02 -5.9558399200439453e+01 -3.5167701721191406e+01 2.7114901733398438e+02 -5.9548698425292969e+01 -3.7561496734619141e+01 2.0986900329589844e+02 -5.9567699432373047e+01 -3.3242599487304688e+01 1.6356500244140625e+02 -5.9376098632812500e+01 -2.7983701705932617e+01 1.2132699584960938e+02 -5.6694103240966797e+01 -2.8142299652099609e+01 1.4651300048828125e+02 -5.7890800476074219e+01 -2.9504899978637695e+01 1.7305000305175781e+02 -5.8148300170898438e+01 -3.1985301971435547e+01 1.0599900054931641e+02 -5.7094497680664062e+01 -2.3374799728393555e+01 1.0629999542236328e+02 -5.9657997131347656e+01 -9.6062297821044922e+00 1.0748100280761719e+02 -2.1787601470947266e+01 -5.2811801910400391e+01 1.0753999328613281e+02 0.0000000000000000e+00 -5.4102397918701172e+01 1.0590699768066406e+02 -5.1664100646972656e+01 -3.5987499237060547e+01 1.0589600372314453e+02 -4.5768398284912109e+01 -4.3152702331542969e+01 1.0639399719238281e+02 -4.0084499359130859e+01 -4.7432502746582031e+01 1.0673200225830078e+02 -3.1287700653076172e+01 -5.0921600341796875e+01 1.1374100494384766e+02 -3.8158097863197327e-01 -5.3426197052001953e+01 1.1373999786376953e+02 -1.1884500503540039e+01 -5.2836299896240234e+01 1.1759200286865234e+02 -1.6310998916625977e+01 -5.2187900543212891e+01 1.4660400390625000e+02 -1.5789000511169434e+01 -4.9292999267578125e+01 1.8940899658203125e+02 -1.6616300582885742e+01 -4.7532001495361328e+01 1.7581201171875000e+02 -1.6619499206542969e+01 -4.8004001617431641e+01 1.4950799560546875e+02 -1.7443799972534180e+01 -4.9311500549316406e+01 1.9384500122070312e+02 -1.2534000396728516e+01 -4.7933799743652344e+01 1.9403800964355469e+02 -1.7250499222427607e-03 -4.9168300628662109e+01 3.3021600341796875e+02 -5.6055797576904297e+01 2.0187198638916016e+01 3.4545901489257812e+02 -5.0816699981689453e+01 2.2870401382446289e+01 3.3549801635742188e+02 -5.0789100646972656e+01 2.9877399444580078e+01 3.2403100585937500e+02 -5.2572601318359375e+01 2.9864000320434570e+01 3.1784500122070312e+02 -5.7084899902343750e+01 1.8167900085449219e+01 3.4129800415039062e+02 -5.6062301635742188e+01 9.2115697860717773e+00 3.5057800292968750e+02 -5.2317699432373047e+01 9.2651100158691406e+00 3.3276901245117188e+02 -5.8215099334716797e+01 8.7259998321533203e+00 3.4325097656250000e+02 -5.6178497314453125e+01 1.1262999475002289e-01 3.1429498291015625e+02 -5.2795299530029297e+01 2.8681699752807617e+01 3.0606799316406250e+02 -5.2102199554443359e+01 2.6739799499511719e+01 3.0453802490234375e+02 -5.6613300323486328e+01 1.3450200080871582e+01 3.2094000244140625e+02 -5.8827301025390625e+01 1.0650600433349609e+01 3.2424099731445312e+02 -5.9578399658203125e+01 3.4495999813079834e+00 3.5264797973632812e+02 -5.1604000091552734e+01 -6.1658797264099121e+00 3.4294900512695312e+02 -5.5334899902343750e+01 -1.0186499595642090e+01 3.4746200561523438e+02 -5.0817401885986328e+01 -2.0237600326538086e+01 3.3017797851562500e+02 -5.9017700195312500e+01 -5.6194200515747070e+00 3.3758898925781250e+02 -5.4773799896240234e+01 -1.9325298309326172e+01 3.4245199584960938e+02 -5.1083801269531250e+01 -2.4650699615478516e+01 2.9087002563476562e+02 -5.9193599700927734e+01 -3.2216899394989014e+00 2.9248602294921875e+02 -5.7564697265625000e+01 7.6732001304626465e+00 2.9598901367187500e+02 -5.4300201416015625e+01 1.7811300277709961e+01 2.9382199096679688e+02 -5.2435001373291016e+01 2.0415199279785156e+01 2.7742098999023438e+02 -5.9148300170898438e+01 5.6215400695800781e+00 1.0530900573730469e+02 3.4321598052978516e+01 6.5242401123046875e+01 1.0569400024414062e+02 3.8895301818847656e+01 6.2172401428222656e+01 1.0148300170898438e+02 3.9306800842285156e+01 5.0527000427246094e+01 1.0617800140380859e+02 4.4436000823974609e+01 5.2621902465820312e+01 1.0614900207519531e+02 5.0014999389648438e+01 4.0773899078369141e+01 1.1361599731445312e+02 5.4901100158691406e+01 2.8888000488281250e+01 1.1414199829101562e+02 4.6037399291992188e+01 4.7626399993896484e+01 1.1798699951171875e+02 4.4691802978515625e+01 4.9682098388671875e+01 1.3803100585937500e+02 4.5747398376464844e+01 4.7655799865722656e+01 1.3999099731445312e+02 4.5829200744628906e+01 4.8849300384521484e+01 1.4675399780273438e+02 4.5329998016357422e+01 4.5792800903320312e+01 1.3424900817871094e+02 4.5920902252197266e+01 4.9633499145507812e+01 1.5674200439453125e+02 4.6255699157714844e+01 3.8023899078369141e+01 1.6293499755859375e+02 4.9106601715087891e+01 3.2713302612304688e+01 1.5772799682617188e+02 4.5693599700927734e+01 3.9082199096679688e+01 1.6438700866699219e+02 4.9323799133300781e+01 3.3832099914550781e+01 1.6457598876953125e+02 5.1265098571777344e+01 3.1693298339843750e+01 1.6572799682617188e+02 5.3874702453613281e+01 2.9780099868774414e+01 1.9815699768066406e+02 5.8837997436523438e+01 2.1240400314331055e+01 1.9343798828125000e+02 5.6698200225830078e+01 2.4391698837280273e+01 1.7957901000976562e+02 2.3111301422119141e+01 3.4188697814941406e+01 1.7661199951171875e+02 2.7193799972534180e+01 3.5522697448730469e+01 1.7350199890136719e+02 2.7229598999023438e+01 3.7267498016357422e+01 1.4899800109863281e+02 2.7814199447631836e+01 5.6784500122070312e+01 1.3937300109863281e+02 2.7741701126098633e+01 6.3865699768066406e+01 1.6256700134277344e+02 2.7309000015258789e+01 4.5492897033691406e+01 1.3362799072265625e+02 2.2824899673461914e+01 6.6271499633789062e+01 1.3495401000976562e+02 2.2463800430297852e+01 6.5064102172851562e+01 1.4000099182128906e+02 -3.7999397277832031e+01 6.0201297760009766e+01 1.4167300415039062e+02 -4.1072902679443359e+01 5.6351402282714844e+01 1.4835600280761719e+02 -3.8722103118896484e+01 5.3804698944091797e+01 1.3761999511718750e+02 -3.2905498504638672e+01 6.3922599792480469e+01 1.4371499633789062e+02 -3.3531402587890625e+01 6.0123001098632812e+01 1.7050500488281250e+02 -3.5418300628662109e+01 3.8127601623535156e+01 1.3574501037597656e+02 -4.1949298858642578e+01 5.7254703521728516e+01 1.3344499206542969e+02 -3.7413997650146484e+01 6.2541000366210938e+01 1.6036199951171875e+02 -3.7501800537109375e+01 4.4486000061035156e+01 1.2822300720214844e+02 2.5380500592291355e-03 6.6940597534179688e+01 1.3307000732421875e+02 -3.4566497802734375e+01 6.4479301452636719e+01 1.1277999877929688e+02 -3.1176601409912109e+01 6.5373397827148438e+01 1.1455500030517578e+02 -3.4925697326660156e+01 6.3660301208496094e+01 1.1466699981689453e+02 -3.8377098083496094e+01 6.0182701110839844e+01 1.7202600097656250e+02 -4.7644599914550781e+01 3.2922801971435547e+01 1.6332400512695312e+02 -4.2409698486328125e+01 3.9155300140380859e+01 1.8566699218750000e+02 -3.5922698974609375e+01 3.1507398605346680e+01 1.5437200927734375e+02 -4.2130802154541016e+01 4.4921398162841797e+01 1.8039299011230469e+02 -4.4782402038574219e+01 3.1724597930908203e+01 1.8650599670410156e+02 -5.1513900756835938e+01 2.7751098632812500e+01 1.8375700378417969e+02 -1.3497900009155273e+01 3.2690799713134766e+01 2.6988101196289062e+02 -5.8853500366210938e+01 4.1775803565979004e+00 2.5401199340820312e+02 -5.6849300384521484e+01 7.2803001403808594e+00 2.6807598876953125e+02 -5.6217498779296875e+01 7.0146603584289551e+00 2.5847198486328125e+02 -5.3321800231933594e+01 8.5031900405883789e+00 2.6445401000976562e+02 -5.2188796997070312e+01 8.2084398269653320e+00 2.6950000000000000e+02 -5.3400299072265625e+01 8.6443300247192383e+00 2.5100201416015625e+02 -5.3311000823974609e+01 1.0358699798583984e+01 2.2819100952148438e+02 -5.6646701812744141e+01 1.7905900955200195e+01 2.3049099731445312e+02 -5.8918201446533203e+01 1.3960800170898438e+01 2.3717098999023438e+02 -5.3330802917480469e+01 1.6238899230957031e+01 2.2476400756835938e+02 -5.2911201477050781e+01 2.0362998962402344e+01 2.0169299316406250e+02 -5.5829101562500000e+01 2.3711700439453125e+01 2.1151300048828125e+02 -5.3709899902343750e+01 2.2954799652099609e+01 2.5361401367187500e+02 5.9597099304199219e+01 1.7641000747680664e+00 2.7073098754882812e+02 5.9595001220703125e+01 1.1347800493240356e+00 2.4433801269531250e+02 5.9590702056884766e+01 -3.6644599914550781e+01 2.9514700317382812e+02 5.9618499755859375e+01 -1.4815299987792969e+01 2.2900999450683594e+02 5.9573402404785156e+01 1.2471499443054199e+01 1.9489300537109375e+02 5.9581298828125000e+01 -3.0429100036621094e+01 1.6975801086425781e+02 5.9464500427246094e+01 -2.8738201141357422e+01 2.9397799682617188e+02 5.9503997802734375e+01 -3.6015701293945312e+01 1.8752799987792969e+02 5.8433799743652344e+01 -3.3148200988769531e+01 1.3923699951171875e+02 5.7992500305175781e+01 -2.8420598983764648e+01 1.8559500122070312e+02 5.5778900146484375e+01 -3.5464500427246094e+01 1.5547401428222656e+02 5.6283702850341797e+01 -3.2385200500488281e+01 1.0595899963378906e+02 5.5626701354980469e+01 -2.7611200332641602e+01 1.0606999969482422e+02 5.8002098083496094e+01 -1.9309000015258789e+01 1.0625699615478516e+02 5.9228500366210938e+01 -1.2706600189208984e+01 1.0581500244140625e+02 5.2338802337646484e+01 -3.4569198608398438e+01 1.0594799804687500e+02 4.8441600799560547e+01 -4.0372299194335938e+01 1.0627699279785156e+02 4.1895698547363281e+01 -4.6385700225830078e+01 1.0749800109863281e+02 2.1781200408935547e+01 -5.2819000244140625e+01 1.0683300018310547e+02 3.2219997406005859e+01 -5.0730602264404297e+01 1.1385800170898438e+02 1.2536900520324707e+01 -5.2801399230957031e+01 1.1831399536132812e+02 1.6657098770141602e+01 -5.2060100555419922e+01 1.4150999450683594e+02 1.6733798980712891e+01 -5.0052600860595703e+01 1.5871099853515625e+02 1.7253200531005859e+01 -4.8840000152587891e+01 1.5283599853515625e+02 1.6447799682617188e+01 -4.9134197235107422e+01 1.7329399108886719e+02 1.6458099365234375e+01 -4.8023998260498047e+01 1.7724299621582031e+02 1.7257999420166016e+01 -4.7909400939941406e+01 1.9079299926757812e+02 1.6327899932861328e+01 -4.7524600982666016e+01 1.9348800659179688e+02 1.1803199768066406e+01 -4.7916000366210938e+01 3.2879299926757812e+02 -5.4604198455810547e+01 -2.5244899749755859e+01 3.1785601806640625e+02 -5.7207500457763672e+01 -2.3674100875854492e+01 3.2115399169921875e+02 -5.4195003509521484e+01 -3.3423999786376953e+01 3.0731201171875000e+02 -5.7213798522949219e+01 -3.6426101684570312e+01 2.4370700073242188e+02 -5.8105400085449219e+01 -4.0483600616455078e+01 1.8605000305175781e+02 -5.5666301727294922e+01 -3.5633197784423828e+01 2.2290701293945312e+02 -5.4581798553466797e+01 -4.0966201782226562e+01 2.5016900634765625e+02 -5.5311500549316406e+01 -4.2954696655273438e+01 2.9298898315429688e+02 -5.8406402587890625e+01 -3.9179798126220703e+01 2.7344998168945312e+02 -5.5917999267578125e+01 -4.2715999603271484e+01 2.6892797851562500e+02 -5.3521598815917969e+01 -4.3816802978515625e+01 2.9295199584960938e+02 -5.5925998687744141e+01 -4.1507198333740234e+01 2.8959701538085938e+02 -5.3229801177978516e+01 -4.2905300140380859e+01 1.6210000610351562e+02 -2.8137701034545898e+01 -4.6781600952148438e+01 2.2045600891113281e+02 -2.0525101572275162e-03 -4.8651199340820312e+01 1.9152799987792969e+02 -2.6897300720214844e+01 -4.5917598724365234e+01 1.4162600708007812e+02 -3.2515800476074219e+01 -4.7097602844238281e+01 1.4261500549316406e+02 -3.9808399200439453e+01 -4.4338600158691406e+01 1.6180300903320312e+02 -3.9506500244140625e+01 -4.3474597930908203e+01 1.9230200195312500e+02 -4.0004398345947266e+01 -4.2837898254394531e+01 1.3307400512695312e+02 -4.4574100494384766e+01 -4.2234397888183594e+01 1.4059600830078125e+02 -5.0834701538085938e+01 -3.7153800964355469e+01 1.2431199645996094e+02 -5.3877700805664062e+01 -3.3177299499511719e+01 1.7020100402832031e+02 -4.6278499603271484e+01 -4.0095199584960938e+01 2.0101000976562500e+02 -4.9776302337646484e+01 -3.9787696838378906e+01 1.6527398681640625e+02 -5.1322799682617188e+01 -3.7043899536132812e+01 3.4758599853515625e+02 -4.6564601898193359e+01 -2.3633201599121094e+01 3.4175802612304688e+02 -4.7322097778320312e+01 -2.8669099807739258e+01 3.5105401611328125e+02 -5.0087699890136719e+01 -1.5676500320434570e+01 3.5647000122070312e+02 -4.6487201690673828e+01 -4.1949100494384766e+00 3.5497497558593750e+02 -4.9988998413085938e+01 1.9928300380706787e+00 3.5551898193359375e+02 -4.7991901397705078e+01 -8.0698108673095703e+00 3.5655297851562500e+02 -4.6585800170898438e+01 2.8831000328063965e+00 3.5317297363281250e+02 -4.9987899780273438e+01 1.1425299644470215e+01 3.5243099975585938e+02 -4.6553897857666016e+01 -1.6864498138427734e+01 3.5240499877929688e+02 -4.6603298187255859e+01 1.6930099487304688e+01 3.5556301879882812e+02 -4.6486900329589844e+01 8.9986906051635742e+00 3.1190802001953125e+02 -4.9952499389648438e+01 3.2275901794433594e+01 3.4660101318359375e+02 -4.6533302307128906e+01 2.4800498962402344e+01 3.3962698364257812e+02 -4.6558799743652344e+01 3.0183099746704102e+01 3.3385101318359375e+02 -4.6603401184082031e+01 3.2969097137451172e+01 3.2513497924804688e+02 -4.9954196929931641e+01 3.3501701354980469e+01 3.3816497802734375e+02 -4.9954002380371094e+01 -2.9056800842285156e+01 2.8545098876953125e+02 -5.5893600463867188e+01 1.2783999443054199e+01 2.9691400146484375e+02 -4.6429599761962891e+01 2.5998100280761719e+01 2.8733102416992188e+02 -4.9988197326660156e+01 1.8403999328613281e+01 2.7717001342773438e+02 -5.3599498748779297e+01 1.1216300010681152e+01 1.4946701049804688e+02 3.4173000335693359e+01 5.5406803131103516e+01 1.6770599365234375e+02 3.4920600891113281e+01 4.0210899353027344e+01 1.2979600524902344e+02 2.8933300018310547e+01 6.6311996459960938e+01 1.3604499816894531e+02 3.2817901611328125e+01 6.4451202392578125e+01 1.4030000305175781e+02 3.3655300140380859e+01 6.2324600219726562e+01 1.4425000000000000e+02 3.8764099121093750e+01 5.7055397033691406e+01 1.3992799377441406e+02 4.1637901306152344e+01 5.6498401641845703e+01 1.3657798767089844e+02 3.7251300811767578e+01 6.2039798736572266e+01 1.4481100463867188e+02 4.0798500061035156e+01 5.4572998046875000e+01 1.6895100402832031e+02 4.1108100891113281e+01 3.7266002655029297e+01 1.7570500183105469e+02 3.4639900207519531e+01 3.5550502777099609e+01 1.6036199951171875e+02 3.7501800537109375e+01 4.4486000061035156e+01 1.6420599365234375e+02 4.3967002868652344e+01 3.7650699615478516e+01 1.5437799072265625e+02 4.2090599060058594e+01 4.4954601287841797e+01 1.7954200744628906e+02 4.3807800292968750e+01 3.2334201812744141e+01 1.8271000671386719e+02 3.4912899017333984e+01 3.2622501373291016e+01 1.7485398864746094e+02 5.1047599792480469e+01 3.0327501296997070e+01 1.1885199737548828e+02 3.8033599853515625e+01 6.0749198913574219e+01 1.1260499572753906e+02 3.8684600830078125e+01 6.0240398406982422e+01 1.1471700286865234e+02 3.4023200988769531e+01 6.4308197021484375e+01 1.3116999816894531e+02 3.4135299682617188e+01 6.4737297058105469e+01 1.3075500488281250e+02 3.7378501892089844e+01 6.2505001068115234e+01 1.3469900512695312e+02 4.1564098358154297e+01 5.7772399902343750e+01 1.1008300018310547e+02 2.8295999526977539e+01 6.5921501159667969e+01 1.8822099304199219e+02 5.2735298156738281e+01 2.6884998321533203e+01 2.5340199279785156e+02 5.8809001922607422e+01 4.8021702766418457e+00 2.7045300292968750e+02 5.8691402435302734e+01 4.6866698265075684e+00 2.2915400695800781e+02 5.7930999755859375e+01 1.6172698974609375e+01 2.5401199340820312e+02 5.6850002288818359e+01 7.2797298431396484e+00 2.6870001220703125e+02 5.6944297790527344e+01 6.5571699142456055e+00 2.2943299865722656e+02 5.5725601196289062e+01 1.8159700393676758e+01 2.5865100097656250e+02 5.3174900054931641e+01 8.5388698577880859e+00 2.6743298339843750e+02 5.3322399139404297e+01 8.1703891754150391e+00 2.5073098754882812e+02 5.3366001129150391e+01 1.0430599212646484e+01 2.0754299926757812e+02 5.3815799713134766e+01 2.3621799468994141e+01 2.2995300292968750e+02 5.3392002105712891e+01 1.8940801620483398e+01 2.5989199829101562e+02 1.9578199833631516e-02 1.0337200164794922e+01 2.6579299926757812e+02 -2.2864998877048492e-01 9.7871303558349609e+00 2.5126200866699219e+02 1.6547399759292603e-01 1.3001600265502930e+01 2.0748699951171875e+02 -3.5740300081670284e-03 2.9029499053955078e+01 2.1601000976562500e+02 -2.6735000610351562e+01 2.5183200836181641e+01 2.2427400207519531e+02 -1.3213099539279938e-01 2.4299200057983398e+01 2.2842800903320312e+02 -3.3193599700927734e+01 2.0551898956298828e+01 2.7235998535156250e+02 -3.6123901367187500e+01 1.0205699920654297e+01 2.7025299072265625e+02 6.1456594616174698e-02 1.0806500434875488e+01 1.9766500854492188e+02 -4.6399600982666016e+01 2.6853300094604492e+01 3.0579901123046875e+02 5.8677299499511719e+01 4.7270102500915527e+00 2.9326998901367188e+02 5.6706199645996094e+01 1.0634400367736816e+01 3.0686798095703125e+02 5.5396697998046875e+01 1.8861700057983398e+01 2.8923999023437500e+02 5.8949199676513672e+01 7.2731298208236694e-01 3.1638101196289062e+02 5.7163398742675781e+01 1.7737598419189453e+01 2.9579800415039062e+02 5.3833000183105469e+01 1.8883600234985352e+01 2.7655801391601562e+02 5.9387901306152344e+01 4.4498901367187500e+00 3.1206301879882812e+02 5.0240200042724609e+01 3.2121402740478516e+01 3.2334100341796875e+02 5.5386600494384766e+01 2.3537099838256836e+01 3.2828399658203125e+02 5.1962497711181641e+01 3.0207698822021484e+01 3.3696499633789062e+02 5.4748100280761719e+01 2.0116201400756836e+01 3.2583697509765625e+02 5.8132297515869141e+01 1.3629400253295898e+01 3.4155599975585938e+02 5.1276798248291016e+01 2.5338800430297852e+01 3.1700598144531250e+02 5.1871601104736328e+01 3.0941799163818359e+01 3.0556399536132812e+02 5.8850696563720703e+01 -2.2756799697875977e+01 3.0676901245117188e+02 5.7761402130126953e+01 -3.4925502777099609e+01 3.1970797729492188e+02 5.4104099273681641e+01 -3.4696899414062500e+01 2.3032299804687500e+02 5.8577701568603516e+01 -3.8440902709960938e+01 2.6688098144531250e+02 5.8656700134277344e+01 -4.0082599639892578e+01 2.3738000488281250e+02 5.7097801208496094e+01 -4.0868801116943359e+01 2.5059199523925781e+02 5.4423801422119141e+01 -4.3293300628662109e+01 2.2987500000000000e+02 5.4408699035644531e+01 -4.1789100646972656e+01 2.7122100830078125e+02 5.6256801605224609e+01 -4.2623199462890625e+01 2.9224200439453125e+02 5.8129398345947266e+01 -3.9615097045898438e+01 2.9490100097656250e+02 5.4677299499511719e+01 -4.2012699127197266e+01 2.7172900390625000e+02 5.3217998504638672e+01 -4.3895801544189453e+01 1.3229200744628906e+02 2.4901100158691406e+01 -4.9607898712158203e+01 1.3106399536132812e+02 3.2620399475097656e+01 -4.7903400421142578e+01 1.3256500244140625e+02 3.9792198181152344e+01 -4.5002300262451172e+01 1.3307400512695312e+02 4.4574100494384766e+01 -4.2234397888183594e+01 1.2406900024414062e+02 4.9163700103759766e+01 -3.8926200866699219e+01 1.6753500366210938e+02 2.8057201385498047e+01 -4.6593799591064453e+01 1.9271699523925781e+02 3.0185100555419922e+01 -4.5341201782226562e+01 1.7020700073242188e+02 4.6277603149414062e+01 -4.0095600128173828e+01 1.5373899841308594e+02 5.0213096618652344e+01 -3.7515300750732422e+01 1.6180300903320312e+02 3.9506500244140625e+01 -4.3474597930908203e+01 1.8816400146484375e+02 4.1039199829101562e+01 -4.2396499633789062e+01 1.9456001281738281e+02 4.8691196441650391e+01 -3.9693698883056641e+01 3.0714898681640625e+02 -5.4431198120117188e+01 -3.9724399566650391e+01 3.2254098510742188e+02 -5.1588798522949219e+01 -3.6031700134277344e+01 3.0816000366210938e+02 -5.1990596771240234e+01 -4.0674400329589844e+01 3.2262399291992188e+02 -4.8886501312255859e+01 -3.7410400390625000e+01 3.3305697631835938e+02 -4.7024803161621094e+01 -3.3586597442626953e+01 2.2141000366210938e+02 -1.9463699340820312e+01 -4.6871101379394531e+01 2.6096401977539062e+02 1.2615600228309631e-01 -4.8555000305175781e+01 2.5980999755859375e+02 -2.1825000762939453e+01 -4.7363399505615234e+01 2.1659300231933594e+02 -3.5800399780273438e+01 -4.4494800567626953e+01 2.4820100402832031e+02 -4.0265003204345703e+01 -4.5528602600097656e+01 2.8806600952148438e+02 -1.8376800417900085e-01 -4.7667297363281250e+01 2.7403799438476562e+02 -3.2568298339843750e+01 -4.6432800292968750e+01 2.9938198852539062e+02 -2.9787300109863281e+01 -4.4220897674560547e+01 2.1799301147460938e+02 -4.6383197784423828e+01 -4.2410102844238281e+01 3.0550198364257812e+02 1.5604100190103054e-03 -4.5325500488281250e+01 3.3713299560546875e+02 -2.7296199798583984e+01 3.2845298767089844e+01 3.4536499023437500e+02 -2.7500299453735352e+01 2.7609300613403320e+01 3.3054501342773438e+02 -2.7301300048828125e+01 3.5275199890136719e+01 3.5222598266601562e+02 -2.7748899459838867e+01 1.9580801010131836e+01 3.5620901489257812e+02 -2.7264900207519531e+01 1.1036899566650391e+01 3.5141998291015625e+02 -2.7590900421142578e+01 -2.0691900253295898e+01 3.5747702026367188e+02 -2.7658300399780273e+01 -6.1160697937011719e+00 3.5773699951171875e+02 -2.7730998992919922e+01 3.6521000862121582e+00 3.5477301025390625e+02 -2.7616800308227539e+01 -1.4722100257873535e+01 3.4653100585937500e+02 -2.7701599121093750e+01 -2.6458301544189453e+01 3.4195397949218750e+02 -2.7236700057983398e+01 -3.0036399841308594e+01 2.7476998901367188e+02 -1.4349600672721863e-01 1.2996800422668457e+01 2.8622500610351562e+02 -2.8034400939941406e+01 1.9559200286865234e+01 2.7812500000000000e+02 -2.7048200607299805e+01 1.3644199371337891e+01 2.7526599121093750e+02 -2.3990999221801758e+01 1.2114700317382812e+01 2.2841101074218750e+02 3.6035701751708984e+01 2.0388200759887695e+01 2.1325999450683594e+02 2.4194000244140625e+01 2.6268999099731445e+01 1.9223899841308594e+02 3.3256603240966797e+01 3.0131299972534180e+01 2.1534500122070312e+02 4.4072700500488281e+01 2.3374000549316406e+01 1.9287901306152344e+02 4.6887699127197266e+01 2.7825201034545898e+01 2.8867199707031250e+02 5.2378597259521484e+01 1.8078699111938477e+01 2.7820700073242188e+02 5.4890499114990234e+01 1.1003299713134766e+01 2.8493499755859375e+02 5.0125202178955078e+01 1.6675199508666992e+01 3.0661300659179688e+02 4.7075801849365234e+01 3.1899499893188477e+01 2.9687802124023438e+02 4.6438899993896484e+01 2.5975198745727539e+01 2.7496002197265625e+02 5.2326297760009766e+01 1.0564499855041504e+01 3.5468600463867188e+02 4.9993198394775391e+01 -4.8203902244567871e+00 3.5105401611328125e+02 5.0087699890136719e+01 -1.5676600456237793e+01 3.5377600097656250e+02 4.7331199645996094e+01 1.4020999908447266e+01 3.5495199584960938e+02 4.7584102630615234e+01 -1.0297300338745117e+01 3.5230401611328125e+02 4.6536899566650391e+01 -1.7081100463867188e+01 3.4601699829101562e+02 4.6798400878906250e+01 -2.5342599868774414e+01 3.5634698486328125e+02 4.6674499511718750e+01 4.8554697036743164e+00 3.5648797607421875e+02 4.6525001525878906e+01 -4.1701798439025879e+00 3.4442999267578125e+02 4.7429901123046875e+01 2.6542301177978516e+01 3.4893899536132812e+02 4.7365596771240234e+01 2.1899101257324219e+01 3.3642898559570312e+02 4.9807601928710938e+01 3.0209800720214844e+01 3.2194201660156250e+02 4.6480300903320312e+01 3.5234600067138672e+01 3.2808898925781250e+02 4.6672798156738281e+01 3.4538501739501953e+01 3.2513497924804688e+02 4.9954196929931641e+01 3.3501701354980469e+01 3.1507299804687500e+02 4.6535499572753906e+01 3.4624599456787109e+01 3.3743399047851562e+02 4.6488399505615234e+01 3.1513799667358398e+01 3.3727700805664062e+02 4.6310298919677734e+01 -3.1631298065185547e+01 3.0766699218750000e+02 5.6297599792480469e+01 -3.7703701019287109e+01 3.2102001953125000e+02 4.8730102539062500e+01 -3.8035900115966797e+01 3.0572500610351562e+02 5.2984699249267578e+01 -4.0842102050781250e+01 3.1386898803710938e+02 5.2998798370361328e+01 -3.8497200012207031e+01 3.2940200805664062e+02 4.9467800140380859e+01 -3.4280502319335938e+01 2.4820700073242188e+02 4.0354900360107422e+01 -4.5516498565673828e+01 2.7123901367187500e+02 2.9942798614501953e+01 -4.6779499053955078e+01 2.2335598754882812e+02 2.1486499786376953e+01 -4.6662597656250000e+01 2.0977899169921875e+02 3.6775100708007812e+01 -4.4052299499511719e+01 2.1080599975585938e+02 4.6506801605224609e+01 -4.1695301055908203e+01 2.9669400024414062e+02 2.9202999114990234e+01 -4.4716899871826172e+01 3.0624801635742188e+02 -2.2213899612426758e+01 -4.3449798583984375e+01 3.0911499023437500e+02 -2.7346899032592773e+01 -4.2625698089599609e+01 3.2430599975585938e+02 -2.7654500961303711e+01 -3.8567199707031250e+01 3.3528701782226562e+02 -2.7687999725341797e+01 -3.3854598999023438e+01 2.8012200927734375e+02 -2.6104598999023438e+01 1.3669399261474609e+01 2.7672000122070312e+02 -2.3183599472045898e+01 1.1913700103759766e+01 2.7633398437500000e+02 -9.2903404235839844e+00 1.2180799484252930e+01 2.7604299926757812e+02 -3.4207201679237187e-04 1.2574600219726562e+01 2.7893899536132812e+02 -2.0653699874877930e+01 8.7239694595336914e+00 2.7657699584960938e+02 5.0345800817012787e-02 1.2027600288391113e+01 3.3445401000976562e+02 -2.2513700485229492e+01 2.8790901184082031e+01 3.4005697631835938e+02 -2.2685300827026367e+01 2.5597900390625000e+01 3.4482897949218750e+02 -2.2565999984741211e+01 2.1283800125122070e+01 2.9766299438476562e+02 -2.6523099899291992e+01 2.7454498291015625e+01 3.0562600708007812e+02 -2.6010398864746094e+01 3.1183000564575195e+01 3.5634899902343750e+02 -2.6059101104736328e+01 5.8243298530578613e+00 3.5154797363281250e+02 -2.6336599349975586e+01 1.9282100677490234e+01 3.4218402099609375e+02 -2.6087699890136719e+01 2.8799999237060547e+01 3.3005801391601562e+02 -2.6043800354003906e+01 3.3971801757812500e+01 3.3773199462890625e+02 -2.6108301162719727e+01 -3.1531200408935547e+01 3.5047000122070312e+02 -2.6140300750732422e+01 -2.0534999847412109e+01 3.1814797973632812e+02 -2.6205898284912109e+01 3.5436100006103516e+01 3.5621801757812500e+02 -2.6078699111938477e+01 -7.2444996833801270e+00 3.2137500000000000e+02 -2.6332401275634766e+01 -3.8557201385498047e+01 3.1005999755859375e+02 -2.5947299957275391e+01 -4.1249397277832031e+01 3.0709201049804688e+02 -2.2699701309204102e+01 -4.1997699737548828e+01 2.7975601196289062e+02 2.7727199554443359e+01 1.4709400177001953e+01 2.9642199707031250e+02 2.7680400848388672e+01 2.7165500640869141e+01 2.7523999023437500e+02 2.3218999862670898e+01 1.2136699676513672e+01 3.0542199707031250e+02 2.7093299865722656e+01 3.2611602783203125e+01 3.5766900634765625e+02 2.7659698486328125e+01 -4.1118702888488770e+00 3.5587500000000000e+02 2.7293498992919922e+01 -1.1997699737548828e+01 3.5250198364257812e+02 2.7535099029541016e+01 -1.9004600524902344e+01 3.4826300048828125e+02 2.7280200958251953e+01 -2.4681600570678711e+01 3.5775698852539062e+02 2.7590799331665039e+01 3.1053099632263184e+00 3.5656198120117188e+02 2.7193000793457031e+01 9.5668497085571289e+00 3.5135598754882812e+02 2.6703300476074219e+01 2.0567199707031250e+01 3.5414498901367188e+02 2.7480300903320312e+01 1.6101799011230469e+01 3.4437500000000000e+02 2.7321100234985352e+01 2.8381200790405273e+01 3.3443200683593750e+02 2.7651300430297852e+01 3.4104999542236328e+01 3.1345401000976562e+02 2.7610599517822266e+01 3.5509700775146484e+01 3.2427499389648438e+02 2.7064800262451172e+01 3.6305099487304688e+01 3.3879101562500000e+02 2.7218500137329102e+01 -3.2092899322509766e+01 3.0641000366210938e+02 2.3153598785400391e+01 -4.3312900543212891e+01 3.2678198242187500e+02 2.7743398666381836e+01 -3.7607498168945312e+01 3.1130200195312500e+02 2.7627698898315430e+01 -4.2145198822021484e+01 3.0729800415039062e+02 -1.3068999350070953e-01 -4.4095500946044922e+01 3.5254699707031250e+02 -2.2570699691772461e+01 5.8562602996826172e+00 2.9912200927734375e+02 -2.2500099182128906e+01 -2.8525199890136719e+01 3.2809201049804688e+02 -2.2587800979614258e+01 3.0876399993896484e+01 3.5303500366210938e+02 -2.2591400146484375e+01 -3.3876399993896484e+00 3.4994500732421875e+02 -2.2623300552368164e+01 -1.3949899673461914e+01 3.4482501220703125e+02 -2.2590000152587891e+01 -2.1335401535034180e+01 3.3741900634765625e+02 -2.2572399139404297e+01 -2.7345800399780273e+01 2.8399597167968750e+02 -2.2465400695800781e+01 7.0138499140739441e-02 2.8402700805664062e+02 -2.2483798980712891e+01 1.1852000236511230e+01 3.2878399658203125e+02 -2.2568099975585938e+01 -3.1702201843261719e+01 3.1482101440429688e+02 -2.2513198852539062e+01 -3.6335502624511719e+01 3.4956399536132812e+02 -2.2603399276733398e+01 1.4776100158691406e+01 2.7682598876953125e+02 2.3387899398803711e+01 1.2001500129699707e+01 2.8011102294921875e+02 2.6141099929809570e+01 1.3711100578308105e+01 2.8342102050781250e+02 -2.6004800796508789e+01 1.1255299568176270e+01 2.7995602416992188e+02 -2.4622001647949219e+01 9.0958299636840820e+00 2.7636599731445312e+02 1.0545199394226074e+01 1.2132500648498535e+01 2.7690301513671875e+02 2.0893600463867188e+01 1.1493800163269043e+01 3.1025100708007812e+02 -2.0070199966430664e+01 -3.7088302612304688e+01 3.1108599853515625e+02 -2.1187500000000000e+01 -3.7158897399902344e+01 3.1001800537109375e+02 -1.9901199340820312e+01 -3.7811500549316406e+01 3.2788101196289062e+02 -2.6000099182128906e+01 3.0941900253295898e+01 3.4796597290039062e+02 -2.6000099182128906e+01 -1.7636600494384766e+01 3.3692602539062500e+02 -2.6000200271606445e+01 -2.7666399002075195e+01 3.3832202148437500e+02 -2.6000000000000000e+01 2.6807100296020508e+01 3.5251000976562500e+02 -2.5998798370361328e+01 6.9172201156616211e+00 3.5261300659179688e+02 -2.6000099182128906e+01 -5.4188599586486816e+00 3.4654699707031250e+02 -2.5999599456787109e+01 1.9377300262451172e+01 3.2077700805664062e+02 -2.6000000000000000e+01 -3.4507400512695312e+01 3.0941900634765625e+02 -2.5780399322509766e+01 -3.7523899078369141e+01 3.0665902709960938e+02 -2.3165500640869141e+01 -3.8298301696777344e+01 3.0206600952148438e+02 2.6097801208496094e+01 2.9890100479125977e+01 3.5634899902343750e+02 2.6059101104736328e+01 5.8244099617004395e+00 3.4173699951171875e+02 2.6119100570678711e+01 -2.8922599792480469e+01 3.3293499755859375e+02 2.6069200515747070e+01 3.3286003112792969e+01 3.4118099975585938e+02 2.6065099716186523e+01 2.9356100082397461e+01 3.1887200927734375e+02 2.6177400588989258e+01 3.5499000549316406e+01 3.5117098999023438e+02 2.6102998733520508e+01 -1.9248298645019531e+01 3.5633001708984375e+02 2.6052700042724609e+01 -5.8796601295471191e+00 3.2291400146484375e+02 2.6110399246215820e+01 -3.7826000213623047e+01 3.0966400146484375e+02 2.5779899597167969e+01 -4.1416099548339844e+01 3.0705700683593750e+02 2.2368700027465820e+01 -4.2082500457763672e+01 2.8673400878906250e+02 -2.0196599960327148e+01 -1.9524398803710938e+01 2.8292001342773438e+02 -2.0130901336669922e+01 -1.0649800300598145e+01 2.8740502929687500e+02 -2.1659000396728516e+01 -1.7899398803710938e+01 2.8085000610351562e+02 -2.0700000762939453e+01 9.6570396423339844e-01 3.0376397705078125e+02 -2.1434400558471680e+01 -3.4334598541259766e+01 2.9701599121093750e+02 -2.1653200149536133e+01 -2.9821500778198242e+01 2.9126998901367188e+02 -2.0262298583984375e+01 -2.6095800399780273e+01 2.9622201538085938e+02 -2.0309598922729492e+01 -3.0737501144409180e+01 2.8183001708984375e+02 -2.0291500091552734e+01 1.0322500228881836e+01 3.1022799682617188e+02 3.0523300170898438e-02 -3.9105197906494141e+01 3.1023999023437500e+02 -6.9103598594665527e-01 -3.8601200103759766e+01 3.1001202392578125e+02 -4.9342002868652344e+00 -3.8894500732421875e+01 3.1023300170898438e+02 -1.2400699615478516e+01 -3.8026199340820312e+01 3.1012899780273438e+02 -6.8877401351928711e+00 -3.7973697662353516e+01 2.8132199096679688e+02 -1.6647100448608398e-01 1.1363299369812012e+01 2.7825399780273438e+02 -9.0659397840499878e-01 9.5199594497680664e+00 2.8212402343750000e+02 2.5955301284790039e+01 1.0360199928283691e+01 2.7893200683593750e+02 2.2772199630737305e+01 8.5578994750976562e+00 3.0666598510742188e+02 -7.5930498540401459e-02 -3.9983997344970703e+01 3.3258200073242188e+02 2.6001399993896484e+01 2.9845399856567383e+01 3.4378701782226562e+02 2.5999799728393555e+01 2.2355598449707031e+01 3.5053198242187500e+02 2.6000200271606445e+01 -1.2615200042724609e+01 3.0544702148437500e+02 2.6000099182128906e+01 2.7420200347900391e+01 3.1806799316406250e+02 2.5999500274658203e+01 3.1459499359130859e+01 3.4996099853515625e+02 2.6000000000000000e+01 1.3619700431823730e+01 3.2077600097656250e+02 2.6000000000000000e+01 -3.4507198333740234e+01 3.1017700195312500e+02 2.5918500900268555e+01 -3.7336799621582031e+01 3.3648800659179688e+02 2.5999198913574219e+01 -2.7846698760986328e+01 3.5312500000000000e+02 2.6000398635864258e+01 2.1355299949645996e+00 3.4473898315429688e+02 2.6000398635864258e+01 -2.1347400665283203e+01 3.0642398071289062e+02 2.3199699401855469e+01 -3.8352096557617188e+01 3.1038699340820312e+02 9.5664100646972656e+00 -3.8100299835205078e+01 3.0491098022460938e+02 -1.1446600547060370e-03 -3.6421699523925781e+01 3.1004901123046875e+02 2.0163801193237305e+01 -3.7772800445556641e+01 3.1037799072265625e+02 2.0527299880981445e+01 -3.7196598052978516e+01 2.9124600219726562e+02 -3.1401601433753967e-01 -2.7701400756835938e+01 2.8512399291992188e+02 -4.2115998268127441e-01 -1.8362098693847656e+01 2.8168899536132812e+02 1.6421999782323837e-02 -8.6530294418334961e+00 2.8004699707031250e+02 -3.6268499493598938e-01 1.8416399955749512e+00 2.9793301391601562e+02 1.0533499717712402e-01 -3.3168098449707031e+01 2.8349200439453125e+02 2.2290100097656250e+01 1.1396100044250488e+01 2.9908999633789062e+02 2.2815700531005859e+01 2.3235698699951172e+01 3.0568600463867188e+02 2.2533899307250977e+01 2.7233999252319336e+01 2.8182101440429688e+02 2.0269199371337891e+01 1.0274700164794922e+01 3.4589498901367188e+02 2.2556598663330078e+01 2.0075799942016602e+01 3.5085202026367188e+02 2.2621700286865234e+01 1.2020199775695801e+01 3.4709899902343750e+02 2.2597900390625000e+01 -1.8744199752807617e+01 3.3921798706054688e+02 2.2599800109863281e+01 -2.6273900985717773e+01 3.5324798583984375e+02 2.2608600616455078e+01 -6.0054697096347809e-02 3.5123101806640625e+02 2.2599800109863281e+01 -1.0864999771118164e+01 3.1195101928710938e+02 2.2623800277709961e+01 3.0223999023437500e+01 3.2231201171875000e+02 2.2578599929809570e+01 3.1666200637817383e+01 3.3136999511718750e+02 2.2594499588012695e+01 3.0013200759887695e+01 3.3935897827148438e+02 2.2509799957275391e+01 2.6158201217651367e+01 3.1352499389648438e+02 2.2338500976562500e+01 -3.6697799682617188e+01 3.2829998779296875e+02 2.2644899368286133e+01 -3.1856998443603516e+01 3.1922998046875000e+02 2.2708799362182617e+01 -3.5121398925781250e+01 2.9673098754882812e+02 2.0280599594116211e+01 -3.1121299743652344e+01 2.8092199707031250e+02 2.0161300659179688e+01 3.4471898078918457e+00 2.8130001831054688e+02 2.0401599884033203e+01 -3.2472999095916748e+00 2.8355899047851562e+02 2.0190500259399414e+01 -1.2346499443054199e+01 2.8687701416015625e+02 2.0207201004028320e+01 -1.9766799926757812e+01 2.9094100952148438e+02 2.0240200042724609e+01 -2.5731901168823242e+01 3.1107299804687500e+02 2.1322200775146484e+01 -3.6683300018310547e+01 2.8336999511718750e+02 2.2372100830078125e+01 8.4650707244873047e+00 2.8845098876953125e+02 2.2632600784301758e+01 1.5141900062561035e+01 2.9204400634765625e+02 2.2500000000000000e+01 1.7394800186157227e+01 2.9310198974609375e+02 2.2624799728393555e+01 1.8662498474121094e+01 2.9767599487304688e+02 2.2536100387573242e+01 2.1906000137329102e+01 3.2286700439453125e+02 2.2496999740600586e+01 -3.3406997680664062e+01 2.8442098999023438e+02 2.1869798660278320e+01 -9.0608596801757812e+00 2.8940600585937500e+02 2.1477800369262695e+01 -2.1441598892211914e+01 2.8895501708984375e+02 2.2499300003051758e+01 -1.4380199432373047e+01 3.0081399536132812e+02 2.2498498916625977e+01 -2.9665199279785156e+01 2.9939599609375000e+02 2.1758598327636719e+01 -3.1656000137329102e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 5100 -> 68 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01) (float-vector 1.6356499493122101e+02 -5.9376098215579987e+01 -2.7983700856566429e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01) (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01) (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 1.6069699823856354e+02 -5.9322800487279892e+01 2.3000599816441536e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 1.3574500381946564e+02 -4.1949298232793808e+01 5.7254701852798462e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 2.5016900897026062e+02 -5.5311501026153564e+01 -4.2954698204994202e+01) (float-vector 3.0714899301528931e+02 -5.4431200027465820e+01 -3.9724398404359818e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 2.9397699236869812e+02 -5.9558399021625519e+01 -3.5167701542377472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.2424101233482361e+02 -5.9578400105237961e+01 3.4495999570935965e+00) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3758899569511414e+02 -5.4773800075054169e+01 -1.9325299188494682e+01) (float-vector 3.4325098991394043e+02 -5.6178499013185501e+01 1.1262999760219827e-01) (float-vector 3.5057801008224487e+02 -5.2317701280117035e+01 9.2651098966598511e+00) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5240501165390015e+02 -4.6603299677371979e+01 1.6930099576711655e+01) (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4437501430511475e+02 2.7321100234985352e+01 2.8381200507283211e+01) (float-vector 3.4660100936889648e+02 -4.6533301472663879e+01 2.4800499901175499e+01) (float-vector 3.3549800515174866e+02 -5.0789099186658859e+01 2.9877400025725365e+01) (float-vector 3.2470500469207764e+02 -4.6435900032520294e+01 3.5191401839256287e+01) (float-vector 3.3443200588226318e+02 2.7651300653815269e+01 3.4104999154806137e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01) (float-vector 1.0608900338411331e+02 -5.2843600511550903e+01 3.3501900732517242e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 1.0629999637603760e+02 -5.9657998383045197e+01 -9.6062300726771355e+00) (float-vector 1.0590700060129166e+02 -5.1664099097251892e+01 -3.5987500101327896e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.7172899246215820e+02 5.3217999637126923e+01 -4.3895799666643143e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 2.8806599974632263e+02 -1.8376800289843231e-01 -4.7667298465967178e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9490101337432861e+02 5.4677300155162811e+01 -4.2012698948383331e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0639400035142899e+02 -4.0084499865770340e+01 -4.7432500869035721e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.4746199846267700e+02 -5.0817400217056274e+01 -2.0237600430846214e+01) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.5551899671554565e+02 -4.7991901636123657e+01 -8.0698104575276375e+00) (float-vector 3.5655298829078674e+02 -4.6585798263549805e+01 2.8830999508500099e+00) (float-vector 3.5775700211524963e+02 2.7590800076723099e+01 3.1053100246936083e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5141998529434204e+02 -2.7590900659561157e+01 -2.0691899582743645e+01) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.3743399381637573e+02 4.6488400548696518e+01 3.1513798981904984e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01) (float-vector 3.0550199747085571e+02 1.5604100553900935e-03 -4.5325499027967453e+01) (float-vector 3.2262399792671204e+02 -4.8886500298976898e+01 -3.7410400807857513e+01) (float-vector 3.4175801277160645e+02 -4.7322098165750504e+01 -2.8669100254774094e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 1.0631900280714035e+02 6.0075700283050537e+01 -1.4537400566041470e+00) (float-vector 1.0595899820327759e+02 5.5626701563596725e+01 -2.7611199766397476e+01) (float-vector 2.3032300174236298e+02 5.8577701449394226e+01 -3.8440901786088943e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01) (float-vector 1.6257199645042419e+02 5.9422601014375687e+01 2.2507499903440475e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01) (float-vector 9.6001997590065002e+01 -3.1918898224830627e+01 4.6096999198198318e+01) (float-vector 9.6003398299217224e+01 -4.0100999176502228e+01 3.6881901323795319e+01) (float-vector 9.5991402864456177e+01 -5.2353098988533020e+01 2.6103900745511055e+00) (float-vector 9.6001200377941132e+01 -3.9989199489355087e+01 -3.5133898258209229e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 9.6000798046588898e+01 3.9988800883293152e+01 -3.5133600234985352e+01) (float-vector 9.6000097692012787e+01 5.0805099308490753e+01 -1.3062699697911739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 9.6005797386169434e+01 -1.0439700447022915e+01 -5.0292000174522400e+01) (float-vector 1.0753999650478363e+02 0.0000000000000000e+00 -5.4102398455142975e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0627699643373489e+02 4.1895698755979538e+01 -4.6385701745748520e+01) (float-vector 9.6005499362945557e+01 2.9500499367713928e+01 -4.3494999408721924e+01) (float-vector 9.6004799008369446e+01 1.0438700206577778e+01 -5.0291799008846283e+01) (float-vector 1.0749799758195877e+02 2.1781200543045998e+01 -5.2818998694419861e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.3469900190830231e+02 4.1564099490642548e+01 5.7772401720285416e+01) (float-vector 3.2513499259948730e+02 4.9954198300838470e+01 3.3501699566841125e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01) (float-vector 9.5996297895908356e+01 -1.0822400450706482e+01 5.3937699645757675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.6004799008369446e+01 2.6230899617075920e+01 5.0048001110553741e+01) (float-vector 9.6015296876430511e+01 4.8818901181221008e+01 1.9644500687718391e+01) (float-vector 1.0614900290966034e+02 5.0014998763799667e+01 4.0773898363113403e+01) (float-vector 1.0617800056934357e+02 4.4436000287532806e+01 5.2621901035308838e+01) (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0530900210142136e+02 3.4321598708629608e+01 6.5242402255535126e+01) (float-vector 1.2979599833488464e+02 2.8933299705386162e+01 6.6312000155448914e+01) (float-vector 1.0531699657440186e+02 -3.4370500594377518e+01 6.5224297344684601e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.5377600789070129e+02 4.7331199049949646e+01 1.4020999893546104e+01) (float-vector 3.4893900156021118e+02 4.7365598380565643e+01 2.1899100393056870e+01) (float-vector 3.3696499466896057e+02 5.4748099297285080e+01 2.0116200670599937e+01) (float-vector 3.2583698630332947e+02 5.8132298290729523e+01 1.3629400171339512e+01) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.4826299548149109e+02 2.7280200272798538e+01 -2.4681599810719490e+01) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5430300235748291e+02 5.0840999931097031e+01 2.4503499735146761e+00) (float-vector 3.3653500676155090e+02 5.8015000075101852e+01 2.0056299399584532e+00) (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.5230401158332825e+02 4.6536900103092194e+01 -1.7081100493669510e+01) (float-vector 3.5648798942565918e+02 4.6525001525878906e+01 -4.1701798327267170e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3727699518203735e+02 4.6310298144817352e+01 -3.1631298363208771e+01) (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01) (float-vector 3.2102000713348389e+02 4.8730101436376572e+01 -3.8035899400711060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4121999144554138e+02 5.0550501793622971e+01 -2.6544099673628807e+01) (float-vector 3.3256500959396362e+02 5.7484500110149384e+01 -1.3136399909853935e+01) (float-vector 2.9397800564765930e+02 5.9503998607397079e+01 -3.6015700548887253e+01) (float-vector 3.1970798969268799e+02 5.4104100912809372e+01 -3.4696899354457855e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_forearm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_forearm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 171 173 0 1 0 173 0 21 171 2 21 0 2 1 309 1 173 381 309 1 381 171 172 173 172 381 173 381 175 174 308 175 381 381 172 308 381 174 309 13 166 309 174 13 309 2 309 166 124 174 175 174 136 13 233 174 124 233 136 174 136 120 14 136 337 120 13 136 14 136 233 337 233 124 57 337 233 404 404 233 57 337 102 121 337 404 102 102 404 100 404 57 100 100 101 102 120 121 102 101 154 102 154 120 102 274 101 100 274 100 405 57 405 100 274 54 321 101 274 321 405 54 274 54 405 57 53 54 55 89 54 57 53 321 54 55 54 89 91 101 321 91 321 53 90 91 53 101 91 302 91 90 302 90 380 302 53 380 90 380 53 152 152 286 380 380 286 302 151 152 153 286 152 151 152 53 153 361 151 258 258 151 153 361 286 151 53 363 153 209 370 153 363 209 153 370 258 153 258 259 83 361 258 83 370 259 258 370 104 329 370 329 259 370 209 104 209 210 104 294 210 209 363 294 209 123 104 210 123 210 56 294 56 210 294 55 56 363 55 294 56 57 58 89 56 55 56 60 123 60 56 58 56 89 57 53 55 363 58 57 60 124 60 57 60 124 123 122 123 124 124 175 122 245 122 175 245 97 122 122 97 123 308 245 175 245 172 293 308 172 245 245 98 97 98 245 293 97 98 99 123 97 336 97 99 336 104 123 336 336 99 330 330 104 336 225 330 99 99 98 346 99 346 225 98 297 346 297 98 293 296 346 297 346 296 225 163 296 297 297 293 68 163 297 214 68 214 297 165 225 296 165 296 163 163 164 165 165 149 225 164 149 165 332 149 164 164 163 332 148 149 150 149 148 225 150 149 332 331 267 332 267 266 332 331 332 163 266 150 332 267 331 213 213 331 163 253 266 267 253 267 213 266 78 77 77 150 266 78 266 253 79 78 253 155 253 213 155 79 253 213 163 214 214 155 213 155 156 79 155 214 156 77 78 79 156 260 79 141 77 79 79 260 141 77 141 150 314 148 150 150 127 314 150 141 143 150 143 127 148 314 127 148 127 256 256 225 148 127 128 129 256 127 129 143 128 127 141 142 143 128 143 142 128 277 278 128 278 129 128 142 277 215 256 129 335 129 278 334 215 129 334 129 335 334 335 278 278 277 357 313 278 357 354 334 278 354 278 313 341 334 354 341 215 334 313 50 354 50 412 354 412 341 354 176 50 313 313 357 176 357 177 176 277 177 357 51 176 177 176 51 50 50 51 52 177 113 51 51 113 52 252 251 52 50 52 251 252 52 113 251 252 43 170 252 113 44 43 252 44 252 170 251 322 50 251 43 322 43 44 45 43 45 322 169 44 170 44 169 208 45 44 208 341 45 212 322 45 341 45 208 212 50 322 412 412 322 341 212 215 341 195 104 212 104 215 212 208 195 212 208 169 362 208 362 195 195 36 104 195 362 36 362 365 34 169 365 362 34 36 362 34 35 36 35 234 36 104 36 234 46 35 34 365 46 34 365 169 192 192 46 365 194 46 192 46 239 35 194 239 46 239 244 35 35 244 234 239 194 190 239 191 244 191 239 190 244 246 206 244 191 246 206 394 244 234 244 394 190 189 191 246 191 189 194 250 190 189 190 250 188 189 94 246 189 188 189 250 95 94 189 95 216 188 217 217 188 94 216 246 188 94 95 96 96 217 94 250 240 95 96 95 240 96 181 182 181 96 240 182 217 96 42 93 217 182 42 217 217 93 216 181 42 182 385 59 181 59 42 181 241 385 181 241 181 240 385 241 59 59 40 42 284 59 241 284 40 59 240 203 241 284 241 203 202 284 203 40 284 356 284 270 323 356 284 323 284 202 270 40 41 42 41 40 356 41 356 323 307 323 306 41 323 307 306 323 409 323 270 409 92 41 307 41 92 42 92 93 42 306 92 307 93 92 47 92 410 47 410 92 306 306 409 410 409 269 410 270 269 409 410 269 47 268 269 270 269 268 47 268 270 318 268 48 47 48 268 318 202 318 270 4 202 203 202 196 318 202 4 3 3 196 202 3 4 5 343 200 4 200 5 4 196 3 197 3 5 197 199 5 200 193 5 199 5 353 197 193 353 5 199 200 201 343 359 200 200 359 201 203 359 343 201 359 250 359 240 250 203 240 359 199 201 250 199 250 194 193 199 194 192 193 194 169 170 192 192 170 193 113 193 170 112 113 114 319 113 177 113 112 342 193 113 342 319 114 113 193 112 183 183 112 114 112 193 342 183 114 184 114 319 184 319 384 184 399 384 319 319 177 399 177 277 280 177 280 399 384 399 280 384 279 141 184 384 141 384 280 279 142 279 280 277 142 280 142 141 279 260 184 141 260 355 184 355 260 290 260 156 299 290 260 299 290 301 355 25 355 398 355 25 184 355 301 398 398 301 390 390 25 398 390 106 25 390 107 106 301 107 390 106 107 108 107 301 347 108 107 347 106 108 162 292 285 108 162 108 285 292 108 347 282 106 162 285 282 162 281 285 67 282 285 281 68 285 214 68 67 285 285 292 214 281 67 282 8 282 6 282 8 106 282 67 6 62 67 68 80 67 62 6 67 80 6 7 8 74 6 75 6 80 75 74 7 6 106 8 65 7 65 8 106 64 25 64 106 65 64 65 66 25 64 351 349 64 66 351 64 349 66 109 111 65 257 66 66 257 109 66 111 349 349 350 351 349 111 350 350 378 351 351 378 386 386 25 351 350 168 378 350 111 168 109 110 111 167 168 111 111 110 167 109 257 110 110 242 243 257 374 110 110 374 242 110 243 167 257 16 242 257 242 374 16 161 242 161 243 242 161 375 243 375 167 243 16 160 161 160 371 161 371 375 161 371 408 375 375 408 167 160 377 371 371 377 408 160 16 15 160 15 222 160 222 224 160 224 377 376 167 377 377 224 376 377 167 408 262 167 376 262 376 224 222 223 224 224 185 262 224 223 406 224 406 185 187 261 262 333 262 261 262 333 167 185 187 262 185 186 187 186 185 406 187 186 247 187 325 261 325 187 247 333 261 324 391 261 325 283 333 324 283 167 333 247 324 325 324 391 325 283 324 247 186 368 247 368 283 247 69 71 283 368 69 283 167 283 49 283 71 49 48 168 167 49 48 167 276 311 168 378 168 310 48 276 168 310 168 311 276 180 232 180 276 48 232 311 276 310 311 30 311 232 26 30 311 26 400 310 30 378 310 386 400 386 310 25 30 26 25 386 30 30 386 400 24 25 26 231 26 232 26 231 24 232 180 312 231 232 312 340 24 231 312 139 231 340 231 139 340 352 24 25 24 184 184 24 352 340 139 373 340 197 352 340 395 197 395 340 373 137 138 139 137 139 312 138 373 139 180 137 312 138 137 180 138 382 373 138 180 382 48 179 180 180 179 382 373 382 383 382 179 383 316 179 392 401 179 316 317 179 48 401 383 179 47 48 49 317 48 318 316 317 318 316 392 317 318 401 316 196 396 401 196 401 318 396 383 401 196 395 396 197 395 196 395 407 396 407 383 396 395 373 407 373 383 407 197 353 352 183 352 353 183 353 193 352 183 184 72 73 49 72 49 130 326 49 327 47 49 216 71 130 49 326 372 49 372 216 49 73 327 49 326 32 372 364 326 327 326 364 32 85 364 327 85 327 73 364 85 88 364 88 235 32 364 235 31 32 33 32 31 372 32 235 33 372 31 360 372 360 216 360 31 205 31 33 205 33 235 218 33 367 205 33 218 367 235 105 218 235 88 105 104 218 105 218 366 367 366 218 104 367 366 205 204 205 206 204 360 205 205 366 206 216 360 204 246 204 206 204 246 216 206 366 394 366 104 234 394 366 234 103 104 105 328 329 104 338 104 315 104 330 215 104 103 315 339 358 104 339 104 338 358 328 104 225 256 330 215 330 256 81 328 249 328 275 249 328 358 275 329 328 81 248 249 134 249 275 134 131 81 249 248 131 249 358 134 275 28 134 135 358 135 134 248 134 28 132 131 248 28 227 248 227 132 248 131 132 133 131 82 81 131 133 82 125 132 227 132 125 116 132 116 133 140 226 227 28 140 227 226 125 227 28 27 140 140 27 264 140 264 226 264 263 226 226 295 230 226 230 125 263 295 226 263 264 265 265 264 219 27 219 264 263 265 295 265 159 295 411 230 295 159 411 295 265 219 159 159 219 220 27 389 219 369 219 389 219 369 220 157 158 159 157 159 220 158 411 159 304 230 411 158 304 411 158 157 304 157 305 304 305 157 393 157 220 393 186 228 304 305 186 304 304 228 230 397 368 305 186 305 368 305 393 397 393 403 397 393 220 403 397 403 255 255 70 397 70 69 397 397 69 368 254 255 403 403 220 254 220 369 254 254 130 255 254 369 130 130 70 255 69 70 71 71 70 130 9 72 130 9 130 369 9 369 389 29 389 27 389 29 9 27 28 29 10 29 207 29 135 207 29 28 135 29 10 9 9 10 11 19 10 207 11 10 19 339 20 207 339 207 135 20 19 207 358 339 135 20 339 338 18 19 20 20 338 18 18 11 19 22 18 23 22 11 18 338 23 18 338 315 23 22 23 87 87 23 315 144 22 87 22 211 11 72 211 22 144 72 22 85 144 87 86 85 87 315 86 87 84 86 315 103 84 315 84 85 86 85 84 88 73 72 85 72 144 85 211 72 9 9 11 211 88 103 105 88 84 103 228 186 406 228 229 230 228 126 229 228 344 126 229 126 125 125 230 229 117 125 126 126 344 115 115 117 126 344 406 115 320 115 406 223 320 406 115 116 117 320 116 115 116 125 117 133 116 39 39 116 320 222 221 320 320 221 39 320 223 222 37 38 39 39 38 286 221 37 39 286 133 39 286 361 133 82 133 361 286 38 302 303 302 38 38 37 273 38 273 303 302 303 272 147 302 272 146 101 302 146 302 147 272 303 273 271 272 273 37 271 273 147 272 271 271 37 147 145 146 147 147 17 145 17 147 37 154 146 145 146 154 101 17 14 145 154 145 402 120 145 14 15 16 17 16 14 17 15 17 37 37 221 15 15 221 222 12 13 14 21 12 14 118 14 198 118 21 14 198 14 16 65 16 257 198 16 65 7 198 65 7 74 198 76 288 198 288 118 198 198 74 76 74 75 76 76 287 288 76 75 287 288 345 118 287 345 288 63 287 75 287 63 62 287 387 345 287 62 387 80 63 75 61 62 63 63 80 61 68 119 62 62 119 387 61 80 62 387 119 345 119 118 345 118 119 21 21 119 178 119 68 178 178 68 171 293 171 68 21 178 171 12 21 2 12 2 13 2 166 13 172 171 293 402 120 154 82 361 83 81 82 83 329 81 83 259 329 83 93 47 216 238 237 214 214 237 299 238 214 292 156 214 299 298 290 299 299 237 298 290 298 291 237 291 298 236 237 238 291 237 236 289 290 291 236 289 291 300 301 290 300 290 289 289 236 238 289 238 379 379 300 289 347 300 379 301 300 347 379 388 347 379 238 388 348 238 292 292 347 348 347 388 348 413 414 415 413 439 440 413 456 457 461 462 413 456 413 471 461 413 434 435 413 468 413 440 484 413 415 469 413 457 439 413 484 414 462 480 413 413 469 468 435 434 413 502 471 413 480 502 413 469 415 449 415 414 449 467 468 469 467 469 501 501 469 449 449 414 450 452 501 449 452 449 450 450 414 484 453 452 450 453 450 464 464 450 484 451 452 453 501 452 488 451 488 452 488 491 501 491 467 501 419 488 451 419 442 488 442 491 488 419 451 453 453 489 419 489 453 464 489 464 463 419 489 463 463 464 459 419 463 423 463 459 424 423 463 424 439 459 440 464 484 459 424 459 439 459 484 440 424 439 443 439 457 443 457 456 447 447 443 457 447 456 471 446 447 448 446 443 447 471 448 447 448 471 428 471 502 496 428 471 496 496 502 481 481 502 480 480 462 481 496 481 475 475 481 462 475 462 474 474 462 461 482 475 474 496 475 482 455 417 474 417 476 474 482 474 476 474 461 455 455 461 434 454 455 434 417 455 433 455 454 433 434 435 436 454 434 436 470 454 441 470 433 454 454 436 441 436 435 467 436 467 491 441 436 491 435 468 467 442 441 491 441 442 419 419 470 441 470 499 433 470 419 499 419 431 499 499 431 433 419 420 421 419 479 420 419 422 500 419 500 479 421 431 419 423 422 419 421 420 477 431 421 477 477 420 478 477 478 431 420 498 478 478 498 431 498 427 495 498 495 432 498 432 431 420 427 498 495 427 494 494 432 495 431 432 433 494 487 432 432 487 433 427 493 494 487 494 493 493 427 485 493 485 487 485 486 487 485 427 486 486 427 490 487 486 490 490 460 487 490 427 460 427 426 460 497 487 460 460 426 497 425 426 427 427 420 425 472 444 425 472 425 479 425 444 448 425 420 479 448 426 425 422 472 473 472 422 445 473 472 479 445 444 472 443 444 445 444 503 448 444 443 503 503 446 448 448 428 426 503 443 446 424 443 445 424 445 422 422 423 424 422 473 500 500 473 479 437 426 438 426 418 483 426 483 465 426 437 497 426 465 438 426 428 418 466 497 437 466 437 438 438 465 466 483 466 465 483 417 466 418 417 483 416 417 418 428 416 418 416 428 458 416 458 417 428 429 430 428 496 429 492 428 430 428 492 458 458 492 417 492 430 417 429 417 430 429 476 417 466 417 433 429 496 476 496 482 476 487 466 433 497 466 487))
                   (list :vertices (let ((mat (make-matrix 504 3))) (fvector-replace (array-entity mat) #f(1.0600399780273438e+02 -9.3246002197265625e+00 4.0252799987792969e+01 1.0598299407958984e+02 -9.9800395965576172e+00 4.1002197265625000e+01 1.0650300598144531e+02 -9.8726997375488281e+00 4.0323699951171875e+01 1.0650000000000000e+02 3.3295299530029297e+01 3.3229999542236328e+00 1.0650000000000000e+02 3.7112499237060547e+01 -1.7666699886322021e+00 1.0600000000000000e+02 3.6189399719238281e+01 2.9743599891662598e-01 1.0600000000000000e+02 -6.6358900070190430e+00 2.8250999450683594e+01 1.0650000000000000e+02 -7.0874996185302734e+00 2.7699298858642578e+01 1.0650000000000000e+02 -6.5229802131652832e+00 2.7763898849487305e+01 9.3900001525878906e+01 -2.9588500976562500e+01 -2.8441398620605469e+01 9.3413299560546875e+01 -3.0424699783325195e+01 -2.8075599670410156e+01 9.3411102294921875e+01 -2.4949800491333008e+01 -3.3031002044677734e+01 1.0650000000000000e+02 -9.5875005722045898e+00 3.9289199829101562e+01 1.0650000000000000e+02 -1.1491900444030762e+01 4.0733596801757812e+01 1.0650000000000000e+02 -9.5875005722045898e+00 3.0199300765991211e+01 1.0650000000000000e+02 -2.0087499618530273e+01 2.1166700363159180e+01 1.0650000000000000e+02 -1.3721800804138184e+01 2.1760900497436523e+01 1.0650000000000000e+02 -1.9587499618530273e+01 2.2666700363159180e+01 9.2408096313476562e+01 -2.3180099487304688e+01 -3.4330402374267578e+01 9.2397506713867188e+01 -2.8620300292968750e+01 -2.9883300781250000e+01 9.1900001525878906e+01 -2.6001699447631836e+01 -3.1681198120117188e+01 1.0600000000000000e+02 -9.0875005722045898e+00 3.9289199829101562e+01 9.3408103942871094e+01 -1.6778999328613281e+01 -3.7901401519775391e+01 9.2405998229980469e+01 -1.6652399063110352e+01 -3.7882999420166016e+01 1.0650000000000000e+02 1.5394399642944336e+01 2.0419599533081055e+01 1.0650000000000000e+02 6.1935896873474121e+00 2.4935699462890625e+01 1.0599099731445312e+02 1.2504000663757324e+01 2.1621500015258789e+01 9.3900001525878906e+01 -3.7409099578857422e+01 -1.6526000976562500e+01 9.3402702331542969e+01 -3.9415500640869141e+01 -1.2758299827575684e+01 9.3392402648925781e+01 -3.5738700866699219e+01 -2.1080900192260742e+01 1.0599300384521484e+02 9.1015205383300781e+00 2.3263000488281250e+01 9.3406600952148438e+01 2.4851999282836914e+01 -3.2996597290039062e+01 9.3432800292968750e+01 1.6941999435424805e+01 -3.7724899291992188e+01 9.2378898620605469e+01 2.2726900100708008e+01 -3.4521099090576172e+01 9.2381599426269531e+01 4.0499603271484375e+01 8.1415395736694336e+00 9.2389595031738281e+01 4.1256599426269531e+01 -9.2630404233932495e-01 9.1900001525878906e+01 4.0202098846435547e+01 7.5019397735595703e+00 1.0600000000000000e+02 -2.0487501144409180e+01 2.1466699600219727e+01 9.3900001525878906e+01 -2.3876300811767578e+01 1.6948299407958984e+01 9.3900001525878906e+01 -2.8699298858642578e+01 1.0517600059509277e+01 1.0650000000000000e+02 2.8912500381469727e+01 -1.5500000000000000e+01 1.0600000000000000e+02 2.8912500381469727e+01 -1.6000000000000000e+01 1.0600000000000000e+02 3.5912498474121094e+01 -1.6000000000000000e+01 9.3395004272460938e+01 2.5451200485229492e+01 3.2538299560546875e+01 9.3402198791503906e+01 2.9934200286865234e+01 2.8402200698852539e+01 9.2391105651855469e+01 2.6465398788452148e+01 3.1714000701904297e+01 9.3364402770996094e+01 4.0916999816894531e+01 5.9389500617980957e+00 9.3900001525878906e+01 2.5748399734497070e+01 -1.7015600204467773e+01 9.3900001525878906e+01 2.6912498474121094e+01 -2.0355300903320312e+00 9.3900001525878906e+01 3.2329201698303223e+00 -2.1429899215698242e+01 9.3400001525878906e+01 2.0340499877929688e+01 3.6153301239013672e+01 9.3900001525878906e+01 1.9912500381469727e+01 3.5890602111816406e+01 9.3900001525878906e+01 2.0921501159667969e+01 3.4975101470947266e+01 9.3400001525878906e+01 -2.1354000091552734e+01 3.5403800964355469e+01 9.3400001525878906e+01 -2.0012001037597656e+01 3.7159000396728516e+01 9.2403205871582031e+01 -2.0478799819946289e+01 3.6168800354003906e+01 9.1900001525878906e+01 -1.9530899047851562e+01 3.7022998809814453e+01 9.2399902343750000e+01 -1.8969900131225586e+01 3.8409599304199219e+01 9.1900001525878906e+01 -1.9235099792480469e+01 3.7579799652099609e+01 1.0650000000000000e+02 3.5912498474121094e+01 -1.5500000000000000e+01 9.1900001525878906e+01 -1.8749300003051758e+01 3.7960903167724609e+01 9.3900001525878906e+01 -7.0874996185302734e+00 2.8199300765991211e+01 9.3900505065917969e+01 -8.7110004425048828e+00 2.8879299163818359e+01 9.7287002563476562e+01 -7.4840898513793945e+00 2.8202800750732422e+01 1.0650000000000000e+02 -8.7499998509883881e-02 2.5500000000000000e+01 1.0650000000000000e+02 -4.6803097724914551e+00 2.5189298629760742e+01 1.0597900390625000e+02 -3.3031499385833740e+00 2.4831300735473633e+01 9.3900100708007812e+01 -4.4406099319458008e+00 2.8699598312377930e+01 9.3900001525878906e+01 -4.4287500381469727e+00 3.5016902923583984e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -1.4000000000000000e+01 9.3900398254394531e+01 -2.7206899642944336e+01 -1.4783800125122070e+01 9.3900001525878906e+01 -2.5091600418090820e+01 -1.4711099624633789e+01 9.3900001525878906e+01 -8.0413503646850586e+00 -4.0114601135253906e+01 9.3900001525878906e+01 -8.7499998509883881e-02 -4.0800003051757812e+01 1.0600000000000000e+02 -7.0874996185302734e+00 2.8199300765991211e+01 1.0093800354003906e+02 -7.3930997848510742e+00 2.8199300765991211e+01 1.0600200653076172e+02 -8.0970792770385742e+00 2.8461198806762695e+01 1.0650000000000000e+02 1.1316900253295898e+01 4.0733596801757812e+01 1.0650000000000000e+02 9.6878404617309570e+00 4.0155300140380859e+01 1.0650000000000000e+02 9.4125003814697266e+00 3.9289199829101562e+01 9.3900001525878906e+01 -6.6358900070190430e+00 2.8250999450683594e+01 9.2385200500488281e+01 -4.0352100372314453e+01 9.5234107971191406e+00 9.3386802673339844e+01 -3.9813598632812500e+01 1.1657099723815918e+01 9.2398803710937500e+01 -3.7589698791503906e+01 1.7452501296997070e+01 9.2400001525878906e+01 -8.7499998509883881e-02 -4.1299999237060547e+01 9.3400001525878906e+01 -8.7499998509883881e-02 -4.1299999237060547e+01 9.2400001525878906e+01 -2.2346801757812500e+00 -4.1244102478027344e+01 9.2419296264648438e+01 -8.8318500518798828e+00 -4.0474899291992188e+01 9.2400001525878906e+01 4.4464502334594727e+00 -4.1099399566650391e+01 9.2400001525878906e+01 -2.0012001037597656e+01 3.7159000396728516e+01 9.3900001525878906e+01 -2.1096500396728516e+01 3.4975101470947266e+01 9.3900001525878906e+01 -2.0087499618530273e+01 3.5890602111816406e+01 9.3900001525878906e+01 2.8912500381469727e+01 -1.6000000000000000e+01 9.3900001525878906e+01 3.5912498474121094e+01 -1.6000000000000000e+01 9.3900398254394531e+01 3.7752502441406250e+01 -1.4911700248718262e+01 9.3900001525878906e+01 3.7912498474121094e+01 -1.4000000000000000e+01 9.9105003356933594e+01 3.7702899932861328e+01 -1.4991199493408203e+01 9.2392898559570312e+01 -6.9005999565124512e+00 4.2310798645019531e+01 9.3388702392578125e+01 -4.5561299324035645e+00 4.2613597869873047e+01 9.2399902343750000e+01 -8.7499998509883881e-02 4.2800003051757812e+01 9.9789199829101562e+01 -1.9569999694824219e+01 3.7992500305175781e+01 9.9448005676269531e+01 -2.0088499069213867e+01 3.6596298217773438e+01 1.0601799774169922e+02 -1.9599800109863281e+01 3.7949600219726562e+01 9.1900001525878906e+01 -8.7507396936416626e-02 -4.0801101684570312e+01 9.1900001525878906e+01 4.9303202629089355e+00 1.2872800230979919e-01 9.1900001525878906e+01 7.6348896026611328e+00 -4.0122501373291016e+01 1.0650000000000000e+02 -6.6803991794586182e-02 2.8663000106811523e+01 1.0600000000000000e+02 6.4608902931213379e+00 2.8250999450683594e+01 1.0599700164794922e+02 2.4476599693298340e+00 2.8908599853515625e+01 9.9694602966308594e+01 -5.3148398399353027e+00 2.4455200195312500e+01 9.3900299072265625e+01 -9.5627698898315430e+00 2.3286100387573242e+01 9.3900100708007812e+01 -2.5808298587799072e+00 2.4900199890136719e+01 1.0201699829101562e+02 2.0000200271606445e+01 2.2045898437500000e+01 9.3900001525878906e+01 1.9912500381469727e+01 2.2666700363159180e+01 1.0600000000000000e+02 1.9912500381469727e+01 2.2666700363159180e+01 1.0600000000000000e+02 -3.7687500000000000e+01 -1.4666699171066284e+00 9.3900001525878906e+01 -3.7687500000000000e+01 -1.4666699171066284e+00 9.9827201843261719e+01 -3.8002597808837891e+01 -2.0540900230407715e+00 1.0600000000000000e+02 -9.0875005722045898e+00 3.0199300765991211e+01 9.3900001525878906e+01 -9.0875005722045898e+00 3.0199300765991211e+01 1.0650000000000000e+02 -1.9360799789428711e+01 3.7407600402832031e+01 1.0650000000000000e+02 -1.9090600967407227e+01 3.7729499816894531e+01 9.2399902343750000e+01 -1.1674500465393066e+01 4.1201698303222656e+01 9.1900001525878906e+01 -1.2428300857543945e+01 4.0568698883056641e+01 9.2383598327636719e+01 -1.5034199714660645e+01 4.0139198303222656e+01 9.3900001525878906e+01 -3.8087497711181641e+01 -2.6666698455810547e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -2.6666698455810547e+00 9.2402900695800781e+01 1.5613400459289551e+01 3.9825500488281250e+01 9.2399902343750000e+01 1.8794898986816406e+01 3.8409599304199219e+01 9.1900001525878906e+01 1.8574298858642578e+01 3.7960903167724609e+01 9.3900207519531250e+01 -2.8023799896240234e+01 -1.5721600532531738e+01 9.3409004211425781e+01 -4.1222801208496094e+01 4.0004796981811523e+00 9.3900001525878906e+01 -4.1014400482177734e+01 6.6825497150421143e-01 9.3900001525878906e+01 -3.8707698822021484e+01 1.3752300262451172e+01 9.2404098510742188e+01 -4.0284500122070312e+01 -9.7258100509643555e+00 9.2391494750976562e+01 -3.7257999420166016e+01 -1.8208600997924805e+01 1.0650000000000000e+02 -1.5166000366210938e+01 3.9557300567626953e+01 9.3900001525878906e+01 2.0506999969482422e+01 1.4206100463867188e+01 9.3900001525878906e+01 2.2031000137329102e+01 1.1682899475097656e+01 1.0600000000000000e+02 1.9891799926757812e+01 1.5122599601745605e+01 9.3900001525878906e+01 -3.8674297332763672e+01 -1.3276100158691406e+01 1.0650000000000000e+02 1.8574298858642578e+01 3.7960903167724609e+01 1.0600000000000000e+02 1.8794898986816406e+01 3.8409599304199219e+01 1.0600000000000000e+02 1.7009399414062500e+01 3.9236900329589844e+01 9.3409599304199219e+01 -8.9973201751708984e+00 -4.0360099792480469e+01 1.0650000000000000e+02 -1.9587499618530273e+01 3.6614700317382812e+01 1.0600000000000000e+02 -2.0087499618530273e+01 3.4290100097656250e+01 1.0600000000000000e+02 -2.0087499618530273e+01 2.2666700363159180e+01 9.2396102905273438e+01 1.2555500030517578e+01 4.0893497467041016e+01 9.3400001525878906e+01 1.1451700210571289e+01 4.1215099334716797e+01 1.0600000000000000e+02 1.1451700210571289e+01 4.1215099334716797e+01 9.3404396057128906e+01 -3.3095596313476562e+01 2.4880500793457031e+01 9.3406402587890625e+01 -2.8592300415039062e+01 2.9951200485229492e+01 9.2407302856445312e+01 -2.8450201034545898e+01 3.0166799545288086e+01 1.0600000000000000e+02 -2.0087499618530273e+01 3.6614700317382812e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.9289199829101562e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.7021301269531250e+01 1.0650000000000000e+02 -2.9087501525878906e+01 -1.5500000000000000e+01 1.0650000000000000e+02 -3.6087501525878906e+01 -1.5500000000000000e+01 1.0600000000000000e+02 -3.6087501525878906e+01 -1.6000000000000000e+01 1.0650000000000000e+02 -1.9367498397827148e+01 1.6780199050903320e+01 1.0600900268554688e+02 -1.4913300514221191e+01 2.0185100555419922e+01 1.0600000000000000e+02 -8.7499998509883881e-02 2.9000000000000000e+01 9.3900001525878906e+01 1.0014199256896973e+01 4.1076103210449219e+01 9.3470703125000000e+01 1.0912500381469727e+01 4.1289199829101562e+01 9.3401603698730469e+01 9.4109992980957031e+00 4.1740600585937500e+01 1.0650000000000000e+02 -1.1087499618530273e+01 4.0789203643798828e+01 9.3900001525878906e+01 -2.3235599517822266e+01 9.4426298141479492e+00 9.3900001525878906e+01 2.6852600574493408e+00 2.2159900665283203e+01 9.3396995544433594e+01 3.4466503143310547e+01 2.2775400161743164e+01 9.3900001525878906e+01 3.3555400848388672e+01 2.3256198883056641e+01 9.3900207519531250e+01 -9.3199396133422852e+00 4.0288299560546875e+01 9.3900001525878906e+01 -1.0189300537109375e+01 4.1076198577880859e+01 9.9941795349121094e+01 -9.8314399719238281e+00 4.0885002136230469e+01 1.0600000000000000e+02 -1.1626799583435059e+01 4.1215099334716797e+01 9.3400001525878906e+01 -1.1626799583435059e+01 4.1215099334716797e+01 9.3523300170898438e+01 1.9912500381469727e+01 3.6614700317382812e+01 9.9448005676269531e+01 1.9913700103759766e+01 3.6595001220703125e+01 9.3900001525878906e+01 -9.0875005722045898e+00 3.9289199829101562e+01 9.3900001525878906e+01 2.6764400482177734e+01 3.6317798495292664e-01 9.3900001525878906e+01 1.8313100814819336e+01 1.0928699493408203e+01 1.0600499725341797e+02 3.7710399627685547e+01 -1.5080300331115723e+01 1.0130699920654297e+02 3.6695701599121094e+01 -1.5872699737548828e+01 1.0600000000000000e+02 2.0312500000000000e+01 2.1466699600219727e+01 1.0650000000000000e+02 1.9412500381469727e+01 2.2666700363159180e+01 1.0650000000000000e+02 -2.7402299880981445e+01 5.5203098058700562e-01 1.0650000000000000e+02 -2.7587499618530273e+01 -3.9223200082778931e-01 1.0600000000000000e+02 -2.6939399719238281e+01 3.6317798495292664e-01 9.3900001525878906e+01 3.7635597229003906e+01 -1.5554800033569336e+01 9.3900001525878906e+01 3.8502201080322266e+01 -1.3257499694824219e+01 9.3900207519531250e+01 4.0495998382568359e+01 -5.6626601219177246e+00 9.3403602600097656e+01 3.9685398101806641e+01 -1.1262900352478027e+01 9.3900100708007812e+01 3.8247600555419922e+01 1.4279799461364746e+01 9.3900001525878906e+01 2.0312500000000000e+01 2.1466699600219727e+01 9.3900001525878906e+01 4.0478500366210938e+01 5.0050797462463379e+00 9.1900001525878906e+01 3.5986999511718750e+01 1.9333099365234375e+01 1.0650000000000000e+02 2.7227298736572266e+01 5.5203098058700562e-01 1.0650000000000000e+02 2.7447898864746094e+01 1.1119500160217285e+01 1.0650000000000000e+02 -9.0512905120849609e+00 2.8470100402832031e+01 9.3900001525878906e+01 3.7512500762939453e+01 -1.4666699171066284e+00 1.0600000000000000e+02 3.7512500762939453e+01 -1.4666699171066284e+00 9.9817298889160156e+01 3.7823200225830078e+01 -2.0384600162506104e+00 1.0650000000000000e+02 2.7412500381469727e+01 -3.9223200082778931e-01 1.0650000000000000e+02 3.7412498474121094e+01 -2.6666698455810547e+00 9.3403198242187500e+01 3.4390399932861328e+01 -2.2877498626708984e+01 9.2387306213378906e+01 3.0786600112915039e+01 -2.7630100250244141e+01 9.2408302307128906e+01 3.6649398803710938e+01 -1.9086898803710938e+01 9.2399597167968750e+01 -3.2656497955322266e+01 -2.5475799560546875e+01 9.2416000366210938e+01 3.2024799346923828e+01 2.6073099136352539e+01 9.1900001525878906e+01 -2.4570699691772461e+01 3.2691398620605469e+01 9.1900001525878906e+01 -1.8576599121093750e+01 3.1771800994873047e+01 9.3900207519531250e+01 -1.8980400085449219e+01 -3.6389297485351562e+01 9.1900001525878906e+01 2.8560400009155273e+01 2.9231300354003906e+01 9.9875999450683594e+01 9.0505599975585938e+00 4.0098400115966797e+01 9.3900001525878906e+01 8.9125003814697266e+00 3.9289199829101562e+01 9.1900001525878906e+01 1.3297299385070801e+01 3.4903400421142578e+01 9.3900001525878906e+01 3.4007999420166016e+01 -2.2763601303100586e+01 9.3900299072265625e+01 3.6679397583007812e+01 -1.5887800216674805e+01 9.1900001525878906e+01 1.7298400878906250e+01 -3.7057003021240234e+01 9.3900001525878906e+01 -3.6087501525878906e+01 -1.6000000000000000e+01 1.0600000000000000e+02 -2.9087501525878906e+01 -1.6000000000000000e+01 1.0600000000000000e+02 -2.1810600280761719e+01 1.9702600479125977e+01 1.0650000000000000e+02 -2.3501298904418945e+01 1.6614999771118164e+01 1.0650000000000000e+02 -2.6674398422241211e+01 1.2384099960327148e+01 1.0650000000000000e+02 -2.3698600769042969e+01 9.6314802169799805e+00 9.2391700744628906e+01 6.3834495544433594e+00 4.2426898956298828e+01 9.3900001525878906e+01 -3.8087497711181641e+01 -1.4000000000000000e+01 9.3900001525878906e+01 -4.0095703125000000e+01 -8.3186407089233398e+00 1.0650000000000000e+02 -3.7587501525878906e+01 -2.6666698455810547e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -4.9265303611755371e+00 1.0600000000000000e+02 -3.8087497711181641e+01 -1.4000000000000000e+01 1.0594300079345703e+02 1.6699501037597656e+01 1.8565099716186523e+01 9.3900001525878906e+01 1.5863999366760254e+01 1.9328399658203125e+01 1.0597799682617188e+02 -1.6018999099731445e+01 3.9784000396728516e+01 9.1900001525878906e+01 4.0520999908447266e+01 -5.2265801429748535e+00 9.2382598876953125e+01 1.3552900314331055e+01 -3.9082500457763672e+01 9.3900299072265625e+01 8.6850299835205078e+00 2.9167600631713867e+01 9.3900001525878906e+01 8.9125003814697266e+00 3.0199300765991211e+01 9.3900001525878906e+01 7.5170097351074219e+00 2.8283599853515625e+01 9.3403396606445312e+01 4.1101699829101562e+01 -3.9148898124694824e+00 1.0600000000000000e+02 3.7912498474121094e+01 -1.4000000000000000e+01 1.0650000000000000e+02 3.7412498474121094e+01 -1.4000000000000000e+01 1.0599199676513672e+02 -1.1893699645996094e+01 2.2043901443481445e+01 9.3900207519531250e+01 -1.4989999771118164e+01 2.0105001449584961e+01 9.2418403625488281e+01 4.0169498443603516e+01 -9.7180500030517578e+00 9.3401702880859375e+01 -9.5865297317504883e+00 4.1740497589111328e+01 9.3389503479003906e+01 3.7671600341796875e+01 -1.6828001022338867e+01 1.0600000000000000e+02 -2.7087499618530273e+01 -3.9223200082778931e-01 9.3412597656250000e+01 -4.1312900543212891e+01 -4.0082297325134277e+00 9.2414794921875000e+01 -4.1516300201416016e+01 -5.2713996171951294e-01 9.3900001525878906e+01 3.7912498474121094e+01 -2.6666698455810547e+00 9.3400001525878906e+01 2.1179000854492188e+01 3.5403800964355469e+01 9.3900207519531250e+01 2.6472499847412109e+01 3.1160200119018555e+01 1.0598500061035156e+02 9.3084707260131836e+00 4.0737899780273438e+01 9.9499000549316406e+01 -2.8394500732421875e+01 -1.5902200698852539e+01 1.0005900573730469e+02 -2.7663101196289062e+01 -1.5436699867248535e+01 9.1900001525878906e+01 1.1130999565124512e+01 4.0882503509521484e+01 1.0598899841308594e+02 -7.8268003463745117e+00 2.3793001174926758e+01 9.2390098571777344e+01 -3.3803199768066406e+01 2.3915498733520508e+01 9.1899902343750000e+01 -3.5675201416015625e+01 2.0122200012207031e+01 1.0650000000000000e+02 9.4125003814697266e+00 3.0199300765991211e+01 9.3900001525878906e+01 -2.6939399719238281e+01 3.6317798495292664e-01 1.0600000000000000e+02 -2.3235599517822266e+01 9.4426298141479492e+00 1.0016500091552734e+02 -3.7756099700927734e+01 -1.5144499778747559e+01 9.3900505065917969e+01 -3.7711799621582031e+01 -1.5224800109863281e+01 9.9814598083496094e+01 -3.6905601501464844e+01 -1.5854300498962402e+01 1.0600000000000000e+02 1.0912500381469727e+01 4.1289199829101562e+01 1.0341500091552734e+02 9.9233999252319336e+00 4.1065299987792969e+01 9.3900001525878906e+01 2.6912498474121094e+01 -8.0455598831176758e+00 9.3900001525878906e+01 2.6912498474121094e+01 -1.4000000000000000e+01 1.0600000000000000e+02 2.6912498474121094e+01 -1.4000000000000000e+01 1.0354100036621094e+02 -2.0188400268554688e+01 2.1996601104736328e+01 9.3900001525878906e+01 -2.0189100265502930e+01 2.2038200378417969e+01 9.5916702270507812e+01 -2.0487501144409180e+01 2.1466699600219727e+01 9.7154197692871094e+01 -2.0028099060058594e+01 3.7137798309326172e+01 9.1899902343750000e+01 -4.0211902618408203e+01 -7.8426403999328613e+00 9.3900001525878906e+01 1.2059900283813477e+01 1.6713600158691406e+01 9.9697906494140625e+01 1.9392900466918945e+01 3.7993598937988281e+01 9.2386795043945312e+01 1.9438899993896484e+01 3.7936401367187500e+01 1.0650000000000000e+02 1.9207901000976562e+01 3.7462398529052734e+01 1.0601200103759766e+02 1.9745201110839844e+01 3.7513496398925781e+01 1.0035599517822266e+02 -3.4069099426269531e+00 2.8835498809814453e+01 1.0598299407958984e+02 -3.8346300125122070e+00 2.8819200515747070e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -1.0350299835205078e+01 1.0650000000000000e+02 2.7412500381469727e+01 -1.4000000000000000e+01 9.3900001525878906e+01 -8.7499998509883881e-02 2.9000000000000000e+01 9.3900001525878906e+01 -3.2327999114990234e+01 2.5194601058959961e+01 9.9455902099609375e+01 -8.1943197250366211e+00 2.8504699707031250e+01 1.0599599456787109e+02 -8.8718595504760742e+00 2.9192899703979492e+01 9.8024703979492188e+01 8.0216798782348633e+00 2.8510099411010742e+01 1.0598199462890625e+02 8.6136703491210938e+00 2.9092199325561523e+01 9.7616302490234375e+01 8.7357902526855469e+00 2.9290100097656250e+01 9.3900001525878906e+01 3.3122398853302002e+00 2.8839399337768555e+01 9.3900001525878906e+01 -7.3392200469970703e+00 4.1708702087402344e+01 9.1900001525878906e+01 -2.1096599578857422e+01 3.4975299835205078e+01 1.0596800231933594e+02 -3.7815601348876953e+01 -1.5168800354003906e+01 9.3400901794433594e+01 4.9529399871826172e+00 4.2534103393554688e+01 9.3900001525878906e+01 -8.7683498859405518e-02 4.2300102233886719e+01 1.0126999664306641e+02 8.7984600067138672e+00 2.9463800430297852e+01 1.0600000000000000e+02 8.9125003814697266e+00 3.0199300765991211e+01 1.0218899536132812e+02 7.2825798988342285e+00 2.8204401016235352e+01 1.0600000000000000e+02 6.9124999046325684e+00 2.8199300765991211e+01 9.3900001525878906e+01 -2.0087499618530273e+01 2.2666700363159180e+01 9.3900001525878906e+01 -2.0487501144409180e+01 2.1466699600219727e+01 1.0650000000000000e+02 -3.7587501525878906e+01 -1.4000000000000000e+01 1.0650000000000000e+02 -2.7587499618530273e+01 -1.4000000000000000e+01 9.8280403137207031e+01 2.7946001052856445e+01 -1.5811499595642090e+01 1.0268199920654297e+02 2.8152999877929688e+01 -1.5884300231933594e+01 9.3470703125000000e+01 -1.1087499618530273e+01 4.1289199829101562e+01 1.0600000000000000e+02 -1.1087499618530273e+01 4.1289199829101562e+01 9.3900100708007812e+01 7.0825800895690918e+00 2.4032499313354492e+01 9.3900100708007812e+01 1.1174400329589844e+01 2.2354200363159180e+01 9.3900001525878906e+01 1.8604499816894531e+01 1.6615100860595703e+01 9.3400001525878906e+01 1.9836999893188477e+01 3.7159000396728516e+01 9.4666503906250000e+01 1.3333999633789062e+01 4.0641201019287109e+01 9.1900001525878906e+01 -7.3356599807739258e+00 -4.0374698638916016e+01 9.8919898986816406e+01 2.6872598648071289e+01 2.4476198479533195e-02 9.3900001525878906e+01 2.6912498474121094e+01 -3.9223200082778931e-01 1.0600000000000000e+02 2.6912498474121094e+01 -3.9223200082778931e-01 1.0600000000000000e+02 1.9912500381469727e+01 3.0176500320434570e+01 1.0600000000000000e+02 -3.0159299850463867e+01 8.5709695816040039e+00 9.3523300170898438e+01 -2.0087499618530273e+01 3.6614700317382812e+01 9.2400001525878906e+01 2.1179000854492188e+01 3.5403800964355469e+01 1.0600399780273438e+02 2.7398899078369141e+01 -1.5334899902343750e+01 9.3900001525878906e+01 -2.7087499618530273e+01 -3.9223200082778931e-01 9.8919395446777344e+01 -2.7047599792480469e+01 2.4511799216270447e-02 9.3900001525878906e+01 1.5882499694824219e+01 -3.7669597625732422e+01 9.3900001525878906e+01 6.8354401588439941e+00 -4.0268199920654297e+01 9.1900001525878906e+01 -4.0944000244140625e+01 2.4558799266815186e+00 9.1900001525878906e+01 -3.9046298980712891e+01 1.2369800567626953e+01 9.1900001525878906e+01 -8.7499998509883881e-02 4.2300102233886719e+01 9.8157798767089844e+01 9.4639606475830078e+00 4.0718399047851562e+01 9.7581398010253906e+01 1.0627600669860840e+01 4.1296298980712891e+01 9.3900001525878906e+01 -2.6477800369262695e+01 1.4946999549865723e+00 9.1900001525878906e+01 1.9355899810791016e+01 3.7022998809814453e+01 9.1900001525878906e+01 1.9059200286865234e+01 3.7578601837158203e+01 9.1900001525878906e+01 -5.2440600395202637e+00 4.2013500213623047e+01 1.0650000000000000e+02 -1.8749300003051758e+01 3.7960903167724609e+01 9.1899902343750000e+01 -1.7429599761962891e+01 -3.7005599975585938e+01 9.1900001525878906e+01 -3.3679000854492188e+01 -2.3326900482177734e+01 1.0650000000000000e+02 2.0976900100708008e+01 1.4521100044250488e+01 9.1900001525878906e+01 2.0921598434448242e+01 3.4975299835205078e+01 9.3900001525878906e+01 2.0016700744628906e+01 2.2030399322509766e+01 1.0650000000000000e+02 3.7334400177001953e+01 -2.1894900798797607e+00 1.0650000000000000e+02 -3.7511299133300781e+01 -2.1952900886535645e+00 1.0118400573730469e+02 -8.9532308578491211e+00 2.9394100189208984e+01 9.3400001525878906e+01 -8.7683498859405518e-02 4.2800003051757812e+01 9.9951400756835938e+01 6.4147200584411621e+00 2.8265998840332031e+01 9.3900001525878906e+01 6.4608902931213379e+00 2.8250999450683594e+01 1.0600000000000000e+02 -8.7499998509883881e-02 2.5000000000000000e+01 9.3900001525878906e+01 -8.7499998509883881e-02 2.5000000000000000e+01 1.0599700164794922e+02 1.8315600156784058e+00 2.4939199447631836e+01 1.0650000000000000e+02 1.9912500381469727e+01 2.1166700363159180e+01 1.0600000000000000e+02 2.4416099548339844e+01 1.5995201110839844e+01 9.2400001525878906e+01 1.9836999893188477e+01 3.7159000396728516e+01 1.0650000000000000e+02 8.1638097763061523e+00 2.8034999847412109e+01 1.0650099945068359e+02 2.8099599838256836e+01 -1.5283200263977051e+01 9.6401603698730469e+01 1.9813100814819336e+01 3.7308498382568359e+01 9.1900001525878906e+01 -3.7668601989746094e+01 -1.6015399932861328e+01 1.0600000000000000e+02 3.7912498474121094e+01 -2.6666698455810547e+00 9.3402099609375000e+01 2.9712099075317383e+01 -2.8631700515747070e+01 9.3402198791503906e+01 -3.6710697174072266e+01 1.9200698852539062e+01 9.2392494201660156e+01 3.7046501159667969e+01 1.8352899551391602e+01 9.2400001525878906e+01 -2.1354000091552734e+01 3.5403800964355469e+01 9.3408401489257812e+01 8.5287199020385742e+00 -4.0435798645019531e+01 9.3401603698730469e+01 3.8474102020263672e+01 1.4962200164794922e+01 9.1900001525878906e+01 3.3029602050781250e+01 -2.3929498672485352e+01 9.1899902343750000e+01 2.6627099990844727e+01 -3.1037099838256836e+01 1.0600000000000000e+02 -2.7087499618530273e+01 -1.1732000350952148e+01 9.3900001525878906e+01 -2.9087501525878906e+01 -1.6000000000000000e+01 9.1900001525878906e+01 -3.0592100143432617e+01 2.7194398880004883e+01 1.0599500274658203e+02 -1.8377399444580078e+01 1.7063899993896484e+01 9.3900001525878906e+01 2.5806499481201172e+01 -3.1690601348876953e+01 1.0600299835205078e+02 2.2216899871826172e+01 1.1318200111389160e+01 9.9225997924804688e+01 -9.3011999130249023e+00 2.3264499664306641e+01 9.3900001525878906e+01 -1.7346000671386719e+01 1.8108699798583984e+01 1.0600000000000000e+02 -2.2474498748779297e+01 1.1127499580383301e+01 1.0600599670410156e+02 -2.1236499786376953e+01 1.3425899505615234e+01 9.3900100708007812e+01 2.4200401306152344e+00 2.4885499954223633e+01 9.8757499694824219e+01 7.1863203048706055e+00 2.8196201324462891e+01 9.3900001525878906e+01 -2.5269300460815430e+01 3.2169597625732422e+01 9.9915901184082031e+01 -1.1181499481201172e+01 4.1294498443603516e+01 9.3900001525878906e+01 2.3060600280761719e+01 9.4426298141479492e+00 9.9622802734375000e+01 2.3060699462890625e+01 9.4426393508911133e+00 1.0650000000000000e+02 1.9412500381469727e+01 3.6614700317382812e+01 1.0650000000000000e+02 3.7195899963378906e+01 -1.4813000679016113e+01 1.0599400329589844e+02 5.3029298782348633e+00 2.4433099746704102e+01 9.8250595092773438e+01 -8.9470300674438477e+00 2.9379999160766602e+01 9.3900001525878906e+01 6.9124999046325684e+00 2.8199300765991211e+01 9.3900001525878906e+01 -3.5226501464843750e+01 -2.0819000244140625e+01 1.0650000000000000e+02 6.3479800224304199e+00 2.7763898849487305e+01 9.3900001525878906e+01 -2.7050298690795898e+01 -8.2228807732462883e-03 9.3900001525878906e+01 2.6874900817871094e+01 -6.4549399539828300e-03 1.0650300598144531e+02 -2.8052900314331055e+01 -1.5215000152587891e+01 9.1900001525878906e+01 3.7568000793457031e+01 -1.5989100456237793e+01 1.0650000000000000e+02 2.3523601531982422e+01 9.6314802169799805e+00 1.0600000000000000e+02 2.3799200057983398e+01 7.6321897506713867e+00 1.0600000000000000e+02 -2.7087499618530273e+01 -1.4000000000000000e+01 1.0650000000000000e+02 6.9124999046325684e+00 2.7699298858642578e+01 1.0600000000000000e+02 1.9912500381469727e+01 3.6614700317382812e+01 9.9157600402832031e+01 7.5321698188781738e+00 2.3816699981689453e+01 1.0600000000000000e+02 2.6764400482177734e+01 3.6317798495292664e-01 1.0650000000000000e+02 -1.9530401229858398e+01 3.7023101806640625e+01 1.0599599456787109e+02 -2.8217500686645508e+01 -1.5851400375366211e+01 1.0600000000000000e+02 -1.8969900131225586e+01 3.8409599304199219e+01 9.5440902709960938e+01 -1.9573900222778320e+01 3.7986301422119141e+01 1.0650000000000000e+02 -3.7287498474121094e+01 -1.7666699886322021e+00 1.0600000000000000e+02 2.3060600280761719e+01 9.4426298141479492e+00 9.3900001525878906e+01 -2.0074699401855469e+01 1.5094799995422363e+01 9.9317398071289062e+01 2.7066400527954102e+01 -1.4834500312805176e+01 9.3899803161621094e+01 2.7680799484252930e+01 -1.5657700538635254e+01 1.0650499725341797e+02 -3.7295898437500000e+01 -1.5037000656127930e+01 9.2400093078613281e+01 2.0340499877929688e+01 3.6153301239013672e+01 9.1900001525878906e+01 0.0000000000000000e+00 4.4408897162204620e-16 9.1900001525878906e+01 5.3135099411010742e+00 5.3135099411010742e+00 9.1900001525878906e+01 2.8756501674652100e+00 6.9424300193786621e+00 5.1869300842285156e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 6.1474899291992188e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 4.6094802856445312e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -1.1102199806005023e-16 -4.4408897162204620e-16 -2.4500000000000000e+01 -2.8756501674652100e+00 -6.9424300193786621e+00 -2.4500000000000000e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 6.9424300193786621e+00 -2.8756501674652100e+00 1.0332200050354004e+01 6.9424300193786621e+00 -2.8756501674652100e+00 6.7281899452209473e+00 1.5133799752220511e-04 -7.5142202377319336e+00 3.3475898742675781e+01 -2.8849399089813232e+00 -6.9405999183654785e+00 5.7977900505065918e+00 -2.8732600212097168e+00 -6.9429302215576172e+00 6.0673599243164062e+01 -2.8732199668884277e+00 -6.9431900978088379e+00 7.1780097961425781e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 6.6000999450683594e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -4.5272803306579590e+00 -6.9424300193786621e+00 -2.8756501674652100e+00 8.0891599655151367e+00 -7.5144300460815430e+00 -3.1380999132579745e-08 9.1900001525878906e+01 -6.9424300193786621e+00 2.8756501674652100e+00 9.1900001525878906e+01 -5.3135099411010742e+00 5.3135099411010742e+00 5.1116802215576172e+01 -5.3135099411010742e+00 5.3135099411010742e+00 2.7307100296020508e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.1490200042724609e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 6.9424300193786621e+00 -2.8756501674652100e+00 9.1900001525878906e+01 7.5144300460815430e+00 0.0000000000000000e+00 -2.4500000000000000e+01 -5.3135099411010742e+00 5.3135099411010742e+00 -2.4500000000000000e+01 -2.8756501674652100e+00 6.9424300193786621e+00 4.4179397583007812e+01 5.3135099411010742e+00 -5.3135099411010742e+00 1.8716899871826172e+01 2.8756501674652100e+00 -6.9424300193786621e+00 1.0601899147033691e+01 5.3135099411010742e+00 -5.3135099411010742e+00 5.8955596923828125e+01 2.8756501674652100e+00 -6.9424300193786621e+00 7.4340003967285156e+01 2.8756501674652100e+00 -6.9424300193786621e+00 3.8972499847412109e+01 -2.1143201738595963e-03 -7.5146799087524414e+00 6.5296798706054688e+01 2.8756501674652100e+00 6.9424300193786621e+00 3.5107299804687500e+01 5.3135099411010742e+00 5.3135099411010742e+00 -2.4500000000000000e+01 2.8756501674652100e+00 6.9424300193786621e+00 6.8251299858093262e+00 2.8756501674652100e+00 6.9424300193786621e+00 -2.4500000000000000e+01 5.3135099411010742e+00 5.3135099411010742e+00 2.5188499450683594e+01 -6.9424300193786621e+00 2.8756501674652100e+00 6.9428199768066406e+01 -7.5144300460815430e+00 -1.2178499098070006e-08 9.1900001525878906e+01 2.8756501674652100e+00 -6.9424300193786621e+00 9.1900001525878906e+01 5.3135099411010742e+00 -5.3135099411010742e+00 5.7016399383544922e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 4.4472702026367188e+01 7.5144300460815430e+00 2.0245298770760201e-08 2.0877799987792969e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 -7.5144300460815430e+00 9.9920103979999611e-16 9.1900001525878906e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -2.4500000000000000e+01 7.5144300460815430e+00 -1.6653300900147617e-15 1.4758699417114258e+01 6.9424300193786621e+00 2.8756501674652100e+00 3.5491500854492188e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.4586601257324219e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 5.9062400817871094e+01 -2.8756501674652100e+00 6.9424300193786621e+00 9.1900001525878906e+01 -2.8756501674652100e+00 6.9424300193786621e+00 9.1900001525878906e+01 5.5511103585654544e-16 7.5144300460815430e+00 -2.4500000000000000e+01 -6.9424300193786621e+00 2.8756501674652100e+00 9.1900001525878906e+01 -3.3306698679688577e-16 -7.5144300460815430e+00 2.9183700680732727e-01 2.8756501674652100e+00 -6.9424300193786621e+00 -1.4862899780273438e+01 2.8756501674652100e+00 -6.9424300193786621e+00 8.1460403442382812e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 8.3242797851562500e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 7.6513404846191406e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.1208099365234375e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.7816101074218750e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -1.4432900378918219e-15 -7.5144300460815430e+00 9.1900001525878906e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 8.7725997924804688e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 7.9441596984863281e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 4.0302101135253906e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 9.1900001525878906e+01 6.9424300193786621e+00 2.8756501674652100e+00 9.1105003356933594e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3711900711059570e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3540299415588379e+01 -6.9424300193786621e+00 -2.8756501674652100e+00 -2.4500000000000000e+01 1.4432900378918219e-15 7.5144300460815430e+00 -2.4500000000000000e+01 6.9424300193786621e+00 2.8756501674652100e+00 1.7158500671386719e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 1.3821800231933594e+01 -2.8756501674652100e+00 6.9424300193786621e+00 6.1954299926757812e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 3.8361301422119141e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.1056200414896011e-01 -5.3135099411010742e+00 -5.3135099411010742e+00 -4.1209101676940918e+00 -5.3135099411010742e+00 -5.3135099411010742e+00 8.3293998718261719e+01 -2.8750801086425781e+00 -6.9430499076843262e+00 2.3951499938964844e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -1.1386799812316895e+01 -5.3135099411010742e+00 -5.3135099411010742e+00 -2.4500000000000000e+01 -7.5144300460815430e+00 7.7715601135849117e-16 -2.4500000000000000e+01 2.8756501674652100e+00 -6.9424300193786621e+00 1.5545199394226074e+01 -2.9718497884800854e-08 7.5144300460815430e+00 9.1900001525878906e+01 -2.8756501674652100e+00 -6.9424300193786621e+00 3.9963302612304688e+01 2.8756501674652100e+00 -6.9424300193786621e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2979 -> 30 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408098280429840e+01 -2.3180099204182625e+01 -3.4330401569604874e+01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01) (float-vector 9.2390097677707672e+01 -3.3803198486566544e+01 2.3915499448776245e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 9.2391498386859894e+01 -3.7257999181747437e+01 -1.8208600580692291e+01) (float-vector 9.2414796352386475e+01 -4.1516300290822983e+01 -5.2713998593389988e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector 9.3900002539157867e+01 2.5806499645113945e+01 -3.1690601259469986e+01) (float-vector 9.2408299446105957e+01 3.6649398505687714e+01 -1.9086899235844612e+01) (float-vector -2.4499999359250069e+01 7.5144302099943161e+00 -1.6653300536188148e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4499999359250069e+01 2.8756500687450171e+00 -6.9424300454556942e+00) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 -5.3135100752115250e+00) (float-vector 9.2419296503067017e+01 -8.8318502530455589e+00 -4.0474899113178253e+01) (float-vector 9.2399999499320984e+01 4.4464501552283764e+00 -4.1099399328231812e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 9.2399902641773224e+01 1.8794899806380272e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2399902641773224e+01 -8.7499996880069375e-02 4.2800001800060272e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 9.2399902641773224e+01 -1.8969900906085968e+01 3.8409598171710968e+01) (float-vector -2.4499999359250069e+01 -5.3135100752115250e+00 5.3135100752115250e+00) (float-vector -2.4499999359250069e+01 5.3135100752115250e+00 5.3135100752115250e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 1.0650499910116196e+02 -3.7295900285243988e+01 -1.5037000179290771e+01) (float-vector 1.0599999874830246e+02 -3.7687499076128006e+01 -1.4666699571534991e+00) (float-vector 1.0649999976158142e+02 -1.9090600311756134e+01 3.7729501724243164e+01) (float-vector 1.0599999874830246e+02 -1.1087499558925629e+01 4.1289199143648148e+01) (float-vector 1.0599999874830246e+02 1.1451699770987034e+01 4.1215099394321442e+01) (float-vector 1.0601200163364410e+02 1.9745200872421265e+01 3.7513498216867447e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0649999976158142e+02 3.7195898592472076e+01 -1.4813000336289406e+01) (float-vector 1.0599999874830246e+02 3.7512499839067459e+01 -1.4666699571534991e+00) (float-vector 9.2392496764659882e+01 3.7046499550342560e+01 1.8352899700403214e+01) (float-vector 9.2389598488807678e+01 4.1256599128246307e+01 -9.2630402650684118e-01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_forearm_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_l_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.6910000000000011e+01 1.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 856 1 0 953 856 0 477 0 484 0 34 484 2 34 0 953 0 477 2 147 33 34 2 33 2 1 147 33 30 34 34 32 484 34 30 32 477 484 32 30 31 32 476 477 32 476 32 486 486 32 31 485 476 486 718 850 476 485 718 476 476 850 477 902 485 486 902 718 485 902 486 717 31 844 486 486 844 717 902 717 718 717 646 718 717 778 646 717 844 778 778 844 647 31 290 844 844 290 647 778 647 646 646 647 620 4 718 646 620 4 646 620 647 36 290 36 647 290 37 36 31 37 290 35 36 37 620 36 396 36 35 396 4 620 396 395 4 396 35 481 396 396 481 546 546 395 396 35 37 481 37 472 481 37 31 470 472 37 470 546 481 545 481 472 923 481 923 545 545 483 546 597 395 546 546 483 597 545 923 483 923 472 483 469 472 470 483 472 469 478 483 469 483 478 597 597 478 543 543 395 597 468 478 469 478 468 479 543 478 479 468 469 470 468 38 466 468 466 479 468 470 38 479 466 480 479 480 543 466 38 467 466 467 471 466 471 480 543 480 688 689 480 471 688 480 689 471 467 734 689 471 690 690 471 734 38 22 467 467 22 734 406 733 734 21 734 22 406 734 21 733 690 734 688 689 690 733 688 690 543 688 408 733 408 688 406 408 733 406 407 408 407 406 21 21 22 23 21 23 407 38 491 22 22 491 23 23 748 407 23 491 489 748 23 489 408 407 832 832 407 791 748 791 407 748 489 853 748 853 791 488 489 490 488 853 489 489 491 490 853 488 791 791 792 148 148 832 791 791 488 792 792 488 490 490 491 896 740 490 896 740 792 490 148 792 740 149 148 740 684 740 896 684 149 740 465 464 896 465 896 491 684 896 464 683 684 464 684 69 149 70 684 683 69 684 70 463 464 465 464 463 683 470 463 39 31 683 463 463 465 39 470 31 463 470 39 38 38 39 40 465 40 39 40 491 38 491 40 465 30 487 31 487 458 31 31 458 683 487 680 458 19 680 487 19 487 473 473 487 30 458 459 216 216 593 458 680 459 458 458 593 683 64 459 680 64 680 19 459 499 216 64 493 459 493 499 459 216 217 218 216 218 593 216 499 217 593 316 683 593 218 316 259 218 260 316 218 259 218 68 70 260 218 70 218 217 68 316 259 683 259 260 683 260 70 683 68 69 70 68 217 272 68 272 69 272 217 232 777 686 217 217 686 232 497 217 499 217 497 777 231 183 232 232 686 231 183 272 232 682 686 777 682 231 686 456 777 497 682 777 456 681 682 456 682 681 231 231 681 183 456 367 681 849 681 367 183 681 849 456 361 457 456 457 367 456 497 361 361 362 191 497 362 361 457 361 191 367 457 191 365 366 367 367 191 365 818 849 367 745 367 366 818 367 528 367 745 528 528 745 529 366 529 745 528 529 530 528 530 963 963 818 528 530 529 366 963 530 859 859 530 366 859 366 860 366 365 860 859 860 381 963 859 381 818 963 381 381 365 190 818 381 190 860 365 381 190 191 192 192 631 190 631 892 190 190 892 818 365 191 190 362 138 191 192 191 178 178 191 138 192 178 736 736 631 192 892 631 736 178 735 736 735 171 736 171 892 736 169 170 171 171 735 169 170 892 171 297 169 298 169 297 752 170 169 752 169 735 829 169 829 298 170 752 818 170 818 892 181 183 818 818 183 849 818 752 181 181 182 183 181 752 182 267 183 182 272 183 267 182 269 267 182 752 269 269 270 267 270 269 879 269 752 879 271 268 270 268 267 270 271 270 301 270 879 301 301 879 373 373 879 752 752 122 373 752 297 122 120 121 122 300 373 122 120 122 297 122 121 300 297 298 120 120 298 732 972 120 732 120 972 121 300 121 49 121 972 47 121 47 49 919 47 972 732 735 972 972 735 919 732 298 829 829 735 732 178 180 735 735 716 919 180 715 735 715 716 735 178 179 180 138 137 178 137 913 178 913 179 178 179 715 180 715 433 716 284 433 715 179 284 715 179 283 284 283 996 284 996 433 284 179 433 283 283 433 996 538 433 179 538 179 913 913 795 914 913 137 795 538 913 914 537 434 538 538 956 537 433 538 434 914 956 538 914 795 797 956 914 797 795 796 797 795 340 796 795 137 340 796 387 797 956 797 387 537 956 387 387 388 250 537 387 311 387 250 311 410 388 387 410 387 796 340 411 796 411 410 796 388 410 411 388 411 342 340 342 411 340 341 342 342 341 898 388 342 802 802 342 898 898 341 769 994 898 769 898 994 802 388 802 803 803 802 651 802 994 651 994 426 425 994 425 651 426 994 769 768 426 769 769 341 194 194 768 769 424 425 426 424 426 867 426 768 867 651 425 652 652 425 494 425 424 494 424 820 494 424 867 820 495 867 961 867 768 961 820 867 495 494 820 495 494 495 496 495 554 496 495 961 554 961 934 549 934 961 768 961 549 554 496 554 275 554 276 275 549 999 554 554 999 276 494 496 932 932 496 275 275 276 277 932 275 883 275 277 883 277 276 326 935 326 276 935 276 999 999 549 935 326 935 327 935 551 327 549 551 935 326 327 328 572 277 326 326 328 572 650 328 327 551 648 327 648 650 327 549 550 551 551 766 648 550 766 551 648 649 650 767 649 648 648 766 767 765 766 550 765 767 766 550 934 765 934 550 549 765 934 193 765 930 767 930 765 193 930 931 767 936 649 767 931 936 767 1001 931 930 1001 930 193 193 194 195 934 194 193 195 1001 193 768 194 934 194 341 195 341 492 195 492 1000 195 1000 1001 195 1000 776 1001 776 931 1001 775 776 1000 492 775 1000 340 775 492 492 341 340 775 504 776 775 137 504 340 137 775 504 927 776 931 776 927 503 504 358 504 503 927 504 137 358 136 137 138 136 358 137 358 359 360 358 136 742 358 360 503 359 358 742 138 116 136 116 117 136 136 117 742 254 138 413 362 413 138 138 254 116 116 28 117 116 254 29 116 29 28 117 28 720 117 720 955 742 117 955 27 28 29 28 114 720 28 27 114 113 114 115 114 595 115 114 27 595 720 114 113 113 115 414 113 414 724 724 888 113 113 888 720 595 414 115 737 595 364 595 642 414 595 737 642 364 595 27 414 642 643 414 643 724 724 980 888 643 988 724 724 988 980 84 887 980 84 980 377 980 887 888 377 980 988 988 565 377 643 565 988 376 84 377 376 377 565 564 565 566 565 212 566 643 212 565 565 564 376 376 320 322 564 320 376 880 84 376 322 880 376 320 564 321 321 564 817 564 566 817 566 629 817 629 566 212 629 624 817 817 624 321 320 321 322 624 53 321 869 321 53 321 869 322 880 322 357 357 322 869 868 869 870 868 357 869 53 870 869 868 976 355 976 868 870 868 355 357 53 55 870 242 870 55 242 976 870 976 838 355 976 242 838 355 356 357 838 452 355 355 452 356 452 838 154 242 619 838 155 838 619 838 155 154 241 242 55 619 242 241 241 243 619 54 835 241 835 404 241 241 404 243 241 55 54 53 54 55 118 54 119 119 54 53 118 835 54 612 835 118 612 404 835 118 119 997 118 997 986 612 118 986 119 53 624 119 624 630 997 119 630 174 997 959 997 630 959 986 997 174 612 986 173 173 986 174 172 173 174 174 289 247 172 174 247 289 174 959 288 111 289 111 247 289 288 289 959 111 246 247 247 246 172 110 111 112 111 288 112 246 111 110 959 808 288 112 288 846 808 846 288 307 112 569 107 110 112 307 107 112 569 112 846 109 246 110 107 109 110 107 108 109 306 107 307 786 108 107 107 306 786 92 306 307 569 92 307 809 569 846 569 809 92 809 846 808 808 783 809 809 813 824 809 824 92 783 813 809 783 18 813 813 20 824 18 20 813 75 824 20 824 75 92 18 19 20 74 75 20 482 74 20 20 19 473 20 473 482 74 739 75 739 92 75 482 596 74 596 739 74 482 473 475 948 596 482 948 482 475 473 474 475 474 473 30 695 475 474 948 475 695 948 695 596 596 695 336 336 695 219 695 474 220 219 695 220 474 30 922 220 474 922 922 30 544 544 30 33 220 922 146 146 922 544 219 220 146 145 336 219 145 219 146 336 1 596 145 1 336 145 146 147 147 1 145 147 146 544 33 147 544 3 1 4 1 516 764 525 516 1 764 93 1 1 856 4 525 1 841 596 1 93 841 1 3 596 93 739 92 93 94 94 93 764 93 92 739 516 94 764 94 516 291 94 291 92 415 92 291 306 92 415 293 306 415 291 293 415 293 435 306 786 306 435 291 292 293 292 435 293 374 375 292 5 374 292 435 292 375 5 292 291 5 640 374 374 438 375 438 374 640 437 435 375 438 437 375 436 437 438 346 438 508 727 436 438 727 438 346 508 438 640 436 227 226 727 330 436 436 226 437 436 330 227 346 330 727 346 347 60 346 60 330 346 508 347 508 640 641 508 641 347 746 747 641 641 640 746 861 347 641 747 906 641 906 861 641 746 843 747 843 906 747 843 905 906 907 861 906 906 905 907 907 905 908 908 702 907 713 861 907 713 907 714 907 702 714 908 954 702 905 671 908 908 671 954 702 703 704 702 704 714 954 703 702 982 954 671 982 703 954 598 671 672 672 671 905 598 982 671 598 80 599 675 598 599 80 598 672 675 982 598 672 72 80 905 72 672 991 72 905 843 991 905 71 72 73 73 72 964 72 71 80 964 72 991 964 991 843 238 842 843 842 964 843 238 843 746 73 964 82 964 842 82 79 71 73 73 82 81 79 73 81 79 80 71 79 599 80 599 79 738 81 738 79 901 675 599 599 738 901 901 738 400 901 982 675 982 901 400 703 982 399 399 982 400 399 43 703 703 43 704 399 400 210 399 210 441 399 441 43 41 42 43 441 41 43 704 43 14 14 43 42 714 704 14 12 13 14 42 12 14 13 714 14 666 713 714 13 666 714 665 666 13 52 773 13 12 52 13 13 773 665 368 52 12 12 42 368 50 51 52 51 335 52 368 50 52 335 773 52 899 666 773 773 666 665 773 335 899 899 335 91 741 666 899 741 899 90 899 91 90 90 91 46 91 335 527 46 91 527 223 501 90 741 90 501 46 223 90 713 741 501 713 666 741 713 501 861 501 502 15 501 942 502 501 15 861 223 942 501 861 15 347 15 16 17 502 939 15 939 16 15 347 15 17 939 502 942 939 942 513 223 943 942 943 513 942 513 16 939 513 331 16 513 248 331 943 248 513 249 943 223 249 248 943 45 222 223 222 249 223 45 223 46 248 249 224 224 249 222 45 224 222 44 45 46 45 248 224 44 248 45 526 46 527 526 44 46 335 44 526 44 712 248 44 385 712 385 44 335 526 527 335 335 384 385 51 839 335 335 839 384 712 385 710 385 384 987 710 385 987 710 711 712 710 987 744 710 744 711 811 810 987 384 811 987 987 810 744 744 265 711 744 144 265 744 810 821 744 821 144 810 811 812 812 821 810 811 993 812 811 628 993 384 628 811 993 627 812 993 628 627 626 627 628 836 837 628 626 628 837 384 836 628 836 384 839 951 837 836 836 839 951 951 839 583 839 51 353 583 839 353 837 951 583 837 305 304 583 950 837 626 837 304 950 305 837 25 950 583 305 950 25 24 25 26 26 25 583 24 305 25 26 789 24 789 305 24 790 789 26 790 26 582 582 26 583 165 789 790 789 165 430 789 430 305 163 165 790 790 804 163 804 790 582 581 582 583 582 581 721 804 582 721 379 378 581 581 805 721 581 378 805 379 581 583 379 583 616 353 616 583 353 615 616 150 379 616 616 615 150 353 50 354 353 51 50 615 353 354 354 50 368 706 615 354 706 354 368 368 42 369 706 368 826 826 368 369 705 615 706 826 705 706 826 832 705 705 832 148 615 705 148 408 832 826 543 408 395 4 395 408 408 826 806 408 806 4 856 718 4 4 806 3 850 856 953 718 856 850 850 953 477 806 78 3 605 841 3 78 605 3 841 605 523 523 525 841 523 524 525 523 918 971 990 918 523 605 990 523 523 971 524 525 524 516 291 516 517 516 524 517 8 291 9 291 8 6 5 291 6 291 517 9 517 524 693 693 9 517 8 9 10 10 9 693 8 11 6 8 10 11 5 6 7 6 11 7 746 640 5 746 5 239 5 7 239 240 239 7 67 7 11 67 240 7 11 890 67 10 890 11 65 66 67 67 66 970 890 65 67 67 970 240 238 239 240 240 970 238 239 238 746 238 970 842 970 66 83 83 842 970 842 83 82 81 82 83 900 81 83 236 83 66 236 900 83 236 237 81 237 738 81 900 236 81 237 236 66 875 738 237 875 237 66 886 738 884 738 610 884 886 400 738 610 738 875 884 885 886 885 400 886 884 209 885 210 884 610 210 209 884 885 208 400 885 209 208 400 208 210 208 209 210 847 441 210 623 847 210 610 623 210 187 847 188 698 847 623 188 847 698 187 441 847 187 41 441 187 188 189 42 187 369 42 41 187 369 187 189 825 826 189 826 369 189 189 188 825 826 825 806 825 188 806 188 944 806 806 944 78 188 697 944 944 607 992 944 992 78 697 607 944 76 77 78 992 76 78 78 77 605 607 76 992 606 607 608 76 607 606 607 697 608 418 76 606 606 416 418 606 608 416 697 416 608 416 417 418 416 696 417 697 696 416 417 609 418 623 417 696 623 609 417 696 697 698 698 623 696 610 609 623 151 609 610 609 151 418 610 875 962 151 610 962 874 875 655 962 875 874 653 655 875 653 875 66 962 874 655 151 962 655 653 654 655 655 654 151 65 653 66 654 653 398 398 653 65 654 398 918 654 723 152 918 723 654 151 654 152 918 398 971 918 990 723 722 723 670 723 722 152 990 670 723 151 152 153 152 722 153 418 151 153 153 722 670 673 153 670 673 418 153 605 604 670 670 604 673 990 605 670 673 604 76 418 673 76 77 604 605 76 604 77 971 398 524 65 397 398 524 398 693 397 10 398 398 10 693 397 65 890 397 890 10 188 698 697 148 149 150 615 148 150 989 150 149 149 69 989 130 150 989 995 833 150 833 379 150 130 995 150 130 989 69 130 131 132 132 380 130 130 380 995 131 130 69 833 995 380 833 380 379 378 379 380 132 533 380 533 378 380 132 429 533 131 427 132 427 429 132 533 534 535 534 533 429 533 535 805 533 805 378 427 428 429 429 428 534 761 762 427 427 762 428 761 427 131 428 603 534 985 603 428 428 762 985 985 762 622 622 762 761 985 622 973 985 973 603 48 622 49 622 590 317 973 622 317 761 49 622 48 590 622 319 587 973 319 973 317 587 603 973 317 318 319 402 317 591 318 317 402 317 590 591 590 542 591 48 542 590 699 402 591 591 893 699 542 893 591 401 318 402 402 699 845 401 402 845 318 401 319 575 401 573 891 401 845 573 401 891 319 401 575 573 574 575 575 574 586 319 575 586 574 573 876 876 573 891 891 845 161 897 876 891 161 897 891 574 876 877 897 799 876 877 876 894 876 799 894 338 574 877 338 586 574 338 877 339 877 894 339 894 799 895 894 895 371 894 371 678 339 894 678 337 338 339 339 677 337 339 678 677 586 338 601 338 337 601 512 511 337 324 337 677 512 337 324 601 337 511 676 677 678 677 676 325 324 677 325 323 324 325 512 324 594 324 323 594 325 676 323 938 323 676 938 676 678 105 594 323 323 106 105 938 106 323 512 594 105 104 105 106 409 105 104 512 105 409 370 104 106 370 106 938 938 678 370 370 678 371 370 371 372 104 370 351 351 370 372 372 371 957 351 372 957 371 782 585 895 952 371 371 952 782 371 585 957 957 958 657 957 585 958 351 957 657 584 446 585 584 585 782 585 446 958 799 584 782 952 799 782 895 799 952 447 799 800 799 460 462 500 799 897 799 462 800 799 447 584 460 799 500 446 584 447 445 446 447 958 446 445 445 532 531 445 447 915 445 915 532 958 445 531 134 531 532 531 657 958 134 657 531 133 134 135 352 134 133 135 134 865 865 134 532 352 657 134 351 657 352 350 351 352 350 352 133 350 133 983 133 135 983 135 865 780 780 983 135 865 532 866 865 866 781 781 780 865 779 780 781 793 780 794 793 983 780 779 794 780 350 983 793 793 848 350 793 345 848 793 343 345 794 343 793 779 580 794 580 343 794 580 779 685 781 685 779 578 579 580 578 580 600 685 600 580 579 343 580 343 344 345 579 547 343 547 344 343 344 848 345 344 409 104 450 449 344 344 200 199 344 199 848 344 104 200 409 344 294 449 294 344 547 450 344 200 104 201 201 104 351 199 200 201 199 201 848 848 201 350 201 351 350 449 450 451 450 547 548 156 450 917 451 450 156 917 450 548 548 547 579 518 548 56 548 579 56 917 548 518 452 154 917 58 917 518 452 917 58 154 156 917 518 56 519 518 519 58 56 57 58 58 57 731 519 56 58 731 452 58 56 578 57 56 579 578 731 57 830 749 831 57 578 749 57 57 831 830 555 452 731 555 731 830 555 830 831 831 726 815 831 725 726 555 831 815 725 831 749 555 556 452 555 814 556 555 815 814 175 556 658 556 175 452 975 658 556 814 975 556 452 175 356 175 176 177 356 175 177 175 658 176 176 658 656 975 656 658 514 975 814 558 656 975 514 558 975 86 656 123 656 85 176 85 656 86 558 123 656 177 176 880 880 176 85 84 85 86 880 85 84 357 947 880 947 177 880 356 177 357 357 177 947 887 84 86 887 728 888 887 86 728 728 729 720 729 728 431 86 431 728 728 720 888 729 390 955 720 729 955 621 390 729 621 729 431 86 63 431 621 431 63 86 123 63 61 62 63 63 389 621 63 123 61 389 63 62 389 390 621 389 386 390 62 785 389 785 386 389 360 359 386 770 360 386 359 390 386 770 386 785 62 771 785 785 771 770 660 770 771 770 503 360 660 503 770 771 570 709 771 62 570 709 660 771 650 660 709 570 650 709 659 503 660 649 659 660 650 649 660 927 503 659 936 927 659 649 936 659 936 931 927 650 570 328 572 328 570 570 571 572 571 277 572 570 644 571 571 881 277 644 61 571 571 61 969 571 969 881 277 881 883 881 882 883 279 881 969 881 279 929 882 881 929 61 754 969 279 969 754 61 753 754 753 280 754 279 754 280 753 514 419 280 753 540 61 558 753 558 514 753 540 753 419 278 279 280 540 278 280 540 419 925 540 925 576 577 278 540 576 577 540 278 577 279 279 577 974 279 974 929 933 928 974 974 928 929 974 577 933 928 882 929 634 928 632 932 928 634 632 928 933 882 928 932 882 932 883 634 494 932 632 633 634 633 494 634 632 730 633 912 632 933 912 730 632 633 281 652 633 652 494 730 281 633 707 708 730 708 282 730 281 730 282 912 707 730 567 912 933 567 707 912 707 204 708 204 707 567 203 708 204 439 708 203 439 282 708 281 282 251 439 440 282 251 282 440 439 203 635 439 635 440 202 203 204 635 203 636 203 202 636 635 636 637 252 635 637 252 440 635 251 440 252 250 251 252 872 281 251 251 250 872 872 250 862 872 862 281 949 803 250 388 949 250 803 862 250 252 311 250 803 651 862 281 862 652 862 651 652 949 388 803 311 252 312 312 537 311 432 537 312 312 645 432 541 645 312 312 252 541 432 434 537 432 433 434 454 432 645 432 878 433 432 454 878 645 541 455 455 454 645 453 454 455 878 454 852 852 454 453 716 878 852 878 716 433 851 852 453 919 852 851 716 852 919 48 453 455 453 48 851 455 541 542 542 48 455 47 48 49 851 48 47 851 47 919 49 299 300 761 299 49 552 299 816 300 299 552 816 299 761 300 552 553 553 373 300 816 855 552 855 553 552 855 816 274 131 274 816 816 761 131 553 855 274 553 274 373 69 274 131 373 274 69 272 266 69 266 373 69 272 267 273 273 266 272 266 267 268 273 267 266 266 268 373 373 268 271 271 301 373 541 893 542 541 252 864 541 864 893 864 252 893 252 699 893 162 252 637 827 252 162 252 827 845 252 845 699 160 161 162 160 162 637 827 162 161 636 160 637 460 500 160 160 500 161 636 460 160 845 827 161 161 500 897 460 461 462 636 461 460 636 202 461 461 663 662 461 998 462 461 202 663 662 998 461 979 800 462 998 979 462 998 662 979 661 662 663 979 662 871 662 310 871 310 662 661 871 915 979 979 915 447 447 800 979 871 310 98 539 915 871 871 98 539 532 915 539 100 539 98 100 99 539 866 539 442 532 539 866 539 99 442 98 99 100 442 99 443 99 725 443 99 98 725 442 443 444 685 442 444 781 442 685 866 442 781 443 749 444 443 725 749 725 98 726 310 726 98 815 726 383 383 726 310 308 309 310 310 309 383 308 310 661 382 383 309 382 815 383 515 814 815 420 515 815 420 815 382 382 664 420 309 308 382 308 664 382 661 664 308 663 664 661 421 664 694 664 663 694 420 664 421 419 420 421 515 420 419 514 515 419 514 814 515 925 419 421 694 921 421 921 925 421 924 576 925 925 921 924 332 924 921 694 941 921 941 332 921 334 576 924 334 924 332 576 334 577 332 333 334 568 577 334 334 333 568 772 926 332 772 332 941 926 333 332 694 772 941 694 204 772 772 204 926 926 204 333 333 567 568 333 204 567 937 568 567 937 577 568 937 933 577 937 567 933 694 202 204 694 663 202 749 600 444 749 578 600 685 444 600 558 61 123 62 61 644 62 909 570 644 909 62 570 909 644 390 359 742 742 955 390 154 155 156 451 156 155 155 618 451 618 155 619 449 451 294 294 451 828 618 828 451 295 618 619 828 618 295 245 619 243 295 619 245 294 295 296 295 245 296 828 295 294 405 409 294 405 294 296 296 403 405 244 296 245 296 244 403 243 244 245 243 404 403 243 403 244 403 404 405 405 404 409 409 404 612 611 612 613 611 409 612 613 612 173 261 409 611 262 611 613 261 611 262 639 613 173 639 262 613 422 173 423 172 423 173 639 173 422 422 638 639 638 262 639 261 262 263 263 262 638 984 409 261 984 261 263 233 920 263 263 834 233 920 984 263 638 834 263 920 409 984 920 589 409 589 512 409 946 589 920 946 920 233 946 233 235 946 235 589 588 510 589 589 592 588 589 510 512 592 589 235 510 511 512 602 511 510 588 602 510 592 535 588 602 588 534 534 588 535 592 234 535 234 592 235 233 234 235 617 234 233 234 804 535 617 804 234 535 804 805 163 804 617 805 804 721 163 164 165 163 617 759 164 163 759 164 314 165 314 164 315 315 164 674 674 164 759 165 314 430 313 314 315 509 314 313 509 430 314 313 315 784 674 945 315 784 315 945 758 945 674 758 674 759 916 945 758 916 784 945 285 784 916 562 313 784 784 285 562 561 313 562 509 313 561 561 562 563 563 562 285 285 286 287 916 286 285 788 285 287 788 563 285 916 758 286 286 873 823 758 873 286 286 823 287 788 287 394 287 823 394 822 394 823 822 823 873 422 873 758 172 873 423 822 873 172 423 873 422 822 172 246 109 822 246 822 109 394 109 108 801 801 394 109 108 394 801 108 393 394 700 701 108 87 89 108 701 87 108 786 700 108 89 393 108 89 788 393 393 788 394 87 88 89 88 788 89 787 788 129 787 563 788 129 788 88 87 129 88 127 128 129 127 129 87 819 129 128 129 819 787 561 563 787 561 787 819 614 303 819 303 509 819 911 819 128 614 819 911 819 509 561 302 303 304 302 430 303 303 430 509 614 304 303 304 305 302 305 430 302 614 854 304 854 812 304 304 812 626 614 142 854 812 854 142 812 142 821 626 812 627 142 143 144 614 143 142 821 142 144 144 264 265 264 144 967 143 967 144 265 264 141 139 264 967 264 139 141 265 141 711 774 711 141 774 712 711 712 774 965 141 966 774 965 774 966 712 965 248 248 965 557 965 966 557 966 559 557 141 560 966 966 560 559 559 560 140 559 140 391 557 559 391 141 140 560 139 140 141 140 139 96 391 140 95 140 96 95 391 392 205 391 95 392 205 557 391 95 96 97 392 95 960 960 95 97 96 139 968 97 96 968 968 139 967 968 967 143 97 968 798 968 143 978 978 798 968 97 798 412 960 97 412 412 807 960 807 392 960 253 412 128 798 128 412 412 253 807 798 978 128 911 128 978 143 911 978 143 614 911 127 253 128 253 127 87 253 87 807 87 701 807 392 807 349 701 349 807 700 349 701 348 206 349 392 349 206 700 348 349 392 206 205 205 206 207 348 700 206 206 700 207 786 207 700 205 207 940 435 207 786 435 940 207 205 940 557 940 763 557 437 940 435 940 437 763 248 557 448 557 763 448 226 763 437 448 763 719 226 719 763 248 448 331 331 448 329 329 448 719 329 719 226 225 226 227 329 226 225 329 330 331 225 330 329 330 16 331 225 227 330 16 330 60 59 16 60 17 16 59 59 60 347 347 17 59 638 422 760 422 758 760 638 760 757 638 757 834 760 758 757 757 758 759 834 757 617 617 757 759 233 834 617 603 602 534 601 602 603 586 603 587 586 601 603 602 601 511 319 586 587 19 18 64 18 667 669 18 507 667 783 507 18 101 18 669 18 101 64 101 103 64 103 493 64 101 102 103 102 101 669 103 213 221 102 213 103 221 493 103 213 102 215 669 215 102 230 215 669 213 215 230 229 214 230 214 213 230 669 229 230 229 625 228 229 669 625 214 229 228 213 214 197 197 214 198 198 214 228 198 228 166 228 625 166 166 167 168 166 840 167 166 168 198 840 166 625 168 167 157 840 158 167 167 158 157 168 157 863 198 168 981 981 168 863 157 158 159 27 157 159 863 157 27 158 625 159 840 625 158 159 625 364 364 27 159 27 29 863 863 29 692 981 863 692 692 679 981 981 679 198 691 679 692 29 691 692 29 254 691 254 258 691 521 679 691 258 521 691 257 258 256 257 521 258 256 258 254 687 257 256 687 521 257 520 521 522 185 679 521 185 521 520 522 521 687 255 522 687 687 256 255 254 255 256 185 520 255 520 522 255 255 186 185 255 254 186 184 185 186 185 184 679 857 679 184 186 857 184 679 857 198 857 858 198 858 857 536 536 857 186 196 197 198 196 198 858 858 536 196 213 197 196 213 196 536 756 904 536 213 536 221 756 536 186 904 221 536 755 756 743 743 756 186 903 904 756 903 756 755 904 493 221 904 903 977 904 977 493 903 755 977 755 743 910 755 910 977 493 977 910 493 910 497 493 497 499 910 743 497 413 497 498 498 497 743 497 413 362 413 498 254 254 498 889 889 498 743 889 186 254 889 743 186 363 125 364 125 737 364 625 363 364 737 643 642 125 643 737 643 125 212 125 211 212 211 629 212 750 211 751 211 750 629 505 211 125 211 505 751 624 629 630 629 750 630 959 630 750 783 750 751 750 783 808 750 808 959 507 783 751 751 505 507 505 506 507 667 507 506 506 668 667 506 126 668 506 124 126 506 505 124 667 668 669 363 669 668 126 363 668 124 125 126 126 125 363 505 125 124 625 669 363))
                   (list :vertices (let ((mat (make-matrix 1002 3))) (fvector-replace (array-entity mat) #f(-1.2468999862670898e+01 -3.9723799228668213e+00 6.4992804527282715e+00 -1.2259700775146484e+01 -4.8232102394104004e+00 9.5915098190307617e+00 -1.2469099998474121e+01 -3.9723799228668213e+00 7.7372398376464844e+00 -1.1248499870300293e+01 -5.1348104476928711e+00 6.3296699523925781e+00 -1.2259700775146484e+01 -4.8232197761535645e+00 1.8234599828720093e+00 4.5199198722839355e+00 -9.9936399459838867e+00 1.2656300544738770e+01 1.0525900125503540e+00 -8.9252195358276367e+00 1.2656300544738770e+01 1.6549700498580933e+00 -9.1108398437500000e+00 1.2403100013732910e+01 -4.0988898277282715e+00 -7.3378596305847168e+00 1.2656300544738770e+01 -7.1897602081298828e+00 -6.3854498863220215e+00 1.2656300544738770e+01 -6.1697001457214355e+00 -6.6997704505920410e+00 1.2403100013732910e+01 -1.7609100341796875e+00 -8.0582799911499023e+00 1.2403100013732910e+01 -1.0249300003051758e+00 -8.2850599288940430e+00 -1.2656300544738770e+01 4.5199198722839355e+00 -9.9936399459838867e+00 -1.2656300544738770e+01 1.6549700498580933e+00 -9.1108398437500000e+00 -1.2403100013732910e+01 6.4850397109985352e+00 -7.0131702423095703e+00 1.2792600393295288e+00 6.9717001914978027e+00 -6.3005099296569824e+00 6.4077000617980957e+00 6.5039496421813965e+00 -6.9507203102111816e+00 6.4160499572753906e+00 -1.3997900009155273e+01 -3.1436100006103516e+00 1.7327999114990234e+01 -1.4515100479125977e+01 -4.0282702445983887e+00 1.6200000762939453e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.4174999237060547e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -9.0204601287841797e+00 -1.2505499839782715e+01 -3.8669600486755371e+00 -8.9239597320556641e+00 -1.2484200477600098e+01 -3.9098598957061768e+00 -9.6969003677368164e+00 2.4653301239013672e+00 1.7317001342773438e+01 -1.3170300483703613e+01 6.9176201820373535e+00 1.2376099586486816e+01 -1.3162500381469727e+01 -2.2360601425170898e+00 2.0811300277709961e+01 -1.3162500381469727e+01 -2.4159500122070312e+01 -6.2754898071289062e+00 2.2972999572753906e+01 -3.2170398712158203e+01 -8.2487401962280273e+00 2.5059400558471680e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 2.0248399734497070e+01 -1.2662399291992188e+01 -3.7477099895477295e+00 7.8319096565246582e+00 -1.2970499992370605e+01 -3.6573300361633301e+00 2.2901000976562500e+00 -1.2573500633239746e+01 -3.8009400367736816e+00 5.9408802986145020e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 7.8881697654724121e+00 -1.2484200477600098e+01 -3.9098598957061768e+00 7.0624599456787109e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -2.0024199485778809e+00 -1.2484299659729004e+01 -3.9098799228668213e+00 -9.6985197067260742e-01 -1.2524399757385254e+01 -3.8409099578857422e+00 -1.8293800354003906e+00 -1.2605199813842773e+01 -3.7882800102233887e+00 -7.5229701995849609e+00 -1.2807399749755859e+01 -3.7095000743865967e+00 -5.9678897857666016e+00 -1.2767600059509277e+01 -3.7213799953460693e+00 -8.6283597946166992e+00 -3.7348401546478271e+00 -9.6158704757690430e+00 -1.2329899787902832e+01 -3.1280300617218018e+00 -7.6370201110839844e+00 -1.2403100013732910e+01 8.7329399585723877e-01 -1.1364899635314941e+01 -1.2318799972534180e+01 1.0703100204467773e+01 -7.2038497924804688e+00 -1.1134699821472168e+01 7.7888498306274414e+00 -6.2445998191833496e+00 -1.0708199501037598e+01 7.8256697654724121e+00 -6.1219301223754883e+00 -1.1171999931335449e+01 -2.1993900299072266e+01 -4.3255300521850586e+00 -2.4526199340820312e+01 -2.3448400497436523e+01 -3.2784500122070312e+00 -2.5642499923706055e+01 -2.0344799041748047e+01 -2.5829300880432129e+00 -2.3502201080322266e+01 -1.1917799711227417e+00 -3.1527099609375000e+00 -1.2656300544738770e+01 6.2891502380371094e+00 -4.2209100723266602e+00 -1.2782799720764160e+01 6.1553201675415039e+00 -4.6863098144531250e+00 -1.2656300544738770e+01 -2.2139501571655273e+01 2.5863601684570312e+01 2.0501499176025391e+01 -2.1425201416015625e+01 2.7268400192260742e+01 1.9481500625610352e+01 -2.5302400588989258e+01 2.7277299880981445e+01 2.1045299530029297e+01 -6.9466300964355469e+01 3.3302398681640625e+01 2.2395801544189453e+01 -7.2046302795410156e+01 3.1377199172973633e+01 2.3069599151611328e+01 -7.0832496643066406e+01 3.1005399703979492e+01 2.3329299926757812e+01 6.5056400299072266e+00 -6.9451603889465332e+00 7.9941797256469727e+00 6.5039496421813965e+00 -6.9507203102111816e+00 1.0265699386596680e+01 -8.3144500732421875e+01 -5.1153302192687988e+00 2.8096899032592773e+01 -7.5474998474121094e+01 -1.5825899124145508e+01 2.8096899032592773e+01 -6.2479598999023438e+01 -1.2624799728393555e+01 2.8096899032592773e+01 -1.4801699638366699e+01 -4.1313600540161133e+00 1.6200000762939453e+01 -3.7829699516296387e+00 -1.0163400650024414e+01 1.2222599983215332e+01 -2.6531100273132324e-01 -1.2549300193786621e+01 1.1706399917602539e+01 8.7329399585723877e-01 -1.1364899635314941e+01 1.2318799972534180e+01 -1.4801400184631348e+01 -4.1321501731872559e+00 -1.6200000762939453e+01 -1.3764300346374512e+01 -3.1246500015258789e+00 -1.7190198898315430e+01 -1.4514800071716309e+01 -4.0290498733520508e+00 -1.6200000762939453e+01 2.2106499671936035e+00 -1.3960100173950195e+01 -2.0790699124336243e-01 3.4323198795318604e+00 -1.3626199722290039e+01 1.5319299697875977e-01 2.2320101261138916e+00 -1.3986299514770508e+01 4.8962998390197754e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 1.2998600006103516e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 1.3617499351501465e+01 -1.1717700004577637e+01 -9.3561401367187500e+00 -4.2465898394584656e-01 -1.2008800506591797e+01 -8.4160299301147461e+00 3.8966000080108643e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 0.0000000000000000e+00 1.3559999465942383e+00 -1.3735700607299805e+01 0.0000000000000000e+00 2.2826800346374512e+00 -1.3991299629211426e+01 -4.2284898757934570e+00 1.3559999465942383e+00 -1.3735700607299805e+01 8.7694101333618164e+00 2.4698100090026855e+00 -1.3937099456787109e+01 8.7694101333618164e+00 1.8381600379943848e+00 -1.3701499938964844e+01 1.0737399101257324e+01 -3.2054100036621094e+01 6.2682800292968750e+00 2.7916500091552734e+01 -3.5307498931884766e+01 6.9998002052307129e+00 2.8040800094604492e+01 -3.4960601806640625e+01 4.6865496635437012e+00 2.8096899032592773e+01 1.6996000289916992e+01 -3.3174800872802734e+00 1.2577500343322754e+01 9.9698200225830078e+00 1.2566100120544434e+01 1.1364099502563477e+01 8.8271598815917969e+00 1.1986900329589844e+01 1.2798500061035156e+01 6.5754299163818359e+00 -6.7187600135803223e+00 -1.1521000862121582e+01 7.0703201293945312e+00 -5.9839997291564941e+00 -1.1557299613952637e+01 -6.3049201965332031e+00 -2.9044599533081055e+00 1.2972599983215332e+01 -1.2259400367736816e+01 -4.8232898712158203e+00 1.2660400390625000e+01 -9.9744796752929688e+00 -4.5425395965576172e+00 1.2656199455261230e+01 1.6979299545288086e+01 -7.7118597030639648e+00 1.0204299926757812e+01 1.7815399169921875e+01 -6.8035297393798828e+00 6.1348299980163574e+00 1.8233100891113281e+01 -6.0392799377441406e+00 9.8591594696044922e+00 -7.5310699462890625e+01 2.9075099945068359e+01 -2.2331199645996094e+01 -7.4115997314453125e+01 3.0917200088500977e+01 -6.3364000320434570e+00 -7.3991905212402344e+01 3.1087200164794922e+01 -2.0753999710083008e+01 -1.7933801651000977e+01 -4.4097299575805664e+00 1.9811000823974609e+01 -1.8381599426269531e+01 -4.6153502464294434e+00 1.9938400268554688e+01 -1.8535400390625000e+01 -4.7442803382873535e+00 1.9777198791503906e+01 -4.6186599731445312e+01 3.2449398040771484e+01 -1.9171899795532227e+01 -3.9010299682617188e+01 3.1170000076293945e+01 -1.2812999725341797e+01 -4.0568500518798828e+01 3.1447801589965820e+01 -1.9171899795532227e+01 -9.3643701076507568e-01 -1.2331299781799316e+00 1.3162500381469727e+01 7.4979400634765625e+00 1.1315800666809082e+01 1.3162500381469727e+01 -2.2360601425170898e+00 2.0811300277709961e+01 1.3162500381469727e+01 -2.7377400398254395e+00 8.1501903533935547e+00 1.3189200401306152e+01 -5.5910696983337402e+00 9.8823995590209961e+00 1.3536700248718262e+01 -5.0552597045898438e+00 -7.3047602176666260e-01 1.3541700363159180e+01 -3.0652400970458984e+01 -6.3191099166870117e+00 2.7726499557495117e+01 -2.8022499084472656e+01 -7.0541601181030273e+00 2.5820299148559570e+01 -2.5538499832153320e+01 -5.7663202285766602e+00 2.5932901382446289e+01 -3.6865699768066406e+01 -9.4052896499633789e+00 2.5059400558471680e+01 -3.6099399566650391e+01 -9.0500707626342773e+00 2.6140300750732422e+01 -1.6234600067138672e+01 2.6851600646972656e+01 1.6481698989868164e+01 -1.5578900337219238e+01 2.5394300460815430e+01 1.7527900695800781e+01 -2.1363500595092773e+01 -5.5741901397705078e+00 -2.1366701126098633e+01 -2.0411201477050781e+01 -4.7090196609497070e+00 -2.2788400650024414e+01 -2.0372501373291016e+01 -5.0616903305053711e+00 -2.1867599487304688e+01 -7.3012802124023438e+01 1.1470699310302734e+01 2.8096899032592773e+01 -1.9929201126098633e+01 -2.5044901371002197e+00 2.3149600982666016e+01 -2.0344799041748047e+01 -2.5829300880432129e+00 2.3502201080322266e+01 -1.9911499023437500e+01 -2.6179800033569336e+00 2.3137298583984375e+01 1.7851099014282227e+01 -2.8868699073791504e+00 1.1213200569152832e+01 1.7999500274658203e+01 -2.8110098838806152e+00 1.0229700088500977e+01 1.0173600196838379e+01 1.2668499946594238e+01 1.0229700088500977e+01 -1.1707900047302246e+01 -1.0305900573730469e+00 -1.6281200408935547e+01 -1.3814399719238281e+01 -1.2366698980331421e+00 -1.7900100708007812e+01 -1.2813099861145020e+01 8.6443700790405273e+00 -1.6657701492309570e+01 -6.7424400329589844e+01 3.5585800170898438e+01 -1.5192500114440918e+01 -6.9739402770996094e+01 3.4844497680664062e+01 -1.9329198837280273e+01 -6.9890800476074219e+01 3.4740299224853516e+01 -1.3068599700927734e+01 -3.8664299011230469e+01 -9.7858896255493164e+00 2.5666900634765625e+01 -3.8664299011230469e+01 -9.7859201431274414e+00 -6.0895299911499023e+00 -3.6865699768066406e+01 -9.4051599502563477e+00 2.5553998947143555e+00 1.7359399795532227e+01 -7.3857803344726562e+00 5.2850300073623657e-01 1.6201900482177734e+01 -8.2512598037719727e+00 6.4863600730895996e+00 1.5625000000000000e+01 -8.4799699783325195e+00 -3.5178201198577881e+00 1.8429599761962891e+01 -4.6149396896362305e+00 -1.0229800224304199e+01 1.8488298416137695e+01 -4.2356801033020020e+00 -5.2802896499633789e+00 1.8034099578857422e+01 -6.5168299674987793e+00 -9.8976402282714844e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 9.9036703109741211e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 9.4646701812744141e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 8.9752006530761719e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -1.3617499351501465e+01 -1.0752200126647949e+01 -3.0702002048492432e+00 -1.4689800262451172e+01 -8.5498199462890625e+00 -2.0437798500061035e+00 -1.4373999595642090e+01 -8.8484201431274414e+00 -1.0371999740600586e+01 1.0295099258422852e+01 -9.3663597106933594e+00 -1.0286300659179688e+01 1.0186400413513184e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 8.7694101333618164e+00 -4.7212001800537109e+01 3.0567699432373047e+01 2.2045299530029297e+01 -3.7275600433349609e+01 2.9620201110839844e+01 2.1652898788452148e+01 -5.6820701599121094e+01 3.2918598175048828e+01 2.1759700775146484e+01 -2.1543800354003906e+01 -5.6311798095703125e+00 2.1169200897216797e+01 -2.1525400161743164e+01 -5.6266598701477051e+00 2.1153800964355469e+01 -2.1363500595092773e+01 -5.5741901397705078e+00 2.1366701126098633e+01 -5.7192401885986328e+01 1.5727400779724121e+01 -2.7392900466918945e+01 -3.6246501922607422e+01 1.2408599853515625e+01 -2.7300899505615234e+01 -4.7573600769042969e+01 1.0629099845886230e+01 -2.7922698974609375e+01 -1.1501399278640747e+00 2.3098100662231445e+01 -1.1806599617004395e+01 1.0235599279403687e+00 2.2340299606323242e+01 -1.1137999534606934e+01 1.8424400091171265e+00 2.0947498321533203e+01 -1.2331600189208984e+01 -2.0471099853515625e+01 -5.3669600486755371e+00 2.0250000000000000e+01 -2.1715600967407227e+01 -5.6734995841979980e+00 2.0814899444580078e+01 -2.2813199996948242e+01 -5.9438600540161133e+00 2.0250000000000000e+01 -2.1642099380493164e+01 -5.6554098129272461e+00 -2.0250000000000000e+01 -2.3167098999023438e+01 -6.1690402030944824e+00 -1.9695999145507812e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -2.0250000000000000e+01 -6.7396001815795898e+00 2.4108900070190430e+01 1.3244400024414062e+01 -6.8111300468444824e+00 2.5263500213623047e+01 1.1734999656677246e+01 -9.2166500091552734e+00 2.4305500030517578e+01 1.4093100547790527e+01 -5.3998703002929688e+01 1.6689399719238281e+01 2.7050100326538086e+01 -3.5852001190185547e+01 1.0150699615478516e+01 2.7704900741577148e+01 -3.6246501922607422e+01 1.2408599853515625e+01 2.7300899505615234e+01 -3.6865699768066406e+01 -9.4052896499633789e+00 -2.5059400558471680e+01 -3.3109001159667969e+01 -8.3592500686645508e+00 -2.5973201751708984e+01 -3.2170398712158203e+01 -8.2487401962280273e+00 -2.5059400558471680e+01 -2.0274599075317383e+01 -6.1647500991821289e+00 -1.9253698348999023e+01 -1.9463399887084961e+01 -5.4603700637817383e+00 -1.9454500198364258e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 -1.8648300170898438e+01 -2.3977399826049805e+01 -9.3802804946899414e+00 1.9237499237060547e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 1.9237499237060547e+01 -2.2188899993896484e+01 -7.8271403312683105e+00 1.6200000762939453e+01 -8.5282297134399414e+00 -8.4679307937622070e+00 -1.2318799972534180e+01 -1.1204199790954590e+01 -8.3859004974365234e+00 -1.1267899513244629e+01 -9.5885000228881836e+00 -5.6457500457763672e+00 -1.2016500473022461e+01 -3.1619102478027344e+01 -9.1428298950195312e+00 -1.9237499237060547e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -1.6200000762939453e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -1.9173799514770508e+01 -8.0539199829101562e+01 -1.8201200485229492e+01 -1.1521100044250488e+01 -8.1597496032714844e+01 -1.7668201446533203e+01 -2.0089199066162109e+01 -7.9247604370117188e+01 -1.8652799606323242e+01 -1.6982500076293945e+01 -1.9463399887084961e+01 -5.4603700637817383e+00 1.9454500198364258e+01 -1.9552999496459961e+01 -5.2118301391601562e+00 1.9774299621582031e+01 -2.0416799545288086e+01 -5.5875201225280762e+00 1.9607500076293945e+01 -6.3738002777099609e+01 3.5578601837158203e+01 6.5812498331069946e-01 -6.0402301788330078e+01 3.4983898162841797e+01 3.0985200405120850e+00 -6.3738002777099609e+01 3.5578601837158203e+01 -6.5812498331069946e-01 -8.1343498229980469e+01 1.6503000259399414e+01 -2.7062200546264648e+01 -8.1813697814941406e+01 1.3203999519348145e+01 -2.7711000442504883e+01 -8.2870994567871094e+01 1.3630099296569824e+01 -2.6311100006103516e+01 1.4399399757385254e+01 -8.0869398117065430e+00 1.1998900413513184e+01 1.4841400146484375e+01 -6.6712498664855957e+00 1.3026099205017090e+01 1.3564299583435059e+01 -6.5236997604370117e+00 1.2960899353027344e+01 -3.6743099689483643e+00 -1.1660599708557129e+01 -1.0305999755859375e+01 -4.2065200805664062e+00 -1.1490400314331055e+01 -1.0306200027465820e+01 -4.5494699478149414e+00 -1.1222999572753906e+01 -1.1082200050354004e+01 -1.5663599967956543e+01 1.2680299758911133e+01 1.8732999801635742e+01 -2.2333801269531250e+01 1.5039600133895874e+00 2.4641700744628906e+01 -1.8950401306152344e+01 -5.0148200988769531e+00 1.9704099655151367e+01 -1.9560499191284180e+01 -5.1910400390625000e+00 1.9819000244140625e+01 -1.8805200576782227e+01 -4.8084197044372559e+00 2.0003700256347656e+01 -1.4816500663757324e+01 -4.1381201744079590e+00 -5.9119100570678711e+00 -1.5987800598144531e+01 -4.4253101348876953e+00 -1.6200000762939453e+01 -1.4801400184631348e+01 -4.1322402954101562e+00 -1.1137500762939453e+01 -1.2476700782775879e+01 -3.9411499500274658e+00 1.0080999374389648e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 9.9088802337646484e+00 -1.8682600021362305e+01 -4.8834199905395508e+00 1.9414600372314453e+01 7.8056902885437012e+00 -6.3070902824401855e+00 -1.0229800224304199e+01 7.7733201980590820e+00 -6.2963700294494629e+00 -1.0229800224304199e+01 7.8375797271728516e+00 -6.3176698684692383e+00 -1.0229800224304199e+01 7.7733201980590820e+00 -6.2963700294494629e+00 1.0229800224304199e+01 7.8056902885437012e+00 -6.3070902824401855e+00 1.0229800224304199e+01 7.7888598442077637e+00 -6.2445998191833496e+00 1.0708199501037598e+01 -2.0253499984741211e+01 -5.3109297752380371e+00 2.0218898773193359e+01 -1.9684999465942383e+01 -5.1407999992370605e+00 2.0137001037597656e+01 -1.9590099334716797e+01 -5.1089401245117188e+00 2.0123201370239258e+01 -1.8959199905395508e+01 -5.0460901260375977e+00 -1.6953500747680664e+01 -1.8677999496459961e+01 -4.9410200119018555e+00 -1.8645801544189453e+01 -6.8465900421142578e+00 2.5434799194335938e+01 -1.0693900108337402e+01 -6.7984600067138672e+00 2.5216499328613281e+01 -1.1873999595642090e+01 -7.0307302474975586e+00 2.5468399047851562e+01 -1.0730699539184570e+01 5.4230195283889771e-01 -1.3339400291442871e+01 1.0186499595642090e+01 6.6291794180870056e-02 -1.3118900299072266e+01 1.0295099258422852e+01 3.5693798065185547e+00 -1.2067600250244141e+01 1.1115400314331055e+01 3.3281998634338379e+00 -9.6264200210571289e+00 1.1927900314331055e+01 1.9329000711441040e+00 -1.1760899543762207e+01 1.2143399238586426e+01 -2.6596599578857422e+01 2.8676700592041016e+01 2.0053998947143555e+01 -3.0364299774169922e+01 2.8519001007080078e+01 2.1515800476074219e+01 -3.2134498596191406e+01 2.9944099426269531e+01 1.9171699523925781e+01 -3.2243801116943359e+01 2.9963600158691406e+01 1.9171899795532227e+01 -3.2244800567626953e+01 2.9958099365234375e+01 1.9357599258422852e+01 -4.5868897438049316e+00 2.1889400482177734e+01 1.3294899940490723e+01 -6.8786296844482422e+00 2.2554998397827148e+01 1.3689200401306152e+01 1.0780099868774414e+01 -7.3840303421020508e+00 -1.0229299545288086e+01 7.9849400520324707e+00 -6.3666200637817383e+00 -9.7502603530883789e+00 -7.5474998474121094e+01 -1.5825899124145508e+01 -2.8096899032592773e+01 -8.3144500732421875e+01 -5.1153302192687988e+00 -2.8096899032592773e+01 -3.4960601806640625e+01 4.6865601539611816e+00 -2.8096899032592773e+01 1.8121999740600586e+01 -3.7267000675201416e+00 1.1475500106811523e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 1.6200000762939453e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 1.6200000762939453e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 1.6200000762939453e+01 -3.1426000595092773e+01 -1.2474399566650391e+01 1.7586500167846680e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 1.9237499237060547e+01 -1.4514900207519531e+01 -4.0289001464843750e+00 -1.0148599624633789e+01 -1.4514900207519531e+01 -4.0289201736450195e+00 -1.0824300765991211e+01 -7.0307302474975586e+00 2.5468399047851562e+01 1.1930599212646484e+00 -6.2811598777770996e+00 2.5323999404907227e+01 8.8308601379394531e+00 -5.1029601097106934e+00 2.5061498641967773e+01 -9.2014297842979431e-02 1.7082599639892578e+01 -7.6317801475524902e+00 -5.2086601257324219e+00 1.6372600555419922e+01 -8.1343603134155273e+00 -1.0082700729370117e+01 -1.8381599426269531e+01 -4.6153502464294434e+00 -1.9938400268554688e+01 -1.8950401306152344e+01 -5.0148200988769531e+00 -1.9704099655151367e+01 -1.8805200576782227e+01 -4.8084197044372559e+00 -2.0003700256347656e+01 -1.9552999496459961e+01 -5.2118301391601562e+00 -1.9774299621582031e+01 -1.9560499191284180e+01 -5.1910400390625000e+00 -1.9819000244140625e+01 -1.9590099334716797e+01 -5.1089401245117188e+00 -2.0123201370239258e+01 -1.8682600021362305e+01 -4.8834199905395508e+00 -1.9414600372314453e+01 -1.8535400390625000e+01 -4.7442803382873535e+00 -1.9777198791503906e+01 -1.5709898948669434e+01 -2.6496000289916992e+00 -1.9353401184082031e+01 -8.5771003723144531e+01 -1.1238199234008789e+01 8.6786994934082031e+00 -8.5504898071289062e+01 -1.2630400657653809e+01 1.7258298873901367e+01 -8.5808395385742188e+01 -1.0856200218200684e+01 2.5666900634765625e+01 -8.4953704833984375e+01 5.5282402038574219e+00 2.6353700637817383e+01 -8.5409095764160156e+01 2.5775000452995300e-01 2.6810899734497070e+01 -8.3794303894042969e+01 8.1370296478271484e+00 2.7293899536132812e+01 -8.4496902465820312e+01 -5.4552202224731445e+00 -2.7859399795532227e+01 -8.3920501708984375e+01 1.1767899990081787e+00 -2.7920200347900391e+01 -3.2235397338867188e+01 -8.0054492950439453e+00 -2.6211301803588867e+01 -3.2233303070068359e+01 -8.0535802841186523e+00 -2.5843000411987305e+01 5.9477596282958984e+00 1.8598400115966797e+01 1.0229899406433105e+01 1.7649099826812744e+00 2.1988698959350586e+01 1.0890100479125977e+01 4.4711198806762695e+00 1.9349500656127930e+01 1.1871500015258789e+01 -8.2649297714233398e+00 1.0456899642944336e+01 1.4296099662780762e+01 -7.5794796943664551e+00 2.2704200744628906e+01 1.3865099906921387e+01 -1.2534000396728516e+01 -3.8350398540496826e+00 -4.3579798936843872e-01 -5.1284399032592773e+00 -3.3915398120880127e+00 1.2656300544738770e+01 6.1553602218627930e+00 -4.6861801147460938e+00 1.2656300544738770e+01 -1.1917500495910645e+00 -3.1527099609375000e+00 1.2656300544738770e+01 -4.9385200500488281e+01 3.3019901275634766e+01 1.9171899795532227e+01 -3.8531600952148438e+01 3.1011400222778320e+01 1.9901300430297852e+01 -3.5196399688720703e+01 3.0490100860595703e+01 1.9171899795532227e+01 -2.1136699676513672e+01 -5.5309100151062012e+00 -2.0822700500488281e+01 -2.1525400161743164e+01 -5.6266598701477051e+00 -2.1153800964355469e+01 -1.9929201126098633e+01 -2.5044901371002197e+00 -2.3149600982666016e+01 -1.9911499023437500e+01 -2.6179800033569336e+00 -2.3137298583984375e+01 -1.9684999465942383e+01 -5.1407999992370605e+00 -2.0137001037597656e+01 9.3636302947998047e+00 1.2259200096130371e+01 -1.2307199478149414e+01 9.9552602767944336e+00 1.2558500289916992e+01 -1.1385199546813965e+01 1.7250400543212891e+01 -3.1916201114654541e+00 -1.2400099754333496e+01 8.3363199234008789e+00 1.1740099906921387e+01 -1.3043000221252441e+01 -1.1279500722885132e+00 -2.6728100776672363e+00 1.2782799720764160e+01 -3.0875298976898193e+00 -2.3608798980712891e+00 1.2931300163269043e+01 -7.9667396545410156e+01 2.1551099777221680e+01 -7.7849397659301758e+00 -7.9124397277832031e+01 2.2711299896240234e+01 6.7944297790527344e+00 -7.8378700256347656e+01 2.4122501373291016e+01 -2.4199899673461914e+01 -5.1685897827148438e+01 -9.9661397933959961e+00 -2.8096899032592773e+01 -4.1871303558349609e+01 -7.5485901832580566e+00 -2.8096899032592773e+01 5.7027497291564941e+00 1.8850900650024414e+01 -1.0230400085449219e+01 4.9494004249572754e+00 1.9332698822021484e+01 -1.1386799812316895e+01 3.4745199680328369e+00 2.0812099456787109e+01 -1.0230200767517090e+01 -1.4514900207519531e+01 -4.0288801193237305e+00 -9.4729499816894531e+00 -2.5882299423217773e+01 6.5729398727416992e+00 -2.5915699005126953e+01 -2.7801700592041016e+01 8.5838298797607422e+00 -2.6338800430297852e+01 -2.4039199829101562e+01 1.7257900238037109e+01 -2.2966598510742188e+01 -2.7801700592041016e+01 8.5838403701782227e+00 2.6338800430297852e+01 -2.4689399719238281e+01 1.7569900512695312e+01 2.3172599792480469e+01 -2.9835699081420898e+01 1.0471699714660645e+01 2.6646598815917969e+01 -3.2243801116943359e+01 2.9963600158691406e+01 -1.9171899795532227e+01 -3.2134498596191406e+01 2.9944099426269531e+01 -1.9171699523925781e+01 -3.2244800567626953e+01 2.9958099365234375e+01 -1.9357599258422852e+01 -8.5030395507812500e+01 -1.3849199295043945e+01 2.5683200836181641e+01 -8.3256996154785156e+01 -1.6324600219726562e+01 2.5701200485229492e+01 -8.3782005310058594e+01 -1.5325400352478027e+01 2.6581800460815430e+01 7.7733201980590820e+00 -6.2963800430297852e+00 9.5904197692871094e+00 7.0217099189758301e+00 -6.2707200050354004e+00 1.0502500534057617e+01 7.7806801795959473e+00 -6.2986197471618652e+00 6.6971802711486816e+00 -8.3059402465820312e+01 1.3686499595642090e+01 -1.0157999992370605e+01 -8.3825904846191406e+01 1.1212299346923828e+01 -2.5673000335693359e+01 -8.3771400451660156e+01 1.1408599853515625e+01 4.6389899253845215e+00 7.3231196403503418e+00 -4.9986801147460938e+00 -1.2475100517272949e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 1.0522600173950195e+01 -2.7505100250244141e+01 2.8871700286865234e+01 -2.0221300125122070e+01 -2.7945199966430664e+01 2.7703599929809570e+01 -2.1552700042724609e+01 -3.2466899871826172e+01 2.8711000442504883e+01 -2.1660499572753906e+01 -7.4771903991699219e+01 -1.8679899215698242e+01 -2.5666900634765625e+01 -7.8437995910644531e+01 -1.8913499832153320e+01 -2.5915500640869141e+01 -7.7258293151855469e+01 -1.8657999038696289e+01 -2.6711400985717773e+01 -6.6294601440429688e+01 3.5746601104736328e+01 1.9609399795532227e+01 -6.3738002777099609e+01 3.5578601837158203e+01 1.9171899795532227e+01 -6.5297294616699219e+01 3.5755100250244141e+01 1.2447099685668945e+01 6.5754299163818359e+00 -6.7187600135803223e+00 1.1521000862121582e+01 5.9373202323913574e+00 -8.7896099090576172e+00 6.6695103645324707e+00 1.4505400657653809e+01 -5.6119298934936523e+00 1.3162500381469727e+01 1.5431400299072266e+01 -4.6149396896362305e+00 1.3162500381469727e+01 -6.5213394165039062e+01 3.5754699707031250e+01 -5.3641695976257324e+00 -6.3738002777099609e+01 3.5578601837158203e+01 -1.9171899795532227e+01 -6.5423103332519531e+01 3.5773197174072266e+01 -1.8596099853515625e+01 -1.1279500722885132e+00 -2.6728100776672363e+00 -1.2782799720764160e+01 -2.9760499000549316e+00 -3.0944697856903076e+00 -1.2656300544738770e+01 -3.5070602416992188e+01 2.1786800384521484e+01 2.4295400619506836e+01 -3.7007598876953125e+01 1.6523199081420898e+01 2.6201299667358398e+01 -3.3571800231933594e+01 1.3752599716186523e+01 2.6741498947143555e+01 -5.5210800170898438e+01 -1.3861700057983398e+01 2.5675899505615234e+01 -5.8108501434326172e+01 -1.4226099967956543e+01 2.6618700027465820e+01 -6.5610900878906250e+01 -1.6215900421142578e+01 2.6334899902343750e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -1.6200000762939453e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 -4.8937501907348633e+00 -2.0114799499511719e+01 -4.5602002143859863e+00 2.2325199127197266e+01 -2.0671400070190430e+01 -5.1170496940612793e+00 2.2351400375366211e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 -1.6200000762939453e+01 -3.0750799179077148e+01 -1.3395999908447266e+01 -1.6200401306152344e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 -1.6200000762939453e+01 -4.3063602447509766e+00 -7.2739300727844238e+00 -1.2656300544738770e+01 -7.9056901931762695e+00 -6.1648397445678711e+00 -1.2403100013732910e+01 -4.5345703125000000e+01 3.2152801513671875e+01 -2.0257198333740234e+01 -5.8073497772216797e+01 3.3361198425292969e+01 -2.1627399444580078e+01 -5.3898498535156250e+01 3.3666698455810547e+01 -2.0286298751831055e+01 -1.8998699188232422e+01 -4.6136698722839355e+00 -2.0957500457763672e+01 6.5172100067138672e+00 -5.2400598526000977e+00 1.2515299797058105e+01 7.2640500068664551e+00 -5.3626699447631836e+00 1.2187999725341797e+01 -2.8788700103759766e+01 8.0465402603149414e+00 2.6805700302124023e+01 -2.9295900344848633e+01 2.6298601627349854e+00 2.7616500854492188e+01 -7.4663600921630859e+00 9.6977396011352539e+00 -1.4044400215148926e+01 -6.7237200736999512e+00 -8.6511200666427612e-01 -1.3970100402832031e+01 -9.9872703552246094e+00 1.0614800453186035e+01 -1.4986700057983398e+01 -3.1582798004150391e+01 -1.1628499984741211e+01 -1.9237499237060547e+01 -7.9663406372070312e+01 2.1549299240112305e+01 2.5176801681518555e+01 -7.8378700256347656e+01 2.4122501373291016e+01 2.4199899673461914e+01 1.3725899696350098e+01 -6.1690597534179688e+00 -1.3083499908447266e+01 1.3075299263000488e+01 -7.6040601730346680e+00 -1.2196599960327148e+01 -6.7755897521972656e+01 -1.5935299873352051e+01 2.7407100677490234e+01 -6.0522998809814453e+01 -1.3709699630737305e+01 -2.7725700378417969e+01 -7.5249801635742188e+01 -1.6741300582885742e+01 -2.7983098983764648e+01 -6.6762901306152344e+01 -1.4503699302673340e+01 2.8012199401855469e+01 -5.4187301635742188e+01 -1.2421299934387207e+01 2.7538700103759766e+01 1.4696800231933594e+01 -8.6779699325561523e+00 1.0343199729919434e+01 1.6443500518798828e+01 -7.5257997512817383e+00 1.2014800071716309e+01 7.5706100463867188e+00 1.3780200004577637e+01 1.2959400177001953e+01 3.1823399066925049e+00 1.8640600204467773e+01 1.3034200668334961e+01 -1.2421900749206543e+01 -4.1541399955749512e+00 -4.5282101631164551e+00 -1.2468999862670898e+01 -3.9723701477050781e+00 -1.8569400310516357e+00 -6.1132202148437500e+00 -8.9653596878051758e+00 1.2327199935913086e+01 -8.5282297134399414e+00 -8.4679307937622070e+00 1.2318799972534180e+01 2.3100900650024414e-01 -1.2773900032043457e+01 -1.1537400245666504e+01 6.6291794180870056e-02 -1.3118900299072266e+01 -1.0295099258422852e+01 -3.1013799667358398e+01 1.1508500099182129e+01 -2.6688199996948242e+01 -2.8788700103759766e+01 8.0465402603149414e+00 -2.6805700302124023e+01 -3.3203502655029297e+01 3.0134700775146484e+01 1.7758001327514648e+01 -2.4825799942016602e+01 2.8641099929809570e+01 1.8163799285888672e+01 -4.1487602233886719e+01 3.1611598968505859e+01 1.4307600021362305e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -8.9752006530761719e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -9.9036703109741211e+00 -1.2259700775146484e+01 -4.8232102394104004e+00 -9.3602504730224609e+00 -3.1784002304077148e+01 2.9881599426269531e+01 1.4811899662017822e+00 -7.1686904907226562e+01 -1.6983200073242188e+01 -2.7335699081420898e+01 -7.4860198974609375e+01 -1.8286399841308594e+01 -2.6814899444580078e+01 1.8429599761962891e+01 -4.6149396896362305e+00 1.0229800224304199e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 5.2312502861022949e+00 -2.5633199691772461e+01 -4.6088900566101074e+00 2.6641799926757812e+01 -2.9760499000549316e+00 -3.0944697856903076e+00 1.2656300544738770e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 -8.7694101333618164e+00 -9.3663597106933594e+00 -1.0286300659179688e+01 -1.0186400413513184e+01 -1.0261599540710449e+01 -1.0155900001525879e+01 0.0000000000000000e+00 -8.1791900634765625e+01 1.5954900741577148e+01 2.6767200469970703e+01 -8.0238800048828125e+01 2.0285900115966797e+01 2.5552999496459961e+01 -8.1184898376464844e+01 1.8335500717163086e+01 2.5733100891113281e+01 -3.6160202026367188e+00 2.4537000656127930e+01 1.1019499778747559e+01 -2.9645600318908691e+00 2.3958898544311523e+01 1.1670299530029297e+01 -8.5344795227050781e+01 -1.3159299850463867e+01 -2.5675498962402344e+01 -8.4780502319335938e+01 -1.3482700347900391e+01 -2.6805799484252930e+01 -8.3488502502441406e+01 -1.6101799011230469e+01 -2.5653900146484375e+01 -1.4594299316406250e+01 1.1992500305175781e+01 -1.7900100708007812e+01 -1.5563899993896484e+01 1.8719600677490234e+01 -1.8207599639892578e+01 -1.3649499893188477e+01 2.0166198730468750e+01 -1.6796400070190430e+01 7.1067600250244141e+00 1.5662099838256836e+01 -1.2590600013732910e+01 -5.2022899627685547e+01 -1.0049200057983398e+01 2.8097499847412109e+01 -3.2659900665283203e+01 -6.2573800086975098e+00 -2.7959701538085938e+01 -3.2310401916503906e+01 -7.7156100273132324e+00 -2.6880100250244141e+01 -3.7114601135253906e+01 -8.2541399002075195e+00 -2.7487701416015625e+01 6.2891502380371094e+00 -4.2209100723266602e+00 1.2782799720764160e+01 7.8256697654724121e+00 -6.1219201087951660e+00 1.1171999931335449e+01 7.8357701301574707e+00 -6.0883202552795410e+00 1.1264100074768066e+01 6.5892200469970703e+00 -6.6740202903747559e+00 1.1643799781799316e+01 -8.2213798522949219e+01 9.0626697540283203e+00 -2.8002300262451172e+01 -8.2400001525878906e+01 4.0667500495910645e+00 -2.8096899032592773e+01 -3.7193300724029541e+00 -1.0557499885559082e+01 -1.2111100196838379e+01 -7.3138801574707031e+01 3.2191802978515625e+01 1.9520699977874756e+00 -7.3991905212402344e+01 3.1087200164794922e+01 2.0753999710083008e+01 -7.3362998962402344e+01 3.1903699874877930e+01 2.0454200744628906e+01 -7.0345703125000000e+01 3.3393600463867188e+01 -2.2247501373291016e+01 -6.5009803771972656e+01 3.4581100463867188e+01 -2.1574399948120117e+01 -7.0832199096679688e+01 3.1005699157714844e+01 -2.3329200744628906e+01 9.4824304580688477e+00 -6.8887901306152344e+00 1.0229599952697754e+01 -5.8311397552490234e+01 3.4510696411132812e+01 2.0043899536132812e+01 -5.9798099517822266e+01 3.4223999023437500e+01 2.1105899810791016e+01 -5.0657699584960938e+01 3.2827701568603516e+01 2.0781299591064453e+01 -5.7458099365234375e+01 2.0169298171997070e+01 2.6201400756835938e+01 -2.6081600189208984e+01 -4.7166800498962402e+00 -2.6796600341796875e+01 -2.9988599777221680e+01 -5.7139000892639160e+00 -2.7801799774169922e+01 -2.9492401123046875e+01 -4.9492101669311523e+00 -2.7866498947143555e+01 -2.0742601394653320e+01 -5.4436001777648926e+00 -1.6200000762939453e+01 -2.4548599243164062e+01 -7.9655795097351074e+00 -1.6200000762939453e+01 -1.4520799636840820e+01 -4.0115003585815430e+00 3.2433801889419556e-01 -1.5133599281311035e+01 -4.2432403564453125e+00 3.3784000873565674e+00 -7.7186103820800781e+01 2.0684000015258789e+01 -2.7094200134277344e+01 -7.8433197021484375e+01 2.0577098846435547e+01 -2.7034099578857422e+01 -7.5841705322265625e+01 2.3446901321411133e+01 -2.6201299667358398e+01 -1.3005199432373047e+01 -3.6734499931335449e+00 -4.7825298309326172e+00 -1.3184000015258789e+01 -3.6677999496459961e+00 -1.0433699607849121e+01 -1.2911699295043945e+01 -3.6889998912811279e+00 -8.6283597946166992e+00 -1.2516999244689941e+01 -3.8552200794219971e+00 -6.6013298034667969e+00 -1.2536999702453613e+01 -3.8368198871612549e+00 -7.7837600708007812e+00 -1.2509699821472168e+01 -3.8612699508666992e+00 -5.5878200531005859e+00 -1.2515500068664551e+01 -3.8569900989532471e+00 -4.7432298660278320e+00 -1.2617600440979004e+01 -3.7806799411773682e+00 -3.9830901622772217e+00 -1.2494400024414062e+01 -3.8837699890136719e+00 -7.4459300041198730e+00 -1.2515299797058105e+01 -3.8555400371551514e+00 -3.1807298660278320e+00 -1.2770099639892578e+01 -3.6780300140380859e+00 1.3781299591064453e+01 -1.2551699638366699e+01 -3.8121600151062012e+00 1.0509500503540039e+01 -1.2494299888610840e+01 -3.8842501640319824e+00 1.1810799598693848e+01 -1.2484299659729004e+01 -3.9098701477050781e+00 4.3427801132202148e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 5.2011504173278809e+00 -1.2487799644470215e+01 -3.8981499671936035e+00 -5.0306601524353027e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -5.9310398101806641e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 -6.6529803276062012e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -2.7161998748779297e+00 -1.2484299659729004e+01 -3.9098799228668213e+00 1.2311100006103516e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -3.8659100532531738e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 6.4431800842285156e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 3.2775499820709229e+00 -1.2553400039672852e+01 -3.8170099258422852e+00 2.6337800025939941e+00 -1.3502200126647949e+01 -3.6915798187255859e+00 5.7843003273010254e+00 -1.2484200477600098e+01 -3.9098501205444336e+00 -1.1838899612426758e+01 -1.2502299308776855e+01 -3.8715100288391113e+00 -1.1204400062561035e+01 -1.2566300392150879e+01 -3.8090999126434326e+00 -1.2344599723815918e+01 -1.2623800277709961e+01 -3.7661299705505371e+00 -1.1394400596618652e+01 -7.6548400878906250e+01 -1.8981800079345703e+01 -2.0772098541259766e+01 -1.5987800598144531e+01 -4.4253101348876953e+00 1.6200000762939453e+01 -8.5808395385742188e+01 -1.0856200218200684e+01 -2.5666900634765625e+01 -8.5545196533203125e+01 -1.2445300102233887e+01 -1.1223400115966797e+01 -8.5798896789550781e+01 -1.0950900077819824e+01 -5.1937799453735352e+00 -1.8212100982666016e+01 -4.8294701576232910e+00 3.5889799594879150e+00 -2.4160200119018555e+01 -6.2756600379943848e+00 1.3753100395202637e+01 -1.5917999267578125e+01 -4.4139900207519531e+00 -2.8708499670028687e-01 -5.4176799774169922e+01 1.8406198501586914e+01 -2.6585201263427734e+01 6.5039496421813965e+00 -6.9507203102111816e+00 -1.0265699386596680e+01 6.6861600875854492e+00 -6.6043400764465332e+00 -5.2144203186035156e+00 -7.4772003173828125e+01 -1.8680000305175781e+01 2.5666900634765625e+01 -7.4772003173828125e+01 -1.8679899215698242e+01 1.1820299148559570e+01 -1.7977699279785156e+01 2.7983801364898682e+00 2.1229398727416992e+01 -1.8674098968505859e+01 -2.1953301429748535e+00 2.2069599151611328e+01 -1.3814399719238281e+01 -1.2366698980331421e+00 1.7900100708007812e+01 6.3108000755310059e+00 -7.5775399208068848e+00 1.1643799781799316e+01 8.6524295806884766e+00 1.5191599845886230e+01 -1.0941699981689453e+01 -1.6323900222778320e+01 2.6955699920654297e+01 -1.6242500305175781e+01 -2.0590400695800781e+01 2.7657899856567383e+01 -1.8403299331665039e+01 -2.3231201171875000e+01 2.8357799530029297e+01 -1.7734498977661133e+01 7.7492098808288574e+00 -6.2869400978088379e+00 -4.6565900556743145e-03 -8.0036903381347656e+01 1.6166000366210938e+01 2.7858100891113281e+01 -7.9609603881835938e+01 1.9263700485229492e+01 2.7067701339721680e+01 -1.0022800445556641e+01 -5.5124697685241699e+00 1.2656300544738770e+01 -7.8006200790405273e+00 -6.1972203254699707e+00 1.2656300544738770e+01 -6.4110900878906250e+01 3.3581001281738281e+01 2.2046899795532227e+01 -6.8545196533203125e+01 3.2818500518798828e+01 2.2579700469970703e+01 -2.8804500579833984e+01 -1.3430199623107910e+01 1.9237600326538086e+01 -3.0280599594116211e+01 -1.3544600486755371e+01 1.9237001419067383e+01 -2.9175899505615234e+01 -1.3620599746704102e+01 1.6201000213623047e+01 -1.1577199935913086e+01 -7.8938903808593750e+00 1.0571000099182129e+01 -9.4056100845336914e+00 -5.7048501968383789e+00 1.2144999504089355e+01 -1.0799900054931641e+01 -5.2730302810668945e+00 1.0634300231933594e+01 9.3039999008178711e+00 -6.4376001358032227e+00 -1.1582799911499023e+01 7.8357701301574707e+00 -6.0883202552795410e+00 -1.1264100074768066e+01 -2.8271600723266602e+01 -1.3109300613403320e+01 -1.9237499237060547e+01 -2.9465299606323242e+01 -1.3595799446105957e+01 -1.9237499237060547e+01 -3.0399499893188477e+01 -1.3425000190734863e+01 -1.9237499237060547e+01 -7.0144195556640625e+01 3.4517097473144531e+01 -2.0652599334716797e+01 -7.2173400878906250e+01 3.3203399658203125e+01 -2.0240598678588867e+01 -1.0893500328063965e+01 2.3506999969482422e+01 -1.5018699645996094e+01 -1.3107599258422852e+01 2.3883600234985352e+01 -1.6286199569702148e+01 -9.3633508682250977e+00 2.4608098983764648e+01 -1.3956800460815430e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 1.8648300170898438e+01 -4.4742698669433594e+01 -9.5224294662475586e+00 -2.7852001190185547e+01 -3.8778800964355469e+01 -9.3354997634887695e+00 -2.6824199676513672e+01 -7.3362998962402344e+01 3.1903699874877930e+01 -2.0454200744628906e+01 -8.2735099792480469e+01 1.3578999519348145e+01 2.6668500900268555e+01 -3.2975799560546875e+01 -3.8400099277496338e+00 -2.8096899032592773e+01 -2.8934200286865234e+01 -3.4957900047302246e+00 -2.7763200759887695e+01 -1.2468999862670898e+01 -3.9723598957061768e+00 -5.8803100585937500e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 9.0204601287841797e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -3.2910499572753906e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 -3.0948998928070068e+00 -6.3811504364013672e+01 3.5166500091552734e+01 2.0719499588012695e+01 -6.3929901123046875e+01 3.4440399169921875e+01 2.1585100173950195e+01 -8.4447395324707031e+01 -1.4850500106811523e+01 1.3938599824905396e+00 -8.3164802551269531e+01 -1.6422599792480469e+01 3.3809599876403809e+00 -8.3263206481933594e+01 -1.6331899642944336e+01 1.2152299880981445e+01 -1.8656398773193359e+01 -2.3088200092315674e+00 -2.2057399749755859e+01 -1.8647300720214844e+01 -3.4699399471282959e+00 -2.1727500915527344e+01 -8.5497795104980469e+01 -1.2562899589538574e+01 2.8260599821805954e-02 -7.5841705322265625e+01 2.3446901321411133e+01 2.6201299667358398e+01 -7.6856498718261719e+01 2.1396400451660156e+01 2.6889600753784180e+01 1.2776300430297852e+01 -8.2544794082641602e+00 1.0229800224304199e+01 -8.0267700195312500e+01 1.2764199256896973e+01 2.8096899032592773e+01 1.3941699981689453e+01 -8.6312093734741211e+00 7.5555901527404785e+00 1.4910300254821777e+01 -8.6305704116821289e+00 3.7874600887298584e+00 8.0147495269775391e+00 1.6214498519897461e+01 -1.0230600357055664e+01 6.6464800834655762e+00 1.7869501113891602e+01 1.2357000112533569e+00 7.1461400985717773e+00 1.7260000228881836e+01 1.0229700088500977e+01 -2.5912401199340820e+01 6.5912199020385742e+00 2.5931301116943359e+01 -2.5644001007080078e+01 2.4205899238586426e+00 2.6451900482177734e+01 -2.3801099777221680e+01 3.8622300624847412e+00 2.5255300521850586e+01 -8.5145103454589844e+01 5.5757799148559570e+00 -2.5662200927734375e+01 -8.4460601806640625e+01 8.7752904891967773e+00 -5.3235797882080078e+00 -6.3375101089477539e+00 -1.7565100193023682e+00 1.3721400260925293e+01 -8.2074394226074219e+01 -1.5267700195312500e+01 2.7876098632812500e+01 -8.4486404418945312e+01 -1.0800999641418457e+01 2.7713001251220703e+01 -8.4867797851562500e+01 -1.2569499969482422e+01 2.7100799560546875e+01 -3.1758199691772461e+01 2.0571800231933594e+01 -2.4306600570678711e+01 -2.9592399597167969e+01 2.7388601303100586e+01 -2.1954000473022461e+01 -2.8733600616455078e+01 1.9363800048828125e+01 -2.4038000106811523e+01 -8.3058799743652344e+01 1.3686300277709961e+01 2.5666900634765625e+01 -8.5035003662109375e+01 6.3558301925659180e+00 2.5674098968505859e+01 -7.1587898254394531e+01 3.3174499511718750e+01 2.1690000534057617e+01 -6.8256202697753906e+01 3.4979999542236328e+01 2.1093599319458008e+01 -6.9966796875000000e+01 3.4713600158691406e+01 1.9631198883056641e+01 -5.3734598159790039e+00 9.3850593566894531e+00 -1.3516600608825684e+01 -4.5868897438049316e+00 2.1889400482177734e+01 -1.3294899940490723e+01 -9.3643701076507568e-01 -1.2331299781799316e+00 -1.3162500381469727e+01 -6.4110900878906250e+01 3.3581001281738281e+01 -2.2046899795532227e+01 -6.3890895843505859e+01 3.4450099945068359e+01 -2.1590299606323242e+01 -2.2416999816894531e+01 2.5918298721313477e+01 -2.0565500259399414e+01 -2.1139299392700195e+01 2.0317699432373047e+01 -2.1121301651000977e+01 -1.2585000038146973e+01 2.6100500106811523e+01 -1.4657299995422363e+01 -1.4178999900817871e+01 2.6742898941040039e+01 -1.3717199325561523e+01 -2.5169300079345703e+01 3.6497998237609863e-01 -2.6374399185180664e+01 -2.8175498962402344e+01 1.5697500705718994e+00 -2.7393899917602539e+01 -9.6048898696899414e+00 2.5772399902343750e+01 -1.2623800277709961e+01 -1.4514900207519531e+01 -4.0288496017456055e+00 -8.1216001510620117e+00 -3.2789901733398438e+01 3.0060899734497070e+01 -1.7758699417114258e+01 -2.2868999481201172e+01 -5.2620897293090820e+00 2.4482398986816406e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 1.1451100349426270e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 -4.6423501968383789e+00 2.4698100090026855e+00 -1.3937099456787109e+01 -8.7694101333618164e+00 1.3559999465942383e+00 -1.3735700607299805e+01 -8.7694101333618164e+00 -7.2062995910644531e+01 3.3286300659179688e+01 2.0510700225830078e+01 -2.1232500076293945e+01 2.6503099441528320e+01 -1.9953899383544922e+01 -1.5564300537109375e+01 2.5595899581909180e+01 -1.7409900665283203e+01 -1.6401000976562500e+01 2.4625801086425781e+01 -1.8170499801635742e+01 -1.1733599662780762e+01 -9.2020101547241211e+00 3.9287097454071045e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 8.7694005966186523e+00 -1.1136300086975098e+01 -9.8672695159912109e+00 -3.1021800041198730e+00 -1.1920199394226074e+01 -8.9085302352905273e+00 -8.3831701278686523e+00 -1.1295700073242188e+01 -9.6952896118164062e+00 -8.7694101333618164e+00 -8.8484201431274414e+00 -1.0371999740600586e+01 -1.0295099258422852e+01 -6.5542902946472168e+00 -1.0829599380493164e+01 -1.0302700042724609e+01 -7.0307302474975586e+00 2.5468399047851562e+01 6.5915398597717285e+00 -1.4179100036621094e+01 2.6742898941040039e+01 1.3717199325561523e+01 -7.0307302474975586e+00 2.5468399047851562e+01 1.0730800628662109e+01 1.7999500274658203e+01 -2.8110098838806152e+00 -1.0229700088500977e+01 -5.0236697196960449e+00 -2.6851301193237305e+00 -1.2880999565124512e+01 -5.3248100280761719e+00 -1.9142800569534302e+00 -1.3434800148010254e+01 -3.2349998950958252e+00 2.4259799957275391e+01 -1.1439999580383301e+01 -3.9967998504638672e+01 3.0895101547241211e+01 2.0772499084472656e+01 -3.2330902099609375e+01 2.9474100112915039e+01 2.0962800979614258e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -5.1695203781127930e-01 -5.4393699645996094e+01 -1.1380000114440918e+01 2.8026699066162109e+01 -2.2231201171875000e+01 1.2556499242782593e+00 -2.4675800323486328e+01 -8.9134998321533203e+00 -1.0206200599670410e+01 -1.1205100059509277e+01 -1.6373800277709961e+01 2.4622798919677734e+01 1.8157501220703125e+01 -2.0687799453735352e+01 -5.2614102363586426e+00 2.1774700164794922e+01 1.5323800086975098e+01 -4.1637501716613770e+00 -1.3162500381469727e+01 1.5431400299072266e+01 -4.6149396896362305e+00 -1.3162500381469727e+01 1.4017400741577148e+01 -5.5252099037170410e+00 -1.3162500381469727e+01 -1.7720899581909180e+01 1.3928599357604980e+01 2.0123699188232422e+01 -1.3107599258422852e+01 2.3883600234985352e+01 1.6286199569702148e+01 -3.1628799438476562e+01 -8.4871101379394531e+00 -1.9451400756835938e+01 -8.5964797973632812e+01 -1.1868500709533691e+00 -2.5676300048828125e+01 -8.5881393432617188e+01 -6.9067101478576660e+00 -2.6386400222778320e+01 -8.6083892822265625e+01 -5.1130099296569824e+00 -2.5666900634765625e+01 -8.0267700195312500e+01 1.2764199256896973e+01 -2.8096899032592773e+01 -7.9344696044921875e+01 1.5972599029541016e+01 -2.7999799728393555e+01 -6.8686302185058594e+01 1.3177599906921387e+01 -2.8035299301147461e+01 -3.4678499698638916e+00 2.4546600341796875e+01 1.0226399421691895e+01 -6.8465900421142578e+00 2.5434799194335938e+01 1.0693900108337402e+01 5.3050603866577148e+00 -1.0234899520874023e+01 1.2282799720764160e+01 5.4755702018737793e+00 -1.0288099288940430e+01 1.1643799781799316e+01 -2.3418100357055664e+01 -3.4390799999237061e+00 2.5626100540161133e+01 -2.3448501586914062e+01 -3.2784798145294189e+00 2.5642599105834961e+01 -8.2882400512695312e+01 -1.0574700355529785e+01 2.8096899032592773e+01 -3.2887599945068359e+01 -5.3357300758361816e+00 -2.8096899032592773e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 7.9923099279403687e-01 -1.2487700462341309e+01 -3.8984899520874023e+00 3.2551601529121399e-01 -8.2080101013183594e+01 -1.7292600631713867e+01 2.5666900634765625e+01 -8.0811302185058594e+01 -1.8070999145507812e+01 2.5639598846435547e+01 -8.1527099609375000e+01 -1.7308099746704102e+01 2.6616500854492188e+01 -8.3500305175781250e+01 -1.2953100204467773e+01 -2.7934499740600586e+01 -8.4759696960449219e+01 -1.0734800338745117e+01 -2.7460899353027344e+01 -4.1574902534484863e+00 -1.0894499778747559e+01 1.1716500282287598e+01 -8.5376605987548828e+00 -1.0257399559020996e+01 1.1212699890136719e+01 -5.0540599822998047e+00 -1.1139400482177734e+01 1.0868499755859375e+01 -6.4351997375488281e+01 1.2023900032043457e+01 2.8055299758911133e+01 -6.6457595825195312e+01 3.5751899719238281e+01 -1.9767801284790039e+01 -6.5414596557617188e+01 1.6021900177001953e+01 2.7626399993896484e+01 -7.7686401367187500e+01 -1.8971700668334961e+01 2.5795400619506836e+01 -7.7796401977539062e+01 -1.8792200088500977e+01 2.6459199905395508e+01 -7.9663406372070312e+01 2.1549299240112305e+01 -2.5176801681518555e+01 -7.7815803527832031e+01 2.4162700653076172e+01 -2.5170400619506836e+01 -8.0238800048828125e+01 2.0285900115966797e+01 -2.5552999496459961e+01 -8.0270500183105469e+01 2.0207399368286133e+01 2.2489600181579590e+00 4.8787798881530762e+00 -1.0104199409484863e+01 -1.2581200599670410e+01 5.1955399513244629e+00 -1.0201799392700195e+01 -1.2359499931335449e+01 -1.7269599914550781e+01 -2.7614200115203857e+00 2.0761899948120117e+01 -1.8656398773193359e+01 -2.3088200092315674e+00 2.2057399749755859e+01 -1.8927799224853516e+01 -4.4864702224731445e+00 2.1103000640869141e+01 -1.1295700073242188e+01 -9.6952896118164062e+00 8.7694101333618164e+00 3.4292600154876709e+00 -1.3637700080871582e+01 -8.3823099136352539e+00 3.2828400135040283e+00 -1.3691499710083008e+01 -4.4710597991943359e+00 -1.0954899787902832e+01 -9.9566106796264648e+00 4.3614101409912109e+00 9.4770300388336182e-01 2.2524200439453125e+01 -1.0229899406433105e+01 1.3160300254821777e+00 -1.3715700149536133e+01 -9.1459999084472656e+00 -3.4076000213623047e+01 3.0211999893188477e+01 -1.9965900421142578e+01 -3.2286403656005859e+01 2.9720199584960938e+01 -2.0481201171875000e+01 -3.7879798889160156e+01 3.0309301376342773e+01 -2.1135299682617188e+01 -2.6406499862670898e+01 -7.8242998123168945e+00 1.9237300872802734e+01 -1.4515699386596680e+01 -4.0267701148986816e+00 1.1472999572753906e+01 -1.9121200561523438e+01 -5.1631298065185547e+00 -1.6200000762939453e+01 -1.8723299026489258e+01 -4.9519901275634766e+00 -1.6200000762939453e+01 -1.3659000396728516e+01 -3.7333600521087646e+00 -1.0100999832153320e+01 -1.3369699478149414e+01 -3.6811499595642090e+00 -1.5818199157714844e+01 -7.2312301635742188e+01 3.3093002319335938e+01 1.3019000053405762e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 -1.6200000762939453e+01 -3.0809600830078125e+01 -1.3216799736022949e+01 1.6199798583984375e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 -6.8087697029113770e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -7.2823896408081055e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -7.7019901275634766e+00 -3.1619102478027344e+01 -9.1428298950195312e+00 1.9237499237060547e+01 -2.8657798767089844e+01 -7.6556901931762695e+00 1.9496599197387695e+01 -7.9056901931762695e+00 -6.1648502349853516e+00 1.2403100013732910e+01 -8.1184898376464844e+01 1.8335500717163086e+01 -2.5733100891113281e+01 -1.2484200477600098e+01 -3.9098398685455322e+00 1.0575200080871582e+01 -1.0217400550842285e+01 -1.0161899566650391e+01 -9.1455993652343750e+00 -1.1837100028991699e+01 -9.0069694519042969e+00 -9.6961002349853516e+00 -1.0723400115966797e+01 -9.2629899978637695e+00 -1.1413799285888672e+01 -3.0947000503540039e+01 6.8715701103210449e+00 -2.7576299667358398e+01 1.4017400741577148e+01 -5.5252299308776855e+00 1.3162500381469727e+01 1.5323800086975098e+01 -4.1637501716613770e+00 1.3162500381469727e+01 3.5189900398254395e+00 -1.2387099266052246e+01 -1.0975000381469727e+01 2.7276201248168945e+00 -1.2909700393676758e+01 -1.1376399993896484e+01 2.0134000778198242e+00 -1.1841899871826172e+01 -1.2109000205993652e+01 -9.9629602432250977e+00 -3.9463801383972168e+00 -1.2822000503540039e+01 -5.1284399032592773e+00 -3.3915398120880127e+00 -1.2656300544738770e+01 -8.4990898132324219e+01 4.6578397750854492e+00 -2.6591299057006836e+01 -8.3480400085449219e+01 8.3210201263427734e+00 -2.7478899002075195e+01 -7.9436500549316406e+01 -1.7295799255371094e+01 2.7633199691772461e+01 1.4097799301147461e+01 -8.5582199096679688e+00 -1.0974300384521484e+01 1.4471399307250977e+01 -8.6752099990844727e+00 -9.8253202438354492e+00 1.2776300430297852e+01 -8.2544794082641602e+00 -1.0229800224304199e+01 5.4755702018737793e+00 -1.0288099288940430e+01 -1.1643799781799316e+01 3.9121499061584473e+00 -9.8083105087280273e+00 -1.1604000091552734e+01 -3.2194900512695312e+01 -8.1703805923461914e+00 -2.5740800857543945e+01 -2.8270698547363281e+01 -7.1634702682495117e+00 -2.5726100921630859e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.9889199733734131e+00 -1.2468999862670898e+01 -3.9723799228668213e+00 3.0948998928070068e+00 7.8375797271728516e+00 -6.3176698684692383e+00 1.0229800224304199e+01 -3.2373802185058594e+01 -7.4179096221923828e+00 2.7315099716186523e+01 -6.8786296844482422e+00 2.2554998397827148e+01 -1.3689200401306152e+01 -1.0217400550842285e+01 -1.0161899566650391e+01 9.1456098556518555e+00 -1.0972799301147461e+01 -9.8318595886230469e+00 1.0179499626159668e+01 -2.7397800445556641e+01 -4.1198697090148926e+00 2.7423400878906250e+01 -7.5310699462890625e+01 2.9075099945068359e+01 2.2331199645996094e+01 -7.6789695739746094e+01 2.6851900100708008e+01 2.3179199218750000e+01 7.0728302001953125e+00 -6.1602401733398438e+00 1.1267999649047852e+01 -3.8524200439453125e+01 -6.7241401672363281e+00 2.8097499847412109e+01 -4.0985801696777344e+01 -8.4421596527099609e+00 2.7926500320434570e+01 -8.5338500976562500e+01 4.3485999107360840e-01 -2.6955900192260742e+01 -7.4673599243164062e+01 2.5458698272705078e+01 2.5446899414062500e+01 -2.1543800354003906e+01 -5.6311798095703125e+00 -2.1169200897216797e+01 -1.2469099998474121e+01 -3.9723901748657227e+00 -7.7372398376464844e+00 -1.2491400718688965e+01 -3.8886401653289795e+00 -8.3463201522827148e+00 -2.4159500122070312e+01 -6.2754898071289062e+00 -2.2972999572753906e+01 -3.1634099960327148e+01 -8.1166400909423828e+00 -2.0250000000000000e+01 -2.1872001647949219e+01 -3.6640801429748535e+00 2.4625801086425781e+01 -1.8115199804306030e+00 -1.2297200202941895e+01 -1.1544100046157837e+00 -1.2392800331115723e+01 -4.2737202644348145e+00 1.2936100006103516e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.4174999237060547e+01 6.1715998649597168e+00 -8.0292997360229492e+00 -1.1643799781799316e+01 -4.6267498016357422e+01 -1.1364599227905273e+01 2.6522500991821289e+01 -2.0308200836181641e+01 -5.3378500938415527e+00 1.6200000762939453e+01 1.6434799194335938e+01 -8.0008001327514648e+00 -1.1106800079345703e+01 -2.9465299606323242e+01 -1.3595799446105957e+01 -1.6200000762939453e+01 4.7463798522949219e+00 -1.0064300537109375e+01 1.0486200332641602e+01 4.9977498054504395e+00 -1.0140899658203125e+01 8.8615293502807617e+00 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.0824300765991211e+01 -7.3093101501464844e+01 3.1947500228881836e+01 2.1611099243164062e+01 -1.3649499893188477e+01 2.0166198730468750e+01 1.6796400070190430e+01 -1.4594299316406250e+01 1.1992500305175781e+01 1.7900100708007812e+01 -2.0471099853515625e+01 -5.3669600486755371e+00 -2.0250000000000000e+01 -8.1364402770996094e+01 1.3131000518798828e+01 2.7924800872802734e+01 -8.4118301391601562e+01 2.4903000891208649e-01 2.7910200119018555e+01 -1.8723299026489258e+01 -4.9519901275634766e+00 1.6200000762939453e+01 -1.9121099472045898e+01 -5.1630897521972656e+00 1.6200000762939453e+01 -2.2204599380493164e+00 2.4079299926757812e+01 -1.0228199958801270e+01 -9.5017600059509277e-01 2.3519701004028320e+01 1.0229700088500977e+01 -9.5017600059509277e-01 2.3519701004028320e+01 -1.0229800224304199e+01 -2.2204599380493164e+00 2.4079299926757812e+01 1.0228199958801270e+01 -1.8619499206542969e+01 1.0543999671936035e+00 -2.1860898971557617e+01 -1.6382200241088867e+01 1.3128899574279785e+01 -1.9254699707031250e+01 7.8754200935363770e+00 -6.1899800300598145e+00 1.0834399223327637e+01 -1.1968599319458008e+01 -4.9128999710083008e+00 1.2656300544738770e+01 -8.1316902160644531e+01 -1.7834100723266602e+01 -5.7058101892471313e-01 -8.1432899475097656e+01 -1.7731700897216797e+01 9.8030796051025391e+00 -7.9688804626464844e+01 -1.8525798797607422e+01 1.2558599472045898e+01 -8.3561798095703125e+01 -1.6003499984741211e+01 -1.7607400894165039e+01 -8.2080101013183594e+01 -1.7292600631713867e+01 -2.5666900634765625e+01 -7.4880401611328125e+01 -1.8242099761962891e+01 2.6841800689697266e+01 -7.7240798950195312e+01 -1.7425498962402344e+01 2.7850198745727539e+01 -8.3054100036621094e+01 1.3700300216674805e+01 -2.5666900634765625e+01 6.5172100067138672e+00 -5.2400598526000977e+00 -1.2515299797058105e+01 1.3856300354003906e+01 -8.6082496643066406e+00 -5.6883196830749512e+00 -7.4771903991699219e+01 -1.8679899215698242e+01 -9.7939796447753906e+00 -7.5627700805664062e+01 -1.8856300354003906e+01 -6.6064101457595825e-01 -1.8680601119995117e+01 -4.9415903091430664e+00 -1.5576899528503418e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.2886400222778320e+00 -7.0791000366210938e+01 3.4229801177978516e+01 1.2186399459838867e+01 -6.9940795898437500e+01 3.4720802307128906e+01 -3.3461299538612366e-01 -7.2171600341796875e+01 3.3224800109863281e+01 1.0406699180603027e+00 -6.4094703674316406e+01 3.3578197479248047e+01 -2.2046899795532227e+01 -1.2100500106811523e+01 -9.9917197227478027e-01 1.6574199676513672e+01 4.2148599624633789e+00 2.0214399337768555e+01 4.3156399726867676e+00 -7.4685699462890625e+01 -1.6565099716186523e+01 2.7998899459838867e+01 7.3976602554321289e+00 -3.0381901264190674e+00 1.3162399291992188e+01 9.2621002197265625e+00 1.4340699195861816e+01 1.0230099678039551e+01 8.2847900390625000e+00 1.5479100227355957e+01 1.1488699913024902e+01 1.9050099849700928e+00 1.9417699813842773e+01 -1.3059399604797363e+01 -1.7540600299835205e+00 2.1827699661254883e+01 -1.2974999427795410e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 -1.1451100349426270e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.2562399864196777e+01 -6.7094001770019531e+01 3.5633499145507812e+01 1.9204199314117432e+00 -6.9141998291015625e+01 3.5073398590087891e+01 1.0676899909973145e+01 -5.8862102508544922e+01 -1.4758200645446777e+01 -2.5771200180053711e+01 -6.6752700805664062e+01 -1.6404199600219727e+01 -2.6540199279785156e+01 -5.7855300903320312e+01 -1.4107700347900391e+01 -2.6716400146484375e+01 1.8461599349975586e+01 -4.4659600257873535e+00 4.0511398315429688e+00 -6.7801803588867188e+01 2.2013500213623047e+01 -2.6201400756835938e+01 -7.4673599243164062e+01 2.5458698272705078e+01 -2.5446899414062500e+01 3.1772801876068115e+00 1.6965400695800781e+01 1.3166399955749512e+01 -7.9464698791503906e+01 -1.6842800140380859e+01 -2.7888599395751953e+01 -8.0379997253417969e+01 -1.4894800186157227e+01 -2.8096899032592773e+01 -6.6855001449584961e+00 2.3976100921630859e+01 -1.3298200607299805e+01 -7.5794796943664551e+00 2.2704200744628906e+01 -1.3865099906921387e+01 -1.1248499870300293e+01 -5.1348104476928711e+00 -8.8615293502807617e+00 1.7053899765014648e+01 -4.5799903869628906e+00 1.2750299453735352e+01 -9.6793699264526367e+00 -7.8165602684020996e-01 1.5179299354553223e+01 -9.2741994857788086e+00 -2.1737599372863770e+00 1.4671999931335449e+01 1.6998899459838867e+01 -6.2526502609252930e+00 -1.2577199935913086e+01 1.5033500671386719e+01 -6.3609900474548340e+00 -1.3092599868774414e+01 1.7478500366210938e+01 -5.1903200149536133e+00 -1.2537400245666504e+01 -1.1825799942016602e+01 -2.5406200885772705e+00 1.5898799896240234e+01 -7.7610099792480469e+01 2.2007999420166016e+01 2.6670200347900391e+01 -7.7864997863769531e+01 2.4162899017333984e+01 2.5080999374389648e+01 -1.8674098968505859e+01 -2.1953301429748535e+00 -2.2069599151611328e+01 -2.0307800292968750e+01 1.5372200012207031e+01 2.1515800476074219e+01 -2.0569900512695312e+01 -6.4211702346801758e+00 -1.9237499237060547e+01 1.0173600196838379e+01 1.2668499946594238e+01 -1.0229700088500977e+01 -8.5624000549316406e+01 -1.2087100028991699e+01 -1.9766099929809570e+01 1.8035499572753906e+01 -6.2667803764343262e+00 -1.1057900428771973e+01 -1.8145300149917603e+00 2.1698999404907227e+01 1.3026299476623535e+01 9.1821396350860596e-01 2.1643299102783203e+01 1.2238900184631348e+01 -1.0127799987792969e+01 -3.3894300460815430e+00 1.3818900108337402e+01 -1.0800699234008789e+01 -5.2727899551391602e+00 -1.0632800102233887e+01 -1.1968599319458008e+01 -4.9128999710083008e+00 -1.2656300544738770e+01 -3.5346199035644531e+01 7.1104402542114258e+00 -2.8034200668334961e+01 -4.5793701171875000e+01 3.2309902191162109e+01 1.9889099121093750e+01 -2.1853099822998047e+01 -5.7073702812194824e+00 -2.0932600021362305e+01 -7.4651397705078125e+01 2.7210699081420898e+01 2.4724800109863281e+01 -7.5132499694824219e+01 2.8274499893188477e+01 2.3792798995971680e+01 -1.2259400367736816e+01 -4.8232898712158203e+00 -1.2660400390625000e+01 -9.0257501602172852e+00 -7.4893897771835327e-01 -1.4873800277709961e+01 -3.4678499698638916e+00 2.4546600341796875e+01 -1.0226300239562988e+01 -2.1972099304199219e+01 2.8044799804687500e+01 1.8302000045776367e+01 1.2765799522399902e+01 -4.9755697250366211e+00 -1.3162500381469727e+01 9.8834295272827148e+00 6.5972900390625000e+00 -1.3162599563598633e+01 -3.2600399017333984e+01 2.7963298797607422e+01 2.2046899795532227e+01 5.3409199714660645e+00 -3.1408400535583496e+00 -1.3085200309753418e+01 -2.1136699676513672e+01 -5.5309100151062012e+00 2.0822700500488281e+01 -1.1248499870300293e+01 -5.1348104476928711e+00 8.8615293502807617e+00 3.5155498981475830e+00 -1.3290500640869141e+01 1.0145500183105469e+01 4.1435799598693848e+00 -1.2604000091552734e+01 8.7694005966186523e+00 -1.2528200149536133e+01 -3.8404700756072998e+00 1.0844699144363403e+00 -3.2696197509765625e+01 9.6085901260375977e+00 -2.7570400238037109e+01 -9.0257501602172852e+00 -7.4893897771835327e-01 1.4873800277709961e+01 -8.8467397689819336e+00 -9.2061595916748047e+00 -1.2156000137329102e+01 -6.4980903625488281e+01 3.5738899230957031e+01 4.7488999366760254e+00 -2.0951200485229492e+01 -6.7523698806762695e+00 -1.7952001571655273e+01 -1.2468999862670898e+01 -3.9723701477050781e+00 4.6423501968383789e+00 -2.3418199539184570e+01 -3.4390799999237061e+00 -2.5625900268554688e+01 -2.5539800643920898e+01 -5.7666797637939453e+00 -2.5933300018310547e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 -1.1211000442504883e+01 1.8064201354980469e+01 -3.8077600002288818e+00 -1.1699000358581543e+01 -1.7263299942016602e+01 -2.5184898376464844e+00 -2.0802299499511719e+01 -1.2420499801635742e+01 -4.1591300964355469e+00 4.3063297271728516e+00 -2.0569900512695312e+01 -6.4211797714233398e+00 1.9237499237060547e+01 -2.0274599075317383e+01 -6.1647500991821289e+00 1.9253698348999023e+01 -3.1579498291015625e+01 -1.1716900825500488e+01 -1.9237499237060547e+01 -3.1538299560546875e+01 -1.2062000274658203e+01 -1.7867500305175781e+01 5.4755702018737793e+00 -1.0288099288940430e+01 -1.4281799793243408e+00 -8.2882400512695312e+01 -1.0574700355529785e+01 -2.8096899032592773e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 2.0250000000000000e+01 -3.3957599639892578e+01 2.2076699733734131e+00 -2.8097000122070312e+01 -7.1406898498535156e+01 3.3811698913574219e+01 -1.0665699958801270e+01 -7.2553596496582031e+01 3.2843196868896484e+01 -1.1039799690246582e+01 -8.4824501037597656e+01 -1.4209400177001953e+01 -1.7676399230957031e+01 -3.1318798065185547e+01 2.0398700714111328e+01 2.4274200439453125e+01 -2.6977600097656250e+01 1.8610399246215820e+01 2.3734500885009766e+01 -2.7629499435424805e+01 2.6979400634765625e+01 2.1713800430297852e+01 -7.5557098388671875e+01 2.8117698669433594e+01 -2.3519599914550781e+01 -8.3045700073242188e+01 -8.4699592590332031e+00 -2.8096899032592773e+01 -1.2279800176620483e+00 2.2933200836181641e+01 1.2090600013732910e+01 -4.3032598495483398e+00 -1.1460499763488770e+01 1.0306200027465820e+01 -4.2065896987915039e+00 -1.1490400314331055e+01 1.0306200027465820e+01 -3.5070602416992188e+01 2.1786800384521484e+01 -2.4295400619506836e+01 -3.2600399017333984e+01 2.7963100433349609e+01 -2.2046899795532227e+01 -3.0197000503540039e+01 -6.8118801116943359e+00 -2.7204399108886719e+01 -2.0253499984741211e+01 -5.3109297752380371e+00 -2.0218898773193359e+01 -3.2878101348876953e+01 9.3289098739624023e+00 2.7645900726318359e+01 -8.5834098815917969e+01 -7.2901301383972168e+00 2.6437700271606445e+01 -8.6083892822265625e+01 -5.1130099296569824e+00 2.5666900634765625e+01 -8.6002799987792969e+01 -8.5538406372070312e+00 2.5668899536132812e+01 -4.3032598495483398e+00 -1.1460499763488770e+01 -1.0306200027465820e+01 -3.7239401340484619e+00 -1.1649600028991699e+01 -1.0305799484252930e+01 -3.6514399051666260e+00 -1.1667500495910645e+01 -1.0304599761962891e+01 -3.2975799560546875e+01 -3.8400099277496338e+00 2.8096899032592773e+01 -3.2887599945068359e+01 -5.3357300758361816e+00 2.8096899032592773e+01 -2.4160200119018555e+01 -6.2756600379943848e+00 1.6200000762939453e+01 -3.7348401546478271e+00 -9.6158704757690430e+00 1.2329899787902832e+01 -3.4674800872802734e+01 1.4640600204467773e+01 -2.6576499938964844e+01 -2.5977300643920898e+01 -7.0095701217651367e+00 -1.9470499038696289e+01 -3.1917098999023438e+01 2.6032500267028809e+00 -2.8021100997924805e+01 -4.0303600311279297e+01 2.9336700439453125e+01 -2.2047401428222656e+01 -5.2587200164794922e+01 3.1526498794555664e+01 -2.2046899795532227e+01 -1.2900600433349609e+01 -3.6866500377655029e+00 -1.4267199516296387e+01 -3.7007598876953125e+01 1.6523199081420898e+01 -2.6201299667358398e+01 -8.0504699707031250e+01 -1.7846899032592773e+01 -2.6673799514770508e+01 6.5892200469970703e+00 -6.6740202903747559e+00 -1.1643799781799316e+01 1.3160300254821777e+00 -1.3715700149536133e+01 9.1459999084472656e+00 5.4230195283889771e-01 -1.3339400291442871e+01 -1.0186499595642090e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 2.6891999244689941e+00 -1.8805799484252930e+01 -4.9762101173400879e+00 1.6808599472045898e+01 -1.8677999496459961e+01 -4.9410200119018555e+00 1.8645801544189453e+01 4.1435799598693848e+00 -1.2604000091552734e+01 0.0000000000000000e+00 4.9977498054504395e+00 -1.0140899658203125e+01 3.7186799049377441e+00 4.9977498054504395e+00 -1.0140899658203125e+01 -8.8615293502807617e+00 4.1435799598693848e+00 -1.2604000091552734e+01 -8.7694005966186523e+00 -8.0861595153808594e+01 -1.4468800544738770e+01 2.8099199295043945e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 1.5576899528503418e+01 1.8025800704956055e+01 -2.8638198375701904e+00 -1.8640899658203125e+00 -8.5711204528808594e+01 1.5585000514984131e+00 -2.5666900634765625e+01 -3.8664299011230469e+01 -9.7858705520629883e+00 -2.5666900634765625e+01 -4.5768001556396484e+01 -1.1208900451660156e+01 -2.6579498291015625e+01 -7.2385307312011719e+01 3.1241298675537109e+01 -2.3072099685668945e+01 2.7172601222991943e+00 2.1455699920654297e+01 9.9170894622802734e+00 -6.4094703674316406e+01 3.3578197479248047e+01 2.2046899795532227e+01 -1.0621700286865234e+01 -9.1452493667602539e+00 1.1563099861145020e+01 -2.3368301391601562e+01 -5.4110898971557617e+00 -2.4809200286865234e+01 -7.0307302474975586e+00 2.5468399047851562e+01 -7.1406497955322266e+00 -8.2216102600097656e+01 1.6069200515747070e+01 5.7170400619506836e+00 -1.2499199867248535e+01 -3.8734200000762939e+00 9.4482898712158203e+00 -1.2490699768066406e+01 -3.8924100399017334e+00 -3.3666701316833496e+00 -8.3060401916503906e+01 1.3686800003051758e+01 1.6274000167846680e+01 -8.3054100036621094e+01 1.3700300216674805e+01 2.5666900634765625e+01 -8.3058799743652344e+01 1.3686300277709961e+01 -2.5666900634765625e+01 -7.6187500000000000e+01 -1.8943000793457031e+01 1.8149898529052734e+01 -8.6044700622558594e+01 -2.5542399883270264e+00 3.6043100357055664e+00 -8.5937301635742188e+01 -8.1713896989822388e-01 2.5695800781250000e+01 -7.8908195495605469e+01 -1.8738399505615234e+01 -2.7807998657226562e-01 -7.7226402282714844e+01 -1.8952301025390625e+01 1.0827600479125977e+01 -8.6039001464843750e+01 -7.8893499374389648e+00 -6.7517399787902832e-01 -8.5695495605468750e+01 1.7946900129318237e+00 -9.9244898557662964e-01 -8.2707893371582031e+01 -1.6874198913574219e+01 -8.4668798446655273e+00 -8.4415199279785156e+01 -1.4895499229431152e+01 1.7561300277709961e+01 -7.8498001098632812e+01 -1.8810798645019531e+01 1.8372900009155273e+01 -8.5170501708984375e+01 5.4223003387451172e+00 1.0836700439453125e+01 -3.9489898681640625e+01 3.1162698745727539e+01 -2.0016599655151367e+01 6.9650502204895020e+00 -6.2961602210998535e+00 1.4111299514770508e+00 1.2963500022888184e+01 -7.8590903282165527e+00 1.1816699981689453e+01 -8.2167495727539062e+01 1.6196201324462891e+01 -1.3814499855041504e+01 7.2005200386047363e+00 -6.2607698440551758e+00 -5.2534098625183105e+00 7.7394099235534668e+00 -6.2859597206115723e+00 -7.0418801307678223e+00 -1.1928699493408203e+01 -7.6515102386474609e+00 -8.7694005966186523e+00 1.6019899845123291e+00 2.2163599014282227e+01 4.3230800628662109e+00 -7.0307302474975586e+00 2.5468399047851562e+01 -1.0015199661254883e+01 -3.4272903442382812e+01 1.2446599960327148e+01 2.7127899169921875e+01 -1.2484399795532227e+01 -3.9099199771881104e+00 1.1597700119018555e+01 -7.6556900024414062e+01 -1.5989600181579590e+01 -2.8096899032592773e+01 7.4979400634765625e+00 1.1315800666809082e+01 -1.3162500381469727e+01 1.7743200063705444e+00 -1.6654300689697266e+00 -1.3162500381469727e+01 -5.6050800323486328e+01 3.2143898010253906e+01 -2.2046501159667969e+01 -1.2468999862670898e+01 -3.9723799228668213e+00 5.5708198547363281e+00 3.6702899932861328e+00 -1.3299300193786621e+01 -9.6205396652221680e+00 -4.3236499786376953e+01 -9.9578104019165039e+00 2.7337198257446289e+01 -5.2473796844482422e+01 -1.2130700111389160e+01 -2.7420099258422852e+01 -6.3763603210449219e+01 3.5443500518798828e+01 -2.0199199676513672e+01 -6.6889602661132812e+01 3.5169300079345703e+01 -2.1070100784301758e+01 -1.0937100410461426e+01 2.3413600921630859e+01 1.5065499305725098e+01 1.8118101119995117e+01 -6.0945100784301758e+00 1.0972000122070312e+01 -8.4443199157714844e+01 -1.4854499816894531e+01 -9.4425296783447266e+00 -5.7554101943969727e+00 -1.1038000106811523e+01 1.0308400154113770e+01 -2.9934400558471680e+01 -1.1625800132751465e+01 -1.9237499237060547e+01 3.7036798000335693e+00 -1.3349900245666504e+01 8.5235795974731445e+00 1.2869499206542969e+01 -8.2948493957519531e+00 -1.4541900157928467e+00 1.3971300125122070e+01 -8.6322698593139648e+00 9.0816795825958252e-01 1.8016201019287109e+01 -6.4611701965332031e+00 -5.0233302116394043e+00 1.8278699874877930e+01 -5.8155899047851562e+00 3.9653798937797546e-01 -8.5030097961425781e+01 -6.9620103836059570e+00 2.7464399337768555e+01 1.9063199758529663e+00 -1.2481399536132812e+01 1.2013400077819824e+01 -9.8575506210327148e+00 -8.1238298416137695e+00 1.2062000274658203e+01 -2.2471500396728516e+01 -5.6958599090576172e+00 -2.3190601348876953e+01 -2.0458801269531250e+01 1.5454299926757812e+01 -2.1590900421142578e+01 -8.5711204528808594e+01 1.5585000514984131e+00 2.5666900634765625e+01 -7.8688301086425781e+01 1.7159898757934570e+01 2.7824800491333008e+01 -3.0506299972534180e+01 2.7548599243164062e+01 2.1996099472045898e+01 -1.8680601119995117e+01 -4.9415903091430664e+00 1.6200000762939453e+01 1.8381200790405273e+01 -3.7917900085449219e+00 7.5998598337173462e-01 -7.4819496154785156e+01 2.7081100463867188e+01 -2.4762300491333008e+01 -2.9883800506591797e+01 -3.6574599742889404e+00 2.7899700164794922e+01 -2.5053699493408203e+01 -6.9892301559448242e+00 1.9359899520874023e+01 2.0604398250579834e+00 -1.3875300407409668e+01 -1.0187500000000000e+01 -6.8339897155761719e+01 3.5352901458740234e+01 -7.4738702774047852e+00 -7.0307302474975586e+00 2.5468399047851562e+01 -4.2167601585388184e+00 -1.8669198989868164e+01 1.4469600677490234e+01 -2.0667400360107422e+01 -1.3715800285339355e+01 2.6531400680541992e+01 1.4534399986267090e+01 1.4554799079895020e+01 -7.8870701789855957e+00 -1.2254600524902344e+01 -2.5937799453735352e+01 -3.4249598979949951e+00 2.6824901580810547e+01 -1.1792400360107422e+01 -1.8972599506378174e+00 -1.6251201629638672e+01 -1.1929100036621094e+01 -8.4870595932006836e+00 9.6228895187377930e+00 3.8926100730895996e+00 -1.3110199928283691e+01 4.5864601135253906e+00 -1.2007099151611328e+01 -8.2018299102783203e+00 -4.3791403770446777e+00 1.5308300018310547e+01 -5.0949902534484863e+00 -1.3162500381469727e+01 -8.2356803894042969e+01 -1.6340200424194336e+01 -2.7129499435424805e+01 -9.6793699264526367e+00 -7.8165602684020996e-01 -1.5179299354553223e+01 -3.2233699798583984e+01 -8.0123805999755859e+00 -2.6198598861694336e+01 -1.2804200172424316e+01 2.5236200332641602e+01 1.5723800659179688e+01 -7.6621002197265625e+01 2.3808599472045898e+01 -2.6010200500488281e+01 -8.5190994262695312e+01 -1.3430399894714355e+01 9.0667800903320312e+00 -7.6371398925781250e+01 -1.8959999084472656e+01 -1.2674399375915527e+01 -7.7428604125976562e+01 -1.8959300994873047e+01 -3.9070899486541748e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6000 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -7.5310699641704559e+01 2.9075099155306816e+01 -2.2331200540065765e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector -6.5423101186752319e+01 3.5773199051618576e+01 -1.8596099689602852e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01) (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01) (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector -4.0303599089384079e+01 2.9336700215935707e+01 -2.2047400474548340e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0235599474981427e+00 2.2340299561619759e+01 -1.1137999594211578e+01) (float-vector -2.2416999563574791e+01 2.5918299332261086e+01 -2.0565500482916832e+01) (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector 9.9552599713206291e+00 1.2558500282466412e+01 -1.1385199613869190e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01) (float-vector 2.4698099587112665e+00 -1.3937099836766720e+01 8.7694097310304642e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector -3.2696198672056198e+01 9.6085900440812111e+00 -2.7570400387048721e+01) (float-vector -7.9344697296619415e+01 1.5972599387168884e+01 -2.7999799698591232e+01) (float-vector -8.5145100951194763e+01 5.5757798254489899e+00 -2.5662200525403023e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 -1.3875300064682961e+01 -1.0187500156462193e+01) (float-vector 1.6372600570321083e+01 -8.1343604251742363e+00 -1.0082700289785862e+01) (float-vector 1.5431400388479233e+01 -4.6149399131536484e+00 -1.3162500225007534e+01) (float-vector -3.2659899443387985e+01 -6.2573798932135105e+00 -2.7959700673818588e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01) (float-vector -7.4860200285911560e+01 -1.8286399543285370e+01 -2.6814900338649750e+01) (float-vector -8.5344798862934113e+01 -1.3159300200641155e+01 -2.5675499811768532e+01) (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5030399262905121e+01 -1.3849199749529362e+01 2.5683199986815453e+01) (float-vector -8.3054102957248688e+01 1.3700299896299839e+01 2.5666899979114532e+01) (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01) (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector -7.7796399593353271e+01 -1.8792200833559036e+01 2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8688301146030426e+01 1.7159899696707726e+01 2.7824800461530685e+01) (float-vector -7.1587897837162018e+01 3.3174499869346619e+01 2.1689999848604202e+01) (float-vector -6.3738003373146057e+01 3.5578601062297821e+01 1.9171899184584618e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2847904413938522e+00 1.5479099936783314e+01 1.1488700285553932e+01) (float-vector 1.8429599702358246e+01 -4.6149399131536484e+00 1.0229799896478653e+01) (float-vector 1.4841400086879730e+01 -6.6712498664855957e+00 1.3026099652051926e+01) (float-vector -2.9883800074458122e+01 -3.6574599798768759e+00 2.7899699285626411e+01) (float-vector -3.2878100872039795e+01 9.3289101496338844e+00 2.7645900845527649e+01) (float-vector -3.0364299193024635e+01 2.8519000858068466e+01 2.1515799686312675e+01) (float-vector -3.6160200834274292e+00 2.4537000805139542e+01 1.1019499972462654e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_l_finger_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_l_finger_tip_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 9.1370000000000005e+01 4.9500000000000002e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 5 8 0 2 5 8 26 0 0 28 1 26 28 0 2 3 4 2 1 3 2 4 5 3 1 7 3 19 4 19 3 7 4 19 5 18 19 20 19 21 20 19 7 21 5 19 24 24 19 18 18 30 24 31 30 18 20 31 18 20 36 31 20 37 36 21 37 20 7 22 21 21 61 37 22 61 21 38 37 39 37 38 36 37 60 39 37 61 60 22 62 61 62 268 61 268 271 61 61 271 60 23 22 7 23 62 22 23 268 62 6 23 7 63 23 6 63 267 23 267 268 23 6 7 1 1 28 6 6 28 63 57 28 58 27 58 28 27 28 26 63 28 57 55 57 56 57 58 56 55 63 57 56 58 50 49 50 58 49 58 27 55 56 54 54 56 52 52 56 50 53 55 54 53 63 55 53 54 52 51 52 50 51 53 52 48 50 49 48 51 50 51 264 53 48 264 51 264 63 53 264 267 63 261 264 260 261 265 264 264 268 267 265 268 264 260 264 48 259 260 254 259 261 260 254 260 48 258 259 255 255 259 254 258 261 259 247 251 254 251 255 254 48 247 254 252 255 251 255 252 256 256 258 255 257 258 256 257 261 258 252 59 256 59 257 256 41 257 59 41 90 257 257 262 261 90 262 257 262 265 261 90 263 262 262 266 265 263 266 262 265 269 268 266 269 265 263 86 266 266 86 84 266 270 269 84 270 266 88 263 90 88 86 263 84 86 85 86 87 85 86 88 87 81 84 83 84 85 83 84 81 270 270 271 269 270 272 271 81 272 270 80 39 81 81 83 80 272 81 39 83 290 80 83 293 290 83 85 293 80 82 39 290 286 80 80 286 82 39 82 38 60 272 39 271 272 60 269 271 268 79 36 38 38 82 79 82 286 79 78 36 79 79 286 78 29 36 78 31 36 29 32 78 77 29 78 32 286 287 78 78 287 77 29 30 31 32 30 29 11 30 9 32 9 30 34 30 11 30 34 24 9 10 11 10 12 11 11 12 13 13 34 11 14 10 9 14 9 32 14 15 10 15 16 10 10 16 12 12 16 17 12 25 13 12 17 25 5 13 25 5 34 13 25 8 5 24 34 5 8 27 26 27 8 25 25 65 27 65 66 27 27 232 49 66 232 27 65 67 66 65 273 67 25 273 65 67 68 66 68 232 66 67 69 68 67 273 69 69 70 68 70 232 68 69 73 70 69 273 73 73 74 70 74 232 70 72 74 73 74 284 285 74 285 232 72 284 74 284 72 277 285 284 276 276 284 277 232 285 282 282 285 274 274 285 276 274 276 73 276 277 73 73 277 71 71 277 278 277 72 278 71 72 73 278 279 71 71 279 72 278 72 279 273 274 73 274 273 275 275 282 274 129 273 25 280 281 273 273 281 275 129 280 273 281 427 275 275 427 282 128 427 281 128 281 280 128 280 129 126 128 127 128 129 127 310 432 128 432 427 128 309 310 128 126 297 128 128 297 309 423 432 431 426 432 423 426 427 432 431 432 310 423 424 247 247 426 423 423 431 424 424 431 430 430 431 310 424 425 247 424 430 425 425 430 429 429 430 310 425 421 247 425 429 421 421 429 428 315 429 310 428 429 315 314 315 308 308 315 310 315 314 116 116 428 315 310 309 308 308 307 306 308 309 307 306 314 308 309 299 307 299 309 297 306 307 305 307 94 305 307 299 94 297 298 299 298 94 299 297 296 298 291 296 297 126 291 297 298 301 95 298 296 301 95 94 298 295 296 288 288 296 291 296 295 301 291 292 288 292 291 126 124 126 125 126 127 125 124 292 126 288 292 122 122 292 124 122 124 123 124 125 123 125 127 118 121 125 118 123 125 121 127 129 64 118 127 64 64 16 118 16 119 118 119 120 118 120 121 118 120 122 121 122 123 121 120 288 122 119 288 120 76 119 16 76 288 119 16 64 17 16 35 76 15 35 16 75 76 35 75 288 76 35 15 33 33 75 35 32 33 15 14 32 15 32 77 33 75 33 77 77 287 75 75 287 288 289 287 286 289 288 287 290 289 286 289 290 294 290 293 294 303 294 293 289 294 303 85 302 293 293 302 303 289 303 501 302 501 303 301 302 85 301 295 302 289 501 302 289 302 500 295 500 302 87 300 85 301 85 300 95 301 300 89 300 87 95 300 89 88 89 87 88 90 89 90 91 89 93 89 91 93 95 89 94 95 93 92 93 91 92 94 93 90 41 91 91 41 40 40 92 91 40 311 92 311 94 92 305 94 311 99 311 96 305 311 99 96 311 40 40 41 42 42 96 40 41 59 42 42 97 96 42 59 97 97 98 96 98 99 96 98 100 99 304 99 100 304 305 99 306 305 304 304 100 101 101 103 304 103 312 304 304 312 306 98 101 100 98 102 101 102 103 101 102 104 103 236 102 249 104 102 236 102 250 249 98 250 102 104 105 103 104 106 105 236 237 104 104 237 106 234 235 236 235 237 236 236 249 234 235 106 237 106 107 105 235 243 106 243 244 106 106 244 107 239 235 234 239 243 235 238 239 234 234 249 248 234 248 238 242 239 238 242 245 239 239 245 243 245 246 243 243 246 244 245 417 246 242 417 245 241 242 238 242 418 417 242 419 418 241 419 242 246 417 416 416 417 414 417 418 414 244 246 46 246 416 46 46 416 44 44 416 231 416 414 231 43 46 44 43 109 46 109 244 46 107 244 109 107 109 108 43 110 109 109 110 108 107 108 105 108 319 105 110 319 108 110 321 319 43 321 110 316 319 318 103 319 316 105 319 103 319 321 318 318 321 320 320 321 111 111 321 43 312 318 317 316 318 312 318 320 317 103 316 312 312 313 306 312 317 313 313 317 314 317 115 314 317 320 115 115 320 111 114 115 113 113 115 111 116 115 114 314 115 116 313 314 306 116 114 117 117 428 116 229 114 113 229 117 114 111 112 113 229 113 228 228 113 112 111 43 112 43 45 112 228 112 45 45 231 228 360 229 228 348 360 228 231 348 228 43 44 45 44 231 45 348 231 414 348 414 454 457 454 414 418 477 414 457 414 439 414 477 439 435 457 439 454 457 435 436 435 439 439 481 436 420 481 439 477 420 439 418 419 477 477 419 415 415 420 477 420 421 422 415 421 420 422 433 420 433 481 420 240 415 241 415 419 241 240 421 415 247 421 240 421 428 422 428 433 422 117 433 428 230 433 117 433 229 481 230 229 433 229 230 117 360 483 229 483 487 229 487 481 229 436 481 451 481 480 451 487 480 481 487 488 480 487 495 488 495 487 483 480 479 451 479 480 488 451 445 436 446 445 451 451 479 446 446 479 478 489 479 488 478 479 491 491 479 489 488 493 489 488 495 493 493 495 494 483 494 495 492 493 494 493 496 489 493 497 496 493 492 497 490 491 489 489 496 490 496 497 475 496 475 499 490 496 499 497 476 475 497 498 476 498 497 492 498 492 485 485 492 494 471 476 498 471 498 485 475 476 410 410 476 408 370 476 471 408 476 370 373 471 470 370 471 373 471 484 470 485 484 471 370 371 372 373 371 370 370 409 408 372 409 370 408 409 410 409 404 412 409 412 410 372 404 409 372 371 377 377 404 372 403 404 402 405 402 404 412 404 403 377 405 404 411 412 413 413 412 403 410 412 411 413 403 396 403 402 396 397 402 401 396 402 397 405 401 402 378 405 377 401 405 378 322 401 323 322 397 401 386 401 378 386 323 401 396 397 325 325 397 324 324 397 322 142 322 323 145 322 142 145 324 322 142 323 381 381 323 386 386 378 385 381 386 382 382 386 385 380 381 382 142 381 380 380 382 383 383 382 387 387 382 385 376 385 375 385 378 375 376 387 385 383 387 376 374 376 366 366 376 375 374 379 376 379 383 376 368 375 371 366 375 368 371 375 378 371 378 377 373 368 371 367 368 369 369 368 373 367 366 368 365 366 367 365 374 366 367 460 365 369 460 367 373 458 369 458 460 369 470 458 373 458 459 460 458 466 459 470 484 458 458 484 466 459 466 467 459 467 460 463 467 466 466 482 463 484 482 466 485 482 484 463 482 464 482 469 464 482 483 469 485 486 482 482 486 483 485 494 486 486 494 483 469 483 465 465 483 360 464 469 354 465 354 469 355 464 354 463 464 355 352 353 354 354 353 355 176 178 354 354 178 352 354 465 176 360 361 465 465 361 176 177 360 348 361 360 177 176 361 177 174 176 177 178 176 174 177 173 174 177 348 173 348 339 173 348 454 339 165 168 173 174 173 168 165 173 339 168 178 174 168 165 167 167 178 168 165 166 167 166 183 167 167 183 178 184 183 166 352 183 184 178 183 352 182 184 166 352 184 353 184 362 353 182 362 184 181 182 155 155 182 153 153 182 166 182 181 362 353 362 356 364 357 362 362 357 356 362 181 364 353 356 355 355 356 349 356 357 349 349 357 350 357 358 350 363 357 364 363 358 357 181 180 364 364 180 363 359 358 363 180 179 363 363 388 359 363 195 388 179 195 363 358 359 350 359 388 393 359 393 350 388 193 389 195 193 388 388 389 393 194 193 195 179 194 195 191 193 192 194 192 193 193 390 389 193 191 390 389 392 393 389 390 392 393 392 395 350 393 395 390 394 392 395 392 374 392 394 374 191 391 390 390 391 394 394 379 374 394 391 379 365 395 374 365 468 395 460 468 365 468 462 351 468 351 461 460 462 468 468 461 395 467 462 460 351 462 349 462 463 349 467 463 462 349 350 351 461 351 350 350 395 461 349 463 355 383 379 384 379 391 384 185 383 384 185 380 383 186 384 391 186 185 384 189 391 191 186 391 189 185 186 187 186 188 187 186 189 188 189 190 188 189 191 190 191 192 190 192 208 190 190 208 188 215 187 188 215 188 207 207 188 208 199 208 192 199 207 208 194 199 192 200 199 194 198 199 200 198 197 199 197 207 199 204 207 197 206 207 204 206 215 207 196 197 198 196 201 197 201 203 197 197 203 204 203 206 204 205 206 203 205 209 206 209 215 206 202 203 201 202 227 203 203 227 205 225 227 202 201 335 202 335 336 202 202 336 225 224 227 225 224 205 227 223 224 225 225 336 223 336 337 223 335 342 336 336 342 344 336 344 337 171 335 201 342 335 171 342 171 172 172 343 342 344 342 343 344 343 345 344 345 337 345 343 341 347 343 172 347 341 343 345 453 337 346 345 341 453 345 346 341 175 340 341 340 346 341 347 175 175 347 163 347 172 163 163 170 175 175 170 165 165 340 175 165 339 340 346 340 339 165 170 166 169 166 170 170 163 169 161 160 163 169 163 160 161 163 172 154 169 160 153 169 154 166 169 153 153 154 155 154 157 155 157 154 160 159 155 157 159 181 155 156 157 158 159 157 156 158 157 160 156 179 159 179 180 159 180 181 159 156 200 194 158 200 156 156 194 179 164 158 160 198 200 158 164 198 158 162 164 160 196 198 164 162 196 164 160 161 162 171 162 172 162 161 172 171 196 162 171 201 196 339 454 346 456 346 454 437 454 435 456 454 437 456 453 346 440 456 437 453 456 440 435 436 437 436 438 437 438 440 437 441 440 438 442 440 441 442 452 440 452 453 440 455 337 453 455 453 452 443 452 330 330 452 442 443 455 452 338 337 455 338 455 443 223 337 221 221 337 219 337 338 219 136 338 329 219 338 136 329 338 443 329 443 330 136 329 134 329 330 134 330 331 134 442 331 330 134 135 136 134 137 135 134 149 137 134 331 149 222 219 136 135 222 136 135 130 132 137 130 135 132 222 135 137 138 130 149 138 137 149 150 138 149 331 150 150 151 138 138 133 130 138 143 133 138 151 143 130 131 132 133 131 130 216 222 132 131 216 132 139 131 140 133 140 131 131 217 216 139 217 131 143 140 133 143 144 140 151 144 143 145 140 144 140 145 139 147 144 151 144 325 145 326 325 144 147 327 144 327 326 144 145 142 139 325 324 145 325 326 396 327 399 326 399 396 326 328 327 147 328 398 327 398 399 327 400 399 398 413 396 399 400 413 399 406 400 398 406 398 328 406 407 400 407 413 400 411 413 407 406 473 407 473 474 407 474 475 407 407 475 411 328 472 406 472 473 406 473 499 474 491 473 472 491 499 473 474 499 475 411 475 410 490 499 491 478 491 472 434 472 328 434 478 472 333 478 434 449 478 333 446 478 449 333 434 328 146 328 147 146 333 328 146 147 148 148 333 146 148 334 333 448 333 334 448 449 333 449 448 446 444 445 446 444 446 448 444 448 447 447 448 334 444 447 441 438 444 441 438 445 444 436 445 438 441 447 442 447 334 450 447 450 442 442 450 331 332 450 334 331 450 332 331 332 150 150 332 334 152 151 150 150 334 152 152 334 148 148 151 152 148 147 151 141 139 142 139 212 217 141 212 139 142 185 141 141 185 212 380 185 142 185 187 212 214 187 215 212 187 214 214 210 212 210 214 213 213 214 215 213 215 209 210 213 211 205 213 209 205 211 213 210 211 212 226 218 211 226 211 205 211 218 212 226 205 224 220 226 224 216 226 220 216 218 226 216 217 218 217 212 218 222 216 220 219 220 221 222 220 219 220 223 221 220 224 223 240 241 238 238 247 240 238 248 247 248 251 247 47 247 48 47 426 247 248 252 251 249 252 248 249 253 252 253 59 252 250 253 249 250 98 253 98 97 253 97 59 253 47 283 426 283 427 426 282 283 233 233 283 47 282 427 283 232 282 233 47 232 233 47 48 49 49 232 47 288 289 500 288 500 295 17 64 25 64 129 25))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-1.1255100250244141e+02 2.1148599624633789e+01 7.2288298606872559e+00 -1.0990699768066406e+02 2.2224800109863281e+01 8.4010801315307617e+00 -1.1138800048828125e+02 2.1970798492431641e+01 7.6926403045654297e+00 -1.1022100067138672e+02 2.2377601623535156e+01 8.1409997940063477e+00 -1.1120399475097656e+02 2.2176399230957031e+01 7.6428799629211426e+00 -1.1219800567626953e+02 2.1725299835205078e+01 7.1447100639343262e+00 -1.0823900604248047e+02 2.1607000350952148e+01 9.1103105545043945e+00 -1.0910300445556641e+02 2.2351900100708008e+01 8.6652698516845703e+00 -1.1298500061035156e+02 2.1160499572753906e+01 6.8069300651550293e+00 -1.1063700103759766e+02 2.2329200744628906e+01 -7.9401097297668457e+00 -1.1053100585937500e+02 2.2138799667358398e+01 -8.1301708221435547e+00 -1.1188899993896484e+02 2.1872499465942383e+01 -7.3370399475097656e+00 -1.1254100036621094e+02 2.1298200607299805e+01 -7.2108802795410156e+00 -1.1268900299072266e+02 2.1404798507690430e+01 -6.8442997932434082e+00 -1.0970099639892578e+02 2.2372600555419922e+01 -8.4108705520629883e+00 -1.0892800140380859e+02 2.2148000717163086e+01 -8.8029594421386719e+00 -1.0786999511718750e+02 2.0569400787353516e+01 -9.1142997741699219e+00 -1.1374600219726562e+02 2.0187700271606445e+01 -6.6784701347351074e+00 -1.0917800140380859e+02 2.3354999542236328e+01 7.0110297203063965e+00 -1.0959700012207031e+02 2.2983501434326172e+01 7.7004499435424805e+00 -1.0783599853515625e+02 2.3773399353027344e+01 7.0611500740051270e+00 -1.0779300689697266e+02 2.3464401245117188e+01 7.9070405960083008e+00 -1.0771399688720703e+02 2.2889999389648438e+01 8.5910701751708984e+00 -1.0673400115966797e+02 2.2362699508666992e+01 8.9888896942138672e+00 -1.1084500122070312e+02 2.2612600326538086e+01 6.7972202301025391e+00 -1.1408399963378906e+02 2.0165700912475586e+01 -6.2718000411987305e+00 -1.1384799957275391e+02 2.0181499481201172e+01 6.6102499961853027e+00 -1.1406900024414062e+02 2.0165899276733398e+01 6.2554397583007812e+00 -1.0810800170898438e+02 2.0549499511718750e+01 9.1296901702880859e+00 -1.0787599945068359e+02 2.3624900817871094e+01 -7.5470304489135742e+00 -1.0941000366210938e+02 2.3245100021362305e+01 -7.2567200660705566e+00 -1.0786599731445312e+02 2.3784700393676758e+01 -6.8197798728942871e+00 -1.0798899841308594e+02 2.3176898956298828e+01 -8.2607002258300781e+00 -1.0745400238037109e+02 2.2550701141357422e+01 -8.8517494201660156e+00 -1.1085499572753906e+02 2.2606800079345703e+01 -6.8199100494384766e+00 -1.0834500122070312e+02 2.1908199310302734e+01 -9.0081100463867188e+00 -1.0678499603271484e+02 2.3850200653076172e+01 -7.2325701713562012e+00 -1.0652100372314453e+02 2.3850898742675781e+01 7.2211799621582031e+00 -1.0580200195312500e+02 2.3780399322509766e+01 -6.8899002075195312e+00 -1.0503900146484375e+02 2.3565999984741211e+01 6.8094100952148438e+00 -8.0891105651855469e+01 1.1325000524520874e+00 -6.8449096679687500e+00 -8.1105300903320312e+01 2.2144498825073242e+00 7.0301799774169922e+00 -8.0893203735351562e+01 1.1343699693679810e+00 6.8404102325439453e+00 -6.6427604675292969e+01 -7.8912601470947266e+00 -7.0898699760437012e+00 -6.6379302978515625e+01 -1.0204099655151367e+01 6.8426899909973145e+00 -6.6416801452636719e+01 -1.0317999839782715e+01 -6.9112296104431152e+00 -6.6422096252441406e+01 -7.8617205619812012e+00 6.9276800155639648e+00 -1.0390999603271484e+02 1.1320199966430664e+01 9.1500005722045898e+00 -1.0289599609375000e+02 1.2907699584960938e+01 9.1500005722045898e+00 -1.0390800476074219e+02 1.1322799682617188e+01 6.2500000000000000e+00 -1.0289599609375000e+02 1.2907699584960938e+01 6.2500000000000000e+00 -1.0243199920654297e+02 1.5235600471496582e+01 9.1500005722045898e+00 -1.0243199920654297e+02 1.5235600471496582e+01 6.2500000000000000e+00 -1.0325399780273438e+02 1.7961500167846680e+01 9.1500005722045898e+00 -1.0325399780273438e+02 1.7961500167846680e+01 6.2500000000000000e+00 -1.0492599487304688e+02 1.9646100997924805e+01 9.1500005722045898e+00 -1.0492599487304688e+02 1.9646100997924805e+01 6.2500000000000000e+00 -1.0664500427246094e+02 2.0404399871826172e+01 9.1500005722045898e+00 -1.0715000152587891e+02 2.0549098968505859e+01 6.2500100135803223e+00 -8.1037994384765625e+01 9.0935903787612915e-01 7.6571698188781738e+00 -1.0581700134277344e+02 2.3635700225830078e+01 7.5242900848388672e+00 -1.0625199890136719e+02 2.3281200408935547e+01 8.2787399291992188e+00 -1.0631799316406250e+02 2.2787200927734375e+01 8.7120494842529297e+00 -1.0642399597167969e+02 2.1591701507568359e+01 9.1486701965332031e+00 -1.0758700561523438e+02 2.0558599472045898e+01 -6.2500600814819336e+00 -1.1537699890136719e+02 1.8636501312255859e+01 -6.2500000000000000e+00 -1.1537699890136719e+02 1.8636501312255859e+01 6.2500000000000000e+00 -1.1674299621582031e+02 1.6191101074218750e+01 -6.2500000000000000e+00 -1.1674299621582031e+02 1.6191101074218750e+01 6.2500000000000000e+00 -1.1696799468994141e+02 1.4067199707031250e+01 -6.2500000000000000e+00 -1.1696799468994141e+02 1.4067199707031250e+01 6.2500000000000000e+00 -1.1538999938964844e+02 9.9371299743652344e+00 -6.2500000000000000e+00 -1.1516500091552734e+02 9.6792697906494141e+00 6.2500000000000000e+00 -1.1622299957275391e+02 1.1383399963378906e+01 -6.2500000000000000e+00 -1.1622299957275391e+02 1.1383399963378906e+01 6.2500000000000000e+00 -1.0658500671386719e+02 2.2050399780273438e+01 -9.0689001083374023e+00 -1.0739199829101562e+02 2.1629100799560547e+01 -9.1438894271850586e+00 -1.0634799957275391e+02 2.2640100479125977e+01 -8.8131694793701172e+00 -1.0628200531005859e+02 2.3285800933837891e+01 -8.2749204635620117e+00 -1.0582099914550781e+02 2.3627899169921875e+01 -7.5341701507568359e+00 -1.0305800628662109e+02 2.2583400726318359e+01 -6.9935097694396973e+00 -1.0316800689697266e+02 2.2666999816894531e+01 6.8754200935363770e+00 -1.0470500183105469e+02 2.3403900146484375e+01 -7.1863298416137695e+00 -8.4307502746582031e+01 7.6383199691772461e+00 -7.0561299324035645e+00 -8.4178100585937500e+01 7.4929299354553223e+00 7.2439699172973633e+00 -8.3353996276855469e+01 6.6484398841857910e+00 -7.2930903434753418e+00 -8.3333702087402344e+01 6.6357998847961426e+00 7.2368602752685547e+00 -8.2248100280761719e+01 5.2323098182678223e+00 -6.7470102310180664e+00 -8.2248100280761719e+01 5.2323098182678223e+00 6.7470197677612305e+00 -8.1535301208496094e+01 3.6073899269104004e+00 -7.2368497848510742e+00 -8.1535301208496094e+01 3.6073899269104004e+00 7.2368602752685547e+00 -8.1164703369140625e+01 2.4137799739837646e+00 -7.0925097465515137e+00 -8.1041595458984375e+01 1.2051099538803101e+00 -7.4830198287963867e+00 -8.1404800415039062e+01 2.1610400676727295e+00 -7.8907098770141602e+00 -8.1464607238769531e+01 5.7703697681427002e-01 -8.4296903610229492e+00 -8.1916801452636719e+01 2.8818399906158447e+00 -8.3461799621582031e+00 -8.0582000732421875e+01 3.2899701595306396e-01 -6.8224301338195801e+00 -8.0611602783203125e+01 3.6499801278114319e-01 7.0285301208496094e+00 -7.9885299682617188e+01 -5.9871703386306763e-01 6.9645900726318359e+00 -8.0027702331542969e+01 -4.7092598676681519e-01 -7.2357196807861328e+00 -7.9382598876953125e+01 -9.8377698659896851e-01 -7.2393703460693359e+00 -7.8882797241210938e+01 -1.2371500730514526e+00 -7.0834403038024902e+00 -7.8878799438476562e+01 -1.2544499635696411e+00 7.2472901344299316e+00 -6.8381195068359375e+01 -5.0998897552490234e+00 -7.0914001464843750e+00 -6.8381401062011719e+01 -5.0997200012207031e+00 7.0912103652954102e+00 -6.7523101806640625e+01 -5.7609796524047852e+00 -6.6500000953674316e+00 -6.7562103271484375e+01 -5.7994298934936523e+00 7.3110098838806152e+00 -6.7093399047851562e+01 -6.2765302658081055e+00 6.6500000953674316e+00 -6.7093399047851562e+01 -6.2765302658081055e+00 -6.6500000953674316e+00 -6.6755897521972656e+01 -6.8566699028015137e+00 6.6500000953674316e+00 -6.6765502929687500e+01 -6.8609399795532227e+00 -6.9129900932312012e+00 -6.6726501464843750e+01 -8.2779598236083984e+00 -7.9365501403808594e+00 -6.6528701782226562e+01 -1.0204299926757812e+01 -7.5418601036071777e+00 -6.6966804504394531e+01 -1.0284399986267090e+01 -8.2502498626708984e+00 -6.7592597961425781e+01 -1.0280200004577637e+01 -8.7884492874145508e+00 -6.7469200134277344e+01 -7.9253296852111816e+00 -8.7163000106811523e+00 -6.8424797058105469e+01 -8.1632604598999023e+00 -9.1246194839477539e+00 -6.8441200256347656e+01 -1.0274600028991699e+01 -9.1099405288696289e+00 -1.0575799560546875e+02 2.0101900100708008e+01 -6.2499799728393555e+00 -1.0574500274658203e+02 2.0094999313354492e+01 -9.1500005722045898e+00 -1.0418099975585938e+02 1.9052000045776367e+01 -9.1500005722045898e+00 -1.0418099975585938e+02 1.9052000045776367e+01 -6.2500000000000000e+00 -1.0282299804687500e+02 1.7104900360107422e+01 -9.1500005722045898e+00 -1.0282299804687500e+02 1.7104900360107422e+01 -6.2500000000000000e+00 -1.0247100067138672e+02 1.4757699966430664e+01 -9.1500005722045898e+00 -1.0247100067138672e+02 1.4757699966430664e+01 -6.2500000000000000e+00 -1.0289599609375000e+02 1.2907699584960938e+01 -9.1500005722045898e+00 -1.0289599609375000e+02 1.2907699584960938e+01 -6.2500000000000000e+00 -1.0390999603271484e+02 1.1320199966430664e+01 -9.1500005722045898e+00 -1.0390800476074219e+02 1.1322799682617188e+01 -6.2500000000000000e+00 -9.3890396118164062e+01 -1.9594499588012695e+01 1.0717599868774414e+01 -9.3311698913574219e+01 -2.0343400955200195e+01 1.0186299324035645e+01 -9.3139999389648438e+01 -1.9639101028442383e+01 1.0931699752807617e+01 -9.4444198608398438e+01 -1.9820499420166016e+01 1.0143100738525391e+01 -9.3770805358886719e+01 -1.8042900085449219e+01 1.1324600219726562e+01 -9.3148300170898438e+01 -1.8898900985717773e+01 1.1310199737548828e+01 -9.2880302429199219e+01 -1.8248298645019531e+01 1.1486599922180176e+01 -9.4190101623535156e+01 -1.8621999740600586e+01 1.1047300338745117e+01 -9.4629699707031250e+01 -1.9244899749755859e+01 1.0483499526977539e+01 -9.3179298400878906e+01 -2.0761600494384766e+01 9.3805398941040039e+00 -9.4466201782226562e+01 -2.0374099731445312e+01 9.2567300796508789e+00 -9.2621604919433594e+01 -2.0890800476074219e+01 8.6935596466064453e+00 -9.3537803649902344e+01 -2.0878400802612305e+01 8.3422803878784180e+00 -9.5026596069335938e+01 -1.9846000671386719e+01 9.4315004348754883e+00 -9.5409896850585938e+01 -1.9844099044799805e+01 8.4183597564697266e+00 -9.4459800720214844e+01 -2.0576400756835938e+01 8.5082206726074219e+00 -9.6102294921875000e+01 -1.8082401275634766e+01 8.4063005447387695e+00 -9.5957000732421875e+01 -1.8826099395751953e+01 8.5782003402709961e+00 -9.5930999755859375e+01 -1.8176700592041016e+01 9.1546802520751953e+00 -9.4813400268554688e+01 -1.8193399429321289e+01 1.0736900329589844e+01 -9.5316596984863281e+01 -1.8348098754882812e+01 1.0241700172424316e+01 -9.5368499755859375e+01 -1.9263999938964844e+01 9.6255397796630859e+00 -9.5664001464843750e+01 -1.8175401687622070e+01 9.7290201187133789e+00 -6.1640899658203125e+01 -1.0425000190734863e+01 3.9616897106170654e+00 -6.1256801605224609e+01 -1.1007900238037109e+01 5.0008902549743652e+00 -6.1028400421142578e+01 -1.0940000534057617e+01 3.5944600105285645e+00 -6.0362701416015625e+01 -1.2412300109863281e+01 3.8142299652099609e+00 -6.0830898284912109e+01 -1.1490600585937500e+01 4.6984200477600098e+00 -6.0695499420166016e+01 -1.2366300582885742e+01 5.3090500831604004e+00 -6.0535999298095703e+01 -1.1712599754333496e+01 3.2430801391601562e+00 -6.1415000915527344e+01 -1.1332499504089355e+01 6.1296601295471191e+00 -6.2047298431396484e+01 -1.1340100288391113e+01 7.2632598876953125e+00 -6.1666099548339844e+01 -1.2169400215148926e+01 7.3382396697998047e+00 -6.2599899291992188e+01 -1.0761500358581543e+01 7.2886400222778320e+00 -6.1104301452636719e+01 -1.2365699768066406e+01 6.3779201507568359e+00 -6.3905403137207031e+01 -9.9834995269775391e+00 6.6251201629638672e+00 -6.2361698150634766e+01 -1.0050799369812012e+01 4.0647602081298828e+00 -6.3224800109863281e+01 -9.8956604003906250e+00 4.1209397315979004e+00 -6.4281700134277344e+01 -9.9137601852416992e+00 6.2162299156188965e+00 -6.2290500640869141e+01 -1.0443200111389160e+01 6.0588402748107910e+00 -6.3195800781250000e+01 -1.0118500709533691e+01 6.4187703132629395e+00 -6.2472702026367188e+01 -1.2513899803161621e+01 8.4688806533813477e+00 -6.2741802215576172e+01 -1.1699199676513672e+01 8.3473205566406250e+00 -6.5240798950195312e+01 -1.0212999343872070e+01 7.2388596534729004e+00 -6.4898796081542969e+01 -9.9844198226928711e+00 6.1325101852416992e+00 -6.3833900451660156e+01 -1.0411499977111816e+01 7.6742200851440430e+00 -6.4857902526855469e+01 -9.9734296798706055e+00 -6.2122802734375000e+00 -6.5789199829101562e+01 -1.0287300109863281e+01 6.7968602180480957e+00 -6.3911804199218750e+01 -9.8958206176757812e+00 -5.6185297966003418e+00 -6.0359798431396484e+01 -1.2307199478149414e+01 -3.6064600944519043e+00 -6.0628803253173828e+01 -1.1578699111938477e+01 -3.7531502246856689e+00 -6.1003398895263672e+01 -1.0976799964904785e+01 -3.6707999706268311e+00 -6.1652702331542969e+01 -1.0380000114440918e+01 -3.2844698429107666e+00 -6.2966400146484375e+01 -9.9117994308471680e+00 -3.9426000118255615e+00 -6.2402801513671875e+01 -1.0049499511718750e+01 -4.1836700439453125e+00 -6.2849601745605469e+01 -2.0878900527954102e+01 -4.6983399391174316e+00 -6.1999298095703125e+01 -2.0687000274658203e+01 -3.4147000312805176e+00 -6.2570995330810547e+01 -2.0865400314331055e+01 3.6086099147796631e+00 -6.1783802032470703e+01 -2.0569799423217773e+01 4.0062098503112793e+00 -6.1179801940917969e+01 -2.0188600540161133e+01 -3.4911398887634277e+00 -6.1094200134277344e+01 -2.0112199783325195e+01 3.4762198925018311e+00 -6.0759300231933594e+01 -1.9701499938964844e+01 -4.0063400268554688e+00 -6.0481601715087891e+01 -1.9313299179077148e+01 3.6495699882507324e+00 -6.0331798553466797e+01 -1.8978799819946289e+01 -3.8294301033020020e+00 -6.0145603179931641e+01 -1.8248100280761719e+01 3.5796301364898682e+00 -6.0149700164794922e+01 -1.8183900833129883e+01 -3.7242200374603271e+00 -6.1329101562500000e+01 -1.8172399520874023e+01 7.3941497802734375e+00 -6.1202499389648438e+01 -1.9032899856567383e+01 6.7604098320007324e+00 -6.0576999664306641e+01 -1.8134300231933594e+01 5.7871098518371582e+00 -6.0678703308105469e+01 -1.9317298889160156e+01 4.9355797767639160e+00 -6.0273300170898438e+01 -1.8190299987792969e+01 4.6072797775268555e+00 -6.2056499481201172e+01 -1.8305599212646484e+01 8.4032497406005859e+00 -6.2891201019287109e+01 -1.8202999114990234e+01 9.2903900146484375e+00 -6.2518798828125000e+01 -1.9168001174926758e+01 8.5312500000000000e+00 -6.1819400787353516e+01 -1.9715000152587891e+01 7.0366902351379395e+00 -6.3629402160644531e+01 -1.9681400299072266e+01 9.1858005523681641e+00 -6.2661094665527344e+01 -2.0117799758911133e+01 7.6399598121643066e+00 -6.1705501556396484e+01 -2.0120000839233398e+01 6.0299701690673828e+00 -6.1365299224853516e+01 -2.0182001113891602e+01 4.7702097892761230e+00 -6.3459999084472656e+01 -2.0138601303100586e+01 8.4642896652221680e+00 -6.5282203674316406e+01 -2.0844699859619141e+01 8.1589899063110352e+00 -6.5461898803710938e+01 -2.0472999572753906e+01 9.3470602035522461e+00 -6.7502799987792969e+01 -2.0880699157714844e+01 8.8870401382446289e+00 -6.4250900268554688e+01 -2.0501499176025391e+01 8.5253801345825195e+00 -6.3902801513671875e+01 -2.0890598297119141e+01 6.4770898818969727e+00 -6.2842899322509766e+01 -2.0660999298095703e+01 6.4450001716613770e+00 -6.7447898864746094e+01 -1.9895900726318359e+01 1.0701199531555176e+01 -6.8066703796386719e+01 -2.0559700012207031e+01 9.8929996490478516e+00 -6.6776199340820312e+01 -2.0473899841308594e+01 9.8433294296264648e+00 -6.8019004821777344e+01 -1.8250000000000000e+01 1.1477600097656250e+01 -6.6453102111816406e+01 -1.9029800415039062e+01 1.1013400077819824e+01 -6.6668197631835938e+01 -1.8167299270629883e+01 1.1279200553894043e+01 -6.8108795166015625e+01 -1.9188899993896484e+01 1.1208799362182617e+01 -6.5456893920898438e+01 -1.8165899276733398e+01 1.0892800331115723e+01 -6.4912101745605469e+01 -1.9028398513793945e+01 1.0428299903869629e+01 -6.4241897583007812e+01 -1.8162601470947266e+01 1.0295599937438965e+01 -6.5291099548339844e+01 -1.9738498687744141e+01 1.0151299476623535e+01 -6.3691497802734375e+01 -1.9022300720214844e+01 9.6710500717163086e+00 -6.6639404296875000e+01 -1.0391200065612793e+01 -7.4401497840881348e+00 -6.7378097534179688e+01 -1.0396800041198730e+01 -8.4291000366210938e+00 -6.8558403015136719e+01 -1.0390600204467773e+01 -8.9551897048950195e+00 -6.6518203735351562e+01 -1.0381000518798828e+01 7.0109400749206543e+00 -1.0655000305175781e+02 9.0483503341674805e+00 6.2500000000000000e+00 -1.0659600067138672e+02 8.9703903198242188e+00 9.1500005722045898e+00 -6.8878005981445312e+01 -5.8127598762512207e+00 8.5706300735473633e+00 -6.8101898193359375e+01 -5.8599400520324707e+00 8.1459197998046875e+00 -6.8941696166992188e+01 -5.2135200500488281e+00 7.9463496208190918e+00 -6.8069396972656250e+01 -5.3750901222229004e+00 7.2382197380065918e+00 -6.9012496948242188e+01 -6.5341000556945801e+00 8.9862108230590820e+00 -6.7782798767089844e+01 -6.8296599388122559e+00 8.5839900970458984e+00 -6.9165496826171875e+01 -7.2737402915954590e+00 9.1449699401855469e+00 -6.8384101867675781e+01 -7.9007697105407715e+00 9.0976705551147461e+00 -6.7704200744628906e+01 -7.7998600006103516e+00 8.8410501480102539e+00 -6.7219802856445312e+01 -6.7383103370666504e+00 7.9707598686218262e+00 -6.6955093383789062e+01 -6.5843300819396973e+00 7.2415699958801270e+00 -6.7004997253417969e+01 -7.9977197647094727e+00 8.2913408279418945e+00 -6.6569900512695312e+01 -7.9542694091796875e+00 7.5836801528930664e+00 -8.0766601562500000e+01 -2.6834499835968018e+00 9.1361703872680664e+00 -8.0020896911621094e+01 -2.0557599067687988e+00 8.8182601928710938e+00 -7.9667900085449219e+01 -1.4880100488662720e+00 8.2595100402832031e+00 -7.9713203430175781e+01 -9.0127098560333252e-01 7.5182800292968750e+00 -8.1314804077148438e+01 -1.4700200557708740e+00 9.0114593505859375e+00 -8.1178298950195312e+01 -3.1777799129486084e-01 8.5120792388916016e+00 -8.0600097656250000e+01 -2.5520402193069458e-01 7.9102797508239746e+00 -8.2784805297851562e+01 -4.4402197003364563e-02 9.1334791183471680e+00 -8.1941299438476562e+01 2.4092900753021240e-01 8.8169498443603516e+00 -8.1437797546386719e+01 9.2610096931457520e-01 8.2673997879028320e+00 -8.1758094787597656e+01 3.0187301635742188e+00 8.1118698120117188e+00 -8.2164199829101562e+01 2.6206700801849365e+00 8.6233196258544922e+00 -8.2902999877929688e+01 2.6529698371887207e+00 9.0108594894409180e+00 -8.3766494750976562e+01 3.3219201564788818e+00 9.1485605239868164e+00 -8.3335899353027344e+01 4.5836100578308105e+00 8.8279705047607422e+00 -8.2762893676757812e+01 4.9265799522399902e+00 8.2738695144653320e+00 -8.2385002136230469e+01 5.1509799957275391e+00 7.5249400138854980e+00 -8.5538703918457031e+01 6.0334100723266602e+00 9.1193103790283203e+00 -8.4640304565429688e+01 6.3338699340820312e+00 8.8090000152587891e+00 -8.4188796997070312e+01 6.8161702156066895e+00 8.2442798614501953e+00 -1.0439299774169922e+02 2.1178501129150391e+01 9.0887203216552734e+00 -1.0403299713134766e+02 2.1799600601196289e+01 8.8098001480102539e+00 -1.0300900268554688e+02 2.1867799758911133e+01 8.2513504028320312e+00 -1.0275500488281250e+02 2.2213001251220703e+01 7.4874601364135742e+00 -1.0447800445556641e+02 2.2709800720214844e+01 8.2735300064086914e+00 -1.0429399871826172e+02 2.3108600616455078e+01 7.5249996185302734e+00 -1.0652499389648438e+02 9.0833702087402344e+00 -6.2500000000000000e+00 -1.0879199981689453e+02 9.1968107223510742e+00 -6.2500000000000000e+00 -1.0652100372314453e+02 8.5220699310302734e+00 -6.2500000000000000e+00 -1.1179100036621094e+02 9.5880804061889648e+00 -6.2500000000000000e+00 -1.1489099884033203e+02 9.5263805389404297e+00 -6.2500000000000000e+00 -1.1528500366210938e+02 9.8146600723266602e+00 -6.2500000000000000e+00 -1.1534700012207031e+02 9.8796491622924805e+00 -6.2500000000000000e+00 -1.0652600097656250e+02 9.0829801559448242e+00 -9.1500005722045898e+00 -1.0653000640869141e+02 8.5469398498535156e+00 -9.1500005722045898e+00 -1.0649300384521484e+02 8.5030593872070312e+00 6.2500000000000000e+00 -1.0643299865722656e+02 8.4661493301391602e+00 9.1500005722045898e+00 -1.1463999938964844e+02 9.5075397491455078e+00 6.2500000000000000e+00 -1.1074099731445312e+02 9.5356006622314453e+00 6.2500000000000000e+00 -1.0459899902343750e+02 2.2849300384521484e+01 -8.1906995773315430e+00 -1.0481200408935547e+02 2.1987098693847656e+01 -8.9133701324462891e+00 -1.0357700347900391e+02 2.0572999954223633e+01 -9.1288499832153320e+00 -1.0290700531005859e+02 2.1414701461791992e+01 -8.5791702270507812e+00 -1.0255799865722656e+02 2.1847799301147461e+01 -7.9297304153442383e+00 -8.5285697937011719e+01 5.3565101623535156e+00 -9.1531400680541992e+00 -8.6191101074218750e+01 5.9746003150939941e+00 -9.1500005722045898e+00 -8.4434997558593750e+01 7.4523196220397949e+00 -7.7178397178649902e+00 -9.3737998962402344e+01 1.4706799507141113e+01 -8.4361400604248047e+00 -8.4648101806640625e+01 6.3001999855041504e+00 -8.8215703964233398e+00 -8.4215202331542969e+01 5.1858601570129395e+00 -9.0355100631713867e+00 -8.3408996582031250e+01 1.5781799554824829e+00 -9.1507396697998047e+00 -8.2511795043945312e+01 2.3564100265502930e+00 -8.9124402999877930e+00 -8.2423698425292969e+01 6.5717399120330811e-01 -8.9903802871704102e+00 -8.2372299194335938e+01 5.1327199935913086e+00 -7.5182700157165527e+00 -8.2866104125976562e+01 4.8270797729492188e+00 -8.4458894729614258e+00 -8.4181701660156250e+01 6.7181601524353027e+00 -8.2935199737548828e+00 -8.4635505676269531e+01 7.3326001167297363e+00 -8.0918207168579102e+00 -7.9508697509765625e+01 -1.3220299482345581e+00 -7.9454097747802734e+00 -8.0807800292968750e+01 -4.0625399351119995e-01 -8.2731399536132812e+00 -7.9835494995117188e+01 -1.7615299224853516e+00 -8.5770492553710938e+00 -8.1352302551269531e+01 -7.9768502712249756e-01 -8.8287897109985352e+00 -8.0248199462890625e+01 -2.4152600765228271e+00 -9.0147600173950195e+00 -8.2238693237304688e+01 -1.0475699901580811e+00 -9.1326198577880859e+00 -8.0497398376464844e+01 -3.0117800235748291e+00 -9.1439599990844727e+00 -8.0731506347656250e+01 3.0195799469947815e-01 -7.5233402252197266e+00 -6.8582801818847656e+01 -5.3629498481750488e+00 -7.9397101402282715e+00 -6.8881599426269531e+01 -5.8094701766967773e+00 -8.5697393417358398e+00 -6.8847198486328125e+01 -6.6348700523376465e+00 -8.9898700714111328e+00 -6.9246902465820312e+01 -7.1703696250915527e+00 -9.1396703720092773e+00 -6.8069396972656250e+01 -5.3750901222229004e+00 -7.2382502555847168e+00 -6.7967201232910156e+01 -6.5680298805236816e+00 -8.5666704177856445e+00 -6.7570594787597656e+01 -6.2374300956726074e+00 -7.9708199501037598e+00 -6.7335296630859375e+01 -6.0413298606872559e+00 -7.2416000366210938e+00 -6.7046905517578125e+01 -7.3667497634887695e+00 -8.1459798812866211e+00 -6.6710304260253906e+01 -7.2175598144531250e+00 -7.4390296936035156e+00 -9.3670799255371094e+01 -2.0848899841308594e+01 -8.3173599243164062e+00 -9.3062400817871094e+01 -2.0889600753784180e+01 -8.6832695007324219e+00 -9.4475296020507812e+01 -2.0568099975585938e+01 -8.2652196884155273e+00 -9.5187599182128906e+01 -2.0061500549316406e+01 -8.3796195983886719e+00 -9.5581100463867188e+01 -1.9595699310302734e+01 -8.4368000030517578e+00 -9.5950202941894531e+01 -1.8861299514770508e+01 -8.5076694488525391e+00 -9.6091598510742188e+01 -1.8124500274658203e+01 -8.5547199249267578e+00 -9.2733894348144531e+01 -1.3036300659179688e+01 1.1314899444580078e+01 -9.3509201049804688e+01 -1.2771699905395508e+01 1.1148099899291992e+01 -9.4322799682617188e+01 -1.2947400093078613e+01 1.0788499832153320e+01 -9.5096099853515625e+01 -1.3248800277709961e+01 1.0142100334167480e+01 -9.5897506713867188e+01 -1.2896499633789062e+01 8.4291496276855469e+00 -9.5564300537109375e+01 -1.2914200782775879e+01 9.4243803024291992e+00 -6.3192703247070312e+01 -1.2891500473022461e+01 9.2307596206665039e+00 -6.4513099670410156e+01 -1.3146400451660156e+01 1.0202899932861328e+01 -6.6488899230957031e+01 -1.2884799957275391e+01 1.1013099670410156e+01 -6.8109695434570312e+01 -1.3013999938964844e+01 1.1299399375915527e+01 -6.5641593933105469e+01 -1.0540900230407715e+01 8.5027809143066406e+00 -6.4671798706054688e+01 -1.0553799629211426e+01 8.2588300704956055e+00 -6.5173202514648438e+01 -1.1195799827575684e+01 9.5083999633789062e+00 -6.3850902557373047e+01 -1.2335700035095215e+01 9.5917797088623047e+00 -6.4128501892089844e+01 -1.1689200401306152e+01 9.3995904922485352e+00 -6.5116004943847656e+01 -1.2520500183105469e+01 1.0389900207519531e+01 -6.5758300781250000e+01 -1.1837399482727051e+01 1.0338700294494629e+01 -6.6464500427246094e+01 -1.0906100273132324e+01 9.6689691543579102e+00 -6.3610897064208984e+01 -1.1091800689697266e+01 8.5185594558715820e+00 -6.6167900085449219e+01 -1.0398699760437012e+01 7.9767799377441406e+00 -6.2467800140380859e+01 -1.1268300056457520e+01 -7.7261500358581543e+00 -6.1838798522949219e+01 -1.2272899627685547e+01 -7.6358799934387207e+00 -6.2593101501464844e+01 -1.1978600502014160e+01 -8.3717203140258789e+00 -6.3545398712158203e+01 -1.0006099700927734e+01 -6.3585700988769531e+00 -6.2917201995849609e+01 -1.0279500007629395e+01 -6.5945401191711426e+00 -6.4087898254394531e+01 -1.0062999725341797e+01 -6.9385199546813965e+00 -6.3364795684814453e+01 -1.0512000083923340e+01 -7.5604901313781738e+00 -6.2347198486328125e+01 -1.0855699539184570e+01 -7.0596799850463867e+00 -6.1525798797607422e+01 -1.1299500465393066e+01 -6.3326201438903809e+00 -6.1499397277832031e+01 -1.1783800125122070e+01 -6.7678098678588867e+00 -6.1221202850341797e+01 -1.2550399780273438e+01 -6.6556100845336914e+00 -6.6212104797363281e+01 -1.0403900146484375e+01 -8.0452194213867188e+00 -6.6002197265625000e+01 -1.0354200363159180e+01 -7.3951301574707031e+00 -6.1782299041748047e+01 -1.0559800148010254e+01 -5.2923297882080078e+00 -6.0674999237060547e+01 -1.2354599952697754e+01 -5.2776899337768555e+00 -6.1002899169921875e+01 -1.1452499389648438e+01 -5.1973299980163574e+00 -6.2865303039550781e+01 -1.8152999877929688e+01 -9.2703104019165039e+00 -6.3542903900146484e+01 -1.9026599884033203e+01 -9.5700607299804688e+00 -6.3911899566650391e+01 -1.8160499572753906e+01 -1.0083099365234375e+01 -6.4932998657226562e+01 -1.9028398513793945e+01 -1.0438500404357910e+01 -6.5083602905273438e+01 -1.8163599014282227e+01 -1.0737700462341309e+01 -6.8084594726562500e+01 -1.8238901138305664e+01 -1.1481900215148926e+01 -6.6696098327636719e+01 -1.9317298889160156e+01 -1.0944100379943848e+01 -6.8112800598144531e+01 -1.9189100265502930e+01 -1.1208999633789062e+01 -6.6610595703125000e+01 -1.8187299728393555e+01 -1.1270100593566895e+01 -6.2587501525878906e+01 -1.9317298889160156e+01 -8.5163793563842773e+00 -6.4965301513671875e+01 -1.9671701431274414e+01 -1.0067800521850586e+01 -6.4137504577636719e+01 -2.0114099502563477e+01 -9.0809097290039062e+00 -6.8143798828125000e+01 -1.9980400085449219e+01 -1.0664299964904785e+01 -6.7360702514648438e+01 -2.0325500488281250e+01 -1.0215700149536133e+01 -6.2951496124267578e+01 -2.0212200164794922e+01 -7.8240799903869629e+00 -6.3676296234130859e+01 -2.0879798889160156e+01 -6.3429899215698242e+00 -6.7528594970703125e+01 -2.0886798858642578e+01 -8.7112894058227539e+00 -6.5104995727539062e+01 -2.0866199493408203e+01 -7.9224696159362793e+00 -6.3572601318359375e+01 -2.0637199401855469e+01 -7.5048704147338867e+00 -6.2261699676513672e+01 -2.0642299652099609e+01 -5.2907700538635254e+00 -6.5791603088378906e+01 -2.0477001190185547e+01 -9.4930295944213867e+00 -6.7668601989746094e+01 -2.0770900726318359e+01 -9.3475894927978516e+00 -6.4894996643066406e+01 -2.0623199462890625e+01 -8.6585197448730469e+00 -6.0366298675537109e+01 -1.8139200210571289e+01 -5.0881099700927734e+00 -6.0722499847412109e+01 -1.8731399536132812e+01 -5.8447499275207520e+00 -6.1084197998046875e+01 -1.9590000152587891e+01 -5.7146601676940918e+00 -6.1696899414062500e+01 -2.0292400360107422e+01 -5.4823598861694336e+00 -6.1519702911376953e+01 -1.9022199630737305e+01 -7.2866196632385254e+00 -6.0968997955322266e+01 -1.8159299850463867e+01 -6.7200498580932617e+00 -6.1844501495361328e+01 -1.9715000152587891e+01 -7.0786099433898926e+00 -6.1798400878906250e+01 -1.8179298400878906e+01 -8.0919799804687500e+00 -9.4956199645996094e+01 -1.9852399826049805e+01 -9.5523796081542969e+00 -9.4453796386718750e+01 -2.0476699829101562e+01 -8.9710702896118164e+00 -9.5729797363281250e+01 -1.8588001251220703e+01 -9.4496603012084961e+00 -9.5338096618652344e+01 -1.9318201065063477e+01 -9.6174697875976562e+00 -9.5275199890136719e+01 -1.8673000335693359e+01 -1.0142399787902832e+01 -9.3161399841308594e+01 -2.0778799057006836e+01 -9.3056592941284180e+00 -9.3839492797851562e+01 -2.0395500183105469e+01 -9.8352499008178711e+00 -9.4051506042480469e+01 -1.9846000671386719e+01 -1.0406599998474121e+01 -9.3038200378417969e+01 -1.9844099044799805e+01 -1.0789899826049805e+01 -9.2919799804687500e+01 -2.0447200775146484e+01 -1.0065799713134766e+01 -9.5639495849609375e+01 -1.7997301101684570e+01 -9.8040399551391602e+00 -9.4895103454589844e+01 -1.8177099227905273e+01 -1.0668899536132812e+01 -9.3024902343750000e+01 -1.8078800201416016e+01 -1.1482800483703613e+01 -9.2970001220703125e+01 -1.8775999069213867e+01 -1.1366900444030762e+01 -9.3774696350097656e+01 -1.8176700592041016e+01 -1.1310899734497070e+01 -9.4405502319335938e+01 -1.8309900283813477e+01 -1.1005100250244141e+01 -9.3781997680664062e+01 -1.9160699844360352e+01 -1.1028399467468262e+01 -9.4629699707031250e+01 -1.9244899749755859e+01 -1.0483499526977539e+01 -6.7091796875000000e+01 -1.0387100219726562e+01 8.2227993011474609e+00 -6.8684898376464844e+01 -1.0267600059509277e+01 9.1260995864868164e+00 -6.6537399291992188e+01 -1.0284700393676758e+01 7.5106997489929199e+00 -6.6952499389648438e+01 -1.0204899787902832e+01 8.2621393203735352e+00 -6.7445297241210938e+01 -1.0284399986267090e+01 8.6767597198486328e+00 -6.8003402709960938e+01 -1.0204400062561035e+01 9.0006399154663086e+00 -9.4780799865722656e+01 -1.0342499732971191e+01 9.0948200225830078e+00 -9.5615997314453125e+01 -7.4379100799560547e+00 9.1500005722045898e+00 -9.5754699707031250e+01 -9.3954296112060547e+00 9.1500005722045898e+00 -9.9812004089355469e+01 3.8179500102996826e+00 9.1500005722045898e+00 -9.7460502624511719e+01 3.4211501479148865e-01 9.1500005722045898e+00 -9.6030395507812500e+01 -3.6031599044799805e+00 9.1500005722045898e+00 -1.0294199371337891e+02 6.6133403778076172e+00 9.1500005722045898e+00 -1.0354500579833984e+02 7.0583600997924805e+00 -9.1500005722045898e+00 -9.5741798400878906e+01 -9.4041604995727539e+00 -9.1500005722045898e+00 -9.5690200805664062e+01 -5.6777200698852539e+00 -9.1500005722045898e+00 -9.6326698303222656e+01 -2.5946600437164307e+00 -9.1500005722045898e+00 -9.7460502624511719e+01 3.4211501479148865e-01 -9.1500005722045898e+00 -9.9812004089355469e+01 3.8179500102996826e+00 -9.1500005722045898e+00 -9.4780197143554688e+01 -1.0343600273132324e+01 -9.0943698883056641e+00 -9.5914100646972656e+01 -1.2885900497436523e+01 -8.1875104904174805e+00 -9.2767204284667969e+01 -1.0443500518798828e+01 8.9088096618652344e+00 -9.3540496826171875e+01 -1.0453800201416016e+01 8.3829898834228516e+00 -9.2991600036621094e+01 -1.0611999511718750e+01 9.4347295761108398e+00 -9.3684799194335938e+01 -1.0865900039672852e+01 9.6164999008178711e+00 -9.3108398437500000e+01 -1.0393699645996094e+01 7.8538393974304199e+00 -9.2875503540039062e+01 -1.1119400024414062e+01 1.0302600860595703e+01 -9.3976898193359375e+01 -1.1336700439453125e+01 1.0092399597167969e+01 -9.4118400573730469e+01 -1.1921799659729004e+01 1.0509799957275391e+01 -9.2803398132324219e+01 -1.2278599739074707e+01 1.1129500389099121e+01 -9.4789199829101562e+01 -1.1336400032043457e+01 9.2163696289062500e+00 -9.4345397949218750e+01 -1.0851400375366211e+01 8.8078298568725586e+00 -9.5200096130371094e+01 -1.1399000167846680e+01 8.2679204940795898e+00 -9.5081802368164062e+01 -1.2056799888610840e+01 9.7091798782348633e+00 -9.5445701599121094e+01 -1.1953700065612793e+01 8.8719797134399414e+00 -9.5723701477050781e+01 -1.2212299346923828e+01 8.0698595046997070e+00 -9.4766296386718750e+01 -1.2548900604248047e+01 1.0349299430847168e+01 -9.4426605224609375e+01 -1.0768700599670410e+01 8.1309795379638672e+00 -9.2969200134277344e+01 -1.1712499618530273e+01 1.0805199623107910e+01 -6.7538795471191406e+01 -1.1655799865722656e+01 1.0740300178527832e+01 -6.7675102233886719e+01 -1.0599900245666504e+01 9.4035396575927734e+00 -6.8163200378417969e+01 -1.2221399307250977e+01 1.1092700004577637e+01 -6.8055099487304688e+01 -1.1065199851989746e+01 1.0230899810791016e+01 -6.8276100158691406e+01 -1.0440400123596191e+01 8.9049005508422852e+00 -6.5624801635742188e+01 -1.2907999992370605e+01 -1.0718899726867676e+01 -6.5133201599121094e+01 -1.2643300056457520e+01 -1.0425600051879883e+01 -6.4267204284667969e+01 -1.3000999450683594e+01 -1.0042300224304199e+01 -6.2303199768066406e+01 -1.2680799484252930e+01 -8.3036804199218750e+00 -6.3390201568603516e+01 -1.1651099205017090e+01 -8.8691902160644531e+00 -6.4303298950195312e+01 -1.1275300025939941e+01 -9.1667203903198242e+00 -6.4761100769042969e+01 -1.0851999282836914e+01 -8.8473796844482422e+00 -6.5631797790527344e+01 -1.0486500740051270e+01 -8.3171300888061523e+00 -6.5605400085449219e+01 -1.1897500038146973e+01 -1.0314599990844727e+01 -6.4388298034667969e+01 -1.2194299697875977e+01 -9.8595495223999023e+00 -6.3178600311279297e+01 -1.2712699890136719e+01 -9.2077093124389648e+00 -6.5609100341796875e+01 -1.0742199897766113e+01 -8.9996404647827148e+00 -6.6827606201171875e+01 -1.3214099884033203e+01 -1.1109299659729004e+01 -6.8150299072265625e+01 -1.2829500198364258e+01 -1.1287300109863281e+01 -9.5783393859863281e+01 -1.2894499778747559e+01 -8.8829793930053711e+00 -9.5408401489257812e+01 -1.2947400093078613e+01 -9.7028608322143555e+00 -9.4762306213378906e+01 -1.3247200012207031e+01 -1.0475899696350098e+01 -9.4044403076171875e+01 -1.2914200782775879e+01 -1.0944300651550293e+01 -9.3054199218750000e+01 -1.2910599708557129e+01 -1.1280300140380859e+01 -6.8154998779296875e+01 -1.0390000343322754e+01 8.9144802093505859e+00 -9.5694496154785156e+01 -1.2157899856567383e+01 -8.2170896530151367e+00 -9.5115501403808594e+01 -1.1302899360656738e+01 -8.2818202972412109e+00 -9.4288604736328125e+01 -1.0711600303649902e+01 -8.3680400848388672e+00 -9.3305107116699219e+01 -1.0405999183654785e+01 -8.3051605224609375e+00 -6.6861396789550781e+01 -1.1230699539184570e+01 -1.0218200683593750e+01 -6.7718498229980469e+01 -1.0555000305175781e+01 -9.3031597137451172e+00 -6.6954704284667969e+01 -1.2355299949645996e+01 -1.0972000122070312e+01 -6.8097000122070312e+01 -1.1831899642944336e+01 -1.0898099899291992e+01 -6.8167404174804688e+01 -1.1026800155639648e+01 -1.0180800437927246e+01 -9.3028099060058594e+01 -1.0487699508666992e+01 -9.0319404602050781e+00 -9.4236503601074219e+01 -1.0865900039672852e+01 -9.0648107528686523e+00 -9.4712402343750000e+01 -1.1336700439453125e+01 -9.3568792343139648e+00 -9.4869003295898438e+01 -1.1888800621032715e+01 -9.8110904693603516e+00 -9.5405403137207031e+01 -1.1966600418090820e+01 -8.9950094223022461e+00 -9.2892494201660156e+01 -1.1598400115966797e+01 -1.0732900619506836e+01 -9.3836395263671875e+01 -1.1336400032043457e+01 -1.0169199943542480e+01 -9.2781700134277344e+01 -1.1079999923706055e+01 -1.0256199836730957e+01 -9.3148902893066406e+01 -1.0728499412536621e+01 -9.6660299301147461e+00 -9.4224105834960938e+01 -1.2082500457763672e+01 -1.0541100502014160e+01 -9.3492004394531250e+01 -1.1953700065612793e+01 -1.0825699806213379e+01 -9.2700401306152344e+01 -1.2215199470520020e+01 -1.1101500511169434e+01 -9.4969200134277344e+01 -1.2548900604248047e+01 -1.0146300315856934e+01 -9.4030799865722656e+01 1.4237500190734863e+01 -8.9692401885986328e+00 -9.3823699951171875e+01 1.4584000587463379e+01 -8.7680501937866211e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01) (float-vector -9.2621602118015289e+01 -2.0890800282359123e+01 8.6935600265860558e+00) (float-vector -9.5581099390983582e+01 -1.9595699384808540e+01 -8.4367999807000160e+00) (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00) (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1622299998998642e+02 1.1383400298655033e+01 6.2500000931322575e+00) (float-vector -1.1537700146436691e+02 1.8636500462889671e+01 6.2500000931322575e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01) (float-vector -9.2880301177501678e+01 -1.8248299136757851e+01 1.1486600153148174e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1696799844503403e+02 1.4067200012505054e+01 -6.2500000931322575e+00) (float-vector -9.2969998717308044e+01 -1.8775999546051025e+01 -1.1366900056600571e+01) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00) (float-vector -6.8101897835731506e+01 -5.8599398471415043e+00 8.1459200009703636e+00) (float-vector -1.0652100294828415e+02 2.3850899189710617e+01 7.2211800143122673e+00) (float-vector -1.0798899829387665e+02 2.3176899179816246e+01 -8.2606999203562737e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00) (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00) (float-vector -6.7447900772094727e+01 -1.9895900040864944e+01 1.0701199993491173e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.7335300147533417e+01 -6.0413298197090626e+00 -7.2416001930832863e+00) (float-vector -6.5791599452495575e+01 -2.0477000623941422e+01 -9.4930296763777733e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 -1.2354600243270397e+01 -5.2776900120079517e+00) (float-vector -6.0722500085830688e+01 -1.8731400370597839e+01 -5.8447499759495258e+00) (float-vector -6.0145601630210876e+01 -1.8248099833726883e+01 3.5796300508081913e+00) (float-vector -6.1640899628400803e+01 -1.0425000451505184e+01 3.9616897702217102e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_l_finger_tip_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_motor_accelerometer_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 -5.0000000000000000e-01 5.0000000000000000e-01 -5.0000000000000000e-01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 4 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 5.0000002374872565e-01) (float-vector -5.0000002374872565e-01 5.0000002374872565e-01 5.0000002374872565e-01) (float-vector 5.0000002374872565e-01 -5.0000002374872565e-01 -5.0000002374872565e-01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_motor_accelerometer_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_palm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.400000 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.800000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 65 66 0 1 0 205 2 105 0 257 65 0 205 0 66 0 105 257 209 66 65 209 442 66 205 66 442 232 442 209 206 205 442 206 442 232 214 232 233 206 232 214 232 382 233 382 232 209 212 213 214 212 214 242 213 206 214 242 214 233 372 233 230 242 233 372 233 382 230 209 230 382 73 230 209 372 230 373 373 230 413 73 413 230 371 372 373 372 371 385 242 372 385 373 393 371 393 373 413 391 393 413 73 308 413 308 391 413 391 392 393 23 159 393 393 392 23 159 371 393 159 71 371 385 371 71 242 385 396 396 385 71 357 358 242 396 357 242 242 358 212 358 357 395 395 357 396 358 395 473 212 358 473 212 434 435 213 212 435 434 212 473 473 479 434 473 426 427 473 395 426 427 479 473 313 395 396 395 313 426 10 426 11 313 11 426 10 427 426 427 491 277 491 427 10 427 277 479 9 10 11 9 356 10 10 264 491 356 264 10 11 70 9 313 315 11 315 70 11 355 356 9 355 9 72 70 72 9 264 356 474 355 474 356 8 264 265 265 264 474 491 264 8 355 24 474 24 265 474 265 345 363 8 265 363 265 24 345 363 6 8 345 6 363 6 7 8 8 7 277 277 491 8 6 345 346 346 468 6 6 468 7 468 161 7 277 7 479 7 161 479 467 468 346 160 468 467 468 160 161 444 346 345 467 346 444 444 471 467 467 471 490 490 160 467 160 55 161 160 376 55 160 490 376 376 490 471 203 376 97 376 56 55 340 56 376 376 471 97 376 203 340 54 55 56 54 161 55 56 434 54 54 434 479 161 54 479 435 434 56 404 435 56 435 404 213 404 56 339 157 213 404 404 339 157 206 213 157 205 206 207 156 206 157 156 365 206 365 207 206 205 364 1 205 207 364 364 207 365 364 365 366 365 158 408 156 158 365 365 408 366 156 157 158 168 158 169 169 158 157 408 158 168 168 282 408 169 472 168 472 282 168 169 359 472 157 360 169 169 360 359 282 472 301 301 472 359 359 360 361 301 359 361 360 157 164 164 361 360 361 192 191 301 361 220 361 191 220 192 361 164 301 281 282 301 220 281 219 220 191 220 153 136 220 136 281 153 220 219 191 192 193 191 193 219 227 219 193 219 227 430 219 154 153 430 154 219 153 154 152 155 153 152 136 153 155 154 150 152 430 150 154 152 150 149 155 152 149 149 150 151 430 151 150 15 149 151 15 17 149 155 149 489 34 489 149 17 34 149 429 151 430 15 151 429 15 16 17 15 91 16 15 429 91 33 34 17 17 16 184 17 184 33 33 428 34 489 34 428 489 87 155 489 428 87 33 319 428 87 428 319 184 319 33 117 319 184 117 184 16 85 319 117 87 319 85 85 86 87 87 86 155 155 86 135 136 155 135 135 46 136 135 86 46 374 375 86 374 86 119 85 119 86 86 375 46 119 85 117 117 118 119 374 119 134 118 134 119 375 374 134 118 133 134 375 134 133 118 379 380 117 89 118 118 89 379 380 133 118 375 133 459 459 133 380 414 380 379 380 367 459 380 414 367 459 367 375 367 368 369 367 417 368 367 414 417 375 367 466 466 367 369 368 255 369 386 368 417 386 255 368 106 369 255 466 369 106 46 466 106 466 46 375 46 106 44 269 44 106 441 106 255 269 106 441 44 45 46 46 45 136 282 45 44 282 44 269 408 282 269 269 441 408 441 254 408 254 441 255 408 254 366 121 253 254 255 256 254 254 270 121 256 270 254 253 366 254 364 366 253 253 121 120 253 129 364 253 120 129 364 129 1 1 129 2 129 120 2 120 121 122 120 122 231 231 2 120 59 105 2 2 231 59 122 272 231 272 341 231 59 231 433 341 433 231 122 139 272 341 272 494 272 457 494 139 457 272 494 457 341 341 432 433 457 348 341 348 432 341 139 138 457 457 138 348 348 138 337 432 348 433 348 337 433 137 138 139 138 304 337 137 140 138 138 140 304 141 137 370 137 141 140 139 370 137 140 141 142 140 142 305 140 305 304 304 305 81 81 80 304 337 304 80 305 483 81 305 326 483 305 142 326 79 80 81 79 81 483 79 14 80 337 80 14 266 267 79 79 483 266 267 50 79 79 50 14 126 483 326 266 483 126 389 406 266 406 267 266 266 126 389 406 244 267 50 267 244 14 50 18 243 50 244 50 243 18 406 407 244 244 407 377 243 244 377 389 229 406 407 406 229 496 407 228 407 229 228 377 407 496 377 378 243 98 377 22 98 378 377 496 22 377 21 308 378 378 98 21 378 308 307 307 243 378 98 22 21 21 22 23 22 159 23 22 496 201 159 22 201 392 21 23 308 21 392 75 307 308 308 73 75 308 392 391 307 75 243 166 243 75 18 243 12 166 215 243 243 215 12 165 166 167 166 257 167 165 215 166 166 75 257 99 13 215 215 13 12 165 99 215 12 13 14 12 14 18 99 100 13 100 101 13 13 101 14 100 99 284 284 99 495 165 495 99 167 495 165 284 495 167 58 283 284 284 283 36 284 167 58 36 100 284 35 100 36 35 101 100 202 101 35 101 202 14 35 36 37 132 35 37 202 35 132 306 37 36 306 36 283 57 283 58 283 57 306 190 37 306 57 190 306 190 189 37 37 189 132 188 189 190 57 433 190 433 188 190 57 58 59 433 57 59 337 188 433 188 337 132 132 189 188 14 132 337 14 202 132 167 59 58 105 59 257 167 257 59 257 75 65 73 74 75 65 75 74 65 74 209 73 209 74 146 72 201 159 201 71 201 72 71 146 201 496 70 71 72 72 146 355 71 464 396 70 465 71 464 71 465 70 315 465 314 464 465 314 465 315 488 396 464 488 464 314 488 497 396 497 313 396 313 488 314 313 497 488 313 314 315 24 355 53 148 355 146 355 148 53 51 52 53 51 53 148 52 24 53 146 147 148 148 180 51 148 147 180 146 496 147 180 147 228 228 147 496 228 229 180 180 229 389 389 128 180 389 126 128 126 127 128 128 179 180 127 179 128 127 126 326 127 326 327 127 327 179 327 218 179 180 179 218 327 334 335 342 40 327 335 342 327 327 40 39 327 39 218 327 326 334 326 142 334 478 142 141 142 492 334 82 142 478 142 124 492 82 124 142 478 141 370 248 83 478 478 370 248 478 83 82 370 249 248 249 370 139 248 249 247 83 248 247 82 83 84 83 247 246 83 237 84 246 237 83 246 247 121 122 247 249 122 121 247 122 249 139 271 121 270 121 271 463 463 246 121 431 246 463 246 431 237 236 84 237 431 236 237 383 240 431 431 240 236 463 383 431 463 271 383 271 256 383 270 256 271 383 256 454 454 240 383 236 240 241 454 296 240 241 240 296 108 453 454 453 296 454 454 256 108 108 256 317 317 256 255 107 69 108 108 69 453 107 108 317 296 453 69 69 295 296 241 296 295 241 295 236 236 295 217 68 295 69 131 217 295 131 295 68 67 68 69 107 200 69 200 67 69 107 317 200 67 200 297 317 318 200 297 200 318 312 420 67 68 67 420 312 67 297 297 311 312 297 318 311 386 311 318 318 255 386 318 317 255 312 311 174 386 416 311 416 174 311 417 416 386 414 415 416 414 416 417 415 174 416 414 379 415 394 415 379 379 89 394 88 394 89 394 335 415 88 335 394 88 89 90 90 89 16 16 89 117 335 88 342 342 88 90 334 415 335 492 501 334 501 415 334 456 492 123 492 456 501 123 492 124 175 501 456 415 501 175 415 175 174 173 174 175 173 175 456 456 362 173 402 362 456 456 123 402 123 124 125 123 125 402 124 82 125 125 130 131 125 131 402 125 82 130 402 131 362 173 362 216 362 131 216 173 216 298 174 173 298 312 174 298 477 312 298 298 216 477 131 68 216 68 477 216 217 131 130 84 217 130 84 130 82 217 84 236 477 68 312 420 312 68 90 16 91 91 235 90 235 342 90 462 316 91 91 429 462 235 91 316 40 235 316 40 342 235 40 316 38 316 462 31 31 38 316 31 462 429 430 31 429 30 31 32 30 221 31 221 38 31 227 32 31 227 31 430 60 61 30 30 61 279 30 279 221 60 30 32 227 28 32 32 28 27 60 32 27 193 226 227 28 227 226 27 28 29 226 484 28 29 28 484 27 29 60 60 29 104 384 29 484 29 384 102 102 104 29 484 338 384 226 338 484 338 226 192 226 193 192 338 162 384 338 192 163 162 338 163 102 384 162 102 103 104 486 103 102 162 486 102 162 163 164 353 162 164 162 353 486 164 163 192 164 401 353 164 157 401 309 353 354 354 353 401 486 353 251 251 353 309 103 486 251 250 251 252 251 309 310 251 250 103 252 251 310 349 323 309 323 310 309 309 354 349 310 323 194 194 252 310 250 252 278 252 194 278 194 195 196 195 194 323 194 196 278 278 196 250 208 196 195 196 347 250 196 208 347 323 324 195 347 208 195 195 436 347 195 324 436 436 423 347 347 423 103 347 103 250 423 436 114 436 475 114 436 476 475 476 436 324 324 323 498 324 498 476 475 476 447 476 485 447 438 476 498 485 476 438 498 323 437 438 498 437 437 323 349 437 110 438 349 111 437 111 110 437 458 485 438 110 458 438 109 110 111 110 109 48 325 458 110 325 110 48 111 349 94 111 94 109 349 354 94 92 93 94 94 76 109 354 92 94 93 76 94 76 48 109 76 77 78 76 268 77 76 78 451 76 93 268 451 48 76 92 268 93 268 439 77 92 157 268 268 157 439 439 381 77 381 78 77 260 451 78 260 78 452 78 381 452 451 260 450 451 450 48 258 259 260 260 452 258 450 260 259 302 452 381 452 302 258 204 302 381 439 204 381 204 210 302 302 210 299 258 302 299 289 322 258 322 259 258 289 258 299 259 322 321 259 321 450 320 321 322 288 320 322 289 288 322 288 289 290 294 290 289 294 289 299 288 499 320 288 290 352 352 424 288 288 424 499 290 351 352 387 290 294 387 351 290 351 387 388 351 197 399 351 388 197 352 351 399 294 469 387 388 387 198 198 387 469 197 388 198 197 198 199 199 399 197 352 399 333 199 333 399 238 199 239 238 333 199 199 198 239 410 333 238 352 333 410 410 238 411 238 239 411 410 411 448 410 448 352 352 331 424 352 448 331 239 448 411 239 331 448 331 332 303 331 239 332 424 331 303 424 303 425 425 461 424 461 499 424 41 143 303 42 303 332 303 143 425 303 42 41 332 239 42 41 42 43 42 198 43 198 42 239 20 143 41 41 43 20 4 19 20 20 329 4 43 336 20 336 329 20 143 20 19 19 291 183 183 143 19 19 3 291 3 19 4 291 403 397 397 287 291 3 403 291 183 291 287 181 182 183 181 183 287 143 183 182 274 287 275 287 397 398 181 287 274 287 398 275 274 275 25 181 274 25 275 345 26 25 275 26 449 345 275 449 275 398 398 397 449 449 444 345 449 397 444 24 26 345 24 25 26 52 181 25 52 25 24 52 51 181 343 182 181 51 343 181 343 51 344 344 405 343 144 343 405 182 343 144 182 144 143 143 144 145 144 405 145 344 263 405 405 263 145 425 143 145 425 145 461 145 263 461 261 262 263 461 263 262 344 261 263 461 262 499 480 499 262 481 480 262 481 262 261 320 499 480 480 481 390 390 320 480 481 445 390 481 261 445 321 320 390 482 390 445 47 390 482 321 390 47 445 446 447 445 447 485 445 261 446 485 482 445 47 482 325 458 325 482 485 458 482 325 48 47 47 48 49 47 49 321 48 450 49 450 321 49 446 409 344 446 261 409 460 446 51 446 344 51 446 460 447 261 344 409 460 475 447 460 51 115 460 115 475 180 218 51 51 116 115 51 218 116 114 115 116 115 114 475 116 218 112 116 279 280 114 116 280 112 279 116 218 39 113 112 218 113 112 113 38 112 38 221 279 112 221 280 279 61 423 114 280 280 61 104 104 423 280 104 61 60 104 103 423 38 39 40 113 39 38 397 443 444 471 444 443 403 443 397 403 471 443 178 471 403 471 178 95 97 471 95 403 3 178 3 4 5 5 178 3 328 4 329 5 4 171 500 171 4 4 328 500 328 329 330 500 328 400 328 330 400 336 330 329 43 330 336 43 400 330 43 455 400 500 400 455 171 500 455 172 455 43 172 171 455 170 171 172 171 170 5 43 273 172 172 273 170 43 419 273 43 225 419 198 225 43 418 273 419 170 273 418 170 418 5 419 276 418 5 418 276 419 245 276 245 419 225 5 276 178 178 276 245 225 62 245 64 178 245 245 62 64 64 95 178 95 96 97 95 64 96 176 96 177 64 177 96 203 96 176 96 203 97 222 223 177 234 222 177 64 234 177 177 223 176 223 222 286 286 222 198 222 224 198 234 224 222 176 223 211 223 286 211 285 211 286 286 186 350 350 285 286 286 198 186 198 224 225 186 198 187 187 198 469 421 412 225 412 62 225 225 224 421 63 412 421 422 421 487 224 487 421 421 422 63 62 412 63 62 63 64 422 64 63 422 487 64 234 487 224 64 487 234 469 294 470 187 469 470 293 470 294 470 293 187 185 186 187 185 187 293 292 293 294 292 185 293 292 186 185 186 292 493 186 493 350 493 292 294 350 493 300 493 294 300 211 350 300 350 211 285 294 299 300 300 299 211 210 176 211 299 210 211 204 176 210 203 176 204 204 439 440 204 440 203 203 339 340 203 440 339 339 440 439 439 157 339 339 56 340 157 92 401 401 92 354 281 45 282 45 281 136))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.1654100036621094e+02 2.8819299697875977e+01 2.1372100830078125e+01 1.1831100463867188e+02 2.4029899597167969e+01 2.2009498596191406e+01 1.2028100585937500e+02 2.0551099777221680e+01 2.0041101455688477e+01 4.1848899841308594e+01 2.3961900711059570e+01 -1.9932701110839844e+01 4.1461299896240234e+01 2.2120000839233398e+01 -1.9689201354980469e+01 4.1461200714111328e+01 2.1937898635864258e+01 -9.5684700012207031e+00 6.1490200042724609e+01 4.6300003051757812e+01 -1.7233299255371094e+01 6.3590801239013672e+01 4.7331298828125000e+01 1.7376600265502930e+01 6.6594604492187500e+01 4.8580097198486328e+01 -1.7121700286865234e+01 8.2293693542480469e+01 5.0280700683593750e+01 -1.8978599548339844e+01 7.6395301818847656e+01 5.0793701171875000e+01 -1.7271301269531250e+01 8.1030303955078125e+01 5.1014698028564453e+01 -1.7174200057983398e+01 1.1479999542236328e+02 3.2614398956298828e+01 -1.3004799842834473e+01 1.1593800354003906e+02 3.2234901428222656e+01 -1.2902700424194336e+01 1.1604299926757812e+02 3.2229698181152344e+01 -1.9731100082397461e+01 1.1605799865722656e+02 -3.2264602661132812e+01 -1.9712699890136719e+01 1.1850199890136719e+02 -2.7195098876953125e+01 -1.9759698867797852e+01 1.1748900604248047e+02 -3.2998699188232422e+01 -1.9747600555419922e+01 1.1488700103759766e+02 3.2486598968505859e+01 -1.9778100967407227e+01 4.1962600708007812e+01 2.1884300231933594e+01 -2.1592199325561523e+01 4.1770000457763672e+01 3.8540201187133789e+00 -2.1172401428222656e+01 1.0538400268554688e+02 4.2581001281738281e+01 -1.8671098709106445e+01 1.0360399627685547e+02 4.2883300781250000e+01 -2.0329401016235352e+01 1.0147100067138672e+02 4.4997497558593750e+01 -1.8635398864746094e+01 6.7597396850585938e+01 4.6218498229980469e+01 -2.0792798995971680e+01 5.2277099609375000e+01 3.2314098358154297e+01 -2.3881799697875977e+01 6.2007999420166016e+01 4.4043197631835938e+01 -2.0751501083374023e+01 1.0396599578857422e+02 -4.2950897216796875e+01 -1.9891799926757812e+01 1.0424599456787109e+02 -4.3347000122070312e+01 -1.8643299102783203e+01 9.9570800781250000e+01 -4.6006698608398438e+01 -1.8625799179077148e+01 1.0612799835205078e+02 -3.9675601959228516e+01 -2.1942399978637695e+01 1.1184799957275391e+02 -3.5224899291992188e+01 -2.2293399810791016e+01 1.0740299987792969e+02 -4.0114002227783203e+01 -2.0729200363159180e+01 1.1833499908447266e+02 -3.2949001312255859e+01 -1.3177000045776367e+01 1.1732900238037109e+02 -3.2930797576904297e+01 4.0176301002502441e+00 1.1844200134277344e+02 3.2897201538085938e+01 -1.2006199836730957e+01 1.1838299560546875e+02 3.2924800872802734e+01 5.3936901092529297e+00 1.1911799621582031e+02 3.2230701446533203e+01 -1.0289499282836914e+01 1.1467099761962891e+02 -2.7561100006103516e+01 -2.3782100677490234e+01 1.1789900207519531e+02 -1.7338798522949219e+01 -2.3882598876953125e+01 1.1865399932861328e+02 -2.1166099548339844e+01 -2.2712999343872070e+01 4.1932003021240234e+01 6.2127596139907837e-01 -2.1483600616455078e+01 2.9449998855590820e+01 -2.4710199832916260e+00 -2.1323400497436523e+01 2.9449998855590820e+01 2.4340200424194336e+00 -2.1343299865722656e+01 1.1990799713134766e+02 -2.0013799667358398e+01 2.1360099792480469e+01 1.1818999481201172e+02 -2.5736099243164062e+01 2.0935001373291016e+01 1.2003300476074219e+02 -2.1960500717163086e+01 1.9855798721313477e+01 6.0512302398681641e+01 -4.5624301910400391e+01 1.7693199157714844e+01 6.1396099090576172e+01 -4.5489299774169922e+01 1.9152299880981445e+01 5.0121299743652344e+01 -3.4111701965332031e+01 2.0814599990844727e+01 1.1603300476074219e+02 3.0545000076293945e+01 -2.0177000045776367e+01 7.4131401062011719e+01 -3.8402198791503906e+01 -2.4230899810791016e+01 5.3492900848388672e+01 3.1628898620605469e+01 -2.4233798980712891e+01 7.4845100402832031e+01 3.8537700653076172e+01 -2.4218099594116211e+01 6.2318798065185547e+01 4.4542396545410156e+01 2.0572299957275391e+01 5.1299499511718750e+01 3.4146900177001953e+01 2.2306499481201172e+01 5.2058300018310547e+01 3.2318302154541016e+01 2.3839698791503906e+01 1.1861799621582031e+02 3.2773700714111328e+01 1.9747798919677734e+01 1.1768000030517578e+02 3.3028202056884766e+01 1.9747499465942383e+01 1.1923200225830078e+02 2.5752300262451172e+01 1.9770500183105469e+01 1.0177099609375000e+02 -4.3595298767089844e+01 -2.0596899032592773e+01 9.8403602600097656e+01 -4.4433097839355469e+01 -2.1070598602294922e+01 4.1448600769042969e+01 2.0201200485229492e+01 7.2723398208618164e+00 4.1445999145507812e+01 1.8578599929809570e+01 1.0757599830627441e+01 4.1475200653076172e+01 2.1937999725341797e+01 2.0074300765991211e+01 1.1415100097656250e+02 3.3124500274658203e+01 2.0921901702880859e+01 1.1377199554443359e+02 3.1981100082397461e+01 2.2530599594116211e+01 1.2519900512695312e+02 -5.3969597816467285e+00 7.3635001182556152e+00 1.2554598999023438e+02 -4.5443401336669922e+00 -6.0654797554016113e+00 1.2552200317382812e+02 -4.5169496536254883e+00 1.8507799148559570e+01 8.6568397521972656e+01 5.0036502838134766e+01 -1.8663000106811523e+01 9.1381294250488281e+01 4.9043701171875000e+01 -1.8709600448608398e+01 8.7309303283691406e+01 4.9024803161621094e+01 -1.9933599472045898e+01 1.0992900085449219e+02 3.7912998199462891e+01 2.0971199035644531e+01 1.1227400207519531e+02 3.5685699462890625e+01 2.0797201156616211e+01 1.1213999938964844e+02 3.6172302246093750e+01 1.9721399307250977e+01 6.4227500915527344e+01 -4.5120998382568359e+01 2.0710599899291992e+01 5.2985198974609375e+01 -3.1408700942993164e+01 2.4222700119018555e+01 5.2224700927734375e+01 -3.2336997985839844e+01 2.3865999221801758e+01 1.1925299835205078e+02 2.3703201293945312e+01 -2.0150600433349609e+01 1.1949100494384766e+02 2.4370899200439453e+01 -1.9778499603271484e+01 1.2063700103759766e+02 1.8895000457763672e+01 -2.0093000411987305e+01 1.2156199645996094e+02 6.2555799484252930e+00 -1.8006399154663086e+01 1.2156300354003906e+02 6.2498903274536133e+00 4.0827598571777344e+00 1.2415999603271484e+02 6.1299600601196289e+00 -6.5868797302246094e+00 1.2100000000000000e+02 -2.8626800537109375e+01 1.9474700927734375e+01 1.2218099975585938e+02 -2.5639499664306641e+01 1.9726301193237305e+01 1.1886199951171875e+02 -3.2624599456787109e+01 1.9689599990844727e+01 1.2106300354003906e+02 -1.6888198852539062e+01 -2.0078699111938477e+01 1.2159700012207031e+02 -1.7674699783325195e+01 -1.9771600723266602e+01 1.1909600067138672e+02 -2.4157001495361328e+01 -2.0106000900268555e+01 1.1707799530029297e+02 -2.8637100219726562e+01 -2.0141799926757812e+01 7.7539299011230469e+01 -4.7723598480224609e+01 2.1053199768066406e+01 7.0501197814941406e+01 -4.6717300415039062e+01 2.0937400817871094e+01 7.4367904663085938e+01 -4.9118198394775391e+01 1.9948200225830078e+01 4.2023498535156250e+01 2.4483001708984375e+01 1.9945800781250000e+01 4.1979301452636719e+01 2.2280099868774414e+01 2.1524398803710938e+01 4.2973598480224609e+01 2.4989999771118164e+01 2.1863000869750977e+01 1.0706099700927734e+02 4.0556198120117188e+01 -2.0412199020385742e+01 1.1578000640869141e+02 3.2241500854492188e+01 -4.5030097961425781e+00 1.1765200042724609e+02 3.3035400390625000e+01 -5.5160603523254395e+00 1.1738400268554688e+02 3.2976898193359375e+01 -1.6216899871826172e+01 9.5943603515625000e+01 -4.7594799041748047e+01 -1.8566099166870117e+01 8.9679702758789062e+01 -4.9457302093505859e+01 -1.8623399734497070e+01 9.4823501586914062e+01 -4.7184700012207031e+01 -1.9878499984741211e+01 1.1793199920654297e+02 2.6954000473022461e+01 2.0128398895263672e+01 1.2137500000000000e+02 -1.4572600364685059e+01 2.0132999420166016e+01 1.2416300201416016e+02 -5.2244997024536133e+00 1.9358800888061523e+01 1.2404299926757812e+02 -3.7942500114440918e+00 1.9900299072265625e+01 6.7845298767089844e+01 -4.7943000793457031e+01 1.9431900024414062e+01 6.6834899902343750e+01 -4.8663002014160156e+01 1.7187700271606445e+01 7.0600097656250000e+01 -4.9512699127197266e+01 1.8100301742553711e+01 1.0911999511718750e+02 -3.3581100463867188e+01 -2.4208101272583008e+01 1.1496800231933594e+02 -2.2546800613403320e+01 -2.4256000518798828e+01 8.0946800231933594e+01 -4.8766098022460938e+01 -2.0619400024414062e+01 7.7487197875976562e+01 -4.7761100769042969e+01 -2.1010900497436523e+01 8.3322006225585938e+01 -3.8958900451660156e+01 -2.4240798950195312e+01 1.2089300537109375e+02 -2.8814199447631836e+01 -1.9726600646972656e+01 1.2399200439453125e+02 -1.8722000122070312e+01 -1.9750000000000000e+01 1.2271299743652344e+02 -2.4364000320434570e+01 -1.9490900039672852e+01 1.2152200317382812e+02 1.3514899253845215e+01 2.0053100585937500e+01 1.2155999755859375e+02 7.0005502700805664e+00 2.0149900436401367e+01 1.2205699920654297e+02 6.9977798461914062e+00 1.9776201248168945e+01 1.2349600219726562e+02 4.3771300315856934e+00 -1.9899000167846680e+01 1.2156700134277344e+02 5.3662900924682617e+00 -1.9448999404907227e+01 1.2415599822998047e+02 5.4748597145080566e+00 -1.9120100021362305e+01 1.1966200256347656e+02 1.5923200607299805e+01 -2.2844299316406250e+01 1.1958499908447266e+02 1.1167099952697754e+01 -2.3250200271606445e+01 1.1814899444580078e+02 1.3589200019836426e+01 -2.3996099472045898e+01 1.2013899993896484e+02 1.8768501281738281e+01 2.1438699722290039e+01 1.2458799743652344e+02 5.9992799758911133e+00 -1.8001298904418945e+01 1.2553000640869141e+02 4.5559401512145996e+00 -1.8481298446655273e+01 1.1880099487304688e+02 3.2646598815917969e+01 -1.9732198715209961e+01 1.2495400238037109e+02 -1.3428999900817871e+01 -1.9517200469970703e+01 1.2414199829101562e+02 -1.9249799728393555e+01 -1.9527099609375000e+01 1.1949100494384766e+02 -2.4370899200439453e+01 1.9778499603271484e+01 1.1672000122070312e+02 -2.9319400787353516e+01 2.0149900436401367e+01 1.2504999542236328e+02 9.9865093231201172e+00 -1.9697200775146484e+01 1.2489099884033203e+02 1.4242899894714355e+01 -1.9663299560546875e+01 1.2508200073242188e+02 1.0018800735473633e+01 3.3295898437500000e+00 1.2204799652099609e+02 7.0051898956298828e+00 -1.9770799636840820e+01 1.2206300354003906e+02 7.0000000000000000e+00 -1.5552700042724609e+01 1.2155899810791016e+02 6.9997301101684570e+00 -2.0134199142456055e+01 4.3363399505615234e+01 4.8121399879455566e+00 -2.3222700119018555e+01 4.4737300872802734e+01 -8.3035602569580078e+00 -2.3961400985717773e+01 4.4120700836181641e+01 -2.2482900619506836e+01 -2.3703201293945312e+01 8.6881401062011719e+01 4.7569099426269531e+01 -2.0928899765014648e+01 8.8601203918457031e+01 3.7955101013183594e+01 -2.4218900680541992e+01 8.1255195617675781e+01 3.9069000244140625e+01 -2.4229598999023438e+01 1.1626799774169922e+02 -3.2354103088378906e+01 1.0055700540542603e+00 1.1494000244140625e+02 -3.2450901031494141e+01 -2.6776200532913208e-01 1.1505200195312500e+02 -3.2389099121093750e+01 -1.5315599441528320e+01 1.1543299865722656e+02 -3.2317199707031250e+01 8.3978300094604492e+00 1.1493899536132812e+02 -3.2432300567626953e+01 2.0050098419189453e+01 1.1474900054931641e+02 -3.2678298950195312e+01 8.1221494674682617e+00 1.1599300384521484e+02 -3.2266399383544922e+01 1.9703500747680664e+01 1.1725699615478516e+02 1.1965000152587891e+01 2.4244100570678711e+01 8.5003005981445312e+01 -3.8562202453613281e+01 2.4246299743652344e+01 1.1735499572753906e+02 -1.1131900787353516e+01 2.4220500946044922e+01 9.6333900451660156e+01 4.7427501678466797e+01 -1.8758600234985352e+01 5.0082603454589844e+01 3.3874401092529297e+01 2.1198301315307617e+01 6.1590198516845703e+01 4.5308399200439453e+01 1.9556098937988281e+01 9.6421005249023438e+01 -4.7370002746582031e+01 1.8783901214599609e+01 1.0019699859619141e+02 -4.5080200195312500e+01 1.9758300781250000e+01 1.0124299621582031e+02 -4.2915699005126953e+01 2.1440999984741211e+01 1.1527700042724609e+02 3.2353698730468750e+01 8.5873804092407227e+00 1.1488700103759766e+02 3.2554500579833984e+01 1.4077199935913086e+01 1.1590599822998047e+02 3.2271999359130859e+01 1.9759901046752930e+01 1.1812300109863281e+02 -1.5584899902343750e+01 2.3930799484252930e+01 1.1414500427246094e+02 -2.4787300109863281e+01 2.4235601425170898e+01 4.1445602416992188e+01 1.9036300659179688e+01 -9.9389896392822266e+00 4.1449100494384766e+01 1.6890701293945312e+01 -1.3332700729370117e+01 2.9449998855590820e+01 1.9019199371337891e+01 -1.0037799835205078e+01 1.2415499877929688e+02 -5.7316303253173828e+00 -1.8848499298095703e+01 1.2156300354003906e+02 -6.2469797134399414e+00 -1.8017700195312500e+01 1.2156500244140625e+02 -5.4651203155517578e+00 -1.9351699829101562e+01 4.2497501373291016e+01 5.2111001014709473e+00 2.2346799850463867e+01 4.1506500244140625e+01 7.3689904212951660e+00 2.0205799102783203e+01 4.1690200805664062e+01 2.3505701065063477e+01 4.7142801284790039e+00 1.1864499664306641e+02 -6.5876703262329102e+00 -2.3852499008178711e+01 1.1704000091552734e+02 1.5026399612426758e+01 -2.4248300552368164e+01 4.5662300109863281e+01 2.2897298812866211e+01 -2.4236000061035156e+01 4.4576499938964844e+01 1.5580699920654297e+01 -2.3915401458740234e+01 4.3443500518798828e+01 2.2479099273681641e+01 -2.3248498916625977e+01 1.1875700378417969e+02 -3.2695899963378906e+01 -1.9715198516845703e+01 2.9450698852539062e+01 -1.5205499649047852e+01 1.5197799682617188e+01 2.9451499938964844e+01 -1.1640099525451660e+01 1.8076799392700195e+01 2.9454101562500000e+01 -1.8656299591064453e+01 1.0724600791931152e+01 1.2233799743652344e+02 2.5371700286865234e+01 -1.9517099380493164e+01 1.2054399871826172e+02 2.9552598953247070e+01 -1.9501600265502930e+01 1.2125399780273438e+02 2.8054500579833984e+01 1.9512899398803711e+01 1.1140499877929688e+02 -3.6038398742675781e+01 2.1706399917602539e+01 1.0604000091552734e+02 -4.1192798614501953e+01 2.0605699539184570e+01 1.0979799652099609e+02 -3.8754299163818359e+01 1.9404298782348633e+01 8.3412498474121094e+01 -5.0918399810791016e+01 1.6443099975585938e+01 8.2245002746582031e+01 -5.0994197845458984e+01 -1.6992900848388672e+01 8.6562797546386719e+01 -5.0568698883056641e+01 -1.0563799858093262e+01 2.9450099945068359e+01 -2.1184900283813477e+01 -3.6931798458099365e+00 2.9449998855590820e+01 -2.0445899963378906e+01 6.5655498504638672e+00 2.9449998855590820e+01 -1.9360700607299805e+01 -9.3323698043823242e+00 1.2442700195312500e+02 -6.0271401405334473e+00 1.8212699890136719e+01 9.5909698486328125e+01 4.6076499938964844e+01 -2.0557399749755859e+01 1.1787100219726562e+02 3.3044597625732422e+01 -1.9747798919677734e+01 4.3507301330566406e+01 2.2327701568603516e+01 2.3380701065063477e+01 4.4268398284912109e+01 -1.1331999778747559e+01 2.3785600662231445e+01 1.1562400054931641e+02 2.6839601516723633e+01 2.3416000366210938e+01 1.1578600311279297e+02 2.1190399169921875e+01 2.4250699996948242e+01 1.1728700256347656e+02 2.0083398818969727e+01 2.3868900299072266e+01 8.6562202453613281e+01 -5.0484897613525391e+01 -1.7434700012207031e+01 1.1066400146484375e+02 3.5422897338867188e+01 2.2967699050903320e+01 4.2715000152587891e+01 -2.1253200531005859e+01 2.2587200164794922e+01 4.1871902465820312e+01 -3.0555698871612549e+00 2.1301898956298828e+01 7.8002403259277344e+01 4.7927398681640625e+01 2.0995498657226562e+01 8.0304199218750000e+01 3.9039802551269531e+01 2.4248100280761719e+01 8.6040496826171875e+01 3.8676998138427734e+01 2.4187700271606445e+01 1.1477999877929688e+02 3.2641399383544922e+01 1.2448700666427612e+00 1.2554700469970703e+02 -4.8945403099060059e+00 -1.8038099288940430e+01 1.2523099517822266e+02 5.3644199371337891e+00 -3.0804901123046875e+00 1.1725600433349609e+02 -9.4152898788452148e+00 -2.4246200561523438e+01 1.1267500305175781e+02 -3.5539100646972656e+01 1.9991199493408203e+01 1.1403199768066406e+02 -3.2502799987792969e+01 2.1869899749755859e+01 1.1058600616455078e+02 -3.5444000244140625e+01 -2.3014999389648438e+01 2.9451999664306641e+01 7.9106698036193848e+00 2.0037500381469727e+01 4.1908802032470703e+01 2.6628899574279785e+00 2.1350700378417969e+01 2.9449899673461914e+01 1.2911100387573242e+01 1.7200500488281250e+01 2.9450599670410156e+01 2.1122200012207031e+01 4.1480898857116699e+00 1.0661199951171875e+02 -4.1649898529052734e+01 1.8603500366210938e+01 1.0902899932861328e+02 -3.9587596893310547e+01 -1.9060300827026367e+01 1.0874500274658203e+02 3.3654399871826172e+01 -2.4233699798583984e+01 1.1331700134277344e+02 2.6757999420166016e+01 -2.4224399566650391e+01 1.0399299621582031e+02 4.1632598876953125e+01 2.1390899658203125e+01 1.2199500274658203e+02 1.4932700157165527e+01 1.9752599716186523e+01 1.0912699890136719e+02 3.3405899047851562e+01 2.4258600234985352e+01 9.6535598754882812e+01 4.4738597869873047e+01 2.1203899383544922e+01 4.1447799682617188e+01 1.1319199562072754e+01 1.8237798690795898e+01 1.1847099304199219e+02 -2.4286499023437500e+01 -2.1516099929809570e+01 1.2518499755859375e+02 5.3708100318908691e+00 1.7989000320434570e+01 1.2409799957275391e+02 6.1388902664184570e+00 1.7529298782348633e+01 2.9452400207519531e+01 -1.6320199966430664e+01 -1.4042399406433105e+01 2.9449998855590820e+01 -9.0945901870727539e+00 -1.9463998794555664e+01 1.2527500152587891e+02 4.0470399856567383e+00 1.9094501495361328e+01 1.2556399536132812e+02 3.8000998497009277e+00 1.8034000396728516e+01 8.7470504760742188e+01 4.7957099914550781e+01 2.0746700286865234e+01 1.1246299743652344e+02 3.5779899597167969e+01 -2.0218299865722656e+01 1.1365599822998047e+02 3.3056800842285156e+01 -2.1897500991821289e+01 4.1455802917480469e+01 2.1384599685668945e+01 2.2605700492858887e+00 1.2156300354003906e+02 6.2451696395874023e+00 1.8022300720214844e+01 1.2156300354003906e+02 7.0000000000000000e+00 1.0747600555419922e+01 1.2156300354003906e+02 7.0000000000000000e+00 1.7906399965286255e+00 1.2206300354003906e+02 7.0000000000000000e+00 8.3286905288696289e+00 8.6563293457031250e+01 -5.0017402648925781e+01 -1.2963099479675293e+00 8.6581398010253906e+01 -5.0049201965332031e+01 1.8601900100708008e+01 8.6563293457031250e+01 -5.0559402465820312e+01 9.1940202713012695e+00 1.2098600006103516e+02 1.2696400642395020e+01 2.1552900314331055e+01 1.2083100128173828e+02 -7.2210496664047241e-01 2.1907600402832031e+01 1.2155400085449219e+02 -6.9981999397277832e+00 2.0158000946044922e+01 1.2158300018310547e+02 -5.0495600700378418e-01 2.0014400482177734e+01 1.1489199829101562e+02 3.2459999084472656e+01 2.0126701354980469e+01 4.3914299011230469e+01 -2.5972900390625000e+01 2.2440999984741211e+01 4.6688999176025391e+01 -3.0191200256347656e+01 2.1198799133300781e+01 5.0702800750732422e+01 -3.2870800018310547e+01 2.2906299591064453e+01 5.1347099304199219e+01 -3.2749599456787109e+01 -2.3373899459838867e+01 4.5005100250244141e+01 -2.6748800277709961e+01 -2.2832500457763672e+01 4.5809803009033203e+01 -2.5172300338745117e+01 -2.3899999618530273e+01 7.2368896484375000e+01 4.9847099304199219e+01 -1.8287500381469727e+01 6.8518104553222656e+01 4.8139698028564453e+01 -1.9446098327636719e+01 1.1872799682617188e+02 2.2832500457763672e+01 -2.2009401321411133e+01 1.1693399810791016e+02 2.7360700607299805e+01 -2.1905700683593750e+01 7.5895599365234375e+01 -3.8876602172851562e+01 2.4225101470947266e+01 1.2014500427246094e+02 -1.6668500900268555e+01 2.2199598312377930e+01 1.2156300354003906e+02 1.0851199626922607e+00 2.0165199279785156e+01 1.2156300354003906e+02 3.8944101333618164e+00 1.9998800277709961e+01 1.2502400207519531e+02 9.9738397598266602e+00 1.9713399887084961e+01 2.9450201034545898e+01 2.0599599838256836e+01 -6.0919404029846191e+00 4.7122299194335938e+01 2.6560800552368164e+01 -2.3925800323486328e+01 5.1354999542236328e+01 3.3145000457763672e+01 -2.3125200271606445e+01 4.1450401306152344e+01 2.1425399780273438e+01 -1.4014999866485596e+00 6.7718902587890625e+01 4.8960700988769531e+01 1.6951999664306641e+01 8.6562698364257812e+01 -5.0569000244140625e+01 1.6153399944305420e+00 1.0523399353027344e+02 -3.8684600830078125e+01 -2.2714199066162109e+01 8.7970802307128906e+01 -4.7339996337890625e+01 -2.0930999755859375e+01 1.1642400360107422e+02 -2.8069200515747070e+01 2.2089599609375000e+01 1.1822499847412109e+02 -2.2612699508666992e+01 2.2685699462890625e+01 1.1841799926757812e+02 3.2908000946044922e+01 1.2055000305175781e+01 1.1731700134277344e+02 3.2933498382568359e+01 1.0373600006103516e+01 2.9450399398803711e+01 -4.0197496414184570e+00 2.1087100982666016e+01 2.9450298309326172e+01 1.1759699583053589e+00 2.1488599777221680e+01 4.4620399475097656e+01 2.5843999862670898e+01 -2.3104600906372070e+01 4.2160598754882812e+01 -2.4873600006103516e+01 -1.9721300125122070e+01 4.2020000457763672e+01 -2.4550701141357422e+01 1.9998500823974609e+01 4.1572998046875000e+01 -2.2780099868774414e+01 2.5766799449920654e+00 4.2974300384521484e+01 2.4490398406982422e+01 -2.2228799819946289e+01 4.1449100494384766e+01 -1.4331899642944336e+01 1.5987400054931641e+01 4.1449497222900391e+01 -1.6877099990844727e+01 1.3331399917602539e+01 4.1484100341796875e+01 -2.1851800918579102e+01 1.9717401504516602e+01 1.2556501007080078e+02 4.4949302673339844e+00 7.4721398353576660e+00 1.2554800415039062e+02 -2.4081601202487946e-01 1.8444801330566406e+01 1.2417399597167969e+02 -6.1183500289916992e+00 6.0768003463745117e+00 1.2411899566650391e+02 -6.1393198966979980e+00 -1.7518001556396484e+01 4.1921100616455078e+01 -2.2732299804687500e+01 2.1374401092529297e+01 4.1540802001953125e+01 -7.1070599555969238e+00 2.0256099700927734e+01 1.1436600494384766e+02 -3.0236999511718750e+01 2.2997900009155273e+01 4.3808502197265625e+01 -2.2717800140380859e+01 2.3489101409912109e+01 4.1893402099609375e+01 -2.7665500640869141e+00 -2.1349500656127930e+01 1.2153800201416016e+02 1.7149499893188477e+01 -1.9765699386596680e+01 1.2143099975585938e+02 1.2672100067138672e+01 -2.0265100479125977e+01 1.1907199859619141e+02 3.2347499847412109e+01 1.9513999938964844e+01 1.1054000091552734e+02 3.8017299652099609e+01 1.7951200008392334e+00 1.0793899536132812e+02 4.0545898437500000e+01 1.8810300827026367e+01 8.2682403564453125e+01 -5.0309898376464844e+01 1.8905900955200195e+01 8.6556900024414062e+01 -5.0553501129150391e+01 1.7278999328613281e+01 1.2156300354003906e+02 -6.2444200515747070e+00 -6.9675701856613159e-01 1.2427500152587891e+02 -6.1088700294494629e+00 -6.6244401931762695e+00 8.3356597900390625e+01 5.0927299499511719e+01 1.6988599777221680e+01 8.6559799194335938e+01 5.0580799102783203e+01 -2.9593899250030518e+00 8.6560501098632812e+01 5.0589900970458984e+01 -1.7030900955200195e+01 1.1646399688720703e+02 -2.7535799026489258e+01 -2.2384300231933594e+01 1.2156700134277344e+02 -4.8942399024963379e+00 1.9851400375366211e+01 1.2156099700927734e+02 -6.2293601036071777e+00 1.8089401245117188e+01 1.1912299346923828e+02 -3.2290699005126953e+01 -4.7652201652526855e+00 4.3421901702880859e+01 -2.7150299072265625e+01 -1.9364700317382812e+01 4.8006000518798828e+01 -3.2157501220703125e+01 1.9838899612426758e+01 4.3395999908447266e+01 -2.7102100372314453e+01 2.0171800613403320e+01 7.8084495544433594e+01 -5.0971900939941406e+01 1.7122600555419922e+01 7.7095802307128906e+01 -5.0876499176025391e+01 -1.7087100982666016e+01 6.3486202239990234e+01 -4.7273097991943359e+01 1.7081399917602539e+01 1.2087000274658203e+02 1.1438300132751465e+01 -2.1848699569702148e+01 1.1984200286865234e+02 -1.2806900024414062e+01 -2.3092399597167969e+01 4.1445400238037109e+01 1.0852499961853027e+01 -1.8539798736572266e+01 4.1521697998046875e+01 7.4629402160644531e+00 -2.0129699707031250e+01 2.9450799942016602e+01 8.8233795166015625e+00 -1.9572601318359375e+01 4.1494701385498047e+01 -7.6232600212097168e+00 -2.0119899749755859e+01 2.9452400207519531e+01 -6.1314601898193359e+00 -2.0570798873901367e+01 4.1449401855468750e+01 -1.7941299438476562e+01 -1.1848400115966797e+01 1.2104299926757812e+02 -3.4721398353576660e-01 -2.1517700195312500e+01 1.2101799774169922e+02 -1.1870800018310547e+01 -2.1538600921630859e+01 2.9451999664306641e+01 5.6320900917053223e+00 -2.0720699310302734e+01 1.2360499572753906e+02 2.1061800003051758e+01 -1.9662199020385742e+01 1.0237000274658203e+02 -4.4525600433349609e+01 1.8729499816894531e+01 4.6008998870849609e+01 2.3310199737548828e+01 2.4242300033569336e+01 4.5149299621582031e+01 2.5467100143432617e+01 2.3525800704956055e+01 1.2477300262451172e+02 1.4673699378967285e+01 1.9649398803710938e+01 1.2036299896240234e+02 -1.8118400573730469e+01 -2.1322500228881836e+01 4.5955596923828125e+01 1.3097300529479980e+01 -2.4247200012207031e+01 5.3228900909423828e+01 -3.1484498977661133e+01 -2.4235399246215820e+01 6.1658401489257812e+01 4.5324096679687500e+01 -1.9570499420166016e+01 5.9491199493408203e+01 4.4742000579833984e+01 -1.7504899978637695e+01 8.6561096191406250e+01 -5.0012901306152344e+01 -1.8737998962402344e+01 1.2450399780273438e+02 1.7211500167846680e+01 8.8741995394229889e-02 7.6335197448730469e+01 -5.0503200531005859e+01 1.8162900924682617e+01 2.9450399398803711e+01 -6.8196997642517090e+00 2.0367799758911133e+01 4.1458400726318359e+01 -2.1431098937988281e+01 -1.9154599905014038e+00 4.1502502441406250e+01 -2.2397899627685547e+01 -1.9669300079345703e+01 8.9915000915527344e+01 -4.8864700317382812e+01 1.9548398971557617e+01 8.0191101074218750e+01 -4.9564800262451172e+01 1.9968200683593750e+01 7.8857894897460938e+01 4.8629398345947266e+01 -2.0719400405883789e+01 7.7992996215820312e+01 5.0031299591064453e+01 -1.9285200119018555e+01 8.2900199890136719e+01 4.9613597869873047e+01 1.9807298660278320e+01 7.7579299926757812e+01 4.9055099487304688e+01 2.0289400100708008e+01 1.1334799957275391e+02 -2.8897199630737305e+01 2.3953001022338867e+01 1.0887799835205078e+02 -3.3707099914550781e+01 2.4216800689697266e+01 1.1023600006103516e+02 -3.5348800659179688e+01 2.3302799224853516e+01 1.2530400085449219e+02 -4.2098202705383301e+00 -1.8979999542236328e+01 6.5223594665527344e+01 4.7747299194335938e+01 -1.8123901367187500e+01 1.1929499816894531e+02 1.8003900527954102e+01 2.2880399703979492e+01 1.1877799987792969e+02 1.1789199829101562e+01 2.3743000030517578e+01 1.2020999908447266e+02 1.0971300125122070e+01 2.2728099822998047e+01 1.2505699920654297e+02 -9.9936103820800781e+00 1.9732500076293945e+01 1.2206300354003906e+02 -7.0000000000000000e+00 1.1625100135803223e+01 1.2206199645996094e+02 -7.0005102157592773e+00 1.9778499603271484e+01 1.2206300354003906e+02 7.0000000000000000e+00 -2.0538301467895508e+00 9.5069999694824219e+01 4.7896797180175781e+01 1.8612800598144531e+01 9.6663497924804688e+01 4.6234897613525391e+01 2.0146400451660156e+01 1.0149700164794922e+02 4.4369998931884766e+01 1.9860898971557617e+01 1.2362599945068359e+02 -2.1295598983764648e+01 1.9502901077270508e+01 1.2441900634765625e+02 -1.7549499511718750e+01 1.9725799560546875e+01 4.4434700012207031e+01 2.6387098312377930e+01 2.2640300750732422e+01 1.1046299743652344e+02 3.6007099151611328e+01 -2.2724399566650391e+01 1.0930699920654297e+02 3.9254596710205078e+01 -1.9282798767089844e+01 1.2208999633789062e+02 -7.0206799507141113e+00 -1.9766799926757812e+01 1.2501299285888672e+02 -9.9498300552368164e+00 -1.9716699600219727e+01 4.5723300933837891e+01 -2.2883501052856445e+01 2.4228099822998047e+01 1.0694499969482422e+02 3.7792198181152344e+01 2.2852600097656250e+01 1.2399099731445312e+02 4.2607698440551758e+00 1.9886299133300781e+01 9.8593597412109375e+01 -4.6460300445556641e+01 7.7177100181579590e+00 9.0517501831054688e+01 4.9235298156738281e+01 1.8761899948120117e+01 1.2156300354003906e+02 -7.0000000000000000e+00 6.2587699890136719e+00 4.1446998596191406e+01 -2.1255100250244141e+01 3.1492199897766113e+00 2.9451400756835938e+01 -2.1394599914550781e+01 1.8386900424957275e+00 1.1756900024414062e+02 2.0236700057983398e+01 -2.3723600387573242e+01 6.0049701690673828e+01 -4.5218200683593750e+01 -1.7670299530029297e+01 1.0467100524902344e+02 4.3041698455810547e+01 1.8641000747680664e+01 1.0376599884033203e+02 4.3659500122070312e+01 2.6347398757934570e+00 1.0009400177001953e+02 4.5747100830078125e+01 1.8707201004028320e+01 1.2153800201416016e+02 -1.0916000366210938e+01 -2.0160699844360352e+01 8.0076698303222656e+01 5.0326499938964844e+01 1.8977800369262695e+01 8.6578506469726562e+01 5.0037799835205078e+01 1.8725198745727539e+01 4.3631099700927734e+01 2.6957700729370117e+01 -2.0975900650024414e+01 4.6153900146484375e+01 2.8781499862670898e+01 -2.2180900573730469e+01 4.1444698333740234e+01 -2.0168998718261719e+01 -7.4942698478698730e+00 2.9450201034545898e+01 1.2137399673461914e+01 -1.7715801239013672e+01 8.6604103088378906e+01 -4.8097400665283203e+01 2.0748498916625977e+01 1.2470400238037109e+02 3.4212801456451416e+00 -1.9651800155639648e+01 4.2493999481201172e+01 2.5605899810791016e+01 -1.9873600006103516e+01 5.3477100372314453e+01 3.1604801177978516e+01 2.4243799209594727e+01 4.6118499755859375e+01 -2.3080799102783203e+01 -2.4238500595092773e+01 1.1544400024414062e+02 2.7181598663330078e+01 -2.3450599670410156e+01 1.1009400177001953e+02 3.4561500549316406e+01 -2.3769300460815430e+01 1.1964300537109375e+02 -1.2571100234985352e+01 2.3256000518798828e+01 5.3597900390625000e+01 -3.3945301055908203e+01 -2.3461999893188477e+01 4.1449302673339844e+01 -1.5137000083923340e+01 -1.5231100082397461e+01 2.9451400756835938e+01 -1.3029700279235840e+01 -1.7065700531005859e+01 2.9451099395751953e+01 1.9630899429321289e+01 8.6858806610107422e+00 1.0599099731445312e+02 4.1502201080322266e+01 2.0141000747680664e+01 1.2206300354003906e+02 -7.0000000000000000e+00 -1.4847399711608887e+01 1.2156700134277344e+02 -7.0021200180053711e+00 -2.0100299835205078e+01 1.2156300354003906e+02 -7.0000000000000000e+00 -4.9702701568603516e+00 1.2206300354003906e+02 -7.0000000000000000e+00 3.8407897949218750e+00 4.1443099975585938e+01 2.0705501556396484e+01 -5.9115500450134277e+00 2.9449998855590820e+01 2.1461299896240234e+01 -1.3934799432754517e+00 1.2510399627685547e+02 -5.4875302314758301e+00 -2.6204500198364258e+00 2.9451599121093750e+01 1.6979499816894531e+01 1.3179400444030762e+01 4.1449302673339844e+01 1.6233200073242188e+01 1.4062999725341797e+01 8.7422401428222656e+01 -4.9064098358154297e+01 -1.9846899032592773e+01 4.1816600799560547e+01 -2.2916400909423828e+01 -2.1086198806762695e+01 4.2815101623535156e+01 -2.1860500335693359e+01 -2.2703800201416016e+01 7.7563896179199219e+01 5.0843299865722656e+01 1.7545801162719727e+01 7.1856697082519531e+01 5.0089199066162109e+01 1.7277500152587891e+01 1.1843399810791016e+02 -3.2894100189208984e+01 5.2945899963378906e+00 1.1496400451660156e+02 -3.2404602050781250e+01 -2.0033300399780273e+01 1.1252400207519531e+02 -3.5706298828125000e+01 -1.9854400634765625e+01 1.2408000183105469e+02 5.6865200996398926e+00 1.8953201293945312e+01 1.2405799865722656e+02 1.9487199783325195e+01 1.9514999389648438e+01 1.2313099670410156e+02 2.2883298873901367e+01 1.9678098678588867e+01 7.0093299865722656e+01 4.6915401458740234e+01 2.0814599990844727e+01 7.3881401062011719e+01 3.8409301757812500e+01 2.4193799972534180e+01 8.0496200561523438e+01 -5.0318000793457031e+01 -1.9005599975585938e+01 7.2027694702148438e+01 -5.0115501403808594e+01 1.6612600326538086e+01 6.9010398864746094e+01 -4.9358100891113281e+01 -1.6804800033569336e+01 4.6135101318359375e+01 -7.1033396720886230e+00 2.4248798370361328e+01 4.4780899047851562e+01 6.5252199172973633e+00 2.3964500427246094e+01 1.2100000000000000e+02 -1.1211899757385254e+01 2.1605800628662109e+01 1.1233300018310547e+02 3.1228599548339844e+01 2.3798900604248047e+01 4.3482299804687500e+01 2.7216701507568359e+01 -1.2783800125122070e+01 4.8873302459716797e+01 3.2969501495361328e+01 -2.0585100173950195e+01 6.1301498413085938e+01 -4.5305198669433594e+01 -1.9338098526000977e+01 6.2783397674560547e+01 -4.4689498901367188e+01 -2.0667100906372070e+01 6.8034202575683594e+01 -4.8063198089599609e+01 -1.9371601104736328e+01 4.1448001861572266e+01 -1.1764200210571289e+01 -1.7972299575805664e+01 5.0433300018310547e+01 3.3507297515869141e+01 -2.2159399032592773e+01 5.0605499267578125e+01 -3.3803897857666016e+01 2.2021099090576172e+01 6.1553798675537109e+01 -4.4041900634765625e+01 2.0580099105834961e+01 4.5529499053955078e+01 -2.5807001113891602e+01 2.3592998504638672e+01 1.2506100463867188e+02 -2.4962198734283447e+00 1.9315698623657227e+01 1.2427199554443359e+02 1.1613200604915619e-01 1.9849100112915039e+01 2.9450201034545898e+01 1.5377300262451172e+01 -1.5040299415588379e+01 1.2397200012207031e+02 -4.3468198776245117e+00 -1.9870899200439453e+01 1.2496200561523438e+02 1.3045000076293945e+01 -7.3478999137878418e+00 6.4566795349121094e+01 -4.7766201019287109e+01 -1.6582500457763672e+01 1.2499500274658203e+02 -1.2810200691223145e+01 1.9527099609375000e+01 7.0175300598144531e+01 -4.6927200317382812e+01 -2.0823200225830078e+01 4.3556797027587891e+01 -2.3889400482177734e+01 -2.3026800155639648e+01 1.1550000000000000e+02 -3.0891201019287109e+01 -2.1069000244140625e+01 1.2156700134277344e+02 5.3327598571777344e+00 1.9488500595092773e+01 8.6563697814941406e+01 5.0022399902343750e+01 4.7650203704833984e+00 8.6563293457031250e+01 5.0018001556396484e+01 -8.4483699798583984e+00 1.2203700256347656e+02 -1.5033599853515625e+01 1.9751699447631836e+01 4.9822799682617188e+01 3.4136699676513672e+01 1.9837999343872070e+01 6.0570697784423828e+01 4.5697101593017578e+01 1.7498500823974609e+01 4.1449901580810547e+01 -2.0154100418090820e+01 7.4180202484130859e+00 4.1449497222900391e+01 -1.8806699752807617e+01 1.0360699653625488e+01 4.3002300262451172e+01 2.6556699752807617e+01 1.9947500228881836e+01 1.1625699615478516e+02 -2.4141599655151367e+01 2.3707300186157227e+01 7.2535697937011719e+01 4.9100399017333984e+01 1.9602998733520508e+01 7.3173599243164062e+01 4.8740200042724609e+01 -2.0037099838256836e+01 7.5365203857421875e+01 -4.9183101654052734e+01 -2.0009300231933594e+01 7.4140495300292969e+01 -5.0144901275634766e+01 -1.8372200012207031e+01 1.2514400482177734e+02 -5.4489202499389648e+00 -1.1442899703979492e+01 1.2156300354003906e+02 7.0000000000000000e+00 -7.4766798019409180e+00 6.7888198852539062e+01 4.8122001647949219e+01 1.9240598678588867e+01 4.8659599304199219e+01 -3.2538002014160156e+01 -2.0967100143432617e+01 5.0401298522949219e+01 -3.3608200073242188e+01 -2.2029298782348633e+01 6.1970798492431641e+01 -4.6539398193359375e+01 -1.7511001586914062e+01 1.2056600189208984e+02 1.6455299377441406e+01 -2.1572700500488281e+01 1.0175900268554688e+02 -4.4870903015136719e+01 2.3420000076293945e+00 6.7292495727539062e+01 -4.8552299499511719e+01 -1.7979801177978516e+01 9.1211997985839844e+01 -4.9090198516845703e+01 1.8606700897216797e+01 4.1446498870849609e+01 1.3913299560546875e+01 1.6371799468994141e+01 8.6563293457031250e+01 5.0559101104736328e+01 9.3907394409179688e+00 1.1766099548339844e+02 -3.3039699554443359e+01 1.9742099761962891e+01 4.5223400115966797e+01 2.8551799774169922e+01 2.1276000976562500e+01 7.2094406127929688e+01 5.0154399871826172e+01 -1.6445699691772461e+01 1.2158200073242188e+02 4.1109700202941895e+00 -2.0010000228881836e+01 4.1451301574707031e+01 -9.9402704238891602e+00 1.9050399780273438e+01 1.2495099639892578e+02 1.3168999671936035e+01 8.1176996231079102e+00 1.1629699707031250e+02 3.2352203369140625e+01 1.0701100349426270e+01 1.0091000366210938e+02 4.2978599548339844e+01 -2.1418399810791016e+01 8.6562698364257812e+01 5.0544700622558594e+01 1.7201200485229492e+01 7.2773200988769531e+01 -5.0259998321533203e+01 -1.6804000854492188e+01 4.3583099365234375e+01 -2.6588798522949219e+01 -2.1462099075317383e+01 4.1445999145507812e+01 1.3733099937438965e+01 -1.6506999969482422e+01 1.2158499908447266e+02 -4.2660198211669922e+00 -1.9997001647949219e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 39 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00) (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01) (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2502400577068329e+02 9.9738398566842079e+00 1.9713399931788445e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01) (float-vector 1.2218099832534790e+02 -2.5639500468969345e+01 1.9726300612092018e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.2495400011539459e+02 -1.3429000042378902e+01 -1.9517200067639351e+01) (float-vector 1.2489099800586700e+02 1.4242899604141712e+01 -1.9663300365209579e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01) (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01) (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 2.9449900612235069e+01 1.2911099940538406e+01 1.7200499773025513e+01) (float-vector 2.9451100155711174e+01 1.9630899652838707e+01 8.6858803406357765e+00) (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1877799779176712e+02 1.1789199896156788e+01 2.3742999881505966e+01) (float-vector 1.0887800157070160e+02 -3.3707100898027420e+01 2.4216800928115845e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 5.2058298140764236e+01 3.2318301498889923e+01 2.3839699104428291e+01) (float-vector 8.0304197967052460e+01 3.9039801806211472e+01 2.4248100817203522e+01) (float-vector 1.0912699997425079e+02 3.3405900001525879e+01 2.4258600547909737e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5723300427198410e+01 -2.2883500903844833e+01 2.4228099733591080e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 2.9450399801135063e+01 -4.0197498165071011e+00 2.1087100729346275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01) (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01) (float-vector 8.7470501661300659e+01 4.7957099974155426e+01 2.0746700465679169e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.2125399708747864e+02 2.8054499998688698e+01 1.9512899219989777e+01) (float-vector 1.1227399855852127e+02 3.5685699433088303e+01 2.0797200500965118e+01) (float-vector 1.0009399801492691e+02 4.5747101306915283e+01 1.8707200884819031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01) (float-vector 1.0147099941968918e+02 4.4997498393058777e+01 -1.8635399639606476e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 1.1496800184249878e+02 -2.2546799853444099e+01 -2.4256000295281410e+01) (float-vector 1.1958499997854233e+02 1.1167099699378014e+01 -2.3250199854373932e+01) (float-vector 1.1880099773406982e+02 3.2646600157022476e+01 -1.9732199609279633e+01) (float-vector 1.0874500125646591e+02 3.3654399216175079e+01 -2.4233700707554817e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0570698231458664e+01 4.5697100460529327e+01 1.7498500645160675e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 8.1030301749706268e+01 5.1014699041843414e+01 -1.7174199223518372e+01) (float-vector 7.7563896775245667e+01 5.0843298435211182e+01 1.7545800656080246e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1875700205564499e+02 -3.2695900648832321e+01 -1.9715199247002602e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01) (float-vector 1.1886200308799744e+02 -3.2624598592519760e+01 1.9689600914716721e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 1.0740300267934799e+02 -4.0114000439643860e+01 -2.0729200914502144e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5943599939346313e+01 -4.7594800591468811e+01 -1.8566099926829338e+01) (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 8.6604103446006775e+01 -4.8097401857376099e+01 2.0748499780893326e+01) (float-vector 1.0237000137567520e+02 -4.4525600969791412e+01 1.8729500472545624e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01) (float-vector 2.9449999332427979e+01 -2.4710199795663357e+00 -2.1323399618268013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01) (float-vector 2.9450200498104095e+01 2.0599599927663803e+01 -6.0919402167201042e+00) (float-vector 2.9450200498104095e+01 1.2137399986386299e+01 -1.7715800553560257e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0433300435543060e+01 3.3507298678159714e+01 -2.2159399464726448e+01) (float-vector 5.3492899984121323e+01 3.1628899276256561e+01 -2.4233799427747726e+01) (float-vector 6.7597396671772003e+01 4.6218499541282654e+01 -2.0792799070477486e+01) (float-vector 6.1490200459957123e+01 4.6300001442432404e+01 -1.7233299091458321e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01) (float-vector 2.9451400041580200e+01 -1.3029700145125389e+01 -1.7065700143575668e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01) (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 8.2244999706745148e+01 -5.0994198769330978e+01 -1.6992900520563126e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 7.0175297558307648e+01 -4.6927198767662048e+01 -2.0823199301958084e+01) (float-vector 8.7970800697803497e+01 -4.7339998185634613e+01 -2.0930999889969826e+01) (float-vector 8.3322003483772278e+01 -3.8958899676799774e+01 -2.4240799248218536e+01) (float-vector 5.1347099244594574e+01 -3.2749600708484650e+01 -2.3373899981379509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9454100877046585e+01 -1.8656300380825996e+01 1.0724600404500961e+01) (float-vector 6.1553798615932465e+01 -4.4041901826858521e+01 2.0580099895596504e+01) (float-vector 7.2027698159217834e+01 -5.0115499645471573e+01 1.6612600535154343e+01) (float-vector 6.1970800161361694e+01 -4.6539399772882462e+01 -1.7511000856757164e+01) (float-vector 2.9450099915266037e+01 -2.1184900775551796e+01 -3.6931799259036779e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_palm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_r_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.6910000000000011e+01 -1.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 856 1 0 953 856 0 477 0 484 0 34 484 2 34 0 953 0 477 2 147 33 34 2 33 2 1 147 33 30 34 34 32 484 34 30 32 477 484 32 30 31 32 476 477 32 476 32 486 486 32 31 485 476 486 718 850 476 485 718 476 476 850 477 902 485 486 902 718 485 902 486 717 31 844 486 486 844 717 902 717 718 717 646 718 717 778 646 717 844 778 778 844 647 31 290 844 844 290 647 778 647 646 646 647 620 4 718 646 620 4 646 620 647 36 290 36 647 290 37 36 31 37 290 35 36 37 620 36 396 36 35 396 4 620 396 395 4 396 35 481 396 396 481 546 546 395 396 35 37 481 37 472 481 37 31 470 472 37 470 546 481 545 481 472 923 481 923 545 545 483 546 597 395 546 546 483 597 545 923 483 923 472 483 469 472 470 483 472 469 478 483 469 483 478 597 597 478 543 543 395 597 468 478 469 478 468 479 543 478 479 468 469 470 468 38 466 468 466 479 468 470 38 479 466 480 479 480 543 466 38 467 466 467 471 466 471 480 543 480 688 689 480 471 688 480 689 471 467 734 689 471 690 690 471 734 38 22 467 467 22 734 406 733 734 21 734 22 406 734 21 733 690 734 688 689 690 733 688 690 543 688 408 733 408 688 406 408 733 406 407 408 407 406 21 21 22 23 21 23 407 38 491 22 22 491 23 23 748 407 23 491 489 748 23 489 408 407 832 832 407 791 748 791 407 748 489 853 748 853 791 488 489 490 488 853 489 489 491 490 853 488 791 791 792 148 148 832 791 791 488 792 792 488 490 490 491 896 740 490 896 740 792 490 148 792 740 149 148 740 684 740 896 684 149 740 465 464 896 465 896 491 684 896 464 683 684 464 684 69 149 70 684 683 69 684 70 463 464 465 464 463 683 470 463 39 31 683 463 463 465 39 470 31 463 470 39 38 38 39 40 465 40 39 40 491 38 491 40 465 30 487 31 487 458 31 31 458 683 487 680 458 19 680 487 19 487 473 473 487 30 458 459 216 216 593 458 680 459 458 458 593 683 64 459 680 64 680 19 459 499 216 64 493 459 493 499 459 216 217 218 216 218 593 216 499 217 593 316 683 593 218 316 259 218 260 316 218 259 218 68 70 260 218 70 218 217 68 316 259 683 259 260 683 260 70 683 68 69 70 68 217 272 68 272 69 272 217 232 777 686 217 217 686 232 497 217 499 217 497 777 231 183 232 232 686 231 183 272 232 682 686 777 682 231 686 456 777 497 682 777 456 681 682 456 682 681 231 231 681 183 456 367 681 849 681 367 183 681 849 456 361 457 456 457 367 456 497 361 361 362 191 497 362 361 457 361 191 367 457 191 365 366 367 367 191 365 818 849 367 745 367 366 818 367 528 367 745 528 528 745 529 366 529 745 528 529 530 528 530 963 963 818 528 530 529 366 963 530 859 859 530 366 859 366 860 366 365 860 859 860 381 963 859 381 818 963 381 381 365 190 818 381 190 860 365 381 190 191 192 192 631 190 631 892 190 190 892 818 365 191 190 362 138 191 192 191 178 178 191 138 192 178 736 736 631 192 892 631 736 178 735 736 735 171 736 171 892 736 169 170 171 171 735 169 170 892 171 297 169 298 169 297 752 170 169 752 169 735 829 169 829 298 170 752 818 170 818 892 181 183 818 818 183 849 818 752 181 181 182 183 181 752 182 267 183 182 272 183 267 182 269 267 182 752 269 269 270 267 270 269 879 269 752 879 271 268 270 268 267 270 271 270 301 270 879 301 301 879 373 373 879 752 752 122 373 752 297 122 120 121 122 300 373 122 120 122 297 122 121 300 297 298 120 120 298 732 972 120 732 120 972 121 300 121 49 121 972 47 121 47 49 919 47 972 732 735 972 972 735 919 732 298 829 829 735 732 178 180 735 735 716 919 180 715 735 715 716 735 178 179 180 138 137 178 137 913 178 913 179 178 179 715 180 715 433 716 284 433 715 179 284 715 179 283 284 283 996 284 996 433 284 179 433 283 283 433 996 538 433 179 538 179 913 913 795 914 913 137 795 538 913 914 537 434 538 538 956 537 433 538 434 914 956 538 914 795 797 956 914 797 795 796 797 795 340 796 795 137 340 796 387 797 956 797 387 537 956 387 387 388 250 537 387 311 387 250 311 410 388 387 410 387 796 340 411 796 411 410 796 388 410 411 388 411 342 340 342 411 340 341 342 342 341 898 388 342 802 802 342 898 898 341 769 994 898 769 898 994 802 388 802 803 803 802 651 802 994 651 994 426 425 994 425 651 426 994 769 768 426 769 769 341 194 194 768 769 424 425 426 424 426 867 426 768 867 651 425 652 652 425 494 425 424 494 424 820 494 424 867 820 495 867 961 867 768 961 820 867 495 494 820 495 494 495 496 495 554 496 495 961 554 961 934 549 934 961 768 961 549 554 496 554 275 554 276 275 549 999 554 554 999 276 494 496 932 932 496 275 275 276 277 932 275 883 275 277 883 277 276 326 935 326 276 935 276 999 999 549 935 326 935 327 935 551 327 549 551 935 326 327 328 572 277 326 326 328 572 650 328 327 551 648 327 648 650 327 549 550 551 551 766 648 550 766 551 648 649 650 767 649 648 648 766 767 765 766 550 765 767 766 550 934 765 934 550 549 765 934 193 765 930 767 930 765 193 930 931 767 936 649 767 931 936 767 1001 931 930 1001 930 193 193 194 195 934 194 193 195 1001 193 768 194 934 194 341 195 341 492 195 492 1000 195 1000 1001 195 1000 776 1001 776 931 1001 775 776 1000 492 775 1000 340 775 492 492 341 340 775 504 776 775 137 504 340 137 775 504 927 776 931 776 927 503 504 358 504 503 927 504 137 358 136 137 138 136 358 137 358 359 360 358 136 742 358 360 503 359 358 742 138 116 136 116 117 136 136 117 742 254 138 413 362 413 138 138 254 116 116 28 117 116 254 29 116 29 28 117 28 720 117 720 955 742 117 955 27 28 29 28 114 720 28 27 114 113 114 115 114 595 115 114 27 595 720 114 113 113 115 414 113 414 724 724 888 113 113 888 720 595 414 115 737 595 364 595 642 414 595 737 642 364 595 27 414 642 643 414 643 724 724 980 888 643 988 724 724 988 980 84 887 980 84 980 377 980 887 888 377 980 988 988 565 377 643 565 988 376 84 377 376 377 565 564 565 566 565 212 566 643 212 565 565 564 376 376 320 322 564 320 376 880 84 376 322 880 376 320 564 321 321 564 817 564 566 817 566 629 817 629 566 212 629 624 817 817 624 321 320 321 322 624 53 321 869 321 53 321 869 322 880 322 357 357 322 869 868 869 870 868 357 869 53 870 869 868 976 355 976 868 870 868 355 357 53 55 870 242 870 55 242 976 870 976 838 355 976 242 838 355 356 357 838 452 355 355 452 356 452 838 154 242 619 838 155 838 619 838 155 154 241 242 55 619 242 241 241 243 619 54 835 241 835 404 241 241 404 243 241 55 54 53 54 55 118 54 119 119 54 53 118 835 54 612 835 118 612 404 835 118 119 997 118 997 986 612 118 986 119 53 624 119 624 630 997 119 630 174 997 959 997 630 959 986 997 174 612 986 173 173 986 174 172 173 174 174 289 247 172 174 247 289 174 959 288 111 289 111 247 289 288 289 959 111 246 247 247 246 172 110 111 112 111 288 112 246 111 110 959 808 288 112 288 846 808 846 288 307 112 569 107 110 112 307 107 112 569 112 846 109 246 110 107 109 110 107 108 109 306 107 307 786 108 107 107 306 786 92 306 307 569 92 307 809 569 846 569 809 92 809 846 808 808 783 809 809 813 824 809 824 92 783 813 809 783 18 813 813 20 824 18 20 813 75 824 20 824 75 92 18 19 20 74 75 20 482 74 20 20 19 473 20 473 482 74 739 75 739 92 75 482 596 74 596 739 74 482 473 475 948 596 482 948 482 475 473 474 475 474 473 30 695 475 474 948 475 695 948 695 596 596 695 336 336 695 219 695 474 220 219 695 220 474 30 922 220 474 922 922 30 544 544 30 33 220 922 146 146 922 544 219 220 146 145 336 219 145 219 146 336 1 596 145 1 336 145 146 147 147 1 145 147 146 544 33 147 544 3 1 4 1 516 764 525 516 1 764 93 1 1 856 4 525 1 841 596 1 93 841 1 3 596 93 739 92 93 94 94 93 764 93 92 739 516 94 764 94 516 291 94 291 92 415 92 291 306 92 415 293 306 415 291 293 415 293 435 306 786 306 435 291 292 293 292 435 293 374 375 292 5 374 292 435 292 375 5 292 291 5 640 374 374 438 375 438 374 640 437 435 375 438 437 375 436 437 438 346 438 508 727 436 438 727 438 346 508 438 640 436 227 226 727 330 436 436 226 437 436 330 227 346 330 727 346 347 60 346 60 330 346 508 347 508 640 641 508 641 347 746 747 641 641 640 746 861 347 641 747 906 641 906 861 641 746 843 747 843 906 747 843 905 906 907 861 906 906 905 907 907 905 908 908 702 907 713 861 907 713 907 714 907 702 714 908 954 702 905 671 908 908 671 954 702 703 704 702 704 714 954 703 702 982 954 671 982 703 954 598 671 672 672 671 905 598 982 671 598 80 599 675 598 599 80 598 672 675 982 598 672 72 80 905 72 672 991 72 905 843 991 905 71 72 73 73 72 964 72 71 80 964 72 991 964 991 843 238 842 843 842 964 843 238 843 746 73 964 82 964 842 82 79 71 73 73 82 81 79 73 81 79 80 71 79 599 80 599 79 738 81 738 79 901 675 599 599 738 901 901 738 400 901 982 675 982 901 400 703 982 399 399 982 400 399 43 703 703 43 704 399 400 210 399 210 441 399 441 43 41 42 43 441 41 43 704 43 14 14 43 42 714 704 14 12 13 14 42 12 14 13 714 14 666 713 714 13 666 714 665 666 13 52 773 13 12 52 13 13 773 665 368 52 12 12 42 368 50 51 52 51 335 52 368 50 52 335 773 52 899 666 773 773 666 665 773 335 899 899 335 91 741 666 899 741 899 90 899 91 90 90 91 46 91 335 527 46 91 527 223 501 90 741 90 501 46 223 90 713 741 501 713 666 741 713 501 861 501 502 15 501 942 502 501 15 861 223 942 501 861 15 347 15 16 17 502 939 15 939 16 15 347 15 17 939 502 942 939 942 513 223 943 942 943 513 942 513 16 939 513 331 16 513 248 331 943 248 513 249 943 223 249 248 943 45 222 223 222 249 223 45 223 46 248 249 224 224 249 222 45 224 222 44 45 46 45 248 224 44 248 45 526 46 527 526 44 46 335 44 526 44 712 248 44 385 712 385 44 335 526 527 335 335 384 385 51 839 335 335 839 384 712 385 710 385 384 987 710 385 987 710 711 712 710 987 744 710 744 711 811 810 987 384 811 987 987 810 744 744 265 711 744 144 265 744 810 821 744 821 144 810 811 812 812 821 810 811 993 812 811 628 993 384 628 811 993 627 812 993 628 627 626 627 628 836 837 628 626 628 837 384 836 628 836 384 839 951 837 836 836 839 951 951 839 583 839 51 353 583 839 353 837 951 583 837 305 304 583 950 837 626 837 304 950 305 837 25 950 583 305 950 25 24 25 26 26 25 583 24 305 25 26 789 24 789 305 24 790 789 26 790 26 582 582 26 583 165 789 790 789 165 430 789 430 305 163 165 790 790 804 163 804 790 582 581 582 583 582 581 721 804 582 721 379 378 581 581 805 721 581 378 805 379 581 583 379 583 616 353 616 583 353 615 616 150 379 616 616 615 150 353 50 354 353 51 50 615 353 354 354 50 368 706 615 354 706 354 368 368 42 369 706 368 826 826 368 369 705 615 706 826 705 706 826 832 705 705 832 148 615 705 148 408 832 826 543 408 395 4 395 408 408 826 806 408 806 4 856 718 4 4 806 3 850 856 953 718 856 850 850 953 477 806 78 3 605 841 3 78 605 3 841 605 523 523 525 841 523 524 525 523 918 971 990 918 523 605 990 523 523 971 524 525 524 516 291 516 517 516 524 517 8 291 9 291 8 6 5 291 6 291 517 9 517 524 693 693 9 517 8 9 10 10 9 693 8 11 6 8 10 11 5 6 7 6 11 7 746 640 5 746 5 239 5 7 239 240 239 7 67 7 11 67 240 7 11 890 67 10 890 11 65 66 67 67 66 970 890 65 67 67 970 240 238 239 240 240 970 238 239 238 746 238 970 842 970 66 83 83 842 970 842 83 82 81 82 83 900 81 83 236 83 66 236 900 83 236 237 81 237 738 81 900 236 81 237 236 66 875 738 237 875 237 66 886 738 884 738 610 884 886 400 738 610 738 875 884 885 886 885 400 886 884 209 885 210 884 610 210 209 884 885 208 400 885 209 208 400 208 210 208 209 210 847 441 210 623 847 210 610 623 210 187 847 188 698 847 623 188 847 698 187 441 847 187 41 441 187 188 189 42 187 369 42 41 187 369 187 189 825 826 189 826 369 189 189 188 825 826 825 806 825 188 806 188 944 806 806 944 78 188 697 944 944 607 992 944 992 78 697 607 944 76 77 78 992 76 78 78 77 605 607 76 992 606 607 608 76 607 606 607 697 608 418 76 606 606 416 418 606 608 416 697 416 608 416 417 418 416 696 417 697 696 416 417 609 418 623 417 696 623 609 417 696 697 698 698 623 696 610 609 623 151 609 610 609 151 418 610 875 962 151 610 962 874 875 655 962 875 874 653 655 875 653 875 66 962 874 655 151 962 655 653 654 655 655 654 151 65 653 66 654 653 398 398 653 65 654 398 918 654 723 152 918 723 654 151 654 152 918 398 971 918 990 723 722 723 670 723 722 152 990 670 723 151 152 153 152 722 153 418 151 153 153 722 670 673 153 670 673 418 153 605 604 670 670 604 673 990 605 670 673 604 76 418 673 76 77 604 605 76 604 77 971 398 524 65 397 398 524 398 693 397 10 398 398 10 693 397 65 890 397 890 10 188 698 697 148 149 150 615 148 150 989 150 149 149 69 989 130 150 989 995 833 150 833 379 150 130 995 150 130 989 69 130 131 132 132 380 130 130 380 995 131 130 69 833 995 380 833 380 379 378 379 380 132 533 380 533 378 380 132 429 533 131 427 132 427 429 132 533 534 535 534 533 429 533 535 805 533 805 378 427 428 429 429 428 534 761 762 427 427 762 428 761 427 131 428 603 534 985 603 428 428 762 985 985 762 622 622 762 761 985 622 973 985 973 603 48 622 49 622 590 317 973 622 317 761 49 622 48 590 622 319 587 973 319 973 317 587 603 973 317 318 319 402 317 591 318 317 402 317 590 591 590 542 591 48 542 590 699 402 591 591 893 699 542 893 591 401 318 402 402 699 845 401 402 845 318 401 319 575 401 573 891 401 845 573 401 891 319 401 575 573 574 575 575 574 586 319 575 586 574 573 876 876 573 891 891 845 161 897 876 891 161 897 891 574 876 877 897 799 876 877 876 894 876 799 894 338 574 877 338 586 574 338 877 339 877 894 339 894 799 895 894 895 371 894 371 678 339 894 678 337 338 339 339 677 337 339 678 677 586 338 601 338 337 601 512 511 337 324 337 677 512 337 324 601 337 511 676 677 678 677 676 325 324 677 325 323 324 325 512 324 594 324 323 594 325 676 323 938 323 676 938 676 678 105 594 323 323 106 105 938 106 323 512 594 105 104 105 106 409 105 104 512 105 409 370 104 106 370 106 938 938 678 370 370 678 371 370 371 372 104 370 351 351 370 372 372 371 957 351 372 957 371 782 585 895 952 371 371 952 782 371 585 957 957 958 657 957 585 958 351 957 657 584 446 585 584 585 782 585 446 958 799 584 782 952 799 782 895 799 952 447 799 800 799 460 462 500 799 897 799 462 800 799 447 584 460 799 500 446 584 447 445 446 447 958 446 445 445 532 531 445 447 915 445 915 532 958 445 531 134 531 532 531 657 958 134 657 531 133 134 135 352 134 133 135 134 865 865 134 532 352 657 134 351 657 352 350 351 352 350 352 133 350 133 983 133 135 983 135 865 780 780 983 135 865 532 866 865 866 781 781 780 865 779 780 781 793 780 794 793 983 780 779 794 780 350 983 793 793 848 350 793 345 848 793 343 345 794 343 793 779 580 794 580 343 794 580 779 685 781 685 779 578 579 580 578 580 600 685 600 580 579 343 580 343 344 345 579 547 343 547 344 343 344 848 345 344 409 104 450 449 344 344 200 199 344 199 848 344 104 200 409 344 294 449 294 344 547 450 344 200 104 201 201 104 351 199 200 201 199 201 848 848 201 350 201 351 350 449 450 451 450 547 548 156 450 917 451 450 156 917 450 548 548 547 579 518 548 56 548 579 56 917 548 518 452 154 917 58 917 518 452 917 58 154 156 917 518 56 519 518 519 58 56 57 58 58 57 731 519 56 58 731 452 58 56 578 57 56 579 578 731 57 830 749 831 57 578 749 57 57 831 830 555 452 731 555 731 830 555 830 831 831 726 815 831 725 726 555 831 815 725 831 749 555 556 452 555 814 556 555 815 814 175 556 658 556 175 452 975 658 556 814 975 556 452 175 356 175 176 177 356 175 177 175 658 176 176 658 656 975 656 658 514 975 814 558 656 975 514 558 975 86 656 123 656 85 176 85 656 86 558 123 656 177 176 880 880 176 85 84 85 86 880 85 84 357 947 880 947 177 880 356 177 357 357 177 947 887 84 86 887 728 888 887 86 728 728 729 720 729 728 431 86 431 728 728 720 888 729 390 955 720 729 955 621 390 729 621 729 431 86 63 431 621 431 63 86 123 63 61 62 63 63 389 621 63 123 61 389 63 62 389 390 621 389 386 390 62 785 389 785 386 389 360 359 386 770 360 386 359 390 386 770 386 785 62 771 785 785 771 770 660 770 771 770 503 360 660 503 770 771 570 709 771 62 570 709 660 771 650 660 709 570 650 709 659 503 660 649 659 660 650 649 660 927 503 659 936 927 659 649 936 659 936 931 927 650 570 328 572 328 570 570 571 572 571 277 572 570 644 571 571 881 277 644 61 571 571 61 969 571 969 881 277 881 883 881 882 883 279 881 969 881 279 929 882 881 929 61 754 969 279 969 754 61 753 754 753 280 754 279 754 280 753 514 419 280 753 540 61 558 753 558 514 753 540 753 419 278 279 280 540 278 280 540 419 925 540 925 576 577 278 540 576 577 540 278 577 279 279 577 974 279 974 929 933 928 974 974 928 929 974 577 933 928 882 929 634 928 632 932 928 634 632 928 933 882 928 932 882 932 883 634 494 932 632 633 634 633 494 634 632 730 633 912 632 933 912 730 632 633 281 652 633 652 494 730 281 633 707 708 730 708 282 730 281 730 282 912 707 730 567 912 933 567 707 912 707 204 708 204 707 567 203 708 204 439 708 203 439 282 708 281 282 251 439 440 282 251 282 440 439 203 635 439 635 440 202 203 204 635 203 636 203 202 636 635 636 637 252 635 637 252 440 635 251 440 252 250 251 252 872 281 251 251 250 872 872 250 862 872 862 281 949 803 250 388 949 250 803 862 250 252 311 250 803 651 862 281 862 652 862 651 652 949 388 803 311 252 312 312 537 311 432 537 312 312 645 432 541 645 312 312 252 541 432 434 537 432 433 434 454 432 645 432 878 433 432 454 878 645 541 455 455 454 645 453 454 455 878 454 852 852 454 453 716 878 852 878 716 433 851 852 453 919 852 851 716 852 919 48 453 455 453 48 851 455 541 542 542 48 455 47 48 49 851 48 47 851 47 919 49 299 300 761 299 49 552 299 816 300 299 552 816 299 761 300 552 553 553 373 300 816 855 552 855 553 552 855 816 274 131 274 816 816 761 131 553 855 274 553 274 373 69 274 131 373 274 69 272 266 69 266 373 69 272 267 273 273 266 272 266 267 268 273 267 266 266 268 373 373 268 271 271 301 373 541 893 542 541 252 864 541 864 893 864 252 893 252 699 893 162 252 637 827 252 162 252 827 845 252 845 699 160 161 162 160 162 637 827 162 161 636 160 637 460 500 160 160 500 161 636 460 160 845 827 161 161 500 897 460 461 462 636 461 460 636 202 461 461 663 662 461 998 462 461 202 663 662 998 461 979 800 462 998 979 462 998 662 979 661 662 663 979 662 871 662 310 871 310 662 661 871 915 979 979 915 447 447 800 979 871 310 98 539 915 871 871 98 539 532 915 539 100 539 98 100 99 539 866 539 442 532 539 866 539 99 442 98 99 100 442 99 443 99 725 443 99 98 725 442 443 444 685 442 444 781 442 685 866 442 781 443 749 444 443 725 749 725 98 726 310 726 98 815 726 383 383 726 310 308 309 310 310 309 383 308 310 661 382 383 309 382 815 383 515 814 815 420 515 815 420 815 382 382 664 420 309 308 382 308 664 382 661 664 308 663 664 661 421 664 694 664 663 694 420 664 421 419 420 421 515 420 419 514 515 419 514 814 515 925 419 421 694 921 421 921 925 421 924 576 925 925 921 924 332 924 921 694 941 921 941 332 921 334 576 924 334 924 332 576 334 577 332 333 334 568 577 334 334 333 568 772 926 332 772 332 941 926 333 332 694 772 941 694 204 772 772 204 926 926 204 333 333 567 568 333 204 567 937 568 567 937 577 568 937 933 577 937 567 933 694 202 204 694 663 202 749 600 444 749 578 600 685 444 600 558 61 123 62 61 644 62 909 570 644 909 62 570 909 644 390 359 742 742 955 390 154 155 156 451 156 155 155 618 451 618 155 619 449 451 294 294 451 828 618 828 451 295 618 619 828 618 295 245 619 243 295 619 245 294 295 296 295 245 296 828 295 294 405 409 294 405 294 296 296 403 405 244 296 245 296 244 403 243 244 245 243 404 403 243 403 244 403 404 405 405 404 409 409 404 612 611 612 613 611 409 612 613 612 173 261 409 611 262 611 613 261 611 262 639 613 173 639 262 613 422 173 423 172 423 173 639 173 422 422 638 639 638 262 639 261 262 263 263 262 638 984 409 261 984 261 263 233 920 263 263 834 233 920 984 263 638 834 263 920 409 984 920 589 409 589 512 409 946 589 920 946 920 233 946 233 235 946 235 589 588 510 589 589 592 588 589 510 512 592 589 235 510 511 512 602 511 510 588 602 510 592 535 588 602 588 534 534 588 535 592 234 535 234 592 235 233 234 235 617 234 233 234 804 535 617 804 234 535 804 805 163 804 617 805 804 721 163 164 165 163 617 759 164 163 759 164 314 165 314 164 315 315 164 674 674 164 759 165 314 430 313 314 315 509 314 313 509 430 314 313 315 784 674 945 315 784 315 945 758 945 674 758 674 759 916 945 758 916 784 945 285 784 916 562 313 784 784 285 562 561 313 562 509 313 561 561 562 563 563 562 285 285 286 287 916 286 285 788 285 287 788 563 285 916 758 286 286 873 823 758 873 286 286 823 287 788 287 394 287 823 394 822 394 823 822 823 873 422 873 758 172 873 423 822 873 172 423 873 422 822 172 246 109 822 246 822 109 394 109 108 801 801 394 109 108 394 801 108 393 394 700 701 108 87 89 108 701 87 108 786 700 108 89 393 108 89 788 393 393 788 394 87 88 89 88 788 89 787 788 129 787 563 788 129 788 88 87 129 88 127 128 129 127 129 87 819 129 128 129 819 787 561 563 787 561 787 819 614 303 819 303 509 819 911 819 128 614 819 911 819 509 561 302 303 304 302 430 303 303 430 509 614 304 303 304 305 302 305 430 302 614 854 304 854 812 304 304 812 626 614 142 854 812 854 142 812 142 821 626 812 627 142 143 144 614 143 142 821 142 144 144 264 265 264 144 967 143 967 144 265 264 141 139 264 967 264 139 141 265 141 711 774 711 141 774 712 711 712 774 965 141 966 774 965 774 966 712 965 248 248 965 557 965 966 557 966 559 557 141 560 966 966 560 559 559 560 140 559 140 391 557 559 391 141 140 560 139 140 141 140 139 96 391 140 95 140 96 95 391 392 205 391 95 392 205 557 391 95 96 97 392 95 960 960 95 97 96 139 968 97 96 968 968 139 967 968 967 143 97 968 798 968 143 978 978 798 968 97 798 412 960 97 412 412 807 960 807 392 960 253 412 128 798 128 412 412 253 807 798 978 128 911 128 978 143 911 978 143 614 911 127 253 128 253 127 87 253 87 807 87 701 807 392 807 349 701 349 807 700 349 701 348 206 349 392 349 206 700 348 349 392 206 205 205 206 207 348 700 206 206 700 207 786 207 700 205 207 940 435 207 786 435 940 207 205 940 557 940 763 557 437 940 435 940 437 763 248 557 448 557 763 448 226 763 437 448 763 719 226 719 763 248 448 331 331 448 329 329 448 719 329 719 226 225 226 227 329 226 225 329 330 331 225 330 329 330 16 331 225 227 330 16 330 60 59 16 60 17 16 59 59 60 347 347 17 59 638 422 760 422 758 760 638 760 757 638 757 834 760 758 757 757 758 759 834 757 617 617 757 759 233 834 617 603 602 534 601 602 603 586 603 587 586 601 603 602 601 511 319 586 587 19 18 64 18 667 669 18 507 667 783 507 18 101 18 669 18 101 64 101 103 64 103 493 64 101 102 103 102 101 669 103 213 221 102 213 103 221 493 103 213 102 215 669 215 102 230 215 669 213 215 230 229 214 230 214 213 230 669 229 230 229 625 228 229 669 625 214 229 228 213 214 197 197 214 198 198 214 228 198 228 166 228 625 166 166 167 168 166 840 167 166 168 198 840 166 625 168 167 157 840 158 167 167 158 157 168 157 863 198 168 981 981 168 863 157 158 159 27 157 159 863 157 27 158 625 159 840 625 158 159 625 364 364 27 159 27 29 863 863 29 692 981 863 692 692 679 981 981 679 198 691 679 692 29 691 692 29 254 691 254 258 691 521 679 691 258 521 691 257 258 256 257 521 258 256 258 254 687 257 256 687 521 257 520 521 522 185 679 521 185 521 520 522 521 687 255 522 687 687 256 255 254 255 256 185 520 255 520 522 255 255 186 185 255 254 186 184 185 186 185 184 679 857 679 184 186 857 184 679 857 198 857 858 198 858 857 536 536 857 186 196 197 198 196 198 858 858 536 196 213 197 196 213 196 536 756 904 536 213 536 221 756 536 186 904 221 536 755 756 743 743 756 186 903 904 756 903 756 755 904 493 221 904 903 977 904 977 493 903 755 977 755 743 910 755 910 977 493 977 910 493 910 497 493 497 499 910 743 497 413 497 498 498 497 743 497 413 362 413 498 254 254 498 889 889 498 743 889 186 254 889 743 186 363 125 364 125 737 364 625 363 364 737 643 642 125 643 737 643 125 212 125 211 212 211 629 212 750 211 751 211 750 629 505 211 125 211 505 751 624 629 630 629 750 630 959 630 750 783 750 751 750 783 808 750 808 959 507 783 751 751 505 507 505 506 507 667 507 506 506 668 667 506 126 668 506 124 126 506 505 124 667 668 669 363 669 668 126 363 668 124 125 126 126 125 363 505 125 124 625 669 363))
                   (list :vertices (let ((mat (make-matrix 1002 3))) (fvector-replace (array-entity mat) #f(-1.2468999862670898e+01 3.9723799228668213e+00 -6.4992804527282715e+00 -1.2259700775146484e+01 4.8232102394104004e+00 -9.5915098190307617e+00 -1.2469099998474121e+01 3.9723799228668213e+00 -7.7372398376464844e+00 -1.1248499870300293e+01 5.1348104476928711e+00 -6.3296699523925781e+00 -1.2259700775146484e+01 4.8232197761535645e+00 -1.8234599828720093e+00 4.5199198722839355e+00 9.9936399459838867e+00 -1.2656300544738770e+01 1.0525900125503540e+00 8.9252195358276367e+00 -1.2656300544738770e+01 1.6549700498580933e+00 9.1108398437500000e+00 -1.2403100013732910e+01 -4.0988898277282715e+00 7.3378596305847168e+00 -1.2656300544738770e+01 -7.1897602081298828e+00 6.3854498863220215e+00 -1.2656300544738770e+01 -6.1697001457214355e+00 6.6997704505920410e+00 -1.2403100013732910e+01 -1.7609100341796875e+00 8.0582799911499023e+00 -1.2403100013732910e+01 -1.0249300003051758e+00 8.2850599288940430e+00 1.2656300544738770e+01 4.5199198722839355e+00 9.9936399459838867e+00 1.2656300544738770e+01 1.6549700498580933e+00 9.1108398437500000e+00 1.2403100013732910e+01 6.4850397109985352e+00 7.0131702423095703e+00 -1.2792600393295288e+00 6.9717001914978027e+00 6.3005099296569824e+00 -6.4077000617980957e+00 6.5039496421813965e+00 6.9507203102111816e+00 -6.4160499572753906e+00 -1.3997900009155273e+01 3.1436100006103516e+00 -1.7327999114990234e+01 -1.4515100479125977e+01 4.0282702445983887e+00 -1.6200000762939453e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.4174999237060547e+01 -1.2484399795532227e+01 3.9099199771881104e+00 9.0204601287841797e+00 -1.2505499839782715e+01 3.8669600486755371e+00 8.9239597320556641e+00 -1.2484200477600098e+01 3.9098598957061768e+00 9.6969003677368164e+00 2.4653301239013672e+00 -1.7317001342773438e+01 1.3170300483703613e+01 6.9176201820373535e+00 -1.2376099586486816e+01 1.3162500381469727e+01 -2.2360601425170898e+00 -2.0811300277709961e+01 1.3162500381469727e+01 -2.4159500122070312e+01 6.2754898071289062e+00 -2.2972999572753906e+01 -3.2170398712158203e+01 8.2487401962280273e+00 -2.5059400558471680e+01 -3.1634099960327148e+01 8.1166400909423828e+00 -2.0248399734497070e+01 -1.2662399291992188e+01 3.7477099895477295e+00 -7.8319096565246582e+00 -1.2970499992370605e+01 3.6573300361633301e+00 -2.2901000976562500e+00 -1.2573500633239746e+01 3.8009400367736816e+00 -5.9408802986145020e+00 -1.2484200477600098e+01 3.9098501205444336e+00 -7.8881697654724121e+00 -1.2484200477600098e+01 3.9098598957061768e+00 -7.0624599456787109e+00 -1.2484399795532227e+01 3.9099199771881104e+00 2.0024199485778809e+00 -1.2484299659729004e+01 3.9098799228668213e+00 9.6985197067260742e-01 -1.2524399757385254e+01 3.8409099578857422e+00 1.8293800354003906e+00 -1.2605199813842773e+01 3.7882800102233887e+00 7.5229701995849609e+00 -1.2807399749755859e+01 3.7095000743865967e+00 5.9678897857666016e+00 -1.2767600059509277e+01 3.7213799953460693e+00 8.6283597946166992e+00 -3.7348401546478271e+00 9.6158704757690430e+00 1.2329899787902832e+01 -3.1280300617218018e+00 7.6370201110839844e+00 1.2403100013732910e+01 8.7329399585723877e-01 1.1364899635314941e+01 1.2318799972534180e+01 1.0703100204467773e+01 7.2038497924804688e+00 1.1134699821472168e+01 7.7888498306274414e+00 6.2445998191833496e+00 1.0708199501037598e+01 7.8256697654724121e+00 6.1219301223754883e+00 1.1171999931335449e+01 -2.1993900299072266e+01 4.3255300521850586e+00 2.4526199340820312e+01 -2.3448400497436523e+01 3.2784500122070312e+00 2.5642499923706055e+01 -2.0344799041748047e+01 2.5829300880432129e+00 2.3502201080322266e+01 -1.1917799711227417e+00 3.1527099609375000e+00 1.2656300544738770e+01 6.2891502380371094e+00 4.2209100723266602e+00 1.2782799720764160e+01 6.1553201675415039e+00 4.6863098144531250e+00 1.2656300544738770e+01 -2.2139501571655273e+01 -2.5863601684570312e+01 -2.0501499176025391e+01 -2.1425201416015625e+01 -2.7268400192260742e+01 -1.9481500625610352e+01 -2.5302400588989258e+01 -2.7277299880981445e+01 -2.1045299530029297e+01 -6.9466300964355469e+01 -3.3302398681640625e+01 -2.2395801544189453e+01 -7.2046302795410156e+01 -3.1377199172973633e+01 -2.3069599151611328e+01 -7.0832496643066406e+01 -3.1005399703979492e+01 -2.3329299926757812e+01 6.5056400299072266e+00 6.9451603889465332e+00 -7.9941797256469727e+00 6.5039496421813965e+00 6.9507203102111816e+00 -1.0265699386596680e+01 -8.3144500732421875e+01 5.1153302192687988e+00 -2.8096899032592773e+01 -7.5474998474121094e+01 1.5825899124145508e+01 -2.8096899032592773e+01 -6.2479598999023438e+01 1.2624799728393555e+01 -2.8096899032592773e+01 -1.4801699638366699e+01 4.1313600540161133e+00 -1.6200000762939453e+01 -3.7829699516296387e+00 1.0163400650024414e+01 -1.2222599983215332e+01 -2.6531100273132324e-01 1.2549300193786621e+01 -1.1706399917602539e+01 8.7329399585723877e-01 1.1364899635314941e+01 -1.2318799972534180e+01 -1.4801400184631348e+01 4.1321501731872559e+00 1.6200000762939453e+01 -1.3764300346374512e+01 3.1246500015258789e+00 1.7190198898315430e+01 -1.4514800071716309e+01 4.0290498733520508e+00 1.6200000762939453e+01 2.2106499671936035e+00 1.3960100173950195e+01 2.0790699124336243e-01 3.4323198795318604e+00 1.3626199722290039e+01 -1.5319299697875977e-01 2.2320101261138916e+00 1.3986299514770508e+01 -4.8962998390197754e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -1.2998600006103516e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -1.3617499351501465e+01 -1.1717700004577637e+01 9.3561401367187500e+00 4.2465898394584656e-01 -1.2008800506591797e+01 8.4160299301147461e+00 -3.8966000080108643e+00 -1.1928699493408203e+01 7.6515102386474609e+00 -4.8316694612263178e-13 1.3559999465942383e+00 1.3735700607299805e+01 7.6857200074706422e-13 2.2826800346374512e+00 1.3991299629211426e+01 4.2284898757934570e+00 1.3559999465942383e+00 1.3735700607299805e+01 -8.7694101333618164e+00 2.4698100090026855e+00 1.3937099456787109e+01 -8.7694101333618164e+00 1.8381600379943848e+00 1.3701499938964844e+01 -1.0737399101257324e+01 -3.2054100036621094e+01 -6.2682800292968750e+00 -2.7916500091552734e+01 -3.5307498931884766e+01 -6.9998002052307129e+00 -2.8040800094604492e+01 -3.4960601806640625e+01 -4.6865496635437012e+00 -2.8096899032592773e+01 1.6996000289916992e+01 3.3174800872802734e+00 -1.2577500343322754e+01 9.9698200225830078e+00 -1.2566100120544434e+01 -1.1364099502563477e+01 8.8271598815917969e+00 -1.1986900329589844e+01 -1.2798500061035156e+01 6.5754299163818359e+00 6.7187600135803223e+00 1.1521000862121582e+01 7.0703201293945312e+00 5.9839997291564941e+00 1.1557299613952637e+01 -6.3049201965332031e+00 2.9044599533081055e+00 -1.2972599983215332e+01 -1.2259400367736816e+01 4.8232898712158203e+00 -1.2660400390625000e+01 -9.9744796752929688e+00 4.5425395965576172e+00 -1.2656199455261230e+01 1.6979299545288086e+01 7.7118597030639648e+00 -1.0204299926757812e+01 1.7815399169921875e+01 6.8035297393798828e+00 -6.1348299980163574e+00 1.8233100891113281e+01 6.0392799377441406e+00 -9.8591594696044922e+00 -7.5310699462890625e+01 -2.9075099945068359e+01 2.2331199645996094e+01 -7.4115997314453125e+01 -3.0917200088500977e+01 6.3364000320434570e+00 -7.3991905212402344e+01 -3.1087200164794922e+01 2.0753999710083008e+01 -1.7933801651000977e+01 4.4097299575805664e+00 -1.9811000823974609e+01 -1.8381599426269531e+01 4.6153502464294434e+00 -1.9938400268554688e+01 -1.8535400390625000e+01 4.7442803382873535e+00 -1.9777198791503906e+01 -4.6186599731445312e+01 -3.2449398040771484e+01 1.9171899795532227e+01 -3.9010299682617188e+01 -3.1170000076293945e+01 1.2812999725341797e+01 -4.0568500518798828e+01 -3.1447801589965820e+01 1.9171899795532227e+01 -9.3643701076507568e-01 1.2331299781799316e+00 -1.3162500381469727e+01 7.4979400634765625e+00 -1.1315800666809082e+01 -1.3162500381469727e+01 -2.2360601425170898e+00 -2.0811300277709961e+01 -1.3162500381469727e+01 -2.7377400398254395e+00 -8.1501903533935547e+00 -1.3189200401306152e+01 -5.5910696983337402e+00 -9.8823995590209961e+00 -1.3536700248718262e+01 -5.0552597045898438e+00 7.3047602176666260e-01 -1.3541700363159180e+01 -3.0652400970458984e+01 6.3191099166870117e+00 -2.7726499557495117e+01 -2.8022499084472656e+01 7.0541601181030273e+00 -2.5820299148559570e+01 -2.5538499832153320e+01 5.7663202285766602e+00 -2.5932901382446289e+01 -3.6865699768066406e+01 9.4052896499633789e+00 -2.5059400558471680e+01 -3.6099399566650391e+01 9.0500707626342773e+00 -2.6140300750732422e+01 -1.6234600067138672e+01 -2.6851600646972656e+01 -1.6481698989868164e+01 -1.5578900337219238e+01 -2.5394300460815430e+01 -1.7527900695800781e+01 -2.1363500595092773e+01 5.5741901397705078e+00 2.1366701126098633e+01 -2.0411201477050781e+01 4.7090196609497070e+00 2.2788400650024414e+01 -2.0372501373291016e+01 5.0616903305053711e+00 2.1867599487304688e+01 -7.3012802124023438e+01 -1.1470699310302734e+01 -2.8096899032592773e+01 -1.9929201126098633e+01 2.5044901371002197e+00 -2.3149600982666016e+01 -2.0344799041748047e+01 2.5829300880432129e+00 -2.3502201080322266e+01 -1.9911499023437500e+01 2.6179800033569336e+00 -2.3137298583984375e+01 1.7851099014282227e+01 2.8868699073791504e+00 -1.1213200569152832e+01 1.7999500274658203e+01 2.8110098838806152e+00 -1.0229700088500977e+01 1.0173600196838379e+01 -1.2668499946594238e+01 -1.0229700088500977e+01 -1.1707900047302246e+01 1.0305900573730469e+00 1.6281200408935547e+01 -1.3814399719238281e+01 1.2366698980331421e+00 1.7900100708007812e+01 -1.2813099861145020e+01 -8.6443700790405273e+00 1.6657701492309570e+01 -6.7424400329589844e+01 -3.5585800170898438e+01 1.5192500114440918e+01 -6.9739402770996094e+01 -3.4844497680664062e+01 1.9329198837280273e+01 -6.9890800476074219e+01 -3.4740299224853516e+01 1.3068599700927734e+01 -3.8664299011230469e+01 9.7858896255493164e+00 -2.5666900634765625e+01 -3.8664299011230469e+01 9.7859201431274414e+00 6.0895299911499023e+00 -3.6865699768066406e+01 9.4051599502563477e+00 -2.5553998947143555e+00 1.7359399795532227e+01 7.3857803344726562e+00 -5.2850300073623657e-01 1.6201900482177734e+01 8.2512598037719727e+00 -6.4863600730895996e+00 1.5625000000000000e+01 8.4799699783325195e+00 3.5178201198577881e+00 1.8429599761962891e+01 4.6149396896362305e+00 1.0229800224304199e+01 1.8488298416137695e+01 4.2356801033020020e+00 5.2802896499633789e+00 1.8034099578857422e+01 6.5168299674987793e+00 9.8976402282714844e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -9.9036703109741211e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -9.4646701812744141e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -8.9752006530761719e+00 -1.2468999862670898e+01 3.9723799228668213e+00 1.3617499351501465e+01 -1.0752200126647949e+01 3.0702002048492432e+00 1.4689800262451172e+01 -8.5498199462890625e+00 2.0437798500061035e+00 1.4373999595642090e+01 -8.8484201431274414e+00 1.0371999740600586e+01 -1.0295099258422852e+01 -9.3663597106933594e+00 1.0286300659179688e+01 -1.0186400413513184e+01 -1.0261599540710449e+01 1.0155900001525879e+01 -8.7694101333618164e+00 -4.7212001800537109e+01 -3.0567699432373047e+01 -2.2045299530029297e+01 -3.7275600433349609e+01 -2.9620201110839844e+01 -2.1652898788452148e+01 -5.6820701599121094e+01 -3.2918598175048828e+01 -2.1759700775146484e+01 -2.1543800354003906e+01 5.6311798095703125e+00 -2.1169200897216797e+01 -2.1525400161743164e+01 5.6266598701477051e+00 -2.1153800964355469e+01 -2.1363500595092773e+01 5.5741901397705078e+00 -2.1366701126098633e+01 -5.7192401885986328e+01 -1.5727400779724121e+01 2.7392900466918945e+01 -3.6246501922607422e+01 -1.2408599853515625e+01 2.7300899505615234e+01 -4.7573600769042969e+01 -1.0629099845886230e+01 2.7922698974609375e+01 -1.1501399278640747e+00 -2.3098100662231445e+01 1.1806599617004395e+01 1.0235599279403687e+00 -2.2340299606323242e+01 1.1137999534606934e+01 1.8424400091171265e+00 -2.0947498321533203e+01 1.2331600189208984e+01 -2.0471099853515625e+01 5.3669600486755371e+00 -2.0250000000000000e+01 -2.1715600967407227e+01 5.6734995841979980e+00 -2.0814899444580078e+01 -2.2813199996948242e+01 5.9438600540161133e+00 -2.0250000000000000e+01 -2.1642099380493164e+01 5.6554098129272461e+00 2.0250000000000000e+01 -2.3167098999023438e+01 6.1690402030944824e+00 1.9695999145507812e+01 -2.4160200119018555e+01 6.2756600379943848e+00 2.0250000000000000e+01 -6.7396001815795898e+00 -2.4108900070190430e+01 -1.3244400024414062e+01 -6.8111300468444824e+00 -2.5263500213623047e+01 -1.1734999656677246e+01 -9.2166500091552734e+00 -2.4305500030517578e+01 -1.4093100547790527e+01 -5.3998703002929688e+01 -1.6689399719238281e+01 -2.7050100326538086e+01 -3.5852001190185547e+01 -1.0150699615478516e+01 -2.7704900741577148e+01 -3.6246501922607422e+01 -1.2408599853515625e+01 -2.7300899505615234e+01 -3.6865699768066406e+01 9.4052896499633789e+00 2.5059400558471680e+01 -3.3109001159667969e+01 8.3592500686645508e+00 2.5973201751708984e+01 -3.2170398712158203e+01 8.2487401962280273e+00 2.5059400558471680e+01 -2.0274599075317383e+01 6.1647500991821289e+00 1.9253698348999023e+01 -1.9463399887084961e+01 5.4603700637817383e+00 1.9454500198364258e+01 -1.9121200561523438e+01 5.1631298065185547e+00 1.8648300170898438e+01 -2.3977399826049805e+01 9.3802804946899414e+00 -1.9237499237060547e+01 -2.8271600723266602e+01 1.3109300613403320e+01 -1.9237499237060547e+01 -2.2188899993896484e+01 7.8271403312683105e+00 -1.6200000762939453e+01 -8.5282297134399414e+00 8.4679307937622070e+00 1.2318799972534180e+01 -1.1204199790954590e+01 8.3859004974365234e+00 1.1267899513244629e+01 -9.5885000228881836e+00 5.6457500457763672e+00 1.2016500473022461e+01 -3.1619102478027344e+01 9.1428298950195312e+00 1.9237499237060547e+01 -3.1634099960327148e+01 8.1166400909423828e+00 1.6200000762939453e+01 -3.1634099960327148e+01 8.1166400909423828e+00 1.9173799514770508e+01 -8.0539199829101562e+01 1.8201200485229492e+01 1.1521100044250488e+01 -8.1597496032714844e+01 1.7668201446533203e+01 2.0089199066162109e+01 -7.9247604370117188e+01 1.8652799606323242e+01 1.6982500076293945e+01 -1.9463399887084961e+01 5.4603700637817383e+00 -1.9454500198364258e+01 -1.9552999496459961e+01 5.2118301391601562e+00 -1.9774299621582031e+01 -2.0416799545288086e+01 5.5875201225280762e+00 -1.9607500076293945e+01 -6.3738002777099609e+01 -3.5578601837158203e+01 -6.5812498331069946e-01 -6.0402301788330078e+01 -3.4983898162841797e+01 -3.0985200405120850e+00 -6.3738002777099609e+01 -3.5578601837158203e+01 6.5812498331069946e-01 -8.1343498229980469e+01 -1.6503000259399414e+01 2.7062200546264648e+01 -8.1813697814941406e+01 -1.3203999519348145e+01 2.7711000442504883e+01 -8.2870994567871094e+01 -1.3630099296569824e+01 2.6311100006103516e+01 1.4399399757385254e+01 8.0869398117065430e+00 -1.1998900413513184e+01 1.4841400146484375e+01 6.6712498664855957e+00 -1.3026099205017090e+01 1.3564299583435059e+01 6.5236997604370117e+00 -1.2960899353027344e+01 -3.6743099689483643e+00 1.1660599708557129e+01 1.0305999755859375e+01 -4.2065200805664062e+00 1.1490400314331055e+01 1.0306200027465820e+01 -4.5494699478149414e+00 1.1222999572753906e+01 1.1082200050354004e+01 -1.5663599967956543e+01 -1.2680299758911133e+01 -1.8732999801635742e+01 -2.2333801269531250e+01 -1.5039600133895874e+00 -2.4641700744628906e+01 -1.8950401306152344e+01 5.0148200988769531e+00 -1.9704099655151367e+01 -1.9560499191284180e+01 5.1910400390625000e+00 -1.9819000244140625e+01 -1.8805200576782227e+01 4.8084197044372559e+00 -2.0003700256347656e+01 -1.4816500663757324e+01 4.1381201744079590e+00 5.9119100570678711e+00 -1.5987800598144531e+01 4.4253101348876953e+00 1.6200000762939453e+01 -1.4801400184631348e+01 4.1322402954101562e+00 1.1137500762939453e+01 -1.2476700782775879e+01 3.9411499500274658e+00 -1.0080999374389648e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -9.9088802337646484e+00 -1.8682600021362305e+01 4.8834199905395508e+00 -1.9414600372314453e+01 7.8056902885437012e+00 6.3070902824401855e+00 1.0229800224304199e+01 7.7733201980590820e+00 6.2963700294494629e+00 1.0229800224304199e+01 7.8375797271728516e+00 6.3176698684692383e+00 1.0229800224304199e+01 7.7733201980590820e+00 6.2963700294494629e+00 -1.0229800224304199e+01 7.8056902885437012e+00 6.3070902824401855e+00 -1.0229800224304199e+01 7.7888598442077637e+00 6.2445998191833496e+00 -1.0708199501037598e+01 -2.0253499984741211e+01 5.3109297752380371e+00 -2.0218898773193359e+01 -1.9684999465942383e+01 5.1407999992370605e+00 -2.0137001037597656e+01 -1.9590099334716797e+01 5.1089401245117188e+00 -2.0123201370239258e+01 -1.8959199905395508e+01 5.0460901260375977e+00 1.6953500747680664e+01 -1.8677999496459961e+01 4.9410200119018555e+00 1.8645801544189453e+01 -6.8465900421142578e+00 -2.5434799194335938e+01 1.0693900108337402e+01 -6.7984600067138672e+00 -2.5216499328613281e+01 1.1873999595642090e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 1.0730699539184570e+01 5.4230195283889771e-01 1.3339400291442871e+01 -1.0186499595642090e+01 6.6291794180870056e-02 1.3118900299072266e+01 -1.0295099258422852e+01 3.5693798065185547e+00 1.2067600250244141e+01 -1.1115400314331055e+01 3.3281998634338379e+00 9.6264200210571289e+00 -1.1927900314331055e+01 1.9329000711441040e+00 1.1760899543762207e+01 -1.2143399238586426e+01 -2.6596599578857422e+01 -2.8676700592041016e+01 -2.0053998947143555e+01 -3.0364299774169922e+01 -2.8519001007080078e+01 -2.1515800476074219e+01 -3.2134498596191406e+01 -2.9944099426269531e+01 -1.9171699523925781e+01 -3.2243801116943359e+01 -2.9963600158691406e+01 -1.9171899795532227e+01 -3.2244800567626953e+01 -2.9958099365234375e+01 -1.9357599258422852e+01 -4.5868897438049316e+00 -2.1889400482177734e+01 -1.3294899940490723e+01 -6.8786296844482422e+00 -2.2554998397827148e+01 -1.3689200401306152e+01 1.0780099868774414e+01 7.3840303421020508e+00 1.0229299545288086e+01 7.9849400520324707e+00 6.3666200637817383e+00 9.7502603530883789e+00 -7.5474998474121094e+01 1.5825899124145508e+01 2.8096899032592773e+01 -8.3144500732421875e+01 5.1153302192687988e+00 2.8096899032592773e+01 -3.4960601806640625e+01 -4.6865601539611816e+00 2.8096899032592773e+01 1.8121999740600586e+01 3.7267000675201416e+00 -1.1475500106811523e+01 -3.1634099960327148e+01 8.1166400909423828e+00 -1.6200000762939453e+01 -2.8271600723266602e+01 1.3109300613403320e+01 -1.6200000762939453e+01 -3.1582798004150391e+01 1.1628499984741211e+01 -1.6200000762939453e+01 -3.1426000595092773e+01 1.2474399566650391e+01 -1.7586500167846680e+01 -3.1582798004150391e+01 1.1628499984741211e+01 -1.9237499237060547e+01 -1.4514900207519531e+01 4.0289001464843750e+00 1.0148599624633789e+01 -1.4514900207519531e+01 4.0289201736450195e+00 1.0824300765991211e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -1.1930599212646484e+00 -6.2811598777770996e+00 -2.5323999404907227e+01 -8.8308601379394531e+00 -5.1029601097106934e+00 -2.5061498641967773e+01 9.2014297842979431e-02 1.7082599639892578e+01 7.6317801475524902e+00 5.2086601257324219e+00 1.6372600555419922e+01 8.1343603134155273e+00 1.0082700729370117e+01 -1.8381599426269531e+01 4.6153502464294434e+00 1.9938400268554688e+01 -1.8950401306152344e+01 5.0148200988769531e+00 1.9704099655151367e+01 -1.8805200576782227e+01 4.8084197044372559e+00 2.0003700256347656e+01 -1.9552999496459961e+01 5.2118301391601562e+00 1.9774299621582031e+01 -1.9560499191284180e+01 5.1910400390625000e+00 1.9819000244140625e+01 -1.9590099334716797e+01 5.1089401245117188e+00 2.0123201370239258e+01 -1.8682600021362305e+01 4.8834199905395508e+00 1.9414600372314453e+01 -1.8535400390625000e+01 4.7442803382873535e+00 1.9777198791503906e+01 -1.5709898948669434e+01 2.6496000289916992e+00 1.9353401184082031e+01 -8.5771003723144531e+01 1.1238199234008789e+01 -8.6786994934082031e+00 -8.5504898071289062e+01 1.2630400657653809e+01 -1.7258298873901367e+01 -8.5808395385742188e+01 1.0856200218200684e+01 -2.5666900634765625e+01 -8.4953704833984375e+01 -5.5282402038574219e+00 -2.6353700637817383e+01 -8.5409095764160156e+01 -2.5775000452995300e-01 -2.6810899734497070e+01 -8.3794303894042969e+01 -8.1370296478271484e+00 -2.7293899536132812e+01 -8.4496902465820312e+01 5.4552202224731445e+00 2.7859399795532227e+01 -8.3920501708984375e+01 -1.1767899990081787e+00 2.7920200347900391e+01 -3.2235397338867188e+01 8.0054492950439453e+00 2.6211301803588867e+01 -3.2233303070068359e+01 8.0535802841186523e+00 2.5843000411987305e+01 5.9477596282958984e+00 -1.8598400115966797e+01 -1.0229899406433105e+01 1.7649099826812744e+00 -2.1988698959350586e+01 -1.0890100479125977e+01 4.4711198806762695e+00 -1.9349500656127930e+01 -1.1871500015258789e+01 -8.2649297714233398e+00 -1.0456899642944336e+01 -1.4296099662780762e+01 -7.5794796943664551e+00 -2.2704200744628906e+01 -1.3865099906921387e+01 -1.2534000396728516e+01 3.8350398540496826e+00 4.3579798936843872e-01 -5.1284399032592773e+00 3.3915398120880127e+00 -1.2656300544738770e+01 6.1553602218627930e+00 4.6861801147460938e+00 -1.2656300544738770e+01 -1.1917500495910645e+00 3.1527099609375000e+00 -1.2656300544738770e+01 -4.9385200500488281e+01 -3.3019901275634766e+01 -1.9171899795532227e+01 -3.8531600952148438e+01 -3.1011400222778320e+01 -1.9901300430297852e+01 -3.5196399688720703e+01 -3.0490100860595703e+01 -1.9171899795532227e+01 -2.1136699676513672e+01 5.5309100151062012e+00 2.0822700500488281e+01 -2.1525400161743164e+01 5.6266598701477051e+00 2.1153800964355469e+01 -1.9929201126098633e+01 2.5044901371002197e+00 2.3149600982666016e+01 -1.9911499023437500e+01 2.6179800033569336e+00 2.3137298583984375e+01 -1.9684999465942383e+01 5.1407999992370605e+00 2.0137001037597656e+01 9.3636302947998047e+00 -1.2259200096130371e+01 1.2307199478149414e+01 9.9552602767944336e+00 -1.2558500289916992e+01 1.1385199546813965e+01 1.7250400543212891e+01 3.1916201114654541e+00 1.2400099754333496e+01 8.3363199234008789e+00 -1.1740099906921387e+01 1.3043000221252441e+01 -1.1279500722885132e+00 2.6728100776672363e+00 -1.2782799720764160e+01 -3.0875298976898193e+00 2.3608798980712891e+00 -1.2931300163269043e+01 -7.9667396545410156e+01 -2.1551099777221680e+01 7.7849397659301758e+00 -7.9124397277832031e+01 -2.2711299896240234e+01 -6.7944297790527344e+00 -7.8378700256347656e+01 -2.4122501373291016e+01 2.4199899673461914e+01 -5.1685897827148438e+01 9.9661397933959961e+00 2.8096899032592773e+01 -4.1871303558349609e+01 7.5485901832580566e+00 2.8096899032592773e+01 5.7027497291564941e+00 -1.8850900650024414e+01 1.0230400085449219e+01 4.9494004249572754e+00 -1.9332698822021484e+01 1.1386799812316895e+01 3.4745199680328369e+00 -2.0812099456787109e+01 1.0230200767517090e+01 -1.4514900207519531e+01 4.0288801193237305e+00 9.4729499816894531e+00 -2.5882299423217773e+01 -6.5729398727416992e+00 2.5915699005126953e+01 -2.7801700592041016e+01 -8.5838298797607422e+00 2.6338800430297852e+01 -2.4039199829101562e+01 -1.7257900238037109e+01 2.2966598510742188e+01 -2.7801700592041016e+01 -8.5838403701782227e+00 -2.6338800430297852e+01 -2.4689399719238281e+01 -1.7569900512695312e+01 -2.3172599792480469e+01 -2.9835699081420898e+01 -1.0471699714660645e+01 -2.6646598815917969e+01 -3.2243801116943359e+01 -2.9963600158691406e+01 1.9171899795532227e+01 -3.2134498596191406e+01 -2.9944099426269531e+01 1.9171699523925781e+01 -3.2244800567626953e+01 -2.9958099365234375e+01 1.9357599258422852e+01 -8.5030395507812500e+01 1.3849199295043945e+01 -2.5683200836181641e+01 -8.3256996154785156e+01 1.6324600219726562e+01 -2.5701200485229492e+01 -8.3782005310058594e+01 1.5325400352478027e+01 -2.6581800460815430e+01 7.7733201980590820e+00 6.2963800430297852e+00 -9.5904197692871094e+00 7.0217099189758301e+00 6.2707200050354004e+00 -1.0502500534057617e+01 7.7806801795959473e+00 6.2986197471618652e+00 -6.6971802711486816e+00 -8.3059402465820312e+01 -1.3686499595642090e+01 1.0157999992370605e+01 -8.3825904846191406e+01 -1.1212299346923828e+01 2.5673000335693359e+01 -8.3771400451660156e+01 -1.1408599853515625e+01 -4.6389899253845215e+00 7.3231196403503418e+00 4.9986801147460938e+00 1.2475100517272949e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -1.0522600173950195e+01 -2.7505100250244141e+01 -2.8871700286865234e+01 2.0221300125122070e+01 -2.7945199966430664e+01 -2.7703599929809570e+01 2.1552700042724609e+01 -3.2466899871826172e+01 -2.8711000442504883e+01 2.1660499572753906e+01 -7.4771903991699219e+01 1.8679899215698242e+01 2.5666900634765625e+01 -7.8437995910644531e+01 1.8913499832153320e+01 2.5915500640869141e+01 -7.7258293151855469e+01 1.8657999038696289e+01 2.6711400985717773e+01 -6.6294601440429688e+01 -3.5746601104736328e+01 -1.9609399795532227e+01 -6.3738002777099609e+01 -3.5578601837158203e+01 -1.9171899795532227e+01 -6.5297294616699219e+01 -3.5755100250244141e+01 -1.2447099685668945e+01 6.5754299163818359e+00 6.7187600135803223e+00 -1.1521000862121582e+01 5.9373202323913574e+00 8.7896099090576172e+00 -6.6695103645324707e+00 1.4505400657653809e+01 5.6119298934936523e+00 -1.3162500381469727e+01 1.5431400299072266e+01 4.6149396896362305e+00 -1.3162500381469727e+01 -6.5213394165039062e+01 -3.5754699707031250e+01 5.3641695976257324e+00 -6.3738002777099609e+01 -3.5578601837158203e+01 1.9171899795532227e+01 -6.5423103332519531e+01 -3.5773197174072266e+01 1.8596099853515625e+01 -1.1279500722885132e+00 2.6728100776672363e+00 1.2782799720764160e+01 -2.9760499000549316e+00 3.0944697856903076e+00 1.2656300544738770e+01 -3.5070602416992188e+01 -2.1786800384521484e+01 -2.4295400619506836e+01 -3.7007598876953125e+01 -1.6523199081420898e+01 -2.6201299667358398e+01 -3.3571800231933594e+01 -1.3752599716186523e+01 -2.6741498947143555e+01 -5.5210800170898438e+01 1.3861700057983398e+01 -2.5675899505615234e+01 -5.8108501434326172e+01 1.4226099967956543e+01 -2.6618700027465820e+01 -6.5610900878906250e+01 1.6215900421142578e+01 -2.6334899902343750e+01 -2.4160200119018555e+01 6.2756600379943848e+00 1.6200000762939453e+01 -2.4160200119018555e+01 6.2756600379943848e+00 4.8937501907348633e+00 -2.0114799499511719e+01 4.5602002143859863e+00 -2.2325199127197266e+01 -2.0671400070190430e+01 5.1170496940612793e+00 -2.2351400375366211e+01 -3.1582798004150391e+01 1.1628499984741211e+01 1.6200000762939453e+01 -3.0750799179077148e+01 1.3395999908447266e+01 1.6200401306152344e+01 -2.8271600723266602e+01 1.3109300613403320e+01 1.6200000762939453e+01 -4.3063602447509766e+00 7.2739300727844238e+00 1.2656300544738770e+01 -7.9056901931762695e+00 6.1648397445678711e+00 1.2403100013732910e+01 -4.5345703125000000e+01 -3.2152801513671875e+01 2.0257198333740234e+01 -5.8073497772216797e+01 -3.3361198425292969e+01 2.1627399444580078e+01 -5.3898498535156250e+01 -3.3666698455810547e+01 2.0286298751831055e+01 -1.8998699188232422e+01 4.6136698722839355e+00 2.0957500457763672e+01 6.5172100067138672e+00 5.2400598526000977e+00 -1.2515299797058105e+01 7.2640500068664551e+00 5.3626699447631836e+00 -1.2187999725341797e+01 -2.8788700103759766e+01 -8.0465402603149414e+00 -2.6805700302124023e+01 -2.9295900344848633e+01 -2.6298601627349854e+00 -2.7616500854492188e+01 -7.4663600921630859e+00 -9.6977396011352539e+00 1.4044400215148926e+01 -6.7237200736999512e+00 8.6511200666427612e-01 1.3970100402832031e+01 -9.9872703552246094e+00 -1.0614800453186035e+01 1.4986700057983398e+01 -3.1582798004150391e+01 1.1628499984741211e+01 1.9237499237060547e+01 -7.9663406372070312e+01 -2.1549299240112305e+01 -2.5176801681518555e+01 -7.8378700256347656e+01 -2.4122501373291016e+01 -2.4199899673461914e+01 1.3725899696350098e+01 6.1690597534179688e+00 1.3083499908447266e+01 1.3075299263000488e+01 7.6040601730346680e+00 1.2196599960327148e+01 -6.7755897521972656e+01 1.5935299873352051e+01 -2.7407100677490234e+01 -6.0522998809814453e+01 1.3709699630737305e+01 2.7725700378417969e+01 -7.5249801635742188e+01 1.6741300582885742e+01 2.7983098983764648e+01 -6.6762901306152344e+01 1.4503699302673340e+01 -2.8012199401855469e+01 -5.4187301635742188e+01 1.2421299934387207e+01 -2.7538700103759766e+01 1.4696800231933594e+01 8.6779699325561523e+00 -1.0343199729919434e+01 1.6443500518798828e+01 7.5257997512817383e+00 -1.2014800071716309e+01 7.5706100463867188e+00 -1.3780200004577637e+01 -1.2959400177001953e+01 3.1823399066925049e+00 -1.8640600204467773e+01 -1.3034200668334961e+01 -1.2421900749206543e+01 4.1541399955749512e+00 4.5282101631164551e+00 -1.2468999862670898e+01 3.9723701477050781e+00 1.8569400310516357e+00 -6.1132202148437500e+00 8.9653596878051758e+00 -1.2327199935913086e+01 -8.5282297134399414e+00 8.4679307937622070e+00 -1.2318799972534180e+01 2.3100900650024414e-01 1.2773900032043457e+01 1.1537400245666504e+01 6.6291794180870056e-02 1.3118900299072266e+01 1.0295099258422852e+01 -3.1013799667358398e+01 -1.1508500099182129e+01 2.6688199996948242e+01 -2.8788700103759766e+01 -8.0465402603149414e+00 2.6805700302124023e+01 -3.3203502655029297e+01 -3.0134700775146484e+01 -1.7758001327514648e+01 -2.4825799942016602e+01 -2.8641099929809570e+01 -1.8163799285888672e+01 -4.1487602233886719e+01 -3.1611598968505859e+01 -1.4307600021362305e+01 -1.2468999862670898e+01 3.9723799228668213e+00 8.9752006530761719e+00 -1.2468999862670898e+01 3.9723799228668213e+00 9.9036703109741211e+00 -1.2259700775146484e+01 4.8232102394104004e+00 9.3602504730224609e+00 -3.1784002304077148e+01 -2.9881599426269531e+01 -1.4811899662017822e+00 -7.1686904907226562e+01 1.6983200073242188e+01 2.7335699081420898e+01 -7.4860198974609375e+01 1.8286399841308594e+01 2.6814899444580078e+01 1.8429599761962891e+01 4.6149396896362305e+00 -1.0229800224304199e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -5.2312502861022949e+00 -2.5633199691772461e+01 4.6088900566101074e+00 -2.6641799926757812e+01 -2.9760499000549316e+00 3.0944697856903076e+00 -1.2656300544738770e+01 -1.0261599540710449e+01 1.0155900001525879e+01 8.7694101333618164e+00 -9.3663597106933594e+00 1.0286300659179688e+01 1.0186400413513184e+01 -1.0261599540710449e+01 1.0155900001525879e+01 3.2075098057183365e-14 -8.1791900634765625e+01 -1.5954900741577148e+01 -2.6767200469970703e+01 -8.0238800048828125e+01 -2.0285900115966797e+01 -2.5552999496459961e+01 -8.1184898376464844e+01 -1.8335500717163086e+01 -2.5733100891113281e+01 -3.6160202026367188e+00 -2.4537000656127930e+01 -1.1019499778747559e+01 -2.9645600318908691e+00 -2.3958898544311523e+01 -1.1670299530029297e+01 -8.5344795227050781e+01 1.3159299850463867e+01 2.5675498962402344e+01 -8.4780502319335938e+01 1.3482700347900391e+01 2.6805799484252930e+01 -8.3488502502441406e+01 1.6101799011230469e+01 2.5653900146484375e+01 -1.4594299316406250e+01 -1.1992500305175781e+01 1.7900100708007812e+01 -1.5563899993896484e+01 -1.8719600677490234e+01 1.8207599639892578e+01 -1.3649499893188477e+01 -2.0166198730468750e+01 1.6796400070190430e+01 7.1067600250244141e+00 -1.5662099838256836e+01 1.2590600013732910e+01 -5.2022899627685547e+01 1.0049200057983398e+01 -2.8097499847412109e+01 -3.2659900665283203e+01 6.2573800086975098e+00 2.7959701538085938e+01 -3.2310401916503906e+01 7.7156100273132324e+00 2.6880100250244141e+01 -3.7114601135253906e+01 8.2541399002075195e+00 2.7487701416015625e+01 6.2891502380371094e+00 4.2209100723266602e+00 -1.2782799720764160e+01 7.8256697654724121e+00 6.1219201087951660e+00 -1.1171999931335449e+01 7.8357701301574707e+00 6.0883202552795410e+00 -1.1264100074768066e+01 6.5892200469970703e+00 6.6740202903747559e+00 -1.1643799781799316e+01 -8.2213798522949219e+01 -9.0626697540283203e+00 2.8002300262451172e+01 -8.2400001525878906e+01 -4.0667500495910645e+00 2.8096899032592773e+01 -3.7193300724029541e+00 1.0557499885559082e+01 1.2111100196838379e+01 -7.3138801574707031e+01 -3.2191802978515625e+01 -1.9520699977874756e+00 -7.3991905212402344e+01 -3.1087200164794922e+01 -2.0753999710083008e+01 -7.3362998962402344e+01 -3.1903699874877930e+01 -2.0454200744628906e+01 -7.0345703125000000e+01 -3.3393600463867188e+01 2.2247501373291016e+01 -6.5009803771972656e+01 -3.4581100463867188e+01 2.1574399948120117e+01 -7.0832199096679688e+01 -3.1005699157714844e+01 2.3329200744628906e+01 9.4824304580688477e+00 6.8887901306152344e+00 -1.0229599952697754e+01 -5.8311397552490234e+01 -3.4510696411132812e+01 -2.0043899536132812e+01 -5.9798099517822266e+01 -3.4223999023437500e+01 -2.1105899810791016e+01 -5.0657699584960938e+01 -3.2827701568603516e+01 -2.0781299591064453e+01 -5.7458099365234375e+01 -2.0169298171997070e+01 -2.6201400756835938e+01 -2.6081600189208984e+01 4.7166800498962402e+00 2.6796600341796875e+01 -2.9988599777221680e+01 5.7139000892639160e+00 2.7801799774169922e+01 -2.9492401123046875e+01 4.9492101669311523e+00 2.7866498947143555e+01 -2.0742601394653320e+01 5.4436001777648926e+00 1.6200000762939453e+01 -2.4548599243164062e+01 7.9655795097351074e+00 1.6200000762939453e+01 -1.4520799636840820e+01 4.0115003585815430e+00 -3.2433801889419556e-01 -1.5133599281311035e+01 4.2432403564453125e+00 -3.3784000873565674e+00 -7.7186103820800781e+01 -2.0684000015258789e+01 2.7094200134277344e+01 -7.8433197021484375e+01 -2.0577098846435547e+01 2.7034099578857422e+01 -7.5841705322265625e+01 -2.3446901321411133e+01 2.6201299667358398e+01 -1.3005199432373047e+01 3.6734499931335449e+00 4.7825298309326172e+00 -1.3184000015258789e+01 3.6677999496459961e+00 1.0433699607849121e+01 -1.2911699295043945e+01 3.6889998912811279e+00 8.6283597946166992e+00 -1.2516999244689941e+01 3.8552200794219971e+00 6.6013298034667969e+00 -1.2536999702453613e+01 3.8368198871612549e+00 7.7837600708007812e+00 -1.2509699821472168e+01 3.8612699508666992e+00 5.5878200531005859e+00 -1.2515500068664551e+01 3.8569900989532471e+00 4.7432298660278320e+00 -1.2617600440979004e+01 3.7806799411773682e+00 3.9830901622772217e+00 -1.2494400024414062e+01 3.8837699890136719e+00 7.4459300041198730e+00 -1.2515299797058105e+01 3.8555400371551514e+00 3.1807298660278320e+00 -1.2770099639892578e+01 3.6780300140380859e+00 -1.3781299591064453e+01 -1.2551699638366699e+01 3.8121600151062012e+00 -1.0509500503540039e+01 -1.2494299888610840e+01 3.8842501640319824e+00 -1.1810799598693848e+01 -1.2484299659729004e+01 3.9098701477050781e+00 -4.3427801132202148e+00 -1.2484200477600098e+01 3.9098501205444336e+00 -5.2011504173278809e+00 -1.2487799644470215e+01 3.8981499671936035e+00 5.0306601524353027e+00 -1.2484399795532227e+01 3.9099199771881104e+00 5.9310398101806641e+00 -1.2484200477600098e+01 3.9098501205444336e+00 6.6529803276062012e+00 -1.2484399795532227e+01 3.9099199771881104e+00 2.7161998748779297e+00 -1.2484299659729004e+01 3.9098799228668213e+00 -1.2311100006103516e+01 -1.2484399795532227e+01 3.9099199771881104e+00 3.8659100532531738e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -6.4431800842285156e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -3.2775499820709229e+00 -1.2553400039672852e+01 3.8170099258422852e+00 -2.6337800025939941e+00 -1.3502200126647949e+01 3.6915798187255859e+00 -5.7843003273010254e+00 -1.2484200477600098e+01 3.9098501205444336e+00 1.1838899612426758e+01 -1.2502299308776855e+01 3.8715100288391113e+00 1.1204400062561035e+01 -1.2566300392150879e+01 3.8090999126434326e+00 1.2344599723815918e+01 -1.2623800277709961e+01 3.7661299705505371e+00 1.1394400596618652e+01 -7.6548400878906250e+01 1.8981800079345703e+01 2.0772098541259766e+01 -1.5987800598144531e+01 4.4253101348876953e+00 -1.6200000762939453e+01 -8.5808395385742188e+01 1.0856200218200684e+01 2.5666900634765625e+01 -8.5545196533203125e+01 1.2445300102233887e+01 1.1223400115966797e+01 -8.5798896789550781e+01 1.0950900077819824e+01 5.1937799453735352e+00 -1.8212100982666016e+01 4.8294701576232910e+00 -3.5889799594879150e+00 -2.4160200119018555e+01 6.2756600379943848e+00 -1.3753100395202637e+01 -1.5917999267578125e+01 4.4139900207519531e+00 2.8708499670028687e-01 -5.4176799774169922e+01 -1.8406198501586914e+01 2.6585201263427734e+01 6.5039496421813965e+00 6.9507203102111816e+00 1.0265699386596680e+01 6.6861600875854492e+00 6.6043400764465332e+00 5.2144203186035156e+00 -7.4772003173828125e+01 1.8680000305175781e+01 -2.5666900634765625e+01 -7.4772003173828125e+01 1.8679899215698242e+01 -1.1820299148559570e+01 -1.7977699279785156e+01 -2.7983801364898682e+00 -2.1229398727416992e+01 -1.8674098968505859e+01 2.1953301429748535e+00 -2.2069599151611328e+01 -1.3814399719238281e+01 1.2366698980331421e+00 -1.7900100708007812e+01 6.3108000755310059e+00 7.5775399208068848e+00 -1.1643799781799316e+01 8.6524295806884766e+00 -1.5191599845886230e+01 1.0941699981689453e+01 -1.6323900222778320e+01 -2.6955699920654297e+01 1.6242500305175781e+01 -2.0590400695800781e+01 -2.7657899856567383e+01 1.8403299331665039e+01 -2.3231201171875000e+01 -2.8357799530029297e+01 1.7734498977661133e+01 7.7492098808288574e+00 6.2869400978088379e+00 4.6565900556743145e-03 -8.0036903381347656e+01 -1.6166000366210938e+01 -2.7858100891113281e+01 -7.9609603881835938e+01 -1.9263700485229492e+01 -2.7067701339721680e+01 -1.0022800445556641e+01 5.5124697685241699e+00 -1.2656300544738770e+01 -7.8006200790405273e+00 6.1972203254699707e+00 -1.2656300544738770e+01 -6.4110900878906250e+01 -3.3581001281738281e+01 -2.2046899795532227e+01 -6.8545196533203125e+01 -3.2818500518798828e+01 -2.2579700469970703e+01 -2.8804500579833984e+01 1.3430199623107910e+01 -1.9237600326538086e+01 -3.0280599594116211e+01 1.3544600486755371e+01 -1.9237001419067383e+01 -2.9175899505615234e+01 1.3620599746704102e+01 -1.6201000213623047e+01 -1.1577199935913086e+01 7.8938903808593750e+00 -1.0571000099182129e+01 -9.4056100845336914e+00 5.7048501968383789e+00 -1.2144999504089355e+01 -1.0799900054931641e+01 5.2730302810668945e+00 -1.0634300231933594e+01 9.3039999008178711e+00 6.4376001358032227e+00 1.1582799911499023e+01 7.8357701301574707e+00 6.0883202552795410e+00 1.1264100074768066e+01 -2.8271600723266602e+01 1.3109300613403320e+01 1.9237499237060547e+01 -2.9465299606323242e+01 1.3595799446105957e+01 1.9237499237060547e+01 -3.0399499893188477e+01 1.3425000190734863e+01 1.9237499237060547e+01 -7.0144195556640625e+01 -3.4517097473144531e+01 2.0652599334716797e+01 -7.2173400878906250e+01 -3.3203399658203125e+01 2.0240598678588867e+01 -1.0893500328063965e+01 -2.3506999969482422e+01 1.5018699645996094e+01 -1.3107599258422852e+01 -2.3883600234985352e+01 1.6286199569702148e+01 -9.3633508682250977e+00 -2.4608098983764648e+01 1.3956800460815430e+01 -1.9121200561523438e+01 5.1631298065185547e+00 -1.8648300170898438e+01 -4.4742698669433594e+01 9.5224294662475586e+00 2.7852001190185547e+01 -3.8778800964355469e+01 9.3354997634887695e+00 2.6824199676513672e+01 -7.3362998962402344e+01 -3.1903699874877930e+01 2.0454200744628906e+01 -8.2735099792480469e+01 -1.3578999519348145e+01 -2.6668500900268555e+01 -3.2975799560546875e+01 3.8400099277496338e+00 2.8096899032592773e+01 -2.8934200286865234e+01 3.4957900047302246e+00 2.7763200759887695e+01 -1.2468999862670898e+01 3.9723598957061768e+00 5.8803100585937500e+00 -1.2484399795532227e+01 3.9099199771881104e+00 -9.0204601287841797e+00 -1.2484399795532227e+01 3.9099199771881104e+00 3.2910499572753906e+00 -1.2468999862670898e+01 3.9723799228668213e+00 3.0948998928070068e+00 -6.3811504364013672e+01 -3.5166500091552734e+01 -2.0719499588012695e+01 -6.3929901123046875e+01 -3.4440399169921875e+01 -2.1585100173950195e+01 -8.4447395324707031e+01 1.4850500106811523e+01 -1.3938599824905396e+00 -8.3164802551269531e+01 1.6422599792480469e+01 -3.3809599876403809e+00 -8.3263206481933594e+01 1.6331899642944336e+01 -1.2152299880981445e+01 -1.8656398773193359e+01 2.3088200092315674e+00 2.2057399749755859e+01 -1.8647300720214844e+01 3.4699399471282959e+00 2.1727500915527344e+01 -8.5497795104980469e+01 1.2562899589538574e+01 -2.8260599821805954e-02 -7.5841705322265625e+01 -2.3446901321411133e+01 -2.6201299667358398e+01 -7.6856498718261719e+01 -2.1396400451660156e+01 -2.6889600753784180e+01 1.2776300430297852e+01 8.2544794082641602e+00 -1.0229800224304199e+01 -8.0267700195312500e+01 -1.2764199256896973e+01 -2.8096899032592773e+01 1.3941699981689453e+01 8.6312093734741211e+00 -7.5555901527404785e+00 1.4910300254821777e+01 8.6305704116821289e+00 -3.7874600887298584e+00 8.0147495269775391e+00 -1.6214498519897461e+01 1.0230600357055664e+01 6.6464800834655762e+00 -1.7869501113891602e+01 -1.2357000112533569e+00 7.1461400985717773e+00 -1.7260000228881836e+01 -1.0229700088500977e+01 -2.5912401199340820e+01 -6.5912199020385742e+00 -2.5931301116943359e+01 -2.5644001007080078e+01 -2.4205899238586426e+00 -2.6451900482177734e+01 -2.3801099777221680e+01 -3.8622300624847412e+00 -2.5255300521850586e+01 -8.5145103454589844e+01 -5.5757799148559570e+00 2.5662200927734375e+01 -8.4460601806640625e+01 -8.7752904891967773e+00 5.3235797882080078e+00 -6.3375101089477539e+00 1.7565100193023682e+00 -1.3721400260925293e+01 -8.2074394226074219e+01 1.5267700195312500e+01 -2.7876098632812500e+01 -8.4486404418945312e+01 1.0800999641418457e+01 -2.7713001251220703e+01 -8.4867797851562500e+01 1.2569499969482422e+01 -2.7100799560546875e+01 -3.1758199691772461e+01 -2.0571800231933594e+01 2.4306600570678711e+01 -2.9592399597167969e+01 -2.7388601303100586e+01 2.1954000473022461e+01 -2.8733600616455078e+01 -1.9363800048828125e+01 2.4038000106811523e+01 -8.3058799743652344e+01 -1.3686300277709961e+01 -2.5666900634765625e+01 -8.5035003662109375e+01 -6.3558301925659180e+00 -2.5674098968505859e+01 -7.1587898254394531e+01 -3.3174499511718750e+01 -2.1690000534057617e+01 -6.8256202697753906e+01 -3.4979999542236328e+01 -2.1093599319458008e+01 -6.9966796875000000e+01 -3.4713600158691406e+01 -1.9631198883056641e+01 -5.3734598159790039e+00 -9.3850593566894531e+00 1.3516600608825684e+01 -4.5868897438049316e+00 -2.1889400482177734e+01 1.3294899940490723e+01 -9.3643701076507568e-01 1.2331299781799316e+00 1.3162500381469727e+01 -6.4110900878906250e+01 -3.3581001281738281e+01 2.2046899795532227e+01 -6.3890895843505859e+01 -3.4450099945068359e+01 2.1590299606323242e+01 -2.2416999816894531e+01 -2.5918298721313477e+01 2.0565500259399414e+01 -2.1139299392700195e+01 -2.0317699432373047e+01 2.1121301651000977e+01 -1.2585000038146973e+01 -2.6100500106811523e+01 1.4657299995422363e+01 -1.4178999900817871e+01 -2.6742898941040039e+01 1.3717199325561523e+01 -2.5169300079345703e+01 -3.6497998237609863e-01 2.6374399185180664e+01 -2.8175498962402344e+01 -1.5697500705718994e+00 2.7393899917602539e+01 -9.6048898696899414e+00 -2.5772399902343750e+01 1.2623800277709961e+01 -1.4514900207519531e+01 4.0288496017456055e+00 8.1216001510620117e+00 -3.2789901733398438e+01 -3.0060899734497070e+01 1.7758699417114258e+01 -2.2868999481201172e+01 5.2620897293090820e+00 -2.4482398986816406e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -1.1451100349426270e+01 -1.2468999862670898e+01 3.9723701477050781e+00 4.6423501968383789e+00 2.4698100090026855e+00 1.3937099456787109e+01 8.7694101333618164e+00 1.3559999465942383e+00 1.3735700607299805e+01 8.7694101333618164e+00 -7.2062995910644531e+01 -3.3286300659179688e+01 -2.0510700225830078e+01 -2.1232500076293945e+01 -2.6503099441528320e+01 1.9953899383544922e+01 -1.5564300537109375e+01 -2.5595899581909180e+01 1.7409900665283203e+01 -1.6401000976562500e+01 -2.4625801086425781e+01 1.8170499801635742e+01 -1.1733599662780762e+01 9.2020101547241211e+00 -3.9287097454071045e+00 -1.1928699493408203e+01 7.6515102386474609e+00 -8.7694005966186523e+00 -1.1136300086975098e+01 9.8672695159912109e+00 3.1021800041198730e+00 -1.1920199394226074e+01 8.9085302352905273e+00 8.3831701278686523e+00 -1.1295700073242188e+01 9.6952896118164062e+00 8.7694101333618164e+00 -8.8484201431274414e+00 1.0371999740600586e+01 1.0295099258422852e+01 -6.5542902946472168e+00 1.0829599380493164e+01 1.0302700042724609e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -6.5915398597717285e+00 -1.4179100036621094e+01 -2.6742898941040039e+01 -1.3717199325561523e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 -1.0730800628662109e+01 1.7999500274658203e+01 2.8110098838806152e+00 1.0229700088500977e+01 -5.0236697196960449e+00 2.6851301193237305e+00 1.2880999565124512e+01 -5.3248100280761719e+00 1.9142800569534302e+00 1.3434800148010254e+01 -3.2349998950958252e+00 -2.4259799957275391e+01 1.1439999580383301e+01 -3.9967998504638672e+01 -3.0895101547241211e+01 -2.0772499084472656e+01 -3.2330902099609375e+01 -2.9474100112915039e+01 -2.0962800979614258e+01 -1.2468999862670898e+01 3.9723799228668213e+00 5.1695203781127930e-01 -5.4393699645996094e+01 1.1380000114440918e+01 -2.8026699066162109e+01 -2.2231201171875000e+01 -1.2556499242782593e+00 2.4675800323486328e+01 -8.9134998321533203e+00 1.0206200599670410e+01 1.1205100059509277e+01 -1.6373800277709961e+01 -2.4622798919677734e+01 -1.8157501220703125e+01 -2.0687799453735352e+01 5.2614102363586426e+00 -2.1774700164794922e+01 1.5323800086975098e+01 4.1637501716613770e+00 1.3162500381469727e+01 1.5431400299072266e+01 4.6149396896362305e+00 1.3162500381469727e+01 1.4017400741577148e+01 5.5252099037170410e+00 1.3162500381469727e+01 -1.7720899581909180e+01 -1.3928599357604980e+01 -2.0123699188232422e+01 -1.3107599258422852e+01 -2.3883600234985352e+01 -1.6286199569702148e+01 -3.1628799438476562e+01 8.4871101379394531e+00 1.9451400756835938e+01 -8.5964797973632812e+01 1.1868500709533691e+00 2.5676300048828125e+01 -8.5881393432617188e+01 6.9067101478576660e+00 2.6386400222778320e+01 -8.6083892822265625e+01 5.1130099296569824e+00 2.5666900634765625e+01 -8.0267700195312500e+01 -1.2764199256896973e+01 2.8096899032592773e+01 -7.9344696044921875e+01 -1.5972599029541016e+01 2.7999799728393555e+01 -6.8686302185058594e+01 -1.3177599906921387e+01 2.8035299301147461e+01 -3.4678499698638916e+00 -2.4546600341796875e+01 -1.0226399421691895e+01 -6.8465900421142578e+00 -2.5434799194335938e+01 -1.0693900108337402e+01 5.3050603866577148e+00 1.0234899520874023e+01 -1.2282799720764160e+01 5.4755702018737793e+00 1.0288099288940430e+01 -1.1643799781799316e+01 -2.3418100357055664e+01 3.4390799999237061e+00 -2.5626100540161133e+01 -2.3448501586914062e+01 3.2784798145294189e+00 -2.5642599105834961e+01 -8.2882400512695312e+01 1.0574700355529785e+01 -2.8096899032592773e+01 -3.2887599945068359e+01 5.3357300758361816e+00 2.8096899032592773e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -7.9923099279403687e-01 -1.2487700462341309e+01 3.8984899520874023e+00 -3.2551601529121399e-01 -8.2080101013183594e+01 1.7292600631713867e+01 -2.5666900634765625e+01 -8.0811302185058594e+01 1.8070999145507812e+01 -2.5639598846435547e+01 -8.1527099609375000e+01 1.7308099746704102e+01 -2.6616500854492188e+01 -8.3500305175781250e+01 1.2953100204467773e+01 2.7934499740600586e+01 -8.4759696960449219e+01 1.0734800338745117e+01 2.7460899353027344e+01 -4.1574902534484863e+00 1.0894499778747559e+01 -1.1716500282287598e+01 -8.5376605987548828e+00 1.0257399559020996e+01 -1.1212699890136719e+01 -5.0540599822998047e+00 1.1139400482177734e+01 -1.0868499755859375e+01 -6.4351997375488281e+01 -1.2023900032043457e+01 -2.8055299758911133e+01 -6.6457595825195312e+01 -3.5751899719238281e+01 1.9767801284790039e+01 -6.5414596557617188e+01 -1.6021900177001953e+01 -2.7626399993896484e+01 -7.7686401367187500e+01 1.8971700668334961e+01 -2.5795400619506836e+01 -7.7796401977539062e+01 1.8792200088500977e+01 -2.6459199905395508e+01 -7.9663406372070312e+01 -2.1549299240112305e+01 2.5176801681518555e+01 -7.7815803527832031e+01 -2.4162700653076172e+01 2.5170400619506836e+01 -8.0238800048828125e+01 -2.0285900115966797e+01 2.5552999496459961e+01 -8.0270500183105469e+01 -2.0207399368286133e+01 -2.2489600181579590e+00 4.8787798881530762e+00 1.0104199409484863e+01 1.2581200599670410e+01 5.1955399513244629e+00 1.0201799392700195e+01 1.2359499931335449e+01 -1.7269599914550781e+01 2.7614200115203857e+00 -2.0761899948120117e+01 -1.8656398773193359e+01 2.3088200092315674e+00 -2.2057399749755859e+01 -1.8927799224853516e+01 4.4864702224731445e+00 -2.1103000640869141e+01 -1.1295700073242188e+01 9.6952896118164062e+00 -8.7694101333618164e+00 3.4292600154876709e+00 1.3637700080871582e+01 8.3823099136352539e+00 3.2828400135040283e+00 1.3691499710083008e+01 4.4710597991943359e+00 -1.0954899787902832e+01 9.9566106796264648e+00 -4.3614101409912109e+00 9.4770300388336182e-01 -2.2524200439453125e+01 1.0229899406433105e+01 1.3160300254821777e+00 1.3715700149536133e+01 9.1459999084472656e+00 -3.4076000213623047e+01 -3.0211999893188477e+01 1.9965900421142578e+01 -3.2286403656005859e+01 -2.9720199584960938e+01 2.0481201171875000e+01 -3.7879798889160156e+01 -3.0309301376342773e+01 2.1135299682617188e+01 -2.6406499862670898e+01 7.8242998123168945e+00 -1.9237300872802734e+01 -1.4515699386596680e+01 4.0267701148986816e+00 -1.1472999572753906e+01 -1.9121200561523438e+01 5.1631298065185547e+00 1.6200000762939453e+01 -1.8723299026489258e+01 4.9519901275634766e+00 1.6200000762939453e+01 -1.3659000396728516e+01 3.7333600521087646e+00 1.0100999832153320e+01 -1.3369699478149414e+01 3.6811499595642090e+00 1.5818199157714844e+01 -7.2312301635742188e+01 -3.3093002319335938e+01 -1.3019000053405762e+01 -1.8680601119995117e+01 4.9415903091430664e+00 1.6200000762939453e+01 -3.0809600830078125e+01 1.3216799736022949e+01 -1.6199798583984375e+01 -1.2468999862670898e+01 3.9723799228668213e+00 6.8087697029113770e+00 -1.2484399795532227e+01 3.9099199771881104e+00 7.2823896408081055e+00 -1.2484399795532227e+01 3.9099199771881104e+00 7.7019901275634766e+00 -3.1619102478027344e+01 9.1428298950195312e+00 -1.9237499237060547e+01 -2.8657798767089844e+01 7.6556901931762695e+00 -1.9496599197387695e+01 -7.9056901931762695e+00 6.1648502349853516e+00 -1.2403100013732910e+01 -8.1184898376464844e+01 -1.8335500717163086e+01 2.5733100891113281e+01 -1.2484200477600098e+01 3.9098398685455322e+00 -1.0575200080871582e+01 -1.0217400550842285e+01 1.0161899566650391e+01 9.1455993652343750e+00 -1.1837100028991699e+01 9.0069694519042969e+00 9.6961002349853516e+00 -1.0723400115966797e+01 9.2629899978637695e+00 1.1413799285888672e+01 -3.0947000503540039e+01 -6.8715701103210449e+00 2.7576299667358398e+01 1.4017400741577148e+01 5.5252299308776855e+00 -1.3162500381469727e+01 1.5323800086975098e+01 4.1637501716613770e+00 -1.3162500381469727e+01 3.5189900398254395e+00 1.2387099266052246e+01 1.0975000381469727e+01 2.7276201248168945e+00 1.2909700393676758e+01 1.1376399993896484e+01 2.0134000778198242e+00 1.1841899871826172e+01 1.2109000205993652e+01 -9.9629602432250977e+00 3.9463801383972168e+00 1.2822000503540039e+01 -5.1284399032592773e+00 3.3915398120880127e+00 1.2656300544738770e+01 -8.4990898132324219e+01 -4.6578397750854492e+00 2.6591299057006836e+01 -8.3480400085449219e+01 -8.3210201263427734e+00 2.7478899002075195e+01 -7.9436500549316406e+01 1.7295799255371094e+01 -2.7633199691772461e+01 1.4097799301147461e+01 8.5582199096679688e+00 1.0974300384521484e+01 1.4471399307250977e+01 8.6752099990844727e+00 9.8253202438354492e+00 1.2776300430297852e+01 8.2544794082641602e+00 1.0229800224304199e+01 5.4755702018737793e+00 1.0288099288940430e+01 1.1643799781799316e+01 3.9121499061584473e+00 9.8083105087280273e+00 1.1604000091552734e+01 -3.2194900512695312e+01 8.1703805923461914e+00 2.5740800857543945e+01 -2.8270698547363281e+01 7.1634702682495117e+00 2.5726100921630859e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.9889199733734131e+00 -1.2468999862670898e+01 3.9723799228668213e+00 -3.0948998928070068e+00 7.8375797271728516e+00 6.3176698684692383e+00 -1.0229800224304199e+01 -3.2373802185058594e+01 7.4179096221923828e+00 -2.7315099716186523e+01 -6.8786296844482422e+00 -2.2554998397827148e+01 1.3689200401306152e+01 -1.0217400550842285e+01 1.0161899566650391e+01 -9.1456098556518555e+00 -1.0972799301147461e+01 9.8318595886230469e+00 -1.0179499626159668e+01 -2.7397800445556641e+01 4.1198697090148926e+00 -2.7423400878906250e+01 -7.5310699462890625e+01 -2.9075099945068359e+01 -2.2331199645996094e+01 -7.6789695739746094e+01 -2.6851900100708008e+01 -2.3179199218750000e+01 7.0728302001953125e+00 6.1602401733398438e+00 -1.1267999649047852e+01 -3.8524200439453125e+01 6.7241401672363281e+00 -2.8097499847412109e+01 -4.0985801696777344e+01 8.4421596527099609e+00 -2.7926500320434570e+01 -8.5338500976562500e+01 -4.3485999107360840e-01 2.6955900192260742e+01 -7.4673599243164062e+01 -2.5458698272705078e+01 -2.5446899414062500e+01 -2.1543800354003906e+01 5.6311798095703125e+00 2.1169200897216797e+01 -1.2469099998474121e+01 3.9723901748657227e+00 7.7372398376464844e+00 -1.2491400718688965e+01 3.8886401653289795e+00 8.3463201522827148e+00 -2.4159500122070312e+01 6.2754898071289062e+00 2.2972999572753906e+01 -3.1634099960327148e+01 8.1166400909423828e+00 2.0250000000000000e+01 -2.1872001647949219e+01 3.6640801429748535e+00 -2.4625801086425781e+01 -1.8115199804306030e+00 1.2297200202941895e+01 1.1544100046157837e+00 -1.2392800331115723e+01 4.2737202644348145e+00 -1.2936100006103516e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.4174999237060547e+01 6.1715998649597168e+00 8.0292997360229492e+00 1.1643799781799316e+01 -4.6267498016357422e+01 1.1364599227905273e+01 -2.6522500991821289e+01 -2.0308200836181641e+01 5.3378500938415527e+00 -1.6200000762939453e+01 1.6434799194335938e+01 8.0008001327514648e+00 1.1106800079345703e+01 -2.9465299606323242e+01 1.3595799446105957e+01 1.6200000762939453e+01 4.7463798522949219e+00 1.0064300537109375e+01 -1.0486200332641602e+01 4.9977498054504395e+00 1.0140899658203125e+01 -8.8615293502807617e+00 -1.2484399795532227e+01 3.9099199771881104e+00 1.0824300765991211e+01 -7.3093101501464844e+01 -3.1947500228881836e+01 -2.1611099243164062e+01 -1.3649499893188477e+01 -2.0166198730468750e+01 -1.6796400070190430e+01 -1.4594299316406250e+01 -1.1992500305175781e+01 -1.7900100708007812e+01 -2.0471099853515625e+01 5.3669600486755371e+00 2.0250000000000000e+01 -8.1364402770996094e+01 -1.3131000518798828e+01 -2.7924800872802734e+01 -8.4118301391601562e+01 -2.4903000891208649e-01 -2.7910200119018555e+01 -1.8723299026489258e+01 4.9519901275634766e+00 -1.6200000762939453e+01 -1.9121099472045898e+01 5.1630897521972656e+00 -1.6200000762939453e+01 -2.2204599380493164e+00 -2.4079299926757812e+01 1.0228199958801270e+01 -9.5017600059509277e-01 -2.3519701004028320e+01 -1.0229700088500977e+01 -9.5017600059509277e-01 -2.3519701004028320e+01 1.0229800224304199e+01 -2.2204599380493164e+00 -2.4079299926757812e+01 -1.0228199958801270e+01 -1.8619499206542969e+01 -1.0543999671936035e+00 2.1860898971557617e+01 -1.6382200241088867e+01 -1.3128899574279785e+01 1.9254699707031250e+01 7.8754200935363770e+00 6.1899800300598145e+00 -1.0834399223327637e+01 -1.1968599319458008e+01 4.9128999710083008e+00 -1.2656300544738770e+01 -8.1316902160644531e+01 1.7834100723266602e+01 5.7058101892471313e-01 -8.1432899475097656e+01 1.7731700897216797e+01 -9.8030796051025391e+00 -7.9688804626464844e+01 1.8525798797607422e+01 -1.2558599472045898e+01 -8.3561798095703125e+01 1.6003499984741211e+01 1.7607400894165039e+01 -8.2080101013183594e+01 1.7292600631713867e+01 2.5666900634765625e+01 -7.4880401611328125e+01 1.8242099761962891e+01 -2.6841800689697266e+01 -7.7240798950195312e+01 1.7425498962402344e+01 -2.7850198745727539e+01 -8.3054100036621094e+01 -1.3700300216674805e+01 2.5666900634765625e+01 6.5172100067138672e+00 5.2400598526000977e+00 1.2515299797058105e+01 1.3856300354003906e+01 8.6082496643066406e+00 5.6883196830749512e+00 -7.4771903991699219e+01 1.8679899215698242e+01 9.7939796447753906e+00 -7.5627700805664062e+01 1.8856300354003906e+01 6.6064101457595825e-01 -1.8680601119995117e+01 4.9415903091430664e+00 1.5576899528503418e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.2886400222778320e+00 -7.0791000366210938e+01 -3.4229801177978516e+01 -1.2186399459838867e+01 -6.9940795898437500e+01 -3.4720802307128906e+01 3.3461299538612366e-01 -7.2171600341796875e+01 -3.3224800109863281e+01 -1.0406699180603027e+00 -6.4094703674316406e+01 -3.3578197479248047e+01 2.2046899795532227e+01 -1.2100500106811523e+01 9.9917197227478027e-01 -1.6574199676513672e+01 4.2148599624633789e+00 -2.0214399337768555e+01 -4.3156399726867676e+00 -7.4685699462890625e+01 1.6565099716186523e+01 -2.7998899459838867e+01 7.3976602554321289e+00 3.0381901264190674e+00 -1.3162399291992188e+01 9.2621002197265625e+00 -1.4340699195861816e+01 -1.0230099678039551e+01 8.2847900390625000e+00 -1.5479100227355957e+01 -1.1488699913024902e+01 1.9050099849700928e+00 -1.9417699813842773e+01 1.3059399604797363e+01 -1.7540600299835205e+00 -2.1827699661254883e+01 1.2974999427795410e+01 -1.2468999862670898e+01 3.9723701477050781e+00 1.1451100349426270e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.2562399864196777e+01 -6.7094001770019531e+01 -3.5633499145507812e+01 -1.9204199314117432e+00 -6.9141998291015625e+01 -3.5073398590087891e+01 -1.0676899909973145e+01 -5.8862102508544922e+01 1.4758200645446777e+01 2.5771200180053711e+01 -6.6752700805664062e+01 1.6404199600219727e+01 2.6540199279785156e+01 -5.7855300903320312e+01 1.4107700347900391e+01 2.6716400146484375e+01 1.8461599349975586e+01 4.4659600257873535e+00 -4.0511398315429688e+00 -6.7801803588867188e+01 -2.2013500213623047e+01 2.6201400756835938e+01 -7.4673599243164062e+01 -2.5458698272705078e+01 2.5446899414062500e+01 3.1772801876068115e+00 -1.6965400695800781e+01 -1.3166399955749512e+01 -7.9464698791503906e+01 1.6842800140380859e+01 2.7888599395751953e+01 -8.0379997253417969e+01 1.4894800186157227e+01 2.8096899032592773e+01 -6.6855001449584961e+00 -2.3976100921630859e+01 1.3298200607299805e+01 -7.5794796943664551e+00 -2.2704200744628906e+01 1.3865099906921387e+01 -1.1248499870300293e+01 5.1348104476928711e+00 8.8615293502807617e+00 1.7053899765014648e+01 4.5799903869628906e+00 -1.2750299453735352e+01 -9.6793699264526367e+00 7.8165602684020996e-01 -1.5179299354553223e+01 -9.2741994857788086e+00 2.1737599372863770e+00 -1.4671999931335449e+01 1.6998899459838867e+01 6.2526502609252930e+00 1.2577199935913086e+01 1.5033500671386719e+01 6.3609900474548340e+00 1.3092599868774414e+01 1.7478500366210938e+01 5.1903200149536133e+00 1.2537400245666504e+01 -1.1825799942016602e+01 2.5406200885772705e+00 -1.5898799896240234e+01 -7.7610099792480469e+01 -2.2007999420166016e+01 -2.6670200347900391e+01 -7.7864997863769531e+01 -2.4162899017333984e+01 -2.5080999374389648e+01 -1.8674098968505859e+01 2.1953301429748535e+00 2.2069599151611328e+01 -2.0307800292968750e+01 -1.5372200012207031e+01 -2.1515800476074219e+01 -2.0569900512695312e+01 6.4211702346801758e+00 1.9237499237060547e+01 1.0173600196838379e+01 -1.2668499946594238e+01 1.0229700088500977e+01 -8.5624000549316406e+01 1.2087100028991699e+01 1.9766099929809570e+01 1.8035499572753906e+01 6.2667803764343262e+00 1.1057900428771973e+01 -1.8145300149917603e+00 -2.1698999404907227e+01 -1.3026299476623535e+01 9.1821396350860596e-01 -2.1643299102783203e+01 -1.2238900184631348e+01 -1.0127799987792969e+01 3.3894300460815430e+00 -1.3818900108337402e+01 -1.0800699234008789e+01 5.2727899551391602e+00 1.0632800102233887e+01 -1.1968599319458008e+01 4.9128999710083008e+00 1.2656300544738770e+01 -3.5346199035644531e+01 -7.1104402542114258e+00 2.8034200668334961e+01 -4.5793701171875000e+01 -3.2309902191162109e+01 -1.9889099121093750e+01 -2.1853099822998047e+01 5.7073702812194824e+00 2.0932600021362305e+01 -7.4651397705078125e+01 -2.7210699081420898e+01 -2.4724800109863281e+01 -7.5132499694824219e+01 -2.8274499893188477e+01 -2.3792798995971680e+01 -1.2259400367736816e+01 4.8232898712158203e+00 1.2660400390625000e+01 -9.0257501602172852e+00 7.4893897771835327e-01 1.4873800277709961e+01 -3.4678499698638916e+00 -2.4546600341796875e+01 1.0226300239562988e+01 -2.1972099304199219e+01 -2.8044799804687500e+01 -1.8302000045776367e+01 1.2765799522399902e+01 4.9755697250366211e+00 1.3162500381469727e+01 9.8834295272827148e+00 -6.5972900390625000e+00 1.3162599563598633e+01 -3.2600399017333984e+01 -2.7963298797607422e+01 -2.2046899795532227e+01 5.3409199714660645e+00 3.1408400535583496e+00 1.3085200309753418e+01 -2.1136699676513672e+01 5.5309100151062012e+00 -2.0822700500488281e+01 -1.1248499870300293e+01 5.1348104476928711e+00 -8.8615293502807617e+00 3.5155498981475830e+00 1.3290500640869141e+01 -1.0145500183105469e+01 4.1435799598693848e+00 1.2604000091552734e+01 -8.7694005966186523e+00 -1.2528200149536133e+01 3.8404700756072998e+00 -1.0844699144363403e+00 -3.2696197509765625e+01 -9.6085901260375977e+00 2.7570400238037109e+01 -9.0257501602172852e+00 7.4893897771835327e-01 -1.4873800277709961e+01 -8.8467397689819336e+00 9.2061595916748047e+00 1.2156000137329102e+01 -6.4980903625488281e+01 -3.5738899230957031e+01 -4.7488999366760254e+00 -2.0951200485229492e+01 6.7523698806762695e+00 1.7952001571655273e+01 -1.2468999862670898e+01 3.9723701477050781e+00 -4.6423501968383789e+00 -2.3418199539184570e+01 3.4390799999237061e+00 2.5625900268554688e+01 -2.5539800643920898e+01 5.7666797637939453e+00 2.5933300018310547e+01 -1.2484399795532227e+01 3.9099199771881104e+00 1.1211000442504883e+01 1.8064201354980469e+01 3.8077600002288818e+00 1.1699000358581543e+01 -1.7263299942016602e+01 2.5184898376464844e+00 2.0802299499511719e+01 -1.2420499801635742e+01 4.1591300964355469e+00 -4.3063297271728516e+00 -2.0569900512695312e+01 6.4211797714233398e+00 -1.9237499237060547e+01 -2.0274599075317383e+01 6.1647500991821289e+00 -1.9253698348999023e+01 -3.1579498291015625e+01 1.1716900825500488e+01 1.9237499237060547e+01 -3.1538299560546875e+01 1.2062000274658203e+01 1.7867500305175781e+01 5.4755702018737793e+00 1.0288099288940430e+01 1.4281799793243408e+00 -8.2882400512695312e+01 1.0574700355529785e+01 2.8096899032592773e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -2.0250000000000000e+01 -3.3957599639892578e+01 -2.2076699733734131e+00 2.8097000122070312e+01 -7.1406898498535156e+01 -3.3811698913574219e+01 1.0665699958801270e+01 -7.2553596496582031e+01 -3.2843196868896484e+01 1.1039799690246582e+01 -8.4824501037597656e+01 1.4209400177001953e+01 1.7676399230957031e+01 -3.1318798065185547e+01 -2.0398700714111328e+01 -2.4274200439453125e+01 -2.6977600097656250e+01 -1.8610399246215820e+01 -2.3734500885009766e+01 -2.7629499435424805e+01 -2.6979400634765625e+01 -2.1713800430297852e+01 -7.5557098388671875e+01 -2.8117698669433594e+01 2.3519599914550781e+01 -8.3045700073242188e+01 8.4699592590332031e+00 2.8096899032592773e+01 -1.2279800176620483e+00 -2.2933200836181641e+01 -1.2090600013732910e+01 -4.3032598495483398e+00 1.1460499763488770e+01 -1.0306200027465820e+01 -4.2065896987915039e+00 1.1490400314331055e+01 -1.0306200027465820e+01 -3.5070602416992188e+01 -2.1786800384521484e+01 2.4295400619506836e+01 -3.2600399017333984e+01 -2.7963100433349609e+01 2.2046899795532227e+01 -3.0197000503540039e+01 6.8118801116943359e+00 2.7204399108886719e+01 -2.0253499984741211e+01 5.3109297752380371e+00 2.0218898773193359e+01 -3.2878101348876953e+01 -9.3289098739624023e+00 -2.7645900726318359e+01 -8.5834098815917969e+01 7.2901301383972168e+00 -2.6437700271606445e+01 -8.6083892822265625e+01 5.1130099296569824e+00 -2.5666900634765625e+01 -8.6002799987792969e+01 8.5538406372070312e+00 -2.5668899536132812e+01 -4.3032598495483398e+00 1.1460499763488770e+01 1.0306200027465820e+01 -3.7239401340484619e+00 1.1649600028991699e+01 1.0305799484252930e+01 -3.6514399051666260e+00 1.1667500495910645e+01 1.0304599761962891e+01 -3.2975799560546875e+01 3.8400099277496338e+00 -2.8096899032592773e+01 -3.2887599945068359e+01 5.3357300758361816e+00 -2.8096899032592773e+01 -2.4160200119018555e+01 6.2756600379943848e+00 -1.6200000762939453e+01 -3.7348401546478271e+00 9.6158704757690430e+00 -1.2329899787902832e+01 -3.4674800872802734e+01 -1.4640600204467773e+01 2.6576499938964844e+01 -2.5977300643920898e+01 7.0095701217651367e+00 1.9470499038696289e+01 -3.1917098999023438e+01 -2.6032500267028809e+00 2.8021100997924805e+01 -4.0303600311279297e+01 -2.9336700439453125e+01 2.2047401428222656e+01 -5.2587200164794922e+01 -3.1526498794555664e+01 2.2046899795532227e+01 -1.2900600433349609e+01 3.6866500377655029e+00 1.4267199516296387e+01 -3.7007598876953125e+01 -1.6523199081420898e+01 2.6201299667358398e+01 -8.0504699707031250e+01 1.7846899032592773e+01 2.6673799514770508e+01 6.5892200469970703e+00 6.6740202903747559e+00 1.1643799781799316e+01 1.3160300254821777e+00 1.3715700149536133e+01 -9.1459999084472656e+00 5.4230195283889771e-01 1.3339400291442871e+01 1.0186499595642090e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -2.6891999244689941e+00 -1.8805799484252930e+01 4.9762101173400879e+00 -1.6808599472045898e+01 -1.8677999496459961e+01 4.9410200119018555e+00 -1.8645801544189453e+01 4.1435799598693848e+00 1.2604000091552734e+01 5.3573400056461384e-13 4.9977498054504395e+00 1.0140899658203125e+01 -3.7186799049377441e+00 4.9977498054504395e+00 1.0140899658203125e+01 8.8615293502807617e+00 4.1435799598693848e+00 1.2604000091552734e+01 8.7694005966186523e+00 -8.0861595153808594e+01 1.4468800544738770e+01 -2.8099199295043945e+01 -1.8680601119995117e+01 4.9415903091430664e+00 -1.5576899528503418e+01 1.8025800704956055e+01 2.8638198375701904e+00 1.8640899658203125e+00 -8.5711204528808594e+01 -1.5585000514984131e+00 2.5666900634765625e+01 -3.8664299011230469e+01 9.7858705520629883e+00 2.5666900634765625e+01 -4.5768001556396484e+01 1.1208900451660156e+01 2.6579498291015625e+01 -7.2385307312011719e+01 -3.1241298675537109e+01 2.3072099685668945e+01 2.7172601222991943e+00 -2.1455699920654297e+01 -9.9170894622802734e+00 -6.4094703674316406e+01 -3.3578197479248047e+01 -2.2046899795532227e+01 -1.0621700286865234e+01 9.1452493667602539e+00 -1.1563099861145020e+01 -2.3368301391601562e+01 5.4110898971557617e+00 2.4809200286865234e+01 -7.0307302474975586e+00 -2.5468399047851562e+01 7.1406497955322266e+00 -8.2216102600097656e+01 -1.6069200515747070e+01 -5.7170400619506836e+00 -1.2499199867248535e+01 3.8734200000762939e+00 -9.4482898712158203e+00 -1.2490699768066406e+01 3.8924100399017334e+00 3.3666701316833496e+00 -8.3060401916503906e+01 -1.3686800003051758e+01 -1.6274000167846680e+01 -8.3054100036621094e+01 -1.3700300216674805e+01 -2.5666900634765625e+01 -8.3058799743652344e+01 -1.3686300277709961e+01 2.5666900634765625e+01 -7.6187500000000000e+01 1.8943000793457031e+01 -1.8149898529052734e+01 -8.6044700622558594e+01 2.5542399883270264e+00 -3.6043100357055664e+00 -8.5937301635742188e+01 8.1713896989822388e-01 -2.5695800781250000e+01 -7.8908195495605469e+01 1.8738399505615234e+01 2.7807998657226562e-01 -7.7226402282714844e+01 1.8952301025390625e+01 -1.0827600479125977e+01 -8.6039001464843750e+01 7.8893499374389648e+00 6.7517399787902832e-01 -8.5695495605468750e+01 -1.7946900129318237e+00 9.9244898557662964e-01 -8.2707893371582031e+01 1.6874198913574219e+01 8.4668798446655273e+00 -8.4415199279785156e+01 1.4895499229431152e+01 -1.7561300277709961e+01 -7.8498001098632812e+01 1.8810798645019531e+01 -1.8372900009155273e+01 -8.5170501708984375e+01 -5.4223003387451172e+00 -1.0836700439453125e+01 -3.9489898681640625e+01 -3.1162698745727539e+01 2.0016599655151367e+01 6.9650502204895020e+00 6.2961602210998535e+00 -1.4111299514770508e+00 1.2963500022888184e+01 7.8590903282165527e+00 -1.1816699981689453e+01 -8.2167495727539062e+01 -1.6196201324462891e+01 1.3814499855041504e+01 7.2005200386047363e+00 6.2607698440551758e+00 5.2534098625183105e+00 7.7394099235534668e+00 6.2859597206115723e+00 7.0418801307678223e+00 -1.1928699493408203e+01 7.6515102386474609e+00 8.7694005966186523e+00 1.6019899845123291e+00 -2.2163599014282227e+01 -4.3230800628662109e+00 -7.0307302474975586e+00 -2.5468399047851562e+01 1.0015199661254883e+01 -3.4272903442382812e+01 -1.2446599960327148e+01 -2.7127899169921875e+01 -1.2484399795532227e+01 3.9099199771881104e+00 -1.1597700119018555e+01 -7.6556900024414062e+01 1.5989600181579590e+01 2.8096899032592773e+01 7.4979400634765625e+00 -1.1315800666809082e+01 1.3162500381469727e+01 1.7743200063705444e+00 1.6654300689697266e+00 1.3162500381469727e+01 -5.6050800323486328e+01 -3.2143898010253906e+01 2.2046501159667969e+01 -1.2468999862670898e+01 3.9723799228668213e+00 -5.5708198547363281e+00 3.6702899932861328e+00 1.3299300193786621e+01 9.6205396652221680e+00 -4.3236499786376953e+01 9.9578104019165039e+00 -2.7337198257446289e+01 -5.2473796844482422e+01 1.2130700111389160e+01 2.7420099258422852e+01 -6.3763603210449219e+01 -3.5443500518798828e+01 2.0199199676513672e+01 -6.6889602661132812e+01 -3.5169300079345703e+01 2.1070100784301758e+01 -1.0937100410461426e+01 -2.3413600921630859e+01 -1.5065499305725098e+01 1.8118101119995117e+01 6.0945100784301758e+00 -1.0972000122070312e+01 -8.4443199157714844e+01 1.4854499816894531e+01 9.4425296783447266e+00 -5.7554101943969727e+00 1.1038000106811523e+01 -1.0308400154113770e+01 -2.9934400558471680e+01 1.1625800132751465e+01 1.9237499237060547e+01 3.7036798000335693e+00 1.3349900245666504e+01 -8.5235795974731445e+00 1.2869499206542969e+01 8.2948493957519531e+00 1.4541900157928467e+00 1.3971300125122070e+01 8.6322698593139648e+00 -9.0816795825958252e-01 1.8016201019287109e+01 6.4611701965332031e+00 5.0233302116394043e+00 1.8278699874877930e+01 5.8155899047851562e+00 -3.9653798937797546e-01 -8.5030097961425781e+01 6.9620103836059570e+00 -2.7464399337768555e+01 1.9063199758529663e+00 1.2481399536132812e+01 -1.2013400077819824e+01 -9.8575506210327148e+00 8.1238298416137695e+00 -1.2062000274658203e+01 -2.2471500396728516e+01 5.6958599090576172e+00 2.3190601348876953e+01 -2.0458801269531250e+01 -1.5454299926757812e+01 2.1590900421142578e+01 -8.5711204528808594e+01 -1.5585000514984131e+00 -2.5666900634765625e+01 -7.8688301086425781e+01 -1.7159898757934570e+01 -2.7824800491333008e+01 -3.0506299972534180e+01 -2.7548599243164062e+01 -2.1996099472045898e+01 -1.8680601119995117e+01 4.9415903091430664e+00 -1.6200000762939453e+01 1.8381200790405273e+01 3.7917900085449219e+00 -7.5998598337173462e-01 -7.4819496154785156e+01 -2.7081100463867188e+01 2.4762300491333008e+01 -2.9883800506591797e+01 3.6574599742889404e+00 -2.7899700164794922e+01 -2.5053699493408203e+01 6.9892301559448242e+00 -1.9359899520874023e+01 2.0604398250579834e+00 1.3875300407409668e+01 1.0187500000000000e+01 -6.8339897155761719e+01 -3.5352901458740234e+01 7.4738702774047852e+00 -7.0307302474975586e+00 -2.5468399047851562e+01 4.2167601585388184e+00 -1.8669198989868164e+01 -1.4469600677490234e+01 2.0667400360107422e+01 -1.3715800285339355e+01 -2.6531400680541992e+01 -1.4534399986267090e+01 1.4554799079895020e+01 7.8870701789855957e+00 1.2254600524902344e+01 -2.5937799453735352e+01 3.4249598979949951e+00 -2.6824901580810547e+01 -1.1792400360107422e+01 1.8972599506378174e+00 1.6251201629638672e+01 -1.1929100036621094e+01 8.4870595932006836e+00 -9.6228895187377930e+00 3.8926100730895996e+00 1.3110199928283691e+01 -4.5864601135253906e+00 -1.2007099151611328e+01 8.2018299102783203e+00 4.3791403770446777e+00 1.5308300018310547e+01 5.0949902534484863e+00 1.3162500381469727e+01 -8.2356803894042969e+01 1.6340200424194336e+01 2.7129499435424805e+01 -9.6793699264526367e+00 7.8165602684020996e-01 1.5179299354553223e+01 -3.2233699798583984e+01 8.0123805999755859e+00 2.6198598861694336e+01 -1.2804200172424316e+01 -2.5236200332641602e+01 -1.5723800659179688e+01 -7.6621002197265625e+01 -2.3808599472045898e+01 2.6010200500488281e+01 -8.5190994262695312e+01 1.3430399894714355e+01 -9.0667800903320312e+00 -7.6371398925781250e+01 1.8959999084472656e+01 1.2674399375915527e+01 -7.7428604125976562e+01 1.8959300994873047e+01 3.9070899486541748e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6000 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -7.5310699641704559e+01 -2.9075099155306816e+01 2.2331200540065765e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector -6.5423101186752319e+01 -3.5773199051618576e+01 1.8596099689602852e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01) (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01) (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector -4.0303599089384079e+01 -2.9336700215935707e+01 2.2047400474548340e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0235599474981427e+00 -2.2340299561619759e+01 1.1137999594211578e+01) (float-vector -2.2416999563574791e+01 -2.5918299332261086e+01 2.0565500482916832e+01) (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector 9.9552599713206291e+00 -1.2558500282466412e+01 1.1385199613869190e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01) (float-vector 2.4698099587112665e+00 1.3937099836766720e+01 -8.7694097310304642e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector -3.2696198672056198e+01 -9.6085900440812111e+00 2.7570400387048721e+01) (float-vector -7.9344697296619415e+01 -1.5972599387168884e+01 2.7999799698591232e+01) (float-vector -8.5145100951194763e+01 -5.5757798254489899e+00 2.5662200525403023e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0604399032890797e+00 1.3875300064682961e+01 1.0187500156462193e+01) (float-vector 1.6372600570321083e+01 8.1343604251742363e+00 1.0082700289785862e+01) (float-vector 1.5431400388479233e+01 4.6149399131536484e+00 1.3162500225007534e+01) (float-vector -3.2659899443387985e+01 6.2573798932135105e+00 2.7959700673818588e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01) (float-vector -7.4860200285911560e+01 1.8286399543285370e+01 2.6814900338649750e+01) (float-vector -8.5344798862934113e+01 1.3159300200641155e+01 2.5675499811768532e+01) (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5030399262905121e+01 1.3849199749529362e+01 -2.5683199986815453e+01) (float-vector -8.3054102957248688e+01 -1.3700299896299839e+01 -2.5666899979114532e+01) (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01) (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector -7.7796399593353271e+01 1.8792200833559036e+01 -2.6459200307726860e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8688301146030426e+01 -1.7159899696707726e+01 -2.7824800461530685e+01) (float-vector -7.1587897837162018e+01 -3.3174499869346619e+01 -2.1689999848604202e+01) (float-vector -6.3738003373146057e+01 -3.5578601062297821e+01 -1.9171899184584618e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2847904413938522e+00 -1.5479099936783314e+01 -1.1488700285553932e+01) (float-vector 1.8429599702358246e+01 4.6149399131536484e+00 -1.0229799896478653e+01) (float-vector 1.4841400086879730e+01 6.6712498664855957e+00 -1.3026099652051926e+01) (float-vector -2.9883800074458122e+01 3.6574599798768759e+00 -2.7899699285626411e+01) (float-vector -3.2878100872039795e+01 -9.3289101496338844e+00 -2.7645900845527649e+01) (float-vector -3.0364299193024635e+01 -2.8519000858068466e+01 -2.1515799686312675e+01) (float-vector -3.6160200834274292e+00 -2.4537000805139542e+01 -1.1019499972462654e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_r_finger_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_r_finger_tip_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 9.1370000000000005e+01 -4.9500000000000002e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 5 8 0 2 5 8 26 0 0 28 1 26 28 0 2 3 4 2 1 3 2 4 5 3 1 7 3 19 4 19 3 7 4 19 5 18 19 20 19 21 20 19 7 21 5 19 24 24 19 18 18 30 24 31 30 18 20 31 18 20 36 31 20 37 36 21 37 20 7 22 21 21 61 37 22 61 21 38 37 39 37 38 36 37 60 39 37 61 60 22 62 61 62 268 61 268 271 61 61 271 60 23 22 7 23 62 22 23 268 62 6 23 7 63 23 6 63 267 23 267 268 23 6 7 1 1 28 6 6 28 63 57 28 58 27 58 28 27 28 26 63 28 57 55 57 56 57 58 56 55 63 57 56 58 50 49 50 58 49 58 27 55 56 54 54 56 52 52 56 50 53 55 54 53 63 55 53 54 52 51 52 50 51 53 52 48 50 49 48 51 50 51 264 53 48 264 51 264 63 53 264 267 63 261 264 260 261 265 264 264 268 267 265 268 264 260 264 48 259 260 254 259 261 260 254 260 48 258 259 255 255 259 254 258 261 259 247 251 254 251 255 254 48 247 254 252 255 251 255 252 256 256 258 255 257 258 256 257 261 258 252 59 256 59 257 256 41 257 59 41 90 257 257 262 261 90 262 257 262 265 261 90 263 262 262 266 265 263 266 262 265 269 268 266 269 265 263 86 266 266 86 84 266 270 269 84 270 266 88 263 90 88 86 263 84 86 85 86 87 85 86 88 87 81 84 83 84 85 83 84 81 270 270 271 269 270 272 271 81 272 270 80 39 81 81 83 80 272 81 39 83 290 80 83 293 290 83 85 293 80 82 39 290 286 80 80 286 82 39 82 38 60 272 39 271 272 60 269 271 268 79 36 38 38 82 79 82 286 79 78 36 79 79 286 78 29 36 78 31 36 29 32 78 77 29 78 32 286 287 78 78 287 77 29 30 31 32 30 29 11 30 9 32 9 30 34 30 11 30 34 24 9 10 11 10 12 11 11 12 13 13 34 11 14 10 9 14 9 32 14 15 10 15 16 10 10 16 12 12 16 17 12 25 13 12 17 25 5 13 25 5 34 13 25 8 5 24 34 5 8 27 26 27 8 25 25 65 27 65 66 27 27 232 49 66 232 27 65 67 66 65 273 67 25 273 65 67 68 66 68 232 66 67 69 68 67 273 69 69 70 68 70 232 68 69 73 70 69 273 73 73 74 70 74 232 70 72 74 73 74 284 285 74 285 232 72 284 74 284 72 277 285 284 276 276 284 277 232 285 282 282 285 274 274 285 276 274 276 73 276 277 73 73 277 71 71 277 278 277 72 278 71 72 73 278 279 71 71 279 72 278 72 279 273 274 73 274 273 275 275 282 274 129 273 25 280 281 273 273 281 275 129 280 273 281 427 275 275 427 282 128 427 281 128 281 280 128 280 129 126 128 127 128 129 127 310 432 128 432 427 128 309 310 128 126 297 128 128 297 309 423 432 431 426 432 423 426 427 432 431 432 310 423 424 247 247 426 423 423 431 424 424 431 430 430 431 310 424 425 247 424 430 425 425 430 429 429 430 310 425 421 247 425 429 421 421 429 428 315 429 310 428 429 315 314 315 308 308 315 310 315 314 116 116 428 315 310 309 308 308 307 306 308 309 307 306 314 308 309 299 307 299 309 297 306 307 305 307 94 305 307 299 94 297 298 299 298 94 299 297 296 298 291 296 297 126 291 297 298 301 95 298 296 301 95 94 298 295 296 288 288 296 291 296 295 301 291 292 288 292 291 126 124 126 125 126 127 125 124 292 126 288 292 122 122 292 124 122 124 123 124 125 123 125 127 118 121 125 118 123 125 121 127 129 64 118 127 64 64 16 118 16 119 118 119 120 118 120 121 118 120 122 121 122 123 121 120 288 122 119 288 120 76 119 16 76 288 119 16 64 17 16 35 76 15 35 16 75 76 35 75 288 76 35 15 33 33 75 35 32 33 15 14 32 15 32 77 33 75 33 77 77 287 75 75 287 288 289 287 286 289 288 287 290 289 286 289 290 294 290 293 294 303 294 293 289 294 303 85 302 293 293 302 303 289 303 501 302 501 303 301 302 85 301 295 302 289 501 302 289 302 500 295 500 302 87 300 85 301 85 300 95 301 300 89 300 87 95 300 89 88 89 87 88 90 89 90 91 89 93 89 91 93 95 89 94 95 93 92 93 91 92 94 93 90 41 91 91 41 40 40 92 91 40 311 92 311 94 92 305 94 311 99 311 96 305 311 99 96 311 40 40 41 42 42 96 40 41 59 42 42 97 96 42 59 97 97 98 96 98 99 96 98 100 99 304 99 100 304 305 99 306 305 304 304 100 101 101 103 304 103 312 304 304 312 306 98 101 100 98 102 101 102 103 101 102 104 103 236 102 249 104 102 236 102 250 249 98 250 102 104 105 103 104 106 105 236 237 104 104 237 106 234 235 236 235 237 236 236 249 234 235 106 237 106 107 105 235 243 106 243 244 106 106 244 107 239 235 234 239 243 235 238 239 234 234 249 248 234 248 238 242 239 238 242 245 239 239 245 243 245 246 243 243 246 244 245 417 246 242 417 245 241 242 238 242 418 417 242 419 418 241 419 242 246 417 416 416 417 414 417 418 414 244 246 46 246 416 46 46 416 44 44 416 231 416 414 231 43 46 44 43 109 46 109 244 46 107 244 109 107 109 108 43 110 109 109 110 108 107 108 105 108 319 105 110 319 108 110 321 319 43 321 110 316 319 318 103 319 316 105 319 103 319 321 318 318 321 320 320 321 111 111 321 43 312 318 317 316 318 312 318 320 317 103 316 312 312 313 306 312 317 313 313 317 314 317 115 314 317 320 115 115 320 111 114 115 113 113 115 111 116 115 114 314 115 116 313 314 306 116 114 117 117 428 116 229 114 113 229 117 114 111 112 113 229 113 228 228 113 112 111 43 112 43 45 112 228 112 45 45 231 228 360 229 228 348 360 228 231 348 228 43 44 45 44 231 45 348 231 414 348 414 454 457 454 414 418 477 414 457 414 439 414 477 439 435 457 439 454 457 435 436 435 439 439 481 436 420 481 439 477 420 439 418 419 477 477 419 415 415 420 477 420 421 422 415 421 420 422 433 420 433 481 420 240 415 241 415 419 241 240 421 415 247 421 240 421 428 422 428 433 422 117 433 428 230 433 117 433 229 481 230 229 433 229 230 117 360 483 229 483 487 229 487 481 229 436 481 451 481 480 451 487 480 481 487 488 480 487 495 488 495 487 483 480 479 451 479 480 488 451 445 436 446 445 451 451 479 446 446 479 478 489 479 488 478 479 491 491 479 489 488 493 489 488 495 493 493 495 494 483 494 495 492 493 494 493 496 489 493 497 496 493 492 497 490 491 489 489 496 490 496 497 475 496 475 499 490 496 499 497 476 475 497 498 476 498 497 492 498 492 485 485 492 494 471 476 498 471 498 485 475 476 410 410 476 408 370 476 471 408 476 370 373 471 470 370 471 373 471 484 470 485 484 471 370 371 372 373 371 370 370 409 408 372 409 370 408 409 410 409 404 412 409 412 410 372 404 409 372 371 377 377 404 372 403 404 402 405 402 404 412 404 403 377 405 404 411 412 413 413 412 403 410 412 411 413 403 396 403 402 396 397 402 401 396 402 397 405 401 402 378 405 377 401 405 378 322 401 323 322 397 401 386 401 378 386 323 401 396 397 325 325 397 324 324 397 322 142 322 323 145 322 142 145 324 322 142 323 381 381 323 386 386 378 385 381 386 382 382 386 385 380 381 382 142 381 380 380 382 383 383 382 387 387 382 385 376 385 375 385 378 375 376 387 385 383 387 376 374 376 366 366 376 375 374 379 376 379 383 376 368 375 371 366 375 368 371 375 378 371 378 377 373 368 371 367 368 369 369 368 373 367 366 368 365 366 367 365 374 366 367 460 365 369 460 367 373 458 369 458 460 369 470 458 373 458 459 460 458 466 459 470 484 458 458 484 466 459 466 467 459 467 460 463 467 466 466 482 463 484 482 466 485 482 484 463 482 464 482 469 464 482 483 469 485 486 482 482 486 483 485 494 486 486 494 483 469 483 465 465 483 360 464 469 354 465 354 469 355 464 354 463 464 355 352 353 354 354 353 355 176 178 354 354 178 352 354 465 176 360 361 465 465 361 176 177 360 348 361 360 177 176 361 177 174 176 177 178 176 174 177 173 174 177 348 173 348 339 173 348 454 339 165 168 173 174 173 168 165 173 339 168 178 174 168 165 167 167 178 168 165 166 167 166 183 167 167 183 178 184 183 166 352 183 184 178 183 352 182 184 166 352 184 353 184 362 353 182 362 184 181 182 155 155 182 153 153 182 166 182 181 362 353 362 356 364 357 362 362 357 356 362 181 364 353 356 355 355 356 349 356 357 349 349 357 350 357 358 350 363 357 364 363 358 357 181 180 364 364 180 363 359 358 363 180 179 363 363 388 359 363 195 388 179 195 363 358 359 350 359 388 393 359 393 350 388 193 389 195 193 388 388 389 393 194 193 195 179 194 195 191 193 192 194 192 193 193 390 389 193 191 390 389 392 393 389 390 392 393 392 395 350 393 395 390 394 392 395 392 374 392 394 374 191 391 390 390 391 394 394 379 374 394 391 379 365 395 374 365 468 395 460 468 365 468 462 351 468 351 461 460 462 468 468 461 395 467 462 460 351 462 349 462 463 349 467 463 462 349 350 351 461 351 350 350 395 461 349 463 355 383 379 384 379 391 384 185 383 384 185 380 383 186 384 391 186 185 384 189 391 191 186 391 189 185 186 187 186 188 187 186 189 188 189 190 188 189 191 190 191 192 190 192 208 190 190 208 188 215 187 188 215 188 207 207 188 208 199 208 192 199 207 208 194 199 192 200 199 194 198 199 200 198 197 199 197 207 199 204 207 197 206 207 204 206 215 207 196 197 198 196 201 197 201 203 197 197 203 204 203 206 204 205 206 203 205 209 206 209 215 206 202 203 201 202 227 203 203 227 205 225 227 202 201 335 202 335 336 202 202 336 225 224 227 225 224 205 227 223 224 225 225 336 223 336 337 223 335 342 336 336 342 344 336 344 337 171 335 201 342 335 171 342 171 172 172 343 342 344 342 343 344 343 345 344 345 337 345 343 341 347 343 172 347 341 343 345 453 337 346 345 341 453 345 346 341 175 340 341 340 346 341 347 175 175 347 163 347 172 163 163 170 175 175 170 165 165 340 175 165 339 340 346 340 339 165 170 166 169 166 170 170 163 169 161 160 163 169 163 160 161 163 172 154 169 160 153 169 154 166 169 153 153 154 155 154 157 155 157 154 160 159 155 157 159 181 155 156 157 158 159 157 156 158 157 160 156 179 159 179 180 159 180 181 159 156 200 194 158 200 156 156 194 179 164 158 160 198 200 158 164 198 158 162 164 160 196 198 164 162 196 164 160 161 162 171 162 172 162 161 172 171 196 162 171 201 196 339 454 346 456 346 454 437 454 435 456 454 437 456 453 346 440 456 437 453 456 440 435 436 437 436 438 437 438 440 437 441 440 438 442 440 441 442 452 440 452 453 440 455 337 453 455 453 452 443 452 330 330 452 442 443 455 452 338 337 455 338 455 443 223 337 221 221 337 219 337 338 219 136 338 329 219 338 136 329 338 443 329 443 330 136 329 134 329 330 134 330 331 134 442 331 330 134 135 136 134 137 135 134 149 137 134 331 149 222 219 136 135 222 136 135 130 132 137 130 135 132 222 135 137 138 130 149 138 137 149 150 138 149 331 150 150 151 138 138 133 130 138 143 133 138 151 143 130 131 132 133 131 130 216 222 132 131 216 132 139 131 140 133 140 131 131 217 216 139 217 131 143 140 133 143 144 140 151 144 143 145 140 144 140 145 139 147 144 151 144 325 145 326 325 144 147 327 144 327 326 144 145 142 139 325 324 145 325 326 396 327 399 326 399 396 326 328 327 147 328 398 327 398 399 327 400 399 398 413 396 399 400 413 399 406 400 398 406 398 328 406 407 400 407 413 400 411 413 407 406 473 407 473 474 407 474 475 407 407 475 411 328 472 406 472 473 406 473 499 474 491 473 472 491 499 473 474 499 475 411 475 410 490 499 491 478 491 472 434 472 328 434 478 472 333 478 434 449 478 333 446 478 449 333 434 328 146 328 147 146 333 328 146 147 148 148 333 146 148 334 333 448 333 334 448 449 333 449 448 446 444 445 446 444 446 448 444 448 447 447 448 334 444 447 441 438 444 441 438 445 444 436 445 438 441 447 442 447 334 450 447 450 442 442 450 331 332 450 334 331 450 332 331 332 150 150 332 334 152 151 150 150 334 152 152 334 148 148 151 152 148 147 151 141 139 142 139 212 217 141 212 139 142 185 141 141 185 212 380 185 142 185 187 212 214 187 215 212 187 214 214 210 212 210 214 213 213 214 215 213 215 209 210 213 211 205 213 209 205 211 213 210 211 212 226 218 211 226 211 205 211 218 212 226 205 224 220 226 224 216 226 220 216 218 226 216 217 218 217 212 218 222 216 220 219 220 221 222 220 219 220 223 221 220 224 223 240 241 238 238 247 240 238 248 247 248 251 247 47 247 48 47 426 247 248 252 251 249 252 248 249 253 252 253 59 252 250 253 249 250 98 253 98 97 253 97 59 253 47 283 426 283 427 426 282 283 233 233 283 47 282 427 283 232 282 233 47 232 233 47 48 49 49 232 47 288 289 500 288 500 295 17 64 25 64 129 25))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-1.1255100250244141e+02 -2.1148599624633789e+01 -7.2288298606872559e+00 -1.0990699768066406e+02 -2.2224800109863281e+01 -8.4010801315307617e+00 -1.1138800048828125e+02 -2.1970798492431641e+01 -7.6926403045654297e+00 -1.1022100067138672e+02 -2.2377601623535156e+01 -8.1409997940063477e+00 -1.1120399475097656e+02 -2.2176399230957031e+01 -7.6428799629211426e+00 -1.1219800567626953e+02 -2.1725299835205078e+01 -7.1447100639343262e+00 -1.0823900604248047e+02 -2.1607000350952148e+01 -9.1103105545043945e+00 -1.0910300445556641e+02 -2.2351900100708008e+01 -8.6652698516845703e+00 -1.1298500061035156e+02 -2.1160499572753906e+01 -6.8069300651550293e+00 -1.1063700103759766e+02 -2.2329200744628906e+01 7.9401097297668457e+00 -1.1053100585937500e+02 -2.2138799667358398e+01 8.1301708221435547e+00 -1.1188899993896484e+02 -2.1872499465942383e+01 7.3370399475097656e+00 -1.1254100036621094e+02 -2.1298200607299805e+01 7.2108802795410156e+00 -1.1268900299072266e+02 -2.1404798507690430e+01 6.8442997932434082e+00 -1.0970099639892578e+02 -2.2372600555419922e+01 8.4108705520629883e+00 -1.0892800140380859e+02 -2.2148000717163086e+01 8.8029594421386719e+00 -1.0786999511718750e+02 -2.0569400787353516e+01 9.1142997741699219e+00 -1.1374600219726562e+02 -2.0187700271606445e+01 6.6784701347351074e+00 -1.0917800140380859e+02 -2.3354999542236328e+01 -7.0110297203063965e+00 -1.0959700012207031e+02 -2.2983501434326172e+01 -7.7004499435424805e+00 -1.0783599853515625e+02 -2.3773399353027344e+01 -7.0611500740051270e+00 -1.0779300689697266e+02 -2.3464401245117188e+01 -7.9070405960083008e+00 -1.0771399688720703e+02 -2.2889999389648438e+01 -8.5910701751708984e+00 -1.0673400115966797e+02 -2.2362699508666992e+01 -8.9888896942138672e+00 -1.1084500122070312e+02 -2.2612600326538086e+01 -6.7972202301025391e+00 -1.1408399963378906e+02 -2.0165700912475586e+01 6.2718000411987305e+00 -1.1384799957275391e+02 -2.0181499481201172e+01 -6.6102499961853027e+00 -1.1406900024414062e+02 -2.0165899276733398e+01 -6.2554397583007812e+00 -1.0810800170898438e+02 -2.0549499511718750e+01 -9.1296901702880859e+00 -1.0787599945068359e+02 -2.3624900817871094e+01 7.5470304489135742e+00 -1.0941000366210938e+02 -2.3245100021362305e+01 7.2567200660705566e+00 -1.0786599731445312e+02 -2.3784700393676758e+01 6.8197798728942871e+00 -1.0798899841308594e+02 -2.3176898956298828e+01 8.2607002258300781e+00 -1.0745400238037109e+02 -2.2550701141357422e+01 8.8517494201660156e+00 -1.1085499572753906e+02 -2.2606800079345703e+01 6.8199100494384766e+00 -1.0834500122070312e+02 -2.1908199310302734e+01 9.0081100463867188e+00 -1.0678499603271484e+02 -2.3850200653076172e+01 7.2325701713562012e+00 -1.0652100372314453e+02 -2.3850898742675781e+01 -7.2211799621582031e+00 -1.0580200195312500e+02 -2.3780399322509766e+01 6.8899002075195312e+00 -1.0503900146484375e+02 -2.3565999984741211e+01 -6.8094100952148438e+00 -8.0891105651855469e+01 -1.1325000524520874e+00 6.8449096679687500e+00 -8.1105300903320312e+01 -2.2144498825073242e+00 -7.0301799774169922e+00 -8.0893203735351562e+01 -1.1343699693679810e+00 -6.8404102325439453e+00 -6.6427604675292969e+01 7.8912601470947266e+00 7.0898699760437012e+00 -6.6379302978515625e+01 1.0204099655151367e+01 -6.8426899909973145e+00 -6.6416801452636719e+01 1.0317999839782715e+01 6.9112296104431152e+00 -6.6422096252441406e+01 7.8617205619812012e+00 -6.9276800155639648e+00 -1.0390999603271484e+02 -1.1320199966430664e+01 -9.1500005722045898e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 -9.1500005722045898e+00 -1.0390800476074219e+02 -1.1322799682617188e+01 -6.2500000000000000e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 -6.2500000000000000e+00 -1.0243199920654297e+02 -1.5235600471496582e+01 -9.1500005722045898e+00 -1.0243199920654297e+02 -1.5235600471496582e+01 -6.2500000000000000e+00 -1.0325399780273438e+02 -1.7961500167846680e+01 -9.1500005722045898e+00 -1.0325399780273438e+02 -1.7961500167846680e+01 -6.2500000000000000e+00 -1.0492599487304688e+02 -1.9646100997924805e+01 -9.1500005722045898e+00 -1.0492599487304688e+02 -1.9646100997924805e+01 -6.2500000000000000e+00 -1.0664500427246094e+02 -2.0404399871826172e+01 -9.1500005722045898e+00 -1.0715000152587891e+02 -2.0549098968505859e+01 -6.2500100135803223e+00 -8.1037994384765625e+01 -9.0935903787612915e-01 -7.6571698188781738e+00 -1.0581700134277344e+02 -2.3635700225830078e+01 -7.5242900848388672e+00 -1.0625199890136719e+02 -2.3281200408935547e+01 -8.2787399291992188e+00 -1.0631799316406250e+02 -2.2787200927734375e+01 -8.7120494842529297e+00 -1.0642399597167969e+02 -2.1591701507568359e+01 -9.1486701965332031e+00 -1.0758700561523438e+02 -2.0558599472045898e+01 6.2500600814819336e+00 -1.1537699890136719e+02 -1.8636501312255859e+01 6.2500000000000000e+00 -1.1537699890136719e+02 -1.8636501312255859e+01 -6.2500000000000000e+00 -1.1674299621582031e+02 -1.6191101074218750e+01 6.2500000000000000e+00 -1.1674299621582031e+02 -1.6191101074218750e+01 -6.2500000000000000e+00 -1.1696799468994141e+02 -1.4067199707031250e+01 6.2500000000000000e+00 -1.1696799468994141e+02 -1.4067199707031250e+01 -6.2500000000000000e+00 -1.1538999938964844e+02 -9.9371299743652344e+00 6.2500000000000000e+00 -1.1516500091552734e+02 -9.6792697906494141e+00 -6.2500000000000000e+00 -1.1622299957275391e+02 -1.1383399963378906e+01 6.2500000000000000e+00 -1.1622299957275391e+02 -1.1383399963378906e+01 -6.2500000000000000e+00 -1.0658500671386719e+02 -2.2050399780273438e+01 9.0689001083374023e+00 -1.0739199829101562e+02 -2.1629100799560547e+01 9.1438894271850586e+00 -1.0634799957275391e+02 -2.2640100479125977e+01 8.8131694793701172e+00 -1.0628200531005859e+02 -2.3285800933837891e+01 8.2749204635620117e+00 -1.0582099914550781e+02 -2.3627899169921875e+01 7.5341701507568359e+00 -1.0305800628662109e+02 -2.2583400726318359e+01 6.9935097694396973e+00 -1.0316800689697266e+02 -2.2666999816894531e+01 -6.8754200935363770e+00 -1.0470500183105469e+02 -2.3403900146484375e+01 7.1863298416137695e+00 -8.4307502746582031e+01 -7.6383199691772461e+00 7.0561299324035645e+00 -8.4178100585937500e+01 -7.4929299354553223e+00 -7.2439699172973633e+00 -8.3353996276855469e+01 -6.6484398841857910e+00 7.2930903434753418e+00 -8.3333702087402344e+01 -6.6357998847961426e+00 -7.2368602752685547e+00 -8.2248100280761719e+01 -5.2323098182678223e+00 6.7470102310180664e+00 -8.2248100280761719e+01 -5.2323098182678223e+00 -6.7470197677612305e+00 -8.1535301208496094e+01 -3.6073899269104004e+00 7.2368497848510742e+00 -8.1535301208496094e+01 -3.6073899269104004e+00 -7.2368602752685547e+00 -8.1164703369140625e+01 -2.4137799739837646e+00 7.0925097465515137e+00 -8.1041595458984375e+01 -1.2051099538803101e+00 7.4830198287963867e+00 -8.1404800415039062e+01 -2.1610400676727295e+00 7.8907098770141602e+00 -8.1464607238769531e+01 -5.7703697681427002e-01 8.4296903610229492e+00 -8.1916801452636719e+01 -2.8818399906158447e+00 8.3461799621582031e+00 -8.0582000732421875e+01 -3.2899701595306396e-01 6.8224301338195801e+00 -8.0611602783203125e+01 -3.6499801278114319e-01 -7.0285301208496094e+00 -7.9885299682617188e+01 5.9871703386306763e-01 -6.9645900726318359e+00 -8.0027702331542969e+01 4.7092598676681519e-01 7.2357196807861328e+00 -7.9382598876953125e+01 9.8377698659896851e-01 7.2393703460693359e+00 -7.8882797241210938e+01 1.2371500730514526e+00 7.0834403038024902e+00 -7.8878799438476562e+01 1.2544499635696411e+00 -7.2472901344299316e+00 -6.8381195068359375e+01 5.0998897552490234e+00 7.0914001464843750e+00 -6.8381401062011719e+01 5.0997200012207031e+00 -7.0912103652954102e+00 -6.7523101806640625e+01 5.7609796524047852e+00 6.6500000953674316e+00 -6.7562103271484375e+01 5.7994298934936523e+00 -7.3110098838806152e+00 -6.7093399047851562e+01 6.2765302658081055e+00 -6.6500000953674316e+00 -6.7093399047851562e+01 6.2765302658081055e+00 6.6500000953674316e+00 -6.6755897521972656e+01 6.8566699028015137e+00 -6.6500000953674316e+00 -6.6765502929687500e+01 6.8609399795532227e+00 6.9129900932312012e+00 -6.6726501464843750e+01 8.2779598236083984e+00 7.9365501403808594e+00 -6.6528701782226562e+01 1.0204299926757812e+01 7.5418601036071777e+00 -6.6966804504394531e+01 1.0284399986267090e+01 8.2502498626708984e+00 -6.7592597961425781e+01 1.0280200004577637e+01 8.7884492874145508e+00 -6.7469200134277344e+01 7.9253296852111816e+00 8.7163000106811523e+00 -6.8424797058105469e+01 8.1632604598999023e+00 9.1246194839477539e+00 -6.8441200256347656e+01 1.0274600028991699e+01 9.1099405288696289e+00 -1.0575799560546875e+02 -2.0101900100708008e+01 6.2499799728393555e+00 -1.0574500274658203e+02 -2.0094999313354492e+01 9.1500005722045898e+00 -1.0418099975585938e+02 -1.9052000045776367e+01 9.1500005722045898e+00 -1.0418099975585938e+02 -1.9052000045776367e+01 6.2500000000000000e+00 -1.0282299804687500e+02 -1.7104900360107422e+01 9.1500005722045898e+00 -1.0282299804687500e+02 -1.7104900360107422e+01 6.2500000000000000e+00 -1.0247100067138672e+02 -1.4757699966430664e+01 9.1500005722045898e+00 -1.0247100067138672e+02 -1.4757699966430664e+01 6.2500000000000000e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 9.1500005722045898e+00 -1.0289599609375000e+02 -1.2907699584960938e+01 6.2500000000000000e+00 -1.0390999603271484e+02 -1.1320199966430664e+01 9.1500005722045898e+00 -1.0390800476074219e+02 -1.1322799682617188e+01 6.2500000000000000e+00 -9.3890396118164062e+01 1.9594499588012695e+01 -1.0717599868774414e+01 -9.3311698913574219e+01 2.0343400955200195e+01 -1.0186299324035645e+01 -9.3139999389648438e+01 1.9639101028442383e+01 -1.0931699752807617e+01 -9.4444198608398438e+01 1.9820499420166016e+01 -1.0143100738525391e+01 -9.3770805358886719e+01 1.8042900085449219e+01 -1.1324600219726562e+01 -9.3148300170898438e+01 1.8898900985717773e+01 -1.1310199737548828e+01 -9.2880302429199219e+01 1.8248298645019531e+01 -1.1486599922180176e+01 -9.4190101623535156e+01 1.8621999740600586e+01 -1.1047300338745117e+01 -9.4629699707031250e+01 1.9244899749755859e+01 -1.0483499526977539e+01 -9.3179298400878906e+01 2.0761600494384766e+01 -9.3805398941040039e+00 -9.4466201782226562e+01 2.0374099731445312e+01 -9.2567300796508789e+00 -9.2621604919433594e+01 2.0890800476074219e+01 -8.6935596466064453e+00 -9.3537803649902344e+01 2.0878400802612305e+01 -8.3422803878784180e+00 -9.5026596069335938e+01 1.9846000671386719e+01 -9.4315004348754883e+00 -9.5409896850585938e+01 1.9844099044799805e+01 -8.4183597564697266e+00 -9.4459800720214844e+01 2.0576400756835938e+01 -8.5082206726074219e+00 -9.6102294921875000e+01 1.8082401275634766e+01 -8.4063005447387695e+00 -9.5957000732421875e+01 1.8826099395751953e+01 -8.5782003402709961e+00 -9.5930999755859375e+01 1.8176700592041016e+01 -9.1546802520751953e+00 -9.4813400268554688e+01 1.8193399429321289e+01 -1.0736900329589844e+01 -9.5316596984863281e+01 1.8348098754882812e+01 -1.0241700172424316e+01 -9.5368499755859375e+01 1.9263999938964844e+01 -9.6255397796630859e+00 -9.5664001464843750e+01 1.8175401687622070e+01 -9.7290201187133789e+00 -6.1640899658203125e+01 1.0425000190734863e+01 -3.9616897106170654e+00 -6.1256801605224609e+01 1.1007900238037109e+01 -5.0008902549743652e+00 -6.1028400421142578e+01 1.0940000534057617e+01 -3.5944600105285645e+00 -6.0362701416015625e+01 1.2412300109863281e+01 -3.8142299652099609e+00 -6.0830898284912109e+01 1.1490600585937500e+01 -4.6984200477600098e+00 -6.0695499420166016e+01 1.2366300582885742e+01 -5.3090500831604004e+00 -6.0535999298095703e+01 1.1712599754333496e+01 -3.2430801391601562e+00 -6.1415000915527344e+01 1.1332499504089355e+01 -6.1296601295471191e+00 -6.2047298431396484e+01 1.1340100288391113e+01 -7.2632598876953125e+00 -6.1666099548339844e+01 1.2169400215148926e+01 -7.3382396697998047e+00 -6.2599899291992188e+01 1.0761500358581543e+01 -7.2886400222778320e+00 -6.1104301452636719e+01 1.2365699768066406e+01 -6.3779201507568359e+00 -6.3905403137207031e+01 9.9834995269775391e+00 -6.6251201629638672e+00 -6.2361698150634766e+01 1.0050799369812012e+01 -4.0647602081298828e+00 -6.3224800109863281e+01 9.8956604003906250e+00 -4.1209397315979004e+00 -6.4281700134277344e+01 9.9137601852416992e+00 -6.2162299156188965e+00 -6.2290500640869141e+01 1.0443200111389160e+01 -6.0588402748107910e+00 -6.3195800781250000e+01 1.0118500709533691e+01 -6.4187703132629395e+00 -6.2472702026367188e+01 1.2513899803161621e+01 -8.4688806533813477e+00 -6.2741802215576172e+01 1.1699199676513672e+01 -8.3473205566406250e+00 -6.5240798950195312e+01 1.0212999343872070e+01 -7.2388596534729004e+00 -6.4898796081542969e+01 9.9844198226928711e+00 -6.1325101852416992e+00 -6.3833900451660156e+01 1.0411499977111816e+01 -7.6742200851440430e+00 -6.4857902526855469e+01 9.9734296798706055e+00 6.2122802734375000e+00 -6.5789199829101562e+01 1.0287300109863281e+01 -6.7968602180480957e+00 -6.3911804199218750e+01 9.8958206176757812e+00 5.6185297966003418e+00 -6.0359798431396484e+01 1.2307199478149414e+01 3.6064600944519043e+00 -6.0628803253173828e+01 1.1578699111938477e+01 3.7531502246856689e+00 -6.1003398895263672e+01 1.0976799964904785e+01 3.6707999706268311e+00 -6.1652702331542969e+01 1.0380000114440918e+01 3.2844698429107666e+00 -6.2966400146484375e+01 9.9117994308471680e+00 3.9426000118255615e+00 -6.2402801513671875e+01 1.0049499511718750e+01 4.1836700439453125e+00 -6.2849601745605469e+01 2.0878900527954102e+01 4.6983399391174316e+00 -6.1999298095703125e+01 2.0687000274658203e+01 3.4147000312805176e+00 -6.2570995330810547e+01 2.0865400314331055e+01 -3.6086099147796631e+00 -6.1783802032470703e+01 2.0569799423217773e+01 -4.0062098503112793e+00 -6.1179801940917969e+01 2.0188600540161133e+01 3.4911398887634277e+00 -6.1094200134277344e+01 2.0112199783325195e+01 -3.4762198925018311e+00 -6.0759300231933594e+01 1.9701499938964844e+01 4.0063400268554688e+00 -6.0481601715087891e+01 1.9313299179077148e+01 -3.6495699882507324e+00 -6.0331798553466797e+01 1.8978799819946289e+01 3.8294301033020020e+00 -6.0145603179931641e+01 1.8248100280761719e+01 -3.5796301364898682e+00 -6.0149700164794922e+01 1.8183900833129883e+01 3.7242200374603271e+00 -6.1329101562500000e+01 1.8172399520874023e+01 -7.3941497802734375e+00 -6.1202499389648438e+01 1.9032899856567383e+01 -6.7604098320007324e+00 -6.0576999664306641e+01 1.8134300231933594e+01 -5.7871098518371582e+00 -6.0678703308105469e+01 1.9317298889160156e+01 -4.9355797767639160e+00 -6.0273300170898438e+01 1.8190299987792969e+01 -4.6072797775268555e+00 -6.2056499481201172e+01 1.8305599212646484e+01 -8.4032497406005859e+00 -6.2891201019287109e+01 1.8202999114990234e+01 -9.2903900146484375e+00 -6.2518798828125000e+01 1.9168001174926758e+01 -8.5312500000000000e+00 -6.1819400787353516e+01 1.9715000152587891e+01 -7.0366902351379395e+00 -6.3629402160644531e+01 1.9681400299072266e+01 -9.1858005523681641e+00 -6.2661094665527344e+01 2.0117799758911133e+01 -7.6399598121643066e+00 -6.1705501556396484e+01 2.0120000839233398e+01 -6.0299701690673828e+00 -6.1365299224853516e+01 2.0182001113891602e+01 -4.7702097892761230e+00 -6.3459999084472656e+01 2.0138601303100586e+01 -8.4642896652221680e+00 -6.5282203674316406e+01 2.0844699859619141e+01 -8.1589899063110352e+00 -6.5461898803710938e+01 2.0472999572753906e+01 -9.3470602035522461e+00 -6.7502799987792969e+01 2.0880699157714844e+01 -8.8870401382446289e+00 -6.4250900268554688e+01 2.0501499176025391e+01 -8.5253801345825195e+00 -6.3902801513671875e+01 2.0890598297119141e+01 -6.4770898818969727e+00 -6.2842899322509766e+01 2.0660999298095703e+01 -6.4450001716613770e+00 -6.7447898864746094e+01 1.9895900726318359e+01 -1.0701199531555176e+01 -6.8066703796386719e+01 2.0559700012207031e+01 -9.8929996490478516e+00 -6.6776199340820312e+01 2.0473899841308594e+01 -9.8433294296264648e+00 -6.8019004821777344e+01 1.8250000000000000e+01 -1.1477600097656250e+01 -6.6453102111816406e+01 1.9029800415039062e+01 -1.1013400077819824e+01 -6.6668197631835938e+01 1.8167299270629883e+01 -1.1279200553894043e+01 -6.8108795166015625e+01 1.9188899993896484e+01 -1.1208799362182617e+01 -6.5456893920898438e+01 1.8165899276733398e+01 -1.0892800331115723e+01 -6.4912101745605469e+01 1.9028398513793945e+01 -1.0428299903869629e+01 -6.4241897583007812e+01 1.8162601470947266e+01 -1.0295599937438965e+01 -6.5291099548339844e+01 1.9738498687744141e+01 -1.0151299476623535e+01 -6.3691497802734375e+01 1.9022300720214844e+01 -9.6710500717163086e+00 -6.6639404296875000e+01 1.0391200065612793e+01 7.4401497840881348e+00 -6.7378097534179688e+01 1.0396800041198730e+01 8.4291000366210938e+00 -6.8558403015136719e+01 1.0390600204467773e+01 8.9551897048950195e+00 -6.6518203735351562e+01 1.0381000518798828e+01 -7.0109400749206543e+00 -1.0655000305175781e+02 -9.0483503341674805e+00 -6.2500000000000000e+00 -1.0659600067138672e+02 -8.9703903198242188e+00 -9.1500005722045898e+00 -6.8878005981445312e+01 5.8127598762512207e+00 -8.5706300735473633e+00 -6.8101898193359375e+01 5.8599400520324707e+00 -8.1459197998046875e+00 -6.8941696166992188e+01 5.2135200500488281e+00 -7.9463496208190918e+00 -6.8069396972656250e+01 5.3750901222229004e+00 -7.2382197380065918e+00 -6.9012496948242188e+01 6.5341000556945801e+00 -8.9862108230590820e+00 -6.7782798767089844e+01 6.8296599388122559e+00 -8.5839900970458984e+00 -6.9165496826171875e+01 7.2737402915954590e+00 -9.1449699401855469e+00 -6.8384101867675781e+01 7.9007697105407715e+00 -9.0976705551147461e+00 -6.7704200744628906e+01 7.7998600006103516e+00 -8.8410501480102539e+00 -6.7219802856445312e+01 6.7383103370666504e+00 -7.9707598686218262e+00 -6.6955093383789062e+01 6.5843300819396973e+00 -7.2415699958801270e+00 -6.7004997253417969e+01 7.9977197647094727e+00 -8.2913408279418945e+00 -6.6569900512695312e+01 7.9542694091796875e+00 -7.5836801528930664e+00 -8.0766601562500000e+01 2.6834499835968018e+00 -9.1361703872680664e+00 -8.0020896911621094e+01 2.0557599067687988e+00 -8.8182601928710938e+00 -7.9667900085449219e+01 1.4880100488662720e+00 -8.2595100402832031e+00 -7.9713203430175781e+01 9.0127098560333252e-01 -7.5182800292968750e+00 -8.1314804077148438e+01 1.4700200557708740e+00 -9.0114593505859375e+00 -8.1178298950195312e+01 3.1777799129486084e-01 -8.5120792388916016e+00 -8.0600097656250000e+01 2.5520402193069458e-01 -7.9102797508239746e+00 -8.2784805297851562e+01 4.4402197003364563e-02 -9.1334791183471680e+00 -8.1941299438476562e+01 -2.4092900753021240e-01 -8.8169498443603516e+00 -8.1437797546386719e+01 -9.2610096931457520e-01 -8.2673997879028320e+00 -8.1758094787597656e+01 -3.0187301635742188e+00 -8.1118698120117188e+00 -8.2164199829101562e+01 -2.6206700801849365e+00 -8.6233196258544922e+00 -8.2902999877929688e+01 -2.6529698371887207e+00 -9.0108594894409180e+00 -8.3766494750976562e+01 -3.3219201564788818e+00 -9.1485605239868164e+00 -8.3335899353027344e+01 -4.5836100578308105e+00 -8.8279705047607422e+00 -8.2762893676757812e+01 -4.9265799522399902e+00 -8.2738695144653320e+00 -8.2385002136230469e+01 -5.1509799957275391e+00 -7.5249400138854980e+00 -8.5538703918457031e+01 -6.0334100723266602e+00 -9.1193103790283203e+00 -8.4640304565429688e+01 -6.3338699340820312e+00 -8.8090000152587891e+00 -8.4188796997070312e+01 -6.8161702156066895e+00 -8.2442798614501953e+00 -1.0439299774169922e+02 -2.1178501129150391e+01 -9.0887203216552734e+00 -1.0403299713134766e+02 -2.1799600601196289e+01 -8.8098001480102539e+00 -1.0300900268554688e+02 -2.1867799758911133e+01 -8.2513504028320312e+00 -1.0275500488281250e+02 -2.2213001251220703e+01 -7.4874601364135742e+00 -1.0447800445556641e+02 -2.2709800720214844e+01 -8.2735300064086914e+00 -1.0429399871826172e+02 -2.3108600616455078e+01 -7.5249996185302734e+00 -1.0652499389648438e+02 -9.0833702087402344e+00 6.2500000000000000e+00 -1.0879199981689453e+02 -9.1968107223510742e+00 6.2500000000000000e+00 -1.0652100372314453e+02 -8.5220699310302734e+00 6.2500000000000000e+00 -1.1179100036621094e+02 -9.5880804061889648e+00 6.2500000000000000e+00 -1.1489099884033203e+02 -9.5263805389404297e+00 6.2500000000000000e+00 -1.1528500366210938e+02 -9.8146600723266602e+00 6.2500000000000000e+00 -1.1534700012207031e+02 -9.8796491622924805e+00 6.2500000000000000e+00 -1.0652600097656250e+02 -9.0829801559448242e+00 9.1500005722045898e+00 -1.0653000640869141e+02 -8.5469398498535156e+00 9.1500005722045898e+00 -1.0649300384521484e+02 -8.5030593872070312e+00 -6.2500000000000000e+00 -1.0643299865722656e+02 -8.4661493301391602e+00 -9.1500005722045898e+00 -1.1463999938964844e+02 -9.5075397491455078e+00 -6.2500000000000000e+00 -1.1074099731445312e+02 -9.5356006622314453e+00 -6.2500000000000000e+00 -1.0459899902343750e+02 -2.2849300384521484e+01 8.1906995773315430e+00 -1.0481200408935547e+02 -2.1987098693847656e+01 8.9133701324462891e+00 -1.0357700347900391e+02 -2.0572999954223633e+01 9.1288499832153320e+00 -1.0290700531005859e+02 -2.1414701461791992e+01 8.5791702270507812e+00 -1.0255799865722656e+02 -2.1847799301147461e+01 7.9297304153442383e+00 -8.5285697937011719e+01 -5.3565101623535156e+00 9.1531400680541992e+00 -8.6191101074218750e+01 -5.9746003150939941e+00 9.1500005722045898e+00 -8.4434997558593750e+01 -7.4523196220397949e+00 7.7178397178649902e+00 -9.3737998962402344e+01 -1.4706799507141113e+01 8.4361400604248047e+00 -8.4648101806640625e+01 -6.3001999855041504e+00 8.8215703964233398e+00 -8.4215202331542969e+01 -5.1858601570129395e+00 9.0355100631713867e+00 -8.3408996582031250e+01 -1.5781799554824829e+00 9.1507396697998047e+00 -8.2511795043945312e+01 -2.3564100265502930e+00 8.9124402999877930e+00 -8.2423698425292969e+01 -6.5717399120330811e-01 8.9903802871704102e+00 -8.2372299194335938e+01 -5.1327199935913086e+00 7.5182700157165527e+00 -8.2866104125976562e+01 -4.8270797729492188e+00 8.4458894729614258e+00 -8.4181701660156250e+01 -6.7181601524353027e+00 8.2935199737548828e+00 -8.4635505676269531e+01 -7.3326001167297363e+00 8.0918207168579102e+00 -7.9508697509765625e+01 1.3220299482345581e+00 7.9454097747802734e+00 -8.0807800292968750e+01 4.0625399351119995e-01 8.2731399536132812e+00 -7.9835494995117188e+01 1.7615299224853516e+00 8.5770492553710938e+00 -8.1352302551269531e+01 7.9768502712249756e-01 8.8287897109985352e+00 -8.0248199462890625e+01 2.4152600765228271e+00 9.0147600173950195e+00 -8.2238693237304688e+01 1.0475699901580811e+00 9.1326198577880859e+00 -8.0497398376464844e+01 3.0117800235748291e+00 9.1439599990844727e+00 -8.0731506347656250e+01 -3.0195799469947815e-01 7.5233402252197266e+00 -6.8582801818847656e+01 5.3629498481750488e+00 7.9397101402282715e+00 -6.8881599426269531e+01 5.8094701766967773e+00 8.5697393417358398e+00 -6.8847198486328125e+01 6.6348700523376465e+00 8.9898700714111328e+00 -6.9246902465820312e+01 7.1703696250915527e+00 9.1396703720092773e+00 -6.8069396972656250e+01 5.3750901222229004e+00 7.2382502555847168e+00 -6.7967201232910156e+01 6.5680298805236816e+00 8.5666704177856445e+00 -6.7570594787597656e+01 6.2374300956726074e+00 7.9708199501037598e+00 -6.7335296630859375e+01 6.0413298606872559e+00 7.2416000366210938e+00 -6.7046905517578125e+01 7.3667497634887695e+00 8.1459798812866211e+00 -6.6710304260253906e+01 7.2175598144531250e+00 7.4390296936035156e+00 -9.3670799255371094e+01 2.0848899841308594e+01 8.3173599243164062e+00 -9.3062400817871094e+01 2.0889600753784180e+01 8.6832695007324219e+00 -9.4475296020507812e+01 2.0568099975585938e+01 8.2652196884155273e+00 -9.5187599182128906e+01 2.0061500549316406e+01 8.3796195983886719e+00 -9.5581100463867188e+01 1.9595699310302734e+01 8.4368000030517578e+00 -9.5950202941894531e+01 1.8861299514770508e+01 8.5076694488525391e+00 -9.6091598510742188e+01 1.8124500274658203e+01 8.5547199249267578e+00 -9.2733894348144531e+01 1.3036300659179688e+01 -1.1314899444580078e+01 -9.3509201049804688e+01 1.2771699905395508e+01 -1.1148099899291992e+01 -9.4322799682617188e+01 1.2947400093078613e+01 -1.0788499832153320e+01 -9.5096099853515625e+01 1.3248800277709961e+01 -1.0142100334167480e+01 -9.5897506713867188e+01 1.2896499633789062e+01 -8.4291496276855469e+00 -9.5564300537109375e+01 1.2914200782775879e+01 -9.4243803024291992e+00 -6.3192703247070312e+01 1.2891500473022461e+01 -9.2307596206665039e+00 -6.4513099670410156e+01 1.3146400451660156e+01 -1.0202899932861328e+01 -6.6488899230957031e+01 1.2884799957275391e+01 -1.1013099670410156e+01 -6.8109695434570312e+01 1.3013999938964844e+01 -1.1299399375915527e+01 -6.5641593933105469e+01 1.0540900230407715e+01 -8.5027809143066406e+00 -6.4671798706054688e+01 1.0553799629211426e+01 -8.2588300704956055e+00 -6.5173202514648438e+01 1.1195799827575684e+01 -9.5083999633789062e+00 -6.3850902557373047e+01 1.2335700035095215e+01 -9.5917797088623047e+00 -6.4128501892089844e+01 1.1689200401306152e+01 -9.3995904922485352e+00 -6.5116004943847656e+01 1.2520500183105469e+01 -1.0389900207519531e+01 -6.5758300781250000e+01 1.1837399482727051e+01 -1.0338700294494629e+01 -6.6464500427246094e+01 1.0906100273132324e+01 -9.6689691543579102e+00 -6.3610897064208984e+01 1.1091800689697266e+01 -8.5185594558715820e+00 -6.6167900085449219e+01 1.0398699760437012e+01 -7.9767799377441406e+00 -6.2467800140380859e+01 1.1268300056457520e+01 7.7261500358581543e+00 -6.1838798522949219e+01 1.2272899627685547e+01 7.6358799934387207e+00 -6.2593101501464844e+01 1.1978600502014160e+01 8.3717203140258789e+00 -6.3545398712158203e+01 1.0006099700927734e+01 6.3585700988769531e+00 -6.2917201995849609e+01 1.0279500007629395e+01 6.5945401191711426e+00 -6.4087898254394531e+01 1.0062999725341797e+01 6.9385199546813965e+00 -6.3364795684814453e+01 1.0512000083923340e+01 7.5604901313781738e+00 -6.2347198486328125e+01 1.0855699539184570e+01 7.0596799850463867e+00 -6.1525798797607422e+01 1.1299500465393066e+01 6.3326201438903809e+00 -6.1499397277832031e+01 1.1783800125122070e+01 6.7678098678588867e+00 -6.1221202850341797e+01 1.2550399780273438e+01 6.6556100845336914e+00 -6.6212104797363281e+01 1.0403900146484375e+01 8.0452194213867188e+00 -6.6002197265625000e+01 1.0354200363159180e+01 7.3951301574707031e+00 -6.1782299041748047e+01 1.0559800148010254e+01 5.2923297882080078e+00 -6.0674999237060547e+01 1.2354599952697754e+01 5.2776899337768555e+00 -6.1002899169921875e+01 1.1452499389648438e+01 5.1973299980163574e+00 -6.2865303039550781e+01 1.8152999877929688e+01 9.2703104019165039e+00 -6.3542903900146484e+01 1.9026599884033203e+01 9.5700607299804688e+00 -6.3911899566650391e+01 1.8160499572753906e+01 1.0083099365234375e+01 -6.4932998657226562e+01 1.9028398513793945e+01 1.0438500404357910e+01 -6.5083602905273438e+01 1.8163599014282227e+01 1.0737700462341309e+01 -6.8084594726562500e+01 1.8238901138305664e+01 1.1481900215148926e+01 -6.6696098327636719e+01 1.9317298889160156e+01 1.0944100379943848e+01 -6.8112800598144531e+01 1.9189100265502930e+01 1.1208999633789062e+01 -6.6610595703125000e+01 1.8187299728393555e+01 1.1270100593566895e+01 -6.2587501525878906e+01 1.9317298889160156e+01 8.5163793563842773e+00 -6.4965301513671875e+01 1.9671701431274414e+01 1.0067800521850586e+01 -6.4137504577636719e+01 2.0114099502563477e+01 9.0809097290039062e+00 -6.8143798828125000e+01 1.9980400085449219e+01 1.0664299964904785e+01 -6.7360702514648438e+01 2.0325500488281250e+01 1.0215700149536133e+01 -6.2951496124267578e+01 2.0212200164794922e+01 7.8240799903869629e+00 -6.3676296234130859e+01 2.0879798889160156e+01 6.3429899215698242e+00 -6.7528594970703125e+01 2.0886798858642578e+01 8.7112894058227539e+00 -6.5104995727539062e+01 2.0866199493408203e+01 7.9224696159362793e+00 -6.3572601318359375e+01 2.0637199401855469e+01 7.5048704147338867e+00 -6.2261699676513672e+01 2.0642299652099609e+01 5.2907700538635254e+00 -6.5791603088378906e+01 2.0477001190185547e+01 9.4930295944213867e+00 -6.7668601989746094e+01 2.0770900726318359e+01 9.3475894927978516e+00 -6.4894996643066406e+01 2.0623199462890625e+01 8.6585197448730469e+00 -6.0366298675537109e+01 1.8139200210571289e+01 5.0881099700927734e+00 -6.0722499847412109e+01 1.8731399536132812e+01 5.8447499275207520e+00 -6.1084197998046875e+01 1.9590000152587891e+01 5.7146601676940918e+00 -6.1696899414062500e+01 2.0292400360107422e+01 5.4823598861694336e+00 -6.1519702911376953e+01 1.9022199630737305e+01 7.2866196632385254e+00 -6.0968997955322266e+01 1.8159299850463867e+01 6.7200498580932617e+00 -6.1844501495361328e+01 1.9715000152587891e+01 7.0786099433898926e+00 -6.1798400878906250e+01 1.8179298400878906e+01 8.0919799804687500e+00 -9.4956199645996094e+01 1.9852399826049805e+01 9.5523796081542969e+00 -9.4453796386718750e+01 2.0476699829101562e+01 8.9710702896118164e+00 -9.5729797363281250e+01 1.8588001251220703e+01 9.4496603012084961e+00 -9.5338096618652344e+01 1.9318201065063477e+01 9.6174697875976562e+00 -9.5275199890136719e+01 1.8673000335693359e+01 1.0142399787902832e+01 -9.3161399841308594e+01 2.0778799057006836e+01 9.3056592941284180e+00 -9.3839492797851562e+01 2.0395500183105469e+01 9.8352499008178711e+00 -9.4051506042480469e+01 1.9846000671386719e+01 1.0406599998474121e+01 -9.3038200378417969e+01 1.9844099044799805e+01 1.0789899826049805e+01 -9.2919799804687500e+01 2.0447200775146484e+01 1.0065799713134766e+01 -9.5639495849609375e+01 1.7997301101684570e+01 9.8040399551391602e+00 -9.4895103454589844e+01 1.8177099227905273e+01 1.0668899536132812e+01 -9.3024902343750000e+01 1.8078800201416016e+01 1.1482800483703613e+01 -9.2970001220703125e+01 1.8775999069213867e+01 1.1366900444030762e+01 -9.3774696350097656e+01 1.8176700592041016e+01 1.1310899734497070e+01 -9.4405502319335938e+01 1.8309900283813477e+01 1.1005100250244141e+01 -9.3781997680664062e+01 1.9160699844360352e+01 1.1028399467468262e+01 -9.4629699707031250e+01 1.9244899749755859e+01 1.0483499526977539e+01 -6.7091796875000000e+01 1.0387100219726562e+01 -8.2227993011474609e+00 -6.8684898376464844e+01 1.0267600059509277e+01 -9.1260995864868164e+00 -6.6537399291992188e+01 1.0284700393676758e+01 -7.5106997489929199e+00 -6.6952499389648438e+01 1.0204899787902832e+01 -8.2621393203735352e+00 -6.7445297241210938e+01 1.0284399986267090e+01 -8.6767597198486328e+00 -6.8003402709960938e+01 1.0204400062561035e+01 -9.0006399154663086e+00 -9.4780799865722656e+01 1.0342499732971191e+01 -9.0948200225830078e+00 -9.5615997314453125e+01 7.4379100799560547e+00 -9.1500005722045898e+00 -9.5754699707031250e+01 9.3954296112060547e+00 -9.1500005722045898e+00 -9.9812004089355469e+01 -3.8179500102996826e+00 -9.1500005722045898e+00 -9.7460502624511719e+01 -3.4211501479148865e-01 -9.1500005722045898e+00 -9.6030395507812500e+01 3.6031599044799805e+00 -9.1500005722045898e+00 -1.0294199371337891e+02 -6.6133403778076172e+00 -9.1500005722045898e+00 -1.0354500579833984e+02 -7.0583600997924805e+00 9.1500005722045898e+00 -9.5741798400878906e+01 9.4041604995727539e+00 9.1500005722045898e+00 -9.5690200805664062e+01 5.6777200698852539e+00 9.1500005722045898e+00 -9.6326698303222656e+01 2.5946600437164307e+00 9.1500005722045898e+00 -9.7460502624511719e+01 -3.4211501479148865e-01 9.1500005722045898e+00 -9.9812004089355469e+01 -3.8179500102996826e+00 9.1500005722045898e+00 -9.4780197143554688e+01 1.0343600273132324e+01 9.0943698883056641e+00 -9.5914100646972656e+01 1.2885900497436523e+01 8.1875104904174805e+00 -9.2767204284667969e+01 1.0443500518798828e+01 -8.9088096618652344e+00 -9.3540496826171875e+01 1.0453800201416016e+01 -8.3829898834228516e+00 -9.2991600036621094e+01 1.0611999511718750e+01 -9.4347295761108398e+00 -9.3684799194335938e+01 1.0865900039672852e+01 -9.6164999008178711e+00 -9.3108398437500000e+01 1.0393699645996094e+01 -7.8538393974304199e+00 -9.2875503540039062e+01 1.1119400024414062e+01 -1.0302600860595703e+01 -9.3976898193359375e+01 1.1336700439453125e+01 -1.0092399597167969e+01 -9.4118400573730469e+01 1.1921799659729004e+01 -1.0509799957275391e+01 -9.2803398132324219e+01 1.2278599739074707e+01 -1.1129500389099121e+01 -9.4789199829101562e+01 1.1336400032043457e+01 -9.2163696289062500e+00 -9.4345397949218750e+01 1.0851400375366211e+01 -8.8078298568725586e+00 -9.5200096130371094e+01 1.1399000167846680e+01 -8.2679204940795898e+00 -9.5081802368164062e+01 1.2056799888610840e+01 -9.7091798782348633e+00 -9.5445701599121094e+01 1.1953700065612793e+01 -8.8719797134399414e+00 -9.5723701477050781e+01 1.2212299346923828e+01 -8.0698595046997070e+00 -9.4766296386718750e+01 1.2548900604248047e+01 -1.0349299430847168e+01 -9.4426605224609375e+01 1.0768700599670410e+01 -8.1309795379638672e+00 -9.2969200134277344e+01 1.1712499618530273e+01 -1.0805199623107910e+01 -6.7538795471191406e+01 1.1655799865722656e+01 -1.0740300178527832e+01 -6.7675102233886719e+01 1.0599900245666504e+01 -9.4035396575927734e+00 -6.8163200378417969e+01 1.2221399307250977e+01 -1.1092700004577637e+01 -6.8055099487304688e+01 1.1065199851989746e+01 -1.0230899810791016e+01 -6.8276100158691406e+01 1.0440400123596191e+01 -8.9049005508422852e+00 -6.5624801635742188e+01 1.2907999992370605e+01 1.0718899726867676e+01 -6.5133201599121094e+01 1.2643300056457520e+01 1.0425600051879883e+01 -6.4267204284667969e+01 1.3000999450683594e+01 1.0042300224304199e+01 -6.2303199768066406e+01 1.2680799484252930e+01 8.3036804199218750e+00 -6.3390201568603516e+01 1.1651099205017090e+01 8.8691902160644531e+00 -6.4303298950195312e+01 1.1275300025939941e+01 9.1667203903198242e+00 -6.4761100769042969e+01 1.0851999282836914e+01 8.8473796844482422e+00 -6.5631797790527344e+01 1.0486500740051270e+01 8.3171300888061523e+00 -6.5605400085449219e+01 1.1897500038146973e+01 1.0314599990844727e+01 -6.4388298034667969e+01 1.2194299697875977e+01 9.8595495223999023e+00 -6.3178600311279297e+01 1.2712699890136719e+01 9.2077093124389648e+00 -6.5609100341796875e+01 1.0742199897766113e+01 8.9996404647827148e+00 -6.6827606201171875e+01 1.3214099884033203e+01 1.1109299659729004e+01 -6.8150299072265625e+01 1.2829500198364258e+01 1.1287300109863281e+01 -9.5783393859863281e+01 1.2894499778747559e+01 8.8829793930053711e+00 -9.5408401489257812e+01 1.2947400093078613e+01 9.7028608322143555e+00 -9.4762306213378906e+01 1.3247200012207031e+01 1.0475899696350098e+01 -9.4044403076171875e+01 1.2914200782775879e+01 1.0944300651550293e+01 -9.3054199218750000e+01 1.2910599708557129e+01 1.1280300140380859e+01 -6.8154998779296875e+01 1.0390000343322754e+01 -8.9144802093505859e+00 -9.5694496154785156e+01 1.2157899856567383e+01 8.2170896530151367e+00 -9.5115501403808594e+01 1.1302899360656738e+01 8.2818202972412109e+00 -9.4288604736328125e+01 1.0711600303649902e+01 8.3680400848388672e+00 -9.3305107116699219e+01 1.0405999183654785e+01 8.3051605224609375e+00 -6.6861396789550781e+01 1.1230699539184570e+01 1.0218200683593750e+01 -6.7718498229980469e+01 1.0555000305175781e+01 9.3031597137451172e+00 -6.6954704284667969e+01 1.2355299949645996e+01 1.0972000122070312e+01 -6.8097000122070312e+01 1.1831899642944336e+01 1.0898099899291992e+01 -6.8167404174804688e+01 1.1026800155639648e+01 1.0180800437927246e+01 -9.3028099060058594e+01 1.0487699508666992e+01 9.0319404602050781e+00 -9.4236503601074219e+01 1.0865900039672852e+01 9.0648107528686523e+00 -9.4712402343750000e+01 1.1336700439453125e+01 9.3568792343139648e+00 -9.4869003295898438e+01 1.1888800621032715e+01 9.8110904693603516e+00 -9.5405403137207031e+01 1.1966600418090820e+01 8.9950094223022461e+00 -9.2892494201660156e+01 1.1598400115966797e+01 1.0732900619506836e+01 -9.3836395263671875e+01 1.1336400032043457e+01 1.0169199943542480e+01 -9.2781700134277344e+01 1.1079999923706055e+01 1.0256199836730957e+01 -9.3148902893066406e+01 1.0728499412536621e+01 9.6660299301147461e+00 -9.4224105834960938e+01 1.2082500457763672e+01 1.0541100502014160e+01 -9.3492004394531250e+01 1.1953700065612793e+01 1.0825699806213379e+01 -9.2700401306152344e+01 1.2215199470520020e+01 1.1101500511169434e+01 -9.4969200134277344e+01 1.2548900604248047e+01 1.0146300315856934e+01 -9.4030799865722656e+01 -1.4237500190734863e+01 8.9692401885986328e+00 -9.3823699951171875e+01 -1.4584000587463379e+01 8.7680501937866211e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01) (float-vector -9.2621602118015289e+01 2.0890800282359123e+01 -8.6935600265860558e+00) (float-vector -9.5581099390983582e+01 1.9595699384808540e+01 8.4367999807000160e+00) (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00) (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00) (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1622299998998642e+02 -1.1383400298655033e+01 -6.2500000931322575e+00) (float-vector -1.1537700146436691e+02 -1.8636500462889671e+01 -6.2500000931322575e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01) (float-vector -9.2880301177501678e+01 1.8248299136757851e+01 -1.1486600153148174e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1696799844503403e+02 -1.4067200012505054e+01 6.2500000931322575e+00) (float-vector -9.2969998717308044e+01 1.8775999546051025e+01 1.1366900056600571e+01) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00) (float-vector -6.8101897835731506e+01 5.8599398471415043e+00 -8.1459200009703636e+00) (float-vector -1.0652100294828415e+02 -2.3850899189710617e+01 -7.2211800143122673e+00) (float-vector -1.0798899829387665e+02 -2.3176899179816246e+01 8.2606999203562737e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00) (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00) (float-vector -6.7447900772094727e+01 1.9895900040864944e+01 -1.0701199993491173e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.7335300147533417e+01 6.0413298197090626e+00 7.2416001930832863e+00) (float-vector -6.5791599452495575e+01 2.0477000623941422e+01 9.4930296763777733e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0674998909235001e+01 1.2354600243270397e+01 5.2776900120079517e+00) (float-vector -6.0722500085830688e+01 1.8731400370597839e+01 5.8447499759495258e+00) (float-vector -6.0145601630210876e+01 1.8248099833726883e+01 -3.5796300508081913e+00) (float-vector -6.1640899628400803e+01 1.0425000451505184e+01 -3.9616897702217102e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_gripper_r_finger_tip_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_shoulder_lift_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.0000000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 200 100 0 100 1 0 2 200 0 100 70 1 1 70 369 2 1 361 369 361 1 99 70 100 99 100 117 217 117 100 100 200 217 343 99 117 217 258 117 117 258 343 105 342 343 343 338 340 99 343 340 342 356 343 343 356 338 343 258 408 408 106 343 105 343 106 338 339 340 340 442 99 442 340 339 339 441 442 442 223 225 442 446 223 99 442 225 441 446 442 225 451 99 99 451 70 223 224 225 258 225 224 225 258 424 451 225 424 330 224 223 330 223 446 312 224 330 312 258 224 311 258 312 258 311 408 217 424 258 216 424 217 424 216 191 451 424 191 49 216 217 217 200 85 84 217 85 49 217 84 49 192 216 191 216 192 191 192 193 48 359 192 48 192 49 280 192 359 193 192 280 166 193 280 166 295 193 295 414 193 414 191 193 359 166 280 359 91 360 359 48 91 360 166 359 2 166 167 166 2 295 167 166 360 360 233 289 91 233 360 167 360 289 91 48 50 110 91 50 233 91 110 289 233 290 341 290 233 233 110 341 156 110 50 156 157 110 157 341 110 156 406 157 50 406 156 406 341 157 406 50 407 407 341 406 399 407 390 341 407 399 391 407 98 98 407 50 390 407 391 341 399 400 400 399 418 390 484 399 418 399 484 390 391 175 390 175 484 391 98 97 391 97 175 50 97 98 49 97 50 175 97 372 84 97 49 97 279 372 279 97 84 48 49 50 83 84 85 279 84 405 405 84 83 278 146 279 279 146 372 279 405 278 153 146 278 153 278 405 405 484 175 405 83 418 153 405 175 484 405 418 153 154 155 154 153 175 155 152 153 153 152 146 155 154 331 154 175 331 331 175 332 140 332 175 140 175 372 332 155 331 145 155 332 152 155 145 152 141 146 145 141 152 140 139 145 140 145 332 139 141 145 139 140 141 140 146 141 140 372 146 418 83 419 302 400 418 419 302 418 85 301 83 419 83 303 83 301 303 303 302 419 301 302 303 341 302 290 400 302 341 301 290 302 85 289 301 289 290 301 200 289 85 200 167 289 200 2 167 2 361 295 361 362 363 361 402 362 295 361 363 369 402 361 363 414 295 438 414 363 438 363 362 438 439 414 414 439 191 305 439 438 362 490 438 490 305 438 451 439 305 191 439 451 305 307 451 70 451 307 305 306 307 378 71 307 468 378 307 307 306 468 307 71 70 69 70 71 69 369 70 71 364 69 378 364 71 364 378 379 387 69 364 387 364 379 386 170 387 387 170 287 386 387 379 287 69 387 168 170 386 168 386 379 168 169 170 168 379 4 4 174 168 174 169 168 173 169 174 170 169 173 226 173 174 174 4 226 3 4 5 4 3 7 4 379 5 226 4 7 173 226 7 6 170 173 7 6 173 6 7 8 3 8 7 6 8 3 5 6 3 379 6 5 378 6 379 6 378 170 286 287 170 468 286 170 378 468 170 368 423 286 423 287 286 368 286 468 287 423 416 69 287 416 416 423 472 368 472 423 69 416 417 417 416 434 434 416 472 69 402 369 487 486 69 402 69 486 69 417 487 487 417 434 486 487 488 488 487 434 434 382 469 472 382 434 469 488 434 472 368 382 305 367 368 368 367 382 306 305 368 368 468 306 367 305 383 383 305 490 382 367 383 362 382 383 362 383 490 402 382 362 382 402 403 403 402 486 382 403 469 469 403 486 469 486 488 408 311 445 408 445 443 408 443 106 445 311 312 445 312 330 445 330 444 443 445 444 352 443 444 352 106 443 446 447 444 447 352 444 444 330 446 339 106 352 339 352 447 441 447 446 339 447 441 221 339 338 339 221 106 106 221 104 338 461 221 221 461 104 356 342 338 208 338 342 461 338 208 437 461 321 461 208 321 461 179 104 179 461 437 104 105 106 105 104 179 199 105 179 199 179 206 437 323 179 179 323 206 321 323 437 321 322 323 323 232 206 323 429 232 429 323 322 206 207 208 206 232 207 199 206 208 208 342 199 105 199 342 321 208 207 207 232 242 244 207 242 244 321 207 321 243 401 401 429 321 244 243 321 321 429 322 243 244 245 288 245 244 288 244 425 242 425 244 242 232 425 232 231 425 231 288 425 463 245 288 231 463 288 463 52 245 52 63 245 63 243 245 231 462 463 462 52 463 230 231 232 230 462 231 429 230 232 230 429 401 230 320 291 401 320 230 65 230 63 230 65 462 230 291 63 320 243 291 401 243 320 291 243 63 63 64 65 64 63 46 46 63 47 47 63 52 459 64 46 64 459 108 64 108 65 459 46 241 241 10 459 459 33 108 10 33 459 241 46 11 10 241 11 9 10 11 9 448 10 448 33 10 11 46 45 45 9 11 9 40 39 51 448 9 9 39 51 40 9 45 51 33 448 51 39 52 33 51 52 39 40 41 47 39 41 39 47 52 45 41 40 45 46 47 45 47 41 52 462 33 65 34 462 462 34 33 33 34 35 108 33 35 433 35 34 433 435 35 309 35 435 108 35 309 107 108 109 109 108 309 65 108 485 485 108 107 347 431 309 435 347 309 309 431 109 347 435 433 347 433 346 34 346 433 346 235 347 235 432 347 347 432 431 431 432 75 431 485 107 109 431 107 431 75 485 75 65 485 34 75 76 131 75 432 65 75 34 76 75 131 131 432 497 497 432 235 80 131 81 131 308 81 76 131 80 131 497 308 497 235 265 497 265 308 308 73 72 265 73 308 72 81 308 80 81 82 81 72 82 72 73 74 236 72 375 236 82 72 375 72 74 264 304 73 264 73 265 304 74 73 344 74 304 344 375 74 236 375 234 264 375 344 436 375 264 375 436 234 263 264 265 304 264 344 436 264 263 235 436 263 235 234 436 76 234 235 236 234 237 234 76 237 235 263 265 346 76 235 76 80 237 34 76 346 237 269 240 237 80 269 236 237 240 316 80 129 269 80 316 129 80 82 315 316 317 394 316 315 316 394 269 316 129 317 82 128 129 129 128 317 236 128 82 236 240 239 236 239 128 128 176 317 239 176 128 315 317 176 394 315 176 270 394 247 394 270 269 394 176 178 394 178 247 176 177 178 318 176 239 177 176 318 178 246 247 177 246 178 389 247 246 270 247 470 470 247 389 395 246 177 395 389 246 420 177 318 420 395 177 409 410 395 409 395 420 68 395 410 68 389 395 420 318 421 409 420 491 470 491 420 420 421 470 270 470 421 421 318 270 269 270 271 271 270 318 269 319 238 319 269 271 238 240 269 318 319 271 318 239 319 238 319 239 238 239 240 470 389 336 470 336 491 389 67 336 67 389 68 66 67 68 67 66 133 67 133 336 410 66 68 410 493 66 493 133 66 479 480 410 479 410 409 410 480 493 480 133 493 427 480 428 371 480 427 480 479 428 371 133 480 494 132 479 479 409 494 132 428 479 491 492 409 337 494 409 492 337 409 494 337 132 336 132 337 336 337 492 491 336 492 336 133 132 132 133 134 134 133 371 427 134 371 132 134 92 92 134 328 326 134 427 134 326 328 326 327 328 327 92 328 351 215 326 326 215 327 326 427 351 94 427 428 427 94 351 94 215 351 114 215 94 327 215 313 215 116 313 116 215 114 93 92 327 313 93 327 313 165 93 313 116 165 163 164 165 165 116 59 59 388 165 165 164 93 163 165 257 257 165 388 252 93 164 163 15 164 15 252 164 251 185 252 115 114 252 252 181 354 252 185 115 93 252 114 15 181 252 251 252 354 114 115 116 93 114 94 92 93 94 92 94 329 94 428 329 132 92 329 132 329 428 458 116 404 115 404 116 458 59 116 204 115 205 115 185 205 204 404 115 415 298 204 204 54 404 415 204 205 298 54 204 187 186 205 205 186 415 185 187 205 185 186 187 186 185 251 251 78 186 186 370 392 392 415 186 78 370 186 182 251 354 79 251 182 78 251 79 77 78 79 77 267 78 267 370 78 392 370 393 370 267 393 392 393 38 415 392 38 36 38 393 393 267 36 36 37 38 267 37 36 60 267 77 37 267 62 62 267 60 37 374 210 37 210 38 374 37 62 60 61 62 373 374 62 474 62 61 62 474 373 374 373 411 374 411 456 374 456 210 373 118 111 450 373 474 450 118 373 373 111 411 474 61 365 474 457 450 365 457 474 449 248 450 457 449 450 467 118 450 450 248 467 385 384 457 385 457 366 457 365 366 457 384 449 365 260 366 260 365 61 212 366 262 385 366 212 260 262 366 212 384 385 26 25 212 26 212 476 412 384 212 476 212 498 299 300 212 483 212 300 498 212 262 25 299 212 412 212 483 498 261 476 26 476 284 261 284 476 262 261 498 260 261 262 358 136 261 136 284 261 261 260 358 357 358 260 136 358 460 460 358 357 135 86 136 135 136 102 136 86 284 102 136 460 87 86 135 87 135 102 13 86 87 86 159 284 159 86 13 266 87 102 266 13 87 101 102 103 101 266 102 103 102 460 16 266 180 14 13 266 180 266 101 266 16 14 17 180 181 180 101 181 180 17 16 15 16 17 15 17 181 14 16 53 53 16 32 16 15 32 12 13 14 12 14 53 53 32 31 501 12 53 31 501 53 30 31 32 15 314 32 32 314 30 314 15 163 163 142 314 314 142 30 142 283 30 283 31 30 142 143 144 257 143 142 142 144 283 163 257 142 283 253 31 283 144 253 159 158 253 254 253 277 254 159 253 228 277 253 144 228 253 31 253 158 158 159 13 159 254 284 158 501 31 158 13 501 13 12 501 284 130 26 284 254 29 284 29 130 24 25 26 345 138 26 26 130 345 26 138 24 137 24 138 24 137 25 299 25 43 25 137 43 137 345 43 137 138 345 345 130 198 465 345 198 465 477 345 477 43 345 130 197 198 197 465 198 454 465 353 471 465 454 477 465 471 465 197 353 43 477 44 44 477 464 477 471 464 471 454 464 44 464 95 453 464 454 464 453 95 42 43 44 95 96 44 44 96 42 42 482 43 42 96 482 426 195 43 426 43 482 43 195 299 495 426 482 482 96 201 201 495 482 397 426 495 495 201 397 196 195 426 426 335 196 335 426 397 397 203 398 201 203 397 398 335 397 201 202 203 201 478 202 96 478 201 203 202 285 285 202 478 478 96 190 190 143 478 143 285 478 190 96 95 95 143 190 259 143 95 143 257 285 143 259 144 388 203 285 257 388 285 203 388 58 59 58 388 203 273 398 58 273 203 57 58 59 58 272 273 57 496 58 496 272 58 57 59 458 376 57 377 57 458 452 376 496 57 57 452 377 348 458 404 350 458 348 452 458 350 377 452 220 452 350 220 220 333 377 333 376 377 333 496 376 333 222 162 334 333 162 222 333 220 333 334 499 333 499 496 219 222 220 219 162 222 218 219 220 219 218 276 249 219 276 219 160 162 219 249 160 274 276 218 274 218 220 274 275 276 350 349 274 350 274 220 275 274 349 55 275 56 276 275 455 455 275 55 56 275 349 348 349 350 54 349 404 404 349 348 56 349 54 54 55 56 54 298 209 54 209 500 55 54 500 209 210 211 209 298 210 209 211 500 310 500 21 21 500 211 500 324 55 324 500 310 310 21 255 324 310 325 489 325 310 489 310 255 297 324 325 297 55 324 296 55 297 296 455 55 250 296 297 325 250 297 489 250 325 489 256 250 489 255 256 255 21 256 213 118 256 213 256 21 118 467 256 467 250 256 248 249 250 250 249 296 248 250 467 449 249 248 449 160 249 276 296 249 384 160 449 160 161 162 160 384 413 161 160 413 412 413 384 422 413 412 396 161 413 396 413 422 162 161 396 334 162 396 300 194 396 300 396 483 396 194 334 483 396 422 412 483 422 334 196 335 196 334 194 335 499 334 194 195 196 195 194 300 299 195 300 496 499 273 499 335 273 398 273 335 272 496 273 276 455 296 112 118 119 118 213 214 430 119 118 111 118 112 214 430 118 292 293 119 430 292 119 119 293 112 292 430 214 214 121 292 211 293 292 121 22 292 292 21 211 22 21 292 112 293 113 293 211 113 211 210 113 111 112 113 456 111 113 456 113 210 298 20 210 210 19 38 210 20 19 298 18 20 298 415 281 298 281 18 18 19 20 19 281 38 19 18 281 38 281 415 411 111 456 21 22 23 213 21 23 23 22 123 120 22 121 123 22 120 23 123 122 124 23 122 213 23 124 213 227 214 172 227 213 213 124 172 171 172 124 122 171 124 120 121 122 171 122 121 122 123 120 171 121 214 171 214 227 227 172 171 28 144 282 229 144 28 229 228 144 259 282 144 27 228 229 28 27 229 228 27 254 473 228 254 481 228 473 228 481 277 27 28 29 254 27 29 473 254 277 473 277 481 29 28 89 130 29 89 88 89 90 88 130 89 28 282 89 89 282 90 197 130 353 353 130 88 466 454 353 466 353 88 88 381 466 381 454 466 380 453 454 454 381 380 380 381 88 440 259 380 380 259 453 148 380 88 148 440 380 259 95 453 282 259 440 148 282 440 294 282 150 282 294 90 148 150 282 150 147 151 147 150 148 188 294 150 188 150 151 147 148 149 151 147 189 189 147 149 188 151 189 126 188 189 125 188 126 294 188 125 189 149 148 126 189 148 125 126 127 127 126 148 127 294 125 88 294 127 127 148 88 90 294 88 181 101 354 355 354 101 355 101 103 268 354 355 268 182 354 183 268 355 183 355 103 183 182 268 182 183 184 79 182 103 182 184 103 460 77 103 77 79 103 184 183 103 460 260 60 460 357 260 60 77 460 475 60 260 475 260 61 475 61 60))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(2.3470200598239899e-01 1.0800000280141830e-01 -7.3000000000000000e+01 1.2431000471115112e+00 -1.5290900230407715e+01 -7.1712203979492188e+01 2.1000000000000000e+01 1.0800000280141830e-01 -7.3000000000000000e+01 1.8000000000000000e+01 -7.4599105834960938e+01 -1.7263500213623047e+01 1.8000000000000000e+01 -7.3891998291015625e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -1.7970600128173828e+01 2.1000000000000000e+01 -7.4891998291015625e+01 -1.7970600128173828e+01 2.1000000000000000e+01 -7.3891998291015625e+01 -1.6970598220825195e+01 2.1000000000000000e+01 -7.4599105834960938e+01 -1.7263500213623047e+01 -1.9498999023437500e+02 -7.4120796203613281e+01 -7.9705703735351562e+01 -1.9616200256347656e+02 -7.3917701721191406e+01 -8.0641906738281250e+01 -1.9728800964355469e+02 -7.4120796203613281e+01 -8.1634002685546875e+01 4.6470003128051758e+00 4.0496799468994141e+01 7.8790199279785156e+01 7.9735097885131836e+00 3.4166801452636719e+01 8.6842597961425781e+01 2.8803999423980713e+00 2.8202899932861328e+01 9.4235298156738281e+01 -3.2177501678466797e+01 2.3207599639892578e+01 1.0380799865722656e+02 -2.8348999023437500e+01 1.8307600021362305e+01 1.0466899871826172e+02 -2.9548099517822266e+01 1.7663799285888672e+01 1.0527899932861328e+02 -8.0203896760940552e-01 -4.8946998596191406e+01 7.4402694702148438e+01 7.3230397701263428e-01 -4.9362598419189453e+01 7.2409797668457031e+01 4.4030100107192993e-01 -5.0143600463867188e+01 7.2716896057128906e+01 2.1000000000000000e+01 -7.4891998291015625e+01 2.9799299240112305e+01 2.1000000000000000e+01 -7.4891998291015625e+01 1.7970600128173828e+01 2.1000000000000000e+01 -7.3891998291015625e+01 1.6970598220825195e+01 2.1000000000000000e+01 4.4702800750732422e+01 6.1597599029541016e+01 2.1000200271606445e+01 3.8596000671386719e+01 6.8976600646972656e+01 2.1000000000000000e+01 4.4833297729492188e+01 5.7956199645996094e+01 1.4506999969482422e+01 6.0928501129150391e+01 4.7579696655273438e+01 1.7152000427246094e+01 6.2820201873779297e+01 3.8687198638916016e+01 1.6707500457763672e+01 5.7793098449707031e+01 4.4737300872802734e+01 -4.7689599990844727e+00 4.5441398620605469e+01 7.9416900634765625e+01 2.1049001216888428e+00 4.7077598571777344e+01 7.1995697021484375e+01 -1.5595499992370605e+01 3.1022298812866211e+01 9.2373397827148438e+01 -1.9510099792480469e+02 -7.3742393493652344e+01 -7.9572898864746094e+01 -2.0812100219726562e+02 7.5106399536132812e+01 -6.1163398742675781e+01 -2.0226800537109375e+02 -6.3592903137207031e+01 -7.0246200561523438e+01 7.0341000556945801e+00 -4.5464500427246094e+01 7.1164604187011719e+01 1.3447500228881836e+01 -5.3169197082519531e+01 5.6213901519775391e+01 2.0333998203277588e+00 -4.7228702545166016e+01 7.1934898376464844e+01 -1.9466699218750000e+02 -7.4891998291015625e+01 -8.0087997436523438e+01 -1.9498999023437500e+02 -7.4391998291015625e+01 -7.9705703735351562e+01 -1.9489500427246094e+02 -7.4745605468750000e+01 -7.9817802429199219e+01 1.2373399734497070e+01 5.2909297943115234e+01 6.5194198608398438e+01 1.9679698944091797e+01 4.8820098876953125e+01 6.3869297027587891e+01 1.6655000686645508e+01 5.9379802703857422e+01 5.4137599945068359e+01 -1.9728800964355469e+02 -7.4391998291015625e+01 -8.1634002685546875e+01 -1.9603300476074219e+02 -7.2734497070312500e+01 -8.3106201171875000e+01 -1.9696499633789062e+02 -7.4891998291015625e+01 -8.2016403198242188e+01 1.1818599700927734e+01 4.9144802093505859e+01 -6.0318897247314453e+01 1.7103899002075195e+01 7.5108001708984375e+01 -4.9149497985839844e+01 1.7103899002075195e+01 6.1016498565673828e+01 -4.9149597167968750e+01 -1.9335499572753906e+02 -7.4470993041992188e+01 -8.1614006042480469e+01 -1.8936500549316406e+02 -7.4891998291015625e+01 -8.6000602722167969e+01 -8.0966205596923828e+00 3.3492099761962891e+01 8.8121398925781250e+01 -4.4254798889160156e+00 -7.4892105102539062e+01 8.4284797668457031e+01 9.1557998657226562e+00 -5.6802997589111328e+01 6.5280601501464844e+01 -2.3937900066375732e+00 -4.5289299011230469e+01 8.1252899169921875e+01 -4.5447902679443359e+01 1.0800000280141830e-01 1.1510100555419922e+02 -3.3992397308349609e+01 1.6715000152587891e+01 1.0987500000000000e+02 -4.7113700866699219e+01 1.0757499933242798e-01 1.1546500396728516e+02 1.7299798965454102e+01 -1.2469900131225586e+01 9.7201194763183594e+01 1.8000000000000000e+01 -2.6923999786376953e+01 7.4437698364257812e+01 1.6142898559570312e+01 -3.7781799316406250e+01 7.3245506286621094e+01 -1.8971400451660156e+02 -7.4891700744628906e+01 -9.0005706787109375e+01 -1.9672801208496094e+02 -3.1246900558471680e+01 -8.2407104492187500e+01 -1.9633898925781250e+02 7.5105697631835938e+01 -8.3057899475097656e+01 -1.5879200744628906e+02 -1.0485199689865112e+00 1.1271399688720703e+02 -1.6432400512695312e+02 7.5107299804687500e+01 1.0962100219726562e+02 -1.7501899719238281e+02 -2.3872101306915283e+00 1.0262899780273438e+02 1.4337699890136719e+01 -5.4901996612548828e+01 -4.7988498687744141e+01 2.2154002189636230e+00 -7.4891899108886719e+01 -7.1059600830078125e+01 1.4337699890136719e+01 -7.4891998291015625e+01 -4.7988498687744141e+01 -2.2543499755859375e+02 -7.4891403198242188e+01 -2.1152601242065430e+01 -2.2267300415039062e+02 -7.3891998291015625e+01 -3.2869998931884766e+01 -2.2292800903320312e+02 -7.4891998291015625e+01 -3.1903099060058594e+01 -2.1504299926757812e+02 7.5107002258300781e+01 -5.4824199676513672e+01 -2.2160301208496094e+02 7.5104598999023438e+01 -2.5158201217651367e+01 1.0121800422668457e+01 -1.6533498764038086e+01 1.0342200469970703e+02 2.5580999851226807e+00 -1.8091600418090820e+01 1.0466899871826172e+02 2.5001001358032227e+00 -1.0140899658203125e+01 1.0999600219726562e+02 -2.2709100341796875e+02 7.5107704162597656e+01 1.7232200130820274e-02 -2.2685499572753906e+02 -1.0918499946594238e+01 -8.0426397323608398e+00 -2.2702400207519531e+02 -7.4892105102539062e+01 3.7199800014495850e+00 1.4337699890136719e+01 5.5118000030517578e+01 -4.7988498687744141e+01 1.4337699890136719e+01 7.5108001708984375e+01 -4.7988498687744141e+01 1.0165399551391602e+01 4.5933700561523438e+01 -5.7064899444580078e+01 1.4968899726867676e+01 3.2673599243164062e+01 8.1433898925781250e+01 1.3642299652099609e+01 1.4999800682067871e+01 1.0129499816894531e+02 2.1000000000000000e+01 6.8942596435546875e+01 2.4304300308227539e+01 1.7520200729370117e+01 6.3328899383544922e+01 3.6498199462890625e+01 1.8000000000000000e+01 6.6748794555664062e+01 2.9799299240112305e+01 1.8000000000000000e+01 5.5078300476074219e+01 -5.2481098175048828e+01 -1.0000000000000000e+02 7.5108001708984375e+01 1.2400000000000000e+02 -7.3782798767089844e+01 7.5108100891113281e+01 1.2160099792480469e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 1.2400000000000000e+02 1.3202000617980957e+01 6.0726799011230469e+01 5.7570098876953125e+01 1.0920399665832520e+01 5.4900501251220703e+01 6.3292198181152344e+01 2.1000000000000000e+01 7.5108001708984375e+01 -2.9799200057983398e+01 2.0726699829101562e+01 7.0765998840332031e+01 -3.5019599914550781e+01 -3.1190700531005859e+01 -7.4891799926757812e+01 -1.0344400024414062e+02 -9.7811002731323242e+00 6.6044199466705322e-01 -8.5328399658203125e+01 -1.4491200447082520e-01 8.3208198547363281e+00 1.1119899749755859e+02 1.0916699409484863e+01 8.6330699920654297e+00 1.0936299896240234e+02 7.2210998535156250e+00 -5.1280598640441895e+00 1.1129800415039062e+02 -8.6697898864746094e+01 7.5108200073242188e+01 -1.2636700439453125e+02 -8.1959205627441406e+01 7.5108200073242188e+01 -1.2283200073242188e+02 -6.1289100646972656e+01 7.5108604431152344e+01 -1.2114699554443359e+02 -2.0725000000000000e+02 -4.6728599548339844e+01 -6.8072799682617188e+01 -2.0499099731445312e+02 -6.2948600769042969e+01 -7.1556503295898438e+01 -2.0981500244140625e+02 -5.5135200500488281e+01 -6.3794204711914062e+01 1.8369199752807617e+01 5.6631000518798828e+01 -5.0843002319335938e+01 1.6746400833129883e+01 -5.7669097900390625e+01 4.4618499755859375e+01 1.6850000381469727e+01 -6.0251300811767578e+01 4.1101100921630859e+01 1.4337599754333496e+01 -6.0713500976562500e+01 4.7988601684570312e+01 -7.5069999694824219e+01 -7.4892105102539062e+01 1.2170399475097656e+02 -4.5905799865722656e+01 -7.4889999389648438e+01 1.1191999816894531e+02 -6.1492900848388672e+01 -7.4891098022460938e+01 1.2134500122070312e+02 -2.4414600372314453e+01 7.5108001708984375e+01 -9.8412902832031250e+01 2.1000598907470703e+01 -6.4429000854492188e+01 3.5479099273681641e+01 1.7511899948120117e+01 -6.3079902648925781e+01 3.6555397033691406e+01 1.8000000000000000e+01 -7.4599105834960938e+01 1.7263500213623047e+01 1.8000000000000000e+01 -7.4891998291015625e+01 1.7970600128173828e+01 1.8000000000000000e+01 -7.3891998291015625e+01 1.6970598220825195e+01 2.1000000000000000e+01 -7.4599105834960938e+01 1.7263500213623047e+01 2.1000000000000000e+01 -7.1676795959472656e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.1277793884277344e+01 1.7182800292968750e+01 2.1000000000000000e+01 7.1892799377441406e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.0922698974609375e+01 1.7727699279785156e+01 -2.2467300415039062e+02 -7.4891593933105469e+01 2.4523500442504883e+01 -2.2641600036621094e+02 5.3997101783752441e+00 1.2965999603271484e+01 2.0999799728393555e+01 5.8480899810791016e+01 4.4186698913574219e+01 -2.2515299987792969e+02 7.5107299804687500e+01 -2.2557399749755859e+01 -1.3277099609375000e+02 7.5105400085449219e+01 1.2005899810791016e+02 -1.4044200134277344e+02 7.5107299804687500e+01 1.2067499542236328e+02 -1.0668999481201172e+02 7.5108001708984375e+01 1.2682299041748047e+02 1.4737400054931641e+01 1.4116399765014648e+01 1.0039400482177734e+02 1.6964899063110352e+01 1.1505800247192383e+01 9.7720306396484375e+01 2.0975799560546875e+01 4.5589900970458984e+01 6.1531101226806641e+01 2.1000000000000000e+01 4.5076999664306641e+01 6.1127799987792969e+01 2.1000000000000000e+01 7.4815101623535156e+01 -1.7263500213623047e+01 2.1000000000000000e+01 7.5108001708984375e+01 -1.7970600128173828e+01 1.8000000000000000e+01 7.4815101623535156e+01 -1.7263500213623047e+01 -7.3691701889038086e+00 7.5107406616210938e+01 8.2811302185058594e+01 4.7304000854492188e+00 7.5107597351074219e+01 7.3345901489257812e+01 1.4337699890136719e+01 7.5108001708984375e+01 4.7988498687744141e+01 2.1000000000000000e+01 7.4107994079589844e+01 -1.6970598220825195e+01 1.8000000000000000e+01 7.5108001708984375e+01 -1.7970600128173828e+01 1.8000000000000000e+01 7.4815101623535156e+01 1.7263500213623047e+01 2.1000000000000000e+01 7.5108001708984375e+01 1.7970600128173828e+01 2.1000000000000000e+01 7.4815101623535156e+01 1.7263500213623047e+01 1.8000000000000000e+01 7.5108001708984375e+01 1.7970600128173828e+01 1.8000000000000000e+01 7.4107994079589844e+01 1.6970598220825195e+01 1.8000000000000000e+01 7.4107994079589844e+01 -1.6970598220825195e+01 1.8000000000000000e+01 7.0922698974609375e+01 -1.7727699279785156e+01 1.8000000000000000e+01 7.1277793884277344e+01 -1.7182800292968750e+01 1.8000000000000000e+01 7.1892799377441406e+01 -1.6970598220825195e+01 1.8862400054931641e+01 5.9060100555419922e+01 -4.8271701812744141e+01 1.8935098648071289e+01 5.9023902893066406e+01 -4.8272201538085938e+01 6.5987000465393066e+00 4.5333900451660156e+01 7.1686401367187500e+01 1.3430399894714355e+01 5.3364898681640625e+01 5.6081897735595703e+01 2.0345098495483398e+01 -2.3524801254272461e+01 9.1230300903320312e+01 1.8666301727294922e+01 -1.3005300521850586e+01 1.0204399871826172e+02 1.6864400863647461e+01 -1.4607399940490723e+01 1.0397700500488281e+02 -2.6127298355102539e+01 7.5107795715332031e+01 9.9849594116210938e+01 -4.7543899536132812e+01 7.5107299804687500e+01 1.1253400421142578e+02 -4.9926399230957031e+01 7.5107704162597656e+01 1.1721199798583984e+02 1.8804199218750000e+01 1.6510299682617188e+01 -7.4573600769042969e+01 2.1178600311279297e+01 1.8494001388549805e+01 -7.0857803344726562e+01 1.8000000000000000e+01 -7.0706703186035156e+01 -1.7727699279785156e+01 2.1000000000000000e+01 -7.1061798095703125e+01 -1.7182800292968750e+01 2.1000000000000000e+01 -7.0706703186035156e+01 -1.7727699279785156e+01 1.8000000000000000e+01 -7.1676795959472656e+01 1.6970598220825195e+01 2.1000000000000000e+01 -7.1061996459960938e+01 1.7182701110839844e+01 2.1000000000000000e+01 -7.1676795959472656e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.1061996459960938e+01 -1.7182701110839844e+01 2.1000000000000000e+01 7.0922698974609375e+01 -1.7727699279785156e+01 -2.1741299438476562e+02 -7.4885894775390625e+01 4.9223098754882812e+01 -2.0345599365234375e+02 -7.4891593933105469e+01 7.3888603210449219e+01 -2.0693899536132812e+02 -4.9084997177124023e+00 6.8771400451660156e+01 -1.0000000000000000e+02 7.5108001708984375e+01 -1.2700000762939453e+02 -1.5642400741577148e+01 1.5332799911499023e+01 1.0724499511718750e+02 -4.2853099822998047e+01 9.2921895980834961e+00 1.1059600067138672e+02 2.5006098747253418e+00 -6.5308899879455566e+00 1.1123899841308594e+02 2.5006999969482422e+00 -5.8350400924682617e+00 1.1141300201416016e+02 2.5006999969482422e+00 -6.1961998939514160e+00 1.1132500457763672e+02 -4.0223899841308594e+01 -1.5410000801086426e+01 1.0878500366210938e+02 -2.8348999023437500e+01 -1.8091600418090820e+01 1.0466899871826172e+02 -3.2152000427246094e+01 -2.2937299728393555e+01 1.0379199981689453e+02 1.8000000000000000e+01 7.1892799377441406e+01 1.6970598220825195e+01 2.1000000000000000e+01 7.4107994079589844e+01 1.6970598220825195e+01 5.3158998489379883e+00 5.3001098632812500e+01 7.1256301879882812e+01 8.5990297794342041e-01 1.0802999883890152e-01 -7.7176895141601562e+01 4.2993998527526855e+00 2.6358999252319336e+01 -7.2684402465820312e+01 3.2423999309539795e+00 1.0799900442361832e-01 -7.6000000000000000e+01 1.9115999221801758e+01 1.2767699241638184e+01 1.0111899566650391e+02 2.0015298843383789e+01 2.0527599334716797e+01 9.4154197692871094e+01 1.8644100189208984e+01 1.3296100616455078e+01 1.0179699707031250e+02 2.1000000000000000e+01 6.1279899597167969e+01 4.2324199676513672e+01 2.1000000000000000e+01 5.8731101989746094e+01 4.4977001190185547e+01 -1.0000000000000000e+02 7.5108001708984375e+01 -1.2400000000000000e+02 2.2366998195648193e+00 2.2410699844360352e+01 -7.0335800170898438e+01 1.7035000324249268e+00 4.3026397705078125e+01 8.0824195861816406e+01 -9.2202701568603516e+00 3.6778800964355469e+01 8.9871299743652344e+01 -2.8348999023437500e+01 2.0407499313354492e+01 1.0681199645996094e+02 -2.5226499557495117e+01 -7.4891899108886719e+01 9.8998100280761719e+01 -3.2177501678466797e+01 -2.2991600036621094e+01 1.0380799865722656e+02 -1.1352399444580078e+02 7.5107795715332031e+01 -1.2336699676513672e+02 -1.3004699707031250e+02 -7.4891998291015625e+01 -1.2049199676513672e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 -1.2400000000000000e+02 8.2552003860473633e+00 -7.4891799926757812e+01 6.0788600921630859e+01 7.7395000457763672e+00 -5.6370700836181641e+01 6.1729900360107422e+01 1.4337699890136719e+01 -7.4891998291015625e+01 4.7988498687744141e+01 2.1000101089477539e+01 1.9199899673461914e+01 7.1127304077148438e+01 2.1000000000000000e+01 -7.0706703186035156e+01 1.7727699279785156e+01 1.8000000000000000e+01 -7.0706703186035156e+01 1.7727699279785156e+01 -8.5987205505371094e+01 -7.4891296386718750e+01 1.2629499816894531e+02 1.0817999839782715e+00 7.5106895446777344e+01 -7.7009605407714844e+01 -1.5594899654388428e+00 7.5108001708984375e+01 -7.6054901123046875e+01 1.0055200576782227e+01 -3.9504901885986328e+01 8.5356201171875000e+01 1.4704400062561035e+01 -3.3138099670410156e+01 9.1603195190429688e+01 4.2192001342773438e+00 -2.0191600799560547e+01 1.0681199645996094e+02 -7.8046005249023438e+01 -7.4890701293945312e+01 -1.2514300537109375e+02 1.1272000312805176e+01 -1.8118999481201172e+01 1.0693599700927734e+02 -4.0971000671386719e+01 -5.5583999633789062e+01 -1.1244799804687500e+02 -3.9326400756835938e+01 -2.4054899215698242e+01 -1.1156900024414062e+02 -2.4468601226806641e+01 -7.4892402648925781e+01 -1.0244999694824219e+02 1.8000000000000000e+01 -7.1676795959472656e+01 -1.6970598220825195e+01 1.8000000000000000e+01 -7.1061798095703125e+01 1.7182800292968750e+01 1.4337599754333496e+01 6.0839599609375000e+01 4.7988601684570312e+01 1.4665599822998047e+01 6.3570499420166016e+01 4.7193298339843750e+01 -1.7139401245117188e+02 7.5105506896972656e+01 -1.0562599945068359e+02 -1.6840699768066406e+02 7.5105804443359375e+01 -1.0365899658203125e+02 -1.4018499755859375e+02 7.5108200073242188e+01 -1.1758100128173828e+02 2.0121299743652344e+01 5.4442802429199219e+01 -5.1874298095703125e+01 -2.2333900451660156e+02 3.3066600561141968e-01 -1.3463000297546387e+01 -2.1951199340820312e+02 -5.4891998291015625e+01 -3.3058403015136719e+01 -2.2434001159667969e+02 -7.4888603210449219e+01 1.2969899177551270e+00 -2.2416099548339844e+02 7.5107902526855469e+01 -1.2013800144195557e+00 -2.2045600891113281e+02 5.4221897125244141e+00 2.9790201187133789e+01 -2.1884100341796875e+02 -7.4891403198242188e+01 3.6125202178955078e+01 -2.2360299682617188e+02 -6.2022700309753418e+00 1.1924800872802734e+01 -1.9730099487304688e+02 -7.3979103088378906e+01 -8.1618301391601562e+01 -1.4337599182128906e+02 7.5013999938964844e+00 -1.1628199768066406e+02 -1.6911299133300781e+02 -7.4891899108886719e+01 -1.0705500030517578e+02 -1.5268200683593750e+02 -7.4890701293945312e+01 -1.1241500091552734e+02 -1.7421899414062500e+02 -7.4891204833984375e+01 -9.9686302185058594e+01 -1.9708601379394531e+02 -2.4027400016784668e+00 8.1963699340820312e+01 -2.0411199951171875e+02 7.5104499816894531e+01 7.3148200988769531e+01 2.1000000000000000e+01 -4.7192699432373047e+01 5.9706699371337891e+01 1.9997301101684570e+01 -5.0283901214599609e+01 6.1828399658203125e+01 2.0247499465942383e+01 -6.0854499816894531e+01 4.7096698760986328e+01 -4.1633598327636719e+01 -8.4118700027465820e+00 1.1066600036621094e+02 -4.8362800598144531e+01 1.0879299789667130e-01 1.1273699951171875e+02 7.1133999824523926e+00 5.5788597106933594e+01 6.2712295532226562e+01 1.5973400115966797e+01 5.6621101379394531e+01 4.7871997833251953e+01 2.0762599945068359e+01 -7.1411804199218750e+01 3.4666000366210938e+01 2.1000000000000000e+01 -7.3284500122070312e+01 2.9799299240112305e+01 -2.2786399841308594e+01 7.5107597351074219e+01 1.0112799835205078e+02 -2.4328300476074219e+01 7.5108299255371094e+01 -1.0229299926757812e+02 1.7103899002075195e+01 7.5108001708984375e+01 4.9149497985839844e+01 1.8000000000000000e+01 1.0800000280141830e-01 9.6601097106933594e+01 1.8002399444580078e+01 1.8926799774169922e+01 8.2105194091796875e+01 1.8000000000000000e+01 6.5922002792358398e+00 7.2711196899414062e+01 -2.1977500915527344e+02 -5.5892002105712891e+01 -3.2093601226806641e+01 -2.1977500915527344e+02 -7.3891998291015625e+01 -3.2093601226806641e+01 -2.2267300415039062e+02 -5.5892002105712891e+01 -3.2869998931884766e+01 2.5000000000000000e+00 1.8307600021362305e+01 1.0466899871826172e+02 9.3776998519897461e+00 -3.4714199066162109e+01 8.5550796508789062e+01 -1.0888500213623047e+00 -3.5304799079895020e+00 1.1184999847412109e+02 -2.1943699645996094e+02 7.5107406616210938e+01 3.6568599700927734e+01 -2.0540399169921875e+02 7.5108001708984375e+01 6.5474197387695312e+01 -2.1020401000976562e+02 1.4833799362182617e+01 5.7062099456787109e+01 2.9303998947143555e+00 1.1191800117492676e+01 1.1289899444580078e+02 3.3034000396728516e+00 1.5760001182556152e+01 1.1056800079345703e+02 -9.5387096405029297e+00 -3.3844600677490234e+01 9.2266296386718750e+01 3.0102000236511230e+00 -4.6909198760986328e+01 7.5950103759765625e+01 1.3488999366760254e+01 -5.3708999633789062e+01 6.3441997528076172e+01 1.3385499954223633e+01 5.7839900970458984e+01 5.1017601013183594e+01 1.8000000000000000e+01 7.0928405761718750e+01 -2.3759199142456055e+01 1.8000000000000000e+01 7.5108001708984375e+01 -2.9799299240112305e+01 5.5107898712158203e+00 2.1042098999023438e+01 -7.3059997558593750e+01 -5.6733798980712891e+00 -4.4396400451660156e+01 8.0489097595214844e+01 1.8000000000000000e+01 7.5108001708984375e+01 2.9799299240112305e+01 -1.5419599413871765e-01 4.9785301208496094e+01 7.3531097412109375e+01 1.7535699844360352e+01 4.9132102966308594e+01 5.4567501068115234e+01 -1.7766000747680664e+01 3.2458499908447266e+01 9.7077301025390625e+01 2.1000000000000000e+01 -6.8290893554687500e+01 -3.5028598785400391e+01 2.1000000000000000e+01 -6.6618896484375000e+01 -2.9605100631713867e+01 -1.6731298828125000e+02 -4.2762002944946289e+00 -1.0428799438476562e+02 2.1034200668334961e+01 3.9254699707031250e+01 -6.2075298309326172e+01 2.0800600051879883e+01 5.3686298370361328e+01 -5.1152099609375000e+01 -1.7693099975585938e+02 1.9977500438690186e+00 -1.0117900085449219e+02 1.8000000000000000e+01 -7.4891998291015625e+01 2.9799299240112305e+01 1.7355199813842773e+01 -6.2855102539062500e+01 3.7557899475097656e+01 1.8000000000000000e+01 7.0922698974609375e+01 1.7727699279785156e+01 1.8000000000000000e+01 1.0800000280141830e-01 -7.6000000000000000e+01 1.6974599838256836e+01 -5.9432800292968750e+01 5.3557796478271484e+01 1.8391799926757812e+01 -6.2457099914550781e+01 4.8568401336669922e+01 -5.3404603004455566e+00 -7.4891502380371094e+01 8.0632904052734375e+01 2.1000000000000000e+01 2.0144699096679688e+01 8.6661003112792969e+01 2.1000000000000000e+01 8.4600601196289062e+00 9.4622200012207031e+01 2.1000000000000000e+01 5.2908397674560547e+01 -5.0409500122070312e+01 2.0983598709106445e+01 5.5569297790527344e+01 -4.8216400146484375e+01 2.1000000000000000e+01 5.3976497650146484e+01 -4.9253200531005859e+01 -2.1985000610351562e+02 -7.4599403381347656e+01 -3.1810298919677734e+01 1.1480299949645996e+01 -4.7841400146484375e+01 -6.1011898040771484e+01 1.7103899002075195e+01 -6.0800498962402344e+01 -4.9149597167968750e+01 1.7103899002075195e+01 -7.4891998291015625e+01 -4.9149497985839844e+01 -2.2459100341796875e+02 -3.5183601379394531e+01 -2.4900398254394531e+01 -2.0748199462890625e+02 -5.5135200500488281e+01 -6.1836299896240234e+01 1.9715101242065430e+01 -6.8232299804687500e+01 4.1411102294921875e+01 -3.9335197448730469e+01 6.9081199645996094e+01 -1.1157499694824219e+02 -3.9326400756835938e+01 1.8272100448608398e+01 -1.1156900024414062e+02 -7.4844505310058594e+01 7.5108001708984375e+01 1.2459199523925781e+02 -2.1668798446655273e+01 3.2112598419189453e+01 9.6281898498535156e+01 -2.1827700805664062e+02 -1.4179999828338623e+00 4.6404201507568359e+01 -2.2446299743652344e+02 7.5106300354003906e+01 2.6909999847412109e+01 -2.2304501342773438e+02 1.7659299850463867e+01 3.1906400680541992e+01 -2.0663101196289062e+02 -7.4886100769042969e+01 6.3669197082519531e+01 -2.1613299560546875e+02 4.8294301033020020e+00 4.3676200866699219e+01 -1.6604100036621094e+02 -1.3293899536132812e+01 -1.0859500122070312e+02 -1.3236500549316406e+02 -7.4889198303222656e+01 -1.2322799682617188e+02 -1.3477600097656250e+02 4.1680402755737305e+00 -1.2219899749755859e+02 -1.2329100036621094e+02 7.5107597351074219e+01 -1.2494400024414062e+02 1.7103899002075195e+01 -6.4845504760742188e+01 4.9149700164794922e+01 1.9013999938964844e+01 -6.4074996948242188e+01 4.6009498596191406e+01 -1.0018800354003906e+02 6.8534398078918457e+00 1.2700299835205078e+02 -9.1548103332519531e+01 7.5108001708984375e+01 1.2671700286865234e+02 -1.0000000000000000e+02 7.5108001708984375e+01 1.2700000762939453e+02 -1.1133200073242188e+02 -8.5999698638916016e+00 1.2359199523925781e+02 -4.0971000671386719e+01 -1.5349600791931152e+01 -1.1244799804687500e+02 2.1000000000000000e+01 7.1277999877929688e+01 -1.7182701110839844e+01 2.1000000000000000e+01 7.1892799377441406e+01 -1.6970598220825195e+01 9.8897008895874023e+00 -5.5709900856018066e+00 1.1372399902343750e+02 1.7712200164794922e+01 4.4143300056457520e+00 1.0767900085449219e+02 1.0344699859619141e+01 1.8827398300170898e+01 1.0696599578857422e+02 -1.6409201049804688e+02 7.5108001708984375e+01 1.0632299804687500e+02 -1.5303399658203125e+02 1.7258600234985352e+01 1.1219699859619141e+02 -8.0452102661132812e+01 -7.4892204284667969e+01 -1.2281300354003906e+02 -6.0083198547363281e+01 -7.4892105102539062e+01 -1.2084500122070312e+02 -5.3797698974609375e+01 -7.4891998291015625e+01 -1.1516699981689453e+02 2.0442899703979492e+01 5.8248401641845703e+01 -4.7478900909423828e+01 -8.2821098327636719e+01 5.3875499725341797e+01 -1.2315200042724609e+02 -5.0509696960449219e+01 7.5108299255371094e+01 -1.1403299713134766e+02 -2.2002999877929688e+02 -7.4891998291015625e+01 -3.1126600265502930e+01 2.0997999191284180e+01 5.0729698181152344e+01 5.4137699127197266e+01 -2.1544801330566406e+02 1.7201700210571289e+01 -4.5611301422119141e+01 -2.0781100463867188e+02 -5.4891998291015625e+01 -6.1259700775146484e+01 -3.0536600112915039e+01 -2.2991600036621094e+01 1.0631999969482422e+02 -1.4031300544738770e+01 -3.4750900268554688e+01 9.3618698120117188e+01 -2.8348999023437500e+01 -2.0191600799560547e+01 1.0681199645996094e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 1.2700000762939453e+02 -4.4298000335693359e+01 3.1567300796508789e+01 -1.1413300323486328e+02 2.1000000000000000e+01 6.3844898223876953e+01 3.9687099456787109e+01 -4.5447902679443359e+01 1.0800000280141830e-01 1.1210100555419922e+02 2.5000000000000000e+00 1.0800000280141830e-01 1.1210100555419922e+02 -6.6079994201660156e+01 4.4925201416015625e+01 -1.1926999664306641e+02 1.8000000000000000e+01 2.5940699577331543e+00 9.6302505493164062e+01 1.8000000000000000e+01 7.4578800201416016e+00 9.3599700927734375e+01 1.0661899566650391e+01 3.8095100402832031e+01 -6.6385299682617188e+01 1.9015298843383789e+01 3.9948600769042969e+01 -6.5030403137207031e+01 2.1175001144409180e+01 -1.8278900146484375e+01 -7.0860099792480469e+01 1.8544599533081055e+01 -4.6590499877929688e+01 -6.0089900970458984e+01 1.8420700073242188e+01 -2.9401899337768555e+01 -7.0327697753906250e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -2.9799299240112305e+01 1.7999900817871094e+01 -1.4813999176025391e+01 7.1764793395996094e+01 1.8000000000000000e+01 1.0800000280141830e-01 7.3000000000000000e+01 1.8336099624633789e+01 -5.6275798797607422e+01 -5.0990802764892578e+01 1.8935199737548828e+01 -5.8807899475097656e+01 -4.8272098541259766e+01 6.6869997978210449e+00 -3.6554298400878906e+01 -6.3411304473876953e+01 3.8247900009155273e+00 -3.1292798995971680e+01 9.0722801208496094e+01 -1.2202799987792969e+02 7.7657198905944824e-01 1.2513500213623047e+02 2.1000000000000000e+01 7.5108001708984375e+01 -2.3884899139404297e+01 1.7280200958251953e+01 -5.1649101257324219e+01 5.1728199005126953e+01 1.5431200027465820e+01 -5.5689498901367188e+01 4.9959102630615234e+01 -2.2155799865722656e+02 -7.4891998291015625e+01 -2.4480899810791016e+01 2.4995999336242676e+00 1.0800000280141830e-01 1.1510100555419922e+02 2.4210000038146973e+00 -8.1501207351684570e+00 1.1407899475097656e+02 2.1000000000000000e+01 -7.4891998291015625e+01 -2.9799200057983398e+01 1.8000000000000000e+01 -7.4891998291015625e+01 -2.5239198684692383e+01 2.1000000000000000e+01 7.3500495910644531e+01 2.9799200057983398e+01 2.1000000000000000e+01 6.9175300598144531e+01 3.3713199615478516e+01 2.0060100555419922e+01 -5.4269802093505859e+01 -5.1915401458740234e+01 1.8000000000000000e+01 -5.4862300872802734e+01 -5.2481098175048828e+01 2.1000000000000000e+01 -2.0907100677490234e+01 8.6932098388671875e+01 2.1000000000000000e+01 1.0800000280141830e-01 7.3000000000000000e+01 1.8000000000000000e+01 -6.8884300231933594e+01 -2.3855001449584961e+01 1.8000000000000000e+01 -6.6532798767089844e+01 -2.9799299240112305e+01 -3.0536600112915039e+01 2.3207599639892578e+01 1.0631999969482422e+02 -1.8569200134277344e+02 7.5104804992675781e+01 9.3923202514648438e+01 2.1000000000000000e+01 6.8513999938964844e+01 -3.5021301269531250e+01 2.1000000000000000e+01 7.3272300720214844e+01 -2.9799200057983398e+01 -1.1753499984741211e+01 -3.0837299346923828e+01 9.1194305419921875e+01 6.1103000640869141e+00 -4.4312000274658203e+01 7.2949897766113281e+01 -2.1466099548339844e+02 7.5108001708984375e+01 5.4784099578857422e+01 -1.9013400268554688e+02 -7.4891296386718750e+01 8.9537704467773438e+01 2.0533998489379883e+01 -7.2795397043228149e-01 1.0195600128173828e+02 7.9645094871520996e+00 3.5167297363281250e+01 9.0931701660156250e+01 3.9316997528076172e+00 2.0407600402832031e+01 1.0681199645996094e+02 2.1004098892211914e+01 6.2256599426269531e+01 -4.1176799774169922e+01 2.1000000000000000e+01 5.7031200408935547e+01 -4.6233798980712891e+01 -1.5327900695800781e+02 -4.6390995979309082e+00 -1.1533100128173828e+02 2.1178699493408203e+01 -4.1126800537109375e+01 -6.0761501312255859e+01 2.0932199478149414e+01 -5.1859699249267578e+01 -5.2187000274658203e+01 -3.4418502807617188e+01 -7.4891403198242188e+01 1.0934200286865234e+02 1.8000000000000000e+01 6.6748794555664062e+01 -2.9799299240112305e+01 1.9166101455688477e+01 6.0066398620605469e+01 -4.7126800537109375e+01 2.0314098358154297e+01 6.5873100280761719e+01 -4.0621299743652344e+01 -4.1148799896240234e+01 7.5108001708984375e+01 -1.1255699920654297e+02 -1.6846800231933594e+02 -7.4890396118164062e+01 1.0418300628662109e+02 -1.6650601196289062e+02 -7.4891204833984375e+01 1.0909700012207031e+02 1.5993300437927246e+01 -5.6457298278808594e+01 4.7894702911376953e+01 2.1000000000000000e+01 5.5608296394348145e-01 9.0649902343750000e+01 2.1000000000000000e+01 -8.4453201293945312e+00 9.4827499389648438e+01 5.6221899986267090e+00 -1.8348899841308594e+01 -7.4209800720214844e+01 -1.3257200241088867e+01 -3.7578899383544922e+01 8.8780799865722656e+01 2.1000000000000000e+01 -5.7266101837158203e+01 -4.5136501312255859e+01 2.1000000000000000e+01 -5.5840499877929688e+01 -4.6890197753906250e+01 2.1000000000000000e+01 5.7483200073242188e+01 -4.5135402679443359e+01 2.1000000000000000e+01 5.6056499481201172e+01 -4.6890197753906250e+01 -1.9163600158691406e+02 -7.4891593933105469e+01 8.3692100524902344e+01 -1.9611099243164062e+02 9.8749694824218750e+00 7.8552902221679688e+01 2.1000000000000000e+01 -3.6007300019264221e-01 9.6598899841308594e+01 2.1004301071166992e+01 -6.2021598815917969e+01 -4.1194801330566406e+01 -8.4987297058105469e+00 7.5108001708984375e+01 -8.8191505432128906e+01 -1.5600900268554688e+02 3.6128101348876953e+00 -1.1068700408935547e+02 1.5161299705505371e+01 3.7162399291992188e+01 8.6777206420898438e+01 -1.1147000122070312e+02 -7.4891403198242188e+01 1.2659700012207031e+02 -1.1642400360107422e+02 -7.4891998291015625e+01 1.2297200012207031e+02 -1.4419500732421875e+02 7.5107299804687500e+01 -1.1916200256347656e+02 1.8000000000000000e+01 -6.6532798767089844e+01 2.9799299240112305e+01 -2.1014698791503906e+02 -5.4891998291015625e+01 -6.3219398498535156e+01 -2.1751199340820312e+02 -5.4891799926757812e+01 -4.8431301116943359e+01 -2.0800100708007812e+02 1.2910199165344238e+00 -6.1064899444580078e+01 2.0981901168823242e+01 -5.5407798767089844e+01 -4.8191699981689453e+01 -2.0590499877929688e+02 -4.1511699676513672e+01 -6.4517601013183594e+01 -2.2121900939941406e+02 -4.6848899841308594e+01 -2.6174999237060547e+01 -1.1017800140380859e+02 6.3913302421569824e+00 -1.2669100189208984e+02 1.2519899368286133e+01 -4.3236698150634766e+01 -6.2628799438476562e+01 3.5546998977661133e+00 -2.1866500854492188e+01 -7.3647796630859375e+01 2.1000000000000000e+01 7.5108001708984375e+01 2.9799200057983398e+01 -4.4298000335693359e+01 -7.3106292724609375e+01 -1.1413300323486328e+02 -4.1794799804687500e+01 -7.4891998291015625e+01 -1.1288099670410156e+02 -4.2628299713134766e+01 6.7965095520019531e+01 -1.1330300140380859e+02 -4.2628299713134766e+01 4.7396998405456543e+00 -1.1330300140380859e+02 -4.0971000671386719e+01 3.5152698516845703e+01 -1.1244799804687500e+02 -4.2628299713134766e+01 -4.1967899322509766e+01 -1.1330300140380859e+02 -4.4298000335693359e+01 -1.3787099838256836e+01 -1.1413300323486328e+02 -1.9500300598144531e+02 -7.3979103088378906e+01 -7.9689895629882812e+01 2.1000000000000000e+01 -4.4068099975585938e+01 6.3845298767089844e+01 2.1000101089477539e+01 -4.3902999877929688e+01 5.8802898406982422e+01 -2.0448801517486572e+00 -7.4892105102539062e+01 -8.1524795532226562e+01 -3.9611701965332031e+01 -1.1682099342346191e+01 1.1259600067138672e+02 1.7103899002075195e+01 6.5061500549316406e+01 4.9149700164794922e+01 1.9856300354003906e+01 6.6521194458007812e+01 4.2222599029541016e+01 1.5833899497985840e+01 -5.9839496612548828e+01 5.4097599029541016e+01 1.5865499496459961e+01 -5.6621799468994141e+01 4.7871601104736328e+01 2.1000000000000000e+01 -1.4489100456237793e+01 7.2099601745605469e+01 -4.0007999420166016e+01 -1.4801500320434570e+01 1.1204000091552734e+02 -1.9739900207519531e+02 -7.3742393493652344e+01 -8.1501296997070312e+01 1.6308401107788086e+01 -4.8506798744201660e+00 1.0468699645996094e+02 -1.0000000000000000e+02 -7.4891998291015625e+01 -1.2700000762939453e+02 -1.9004100036621094e+02 7.5104301452636719e+01 -8.5460197448730469e+01 -1.8223999023437500e+02 1.7392500638961792e+00 -9.2903800964355469e+01 1.8357299804687500e+01 6.2707000732421875e+01 4.8569797515869141e+01 2.0624500274658203e+01 6.0352798461914062e+01 4.6493999481201172e+01 2.1000000000000000e+01 6.7407897949218750e+01 3.5785701751708984e+01 2.1000000000000000e+01 -5.8562999725341797e+01 4.5097900390625000e+01 2.1000000000000000e+01 -7.3056304931640625e+01 -2.9799200057983398e+01 2.0995100021362305e+01 -5.2815799713134766e+01 -5.0527301788330078e+01 -1.8799699401855469e+02 7.5106399536132812e+01 8.7539703369140625e+01 1.9731599807739258e+01 6.1630401611328125e+01 4.7645401000976562e+01 2.1000000000000000e+01 -5.6809398651123047e+01 -4.6239498138427734e+01 1.5814099311828613e+01 5.6829601287841797e+01 4.7844902038574219e+01 1.8000000000000000e+01 -3.8214298248291016e+01 6.2132102966308594e+01 1.8000000000000000e+01 -7.2825498580932617e+00 9.3641197204589844e+01 1.8000000000000000e+01 3.7198902130126953e+01 6.2875003814697266e+01 1.9513198852539062e+01 5.7422000885009766e+01 5.3005401611328125e+01 -2.3469798564910889e+00 4.5547401428222656e+01 8.1196601867675781e+01 -1.3559399414062500e+02 -7.4891998291015625e+01 1.1897899627685547e+02 -1.3439500427246094e+02 -7.4891700744628906e+01 1.2245000457763672e+02 1.4789000511169434e+01 5.8734001159667969e+01 4.7777198791503906e+01 1.2187500000000000e+01 5.2666500091552734e+01 6.5605995178222656e+01 2.1000000000000000e+01 1.2906099855899811e-01 9.6600502014160156e+01 2.1000000000000000e+01 6.6834899902343750e+01 -2.9605100631713867e+01 -2.0749400329589844e+02 1.5842599868774414e+01 -6.7731903076171875e+01 2.1000000000000000e+01 -5.2692398071289062e+01 -5.0409500122070312e+01 2.1000000000000000e+01 -5.3760601043701172e+01 -4.9253200531005859e+01 2.1000000000000000e+01 -5.3699699401855469e+01 -4.9362800598144531e+01 2.0763799667358398e+01 -7.0773902893066406e+01 3.4953300476074219e+01 1.6749300003051758e+01 -5.2333000183105469e+01 -5.5008499145507812e+01 -1.7778900146484375e+02 1.0520999908447266e+01 9.6655693054199219e+01 -1.6788899230957031e+02 -2.8404199600219727e+01 1.0391799926757812e+02 -1.4750300598144531e+02 -4.1497802734375000e+00 1.1786500549316406e+02 -1.3913500976562500e+02 7.0647201538085938e+00 1.1778099822998047e+02 1.1004500389099121e+01 4.7851100921630859e+01 7.3358398437500000e+01 2.6818099021911621e+00 6.7375898361206055e+00 1.1440700531005859e+02 -2.2240998840332031e+02 -5.4891998291015625e+01 -3.3834899902343750e+01 1.8000299453735352e+01 2.3586599349975586e+01 6.9473197937011719e+01 8.2315006256103516e+00 1.0114500045776367e+01 1.1246299743652344e+02 1.7103899002075195e+01 -7.4891998291015625e+01 4.9149497985839844e+01 5.4821000099182129e+00 4.3973300933837891e+01 7.3780700683593750e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 38 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02) (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01) (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02) (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector 1.8804199993610382e+01 1.6510300338268280e+01 -7.4573598802089691e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -2.1751199662685394e+02 -5.4891798645257950e+01 -4.8431299626827240e+01) (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -7.4891999363899231e+01 -1.2700000405311584e+02) (float-vector -1.3236500322818756e+02 -7.4889197945594788e+01 -1.2322799861431122e+02) (float-vector -1.6911299526691437e+02 -7.4891902506351471e+01 -1.0705500096082687e+02) (float-vector -1.9696499407291412e+02 -7.4891999363899231e+01 -8.2016400992870331e+01) (float-vector -2.2292800247669220e+02 -7.4891999363899231e+01 -3.1903099268674850e+01) (float-vector -2.2543500363826752e+02 -7.4891403317451477e+01 -2.1152600646018982e+01) (float-vector -2.2702400386333466e+02 -7.4892103672027588e+01 3.7199798971414566e+00) (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02) (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 1.7103899270296097e+01 -7.4891999363899231e+01 -4.9149498343467712e+01) (float-vector -2.0448800642043352e+00 -7.4892103672027588e+01 -8.1524796783924103e+01) (float-vector -2.4468600749969482e+01 -7.4892401695251465e+01 -1.0244999825954437e+02) (float-vector -6.0083199292421341e+01 -7.4892103672027588e+01 -1.2084499746561050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 -1.7970599234104156e+01) (float-vector 2.0999999716877937e+01 -7.4891999363899231e+01 2.9799299314618111e+01) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02) (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 2.1175000816583633e+01 -1.8278900533914566e+01 -7.0860102772712708e+01) (float-vector 2.1178700029850006e+01 -4.1126798838376999e+01 -6.0761500149965286e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0015299320220947e+01 2.0527599379420280e+01 9.4154201447963715e+01) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7712200060486794e+01 4.4143297709524632e+00 1.0767900198698044e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector 1.8666300922632217e+01 -1.3005300424993038e+01 1.0204400122165680e+02) (float-vector -4.4254800304770470e+00 -7.4892103672027588e+01 8.4284797310829163e+01) (float-vector -3.4418500959873199e+01 -7.4891403317451477e+01 1.0934200137853622e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector 2.9303999617695808e+00 1.1191800236701965e+01 1.1289899796247482e+02) (float-vector 9.8897004500031471e+00 -5.5709900334477425e+00 1.1372400075197220e+02) (float-vector -8.5987202823162079e+01 -7.4891299009323120e+01 1.2629500031471252e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01) (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01) (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1741299331188202e+02 -7.4885897338390350e+01 4.9223098903894424e+01) (float-vector -2.2467300295829773e+02 -7.4891597032546997e+01 2.4523500353097916e+01) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01) (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3439500331878662e+02 -7.4891701340675354e+01 1.2245000153779984e+02) (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02) (float-vector -1.1146999895572662e+02 -7.4891403317451477e+01 1.2659700214862823e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1289101839065552e+01 7.5108602643013000e+01 -1.2114699929952621e+02) (float-vector -8.4987301379442215e+00 7.5107999145984650e+01 -8.8191501796245575e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 -4.9149498343467712e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 -2.9799200594425201e+01) (float-vector 2.0999999716877937e+01 7.5107999145984650e+01 2.9799200594425201e+01) (float-vector 1.7103899270296097e+01 7.5107999145984650e+01 4.9149498343467712e+01) (float-vector 4.7304001636803150e+00 7.5107596814632416e+01 7.3345899581909180e+01) (float-vector -2.2786399349570274e+01 7.5107596814632416e+01 1.0112799704074860e+02) (float-vector -4.9926400184631348e+01 7.5107701122760773e+01 1.1721199750900269e+02) (float-vector -1.0668999701738358e+02 7.5107999145984650e+01 1.2682299315929413e+02) (float-vector -1.4044199883937836e+02 7.5107298791408539e+01 1.2067499756813049e+02) (float-vector -1.6432400047779083e+02 7.5107298791408539e+01 1.0962100327014923e+02) (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -2.1466100215911865e+02 7.5107999145984650e+01 5.4784100502729416e+01) (float-vector -2.2446300089359283e+02 7.5106300413608551e+01 2.6909999549388885e+01) (float-vector -2.2709099948406219e+02 7.5107701122760773e+01 1.7232199752470478e-02) (float-vector -2.2515299916267395e+02 7.5107298791408539e+01 -2.2557400166988373e+01) (float-vector -2.1504299342632294e+02 7.5107000768184662e+01 -5.4824199527502060e+01) (float-vector -1.9633899629116058e+02 7.5105696916580200e+01 -8.3057902753353119e+01) (float-vector -1.7139400541782379e+02 7.5105503201484680e+01 -1.0562600195407867e+02) (float-vector -1.4419500529766083e+02 7.5107298791408539e+01 -1.1916200071573257e+02) (float-vector -1.2329100072383881e+02 7.5107596814632416e+01 -1.2494400143623352e+02) (float-vector -1.0000000149011612e+02 7.5107999145984650e+01 -1.2700000405311584e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0411199331283569e+02 7.5104497373104095e+01 7.3148198425769806e+01) (float-vector -1.8569199740886688e+02 7.5104802846908569e+01 9.3923203647136688e+01) (float-vector -1.6650600731372833e+02 -7.4891202151775360e+01 1.0909699648618698e+02) (float-vector -2.0345599949359894e+02 -7.4891597032546997e+01 7.3888599872589111e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_shoulder_lift_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_shoulder_pan_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.8800000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 3 1 0 2 14 0 14 168 0 169 0 168 173 174 0 0 169 175 175 173 0 0 174 3 169 168 170 14 170 168 177 170 14 177 202 170 202 169 170 177 203 202 203 177 372 177 379 372 177 422 379 177 14 422 161 179 202 202 203 161 169 202 179 178 169 179 179 161 160 179 205 178 402 179 160 205 179 402 169 176 175 169 178 176 176 173 175 172 174 173 173 176 172 171 3 172 172 3 174 176 171 172 3 171 5 5 171 176 4 1 3 5 4 3 5 6 4 15 4 6 4 469 1 469 4 15 1 467 2 1 469 467 467 417 421 467 468 417 467 469 468 420 467 421 2 467 420 14 2 420 420 421 416 412 420 416 412 419 420 419 422 420 422 14 420 416 421 417 376 412 416 376 416 409 415 409 416 417 415 416 377 411 412 412 376 377 419 412 411 411 379 419 422 419 379 378 411 377 378 379 411 373 375 377 375 378 377 373 377 376 375 371 378 378 371 372 372 379 378 369 371 375 375 373 366 366 369 375 366 373 368 373 376 368 368 367 366 374 367 368 376 374 368 376 409 374 374 409 410 367 374 480 410 452 374 374 452 480 413 410 409 413 409 414 409 415 414 413 453 410 453 452 410 452 453 454 466 452 454 480 452 466 480 466 367 465 466 454 501 466 481 501 367 466 481 466 465 465 454 462 462 479 465 465 479 481 457 462 454 462 457 447 450 479 462 462 447 450 479 450 481 449 450 446 446 450 447 449 481 450 446 447 448 448 447 457 455 456 457 454 455 457 456 448 457 451 446 448 459 448 456 460 448 459 451 448 460 456 455 458 458 459 456 461 460 459 458 463 459 463 461 459 490 460 461 451 460 490 464 461 463 464 490 461 414 418 463 458 414 463 463 418 464 455 413 458 414 458 413 417 418 414 415 417 414 468 418 417 470 418 468 470 471 418 464 418 471 468 469 470 470 469 472 470 472 471 434 471 495 471 472 495 471 434 491 464 471 491 496 495 472 472 469 496 434 495 435 435 495 496 434 435 433 433 491 434 435 436 433 435 437 436 437 435 496 433 436 428 436 431 428 438 436 437 436 438 431 437 440 438 437 441 440 437 496 441 440 431 438 431 393 428 431 439 396 393 431 396 440 439 431 442 439 440 440 441 442 47 442 441 441 405 47 441 496 405 59 439 442 58 59 442 47 58 442 439 59 396 50 59 58 50 61 59 61 129 59 129 23 59 23 156 59 396 59 395 156 395 59 319 156 23 319 321 156 156 321 336 336 395 156 352 395 336 388 395 352 388 396 395 336 321 337 336 351 352 337 351 336 338 337 321 319 338 321 351 337 353 338 355 337 337 355 353 351 354 352 351 333 354 351 334 333 353 334 351 355 334 353 338 356 355 356 331 355 334 355 331 331 333 334 331 332 333 333 332 354 354 332 386 354 386 352 386 332 387 386 387 388 388 352 386 389 388 387 335 389 387 332 335 387 389 393 388 393 396 388 335 392 389 392 393 389 394 393 392 428 393 394 335 391 392 391 397 392 394 392 397 397 426 394 428 394 426 429 428 426 433 428 429 426 433 429 397 427 426 427 430 426 426 430 432 432 433 426 397 391 494 397 494 427 427 483 430 494 483 427 485 430 483 430 485 432 485 488 432 488 491 432 491 433 432 487 488 485 487 491 488 483 484 485 486 485 484 485 489 487 486 489 485 483 492 484 483 494 492 391 492 494 492 493 486 492 486 484 499 493 492 499 492 391 486 446 489 486 449 446 486 493 449 489 446 451 451 487 489 451 490 487 490 491 487 490 464 491 476 449 475 449 476 481 449 493 475 475 443 476 443 445 476 476 445 482 476 482 481 501 481 482 445 477 482 482 500 501 500 482 477 443 444 445 445 444 474 474 477 445 474 478 477 477 478 500 384 500 385 385 500 478 384 501 500 384 367 501 286 384 385 367 384 286 367 286 366 285 286 277 286 285 366 286 385 277 366 285 365 369 366 365 280 285 277 295 285 280 295 365 285 295 294 365 365 294 369 294 370 369 370 371 369 294 295 289 287 370 294 289 287 294 295 296 289 296 295 280 289 288 287 289 293 288 293 289 296 287 270 203 287 288 270 287 203 370 288 292 270 288 293 292 296 284 293 293 284 278 297 293 278 293 297 292 284 296 280 284 280 278 278 276 279 276 278 280 278 279 297 297 298 292 279 298 297 292 291 270 292 298 291 279 276 298 291 298 302 298 313 302 315 313 298 276 315 298 270 291 290 291 302 290 268 203 270 290 268 270 268 290 299 302 299 290 268 299 300 299 301 300 302 301 299 300 271 268 300 303 271 301 308 300 308 303 300 302 314 301 301 314 316 308 301 316 308 309 303 316 317 308 308 317 309 272 316 314 272 317 316 313 314 302 313 275 314 272 314 275 272 273 274 272 275 273 274 317 272 317 274 309 303 309 306 309 274 306 274 273 306 306 307 303 307 306 312 306 273 312 303 307 304 305 304 307 307 310 305 307 312 310 271 303 304 269 271 304 304 305 269 310 311 305 269 305 162 305 311 163 162 305 163 310 318 311 312 282 310 310 282 318 158 163 311 158 311 318 163 164 162 158 165 163 165 164 163 157 158 159 157 165 158 166 159 158 158 318 166 282 281 318 318 281 166 281 282 273 312 273 282 277 281 273 281 283 167 281 277 283 166 281 167 159 166 167 383 167 283 383 159 167 383 283 382 159 383 401 382 401 383 381 382 283 381 401 382 159 401 402 32 401 398 380 401 381 398 401 380 401 32 402 283 380 381 398 380 283 283 28 398 28 32 398 31 32 24 28 25 32 32 25 24 402 32 31 24 29 31 423 31 29 31 423 402 21 24 22 24 25 26 24 26 22 24 21 29 27 26 25 25 28 27 26 363 348 22 26 348 26 329 363 329 26 27 18 21 22 22 348 18 18 20 21 20 29 21 18 19 20 18 344 19 18 348 344 348 347 344 363 362 348 348 362 347 344 343 19 344 347 343 19 23 20 23 19 320 19 343 320 23 30 20 30 29 20 141 23 129 141 30 23 319 23 320 320 341 319 343 341 320 339 340 319 319 340 338 341 342 319 342 339 319 343 346 341 341 350 342 346 350 341 339 342 345 342 350 345 345 340 339 340 357 338 345 357 340 357 356 338 358 357 345 357 328 356 357 358 364 357 364 328 360 358 345 350 360 345 364 358 326 326 358 327 327 358 360 328 364 326 326 327 325 325 328 326 325 327 360 325 360 350 28 325 324 28 328 325 361 325 350 361 324 325 322 28 324 322 324 349 349 324 361 349 361 350 349 350 346 346 359 349 322 349 359 28 322 323 362 322 359 323 322 362 347 359 346 362 359 347 347 346 343 363 323 362 28 323 329 329 323 363 329 27 28 328 28 330 283 277 28 277 330 28 331 328 332 330 332 328 331 356 328 330 335 332 390 391 335 335 400 390 330 400 335 391 390 498 400 498 390 499 391 498 498 497 475 475 499 498 498 400 497 399 400 330 399 497 400 443 497 473 473 497 399 443 475 497 475 493 499 443 473 444 444 473 474 385 473 399 474 473 385 385 399 330 385 330 277 478 474 385 276 277 273 277 276 280 275 276 273 276 313 315 275 313 276 423 29 30 30 141 423 424 423 141 130 423 424 402 423 130 129 140 141 141 140 424 139 424 140 130 424 139 139 140 129 129 61 130 130 139 129 50 60 61 61 60 128 130 61 128 45 60 52 45 56 60 52 60 50 60 56 128 56 131 128 128 131 130 69 131 56 132 131 69 130 131 135 131 132 135 135 144 130 402 130 144 135 132 144 132 142 144 142 145 144 145 425 144 425 402 144 132 134 142 134 137 142 142 137 145 137 143 145 143 153 145 145 153 425 148 402 425 153 152 425 152 148 425 153 143 152 152 143 148 143 105 148 148 105 146 146 151 148 154 402 148 151 154 148 108 146 105 147 146 108 147 149 146 146 149 151 151 149 150 151 150 122 122 154 151 147 123 149 149 123 150 109 147 106 108 106 147 123 147 109 106 108 105 83 106 85 83 86 106 106 105 85 106 86 109 86 107 109 109 107 123 107 114 123 114 150 123 86 84 107 84 114 107 82 84 86 82 86 83 81 84 82 81 100 84 100 110 84 111 84 110 84 111 114 111 122 114 122 150 114 111 110 122 110 100 115 115 120 110 120 121 110 122 110 121 121 127 122 122 127 154 119 121 112 112 121 120 119 125 121 125 127 121 112 120 115 115 100 112 112 102 113 112 100 95 95 102 112 112 113 119 113 116 119 116 125 119 124 125 116 124 127 125 97 103 116 116 102 97 102 116 113 103 118 116 118 124 116 95 101 102 101 97 102 94 97 96 94 98 97 96 97 101 103 97 98 103 117 118 98 99 103 103 99 117 117 126 118 118 126 124 99 227 117 117 227 240 117 240 126 94 99 98 94 93 99 93 224 99 99 224 227 227 224 225 228 227 225 240 227 228 228 241 240 240 241 242 240 242 126 226 228 225 239 228 226 239 241 228 223 225 224 226 225 223 223 224 12 93 12 224 12 221 223 221 226 223 229 226 221 239 226 229 229 234 239 243 241 239 239 234 243 231 229 221 231 234 229 213 221 12 222 221 213 222 231 221 231 233 234 232 231 222 232 233 231 233 244 234 244 243 234 233 232 236 238 233 236 250 233 238 250 244 233 230 232 222 236 232 230 230 222 213 219 230 213 230 219 235 235 236 230 235 238 236 237 238 235 258 238 237 250 238 258 262 244 250 258 264 250 264 262 250 257 258 237 264 258 257 237 235 219 256 257 237 256 237 219 256 259 257 259 264 257 264 265 262 264 259 265 262 265 261 261 244 262 265 263 261 265 260 263 259 260 265 261 245 243 244 261 243 263 245 261 263 266 242 263 242 245 260 266 263 127 260 154 127 266 260 154 260 259 242 266 155 155 266 127 241 245 242 126 242 155 243 245 241 124 155 127 126 155 124 259 256 219 259 219 252 252 267 259 267 154 259 402 154 267 402 267 252 402 164 157 164 402 160 402 252 210 210 209 402 402 209 205 159 402 157 164 160 162 157 164 165 160 161 162 161 269 162 203 268 161 268 269 161 269 268 271 370 203 372 370 372 371 178 205 206 206 205 209 204 178 206 204 206 208 206 200 208 209 200 206 209 210 200 199 200 196 200 201 196 200 199 208 200 210 201 199 197 208 208 207 204 208 197 207 199 194 198 196 194 199 197 199 198 194 196 192 192 196 185 196 201 185 194 192 193 198 194 193 197 198 190 198 193 190 197 190 195 207 197 195 207 195 182 204 207 182 180 195 189 182 195 180 189 195 190 190 187 189 190 191 187 190 193 191 193 192 191 191 192 187 184 187 183 184 189 187 192 183 187 180 189 184 176 184 183 184 176 188 180 184 188 183 5 176 185 5 183 192 185 183 178 188 176 181 180 188 181 188 178 182 178 204 182 181 178 180 181 182 5 185 7 186 7 185 201 186 185 6 5 7 8 6 7 186 8 7 211 8 186 214 186 201 211 186 214 246 214 201 246 201 210 214 217 211 214 246 217 255 217 246 252 246 210 255 246 252 254 255 252 255 254 217 217 247 211 217 249 247 217 253 249 254 253 217 254 251 253 254 252 251 252 219 251 251 219 248 251 248 253 253 248 249 249 220 247 249 248 220 247 215 211 247 220 215 219 218 220 220 218 215 220 248 219 219 213 218 212 218 213 215 218 212 215 212 216 211 215 216 211 11 8 212 11 211 216 212 211 11 212 9 212 213 9 213 10 9 213 12 10 9 10 11 11 6 8 11 15 6 10 15 11 12 13 10 13 15 10 12 17 13 17 12 93 13 16 15 17 16 13 469 15 16 79 16 81 81 16 17 79 403 16 469 16 403 496 469 407 469 403 407 79 404 403 407 403 404 404 406 407 406 408 407 496 407 408 496 408 405 405 408 44 44 408 406 53 406 404 41 406 53 41 44 406 53 54 55 42 53 55 42 41 53 54 53 404 41 42 43 41 43 44 43 42 45 45 42 56 56 42 55 44 43 45 34 44 45 45 46 34 45 52 46 34 46 52 34 52 50 40 50 49 40 34 50 51 49 50 51 50 58 39 34 40 40 49 39 39 49 48 51 48 49 48 51 58 58 47 48 48 47 39 36 34 39 36 39 47 405 35 47 36 47 35 35 34 36 33 34 35 35 37 33 35 405 37 405 44 37 33 37 34 34 37 38 37 44 38 38 44 34 54 57 55 56 55 62 65 62 55 55 57 65 73 54 74 54 73 57 54 404 74 57 73 104 73 74 105 73 105 104 57 104 72 136 72 104 104 105 143 136 104 143 78 105 74 78 85 105 77 78 76 76 78 74 77 85 78 83 85 77 75 77 76 75 80 77 80 83 77 75 76 74 75 79 80 75 74 79 79 81 80 80 81 82 80 82 83 74 404 79 87 88 81 88 90 81 81 90 100 81 92 87 92 81 17 89 90 88 88 87 89 89 95 90 90 95 100 89 87 91 89 91 95 95 91 96 96 101 95 17 91 87 91 17 96 87 92 17 17 93 94 96 17 94 138 143 137 138 136 143 137 136 138 136 137 72 72 137 134 57 72 71 72 133 71 72 134 133 133 134 132 70 133 132 71 133 70 66 57 71 66 71 70 65 57 66 66 67 65 67 66 70 68 70 69 70 68 67 69 70 132 67 63 65 67 68 63 62 65 63 62 63 64 63 68 64 64 68 56 68 69 56 62 64 56 455 453 413 455 454 453))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(-2.0386199951171875e+01 6.2258399963378906e+01 -4.8366799926757812e+02 -2.3539199829101562e+01 6.9229293823242188e+01 -4.9085400390625000e+02 1.5101799964904785e+00 6.4647598266601562e+01 -4.8928500366210938e+02 -4.4597099304199219e+01 6.9110397338867188e+01 -4.8414599609375000e+02 -5.7018898010253906e+01 8.1554504394531250e+01 -4.9092501831054688e+02 -6.3879600524902344e+01 7.7930801391601562e+01 -4.8355401611328125e+02 -7.9504402160644531e+01 9.5229202270507812e+01 -4.9013098144531250e+02 -8.7696296691894531e+01 9.5793899536132812e+01 -4.8369500732421875e+02 -9.8202201843261719e+01 1.0736100006103516e+02 -4.8480700683593750e+02 -1.1751300048828125e+02 1.3945500183105469e+02 -4.8154602050781250e+02 -1.2229100036621094e+02 1.5381300354003906e+02 -4.8598199462890625e+02 -1.0817900085449219e+02 1.2132199859619141e+02 -4.8531100463867188e+02 -1.2632499694824219e+02 1.7349200439453125e+02 -4.8305801391601562e+02 -1.2283100128173828e+02 1.6820800781250000e+02 -4.8846301269531250e+02 2.8380999565124512e+00 6.0998600006103516e+01 -4.8454699707031250e+02 -1.0650800323486328e+02 1.3267800903320312e+02 -4.9088998413085938e+02 -1.2008499908447266e+02 2.0513500976562500e+02 -4.9096200561523438e+02 -1.2667199707031250e+02 1.9680200195312500e+02 -4.8404199218750000e+02 1.1191799926757812e+02 3.1115200805664062e+02 1.1239500427246094e+02 1.4279399108886719e+02 3.1470901489257812e+02 9.3671005249023438e+01 3.3887100219726562e+01 3.1402398681640625e+02 1.0249699401855469e+02 4.8612899780273438e+01 3.0957299804687500e+02 1.1542700195312500e+02 1.0820300292968750e+02 3.0380499267578125e+02 1.2013199615478516e+02 6.3338198661804199e+00 3.1501400756835938e+02 8.7461502075195312e+01 5.6660999298095703e+01 2.9965698242187500e+02 1.2241500091552734e+02 6.1319900512695312e+01 2.8233200073242188e+02 1.2582799530029297e+02 1.1429700469970703e+02 2.9001501464843750e+02 1.2432499694824219e+02 1.0525099945068359e+02 2.6739999389648438e+02 1.2696899414062500e+02 6.2915802001953125e+01 2.6739199829101562e+02 1.2631200408935547e+02 5.0127498626708984e+01 3.0943798828125000e+02 1.4194400024414062e+02 2.4879999160766602e+01 3.1487899780273438e+02 1.4194400024414062e+02 5.8835903167724609e+01 2.8740502929687500e+02 1.4194400024414062e+02 5.9172801971435547e+01 2.8018899536132812e+02 1.2853900146484375e+02 -1.0730000495910645e+01 3.1455697631835938e+02 -4.8100000000000000e+02 -2.2236398696899414e+01 3.1329699707031250e+02 -3.8613500976562500e+02 9.5290201902389526e-01 3.1508200073242188e+02 -4.8280001831054688e+02 -1.9158499240875244e+00 3.1501998901367188e+02 -4.2910598754882812e+02 -1.6738698959350586e+01 3.1389099121093750e+02 -4.8202401733398438e+02 -2.2900798797607422e+01 3.1294100952148438e+02 -4.7951800537109375e+02 -4.9496698379516602e+00 3.1490298461914062e+02 -3.7525601196289062e+02 -7.4571700096130371e+00 3.1478100585937500e+02 -3.6481298828125000e+02 -5.1831802368164062e+01 3.0392599487304688e+02 -4.8419100952148438e+02 -5.1448501586914062e+01 3.0416198730468750e+02 -4.1818197631835938e+02 -4.1733898162841797e+01 3.0794702148437500e+02 -4.7789700317382812e+02 -3.3772499084472656e+01 3.1012899780273438e+02 -4.8577499389648438e+02 -4.5538803100585938e+01 3.0658297729492188e+02 -3.3249499511718750e+02 -3.8335700988769531e+01 3.0907299804687500e+02 -3.3971801757812500e+02 8.2428798675537109e+00 3.1482897949218750e+02 -4.8467001342773438e+02 -2.4886200428009033e+00 3.1497601318359375e+02 -3.2593899536132812e+02 -4.9915499687194824e+00 3.1490200805664062e+02 -3.2379202270507812e+02 -1.7847801208496094e+01 3.1395501708984375e+02 -2.3374000549316406e+02 -5.0281000137329102e+00 3.1490002441406250e+02 -2.7877999877929688e+02 -3.7623199462890625e+01 3.0934701538085938e+02 -2.6787100219726562e+02 -6.5083602905273438e+01 2.9726998901367188e+02 -4.8454898071289062e+02 -8.8373199462890625e+01 2.7959701538085938e+02 -4.8306900024414062e+02 -7.1430694580078125e+01 2.9316000366210938e+02 -3.1817901611328125e+02 -5.3965900421142578e+01 3.0300799560546875e+02 -1.9534100341796875e+02 -8.0282005310058594e+01 2.8652502441406250e+02 -2.3261601257324219e+02 7.0645198822021484e+00 3.1496798706054688e+02 -2.5213798522949219e+02 9.8963394165039062e+00 3.1518499755859375e+02 -1.5394900512695312e+02 -4.0323398590087891e+01 3.0850799560546875e+02 -1.7597700500488281e+02 -1.8255199432373047e+01 3.1400497436523438e+02 -1.3561299133300781e+02 -6.6130401611328125e+01 2.9644201660156250e+02 -2.2605200195312500e+02 -7.0306602478027344e+01 2.9376199340820312e+02 -1.9116101074218750e+02 -6.7984497070312500e+01 2.9526901245117188e+02 -1.8058801269531250e+02 -7.2347496032714844e+01 2.9237698364257812e+02 -2.1601000976562500e+02 -7.4448799133300781e+01 2.9088900756835938e+02 -1.8302699279785156e+02 -7.2442298889160156e+01 2.9231100463867188e+02 -1.5392500305175781e+02 -7.0382499694824219e+01 2.9371099853515625e+02 -1.4635198974609375e+02 -7.0481895446777344e+01 2.9364498901367188e+02 -8.7289993286132812e+01 -7.3517097473144531e+01 2.9156399536132812e+02 -1.2342700195312500e+02 -7.6505401611328125e+01 2.8936898803710938e+02 -1.5491700744628906e+02 -8.4778305053710938e+01 2.8261300659179688e+02 -6.7579795837402344e+01 -9.5364898681640625e+01 2.7195401000976562e+02 -3.2015600585937500e+02 -1.0613600158691406e+02 2.5798898315429688e+02 -4.8381100463867188e+02 -1.1370000457763672e+02 2.4458000183105469e+02 -4.7781900024414062e+02 -1.1168599700927734e+02 2.4845700073242188e+02 -4.1662200927734375e+02 -1.1353299713134766e+02 2.4490899658203125e+02 -3.5188000488281250e+02 -1.1157400512695312e+02 2.4866099548339844e+02 -3.3159802246093750e+02 -1.1730300140380859e+02 2.3654699707031250e+02 -4.8420199584960938e+02 -1.1539500427246094e+02 2.4103500366210938e+02 -3.9727398681640625e+02 -1.2269700622558594e+02 2.2211801147460938e+02 -4.8232098388671875e+02 -1.1702399444580078e+02 2.3733299255371094e+02 -3.6617898559570312e+02 -1.1526799774169922e+02 2.4130499267578125e+02 -3.0071099853515625e+02 -1.2293799591064453e+02 2.2032600402832031e+02 -3.5670001220703125e+02 -1.1342500305175781e+02 2.4512199401855469e+02 -2.7013299560546875e+02 -1.1687999725341797e+02 2.3767100524902344e+02 -2.5190200805664062e+02 -1.2599599456787109e+02 2.0401998901367188e+02 -4.6177200317382812e+02 -1.2579399108886719e+02 2.0545298767089844e+02 -4.1757901000976562e+02 -1.2613099670410156e+02 2.0282800292968750e+02 -3.9319198608398438e+02 -1.2596200561523438e+02 2.0425898742675781e+02 -3.5157800292968750e+02 -1.2642200469970703e+02 2.0009700012207031e+02 -4.2654800415039062e+02 -1.2580400848388672e+02 2.0565600585937500e+02 -4.8100201416015625e+02 -1.2700000762939453e+02 1.8800000000000000e+02 -4.8099899291992188e+02 -1.2690800476074219e+02 1.9310699462890625e+02 -4.2516000366210938e+02 -1.2640699768066406e+02 2.0024900817871094e+02 -3.4070797729492188e+02 -1.2664300537109375e+02 1.9750698852539062e+02 -3.8592800903320312e+02 -1.2681199645996094e+02 1.9490200805664062e+02 -3.4539199829101562e+02 -1.2695400238037109e+02 1.9142700195312500e+02 -3.6554800415039062e+02 -1.2700000762939453e+02 1.8800000000000000e+02 -3.7742199707031250e+02 -1.2562599945068359e+02 2.0680400085449219e+02 -2.8781802368164062e+02 -1.2663699340820312e+02 1.9758399963378906e+02 -3.3234097290039062e+02 -1.2663300323486328e+02 1.9763700866699219e+02 -2.9629702758789062e+02 -1.2695300292968750e+02 1.9145800781250000e+02 -3.1280200195312500e+02 -9.5416900634765625e+01 2.7195999145507812e+02 -1.4185800170898438e+02 -1.0484900665283203e+02 2.5980999755859375e+02 -1.2765499877929688e+02 -1.1427000427246094e+02 2.4345300292968750e+02 -2.0267599487304688e+02 -1.1907699584960938e+02 2.3218800354003906e+02 -2.2590699768066406e+02 -1.1133499908447266e+02 2.4915400695800781e+02 -1.1397200012207031e+02 -1.1675400543212891e+02 2.3796699523925781e+02 -1.5135798645019531e+02 -1.2474800109863281e+02 2.1195300292968750e+02 -2.2539601135253906e+02 -1.2339600372314453e+02 2.1808799743652344e+02 -1.9464099121093750e+02 -1.2625600433349609e+02 2.0178500366210938e+02 -2.4012300109863281e+02 -1.2662899780273438e+02 1.9769099426269531e+02 -2.5849700927734375e+02 -1.2086599731445312e+02 2.2707299804687500e+02 -1.6345800781250000e+02 -1.2554800415039062e+02 2.0720100402832031e+02 -2.2222100830078125e+02 -1.2680600738525391e+02 1.9501000976562500e+02 -2.4650900268554688e+02 -1.2700499725341797e+02 1.8800000000000000e+02 -2.4787298583984375e+02 -1.2695201110839844e+02 1.9149499511718750e+02 -2.4941700744628906e+02 -1.2651699829101562e+02 1.9913899230957031e+02 -1.9886599731445312e+02 -1.2572499847412109e+02 2.0593800354003906e+02 -2.0585299682617188e+02 -1.2600900268554688e+02 2.0402799987792969e+02 -1.4287799072265625e+02 -1.2486100006103516e+02 2.1188899230957031e+02 -7.8009597778320312e+01 -1.1823300170898438e+02 2.3435800170898438e+02 -8.8684295654296875e+01 -1.2695099639892578e+02 1.9153399658203125e+02 -1.8005900573730469e+02 -1.2672500610351562e+02 1.9647000122070312e+02 -1.5891799926757812e+02 -1.2700000762939453e+02 1.8800000000000000e+02 -2.2350500488281250e+02 -1.2685500335693359e+02 1.9454100036621094e+02 -7.8726501464843750e+01 -5.3327602386474609e+01 3.0354400634765625e+02 -4.0043701171875000e+01 -2.1231399536132812e+01 3.1333499145507812e+02 3.2805202484130859e+01 -4.8489299774169922e+01 3.0594500732421875e+02 1.4194400024414062e+02 -6.7410301208496094e+01 2.9566897583007812e+02 -2.9937900543212891e+01 -7.3549301147460938e+01 2.9155001831054688e+02 -1.5339599609375000e+01 -7.6580505371093750e+01 2.8931298828125000e+02 -9.0714202880859375e+01 -7.8601005554199219e+01 2.8775299072265625e+02 -4.9109100341796875e+01 -6.7595802307128906e+01 2.9556399536132812e+02 6.7999198913574219e+01 -8.7625099182128906e+01 2.7995800781250000e+02 -1.8369300842285156e+01 -8.2434494018554688e+01 2.8461001586914062e+02 3.8092399597167969e+01 -8.6060798645019531e+01 2.8139401245117188e+02 2.6018699645996094e+01 -2.7250499725341797e+01 3.1210000610351562e+02 1.4194400024414062e+02 -1.9763000488281250e+01 3.1345300292968750e+02 1.4194400024414062e+02 -1.0930399894714355e+01 3.1458398437500000e+02 1.4194400024414062e+02 -7.8716896057128906e+01 2.8766198730468750e+02 7.0067298889160156e+01 -9.2582000732421875e+01 2.7520599365234375e+02 2.9808099746704102e+01 -7.2979400634765625e+01 2.9206698608398438e+02 1.4194400024414062e+02 -8.3949401855468750e+01 2.8331802368164062e+02 1.4194400024414062e+02 -1.1253500366210938e+02 2.4725300598144531e+02 1.7826101303100586e+01 -1.1583100128173828e+02 2.4011300659179688e+02 -6.1110401153564453e+01 -1.0817500305175781e+02 2.5501400756835938e+02 1.4194400024414062e+02 -1.1812899780273438e+02 2.3462500000000000e+02 7.6065498590469360e-01 -1.2105599975585938e+02 2.2652000427246094e+02 -5.5568298339843750e+01 -1.2200599670410156e+02 2.2411399841308594e+02 1.4194400024414062e+02 -9.6165199279785156e+01 2.7109500122070312e+02 1.4194400024414062e+02 -8.8148200988769531e+01 2.7942700195312500e+02 1.4194400024414062e+02 -1.2711900329589844e+02 1.9181199645996094e+02 1.4194400024414062e+02 -1.2700000762939453e+02 1.8800000000000000e+02 -1.1943099975585938e+02 5.1629100799560547e+01 3.1497100830078125e+02 -1.0152500152587891e+02 5.8887401580810547e+01 9.7612594604492188e+01 1.4194400024414062e+02 5.6119400024414062e+01 7.3881599426269531e+01 1.2143900299072266e+02 5.9328498840332031e+01 1.0143800354003906e+02 1.2837199401855469e+02 2.3114500045776367e+01 6.1013401031494141e+01 1.4194400024414062e+02 1.1166799545288086e+01 6.0870403289794922e+01 9.0647300720214844e+01 4.0624698638916016e+01 6.3211299896240234e+01 1.0823400115966797e+02 5.1440898895263672e+01 6.8786399841308594e+01 1.1853999328613281e+02 4.4208099365234375e+01 6.4324501037597656e+01 1.4194400024414062e+02 5.5495601654052734e+01 7.4161300659179688e+01 1.4194299316406250e+02 6.1112197875976562e+01 8.8569297790527344e+01 1.2522800445556641e+02 6.2940799713134766e+01 1.0860800170898438e+02 1.2680700683593750e+02 -1.1595199584960938e+01 6.1465301513671875e+01 -3.5641101074218750e+02 -2.4380199432373047e+01 6.3232696533203125e+01 -3.0230398559570312e+02 -1.1757100105285645e+01 6.1505397796630859e+01 -2.1956600952148438e+02 -4.9355201721191406e+01 7.0958297729492188e+01 -3.9170101928710938e+02 -4.1970600128173828e+01 6.8137603759765625e+01 -4.0246701049804688e+02 -3.8290897369384766e+01 6.6912704467773438e+01 -3.5388897705078125e+02 -3.7898101806640625e+01 6.6786499023437500e+01 -4.7791998291015625e+02 -3.4576801300048828e+01 6.5800804138183594e+01 -3.1122601318359375e+02 -4.6176799774169922e+01 6.9601997375488281e+01 -2.8801000976562500e+02 2.7423400878906250e+00 6.0935100555419922e+01 -1.5879299926757812e+02 -3.9852897644042969e+01 6.7316802978515625e+01 -1.0809200286865234e+02 -2.0531499862670898e+01 6.2424297332763672e+01 1.4194400024414062e+02 -5.8142700195312500e+01 7.5094497680664062e+01 -1.9857699584960938e+02 -5.5651100158691406e+01 7.3846000671386719e+01 -1.4608399963378906e+02 -5.8330699920654297e+01 7.5191398620605469e+01 -1.2444400024414062e+02 -6.6638404846191406e+01 7.9770896911621094e+01 -3.2167300415039062e+02 -5.7937900543212891e+01 7.4988899230957031e+01 -2.7876202392578125e+02 -8.2374000549316406e+01 9.1208503723144531e+01 -3.3335900878906250e+02 -9.4717498779296875e+01 1.0330200195312500e+02 -2.6646102905273438e+02 -6.3624202728271484e+01 7.8066101074218750e+01 -2.7506301879882812e+02 -5.5408798217773438e+01 7.3728096008300781e+01 -2.3635398864746094e+02 -6.0688899993896484e+01 7.6442100524902344e+01 -2.2391900634765625e+02 -6.3186698913574219e+01 7.7837303161621094e+01 -1.9436499023437500e+02 -6.5499496459960938e+01 7.9196105957031250e+01 -2.3661300659179688e+02 -6.9072097778320312e+01 8.1419105529785156e+01 -2.3104899597167969e+02 -6.5608001708984375e+01 7.9261604309082031e+01 -1.8407099914550781e+02 -6.7984497070312500e+01 8.0730995178222656e+01 -1.8058801269531250e+02 -6.0861900329589844e+01 7.6536399841308594e+01 -1.5147499084472656e+02 -7.1913299560546875e+01 8.3310905456542969e+01 -1.6620199584960938e+02 -6.3359996795654297e+01 7.7936798095703125e+01 -1.1645100402832031e+02 -6.5697502136230469e+01 7.9315605163574219e+01 -1.4053199768066406e+02 -6.6962699890136719e+01 8.0081497192382812e+01 -1.0181999969482422e+02 -7.2715995788574219e+01 8.3754394531250000e+01 -8.2801498413085938e+01 -8.6448898315429688e+01 9.4625999450683594e+01 -9.2565093994140625e+01 -1.0263100624084473e+01 6.1383098602294922e+01 -7.0137901306152344e+01 6.2046901702880859e+01 6.0990699768066406e+01 -9.8233200073242188e+01 -5.8526798248291016e+01 7.5292495727539062e+01 -4.6357597351074219e+01 -4.7585800170898438e+01 7.0082801818847656e+01 1.4194400024414062e+02 -5.4899799346923828e+01 7.3325302124023438e+01 9.2592601776123047e+00 -6.1012100219726562e+01 7.6618400573730469e+01 -8.8112503051757812e+01 -6.2307102203369141e+01 7.7328598022460938e+01 -5.1939498901367188e+01 -6.9274101257324219e+01 8.1416198730468750e+01 1.4194400024414062e+02 -8.4998199462890625e+01 9.3269699096679688e+01 1.4194400024414062e+02 -1.0532999420166016e+02 1.1691300201416016e+02 -2.4356498718261719e+02 -1.1205500030517578e+02 1.2814399719238281e+02 -2.7908798217773438e+02 -1.2067300415039062e+02 1.4701199340820312e+02 -3.0631500244140625e+02 -1.0001100158691406e+02 1.0964400482177734e+02 -1.3120600891113281e+02 -1.1327199554443359e+02 1.3057499694824219e+02 -1.5344099426269531e+02 -1.1048399353027344e+02 1.2534600830078125e+02 -2.2892799377441406e+02 -1.0815100097656250e+02 1.2127300262451172e+02 -3.6759201049804688e+01 -1.1514399719238281e+02 1.3442799377441406e+02 -2.0518901062011719e+02 -1.2057500457763672e+02 1.4789801025390625e+02 -1.2323999786376953e+02 -1.1501900482177734e+02 1.3416000366210938e+02 -1.0840200042724609e+02 -1.2586399841308594e+02 1.7085400390625000e+02 -3.3965701293945312e+02 -1.2550599670410156e+02 1.6852099609375000e+02 -2.8637399291992188e+02 -1.2668299865722656e+02 1.7884400939941406e+02 -4.0105300903320312e+02 -1.2695400238037109e+02 1.8460200500488281e+02 -4.1550897216796875e+02 -1.2681299591064453e+02 1.8110699462890625e+02 -3.5360501098632812e+02 -1.2663500213623047e+02 1.7838700866699219e+02 -3.1232897949218750e+02 -1.2695300292968750e+02 1.8454200744628906e+02 -3.1191400146484375e+02 -1.2680899810791016e+02 1.8103399658203125e+02 -2.8730599975585938e+02 -1.2639699554443359e+02 1.7565100097656250e+02 -2.8342398071289062e+02 -1.2384899902343750e+02 1.5970599365234375e+02 -2.2046199035644531e+02 -1.2609900665283203e+02 1.7290901184082031e+02 -2.6388000488281250e+02 -1.2572999572753906e+02 1.7010200500488281e+02 -2.2334700012207031e+02 -1.2607899475097656e+02 1.7274800109863281e+02 -1.8491000366210938e+02 -1.2638899993896484e+02 1.7556401062011719e+02 -2.3421800231933594e+02 -1.2518100738525391e+02 1.6659500122070312e+02 -2.0450900268554688e+02 -1.2572499847412109e+02 1.7006201171875000e+02 -2.0585299682617188e+02 -1.2514799499511719e+02 1.6640699768066406e+02 -1.3009400939941406e+02 -1.2570400238037109e+02 1.6991400146484375e+02 -1.4065200805664062e+02 -1.2662699890136719e+02 1.7828700256347656e+02 -2.4319900512695312e+02 -1.2695201110839844e+02 1.8450500488281250e+02 -2.4941700744628906e+02 -1.2680399322509766e+02 1.8096000671386719e+02 -2.1940701293945312e+02 -1.2694999694824219e+02 1.8445399475097656e+02 -1.6055999755859375e+02 -1.2662099456787109e+02 1.7820001220703125e+02 -1.8225199890136719e+02 -1.2637500762939453e+02 1.7543099975585938e+02 -1.5792599487304688e+02 -1.2680100250244141e+02 1.8089100646972656e+02 -1.5515600585937500e+02 -1.0044000244140625e+02 1.0993599700927734e+02 1.4194400024414062e+02 -1.1314199829101562e+02 1.3031700134277344e+02 -5.2696300506591797e+01 -1.1664599609375000e+02 1.3778099060058594e+02 -6.4641296386718750e+01 -1.1488600158691406e+02 1.3387300109863281e+02 -3.3939599990844727e+00 -1.2606100463867188e+02 1.7259399414062500e+02 -1.0817099761962891e+02 -1.1812899780273438e+02 1.4137500000000000e+02 7.6065498590469360e-01 -1.2146700286865234e+02 1.5050601196289062e+02 1.4194400024414062e+02 -1.1654900360107422e+02 1.3755599975585938e+02 1.3889599800109863e+01 -1.1647100067138672e+02 1.3737300109863281e+02 7.8563896179199219e+01 -1.1480799865722656e+02 1.3345899963378906e+02 1.4194400024414062e+02 -1.2445999908447266e+02 1.6273799133300781e+02 -6.0051300048828125e+01 -1.2542100524902344e+02 1.6797601318359375e+02 -5.9027999877929688e+01 -1.2568999481201172e+02 1.6981700134277344e+02 -9.7443496704101562e+01 -1.2588199615478516e+02 1.7042700195312500e+02 2.0804300308227539e+01 -1.2679399871826172e+02 1.8076400756835938e+02 -3.7121097564697266e+01 -1.2661300659179688e+02 1.7810499572753906e+02 -1.1558899688720703e+02 -1.2636199951171875e+02 1.7529299926757812e+02 -7.7984001159667969e+01 -1.2679700469970703e+02 1.8082200622558594e+02 -9.1553199768066406e+01 -1.2621499633789062e+02 1.7384800720214844e+02 -4.2187500000000000e+01 -1.2660600280761719e+02 1.7800700378417969e+02 -4.6739803314208984e+01 -1.2694899749755859e+02 1.8440200805664062e+02 -6.8973701477050781e+01 -1.2626600646972656e+02 1.7322898864746094e+02 1.4194400024414062e+02 1.9505799865722656e+02 6.1004600524902344e+01 -1.7240200042724609e+01 1.1118499755859375e+02 6.1046802520751953e+01 9.6514999389648438e+01 1.6698199462890625e+02 6.1076297760009766e+01 -7.7959205627441406e+01 1.7156500244140625e+02 6.0992698669433594e+01 6.1691299438476562e+01 2.2490299987792969e+02 1.0860800170898438e+02 2.6359598159790039e+01 1.7702099609375000e+02 1.0860700225830078e+02 1.0179799652099609e+02 2.0350900268554688e+02 1.0859200286865234e+02 7.4386405944824219e+01 2.2587600708007812e+02 1.0860800170898438e+02 -1.7441999435424805e+01 2.1618600463867188e+02 1.0860800170898438e+02 -5.2203098297119141e+01 6.2462699890136719e+01 1.0860800170898438e+02 -5.5947799682617188e+01 1.6963299560546875e+02 1.0860700225830078e+02 -1.0655100250244141e+02 1.9776300048828125e+02 1.0860399627685547e+02 -8.1758499145507812e+01 1.1587899780273438e+02 1.0860800170898438e+02 -1.2622700500488281e+02 1.0835600280761719e+02 1.0860800170898438e+02 1.2680999755859375e+02 1.4104899597167969e+02 1.0858699798583984e+02 1.2079499816894531e+02 6.2748798370361328e+01 1.0860800170898438e+02 5.5877300262451172e+01 1.5003298950195312e+02 1.0859799957275391e+02 -1.1716699981689453e+02 8.7536903381347656e+01 1.0860499572753906e+02 -1.2757099914550781e+02 6.2513999938964844e+01 1.0860099792480469e+02 -1.4090199279785156e+02 1.0484600067138672e+02 6.3259803771972656e+01 -1.1165100097656250e+02 1.4487400817871094e+02 6.3888298034667969e+01 -1.0471600341796875e+02 1.2478700256347656e+02 6.6733299255371094e+01 -1.1617199707031250e+02 2.0559400939941406e+02 6.3598094940185547e+01 -3.7847198486328125e+01 2.0100599670410156e+02 6.6871398925781250e+01 -6.1296501159667969e+01 1.8040199279785156e+02 6.6737098693847656e+01 -8.6614494323730469e+01 1.5322299194335938e+02 7.2704299926757812e+01 -1.1073700714111328e+02 8.2857498168945312e+01 7.0793395996093750e+01 -1.2201199340820312e+02 1.1074400329589844e+02 8.0699104309082031e+01 -1.2432800292968750e+02 1.3035899353027344e+02 8.1076896667480469e+01 -1.2116300201416016e+02 1.8080400085449219e+02 7.9311294555664062e+01 -9.5126502990722656e+01 2.0724900817871094e+02 7.7661300659179688e+01 -6.2189098358154297e+01 2.1335899353027344e+02 6.4132896423339844e+01 -6.0748000144958496e+00 2.0096099853515625e+02 6.2158199310302734e+01 3.5687397003173828e+01 2.1591200256347656e+02 6.8083099365234375e+01 2.6680400848388672e+01 2.1923300170898438e+02 6.9722396850585938e+01 -1.9833499908447266e+01 1.8280999755859375e+02 6.4494697570800781e+01 7.7822700500488281e+01 1.4647799682617188e+02 6.1912300109863281e+01 9.2877593994140625e+01 1.2100800323486328e+02 6.4289001464843750e+01 1.1034899902343750e+02 1.8365701293945312e+02 7.7408302307128906e+01 9.0514602661132812e+01 1.6213800048828125e+02 6.6978294372558594e+01 9.8933700561523438e+01 2.0798799133300781e+02 6.7833702087402344e+01 4.8401100158691406e+01 1.9659300231933594e+02 7.4313499450683594e+01 7.4555595397949219e+01 1.3999200439453125e+02 7.4412399291992188e+01 1.1552600097656250e+02 1.0781399536132812e+02 6.9342102050781250e+01 1.1866900634765625e+02 1.6411300659179688e+02 7.7874099731445312e+01 1.0537500000000000e+02 2.2299400329589844e+02 8.1605400085449219e+01 -2.0850200653076172e+01 2.2492698669433594e+02 8.4692199707031250e+01 1.0091500282287598e+01 2.1649299621582031e+02 9.0627197265625000e+01 -4.7570602416992188e+01 2.1820700073242188e+02 8.4266197204589844e+01 4.0720397949218750e+01 2.0847299194335938e+02 8.4609001159667969e+01 6.2196399688720703e+01 1.1234600067138672e+02 8.5627395629882812e+01 1.2461299896240234e+02 1.8967900085449219e+02 3.1497500610351562e+02 -4.9712596893310547e+01 1.8978999328613281e+02 3.1498797607421875e+02 3.4521800994873047e+01 1.5169900512695312e+02 3.1452102661132812e+02 -9.1658599853515625e+01 1.8291999816894531e+02 2.6740701293945312e+02 9.6916694641113281e+01 1.5508300781250000e+02 2.6739901733398438e+02 1.1465500640869141e+02 2.0269400024414062e+02 2.6739099121093750e+02 7.5614196777343750e+01 2.2066900634765625e+02 2.6739498901367188e+02 4.0891098022460938e+01 2.2416400146484375e+02 2.6739199829101562e+02 -2.9159299850463867e+01 2.2650300598144531e+02 2.6739401245117188e+02 1.4042599678039551e+01 2.0614999389648438e+02 2.6739199829101562e+02 -7.0524795532226562e+01 1.3126400756835938e+02 2.6739901733398438e+02 1.2347300720214844e+02 6.2328598022460938e+01 2.6739199829101562e+02 -1.1428699493408203e+02 1.7696099853515625e+02 2.6739199829101562e+02 -1.0131099700927734e+02 8.6748596191406250e+01 2.6739300537109375e+02 -1.2766300201416016e+02 1.2106999969482422e+02 2.6739801025390625e+02 -1.2573200225830078e+02 1.4651100158691406e+02 2.6741497802734375e+02 -1.1856500244140625e+02 6.3028701782226562e+01 2.6745098876953125e+02 -1.4211199951171875e+02 1.1459300231933594e+02 3.1196002197265625e+02 -1.1340100097656250e+02 1.5310501098632812e+02 3.0951300048828125e+02 -1.0582599639892578e+02 1.8040199279785156e+02 3.0926300048828125e+02 -8.6614494323730469e+01 2.0559400939941406e+02 3.1240200805664062e+02 -3.7847198486328125e+01 2.0100599670410156e+02 3.0912899780273438e+02 -6.1296501159667969e+01 2.0883299255371094e+02 3.1196798706054688e+02 3.2384399414062500e+01 2.1335899353027344e+02 3.1186700439453125e+02 -6.0748000144958496e+00 1.7669700622558594e+02 3.1303302001953125e+02 7.6760398864746094e+01 1.4589900207519531e+02 3.1351300048828125e+02 9.6739997863769531e+01 2.1923300170898438e+02 3.0627798461914062e+02 -1.9833499908447266e+01 1.9633999633789062e+02 3.0925900268554688e+02 6.6335098266601562e+01 1.6528601074218750e+02 3.0767199707031250e+02 9.8848701477050781e+01 1.3801499938964844e+02 3.0669500732421875e+02 1.1298100280761719e+02 1.9786100769042969e+02 2.9951000976562500e+02 7.4741500854492188e+01 2.1694299316406250e+02 3.0258700561523438e+02 3.5626602172851562e+01 1.2864700317382812e+02 3.0393298339843750e+02 -1.1918599700927734e+02 7.6779800415039062e+01 3.0872698974609375e+02 -1.1990900421142578e+02 1.5159500122070312e+02 2.9678799438476562e+02 -1.1318799591064453e+02 1.1080500030517578e+02 2.9670001220703125e+02 -1.2408900451660156e+02 1.7079899597167969e+02 2.9448001098632812e+02 -1.0284200286865234e+02 1.9033700561523438e+02 2.9341302490234375e+02 -8.6301101684570312e+01 2.0724900817871094e+02 2.9833901977539062e+02 -6.2189098358154297e+01 2.2358399963378906e+02 2.9319998168945312e+02 -1.9464298248291016e+01 1.8101300048828125e+02 3.0083200073242188e+02 9.1508003234863281e+01 2.2435900878906250e+02 2.9252301025390625e+02 1.2755200386047363e+01 2.0858399963378906e+02 2.9165899658203125e+02 6.1897300720214844e+01 1.6375500488281250e+02 2.9139599609375000e+02 1.0734999847412109e+02 1.4271398925781250e+02 2.9263699340820312e+02 1.1685800170898438e+02 2.1571800231933594e+02 2.8400100708007812e+02 -4.9814800262451172e+01 8.7036697387695312e+01 8.2200996398925781e+01 -1.2553599548339844e+02 6.8245300292968750e+01 8.9484199523925781e+01 -1.3351300048828125e+02 6.1130500793457031e+01 1.1351200103759766e+02 -1.4557200622558594e+02 5.6205699920654297e+01 9.3729698181152344e+01 -1.5092100524902344e+02 6.2038600921630859e+01 7.2629302978515625e+01 -1.3188099670410156e+02 6.7993499755859375e+01 6.4320602416992188e+01 -1.1864200592041016e+02 4.7243198394775391e+01 6.4540199279785156e+01 -1.3330999755859375e+02 2.8281700134277344e+01 6.1961097717285156e+01 -1.4085299682617188e+02 4.7516597747802734e+01 7.7612197875976562e+01 -1.6372099304199219e+02 5.3583999633789062e+01 1.0994400024414062e+02 -1.7091000366210938e+02 4.8974998474121094e+01 7.0968597412109375e+01 -1.4592599487304688e+02 5.1542900085449219e+01 8.9650604248046875e+01 -1.7528800964355469e+02 4.4716899871826172e+01 7.2974304199218750e+01 -1.6806399536132812e+02 3.4729598999023438e+01 6.5309600830078125e+01 -1.6184799194335938e+02 2.3630599975585938e+01 6.2577098846435547e+01 -2.4038699340820312e+02 6.2940902709960938e+01 2.0583200073242188e+02 1.2680700683593750e+02 6.2940902709960938e+01 1.8551899719238281e+02 1.2680700683593750e+02 6.2940902709960938e+01 1.7063299560546875e+02 1.2680700683593750e+02 6.2895500183105469e+01 1.4737400817871094e+02 1.2661099243164062e+02 6.2278999328613281e+01 1.1944599914550781e+02 -1.3603599548339844e+02 6.2297599792480469e+01 1.1939000701904297e+02 -1.2692299652099609e+02 8.5051795959472656e+01 2.9708901977539062e+02 -1.2524400329589844e+02 7.1835899353027344e+01 2.9038900756835938e+02 -1.3085398864746094e+02 5.6591102600097656e+01 3.0619799804687500e+02 -1.3307299804687500e+02 5.5134201049804688e+01 2.9830300903320312e+02 -1.4283799743652344e+02 6.2201702117919922e+01 2.6191101074218750e+02 -1.4380200195312500e+02 5.5387401580810547e+01 2.6243298339843750e+02 -1.5869200134277344e+02 5.5431999206542969e+01 2.8836398315429688e+02 -1.5060900878906250e+02 4.5932098388671875e+01 3.0154602050781250e+02 -1.6649099731445312e+02 5.2335098266601562e+01 2.8365200805664062e+02 -1.6989299011230469e+02 5.3190799713134766e+01 3.1370898437500000e+02 -1.1772900390625000e+02 3.3222400665283203e+01 3.1169799804687500e+02 -1.6042700195312500e+02 5.3657798767089844e+01 2.6599600219726562e+02 -1.7429100036621094e+02 6.2940799713134766e+01 2.2025300598144531e+02 1.2680700683593750e+02 6.2292499542236328e+01 2.5660601806640625e+02 -1.2692299652099609e+02 6.2272701263427734e+01 2.5658801269531250e+02 -1.3617999267578125e+02 5.9509197235107422e+01 1.8205000305175781e+02 1.2818301391601562e+02 5.8883903503417969e+01 1.4990901184082031e+02 1.4194400024414062e+02 -1.1384999847412109e+02 2.2830000305175781e+02 -4.9088497924804688e+02 -9.8200798034667969e+01 2.6410699462890625e+02 -4.8877398681640625e+02 -5.3559803962707520e-01 3.1242498779296875e+02 -4.8864099121093750e+02 -6.4981201171875000e+01 2.9316799926757812e+02 -4.8920700073242188e+02 -7.3221199035644531e+01 2.8443801879882812e+02 -4.9095999145507812e+02 -1.7018400192260742e+01 3.0677499389648438e+02 -4.9095700073242188e+02 5.7139602661132812e+01 8.9734397888183594e+01 -3.1033099365234375e+02 5.6464599609375000e+01 1.0981199645996094e+02 -2.6258700561523438e+02 3.8864299774169922e+01 6.6606399536132812e+01 -3.0262899780273438e+02 4.9913398742675781e+01 7.4457801818847656e+01 -3.2128598022460938e+02 6.3399394989013672e+01 1.1228199768066406e+02 -3.6246301269531250e+02 6.5713005065917969e+01 1.0257299804687500e+02 -4.0574301147460938e+02 6.3319801330566406e+01 9.0354896545410156e+01 -4.1479598999023438e+02 5.5794399261474609e+01 7.7609100341796875e+01 -3.9160098266601562e+02 6.0450901031494141e+01 8.0992897033691406e+01 -4.8320498657226562e+02 6.8412399291992188e+01 1.0917499542236328e+02 -4.8195898437500000e+02 3.6712699890136719e+01 6.4952003479003906e+01 -3.6817700195312500e+02 4.6029399871826172e+01 6.9043395996093750e+01 -4.8577099609375000e+02 5.0595001220703125e+01 7.1961898803710938e+01 -4.8366000366210938e+02 2.1635700225830078e+01 6.2401203155517578e+01 -4.8338500976562500e+02 -5.3496799468994141e+00 2.9733898925781250e+02 1.4194400024414062e+02 -2.5222499847412109e+01 3.0657101440429688e+02 1.4194400024414062e+02 -7.7815505981445312e+01 2.7903698730468750e+02 1.4194400024414062e+02 5.4910896301269531e+01 2.7726800537109375e+02 -2.4874000549316406e+02 5.4471897125244141e+01 2.6513000488281250e+02 -2.2128300476074219e+02 5.4691501617431641e+01 2.9386999511718750e+02 -3.1838500976562500e+02 5.6865798950195312e+01 2.8435198974609375e+02 -3.0131500244140625e+02 5.7725601196289062e+01 2.6369900512695312e+02 -2.8730401611328125e+02 4.8052097320556641e+01 3.0261599731445312e+02 -2.8891302490234375e+02 6.5324203491210938e+01 2.6175299072265625e+02 -3.8867199707031250e+02 6.5102302551269531e+01 2.7652600097656250e+02 -4.0381900024414062e+02 6.8174400329589844e+01 2.6864901733398438e+02 -4.7958200073242188e+02 6.3778602600097656e+01 2.8779901123046875e+02 -4.8524600219726562e+02 5.9992801666259766e+01 2.9407400512695312e+02 -4.2564300537109375e+02 5.1288002014160156e+01 3.0411898803710938e+02 -4.8342498779296875e+02 4.8997997283935547e+01 3.0479602050781250e+02 -3.8575198364257812e+02 3.4768501281738281e+01 3.1072598266601562e+02 -2.6661801147460938e+02 4.0111099243164062e+01 3.0968298339843750e+02 -3.7790499877929688e+02 3.1249099731445312e+01 3.1154598999023438e+02 -4.8672802734375000e+02 2.5231599807739258e+01 3.1354498291015625e+02 -3.7020498657226562e+02 4.0435199737548828e+01 2.2924000549316406e+02 -1.4050100708007812e+02 3.5379398345947266e+01 2.0409700012207031e+02 -1.4632701110839844e+02 3.3710800170898438e+01 1.8670700073242188e+02 -1.5197799682617188e+02 3.8041801452636719e+01 2.2967199707031250e+02 -2.9307800292968750e+02 3.6891399383544922e+01 1.4424900817871094e+02 -2.8500100708007812e+02 5.6724601745605469e+01 1.5238400268554688e+02 -4.1753100585937500e+02 2.0352001190185547e+01 2.3076699829101562e+02 -1.7375000000000000e+02 2.0800600051879883e+01 1.4585200500488281e+02 -1.7905500793457031e+02 5.6568397521972656e+01 2.2672100830078125e+02 -4.1521398925781250e+02 5.3439201354980469e+01 1.1432799530029297e+02 -2.3931999206542969e+02 5.8864799499511719e+01 1.1513500213623047e+02 -3.2538900756835938e+02 4.4320899963378906e+01 1.2307800292968750e+02 -2.6502697753906250e+02 5.7672000885009766e+01 1.2355300140380859e+02 -3.7765499877929688e+02 5.7236297607421875e+01 1.3813200378417969e+02 -4.1006500244140625e+02 5.0562500000000000e+01 1.2976699829101562e+02 -3.5103399658203125e+02 6.7357398986816406e+01 1.2661699676513672e+02 -4.2535900878906250e+02 6.3268600463867188e+01 1.4857701110839844e+02 -4.4014700317382812e+02 6.0768299102783203e+01 1.8800000000000000e+02 -4.3790701293945312e+02 6.5125694274902344e+01 1.8547399902343750e+02 -4.4929199218750000e+02 3.3770599365234375e+01 1.3625900268554688e+02 -2.4545800781250000e+02 6.8844306945800781e+01 1.4555500793457031e+02 -4.4780999755859375e+02 6.9593597412109375e+01 1.9967100524902344e+02 -4.5589797973632812e+02 3.0507600784301758e+01 1.2818899536132812e+02 -1.7606399536132812e+02 3.7325199127197266e+01 1.2269599914550781e+02 -1.6570500183105469e+02 4.3810901641845703e+01 7.5048698425292969e+01 -4.9094400024414062e+02 6.2465599060058594e+01 9.1358398437500000e+01 -4.8897601318359375e+02 6.1174697875976562e+01 1.0606200408935547e+02 -4.9099499511718750e+02 6.7371505737304688e+01 1.5317199707031250e+02 -4.8778097534179688e+02 7.0070495605468750e+01 2.0872799682617188e+02 -4.8256497192382812e+02 6.5605300903320312e+01 2.1721699523925781e+02 -4.8958398437500000e+02 4.2002399444580078e+01 2.3302999877929688e+02 -1.2692299652099609e+02 3.4187202453613281e+01 1.8530599975585938e+02 -1.2692299652099609e+02 2.8171400070190430e+01 2.3451599121093750e+02 -1.5264700317382812e+02 2.4904899597167969e+01 1.8330599975585938e+02 -1.6169300842285156e+02 4.0530799865722656e+01 1.4683500671386719e+02 -1.3999900817871094e+02 4.3324298858642578e+01 1.4055200195312500e+02 -1.2692299652099609e+02 2.3212999343872070e+01 1.3716900634765625e+02 -1.7658000183105469e+02 5.1200099945068359e+01 1.1472499847412109e+02 -1.7388899230957031e+02 2.2772100448608398e+01 1.4118699645996094e+02 -1.6369200134277344e+02 3.0628499984741211e+01 1.4163999938964844e+02 -1.4972200012207031e+02 5.2199798583984375e+01 2.6023098754882812e+02 -2.5313899230957031e+02 4.3601799011230469e+01 2.5182699584960938e+02 -2.6421401977539062e+02 5.5447898864746094e+01 2.5561698913574219e+02 -3.4373699951171875e+02 3.3618099212646484e+01 2.4035600280761719e+02 -2.4359400939941406e+02 6.0310501098632812e+01 2.4723100280761719e+02 -4.0998797607421875e+02 6.3381999969482422e+01 2.5484498596191406e+02 -3.9515798950195312e+02 5.3292900085449219e+01 2.4111999511718750e+02 -3.8138397216796875e+02 6.3668495178222656e+01 2.2784100341796875e+02 -4.4042501831054688e+02 6.7989799499511719e+01 2.4446600341796875e+02 -4.3456799316406250e+02 3.6272701263427734e+01 2.5282099914550781e+02 -1.7338800048828125e+02 2.2915300369262695e+01 2.3837199401855469e+02 -1.7542199707031250e+02 5.1267898559570312e+01 2.6134802246093750e+02 -1.7844801330566406e+02 6.6065803527832031e+01 2.7116799926757812e+02 -4.8713601684570312e+02 5.5346401214599609e+01 2.9267599487304688e+02 -4.9100198364257812e+02 4.9384998321533203e+01 2.4524099731445312e+02 -1.3719200134277344e+02 4.6587898254394531e+01 2.5167999267578125e+02 -1.4516999816894531e+02 3.1689800262451172e+01 2.4677699279785156e+02 -1.6045600891113281e+02 4.9874397277832031e+01 1.3009100341796875e+02 -1.3708599853515625e+02 4.4320098876953125e+01 1.2456700134277344e+02 -1.4733399963378906e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 82 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0044000297784805e+02 1.0993599891662598e+02 1.4194400608539581e+02) (float-vector -8.6448900401592255e+01 9.4626002013683319e+01 -9.2565096914768219e+01) (float-vector -9.8202198743820190e+01 1.0736099630594254e+02 -4.8480701446533203e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0044000297784805e+02 1.0993599891662598e+02 1.4194400608539581e+02) (float-vector -6.9274097681045532e+01 8.1416197121143341e+01 1.4194400608539581e+02) (float-vector -8.6448900401592255e+01 9.4626002013683319e+01 -9.2565096914768219e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2711900472640991e+02 1.9181199371814728e+02 1.4194400608539581e+02) (float-vector -1.2588199973106384e+02 1.7042699456214905e+02 2.0804300904273987e+01) (float-vector -1.2632499635219574e+02 1.7349199950695038e+02 -4.8305800557136536e+02) (float-vector -1.2667199969291687e+02 1.9680200517177582e+02 -4.8404198884963989e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1288001239299774e+01 3.0411899089813232e+02 -4.8342499136924744e+02) (float-vector 3.1249100342392921e+01 3.1154599785804749e+02 -4.8672801256179810e+02) (float-vector 5.5346399545669556e+01 2.9267600178718567e+02 -4.9100199341773987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1288001239299774e+01 3.0411899089813232e+02 -4.8342499136924744e+02) (float-vector 2.1923300623893738e+02 3.0627799034118652e+02 -1.9833499565720558e+01) (float-vector 2.1335899829864502e+02 3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 1.8967899680137634e+02 3.1497499346733093e+02 -4.9712598323822021e+01) (float-vector 3.1249100342392921e+01 3.1154599785804749e+02 -4.8672801256179810e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.3879601657390594e+01 7.7930800616741180e+01 -4.8355400562286377e+02) (float-vector -6.9274097681045532e+01 8.1416197121143341e+01 1.4194400608539581e+02) (float-vector -2.0531499758362770e+01 6.2424298375844955e+01 1.4194400608539581e+02) (float-vector -2.0386200398206711e+01 6.2258400022983551e+01 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2269700318574905e+02 2.2211800515651703e+02 -4.8232099413871765e+02) (float-vector -1.2200599908828735e+02 2.2411400079727173e+02 1.4194400608539581e+02) (float-vector -1.2711900472640991e+02 1.9181199371814728e+02 1.4194400608539581e+02) (float-vector -1.2667199969291687e+02 1.9680200517177582e+02 -4.8404198884963989e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0613600164651871e+02 2.5798898935317993e+02 -4.8381099104881287e+02) (float-vector -1.0817500203847885e+02 2.5501400232315063e+02 1.4194400608539581e+02) (float-vector -1.2200599908828735e+02 2.2411400079727173e+02 1.4194400608539581e+02) (float-vector -1.2269700318574905e+02 2.2211800515651703e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2146700173616409e+02 1.5050600469112396e+02 1.4194400608539581e+02) (float-vector -1.2588199973106384e+02 1.7042699456214905e+02 2.0804300904273987e+01) (float-vector -1.2711900472640991e+02 1.9181199371814728e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.1249100342392921e+01 3.1154599785804749e+02 -4.8672801256179810e+02) (float-vector -5.3559802472591400e-01 3.1242498755455017e+02 -4.8864099383354187e+02) (float-vector -1.7018400132656097e+01 3.0677500367164612e+02 -4.9095699191093445e+02) (float-vector 5.5346399545669556e+01 2.9267600178718567e+02 -4.9100199341773987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1831800490617752e+01 3.0392599105834961e+02 -4.8419100046157837e+02) (float-vector -8.8373199105262756e+01 2.7959701418876648e+02 -4.8306900262832642e+02) (float-vector -7.3221199214458466e+01 2.8443801403045654e+02 -4.9096000194549561e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.5346399545669556e+01 2.9267600178718567e+02 -4.9100199341773987e+02) (float-vector 6.3778601586818695e+01 2.8779900074005127e+02 -4.8524600267410278e+02) (float-vector 2.1923300623893738e+02 3.0627799034118652e+02 -1.9833499565720558e+01) (float-vector 5.1288001239299774e+01 3.0411899089813232e+02 -4.8342499136924744e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.3778601586818695e+01 2.8779900074005127e+02 -4.8524600267410278e+02) (float-vector 5.5346399545669556e+01 2.9267600178718567e+02 -4.9100199341773987e+02) (float-vector 6.2465600669384003e+01 9.1358400881290436e+01 -4.8897600173950195e+02) (float-vector 6.6065803170204163e+01 2.7116799354553223e+02 -4.8713600635528564e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0930400341749191e+01 3.1458398699760437e+02 1.4194400608539581e+02) (float-vector -4.8489298671483994e+01 3.0594500899314880e+02 1.4194400608539581e+02) (float-vector -2.1231399849057198e+01 3.1333500146865845e+02 3.2805200666189194e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.8489298671483994e+01 3.0594500899314880e+02 1.4194400608539581e+02) (float-vector -8.3949401974678040e+01 2.8331801295280457e+02 1.4194400608539581e+02) (float-vector -8.8373199105262756e+01 2.7959701418876648e+02 -4.8306900262832642e+02) (float-vector -5.1831800490617752e+01 3.0392599105834961e+02 -4.8419100046157837e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7018898427486420e+01 8.1554502248764038e+01 -4.9092501401901245e+02) (float-vector -7.9504400491714478e+01 9.5229201018810272e+01 -4.9013099074363708e+02) (float-vector -6.3879601657390594e+01 7.7930800616741180e+01 -4.8355400562286377e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9274097681045532e+01 8.1416197121143341e+01 1.4194400608539581e+02) (float-vector -6.3879601657390594e+01 7.7930800616741180e+01 -4.8355400562286377e+02) (float-vector -7.9504400491714478e+01 9.5229201018810272e+01 -4.9013099074363708e+02) (float-vector -9.8202198743820190e+01 1.0736099630594254e+02 -4.8480701446533203e+02) (float-vector -8.6448900401592255e+01 9.4626002013683319e+01 -9.2565096914768219e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0817900300025940e+02 1.2132199853658676e+02 -4.8531100153923035e+02) (float-vector -9.8202198743820190e+01 1.0736099630594254e+02 -4.8480701446533203e+02) (float-vector -7.9504400491714478e+01 9.5229201018810272e+01 -4.9013099074363708e+02) (float-vector -1.0650800168514252e+02 1.3267800211906433e+02 -4.9088999629020691e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.8202198743820190e+01 1.0736099630594254e+02 -4.8480701446533203e+02) (float-vector -1.0817900300025940e+02 1.2132199853658676e+02 -4.8531100153923035e+02) (float-vector -1.1751300096511841e+02 1.3945500552654266e+02 -4.8154601454734802e+02) (float-vector -1.2146700173616409e+02 1.5050600469112396e+02 1.4194400608539581e+02) (float-vector -1.0044000297784805e+02 1.0993599891662598e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2283100187778473e+02 1.6820800304412842e+02 -4.8846301436424255e+02) (float-vector -1.1751300096511841e+02 1.3945500552654266e+02 -4.8154601454734802e+02) (float-vector -1.0817900300025940e+02 1.2132199853658676e+02 -4.8531100153923035e+02) (float-vector -1.0650800168514252e+02 1.3267800211906433e+02 -4.9088999629020691e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2283100187778473e+02 1.6820800304412842e+02 -4.8846301436424255e+02) (float-vector -1.2632499635219574e+02 1.7349199950695038e+02 -4.8305800557136536e+02) (float-vector -1.2588199973106384e+02 1.7042699456214905e+02 2.0804300904273987e+01) (float-vector -1.2146700173616409e+02 1.5050600469112396e+02 1.4194400608539581e+02) (float-vector -1.1751300096511841e+02 1.3945500552654266e+02 -4.8154601454734802e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1831800490617752e+01 3.0392599105834961e+02 -4.8419100046157837e+02) (float-vector -3.3772498369216919e+01 3.1012898683547974e+02 -4.8577499389648438e+02) (float-vector -2.2900799289345741e+01 3.1294101476669312e+02 -4.7951799631118774e+02) (float-vector -2.1231399849057198e+01 3.1333500146865845e+02 3.2805200666189194e+01) (float-vector -4.8489298671483994e+01 3.0594500899314880e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3559802472591400e-01 3.1242498755455017e+02 -4.8864099383354187e+02) (float-vector -3.3772498369216919e+01 3.1012898683547974e+02 -4.8577499389648438e+02) (float-vector -5.1831800490617752e+01 3.0392599105834961e+02 -4.8419100046157837e+02) (float-vector -7.3221199214458466e+01 2.8443801403045654e+02 -4.9096000194549561e+02) (float-vector -1.7018400132656097e+01 3.0677500367164612e+02 -4.9095699191093445e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.8373199105262756e+01 2.7959701418876648e+02 -4.8306900262832642e+02) (float-vector -9.8200798034667969e+01 2.6410698890686035e+02 -4.8877400159835815e+02) (float-vector -7.3221199214458466e+01 2.8443801403045654e+02 -4.9096000194549561e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1384999752044678e+02 2.2830000519752502e+02 -4.9088498950004578e+02) (float-vector -9.8200798034667969e+01 2.6410698890686035e+02 -4.8877400159835815e+02) (float-vector -1.0613600164651871e+02 2.5798898935317993e+02 -4.8381099104881287e+02) (float-vector -1.2269700318574905e+02 2.2211800515651703e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0613600164651871e+02 2.5798898935317993e+02 -4.8381099104881287e+02) (float-vector -9.8200798034667969e+01 2.6410698890686035e+02 -4.8877400159835815e+02) (float-vector -8.8373199105262756e+01 2.7959701418876648e+02 -4.8306900262832642e+02) (float-vector -8.3949401974678040e+01 2.8331801295280457e+02 1.4194400608539581e+02) (float-vector -1.0817500203847885e+02 2.5501400232315063e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6029400080442429e+01 6.9043397903442383e+01 -4.8577100038528442e+02) (float-vector 6.0450900346040726e+01 8.0992899835109711e+01 -4.8320499062538147e+02) (float-vector 6.2465600669384003e+01 9.1358400881290436e+01 -4.8897600173950195e+02) (float-vector 4.3810900300741196e+01 7.5048699975013733e+01 -4.9094399809837341e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6029400080442429e+01 6.9043397903442383e+01 -4.8577100038528442e+02) (float-vector 2.0559400320053101e+02 6.3598096370697021e+01 -3.7847198545932770e+01) (float-vector 2.1923300623893738e+02 6.9722399115562439e+01 -1.9833499565720558e+01) (float-vector 6.0450900346040726e+01 8.0992899835109711e+01 -4.8320499062538147e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1635700017213821e+01 6.2401201575994492e+01 -4.8338499665260315e+02) (float-vector 1.9505800306797028e+02 6.1004601418972015e+01 -1.7240200191736221e+01) (float-vector 2.0559400320053101e+02 6.3598096370697021e+01 -3.7847198545932770e+01) (float-vector 4.6029400080442429e+01 6.9043397903442383e+01 -4.8577100038528442e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1923300623893738e+02 3.0627799034118652e+02 -1.9833499565720558e+01) (float-vector 6.3778601586818695e+01 2.8779900074005127e+02 -4.8524600267410278e+02) (float-vector 6.6065803170204163e+01 2.7116799354553223e+02 -4.8713600635528564e+02) (float-vector 2.2358399629592896e+02 2.9319998621940613e+02 -1.9464299082756042e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2650299966335297e+02 2.6739400625228882e+02 1.4042600058019161e+01) (float-vector 2.2435900568962097e+02 2.9252299666404724e+02 1.2755200266838074e+01) (float-vector 2.2358399629592896e+02 2.9319998621940613e+02 -1.9464299082756042e+01) (float-vector 2.2587600350379944e+02 1.0860799998044968e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2358399629592896e+02 2.9319998621940613e+02 -1.9464299082756042e+01) (float-vector 2.2435900568962097e+02 2.9252299666404724e+02 1.2755200266838074e+01) (float-vector 2.1694299578666687e+02 3.0258700251579285e+02 3.5626601427793503e+01) (float-vector 2.1335899829864502e+02 3.1186699867248535e+02 -6.0748001560568810e+00) (float-vector 2.1923300623893738e+02 3.0627799034118652e+02 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1694299578666687e+02 3.0258700251579285e+02 3.5626601427793503e+01) (float-vector 2.0883299410343170e+02 3.1196799874305725e+02 3.2384399324655533e+01) (float-vector 2.1335899829864502e+02 3.1186699867248535e+02 -6.0748001560568810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 3.1196799874305725e+02 3.2384399324655533e+01) (float-vector 2.1694299578666687e+02 3.0258700251579285e+02 3.5626601427793503e+01) (float-vector 1.9633999466896057e+02 3.0925899744033813e+02 6.6335096955299377e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900799289345741e+01 3.1294101476669312e+02 -4.7951799631118774e+02) (float-vector -3.3772498369216919e+01 3.1012898683547974e+02 -4.8577499389648438e+02) (float-vector -5.3559802472591400e-01 3.1242498755455017e+02 -4.8864099383354187e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8835901319980621e+01 2.8740501403808594e+02 1.4194400608539581e+02) (float-vector 1.5508300065994263e+02 2.6739901304244995e+02 1.1465500295162201e+02) (float-vector 1.4104899764060974e+02 1.0858699679374695e+02 1.2079499661922455e+02) (float-vector 5.5495601147413254e+01 7.4161298573017120e+01 1.4194299280643463e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2667199969291687e+02 1.9680200517177582e+02 -4.8404198884963989e+02) (float-vector -1.2008500099182129e+02 2.0513500273227692e+02 -4.9096199870109558e+02) (float-vector -1.1384999752044678e+02 2.2830000519752502e+02 -4.9088498950004578e+02) (float-vector -1.2269700318574905e+02 2.2211800515651703e+02 -4.8232099413871765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2008500099182129e+02 2.0513500273227692e+02 -4.9096199870109558e+02) (float-vector -1.2667199969291687e+02 1.9680200517177582e+02 -4.8404198884963989e+02) (float-vector -1.2632499635219574e+02 1.7349199950695038e+02 -4.8305800557136536e+02) (float-vector -1.2283100187778473e+02 1.6820800304412842e+02 -4.8846301436424255e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6213800013065338e+02 6.6978298127651215e+01 9.8933696746826172e+01) (float-vector 1.8280999362468719e+02 6.4494699239730835e+01 7.7822700142860413e+01) (float-vector 2.0096099376678467e+02 6.2158200889825821e+01 3.5687398165464401e+01) (float-vector 4.4208098202943802e+01 6.4324498176574707e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3539200425148010e+01 6.9229297339916229e+01 -4.9085399508476257e+02) (float-vector -5.7018898427486420e+01 8.1554502248764038e+01 -4.9092501401901245e+02) (float-vector -6.3879601657390594e+01 7.7930800616741180e+01 -4.8355400562286377e+02) (float-vector -2.0386200398206711e+01 6.2258400022983551e+01 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.2465600669384003e+01 9.1358400881290436e+01 -4.8897600173950195e+02) (float-vector 2.1649299561977386e+02 9.0627200901508331e+01 -4.7570601105690002e+01) (float-vector 2.2587600350379944e+02 1.0860799998044968e+02 -1.7441999167203903e+01) (float-vector 2.2358399629592896e+02 2.9319998621940613e+02 -1.9464299082756042e+01) (float-vector 6.6065803170204163e+01 2.7116799354553223e+02 -4.8713600635528564e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0559400320053101e+02 6.3598096370697021e+01 -3.7847198545932770e+01) (float-vector 2.1335899829864502e+02 6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 2.1923300623893738e+02 6.9722399115562439e+01 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1335899829864502e+02 6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 2.0559400320053101e+02 6.3598096370697021e+01 -3.7847198545932770e+01) (float-vector 1.9505800306797028e+02 6.1004601418972015e+01 -1.7240200191736221e+01) (float-vector 2.0096099376678467e+02 6.2158200889825821e+01 3.5687398165464401e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 6.7833699285984039e+01 4.8401098698377609e+01) (float-vector 2.1820700168609619e+02 8.4266200661659241e+01 4.0720399469137192e+01) (float-vector 2.1591199934482574e+02 6.8083100020885468e+01 2.6680400595068932e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 6.7833699285984039e+01 4.8401098698377609e+01) (float-vector 2.0096099376678467e+02 6.2158200889825821e+01 3.5687398165464401e+01) (float-vector 1.8280999362468719e+02 6.4494699239730835e+01 7.7822700142860413e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0798799395561218e+02 6.7833699285984039e+01 4.8401098698377609e+01) (float-vector 2.1591199934482574e+02 6.8083100020885468e+01 2.6680400595068932e+01) (float-vector 2.1335899829864502e+02 6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 2.0096099376678467e+02 6.2158200889825821e+01 3.5687398165464401e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2492699325084686e+02 8.4692202508449554e+01 1.0091500356793404e+01) (float-vector 2.1591199934482574e+02 6.8083100020885468e+01 2.6680400595068932e+01) (float-vector 2.1820700168609619e+02 8.4266200661659241e+01 4.0720399469137192e+01) (float-vector 2.2490300238132477e+02 1.0860799998044968e+02 2.6359599083662033e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 3.1196799874305725e+02 3.2384399324655533e+01) (float-vector 1.8978999555110931e+02 3.1498798727989197e+02 3.4521799534559250e+01) (float-vector 1.8967899680137634e+02 3.1497499346733093e+02 -4.9712598323822021e+01) (float-vector 2.1335899829864502e+02 3.1186699867248535e+02 -6.0748001560568810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900799289345741e+01 3.1294101476669312e+02 -4.7951799631118774e+02) (float-vector -5.3559802472591400e-01 3.1242498755455017e+02 -4.8864099383354187e+02) (float-vector 3.1249100342392921e+01 3.1154599785804749e+02 -4.8672801256179810e+02) (float-vector 1.8967899680137634e+02 3.1497499346733093e+02 -4.9712598323822021e+01) (float-vector 1.8978999555110931e+02 3.1498798727989197e+02 3.4521799534559250e+01) (float-vector 1.4279399812221527e+02 3.1470900774002075e+02 9.3671001493930817e+01) (float-vector 2.4879999458789825e+01 3.1487900018692017e+02 1.4194400608539581e+02) (float-vector -1.0930400341749191e+01 3.1458398699760437e+02 1.4194400608539581e+02) (float-vector -2.1231399849057198e+01 3.1333500146865845e+02 3.2805200666189194e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9274097681045532e+01 8.1416197121143341e+01 1.4194400608539581e+02) (float-vector -1.0044000297784805e+02 1.0993599891662598e+02 1.4194400608539581e+02) (float-vector -1.2146700173616409e+02 1.5050600469112396e+02 1.4194400608539581e+02) (float-vector -1.2711900472640991e+02 1.9181199371814728e+02 1.4194400608539581e+02) (float-vector -1.2200599908828735e+02 2.2411400079727173e+02 1.4194400608539581e+02) (float-vector -1.0817500203847885e+02 2.5501400232315063e+02 1.4194400608539581e+02) (float-vector -8.3949401974678040e+01 2.8331801295280457e+02 1.4194400608539581e+02) (float-vector -4.8489298671483994e+01 3.0594500899314880e+02 1.4194400608539581e+02) (float-vector -1.0930400341749191e+01 3.1458398699760437e+02 1.4194400608539581e+02) (float-vector 2.4879999458789825e+01 3.1487900018692017e+02 1.4194400608539581e+02) (float-vector 5.0127498805522919e+01 3.0943799018859863e+02 1.4194400608539581e+02) (float-vector 5.8835901319980621e+01 2.8740501403808594e+02 1.4194400608539581e+02) (float-vector 5.5495601147413254e+01 7.4161298573017120e+01 1.4194299280643463e+02) (float-vector 4.4208098202943802e+01 6.4324498176574707e+01 1.4194400608539581e+02) (float-vector -2.0531499758362770e+01 6.2424298375844955e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4271399378776550e+02 2.9263699054718018e+02 1.1685799807310104e+02) (float-vector 5.0127498805522919e+01 3.0943799018859863e+02 1.4194400608539581e+02) (float-vector 1.3801500201225281e+02 3.0669501423835754e+02 1.1298099905252457e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0127498805522919e+01 3.0943799018859863e+02 1.4194400608539581e+02) (float-vector 1.4271399378776550e+02 2.9263699054718018e+02 1.1685799807310104e+02) (float-vector 1.5508300065994263e+02 2.6739901304244995e+02 1.1465500295162201e+02) (float-vector 5.8835901319980621e+01 2.8740501403808594e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5101799508556724e+00 6.4647600054740906e+01 -4.8928499221801758e+02) (float-vector -2.3539200425148010e+01 6.9229297339916229e+01 -4.9085399508476257e+02) (float-vector -2.0386200398206711e+01 6.2258400022983551e+01 -4.8366799950599670e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5101799508556724e+00 6.4647600054740906e+01 -4.8928499221801758e+02) (float-vector 2.1635700017213821e+01 6.2401201575994492e+01 -4.8338499665260315e+02) (float-vector 4.6029400080442429e+01 6.9043397903442383e+01 -4.8577100038528442e+02) (float-vector 4.3810900300741196e+01 7.5048699975013733e+01 -4.9094399809837341e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1384999752044678e+02 2.2830000519752502e+02 -4.9088498950004578e+02) (float-vector -1.2008500099182129e+02 2.0513500273227692e+02 -4.9096199870109558e+02) (float-vector -1.2283100187778473e+02 1.6820800304412842e+02 -4.8846301436424255e+02) (float-vector -1.0650800168514252e+02 1.3267800211906433e+02 -4.9088999629020691e+02) (float-vector -7.9504400491714478e+01 9.5229201018810272e+01 -4.9013099074363708e+02) (float-vector -5.7018898427486420e+01 8.1554502248764038e+01 -4.9092501401901245e+02) (float-vector -2.3539200425148010e+01 6.9229297339916229e+01 -4.9085399508476257e+02) (float-vector 1.5101799508556724e+00 6.4647600054740906e+01 -4.8928499221801758e+02) (float-vector 4.3810900300741196e+01 7.5048699975013733e+01 -4.9094399809837341e+02) (float-vector 6.2465600669384003e+01 9.1358400881290436e+01 -4.8897600173950195e+02) (float-vector 5.5346399545669556e+01 2.9267600178718567e+02 -4.9100199341773987e+02) (float-vector -1.7018400132656097e+01 3.0677500367164612e+02 -4.9095699191093445e+02) (float-vector -7.3221199214458466e+01 2.8443801403045654e+02 -4.9096000194549561e+02) (float-vector -9.8200798034667969e+01 2.6410698890686035e+02 -4.8877400159835815e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4208098202943802e+01 6.4324498176574707e+01 1.4194400608539581e+02) (float-vector 2.0096099376678467e+02 6.2158200889825821e+01 3.5687398165464401e+01) (float-vector 1.9505800306797028e+02 6.1004601418972015e+01 -1.7240200191736221e+01) (float-vector 2.1635700017213821e+01 6.2401201575994492e+01 -4.8338499665260315e+02) (float-vector 1.5101799508556724e+00 6.4647600054740906e+01 -4.8928499221801758e+02) (float-vector -2.0386200398206711e+01 6.2258400022983551e+01 -4.8366799950599670e+02) (float-vector -2.0531499758362770e+01 6.2424298375844955e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1649299561977386e+02 9.0627200901508331e+01 -4.7570601105690002e+01) (float-vector 2.2299399971961975e+02 8.1605397164821625e+01 -2.0850200206041336e+01) (float-vector 2.2587600350379944e+02 1.0860799998044968e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 8.1605397164821625e+01 -2.0850200206041336e+01) (float-vector 2.1649299561977386e+02 9.0627200901508331e+01 -4.7570601105690002e+01) (float-vector 6.2465600669384003e+01 9.1358400881290436e+01 -4.8897600173950195e+02) (float-vector 6.0450900346040726e+01 8.0992899835109711e+01 -4.8320499062538147e+02) (float-vector 2.1923300623893738e+02 6.9722399115562439e+01 -1.9833499565720558e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 8.1605397164821625e+01 -2.0850200206041336e+01) (float-vector 2.2492699325084686e+02 8.4692202508449554e+01 1.0091500356793404e+01) (float-vector 2.2490300238132477e+02 1.0860799998044968e+02 2.6359599083662033e+01) (float-vector 2.2650299966335297e+02 2.6739400625228882e+02 1.4042600058019161e+01) (float-vector 2.2587600350379944e+02 1.0860799998044968e+02 -1.7441999167203903e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2299399971961975e+02 8.1605397164821625e+01 -2.0850200206041336e+01) (float-vector 2.1923300623893738e+02 6.9722399115562439e+01 -1.9833499565720558e+01) (float-vector 2.1335899829864502e+02 6.4132899045944214e+01 -6.0748001560568810e+00) (float-vector 2.1591199934482574e+02 6.8083100020885468e+01 2.6680400595068932e+01) (float-vector 2.2492699325084686e+02 8.4692202508449554e+01 1.0091500356793404e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9659300148487091e+02 7.4313499033451080e+01 7.4555598199367523e+01) (float-vector 2.0798799395561218e+02 6.7833699285984039e+01 4.8401098698377609e+01) (float-vector 1.8280999362468719e+02 6.4494699239730835e+01 7.7822700142860413e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8365700542926788e+02 7.7408298850059509e+01 9.0514600276947021e+01) (float-vector 1.6411300003528595e+02 7.7874101698398590e+01 1.0537499934434891e+02) (float-vector 1.7702099680900574e+02 1.0860700160264969e+02 1.0179799795150757e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8291999399662018e+02 2.6740700006484985e+02 9.6916697919368744e+01) (float-vector 1.7702099680900574e+02 1.0860700160264969e+02 1.0179799795150757e+02) (float-vector 1.6411300003528595e+02 7.7874101698398590e+01 1.0537499934434891e+02) (float-vector 1.4104899764060974e+02 1.0858699679374695e+02 1.2079499661922455e+02) (float-vector 1.5508300065994263e+02 2.6739901304244995e+02 1.1465500295162201e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.5495601147413254e+01 7.4161298573017120e+01 1.4194299280643463e+02) (float-vector 1.4104899764060974e+02 1.0858699679374695e+02 1.2079499661922455e+02) (float-vector 1.6411300003528595e+02 7.7874101698398590e+01 1.0537499934434891e+02) (float-vector 4.4208098202943802e+01 6.4324498176574707e+01 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6411300003528595e+02 7.7874101698398590e+01 1.0537499934434891e+02) (float-vector 1.8365700542926788e+02 7.7408298850059509e+01 9.0514600276947021e+01) (float-vector 1.9659300148487091e+02 7.4313499033451080e+01 7.4555598199367523e+01) (float-vector 1.8280999362468719e+02 6.4494699239730835e+01 7.7822700142860413e+01) (float-vector 1.6213800013065338e+02 6.6978298127651215e+01 9.8933696746826172e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6213800013065338e+02 6.6978298127651215e+01 9.8933696746826172e+01) (float-vector 4.4208098202943802e+01 6.4324498176574707e+01 1.4194400608539581e+02) (float-vector 1.6411300003528595e+02 7.7874101698398590e+01 1.0537499934434891e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2490300238132477e+02 1.0860799998044968e+02 2.6359599083662033e+01) (float-vector 2.2066900134086609e+02 2.6739498972892761e+02 4.0891099721193314e+01) (float-vector 2.2650299966335297e+02 2.6739400625228882e+02 1.4042600058019161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.2650299966335297e+02 2.6739400625228882e+02 1.4042600058019161e+01) (float-vector 2.2066900134086609e+02 2.6739498972892761e+02 4.0891099721193314e+01) (float-vector 2.0858399569988251e+02 2.9165899753570557e+02 6.1897300183773041e+01) (float-vector 2.1694299578666687e+02 3.0258700251579285e+02 3.5626601427793503e+01) (float-vector 2.2435900568962097e+02 2.9252299666404724e+02 1.2755200266838074e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9786100089550018e+02 2.9951000213623047e+02 7.4741497635841370e+01) (float-vector 1.9633999466896057e+02 3.0925899744033813e+02 6.6335096955299377e+01) (float-vector 2.1694299578666687e+02 3.0258700251579285e+02 3.5626601427793503e+01) (float-vector 2.0858399569988251e+02 2.9165899753570557e+02 6.1897300183773041e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 3.0083200335502625e+02 9.1508001089096069e+01) (float-vector 1.9786100089550018e+02 2.9951000213623047e+02 7.4741497635841370e+01) (float-vector 2.0858399569988251e+02 2.9165899753570557e+02 6.1897300183773041e+01) (float-vector 2.0269399881362915e+02 2.6739099621772766e+02 7.5614199042320251e+01) (float-vector 1.8291999399662018e+02 2.6740700006484985e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4271399378776550e+02 2.9263699054718018e+02 1.1685799807310104e+02) (float-vector 1.6375499963760376e+02 2.9139599204063416e+02 1.0734999924898148e+02) (float-vector 1.5508300065994263e+02 2.6739901304244995e+02 1.1465500295162201e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6375499963760376e+02 2.9139599204063416e+02 1.0734999924898148e+02) (float-vector 1.8101300299167633e+02 3.0083200335502625e+02 9.1508001089096069e+01) (float-vector 1.8291999399662018e+02 2.6740700006484985e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5508300065994263e+02 2.6739901304244995e+02 1.1465500295162201e+02) (float-vector 1.6375499963760376e+02 2.9139599204063416e+02 1.0734999924898148e+02) (float-vector 1.8291999399662018e+02 2.6740700006484985e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4879999458789825e+01 3.1487900018692017e+02 1.4194400608539581e+02) (float-vector 1.4279399812221527e+02 3.1470900774002075e+02 9.3671001493930817e+01) (float-vector 1.6528600454330444e+02 3.0767199397087097e+02 9.8848700523376465e+01) (float-vector 1.3801500201225281e+02 3.0669501423835754e+02 1.1298099905252457e+02) (float-vector 5.0127498805522919e+01 3.0943799018859863e+02 1.4194400608539581e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 3.0083200335502625e+02 9.1508001089096069e+01) (float-vector 1.6528600454330444e+02 3.0767199397087097e+02 9.8848700523376465e+01) (float-vector 1.9633999466896057e+02 3.0925899744033813e+02 6.6335096955299377e+01) (float-vector 1.9786100089550018e+02 2.9951000213623047e+02 7.4741497635841370e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0883299410343170e+02 3.1196799874305725e+02 3.2384399324655533e+01) (float-vector 1.9633999466896057e+02 3.0925899744033813e+02 6.6335096955299377e+01) (float-vector 1.6528600454330444e+02 3.0767199397087097e+02 9.8848700523376465e+01) (float-vector 1.4279399812221527e+02 3.1470900774002075e+02 9.3671001493930817e+01) (float-vector 1.8978999555110931e+02 3.1498798727989197e+02 3.4521799534559250e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8101300299167633e+02 3.0083200335502625e+02 9.1508001089096069e+01) (float-vector 1.6375499963760376e+02 2.9139599204063416e+02 1.0734999924898148e+02) (float-vector 1.4271399378776550e+02 2.9263699054718018e+02 1.1685799807310104e+02) (float-vector 1.3801500201225281e+02 3.0669501423835754e+02 1.1298099905252457e+02) (float-vector 1.6528600454330444e+02 3.0767199397087097e+02 9.8848700523376465e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0269399881362915e+02 2.6739099621772766e+02 7.5614199042320251e+01) (float-vector 2.0350900292396545e+02 1.0859200358390808e+02 7.4386402964591980e+01) (float-vector 1.7702099680900574e+02 1.0860700160264969e+02 1.0179799795150757e+02) (float-vector 1.8291999399662018e+02 2.6740700006484985e+02 9.6916697919368744e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0350900292396545e+02 1.0859200358390808e+02 7.4386402964591980e+01) (float-vector 2.0269399881362915e+02 2.6739099621772766e+02 7.5614199042320251e+01) (float-vector 2.0858399569988251e+02 2.9165899753570557e+02 6.1897300183773041e+01) (float-vector 2.2066900134086609e+02 2.6739498972892761e+02 4.0891099721193314e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0847299695014954e+02 8.4609001874923706e+01 6.2196400016546249e+01) (float-vector 2.0350900292396545e+02 1.0859200358390808e+02 7.4386402964591980e+01) (float-vector 2.2066900134086609e+02 2.6739498972892761e+02 4.0891099721193314e+01) (float-vector 2.2490300238132477e+02 1.0860799998044968e+02 2.6359599083662033e+01) (float-vector 2.1820700168609619e+02 8.4266200661659241e+01 4.0720399469137192e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9659300148487091e+02 7.4313499033451080e+01 7.4555598199367523e+01) (float-vector 2.0847299695014954e+02 8.4609001874923706e+01 6.2196400016546249e+01) (float-vector 2.1820700168609619e+02 8.4266200661659241e+01 4.0720399469137192e+01) (float-vector 2.0798799395561218e+02 6.7833699285984039e+01 4.8401098698377609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0847299695014954e+02 8.4609001874923706e+01 6.2196400016546249e+01) (float-vector 1.9659300148487091e+02 7.4313499033451080e+01 7.4555598199367523e+01) (float-vector 1.8365700542926788e+02 7.7408298850059509e+01 9.0514600276947021e+01) (float-vector 1.7702099680900574e+02 1.0860700160264969e+02 1.0179799795150757e+02) (float-vector 2.0350900292396545e+02 1.0859200358390808e+02 7.4386402964591980e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_shoulder_pan_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_upper_arm_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.400000 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.800000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 202 203 0 215 0 2 609 0 607 215 698 0 202 0 698 0 609 1 0 203 607 457 458 215 458 698 215 457 215 2 698 458 122 122 434 698 434 202 698 120 458 457 458 120 122 457 658 120 658 457 2 120 658 161 466 658 678 161 658 466 678 658 768 658 2 768 768 2 704 2 1 704 768 704 785 678 768 785 466 678 237 238 678 785 237 678 238 634 785 584 704 347 785 347 584 785 238 785 634 1 537 704 537 347 704 1 609 72 1 72 537 537 71 348 72 71 537 347 537 348 346 347 348 346 584 347 348 71 446 446 346 348 534 346 445 346 446 445 346 534 584 445 26 534 171 584 534 26 694 534 694 171 534 445 446 27 27 26 445 26 27 28 694 26 28 171 694 583 694 28 195 195 594 694 594 583 694 446 28 27 195 28 683 683 28 446 683 446 305 683 305 307 683 447 195 307 447 683 306 305 446 306 446 71 305 306 307 307 645 447 414 307 306 307 414 645 415 306 71 415 414 306 70 71 72 71 410 415 70 410 71 414 415 409 409 415 410 414 628 645 409 628 414 409 410 411 628 409 411 410 38 411 410 642 604 70 642 410 604 38 410 411 38 628 38 39 40 38 604 39 38 40 628 623 604 663 642 403 604 39 604 623 604 403 663 623 40 39 40 623 515 623 663 515 663 403 664 664 515 663 402 664 403 402 81 664 81 515 664 79 80 81 81 713 79 402 713 81 515 81 80 471 79 103 79 193 103 713 193 79 79 471 80 402 529 713 193 713 733 733 713 529 104 103 193 732 193 733 104 193 732 528 747 733 747 732 733 528 733 529 402 528 529 528 402 788 788 374 528 374 747 528 374 376 747 747 554 732 376 554 747 104 732 553 553 732 554 553 554 555 554 330 555 328 554 376 330 554 328 374 375 376 376 375 652 376 652 328 328 329 330 443 329 328 443 328 652 416 330 329 330 416 555 329 309 416 329 443 309 309 308 416 308 102 416 555 416 102 308 309 310 443 310 309 308 339 102 339 308 455 455 308 310 310 475 455 310 443 475 454 455 456 455 475 476 456 455 476 454 629 455 455 629 339 728 475 443 475 728 476 456 476 287 728 121 476 476 121 287 728 443 729 121 728 779 779 728 729 443 652 729 729 652 435 729 435 779 434 122 779 121 779 122 435 434 779 434 435 202 435 375 202 435 652 375 202 375 203 404 375 374 203 375 404 607 203 401 203 404 401 404 402 401 788 404 374 788 402 404 401 402 403 401 403 607 607 403 608 598 609 607 598 607 608 403 599 608 642 599 403 598 608 599 597 598 599 609 598 597 609 597 769 72 609 769 70 597 642 599 642 597 70 769 597 72 769 70 120 121 122 286 287 121 286 121 120 287 286 483 286 120 483 120 654 483 161 113 120 120 113 654 483 112 441 287 483 441 483 654 112 456 287 635 635 287 441 441 183 442 441 442 635 441 112 751 441 751 183 456 635 653 442 653 635 643 454 456 643 456 653 643 653 442 518 643 442 442 183 518 643 630 629 629 454 643 630 643 518 518 629 630 73 174 518 74 518 183 73 518 74 629 518 174 173 629 174 173 339 629 172 173 174 620 172 174 174 73 716 174 716 620 172 444 173 172 622 444 622 172 620 620 621 622 620 716 73 73 780 620 780 621 620 622 621 444 444 782 783 782 444 621 444 783 173 621 780 672 621 672 782 780 73 75 780 723 672 780 75 723 672 373 673 672 723 373 782 672 673 723 428 226 373 723 226 723 75 428 73 74 75 75 182 428 74 182 75 428 227 226 428 182 227 14 226 227 13 277 226 277 373 226 14 13 226 227 207 14 207 227 182 182 74 183 326 207 182 326 182 183 327 183 751 326 183 327 92 326 327 207 326 92 93 92 327 93 327 111 327 751 111 751 112 111 111 112 113 113 112 654 113 161 162 113 162 111 162 161 466 352 353 162 111 162 353 466 4 162 3 162 4 162 3 352 466 265 5 237 265 466 4 466 5 3 4 5 3 361 746 3 626 352 5 361 3 626 3 746 5 264 361 264 5 265 532 531 361 532 361 264 531 746 361 430 746 425 626 746 430 531 425 746 429 625 626 625 352 626 626 430 429 429 430 431 430 425 431 681 429 431 625 429 353 681 353 429 352 625 353 353 681 741 111 353 741 399 681 431 741 681 399 650 399 431 425 424 431 650 431 424 399 400 82 399 650 400 399 82 741 741 82 50 741 50 111 111 50 49 49 93 111 49 50 51 605 50 82 662 50 605 662 51 50 51 269 49 93 49 136 269 136 49 92 93 94 93 136 94 134 135 136 134 136 519 94 136 135 269 519 136 94 422 92 422 94 135 422 207 92 421 422 135 421 207 422 303 135 134 303 421 135 208 207 421 421 303 208 207 208 14 208 303 304 208 12 14 208 735 755 12 208 755 304 735 208 12 13 14 12 755 13 13 755 756 272 755 734 756 755 272 734 755 735 297 734 735 297 735 304 297 296 734 294 272 734 296 294 734 255 296 297 297 800 255 800 297 304 294 296 255 272 294 295 295 294 69 254 69 294 294 255 254 253 254 255 742 253 255 255 800 742 542 254 253 743 69 254 254 542 743 275 274 253 253 274 542 275 253 742 344 275 742 633 344 742 742 800 633 228 274 275 228 275 345 344 345 275 542 274 132 274 133 132 133 274 228 133 228 229 229 228 247 345 247 228 344 247 345 245 246 247 247 344 651 245 247 651 246 229 247 246 245 574 651 575 245 574 245 575 246 574 601 657 229 246 246 601 657 573 574 575 574 573 391 574 687 601 574 391 687 575 651 526 413 573 575 526 413 575 412 573 413 573 412 391 315 412 413 526 527 413 413 196 360 527 196 413 360 315 413 389 412 315 412 389 391 389 390 391 390 389 300 300 389 315 390 233 391 234 390 300 234 233 390 300 301 302 301 300 315 302 234 300 233 234 235 87 235 234 234 302 87 302 301 88 87 302 88 87 88 89 89 235 87 235 638 233 581 235 89 235 581 638 44 89 748 36 89 44 89 88 748 89 36 581 343 88 301 748 88 343 44 748 342 748 343 342 44 45 37 44 342 45 36 44 37 35 36 37 36 35 571 581 36 571 35 37 505 37 45 505 35 289 288 571 35 288 289 35 505 581 571 632 690 632 571 288 775 571 775 690 571 288 289 290 290 775 288 775 499 692 565 775 290 775 565 499 690 775 692 690 731 632 690 692 731 691 692 693 693 692 499 731 692 691 149 439 499 499 565 149 693 499 439 691 693 676 693 439 497 693 497 676 668 691 676 668 731 691 668 639 731 731 639 632 613 668 614 217 614 668 613 639 668 217 668 676 676 497 217 216 217 218 217 10 218 217 216 614 10 217 496 217 497 496 612 613 614 216 686 614 614 686 612 218 701 216 701 686 216 218 10 9 703 218 9 703 701 218 9 10 11 10 496 11 495 496 497 495 11 496 11 393 9 393 11 495 392 9 393 392 703 9 701 703 331 392 331 703 393 479 392 392 479 332 332 331 392 331 332 20 20 229 331 714 701 331 229 714 331 20 21 22 229 20 465 20 332 21 20 22 465 229 440 133 657 714 229 465 440 229 714 657 686 686 701 714 612 657 601 612 686 657 638 613 612 601 638 612 233 601 687 233 638 601 638 639 613 638 632 639 581 632 638 233 687 391 131 133 440 131 440 145 351 145 440 465 351 440 131 132 133 132 131 388 388 387 132 387 542 132 386 387 388 387 67 743 743 542 387 67 387 386 436 61 386 386 163 67 163 386 61 386 388 436 666 436 388 666 617 436 617 61 436 61 62 63 61 63 163 617 616 61 62 61 616 67 163 670 163 726 670 63 726 163 592 726 63 63 62 592 484 62 319 592 62 484 62 616 319 318 592 484 592 318 719 720 592 719 592 720 726 758 670 726 726 720 758 719 472 720 758 720 538 720 539 538 472 539 720 739 670 758 739 758 538 538 539 29 739 538 29 702 29 539 539 472 702 29 30 31 560 29 31 739 29 772 30 29 702 772 29 560 670 739 68 68 739 772 68 67 670 67 68 69 68 772 69 772 560 273 295 69 772 272 772 273 295 772 272 273 560 561 560 31 561 271 272 273 561 271 273 272 271 792 792 756 272 707 271 561 792 271 707 572 707 561 572 561 31 707 572 507 507 792 707 756 792 506 506 792 507 756 506 587 13 756 587 506 507 106 587 506 105 105 506 106 572 106 507 105 106 107 106 572 107 105 251 252 252 278 105 105 107 251 278 587 105 587 277 13 277 587 278 276 277 278 276 278 467 467 278 252 151 383 252 383 467 252 151 252 251 7 467 383 467 7 721 721 276 467 277 276 373 673 276 721 673 373 276 721 7 796 721 796 673 796 782 673 695 789 796 782 796 789 695 796 7 783 782 789 589 783 789 695 589 789 589 695 371 7 371 695 173 589 371 783 589 173 371 7 372 372 173 371 6 7 8 7 6 372 383 8 7 6 8 624 624 372 6 383 646 8 646 624 8 760 646 383 151 760 383 760 151 646 646 150 624 150 646 151 150 151 152 152 151 251 624 150 718 702 150 152 150 702 718 152 591 702 251 591 152 251 107 591 107 572 591 30 702 591 591 572 30 474 702 472 718 702 474 474 473 718 473 624 718 472 473 474 472 719 473 738 624 473 719 738 473 738 372 624 719 372 738 719 318 372 318 173 372 318 319 173 319 318 484 319 616 173 616 617 618 618 568 616 616 568 173 666 618 617 568 618 666 388 569 666 666 569 568 131 569 388 567 568 569 569 131 567 145 567 131 567 145 48 567 48 568 145 146 46 350 145 351 146 145 350 145 46 48 46 47 48 47 102 48 48 102 568 146 753 46 46 753 47 350 753 146 488 350 715 350 351 715 350 488 753 351 465 715 22 715 465 22 488 715 488 22 191 488 270 99 488 191 270 753 488 99 47 753 99 99 100 101 270 100 99 47 99 101 270 191 201 201 100 270 100 130 101 100 201 157 157 130 100 102 101 130 101 102 47 503 130 157 130 503 102 156 157 154 154 157 201 157 156 503 124 102 503 503 156 619 619 709 503 503 709 124 156 154 619 153 154 155 154 153 619 201 155 154 423 619 153 619 423 709 125 709 423 124 709 125 125 423 181 181 423 153 153 155 181 125 181 86 181 155 749 86 181 749 123 124 125 765 125 86 125 765 123 54 85 86 749 54 86 86 85 547 765 86 547 52 749 155 54 749 52 52 53 54 54 706 85 53 706 54 53 52 763 706 53 40 53 763 40 515 85 706 40 515 706 628 40 52 52 40 763 685 628 52 685 667 628 667 645 628 697 685 322 697 667 685 685 52 322 667 160 448 645 667 448 667 697 717 667 717 160 447 645 448 447 448 261 261 448 160 263 447 261 447 263 195 261 262 263 159 262 261 261 160 159 263 262 165 165 195 263 194 195 167 165 167 195 195 194 594 194 593 594 194 759 593 167 759 194 165 166 167 166 596 167 596 759 167 659 759 596 593 759 659 219 593 659 594 593 219 219 583 594 204 206 219 370 417 219 240 583 219 204 219 417 219 659 660 660 370 219 219 241 240 219 206 241 204 205 206 205 241 206 470 205 204 417 470 204 370 468 417 468 470 417 468 469 470 205 470 469 640 205 469 241 205 610 205 640 610 724 469 468 640 469 724 370 369 468 468 369 521 724 468 521 677 640 724 521 677 724 452 640 381 381 640 677 640 452 610 241 610 25 25 610 452 452 453 23 453 452 381 452 23 25 23 24 25 24 239 25 25 239 241 239 240 241 407 408 239 239 408 655 24 407 239 199 239 655 198 239 199 240 239 198 407 24 23 407 513 408 513 407 23 655 408 656 656 408 513 243 530 655 655 656 243 199 655 530 198 199 200 530 200 199 530 242 200 530 243 242 242 243 244 243 656 231 244 243 231 513 489 656 231 656 489 23 489 513 453 477 489 489 700 231 700 489 477 453 489 23 230 231 232 244 231 230 700 232 231 477 148 700 147 232 700 700 148 147 477 478 148 730 478 477 453 730 477 147 148 149 478 149 148 565 147 149 232 147 566 565 566 147 368 232 566 368 230 232 230 368 244 367 244 368 565 368 566 368 290 289 565 290 368 289 367 368 552 504 244 244 367 552 244 504 545 242 244 545 367 289 552 505 552 289 505 504 552 504 505 45 504 546 545 504 45 546 545 546 349 545 200 242 200 545 349 349 546 260 362 260 546 45 362 546 342 362 45 362 342 363 362 259 260 362 363 259 259 198 260 198 349 260 198 200 349 482 481 198 198 508 482 259 508 198 198 481 240 508 259 535 535 259 363 363 342 341 363 341 535 341 342 343 343 727 341 535 341 509 727 509 341 508 535 509 508 509 482 509 562 482 727 562 509 727 314 562 727 301 314 727 343 301 480 482 562 480 562 536 562 314 536 314 315 316 314 316 536 315 314 301 480 536 481 708 536 316 708 481 536 480 481 482 481 708 564 240 481 564 708 324 564 316 324 708 315 360 316 325 324 316 316 360 325 323 324 325 564 324 579 579 324 323 240 564 56 579 56 564 579 57 56 323 57 579 359 57 323 325 359 323 325 360 359 196 359 360 57 359 196 55 56 57 57 196 197 55 57 689 689 57 197 196 527 197 197 385 184 689 197 184 197 527 526 197 526 385 384 184 385 526 651 385 651 384 385 344 633 384 633 185 384 184 384 185 384 651 344 633 800 185 184 185 186 750 185 800 186 185 750 800 570 750 570 800 304 750 437 186 437 750 570 186 437 109 186 108 184 108 186 109 437 570 303 109 437 134 303 134 437 303 570 304 519 109 134 519 520 109 269 520 519 267 268 269 267 269 51 520 269 268 267 541 268 603 541 267 662 267 51 267 662 603 777 520 268 268 540 777 541 540 268 77 540 541 602 541 603 602 77 541 777 540 615 77 90 540 540 90 615 647 520 777 647 777 615 615 90 98 647 615 98 90 76 91 98 90 91 90 77 76 357 98 358 647 98 648 648 98 357 358 98 91 544 520 647 544 647 648 544 543 520 543 109 520 543 544 110 689 544 606 110 544 689 648 606 544 648 357 606 606 212 214 689 606 55 606 357 212 55 606 164 164 606 214 110 689 184 110 184 108 108 109 110 543 110 109 212 213 214 665 516 214 665 214 213 214 516 164 212 357 213 357 405 213 665 213 405 516 665 517 405 406 665 517 665 406 240 516 517 516 240 56 164 516 56 517 406 249 517 249 240 405 250 406 250 249 406 248 249 250 249 248 583 240 249 583 250 512 248 405 512 250 248 511 583 511 248 512 736 583 511 188 169 583 169 171 583 736 188 583 511 512 187 736 511 187 512 405 187 405 78 433 78 405 126 187 405 433 126 405 357 76 77 78 77 168 78 78 126 76 433 78 168 126 91 76 357 358 126 126 358 91 432 433 168 168 77 432 787 432 77 787 77 602 432 563 433 725 631 432 631 563 432 787 725 432 787 795 725 258 787 602 795 787 258 603 745 602 745 258 602 745 603 256 256 603 794 794 603 793 662 793 603 745 256 258 256 257 258 766 722 256 256 722 257 794 766 256 793 84 794 794 790 766 84 790 794 84 793 662 84 662 605 82 83 84 83 790 84 84 605 82 790 791 722 766 790 722 83 791 790 257 722 490 490 722 791 313 490 791 791 83 313 313 83 15 82 400 83 649 15 83 400 649 83 15 16 17 15 17 313 16 15 649 649 400 650 649 650 16 17 16 364 737 16 650 16 737 364 424 737 650 364 737 426 737 424 426 364 365 366 366 17 364 365 364 426 424 425 426 426 533 365 533 426 425 365 533 776 366 365 776 18 366 177 366 776 177 18 17 366 776 129 177 129 776 532 533 532 776 531 532 533 533 425 531 582 129 532 532 705 582 264 705 532 127 128 129 129 582 127 128 177 129 127 582 95 95 582 705 266 705 264 705 266 95 264 265 266 266 265 463 96 266 463 266 96 95 95 96 97 740 95 97 127 95 740 96 463 611 138 97 96 96 611 138 577 578 463 265 577 463 463 578 611 237 577 265 585 577 236 577 585 578 236 577 237 311 578 585 142 578 311 578 142 611 584 285 585 236 634 585 311 585 285 584 585 634 236 237 238 634 236 238 170 584 171 285 584 170 284 285 170 311 285 312 312 285 284 169 170 171 284 170 464 187 464 170 170 169 187 284 464 312 312 464 773 312 773 311 449 464 187 225 464 449 773 464 225 187 169 188 736 187 188 433 449 187 563 449 433 449 563 631 459 631 675 459 449 631 631 795 675 795 631 725 459 222 460 459 675 600 222 459 600 459 460 449 258 675 795 258 600 675 600 220 222 220 600 258 220 221 222 222 221 427 427 460 222 491 220 257 220 258 257 178 220 491 221 220 178 221 178 180 180 209 221 221 209 427 427 209 34 34 33 427 460 427 33 32 33 34 34 280 627 280 34 209 34 627 32 32 450 33 460 33 450 450 449 460 449 450 451 451 450 500 450 627 500 627 450 32 280 279 627 500 627 279 279 280 211 209 211 280 211 501 279 279 501 500 451 500 501 682 762 501 501 211 682 451 501 762 209 210 211 210 682 211 210 550 682 550 762 682 550 549 762 549 451 762 549 550 551 210 559 550 550 559 551 549 551 711 451 549 711 559 688 551 551 710 711 688 710 551 688 559 317 317 559 210 176 175 317 141 176 317 141 317 210 688 317 757 317 175 757 175 176 177 757 175 128 175 177 128 576 688 757 128 576 757 128 127 576 576 137 688 576 740 137 740 576 127 688 754 710 688 137 754 754 684 712 710 754 712 798 684 754 137 798 754 711 710 712 684 679 712 712 799 711 712 679 799 684 66 679 684 798 66 137 64 798 798 64 66 64 65 66 66 65 781 66 781 680 66 680 679 137 138 64 333 64 334 64 138 334 64 333 65 137 740 138 334 138 144 138 740 97 138 611 144 333 334 335 144 335 334 223 65 333 335 223 333 144 498 335 335 498 223 223 224 225 223 498 224 299 223 225 65 223 299 65 299 781 225 298 299 298 781 299 224 773 225 786 225 449 786 298 225 781 298 786 781 786 680 449 680 786 449 679 680 679 449 451 451 799 679 799 451 711 224 590 773 773 590 311 498 143 224 143 590 224 311 590 142 143 142 590 142 143 144 498 144 143 144 611 142 176 18 177 140 18 176 140 176 141 18 19 17 19 18 140 139 140 141 140 139 641 641 19 140 139 141 210 139 661 641 661 139 210 43 641 548 19 641 43 661 548 641 19 43 17 17 42 313 43 42 17 41 42 43 41 43 548 461 548 661 461 41 548 209 461 661 209 661 210 461 209 462 462 41 461 462 586 41 313 41 179 41 586 179 42 41 313 313 179 490 178 179 180 179 178 490 586 180 179 180 586 462 462 209 180 257 490 491 490 178 491 55 164 56 149 438 439 478 438 149 752 674 438 752 438 784 438 478 784 438 674 439 439 674 495 439 495 497 495 674 393 558 393 674 674 752 558 637 558 752 784 637 752 478 730 784 380 637 784 730 380 784 636 558 637 637 382 699 637 380 382 637 699 636 380 381 382 380 453 381 380 730 453 381 699 382 282 699 381 669 699 282 699 669 636 381 677 282 281 282 283 281 669 282 282 522 283 282 677 522 281 636 669 557 636 281 767 281 283 767 58 281 281 58 557 557 60 558 58 60 557 557 558 636 58 59 60 354 58 767 58 354 59 283 354 767 354 355 356 354 283 510 59 354 356 354 510 355 60 59 356 158 332 356 159 356 355 158 356 159 356 332 479 60 356 479 158 159 160 158 21 332 158 160 21 262 159 355 595 262 355 165 262 595 595 355 510 510 165 595 166 165 292 165 510 292 596 166 292 291 292 293 283 292 510 596 292 291 292 283 293 659 596 774 291 774 596 660 659 774 660 774 291 370 660 291 369 370 291 369 291 293 293 283 522 522 369 293 521 369 522 522 677 521 717 192 21 21 160 717 192 22 21 697 192 717 191 22 192 321 191 192 192 697 321 321 697 322 320 321 322 191 321 320 320 201 191 155 320 322 201 320 155 322 52 155 60 479 393 60 393 558 80 514 515 514 85 515 547 85 80 80 85 514 547 80 471 471 764 547 764 765 547 764 471 123 471 103 123 764 123 765 123 103 124 102 103 104 103 102 124 102 339 340 102 104 555 377 568 102 340 696 102 696 377 102 555 104 553 377 378 379 696 378 377 568 377 173 173 377 379 696 397 398 696 398 378 397 696 340 397 173 398 173 397 340 340 339 173 114 398 173 114 173 379 378 644 379 114 379 115 644 115 379 114 115 116 116 398 114 378 398 116 378 116 744 485 116 117 744 116 556 116 485 556 117 116 115 117 115 588 115 644 588 588 644 378 378 744 588 744 556 588 556 485 487 556 487 588 485 486 487 117 486 485 487 580 419 487 419 588 494 487 486 494 493 487 493 580 487 419 418 588 117 588 418 418 419 420 419 580 420 525 671 418 525 418 797 418 190 117 420 797 418 190 418 671 761 420 580 420 761 797 525 797 523 523 797 761 523 524 525 524 671 525 671 394 190 394 671 524 189 118 190 118 117 190 189 190 394 117 118 119 486 117 119 119 118 189 189 394 396 396 801 189 189 801 778 778 119 189 394 395 396 395 394 524 523 395 524 395 770 771 523 770 395 395 771 396 771 801 396 771 770 801 801 770 502 801 502 494 801 494 778 778 494 119 492 493 494 502 492 494 494 486 119 502 770 492 770 523 492 523 761 338 338 337 523 337 492 523 492 336 493 336 492 337 336 580 493 336 337 338 336 338 580 580 338 761 572 31 30 743 67 69))
                   (list :vertices (let ((mat (make-matrix 802 3))) (fvector-replace (array-entity mat) #f(2.6986798095703125e+02 -3.9552700042724609e+01 -8.5208602905273438e+01 2.7694601440429688e+02 -3.3872398376464844e+01 -8.5934898376464844e+01 3.0842401123046875e+02 -4.3315299987792969e+01 -8.3196403503417969e+01 3.9816000366210938e+02 -5.9998798370361328e+01 -6.2860301971435547e+01 4.0136700439453125e+02 -5.9997901916503906e+01 -7.2361297607421875e+01 4.1815399169921875e+02 -5.9998798370361328e+01 -7.0219200134277344e+01 1.5893598937988281e+02 -1.2309099197387695e+01 7.7216903686523438e+01 1.6485099792480469e+02 -3.0282199859619141e+01 7.6222206115722656e+01 1.6143600463867188e+02 -2.4344900131225586e+01 7.5617698669433594e+01 4.1278298950195312e+02 6.3789100646972656e+01 -4.5672698974609375e+01 4.1299600219726562e+02 6.7244499206542969e+01 -2.3317600250244141e+01 4.2784698486328125e+02 6.4496597290039062e+01 -3.4076499938964844e+01 2.4403401184082031e+02 -4.3474498748779297e+01 4.9415397644042969e+01 2.3051998901367188e+02 -4.5847801208496094e+01 6.0693599700927734e+01 2.4332398986816406e+02 -5.1150798797607422e+01 4.7005798339843750e+01 3.9466400146484375e+02 -6.0129798889160156e+01 6.1981597900390625e+01 4.0706597900390625e+02 -6.5834503173828125e+01 3.5854801177978516e+01 4.2979602050781250e+02 -6.0115501403808594e+01 5.5395202636718750e+01 4.6494799804687500e+02 -5.9999099731445312e+01 3.2285102844238281e+01 4.5424801635742188e+02 -5.9998901367187500e+01 4.8128002166748047e+01 3.5395199584960938e+02 5.9978099822998047e+01 -6.9140296936035156e+01 3.4920599365234375e+02 5.5760101318359375e+01 -7.7187599182128906e+01 2.9290499877929688e+02 5.7566402435302734e+01 -7.2705406188964844e+01 4.7654400634765625e+02 4.6998199462890625e+01 1.2270199775695801e+01 4.7660101318359375e+02 2.0735900878906250e+01 1.0939000129699707e+01 4.7699902343750000e+02 1.9828201293945312e+01 -5.1001197099685669e-01 3.7617300415039062e+02 6.3791996240615845e-01 -8.0953796386718750e+01 3.7085198974609375e+02 2.7463099956512451e+00 -8.1232398986816406e+01 3.7310400390625000e+02 8.4643297195434570e+00 -8.0613502502441406e+01 2.1702900695800781e+02 2.8702400207519531e+01 6.8424201965332031e+01 2.1228399658203125e+02 2.8834899902343750e+01 6.6361503601074219e+01 2.2132800292968750e+02 2.8147998809814453e+01 6.2509403228759766e+01 4.1574298095703125e+02 -2.1155399322509766e+01 7.5707298278808594e+01 4.0561700439453125e+02 -2.0677000045776367e+01 7.7149101257324219e+01 4.1629498291015625e+02 -4.6997398376464844e+01 7.5683799743652344e+01 4.1280200195312500e+02 5.4773597717285156e+01 7.7729003906250000e+01 3.8889398193359375e+02 5.4655498504638672e+01 7.8453102111816406e+01 3.9807998657226562e+02 5.0818698883056641e+01 8.2171096801757812e+01 2.3680500793457031e+02 2.4093900680541992e+01 -8.5377502441406250e+01 2.3606599426269531e+02 2.3887100219726562e+01 -8.0423400878906250e+01 2.3054598999023438e+02 2.8480600357055664e+01 -8.4933799743652344e+01 4.2424200439453125e+02 -5.3822799682617188e+01 7.6156600952148438e+01 4.2204602050781250e+02 -5.9998298645019531e+01 6.8907295227050781e+01 4.3811898803710938e+02 -5.9996799468994141e+01 6.1647697448730469e+01 3.7960198974609375e+02 4.9416500091552734e+01 8.0190101623535156e+01 3.9882598876953125e+02 4.7364601135253906e+01 8.2470901489257812e+01 1.5089700317382812e+02 7.2811798095703125e+01 -7.4253101348876953e+00 1.2140000152587891e+02 7.3841697692871094e+01 -1.8654199600219727e+01 1.2138999938964844e+02 7.6263000488281250e+01 2.3532900810241699e+00 3.0664797973632812e+02 -5.7578300476074219e+01 2.7616000175476074e+00 3.1935598754882812e+02 -6.0008102416992188e+01 5.0378699302673340e+00 3.1697500610351562e+02 -5.4764301300048828e+01 1.1626799583435059e+01 2.0703298950195312e+02 4.7485797882080078e+01 -8.2852500915527344e+01 2.0158799743652344e+02 3.0267299652099609e+01 -8.3859504699707031e+01 1.7736099243164062e+02 3.0544700622558594e+01 -8.2059303283691406e+01 3.1340600585937500e+02 1.9811399459838867e+01 9.8132400512695312e+00 3.1770397949218750e+02 1.9901700973510742e+01 6.5741100311279297e+00 3.1196200561523438e+02 2.3891498565673828e+01 1.1806300163269043e+01 4.5297799682617188e+02 5.3168800354003906e+01 -6.0622798919677734e+01 4.4024398803710938e+02 5.4464599609375000e+01 -6.8112594604492188e+01 4.4211898803710938e+02 5.9998901367187500e+01 -5.9171501159667969e+01 1.7923399353027344e+02 5.5238800048828125e+01 6.6634796142578125e+01 1.5311000061035156e+02 4.6697097778320312e+01 6.9339202880859375e+01 1.7761199951171875e+02 4.9026298522949219e+01 7.1591598510742188e+01 4.7360800170898438e+02 -4.6919101715087891e+01 -2.4326000213623047e+01 4.6661499023437500e+02 -3.4613201141357422e+01 -3.9662498474121094e+01 4.7283102416992188e+02 -2.0681900024414062e+01 -2.6530899047851562e+01 2.2145600891113281e+02 5.3074600219726562e+01 6.2365600585937500e+01 2.2105200195312500e+02 4.5480800628662109e+01 6.6385299682617188e+01 2.3066999816894531e+02 4.6444198608398438e+01 6.0312698364257812e+01 2.3813800048828125e+02 -9.9425201416015625e+00 -8.4197097778320312e+01 2.8719100952148438e+02 -9.9715194702148438e+00 -8.4992202758789062e+01 2.6918499755859375e+02 -1.0910200119018555e+01 -8.6877502441406250e+01 1.7088600158691406e+02 -6.7885894775390625e+01 2.9224599838256836e+01 2.0478900146484375e+02 -6.3624000549316406e+01 3.8380500793457031e+01 2.0894700622558594e+02 -6.0195899963378906e+01 5.3730300903320312e+01 3.2603298950195312e+02 -4.1732398986816406e+01 2.2306699752807617e+01 3.2933898925781250e+02 -4.6893299102783203e+01 3.1939498901367188e+01 3.2545599365234375e+02 -2.0907501220703125e+01 2.0522499084472656e+01 1.5300799560546875e+02 -2.8839397430419922e-01 -7.8621902465820312e+01 1.5413198852539062e+02 2.2949001312255859e+01 -7.3717597961425781e+01 1.5305299377441406e+02 -9.1694802045822144e-01 -7.5586799621582031e+01 3.3972201538085938e+02 -6.0005901336669922e+01 1.6729999542236328e+01 3.6316400146484375e+02 -6.0006202697753906e+01 5.1266201019287109e+01 3.3911499023437500e+02 -5.9995700836181641e+01 3.9877002716064453e+01 1.6171299743652344e+02 2.8147998809814453e+01 -7.8484001159667969e+01 1.5855899047851562e+02 2.9345399856567383e+01 -7.8902999877929688e+01 3.4951202392578125e+02 5.3926898956298828e+01 6.1641201019287109e+01 3.4959997558593750e+02 5.0109600067138672e+01 6.5272895812988281e+01 3.6565798950195312e+02 5.3905899047851562e+01 7.2036903381347656e+01 3.2376797485351562e+02 -4.2838600158691406e+01 2.2373498916625977e+01 3.2380599975585938e+02 -4.0734100341796875e+01 1.9065999984741211e+01 2.7185198974609375e+02 -5.8264499664306641e+01 9.5921592712402344e+00 2.9277700805664062e+02 -5.7906002044677734e+01 1.0180799961090088e+00 2.8657598876953125e+02 -5.6599098205566406e+01 4.6875100135803223e+00 4.6709600830078125e+02 -5.3823299407958984e+01 -4.3650299072265625e+01 4.6170397949218750e+02 -4.9313098907470703e+01 -5.5342300415039062e+01 4.7101599121093750e+02 -4.9803001403808594e+01 -4.2164699554443359e+01 3.1809600830078125e+02 -3.5133399963378906e+01 1.5108200073242188e+01 1.4565100097656250e+02 6.8649497985839844e+01 -3.6268699645996094e+01 1.3780499267578125e+02 6.4641105651855469e+01 -4.4423801422119141e+01 1.2140399932861328e+02 6.9412200927734375e+01 -3.2745201110839844e+01 1.2139300537109375e+02 9.9997701644897461e+00 -1.1968299865722656e+01 1.2139300537109375e+02 9.8423099517822266e+00 -7.5771804809570312e+01 1.2139900207519531e+02 -9.9811496734619141e+00 -7.4517898559570312e+01 2.1418299865722656e+02 -2.8903200149536133e+01 6.9828102111816406e+01 2.2198001098632812e+02 -2.8015300750732422e+01 6.2136299133300781e+01 2.1008999633789062e+02 -2.8920499801635742e+01 6.7124397277832031e+01 3.0036898803710938e+02 -8.9209400117397308e-02 1.5115599632263184e+01 3.0177099609375000e+02 -2.9157999038696289e+01 1.2824599266052246e+01 3.0692700195312500e+02 -2.9952199459075928e+00 1.6996101379394531e+01 2.9884201049804688e+02 -6.0129898071289062e+01 -4.8139300346374512e+00 2.9283801269531250e+02 -6.0129001617431641e+01 -5.4920700073242188e+01 3.4953399658203125e+02 -5.9949497222900391e+01 -6.8550697326660156e+01 3.9273399353027344e+01 -1.3449899673461914e+01 5.2689399719238281e+00 2.8058801651000977e+01 -1.3449899673461914e+01 2.3030998706817627e+00 3.1032899856567383e+01 -1.3450200080871582e+01 -1.0102399826049805e+01 1.8257999420166016e+01 -1.3449800491333008e+01 -2.5995299816131592e+00 -3.3837600708007812e+01 -1.3392100334167480e+01 -2.9419200420379639e+00 -3.3802902221679688e+01 -1.3426199913024902e+01 -2.2469400405883789e+01 3.0067599487304688e+02 -5.6111000061035156e+01 -7.5902999877929688e+01 2.1492999267578125e+02 -6.2470802307128906e+01 -7.0899299621582031e+01 2.4110699462890625e+02 -5.6888999938964844e+01 -7.7841697692871094e+01 1.3857699584960938e+02 1.1006800651550293e+01 -7.7741195678710938e+01 1.2139499664306641e+02 1.8486499786376953e+01 -7.4485305786132812e+01 1.4368798828125000e+02 2.6688600540161133e+01 -7.5144699096679688e+01 3.2345599365234375e+02 -3.1529602050781250e+01 1.2233900070190430e+01 4.7807601928710938e+02 -5.3813598632812500e+01 -1.8448099136352539e+01 4.8035400390625000e+02 -5.3332298278808594e+01 4.1944399476051331e-01 4.7164099121093750e+02 -5.9999298095703125e+01 -1.3072199821472168e+01 1.2139599609375000e+02 6.2054000854492188e+01 -4.5387599945068359e+01 2.1473699951171875e+02 6.3270702362060547e+01 3.4553501129150391e+01 2.2899800109863281e+02 5.9934097290039062e+01 4.3128700256347656e+01 2.6944799804687500e+02 6.0635700225830078e+01 -3.2574899196624756e+00 2.9396298217773438e+02 -4.4181598663330078e+01 9.3261995315551758e+00 2.8868298339843750e+02 -4.8889301300048828e+01 9.0583791732788086e+00 3.0042098999023438e+02 -5.3955600738525391e+01 5.0463500022888184e+00 4.7838000488281250e+02 -4.7064800262451172e+01 -2.3568698883056641e+01 4.7109402465820312e+02 -4.7213798522949219e+01 -4.1692001342773438e+01 4.5972601318359375e+02 -5.0037700653076172e+01 5.7041999816894531e+01 4.6915798950195312e+02 -5.4221202850341797e+01 3.9175598144531250e+01 4.7038098144531250e+02 -4.9879798889160156e+01 4.3316799163818359e+01 4.4158700561523438e+02 -4.5438697814941406e+01 -6.7158103942871094e+01 4.4945898437500000e+02 -4.1862598419189453e+01 -6.2420700073242188e+01 4.5697097778320312e+02 -4.7024898529052734e+01 -5.3940097808837891e+01 2.0153999328613281e+02 6.8060195922851562e+01 -1.1492799758911133e+01 1.7148500061035156e+02 7.0551795959472656e+01 -1.8865798950195312e+01 4.6680700683593750e+02 5.4159297943115234e+01 4.3343799591064453e+01 4.7536297607421875e+02 5.3367301940917969e+01 2.8076700210571289e+01 4.6810598754882812e+02 6.0000198364257812e+01 2.5183700561523438e+01 1.6003599548339844e+02 3.9523601531982422e-01 7.2710296630859375e+01 1.7845100402832031e+02 -2.8838699340820312e+01 7.1519203186035156e+01 1.8851399230957031e+02 -1.7382399737834930e-01 7.1839195251464844e+01 1.6020199584960938e+02 4.8382202148437500e+01 -7.3968200683593750e+01 1.6479299926757812e+02 5.3966899871826172e+01 -7.2279495239257812e+01 1.8417898559570312e+02 5.3395099639892578e+01 -7.8712303161621094e+01 1.4016999816894531e+02 5.3923801422119141e+01 -5.9281101226806641e+01 1.3903399658203125e+02 5.8825702667236328e+01 -5.3495998382568359e+01 4.0570599365234375e+02 5.3947601318359375e+01 -7.9568199157714844e+01 4.1013800048828125e+02 5.0291297912597656e+01 -8.1996406555175781e+01 3.7038998413085938e+02 5.1096397399902344e+01 -8.1582099914550781e+01 3.4594100952148438e+02 -5.5474601745605469e+01 -7.7564903259277344e+01 3.7423397827148438e+02 -5.9976997375488281e+01 -7.1428298950195312e+01 2.0081800842285156e+02 5.1504600524902344e+01 6.9726699829101562e+01 3.1583700561523438e+02 1.9498199462890625e+01 6.0402803421020508e+00 4.1638800048828125e+02 3.3946498870849609e+01 -8.2740203857421875e+01 4.2376199340820312e+02 3.7665500640869141e+01 -7.6277000427246094e+01 4.0964401245117188e+02 3.0147800445556641e+01 -7.9614402770996094e+01 3.3024700927734375e+02 -2.1268400192260742e+01 3.3185501098632812e+01 3.6955099487304688e+02 -1.9496799468994141e+01 -7.7861305236816406e+01 3.8992102050781250e+02 -1.9616498947143555e+01 -7.9423706054687500e+01 3.7680102539062500e+02 -1.2180100440979004e+01 -7.8124595642089844e+01 1.2139599609375000e+02 -6.6797897338867188e+01 3.8167598724365234e+01 1.2138600158691406e+02 -1.3449899673461914e+01 5.0183601379394531e+00 1.2138999938964844e+02 -7.3373306274414062e+01 2.2108100891113281e+01 4.7867797851562500e+02 -5.3674499511718750e+01 1.4692000389099121e+01 4.7551599121093750e+02 -5.3135601043701172e+01 2.7813499450683594e+01 4.7154501342773438e+02 -6.0000000000000000e+01 1.2690000534057617e+01 3.9115499877929688e+02 -4.9367801666259766e+01 8.2341598510742188e+01 4.0481698608398438e+02 -5.3760101318359375e+01 7.9872695922851562e+01 4.0211801147460938e+02 -4.8140602111816406e+01 8.2547996520996094e+01 1.6903599548339844e+02 4.3589599609375000e+01 -7.8905403137207031e+01 2.3655499267578125e+02 -5.9016101837158203e+01 4.1195701599121094e+01 2.3055299377441406e+02 -6.2521800994873047e+01 2.4980100631713867e+01 3.0025601196289062e+02 1.7427900314331055e+01 1.3779999732971191e+01 2.8647100830078125e+02 2.8453498840332031e+01 1.3760600090026855e+01 2.9213198852539062e+02 -5.9411001205444336e+00 1.4324099540710449e+01 3.4870800781250000e+02 -1.9499300003051758e+01 -6.9588104248046875e+01 3.5845397949218750e+02 -1.9489898681640625e+01 -7.4871505737304688e+01 -3.6853500366210938e+01 -1.0836500167846680e+01 -9.1771993637084961e+00 -3.5132900238037109e+01 -8.0246801376342773e+00 -2.6096498966217041e+00 2.1107600402832031e+02 6.1521999359130859e+01 -7.3211105346679688e+01 3.0263299560546875e+02 5.4852298736572266e+01 -7.7576599121093750e+01 1.5302899169921875e+02 -1.0001899719238281e+01 -7.7975898742675781e+01 3.9240100097656250e+02 2.0922300338745117e+01 -8.0007392883300781e+01 3.8156701660156250e+02 1.5172899246215820e+01 -8.3363395690917969e+01 3.1338800048828125e+02 4.3959300994873047e+01 9.6440000534057617e+00 3.0935299682617188e+02 3.1767000198364258e+01 1.4847200393676758e+01 4.1321200561523438e+02 1.9500000000000000e+01 7.4684600830078125e+01 4.4500399780273438e+02 1.9546899795532227e+01 6.1493198394775391e+01 4.3336401367187500e+02 2.0601499557495117e+01 6.9930801391601562e+01 1.7918800354003906e+02 5.9264999389648438e+01 -7.2425399780273438e+01 2.0902299499511719e+02 -5.0874099731445312e+01 -8.2039299011230469e+01 2.0939199829101562e+02 -4.2539100646972656e+01 -8.3531600952148438e+01 4.6049899291992188e+02 2.0859399795532227e+01 -4.8491600036621094e+01 4.7099700927734375e+02 2.0322999954223633e+01 -3.1006698608398438e+01 4.5732098388671875e+02 1.9546899795532227e+01 -5.0013301849365234e+01 2.6233499145507812e+02 -5.5384502410888672e+01 2.2946399688720703e+01 2.6440701293945312e+02 -4.7897102355957031e+01 2.6482500076293945e+01 4.2614999389648438e+02 -4.7050201416015625e+01 7.7948097229003906e+01 4.6317398071289062e+02 -4.7130199432373047e+01 5.2111000061035156e+01 4.4767901611328125e+02 -4.6999599456787109e+01 6.0965400695800781e+01 3.1367700195312500e+02 -1.9999500274658203e+01 9.2987298965454102e+00 3.1829699707031250e+02 -1.9518999099731445e+01 6.2488603591918945e+00 3.1570898437500000e+02 -1.9467100143432617e+01 6.0103697776794434e+00 2.7382998657226562e+02 -4.7906997680664062e+01 -8.3371200561523438e+01 3.7380999755859375e+02 6.6768104553222656e+01 -1.5534600257873535e+01 4.0231399536132812e+02 6.8998100280761719e+01 -4.4331297874450684e+00 3.9324899291992188e+02 6.7024795532226562e+01 -2.7822500228881836e+01 4.4623501586914062e+02 1.9570301055908203e+01 -6.2450401306152344e+01 3.7662802124023438e+02 -4.7040100097656250e+01 7.7853797912597656e+01 3.9494699096679688e+02 -4.7025600433349609e+01 8.1092605590820312e+01 3.8329397583007812e+02 -4.6997100830078125e+01 7.5581100463867188e+01 4.6304602050781250e+02 -3.1340900421142578e+01 -4.9396999359130859e+01 4.4703701782226562e+02 -2.0881000518798828e+01 -6.4975502014160156e+01 4.4551101684570312e+02 -1.9466899871826172e+01 -6.3752300262451172e+01 2.2124800109863281e+02 -5.3368698120117188e+01 6.2238800048828125e+01 2.3674499511718750e+02 -5.6224300384521484e+01 4.7721401214599609e+01 2.8605099487304688e+02 5.8087200164794922e+01 2.0315999984741211e+00 2.8768499755859375e+02 6.0119899749755859e+01 -6.3383498191833496e+00 4.5564801025390625e+02 4.8281200408935547e+01 6.1075901031494141e+01 4.6816302490234375e+02 4.7333400726318359e+01 4.6460899353027344e+01 4.6154400634765625e+02 4.9588298797607422e+01 5.5273998260498047e+01 3.3768499755859375e+02 5.9995300292968750e+01 3.7050399780273438e+01 3.3727801513671875e+02 5.3218498229980469e+01 5.0358001708984375e+01 3.5332699584960938e+02 6.0000000000000000e+01 5.5455799102783203e+01 4.2033700561523438e+02 -3.7974300384521484e+01 -8.2487594604492188e+01 4.2375799560546875e+02 -4.8129497528076172e+01 -7.9968200683593750e+01 4.0650000000000000e+02 -4.4263099670410156e+01 -8.4146697998046875e+01 4.6930300903320312e+02 1.9473699569702148e+01 3.3172203063964844e+01 3.2463699340820312e+02 1.9500299453735352e+01 7.4353399276733398e+00 4.7125399780273438e+02 1.9502698898315430e+01 -2.7070699691772461e+01 4.3906799316406250e+02 4.6999397277832031e+01 6.6787101745605469e+01 4.5112899780273438e+02 4.6999698638916016e+01 5.8139202117919922e+01 4.4153402709960938e+02 4.7216899871826172e+01 7.0952301025390625e+01 3.0929199218750000e+02 5.6993598937988281e+01 4.3637099266052246e+00 3.1117401123046875e+02 6.0046901702880859e+01 -3.5963502526283264e-01 2.9760000610351562e+02 5.7296298980712891e+01 1.9913599491119385e+00 3.3396099853515625e+02 1.9496799468994141e+01 -5.5271099090576172e+01 3.2498199462890625e+02 1.9494899749755859e+01 -3.9764198303222656e+01 3.3048901367187500e+02 -1.9485799789428711e+01 -5.0209197998046875e+01 1.9752000427246094e+02 -2.8996999740600586e+01 6.9826400756835938e+01 1.9283300781250000e+02 -2.9338899612426758e+01 7.4710800170898438e+01 2.6233499145507812e+02 5.5384597778320312e+01 2.2946199417114258e+01 2.4693399047851562e+02 4.9439197540283203e+01 4.4376800537109375e+01 2.6343600463867188e+02 4.6680801391601562e+01 2.8110099792480469e+01 3.4889099121093750e+02 -5.0128097534179688e+01 6.4892799377441406e+01 3.6860800170898438e+02 -4.9317401885986328e+01 7.6662300109863281e+01 3.5238598632812500e+02 -4.7202503204345703e+01 6.7087905883789062e+01 3.8578799438476562e+02 2.0408199310302734e+01 7.6132904052734375e+01 4.0146801757812500e+02 2.0530000686645508e+01 7.7252403259277344e+01 4.0245700073242188e+02 4.2681701660156250e+01 -8.4610900878906250e+01 4.1418099975585938e+02 4.4590801239013672e+01 -8.3079399108886719e+01 4.0629299926757812e+02 2.9699600219726562e+01 -8.4733703613281250e+01 4.3701199340820312e+02 -5.9997001647949219e+01 -6.2299800872802734e+01 4.2976300048828125e+02 -5.2976600646972656e+01 -7.5196701049804688e+01 4.4970101928710938e+02 -5.3270896911621094e+01 -6.3543998718261719e+01 3.1956198120117188e+02 -4.9608798980712891e+01 2.1117498397827148e+01 3.1445397949218750e+02 -4.7147800445556641e+01 1.3249499320983887e+01 3.1273001098632812e+02 -4.9305099487304688e+01 1.2802599906921387e+01 1.8479399108886719e+02 6.2976100921630859e+01 -6.6643096923828125e+01 2.3029998779296875e+02 8.4347200393676758e+00 6.1281799316406250e+01 2.3263600158691406e+02 1.4125600814819336e+01 6.2240001678466797e+01 2.3024700927734375e+02 2.0864000320434570e+01 6.2046798706054688e+01 2.5917700195312500e+02 5.8716899871826172e+01 1.8326200485229492e+01 2.7426300048828125e+02 5.6647098541259766e+01 1.1210100173950195e+01 2.0695100402832031e+02 -4.3192401885986328e+01 7.1861602783203125e+01 2.1846200561523438e+02 -4.6244400024414062e+01 6.7268699645996094e+01 2.1029199218750000e+02 -3.1240501403808594e+01 7.2299598693847656e+01 4.3961300659179688e+02 -2.0954700469970703e+01 6.6452499389648438e+01 4.3207299804687500e+02 -4.6992599487304688e+01 7.0418098449707031e+01 4.6399798583984375e+02 4.8775402069091797e+01 -5.2801399230957031e+01 4.6948901367187500e+02 4.7205799102783203e+01 -4.3558399200439453e+01 4.5015399169921875e+02 4.7171199798583984e+01 -6.4952598571777344e+01 4.0357000732421875e+02 -2.0669000625610352e+01 -7.9856201171875000e+01 4.0683801269531250e+02 -2.8655300140380859e+01 -7.9769798278808594e+01 2.5902499389648438e+02 -6.0186401367187500e+01 -7.0155700683593750e+01 2.1616398620605469e+02 -6.4617599487304688e+01 -6.2114997863769531e+01 4.2200000000000000e+02 5.9999801635742188e+01 6.9077003479003906e+01 4.3445199584960938e+02 5.3369400024414062e+01 7.2814002990722656e+01 4.3856399536132812e+02 5.9996898651123047e+01 6.1295597076416016e+01 4.4381399536132812e+02 3.5276599884033203e+01 -6.7163101196289062e+01 4.3527200317382812e+02 4.3373802185058594e+01 -7.1270103454589844e+01 4.4901699829101562e+02 4.6619899749755859e+01 -6.1579498291015625e+01 2.4286100769042969e+02 3.9521400451660156e+01 5.1413299560546875e+01 2.3515998840332031e+02 3.2205600738525391e+01 5.8955299377441406e+01 2.5973300170898438e+02 3.4162399291992188e+01 3.3229400634765625e+01 2.6420401000976562e+02 1.0952799797058105e+01 2.9290800094604492e+01 4.5578500366210938e+02 -2.0386100769042969e+01 -5.3351303100585938e+01 4.5673098754882812e+02 -2.5990900039672852e+01 -5.2924598693847656e+01 3.2822100830078125e+02 4.8122303009033203e+01 4.0762302398681641e+01 3.4029400634765625e+02 4.7230400085449219e+01 5.6344596862792969e+01 3.3739401245117188e+02 4.9815700531005859e+01 5.3847499847412109e+01 2.7990402221679688e+02 -3.4508197784423828e+01 1.6098100662231445e+01 2.7173001098632812e+02 -2.3079999923706055e+01 2.2498600006103516e+01 3.5463101196289062e+02 9.9919700622558594e+00 -8.3778205871582031e+01 3.2274899291992188e+02 9.9649105072021484e+00 -8.4541297912597656e+01 3.5360900878906250e+02 1.0478300094604492e+01 -8.5510597229003906e+01 1.2139499664306641e+02 -6.3039100646972656e+01 -4.4126201629638672e+01 1.3699099731445312e+02 -5.5877101898193359e+01 -5.5938301086425781e+01 1.3608500671386719e+02 -6.2437999725341797e+01 -4.7398002624511719e+01 4.2259899902343750e+02 -3.7057601928710938e+01 -7.6763397216796875e+01 4.1775000000000000e+02 -2.0649799346923828e+01 -7.8183700561523438e+01 4.0339199829101562e+02 -6.0000198364257812e+01 7.2648506164550781e+01 3.3673199462890625e+02 4.7000499725341797e+01 4.4600597381591797e+01 3.2035400390625000e+02 4.7154197692871094e+01 2.0995000839233398e+01 3.2905001831054688e+02 4.7052600860595703e+01 3.0753099441528320e+01 4.7758999633789062e+02 -4.8609100341796875e+01 2.9899200439453125e+01 1.2140000152587891e+02 1.9523799896240234e+01 7.4487297058105469e+01 1.2139499664306641e+02 3.9317897796630859e+01 6.6696304321289062e+01 2.0190800476074219e+02 5.8483600616455078e+01 -7.7087097167968750e+01 2.2209100341796875e+02 5.7571899414062500e+01 -7.8153198242187500e+01 2.1001901245117188e+02 5.5216201782226562e+01 -8.0158599853515625e+01 3.2088198852539062e+02 3.5206298828125000e+01 1.3385799407958984e+01 3.2439700317382812e+02 3.7311798095703125e+01 1.6667499542236328e+01 3.2435501098632812e+02 4.3716197967529297e+01 2.3257200241088867e+01 2.5734100341796875e+02 -5.8833999633789062e+01 1.9736801147460938e+01 2.7373901367187500e+02 -6.0437702178955078e+01 -4.7786302566528320e+00 1.5920799255371094e+02 -4.7932201385498047e+01 -7.3774101257324219e+01 1.3699800109863281e+02 -4.6578701019287109e+01 -6.3617298126220703e+01 1.3964399719238281e+02 -3.7774299621582031e+01 -6.9598396301269531e+01 3.8093399047851562e+02 6.0015296936035156e+01 -6.0300498962402344e+01 4.0476599121093750e+02 6.0003501892089844e+01 -7.2448501586914062e+01 4.7289801025390625e+02 -4.3565998077392578e+01 -3.0951099395751953e+01 4.6832400512695312e+02 -4.6991901397705078e+01 -3.8521598815917969e+01 4.6921099853515625e+02 -4.0864398956298828e+01 -3.9848701477050781e+01 -3.8829799652099609e+01 8.4264297485351562e+00 -1.8046800613403320e+01 -5.2199600219726562e+01 6.6490097045898438e+00 -1.9946599960327148e+01 -5.2207397460937500e+01 9.3103599548339844e+00 -1.5870100021362305e+01 1.2139499664306641e+02 -6.9184402465820312e+01 -3.3060401916503906e+01 1.2139199829101562e+02 -1.3450200080871582e+01 -1.1897100448608398e+01 3.6526599121093750e+02 4.7000099182128906e+01 6.9119102478027344e+01 3.7322500610351562e+02 4.7052600860595703e+01 7.7051498413085938e+01 3.5123101806640625e+02 4.7212699890136719e+01 6.5883598327636719e+01 2.8851800537109375e+02 4.9751800537109375e+01 8.6520395278930664e+00 2.8751098632812500e+02 5.5096500396728516e+01 5.7343597412109375e+00 3.7455099487304688e+02 -9.9911594390869141e+00 -8.3500495910644531e+01 3.7303500366210938e+02 -1.0890100479125977e+01 -8.5416603088378906e+01 3.4465899658203125e+02 -9.9475593566894531e+00 -8.4082099914550781e+01 4.1382199096679688e+02 2.0520500183105469e+01 7.6125801086425781e+01 2.0997700500488281e+02 6.8231796264648438e+01 -3.5426097869873047e+01 2.7858599853515625e+02 6.1413700103759766e+01 -5.0858596801757812e+01 3.6783599853515625e+02 -6.0022102355957031e+01 -5.2814899444580078e+01 3.4871200561523438e+02 -6.0184501647949219e+01 -3.4829399108886719e+01 4.4373800659179688e+02 4.8891300201416016e+01 -7.0732597351074219e+01 4.2629199218750000e+02 4.6583400726318359e+01 -7.9632698059082031e+01 4.2881201171875000e+02 5.3365398406982422e+01 -7.5047004699707031e+01 3.1871499633789062e+02 -2.5577901840209961e+01 7.7959499359130859e+00 3.2085601806640625e+02 -3.4658000946044922e+01 1.2971100807189941e+01 3.1939797973632812e+02 3.7043003082275391e+01 1.6164699554443359e+01 3.1959201049804688e+02 4.7047298431396484e+01 1.3563099861145020e+01 4.2574600219726562e+02 -5.9999397277832031e+01 -5.6593803405761719e+01 3.9389801025390625e+02 4.6999099731445312e+01 7.7121597290039062e+01 3.7800500488281250e+02 4.6999698638916016e+01 7.4091598510742188e+01 4.3556100463867188e+02 -6.3748703002929688e+01 3.2133800506591797e+01 4.4895700073242188e+02 -6.3019500732421875e+01 1.3286800384521484e+01 4.5796099853515625e+02 -6.0000598907470703e+01 2.3436199188232422e+01 4.3767700195312500e+02 5.0037998199462891e+01 7.3454299926757812e+01 4.4826699829101562e+02 5.1183601379394531e+01 6.6398002624511719e+01 4.5757299804687500e+02 4.1167499542236328e+01 -5.5166099548339844e+01 4.5711499023437500e+02 2.6968900680541992e+01 -5.5978801727294922e+01 1.2141799926757812e+02 -1.1030699729919434e+01 7.5932998657226562e+01 1.2137699890136719e+02 1.8111799955368042e+00 7.6768302917480469e+01 2.0642100524902344e+02 -5.0541698455810547e+01 6.9386802673339844e+01 1.6833900451660156e+02 -3.0322700500488281e+01 -8.0908203125000000e+01 1.8574899291992188e+02 -4.7965602874755859e+01 -8.0921394348144531e+01 1.6871299743652344e+02 -4.2440601348876953e+01 -7.9159805297851562e+01 1.2138600158691406e+02 9.9997997283935547e+00 4.9754199981689453e+00 4.0206996917724609e+01 9.9997606277465820e+00 -7.0157999992370605e+00 3.9356601715087891e+01 9.9995203018188477e+00 5.4596600532531738e+00 4.8285897827148438e+02 4.9023597717285156e+01 -2.2885200977325439e+00 4.8016101074218750e+02 4.7198200225830078e+01 -1.9647600173950195e+01 4.8022198486328125e+02 4.8344600677490234e+01 -2.0300500869750977e+01 1.6862901306152344e+02 -2.8404600143432617e+01 7.5372299194335938e+01 2.9437399291992188e+02 3.9367702484130859e+01 1.0528300285339355e+01 3.0028799438476562e+02 3.4368198394775391e+01 1.1748299598693848e+01 2.0505499267578125e+02 5.6041301727294922e+01 6.4948997497558594e+01 2.2232901000976562e+02 5.7294200897216797e+01 5.6930500030517578e+01 2.0981199645996094e+02 5.9544300079345703e+01 5.5890800476074219e+01 3.2305099487304688e+02 4.8730499267578125e+01 2.9741498947143555e+01 3.2657901000976562e+02 5.0801998138427734e+01 3.6722202301025391e+01 3.2317297363281250e+02 5.3442298889160156e+01 2.3058900833129883e+01 4.1613598632812500e+02 6.0000698089599609e+01 -6.0036998748779297e+01 4.3933401489257812e+02 6.0003200531005859e+01 -4.8552902221679688e+01 -3.9101898193359375e+01 -7.7785501480102539e+00 -5.9053301811218262e+00 -5.2207202911376953e+01 -1.0355299949645996e+01 -1.0454099655151367e+01 -4.0447898864746094e+01 -1.0300499916076660e+01 -1.0833999633789062e+01 1.0617300415039062e+02 -1.3450200080871582e+01 -7.1649298667907715e+00 4.1278999328613281e+01 -1.3450200080871582e+01 -7.0143098831176758e+00 3.6346099853515625e+02 -6.5623001098632812e+01 9.0900602340698242e+00 3.5942700195312500e+02 -6.3574501037597656e+01 2.6146200180053711e+01 2.0978799438476562e+02 -2.9403900146484375e+01 -8.3998802185058594e+01 1.7411898803710938e+02 -2.8856199264526367e+01 -7.6761901855468750e+01 2.0923100280761719e+02 -2.8993900299072266e+01 -7.9408493041992188e+01 1.8325599670410156e+02 -2.9675899505615234e+01 -8.2495506286621094e+01 3.2358700561523438e+02 -1.9684499740600586e+01 8.6622705459594727e+00 3.2215802001953125e+02 -1.9497999191284180e+01 -3.2977199554443359e+01 4.7376901245117188e+02 2.1386598587036133e+01 2.3267200469970703e+01 4.6779000854492188e+02 2.0513000488281250e+01 3.7409702301025391e+01 2.6880700683593750e+02 1.0747099876403809e+01 -8.6791000366210938e+01 2.3817601013183594e+02 9.9974393844604492e+00 -8.4372398376464844e+01 2.3947698974609375e+02 1.0498600006103516e+01 -8.5949401855468750e+01 3.1859100341796875e+02 4.9858699798583984e+01 1.9355899810791016e+01 3.1367199707031250e+02 4.7429000854492188e+01 1.4108799934387207e+01 3.1850399780273438e+02 1.0779599189758301e+01 -8.6433502197265625e+01 2.8481298828125000e+02 9.9594202041625977e+00 -8.4976303100585938e+01 1.2139700317382812e+02 -4.4761199951171875e+01 -6.2557197570800781e+01 4.6009799194335938e+02 2.8615100860595703e+01 -4.8899898529052734e+01 -3.8805297851562500e+01 2.1942300796508789e+00 -2.6787099838256836e+00 -3.4253200531005859e+01 9.9260101318359375e+00 -2.9263200759887695e+00 -3.8575702667236328e+01 8.2397899627685547e+00 -6.9093298912048340e+00 2.7972097778320312e+02 -4.8689601898193359e+01 1.3545800209045410e+01 2.7527099609375000e+02 -5.5110301971435547e+01 1.2155799865722656e+01 1.4177799987792969e+02 3.4543399810791016e+01 -7.1905502319335938e+01 4.0603500366210938e+02 -6.8803497314453125e+01 1.4634000062942505e+00 4.2048498535156250e+02 -6.7412506103515625e+01 -1.6210699081420898e+01 4.2928799438476562e+02 -6.6924293518066406e+01 5.2737298011779785e+00 4.0248297119140625e+02 -4.6996101379394531e+01 7.7266098022460938e+01 2.2039199829101562e+02 -5.7974597930908203e+01 5.6403701782226562e+01 3.7732897949218750e+02 -6.6330902099609375e+01 -2.5233098983764648e+01 4.0149700927734375e+02 -6.6905899047851562e+01 -2.9552000045776367e+01 3.8943698120117188e+02 -6.8757202148437500e+01 -3.5911800861358643e+00 3.3835198974609375e+02 -2.0324998855590820e+01 4.6718502044677734e+01 3.2756399536132812e+02 -1.9502300262451172e+01 2.3850599288940430e+01 2.1592498779296875e+02 -5.5361698150634766e+01 -8.0084693908691406e+01 1.9516900634765625e+02 -5.4913799285888672e+01 -7.9384605407714844e+01 1.8761500549316406e+02 5.8249599456787109e+01 6.2449001312255859e+01 2.8975201416015625e+02 -2.5156000137329102e+01 1.3326499938964844e+01 4.7258099365234375e+02 5.9998699188232422e+01 1.4192500114440918e+00 4.6284500122070312e+02 6.0008701324462891e+01 -3.6313802003860474e-01 2.6817199707031250e+02 6.0726200103759766e+01 -2.7909000396728516e+01 2.3774301147460938e+02 -6.5778999328613281e+01 -4.0708198547363281e+01 1.9886698913574219e+02 -6.8236595153808594e+01 -7.3314499855041504e+00 1.6130700683593750e+02 -5.6858901977539062e+01 -6.7954200744628906e+01 1.2141799926757812e+02 -5.5553199768066406e+01 5.3859497070312500e+01 3.7179501342773438e+02 -6.6181998252868652e+00 -8.0730995178222656e+01 3.7031201171875000e+02 -7.3377901315689087e-01 -8.4307601928710938e+01 3.7452600097656250e+02 1.2316200256347656e+01 -8.5427001953125000e+01 3.8273400878906250e+02 4.4961502075195312e+01 -8.4029304504394531e+01 3.7726901245117188e+02 -1.9499799728393555e+01 7.2692901611328125e+01 4.1229699707031250e+02 -1.9455799102783203e+01 7.4946296691894531e+01 4.6330401611328125e+02 -1.9528900146484375e+01 4.3163600921630859e+01 4.7718499755859375e+02 4.7031600952148438e+01 -8.0190200805664062e+00 4.8117797851562500e+02 4.7104103088378906e+01 1.1359499931335449e+01 1.3648399353027344e+02 -7.2275802612304688e+01 -2.1791400909423828e+01 1.3998199462890625e+02 -6.8141899108886719e+01 -3.7146900177001953e+01 1.6234800720214844e+02 -6.9730903625488281e+01 -3.2697902679443359e+01 3.0661300659179688e+02 -5.1591899871826172e+01 -8.0196205139160156e+01 2.7342999267578125e+02 -5.4090297698974609e+01 -7.9887596130371094e+01 3.6923501586914062e+02 -2.0616098403930664e+01 7.0954002380371094e+01 3.8781600952148438e+02 -2.0435501098632812e+01 7.6430000305175781e+01 4.3329598999023438e+02 -4.9894702911376953e+01 7.5655799865722656e+01 4.2008502197265625e+02 -4.8013698577880859e+01 8.0104499816894531e+01 4.4692098999023438e+02 -4.8459602355957031e+01 -6.8739601135253906e+01 4.1259197998046875e+02 -1.9500400543212891e+01 -7.7915992736816406e+01 2.9868200683593750e+02 5.9954502105712891e+01 -5.9096500396728516e+01 4.0756698608398438e+02 -5.3954998016357422e+01 -7.9620101928710938e+01 1.8743200683593750e+02 -3.0600299835205078e+01 7.5947799682617188e+01 4.6523699951171875e+02 3.3452102661132812e+01 -4.6088500976562500e+01 4.7157601928710938e+02 4.1733699798583984e+01 -2.9466199874877930e+01 4.6689297485351562e+02 3.5142101287841797e+01 -3.9242900848388672e+01 1.5311799621582031e+02 1.0007599830627441e+01 -7.8002296447753906e+01 1.6796398925781250e+02 2.8336099624633789e+01 7.5395004272460938e+01 1.6127600097656250e+02 2.3711500167846680e+01 7.5437797546386719e+01 1.6511000061035156e+02 2.7566200256347656e+01 7.1445800781250000e+01 1.5259201049804688e+02 -6.4640899658203125e+01 -5.0179199218750000e+01 1.8425700378417969e+02 -6.5575004577636719e+01 -5.7792900085449219e+01 4.7907901000976562e+02 4.9219799041748047e+01 2.4461700439453125e+01 4.7902798461914062e+02 5.3630901336669922e+01 1.2806399345397949e+01 4.2361099243164062e+02 5.9999702453613281e+01 -6.8437705993652344e+01 3.3600100708007812e+02 1.9685701370239258e+01 4.1637802124023438e+01 3.2825299072265625e+02 1.9507299423217773e+01 2.5761199951171875e+01 3.4998699951171875e+02 1.9506198883056641e+01 5.7094299316406250e+01 2.9614199829101562e+02 -5.8876800537109375e+01 -6.7440895080566406e+01 1.4397099304199219e+02 3.4710399627685547e+01 7.2951499938964844e+01 1.9188299179077148e+01 -1.3449099540710449e+01 -1.9286100387573242e+01 8.8103094100952148e+00 -1.3450000762939453e+01 -2.2580400466918945e+01 9.1594600677490234e+00 9.9991302490234375e+00 -2.2570899963378906e+01 2.0770800781250000e+02 6.4783897399902344e+01 -6.3669601440429688e+01 4.7770101928710938e+02 4.7195800781250000e+01 2.6885499954223633e+01 3.8425799560546875e+02 -5.3581401824951172e+01 7.8558601379394531e+01 3.7770700073242188e+02 -4.8815399169921875e+01 7.9550903320312500e+01 -3.9498798370361328e+01 1.5597300529479980e+00 -2.2691600799560547e+01 -3.4039699554443359e+01 9.9082002639770508e+00 -2.2434900283813477e+01 -3.6558097839355469e+01 -5.7264099121093750e+00 -2.2590900421142578e+01 4.4380700683593750e+02 6.3095195770263672e+01 -2.5015701293945312e+01 4.3029800415039062e+02 6.6494598388671875e+01 -1.1050700187683105e+01 4.4017498779296875e+02 6.5324302673339844e+01 3.3569598197937012e+00 4.5810400390625000e+02 -4.0826000213623047e+01 -5.4695598602294922e+01 4.5092700195312500e+02 6.0000900268554688e+01 3.5562900543212891e+01 4.4334500122070312e+02 -1.9585000991821289e+01 6.2819400787353516e+01 4.5092898559570312e+02 -2.0515899658203125e+01 5.8298099517822266e+01 -4.0346801757812500e+01 -4.0342397689819336e+00 -2.1897998809814453e+01 1.2140099334716797e+02 4.9184898376464844e+01 -5.8824798583984375e+01 4.1492999267578125e+02 4.7227798461914062e+01 8.0652099609375000e+01 4.1453997802734375e+02 5.0165798187255859e+01 8.1171600341796875e+01 2.2669300842285156e+02 -2.6684700012207031e+01 6.3238204956054688e+01 2.2936099243164062e+02 -2.2227499008178711e+01 5.7892700195312500e+01 3.7604699707031250e+02 1.9552198410034180e+01 7.2653701782226562e+01 3.5830798339843750e+02 2.0399900436401367e+01 6.4990997314453125e+01 4.3634799194335938e+02 4.4071701049804688e+01 -7.5414703369140625e+01 3.4434301757812500e+02 1.9485799789428711e+01 -6.6335098266601562e+01 3.3899700927734375e+02 -1.9488298416137695e+01 -6.1291198730468750e+01 4.7089700317382812e+02 4.6998100280761719e+01 3.1079801559448242e+01 1.6093299865722656e+02 2.7697698593139648e+01 -7.4587799072265625e+01 1.8120401000976562e+02 2.9061500549316406e+01 -7.7659301757812500e+01 3.1665600585937500e+02 1.9500200271606445e+01 -7.8561501502990723e+00 3.1971899414062500e+02 1.9496500015258789e+01 -2.4786399841308594e+01 1.2138700103759766e+02 -7.5496597290039062e+01 1.0262300491333008e+01 3.0283901977539062e+02 -4.5932201385498047e+01 9.2503805160522461e+00 3.1062100219726562e+02 -4.3601200103759766e+01 1.3135299682617188e+01 4.6549798583984375e+02 4.2101699829101562e+01 -4.5255798339843750e+01 4.5980999755859375e+02 4.7003799438476562e+01 -5.0753398895263672e+01 -5.2213600158691406e+01 1.2892800569534302e+00 -2.2631900787353516e+01 -5.2211299896240234e+01 -5.4359102249145508e+00 -3.8882999420166016e+00 -5.2213199615478516e+01 1.3888500928878784e+00 -2.5954499244689941e+00 3.0472399902343750e+02 4.3305599212646484e+01 1.0643199920654297e+01 3.1080697631835938e+02 4.4436500549316406e+01 1.2970600128173828e+01 1.5894099426269531e+02 -2.7586198806762695e+01 -7.8158294677734375e+01 1.5885800170898438e+02 -2.7126901626586914e+01 -7.4080604553222656e+01 4.4790399169921875e+02 2.1455801010131836e+01 6.0823398590087891e+01 4.3296899414062500e+02 -6.2763103485107422e+01 -4.0159099578857422e+01 4.5260400390625000e+02 -6.0000301361083984e+01 -3.3559501647949219e+01 4.4520397949218750e+02 -6.3975402832031250e+01 -1.2906099319458008e+01 3.7690798950195312e+02 -1.1944700241088867e+01 -7.9862800598144531e+01 3.6856698608398438e+02 2.1349100112915039e+01 7.0643501281738281e+01 3.3417401123046875e+02 2.1146800994873047e+01 4.0620899200439453e+01 3.2288400268554688e+02 -1.0753899574279785e+01 -8.6279701232910156e+01 2.0102400207519531e+02 2.9871599197387695e+01 7.4030899047851562e+01 1.8846600341796875e+02 2.9156999588012695e+01 7.4716003417968750e+01 3.2325698852539062e+02 -4.6995498657226562e+01 1.8619600296020508e+01 3.2074697875976562e+02 -4.7207698822021484e+01 2.1647300720214844e+01 2.4750900268554688e+02 5.6442199707031250e+01 3.6722599029541016e+01 3.0844799804687500e+02 -2.9747200012207031e+01 1.4979500770568848e+01 3.0972601318359375e+02 -2.8544599533081055e+01 1.4712999343872070e+01 4.2329998779296875e+02 4.6996997833251953e+01 7.3860496520996094e+01 4.0638699340820312e+02 4.6999000549316406e+01 7.7058898925781250e+01 1.5434100341796875e+02 2.3110198974609375e+01 -7.7022499084472656e+01 4.4112100219726562e+02 -5.3270896911621094e+01 6.8994697570800781e+01 4.6729901123046875e+02 -2.0598600387573242e+01 3.8382602691650391e+01 4.6611401367187500e+02 -4.6995800018310547e+01 4.0229000091552734e+01 4.7122500610351562e+02 -4.6993999481201172e+01 3.0214799880981445e+01 4.2645800781250000e+02 4.8638900756835938e+01 7.8525604248046875e+01 1.2144699859619141e+02 -1.1082099914550781e+01 -7.5967903137207031e+01 1.4094400024414062e+02 -2.3374700546264648e+01 -7.5681999206542969e+01 1.2139599609375000e+02 -2.3031799316406250e+01 -7.3275901794433594e+01 2.4208999633789062e+01 9.9948997497558594e+00 -1.6386301040649414e+01 4.6035598754882812e+02 5.4745700836181641e+01 -5.0807498931884766e+01 4.6098397827148438e+02 6.0000198364257812e+01 -3.9570899963378906e+01 4.7446398925781250e+02 -4.7099300384521484e+01 3.3413898468017578e+01 2.2766700744628906e+02 2.6047399520874023e+01 6.2707603454589844e+01 2.2859199523925781e+02 2.3706499099731445e+01 5.8528301239013672e+01 3.4494900512695312e+02 2.0604000091552734e+01 5.4376502990722656e+01 3.4264300537109375e+02 -1.9499799728393555e+01 4.9337902069091797e+01 3.2253900146484375e+02 2.0319999694824219e+01 7.6380100250244141e+00 4.5493099975585938e+02 6.0001399993896484e+01 4.7762699127197266e+01 4.5729299926757812e+02 5.3432701110839844e+01 5.6181900024414062e+01 1.8244999694824219e+02 6.8681800842285156e+01 1.4439599990844727e+01 1.2139499664306641e+02 7.4013999938964844e+01 1.9531600952148438e+01 1.8924299621582031e+02 6.5076095581054688e+01 3.6148399353027344e+01 2.7857199096679688e+02 -3.3273999691009521e+00 1.8129701614379883e+01 3.9531201171875000e+02 5.9999397277832031e+01 7.2362403869628906e+01 2.1791999816894531e+02 -1.9250901043415070e-01 6.5389793395996094e+01 3.1770700073242188e+02 5.3210601806640625e+01 1.4727499961853027e+01 3.2292199707031250e+02 5.9970901489257812e+01 8.9725704193115234e+00 3.1019198608398438e+02 5.1456100463867188e+01 9.8250303268432617e+00 4.8186499023437500e+02 -4.8405200958251953e+01 -1.3818000793457031e+01 4.3462802124023438e+02 -4.4208602905273438e+01 -7.6701301574707031e+01 4.3775698852539062e+02 -4.4371601104736328e+01 -7.3397705078125000e+01 3.1949499511718750e+02 2.8391700744628906e+01 9.0772905349731445e+00 -3.9751296997070312e+01 9.8612995147705078e+00 -1.2903699874877930e+01 3.7295700073242188e+02 6.0000801086425781e+01 6.7334602355957031e+01 4.6382299804687500e+02 -5.9995300292968750e+01 -3.4188697814941406e+01 3.6793399047851562e+02 1.9505699157714844e+01 -7.7577400207519531e+01 3.8226300048828125e+02 -1.6083599090576172e+01 -8.4906799316406250e+01 4.1496301269531250e+02 -3.3101997375488281e+01 -8.3059196472167969e+01 4.1146499633789062e+02 -5.0028800964355469e+01 8.1623298645019531e+01 2.2652099609375000e+02 -2.9473999023437500e+01 6.5283798217773438e+01 1.8784099578857422e+01 9.9991903305053711e+00 -2.5935499668121338e+00 1.2140399932861328e+02 -2.9224199295043945e+01 7.1641403198242188e+01 4.3800000000000000e+02 -3.7197101593017578e+01 -7.0391296386718750e+01 2.0307501220703125e+02 -2.1902999281883240e-01 6.9769699096679688e+01 1.6842700195312500e+02 3.8101799011230469e+01 7.5127197265625000e+01 4.0508999633789062e+02 1.9607198715209961e+01 -7.8820198059082031e+01 3.8956399536132812e+02 1.9482000350952148e+01 -7.8164199829101562e+01 4.2695401000976562e+02 4.0556900024414062e+01 -8.0134506225585938e+01 4.2694299316406250e+02 2.1298099517822266e+01 -7.5493698120117188e+01 2.3706401062011719e+02 -2.1446100234985352e+01 -8.3815597534179688e+01 2.3241099548339844e+02 -2.7318099975585938e+01 -8.3929298400878906e+01 2.3493299865722656e+02 -2.5151500701904297e+01 -8.0320800781250000e+01 3.7039700317382812e+02 -4.6996501922607422e+01 7.1414703369140625e+01 3.4057800292968750e+02 5.9999599456787109e+01 1.7444400787353516e+01 3.3242401123046875e+02 -4.7271499633789062e+01 4.6557800292968750e+01 3.2822497558593750e+02 -5.0210300445556641e+01 4.1165000915527344e+01 2.3817401123046875e+02 7.7359399795532227e+00 -8.1224205017089844e+01 3.2963400268554688e+02 -5.9987701416015625e+01 1.8482599258422852e+01 3.1305599975585938e+02 -1.8249799728393555e+01 1.0080900192260742e+01 2.2427700805664062e+02 -2.8941400527954102e+01 -8.4644401550292969e+01 2.3003500366210938e+02 -2.7789300918579102e+01 -8.0052803039550781e+01 2.3548400878906250e+02 -2.7285499572753906e+01 -8.5217300415039062e+01 4.7631399536132812e+02 2.1028699874877930e+01 -1.3156900405883789e+01 4.5043899536132812e+02 -4.7057201385498047e+01 -6.4637397766113281e+01 3.5404199218750000e+02 6.3482501983642578e+01 1.6369798660278320e+01 3.6813598632812500e+02 6.5215904235839844e+01 2.5302600860595703e+01 3.8165600585937500e+02 6.8086105346679688e+01 5.5572500228881836e+00 3.1773901367187500e+02 -4.1326797485351562e+01 1.3830400466918945e+01 1.2140999603271484e+02 5.3768798828125000e+01 5.6119503021240234e+01 1.4008200073242188e+02 6.0924400329589844e+01 4.8280300140380859e+01 1.2139099884033203e+02 6.7247200012207031e+01 3.7593101501464844e+01 1.3687400817871094e+02 4.5585800170898438e+01 -6.4200202941894531e+01 1.5900099182128906e+02 -6.3000202178955078e+01 4.5924499511718750e+01 1.7153599548339844e+02 -5.6645900726318359e+01 6.3568504333496094e+01 1.4074200439453125e+02 -6.0995300292968750e+01 4.8195899963378906e+01 2.2845700073242188e+02 2.8236801147460938e+01 -8.0183998107910156e+01 1.5924899291992188e+02 6.0796799659729004e+00 7.7349899291992188e+01 3.7064498901367188e+02 -6.3272296905517578e+01 -3.9899200439453125e+01 3.8990301513671875e+02 -6.3551403045654297e+01 -4.7807296752929688e+01 4.2641699218750000e+02 -2.0340200424194336e+01 7.2655601501464844e+01 2.8024600219726562e+02 3.4880599975585938e+01 -8.5823699951171875e+01 1.2140200042724609e+02 -7.4608001708984375e+01 -1.5916200637817383e+01 1.2139900207519531e+02 -7.6086997985839844e+01 -2.0323601365089417e-01 3.5722900390625000e+02 -2.0051099777221680e+01 6.4125701904296875e+01 3.7715597534179688e+02 6.0001998901367188e+01 5.8282699584960938e+01 2.8508300781250000e+02 4.0666000366210938e+01 1.2633799552917480e+01 4.0627801513671875e+02 -3.0101400375366211e+01 -8.4828399658203125e+01 2.0203599548339844e+02 -6.8860000610351562e+01 -3.4175796508789062e+01 4.6938500976562500e+02 5.3855602264404297e+01 -3.9432601928710938e+01 4.7712698364257812e+02 5.3354400634765625e+01 -2.3150001525878906e+01 3.5226602172851562e+02 6.0000499725341797e+01 3.9655101776123047e+01 3.7605801391601562e+02 6.3361099243164062e+01 4.3322898864746094e+01 4.7354901123046875e+02 4.6998298645019531e+01 -2.4059999465942383e+01 4.5430499267578125e+02 -5.5246299743652344e+01 5.6729396820068359e+01 2.3768901062011719e+02 -1.8429899215698242e+01 -8.0736602783203125e+01 1.5465199279785156e+02 -7.2437705993652344e+01 -8.4779701232910156e+00 2.6725999832153320e+01 9.9988803863525391e+00 1.6717799901962280e+00 3.2548901367187500e+02 3.0100200653076172e+01 -8.4728897094726562e+01 1.6115798950195312e+02 -2.3830600738525391e+01 7.1780899047851562e+01 3.1332202148437500e+02 -4.2011398315429688e+01 9.6432504653930664e+00 3.1184802246093750e+02 -2.3497400283813477e+01 1.1880299568176270e+01 3.8273699951171875e+02 -6.5534301757812500e+01 3.5133201599121094e+01 3.8676397705078125e+02 -6.7754295349121094e+01 1.8944700241088867e+01 3.0022399902343750e+02 5.1093299865722656e+01 6.5889496803283691e+00 1.7460000610351562e+02 -5.2863800048828125e+01 -7.6696205139160156e+01 1.7243899536132812e+02 -7.0401496887207031e+01 -2.2019399642944336e+01 3.1446499633789062e+02 -5.8274398803710938e+01 -7.1471000671386719e+01 4.5787899780273438e+02 2.0334600448608398e+01 5.1297500610351562e+01 4.6189099121093750e+02 4.6999599456787109e+01 4.6506000518798828e+01 3.3753500366210938e+02 6.0036499023437500e+01 2.8993301093578339e-02 3.3608697509765625e+02 -5.2141597747802734e+01 -8.0029602050781250e+01 4.2741098022460938e+02 1.9526800155639648e+01 -7.3969001770019531e+01 4.4612399291992188e+02 2.0561899185180664e+01 -6.5466903686523438e+01 4.4899200439453125e+02 -4.8467300415039062e+01 6.6893898010253906e+01 3.2321301269531250e+02 -5.4660900115966797e+01 2.0205400466918945e+01 2.1493400573730469e+02 1.1095900554209948e-03 -8.0631706237792969e+01 1.7903601074218750e+02 -7.2128000259399414e+00 -7.8161399841308594e+01 3.1746899414062500e+02 -1.9495500564575195e+01 -1.3806000709533691e+01 1.7376600646972656e+02 6.4496101379394531e+01 4.1711597442626953e+01 3.1281301879882812e+02 4.6363597869873047e+01 -8.2290802001953125e+01 3.9618701171875000e+02 6.7704399108886719e+01 2.2618999481201172e+01 4.6973999023437500e+02 5.0240596771240234e+01 -4.3916198730468750e+01 2.1057600402832031e+02 4.7207698822021484e+01 6.9880798339843750e+01 -3.9354900360107422e+01 -2.7552599906921387e+00 -2.7192399501800537e+00 1.9242399597167969e+02 -5.4745300292968750e+01 6.7543899536132812e+01 1.9428700256347656e+02 -4.8353000640869141e+01 7.2414398193359375e+01 4.5624899291992188e+02 6.0000900268554688e+01 -2.6427700042724609e+01 3.5940600585937500e+02 -4.6993598937988281e+01 6.5772697448730469e+01 4.1950500488281250e+02 6.7430503845214844e+01 1.5704600334167480e+01 4.7153298950195312e+02 4.6978801727294922e+01 -3.2296298980712891e+01 4.0298699951171875e+02 -4.9353801727294922e+01 -8.2853195190429688e+01 4.7494097900390625e+02 -1.9511699676513672e+01 -1.5548299789428711e+01 4.6614001464843750e+02 -1.9525001525878906e+01 -3.7789699554443359e+01 3.6092999267578125e+02 -6.5256797790527344e+01 -8.4853792190551758e+00 4.5789001464843750e+02 -4.6999000549316406e+01 5.1349899291992188e+01 3.7430200195312500e+02 9.9293403625488281e+00 -8.3930099487304688e+01 4.7673699951171875e+02 -2.0532699584960938e+01 -1.0493399620056152e+01 2.7144799804687500e+02 4.5715896606445312e+01 -8.4106994628906250e+01 3.5525198364257812e+02 6.4174598693847656e+01 -1.1331299781799316e+01 3.2989401245117188e+02 5.9976600646972656e+01 1.9294900894165039e+01 4.8172000122070312e+02 -4.7110698699951172e+01 4.0064196586608887e+00 3.0803701782226562e+02 4.0838098526000977e+00 1.6993099212646484e+01 4.0518798828125000e+02 6.0006099700927734e+01 6.1959197998046875e+01 4.1278298950195312e+02 6.5869697570800781e+01 3.4340301513671875e+01 4.2548901367187500e+02 6.2698200225830078e+01 4.5882198333740234e+01 4.4351800537109375e+02 6.3348598480224609e+01 2.4119499206542969e+01 3.7674298095703125e+02 1.1935899734497070e+01 -7.8256004333496094e+01 1.5147499084472656e+02 -3.4508499145507812e+01 7.4204498291015625e+01 1.0606600189208984e+02 9.9995899200439453e+00 -7.0439600944519043e+00 2.8841000366210938e+02 5.2489097595214844e+01 -8.0498504638671875e+01 2.3831201171875000e+02 -5.0986400604248047e+01 -8.1918800354003906e+01 4.7575302124023438e+02 4.9695499420166016e+01 -3.3041000366210938e+01 4.7260998535156250e+02 5.0078498840332031e+01 3.9270401000976562e+01 3.6967599487304688e+02 6.3682102203369141e+01 -3.7480201721191406e+01 1.9246099853515625e+02 2.9167699813842773e+01 7.0744598388671875e+01 3.9386199951171875e+02 6.3911697387695312e+01 -4.6495002746582031e+01 3.3437899780273438e+02 -2.8980899810791016e+01 -8.4656799316406250e+01 4.5352700805664062e+02 -6.0000499725341797e+01 -4.9077800750732422e+01 1.8212200927734375e+02 2.9206499099731445e+01 -8.1619003295898438e+01 2.3012001037597656e+02 8.1384494900703430e-02 5.8210601806640625e+01 3.2590600585937500e+02 2.0843601226806641e+01 2.2145999908447266e+01 1.2141499328613281e+02 3.0817899703979492e+01 -7.0121902465820312e+01 4.7567700195312500e+02 -4.6996299743652344e+01 1.6270999908447266e+01 4.7411700439453125e+02 -2.0461500167846680e+01 2.2169599533081055e+01 4.7708099365234375e+02 -2.0624200820922852e+01 7.6081399917602539e+00 1.5374000549316406e+02 -1.9587398529052734e+01 -7.4028999328613281e+01 3.4714697265625000e+02 6.0097797393798828e+01 -3.2233303070068359e+01 2.7199798583984375e+02 6.0908397674560547e+01 -6.1903999328613281e+01 1.5916000366210938e+02 -6.7103202819824219e+01 3.5625000000000000e+01 3.3029602050781250e+02 5.2576999664306641e+01 -7.9605400085449219e+01 1.6083000183105469e+02 2.0524600982666016e+01 7.2027496337890625e+01 1.6486099243164062e+02 2.9716699600219727e+01 7.6240898132324219e+01 1.8545500183105469e+02 3.1283699035644531e+01 7.6079299926757812e+01 1.8600399780273438e+02 -4.1304500579833984e+01 7.4833000183105469e+01 3.6487799072265625e+02 -5.3943500518798828e+01 7.1718299865722656e+01 2.0729899597167969e+02 -5.6372798919677734e+01 6.3907802581787109e+01 4.7248199462890625e+02 4.2861801147460938e+01 -3.2742897033691406e+01 3.4727600097656250e+02 -2.1075099945068359e+01 5.6460399627685547e+01 1.9106399536132812e+02 4.4755100250244141e+01 7.3893600463867188e+01 3.4977099609375000e+02 4.7004901885986328e+01 5.9012699127197266e+01 1.8536799621582031e+02 -6.2319400787353516e+01 -6.8996597290039062e+01 1.8572200012207031e+02 -5.9252700805664062e+01 -7.3872299194335938e+01 4.8194302368164062e+02 4.9584300994873047e+01 1.0631100654602051e+01 3.9419601440429688e+02 6.4472305297851562e+01 4.3811199188232422e+01 1.5135900878906250e+02 -1.0893400192260742e+01 -7.9699302673339844e+01 1.5407901000976562e+02 -2.2339599609375000e+01 -7.7376296997070312e+01 2.4361898803710938e+02 7.7641898393630981e-01 5.2963199615478516e+01 2.6086199951171875e+02 -3.3180999755859375e+01 3.2078899383544922e+01 3.5293899536132812e+02 1.9496500015258789e+01 -7.2189102172851562e+01 4.1677297973632812e+02 -6.7151100158691406e+01 2.1611299514770508e+01 1.5938200378417969e+02 2.0673999786376953e+01 7.6856796264648438e+01 2.1184500122070312e+02 3.0791799545288086e+01 7.1641601562500000e+01 4.7677401733398438e+02 -5.0294898986816406e+01 -2.9972101211547852e+01 3.3792999267578125e+02 -6.0076198577880859e+01 -6.2225198745727539e+00 2.7712197875976562e+02 4.7956298828125000e+01 1.5653100013732910e+01 2.3766299438476562e+02 5.3402698516845703e+01 5.0549201965332031e+01 3.0375799179077148e+01 9.9391202926635742e+00 -1.0591000556945801e+01 3.3997299194335938e+02 -4.8548900604248047e+01 5.6806900024414062e+01 4.1624700927734375e+02 -6.4079299926757812e+01 -4.3270599365234375e+01 1.5411199951171875e+02 -2.7009201049804688e+01 -7.8020500183105469e+01 3.6437402343750000e+02 4.9025402069091797e+01 7.4818000793457031e+01 1.8716200256347656e+02 4.6253498077392578e+01 -8.1463699340820312e+01 2.8436099243164062e+02 3.0368900299072266e-01 1.5762899398803711e+01 2.6777200317382812e+02 -6.0659500122070312e+01 -2.6114900588989258e+01 4.6991299438476562e+02 5.9998901367187500e+01 -1.9130100250244141e+01 1.4642800903320312e+02 7.1499694824218750e+01 -2.3242799758911133e+01 4.7739700317382812e+02 -4.6997699737548828e+01 3.3630700111389160e+00 2.4102101135253906e+02 -2.1528799057006836e+01 5.4675800323486328e+01 2.3194700622558594e+02 -2.1836099624633789e+01 6.2076900482177734e+01 4.8216302490234375e+02 -4.9043598175048828e+01 1.0561300277709961e+01 2.0079399108886719e+02 3.9153499603271484e+01 7.3614997863769531e+01 4.1032598876953125e+02 2.0676000595092773e+01 -7.9506500244140625e+01 1.6784199523925781e+02 -2.8001399993896484e+01 7.1406204223632812e+01 -5.2198200225830078e+01 9.3285408020019531e+00 -9.6113891601562500e+00 4.5998901367187500e+02 -2.1096799850463867e+01 4.8851299285888672e+01 2.2198100280761719e+02 3.0446498870849609e+01 -8.4691101074218750e+01 1.5130500793457031e+02 1.0406499862670898e+01 -7.9566703796386719e+01 1.5327499389648438e+02 2.3042499542236328e+01 -7.8294204711914062e+01 3.5034899902343750e+02 -5.4572700500488281e+01 6.1386997222900391e+01 4.5364001464843750e+02 4.9013599395751953e+01 -6.3041599273681641e+01 3.3279699707031250e+02 -4.2505397796630859e+01 -8.3159400939941406e+01 2.3909799194335938e+02 -1.1195799827575684e+01 -8.6013198852539062e+01 -5.2211696624755859e+01 -5.7841696739196777e+00 -2.1085800170898438e+01 -5.2150802612304688e+01 -9.4350700378417969e+00 -1.6849100112915039e+01 2.2823899841308594e+02 2.8106899261474609e+01 6.4293800354003906e+01 4.3345300292968750e+02 -2.0558399200439453e+01 -7.2749801635742188e+01 4.3682797241210938e+02 2.0550899505615234e+01 -7.1027198791503906e+01 4.2785501098632812e+02 6.0000999450683594e+01 5.5945697784423828e+01 4.6189801025390625e+02 -6.0000000000000000e+01 -6.1515498161315918e+00 3.1639797973632812e+02 -4.6750301361083984e+01 1.0335700035095215e+01 -3.6740798950195312e+01 -1.0678500175476074e+01 -1.6623201370239258e+01 2.0746199035644531e+02 -5.9102500915527344e+01 -7.6797302246093750e+01 1.9206100463867188e+02 -5.8412998199462891e+01 6.1629798889160156e+01 4.6382800292968750e+02 -2.0742399215698242e+01 -4.3754299163818359e+01 1.6854199218750000e+02 -5.2668800354003906e+01 6.7774398803710938e+01 1.2142700195312500e+02 -4.5622501373291016e+01 6.2988697052001953e+01 4.8035101318359375e+02 5.3385299682617188e+01 -2.6758899688720703e+00 3.7970199584960938e+02 -3.7449501037597656e+01 -8.4848594665527344e+01 4.5082000732421875e+02 -1.9499898910522461e+01 -5.6452598571777344e+01 3.4095300292968750e+02 -4.6998401641845703e+01 4.9828899383544922e+01 1.7288899230957031e+02 -2.8761299133300781e+01 -7.9521301269531250e+01 1.5466299438476562e+02 -4.4225902557373047e+01 7.0831298828125000e+01 3.5824298095703125e+02 -5.9998600006103516e+01 5.9292999267578125e+01 3.7871398925781250e+02 -5.9998199462890625e+01 6.9279098510742188e+01 2.2982600402832031e+02 -1.6795700073242188e+01 6.0896797180175781e+01 3.3195001220703125e+02 -5.4020198822021484e+01 4.1310600280761719e+01 3.4126699829101562e+02 -5.4441699981689453e+01 5.2895797729492188e+01 3.4962698364257812e+02 -4.6997200012207031e+01 5.8637001037597656e+01 1.7262800598144531e+02 -4.4369602203369141e+01 7.3444801330566406e+01 -5.2204502105712891e+01 6.9395403861999512e+00 -5.5010600090026855e+00 4.7680899047851562e+02 -4.6995800018310547e+01 -9.6744699478149414e+00 4.7443899536132812e+02 -1.9502500534057617e+01 1.3590799331665039e+01 2.7759100341796875e+02 2.6923999786376953e+01 1.8183401107788086e+01 -4.0981300354003906e+01 -8.7790393829345703e+00 -1.8236799240112305e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 4800 -> 87 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 -6.3039101660251617e+01 -4.4126201421022415e+01) (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01) (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01) (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2211698144674301e+01 -5.7841697707772255e+00 -2.1085800603032112e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector -5.2213199436664581e+01 1.3888500398024917e+00 -2.5954500306397676e+00) (float-vector -5.2207201719284058e+01 -1.0355300270020962e+01 -1.0454099625349045e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 1.2140200287103653e+02 -7.4607998132705688e+01 -1.5916200354695320e+01) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 2.0939199626445770e+02 -4.2539101094007492e+01 -8.3531603217124939e+01) (float-vector 1.2144699692726135e+02 -1.1082099750638008e+01 -7.5967900454998016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139499932527542e+02 3.9317898452281952e+01 6.6696301102638245e+01) (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01) (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01) (float-vector 2.0158800482749939e+02 3.0267300084233284e+01 -8.3859503269195557e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0703299343585968e+02 4.7485798597335815e+01 -8.2852497696876526e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8536800146102905e+02 -6.2319401651620865e+01 -6.8996600806713104e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01) (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01) (float-vector 2.1592499315738678e+02 -5.5361699312925339e+01 -8.0084696412086487e+01) (float-vector 1.7460000514984131e+02 -5.2863799035549164e+01 -7.6696202158927917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.8186498880386353e+02 -4.8405200242996216e+01 -1.3818000443279743e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01) (float-vector 1.2139499932527542e+02 1.8486499786376953e+01 -7.4485301971435547e+01) (float-vector 1.6903600096702576e+02 4.3589599430561066e+01 -7.8905403614044189e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector -5.2207399159669876e+01 9.3103600665926933e+00 -1.5870099887251854e+01) (float-vector -5.2213601768016815e+01 1.2892800150439143e+00 -2.2631900385022163e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139599770307541e+02 6.2054000794887543e+01 -4.5387599617242813e+01) (float-vector 1.6479299962520599e+02 5.3966898471117020e+01 -7.2279497981071472e+01) (float-vector 1.8417899310588837e+02 5.3395099937915802e+01 -7.8712299466133118e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01) (float-vector 4.0149700641632080e+02 -6.6905900835990906e+01 -2.9551999643445015e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01) (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 2.8024598956108093e+02 3.4880600869655609e+01 -8.5823699831962585e+01) (float-vector 2.6918500661849976e+02 -1.0910199955105782e+01 -8.6877502501010895e+01) (float-vector 2.7694600820541382e+02 -3.3872399479150772e+01 -8.5934899747371674e+01) (float-vector 4.0298700332641602e+02 -4.9353800714015961e+01 -8.2853198051452637e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.0629300475120544e+02 2.9699599370360374e+01 -8.4733702242374420e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01) (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.3634799122810364e+02 4.4071700423955917e+01 -7.5414702296257019e+01) (float-vector 4.2033699154853821e+02 -3.7974301725625992e+01 -8.2487598061561584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01) (float-vector 4.7164100408554077e+02 -5.9999298304319382e+01 -1.3072200119495392e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.2142699956893921e+02 -4.5622501522302628e+01 6.2988698482513428e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2198201417922974e+01 9.3285404145717621e+00 -9.6113895997405052e+00) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.2140999734401703e+02 5.3768798708915710e+01 5.6119501590728760e+01) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 7.3841698467731476e+01 -1.8654199317097664e+01) (float-vector 2.1107600629329681e+02 6.1521999537944794e+01 -7.3211103677749634e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01) (float-vector 1.2138999998569489e+02 7.6263003051280975e+01 2.3532900959253311e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.0476599335670471e+02 6.0003500431776047e+01 -7.2448499500751495e+01) (float-vector 4.1013801097869873e+02 5.0291299819946289e+01 -8.1996403634548187e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.2976298928260803e+02 -5.2976600825786591e+01 -7.5196698307991028e+01) (float-vector 4.1815400123596191e+02 -5.9998799115419388e+01 -7.0219196379184723e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.3701198697090149e+02 -5.9996999800205231e+01 -6.2299799174070358e+01) (float-vector 4.6382299065589905e+02 -5.9995301067829132e+01 -3.4188698977231979e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4692099094390869e+02 -4.8459600657224655e+01 -6.8739600479602814e+01) (float-vector 4.4970101118087769e+02 -5.3270898759365082e+01 -6.3543997704982758e+01) (float-vector 4.7101598978042603e+02 -4.9802999943494797e+01 -4.2164698243141174e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01) (float-vector 1.2139099836349487e+02 6.7247197031974792e+01 3.7593100219964981e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 1.2139599770307541e+02 -6.6797897219657898e+01 3.8167599588632584e+01) (float-vector 1.7153599858283997e+02 -5.6645900011062622e+01 6.3568502664566040e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.1299599409103394e+02 6.7244499921798706e+01 -2.3317599669098854e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4211900234222412e+02 5.9998899698257446e+01 -5.9171501547098160e+01) (float-vector 4.4024398922920227e+02 5.4464600980281830e+01 -6.8112596869468689e+01) (float-vector 4.4373801350593567e+02 4.8891298472881317e+01 -7.0732600986957550e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6098399162292480e+02 6.0000199824571609e+01 -3.9570901542901993e+01) (float-vector 4.6399798989295959e+02 4.8775400966405869e+01 -5.2801400423049927e+01) (float-vector 4.7575300931930542e+02 4.9695499241352081e+01 -3.3041000366210938e+01) (float-vector 4.6991300582885742e+02 5.9998899698257446e+01 -1.9130099564790726e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2139999866485596e+02 1.9523799419403076e+01 7.4487298727035522e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 1.7262800037860870e+02 -4.4369600713253021e+01 7.3444798588752747e+01) (float-vector 1.2140399962663651e+02 -2.9224200174212456e+01 7.1641400456428528e+01) (float-vector 1.2137699872255325e+02 1.8111800309270620e+00 7.6768301427364349e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 1.9106400012969971e+02 4.4755101203918457e+01 7.3893599212169647e+01) (float-vector 1.5310999751091003e+02 4.6697098761796951e+01 6.9339200854301453e+01) (float-vector 1.8761500716209412e+02 5.8249600231647491e+01 6.2449000775814056e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4017499685287476e+02 6.5324299037456512e+01 3.3569599036127329e+00) (float-vector 4.7258099913597107e+02 5.9998698532581329e+01 1.4192500384524465e+00) (float-vector 4.6810600161552429e+02 6.0000199824571609e+01 2.5183700025081635e+01) (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.5493099093437195e+02 6.0001399368047714e+01 4.7762699425220490e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01) (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 1.2139499932527542e+02 7.4014000594615936e+01 1.9531600177288055e+01) (float-vector 4.1278299689292908e+02 6.5869696438312531e+01 3.4340299665927887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.7154501080513000e+02 -5.9999998658895493e+01 1.2690000236034393e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8285898566246033e+02 4.9023598432540894e+01 -2.2885201033204794e+00) (float-vector 4.8216301202774048e+02 -4.9043599516153336e+01 1.0561300441622734e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01) (float-vector 4.7536298632621765e+02 5.3367301821708679e+01 2.8076700866222382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01) (float-vector 4.3856400251388550e+02 5.9996899217367172e+01 6.1295598745346069e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01) (float-vector 3.9531201124191284e+02 5.9999398887157440e+01 7.2362400591373444e+01) (float-vector 4.2199999094009399e+02 5.9999801218509674e+01 6.9077000021934509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2138999998569489e+02 -7.3373302817344666e+01 2.2108100354671478e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01) (float-vector 4.2928799986839294e+02 -6.6924296319484711e+01 5.2737300284206867e+00) (float-vector 1.2139900028705597e+02 -7.6086997985839844e+01 -2.0323600620031357e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01) (float-vector 4.6816301345825195e+02 4.7333400696516037e+01 4.6460900455713272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5424801111221313e+02 -5.9998899698257446e+01 4.8128001391887665e+01) (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01) (float-vector 4.6494799852371216e+02 -5.9999100863933563e+01 3.2285101711750031e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5430499315261841e+02 -5.5246300995349884e+01 5.6729398667812347e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.7038099169731140e+02 -4.9879800528287888e+01 4.3316800147294998e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.2204600572586060e+02 -5.9998299926519394e+01 6.8907298147678375e+01) (float-vector 4.0339198708534241e+02 -6.0000199824571609e+01 7.2648502886295319e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1280201077461243e+02 5.4773598909378052e+01 7.7729001641273499e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.1146498918533325e+02 -5.0028800964355469e+01 8.1623300909996033e+01) (float-vector 3.9807999134063721e+02 5.0818700343370438e+01 8.2171097397804260e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5564800500869751e+02 4.8281200230121613e+01 6.1075899749994278e+01) (float-vector 4.4899201393127441e+02 -4.8467300832271576e+01 6.6893897950649261e+01) (float-vector 4.4112101197242737e+02 -5.3270898759365082e+01 6.8994700908660889e+01) (float-vector 4.3329599499702454e+02 -4.9894701689481735e+01 7.5655803084373474e+01) (float-vector 4.2645800113677979e+02 4.8638898879289627e+01 7.8525602817535400e+01) (float-vector 4.4826701283454895e+02 5.1183599978685379e+01 6.6398002207279205e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_upper_arm_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_upper_arm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 156 0 157 306 1 0 306 0 430 430 0 156 0 2 157 1 319 2 319 361 2 157 2 361 1 6 319 319 193 361 193 319 6 157 361 437 361 193 437 223 157 437 223 437 193 223 158 157 223 15 17 15 223 193 158 223 17 156 157 158 156 158 327 158 469 327 158 17 469 430 156 327 306 430 291 291 430 56 56 430 500 500 430 327 306 291 292 372 1 306 372 306 292 292 371 372 371 498 372 498 6 372 6 1 372 371 292 492 371 492 498 7 6 498 498 492 7 6 7 8 193 6 8 8 7 283 492 283 7 492 292 258 492 258 283 282 283 258 253 283 282 283 253 8 282 143 142 282 258 143 253 282 142 141 142 143 258 259 143 141 143 259 141 277 142 142 155 253 277 155 142 277 141 120 277 120 155 120 154 155 398 253 155 398 155 244 244 155 154 26 119 120 120 119 243 141 26 120 120 243 154 243 244 154 243 140 244 138 140 243 138 243 119 110 138 119 26 110 119 138 139 140 323 138 110 323 324 138 324 139 138 110 26 111 111 323 110 323 111 324 324 25 139 25 324 111 25 24 139 55 140 139 55 139 24 24 25 26 26 25 111 24 269 55 269 24 26 313 269 26 313 26 141 269 149 55 313 149 269 141 312 313 285 149 313 285 313 263 313 312 263 312 141 259 391 312 65 65 312 66 312 259 66 263 312 391 259 258 66 65 66 67 293 443 66 258 293 66 66 443 67 391 65 67 408 392 67 392 391 67 408 67 443 293 305 443 305 408 443 258 292 293 292 305 293 291 305 292 305 291 408 408 291 409 264 408 409 264 392 408 264 391 392 246 263 264 192 264 409 57 246 264 264 263 391 57 264 192 409 401 192 291 401 409 57 192 58 192 401 58 56 57 58 245 246 57 245 57 56 291 56 58 401 291 58 245 56 500 245 500 412 326 245 412 245 326 246 500 327 412 327 411 412 411 326 412 326 327 328 328 327 469 326 411 327 124 326 328 421 124 328 474 328 469 421 328 474 474 469 475 469 17 475 474 422 421 422 474 475 422 475 17 15 16 17 17 16 422 16 421 422 432 16 15 421 16 484 16 432 484 112 113 15 193 112 15 113 432 15 112 193 194 194 270 112 203 113 112 270 203 112 266 193 94 193 8 94 266 194 193 204 194 266 204 270 194 203 270 204 202 203 204 202 38 203 203 38 113 265 204 266 204 265 340 202 204 340 94 341 266 265 266 341 340 265 341 339 294 340 294 202 340 341 339 340 294 11 202 11 38 202 11 10 38 38 10 113 9 10 11 11 294 46 11 46 9 234 294 295 46 294 234 295 294 339 45 9 46 234 45 46 10 9 209 45 209 9 10 209 173 10 173 113 113 415 432 113 173 415 172 173 174 173 314 174 415 173 172 173 209 314 414 415 172 432 415 433 433 415 414 172 174 311 414 172 311 314 311 174 314 404 368 209 404 314 314 368 311 404 369 368 404 354 369 209 354 404 368 369 370 368 370 311 370 369 479 354 446 369 446 479 369 209 45 354 45 446 354 236 398 446 446 45 236 446 464 479 446 398 464 479 44 370 464 463 479 479 463 44 462 463 464 462 464 398 244 487 398 398 487 462 236 253 398 463 462 27 462 487 27 463 27 44 27 28 29 29 44 27 487 28 27 244 28 487 244 257 28 244 140 257 28 257 29 257 189 29 191 44 29 189 191 29 140 189 257 140 55 190 140 190 189 189 190 191 190 54 191 191 212 272 272 44 191 191 54 212 55 54 190 53 54 55 211 55 149 53 55 211 54 53 212 53 211 212 212 211 272 271 68 272 211 271 272 44 272 68 211 149 271 271 461 68 149 461 271 68 69 44 396 69 68 396 68 461 149 396 461 149 395 396 396 395 69 69 440 44 395 440 69 395 439 440 149 151 395 151 208 395 395 208 439 439 74 440 74 44 440 439 72 74 72 439 208 207 208 151 400 208 207 72 208 400 149 150 151 151 150 207 42 207 150 207 42 400 400 42 73 73 72 400 72 73 74 73 42 75 74 73 75 42 43 44 70 42 71 42 44 71 150 43 42 149 285 150 150 285 43 285 198 43 43 198 501 501 44 43 44 74 71 44 501 370 74 70 71 370 197 419 495 370 419 495 311 370 501 197 370 198 197 501 196 197 198 285 196 198 196 285 263 196 303 419 196 419 197 263 303 196 303 495 419 468 311 495 343 468 495 343 495 303 263 246 303 246 343 303 61 466 343 466 468 343 246 61 343 466 467 468 311 468 467 466 63 467 466 61 63 61 62 63 326 61 246 61 326 62 63 217 467 63 483 217 62 483 63 467 217 311 216 137 217 311 217 137 483 216 217 62 444 483 444 216 483 326 124 62 62 124 444 124 84 444 84 382 444 216 444 382 216 382 137 137 382 386 84 476 382 382 476 386 137 386 135 386 427 135 476 427 386 84 83 476 476 83 427 135 427 108 427 83 108 82 83 84 107 108 83 82 107 83 135 108 480 224 480 108 107 224 108 224 107 82 82 145 144 145 82 84 82 144 224 224 144 225 224 225 480 144 145 146 144 146 225 146 145 302 84 302 145 84 124 97 97 302 84 95 124 351 456 330 124 97 124 95 456 124 421 330 351 124 95 96 97 351 96 95 351 332 147 96 351 147 330 332 351 330 331 332 484 331 330 484 330 456 456 421 484 432 331 484 331 432 389 374 331 389 332 331 374 488 432 433 389 432 488 374 389 390 389 488 390 352 332 374 352 374 390 352 390 353 390 310 137 488 310 390 353 390 137 433 310 488 433 414 310 310 311 137 310 414 311 135 136 137 136 353 137 276 352 353 276 353 136 276 332 352 136 275 276 332 276 275 135 431 136 380 275 136 431 380 136 147 275 380 147 332 275 380 431 148 147 380 148 497 431 135 148 431 497 18 147 148 278 148 497 18 148 278 383 96 147 18 20 147 147 20 383 18 19 20 19 18 278 278 497 460 19 278 460 460 497 135 459 460 135 493 19 460 493 460 459 20 19 455 455 19 493 459 188 493 455 493 188 459 480 423 423 188 459 480 459 135 186 187 188 186 188 423 187 455 188 187 20 455 3 377 187 248 20 187 376 248 187 187 186 465 337 187 465 3 187 337 376 187 377 186 423 465 338 465 423 465 338 337 336 337 338 336 397 337 3 337 397 410 336 338 338 423 410 410 436 336 304 336 436 397 336 304 3 397 304 4 3 304 4 304 435 435 304 436 434 435 436 210 434 436 436 410 210 434 4 435 98 4 434 434 210 98 98 99 100 100 4 98 289 98 210 99 98 289 78 100 99 167 78 99 167 99 289 77 100 78 77 118 100 118 4 100 76 77 78 166 78 167 261 78 166 261 76 78 166 167 175 175 167 289 289 210 175 116 210 205 115 210 116 210 410 205 210 115 175 114 115 116 205 206 116 206 114 116 346 347 205 347 206 205 346 205 410 410 480 225 346 410 225 423 480 410 346 318 347 225 146 346 146 318 346 317 206 347 318 317 347 316 317 318 146 316 318 316 146 302 316 302 301 316 301 317 317 489 206 489 317 301 489 91 93 489 114 206 301 91 489 489 93 114 91 92 93 91 485 92 91 301 485 93 447 115 92 290 93 114 93 115 447 93 290 115 447 175 447 290 175 290 231 175 231 290 92 166 175 176 175 231 375 176 175 375 261 166 176 201 200 176 200 261 176 201 176 375 300 199 375 199 201 375 300 375 231 199 200 201 281 199 300 280 200 199 199 281 280 299 279 300 233 300 231 279 281 300 299 300 233 279 280 281 59 280 279 200 280 490 59 490 280 299 59 279 273 299 233 273 424 299 59 299 424 231 232 233 232 273 233 60 273 274 273 232 274 273 60 424 60 59 424 14 59 60 59 14 490 12 13 14 457 14 13 457 490 14 12 14 60 366 219 12 12 60 366 219 13 12 13 219 218 182 13 218 182 457 13 218 219 220 220 219 366 182 218 213 218 220 287 218 287 450 218 450 213 181 182 183 183 182 213 457 182 181 450 296 213 428 183 213 213 296 428 287 296 450 286 287 288 286 296 287 287 220 288 428 296 286 105 428 286 183 428 105 181 183 134 134 183 105 104 105 106 417 106 105 105 286 325 104 134 105 105 325 417 286 288 325 288 358 378 348 288 220 288 348 358 378 130 288 130 325 288 130 378 131 131 378 358 226 358 348 226 228 358 131 358 228 130 131 132 36 131 228 35 131 36 131 35 132 214 130 132 130 214 325 359 214 132 359 325 214 359 360 325 240 325 360 417 325 240 359 132 472 284 359 472 359 284 360 360 284 240 240 241 242 251 241 240 417 240 242 284 251 240 90 417 418 417 90 106 242 418 417 242 241 445 445 418 242 251 350 241 350 445 241 445 385 418 445 350 251 251 403 445 445 403 385 251 284 179 403 251 179 21 403 179 385 403 452 403 21 452 179 180 21 179 284 315 179 315 399 399 180 179 364 159 180 180 159 22 180 399 364 21 180 22 35 482 399 486 399 482 364 399 486 315 35 399 284 132 315 35 315 132 284 472 132 35 36 37 482 35 37 37 481 482 486 482 481 486 499 364 499 486 481 481 37 121 121 499 481 237 37 36 237 121 37 227 36 228 36 227 237 226 227 228 170 227 226 237 227 170 226 348 126 226 126 170 170 126 171 170 171 473 473 237 170 125 126 127 171 126 125 126 348 127 220 366 348 127 348 366 127 366 367 367 366 60 127 367 458 478 367 363 458 367 478 367 60 363 60 274 363 274 362 363 478 363 362 478 362 388 478 388 458 458 388 387 127 458 387 387 388 335 388 362 426 335 388 426 362 232 231 362 231 426 274 232 362 231 425 426 92 425 231 425 451 426 122 425 92 122 451 425 485 122 92 121 122 123 122 121 442 122 485 301 122 442 451 122 301 123 442 121 321 121 237 321 121 123 499 442 321 405 442 405 451 229 320 321 405 321 406 321 237 229 321 320 406 405 406 407 405 407 454 451 405 454 406 262 163 407 406 163 406 320 262 407 163 178 454 407 178 454 426 451 454 178 426 163 177 178 334 335 178 349 178 177 178 335 426 178 349 334 101 177 345 345 177 163 349 177 101 333 334 349 344 349 101 344 333 349 101 102 103 344 101 103 102 101 345 496 333 344 41 344 103 381 496 344 381 344 41 384 41 103 103 102 345 103 345 384 384 345 165 429 384 165 429 41 384 163 164 165 402 165 164 165 345 163 402 429 165 39 41 429 429 402 342 429 342 39 255 402 256 342 402 255 402 164 256 256 164 438 163 438 164 254 255 256 438 470 256 254 256 470 342 255 229 51 229 255 255 254 51 50 51 52 229 51 230 50 230 51 52 51 254 50 52 64 168 50 169 169 50 64 50 168 230 64 52 169 52 441 169 52 254 441 168 169 416 441 491 169 416 169 491 355 168 416 230 168 355 229 230 184 355 184 230 184 355 356 356 355 416 297 416 471 471 416 491 356 416 297 441 254 491 491 254 471 254 470 471 470 297 471 470 438 297 438 163 297 297 163 298 80 356 297 80 297 298 184 356 80 79 80 81 80 79 184 80 448 81 80 298 448 87 298 163 87 448 298 262 87 163 87 86 85 86 87 262 85 449 87 449 448 87 48 448 449 81 448 48 79 81 365 365 81 48 47 48 49 222 48 47 222 365 48 79 365 229 221 365 222 229 365 320 320 365 221 221 222 47 320 221 329 221 195 329 195 221 47 320 329 86 320 86 262 195 86 329 86 195 47 86 47 85 47 49 85 79 229 184 342 229 237 342 237 309 39 342 309 237 238 239 309 237 239 238 237 473 239 238 381 238 473 496 238 496 381 307 309 239 307 239 381 494 307 381 494 381 41 307 308 309 308 307 322 307 494 322 494 41 40 494 40 322 39 40 41 309 322 40 309 40 39 308 322 309 333 496 171 473 171 496 171 125 333 333 125 334 125 127 379 125 379 334 334 379 335 387 379 127 379 387 335 364 499 393 499 123 393 364 393 394 364 394 159 393 123 394 394 123 23 123 301 23 394 23 159 159 23 22 21 22 23 109 21 23 301 109 23 301 302 152 301 152 109 152 453 109 453 21 109 452 21 453 452 453 153 153 453 152 385 452 153 152 30 153 385 153 32 153 30 32 477 385 373 385 477 418 373 385 32 30 31 32 31 373 32 30 247 31 268 247 30 152 268 30 31 260 373 31 247 260 373 260 90 477 373 90 418 477 90 88 89 90 90 261 200 260 261 90 89 106 90 200 88 90 260 76 261 247 76 260 268 77 76 268 76 247 267 118 77 268 267 77 152 267 268 267 117 118 152 117 267 117 5 118 5 4 118 5 117 413 162 117 152 117 162 413 162 152 302 160 161 162 162 377 413 162 161 377 160 162 302 413 3 5 377 3 413 3 4 5 161 376 377 357 376 161 357 161 160 160 302 357 185 302 97 302 185 357 357 248 376 357 128 248 185 128 357 97 129 185 128 185 129 383 97 96 129 97 383 128 129 20 129 383 20 128 20 248 420 89 88 490 457 88 420 88 457 490 88 200 420 181 133 133 89 420 457 181 420 215 106 89 133 215 89 133 134 104 133 104 215 181 134 133 215 104 106 252 253 236 252 34 253 34 8 253 234 235 236 45 234 236 235 252 236 235 234 295 235 295 249 252 235 249 249 295 250 295 339 250 249 250 33 252 249 33 33 250 94 339 94 250 339 341 94 8 33 94 33 8 34 33 34 252))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.3837001037597656e+02 2.8102998733520508e+01 -5.3000000000000000e+01 1.4036999511718750e+02 2.7274599075317383e+01 -5.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 -5.5828399658203125e+01 1.1886999511718750e+02 6.0911300659179688e+01 2.3493299484252930e+01 1.1886599731445312e+02 5.5482101440429688e+01 3.3601200103759766e+01 1.1886999511718750e+02 6.4159896850585938e+01 3.3188999176025391e+01 1.4036999511718750e+02 -2.5872699737548828e+01 -6.5000000000000000e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -6.4158203125000000e+01 1.3837001037597656e+02 -2.6258998870849609e+01 -6.7000000000000000e+01 1.1886999511718750e+02 -3.8841802626848221e-02 -7.2086601257324219e+01 1.1886999511718750e+02 9.7871809005737305e+00 -7.1372596740722656e+01 1.2137000274658203e+02 3.0495100021362305e+00 -7.1979003906250000e+01 1.1886999511718750e+02 -7.5180497169494629e+00 7.1620002746582031e+01 1.2137000274658203e+02 -1.5263999700546265e+00 7.2027099609375000e+01 1.1886999511718750e+02 1.7722400426864624e+00 7.2045806884765625e+01 1.1886999511718750e+02 2.9271900177001953e+01 -6.5830902099609375e+01 1.1886999511718750e+02 3.2772102355957031e+01 -6.4178802490234375e+01 1.2225399780273438e+02 3.0408300399780273e+01 -6.5315002441406250e+01 1.1886899566650391e+02 6.2879100799560547e+01 -1.7059499740600586e+01 1.1886999511718750e+02 6.4711402893066406e+01 -7.0697798728942871e+00 1.1886999511718750e+02 7.1740097045898438e+01 -8.0421199798583984e+00 1.2334299468994141e+02 2.0932399749755859e+01 5.2999897003173828e+01 1.2235099792480469e+02 1.1860799789428711e+01 5.2780300140380859e+01 1.2156599426269531e+02 1.2450900077819824e+01 5.1984100341796875e+01 1.2137000274658203e+02 -5.4027698516845703e+01 -4.0807399749755859e+01 1.2137000274658203e+02 -5.6317501068115234e+01 -4.3395599365234375e+01 1.2137000274658203e+02 -4.6876697540283203e+01 -4.7991001129150391e+01 1.1737000274658203e+02 -3.4353099822998047e+01 -5.3386100769042969e+01 1.1847600555419922e+02 -3.5485801696777344e+01 -5.3080101013183594e+01 1.1737200164794922e+02 -3.9874198913574219e+01 -4.9363899230957031e+01 1.2137000274658203e+02 3.2102996826171875e+01 5.4171600341796875e+01 1.2137000274658203e+02 3.2102996826171875e+01 6.4500503540039062e+01 1.2175499725341797e+02 3.0767000198364258e+01 5.8083000183105469e+01 1.2330100250244141e+02 -1.5703101158142090e+01 -6.6997795104980469e+01 1.2337000274658203e+02 -2.6254899978637695e+01 -6.7000000000000000e+01 1.2337000274658203e+02 -2.7886999130249023e+01 5.3000000000000000e+01 1.2175899505615234e+02 -3.0437400817871094e+01 5.4857498168945312e+01 1.2175499725341797e+02 -2.8295799255371094e+01 5.2285400390625000e+01 1.2137000274658203e+02 1.5079000473022461e+01 -7.0493698120117188e+01 1.1886999511718750e+02 -6.0362800598144531e+01 2.3838798522949219e+01 1.1886999511718750e+02 -6.5623100280761719e+01 2.7320598602294922e+01 1.1886999511718750e+02 -5.8172500610351562e+01 2.8881599426269531e+01 1.1761999511718750e+02 -2.7101200103759766e+01 -1.7819499969482422e+01 1.1763499450683594e+02 -2.1460599899291992e+01 -2.4439599990844727e+01 1.1737000274658203e+02 -2.4275100708007812e+01 -2.2130399703979492e+01 1.1886999511718750e+02 -1.1811599731445312e+01 -7.1095497131347656e+01 1.2137000274658203e+02 -7.5685801506042480e+00 -7.1636199951171875e+01 1.1761999511718750e+02 -3.0257101058959961e+01 1.3208700180053711e+01 1.1761999511718750e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.1737000274658203e+02 -3.0257101058959961e+01 1.3458700180053711e+01 1.2137000274658203e+02 -3.8890602111816406e+01 1.2624699592590332e+01 1.2137000274658203e+02 -4.2355197906494141e+01 1.1919799804687500e+01 1.2137000274658203e+02 -4.0975399017333984e+01 1.1504599571228027e+01 1.1761999511718750e+02 -5.1134197235107422e+01 -3.7537002563476562e+01 1.1818900299072266e+02 -4.9283901214599609e+01 -4.0244300842285156e+01 1.1886999511718750e+02 -5.2137298583984375e+01 -3.8670799255371094e+01 1.2222299957275391e+02 1.0924599647521973e+01 -5.2719699859619141e+01 1.2137000274658203e+02 4.8255200386047363e+00 -5.1033500671386719e+01 1.2224900054931641e+02 5.6168699264526367e+00 -5.2746398925781250e+01 1.1886599731445312e+02 2.0431599617004395e+00 6.4957099914550781e+01 1.1886599731445312e+02 -7.1629400253295898e+00 6.4649597167968750e+01 1.2137000274658203e+02 8.2198905944824219e+00 -3.1664598464965820e+01 1.2137000274658203e+02 1.6157999038696289e+01 -2.8363399505615234e+01 1.1761599731445312e+02 1.4625800132751465e+01 -2.9182701110839844e+01 1.2136799621582031e+02 -4.0019298553466797e+01 1.1677000045776367e+01 1.2155699920654297e+02 -2.4789800643920898e+01 -5.1964996337890625e+01 1.2205799865722656e+02 -2.8022800445556641e+01 -5.2669300079345703e+01 1.2157999420166016e+02 -1.8630100250244141e+01 -5.2017902374267578e+01 1.1737000274658203e+02 -4.0101600646972656e+01 -2.5444200515747070e+01 1.1737000274658203e+02 -3.7895401000976562e+01 -2.3592500686645508e+01 1.1737000274658203e+02 -2.7581300735473633e+01 -1.7707799911499023e+01 1.1737000274658203e+02 -2.7310300827026367e+01 -1.7956501007080078e+01 1.1761999511718750e+02 -2.8460399627685547e+01 -1.7514900207519531e+01 1.1761999511718750e+02 -2.7937698364257812e+01 -1.7367401123046875e+01 1.1737000274658203e+02 -2.8329801559448242e+01 -1.7728000640869141e+01 1.1737000274658203e+02 -2.7937698364257812e+01 -1.7617401123046875e+01 1.1886999511718750e+02 3.8424701690673828e+01 6.1056697845458984e+01 1.1886999511718750e+02 4.7440799713134766e+01 5.4317199707031250e+01 1.1886700439453125e+02 3.7178501129150391e+01 5.3142101287841797e+01 1.1761999511718750e+02 -3.5414699554443359e+01 1.5034999847412109e+01 1.1737000274658203e+02 -3.5414699554443359e+01 1.5284999847412109e+01 1.1761999511718750e+02 -3.4026500701904297e+01 1.4747900009155273e+01 1.2137000274658203e+02 3.1945198059082031e+01 -7.2414598464965820e+00 1.1763399505615234e+02 3.1368400573730469e+01 -9.2509603500366211e+00 1.2137000274658203e+02 2.8730501174926758e+01 -1.5605100631713867e+01 1.1737000274658203e+02 -2.9854598999023438e+01 1.3576099395751953e+01 1.1761999511718750e+02 -2.9351299285888672e+01 1.3784900665283203e+01 1.1737000274658203e+02 -2.9577798843383789e+01 1.3890800476074219e+01 1.1886999511718750e+02 1.9947898864746094e+01 6.9319000244140625e+01 1.2275599670410156e+02 2.6223499298095703e+01 6.7096702575683594e+01 1.1886999511718750e+02 2.8016601562500000e+01 6.6379196166992188e+01 1.2137000274658203e+02 1.4018799781799316e+01 2.9597200393676758e+01 1.1764299774169922e+02 5.6489901542663574e+00 3.2238201141357422e+01 1.1759600067138672e+02 1.6880899429321289e+01 2.8038600921630859e+01 1.2317100524902344e+02 -6.0609102249145508e-01 -6.7000297546386719e+01 1.2137000274658203e+02 6.1707298278808594e+01 -3.7386100769042969e+01 1.1886999511718750e+02 6.5867202758789062e+01 -2.9558200836181641e+01 1.2137000274658203e+02 6.7189094543457031e+01 -2.6405298233032227e+01 1.1845099639892578e+02 4.8900100708007812e+01 4.1262802124023438e+01 1.1849299621582031e+02 4.3287399291992188e+01 4.7150798797607422e+01 1.1886599731445312e+02 4.7488800048828125e+01 4.4185199737548828e+01 1.1855900573730469e+02 -4.9810398101806641e+01 4.0064201354980469e+01 1.1814800262451172e+02 -5.1147800445556641e+01 3.7811901092529297e+01 1.1867500305175781e+02 -5.3971000671386719e+01 3.4668098449707031e+01 1.2241799926757812e+02 1.3628199577331543e+01 6.7201698303222656e+01 1.2286000061035156e+02 4.4063701629638672e+00 6.7005096435546875e+01 1.2337000274658203e+02 2.6470899581909180e+01 6.7000000000000000e+01 1.1761999511718750e+02 3.2391300201416016e+01 -3.9578700065612793e+00 1.1737000274658203e+02 3.2497699737548828e+01 -5.1400599479675293e+00 1.2161599731445312e+02 2.2089900970458984e+01 5.2101200103759766e+01 1.2137000274658203e+02 -5.4713001251220703e+01 -4.6703899383544922e+01 1.2137000274658203e+02 -5.6568500518798828e+01 -4.4058200836181641e+01 1.2337000274658203e+02 2.6470899581909180e+01 -6.7000000000000000e+01 1.1886999511718750e+02 2.1601699829101562e+01 -6.8827796936035156e+01 1.1760900115966797e+02 2.2688598632812500e+01 2.3479598999023438e+01 1.1737000274658203e+02 1.9260601043701172e+01 2.6627300262451172e+01 1.1737000274658203e+02 2.5179500579833984e+01 2.1338300704956055e+01 1.2137000274658203e+02 6.4264198303222656e+01 3.2988399505615234e+01 1.1886999511718750e+02 5.6136501312255859e+01 4.5345397949218750e+01 1.2137000274658203e+02 -4.8838600158691406e+01 -5.2884002685546875e+01 1.2137000274658203e+02 -3.8841197967529297e+01 -6.0686500549316406e+01 1.2137000274658203e+02 -1.8172599792480469e+01 5.0735500335693359e+01 1.2137000274658203e+02 -3.7241301536560059e+00 3.2484401702880859e+01 1.2137400054931641e+02 -6.7035800218582153e-01 5.1426300048828125e+01 1.2137000274658203e+02 5.5127597808837891e+01 -4.6537998199462891e+01 1.1886700439453125e+02 -3.5631198883056641e+01 5.3900901794433594e+01 1.1886999511718750e+02 -3.8045997619628906e+01 6.1132801055908203e+01 1.1884999847412109e+02 -2.8608699798583984e+01 5.7999202728271484e+01 1.2137000274658203e+02 7.2016403198242188e+01 -4.6319098472595215e+00 1.2137000274658203e+02 7.0636802673339844e+01 -1.4785599708557129e+01 1.2915499877929688e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.2337000274658203e+02 -2.9887001037597656e+01 5.5000000000000000e+01 1.3837001037597656e+02 -2.9887001037597656e+01 5.5000000000000000e+01 1.2165000152587891e+02 1.9512100219726562e+01 6.7920204162597656e+01 1.2159000396728516e+02 1.0458299636840820e+01 6.7999496459960938e+01 1.1737000274658203e+02 6.0491100311279297e+01 -2.0045900344848633e+01 1.1738099670410156e+02 5.4535400390625000e+01 -3.2764598846435547e+01 1.1737000274658203e+02 2.4598600387573242e+01 -2.1879899978637695e+01 1.1886999511718750e+02 -5.6352699279785156e+01 -4.4678798675537109e+01 1.1886999511718750e+02 -5.6317501068115234e+01 -4.3395599365234375e+01 1.1886999511718750e+02 -4.4921699523925781e+01 -4.7023899078369141e+01 1.2137000274658203e+02 -3.1886999130249023e+01 -5.4171600341796875e+01 1.2171799468994141e+02 -3.0610200881958008e+01 -6.5120101928710938e+01 1.2219099426269531e+02 -3.0203300476074219e+01 -5.9604999542236328e+01 1.2137000274658203e+02 3.2632999420166016e+01 -1.4210900454981155e-14 1.2137000274658203e+02 3.4800498962402344e+01 -5.4644002914428711e+00 1.2137000274658203e+02 3.2294197082519531e+01 4.8958797454833984e+00 1.1886999511718750e+02 5.7366401672363281e+01 -3.1222900390625000e+01 1.1868800354003906e+02 6.0740200042724609e+01 -2.1166299819946289e+01 1.2137000274658203e+02 -4.0288799285888672e+01 -2.5278499603271484e+01 1.2137000274658203e+02 -2.3569700241088867e+01 -2.2407899856567383e+01 1.2137000274658203e+02 -3.8026000976562500e+01 -2.3379400253295898e+01 1.2137000274658203e+02 2.8931400299072266e+01 5.1000000000000000e+01 1.2189800262451172e+02 3.0577301025390625e+01 5.4872501373291016e+01 1.1886999511718750e+02 -3.9752700805664062e+01 -5.9999702453613281e+01 1.1886999511718750e+02 -3.3598697662353516e+01 -6.3636398315429688e+01 1.2337000274658203e+02 2.8102998733520508e+01 -5.3000000000000000e+01 1.3837001037597656e+02 3.0103000640869141e+01 -5.5000000000000000e+01 1.2337000274658203e+02 3.0103000640869141e+01 -5.5000000000000000e+01 1.2232700347900391e+02 6.0257802009582520e+00 5.2771499633789062e+01 1.2137000274658203e+02 6.7176605224609375e+01 8.7329998016357422e+00 1.2137000274658203e+02 7.1865295410156250e+01 6.4717001914978027e+00 1.2137000274658203e+02 6.9949203491210938e+01 1.8015501022338867e+01 1.1737000274658203e+02 -2.4616600036621094e+01 2.1620100021362305e+01 1.1737000274658203e+02 -5.4012897491455078e+01 1.9935699462890625e+01 1.1737000274658203e+02 -5.8990299224853516e+01 2.3230199813842773e+01 1.1854199981689453e+02 2.8987800598144531e+01 5.7150798797607422e+01 1.1841400146484375e+02 3.6011798858642578e+01 5.2829399108886719e+01 1.1761999511718750e+02 -3.8890602111816406e+01 1.2624699592590332e+01 1.1760600280761719e+02 -3.9935100555419922e+01 1.1683500289916992e+01 1.2137000274658203e+02 -4.2364700317382812e+01 5.8364498138427734e+01 1.1886999511718750e+02 -4.7349201202392578e+01 5.4317897796630859e+01 1.1849199676513672e+02 1.9945800781250000e+01 -6.0786899566650391e+01 1.1886999511718750e+02 1.3379899978637695e+01 -6.3592998504638672e+01 1.1843399810791016e+02 1.4714799880981445e+01 -6.2136501312255859e+01 1.1737000274658203e+02 2.8809198379516602e+01 5.6720001220703125e+01 1.1848600006103516e+02 2.3653398513793945e+01 5.9397701263427734e+01 1.1737000274658203e+02 -4.5455501556396484e+01 4.4291801452636719e+01 1.1737000274658203e+02 -3.9683101654052734e+01 4.9556999206542969e+01 1.3837001037597656e+02 2.7618200778961182e+00 5.3000000000000000e+01 1.2330699920654297e+02 5.9888100624084473e+00 5.2999797821044922e+01 1.2137300109863281e+02 1.2602199554443359e+01 6.8827499389648438e+01 1.2137100219726562e+02 1.5094200372695923e+00 6.9024803161621094e+01 1.2158600616455078e+02 3.4607899188995361e+00 6.7970703125000000e+01 1.1761999511718750e+02 -3.7071300506591797e+01 1.4618099212646484e+01 1.2137000274658203e+02 6.6644500732421875e+01 -9.7219600677490234e+00 1.1863300323486328e+02 6.4118804931640625e+01 4.4358601570129395e+00 1.1886999511718750e+02 6.4816398620605469e+01 8.3940601348876953e+00 1.1848400115966797e+02 6.4006004333496094e+01 8.6720287799835205e-02 1.1844400024414062e+02 -4.2903800964355469e+01 -4.7232700347900391e+01 1.1855000305175781e+02 -4.6752799987792969e+01 -4.3500598907470703e+01 1.1737000274658203e+02 -4.6861598968505859e+01 -4.2791900634765625e+01 1.2154599761962891e+02 2.4122200906276703e-01 -5.1890102386474609e+01 1.3837001037597656e+02 2.6475099563598633e+01 -6.7000000000000000e+01 1.2312799835205078e+02 2.0708600997924805e+01 -6.7007202148437500e+01 1.2137000274658203e+02 -2.9902299880981445e+01 1.3273699760437012e+01 1.1764099884033203e+02 -9.2966394424438477e+00 -3.1213098526000977e+01 1.1737000274658203e+02 -1.4536700248718262e+01 -2.9371000289916992e+01 1.1762899780273438e+02 -1.5938500404357910e+01 -2.8328201293945312e+01 1.1854899597167969e+02 1.6234100341796875e+01 6.1868701934814453e+01 1.1886999511718750e+02 2.1466100692749023e+01 6.1433597564697266e+01 1.1850800323486328e+02 2.0161399841308594e+01 6.0728401184082031e+01 1.2137300109863281e+02 1.0267900466918945e+01 -6.8858604431152344e+01 1.2137000274658203e+02 2.0674999237060547e+01 -6.9000000000000000e+01 1.2189800262451172e+02 1.5803700447082520e+01 -6.7499198913574219e+01 1.1737000274658203e+02 2.9397100448608398e+01 1.4782500267028809e+01 1.1761599731445312e+02 2.6375898361206055e+01 1.9258800506591797e+01 1.2137000274658203e+02 -2.7101200103759766e+01 -1.7819499969482422e+01 1.2137000274658203e+02 -2.8460399627685547e+01 -1.7514900207519531e+01 1.1886999511718750e+02 3.3142700195312500e+00 -6.5001304626464844e+01 1.1737000274658203e+02 4.9717998504638672e+01 3.9694396972656250e+01 1.1761999511718750e+02 -4.7914501190185547e+01 -3.3897796630859375e+01 1.1737000274658203e+02 -5.0969100952148438e+01 -3.7727699279785156e+01 1.2159500122070312e+02 -7.1500301361083984e+00 6.7965698242187500e+01 1.3837001037597656e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.2261699676513672e+02 2.2238500595092773e+01 6.7120300292968750e+01 1.1761700439453125e+02 2.1297098159790039e+01 -2.4689701080322266e+01 1.1737000274658203e+02 1.7519599914550781e+01 -2.7862998962402344e+01 1.2137300109863281e+02 -1.0486300468444824e+01 6.8867401123046875e+01 1.2137000274658203e+02 -1.3528600692749023e+01 7.0840003967285156e+01 1.2137000274658203e+02 -2.0458999633789062e+01 6.9000000000000000e+01 1.2137000274658203e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.1949499511718750e+02 -3.0653699874877930e+01 1.3290699958801270e+01 1.2337000274658203e+02 3.0103000640869141e+01 -6.5454605102539062e+01 1.1761999511718750e+02 3.2632999420166016e+01 3.2000997391496073e-17 1.1762400054931641e+02 3.2563602447509766e+01 2.3690600395202637e+00 1.2137000274658203e+02 -3.1886999130249023e+01 6.4500503540039062e+01 1.2137000274658203e+02 -3.1886999130249023e+01 5.4171600341796875e+01 1.2175499725341797e+02 -3.0550998687744141e+01 5.8083000183105469e+01 1.2136799621582031e+02 -3.6309997558593750e+01 1.5016699790954590e+01 1.2137000274658203e+02 -3.8333301544189453e+01 1.3466799736022949e+01 1.1737000274658203e+02 1.9529700279235840e+00 3.2814399719238281e+01 1.1737000274658203e+02 -6.9231801033020020e+00 6.3126197814941406e+01 1.1737000274658203e+02 9.4580096006393433e-01 6.3574703216552734e+01 1.2137000274658203e+02 -2.0458999633789062e+01 -6.9000000000000000e+01 1.2151999664306641e+02 -2.3022500991821289e+01 -6.8188102722167969e+01 1.1886999511718750e+02 -2.1853899002075195e+01 -6.8590301513671875e+01 1.2137000274658203e+02 -2.8715400695800781e+01 5.1000000000000000e+01 1.2137000274658203e+02 -5.7734298706054688e+01 4.3032798767089844e+01 1.2137000274658203e+02 -6.2470500946044922e+01 3.5678302764892578e+01 1.4036999511718750e+02 2.6088699340820312e+01 6.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 6.0260799407958984e+01 1.4036999511718750e+02 2.8102998733520508e+01 6.4158203125000000e+01 1.1886999511718750e+02 -4.7454200744628906e+01 -5.4153099060058594e+01 1.1886999511718750e+02 -3.6804298400878906e+01 -5.3527900695800781e+01 1.2137200164794922e+02 1.2510599136352539e+01 -5.1171001434326172e+01 1.2137000274658203e+02 -1.2524300813674927e+00 -3.2546100616455078e+01 1.2137000274658203e+02 3.7243000030517578e+01 6.1743598937988281e+01 1.1886999511718750e+02 7.2108001708984375e+01 1.4210900454981155e-14 1.2223000335693359e+02 -1.5892399787902832e+01 -6.7301902770996094e+01 1.2235599517822266e+02 -7.8413996696472168e+00 -6.7212402343750000e+01 1.4036999511718750e+02 2.7274599075317383e+01 5.5000000000000000e+01 1.2275599670410156e+02 -2.6007499694824219e+01 -6.7096702575683594e+01 1.1886999511718750e+02 -2.7524900436401367e+01 -6.6491500854492188e+01 1.1761999511718750e+02 -4.2355197906494141e+01 1.1919799804687500e+01 1.2137000274658203e+02 -4.5679199218750000e+01 1.4119899749755859e+01 1.1761999511718750e+02 -4.9136199951171875e+01 1.6408100128173828e+01 1.1868199920654297e+02 -3.9552101135253906e+01 -5.0510700225830078e+01 1.2337000274658203e+02 -2.9887001037597656e+01 -5.5000000000000000e+01 1.2172499847412109e+02 -3.0462701797485352e+01 -5.4544502258300781e+01 1.1886999511718750e+02 3.2619800567626953e+01 6.4241500854492188e+01 1.1886999511718750e+02 2.5471799850463867e+01 5.9758201599121094e+01 1.1764600372314453e+02 -2.7308700561523438e+01 1.7566301345825195e+01 1.2137000274658203e+02 -8.3014602661132812e+00 -3.1481000900268555e+01 1.2137100219726562e+02 -4.5079498291015625e+00 -5.1209899902343750e+01 1.2231499481201172e+02 9.1094303131103516e+00 -6.7229896545410156e+01 1.2343199920654297e+02 7.8583498001098633e+00 -6.6999000549316406e+01 1.2137000274658203e+02 5.5055900573730469e+01 4.6770698547363281e+01 1.2137000274658203e+02 4.5815898895263672e+01 5.5719600677490234e+01 1.2137000274658203e+02 -5.2208801269531250e+01 -3.8751598358154297e+01 1.2192600250244141e+02 2.2115200042724609e+01 -6.7486900329589844e+01 1.1761999511718750e+02 -4.2457901000976562e+01 -2.7730199813842773e+01 1.1737000274658203e+02 -4.4869400024414062e+01 -3.0833200454711914e+01 1.1859400177001953e+02 -4.0541796684265137e+00 6.3980804443359375e+01 1.1853100585937500e+02 -1.0671599388122559e+01 6.3023200988769531e+01 1.1853200531005859e+02 5.4580902099609375e+01 -3.3514400482177734e+01 1.1838899993896484e+02 5.1760902404785156e+01 -3.7530197143554688e+01 1.2137000274658203e+02 -3.1886999130249023e+01 -6.4500503540039062e+01 1.1866900634765625e+02 6.2999599456787109e+01 -1.3057600021362305e+01 1.1851100158691406e+02 8.6447401046752930e+00 6.3330703735351562e+01 1.1886800384521484e+02 1.2249699592590332e+01 6.3842998504638672e+01 1.1819300079345703e+02 1.3418299674987793e+01 6.2310699462890625e+01 1.2337000274658203e+02 -2.9887001037597656e+01 -6.5454605102539062e+01 1.3837001037597656e+02 -2.9887001037597656e+01 -6.5454605102539062e+01 1.4036999511718750e+02 -2.7058599472045898e+01 5.5000000000000000e+01 1.2137000274658203e+02 -1.5906701087951660e+01 -2.8460100173950195e+01 1.2349300384521484e+02 -7.9625902175903320e+00 6.6999000549316406e+01 1.2202999877929688e+02 -2.1181900024414062e+01 6.7372596740722656e+01 1.2337000274658203e+02 -2.6254899978637695e+01 6.7000000000000000e+01 1.1737100219726562e+02 4.2544300079345703e+01 4.7411098480224609e+01 1.1737000274658203e+02 9.5523900985717773e+00 3.1442798614501953e+01 1.2391799926757812e+02 -7.3300099372863770e-01 -5.3001399993896484e+01 1.3837001037597656e+02 -2.7886999130249023e+01 -5.3000000000000000e+01 1.2337000274658203e+02 -2.7886999130249023e+01 -5.3000000000000000e+01 1.2137599945068359e+02 -6.8729901313781738e+00 -6.8855499267578125e+01 1.2152499389648438e+02 -1.0067399978637695e+01 -6.8156898498535156e+01 1.2261500549316406e+02 -9.1735095977783203e+00 6.7123397827148438e+01 1.1737000274658203e+02 -3.9200599670410156e+01 1.6385799407958984e+01 1.1737000274658203e+02 -3.1682600021362305e+01 1.7502000808715820e+01 1.1842100524902344e+02 4.1473698616027832e+00 6.3737400054931641e+01 1.1737000274658203e+02 1.2427000045776367e+01 6.2363098144531250e+01 1.2137000274658203e+02 1.8387599945068359e+01 5.0735599517822266e+01 1.2137000274658203e+02 4.8338100433349609e+01 9.3933696746826172e+00 1.1763200378417969e+02 -2.7521200180053711e+00 -3.2435398101806641e+01 1.1853299713134766e+02 5.8128799438476562e+01 2.6877998352050781e+01 1.2333699798583984e+02 -1.5853399276733398e+01 -5.3000000000000000e+01 1.3837001037597656e+02 4.4822196960449219e+00 -5.3000000000000000e+01 1.2137000274658203e+02 -6.5989196777343750e+01 2.8550998687744141e+01 1.2137000274658203e+02 -6.6029701232910156e+01 2.7869300842285156e+01 1.2137000274658203e+02 -6.5623100280761719e+01 2.7320598602294922e+01 1.1736799621582031e+02 2.9482500076293945e+01 -5.6398200988769531e+01 1.1737000274658203e+02 1.4023200035095215e+01 -6.2224800109863281e+01 1.2137000274658203e+02 -2.8715400695800781e+01 -5.1000000000000000e+01 1.2137000274658203e+02 -3.4914600372314453e+01 -4.4607898712158203e+01 1.1849100494384766e+02 9.1693201065063477e+00 -6.3284797668457031e+01 1.3837001037597656e+02 -2.7886999130249023e+01 5.3000000000000000e+01 1.2137000274658203e+02 3.1598602294921875e+01 1.5615800857543945e+01 1.2137000274658203e+02 2.7497900009155273e+01 1.7717100143432617e+01 1.2137000274658203e+02 3.0582300186157227e+01 1.1498799324035645e+01 1.4036999511718750e+02 2.6088699340820312e+01 -6.5000000000000000e+01 1.2137000274658203e+02 -2.7313800811767578e+01 1.7535301208496094e+01 1.2137000274658203e+02 -2.2064701080322266e+01 2.3874898910522461e+01 1.1886999511718750e+02 -6.6029701232910156e+01 2.7869300842285156e+01 1.2137000274658203e+02 -5.6352699279785156e+01 -4.4678798675537109e+01 1.1886999511718750e+02 -5.6568500518798828e+01 -4.4058200836181641e+01 1.3837001037597656e+02 -2.6259099960327148e+01 6.7000000000000000e+01 1.2137000274658203e+02 2.8931400299072266e+01 -5.1000000000000000e+01 1.2205799865722656e+02 2.8239000320434570e+01 -5.2669399261474609e+01 1.2137000274658203e+02 3.2102996826171875e+01 -5.4171600341796875e+01 1.2137000274658203e+02 -2.9351299285888672e+01 1.3784900665283203e+01 1.1886999511718750e+02 5.2377201080322266e+01 -4.9650901794433594e+01 1.1886999511718750e+02 4.0899501800537109e+01 -5.0718898773193359e+01 1.1886599731445312e+02 5.0433300018310547e+01 -4.0747898101806641e+01 1.1886899566650391e+02 -4.2332000732421875e+01 4.9297000885009766e+01 1.1856800079345703e+02 -3.9030300140380859e+01 5.0684898376464844e+01 1.1737000274658203e+02 -3.1198799133300781e+01 5.5306301116943359e+01 1.1737500000000000e+02 5.8853897094726562e+01 2.4166601181030273e+01 1.1855699920654297e+02 6.2409198760986328e+01 1.4375800132751465e+01 1.1737200164794922e+02 6.2433399200439453e+01 1.2367700576782227e+01 1.2158899688720703e+02 -2.1880099773406982e+00 -6.7966300964355469e+01 1.2157299804687500e+02 6.9003601074218750e+00 -6.8011596679687500e+01 1.2227600097656250e+02 2.1726500988006592e+00 -6.7260597229003906e+01 1.2137000274658203e+02 -5.9009201049804688e+01 2.2942901611328125e+01 1.1762200164794922e+02 2.4148600101470947e+00 -3.2453300476074219e+01 1.1886899566650391e+02 -5.1713798522949219e+01 3.9198997497558594e+01 1.1737100219726562e+02 -5.2649200439453125e+01 3.5542800903320312e+01 1.1766699981689453e+02 3.1545200347900391e+01 8.5568103790283203e+00 1.1763200378417969e+02 2.9337100982666016e+01 1.4323200225830078e+01 1.1886999511718750e+02 -2.7984600067138672e+01 6.6349800109863281e+01 1.1863899993896484e+02 -4.5179298400878906e+01 4.5482299804687500e+01 1.4036999511718750e+02 2.8102998733520508e+01 5.5828399658203125e+01 1.1886999511718750e+02 6.0302398681640625e+01 -3.9612503051757812e+01 1.1843399810791016e+02 4.6489299774169922e+01 -4.3946399688720703e+01 1.1737000274658203e+02 4.8203701019287109e+01 -4.1558502197265625e+01 1.1887100219726562e+02 -6.3287601470947266e+00 -6.4690406799316406e+01 1.1761999511718750e+02 -3.8333301544189453e+01 1.3466799736022949e+01 1.1737000274658203e+02 -3.8541801452636719e+01 1.3604800224304199e+01 1.2137000274658203e+02 7.2108001708984375e+01 2.4158499094435737e-13 1.2225499725341797e+02 -3.0191900253295898e+01 6.5315093994140625e+01 1.4036999511718750e+02 -2.7886999130249023e+01 6.4158203125000000e+01 1.4036999511718750e+02 -2.5872699737548828e+01 6.5000000000000000e+01 1.4036999511718750e+02 2.8102998733520508e+01 -6.4158203125000000e+01 1.1737000274658203e+02 -1.4913800239562988e+01 6.1755699157714844e+01 1.1847499847412109e+02 -1.4920899391174316e+01 6.2122699737548828e+01 1.2231499481201172e+02 -3.2408800125122070e+00 5.2767501831054688e+01 1.2137000274658203e+02 -3.4026500701904297e+01 1.4747900009155273e+01 1.1886999511718750e+02 -1.6125699996948242e+01 7.0211402893066406e+01 1.1886899566650391e+02 -1.9463998794555664e+01 6.1953800201416016e+01 1.1804299926757812e+02 2.3236801624298096e+00 -6.3704200744628906e+01 1.1845600128173828e+02 -7.4153099060058594e+00 -6.3474796295166016e+01 1.1737000274658203e+02 -4.8890900611877441e+00 -6.3496700286865234e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -5.5828399658203125e+01 1.4036999511718750e+02 -2.7058599472045898e+01 -5.5000000000000000e+01 1.2225499725341797e+02 3.0408100128173828e+01 6.5314598083496094e+01 1.1860800170898438e+02 4.2470802307128906e+01 -4.8004096984863281e+01 1.1737000274658203e+02 2.1118700027465820e+01 5.9949199676513672e+01 1.1886999511718750e+02 7.2016502380371094e+01 3.6040399074554443e+00 1.1886999511718750e+02 7.0811698913574219e+01 1.4034000396728516e+01 1.2337000274658203e+02 -2.9887001037597656e+01 6.5454605102539062e+01 1.1843500518798828e+02 -3.3093299865722656e+01 5.4558601379394531e+01 1.1866999816894531e+02 5.7572700500488281e+01 -2.8691400527954102e+01 1.1886999511718750e+02 -6.2338901519775391e+01 3.6005199432373047e+01 1.1763700103759766e+02 2.5347801208496094e+01 -2.0675899505615234e+01 1.1886999511718750e+02 6.9648902893066406e+01 -1.8769800186157227e+01 1.1818299865722656e+02 -5.5386199951171875e+01 3.1375698089599609e+01 1.2337000274658203e+02 3.0103000640869141e+01 5.5000000000000000e+01 1.1737000274658203e+02 2.7959701538085938e+01 -1.7380599975585938e+01 1.1820600128173828e+02 -2.8034801483154297e+01 5.7169399261474609e+01 1.1737299346923828e+02 -2.3443000793457031e+01 5.8980701446533203e+01 1.1847999572753906e+02 3.8226398468017578e+01 -5.1287799835205078e+01 1.1737100219726562e+02 3.9669597625732422e+01 -4.9769199371337891e+01 1.2136899566650391e+02 -1.8175001144409180e+01 -5.0726802825927734e+01 1.2147600555419922e+02 -1.1570799827575684e+01 -5.1704898834228516e+01 1.2157499694824219e+02 -2.8302400112152100e+00 5.1970298767089844e+01 1.2164700317382812e+02 3.4586400985717773e+00 5.2106998443603516e+01 1.1761999511718750e+02 -3.8026000976562500e+01 -2.3379400253295898e+01 1.1761999511718750e+02 -3.9227897644042969e+01 -2.4244998931884766e+01 1.1852099609375000e+02 6.0291500091552734e+01 2.1799200057983398e+01 1.1886599731445312e+02 -2.5886600494384766e+01 -5.9272800445556641e+01 1.2330500030517578e+02 -1.2942000389099121e+01 5.3000301361083984e+01 1.2137000274658203e+02 -2.7718999862670898e+01 -1.7391599655151367e+01 1.2238299560546875e+02 3.1219500303268433e-01 -5.2810901641845703e+01 1.1761999511718750e+02 -5.9100502014160156e+01 2.3003299713134766e+01 1.3837001037597656e+02 2.8102998733520508e+01 5.3000000000000000e+01 1.1863400268554688e+02 3.8843297958374023e-01 -6.4193702697753906e+01 1.1761100006103516e+02 -1.6871200561523438e+01 2.7775199890136719e+01 1.1758200073242188e+02 -2.2663301467895508e+01 2.3472900390625000e+01 1.1737000274658203e+02 -2.0256898880004883e+01 2.5712799072265625e+01 1.2222299957275391e+02 -1.0709900856018066e+01 -5.2719699859619141e+01 1.2224900054931641e+02 -5.4021396636962891e+00 -5.2746398925781250e+01 1.1737000274658203e+02 3.2081897735595703e+01 7.5248799324035645e+00 1.2155699920654297e+02 2.5004699707031250e+01 -5.1964900970458984e+01 1.2160799407958984e+02 1.9047800064086914e+01 -5.2066299438476562e+01 1.1886999511718750e+02 6.8511802673339844e+01 2.2576299667358398e+01 1.1849500274658203e+02 2.5292100906372070e+01 -5.8713500976562500e+01 1.1886800384521484e+02 2.6568399429321289e+01 -5.9357097625732422e+01 1.1737000274658203e+02 -3.9099102020263672e+01 1.2762700080871582e+01 1.3837001037597656e+02 2.6474998474121094e+01 6.7000000000000000e+01 1.3837001037597656e+02 3.0103000640869141e+01 6.5454605102539062e+01 1.1737000274658203e+02 -8.1189699172973633e+00 -3.1791400909423828e+01 1.2137000274658203e+02 2.0674999237060547e+01 6.9000000000000000e+01 1.2137000274658203e+02 3.6923099517822266e+01 -6.1917098999023438e+01 1.2137000274658203e+02 3.2102996826171875e+01 -6.4500503540039062e+01 1.1737000274658203e+02 6.3607997894287109e+01 -9.6633801221351900e-13 1.1868599700927734e+02 6.2898403406143188e-01 6.4218696594238281e+01 1.1763300323486328e+02 -2.8975999355316162e+00 3.2396598815917969e+01 1.1737000274658203e+02 -5.8872699737548828e+00 3.2315898895263672e+01 1.1737000274658203e+02 3.1001699447631836e+01 -1.1159599304199219e+01 1.2227600097656250e+02 -1.9566500186920166e+00 6.7260597229003906e+01 1.1843099975585938e+02 -5.9458599090576172e+01 2.3240299224853516e+01 1.2313199615478516e+02 1.8484100341796875e+01 -5.2999702453613281e+01 1.1819600677490234e+02 5.8913101196289062e+01 -2.4616500854492188e+01 1.1886800384521484e+02 3.2603401184082031e+01 -5.6195697784423828e+01 1.1850199890136719e+02 2.8431699752807617e+01 -5.7314102172851562e+01 1.1852500152587891e+02 5.3111602783203125e+01 3.5825801849365234e+01 1.1827999877929688e+02 5.5938899993896484e+01 3.0847801208496094e+01 1.1737000274658203e+02 5.5271598815917969e+01 3.1592802047729492e+01 1.3837001037597656e+02 3.0103000640869141e+01 -6.5454498291015625e+01 1.1737000274658203e+02 -4.9159603118896484e+01 1.6723400115966797e+01 1.1761999511718750e+02 -3.1649000167846680e+01 -1.9469699859619141e+01 1.1737000274658203e+02 -3.3802101135253906e+01 -2.1082998275756836e+01 1.1761999511718750e+02 -4.0975399017333984e+01 1.1504599571228027e+01 1.2137000274658203e+02 -1.4254399299621582e+01 2.9293998718261719e+01 1.2229100036621094e+02 -1.7794401168823242e+01 -5.2748100280761719e+01 1.2137000274658203e+02 2.3336099624633789e+01 -2.2923299789428711e+01 1.3837001037597656e+02 3.0103000640869141e+01 5.5000000000000000e+01 1.1886999511718750e+02 -1.4996999740600586e+01 -6.3287197113037109e+01 1.1737000274658203e+02 1.5259600639343262e+01 2.9098098754882812e+01 1.1737000274658203e+02 -3.3927398681640625e+01 1.4977399826049805e+01 1.1737000274658203e+02 -3.0554599761962891e+01 1.3520199775695801e+01 1.2167900085449219e+02 -1.5458099365234375e+01 6.7850097656250000e+01 1.1762999725341797e+02 -9.6849603652954102e+00 3.1160600662231445e+01 1.2337000274658203e+02 2.8102998733520508e+01 5.3000000000000000e+01 1.2225099945068359e+02 2.8251899719238281e+01 5.2701000213623047e+01 1.1737000274658203e+02 -1.3914899826049805e+01 2.9743301391601562e+01 1.1886999511718750e+02 6.5108001708984375e+01 -8.6686202920710498e-13 1.2137000274658203e+02 4.6335998535156250e+01 -5.5385898590087891e+01 1.2137000274658203e+02 1.0696800231933594e+01 7.1361495971679688e+01 1.1866100311279297e+02 -2.4940299987792969e+01 5.9089702606201172e+01 1.1737000274658203e+02 6.3341899871826172e+01 -6.4508299827575684e+00 1.1813200378417969e+02 6.3290798187255859e+01 -8.3502302169799805e+00 1.1761999511718750e+02 -4.0288799285888672e+01 -2.5278499603271484e+01 1.1846300506591797e+02 -2.7731100082397461e+01 -5.7558399200439453e+01 1.1738699340820312e+02 -2.6513099670410156e+01 -5.7629199981689453e+01 1.1819400024414062e+02 -1.9792400360107422e+01 -6.0569099426269531e+01 1.1848200225830078e+02 6.3147598266601562e+01 1.0512200355529785e+01 1.1763399505615234e+02 8.4969196319580078e+00 -3.1469099044799805e+01 1.1737000274658203e+02 1.0995600700378418e+01 -3.0952800750732422e+01 1.1737000274658203e+02 5.7727699279785156e+00 -3.2296501159667969e+01 1.2228500366210938e+02 3.0357099533081055e+01 -5.4833999633789062e+01 1.1737000274658203e+02 -4.5341701507568359e+01 1.4196399688720703e+01 1.1737000274658203e+02 -4.2217197418212891e+01 1.2128299713134766e+01 1.4036999511718750e+02 -2.7886999130249023e+01 5.5828399658203125e+01 1.2137000274658203e+02 -5.1566600799560547e+01 5.0175998687744141e+01 1.2136899566650391e+02 3.2042800903320312e+01 -5.7899398803710938e+01 1.2163600158691406e+02 3.1005899429321289e+01 -6.1990901947021484e+01 1.1760900115966797e+02 2.9176599502563477e+01 -1.4637299537658691e+01 1.2337000274658203e+02 3.0103000640869141e+01 6.5454605102539062e+01 1.1850099945068359e+02 -1.9194801330566406e+01 6.0964199066162109e+01 1.1737000274658203e+02 -1.8898500442504883e+01 -6.0616298675537109e+01 1.1737000274658203e+02 3.2882999420166016e+01 2.8421701298887714e-13 1.2156199645996094e+02 -1.9396598815917969e+01 5.1963401794433594e+01 1.2250699615478516e+02 -2.2260900497436523e+01 5.2837402343750000e+01 1.1761999511718750e+02 1.8994298934936523e+01 -2.6486999511718750e+01 1.1886999511718750e+02 4.1817401885986328e+01 -5.8911598205566406e+01 1.2137000274658203e+02 4.8735098838806152e+00 3.2218399047851562e+01 1.2230200195312500e+02 -1.2254400253295898e+01 5.2756298065185547e+01 1.1871799468994141e+02 -3.1468997955322266e+01 -5.5970298767089844e+01 1.1822900390625000e+02 3.2869300842285156e+01 -5.4708499908447266e+01 1.2137000274658203e+02 2.2720699310302734e+01 2.3456800460815430e+01 1.1886999511718750e+02 1.1232599258422852e+01 7.1156005859375000e+01 1.1737000274658203e+02 -4.0975399017333984e+01 1.1754600524902344e+01 1.3837001037597656e+02 -2.9887001037597656e+01 -5.5000000000000000e+01 1.1855300140380859e+02 6.3947097778320312e+01 -3.5793299674987793e+00 1.1886999511718750e+02 -6.5989196777343750e+01 2.8550998687744141e+01 1.1737000274658203e+02 -4.3372997641563416e-01 -3.2841197967529297e+01 1.1886999511718750e+02 -5.5902801513671875e+01 4.5347499847412109e+01 1.1818599700927734e+02 6.1611400604248047e+01 -1.6768699645996094e+01 1.4036999511718750e+02 -2.7886999130249023e+01 -6.0179199218750000e+01 1.2147399902343750e+02 -1.0176099777221680e+01 5.1711101531982422e+01 1.2246699523925781e+02 1.7770599365234375e+01 -5.2830497741699219e+01 1.1737000274658203e+02 -1.9266300201416016e+01 -2.6453399658203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2988 -> 23 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.2137000262737274e+02 -6.6029697656631470e+01 2.7869300916790962e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01) (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 -4.7454200685024261e+01 -5.4153099656105042e+01) (float-vector 1.1886999756097794e+02 -2.7524899691343307e+01 -6.6491499543190002e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01) (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.2137000262737274e+02 -5.6568499654531479e+01 -4.4058199971914291e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 2.1601699292659760e+01 -6.8827800452709198e+01) (float-vector 1.1886999756097794e+02 -3.8841801142552868e-02 -7.2086602449417114e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4036999642848969e+02 -2.7886999770998955e+01 -6.4158201217651367e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.3837000727653503e+02 -2.6258999481797218e+01 -6.7000001668930054e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.4036999642848969e+02 -2.5872699916362762e+01 6.4999997615814209e+01) (float-vector 1.3837000727653503e+02 -2.9887000098824501e+01 6.5454602241516113e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.2137000262737274e+02 6.1707299202680588e+01 -3.7386100739240646e+01) (float-vector 1.3837000727653503e+02 3.0102999880909920e+01 -6.5454497933387756e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01) (float-vector 1.3837000727653503e+02 2.6474999263882637e+01 6.7000001668930054e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 3.8424700498580933e+01 6.1056699603796005e+01) (float-vector 1.2137000262737274e+02 2.0674999803304672e+01 6.8999998271465302e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.2137000262737274e+02 6.9949202239513397e+01 1.8015500158071518e+01) (float-vector 1.4036999642848969e+02 2.8102999553084373e+01 6.4158201217651367e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1886999756097794e+02 7.2108000516891479e+01 1.4210900057934461e-14) (float-vector 1.1886999756097794e+02 6.8511798977851868e+01 2.2576300427317619e+01) (float-vector 1.1886999756097794e+02 5.6136500090360641e+01 4.5345399528741837e+01) (float-vector 1.1886999756097794e+02 1.7722400370985270e+00 7.2045803070068359e+01) (float-vector 1.2137000262737274e+02 -2.0459000021219254e+01 6.8999998271465302e+01) (float-vector 1.2137000262737274e+02 -4.2364701628684998e+01 5.8364499360322952e+01) (float-vector 1.1737000197172165e+02 -5.8990299701690674e+01 2.3230200633406639e+01) (float-vector 1.1886999756097794e+02 4.1817400604486465e+01 -5.8911599218845367e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_upper_arm_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_wrist_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 3.2100000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.350000 0.350000 0.350000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.700000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 0 50 229 393 50 0 0 2 324 98 0 229 1 0 98 324 393 0 393 51 50 51 393 324 50 51 52 50 52 291 50 291 229 2 308 51 324 2 51 51 431 52 431 51 308 308 430 431 128 209 308 128 308 2 308 440 430 308 209 440 431 430 52 430 39 38 52 430 38 440 39 430 38 39 40 40 39 412 39 440 412 38 40 52 40 327 52 356 327 40 356 40 191 412 191 40 412 440 191 440 209 439 439 387 440 191 440 387 432 387 439 298 439 209 432 439 298 297 303 387 389 191 387 432 297 387 303 389 387 297 432 298 296 297 298 296 303 297 296 302 303 303 302 389 302 489 389 389 489 191 489 302 499 499 191 489 191 499 500 499 302 500 500 302 492 492 191 500 492 302 487 191 492 487 487 302 192 487 192 191 32 191 192 192 346 347 346 192 302 32 192 347 347 346 423 32 347 423 32 423 201 63 423 346 201 423 63 32 201 202 201 63 202 62 63 64 63 262 64 202 63 339 339 63 62 63 346 262 202 339 247 247 32 202 62 338 339 338 247 339 140 62 64 62 140 338 140 64 73 73 64 71 71 64 262 140 141 142 140 73 141 142 338 140 338 142 245 338 245 247 245 246 247 311 246 245 142 311 245 33 246 269 311 267 246 246 267 269 33 247 246 142 310 311 310 267 311 267 268 269 284 268 267 284 267 22 310 22 267 22 310 142 21 22 23 284 22 21 23 22 99 142 99 22 341 284 21 284 341 268 341 368 268 341 438 174 110 368 341 174 110 341 341 21 438 400 332 368 268 368 436 400 368 110 368 332 436 108 109 110 109 400 110 108 110 174 173 108 174 173 174 438 173 183 108 108 305 109 108 498 305 108 183 498 422 109 304 109 422 400 305 304 109 304 305 241 241 305 9 9 305 498 484 498 183 484 9 498 9 10 11 240 241 9 11 265 9 265 240 9 484 10 9 10 253 11 256 253 10 10 484 256 253 265 11 122 253 256 299 265 253 299 253 122 129 122 256 496 129 256 484 496 256 121 122 123 309 299 122 123 122 129 121 309 122 469 299 309 299 469 265 318 309 121 468 309 318 468 469 309 130 217 121 123 130 121 121 217 318 129 130 123 411 130 129 420 203 130 419 420 130 411 419 130 130 203 217 318 217 205 217 203 205 203 204 205 334 485 203 204 203 485 203 420 334 293 318 205 205 204 293 204 433 293 433 204 485 334 314 485 314 433 485 132 131 433 433 294 293 433 261 294 314 132 433 131 261 433 131 132 133 132 189 133 189 132 314 131 190 261 131 133 190 261 328 294 261 416 328 261 190 416 125 293 294 328 125 294 124 125 126 126 125 328 408 125 124 206 293 125 408 206 125 293 206 318 206 468 318 468 206 469 469 229 265 98 469 206 98 229 469 265 229 266 229 291 292 266 229 292 265 266 240 240 266 279 266 292 279 292 291 279 291 52 279 240 279 241 279 52 327 357 241 279 357 279 327 304 241 357 356 304 357 356 357 327 422 304 356 422 356 332 356 191 332 400 422 332 331 332 333 436 332 331 333 332 191 34 191 32 333 191 34 331 333 34 32 33 34 331 34 33 409 331 33 436 331 269 269 331 409 269 268 436 409 33 269 32 247 33 97 1 98 319 24 98 350 319 98 98 208 348 350 98 348 206 208 98 24 97 98 128 2 1 1 97 128 97 127 128 209 128 127 19 127 20 127 19 298 298 209 127 127 97 20 18 19 20 298 19 434 19 18 474 434 19 474 24 20 97 18 20 24 18 24 25 18 25 212 474 18 212 434 474 475 475 474 212 210 211 212 212 211 475 210 212 25 319 263 25 263 210 25 319 25 24 263 236 210 210 236 460 210 460 211 211 460 470 475 211 470 235 231 460 460 236 235 460 231 470 235 236 237 263 264 236 236 264 237 264 263 336 319 336 263 336 337 264 337 391 264 264 391 237 237 448 235 390 448 237 237 391 390 235 448 231 448 322 231 448 390 322 390 391 392 390 83 322 83 390 437 392 497 390 390 497 437 322 180 231 83 181 322 180 322 181 82 83 84 181 83 82 83 437 84 179 180 181 82 179 181 231 180 232 180 373 232 179 373 180 470 231 232 470 232 475 102 232 163 475 232 102 232 373 163 163 373 316 316 373 179 316 179 82 316 82 317 316 197 163 316 317 197 103 163 164 164 163 197 102 163 103 164 197 72 317 78 197 197 78 72 262 164 71 262 103 164 71 164 72 102 103 104 346 103 262 346 104 103 302 296 104 434 104 296 102 104 434 302 104 346 434 296 298 434 475 102 71 72 73 77 72 78 73 72 77 141 73 77 77 78 463 141 77 463 463 78 429 429 78 317 141 463 377 463 429 377 142 141 358 377 358 141 377 85 358 429 85 377 317 86 429 429 86 85 317 82 426 317 426 86 85 86 87 87 86 426 85 115 358 67 85 87 67 115 85 87 426 84 84 53 87 53 323 87 87 323 67 84 426 82 84 437 53 53 54 55 53 55 323 437 54 53 323 55 483 323 65 67 323 483 65 74 483 75 75 483 55 483 74 65 65 66 67 74 66 65 74 75 76 76 66 74 75 55 175 351 75 447 75 175 447 75 351 76 76 351 353 66 76 353 67 66 115 358 66 353 115 66 358 351 352 353 353 272 358 352 270 353 353 270 272 142 358 272 99 142 272 23 99 69 99 146 69 99 274 105 105 107 99 345 99 272 99 154 90 379 466 99 90 146 99 239 379 99 154 99 466 107 239 99 274 99 345 154 88 90 466 275 154 275 88 154 466 467 276 379 467 466 276 275 466 151 275 276 425 88 275 151 425 275 88 89 90 425 89 88 222 425 453 454 425 151 453 425 454 89 425 222 221 89 222 221 90 89 221 222 223 80 223 222 80 222 453 476 453 454 80 453 476 454 150 476 150 454 151 81 80 476 476 150 81 79 80 81 80 79 223 100 101 81 81 150 187 81 187 100 79 81 101 150 151 152 187 150 152 187 188 100 187 152 371 187 371 188 152 151 493 152 493 371 493 151 276 371 493 372 372 493 276 188 371 372 450 188 372 450 375 188 375 100 188 406 372 467 372 276 467 450 372 406 450 406 252 354 375 450 354 450 252 248 406 379 252 406 248 379 406 467 238 91 252 91 354 252 238 252 248 374 375 354 374 354 91 91 92 93 378 374 91 378 91 93 91 238 92 107 238 239 238 248 239 92 238 107 239 248 379 105 106 107 106 92 107 106 93 92 93 106 290 289 378 93 289 93 290 289 374 378 375 374 289 288 289 290 289 288 375 177 176 290 176 288 290 106 177 290 176 177 178 456 177 106 456 490 177 178 177 490 277 176 278 176 178 278 176 277 288 278 178 8 8 178 12 178 490 12 490 13 12 404 13 490 404 490 456 274 404 456 456 106 274 345 403 404 404 254 13 345 404 274 404 403 254 12 13 14 13 254 14 139 44 254 254 403 139 44 14 254 344 403 345 403 457 139 457 403 344 272 344 345 272 376 344 376 457 344 369 457 376 139 457 137 137 457 369 376 272 271 113 369 376 376 271 113 270 271 272 270 113 271 111 112 113 111 113 477 369 113 112 270 477 113 270 352 477 446 111 477 352 446 477 116 111 386 116 112 111 111 446 386 112 116 117 117 369 112 320 116 386 117 116 320 320 321 117 321 138 117 369 117 138 137 369 138 137 138 139 139 167 44 329 139 138 139 329 167 44 45 46 45 44 167 424 14 44 44 46 424 166 95 45 167 166 45 46 45 95 46 95 94 424 46 94 193 424 295 193 14 424 295 424 94 193 12 14 8 12 193 8 193 295 381 295 94 295 6 8 295 381 6 94 95 96 96 381 94 380 234 381 381 234 405 381 405 6 96 380 381 6 7 8 6 405 7 8 7 278 278 7 158 405 158 7 234 233 405 405 233 158 58 233 234 58 234 227 227 234 380 96 227 380 227 96 228 49 227 228 58 227 48 48 227 49 200 255 228 228 255 49 481 228 96 200 228 481 47 48 49 49 255 47 48 47 162 162 58 48 367 59 47 255 367 47 59 162 47 255 200 199 367 255 199 367 60 59 367 199 60 198 199 200 168 199 213 213 199 198 199 168 60 59 60 61 60 169 61 60 168 169 168 28 169 26 28 168 26 168 213 26 27 28 169 28 27 218 300 169 472 61 169 169 300 472 27 218 169 218 27 482 27 26 482 482 26 326 26 213 326 479 219 482 218 482 219 326 479 482 213 325 326 325 479 326 479 243 219 175 479 325 175 55 479 55 243 479 218 219 220 220 219 243 444 220 462 444 218 220 462 220 471 220 243 471 300 444 445 300 218 444 444 462 459 445 444 459 462 242 459 462 471 242 471 243 242 242 243 244 242 391 459 242 244 391 458 445 459 459 391 337 459 337 336 459 336 458 392 391 244 243 340 244 54 244 340 54 392 244 497 392 54 437 497 54 54 340 55 340 243 55 370 445 458 336 370 458 370 336 319 370 319 455 455 445 370 300 445 455 455 319 350 61 472 455 472 300 455 350 61 455 59 61 350 59 225 413 59 350 225 162 59 413 56 162 413 225 56 413 3 5 225 465 3 225 5 56 225 465 225 350 56 57 58 56 5 57 56 58 162 3 4 5 4 488 5 57 5 488 465 4 3 465 382 4 382 465 350 382 43 4 359 488 4 4 43 359 57 488 159 361 159 488 488 359 361 359 360 361 359 43 42 42 360 359 160 159 361 360 288 361 160 361 288 158 159 160 233 57 159 158 233 159 277 158 160 277 160 288 288 100 375 288 442 100 442 288 360 101 100 155 100 136 155 100 442 136 360 42 442 442 41 136 41 442 42 134 135 136 136 135 155 136 41 134 41 42 43 41 43 134 153 147 134 280 135 134 147 280 134 134 43 153 135 301 286 286 155 135 280 301 135 149 301 280 147 149 280 147 148 149 396 147 153 396 148 147 149 461 301 148 461 149 301 287 286 301 461 287 148 452 461 461 452 287 478 148 208 148 396 208 478 452 148 208 396 348 348 396 153 206 207 208 207 452 208 452 478 208 287 452 449 449 452 207 415 449 207 415 207 206 414 415 206 206 408 414 285 449 415 415 282 285 282 415 414 285 287 449 285 286 287 285 282 365 286 285 473 285 494 473 285 365 494 155 286 473 473 435 155 473 494 435 155 156 157 435 156 155 155 157 101 435 494 156 383 118 156 156 118 157 156 494 383 120 101 157 118 120 157 120 143 101 101 143 79 118 119 120 119 143 120 383 119 118 119 383 384 383 494 281 384 383 281 144 119 384 144 143 119 364 384 281 464 144 384 464 384 364 281 282 283 281 283 364 282 281 494 365 282 494 283 282 414 283 414 407 364 283 407 414 408 407 407 408 124 364 407 362 407 366 362 407 124 366 366 124 126 366 363 362 363 366 395 126 395 366 362 363 364 363 395 37 36 363 37 36 464 363 363 464 364 395 126 328 328 37 395 35 36 37 328 35 37 36 417 418 36 35 417 36 418 464 144 464 441 418 441 464 260 441 418 260 418 394 418 417 394 417 35 394 17 260 394 15 17 394 35 451 394 394 451 15 15 16 17 17 259 260 17 388 259 17 16 388 185 16 15 15 451 185 451 401 185 401 451 416 416 451 35 185 186 16 185 401 257 186 185 257 257 258 186 258 161 186 186 161 16 401 402 257 258 257 402 402 250 249 402 249 258 421 402 401 402 421 315 402 315 250 249 250 251 250 315 251 258 249 251 196 195 258 195 68 258 68 161 258 196 258 251 194 195 196 196 251 194 230 195 194 230 273 195 114 68 195 273 114 195 68 69 70 114 69 68 68 70 161 443 69 114 216 114 273 443 114 216 216 273 397 397 273 230 214 215 216 397 214 216 215 443 216 171 443 215 69 443 23 23 443 171 69 146 70 161 70 146 90 29 146 146 388 161 146 29 388 29 90 30 30 90 221 29 30 31 388 29 31 161 388 16 259 388 31 31 307 259 355 307 31 31 30 355 30 221 355 223 342 221 355 221 342 355 306 307 355 342 343 355 343 306 306 260 307 307 260 259 343 145 306 306 441 260 306 145 441 342 223 343 223 143 343 343 143 145 223 79 143 143 144 145 144 441 145 170 171 172 170 23 171 172 171 215 224 21 170 170 21 23 170 172 224 172 226 182 172 182 224 215 226 172 215 214 226 427 428 226 214 427 226 226 428 182 182 183 173 224 182 173 428 183 182 427 496 428 428 496 484 428 484 183 410 427 486 214 486 427 427 410 496 496 410 129 410 411 129 411 410 486 480 411 486 214 480 486 480 419 411 397 480 214 313 419 480 397 313 480 419 313 420 230 312 313 397 230 313 335 495 313 312 335 313 420 313 495 495 334 420 334 495 335 251 334 335 251 335 312 194 312 230 194 251 312 314 251 315 334 251 314 314 421 189 314 315 421 189 421 190 421 401 190 189 190 133 190 401 416 328 416 35 173 438 224 438 21 224 43 349 153 153 349 348 382 349 43 348 349 350 350 349 382 278 158 277 58 57 233 175 325 385 175 385 447 385 325 386 386 325 213 386 447 385 386 446 447 447 446 351 213 321 386 320 386 321 398 213 198 213 398 321 321 398 138 398 198 399 398 399 165 398 165 138 200 399 198 399 200 491 399 491 184 399 184 165 165 166 167 165 184 166 167 330 165 138 165 330 330 329 138 167 329 330 166 481 95 166 184 481 491 481 184 491 200 481 95 481 96 351 446 352 274 106 105))
                   (list :vertices (let ((mat (make-matrix 501 3))) (fvector-replace (array-entity mat) #f(-3.5301699829101562e+02 2.1641901016235352e+01 4.1873102188110352e+00 -3.5611999511718750e+02 2.1715000152587891e+01 0.0000000000000000e+00 -3.5607598876953125e+02 2.1692899703979492e+01 1.2645499706268311e+00 -2.9478799438476562e+02 2.1286500930786133e+01 -2.0755001068115234e+01 -2.9394799804687500e+02 2.0900800704956055e+01 -2.0644199371337891e+01 -2.9454498291015625e+02 2.1118700027465820e+01 -2.5026998519897461e+01 -2.9516101074218750e+02 2.3047499656677246e+00 -3.5144500732421875e+01 -2.9418600463867188e+02 3.6295700073242188e+00 -3.2654502868652344e+01 -2.9509899902343750e+02 -1.8817499160766602e+01 -3.5094299316406250e+01 -3.5238900756835938e+02 1.9902599334716797e+01 2.0142499923706055e+01 -3.4893899536132812e+02 1.9776300430297852e+01 2.4683900833129883e+01 -3.5029000854492188e+02 2.0569499969482422e+01 2.2376399993896484e+01 -2.9583499145507812e+02 -1.9436700820922852e+01 -3.6196300506591797e+01 -2.9672302246093750e+02 -2.0360700607299805e+01 -3.6702301025390625e+01 -2.9791702270507812e+02 -1.9608400344848633e+01 -3.8560199737548828e+01 -3.0912701416015625e+02 -1.9747900009155273e+01 3.5340301513671875e+01 -3.1271801757812500e+02 -2.0705598831176758e+01 3.5513000488281250e+01 -3.0717001342773438e+02 -2.0295598983764648e+01 3.4268901824951172e+01 -3.5556301879882812e+02 2.1432699203491211e+01 -9.7471504211425781e+00 -3.5711898803710938e+02 2.1207601547241211e+01 -5.1841897964477539e+00 -3.5629998779296875e+02 2.1574800491333008e+01 -4.9674201011657715e+00 -3.5129202270507812e+02 -2.1317298889160156e+01 1.8885200500488281e+01 -3.5171697998046875e+02 -2.1437799453735352e+01 1.6795900344848633e+01 -3.4419198608398438e+02 -2.1295299530029297e+01 2.6035999298095703e+01 -3.5373199462890625e+02 2.1518899917602539e+01 -1.2404700279235840e+01 -3.5354299926757812e+02 2.1373300552368164e+01 -1.4902899742126465e+01 -3.1502398681640625e+02 1.8796300888061523e+01 -3.9231098175048828e+01 -3.2345501708984375e+02 1.9679599761962891e+01 -3.7457202911376953e+01 -3.1820999145507812e+02 1.9652000427246094e+01 -3.8476398468017578e+01 -3.0773400878906250e+02 -2.1182800292968750e+01 3.2080097198486328e+01 -2.9687802124023438e+02 -2.1269298553466797e+01 2.5533899307250977e+01 -3.0021701049804688e+02 -2.1105300903320312e+01 2.9298198699951172e+01 -3.5834698486328125e+02 -1.9420801162719727e+01 1.3042000532150269e+00 -3.5800997924804688e+02 -2.0234498977661133e+01 3.9089400768280029e+00 -3.5817797851562500e+02 -1.9378999710083008e+01 3.7875001430511475e+00 -3.0845401000976562e+02 1.8866498947143555e+01 3.5229701995849609e+01 -3.0312500000000000e+02 1.8695199966430664e+01 3.2908203125000000e+01 -3.0759899902343750e+02 1.9508300781250000e+01 3.4821399688720703e+01 -3.5812500000000000e+02 1.9712200164794922e+01 4.0400400161743164e+00 -3.5817797851562500e+02 1.9378999710083008e+01 3.7875001430511475e+00 -3.5815100097656250e+02 1.9377000808715820e+01 4.0399999618530273e+00 -2.9287600708007812e+02 1.9959699630737305e+01 -4.9184298515319824e+00 -2.9301199340820312e+02 1.9805700302124023e+01 -1.2913000106811523e+01 -2.9339099121093750e+02 2.0763799667358398e+01 -8.6935701370239258e+00 -3.0073800659179688e+02 -1.8931900024414062e+01 -4.0221900939941406e+01 -3.0134399414062500e+02 -6.9823198318481445e+00 -4.0403602600097656e+01 -2.9997900390625000e+02 -3.1850500106811523e+00 -3.9919296264648438e+01 -3.0488101196289062e+02 2.1041101455688477e+01 -3.8609600067138672e+01 -2.9809500122070312e+02 2.0997800827026367e+01 -3.6835201263427734e+01 -3.0123001098632812e+02 2.0798700332641602e+01 -3.9214000701904297e+01 -3.5586898803710938e+02 2.1644498825073242e+01 4.0399899482727051e+00 -3.5649200439453125e+02 2.1582498550415039e+01 3.7915399074554443e+00 -3.5765902709960938e+02 2.0909799575805664e+01 3.8497300148010254e+00 -3.4104998779296875e+02 -1.8928001403808594e+01 -3.1607698440551758e+01 -3.3941000366210938e+02 -1.8548299789428711e+01 -3.2494998931884766e+01 -3.3415600585937500e+02 -1.8840799331665039e+01 -3.4997600555419922e+01 -2.9507601928710938e+02 2.1140100479125977e+01 -2.8969400405883789e+01 -2.9423498535156250e+02 2.0540399551391602e+01 -3.0364099502563477e+01 -2.9576199340820312e+02 2.0860399246215820e+01 -3.3895999908447266e+01 -3.0844598388671875e+02 2.1047599792480469e+01 -3.8234199523925781e+01 -3.1204501342773438e+02 2.0852899551391602e+01 -3.8557201385498047e+01 -3.2042599487304688e+02 2.1049798965454102e+01 -3.6366600036621094e+01 -3.5695700073242188e+02 -2.1528100967407227e+01 -1.3672299385070801e+00 -3.5808300781250000e+02 -2.0571901321411133e+01 -1.6275700330734253e+00 -3.5690100097656250e+02 -2.1453899383544922e+01 -4.2780499458312988e+00 -3.3824398803710938e+02 -2.0333400726318359e+01 -3.2655998229980469e+01 -3.3714602661132812e+02 -2.0995498657226562e+01 -3.2264698028564453e+01 -3.4192300415039062e+02 -2.0409999847412109e+01 -3.0380500793457031e+01 -3.2463101196289062e+02 -2.0982398986816406e+01 3.5771102905273438e+01 -3.3658001708984375e+02 -2.1173799514770508e+01 3.1602100372314453e+01 -3.2473800659179688e+02 -2.1105199813842773e+01 3.4942001342773438e+01 -3.5711801147460938e+02 -2.0758501052856445e+01 -7.5738797187805176e+00 -3.5564498901367188e+02 -2.0659599304199219e+01 -1.2771900177001953e+01 -3.5564602661132812e+02 -2.1346900939941406e+01 -1.0336899757385254e+01 -3.3404098510742188e+02 -2.0342800140380859e+01 -3.4504699707031250e+01 -3.3085400390625000e+02 -1.9838399887084961e+01 -3.5884998321533203e+01 -3.3025299072265625e+02 -2.0969900131225586e+01 -3.4810901641845703e+01 -3.5392800903320312e+02 -2.1372699737548828e+01 -1.4258600234985352e+01 -3.5379998779296875e+02 -2.0633001327514648e+01 -1.6859498977661133e+01 -2.9310598754882812e+02 -1.9056501388549805e+01 2.2132900238037109e+01 -2.9319799804687500e+02 -1.9659500122070312e+01 2.2141799926757812e+01 -2.9298202514648438e+02 -1.9177999496459961e+01 1.5009799957275391e+01 -3.5025701904296875e+02 -1.9035499572753906e+01 -2.3315399169921875e+01 -3.4762298583984375e+02 -1.8535400390625000e+01 -2.6109399795532227e+01 -3.4638699340820312e+02 -1.9011798858642578e+01 -2.7484899520874023e+01 -3.4489102172851562e+02 -2.0840400695800781e+01 -2.7574998855590820e+01 -3.4848498535156250e+02 -2.0445098876953125e+01 -2.4654699325561523e+01 -3.4584997558593750e+02 -1.9826700210571289e+01 -2.7800500869750977e+01 -2.9469100952148438e+02 -2.1390199661254883e+01 1.5064200401306152e+01 -2.9455502319335938e+02 -2.1195899963378906e+01 2.2164899826049805e+01 -2.9537799072265625e+02 -2.1328701019287109e+01 2.2132900238037109e+01 -2.9358099365234375e+02 -2.0782501220703125e+01 -1.3934000015258789e+01 -2.9447000122070312e+02 -2.1253999710083008e+01 -1.8271800994873047e+01 -2.9381399536132812e+02 -2.0783700942993164e+01 -2.0777799606323242e+01 -2.9868701171875000e+02 5.3715000152587891e+00 -3.9247501373291016e+01 -3.0086700439453125e+02 1.4495900154113770e+01 -4.0261699676513672e+01 -2.9887500000000000e+02 1.9101100921630859e+01 -3.9388500213623047e+01 -3.5607598876953125e+02 2.1692899703979492e+01 -1.2645399570465088e+00 -3.3094097900390625e+02 2.1715000152587891e+01 0.0000000000000000e+00 -3.2660299682617188e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9272000122070312e+02 -1.2480899810791016e+01 0.0000000000000000e+00 -2.9310101318359375e+02 -9.5282592773437500e+00 2.2133199691772461e+01 -3.5680200195312500e+02 1.9170299530029297e+01 -1.0743799209594727e+01 -3.5700000000000000e+02 -1.9283300399780273e+01 -1.0072000503540039e+01 -3.5783700561523438e+02 1.9338800430297852e+01 -6.2930798530578613e+00 -2.9542700195312500e+02 -2.1280000686645508e+01 -2.4923398971557617e+01 -2.9457199096679688e+02 -2.1129699707031250e+01 -2.5248401641845703e+01 -2.9529101562500000e+02 -2.1393400192260742e+01 -1.8437801361083984e+01 -3.5415100097656250e+02 -1.9159400939941406e+01 1.7321100234985352e+01 -3.5592898559570312e+02 -1.9224500656127930e+01 1.3314700126647949e+01 -3.5515298461914062e+02 -2.0062999725341797e+01 1.4870900154113770e+01 -3.1422900390625000e+02 -1.9933101654052734e+01 -3.9087100982666016e+01 -3.1189199829101562e+02 -1.9628000259399414e+01 -3.9706497192382812e+01 -3.1217102050781250e+02 -2.0584499359130859e+01 -3.8925098419189453e+01 -3.3257699584960938e+02 -2.1000101089477539e+01 3.4073299407958984e+01 -3.4172299194335938e+02 -2.1072500228881836e+01 -2.9408599853515625e+01 -3.1605801391601562e+02 -1.9327600479125977e+01 -3.8978302001953125e+01 -3.0888000488281250e+02 -1.8775501251220703e+01 -4.0425300598144531e+01 -2.9338500976562500e+02 1.6920000076293945e+01 2.3979600906372070e+01 -2.9422598266601562e+02 7.1667399406433105e+00 2.5911100387573242e+01 -2.9338500976562500e+02 -7.1761697530746460e-01 2.3979600906372070e+01 -3.3547100830078125e+02 2.0776899337768555e+01 3.3450698852539062e+01 -3.4247100830078125e+02 2.0694698333740234e+01 2.9690299987792969e+01 -3.3793301391601562e+02 2.0354600906372070e+01 3.2776298522949219e+01 -3.0514599609375000e+02 2.1098001480102539e+01 3.2023899078369141e+01 -3.1241101074218750e+02 2.0910799026489258e+01 3.5174900054931641e+01 -3.0844598388671875e+02 2.0781000137329102e+01 3.4161300659179688e+01 -3.5721002197265625e+02 2.1388801574707031e+01 -1.2988300323486328e+00 -3.5697497558593750e+02 2.1567300796508789e+01 3.3120602369308472e-01 -3.4166799926757812e+02 1.9748600006103516e+01 3.1055801391601562e+01 -3.3513500976562500e+02 1.9611999511718750e+01 3.4518199920654297e+01 -3.2092401123046875e+02 1.8829700469970703e+01 3.7369899749755859e+01 -3.2101800537109375e+02 1.8829700469970703e+01 3.7369998931884766e+01 -3.2044400024414062e+02 1.7454999923706055e+01 3.7367298126220703e+01 -2.9289401245117188e+02 2.0353000640869141e+01 -7.1080195903778076e-01 -2.9283401489257812e+02 1.9329799652099609e+01 6.4341502189636230e+00 -2.9272000122070312e+02 1.9442800521850586e+01 0.0000000000000000e+00 -3.0660900878906250e+02 -1.9584199905395508e+01 -4.0665897369384766e+01 -3.0507299804687500e+02 -1.8768899917602539e+01 -4.0841602325439453e+01 -3.0356402587890625e+02 -1.9593799591064453e+01 -4.0697898864746094e+01 -3.5607598876953125e+02 -2.1692899703979492e+01 -1.2645399570465088e+00 -3.5243698120117188e+02 -2.1438001632690430e+01 -1.6253198623657227e+01 -3.4977999877929688e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9389102172851562e+02 -1.8979900360107422e+01 2.5343799591064453e+01 -2.9530999755859375e+02 -5.3384203910827637e+00 2.7151700973510742e+01 -2.9531600952148438e+02 -1.8997200012207031e+01 2.7145198822021484e+01 -3.2100201416015625e+02 -2.1101699829101562e+01 3.5137298583984375e+01 -2.9328799438476562e+02 2.0910200119018555e+01 2.4294300079345703e+00 -2.9423498535156250e+02 2.1436700820922852e+01 7.9212093353271484e+00 -2.9331600952148438e+02 2.0680099487304688e+01 8.3790197372436523e+00 -2.9299798583984375e+02 -2.0043001174926758e+01 9.4347801208496094e+00 -2.9360397338867188e+02 -2.1064100265502930e+01 6.5731902122497559e+00 -2.9292398071289062e+02 -2.0053699493408203e+01 6.0825400352478027e+00 -2.9389501953125000e+02 2.1500699996948242e+01 -1.8998600542545319e-02 -2.9521200561523438e+02 -2.1496000289916992e+01 1.2589699745178223e+01 -2.9308599853515625e+02 1.2501699447631836e+01 2.2134401321411133e+01 -2.9326998901367188e+02 1.9039999008178711e+01 2.3525598526000977e+01 -2.9326998901367188e+02 7.7019100189208984e+00 2.3525899887084961e+01 -2.9362100219726562e+02 1.8922399520874023e+01 -3.0231399536132812e+01 -2.9341098022460938e+02 1.9731498718261719e+01 -2.8019500732421875e+01 -2.9327801513671875e+02 1.8965499877929688e+01 -2.7515899658203125e+01 -3.1907498168945312e+02 -2.0976200103759766e+01 3.5905399322509766e+01 -2.9638900756835938e+02 2.1148000717163086e+01 -3.2614101409912109e+01 -3.5573199462890625e+02 -1.9215301513671875e+01 -1.3810099601745605e+01 -3.5643301391601562e+02 -1.9833499908447266e+01 -1.1759099960327148e+01 -3.0430902099609375e+02 -1.8555899858474731e+00 -4.0844600677490234e+01 -3.0249200439453125e+02 1.1829500198364258e+01 -4.0658897399902344e+01 -3.0264498901367188e+02 -1.8771400451660156e+01 -4.0680099487304688e+01 -3.1430798339843750e+02 1.9702499389648438e+01 -3.9203201293945312e+01 -3.1984500122070312e+02 2.0591798782348633e+01 -3.7447299957275391e+01 -3.4647000122070312e+02 -2.1216400146484375e+01 2.4975999832153320e+01 -3.4159402465820312e+02 -2.1077899932861328e+01 2.9460500717163086e+01 -3.4637698364257812e+02 -2.0909101486206055e+01 2.6118799209594727e+01 -3.5209399414062500e+02 -2.0018499374389648e+01 2.0471300125122070e+01 -3.5347900390625000e+02 -2.0099201202392578e+01 1.8154300689697266e+01 -3.3030599975585938e+02 -1.8848699569702148e+01 -3.6203102111816406e+01 -2.9343099975585938e+02 -1.9761400222778320e+01 -2.8140600204467773e+01 -2.9422500610351562e+02 -2.0539600372314453e+01 -3.0411399841308594e+01 -2.9426599121093750e+02 -1.9398899078369141e+01 -3.2816200256347656e+01 -3.5261300659179688e+02 -1.8655199050903320e+01 -1.9787799835205078e+01 -3.5268099975585938e+02 1.8645401000976562e+01 -1.9713500976562500e+01 -3.5036099243164062e+02 -1.8625799179077148e+01 -2.3007801055908203e+01 -3.4930398559570312e+02 -2.0009599685668945e+01 2.4183099746704102e+01 -3.5157498168945312e+02 -1.9090700149536133e+01 2.1532600402832031e+01 -3.0346600341796875e+02 1.4679299354553223e+01 -4.0783000946044922e+01 -3.1395199584960938e+02 -1.9701200485229492e+01 3.6567798614501953e+01 -3.1672497558593750e+02 -2.0192699432373047e+01 3.6717002868652344e+01 -2.9281698608398438e+02 -1.9346300125122070e+01 5.5332198143005371e+00 -2.9272000122070312e+02 -1.9442800521850586e+01 0.0000000000000000e+00 -3.2081198120117188e+02 1.0791099548339844e+01 3.7371200561523438e+01 -3.1724398803710938e+02 1.9006500244140625e+01 3.7210098266601562e+01 -3.5834698486328125e+02 -3.4417200088500977e-01 2.1963999271392822e+00 -3.5834698486328125e+02 -9.1127700805664062e+00 -1.2978600263595581e+00 -2.9685900878906250e+02 -1.8872900009155273e+01 -3.7652400970458984e+01 -3.2794897460937500e+02 -1.9750200271606445e+01 3.6587100982666016e+01 -3.2780999755859375e+02 -2.0669000625610352e+01 3.5925102233886719e+01 -3.2391699218750000e+02 -1.9712800979614258e+01 3.7130401611328125e+01 -3.5435000610351562e+02 -1.9748800277709961e+01 -1.6822799682617188e+01 -3.0676901245117188e+02 1.8752901077270508e+01 -4.0763198852539062e+01 -3.0882702636718750e+02 1.9946399688720703e+01 -4.0176700592041016e+01 -3.0496099853515625e+02 1.9614299774169922e+01 -4.0783699035644531e+01 -3.5834698486328125e+02 -1.9443500518798828e+01 -1.3041900396347046e+00 -3.5814398193359375e+02 -2.0477001190185547e+01 0.0000000000000000e+00 -3.2921002197265625e+02 1.9697200775146484e+01 3.6352500915527344e+01 -3.2421200561523438e+02 2.0156599044799805e+01 3.6847499847412109e+01 -3.2686401367187500e+02 2.0697500228881836e+01 3.6008201599121094e+01 -3.2100201416015625e+02 2.1101699829101562e+01 3.5137298583984375e+01 -2.9527600097656250e+02 2.1412799835205078e+01 1.7235700607299805e+01 -2.9540600585937500e+02 2.1568498611450195e+01 8.8543395996093750e+00 -3.5814398193359375e+02 2.0477001190185547e+01 0.0000000000000000e+00 -3.5139700317382812e+02 2.0919799804687500e+01 -2.0299098968505859e+01 -3.5380398559570312e+02 2.0627099990844727e+01 -1.6860799789428711e+01 -3.5473901367187500e+02 2.1041700363159180e+01 -1.3936400413513184e+01 -3.0888000488281250e+02 1.8775501251220703e+01 -4.0425300598144531e+01 -3.4084298706054688e+02 -1.9801599502563477e+01 3.1534000396728516e+01 -3.4271099853515625e+02 -2.0521400451660156e+01 2.9706800460815430e+01 -3.3793801879882812e+02 -2.0354099273681641e+01 3.2774002075195312e+01 -3.3154299926757812e+02 2.0306900024414062e+01 3.5360797882080078e+01 -3.2807400512695312e+02 2.0018199920654297e+01 -3.6406101226806641e+01 -3.3054299926757812e+02 1.8849498748779297e+01 -3.6133800506591797e+01 -3.3050097656250000e+02 1.9640399932861328e+01 -3.6027500152587891e+01 -2.9454800415039062e+02 -2.1165300369262695e+01 2.3529899597167969e+01 -2.9354101562500000e+02 -2.0450700759887695e+01 2.1593698501586914e+01 -2.9352999877929688e+02 -1.9945899963378906e+01 2.4132699966430664e+01 -3.5027398681640625e+02 -2.0774400711059570e+01 2.2095098495483398e+01 -2.9542700195312500e+02 2.1280000686645508e+01 -2.4923398971557617e+01 -3.4608398437500000e+02 -1.9849899291992188e+01 2.7569898605346680e+01 -2.9817001342773438e+02 2.0221099853515625e+01 -3.8348499298095703e+01 -3.0135400390625000e+02 1.9679300308227539e+01 -4.0253299713134766e+01 -3.5280999755859375e+02 2.1489599227905273e+01 1.4429300308227539e+01 -3.3125497436523438e+02 -1.9740200042724609e+01 3.5798099517822266e+01 -3.5258599853515625e+02 1.9049900054931641e+01 -2.0097499847412109e+01 -3.5518099975585938e+02 1.9193099975585938e+01 -1.5135700225830078e+01 -2.9447100830078125e+02 1.9673799514770508e+01 -3.3245998382568359e+01 -2.9600598144531250e+02 1.9808300018310547e+01 -3.6304397583007812e+01 -3.4952700805664062e+02 1.9592401504516602e+01 -2.4081501007080078e+01 -3.4875802612304688e+02 2.0456298828125000e+01 -2.4366399765014648e+01 -3.4627999877929688e+02 1.9539398193359375e+01 -2.7475700378417969e+01 -2.9445999145507812e+02 -2.1392999649047852e+01 -1.2102700233459473e+01 -2.9513601684570312e+02 -2.1514900207519531e+01 -1.1265500068664551e+01 -3.5333898925781250e+02 2.0614799499511719e+01 1.7745698928833008e+01 -3.5506399536132812e+02 2.0054599761962891e+01 1.5079500198364258e+01 -3.3875900268554688e+02 1.9763700485229492e+01 -3.2741302490234375e+01 -3.3436099243164062e+02 1.8835599899291992e+01 -3.4935298919677734e+01 -3.3937298583984375e+02 1.8953699111938477e+01 -3.2561100006103516e+01 -3.5607598876953125e+02 -2.1692899703979492e+01 1.2645499706268311e+00 -3.5703500366210938e+02 -2.1400499343872070e+01 3.8565700054168701e+00 -3.5773199462890625e+02 -2.1037698745727539e+01 1.6897399425506592e+00 -2.9437301635742188e+02 -2.1436899185180664e+01 -9.0840997695922852e+00 -3.2101800537109375e+02 -1.8829700469970703e+01 3.7369998931884766e+01 -3.2140600585937500e+02 -1.7583400726318359e+01 3.7368499755859375e+01 -3.2482299804687500e+02 -1.8929100036621094e+01 3.7224697113037109e+01 -2.9354000854492188e+02 -2.0930999755859375e+01 -8.1252498626708984e+00 -3.4674700927734375e+02 2.0832700729370117e+01 2.5924900054931641e+01 -2.9987200927734375e+02 -2.0180599212646484e+01 -3.9411300659179688e+01 -3.0491702270507812e+02 2.0618099212646484e+01 -3.9998798370361328e+01 -3.4606100463867188e+02 1.9925899505615234e+01 2.7537700653076172e+01 -3.1801300048828125e+02 -1.9320600509643555e+01 3.7224300384521484e+01 -3.2061801147460938e+02 -2.0167699813842773e+01 3.7003498077392578e+01 -3.0369299316406250e+02 -2.0773601531982422e+01 3.2077201843261719e+01 -3.0207397460937500e+02 -1.9697500228881836e+01 3.2151699066162109e+01 -3.1690100097656250e+02 1.9549200057983398e+01 3.7093200683593750e+01 -3.5792898559570312e+02 -2.0122098922729492e+01 -5.3060798645019531e+00 -3.4812399291992188e+02 2.1213899612426758e+01 -2.3536401748657227e+01 -3.4604098510742188e+02 2.0502298355102539e+01 -2.7044799804687500e+01 -3.5003997802734375e+02 2.1177700042724609e+01 2.1476499557495117e+01 -3.5280902099609375e+02 2.1289100646972656e+01 1.6794000625610352e+01 -3.5586898803710938e+02 -2.1644498825073242e+01 4.0399899482727051e+00 -3.5662799072265625e+02 -2.1450700759887695e+01 5.7333002090454102e+00 -3.5763000488281250e+02 -2.0915899276733398e+01 3.9535799026489258e+00 -3.1959799194335938e+02 -2.1012901306152344e+01 -3.6637500762939453e+01 -3.1159500122070312e+02 -2.0971199035644531e+01 -3.8243301391601562e+01 -3.0844598388671875e+02 -2.1047599792480469e+01 -3.8234199523925781e+01 -3.3399002075195312e+02 -2.0463300704956055e+01 3.4382102966308594e+01 -2.9550701904296875e+02 -2.1220600128173828e+01 -2.8668201446533203e+01 -2.9457199096679688e+02 -2.1510900497436523e+01 8.2121295928955078e+00 -2.9417800903320312e+02 -2.1533100128173828e+01 3.1188600063323975e+00 -2.9334899902343750e+02 -1.8914800643920898e+01 -2.8487800598144531e+01 -2.9388699340820312e+02 -1.8902101516723633e+01 -3.1506698608398438e+01 -3.5596401977539062e+02 2.0822801589965820e+01 1.1559199333190918e+01 -2.9289599609375000e+02 1.9868801116943359e+01 6.6371603012084961e+00 -2.9544500732421875e+02 1.9908800125122070e+01 2.7024900436401367e+01 -2.9491497802734375e+02 2.1063600540161133e+01 2.4867498397827148e+01 -2.9605697631835938e+02 2.1032400131225586e+01 2.6281299591064453e+01 -3.5476400756835938e+02 -2.1436000823974609e+01 1.1820499420166016e+01 -2.9351300048828125e+02 2.0482898712158203e+01 2.2125499725341797e+01 -2.9305499267578125e+02 1.9228498458862305e+01 1.8848798751831055e+01 -2.9341900634765625e+02 2.0416299819946289e+01 1.8378601074218750e+01 -2.9315502929687500e+02 -1.9007801055908203e+01 -2.4923398971557617e+01 -2.9310501098632812e+02 -1.9728700637817383e+01 -1.7640798568725586e+01 -2.9364498901367188e+02 -2.0444400787353516e+01 -2.4939100265502930e+01 -3.5650100708007812e+02 2.1465898513793945e+01 5.8667902946472168e+00 -3.5503100585937500e+02 2.1411300659179688e+01 1.1534199714660645e+01 -3.1990600585937500e+02 2.0899099349975586e+01 3.6170799255371094e+01 -3.1497799682617188e+02 2.0311800003051758e+01 3.6380802154541016e+01 -2.9642700195312500e+02 -2.6864600181579590e+00 -3.7169200897216797e+01 -3.5826901245117188e+02 1.9396200180053711e+01 -2.7868998050689697e+00 -3.5834698486328125e+02 1.9420801162719727e+01 -1.3041900396347046e+00 -3.5808102416992188e+02 2.0524499893188477e+01 -1.9851101636886597e+00 -3.4434597778320312e+02 2.1216800689697266e+01 2.6880199432373047e+01 -3.2735400390625000e+02 2.0929399490356445e+01 -3.5480102539062500e+01 -2.9309799194335938e+02 1.9990001678466797e+01 1.4655200004577637e+01 -3.5818298339843750e+02 -1.0875799655914307e+00 -3.8518300056457520e+00 -3.5834698486328125e+02 1.3966799736022949e+01 -1.2978600263595581e+00 -3.5647900390625000e+02 1.9250000000000000e+01 1.1819000244140625e+01 -3.5481399536132812e+02 1.9181400299072266e+01 1.5933800697326660e+01 -2.9740899658203125e+02 -1.9789999008178711e+01 2.8850900650024414e+01 -2.9899902343750000e+02 -2.0753999710083008e+01 2.9213399887084961e+01 -3.5760302734375000e+02 2.1160999298095703e+01 1.4570499658584595e+00 -3.3751800537109375e+02 2.1068399429321289e+01 3.1864599227905273e+01 -3.5440600585937500e+02 -2.1626298904418945e+01 5.0832700729370117e+00 -3.5589700317382812e+02 -2.1648900985717773e+01 3.7875001430511475e+00 -3.2881298828125000e+02 -1.8843299865722656e+01 3.6546699523925781e+01 -3.3228601074218750e+02 -1.8861598968505859e+01 3.5655597686767578e+01 -3.2306600952148438e+02 1.8831100463867188e+01 3.7318099975585938e+01 -3.2146701049804688e+02 -1.6176101684570312e+01 3.7370201110839844e+01 -3.5406500244140625e+02 -1.9178598403930664e+01 -1.7486400604248047e+01 -3.5185198974609375e+02 -1.9945699691772461e+01 -2.0880500793457031e+01 -3.2843899536132812e+02 2.1021301269531250e+01 3.5178100585937500e+01 -3.4762600708007812e+02 2.1344600677490234e+01 -2.2794698715209961e+01 -3.1502398681640625e+02 -1.8796300888061523e+01 -3.9231098175048828e+01 -3.0888000488281250e+02 -1.3805500030517578e+01 -4.0425502777099609e+01 -3.5015197753906250e+02 1.8606500625610352e+01 -2.3265600204467773e+01 -3.3998999023437500e+02 -1.9486799240112305e+01 -3.2167503356933594e+01 -3.5603298950195312e+02 2.1677200317382812e+01 2.1655900478363037e+00 -3.2813098144531250e+02 -2.5604700669646263e-02 -3.6683498382568359e+01 -3.2813098144531250e+02 5.0987601280212402e+00 -3.6683399200439453e+01 -3.5746398925781250e+02 2.0303298950195312e+01 7.3249602317810059e+00 -3.1179101562500000e+02 1.9813699722290039e+01 3.6043498992919922e+01 -3.0476300048828125e+02 -1.8768800735473633e+01 -4.0842296600341797e+01 -3.0375497436523438e+02 -1.4236000061035156e+01 -4.0810100555419922e+01 -3.5815100097656250e+02 -1.9377000808715820e+01 4.0399999618530273e+00 -3.5772000122070312e+02 -1.9327600479125977e+01 7.0548300743103027e+00 -3.5810101318359375e+02 -1.5556599617004395e+01 4.4922103881835938e+00 -3.2705398559570312e+02 1.8839099884033203e+01 3.6892498016357422e+01 -3.2893499755859375e+02 -1.1858800888061523e+01 3.6523597717285156e+01 -3.4358297729492188e+02 2.1170099258422852e+01 -2.7724300384521484e+01 -3.4299499511718750e+02 2.0763900756835938e+01 -2.9156200408935547e+01 -3.5611999511718750e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -3.5778799438476562e+02 -2.0986700057983398e+01 -2.6590199558995664e-04 -3.3586999511718750e+02 4.9580696225166321e-01 -3.4280097961425781e+01 -3.5449002075195312e+02 -2.1093299865722656e+01 1.4353300094604492e+01 -2.9463699340820312e+02 -2.0799200057983398e+01 2.4978399276733398e+01 -2.9544601440429688e+02 -1.9906999588012695e+01 2.7025600433349609e+01 -3.0488101196289062e+02 -2.1041101455688477e+01 -3.8609600067138672e+01 -3.0070498657226562e+02 -2.1078199386596680e+01 -3.7644599914550781e+01 -3.5809100341796875e+02 -1.9329900741577148e+01 -4.8850998878479004e+00 -3.5834698486328125e+02 -1.4840600013732910e+01 -1.2978600263595581e+00 -2.9499200439453125e+02 2.1715000152587891e+01 0.0000000000000000e+00 -2.9414801025390625e+02 2.1496801376342773e+01 -3.3543500900268555e+00 -2.9501699829101562e+02 2.1595598220825195e+01 -6.7908496856689453e+00 -3.2797500610351562e+02 -2.0812900543212891e+01 -3.5661102294921875e+01 -3.2473400878906250e+02 -2.0942600250244141e+01 -3.5960800170898438e+01 -3.2769702148437500e+02 -2.1112899780273438e+01 -3.4492401123046875e+01 -2.9298898315429688e+02 -2.0142499923706055e+01 -7.6051497459411621e+00 -2.9599801635742188e+02 -2.0920900344848633e+01 2.6439599990844727e+01 -3.5754998779296875e+02 1.9198099136352539e+01 7.9628500938415527e+00 -3.5651300048828125e+02 1.9896200180053711e+01 1.1456799507141113e+01 -3.4111599731445312e+02 -2.1202299118041992e+01 -2.8984800338745117e+01 -2.9318899536132812e+02 1.9989601135253906e+01 -1.8623899459838867e+01 -2.9301397705078125e+02 1.9255699157714844e+01 -1.6637100219726562e+01 -2.9315502929687500e+02 1.9007801055908203e+01 -2.4923398971557617e+01 -2.9862402343750000e+02 2.0614500045776367e+01 2.9065099716186523e+01 -3.0196899414062500e+02 1.9748498916625977e+01 3.2083000183105469e+01 -2.9710098266601562e+02 1.9892801284790039e+01 2.8552400588989258e+01 -2.9366101074218750e+02 2.0477399826049805e+01 2.3110700607299805e+01 -3.0232000732421875e+02 2.0738700866699219e+01 3.1372398376464844e+01 -3.0861099243164062e+02 2.0884700775146484e+01 -3.9078899383544922e+01 -3.5606301879882812e+02 -2.0713399887084961e+01 1.1461899757385254e+01 -3.0955801391601562e+02 -1.9846300125122070e+01 -4.0090198516845703e+01 -3.3147698974609375e+02 2.1130699157714844e+01 -3.3505802154541016e+01 -2.9286599731445312e+02 -2.0144500732421875e+01 2.0268700122833252e+00 -2.9316000366210938e+02 -2.0815498352050781e+01 -2.5017300248146057e-01 -3.5429299926757812e+02 -1.8833799362182617e+01 -1.6851200103759766e+01 -2.9301699829101562e+02 -2.0011701583862305e+01 -1.0951999664306641e+01 -2.9293600463867188e+02 -1.9169601440429688e+01 -1.2381299972534180e+01 -3.0861300659179688e+02 -2.0877300262451172e+01 -3.9086498260498047e+01 -3.4602200317382812e+02 -2.1209100723266602e+01 -2.5532299041748047e+01 -2.9335998535156250e+02 -2.0292200088500977e+01 -1.8246900558471680e+01 -2.9511599731445312e+02 -2.1624200820922852e+01 -5.2132701873779297e+00 -2.9801397705078125e+02 1.9363100051879883e+01 -3.8681102752685547e+01 -2.9636300659179688e+02 1.8934900283813477e+01 -3.7104099273681641e+01 -2.9401000976562500e+02 2.1180299758911133e+01 -1.1817700386047363e+01 -2.9377099609375000e+02 1.8889099121093750e+01 2.5117799758911133e+01 -2.9531600952148438e+02 1.8997200012207031e+01 2.7145198822021484e+01 -3.2813098144531250e+02 -1.8840799331665039e+01 -3.6683399200439453e+01 -3.2379800415039062e+02 -1.8826000213623047e+01 -3.7523998260498047e+01 -3.5837200927734375e+02 1.8921699523925781e+01 -2.0907101035118103e-01 -3.1051901245117188e+02 -2.1018600463867188e+01 3.4418601989746094e+01 -3.5834698486328125e+02 9.1127700805664062e+00 -1.2978600263595581e+00 -3.4554800415039062e+02 1.8992599487304688e+01 -2.8222999572753906e+01 -3.4229498291015625e+02 1.9781700134277344e+01 -3.0575700759887695e+01 -3.4187100219726562e+02 1.8969900131225586e+01 -3.0999300003051758e+01 -3.5589700317382812e+02 2.1648900985717773e+01 3.7875001430511475e+00 -3.0598898315429688e+02 -1.8919500350952148e+01 3.4270000457763672e+01 -3.0674298095703125e+02 2.0300998687744141e+01 3.4072601318359375e+01 -2.9420501708984375e+02 2.1496000289916992e+01 4.6709599494934082e+00 -3.3512399291992188e+02 -1.9611301422119141e+01 3.4523300170898438e+01 -3.0652801513671875e+02 3.9767501354217529e+00 -4.0787200927734375e+01 -3.0504797363281250e+02 1.8768699645996094e+01 -4.0841899871826172e+01 -3.5642001342773438e+02 -1.9835100173950195e+01 1.1765600204467773e+01 -3.1605099487304688e+02 -1.9000099182128906e+01 3.7082500457763672e+01 -3.2092401123046875e+02 -1.8829700469970703e+01 3.7369899749755859e+01 -3.0149398803710938e+02 -2.0793701171875000e+01 -3.9310699462890625e+01 -2.9745401000976562e+02 -2.0954299926757812e+01 -3.6376899719238281e+01 -2.9460299682617188e+02 1.8884201049804688e+01 -3.3892700195312500e+01 -2.9364801025390625e+02 -2.1200399398803711e+01 -3.3317599296569824e+00 -3.0004901123046875e+02 2.1085699081420898e+01 2.9257400512695312e+01 -3.0743301391601562e+02 2.1191900253295898e+01 3.2060798645019531e+01 -3.5812500000000000e+02 -1.9712200164794922e+01 4.0400400161743164e+00 -3.4259600830078125e+02 1.8944200515747070e+01 3.0526500701904297e+01 -3.3932098388671875e+02 1.8908899307250977e+01 3.2588001251220703e+01 -3.5827999877929688e+02 1.4844900131225586e+01 2.6031599044799805e+00 -2.9566799926757812e+02 2.1223400115966797e+01 -2.8238401412963867e+01 -2.9687802124023438e+02 2.1269298553466797e+01 2.5534101486206055e+01 -2.9537899780273438e+02 2.1328498840332031e+01 2.2141799926757812e+01 -3.1321200561523438e+02 1.8844200134277344e+01 3.6570499420166016e+01 -3.0418200683593750e+02 2.7969000339508057e+00 3.3395500183105469e+01 -3.0206799316406250e+02 -1.8914899826049805e+01 3.2236999511718750e+01 -3.3626800537109375e+02 1.8883199691772461e+01 3.4117500305175781e+01 -3.3267700195312500e+02 1.8861499786376953e+01 3.5520301818847656e+01 -3.1994699096679688e+02 -5.1878199577331543e+00 3.7359901428222656e+01 -3.5688998413085938e+02 -1.9271200180053711e+01 1.0455399513244629e+01 -3.5834698486328125e+02 -1.9420801162719727e+01 -1.3041900396347046e+00 -2.9864199829101562e+02 -1.8773300170898438e+01 -3.9216201782226562e+01 -2.9410897827148438e+02 -2.1056200027465820e+01 1.8797698974609375e+01 -3.4948599243164062e+02 -1.9572900772094727e+01 -2.4137399673461914e+01 -3.4397198486328125e+02 -1.8960100173950195e+01 2.9512298583984375e+01 -3.4822100830078125e+02 -1.9023900985717773e+01 2.5644699096679688e+01 -3.5030999755859375e+02 -2.0830198287963867e+01 -2.1956499099731445e+01 -3.5796899414062500e+02 2.0331899642944336e+01 3.9482898712158203e+00 -3.5751400756835938e+02 2.0967201232910156e+01 3.7875001430511475e+00 -3.5836999511718750e+02 1.9432199478149414e+01 -6.5209698677062988e-01 -3.2050897216796875e+02 1.9792100906372070e+01 3.7196098327636719e+01 -3.5790100097656250e+02 2.0170999526977539e+01 -5.3803701400756836e+00 -2.9315502929687500e+02 1.9048400878906250e+01 2.2833799362182617e+01 -3.5727999877929688e+02 -2.0736299514770508e+01 6.9037899971008301e+00 -3.4454000854492188e+02 -1.8609199523925781e+01 -2.8952798843383789e+01 -3.5209597778320312e+02 -2.0996799468994141e+01 1.8986598968505859e+01 -3.5839300537109375e+02 1.9443500518798828e+01 0.0000000000000000e+00 -3.5834698486328125e+02 1.9420801162719727e+01 1.3042000532150269e+00 -2.9879199218750000e+02 -1.8950899124145508e+01 3.0093799591064453e+01 -2.9293899536132812e+02 1.9302200317382812e+01 -1.2291600227355957e+01 -3.3834799194335938e+02 -2.1032199859619141e+01 3.1538900375366211e+01 -3.3006600952148438e+02 2.0704399108886719e+01 -3.5360500335693359e+01 -3.3085998535156250e+02 2.1028799057006836e+01 -3.4449699401855469e+01 -3.2315701293945312e+02 -2.0186399459838867e+01 -3.7215400695800781e+01 -3.2810000610351562e+02 -1.9724100112915039e+01 -3.6536201477050781e+01 -3.4930801391601562e+02 1.9034198760986328e+01 -2.4420200347900391e+01 -2.9450000000000000e+02 2.1250600814819336e+01 1.9632299423217773e+01 -2.9291299438476562e+02 -2.0182098388671875e+01 -3.5791299343109131e+00 -3.1092599487304688e+02 -1.8853700637817383e+01 3.6003196716308594e+01 -2.9439099121093750e+02 2.1284301757812500e+01 1.6522699356079102e+01 -2.9342898559570312e+02 -2.0489299774169922e+01 1.7059600830078125e+01 -2.9344201660156250e+02 -2.0672800064086914e+01 1.2770199775695801e+01 -3.2769702148437500e+02 2.1112899780273438e+01 -3.4492401123046875e+01 -2.9540399169921875e+02 -2.1068399429321289e+01 -3.1504400253295898e+01 -3.0506597900390625e+02 -2.0638999938964844e+01 -3.9955097198486328e+01 -3.3741699218750000e+02 2.1109699249267578e+01 -3.1682901382446289e+01 -3.3869998168945312e+02 2.0800600051879883e+01 -3.1858600616455078e+01 -3.5179098510742188e+02 2.0019300460815430e+01 -2.0903600692749023e+01 -2.9362899780273438e+02 2.0801599502563477e+01 1.4327899932861328e+01 -3.3454299926757812e+02 2.0316301345825195e+01 -3.4356002807617188e+01 -3.5110101318359375e+02 -2.1267099380493164e+01 -1.9590099334716797e+01 -2.9847100830078125e+02 1.8778600692749023e+01 2.9873401641845703e+01 -2.9463601684570312e+02 2.1392398834228516e+01 -1.4212500572204590e+01 -2.9499200439453125e+02 -2.1715000152587891e+01 0.0000000000000000e+00 -2.9411700439453125e+02 -2.1560701370239258e+01 -4.4470497965812683e-01 -3.3192501831054688e+02 2.1169300079345703e+01 3.3075298309326172e+01 -3.4372698974609375e+02 2.1261499404907227e+01 2.6730300903320312e+01 -3.5434899902343750e+02 1.9749300003051758e+01 -1.6822698593139648e+01 -3.3484100341796875e+02 1.9469400405883789e+01 -3.4661800384521484e+01 -3.2450000000000000e+02 2.0966499328613281e+01 -3.5923599243164062e+01 -2.9310598754882812e+02 1.9056501388549805e+01 2.2132900238037109e+01 -3.5648999023437500e+02 2.0910301208496094e+01 -9.5198602676391602e+00 -3.5628799438476562e+02 2.0098001480102539e+01 -1.1975999832153320e+01 -2.9304901123046875e+02 -1.9753999710083008e+01 1.5128799438476562e+01 -3.1738702392578125e+02 -2.0613300323486328e+01 -3.7891799926757812e+01 -2.9470898437500000e+02 2.1455999374389648e+01 1.1961799621582031e+01 -3.3017901611328125e+02 5.0834503173828125e+00 -3.6240398406982422e+01 -3.3655700683593750e+02 -1.8886299133300781e+01 3.3996196746826172e+01 -3.0234500122070312e+02 1.8929800033569336e+01 -4.0626998901367188e+01 -3.2813098144531250e+02 1.8840799331665039e+01 -3.6683399200439453e+01 -3.3484201049804688e+02 -1.9465299606323242e+01 -3.4663200378417969e+01 -3.4947399902343750e+02 1.8960500717163086e+01 2.4254400253295898e+01 -3.2469497680664062e+02 1.9346300125122070e+01 3.7166999816894531e+01 -3.4057501220703125e+02 -1.8921199798583984e+01 3.1855899810791016e+01 -3.5834698486328125e+02 -9.0900001525878906e+00 -1.2978600263595581e+00 -2.9367599487304688e+02 2.0488698959350586e+01 -2.5060199737548828e+01 -3.5834698486328125e+02 9.0900001525878906e+00 -1.2978600263595581e+00 -2.9482702636718750e+02 -2.0255800247192383e+01 -3.3309799194335938e+01 -3.0476599121093750e+02 1.8768800735473633e+01 -4.0842296600341797e+01 -3.5834698486328125e+02 -5.1512403488159180e+00 -1.2978600263595581e+00 -2.9324700927734375e+02 -2.0800300598144531e+01 3.6718399524688721e+00 -2.9344400024414062e+02 1.9818399429321289e+01 2.4002199172973633e+01 -3.2935699462890625e+02 1.1955900192260742e+01 3.6433799743652344e+01 -3.4562899780273438e+02 1.8982200622558594e+01 2.8123498916625977e+01 -3.4391098022460938e+02 1.8453798294067383e+01 -2.9462400436401367e+01 -3.5237399291992188e+02 1.9291599273681641e+01 2.0367198944091797e+01 -3.5834698486328125e+02 5.1512403488159180e+00 -1.2978600263595581e+00 -3.5834698486328125e+02 0.0000000000000000e+00 -1.2978600263595581e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2994 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01) (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01) (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.2081198692321777e+02 1.0791099630296230e+01 3.7371199578046799e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01) (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0845400691032410e+02 1.8866499885916710e+01 3.5229701548814774e+01) (float-vector -3.3513501286506653e+02 1.9611999392509460e+01 3.4518200904130936e+01) (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.5434898734092712e+02 1.9749300554394722e+01 -1.6822699457406998e+01) (float-vector -3.4229499101638794e+02 1.9781699404120445e+01 -3.0575700104236603e+01) (float-vector -3.3050099015235901e+02 1.9640399143099785e+01 -3.6027498543262482e+01) (float-vector -2.9887500405311584e+02 1.9101100042462349e+01 -3.9388500154018402e+01) (float-vector -2.9447099566459656e+02 1.9673800095915794e+01 -3.3245999366044998e+01) (float-vector -2.9377099871635437e+02 1.8889099359512329e+01 2.5117799639701843e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01) (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5839301347732544e+02 1.9443500787019730e+01 0.0000000000000000e+00) (float-vector -3.4947401285171509e+02 1.8960500136017799e+01 2.4254400283098221e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.5157498717308044e+02 -1.9090700894594193e+01 2.1532600745558739e+01) (float-vector -3.3655700087547302e+02 -1.8886299803853035e+01 3.3996198326349258e+01) (float-vector -3.2482299208641052e+02 -1.8929099664092064e+01 3.7224698811769485e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9334899783134460e+02 -1.8914800137281418e+01 -2.8487799689173698e+01) (float-vector -2.9745399951934814e+02 -2.0954299718141556e+01 -3.6376900970935822e+01) (float-vector -3.0955800414085388e+02 -1.9846299663186073e+01 -4.0090199559926987e+01) (float-vector -3.3415600657463074e+02 -1.8840799108147621e+01 -3.4997601062059402e+01) (float-vector -3.4453999996185303e+02 -1.8609199672937393e+01 -2.8952799737453461e+01) (float-vector -3.5573199391365051e+02 -1.9215300679206848e+01 -1.3810100033879280e+01) (float-vector -3.5817798972129822e+02 -1.9378999248147011e+01 3.7875000853091478e+00) (float-vector -3.5171699523925781e+02 -2.1437799558043480e+01 1.6795899718999863e+01) (float-vector -3.1271800398826599e+02 -2.0705599337816238e+01 3.5512998700141907e+01) (float-vector -2.9352998733520508e+02 -1.9945900887250900e+01 2.4132700636982918e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_wrist_flex_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_wrist_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 3 4 0 4 72 0 72 248 0 0 2 3 1 0 248 1 270 2 270 410 2 2 410 3 4 3 294 410 294 3 294 410 454 410 324 454 270 325 410 324 410 325 269 270 1 270 269 79 79 325 270 324 325 20 325 79 21 20 325 21 21 79 23 79 318 23 79 269 318 318 269 407 318 407 23 407 194 196 407 148 23 269 194 407 194 195 196 194 338 195 269 445 194 329 338 194 445 329 194 445 269 1 72 329 445 248 72 445 248 445 1 329 330 331 72 330 329 329 331 338 72 4 330 444 330 4 331 330 444 331 337 338 494 337 331 331 444 494 494 444 4 494 4 273 337 494 273 338 337 311 273 311 337 96 272 273 273 272 311 96 273 4 310 311 149 149 311 317 311 272 317 310 338 311 338 310 447 338 447 195 310 149 195 310 195 447 147 148 149 195 149 148 317 124 149 147 149 124 148 147 403 147 464 403 124 464 147 473 148 474 474 148 403 23 148 473 474 403 464 467 473 474 467 474 95 95 474 464 467 23 473 21 23 24 24 23 467 95 24 467 462 24 95 21 24 462 141 462 202 462 95 203 203 202 462 462 141 21 201 202 203 396 141 202 201 396 202 197 201 203 197 203 95 396 201 197 396 197 414 141 396 475 396 414 475 197 95 189 414 197 189 476 414 369 369 414 189 475 414 476 142 475 476 141 475 142 142 476 369 80 142 369 402 369 189 402 80 369 80 141 142 381 21 141 441 141 39 141 80 39 381 141 441 380 381 382 380 21 381 381 441 382 38 382 441 39 38 441 38 39 40 39 80 40 38 40 466 466 306 38 382 38 306 306 380 382 380 379 21 380 306 379 21 379 326 379 306 326 326 327 22 326 22 21 326 306 327 20 21 22 22 327 20 70 71 20 327 70 20 71 324 20 70 327 339 71 70 339 71 295 294 71 294 324 71 159 295 339 159 71 294 454 324 294 295 296 294 296 4 296 295 302 158 302 295 159 158 295 296 302 4 96 4 97 97 4 302 97 302 303 303 302 158 158 159 160 158 160 328 328 303 158 303 317 272 272 97 303 328 317 303 96 97 272 328 6 317 125 317 144 317 5 144 317 6 5 317 125 124 6 328 160 5 6 7 73 6 160 6 73 7 73 74 7 74 264 7 7 264 5 73 313 74 74 313 214 264 74 214 214 5 264 214 215 5 408 215 214 214 313 408 73 257 313 313 257 409 313 409 408 408 409 191 408 191 215 409 257 261 409 261 191 261 257 262 261 314 191 261 262 314 262 256 314 257 256 262 314 256 461 314 461 191 255 256 257 256 255 461 255 104 461 191 461 104 274 255 257 255 109 104 274 109 255 274 85 109 452 274 257 452 85 274 109 110 104 85 84 109 110 109 84 83 84 85 497 85 452 85 497 83 84 453 110 84 496 453 84 83 496 497 496 83 489 496 497 99 489 497 452 99 497 496 489 453 489 260 453 260 319 453 453 319 110 489 99 258 260 489 258 99 11 100 99 100 258 99 452 11 258 259 260 100 259 258 260 259 319 259 100 319 100 11 55 54 100 55 100 54 319 54 55 56 55 389 56 55 11 389 319 54 304 54 56 304 56 389 46 56 46 304 44 46 389 389 64 44 11 64 389 44 45 46 46 45 304 63 44 64 44 63 45 11 293 64 293 63 64 478 288 63 288 45 63 478 63 293 293 13 478 11 13 293 288 478 289 478 13 289 11 12 13 78 13 12 13 78 493 13 493 289 288 289 69 289 493 69 493 68 69 493 78 68 68 60 69 60 288 69 78 35 68 35 60 68 35 36 37 60 35 37 78 36 35 36 107 108 108 440 36 36 440 37 211 107 36 211 36 78 440 120 37 60 37 120 440 108 120 108 14 120 107 213 108 108 213 14 211 213 107 211 212 213 463 65 211 211 65 212 211 78 463 213 212 14 198 212 65 14 212 198 65 66 67 463 66 65 65 67 198 198 92 14 198 67 92 32 67 263 67 66 263 67 32 92 463 263 66 263 33 32 263 463 33 32 33 34 32 34 92 33 457 458 34 33 487 487 33 458 463 457 33 34 487 92 487 458 89 487 89 92 458 90 89 458 457 90 89 90 91 91 90 457 250 251 89 91 316 89 250 89 460 460 89 57 251 92 89 316 57 89 250 459 477 251 250 477 250 460 459 251 477 145 92 251 145 145 146 92 15 92 206 92 15 14 92 146 206 146 145 477 146 477 115 115 477 459 459 460 435 459 435 115 400 404 435 57 400 435 435 292 115 435 404 292 460 57 435 57 59 400 404 400 59 59 58 404 58 292 404 57 58 59 376 374 58 58 57 376 58 374 292 372 373 374 374 290 372 373 292 374 374 376 290 290 87 372 373 372 87 373 87 86 292 373 86 86 87 88 266 87 290 88 87 266 266 290 291 376 291 290 265 266 267 265 88 266 266 291 267 88 265 86 265 267 137 265 137 86 284 285 267 267 285 76 434 267 291 76 137 267 434 284 267 392 393 284 434 392 284 285 284 393 76 285 77 492 285 393 492 77 285 42 436 393 393 436 492 392 42 393 42 392 442 434 442 392 291 442 434 442 308 42 308 442 291 41 42 43 42 308 43 436 42 41 43 308 309 309 308 376 291 376 308 309 53 43 376 53 309 53 376 51 438 51 376 438 376 57 51 52 53 43 53 52 51 438 52 315 411 438 315 438 57 438 488 52 438 411 488 316 315 57 315 316 91 411 315 91 411 91 412 411 412 488 412 52 488 412 43 52 91 43 412 457 43 91 41 43 47 47 43 413 43 457 413 413 457 463 413 78 12 413 463 78 102 413 161 413 12 161 47 413 102 101 102 103 47 102 164 161 163 102 102 101 164 163 103 102 161 162 163 450 162 161 161 12 450 419 163 162 163 323 103 419 322 163 323 163 322 450 419 162 12 351 450 352 419 450 450 351 352 246 322 419 352 246 419 322 10 323 246 10 322 103 323 443 10 115 323 323 115 443 103 443 220 443 115 220 220 101 103 101 220 165 165 220 114 115 114 220 164 101 165 164 165 166 423 165 114 166 165 423 114 115 116 423 114 424 424 114 116 166 423 271 271 423 424 164 166 271 47 164 271 177 271 178 271 175 178 175 271 424 271 177 448 448 47 271 175 424 176 424 116 176 174 175 176 178 175 174 177 178 174 484 177 174 448 177 484 395 448 181 41 47 448 448 395 41 181 448 484 433 181 484 433 484 174 432 433 174 174 176 486 486 432 174 179 433 432 179 181 433 179 180 181 395 181 180 336 179 432 180 179 336 486 336 432 486 292 336 292 486 176 335 336 86 335 425 336 425 180 336 292 86 336 425 226 180 395 180 226 425 426 224 426 425 335 224 226 425 429 335 86 429 426 335 429 428 426 428 224 426 224 225 226 49 224 427 427 224 428 49 225 224 395 226 225 225 41 395 41 225 49 98 41 49 41 98 436 169 98 48 48 98 49 169 306 98 98 306 436 386 436 306 386 77 436 492 436 77 386 387 388 75 386 388 386 75 77 387 386 306 75 76 77 437 81 75 75 81 76 388 437 75 387 437 388 306 341 387 377 437 387 387 341 377 81 437 377 81 377 378 341 378 377 340 341 306 341 340 378 340 81 378 340 490 81 306 490 340 82 490 491 490 466 491 490 306 466 490 82 81 80 81 82 82 40 80 82 491 40 40 491 466 199 200 80 80 200 394 80 402 199 394 81 80 312 199 189 189 199 402 200 199 312 200 312 394 470 394 287 312 287 394 470 81 394 312 189 286 287 312 286 286 254 287 287 254 136 495 470 287 495 287 136 135 81 470 135 470 495 136 135 495 135 136 17 17 136 254 17 254 18 286 189 254 18 254 189 17 18 19 25 17 19 135 17 25 398 135 399 398 81 135 25 399 135 399 25 19 19 18 397 397 399 19 397 18 189 397 398 399 130 397 131 130 398 397 131 397 189 130 81 398 81 130 76 129 130 131 76 130 129 137 129 131 137 131 189 129 137 76 137 189 86 344 86 189 429 86 344 344 170 345 173 344 189 173 170 344 345 429 344 345 428 429 170 421 345 345 421 428 170 171 172 173 171 170 170 172 421 171 173 189 223 342 171 171 342 172 223 171 189 342 48 172 172 347 421 50 347 172 48 50 172 421 347 428 50 346 347 346 428 347 48 49 50 49 346 50 167 48 342 169 48 167 223 167 342 167 168 169 188 167 223 188 168 167 306 169 168 168 188 243 306 168 415 168 243 415 188 189 190 188 223 189 243 188 190 243 282 418 415 243 418 282 243 190 307 415 418 307 306 415 307 418 349 349 418 282 280 306 307 221 307 349 280 307 184 184 307 221 282 222 349 222 221 349 182 221 222 182 184 221 182 183 184 183 30 184 30 280 184 30 279 280 279 306 280 306 279 327 279 159 327 327 159 339 73 159 279 159 73 160 257 73 279 257 277 297 279 277 257 452 257 297 451 452 297 452 451 11 320 348 451 281 11 451 320 451 297 350 281 451 350 451 348 11 281 12 253 252 281 253 281 151 252 12 281 350 151 281 12 252 351 252 253 216 479 252 216 351 252 479 153 216 253 151 153 253 216 217 218 153 217 216 216 218 479 479 245 351 479 234 245 218 234 479 351 245 352 245 236 246 234 236 245 245 246 352 234 235 236 334 234 218 234 334 235 235 246 236 246 235 10 333 235 334 235 333 10 334 356 333 334 218 356 354 355 356 356 355 416 417 356 416 356 417 333 218 354 356 218 217 354 354 217 355 153 355 217 355 152 244 355 244 416 152 355 153 244 431 416 431 417 416 152 230 244 230 431 244 151 152 153 152 151 230 151 229 230 229 238 230 238 431 230 238 430 431 431 430 417 237 238 229 237 480 238 480 430 238 350 237 229 151 350 229 350 155 237 155 480 237 155 481 480 480 481 430 430 481 417 154 481 155 481 154 417 154 155 156 155 350 156 156 350 348 154 156 157 348 157 156 348 320 485 157 348 485 320 297 321 485 320 321 485 321 157 119 321 117 119 157 321 297 117 321 297 276 301 297 277 276 297 301 117 117 118 119 117 301 118 119 353 157 353 119 118 118 227 228 227 118 301 118 228 353 301 276 227 360 361 227 360 227 276 227 361 228 353 228 268 228 361 268 247 353 268 247 157 353 154 157 247 154 247 268 123 154 268 332 154 134 154 113 333 113 154 332 417 154 333 134 154 205 205 154 210 123 210 154 205 132 134 209 205 210 209 132 205 208 209 210 208 210 401 401 210 123 319 132 209 208 319 209 132 133 134 132 304 133 304 132 319 122 110 319 208 122 319 122 208 401 122 401 123 122 123 110 105 110 150 471 110 123 150 110 469 105 104 110 471 469 110 471 123 268 268 469 471 268 105 469 150 469 105 104 105 106 105 299 106 299 105 268 104 106 371 191 104 371 106 299 298 106 298 371 298 299 300 300 299 268 93 268 361 268 93 300 232 93 361 232 361 360 231 186 232 232 240 93 186 240 232 231 232 360 275 231 360 275 360 276 187 186 231 187 231 275 185 186 187 185 240 186 482 187 275 482 185 187 275 276 277 275 277 482 482 483 239 239 185 482 357 482 277 482 357 483 239 240 185 420 240 239 483 420 239 483 359 420 357 359 483 357 358 359 357 279 465 358 357 465 357 277 279 358 94 359 94 420 359 94 240 420 93 94 95 240 94 93 383 95 94 358 384 94 383 94 384 384 358 465 383 384 385 384 465 439 385 384 439 27 383 385 27 26 383 383 26 95 29 385 439 27 385 29 439 30 29 439 465 30 29 30 31 29 31 28 27 29 28 26 27 28 26 28 219 219 283 26 283 95 26 31 343 28 343 219 28 31 30 233 343 31 233 343 422 219 233 422 343 283 219 422 282 95 283 242 282 283 242 283 422 189 95 190 282 190 95 95 464 93 282 242 222 241 182 242 242 182 222 422 241 242 233 241 422 241 183 182 233 183 241 233 30 183 465 279 30 300 93 127 93 464 127 140 298 300 138 140 300 367 300 127 138 300 367 138 139 140 370 140 192 140 139 192 140 370 298 370 371 298 192 371 370 191 192 193 191 371 192 192 139 193 139 215 193 215 139 138 215 191 193 215 138 368 5 215 498 368 498 215 367 368 138 368 367 498 127 498 367 498 127 5 127 128 5 144 5 128 446 127 126 128 127 446 464 126 127 143 144 128 143 128 446 143 125 144 143 126 125 446 126 143 124 125 126 124 126 464 304 305 133 304 112 305 45 112 304 305 204 133 332 204 305 112 111 305 305 111 332 133 204 134 204 332 134 111 113 332 111 112 113 112 45 406 112 406 113 113 406 365 365 333 113 45 365 406 365 366 333 365 45 366 288 366 45 366 363 333 366 364 363 288 364 366 333 249 10 363 362 333 333 362 249 362 363 364 362 364 375 456 375 364 364 288 456 288 60 456 455 449 456 456 62 455 456 60 62 449 375 456 375 449 362 362 449 249 249 449 455 62 61 455 455 61 121 121 249 455 60 61 62 120 61 60 120 121 61 120 8 121 121 8 249 120 468 8 120 14 468 8 9 10 8 10 249 468 9 8 468 14 472 9 468 472 14 15 16 14 16 278 14 278 472 9 472 390 472 278 391 390 472 391 9 390 10 390 391 10 391 115 10 16 499 391 278 16 391 499 115 391 405 16 15 405 499 16 405 15 206 207 405 206 499 405 115 405 207 115 116 115 292 207 146 115 206 146 207 176 116 292 346 49 427 346 427 428))
                   (list :vertices (let ((mat (make-matrix 500 3))) (fvector-replace (array-entity mat) #f(2.6949899673461914e+01 -1.3321399688720703e+00 -1.4519399642944336e+01 2.7806900024414062e+01 -1.1231600046157837e+00 -1.4235500335693359e+01 2.7934198379516602e+01 -1.4776200056076050e+00 -1.4892799377441406e+01 2.6950000762939453e+01 -1.5249999761581421e+00 -1.5300000190734863e+01 2.6950000762939453e+01 1.5249999761581421e+00 -1.5300000190734863e+01 2.9449998855590820e+01 5.6033401489257812e+00 -1.1994600296020508e+01 2.9449998855590820e+01 4.4691600799560547e+00 -1.8366899490356445e+01 2.9449998855590820e+01 6.4079799652099609e+00 -1.7792999267578125e+01 4.1700000762939453e+01 5.2891001701354980e+00 1.2142200469970703e+01 4.1700000762939453e+01 4.1911201477050781e+00 1.2555100440979004e+01 4.1700000762939453e+01 2.3946001529693604e+00 9.0899496078491211e+00 2.4800001144409180e+01 1.4113900184631348e+01 5.2387599945068359e+00 2.4800001144409180e+01 5.0686402320861816e+00 6.1980595588684082e+00 2.4800001144409180e+01 1.2478300094604492e+01 9.0991601943969727e+00 2.9449998855590820e+01 3.5873501300811768e+00 1.8564199447631836e+01 2.9449998855590820e+01 1.7070800068658132e-12 1.3250000000000000e+01 2.9449998855590820e+01 9.4172596931457520e-01 1.3219099998474121e+01 4.0941303253173828e+01 -1.2944400787353516e+01 -2.7889099121093750e+00 4.1700000762939453e+01 -1.3126599311828613e+01 -1.7778500318527222e+00 4.0596401214599609e+01 -1.3072700500488281e+01 -2.1210699081420898e+00 2.9449998855590820e+01 -3.7143499851226807e+00 -1.8546400070190430e+01 2.9449998855590820e+01 -8.6656904220581055e+00 -1.6823900222778320e+01 2.9449998855590820e+01 -6.4647998809814453e+00 -1.7769500732421875e+01 2.9449998855590820e+01 -1.5027298927307129e+00 -1.3168100357055664e+01 2.9449998855590820e+01 -3.3077600002288818e+00 -1.2824199676513672e+01 3.7543899536132812e+01 -1.3026099205017090e+01 -2.3835899829864502e+00 4.1700000762939453e+01 -1.0812700986862183e+00 -4.8788895606994629e+00 4.1451499938964844e+01 -8.2713496685028076e-01 -4.9284200668334961e+00 3.6605102539062500e+01 -1.0988899469375610e+00 -4.8750300407409668e+00 3.1152399063110352e+01 -8.2713496685028076e-01 -4.9284200668334961e+00 2.4800498962402344e+01 -1.2670500278472900e+00 -4.8517098426818848e+00 2.8791999816894531e+01 -1.2358100414276123e+00 -4.8441500663757324e+00 2.9449998855590820e+01 -1.6344200372695923e+00 1.8844400405883789e+01 2.4800001144409180e+01 -3.0237698554992676e+00 1.8664899826049805e+01 2.9449998855590820e+01 -3.2595500946044922e+00 1.8619998931884766e+01 2.4800001144409180e+01 9.9735498428344727e+00 1.6064901351928711e+01 2.4800001144409180e+01 7.7365999221801758e+00 1.7259799957275391e+01 2.9449899673461914e+01 9.5353603363037109e+00 1.6332099914550781e+01 2.4800001144409180e+01 -1.3306699752807617e+01 -1.3433399200439453e+01 2.9449998855590820e+01 -1.3193599700927734e+01 -1.3537799835205078e+01 2.9449899673461914e+01 -1.4166500091552734e+01 -1.2516999244689941e+01 2.4800001144409180e+01 -7.0188102722167969e+00 3.5983300209045410e+00 2.4800001144409180e+01 -1.5630700111389160e+01 4.6948299407958984e+00 2.4800001144409180e+01 -1.2478799819946289e+01 9.9487600326538086e+00 2.9449998855590820e+01 1.7299499511718750e+01 7.6166000366210938e+00 2.9449998855590820e+01 1.1459199905395508e+01 6.6333303451538086e+00 2.9449998855590820e+01 1.7936100006103516e+01 5.9735398292541504e+00 2.4800001144409180e+01 -2.7413001060485840e+00 6.8829898834228516e+00 2.4800100326538086e+01 -4.7332797050476074e+00 -1.6327600479125977e+00 2.4800001144409180e+01 -4.9987001419067383e+00 1.7108700376411434e-06 2.5172800064086914e+01 -4.9490499496459961e+00 -7.0615899562835693e-01 2.9449998855590820e+01 -1.3733900070190430e+01 1.3003800392150879e+01 2.4800001144409180e+01 -1.3201000213623047e+01 1.3534600257873535e+01 2.4800001144409180e+01 -1.4448500633239746e+01 1.2194899559020996e+01 2.4800001144409180e+01 1.8614400863647461e+01 3.2872800827026367e+00 2.4800001144409180e+01 1.7139900207519531e+01 5.5272798538208008e+00 2.4800001144409180e+01 1.8191400527954102e+01 5.1539697647094727e+00 2.9449998855590820e+01 -7.9176297187805176e+00 1.0620200157165527e+01 2.9449998855590820e+01 -9.1493997573852539e+00 9.5894107818603516e+00 3.5463500976562500e+01 -8.6739902496337891e+00 1.0019599914550781e+01 2.9449998855590820e+01 1.0968299865722656e+01 1.5395999908447266e+01 2.9449998855590820e+01 7.0534601211547852e+00 1.1208900451660156e+01 2.9449998855590820e+01 7.9035301208496094e+00 1.0628799438476562e+01 2.9449998855590820e+01 1.6562898635864258e+01 9.1354904174804688e+00 2.4800001144409180e+01 1.7104598999023438e+01 8.0530996322631836e+00 2.4800001144409180e+01 1.3717299699783325e+00 1.8857799530029297e+01 2.4800001144409180e+01 -1.4854799681995878e-11 1.8899999618530273e+01 2.9449998855590820e+01 -1.5583599966007000e-09 1.8899999618530273e+01 2.4800001144409180e+01 1.1533399581909180e+01 1.4974200248718262e+01 2.9449998855590820e+01 1.2898599624633789e+01 1.3833900451660156e+01 2.4800001144409180e+01 -3.5367000102996826e+00 -1.8570798873901367e+01 2.4800001144409180e+01 -1.7920200824737549e+00 -1.8824199676513672e+01 2.6950000762939453e+01 -6.9327699137033960e-10 -1.3775000572204590e+01 2.4800001144409180e+01 6.1278700828552246e+00 -1.7885200500488281e+01 2.4800001144409180e+01 8.2251195907592773e+00 -1.7023900985717773e+01 2.9449899673461914e+01 -1.8800298690795898e+01 -2.0146400928497314e+00 2.9449998855590820e+01 -1.3177899360656738e+01 1.3828600645065308e+00 2.9449899673461914e+01 -1.8906700134277344e+01 4.3627300858497620e-01 2.4800001144409180e+01 7.6361198425292969e+00 1.2906599998474121e+01 2.9449899673461914e+01 -1.7853900194168091e+00 -1.4315999984741211e+01 2.9449998855590820e+01 -1.0306200027465820e+01 -8.3443403244018555e+00 2.9449998855590820e+01 -1.6965299606323242e+01 -8.3512096405029297e+00 2.9449998855590820e+01 -1.5813600540161133e+01 -1.0373899459838867e+01 2.4800001144409180e+01 1.8169099807739258e+01 -5.2433500289916992e+00 2.9449998855590820e+01 1.8230001449584961e+01 -5.0533900260925293e+00 2.4800100326538086e+01 1.7557699203491211e+01 -7.0197801589965820e+00 4.1700000762939453e+01 -9.0987195968627930e+00 3.0617098808288574e+00 4.1700000762939453e+01 -1.1873300552368164e+01 5.8653898239135742e+00 4.1700000762939453e+01 -1.2331399917602539e+01 4.8047900199890137e+00 2.9449998855590820e+01 -6.9459600448608398e+00 1.7588899612426758e+01 2.4800001144409180e+01 -6.7345299720764160e+00 1.7668100357055664e+01 2.4800001144409180e+01 -8.5615901947021484e+00 1.6858699798583984e+01 2.9449998855590820e+01 -1.5945000648498535e+00 1.3163100242614746e+01 4.1700000762939453e+01 4.2218799591064453e+00 -5.8488397598266602e+00 4.1700000762939453e+01 8.6131399869918823e-01 -4.9489803314208984e+00 4.1700099945068359e+01 -3.6179699897766113e+00 -1.2741100311279297e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.6184600830078125e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.8838399887084961e+01 2.4800001144409180e+01 -6.4720101356506348e+00 -1.8500200510025024e+00 2.4800001144409180e+01 1.5606900215148926e+01 -1.3564898967742920e+00 2.4800001144409180e+01 1.8856498718261719e+01 1.3846999406814575e+00 3.0496999740600586e+01 -6.9884502887725830e-01 4.9502301216125488e+00 2.4800001144409180e+01 1.7109100554080214e-06 4.9987001419067383e+00 3.3118000030517578e+01 3.1702800107336060e-11 4.9973497390747070e+00 2.9449998855590820e+01 1.4403300285339355e+01 -9.0918502807617188e+00 2.9449998855590820e+01 1.2218600273132324e+01 -5.1004796028137207e+00 2.9449998855590820e+01 1.1632599830627441e+01 -6.3270602226257324e+00 2.4800001144409180e+01 6.1484198570251465e+00 1.7874099731445312e+01 2.9449998855590820e+01 5.7962603569030762e+00 1.7995498657226562e+01 2.9449998855590820e+01 1.7369400024414062e+01 -7.4808998107910156e+00 2.9450099945068359e+01 1.2841000556945801e+01 -3.2295300960540771e+00 4.1044700622558594e+01 1.2410599708557129e+01 4.6027798652648926e+00 2.9449998855590820e+01 1.2081000328063965e+01 5.4132800102233887e+00 4.1700099945068359e+01 1.2073200225830078e+01 5.4324998855590820e+00 4.1366802215576172e+01 -1.3704800605773926e+00 4.8117103576660156e+00 4.1700000762939453e+01 -9.7641903162002563e-01 4.9032096862792969e+00 4.1700000762939453e+01 -1.9282399415969849e+00 4.6091599464416504e+00 2.5281700134277344e+01 4.6080799102783203e+00 -1.9345901012420654e+00 3.5064498901367188e+01 4.5723900794982910e+00 -2.0414299964904785e+00 3.2693099975585938e+01 4.7710299491882324e+00 -1.5233099460601807e+00 2.9449998855590820e+01 5.9480400085449219e+00 1.1824600219726562e+01 4.1700000762939453e+01 6.8109397888183594e+00 1.1353399276733398e+01 2.9449998855590820e+01 1.3077699661254883e+01 -2.1189999580383301e+00 4.1700000762939453e+01 1.3024199485778809e+01 -2.4528200626373291e+00 4.1700000762939453e+01 1.8967499732971191e+00 -1.3111899375915527e+01 3.2467102050781250e+01 3.5735399723052979e+00 -1.2753700256347656e+01 4.1700000762939453e+01 3.5595600605010986e+00 -1.2760800361633301e+01 4.1700000762939453e+01 5.7176399230957031e+00 -1.1947800636291504e+01 3.5498397827148438e+01 4.6924200057983398e+00 -1.2375200271606445e+01 2.9909299850463867e+01 -1.3233499526977539e+01 6.7986297607421875e-01 2.9450099945068359e+01 -1.3251099586486816e+01 -4.2760699987411499e-01 4.1700000762939453e+01 -1.3251000404357910e+01 1.1281799525022507e-02 2.9449998855590820e+01 1.3185000419616699e+01 1.3257799148559570e+00 2.9449998855590820e+01 1.3010799407958984e+01 2.4883000850677490e+00 4.1700000762939453e+01 1.3091700553894043e+01 2.0333499908447266e+00 2.9449998855590820e+01 -1.2854799270629883e+01 -3.1774599552154541e+00 3.5451599121093750e+01 -1.2673999786376953e+01 -3.8420100212097168e+00 4.1700000762939453e+01 -1.3146899223327637e+01 1.6732499599456787e+00 4.1700000762939453e+01 8.7537002563476562e+00 -9.9471302032470703e+00 3.5589797973632812e+01 9.0852098464965820e+00 -9.6500902175903320e+00 4.1700000762939453e+01 9.6044502258300781e+00 -9.1407299041748047e+00 2.9449998855590820e+01 -8.4621601104736328e+00 -1.2428799629211426e+01 2.9450099945068359e+01 -9.1007795333862305e+00 -9.6398496627807617e+00 4.0596401214599609e+01 4.4419002532958984e+00 -1.2467600822448730e+01 3.0563600540161133e+01 4.4419002532958984e+00 -1.2467600822448730e+01 3.4262798309326172e+01 -2.5802001953125000e+00 1.2989199638366699e+01 4.1700000762939453e+01 -2.0681099891662598e+00 1.3082499504089355e+01 4.1700000762939453e+01 9.5419400930404663e-01 -1.3217900276184082e+01 2.9449998855590820e+01 -1.5099000608836954e-13 -1.3250000000000000e+01 2.9449998855590820e+01 1.3475999832153320e+00 -1.3186599731445312e+01 3.0563600540161133e+01 1.2555100440979004e+01 -4.1896400451660156e+00 2.4799900054931641e+01 4.5830502510070801e+00 1.9992399215698242e+00 2.8193998336791992e+01 4.4985599517822266e+00 2.1763498783111572e+00 2.5048500061035156e+01 4.3693199157714844e+00 2.4254100322723389e+00 4.1699901580810547e+01 4.9439101219177246e+00 7.6508200168609619e-01 3.3006999969482422e+01 4.9120898246765137e+00 9.2592900991439819e-01 3.1737901687622070e+01 4.9853000640869141e+00 4.0886998176574707e-01 3.5200901031494141e+01 4.9823098182678223e+00 -4.8427399992942810e-01 2.4800001144409180e+01 1.7883800268173218e+00 -1.8824499130249023e+01 2.4800001144409180e+01 5.1598697900772095e-01 -1.4673399925231934e+01 2.4800001144409180e+01 4.3475599288940430e+00 -1.8397600173950195e+01 2.4800001144409180e+01 9.0005397796630859e-01 4.9207901954650879e+00 2.9995800018310547e+01 1.2358300685882568e+00 4.8441500663757324e+00 3.3199298858642578e+01 6.0916501283645630e-01 4.9676499366760254e+00 2.4800001144409180e+01 -8.7354403734207153e-01 4.9205598831176758e+00 3.4352897644042969e+01 -1.1120200157165527e+00 4.8720598220825195e+00 3.0656000137329102e+01 -1.3837099075317383e+00 4.8019599914550781e+00 2.5064998626708984e+01 -4.4503998756408691e+00 -2.2920100688934326e+00 2.5491998672485352e+01 -3.7973399162292480e+00 -3.2582600116729736e+00 2.4799900054931641e+01 -3.9770100116729736e+00 -3.0274100303649902e+00 3.7475002288818359e+01 -4.8703002929687500e+00 -1.1196700334548950e+00 3.3742599487304688e+01 -4.7547302246093750e+00 -1.5442498922348022e+00 3.0139801025390625e+01 -4.8750100135803223e+00 -1.1267799139022827e+00 4.1327201843261719e+01 -4.7908797264099121e+00 -1.4225100278854370e+00 3.5886898040771484e+01 -3.4335300922393799e+00 3.6457099914550781e+00 3.5273200988769531e+01 -2.7790000438690186e+00 4.1557497978210449e+00 4.1700000762939453e+01 -2.9831700325012207e+00 4.0128798484802246e+00 2.5635999679565430e+01 -3.0542199611663818e+00 3.9661097526550293e+00 2.9655099868774414e+01 -2.7790000438690186e+00 4.1557402610778809e+00 3.4228599548339844e+01 -4.2334699630737305e+00 2.6554300785064697e+00 2.5157899856567383e+01 -4.5110802650451660e+00 2.1703798770904541e+00 2.5359100341796875e+01 -3.8741300106048584e+00 3.1621801853179932e+00 3.2100597381591797e+01 -2.1571500301361084e+00 -4.5078001022338867e+00 2.9875398635864258e+01 -1.9007399082183838e+00 -4.6217598915100098e+00 2.5522800445556641e+01 -2.1281199455261230e+00 -4.5269098281860352e+00 3.3747100830078125e+01 2.4185400009155273e+00 -4.3731203079223633e+00 3.6387699127197266e+01 2.6601800918579102e+00 -4.2304801940917969e+00 2.9149299621582031e+01 2.6601800918579102e+00 -4.2304801940917969e+00 4.1377998352050781e+01 -4.2740101814270020e+00 -2.6047999858856201e+00 4.1700000762939453e+01 -4.6142601966857910e+00 -1.9129699468612671e+00 4.1700000762939453e+01 -3.8957700729370117e+00 -3.1462600231170654e+00 2.9449998855590820e+01 1.2822800636291504e+01 -1.3897599220275879e+01 2.9449998855590820e+01 9.9814195632934570e+00 -8.7158994674682617e+00 2.9450099945068359e+01 9.1288604736328125e+00 -9.6070594787597656e+00 2.8950000762939453e+01 -2.6849699352737844e-08 -1.3775000572204590e+01 2.9449998855590820e+01 4.0034601092338562e-01 -1.3321899414062500e+01 2.9449998855590820e+01 -2.5009200266268294e-10 -1.3275000572204590e+01 4.1700000762939453e+01 -6.7596302032470703e+00 -1.1387599945068359e+01 2.9449998855590820e+01 1.4829100370407104e+00 1.8850200653076172e+01 4.1700000762939453e+01 -1.0580799102783203e+01 -7.9779596328735352e+00 2.9937200546264648e+01 -1.1114899635314941e+01 -7.1989998817443848e+00 3.5727001190185547e+01 -6.5068202018737793e+00 -1.1531299591064453e+01 2.9449998855590820e+01 -5.9482998847961426e+00 -1.1826000213623047e+01 4.1699901580810547e+01 -5.4556403160095215e+00 -1.2071100234985352e+01 3.7817501068115234e+01 1.2935999870300293e+01 2.8339099884033203e+00 4.1700000762939453e+01 1.3217700004577637e+01 9.7401398420333862e-01 3.8573200225830078e+01 -1.3627499341964722e+00 1.3181200027465820e+01 4.1700000762939453e+01 -9.4658499956130981e-01 1.3215100288391113e+01 2.9449998855590820e+01 1.3217000007629395e+01 -9.6028500795364380e-01 2.9449998855590820e+01 1.3250000000000000e+01 -2.0045698620378971e-03 4.1700000762939453e+01 1.3250000000000000e+01 -3.5527100789104751e-15 2.4800001144409180e+01 3.7499701976776123e+00 1.6734001159667969e+01 2.4800001144409180e+01 3.0695300102233887e+00 1.8649799346923828e+01 2.4800100326538086e+01 4.3336400985717773e+00 1.8401800155639648e+01 2.9449998855590820e+01 9.5055303573608398e+00 -1.6344100952148438e+01 2.9449998855590820e+01 7.8296594619750977e+00 -1.0713999748229980e+01 2.5048799514770508e+01 3.8801999092102051e+00 3.1612598896026611e+00 2.9724000930786133e+01 4.2262997627258301e+00 2.6668200492858887e+00 3.8146999359130859e+01 3.8809800148010254e+00 3.1654098033905029e+00 4.1451499938964844e+01 -1.5267000198364258e+00 -4.7615299224853516e+00 3.5249900817871094e+01 -8.3708697557449341e-01 4.9267401695251465e+00 3.0807399749755859e+01 -2.4067599773406982e+00 -4.3796200752258301e+00 3.7412899017333984e+01 -2.4067599773406982e+00 -4.3796200752258301e+00 3.6807102203369141e+01 -4.6136202812194824e+00 -1.9204299449920654e+00 2.5048500061035156e+01 -4.9248199462890625e+00 8.4835904836654663e-01 2.4800001144409180e+01 -4.8660397529602051e+00 1.1375000476837158e+00 2.5794099807739258e+01 -4.7648100852966309e+00 1.5131800174713135e+00 3.6961601257324219e+01 4.2035498619079590e+00 -2.7138500213623047e+00 4.1700000762939453e+01 4.4363698959350586e+00 -2.3252601623535156e+00 2.5297100067138672e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.0038499832153320e+01 4.6136202812194824e+00 1.9204299449920654e+00 3.5120800018310547e+01 3.0078499317169189e+00 -3.9932601451873779e+00 4.1700099945068359e+01 3.1686899662017822e+00 -3.8774399757385254e+00 3.1650100708007812e+01 -1.6383399963378906e+00 -4.7211599349975586e+00 3.9070098876953125e+01 3.1667201519012451e+00 3.8768999576568604e+00 4.1700000762939453e+01 3.0313599109649658e+00 3.9810700416564941e+00 4.0736900329589844e+01 2.4746601581573486e+00 4.3486800193786621e+00 3.0236600875854492e+01 4.7997798919677734e+00 1.3912599086761475e+00 3.4741199493408203e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.1912200927734375e+01 2.0574100017547607e+00 -4.5562601089477539e+00 4.1700000762939453e+01 2.0206000804901123e+00 -4.5724501609802246e+00 3.5587699890136719e+01 -1.9007399082183838e+00 -4.6217598915100098e+00 4.0705902099609375e+01 -2.1571500301361084e+00 -4.5078001022338867e+00 3.6748802185058594e+01 -3.6158800125122070e+00 -3.4654498100280762e+00 3.3250000000000000e+01 4.4985599517822266e+00 2.1763498783111572e+00 3.4513099670410156e+01 2.3838200569152832e+00 4.3947401046752930e+00 4.1700000762939453e+01 2.0182600021362305e+00 4.5777096748352051e+00 4.1700000762939453e+01 4.9939398765563965e+00 -2.3858800530433655e-01 2.6950099945068359e+01 -6.2554597854614258e-01 -1.3902099609375000e+01 4.1700000762939453e+01 6.8182497024536133e+00 9.0122699737548828e+00 2.9449998855590820e+01 -5.0816497802734375e+00 1.2220200538635254e+01 2.9449998855590820e+01 -3.7489798069000244e+00 1.2702899932861328e+01 2.4800001144409180e+01 3.3998799324035645e+00 3.6651298999786377e+00 2.4800001144409180e+01 3.9777402877807617e+00 3.0276300907135010e+00 4.1700000762939453e+01 -1.2797200202941895e+01 -3.4067099094390869e+00 2.9449998855590820e+01 1.6111200332641602e+01 -9.8928604125976562e+00 2.9449998855590820e+01 1.5145599365234375e+01 -1.1308600425720215e+01 2.4800001144409180e+01 1.5501599311828613e+01 -1.0832400321960449e+01 2.4800001144409180e+01 1.8899999618530273e+01 1.5631900288082257e-11 2.9449998855590820e+01 1.8887401580810547e+01 9.1989201307296753e-01 2.9449998855590820e+01 1.8866199493408203e+01 -1.2389400005340576e+00 2.4800001144409180e+01 1.3872900009155273e+01 -1.2846400260925293e+01 2.6858299255371094e+01 1.4819600105285645e+01 -1.1737200736999512e+01 2.4800001144409180e+01 -1.0743399858474731e+00 1.8871101379394531e+01 2.9449998855590820e+01 7.8572101593017578e+00 -1.7191499710083008e+01 4.1700000762939453e+01 -1.2775400161743164e+01 3.4847400188446045e+00 2.9449998855590820e+01 -1.2358600616455078e+01 4.7548999786376953e+00 2.9449998855590820e+01 -1.2941699981689453e+01 2.8194899559020996e+00 4.1700000762939453e+01 1.2358300209045410e+01 -4.7434897422790527e+00 2.8943300247192383e+01 -8.4296703338623047e-01 -1.4008899688720703e+01 2.8950000762939453e+01 -1.3283500671386719e+00 -1.4550900459289551e+01 2.4800001144409180e+01 -2.1010298728942871e+00 4.5441198348999023e+00 2.9449998855590820e+01 2.0250000953674316e+00 -1.5300000190734863e+01 2.8950000762939453e+01 1.5249999761581421e+00 -1.5300000190734863e+01 2.4800001144409180e+01 1.6667301177978516e+01 -8.9205904006958008e+00 2.4800001144409180e+01 3.0401298999786377e+00 -3.9712200164794922e+00 2.4800001144409180e+01 3.5477199554443359e+00 -3.5183198451995850e+00 2.4800001144409180e+01 2.9181900024414062e+00 -5.5421199798583984e+00 2.9449998855590820e+01 2.2433400154113770e+00 1.3056299209594727e+01 2.4800001144409180e+01 -1.3477499485015869e+00 -8.0606098175048828e+00 2.4800001144409180e+01 -2.4538598060607910e+00 -4.3522100448608398e+00 2.4800001144409180e+01 5.9878001213073730e+00 3.3621299266815186e+00 4.1700099945068359e+01 -2.8946800231933594e+00 -4.0769495964050293e+00 4.1700000762939453e+01 -2.1914999485015869e+00 -4.4933600425720215e+00 2.9449998855590820e+01 -1.8301500320434570e+01 4.7207698822021484e+00 2.9449998855590820e+01 -1.8650999069213867e+01 3.0929598808288574e+00 4.1700000762939453e+01 -1.2297100067138672e+01 -4.9172501564025879e+00 4.0615600585937500e+01 -1.2106699943542480e+01 -5.3535900115966797e+00 2.9449998855590820e+01 1.4747099876403809e+01 1.1842700004577637e+01 2.4800100326538086e+01 1.4372400283813477e+01 1.2304400444030762e+01 2.9449998855590820e+01 -1.1683199882507324e+01 6.2337899208068848e+00 2.9449998855590820e+01 -1.6836900711059570e+01 8.6031103134155273e+00 4.1699901580810547e+01 -9.9462699890136719e+00 8.7587499618530273e+00 2.4800001144409180e+01 1.6276798248291016e+01 9.6195201873779297e+00 2.6950000762939453e+01 -1.5249999761581421e+00 -1.8838399887084961e+01 2.4800001144409180e+01 1.5195799479839067e-11 -1.8899999618530273e+01 2.6950000762939453e+01 -5.2957600327543930e-13 -1.8899999618530273e+01 2.4800001144409180e+01 4.4624700546264648e+00 -2.3056600093841553e+00 4.1700000762939453e+01 1.0825200080871582e+01 -7.6326203346252441e+00 4.1700000762939453e+01 1.1791600227355957e+01 -6.0317301750183105e+00 4.1700000762939453e+01 8.8994798660278320e+00 -6.7522101402282715e+00 2.4992198944091797e+01 4.2495203018188477e+00 -2.6554801464080811e+00 2.6950000762939453e+01 1.5249999761581421e+00 -1.8838399887084961e+01 2.9449998855590820e+01 2.0250000953674316e+00 -1.8791200637817383e+01 2.9449998855590820e+01 1.8390199661254883e+01 4.3643698692321777e+00 2.9449998855590820e+01 1.2689099311828613e+01 3.7930700778961182e+00 2.4800100326538086e+01 -3.2428801059722900e+00 -3.8084399700164795e+00 2.5642499923706055e+01 -2.7681601047515869e+00 -4.1631898880004883e+00 2.4800001144409180e+01 -1.6275199890136719e+01 9.6231803894042969e+00 2.4800001144409180e+01 -1.5456299781799316e+01 1.0881600379943848e+01 2.9449998855590820e+01 1.0138599872589111e+00 -1.3547200202941895e+01 2.9449998855590820e+01 1.8589400053024292e+00 -1.4446499824523926e+01 4.1700000762939453e+01 -1.1405799865722656e+01 -6.7373299598693848e+00 2.4800001144409180e+01 1.0179300308227539e+01 -1.5931799888610840e+01 2.9449998855590820e+01 1.4185699462890625e+01 -1.2493100166320801e+01 2.9449899673461914e+01 -1.0493899345397949e+01 1.5739500045776367e+01 2.9449998855590820e+01 -8.8438701629638672e+00 1.6708898544311523e+01 2.9449998855590820e+01 3.3471400737762451e+00 -1.2829800605773926e+01 2.9449699401855469e+01 -1.0802299976348877e+00 -1.3560500144958496e+01 2.9449998855590820e+01 1.8634500503540039e+01 3.1860501766204834e+00 2.4800001144409180e+01 4.9210400581359863e+00 -9.0871900320053101e-01 2.5179199218750000e+01 4.8703203201293945e+00 -1.1570299863815308e+00 4.1700000762939453e+01 1.1110500097274780e+00 4.8738498687744141e+00 4.1700000762939453e+01 2.2204498608985757e-15 5.0000000000000000e+00 2.9449998855590820e+01 -2.0250000953674316e+00 -1.8791200637817383e+01 2.9449998855590820e+01 -2.0250000953674316e+00 -1.5300000190734863e+01 2.4800001144409180e+01 -7.0885000228881836e+00 -1.7525199890136719e+01 2.4800001144409180e+01 -4.9320502281188965e+00 -1.8249200820922852e+01 2.9449998855590820e+01 2.9568200111389160e+00 -1.8670000076293945e+01 2.8037199020385742e+01 3.7343701720237732e-01 -1.3814900398254395e+01 2.6950099945068359e+01 5.4151099920272827e-01 -1.3856599807739258e+01 2.8017700195312500e+01 1.1112500429153442e+00 -1.4212800025939941e+01 4.1700000762939453e+01 1.2739599227905273e+01 3.6081001758575439e+00 4.1700000762939453e+01 1.0911499977111816e+01 7.5164599418640137e+00 4.1699802398681641e+01 3.7404100894927979e+00 3.3201501369476318e+00 4.1700000762939453e+01 -4.8871197700500488e+00 1.0520899295806885e+00 4.1700000762939453e+01 -4.5000700950622559e+00 2.1826899051666260e+00 2.8952899932861328e+01 1.3881899118423462e+00 -1.4642200469970703e+01 2.8916898727416992e+01 8.2251203060150146e-01 -1.3990099906921387e+01 2.4800001144409180e+01 -1.2620900869369507e+00 -1.7424499511718750e+01 2.4800001144409180e+01 -1.6897899627685547e+01 -8.4848995208740234e+00 2.4800001144409180e+01 -1.7877399444580078e+01 -6.1482095718383789e+00 3.1898599624633789e+01 -4.7141299247741699e+00 -1.6584600210189819e+00 3.2915996551513672e+01 -1.3707801103591919e+00 -4.8056702613830566e+00 4.1700000762939453e+01 -4.8921098709106445e+00 -1.0340999364852905e+00 4.1451499938964844e+01 -4.9257502555847168e+00 -8.4289097785949707e-01 2.5048500061035156e+01 -4.9892797470092773e+00 -2.8384402394294739e-01 2.9522100448608398e+01 -4.9651103019714355e+00 -5.6676900386810303e-01 2.4800001144409180e+01 4.9963698387145996e+00 -1.8702000379562378e-02 3.4834400177001953e+01 -2.6487700939178467e+00 -4.2376298904418945e+00 2.4799900054931641e+01 4.8941898345947266e+00 1.0495899915695190e+00 2.4800001144409180e+01 2.5379199981689453e+00 4.3056302070617676e+00 3.1059799194335938e+01 1.9007399082183838e+00 4.6217598915100098e+00 4.1700000762939453e+01 4.8502702713012695e+00 -1.2260400056838989e+00 3.7350700378417969e+01 4.2262997627258301e+00 2.6668200492858887e+00 3.2255897521972656e+01 4.3693199157714844e+00 2.4254100322723389e+00 4.1700000762939453e+01 4.3661198616027832e+00 2.4433100223541260e+00 2.4800001144409180e+01 1.1244099140167236e+00 -4.8914198875427246e+00 3.7043003082275391e+01 7.6922196149826050e-01 -4.9447102546691895e+00 3.1742300033569336e+01 1.3837099075317383e+00 -4.8019599914550781e+00 3.6150501251220703e+01 3.6216299533843994e+00 -3.4574899673461914e+00 4.1700000762939453e+01 3.8508801460266113e+00 -3.1995701789855957e+00 4.1700000762939453e+01 9.6837406158447266e+00 9.0545501708984375e+00 3.8337200164794922e+01 1.0182400703430176e+01 8.4795398712158203e+00 2.9449998855590820e+01 9.8481197357177734e+00 8.8664398193359375e+00 4.1010200500488281e+01 1.1318900108337402e+01 6.8856997489929199e+00 2.9449998855590820e+01 1.0594799995422363e+01 7.9537796974182129e+00 4.1700000762939453e+01 7.4504399299621582e+00 -1.0962599754333496e+01 3.5348602294921875e+01 7.7396798133850098e+00 -1.0753099441528320e+01 4.1700000762939453e+01 -9.0503005981445312e+00 -9.6821193695068359e+00 3.8730201721191406e+01 1.0206299781799316e+01 -8.4540300369262695e+00 2.9449998855590820e+01 1.0812399864196777e+01 -7.6491103172302246e+00 3.3401500701904297e+01 -1.1174599647521973e+01 7.1107802391052246e+00 4.1700000762939453e+01 -1.0885399818420410e+01 7.5579400062561035e+00 2.9449998855590820e+01 -1.0344099998474121e+01 8.2848396301269531e+00 3.3956699371337891e+01 9.3241205215454102e+00 9.4183301925659180e+00 2.9449998855590820e+01 -1.5550900459289551e+01 1.0775700569152832e+01 2.9449998855590820e+01 -1.7864900588989258e+01 -6.1986598968505859e+00 2.6538801193237305e+01 -1.7346000671386719e+01 -7.5152401924133301e+00 2.4800001144409180e+01 -8.6485795974731445e+00 -1.6812601089477539e+01 2.4800001144409180e+01 -9.9439496994018555e+00 -1.6074298858642578e+01 2.9449998855590820e+01 -1.0854700088500977e+01 -1.5472799301147461e+01 2.4800100326538086e+01 -1.1520800590515137e+01 -1.5003800392150879e+01 4.1700000762939453e+01 3.5527100789104751e-15 -5.0000000000000000e+00 3.4021602630615234e+01 -4.3147701944690198e-05 -5.0023598670959473e+00 3.6430900573730469e+01 -5.5283904075622559e-01 -4.9666800498962402e+00 2.4800001144409180e+01 -1.8822700500488281e+01 -1.9479199647903442e+00 2.4800001144409180e+01 -1.8387399673461914e+01 -4.3816800117492676e+00 2.7193000793457031e+01 -1.8585498809814453e+01 -3.4506700038909912e+00 2.4800001144409180e+01 1.7719398498535156e+01 6.5778098106384277e+00 4.1700000762939453e+01 3.2244198322296143e+00 1.2841400146484375e+01 4.1700000762939453e+01 2.2679700851440430e+00 1.3052400588989258e+01 2.4800001144409180e+01 -1.7905599594116211e+01 6.0784401893615723e+00 2.4800001144409180e+01 -1.8639799118041992e+01 3.2260699272155762e+00 2.9449998855590820e+01 -1.1473399162292480e+01 -6.6046400070190430e+00 2.4800498962402344e+01 -4.5277299880981445e+00 2.1901500225067139e+00 2.9449998855590820e+01 -7.0489597320556641e+00 -1.1210200309753418e+01 4.1700000762939453e+01 -1.3220399856567383e+01 -9.0833395719528198e-01 2.9449998855590820e+01 -1.3094499588012695e+01 -1.9941999912261963e+00 3.3010898590087891e+01 -1.3072700500488281e+01 -2.1210699081420898e+00 4.1079200744628906e+01 -7.6970500946044922e+00 1.0781199455261230e+01 4.0135498046875000e+01 1.3164400100708008e+01 -1.4988400936126709e+00 4.1700000762939453e+01 -9.8609600067138672e+00 -8.8514099121093750e+00 4.1700000762939453e+01 3.5527100789104751e-15 -1.3250000000000000e+01 4.1700000762939453e+01 -8.7294702529907227e+00 9.9829206466674805e+00 4.1700000762939453e+01 3.5527100789104751e-15 1.3250000000000000e+01 3.3017799377441406e+01 1.1722599983215332e+01 6.1502499580383301e+00 2.9449998855590820e+01 -4.0375900268554688e-01 -1.3321100234985352e+01 2.9449998855590820e+01 1.1093700408935547e+01 -1.5308099746704102e+01 2.4800001144409180e+01 1.1934000015258789e+01 -1.4662099838256836e+01 2.8950000762939453e+01 -1.5249999761581421e+00 -1.5300000190734863e+01 2.4800001144409180e+01 -1.0443900108337402e+01 1.5761099815368652e+01 2.4800001144409180e+01 -1.1309200286865234e+01 1.3782600402832031e+01 2.4800001144409180e+01 9.7973696887493134e-02 8.2902097702026367e+00 4.1700000762939453e+01 -7.9593696594238281e+00 -1.0588300704956055e+01 2.5110601425170898e+01 -3.3533899784088135e+00 -3.7071900367736816e+00 3.6480899810791016e+01 4.4985599517822266e+00 2.1763498783111572e+00 4.1700000762939453e+01 4.6284899711608887e+00 1.8853900432586670e+00 2.8218200683593750e+01 -3.0356299877166748e+00 -3.9726901054382324e+00 3.3556800842285156e+01 1.5057100057601929e+00 4.7671899795532227e+00 3.5859600067138672e+01 1.6510500907897949e+00 -4.7167301177978516e+00 3.4290702819824219e+01 -4.9254698753356934e+00 -8.4455001354217529e-01 3.8764202117919922e+01 -1.7710200548171997e+00 -4.6752796173095703e+00 3.5510997772216797e+01 -1.5185400247573853e+00 4.7631196975708008e+00 4.1223197937011719e+01 -2.2106401920318604e+00 4.4923200607299805e+00 3.6527599334716797e+01 -4.7948203086853027e+00 1.4180999994277954e+00 4.1176799774169922e+01 -4.9679498672485352e+00 5.9715402126312256e-01 2.5105699539184570e+01 -4.9928598403930664e+00 2.7264899015426636e-01 3.4426399230957031e+01 -5.0038399696350098e+00 -6.0524802654981613e-02 4.1700000762939453e+01 -5.0000000000000000e+00 -3.5527100789104751e-15 3.8484600067138672e+01 4.7141299247741699e+00 1.6584600210189819e+00 3.4477100372314453e+01 4.6136202812194824e+00 1.9204299449920654e+00 4.1258998870849609e+01 -4.1352801322937012e+00 2.8180201053619385e+00 3.6688598632812500e+01 -3.9966697692871094e+00 3.0033500194549561e+00 2.9449998855590820e+01 -1.7697200775146484e+01 6.6598796844482422e+00 4.1700000762939453e+01 -6.8491501808166504e+00 1.1335199356079102e+01 2.4800001144409180e+01 -1.8899999618530273e+01 -1.5579399992304843e-09 2.9449998855590820e+01 -1.8386600494384766e+01 -4.3971800804138184e+00 2.9449998855590820e+01 -1.2079899787902832e+01 1.4545300483703613e+01 2.9606899261474609e+01 -5.5283904075622559e-01 -4.9666800498962402e+00 2.9449998855590820e+01 7.4122099876403809e+00 1.7391498565673828e+01 2.9449998855590820e+01 -1.2001500129699707e+01 -1.4610500335693359e+01 2.4800001144409180e+01 -1.7215700149536133e+01 7.8101801872253418e+00 4.0674797058105469e+01 -5.5952596664428711e-01 4.9659299850463867e+00 2.6950000762939453e+01 1.2915600538253784e+00 -1.4445000648498535e+01 2.8275600433349609e+01 -4.1702300310134888e-01 -1.3823400497436523e+01 4.1424098968505859e+01 4.6972999572753906e+00 -1.2373300552368164e+01 2.9449998855590820e+01 7.7934700250625610e-01 -1.3431300163269043e+01 2.4800001144409180e+01 -3.3469099998474121e+00 3.7231998443603516e+00 4.1700000762939453e+01 8.6985101699829102e+00 9.9949102401733398e+00 2.4800001144409180e+01 1.7519800662994385e+00 4.6830697059631348e+00 2.4800001144409180e+01 7.7306900024414062e+00 -3.6552900075912476e-01 2.4800001144409180e+01 1.3829299926757812e+01 -6.4051799774169922e+00 2.9449998855590820e+01 1.8633899688720703e+01 -3.1787199974060059e+00 2.8950000762939453e+01 -1.5249999761581421e+00 -1.8838399887084961e+01 4.1700000762939453e+01 7.7042098045349121e+00 1.0777099609375000e+01 2.9449998855590820e+01 8.7703905105590820e+00 9.9334201812744141e+00 2.4800001144409180e+01 -4.9205904006958008e+00 1.6132799148559570e+01 2.4800001144409180e+01 -5.0075902938842773e+00 1.8233800888061523e+01 4.1700000762939453e+01 -5.6207799911499023e+00 1.1992399215698242e+01 2.9449998855590820e+01 -6.5312399864196777e+00 1.1527700424194336e+01 2.9449998855590820e+01 1.4903900146484375e+01 -1.0531800270080566e+01 2.9449998855590820e+01 -4.5353097915649414e+00 -1.2442899703979492e+01 2.4800001144409180e+01 -9.2650198936462402e-01 1.5960400581359863e+01 4.1700000762939453e+01 2.5249499082565308e-01 -1.0592100143432617e+01 2.4800001144409180e+01 1.8136398693968658e-06 -4.9986000061035156e+00 2.4800001144409180e+01 -1.4857399940490723e+01 -1.1700200080871582e+01 3.5677001953125000e+01 -2.5360400676727295e+00 -1.3000300407409668e+01 2.9449998855590820e+01 4.9950399398803711e+00 1.2256999969482422e+01 3.6311599731445312e+01 1.2555100440979004e+01 -4.1896400451660156e+00 2.9449998855590820e+01 -1.2246999740600586e+01 -5.0621500015258789e+00 4.1165401458740234e+01 1.2685899734497070e+01 -3.7877101898193359e+00 2.9450099945068359e+01 3.6273798942565918e+00 1.2736200332641602e+01 3.3152999877929688e+01 -1.2918499708175659e+00 -1.3188100814819336e+01 4.1700000762939453e+01 -1.3868299722671509e+00 -1.3184299468994141e+01 2.9449998855590820e+01 -7.9923000335693359e+00 -1.0569299697875977e+01 4.1182701110839844e+01 -8.4638795852661133e+00 -1.0191899299621582e+01 4.1700000762939453e+01 -3.5744600296020508e+00 1.2749499320983887e+01 2.4800001144409180e+01 1.5480299949645996e+01 1.0846799850463867e+01 2.8154001235961914e+01 3.1742300987243652e+00 3.8707301616668701e+00 3.5253799438476562e+01 4.7997798919677734e+00 1.3912599086761475e+00 4.1451499938964844e+01 4.7997798919677734e+00 1.3912599086761475e+00 2.4800001144409180e+01 2.2216498851776123e+00 -4.4787802696228027e+00 2.5370800018310547e+01 1.8058999776840210e+00 -4.6614503860473633e+00 3.1703498840332031e+01 -3.6103398799896240e+00 3.4666299819946289e+00 2.5545600891113281e+01 4.9625401496887207e+00 -6.2990200519561768e-01 4.1699802398681641e+01 -3.5861799716949463e+00 3.4918401241302490e+00 2.9449998855590820e+01 -4.7791500091552734e+00 1.8292701721191406e+01 2.4800001144409180e+01 -1.2024999618530273e+01 1.4586599349975586e+01 2.4800001144409180e+01 1.8845800399780273e+01 -1.5313301086425781e+00 2.4800001144409180e+01 -1.6155099868774414e+01 -9.8147907257080078e+00 2.7458200454711914e+01 -1.5312899589538574e+01 -1.1099900245666504e+01 2.6681098937988281e+01 -1.8815999984741211e+01 1.8006500005722046e+00 2.4800001144409180e+01 1.2838600158691406e+01 1.3878400802612305e+01 2.7960899353027344e+01 1.4763799905776978e+00 -1.4887000083923340e+01 3.0511400222778320e+01 -1.2600000381469727e+01 -4.0787100791931152e+00 2.4800001144409180e+01 1.8584499359130859e+01 -3.4542100429534912e+00 2.4800001144409180e+01 1.7056200027465820e+01 -4.6083002090454102e+00 3.0997098922729492e+01 6.7090201377868652e+00 -1.1416500091552734e+01 4.1700000762939453e+01 9.4161397218704224e-01 1.3219099998474121e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 2994 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.9449999332427979e+01 -1.2079900130629539e+01 1.4545300044119358e+01) (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00) (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -1.8650999292731285e+01 3.0929599888622761e+00) (float-vector 2.4800000712275505e+01 -1.8387399613857269e+01 -4.3816799297928810e+00) (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01) (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01) (float-vector 2.4800000712275505e+01 -1.4854799654890824e-11 1.8899999558925629e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 2.4800099432468414e+01 -1.1520800180733204e+01 -1.5003800392150879e+01) (float-vector 2.9449900612235069e+01 -1.4166500419378281e+01 -1.2516999617218971e+01) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 -6.8491501733660698e+00 1.1335199698805809e+01) (float-vector 4.1700001806020737e+01 2.2679700050503016e+00 1.3052400201559067e+01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01) (float-vector 4.1700001806020737e+01 -1.3126599602401257e+01 -1.7778499750420451e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 2.4800000712275505e+01 1.7883799737319350e+00 -1.8824499100446701e+01) (float-vector 2.9449999332427979e+01 -6.4647998660802841e+00 -1.7769500613212585e+01) (float-vector 4.1700098663568497e+01 -3.6179700400680304e+00 -1.2741100043058395e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.3872900046408176e+01 -1.2846400029957294e+01) (float-vector 2.9449999332427979e+01 6.4079798758029938e+00 -1.7792999744415283e+01) (float-vector 4.1700001806020737e+01 3.5595600493252277e+00 -1.2760800309479237e+01) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 2.9449999332427979e+01 1.7369400709867477e+01 -7.4808998033404350e+00) (float-vector 4.1700001806020737e+01 1.0825200006365776e+01 -7.6326201669871807e+00) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4800000712275505e+01 1.8899999558925629e+01 1.5631899867953915e-11) (float-vector 4.1700001806020737e+01 1.3217699714004993e+01 9.7401399398222566e-01) (float-vector 4.1700001806020737e+01 9.6837403252720833e+00 9.0545499697327614e+00) (float-vector 2.4800000712275505e+01 1.2838600203394890e+01 1.3878400437533855e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "r_wrist_roll_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_sensor_mount_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.400000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 4 3 2 2 5 4 6 5 2 2 1 6 3 4 7 7 0 3 0 7 6 6 1 0 6 7 4 4 5 6))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 -5.0000000000000000e+00 5.0000000000000000e+00 -5.0000000000000000e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector -4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 -4.9999998882412910e+00) (float-vector 4.9999998882412910e+00 -4.9999998882412910e+00 4.9999998882412910e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "sensor_mount_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_torso_lift_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -5.0000000000000000e+01 0.0000000000000000e+00 7.3967499999999995e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.450000 0.450000 0.450000 1.000000))
                    (list :diffuse (float-vector 0.900000 0.900000 0.900000 1.000000))))
                   (list :indices #i( 0 1 2 2 4 0 4 5 0 5 6 0 0 399 1 6 399 0 397 1 398 1 399 398 1 397 2 2 3 4 397 3 2 393 395 397 395 3 397 397 398 393 399 400 398 398 400 393 399 6 400 396 400 401 393 400 396 400 6 401 393 394 395 394 393 396 395 498 3 394 498 395 498 4 3 4 498 7 498 499 500 498 500 7 394 499 498 427 394 396 427 499 394 427 396 401 499 427 401 406 499 401 405 500 499 406 405 499 405 406 402 406 412 402 406 401 412 402 426 405 426 500 405 402 403 404 402 412 403 404 426 402 412 428 403 401 428 412 404 403 429 403 430 429 403 428 430 429 431 404 429 430 431 404 407 408 404 408 426 404 431 407 426 408 500 413 408 407 413 500 408 414 413 407 431 432 407 407 432 414 431 428 432 430 428 431 432 433 414 432 434 433 428 434 432 414 415 413 414 411 415 414 433 411 500 413 415 410 415 411 415 410 500 409 410 411 433 437 411 411 437 409 434 436 433 433 436 437 428 435 434 435 436 434 436 438 437 435 438 436 409 437 417 417 437 419 437 438 419 435 420 438 438 420 419 435 428 420 419 420 421 420 440 421 420 441 440 420 423 441 420 428 423 417 419 421 421 440 417 417 440 439 440 442 439 441 442 440 441 422 442 422 441 423 439 442 422 417 439 416 416 439 425 439 422 425 422 423 424 424 500 422 425 422 500 425 418 416 418 425 500 416 409 417 416 418 409 409 418 410 500 410 418 424 487 500 500 487 501 7 500 497 500 501 478 497 500 475 476 500 478 476 475 500 445 476 478 445 478 453 478 451 453 451 478 501 475 476 444 444 476 445 443 444 445 445 453 454 445 454 443 452 453 451 454 453 452 449 450 451 451 450 452 451 501 449 449 464 450 449 479 464 501 479 449 450 464 465 464 479 480 464 480 465 480 479 501 480 481 465 480 501 481 462 465 469 450 465 462 469 465 481 481 482 469 481 501 482 463 469 466 462 469 463 469 482 466 461 462 463 450 462 461 461 463 457 463 466 457 466 467 468 457 466 468 466 482 467 467 482 501 468 467 471 501 471 467 457 468 471 471 472 458 471 483 472 457 471 458 471 501 483 470 472 473 458 472 470 472 483 473 456 457 458 458 470 456 456 470 459 459 470 473 483 484 473 473 484 459 501 484 483 484 485 459 501 485 484 459 460 456 459 485 460 488 489 485 485 489 460 485 501 488 460 489 456 489 391 390 488 391 489 390 456 489 487 391 488 488 501 487 486 487 424 372 487 486 372 375 487 339 487 375 487 339 391 486 424 344 372 486 344 423 344 424 343 344 294 343 342 344 342 372 344 344 423 491 491 294 344 423 428 490 491 423 490 490 383 491 383 258 491 491 258 295 295 294 491 490 428 401 401 6 490 384 490 34 34 490 6 384 383 490 7 6 5 7 8 6 57 34 6 6 8 57 4 7 5 7 385 8 492 7 493 492 385 7 497 493 7 8 385 330 385 496 330 496 385 492 386 492 493 331 496 492 331 492 386 332 493 494 386 493 332 493 497 494 331 386 332 111 332 333 111 331 332 332 494 333 333 494 495 497 495 494 333 387 111 448 387 333 333 495 446 333 446 448 446 495 497 446 447 448 447 446 477 446 497 477 475 477 497 477 475 447 447 474 448 447 475 474 474 475 444 474 444 455 448 474 455 455 444 443 452 455 443 448 455 452 443 454 452 140 452 450 387 448 452 387 452 140 140 450 457 457 450 461 140 457 456 456 176 140 390 176 456 138 176 137 140 176 138 137 176 179 176 181 179 390 181 176 390 391 388 335 390 388 181 390 335 181 165 179 181 201 165 181 334 201 335 334 181 335 388 334 388 389 334 388 391 389 389 391 392 392 391 339 334 389 291 291 389 336 389 392 336 292 201 334 291 292 334 196 291 193 292 291 196 193 291 208 291 336 208 201 292 197 197 292 196 195 196 193 195 197 196 190 191 193 195 193 191 193 160 190 193 208 160 194 195 191 194 197 195 194 192 197 198 197 192 201 197 198 192 194 191 190 157 191 191 157 165 192 191 165 198 192 165 201 198 165 157 156 165 164 165 156 179 165 164 156 157 158 157 190 158 156 158 123 158 160 123 158 190 160 122 123 120 122 156 123 123 154 120 160 154 123 160 208 154 153 124 154 154 124 120 153 154 208 118 119 120 122 120 119 118 120 124 124 125 118 153 125 124 155 125 153 208 155 153 125 132 118 151 125 152 132 125 151 155 188 125 125 188 152 155 189 188 155 208 189 188 206 152 189 206 188 151 152 97 97 152 150 206 207 152 152 207 150 189 208 206 206 311 207 208 311 206 311 150 207 150 93 97 150 322 329 311 322 150 150 329 93 208 310 311 310 322 311 313 310 208 336 313 208 312 310 313 325 322 310 325 310 312 289 241 325 326 325 241 325 326 322 289 325 312 235 241 238 235 244 241 238 241 289 326 241 244 244 322 326 244 245 246 234 244 235 245 244 234 246 290 244 290 322 244 234 235 236 235 238 236 236 240 234 240 243 234 243 245 234 246 245 243 240 242 243 242 246 243 239 240 236 237 240 239 237 242 240 236 238 239 237 239 228 238 288 239 239 288 228 237 228 233 233 242 237 233 246 242 233 228 224 224 246 233 228 225 224 225 228 288 224 225 226 230 224 226 247 246 224 230 247 224 246 329 290 247 329 246 247 328 329 93 329 308 290 329 322 329 328 308 327 328 223 223 328 247 328 327 307 308 328 307 94 308 307 93 308 94 94 307 205 307 309 205 307 327 309 223 205 327 327 205 309 94 205 16 16 205 17 17 205 187 187 205 223 13 16 14 16 17 14 16 13 94 184 185 17 187 184 17 17 12 14 185 12 17 12 13 14 12 10 13 13 10 62 13 62 94 9 10 11 12 11 10 62 10 9 11 15 9 62 9 15 202 15 11 288 11 12 203 11 288 11 203 202 203 204 202 202 204 15 203 255 248 282 255 203 288 282 203 248 204 203 258 204 248 42 204 258 204 42 43 15 204 43 30 37 42 37 41 42 41 43 42 30 42 383 383 42 258 43 39 15 39 43 41 41 37 36 41 36 39 35 36 37 30 35 37 35 38 36 39 36 38 39 38 40 15 39 40 63 15 61 15 40 61 63 62 15 38 58 40 72 40 58 61 40 73 40 72 73 38 35 58 71 72 58 35 71 58 71 83 72 87 76 72 87 72 83 73 72 76 35 59 71 21 71 59 84 83 71 71 21 84 113 87 83 84 113 83 21 23 84 89 84 23 89 113 84 21 22 23 89 23 22 21 24 22 21 29 24 29 21 59 24 27 22 22 27 60 22 60 89 25 27 24 24 29 25 25 26 27 26 60 27 79 60 26 79 89 60 25 28 26 28 68 26 68 79 26 29 28 25 28 65 78 28 29 65 78 68 28 68 80 79 78 105 68 107 80 68 107 68 105 77 78 65 77 105 78 105 77 106 134 135 105 105 135 107 105 106 134 107 101 80 107 135 101 80 100 79 101 100 80 135 167 101 101 167 100 135 134 166 166 167 135 166 134 168 166 169 167 166 171 169 168 171 166 170 171 168 168 134 136 168 137 170 137 168 136 173 171 170 173 177 171 177 175 171 171 175 169 170 137 179 179 173 170 180 177 173 179 180 173 177 200 175 180 200 177 175 174 169 175 178 174 200 178 175 200 163 178 200 180 164 163 200 164 180 179 164 163 164 156 163 156 159 159 162 163 163 162 178 199 174 178 199 178 161 178 162 161 159 161 162 156 122 159 159 122 126 161 159 126 126 128 161 199 161 128 174 199 128 126 127 128 144 172 128 174 128 172 144 128 127 129 126 119 129 127 126 126 122 119 144 127 145 145 127 182 127 129 182 119 121 129 121 130 129 182 129 130 119 118 121 121 131 130 118 131 121 182 130 183 130 131 183 182 146 145 182 183 146 146 183 147 148 183 131 148 147 183 131 118 132 131 132 148 147 148 143 149 143 148 148 132 149 146 147 142 147 143 142 146 142 145 141 142 114 114 142 143 141 145 142 145 141 144 20 19 144 20 144 141 167 144 133 133 144 19 167 172 144 18 19 20 19 18 99 19 99 133 104 133 99 133 104 167 100 167 104 172 167 169 169 174 172 100 104 79 79 104 20 20 104 99 18 20 99 79 20 103 103 20 141 79 103 89 102 90 103 90 89 103 103 141 102 102 141 113 141 114 113 90 102 113 88 89 90 90 113 88 89 88 113 113 114 87 115 87 114 114 143 115 76 87 86 86 87 115 86 115 116 143 117 115 116 115 117 149 151 143 151 117 143 91 116 117 91 117 95 117 97 95 151 97 117 86 116 91 85 76 86 91 85 86 95 92 91 92 85 91 92 95 96 95 97 96 96 97 92 92 97 98 97 93 98 98 93 92 92 93 94 94 64 92 85 92 75 64 75 92 85 75 76 74 73 75 75 73 76 74 75 64 73 74 64 64 62 61 73 64 61 94 62 64 61 62 63 132 151 149 136 112 137 138 137 139 109 137 112 137 109 139 136 134 108 108 112 136 112 110 109 112 108 110 109 110 111 109 111 139 138 139 140 139 111 140 331 111 110 111 387 140 108 81 110 81 69 110 69 331 110 69 330 331 330 496 331 67 69 70 81 70 69 69 8 330 69 67 8 81 82 70 82 81 108 56 67 70 56 70 106 70 82 106 8 67 56 8 56 57 54 56 47 54 57 56 47 56 77 56 106 77 108 134 106 108 106 82 47 77 65 44 47 45 54 47 44 47 65 45 44 55 54 57 54 55 57 55 34 44 46 55 34 55 46 44 45 46 31 34 45 34 46 45 31 45 65 33 34 31 33 384 34 31 30 33 30 383 33 383 384 33 30 31 32 35 30 32 32 31 52 52 35 32 35 52 59 31 51 52 51 53 52 53 59 52 29 59 53 53 51 29 29 51 65 48 50 51 48 51 31 65 51 66 50 66 51 66 48 65 31 65 48 48 49 50 49 48 66 50 49 66 256 257 258 257 268 258 258 269 273 278 272 258 248 256 258 268 278 258 258 272 269 273 293 258 258 293 295 268 257 275 268 275 278 278 275 274 274 272 278 269 272 270 274 277 272 270 272 277 274 275 276 274 276 277 289 275 257 276 275 289 277 276 279 289 279 276 277 279 270 269 270 271 279 271 270 289 271 279 273 271 280 269 271 273 271 289 280 280 281 273 286 273 281 286 293 273 280 284 281 289 284 280 284 285 281 281 285 286 286 285 287 295 286 324 295 293 286 287 324 286 289 285 284 287 285 289 324 287 323 289 323 287 324 323 295 294 295 296 323 296 295 296 323 289 238 289 288 257 288 289 296 289 312 256 265 257 288 257 265 250 256 248 266 265 256 250 266 256 266 267 265 288 265 267 250 252 266 252 267 266 248 249 250 249 252 250 248 253 254 248 255 253 254 249 248 249 251 252 254 251 249 260 267 252 252 251 260 260 283 267 288 267 283 251 259 260 264 283 260 259 264 260 254 261 251 251 261 259 253 261 254 255 261 253 255 282 262 255 262 261 261 262 259 259 263 264 262 263 259 264 263 288 288 283 264 282 263 262 288 263 282 209 288 218 221 288 209 218 288 12 288 229 225 231 288 221 229 288 231 215 12 185 215 214 12 218 12 214 212 215 216 215 185 216 212 214 215 186 185 184 216 185 186 187 216 186 216 227 212 187 227 216 212 213 214 212 227 213 219 218 214 213 219 214 227 223 213 213 223 219 187 223 227 186 184 187 219 223 217 210 223 220 223 247 220 217 223 210 217 218 219 210 218 217 209 218 210 209 210 211 211 210 220 220 221 222 232 221 220 211 220 222 220 247 232 232 247 230 230 231 232 232 231 221 222 221 209 211 222 209 230 229 231 226 229 230 226 225 229 313 314 312 314 315 312 316 312 315 316 321 312 312 304 296 312 321 304 313 315 314 313 317 315 317 316 315 318 316 317 321 316 318 318 317 319 317 313 319 320 318 319 320 321 318 336 337 319 336 319 313 321 319 305 305 319 337 320 319 321 336 392 337 305 337 339 340 339 337 392 340 337 303 301 305 301 321 305 338 305 339 305 338 303 301 303 302 303 359 302 303 361 359 338 361 303 300 301 302 300 304 301 304 321 301 359 300 302 359 360 358 359 358 300 361 360 359 338 364 361 361 364 360 339 364 338 364 363 360 364 365 363 365 364 382 364 339 382 360 357 358 360 363 357 358 355 300 358 357 355 357 356 355 357 362 356 363 362 357 363 378 362 363 365 378 378 365 379 365 382 379 382 381 379 381 382 339 378 379 377 379 374 380 377 379 380 379 381 374 362 378 377 356 362 353 362 377 353 353 377 368 377 369 368 377 380 369 369 380 374 369 370 368 369 374 370 374 373 370 374 376 373 381 376 374 381 339 376 376 375 373 376 339 375 366 373 371 373 375 371 370 373 366 368 370 366 354 366 367 368 366 354 366 371 367 371 372 367 371 375 372 354 367 342 367 372 342 354 342 351 352 354 351 352 368 354 341 342 343 341 346 342 346 351 342 350 351 346 352 351 350 349 353 352 349 352 350 353 368 352 298 349 350 347 350 346 298 350 347 341 347 346 343 345 341 345 347 341 306 345 343 306 343 294 299 347 345 299 345 306 298 347 299 297 298 299 299 306 297 297 306 294 294 296 297 297 296 298 296 304 298 304 300 298 300 348 298 300 355 348 348 349 298 355 356 348 348 356 349 356 353 349 392 339 340))
                   (list :vertices (let ((mat (make-matrix 502 3))) (fvector-replace (array-entity mat) #f(1.1006800079345703e+02 1.4304899597167969e+02 -5.8909704589843750e+02 1.0717199707031250e+02 1.3988900756835938e+02 -5.8938098144531250e+02 1.0693299865722656e+02 1.4009300231933594e+02 -5.8959301757812500e+02 1.0659200286865234e+02 1.4034899902343750e+02 -5.8967797851562500e+02 1.1192700195312500e+02 1.4696099853515625e+02 -5.8965301513671875e+02 1.1823700714111328e+02 1.5690000915527344e+02 -5.8947900390625000e+02 1.1445099639892578e+02 1.4947399902343750e+02 -5.8218005371093750e+02 1.2428900146484375e+02 1.7772399902343750e+02 -5.8967205810546875e+02 1.2538600158691406e+02 1.9374699401855469e+02 -5.7970098876953125e+02 1.2218399810791016e+02 -2.0963500976562500e+02 -5.7821795654296875e+02 1.1065200042724609e+02 -2.3244599914550781e+02 -5.7822100830078125e+02 1.2426900482177734e+02 -2.0668699645996094e+02 -5.8957202148437500e+02 9.7840301513671875e+01 -2.4662899780273438e+02 -5.8964099121093750e+02 8.9808395385742188e+01 -2.5278898620605469e+02 -5.7822003173828125e+02 5.3770301818847656e+01 -2.6427902221679688e+02 -5.8944000244140625e+02 1.2488199615478516e+02 -1.9382398986816406e+02 -5.7880596923828125e+02 4.7353000640869141e+01 -2.6371499633789062e+02 -5.7815197753906250e+02 1.9340700149536133e+01 -2.5700100708007812e+02 -5.8910296630859375e+02 -7.8277793884277344e+01 -6.0048599243164062e+00 -4.2358499145507812e+02 -7.8956794738769531e+01 -4.5254702568054199e+00 -4.2733499145507812e+02 -6.9484504699707031e+01 -4.4919898986816406e+01 -4.2567199707031250e+02 1.2178800201416016e+02 -6.5490798950195312e+01 -4.3148101806640625e+02 1.3932398986816406e+02 -3.5427299499511719e+01 -4.2353399658203125e+02 1.1278499603271484e+02 -7.8885597229003906e+01 -4.2504199218750000e+02 1.3711898803710938e+02 -3.6195098876953125e+01 -4.3008898925781250e+02 1.3093400573730469e+02 9.4587497711181641e+00 -4.4008801269531250e+02 1.3523599243164062e+02 4.2234397888183594e+01 -4.3036599731445312e+02 1.4375599670410156e+02 3.1679898500442505e-02 -4.2939001464843750e+02 1.2245999908447266e+02 6.1104301452636719e+01 -4.3352197265625000e+02 1.2429699707031250e+02 -1.7496800422668457e+00 -4.5078997802734375e+02 1.6369000244140625e+02 -8.8696899414062500e+01 -5.7814099121093750e+02 5.0000000000000000e+01 8.8699996948242188e+01 -5.7820599365234375e+02 5.0000000000000000e+01 -8.8699996948242188e+01 -5.7817498779296875e+02 1.6392900085449219e+02 -3.7518698722124100e-02 -5.7817498779296875e+02 1.6422499084472656e+02 8.9205505371093750e+01 -5.8095300292968750e+02 1.2983900451660156e+02 -8.8711502075195312e+01 -5.0164096069335938e+02 1.4947000122070312e+02 -1.2292300415039062e+02 -5.0684100341796875e+02 1.5781900024414062e+02 -8.8741401672363281e+01 -5.0717700195312500e+02 1.3090600585937500e+02 -1.7638899230957031e+02 -5.1064700317382812e+02 1.3830200195312500e+02 -1.7024800109863281e+02 -5.1380596923828125e+02 1.1963500213623047e+02 -1.9404399108886719e+02 -5.1399896240234375e+02 1.5311199951171875e+02 -1.2960598754882812e+02 -5.1509497070312500e+02 1.6335800170898438e+02 -9.7195198059082031e+01 -5.8215496826171875e+02 1.4185200500488281e+02 -1.7051100158691406e+02 -5.8216900634765625e+02 1.4347599792480469e+02 1.4305799865722656e+02 -5.0751196289062500e+02 1.2993200683593750e+02 8.8711502075195312e+01 -5.0181103515625000e+02 1.5755599975585938e+02 8.8744094848632812e+01 -5.0680099487304688e+02 1.2501600646972656e+02 1.7240899658203125e+02 -5.0620300292968750e+02 5.0000000000000000e+01 8.8699996948242188e+01 -4.5603497314453125e+02 5.0000000000000000e+01 8.8022399902343750e+01 -4.5333001708984375e+02 5.0000000000000000e+01 8.5153900146484375e+01 -4.5111401367187500e+02 5.0000000000000000e+01 -5.8715500831604004e+00 -4.5103601074218750e+02 5.0000000000000000e+01 -8.8699996948242188e+01 -4.9086401367187500e+02 5.0005500793457031e+01 -8.7299896240234375e+01 -4.5148797607421875e+02 1.3851499938964844e+02 1.6910600280761719e+02 -5.1382299804687500e+02 1.5391198730468750e+02 1.2421199798583984e+02 -5.1293896484375000e+02 1.1988200378417969e+02 1.9430198669433594e+02 -5.1420703125000000e+02 1.4624600219726562e+02 1.6167500305175781e+02 -5.8216400146484375e+02 1.2388999938964844e+02 -1.7493299865722656e+02 -5.0500201416015625e+02 1.2397499847412109e+02 -8.8285606384277344e+01 -4.5311199951171875e+02 1.4398899841308594e+02 1.0713199615478516e+01 -4.2358801269531250e+02 1.0850500488281250e+02 -1.9819200134277344e+02 -5.0006698608398438e+02 1.0677500152587891e+02 -2.0569300842285156e+02 -5.7818298339843750e+02 1.0815799713134766e+02 -2.0063899230957031e+02 -5.7816998291015625e+02 1.0692299652099609e+02 -2.0578298950195312e+02 -4.8537100219726562e+02 1.2396000671386719e+02 8.8234794616699219e+01 -4.5268899536132812e+02 8.1708297729492188e+01 8.7226097106933594e+01 -4.5171899414062500e+02 1.1030400085449219e+02 1.9970401000976562e+02 -5.7818701171875000e+02 1.1484300231933594e+02 7.6764297485351562e+01 -4.2676498413085938e+02 1.0676200103759766e+02 2.0574400329589844e+02 -5.7817602539062500e+02 1.0740200042724609e+02 1.9757899475097656e+02 -4.5708297729492188e+02 1.1763700103759766e+02 -1.7992900085449219e+02 -4.3784399414062500e+02 1.1308900451660156e+02 -1.9076699829101562e+02 -4.3845800781250000e+02 1.0734199523925781e+02 -1.9650498962402344e+02 -4.5559100341796875e+02 1.0678199768066406e+02 -2.0578500366210938e+02 -4.5669699096679688e+02 9.9897895812988281e+01 -2.0578399658203125e+02 -4.5102899169921875e+02 9.8233001708984375e+01 -1.9718800354003906e+02 -4.4980300903320312e+02 1.1662599945068359e+02 1.8145098876953125e+02 -4.3553500366210938e+02 1.1914700317382812e+02 1.3689599609375000e+02 -4.3147299194335938e+02 1.2880801391601562e+02 5.8052902221679688e+01 -4.2358499145507812e+02 8.5575202941894531e+01 9.8413902282714844e+01 -4.2330102539062500e+02 1.0531500244140625e+02 2.0570599365234375e+02 -4.5325299072265625e+02 1.0015899658203125e+02 1.9722399902343750e+02 -4.5009698486328125e+02 1.0983300018310547e+02 -1.8112599182128906e+02 -4.2966198730468750e+02 1.1548999786376953e+02 -1.3723899841308594e+02 -4.2823202514648438e+02 2.6902099609375000e+01 -2.0570098876953125e+02 -4.5110601806640625e+02 4.3963397979736328e+01 -2.0042300415039062e+02 -4.4961801147460938e+02 7.6529006958007812e+01 -1.9454100036621094e+02 -4.3399099731445312e+02 5.6377002716064453e+01 -1.1111799621582031e+02 -4.2562100219726562e+02 8.8425796508789062e+01 -9.6909393310546875e+01 -4.2433499145507812e+02 2.3944299697875977e+01 -1.1195899963378906e+02 -4.2467599487304688e+02 -3.6510700225830078e+01 -2.0582998657226562e+02 -4.5150799560546875e+02 -3.4925098419189453e+01 -2.0578298950195312e+02 -5.5634698486328125e+02 -4.7795001983642578e+01 -2.0179598999023438e+02 -5.8084295654296875e+02 -4.2707302093505859e+01 -2.0548098754882812e+02 -5.7827697753906250e+02 -3.9251701354980469e+01 -2.0578900146484375e+02 -5.0370996093750000e+02 -3.9368801116943359e+01 -2.0577700805664062e+02 -5.3461895751953125e+02 -4.1770900726318359e+01 -2.0231799316406250e+02 -5.2377496337890625e+02 -3.9417800903320312e+01 -2.0577499389648438e+02 -5.5311199951171875e+02 -7.0925300598144531e+01 4.2115200042724609e+01 -4.2367102050781250e+02 -3.2710199356079102e+00 1.0587300109863281e+02 -4.2402200317382812e+02 3.8006801605224609e+01 1.1239099884033203e+02 -4.2497799682617188e+02 -1.9090900421142578e+01 -9.9693298339843750e+01 -4.2460699462890625e+02 -4.6280498504638672e+01 -7.8698204040527344e+01 -4.2463101196289062e+02 -3.8061698913574219e+01 8.7030204772949219e+01 -4.2476098632812500e+02 1.0912799835205078e+02 1.7892999267578125e+02 -4.2861898803710938e+02 1.1213400268554688e+02 1.8991300964355469e+02 -4.3602301025390625e+02 7.6614898681640625e+01 1.0508499908447266e+02 -4.2572299194335938e+02 3.8790199756622314e+00 2.0505300903320312e+02 -4.5128302001953125e+02 -3.9252899169921875e+01 2.0577299499511719e+02 -5.1180203247070312e+02 2.3607799530029297e+01 2.0578500366210938e+02 -5.7817700195312500e+02 -3.9929798126220703e+01 2.0577398681640625e+02 -5.7832495117187500e+02 -3.6677497863769531e+01 2.0574699401855469e+02 -4.5159399414062500e+02 1.5857299804687500e+01 -1.8783000183105469e+02 -4.2728298950195312e+02 -3.0589099884033203e+01 -1.9495100402832031e+02 -4.3184997558593750e+02 -3.3833000183105469e+01 -1.9800401306152344e+02 -4.3863800048828125e+02 -3.1367500305175781e+01 -2.0105799865722656e+02 -4.4952801513671875e+02 -4.2124500274658203e+01 -2.0029600524902344e+02 -4.5639999389648438e+02 -2.2671099853515625e+02 -1.6133900451660156e+02 -5.2923400878906250e+02 -2.2522799682617188e+02 -8.4911003112792969e+01 -4.8069198608398438e+02 -2.3634199523925781e+02 -8.4680099487304688e+01 -5.8516400146484375e+02 -2.2400199890136719e+02 -1.3433000183105469e+02 -4.9602401733398438e+02 -2.3215499877929688e+02 2.0346698760986328e+01 -5.1641705322265625e+02 -2.4046600341796875e+02 -8.7096700668334961e+00 -6.2242596435546875e+02 -2.3145199584960938e+02 -1.7117799377441406e+02 -6.3912701416015625e+02 -2.1285099792480469e+02 -1.9075199890136719e+02 -5.4467901611328125e+02 -2.2344900512695312e+02 -3.7253499031066895e+00 -4.6574700927734375e+02 -2.1221501159667969e+02 -4.8488597869873047e+01 -4.5595397949218750e+02 -2.1211099243164062e+02 1.4311200141906738e+01 -4.5481500244140625e+02 -2.1235499572753906e+02 -9.9579299926757812e+01 -4.6399798583984375e+02 -2.1238200378417969e+02 -1.4011601257324219e+02 -4.7755798339843750e+02 -2.1161599731445312e+02 -1.6786499023437500e+02 -4.9484100341796875e+02 -2.1230200195312500e+02 -1.8419000244140625e+02 -5.2119201660156250e+02 -6.5943595886230469e+01 5.6297599792480469e+01 -4.2648101806640625e+02 6.0268901824951172e+01 1.9486599731445312e+02 -4.3244900512695312e+02 6.1044399261474609e+01 1.7959500122070312e+02 -4.2708700561523438e+02 -2.7079099655151367e+01 2.0046701049804688e+02 -4.4817401123046875e+02 -4.1721298217773438e+01 2.0061399841308594e+02 -4.5572097778320312e+02 -4.3217399597167969e+01 2.0141200256347656e+02 -4.9406497192382812e+02 -4.0821998596191406e+01 2.0335800170898438e+02 -5.3042901611328125e+02 -4.4669799804687500e+01 2.0273500061035156e+02 -5.8091699218750000e+02 -6.9588600158691406e+01 -1.6151599121093750e+02 -4.2903500366210938e+02 -7.4250396728515625e+01 -1.8420599365234375e+02 -4.3584701538085938e+02 -6.6486595153808594e+01 -1.9446499633789062e+02 -4.4414599609375000e+02 -1.1209300231933594e+02 -4.7696098327636719e+01 -4.3259100341796875e+02 -1.6093099975585938e+02 -7.4441299438476562e+01 -4.4878302001953125e+02 -1.4582099914550781e+02 -1.3940000915527344e+02 -4.5558200073242188e+02 -1.4333300781250000e+02 -1.6795500183105469e+02 -4.6650500488281250e+02 -1.8003900146484375e+02 -1.7347300720214844e+02 -4.9198300170898438e+02 -1.4006399536132812e+02 -1.8779100036621094e+02 -4.9943600463867188e+02 -9.8211196899414062e+01 -1.9959600830078125e+02 -5.8217297363281250e+02 -1.4312001037597656e+02 -1.9295201110839844e+02 -5.3238299560546875e+02 -1.5305699157714844e+02 -1.9598100280761719e+02 -5.8081298828125000e+02 -2.2201600646972656e+02 -1.9565899658203125e+02 -7.8458099365234375e+02 -2.3659800720214844e+02 -1.7206600952148438e+02 -7.8458599853515625e+02 -2.1294100952148438e+02 -2.0415499877929688e+02 -7.8457000732421875e+02 -2.2690299987792969e+02 1.5514199829101562e+02 -5.2014599609375000e+02 -2.2760800170898438e+02 1.6711199951171875e+02 -5.5007800292968750e+02 -2.3844699096679688e+02 1.0259400177001953e+02 -6.5892901611328125e+02 -2.2468598937988281e+02 1.1277599334716797e+02 -4.8710198974609375e+02 -2.4293800354003906e+02 4.8534400939941406e+01 -7.8458099365234375e+02 -2.1194999694824219e+02 7.9315795898437500e+01 -4.5943298339843750e+02 -2.1271499633789062e+02 1.2352799987792969e+02 -4.7109100341796875e+02 -2.1208999633789062e+02 1.5423899841308594e+02 -4.8492800903320312e+02 -2.1175399780273438e+02 1.7772200012207031e+02 -5.0727200317382812e+02 -2.1221000671386719e+02 1.8981700134277344e+02 -5.3838000488281250e+02 -3.8815402984619141e+01 1.9121900939941406e+02 -4.3100198364257812e+02 -5.2175701141357422e+01 1.6535000610351562e+02 -4.2710900878906250e+02 -3.0996900558471680e+01 1.9801499938964844e+02 -4.3687500000000000e+02 -7.9411796569824219e+01 1.7399501037597656e+02 -4.3411801147460938e+02 -6.3735595703125000e+01 1.9413999938964844e+02 -4.4194702148437500e+02 -7.4985694885253906e+01 1.8541899108886719e+02 -4.3779998779296875e+02 -1.0114099884033203e+02 8.7586997985839844e+01 -4.3177801513671875e+02 -1.2713800048828125e+02 1.8458599853515625e+02 -4.7601101684570312e+02 -1.4963999938964844e+02 8.2502899169921875e+01 -4.4632501220703125e+02 -1.5074400329589844e+02 1.4818600463867188e+02 -4.5988299560546875e+02 -1.2495200347900391e+02 1.9781500244140625e+02 -5.8205700683593750e+02 -1.5715600585937500e+02 1.7019300842285156e+02 -4.7648400878906250e+02 -1.9303199768066406e+02 1.2953298950195312e+02 -4.7103698730468750e+02 -1.5566299438476562e+02 1.9115798950195312e+02 -5.2680700683593750e+02 -1.6698298645019531e+02 1.7983799743652344e+02 -4.9537399291992188e+02 -1.5299501037597656e+02 1.9594299316406250e+02 -5.8090002441406250e+02 -1.9414601135253906e+02 -1.0166200256347656e+02 -4.6350399780273438e+02 -1.9311599731445312e+02 -1.5333099365234375e+02 -4.8013897705078125e+02 7.1383900642395020e+00 -2.4903999328613281e+02 -5.8951995849609375e+02 6.6115303039550781e+00 -2.4773300170898438e+02 -5.8970202636718750e+02 1.8717299699783325e+00 -2.4504299926757812e+02 -5.8949700927734375e+02 5.1132397651672363e+00 -2.4867199707031250e+02 -5.8739501953125000e+02 -1.6204200744628906e+02 -1.9585899353027344e+02 -5.8504602050781250e+02 -1.6207099914550781e+02 -2.0634100341796875e+02 -7.8458398437500000e+02 -2.3633900451660156e+02 1.7303300476074219e+02 -7.8457397460937500e+02 -2.2363999938964844e+02 1.8676300048828125e+02 -6.7379101562500000e+02 -2.1329901123046875e+02 1.9574800109863281e+02 -6.3533300781250000e+02 -2.1655599975585938e+02 2.0198699951171875e+02 -7.8457598876953125e+02 -2.1323699951171875e+02 1.9859700012207031e+02 -6.8729504394531250e+02 -2.1382800292968750e+02 2.0041499328613281e+02 -7.2750402832031250e+02 -2.0946800231933594e+02 2.0467199707031250e+02 -7.8458398437500000e+02 -2.0945300292968750e+02 1.9946099853515625e+02 -6.8446795654296875e+02 -2.0874099731445312e+02 1.9386599731445312e+02 -5.7820397949218750e+02 -1.9121701049804688e+02 7.8425804138183594e+01 -4.5754299926757812e+02 -1.8896499633789062e+02 1.6255900573730469e+02 -4.8421499633789062e+02 -1.6201399230957031e+02 1.9587199401855469e+02 -5.8521002197265625e+02 1.2173899841308594e+02 -1.6484700012207031e+02 -5.8951196289062500e+02 1.0801299285888672e+02 -1.3988400268554688e+02 -5.8920404052734375e+02 1.2183100128173828e+02 -1.6317098999023438e+02 -5.8220294189453125e+02 1.0240900039672852e+01 -2.5203601074218750e+02 -5.7839898681640625e+02 -1.6110398864746094e+02 -1.6977900695800781e+02 -5.8288500976562500e+02 -1.5162100219726562e+02 -1.6996900939941406e+02 -5.7956597900390625e+02 -1.6180300903320312e+02 -1.7061500549316406e+02 -7.8458398437500000e+02 -3.8994098663330078e+01 -2.0818600463867188e+02 -5.8967498779296875e+02 -3.6528301239013672e+01 -2.1137799072265625e+02 -5.8939599609375000e+02 -4.0599903106689453e+01 -2.0729899597167969e+02 -5.8959301757812500e+02 -1.3106400489807129e+01 -2.3176998901367188e+02 -5.8951995849609375e+02 -1.8517398834228516e+01 -2.2746600341796875e+02 -5.8913702392578125e+02 -1.7332000732421875e+01 -2.2787699890136719e+02 -5.8962200927734375e+02 -7.9363799095153809e+00 -2.3557299804687500e+02 -5.8967498779296875e+02 -4.7902102470397949e+00 -2.3929400634765625e+02 -5.8944897460937500e+02 -3.0415199279785156e+01 -2.1661900329589844e+02 -5.8947601318359375e+02 -3.0366199493408203e+01 -2.1579399108886719e+02 -5.8967498779296875e+02 -2.5734300613403320e+01 -2.2087399291992188e+02 -5.8942199707031250e+02 -4.7535999298095703e+01 -2.0174899291992188e+02 -5.8934399414062500e+02 -4.8484298706054688e+01 -1.9981799316406250e+02 -5.8967498779296875e+02 -4.4050701141357422e+01 -2.0425700378417969e+02 -5.8959301757812500e+02 -2.8922698974609375e+01 -2.1880101013183594e+02 -5.8610601806640625e+02 -7.6666496276855469e+01 -1.7613800048828125e+02 -5.8928295898437500e+02 -7.3501106262207031e+01 -1.7775799560546875e+02 -5.8967498779296875e+02 -6.9931297302246094e+01 -1.8143499755859375e+02 -5.8959301757812500e+02 -1.3338500022888184e+01 -2.3203300476074219e+02 -5.8907196044921875e+02 -8.6882499694824219e+01 -1.6595899963378906e+02 -5.8967498779296875e+02 -6.4010902404785156e+01 -1.8612701416015625e+02 -5.8967498779296875e+02 -6.2235500335693359e+01 -1.8879200744628906e+02 -5.8936499023437500e+02 -5.5838600158691406e+01 -1.9333299255371094e+02 -5.8967498779296875e+02 -5.4534400939941406e+01 -1.9527799987792969e+02 -5.8950000000000000e+02 -8.4662300109863281e+01 -1.6901100158691406e+02 -5.8934899902343750e+02 -1.0291899871826172e+02 -1.5276100158691406e+02 -5.8938201904296875e+02 -1.0616400146484375e+02 -1.4948500061035156e+02 -5.8959301757812500e+02 -9.7537300109863281e+01 -1.5709300231933594e+02 -5.8959301757812500e+02 -8.9904304504394531e+01 -1.6408799743652344e+02 -5.8949798583984375e+02 -1.0110999298095703e+02 -1.5341400146484375e+02 -5.8967498779296875e+02 -9.3504104614257812e+01 -1.6040000915527344e+02 -5.8966998291015625e+02 -9.7742500305175781e+01 -1.5732499694824219e+02 -5.8938201904296875e+02 -1.0930299377441406e+02 -1.4618800354003906e+02 -5.8967498779296875e+02 -9.2705802917480469e+01 -1.6204800415039062e+02 -5.8907196044921875e+02 -1.0305800628662109e+02 -1.5291899108886719e+02 -5.8907196044921875e+02 -1.0994300079345703e+02 -1.4682800292968750e+02 -5.8925299072265625e+02 -1.0650900268554688e+02 -1.4987599182128906e+02 -5.8907196044921875e+02 -9.8135299682617188e+01 -1.5766300964355469e+02 -5.8556298828125000e+02 -5.2522701263427734e+01 -1.9807000732421875e+02 -5.8659399414062500e+02 9.0503097534179688e+01 -1.1995800018310547e+02 -5.8652001953125000e+02 8.4904403686523438e+01 -1.1430899810791016e+02 -5.8907196044921875e+02 7.8818702697753906e+01 -1.0740800476074219e+02 -5.8907196044921875e+02 8.6267700195312500e+01 -1.1617399597167969e+02 -5.8938201904296875e+02 8.0181999206542969e+01 -1.0927300262451172e+02 -5.8938201904296875e+02 9.5554298400878906e+01 -1.2638700103759766e+02 -5.8907196044921875e+02 9.0990097045898438e+01 -1.2121099853515625e+02 -5.8907196044921875e+02 9.8440902709960938e+01 -1.2997500610351562e+02 -5.8944702148437500e+02 7.1204605102539062e+01 -9.8787101745605469e+01 -5.8905902099609375e+02 6.0631099700927734e+01 -8.7163597106933594e+01 -5.8954602050781250e+02 5.3615997314453125e+01 -7.8979095458984375e+01 -5.8274603271484375e+02 8.7556396484375000e+01 -1.1810500335693359e+02 -5.8959301757812500e+02 8.2992095947265625e+01 -1.1292900085449219e+02 -5.8959301757812500e+02 9.2353401184082031e+01 -1.2307599639892578e+02 -5.8938201904296875e+02 9.3642097473144531e+01 -1.2500600433349609e+02 -5.8959301757812500e+02 9.1829399108886719e+01 -1.2354999542236328e+02 -5.8967498779296875e+02 8.3434700012207031e+01 -1.1403000640869141e+02 -5.8967498779296875e+02 6.9015197753906250e+01 -9.7102600097656250e+01 -5.8963800048828125e+02 7.4096397399902344e+01 -1.0237100219726562e+02 -5.8938201904296875e+02 7.5368202209472656e+01 -1.0444200134277344e+02 -5.8964300537109375e+02 5.3967201232910156e+01 -7.9483703613281250e+01 -5.8942199707031250e+02 3.9261798858642578e+01 -6.2547996520996094e+01 -5.8907196044921875e+02 3.7477199554443359e+01 -6.1054698944091797e+01 -5.8951995849609375e+02 3.3265697479248047e+01 -5.6426300048828125e+01 -5.8960198974609375e+02 4.3667999267578125e+01 -6.7863502502441406e+01 -5.8938201904296875e+02 2.5450599670410156e+01 -4.6075798034667969e+01 -5.8807598876953125e+02 4.6478099822998047e+01 -7.1519500732421875e+01 -5.8959301757812500e+02 5.0477401733398438e+01 -7.6654907226562500e+01 -5.8967498779296875e+02 4.3747200012207031e+01 -6.9022499084472656e+01 -5.8967498779296875e+02 4.0392398834228516e+01 -6.4617996215820312e+01 -5.8959301757812500e+02 5.0430500030517578e+01 -7.5701698303222656e+01 -5.8949798583984375e+02 3.5562702178955078e+01 -5.9740798950195312e+01 -5.8967498779296875e+02 2.6600700378417969e+01 -4.9062599182128906e+01 -5.8963604736328125e+02 1.7697200775146484e+01 -3.8626296997070312e+01 -5.8952600097656250e+02 9.8435096740722656e+01 -1.3104200744628906e+02 -5.8967498779296875e+02 7.8850097656250000e+01 -1.0883100128173828e+02 -5.8967498779296875e+02 2.1519399642944336e+01 -4.3814899444580078e+01 -5.8967498779296875e+02 1.3712500572204590e+01 -3.4961399078369141e+01 -5.8967498779296875e+02 8.7775192260742188e+00 -2.8114799499511719e+01 -5.8929998779296875e+02 8.1929197311401367e+00 -2.8692501068115234e+01 -5.8967498779296875e+02 1.2186200141906738e+01 -1.4359399414062500e+02 -5.8967498779296875e+02 -2.5599500656127930e+01 -6.2484901428222656e+01 -5.8967498779296875e+02 -1.0967399597167969e+02 -1.4655999755859375e+02 -5.8255395507812500e+02 -1.6207099914550781e+02 1.6974400329589844e+02 -7.8458398437500000e+02 -1.6207099914550781e+02 2.0636599731445312e+02 -7.8458398437500000e+02 8.1884698867797852e+00 -2.8696899414062500e+01 -5.8217498779296875e+02 2.4263101577758789e+01 -5.2926602363586426e+00 -5.8217498779296875e+02 1.9506299972534180e+01 -1.6968000411987305e+01 -5.8217498779296875e+02 1.8897499084472656e+01 -1.7689001083374023e+01 -7.7282299804687500e+02 2.4120800018310547e+01 -5.0779800415039062e+00 -7.4441400146484375e+02 2.5030899047851562e+01 -4.6453800201416016e+00 -8.4425598144531250e+02 2.4580999374389648e+01 -1.5281400680541992e+00 -8.0046801757812500e+02 2.4711999893188477e+01 -4.0302596092224121e+00 -9.8755401611328125e+02 1.9405899047851562e+01 -1.7153200149536133e+01 -1.1613299560546875e+03 2.4566499710083008e+01 -3.1836798191070557e+00 -1.1889200439453125e+03 2.5235399246215820e+01 -2.2696402072906494e+00 -1.2456699218750000e+03 1.7571001052856445e+01 -1.9207998275756836e+01 -9.8446203613281250e+02 1.8400400161743164e+01 -1.8401800155639648e+01 -1.2456699218750000e+03 2.4459001541137695e+01 0.0000000000000000e+00 -6.7665399169921875e+02 -2.2306900024414062e+01 -2.2423799133300781e+02 -5.8217498779296875e+02 -4.5322196960449219e+01 -2.0394699096679688e+02 -5.8217498779296875e+02 -3.5563099384307861e+00 -2.4076899719238281e+02 -5.8217498779296875e+02 -1.3181201171875000e+02 -1.6641398620605469e+02 -8.2149304199218750e+02 -1.3869400024414062e+02 -1.6869700622558594e+02 -5.8217901611328125e+02 -1.3012699890136719e+02 -1.6552500915527344e+02 -9.8216198730468750e+02 -1.6169700622558594e+02 -1.7066200256347656e+02 -9.5563604736328125e+02 -1.4547399902343750e+02 -1.6954800415039062e+02 -9.7762695312500000e+02 -1.4158700561523438e+02 -1.6896800231933594e+02 -1.0468800048828125e+03 -1.3365901184082031e+02 -1.6668798828125000e+02 -1.1114100341796875e+03 -1.4158700561523438e+02 -1.6896800231933594e+02 -1.1256999511718750e+03 -1.3734300231933594e+02 -1.6803399658203125e+02 -1.2017099609375000e+03 -1.6180000305175781e+02 -1.7062300109863281e+02 -1.2456799316406250e+03 -1.4013899230957031e+02 -1.6901699829101562e+02 -1.2456699218750000e+03 -1.2490200042724609e+02 -1.6175900268554688e+02 -1.2456799316406250e+03 -1.2371399688720703e+02 -1.6056799316406250e+02 -5.8217498779296875e+02 7.7916898727416992e+00 -2.9093700408935547e+01 -6.1899499511718750e+02 9.2614393234252930e+00 -2.7623899459838867e+01 -5.8993695068359375e+02 -1.0748300170898438e+02 -1.4436799621582031e+02 -6.8415197753906250e+02 -1.1185900115966797e+02 -1.4874499511718750e+02 -6.0658197021484375e+02 -1.6759901046752930e+01 -2.2779199218750000e+02 -5.8217498779296875e+02 -3.0473598480224609e+01 -2.1569999694824219e+02 -5.8217498779296875e+02 -5.1738098144531250e+01 -1.9686199951171875e+02 -5.8215399169921875e+02 1.1387900543212891e+02 2.2784899902343750e+02 -5.7838702392578125e+02 9.1386604309082031e+01 2.5099798583984375e+02 -5.7846496582031250e+02 4.6578399658203125e+01 2.6357299804687500e+02 -5.7835900878906250e+02 1.1805199623107910e+01 2.5288099670410156e+02 -5.7847100830078125e+02 -1.6204699707031250e+02 1.6974400329589844e+02 -5.8402502441406250e+02 -1.5248200988769531e+02 1.6976499938964844e+02 -5.7843395996093750e+02 -1.6207099914550781e+02 1.6977299499511719e+02 -1.0488200683593750e+03 -1.6206599426269531e+02 1.6981401062011719e+02 -1.2456699218750000e+03 2.1051698684692383e+01 1.4759400367736816e+01 -1.2456699218750000e+03 -1.2543299865722656e+02 1.6220700073242188e+02 -1.2456699218750000e+03 -1.3934899902343750e+02 1.6875000000000000e+02 -1.2456699218750000e+03 2.3909799575805664e+01 5.7298202514648438e+00 -7.0508898925781250e+02 2.2115100860595703e+01 1.2181300163269043e+01 -7.1872698974609375e+02 2.4321699142456055e+01 2.8755700588226318e+00 -6.5466400146484375e+02 2.2648099899291992e+01 1.3505999565124512e+01 -5.8215399169921875e+02 2.4321699142456055e+01 2.8755700588226318e+00 -7.3266101074218750e+02 2.3223299026489258e+01 8.5414094924926758e+00 -7.4383801269531250e+02 2.3909799575805664e+01 5.7298202514648438e+00 -7.9016699218750000e+02 2.3909799575805664e+01 5.7298202514648438e+00 -9.1250799560546875e+02 2.3223299026489258e+01 8.5414094924926758e+00 -8.9371697998046875e+02 2.3223299026489258e+01 8.5414094924926758e+00 -8.0575799560546875e+02 2.2262298583984375e+01 1.1288999557495117e+01 -7.6355999755859375e+02 2.2262298583984375e+01 1.1288999557495117e+01 -8.3795294189453125e+02 2.2262298583984375e+01 1.1288999557495117e+01 -9.1874401855468750e+02 2.1026599884033203e+01 1.3951299667358398e+01 -7.8125695800781250e+02 2.3909799575805664e+01 5.7298202514648438e+00 -9.8297204589843750e+02 2.3223299026489258e+01 8.5414094924926758e+00 -9.6244000244140625e+02 2.3223299026489258e+01 8.5414094924926758e+00 -1.0203900146484375e+03 2.3909799575805664e+01 5.7298202514648438e+00 -1.0532301025390625e+03 2.3909799575805664e+01 5.7298202514648438e+00 -1.1226899414062500e+03 2.3223299026489258e+01 8.5414094924926758e+00 -1.0969300537109375e+03 2.3223299026489258e+01 8.5414094924926758e+00 -1.1660599365234375e+03 2.2262298583984375e+01 1.1288999557495117e+01 -9.9973797607421875e+02 2.2262298583984375e+01 1.1288999557495117e+01 -1.0653400878906250e+03 1.9649000167846680e+01 1.6808099746704102e+01 -1.1356899414062500e+03 2.0333898544311523e+01 1.5267399787902832e+01 -1.0853099365234375e+03 1.9516399383544922e+01 1.6506999969482422e+01 -8.0863305664062500e+02 1.9516399383544922e+01 1.6506999969482422e+01 -7.4157098388671875e+02 2.1026599884033203e+01 1.3951299667358398e+01 -8.6221099853515625e+02 1.9516399383544922e+01 1.6506999969482422e+01 -9.1927099609375000e+02 1.9516399383544922e+01 1.6506999969482422e+01 -8.6496398925781250e+02 1.7731599807739258e+01 1.8934799194335938e+01 -7.6813604736328125e+02 1.6749799728393555e+01 2.0119100570678711e+01 -7.2450103759765625e+02 1.7731599807739258e+01 1.8934799194335938e+01 -8.3742602539062500e+02 1.7731599807739258e+01 1.8934799194335938e+01 -9.2129498291015625e+02 1.5672199249267578e+01 2.1213199615478516e+01 -7.9211096191406250e+02 1.5672199249267578e+01 2.1213199615478516e+01 -8.6771795654296875e+02 2.1026599884033203e+01 1.3951299667358398e+01 -9.6883898925781250e+02 2.1026599884033203e+01 1.3951299667358398e+01 -1.0320899658203125e+03 1.8577400207519531e+01 1.7908699035644531e+01 -1.0109000244140625e+03 1.9516399383544922e+01 1.6506999969482422e+01 -9.6669195556640625e+02 1.5672199249267578e+01 2.1213199615478516e+01 -9.5915997314453125e+02 1.7124698638916016e+01 1.9684400558471680e+01 -1.0745400390625000e+03 1.6392900085449219e+02 -2.6739099502563477e+01 -5.8217498779296875e+02 1.6392900085449219e+02 3.9394500732421875e+01 -5.8217498779296875e+02 1.2312300109863281e+02 2.0760400390625000e+02 -5.8903302001953125e+02 7.2125198364257812e+01 2.5987399291992188e+02 -5.8233099365234375e+02 2.1193799376487732e-01 2.4358099365234375e+02 -5.8221600341796875e+02 -1.4216799926757812e+02 1.6955900573730469e+02 -6.9684204101562500e+02 -1.3920700073242188e+02 1.6887899780273438e+02 -8.6274304199218750e+02 -1.3544900512695312e+02 1.6774000549316406e+02 -5.8248199462890625e+02 -1.2533499145507812e+02 1.6188700866699219e+02 -8.1295501708984375e+02 -1.3924198913574219e+02 1.6880500793457031e+02 -1.0761699218750000e+03 9.5163505554199219e+01 1.2673200988769531e+02 -5.8959301757812500e+02 9.2008598327636719e+01 1.2375400543212891e+02 -5.8967498779296875e+02 9.7264900207519531e+01 1.2971499633789062e+02 -5.8967498779296875e+02 9.0599296569824219e+01 1.2155500030517578e+02 -5.8959301757812500e+02 1.0277099609375000e+02 1.3535800170898438e+02 -5.8959301757812500e+02 9.8439094543457031e+01 1.2997700500488281e+02 -5.8938201904296875e+02 1.0318399810791016e+02 1.3498200988769531e+02 -5.8899499511718750e+02 9.4846199035644531e+01 1.2547799682617188e+02 -5.8907598876953125e+02 8.4354995727539062e+01 1.1298999786376953e+02 -5.8859997558593750e+02 7.0208900451660156e+01 9.8131599426269531e+01 -5.8949798583984375e+02 6.6592498779296875e+01 9.3653099060058594e+01 -5.8924200439453125e+02 6.1692302703857422e+01 8.8773200988769531e+01 -5.8959301757812500e+02 7.2673004150390625e+01 1.0182599639892578e+02 -5.8967498779296875e+02 7.7697395324707031e+01 1.0645400238037109e+02 -5.8951995849609375e+02 5.5606601715087891e+01 8.1871704101562500e+01 -5.8959301757812500e+02 5.8465599060058594e+01 8.5713996887207031e+01 -5.8967498779296875e+02 3.7349601745605469e+01 6.1167198181152344e+01 -5.8959301757812500e+02 3.9911602020263672e+01 6.4672698974609375e+01 -5.8967498779296875e+02 4.3435199737548828e+01 6.8068695068359375e+01 -5.8959301757812500e+02 7.1243499755859375e+01 9.8745506286621094e+01 -5.8896899414062500e+02 5.4292297363281250e+01 8.0981201171875000e+01 -5.8967498779296875e+02 4.9520896911621094e+01 7.4970199584960938e+01 -5.8959301757812500e+02 4.8218399047851562e+01 7.4093101501464844e+01 -5.8967498779296875e+02 3.1263898849487305e+01 5.4265701293945312e+01 -5.8959301757812500e+02 3.4539497375488281e+01 5.7511299133300781e+01 -5.8938201904296875e+02 3.4041900634765625e+01 5.8016098022460938e+01 -5.8967498779296875e+02 3.6219001770019531e+01 5.9097202301025391e+01 -5.8907196044921875e+02 3.4757301330566406e+01 5.7315498352050781e+01 -5.8867504882812500e+02 3.3176101684570312e+01 5.5646499633789062e+01 -5.8907196044921875e+02 2.0408699035644531e+01 4.1434001922607422e+01 -5.8948699951171875e+02 8.6873598098754883e+00 2.8197999954223633e+01 -5.8238201904296875e+02 8.6546802520751953e+00 2.8230701446533203e+01 -5.8949902343750000e+02 2.7205999374389648e+01 4.9909801483154297e+01 -5.8966400146484375e+02 6.4001396179199219e+01 9.1991897583007812e+01 -5.8967498779296875e+02 8.5566497802734375e+01 1.1644799804687500e+02 -5.8967498779296875e+02 5.6082801818847656e+01 8.0967201232910156e+01 -5.8642797851562500e+02 6.1925003051757812e+01 8.8568000793457031e+01 -5.8938201904296875e+02 5.7522399902343750e+01 8.3123901367187500e+01 -5.8886804199218750e+02 5.7360801696777344e+01 8.3391899108886719e+01 -5.8938201904296875e+02 5.2796501159667969e+01 7.8215797424316406e+01 -5.8938201904296875e+02 4.6710800170898438e+01 7.1314300537109375e+01 -5.8938201904296875e+02 4.8390300750732422e+01 7.2900199890136719e+01 -5.8907196044921875e+02 4.3884502410888672e+01 6.7666206359863281e+01 -5.8867504882812500e+02 4.3826099395751953e+01 6.7724098205566406e+01 -5.8907196044921875e+02 4.0625099182128906e+01 6.4412803649902344e+01 -5.8938201904296875e+02 3.9261798858642578e+01 6.2547996520996094e+01 -5.8907196044921875e+02 2.8453800201416016e+01 5.0609802246093750e+01 -5.8938201904296875e+02 3.0133298873901367e+01 5.2195701599121094e+01 -5.8907196044921875e+02 2.4869499206542969e+01 4.6102199554443359e+01 -5.8867504882812500e+02 2.5569099426269531e+01 4.7019599914550781e+01 -5.8907196044921875e+02 -2.0100599288940430e+01 2.2578900146484375e+02 -5.8938201904296875e+02 -1.6444700241088867e+01 2.2859899902343750e+02 -5.8959301757812500e+02 -2.5071500778198242e+01 2.2099200439453125e+02 -5.8959301757812500e+02 3.6138699054718018e+00 2.4673500061035156e+02 -5.8947998046875000e+02 -4.3670401573181152e+00 2.3924900817871094e+02 -5.8959301757812500e+02 -8.4200696945190430e+00 2.3721600341796875e+02 -5.8767401123046875e+02 -4.8956199645996094e+01 2.0019100952148438e+02 -5.8954797363281250e+02 -6.1465198516845703e+01 1.9025599670410156e+02 -5.8778399658203125e+02 -3.8262699127197266e+01 2.0969999694824219e+02 -5.8950799560546875e+02 -2.5228099822998047e+01 2.2197399902343750e+02 -5.8834204101562500e+02 -3.0411600112915039e+01 2.1661099243164062e+02 -5.8947802734375000e+02 -2.5276800155639648e+01 2.2122499084472656e+02 -5.8938201904296875e+02 -1.3199100494384766e+01 2.3187500000000000e+02 -5.8938201904296875e+02 -1.1078599548339844e+02 1.4768099975585938e+02 -5.8440899658203125e+02 -8.1961799621582031e+01 1.7186700439453125e+02 -5.8867504882812500e+02 -9.1780403137207031e+01 1.6273699951171875e+02 -5.8927001953125000e+02 -1.0511199951171875e+02 1.5090200805664062e+02 -5.8940399169921875e+02 -1.0957399749755859e+02 1.4645999145507812e+02 -5.8959899902343750e+02 -7.0308998107910156e+01 1.8186000061035156e+02 -5.8896899414062500e+02 -6.8411094665527344e+01 1.8318901062011719e+02 -5.8938201904296875e+02 -7.3587295532226562e+01 1.7862500000000000e+02 -5.8938201904296875e+02 -5.7945198059082031e+01 1.9219000244140625e+02 -5.8953900146484375e+02 -6.6480499267578125e+01 1.8447799682617188e+02 -5.8959301757812500e+02 -7.8558197021484375e+01 1.7382800292968750e+02 -5.8959301757812500e+02 -8.3123298645019531e+01 1.6927400207519531e+02 -5.8967498779296875e+02 -8.5459701538085938e+01 1.6774299621582031e+02 -5.8959301757812500e+02 -7.3381996154785156e+01 1.7839199829101562e+02 -5.8959301757812500e+02 -9.6017097473144531e+01 1.5884700012207031e+02 -5.8938201904296875e+02 -8.8647201538085938e+01 1.6467300415039062e+02 -5.8966699218750000e+02 -9.4086494445800781e+01 1.6013499450683594e+02 -5.8959301757812500e+02 -1.0098799896240234e+02 1.5404998779296875e+02 -5.8959301757812500e+02 -1.1268500328063965e+01 2.3316400146484375e+02 -5.8959301757812500e+02 -1.0149899482727051e+01 2.3362100219726562e+02 -5.8967498779296875e+02 -2.0034101486206055e+01 2.2490499877929688e+02 -5.8967498779296875e+02 2.0798799991607666e+00 2.4437300109863281e+02 -5.8967700195312500e+02 -2.9878700256347656e+01 2.1622399902343750e+02 -5.8967498779296875e+02 -5.4138500213623047e+01 1.9483200073242188e+02 -5.8967498779296875e+02 -6.2310100555419922e+01 1.8762699890136719e+02 -5.8967498779296875e+02 -6.9829399108886719e+01 1.8099600219726562e+02 -5.8967498779296875e+02 -7.7280403137207031e+01 1.7442601013183594e+02 -5.8967498779296875e+02 -9.5066200256347656e+01 1.5874299621582031e+02 -5.8967498779296875e+02 -1.0286100006103516e+02 1.5186999511718750e+02 -5.8967498779296875e+02 -1.0930299377441406e+02 1.4618800354003906e+02 -5.8967498779296875e+02 5.7206802368164062e+00 3.1164699554443359e+01 -6.0755401611328125e+02 -5.6962501525878906e+01 9.3847900390625000e+01 -5.8967498779296875e+02 -9.9997604370117188e+01 1.3688301086425781e+02 -5.8967498779296875e+02 -1.1205899810791016e+02 1.4894599914550781e+02 -5.9123303222656250e+02 7.2305099487304688e+01 1.0140900421142578e+02 -5.8217498779296875e+02 3.8717197418212891e+01 1.0950099945068359e+01 -5.8217498779296875e+02 9.7166206359863281e+01 2.4626199340820312e+02 -5.8961804199218750e+02 7.0479804992675781e+01 2.6147799682617188e+02 -5.8943896484375000e+02 3.4876903533935547e+01 2.6142401123046875e+02 -5.8955200195312500e+02 1.6978599548339844e+01 2.5554200744628906e+02 -5.8906604003906250e+02 1.1303800201416016e+02 2.2921000671386719e+02 -5.8932397460937500e+02 1.6223798751831055e+01 2.5438999938964844e+02 -5.8967205810546875e+02 9.6268493652343750e+01 1.3895001220703125e+02 -5.8967498779296875e+02 7.5900100708007812e+01 1.1289800262451172e+02 -5.8967498779296875e+02 6.4671502113342285e+00 7.0789497375488281e+01 -5.8967498779296875e+02 -5.9117500305175781e+01 1.6898399353027344e+02 -5.8967498779296875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 3000 -> 96 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4013899862766266e+02 -1.6901700198650360e+02 -1.2456699609756470e+03) (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector 5.3770300000905991e+01 -2.6427900791168213e+02 -5.8943998813629150e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1294100582599640e+02 -2.0415499806404114e+02 -7.8456997871398926e+02) (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -2.2201600670814514e+02 -1.9565899670124054e+02 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3659799993038177e+02 -1.7206600308418274e+02 -7.8458601236343384e+02) (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -2.3659799993038177e+02 -1.7206600308418274e+02 -7.8458601236343384e+02) (float-vector -2.2201600670814514e+02 -1.9565899670124054e+02 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6335800290107727e+02 -9.7195200622081757e+01 -5.8215498924255371e+02) (float-vector 2.5235399603843689e+01 -2.2696400992572308e+00 -1.2456699609756470e+03) (float-vector 1.4185200631618500e+02 -1.7051100730895996e+02 -5.8216899633407593e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5235399603843689e+01 -2.2696400992572308e+00 -1.2456699609756470e+03) (float-vector 1.6335800290107727e+02 -9.7195200622081757e+01 -5.8215498924255371e+02) (float-vector 1.6422499716281891e+02 8.9205503463745117e+01 -5.8095300197601318e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.7840301692485809e+01 -2.4662899971008301e+02 -5.8964097499847412e+02) (float-vector 1.8400400876998901e+01 -1.8401799723505974e+01 -1.2456699609756470e+03) (float-vector -1.2490200251340866e+02 -1.6175900399684906e+02 -1.2456799745559692e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4013899862766266e+02 -1.6901700198650360e+02 -1.2456699609756470e+03) (float-vector 5.3770300000905991e+01 -2.6427900791168213e+02 -5.8943998813629150e+02) (float-vector 8.9808396995067596e+01 -2.5278899073600769e+02 -5.7822000980377197e+02) (float-vector 9.7840301692485809e+01 -2.4662899971008301e+02 -5.8964097499847412e+02) (float-vector -1.2490200251340866e+02 -1.6175900399684906e+02 -1.2456799745559692e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02) (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector -2.1655599772930145e+02 2.0198699831962585e+02 -7.8457599878311157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5391199290752411e+02 1.2421199679374695e+02 -5.1293897628784180e+02) (float-vector 1.4624600112438202e+02 1.6167500615119934e+02 -5.8216398954391479e+02) (float-vector 1.6422499716281891e+02 8.9205503463745117e+01 -5.8095300197601318e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2426900118589401e+02 -2.0668700337409973e+02 -5.8957201242446899e+02) (float-vector 1.4185200631618500e+02 -1.7051100730895996e+02 -5.8216899633407593e+02) (float-vector 2.5235399603843689e+01 -2.2696400992572308e+00 -1.2456699609756470e+03) (float-vector 1.8400400876998901e+01 -1.8401799723505974e+01 -1.2456699609756470e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2363999485969543e+02 1.8676300346851349e+02 -6.7379099130630493e+02) (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02) (float-vector -2.1655599772930145e+02 2.0198699831962585e+02 -7.8457599878311157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3844699561595917e+02 1.0259400308132172e+02 -6.5892899036407471e+02) (float-vector -2.4046599864959717e+02 -8.7096700444817543e+00 -6.2242597341537476e+02) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02) (float-vector -2.3844699561595917e+02 1.0259400308132172e+02 -6.5892899036407471e+02) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3659799993038177e+02 -1.7206600308418274e+02 -7.8458601236343384e+02) (float-vector -2.4293799698352814e+02 4.8534400761127472e+01 -7.8458100557327271e+02) (float-vector -2.4046599864959717e+02 -8.7096700444817543e+00 -6.2242597341537476e+02) (float-vector -2.3634199798107147e+02 -8.4680102765560150e+01 -5.8516401052474976e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3145200312137604e+02 -1.7117799818515778e+02 -6.3912701606750488e+02) (float-vector -2.3659799993038177e+02 -1.7206600308418274e+02 -7.8458601236343384e+02) (float-vector -2.3634199798107147e+02 -8.4680102765560150e+01 -5.8516401052474976e+02) (float-vector -2.2671100497245789e+02 -1.6133899986743927e+02 -5.2923399209976196e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3145200312137604e+02 -1.7117799818515778e+02 -6.3912701606750488e+02) (float-vector -2.1285100281238556e+02 -1.9075199961662292e+02 -5.4467898607254028e+02) (float-vector -2.1294100582599640e+02 -2.0415499806404114e+02 -7.8456997871398926e+02) (float-vector -2.2201600670814514e+02 -1.9565899670124054e+02 -7.8458100557327271e+02) (float-vector -2.3659799993038177e+02 -1.7206600308418274e+02 -7.8458601236343384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4624600112438202e+02 1.6167500615119934e+02 -5.8216398954391479e+02) (float-vector 2.1051699295639992e+01 1.4759399928152561e+01 -1.2456699609756470e+03) (float-vector 2.5235399603843689e+01 -2.2696400992572308e+00 -1.2456699609756470e+03) (float-vector 1.6422499716281891e+02 8.9205503463745117e+01 -5.8095300197601318e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2760799527168274e+02 1.6711199283599854e+02 -5.5007797479629517e+02) (float-vector -2.2690300643444061e+02 1.5514199435710907e+02 -5.2014601230621338e+02) (float-vector -2.3844699561595917e+02 1.0259400308132172e+02 -6.5892899036407471e+02) (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2490200251340866e+02 -1.6175900399684906e+02 -1.2456799745559692e+03) (float-vector 1.8400400876998901e+01 -1.8401799723505974e+01 -1.2456699609756470e+03) (float-vector 2.5235399603843689e+01 -2.2696400992572308e+00 -1.2456699609756470e+03) (float-vector 2.1051699295639992e+01 1.4759399928152561e+01 -1.2456699609756470e+03) (float-vector -1.2543299794197083e+02 1.6220700740814209e+02 -1.2456699609756470e+03) (float-vector -1.3934899866580963e+02 1.6875000298023224e+02 -1.2456699609756470e+03) (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -1.4013899862766266e+02 -1.6901700198650360e+02 -1.2456699609756470e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector 3.4876901656389236e+01 2.6142400503158569e+02 -5.8955198526382446e+02) (float-vector -2.1655599772930145e+02 2.0198699831962585e+02 -7.8457599878311157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1303800344467163e+02 2.2921000421047211e+02 -5.8932399749755859e+02) (float-vector 2.1051699295639992e+01 1.4759399928152561e+01 -1.2456699609756470e+03) (float-vector 1.4624600112438202e+02 1.6167500615119934e+02 -5.8216398954391479e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1303800344467163e+02 2.2921000421047211e+02 -5.8932399749755859e+02) (float-vector 9.7166202962398529e+01 2.4626199901103973e+02 -5.8961802721023560e+02) (float-vector -1.2543299794197083e+02 1.6220700740814209e+02 -1.2456699609756470e+03) (float-vector 2.1051699295639992e+01 1.4759399928152561e+01 -1.2456699609756470e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1230199933052063e+02 -1.8419000506401062e+02 -5.2119201421737671e+02) (float-vector -2.1285100281238556e+02 -1.9075199961662292e+02 -5.4467898607254028e+02) (float-vector -2.3145200312137604e+02 -1.7117799818515778e+02 -6.3912701606750488e+02) (float-vector -2.2671100497245789e+02 -1.6133899986743927e+02 -5.2923399209976196e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2344900667667389e+02 -3.7253499031066895e+00 -4.6574699878692627e+02) (float-vector -2.3215499520301819e+02 2.0346699282526970e+01 -5.1641702651977539e+02) (float-vector -2.2468599677085876e+02 1.1277599632740021e+02 -4.8710200190544128e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2468599677085876e+02 1.1277599632740021e+02 -4.8710200190544128e+02) (float-vector -2.3215499520301819e+02 2.0346699282526970e+01 -5.1641702651977539e+02) (float-vector -2.4046599864959717e+02 -8.7096700444817543e+00 -6.2242597341537476e+02) (float-vector -2.3844699561595917e+02 1.0259400308132172e+02 -6.5892899036407471e+02) (float-vector -2.2690300643444061e+02 1.5514199435710907e+02 -5.2014601230621338e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2344900667667389e+02 -3.7253499031066895e+00 -4.6574699878692627e+02) (float-vector -2.2522799670696259e+02 -8.4911003708839417e+01 -4.8069199919700623e+02) (float-vector -2.2400200366973877e+02 -1.3433000445365906e+02 -4.9602401256561279e+02) (float-vector -2.2671100497245789e+02 -1.6133899986743927e+02 -5.2923399209976196e+02) (float-vector -2.3634199798107147e+02 -8.4680102765560150e+01 -5.8516401052474976e+02) (float-vector -2.4046599864959717e+02 -8.7096700444817543e+00 -6.2242597341537476e+02) (float-vector -2.3215499520301819e+02 2.0346699282526970e+01 -5.1641702651977539e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02) (float-vector -2.2363999485969543e+02 1.8676300346851349e+02 -6.7379099130630493e+02) (float-vector -2.1655599772930145e+02 2.0198699831962585e+02 -7.8457599878311157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2363999485969543e+02 1.8676300346851349e+02 -6.7379099130630493e+02) (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02) (float-vector -2.2760799527168274e+02 1.6711199283599854e+02 -5.5007797479629517e+02) (float-vector -2.3633900284767151e+02 1.7303299903869629e+02 -7.8457397222518921e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.7840301692485809e+01 -2.4662899971008301e+02 -5.8964097499847412e+02) (float-vector 1.1065199971199036e+02 -2.3244599997997284e+02 -5.7822102308273315e+02) (float-vector 1.2426900118589401e+02 -2.0668700337409973e+02 -5.8957201242446899e+02) (float-vector 1.8400400876998901e+01 -1.8401799723505974e+01 -1.2456699609756470e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1065199971199036e+02 -2.3244599997997284e+02 -5.7822102308273315e+02) (float-vector 1.3830199837684631e+02 -1.7024800181388855e+02 -5.1380598545074463e+02) (float-vector 1.4185200631618500e+02 -1.7051100730895996e+02 -5.8216899633407593e+02) (float-vector 1.2426900118589401e+02 -2.0668700337409973e+02 -5.8957201242446899e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5755599737167358e+02 8.8744096457958221e+01 -5.0680100917816162e+02) (float-vector 1.5391199290752411e+02 1.2421199679374695e+02 -5.1293897628784180e+02) (float-vector 1.6422499716281891e+02 8.9205503463745117e+01 -5.8095300197601318e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1238200366497040e+02 -1.4011600613594055e+02 -4.7755798697471619e+02) (float-vector -2.1161599457263947e+02 -1.6786499321460724e+02 -4.9484100937843323e+02) (float-vector -2.1230199933052063e+02 -1.8419000506401062e+02 -5.2119201421737671e+02) (float-vector -2.2671100497245789e+02 -1.6133899986743927e+02 -5.2923399209976196e+02) (float-vector -2.2400200366973877e+02 -1.3433000445365906e+02 -4.9602401256561279e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1285100281238556e+02 -1.9075199961662292e+02 -5.4467898607254028e+02) (float-vector 4.7352999448776245e+01 -2.6371499896049500e+02 -5.7815200090408325e+02) (float-vector -2.1294100582599640e+02 -2.0415499806404114e+02 -7.8456997871398926e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7352999448776245e+01 -2.6371499896049500e+02 -5.7815200090408325e+02) (float-vector 5.3770300000905991e+01 -2.6427900791168213e+02 -5.8943998813629150e+02) (float-vector -1.6179999709129333e+02 -1.7062300443649292e+02 -1.2456799745559692e+03) (float-vector -2.1294100582599640e+02 -2.0415499806404114e+02 -7.8456997871398926e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.6529003679752350e+01 -1.9454100728034973e+02 -4.3399098515510559e+02) (float-vector 9.9897898733615875e+01 -2.0578399300575256e+02 -4.5102900266647339e+02) (float-vector 4.7352999448776245e+01 -2.6371499896049500e+02 -5.7815200090408325e+02) (float-vector -3.0589099973440170e+01 -1.9495099782943726e+02 -4.3184998631477356e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7352999448776245e+01 -2.6371499896049500e+02 -5.7815200090408325e+02) (float-vector -2.1285100281238556e+02 -1.9075199961662292e+02 -5.4467898607254028e+02) (float-vector -2.1230199933052063e+02 -1.8419000506401062e+02 -5.2119201421737671e+02) (float-vector -6.6486597061157227e+01 -1.9446499645709991e+02 -4.4414600729942322e+02) (float-vector -3.0589099973440170e+01 -1.9495099782943726e+02 -4.3184998631477356e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.7166202962398529e+01 2.4626199901103973e+02 -5.8961802721023560e+02) (float-vector 9.1386601328849792e+01 2.5099799036979675e+02 -5.7846498489379883e+02) (float-vector 7.0479802787303925e+01 2.6147800683975220e+02 -5.8943897485733032e+02) (float-vector -1.3934899866580963e+02 1.6875000298023224e+02 -1.2456699609756470e+03) (float-vector -1.2543299794197083e+02 1.6220700740814209e+02 -1.2456699609756470e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3851499557495117e+02 1.6910600662231445e+02 -5.1382297277450562e+02) (float-vector 1.1303800344467163e+02 2.2921000421047211e+02 -5.8932399749755859e+02) (float-vector 1.4624600112438202e+02 1.6167500615119934e+02 -5.8216398954391479e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5391199290752411e+02 1.2421199679374695e+02 -5.1293897628784180e+02) (float-vector 1.3851499557495117e+02 1.6910600662231445e+02 -5.1382297277450562e+02) (float-vector 1.4624600112438202e+02 1.6167500615119934e+02 -5.8216398954391479e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8277796506881714e+01 -6.0048601590096951e+00 -4.2358499765396118e+02) (float-vector -1.0114099830389023e+02 8.7586998939514160e+01 -4.3177801370620728e+02) (float-vector -5.2175700664520264e+01 1.6535000503063202e+02 -4.2710900306701660e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1211099624633789e+02 1.4311200007796288e+01 -4.5481500029563904e+02) (float-vector -1.0114099830389023e+02 8.7586998939514160e+01 -4.3177801370620728e+02) (float-vector -7.8277796506881714e+01 -6.0048601590096951e+00 -4.2358499765396118e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1271499991416931e+02 1.2352800369262695e+02 -4.7109100222587585e+02) (float-vector -2.1195000410079956e+02 7.9315796494483948e+01 -4.5943298935890198e+02) (float-vector -2.1211099624633789e+02 1.4311200007796288e+01 -4.5481500029563904e+02) (float-vector -2.2344900667667389e+02 -3.7253499031066895e+00 -4.6574699878692627e+02) (float-vector -2.2468599677085876e+02 1.1277599632740021e+02 -4.8710200190544128e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0678199678659439e+02 -2.0578500628471375e+02 -4.5669698715209961e+02) (float-vector 1.1308900266885757e+02 -1.9076700508594513e+02 -4.3845799565315247e+02) (float-vector 1.1763700097799301e+02 -1.7992900311946869e+02 -4.3784400820732117e+02) (float-vector 1.3830199837684631e+02 -1.7024800181388855e+02 -5.1380598545074463e+02) (float-vector 1.1065199971199036e+02 -2.3244599997997284e+02 -5.7822102308273315e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7352999448776245e+01 -2.6371499896049500e+02 -5.7815200090408325e+02) (float-vector 9.9897898733615875e+01 -2.0578399300575256e+02 -4.5102900266647339e+02) (float-vector 1.0678199678659439e+02 -2.0578500628471375e+02 -4.5669698715209961e+02) (float-vector 8.9808396995067596e+01 -2.5278899073600769e+02 -5.7822000980377197e+02) (float-vector 5.3770300000905991e+01 -2.6427900791168213e+02 -5.8943998813629150e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9808396995067596e+01 -2.5278899073600769e+02 -5.7822000980377197e+02) (float-vector 1.0678199678659439e+02 -2.0578500628471375e+02 -4.5669698715209961e+02) (float-vector 1.1065199971199036e+02 -2.3244599997997284e+02 -5.7822102308273315e+02) (float-vector 9.7840301692485809e+01 -2.4662899971008301e+02 -5.8964097499847412e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5857299789786339e+01 -1.8783000111579895e+02 -4.2728298902511597e+02) (float-vector 7.6529003679752350e+01 -1.9454100728034973e+02 -4.3399098515510559e+02) (float-vector -3.0589099973440170e+01 -1.9495099782943726e+02 -4.3184998631477356e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5755599737167358e+02 8.8744096457958221e+01 -5.0680100917816162e+02) (float-vector 1.5781900286674500e+02 -8.8741399347782135e+01 -5.0717699527740479e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5781900286674500e+02 -8.8741399347782135e+01 -5.0717699527740479e+02) (float-vector 1.5755599737167358e+02 8.8744096457958221e+01 -5.0680100917816162e+02) (float-vector 1.6422499716281891e+02 8.9205503463745117e+01 -5.8095300197601318e+02) (float-vector 1.6335800290107727e+02 -9.7195200622081757e+01 -5.8215498924255371e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2175700664520264e+01 1.6535000503063202e+02 -4.2710900306701660e+02) (float-vector 6.1044398695230484e+01 1.7959499359130859e+02 -4.2708700895309448e+02) (float-vector 8.5575200617313385e+01 9.8413899540901184e+01 -4.2330101132392883e+02) (float-vector -7.8277796506881714e+01 -6.0048601590096951e+00 -4.2358499765396118e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02) (float-vector -2.1175399422645569e+02 1.7772200703620911e+02 -5.0727200508117676e+02) (float-vector -2.2690300643444061e+02 1.5514199435710907e+02 -5.2014601230621338e+02) (float-vector -2.2760799527168274e+02 1.6711199283599854e+02 -5.5007797479629517e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1175399422645569e+02 1.7772200703620911e+02 -5.0727200508117676e+02) (float-vector -2.1209000051021576e+02 1.5423899888992310e+02 -4.8492801189422607e+02) (float-vector -2.1271499991416931e+02 1.2352800369262695e+02 -4.7109100222587585e+02) (float-vector -2.2468599677085876e+02 1.1277599632740021e+02 -4.8710200190544128e+02) (float-vector -2.2690300643444061e+02 1.5514199435710907e+02 -5.2014601230621338e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5857299789786339e+01 -1.8783000111579895e+02 -4.2728298902511597e+02) (float-vector 1.0983300209045410e+02 -1.8112599849700928e+02 -4.2966198921203613e+02) (float-vector 7.6529003679752350e+01 -1.9454100728034973e+02 -4.3399098515510559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0983300209045410e+02 -1.8112599849700928e+02 -4.2966198921203613e+02) (float-vector 1.1308900266885757e+02 -1.9076700508594513e+02 -4.3845799565315247e+02) (float-vector 1.0678199678659439e+02 -2.0578500628471375e+02 -4.5669698715209961e+02) (float-vector 9.9897898733615875e+01 -2.0578399300575256e+02 -4.5102900266647339e+02) (float-vector 7.6529003679752350e+01 -1.9454100728034973e+02 -4.3399098515510559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5311199426651001e+02 -1.2960599362850189e+02 -5.1509499549865723e+02) (float-vector 1.5781900286674500e+02 -8.8741399347782135e+01 -5.0717699527740479e+02) (float-vector 1.6335800290107727e+02 -9.7195200622081757e+01 -5.8215498924255371e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1763700097799301e+02 -1.7992900311946869e+02 -4.3784400820732117e+02) (float-vector 1.5311199426651001e+02 -1.2960599362850189e+02 -5.1509499549865723e+02) (float-vector 1.3830199837684631e+02 -1.7024800181388855e+02 -5.1380598545074463e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5311199426651001e+02 -1.2960599362850189e+02 -5.1509499549865723e+02) (float-vector 1.6335800290107727e+02 -9.7195200622081757e+01 -5.8215498924255371e+02) (float-vector 1.4185200631618500e+02 -1.7051100730895996e+02 -5.8216899633407593e+02) (float-vector 1.3830199837684631e+02 -1.7024800181388855e+02 -5.1380598545074463e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1044398695230484e+01 1.7959499359130859e+02 -4.2708700895309448e+02) (float-vector 1.0912799835205078e+02 1.7892999947071075e+02 -4.2861899733543396e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02) (float-vector 8.5575200617313385e+01 9.8413899540901184e+01 -4.2330101132392883e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1211099624633789e+02 1.4311200007796288e+01 -4.5481500029563904e+02) (float-vector -2.1221500635147095e+02 -4.8488598316907883e+01 -4.5595398545265198e+02) (float-vector -2.2344900667667389e+02 -3.7253499031066895e+00 -4.6574699878692627e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1221500635147095e+02 -4.8488598316907883e+01 -4.5595398545265198e+02) (float-vector -2.1211099624633789e+02 1.4311200007796288e+01 -4.5481500029563904e+02) (float-vector -7.8277796506881714e+01 -6.0048601590096951e+00 -4.2358499765396118e+02) (float-vector -6.9588601589202881e+01 -1.6151599586009979e+02 -4.2903500795364380e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.6486597061157227e+01 -1.9446499645709991e+02 -4.4414600729942322e+02) (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -3.0589099973440170e+01 -1.9495099782943726e+02 -4.3184998631477356e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1238200366497040e+02 -1.4011600613594055e+02 -4.7755798697471619e+02) (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -2.1161599457263947e+02 -1.6786499321460724e+02 -4.9484100937843323e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -6.6486597061157227e+01 -1.9446499645709991e+02 -4.4414600729942322e+02) (float-vector -2.1230199933052063e+02 -1.8419000506401062e+02 -5.2119201421737671e+02) (float-vector -2.1161599457263947e+02 -1.6786499321460724e+02 -4.9484100937843323e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0589099973440170e+01 -1.9495099782943726e+02 -4.3184998631477356e+02) (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -6.9588601589202881e+01 -1.6151599586009979e+02 -4.2903500795364380e+02) (float-vector 1.5857299789786339e+01 -1.8783000111579895e+02 -4.2728298902511597e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6677498370409012e+01 2.0574699342250824e+02 -4.5159399509429932e+02) (float-vector -3.8815401494503021e+01 1.9121900200843811e+02 -4.3100199103355408e+02) (float-vector -6.3735596835613251e+01 1.9414000213146210e+02 -4.4194701313972473e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6677498370409012e+01 2.0574699342250824e+02 -4.5159399509429932e+02) (float-vector -6.3735596835613251e+01 1.9414000213146210e+02 -4.4194701313972473e+02) (float-vector -2.1175399422645569e+02 1.7772200703620911e+02 -5.0727200508117676e+02) (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -2.1271499991416931e+02 1.2352800369262695e+02 -4.7109100222587585e+02) (float-vector -2.1209000051021576e+02 1.5423899888992310e+02 -4.8492801189422607e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -3.8815401494503021e+01 1.9121900200843811e+02 -4.3100199103355408e+02) (float-vector -5.2175700664520264e+01 1.6535000503063202e+02 -4.2710900306701660e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8815401494503021e+01 1.9121900200843811e+02 -4.3100199103355408e+02) (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -6.3735596835613251e+01 1.9414000213146210e+02 -4.4194701313972473e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1271499991416931e+02 1.2352800369262695e+02 -4.7109100222587585e+02) (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -2.1195000410079956e+02 7.9315796494483948e+01 -4.5943298935890198e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1211099624633789e+02 1.4311200007796288e+01 -4.5481500029563904e+02) (float-vector -2.1195000410079956e+02 7.9315796494483948e+01 -4.5943298935890198e+02) (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -5.2175700664520264e+01 1.6535000503063202e+02 -4.2710900306701660e+02) (float-vector -1.0114099830389023e+02 8.7586998939514160e+01 -4.3177801370620728e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9411797225475311e+01 1.7399500310420990e+02 -4.3411800265312195e+02) (float-vector -2.1209000051021576e+02 1.5423899888992310e+02 -4.8492801189422607e+02) (float-vector -2.1175399422645569e+02 1.7772200703620911e+02 -5.0727200508117676e+02) (float-vector -6.3735596835613251e+01 1.9414000213146210e+02 -4.4194701313972473e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5781900286674500e+02 -8.8741399347782135e+01 -5.0717699527740479e+02) (float-vector 1.3932399451732635e+02 -3.5427298396825790e+01 -4.2353400588035583e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8277796506881714e+01 -6.0048601590096951e+00 -4.2358499765396118e+02) (float-vector 8.5575200617313385e+01 9.8413899540901184e+01 -4.2330101132392883e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02) (float-vector 1.3932399451732635e+02 -3.5427298396825790e+01 -4.2353400588035583e+02) (float-vector 1.0983300209045410e+02 -1.8112599849700928e+02 -4.2966198921203613e+02) (float-vector 1.5857299789786339e+01 -1.8783000111579895e+02 -4.2728298902511597e+02) (float-vector -6.9588601589202881e+01 -1.6151599586009979e+02 -4.2903500795364380e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3932399451732635e+02 -3.5427298396825790e+01 -4.2353400588035583e+02) (float-vector 1.1763700097799301e+02 -1.7992900311946869e+02 -4.3784400820732117e+02) (float-vector 1.1308900266885757e+02 -1.9076700508594513e+02 -4.3845799565315247e+02) (float-vector 1.0983300209045410e+02 -1.8112599849700928e+02 -4.2966198921203613e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5781900286674500e+02 -8.8741399347782135e+01 -5.0717699527740479e+02) (float-vector 1.5311199426651001e+02 -1.2960599362850189e+02 -5.1509499549865723e+02) (float-vector 1.1763700097799301e+02 -1.7992900311946869e+02 -4.3784400820732117e+02) (float-vector 1.3932399451732635e+02 -3.5427298396825790e+01 -4.2353400588035583e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1662600189447403e+02 1.8145099282264709e+02 -4.3553501367568970e+02) (float-vector 1.3851499557495117e+02 1.6910600662231445e+02 -5.1382297277450562e+02) (float-vector 1.5391199290752411e+02 1.2421199679374695e+02 -5.1293897628784180e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5755599737167358e+02 8.8744096457958221e+01 -5.0680100917816162e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02) (float-vector 1.1662600189447403e+02 1.8145099282264709e+02 -4.3553501367568970e+02) (float-vector 1.5391199290752411e+02 1.2421199679374695e+02 -5.1293897628784180e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1235500276088715e+02 -9.9579297006130219e+01 -4.6399798989295959e+02) (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -2.1238200366497040e+02 -1.4011600613594055e+02 -4.7755798697471619e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1235500276088715e+02 -9.9579297006130219e+01 -4.6399798989295959e+02) (float-vector -2.1238200366497040e+02 -1.4011600613594055e+02 -4.7755798697471619e+02) (float-vector -2.2400200366973877e+02 -1.3433000445365906e+02 -4.9602401256561279e+02) (float-vector -2.2522799670696259e+02 -8.4911003708839417e+01 -4.8069199919700623e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1221500635147095e+02 -4.8488598316907883e+01 -4.5595398545265198e+02) (float-vector -2.1235500276088715e+02 -9.9579297006130219e+01 -4.6399798989295959e+02) (float-vector -2.2522799670696259e+02 -8.4911003708839417e+01 -4.8069199919700623e+02) (float-vector -2.2344900667667389e+02 -3.7253499031066895e+00 -4.6574699878692627e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.4250400066375732e+01 -1.8420599400997162e+02 -4.3584701418876648e+02) (float-vector -2.1235500276088715e+02 -9.9579297006130219e+01 -4.6399798989295959e+02) (float-vector -2.1221500635147095e+02 -4.8488598316907883e+01 -4.5595398545265198e+02) (float-vector -6.9588601589202881e+01 -1.6151599586009979e+02 -4.2903500795364380e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0531499981880188e+02 2.0570600032806396e+02 -4.5325300097465515e+02) (float-vector 9.1386601328849792e+01 2.5099799036979675e+02 -5.7846498489379883e+02) (float-vector 9.7166202962398529e+01 2.4626199901103973e+02 -5.8961802721023560e+02) (float-vector 1.1303800344467163e+02 2.2921000421047211e+02 -5.8932399749755859e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6578399837017059e+01 2.6357299089431763e+02 -5.7835900783538818e+02) (float-vector -3.6677498370409012e+01 2.0574699342250824e+02 -4.5159399509429932e+02) (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6578399837017059e+01 2.6357299089431763e+02 -5.7835900783538818e+02) (float-vector 3.4876901656389236e+01 2.6142400503158569e+02 -5.8955198526382446e+02) (float-vector -1.6206599771976471e+02 1.6981400549411774e+02 -1.2456699609756470e+03) (float-vector -1.3934899866580963e+02 1.6875000298023224e+02 -1.2456699609756470e+03) (float-vector 7.0479802787303925e+01 2.6147800683975220e+02 -5.8943897485733032e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1220999956130981e+02 1.8981699645519257e+02 -5.3838002681732178e+02) (float-vector -2.1655599772930145e+02 2.0198699831962585e+02 -7.8457599878311157e+02) (float-vector 3.4876901656389236e+01 2.6142400503158569e+02 -5.8955198526382446e+02) (float-vector 4.6578399837017059e+01 2.6357299089431763e+02 -5.7835900783538818e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.1386601328849792e+01 2.5099799036979675e+02 -5.7846498489379883e+02) (float-vector 1.0531499981880188e+02 2.0570600032806396e+02 -4.5325300097465515e+02) (float-vector 4.6578399837017059e+01 2.6357299089431763e+02 -5.7835900783538818e+02) (float-vector 7.0479802787303925e+01 2.6147800683975220e+02 -5.8943897485733032e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6677498370409012e+01 2.0574699342250824e+02 -4.5159399509429932e+02) (float-vector 6.0268901288509369e+01 1.9486600160598755e+02 -4.3244901299476624e+02) (float-vector -3.8815401494503021e+01 1.9121900200843811e+02 -4.3100199103355408e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0268901288509369e+01 1.9486600160598755e+02 -4.3244901299476624e+02) (float-vector -3.6677498370409012e+01 2.0574699342250824e+02 -4.5159399509429932e+02) (float-vector 4.6578399837017059e+01 2.6357299089431763e+02 -5.7835900783538818e+02) (float-vector 1.0531499981880188e+02 2.0570600032806396e+02 -4.5325300097465515e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8815401494503021e+01 1.9121900200843811e+02 -4.3100199103355408e+02) (float-vector 6.0268901288509369e+01 1.9486600160598755e+02 -4.3244901299476624e+02) (float-vector 1.0912799835205078e+02 1.7892999947071075e+02 -4.2861899733543396e+02) (float-vector 6.1044398695230484e+01 1.7959499359130859e+02 -4.2708700895309448e+02) (float-vector -5.2175700664520264e+01 1.6535000503063202e+02 -4.2710900306701660e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.0268901288509369e+01 1.9486600160598755e+02 -4.3244901299476624e+02) (float-vector 1.1213400214910507e+02 1.8991300463676453e+02 -4.3602299690246582e+02) (float-vector 1.0912799835205078e+02 1.7892999947071075e+02 -4.2861899733543396e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1213400214910507e+02 1.8991300463676453e+02 -4.3602299690246582e+02) (float-vector 6.0268901288509369e+01 1.9486600160598755e+02 -4.3244901299476624e+02) (float-vector 1.0531499981880188e+02 2.0570600032806396e+02 -4.5325300097465515e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1213400214910507e+02 1.8991300463676453e+02 -4.3602299690246582e+02) (float-vector 1.0531499981880188e+02 2.0570600032806396e+02 -4.5325300097465515e+02) (float-vector 1.1303800344467163e+02 2.2921000421047211e+02 -5.8932399749755859e+02) (float-vector 1.3851499557495117e+02 1.6910600662231445e+02 -5.1382297277450562e+02) (float-vector 1.1662600189447403e+02 1.8145099282264709e+02 -4.3553501367568970e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1213400214910507e+02 1.8991300463676453e+02 -4.3602299690246582e+02) (float-vector 1.1662600189447403e+02 1.8145099282264709e+02 -4.3553501367568970e+02) (float-vector 1.4398899674415588e+02 1.0713200084865093e+01 -4.2358800768852234e+02) (float-vector 1.0912799835205078e+02 1.7892999947071075e+02 -4.2861899733543396e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "torso_lift_link_geom0"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :pr2 "(ubuntu-18 4.15.0-29-generic x86_64) at 2019-12-19 10:43:01 UTC")

;;
;; additional robot model description from camera_info
;;   based on EusLisp 9.26( 1.2.1) for Linux64 created on ip-172-30-1-118(Tue Oct 8 16:03:51 UTC 2019)
;;        and irteus "1.7.4-11-gbca736a"
;;
;; make-camera-from-ros-camera-info-aux is defined in roseus since 1.0.1, but to use this code in jskeus, we re-define here
(defun make-camera-from-ros-camera-info-aux (pwidth pheight p frame-coords &rest args) (let* ((fx (elt p 0)) (fy (elt p 5)) (cx (elt p 2)) (cy (elt p 6)) (fx*tx (elt p 3)) (fy*ty (elt p 7)) (tx (* 1000 (/ fx*tx fx))) (ty (* 1000 (/ fy*ty fy)))) (apply #'make-camera-from-param :pwidth pwidth :pheight pheight :fx fx :fy fy :cx cx :cy cy :tx tx :ty ty :parent-coords frame-coords args)))
;;
(defun pr2 (&optional (name :pr1012)) (setq *pr2* (instance pr2-sensor-robot :init name)))

(defclass pr2-sensor-robot
  :super pr2-robot
  :slots (name kinect_head-depth kinect_head-rgb prosilica r_forearm_cam l_forearm_cam wide_stereo-right wide_stereo-left narrow_stereo-right narrow_stereo-left ))

(defmethod pr2-sensor-robot
  (:init (&optional (n :pr1012) &rest args)
   (send-super* :init args)
   (setq name n)
   ;; kinect_head frame definition, this data is taken from jsk_pr2_startup kinect_head_launch 
#|
 get frame coordinates data from pr1012:/etc/ros/distro/urdf/robot.xml
|#
   (case name
     ;; define cameras for pr1012
     (:pr1012
      ;; sensor_msgs::camerainfo #f(575.816 0.0 315.0 0.0 0.0 575.816 237.0 0.0 0.0 0.0 1.0 0.0)
      (setq kinect_head-depth (make-camera-from-ros-camera-info-aux 640 480 #f(575.816 0.0 315.0 0.0 0.0 575.816 237.0 0.0 0.0 0.0 1.0 0.0) head_mount_kinect_ir_optical_frame_lk :name :kinect_head/depth))

      ;; sensor_msgs::camerainfo #f(525.0 0.0 319.5 0.0 0.0 525.0 239.5 0.0 0.0 0.0 1.0 0.0)
      (setq kinect_head-rgb (make-camera-from-ros-camera-info-aux 640 480 #f(525.0 0.0 319.5 0.0 0.0 525.0 239.5 0.0 0.0 0.0 1.0 0.0) head_mount_kinect_rgb_optical_frame_lk :name :kinect_head/rgb))

      ;; sensor_msgs::camerainfo #f(341.275 0.0 326.117 0.0 0.0 382.992 244.101 0.0 0.0 0.0 1.0 0.0)
      (setq r_forearm_cam (make-camera-from-ros-camera-info-aux 640 480 #f(341.275 0.0 326.117 0.0 0.0 382.992 244.101 0.0 0.0 0.0 1.0 0.0) r_forearm_cam_optical_frame_lk :name :r_forearm_cam))

      ;; sensor_msgs::camerainfo #f(338.589 0.0 290.813 0.0 0.0 378.466 241.389 0.0 0.0 0.0 1.0 0.0)
      (setq l_forearm_cam (make-camera-from-ros-camera-info-aux 640 480 #f(338.589 0.0 290.813 0.0 0.0 378.466 241.389 0.0 0.0 0.0 1.0 0.0) l_forearm_cam_optical_frame_lk :name :l_forearm_cam))

      ;; sensor_msgs::camerainfo #f(445.634 0.0 240.474 -39.9524 0.0 445.634 193.274 0.0 0.0 0.0 1.0 0.0)
      (setq wide_stereo-right (make-camera-from-ros-camera-info-aux 640 480 #f(445.634 0.0 240.474 -39.9524 0.0 445.634 193.274 0.0 0.0 0.0 1.0 0.0) wide_stereo_optical_frame_lk :name :wide_stereo/right))

      ;; sensor_msgs::camerainfo #f(445.634 0.0 240.474 0.0 0.0 445.634 193.274 0.0 0.0 0.0 1.0 0.0)
      (setq wide_stereo-left (make-camera-from-ros-camera-info-aux 640 480 #f(445.634 0.0 240.474 0.0 0.0 445.634 193.274 0.0 0.0 0.0 1.0 0.0) wide_stereo_optical_frame_lk :name :wide_stereo/left))

      ;; sensor_msgs::camerainfo #f(910.712 0.0 320.414 -81.6247 0.0 910.712 263.573 0.0 0.0 0.0 1.0 0.0)
      (setq narrow_stereo-right (make-camera-from-ros-camera-info-aux 640 480 #f(910.712 0.0 320.414 -81.6247 0.0 910.712 263.573 0.0 0.0 0.0 1.0 0.0) narrow_stereo_optical_frame_lk :name :narrow_stereo/right))

      ;; sensor_msgs::camerainfo #f(910.712 0.0 320.414 0.0 0.0 910.712 263.573 0.0 0.0 0.0 1.0 0.0)
      (setq narrow_stereo-left (make-camera-from-ros-camera-info-aux 640 480 #f(910.712 0.0 320.414 0.0 0.0 910.712 263.573 0.0 0.0 0.0 1.0 0.0) narrow_stereo_optical_frame_lk :name :narrow_stereo/left))

      (setq cameras (list  (send self :kinect_head-depth) (send self :kinect_head-rgb) (send self :r_forearm_cam) (send self :l_forearm_cam) (send self :wide_stereo-right) (send self :wide_stereo-left) (send self :narrow_stereo-right) (send self :narrow_stereo-left)))
      ) ;; case pr1012
     ;; define cameras for pr1040
     (:pr1040
      ;; sensor_msgs::camerainfo #f(575.816 0.0 315.0 0.0 0.0 575.816 237.0 0.0 0.0 0.0 1.0 0.0)
      (setq kinect_head-depth (make-camera-from-ros-camera-info-aux 640 480 #f(575.816 0.0 315.0 0.0 0.0 575.816 237.0 0.0 0.0 0.0 1.0 0.0) head_mount_kinect_ir_optical_frame_lk :name :kinect_head/depth))

      ;; sensor_msgs::camerainfo #f(525.0 0.0 319.5 0.0 0.0 525.0 239.5 0.0 0.0 0.0 1.0 0.0)
      (setq kinect_head-rgb (make-camera-from-ros-camera-info-aux 640 480 #f(525.0 0.0 319.5 0.0 0.0 525.0 239.5 0.0 0.0 0.0 1.0 0.0) head_mount_kinect_rgb_optical_frame_lk :name :kinect_head/rgb))

      ;; sensor_msgs::camerainfo #f(2014.54 0.0 1197.49 0.0 0.0 2099.84 980.052 0.0 0.0 0.0 1.0 0.0)
      (setq prosilica (make-camera-from-ros-camera-info-aux 2448 2050 #f(2014.54 0.0 1197.49 0.0 0.0 2099.84 980.052 0.0 0.0 0.0 1.0 0.0) high_def_optical_frame_lk :name :prosilica))

      ;; sensor_msgs::camerainfo #f(334.856 0.0 325.141 0.0 0.0 377.534 252.949 0.0 0.0 0.0 1.0 0.0)
      (setq r_forearm_cam (make-camera-from-ros-camera-info-aux 640 480 #f(334.856 0.0 325.141 0.0 0.0 377.534 252.949 0.0 0.0 0.0 1.0 0.0) r_forearm_cam_optical_frame_lk :name :r_forearm_cam))

      ;; sensor_msgs::camerainfo #f(335.132 0.0 314.528 0.0 0.0 375.06 218.474 0.0 0.0 0.0 1.0 0.0)
      (setq l_forearm_cam (make-camera-from-ros-camera-info-aux 640 480 #f(335.132 0.0 314.528 0.0 0.0 375.06 218.474 0.0 0.0 0.0 1.0 0.0) l_forearm_cam_optical_frame_lk :name :l_forearm_cam))

      ;; sensor_msgs::camerainfo #f(386.179 0.0 321.406 -34.5313 0.0 386.179 241.11 0.0 0.0 0.0 1.0 0.0)
      (setq wide_stereo-right (make-camera-from-ros-camera-info-aux 640 480 #f(386.179 0.0 321.406 -34.5313 0.0 386.179 241.11 0.0 0.0 0.0 1.0 0.0) wide_stereo_optical_frame_lk :name :wide_stereo/right))

      ;; sensor_msgs::camerainfo #f(386.179 0.0 321.406 0.0 0.0 386.179 241.11 0.0 0.0 0.0 1.0 0.0)
      (setq wide_stereo-left (make-camera-from-ros-camera-info-aux 640 480 #f(386.179 0.0 321.406 0.0 0.0 386.179 241.11 0.0 0.0 0.0 1.0 0.0) wide_stereo_optical_frame_lk :name :wide_stereo/left))

      ;; sensor_msgs::camerainfo #f(904.762 0.0 324.702 -81.3571 0.0 904.762 232.22 0.0 0.0 0.0 1.0 0.0)
      (setq narrow_stereo-right (make-camera-from-ros-camera-info-aux 640 480 #f(904.762 0.0 324.702 -81.3571 0.0 904.762 232.22 0.0 0.0 0.0 1.0 0.0) narrow_stereo_optical_frame_lk :name :narrow_stereo/right))

      ;; sensor_msgs::camerainfo #f(904.762 0.0 324.702 0.0 0.0 904.762 232.22 0.0 0.0 0.0 1.0 0.0)
      (setq narrow_stereo-left (make-camera-from-ros-camera-info-aux 640 480 #f(904.762 0.0 324.702 0.0 0.0 904.762 232.22 0.0 0.0 0.0 1.0 0.0) narrow_stereo_optical_frame_lk :name :narrow_stereo/left))

      (setq cameras (list  (send self :kinect_head-depth) (send self :kinect_head-rgb) (send self :prosilica) (send self :r_forearm_cam) (send self :l_forearm_cam) (send self :wide_stereo-right) (send self :wide_stereo-left) (send self :narrow_stereo-right) (send self :narrow_stereo-left)))
      ) ;; case pr1040
   )
   self)

  (:kinect_head-depth (&rest args) (forward-message-to kinect_head-depth args))
  (:kinect_head-rgb (&rest args) (forward-message-to kinect_head-rgb args))
  (:prosilica (&rest args) (forward-message-to prosilica args))
  (:r_forearm_cam (&rest args) (forward-message-to r_forearm_cam args))
  (:l_forearm_cam (&rest args) (forward-message-to l_forearm_cam args))
  (:wide_stereo-right (&rest args) (forward-message-to wide_stereo-right args))
  (:wide_stereo-left (&rest args) (forward-message-to wide_stereo-left args))
  (:narrow_stereo-right (&rest args) (forward-message-to narrow_stereo-right args))
  (:narrow_stereo-left (&rest args) (forward-message-to narrow_stereo-left args))
  ) ;; defmethod pr2-robot


